using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.VersionInfo;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for About.
	/// </summary>
	public class About : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Label lblVersion;
		private System.Windows.Forms.Label lblRelDateTime;
		private System.Windows.Forms.Label lblReleaseDateTime;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public About()
		{
			//
			// Required for Windows Form Designer support
			//

			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			
			LRRApp app;
			LRRVersionInfo lrrVersionInfo;
//			LRROptions	lrrOptionsObj;

			app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
//			lrrOptionsObj = app.GetOptions() as LRROptions;
			
			lrrVersionInfo = app.VersionInfo;
			if(lrrVersionInfo != null)
			{
				lblVersion.Text = "PE-Advisor Version " + lrrVersionInfo.ClientVersion;//lrrOptionsObj.ClientVersion;
				lblRelDateTime.Text = lrrVersionInfo.ReleaseDateTime;//lrrOptionsObj.ReleaseDateTime;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(About));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.lblVersion = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.btnClose = new System.Windows.Forms.Button();
			this.lblRelDateTime = new System.Windows.Forms.Label();
			this.lblReleaseDateTime = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(448, 72);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 3;
			this.pictureBox1.TabStop = false;
			// 
			// lblVersion
			// 
			this.lblVersion.Location = new System.Drawing.Point(224, 80);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(216, 16);
			this.lblVersion.TabIndex = 4;
			this.lblVersion.Tag = "SID_LBLVERSION";
			this.lblVersion.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 88);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 16);
			this.label2.TabIndex = 6;
			this.label2.Tag = "SID_LEGALNOTICE";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 112);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(424, 232);
			this.label3.TabIndex = 7;
			this.label3.Tag = "SID_NOTICE";
			// 
			// btnClose
			// 
			this.btnClose.BackColor = System.Drawing.SystemColors.Control;
			this.btnClose.Location = new System.Drawing.Point(344, 352);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(88, 24);
			this.btnClose.TabIndex = 8;
			this.btnClose.Tag = "SID_OK";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// lblRelDateTime
			// 
			this.lblRelDateTime.Location = new System.Drawing.Point(104, 360);
			this.lblRelDateTime.Name = "lblRelDateTime";
			this.lblRelDateTime.Size = new System.Drawing.Size(224, 16);
			this.lblRelDateTime.TabIndex = 16;
			// 
			// lblReleaseDateTime
			// 
			this.lblReleaseDateTime.Location = new System.Drawing.Point(16, 360);
			this.lblReleaseDateTime.Name = "lblReleaseDateTime";
			this.lblReleaseDateTime.Size = new System.Drawing.Size(72, 16);
			this.lblReleaseDateTime.TabIndex = 15;
			this.lblReleaseDateTime.Tag = "SID_RELEASED";
			// 
			// About
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.ClientSize = new System.Drawing.Size(448, 384);
			this.Controls.Add(this.lblRelDateTime);
			this.Controls.Add(this.lblReleaseDateTime);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.lblVersion);
			this.Controls.Add(this.pictureBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "About";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_ABTPE";
			this.ResumeLayout(false);

		}
		#endregion

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

	}
}
