using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.Options;
using Symcon.Utils.HeaderDispatcher;  
using Symcon.LightRidge.Options.DBOptions;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ActiveDBs.
	/// </summary>
	public class ActiveDBs : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridActiveDBs;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ActiveDBs()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridActiveDBs = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridActiveDBs)).BeginInit();
			this.SuspendLayout();
			// 
			// gridActiveDBs
			// 
			this.gridActiveDBs.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridActiveDBs.HScrollBehavior = Syncfusion.Windows.Forms.Grid.GridScrollbarMode.Automatic;
			this.gridActiveDBs.Location = new System.Drawing.Point(0, 0);
			this.gridActiveDBs.Name = "gridActiveDBs";
			this.gridActiveDBs.ResizeColsBehavior = ((Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior)((((Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.ResizeAll | Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.ResizeSingle) 
				| Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.OutlineHeaders) 
				| Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.OutlineBounds)));
			this.gridActiveDBs.ResizeRowsBehavior = ((Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior)((((Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.ResizeAll | Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.ResizeSingle) 
				| Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.OutlineHeaders) 
				| Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.OutlineBounds)));
			this.gridActiveDBs.ScrollFrozen = false;
			this.gridActiveDBs.Size = new System.Drawing.Size(784, 118);
			this.gridActiveDBs.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Auto;
			this.gridActiveDBs.SmartSizeBox = false;
			this.gridActiveDBs.TabIndex = 0;
			this.gridActiveDBs.Text = "gridActiveDBs";
			this.gridActiveDBs.VScrollBehavior = Syncfusion.Windows.Forms.Grid.GridScrollbarMode.Automatic;
			// 
			// ActiveDBs
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(784, 118);
			this.Controls.Add(this.gridActiveDBs);
			this.Name = "ActiveDBs";
			this.Tag = "SID_ACTIVEDBS";
			this.Load += new System.EventHandler(this.ActiveDBs_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridActiveDBs)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void ActiveDBs_Load(object sender, System.EventArgs e)
		{
			LRRApp app;
			LRROptions	lrrOptionsObj;

			app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			lrrOptionsObj = app.GetOptions() as LRROptions;

			this.gridActiveDBs.ColCount = 4;
			this.gridActiveDBs.ColWidths[1] = 150;
			this.gridActiveDBs.ColWidths[2] = 100;
			this.gridActiveDBs.ColWidths[3] = 100;
			this.gridActiveDBs.ColWidths[4] = 300;
			this.gridActiveDBs[0,1].Text = LRRHeaderText.GetHeaderString("SID_ACTIVEDBS"); 
			this.gridActiveDBs[0,2].Text = LRRHeaderText.GetHeaderString("SID_DBENAME");
			this.gridActiveDBs[0,3].Text = LRRHeaderText.GetHeaderString("SID_DBTYPE");
			this.gridActiveDBs[0,4].Text = LRRHeaderText.GetHeaderString("SID_DBEPATH");
			int rowCount = 0;
			int nSelectedIndex = lrrOptionsObj.SelectedDBIndex;
			rowCount ++;
			this.gridActiveDBs.RowCount = rowCount;
			this.gridActiveDBs[rowCount,0].Text = " ";
			this.gridActiveDBs[rowCount,1].Text = LRRHeaderText.GetHeaderString("SID_LRR_DATABASE");
			this.gridActiveDBs[rowCount,2].Text = lrrOptionsObj.DataBaseConnectionInfosObj[nSelectedIndex].DatabaseName;
			this.gridActiveDBs[rowCount,3].Text = lrrOptionsObj.DataBaseConnectionInfosObj[nSelectedIndex].DatabaseType.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			this.gridActiveDBs[rowCount,4].Text = lrrOptionsObj.DataBaseConnectionInfosObj[nSelectedIndex].DatabaseFilePath;

			for(int i=0;i<lrrOptionsObj.HistorianConnectionInfosObj.Count;i++)
			{
				if(lrrOptionsObj.HistorianConnectionInfosObj[i].IsActive)
				{
					rowCount++;
					this.gridActiveDBs.RowCount = rowCount;
					this.gridActiveDBs[rowCount,0].Text = " ";
					this.gridActiveDBs[rowCount,1].Text = LRRHeaderText.GetHeaderString("SID_HISTORIAN")+ " - " + lrrOptionsObj.HistorianConnectionInfosObj[i].HistorainType.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					this.gridActiveDBs[rowCount,2].Text = lrrOptionsObj.HistorianConnectionInfosObj[i].DatabaseName;
					this.gridActiveDBs[rowCount,3].Text = lrrOptionsObj.HistorianConnectionInfosObj[i].DatabaseType.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					this.gridActiveDBs[rowCount,4].Text = lrrOptionsObj.HistorianConnectionInfosObj[i].DBLocation;
				}
			}
			this.gridActiveDBs.ReadOnly = true;
		}
	}
}
