using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher; 


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for AddIndicesItems.
	/// </summary>
	public class AddIndicesItems : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteItems;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AddIndicesItems(LRRSiteComponents lscs,string siteItem,LRRSiteComponents selectedscs,IndicesConfiguration indiceConfig)
		{
			selectedSiteItem = siteItem;
			_selectedSiteItemList = selectedscs;
			_combositeComponentsList = lscs;
			_indConfig = indiceConfig;
			//_lrrIndicesXRefs = LRRModel.IndicesXRefs.GetSiteItemXRefsByIndexID(selectedSiteItem);
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			InitializeDataSource();
			BindSiteItemsGrid();
			setSelectedRecord(_selectedSiteItemList); 

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AddIndicesItems));
			this.gridSiteItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			((System.ComponentModel.ISupportInitialize)(this.gridSiteItems)).BeginInit();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// gridSiteItems
			// 
			this.gridSiteItems.BackColor = System.Drawing.SystemColors.Window;
			this.gridSiteItems.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSiteItems.Location = new System.Drawing.Point(0, 0);
			this.gridSiteItems.Name = "gridSiteItems";
			this.gridSiteItems.Size = new System.Drawing.Size(600, 542);
			this.gridSiteItems.TabIndex = 0;
			this.gridSiteItems.Text = "gridGroupingControl1";
			this.gridSiteItems.VersionInfo = "3.301.0.0";
			this.gridSiteItems.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridSiteItems_RecordValueChanged);
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(424, 8);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 1;
			this.btnOK.Tag = "SID_OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(512, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnOK);
			this.panel1.Controls.Add(this.btnCancel);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 502);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(600, 40);
			this.panel1.TabIndex = 3;
			// 
			// AddIndicesItems
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 542);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.gridSiteItems);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AddIndicesItems";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_ADD_INDICES_ITEMS";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.AddIndicesItems_Closing);
			this.Load += new System.EventHandler(this.AddIndicesItems_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridSiteItems)).EndInit();
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitializeDataSource()
		{
			_siteComponentsList = new LRRSiteComponents();
			_tempsiteComponentsList = LRRModel.SiteComponentsObj;
			foreach(LRRSiteComponent lsc in _tempsiteComponentsList)
			{
				if(!(_combositeComponentsList.Contains(lsc)))
				{
					_siteComponentsList.Add(lsc);
				}
			}

			_lrrIndicesXRefs = LRRModel.IndicesXRefs.GetSiteItemXRefsByIndexID(selectedSiteItem);

			IEnumerator indxrefEnum = _lrrIndicesXRefs.GetEnumerator();
			while(indxrefEnum.MoveNext())
			{
				LRRIndicesXRef lindXref = indxrefEnum.Current as LRRIndicesXRef;
				_arrIndicesItems.Add(lindXref);
			}
		}
		private void BindSiteItemsGrid()
		{
			gridSiteItems.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridSiteItems);
			gridSiteItems.DataSource = null;
			gridSiteItems.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_siteComponentsList.ItemType,out fkColumns,out childColumns);
			//Hashtable fkData = new Hashtable();
			/*foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
				SymForeignKeyFieldAttribute fkAttr = fkColumns[obj] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}*/
			
			//Populate the columns for the grid object
			//			_siteComponentsList.SortColumn="Name";
			//			_siteComponentsList.Sort();
			//SyncGridUtilities.InitializeGridColumns(gridSiteItems,_siteComponentsList.ItemType,null,fkData);
			gridSiteItems.TableDescriptor.Columns.Clear();		
			gridUnBoundSiteItem.WireGrid(gridSiteItems);
			gridSiteItems.TableDescriptor.Columns.Add("Name","Name");
			gridSiteItems.TableDescriptor.Columns.Add("Description","Description");
			
			Hashtable RelativeWidths = new Hashtable();
			RelativeWidths.Add("Name",30);
			RelativeWidths.Add("Description",30);
			SyncGridUtilities.InitializeGridColumnsWidth(gridSiteItems,RelativeWidths );

			//Set the data store 
			//gridSiteItems.Engine.SourceListSet.Add("ParentTable",_siteComponentsList);

			gridSiteItems.DataSource = _siteComponentsList;

			gridSiteItems.TableDescriptor.AllowEdit = true;
			gridSiteItems.TableDescriptor.AllowNew = false;
			gridSiteItems.TableDescriptor.Columns["Name"].ReadOnly=true;
			gridSiteItems.TableDescriptor.Columns["Description"].ReadOnly = true;
			//		gridSiteItems.TableOptions.AllowSortColumns = false;

			//Resume the Layout of the Grid...
			gridSiteItems.ResumeLayout(false);
		}

		private void setSelectedRecord(LRRSiteComponents siteComponents)
		{
			foreach(Record rec in gridSiteItems.Table.Records)
			{
				if(rec != null)
				{
					LRRSiteComponent lscp = rec.GetData() as LRRSiteComponent;
					foreach(LRRSiteComponent lscp1 in siteComponents)
					{
						if(lscp1.SiteComponentID == lscp.SiteComponentID)
						{
							gridUnBoundSiteItem.SetRecord(lscp,true); 
						}
					}
				}
			}
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{	
			_indConfig.BindSiteItemGridWithXref(_lrrIndicesXRefs);
		}

		#region fields
		private LRRSiteComponents						_siteComponentsList;
		private LRRSiteComponents						_tempsiteComponentsList;
		private LRRSiteComponents						_combositeComponentsList;
		private LRRSiteComponents						_selectedSiteItemList;
		private GridUnBoundColumn						gridUnBoundSiteItem=new GridUnBoundColumn();
		private string									selectedSiteItem;
		private ArrayList								_arrIndicesItems = new ArrayList();
		private LRRIndicesXRefs							_lrrIndicesXRefs;
		private IndicesConfiguration					_indConfig = null;
		#endregion

		private void gridSiteItems_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			string sSiteComponentID = "";
			bool bExists = false;

			LRRSiteComponent objSiteComponent = e.Record.GetData() as LRRSiteComponent;
			
			sSiteComponentID =objSiteComponent.SiteComponentID == null ? "" : objSiteComponent.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(e.Record.GetValue("Select").ToString().ToUpper() == "TRUE")
			{
				for(int i=0; i < _arrIndicesItems.Count; i++)
				{
					LRRIndicesXRef currentindex = _arrIndicesItems[i] as LRRIndicesXRef;
					if((currentindex.IndexID == selectedSiteItem) && (currentindex.SiteComponentID == sSiteComponentID))
					{
						bExists = true;
						break;
					}
				}
				if(!bExists)
				{
					LRRIndicesXRef currentIndexXRef = new LRRIndicesXRef();
					currentIndexXRef.IndexID = selectedSiteItem;
					currentIndexXRef.SiteComponentID = sSiteComponentID;
					currentIndexXRef.Name = objSiteComponent.Name;
					currentIndexXRef.Description = objSiteComponent.Description;

					LRRMasterComponent lmc = LRRModel.Model.GetMasterComponentByID(objSiteComponent.MasterComponentType);
					currentIndexXRef.MasterComponentType = lmc.ComponentName;

					_lrrIndicesXRefs.Add(currentIndexXRef);
					_arrIndicesItems.Add(currentIndexXRef);
//					currentAggEquip.EquipmentID = sSiteComponentID;
//					currentAggEquip.ParentAggregateID = sAggregateID;
//					_lrrAggregateEquipments.Add(currentAggEquip);
//					_arrIndicesItems.Add(currentAggEquip);
				}
				
			}
			else
			{
				//equipments
				for(int i=0; i < _arrIndicesItems.Count; i++)
				{
					LRRIndicesXRef currentIndexXRef = _arrIndicesItems[i] as LRRIndicesXRef;
					if((currentIndexXRef.IndexID == selectedSiteItem) && (currentIndexXRef.SiteComponentID == sSiteComponentID))
					{
						_lrrIndicesXRefs.Remove(currentIndexXRef);
						_arrIndicesItems.Remove(currentIndexXRef);
					}
				}
			}
			
		}

		private void AddIndicesItems_Load(object sender, System.EventArgs e)
		{
			ApplicationPersistanceUtil.ApplyGridSettings(this,null,this.Tag);
		}

		private void AddIndicesItems_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			ApplicationPersistanceUtil.SaveGridSettings(this,null,this.Tag);
		}
	}
}
