using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.PEAdvisor.DataStore;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.Utils.HeaderDispatcher;

using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;


//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for Aggregates.
	/// </summary>
	public class AggregateOfAggregates : System.Windows.Forms.Form,ILRRUIContainer
	{
		# region Fields

		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem5;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem6;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barClose;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;
		

		private LRRApp						_app;
		private LRRAggregates				_lrrAggregates;//Data Source for the grid to show the aggregates equipment groups
		private LRRAggregateOfAggregates	_lrrAggregateLists; //Collection to get aggregate equipment groups items i.e equipments already mapped.
		private LRRAggregate				_aggregate;//To store the object of site component.
		private LRRAggregates				_aggregatesCompleteList; //Collection to get site component list.
		private LRRAggregateOfAggregates	_aggrEquipGrpItemListToInsert = new LRRAggregateOfAggregates(); //Collection to get aggregate equipment groups items i.e equipments already mapped.
		private LRRAggregateOfAggregate		_aggrEquipmentGrpItemFD; //To store the object of aggregate equipment groups item
		private LRRAggregateOfAggregate		_aggrEquipmentGrpItemFI; //To store the object of aggregate equipment groups item

		private LRRAggregateOfAggregates	_aggrOfAggregates = new LRRAggregateOfAggregates(); //To store the object of aggregate equipment groups item
		private LRRMasterComponents			_lrrMasterComps=new LRRMasterComponents();


		private Hashtable					_allAggregate = new Hashtable(); //Hash table which has all the site components with ID = EquipID & Obj = Site COmponent.
		private Hashtable					_equipToDelete = new Hashtable(); //Hash table which has all the equipment that needs to be deleted for the group
		private Hashtable					_equipToInsert = new Hashtable();
	
		private string						_recordValueChanged="0";
		private string						_aggrNameToDelete;
		private string						_resetInvoked="0";
		private bool						_chkAggregate=true;
		//private LRRUIManager lrrUI=new LRRUIManager();
		private System.Windows.Forms.Panel pnlAggregatesOption;
		private System.Windows.Forms.Panel pnlAggregates;
		private Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar xpToolBar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSave;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregateList;
		private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregateGroups;

		private string sAggregateIDList = "";
		private string sAggregateType = "";
		private string sEquipmentType = "";

		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;

		#endregion

		public AggregateOfAggregates(string sAggregatesIDList,string sType, string sEquipType)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			sAggregateIDList= sAggregatesIDList;
			sAggregateType = sType;
			sEquipmentType = sEquipType;

			InitDataSource(sAggregatesIDList,sAggregateType);
		
			gridAggregateList.TableDescriptor.AllowEdit=false;
			
			_gridExcelFormatter.WireGrid(gridAggregateGroups);

			bindgridAggregateGroups();
			bindGridAggregateList();
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AggregateOfAggregates));
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.barItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem5 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem6 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barClose = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.gridAggregateList = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pnlAggregates = new System.Windows.Forms.Panel();
			this.gridAggregateGroups = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlAggregatesOption = new System.Windows.Forms.Panel();
			this.xpToolBar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar();
			this.panel2 = new System.Windows.Forms.Panel();
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateList)).BeginInit();
			this.panel1.SuspendLayout();
			this.pnlAggregates.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateGroups)).BeginInit();
			this.pnlAggregatesOption.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// barItemSave
			// 
			this.barItemSave.CategoryIndex = -1;
			this.barItemSave.ID = "Create Aggregate Of Aggregate";
			this.barItemSave.ImageIndex = 0;
			this.barItemSave.ImageList = this.imageList1;
			this.barItemSave.LargeImageList = this.imageList1;
			this.barItemSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barItemSave.Text = "Save";
			// 
			// barItem5
			// 
			this.barItem5.CategoryIndex = -1;
			this.barItem5.ID = "";
			// 
			// barItem6
			// 
			this.barItem6.CategoryIndex = -1;
			this.barItem6.ID = "";
			// 
			// barClose
			// 
			this.barClose.CategoryIndex = -1;
			this.barClose.ID = "Close";
			this.barClose.ImageIndex = 2;
			this.barClose.ImageList = this.imageList1;
			this.barClose.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barClose.Text = "Close";
			this.barClose.Click += new System.EventHandler(this.barClose_Click);
			// 
			// gridAggregateList
			// 
			this.gridAggregateList.BackColor = System.Drawing.SystemColors.Window;
			this.gridAggregateList.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridAggregateList.Location = new System.Drawing.Point(0, 0);
			this.gridAggregateList.Name = "gridAggregateList";
			this.gridAggregateList.NestedTableGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_AGGREGATES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridAggregateList.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridAggregateList.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridAggregateList.NestedTableGroupOptions.ShowColumnHeaders = true;
			this.gridAggregateList.Size = new System.Drawing.Size(816, 320);
			this.gridAggregateList.TabIndex = 5;
			this.gridAggregateList.TableDescriptor.AllowNew = false;
			this.gridAggregateList.TableDescriptor.AllowRemove = false;
			this.gridAggregateList.Text = "gridAggregateList";
			this.gridAggregateList.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_AGGREGATES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridAggregateList.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridAggregateList.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridAggregateList.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridAggregateList.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridAggregateList.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridAggregateList.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridAggregateList.VersionInfo = "3.301.0.0";
			this.gridAggregateList.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridAggregateList_RecordDeleting);
			this.gridAggregateList.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridAggregateList_RecordValueChanged);
			this.gridAggregateList.Click += new System.EventHandler(this.gridAggregateList_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.pnlAggregates);
			this.panel1.Controls.Add(this.pnlAggregatesOption);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(816, 300);
			this.panel1.TabIndex = 5;
			// 
			// pnlAggregates
			// 
			this.pnlAggregates.Controls.Add(this.gridAggregateGroups);
			this.pnlAggregates.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlAggregates.Location = new System.Drawing.Point(0, 32);
			this.pnlAggregates.Name = "pnlAggregates";
			this.pnlAggregates.Size = new System.Drawing.Size(816, 268);
			this.pnlAggregates.TabIndex = 8;
			// 
			// gridAggregateGroups
			// 
			this.gridAggregateGroups.BackColor = System.Drawing.SystemColors.Window;
			this.gridAggregateGroups.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridAggregateGroups.Location = new System.Drawing.Point(0, 0);
			this.gridAggregateGroups.Name = "gridAggregateGroups";
			this.gridAggregateGroups.Size = new System.Drawing.Size(816, 268);
			this.gridAggregateGroups.TabIndex = 7;
			this.gridAggregateGroups.TableDescriptor.AllowNew = false;
			this.gridAggregateGroups.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridAggregateGroups.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridAggregateGroups.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
			this.gridAggregateGroups.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridAggregateGroups.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridAggregateGroups.Text = "gridAggregateGroups";
			this.gridAggregateGroups.ThemesEnabled = false;
			this.gridAggregateGroups.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_AGG_OF_AGG") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridAggregateGroups.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridAggregateGroups.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridAggregateGroups.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridAggregateGroups.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridAggregateGroups.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridAggregateGroups.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridAggregateGroups.VersionInfo = "3.301.0.0";
			this.gridAggregateGroups.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridAggregateGroups_CurrentRecordContextChange);
			// 
			// pnlAggregatesOption
			// 
			this.pnlAggregatesOption.Controls.Add(this.xpToolBar1);
			this.pnlAggregatesOption.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlAggregatesOption.Location = new System.Drawing.Point(0, 0);
			this.pnlAggregatesOption.Name = "pnlAggregatesOption";
			this.pnlAggregatesOption.Size = new System.Drawing.Size(816, 32);
			this.pnlAggregatesOption.TabIndex = 7;
			// 
			// xpToolBar1
			// 
			this.xpToolBar1.Bar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(null, "", ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder))), null, null);
			this.xpToolBar1.Dock = System.Windows.Forms.DockStyle.Top;
			this.xpToolBar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									this.barItemSave});
			this.xpToolBar1.Location = new System.Drawing.Point(0, 0);
			this.xpToolBar1.Name = "xpToolBar1";
			this.xpToolBar1.Size = new System.Drawing.Size(816, 25);
			this.xpToolBar1.TabIndex = 1;
			this.xpToolBar1.Text = "xpToolBar1";
			this.xpToolBar1.Click += new System.EventHandler(this.xpToolBar1_Click);
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.gridAggregateList);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel2.Location = new System.Drawing.Point(0, 214);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(816, 320);
			this.panel2.TabIndex = 7;
			// 
			// AggregateOfAggregates
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(816, 534);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "AggregateOfAggregates";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Aggregate of Aggregates";
			this.Closed += new System.EventHandler(this.Aggregates_Closed);
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateList)).EndInit();
			this.panel1.ResumeLayout(false);
			this.pnlAggregates.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateGroups)).EndInit();
			this.pnlAggregatesOption.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region Methods

		#region ValidateClose
		private bool ValidateClose()
		{
			try
			{
				if(_lrrAggregates.GetChanges().Count > 0)
				{
					DialogResult k = LRRMessagBox.ShowMessage("SID_SAVEINFO_QUESTION","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
					if(k == DialogResult.Yes)     
					{
						return true;			
					}
					else
					{
						return false;
					}
				}
				else
				{
					return true;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(AddMasterProperties),ex.Message  ,Logger.Level.Debug);
				return false;

			}
		}
		#endregion
	
		
		public void InitDataSource(string sAggregatesIDList,string sType)
		{
			if(_resetInvoked=="0")
			{
				if(_lrrAggregates != null)
					_lrrAggregates.Clear();

				if(_lrrAggregateLists != null)
					_lrrAggregateLists.Clear();

				if(_aggregatesCompleteList != null)
					_aggregatesCompleteList.Clear();
			

				_lrrAggregates = new LRRAggregates();
				_lrrAggregateLists = new LRRAggregateOfAggregates();
				_aggregatesCompleteList= new LRRAggregates();

				if(sType == "Aggregate")
				{
					_app.DBManagerObj.PopulateCollection(_lrrAggregateLists," where AggregateOfAggregatesID IN (" + sAggregatesIDList + ")",false);
					_app.DBManagerObj.PopulateCollection(_lrrAggregates," where IsAggregateOfAggregates = true and AggregateID IN (" + sAggregatesIDList + ")",false);
				}
				else if(sType == "Equipment")
				{
					
					_app.DBManagerObj.PopulateCollection(_aggregatesCompleteList," Where AggregateID IN (" + sAggregatesIDList + ")",false);
					
					LRRAggregate objAggregate = new LRRAggregate();
					objAggregate.IsAggregateOfAggregates = true;
					objAggregate.EquipmentTypeID =sEquipmentType ;
					_lrrAggregates.Add(objAggregate);

					foreach (LRRAggregate objAgg in _aggregatesCompleteList)
					{
						LRRAggregateOfAggregate objAggOfAgg = new LRRAggregateOfAggregate();
						objAggOfAgg.AggregateOfAggregatesID = objAggregate.AggregateID;
						objAggOfAgg.AggregateID = objAgg.AggregateID;
						_aggrOfAggregates.Add(objAggOfAgg);
					}
					_lrrAggregateLists = _aggrOfAggregates;
				}

				_aggregatesCompleteList = new LRRAggregates();
				_app.DBManagerObj.PopulateCollection(_aggregatesCompleteList,false);
				
			}
			else
			{
				_lrrAggregates.RefreshCollection();
				_lrrAggregateLists.RefreshCollection();
				_aggregatesCompleteList.RefreshCollection();
			}
			for(int j=0;j<_aggregatesCompleteList.Count;j++)
			{
				_allAggregate.Add(_aggregatesCompleteList[j].AggregateID,_aggregatesCompleteList[j]);
			}


		}
		
		

		#region bindGrids
	
		/// <summary>
		/// This method binds the grid to the cached data store ..
		/// </summary>
		private void bindgridAggregateGroups()
		{
			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridAggregateGroups.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridAggregateGroups);
			gridAggregateGroups.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregates.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			
			SyncGridUtilities.InitializeGridColumns(gridAggregateGroups,_lrrAggregates.ItemType,null,fkData);
			//Add the parent table for the Relations...
			gridAggregateGroups.Engine.SourceListSet.Add("ParentTable",_lrrAggregates);

			
			RelativeWidths.Add("Name",25);
			RelativeWidths.Add("Description",35);
			RelativeWidths.Add("IsAggregateOfAggregates",20);
			RelativeWidths.Add("EquipmentTypeID_ComponentName",20);
			SyncGridUtilities.InitializeGridColumnsWidth(gridAggregateGroups,RelativeWidths );

			
			//Set the data store 
			gridAggregateGroups.DataSource = _lrrAggregates;

			//Populate the columns for the grid object
			
			gridAggregateGroups.TableDescriptor.AllowNew = false;
			gridAggregateGroups.TableDescriptor.AllowRemove = true;
			//gridAggregateGroups.TableDescriptor.AllowEdit = true;

			
			gridAggregateGroups.TableDescriptor.Appearance.AnyCell.ShowButtons =Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;

			//Resume the Layout of the Grid...
			gridAggregateGroups.ResumeLayout(false);
			//Add the parent table for the Relations...
			
			//gridAggregateGroups.TableControl.CurrentCell.MoveTo(gridAggregateGroups.TableControl.Model.RowCount, 1); 
		}

		
		/// <summary>
		/// This Method binds the site component grid to the data source.
		/// </summary>
		private void bindGridAggregateList()
		{
			//Suspend the Layout of the Grid...
			gridAggregateList.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridAggregateList);

			//			Hashtable columnForDisplay = new Hashtable();
			//			columnForDisplay.Add("IsSelected",null);
			//			columnForDisplay.Add("AggregateID",null);
			
			
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridAggregateList,_lrrAggregateLists.ItemType,null);
			//,true,columnForDisplay);

			//			Hashtable RelativeWidths = new Hashtable();
			//			RelativeWidths.Add("IsSelected",10);
			//			RelativeWidths.Add("AggregateID_Name",45);
			//			
			//			SyncGridUtilities.InitializeGridColumnsWidth(gridAggregateList,RelativeWidths );
			
			//Set the data store 
			gridAggregateList.DataSource = _lrrAggregateLists;

			//			gridAggregateList.TableDescriptor.AllowEdit = true;
			//			gridAggregateList.TableDescriptor.Columns["Name"].ReadOnly=true;
			//			gridAggregateList.TableDescriptor.Columns["Description"].ReadOnly=true;
			
			gridAggregateList.TableDescriptor.Appearance.AnyCell.ShowButtons =Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;

			//Resume the Layout of the Grid...
			gridAggregateList.ResumeLayout(false);
			gridAggregateList.Engine.SourceListSet.Add("ParentTable",_lrrAggregateLists);
			
		}
		#endregion

		#region clearAllCollections
		private void clearAllCollections()
		{
			_lrrAggregateLists.RefreshCollection();
			_lrrAggregates.RefreshCollection();
			_aggregatesCompleteList.RefreshCollection();

			_equipToDelete.Clear();
			_equipToInsert.Clear();
			_allAggregate.Clear();

			_aggrEquipmentGrpItemFI = null;
			_aggrEquipmentGrpItemFD = null;

			RefreshAggregatesList();

			_recordValueChanged = "0";

			gridAggregateGroups.TableControl.Refresh();
			gridAggregateList.TableControl.Refresh();
			
		}

		#endregion

		#region RefreshAggregatesList
		private void RefreshAggregatesList()
		{
			_equipToInsert.Clear();
			_aggregatesCompleteList.RefreshCollection();

			//initialize the collection so that all the aggregates have isSelected = false
			_aggregatesCompleteList.ItemFilter = "IsSelected = true" ;
							
			for(int j=0;j<_aggregatesCompleteList.Count;j++)
			{
				_aggregatesCompleteList[j].IsSelected=false;
			}
							
			_aggregatesCompleteList.ItemFilter = "";
		}
		#endregion

		#region ResetValues

		/// <summary>
		/// This Method resets the collection objects & rebinds the grid.
		/// </summary>
		private void resetValues()
		{
			clearAllCollections();
			_resetInvoked="1";
			InitDataSource(sAggregateIDList,sAggregateType);
			bindgridAggregateGroups();
			bindGridAggregateList();
			_resetInvoked="0";	
			gridAggregateList.TableDescriptor.AllowEdit=false;
		}
		#endregion

		#endregion
		
		#region Events

	
		private void barClose_Click(object sender, System.EventArgs e)
		{
			if(ValidateClose())
			{
				clearAllCollections();
				this.Close();
			}		
		}

	

		private void gridAggregateGroups_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			Cursor=Cursors.WaitCursor;	
			try
			{
				if(e.Table.CurrentRecord != null)
				{
					if(e.Table.CurrentRecord != null)
					{
						if(e.Table.CurrentRecord.Kind.ToString(Symcon.BusinessObjects.SymConverter.Culture) == "AddNewRecord") 
						{
							LRRAggregate aggrObj = e.Table.CurrentRecord.GetData() as LRRAggregate;
						}
					}
				}
				if (gridAggregateGroups.CurrencyManager.Count > 0 )
				{
					LRRAggregate aggrObj = gridAggregateGroups.CurrencyManager.Current as LRRAggregate;
			
					if(aggrObj!= null)
					{
						if(e.Action == CurrentRecordAction.NavigateComplete)
						{
								
							_lrrAggregateLists.ItemFilter="AggregateOfAggregatesID = '" + aggrObj.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "'";
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(AggregateDetails),ex.Message  ,Logger.Level.Debug);
			}
			Cursor=Cursors.Default;
			
		}


		private void gridAggregateGroups_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
			
			if(e.TableControl.CurrentCell.ColIndex==3)
			{
				
				//checking whether it is a filterbarcell
				GridCurrentCell cc = e.TableControl.CurrentCell;
				GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[cc.RowIndex, cc.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
				if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
				{
					return;
				}
				
				//gridAggregateList.TableDescriptor.AllowEdit=true;
				// if not a filterbar cell find the id of selected master plant Item
				string	h=	e.TableControl.Controls[2].Text;
				_app.DBManagerObj.PopulateCollection(_lrrMasterComps," where Name='"+h+"'");
				LRRMasterComponent  mastComp = _lrrMasterComps[0] as LRRMasterComponent;
				string mastCompId=mastComp.ID;

				if((mastCompId != null) && (mastCompId != ""))//if not then filter the sitecomps
				{
					string filterString = "MasterComponentType = '" + mastCompId + "'";
					_aggregatesCompleteList.ItemFilter = filterString;
					_chkAggregate=true;
				}
					
				
				gridAggregateList.TableControl.Refresh();
			}

		}
	
		

		private void gridAggregateList_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			

		}

	

		private void gridAggregateGroups_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			
			
		}

		
		private void gridAggregateList_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			LRRMessagBox.ShowMessage("SID_DELETEABORT","SID_LABEL", MessageBoxButtons.OK,MessageBoxIcon.Warning); 

			e.Cancel=true;
		}

		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			
//			lrrUI.SaveColumnOrder(gridAggregateGroups,this);
//			lrrUI.SaveGridSettings(gridAggregateGroups,this, this.Tag);

			clearAllCollections();
			_resetInvoked="0";
			InitDataSource(sAggregateIDList,sAggregateType);
			bindgridAggregateGroups();
			bindGridAggregateList();

//			lrrUI.ApplyColumOrder(gridAggregateGroups,this);
//			lrrUI.ApplyGridSettings(gridAggregateGroups,this,this.Tag);

		}

		public void Save()
		{
			bool isSaved = false;
			LRRAggregates toSaveAggregates = _lrrAggregates.GetChanges();
				
			_app.DBManagerObj.CommitCollection(toSaveAggregates);
			if(toSaveAggregates.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
                return;
			}
			else
			{
				isSaved = true;
			}
			_lrrAggregates.RefreshCollection();

			LRRAggregateOfAggregates toSaveAggregateOfAggregates = _lrrAggregateLists.GetChanges();
				
			_app.DBManagerObj.CommitCollection(toSaveAggregateOfAggregates);
			if(toSaveAggregateOfAggregates.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
				return;
			}
			else
			{
				isSaved = true;
			}
			_lrrAggregateLists.RefreshCollection();

		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add ComplexEquip.ClearFilter implementation
			this.gridAggregateGroups.TableDescriptor.RecordFilters.Clear();
			this.gridAggregateList.TableDescriptor.RecordFilters.Clear();
		}
		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridAggregateGroups);
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridAggregateGroups);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return true;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			InsertNewRowsForm insNewRows = new InsertNewRowsForm();
			DialogResult dlgResult = insNewRows.ShowDialog(this);
			int iNumofRows = insNewRows.iNewRows;
			if(dlgResult == DialogResult.OK)
			{
				for(int i = 0; i < iNumofRows;i++)
				{
					LRRComplexEquipment ce = new LRRComplexEquipment();
					_lrrAggregates.Add(ce);
				}
				gridAggregateGroups.Refresh();
			}
			else
			{
				return;
			}
		}

		public void Export()
		{
			if(gridAggregateGroups.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridAggregateGroups);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get{
				return _parentTabPage;
			}
		}
		#endregion

		private void Aggregates_Load(object sender, System.EventArgs e)
		{
		
		}

		private void gridAggregateList_Click(object sender, System.EventArgs e)
		{
			if(gridAggregateList.TableDescriptor.AllowEdit == false)
			{
				LRRMessagBox.ShowMessage("SID_SELEQUIPFORAGG","SID_LABEL",MessageBoxButtons.OKCancel,MessageBoxIcon.Error);  

			}
		}

		private void Aggregates_Closed(object sender, System.EventArgs e)
		{
			_gridExcelFormatter.UnwireGrid();
		}

		private void xpToolBar1_Click(object sender, System.EventArgs e)
		{
			Save();
		}
		
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add AggregateOfAggregates.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add AggregateOfAggregates.SupportsClearSort implementation
			return true;
		}

		#endregion
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add AggregateOfAggregates.PrintPreview implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add AggregateOfAggregates.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add AggregateOfAggregates.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add AggregateOfAggregates.ShowComponentList implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add AggregateOfAggregates.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add AggregateOfAggregates.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
            SyncGridUtilities.RollBackChanges(gridAggregateGroups);
            SyncGridUtilities.RollBackChanges(gridAggregateList);
            Refresh(); 
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add AggregateOfAggregates.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add AggregateOfAggregates.SupportsUndo implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add AggregateOfAggregates.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add AggregateOfAggregates.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add AggregateOfAggregates.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add AggregateOfAggregates.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add AggregateOfAggregates.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add AggregateOfAggregates.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add AggregateOfAggregates.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add AggregateOfAggregates.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add AggregateOfAggregates.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add AggregateOfAggregates.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		
	}
}
