using System;
using System.Text;
using System.Collections;
using Symcon.Utils.XMLUtils;
using Symcon.Utils.MessageLogger;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.IOScreen;
using Symcon.LightRidge.PEAdvisor.GroupProperties;
using Symcon.LightRidge.PEAdvisor.CommonViews;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ApplicationPersistanceUtil.
	/// </summary>
	public class ApplicationPersistanceUtil
	{
		#region Constructor

		public ApplicationPersistanceUtil()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		#endregion

		#region Static Constructor

		static ApplicationPersistanceUtil()
		{
			LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			LRROptions lrrOptionsObj = app.GetOptions() as LRROptions;
			DisablePersistance = lrrOptionsObj.DisablePersistance;
			ArrayList arrExcludedControls = new ArrayList();
			arrExcludedControls.Add("pnlCanvasHeader");
			_htExcludedControls.Add(typeof(OperatorsScreen),arrExcludedControls);
            arrExcludedControls = new ArrayList();
            arrExcludedControls.Add("gridModes");
            arrExcludedControls.Add("panel1");
            _htExcludedControls.Add(typeof(RunControlPanelDialog), arrExcludedControls);
			//arrExcludedControls = new ArrayList();
			//arrExcludedControls.Add("panel1");
			//_htExcludedControls.Add(typeof(IOScreen.ResultForm),arrExcludedControls);
		}

		#endregion

		#region Properties

        //public static Hashtable HtUserQueries
        //{
        //    get
        //    {
        //        return _htUserQueries;
        //    }
        //}

		public static bool DisablePersistance
		{
			get{ return _disablePersistance; }
			set{ _disablePersistance = value; }
		}

		#endregion

		#region Public Static Methods

		public static void SaveAppSettings(LRRApp lrrApp, PEMainWindow mainFrameObj)
		{
			//ICollection ic = lrrApp.LRRUIManagerObj._windowStore.Keys;
            if (DisablePersistance)
                return;
			bool flag2 = true;
			string activeMdiChild = null;
			if(mainFrameObj.MdiChildren.Length == 0)
			{
				flag2 = false;
			}
			else
			{
				try
				{
					activeMdiChild = mainFrameObj.ActiveMdiChild.Tag.ToString();
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ApplicationPersistanceUtil),"Active Mdi Child Not Found:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
				}
			}
			
			ArrayList arrWindowsOpened = new ArrayList();
			
			//IEnumerator ie = ic.GetEnumerator;
			bool flag = true;
			int nSelectedQuery = LRRApplicationSettings.SSelectedQuery;
			if(flag2)
			{
			
				
				if(_appSettings != null)
				{
					flag = false;
					for(int count=0;count<mainFrameObj.MdiChildren.Length;count++)
					{ 
						if(mainFrameObj.MdiChildren[count].Tag == null)
							continue;
						Form frm = null;
						string windowType = "";
						string id = "";
						id = mainFrameObj.MdiChildren[count].Tag as string;
						if(id!=null)
						{
							frm = lrrApp.LRRUIManagerObj._windowStore[id] as Form;

                            if (frm.GetType().ToString().IndexOf("Log") != -1)
                                windowType = "Log";
                            else if (frm.GetType().ToString().IndexOf("HistTrend") != -1)
                                windowType = "HistTrend";
                            else if (frm.GetType() == typeof(MultiTrend))
                                windowType = "MultiTrend";
                            else if (frm.GetType() == typeof(ExcelView))
                                windowType = "ExcelView";
                            else if (frm.GetType() == typeof(ResultForm))
                                windowType = "ResultForm";
                            else if (frm.GetType() == typeof(GroupedPlantPropertiesResultForm))
                                windowType = "GroupedPlantPropertiesResultForm";
                            else if (frm.GetType() == typeof(UnifiedViewResultForm))
                                windowType = "UnifiedViewResultForm";
                            else if (frm.GetType() == typeof(CompositeView))
                                windowType = "CompositeView";
                            
						}
						else
						{
							id = mainFrameObj.MdiChildren[count].Tag.ToString();
							frm = lrrApp.LRRUIManagerObj._windowStore[mainFrameObj.MdiChildren[count].Tag] as Form;
							windowType = "Normal";
						}
						if(frm == null)
							continue;
						OpenedWindow ow = _appSettings.GetOpenedWindowByID(id);
						if(ow == null)
						{
							int newId = 0;
							LRRApplicationSettings appSettings2 = new LRRApplicationSettings();
							appSettings2.openedCanvas = _appSettings.openedCanvas;
							if(_appSettings.openedWindows !=null)
							{
								newId = _appSettings.openedWindows.Length;
								appSettings2.openedWindows = new OpenedWindow[newId + 1];
								_appSettings.openedWindows.CopyTo(appSettings2.openedWindows,0);
							}
							else
							{
								appSettings2.openedWindows = new OpenedWindow[1];
							}
							
							appSettings2.openedWindows[newId] = new OpenedWindow();
							appSettings2.openedWindows[newId].WindowType = windowType;
							appSettings2.openedWindows[newId].WindowID = id;
							appSettings2.openedWindows[newId].Width = frm.Width;
							appSettings2.openedWindows[newId].Height = frm.Height;
							appSettings2.openedWindows[newId].LocationX = frm.Location.X;
							appSettings2.openedWindows[newId].LocationY = frm.Location.Y;
							appSettings2.openedWindows[newId].WindowState = frm.WindowState;
							appSettings2.openedWindows[newId].Index = count+1;
							arrWindowsOpened.Add(id);
							_appSettings = appSettings2;
						}
						else
						{
							ow.WindowType = windowType;
							ow.Width = frm.Width;
							ow.Height = frm.Height;
							ow.LocationX = frm.Location.X;
							ow.LocationY = frm.Location.Y;
							ow.WindowState = frm.WindowState;
							ow.Index = count+1;
							arrWindowsOpened.Add(id);
							
						}
					}
				}
			}
			if(flag && flag2)
			{
				if(_appSettings == null)
					_appSettings = new LRRApplicationSettings();
				_appSettings.openedWindows = new OpenedWindow[mainFrameObj.MdiChildren.Length];
				for(int count=0;count<mainFrameObj.MdiChildren.Length;count++)
				{
					if(mainFrameObj.MdiChildren[count].Tag == null)
						continue;
					Form frm;
					string key = mainFrameObj.MdiChildren[count].Tag as string;
					if(key!=null)
					{
						frm = lrrApp.LRRUIManagerObj._windowStore[key] as Form;
						_appSettings.openedWindows[count] = new OpenedWindow();

						if(frm.GetType().ToString().IndexOf("Log")!=-1)
							_appSettings.openedWindows[count].WindowType = "Log";
						else if(frm.GetType().ToString().IndexOf("HistTrend")!=-1)
							_appSettings.openedWindows[count].WindowType = "HistTrend";
						else if(frm.GetType() == typeof(MultiTrend))
							_appSettings.openedWindows[count].WindowType = "MultiTrend";
                        else if (frm.GetType() == typeof(ExcelView))
							_appSettings.openedWindows[count].WindowType = "ExcelView";
                        else if (frm.GetType() == typeof(ResultForm))
                            _appSettings.openedWindows[count].WindowType = "ResultForm";
                        else if (frm.GetType() == typeof(GroupedPlantPropertiesResultForm))
                            _appSettings.openedWindows[count].WindowType = "GroupedPlantPropertiesResultForm";
                        else if (frm.GetType() == typeof(UnifiedViewResultForm))
                            _appSettings.openedWindows[count].WindowType = "UnifiedViewResultForm";
                        else if (frm.GetType() == typeof(CompositeView))
                            _appSettings.openedWindows[count].WindowType = "CompositeView";

						_appSettings.openedWindows[count].WindowID = key.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					}
					else
					{
						object key2 = mainFrameObj.MdiChildren[count].Tag;
						frm = lrrApp.LRRUIManagerObj._windowStore[key2] as Form;
						_appSettings.openedWindows[count] = new OpenedWindow();
						_appSettings.openedWindows[count].WindowType = "Normal";
						_appSettings.openedWindows[count].WindowID = key2.ToString();
					}
					_appSettings.openedWindows[count].Width = frm.Width;
					_appSettings.openedWindows[count].Height = frm.Height;
					_appSettings.openedWindows[count].LocationX = frm.Location.X;
					_appSettings.openedWindows[count].LocationY = frm.Location.Y;
					_appSettings.openedWindows[count].WindowState = frm.WindowState;
					_appSettings.openedWindows[count].Index = count+1;
					arrWindowsOpened.Add(mainFrameObj.MdiChildren[count].Tag.ToString());
					
				}
			}
			if(_appSettings == null)
				_appSettings = new LRRApplicationSettings();
			else
			{
				_appSettings.OpenedCount = arrWindowsOpened.Count;
				if(_appSettings.openedWindows !=null)
				{
					foreach(OpenedWindow ow in _appSettings.openedWindows)
					{
						if(!arrWindowsOpened.Contains(ow.WindowID))
							ow.Index = 0;
					}
				}
				_appSettings.ActiveMdiChildID = activeMdiChild;
				_appSettings.SelectedQuery = nSelectedQuery;
			}
			
			_appSettings.pQueryList = mainFrameObj.GetPQueryList();
            //SaveQueries();
			SaveTrendSettings();
			
			try
			{
				MemoryStream memoryStream = new MemoryStream();
				XmlSerializer xs = new XmlSerializer(typeof(LRRApplicationSettings));
				XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);

				xs.Serialize(xmlTextWriter, _appSettings);
				memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
				byte[] buffer = memoryStream.ToArray();

				string userID = lrrApp.DBManagerObj.AccessControlModel.UserID;
				
				LRRPersistances lrrPersists = new LRRPersistances();
				LRRPersistance lrrPersist = new LRRPersistance();
				lrrApp.DBManagerObj.PopulateCollection(lrrPersists," where UserID='" + userID + "'",false);
				//lrrPersist.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
				//lrrApp.DBManagerObj.CommitObject(lrrPersist);
				lrrPersist.UserID = userID;
				lrrPersist.SettingsXml = buffer;
				lrrPersist.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
				lrrApp.DBManagerObj.CommitObject(lrrPersist);
				lrrApp.DBManagerObj.ExecuteBatchDelete(lrrPersists);
			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
				Logger.LogMessage(typeof(ApplicationPersistanceUtil),ex.Message + ex.StackTrace,Logger.Level.Debug);
			}
			
		}

		public static byte[] StrToByteArray(string str)
		{
			System.Text.ASCIIEncoding  encoding=new System.Text.ASCIIEncoding();
			return encoding.GetBytes(str);
		}

		public static string ByteArrayToStr(byte[] byteArray)
		{
			System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
			return enc.GetString(byteArray);
		}

		public static void SaveOperatorsCanvas(Form frm)
		{
			if(!DisablePersistance)
			{
				if(_appSettings == null)
					_appSettings = new LRRApplicationSettings();
				ApplicationPersistanceUtil.SaveOperatorsCanvas(frm, _appSettings);
				
			}
			GC.Collect();
		}

		public static void SaveCanvas(Form frm)
		{
			if(!DisablePersistance)
			{
				if(_appSettings == null)
					_appSettings = new LRRApplicationSettings();
				ApplicationPersistanceUtil.SaveCanvas(frm, _appSettings);
			}
			GC.Collect();
		}

		public static void LoadOperatorsCanvas(Form frm)
		{
			if(DisablePersistance)
				return;
			if(_appSettings == null)
				return;
			OperatorsScreen screen = frm as OperatorsScreen;
			if(_appSettings.openedOperatorsCanvas == null)
				return;
			foreach(OpenedCanvas oc in _appSettings.openedOperatorsCanvas)
			{
				if(oc!=null)
				{
					try
					{
						if(oc.FileID !=null)
							screen.OpenFiles(oc.FileID);
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(ApplicationPersistanceUtil),"Error Loading Operator's Canvas:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
					}
				}
			}
			if(_appSettings.ActiveOperatorsCanvas != null)
			{
				foreach(TabPageAdv tp in screen.GetTabControl().TabPages)
				{
					Canvas openCanvas =	tp.Controls[0] as Canvas;
					if(openCanvas.FileID.Equals(_appSettings.ActiveOperatorsCanvas))
					{
						screen.OpenFiles(openCanvas.FileID);
						break;
					}
				}
			}	
		}

		public static void LoadCanvas(Form frm)
		{
			if(DisablePersistance)
				return;
			if(_appSettings == null)
				return;
			ImplementerScreen implScreen = frm as ImplementerScreen;
			if(_appSettings.openedCanvas == null)
				return;
			foreach(OpenedCanvas oc in _appSettings.openedCanvas)
			{
				if(oc!=null)
				{
					try
					{
						if(oc.FileID !=null)
							implScreen.OpenFiles(oc.FileID);
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(ApplicationPersistanceUtil),"Error Loading Implementer's Canvas:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
					}
				}
			}
			if(_appSettings.ActiveCanvas != null)
			{
				foreach(TabPageAdv tp in implScreen.GetTabControl().TabPages)
				{
					Canvas openCanvas =	tp.Controls[0] as Canvas;
					if(openCanvas.FileID.Equals(_appSettings.ActiveCanvas))
					{
						implScreen.OpenFiles(openCanvas.FileID);
						break;
					}
				}

			}	
		}

		public static void LoadAppSettings(LRRApp lrrApp,PEMainWindow mainFrameObj)
		{
			try
			{
				string userID = lrrApp.DBManagerObj.AccessControlModel.UserID;

				LRRPersistance lrrPersist = new LRRPersistance();
				lrrApp.DBManagerObj.PopulateObject(lrrPersist,typeof(LRRPersistance)," where UserID='" + userID + "'");
				if(lrrPersist.SettingsXml!=null)
				{
					MemoryStream memoryStream = new MemoryStream (lrrPersist.SettingsXml);
					XmlSerializer xs = new XmlSerializer(typeof(LRRApplicationSettings));
					_appSettings = xs.Deserialize(memoryStream) as LRRApplicationSettings;
					memoryStream.Close();

					//Load Organize Views irrespective of Enable/Disable Persistance
					if(_appSettings.pQueryList != null)
						mainFrameObj.SetPQueryList(_appSettings.pQueryList);

                    if(_appSettings.PQuries != null)
                        LoadQueries(_appSettings.PQuries, lrrApp);
					
					if(_appSettings.TrendSettings != null)
						LoadTrendSettings();
				}
			}
			catch(Exception ex)
			{
				//System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
				Logger.LogMessage(typeof(ApplicationPersistanceUtil),"LoadAppSettings 1:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
			}
			if(DisablePersistance)
				return;
			try
			{
				if(_appSettings == null)
					return;
				LRRApplicationSettings.SSelectedQuery = _appSettings.SelectedQuery;
//				if(_appSettings.pQueryList != null)
//					mainFrameObj.SetPQueryList(_appSettings.pQueryList);
				if(_appSettings.OpenedCount == 0)
					return;
				bool flag = false;
				for(int j=1;j<=_appSettings.OpenedCount;j++)
				{
					for(int i=0;i<_appSettings.openedWindows.Length;i++)
					{
						if(_appSettings.openedWindows[i].Index == j)
						{
							try
							{
								OpenedWindow openedWindow = _appSettings.openedWindows[i];
								Form frm = null;
								if(openedWindow.WindowType == "Normal")
								{
									int id = int.Parse(openedWindow.WindowID,Symcon.BusinessObjects.SymConverter.Culture);
									lrrApp.LRRUIManagerObj.ShowWindow(id);
									frm = lrrApp.LRRUIManagerObj._windowStore[id] as Form;
								}
								else if(openedWindow.WindowType == "ExcelView")
								{
									object[] objParam = new object[1];
									objParam[0] = openedWindow.WindowID;
									lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID,typeof(ExcelView), objParam);
									frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
								}
                                else if (openedWindow.WindowType == "ResultForm")
                                {
                                    object[] objParam = new object[1];
                                    objParam[0] = openedWindow.WindowID;
                                    lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID, typeof(ResultForm), objParam);
                                    frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
                                }
                                else if (openedWindow.WindowType == "GroupedPlantPropertiesResultForm")
                                {
                                    object[] objParam = new object[1];
                                    objParam[0] = openedWindow.WindowID;
                                    lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID, typeof(GroupedPlantPropertiesResultForm), objParam);
                                    frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
                                }
                                else if (openedWindow.WindowType == "UnifiedViewResultForm")
                                {
                                    object[] objParam = new object[1];
                                    objParam[0] = openedWindow.WindowID;
                                    lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID, typeof(UnifiedViewResultForm), objParam);
                                    frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
                                }
								else if(openedWindow.WindowType == "Log")
								{
									object[] objParam = new object[1];
									objParam[0] = openedWindow.WindowID.Replace("Log:","");
									lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID,typeof(Log), objParam);
									frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
								}
								else if(openedWindow.WindowType == "HistTrend")
								{
									object[] objParam = new object[2];
                                    objParam[1] = openedWindow.WindowID.Contains("HistTrend(All):");
									objParam[0] = openedWindow.WindowID.Replace("HistTrend:","").Replace("HistTrend(All):","");
									lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID,typeof(HistTrends), objParam);
									frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
								}
								else if(openedWindow.WindowType == "MultiTrend")
								{
									object[] objParam = new object[1];
									objParam[0] = openedWindow.WindowID.Replace("MultiTrend:","");
									lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID,typeof(MultiTrend), objParam);
									frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
								}
                                else if (openedWindow.WindowType == "CompositeView")
                                {
                                    string compViewID = openedWindow.WindowID;
                                    LRRCompositeView compView = LRRModel.ChildModel.CompositeViews.GetCompositeViewFromID(compViewID);
                                    if (compView != null)
                                    {
                                        object[] objParam = new object[1];
                                        objParam[0] = compView;
                                        lrrApp.LRRUIManagerObj.ShowWindow(openedWindow.WindowID, typeof(CompositeView), objParam);
                                        frm = lrrApp.LRRUIManagerObj._windowStore[openedWindow.WindowID] as Form;
                                    }
                                }

								if(openedWindow.WindowState != FormWindowState.Maximized)
								{
									frm.Width = openedWindow.Width;
									frm.Height = openedWindow.Height;
									frm.Location = new System.Drawing.Point(openedWindow.LocationX,openedWindow.LocationY);
								}
							
								if(openedWindow.WindowState == FormWindowState.Maximized)
								{
									flag = true;
								}
								if(flag)
								{
									frm.WindowState = FormWindowState.Maximized;
								}
								else
								{
									frm.WindowState = openedWindow.WindowState;
								}
								break;
							}
							catch(Exception ex)
							{
								//System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
								Logger.LogMessage(typeof(ApplicationPersistanceUtil),"LoadAppSettings 2:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
							}
						}
					}
				}
				foreach(Form frm in mainFrameObj.MdiChildren)
				{
					if(frm.Tag!=null)
						if(frm.Tag.ToString().Equals(_appSettings.ActiveMdiChildID))
						{
                            frm.Activate();
                            //if(frm.GetType() == typeof(MultiTrend))
                            //{
                            //    lrrApp.LRRUIManagerObj.ShowWindow(frm.Tag.ToString(),typeof(MultiTrend),null);
                            //}
                            //else if(frm.Tag.GetType()== typeof(string))
                            //{
                            //    if(frm.Tag.ToString().IndexOf("Log")!=-1)
                            //    {
                            //        lrrApp.LRRUIManagerObj.ShowWindow(frm.Tag.ToString(),typeof(Log),null);
                            //    }
                            //    else if(frm.Tag.ToString().IndexOf("HistTrend")!=-1)
                            //    {
                            //        lrrApp.LRRUIManagerObj.ShowWindow(frm.Tag.ToString(),typeof(HistTrends),null);
                            //    }
                            //    else if (frm.Tag.ToString().IndexOf("ExcelView") != -1)
                            //    {
                            //        lrrApp.LRRUIManagerObj.ShowWindow(frm.Tag.ToString(),typeof(ExcelView),null);
                            //    }
                            //    else if (frm.Tag.ToString().IndexOf("ResultForm") != -1)
                            //    {
                            //        lrrApp.LRRUIManagerObj.ShowWindow(frm.Tag.ToString(), typeof(ResultForm), null);
                            //    }
                            //    else if (frm.Tag.ToString().IndexOf("GroupedPlantPropertiesResultForm") != -1)
                            //    {
                            //        lrrApp.LRRUIManagerObj.ShowWindow(frm.Tag.ToString(), typeof(GroupedPlantPropertiesResultForm), null);
                            //    }
                            //    else if (frm.Tag.ToString().IndexOf("UnifiedViewResultForm") != -1)
                            //    {
                            //        lrrApp.LRRUIManagerObj.ShowWindow(frm.Tag.ToString(), typeof(UnifiedViewResultForm), null);
                            //    }
                            //}
                            //else if(frm.Tag.GetType()== typeof(int))
                            //{
                            //    lrrApp.LRRUIManagerObj.ShowWindow(int.Parse(frm.Tag.ToString(),Symcon.BusinessObjects.SymConverter.Culture));
                            //}
						}
				}
			}
			catch(Exception ex)
			{
				//System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
				Logger.LogMessage(typeof(ApplicationPersistanceUtil),"LoadAppSettings 3:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
			}
		}

        public static string SaveCompositeViewSettings(Form frm, LRRCompositeView compositeView, LRRApp lrrApp)
        {
            if (compositeView == null)
                return null;

            string compositeViewID = compositeView.ID;

            string userSettingsID = compositeView.UserSettingsID;

            SaveCompositeViewSettings(frm as Control, frm as ILRRUIContainer, compositeViewID);
            if (_compositeViewSettings != null)
            {
                LRRUserSetting userSettings = new LRRUserSetting();
                if (userSettingsID != null)
                {
                    lrrApp.DBManagerObj.PopulateObject(userSettings, typeof(LRRUserSetting), " WHERE ID='" + userSettingsID + "'");
                    if (userSettings != null)
                    {
                        userSettings.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                        lrrApp.DBManagerObj.CommitObject(userSettings);
                    }
                }
                if (userSettings != null)
                {
                    userSettings.UID = lrrApp.DBManagerObj.AccessControlModel.UserID;
                    try
			        {
				        MemoryStream memoryStream = new MemoryStream();
				        XmlSerializer xs = new XmlSerializer(typeof(LRRApplicationSettings));
				        XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);

				        xs.Serialize(xmlTextWriter, _compositeViewSettings);
				        memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
				        userSettings.UserSettings = memoryStream.ToArray();

                        userSettings.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                        lrrApp.DBManagerObj.CommitObject(userSettings);

                        _compositeViewSettings = null;
                        userSettingsID = userSettings.ID;
                    }
                    catch
                    {
                        return null;
                    }
                   
                }
            }
            return userSettingsID;
        }

        
		public static void SaveGridSettings(Control ctl,ILRRUIContainer container, object formID)
		{
			if(DisablePersistance)
				return;
			if(formID == null)
				return;
            if (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(ExcelView) || ctl.GetType() == typeof(Canvas))
			{
				if(!CheckIfControlExcluded(ctl,container))
				{
					OpenedWindow ow = new OpenedWindow();
					
					LRRApplicationSettings appSettings2 = new LRRApplicationSettings(); //LRRGridSetting gridSetting2 = new LRRGridSetting();
					bool isAppSettingsNew = false;
					if(_appSettings != null)
					{
						ow = _appSettings.GetOpenedWindowByID(formID.ToString());
						if(ow == null)
						{
							int newId = 0;
							if(_appSettings.openedWindows !=null)
							{
								newId = _appSettings.openedWindows.Length;
								appSettings2.openedWindows = new OpenedWindow[newId + 1];
								_appSettings.openedWindows.CopyTo(appSettings2.openedWindows,0);
							}
							else
								appSettings2.openedWindows = new OpenedWindow[1];
							appSettings2.openedWindows[newId] = new OpenedWindow();
							appSettings2.openedWindows[newId].WindowID = formID.ToString();
							appSettings2.openedWindows[newId].Index = 0;
							appSettings2.openedCanvas = _appSettings.openedCanvas;
							_appSettings = appSettings2;
							ow = appSettings2.openedWindows[newId];
						}
					}
					else
					{
						_appSettings = new LRRApplicationSettings();
						isAppSettingsNew = true;
					}
					if(ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl))
					{
						Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridInstance = ctl as Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl;

						GridTableDescriptor gtd = gridInstance.TableDescriptor;
						InternalSaveGridSettings(ow,gridInstance,gtd,isAppSettingsNew,formID);
						isAppSettingsNew = false;
					}
                    else if ((ctl.Dock != DockStyle.Fill || ctl.GetType() == typeof(Canvas)) && (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(Canvas)))
					{
						if(ctl.Name != null && ctl.Name != "" && ctl.Name != "pnlCanvasHeader")
						{
							OtherControl oc = new OtherControl();
							oc.ControlName = ctl.Name;

                            if (ctl is Splitter)
                            {
                                oc.Dock = ctl.Dock;
                            }
                            else if (ctl is Canvas)
                            {
                                Canvas canvas = ctl as Canvas;
                                oc.LocationX = canvas.View.Origin.X;
                                oc.LocationY = canvas.View.Origin.Y;
                                //oc.Width = canvas.View.Magnification.Width;
                                //oc.Height = canvas.View.Magnification.Height;

                            }
                            else
                            {
                                oc.Width = ctl.Width;
                                oc.Height = ctl.Height;
                            }
							if(!isAppSettingsNew)
							{
								bool flag = false;
								if(ow.ocInstance != null)
								{
									for(int j=0;j < ow.ocInstance.Length;j++)
									{
										if(ctl.Name.Equals(ow.ocInstance[j].ControlName))
										{
											flag = true;
											ow.ocInstance[j] = oc;
											break;
										}
								
									}
								}
								if(!flag)
								{
									OpenedWindow ow2 = new OpenedWindow();
									if(ow.gridInstance != null)
									{
										ow2.gridInstance = new Grid[ow.gridInstance.Length];
										ow.gridInstance.CopyTo(ow2.gridInstance,0);
									}
									if(ow.ocInstance == null)
									{
										ow2.ocInstance = new OtherControl[1];
										ow2.ocInstance[0] = oc;
									}
									else
									{
										ow2.ocInstance = new OtherControl[ow.ocInstance.Length + 1];
										ow.ocInstance.CopyTo(ow2.ocInstance,0);
										ow2.ocInstance[ow.ocInstance.Length] = oc;
									}
									ow2.WindowID = ow.WindowID;
									ow2.Index = 0;
									_appSettings.SetOpenWindow(ow2);
								}
							}
							else
							{
								ow.ocInstance = new OtherControl[1];
								ow.ocInstance[0] = oc;
								ow.WindowID = formID.ToString();
								ow.Index = 0;
								_appSettings.openedWindows = new OpenedWindow[1];
								_appSettings.openedWindows[0] = ow;
							}
						
						}
					}
					else if(ctl.GetType() == typeof(ExcelView))
					{
						try
						{
							bool flag = true;
							ExcelView ev = ctl as ExcelView;
							if(_appSettings.miscZooms != null)
							{
						
								if(ctl.Controls[0].Controls[0].GetType() == typeof(UserControls.UserControlExcelNamedRangeView))
								{
									foreach(MiscZoom miscZoom in _appSettings.miscZooms)
									{
										if(miscZoom.ViewID.Equals(ctl.Tag.ToString()))
										{
											miscZoom.nZoom = ev.LastZoom;
											flag = false;
											break;
										}
									}
								}

								if(flag)
								{
									MiscZoom[] miscZoom2 = new MiscZoom[_appSettings.miscZooms.Length + 1];
									_appSettings.miscZooms.CopyTo(miscZoom2,0);
									miscZoom2[_appSettings.miscZooms.Length] = new MiscZoom();
									miscZoom2[_appSettings.miscZooms.Length].nZoom = ev.LastZoom;
									miscZoom2[_appSettings.miscZooms.Length].ViewID = ev.Tag.ToString();
									_appSettings.miscZooms = miscZoom2;
								}
							}
							else
							{
								_appSettings.miscZooms = new MiscZoom[1];
								_appSettings.miscZooms[0] = new MiscZoom();
								_appSettings.miscZooms[0].ViewID = ev.Tag.ToString();
								_appSettings.miscZooms[0].nZoom = ev.LastZoom;
							}

						}
						catch
						{

						}
					}
				}
			}
			foreach(Control cc in ctl.Controls)
			{
				SaveGridSettings(cc,container,formID);
			}
			
		}

        public static void ApplyCompositeViewSettings(Form frm, LRRCompositeView compositeView, LRRApp lrrApp)
        {
            if(compositeView == null)
                return;

            string compositeViewID = compositeView.ID;
            string userSettingsID = compositeView.UserSettingsID;
            if (userSettingsID == null)
            {
                ApplyGridSettings(frm as Control, frm as ILRRUIContainer, compositeViewID, true);
                return;
            }
            LRRUserSetting userSettings = new LRRUserSetting();
            lrrApp.DBManagerObj.PopulateObject(userSettings, typeof(LRRUserSetting), " WHERE ID='" + userSettingsID +"'");

            if (userSettings != null)
            {
                byte[] byteArr = userSettings.UserSettings;

                if (byteArr != null)
                {
                    MemoryStream memoryStream = new MemoryStream(byteArr);
                    XmlSerializer xs = new XmlSerializer(typeof(LRRApplicationSettings));
                    _compositeViewSettings = xs.Deserialize(memoryStream) as LRRApplicationSettings;
                    memoryStream.Close();

                    ApplyCompositeViewSettings(frm as Control, frm as ILRRUIContainer, compositeViewID);
                    _compositeViewSettings = null;
                }
            }
        }

        public static void ApplyGridSettings(Control ctl, ILRRUIContainer container, object formID)
        {
            ApplyGridSettings(ctl, container, formID, false);
        }

		public static void ApplyGridSettings(Control ctl,ILRRUIContainer container, object formID , bool ignoreDisablePersistance)
		{
            if (!ignoreDisablePersistance)
            {
                if (DisablePersistance)
                    return;
            }
			if(_appSettings == null)
				return;
			bool shouldGoIn = true;
            if (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(ExcelView) || ctl.GetType() == typeof(Canvas))
			{
				if(!CheckIfControlExcluded(ctl,container))
				{
					OpenedWindow ow = _appSettings.GetOpenedWindowByID(formID.ToString());
					if(ow == null)
						return;
				
					if(ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl))
					{
						if(ow.gridInstance == null)
							return;
						Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridInstance = ctl as Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl;
						GridTableDescriptor gtd = gridInstance.TableDescriptor;
                        //if(_appSettings == null)
                        //    return;
					
						//	gtd.Name=gridInstance.Name+"_"+ baseName;
						
					
						
							InternalApplyGridSettings(ow,gridInstance,gtd);
							//gtd.Name=baseName;
					}
                    else if ((ctl.Dock != DockStyle.Fill || ctl.GetType() == typeof(Canvas)) && (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(Canvas)))
					{
						if(ow.ocInstance == null)
							return;
					
						if(ctl.Name != null && ctl.Name != "")
						{	
							for(int j=0;j < ow.ocInstance.Length;j++)
							{
								if(ctl.Name.Equals(ow.ocInstance[j].ControlName))
							    {
                                    if (ctl is Splitter)
                                    {
                                        if (container is CompositeView)
                                        {
                                            if (ow.ocInstance[j].Dock == DockStyle.Right)
                                            {
                                                (container as CompositeView).TransposeViewWithoutResizing();
                                            }
                                        }
                                    }
                                    else if (ctl is Canvas)
                                    {
                                        Canvas canvas = ctl as Canvas;
                                        float x = ow.ocInstance[j].LocationX;
                                        float y = ow.ocInstance[j].LocationY;
                                        if(ow.ocInstance[j].Width != 0)
                                            canvas.Zoom(ow.ocInstance[j].Width.ToString());
                                        
                                        canvas.View.Origin = new System.Drawing.PointF(x, y);
                                    }
                                    else
                                    {
                                        ctl.Width = ow.ocInstance[j].Width;
                                        ctl.Height = ow.ocInstance[j].Height;
                                    }
                                    break;
								}
							}
						}
					}
					else if(ctl.GetType() == typeof(ExcelView))
					{
						if(_appSettings.miscZooms != null)
						{
							try
							{
								if(ctl.Controls[0].Controls[0].GetType() == typeof(UserControls.UserControlExcelNamedRangeView))
								{
									foreach(MiscZoom miscZoom in _appSettings.miscZooms)
									{
										if(miscZoom.ViewID.Equals(ctl.Tag.ToString()))
										{
											ExcelView ev = ctl as ExcelView;
											ev.LastZoom = miscZoom.nZoom;
											break;
										}
									}
								}
							}
							catch
							{

							}
						}
					}
				}
				else
				{
					shouldGoIn = false;
				}
			}
			
			if(shouldGoIn)
				foreach(Control cc in ctl.Controls)
				{
					ApplyGridSettings(cc,container, formID);
				}
		}

		#endregion

		#region Private Static Methods

        private static void ApplyCompositeViewSettings(Control ctl, ILRRUIContainer container, object formID)
        {
            if (_compositeViewSettings == null)
                return;
            if (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(ExcelView) || ctl.GetType() == typeof(Canvas))
            {
                OpenedWindow ow = _compositeViewSettings.GetOpenedWindowByID(formID.ToString());
                if (ow == null)
                    return;

                if (ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl))
                {
                    if (ow.gridInstance == null)
                        return;
                    Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridInstance = ctl as Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl;
                    GridTableDescriptor gtd = gridInstance.TableDescriptor;
                    //if(_compositeViewSettings == null)
                    //    return;

                    //	gtd.Name=gridInstance.Name+"_"+ baseName;



                    InternalApplyGridSettings(ow, gridInstance, gtd);
                    //gtd.Name=baseName;
                }
                else if ((ctl.Dock != DockStyle.Fill || ctl.GetType() == typeof(Canvas)) && (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(Canvas)))
                {
                    if (ow.ocInstance == null)
                        return;

                    if (ctl.Name != null && ctl.Name != "")
                    {
                        for (int j = 0; j < ow.ocInstance.Length; j++)
                        {
                            if (ctl.Name.Equals(ow.ocInstance[j].ControlName))
                            {
                                if (ctl is Splitter)
                                {
                                    if (container is CompositeView)
                                    {
                                        if (ow.ocInstance[j].Dock == DockStyle.Right)
                                        {
                                            (container as CompositeView).TransposeViewWithoutResizing();
                                        }
                                    }
                                }
                                else if (ctl is Canvas)
                                {
                                    Canvas canvas = ctl as Canvas;
                                    float x = ow.ocInstance[j].LocationX;
                                    float y = ow.ocInstance[j].LocationY;
                                    if (ow.ocInstance[j].Width != 0)
                                        canvas.Zoom(ow.ocInstance[j].Width.ToString());

                                    canvas.View.Origin = new System.Drawing.PointF(x, y);
                                }
                                else
                                {
                                    ctl.Width = ow.ocInstance[j].Width;
                                    ctl.Height = ow.ocInstance[j].Height;
                                }
                                break;
                            }
                        }
                    }
                }
                else if (ctl.GetType() == typeof(ExcelView))
                {
                    if (_compositeViewSettings.miscZooms != null)
                    {
                        try
                        {
                            if (ctl.Controls[0].Controls[0].GetType() == typeof(UserControls.UserControlExcelNamedRangeView))
                            {
                                foreach (MiscZoom miscZoom in _compositeViewSettings.miscZooms)
                                {
                                    if (miscZoom.ViewID.Equals(ctl.Tag.ToString()))
                                    {
                                        ExcelView ev = ctl as ExcelView;
                                        ev.LastZoom = miscZoom.nZoom;
                                        break;
                                    }
                                }
                            }
                        }
                        catch
                        {

                        }
                    }
                }
            }
            foreach (Control cc in ctl.Controls)
            {
                ApplyCompositeViewSettings(cc, container, formID);
            }
        }

        private static void SaveCompositeViewSettings(Control ctl, ILRRUIContainer container, object formID)
        {
            if (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(ExcelView) || ctl.GetType() == typeof(Canvas))
            {
                OpenedWindow ow = new OpenedWindow();

                LRRApplicationSettings appSettings2 = new LRRApplicationSettings(); //LRRGridSetting gridSetting2 = new LRRGridSetting();
                bool isAppSettingsNew = false;
                if (_compositeViewSettings != null)
                {
                    ow = _compositeViewSettings.GetOpenedWindowByID(formID.ToString());
                    if (ow == null)
                    {
                        int newId = 0;
                        if (_compositeViewSettings.openedWindows != null)
                        {
                            newId = _compositeViewSettings.openedWindows.Length;
                            appSettings2.openedWindows = new OpenedWindow[newId + 1];
                            _compositeViewSettings.openedWindows.CopyTo(appSettings2.openedWindows, 0);
                        }
                        else
                            appSettings2.openedWindows = new OpenedWindow[1];
                        appSettings2.openedWindows[newId] = new OpenedWindow();
                        appSettings2.openedWindows[newId].WindowID = formID.ToString();
                        appSettings2.openedWindows[newId].Index = 0;
                        appSettings2.openedCanvas = _compositeViewSettings.openedCanvas;
                        _compositeViewSettings = appSettings2;
                        ow = appSettings2.openedWindows[newId];
                    }
                }
                else
                {
                    _compositeViewSettings = new LRRApplicationSettings();
                    isAppSettingsNew = true;
                }
                if (ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl))
                {
                    Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridInstance = ctl as Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl;

                    GridTableDescriptor gtd = gridInstance.TableDescriptor;
                    InternalSaveGridSettings(ow, gridInstance, gtd, isAppSettingsNew, formID);
                    isAppSettingsNew = false;
                }
                else if ((ctl.Dock != DockStyle.Fill || ctl.GetType() == typeof(Canvas)) && (ctl.GetType() == typeof(GridControl) || ctl.GetType() == typeof(Panel) || ctl.GetType() == typeof(Splitter) || ctl.GetType() == typeof(PictureBox) || ctl.GetType() == typeof(TreeView) || ctl.GetType() == typeof(Canvas)))
                {
                    if (ctl.Name != null && ctl.Name != "" && ctl.Name != "pnlCanvasHeader")
                    {
                        OtherControl oc = new OtherControl();
                        oc.ControlName = ctl.Name;

                        if (ctl is Splitter)
                        {
                            oc.Dock = ctl.Dock;
                        }
                        else if (ctl is Canvas)
                        {
                            Canvas canvas = ctl as Canvas;
                            oc.LocationX = canvas.View.Origin.X;
                            oc.LocationY = canvas.View.Origin.Y;
                            //oc.Width = canvas.View.Magnification.Width;
                            
                            //oc.Height = canvas.View.Magnification.Height;

                        }
                        else
                        {
                            oc.Width = ctl.Width;
                            oc.Height = ctl.Height;
                        }
                        if (!isAppSettingsNew)
                        {
                            bool flag = false;
                            if (ow.ocInstance != null)
                            {
                                for (int j = 0; j < ow.ocInstance.Length; j++)
                                {
                                    if (ctl.Name.Equals(ow.ocInstance[j].ControlName))
                                    {
                                        flag = true;
                                        ow.ocInstance[j] = oc;
                                        break;
                                    }

                                }
                            }
                            if (!flag)
                            {
                                OpenedWindow ow2 = new OpenedWindow();
                                if (ow.gridInstance != null)
                                {
                                    ow2.gridInstance = new Grid[ow.gridInstance.Length];
                                    ow.gridInstance.CopyTo(ow2.gridInstance, 0);
                                }
                                if (ow.ocInstance == null)
                                {
                                    ow2.ocInstance = new OtherControl[1];
                                    ow2.ocInstance[0] = oc;
                                }
                                else
                                {
                                    ow2.ocInstance = new OtherControl[ow.ocInstance.Length + 1];
                                    ow.ocInstance.CopyTo(ow2.ocInstance, 0);
                                    ow2.ocInstance[ow.ocInstance.Length] = oc;
                                }
                                ow2.WindowID = ow.WindowID;
                                ow2.Index = 0;
                                _compositeViewSettings.SetOpenWindow(ow2);
                            }
                        }
                        else
                        {
                            ow.ocInstance = new OtherControl[1];
                            ow.ocInstance[0] = oc;
                            ow.WindowID = formID.ToString();
                            ow.Index = 0;
                            _compositeViewSettings.openedWindows = new OpenedWindow[1];
                            _compositeViewSettings.openedWindows[0] = ow;
                        }

                    }
                }
                else if (ctl.GetType() == typeof(ExcelView))
                {
                    try
                    {
                        bool flag = true;
                        ExcelView ev = ctl as ExcelView;
                        if (_compositeViewSettings.miscZooms != null)
                        {

                            if (ctl.Controls[0].Controls[0].GetType() == typeof(UserControls.UserControlExcelNamedRangeView))
                            {
                                foreach (MiscZoom miscZoom in _compositeViewSettings.miscZooms)
                                {
                                    if (miscZoom.ViewID.Equals(ctl.Tag.ToString()))
                                    {
                                        miscZoom.nZoom = ev.LastZoom;
                                        flag = false;
                                        break;
                                    }
                                }
                            }

                            if (flag)
                            {
                                MiscZoom[] miscZoom2 = new MiscZoom[_compositeViewSettings.miscZooms.Length + 1];
                                _compositeViewSettings.miscZooms.CopyTo(miscZoom2, 0);
                                miscZoom2[_compositeViewSettings.miscZooms.Length] = new MiscZoom();
                                miscZoom2[_compositeViewSettings.miscZooms.Length].nZoom = ev.LastZoom;
                                miscZoom2[_compositeViewSettings.miscZooms.Length].ViewID = ev.Tag.ToString();
                                _compositeViewSettings.miscZooms = miscZoom2;
                            }
                        }
                        else
                        {
                            _compositeViewSettings.miscZooms = new MiscZoom[1];
                            _compositeViewSettings.miscZooms[0] = new MiscZoom();
                            _compositeViewSettings.miscZooms[0].ViewID = ev.Tag.ToString();
                            _compositeViewSettings.miscZooms[0].nZoom = ev.LastZoom;
                        }

                    }
                    catch
                    {

                    }
                }

            }


            foreach (Control cc in ctl.Controls)
            {
                SaveCompositeViewSettings(cc, container, formID);
            }
        }

		private static void InternalSaveGridSettings(OpenedWindow ow,GridGroupingControl gridInstance, GridTableDescriptor gtd, bool isAppSettingsNew, object formID)
		{
			int nCols = 0;
			int nColCtr = 0;

			int iRelation = gtd.Relations.Count;
			nCols = gtd.Columns.Count;
			string hh=null;
			bool flag = false;
				
			if(!isAppSettingsNew)
			{
				hh=gridInstance.Name+"_"+ gtd.Name;
				if(ow.gridInstance != null)
				{	
					for(int j=0;j < ow.gridInstance.Length;j++)
					{
						if(hh.Equals(ow.gridInstance[j].GridName))
						{
							flag = true;
							Grid gridControl = new Grid();
							gridControl.GridName = hh;//gtd.Name;
							gridControl.GridColumns = new Columns[nCols];
							gridControl.GridSortedColumns = new SortedColumns[gtd.SortedColumns.Count];
							gridControl.Filter = new RecordFilterDescriptor[gtd.RecordFilters.Count];
							nColCtr = 0;
							int nSortColCtr = 0;
							int nFilterCtr = 0;

							foreach(GridColumnDescriptor newColWidth in gtd.Columns)
							{
								Columns col = new Columns();
								col.Name =  newColWidth.Name;
								col.Width= newColWidth.Width;
								col.Header=newColWidth.HeaderText;
								gridControl.GridColumns[nColCtr] = col;
								nColCtr++;
							}
							foreach(RecordFilterDescriptor rfd in gtd.RecordFilters)
							{
								gridControl.Filter[nFilterCtr] = rfd.Clone();
								nFilterCtr++;
							}
							foreach(SortColumnDescriptor scd in gtd.SortedColumns)
							{
								SortedColumns scol = new SortedColumns();
								scol.Name = scd.Name;
								scol.SortDirection = scd.SortDirection;
								gridControl.GridSortedColumns[nSortColCtr] = scol;
								nSortColCtr++;
							}
							ow.gridInstance[j] = gridControl;
							break;
						}
					}
				}
				if(!flag)
				{
					Grid gridControl = new Grid();
					gridControl.GridName = hh;//gtd.Name;
					gridControl.GridColumns = new Columns[nCols];
					gridControl.GridSortedColumns = new SortedColumns[gtd.SortedColumns.Count];
					gridControl.Filter = new RecordFilterDescriptor[gtd.RecordFilters.Count];
					nColCtr = 0;
					int nSortColCtr = 0;
					int nFilterCtr = 0;

					foreach(GridColumnDescriptor newColWidth in gtd.Columns)
					{
						Columns col = new Columns();
						col.Name =  newColWidth.Name;
						col.Width= newColWidth.Width;
						col.Header=newColWidth.HeaderText;
						gridControl.GridColumns[nColCtr] = col;
						nColCtr++;
					}
					foreach(RecordFilterDescriptor rfd in gtd.RecordFilters)
					{
						gridControl.Filter[nFilterCtr] = rfd.Clone();
						nFilterCtr++;
					}
					foreach(SortColumnDescriptor scd in gtd.SortedColumns)
					{
						SortedColumns scol = new SortedColumns();
						scol.Name = scd.Name;
						scol.SortDirection = scd.SortDirection;
						gridControl.GridSortedColumns[nSortColCtr] = scol;
						nSortColCtr++;
					}
					OpenedWindow ow2 = new OpenedWindow();
					if(ow.gridInstance == null)
					{
						ow2.gridInstance = new Grid[1];
						ow2.gridInstance[0] = gridControl;
					}
					else
					{
						ow2.gridInstance = new Grid[ow.gridInstance.Length + 1];
						ow.gridInstance.CopyTo(ow2.gridInstance,0);
						ow2.gridInstance[ow.gridInstance.Length] = gridControl;
					}
					if(ow.ocInstance != null)
					{
						ow2.ocInstance = new OtherControl[ow.ocInstance.Length];
						ow.ocInstance.CopyTo(ow2.ocInstance,0);
					}
					ow2.WindowID = ow.WindowID;
					ow2.Index = 0;
					_appSettings.SetOpenWindow(ow2);
					ow = ow2;
				}
			}
			else
			{
				ow.gridInstance = new Grid[1];
				Grid gridControl = new Grid();

				gridControl.GridName =gridInstance.Name+"_"+ gtd.Name;
				gridControl.GridColumns = new Columns[nCols];
				gridControl.GridSortedColumns = new SortedColumns[gtd.SortedColumns.Count];
				gridControl.Filter = new RecordFilterDescriptor[gtd.RecordFilters.Count];
				int nSortColCtr = 0;
				int nFilterCtr = 0;

				foreach(GridVisibleColumnDescriptor newColWidth in gtd.VisibleColumns)
				{
                    GridColumnDescriptor gcd = gtd.Columns[newColWidth.Name];
					Columns col = new Columns();
                    col.Name = gcd.Name;
                    col.Width = gcd.Width;
                    col.Header = gcd.HeaderText;
					gridControl.GridColumns[nColCtr] = col;
					nColCtr++;
				}
				foreach(RecordFilterDescriptor rfd in gtd.RecordFilters)
				{
					gridControl.Filter[nFilterCtr] = rfd.Clone();
					nFilterCtr++;
				}
				foreach(SortColumnDescriptor scd in gtd.SortedColumns)
				{
					SortedColumns scol = new SortedColumns();
					scol.Name = scd.Name;
					scol.SortDirection = scd.SortDirection;
					gridControl.GridSortedColumns[nSortColCtr] = scol;
					nSortColCtr++;
				}
				ow.gridInstance[0] = gridControl;
				ow.WindowID = formID.ToString();
				ow.Index = 0;
				_appSettings.openedWindows = new OpenedWindow[1];
				_appSettings.openedWindows[0] = ow;
				isAppSettingsNew = false;
			}

			foreach(GridRelationDescriptor grd in gtd.Relations)
			{
				InternalSaveGridSettings(ow,gridInstance,grd.ChildTableDescriptor,isAppSettingsNew,formID);
			}
		}

		private static void InternalApplyGridSettings(OpenedWindow ow,GridGroupingControl gridInstance, GridTableDescriptor gtd)
		{
			try
			{
				string hh=gridInstance.Name+"_"+ gtd.Name;
				int iChildGrid = gtd.Relations.Count;
				int nColCtr = 0;
				for(int j=0;j < ow.gridInstance.Length;j++)
				{
							
					if(hh.Equals(ow.gridInstance[j].GridName))
					{
						Columns[] col = ow.gridInstance[j].GridColumns;
						SortedColumns[] scols = ow.gridInstance[j].GridSortedColumns;
						Syncfusion.Grouping.RecordFilterDescriptor[] filters = ow.gridInstance[j].Filter;
						ArrayList arrCols = new ArrayList();
						if(col!=null)
						{
							for(int i=0;i < col.Length;i++)
							{
								if(col[i]!=null)
								{
									int colIndex = 0;
									bool colFound = false;
									foreach(GridVisibleColumnDescriptor newColWidth in gtd.VisibleColumns)
									{
										if(newColWidth.Name.Equals(col[i].Name))
										{
                                            GridColumnDescriptor gcd = gtd.Columns[newColWidth.Name];
											gcd.Width = col[i].Width;
                                            gtd.Columns.Move(colIndex, nColCtr);
											colFound = true;
											arrCols.Add(gcd.MappingName);
											break;
										}
										colIndex++;	
									}
									if(colFound)
									{
										nColCtr++;
									}
								}
							}
						}
                       
						if(filters!=null)
						{
							gtd.RecordFilters.Clear();
							foreach(RecordFilterDescriptor rfd in filters)
							{
                                FilterCondition[] fc = new FilterCondition[rfd.Conditions.Count];
                                for(int i=0;i<rfd.Conditions.Count;i++)
                                {
                                    fc[i] = new FilterCondition();
                                    fc[i].CompareOperator = rfd.Conditions[i].CompareOperator;
                                    //fc[i].CompareText = rfd.Conditions[i].CompareText;
                                    fc[i].CompareValue = rfd.Conditions[i].CompareValue;
                                }
                                RecordFilterDescriptor rfd2 = new RecordFilterDescriptor(rfd.Name, rfd.LogicalOperator, fc);
                                rfd2.Expression = rfd.Expression;
								gtd.RecordFilters.Add(rfd2);
							}
						}
						if(scols!=null)
						{
							gtd.SortedColumns.Clear();
							foreach(SortedColumns scol in scols)
							{
								if(arrCols.Contains(scol.Name))
									gtd.SortedColumns.Add(scol.Name,scol.SortDirection);
							}
						}
						break;
					}
				
				}
			}
			catch(Exception ex)
			{
				//System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
				Logger.LogMessage(typeof(ApplicationPersistanceUtil),"ApplyGridSettings 1:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
			}
			foreach(GridRelationDescriptor grd in gtd.Relations)
			{
				InternalApplyGridSettings(ow,gridInstance,grd.ChildTableDescriptor);
			}
		}

		private static void SaveOperatorsCanvas(Form frm, LRRApplicationSettings appSettings)
		{
			if(DisablePersistance)
				return;
			OperatorsScreen screen = frm as OperatorsScreen;
			appSettings.openedOperatorsCanvas = new OpenedCanvas[screen.GetTabControl().TabPages.Count];
			int i=0;
			foreach(TabPageAdv tp in screen.GetTabControl().TabPages)
			{
				appSettings.openedOperatorsCanvas[i] = new OpenedCanvas();
				Canvas openCanvas =	tp.Controls[0] as Canvas;
				if(openCanvas.FileName!=null)
				{
					appSettings.openedOperatorsCanvas[i].FileID = openCanvas.FileID;
					i++;
				}
			}
			try
			{
				if(screen.GetTabControl().SelectedTab != null)
				{
					Canvas openCanvas2 = screen.GetTabControl().SelectedTab.Controls[0] as Canvas;
					if(openCanvas2.FileName!=null)
						appSettings.ActiveOperatorsCanvas = openCanvas2.FileID;
					else
						appSettings.ActiveOperatorsCanvas = null;
				}
				else
					appSettings.ActiveOperatorsCanvas = null;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(ApplicationPersistanceUtil),"SaveOperatorsCanvas:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
				appSettings.ActiveOperatorsCanvas = null;
			}
		}

		private static void SaveCanvas(Form frm, LRRApplicationSettings appSettings)
		{
			if(DisablePersistance)
				return;
			ImplementerScreen implScreen = frm as ImplementerScreen;
			appSettings.openedCanvas = new OpenedCanvas[implScreen.GetTabControl().TabPages.Count];
			int i=0;
			foreach(TabPageAdv tp in implScreen.GetTabControl().TabPages)
			{
				appSettings.openedCanvas[i] = new OpenedCanvas();
				Canvas openCanvas =	tp.Controls[0] as Canvas;
				if(openCanvas.FileName!=null)
				{
					appSettings.openedCanvas[i].FileID = openCanvas.FileID;
					i++;
				}
			}
			try
			{
				if(implScreen.GetTabControl().SelectedTab != null)
				{
					Canvas openCanvas2 = implScreen.GetTabControl().SelectedTab.Controls[0] as Canvas;
					if(openCanvas2.FileName!=null)
						appSettings.ActiveCanvas = openCanvas2.FileID;
					else
						appSettings.ActiveCanvas = null;
				}
				else
					appSettings.ActiveCanvas = null;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(ApplicationPersistanceUtil),"SaveCanvas:" + ex.Message + ex.StackTrace,Logger.Level.Debug);
				appSettings.ActiveCanvas = null;
			}
		}

		private static bool CheckIfControlExcluded(Control ctl, ILRRUIContainer cont)
		{
			if(cont != null)
			{
				if(_htExcludedControls.ContainsKey(cont.GetType()))
				{
					ArrayList arrExcludedControls = _htExcludedControls[cont.GetType()] as ArrayList;
					if(arrExcludedControls.Contains(ctl.Name))
						return true;
				}
			}
			return false;
		}

        private static void LoadQueries(PersistQueries pQueries, LRRApp lrrApp)
        {
            for (int i = 0; i < pQueries.PQueries.Length; i++)
            {
                PersistQuery pQuery = pQueries.PQueries[i];
                LRRSearchCriteria sc = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(pQuery.QueryID);
                LRRUnifiedViewSearchCrtiteria uvsc = LRRModel.ChildModel.UnifiedViewSearchCrtiterias.GetUnifiedViewByID(pQuery.QueryID);
                if (sc != null || uvsc != null)
                {
                    try
                    {
                        if (sc != null)
                        {
                            if (sc.UserSettingsID == null)
                            {
                                LRRUserSetting userSetting = new LRRUserSetting();
                                userSetting.UID = lrrApp.DBManagerObj.AccessControlModel.UserID;
                                IOScreen.GridPersistanceUtil gutil = new GridPersistanceUtil();
                                gutil.GctlSetting = pQuery.GridControlSettings;
                                userSetting.UserSettings = gutil.GetUserSettingsXmlBytes();

                                sc.UserSettingsID = userSetting.ID;
                                lrrApp.DBManagerObj.CommitObject(userSetting);
                                lrrApp.DBManagerObj.CommitObject(sc);
                            }
                        }
                        else if (uvsc != null)
                        {
                            if (uvsc.UserSettingsID == null)
                            {
                                LRRUserSetting userSetting = new LRRUserSetting();
                                userSetting.UID = lrrApp.DBManagerObj.AccessControlModel.UserID;
                                IOScreen.GridPersistanceUtil gutil = new GridPersistanceUtil();
                                gutil.GctlSetting = pQuery.GridControlSettings;
                                userSetting.UserSettings = gutil.GetUserSettingsXmlBytes();

                                uvsc.UserSettingsID = userSetting.ID;
                                lrrApp.DBManagerObj.CommitObject(userSetting);
                                lrrApp.DBManagerObj.CommitObject(uvsc);
                            }
                        }
                    }
                    catch
                    {
 
                    }
                    //_htUserQueries.Add(pQuery.QueryID, pQuery.GridControlSettings);
                }
            }
            //foreach (LRRSearchCriteria sc in LRRModel.ChildModel.SearchCriterias)
            //{
            //    if (sc != null && !sc.ID.Equals("0") && !_htUserQueries.ContainsKey(sc.ID))
            //    {
            //        IOScreen.GridPersistanceUtil gputil = new Symcon.LightRidge.PEAdvisor.IOScreen.GridPersistanceUtil();
            //        gputil.SetBytesToSizeXml(sc.SizeXml);
            //        //IOScreen.LRRGridControlSetting gcs = gputil.DeserializeObject(typeof(IOScreen.LRRGridControlSetting)) as IOScreen.LRRGridControlSetting;
            //        //_htUserQueries.Add(sc.ID, gcs);
            //    }
            //}
            //foreach (LRRUnifiedViewSearchCrtiteria sc in LRRModel.ChildModel.UnifiedViewSearchCrtiterias)
            //{
            //    if (sc != null && !sc.ID.Equals("0") && !_htUserQueries.ContainsKey(sc.ID))
            //    {
            //        IOScreen.GridPersistanceUtil gputil = new Symcon.LightRidge.PEAdvisor.IOScreen.GridPersistanceUtil();
            //        gputil.SetBytesToSizeXml(sc.SizeXml);
            //        IOScreen.LRRGridControlSetting gcs = gputil.DeserializeObject(typeof(IOScreen.LRRGridControlSetting)) as IOScreen.LRRGridControlSetting;
            //        _htUserQueries.Add(sc.ID, gcs);
            //    }
            //}
        }

        //private static void SaveQueries()
        //{
        //    PersistQueries pQueries = new PersistQueries();
        //    pQueries.PQueries = new PersistQuery[_htUserQueries.Count];

        //    int i=0;
        //    foreach(string queryID in _htUserQueries.Keys)
        //    {
        //        PersistQuery pQuery = new PersistQuery();
        //        pQuery.QueryID = queryID;
        //        pQuery.GridControlSettings = _htUserQueries[queryID] as IOScreen.LRRGridControlSetting;
        //        pQueries.PQueries[i] = pQuery;
        //        i++;
        //    }

        //    _appSettings.PQuries = pQueries;
        //}

		private static void SaveTrendSettings()
		{
			TrendSetting[] trendSettings = new TrendSetting[UserControls.UserControlTrendOptions.HtSchemes.Count];
			int i=0;
			foreach(object schemeName in UserControls.UserControlTrendOptions.HtSchemes.Keys)
			{
				trendSettings[i] = new TrendSetting();
				try
				{
					trendSettings[i].SchemeName = schemeName as string;
					trendSettings[i].SeriesType = UserControls.UserControlTrendOptions.HtSchemes[schemeName].ToString().Split("|".ToCharArray())[0];
					trendSettings[i].SymbolShape = UserControls.UserControlTrendOptions.HtSchemes[schemeName].ToString().Split("|".ToCharArray())[1];
					trendSettings[i].SymbolColor = UserControls.UserControlTrendOptions.HtSchemes[schemeName].ToString().Split("|".ToCharArray())[2];
					trendSettings[i].SeriesInteriorColor = UserControls.UserControlTrendOptions.HtSchemes[schemeName].ToString().Split("|".ToCharArray())[3];
				}
				catch
				{

				}
				i++;
			}
			_appSettings.TrendSettings = trendSettings;
		}

		private static void LoadTrendSettings()
		{
			TrendSetting[] trendSettings = _appSettings.TrendSettings;

			if(trendSettings != null)
				foreach(TrendSetting trendSetting in trendSettings)
				{
					if(!UserControls.UserControlTrendOptions.HtSchemes.Contains(trendSetting.SchemeName))
						UserControls.UserControlTrendOptions.HtSchemes.Add(trendSetting.SchemeName, trendSetting.SeriesType + "|" + trendSetting.SymbolShape + "|" +trendSetting.SymbolColor + "|" +trendSetting.SeriesInteriorColor);
				}
		}

		#endregion

		#region Fields

		private static bool _disablePersistance;
		private static LRRApplicationSettings _appSettings;
        private static LRRApplicationSettings _compositeViewSettings;
		private static Hashtable _htExcludedControls = new Hashtable();
		private static Hashtable _htUserQueries = new Hashtable();

		#endregion
	}
}
