using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Globals.Enums;  
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Drawing;
using Symcon.Utils.HeaderDispatcher;  


using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for AddMasterProperties.
	/// </summary>
	public class AddMasterProperties : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCheckAll;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridMasterProperties;
		private System.Windows.Forms.Label lblMeasurementSystem;
		private System.Windows.Forms.ComboBox cmbMeasurementSystem;
		private LRRMeasurementSystems _lrrMeasurementSystems = new LRRMeasurementSystems();
		private LRRApp				  _app;
		public string sLocaleID="";
		private System.Windows.Forms.CheckBox chkCopyToAll;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Button btnCommon;
		private System.Windows.Forms.Button BtnUnionAll;
        private Panel panel2;
        private Splitter splitter1;
        private Panel panel1;
		private System.ComponentModel.IContainer components;

		public AddMasterProperties(LRRMasterProperties collectionBase,string siteComponentID)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InternationalizationUtils.GetControlText(this,null); 
			
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

					
			//sLocaleID =  _app.AppLocaleID;

			masterProperties = collectionBase;
			scID = siteComponentID; 
			//Columns to be shown in this view...
			Hashtable filteredProps = new Hashtable();
			filteredProps.Add("Name",null);
			filteredProps.Add("Description",null);
			filteredProps.Add("ModeID",null);
			filteredProps.Add("IsSelected",null);
			filteredProps.Add("MasterPropertyUOMTypeID",null);
			filteredProps.Add("IsAggregatable",null);
			gridMasterProperties.DataSource = masterProperties;
			SyncGridUtilities.InitializeGridColumns(gridMasterProperties,gridMasterProperties.TableDescriptor,collectionBase.ItemType,null,true,null,filteredProps,true);
			SyncGridUtilities.InitializeGridLookAndFeel(gridMasterProperties);

			//Make all the columns ReadOnly except IsSelected
			foreach(GridColumnDescriptor gcd in this.gridMasterProperties.TableDescriptor.Columns)
			{
				if(gcd.MappingName != "IsSelected")
					gcd.ReadOnly = true;
				if(gcd.MappingName == "MasterPropertyUOMTypeID_Name")
					gcd.Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
   
				gcd.Appearance.AnyRecordFieldCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;        
			}
			bindMeasurementSystemCombo();	
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddMasterProperties));
            this.btnOK = new System.Windows.Forms.Button();
            this.button2 = new System.Windows.Forms.Button();
            this.gridMasterProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.btnCheckAll = new System.Windows.Forms.Button();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.cmbMeasurementSystem = new System.Windows.Forms.ComboBox();
            this.lblMeasurementSystem = new System.Windows.Forms.Label();
            this.chkCopyToAll = new System.Windows.Forms.CheckBox();
            this.btnCommon = new System.Windows.Forms.Button();
            this.BtnUnionAll = new System.Windows.Forms.Button();
            this.panel2 = new System.Windows.Forms.Panel();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.panel1 = new System.Windows.Forms.Panel();
            ((System.ComponentModel.ISupportInitialize)(this.gridMasterProperties)).BeginInit();
            this.panel2.SuspendLayout();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // btnOK
            // 
            this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.btnOK.Location = new System.Drawing.Point(556, 44);
            this.btnOK.Name = "btnOK";
            this.btnOK.Size = new System.Drawing.Size(75, 24);
            this.btnOK.TabIndex = 0;
            this.btnOK.Tag = "SID_OK";
            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // button2
            // 
            this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.button2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.button2.Location = new System.Drawing.Point(637, 44);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(75, 24);
            this.button2.TabIndex = 1;
            this.button2.Tag = "SID_CANCEL";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // gridMasterProperties
            // 
            this.gridMasterProperties.BackColor = System.Drawing.SystemColors.Window;
            this.gridMasterProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridMasterProperties.Location = new System.Drawing.Point(0, 0);
            this.gridMasterProperties.Name = "gridMasterProperties";
            this.gridMasterProperties.Size = new System.Drawing.Size(722, 326);
            this.gridMasterProperties.TabIndex = 20;
            this.gridMasterProperties.TableDescriptor.AllowNew = false;
            this.gridMasterProperties.TableDescriptor.AllowRemove = false;
            this.gridMasterProperties.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
            this.gridMasterProperties.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridMasterProperties.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridMasterProperties.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridMasterProperties.TableDescriptor.TopLevelGroupOptions.ShowCaption = false;
            this.gridMasterProperties.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridMasterProperties.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridMasterProperties.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
            this.gridMasterProperties.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            this.gridMasterProperties.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
            this.gridMasterProperties.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
            this.gridMasterProperties.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
            this.gridMasterProperties.Text = "gridMasterPlantItems";
            this.gridMasterProperties.ThemesEnabled = false;
            this.gridMasterProperties.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridMasterProperties.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridMasterProperties.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridMasterProperties.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridMasterProperties.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridMasterProperties.TopLevelGroupOptions.ShowFilterBar = true;
            this.gridMasterProperties.VersionInfo = "3.301.0.0";
            // 
            // btnCheckAll
            // 
            this.btnCheckAll.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.btnCheckAll.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnCheckAll.ImageIndex = 0;
            this.btnCheckAll.ImageList = this.imageList1;
            this.btnCheckAll.Location = new System.Drawing.Point(462, 44);
            this.btnCheckAll.Name = "btnCheckAll";
            this.btnCheckAll.Size = new System.Drawing.Size(88, 24);
            this.btnCheckAll.TabIndex = 4;
            this.btnCheckAll.Tag = "SID_CHECKALL";
            this.btnCheckAll.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.btnCheckAll.Click += new System.EventHandler(this.btnCheckAll_Click);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            // 
            // cmbMeasurementSystem
            // 
            this.cmbMeasurementSystem.Location = new System.Drawing.Point(131, 17);
            this.cmbMeasurementSystem.Name = "cmbMeasurementSystem";
            this.cmbMeasurementSystem.Size = new System.Drawing.Size(112, 21);
            this.cmbMeasurementSystem.TabIndex = 5;
            this.cmbMeasurementSystem.SelectedIndexChanged += new System.EventHandler(this.cmbMeasurementSystem_SelectedIndexChanged);
            // 
            // lblMeasurementSystem
            // 
            this.lblMeasurementSystem.Location = new System.Drawing.Point(3, 17);
            this.lblMeasurementSystem.Name = "lblMeasurementSystem";
            this.lblMeasurementSystem.Size = new System.Drawing.Size(128, 32);
            this.lblMeasurementSystem.TabIndex = 6;
            this.lblMeasurementSystem.Tag = "SID_MSSYS";
            // 
            // chkCopyToAll
            // 
            this.chkCopyToAll.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.chkCopyToAll.ImageIndex = 1;
            this.chkCopyToAll.Location = new System.Drawing.Point(259, 17);
            this.chkCopyToAll.Name = "chkCopyToAll";
            this.chkCopyToAll.Size = new System.Drawing.Size(144, 24);
            this.chkCopyToAll.TabIndex = 7;
            this.chkCopyToAll.Tag = "SID_COPYTOALLPLANT";
            this.chkCopyToAll.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkCopyToAll.CheckedChanged += new System.EventHandler(this.chkCopyToAll_CheckedChanged);
            // 
            // btnCommon
            // 
            this.btnCommon.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.btnCommon.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnCommon.ImageIndex = 0;
            this.btnCommon.ImageList = this.imageList1;
            this.btnCommon.Location = new System.Drawing.Point(344, 44);
            this.btnCommon.Name = "btnCommon";
            this.btnCommon.Size = new System.Drawing.Size(112, 24);
            this.btnCommon.TabIndex = 8;
            this.btnCommon.Tag = "SID_COMMONTOALL";
            this.btnCommon.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.btnCommon.Click += new System.EventHandler(this.btnCommon_Click);
            // 
            // BtnUnionAll
            // 
            this.BtnUnionAll.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.BtnUnionAll.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.BtnUnionAll.ImageIndex = 0;
            this.BtnUnionAll.ImageList = this.imageList1;
            this.BtnUnionAll.Location = new System.Drawing.Point(226, 44);
            this.BtnUnionAll.Name = "BtnUnionAll";
            this.BtnUnionAll.Size = new System.Drawing.Size(112, 24);
            this.BtnUnionAll.TabIndex = 9;
            this.BtnUnionAll.Tag = "SID_UNION";
            this.BtnUnionAll.Click += new System.EventHandler(this.BtnUnionAll_Click);
            // 
            // panel2
            // 
            this.panel2.Controls.Add(this.lblMeasurementSystem);
            this.panel2.Controls.Add(this.BtnUnionAll);
            this.panel2.Controls.Add(this.btnOK);
            this.panel2.Controls.Add(this.btnCommon);
            this.panel2.Controls.Add(this.button2);
            this.panel2.Controls.Add(this.chkCopyToAll);
            this.panel2.Controls.Add(this.btnCheckAll);
            this.panel2.Controls.Add(this.cmbMeasurementSystem);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel2.Location = new System.Drawing.Point(0, 329);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(722, 75);
            this.panel2.TabIndex = 10;
            // 
            // splitter1
            // 
            this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter1.Location = new System.Drawing.Point(0, 326);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(722, 3);
            this.splitter1.TabIndex = 22;
            this.splitter1.TabStop = false;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.gridMasterProperties);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(722, 326);
            this.panel1.TabIndex = 23;
            // 
            // AddMasterProperties
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(722, 404);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.panel2);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "AddMasterProperties";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Tag = "SID_ADDMASTERPPTIES";
            ((System.ComponentModel.ISupportInitialize)(this.gridMasterProperties)).EndInit();
            this.panel2.ResumeLayout(false);
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion


		private void btnOK_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.OK;
		}

	

		private void btnCheckAll_Click(object sender, System.EventArgs e)
		{
            clearPreviousSelection();	
			bool checkedFlag = false;
			if(btnCheckAll.Text == LRRHeaderText.GetHeaderString("SID_CHECKALL"))
			{
				checkedFlag = true;
				btnCheckAll.Text = LRRHeaderText.GetHeaderString("SID_CLEAR_ALL");
			}
			else if(btnCheckAll.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_ALL"))
			{
				checkedFlag = false;
				btnCheckAll.Text = LRRHeaderText.GetHeaderString("SID_CHECKALL");
			}
			IEnumerator iEnum = masterProperties.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRMasterProperty masterProperty = iEnum.Current as LRRMasterProperty;
				if(masterProperty != null)
					masterProperty.IsSelected = checkedFlag;
			}
			if(BtnUnionAll.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
			{	
				checkedFlag = false;
				BtnUnionAll.Text =  LRRHeaderText.GetHeaderString("SID_UNION");
			}
			if(btnCommon.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
			{
				checkedFlag = false;
				btnCommon.Text =  LRRHeaderText.GetHeaderString("SID_COMMONTOALL");
			}

			gridMasterProperties.Refresh();
		
		
		}

		private void cmbMeasurementSystem_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			System.Windows.Forms.ComboBox cmbItem = sender as System.Windows.Forms.ComboBox;
			LRRMeasurementSystem objSelectedItem = cmbItem.SelectedItem as LRRMeasurementSystem;
			sLocaleID = objSelectedItem.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
		}

		private void bindMeasurementSystemCombo()
		{

			_app.DBManagerObj.PopulateCollection(_lrrMeasurementSystems ,false);
			cmbMeasurementSystem.DataSource = _lrrMeasurementSystems;
			cmbMeasurementSystem.DisplayMember = "Locale";
			cmbMeasurementSystem.ValueMember="ID";

			sLocaleID =  _app.AppLocaleID;
			if((sLocaleID != null) ||(sLocaleID != ""))
			{
				_lrrMeasurementSystems.ItemFilter="UIUOM = true";
				if(_lrrMeasurementSystems.Count > 0)
				{
					cmbMeasurementSystem.SelectedItem = _lrrMeasurementSystems[0];
				}
				_lrrMeasurementSystems.ItemFilter="";
			}
		}

		private void chkCopyToAll_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkCopyToAll.Checked)
				SiteComponentEntry.copyToAll = true;
			else
				SiteComponentEntry.copyToAll = false;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			SiteComponentEntry.copyToAll = false;
		}

		private void btnCommon_Click(object sender, System.EventArgs e)
		{
			clearPreviousSelection();
			try
			{
				bool checkedFlag = false;
				bool isCommon = false;
				ArrayList list = new ArrayList();
				if(btnCommon.Text == LRRHeaderText.GetHeaderString("SID_COMMONTOALL"))
				{
					checkedFlag = true;
					btnCommon.Text = LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON");
				}
				else if(btnCommon.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
				{
					checkedFlag = false;
					btnCommon.Text =  LRRHeaderText.GetHeaderString("SID_COMMONTOALL");
				}
				Hashtable commonSiteComp = new Hashtable();
				foreach(LRRMasterProperty lmp in masterProperties)
				{
					int i = 1;
					LRRSiteComponents  lscs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(lmp.ComponentID);
					lrrsiteComponents = lscs;
					siteCompCount = lscs.Count;
					foreach(LRRSiteComponent lsc in lscs)
					{
						if(lsc.SiteComponentID != scID)
						{
							LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(lsc.SiteComponentID,lmp.PropID);
							if(lscp != null)
							{
								if(commonSiteComp[lscp.PropertyID] == null)
								{
									commonSiteComp.Add(lscp.PropertyID,i);
								}
							}
						}
					}
				}
				IEnumerator iEnum = commonSiteComp.GetEnumerator();
				while(iEnum.MoveNext())
				{
					DictionaryEntry dEntry =(DictionaryEntry)iEnum.Current;
					string propID = dEntry.Key.ToString();
					LRRMasterProperty lmprop = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(propID);
					if(lmprop != null)
					{
						foreach(LRRSiteComponent lsc1 in lrrsiteComponents)
						{
							if(lsc1.ObjectState != DBOperation.INSERT)
							{
								if(lsc1.SiteComponentID != scID)
								{
									LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(lsc1.SiteComponentID);
									if(lscps.Count != 0)
									{
										LRRSiteComponentProperty lscp = lscps.GetSiteCompPropFromName(lmprop.Name);
										if(lscp == null || lscp.ObjectState == DBOperation.DELETE)
										{
											isCommon = false;
											break;
										}
										if(lscp!=null && !commonProp.ContainsValue(lscp.Name))
										{
											isCommon = true;
										}
									}
								}
							}
						}
					}
					if(isCommon)
					{
						commonProp.Add(lmprop.PropID,lmprop.Name);
					}
				}
				if(commonProp.Count > 0 )
				{
					IEnumerator  iMastEnum = commonProp.Keys.GetEnumerator();  
					while(iMastEnum.MoveNext())
					{
						string propID = iMastEnum.Current.ToString(); 
						foreach(LRRMasterProperty commonLmp in masterProperties)
						{
							if(commonLmp.PropID == propID)
							{
								commonLmp.IsSelected = checkedFlag;  
							}
						}
					}
					gridMasterProperties.Refresh();
				}
				else if(btnCommon.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
				{	
					checkedFlag = false;
					btnCommon.Text =  LRRHeaderText.GetHeaderString("SID_COMMONTOALL");
				}
				if(BtnUnionAll.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
				{	
					checkedFlag = false;
					BtnUnionAll.Text =  LRRHeaderText.GetHeaderString("SID_UNION");
				}
				if(btnCheckAll.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_ALL"))
				{
					checkedFlag = false;
					btnCheckAll.Text = LRRHeaderText.GetHeaderString("SID_CHECKALL");
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(AddMasterProperties),ex.Message  ,Logger.Level.Debug);
			}
		}


	
		#region Fields

		private static int siteCompCount;
		private LRRMasterProperties   masterProperties;
		public  LRRSiteComponents		lrrsiteComponents;
		private Hashtable commonProp = new Hashtable();
		private string scID;

		#endregion 

		private void BtnUnionAll_Click(object sender, System.EventArgs e)
		{
			clearPreviousSelection(); 
			try
			{
				bool checkedFlag = false;
				ArrayList list = new ArrayList();
				if(BtnUnionAll.Text == LRRHeaderText.GetHeaderString("SID_UNION"))
				{
					checkedFlag = true;
					BtnUnionAll.Text = LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON");
				}
				else if(BtnUnionAll.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
				{
					checkedFlag = false;
					BtnUnionAll.Text =  LRRHeaderText.GetHeaderString("SID_UNION");
				}
				Hashtable unionSiteComp = new Hashtable();
				foreach(LRRMasterProperty lmp in masterProperties)
				{
					int i = 1;
					LRRSiteComponents  lscs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(lmp.ComponentID);
					lrrsiteComponents = lscs;
					siteCompCount = lscs.Count;
					foreach(LRRSiteComponent lsc in lscs)
					{
						if(lsc.SiteComponentID != scID)
						{
							LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(lsc.SiteComponentID,lmp.PropID);
							if(lscp != null)
							{
								if(unionSiteComp[lscp.PropertyID] == null)
								{
									unionSiteComp.Add(lscp.PropertyID,i);
								}
							}
						}
					}
				}
				if(unionSiteComp.Count > 0 )
				{
					IEnumerator iMastEnum = unionSiteComp.GetEnumerator();
					while(iMastEnum.MoveNext())
					{
						DictionaryEntry dEntry =(DictionaryEntry)iMastEnum.Current;
						string propID = dEntry.Key.ToString();
						foreach(LRRMasterProperty commonLmp in masterProperties)
						{
							if(commonLmp.PropID == propID)
							{
								commonLmp.IsSelected = checkedFlag;  
							}
						}
					}
					gridMasterProperties.Refresh();
				}
				else if(BtnUnionAll.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
				{	
					checkedFlag = false;
					BtnUnionAll.Text =  LRRHeaderText.GetHeaderString("SID_UNION");
				}
				if(btnCommon.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_COMMON"))
				{
					checkedFlag = false;
					btnCommon.Text =  LRRHeaderText.GetHeaderString("SID_COMMONTOALL");
				}
				if(btnCheckAll.Text == LRRHeaderText.GetHeaderString("SID_CLEAR_ALL"))
				{
					checkedFlag = false;
					btnCheckAll.Text = LRRHeaderText.GetHeaderString("SID_CHECKALL");
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(AddMasterProperties),ex.Message  ,Logger.Level.Debug);
			}
		}
		
		private void clearPreviousSelection()
		{	
			IEnumerator iEnum = masterProperties.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRMasterProperty masterProperty = iEnum.Current as LRRMasterProperty;
				if(masterProperty != null)
					masterProperty.IsSelected = false;
			}
		}

	}
}
