using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for AggregateDetails.
	/// </summary>
	public class AggregateDetails : System.Windows.Forms.Form,ILRRUIContainer
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel pnlFullAggr;
		private System.Windows.Forms.Panel pnlTopAggr;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel pnlDownAggr;
		private System.Windows.Forms.Panel pnlleftAggr;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel pnlRightlAggr;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregateOfAggregates;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregates;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregateEqpmnts;
		
		Hashtable htSiteComponents = new Hashtable();

		#region Form Fields
		private LRRApp									_app;
		private LRRAggregates							_lrrAggregates;
		private LRRAggregates							_lrrAggregatesforAggregates;
		private LRRAggregateEquipments					_lrrAggregateEquipments; 
		private LRRSiteComponents						_siteComponentsList; //Collection to get site component list.
		private GridUnBoundColumn						gridUnBoundEquip=new GridUnBoundColumn();
		private GridUnBoundColumn						gridUnBoundAgg=new GridUnBoundColumn();
		private string									_recordValueChanged="0";
		private string									_recordAggID="";
		private TabControl								_parentTabControl;
		private TabPage									_parentTabPage;
		private LRRAggregateProperties					_lrrAggregateProperties;
		private LRRAggregatePropertyValues				_lrrAggregatePropertyValues;
		private LRRAggregateGroupedProperties			_lrrAggregateGroupedProperties;
        private DuplicateValidation _chkDuplicate = new DuplicateValidation();
		private LRRAggregateGroupedPropertyValues		_lrrAggregateGroupedPropertyValues;
		private Hashtable								lrrMasterPropertyDirections=new Hashtable();
		private string									_LocaleID;
		private LRRMasterProperties						_lrrMasterCompPpties;
		private LRRMasterComponents						_lrrMasterComps=new LRRMasterComponents();
		private LRRFormulas								_lrrFormulas = null;
		private Hashtable								lrrFormulaSiteComponents = new Hashtable();
        private Dictionary<string, LRRSiteComponent>    lrrSiteComponentList = new Dictionary<string, LRRSiteComponent>();	
		private string									_sSiteComponentList = "";
		private AggregateFormula						objAggregateFormula = new AggregateFormula();
		private LRRAggregates							_Aggregates = new LRRAggregates();
		private LRRFormulas								objFormulas= new LRRFormulas();
		private LRRFormulas								_lrrTotalFormulas;
		private GridExcelFormatter						_gridExcelFormatter = new GridExcelFormatter();
		private bool									_isDeletePress = false;
		private bool									_isRecordeDel = false;
		#endregion

        public AggregateDetails()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_LocaleID = _app.AppLocaleID;

			_gridExcelFormatter.WireGrid(this.gridAggregates);


            _chkDuplicate.ChkDuplicate(gridAggregates, "AggregateID", null, "Name", null, null);  

			InitDataSource();
			BindAggregateGrid();
			BindAggregateEqpmntsGrid();
			BindAggregateOfAggregatesGrid();

			// Sorting columns
			gridAggregates.TableDescriptor.SortedColumns.Add("Name");
			gridAggregateEqpmnts.TableDescriptor.SortedColumns.Add("Name");
			gridAggregateOfAggregates.TableDescriptor.SortedColumns.Add("Name");

			//--Form the datasource for the formula
			LRRMasterComponents masterComponents = LRRModel.Model;
			lrrFormulaSiteComponents.Clear();
			lrrFormulaSiteComponents.Add(0,masterComponents);
			lrrFormulaSiteComponents.Add(1,"MasterComponents");
			lrrFormulaSiteComponents.Add(2,"SiteComponentsObj");
			lrrFormulaSiteComponents.Add(3,"Properties");
			lrrFormulaSiteComponents.Add(4,_lrrAggregateProperties);
			lrrFormulaSiteComponents.Add(5,_lrrAggregates);

			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
			LRRFormulaDataStore.ModeFlag = true;
            LRRFormulaDataStore.Aggregates = _lrrAggregates.AggregatesHash;
			LRRFormulaDataStore.ShowGroupedAttributes = false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;

			_lrrFormulas= new LRRFormulas();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pnlFullAggr = new System.Windows.Forms.Panel();
			this.pnlDownAggr = new System.Windows.Forms.Panel();
			this.pnlRightlAggr = new System.Windows.Forms.Panel();
			this.gridAggregateOfAggregates = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.pnlleftAggr = new System.Windows.Forms.Panel();
			this.gridAggregateEqpmnts = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlTopAggr = new System.Windows.Forms.Panel();
			this.gridAggregates = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlFullAggr.SuspendLayout();
			this.pnlDownAggr.SuspendLayout();
			this.pnlRightlAggr.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateOfAggregates)).BeginInit();
			this.pnlleftAggr.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateEqpmnts)).BeginInit();
			this.pnlTopAggr.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridAggregates)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlFullAggr
			// 
			this.pnlFullAggr.Controls.Add(this.pnlDownAggr);
			this.pnlFullAggr.Controls.Add(this.splitter1);
			this.pnlFullAggr.Controls.Add(this.pnlTopAggr);
			this.pnlFullAggr.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlFullAggr.Location = new System.Drawing.Point(0, 0);
			this.pnlFullAggr.Name = "pnlFullAggr";
			this.pnlFullAggr.Size = new System.Drawing.Size(984, 598);
			this.pnlFullAggr.TabIndex = 0;
			// 
			// pnlDownAggr
			// 
			this.pnlDownAggr.Controls.Add(this.pnlRightlAggr);
			this.pnlDownAggr.Controls.Add(this.splitter2);
			this.pnlDownAggr.Controls.Add(this.pnlleftAggr);
			this.pnlDownAggr.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlDownAggr.Location = new System.Drawing.Point(0, 291);
			this.pnlDownAggr.Name = "pnlDownAggr";
			this.pnlDownAggr.Size = new System.Drawing.Size(984, 307);
			this.pnlDownAggr.TabIndex = 2;
			// 
			// pnlRightlAggr
			// 
			this.pnlRightlAggr.Controls.Add(this.gridAggregateOfAggregates);
			this.pnlRightlAggr.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlRightlAggr.Location = new System.Drawing.Point(531, 0);
			this.pnlRightlAggr.Name = "pnlRightlAggr";
			this.pnlRightlAggr.Size = new System.Drawing.Size(453, 307);
			this.pnlRightlAggr.TabIndex = 2;
			// 
			// gridAggregateOfAggregates
			// 
			this.gridAggregateOfAggregates.BackColor = System.Drawing.SystemColors.Window;
			this.gridAggregateOfAggregates.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridAggregateOfAggregates.Location = new System.Drawing.Point(0, 0);
			this.gridAggregateOfAggregates.Name = "gridAggregateOfAggregates";
			this.gridAggregateOfAggregates.Size = new System.Drawing.Size(453, 307);
			this.gridAggregateOfAggregates.TabIndex = 0;
			this.gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
			this.gridAggregateOfAggregates.TableDescriptor.AllowNew = false;
			this.gridAggregateOfAggregates.TableDescriptor.AllowRemove = false;
			this.gridAggregateOfAggregates.Text = "gridGroupingControl3";
			this.gridAggregateOfAggregates.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_AGGREGAT") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridAggregateOfAggregates.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridAggregateOfAggregates.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridAggregateOfAggregates.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridAggregateOfAggregates.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridAggregateOfAggregates.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridAggregateOfAggregates.VersionInfo = "3.301.0.0";
			this.gridAggregateOfAggregates.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridAggregateOfAggregates_RecordValueChanged);
            this.gridAggregateOfAggregates.TableControlCheckBoxClick += new GridTableControlCellClickEventHandler(gridAggregateOfAggregates_TableControlCheckBoxClick);  
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(528, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 307);
			this.splitter2.TabIndex = 1;
			this.splitter2.TabStop = false;
			// 
			// pnlleftAggr
			// 
			this.pnlleftAggr.Controls.Add(this.gridAggregateEqpmnts);
			this.pnlleftAggr.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlleftAggr.Location = new System.Drawing.Point(0, 0);
			this.pnlleftAggr.Name = "pnlleftAggr";
			this.pnlleftAggr.Size = new System.Drawing.Size(528, 307);
			this.pnlleftAggr.TabIndex = 0;
			// 
			// gridAggregateEqpmnts
			// 
			this.gridAggregateEqpmnts.BackColor = System.Drawing.SystemColors.Window;
			this.gridAggregateEqpmnts.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridAggregateEqpmnts.Location = new System.Drawing.Point(0, 0);
			this.gridAggregateEqpmnts.Name = "gridAggregateEqpmnts";
			this.gridAggregateEqpmnts.Size = new System.Drawing.Size(528, 307);
			this.gridAggregateEqpmnts.TabIndex = 1;
			this.gridAggregateEqpmnts.TableDescriptor.AllowEdit = false;
			this.gridAggregateEqpmnts.TableDescriptor.AllowNew = false;
			this.gridAggregateEqpmnts.TableDescriptor.AllowRemove = false;
			this.gridAggregateEqpmnts.Text = "gridGroupingControl3";
			this.gridAggregateEqpmnts.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridAggregateEqpmnts.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridAggregateEqpmnts.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridAggregateEqpmnts.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridAggregateEqpmnts.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridAggregateEqpmnts.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridAggregateEqpmnts.VersionInfo = "3.301.0.0";
			this.gridAggregateEqpmnts.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridAggregateEqpmnts_RecordValueChanged);
            this.gridAggregateEqpmnts.TableControlCheckBoxClick += new GridTableControlCellClickEventHandler(gridAggregateEqpmnts_TableControlCheckBoxClick); 
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 288);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(984, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// pnlTopAggr
			// 
			this.pnlTopAggr.Controls.Add(this.gridAggregates);
			this.pnlTopAggr.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlTopAggr.Location = new System.Drawing.Point(0, 0);
			this.pnlTopAggr.Name = "pnlTopAggr";
			this.pnlTopAggr.Size = new System.Drawing.Size(984, 288);
			this.pnlTopAggr.TabIndex = 0;
			// 
			// gridAggregates
			// 
			this.gridAggregates.BackColor = System.Drawing.SystemColors.Window;
			this.gridAggregates.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridAggregates.Location = new System.Drawing.Point(0, 0);
			this.gridAggregates.Name = "gridAggregates";
			this.gridAggregates.Size = new System.Drawing.Size(984, 288);
			this.gridAggregates.TabIndex = 0;
			this.gridAggregates.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridAggregates.Text = "gridGroupingControl1";
			this.gridAggregates.TopLevelGroupOptions.CaptionText = "Aggregate(s) Definition: {RecordCount} Items";
			this.gridAggregates.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridAggregates.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridAggregates.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridAggregates.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridAggregates.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridAggregates.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridAggregates.VersionInfo = "3.301.0.0";
			this.gridAggregates.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridAggregates_RecordDeleting);
			this.gridAggregates.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridAggregates_RecordValueChanged);
			this.gridAggregates.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridAggregates_TableControlCurrentCellShowingDropDown);
			this.gridAggregates.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridAggregates_CurrentRecordContextChange);
			this.gridAggregates.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.gridAggregates_TableControlCurrentCellCloseDropDown);
            this.gridAggregates.TableControlCellClick += new GridTableControlCellClickEventHandler(gridAggregates_TableControlCellClick);
			// 
			// AggregateDetails
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(984, 598);
			this.Controls.Add(this.pnlFullAggr);
			this.Name = "AggregateDetails";
			this.Tag = "SID_AGGREGAT";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Closed += new System.EventHandler(this.AggregateDetails_Closed);
			this.Activated += new System.EventHandler(this.AggregateDetails_Activated);
			this.pnlFullAggr.ResumeLayout(false);
			this.pnlDownAggr.ResumeLayout(false);
			this.pnlRightlAggr.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateOfAggregates)).EndInit();
			this.pnlleftAggr.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridAggregateEqpmnts)).EndInit();
			this.pnlTopAggr.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridAggregates)).EndInit();
			this.ResumeLayout(false);

		}

        void gridAggregateOfAggregates_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        {
            if (CheckForIsAggregateable())
            {
                string sAggID = "";
                string sCompType = "";
                bool bSelected = false;
                bool bExists = false;

                object[] objAgg = gridUnBoundAgg.GetSelectedRecords();
                if (objAgg.Length == 0)
                    gridUnBoundEquip.ClearSelectedRecords();

                LRRAggregate objChildAggregate = e.TableControl.Table.DisplayElements[e.Inner.RowIndex].GetData() as LRRAggregate;    /*gridAggregateOfAggregates.Table.DisplayElements[e.RowIndex].GetData() as LRRAggregate*/ ;
                sAggID = objChildAggregate.AggregateID == null ? "" : objChildAggregate.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                sCompType = objChildAggregate.EquipmentTypeID == null ? "" : objChildAggregate.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                LRRAggregate objParentAggregate = null;
                if (gridAggregates.TableControl.Table.CurrentRecord != null)
                {
                    objParentAggregate = gridAggregates.TableControl.Table.CurrentRecord.GetData() as LRRAggregate;
                }
                else
                {
                    Element eCurrentElement = gridAggregates.TableControl.Table.CurrentElement;
                    GridNestedTable gnt = eCurrentElement as GridNestedTable;
                    GridNestedTable gnt1 = gnt;
                    GridTableDescriptor gtd = null;
                    GridTableModel tableModel = new GridTableModel();
                    while (gnt1 != null && gnt1.ChildTable != null)
                    {
                        gnt = gnt1;
                        gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                        gtd = gnt.ParentTable.ParentTableDescriptor;
                    }
                    if (gnt != null)
                    {
                        GridChildTable childTable = gnt.ChildTable as GridChildTable;
                        if (childTable != null)
                        {
                            LRRAggregate selectedAggr = null;
                            if (childTable.Name.Equals("Values"))
                            {
                                LRRAggregateProperty aggProp = childTable.ParentDisplayElement.ParentRecord.GetData() as LRRAggregateProperty;
                                objParentAggregate = LRRModel.AggregatesObj.GetAggregateFromID(aggProp.AggregateID) as LRRAggregate;
                            }
                            else if (childTable.Name.Equals("Properties"))
                            {
                                objParentAggregate = childTable.ParentDisplayElement.ParentRecord.GetData() as LRRAggregate;
                            }
                        }
                    }
                }
                //Remove Aggregate from AggregateOfAggregate
                if (gridAggregateOfAggregates.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue.ToString() == "True")
                {
                    LRRAggregateEquipment aggregateEquip = null;
                    LRRAggregateEquipments aggregateEquips = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(objParentAggregate.AggregateID);
                    foreach (LRRAggregateEquipment aggEquip in aggregateEquips)
                    {
                        if (aggEquip.ChildAggregateID == sAggID)
                        {
                            aggregateEquip = aggEquip;
                            break;
                        }
                    }
                    _lrrAggregateEquipments.Remove(aggregateEquip);
                    objParentAggregate.AggregateEquipments.Remove(objChildAggregate);
                }
                //Add Aggregate as part of onther aggregate.
                else if (gridAggregateOfAggregates.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue.ToString() == "")
                {
                    LRRAggregateEquipment aggregateEquip = new LRRAggregateEquipment();
                    aggregateEquip.ChildAggregateID = objChildAggregate.AggregateID;
                    aggregateEquip.ParentAggregateID = objParentAggregate.AggregateID;
                    objParentAggregate.AggregateEquipments.Add(aggregateEquip);
                    _lrrAggregateEquipments.Add(aggregateEquip);
                    bSelected = true;
                }
                e.TableControl.Table.TableModel.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex).FieldDescriptor.ForceImmediateSaveValue = true;   
                ApplyFinerFilterForAggGroupGrid(sAggID, sCompType, bSelected);
            }
        }

        void gridAggregateEqpmnts_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
        {
            string sSiteComponentID = "";
            bool bExists = false;

            GridGroupingControl ggc = sender as GridGroupingControl;
            LRRSiteComponent objSiteComponent = e.TableControl.Table.DisplayElements[e.Inner.RowIndex].GetData() as LRRSiteComponent;

            sSiteComponentID = objSiteComponent.SiteComponentID == null ? "" : objSiteComponent.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

            if (gridAggregates.TableControl.Table.CurrentRecord != null)
            {
                LRRAggregate selectedAggr = gridAggregates.TableControl.Table.CurrentRecord.GetData() as LRRAggregate;
                string sAggregateID = selectedAggr.AggregateID == null ? "" : selectedAggr.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                LRRAggregateEquipment aggregateEquipToUpdate = null;
                if (selectedAggr != null)
                {
                    if (e.TableControl.Table.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue.ToString().ToUpper() == "")
                    {
                        aggregateEquipToUpdate = new LRRAggregateEquipment();
                        aggregateEquipToUpdate.EquipmentID = sSiteComponentID;
                        aggregateEquipToUpdate.ParentAggregateID = sAggregateID;
                        _lrrAggregateEquipments.Add(aggregateEquipToUpdate);
                        selectedAggr.AggregateEquipments.Add(aggregateEquipToUpdate);
                    }
                    else if (e.TableControl.Table.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue.ToString().ToUpper() == "TRUE")
                    {
                        //equipments
                        LRRAggregateEquipments aggregateEquips = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(sAggregateID);
                        foreach (LRRAggregateEquipment aggregateEquip in aggregateEquips)
                        {
                            if (aggregateEquip.EquipmentID == sSiteComponentID)
                            {
                                aggregateEquipToUpdate = aggregateEquip;
                                break;
                            }
                        }
                        _lrrAggregateEquipments.Remove(aggregateEquipToUpdate);
                        selectedAggr.AggregateEquipments.Remove(aggregateEquipToUpdate);
                    }
                    CheckForUpdate(objSiteComponent, ggc, aggregateEquipToUpdate);
                }
            }
            else
            {
                Element eCurrentElement = gridAggregates.TableControl.Table.CurrentElement;
                GridNestedTable gnt = eCurrentElement as GridNestedTable;
                GridNestedTable gnt1 = gnt;
                GridTableDescriptor gtd = null;
                GridTableModel tableModel = new GridTableModel();
                while (gnt1 != null && gnt1.ChildTable != null)
                {
                    gnt = gnt1;
                    gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                    gtd = gnt.ParentTable.ParentTableDescriptor;
                }
                if (gnt != null)
                {
                    GridChildTable childTable = gnt.ChildTable as GridChildTable;
                    if (childTable != null)
                    {
                        LRRAggregate selectedAggr = null;
                        if (childTable.Name.Equals("Values"))
                        {
                            LRRAggregateProperty aggProp = childTable.ParentDisplayElement.ParentRecord.GetData() as LRRAggregateProperty;
                            selectedAggr = LRRModel.AggregatesObj.GetAggregateFromID(aggProp.AggregateID) as LRRAggregate;
                        }
                        else if (childTable.Name.Equals("Properties"))
                        {
                            selectedAggr = childTable.ParentDisplayElement.ParentRecord.GetData() as LRRAggregate;
                        }
                        string sAggregateID = selectedAggr.AggregateID == null ? "" : selectedAggr.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        LRRAggregateEquipment aggregateEquipToUpdate = null;
                        if (selectedAggr != null)
                        {
                            if (e.TableControl.Table.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue.ToString().ToUpper() == "")
                            {
                                aggregateEquipToUpdate = new LRRAggregateEquipment();
                                aggregateEquipToUpdate.EquipmentID = sSiteComponentID;
                                aggregateEquipToUpdate.ParentAggregateID = sAggregateID;
                                _lrrAggregateEquipments.Add(aggregateEquipToUpdate);
                                selectedAggr.AggregateEquipments.Add(aggregateEquipToUpdate);
                            }
                            else if (e.TableControl.Table.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue.ToString().ToUpper() == "TRUE")
                            {
                                //equipments
                                LRRAggregateEquipments aggregateEquips = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(sAggregateID);
                                foreach (LRRAggregateEquipment aggregateEquip in aggregateEquips)
                                {
                                    if (aggregateEquip.EquipmentID == sSiteComponentID)
                                    {
                                        aggregateEquipToUpdate = aggregateEquip;
                                        break;
                                    }
                                }
                                _lrrAggregateEquipments.Remove(aggregateEquipToUpdate);
                                selectedAggr.AggregateEquipments.Remove(aggregateEquipToUpdate);
                            }
                            CheckForUpdate(objSiteComponent, ggc, aggregateEquipToUpdate);
                        }
                    }
                }
            }
            e.TableControl.Table.TableModel.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex).FieldDescriptor.ForceImmediateSaveValue = true;   
        }

        private bool CheckForIsAggregateable()
        {
            if (gridAggregates.TableControl.Table.CurrentRecord == null)
            {
                Element eCurrentElement = gridAggregates.TableControl.Table.CurrentElement;
                if (eCurrentElement.ParentRecord.GetData().GetType() == typeof(LRRAggregate))
                {
                    LRRAggregate parentAggregate = eCurrentElement.ParentRecord.GetData() as LRRAggregate;
                    if (parentAggregate.IsAggregateOfAggregates)
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }

                return true;
            }
            else
            {
                LRRAggregate selectedAggregate = gridAggregates.TableControl.Table.CurrentRecord.GetData() as LRRAggregate;
                if (selectedAggregate.IsAggregateOfAggregates)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
        }


        
		
		
		#endregion

		#region Private Members
		
		private bool ValidateClose()
		{
			try
			{
				if(_lrrAggregates.GetChanges().Count > 0)
				{
					DialogResult k = LRRMessagBox.ShowMessage("SID_SAVEINFO_QUESTION","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
					if(k == DialogResult.Yes)     
					{
						return true;			
					}
					else
					{
						return false;
					}
				}
				else
				{
					return true;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(AggregateDetails),ex.Message  ,Logger.Level.Debug);
				return false;

			}
		}
		

		private void InitDataSource()
		{
			LRRSiteComponents	siteComponents;

			if(_lrrAggregatesforAggregates != null)
				_lrrAggregatesforAggregates.Clear();

			_siteComponentsList = new LRRSiteComponents();
			_lrrAggregatesforAggregates = new LRRAggregates();
			_lrrAggregates = LRRModel.AggregatesObj;
			_lrrAggregateEquipments = LRRModel.AggregateEquipmentsObj;
			_lrrAggregateProperties = LRRModel.AggregatePropertiesObj;
			_lrrAggregatePropertyValues = LRRModel.AggregatePropertyValuesObj;
			_lrrAggregateGroupedProperties = LRRModel.AggregateGroupedPropertiesObj;
			_lrrAggregateGroupedPropertyValues = LRRModel.AggregateGroupedPropertyValuesObj;
			_lrrMasterCompPpties = LRRModel.MasterComponentPropertiesObj;
			_lrrTotalFormulas = LRRModel.FormulasObj;
			_app.DBManagerObj.PopulateCollection(_lrrAggregatesforAggregates,false);
			_lrrAggregatePropertyValues.SortColumn = "ModeID";
			_lrrAggregatePropertyValues.Sort();
			siteComponents = LRRModel.SiteComponentsObj;
		}
		
		/// <summary>
		/// In table close drop down, this function is invoked to 
		/// get list of master properties for the selected component type id having agg = true
		/// and create Aggregate Properties
		/// </summary>
		private LRRAggregateProperty ConverMasterPropToAggregateProp(LRRMasterProperty lmpObj,string sAggregateID)
		{
			LRRAggregateProperty lap = new LRRAggregateProperty();
			lap.AggregateID = sAggregateID;
			lap.Name = lmpObj.Name;
			lap.Description = lmpObj.Description;
			lap.UOMTypeID = lmpObj.MasterPropertyUOMTypeID;
            lap.ModeID = lmpObj.ModeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lap.UOM = _lrrMSD.GetLocaleUOM(_LocaleID,lap.UOMTypeID);
			if (lrrMasterPropertyDirections.Contains(lmpObj.PropID) == false)
			{
				if(lmpObj.Direction == null)
					lrrMasterPropertyDirections.Add(lmpObj.PropID,"");
				else
					lrrMasterPropertyDirections.Add(lmpObj.PropID,lmpObj.Direction);
			}
			lap.Formula = lmpObj.AggregationRule;
			lap.MasterPropertyID= lmpObj.PropID;
			lap.MasterCompTypeID= lmpObj.ComponentID;
			return lap;
		}

		private void AggregateCompPropertyAdded(LRRAggregateProperty aggregateProperty)
		{
			bool bMatchFound = false;
            string sMPID = aggregateProperty.MasterPropertyID;
			string sGPID = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMPID).Type;
			bool bIsGrouped = false;
			
			if(sGPID != "1")
				bIsGrouped = true;
            if (aggregateProperty.ModeID == true)
			{
				for(int i=0;i < LRRModel.ProjectModes.Count;i++)
				{
					LRRMode lmsd = LRRModel.ProjectModes[i] as LRRMode;
					if(lmsd.IsDefault)
						continue;
					if(!bIsGrouped)
                        GenerateSimplePropertyValues(aggregateProperty, lmsd.ModeId);
				}
			}
			else
			{
				if(!bIsGrouped)
                    GenerateSimplePropertyValues(aggregateProperty, "0");
			}

		}


		private void CreateAggregateGroupedProperties(LRRAggregateProperty lscp)
		{
			string sMPID = lscp.MasterPropertyID;
			string sGPID = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMPID).Type;
			bool bDataArrays = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sGPID).IsDataArray;
			LRRLookUpProperties objLkupProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(sGPID);
			//For each lookup properties, create group properties
			foreach(LRRLookUpProperty objLkupProp in objLkupProps)
			{
				LRRAggregateGroupedProperty lagp = new LRRAggregateGroupedProperty();
				lagp.AggregatePropertyID = lscp.ID;
				lagp.AttributeName = objLkupProp.Name;
				lagp.AttributeDescription = objLkupProp.Description;
				lagp.LookUpPropertiesID = objLkupProp.LookUpPropertiesID;
				lagp.UOMTypeID = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMPID).MasterPropertyUOMTypeID;
				LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
				lagp.ModeID = lscp.ModeID;
				lagp.PropertyID = objLkupProp.PropertyID;
				lagp.MasterPropID =sMPID;
				
				if(lagp.ModeID ==  true)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode lmsd = LRRModel.ProjectModes[i] as LRRMode;
				
						if(lmsd.IsDefault)
							continue;
				
						GenerateGroupedPropertyValues(lagp,lmsd.ModeId,bDataArrays);
						
					}
			
				}
				else
				{
					GenerateGroupedPropertyValues(lagp,"0",bDataArrays);
					
				}
				_lrrAggregateGroupedProperties.Add(lagp);
                lscp.GroupPpties.Add(lagp);
			}

		}

		private void GenerateSimplePropertyValues(LRRAggregateProperty lscp, string sModeID)
		{
			LRRAggregatePropertyValue lscpv = new LRRAggregatePropertyValue();
			lscpv.ModeID = sModeID;
			lscpv.AggregateID = lscp.ID;
			if(lscp.MasterPropertyID != null)
			{
				if(lrrMasterPropertyDirections[lscp.MasterPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)] != null)
				{
					string sDirection = lrrMasterPropertyDirections[lscp.MasterPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString();
                    lscpv.IsEditable = true;
                    lscpv.ReadOnlyAccess = false; 
					lscpv.Direction=sDirection ;
					if((sDirection == "Input/Output") || (sDirection == "3"))
					{
						if(sModeID == "1")
							lscpv.Direction = "1";
					}
					//Add Cascading logic here
				}
			}
						
			//--item added, get the formula
			if(objFormulas != null)
			{
				foreach(LRRFormula objLRRFormula in objFormulas)
				{
					if(objLRRFormula.SourceObjectID == lscpv.ID)
						lscpv.FormulaID=objLRRFormula.ID;
				}
			}
			if(_lrrAggregatePropertyValues.GetAggregateValueObjectForPropertyMode(sModeID,lscp.ID) == null)
			{
				_lrrAggregatePropertyValues.Add(lscpv);
				lscp.Values.Add(lscpv);
			}
		}
		
		
		private void GenerateGroupedPropertyValues(LRRAggregateGroupedProperty lscgp, string sModeID,bool bDataArrays)
		{
			string sPropertyType = lscgp.PropertyID == null? "" : lscgp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
			if(bDataArrays)
			{
				CreateAggregateGroupedPropValue(lscgp,sModeID,null);
			}
			else
			{
				LRRLookUpQualifiers LRRLookUpQualifiersObj = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(sPropertyType);
			
				foreach(LRRLookUpQualifier objQualifierForGrpType in LRRLookUpQualifiersObj)
				{
					CreateAggregateGroupedPropValue(lscgp,sModeID,objQualifierForGrpType);
				}
			}
		}

		
		private void CreateAggregateGroupedPropValue(LRRAggregateGroupedProperty lscgp, string sModeID,LRRLookUpQualifier objQualifierForGrpType )
		{
			string sMasterPropID = "";
			string sGrpPropID = lscgp.AggregateGroupedPropertyID == null ? "" : lscgp.AggregateGroupedPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
			LRRAggregateGroupedPropertyValue QualifierPropertyValue = new LRRAggregateGroupedPropertyValue();
			QualifierPropertyValue.AggregateGroupPropertyID = lscgp.AggregateGroupedPropertyID;
			if(objQualifierForGrpType != null)
			{
				QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
				QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
			}
			QualifierPropertyValue.LookUpPropertiesID = lscgp.LookUpPropertiesID;
			QualifierPropertyValue.PropertyID = lscgp.PropertyID;
			QualifierPropertyValue.ModeID =sModeID;
            QualifierPropertyValue.ReadOnlyAccess = false;
            QualifierPropertyValue.IsEditable = true;
			sMasterPropID = lscgp.MasterPropID == null ? "" : lscgp.MasterPropID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			QualifierPropertyValue.MasterPropID	=sMasterPropID;
			
			if((sMasterPropID != null) && (sMasterPropID != ""))
			{
				LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMasterPropID);
				string sDirection = objMasterProp.Direction == null ? "" : objMasterProp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if((sDirection == "Input/Output") || (sDirection == "3"))
				{
					if(sModeID == "1")
						sDirection = "1";
				}
				QualifierPropertyValue.Direction=sDirection ;
			}
			_lrrAggregateGroupedPropertyValues.Add(QualifierPropertyValue);
            lscgp.GroupPptiesQualifierValues.Add(QualifierPropertyValue); 
		}
		
	
		//The function is used to apply filter based on the aggrgate group being selected.
		private void ApplyFinerFilterForAggGroupGrid(string sAggregateID,string sCompType, bool bAggSelected)
		{
			_siteComponentsList = new LRRSiteComponents();
			LRRSiteComponents oSCs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(sCompType);
			foreach(LRRSiteComponent oSC in oSCs)
			{
				if(!htSiteComponents.Contains(oSC.SiteComponentID))
					htSiteComponents.Add(oSC.SiteComponentID,oSC);
			}
			LRRAggregate aggregate = _lrrAggregates.GetAggregateFromID(sAggregateID);
			
			object[] objAgg=gridUnBoundAgg.GetSelectedRecords();
			IEnumerator enumeratorAgg = objAgg.GetEnumerator();
			while(enumeratorAgg.MoveNext())
			{
				if(enumeratorAgg.Current.ToString()=="Symcon.LightRidge.BusinessObjects.LRRAggregate")
				{
					LRRAggregate lrrAggr=enumeratorAgg.Current as LRRAggregate;
					if((lrrAggr.AggregateID == sAggregateID) && (bAggSelected))
					{
					
						//--get all the selected aggregates and corresponding  components
						GetSiteComponentsForAggregates(lrrAggr);
						_sSiteComponentList = "";
						
						//--form the filter criteria
						IEnumerator enumSC1 = lrrSiteComponentList.Keys.GetEnumerator();
						while(enumSC1.MoveNext())
						{
							_sSiteComponentList = enumSC1.Current.ToString();
							
							if(htSiteComponents.Contains(_sSiteComponentList))
								htSiteComponents.Remove(_sSiteComponentList);

						}
						lrrSiteComponentList.Clear();
						_sSiteComponentList = "";
					}
					else if (lrrAggr.AggregateID != sAggregateID)
					{
						//--get all the selected aggregates and corresponding  components
						GetSiteComponentsForAggregates(lrrAggr);
						_sSiteComponentList = "";
						
						//--form the filter criteria
						IEnumerator enumSC1 = lrrSiteComponentList.Keys.GetEnumerator();
						while(enumSC1.MoveNext())
						{
							_sSiteComponentList = enumSC1.Current.ToString();
							
							if(htSiteComponents.Contains(_sSiteComponentList))
								htSiteComponents.Remove(_sSiteComponentList);

						}
						lrrSiteComponentList.Clear();
						_sSiteComponentList = "";
					}
				}
			}

			if(bAggSelected)
			{
				GetSiteComponentsForAggregates(aggregate);
				_sSiteComponentList = "";
						
				//--form the filter criteria
				IEnumerator enumSC = lrrSiteComponentList.Keys.GetEnumerator();
				while(enumSC.MoveNext())
				{
					_sSiteComponentList = enumSC.Current.ToString();

					if(htSiteComponents.Contains(_sSiteComponentList))
						htSiteComponents.Remove(_sSiteComponentList);
				}
				lrrSiteComponentList.Clear();
				_sSiteComponentList = "";
			}
			
			IEnumerator enumHtSC = htSiteComponents.Keys.GetEnumerator();
			while(enumHtSC.MoveNext())
			{
				string sCompID = enumHtSC.Current.ToString();
			
				if(htSiteComponents.Contains(sCompID))
				{
					_siteComponentsList.Add(htSiteComponents[sCompID]);
				}
			}
			
			gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
			gridAggregateEqpmnts.DataSource = null;
			gridAggregateEqpmnts.DataSource = _siteComponentsList;
			
		}
		
		
		//The function is used to apply filter based on the equipment type being selected.
		private void ApplyFiltersForAggDtlGrids(string sCompType,string sAggregatable, string sAggregateID,bool bAddNew)
		{
			
			_siteComponentsList = new LRRSiteComponents();	
			_lrrAggregatesforAggregates = new LRRAggregates();
            if (sAggregatable.ToUpper() == "TRUE")
            {
                _lrrAggregatesforAggregates = _lrrAggregates.GetAggregatesOfAggregateForParentAggregate(sAggregateID);
            }
            else
            {
                _lrrAggregatesforAggregates = _lrrAggregates.GetAggregatesByMasterComponentID(sCompType);
            }
			LRRSiteComponents oSCs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(sCompType);
			foreach(LRRSiteComponent oSC in oSCs)
			{
				if(!htSiteComponents.Contains(oSC.SiteComponentID))
					htSiteComponents.Add(oSC.SiteComponentID,oSC);
			}
			IEnumerator enumSC = htSiteComponents.Keys.GetEnumerator();
			while(enumSC.MoveNext())
			{
				string sCompID = enumSC.Current.ToString();
			
				if(htSiteComponents.Contains(sCompID))
				{
					_siteComponentsList.Add(htSiteComponents[sCompID]);
				}
			}

			gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
			gridAggregateEqpmnts.DataSource = null;
			gridAggregateEqpmnts.DataSource = _siteComponentsList;
		
			gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
			gridAggregateOfAggregates.DataSource = null;
			gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;
	
			
		}
		
		
		#endregion
		
		#region  Bind Grids
		
		/// <summary>
		/// This Method binds the Aggregate grid to the data source.
		/// </summary>
		public void BindAggregateGrid()
		{
			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridAggregates.SuspendLayout();
			gridAggregates.TableDescriptor.Relations.Clear();
			gridAggregates.Engine.SourceListSet.Clear();
			gridAggregates.DataSource = null;
			
			SyncGridUtilities.InitializeGridLookAndFeel(gridAggregates);

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregates.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
//			_lrrAggregates.SortColumn = "Name";
//			_lrrAggregates.Sort();
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridAggregates,_lrrAggregates.ItemType,null,fkData);
			gridAggregates.TopLevelGroupOptions.CaptionText =   LRRHeaderText.GetHeaderString("SID_AGGREGATES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  

			//Add the parent table for the Relations...
			RelativeWidths.Add("Name",30);
			RelativeWidths.Add("Description",30);
			RelativeWidths.Add("IsAggregateOfAggregates",10);
			RelativeWidths.Add("EquipmentTypeID_ComponentName",25);
			

			//Initilaize the columns widths for the grid object
			SyncGridUtilities.InitializeGridColumnsWidth(gridAggregates,RelativeWidths );
			gridAggregates.Engine.SourceListSet.Add("ParentTable",_lrrAggregates);
			//Set the data store 
			gridAggregates.DataSource = _lrrAggregates;
			
			//Properties for the site component
			GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
			grdCompProps.ChildTableName = "Properties";
			grdCompProps.RelationKeys.Add("AggregateID","AggregateID");
			grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.DarkGoldenrod;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Attributes: {RecordCount} Items";
			//grdCompProps.ChildTableDescriptor.AllowRemove = false;
			grdCompProps.ChildTableDescriptor.AllowNew = false;
			gridAggregates.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
			grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			gridAggregates.TableDescriptor.Relations.Add(grdCompProps);
			gridAggregates.NestedTableGroupOptions.ShowFilterBar = true;
			gridAggregates.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridAggregates.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumnsforProp;
            Dictionary<string, SymChildDataAttribute> childColumnsforProp;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregateProperties.ItemType,out fkColumnsforProp,out childColumnsforProp);
			Hashtable fkDataforProp = new Hashtable();
			foreach(object obj in fkColumnsforProp.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttrforProp = fkColumnsforProp[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttrforProp.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkDataforProp.Add(propName,collectionObject);
			}
//			_lrrAggregateProperties.SortColumn = "Name";
//			_lrrAggregateProperties.Sort();
			SyncGridUtilities.InitializeGridColumns(gridAggregates,grdCompProps.ChildTableDescriptor,_lrrAggregateProperties.ItemType,null,fkDataforProp);
			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Properties",_lrrAggregateProperties);
			grdCompProps.ChildTableDescriptor.Columns["Name"].ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns["Description"].ReadOnly = true;
			grdCompProps.ChildTableDescriptor.RecordExpanding+=new RecordEventHandler(ChildTableDescriptor_RecordExpanding);
			//Property Values for the property
            foreach (GridColumnDescriptor gcd in grdCompProps.ChildTableDescriptor.Columns)
            {
                if (gcd.MappingName == "Formula_Expression")
                {
                    gcd.Appearance.AnyRecordFieldCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
                    gcd.AllowDropDownCell = false;
                }
            }


			GridRelationDescriptor grdCompPropValues = new GridRelationDescriptor("Values");
			grdCompPropValues.ChildTableName = "Values";
			grdCompPropValues.RelationKeys.Add("ID","AggregateID");
			grdCompPropValues.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.OrangeRed;
			grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompPropValues.ChildTableDescriptor.AllowEdit = true;//false;
			//grdCompPropValues.ChildTableDescriptor.AllowRemove = false;
			grdCompPropValues.ChildTableDescriptor.AllowNew = false;
			grdCompPropValues.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Values: {RecordCount} Items";
			grdCompPropValues.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			grdCompProps.ChildTableDescriptor.Relations.Add(grdCompPropValues);


            Dictionary<string, SymForeignKeyFieldAttribute> fkColumnsforPropVals;
            Dictionary<string, SymChildDataAttribute> childColumnsforPropVals;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregatePropertyValues.ItemType,out fkColumnsforPropVals,out childColumnsforPropVals);
			Hashtable fkDataforPropVals = new Hashtable();
			foreach(object obj in fkColumnsforPropVals.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttrforPropVals = fkColumnsforPropVals[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttrforPropVals.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkDataforPropVals.Add(propName,collectionObject);
			}
			SyncGridUtilities.InitializeGridColumns(gridAggregates,grdCompPropValues.ChildTableDescriptor,_lrrAggregatePropertyValues.ItemType,null,fkDataforPropVals);
			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Values",_lrrAggregatePropertyValues); 
			GridTableCellStyleInfo gtc = grdCompPropValues.ChildTableDescriptor.Columns["ModeID_ModeName"].Appearance.AnyRecordFieldCell;
			gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			grdCompPropValues.ChildTableDescriptor.Columns["ModeID_ModeName"].ReadOnly = true;
			grdCompPropValues.ChildTableDescriptor.Columns["ModeID_ModeName"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            GridTableCellStyleInfo gtc2 = grdCompPropValues.ChildTableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell;
            gtc2.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
            gtc2.ExclusiveChoiceList = false;
			
			gridAggregates.NestedTableGroupOptions.ShowFilterBar = true;
			gridAggregates.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridAggregates.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;

			gridAggregates.TableDescriptor.AllowNew = true;
			gridAggregates.TableDescriptor.AllowRemove = true;
			gridAggregates.TableDescriptor.AllowEdit = true;

			gridAggregates.NestedTableGroupOptions.ShowFilterBar = true;
			gridAggregates.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridAggregates.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			
			
			// sort column
			gridAggregates.TableDescriptor.Relations["Properties"].ChildTableDescriptor.SortedColumns.Add("Name");

			//Resume the Layout of the Grid...
			gridAggregates.ResumeLayout(false);

			string[,] arry=new string[,]{{"Description","255"}};
			Validations	objValidations=new Validations(gridAggregates,arry);
			
		}
		

		/// <summary>
		/// This Method binds the AggregateEqpmnts grid to the data source.
		/// </summary>
		private void BindAggregateEqpmntsGrid()
		{
			//Suspend the Layout of the Grid...
			gridAggregateEqpmnts.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridAggregateEqpmnts);
			gridAggregateEqpmnts.DataSource = null;
			gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_siteComponentsList.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			
			//Populate the columns for the grid object
//			_siteComponentsList.SortColumn="Name";
//			_siteComponentsList.Sort();
			SyncGridUtilities.InitializeGridColumns(gridAggregateEqpmnts,_siteComponentsList.ItemType,null,fkData);
			gridAggregateEqpmnts.TableDescriptor.Columns.Clear();		
			gridUnBoundEquip.WireGrid(gridAggregateEqpmnts);
			gridAggregateEqpmnts.TableDescriptor.Columns.Add("Name","Name");
			gridAggregateEqpmnts.TableDescriptor.Columns.Add("Description","Description");
			
			Hashtable RelativeWidths = new Hashtable();
			RelativeWidths.Add("Name",40);
			RelativeWidths.Add("Description",40);
			SyncGridUtilities.InitializeGridColumnsWidth(gridAggregateEqpmnts,RelativeWidths );

			//Set the data store 
			gridAggregateEqpmnts.Engine.SourceListSet.Add("ParentTable",_siteComponentsList);

			gridAggregateEqpmnts.DataSource = _siteComponentsList;

			gridAggregateEqpmnts.TableDescriptor.AllowEdit = true;
			gridAggregateEqpmnts.TableDescriptor.AllowNew = false;
			gridAggregateEqpmnts.TableDescriptor.Columns["Name"].ReadOnly=true;
			//		gridAggregateEqpmnts.TableOptions.AllowSortColumns = false;

			//Resume the Layout of the Grid...
			gridAggregateEqpmnts.ResumeLayout(false);
			
		}
		
		
		/// <summary>
		/// This Method binds the AggregateOfAggregates grid to the data source.
		/// </summary>
		private void BindAggregateOfAggregatesGrid()
		{
			//Suspend the Layout of the Grid...
			gridAggregateOfAggregates.SuspendLayout();
			gridAggregateOfAggregates.DataSource = null;
			SyncGridUtilities.InitializeGridLookAndFeel(gridAggregateOfAggregates);
			gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregatesforAggregates.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

//			_lrrAggregatesforAggregates.SortColumn="Name";
//			_lrrAggregatesforAggregates.Sort();

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridAggregateOfAggregates,_lrrAggregatesforAggregates.ItemType,null,fkData);

			gridAggregateOfAggregates.TableDescriptor.Columns.Clear();
			gridUnBoundAgg.WireGrid(gridAggregateOfAggregates);
			gridAggregateOfAggregates.TableDescriptor.Columns.Add("Name","Name");
			gridAggregateOfAggregates.TableDescriptor.Columns.Add("Description","Description");
			
			Hashtable RelativeWidths = new Hashtable();
			RelativeWidths.Add("Name",60);
			RelativeWidths.Add("Description",60);
			SyncGridUtilities.InitializeGridColumnsWidth(gridAggregateOfAggregates,RelativeWidths );

			//Add the parent table for the Relations...
			gridAggregateOfAggregates.Engine.SourceListSet.Add("ParentTable",_lrrAggregatesforAggregates);

			//Set the data store 
			gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;
			

			gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
			gridAggregateOfAggregates.TableDescriptor.AllowNew = false;
//			gridAggregateOfAggregates.TableOptions.AllowSortColumns = false;

			//Resume the Layout of the Grid...
			gridAggregateOfAggregates.ResumeLayout(false);
		
		}
		
		
		#endregion
		
		#region Events


        private void gridAggregates_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            int recCount = e.TableControl.Table.Records.Count;
            if (e.Inner.RowIndex >= recCount + 4)
            {
                _siteComponentsList = new LRRSiteComponents();
                gridUnBoundEquip.ClearSelectedRecords();
                gridUnBoundAgg.ClearSelectedRecords();
                htSiteComponents.Clear();
                gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                _lrrAggregatesforAggregates.RefreshCollection();
                gridAggregateOfAggregates.TableControl.Refresh();
                gridAggregateEqpmnts.TableControl.Refresh();
            }
        }

		private void gridAggregates_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
			GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
			if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
			{
				return;
			}
			GridTableModel tableModel = null;
			GridGroupingControl grid = sender as GridGroupingControl;
			if(grid.TableControl.Table.CurrentRecord == null)
			{
				Element eCurrentElement = grid.TableControl.Table.CurrentElement;
				GridNestedTable gnt = eCurrentElement as GridNestedTable;
				GridNestedTable gnt1 = gnt;
				GridTableDescriptor gtd = null;
				while(gnt1 != null && gnt1.ChildTable != null)
				{
					gnt = gnt1;
					gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
					gtd = gnt.ParentTable.ParentTableDescriptor;
				}

				GridChildTable childTable = gnt.ChildTable as GridChildTable;
				tableModel = childTable.ParentTable.TableModel;
				
				if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
					return;

				if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).MappingName == "UOM")
				{
					string sUOMType = "";
					try
					{
						sUOMType = ((LRRAggregateProperty)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(AggregateDetails),ex.Message  ,Logger.Level.Debug);
					}
					if(sUOMType != "" && sUOMType != null)
					{

						LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
						GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
						cr.ListBoxPart.DataSource = uoms;
						uoms.SortColumn="Name";
						uoms.Sort();
						cr.Model.SupportsChoiceList = false;
						if(uoms.Count ==0)
						{
							e.TableControl.CurrentCell.ConfirmChanges();
							//UOM not defined for the selected UOM Type
							LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
						}
					}
				}
				
			}
		}
		
		
		private void gridAggregates_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			Cursor=Cursors.WaitCursor;	
			try
			{
				string aggrEquipID="";
				string sAggregateID="";
				string sTableName = "";
				if(e.Action == CurrentRecordAction.EnterRecordComplete)
				{
					if (gridAggregates.TableControl.Table.CurrentRecord == null)
                    {
                        Element eCurrentElement = gridAggregates.TableControl.Table.CurrentElement;
                        GridNestedTable gnt = eCurrentElement as GridNestedTable;
                        GridNestedTable gnt1 = gnt;
                        GridTableDescriptor gtd = null;
                        GridTableModel tableModel = new GridTableModel();
                        while (gnt1 != null && gnt1.ChildTable != null)
                        {
                            gnt = gnt1;
                            gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                            gtd = gnt.ParentTable.ParentTableDescriptor;
                        }
                        if (gnt != null)
                        {
                            GridChildTable childTable = gnt.ChildTable as GridChildTable;
                            if (childTable != null)
                            {
                                sTableName = childTable.Name == null ? "" : childTable.Name.ToString();
                                if (childTable.Name.Equals("Values"))
                                {
                                    if (e.Record.IsCaption())
                                        return;
                                    string modeID = e.Record.GetRecord().GetValue("ModeID") == null ? "" : e.Record.GetRecord().GetValue("ModeID").ToString();
                                    string aggregatePropID = e.Record.GetRecord().GetValue("ID") == null ? "" : e.Record.GetRecord().GetValue("ID").ToString();
                                    string sValID = e.Record.GetRecord().GetValue("ID") == null ? "" : e.Record.GetRecord().GetValue("ID").ToString();
                                    string aggregateID = e.Record.GetRecord().GetValue("AggregateID") == null ? "" : e.Record.GetRecord().GetValue("AggregateID").ToString();
                                    LRRAggregate objAgg;
                                    objAgg = _lrrAggregates.GetAggregateFromID(aggregateID);
                                    if (objAgg != null)
                                    {
                                        lrrSiteComponentList.Clear();
                                        GetSiteComponentsForAggregates(objAgg);
                                        LRRFormulaDataStore.SiteComponents = lrrSiteComponentList;
                                        LRRFormulaDataStore.MasterProperties = GetMasterCompPptiesForAggregateID(aggregateID);
                                    }
                                    LRRFormulaDataStore.SourceObjectID = sValID;
                                    LRRFormulaDataStore.ModeID = modeID;
                                    LRRFormulaDataStore.SourcePropertyID = aggregatePropID;
                                    LRRFormulaDataStore.ObjectSource = typeof(LRRAggregatePropertyValue).ToString();
                                    LRRFormulaDataStore.ShowGroupedAttributes = false;
                                    LRRFormulaDataStore.SourceLookupPropertyID = null;
                                    LRRFormulaDataStore.SourceLookupQualifierID = null;
                                }
                                else if (sTableName == "Properties")
                                {
                                    gridUnBoundEquip.ClearSelectedRecords();
                                    gridUnBoundAgg.ClearSelectedRecords();
                                    htSiteComponents.Clear();

                                    LRRAggregate aggrEquipment = childTable.ParentDisplayElement.ParentRecord.GetData() as LRRAggregate;
                                    aggrEquipID = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                                    LRRAggregateEquipments objAggEquips = FilterAggregateEquipment(true, aggrEquipment.AggregateID);
                                    object[] objArrAggregateEquipment = new object[objAggEquips.Count];

                                    gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
                                    gridAggregateEqpmnts.DataSource = null;
                                    _siteComponentsList = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(aggrEquipID);
                                    gridAggregateEqpmnts.DataSource = _siteComponentsList;

                                    for (int i = 0; i < _siteComponentsList.Count; i++)
                                    {
                                        LRRSiteComponent site = _siteComponentsList[i] as LRRSiteComponent;
                                        for (int j = 0; j < objAggEquips.Count; j++)
                                        {
                                            LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                            if (lrrAggrEquipment.EquipmentID == site.SiteComponentID)
                                                objArrAggregateEquipment[j] = site;
                                        }
                                    }

                                    if (aggrEquipment.IsAggregateOfAggregates == false)
                                    {
                                        gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
                                        gridAggregateOfAggregates.DataSource = null;
                                        _lrrAggregatesforAggregates = _lrrAggregates.GetAggregatesOfAggregateForParentAggregate(aggrEquipment.AggregateID);
                                        gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;
                                        //_lrrAggregatesforAggregates.RefreshCollection();
                                        gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                                    }

                                    if (aggrEquipment.IsAggregateOfAggregates == true)
                                    {
                                        object[] objArrChildAggregates = new object[objAggEquips.Count];

                                        string aggrID11 = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                                        ApplyFiltersForAggDtlGrids(aggrID11, "true", aggrEquipment.AggregateID, false);

                                        for (int i = 0; i < _lrrAggregatesforAggregates.Count; i++)
                                        {
                                            LRRAggregate aggregate = _lrrAggregatesforAggregates[i] as LRRAggregate;
                                            for (int j = 0; j < objAggEquips.Count; j++)
                                            {
                                                LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                                if (lrrAggrEquipment.ChildAggregateID == aggregate.AggregateID)
                                                    objArrChildAggregates[j] = aggregate;
                                            }
                                        }

                                        gridUnBoundAgg.SetSelectedRecords(objArrChildAggregates);

                                        gridAggregateOfAggregates.TableDescriptor.AllowEdit = true;
                                        gridAggregateOfAggregates.TableDescriptor.Columns["Name"].ReadOnly = true;

                                        gridAggregateOfAggregates.TableControl.Refresh();

                                        ApplyFinerFilterForAggGroupGrid(aggrEquipment.AggregateID, aggrID11, false);
                                    }
                                    gridUnBoundEquip.SetSelectedRecords(objArrAggregateEquipment);
                                    gridAggregateEqpmnts.Refresh();
                                }
                            }
                        }
                    }
                    else
                    {
                        gridUnBoundEquip.ClearSelectedRecords();
                        gridUnBoundAgg.ClearSelectedRecords();
                        htSiteComponents.Clear();
                    }
				}
				if(e.Action == CurrentRecordAction.NavigateComplete)
				{
					if(e.Table.CurrentRecord != null)
					{
						if(e.Table.CurrentRecord.Kind == DisplayElementKind.AddNewRecord) 
						{
                            e.Table.AddNewRecord.SetCurrent();
                            e.Table.AddNewRecord.SetSelected(true); 
                            LRRAggregate aggrObj = e.Table.CurrentRecord.GetData() as LRRAggregate;
							_siteComponentsList = new LRRSiteComponents();
							gridUnBoundEquip.ClearSelectedRecords();
							gridUnBoundAgg.ClearSelectedRecords();
							htSiteComponents.Clear();
							if((aggrObj == null) || (aggrObj.EquipmentTypeID == null) || (aggrObj.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture) == ""))
							{
								gridAggregateOfAggregates.TableDescriptor.AllowEdit=false;
								_lrrAggregatesforAggregates.RefreshCollection();
								gridAggregateOfAggregates.TableControl.Refresh();
								gridAggregateEqpmnts.TableControl.Refresh();
                                gridAggregateEqpmnts.DataSource = null;
                                gridAggregateOfAggregates.DataSource = null;
								return;
							}
					
						}
					}
				}
                if (gridAggregates.TableControl.Table.CurrentRecord != null && gridAggregates.TableControl.Table.CurrentRecord.Kind != DisplayElementKind.AddNewRecord)
				{
                    LRRAggregate aggrEquipment = gridAggregates.TableControl.Table.CurrentRecord.GetData() as LRRAggregate;
                    if (aggrEquipment != null)
                    {
                        sAggregateID = aggrEquipment.AggregateID == null ? "" : aggrEquipment.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                        if (aggrEquipment != null)
                        {
                            if (e.Action == CurrentRecordAction.LeaveRecordCalled)
                            {
                                if ((_recordValueChanged == "1") && (sTableName == ""))
                                {
                                    DialogResult k = LRRMessagBox.ShowMessage("SID_SAVEINFO_QUESTION", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                                    if (k == DialogResult.Yes)
                                    {
                                        e.Cancel = true;
                                        Save();
                                    }
                                    else
                                    {
                                        _recordValueChanged = "0";

                                        if (_recordAggID != "")
                                        {
                                            LRRAggregate objAgg = _lrrAggregates.GetAggregateFromID(_recordAggID);
                                            int nIndex = _lrrAggregates.IndexOf(_lrrAggregates.GetAggregateFromID(_recordAggID));
                                            _lrrAggregates.RemoveAt(nIndex);

                                            Dictionary<string, LRRAggregate> objAggHash = new Dictionary<string, LRRAggregate>();
                                            objAggHash = _lrrAggregates.AggregatesHash;

                                            if (objAggHash.ContainsKey(_recordAggID))
                                                objAggHash.Remove(_recordAggID);

                                            Dictionary<string, List<LRRAggregate>> objAggCompTypeHash = new Dictionary<string, List<LRRAggregate>>();
                                            objAggCompTypeHash = _lrrAggregates.AggCompTypeHash;

                                            string sAggType = "";
                                            sAggType = _recordAggID + "|" + sAggType;

                                            if (objAggCompTypeHash.ContainsKey(sAggType))
                                                objAggCompTypeHash.Remove(sAggType);

                                            sAggType = objAgg.EquipmentTypeID;
                                            sAggType = _recordAggID + "|" + sAggType;

                                            if (objAggCompTypeHash.ContainsKey(sAggType))
                                                objAggCompTypeHash.Remove(sAggType);

                                            _lrrAggregates.AggCompTypeHash = objAggCompTypeHash;
                                            _lrrAggregates.AggregatesHash = objAggHash;
                                        }

                                        _lrrAggregatesforAggregates = _lrrAggregates;
                                        gridUnBoundEquip.ClearSelectedRecords();
                                        gridUnBoundAgg.ClearSelectedRecords();
                                        _siteComponentsList = new LRRSiteComponents();
                                        htSiteComponents.Clear();
                                        gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                                        gridAggregateEqpmnts.Refresh();
                                        gridAggregateOfAggregates.Refresh();
                                        _recordAggID = "";
                                        e.Cancel = true;
                                    }
                                }
                            }
                            if (e.Action == CurrentRecordAction.NavigateComplete)
                            {
                                gridUnBoundEquip.ClearSelectedRecords();
                                gridUnBoundAgg.ClearSelectedRecords();

                                aggrEquipID = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                                LRRAggregateEquipments objAggEquips = FilterAggregateEquipment(true, sAggregateID);
                                object[] objArrAggregateEquipment = new object[objAggEquips.Count];

                                gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
                                gridAggregateEqpmnts.DataSource = null;
                                _siteComponentsList = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(aggrEquipID);
                                gridAggregateEqpmnts.DataSource = _siteComponentsList;

                                for (int i = 0; i < _siteComponentsList.Count; i++)
                                {
                                    LRRSiteComponent site = _siteComponentsList[i] as LRRSiteComponent;
                                    for (int j = 0; j < objAggEquips.Count; j++)
                                    {
                                        LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                        if (lrrAggrEquipment.EquipmentID == site.SiteComponentID)
                                            objArrAggregateEquipment[j] = site;
                                    }
                                }

                                if (aggrEquipment.IsAggregateOfAggregates == false)
                                {
                                    gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
                                    gridAggregateOfAggregates.DataSource = null;
                                    _lrrAggregatesforAggregates = _lrrAggregates.GetAggregatesOfAggregateForParentAggregate(aggrEquipment.AggregateID);
                                    gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;
                                    //_lrrAggregatesforAggregates.RefreshCollection();
                                    gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                                }

                                if (aggrEquipment.IsAggregateOfAggregates == true)
                                {
                                    object[] objArrChildAggregates = new object[objAggEquips.Count];

                                    string aggrID11 = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                                    ApplyFiltersForAggDtlGrids(aggrID11, "true", sAggregateID, false);

                                    for (int i = 0; i < _lrrAggregatesforAggregates.Count; i++)
                                    {
                                        LRRAggregate aggregate = _lrrAggregatesforAggregates[i] as LRRAggregate;
                                        for (int j = 0; j < objAggEquips.Count; j++)
                                        {
                                            LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                            if (lrrAggrEquipment.ChildAggregateID == aggregate.AggregateID)
                                                objArrChildAggregates[j] = aggregate;
                                        }
                                    }

                                    gridUnBoundAgg.SetSelectedRecords(objArrChildAggregates);

                                    gridAggregateOfAggregates.TableDescriptor.AllowEdit = true;
                                    gridAggregateOfAggregates.TableDescriptor.Columns["Name"].ReadOnly = true;

                                    gridAggregateOfAggregates.TableControl.Refresh();

                                    ApplyFinerFilterForAggGroupGrid(sAggregateID, aggrID11, false);
                                }
                                gridUnBoundEquip.SetSelectedRecords(objArrAggregateEquipment);
                                gridAggregateEqpmnts.Refresh();
                            }
                        }
                    }
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(AggregateDetails),ex.Message  ,Logger.Level.Debug);
			}
		}

        private void RefreashAfterSave()
        {
            Cursor = Cursors.WaitCursor;
            try
            {
                string aggrEquipID = "";
                string sAggregateID = "";
                string sTableName = "";
                gridUnBoundEquip.ClearSelectedRecords();
                gridUnBoundAgg.ClearSelectedRecords();
                htSiteComponents.Clear();
                
                if (gridAggregates.CurrencyManager.Count > 0)
                {
                    LRRAggregate aggrEquipment = gridAggregates.CurrencyManager.Current as LRRAggregate;
                    sAggregateID = aggrEquipment.AggregateID == null ? "" : aggrEquipment.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    if (aggrEquipment != null)
                    {
                        gridUnBoundEquip.ClearSelectedRecords();
                        gridUnBoundAgg.ClearSelectedRecords();

                        aggrEquipID = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                        LRRAggregateEquipments objAggEquips = FilterAggregateEquipment(true, sAggregateID);
                        object[] objArrAggregateEquipment = new object[objAggEquips.Count];

                        gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
                        gridAggregateEqpmnts.DataSource = null;
                        _siteComponentsList = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(aggrEquipID);
                        gridAggregateEqpmnts.DataSource = _siteComponentsList;

                        for (int i = 0; i < _siteComponentsList.Count; i++)
                        {
                            LRRSiteComponent site = _siteComponentsList[i] as LRRSiteComponent;
                            for (int j = 0; j < objAggEquips.Count; j++)
                            {
                                LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                if (lrrAggrEquipment.EquipmentID == site.SiteComponentID)
                                    objArrAggregateEquipment[j] = site;
                            }
                        }

                        if (aggrEquipment.IsAggregateOfAggregates == false)
                        {
                            gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
                            gridAggregateOfAggregates.DataSource = null;
                            _lrrAggregatesforAggregates = _lrrAggregates.GetAggregatesByMasterComponentID(aggrEquipID);
                            gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;
                            //_lrrAggregatesforAggregates.RefreshCollection();
                            gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                        }

                        if (aggrEquipment.IsAggregateOfAggregates == true)
                        {
                            object[] objArrChildAggregates = new object[objAggEquips.Count];

                            string aggrID11 = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                            ApplyFiltersForAggDtlGrids(aggrID11, "true", sAggregateID, false);

                            for (int i = 0; i < _lrrAggregatesforAggregates.Count; i++)
                            {
                                LRRAggregate aggregate = _lrrAggregatesforAggregates[i] as LRRAggregate;
                                for (int j = 0; j < objAggEquips.Count; j++)
                                {
                                    LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                    if (lrrAggrEquipment.ChildAggregateID == aggregate.AggregateID)
                                        objArrChildAggregates[j] = aggregate;
                                }
                            }

                            gridUnBoundAgg.SetSelectedRecords(objArrChildAggregates);

                            gridAggregateOfAggregates.TableDescriptor.AllowEdit = true;
                            gridAggregateOfAggregates.TableDescriptor.Columns["Name"].ReadOnly = true;

                            gridAggregateOfAggregates.TableControl.Refresh();

                            ApplyFinerFilterForAggGroupGrid(sAggregateID, aggrID11, false);
                        }
                        gridUnBoundEquip.SetSelectedRecords(objArrAggregateEquipment);
                        gridAggregateEqpmnts.Refresh();
                    }
                }
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(AggregateDetails), ex.Message, Logger.Level.Debug);
            }
        }
		

		private Dictionary<string, LRRMasterProperty> GetMasterCompPptiesForAggregateID(string aggregateID)
		{
            Dictionary<string, LRRMasterProperty> masterProps = new Dictionary<string, LRRMasterProperty>();
			string sAggID = "";
			string sMasterPropID = "";
			foreach(LRRAggregateProperty objAggProp in _lrrAggregateProperties)
			{
				sAggID = objAggProp.AggregateID == null ? "" : objAggProp.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(sAggID == aggregateID)
				{
					sMasterPropID = objAggProp.MasterPropertyID == null ? "" : objAggProp.MasterPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					masterProps.Add(sMasterPropID,_lrrMasterCompPpties.GetMasterPropertyByID(sMasterPropID));
				}
			}
			return masterProps;
		}
		
		
		public void GetSiteComponentsForAggregates(LRRAggregate objAggregate)
		{
			
			string sSiteComponentID = "";
			if(objAggregate != null)
			{
                LRRAggregateEquipments aggregateEquipments = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(objAggregate.AggregateID);
                foreach (LRRAggregateEquipment aggregateEquipment in aggregateEquipments)
                {
                    if (aggregateEquipment.EquipmentID != null && aggregateEquipment.EquipmentID != "")
                    {
                        sSiteComponentID = aggregateEquipment.EquipmentID == null ? "" : aggregateEquipment.EquipmentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        if (!lrrSiteComponentList.ContainsKey(sSiteComponentID))
                        {
                            LRRSiteComponent siteCompObj = LRRModel.SiteComponentsObj.GetSiteComponentByID(sSiteComponentID);
                            if(siteCompObj != null)
                                lrrSiteComponentList.Add(sSiteComponentID,siteCompObj);
                        }
                    }
                    else if (aggregateEquipment.ChildAggregateID != null && aggregateEquipment.ChildAggregateID != "")
                    {
                        string childAggregateID = aggregateEquipment.ChildAggregateID == null ? "" : aggregateEquipment.ChildAggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        LRRAggregate objAgg = LRRModel.AggregatesObj.GetAggregateFromID(childAggregateID);
                        if (objAgg != null)
                        {
                            GetSiteComponentsForAggregates(objAgg);
                        }
                    }
                }
			}
		}
		private void ChildTableDescriptor_RecordExpanding(object sender, RecordEventArgs e)
		{
			LRRAggregateProperty oProp = e.Record.GetData() as LRRAggregateProperty;
			LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(oProp.MasterPropertyID);
			if(objMasterProp != null)
			{
				string sPropertyType =objMasterProp.Type == null ? "" : objMasterProp.Type;
		
				if((sPropertyType != "0") && (sPropertyType != "1") && (sPropertyType != "2") && (sPropertyType != ""))
				{
					e.Cancel = true;
				}
			}
			
		}
		
		private void gridAggregates_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
			try
			{
				bool blnMasterComponentTypeChanged = false;
				if(gridAggregates.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridAggregates.TableControl.Table.CurrentElement;
					Element eCurrentInnerElement = gridAggregates.TableControl.Table.GetInnerMostCurrentElement();    
					if(eCurrentElement == null)
						return;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}

					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					tableModel = childTable.ParentTable.TableModel;
					int iRow = e.TableControl.CurrentCell.RowIndex;
					int iCol = e.TableControl.CurrentCell.ColIndex;
					string sColHeader = "";
					if(tableModel.GetColumnDescriptorAt(iRow,iCol) != null)
					{
						sColHeader = tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
					}
				}
				
				if(e.TableControl.Table.CurrentRecord == null)
				{
					return;
				}
				
				LRRAggregate currAggregate = e.TableControl.Table.CurrentRecord.GetData() as LRRAggregate; 	
				if(currAggregate != null)
				{
					string sAggID = currAggregate.AggregateID == null ? "" : currAggregate.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture) ;

                    if (gridAggregates.TableModel.GetHeaderColumnDescriptorAt(e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_AGGREGATEOFAGGREGATE"))
					{
						string sEquipType = currAggregate.EquipmentTypeID == null ? "" : currAggregate.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture) ; 
						string oldVal = currAggregate.IsAggregateOfAggregates.ToString(Symcon.BusinessObjects.SymConverter.Culture) ; 
						string nVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
					
						if(nVal.ToUpper() == "TRUE")
							gridAggregateOfAggregates.TableDescriptor.AllowEdit=true;

						if(nVal.ToUpper() == "FALSE")
							gridAggregateOfAggregates.TableDescriptor.AllowEdit=false;
				
						if(e.TableControl.Table.CurrentRecord.Kind == DisplayElementKind.AddNewRecord) 
						{
							ApplyFiltersForAggDtlGrids(sEquipType,nVal,sAggID,true);
						}
						else
						{
							if((nVal.ToUpper() == "FALSE") && (oldVal != nVal))
							{
								//remove equipments
                                LRRAggregateEquipments aggregateEquipments = _lrrAggregateEquipments.GetAggregateEquipsFromParentAggregateID(currAggregate.AggregateID);
                                List<LRRAggregateEquipment> aggEquipToRemove = new List<LRRAggregateEquipment>();
                                foreach (LRRAggregateEquipment aggEquip in aggregateEquipments)
                                {
                                    if (aggEquip.ChildAggregateID != null && aggEquip.ChildAggregateID != "")
                                    {
                                        if (aggEquip.ParentAggregateID == currAggregate.AggregateID)
                                        {
                                            aggEquipToRemove.Add(aggEquip);
                                        }
                                    }
                                }
                                foreach (LRRAggregateEquipment equip in aggEquipToRemove)
                                {
                                    _lrrAggregateEquipments.Remove(equip);
                                    currAggregate.AggregateEquipments.Remove(equip);  
                                }
								e.TableControl.CurrentCell.ConfirmChanges();
								gridUnBoundEquip.ClearSelectedRecords();
								gridUnBoundAgg.ClearSelectedRecords();
							}
							ApplyFiltersForAggDtlGrids(sEquipType,nVal,sAggID,false);
						}
						gridAggregateOfAggregates.Refresh();
					}
					if(gridAggregates.TableModel.GetHeaderColumnDescriptorAt(e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_EQUIPTYPE"))
					{
						string oldVal = currAggregate.EquipmentTypeID == null ? "" : currAggregate.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture) ; 
						string nVal = e.TableControl.CurrentCell.Renderer.ControlValue == null ? "" : e.TableControl.CurrentCell.Renderer.ControlValue.ToString();

						if(oldVal != nVal)
							blnMasterComponentTypeChanged = true;
						else
							blnMasterComponentTypeChanged = false;


						if(e.TableControl.Table.CurrentRecord.Kind != DisplayElementKind.AddNewRecord) 
						{
							if(e.TableControl.CurrentCell.Renderer.CurrentStyle.CellType ==  "FilterBarCell")
								return;

							if((oldVal != nVal) && (oldVal != ""))
							{
								//equipments
                                if (LRRModel.AggregateEquipmentsObj.CheckIfAggExistsinAggOfAgg(sAggID))
                                {
                                    LRRMessagBox.ShowMessage("SID_AGGREGATETE_CONFIGRATION", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                                    return;
                                }
							
								if(LRRMessagBox.ShowMessage("SID_PROPVALUECHANGEINFO","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question) == DialogResult.Yes)
								{
									blnMasterComponentTypeChanged = true;
									//remove equipments
                                    LRRAggregateEquipments aggregateEquipments = _lrrAggregateEquipments.GetAggregateEquipsFromParentAggregateID(currAggregate.AggregateID);
                                    List<LRRAggregateEquipment> aggEquipToRemove = new List<LRRAggregateEquipment>();
                                    foreach (LRRAggregateEquipment aggEquip in aggregateEquipments)
                                    {
                                        if (aggEquip.ChildAggregateID != null && aggEquip.ChildAggregateID != "")
                                        {
                                            if (aggEquip.ParentAggregateID == currAggregate.AggregateID)
                                            {
                                                aggEquipToRemove.Add(aggEquip);
                                            }
                                        }
                                    }
                                    foreach (LRRAggregateEquipment equip in aggEquipToRemove)
                                    {
                                        _lrrAggregateEquipments.Remove(equip);
                                        currAggregate.AggregateEquipments.Remove(equip);
                                    }
									//remove properties
									for(int i=e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records.Count - 1;i>=0;i--)
									{
										object obj = e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records[i].GetData();
										if(obj!=null)
										{
											
											LRRAggregateProperty objAggProp = obj as LRRAggregateProperty;
											//Remove all the  property values of the aggregate property
											LRRAggregatePropertyValues objAggPropValues = objAggProp.Values;
											foreach(LRRAggregatePropertyValue objAggPropValue in objAggPropValues)
											{
												_lrrAggregatePropertyValues.Remove(objAggPropValue);
											}
											//Remove all the grouped properties of the aggregate property
											LRRAggregateGroupedProperties objGroupedProps = objAggProp.GetGroupProperties() as LRRAggregateGroupedProperties;
											foreach(LRRAggregateGroupedProperty objGroupedProp in objGroupedProps)
											{
												//Remove all the grouped property values of the aggregate grouped property
												LRRAggregateGroupedPropertyValues objAggGroupedPropValues = objGroupedProp.GroupPptiesQualifierValues as LRRAggregateGroupedPropertyValues;
												foreach(LRRAggregateGroupedPropertyValue objAggGroupedPropValue in objAggGroupedPropValues)
												{
													_lrrAggregateGroupedPropertyValues.Remove(objAggGroupedPropValue);
												}
												_lrrAggregateGroupedProperties.Remove(objGroupedProp);
											}
											_lrrAggregateProperties.Remove(objAggProp);
										}
									}
									e.TableControl.CurrentCell.ConfirmChanges();
									gridUnBoundEquip.ClearSelectedRecords();
									gridUnBoundAgg.ClearSelectedRecords();

								}
								else
								{
									e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
									blnMasterComponentTypeChanged = false;
								}
							}
						}
						else
						{
							//gridAggregateEqpmnts.DataSource = _siteComponentsList;
							//Incase, new aggregate is being defined, clear the equi/agg list 
							gridUnBoundEquip.ClearSelectedRecords();
							gridUnBoundAgg.ClearSelectedRecords();
							blnMasterComponentTypeChanged = true;
						}
						if(blnMasterComponentTypeChanged)
						{
							MasterComponentTypeChanged(currAggregate,nVal,sAggID);
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(AggregateDetails),ex.Message  ,Logger.Level.Debug);
				return;
			}
		}

        private void MasterComponentTypeChanged(LRRAggregate currAggregate,string nVal,string sAggID)
		{
			string sAggregatable = currAggregate.IsAggregateOfAggregates.ToString(Symcon.BusinessObjects.SymConverter.Culture) ;
			htSiteComponents.Clear();
						
			ApplyFiltersForAggDtlGrids(nVal,sAggregatable,sAggID,false);
					
			if(sAggregatable.ToUpper() == "TRUE")
				gridAggregateOfAggregates.TableDescriptor.AllowEdit=true;

			if(sAggregatable.ToUpper()  == "FALSE")
				gridAggregateOfAggregates.TableDescriptor.AllowEdit=false;

			if(nVal != "")
			{
				foreach(LRRMasterProperty masterPpty in _lrrMasterCompPpties)
				{
					if((masterPpty.ComponentID==nVal) && (masterPpty.IsAggregatable))
					{
						LRRAggregateProperty objLRRAggregateProperty = ConverMasterPropToAggregateProp(masterPpty,sAggID);
						if(objLRRAggregateProperty != null)
						{
							string sGPID =masterPpty.Type;
							
                            _lrrAggregateProperties.Add(objLRRAggregateProperty);
                            AggregateCompPropertyAdded(objLRRAggregateProperty);
							//currAggregate.AggregateProperties.Add(objLRRAggregateProperty);
                            LRRModel.AggregatesObj.GetAggregateFromID(objLRRAggregateProperty.AggregateID).AggregateProperties.Add(objLRRAggregateProperty);   

							if(sGPID != "1") //-- Its the case of grouped properties - Chemical components / Data Arrays
								CreateAggregateGroupedProperties(objLRRAggregateProperty);
							
						}
					}
				}
				LRRAggregateEquipments objAggEquips = FilterAggregateEquipment(true,sAggID);
				currAggregate.AggregateEquipments = objAggEquips;
			}
		}
		
		
		private LRRAggregateEquipments FilterAggregateEquipment(bool blnParent, string sAggregateID)
		{
            LRRAggregateEquipments objAggEquip = _lrrAggregateEquipments.GetAggregateEquipsFromParentAggregateID(sAggregateID);  
            /*LRRAggregateEquipments objAggEquip = new LRRAggregateEquipments();
			for(int i=0; i < _lrrAggregateEquipments.Count; i++)
			{
				LRRAggregateEquipment currentAggEquip = _lrrAggregateEquipments[i] as LRRAggregateEquipment;
				if(blnParent)
				{
					if(currentAggEquip.ParentAggregateID == sAggregateID)
						objAggEquip.Add(currentAggEquip);
				}
				else
				{
					if(currentAggEquip.ChildAggregateID == sAggregateID)
						objAggEquip.Add(currentAggEquip);
					
				}
			}*/
			return objAggEquip;

		}
		
		
		public ArrayList FillFormulaForPropertyValues(Hashtable aggreGateHash)
		{
            bool _formulaFailed = false;
            IEnumerator iEnumAggProp = aggreGateHash.GetEnumerator();
            ArrayList formulaParamsToRemove = new ArrayList();
            string aggGateObjID = "";
            while (iEnumAggProp.MoveNext())
            {
                DictionaryEntry dEntry = (DictionaryEntry)iEnumAggProp.Current;
                aggGateObjID = dEntry.Key.ToString();
                LRRAggregate aggreGateObj = LRRModel.AggregatesObj.GetAggregateFromID(aggGateObjID); 
                foreach (LRRAggregateProperty aggProp in aggreGateObj.AggregateProperties)
                {
                    bool isExists = CheckAggPropExistsInSitComp(aggProp);
                    if (isExists)
                    {
                        if (aggProp.Formula != null && aggProp.Formula != "")
                        {
                            AggregateFormula objAggregateFormula = new AggregateFormula();
                            LRRFormulaParams formulaParamsToDelete = objAggregateFormula.CreateAggregatesFormulaExpression(aggProp.AggregateID, aggProp.ID, aggProp.Formula, true);
                            _formulaFailed = objAggregateFormula.HasFormulaFailed;
                            formulaParamsToRemove.Add(formulaParamsToDelete);
                        }
                    }
                }
                objFormulas = LRRModel.FormulasObj.GetChanges();
                if (objFormulas != null)
                {
                    foreach (LRRFormula objFormula in objFormulas)
                    {
                        if (objFormula.ObjectState != DBOperation.DELETE)
                        {
                            string nAggPropValID = objFormula.SourceObjectID;
                            LRRAggregatePropertyValue objValue = null;
                            if (nAggPropValID != null)
                            {
                                objValue = _lrrAggregatePropertyValues.FindAggregatePropertyValueByID(nAggPropValID);
                            }
                            if (objValue != null)
                            {
                                objValue.FormulaID = objFormula.ID;
                                string sPropID = objValue.AggregateID;
                                if (_lrrAggregates.GetAggregateFromID(aggGateObjID).AggregateProperties.GetAggregatePropFromID(sPropID) != null)
                                {
                                    if (_lrrAggregates.GetAggregateFromID(aggGateObjID).AggregateProperties.GetAggregatePropFromID(sPropID).Values.FindAggregatePropertyValueByID(nAggPropValID) != null)
                                        _lrrAggregates.GetAggregateFromID(aggGateObjID).AggregateProperties.GetAggregatePropFromID(sPropID).Values.FindAggregatePropertyValueByID(nAggPropValID).FormulaID = objFormula.ID;
                                }
                            }
                        }
                    }
                }
            }
            if (_formulaFailed)
            {
                LRRMessagBox.ShowMessage("SID_PROP_VAL_NOT_EXISTS", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
			return formulaParamsToRemove;
		}

        public ArrayList FillFormulaForPropertyValues(Hashtable aggreGateHash,LRRMasterProperty masterProperty)
        {
            bool _formulaFailed = false;
            IEnumerator iEnumAggProp = aggreGateHash.GetEnumerator();
            ArrayList formulaParamsToRemove = new ArrayList();
            string aggGateObjID = "";
            while (iEnumAggProp.MoveNext())
            {
                DictionaryEntry dEntry = (DictionaryEntry)iEnumAggProp.Current;
                aggGateObjID = dEntry.Key.ToString();
                LRRAggregate aggreGateObj = LRRModel.AggregatesObj.GetAggregateFromID(aggGateObjID);
                foreach (LRRAggregateProperty aggProp in aggreGateObj.AggregateProperties)
                {
                     bool isExists = CheckAggPropExistsInSitComp(aggProp);
                     if (isExists)
                     {
                         if (aggProp.MasterPropertyID == masterProperty.PropID)
                         {
                             aggProp.Formula = masterProperty.AggregationRule;
                             if (aggProp.Formula != null && aggProp.Formula != "")
                             {
                                 AggregateFormula objAggregateFormula = new AggregateFormula();
                                 LRRFormulaParams formulaParamsToDelete = objAggregateFormula.CreateAggregatesFormulaExpression(aggProp.AggregateID, aggProp.ID, aggProp.Formula, true);
                                 _formulaFailed = objAggregateFormula.HasFormulaFailed;
                                 formulaParamsToRemove.Add(formulaParamsToDelete);
                             }
                         }
                     }
                }
                for (int i = 0; i < formulaParamsToRemove.Count; i++)
                {
                    LRRFormulaParams fParms = formulaParamsToRemove[i] as LRRFormulaParams;
                    foreach (LRRFormulaParam fparam in fParms)
                    {
                        LRRFormula formulaObj = LRRModel.FormulasObj.GetFormulaObjFromID(fparam.FormulaID);
                        if (formulaObj != null)
                        {
                            formulaObj.Params.Remove(fparam); 
                        }
                    }
                    _app.DBManagerObj.ExecuteBatchDelete(fParms);  
                }
                objFormulas = LRRModel.FormulasObj.GetChanges();
                if (objFormulas != null)
                {
                    foreach (LRRFormula objFormula in objFormulas)
                    {
                        if (objFormula.ObjectState != DBOperation.DELETE)
                        {
                            string nAggPropValID = objFormula.SourceObjectID;
                            LRRAggregatePropertyValue objValue = null;
                            if (nAggPropValID != null)
                            {
                                objValue = _lrrAggregatePropertyValues.FindAggregatePropertyValueByID(nAggPropValID);
                            }
                            if (objValue != null)
                            {
                                objValue.FormulaID = objFormula.ID;
                                string sPropID = objValue.AggregateID;
                                if (_lrrAggregates.GetAggregateFromID(aggGateObjID).AggregateProperties.GetAggregatePropFromID(sPropID) != null)
                                {
                                    if (_lrrAggregates.GetAggregateFromID(aggGateObjID).AggregateProperties.GetAggregatePropFromID(sPropID).Values.FindAggregatePropertyValueByID(nAggPropValID) != null)
                                        _lrrAggregates.GetAggregateFromID(aggGateObjID).AggregateProperties.GetAggregatePropFromID(sPropID).Values.FindAggregatePropertyValueByID(nAggPropValID).FormulaID = objFormula.ID;
                                }
                            }
                        }
                    }
                }
            }
            _app.DBManagerObj.CommitCollection(LRRModel.FormulasObj.GetChanges()); 
            if (_formulaFailed)
            {
                LRRMessagBox.ShowMessage("SID_PROP_VAL_NOT_EXISTS", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            return formulaParamsToRemove;
        }

		
		private void gridAggregateEqpmnts_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			
		}

		
		private void gridAggregateOfAggregates_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{

		}
		

		private void gridAggregates_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(gridAggregates.TableControl.Table.CurrentRecord == null)
			{
				Element eCurrentElement = gridAggregates.TableControl.Table.CurrentElement;
				Element eCurrentInnerElement = gridAggregates.TableControl.Table.GetInnerMostCurrentElement();    
				if(eCurrentElement == null)
					return;
				GridNestedTable gnt = eCurrentElement as GridNestedTable;
				GridNestedTable gnt1 = gnt;
				GridTableDescriptor gtd = null;
				GridTableModel tableModel = new GridTableModel();
				while(gnt1 != null && gnt1.ChildTable != null)
				{
					gnt = gnt1;
					gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
					gtd = gnt.ParentTable.ParentTableDescriptor;
				}
				GridChildTable childTable = gnt.ChildTable as GridChildTable;
				if(childTable.Name.Equals("Values"))
				{
					e.Cancel=true;
					return;					
				}
				if(childTable.Name.Equals("Properties"))
				{
					e.Cancel=true;
					return;					
				}
			}
			else
			{
				if(_isDeletePress)
				{
					DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
					if(_dlgResult == DialogResult.Yes)
					{
						_isRecordeDel = true; 
					}
					else
					{
						_isRecordeDel = false; 
					}
					_isDeletePress = false;
				}
				if(_isRecordeDel)
				{
					LRRAggregate objAgg = e.Record.GetData() as LRRAggregate;
					string sAggID = objAgg.AggregateID == null ? "" : objAgg.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					//equipments
                    if (LRRModel.AggregateEquipmentsObj.CheckIfAggExistsinAggOfAgg(sAggID))
                    {
                        LRRMessagBox.ShowMessage("SID_AGG_GROUP_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);  
				        e.Cancel=true;
				        return;
                    }
				}
				else
				{
					e.Cancel = true;
					_isDeletePress = false;
				}
			}
		}
		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}
		private void gridAggregates_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			
			/*if(e.Record.GetData().GetType() == typeof(LRRAggregate))
			{
				LRRAggregate objLRRAggregate = e.Record.GetData() as LRRAggregate;
				string sAggID = objLRRAggregate.AggregateID == null? "" : objLRRAggregate.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				
				if(objLRRAggregate.ObjectState == DBOperation.INSERT)
					_recordAggID = sAggID;
				else
					_recordAggID = "";

				if(objLRRAggregate.EquipmentTypeID =="")
				{
					if(sAggID != "")
					{
						//equipments
						for(int i=0; i < _arrAggregateEquipment.Count; i++)
						{
							LRRAggregateEquipment currentAggEquip = _arrAggregateEquipment[i] as LRRAggregateEquipment;
							if(currentAggEquip.ParentAggregateID == sAggID)
							{
								_lrrAggregateEquipments.Remove(currentAggEquip);
							}
						}

						//Properties
						for(int i=0; i < _arrAggregateProperties.Count; i++)
						{
							LRRAggregateProperty currentAggProp = _arrAggregateProperties[i] as LRRAggregateProperty;
							if(currentAggProp.AggregateID == sAggID)
							{
								//Remove all the  property values of the aggregate property
								LRRAggregatePropertyValues objAggPropValues = currentAggProp.Values;
								foreach(LRRAggregatePropertyValue objAggPropValue in objAggPropValues)
								{
									_lrrAggregatePropertyValues.Remove(objAggPropValue);
								}
											
								//Remove all the grouped properties of the aggregate property
								LRRAggregateGroupedProperties objGroupedProps = currentAggProp.GetGroupProperties() as LRRAggregateGroupedProperties;
								foreach(LRRAggregateGroupedProperty objGroupedProp in objGroupedProps)
								{
									//Remove all the grouped property values of the aggregate grouped property
									LRRAggregateGroupedPropertyValues objAggGroupedPropValues = objGroupedProp.GetPropertyValues() as LRRAggregateGroupedPropertyValues;
									if(objAggGroupedPropValues!=null)
									{
										foreach(LRRAggregateGroupedPropertyValue objAggGroupedPropValue in objAggGroupedPropValues)
    									{
											_lrrAggregateGroupedPropertyValues.Remove(objAggGroupedPropValue);
										}
									}
									_lrrAggregateGroupedProperties.Remove(objGroupedProp);
								}
                                
                                _lrrAggregateProperties.Remove(currentAggProp);
							}
						}
						
					}
				}
				
			}*/
		}
		

		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			RefreshForm();
		}

		public 	void LeftColMovement()
		{
		}
		public void RightColMovement()
		{
		}
		public void Save()
		{
			bool isSaved = false;
			bool blnCreateFormula = true;
			bool bSameEquipInDifferentAggregates = false;
			Hashtable htEquipment = new Hashtable();
			Hashtable htFormulaForAggregates = new Hashtable();
			ArrayList arFormulas = new ArrayList();

			#region Aggregates save
			if(_lrrAggregates.GetChanges().Count!=0)
			{
				LRRAggregates toSaveAggregates = _lrrAggregates.GetChanges();
                foreach (LRRAggregate lrrAggregate in toSaveAggregates)
				{
					string sName = lrrAggregate.Name  == null ? "" : lrrAggregate.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					
					string sAggID = lrrAggregate.AggregateID == null ? "" : lrrAggregate.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    if (lrrAggregate.ObjectState != DBOperation.DELETE)
                    {
                        if (sName == "")
                        {
                            LRRMessagBox.ShowMessage("SID_AGGNAME_NULL", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }
                    }
				}
                DeleteChildObjectsForAggregate(toSaveAggregates);
				_app.DBManagerObj.CommitCollection(toSaveAggregates);
				if(toSaveAggregates.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					_recordValueChanged = "0";
					_recordAggID = "";
					return;
				}
				else
				{
					isSaved = true;
				}
				_lrrAggregates.RefreshCollection();
				//_lrrOrgAggregates.RefreshCollection(); 
			}
			#endregion
			
			#region Aggregates Properties Save
			if(_lrrAggregateProperties.GetChanges().Count > 0)
			{
				LRRAggregateProperties  toSaveProperties = _lrrAggregateProperties.GetChanges();
				
				foreach(LRRAggregateProperty objAggProp in toSaveProperties)
				{
                    if (objAggProp.ObjectState != DBOperation.DELETE)
                    {
                        if (objAggProp.Formula != "" && objAggProp.Formula != null)
                        {
                            //bool isExists = CheckAggPropExistsInSitComp(objAggProp);
                            if (!htFormulaForAggregates.Contains(objAggProp.AggregateID))
                                htFormulaForAggregates.Add(objAggProp.AggregateID, null);

                        }
                    }
				}

				_app.DBManagerObj.CommitCollection(toSaveProperties); //Commit Site Components
				if(toSaveProperties.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					_recordValueChanged = "0";
					_recordAggID = "";
					return;
				}
				isSaved = true;
				_lrrAggregateProperties.RefreshCollection();
			}

			#endregion

			#region Aggregates Grouped Properties Save
			if(_lrrAggregateGroupedProperties.GetChanges().Count > 0)
			{
				LRRAggregateGroupedProperties  toSaveGroupedProperties = _lrrAggregateGroupedProperties.GetChanges();
                //foreach (LRRAggregateGroupedProperty objAggGrpProp in toSaveGroupedProperties)
                //{
                //    if (objAggGrpProp.Formula != "" && objAggGrpProp.Formula != null)
                //    {
                //        if (!htFormulaForAggregates.Contains(objAggGrpProp.AggregatePropertyID))
                //            htFormulaForAggregates.Add(objAggProp.AggregateID, null);
                //    }
                //}
				_app.DBManagerObj.CommitCollection(toSaveGroupedProperties); //Commit Site Components
				if(toSaveGroupedProperties.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					_recordValueChanged = "0";
					_recordAggID = "";
					return;
				}
				isSaved = true;
				_lrrAggregateGroupedProperties.RefreshCollection();
			}

			#endregion
			
			#region Aggregates Equipment Save
			if(_lrrAggregateEquipments.GetChanges().Count!=0)
			{
				LRRAggregateEquipments toSaveAggregateEquipments = _lrrAggregateEquipments.GetChanges();
				foreach(LRRAggregateEquipment objAggEquip in toSaveAggregateEquipments)
				{
                    if (objAggEquip.ObjectState != DBOperation.UPDATE)
                    {
                        if(objAggEquip.ObjectState != DBOperation.DELETE)
                            bSameEquipInDifferentAggregates = true;
                        if (!htFormulaForAggregates.Contains(objAggEquip.ParentAggregateID))
                            htFormulaForAggregates.Add(objAggEquip.ParentAggregateID, null);
                    }
				}
				_app.DBManagerObj.CommitCollection(toSaveAggregateEquipments);
				isSaved = true;
				_lrrAggregateEquipments.RefreshCollection();
			}
			#endregion

			#region Get for each equipment, if mapped to multiple aggregates
			if(bSameEquipInDifferentAggregates)
			{
				bSameEquipInDifferentAggregates = false;
				foreach(LRRAggregateEquipment objAggEquip in _lrrAggregateEquipments)
				{
					string sSiteComponentID = objAggEquip.EquipmentID == null ? "" : objAggEquip.EquipmentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					if(sSiteComponentID != "")
					{
						if(!htEquipment.Contains(sSiteComponentID))
						{
							htEquipment.Add(sSiteComponentID,objAggEquip.ParentAggregateID);
						}
						else if ((htEquipment.Contains(sSiteComponentID)) && (htEquipment[sSiteComponentID].ToString() != objAggEquip.ParentAggregateID))
						{
							bSameEquipInDifferentAggregates = true;
						}
					}

				}
			}
			if(bSameEquipInDifferentAggregates)
				LRRMessagBox.ShowMessage("SID_AGG_EQUIP_WARNING","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Warning);  
		
			#endregion

            #region Commit Formula
            if (htFormulaForAggregates.Count > 0)
            {
                ArrayList formulaPramsToRemove = FillFormulaForPropertyValues(htFormulaForAggregates);
                for (int i = 0; i < formulaPramsToRemove.Count; i++)
                {
                    LRRFormulaParams fParms = formulaPramsToRemove[i] as LRRFormulaParams;
                    foreach (LRRFormulaParam fparam in fParms)
                    {
                        LRRFormula formulaObj = LRRModel.FormulasObj.GetFormulaObjFromID(fparam.FormulaID);
                        if (formulaObj != null)
                        {
                            formulaObj.Params.Remove(fparam);
                        }
                    }
                    _app.DBManagerObj.ExecuteBatchDelete(fParms);
                }
            }
            LRRFormulas formulasToCommit = LRRModel.FormulasObj.GetChanges();
            if (formulasToCommit.Count > 0)
            {
                _app.DBManagerObj.CommitCollection(formulasToCommit);
                isSaved = true;
            }
            foreach (LRRFormula formula in formulasToCommit)
            {
                if (!arFormulas.Contains(formula.ID))
                    arFormulas.Add(formula.ID);
            }
            LRRModel.FormulasObj.RefreshCollection();
            #endregion

			#region Aggregates PropertyValues Save
			LRRAggregatePropertyValues objSaveFormulaForAggPropertyValues = _lrrAggregatePropertyValues.GetChanges() as LRRAggregatePropertyValues;
			if(objSaveFormulaForAggPropertyValues.Count>0)
			{
				_app.DBManagerObj.CommitCollection(objSaveFormulaForAggPropertyValues);
				isSaved = true;
				if(objSaveFormulaForAggPropertyValues.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					_recordValueChanged = "0";
					_recordAggID = "";
					return;
				}
				_lrrAggregatePropertyValues.RefreshCollection();
			}

			#endregion
			
			#region Aggregates Grouped Property Values Save
			if(_lrrAggregateGroupedPropertyValues.GetChanges().Count > 0)
			{
				LRRAggregateGroupedPropertyValues  toSaveGroupedPropertyValues = _lrrAggregateGroupedPropertyValues.GetChanges();
				
				_app.DBManagerObj.CommitCollection(toSaveGroupedPropertyValues); //Commit Site Components
				if(toSaveGroupedPropertyValues.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					_recordValueChanged = "0";
					_recordAggID = "";
					return;
				}
				isSaved = true;
				_lrrAggregateGroupedPropertyValues.RefreshCollection();
			}

			#endregion

			if(isSaved)
			{
				//LRRMessagBox.ShowMessage("SID_SAVEDINFO","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);   
                RefreshObjects();
                RefreshForm(); 
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true); 
			}					
			else
			{
				//LRRMessagBox.ShowMessage("SID_NODATASAVED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);  
			}
		}

        private bool CheckAggPropExistsInSitComp(LRRAggregateProperty objAggProp)
        {
            string aggregateID = objAggProp.AggregateID;
            LRRAggregateEquipments aggEquipsObj = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(aggregateID);
            foreach (LRRAggregateEquipment aggEquip in aggEquipsObj)
            {
                if (aggEquip.EquipmentID != null)
                {
                    string siteCompID = aggEquip.EquipmentID;
                    LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, objAggProp.MasterPropertyID);
                    if (lscp == null)
                    {
                        return false;
                    }
                }
                else if(aggEquip.ChildAggregateID != null)
                {
                    LRRAggregate aggregate = LRRModel.AggregatesObj.GetAggregateFromID(aggEquip.ChildAggregateID);
                    if (aggregate != null)
                    {
                        foreach (LRRAggregateProperty aggregateProp in aggregate.AggregateProperties)
                        {
                            bool isExis = CheckAggPropExistsInSitComp(aggregateProp);
                            if (!isExis)
                            {
                                return false;
                            }
                            else
                            {
                                return true;
                            }
                        }
                    }
                }
            }
            return true;
        }

        private void DeleteChildObjectsForAggregate(LRRAggregates aggreGates)
        {
            foreach (LRRAggregate aggreGate in aggreGates)
            {
                if (aggreGate.ObjectState == DBOperation.DELETE)
                {
                    #region Remove Formulas
                    LRRAggregateProperties aggProperties = aggreGate.AggregateProperties;
                    foreach (LRRAggregateProperty aggProp in aggProperties)
                    {
                        string masterPropID = aggProp.MasterPropertyID;
                        LRRMasterProperty masterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);
                        if (masterProp.Type != "1")
                        {
                            LRRAggregateGroupedProperties aggGroupProps = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromSiteCompPropID(aggProp.ID);
                            foreach (LRRAggregateGroupedProperty aggGroupProp in aggGroupProps)
                            {
                                LRRAggregateGroupedPropertyValues aggGroupPropValues = LRRModel.AggregateGroupedPropertyValuesObj.GetGroupedValuesFromGroupPropID(aggGroupProp.AggregateGroupedPropertyID);
                                foreach (LRRAggregateGroupedPropertyValue aggGroupPropValue in aggGroupPropValues)
                                {
                                    if (aggGroupPropValue.FormulaObj != null)
                                    {
                                        LRRModel.FormulasObj.Remove(aggGroupPropValue.FormulaObj); 
                                    }
                                    _lrrAggregateGroupedPropertyValues.Remove(aggGroupPropValue);  
                                }
                                _lrrAggregateGroupedProperties.Remove(aggGroupProp);  
                            }
                        }
                        else
                        {
                            foreach (LRRAggregatePropertyValue aggPropValue in aggProp.Values)
                            {
                                if (aggPropValue.FormulaObj != null)
                                    LRRModel.FormulasObj.Remove(aggPropValue.FormulaObj);
                            }
                        }
                    }
                    #endregion

                    #region Remove AggregateEquipments

                    LRRAggregateEquipments aggregateEquips = aggreGate.AggregateEquipments;
                    foreach (LRRAggregateEquipment equip in aggregateEquips)
                    {
                        _lrrAggregateEquipments.Remove(equip);
                    }

                    #endregion

                    #region Remove related Properties/GpProperties & Values/GpValues

                    LRRAggregateProperties aggregatePrps = aggreGate.AggregateProperties;
                    foreach (LRRAggregateProperty aggProp in aggregatePrps)
                    {
                        LRRAggregatePropertyValues aggPropValues = aggProp.Values;
                        foreach (LRRAggregatePropertyValue aggPropValue in aggPropValues)
                        {
                            _lrrAggregatePropertyValues.Remove(aggPropValue);
                        }
                        _lrrAggregateProperties.Remove(aggProp);
                    }

                    #endregion
                }
            }
            _app.DBManagerObj.CommitCollection(LRRModel.FormulasObj.GetChanges());
            LRRModel.FormulasObj.RefreshCollection();
        }

		private void RefreshObjects()
		{
			gridAggregates.TableControl.Selections.Clear();
			
			_lrrAggregates.RefreshCollection();
			//_lrrOrgAggregates.RefreshCollection();
			_lrrAggregateEquipments.RefreshCollection();
			_lrrAggregatesforAggregates.RefreshCollection();
			_siteComponentsList.RefreshCollection();
			_lrrAggregateProperties.RefreshCollection();
			_lrrFormulas.RefreshCollection();
			_lrrAggregatePropertyValues.RefreshCollection();

//			gridUnBoundEquip.ClearSelectedRecords();
//			gridUnBoundAgg.ClearSelectedRecords();

            //gridAggregateOfAggregates.TableDescriptor.AllowEdit=false;
            //gridAggregateOfAggregates.TableDescriptor.AllowNew=false;
            //gridAggregateOfAggregates.TableDescriptor.AllowRemove=false;
			
			_lrrAggregatesforAggregates = new LRRAggregates();
			_app.DBManagerObj.PopulateCollection(_lrrAggregatesforAggregates,false);

///			BindAggregateOfAggregatesGrid();

			_recordValueChanged = "0";
			_recordAggID = "";
		}

		private void ResetCollectionState(CustomCollection customCollection)
		{
			foreach(BaseObject obj in customCollection.DeletedItems)
			{
				obj.ResetObjectState();
				customCollection.Add(obj);
			}
			customCollection.DeletedItems.Clear();
			
		}
		private void RefreshForm()
		{
			gridAggregates.TableControl.Selections.Clear();
			
			gridUnBoundEquip.ClearSelectedRecords();
			gridUnBoundAgg.ClearSelectedRecords();
			
			ResetCollectionState(_lrrAggregates);
			//ResetCollectionState(_lrrOrgAggregates);
			ResetCollectionState(_lrrAggregateEquipments);
			ResetCollectionState(_lrrAggregateProperties);
			ResetCollectionState(_lrrAggregatePropertyValues);
			
			_lrrAggregates.RefreshCollection();
			//_lrrOrgAggregates.RefreshCollection();
			_lrrAggregateEquipments.RefreshCollection();
			_lrrAggregatesforAggregates.RefreshCollection();
			_siteComponentsList.RefreshCollection();
			_lrrAggregateProperties.RefreshCollection();
			_lrrFormulas.RefreshCollection();
			_lrrAggregatePropertyValues.RefreshCollection();

			InitDataSource();
			BindAggregateGrid();
			BindAggregateEqpmntsGrid();
			BindAggregateOfAggregatesGrid();
			gridAggregateOfAggregates.TableDescriptor.AllowEdit=false;
			gridAggregateOfAggregates.TableDescriptor.AllowNew=false;
			gridAggregateOfAggregates.TableDescriptor.AllowRemove=false;
			//_siteComponentsList.Clear();
			_siteComponentsList = new LRRSiteComponents();
			_recordValueChanged = "0";
			_recordAggID = "";
		}
		
		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridAggregates.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAggregates,false);
			}
			if(gridAggregateOfAggregates.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAggregateOfAggregates,false);
			}
			if(gridAggregateEqpmnts.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAggregateEqpmnts,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add ComplexEquip.ClearFilter implementation
			this.gridAggregates.TableDescriptor.RecordFilters.Clear();
			this.gridAggregateEqpmnts.TableDescriptor.RecordFilters.Clear();
		}
		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridAggregates);
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridAggregates);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
            return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			InsertNewRowsForm insNewRows = new InsertNewRowsForm();
			DialogResult dlgResult = insNewRows.ShowDialog(this);
			int iNumofRows = insNewRows.iNewRows;
			if(dlgResult == DialogResult.OK)
			{
				for(int i = 0; i < iNumofRows;i++)
				{
					LRRComplexEquipment ce = new LRRComplexEquipment();
					_lrrAggregates.Add(ce);
				}
				gridAggregates.Refresh();
			}
			else
			{
				return;
			}
		}

		public void Export()
		{
			if(gridAggregates.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridAggregates);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
	
		public void ClearSort()
		{
			//AggregateDetails.ClearSort implementation
			SyncGridUtilities.ClearSort(gridAggregateEqpmnts);
			SyncGridUtilities.ClearSort(gridAggregates);
			SyncGridUtilities.ClearSort(gridAggregateOfAggregates);
		}

		public bool SupportsClearSort()
		{
			//AggregateDetails.SupportsClearSort implementation
			return true;
		}

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		public void PrintPreview()
		{
			// TODO:  Add AggregateDetails.PrintPreview implementation
			//Print Implementation
			if(gridAggregates.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAggregates,true);
			}
			if(gridAggregateOfAggregates.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAggregateOfAggregates,true);
			}
			if(gridAggregateEqpmnts.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAggregateEqpmnts,true);
			}
		}

		public void ShowPropertyList()
		{
			// TODO:  Add AggregateDetails.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add AggregateDetails.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add AggregateDetails.SupportsResultsFilter implementation
			return false;
		}

        private void CheckForUpdate(LRRSiteComponent objSiteComponent, GridGroupingControl ggc, LRRAggregateEquipment currentAggEquip)
        {
            string gridScreenName = this.Text;
            try
            {
                if (GridChangedRecordLists.GetInstance().Count > 0)
                {
                    bool screenRecordExists = false;
                    IEnumerator ieNumChangedRecordLists = GridChangedRecordLists.GetInstance().GetEnumerator();
                    while (ieNumChangedRecordLists.MoveNext())
                    {
                        string recordScreenName = ((GridChangedRecord)(ieNumChangedRecordLists.Current)).ScreenName.ToString();
                        if (gridScreenName == recordScreenName)
                        {
                            screenRecordExists = true;
                            if (((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList != null)
                            {
                                if (!((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList.Contains(currentAggEquip))
                                    ((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList.Add(currentAggEquip);
                            }
                            else
                            {
                                ((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList = new ArrayList();
                                ((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList.Add(currentAggEquip);
                            }
                        }
                    }
                    if (!screenRecordExists)
                    {
                        GridChangedRecord gridChangedRecord = new GridChangedRecord();
                        gridChangedRecord.ScreenName = gridScreenName;
                        gridChangedRecord.DataTypeStored = currentAggEquip.GetType().ToString();
                        gridChangedRecord.ChangedRecordList.Add(currentAggEquip);
                        GridChangedRecordLists.GetInstance().Add(gridChangedRecord);

                    }
                }
                else
                {
                    GridChangedRecord gridChangedRecord = new GridChangedRecord();
                    gridChangedRecord.ScreenName = gridScreenName;
                    gridChangedRecord.DataTypeStored = currentAggEquip.GetType().ToString();
                    gridChangedRecord.ChangedRecordList.Add(currentAggEquip);
                    GridChangedRecordLists.GetInstance().Add(gridChangedRecord);
                }
            }
            catch (Exception ex)
            {
                Debug.Assert(true, ex.Message); 
            }

        }

		#endregion

		private void AggregateDetails_Activated(object sender, System.EventArgs e)
		{
			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
			LRRFormulaDataStore.ModeFlag = true;
			LRRFormulaDataStore.ObjectSource = typeof(LRRAggregatePropertyValue).ToString();
			LRRFormulaDataStore.ShowGroupedAttributes = false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;
		}

		private void AggregateDetails_Closed(object sender, System.EventArgs e)
		{
			_gridExcelFormatter.UnwireGrid(); 
			
		}

       	#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
            SyncGridUtilities.RollBackChanges(this.gridAggregateEqpmnts);
            SyncGridUtilities.RollBackChanges(this.gridAggregates);
            SyncGridUtilities.RollBackChanges(this.gridAggregateOfAggregates);
            Refresh();
 
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add AggregateDetails.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add AggregateDetails.SupportsUndo implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add AggregateDetails.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add AggregateDetails.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add AggregateDetails.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add AggregateDetails.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add AggregateDetails.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				return true;
			}
		}

		#endregion
	}
}
