using System;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.MessageDispatcher;
using Symcon.Globals.Enums;
using Symcon.Utils.HeaderDispatcher;
namespace Symcon.LightRidge.PEAdvisor
{
	
	/// <summary>
	/// Summary description for AggregateUtility.
	/// </summary>
	public class AggregateUtility
	{
		public AggregateUtility()
		{
			//
			// TODO: Add constructor logic here
			//
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_LocaleID = _app.AppLocaleID;
            aggDetl = new AggregateDetails();

            _objAggregates =LRRModel.AggregatesObj;
			_objAggregateEquips =LRRModel.AggregateEquipmentsObj;
			_objAggregateProps =LRRModel.AggregatePropertiesObj;
			_objAggregatePropVals =LRRModel.AggregatePropertyValuesObj;
			_objAggregateGroupedProps =LRRModel.AggregateGroupedPropertiesObj;
			_objAggregateGroupedPropVals =LRRModel.AggregateGroupedPropertyValuesObj;
			
		}
        public void UpdateAggregateProperties(LRRMasterProperty objMasterProp,bool isAggregatable)
        {
            string sMasterComponentTypeID = objMasterProp.ComponentID == null ? "" : objMasterProp.ComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
            int nPropCtr = 0;
            LRRAggregateProperties objAggregateProperties;
            ArrayList arrDelAggregateProperties = new ArrayList();
            ArrayList arrAddAggregateProperties = new ArrayList();
            ArrayList arrAddAggregatePropertyValues = new ArrayList();
            ArrayList arrAggregatesList = new ArrayList();
            LRRAggregates objAggregates = _objAggregates.GetAggregatesByMasterComponentID(sMasterComponentTypeID);
            if (isAggregatable)
            {
                foreach (LRRAggregate objAgg in objAggregates)
                {
                    LRRAggregateProperty objAggregateProp = ConverMasterPropToAggregateProp(objMasterProp, objAgg.AggregateID);
                    arrAddAggregateProperties.Add(objAggregateProp);
                    objAgg.AggregateProperties.Add(objAggregateProp);
                    if (objMasterProp.Type == "1")
                    {
                        if (objAggregateProp.ModeID == true)
                        {
                            for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                            {
                                LRRMode lmsd = LRRModel.ProjectModes[i] as LRRMode;
                                if (lmsd.IsDefault)
                                    continue;
                                LRRAggregatePropertyValue lscpv = new LRRAggregatePropertyValue();
                                lscpv.ModeID = lmsd.ModeId;
                                lscpv.AggregateID = objAggregateProp.ID;
                                lscpv.IsEditable = true;
                                string sDirection = objMasterProp.Direction == null ? "" : objMasterProp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                lscpv.Direction = sDirection;
                                if ((sDirection == "Input/Output") || (sDirection == "3"))
                                {
                                    if (lmsd.ModeId == "1")
                                        lscpv.Direction = "1";
                                }
                                objAggregateProp.Values.Add(lscpv);
                                _objAggregatePropVals.Add(lscpv);
                                if (!arrAddAggregatePropertyValues.Contains(lscpv))
                                    arrAddAggregatePropertyValues.Add(lscpv);
                            }
                        }
                        else
                        {
                            LRRAggregatePropertyValue lscpv = new LRRAggregatePropertyValue();
                            lscpv.ModeID = "0";
                            lscpv.AggregateID = objAggregateProp.ID;
                            lscpv.IsEditable = true;
                            string sDirection = objMasterProp.Direction == null ? "" : objMasterProp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            lscpv.Direction = sDirection;
                            objAggregateProp.Values.Add(lscpv);
                            _objAggregatePropVals.Add(lscpv);
                            if (!arrAddAggregatePropertyValues.Contains(lscpv))
                                arrAddAggregatePropertyValues.Add(lscpv);
                        }
                    }
                    else
                    {
                        CreateAggregateGroupedProperties(objAggregateProp);
                    }
                }
            }
            else
            {
                foreach (LRRAggregate objAgg in objAggregates)
                {
                    foreach (LRRAggregateProperty aggProp in objAgg.AggregateProperties)
                    {
                        if (objMasterProp.PropID == aggProp.MasterPropertyID)
                        {
                            arrDelAggregateProperties.Add(aggProp);
                            if (objMasterProp.Type != "1")
                            {
                                DeleteFormulasAndGPForAggregate(aggProp);
                            }
                            else
                            {
                                DeleteFormulasForSimpleAggProp(aggProp);
                            }
                        }
                    }
                }
                for (int i = 0; i < arrDelAggregateProperties.Count; i++)
                {
                    LRRAggregateProperty objLRRAggregateProperty = arrDelAggregateProperties[i] as LRRAggregateProperty;
                    foreach (LRRAggregatePropertyValue aggPropValue in objLRRAggregateProperty.Values)
                    {
                        _objAggregatePropVals.Remove(aggPropValue); 
                    }
                    LRRAggregate aggreGate = LRRModel.AggregatesObj.GetAggregateFromID(objLRRAggregateProperty.AggregateID);
                    if(aggreGate != null)
                        aggreGate.AggregateProperties.Remove(objLRRAggregateProperty);
                    _objAggregateProps.Remove(objLRRAggregateProperty);
                }
            }
            //Save Aggregates
            _app.DBManagerObj.CommitCollection(LRRModel.AggregatesObj.GetChanges());
            //Save AggregateProperties
            if (_objAggregateProps.GetChanges().Count > 0)
            {
                LRRAggregateProperties objAggregatePropertiesToSave = _objAggregateProps.GetChanges();
                _app.DBManagerObj.CommitCollection(objAggregatePropertiesToSave);
            }
            if (_objAggregatePropVals.GetChanges().Count > 0)
            {
                LRRAggregatePropertyValues objAggregatePropertyValuesToSave = _objAggregatePropVals.GetChanges();
                _app.DBManagerObj.CommitCollection(objAggregatePropertyValuesToSave);
            }
            if (_objAggregateGroupedProps.GetChanges().Count > 0)
            {
                LRRAggregateGroupedProperties toSaveAggGroupProps = _objAggregateGroupedProps.GetChanges();
                _app.DBManagerObj.CommitCollection(toSaveAggGroupProps);
            }
            if (_objAggregateGroupedPropVals.GetChanges().Count > 0)
            {
                LRRAggregateGroupedPropertyValues toSaveAggGroupPropsValues = _objAggregateGroupedPropVals.GetChanges();
                _app.DBManagerObj.CommitCollection(toSaveAggGroupPropsValues);
            }

            LRRModel.AggregatesObj.RefreshCollection();
            _objAggregateProps.RefreshCollection();
            _objAggregatePropVals.RefreshCollection();
            _objAggregateGroupedProps.RefreshCollection();
            _objAggregateGroupedPropVals.RefreshCollection();
        }

        private void DeleteFormulasForSimpleAggProp(LRRAggregateProperty aggProp)
        {
            foreach (LRRAggregatePropertyValue aggPropValue in aggProp.Values)
            {
                if (aggPropValue.FormulaID != null || aggPropValue.FormulaID.Trim() != "")
                {
                    LRRFormula formulaObj = LRRModel.FormulasObj.GetFormulaObjFromID(aggPropValue.FormulaID);
                    if (formulaObj != null)
                        LRRModel.FormulasObj.Remove(formulaObj);
                }
            }
            if (LRRModel.FormulasObj.GetChanges().Count > 0)
            {
                _app.DBManagerObj.CommitCollection(LRRModel.FormulasObj.GetChanges());
                LRRModel.FormulasObj.RefreshCollection();
            }
        }

        private void CreateAggregateGroupedProperties(LRRAggregateProperty lscp)
        {
            string sMPID = lscp.MasterPropertyID;
            string sGPID = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMPID).Type;
            bool bDataArrays = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sGPID).IsDataArray;
            LRRLookUpProperties objLkupProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(sGPID);
            //For each lookup properties, create group properties
            foreach (LRRLookUpProperty objLkupProp in objLkupProps)
            {
                LRRAggregateGroupedProperty lagp = new LRRAggregateGroupedProperty();
                lagp.AggregatePropertyID = lscp.ID;
                lagp.AttributeName = objLkupProp.Name;
                lagp.AttributeDescription = objLkupProp.Description;
                lagp.LookUpPropertiesID = objLkupProp.LookUpPropertiesID;
                lagp.UOMTypeID = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMPID).MasterPropertyUOMTypeID;
                LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
                lagp.ModeID = lscp.ModeID;
                lagp.PropertyID = objLkupProp.PropertyID;
                lagp.MasterPropID = sMPID;
                if (lagp.ModeID == true)
                {
                    for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                    {
                        LRRMode lmsd = LRRModel.ProjectModes[i] as LRRMode;
                        if (lmsd.IsDefault)
                            continue;
                        GenerateGroupedPropertyValues(lagp, lmsd.ModeId, bDataArrays);
                    }
                }
                else
                {
                    GenerateGroupedPropertyValues(lagp, "0", bDataArrays);
                }
                _objAggregateGroupedProps.Add(lagp);
                lscp.GroupPpties.Add(lagp);
            }
        }

        private void GenerateGroupedPropertyValues(LRRAggregateGroupedProperty lscgp, string sModeID, bool bDataArrays)
        {
            string sPropertyType = lscgp.PropertyID == null ? "" : lscgp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

            if (bDataArrays)
            {
                CreateAggregateGroupedPropValue(lscgp, sModeID, null);
            }
            else
            {
                LRRLookUpQualifiers LRRLookUpQualifiersObj = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(sPropertyType);

                foreach (LRRLookUpQualifier objQualifierForGrpType in LRRLookUpQualifiersObj)
                {
                    CreateAggregateGroupedPropValue(lscgp, sModeID, objQualifierForGrpType);
                }
            }
        }
        private void CreateAggregateGroupedPropValue(LRRAggregateGroupedProperty lscgp, string sModeID, LRRLookUpQualifier objQualifierForGrpType)
        {
            string sMasterPropID = "";
            string sGrpPropID = lscgp.AggregateGroupedPropertyID == null ? "" : lscgp.AggregateGroupedPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

            LRRAggregateGroupedPropertyValue QualifierPropertyValue = new LRRAggregateGroupedPropertyValue();
            QualifierPropertyValue.AggregateGroupPropertyID = lscgp.AggregateGroupedPropertyID;
            if (objQualifierForGrpType != null)
            {
                QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
                QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
            }
            QualifierPropertyValue.LookUpPropertiesID = lscgp.LookUpPropertiesID;
            QualifierPropertyValue.PropertyID = lscgp.PropertyID;
            QualifierPropertyValue.ModeID = sModeID;
            QualifierPropertyValue.IsEditable = true;
            sMasterPropID = lscgp.MasterPropID == null ? "" : lscgp.MasterPropID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
            QualifierPropertyValue.MasterPropID = sMasterPropID;

            if ((sMasterPropID != null) && (sMasterPropID != ""))
            {
                LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMasterPropID);
                string sDirection = objMasterProp.Direction == null ? "" : objMasterProp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                if ((sDirection == "Input/Output") || (sDirection == "3"))
                {
                    if (sModeID == "1")
                        sDirection = "1";
                }
                QualifierPropertyValue.Direction = sDirection;
            }
            _objAggregateGroupedPropVals.Add(QualifierPropertyValue);
            lscgp.GroupPptiesQualifierValues.Add(QualifierPropertyValue);
        }

        private void DeleteFormulasAndGPForAggregate(LRRAggregateProperty aggProp)
        {
            LRRAggregateGroupedProperties aggGroupProps = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromSiteCompPropID(aggProp.ID);
            foreach (LRRAggregateGroupedProperty aggGroupProp in aggGroupProps)
            {
                LRRAggregateGroupedPropertyValues aggGroupPropValues = LRRModel.AggregateGroupedPropertyValuesObj.GetGroupedValuesFromGroupPropID(aggGroupProp.AggregateGroupedPropertyID);
                foreach (LRRAggregateGroupedPropertyValue aggGroupPropValue in aggGroupPropValues)
                {
                    if (aggGroupPropValue.FormulaObj != null)
                    {
                        LRRModel.FormulasObj.Remove(aggGroupPropValue.FormulaObj);
                    }
                    LRRModel.AggregateGroupedPropertyValuesObj.Remove(aggGroupPropValue);
                }
                LRRModel.AggregateGroupedPropertiesObj.Remove(aggGroupProp);
            }
            _app.DBManagerObj.CommitCollection(LRRModel.FormulasObj.GetChanges());
            _app.DBManagerObj.CommitCollection(LRRModel.AggregateGroupedPropertyValuesObj.GetChanges());
            _app.DBManagerObj.CommitCollection(LRRModel.AggregateGroupedPropertiesObj.GetChanges());
            LRRModel.FormulasObj.RefreshCollection();
            LRRModel.AggregateGroupedPropertyValuesObj.RefreshCollection();
            LRRModel.AggregateGroupedPropertiesObj.RefreshCollection();
        }

        public void UpdateAggregateProperties(ArrayList masterPropIDArray)
		{
			string sMasterComponentTypeID = "";
			int nPropCtr = 0;
			LRRMasterProperties objMasterProperties = new LRRMasterProperties();
			LRRAggregateProperties objAggregateProperties;
			
            ArrayList arrDelAggregateProperties = new ArrayList();
			ArrayList arrAddAggregateProperties = new ArrayList();
			ArrayList arrAddAggregatePropertyValues = new ArrayList();
			ArrayList arrAggregatesList = new ArrayList();

			for(int k =0 ;k <masterPropIDArray.Count;k++)
			{
                string sMasterPropertyID = masterPropIDArray[k].ToString();
                LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMasterPropertyID);
                if (objMasterProp.ObjectState == DBOperation.DELETE)
                {
                    objMasterProp.ObjectState = DBOperation.UNCHANGED;
                    UpdateAggregateProperties(objMasterProp, false);
                }
                else if (objMasterProp.ObjectState == DBOperation.INSERT)
                {
                    objMasterProp.ObjectState = DBOperation.UNCHANGED;
                    sMasterComponentTypeID = objMasterProp.ComponentID == null ? "" : objMasterProp.ComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    string sAggregatable = objMasterProp.IsAggregatable.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    LRRAggregates objAggregates = _objAggregates.GetAggregatesByMasterComponentID(sMasterComponentTypeID);
                    foreach (LRRAggregate objAggregate in objAggregates)
                    {
                        if (!arrAggregatesList.Contains(objAggregate))
                            arrAggregatesList.Add(objAggregate);

                        string sAggID = objAggregate.AggregateID == null ? "" : objAggregate.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        objAggregateProperties = objAggregate.AggregateProperties;

                        string sMasterPropID = objMasterProp.PropID == null ? "" : objMasterProp.PropID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        LRRAggregateProperty objAggProp = objAggregate.AggregateProperties.GetAggregatePropFromMasterPropertyID(sAggID, sMasterPropID); 
                        if (objAggProp == null)
                        {
                            if (sAggregatable.ToUpper() == "TRUE")
                            {
                                LRRAggregateProperty objAggregateProp = ConverMasterPropToAggregateProp(objMasterProp, sAggID);
                                objAggregate.AggregateProperties.Add(objAggregateProp);
                                string sGPID = objMasterProp.Type;
                                if (sGPID != "1") //-- Its the case of grouped properties - Chemical components / Data Arrays
                                {
                                    CreateAggregateGroupedProperties(objAggregateProp);
                                    if (!arrAddAggregateProperties.Contains(objAggregateProp))
                                    {
                                        arrAddAggregateProperties.Add(objAggregateProp);
                                    }
                                }
                                else
                                {
                                    if (!arrAddAggregateProperties.Contains(objAggregateProp))
                                    {
                                        if (objAggregateProp.ModeID == true)
                                        {
                                            for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                            {
                                                LRRMode lmsd = LRRModel.ProjectModes[i] as LRRMode;
                                                if (lmsd.IsDefault)
                                                    continue;
                                                LRRAggregatePropertyValue lscpv = new LRRAggregatePropertyValue();
                                                lscpv.ModeID = lmsd.ModeId;
                                                lscpv.AggregateID = objAggregateProp.ID;
                                                lscpv.IsEditable = true;
                                                string sDirection = objMasterProp.Direction == null ? "" : objMasterProp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                                lscpv.Direction = sDirection;
                                                if ((sDirection == "Input/Output") || (sDirection == "3"))
                                                {
                                                    if (lmsd.ModeId == "1")
                                                        lscpv.Direction = "1";
                                                }
                                                objAggregateProp.Values.Add(lscpv);
                                                _objAggregatePropVals.Add(lscpv);
                                                if (!arrAddAggregatePropertyValues.Contains(lscpv))
                                                    arrAddAggregatePropertyValues.Add(lscpv);
                                            }
                                        }
                                        else
                                        {
                                            LRRAggregatePropertyValue lscpv = new LRRAggregatePropertyValue();
                                            lscpv.ModeID = "0";
                                            lscpv.AggregateID = objAggregateProp.ID;
                                            lscpv.IsEditable = true;
                                            string sDirection = objMasterProp.Direction == null ? "" : objMasterProp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                            lscpv.Direction = sDirection;
                                            objAggregateProp.Values.Add(lscpv);
                                            _objAggregatePropVals.Add(lscpv);
                                            if (!arrAddAggregatePropertyValues.Contains(lscpv))
                                                arrAddAggregatePropertyValues.Add(lscpv);
                                        }
                                        arrAddAggregateProperties.Add(objAggregateProp);
                                    }
                                }
                            }
                        }
                        else if (sAggregatable.ToUpper() == "FALSE")
                        {
                            if (objAggProp != null)
                            {
                                if (!arrDelAggregateProperties.Contains(objAggProp))
                                    arrDelAggregateProperties.Add(objAggProp);
                            }
                        }
                    }
                }
                else
                {
                    ArrayList updatedColomns = objMasterProp.ArrListUpdatedColNames;
                    if (updatedColomns.Contains("Aggregatable"))
                    {
                        if (objMasterProp.IsAggregatable)
                        {
                            UpdateAggregateProperties(objMasterProp, true);
                        }
                        else
                        {
                            UpdateAggregateProperties(objMasterProp, false);
                        }
                    }
                    if (updatedColomns.Contains("AggregationRule"))
                    {
                        Hashtable aggregateHash = new Hashtable();
                        string masterCompId = objMasterProp.ComponentID;
                        LRRAggregates aggregates = LRRModel.AggregatesObj.GetAggregatesByMasterComponentID(masterCompId);
                        foreach (LRRAggregate agg in aggregates)
                        {
                            if (!aggregateHash.Contains(agg.AggregateID))
                                aggregateHash.Add(agg.AggregateID, null);
                        }
                        aggDetl.FillFormulaForPropertyValues(aggregateHash, objMasterProp);
                        aggDetl.BindAggregateGrid();
                        aggDetl.Refresh(); 
                    }
                }
			}
			
			for(int i=0; i< arrDelAggregateProperties.Count;i++)
			{
				LRRAggregateProperty objLRRAggregateProperty = arrDelAggregateProperties[i] as LRRAggregateProperty;
				string sAggregatePropid = objLRRAggregateProperty.ID;
				string sAggID = objLRRAggregateProperty.AggregateID;
				ArrayList arVals = new ArrayList();
				foreach(LRRAggregatePropertyValue aggv in objLRRAggregateProperty.Values)
				{
					arVals.Add(aggv);
				}
				for(int iv=0; iv< arVals.Count;iv++)
				{
					LRRAggregatePropertyValue objVal = arVals[iv] as LRRAggregatePropertyValue;
					objLRRAggregateProperty.Values.Remove(objVal);
				}
				_objAggregates.GetAggregateFromID(sAggID).AggregateProperties.Remove(objLRRAggregateProperty);
				_objAggregateProps.Remove(objLRRAggregateProperty);

			}
			//Incase Aggregates have not been saved, save them first
			//Save Aggregates
			_app.DBManagerObj.CommitCollection(LRRModel.AggregatesObj.GetChanges()); 
			

			//Save AggregateProperties
			if(_objAggregateProps.GetChanges().Count > 0)
			{
				LRRAggregateProperties objAggregatePropertiesToSave = _objAggregateProps.GetChanges();
				_app.DBManagerObj.CommitCollection(objAggregatePropertiesToSave); 
				
			}

			//Save AggregateGroupedProperties
			if(_objAggregateGroupedProps.GetChanges().Count > 0)
			{
				LRRAggregateGroupedProperties objAggregateGPropertiesToSave = _objAggregateGroupedProps.GetChanges();
				_app.DBManagerObj.CommitCollection(objAggregateGPropertiesToSave); 
				
			}
			
			//Save AggregateGroupedPropertyValues
			if(_objAggregateGroupedPropVals.GetChanges().Count > 0)
			{
				LRRAggregateGroupedPropertyValues objAggregateGPropertyValuesToSave = _objAggregateGroupedPropVals.GetChanges();
				_app.DBManagerObj.CommitCollection(objAggregateGPropertyValuesToSave); 
			}
			
			//Save AggregatePropertyValues
			if(_objAggregatePropVals.GetChanges().Count > 0)
			{
				LRRAggregatePropertyValues objAggregatePropertyValuesToSave = _objAggregatePropVals.GetChanges();
				_app.DBManagerObj.CommitCollection(objAggregatePropertyValuesToSave); 
				
			}
			LRRModel.AggregatesObj.RefreshCollection();
			_objAggregateProps.RefreshCollection();
			_objAggregatePropVals.RefreshCollection();
			_objAggregateGroupedPropVals.RefreshCollection();
			_objAggregateGroupedProps.RefreshCollection();
		}
		private LRRFormulaParams FillFormulaForPropertyValues(LRRAggregate objCurrAggregate,bool bOverwriteExisting)
		{
			AggregateFormula objAggregateFormula = new AggregateFormula();
			LRRFormulaParams objParamsToDelete = new  LRRFormulaParams();
			//objParamsToDelete= objAggregateFormula.CreateAggregatesFormulaExpression(objCurrAggregate.AggregateID,bOverwriteExisting);
			LRRFormulas objFormulas = LRRModel.FormulasObj.GetChanges();
			if(objFormulas != null)
			{
				foreach(LRRFormula objFormula in objFormulas)
				{
					if(objFormula.ObjectState != DBOperation.DELETE)
					{
						string nAggPropValID = objFormula.SourceObjectID;
						LRRAggregatePropertyValue objValue = _objAggregatePropVals.FindAggregatePropertyValueByID(nAggPropValID);
						if(objValue == null)
						{
							if(_objAggregateGroupedPropVals.GetAggregateGroupedPropertyValueFromID(nAggPropValID) != null)
								_objAggregateGroupedPropVals.GetAggregateGroupedPropertyValueFromID(nAggPropValID).FormulaID= objFormula.ID;
						}
						else
							objValue.FormulaID = objFormula.ID;
						
					}
				}
			}
			return objParamsToDelete;
		}
		private LRRAggregateProperty ConverMasterPropToAggregateProp(LRRMasterProperty lmpObj,string sAggregateID)
		{
			LRRAggregateProperty lap = new LRRAggregateProperty();
			lap.AggregateID = sAggregateID;
			lap.Name = lmpObj.Name;
			lap.Description = lmpObj.Description;
			lap.UOMTypeID = lmpObj.MasterPropertyUOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lap.UOM = _lrrMSD.GetLocaleUOM(_LocaleID,lap.UOMTypeID);
			lap.Formula = lmpObj.AggregationRule;
			lap.MasterPropertyID= lmpObj.PropID;
			lap.MasterCompTypeID= lmpObj.ComponentID;
			lap.ModeID = lmpObj.ModeID;
            _objAggregateProps.Add(lap);
			return lap;
		}

        /*public void CreateAggFormulas(LRRSiteComponentProperties lscps)
        {
            Hashtable aggregateHash = new Hashtable();
            foreach (LRRSiteComponentProperty lscp in lscps)
            {
                LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscp.PropertyID);
                if (lmp.IsAggregatable)
                {
                    LRRAggregates aggreGates = _objAggregates.GetAggregatesByMasterComponentID(lmp.ComponentID);
                    foreach (LRRAggregate agg in aggreGates)
                    {
                         LRRAggregateEquipments aggEquips = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(agg.AggregateID);
                         foreach (LRRAggregateEquipment aggEquip in aggEquips)
                         {
                             if (aggEquip.EquipmentID == lscp.ComponentID)
                             {
                                 if (!aggregateHash.Contains(agg.AggregateID))
                                     aggregateHash.Add(agg.AggregateID, null);
                             }
                         }         
                    }
                    aggDetl.FillFormulaForPropertyValues(aggregateHash, lmp);
                }
            }
            aggDetl.BindAggregateGrid();
            aggDetl.Refresh();
        }*/

        public void CreateAggFormulas(LRRSiteComponentProperties lscps)
        {
            Hashtable masterPropHash = new Hashtable();
            foreach (LRRSiteComponentProperty lscp in lscps)
            {
                Hashtable aggregateHash = new Hashtable();
                LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscp.PropertyID);
                if (!masterPropHash.Contains(lmp.PropID))
                {
                    masterPropHash.Add(lmp.PropID, null);
                    if (lmp.IsAggregatable)
                    {
                        LRRAggregates aggreGates = _objAggregates.GetAggregatesByMasterComponentID(lmp.ComponentID);
                        foreach (LRRAggregate agg in aggreGates)
                        {
                            if (!aggregateHash.Contains(agg.AggregateID))
                                aggregateHash.Add(agg.AggregateID, null);
                        }
                        aggDetl.FillFormulaForPropertyValues(aggregateHash, lmp);
                    }
                }
            }
            aggDetl.BindAggregateGrid();
            aggDetl.Refresh();
        }
		

        #region Fields
		private string						_LocaleID;
		private LRRAggregates _objAggregates  = null;
		private LRRAggregateProperties _objAggregateProps  = null;
		private LRRAggregatePropertyValues _objAggregatePropVals  = null;
		private LRRAggregateEquipments _objAggregateEquips  = null;
		private LRRAggregateGroupedProperties _objAggregateGroupedProps  = null;
		private LRRAggregateGroupedPropertyValues _objAggregateGroupedPropVals  = null;
		private LRRApp				_app;
        private AggregateDetails aggDetl;
		
		#endregion
	}
}



