using System;
using System.Text;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.BusinessObjects.Utilities;
using Symcon.LightRidge.DataQualityConfiguration;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for AnalyzeDataQuality.
	/// </summary>
	public class AnalyzeDataQuality
	{
		#region Constructor

		public AnalyzeDataQuality()
		{
			//
			// TODO: Add constructor logic here
			//
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}

		#endregion

		#region Static Constructor

		static AnalyzeDataQuality()
		{
			//
			// TODO: Add constructor logic here
			//
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
//			string sAppSettingsPath = Application.StartupPath + @"\config\DQSettings.xml";
//			
//			if(System.IO.File.Exists(sAppSettingsPath))
//			{
//				
//				_lrrDQSettings = SGTXmlSerializer.DeserializeXML(sAppSettingsPath,typeof(LRRDQSettings)) as LRRDQSettings;
//				
//				if(_lrrDQSettings != null)
//				{
//				}
//			}
		}

		#endregion
		
		#region Properties

	

		#endregion

		#region Public Static Methods
		public static string GetDQRangeImageIndex(ImageToApply enImageToApply)
		{
			string sImageIndex="";

			switch(enImageToApply)
			{
				case ImageToApply.VERYHIGH | ImageToApply.BAD:
					sImageIndex = "5";
					break;
				case ImageToApply.HIGH:
					sImageIndex = "1";
					break;
//				case ImageToApply.AVG:
//					sImageIndex = "2";
//					break;
				case ImageToApply.GOOD:
					sImageIndex = "3";
					break;
				default:
					sImageIndex = "0";
					break;
			}
						
			//Get the DQ ImageIndex
			return sImageIndex;
		}
	

		public static Image GetDQRangeImage(string sImageIndex)
		{
			Image oImage = null;
			
			Assembly peAssembly = Assembly.GetAssembly(Type.GetType("Symcon.LightRidge.PEAdvisor.PEMainWindow"));
			Stream fs = peAssembly.GetManifestResourceStream("Symcon.LightRidge.PEAdvisor.NONE.jpg");
            
			switch(sImageIndex)
			{
				case "5": //BAD or Very High
					fs = peAssembly.GetManifestResourceStream("Symcon.LightRidge.PEAdvisor.BAD.jpg");
					oImage = Image.FromStream(fs);
					break;
				case "1": //High
					fs = peAssembly.GetManifestResourceStream("Symcon.LightRidge.PEAdvisor.HIGH.jpg");
					oImage = Image.FromStream(fs);
					break;
				case "2": //AVG
					//fs = peAssembly.GetManifestResourceStream("Symcon.LightRidge.PEAdvisor.AVG.jpg");
					oImage = Image.FromStream(fs);
					break;
				case "3": //GOOD
					fs = peAssembly.GetManifestResourceStream("Symcon.LightRidge.PEAdvisor.GOOD.jpg");
					oImage = Image.FromStream(fs);
					break;
				case "0": //NONE
					oImage = Image.FromStream(fs);
					break;
			}
			
			if(fs != null)
			{
				fs.Close();
				fs = null;
			}

			//Get the DQ ImageIndex
			return oImage;
		}

		
		public static DQDetails InterpretSiteComponentDQWithTag(string sSiteComponentID)
		{
            DQDetails siteComponentDQsObj = new DQDetails();
            LRRSiteComponentPropertyValue lrrSiteCompPropValue;
            LRRSiteGroupPropertyQualifierValue lrrSiteCompQualValue;
            Hashtable htPercent = new Hashtable();
            Hashtable htImageSummary = new Hashtable();
            float nTotalTags = 0;

            
            siteComponentDQsObj.ImageSummary = ImageToApply.NONE;

            //Get all the properties tied to hist tags for the given component id
            LRRHistPropCompPropMappings objCompPropMappings = new LRRHistPropCompPropMappings();
            objCompPropMappings = LRRModel.HistPropMaps.FilterBySiteComponentID(sSiteComponentID);
            //_lrrApp.DBManagerObj.PopulateCollection(objCompPropMappings," WHERE ComponentID='" + sSiteComponentID + "'",false);

            nTotalTags = objCompPropMappings.Count;
            if (nTotalTags > 0)
            {
                #region	For each proerty get the DQ
                foreach (LRRHistPropCompPropMapping objCompPropMapping in objCompPropMappings)
                {
                    string sHistTagUID = objCompPropMapping.HistPropID == null ? "" : objCompPropMapping.HistPropID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    string sSiteCompPropValID = objCompPropMapping.SiteComponentPropValID == null ? "" : objCompPropMapping.SiteComponentPropValID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    string sSiteCompQualValID = objCompPropMapping.GroupPropertyValID == null ? "" : objCompPropMapping.GroupPropertyValID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    lrrSiteCompPropValue = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(sSiteCompPropValID);
                    lrrSiteCompQualValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(sSiteCompQualValID);

                    
                    DQDetail DQDetailObj = null;

                    if (lrrSiteCompPropValue != null)
                    {
                        //DQDetailObj = GetDQObjectForPropValue(lrrSiteCompPropValue);
                    }
                    else if (lrrSiteCompQualValue != null)
                    {
                        //DQDetailObj = GetDQObjectForQualValue(lrrSiteCompQualValue);
                    }
                    #region getDQ for simpleprops

                    if (lrrSiteCompPropValue != null)
                    {
                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.VERY_HIGH | ErrorCode.GOOD)) == (ErrorCode.VERY_HIGH | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";
                        }

                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.VERY_HIGH | ErrorCode.BAD)) == (ErrorCode.VERY_HIGH | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            siteComponentDQsObj.ImageSummary = ImageToApply.VERYHIGH;
                            ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                            ErrorCodeEnum = ErrorCode.VERY_HIGH | ErrorCode.BAD;
                            ColourCodes ColourCodesobj = new ColourCodes();
                            objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                            siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                        }

                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.HIGH | ErrorCode.GOOD)) == (ErrorCode.HIGH | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";
                        }
                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.HIGH | ErrorCode.BAD)) == (ErrorCode.HIGH | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            if (siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH)
                            {
                                siteComponentDQsObj.ImageSummary = ImageToApply.HIGH;
                                ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                ErrorCodeEnum = ErrorCode.HIGH | ErrorCode.BAD;
                                ColourCodes ColourCodesobj = new ColourCodes();
                                objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                            }
                        }

                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.MEDIUM | ErrorCode.GOOD)) == (ErrorCode.MEDIUM | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";
                        }

                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.MEDIUM | ErrorCode.BAD)) == (ErrorCode.MEDIUM | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            if ((siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.HIGH))
                            {
                                siteComponentDQsObj.ImageSummary = ImageToApply.AVG;
                                ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                ErrorCodeEnum = ErrorCode.MEDIUM | ErrorCode.BAD;
                                ColourCodes ColourCodesobj = new ColourCodes();
                                objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                            }
                        }

                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.LOW | ErrorCode.GOOD)) == (ErrorCode.LOW | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";

                        }
                        if ((lrrSiteCompPropValue.ErrCode & (ErrorCode.LOW | ErrorCode.BAD)) == (ErrorCode.LOW | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            if ((siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.AVG))
                            {
                                siteComponentDQsObj.ImageSummary = ImageToApply.LOW;
                                ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                ErrorCodeEnum = ErrorCode.LOW | ErrorCode.BAD;
                                ColourCodes ColourCodesobj = new ColourCodes();
                                objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                            }
                        }


                        if (DQDetailObj != null)
                        {
                            if (DQDetailObj.GoodPoint == "1")
                            {
                                if ((siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.AVG) && (siteComponentDQsObj.ImageSummary != ImageToApply.LOW))
                                {
                                    siteComponentDQsObj.ImageSummary = ImageToApply.GOOD;
                                    ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                    ErrorCodeEnum = ErrorCode.GOOD;
                                    ColourCodes ColourCodesobj = new ColourCodes();
                                    objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                    siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                                }
                            }
                            siteComponentDQsObj.Add(DQDetailObj);
                        }


                    }
                    #endregion

                    #region getDQ for Grouped and DAs
                    else if (lrrSiteCompQualValue != null)
                    {
                        
                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.VERY_HIGH | ErrorCode.GOOD)) == (ErrorCode.VERY_HIGH | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";
                        }

                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.VERY_HIGH | ErrorCode.BAD)) == (ErrorCode.VERY_HIGH | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            siteComponentDQsObj.ImageSummary = ImageToApply.VERYHIGH;
                            ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                            ErrorCodeEnum = ErrorCode.VERY_HIGH | ErrorCode.BAD;
                            ColourCodes ColourCodesobj = new ColourCodes();
                            objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                            siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                        }

                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.HIGH | ErrorCode.GOOD)) == (ErrorCode.HIGH | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";
                        }
                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.HIGH | ErrorCode.BAD)) == (ErrorCode.HIGH | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            if (siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH)
                            {
                                siteComponentDQsObj.ImageSummary = ImageToApply.HIGH;
                                ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                ErrorCodeEnum = ErrorCode.HIGH | ErrorCode.BAD;
                                ColourCodes ColourCodesobj = new ColourCodes();
                                objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                            }
                        }

                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.MEDIUM | ErrorCode.GOOD)) == (ErrorCode.MEDIUM | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";
                        }

                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.MEDIUM | ErrorCode.BAD)) == (ErrorCode.MEDIUM | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            if ((siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.HIGH))
                            {
                                siteComponentDQsObj.ImageSummary = ImageToApply.AVG;
                                ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                ErrorCodeEnum = ErrorCode.MEDIUM | ErrorCode.BAD;
                                ColourCodes ColourCodesobj = new ColourCodes();
                                objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                            }
                        }

                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.LOW | ErrorCode.GOOD)) == (ErrorCode.LOW | ErrorCode.GOOD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "1";

                        }
                        if ((lrrSiteCompQualValue.ErrCode & (ErrorCode.LOW | ErrorCode.BAD)) == (ErrorCode.LOW | ErrorCode.BAD))
                        {
                            DQDetailObj = new DQDetail();
                            DQDetailObj.Total = "1";
                            DQDetailObj.Type = ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            DQDetailObj.GoodPoint = "0";
                            if ((siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.AVG))
                            {
                                siteComponentDQsObj.ImageSummary = ImageToApply.LOW;
                                ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                ErrorCodeEnum = ErrorCode.LOW | ErrorCode.BAD;
                                ColourCodes ColourCodesobj = new ColourCodes();
                                objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                            }
                        }


                        if (DQDetailObj != null)
                        {
                            if (DQDetailObj.GoodPoint == "1")
                            {
                                if ((siteComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (siteComponentDQsObj.ImageSummary != ImageToApply.AVG) && (siteComponentDQsObj.ImageSummary != ImageToApply.LOW))
                                {
                                    siteComponentDQsObj.ImageSummary = ImageToApply.GOOD;
                                    ColourCodesContainer objColourCodesContainer = new ColourCodesContainer();
                                    ErrorCodeEnum = ErrorCode.GOOD;
                                    ColourCodes ColourCodesobj = new ColourCodes();
                                    objColourCodesContainer = ColourCodesobj.GetColorObject(ErrorCodeEnum);
                                    siteComponentDQsObj.ForeColor = objColourCodesContainer.ForeColor;
                                }
                            }
                            siteComponentDQsObj.Add(DQDetailObj);
                        }


                    }
                    #endregion


                } //For each Mapped Record
                #endregion

            } //If there exists Mapping

            htPercent = CalculatePercentageOfGood(siteComponentDQsObj);

            siteComponentDQsObj.Percent = htPercent;

            #region CalculateImageSummary
            CalculateImageSummary(siteComponentDQsObj, htImageSummary);

            if (htImageSummary.ContainsValue(true))
            {
                if ((bool)htImageSummary[ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)])
                    siteComponentDQsObj.ImageSummary = ImageToApply.LOW;
                if ((bool)htImageSummary[ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)])
                    siteComponentDQsObj.ImageSummary = ImageToApply.AVG;
                if ((bool)htImageSummary[ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)])
                    siteComponentDQsObj.ImageSummary = ImageToApply.HIGH;
                if ((bool)htImageSummary[ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)])
                    siteComponentDQsObj.ImageSummary = ImageToApply.VERYHIGH;
            }
            #endregion

            //Get the DQ of the component
            return siteComponentDQsObj;

        }

		public static DQDetails InterpretMasterComponentDQWithTag(string sMasterComponentTypeID)
		{
			Hashtable htPercent = new Hashtable();
			Hashtable htImageSummary = new Hashtable();

			DQDetails masterComponentDQsObj = new DQDetails();
			DQDetails siteComponentDQsObj = new DQDetails();
            if (sMasterComponentTypeID == "75")
            {
                int xyz = 0;
            }
			
			LRRSiteComponents objSiteComponents = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(sMasterComponentTypeID);
			masterComponentDQsObj.ImageSummary = ImageToApply.NONE;
			foreach(LRRSiteComponent objSiteComponent in objSiteComponents)
			{
				string sSiteComponentID = objSiteComponent.SiteComponentID == null ? "" : objSiteComponent.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				siteComponentDQsObj = InterpretSiteComponentDQWithTag(sSiteComponentID);
				#region Calculate Image Summary
				if((siteComponentDQsObj.ImageSummary == ImageToApply.VERYHIGH) )
				{
					masterComponentDQsObj.ImageSummary = siteComponentDQsObj.ImageSummary;
					masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
				}
				if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary == ImageToApply.HIGH))
				{
					masterComponentDQsObj.ImageSummary = ImageToApply.HIGH;
					masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
				}
				if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (siteComponentDQsObj.ImageSummary == ImageToApply.AVG))
				{
					masterComponentDQsObj.ImageSummary = ImageToApply.AVG;
					masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
				}
				if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.AVG) && (siteComponentDQsObj.ImageSummary == ImageToApply.LOW))
				{
					masterComponentDQsObj.ImageSummary = ImageToApply.LOW;
					masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
				}
				if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.AVG) && (masterComponentDQsObj.ImageSummary != ImageToApply.LOW) && (siteComponentDQsObj.ImageSummary == ImageToApply.GOOD))
				{
					masterComponentDQsObj.ImageSummary = siteComponentDQsObj.ImageSummary;
					masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
				}	
				#endregion
				UpdatePointsTagWise(siteComponentDQsObj,masterComponentDQsObj);
			}
			
			
			//Calculate the Percentage of Good
			htPercent = CalculatePercentageOfGood(masterComponentDQsObj);

			masterComponentDQsObj.Percent = htPercent;
			
			//Get the DQ of the Master Component Type
			return masterComponentDQsObj;
		}

        public static void PopulateLevelAndChildLevelIDs(List<string> levelIDs, string sLevelID, LRRLevelLinks levelLinks)
        {
            levelIDs.Add(sLevelID);
            foreach (LRRLevelLink levelLink in levelLinks)
            {
                if (levelLink.ParentID == sLevelID)
                {
                    PopulateLevelAndChildLevelIDs(levelIDs,levelLink.ChildID,levelLinks);
                    
                }
            }
        }

        public static DQDetails InterpretLevelDQWithTag(string sLevelID)
        {
            LRRLevel level = LRRModel.ChildModel.Levels.getLevelByLevelID(sLevelID);
            List<string> levelIDs = new List<string>();
            LRRLevelLinks levelLinks = new LRRLevelLinks();
            _lrrApp.DBManagerObj.PopulateCollection(levelLinks);
            PopulateLevelAndChildLevelIDs(levelIDs, sLevelID, levelLinks);

            Hashtable htPercent = new Hashtable();
            Hashtable htImageSummary = new Hashtable();

            DQDetails levelDQsObj = new DQDetails();
            DQDetails siteComponentDQsObj = new DQDetails();
            levelDQsObj.ImageSummary = ImageToApply.NONE;
            LRRSiteComponents objSiteComponents = LRRModel.SiteComponentsObj;

            foreach (LRRSiteComponent objSiteComponent in objSiteComponents)
            {
                string sCompLevel = objSiteComponent.PlantUnit == null ? "" : objSiteComponent.PlantUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                if (levelIDs.Contains(sCompLevel))
                {
                    string sSiteComponentID = objSiteComponent.SiteComponentID == null ? "" : objSiteComponent.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    siteComponentDQsObj = InterpretSiteComponentDQWithTag(sSiteComponentID);
                    #region Calculate Image Summary
                    if ((siteComponentDQsObj.ImageSummary == ImageToApply.VERYHIGH))
                    {
                        levelDQsObj.ImageSummary = siteComponentDQsObj.ImageSummary;
                        levelDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
                    }
                    if ((levelDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary == ImageToApply.HIGH))
                    {
                        levelDQsObj.ImageSummary = ImageToApply.HIGH;
                        levelDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
                    }
                    if ((levelDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (levelDQsObj.ImageSummary != ImageToApply.HIGH) && (siteComponentDQsObj.ImageSummary == ImageToApply.AVG))
                    {
                        levelDQsObj.ImageSummary = ImageToApply.AVG;
                        levelDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
                    }
                    if ((levelDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (levelDQsObj.ImageSummary != ImageToApply.HIGH) && (levelDQsObj.ImageSummary != ImageToApply.AVG) && (siteComponentDQsObj.ImageSummary == ImageToApply.LOW))
                    {
                        levelDQsObj.ImageSummary = ImageToApply.LOW;
                        levelDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
                    }
                    if ((levelDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (levelDQsObj.ImageSummary != ImageToApply.HIGH) && (levelDQsObj.ImageSummary != ImageToApply.AVG) && (levelDQsObj.ImageSummary != ImageToApply.LOW) && (siteComponentDQsObj.ImageSummary == ImageToApply.GOOD))
                    {
                        levelDQsObj.ImageSummary = siteComponentDQsObj.ImageSummary;
                        levelDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
                    }

                    #endregion
                    UpdatePointsTagWise(siteComponentDQsObj, levelDQsObj);
                }
            }

            //Calculate the Percentage of Good
            htPercent = CalculatePercentageOfGood(levelDQsObj);

            levelDQsObj.Percent = htPercent;


            //Get the DQ of the Master Component Type
            return levelDQsObj;
        }
		
		public static DQDetails InterpretMasterComponentDQWithTag(string sMasterComponentTypeID,string sLevelID)
		{
			Hashtable htPercent = new Hashtable();
			Hashtable htImageSummary = new Hashtable();
			
			DQDetails masterComponentDQsObj = new DQDetails();
			DQDetails siteComponentDQsObj = new DQDetails();
			masterComponentDQsObj.ImageSummary = ImageToApply.NONE;
			LRRSiteComponents objSiteComponents = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(sMasterComponentTypeID);
			
			foreach(LRRSiteComponent objSiteComponent in objSiteComponents)
			{
				string sCompLevel = objSiteComponent.PlantUnit == null ? "" : objSiteComponent.PlantUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(sLevelID == sCompLevel)
				{
					string sSiteComponentID = objSiteComponent.SiteComponentID == null ? "" : objSiteComponent.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					siteComponentDQsObj = InterpretSiteComponentDQWithTag(sSiteComponentID);
					#region Calculate Image Summary
					if((siteComponentDQsObj.ImageSummary == ImageToApply.VERYHIGH) )
					{
						masterComponentDQsObj.ImageSummary = siteComponentDQsObj.ImageSummary;
						masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
					}
					if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (siteComponentDQsObj.ImageSummary == ImageToApply.HIGH))
					{
						masterComponentDQsObj.ImageSummary = ImageToApply.HIGH;
						masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
					}
					if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (siteComponentDQsObj.ImageSummary == ImageToApply.AVG))
					{
						masterComponentDQsObj.ImageSummary = ImageToApply.AVG;
						masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
					}
					if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.AVG) && (siteComponentDQsObj.ImageSummary == ImageToApply.LOW))
					{
						masterComponentDQsObj.ImageSummary = ImageToApply.LOW;
						masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
					}
					if((masterComponentDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.HIGH) && (masterComponentDQsObj.ImageSummary != ImageToApply.AVG) && (masterComponentDQsObj.ImageSummary != ImageToApply.LOW) && (siteComponentDQsObj.ImageSummary == ImageToApply.GOOD))
					{
						masterComponentDQsObj.ImageSummary = siteComponentDQsObj.ImageSummary;
						masterComponentDQsObj.ForeColor = siteComponentDQsObj.ForeColor;
					}
				
					#endregion
					UpdatePointsTagWise(siteComponentDQsObj,masterComponentDQsObj);
				}
				
			}
			
			//Calculate the Percentage of Good
			htPercent = CalculatePercentageOfGood(masterComponentDQsObj);

			masterComponentDQsObj.Percent = htPercent;

			
			//Get the DQ of the Master Component Type
			return masterComponentDQsObj;
		}


		public static DQDetails InterpretMasterComponentTypeDQWithTag(string sComponentTypeID)
		{
			DQDetails masterComponentTypeDQsObj = new DQDetails();
			DQDetails masterComponentDQsObj = new DQDetails();
			
			Hashtable htImageSummary = new Hashtable();
			Hashtable htPercent = new Hashtable();
			masterComponentTypeDQsObj.ImageSummary = ImageToApply.NONE;
			LRRMasterComponents objMCs = LRRModel.Model.FilterMasterComponentsByComponentTypeID(sComponentTypeID);
			
			foreach(LRRMasterComponent objMC in  objMCs)
			{
				string sMasterComponentTypeID = objMC.ID == null ? "" : objMC.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				masterComponentDQsObj = InterpretMasterComponentDQWithTag(sMasterComponentTypeID);
				#region Calculate Image Summary
				if((masterComponentDQsObj.ImageSummary == ImageToApply.VERYHIGH))
				{
					masterComponentTypeDQsObj.ImageSummary = masterComponentDQsObj.ImageSummary;
					masterComponentTypeDQsObj.ForeColor = masterComponentDQsObj.ForeColor;
				}
				if((masterComponentTypeDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentDQsObj.ImageSummary == ImageToApply.HIGH))
				{
					masterComponentTypeDQsObj.ImageSummary =  masterComponentDQsObj.ImageSummary;
					masterComponentTypeDQsObj.ForeColor = masterComponentDQsObj.ForeColor;
				}
				if((masterComponentTypeDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentTypeDQsObj.ImageSummary != ImageToApply.HIGH) && (masterComponentDQsObj.ImageSummary == ImageToApply.AVG))
				{
					masterComponentTypeDQsObj.ImageSummary =  masterComponentDQsObj.ImageSummary;
					masterComponentTypeDQsObj.ForeColor = masterComponentDQsObj.ForeColor;
				}
				if((masterComponentTypeDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentTypeDQsObj.ImageSummary != ImageToApply.HIGH) && (masterComponentTypeDQsObj.ImageSummary != ImageToApply.AVG) && (masterComponentDQsObj.ImageSummary == ImageToApply.LOW))
				{
					masterComponentTypeDQsObj.ImageSummary =  masterComponentDQsObj.ImageSummary;
					masterComponentTypeDQsObj.ForeColor = masterComponentDQsObj.ForeColor;
				}
				if((masterComponentTypeDQsObj.ImageSummary != ImageToApply.VERYHIGH) && (masterComponentTypeDQsObj.ImageSummary != ImageToApply.HIGH) && (masterComponentTypeDQsObj.ImageSummary != ImageToApply.AVG) && (masterComponentTypeDQsObj.ImageSummary != ImageToApply.LOW) && (masterComponentDQsObj.ImageSummary == ImageToApply.GOOD))
				{
					masterComponentTypeDQsObj.ImageSummary =  masterComponentDQsObj.ImageSummary;
					masterComponentTypeDQsObj.ForeColor = masterComponentDQsObj.ForeColor;
				}	
				#endregion
				UpdatePointsTagWise(masterComponentDQsObj,masterComponentTypeDQsObj);
				
			}
			
			//Calculate the Percentage of Good
			htPercent = CalculatePercentageOfGood(masterComponentTypeDQsObj);
			
			masterComponentTypeDQsObj.Percent = htPercent;

			
			//Get the DQ of the Master Component Type
			return masterComponentTypeDQsObj;
		}

		#endregion

		#region Private Static Methods
		private static void UpdatePointsTagWise(DQDetails ItemsDQsObj,DQDetails masterDQsObj)
		{
			DQDetail masterDQObj;
			
			if(ItemsDQsObj.Count>0)
			{
				masterDQObj = new DQDetail();
                Dictionary<string, int> htDQDetails = new Dictionary<string, int>();
				htDQDetails = ItemsDQsObj.GetDQDetails;

				masterDQObj.Type = ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(htDQDetails.ContainsKey(ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				{
					masterDQObj.GoodPoint = htDQDetails[ErrorCode.VERY_HIGH.ToString()].ToString();
					masterDQObj.Total = htDQDetails[ErrorCode.VERY_HIGH.ToString() + "TOTAL"].ToString();
				}
				else
				{
					masterDQObj.GoodPoint = "0";
					masterDQObj.Total = "0";
				
				}
				masterDQsObj.Add(masterDQObj);
					
				masterDQObj = new DQDetail();
				masterDQObj.Type = ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(htDQDetails.ContainsKey(ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				{
					masterDQObj.GoodPoint = htDQDetails[ErrorCode.HIGH.ToString()].ToString();
					masterDQObj.Total = htDQDetails[ErrorCode.HIGH.ToString() + "TOTAL"].ToString();
				}
				else
				{
					masterDQObj.GoodPoint = "0";
					masterDQObj.Total = "0";
				
				}
				masterDQsObj.Add(masterDQObj);
					
				masterDQObj = new DQDetail();
				masterDQObj.Type = ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(htDQDetails.ContainsKey(ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				{
					masterDQObj.GoodPoint = htDQDetails[ErrorCode.MEDIUM.ToString()].ToString();
					masterDQObj.Total = htDQDetails[ErrorCode.MEDIUM.ToString() + "TOTAL"].ToString();
				}
				else
				{
					masterDQObj.GoodPoint = "0";
					masterDQObj.Total = "0";
				
				}
				masterDQsObj.Add(masterDQObj);
					
				masterDQObj = new DQDetail();
				masterDQObj.Type = ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(htDQDetails.ContainsKey(ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				{	
					masterDQObj.GoodPoint = htDQDetails[ErrorCode.LOW.ToString()].ToString();
					masterDQObj.Total = htDQDetails[ErrorCode.LOW.ToString() + "TOTAL"].ToString();
				}
				else
				{
					masterDQObj.GoodPoint = "0";
					masterDQObj.Total = "0";
				
				}
				masterDQsObj.Add(masterDQObj);

			}

//			masterDQsObj.ImageSummary = ItemsDQsObj.ImageSummary;
//			CalculateImageSummary(ItemsDQsObj,htImageSummary);
			
		}

		
		private static void CalculateImageSummary(DQDetails ItemsDQsObj,Hashtable htImageSummary)
		{
			bool bBadPoint_VERY_HIGH = false;
			bool bBadPoint_HIGH = false;
			bool bBadPoint_MEDIUM = false;
			bool bBadPoint_LOW = false;
			
			
			switch(ItemsDQsObj.ImageSummary)
			{
				case ImageToApply.VERYHIGH:
					bBadPoint_VERY_HIGH = true;
					break;
				case ImageToApply.HIGH:
					bBadPoint_HIGH = true;
					break;
				case ImageToApply.AVG:
					bBadPoint_MEDIUM = true;
					break;
				case ImageToApply.LOW:
					bBadPoint_LOW = true;
					break;
			}
			
			if(!htImageSummary.Contains(ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				htImageSummary.Add(ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture),bBadPoint_VERY_HIGH);
			else if ((htImageSummary[ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString().ToUpper() == "FALSE") && (bBadPoint_VERY_HIGH))
			{
				htImageSummary[ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)]	= bBadPoint_VERY_HIGH;
			}
			
			if(!htImageSummary.Contains(ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				htImageSummary.Add(ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture),bBadPoint_VERY_HIGH);
			else if ((htImageSummary[ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString().ToUpper() == "FALSE") && (bBadPoint_HIGH))
			{
				htImageSummary[ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)]	= bBadPoint_HIGH;
			}
			
			if(!htImageSummary.Contains(ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				htImageSummary.Add(ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture),bBadPoint_MEDIUM);
			else if ((htImageSummary[ErrorCode.MEDIUM.ToString()].ToString().ToUpper() == "FALSE") && (bBadPoint_MEDIUM))
			{
				htImageSummary[ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)]	= bBadPoint_MEDIUM;
			}
			
			if(!htImageSummary.Contains(ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
				htImageSummary.Add(ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture),bBadPoint_LOW);
			else if ((htImageSummary[ErrorCode.LOW.ToString()].ToString().ToUpper() == "FALSE") && (bBadPoint_LOW))
			{
				htImageSummary[ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)]	= bBadPoint_LOW;
			}
		}

		
		private static Hashtable CalculatePercentageOfGood(DQDetails masterDQsObj)
		{
			Hashtable htPercent = new Hashtable();	
			double nVHPointCtr = 0;
			double nVHTotalPointCtr=0;
			double nHPointCtr = 0;
			double nHTotalPointCtr=0;
			double nMPointCtr = 0;
			double nMTotalPointCtr=0;
			double nLPointCtr = 0;
			double nLTotalPointCtr=0;
			double nResult=0;
			//Calculate the Percentage of Good
			foreach(DQDetail DQObj in masterDQsObj)
			{
				if(DQObj.Type == ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture))
				{
					nVHPointCtr = nVHPointCtr + double.Parse(DQObj.GoodPoint.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					nVHTotalPointCtr= nVHTotalPointCtr + double.Parse(DQObj.Total.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					
				}
				if(DQObj.Type == ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture))
				{
					nHPointCtr = nHPointCtr + double.Parse(DQObj.GoodPoint.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					nHTotalPointCtr= nHTotalPointCtr + double.Parse(DQObj.Total.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					nResult = (nHPointCtr/nHTotalPointCtr) * 100;
				}
				if(DQObj.Type == ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture))
				{
					nMPointCtr = nMPointCtr + double.Parse(DQObj.GoodPoint.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					nMTotalPointCtr= nMTotalPointCtr + double.Parse(DQObj.Total.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					nResult = (nMPointCtr/nMTotalPointCtr) * 100;
				}
				if(DQObj.Type == ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture))
				{
					nLPointCtr = nLPointCtr + double.Parse(DQObj.GoodPoint.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					nLTotalPointCtr= nLTotalPointCtr + double.Parse(DQObj.Total.ToString(Symcon.BusinessObjects.SymConverter.Culture),Symcon.BusinessObjects.SymConverter.Culture);
					nResult = (nLPointCtr/nLTotalPointCtr) * 100;
				}
			}
			
			nResult = (nVHPointCtr/nVHTotalPointCtr) * 100;
			if(double.IsNaN(nResult))
				htPercent.Add(ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture),"...");
			else
			{
				nResult = Math.Round(nResult,2);
				htPercent.Add(ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture),nResult);
			}

			nResult = (nHPointCtr/nHTotalPointCtr) * 100;
			if(double.IsNaN(nResult))
				htPercent.Add(ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture),"...");
			else
			{
				nResult = Math.Round(nResult,2);
				htPercent.Add(ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture),nResult);
			}

			nResult = (nMPointCtr/nMTotalPointCtr) * 100;
			if(double.IsNaN(nResult))
				htPercent.Add(ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture),"...");
			else
			{
				nResult = Math.Round(nResult,2);
				htPercent.Add(ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture),nResult);
			}

			nResult = (nLPointCtr/nLTotalPointCtr) * 100;
			if(double.IsNaN(nResult))
				htPercent.Add(ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture),"...");
			else
			{
				nResult = Math.Round(nResult,2);
				htPercent.Add(ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture),nResult);
			}
			return htPercent;
		}
		
		#endregion
		
		#region Fields

			private static LRRApp _lrrApp;
			private static ErrorCode ErrorCodeEnum = ErrorCode.NONE;
		#endregion
		
	}
}
