using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ChangeUOMSetDefinition.
	/// </summary>
	public class ChangeUOMSetDefinitionForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Button btnApply;
		private System.Windows.Forms.Panel pnlTop;
		private System.Windows.Forms.Splitter splitter1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUOMSetDefns;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ChangeUOMSetDefinitionForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			InitDataSource();
			BindGrid();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ChangeUOMSetDefinitionForm));
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnApply = new System.Windows.Forms.Button();
			this.pnlTop = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.gridUOMSetDefns = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlBottom.SuspendLayout();
			this.pnlTop.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridUOMSetDefns)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.btnApply);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 136);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(474, 40);
			this.pnlBottom.TabIndex = 1;
			// 
			// btnApply
			// 
			this.btnApply.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnApply.Location = new System.Drawing.Point(384, 8);
			this.btnApply.Name = "btnApply";
			this.btnApply.TabIndex = 0;
			this.btnApply.Tag = "SID_APPLY";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// pnlTop
			// 
			this.pnlTop.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlTop.Controls.Add(this.splitter1);
			this.pnlTop.Controls.Add(this.gridUOMSetDefns);
			this.pnlTop.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlTop.Location = new System.Drawing.Point(0, 0);
			this.pnlTop.Name = "pnlTop";
			this.pnlTop.Size = new System.Drawing.Size(474, 136);
			this.pnlTop.TabIndex = 2;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 131);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(472, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// gridUOMSetDefns
			// 
			this.gridUOMSetDefns.BackColor = System.Drawing.SystemColors.Window;
			this.gridUOMSetDefns.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUOMSetDefns.Location = new System.Drawing.Point(0, 0);
			this.gridUOMSetDefns.Name = "gridUOMSetDefns";
			this.gridUOMSetDefns.Size = new System.Drawing.Size(472, 134);
			this.gridUOMSetDefns.TabIndex = 0;
			this.gridUOMSetDefns.VersionInfo = "3.301.0.0";
			this.gridUOMSetDefns.TableControlCurrentCellChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridUOMSetDefns_TableControlCurrentCellChanged);
			// 
			// ChangeUOMSetDefinitionForm
			// 
			this.AcceptButton = this.btnApply;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(474, 176);
			this.Controls.Add(this.pnlTop);
			this.Controls.Add(this.pnlBottom);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "ChangeUOMSetDefinitionForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_UOM_SET_DEF";
			this.pnlBottom.ResumeLayout(false);
			this.pnlTop.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridUOMSetDefns)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Private Methods
		private void InitDataSource()
		{
			_lrrMeasSys = LRRModel.MeasurementSystems;
		}

		private void BindGrid()
		{
			SyncGridUtilities.InitializeGridColumns(gridUOMSetDefns,gridUOMSetDefns.TableDescriptor,_lrrMeasSys.ItemType,null,true,null,null,true);
			SyncGridUtilities.InitializeGridLookAndFeel(gridUOMSetDefns);
		
			gridUOMSetDefns.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_UOM_SET_SELECTION") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");
			this.gridUOMSetDefns.TableDescriptor.AllowNew = false;
			this.gridUOMSetDefns.TableDescriptor.AllowEdit = true;
			this.gridUOMSetDefns.TableDescriptor.AllowRemove = false;
			
			this.gridUOMSetDefns.TableDescriptor.Relations.Clear();
			gridUOMSetDefns.DataSource = null;	
			gridUOMSetDefns.DataSource = _lrrMeasSys;	

			_unBound.WireGrid(gridUOMSetDefns);
			
			gridUOMSetDefns.TableDescriptor.Columns.Remove("ModelUOM");
			gridUOMSetDefns.TableDescriptor.Columns.Remove("UIUOM");

			gridUOMSetDefns.TableDescriptor.Columns["Locale"].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridUOMSetDefns.TableDescriptor.Columns["Description"].Appearance.AnyRecordFieldCell.ReadOnly = true;
		}

		#endregion

		#region Fields
		private LRRMeasurementSystems _lrrMeasSys;
		private GridUnBoundColumn	_unBound=new GridUnBoundColumn();
		private string _measSysID;
		#endregion

		#region Properties
		public  string MeasSysID
		{
			get{return _measSysID;}
			set
			{
				_measSysID = value;
			}
		}
		#endregion
		
		#region Event Handlers
		private void btnApply_Click(object sender, System.EventArgs e)
		{
			object[] selectedRecords = _unBound.GetSelectedRecords();
			if(selectedRecords.Length > 0)
			{
				LRRMeasurementSystem lrrMeasSys = selectedRecords[0] as LRRMeasurementSystem;
				if(lrrMeasSys != null)
					this.MeasSysID = lrrMeasSys.ID;
			}

		}

		private void gridUOMSetDefns_TableControlCurrentCellChanged(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{
			LRRMeasurementSystem lrrMeasSys = e.TableControl.Table.CurrentRecord.GetData() as LRRMeasurementSystem;
			object[] objMeasSys = _unBound.GetSelectedRecords();
			for(int i= 0; i < objMeasSys.Length;i++)
			{
				LRRMeasurementSystem objMeasSystem = objMeasSys[i] as LRRMeasurementSystem;
				if(objMeasSystem.ID != lrrMeasSys.ID)
				{
					_unBound.SetRecord(objMeasSystem,false);
					gridUOMSetDefns.Refresh();
				}
			}
		}
		#endregion

	}
}
