using System;


namespace Symcon.LightRidge.PEAdvisor.CommonViews
{
	/// <summary>
	/// Summary description for ColorEventArgs.
	/// </summary>
	public class ColorEventArgs : EventArgs
	{
		public ColorEventArgs()
		{

		}

		#region Fields
		private int _row;
		private int _col;
		private object _propValueObj;
		private bool   _isRecordedValue;	
		#endregion

		#region Properties
        /// <summary>
        /// Gets or sets the row.
        /// </summary>
        /// <value>The row.</value>
		public int Row
		{
			get{return _row;}
			set
			{
				_row = value;
			}
		}

        /// <summary>
        /// Gets or sets the col.
        /// </summary>
        /// <value>The col.</value>
		public int Col
		{
			get{return _col;}
			set
			{
				_col = value;
			}
		}

        /// <summary>
        /// Gets or sets the prop value obj.
        /// </summary>
        /// <value>The prop value obj.</value>
		public object PropValueObj
		{
			get{return _propValueObj;}
			set
			{
				_propValueObj = value;
			}
		}
        /// <summary>
        /// Gets or sets a value indicating whether this instance is recorded value.
        /// </summary>
        /// <value>
        /// 	<c>true</c> if this instance is recorded value; otherwise, <c>false</c>.
        /// </value>
		public bool IsRecordedValue
		{
			get{return _isRecordedValue;}
			set
			{
				_isRecordedValue = value;
			}
		}
		#endregion
	}
}
