using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

using Symcon.LightRidge.Options.DBOptions;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for DBInfoForm.
	/// </summary>
	public class DBInfoForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TabControl tabControlDBInfo;
		private System.Windows.Forms.TabPage tabPageTuning;
		private System.Windows.Forms.TabPage tabPageOffline;
		private System.Windows.Forms.TabPage tabPageRecording;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnApply;
		
		private LRRApp _lrrApp;
		

		public DBInfoForm()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			
			DataBaseConnectionInfosUserControl dbUserControl1 = new DataBaseConnectionInfosUserControl();
			dbUserControl1.CustCollection = _lrrApp.GetOptions().TuningConnectionObj;
			dbUserControl1.BindGrid();
			tabPageTuning.Controls.Add(dbUserControl1);

			
			DataBaseConnectionInfosUserControl dbUserControl2 = new DataBaseConnectionInfosUserControl();
			dbUserControl2.CustCollection = _lrrApp.GetOptions().OfflineConnectionObj;
			dbUserControl2.BindGrid();
			tabPageOffline.Controls.Add(dbUserControl2);
			
			DataBaseConnectionInfosUserControl dbUserControl3 = new DataBaseConnectionInfosUserControl();
			dbUserControl3.CustCollection = _lrrApp.GetOptions().RecordingValuesConnectionObj;
			dbUserControl3.BindGrid();
			tabPageRecording.Controls.Add(dbUserControl3);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DBInfoForm));
			this.tabControlDBInfo = new System.Windows.Forms.TabControl();
			this.tabPageTuning = new System.Windows.Forms.TabPage();
			this.tabPageOffline = new System.Windows.Forms.TabPage();
			this.tabPageRecording = new System.Windows.Forms.TabPage();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnApply = new System.Windows.Forms.Button();
			this.tabControlDBInfo.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControlDBInfo
			// 
			this.tabControlDBInfo.Controls.Add(this.tabPageTuning);
			this.tabControlDBInfo.Controls.Add(this.tabPageOffline);
			this.tabControlDBInfo.Controls.Add(this.tabPageRecording);
			this.tabControlDBInfo.Location = new System.Drawing.Point(0, 0);
			this.tabControlDBInfo.Name = "tabControlDBInfo";
			this.tabControlDBInfo.SelectedIndex = 0;
			this.tabControlDBInfo.Size = new System.Drawing.Size(600, 408);
			this.tabControlDBInfo.TabIndex = 0;
			// 
			// tabPageTuning
			// 
			this.tabPageTuning.Location = new System.Drawing.Point(4, 22);
			this.tabPageTuning.Name = "tabPageTuning";
			this.tabPageTuning.Size = new System.Drawing.Size(592, 382);
			this.tabPageTuning.TabIndex = 0;
			this.tabPageTuning.Tag = "SID_TUNINGDB";
			// 
			// tabPageOffline
			// 
			this.tabPageOffline.Location = new System.Drawing.Point(4, 22);
			this.tabPageOffline.Name = "tabPageOffline";
			this.tabPageOffline.Size = new System.Drawing.Size(592, 502);
			this.tabPageOffline.TabIndex = 1;
			this.tabPageOffline.Tag = "SID_OFFLINE_DBS";
			// 
			// tabPageRecording
			// 
			this.tabPageRecording.Location = new System.Drawing.Point(4, 22);
			this.tabPageRecording.Name = "tabPageRecording";
			this.tabPageRecording.Size = new System.Drawing.Size(592, 502);
			this.tabPageRecording.TabIndex = 2;
			this.tabPageRecording.Tag = "SID_RECORDING";
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(440, 416);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 1;
			this.btnOK.Tag = "SID_OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(520, 416);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// btnApply
			// 
			this.btnApply.Location = new System.Drawing.Point(360, 416);
			this.btnApply.Name = "btnApply";
			this.btnApply.TabIndex = 3;
			this.btnApply.Tag = "SID_APPLY";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// DBInfoForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(602, 448);
			this.Controls.Add(this.btnApply);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.tabControlDBInfo);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "DBInfoForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_DB_INFO";
			this.tabControlDBInfo.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			for(int i=0;i < this.tabControlDBInfo.TabCount;i++)
			{
				TabPage currentTab = this.tabControlDBInfo.Controls[i] as TabPage;
				DataBaseConnectionInfosUserControl dbUserControl = currentTab.Controls[0] as DataBaseConnectionInfosUserControl;
				dbUserControl.Save();
			}
			_lrrApp.RunControllerObj.Initialize();
			
		}

		private void btnApply_Click(object sender, System.EventArgs e)
		{
			TabPage currentTab = this.tabControlDBInfo.SelectedTab;
			DataBaseConnectionInfosUserControl dbUserControl = currentTab.Controls[0] as DataBaseConnectionInfosUserControl;
			dbUserControl.Save();
			_lrrApp.RunControllerObj.Initialize();
		}

	}
}
