using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using Symcon.LightRidge.DashBoardControlsLibrary;
using Symcon.LightRidge.DashBoardControlsLibrary.Controls;

namespace Symcon.LightRidge.PEAdvisor.DashBoard
{
    public partial class ControlPropertyForm : Form
    {
        public ControlPropertyForm()
        {
            InitializeComponent();
            InternationalizationUtils.GetControlText(this, null);
        }

        #region Fields/Properties
        private Cell _cell;
        public Cell CellControl
        {
            get { return _cell; }
            set
            {
                _cell = value;
            }

        }

        private IDashBoardControl _iDashBoardCtrl;
        public IDashBoardControl IDashBoardCtrl
        {
            get { return _iDashBoardCtrl; }
            set { _iDashBoardCtrl = value; }
        }

        #endregion

        #region Methods
        public void BindControl()
        {
            ControlProperties ctrlProps = new ControlProperties();
            ctrlProps.MaxValue = this._cell.MaxLimit;
            ctrlProps.MinValue = this._cell.MinLimit;
            ctrlProps.Height = this._cell.Height;
            ctrlProps.Width = this._cell.Width;

            ctrlProps.Mode = this._cell.BindInfo.ModeName;
            ctrlProps.SourceItem = this._cell.BindInfo.SiteComponentName;
            ctrlProps.AttributeName = this._cell.BindInfo.SiteComponentProperty;

            //this.propertyGrid.SelectedObject = ctrlProps;
            _iDashBoardCtrl.SetPropertyTable();
            this.propertyGrid.SelectedObject = _iDashBoardCtrl.PT;
        }

        #endregion

        #region Event Handlers
        private void btnOk_Click(object sender, EventArgs e)
        {
            /*
            ControlProperties ctrlProps = this.propertyGrid.SelectedObject as ControlProperties;
            this._cell.MaxLimit = ctrlProps.MaxValue;
            this._cell.MinLimit = ctrlProps.MinValue;
            this._cell.Width = ctrlProps.Width;
            this._cell.Height = ctrlProps.Height;

            if( ctrlProps.SourceItem != null &&  ctrlProps.SourceItem.Trim() != "")
                this._cell.BindInfo.SiteComponentName = ctrlProps.SourceItem;
            if (ctrlProps.AttributeName != null && ctrlProps.AttributeName.Trim() != "")
                this._cell.BindInfo.SiteComponentProperty = ctrlProps.AttributeName;
            if (ctrlProps.Mode != null && ctrlProps.Mode.Trim() != "")
                this._cell.BindInfo.ModeName = ctrlProps.Mode;*/

            
        }
        #endregion

        #region Events
        public delegate void ControlPropertiesDel(object sender, ControlPropertiesEventArgs e);
        public event ControlPropertiesDel ControlPropertiesChanged;
        #endregion

        private void ControlPropertyForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            ControlProperties ctrlProps = new ControlProperties();
            ctrlProps.Width = this._iDashBoardCtrl.GetControlWidth();
            ctrlProps.Height = this._iDashBoardCtrl.GetControlHeight();

            ControlPropertiesEventArgs ctrlPropEventArgs = new ControlPropertiesEventArgs();
            ctrlPropEventArgs.CtrlProperties = ctrlProps;
            if (ControlPropertiesChanged != null)
                ControlPropertiesChanged(this, ctrlPropEventArgs);
        }

    }
}