using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Symcon.LightRidge.PEAdvisor.DashBoard
{
    public partial class DBPreviewScreenUC : UserControl
    {
        public DBPreviewScreenUC()
        {
            InitializeComponent();
        }

        public DBPreviewScreenUC(XmlDashBoard xmlDashBoard)
        {
            InitializeComponent();
            this.DashBoardXML = xmlDashBoard;
            CreateDashBoard();
        }

        #region Methods
        public void CreateDashBoard()
        {
            TableLayoutPanel tableLayoutPanel = DashBoardCreatorFactory.CreateDashBoard(this.DashBoardXML);
            tableLayoutPanel.AutoScroll = true;
            this.bottomPanel.Controls.Clear();
            this.bottomPanel.Controls.Add(tableLayoutPanel);
            tableLayoutPanel.Dock = DockStyle.Fill;
            //TableLookAndFeel(tableLayoutPanel, this.DashBoardXML.Rows, this.DashBoardXML.Cols);
        }

        private void TableLookAndFeel(TableLayoutPanel tableLayoutPanel, int iRows, int iCols)
        {
            TableLayoutRowStyleCollection rowStyles = tableLayoutPanel.RowStyles;
            int rowHeight = 100 / iRows;
            foreach (RowStyle style in rowStyles)
            {
                style.SizeType = SizeType.AutoSize;
                style.Height = rowHeight;
            }

            TableLayoutColumnStyleCollection colStyles = tableLayoutPanel.ColumnStyles;
            int colHeight = 100 / iCols;
            foreach (ColumnStyle style in colStyles)
            {
                style.SizeType = SizeType.AutoSize;
                style.Width = colHeight;
            }
        }
        #endregion

        #region Fields/Properties
        private XmlDashBoard _xmlDashBoard = new XmlDashBoard();
        public XmlDashBoard DashBoardXML
        {
            get { return _xmlDashBoard; }
            set { _xmlDashBoard = value; }
        }
        #endregion


    }
}
