using System;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageDispatcher;

namespace Symcon.LightRidge.PEAdvisor.DashBoard
{
    public partial class WizardMainFrame : Form
    {
        public WizardMainFrame()
        {
            InitializeComponent();
            InternationalizationUtils.GetControlText(this, null);
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            _userControlHashMap = new Hashtable();
            _xmlDashBoard = new XmlDashBoard();
            DBWelcomeScreenUC dbWelcomeScreenUC = new DBWelcomeScreenUC();
           // DBScreen1UC dbScreen1UC = new DBScreen1UC();
            DBScreen2UC dbScreen2UC = new DBScreen2UC();
            DBPreviewScreenUC dbPreviewScreenUC = new DBPreviewScreenUC();
            DBFinishScreenUC dbFinishScreenUC = new DBFinishScreenUC();
            DBLoadExistingUC dbLoadExistingUC = new DBLoadExistingUC();
            DBLayoutUC dbLayoutUC = new DBLayoutUC();
            arrayUC = new UserControl[] { dbWelcomeScreenUC,/*dbScreen1UC,*/ dbScreen2UC, dbLayoutUC, dbPreviewScreenUC, dbFinishScreenUC };
            _treeNodeUC = new ArrayList();
            InitializeTree(arrayUC);
        }

        #region fields

        //---enabling and disabling the buttons
        private bool cancelEnabled;
        private bool backEnabled;
        private bool nextEnabled;
        private System.Windows.Forms.UserControl _activeUserControl;
        private Hashtable _userControlHashMap = null;
        private string _activeID;
        private ArrayList _treeNodeUC;

        //Usercontrols 



        //--set the next and back panel
        private UserControl nextUC;
        private UserControl backUC;
        private UserControl presentUC;
        //
        private UserControl[] arrayUC;

        private XmlDashBoard _xmlDashBoard;

        private LRRApp _lrrApp;

        private bool _createFlag=false;

        #endregion 

        #region Methods
        /// <summary>
        /// This method is used to set the buttons & panels
        /// </summary>
        /// 
        private void RefreshView()
        {
           
            if (cancelEnabled)
                btnCancel.Enabled = true;
            else
                btnCancel.Enabled = false;
            if (backEnabled)
                btnBack.Enabled = true;
            else
                btnBack.Enabled = false;
            if (nextEnabled)
                btnNext.Enabled = true;
            else
                btnNext.Enabled = false;

            if (presentUC != null)
            {
                
                presentUC.Show();
                presentUC.Visible = true;
                presentUC.Dock = DockStyle.Fill;
                presentUC.BringToFront();
                int pos = GetPositionOfThePresentUC(presentUC);
                ActivateControl(pos.ToString());
            }
        }

        /// <summary>
        /// return the position of the presentUC in the UsercontrolArrays
        /// </summary>
        /// <param name="p">pass the present UC  to get the position</param>
        /// <returns></returns>
        private int GetPositionOfThePresentUC(UserControl p)
        {
            int result = -1;
            for (int i = 0; i < arrayUC.Length; i++)
            {
                if (arrayUC[i] == p)
                {
                    result = i;
                    break;
                }
            }
            return result;
        }

        /// <summary>
        /// this method is used to set the properties for UC & buttons according to the PresentUC 
        /// </summary>
        /// <param name="presentUCPosition">pass the present UC position</param>
        private void SetPropertyForBtnAndUCs(int presentUCPosition)
        {
            int ucLength = arrayUC.Length - 1;
            if (presentUCPosition == 0)//this is the first Screen
            {
                cancelEnabled = true;
                backEnabled = false;
                nextEnabled = true;
                presentUC = arrayUC[presentUCPosition];
                nextUC = arrayUC[presentUCPosition + 1];
                backUC = null;
            }
            else if (presentUCPosition == ucLength)//this is the last Screem
            {
                cancelEnabled = true;
                backEnabled = true;
                nextEnabled = true;
                presentUC = arrayUC[presentUCPosition];
                nextUC = null;
                backUC = arrayUC[presentUCPosition - 1];
            }
            else
            {
                cancelEnabled = true;
                backEnabled = true;
                nextEnabled = true; ;
                presentUC = arrayUC[presentUCPosition];
                nextUC = arrayUC[presentUCPosition + 1];
                backUC = arrayUC[presentUCPosition - 1];
            }
        }

        #endregion

        private void WizardMainFrame_Load(object sender, EventArgs e)
        {
            //foreach (Control ct in this.Controls)
            //{
            //    if (ct.GetType().Name == "Panel")
            //    {
            //        if (ct.Name != "pnlButtons")
            //        {
            //            ct.Visible = false;
            //        }
            //    }
            //}
            presentUC = arrayUC[0];
            int pos = GetPositionOfThePresentUC(presentUC);
            SetPropertyForBtnAndUCs(pos);
            RefreshView();

        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            foreach (TreeNode tn in _treeNodeUC)
            {
                if (tn.Text == backUC.AccessibleName)
                {
                    tn.ImageIndex = 1;
                    
                }
                else
                {
                    tn.ImageIndex = 0;
                }
            }
            if (btnNext.Text != LRRHeaderText.GetHeaderString("SID_NEXT"))
                btnNext.Text = LRRHeaderText.GetHeaderString("SID_NEXT");
            int pos = GetPositionOfThePresentUC(presentUC);
            presentUC = arrayUC[pos - 1];
            SetPropertyForBtnAndUCs(GetPositionOfThePresentUC(presentUC));
            RefreshView();
            nextUC.Visible = false;

        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            //display the 
            foreach (TreeNode tn in _treeNodeUC)
            {
                if (tn.Text == presentUC.AccessibleName)
                {
                    tn.ImageIndex = 1;
                    
                }
                else
                {
                    tn.ImageIndex = 0;
                }
            }
            if (presentUC.Name == "DBWelcomeScreenUC")
            {
                int pos = GetPositionOfThePresentUC(presentUC);
                DBWelcomeScreenUC dbwelcome = GetUserControl(pos.ToString()) as DBWelcomeScreenUC;
                _createFlag = dbwelcome.CreateNew;
                if (!_createFlag)
                {
                    DashBoardTemplateSetting dbSetting = dbwelcome.DBoardTemplateSetting;

                    LRRDashBoardSetting lrrDashBoardSetting = new LRRDashBoardSetting();
                    _lrrApp.DBManagerObj.PopulateObject(lrrDashBoardSetting, typeof(LRRDashBoardSetting), " where ID = '" + dbSetting.ID + "'");

                    if (lrrDashBoardSetting.SettingsXml != null)
                    {
                        MemoryStream memoryStream = new MemoryStream(lrrDashBoardSetting.SettingsXml);
                        XmlSerializer xs = new XmlSerializer(typeof(XmlDashBoard));
                        _xmlDashBoard = xs.Deserialize(memoryStream) as XmlDashBoard;
                        memoryStream.Close();
                    }
                }
                else
                {
                    this._xmlDashBoard = new XmlDashBoard();
                }
            }
           
            if (presentUC.Name == "DBPreviewScreenUC")
            {
                btnNext.Text = LRRHeaderText.GetHeaderString("SID_FINISH");
                int pos = GetPositionOfThePresentUC(presentUC) + 1;
                presentUC = arrayUC[pos];
                SetPropertyForBtnAndUCs(pos);
                RefreshView();
            }
            else if (presentUC.Name == "DBFinishScreenUC")
            {
                LRRDashBoardSetting dashBoardSetting1 = new LRRDashBoardSetting();
                if (!_createFlag)
                {
                    LRRDashBoardSetting lrrDashBoardSetting = new LRRDashBoardSetting();
                    _lrrApp.DBManagerObj.PopulateObject(lrrDashBoardSetting, typeof(LRRDashBoardSetting), " where Name = '" + _xmlDashBoard.Name + "'");

                    dashBoardSetting1.ID = lrrDashBoardSetting.ID;
                    lrrDashBoardSetting.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                    _lrrApp.DBManagerObj.CommitObject(lrrDashBoardSetting);
                }

                dashBoardSetting1.Name = _xmlDashBoard.Name;

                MemoryStream memoryStream = new MemoryStream();
                XmlSerializer xs = new XmlSerializer(typeof(XmlDashBoard));
                XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.Unicode);
                xs.Serialize(xmlTextWriter, _xmlDashBoard);
                memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
                byte[] buffer = memoryStream.ToArray();
                dashBoardSetting1.SettingsXml = buffer;
                _lrrApp.DBManagerObj.CommitObject(dashBoardSetting1);


                //MessageBox.Show("Configuration Completed");

                ArrayList arrParams = new ArrayList();
				arrParams.Add(this._xmlDashBoard);
				_lrrApp.LRRUIManagerObj.ShowWindow(600,arrParams,this._xmlDashBoard.Name,true);

                this.Close();
            }
            else if (presentUC.Name == "DBScreen2UC")
            {
                int pos = GetPositionOfThePresentUC(presentUC) + 1;
                if (this._xmlDashBoard.Rows == 0 || this._xmlDashBoard.Cols == 0)
                {
                    //MessageBox.Show("No. of Rows or Columns cannot be zero.");
                    LRRMessagBox.ShowMessage("SID_ROWS_COLS_CHECK");
                    pos = pos - 1;
                }
                presentUC = arrayUC[pos];
                SetPropertyForBtnAndUCs(pos);
                RefreshView();
            } 
            else
            {
                int pos = GetPositionOfThePresentUC(presentUC) + 1;
                presentUC = arrayUC[pos];
                SetPropertyForBtnAndUCs(pos);
                RefreshView();
            } 
       

         
        }

        private void InitializeTree(UserControl[] arrayUC)
        {

            TreeNode root = new TreeNode(LRRHeaderText.GetHeaderString("SID_START"));
            foreach (UserControl uc in arrayUC)
            {
                TreeNode ucTypeNode = new TreeNode(uc.AccessibleName);
               // ucTypeNode.ImageIndex = 0;
                root.Nodes.Add(ucTypeNode);
                _treeNodeUC.Add(ucTypeNode);

            }
            
            trvUserControls.Nodes.Add(root);
            trvUserControls.ExpandAll();
        }
        public UserControl ActivePane
        {
            get
            {
                return _activeUserControl;
            }
            set
            {
                this.pnlContainer.Controls.Clear();
                _activeUserControl = value;
                if (value != null)
                    this.pnlContainer.Controls.Add(_activeUserControl);
            }
        }

        public UserControl GetUserControl(string identifier)
        {
            if (_userControlHashMap != null)
            {
                if (_userControlHashMap.ContainsKey(identifier))
                    return (UserControl)_userControlHashMap[identifier];
            }
            return null;

        }

        public void AddUserControl(UserControl ctl, int identifier)
        {
            if (_userControlHashMap != null)
            {
                if (!_userControlHashMap.ContainsKey(identifier))
                    _userControlHashMap.Add(identifier, ctl);
            }

        }

        // public void ActivateControl(string id, ListView lstView)
        public void ActivateControl(string id)
        {
            _activeID = id;
            if (_userControlHashMap != null)
            {
                pnlContainer.BringToFront();
                if (_userControlHashMap.ContainsKey(id))
                {
                    //UserControl cont = (UserControl)_userControlHashMap[id];
                    switch (id)
                    {
                        case "0":
                            DBWelcomeScreenUC dbWel = _userControlHashMap[id] as DBWelcomeScreenUC;
                            dbWel.DashBoardXML = this._xmlDashBoard;
                            dbWel.BringToFront();
                            break;
                        /* case "1":
                             uc = new DBScreen1UC(_xmlDashBoard);
                             break;*/
                        case "1":
                            DBScreen2UC dbScreen2UC = _userControlHashMap[id] as DBScreen2UC;
                            dbScreen2UC.DashBoardXML = this._xmlDashBoard;
                            dbScreen2UC.BindControls();
                            dbScreen2UC.BringToFront();
                            break;
                        case "2":
                            DBLayoutUC dbLayoutUC = _userControlHashMap[id] as DBLayoutUC;
                            dbLayoutUC.DashBoardXML = this._xmlDashBoard;
                            dbLayoutUC.CreateLayoutPanel();
                            dbLayoutUC.BringToFront();
                            break;
                        case "3":
                            DBPreviewScreenUC dbPreviewUC = _userControlHashMap[id] as DBPreviewScreenUC;
                            dbPreviewUC.DashBoardXML = this._xmlDashBoard;
                            dbPreviewUC.CreateDashBoard();
                            dbPreviewUC.BringToFront();
                            break;
                        case "4":
                            DBFinishScreenUC dbFinishUC = _userControlHashMap[id] as DBFinishScreenUC;
                            dbFinishUC.DashBoardXML = this._xmlDashBoard;
                            dbFinishUC.BringToFront();
                            break;
                        case "5":
                            DBLoadExistingUC dbLoadExistingUC = _userControlHashMap[id] as DBLoadExistingUC;
                            dbLoadExistingUC.DashBoardXML = this._xmlDashBoard;
                            dbLoadExistingUC.BringToFront();
                            break;

                        default:
                            break;

                    }
                    //cont.BringToFront();
                }
                else
                {
                    try
                    {
                        UserControl cont = CreateUserControl(id);
                        _userControlHashMap.Add(id, cont);
                        pnlContainer.Controls.Add(cont);
                        cont.BringToFront();
                    }
                    catch (Exception ex)
                    {
                        string hh = ex.ToString();
                    }
                }

            }
            else
            {
                pnlContainer.BringToFront();
            }
        }


        public UserControl CreateUserControl(string id)
        {
            UserControl uc = null;
            try
            {

                switch (id)
                {
                    case "0":
                        uc = new DBWelcomeScreenUC(_xmlDashBoard);
                        break;
                   /* case "1":
                        uc = new DBScreen1UC(_xmlDashBoard);
                        break;*/

                    case "1":
                        uc = new DBScreen2UC(_xmlDashBoard);
                        break;
                    case "2":
                        uc = new DBLayoutUC(_xmlDashBoard);
                        break;
                    case "3":
                        uc = new DBPreviewScreenUC(_xmlDashBoard);
                        break;
                    case "4":
                        uc = new DBFinishScreenUC(_xmlDashBoard);
                        break;
                     case "5":
                         uc = new DBLoadExistingUC(_xmlDashBoard);
                    break;
                        
                    default:
                        break;

                }
                uc.Dock = DockStyle.Fill;
                return uc;
            }
            catch (Exception ex)
            {
                string hh = ex.ToString();
                return uc;
            }
        }

        
    }
}