using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.MessageService;
using Symcon.Utils.HeaderDispatcher;
using Symcon.LightRidge.BusinessObjects.TypeEditors;


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for OptionalInput.
	/// </summary>
	public class DataHistorianPoints : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.Panel pnlHistorianData;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridHistorianData;
		private System.Windows.Forms.ContextMenu gridContext;

		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private System.Windows.Forms.RadioButton rdDefaultToInterfaceUOM;
		private System.Windows.Forms.RadioButton rdDefaultToModelUOM;
		private System.Windows.Forms.GroupBox groupBoxUOMs;
		private System.Windows.Forms.ToolTip toolTip2;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.Panel panel1;
        private Button btnTransPosedView;
        private Button btnCheckValidation;
		private System.ComponentModel.IContainer components;
	
		[DllImport("User32")] 
 
		private static extern bool SendMessage(IntPtr hWnd, int msg, int wParam, int lParam); 
		private const int WM_SETREDRAW = 0xB; 
		private	GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		private DuplicateValidation _duplicateChk = new DuplicateValidation();
        private LRRUOMs histUoms = new LRRUOMs();
        private LRRUOMs interFaceUoms = new LRRUOMs();
        private LRRUOMs modelUoms = new LRRUOMs();
		public DataHistorianPoints()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Get the App Object
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			//_lrrHistData = _app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRHistDatas)) as LRRHistDatas;
			//Populate HistData from Model
			_lrrHistData = LRRModel.HistDatas;

			//_lrrHistData = new LRRHistDatas();

            foreach (LRRHistData histData in _lrrHistData)
            {
                _arrHistTags.Add(histData.HistTag);
                if (histData.InterfaceUnits != "" && histData.InterfaceUnits != null)
                {
                    LRRUOM interfaceUom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(histData.InterfaceUnits);
                    if (interfaceUom != null)
                    {
                        if(!interFaceUoms.Contains(interfaceUom))
                            interFaceUoms.Add(interfaceUom);
                    }
                }
                if (histData.ModelUOM != "" && histData.ModelUOM != null)
                {
                    LRRUOM modelUom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(histData.ModelUOM);
                    if (modelUom != null)
                    {
                        if (!modelUoms.Contains(modelUom))
                            modelUoms.Add(modelUom);
                    }
                }
                if (histData.HistUnits != "" && histData.HistUnits != null)
                {
                    LRRUOM histUom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(histData.HistUnits);
                    if (histUom != null)
                    {
                        if (!histUoms.Contains(histUom))
                           histUoms.Add(histUom);
                    }
                }
                
            }
			
			lrrFormulaHistData.Add(0,_lrrHistData);
			lrrFormulaHistData.Add(1,"Historian Data");
			LRRFormulaDataStore.DataSource = lrrFormulaHistData;
			LRRFormulaDataStore.ModeFlag = false;
			LRRFormulaDataStore.ShowGroupedAttributes = false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;
			_gridExcelFormatter.WireGrid(gridHistorianData);
			_duplicateChk.ChkDuplicate(gridHistorianData,"HistTagUID",null,"HistTag",null,null);  
			InitializeGridWithData();	
			InitDataSource();


			this.Activated+=new EventHandler(DataHistorianPoints_Activated);
			
			// Set up the delays for the ToolTip.
         toolTip1.AutoPopDelay = 5000;
         toolTip1.InitialDelay = 1000;
         toolTip1.ReshowDelay = 500;

			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DataHistorianPoints));
            this.pnlHistorianData = new System.Windows.Forms.Panel();
            this.gridHistorianData = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.gridContext = new System.Windows.Forms.ContextMenu();
            this.panel1 = new System.Windows.Forms.Panel();
            this.groupBoxUOMs = new System.Windows.Forms.GroupBox();
            this.rdDefaultToInterfaceUOM = new System.Windows.Forms.RadioButton();
            this.rdDefaultToModelUOM = new System.Windows.Forms.RadioButton();
            this.toolTip2 = new System.Windows.Forms.ToolTip(this.components);
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.btnTransPosedView = new System.Windows.Forms.Button();
            this.btnCheckValidation = new System.Windows.Forms.Button();
            this.pnlHistorianData.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridHistorianData)).BeginInit();
            this.panel1.SuspendLayout();
            this.groupBoxUOMs.SuspendLayout();
            this.SuspendLayout();
            // 
            // pnlHistorianData
            // 
            this.pnlHistorianData.Controls.Add(this.gridHistorianData);
            this.pnlHistorianData.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlHistorianData.Location = new System.Drawing.Point(0, 32);
            this.pnlHistorianData.Name = "pnlHistorianData";
            this.pnlHistorianData.Size = new System.Drawing.Size(896, 270);
            this.pnlHistorianData.TabIndex = 19;
            // 
            // gridHistorianData
            // 
            this.gridHistorianData.BackColor = System.Drawing.SystemColors.Window;
            this.gridHistorianData.ContextMenu = this.gridContext;
            this.gridHistorianData.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridHistorianData.Location = new System.Drawing.Point(0, 0);
            this.gridHistorianData.Name = "gridHistorianData";
            this.gridHistorianData.Size = new System.Drawing.Size(896, 270);
            this.gridHistorianData.TabIndex = 18;
            this.gridHistorianData.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
            this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
            this.gridHistorianData.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            this.gridHistorianData.TableOptions.DefaultColumnWidth = 150;
            this.gridHistorianData.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
            this.gridHistorianData.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
            this.gridHistorianData.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
            this.gridHistorianData.Text = "gridGroupingControl1";
            this.gridHistorianData.ThemesEnabled = false;
            this.gridHistorianData.TopLevelGroupOptions.CaptionText = "Historian Points : {RecordCount} Items";
            this.gridHistorianData.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridHistorianData.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridHistorianData.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridHistorianData.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridHistorianData.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridHistorianData.TopLevelGroupOptions.ShowFilterBar = true;
            this.gridHistorianData.VersionInfo = "3.301.0.0";
            this.gridHistorianData.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridHistorianData_TableControlCurrentCellShowingDropDown);
            this.gridHistorianData.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridHistorianData_CurrentRecordContextChange);
            this.gridHistorianData.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.gridHistorianData_TableControlCurrentCellCloseDropDown);
            this.gridHistorianData.TableControlCellMouseHover += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(this.gridHistorianData_TableControlCellMouseHover);
            this.gridHistorianData.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridHistorianData_TableControlCellClick);
            this.gridHistorianData.TableControl.ActivateToolTip += new GridActivateToolTipEventHandler(TableControl_ActivateToolTip);
            this.gridHistorianData.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridHistorianData_RecordDeleting);
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.SystemColors.ControlDark;
            this.panel1.Controls.Add(this.btnTransPosedView);
            this.panel1.Controls.Add(this.btnCheckValidation); 
            this.panel1.Controls.Add(this.groupBoxUOMs);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(896, 32);
            this.panel1.TabIndex = 24;
            // 
            // groupBoxUOMs
            // 
            this.groupBoxUOMs.BackColor = System.Drawing.Color.Transparent;
            this.groupBoxUOMs.Controls.Add(this.rdDefaultToInterfaceUOM);
            this.groupBoxUOMs.Controls.Add(this.rdDefaultToModelUOM);
            this.groupBoxUOMs.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.groupBoxUOMs.Location = new System.Drawing.Point(2, -2);
            this.groupBoxUOMs.Name = "groupBoxUOMs";
            this.groupBoxUOMs.Size = new System.Drawing.Size(328, 32);
            this.groupBoxUOMs.TabIndex = 22;
            this.groupBoxUOMs.TabStop = false;
            // 
            // rdDefaultToInterfaceUOM
            // 
            this.rdDefaultToInterfaceUOM.ForeColor = System.Drawing.Color.White;
            this.rdDefaultToInterfaceUOM.Location = new System.Drawing.Point(168, 3);
            this.rdDefaultToInterfaceUOM.Name = "rdDefaultToInterfaceUOM";
            this.rdDefaultToInterfaceUOM.Size = new System.Drawing.Size(152, 24);
            this.rdDefaultToInterfaceUOM.TabIndex = 20;
            this.rdDefaultToInterfaceUOM.Tag = "SID_DEFAULT_INTERDACE_UOM";
            this.rdDefaultToInterfaceUOM.CheckedChanged += new System.EventHandler(this.rdDefaultToInterfaceUOM_CheckedChanged);
            // 
            // rdDefaultToModelUOM
            // 
            this.rdDefaultToModelUOM.ForeColor = System.Drawing.Color.White;
            this.rdDefaultToModelUOM.Location = new System.Drawing.Point(8, 3);
            this.rdDefaultToModelUOM.Name = "rdDefaultToModelUOM";
            this.rdDefaultToModelUOM.Size = new System.Drawing.Size(152, 24);
            this.rdDefaultToModelUOM.TabIndex = 21;
            this.rdDefaultToModelUOM.Tag = "SID_DEFAULT_MODEL_UOM";
            this.rdDefaultToModelUOM.CheckedChanged += new System.EventHandler(this.rdDefaultToModelUOM_CheckedChanged);
            // 
            // btnTransPosedView
            // 
            this.btnTransPosedView.Location = new System.Drawing.Point(366, 4);
            this.btnTransPosedView.Name = "btnTransPosedView";
            this.btnTransPosedView.Size = new System.Drawing.Size(75, 23);
            this.btnTransPosedView.TabIndex = 23;
            this.btnTransPosedView.Tag = "SID_TRANSPOSED";
            this.btnTransPosedView.UseVisualStyleBackColor = true;
            this.btnTransPosedView.Click += new System.EventHandler(this.btnTransPosedView_Click);
            // 
            // btnCheckValidation
            // 
            this.btnCheckValidation.Location = new System.Drawing.Point(451, 4);
            this.btnCheckValidation.Name = "btnCheckValidation";
            this.btnCheckValidation.Size = new System.Drawing.Size(75, 23);
            this.btnCheckValidation.TabIndex = 24;
            this.btnCheckValidation.Tag = "SID_CHKFORVALIDATION";
            this.btnCheckValidation.UseVisualStyleBackColor = true;
            this.btnCheckValidation.Click += new EventHandler(btnCheckValidation_Click);
            // 
            // DataHistorianPoints
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(896, 302);
            this.Controls.Add(this.pnlHistorianData);
            this.Controls.Add(this.panel1);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "DataHistorianPoints";
            this.Tag = "SID_HIST_POINTS";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.pnlHistorianData.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridHistorianData)).EndInit();
            this.panel1.ResumeLayout(false);
            this.groupBoxUOMs.ResumeLayout(false);
            this.ResumeLayout(false);

		}


		#endregion


		#region Private Methods

		private void DisableContextMenuItems()
		{
			gridContext.MenuItems.Clear();

			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_CHOOSE_COLUMNS"),new EventHandler(ChooseColumns)));
		}

		private void EnableContextMenuItems()
		{
			gridContext.MenuItems.Clear();

			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_CHOOSE_COLUMNS"),new EventHandler(ChooseColumns)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_OVERRIDE_HIST_DATA"),new EventHandler(Override)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_SITE_COMP_MAPPING"),new EventHandler(ViewSiteComponentProperty)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_TREND"), new EventHandler(ViewTrends)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_TREND_ALL_TUNNING_DATA"), new EventHandler(ViewAllTrends)));
		}

		/// <summary>
		/// Method used to initialize the grid with the data from the Historian...
		/// </summary>
		private void InitializeGridWithData()
		{
			gridHistorianData.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridHistorianData);
			gridHistorianData.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_HIST_POINTS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrHistData.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridHistorianData,_lrrHistData.ItemType,null,fkData);

			//SyncGridUtilities.InitializeGridColumns(gridHistorianData,_lrrHistData.ItemType,null);

			gridHistorianData.DataSource = _lrrHistData;
			gridHistorianData.SourceListSet.Add("HistDatas",_lrrHistData);
			gridHistorianData.TableDescriptor.Columns.Remove(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE"));
			gridHistorianData.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_INTERNAL_INTERFACEVALUE"),"InterfaceValue");
			gridHistorianData.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_INTERNAL_INTERFACEVALUE")].Appearance.AnyRecordFieldCell.ReadOnly = true;

			gridHistorianData.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE"),"DisplayInterfaceValue");
			gridHistorianData.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE")].ReadOnly = true;
			gridHistorianData.TableDescriptor.Columns.Add("ModelUOM","ModelUOM");
			LRRUOMs lrrUOMs = LRRModel.ChildModel.UOMs;
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.DataSource = lrrUOMs;
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].HeaderText=LRRHeaderText.GetHeaderString("SID_MODELUOM");
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.DisplayMember = "Name";
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ValueMember = "ID";
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ReadOnly = true;

            gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			

			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistTag")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("PlantUnit_Name")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("GeneralDesc")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("EquipTag")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ServerID") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			//gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistoryValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistDesc") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("DataQuality") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("MeasType") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("MeterOnOffStatusFlag") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ComplexEquipOnOff") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("FilterSelection") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ActiveFilterReturnValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("AverageValueForPeriodEntered") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("LastValidAverageValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("CalibrationFactor") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("StartOfPeriodValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("EndOfPeriodValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("SpotValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ValidRangeLowerLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ValidRangeUpperLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("OnOffThresholdLowerLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("OnOffThresholdUpperLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("OffConditionSubstituteValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("FinalValueWithoutOverrides") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("FormulaObj") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("TagImportanceID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ActionsID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("StatusID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ConditionID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("Comments") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("PreFilterUserOverride") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistUnits") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistUnitStringFromDH") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ConversionFormulaObj") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ErrorStatus") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("PostFilterUserOverride") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
            gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("SourceType_AdaptorName")].Appearance.AnyRecordFieldCell.BackColor = Color.FromArgb(255, 255, 255);

			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("UOMTypeID_Name") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
            gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistUOMTypeID_Name")].Appearance.AnyRecordFieldCell.BackColor = Color.FromArgb(204, 255, 204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ModelUOM") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("InterfaceUnits") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE")) ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf(LRRHeaderText.GetHeaderString("SID_INTERNAL_INTERFACEVALUE")) ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("CustomFormulaObj") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
            /*gridHistorianData.TableDescriptor.Columns["InterfaceUnits"].AllowFilter = false;
            gridHistorianData.TableDescriptor.Columns["HistUnits"].AllowFilter = false;
            gridHistorianData.TableDescriptor.Columns["ModelUOM"].AllowFilter = false;  */


            

			// registration for Tree Control for Plant levels....
            if (!gridHistorianData.TableModel.CellModels.ContainsKey("DropDownTree"))
            {
                gridHistorianData.TableModel.CellModels.Add("DropDownTree", new PlantLevelUserFormTreeControl(this.gridHistorianData.TableModel, new PlantLevelTreeControlStructure()));
            }
			gridHistorianData.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridHistorianData_QueryCellStyleInfo);

			//gridHistorianData.GridGroupDropArea.Paint+=new PaintEventHandler(GridGroupDropArea_Paint);

			//gridHistorianData.GridGroupDropArea.CurrentCellInitializeControlText+=new Syncfusion.Windows.Forms.Grid.GridCurrentCellInitializeControlTextEventHandler(GridGroupDropArea_CurrentCellInitializeControlText);
			//SyncGridUtilities.SetFilterHeader(gridHistorianData);
			//			gridContext.MenuItems.Clear();
			//
			//			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_CHOOSE_COLUMNS"),new EventHandler(ChooseColumns)));
			//			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_OVERRIDE_HIST_DATA"),new EventHandler(Override)));
			//			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_SITE_COMP_MAPPING"),new EventHandler(ViewSiteComponentProperty)));
			//			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_TREND"), new EventHandler(ViewTrends)));
			//			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_TREND_ALL_TUNNING_DATA"), new EventHandler(ViewAllTrends)));
			gridContext.Popup +=new EventHandler(gridContext_Popup);
			gridHistorianData.ResumeLayout(false);
            Syncfusion.Windows.Forms.Grid.GridModel gm = new GridModel();
            GridTableFilterBarCellModel1 g = new GridTableFilterBarCellModel1(gm);
            
            foreach (GridColumnDescriptor gcd in gridHistorianData.TableDescriptor.Columns)
            {
                if (gcd.MappingName == "InterfaceUnits")
                {
                    gcd.Appearance.FilterBarCell.CellType = "DisplayMemberFilterBarCell";
                    gcd.Appearance.FilterBarCell.DataSource = interFaceUoms;
                    gcd.Appearance.FilterBarCell.DisplayMember = "Name";
                    gcd.Appearance.FilterBarCell.ValueMember = "ID";
                }
                else if (gcd.MappingName == "HistUnits")
                {
                    gcd.Appearance.FilterBarCell.CellType = "DisplayMemberFilterBarCell";
                    gcd.Appearance.FilterBarCell.DataSource = histUoms; 
                    gcd.Appearance.FilterBarCell.DisplayMember = "Name";
                    gcd.Appearance.FilterBarCell.ValueMember = "ID";
                }
                else if (gcd.MappingName == "ModelUOM")
                {
                    gcd.Appearance.FilterBarCell.CellType = "DisplayMemberFilterBarCell";
                    gcd.Appearance.FilterBarCell.DataSource = modelUoms;
                    gcd.Appearance.FilterBarCell.DisplayMember = "Name";
                    gcd.Appearance.FilterBarCell.ValueMember = "ID";
                    gcd.Appearance.FilterBarCell.ShowButtons = GridShowButtons.Show;
                    gcd.Appearance.FilterBarRowHeaderCell.ShowButtons = GridShowButtons.Show;
                }
            }

            if (!this.gridHistorianData.TableModel.CellModels.ContainsKey("DisplayMemberFilterBarCell"))
            {
                this.gridHistorianData.TableModel.CellModels.Add("DisplayMemberFilterBarCell", g);
            }
			string[,] arry=new string[,]{{"GeneralDesc","255"},{"HistDesc","255"},{"Comments","255"}};
			Validations	objValidations=new Validations(gridHistorianData,arry);

		}

		private void InitDataSource()
		{
			if(_lrrProjConfigs != null)
				_lrrProjConfigs.Clear();
			if(_lrrMeasSystemDefs != null)
				_lrrMeasSystemDefs.Clear();
			if(_levels!= null)
				_levels.Clear(); 

			_lrrProjConfigs = new LRRProjectConfigurations();
			_app.DBManagerObj.PopulateCollection(_lrrProjConfigs,false);

			_lrrMeasSystemDefs = new LRRMeasurementSystemDefinitions();
			_app.DBManagerObj.PopulateCollection(_lrrMeasSystemDefs,false);

			_levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(_levels,false);  
		}

		#endregion

		#region Fields

		private LRRHistDatas					_lrrHistData; //Local Storage for Data Historian acting as datasource
		private LRRApp							_app; //App Instance...
		private LRRUIManager					lrrUI;
		private bool							isSaved =  false;
        private string _measType = "";
		private ArrayList						duplicateData =new ArrayList();  
		Hashtable lrrFormulaHistData = new Hashtable();

		private LRRProjectConfigurations _lrrProjConfigs; 
		private LRRMeasurementSystemDefinitions	 _lrrMeasSystemDefs;

		private string interfaceVal="";
		private LRRLevels									_levels;
        private ArrayList _arrHistTags = new ArrayList();
		#endregion

		#region EventHandlers


		private void ChooseColumns(object sender,EventArgs e)
		{
			_ShowGridColumnsDialog(this.gridHistorianData.Engine.TableDescriptor, "Columns", null, typeof(GridColumnDescriptorCollection));
		}

		private void Override(object sender,EventArgs e)
		{
			Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
			GridRecord gnt = eCurrentElement as GridRecord;
			LRRHistData objHistData = eCurrentElement.GetRecord().GetData() as LRRHistData;
					
			//e.TableCellIdentity.Table.GetRecord().GetData()
			LRRHistDataUserAndTimes objHistDataOverrides =new LRRHistDataUserAndTimes();
			_app.DBManagerObj.PopulateCollection(objHistDataOverrides," WHERE HistTagUID ='" + objHistData.HistTagUID + "'");
			if(objHistDataOverrides.Count == 0 )
			{
				objHistDataOverrides.Add(ConverHistDataToHistDataOverride(objHistData));
			}

			DataHistorianPointOverrides amp = new DataHistorianPointOverrides(objHistDataOverrides);
			amp.Text = amp.Text + " [" + objHistData.HistTag + "]";
			amp.ShowDialog(this);
             

		}
		private void ViewSiteComponentProperty(object sender,EventArgs e)
		{
			try
			{
				Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
				GridRecord gnt = eCurrentElement as GridRecord;
				LRRHistData objHistData = eCurrentElement.GetRecord().GetData() as LRRHistData;
					
				LRRHistPropCompPropMappings objHistDataCompPropMappings =new LRRHistPropCompPropMappings();

				_app.DBManagerObj.PopulateCollection(objHistDataCompPropMappings," WHERE HistPropID ='" + objHistData.HistTagUID + "'");

				LRRHistData lrrhistdata = LRRModel.HistDatas.GetHistDataFromHistTagUID(objHistData.HistTagUID);

				string sSiteCompPropertiesID = "";
				string sGroupPropertyID = ""; 

				foreach (LRRHistPropCompPropMapping objHistDataCompPropMapping in objHistDataCompPropMappings)
				{
					/*if(objHistDataCompPropMapping.SiteComponentPropID.ToString(Symcon.BusinessObjects.SymConverter.Culture) != "")*/
					if(objHistDataCompPropMapping.SiteComponentPropID != "" && objHistDataCompPropMapping.SiteComponentPropID != null)
					{
						if(sSiteCompPropertiesID == "")
						{
							sSiteCompPropertiesID = "'" + objHistDataCompPropMapping.SiteComponentPropID + "'";
						}
						else
						{
							sSiteCompPropertiesID = sSiteCompPropertiesID  + ",'" + objHistDataCompPropMapping.SiteComponentPropID + "'";
						}
							
					}
				
					if(objHistDataCompPropMapping.GroupPropertyID != null && objHistDataCompPropMapping.GroupPropertyID != "")
					{
						if(objHistDataCompPropMapping.GroupPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture) != "")
						{
							if(sGroupPropertyID == "")
								sGroupPropertyID = "'" + objHistDataCompPropMapping.GroupPropertyID + "'";
							else
								sGroupPropertyID = sGroupPropertyID  + ",'" + objHistDataCompPropMapping.GroupPropertyID + "'";
						}
					}
				}
			
				LRRSiteComponentProperties objSiteComponentProperties =new LRRSiteComponentProperties();
			
				if(sSiteCompPropertiesID != "")
					_app.DBManagerObj.PopulateCollection(objSiteComponentProperties," WHERE SiteComponentPropID IN (" + sSiteCompPropertiesID + ")");

				
				LRRSiteComponentGroupProperties objSiteComponentGroupProperties =new LRRSiteComponentGroupProperties();
			
				if(sGroupPropertyID != "")
					_app.DBManagerObj.PopulateCollection(objSiteComponentGroupProperties," WHERE GroupPropertyID IN (" + sGroupPropertyID + ")");
			
				int i = objSiteComponentGroupProperties.Count + objSiteComponentProperties.Count;

				ArrayList objSiteComponents = new ArrayList(i);

				IEnumerator iSiteComponentPropertiesEnum	= objSiteComponentProperties.GetEnumerator();
				while(iSiteComponentPropertiesEnum.MoveNext())
				{
					LRRSiteComponentProperty objLRRSiteComponentProperty= (LRRSiteComponentProperty)iSiteComponentPropertiesEnum.Current;
					LRRSiteComponent objSiteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(objLRRSiteComponentProperty.ComponentID);
					HistorianProps objHistorianProps = new HistorianProps(objLRRSiteComponentProperty.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture),objSiteComp.Name );
					objSiteComponents.Add(objHistorianProps);
				}

				IEnumerator iSiteComponentGroupPropsEnum	= objSiteComponentGroupProperties.GetEnumerator();
				while(iSiteComponentGroupPropsEnum.MoveNext())
				{
					LRRSiteComponentGroupProperty objLRRSiteComponentGroupProperty= (LRRSiteComponentGroupProperty)iSiteComponentGroupPropsEnum.Current;
					LRRSiteGroupPropertyQualifierValue objSCQV = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForModeSiteCompAndLookUpProp(objLRRSiteComponentGroupProperty.SiteComponentPropID,objLRRSiteComponentGroupProperty.LookUpPropertiesID,"1");
					LRRSiteComponentProperty objSCP = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(objLRRSiteComponentGroupProperty.SiteComponentPropID);
					LRRSiteComponent objsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(objSCP.ComponentID);
					string sName = "";
					if(objSCQV.QualifierID == null || objSCQV.QualifierID == "")
					{
						sName = objSCP.Name + @" \ " + objLRRSiteComponentGroupProperty.AttributeName + " [Data Array]";
					}
					else
					{
						sName = objSCP.Name + @" \ " + objLRRSiteComponentGroupProperty.AttributeName + @" \ " + objSCQV.QualifierName + " [Grouped Property]";
					}
					//HistorianProps objHistorianProps = new HistorianProps(objLRRSiteComponentGroupProperty.AttributeName.ToString(Symcon.BusinessObjects.SymConverter.Culture) + " [Grouped Property]","");
					HistorianProps objHistorianProps = new HistorianProps(sName,objsc.Name);
					objSiteComponents.Add(objHistorianProps);

				}
				if(objSiteComponents.Count == 0)
				{
					LRRMessagBox.ShowMessage("SID_MAPPEDPROPERTIES_DOESNOTEXIST","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);  
					return;
				}
				DataHistorianPointProperties amp = new DataHistorianPointProperties(objSiteComponents,lrrhistdata.HistTag);
				amp.Text = amp.Text + " [" + objHistData.HistTag + "]";
				amp.ShowDialog(this);
			}
			catch(Exception)
			{
			}
		}

		private void ViewTrends(object sender,EventArgs e)
		{
			ShowTrends(false);
		}

		private void ViewAllTrends(object sender,EventArgs e)
		{
			ShowTrends(true);
		}

		#endregion

		#region Private Methods

		private void ShowTrends(bool showAll)
		{
			Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
			GridRecord gnt = eCurrentElement as GridRecord;
			LRRHistData objHistData = eCurrentElement.GetRecord().GetData() as LRRHistData;

			if(objHistData != null)
			{
				if(objHistData.HistTag!=null)
				{
					string key;
					if(showAll)
					{
						key = "HistTrend(All):" + objHistData.HistTag;
					}
					else
					{
						key = "HistTrend:" + objHistData.HistTag;
					}
					if(_app.LRRUIManagerObj._windowStore.ContainsKey(key))
					{
						ILRRUIContainer cont = _app.LRRUIManagerObj._windowStore[key] as ILRRUIContainer;
						cont.Refresh();
						Form frm = cont as Form;
						frm.Activate();
					}
					else
					{
						HistTrends._arrHistTags = new ArrayList();
						for(int i=0;i<gridHistorianData.TableControl.Table.Elements.Count;i++)
						{
							if(gridHistorianData.TableControl.Table.Elements[i].IsRecord())
							{
								LRRHistData histData = gridHistorianData.TableControl.Table.Elements[i].GetRecord().GetData() as LRRHistData;
								if(histData != null)
								{
									if(histData.HistTag!=null)
									{
										HistTrends._arrHistTags.Add(histData.HistTag);
									}
								}
							}
						}
						object[] obj = new object[2];
						obj[0] = objHistData.HistTag;
                        obj[1] = false;
						if(showAll)
						{
                            obj[1] = true;
							_app.LRRUIManagerObj.ShowWindow(key,typeof(HistTrends),obj);
						}
						else
						{
							HistTrendsDialog histDialog = new HistTrendsDialog();
							DialogResult dlgResult = histDialog.ShowDialog(this);
							if(dlgResult == DialogResult.OK)
							{
								_app.LRRUIManagerObj.ShowWindow(key,typeof(HistTrends),obj);
							}
						}
					}
				}
			}
		}

        /// <summary>
        /// show grid columns collection editor dialog.
        /// </summary>
        /// <param name="instance">The instance.</param>
        /// <param name="propertyName">Name of the property.</param>
        /// <param name="provider">The provider.</param>
        /// <param name="type">The type.</param>
        /// <returns></returns>
		internal DialogResult _ShowGridColumnsDialog(object instance, string propertyName, IServiceProvider provider, Type type)
		{
            LRRGroupingCollectionEditor ce = new LRRGroupingCollectionEditor(type);
			Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer esc = new Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer(provider);
			PropertyDescriptor pd = TypeDescriptor.GetProperties(instance)[propertyName];
			Syncfusion.ComponentModel.TypeDescriptorContext tdc = new Syncfusion.ComponentModel.TypeDescriptorContext(instance, pd);
			tdc.ServiceProvider = esc;
			ce.EditValue(tdc, esc, pd.GetValue(instance));
			return esc.DialogResult;
		}
		private LRRHistDataUserAndTime ConverHistDataToHistDataOverride(LRRHistData objHist)
		{
			LRRHistDataUserAndTime objHistDataOverride =new LRRHistDataUserAndTime();

			objHistDataOverride.HistTagUID= objHist.HistTagUID;
			objHistDataOverride.HistTag= objHist.HistTag;
			objHistDataOverride.GeneralDesc= objHist.GeneralDesc;
			objHistDataOverride.EquipTag= objHist.EquipTag;
			objHistDataOverride.PropertyID= objHist.PropertyID;
			objHistDataOverride.FinalValueWithoutOverrides= objHist.FinalValueWithoutOverrides;
			objHistDataOverride.InterfaceValue= objHist.InterfaceValue;
			objHistDataOverride.ServerID= objHist.ServerID;
			objHistDataOverride.HistDesc= objHist.HistDesc;
			objHistDataOverride.HistUnits= objHist.HistUnits;
			objHistDataOverride.MeasType= objHist.MeasType;
			objHistDataOverride.FilterSelection= objHist.FilterSelection;
			objHistDataOverride.ValidRangeLowerLimit= objHist.ValidRangeLowerLimit;
			objHistDataOverride.ValidRangeUpperLimit= objHist.ValidRangeUpperLimit;
			objHistDataOverride.OnOffThresholdLowerLimit= objHist.OnOffThresholdLowerLimit;
			objHistDataOverride.OnOffThresholdUpperLimit= objHist.OnOffThresholdUpperLimit;
			objHistDataOverride.OffConditionSubstituteValue= objHist.OffConditionSubstituteValue;
			objHistDataOverride.StartOfPeriodValue= objHist.StartOfPeriodValue;
			objHistDataOverride.EndOfPeriodValue= objHist.EndOfPeriodValue;
			objHistDataOverride.SpotValue= objHist.SpotValue;
			objHistDataOverride.AverageValueForPeriodEntered= objHist.AverageValueForPeriodEntered;
			objHistDataOverride.LastValidAverageValue= objHist.LastValidAverageValue;
			//objHistDataOverride.HistoryValue= objHist.HistoryValue;
			objHistDataOverride.DataQuality= objHist.DataQuality;
			objHistDataOverride.ActiveFilterReturnValue= objHist.ActiveFilterReturnValue;
			objHistDataOverride.MeterOnOffStatusFlag= objHist.MeterOnOffStatusFlag;
			objHistDataOverride.ComplexEquipOnOff= objHist.ComplexEquipOnOff;
			objHistDataOverride.CalibrationFactor= objHist.CalibrationFactor;
			objHistDataOverride.PreFilterUserOverride= objHist.PreFilterUserOverride;
			objHistDataOverride.InterfaceUnits= objHist.InterfaceUnits;
			objHistDataOverride.PostFilterUserOverride= objHist.PostFilterUserOverride;
			objHistDataOverride.Comments= objHist.Comments;
			return objHistDataOverride;
		}

		private void SetConversionFormualDataStore()
		{
			LRRUCFDataStore.IsUCF = false;
		}

		#endregion

		#region ILRRUIContainer Members
		public void Save()
		{
            this.gridHistorianData.Table.EndEdit();
			LRRHistDatas toSaveHistData = _lrrHistData.GetChanges();
            //ArrayList histTagWithOutUom = new ArrayList();
            ArrayList histTagWithOutMendatoryFields = new ArrayList();
			if(toSaveHistData.Count > 0)
			{
				for(int i=0;i<toSaveHistData.Count;i++)
				{
					LRRHistData  lhd = toSaveHistData[i] as LRRHistData;
                    
					if(lhd.HistTag == null || lhd.HistTag.Trim() == "")
					{
						LRRMessagBox.ShowMessage("SID_HISTDATA_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);      
						return;
					}
                    string retString = CheackForValidation(lhd);
                    if (retString != "")
                    {
                        string s = lhd.HistTag + " without some mandatory field(s) like " + retString;
                        if (!histTagWithOutMendatoryFields.Contains(s))
                            histTagWithOutMendatoryFields.Add(s);
                    }
				}
                if (histTagWithOutMendatoryFields.Count > 0)
                {
                    DialogResult dlg = LRRMessagBox.ShowMessage("SID_UOMTYPENULL_HISTDATA", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    foreach (string s in histTagWithOutMendatoryFields)
                    {
                        Logger.LogMessage(typeof(DataHistorianPoints),s, Logger.Level.Error);
                    }
                }
                for (int i = 0; i < toSaveHistData.Count; i++)
                {
                    LRRHistData lhd = toSaveHistData[i] as LRRHistData;
                    if (lhd.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
                    {
                        if (_arrHistTags.Contains(lhd.HistTag))
                        {
                            MessagingClient.RaiseAlert("Hist tag: '" + lhd.HistTag + "' deleted.");
                            _arrHistTags.Remove(lhd.HistTag);
                        }
                    }
                    if (lhd.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                    {
                        MessagingClient.RaiseAlert("New hist tag: '" + lhd.HistTag + "' added.");
                        if (!_arrHistTags.Contains(lhd.HistTag))
                            _arrHistTags.Add(lhd.HistTag);
                    }
                }
                LRRPESteamFormulas peSteamForumalsChages = LRRModel.PESteamFormulaObj.GetChanges();
                if (peSteamForumalsChages.Count > 0)
                {
                    _app.DBManagerObj.CommitCollection(peSteamForumalsChages);
                    LRRModel.PESteamFormulaObj.RefreshCollection();
                }

                //LRRFormulas updatedFormulas = new LRRFormulas();
                //LRRFormulaParams updatedParams = new LRRFormulaParams();
                //bool onlyFormulaUpdated = false;
                // for loop added by ashwin for handling of formula updation in historian points screen
                for (int xyz = 0; xyz < toSaveHistData.Count; xyz++)
                {
                    LRRHistData hd1 = toSaveHistData[xyz] as LRRHistData;
                    LRRHistData hd = LRRModel.HistDatas.GetHistDataFromHistTagUID(hd1.HistTagUID);
                    if (hd.ArrListUpdatedColNames.Contains("Formula"))
                    {
                        LRRFormula frm = hd.FormulaObj;
                        if (frm != null)
                        {
                            if (frm.ObjectState != Symcon.Globals.Enums.DBOperation.DELETE)
                            {
                                LRRFormula delFrmObj = new LRRFormula();
                                LRRFormulaParams delFrmPrms = new LRRFormulaParams();
                                delFrmPrms = frm.Params;
                                delFrmObj = frm;
                                frm.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                                LRRModel.FormulasObj.Remove(frm);
                                _app.DBManagerObj.CommitObject(frm);
                                delFrmObj.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                                foreach (LRRFormulaParam fpm in delFrmPrms)
                                {
                                    fpm.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                                }
                                delFrmObj.Params = delFrmPrms;
                                hd.FormulaObj = delFrmObj;
                                hd.FormulaID = delFrmObj.ID;
                                _app.DBManagerObj.CommitObject(hd);

                            }
                            else
                            {
                                frm.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                                LRRModel.FormulasObj.Remove(frm);
                                _app.DBManagerObj.CommitObject(frm);
                                LRRFormula hfrm = new LRRFormula();
                                hd.FormulaObj = hfrm;
                                _app.DBManagerObj.CommitObject(hd);
                                hd.FormulaID = "";
                            }
                        }
                    }
                }
                             
                //            foreach (LRRFormulaParam frmprm in frm.Params)
                //            {
                //                updatedParams.Add(frmprm);
                //            }
                //            if (frm.ObjectState != Symcon.Globals.Enums.DBOperation.INSERT)
                //            {
                //                onlyFormulaUpdated = true;
                //                frm.ObjectState = Symcon.Globals.Enums.DBOperation.UPDATE;
                //            }
                //            else
                //            {
                //                _app.DBManagerObj.CommitCollection(toSaveHistData);
                //            }
                //            updatedFormulas.Add(frm);
                //        }
                //    }
                //}
                //try
                //{
                //    if (updatedFormulas.Count > 0)
                //    {
                //        if (onlyFormulaUpdated)
                //        {
                //            for (int i = 0; i < updatedFormulas.Count; i++)
                //            {
                //                LRRFormula frm = updatedFormulas[i];
                //                if (frm != null)
                //                {
                //                    _app.DBManagerObj.CommitObject(frm);
                //                    //_app.DBManagerObj.CommitCollection(toSaveHistData);
                //                    /*
                //                    for (int j = 0; j < frm.Params.Count; j++)
                //                    {
                //                        LRRFormulaParam frmprm = frm.Params[j];
                //                        if (frmprm != null)
                //                        {
                //                            _app.DBManagerObj.CommitObject(frmprm);
                //                        }
                //                    }
                //                     * */
                //                }
                //            }
                //        }
                //    }
                //    else
                //    {
                //        _app.DBManagerObj.CommitCollection(toSaveHistData);
                //    }
                //}
                //catch (Exception ex)
                //{

                //}
                //isSaved = true;

                _app.DBManagerObj.CommitCollection(toSaveHistData);
                isSaved = true;

                /*

                if (updatedFormulas.Count > 0)
                {
                    _app.DBManagerObj.CommitCollection(updatedFormulas);
                    if (updatedParams.Count > 0)
                    {
                        _app.DBManagerObj.CommitCollection(updatedParams);
                    }
                    _app.DBManagerObj.CommitCollection(toSaveHistData);
                    isSaved = true;
                }
                else
                {
                    _app.DBManagerObj.CommitCollection(toSaveHistData);
                    isSaved = true;
                }
                
                //_app.DBManagerObj.CommitCollection(toSaveHistData);
                //isSaved = true;
                **/
			}
            LRRModel.HistDatas.RefreshCollection();
			if(toSaveHistData.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
			else
			{
				if(!isSaved)
				{
					LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
				}
				else
				{
					ApplicationPersistanceUtil.SaveGridSettings(gridHistorianData,this,this.Tag);

					for(int i=0;i<toSaveHistData.Count;i++)
					{
						LRRHistData data = toSaveHistData[i];
                        if (data.ArrListUpdatedColNames.Contains("CalibrationFactor"))
                        {
                            Symcon.Utils.Alert.Messages.LRRAlert.AddAlert(Symcon.Globals.Enums.MessageType.MSgUpdate,"Calibration factor changed for hist tag " + data.HistTag);
                        }
                        if (data.ArrListUpdatedColNames.Contains("PreFilterUserOverride"))
                        {
                            Symcon.Utils.Alert.Messages.LRRAlert.AddAlert(Symcon.Globals.Enums.MessageType.MSgUpdate, "Pre Filter User Override changed for hist tag " + data.HistTag);
                        }
                        if (data.ArrListUpdatedColNames.Contains("PostFilterUserOverride"))
                        {
                            Symcon.Utils.Alert.Messages.LRRAlert.AddAlert(Symcon.Globals.Enums.MessageType.MSgUpdate, "Post Filter User Override changed for hist tag " + data.HistTag);
                        }
						if(data.ArrListUpdatedColNames.Contains("CalibrationFactor") || data.ArrListUpdatedColNames.Contains("PreFilterUserOverride") || data.ArrListUpdatedColNames.Contains("PostFilterUserOverride") )
						{
							MessagingClient.CalibrationFactorChanged(data.HistTag,data.CalibrationFactor,data.PreFilterUserOverride,data.PostFilterUserOverride);
						}
					}
					
				   GridChangedRecordLists.GetInstance().Remove(this.Text);
					//Refresh();
					ApplicationPersistanceUtil.ApplyGridSettings(gridHistorianData,this,this.Tag);
					LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				}
			}
		}

        private string CheackForValidation(LRRHistData lhd)
        {
            string retValue = "";
            string[] s = new string[1];
            s[0] = lhd.HistTag;
            if (lhd.HistTag == "WC1BL1XS.UNIT1@NET0")
            {
                int xyz = 0;
            }

            if (lhd.CalibrationFactor == null || lhd.CalibrationFactor == "")
            {
               //LRRMessagBox.ShowMessage("SID_CALIFACTORNULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
               retValue = "CalibrationFactor";
            }
            /* commented by ashwin for handling EVVs
            if (lhd.HistUnits == null || lhd.HistUnits == "")
            {
                //LRRMessagBox.ShowMessage("SID_HISTUNITNULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : HistUnits";
            }
            */
            if (lhd.MeasType == null || lhd.MeasType == "")
            {
                //LRRMessagBox.ShowMessage("SID_MEASTYPENULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : MeasType";
            }
            if (lhd.OffConditionSubstituteValue == null || lhd.OffConditionSubstituteValue == "")
            {
                //LRRMessagBox.ShowMessage("SID_OFFCONDSUBVALUENULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : OffConditionSubstituteValue";
            }
            if (lhd.OnOffThresholdLowerLimit == null || lhd.OnOffThresholdLowerLimit == "")
            {
                //LRRMessagBox.ShowMessage("SID_THRESHOLDLOWER_NULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : OnOffThresholdLowerLimit";
            }
            if (lhd.OnOffThresholdUpperLimit == null || lhd.OnOffThresholdUpperLimit == "")
            {
                //LRRMessagBox.ShowMessage("SID_THRESHOLDUPPER_NULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : OnOffThresholdUpperLimit";
            }
            if (lhd.PlantUnit  == null || lhd.PlantUnit == "")
            {
                //LRRMessagBox.ShowMessage("SID_PLANTUNITNULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : PlantUnit";
            }
            if (lhd.ServerID == null || lhd.ServerID == "")
            {
                //LRRMessagBox.ShowMessage("SID_SERVERIDNULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : ServerID";
            }
            if (lhd.ValidRangeLowerLimit == null || lhd.ValidRangeLowerLimit == "")
            {
                //LRRMessagBox.ShowMessage("SID_VALIDLOWER_NULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : ValidRangeLowerLimit";
            }
            if (lhd.ValidRangeUpperLimit == null || lhd.ValidRangeUpperLimit == "")
            {
                //LRRMessagBox.ShowMessage("SID_VALIDUPPER_NULL_HISTDATA", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                retValue = retValue + " : ValidRangeUpperLimit"; 
            }
            if (lhd.UOMTypeID == null || lhd.UOMTypeID == "")
            {
                retValue = retValue + " : UomType"; 
            }
            if (lhd.UOMTypeID != null && lhd.UOMTypeID != "")
            {
                LRRUOMType uomType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(lhd.UOMTypeID);
                if (uomType != null)
                {
                    if (!uomType.IsEVV)
                    {
                        LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(uomType.UOMTypeID);
                        if (uom.Count > 0)
                        {
                            if (lhd.InterfaceUnits == null || lhd.InterfaceUnits.Trim() == "")
                            {
                                retValue = retValue + " : InterfaceUnits";
                            }
                        }
                    }
                    else
                    {

                    }
                }
            }
            return retValue;
        }

		public new void Refresh()
		{
			_lrrHistData.RefreshCollection();
			gridHistorianData.TableModel.CellModels.Remove("DropDownTree");
            if (gridHistorianData.TableModel.CellModels.ContainsKey("DisplayMemberFilterBarCell"))
            {
                gridHistorianData.TableModel.CellModels.Remove("DisplayMemberFilterBarCell");
            }
			gridHistorianData.TableDescriptor.Relations.Clear();
			gridHistorianData.QueryCellStyleInfo-=new GridTableCellStyleInfoEventHandler(gridHistorianData_QueryCellStyleInfo);  
			InitDataSource();
			InitializeGridWithData();	
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public void CopyMasterProperties()
		{
			// TODO:  Add ComplexEquipment.CopyMasterProperties implementation
			
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquipment.Paste implementation
			
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquipment.Copy implementation
			
		}

		public void Print()
		{
			//Print Implementation
			if(gridHistorianData.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridHistorianData,false);
			}
			
		}

		public void Delete()
		{
			SyncGridUtilities.DeleteRecords(gridHistorianData);   
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquipment.ArrangeColumns implementation
			
		}

		public void ClearFilter()
		{
			SyncGridUtilities.ClearFilter(gridHistorianData);   
			//this.gridHistorianData.TableDescriptor.RecordFilters.Clear();
			//Refresh(); 
		}

		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridHistorianData);
		}
		
		public void Export()
		{
			if(gridHistorianData.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridHistorianData);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquipment.SupportsCopy implementation
			return true;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquipment.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquipment.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquipment.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquipment.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquipment.SupportsDelete implementation
			return true;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquipment.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquipment.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add SiteComponentEntry.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void SelectionPaste()
		{
			try
			{
				if(gridHistorianData.TableControl.CurrentCell.IsActive)
				{
					int rowI = gridHistorianData.TableControl.CurrentCell.RowIndex;
					int colI = gridHistorianData.TableControl.CurrentCell.ColIndex;
					string sColHeader = gridHistorianData.TableControl.Table.TableModel.GetColumnDescriptorAt(rowI,colI).HeaderText;
					if(sColHeader == LRRHeaderText.GetHeaderString("SID_INTERFACEUOM"))
					{
						GridRangeInfoList ranges = gridHistorianData.TableControl.Model.SelectedRanges;
						if(ranges.Count == 1 && ranges.ActiveRange.IsCells)
						{
							GridRangeInfo range = ranges.ActiveRange;
							for(int col = range.Left; col <= range.Right; ++col)
							{
								GridRecord _rec = gridHistorianData.TableControl.Table.CurrentRecord as GridRecord;
								LRRHistData histDataObj = _rec.GetData() as LRRHistData;  
								if(histDataObj != null)
								{
									string currentUomType = histDataObj.UOMTypeID;
									object o = gridHistorianData.TableControl.Model[range.Top, col].CellValue;
									for(int row = range.Top + 1; row <= range.Bottom; row++)
									{
										try
										{
											LRRHistData histObj = gridHistorianData.TableControl.Model.GetDisplayElementAt(row).GetData() as LRRHistData;
											if(histObj != null)
											{
												string uomType = histObj.UOMTypeID;
												if(uomType == currentUomType)
												{
													ConvertUOM(histObj,histObj.ModelUOM,o.ToString());
													gridHistorianData.TableControl.Model[row, col].CellValue = o;
												}
												else
												{
													break;
												}
											}
										}
										catch(Exception ex)
										{
											Logger.LogMessage(typeof(SyncGridUtilities),"PasteSelection :"+ex.Message  ,Logger.Level.Debug);

										}
									}
									this.gridHistorianData.Refresh(); 
								}
							}
						}
					}
					else if(sColHeader == LRRHeaderText.GetHeaderString("SID_UOMTYPE"))
					{
						GridRangeInfoList ranges = gridHistorianData.TableControl.Model.SelectedRanges;
						if(ranges.Count == 1 && ranges.ActiveRange.IsCells)
						{
							GridRangeInfo range = ranges.ActiveRange;
							for(int col = range.Left; col <= range.Right; ++col)
							{
								GridRecord _rec = gridHistorianData.TableControl.Table.CurrentRecord as GridRecord;
								LRRHistData histDataObj = _rec.GetData() as LRRHistData;  
								if(histDataObj != null)
								{
									string currentUomType = histDataObj.UOMTypeID;
									object o = gridHistorianData.TableControl.Model[range.Top, col].CellValue;
									for(int row = range.Top + 1; row <= range.Bottom; row++)
									{
										try
										{
											LRRHistData histObj = gridHistorianData.TableControl.Model.GetDisplayElementAt(row).GetData() as LRRHistData;
											if(histObj != null)
											{
												if(currentUomType != null)
												{
													histObj.UOMTypeID = currentUomType;
													LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
													string modelUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,currentUomType);
													string uiUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemUserInterfaceID,currentUomType);
													if(modelUOMID != null && modelUOMID.Trim() != "")
													{
														histObj.ModelUOM = modelUOMID;
													}
													else
													{
														histObj.ModelUOM = "";
													}
													histObj.InterfaceUnits = uiUOMID;
													histObj.HistUnits = "";
													histObj.InterfaceValue = "";
												}
											}
										}
										catch(Exception ex)
										{
											Logger.LogMessage(typeof(SyncGridUtilities),"PasteSelection :"+ex.Message  ,Logger.Level.Debug);

										}
									}
									this.gridHistorianData.Refresh(); 
								}
							}
						}
					}
					else
					{
						if(sColHeader != LRRHeaderText.GetHeaderString("SID_CUSTOMFORMULA")
							&& sColHeader != LRRHeaderText.GetHeaderString("SID_FORMULA")
							&& sColHeader != LRRHeaderText.GetHeaderString("SID_CONVERSIONFORMULA"))
						{
							SyncGridUtilities.PasteSelection(gridHistorianData);
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SyncGridUtilities),"PasteSelection :"+ex.Message  ,Logger.Level.Debug);

			}
		}


		public void InsertNewRows()
		{
			// TODO:  Add SiteComponentEntry.InsertNewRows implementation
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		#endregion

		private void DataHistorianPoints_Activated(object sender, EventArgs e)
		{
			LRRFormulaDataStore.DataSource = lrrFormulaHistData;
			LRRFormulaDataStore.ModeFlag = false;
			LRRFormulaDataStore.ShowGroupedAttributes = false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;

			SetConversionFormualDataStore();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//this.gridHistorianData.TableModel.BeginUpdate(Syncfusion.Windows.Forms.BeginUpdateOptions.None);
			//this.gridHistorianData.Table.TableDirty = true;
			//gridHistorianData.Table.SummariesDirty = true;
			SendMessage(gridHistorianData.Handle, WM_SETREDRAW, 0, 0); 

		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			//this.gridHistorianData.TableModel.EndUpdate(true);
			//this.gridHistorianData.Table.TableDirty = false;
			//this.gridHistorianData.Refresh();
			SendMessage(gridHistorianData.Handle, WM_SETREDRAW, 1, 0); 
			gridHistorianData.Invalidate(true);
		}

		private void gridHistorianData_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
            if (e.TableControl.CurrentCell.RowIndex == 3)
                return;
            GridTableModel tableModel = gridHistorianData.Table.TableModel;
			if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
				return;
			if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_INTERFACEUOM"))
			{
				string sUOMType = "";
				try
				{
					sUOMType = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(DataHistorianPoints),ex.Message  ,Logger.Level.Debug);
				}
				if(sUOMType != "" && sUOMType != null)
				{
					LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
					GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
					cr.ListBoxPart.DataSource = uoms;
					uoms.SortColumn="Name";
					uoms.Sort();
					cr.Model.SupportsChoiceList = false; 
					if(uoms.Count ==0)
					{
						LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					}
				}
			}
            else if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_HISTUOM"))
            {
                string sUOMType = "";
                try
                {
                    sUOMType = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData()).HistUOMTypeID;
                }
                catch (Exception ex)
                {
                    Logger.LogMessage(typeof(DataHistorianPoints), ex.Message, Logger.Level.Debug);
                }
                if (sUOMType != "" && sUOMType != null)
                {
                    LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
                    GridComboBoxCellRenderer cr = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
                    cr.ListBoxPart.DataSource = uoms;
                    uoms.SortColumn = "Name";
                    uoms.Sort();
                    cr.Model.SupportsChoiceList = false;
                    if (uoms.Count == 0)
                    {
                        LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                }
            }
            else if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_HIST_UOM_TYPE"))
            {
                LRRHistData histData = e.TableControl.Table.CurrentRecord.GetData() as LRRHistData;
                if (histData != null)
                {
                    if (histData.MeasType != "C" && histData.MeasType != "N")
                    {
                        e.Inner.Cancel = true;
                    }
                }
            }
			
		}

        private void gridHistorianData_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
			int iRow = e.TableControl.CurrentCell.RowIndex;
			int iCol = e.TableControl.CurrentCell.ColIndex;
			GridTableModel tableModel = gridHistorianData.Table.TableModel;
			if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
				return;
			
			if (tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText ==LRRHeaderText.GetHeaderString("SID_INTERFACEUOM"))
			{
				if(e.TableControl.Table.CurrentRecord == null)
					return;
				LRRHistData histData = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData());
				string oldUOM	  = histData.ModelUOM;
				string currentUOM = e.TableControl.CurrentCell.Renderer.ControlValue == null ? "" : e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
				ConvertUOM(histData,oldUOM,currentUOM);
			}

			if (tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText == LRRHeaderText.GetHeaderString("SID_UOMTYPE"))
			{
				if(e.TableControl.Table.CurrentRecord == null)
					return;
				LRRHistData histData = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData());
				string currentUOM = e.TableControl.CurrentCell.Renderer.ControlValue == null ? "" : e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
				if(currentUOM != "")
				{
					LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
					string modelUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,currentUOM);
					string uiUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemUserInterfaceID,currentUOM);
					
					if(e.TableControl.Table.CurrentRecord != null)
					{
						//LRRHistData histData = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData());
						if(modelUOMID != null && modelUOMID.Trim() != "")
						{
							//string modelUOM = LRRModel.ChildModel.GetUOMNameFromID(modelUOMID);
							//histData.ModelUOM = modelUOM;
							histData.ModelUOM = modelUOMID;

						}
						else
						{
							histData.ModelUOM = "";
						}
						histData.InterfaceUnits = uiUOMID;
						histData.InterfaceValue = "";
					}
				}
			}
            if (tableModel.GetColumnDescriptorAt(iRow, iCol).HeaderText == LRRHeaderText.GetHeaderString("SID_HIST_UOM_TYPE"))
            {
                if (e.TableControl.Table.CurrentRecord == null)
                    return;
                LRRHistData histData = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData());
                string currentUOM = e.TableControl.CurrentCell.Renderer.ControlValue == null ? "" : e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
                if (currentUOM != "")
                {
                    LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
                    string modelUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID, currentUOM);
                    string uiUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemUserInterfaceID, currentUOM);

                    if (e.TableControl.Table.CurrentRecord != null)
                    {
                        histData.HistUnits = uiUOMID;
                    }
                }
            }
            if (e.TableControl.Table.CurrentRecord != null)
                e.TableControl.Table.CurrentRecord.EndEdit();
		}

		private void rdDefaultToInterfaceUOM_CheckedChanged(object sender, System.EventArgs e)
		{
			if(rdDefaultToInterfaceUOM.Checked)
			{
				LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
				foreach(LRRHistData histData in _lrrHistData)
				{
					string interfaceUOM = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemUserInterfaceID,histData.UOMTypeID);
					string oldUOM = histData.ModelUOM;
					ConvertUOM(histData,oldUOM,interfaceUOM);
				}
			}
		}

		private void rdDefaultToModelUOM_CheckedChanged(object sender, System.EventArgs e)
		{
			if(rdDefaultToModelUOM.Checked)
			{
				LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
				foreach(LRRHistData histData in _lrrHistData)
				{
					string modelUOM = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,histData.UOMTypeID);
					string oldUOM = histData.ModelUOM;
					ConvertUOM(histData,oldUOM,modelUOM);
				}
			}
		}

		private void ConvertUOM(LRRHistData histData,string oldUOM,string currentUOM)
		{
			string val = histData.InterfaceValue;
			string val2 = histData.PostFilterUserOverride;
			string val3 = histData.InterfaceUnits;
			histData.InterfaceUnits = currentUOM;
			if(!(val2 == null || val2 == ""))
			{
				if(val3 != currentUOM)
				{
					histData.PostFilterUserOverride = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(val3,currentUOM,val2, false,null);
				}
			}
			if(val == null || val == "")
			{
				oldUOM = histData.UnderlyingInterfaceUnits;
				val = histData.UnderlyingInterfaceValue;
				if(oldUOM == currentUOM)
				{
					histData.InterfaceValue = val;
					interfaceVal=val;
					return;
				}
			}
			if((val != null && val != "")
				&& (oldUOM != null && oldUOM != "")
				&& (currentUOM != null && currentUOM != ""))
				//&& )
			{
				if(oldUOM != currentUOM)
				{
                    string newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldUOM, currentUOM, val, null);
					histData.DisplayInterfaceValue = newVal;
					interfaceVal=newVal;
				}
				else
				{
					histData.DisplayInterfaceValue = histData.InterfaceValue;
					interfaceVal=histData.InterfaceValue;
				}
			}
		}


        private void TableControl_ActivateToolTip(object sender, GridActivateToolTipEventArgs e)
        {
            
        }

		private void gridHistorianData_TableControlCellMouseHover(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventArgs e)
		{
		
				if (e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellType != "ComboBox" && e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellType != "ForeignKeyCell" && e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellType != "GridListControl")
				{
						//tool tip for the header cells only 
						 if(e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellType=="ColumnHeaderCell")
						 {
							 string txt=""; 
							 this.toolTip2.Active = true;
							 txt = LRRHeaderText.GetHeaderString("SID_"+e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].Text+"_DESC");  		
							 this.toolTip2.SetToolTip(this.gridHistorianData.TableControl,txt);
						 }
						 else
						 {
							 string text=""; 
							 this.toolTip2.Active = false;
							 if(e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellValueType!=null)
							 {
								 if( e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellValueType.Name=="LRRFormula")
								 {
									 this.toolTip1.Active = true;
									 text = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].Text;
									 this.toolTip1.SetToolTip(this.gridHistorianData.TableControl, text);
								 }
							 }
							 else
							 {
								  this.toolTip1.Active = false;
							 }	 
						 }		 
					
					 //this.toolTip1.Active = true;
					//if(e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellType=="ColumnHeaderCell")
					//{
					//   text= LRRHeaderText.GetHeaderString("SID_"+e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].Text+"_DESC");  			 
					//}
					//else
					//{
						//text = e.TableControl.Model[e.Inner.RowIndex, e.Inner.ColIndex].Text;					
					//}
					 //this.toolTip1.SetToolTip(this.gridHistorianData.TableControl, text);
				}
				else
				{
					 this.toolTip1.Active = false;
				    this.toolTip2.Active = false;
				}
		}

		private void gridHistorianData_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			//SourceObject ID
            GridTableModel tableModel = gridHistorianData.Table.TableModel;
            if(e.Action == CurrentRecordAction.EnterRecordComplete && e.Record.GetRecord() != null)
			{
				LRRFormulaDataStore.SourceObjectID = e.Record.GetRecord().GetValue("HistTagUID") == null ? "" : e.Record.GetRecord().GetValue("HistTagUID").ToString();
				LRRFormulaDataStore.ShowGroupedAttributes = false;
				LRRFormulaDataStore.SourceLookupPropertyID = null;
				LRRFormulaDataStore.SourceLookupQualifierID = null;
				LRRConversionFormulaDataStore.SourceObjectID = e.Record.GetRecord().GetValue("HistTagUID") == null ? "" : e.Record.GetRecord().GetValue("HistTagUID").ToString();
				string fromUOMID = e.Record.GetRecord().GetValue("HistUnits") == null ? "" : e.Record.GetRecord().GetValue("HistUnits").ToString();
				string fromUOM = "";
				if(fromUOMID.Trim() != "")
					fromUOM = LRRModel.ChildModel.GetUOMNameFromID(fromUOMID);
				LRRConversionFormulaDataStore.FromUOM = fromUOM;

				string toUOMID = e.Record.GetRecord().GetValue("ModelUOM") == null ? "" : e.Record.GetRecord().GetValue("ModelUOM").ToString();
				string toUOM = "";
				if(toUOMID.Trim() != "")
					toUOM = LRRModel.ChildModel.GetUOMNameFromID(toUOMID);
				LRRConversionFormulaDataStore.ToUOM = toUOM;
				LRRConversionFormulaDataStore.InterfaceValue = e.Record.GetRecord().GetValue("InterfaceValue") == null ? "" : e.Record.GetRecord().GetValue("InterfaceValue").ToString();
				
				LRRConstants objUserCons = new LRRConstants();

				foreach(LRRConstant objCons in LRRModel.ChildModel.ConstantsDefined)
				{
					if((objCons.InputSourceID != "2") && (objCons.ID != "0"))
					{
						objUserCons.Add(objCons);
					}
				}
			
				LRRConversionFormulaDataStore.LRRConstUser = objUserCons;
				SetConversionFormualDataStore();
			}
            if (e.Action == CurrentRecordAction.EnterRecordCalled && e.Record.GetRecord() != null)
            {
                LRRHistData histDataObj = e.Record.GetData() as LRRHistData;
                if(histDataObj != null)
                    _measType = histDataObj.MeasType;
            }
            if (e.Action == CurrentRecordAction.EndEditComplete && e.Record.GetRecord() != null)
            {
                LRRHistData histDataObj = e.Record.GetData() as LRRHistData;
                if (histDataObj != null)
                {
                    if (histDataObj.MeasType != "C" && histDataObj.MeasType != "N")
                    {
                        if (histDataObj.HistUOMTypeID != histDataObj.UOMTypeID)
                        {
                            histDataObj.HistUOMTypeID = histDataObj.UOMTypeID;
                            histDataObj.HistUnits = histDataObj.InterfaceUnits;
                        }
                    }
                }
            }
            
            if (e.Action == CurrentRecordAction.EndEditCalled && e.Record.Kind == DisplayElementKind.AddNewRecord)
            {
                
                string headerText = "";
                if (tableModel != null)
                {
                    if (tableModel.CurrentCellInfo != null)
                    {
                        headerText = tableModel.GetColumnDescriptorAt(tableModel.CurrentCellInfo.RowIndex, tableModel.CurrentCellInfo.ColIndex).HeaderText == null ? "" : tableModel.GetColumnDescriptorAt(tableModel.CurrentCellInfo.RowIndex, tableModel.CurrentCellInfo.ColIndex).HeaderText.ToString();
                    }
                }
                if (headerText == "Historian Tag")
                {
                    bool addNewRecord = true;
                    GridTransposedView.ApplyTransposedView(this.gridHistorianData, addNewRecord);
                }
            }
		}

		private void gridHistorianData_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(e.Inner.RowIndex != 2)
				return;
			GridTableModel tableModel = gridHistorianData.Table.TableModel;
			
			GridTableDescriptor tableDescriptor = e.TableControl.TableDescriptor;
			GridColumnDescriptor column = e.TableControl.Table.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex);
			string col = column.Name;
			if(col == "FormulaObj" || col == "ConversionFormulaObj" || col == "CustomFormulaObj")
			{
				int sortingOrder = 0;
				if(tableDescriptor.SortedColumns.Contains(col))
				{
					if(tableDescriptor.SortedColumns[col].SortDirection == ListSortDirection.Ascending)
						sortingOrder = 0;
					else
						sortingOrder = 1;
				}
				_lrrHistData.SortByFormulaExpression(sortingOrder,col);
				return;
			}

			if(e.TableControl.CurrentCell.RowIndex == -1 || e.TableControl.CurrentCell.ColIndex == -1)
				return;

			if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
				return;


			/*if ((tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_INTERFACEUOM"))
				|| (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_HISTUOM")))
			{
				string sUOMType = "";
				try
				{
					sUOMType = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(DataHistorianPoints),ex.Message  ,Logger.Level.Debug);
				}
				if(sUOMType != "" && sUOMType != null)
				{
					LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
					GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
					cr.ListBoxPart.DataSource = uoms;
					uoms.SortColumn="Name";
					uoms.Sort();
					if(uoms.Count ==0)
					{
						LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					}
				}
			}*/
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add DataHistorianPoints.ClearSort implementation
			SyncGridUtilities.ClearSort(gridHistorianData);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add DataHistorianPoints.SupportsClearSort implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add DataHistorianPoints.PrintPreview implementation
			if(gridHistorianData.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridHistorianData,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add DataHistorianPoints.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add DataHistorianPoints.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add DataHistorianPoints.ShowComponentList implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add DataHistorianPoints.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add DataHistorianPoints.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add DataHistorianPoints.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridHistorianData);
            Refresh();
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add DataHistorianPoints.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add DataHistorianPoints.SupportsUndo implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add DataHistorianPoints.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add DataHistorianPoints.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add DataHistorianPoints.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add DataHistorianPoints.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add DataHistorianPoints.SupportsCompositeView implementation
			return false;
		}

		#endregion


		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		private void gridHistorianData_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
			}
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add DataHistorianPoints.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		private void gridHistorianData_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			// try
			//   {
			//       if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			//     {  
			//             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			//             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			//     }  
			//  }
			//catch(Exception ex)
			//{
			//   MessageBox.Show(ex.Message);
			//}
			
			if(e.TableCellIdentity.RowIndex < 0)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex) == null)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_LEVEL") && e.TableCellIdentity.RowIndex > 3)
			{
				e.Style.CellType = "DropDownTree";
				string displaymember = e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit") == null ? "" :e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit").ToString();          
				if(displaymember != "")
				{
					string sFilter;
					sFilter = "LevelID = " + displaymember;
					_levels.ItemFilter = sFilter;
					GridTableCellStyleInfo gsi = new GridTableCellStyleInfo();
					gsi = e.Style;
					if(gsi != null)
					{
						if(_levels.Count>0)
							gsi.FormattedText = _levels[0].Name;  
						gsi.WrapText = true;
						gsi.AutoSize = true;
					}	
					_levels.ItemFilter ="";
				}
			}
		}

		private void gridContext_Popup(object sender, EventArgs e)
		{
			Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
			GridRecord gnt = eCurrentElement as GridRecord;
			if(eCurrentElement != null)
			{
				Record rec = eCurrentElement.GetRecord();
				if(rec!=null)
				{
					LRRHistData objHistData = rec.GetData() as LRRHistData;

					if(objHistData != null)
					{
						if(objHistData.HistTag != "" && objHistData.HistTag != null)
							EnableContextMenuItems();
						else
							DisableContextMenuItems();
					}
					else
					{
						DisableContextMenuItems();
					}
				}
				else
					DisableContextMenuItems();
			}
			else
				DisableContextMenuItems();
		}

        private void btnTransPosedView_Click(object sender, EventArgs e)
        {
            GridTransposedView.ApplyTransposedView(this.gridHistorianData,false);  
        }
        private void btnCheckValidation_Click(object sender, EventArgs e)
        {
            IList dataSource = gridHistorianData.Engine.Table.SourceList;
            CustomCollection cc = dataSource as CustomCollection;
            HistdataValidation histDataValiDation = new HistdataValidation(cc);
            histDataValiDation.ShowDialog(); 
        }
	}

}





