using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;
using System.IO;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.ExecutionEngine.Model;

using Symcon.LightRidge.PEAdvisor.GridUtilities;


//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ExecutionEngineModel.
	/// </summary>
	public class ExecutionEngineModel : System.Windows.Forms.Form,ILRRUIContainer

	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ExecutionEngineModel()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InternationalizationUtils.GetControlText(this,null);
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridExecutionEngineModel = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridExecutionEngineModel)).BeginInit();
			this.SuspendLayout();
			// 
			// gridExecutionEngineModel
			// 
			this.gridExecutionEngineModel.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridExecutionEngineModel.BackColor = System.Drawing.SystemColors.Window;
			this.gridExecutionEngineModel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridExecutionEngineModel.Location = new System.Drawing.Point(0, 0);
			this.gridExecutionEngineModel.Name = "gridExecutionEngineModel";
			this.gridExecutionEngineModel.Size = new System.Drawing.Size(792, 486);
			this.gridExecutionEngineModel.TabIndex = 0;
			this.gridExecutionEngineModel.TableOptions.AllowSortColumns = false;
			this.gridExecutionEngineModel.Text = "gridGroupingControl1";
			this.gridExecutionEngineModel.ThemesEnabled = false;
			this.gridExecutionEngineModel.TopLevelGroupOptions.CaptionText = "";
			this.gridExecutionEngineModel.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridExecutionEngineModel.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridExecutionEngineModel.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridExecutionEngineModel.TopLevelGroupOptions.ShowCaption = false;
			this.gridExecutionEngineModel.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridExecutionEngineModel.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridExecutionEngineModel.VersionInfo = "3.301.0.0";
			this.gridExecutionEngineModel.TableControlCellButtonClicked += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellButtonClickedEventHandler(this.gridExecutionEngineModel_TableControlCellButtonClicked);
			this.gridExecutionEngineModel.TableControlCurrentCellChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridExecutionEngineModel_TableControlCurrentCellChanged);
			this.gridExecutionEngineModel.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridExecutionEngineModel_TableControlPrepareViewStyleInfo);
			// 
			// ExecutionEngineModel
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 486);
			this.Controls.Add(this.gridExecutionEngineModel);
			this.Name = "ExecutionEngineModel";
			this.Tag = "SID_EX_ENGINE_MODEL";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.ExecutionEngineModel_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridExecutionEngineModel)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		private LRRApp						_app;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridExecutionEngineModel;
		private LRRExecutionEngineModels	_lrrExecutionEngineModels=null;
		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private	int					checkBoxCol=0;

		#endregion

		#region BindExecutionEngineModel

		private void BingGridExecutionEngineModel()
		{
			_lrrExecutionEngineModels=new LRRExecutionEngineModels();
			_app.DBManagerObj.PopulateCollection(_lrrExecutionEngineModels,false);
			//Suspend the Layout of the Grid...
			gridExecutionEngineModel.SuspendLayout();
			//SyncGridUtilities.InitializeGridLookAndFeel(gridExecutionEngineModel);
			//gridExecutionEngineModel.TableModel.Model.CellModels.Add("EllipsisText", new  EllipsisCellModel(gridExecutionEngineModel.TableModel.Model));
//			SyncGridUtilities.InitializeGridColumns(gridExecutionEngineModel,gridExecutionEngineModel.TableDescriptor,_lrrExecutionEngineModels.ItemType,null);
			
//			gridExecutionEngineModel.TableDescriptor.Columns.Clear();
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Model Name","ModelName");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Model Description","ModelDescription");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Book","WorkBookName");
//
//
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Sheet","WorkSheetName");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Rest","Rest");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Front","Front");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Datain","Datain");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("SSEarly","SSEarly");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("SystStat","SystStat");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("SSDetail","SSDetail");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("SCEarly","SCEarly");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Scen","Scen");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Optim","Optim");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("SC Detail","SCDetail");
//			gridExecutionEngineModel.TableDescriptor.Columns.Add("Back","Back");
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Book"].Appearance.AnyRecordFieldCell.CellType ="EllipsisText";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Book"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;

//			this.gridExecutionEngineModel.TableDescriptor.Columns["Rest"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Rest"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Rest"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Front"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Front"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Front"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Datain"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Datain"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Datain"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SSEarly"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SSEarly"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SSEarly"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SystStat"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SystStat"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SystStat"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SSDetail"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SSDetail"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SSDetail"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SCEarly"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SCEarly"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SCEarly"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Scen"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Scen"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Scen"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Optim"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Optim"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Optim"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SC Detail"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SC Detail"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["SC Detail"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Back"].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Back"].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
//			this.gridExecutionEngineModel.TableDescriptor.Columns["Back"].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;
			//int rowIndex;
			//gridExecutionEngineModel.Engine.SourceListSet.Add("ParentTable",_lrrExecutionEngineModels);

			
			SyncGridUtilities.InitializeGridColumns(gridExecutionEngineModel,gridExecutionEngineModel.TableDescriptor,_lrrExecutionEngineModels.ItemType,null,true,null,null,true);
			//Set the data store 
			gridExecutionEngineModel.DataSource = _lrrExecutionEngineModels;
//			//Resume the Layout of the Grid...
			gridExecutionEngineModel.ResumeLayout(true);
			
			string[,] arry=new string[,]{{"ModelDescription","255"}};
			Validations	obj=new Validations(gridExecutionEngineModel,arry);
		}

		#endregion

		#region Events
	
		private void gridExecutionEngineModel_TableControlCellButtonClicked(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellButtonClickedEventArgs e)
		{
//			string fileName="";
//			OpenFileDialog flDialog = new OpenFileDialog();
//			flDialog.Filter ="Excel files | *.xls";
//			if(flDialog.ShowDialog() == DialogResult.OK)
//			{
//				fileName=  Path.GetFileName(flDialog.FileName);
//				gridExecutionEngineModel.TableModel.Model[e.Inner.RowIndex,e.Inner.ColIndex].CellValue=fileName;
//				
//			}
		}

		private void gridExecutionEngineModel_TableControlCurrentCellChanged(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{
//			checkBoxCol=9;
//			if(this.gridExecutionEngineModel.TableControl.CurrentCell.ColIndex == checkBoxCol)
//			{
//				this.gridExecutionEngineModel.TableControl.CurrentCell.ConfirmChanges();
//				this.gridExecutionEngineModel.GetTableControl(gridExecutionEngineModel.TableControl.Name).RefreshRange(GridRangeInfo.Row(this.gridExecutionEngineModel.TableControl.CurrentCell.RowIndex));
//
//			}
		}
	
		private void gridExecutionEngineModel_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			try
			{

				if(e.Inner.RowIndex > 0 && e.Inner.ColIndex > 0)
				{
					
					if(this.gridExecutionEngineModel.TableModel.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellType=="CheckBox")
					{
						object o = this.gridExecutionEngineModel.TableModel.Model[e.Inner.RowIndex, e.Inner.ColIndex].CellValue;
						if(o!=null)
						{
							bool val = o.ToString() == true.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							if(val)
							{
								e.Inner.Style.BackColor = Color.FromArgb(153,204,0);
							}
							else if(val==false)
								e.Inner.Style.BackColor = Color.FromArgb(255,102,0);
						}
					}
					//else
						//e.Inner.Style.BackColor = Color.FromArgb(192,192,192);
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(ExecutionEngineModel),ex.Message  ,Logger.Level.Debug);
				return;
			}
		}
		
	

		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			BingGridExecutionEngineModel();
		}

		public void Save()
		{
			if(_lrrExecutionEngineModels.GetChanges().Count>0)
			{
				_app.DBManagerObj.CommitCollection(_lrrExecutionEngineModels.GetChanges());
				if(_lrrExecutionEngineModels.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				}	
			}
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add ComplexEquip.ClearFilter implementation
			this.gridExecutionEngineModel.TableDescriptor.RecordFilters.Clear();
		}
		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridExecutionEngineModel);
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridExecutionEngineModel);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			InsertNewRowsForm insNewRows = new InsertNewRowsForm();
			DialogResult dlgResult = insNewRows.ShowDialog(this);
			int iNumofRows = insNewRows.iNewRows;
			if(dlgResult == DialogResult.OK)
			{
				for(int i = 0; i < iNumofRows;i++)
				{
					LRRExecutionEngineModel ee = new LRRExecutionEngineModel();
					_lrrExecutionEngineModels.Add(ee);
				}
				gridExecutionEngineModel.Refresh();
			}
			else
			{
				return;
			}
		}

		public void Export()
		{
			if(gridExecutionEngineModel.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridExecutionEngineModel);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		private void ExecutionEngineModel_Load(object sender, System.EventArgs e)
		{
			BingGridExecutionEngineModel();
		}

	

	

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add ExecutionEngineModel.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add ExecutionEngineModel.SupportsClearSort implementation
			return false;
		}

		#endregion
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add ExecutionEngineModel.PrintPreview implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add ExecutionEngineModel.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add ExecutionEngineModel.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add ExecutionEngineModel.ShowComponentList implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add ExecutionEngineModel.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add ExecutionEngineModel.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add ExecutionEngineModel.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add ExecutionEngineModel.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add ExecutionEngineModel.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add ExecutionEngineModel.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add ExecutionEngineModel.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add ExecutionEngineModel.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add ExecutionEngineModel.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add ExecutionEngineModel.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add ExecutionEngineModel.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add ExecutionEngineModel.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add ExecutionEngineModel.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add ExecutionEngineModel.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add ExecutionEngineModel.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}

}
