using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageLogger;

using Symcon.BusinessObjects; 
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ExcelView.
	/// </summary>
	public class ExcelView : System.Windows.Forms.Form, ILRRUIContainer, ILRRView
	{
		private System.ComponentModel.IContainer components;

		public ExcelView()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}

		public ExcelView(string viewID)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			_ucExcelView = LoadExcelView(viewID);
			_pnlUC = new Panel();
			_pnlUC.Size = _ucExcelView.Size;
			_pnlUC.Dock = _ucExcelView.Dock;
			_pnlUC.Controls.Add(_ucExcelView);
			this.Controls.Add(_pnlUC);
			this.AutoScroll = true;
			if(_ucExcelView.GetType() != typeof(UserControls.UserControlExcelNamedRangeView))
				this.childFrameBarManager1.Dispose();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ExcelView));
			this.childFrameBarManager1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager(this.components, this);
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager1, "Zoom");
			this.comboBoxBarItemZoom = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.CanvasToolbarImages = new System.Windows.Forms.ImageList(this.components);
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).BeginInit();
			// 
			// childFrameBarManager1
			// 
			this.childFrameBarManager1.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("childFrameBarManager1.BarPositionInfo")));
			this.childFrameBarManager1.Bars.Add(this.bar1);
			this.childFrameBarManager1.Categories.Add("Zoom");
			this.childFrameBarManager1.CurrentBaseFormType = "";
			this.childFrameBarManager1.DisabledImageList = null;
			this.childFrameBarManager1.DisabledLargeImageList = null;
			this.childFrameBarManager1.Form = this;
			this.childFrameBarManager1.ImageList = null;
			this.childFrameBarManager1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											   this.comboBoxBarItemZoom});
			this.childFrameBarManager1.LargeImageList = null;
			// 
			// bar1
			// 
			this.bar1.BarName = "Zoom";
			this.bar1.Caption = "Zoom";
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.comboBoxBarItemZoom});
			this.bar1.Manager = this.childFrameBarManager1;
			// 
			// comboBoxBarItemZoom
			// 
			this.comboBoxBarItemZoom.CategoryIndex = 0;
			this.comboBoxBarItemZoom.ChoiceList.AddRange(new string[] {
																		  "25%",
																		  "50%",
																		  "75%",
																		  "100%",
																		  "150%",
																		  "200%",
																		  "300%",
																		  "400%",
																		  "500%"});
			this.comboBoxBarItemZoom.Editable = false;
			this.comboBoxBarItemZoom.ID = "Zoom:";
			this.comboBoxBarItemZoom.ImageIndex = 17;
			this.comboBoxBarItemZoom.ImageList = this.CanvasToolbarImages;
			this.comboBoxBarItemZoom.Text = "Zoom:";
			this.comboBoxBarItemZoom.TextBoxValue = "100%";
			this.comboBoxBarItemZoom.Click += new System.EventHandler(this.comboBoxBarItemZoom_Click);
			// 
			// CanvasToolbarImages
			// 
			this.CanvasToolbarImages.ImageSize = new System.Drawing.Size(16, 16);
			this.CanvasToolbarImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("CanvasToolbarImages.ImageStream")));
			this.CanvasToolbarImages.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// ExcelView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1144, 741);
			this.Name = "ExcelView";
			this.Text = "ExcelView";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).EndInit();

		}
		#endregion

		#region Public Properties

		public int LastZoom
		{
			get { return _lastZoom; }
			set
			{
				try
				{
					_lastZoom = value;
					if(_ucExcelView.GetType() == typeof(UserControls.UserControlExcelNamedRangeView))
					{
						comboBoxBarItemZoom.TextBoxValue = _lastZoom.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "%";
						Zoom();
					}
				}
				catch
				{

				}
			}
		}
		#endregion

		#region Fields

		private LRRApp	_lrrApp;
		private TabPage _parentTabPage;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager childFrameBarManager1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem comboBoxBarItemZoom;
		private TabControl _parentTabControl;
		private int _lastZoom = 100;
		private UserControl _ucExcelView;
		private System.Windows.Forms.ImageList CanvasToolbarImages;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Panel _pnlUC;

		#endregion
		
		#region ILRRUIContainer Members
		public new void Refresh()
		{
		}
		public void Save()
		{
		}
		public void CopyMasterProperties()
		{
		}
		public void Paste()
		{
		}
		public void Copy()
		{
		}
		public void Print()
		{
		}
		public void Delete()
		{
		}
		public void ArrangeColumns()
		{
		}
		public void ClearFilter()
		{
		}
		public void InsertNewRows()//Inserts New rows 
		{
		}
		public void ImportToExcel()
		{
		}
		public void Export()
		{
		}
		public void SelectionPaste()
		{
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		//Methods Suported
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsCopy()
		{
			return false;
		}
		public bool SupportsPaste()
		{
			return false;
		}
		public bool SupportsExport()
		{
			return true;
		}
		public bool SupportsSave()
		{
			return true;
		}
		public bool SupportsRefresh()
		{
			return false;
		}
		public bool SupportsDelete()
		{
			return false;
		}
		public bool SupportsPrint()
		{
			return false;
		}
		public bool SupportsArrangeColumns()
		{
			return false;
		}
		public bool SupportsClearFilter()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			return false;
		}
		public bool SupportsImportToExcel()
		{
			return false;
		}
		public bool SupportsSelectionPaste()
		{
			return false;
		}
		public bool SupportsLevel()
		{
			return false;
		}

		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add Chart.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add Chart.SupportsClearSort implementation
			return false;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add Chart.PrintPreview implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add Chart.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add Chart.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add Chart.ShowComponentList implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add Chart.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add Chart.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add Chart.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add Chart.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add Chart.SupportsUndo implementation
			return false;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add Chart.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add Chart.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add Chart.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add Chart.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add Chart.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRView Members

		public Panel Open(object id)
		{
			Panel pnl = new Panel();
			try
			{
				
				UserControl ucExcelView = LoadExcelView(id.ToString());
				
				ucExcelView.Dock = DockStyle.Fill;
				pnl.Controls.Add(ucExcelView);
				
			}
			catch(Exception ex)
			{
				Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(ExcelView),"Could not load Excel View: " + ex.Message + ex.StackTrace, Symcon.Utils.MessageLogger.Logger.Level.Debug);
			}
			return pnl;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add InputOutputViews.PerformDirtyChk getter implementation
				return false;
			}
		}

		#endregion

		#region Private Methods
		private UserControl LoadExcelView(string viewID)
		{
			UserControl ucExcelView = null;
			//this.childFrameBarManager1.Bars.Clear();
			LRRExcelView excelView = new LRRExcelView();
			_lrrApp.DBManagerObj.PopulateObject(excelView,typeof(LRRExcelView), " WHERE ID='" + viewID + "'");

			switch(excelView.ViewType)
			{
				case "Chart":
					ucExcelView = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlChart(excelView.ViewID);
					ucExcelView.Dock = DockStyle.Fill;
					break;
				case "Charts":
					ucExcelView = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlCharts(excelView.ViewID);
					ucExcelView.Dock = DockStyle.Fill;
					break;
				case "Misc":
					ucExcelView = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlExcelNamedRangeView(excelView.ViewID);
					ucExcelView.Dock = DockStyle.None;
					//this.childFrameBarManager1.Bars.Add(this.bar1);
					UserControls.UserControlExcelNamedRangeView ucENRV = ucExcelView as UserControls.UserControlExcelNamedRangeView;
					ucENRV.Zoom(100);
					this.BackColor = ucExcelView.BackColor;
					break;
			}
			this.Text = ucExcelView.Text;
			return ucExcelView;
		}

		private void Zoom()
		{
			try
			{
				double dblZoom = double.Parse(comboBoxBarItemZoom.TextBoxValue.Replace("%","").Trim(),Symcon.BusinessObjects.SymConverter.Culture);
				int nZoom = (int)dblZoom;
				comboBoxBarItemZoom.TextBoxValue = nZoom.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "%";
				
				if(_ucExcelView.GetType() == typeof(UserControls.UserControlExcelNamedRangeView))
				{
					UserControls.UserControlExcelNamedRangeView ucENRV = _ucExcelView as UserControls.UserControlExcelNamedRangeView;
					ucENRV.Zoom(nZoom);

					_pnlUC.Width = ucENRV.Width;
					_pnlUC.Height = ucENRV.Height;
				}

				_lastZoom = nZoom;
			}
			catch(Exception ex)
			{
				comboBoxBarItemZoom.TextBoxValue = _lastZoom.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "%";
				Logger.LogMessage(typeof(ExcelView),"buttonZoom_Click Event:" + ex.Message,Logger.Level.Debug);
			}
		}
		#endregion

		private void comboBoxBarItemZoom_Click(object sender, System.EventArgs e)
		{
			Zoom();
		}
	}
}
