using System;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Grouping;
using Syncfusion.ExcelRW;
using Syncfusion.ComponentModel;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ImportFromExcel.
	/// </summary>
	public class ExportToExcel : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;

		private string fname = null;
		private System.Windows.Forms.Label lblExcelFile;
		private System.Windows.Forms.TextBox txtExcel;

		private GridGroupingControl gridControl = null;
		private GridControl gridInstance = null;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		public ExportToExcel()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public ExportToExcel(GridGroupingControl gridControl)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 

			this.gridControl = gridControl;
		}

		public ExportToExcel(GridControl gridInstance)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			this.gridInstance = gridInstance;
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ExportToExcel));
            this.button1 = new System.Windows.Forms.Button();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.lblExcelFile = new System.Windows.Forms.Label();
            this.btnOK = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.txtExcel = new System.Windows.Forms.TextBox();
            this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.button1.ImageIndex = 0;
            this.button1.ImageList = this.imageList1;
            this.button1.Location = new System.Drawing.Point(384, 24);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 24);
            this.button1.TabIndex = 0;
            this.button1.Tag = "SID_BROWSE";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            // 
            // lblExcelFile
            // 
            this.lblExcelFile.Location = new System.Drawing.Point(8, 0);
            this.lblExcelFile.Name = "lblExcelFile";
            this.lblExcelFile.Size = new System.Drawing.Size(112, 24);
            this.lblExcelFile.TabIndex = 1;
            this.lblExcelFile.Tag = "SID_SELECTEXCELFILE";
            this.lblExcelFile.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // btnOK
            // 
            this.btnOK.Location = new System.Drawing.Point(296, 64);
            this.btnOK.Name = "btnOK";
            this.btnOK.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
            this.btnOK.Size = new System.Drawing.Size(75, 24);
            this.btnOK.TabIndex = 2;
            this.btnOK.Tag = "SID_OK";
            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // btnCancel
            // 
            this.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnCancel.ImageIndex = 4;
            this.btnCancel.ImageList = this.imageList1;
            this.btnCancel.Location = new System.Drawing.Point(384, 64);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(75, 24);
            this.btnCancel.TabIndex = 3;
            this.btnCancel.Tag = "SID_CLOSE";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // txtExcel
            // 
            this.txtExcel.Location = new System.Drawing.Point(8, 24);
            this.txtExcel.Name = "txtExcel";
            this.txtExcel.Size = new System.Drawing.Size(352, 20);
            this.txtExcel.TabIndex = 4;
            // 
            // ExportToExcel
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(474, 96);
            this.Controls.Add(this.txtExcel);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnOK);
            this.Controls.Add(this.lblExcelFile);
            this.Controls.Add(this.button1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "ExportToExcel";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Tag = "SID_EXPORTTOEXCEL";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

        private bool isFileExists = false;

		private void button1_Click(object sender, System.EventArgs e)
		{
			saveFileDialog.Filter = "Excel Files|*.xls";
			DialogResult dlgResult = saveFileDialog.ShowDialog();
            if (dlgResult == DialogResult.OK)
            {
                System.IO.FileInfo fileInfo = new System.IO.FileInfo(saveFileDialog.FileName);
                if (fileInfo.Exists)
                {
                    isFileExists = true;
                }
                fname = saveFileDialog.FileName;
                txtExcel.Text = fname;
                return;
            }
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			if(fname == null || fname == "")
			{
				LRRMessagBox.ShowMessage("SID_EXCELSELECTION","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);	  
				return;
			}
            bool retResult =false;
			this.Cursor = Cursors.WaitCursor;
			ExportToExcelUtility excelUtil = new ExportToExcelUtility();

			if(gridControl != null)
			{
				retResult = excelUtil.ExportToExcel(gridControl,fname,isFileExists);
			}
			else
			{
				retResult =  excelUtil.writeToExcel(gridInstance,fname,isFileExists);
			}

            if (retResult)
            {
                LRRMessagBox.ShowMessage("SID_EXPORTCOMPLETED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Cursor = Cursors.Default;
                this.Close();
                return;
            }
            else
            {
                this.Cursor = Cursors.Default;
            }
		}
	}
}
