using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;

using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.DataQualityConfiguration;
using Symcon.LightRidge.BusinessObjects.Utilities;
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for DataQuality.
	/// </summary>
	
	public class DataQuality : System.Windows.Forms.Form
	{
		#region Form Design Fields
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Panel panelViewBy;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton rdPlantItem;
		private System.Windows.Forms.Panel pnlTreeView;
		private System.Windows.Forms.RadioButton rdLevel;
		private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager1;
		private System.Windows.Forms.Panel pnlLegends;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Button button1;
		private System.ComponentModel.IContainer components;
		#endregion	
		
		/// <summary>
		/// Constructor to initialize the private objects
		/// </summary>
		public DataQuality()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrapp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrCompTypes = new LRRComponentTypes();
			_lrrLevels = new LRRLevels();
			_lrrLevelLinks  = new LRRLevelLinks();
			_mainFrameStatusBar =	_lrrapp.MainFrame.GetStatusBar();
		}

       
		
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DataQuality));
			this.panel1 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlTreeView = new System.Windows.Forms.Panel();
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.panelViewBy = new System.Windows.Forms.Panel();
			this.pnlLegends = new System.Windows.Forms.Panel();
			this.dqLegend1 = new Symcon.LightRidge.PEAdvisor.DQLegend();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.rdLevel = new System.Windows.Forms.RadioButton();
			this.rdPlantItem = new System.Windows.Forms.RadioButton();
			this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.button1 = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.pnlTreeView.SuspendLayout();
			this.panelViewBy.SuspendLayout();
			this.pnlLegends.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.button1);
			this.panel1.Controls.Add(this.splitter2);
			this.panel1.Controls.Add(this.splitter1);
			this.panel1.Controls.Add(this.pnlTreeView);
			this.panel1.Controls.Add(this.panelViewBy);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(480, 526);
			this.panel1.TabIndex = 16;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 110);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(480, 2);
			this.splitter1.TabIndex = 24;
			this.splitter1.TabStop = false;
			// 
			// pnlTreeView
			// 
			this.pnlTreeView.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlTreeView.Controls.Add(this.treeView1);
			this.pnlTreeView.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlTreeView.Location = new System.Drawing.Point(0, 110);
			this.pnlTreeView.Name = "pnlTreeView";
			this.pnlTreeView.Size = new System.Drawing.Size(480, 346);
			this.pnlTreeView.TabIndex = 21;
			// 
			// treeView1
			// 
			this.treeView1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.treeView1.ImageList = this.imageList1;
			this.treeView1.Location = new System.Drawing.Point(0, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = 4;
			this.treeView1.Size = new System.Drawing.Size(478, 344);
			this.treeView1.TabIndex = 18;
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// panelViewBy
			// 
			this.panelViewBy.Controls.Add(this.pnlLegends);
			this.panelViewBy.Controls.Add(this.groupBox1);
			this.panelViewBy.Dock = System.Windows.Forms.DockStyle.Top;
			this.panelViewBy.Location = new System.Drawing.Point(0, 0);
			this.panelViewBy.Name = "panelViewBy";
			this.panelViewBy.Size = new System.Drawing.Size(480, 110);
			this.panelViewBy.TabIndex = 19;
			// 
			// pnlLegends
			// 
			this.pnlLegends.BackColor = System.Drawing.SystemColors.Window;
			this.pnlLegends.Controls.Add(this.dqLegend1);
			this.pnlLegends.Dock = System.Windows.Forms.DockStyle.Right;
			this.pnlLegends.Location = new System.Drawing.Point(224, 0);
			this.pnlLegends.Name = "pnlLegends";
			this.pnlLegends.Size = new System.Drawing.Size(256, 144);
			this.pnlLegends.TabIndex = 20;
			// 
			// dqLegend1
			// 
			this.dqLegend1.AutoScroll = true;
			this.dqLegend1.BackColor = System.Drawing.SystemColors.Window;
			this.dqLegend1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dqLegend1.Location = new System.Drawing.Point(0, 0);
			this.dqLegend1.Name = "dqLegend1";
			this.dqLegend1.Size = new System.Drawing.Size(256, 144);
			this.dqLegend1.TabIndex = 0;
			this.dqLegend1.Tag = "SID_DQLEGEND";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.rdLevel);
			this.groupBox1.Controls.Add(this.rdPlantItem);
			this.groupBox1.Location = new System.Drawing.Point(8, 24);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(200, 72);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Tag = "SID_VIEWDATA_QUALITY";
			// 
			// rdLevel
			// 
			this.rdLevel.Location = new System.Drawing.Point(136, 24);
			this.rdLevel.Name = "rdLevel";
			this.rdLevel.Size = new System.Drawing.Size(56, 24);
			this.rdLevel.TabIndex = 1;
			this.rdLevel.Tag = "SID_LEVELS";
			this.rdLevel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rdLevel.CheckedChanged += new System.EventHandler(this.rdLevel_CheckedChanged);
			// 
			// rdPlantItem
			// 
			this.rdPlantItem.Checked = true;
			this.rdPlantItem.Location = new System.Drawing.Point(35, 24);
			this.rdPlantItem.Name = "rdPlantItem";
			this.rdPlantItem.Size = new System.Drawing.Size(95, 24);
			this.rdPlantItem.TabIndex = 0;
			this.rdPlantItem.TabStop = true;
			this.rdPlantItem.Tag = "SID_PLANT_ITEMS";
			// 
			// dockingManager1
			// 
			this.dockingManager1.AutoHideInterval = 200;
			this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
			this.dockingManager1.HostControl = this;
			this.dockingManager1.ShowToolTips = true;
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(0, 482);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(480, 2);
			this.splitter2.TabIndex = 25;
			this.splitter2.TabStop = false;
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.SystemColors.Control;
			this.button1.Location = new System.Drawing.Point(400, 465);
			this.button1.Name = "button1";
			this.button1.TabIndex = 26;
			this.button1.Tag = "SID_CLOSE";
			this.button1.Click +=new EventHandler(button1_Click);
			//this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			// 
			// DataQuality
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.ClientSize = new System.Drawing.Size(480, 495);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.Name = "DataQuality";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_DATA_QUALITY";
			this.Load += new System.EventHandler(this.DataQuality_Load);
			this.panel1.ResumeLayout(false);
			this.pnlTreeView.ResumeLayout(false);
			this.panelViewBy.ResumeLayout(false);
			this.pnlLegends.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Properties
		/// <summary>
		/// Return true if view is by plant items.
		/// Return false if view is by levels.
		/// </summary>
		public bool ViewDQByPlantItem
		{
			get
			{
				if(rdPlantItem.Checked)
					return true;
				else
					return false;
			}
		}

		
		public DQLegend LegendUserControlObj
		{
			get
			{
				return dqLegend1;
			}
		}
		
		#endregion
			
		#region Overrides
		/// <summary>
		/// Overrides the onclosing event
		/// </summary>
		protected override void OnClosing(CancelEventArgs e)
		{
			e.Cancel = true;
			this.Hide();
			_lrrapp.MainFrame.Activate();
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Private Methods
		/// <summary>
		/// Create the node containing child nodes for the given parent ID
		/// </summary>
		/// <param name="sParentID"></param>
		/// <param name="trvNode"></param>
		private void CreateGrandChild(string sParentID,TreeNode trvNode)
		{
			string sSiteComponentID = "";
			string sSiteComponentName = "";
			LRRLevelLinks lvlLinks = _lrrLevelLinks.GetAllChildLevels(sParentID);
			IEnumerator levelEnum = lvlLinks.GetEnumerator();
			while(levelEnum.MoveNext())
			{
				TreeNode child = new TreeNode();
				LRRLevelLink levelLinkObj = levelEnum.Current as LRRLevelLink;
				child.Tag =	_lrrLevels.getLevelByLevelID(levelLinkObj.ChildID);
				child.Text = _lrrLevels.getLevelByLevelID(levelLinkObj.ChildID).Name;

				CreateGrandChild(levelLinkObj.ChildID,child);
	
				LRRSiteComponents objComponents = LRRModel.SiteComponentsObj.FilterSiteComponentsByLevelID(levelLinkObj.ChildID.ToString(Symcon.BusinessObjects.SymConverter.Culture));
				objComponents.SortColumn = "Name";
				objComponents.Sort();
				foreach(LRRSiteComponent sc	in objComponents)
				{
							
					LRRLevel lvl = _lrrLevels.getLevelByLevelID(levelLinkObj.ChildID);
					sSiteComponentID = sc.SiteComponentID == null ? "" : sc.SiteComponentID;
					sSiteComponentName = sc.Name == null ? "" : sc.Name;

					TreeNode grandChildNode = new TreeNode();
					sSiteComponentName = sSiteComponentName + " [" + sc.EquipmentTag + "]";
							
					sSiteComponentName = ApplySiteComponentDQ(grandChildNode,sSiteComponentID,sSiteComponentName);
					grandChildNode.Text	= sSiteComponentName;

					child.Nodes.Add(grandChildNode);
							
				}
				trvNode.Nodes.Add(child);
			}
		}

        /// <summary>
        /// Apply DQ Status on the Levels
        /// </summary>
        /// <param name="oNode"></param>
        /// <param name="sSiteComponentID"></param>
        /// <param name="sSiteComponentName"></param>
        /// <returns></returns>
        private string ApplyLevelDQ(TreeNode oNode, string sLevelID, string sLevelName)
        {
            string sDQRangendex = "";

            DQDetails objLevelDtls = new DQDetails();
            objLevelDtls = AnalyzeDataQuality.InterpretLevelDQWithTag(sLevelID);
            if (objLevelDtls.Count > 0)
            {
                Hashtable htPercent = objLevelDtls.Percent;
                string sPercent = "...";
                if (htPercent.Count > 0)
                {
                    sPercent = htPercent[ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/";
                    sPercent = sPercent + htPercent[ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/";
                    sPercent = sPercent + htPercent[ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/";
                    sPercent = sPercent + htPercent[ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString();
                }
                sLevelName = sLevelName + " [" + sPercent + "]%";

                sDQRangendex = AnalyzeDataQuality.GetDQRangeImageIndex(objLevelDtls.ImageSummary);

                if (sDQRangendex != "")
                    oNode.ImageIndex = int.Parse(sDQRangendex, Symcon.BusinessObjects.SymConverter.Culture);

                oNode.ForeColor = objLevelDtls.ForeColor;

            }
            else
            {
                sLevelName = sLevelName + " [ No Tag ]";
                oNode.ForeColor = SystemColors.ControlDarkDark;
            }

            return sLevelName;
        }
		
		/// <summary>
		/// Apply DQ Status on the Plant Items
		/// </summary>
		/// <param name="oNode"></param>
		/// <param name="sSiteComponentID"></param>
		/// <param name="sSiteComponentName"></param>
		/// <returns></returns>
		private string ApplySiteComponentDQ(TreeNode oNode,string sSiteComponentID,string sSiteComponentName)
		{
			string sDQRangendex = "";

			DQDetails objSiteCompDtls = new DQDetails();
			objSiteCompDtls = AnalyzeDataQuality.InterpretSiteComponentDQWithTag(sSiteComponentID);
			if(objSiteCompDtls.Count>0)
			{
				Hashtable htPercent = objSiteCompDtls.Percent;
				string sPercent = "...";
				if(htPercent.Count>0)
				{
					sPercent = htPercent[ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() ;
				}
				sSiteComponentName = sSiteComponentName + " [" + sPercent + "]%";
				
				sDQRangendex = AnalyzeDataQuality.GetDQRangeImageIndex(objSiteCompDtls.ImageSummary);
				
				if(sDQRangendex != "")
					oNode.ImageIndex =int.Parse(sDQRangendex,Symcon.BusinessObjects.SymConverter.Culture);	

				oNode.ForeColor = objSiteCompDtls.ForeColor;

			}
			else
			{
				sSiteComponentName = sSiteComponentName + " [ No Tag ]";
				oNode.ForeColor =  SystemColors.ControlDarkDark;
			}

			return sSiteComponentName;
		}
		
		
		/// <summary>
		/// Apply DQ Status on the MasterComponent
		/// </summary>
		/// <param name="child"></param>
		/// <param name="sMasterComponentID"></param>
		/// <param name="sMasterComponentName"></param>
		/// <returns></returns>
		private string ApplyMasterComponentDQ(TreeNode child ,string sMasterComponentID, string sMasterComponentName)
		{
			string sDQRangendex = "";
			DQDetails objMasterCompType = new DQDetails();
			objMasterCompType = AnalyzeDataQuality.InterpretMasterComponentDQWithTag(sMasterComponentID);
							
			if(objMasterCompType.Count>0)
			{
				Hashtable htPercent = objMasterCompType.Percent;
				string sPercent = "...";
				if(htPercent.Count>0)
				{
					sPercent = htPercent[ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() ;
				}
				sMasterComponentName = sMasterComponentName + " [" + sPercent + "]%";
				
				sDQRangendex = AnalyzeDataQuality.GetDQRangeImageIndex(objMasterCompType.ImageSummary);
				
				if(sDQRangendex != "")
					child.ImageIndex =int.Parse(sDQRangendex,Symcon.BusinessObjects.SymConverter.Culture);	

				child.ForeColor = objMasterCompType.ForeColor;
				
			}
			else
			{
				sMasterComponentName = sMasterComponentName + " [ No Tag ]";
				child.ForeColor = SystemColors.ControlDarkDark;
			}
			return sMasterComponentName;
		}
		
		
		/// <summary>
		/// Apply DQ Status on the MasterComponentType
		/// </summary>
		/// <param name="tnav">Tree node on which forecolor & image will be applies</param>
		/// <param name="sComponentTypeID"></param>
		/// <param name="sCompTypeName"></param>
		/// <param name="objLegendDetail"></param>
		/// <returns></returns>
		private string ApplyMasterComponentTypeDQ(TreeNode tnav ,string sComponentTypeID, string sCompTypeName,LegendDetail objLegendDetail)
		{
			string sDQRangendex = "";
			DQDetails objCompType = new DQDetails();
			objCompType = AnalyzeDataQuality.InterpretMasterComponentTypeDQWithTag(sComponentTypeID);
			
			if(objCompType.Count>0)
			{
				Hashtable htPercent = objCompType.Percent;
				string sPercent = "...";
				if(htPercent.Count>0)
				{
					sPercent = htPercent[ErrorCode.VERY_HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.HIGH.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.MEDIUM.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() + "/" ;
					sPercent = sPercent + htPercent[ErrorCode.LOW.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString() ;
				}
				sCompTypeName = sCompTypeName + " [" + sPercent + "]%";
				
				if((objCompType.ImageSummary == ImageToApply.VERYHIGH) || (objCompType.ImageSummary == ImageToApply.HIGH))
					dqLegend1.LegendDetailsObj.ImageSummaryEnum = ImageToApply.BAD;
				else if((objCompType.ImageSummary == ImageToApply.AVG) || (objCompType.ImageSummary == ImageToApply.LOW))
					dqLegend1.LegendDetailsObj.ImageSummaryEnum = ImageToApply.LOW;
				else
					dqLegend1.LegendDetailsObj.ImageSummaryEnum = ImageToApply.GOOD;
				
				
				sDQRangendex = AnalyzeDataQuality.GetDQRangeImageIndex(objCompType.ImageSummary);
				
				if(sDQRangendex != "")
					tnav.ImageIndex =int.Parse(sDQRangendex,Symcon.BusinessObjects.SymConverter.Culture);	

				tnav.ForeColor = objCompType.ForeColor;
				
				objLegendDetail.ImageSummary = objCompType.ImageSummary;
				objLegendDetail.Name = sCompTypeName;
				objLegendDetail.DQImage = AnalyzeDataQuality.GetDQRangeImage(sDQRangendex);
			}
			else
			{
				sDQRangendex = "0";
				objLegendDetail.DQImage = AnalyzeDataQuality.GetDQRangeImage(sDQRangendex);
			}
			objLegendDetail.Name = sCompTypeName;
			return sCompTypeName;
		}
	
		#endregion
		
		#region Public Methods
		/// <summary>
		/// Required method for recreating the treeview to be viewed plant item wise
		/// </summary>
		public void InitializeDataQualityGrid()
		{
            
			string sMasterComponentID="";
			string sMasterComponentName="";
			string sSiteComponentID="";
			string sSiteComponentName="";
		
			_lrrapp.DBManagerObj.PopulateCollection(_lrrLevels,false);
			treeView1.SuspendLayout();
			treeView1.Nodes.Clear();
			
			_lrrapp.DBManagerObj.PopulateCollection(_lrrCompTypes,false);
			
			int[] folders =	new	int[1];
			folders[0] = 0;
			int[] leaf = new int[1];
			leaf[0]	= 1;
			LRRMasterComponents masterComponents = LRRModel.Model;
			masterComponents.SortColumn = "ComponentName";
			masterComponents.Sort();
				
			IEnumerator compTypeEnum = _lrrCompTypes.GetEnumerator();
			while(compTypeEnum.MoveNext())
			{
				LRRMasterComponents masterComps = new LRRMasterComponents();
				LRRComponentType compType = compTypeEnum.Current as LRRComponentType;
				IEnumerator masterCompEnum = masterComponents.GetEnumerator();
				
				string sComponentTypeID = compType.ID == null ? "" : compType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				string sCompTypeName = compType.Name;
				
				TreeNode tnav = new TreeNode();
				
				LegendDetail objLegendDetail = new LegendDetail();
				objLegendDetail.Name = sCompTypeName;
				objLegendDetail.ID = sComponentTypeID;

				sCompTypeName =ApplyMasterComponentTypeDQ(tnav,sComponentTypeID,sCompTypeName,objLegendDetail);

				tnav.Text =	sCompTypeName;
				tnav.Tag =	compType;

				_legendDetails.Add(objLegendDetail);
				

				tnav.Expand();
				while(masterCompEnum.MoveNext())
				{
					LRRMasterComponent masterComp = masterCompEnum.Current as LRRMasterComponent;
					if(compType.ID == masterComp.ComponentID)
					{
						compType.MasterComponentObj = masterComponents;
						masterComp.SiteComponentsObj.SortColumn="Name";
						masterComp.SiteComponentsObj.Sort();
						if(masterComp.SiteComponentsObj.Count > 0)
						{
							TreeNode child = new TreeNode();
							sMasterComponentID = masterComp.ID == null ? "" : masterComp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							sMasterComponentName = masterComp.ComponentName  == null ? "" : masterComp.ComponentName.ToString(Symcon.BusinessObjects.SymConverter.Culture);

							sMasterComponentName = ApplyMasterComponentDQ(child ,sMasterComponentID, sMasterComponentName);

							child.Tag =	masterComp;
							child.Text = sMasterComponentName;
							tnav.Nodes.Add(child);

							LRRLevel lvl =	new	LRRLevel();
							
							foreach(LRRSiteComponent sc	in masterComp.SiteComponentsObj)
							{
								sSiteComponentID = sc.SiteComponentID == null ? "" : sc.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
								sSiteComponentName = sc.Name == null ? "" : sc.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
								string sCompLevel = sc.PlantUnit == null ? "" : sc.PlantUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);

								TreeNode grandChild = new TreeNode();
								lvl = _lrrLevels.getLevelByLevelID(sCompLevel);
								
								if(lvl != null)
									sSiteComponentName = sSiteComponentName + " [" + lvl.Name +" ]" ;
								else
									sSiteComponentName = sSiteComponentName + " [ Level not defined ]" ;
								
								sSiteComponentName = sSiteComponentName + " [" + sc.EquipmentTag + "]";
								
								sSiteComponentName = ApplySiteComponentDQ(grandChild,sSiteComponentID,sSiteComponentName);

								grandChild.Tag = sc;
								grandChild.Text	= sSiteComponentName;
								child.Nodes.Add(grandChild);
							}
						}
					}
				}
				
				
				IEnumerator mastCompEnum = masterComps.GetEnumerator();
				while(mastCompEnum.MoveNext())
				{
					LRRMasterComponent mastComp = mastCompEnum.Current as LRRMasterComponent;
					if(compType.ID == mastComp.ComponentID)
					{
						TreeNode child = new TreeNode();
						child.Text = mastComp.ComponentName;
						child.ForeColor = Color.LightGray;
						child.Tag ="";
						tnav.Nodes.Add(child);
					}
				}
				treeView1.Nodes.Add(tnav);
			}
			
			dqLegend1.LegendDetailsObj = _legendDetails;
			dqLegend1.PopulateControls();
			CreateLegendLabel();
			treeView1.ResumeLayout(true);
			if(treeView1.Nodes.Count > 0)
				treeView1.SelectedNode = treeView1.Nodes[0];

            rdPlantItem.Checked = true;
		}

		/// <summary>
		/// Required overloaded method for recreating the tree view to be viewed plant item wise
		/// </summary>
		public void InitializeDataQualityGrid(bool bReloadLegends)
		{
			string sMasterComponentID="";
			string sMasterComponentName="";
			string sSiteComponentID="";
			string sSiteComponentName="";
		
			_lrrapp.DBManagerObj.PopulateCollection(_lrrLevels,false);
			treeView1.SuspendLayout();
			treeView1.Nodes.Clear();
			
			_lrrapp.DBManagerObj.PopulateCollection(_lrrCompTypes,false);
			
			int[] folders =	new	int[1];
			folders[0] = 0;
			int[] leaf = new int[1];
			leaf[0]	= 1;
			LRRMasterComponents masterComponents = LRRModel.Model;
			masterComponents.SortColumn = "ComponentName";
			masterComponents.Sort();
				
			IEnumerator compTypeEnum = _lrrCompTypes.GetEnumerator();
			while(compTypeEnum.MoveNext())
			{
				LRRMasterComponents masterComps = new LRRMasterComponents();
				LRRComponentType compType = compTypeEnum.Current as LRRComponentType;
				IEnumerator masterCompEnum = masterComponents.GetEnumerator();
				
				string sComponentTypeID = compType.ID == null ? "" : compType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				string sCompTypeName = compType.Name;
				
				TreeNode tnav = new TreeNode();
				
				LegendDetail objLegendDetail = new LegendDetail();
				objLegendDetail.Name = sCompTypeName;
				objLegendDetail.ID = sComponentTypeID;

				sCompTypeName =ApplyMasterComponentTypeDQ(tnav,sComponentTypeID,sCompTypeName,objLegendDetail);

				tnav.Text =	sCompTypeName;
				tnav.Tag =	compType;

				if(bReloadLegends)
				{
					_legendDetails.Add(objLegendDetail);
				}
				else
				{
					if (_legendDetails.GetLegendDetailFromID(sComponentTypeID) != null)
					{
						_legendDetails.GetLegendDetailFromID(sComponentTypeID).Name = objLegendDetail.Name;
						_legendDetails.GetLegendDetailFromID(sComponentTypeID).ID = objLegendDetail.ID;
						_legendDetails.GetLegendDetailFromID(sComponentTypeID).Value = objLegendDetail.Value;
						_legendDetails.GetLegendDetailFromID(sComponentTypeID).DQImage = objLegendDetail.DQImage;
						_legendDetails.GetLegendDetailFromID(sComponentTypeID).ImageSummary = objLegendDetail.ImageSummary;
					}
				}
				

				tnav.Expand();
				while(masterCompEnum.MoveNext())
				{
					LRRMasterComponent masterComp = masterCompEnum.Current as LRRMasterComponent;
					if(compType.ID == masterComp.ComponentID)
					{
						compType.MasterComponentObj = masterComponents;
						masterComp.SiteComponentsObj.SortColumn="Name";
						masterComp.SiteComponentsObj.Sort();
						if(masterComp.SiteComponentsObj.Count > 0)
						{
							TreeNode child = new TreeNode();
							sMasterComponentID = masterComp.ID == null ? "" : masterComp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							sMasterComponentName = masterComp.ComponentName  == null ? "" : masterComp.ComponentName.ToString(Symcon.BusinessObjects.SymConverter.Culture);

							sMasterComponentName = ApplyMasterComponentDQ(child ,sMasterComponentID, sMasterComponentName);

							child.Tag =	masterComp;
							child.Text = sMasterComponentName;
							tnav.Nodes.Add(child);

							LRRLevel lvl =	new	LRRLevel();
							
							foreach(LRRSiteComponent sc	in masterComp.SiteComponentsObj)
							{
								sSiteComponentID = sc.SiteComponentID == null ? "" : sc.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
								sSiteComponentName = sc.Name == null ? "" : sc.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
								string sCompLevel = sc.PlantUnit == null ? "" : sc.PlantUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);

								TreeNode grandChild = new TreeNode();
								lvl = _lrrLevels.getLevelByLevelID(sCompLevel);
								
								if(lvl != null)
									sSiteComponentName = sSiteComponentName + " [" + lvl.Name +" ]" ;
								else
									sSiteComponentName = sSiteComponentName + " [ Level not defined ]" ;
								
								sSiteComponentName = sSiteComponentName + " [" + sc.EquipmentTag + "]";
								
								sSiteComponentName = ApplySiteComponentDQ(grandChild,sSiteComponentID,sSiteComponentName);

								grandChild.Tag = sc;
								grandChild.Text	= sSiteComponentName;
								child.Nodes.Add(grandChild);
							}
						}
					}
				}
				
				
				IEnumerator mastCompEnum = masterComps.GetEnumerator();
				while(mastCompEnum.MoveNext())
				{
					LRRMasterComponent mastComp = mastCompEnum.Current as LRRMasterComponent;
					if(compType.ID == mastComp.ComponentID)
					{
						TreeNode child = new TreeNode();
						child.Text = mastComp.ComponentName;
						child.ForeColor = Color.LightGray;
						child.Tag ="";
						tnav.Nodes.Add(child);
					}
				}
				treeView1.Nodes.Add(tnav);
			}
			
			dqLegend1.LegendDetailsObj = _legendDetails;
			if(bReloadLegends)
			{
				dqLegend1.PopulateControls();
				CreateLegendLabel();
			}
			else
				CalculateImageSummary();

			treeView1.ResumeLayout(true);
			if(treeView1.Nodes.Count > 0)
				treeView1.SelectedNode = treeView1.Nodes[0];
		}
		/// <summary>
		/// This method is used to create summary label of the legends displayed
		/// </summary>
		private void CreateLegendLabel()
		{
			int nStartXPos = dqLegend1.StartXPos;
			int nStartYPos = dqLegend1.StartYPos;

			Label lblValue   = new Label();
			lblValue.Location = new System.Drawing.Point(nStartXPos, nStartYPos);
			lblValue.Height = 16;
			lblValue.Width = 220;
			lblValue.ImageList = imageList1;
			lblValue.Text = "Where, DQ (../../../..) indicates, (VH/H/M/L)%"; 
			lblValue.Font = new System.Drawing.Font("Arial Narrow", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			lblValue.ForeColor = System.Drawing.Color.Blue;	
			dqLegend1.PanelsObj.Controls.Add(lblValue);

		}

		
		/// <summary>
		/// Required method for refreshing the treeview & re-redering the legends
		/// </summary>
		public void RefreshDataQualityGrid(bool bInitialize)
		{
			if(!bInitialize)
			{
				treeView1.SuspendLayout();
			
				ApplyDataQuality(treeView1.Nodes);
			
				treeView1.Refresh();
				treeView1.ResumeLayout(true);
			
				dqLegend1.Refresh();
			}
			CalculateImageSummary();
			_mainFrameStatusBar.SetDQInfo(_legendDetails);
			
		}
		/// <summary>
		/// Required method for applying the DQ Status summary on the status bar
		/// </summary>	
		public void CalculateImageSummary()
		{
			foreach(LegendDetail objDetail in _legendDetails)
			{
				if((objDetail.ImageSummary == ImageToApply.VERYHIGH) )
					_legendDetails.ImageSummaryEnum =ImageToApply.BAD;
		
				if((_legendDetails.ImageSummaryEnum != ImageToApply.BAD) && (objDetail.ImageSummary == ImageToApply.HIGH))
					_legendDetails.ImageSummaryEnum =ImageToApply.BAD;

				if((_legendDetails.ImageSummaryEnum != ImageToApply.BAD)  && (objDetail.ImageSummary == ImageToApply.AVG))
					_legendDetails.ImageSummaryEnum =ImageToApply.AVG;
			
				if((_legendDetails.ImageSummaryEnum != ImageToApply.BAD) && (objDetail.ImageSummary == ImageToApply.LOW))
					_legendDetails.ImageSummaryEnum =ImageToApply.AVG;
			
				if((_legendDetails.ImageSummaryEnum != ImageToApply.BAD) && (_legendDetails.ImageSummaryEnum != ImageToApply.AVG) && (objDetail.ImageSummary == ImageToApply.GOOD))
					_legendDetails.ImageSummaryEnum =ImageToApply.GOOD;
			}
			
		}
		/// <summary>
		/// Required method for applying the DQ Status on the treeview
		/// </summary>
		public void ApplyDataQuality(TreeNodeCollection oNodes)
		{
			string sTagText = "";
			string sTagType = "";
			foreach(TreeNode objTreeNode in oNodes)
			{
				if(objTreeNode.Tag != null)
				{
					
					sTagType = objTreeNode.Tag.ToString();
					switch(sTagType)
					{
						case "Symcon.LightRidge.BusinessObjects.LRRComponentType":

							LRRComponentType objLRRComponentType = objTreeNode.Tag as LRRComponentType;
							string sComponentTypeID="";
							string sComponentTypeName="";
							sComponentTypeID=objLRRComponentType.ID == null ? "" : objLRRComponentType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							sComponentTypeName=objLRRComponentType.Name == null ? "" : objLRRComponentType.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							LegendDetail objLegendDetail = dqLegend1.LegendDetailsObj.GetLegendDetailFromID(sComponentTypeID);
							sTagText = ApplyMasterComponentTypeDQ(objTreeNode,sComponentTypeID,sComponentTypeName,objLegendDetail);
							break;

						case "Symcon.LightRidge.BusinessObjects.LRRMasterComponent":
							
							LRRMasterComponent objLRRMasterComponent = objTreeNode.Tag as LRRMasterComponent;
							string sMasterComponentID="";
							string sMasterComponentName="";
							sMasterComponentID=objLRRMasterComponent.ID == null ? "" : objLRRMasterComponent.ID.ToString();
							sMasterComponentName=objLRRMasterComponent.ComponentName == null ? "" : objLRRMasterComponent.ComponentName.ToString();
							sTagText = ApplyMasterComponentDQ(objTreeNode,sMasterComponentID,sMasterComponentName);
							break;

						case "Symcon.LightRidge.BusinessObjects.LRRSiteComponent":
							
							LRRSiteComponent objLRRSiteComponent = objTreeNode.Tag as LRRSiteComponent;
							string sSiteComponentID="";
							string sSiteComponentName="";
							sSiteComponentID=objLRRSiteComponent.SiteComponentID == null ? "" : objLRRSiteComponent.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							sSiteComponentName=objLRRSiteComponent.Name == null ? "" : objLRRSiteComponent.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							sTagText = ApplySiteComponentDQ(objTreeNode,sSiteComponentID,sSiteComponentName);
							break;
						case "Symcon.LightRidge.BusinessObjects.LRRLevel":
                            LRRLevel objLevel = objTreeNode.Tag as LRRLevel;
                            string sLevelID = "";
                            string sLevelName = "";
                            sLevelID = objLevel.LevelID == null ? "" : objLevel.LevelID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            sLevelName = objLevel.Name == null ? "" : objLevel.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            sTagText = ApplyLevelDQ(objTreeNode, sLevelID, sLevelName);
							//sTagText = objTreeNode.Text;
							break;

					}
					objTreeNode.Text = sTagText;
				}
				if(objTreeNode.Nodes.Count > 0)
					ApplyDataQuality(objTreeNode.Nodes);
			}
			
			
			
		}

		
		/// <summary>
		/// Required method for recreating the treeview to be viewed level wise
		/// </summary>
		public void InitializeDataQualityGridForLevels()
		{
			string sLevelID="";
			string sLevelName="";
			string sSiteComponentID = "";
			string sSiteComponentName = "";

			treeView1.SuspendLayout();
			treeView1.Sorted = true;
			treeView1.Nodes.Clear();

			_lrrapp.DBManagerObj.PopulateCollection(_lrrLevels,false);
			_lrrapp.DBManagerObj.PopulateCollection(_lrrLevelLinks,false);
			
			int[] folders =	new	int[1];
			folders[0] = 0;
			int[] leaf = new int[1];
			leaf[0]	= 1;
			_lrrLevels.SortColumn = "Name";
			_lrrLevels.Sort();
			
			TreeNode tnav = new TreeNode();
			sLevelID= "0";
			tnav.Tag = _lrrLevels.getLevelByLevelID(sLevelID);
			sLevelName= _lrrLevels.getLevelByLevelID(sLevelID).Name;
			tnav.Text = sLevelName;
			tnav.Expand();
			
			LRRLevelLinks lvlLinks = _lrrLevelLinks.GetAllChildLevels(sLevelID);
			IEnumerator levelEnum = lvlLinks.GetEnumerator();
			while(levelEnum.MoveNext())
			{
				LRRLevelLink levelLinkObj = levelEnum.Current as LRRLevelLink;
				TreeNode child = new TreeNode();
				child.Tag =	_lrrLevels.getLevelByLevelID(levelLinkObj.ChildID);
				child.Text = _lrrLevels.getLevelByLevelID(levelLinkObj.ChildID).Name;
				
				CreateGrandChild(levelLinkObj.ChildID,child);
				
				LRRSiteComponents objComponents = LRRModel.SiteComponentsObj.FilterSiteComponentsByLevelID(levelLinkObj.ChildID.ToString(Symcon.BusinessObjects.SymConverter.Culture));
				objComponents.SortColumn = "Name";
				objComponents.Sort();
				foreach(LRRSiteComponent sc	in objComponents)
				{
							
					LRRLevel lvl = _lrrLevels.getLevelByLevelID(levelLinkObj.ChildID);
					sSiteComponentID = sc.SiteComponentID == null ? "" : sc.SiteComponentID;
					sSiteComponentName = sc.Name == null ? "" : sc.Name;

					TreeNode grandChildNode = new TreeNode();
					sSiteComponentName = sSiteComponentName + " [" + sc.EquipmentTag + "]";
							
					sSiteComponentName = ApplySiteComponentDQ(grandChildNode,sSiteComponentID,sSiteComponentName);
					grandChildNode.Text	= sSiteComponentName;
					child.Nodes.Add(grandChildNode);
							
				}

				tnav.Nodes.Add(child);
			}
			
			treeView1.Nodes.Add(tnav);
			treeView1.ResumeLayout(true);
			if(treeView1.Nodes.Count > 0)
				treeView1.SelectedNode = treeView1.Nodes[0];
		}
		
		
		#endregion

		#region Event Handlers
		/// <summary>
		/// This is the event handler for load of the form. This calls RefreshDataQualityGrid()
		/// where the treeview is rendered.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void DataQuality_Load(object sender, System.EventArgs e)
		{
			RefreshDataQualityGrid(false);
		}
		/// <summary>
		/// This is the event handler for click on view by radio buttons
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void rdLevel_CheckedChanged(object sender, System.EventArgs e)
		{
			this.Cursor = Cursors.WaitCursor;
			if(rdLevel.Checked)
			{
				InitializeDataQualityGridForLevels();
				ApplyDataQuality(treeView1.Nodes);
			}
			else
			{
				InitializeDataQualityGrid(false);
				ApplyDataQuality(treeView1.Nodes);
			}
			this.Cursor = Cursors.Default;
		}
		/// <summary>
		/// This is the event handler for click on Close button
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void button1_Click(object sender, EventArgs e)
		{
			this.Close();
		}
        
		#endregion

		#region Form Fields
		private LRRApp							_lrrapp;
		private LRRComponentTypes				_lrrCompTypes = null;
		private LRRLevels						_lrrLevels = null;
		private LRRLevelLinks					_lrrLevelLinks = null;
		private Hashtable						_htCompType = new Hashtable();
		private Hashtable						_htMasterCompType = new Hashtable();
		private Hashtable						_htSiteComp	= new Hashtable();
		private LegendDetails					_legendDetails = new LegendDetails();
		private Symcon.CCLibrary.Controls.StatusBar _mainFrameStatusBar;
		private Symcon.LightRidge.PEAdvisor.DQLegend dqLegend1;
		
		#endregion

	}
}
