using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;   

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for Modes.
	/// </summary>
	public class ModesDialog : System.Windows.Forms.Form
	{
		private	LRRModes lrrModes;
		private	LRRApp							_app;
		private System.Windows.Forms.Panel pnlMain;
		private System.Windows.Forms.Panel pnlDown;
		private System.Windows.Forms.Button btnApply;
		private System.Windows.Forms.Panel pnlUp;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGlobalModes;
		private System.Windows.Forms.Splitter splitter1;
        private LRRMode _curMode = null;
//		private	GridUnBoundColumn unboundGc = new GridUnBoundColumn();
		//public	event ModesChangedEventhandler ModesChanged;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ModesDialog()
		{
			//lrrModes = new LRRModes();
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

        /// <summary>
        /// Initializes the modes.
        /// </summary>
		public void InitializeModes()
		{
			_app = AppDomain.CurrentDomain.GetData("AppObject")	as LRRApp;
			lrrModes = LRRModel.ProjectModes;
			lrrModes.SortColumn = "ModeId";
			lrrModes.Sort();
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of	the	Grid...
			gridGlobalModes.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridGlobalModes);

			columnForDisplay.Add("ModeName",null);
			columnForDisplay.Add("ModeTypeID", null);
			columnForDisplay.Add("ViewSelection",null);
			
			//Populate the columns for the grid	object
			SyncGridUtilities.InitializeGridColumns(gridGlobalModes,lrrModes.ItemType,null,true,columnForDisplay);
			/*unboundGc.WireGrid(gridGlobalModes.TableDescriptor);*/

			RelativeWidths.Add("ModeName",70);
			RelativeWidths.Add("ModeTypeID_Name", 20);
			RelativeWidths.Add("ViewSelection",20);

			//Populate the columns for the grid	object
			SyncGridUtilities.InitializeGridColumnsWidth(gridGlobalModes,RelativeWidths	);
			
			
			//Set the data store 
			gridGlobalModes.DataSource = lrrModes;
			gridGlobalModes.Engine.SourceListSet.Add("Parent",lrrModes);
			gridGlobalModes.TableDescriptor.AllowNew = false;
			gridGlobalModes.TableDescriptor.AllowRemove	= false;
			gridGlobalModes.TableDescriptor.AllowEdit =	true;
			gridGlobalModes.TableDescriptor.Columns["ModeName"].ReadOnly=true;
//			gridGlobalModes.TableDescriptor.Columns["ModeName"].Width = 100;
//			gridGlobalModes.TableDescriptor.Columns["ModeTypeID_Name"].Width = 100;
//			gridGlobalModes.TableDescriptor.Columns["ViewSelection"].Width = 50;
			gridGlobalModes.TopLevelGroupOptions.ShowCaption = false;
			gridGlobalModes.TableControlCurrentCellChanged+=new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(gridGlobalModes_TableControlCurrentCellChanged);
			//Resume the Layout	of the Grid...
			gridGlobalModes.ResumeLayout(false);
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ModesDialog));
			this.pnlMain = new System.Windows.Forms.Panel();
			this.pnlUp = new System.Windows.Forms.Panel();
			this.gridGlobalModes = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlDown = new System.Windows.Forms.Panel();
			this.btnApply = new System.Windows.Forms.Button();
			this.pnlMain.SuspendLayout();
			this.pnlUp.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridGlobalModes)).BeginInit();
			this.pnlDown.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlMain
			// 
			this.pnlMain.Controls.Add(this.pnlUp);
			this.pnlMain.Controls.Add(this.splitter1);
			this.pnlMain.Controls.Add(this.pnlDown);
			this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMain.Location = new System.Drawing.Point(0, 0);
			this.pnlMain.Name = "pnlMain";
			this.pnlMain.Size = new System.Drawing.Size(474, 176);
			this.pnlMain.TabIndex = 3;
			// 
			// pnlUp
			// 
			this.pnlUp.Controls.Add(this.gridGlobalModes);
			this.pnlUp.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlUp.Location = new System.Drawing.Point(0, 0);
			this.pnlUp.Name = "pnlUp";
			this.pnlUp.Size = new System.Drawing.Size(474, 133);
			this.pnlUp.TabIndex = 5;
			// 
			// gridGlobalModes
			// 
			this.gridGlobalModes.BackColor = System.Drawing.SystemColors.Window;
			this.gridGlobalModes.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridGlobalModes.Location = new System.Drawing.Point(0, 0);
			this.gridGlobalModes.Name = "gridGlobalModes";
			this.gridGlobalModes.Size = new System.Drawing.Size(474, 133);
			this.gridGlobalModes.TabIndex = 0;
			this.gridGlobalModes.Text = "gridGroupingControl1";
			this.gridGlobalModes.VersionInfo = "3.301.0.0";
			this.gridGlobalModes.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridGlobalModes_TableControlQueryAllowSortColumn);
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 133);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(474, 3);
			this.splitter1.TabIndex = 6;
			this.splitter1.TabStop = false;
			// 
			// pnlDown
			// 
			this.pnlDown.BackColor = System.Drawing.SystemColors.Control;
			this.pnlDown.Controls.Add(this.btnApply);
			this.pnlDown.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlDown.Location = new System.Drawing.Point(0, 136);
			this.pnlDown.Name = "pnlDown";
			this.pnlDown.Size = new System.Drawing.Size(474, 40);
			this.pnlDown.TabIndex = 4;
			// 
			// btnApply
			// 
			this.btnApply.Location = new System.Drawing.Point(392, 8);
			this.btnApply.Name = "btnApply";
			this.btnApply.Size = new System.Drawing.Size(71, 24);
			this.btnApply.TabIndex = 0;
			this.btnApply.Tag = "SID_APPLY";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// ModesDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(474, 176);
			this.Controls.Add(this.pnlMain);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimumSize = new System.Drawing.Size(256, 200);
			this.Name = "ModesDialog";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_MODES";
			this.Load += new System.EventHandler(this.ModesDialog_Load);
			this.pnlMain.ResumeLayout(false);
			this.pnlUp.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridGlobalModes)).EndInit();
			this.pnlDown.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

        /// <summary>
        /// Handles the Click event of the btnApply control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnApply_Click(object sender, System.EventArgs e)
		{
            if (_curMode != null)
            {
                foreach (LRRMode selectedMode in lrrModes)
                {
                    if (selectedMode != _curMode && _curMode.ModeTypeID != null && _curMode.ModeTypeID != "" && selectedMode.ModeTypeID == _curMode.ModeTypeID)
                    {
                        LRRMessagBox.ShowMessage("SID_DUPLICATE_MODE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        _curMode.ModeTypeID = "";
                        gridGlobalModes.Refresh();
                        return;
                    }
                }
                // access control logic added by ashwin
                LRRUIEntity uiEntity = LRRModel.UIEntities.GetUIEntityByName("Modes");
                if (uiEntity != null)
                {
                    LRRAccessControlUIEntity accessControlUIEntity = LRRModel.AccessControlUIEntities.GetUIAccessControlByRoleIDandEntityID(LRRModel.CurrentRoleID, uiEntity.UIEntitiesID);
                    if (accessControlUIEntity != null)
                    {
                        //if (accessControlUIEntity.AccessPermissions == "CUDA" || accessControlUIEntity.AccessPermissions == "C" || accessControlUIEntity.AccessPermissions == "U")
                        if (accessControlUIEntity.AccessPermissions.Contains("U"))
                        {
                            _app.DBManagerObj.CommitCollection(lrrModes);
                            lrrModes.RaiseChangeOfModes();
                        }
                        else
                        {
                            MessageBox.Show("Please note that this change will only persist for the active session (irrespective of your persistence preference setting) for user " + _app.LoggedUser, "PE-Advisor", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            lrrModes.RaiseChangeOfModes();

                        }
                    }
                }
                
                // below two lines of code commented by ashwin
                /*
                _app.DBManagerObj.CommitCollection(lrrModes);
                lrrModes.RaiseChangeOfModes();
                 **/
            }
		}

        /// <summary>
        /// Handles the TableControlCurrentCellChanged event of the gridGlobalModes control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs"/> instance containing the event data.</param>
		private void gridGlobalModes_TableControlCurrentCellChanged(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{
			gridGlobalModes.TableControl.CurrentCell.ConfirmChanges();
			//LRRMode	lrmd =	gridGlobalModes.CurrencyManager.Current	as LRRMode;
            _curMode = gridGlobalModes.CurrencyManager.Current as LRRMode;
            //foreach(LRRMode	selectedMode in	lrrModes)
            //{
            //    if(selectedMode	!= lrmd	&& lrmd.ModeTypeID  != null && lrmd.ModeTypeID != "" &&	selectedMode.ModeTypeID	== lrmd.ModeTypeID)
            //    {
            //        LRRMessagBox.ShowMessage("SID_DUPLICATE_MODE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);      
            //        lrmd.ModeTypeID	= "";
            //        break;
            //    }
            //}
		}

        /// <summary>
        /// Raises the <see cref="E:System.Windows.Forms.Form.Closing"></see> event.
        /// </summary>
        /// <param name="e">A <see cref="T:System.ComponentModel.CancelEventArgs"></see> that contains the event data.</param>
		protected override void OnClosing(CancelEventArgs e)
		{
			e.Cancel = true;
			this.Hide();
			_app.MainFrame.Activate();
		}

		private void ModesDialog_Load(object sender, System.EventArgs e)
		{
		
		}

        /// <summary>
        /// Handles the TableControlQueryAllowSortColumn event of the gridGlobalModes control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs"/> instance containing the event data.</param>
		private void gridGlobalModes_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			e.AllowSort = false;
		}
	}
}
