using System;
using System.Drawing;
using System.Collections;
using System.Diagnostics;
using System.Reflection;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.Utils.MessageLogger;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.PEAdvisor.Global;
using Symcon.Utils.HeaderDispatcher;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for OverridesWindow.
	/// </summary>
	public class OverridesWindow : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.Panel pnlTop;
		private System.Windows.Forms.Panel panel1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OverridesWindow()
		{
			InitializeComponent();
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject")	as LRRApp;
			InternationalizationUtils.GetControlText(this,null); 
			this.Load+=new EventHandler(OverridesWindow_Load);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(OverridesWindow));
			this.pnlTop = new System.Windows.Forms.Panel();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pnlTop.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlTop
			// 
			this.pnlTop.Controls.Add(this.panel1);
			this.pnlTop.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlTop.Location = new System.Drawing.Point(0, 0);
			this.pnlTop.Name = "pnlTop";
			this.pnlTop.Size = new System.Drawing.Size(472, 174);
			this.pnlTop.TabIndex = 0;
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(472, 174);
			this.panel1.TabIndex = 0;
			// 
			// OverridesWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.ClientSize = new System.Drawing.Size(472, 174);
			this.Controls.Add(this.pnlTop);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "OverridesWindow";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_OVERRIDE_WND";
			this.pnlTop.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region OverRides

		protected override void OnClosing(CancelEventArgs e)
		{
			e.Cancel = true;
            // hide part commented by ashwin
			this.Hide();
            // close part added by ashwin
            //this.Close();
            
			_lrrApp.MainFrame.Activate();
		}
		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			
			if(keyData == Keys.Delete)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{	
					_isDelete = true;
				}
				else
				{
					_isDelete = false;
				}
				if(_isDelete)
				{
					Syncfusion.Windows.Forms.Grid.GridRangeInfoList list  = new Syncfusion.Windows.Forms.Grid.GridRangeInfoList();    
					this.gridControlInstance.Selections.GetSelectedRanges(out list,true);
					Syncfusion.Windows.Forms.Grid.GridRangeInfo _info = list.ActiveRange;   
					ArrayList _objToRemove = new ArrayList();
					int top = _info.Top;
					int bottom = _info.Bottom;
					for(int i = top-1;i<=bottom-1;i++)
					{
						LRROverride overrideObj = _rowsArrary[i] as LRROverride;
                        bool arryaisAvailble = false;
                        if (_rowsArrary.Count > 0)
                        {
                            arryaisAvailble = true;
                        }
                        if (overrideObj != null && arryaisAvailble)
                        {
                            _isOverrideDelte = true;
                            _objToRemove.Add(overrideObj);
                            LRRModel.ChildModel.Overrides.Remove(overrideObj);
                            LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(overrideObj.SiteComponentPropertyID);
                            string modeID = overrideObj.ModeID;
                            LRRSiteComponentPropertyValues lrrSCPVs = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(lrrSiteCompProperty.ID);

                            foreach (LRRSiteComponentPropertyValue lrrSiteCompPropValue in lrrSCPVs)
                            {
                                //LRRSiteComponentPropertyValue lrrSiteCompPropValue = lrrSiteCompProperty.GetValueObjectForPropertyMode(modeID);

                                if (lrrSiteCompPropValue.ModeID == modeID)
                                {
                                    lrrSiteCompPropValue.SetOverrideState(false);
                                    if (modeID == "1")
                                    {
                                        _lrrApp.SwapBindings(lrrSiteCompPropValue, false);
                                        lrrSiteCompPropValue.SetPropertyValue(lrrSiteCompPropValue.GetActualOverridedValue());
                                    }
                                    else
                                    {
                                        _lrrApp.RemoveCascadedBindings(lrrSiteCompPropValue, false);
                                        lrrSiteCompPropValue.SetPropertyValue(lrrSiteCompPropValue.GetActualOverridedValue());
                                    }
                                }
                            }
                        }
                        else if(arryaisAvailble)
                        {
                            LRRGroupOverride grpOverrideObj = _rowsArrary[i] as LRRGroupOverride;
                            if (grpOverrideObj != null)
                            {
                                _isGrpOverrideDelete = true;
                                _objToRemove.Add(grpOverrideObj);
                                LRRModel.ChildModel.GroupOverrides.Remove(grpOverrideObj);
                                //LRRSiteComponentGroupProperty lrrSiteCompGrpProperty = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(grpOverrideObj.GroupPropertyID);

                                string modeID = grpOverrideObj.ModeID;
                                //LRRSiteGroupPropertyQualifierValue lrrSCGQPV = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForModeSiteCompAndLookUpProp(lrrSiteCompGrpProperty.SiteComponentPropID, lrrSiteCompGrpProperty.LookUpPropertiesID, modeID);
                                LRRSiteGroupPropertyQualifierValue lrrSCGQPV = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(grpOverrideObj.SiteGroupPropertyQualifierValueID.ToString());
                                

                                lrrSCGQPV.SetOverrideState(false);
                                if (modeID == "1")
                                {
                                    _lrrApp.SwapBindings(lrrSCGQPV, false);
                                    lrrSCGQPV.SetPropertyValue(lrrSCGQPV.GetActualOverridedValue());
                                }
                                else
                                {
                                    _lrrApp.RemoveCascadedBindings(lrrSCGQPV, lrrSCGQPV.GroupPropertyID, lrrSCGQPV.LookUpPropertiesID, lrrSCGQPV.QualifierID, false);
                                    lrrSCGQPV.SetPropertyValue(lrrSCGQPV.GetActualOverridedValue());
                                }
                            }
                            else
                            {
                                LRRAggregateOverride overrideAggObj = _rowsArrary[i] as LRRAggregateOverride;
                                if (overrideAggObj != null)
                                {
                                    _isOverrideDelte = true;
                                    _objToRemove.Add(overrideAggObj);
                                    LRRModel.ChildModel.AggregateOverrides.Remove(overrideAggObj);
                                    LRRAggregateProperty lrrAggProperty = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(overrideAggObj.AggregatePropertyID);
                                    string modeID = overrideAggObj.ModeID;
                                    LRRAggregatePropertyValues lrrAggVs = LRRModel.AggregatePropertyValuesObj.GetPropValuesCollectionByPropID(lrrAggProperty.ID);
                                    foreach (LRRAggregatePropertyValue lrrAggV in lrrAggVs)
                                    {
                                        //LRRSiteComponentPropertyValue lrrSiteCompPropValue = lrrSiteCompProperty.GetValueObjectForPropertyMode(modeID);

                                        if (lrrAggV.ModeID == modeID)
                                        {
                                            lrrAggV.SetOverrideState(false);
                                            if (modeID == "1")
                                            {
                                                _lrrApp.SwapBindings(lrrAggV, false);
                                                lrrAggV.SetPropertyValue(lrrAggV.GetActualOverridedValue());
                                            }
                                            else
                                            {
                                                _lrrApp.RemoveCascadedBindings(lrrAggV, false);
                                                lrrAggV.SetPropertyValue(lrrAggV.GetActualOverridedValue());
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    //lrrgroupAgg
                                    LRRAggGroupOverride aggGrpOverride = _rowsArrary[i] as LRRAggGroupOverride;
                                    if (aggGrpOverride != null)
                                    {
                                        _isAggGrpOverrideDelete = true;
                                        _objToRemove.Add(aggGrpOverride);
                                        LRRModel.ChildModel.GroupAggOverrides.Remove(aggGrpOverride);
                                        LRRAggregateGroupedProperty lrrAggGrpProperty = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpOverride.AggGroupPropertyID);
                                        string modeID = aggGrpOverride.ModeID;
                                        LRRAggregateGroupedPropertyValues lrrAggGrpPropVals = LRRModel.AggregateGroupedPropertyValuesObj.GetGroupedValuesFromGroupPropID(lrrAggGrpProperty.AggregateGroupedPropertyID);
                                        foreach (LRRAggregateGroupedPropertyValue lrrAggGrpPropVal in lrrAggGrpPropVals)
                                        {
                                            if (lrrAggGrpPropVal.ModeID == modeID)
                                            {
                                                lrrAggGrpPropVal.SetOverrideState(false);
                                                if (modeID == "1")
                                                {
                                                    _lrrApp.SwapBindings(lrrAggGrpPropVal, false);
                                                    lrrAggGrpPropVal.SetPropertyValue(lrrAggGrpPropVal.GetActualOverridedValue());
                                                }
                                                else
                                                {
                                                    _lrrApp.RemoveCascadedBindings(lrrAggGrpPropVal, lrrAggGrpPropVal.AggregateGroupPropertyID, lrrAggGrpPropVal.LookUpPropertiesID, lrrAggGrpPropVal.QualifierID, false);
                                                    lrrAggGrpPropVal.SetPropertyValue(lrrAggGrpPropVal.GetActualOverridedValue());
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
					}
					for(int i=0;i<_objToRemove.Count;i++)
					{
						LRROverride _removeObj = _objToRemove[i] as LRROverride;
						if(_removeObj != null)
						{
							_rowsArrary.Remove(_removeObj);
						}
						else
						{
									LRRGroupOverride _removeGrpOverrideObj = _objToRemove[i] as LRRGroupOverride;
                            if (_removeGrpOverrideObj != null)
                            {
                                _rowsArrary.Remove(_removeGrpOverrideObj);
                            }
                            else
                            {
                                LRRAggregateOverride _removeAggOverrideObj = _objToRemove[i] as LRRAggregateOverride;
                                if (_removeAggOverrideObj != null)
                                {
                                    _rowsArrary.Remove(_removeAggOverrideObj);
                                }
							    LRRAggGroupOverride _removeAggGrpOverrideObj = _objToRemove[i] as LRRAggGroupOverride;
                                if (_removeAggGrpOverrideObj != null)
                                {
                                    _rowsArrary.Remove(_removeAggGrpOverrideObj);
                                }
                            }
						}
					}
					this.gridControlInstance.Model.Rows.RemoveRange(top,bottom);   
					_isOverrideDelte = false;
					_isGrpOverrideDelete = false;
					_isAggGrpOverrideDelete=false;
				}
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

	
		#endregion

		#region Fields
		private LRRApp _lrrApp;
		/// <summary>
		/// overrides Collection Object
		/// </summary>
		private LRROverrides _lrrOverrides;

		private LRRGroupOverrides _lrrGrpOverrides;

        private LRRAggregateOverrides _lrrAggregateOverrids;

		private LRRAggGroupOverrides _lrrAggGroupOverrides;
		/// <summary>
		/// Arraylist that contains the properites to be display in Grid
		/// </summary>
		private ArrayList _displayProperties = new ArrayList();
		
		//Saved Cases Overrides Array List
		private ArrayList _arrListSavedCaseOverrides = new ArrayList();

		/// <summary>
		/// Constants for Coloums
		/// </summary>
		private int HEADER_ROW = 0;
		private int SITECOMPONENT = 2;
		private int ATTRIBUTE = 3;
		private int UOM_NAME = 4;
		private int PRE_OVERRIDE_VALUE = 5;
		private int POST_OVERRIDE_VALUE = 6;
		private int DATA_CONFIDANCE_LEVEL = 7;
		private int MODE_NAME = 1;
        private int HEADER_ISTEMPLATEOVERRIDE = 8;
		/// <summary>
		/// Arraylist to store row with corresponding dataobj.
		/// </summary>
		private ArrayList _rowsArrary = new ArrayList();
		private GridControl gridControlInstance;
		private bool _isOverrideDelte = false;
		private bool _isGrpOverrideDelete = false;
		private bool _isAggGrpOverrideDelete= false;
      
		#endregion

        /// <summary>
        /// Handles the Load event of the OverridesWindow control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void OverridesWindow_Load(object sender, EventArgs e)
		{
			_lrrOverrides = LRRModel.ChildModel.Overrides;
			_lrrOverrides.ItemAdded+=new EventHandler(_lrrOverrides_ItemAdded); 
			_lrrOverrides.ItemDeleted+=new EventHandler(_lrrOverrides_ItemDeleted); 

			_lrrGrpOverrides = LRRModel.ChildModel.GroupOverrides;
			_lrrGrpOverrides.ItemAdded+=new EventHandler(_lrrGrpOverrides_ItemAdded); 
			_lrrGrpOverrides.ItemDeleted+=new EventHandler(_lrrGrpOverrides_ItemDeleted);
            _lrrAggregateOverrids = LRRModel.ChildModel.AggregateOverrides;
            _lrrAggregateOverrids.ItemAdded += new EventHandler(_lrrAggregateOverrids_ItemAdded);
            _lrrAggregateOverrids.ItemDeleted += new EventHandler(_lrrAggregateOverrids_ItemDeleted); 

			//lrrAggregateGroup Overrides
			_lrrAggGroupOverrides = LRRModel.ChildModel.GroupAggOverrides;
			_lrrAggGroupOverrides.ItemAdded +=new EventHandler(_lrrAggGroupOverrides_ItemAdded);
			_lrrAggGroupOverrides.ItemDeleted +=new EventHandler(_lrrAggGroupOverrides_ItemDeleted);


			
			GetDisplayProperties(_lrrOverrides);

			gridControlInstance = new GridControl();
			gridControlInstance.Dock =System.Windows.Forms.DockStyle.Fill; 
			this.panel1.Controls.Add(gridControlInstance);
			gridControlInstance.RowCount =  GetGridRowCount(_lrrOverrides,_lrrGrpOverrides,_lrrAggregateOverrids,_lrrAggGroupOverrides);
			gridControlInstance.ColCount =  GetGridColCount(_lrrOverrides);
			gridControlInstance.NumberedRowHeaders = false;
			gridControlInstance.ExcelLikeSelectionFrame = true;
			gridControlInstance.Properties.BackgroundColor = Color.White; 

			registerGridEvents(gridControlInstance);
			CreateHeaders(gridControlInstance);
			CreateGrid(gridControlInstance,_lrrOverrides,_lrrGrpOverrides,_lrrAggregateOverrids,_lrrAggGroupOverrides);
		}

	

        
		
		#region ILRRUIContainer Members

		public void Refresh()
		{
			// TODO:  Add OverridesWindow.Refresh implementation
		}

		public void Save()
		{
			// TODO:  Add OverridesWindow.Save implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add OverridesWindow.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add OverridesWindow.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add OverridesWindow.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add OverridesWindow.Print implementation
		}

		public void PrintPreview()
		{
			// TODO:  Add OverridesWindow.PrintPreview implementation
		}

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add OverridesWindow.Undo implementation
		}

		public void Delete()
		{
			
		}

		public void ArrangeColumns()
		{
			// TODO:  Add OverridesWindow.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add OverridesWindow.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add OverridesWindow.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add OverridesWindow.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add OverridesWindow.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add OverridesWindow.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add OverridesWindow.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add OverridesWindow.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add OverridesWindow.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add OverridesWindow.DownLevel implementation
		}

		public void ClearSort()
		{
			// TODO:  Add OverridesWindow.ClearSort implementation
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add OverridesWindow.CopyUOMTypes implementation
		}

		public void ShowPropertyList()
		{
			// TODO:  Add OverridesWindow.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add OverridesWindow.ShowComponentList implementation
		}

		public void LeftColMovement()
		{
			// TODO:  Add OverridesWindow.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add OverridesWindow.RightColMovement implementation
		}

		public void OpenCompositeView()
		{
			// TODO:  Add OverridesWindow.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add OverridesWindow.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add OverridesWindow.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add OverridesWindow.OpenView implementation
		}

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add OverridesWindow.PerformDirtyChk getter implementation
				return false;
			}
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add OverridesWindow.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add OverridesWindow.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add OverridesWindow.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add OverridesWindow.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add OverridesWindow.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add OverridesWindow.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add OverridesWindow.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add OverridesWindow.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add OverridesWindow.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add OverridesWindow.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add OverridesWindow.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add OverridesWindow.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add OverridesWindow.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add OverridesWindow.SupportsLevel implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add OverridesWindow.SupportsClearSort implementation
			return false;
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add OverridesWindow.SupportsCopyUOMTypes implementation
			return false;
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add OverridesWindow.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add OverridesWindow.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add OverridesWindow.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add OverridesWindow.SupportsUndo implementation
			return false;
		}

		
		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add OverridesWindow.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OverridesWindow.ParentTabControl setter implementation
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add OverridesWindow.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OverridesWindow.ParentTabPage setter implementation
			}
		}

		#endregion

        /// <summary>
        /// Gets the display properties.
        /// </summary>
        /// <param name="objCollection">The obj collection.</param>
        /// <returns></returns>
		private ArrayList GetDisplayProperties(LRROverrides objCollection)
		{
			PropertyInfo[] props = objCollection.ItemType.GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly | BindingFlags.Public);      
			for(int i =0;i<props.Length;i++)
			{
				PropertyInfo prop = props[i];
				SymDataFieldAttribute[] field = (SymDataFieldAttribute[])
					prop.GetCustomAttributes(typeof(SymDataFieldAttribute),
					false);
				if(field.Length > 0)
				{
					SymDataFieldAttribute sDFA = field[0];
					if(sDFA.IsVisible == true)
					{
						_displayProperties.Add(sDFA);  
					}
				}
			}
			return _displayProperties;
		}
        /// <summary>
        /// Gets the grid col count.
        /// </summary>
        /// <param name="objCollection">The obj collection.</param>
        /// <returns></returns>
		private int GetGridColCount(LRROverrides objCollection)
		{
			int iGridColCount = _displayProperties.Count;
			return iGridColCount;
		}
        /// <summary>
        /// Gets the grid row count.
        /// </summary>
        /// <param name="objCollection">The obj collection.</param>
        /// <param name="objGrpOvCollection">The obj GRP ov collection.</param>
        /// <param name="objAggregateOverrides">The obj aggregate overrides.</param>
        /// <param name="objAggGrpOverideCollection">The obj agg GRP overide collection.</param>
        /// <returns></returns>
		private int GetGridRowCount(LRROverrides objCollection,LRRGroupOverrides objGrpOvCollection,LRRAggregateOverrides objAggregateOverrides,LRRAggGroupOverrides objAggGrpOverideCollection)
		{
			int i = 0;
            foreach (LRROverride overrideValue in objCollection)
            {
                LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(overrideValue.SiteComponentID);
                LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(overrideValue.SiteComponentPropertyID);
                if (lsc != null && lscp != null)
                {
                    i++;
                }
            }
            foreach (LRRGroupOverride grpOverrideValue in objGrpOvCollection)
            {
                LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(grpOverrideValue.SiteComponentID);
                LRRSiteComponentGroupProperty lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(grpOverrideValue.GroupPropertyID);
                if (lsc != null && lscgp != null)
                {
                    i++;
                }
            }
            foreach (LRRAggregateOverride aggOverrideValue in objAggregateOverrides)
            {
                LRRAggregate agg = LRRModel.AggregatesObj.GetAggregateFromID(aggOverrideValue.AggregateID);
                LRRAggregateProperty aggProperty = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggOverrideValue.AggregatePropertyID);
                if (agg != null && aggProperty != null)
                {
                    i++;
                }
            }
            foreach (LRRAggGroupOverride aggGrpOverrideValue in objAggGrpOverideCollection)
            {
                LRRAggregate Agg = LRRModel.AggregatesObj.GetAggregateFromID(aggGrpOverrideValue.AggregateID);
                LRRAggregateGroupedProperty lAggGroupProp = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpOverrideValue.AggGroupPropertyID);
                if (Agg != null && lAggGroupProp != null)
                {
                    i++;
                }
            }
            
           // i = objCollection.Count + objGrpOvCollection.Count + objAggregateOverrides.Count+ objAggGrpOverideCollection.Count; 
			return i;
		}
        /// <summary>
        /// Registers the grid events.
        /// </summary>
        /// <param name="gridControlInstance">The grid control instance.</param>
		private void registerGridEvents(GridControl gridControlInstance)
		{
			gridControlInstance.CurrentCellCloseDropDown+=new Syncfusion.Windows.Forms.PopupClosedEventHandler(gridControlInstance_CurrentCellCloseDropDown); 
			gridControlInstance.CurrentCellShowingDropDown+=new GridCurrentCellShowingDropDownEventHandler(gridControlInstance_CurrentCellShowingDropDown); 
			gridControlInstance.CurrentCellEditingComplete+=new EventHandler(gridControlInstance_CurrentCellEditingComplete); 
			gridControlInstance.CellModels.Add("ColumnHeaderCell", new GridSortColumnHeaderCellModel(gridControlInstance.Model));
			//Implement after resolving bugs.
			gridControlInstance.CellClick+=new GridCellClickEventHandler(gridControlInstance_CellClick); 
			gridControlInstance.CurrentCellStartEditing+=new CancelEventHandler(gridControlInstance_CurrentCellStartEditing); 
		}

        /// <summary>
        /// Creates the headers.
        /// </summary>
        /// <param name="gridInstance">The grid instance.</param>
		private void CreateHeaders(GridControl gridInstance)
		{
			#region Colomn HeaderCreation and Look&Fill

			gridInstance[HEADER_ROW,0].Text = "";
			gridInstance[HEADER_ROW,0].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);   
			gridInstance.ColWidths[MODE_NAME] = 120; 
			gridInstance[HEADER_ROW,MODE_NAME].Text = LRRHeaderText.GetHeaderString("SID_MODE");
			gridInstance[HEADER_ROW,MODE_NAME].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);  
			gridInstance[HEADER_ROW,SITECOMPONENT].Text = LRRHeaderText.GetHeaderString("SID_SITECOMPONENTS");
			gridInstance[HEADER_ROW,SITECOMPONENT].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);  
			gridInstance.ColWidths[SITECOMPONENT] = 110; 
			gridInstance[HEADER_ROW,ATTRIBUTE].Text = LRRHeaderText.GetHeaderString("SID_ATTRIBUTE");
			gridInstance[HEADER_ROW,ATTRIBUTE].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);  
			gridInstance.ColWidths[ATTRIBUTE] = 110; 
			gridInstance[HEADER_ROW,UOM_NAME].Text = LRRHeaderText.GetHeaderString("SID_UOM");
			gridInstance[HEADER_ROW,UOM_NAME].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);   
			gridInstance.ColWidths[UOM_NAME] = 110; 
			gridInstance[HEADER_ROW,PRE_OVERRIDE_VALUE].Text = LRRHeaderText.GetHeaderString("SID_PREOVERRIDEVALUE");
			gridInstance[HEADER_ROW,PRE_OVERRIDE_VALUE].BackColor =System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);  
			gridInstance.ColWidths[PRE_OVERRIDE_VALUE] = 140; 
			gridInstance[HEADER_ROW,POST_OVERRIDE_VALUE].Text =LRRHeaderText.GetHeaderString("SID_POSTOVERRIDEVALUE");
			gridInstance[HEADER_ROW,POST_OVERRIDE_VALUE].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);    
			gridInstance.ColWidths[POST_OVERRIDE_VALUE] = 140; 
			gridInstance[HEADER_ROW,DATA_CONFIDANCE_LEVEL].Text = LRRHeaderText.GetHeaderString("SID_DATACONFIDENCELEVEL");
			gridInstance[HEADER_ROW,DATA_CONFIDANCE_LEVEL].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);    
			gridInstance.ColWidths[DATA_CONFIDANCE_LEVEL] = 140;
            gridInstance[HEADER_ROW, HEADER_ISTEMPLATEOVERRIDE].Text = LRRHeaderText.GetHeaderString("SID_IsTemplateOverride");
            gridInstance[HEADER_ROW, HEADER_ISTEMPLATEOVERRIDE].BackColor = System.Drawing.Color.FromKnownColor(System.Drawing.KnownColor.Control);  
            gridInstance.ColWidths[HEADER_ISTEMPLATEOVERRIDE] = 140;
			#endregion
		}

        /// <summary>
        /// Creates the grid.
        /// </summary>
        /// <param name="gridInstance">The grid instance.</param>
        /// <param name="objCollection">The obj collection.</param>
        /// <param name="objGrpOvCollection">The obj GRP ov collection.</param>
        /// <param name="objAggOverrides">The obj agg overrides.</param>
        /// <param name="objAggGroupOverrides">The obj agg group overrides.</param>
		private void CreateGrid(GridControl gridInstance,LRROverrides objCollection,LRRGroupOverrides objGrpOvCollection,LRRAggregateOverrides objAggOverrides,LRRAggGroupOverrides objAggGroupOverrides )
		{
			int iRow = HEADER_ROW +1;

			#region Simple Properties

			for(int i = 0;i<objCollection.Count;i++)
			{
				LRROverride overrideValue = objCollection[i] as LRROverride;

				if(!_rowsArrary.Contains(iRow))
				{
					_rowsArrary.Add(overrideValue); 
				}
				#region GridData
				string mode = "";
				string sitecomp ="";
				string attribute = "";
				string uomTypeID = "";
				LRRMode _mode = LRRModel.ChildModel.Modes.GetModeByID(overrideValue.ModeID);
                if (_mode != null)
                {
                    mode = _mode.ModeName;
                }
                else
                { 
                    _rowsArrary.Remove(overrideValue);
                    continue;
                }
				LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(overrideValue.SiteComponentID);
                if (lsc != null)
                {
                    sitecomp = lsc.Name;
                }
                else
                {
                    _rowsArrary.Remove(overrideValue);
                    continue;
                }
				LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(overrideValue.SiteComponentPropertyID);
                if (lscp != null)
                {
                    attribute = lscp.Name;
                    uomTypeID = lscp.UOMTypeID;
                }
                else
                {
                    _rowsArrary.Remove(overrideValue);
                    continue;
                }
				string uomName = overrideValue.UOM;
				string preOverrideVal= overrideValue.PreOverrideValue;
				string postOverrideVal = overrideValue.PostOverrideValue;  
				string dataConfidanceLevel = overrideValue.DataConfidenceLevelID; 
				LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);

				#endregion

				#region ModeColomn
				gridInstance.Model[iRow,MODE_NAME].Text =  mode;
				gridInstance.Model[iRow,MODE_NAME].BackColor = Color.LightGray;
				gridInstance.Model[iRow,MODE_NAME].ReadOnly = true;
				#endregion

				#region SiteComponentColomn
				gridInstance.Model[iRow,SITECOMPONENT].Text = sitecomp; 
				gridInstance.Model[iRow,SITECOMPONENT].BackColor = Color.LightGray;
				gridInstance.Model[iRow,SITECOMPONENT].ReadOnly = true;  
				#endregion

				#region AttributeColomn
				gridInstance.Model[iRow,ATTRIBUTE].Text =  attribute;
				gridInstance.Model[iRow,ATTRIBUTE].BackColor = Color.LightGray;
				//gridInstance.Model[iRow,ATTRIBUTE].ReadOnly = true;
				

				#endregion

                gridControlInstance.Model[iRow, HEADER_ISTEMPLATEOVERRIDE].ReadOnly = false;
                if (overrideValue.IsTemplateOverride.ToString() == "0")
                {
                    gridControlInstance.Model[iRow, HEADER_ISTEMPLATEOVERRIDE].Text = "False";
                }
                else if (overrideValue.IsTemplateOverride.ToString() == "1")
                {
                    gridControlInstance.Model[iRow, HEADER_ISTEMPLATEOVERRIDE].Text = "True";
                }
                else
                {
                    gridControlInstance.Model[iRow, HEADER_ISTEMPLATEOVERRIDE].Text = overrideValue.IsTemplateOverride.ToString();
                }
                gridControlInstance.Model[iRow, HEADER_ISTEMPLATEOVERRIDE].ReadOnly = true;
                //gridControlInstance.Model[iRow, HEADER_ISTEMPLATEOVERRIDE].Text = overrideValue.IsTemplateOverride.ToString();
                gridInstance.Model[iRow, HEADER_ISTEMPLATEOVERRIDE].BackColor = Color.LightGray;

				#region UOMColomn
				//for UOM 
				if(lrrUOMType != null && lrrUOMType.UOMTypeID != null && lrrUOMType.UOMTypeID != "")
				{
					gridInstance.Model[iRow,UOM_NAME].Text = uomName; 
					LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
					gridInstance.Model[iRow,UOM_NAME].CellType = "ComboBox";
					gridInstance.Model[iRow,UOM_NAME].DataSource = uom;
					gridInstance.Model[iRow,UOM_NAME].DisplayMember = "Name";
					gridInstance.Model[iRow,UOM_NAME].ValueMember = "ID";
					gridInstance.Model[iRow,UOM_NAME].ExclusiveChoiceList = true;
				}
				#endregion

				#region PrOVerrideValues & PostOverrideValues Colomns
				//For checkin IsEVV values true or false
				if(uomName == "")
				{
					if(uomTypeID != null && uomTypeID.Trim() != "")
					{
						if(lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
						{
							LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(uomTypeID);
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text = preOverrideVal;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].CellType = "ComboBox";
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ReadOnly = true;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].DataSource = evvs;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ValueMember = "EVV";
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].CellType = "ComboBox";
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].DataSource = evvs;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].DisplayMember = "EVV";
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].ValueMember = "EVV";
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
						}
					}
					else
						{
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
						}


				}
				else
				{
					gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
					gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
					gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
                    //gridInstance.Model[iRow,POST_OVERRIDE_VALUE].
				}
				#endregion

				#region DataConfidancelevel
				//DataConfidance Level

				LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;  
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].Text =  dataConfidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].CellValue =  dataConfidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;

				#endregion

				iRow++;
			}

			#endregion

			#region Group Properties

			for(int j=0;j<objGrpOvCollection.Count ;j++)
			{
				LRRGroupOverride grpOverrideValue = objGrpOvCollection[j] as LRRGroupOverride;
				if(!_rowsArrary.Contains(iRow))
				{
					_rowsArrary.Add(grpOverrideValue);
                }

				#region GridData

				string grpPropmode = "";
				string grpSitecomp ="";
				string grpAttribute = "";
				string grpUomTypeID = "";

				LRRMode mode = LRRModel.Modes.GetModeByID(grpOverrideValue.ModeID);  
				if(mode != null)
				{
					grpPropmode = mode.ModeName;
				}
                else
                {
                    _rowsArrary.Remove(grpOverrideValue);
                    continue;
                }
				LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(grpOverrideValue.SiteComponentID);
                if (lsc != null)
                {
                    grpSitecomp = lsc.Name;
                }
                else
                {
                    _rowsArrary.Remove(grpOverrideValue);
                    continue;
                }
				LRRSiteComponentGroupProperty  lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(grpOverrideValue.GroupPropertyID);
				LRRLookUpQualifiers lookUpQualifiers = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lscgp.PropertyID);
				foreach(LRRLookUpQualifier lookUpQualifier in lookUpQualifiers)
				{
					if(lookUpQualifier.QualifierID == grpOverrideValue.QualifierID)
					{
						grpUomTypeID = lookUpQualifier.UOMTypeID;  
					}
				}
                if (lscgp != null)
                {
                    if (grpOverrideValue.QualifierID == null || grpOverrideValue.QualifierID == "")
                    {
                        string propName = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscgp.MasterPropID).Name;
                        grpAttribute = propName + " / " + lscgp.AttributeName;
                    }
                    else
                    {
                        string propName = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscgp.MasterPropID).Name;
                        grpAttribute = propName + " / " + lscgp.AttributeName + " / " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(grpOverrideValue.QualifierID).Name;
                    }
                }
                else
                {
                    _rowsArrary.Remove(grpOverrideValue);
                    continue;
                }
				string uomName = grpOverrideValue.UOM;
				string preOverrideVal= grpOverrideValue.PreOverrideValue;
				string postOverrideVal = grpOverrideValue.PostOverrideValue;  
				string dataConfidanceLevel = grpOverrideValue.DataConfidenceLevelID; 
				LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(grpUomTypeID);
				#endregion

				#region ModeColomn
				gridInstance.Model[iRow,MODE_NAME].Text =  grpPropmode ;
				gridInstance.Model[iRow,MODE_NAME].BackColor = Color.LightGray;
				gridInstance.Model[iRow,MODE_NAME].ReadOnly = true;
				#endregion

				#region SiteComponentColomn
				gridInstance.Model[iRow,SITECOMPONENT].Text = grpSitecomp; 
				gridInstance.Model[iRow,SITECOMPONENT].BackColor = Color.LightGray;
				gridInstance.Model[iRow,SITECOMPONENT].ReadOnly = true;  
				#endregion

				#region AttributeColomn
				gridInstance.Model[iRow,ATTRIBUTE].Text =  grpAttribute;
				gridInstance.Model[iRow,ATTRIBUTE].BackColor = Color.LightGray;
				gridInstance.Model[iRow,ATTRIBUTE].ReadOnly = true;
				#endregion

				#region UOMColomn
				//for UOM 
				if(lrrUOMType != null && lrrUOMType.UOMTypeID != null && lrrUOMType.UOMTypeID != "")
				{
					gridInstance.Model[iRow,UOM_NAME].Text = uomName; 
					LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
					gridInstance.Model[iRow,UOM_NAME].CellType = "ComboBox";
					gridInstance.Model[iRow,UOM_NAME].DataSource = uom;
					gridInstance.Model[iRow,UOM_NAME].DisplayMember = "Name";
					gridInstance.Model[iRow,UOM_NAME].ValueMember = "ID";
					gridInstance.Model[iRow,UOM_NAME].ExclusiveChoiceList = true;
				}
				#endregion

				#region PrOVerrideValues & PostOverrideValues Colomns
				//For checkin IsEVV values true or false
				if(uomName == "")
				{
					if(grpUomTypeID != null && grpUomTypeID.Trim() != "")
					{
						if(lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(grpUomTypeID))
						{
							LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(grpUomTypeID);
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text = preOverrideVal;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].CellType = "ComboBox";
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ReadOnly = true;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].DataSource = evvs;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ValueMember = "EVV";
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].CellType = "ComboBox";
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].DataSource = evvs;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].DisplayMember = "EVV";
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].ValueMember = "EVV";
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
						}
					}
				}
				else
				{
					gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
					gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
					gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
				}
				#endregion

				#region DataConfidancelevel
				//DataConfidance Level

				LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;  
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].Text =  dataConfidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].CellValue =  dataConfidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;

				#endregion

				iRow++;
			}

			#endregion

            #region Aggregate Properties

            for (int i = 0; i < objAggOverrides.Count; i++)
            {
                LRRAggregateOverride aggOverrideValue = objAggOverrides[i] as LRRAggregateOverride;
                if (!_rowsArrary.Contains(iRow))
                {
                    _rowsArrary.Add(aggOverrideValue);
                }

                #region GridData
                string mode = "";
                string aggComp = "";
                string attribute = "";
                string uomTypeID = "";
                LRRMode _mode = LRRModel.ChildModel.Modes.GetModeByID(aggOverrideValue.ModeID);
                if (_mode != null)
                {
                    mode = _mode.ModeName;
                }
                else
                {
                    _rowsArrary.Remove(aggOverrideValue);
                    continue;
                }
                LRRAggregate agg = LRRModel.AggregatesObj.GetAggregateFromID(aggOverrideValue.AggregateID);
                if (agg != null)
                {
                    aggComp = agg.Name;
                }
                else
                {
                    _rowsArrary.Remove(aggOverrideValue);
                    continue;
                }
                LRRAggregateProperty aggProperty = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggOverrideValue.AggregatePropertyID);
                if (aggProperty != null)
                {
                    attribute = aggComp + " / " + aggProperty.Name;
                    uomTypeID = aggProperty.UOMTypeID;
                }
                else
                {
                    _rowsArrary.Remove(aggOverrideValue);
                    continue;
                }
                string uomName = aggOverrideValue.UOM;
                string preOverrideVal = aggOverrideValue.PreOverrideValue;
                string postOverrideVal = aggOverrideValue.PostOverrideValue;
                string dataConfidanceLevel = aggOverrideValue.DataConfidenceLevelID;
                LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);

                #endregion

                #region ModeColomn
                gridInstance.Model[iRow, MODE_NAME].Text = mode;
                gridInstance.Model[iRow, MODE_NAME].BackColor = Color.LightGray;
                gridInstance.Model[iRow, MODE_NAME].ReadOnly = true;
                #endregion

                #region SiteComponentColomn
                gridInstance.Model[iRow, SITECOMPONENT].Text = aggComp;
                gridInstance.Model[iRow, SITECOMPONENT].BackColor = Color.LightGray;
                gridInstance.Model[iRow, SITECOMPONENT].ReadOnly = true;
                #endregion

                #region AttributeColomn
                gridInstance.Model[iRow, ATTRIBUTE].Text = attribute;
                gridInstance.Model[iRow, ATTRIBUTE].BackColor = Color.LightGray;
                gridInstance.Model[iRow, ATTRIBUTE].ReadOnly = true;


                #endregion

                #region UOMColomn
                //for UOM 
                if (lrrUOMType != null && lrrUOMType.UOMTypeID != null && lrrUOMType.UOMTypeID != "")
                {
                    gridInstance.Model[iRow, UOM_NAME].Text = uomName;
                    LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
                    gridInstance.Model[iRow, UOM_NAME].CellType = "ComboBox";
                    gridInstance.Model[iRow, UOM_NAME].DataSource = uom;
                    gridInstance.Model[iRow, UOM_NAME].DisplayMember = "Name";
                    gridInstance.Model[iRow, UOM_NAME].ValueMember = "ID";
                    gridInstance.Model[iRow, UOM_NAME].ExclusiveChoiceList = true;
                }
                #endregion

                #region PrOVerrideValues & PostOverrideValues Colomns
                //For checkin IsEVV values true or false
                if (uomName == "")
                {
                    if (uomTypeID != null && uomTypeID.Trim() != "")
                    {
                        if (lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
                        {
                            LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(uomTypeID);
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].Text = preOverrideVal;
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].BackColor = Color.LightGray;
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].CellType = "ComboBox";
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].ReadOnly = true;
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].DataSource = evvs;
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].ValueMember = "EVV";
                            gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
                            gridInstance.Model[iRow, POST_OVERRIDE_VALUE].Text = postOverrideVal;
                            gridInstance.Model[iRow, POST_OVERRIDE_VALUE].CellType = "ComboBox";
                            gridInstance.Model[iRow, POST_OVERRIDE_VALUE].DataSource = evvs;
                            gridInstance.Model[iRow, POST_OVERRIDE_VALUE].DisplayMember = "EVV";
                            gridInstance.Model[iRow, POST_OVERRIDE_VALUE].ValueMember = "EVV";
                            gridInstance.Model[iRow, POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
                        }
                    }
                }
                else
                {
                    gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].Text = preOverrideVal;
                    gridInstance.Model[iRow, PRE_OVERRIDE_VALUE].BackColor = Color.LightGray;
                    gridInstance.Model[iRow, POST_OVERRIDE_VALUE].Text = postOverrideVal;
                }
                #endregion

                #region DataConfidancelevel
                //DataConfidance Level

                LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;
                gridInstance.Model[iRow, DATA_CONFIDANCE_LEVEL].Text = dataConfidanceLevel;
                gridInstance.Model[iRow, DATA_CONFIDANCE_LEVEL].CellValue = dataConfidanceLevel;
                gridInstance.Model[iRow, DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
                gridInstance.Model[iRow, DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
                gridInstance.Model[iRow, DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
                gridInstance.Model[iRow, DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
                gridInstance.Model[iRow, DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;

                #endregion

                iRow++;
            }
            #endregion

			#region Aggregate Group Properties

			for(int j=0;j<objAggGroupOverrides.Count;j++)
			{
				LRRAggGroupOverride aggGrpOverrideValue = objAggGroupOverrides[j] as LRRAggGroupOverride;
				if(!_rowsArrary.Contains(iRow))
				{
					_rowsArrary.Add(aggGrpOverrideValue);
                }

				#region [GridData]
				string grpPropmode = "";
				string grpSitecomp ="";
				string grpAttribute = "";
				string grpUomTypeID = "";
				LRRMode mode = LRRModel.Modes.GetModeByID(aggGrpOverrideValue.ModeID);
                if (mode != null)
                {
                    grpPropmode = mode.ModeName;
                }
                else
                {
                    _rowsArrary.Remove(aggGrpOverrideValue);
                    continue;
                }
				LRRAggregate lAgg = LRRModel.AggregatesObj.GetAggregateFromID(aggGrpOverrideValue.AggregateID);
				if(lAgg !=null)
				{
					grpSitecomp = lAgg.Name;
				}
                else
                {
                    _rowsArrary.Remove(aggGrpOverrideValue);
                    continue;
                }
				LRRAggregateGroupedProperty lAggGroupProp = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpOverrideValue.AggGroupPropertyID);
				LRRLookUpQualifiers lookUpQualifiers = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lAggGroupProp.AggregatePropertyID);

				foreach(LRRLookUpQualifier lookUpQualifier in lookUpQualifiers)
				{
					if(lookUpQualifier.QualifierID == aggGrpOverrideValue.QualifierID)
					{
						grpUomTypeID = lookUpQualifier.UOMTypeID;  
					}
				}
				if(lAggGroupProp!=null)
				{
					if(aggGrpOverrideValue.QualifierID == null || aggGrpOverrideValue.QualifierID == "")
					{
						string propName = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lAggGroupProp.MasterPropID).Name; 
						grpAttribute =  propName + " / " + lAggGroupProp.AttributeName;
					}
					else
				    {
					    string propName = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lAggGroupProp.MasterPropID).Name;    
					    grpAttribute =  propName + " / " + lAggGroupProp.AttributeName + " / " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(aggGrpOverrideValue.QualifierID).Name;
                    } 
				}
                else
                {
                    _rowsArrary.Remove(aggGrpOverrideValue);
                    continue;
                }

				string uomName = aggGrpOverrideValue.UOM;
				string preOverrideVal= aggGrpOverrideValue.PreOverrideValue;
				string postOverrideVal = aggGrpOverrideValue.PostOverrideValue;  
				string dataConfidanceLevel = aggGrpOverrideValue.DataConfidenceLevelID; 
				LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(grpUomTypeID);

			 
				#endregion [GridData]

				#region [ModeColumn]
				gridInstance.Model[iRow,MODE_NAME].Text =  grpPropmode ;
				gridInstance.Model[iRow,MODE_NAME].BackColor = Color.LightGray;
				gridInstance.Model[iRow,MODE_NAME].ReadOnly = true;
				#endregion [ModeColumn]

				#region [SiteComponenttColumn]
				gridInstance.Model[iRow,SITECOMPONENT].Text = grpSitecomp; 
				gridInstance.Model[iRow,SITECOMPONENT].BackColor = Color.LightGray;
				gridInstance.Model[iRow,SITECOMPONENT].ReadOnly = true;  
				#endregion [SiteComponentColumn]

				#region [AttributeColumn]
				gridInstance.Model[iRow,ATTRIBUTE].Text =  grpAttribute;
				gridInstance.Model[iRow,ATTRIBUTE].BackColor = Color.LightGray;
				gridInstance.Model[iRow,ATTRIBUTE].ReadOnly = true;
				#endregion [AttributeColumn]

				#region [UOMColumn] 
					if(lrrUOMType != null && lrrUOMType.UOMTypeID != null && lrrUOMType.UOMTypeID != "")
					{
						gridInstance.Model[iRow,UOM_NAME].Text = uomName; 
						LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
						gridInstance.Model[iRow,UOM_NAME].CellType = "ComboBox";
						gridInstance.Model[iRow,UOM_NAME].DataSource = uom;
						gridInstance.Model[iRow,UOM_NAME].DisplayMember = "Name";
						gridInstance.Model[iRow,UOM_NAME].ValueMember = "ID";
						gridInstance.Model[iRow,UOM_NAME].ExclusiveChoiceList = true;
					}
				#endregion [UOMColumn]

				#region [PreOverrideValues & PostOverrideValues Columns] 
						//For checkin IsEVV values true or false
					if(uomName == "")
					{
						if(grpUomTypeID != null && grpUomTypeID.Trim() != "")
						{
							if(lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(grpUomTypeID))
							{
								LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(grpUomTypeID);
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text = preOverrideVal;
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].CellType = "ComboBox";
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ReadOnly = true;
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].DataSource = evvs;
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ValueMember = "EVV";
								gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
								gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal;
								gridInstance.Model[iRow,POST_OVERRIDE_VALUE].CellType = "ComboBox";
								gridInstance.Model[iRow,POST_OVERRIDE_VALUE].DataSource = evvs;
								gridInstance.Model[iRow,POST_OVERRIDE_VALUE].DisplayMember = "EVV";
								gridInstance.Model[iRow,POST_OVERRIDE_VALUE].ValueMember = "EVV";
								gridInstance.Model[iRow,POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
							}
						}

						else
						{
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
							gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
							gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
						}

					}
					else
					{
						gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
						gridInstance.Model[iRow,PRE_OVERRIDE_VALUE].BackColor  =  Color.LightGray;
						gridInstance.Model[iRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
					}
				#endregion [PreOverrideValues & PostOverrideValues Columns] 

				#region [DataConfidencelevel]
				LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;  
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].Text =  dataConfidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].CellValue =  dataConfidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
				gridInstance.Model[iRow,DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;
				#endregion [DataConfidencelevel] 

				iRow++;
			}
			#endregion Aggregate Group Properties 
		}


        /// <summary>
        /// Checks for opened case.
        /// </summary>
        /// <param name="lrrOverride">The LRR override.</param>
		private void CheckForOpenedCase(LRROverride lrrOverride)
		{
			if(lrrOverride.ModeID != "3")
				return;
			if(!_arrListSavedCaseOverrides.Contains(lrrOverride.ID))
			{
				//Check if Dynamic Scenario Saved Case is opened
				LRRMode mode = LRRModel.ProjectModes.GetModeByID("3");
				string caseID = null;
				if(mode.ModeTypeID == "1")
				{
					caseID = _lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.CaseID;
				}
				else if(mode.ModeTypeID == "2")
				{
					caseID = _lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.CaseID;
				}
				else if(mode.ModeTypeID == "3")
				{
					caseID = _lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.CaseID;
				}
				if(caseID != null)
				{
					LRRSavedCase lrrSavedCase = LRRModel.ChildModel.SavedCases.GetSavedCaseByID(caseID);
					if(lrrSavedCase.IsDynamic)
					{
						_arrListSavedCaseOverrides.Add(lrrOverride.ID);
					}
				}
			}
		}

        /// <summary>
        /// Clears the saved case overrides.
        /// </summary>
		public void ClearSavedCaseOverrides()
		{
			for(int i=0;i < _arrListSavedCaseOverrides.Count;i++)
			{
				string id = _arrListSavedCaseOverrides[i] as String;
				LRROverride overrideObj = LRRModel.ChildModel.Overrides.GetOverrideObjByID(id);
				LRRModel.ChildModel.Overrides.Remove(overrideObj);
			}
		}

        /// <summary>
        /// Handles the CurrentCellCloseDropDown event of the gridControlInstance control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.PopupClosedEventArgs"/> instance containing the event data.</param>
		private void gridControlInstance_CurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs e)
		{
			GridControl gc = sender as GridControl;
			int iRow = gc.CurrentCellInfo.RowIndex;
			int iCol = gc.CurrentCellInfo.ColIndex;
			if(iCol == UOM_NAME || iCol == DATA_CONFIDANCE_LEVEL)
			{
				string  oldUOMvalue = gc[iRow,iCol].Text;
				string currentValue  = gc.CurrentCell.Renderer.ControlValue.ToString(); 
				LRROverride lrrOverride = _rowsArrary[iRow-1] as LRROverride;
				if(lrrOverride != null)
				{
					string ID = lrrOverride.ID; 
					LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrOverride.SiteComponentPropertyID);
					string modeID = lrrOverride.ModeID;
					LRRSiteComponentPropertyValues lrrSCPVs = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(lrrSiteCompProperty.ID);
                    if (lrrSCPVs != null)
                    {
                        foreach (LRRSiteComponentPropertyValue lrrSiteCompPropValue in lrrSCPVs)
                        {
                            IPropertyValue iPropValue = lrrSiteCompPropValue as IPropertyValue;
                            string ModeID = iPropValue.GetModeID();
                            if (ModeID == modeID)
                            {
                                if (iCol == DATA_CONFIDANCE_LEVEL)
                                {
                                    lrrOverride.DataConfidenceLevelID = currentValue;
                                    iPropValue.SetDataConfidenceLevelID(currentValue);
                                    //Update Overrides
                                    _lrrApp.UpdateOverridePoints();
                                }
                            }
                            if (iCol == UOM_NAME)
                            {
                                if (ModeID == modeID)
                                {
                                    lrrOverride.UOM = currentValue;
                                    string uomID = iPropValue.GetUOMID();
                                    string lrrDataType = iPropValue.GetDataType();

                                    //Convert property value according to UIUOM 
                                    string propertyValue = iPropValue.GetActualPropertyValue();
                                    propertyValue = ConvertUOM(uomID, currentValue, propertyValue, lrrDataType);
                                    lrrOverride.PostOverrideValue = propertyValue;
                                    gc.Model[iRow, POST_OVERRIDE_VALUE].Text = propertyValue;

                                    //Convert PreOverride Value
                                    string preOverrideValue = iPropValue.GetActualOverridedValue();
                                    preOverrideValue = ConvertUOM(uomID, currentValue, preOverrideValue, lrrDataType);
                                    lrrOverride.PreOverrideValue = preOverrideValue;
                                    gc.Model[iRow, PRE_OVERRIDE_VALUE].Text = preOverrideValue;
                                }
                            }
                        }
                    }
				}
				else
				{
					LRRGroupOverride grpOverrideObj = _rowsArrary[iRow-1] as LRRGroupOverride;
                    if (grpOverrideObj != null)
                    {
                        string ID = grpOverrideObj.ID;
                        LRRSiteComponentGroupProperty lrrSiteCompGrpProperty = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(grpOverrideObj.GroupPropertyID);
                        string modeID = grpOverrideObj.ModeID;
                        string qualifierID = grpOverrideObj.QualifierID;
                        object lrrSCGPQV = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(lrrSiteCompGrpProperty.GroupPropertyID, lrrSiteCompGrpProperty.LookUpPropertiesID, qualifierID, modeID);
                        IPropertyValue iPropValue = lrrSCGPQV as IPropertyValue;
                        string ModeID = iPropValue.GetModeID();
                        if (ModeID == modeID)
                        {
                            if (iCol == DATA_CONFIDANCE_LEVEL)
                            {
                                grpOverrideObj.DataConfidenceLevelID = currentValue;
                                iPropValue.SetDataConfidenceLevelID(currentValue);
                                
                                _lrrApp.UpdateGrpOverridePoints();
                            }
                        }
                        if (iCol == UOM_NAME)
                        {
                            if (ModeID == modeID)
                            {
                                grpOverrideObj.UOM = currentValue;
                                string uomID = iPropValue.GetUOMID();
                                string lrrDataType = iPropValue.GetDataType();
                                //Convert PostOverride Value
                                string propertyValue = iPropValue.GetActualPropertyValue();
                                propertyValue = iPropValue.GetPropertyValueForUOM(uomID, currentValue, propertyValue);//ConvertUOM(uomID,newUOM,propertyValue);
                                grpOverrideObj.PostOverrideValue = propertyValue;
                                gc.Model[iRow, POST_OVERRIDE_VALUE].Text = propertyValue;


                                //Convert PreOverride Value
                                string preOverrideValue = iPropValue.GetActualOverridedValue();
                                preOverrideValue = ConvertUOM(uomID, currentValue, preOverrideValue, lrrDataType);
                                grpOverrideObj.PreOverrideValue = preOverrideValue;
                                gc.Model[iRow, PRE_OVERRIDE_VALUE].Text = preOverrideValue;
                            }
                        }
                    }
                    else
                    {
                        LRRAggregateOverride lrrAggOverride = _rowsArrary[iRow - 1] as LRRAggregateOverride;
                        if (lrrAggOverride != null)
                        {
                            string ID = lrrAggOverride.ID;
                            LRRAggregateProperty lrrAggProperty = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(lrrAggOverride.AggregatePropertyID);
                            string modeID = lrrAggOverride.ModeID;
                            LRRAggregatePropertyValues lrrAggVs = LRRModel.AggregatePropertyValuesObj.GetPropValuesCollectionByPropID(lrrAggProperty.ID);
                            foreach (LRRAggregatePropertyValue lrrAggV in lrrAggVs)
                            {
                                IPropertyValue iPropValue = lrrAggV as IPropertyValue;
                                string ModeID = iPropValue.GetModeID();
                                if (ModeID == modeID)
                                {
                                    if (iCol == DATA_CONFIDANCE_LEVEL)
                                    {
                                        lrrAggOverride.DataConfidenceLevelID = currentValue;
                                        iPropValue.SetDataConfidenceLevelID(currentValue);
                                        //Update Overrides
                                        _lrrApp.UpdateAggregateOverridePoints(); 
                                    }
                                }
                                if (iCol == UOM_NAME)
                                {
                                    if (ModeID == modeID)
                                    {
                                        lrrAggOverride.UOM = currentValue;
                                        string uomID = iPropValue.GetUOMID();
                                        string lrrDataType = iPropValue.GetDataType();
                                        //Convert property value according to UIUOM 
                                        string propertyValue = iPropValue.GetActualPropertyValue();
                                        propertyValue = ConvertUOM(uomID, currentValue, propertyValue, lrrDataType);
                                        lrrAggOverride.PostOverrideValue = propertyValue;
                                        gc.Model[iRow, POST_OVERRIDE_VALUE].Text = propertyValue;

                                        //Convert PreOverride Value
                                        string preOverrideValue = iPropValue.GetActualOverridedValue();
                                        preOverrideValue = ConvertUOM(uomID, currentValue, preOverrideValue, lrrDataType);
                                        lrrAggOverride.PreOverrideValue = preOverrideValue;
                                        gc.Model[iRow, PRE_OVERRIDE_VALUE].Text = preOverrideValue;
                                    }
                                }
                            }
                        }

							  //AggGroupOverride
							  LRRAggGroupOverride aggGrpOverrideObj = _rowsArrary[iRow-1] as LRRAggGroupOverride ;
							  if(aggGrpOverrideObj!=null)
							  {
								  string ID= aggGrpOverrideObj.ID;
								  LRRAggregateGroupedProperty lrrAggGrpProperty = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpOverrideObj.AggGroupPropertyID);
								  string modeID = aggGrpOverrideObj.ModeID;
								 string qualifierID = aggGrpOverrideObj.QualifierID;
								 object lrraggGPVal= LRRModel.AggregateGroupedPropertyValuesObj.GetGroupedValueObjectForPropertyMode(lrrAggGrpProperty.AggregateGroupedPropertyID,lrrAggGrpProperty.LookUpPropertiesID,qualifierID,modeID);
								  IPropertyValue iPropValue = lrraggGPVal as IPropertyValue;
                        string ModeID = iPropValue.GetModeID();
								if (ModeID == modeID)
                        {
                            if (iCol == DATA_CONFIDANCE_LEVEL)
                            {
										 aggGrpOverrideObj.DataConfidenceLevelID = currentValue;
                                iPropValue.SetDataConfidenceLevelID(currentValue);
										   _lrrApp.UpdataGrpAggOverridePoints(); 
									 }
								}
								if (iCol == UOM_NAME)
                        {
                            if (ModeID == modeID)
                            {
										 aggGrpOverrideObj.UOM = currentValue;
                                string uomID = iPropValue.GetUOMID();
                                string lrrDataType = iPropValue.GetDataType();
										  //Convert PostOverride Value
                                string propertyValue = iPropValue.GetActualPropertyValue();
                                propertyValue = iPropValue.GetPropertyValueForUOM(uomID, currentValue, propertyValue);//ConvertUOM(uomID,newUOM,propertyValue);
                                aggGrpOverrideObj.PostOverrideValue = propertyValue;
                                gc.Model[iRow, POST_OVERRIDE_VALUE].Text = propertyValue;


                                //Convert PreOverride Value
                                string preOverrideValue = iPropValue.GetActualOverridedValue();
                                preOverrideValue = ConvertUOM(uomID, currentValue, preOverrideValue, lrrDataType);
                                aggGrpOverrideObj.PreOverrideValue = preOverrideValue;
                                gc.Model[iRow, PRE_OVERRIDE_VALUE].Text = preOverrideValue;

									 }
								 }

							  } 
                    }
				}
            }
			gc.CurrentCell.ConfirmChanges();
			gc.Refresh();
		}
        /// <summary>
        /// Handles the CurrentCellShowingDropDown event of the gridControlInstance control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventArgs"/> instance containing the event data.</param>
		private void gridControlInstance_CurrentCellShowingDropDown(object sender, GridCurrentCellShowingDropDownEventArgs e)
		{
			GridControl gc = sender as GridControl;
			int iRow = gc.CurrentCellInfo.RowIndex;
			int iCol = gc.CurrentCellInfo.ColIndex;
			if(iCol == UOM_NAME)
			{
				LRROverride overrideObj = _rowsArrary[iRow-1] as LRROverride;
				if(overrideObj != null)
				{
					string ID = overrideObj.ID;
					string uomTypeID = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(overrideObj.SiteComponentPropertyID).UOMTypeID; 
					if(uomTypeID != null && uomTypeID.Trim() != "")
					{
						LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
						if(lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
						{
							LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
							e.Cancel = true;
						}
					}
				}
				else
				{
					LRRGroupOverride grpOverrideObj = _rowsArrary[iRow-1] as LRRGroupOverride;
                    if (grpOverrideObj != null)
                    {
                        string ID = grpOverrideObj.ID;
                        string uomTypeID = "";
                        LRRSiteComponentGroupProperty lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(grpOverrideObj.GroupPropertyID);
                        LRRLookUpQualifiers lookUpQualifiers = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lscgp.PropertyID);
                        foreach (LRRLookUpQualifier lookUpQualifier in lookUpQualifiers)
                        {
                            if (lookUpQualifier.QualifierID == grpOverrideObj.QualifierID)
                            {
                                uomTypeID = lookUpQualifier.UOMTypeID;
                            }
                        }
                        if (uomTypeID != null && uomTypeID.Trim() != "")
                        {
                            LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
                            if (lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
                            {
                                LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                e.Cancel = true;
                            }
                        }
                    }
                    else
                    {
                        LRRAggregateOverride aggOverrideObj = _rowsArrary[iRow - 1] as LRRAggregateOverride;
                        if (aggOverrideObj != null)
                        {
                            string ID = aggOverrideObj.ID;
                            string uomTypeID = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggOverrideObj.AggregatePropertyID).UOMTypeID; 
                            if (uomTypeID != null && uomTypeID.Trim() != "")
                            {
                                LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
                                if (lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
                                {
                                    LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                    e.Cancel = true;
                                }
                            }
                        }
								else
								{
									LRRAggGroupOverride aggGrpOverrideObj =  _rowsArrary[iRow-1] as LRRAggGroupOverride;
									if(aggGrpOverrideObj!=null)
									{
										string ID = aggGrpOverrideObj.ID;
										string uomTypeID = "";
										LRRAggregateGroupedProperty laggProp = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpOverrideObj.AggGroupPropertyID);
										LRRLookUpQualifiers lkupQualifiers = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(laggProp.PropertyID);
										 foreach (LRRLookUpQualifier lookUpQualifier in lkupQualifiers)
											{
												 if (lookUpQualifier.QualifierID == aggGrpOverrideObj.QualifierID)
												 {
													  uomTypeID = lookUpQualifier.UOMTypeID;
												 }
											}

										if (uomTypeID != null && uomTypeID.Trim() != "")
										{
											 LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
											 if (lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
											 {
												  LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
												  e.Cancel = true;
											 }
										}

									}

								 

								}
                    }
				}	
			}
		}
        /// <summary>
        /// Handles the CurrentCellEditingComplete event of the gridControlInstance control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gridControlInstance_CurrentCellEditingComplete(object sender, EventArgs e)
		{
			
			GridControl gc = sender as GridControl;
			int iCol = gc.CurrentCellInfo.ColIndex;
			int iRow = gc.CurrentCellInfo.RowIndex;
            if(iCol == POST_OVERRIDE_VALUE)
			{
				LRROverride overrideObj = _rowsArrary[iRow-1] as LRROverride;
				if(overrideObj != null)
				{
					string PropValue = gc.CurrentCell.Renderer.ControlValue.ToString(); 
					string ID = overrideObj.ID;
					LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(overrideObj.SiteComponentPropertyID);
					string modeID = overrideObj.ModeID;
					LRRSiteComponentPropertyValues lrrSCPVs = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(lrrSiteCompProperty.ID);
					foreach(LRRSiteComponentPropertyValue lrrSiteCompPropValue in lrrSCPVs)
					{
						if(lrrSiteCompPropValue.ModeID == modeID)
						{
                            lrrSiteCompPropValue.PropertyValue = ConvertUOM(overrideObj.UOM, lrrSiteCompPropValue.GetUOMID(), PropValue, lrrSiteCompPropValue.LRRDataType);
                            overrideObj.PostOverrideValue = ConvertUOM(overrideObj.UOM, lrrSiteCompPropValue.GetUOMID(), PropValue, lrrSiteCompPropValue.LRRDataType);
						}
					}
				}
				else
				{
					LRRGroupOverride groupOverrideObj = _rowsArrary[iRow-1] as LRRGroupOverride;
                    if (groupOverrideObj != null)
                    {
                        string propValue = gc.CurrentCell.Renderer.ControlValue.ToString();
                        string ID = groupOverrideObj.ID;
                        LRRSiteComponentGroupProperty lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(groupOverrideObj.GroupPropertyID);
                        string modeID = groupOverrideObj.ModeID;
                        //LRRSiteGroupPropertyQualifierValues groupPropValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(lscgp.GroupPropertyID);
                        List<IPropertyValue> lstVals = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(lscgp.GroupPropertyID);

                        foreach (IPropertyValue val in lstVals)
                        {
                            LRRSiteGroupPropertyQualifierValue groupPropValue = val as LRRSiteGroupPropertyQualifierValue;
                            if (groupPropValue.ModeID == modeID)
                            {
                                groupPropValue.PropertyValue = ConvertUOM(groupOverrideObj.UOM, groupPropValue.GetUOMID(), propValue, groupPropValue.LRRDataType);
                                groupOverrideObj.PostOverrideValue = ConvertUOM(groupOverrideObj.UOM, groupPropValue.GetUOMID(), propValue, groupPropValue.LRRDataType);
                            }
                        }
                        //foreach(LRRSiteGroupPropertyQualifierValue  groupPropValue in groupPropValues)
                        //{

                        //}
                    }
                    else
                    {
                        LRRAggregateOverride aggOverrideObj = _rowsArrary[iRow - 1] as LRRAggregateOverride;
                        if (aggOverrideObj != null)
                        {
                            string propValue = gc.CurrentCell.Renderer.ControlValue.ToString();
                            string ID = aggOverrideObj.ID;
                            LRRAggregateProperty aggProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggOverrideObj.AggregatePropertyID);
                            string modeID = aggOverrideObj.ModeID;
                            List<IPropertyValue> lstVals = LRRModel.AggregatePropertyValuesObj.GetPropValuesByPropID(aggOverrideObj.AggregatePropertyID);
                            foreach (IPropertyValue val in lstVals)
                            {
                                LRRAggregatePropertyValue aggPropValue = val as LRRAggregatePropertyValue;
                                if (aggPropValue.ModeID == modeID)
                                {
                                    aggPropValue.PropertyValue = ConvertUOM(aggOverrideObj.UOM, aggPropValue.GetUOMID(), propValue, aggPropValue.LRRDataType);
                                    aggOverrideObj.PostOverrideValue = ConvertUOM(aggOverrideObj.UOM, aggPropValue.GetUOMID(), propValue, aggPropValue.LRRDataType);
                                }
                            }
                        }

							  //  AggGrpoverride
							  LRRAggGroupOverride aggGrpOverrideObj = _rowsArrary[iRow-1] as LRRAggGroupOverride;
							  if(aggGrpOverrideObj!=null)
							  {
									string propValue = gc.CurrentCell.Renderer.ControlValue.ToString();
									string ID = aggGrpOverrideObj.ID;
								  LRRAggregateGroupedProperty laggp = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpOverrideObj.AggGroupPropertyID);
								  string modeID= aggGrpOverrideObj.ModeID;
								 LRRAggregateGroupedPropertyValues aggPropValues = LRRModel.AggregateGroupedPropertyValuesObj.GetGroupedValuesFromGroupPropID(laggp.AggregateGroupedPropertyID);
								  
								  	foreach (LRRAggregateGroupedPropertyValue val in aggPropValues)
									{
										LRRAggregateGroupedPropertyValue aggGrpPropVal = val as LRRAggregateGroupedPropertyValue;
										if(aggGrpPropVal.ModeID ==modeID)
										{
                                            aggGrpPropVal.PropertyValue = ConvertUOM(aggGrpOverrideObj.UOM, aggGrpPropVal.GetUOMID(), propValue, aggGrpPropVal.LRRDataType);
                                            aggGrpOverrideObj.PostOverrideValue = ConvertUOM(aggGrpOverrideObj.UOM, aggGrpPropVal.GetUOMID(), propValue, aggGrpPropVal.LRRDataType);

										}
									}

							  }					

                    }
				}
			}
		}
        /// <summary>
        /// Converts the UOM.
        /// </summary>
        /// <param name="oldUOMValue">The old UOM value.</param>
        /// <param name="newUOMValue">The new UOM value.</param>
        /// <param name="propVal">The prop val.</param>
        /// <returns></returns>
		private string ConvertUOM(string oldUOMValue,string newUOMValue,string propVal,string lrrDataTypeID)
		{
			string newVal = "";
			if(propVal != null && propVal != "")
			{
				if(oldUOMValue == newUOMValue)
				{
					newVal = propVal;
				}
				else
				{
					if((oldUOMValue != null && oldUOMValue != "") &&
						(newUOMValue != null && newUOMValue != ""))
					{
                        newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldUOMValue, newUOMValue, propVal, lrrDataTypeID);
					}
				}
			}
			return newVal;
		}

		public class DisplayMemberComparer : IComparer
		{
			string _fieldName = null;

            /// <summary>
            /// Initializes a new instance of the <see cref="DisplayMemberComparer"/> class.
            /// </summary>
            /// <param name="fieldName">Name of the field.</param>
			public DisplayMemberComparer(string fieldName)
			{
				_fieldName = fieldName;
			}

			#region Implementation of IComparer
			public int Compare(object x, object y)
			{
				if(x == null && y == null)
					return 0;
				else if(x == null)
					return -1;
				else if(y == null)
					return 1;
				else
				{
					try
					{
						string xDM = "";
						string yDM = "";
						if(_fieldName == "ModeID")
						{
							xDM = LRRModel.ChildModel.Modes.GetModeByID(x.ToString()).ModeName;
							yDM = LRRModel.ChildModel.Modes.GetModeByID(y.ToString()).ModeName;
						}
						else if(_fieldName == "SiteComponentID")
						{
							xDM = LRRModel.ChildModel.SiteComponents.GetSiteComponentByID(x.ToString()).Name;
							yDM = LRRModel.ChildModel.SiteComponents.GetSiteComponentByID(y.ToString()).Name;
						}
						else if(_fieldName == "SiteComponentPropertyID")
						{
							xDM = LRRModel.ChildModel.SiteComponentProperties.GetSiteCompPropFromID(x.ToString()).Name;
							yDM = LRRModel.ChildModel.SiteComponentProperties.GetSiteCompPropFromID(y.ToString()).Name;
						}
						else if(_fieldName == "UOM")
						{
							xDM = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(x.ToString()).Name;
							yDM = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(y.ToString()).Name;
						}
						else if(_fieldName == "DataConfidenceLevelID")
						{
							xDM = LRRModel.ChildModel.DataConfidenceLevels.GetConfidenceLevelFromID(x.ToString()).ConfidenceLevel;
							yDM = LRRModel.ChildModel.DataConfidenceLevels.GetConfidenceLevelFromID(y.ToString()).ConfidenceLevel;
						}
						return xDM.CompareTo(yDM);
					}
					catch (Exception ex)
					{
						Logger.LogMessage(typeof(OverridesWindow),"Compare:"+ ex.Message  ,Logger.Level.Debug);
					}
				
					return 0;
				}
			}
	
			#endregion
		}

        /// <summary>
        /// Handles the ItemAdded event of the _lrrOverrides control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void _lrrOverrides_ItemAdded(object sender, EventArgs e)
		{
			LRROverride overrideValue = sender as LRROverride;

			//Check for Dyanmic Opened Case And Add to openedCase arrayList
			CheckForOpenedCase(overrideValue);

			int iNewRow = gridControlInstance.RowCount+1;
			gridControlInstance.RowCount = iNewRow;
			if(!_rowsArrary.Contains(iNewRow))
			{
				_rowsArrary.Add(overrideValue); 
			}
			#region GridData

			string mode = LRRModel.ChildModel.Modes.GetModeByID(overrideValue.ModeID).ModeName;      
			string sitecomp = LRRModel.SiteComponentsObj.GetSiteComponentByID(overrideValue.SiteComponentID).Name;     
			string attribute = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(overrideValue.SiteComponentPropertyID).Name;
			string uomName = overrideValue.UOM;
			string preOverrideVal= overrideValue.PreOverrideValue;
			string postOverrideVal = overrideValue.PostOverrideValue;  
			string dataConfidanceLevel = overrideValue.DataConfidenceLevelID; 
			string uomTypeID = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(overrideValue.SiteComponentPropertyID).UOMTypeID; 
			LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);

			#endregion

			#region ModeColomn
			gridControlInstance[iNewRow,MODE_NAME].Text =  mode;
			gridControlInstance.Model[iNewRow,MODE_NAME].BackColor  =  Color.LightGray;
			gridControlInstance[iNewRow,MODE_NAME].ReadOnly = true;
			#endregion

			#region SiteComponentColomn
			gridControlInstance[iNewRow,SITECOMPONENT].Text = sitecomp; 
			gridControlInstance[iNewRow,SITECOMPONENT].BackColor  = Color.LightGray;
			gridControlInstance[iNewRow,SITECOMPONENT].ReadOnly = true;  
			#endregion

			#region AttributeColomn
			gridControlInstance[iNewRow,ATTRIBUTE].Text =  attribute;
			gridControlInstance[iNewRow,ATTRIBUTE].BackColor  = Color.LightGray;
			
			gridControlInstance[iNewRow,ATTRIBUTE].ReadOnly = true;
			#endregion

			#region UOMColomn
			//for UOM 
			gridControlInstance[iNewRow,UOM_NAME].Text = uomName; 
			if(lrrUOMType.UOMTypeID != null || lrrUOMType.UOMTypeID != "")
			{
				LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
				gridControlInstance[iNewRow,UOM_NAME].CellType = "ComboBox";
				gridControlInstance[iNewRow,UOM_NAME].DataSource = uom;
				gridControlInstance[iNewRow,UOM_NAME].DisplayMember = "Name";
				gridControlInstance[iNewRow,UOM_NAME].ValueMember = "ID";
				gridControlInstance[iNewRow,UOM_NAME].ExclusiveChoiceList = true;
			}
			#endregion

			#region PrOVerrideValues & PostOverrideValues Colomns
			//For checkin IsEVV values true or false
			if(uomName == "" || uomName == null)
			{
				if(uomTypeID != null && uomTypeID.Trim() != "")
				{
					if(lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
					{
						LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(uomTypeID);
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].Text = preOverrideVal;
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].CellType = "ComboBox";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ReadOnly = true;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].DataSource = evvs;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ValueMember = "EVV";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].CellType = "ComboBox";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].DataSource = evvs;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].DisplayMember = "EVV";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].ValueMember = "EVV";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
					}
					else
					{
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
						gridControlInstance[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
					}
				}
			}
			else
			{	
				gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
				gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
				gridControlInstance[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
			}

			#endregion

			#region DataConfidancelevel
			//DataConfidance Level


			LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;  
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].Text =  dataConfidanceLevel;
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;

			#endregion

		}
		private bool _isDelete = false;
        /// <summary>
        /// Handles the ItemDeleted event of the _lrrOverrides control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void _lrrOverrides_ItemDeleted(object sender, EventArgs e)
		{
			CustomCollection ccObj = sender as CustomCollection;
			ArrayList _objToDelete = new ArrayList();
			foreach(LRROverride overrideValue in ccObj.DeletedItems)
			{
				for(int i=0;i<_rowsArrary.Count;i++)
				{
					LRROverride _override = _rowsArrary[i] as LRROverride; 
					if(_override != null)
					{
						string id = _override.ID; 
						if(id == overrideValue.ID)
						{
							_objToDelete.Add(_override); 
							if(!_isOverrideDelte)
							{
								int iRow = i+1;
								gridControlInstance.Model.Rows.RemoveRange(iRow,iRow);   
							}
							//Remove from saved case ArrayList
							if(_arrListSavedCaseOverrides.Contains(id))
								_arrListSavedCaseOverrides.Remove(id);
							break;
						}
					}
				}
			}
			if(!_isOverrideDelte)
			{
				for(int i=0;i<_objToDelete.Count;i++)
				{
					LRROverride _removeObj = _objToDelete[i] as LRROverride;
					_rowsArrary.Remove(_removeObj);
				}
			}
        }

        /// <summary>
        /// Handles the CellClick event of the gridControlInstance control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs"/> instance containing the event data.</param>
		private void gridControlInstance_CellClick(object sender, GridCellClickEventArgs e)
		{
			if(e.ColIndex != PRE_OVERRIDE_VALUE && e.ColIndex != POST_OVERRIDE_VALUE)
			{
				if(e.MouseEventArgs.Button  == MouseButtons.Left && e.RowIndex == 0)
				{
					GridControl gc = sender as GridControl;
					int colIndex = e.ColIndex;
					SortCol(colIndex,gridControlInstance); 
				}
			}
		}
        /// <summary>
        /// Sorts the col.
        /// </summary>
        /// <param name="col">The col.</param>
        /// <param name="gridControl">The grid control.</param>
		public void SortCol(int col,GridControl gridControl)
		{
			if(gridControl.CurrentCell.IsEditing)
				gridControl.CurrentCell.EndEdit();
		
			GridStyleInfo style = new GridStyleInfo();
			style.Tag = "";

			//turn off the old sort arrow
			for(int col1 = 1; col1 <= gridControl.ColCount; ++col1)
				if(col1 != col && gridControl[0, col1].CellType == "ColumnHeaderCell")
				{
					gridControl[0, col1].CellType = "Header";
					break;
				}

			//turn on new sort arrow
			gridControl[0, col].CellType = "ColumnHeaderCell";
			string colName = gridControl[0, col].Text; 

			System.ComponentModel.ListSortDirection dir = System.ComponentModel.ListSortDirection.Ascending;
			if(gridControl[0, col].HasTag)
			{
				if((System.ComponentModel.ListSortDirection) gridControl[0, col].Tag == System.ComponentModel.ListSortDirection.Ascending)
					dir = System.ComponentModel.ListSortDirection.Descending;
			}
			
			gridControl[0, col].Tag = dir;

			int headerCount = 0;
			OverrideWndSortUtility sortUtilityObj = new OverrideWndSortUtility(); 
//			Comparer iComp = new Comparer();

			gridControl.Data.SortByColumn(col,dir,headerCount);
			gridControl.Refresh(); 

			int direction = 0;
			if(dir == System.ComponentModel.ListSortDirection.Ascending)
				direction = 0;
			if(dir == System.ComponentModel.ListSortDirection.Descending)
				direction = 1;
			//Sort the Row List
			sortUtilityObj.SortColumn = colName;
			sortUtilityObj.SortingOrder = direction; 
			_rowsArrary.Sort(sortUtilityObj); 
		}

        /// <summary>
        /// Handles the CurrentCellStartEditing event of the gridControlInstance control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.ComponentModel.CancelEventArgs"/> instance containing the event data.</param>
		private void gridControlInstance_CurrentCellStartEditing(object sender, CancelEventArgs e)
		{
			GridControl gc = sender as GridControl;
			int iCol = gc.CurrentCellInfo.ColIndex;
			if(iCol == PRE_OVERRIDE_VALUE)
			{
				e.Cancel = true;
			}
		}
        /// <summary>
        /// Sets the data confidance level.
        /// </summary>
        /// <param name="overrideID">The override ID.</param>
		public void SetDataConfidanceLevel(string overrideID)
		{
			for(int i = 0;i<_rowsArrary.Count;i++)
			{
				LRROverride overrideObj = _rowsArrary[i] as LRROverride;
				if(overrideObj != null)
				{
					if(overrideObj.ID == overrideID)
					{
						int iRow = i+1;
						this.gridControlInstance[iRow,DATA_CONFIDANCE_LEVEL].Text = overrideObj.DataConfidenceLevelID;
					}
				}
				else
				{
					LRRGroupOverride grpOverrideObj = _rowsArrary[i] as LRRGroupOverride;
                    if (grpOverrideObj != null)
                    {
                        int iRow = i + 1;
                        this.gridControlInstance[iRow, DATA_CONFIDANCE_LEVEL].Text = grpOverrideObj.DataConfidenceLevelID;
                    }
                    else
                    {
                        LRRAggregateOverride aggOverrideObj = _rowsArrary[i] as LRRAggregateOverride;
                        if (aggOverrideObj != null)
                        {
                            int iRow = i + 1;
                            this.gridControlInstance[iRow, DATA_CONFIDANCE_LEVEL].Text = aggOverrideObj.DataConfidenceLevelID;
                        }
                    }
				}
			}
		}

        /// <summary>
        /// Handles the ItemAdded event of the _lrrGrpOverrides control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void _lrrGrpOverrides_ItemAdded(object sender, EventArgs e)
		{
			LRRGroupOverride  grpOverrideValue = sender as LRRGroupOverride;

			int iNewRow = gridControlInstance.RowCount+1;
			gridControlInstance.RowCount = iNewRow;
			if(!_rowsArrary.Contains(iNewRow))
			{
				_rowsArrary.Add(grpOverrideValue); 
			}

			#region GridData

			string mode = LRRModel.ChildModel.Modes.GetModeByID(grpOverrideValue.ModeID).ModeName;      
			string sitecomp = LRRModel.SiteComponentsObj.GetSiteComponentByID(grpOverrideValue.SiteComponentID).Name;     
			LRRSiteComponentGroupProperty  lscgp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(grpOverrideValue.GroupPropertyID);
			string propName = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscgp.MasterPropID).Name;
            string attribute = null;
            if (grpOverrideValue.QualifierID == null || grpOverrideValue.QualifierID == "")
            {
                attribute = propName + " / " + lscgp.AttributeName + " / ";
            }
            else
            {
                attribute = propName + " / " + lscgp.AttributeName + " / " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(grpOverrideValue.QualifierID).Name;
            }
			string uomName = grpOverrideValue.UOM;
			string preOverrideVal= grpOverrideValue.PreOverrideValue;
			string postOverrideVal = grpOverrideValue.PostOverrideValue;  
			string dataConfidanceLevel = grpOverrideValue.DataConfidenceLevelID; 
			string uomTypeID = ""; 
			LRRLookUpQualifiers lookUpQualifiers = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lscgp.PropertyID);
			foreach(LRRLookUpQualifier lookUpQualifier in lookUpQualifiers)
			{
				if(lookUpQualifier.QualifierID == grpOverrideValue.QualifierID)
				{
					 uomTypeID = lookUpQualifier.UOMTypeID;  
				}
			}
			LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);


			#endregion

			#region ModeColomn
			gridControlInstance[iNewRow,MODE_NAME].Text =  mode;
			gridControlInstance.Model[iNewRow,MODE_NAME].BackColor  =  Color.LightGray;
			gridControlInstance[iNewRow,MODE_NAME].ReadOnly = true;
			#endregion

			#region SiteComponentColomn
			gridControlInstance[iNewRow,SITECOMPONENT].Text = sitecomp; 
			gridControlInstance[iNewRow,SITECOMPONENT].BackColor  = Color.LightGray;
			gridControlInstance[iNewRow,SITECOMPONENT].ReadOnly = true;  
			#endregion

			#region AttributeColomn
			gridControlInstance[iNewRow,ATTRIBUTE].Text =  attribute;
			gridControlInstance[iNewRow,ATTRIBUTE].BackColor  = Color.LightGray;
			gridControlInstance[iNewRow,ATTRIBUTE].ReadOnly = true;
			#endregion

			#region UOMColomn
			//for UOM 
			if(lrrUOMType != null)
			{
				gridControlInstance[iNewRow,UOM_NAME].Text = uomName; 
				if(lrrUOMType.UOMTypeID != null || lrrUOMType.UOMTypeID != "")
				{
					LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
					gridControlInstance[iNewRow,UOM_NAME].CellType = "ComboBox";
					gridControlInstance[iNewRow,UOM_NAME].DataSource = uom;
					gridControlInstance[iNewRow,UOM_NAME].DisplayMember = "Name";
					gridControlInstance[iNewRow,UOM_NAME].ValueMember = "ID";
					gridControlInstance[iNewRow,UOM_NAME].ExclusiveChoiceList = true;
				}
			}
			#endregion

			#region PrOVerrideValues & PostOverrideValues Colomns
			//For checkin IsEVV values true or false
			if(uomName == "" || uomName == null)
			{
				if(uomTypeID != null && uomTypeID.Trim() != "")
				{
					if(lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
					{
						LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(uomTypeID);
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].Text = preOverrideVal;
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].CellType = "ComboBox";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ReadOnly = true;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].DataSource = evvs;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ValueMember = "EVV";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].CellType = "ComboBox";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].DataSource = evvs;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].DisplayMember = "EVV";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].ValueMember = "EVV";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
					}
					else
					{
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
						gridControlInstance[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
					}
				}
                else
                {
                    gridControlInstance[iNewRow, PRE_OVERRIDE_VALUE].Text = preOverrideVal;
                    gridControlInstance[iNewRow, PRE_OVERRIDE_VALUE].BackColor = Color.LightGray;
                    gridControlInstance[iNewRow, POST_OVERRIDE_VALUE].Text = postOverrideVal;
                }
			}
			else
			{	
				gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
				gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
				gridControlInstance[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
			}

			#endregion

			#region DataConfidancelevel
			//DataConfidance Level


			LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;  
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].Text =  dataConfidanceLevel;
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;

			#endregion

		}

        /// <summary>
        /// Handles the ItemDeleted event of the _lrrGrpOverrides control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void _lrrGrpOverrides_ItemDeleted(object sender, EventArgs e)
		{
			CustomCollection ccObj = sender as CustomCollection;
			ArrayList _objToDelete = new ArrayList();
			foreach(LRRGroupOverride  grpOverrideValue in ccObj.DeletedItems)
			{
				for(int i=0;i<_rowsArrary.Count;i++)
				{
					LRRGroupOverride  _grpOverride = _rowsArrary[i] as LRRGroupOverride; 
					if(_grpOverride != null)
					{
						string id = _grpOverride.ID; 
						if(id == grpOverrideValue.ID)
						{
							_objToDelete.Add(_grpOverride); 
							if(!_isGrpOverrideDelete)
							{
								int iRow = i+1;
								gridControlInstance.Model.Rows.RemoveRange(iRow,iRow);   
							}
							//Remove from saved case ArrayList
							/*if(_arrListSavedCaseOverrides.Contains(id))
								_arrListSavedCaseOverrides.Remove(id);*/
							break;
						}
					}
				}
			}
			if(!_isGrpOverrideDelete)
			{
				for(int i=0;i<_objToDelete.Count;i++)
				{
					LRRGroupOverride _removeGrpOverrideObj = _objToDelete[i] as LRRGroupOverride;
					_rowsArrary.Remove(_removeGrpOverrideObj);
				}
			}
			
		}

        /// <summary>
        /// Handles the ItemDeleted event of the _lrrAggregateOverrids control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void _lrrAggregateOverrids_ItemDeleted(object sender, EventArgs e)
        {
            CustomCollection ccObj = sender as CustomCollection;
            ArrayList _objToDelete = new ArrayList();
            foreach (LRRAggregateOverride overrideValue in ccObj.DeletedItems)
            {
                for (int i = 0; i < _rowsArrary.Count; i++)
                {
                    LRRAggregateOverride _override = _rowsArrary[i] as LRRAggregateOverride;
                    if (_override != null)
                    {
                        string id = _override.ID;
                        if (id == overrideValue.ID)
                        {
                            _objToDelete.Add(_override);
                            if (!_isOverrideDelte)
                            {
                                int iRow = i + 1;
                                gridControlInstance.Model.Rows.RemoveRange(iRow, iRow);
                            }
                            //Remove from saved case ArrayList
                            /*if (_arrListSavedCaseOverrides.Contains(id))
                                _arrListSavedCaseOverrides.Remove(id);*/
                            break;
                        }
                    }
                }
            }
            if (!_isOverrideDelte)
            {
                for (int i = 0; i < _objToDelete.Count; i++)
                {
                    LRROverride _removeObj = _objToDelete[i] as LRROverride;
                    _rowsArrary.Remove(_removeObj);
                }
            }
        }

        /// <summary>
        /// Handles the ItemAdded event of the _lrrAggregateOverrids control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void _lrrAggregateOverrids_ItemAdded(object sender, EventArgs e)
        {
            LRRAggregateOverride aggOverrideValue = sender as LRRAggregateOverride;

            int iNewRow = gridControlInstance.RowCount + 1;
            gridControlInstance.RowCount = iNewRow;
            if (!_rowsArrary.Contains(iNewRow))
            {
                _rowsArrary.Add(aggOverrideValue);
            }

            #region GridData

            string mode = LRRModel.ChildModel.Modes.GetModeByID(aggOverrideValue.ModeID).ModeName;
            string aggComp = LRRModel.AggregatesObj.GetAggregateFromID(aggOverrideValue.AggregateID).Name;
            LRRAggregateProperty aggProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggOverrideValue.AggregatePropertyID);
            string attribute = aggComp + " / " + aggProp.Name;
            string uomName = aggOverrideValue.UOM;
            string preOverrideVal = aggOverrideValue.PreOverrideValue;
            string postOverrideVal = aggOverrideValue.PostOverrideValue;
            string dataConfidanceLevel = aggOverrideValue.DataConfidenceLevelID;
            string uomTypeID = aggProp.UOMTypeID;
            LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);

            #endregion

            #region ModeColomn
            gridControlInstance[iNewRow, MODE_NAME].Text = mode;
            gridControlInstance.Model[iNewRow, MODE_NAME].BackColor = Color.LightGray;
            gridControlInstance[iNewRow, MODE_NAME].ReadOnly = true;
            #endregion

            #region SiteComponentColomn
            gridControlInstance[iNewRow, SITECOMPONENT].Text = aggComp;
            gridControlInstance[iNewRow, SITECOMPONENT].BackColor = Color.LightGray;
            gridControlInstance[iNewRow, SITECOMPONENT].ReadOnly = true;
            #endregion

            #region AttributeColomn
            gridControlInstance[iNewRow, ATTRIBUTE].Text = attribute;
            gridControlInstance[iNewRow, ATTRIBUTE].BackColor = Color.LightGray;
            gridControlInstance[iNewRow, ATTRIBUTE].ReadOnly = true;
            #endregion

            #region UOMColomn
            //for UOM 
            if (lrrUOMType != null)
            {
                gridControlInstance[iNewRow, UOM_NAME].Text = uomName;
                if (lrrUOMType.UOMTypeID != null || lrrUOMType.UOMTypeID != "")
                {
                    LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
                    gridControlInstance[iNewRow, UOM_NAME].CellType = "ComboBox";
                    gridControlInstance[iNewRow, UOM_NAME].DataSource = uom;
                    gridControlInstance[iNewRow, UOM_NAME].DisplayMember = "Name";
                    gridControlInstance[iNewRow, UOM_NAME].ValueMember = "ID";
                    gridControlInstance[iNewRow, UOM_NAME].ExclusiveChoiceList = true;
                }
            }
            #endregion

            #region PrOVerrideValues & PostOverrideValues Colomns
            //For checkin IsEVV values true or false
            if (uomName == "" || uomName == null)
            {
                if (uomTypeID != null && uomTypeID.Trim() != "")
                {
                    if (lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
                    {
                        LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(uomTypeID);
                        gridControlInstance.Model[iNewRow, PRE_OVERRIDE_VALUE].Text = preOverrideVal;
                        gridControlInstance[iNewRow, PRE_OVERRIDE_VALUE].BackColor = Color.LightGray;
                        gridControlInstance.Model[iNewRow, PRE_OVERRIDE_VALUE].CellType = "ComboBox";
                        gridControlInstance.Model[iNewRow, PRE_OVERRIDE_VALUE].ReadOnly = true;
                        gridControlInstance.Model[iNewRow, PRE_OVERRIDE_VALUE].DataSource = evvs;
                        gridControlInstance.Model[iNewRow, PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
                        gridControlInstance.Model[iNewRow, PRE_OVERRIDE_VALUE].ValueMember = "EVV";
                        gridControlInstance.Model[iNewRow, PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
                        gridControlInstance.Model[iNewRow, POST_OVERRIDE_VALUE].Text = postOverrideVal;
                        gridControlInstance.Model[iNewRow, POST_OVERRIDE_VALUE].CellType = "ComboBox";
                        gridControlInstance.Model[iNewRow, POST_OVERRIDE_VALUE].DataSource = evvs;
                        gridControlInstance.Model[iNewRow, POST_OVERRIDE_VALUE].DisplayMember = "EVV";
                        gridControlInstance.Model[iNewRow, POST_OVERRIDE_VALUE].ValueMember = "EVV";
                        gridControlInstance.Model[iNewRow, POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
                    }
                    else
                    {
                        gridControlInstance[iNewRow, PRE_OVERRIDE_VALUE].Text = preOverrideVal;
                        gridControlInstance[iNewRow, PRE_OVERRIDE_VALUE].BackColor = Color.LightGray;
                        gridControlInstance[iNewRow, POST_OVERRIDE_VALUE].Text = postOverrideVal;
                    }
                }
            }
            else
            {
                gridControlInstance[iNewRow, PRE_OVERRIDE_VALUE].Text = preOverrideVal;
                gridControlInstance[iNewRow, PRE_OVERRIDE_VALUE].BackColor = Color.LightGray;
                gridControlInstance[iNewRow, POST_OVERRIDE_VALUE].Text = postOverrideVal;
            }

            #endregion

            #region DataConfidancelevel
            //DataConfidance Level


            LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;
            gridControlInstance[iNewRow, DATA_CONFIDANCE_LEVEL].Text = dataConfidanceLevel;
            gridControlInstance[iNewRow, DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
            gridControlInstance[iNewRow, DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
            gridControlInstance[iNewRow, DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
            gridControlInstance[iNewRow, DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
            gridControlInstance[iNewRow, DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;

            #endregion
        }


        /// <summary>
        /// Handles the ItemDeleted event of the _lrrAggGroupOverrides control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void _lrrAggGroupOverrides_ItemDeleted(object sender, EventArgs e)
		{
			 CustomCollection ccObj = sender as CustomCollection;
			ArrayList _objToDelete = new ArrayList();
			foreach(LRRAggGroupOverride  aggGrpOverrideValue in ccObj.DeletedItems)
			{
				for(int i=0;i<_rowsArrary.Count;i++)
				{
					LRRAggGroupOverride  _aggGrpOverride = _rowsArrary[i] as LRRAggGroupOverride; 
					if(_aggGrpOverride != null)
					{
						string id = _aggGrpOverride.ID; 
						if(id == aggGrpOverrideValue .ID)
						{
							_objToDelete.Add(_aggGrpOverride); 
							if(!_isAggGrpOverrideDelete)
							{
								int iRow = i+1;
								gridControlInstance.Model.Rows.RemoveRange(iRow,iRow);   
							}
							//Remove from saved case ArrayList
							/*if(_arrListSavedCaseOverrides.Contains(id))
								_arrListSavedCaseOverrides.Remove(id);*/
							break;
						}
					}
				}
			}
			if(!_isAggGrpOverrideDelete)
			{
				for(int i=0;i<_objToDelete.Count;i++)
				{
					LRRAggGroupOverride _removeGrpOverrideObj = _objToDelete[i] as LRRAggGroupOverride;
					_rowsArrary.Remove(_removeGrpOverrideObj);
				}
			}
		}

        /// <summary>
        /// Handles the ItemAdded event of the _lrrAggGroupOverrides control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void _lrrAggGroupOverrides_ItemAdded(object sender, EventArgs e)
		{
			 LRRAggGroupOverride  aggGrpOverrideValue  = sender as LRRAggGroupOverride;

			int iNewRow = gridControlInstance.RowCount+1;
			gridControlInstance.RowCount = iNewRow;
			if(!_rowsArrary.Contains(iNewRow))
			{
				_rowsArrary.Add(aggGrpOverrideValue );
			}

			#region[GridData]
			string mode = LRRModel.ChildModel.Modes.GetModeByID(aggGrpOverrideValue.ModeID).ModeName;
			string sitecomp = LRRModel.AggregatesObj.GetAggregateFromID(aggGrpOverrideValue.AggregateID).Name;     
			LRRAggregateGroupedProperty lrrAggGp  = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpOverrideValue.AggGroupPropertyID);
            LRRPropertyType propType = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(lrrAggGp.PropertyID); 
			string propName = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lrrAggGp.MasterPropID).Name;    
			string attribute =null;
			if(aggGrpOverrideValue.QualifierID == null || aggGrpOverrideValue.QualifierID == "")
			{
					attribute = propName + " / " + lrrAggGp.AttributeName + " / " ;
			}
			else
			{
				attribute = propName + " / " + lrrAggGp.AttributeName + " / " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(aggGrpOverrideValue.QualifierID).Name;
			}
			string uomName = aggGrpOverrideValue.UOM;
			string preOverrideVal= aggGrpOverrideValue.PreOverrideValue;
			string postOverrideVal = aggGrpOverrideValue.PostOverrideValue;
			string dataConfidanceLevel = aggGrpOverrideValue.DataConfidenceLevelID;
            string uomTypeID = propType.UOMTypeID;  
			LRRLookUpQualifiers lookUpQualifiers = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lrrAggGp.AggregatePropertyID);
			foreach(LRRLookUpQualifier lookUpQualifier in lookUpQualifiers)
			{
				if(lookUpQualifier.QualifierID == aggGrpOverrideValue.QualifierID)
				{
					 uomTypeID = lookUpQualifier.UOMTypeID;  
				}
			}

			LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);

			 
		 
			#endregion[GridData]

			 #region [ModeColumn]
            gridControlInstance[iNewRow, MODE_NAME].Text = mode;
            gridControlInstance.Model[iNewRow, MODE_NAME].BackColor = Color.LightGray;
            gridControlInstance[iNewRow, MODE_NAME].ReadOnly = true;
            #endregion [ModeColumn]

			#region [SiteComponentColumn]
			gridControlInstance[iNewRow,SITECOMPONENT].Text = sitecomp; 
			gridControlInstance[iNewRow,SITECOMPONENT].BackColor  = Color.LightGray;
			gridControlInstance[iNewRow,SITECOMPONENT].ReadOnly = true;  
			#endregion [SiteComponentColumn]

			#region [AttributeColumn]
			gridControlInstance[iNewRow,ATTRIBUTE].Text =  attribute;
			gridControlInstance[iNewRow,ATTRIBUTE].BackColor  = Color.LightGray;
			gridControlInstance[iNewRow,ATTRIBUTE].ReadOnly = true;
			#endregion [AttributeColumn]

			#region [UOMColumn]
			//for UOM 
			if(lrrUOMType != null)
			{
				gridControlInstance[iNewRow,UOM_NAME].Text = uomName; 
				if(lrrUOMType.UOMTypeID != null || lrrUOMType.UOMTypeID != "")
				{
					LRRUOMs uom = LRRModel.ChildModel.GetUOMsFromUOMTypeID(lrrUOMType.UOMTypeID);
					gridControlInstance[iNewRow,UOM_NAME].CellType = "ComboBox";
					gridControlInstance[iNewRow,UOM_NAME].DataSource = uom;
					gridControlInstance[iNewRow,UOM_NAME].DisplayMember = "Name";
					gridControlInstance[iNewRow,UOM_NAME].ValueMember = "ID";
					gridControlInstance[iNewRow,UOM_NAME].ExclusiveChoiceList = true;
				}
			}
			#endregion [UOMColumn]

			#region [PrOVerrideValues & PostOverrideValues Columns]
			//For checkin IsEVV values true or false
			if(uomName == "" || uomName == null)
			{
				if(uomTypeID != null && uomTypeID.Trim() != "")
				{
					if(lrrUOMType != null && lrrUOMType.IsEVV && !LRRModel.ChildModel.ConstantEVVs.ContainsKey(uomTypeID))
					{
						LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(uomTypeID);
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].Text = preOverrideVal;
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].CellType = "ComboBox";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ReadOnly = true;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].DataSource = evvs;
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].DisplayMember = "EVV";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ValueMember = "EVV";
						gridControlInstance.Model[iNewRow,PRE_OVERRIDE_VALUE].ExclusiveChoiceList = false;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].CellType = "ComboBox";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].DataSource = evvs;
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].DisplayMember = "EVV";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].ValueMember = "EVV";
						gridControlInstance.Model[iNewRow,POST_OVERRIDE_VALUE].ExclusiveChoiceList = true;
					}
					else
					{
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
						gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
						gridControlInstance[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
					}
				}
				else
				{
					gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
					gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
					gridControlInstance[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
				}
			}
			else
			{	
				gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].Text =  preOverrideVal;
				gridControlInstance[iNewRow,PRE_OVERRIDE_VALUE].BackColor  = Color.LightGray;
				gridControlInstance[iNewRow,POST_OVERRIDE_VALUE].Text = postOverrideVal; 
			}

			#endregion [PrOVerrideValues & PostOverrideValues Columns]
			 

			#region [DataConfidancelevel]
			//DataConfidance Level


			LRRDataConfidenceLevels confidanceLevel = LRRModel.ChildModel.DataConfidenceLevels;  
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].Text =  dataConfidanceLevel;
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].CellType = "ComboBox";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].DataSource = confidanceLevel;
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].DisplayMember = "ConfidenceLevel";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].ValueMember = "ID";
			gridControlInstance[iNewRow,DATA_CONFIDANCE_LEVEL].ExclusiveChoiceList = true;

			#endregion [DataConfidancelevel]


		}


	}
}