using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.MessageLogger;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;



namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for RecorderValues.
	/// </summary>
	public class RecordedProperties : System.Windows.Forms.Form
    {
        public GridGroupingControl gridRecordedValues;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public RecordedProperties()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject")	as LRRApp;
			this.Load+=new EventHandler(RecordedValues_Load);
			gridRecordedValues.SizeChanged += new EventHandler(gridRecordedValues_SizeChanged);
			gridRecordedValues.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp); 
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RecordedProperties));
            this.gridRecordedValues = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            ((System.ComponentModel.ISupportInitialize)(this.gridRecordedValues)).BeginInit();
            this.SuspendLayout();
            // 
            // gridRecordedValues
            // 
            this.gridRecordedValues.BackColor = System.Drawing.SystemColors.Window;
            this.gridRecordedValues.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridRecordedValues.Location = new System.Drawing.Point(0, 0);
            this.gridRecordedValues.Name = "gridRecordedValues";
            this.gridRecordedValues.Size = new System.Drawing.Size(505, 382);
            this.gridRecordedValues.TabIndex = 1;
            this.gridRecordedValues.TableOptions.ShowRowHeader = false;
            this.gridRecordedValues.Text = "Recorder Values";
            this.gridRecordedValues.VersionInfo = "3.301.0.0";
            this.gridRecordedValues.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridRecordedValues_TableControlQueryAllowSortColumn);
            this.gridRecordedValues.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridRecordedValues_QueryCellStyleInfo);
            this.gridRecordedValues.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridRecordedValues_SaveCellText);
            // 
            // RecordedProperties
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(505, 382);
            this.Controls.Add(this.gridRecordedValues);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "RecordedProperties";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Tag = "SID_RECORDED_VALUES";
            this.Activated += new System.EventHandler(this.RecordedProperties_Activated);
            ((System.ComponentModel.ISupportInitialize)(this.gridRecordedValues)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private void RecordedValues_Load(object sender, EventArgs e)
		{
			InitializeRecPropsGrid();
		}
        LRRRunRecords _lrrRunRecords;


        /// <summary>
        /// Initializes the rec props grid.
        /// </summary>
        public void InitializeRecPropsGrid()
		{
			//lrrRecProps = LRRModel.RecordedProperties;
            // added by ashwin for handling user specific recorded attributes
            lrrRecProps = new LRRRecordedProperies();
            //_lrrUserSpecificRecordedProps = LRRModel.UserSpecificRecordedProperties;
            _lrrUserSpecificRecordedProps = LRRModel.UserSpecificRecordedProperties;

            // end of change
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of	the	Grid...
			gridRecordedValues.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridRecordedValues);
//
//			
			columnForDisplay.Add("Name",null);
			columnForDisplay.Add("IsTracked", null);
			columnForDisplay.Add("SiteComponentID",null);
			
			
			//Populate the columns for the grid	object
			//SyncGridUtilities.InitializeGridColumns(gridRecordedValues,lrrRecProps.ItemType,null,true,columnForDisplay);
            SyncGridUtilities.InitializeGridColumns(gridRecordedValues, _lrrUserSpecificRecordedProps.ItemType, null, true, columnForDisplay);

//			GridColumnDescriptor gbc = new GridColumnDescriptor();
//			GridStyleInfo gsi = gbc.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
//			gsi.BaseStyle = "Standard";
//			gsi.AutoSize = true;
//			gsi.CellType = "ComboBox";
//			gsi.VerticalScrollbar = true;
//
//			gsi.DisplayMember = "Name";
//			gsi.ValueMember = "SiteComponentID";
//			gsi.DataSource = LRRModel.SiteComponentsObj;
//			gsi.ShowButtons = GridShowButtons.Hide;
//			gbc.HeaderText = "Item Name";
//			gbc.MappingName = "ComponentID";
//			GridTableDescriptor gtc = gridRecordedValues.TableDescriptor;
//			gtc.Columns.Add(gbc);


            RelativeWidths.Add("SiteComponentID_Name", 30);
			RelativeWidths.Add("Name",30);
			RelativeWidths.Add("IsTracked", 15);
			SyncGridUtilities.InitializeGridColumnsWidth(gridRecordedValues,RelativeWidths	);
			//Set the data store 
            // datasource changed from recorded property to user specific recorded property by ashwin
            //gridRecordedValues.DataSource = lrrRecProps;
            //gridRecordedValues.Engine.SourceListSet.Add("Parent", lrrRecProps);
            gridRecordedValues.DataSource = _lrrUserSpecificRecordedProps;
            gridRecordedValues.Engine.SourceListSet.Add("Parent", _lrrUserSpecificRecordedProps);

			gridRecordedValues.Engine.SourceListSet.Add(LRRModel.SiteComponentsObj);
			gridRecordedValues.TableDescriptor.AllowNew = false;
			gridRecordedValues.TableDescriptor.AllowRemove	= false;
			gridRecordedValues.TableDescriptor.AllowEdit =	true;

			gridRecordedValues.TableDescriptor.Columns["Name"].ReadOnly=true;
            gridRecordedValues.TableDescriptor.Columns["SiteComponentID_Name"].ReadOnly = true;
            gridRecordedValues.TableDescriptor.Columns["SiteComponentID_Name"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridRecordedValues.TableDescriptor.Columns["Name"].Width = 161;

			//gridRecordedValues.TableDescriptor.Columns["IsTracked"].Width = 20;
            gridRecordedValues.TableDescriptor.Columns["SiteComponentID_Name"].Width = 225;
            gridRecordedValues.TableDescriptor.Columns["SiteComponentID_Name"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;

            //gridRecordedValues.TopLevelGroupOptions.CaptionText = Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") + " {RecordCount} " + Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_ITEMS");  
            gridRecordedValues.TopLevelGroupOptions.CaptionText = Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_RECORDED_PROPERTIES") + " {RecordCount} " + Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_ITEMS");  

            gridRecordedValues.TopLevelGroupOptions.ShowCaption = true;
            
            // filter disabled by ashwin
            gridRecordedValues.TopLevelGroupOptions.ShowFilterBar = true;
			gridRecordedValues_SizeChanged(gridRecordedValues, new EventArgs());
			gridRecordedValues.ResumeLayout();
			_unBound.WireGrid(gridRecordedValues);
            // changed from recorded property to user specific recorded property by ashwin
			//object[] objArray = new object[lrrRecProps.Count];
            object[] objArray = new object[_lrrUserSpecificRecordedProps.Count];
			int k = 0;
            // for loop changed from recorded properties to user specific properites by ashwin
            /*
            foreach(LRRRecordedProperty _recProps in lrrRecProps)
            {
                objArray[k] = _recProps;
                k++;
            }
            */
            foreach (LRRUserSpecificRecordedProperty userSpRecProp in _lrrUserSpecificRecordedProps)
            {
                objArray[k] = userSpRecProp;
                k++;
            }
			_unBound.SetSelectedRecords(objArray);

		}

		#region Fields

		private CustomCollection _lrrRecordedVals;
		private LRRApp _lrrApp;
		private LRRRecordedProperies lrrRecProps;
        private LRRUserSpecificRecordedProperties _lrrUserSpecificRecordedProps;
		private GridUnBoundColumn	_unBound=new GridUnBoundColumn();
		private bool _isClose = false;


		#endregion

        /// <summary>
        /// Raises the <see cref="E:System.Windows.Forms.Form.Closing"></see> event.
        /// </summary>
        /// <param name="e">A <see cref="T:System.ComponentModel.CancelEventArgs"></see> that contains the event data.</param>
		protected override void OnClosing(CancelEventArgs e)
		{
            /*
            e.Cancel = true;
            this.Hide();
            _isClose = true;
            _lrrApp.MainFrame.Activate();
            _lrrApp.LRRUIManagerObj.IsRecordedPropsWindowActive = false;
            if (_lrrApp.LRRUIManagerObj.MainFrameObj.TabbedMDIChildList.TabCount == 0)
            {
                _lrrApp.LRRUIManagerObj.MainFrameObj.tlbExport.Enabled = false;
            }
            else
            {
                _lrrApp.LRRUIManagerObj.MainFrameObj.tlbExport.Enabled = true;
            }
            */
            
			e.Cancel = true;
			this.Hide();
			_isClose = true;
			_lrrApp.MainFrame.Activate();
            _lrrApp.LRRUIManagerObj.IsRecordedPropsWindowActive = false; 

			 if(_lrrApp.LRRUIManagerObj.MainFrameObj.TabbedMDIChildList.TabCount==0)
			  {
				  _lrrApp.LRRUIManagerObj.MainFrameObj.tlbExport.Enabled=false;
			  }
			  else
			  {
				 _lrrApp.LRRUIManagerObj.MainFrameObj.tlbExport.Enabled=true;
			  }
            
		}

        /// <summary>
        /// Handles the SizeChanged event of the gridRecordedValues control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gridRecordedValues_SizeChanged(object sender, EventArgs e)
		{
			int totalColsWidth = 0;
			
			foreach(GridColumnDescriptor gcd in this.gridRecordedValues.TableDescriptor.Columns)
			{
				totalColsWidth += gcd.Width;
			}

			float nPercent = (float)(this.gridRecordedValues.Width - (5 +(new VScrollBar()).Width))/(float)totalColsWidth;

			foreach(GridColumnDescriptor gcd in this.gridRecordedValues.TableDescriptor.Columns)
			{
				gcd.Width = (int)(gcd.Width * nPercent + 0.5);
				if(gcd.Width == 0)
					gcd.Width = 1;
			}
		}
		int row, col;
		bool CheckBoxValue = true;
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridRecordedValues control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
		private void gridRecordedValues_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("Select", out row , out col);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = CheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

        /// <summary>
        /// Handles the SaveCellText event of the gridRecordedValues control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
        LRRUserSpecificRecordedProperties removedUserSpecificRecordedProps = new LRRUserSpecificRecordedProperties();
		private void gridRecordedValues_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
        {
            DialogResult dr = MessageBox.Show("This will reset all the recorded attributes. Would you like to continue?", " ", MessageBoxButtons.YesNo);
            if (dr.ToString() == "Yes")
            {
                #region user selection dialog added by ashwin
                GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
                
                if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
                {
                    this.CheckBoxValue = bool.Parse(e.Text);
                    // user specific part added by ashwin
                    foreach (LRRUserSpecificRecordedProperty userRecProp in _lrrUserSpecificRecordedProps)
                    {
                        LRRUserSpecificRecordedProperty modeluserRecProp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, userRecProp.SiteComponentPropertyID);
                        if (modeluserRecProp != null)
                        {
                            modeluserRecProp.IsTracked = false;
                            modeluserRecProp.UID = _lrrApp.UID;
                            modeluserRecProp.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                            removedUserSpecificRecordedProps.Add(userRecProp);
                        }

                    }
                    if (removedUserSpecificRecordedProps.Count > 0)
                    {
                        _lrrApp.DBManagerObj.CommitCollection(removedUserSpecificRecordedProps);
                    }
                    //_lrrUserSpecificRecordedProps = null;
                    
                    foreach (LRRUserSpecificRecordedProperty userRecProp in removedUserSpecificRecordedProps)
                    {
                        _lrrUserSpecificRecordedProps.Remove(userRecProp);
                    }
                     
                    /*
                    IEnumerator iEnum = lrrRecProps.GetEnumerator();
                    ArrayList selectedRecords = new ArrayList();
                    while (iEnum.MoveNext())
                    {
                        
                        LRRRecordedProperty _recProps = iEnum.Current as LRRRecordedProperty;
                        if (_recProps != null)
                        {
                            selectedRecords.Add(_recProps);
                        }
                    }
                    object[] objSelectedRecords = new object[selectedRecords.Count];
                    for (int i = 0; i < selectedRecords.Count; i++)
                    {
                        LRRRecordedProperty recProp = selectedRecords[i] as LRRRecordedProperty;
                        recProp.IsTracked = false;
                    }
                    //_unBound.SetSelectedRecords(objSelectedRecords,CheckBoxValue);  
                    gridRecordedValues.Refresh();
                    e.Handled = true;
                    */
                }
                else
                {
                    GridGroupingControl _grid = sender as GridGroupingControl;
                    // changed from LRRRecordedProperty to user specific property by ashwin
                    //LRRRecordedProperty _recProp = _grid.CurrencyManager.Current as LRRRecordedProperty;
                    //if (_recProp != null)
                    //{
                    //    _recProp.IsTracked = false;
                    //}

                    LRRUserSpecificRecordedProperty userRecProp = _grid.CurrencyManager.Current as LRRUserSpecificRecordedProperty;
                    if (userRecProp != null)
                    {
                        LRRUserSpecificRecordedProperty modeluserRecProp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, userRecProp.SiteComponentPropertyID);
                        if (modeluserRecProp != null)
                        {
                            modeluserRecProp.IsTracked = false;
                            modeluserRecProp.UID = _lrrApp.UID;
                            modeluserRecProp.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                            removedUserSpecificRecordedProps.Add(userRecProp);
                            LRRModel.UserSpecificRecordedProperties.Remove(modeluserRecProp);
                        }

                    }
                    /*
                    LRRRecordedProperty _recProp = _grid.CurrencyManager.Current as LRRRecordedProperty;

                    if (_recProp != null)
                    {
                        _recProp.IsTracked = false;
                    }
                     * */
                    //gridRecordedValues.Refresh();
                    //e.Handled = true;

                }

                #endregion
            }
		}

        /// <summary>
        /// Handles the TableControlQueryAllowSortColumn event of the gridRecordedValues control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs"/> instance containing the event data.</param>
		private void gridRecordedValues_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == "Select")
			{
				e.AllowSort = false;
			}
		}

        /// <summary>
        /// Handles the MouseUp event of the TableControl control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
		private void TableControl_MouseUp(object sender, MouseEventArgs e)
		{
			int row, col;
			GridTableControl gridTableControl = sender as GridTableControl;
			gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
			GridTableCellStyleInfo style = gridTableControl.Model[row, col];

			IMouseController controller;
			gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

			if(controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
			{
				gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
			}
		}

        /// <summary>
        /// Raises the <see cref="E:System.Windows.Forms.Form.Activated"></see> event.
        /// </summary>
        /// <param name="e">An <see cref="T:System.EventArgs"></see> that contains the event data.</param>
		protected override void OnActivated(EventArgs e)
		{
            /*
			if(_isClose)
			{
				object[] _recObj = new object[lrrRecProps.Count];  
				if(lrrRecProps.Count >0)
				{
					for(int i = 0 ;i<lrrRecProps.Count;i++)
					{
						_recObj[i] = lrrRecProps[i];
					}
				}
				_unBound.SetSelectedRecords(_recObj,true); 	
			}
             * */
            if (_isClose)
            {
                object[] recObj = new object[_lrrUserSpecificRecordedProps.Count];
                if (_lrrUserSpecificRecordedProps.Count > 0)
                {
                    for (int i = 0; i < _lrrUserSpecificRecordedProps.Count; i++)
                    {
                        recObj[i] = _lrrUserSpecificRecordedProps[i];
                    }
                }
                _unBound.SetSelectedRecords(recObj, true);
            }
		}

        /// <summary>
        /// Raises the <see cref="E:System.Windows.Forms.Form.Deactivate"></see> event.
        /// </summary>
        /// <param name="e">The <see cref="T:System.EventArgs"></see> that contains the event data.</param>
		protected override void OnDeactivate(EventArgs e)
		{
            /*
			if(this.Visible == false)
			{
				IEnumerator iEnum = lrrRecProps.GetEnumerator(); 
				LRRSiteComponentProperties selectedSCPs = new LRRSiteComponentProperties(); 
				while(iEnum.MoveNext())
				{
                    
					LRRRecordedProperty recProps = iEnum.Current as LRRRecordedProperty; 
					foreach(LRRSiteComponentProperty siteCompProperty in LRRModel.SiteComponentPropertiesObj)
					{
						if(siteCompProperty.ArrListUpdatedColNames.Contains("IsTracked"))
						{
							selectedSCPs.Add(siteCompProperty);
						}
					}
                    
				}
                if (selectedSCPs.Count != 0)
                {
                    _lrrApp.DBManagerObj.ExecuteBatchUpdate(selectedSCPs);
                }
			}
			*/
            //if (this.Visible == false)
            //{
                LRRSiteComponentProperties selectedSCPs = new LRRSiteComponentProperties();
                LRRSiteComponentProperties scps = LRRModel.SiteComponentPropertiesObj.GetChanges();
                foreach (LRRSiteComponentProperty scp in scps)
                {
                    if (scp.ArrListUpdatedColNames.Contains("IsTracked"))
                    {
                        selectedSCPs.Add(scp);
                    }
                }
                if (removedUserSpecificRecordedProps.Count > 0)
                {
                    _lrrApp.DBManagerObj.CommitCollection(removedUserSpecificRecordedProps);
                }
                if (selectedSCPs.Count != 0)
                {
                    _lrrApp.DBManagerObj.ExecuteBatchUpdate(selectedSCPs);
                }
                base.OnDeactivate(e);
            //}
		}

		private void RecordedProperties_Activated(object sender, System.EventArgs e)
		{
			/*if(_isClose)
			{
				object[] _recObj = new object[lrrRecProps.Count];  
				if(lrrRecProps.Count >0)
				{
					for(int i = 0 ;i<lrrRecProps.Count;i++)
					{
						_recObj[i] = lrrRecProps[i];
					}
				}
				_unBound.SetSelectedRecords(_recObj,true); 	
			}*/
		}

        

	}
}
