using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Symcon.BusinessObjects;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
namespace Symcon.LightRidge.PEAdvisor.GridUtilities
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class DuplicateValidation
	{
		public DuplicateValidation()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		/*public void ChkDuplicate(GridGroupingControl grid,string fieldName)
		{
			this._gridGrouping = grid;
			this.chkForDuplicate = fieldName; 
			this._gridGrouping.CurrentRecordContextChange+=new CurrentRecordContextChangeEventHandler(_gridGrouping_CurrentRecordContextChange);  
		}*/

        /// <summary>
        /// CHKs the duplicate.
        /// </summary>
        /// <param name="grid">The grid.</param>
        /// <param name="pKID">The p KID.</param>
        /// <param name="cKID">The c KID.</param>
        /// <param name="parentFieldName">Name of the parent field.</param>
        /// <param name="childFieldName">Name of the child field.</param>
        /// <param name="parentID">The parent ID.</param>
		public void ChkDuplicate(GridGroupingControl grid,string pKID,string cKID,string parentFieldName,string childFieldName,string parentID)
		{
			this._gridGrouping = grid;
			this.chkDuplicateForParent = parentFieldName;
			this.chkDuplicateForChild = childFieldName;
			this.parentKeyField = pKID;
			this.childKeyField = cKID; 
			this.parentValue = parentID;
			this._gridGrouping.TableControlCurrentCellValidating+=new GridTableControlCancelEventHandler(_gridGrouping_TableControlCurrentCellValidating); 
			
		}
	
		#region Fields
		private GridGroupingControl						_gridGrouping = null;
		private string							 		chkDuplicateForParent = null;
		private string									chkDuplicateForChild = null;
		private string									parentKeyField = null;
		private string									childKeyField = null;
		private string									parentValue = null;
		private string									_preValue = null;
		private bool									_isInvalidate = false;
		#endregion

        /// <summary>
        /// Handles the TableControlCurrentCellValidating event of the _gridGrouping control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs"/> instance containing the event data.</param>
		private void _gridGrouping_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
		{
			try
			{
				if(this._gridGrouping.TableControl.Table.CurrentRecord != null)
				{
					int iRow = e.TableControl.CurrentCell.RowIndex;
					int iCol = e.TableControl.CurrentCell.ColIndex;
					string sColHeader = e.TableControl.Table.TableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;    //tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
					if(e.TableControl.TableDescriptor.Columns[chkDuplicateForParent].HeaderText == sColHeader)
					{
						if(e.TableControl.TableDescriptor.Columns.Contains(chkDuplicateForParent))   
						{
							object recObj = e.TableControl.Table.CurrentRecord.GetData();       
							string keyValue = recObj.GetType().GetProperty(parentKeyField).GetValue(recObj,null).ToString();       
							foreach(Record r1 in _gridGrouping.Table.Records) 
							{
								if(r1.GetValue(chkDuplicateForParent)!=null)
								{
									string s = r1.GetValue(chkDuplicateForParent).ToString(); 
									string key = r1.GetValue(parentKeyField).ToString();
									if(keyValue != key)
									{
										object obj = e.TableControl.CurrentCell.Renderer.ControlText;      
										if(s.Trim().ToUpper() == obj.ToString().Trim().ToUpper())
										{
											//MessageBox.Show("Duplicate name - '"+s+"' exists. Can not continue !","PE-Advisor",MessageBoxButtons.OK,MessageBoxIcon.Error);
											string[] str = new string[1];
											str[0] = s;
											LRRMessagBox.ShowMessage("SID_DUPLICATE_VALUE","SID_LABEL",str,MessageBoxButtons.OK,MessageBoxIcon.Error);      
											e.Inner.Cancel = true; 
											break;
										}
									}
								}
							}
						}
					}
				}
				else
				{
                    if (chkDuplicateForChild != null)
                    {
                        if (e.TableControl.TableDescriptor.Columns.Contains(chkDuplicateForChild))
                        {
                            int iRow = e.TableControl.CurrentCell.RowIndex;
                            int iCol = e.TableControl.CurrentCell.ColIndex;
                            string sColHeader = e.TableControl.Table.TableModel.GetColumnDescriptorAt(iRow, iCol).HeaderText;    //tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
                            if (e.TableControl.TableDescriptor.Columns[chkDuplicateForChild].HeaderText == sColHeader)
                            {
                                Element eCurrentInnerElement = _gridGrouping.Table.GetInnerMostCurrentElement();
                                Element eCurrentElement = _gridGrouping.TableControl.Table.CurrentElement;
                                if (eCurrentElement != null)
                                {
                                    GridTable gt = eCurrentInnerElement.ParentTable as GridTable;
                                    GridNestedTable gnt = eCurrentElement as GridNestedTable;
                                    GridNestedTable gnt1 = gnt;
                                    GridTableDescriptor gtd = null;
                                    while (gnt1 != null && gnt1.ChildTable != null)
                                    {
                                        gnt = gnt1;
                                        gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                                        gtd = gnt.ParentTable.ParentTableDescriptor;
                                    }
                                    GridChildTable gt1 = gnt.ChildTable;
                                    object recObj = e.TableControl.Table.CurrentRecord.GetData();
                                    string keyValue = recObj.GetType().GetProperty(childKeyField).GetValue(recObj, null).ToString();
                                    foreach (Record r1 in gt1.Records)
                                    {
                                        if (r1.GetValue(chkDuplicateForChild) != null)
                                        {
                                            string s = r1.GetValue(chkDuplicateForChild).ToString();
                                            string key = r1.GetValue(childKeyField).ToString();
                                            if (keyValue != key)
                                            {
                                                object obj = e.TableControl.CurrentCell.Renderer.ControlText;
                                                if (s.Trim().ToUpper() == obj.ToString().Trim().ToUpper())
                                                {
                                                    //MessageBox.Show("Duplicate name - '"+s+"' exists. Can not continue !","PE-Advisor",MessageBoxButtons.OK,MessageBoxIcon.Error);
                                                    string[] str = new string[1];
                                                    str[0] = s;
                                                    LRRMessagBox.ShowMessage("SID_DUPLICATE_VALUE", "SID_LABEL", str, MessageBoxButtons.OK, MessageBoxIcon.Error);
                                                    e.Inner.Cancel = true;
                                                    break;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(DuplicateValidation),"TableControlCurrentCellValidating Event:"+ ex.Message  ,Logger.Level.Debug);			}
		}
	}
}
