using System;
using System.Collections;
using System.Drawing;
using System.Diagnostics;
using Syncfusion.ExcelRW;
using Syncfusion.Windows.Forms.Grid;
using System.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using System.Data;
using Symcon.Utils.MessageDispatcher; 

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.GridUtilities 
{
	/// <summary>
	/// Summary description for ExportToExcelUtility.
	/// </summary>
	public class ExportToExcelUtility 
	{
	bool isChildTable=false;
		public ExportToExcelUtility() 
		{	
		
		}

        /// <summary>
        /// Exports to excel.
        /// </summary>
        /// <param name="grid">The grid.</param>
        /// <param name="fileName">Name of the file.</param>
        /// <param name="isfileExists">if set to <c>true</c> [isfile exists].</param>
        /// <returns></returns>
		public bool ExportToExcel(GridGroupingControl grid, string fileName,bool isfileExists)
		{
			GridTableModel tableModel = null;
            bool retResult = false;
			if(grid.TableControl.Table.CurrentRecord == null)
			{
				isChildTable=true;

                if (!grid.TableControl.CurrentCell.IsActive)
                {
                    tableModel = grid.TableModel.Table.TableModel;
                }
                else
                {
                    Element eCurrentElement = grid.TableControl.Table.CurrentElement;
                    GridNestedTable gnt = eCurrentElement as GridNestedTable;

                    GridNestedTable gnt1 = gnt;
                    GridTableDescriptor gtd = null;
                    while (gnt1 != null && gnt1.ChildTable != null)
                    {
                        gnt = gnt1;
                        gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                        gtd = gnt.ParentTable.ParentTableDescriptor;
                    }
                    GridChildTable childTable = gnt.ChildTable as GridChildTable;
                    tableModel = childTable.ParentTable.TableModel;
                }

			}
			else
			{
				isChildTable=false;
				tableModel = grid.TableModel;
			}

            retResult = writeToExcel(tableModel, fileName, isfileExists);
            return retResult;
	 	 }

         /// <summary>
         /// Writes to excel.
         /// </summary>
         /// <param name="tableModel">The table model.</param>
         /// <param name="fileName">Name of the file.</param>
         /// <param name="isFileExists">if set to <c>true</c> [is file exists].</param>
         /// <returns></returns>
        public bool writeToExcel(GridTableModel tableModel, string fileName, bool isFileExists)
        {
            ExcelEngine excelEngine = new ExcelEngine();
            bool isUpend = false;
            IWorkbook myWorkBook = null;
            IApplication application = excelEngine.Excel;
            try
            {
                if (isFileExists)
                {
                    myWorkBook = excelEngine.Excel.Workbooks.Add(fileName);
                    IWorksheet sheet = null;
                    foreach (IWorksheet writeSheet in myWorkBook.Worksheets)
                    {
                        if (writeSheet.Rows.Length <= 1)
                        {
                            sheet = writeSheet;
                            break;
                        }
                        else
                        {
                            DialogResult result = LRRMessagBox.ShowMessage("SID_UPEND_WORKSHEET", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                            if (result == DialogResult.Yes)
                            {
                                sheet = writeSheet;
                                isUpend = true;
                                break;
                            }
                        }
                    }
                    if (isUpend)
                    {

                        #region While isUpend true

                        # region Looping through the Grid cells

                        int colIndent = tableModel.Table.TableDescriptor.GetColumnIndentCount();
                        int existingRow = sheet.Rows.Length;
					    int nRowCount=0;
					    int nCol=tableModel.Table.TableDescriptor.Columns.Count;
                        for (int i = existingRow; i <= existingRow + tableModel.RowCount + 1; i++)
                        {
                            # region Setting Row Heights
                            sheet.Range[i + 1, 1].RowHeight = (tableModel.RowHeights[i-existingRow] / 1.33);
                            #endregion
							int nColCount=0;
                            for (int j = colIndent; j <= tableModel.ColCount; j++)
                            {
                                # region Setting Text
                                string text = tableModel[i - existingRow, j].FormattedText.Replace("\n", " ");
                                if (isChildTable)
                                {
                                    sheet.Range[i + 1, j - colIndent + 1].Value2 = text;
                                }
                                else
                                {
                                    if (text != "" && !tableModel.Table.Engine.NestedTableGroupOptions.IsEmpty)
                                    {
                                        sheet.Range[nRowCount + 1, j - colIndent + 1].Value2 = text;
                                        if (nColCount == tableModel.ColCount - colIndent - 1)
                                            nRowCount = nRowCount + 1;

                                        // sheet.Range[i+1,j-colIndent+1].NumberFormat = tableModel[i, j].Format;
                                    }
                                    else if (tableModel.Table.Engine.NestedTableGroupOptions.IsEmpty)
                                    {
                                        if (text != "")
                                        {
                                            sheet.Range[nRowCount + 1, j - colIndent + 1].Value2 = text;
                                        }
                                        if (nColCount == tableModel.ColCount - colIndent - 1)
                                            nRowCount = nRowCount + 1;
                                    }
                                    nColCount = nColCount + 1;
                                }
                                #endregion
                            }
                        }
                        # endregion

                        #endregion
                    }
                    else
                    {
                        #region While isUpend false

                        # region Looping through the Grid cells

                        int colIndent = tableModel.Table.TableDescriptor.GetColumnIndentCount();
					   int nRowCount=0;
					   int nCol=tableModel.Table.TableDescriptor.Columns.Count;
                        for (int i = 0; i <= tableModel.RowCount + 1; i++)
                        {
                            # region Setting Row Heights
                            sheet.Range[i + 1, 1].RowHeight = (tableModel.RowHeights[i] / 1.33);
                            #endregion
									int nColCount=0;
                            for (int j = colIndent; j <= tableModel.ColCount; j++)
                            {
                                # region Setting Text
                                string text = tableModel[i, j].FormattedText.Replace("\n", " ");
                                if (isChildTable)
                                {
                                    sheet.Range[i + 1, j - colIndent + 1].Value2 = text;
                                }
                                else
                                {
                                    if (text != ""&& !tableModel.Table.Engine.NestedTableGroupOptions.IsEmpty)
                                    {
                                        sheet.Range[nRowCount + 1, j - colIndent + 1].Value2 = text;
                                        if (nColCount == tableModel.ColCount - colIndent - 1)
                                            nRowCount = nRowCount + 1;

                                        // sheet.Range[i+1,j-colIndent+1].NumberFormat = tableModel[i, j].Format;
                                    }
                                    else if(tableModel.Table.Engine.NestedTableGroupOptions.IsEmpty)
                                    {
                                        if (text != "")
                                        {
                                            sheet.Range[nRowCount + 1, j - colIndent + 1].Value2 = text;
                                        }
                                        if (nColCount == tableModel.ColCount - colIndent - 1)
                                            nRowCount = nRowCount + 1;
                                    }
                                    nColCount = nColCount + 1;
                                }										  
                                
                                #endregion
                            }
                        }
                        # endregion

                        #endregion
                    }
                }
                else
                {
                    myWorkBook = excelEngine.Excel.Workbooks.Add();
                    IWorksheet sheet = myWorkBook.Worksheets[0];
                    # region Looping through the Grid cells
                    int colIndent = tableModel.Table.TableDescriptor.GetColumnIndentCount();
	                int nCol=tableModel.Table.TableDescriptor.Columns.Count;
                	
	                // int nCol= tableModel.ColCount;
	                int nRowCount=0;
                    for (int i = 0; i <= tableModel.RowCount + 1; i++)
                    { 
							   
								# region Setting Row Heights
                        sheet.Range[i + 1, 1].RowHeight = (tableModel.RowHeights[i] / 1.33);
                        #endregion
						int nColCount=0;
                        for (int j = colIndent; j <= tableModel.ColCount; j++)
                        {
                            # region Setting Text
                            string text = tableModel[i, j].FormattedText.Replace("\n", " ");
                            if (isChildTable)
                            {
                                sheet.Range[i + 1, j - colIndent + 1].Value2 = text;
                            }
                            else
                            {
                                if (text != "" && !tableModel.Table.Engine.NestedTableGroupOptions.IsEmpty)
                                {
                                    sheet.Range[nRowCount + 1, j - colIndent + 1].Value2 = text;
                                    if (nColCount == tableModel.ColCount - colIndent - 1)
                                        nRowCount = nRowCount + 1;
                                    //					sheet.Range[i+1,j-colIndent+1].NumberFormat = tableModel[i, j].Format;
                                }
                                else if (tableModel.Table.Engine.NestedTableGroupOptions.IsEmpty)
                                {
                                    if (text != "")
                                    {
                                        sheet.Range[nRowCount + 1, j - colIndent + 1].Value2 = text;
                                    }
                                    if (nColCount == tableModel.ColCount - colIndent - 1)
                                        nRowCount = nRowCount + 1;
                                }
                                nColCount = nColCount + 1;
                            }
									
								   
                            #endregion
                        }
							  
							   
                    }
                    # endregion
                }

                #region Saving Workbook
                try
                {
                    myWorkBook.SaveAs(fileName);
                    excelEngine.ThrowNotSavedOnDestroy = false;
                    excelEngine.Dispose();
                    return true;
                }
                catch (System.Runtime.InteropServices.ExternalException ex)
                {
                    if (ex.ErrorCode == -2147287007)
                    {
                        LRRMessagBox.ShowMessage("SID_EXCEL_FILE_OPEN", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        excelEngine.ThrowNotSavedOnDestroy = false;
                        excelEngine.Dispose();
                    }
                    return false;
                }
            }
            catch (System.Runtime.InteropServices.ExternalException ex)
            {
                if (ex.ErrorCode == -2147287008)
                {
                    LRRMessagBox.ShowMessage("SID_EXCEL_FILE_OPEN", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    excelEngine.ThrowNotSavedOnDestroy = false;
                    excelEngine.Dispose();
                }
                return false;
            }
            # endregion

        }
        /// <summary>
        /// Writes to excel.
        /// </summary>
        /// <param name="gridInstance">The grid instance.</param>
        /// <param name="fileName">Name of the file.</param>
        /// <param name="isFileExists">if set to <c>true</c> [is file exists].</param>
        /// <returns></returns>
		public bool writeToExcel(GridControl gridInstance,string fileName,bool isFileExists)
		{
			ExcelEngine excelEngine = new ExcelEngine();
			IApplication application = excelEngine.Excel;
            bool isUpend = false;
            IWorkbook myWorkBook = null;
            try
            {
                if (isFileExists)
                {
                    myWorkBook = excelEngine.Excel.Workbooks.Add(fileName);
                    IWorksheet sheet = null;
                    foreach (IWorksheet writeSheet in myWorkBook.Worksheets)
                    {
                        if (writeSheet.Rows.Length <= 1)
                        {
                            sheet = writeSheet;
                            break;
                        }
                        else
                        {
                            DialogResult result = LRRMessagBox.ShowMessage("SID_UPEND_WORKSHEET", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                            if (result == DialogResult.Yes)
                            {
                                sheet = writeSheet;
                                isUpend = true;
                                break;
                            }
                        }
                    }
                    if (isUpend)
                    {

                        #region While isUpend true

                        # region Looping through the Grid cells

                        int existingRowCount = sheet.Rows.Length;


                        for (int i = existingRowCount; i <= gridInstance.RowCount + existingRowCount; i++)
                        {
                            # region Setting Row Heights
                            sheet.Range[i + 1, 1].RowHeight = (gridInstance.RowHeights[i - existingRowCount] / 1.33);
                            #endregion

                            for (int j = 1; j <= gridInstance.ColCount; j++)
                            {
                                # region Setting Text
                                string text = gridInstance[i - existingRowCount, j].FormattedText.Replace("\n", " ");
                                if (text != "")
                                {
                                    sheet.Range[i, j].Value2 = text;
                                }
                                #endregion
                            }
                        }
                        # endregion

                        #endregion
                    }
                    else
                    {
                        # region Looping through the Grid cells


                        for (int i = 1; i <= gridInstance.RowCount; i++)
                        {
                            # region Setting Row Heights
                            sheet.Range[i + 1, 1].RowHeight = (gridInstance.RowHeights[i] / 1.33);
                            #endregion

                            for (int j = 1; j <= gridInstance.ColCount; j++)
                            {
                                # region Setting Text
                                string text = gridInstance[i, j].FormattedText.Replace("\n", " ");
                                if (text != "")
                                {
                                    sheet.Range[i, j].Value2 = text;
                                }
                                #endregion
                            }
                        }
                        # endregion
                    }

                }
                else
                {
                    myWorkBook = excelEngine.Excel.Workbooks.Add();
                    IWorksheet sheet = myWorkBook.Worksheets[0];

                    # region Looping through the Grid cells

                    for (int i = 1; i <= gridInstance.RowCount; i++)
                    {

                        # region Setting Row Heights
                        sheet.Range[i + 1, 1].RowHeight = (gridInstance.RowHeights[i] / 1.33);
                        #endregion

                        for (int j = 1; j <= gridInstance.ColCount; j++)
                        {
                            # region Setting Text

                            string text = gridInstance[i, j].FormattedText.Replace("\n", " ");
                            if (text != "" || text != " ")
                            {
                                text = gridInstance[i, j].FormattedText.Replace("\n", " ");
                                sheet.Range[i, j].Value2 = text;

                            }
                            sheet.Range[i, j].Value2 = text;
                            #endregion
                        }
                    }
                    # endregion
                }
            }
            catch (System.Runtime.InteropServices.ExternalException ex)
            {
                if (ex.ErrorCode == -2147287008)
                {
                    LRRMessagBox.ShowMessage("SID_EXCEL_FILE_OPEN", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    excelEngine.ThrowNotSavedOnDestroy = false;
                    excelEngine.Dispose();
                }
                return false;
            }
	
            #region Saving Workbook
            try
            {
                myWorkBook.SaveAs(fileName);
                excelEngine.ThrowNotSavedOnDestroy = false;
                excelEngine.Dispose();
                return true;
            }
            catch (System.Runtime.InteropServices.ExternalException ex)
            {
                if (ex.ErrorCode == -2147287007)
                {
                    LRRMessagBox.ShowMessage("SID_EXCEL_FILE_OPEN", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    excelEngine.ThrowNotSavedOnDestroy = false;
                    excelEngine.Dispose();
                }
                return false;
            }
			# endregion	

		}
	}
}



