using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

using Symcon.Database; 
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageLogger;

using Symcon.LightRidge.PEAdvisor.IOScreen;

namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
	/// <summary>
	/// Summary description for GroupedPlantDataArrayView.
	/// </summary>
	public class GroupedPlantDataArrayView : System.Windows.Forms.Form,ILRRUIContainer,ILRRUISpecificContainer
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel pnlGroupedPropMain;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemCopy;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPaste;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemClear;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDelete;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemArrangeCols;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPrint;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemExport;
		private System.Windows.Forms.Splitter splitter1;
		private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager1;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.ImageList imageList3;
		private TabControl			_parentTabControl;
		private System.Windows.Forms.ImageList imageList2;
		private System.Windows.Forms.Panel pnlSeachMain;
		private System.Windows.Forms.Panel pnlQuery;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.Panel pnlSearchCriteria;
		private System.Windows.Forms.Panel pnlGroupedProperties;
		private System.Windows.Forms.Panel pnlPlantItems;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridPlantItems;
		private System.Windows.Forms.Splitter splitter7;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupedProperties;
		private System.Windows.Forms.Button btnExecute;
		private System.Windows.Forms.Label lblQuery;
		private System.Windows.Forms.ComboBox cmbQueryList;
		private System.Windows.Forms.Splitter splitter5;
		private System.Windows.Forms.Panel pnlGrpPropQualifierModes;
		private System.Windows.Forms.Panel pnlGroupedProp;
		private TabPage				_parentTabPage;
		Hashtable lrrFormulaGroupedProperties = new Hashtable();
		public System.Windows.Forms.Panel pnlGridContainer;
		private System.Windows.Forms.Splitter splitter6;
		private System.Windows.Forms.Panel pnlGroupedPropertiesOutput;
		private System.Windows.Forms.Panel pnlUserDefinedArrays;
		private System.Windows.Forms.Splitter splitter4;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUserDefinedArrays;
        private Panel pnlRun;
        private Button btnTranspose;
        private System.Windows.Forms.Button btnSaveView;
        private bool transposeFlag = false;
        private ImageList imageList1;
		private LRRLookUpProperties _objLookUpProperties = new LRRLookUpProperties();
        public bool IsChanged = false;
        public static bool BPropertyValChanged = false;

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupedPlantDataArrayView"/> class.
        /// </summary>
		public GroupedPlantDataArrayView()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrApp.LRRUIManagerObj.PerformDataDirtyCheck = false;

			InitDataSource();
			BindGridGroupedProperties();
			BindGridPlantItems();
			BindGridUserDefinedArrays();
			
			LRRMasterComponents masterComponents = LRRModel.Model;
			lrrFormulaGroupedProperties.Clear();
			lrrFormulaGroupedProperties.Add(0,masterComponents);
			lrrFormulaGroupedProperties.Add(1,"MasterComponents");
			lrrFormulaGroupedProperties.Add(2,"SiteComponentsObj");
			lrrFormulaGroupedProperties.Add(3,"Properties");
			lrrFormulaGroupedProperties.Add(4,"GroupPpties");
			lrrFormulaGroupedProperties.Add(5,"GroupPptiesQualifierValues");
			lrrFormulaGroupedProperties.Add(6,_objLookupQualifiers);

	
			LRRFormulaDataStore.DataSource = lrrFormulaGroupedProperties;
			LRRFormulaDataStore.ModeFlag = true;
			this.Closing+=new CancelEventHandler(GroupedPlantPropertiesView_Closing);

			LRRModel.ProjectModes.ModesChanged+=new EventHandler(ProjectModes_ModesChanged);
            

		}
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupedPlantDataArrayView"/> class.
        /// </summary>
        /// <param name="b">if set to <c>true</c> [b].</param>
		public GroupedPlantDataArrayView(bool b)
		{
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			LRRMasterComponents masterComponents = LRRModel.Model;
			
			lrrFormulaGroupedProperties.Clear();
			lrrFormulaGroupedProperties.Add(0,masterComponents);
			lrrFormulaGroupedProperties.Add(1,"MasterComponents");
			lrrFormulaGroupedProperties.Add(2,"SiteComponentsObj");
			lrrFormulaGroupedProperties.Add(3,"Properties");
			lrrFormulaGroupedProperties.Add(4,"GroupPpties");
			lrrFormulaGroupedProperties.Add(5,"GroupPptiesQualifierValues");
			lrrFormulaGroupedProperties.Add(6,_objLookupQualifiers);

			LRRFormulaDataStore.DataSource = lrrFormulaGroupedProperties;
			LRRFormulaDataStore.ModeFlag = true;
			
			this.Closing+=new CancelEventHandler(GroupedPlantPropertiesView_Closing);
			LRRModel.ProjectModes.ModesChanged+=new EventHandler(ProjectModes_ModesChanged);

		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(GroupedPlantDataArrayView));
            this.pnlGroupedPropMain = new System.Windows.Forms.Panel();
            this.pnlSeachMain = new System.Windows.Forms.Panel();
            this.pnlSearchCriteria = new System.Windows.Forms.Panel();
            this.pnlGroupedProperties = new System.Windows.Forms.Panel();
            this.pnlGrpPropQualifierModes = new System.Windows.Forms.Panel();
            this.pnlUserDefinedArrays = new System.Windows.Forms.Panel();
            this.gridUserDefinedArrays = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlGroupedProp = new System.Windows.Forms.Panel();
            this.splitter4 = new System.Windows.Forms.Splitter();
            this.gridGroupedProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter5 = new System.Windows.Forms.Splitter();
            this.pnlPlantItems = new System.Windows.Forms.Panel();
            this.gridPlantItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter7 = new System.Windows.Forms.Splitter();
            this.splitter3 = new System.Windows.Forms.Splitter();
            this.pnlQuery = new System.Windows.Forms.Panel();
            this.cmbQueryList = new System.Windows.Forms.ComboBox();
            this.lblQuery = new System.Windows.Forms.Label();
            this.btnExecute = new System.Windows.Forms.Button();
            this.imageList3 = new System.Windows.Forms.ImageList(this.components);
            this.btnTranspose = new System.Windows.Forms.Button();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.btnSaveView = new System.Windows.Forms.Button();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.barItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.imageList2 = new System.Windows.Forms.ImageList(this.components);
            this.barItemPrint = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemCopy = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemDelete = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemClear = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemArrangeCols = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemExport = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
            this.pnlGridContainer = new System.Windows.Forms.Panel();
            this.pnlRun = new System.Windows.Forms.Panel();
            this.splitter6 = new System.Windows.Forms.Splitter();
            this.pnlGroupedPropertiesOutput = new System.Windows.Forms.Panel();
            this.pnlGroupedPropMain.SuspendLayout();
            this.pnlSeachMain.SuspendLayout();
            this.pnlSearchCriteria.SuspendLayout();
            this.pnlGroupedProperties.SuspendLayout();
            this.pnlGrpPropQualifierModes.SuspendLayout();
            this.pnlUserDefinedArrays.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridUserDefinedArrays)).BeginInit();
            this.pnlGroupedProp.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupedProperties)).BeginInit();
            this.pnlPlantItems.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems)).BeginInit();
            this.pnlQuery.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
            this.pnlGridContainer.SuspendLayout();
            this.pnlGroupedPropertiesOutput.SuspendLayout();
            this.SuspendLayout();
            // 
            // pnlGroupedPropMain
            // 
            this.pnlGroupedPropMain.AutoScroll = true;
            this.pnlGroupedPropMain.Controls.Add(this.pnlSeachMain);
            this.pnlGroupedPropMain.Controls.Add(this.splitter2);
            this.dockingManager1.SetEnableDocking(this.pnlGroupedPropMain, true);
            this.pnlGroupedPropMain.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.pnlGroupedPropMain.Location = new System.Drawing.Point(1, 21);
            this.pnlGroupedPropMain.Name = "pnlGroupedPropMain";
            this.pnlGroupedPropMain.Size = new System.Drawing.Size(659, 597);
            this.pnlGroupedPropMain.TabIndex = 0;
            // 
            // pnlSeachMain
            // 
            this.pnlSeachMain.Controls.Add(this.pnlSearchCriteria);
            this.pnlSeachMain.Controls.Add(this.splitter3);
            this.pnlSeachMain.Controls.Add(this.pnlQuery);
            this.pnlSeachMain.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlSeachMain.Location = new System.Drawing.Point(0, 2);
            this.pnlSeachMain.Name = "pnlSeachMain";
            this.pnlSeachMain.Size = new System.Drawing.Size(659, 595);
            this.pnlSeachMain.TabIndex = 2;
            // 
            // pnlSearchCriteria
            // 
            this.pnlSearchCriteria.Controls.Add(this.pnlGroupedProperties);
            this.pnlSearchCriteria.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlSearchCriteria.Location = new System.Drawing.Point(0, 74);
            this.pnlSearchCriteria.Name = "pnlSearchCriteria";
            this.pnlSearchCriteria.Size = new System.Drawing.Size(659, 521);
            this.pnlSearchCriteria.TabIndex = 2;
            // 
            // pnlGroupedProperties
            // 
            this.pnlGroupedProperties.Controls.Add(this.pnlGrpPropQualifierModes);
            this.pnlGroupedProperties.Controls.Add(this.splitter5);
            this.pnlGroupedProperties.Controls.Add(this.pnlPlantItems);
            this.pnlGroupedProperties.Controls.Add(this.splitter7);
            this.pnlGroupedProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGroupedProperties.Location = new System.Drawing.Point(0, 0);
            this.pnlGroupedProperties.Name = "pnlGroupedProperties";
            this.pnlGroupedProperties.Size = new System.Drawing.Size(659, 521);
            this.pnlGroupedProperties.TabIndex = 8;
            // 
            // pnlGrpPropQualifierModes
            // 
            this.pnlGrpPropQualifierModes.Controls.Add(this.pnlUserDefinedArrays);
            this.pnlGrpPropQualifierModes.Controls.Add(this.pnlGroupedProp);
            this.pnlGrpPropQualifierModes.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGrpPropQualifierModes.Location = new System.Drawing.Point(2, 0);
            this.pnlGrpPropQualifierModes.Name = "pnlGrpPropQualifierModes";
            this.pnlGrpPropQualifierModes.Size = new System.Drawing.Size(286, 521);
            this.pnlGrpPropQualifierModes.TabIndex = 4;
            // 
            // pnlUserDefinedArrays
            // 
            this.pnlUserDefinedArrays.Controls.Add(this.gridUserDefinedArrays);
            this.pnlUserDefinedArrays.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlUserDefinedArrays.Location = new System.Drawing.Point(0, 264);
            this.pnlUserDefinedArrays.Name = "pnlUserDefinedArrays";
            this.pnlUserDefinedArrays.Size = new System.Drawing.Size(286, 257);
            this.pnlUserDefinedArrays.TabIndex = 1;
            // 
            // gridUserDefinedArrays
            // 
            this.gridUserDefinedArrays.BackColor = System.Drawing.SystemColors.Window;
            this.gridUserDefinedArrays.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridUserDefinedArrays.Location = new System.Drawing.Point(0, 0);
            this.gridUserDefinedArrays.Name = "gridUserDefinedArrays";
            this.gridUserDefinedArrays.Size = new System.Drawing.Size(286, 257);
            this.gridUserDefinedArrays.TabIndex = 0;
            this.gridUserDefinedArrays.Text = "gridGroupingControl1";
            this.gridUserDefinedArrays.VersionInfo = "3.301.0.0";
            this.gridUserDefinedArrays.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridUserDefinedArrays_RecordValueChanged);
            // 
            // pnlGroupedProp
            // 
            this.pnlGroupedProp.Controls.Add(this.splitter4);
            this.pnlGroupedProp.Controls.Add(this.gridGroupedProperties);
            this.pnlGroupedProp.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlGroupedProp.Location = new System.Drawing.Point(0, 0);
            this.pnlGroupedProp.Name = "pnlGroupedProp";
            this.pnlGroupedProp.Size = new System.Drawing.Size(286, 264);
            this.pnlGroupedProp.TabIndex = 0;
            // 
            // splitter4
            // 
            this.splitter4.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter4.Location = new System.Drawing.Point(0, 262);
            this.splitter4.Name = "splitter4";
            this.splitter4.Size = new System.Drawing.Size(286, 2);
            this.splitter4.TabIndex = 1;
            this.splitter4.TabStop = false;
            // 
            // gridGroupedProperties
            // 
            this.gridGroupedProperties.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupedProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridGroupedProperties.Location = new System.Drawing.Point(0, 0);
            this.gridGroupedProperties.Name = "gridGroupedProperties";
            this.gridGroupedProperties.Size = new System.Drawing.Size(286, 264);
            this.gridGroupedProperties.TabIndex = 0;
            this.gridGroupedProperties.Text = "gridGroupingControl3";
            this.gridGroupedProperties.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridGroupedProperties.VersionInfo = "3.301.0.0";
            this.gridGroupedProperties.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridGroupedProperties_RecordValueChanged);
            // 
            // splitter5
            // 
            this.splitter5.Dock = System.Windows.Forms.DockStyle.Right;
            this.splitter5.Location = new System.Drawing.Point(288, 0);
            this.splitter5.Name = "splitter5";
            this.splitter5.Size = new System.Drawing.Size(2, 521);
            this.splitter5.TabIndex = 3;
            this.splitter5.TabStop = false;
            // 
            // pnlPlantItems
            // 
            this.pnlPlantItems.Controls.Add(this.gridPlantItems);
            this.pnlPlantItems.Dock = System.Windows.Forms.DockStyle.Right;
            this.pnlPlantItems.Location = new System.Drawing.Point(290, 0);
            this.pnlPlantItems.Name = "pnlPlantItems";
            this.pnlPlantItems.Size = new System.Drawing.Size(369, 521);
            this.pnlPlantItems.TabIndex = 2;
            // 
            // gridPlantItems
            // 
            this.gridPlantItems.BackColor = System.Drawing.SystemColors.Window;
            this.gridPlantItems.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridPlantItems.Location = new System.Drawing.Point(0, 0);
            this.gridPlantItems.Name = "gridPlantItems";
            this.gridPlantItems.Size = new System.Drawing.Size(369, 521);
            this.gridPlantItems.TabIndex = 0;
            this.gridPlantItems.Text = "gridGroupingControl2";
            this.gridPlantItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridPlantItems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridPlantItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridPlantItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridPlantItems.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridPlantItems.VersionInfo = "3.301.0.0";
            // 
            // splitter7
            // 
            this.splitter7.Location = new System.Drawing.Point(0, 0);
            this.splitter7.Name = "splitter7";
            this.splitter7.Size = new System.Drawing.Size(2, 521);
            this.splitter7.TabIndex = 1;
            this.splitter7.TabStop = false;
            // 
            // splitter3
            // 
            this.splitter3.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter3.Location = new System.Drawing.Point(0, 72);
            this.splitter3.Name = "splitter3";
            this.splitter3.Size = new System.Drawing.Size(659, 2);
            this.splitter3.TabIndex = 1;
            this.splitter3.TabStop = false;
            // 
            // pnlQuery
            // 
            this.pnlQuery.Controls.Add(this.cmbQueryList);
            this.pnlQuery.Controls.Add(this.lblQuery);
            this.pnlQuery.Controls.Add(this.btnExecute);
            this.pnlQuery.Controls.Add(this.btnTranspose);
            this.pnlQuery.Controls.Add(this.btnSaveView);
            this.pnlQuery.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlQuery.Location = new System.Drawing.Point(0, 0);
            this.pnlQuery.Name = "pnlQuery";
            this.pnlQuery.Size = new System.Drawing.Size(659, 72);
            this.pnlQuery.TabIndex = 0;
            // 
            // cmbQueryList
            // 
            this.cmbQueryList.Location = new System.Drawing.Point(88, 24);
            this.cmbQueryList.Name = "cmbQueryList";
            this.cmbQueryList.Size = new System.Drawing.Size(192, 21);
            this.cmbQueryList.TabIndex = 13;
            this.cmbQueryList.Tag = "SID_QUERY_LIST";
            this.cmbQueryList.SelectedIndexChanged += new System.EventHandler(this.cmbQueryList_SelectedIndexChanged);
            this.cmbQueryList.DropDown += new System.EventHandler(this.cmbQueryList_DropDown);
            // 
            // lblQuery
            // 
            this.lblQuery.Location = new System.Drawing.Point(8, 24);
            this.lblQuery.Name = "lblQuery";
            this.lblQuery.Size = new System.Drawing.Size(72, 24);
            this.lblQuery.TabIndex = 12;
            this.lblQuery.Tag = "SID_QUERY";
            // 
            // btnExecute
            // 
            this.btnExecute.ImageAlign = System.Drawing.ContentAlignment.TopRight;
            this.btnExecute.ImageIndex = 8;
            this.btnExecute.ImageList = this.imageList3;
            this.btnExecute.Location = new System.Drawing.Point(576, 23);
            this.btnExecute.Name = "btnExecute";
            this.btnExecute.Size = new System.Drawing.Size(72, 24);
            this.btnExecute.TabIndex = 7;
            this.btnExecute.Tag = "SID_EXECUTE";
            this.btnExecute.TextAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnExecute.Click += new System.EventHandler(this.btnExecute_Click);
            // 
            // imageList3
            // 
            this.imageList3.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList3.ImageStream")));
            this.imageList3.TransparentColor = System.Drawing.SystemColors.Desktop;
            this.imageList3.Images.SetKeyName(0, "");
            this.imageList3.Images.SetKeyName(1, "");
            this.imageList3.Images.SetKeyName(2, "");
            this.imageList3.Images.SetKeyName(3, "");
            this.imageList3.Images.SetKeyName(4, "");
            this.imageList3.Images.SetKeyName(5, "");
            this.imageList3.Images.SetKeyName(6, "");
            this.imageList3.Images.SetKeyName(7, "");
            this.imageList3.Images.SetKeyName(8, "");
            // 
            // btnTranspose
            // 
            this.btnTranspose.BackColor = System.Drawing.SystemColors.Control;
            this.btnTranspose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnTranspose.ImageIndex = 11;
            this.btnTranspose.ImageList = this.imageList1;
            this.btnTranspose.Location = new System.Drawing.Point(415, 24);
            this.btnTranspose.Name = "btnTranspose";
            this.btnTranspose.Size = new System.Drawing.Size(80, 23);
            this.btnTranspose.TabIndex = 34;
            this.btnTranspose.Tag = "SID_TRANSPOSE";
            this.btnTranspose.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.btnTranspose.UseVisualStyleBackColor = false;
            this.btnTranspose.Click += new System.EventHandler(this.btnTranspose_Click);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            this.imageList1.Images.SetKeyName(5, "");
            this.imageList1.Images.SetKeyName(6, "");
            this.imageList1.Images.SetKeyName(7, "");
            this.imageList1.Images.SetKeyName(8, "");
            this.imageList1.Images.SetKeyName(9, "");
            this.imageList1.Images.SetKeyName(10, "");
            this.imageList1.Images.SetKeyName(11, "");
            this.imageList1.Images.SetKeyName(12, "");
            // 
            // btnSaveView
            // 
            this.btnSaveView.Location = new System.Drawing.Point(500, 24);
            this.btnSaveView.Name = "btnSaveView";
            this.btnSaveView.Size = new System.Drawing.Size(70, 23);
            this.btnSaveView.TabIndex = 34;
            this.btnSaveView.Tag = "SID_SAVE_VIEW";
            this.btnSaveView.Click += new System.EventHandler(this.btnSaveView_Click);
            // 
            // splitter2
            // 
            this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter2.Location = new System.Drawing.Point(0, 0);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(659, 2);
            this.splitter2.TabIndex = 1;
            this.splitter2.TabStop = false;
            // 
            // barItemSave
            // 
            this.barItemSave.CategoryIndex = -1;
            this.barItemSave.ID = "Save";
            this.barItemSave.ImageIndex = 0;
            this.barItemSave.ImageList = this.imageList2;
            this.barItemSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemSave.Tag = "SID_SAVE";
            this.barItemSave.Tooltip = "Click here to save";
            // 
            // imageList2
            // 
            this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
            this.imageList2.TransparentColor = System.Drawing.SystemColors.Desktop;
            this.imageList2.Images.SetKeyName(0, "");
            this.imageList2.Images.SetKeyName(1, "");
            this.imageList2.Images.SetKeyName(2, "");
            this.imageList2.Images.SetKeyName(3, "");
            this.imageList2.Images.SetKeyName(4, "");
            this.imageList2.Images.SetKeyName(5, "");
            this.imageList2.Images.SetKeyName(6, "");
            this.imageList2.Images.SetKeyName(7, "");
            this.imageList2.Images.SetKeyName(8, "");
            this.imageList2.Images.SetKeyName(9, "");
            this.imageList2.Images.SetKeyName(10, "");
            this.imageList2.Images.SetKeyName(11, "");
            this.imageList2.Images.SetKeyName(12, "");
            this.imageList2.Images.SetKeyName(13, "");
            // 
            // barItemPrint
            // 
            this.barItemPrint.CategoryIndex = -1;
            this.barItemPrint.ID = "Print";
            this.barItemPrint.ImageIndex = 1;
            this.barItemPrint.ImageList = this.imageList2;
            this.barItemPrint.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemPrint.Tag = "SID_PRINT";
            this.barItemPrint.Tooltip = "Click here to print.";
            // 
            // barItemCopy
            // 
            this.barItemCopy.CategoryIndex = -1;
            this.barItemCopy.ID = "Copy";
            this.barItemCopy.ImageIndex = 2;
            this.barItemCopy.ImageList = this.imageList2;
            this.barItemCopy.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
            this.barItemCopy.Tag = "SID_COPY";
            this.barItemCopy.Tooltip = "Click here to copy a row or the selection";
            // 
            // barItemPaste
            // 
            this.barItemPaste.CategoryIndex = -1;
            this.barItemPaste.ID = "Paste";
            this.barItemPaste.ImageIndex = 3;
            this.barItemPaste.ImageList = this.imageList2;
            this.barItemPaste.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
            this.barItemPaste.Tag = "SID_PASTE";
            this.barItemPaste.Tooltip = "Click here to paste a row or the selection";
            // 
            // barItemDelete
            // 
            this.barItemDelete.CategoryIndex = -1;
            this.barItemDelete.ID = "Delete";
            this.barItemDelete.ImageIndex = 4;
            this.barItemDelete.ImageList = this.imageList2;
            this.barItemDelete.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemDelete.Tag = "SID_DEL";
            this.barItemDelete.Tooltip = "Click here to delete the row.";
            // 
            // barItemClear
            // 
            this.barItemClear.CategoryIndex = -1;
            this.barItemClear.ID = "Clear Filter";
            this.barItemClear.ImageIndex = 5;
            this.barItemClear.ImageList = this.imageList2;
            this.barItemClear.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemClear.Tag = "SID_CLEAR_FILTER";
            this.barItemClear.Tooltip = "Click here to clear the filter criteria specified.";
            // 
            // barItemArrangeCols
            // 
            this.barItemArrangeCols.CategoryIndex = -1;
            this.barItemArrangeCols.ID = "Arrange columns";
            this.barItemArrangeCols.ImageIndex = 7;
            this.barItemArrangeCols.ImageList = this.imageList2;
            this.barItemArrangeCols.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemArrangeCols.Tag = "SID_ARRANGE_COL";
            this.barItemArrangeCols.Tooltip = "Click here to specify the columns";
            // 
            // barItemExport
            // 
            this.barItemExport.CategoryIndex = -1;
            this.barItemExport.ID = "Export";
            this.barItemExport.ImageIndex = 6;
            this.barItemExport.ImageList = this.imageList2;
            this.barItemExport.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemExport.Tag = "SID_EXPORT";
            this.barItemExport.Tooltip = "Click here to export the data";
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(1028, 2);
            this.splitter1.TabIndex = 2;
            this.splitter1.TabStop = false;
            // 
            // dockingManager1
            // 
            this.dockingManager1.AutoHideInterval = 200;
            this.dockingManager1.CloseEnabled = false;
            this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
            this.dockingManager1.HostControl = this;
            this.dockingManager1.ShowToolTips = true;
            this.dockingManager1.AutoHideAnimationStart += new Syncfusion.Windows.Forms.Tools.AutoHideAnimationEventHandler(this.dockingManager1_AutoHideAnimationStart);
            this.dockingManager1.SetDockLabel(this.pnlGroupedPropMain, "View Criteria");
            this.dockingManager1.SetAutoHideOnLoad(this.pnlGroupedPropMain, true);
            // 
            // pnlGridContainer
            // 
            this.pnlGridContainer.AutoScroll = true;
            this.pnlGridContainer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pnlGridContainer.Controls.Add(this.pnlRun);
            this.pnlGridContainer.Controls.Add(this.splitter6);
            this.pnlGridContainer.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGridContainer.Location = new System.Drawing.Point(0, 0);
            this.pnlGridContainer.Name = "pnlGridContainer";
            this.pnlGridContainer.Size = new System.Drawing.Size(1028, 619);
            this.pnlGridContainer.TabIndex = 9;
            // 
            // pnlRun
            // 
            this.pnlRun.AutoScroll = true;
            this.pnlRun.BackColor = System.Drawing.SystemColors.Control;
            this.pnlRun.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlRun.Location = new System.Drawing.Point(0, 0);
            this.pnlRun.Name = "pnlRun";
            this.pnlRun.Size = new System.Drawing.Size(1026, 54);
            this.pnlRun.TabIndex = 5;
            // 
            // splitter6
            // 
            this.splitter6.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter6.Location = new System.Drawing.Point(0, 614);
            this.splitter6.Name = "splitter6";
            this.splitter6.Size = new System.Drawing.Size(1026, 3);
            this.splitter6.TabIndex = 0;
            this.splitter6.TabStop = false;
            // 
            // pnlGroupedPropertiesOutput
            // 
            this.pnlGroupedPropertiesOutput.AutoScroll = true;
            this.pnlGroupedPropertiesOutput.Controls.Add(this.pnlGridContainer);
            this.pnlGroupedPropertiesOutput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGroupedPropertiesOutput.Location = new System.Drawing.Point(0, 2);
            this.pnlGroupedPropertiesOutput.Name = "pnlGroupedPropertiesOutput";
            this.pnlGroupedPropertiesOutput.Size = new System.Drawing.Size(1028, 619);
            this.pnlGroupedPropertiesOutput.TabIndex = 8;
            // 
            // GroupedPlantDataArrayView
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(1028, 621);
            this.Controls.Add(this.pnlGroupedPropertiesOutput);
            this.Controls.Add(this.splitter1);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "GroupedPlantDataArrayView";
            this.Tag = "SID_PIP_DATA_ARRAYS_VIEWS";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.GroupedPlantPropertiesView_Load);
            this.Closed += new System.EventHandler(this.GroupedPlantPropertiesView_Closed);
            this.Activated += new System.EventHandler(this.GroupedPlantPropertiesView_Activated);
            this.pnlGroupedPropMain.ResumeLayout(false);
            this.pnlSeachMain.ResumeLayout(false);
            this.pnlSearchCriteria.ResumeLayout(false);
            this.pnlGroupedProperties.ResumeLayout(false);
            this.pnlGrpPropQualifierModes.ResumeLayout(false);
            this.pnlUserDefinedArrays.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridUserDefinedArrays)).EndInit();
            this.pnlGroupedProp.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupedProperties)).EndInit();
            this.pnlPlantItems.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems)).EndInit();
            this.pnlQuery.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();
            this.pnlGridContainer.ResumeLayout(false);
            this.pnlGroupedPropertiesOutput.ResumeLayout(false);
            this.ResumeLayout(false);

		}

        void btnSaveView_Click(object sender, EventArgs e)
        {
            if (gridView == null)
            {
                MessageBox.Show("Please execute the query before saving!");
                return;
            }
            //SaveQueryForm saveQueryForm = new SaveQueryForm();
            string queryName = cmbQueryList.Text;
            if (cmbQueryList.SelectedValue != null && cmbQueryList.SelectedValue.ToString() == "0")
                queryName = "";
            SaveQueryForm saveQueryForm = new SaveQueryForm(queryName, "Query");
            //Incase output is rendered, check for saving the query along with the output
            if (this.pnlGridContainer.Controls.Count > 1)
            {

                DialogResult resultQueryForm = saveQueryForm.ShowDialog();
                if (resultQueryForm == DialogResult.OK)
                {
                    SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
                }
                return;
            }
            //Incase output is not rendered, save only the query
            DialogResult result = saveQueryForm.ShowDialog();

            if (result == DialogResult.OK)
            {
                SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
            }
            IsChanged = false;
        }
		#endregion

		#region ILRRUIContainer Members
		public new void Refresh()
		{
			//Method to Refresh the User Interface form..
			//			LRRUIManager lrrUI=new LRRUIManager();
			//			
			//			lrrUI.SaveGridSettings(gridPlantItems,this);
			//			lrrUI.SaveGridSettings(gridGroupingModes,this);
			//			lrrUI.SaveGridSettings(gridPlantItems2,this);
			//			lrrUI.SaveGridSettings(gridQualifiers,this);
			//
			//			lrrUI.ApplyGridSettings(gridPlantItems,this);
			//			lrrUI.ApplyGridSettings(gridGroupingModes,this);
			//			lrrUI.ApplyGridSettings(gridPlantItems2,this);
			//			lrrUI.ApplyGridSettings(gridQualifiers,this);

		}
		public void Save() //Method to save the contents of the form...
		{
            LRRSiteGroupPropertyQualifierValues propertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();

            if (propertyQualifierValues.Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(propertyQualifierValues); //Commit Site Components

                if (propertyQualifierValues.HasError)
                {
                    LRRMessagBox.ShowMessage("SID_PLANTEFFICTIVETIME_BLANK_ERROR", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                foreach (LRRSiteGroupPropertyQualifierValue siteGrpPropQualifierVal in propertyQualifierValues)
                {
                    if (siteGrpPropQualifierVal.Direction == "1" && siteGrpPropQualifierVal.Derivation == "4")
                    {
                        MessagingClient.GroupedPropertyValueChanged(siteGrpPropQualifierVal.LookUpQualifierID, siteGrpPropQualifierVal.GroupPropertyID, siteGrpPropQualifierVal.ModeID, siteGrpPropQualifierVal.PropertyValue);
                    }
                }
                _lrrApp.SetGroupPropertyValueBinding(propertyQualifierValues);
                LRRMessagBox.ShowMessage("SID_UPDATED_QUALIFIER", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);

                LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                LRRMessagBox.ShowMessage("SID_SAVEDINFO", true);
            }
            else
                LRRMessagBox.ShowMessage("SID_NODATASAVED", true);
            BPropertyValChanged = false;

            /*if (gridView == null)
            {
                MessageBox.Show("Please execute the query before saving!");
                return;
            }
//			SaveQueryForm saveQueryForm = new SaveQueryForm();
			string queryName = cmbQueryList.Text;
			if(cmbQueryList.SelectedValue != null && cmbQueryList.SelectedValue.ToString() == "0")
				queryName = "";
			SaveQueryForm saveQueryForm = new SaveQueryForm(queryName,"Query");
//			PrepareQuery();
			//Incase output is rendered, check for saving the query along with the output
			if(this.pnlGridContainer.Controls.Count > 1)
			{

				DialogResult resultQueryForm = saveQueryForm.ShowDialog();
				if(resultQueryForm == DialogResult.OK)
				{
					SaveQuery(saveQueryForm.queryName,saveQueryForm.queryDesc,saveQueryForm.SelectedLevel,saveQueryForm.IsPublished);
				}
				return;
			}
           // SaveOutput();
			//Incase output is not rendered, save only the query
			DialogResult result = saveQueryForm.ShowDialog();

            if (result == DialogResult.OK)
            {
                SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
            }
            IsChanged = false;*/
            
		}

        public void SaveOutput()
        {
            /* LRRSiteGroupPropertyQualifierValues propertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();			
    			
                 if(propertyQualifierValues.Count > 0)
                 {
                     _lrrApp.DBManagerObj.CommitCollection(propertyQualifierValues); //Commit Site Components
    				
                     if(propertyQualifierValues.HasError)
                     {
                         LRRMessagBox.ShowMessage("SID_PLANTEFFICTIVETIME_BLANK_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
                         return;
                     }

                     foreach(LRRSiteGroupPropertyQualifierValue siteGrpPropQualifierVal in  propertyQualifierValues)
                     {
                         if(siteGrpPropQualifierVal.Direction == "1" && siteGrpPropQualifierVal.Derivation == "4")
                         {
                             MessagingClient.GroupedPropertyValueChanged(siteGrpPropQualifierVal.LookUpQualifierID,siteGrpPropQualifierVal.GroupPropertyID,siteGrpPropQualifierVal.ModeID,siteGrpPropQualifierVal.PropertyValue);
                         }
                     }
                     _lrrApp.SetGroupPropertyValueBinding(propertyQualifierValues);
                     LRRMessagBox.ShowMessage("SID_UPDATED_QUALIFIER","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);

                     LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                 }*/

        }

        public void SaveQuery()
		{
            if (gridView == null)
            {
                MessageBox.Show("Please execute the query before saving!");
                return;
            }

            string queryName = cmbQueryList.Text;
            if (cmbQueryList.SelectedValue != null && cmbQueryList.SelectedValue.ToString() == "0")
                queryName = "";
            SaveQueryForm saveQueryForm = new SaveQueryForm(queryName, "Query");

            //Incase output is rendered, check for saving the query along with the output
            if (this.pnlGridContainer.Controls.Count > 1)
            {

                DialogResult resultQueryForm = saveQueryForm.ShowDialog();
                if (resultQueryForm == DialogResult.OK)
                {
                    SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
                }
                return;
            }

            //Incase output is not rendered, save only the query
            DialogResult result = saveQueryForm.ShowDialog();

            if (result == DialogResult.OK)
            {
                SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
            }
            IsChanged = false;
		}

		public void CopyMasterProperties()
		{
		}
		public void Paste()
		{
		}
		public void Copy()
		{
		}
		public void Print()
		{
			if(gridView != null)
				gridView.Print();
		}
		public void Delete()
		{
		}
		public void ArrangeColumns()
		{
		}
		public void ClearFilter()
		{
		}
		public void InsertNewRows()//Inserts New rows 
		{
		}
		public void ImportToExcel()
		{
		}
		public void Export()
		{
			if(gridView != null && gridView.Export() != null)
			{
				ExportToExcel excelExpForm = new ExportToExcel(gridView.Export());
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}
		public void SelectionPaste()
		{
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		//Methods Suported
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsCopy()
		{
			return false;
		}
		public bool SupportsPaste()
		{
			return false;
		}
		public bool SupportsExport()
		{
			return true;
		}
		public bool SupportsSave()
		{
			return true;
		}
		public bool SupportsRefresh()
		{
			return false;
		}
		public bool SupportsDelete()
		{
			return false;
		}
		public bool SupportsPrint()
		{
			return true;
		}
		public bool SupportsArrangeColumns()
		{
			return false;
		}
		public bool SupportsClearFilter()
		{
			return true;
		}
		public bool SupportsInsertNewRows()
		{
			return false;
		}
		public bool SupportsImportToExcel()
		{
			return false;
		}
		public bool SupportsSelectionPaste()
		{
			return false;
		}
		public bool SupportsLevel()
		{
			return false;
		}


		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region Private Methods

        /// <summary>
        /// Inits the data source.
        /// </summary>
		private void InitDataSource()
		{
			if(_objPropertyTypes != null)
				_objPropertyTypes.Clear();
				
			if(_objSiteComponents != null)
				_objSiteComponents.Clear();
				
		
			if(_lrrSearchCriterias != null)
				_lrrSearchCriterias.Clear();

			if(_objLookUpProperties != null)
				_objLookUpProperties.Clear();

			if(_lrrPropertyTypesforUserDefinedArrays != null)
				_lrrPropertyTypesforUserDefinedArrays.Clear();

			_objPropertyTypes=new LRRPropertyTypes();
			_lrrApp.DBManagerObj.PopulateCollection(_objPropertyTypes," WHERE ID NOT IN ('0','1','2') And IsStandard=true", false);

			_objSiteComponents = new LRRSiteComponents();
			_lrrApp.DBManagerObj.PopulateCollection(_objSiteComponents ,false);


			_lrrSearchCriterias=new LRRSearchCriterias();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchCriterias," WHERE (Source = 'DA' OR  Source is null) ", false,true);
			_lrrSearchCriterias = _lrrSearchCriterias.FilterForUserByUserID();
			
			for(int j=0;j<_objSiteComponents.Count;j++)
			{
				_AllComponents.Add(_objSiteComponents[j].SiteComponentID,_objSiteComponents[j]);

			}

			_lrrPropertyTypesforUserDefinedArrays=new LRRPropertyTypes();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrPropertyTypesforUserDefinedArrays," where IsStandard=false and IsDataArray=true",false);
		}

        /// <summary>
        /// Binds the grid grouped properties.
        /// </summary>
		private void BindGridGroupedProperties()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridGroupedProperties.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridGroupedProperties);

			columnForDisplay.Add("IsSelected",null);
			columnForDisplay.Add("PropertyType",null);
			
			_objPropertyTypes = _objPropertyTypes.FilterPropertyTypesByDataArray(true);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridGroupedProperties,_objPropertyTypes.ItemType,null,true,columnForDisplay);
		
			RelativeWidths.Add("IsSelected",16);
			RelativeWidths.Add("PropertyType",80);
				
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumnsWidth(gridGroupedProperties,RelativeWidths );
			//Set the data store 
			gridGroupedProperties.DataSource = _objPropertyTypes;

			gridGroupedProperties.TableDescriptor.AllowNew = false;
			gridGroupedProperties.TableDescriptor.AllowRemove = false;
			gridGroupedProperties.TableDescriptor.AllowEdit = true;
				
			foreach(GridColumnDescriptor objCol in gridGroupedProperties.TableDescriptor.Columns)
			{
				if (objCol.MappingName != "IsSelected")
					objCol.ReadOnly = true;
			}
			gridGroupedProperties.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_DATA_ARRYAS")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");

			//Resume the Layout of the Grid...
			gridGroupedProperties.ResumeLayout(false);
	

			//Add the parent table for the Relations...
			gridGroupedProperties.Engine.SourceListSet.Add("ParentTable",_objPropertyTypes);

			//Events for check/uncheck all items
			gridGroupedProperties.TableControlQueryAllowSortColumn+=new GridQueryAllowSortColumnEventHandler(gridGroupedProperties_TableControlQueryAllowSortColumn);
			gridGroupedProperties.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);
			gridGroupedProperties.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridGroupedProperties_QueryCellStyleInfo);
			gridGroupedProperties.SaveCellText+=new GridCellTextEventHandler(gridGroupedProperties_SaveCellText);
		}
        /// <summary>
        /// Binds the grid plant items.
        /// </summary>
		private void BindGridPlantItems()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridPlantItems.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridPlantItems);
			columnForDisplay.Add("IsSelected",null);
			columnForDisplay.Add("Name",null);
			columnForDisplay.Add("MasterComponentType",null);
			
			int i = gridPlantItems.TableDescriptor.SortedColumns.Add("Name");

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_objSiteComponents.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_lrrApp.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridPlantItems,_objSiteComponents.ItemType,null,true,columnForDisplay,fkData);
				

			RelativeWidths.Add("IsSelected",5);
			RelativeWidths.Add("Name",30);
			RelativeWidths.Add("MasterComponentType_ComponentName",60);
			
			SyncGridUtilities.InitializeGridColumnsWidth(gridPlantItems,RelativeWidths );
			
			gridPlantItems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");
			gridPlantItems.TableDescriptor.AllowEdit = true;
			gridPlantItems.TableDescriptor.AllowNew = false;
			gridPlantItems.TableDescriptor.AllowRemove = false;
			gridPlantItems.TopLevelGroupOptions.ShowFilterBar = true;
			gridPlantItems.TableDescriptor.Appearance.AnyCell.ShowButtons=GridShowButtons.Hide;

			foreach(GridColumnDescriptor objCol in gridPlantItems.TableDescriptor.Columns)
			{
				if (objCol.MappingName != "IsSelected")
					objCol.ReadOnly = true;
			}

				
			//Set the data store 
			gridPlantItems.DataSource = _objSiteComponents;


			//Resume the Layout of the Grid...
			gridPlantItems.ResumeLayout(false);
	

			//Add the parent table for the Relations...
			gridPlantItems.Engine.SourceListSet.Add("ParentTable",_objSiteComponents);

			//Events for check/uncheck all items
			gridPlantItems.TableControlQueryAllowSortColumn+=new GridQueryAllowSortColumnEventHandler(gridGroupedProperties_TableControlQueryAllowSortColumn);
			gridPlantItems.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);
			gridPlantItems.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridPlantItems_QueryCellStyleInfo);
			gridPlantItems.SaveCellText+=new GridCellTextEventHandler(gridPlantItems_SaveCellText);

		}

        /// <summary>
        /// Binds the grid user defined arrays.
        /// </summary>
		private void BindGridUserDefinedArrays()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUserDefinedArrays.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridUserDefinedArrays);

			columnForDisplay.Add("IsSelected",null);
			columnForDisplay.Add("PropertyType",null);
			columnForDisplay.Add("Description",null);
			
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridUserDefinedArrays,_lrrPropertyTypesforUserDefinedArrays.ItemType,null,true,columnForDisplay);
		
			RelativeWidths.Add("IsSelected",16);
			RelativeWidths.Add("PropertyType",80);
			RelativeWidths.Add("Description",80);
				
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumnsWidth(gridUserDefinedArrays,RelativeWidths );
			//Set the data store 
			gridUserDefinedArrays.DataSource = _lrrPropertyTypesforUserDefinedArrays;

			gridUserDefinedArrays.TableDescriptor.AllowNew = false;
			gridUserDefinedArrays.TableDescriptor.AllowRemove = false;
			gridUserDefinedArrays.TableDescriptor.AllowEdit = true;
				
			foreach(GridColumnDescriptor objCol in gridUserDefinedArrays.TableDescriptor.Columns)
			{
				if (objCol.MappingName != "IsSelected")
					objCol.ReadOnly = true;
			}
			gridUserDefinedArrays.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_USER_DEFINED_DATA_ARRAYS")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");

			//Resume the Layout of the Grid...
			gridUserDefinedArrays.ResumeLayout(false);
	

			//Add the parent table for the Relations...
			gridUserDefinedArrays.Engine.SourceListSet.Add("ParentTable",_lrrPropertyTypesforUserDefinedArrays);
		}
		
		#endregion

        /// <summary>
        /// Handles the Click event of the btnExecute control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnExecute_Click(object sender, System.EventArgs e)
		{
            try
            {
                transposeFlag = false;
                int nModesCol = 0;
                LRRSiteComponents objSiteCompCollection = new LRRSiteComponents();
                LRRSiteComponents objModelComponent = LRRModel.SiteComponentsObj;
                LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();

                foreach (LRRMode lrrMode in LRRModel.ProjectModes)//_objModes)
                {
                    if (lrrMode.ViewSelection)
                        nModesCol++;
                }

                if (nModesCol == 0)
                {
                    LRRMessagBox.ShowMessage("SID_MODENOTSPECIFIED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }


                foreach (LRRSiteComponent objSiteComp in _objSiteComponents)
                {
                    if (objSiteComp.IsSelected)
                    {
                        LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComp.SiteComponentID);
                        objSiteCompCollection.Add(objModelSiteComponent);
                    }
                }
                if (objSiteCompCollection.Count == 0)
                {
                    LRRMessagBox.ShowMessage("SID_PLANTITEMNOTSPECIFIED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;

                }
                
                /*foreach(LRRLookUpQualifier objLkupQual in _lrrLookUpQualifiers)
                {
                    if(objLkupQual.IsSelected)
                    {
                        objLookUpQualifiers.Add(objLkupQual);
                    }
                }
			
                if(objLookUpQualifiers.Count == 0)
                {
                    LRRMessagBox.ShowMessage("SID_QUALIFIERNOTSPECIFIED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
                    _objSiteComponents.RefreshCollection();
                    return;
                }*/

                this.pnlGridContainer.Controls.Clear();

                //Clear All Bindings
                if (gridView != null)
                {
                    gridView.ClearAllBindings();
                    gridView.UnSubscribeReconnectCompleted();
                }

                ArrayList custCollection = new ArrayList();
                //custCollection.Add(objLookUpQualifiers);
                LRRPropertyTypes propTypes = new LRRPropertyTypes();
                foreach (LRRPropertyType propType in _lrrPropertyTypes)
                {
                    if (propType.IsSelected)
                    {
                        propTypes.Add(propType);
                    }
                }
                if (propTypes.Count > 5)
                {
                    LRRMessagBox.ShowMessage("SID_NERROW_DOWN_SEARCH", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //			foreach(LRRPropertyType propType in _lrrPropertyTypesforUserDefinedArrays)
                //			{
                //				if(propType.IsSelected)
                //				{
                //					propTypes.Add(propType);
                //				}
                //			}
                LRRWaitWindowUtility.ShowPogressIndicator(LRRHeaderText.GetHeaderString(""));
                custCollection.Add(propTypes);
                custCollection.Add(objSiteCompCollection);


                gridView = new GridDataArrayViewController();
                //custCollection.Add(objLookUpQualifiers);
                gridView.LoadPanel(custCollection, null);

                //Show the Properties Form
                LRRResultProperties resultProperties = SearchRetrievalUtility.ShowGroupedPropertiesWindow(objSiteCompCollection,propTypes,typeof(GroupedPlantDataArrayView));
                _rsProperties.PropertyCollection = resultProperties;
                _rsProperties.Text = "Result Properties Window";
                _rsProperties.BindGrid();
                _rsProperties.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsProperties_SelectedProperties);
                _rsProperties.Owner = this;


                // Show the Component List Form
                LRRResultProperties resultComponents = SearchRetrievalUtility.ShowComponents(objSiteCompCollection, null);
                _rsComponents.PropertyCollection = resultComponents;
                _rsComponents.Text = "Result Components Window";
                _rsComponents.BindGrid();
                _rsComponents.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsComponents_SelectedProperties);
                _rsComponents.Owner = this;


                gridView.HideProperties(_rsProperties.UnSelectedRecords);
                gridView.HideComponents(_rsComponents.UnSelectedRecords);

                ArrayList pnlCollection = gridView.GetPanelCollection();
                if (pnlCollection != null && pnlCollection.Count > 0)
                {
                    SetPanel(pnlCollection);
                    gridView.HideModes();

                    if (this.dockingManager1 != null)
                    {
                        this.dockingManager1.HideAutoHiddenControl();
                        pnlGroupedPropertiesOutput.DockPadding.Left = this.dockingManager1.DockTabHeight;
                    }
                    _objSiteComponents.RefreshCollection();
                    objSiteCompCollection.RefreshCollection();
                    Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
                    _lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter, true);
                }
                else
                {
                    LRRMessagBox.ShowMessage(this, "SID_INVALID_QUERY", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                IsChanged = true;
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(GroupedPlantDataArrayView), "ExecuteClick: " + ex, Logger.Level.Debug);
            }
            finally
            {
                LRRWaitWindowUtility.EndProgressIndicator();
            }
		}

        void _rsProperties_SelectedProperties(ArrayList arrayUnSelectedRecords)
        {
            gridView.HideProperties(arrayUnSelectedRecords);
        }

        void _rsComponents_SelectedProperties(ArrayList arrayUnSelectedRecords)
        {
            gridView.HideComponents(arrayUnSelectedRecords);
        }

        /// <summary>
        /// Handles the Load event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void GroupedPlantPropertiesView_Load(object sender, System.EventArgs e)
		{
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriterias," WHERE (Source = 'DA' OR  Source is null) ",false,true);
			_SearchCriterias = _SearchCriterias.FilterForUserByUserID();

			_lrrApp.DBManagerObj.PopulateCollection(_SearchModes," WHERE (Source = 'DA' OR  Source is null) ",false,true);
			
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItems," WHERE (Source = 'DA' OR  Source is null) ",false,true);

			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaPropertyTypes,"",false,true);
			
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaQualifiers,"",false,true);

			cmbQueryList.DataSource = _lrrSearchCriterias;
			cmbQueryList.DisplayMember = "Name";
			cmbQueryList.ValueMember = "ID";

			LRRSearchCriteria srchCriteria = _lrrSearchCriterias.GetSearchCriteriaByID("0");
			if(srchCriteria != null)
				cmbQueryList.SelectedItem = srchCriteria;

			Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
			_lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter,false);
            pnlRun.Visible = false;
		
		}

        /// <summary>
        /// Sets the panel.
        /// </summary>
        /// <param name="pnlCollection">The PNL collection.</param>
		private void SetPanel(ArrayList pnlCollection)
		{
			int heightOfEach = pnlGridContainer.Height/pnlCollection.Count;
			int splitCnt = 0;
			for(int i=pnlCollection.Count-1;i>=0;i--)
			{
				Panel panel = pnlCollection[i] as Panel;
				panel.Height = heightOfEach;
				this.pnlGridContainer.Controls.Add(panel);
				if(splitCnt < pnlCollection.Count - 1)
				{
					Splitter splitGrid = new Splitter();
					splitGrid.Dock = DockStyle.Top;
					this.pnlGridContainer.Controls.Add(splitGrid);
					splitCnt++;
				}
			}
			if(this.pnlGridContainer.Controls.Count > 0)
				this.pnlGridContainer.Controls[0].Dock = DockStyle.Fill;
		}

        /// <summary>
        /// Sets the height of the panel.
        /// </summary>
		private void SetPanelHeight()
		{
			int iNumPanels = pnlGridContainer.Controls.Count/2;
			if(iNumPanels != 0)
			{
				//int pnlHeight = this.pnlGroupedPropMain.Height - (SystemInformation.HorizontalScrollBarHeight);
				int pnlHeight = this.pnlGroupedPropertiesOutput.Height - (SystemInformation.HorizontalScrollBarHeight);
				int gridPnlHeight = (pnlHeight)/iNumPanels;
				foreach(Control ctl in pnlGridContainer.Controls)
				{
					if(ctl.GetType() == typeof(Panel))
					{
						ctl.Height = gridPnlHeight;
					}
				}
			}
		}
        /// <summary>
        /// Binds the site components on check changed.
        /// </summary>
		private void bindSiteComponentsOnCheckChanged()
		{
            //IsChanged = true;
			_lrrSiteCompsList = new LRRSiteComponents();
			
			foreach(LRRPropertyType objPropertyType in _objPropertyTypes)
			{
				if(objPropertyType.IsSelected)
				{
					_lrrSiteComps2 = new LRRSiteComponents();
					_lrrSiteComps2 = LRRModel.SiteComponentsObj;

					_objSelectedComponents= _lrrSiteComps2.FilterSiteComponentsByPropertyType(objPropertyType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture));
			
					foreach(LRRSiteComponent objComp in  _objSelectedComponents )
					{
						LRRSiteComponent objCompCloned = objComp.Clone() as LRRSiteComponent ;
						bool blnCompExists = false;
						foreach(LRRSiteComponent objCompToAdd in _lrrSiteCompsList)
						{
							if(objCompToAdd.SiteComponentID.Equals(objCompCloned.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
								blnCompExists = true;

						}
						if(!blnCompExists)
							_lrrSiteCompsList.Add(objCompCloned);
					}
				}
				else
				{
					//Unselect Lookup Qualifiers & corresponding Site Components.
					_lrrSiteComps2 = new LRRSiteComponents();
					_lrrSiteComps2 = LRRModel.SiteComponentsObj;

					_objSelectedComponents= _lrrSiteComps2.FilterSiteComponentsByPropertyType(objPropertyType.ID);
			
					foreach(LRRSiteComponent objComp in  _objSelectedComponents )
					{
						objComp.IsSelected = false;
					}
				}
			}

			//User Defined Arrays
			foreach(LRRPropertyType objPropertyType in _lrrPropertyTypesforUserDefinedArrays)
			{
				if(objPropertyType.IsSelected)
				{
					_lrrSiteComps2 = new LRRSiteComponents();
					_lrrSiteComps2 = LRRModel.SiteComponentsObj;

					_objSelectedComponents= _lrrSiteComps2.FilterSiteComponentsByPropertyType(objPropertyType.ID);
			
					foreach(LRRSiteComponent objComp in  _objSelectedComponents )
					{
						LRRSiteComponent objCompCloned = objComp.Clone() as LRRSiteComponent ;
						bool blnCompExists = false;
						foreach(LRRSiteComponent objCompToAdd in _lrrSiteCompsList)
						{
							if(objCompToAdd.SiteComponentID.Equals(objCompCloned.SiteComponentID))
								blnCompExists = true;

						}
						if(!blnCompExists)
							_lrrSiteCompsList.Add(objCompCloned);
					}
				}
				else
				{
					//Unselect Lookup Qualifiers & corresponding Site Components.
					_lrrSiteComps2 = new LRRSiteComponents();
					_lrrSiteComps2 = LRRModel.SiteComponentsObj;

					_objSelectedComponents= _lrrSiteComps2.FilterSiteComponentsByPropertyType(objPropertyType.ID);
			
					foreach(LRRSiteComponent objComp in  _objSelectedComponents )
					{
						objComp.IsSelected = false;
					}
				}

			}
			
			
			_objSiteComponents = _lrrSiteCompsList;
			
			gridPlantItems.CurrencyManager.List.Clear();
			foreach(LRRSiteComponent lsc in _objSiteComponents)
			{
				gridPlantItems.CurrencyManager.List.Add(lsc);
			}

			gridPlantItems.TableDescriptor.Columns["Name"].ReadOnly=true;
			gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].ReadOnly=true;
			gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridPlantItems.TableDescriptor.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
		}

        /// <summary>
        /// Handles the RecordValueChanged event of the gridGroupedProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Grouping.RecordValueChangedEventArgs"/> instance containing the event data.</param>
		private void gridGroupedProperties_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
            //IsChanged = true;
            CheckUncheckGroupProps();
		}

        /// <summary>
        /// Checks the uncheck group props.
        /// </summary>
		private void CheckUncheckGroupProps()
		{
            //IsChanged = true;
			ReBindQualifierGrid();
//			if(!rdGroupByItems.Checked)
//			{
				bindSiteComponentsOnCheckChanged();
//			}
		}

        /// <summary>
        /// Res the bind qualifier grid.
        /// </summary>
		private void ReBindQualifierGrid()
		{
            //IsChanged = true;
			_lrrPropertyTypes.Clear();
			ArrayList arrPropertyType = new ArrayList();

			foreach(LRRPropertyType lrrPropType in _objPropertyTypes)
			{
				if(lrrPropType.IsSelected)
				{
					string sPropType = lrrPropType.ID == null ? "" : lrrPropType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					if(!arrPropertyType.Contains(lrrPropType.ID))
					{
						arrPropertyType.Add(lrrPropType.ID);
						_lrrPropertyTypes.Add(lrrPropType);
					}
				}
			}

			foreach(LRRPropertyType lrrPropType in _lrrPropertyTypesforUserDefinedArrays)
			{
				if(lrrPropType.IsSelected)
				{
					string sPropType = lrrPropType.ID == null ? "" : lrrPropType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					if(!arrPropertyType.Contains(lrrPropType.ID))
					{
						arrPropertyType.Add(lrrPropType.ID);
						_lrrPropertyTypes.Add(lrrPropType);
					}
				}
			}
		}	
		
		
		#region Private Fields
		private	LRRApp					_lrrApp; //All object to access the DB Manager and DB Adapter
		private	LRRPropertyTypes		_objPropertyTypes = null;
		private	LRRSiteComponents		_objSiteComponents = null;
		private LRRSiteComponents		_objSelectedComponents = null;
//		private	LRRModes				_objModes		  = null;
		private LRRModes				_objSelectedModes = null;
		private	LRRQualifiers			_objQualifiers = null;	
		private	LRRLookUpQualifiers		_objLookupQualifiers = null;	
		private Hashtable				_AllQualifiers = new Hashtable(); //Hash table which has all the Qualifiers with ID = QualifierID & Obj = LRRQualifier.
		private Hashtable				_AllComponents = new Hashtable(); //Hash table which has all the site components with ID = sitecomponentid & Obj = LRRSiteComponent.
		public IGroupGridFactory		gridView;
		private LRRSiteComponents		_lrrSiteComps2=null;
		private LRRSiteComponents		_lrrSiteCompsList = new LRRSiteComponents();
		ArrayList gridCollection = new ArrayList();
		ArrayList gridInstanceCollection = new ArrayList();
		private LRRSearchCriterias _lrrSearchCriterias;
		private LRRSearchCriterias _SearchCriterias = new LRRSearchCriterias();
		private LRRSearchCriteriaModes _SearchModes = new LRRSearchCriteriaModes();
		private LRRSearchCriteriaItems _SearchCriteriaItems = new LRRSearchCriteriaItems();
		private LRRSearchCriteriaQualifiers _SearchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();
		private LRRSearchCriteriaPropertyTypes _SearchCriteriaPropertyTypes = new LRRSearchCriteriaPropertyTypes();
		private LRRPropertyTypes		_lrrPropTypes=null;
		bool bFlag = true;
		ArrayList	arrPptytype=new ArrayList();
		private LRRPropertyTypes		_lrrPropertyTypes = new LRRPropertyTypes();
		private LRRLookUpQualifiers		 _lrrLookUpQualifiers = new LRRLookUpQualifiers();
		private LRRPropertyTypes _lrrPropertyTypesforUserDefinedArrays = new LRRPropertyTypes();


        //Results Filter Windows
        private ResultPropertiesWindow _rsProperties = new ResultPropertiesWindow();
        private ResultPropertiesWindow _rsComponents = new ResultPropertiesWindow();
		#endregion

        /// <summary>
        /// Handles the SelectedIndexChanged event of the cmbQueryList control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void cmbQueryList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(!bFlag)
			{
				bFlag = true;
				return;
			}
			LRRSearchCriteria searchCriteriaObj = cmbQueryList.SelectedItem as LRRSearchCriteria;
			_objSiteComponents.RefreshCollection();
			_objPropertyTypes.RefreshCollection();
			_lrrPropertyTypesforUserDefinedArrays.RefreshCollection();

			if(!searchCriteriaObj.ID.Equals("0"))
			{
				_SearchCriteriaItems.ItemFilter = "SearchCriteriaID = '" + searchCriteriaObj.ID + "'";
				_SearchCriteriaPropertyTypes.ItemFilter = "SearchCriteriaID = '" + searchCriteriaObj.ID + "'";

				//Plant Items
				foreach(LRRSearchCriteriaItem searchCriteriaItem in _SearchCriteriaItems)
				{
					LRRSiteComponent siteComponentObj =_objSiteComponents.GetSiteComponentByID(searchCriteriaItem.ItemID);
					if(siteComponentObj != null)
					{
						siteComponentObj.IsSelected = true;
						LRRSearchCriteriaItemProperties srchCriteriaItemProps = new LRRSearchCriteriaItemProperties();
						_lrrApp.DBManagerObj.PopulateCollection(srchCriteriaItemProps," where ItemID = '" + siteComponentObj.SiteComponentID + "'",false,true);
						foreach(LRRSearchCriteriaItemProperty srchCriteriaItemProp in srchCriteriaItemProps)
						{
							LRRSiteComponentProperty siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(srchCriteriaItemProp.ItemPropertyID);
							if(siteCompProp != null)
							{
								siteCompProp.UIUomID = srchCriteriaItemProp.UIUomID;
							}
						}
					}
					else
					{
						if( _AllComponents[searchCriteriaItem.ItemID] != null)
						{
							LRRSiteComponent siteCompObj = _AllComponents[searchCriteriaItem.ItemID] as LRRSiteComponent;
							_objSiteComponents.Add(siteCompObj);
						}
					}
				}
				//Property Type
				foreach(LRRSearchCriteriaPropertyType searchCriteriaPropType in _SearchCriteriaPropertyTypes)
				{
					foreach(LRRPropertyType propTypeObj in _objPropertyTypes)
					{
						if(searchCriteriaPropType.PropertyType == propTypeObj.ID)
						{
							propTypeObj.IsSelected = true;
						}
					}
				}

				//User Defined Arrays
				foreach(LRRSearchCriteriaPropertyType searchCriteriaPropType in _SearchCriteriaPropertyTypes)
				{
					foreach(LRRPropertyType propTypeObj in _lrrPropertyTypesforUserDefinedArrays)
					{
						if(searchCriteriaPropType.PropertyType == propTypeObj.ID)
						{
							propTypeObj.IsSelected = true;
						}
					}
				}

				ReBindQualifierGrid();
			}
			else
			{
				foreach(LRRPropertyType propTypeObj in _objPropertyTypes)
				{
					propTypeObj.IsSelected = false;
				}
				foreach(LRRPropertyType propTypeObj in _lrrPropertyTypesforUserDefinedArrays)
				{
					propTypeObj.IsSelected = false;
				}
				foreach(LRRSiteComponent siteComponentObj in _objSiteComponents)
				{
					siteComponentObj.IsSelected = false;
				}
				ReBindQualifierGrid();
			}
			gridGroupedProperties.Refresh();
			gridPlantItems.Refresh();
			gridUserDefinedArrays.Refresh();
            IsChanged = false;
		}

        /// <summary>
        /// Prepares the query.
        /// </summary>
        /// <param name="searchQueryID">The search query ID.</param>
		public void PrepareQuery(string searchQueryID)
		{
			GroupSearchCriteria query = new GroupSearchCriteria();

			LRRSearchCriteria searchCriteria = new LRRSearchCriteria();
			if(searchQueryID != null)
				searchCriteria.ID = searchQueryID;

			searchCriteria.Source="DA";
			string template = "";
			template = "Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayViewController";
			searchCriteria.TemplateClass = template;
			
			LRRSearchCriteriaPropertyTypes searchCriteriaPropTypesObj = new LRRSearchCriteriaPropertyTypes();
			foreach(LRRPropertyType propTypeObj in _objPropertyTypes)
			{
				BaseObject bo = propTypeObj as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaPropertyType searchCriteriaPropType = new LRRSearchCriteriaPropertyType();
					searchCriteriaPropType.SearchCriteriaID = searchCriteria.ID;
					searchCriteriaPropType.PropertyType= propTypeObj.ID;
					searchCriteriaPropTypesObj.Add(searchCriteriaPropType);
				}
			}

			foreach(LRRPropertyType propTypeObj in _lrrPropertyTypesforUserDefinedArrays)
			{
				BaseObject bo = propTypeObj as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaPropertyType searchCriteriaPropType = new LRRSearchCriteriaPropertyType();
					searchCriteriaPropType.SearchCriteriaID = searchCriteria.ID;
					searchCriteriaPropType.PropertyType= propTypeObj.ID;
					searchCriteriaPropTypesObj.Add(searchCriteriaPropType);
				}
			}

			
			LRRSearchCriteriaItems searchCriteriaItems = new LRRSearchCriteriaItems();
			LRRSearchCriteriaItemProperties searchCriteriaItemProperties = new LRRSearchCriteriaItemProperties();
			foreach(LRRSiteComponent siteComponentObj in _objSiteComponents)
			{
				BaseObject bo = siteComponentObj as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaItem searchCriteriaItem = new LRRSearchCriteriaItem();
					searchCriteriaItem.SearchCriteriaID	= searchCriteria.ID;
					searchCriteriaItem.ItemID = siteComponentObj.SiteComponentID;
					searchCriteriaItem.Source="DA";
					searchCriteriaItems.Add(searchCriteriaItem);
				}
			}
			
			//Assign to searchcriteria object
			query.SearchQuery = searchCriteria;
			query.SearchCriteriaItems = searchCriteriaItems;
			query.SearchCriteriaPropTypes = searchCriteriaPropTypesObj;
			gridView.SearchQuery = query;

		}

        /// <summary>
        /// Saves the query.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="desc">The desc.</param>
        /// <param name="groupLevel">The group level.</param>
        /// <param name="isPublished">if set to <c>true</c> [is published].</param>
		public void SaveQuery(string name, string desc,LRRSearchGroupLevel groupLevel,bool isPublished)
		{
			string searchQueryID = null;
            string userSettingsID = null;
			string userID = this._lrrApp.DBManagerObj.AccessControlModel.UserID;

			IEnumerator iEnum = LRRModel.ChildModel.SearchCriterias.GetEnumerator();//_SearchCriterias.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRSearchCriteria srch = iEnum.Current as LRRSearchCriteria;
				if(srch.Name == name)
				{
					DialogResult dlgResult =  LRRMessagBox.ShowMessage("SID_QUERYNAME_DUPLICATE","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);    
					if(dlgResult == DialogResult.No)
					{
						return;
					}
					
					
					searchQueryID = srch.ID;
                    userSettingsID = srch.UserSettingsID;
					srch.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
					_lrrApp.DBManagerObj.CommitObject(srch);
//					_SearchCriterias.Remove(srch);

					//Remove from Model
					LRRSearchCriteria srchCriteria = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(srch.ID);
					if(srchCriteria != null)
					{
						userID = srchCriteria.UserID;
						srchCriteria.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
						LRRModel.ChildModel.SearchCriterias.Remove(srchCriteria);

						//Remove from Levels and Level Link tables
						LRRSearchGroupLevel lrrSrchGroupLevel = new LRRSearchGroupLevel();
						lrrSrchGroupLevel.LevelID = srchCriteria.ID;
						lrrSrchGroupLevel.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(lrrSrchGroupLevel);

						LRRSearchGroupLevelLink lrrSrchGroupLevelLink = new LRRSearchGroupLevelLink();
						_lrrApp.DBManagerObj.PopulateObject(lrrSrchGroupLevelLink,typeof(LRRSearchGroupLevelLink)," where ChildID = '" + srchCriteria.ID + "'");
						
						//Delete the Object
						lrrSrchGroupLevelLink.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(lrrSrchGroupLevelLink);
					}

					break;
				}
			}
			
			
			if(gridView != null)
			{
				PrepareQuery(searchQueryID);
				if(userID == null || userID.Trim() == "")
					userID = this._lrrApp.DBManagerObj.AccessControlModel.UserID;
				gridView.SearchQuery.UserID = userID;
                gridView.SearchQuery.SearchQuery.UserSettingsID = userSettingsID;
				gridView.Save(name,desc,groupLevel,isPublished);
			}
			else
				return;			
			LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			
			bFlag = false;

			if(_SearchCriteriaItems != null)
				_SearchCriteriaItems.Clear();
			if(_SearchCriterias != null)
				_SearchCriterias = new LRRSearchCriterias();
			if(_SearchCriteriaPropertyTypes != null)
				_SearchCriteriaPropertyTypes.Clear();

			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriterias," WHERE (Source = 'DA' OR  Source is null) ",false,true);
			_SearchCriterias = _SearchCriterias.FilterForUserByUserID();
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaPropertyTypes,null,false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItems," WHERE (Source = 'DA' OR  Source is null) ",false,true);
			
			_lrrSearchCriterias = _SearchCriterias;
			cmbQueryList.DataSource = _lrrSearchCriterias;
			LRRSearchCriteria srchCriteria1 = _lrrSearchCriterias.GetSearchCriteriaByID(gridView.SearchQuery.SearchQuery.ID);
			if(srchCriteria1 != null)
				cmbQueryList.SelectedItem = srchCriteria1;
			
			//Update in Model
			LRRSearchCriterias srchCriterias = new LRRSearchCriterias();
			_lrrApp.DBManagerObj.PopulateCollection(srchCriterias,"",false,true);
			LRRModel.ChildModel.SearchCriterias = srchCriterias;
            IsChanged = false;

        }

        /// <summary>
        /// Handles the Activated event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void GroupedPlantPropertiesView_Activated(object sender, System.EventArgs e)
		{
			LRRFormulaDataStore.DataSource = lrrFormulaGroupedProperties;
			LRRFormulaDataStore.ModeFlag = true;
		}

		private void gridOutputModes_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{

		}

		private void ProjectModes_ModesChanged(object sender, EventArgs e)
		{
			if(gridView != null)
				gridView.HideModes();
		}

        /// <summary>
        /// Handles the Closing event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.ComponentModel.CancelEventArgs"/> instance containing the event data.</param>
		private void GroupedPlantPropertiesView_Closing(object sender, CancelEventArgs e)
		{
            Form frm = sender as Form;
            GridCheckForViewChanges.CheckForViewChanges(IsChanged, null, gridView, frm, null, null, false, null, null, null, null,false);
            LRRModel.ProjectModes.ModesChanged -= new EventHandler(ProjectModes_ModesChanged);
            IsChanged = false;
            BPropertyValChanged = false;
            //CommonViews.ChangedUIUOMDictionary.Clear(this.GetType());
			
            //Clear All Bindings
			/*if(gridView != null)
			{
				gridView.ClearAllBindings();
				gridView.UnSubscribeReconnectCompleted();
			}
			LRRModel.ProjectModes.ModesChanged-=new EventHandler(ProjectModes_ModesChanged);

            if (_isChanged)
            {
                DialogResult k = LRRMessagBox.ShowMessage("SID_SAVE_QUERY", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (k == DialogResult.Yes)
                {
                    Save();
                }
            }

            // Save For Property Values
            LRRSiteGroupPropertyQualifierValues propertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();

            if (propertyQualifierValues.Count > 0)
            {
                DialogResult dlgResult = LRRMessagBox.ShowMessage(this,"SID_SAVE_PROPVALUE","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
                if (dlgResult == DialogResult.Yes)
                {
                    SaveOutput();
                }
                else
                {
                    foreach (LRRSiteGroupPropertyQualifierValue propertyQualifierValue in propertyQualifierValues)
                    {
                        LRRSiteComponentProperty objProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propertyQualifierValue.SiteComponentPropID);
                        string groupPropID = LRRModel.SiteComponentGroupPropertiesObj.GetSiteGroupPropID(propertyQualifierValue.SiteComponentPropID,propertyQualifierValue.LookUpPropertiesID);
                        LRRSiteGroupPropertyQualifierValue objPropValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID, propertyQualifierValue.LookUpPropertiesID, propertyQualifierValue.QualifierID, propertyQualifierValue.ModeID);
                        objPropValue.RollBackChanges(true);
                    }
                }
            }*/
		}

		#region ILRRUIContainer Members


		public void ClearSort()
		{
			//Add GroupedPlantPropertiesView.ClearSort implementation
			SyncGridUtilities.ClearSort(gridPlantItems);
			SyncGridUtilities.ClearSort(gridGroupedProperties);

			//Clear Sort
			if(gridView != null)
			{
				gridView.ClearSort();
			}
		}

		public bool SupportsClearSort()
		{
			// Add GroupedPlantPropertiesView.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			if(gridView != null)
				gridView.PrintPreview();
		}

		#endregion

		#region ILRRUIContainer Members

        public void ShowPropertyList()
        {
            //Add GroupedPlantDataArrayView.ShowPropertyList implementation
            if (_rsProperties != null)
            {
                _rsProperties.IsWindowOpen = true;
                _rsProperties.Show();
            }
        }

		public bool SupportsResultsFilter()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

        public void ShowComponentList()
        {
            //Add GroupedPlantDataArrayView.ShowComponentList implementation
            if (_rsComponents != null)
            {
                _rsComponents.IsWindowOpen = true;
                _rsComponents.Show();
            }
        }

		#endregion

        /// <summary>
        /// Handles the Closed event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void GroupedPlantPropertiesView_Closed(object sender, System.EventArgs e)
		{
			_lrrApp.LRRUIManagerObj.PerformDataDirtyCheck = true;

		}

        /// <summary>
        /// Handles the TableControlQueryAllowSortColumn event of the gridGroupedProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs"/> instance containing the event data.</param>
		private void gridGroupedProperties_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == "IsSelected")
			{
				e.AllowSort = false;
			}
		}

        /// <summary>
        /// Handles the MouseUp event of the TableControl control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
		private void TableControl_MouseUp(object sender, MouseEventArgs e)
		{
			int row, col;
			GridTableControl gridTableControl = sender as GridTableControl;
			gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
			GridTableCellStyleInfo style = gridTableControl.Model[row, col];

			IMouseController controller;
			gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

			if(controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
			{
				gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
			}
		}
		
		int row, col;
		bool CheckBoxValue = false;
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridGroupedProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
		private void gridGroupedProperties_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
		  try
		   {
		       if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
		     {  
		             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
		             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
		     }  
		  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		 
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row, out col);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = CheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

        /// <summary>
        /// Handles the SaveCellText event of the gridGroupedProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
		private void gridGroupedProperties_SaveCellText(object sender, GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.CheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _objPropertyTypes.GetEnumerator();
				while(iEnum.MoveNext())
				{
					LRRPropertyType propertyType = iEnum.Current as LRRPropertyType;
					if(propertyType != null)
						propertyType.IsSelected = this.CheckBoxValue;
				}
				gridGroupedProperties.Refresh();
				CheckUncheckGroupProps();
				e.Handled = true;
			}

		}
		
		bool siteCompCheckBoxValue = false;
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridPlantItems control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
		private void gridPlantItems_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
		  try
		   {
		       if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
		     {  
		             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
		             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
		     }  
		  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		 
		 
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row, out col);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = siteCompCheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

        /// <summary>
        /// Handles the SaveCellText event of the gridPlantItems control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
		private void gridPlantItems_SaveCellText(object sender, GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.siteCompCheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _objSiteComponents.GetEnumerator();
				while(iEnum.MoveNext())
				{
					LRRSiteComponent siteComp = iEnum.Current as LRRSiteComponent;
					if(siteComp != null)
						siteComp.IsSelected = this.siteCompCheckBoxValue;
				}
				gridPlantItems.Refresh();
				e.Handled = true;
			}
		}

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			if(gridView != null)
				gridView.LeftColMovement();
		}

		public void RightColMovement()
		{
			if(gridView != null)
				gridView.RightColMovement();
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add GroupedPlantPropertiesView.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add GroupedPlantPropertiesView.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add GroupedPlantPropertiesView.SupportsUndo implementation
			return false;
		}

		#endregion

        /// <summary>
        /// Handles the RecordValueChanged event of the gridUserDefinedArrays control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Grouping.RecordValueChangedEventArgs"/> instance containing the event data.</param>
		private void gridUserDefinedArrays_RecordValueChanged(object sender, RecordValueChangedEventArgs e)
		{
            //IsChanged = true;
			CheckUncheckGroupProps();
		}
		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add GroupedPlantDataArrayView.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add GroupedPlantDataArrayView.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add GroupedPlantDataArrayView.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add GroupedPlantDataArrayView.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add GroupedPlantDataArrayView.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add GroupedPlantDataArrayView.PerformDirtyChk getter implementation
                return true;
			}
		}

		#endregion

		#region ILRRUISpecificContainer Members

		public void ChangeUOMSet()
		{
			if(gridView != null)
			{
				ChangeUOMSetDefinitionForm chngUOMSetDefn = new ChangeUOMSetDefinitionForm();
				DialogResult dlgResult = chngUOMSetDefn.ShowDialog();
				if(dlgResult == DialogResult.OK)
				{
					gridView.ChangeUOMSet(chngUOMSetDefn.MeasSysID);
				}
			}
		}

		public bool SupportsChangeUOMSet()
		{
			return true;
		}

		#endregion

        /// <summary>
        /// Handles the DropDown event of the cmbQueryList control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void cmbQueryList_DropDown(object sender, System.EventArgs e)
		{
			ComboBox senderComboBox = (ComboBox)sender;
			int width = senderComboBox.DropDownWidth;
			Graphics g = senderComboBox.CreateGraphics();
			Font font = senderComboBox.Font;
			int vertScrollBarWidth = 
				(senderComboBox.Items.Count>senderComboBox.MaxDropDownItems)
				?SystemInformation.VerticalScrollBarWidth:0;

			int newWidth;
			foreach (LRRSearchCriteria searchCriteria in ((ComboBox)sender).Items)
			{
				string s = searchCriteria.Name;
				newWidth = (int) g.MeasureString(s, font).Width 
					+ vertScrollBarWidth;
				if (width < newWidth )
				{
					width = newWidth;
				}
			}
			senderComboBox.DropDownWidth = width;
		}

        bool isOpen = false;
        private void dockingManager1_AutoHideAnimationStart(object sender, Syncfusion.Windows.Forms.Tools.AutoHideAnimationEventArgs arg)
        {
            if (!isOpen)
            {
                InternationalizationUtils.GetControlText(this, this.components.Components);  
            }
        }

        /// <summary>
        /// Handles the Click event of the btnTranspose control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void btnTranspose_Click(object sender, EventArgs e)
        {
            LRRSiteComponents objModelComponent = LRRModel.SiteComponentsObj;
            LRRSiteComponents objSiteCompCollection = new LRRSiteComponents();
            foreach (LRRSiteComponent objSiteComp in _objSiteComponents)
            {
                if (objSiteComp.IsSelected)
                {
                    LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComp.SiteComponentID);
                    objSiteCompCollection.Add(objModelSiteComponent);
                }
            }

            LRRPropertyTypes propTypes = new LRRPropertyTypes();
            foreach (LRRPropertyType propType in _lrrPropertyTypes)
            {
                if (propType.IsSelected)
                {
                    propTypes.Add(propType);
                }
            }

            if (!transposeFlag)
                transposeFlag = true;
            else
                transposeFlag = false;

            if (gridView != null)
            {
                gridView.ClearAllBindings();
                gridView.UnSubscribeReconnectCompleted();
            }

            if (transposeFlag)
            {
                gridView = new Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayTransposeViewController();
            }
            else
            {
                gridView = new Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayViewController();
            }

            ArrayList custCollection = new ArrayList();
            custCollection.Add(propTypes);
            custCollection.Add(objSiteCompCollection);

            gridView.LoadPanel(custCollection, null);

            ArrayList pnlCollection = gridView.GetPanelCollection();
            if (pnlCollection != null && pnlCollection.Count > 0)
            {
                this.pnlGridContainer.Controls.Clear();
                SetPanel(pnlCollection);
                gridView.HideModes();

                if (this.dockingManager1 != null)
                {
                    this.dockingManager1.HideAutoHiddenControl();
                    pnlGroupedPropertiesOutput.DockPadding.Left = this.dockingManager1.DockTabHeight;
                }
                _objSiteComponents.RefreshCollection();
                objSiteCompCollection.RefreshCollection();
                Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
                _lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter, true);
            }
        }
	}
}
