using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects; 
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.PEAdvisor.IOScreen;

namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
	/// <summary>
	/// Summary description for SearchForm.
	/// </summary>
	public class GroupedPlantPropertiesResultForm : System.Windows.Forms.Form,ILRRUIContainer,ILRRUISpecificContainer
	{

		
		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private System.Windows.Forms.Panel panel1;
        private LRRApp _lrrApp;
        public static bool BGroupedPlantPropertiesResultFormChange = false;
        public static bool BGroupedPlantPropertiesDataArrayResultFormChange = false;


		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupedPlantPropertiesResultForm"/> class.
        /// </summary>
		public GroupedPlantPropertiesResultForm()
		{
			InitializeComponent();
		}

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupedPlantPropertiesResultForm"/> class.
        /// </summary>
        /// <param name="gridView">The grid view.</param>
		public GroupedPlantPropertiesResultForm(IGroupGridFactory gridView)
		{
            InitForm(gridView);
		}

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupedPlantPropertiesResultForm"/> class.
        /// </summary>
        /// <param name="searchCriteriaID">The search criteria ID.</param>
        public GroupedPlantPropertiesResultForm(string searchCriteriaID)
        {
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            LRRSearchCriteria lrrSrchCriteria = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(searchCriteriaID);
            OpenQuery(lrrSrchCriteria);
            this.Text = Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_RESULT") + "-" + "[" + lrrSrchCriteria.Name + "]";
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(GroupedPlantPropertiesResultForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(832, 582);
			this.panel1.TabIndex = 2;
			// 
			// GroupedPlantPropertiesResultForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(832, 582);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "GroupedPlantPropertiesResultForm";
			this.Text = "Result";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.ResumeLayout(false);

		}
		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
		}

		public void Save()
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			if(iGroupGridView != null)
			{
				iGroupGridView.Save();
                LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                if (this.GridView.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierViewController))
                {
                        BGroupedPlantPropertiesResultFormChange = false;
                }
                else if (this.GridView.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayViewController))
                {
                        BGroupedPlantPropertiesDataArrayResultFormChange = false;
                }
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			}
		}
		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			
		}

		public void Copy()
		{
			
		}

		public void Print()
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			iGroupGridView.Print();
		}

		public void Delete()
		{
			
		}

		public void ArrangeColumns()
		{
			
		}

		public void ClearFilter()
		{
		}
		public void ImportToExcel()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		public bool SupportsSelectionPaste()
		{
			return false;
		}

		public void SelectionPaste()
		{
		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return false;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			return false;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}
		public void Export()
		{
		}
		
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region Methods

        /// <summary>
        /// Opens the query.
        /// </summary>
        /// <param name="lrrSrchCriteria">The LRR SRCH criteria.</param>
        private void OpenQuery(LRRSearchCriteria lrrSrchCriteria)
        {
            ResultPropertiesWindow rsProperties = _lrrApp.MainFrame.LRRScreenListView.RsProperties = new ResultPropertiesWindow();
            ResultPropertiesWindow rsComponents = _lrrApp.MainFrame.LRRScreenListView.RsComponents = new ResultPropertiesWindow();

            string searchCriteriaID = lrrSrchCriteria.ID;

            LRRModes lrrModes = LRRModel.ProjectModes;
            SearchRetrievalUtility searchUtil = new SearchRetrievalUtility();
            LRRSiteComponents lrrSiteComponents = searchUtil.PopulateSiteComponents(searchCriteriaID);

            //Aggregates
            LRRAggregates lrrResultAggregates = searchUtil.PopulateAggregates(searchCriteriaID);

            LRRSearchCriteria lrrSearchCriteria = lrrSrchCriteria;

            string sSource = lrrSearchCriteria.Source == null ? "" : lrrSearchCriteria.Source.ToString(Symcon.BusinessObjects.SymConverter.Culture);

            Type gridType = Type.GetType(lrrSearchCriteria.TemplateClass);
            object gridView = Activator.CreateInstance(gridType);
            GridView = gridView;
            Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory objGrid = gridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;

            LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();
            LRRSiteComponents objModelComponent = LRRModel.SiteComponentsObj;
            LRRSiteComponents objSiteCompCollection = new LRRSiteComponents();
            string qualIDs = "";

            ArrayList custCollection = new ArrayList();
            foreach (LRRSiteComponent objSiteComponent in lrrSiteComponents)
            {
                LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComponent.SiteComponentID);
                objSiteCompCollection.Add(objModelSiteComponent);
            }
            LRRSearchCriteriaPropertyTypes srchPropTypes = _lrrApp.MainFrame.LRRScreenListView.LRRSrchCriteriaPropertyTypes.FilterBySearchCriteriaID(lrrSearchCriteria.ID);
            if (srchPropTypes.Count > 0)
            {
                LRRSearchCriteriaPropertyType srchPropType = srchPropTypes[0];
                LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(srchPropType.PropertyType);
                if (propTypeObj != null && propTypeObj.IsDataArray)
                {
                    LRRPropertyTypes objPropTypes = new LRRPropertyTypes();
                    foreach (LRRSearchCriteriaPropertyType srchCriteriaPropType in srchPropTypes)
                    {
                        LRRPropertyType lrrPropTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(srchCriteriaPropType.PropertyType);
                        objPropTypes.Add(lrrPropTypeObj);
                    }
                    custCollection.Add(objPropTypes);
                    custCollection.Add(objSiteCompCollection);
                }
                else
                {
                    LRRSearchCriteriaQualifiers lrrSrchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();
                    _lrrApp.DBManagerObj.PopulateCollection(lrrSrchCriteriaQualifiers, false);
                    LRRSearchCriteriaQualifiers lrrSrchCriteriaQuals = lrrSrchCriteriaQualifiers.FilterBySearchCriteriaID(searchCriteriaID);
                    foreach (LRRSearchCriteriaQualifier lrrSearchCriteriaQual in lrrSrchCriteriaQuals)
                    {
                        if (qualIDs == "")
                        {
                            qualIDs = "'" + lrrSearchCriteriaQual.QualifierID + "'";
                        }
                        else
                            qualIDs = qualIDs + ",'" + lrrSearchCriteriaQual.QualifierID + "'";

                    }

                    _lrrApp.DBManagerObj.PopulateCollection(objLookUpQualifiers, " WHERE LookupQualifierID IN (" + qualIDs + ")", false);
                    custCollection.Add(objSiteCompCollection);
                    custCollection.Add(objLookUpQualifiers);
                }
            }

            LRRSearchCriteriaItemGroupPropertiesUIUOMs srchCriteriaUIUOMs = null;
            srchCriteriaUIUOMs = new LRRSearchCriteriaItemGroupPropertiesUIUOMs();
            this._lrrApp.DBManagerObj.PopulateCollection(srchCriteriaUIUOMs, " where SearchCriteriaID = '" + searchCriteriaID + "'");

            objGrid.SearchQuery.SearchQuery.ID = lrrSearchCriteria.ID;
            objGrid.SearchQuery.SearchCriteriaItemGroupPropertiesUIUOMs = srchCriteriaUIUOMs;
            objGrid.SearchQuery.SearchQuery.UserSettingsID = lrrSearchCriteria.UserSettingsID;
            objGrid.LoadPanel(custCollection, srchCriteriaUIUOMs);//Change to UIUOMs collection

            //ArrayList arrParams = new ArrayList();
            //arrParams.Add(gridView);
            //_lrrApp.LRRUIManagerObj.ShowWindow(301, arrParams, lrrSearchCriteria.Name, true);
            InitForm(gridView as IGroupGridFactory);
        }

        /// <summary>
        /// Inits the form.
        /// </summary>
        /// <param name="gridView">The grid view.</param>
        public void InitForm(IGroupGridFactory gridView)
        {
            InitializeComponent();
            GridView = gridView;
            ArrayList pnlCollection = gridView.GetPanelCollection();
            SetPanel(pnlCollection);
            gridView.HideModes();
            LRRModel.ProjectModes.ModesChanged += new EventHandler(ProjectModes_ModesChanged);
            this.FormClosing += new FormClosingEventHandler(GroupedPlantPropertiesResultForm_FormClosing);
            //btnExec.Click+=new EventHandler(inOutForm.btnUpdateModel_Click);
        }

        /// <summary>
        /// Handles the FormClosing event of the GroupedPlantPropertiesResultForm control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.FormClosingEventArgs"/> instance containing the event data.</param>
        void GroupedPlantPropertiesResultForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
            if (iGroupGridView != null)
            {
                iGroupGridView.ClearAllBindings();
                iGroupGridView.UnSubscribeReconnectCompleted();
            }
            // Save For Property Values
            LRRSiteGroupPropertyQualifierValues propertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();

            if (propertyQualifierValues.Count > 0)
            {
                DialogResult dlgResult = LRRMessagBox.ShowMessage(this, "SID_SAVE_PROPVALUE", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (dlgResult == DialogResult.Yes)
                {
                    Save();
                }
                else
                {
                    foreach (LRRSiteGroupPropertyQualifierValue propertyQualifierValue in propertyQualifierValues)
                    {
                        LRRSiteComponentProperty objProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propertyQualifierValue.SiteComponentPropID);
                        string groupPropID = LRRModel.SiteComponentGroupPropertiesObj.GetSiteGroupPropID(propertyQualifierValue.SiteComponentPropID, propertyQualifierValue.LookUpPropertiesID);
                        LRRSiteGroupPropertyQualifierValue objPropValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID, propertyQualifierValue.LookUpPropertiesID, propertyQualifierValue.QualifierID, propertyQualifierValue.ModeID);
                        objPropValue.RollBackChanges(true);
                    }
                }
                LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
            }
            if (iGroupGridView != null)
            {
                if (iGroupGridView.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierViewController))
                {
                    if (BGroupedPlantPropertiesResultFormChange == true)
                        BGroupedPlantPropertiesResultFormChange = false;
                }
                else if (iGroupGridView.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayViewController))
                {
                    if (BGroupedPlantPropertiesDataArrayResultFormChange == true)
                        BGroupedPlantPropertiesDataArrayResultFormChange = false;
                }
            }
            

        }

        /// <summary>
        /// Sets the panel.
        /// </summary>
        /// <param name="pnlCollection">The PNL collection.</param>
		private void SetPanel(ArrayList pnlCollection)
		{
			int heightOfEach = panel1.Height/pnlCollection.Count;
			int splitCnt = 0;
			for(int i=pnlCollection.Count-1;i>=0;i--)
			{
				Panel panel = pnlCollection[i] as Panel;
                panel.Name = "GPPanel" + i;
				panel.Height = heightOfEach;
				this.panel1.Controls.Add(panel);
				if(splitCnt < pnlCollection.Count - 1)
				{
					Splitter splitGrid = new Splitter();
					splitGrid.Dock = DockStyle.Top;
					this.panel1.Controls.Add(splitGrid);
					splitCnt++;
				}
			}
			if(this.panel1.Controls.Count > 0)
				this.panel1.Controls[0].Dock = DockStyle.Fill;
		}
		#endregion

		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			if(iGroupGridView != null)
				iGroupGridView.ClearSort();
		}

		public bool SupportsClearSort()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			iGroupGridView.PrintPreview();
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.ShowComponentList implementation
		}

		#endregion

        /// <summary>
        /// Handles the ModesChanged event of the ProjectModes control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void ProjectModes_ModesChanged(object sender, EventArgs e)
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			if(iGroupGridView != null)
				iGroupGridView.HideModes();
		}

		#region Properties
		public object GridView
		{
			get { return _gridView;}
			set
			{
				_gridView = value;
			}
		}
		#endregion

		#region
		private object _gridView;
		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			if(iGroupGridView != null)
				iGroupGridView.LeftColMovement();
		}

		public void RightColMovement()
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			if(iGroupGridView != null)
				iGroupGridView.RightColMovement();
			
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add GroupedPlantPropertiesResultForm.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add GroupedPlantPropertiesResultForm.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		#region ILRRUISpecificContainer Members

		public void ChangeUOMSet()
		{
			IGroupGridFactory iGroupGridView = GridView as IGroupGridFactory;
			if(iGroupGridView != null)
			{
				ChangeUOMSetDefinitionForm chngUOMSetDefn = new ChangeUOMSetDefinitionForm();
				DialogResult dlgResult = chngUOMSetDefn.ShowDialog();
				if(dlgResult == DialogResult.OK  && chngUOMSetDefn.MeasSysID != null)
				{
					iGroupGridView.ChangeUOMSet(chngUOMSetDefn.MeasSysID);
				}
			}
		}

		public bool SupportsChangeUOMSet()
		{
			return true;
		}

		#endregion
	}
}
