using System;
using System.Windows.Forms;
using System.Collections;
using Syncfusion.Windows.Forms.Grid;

using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
	/// <summary>
	/// Summary description for IGroupGridFactory.
	/// </summary>
	public interface IGroupGridFactory
	{
		void LoadPanel(ArrayList custCollection,LRRSearchCriteriaItemGroupPropertiesUIUOMs srchCriteriaUIUOMs);
		ArrayList GetPanelCollection();
		void HideModes();
		void Save(string name,string desc,LRRSearchGroupLevel srchGroupLevel,bool isPublished);
		void Save();
		GroupSearchCriteria SearchQuery {get;set;}
		GridControl Export();
		void Print();
		void PrintPreview();
		void ClearAllBindings();
		void ChangeUOMSet(string measSysID);
		void UnSubscribeReconnectCompleted();
		void ClearSort();
		void LeftColMovement();
		void RightColMovement();
        void HideProperties(ArrayList arrUnSelectedRecords);
        void HideComponents(ArrayList arrUnSelectedRecords);
	}
}
