using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Grouping;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.HeaderDispatcher;
using Symcon.LightRidge.PEAdvisor.IOScreen;

namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
	/// <summary>
	/// Summary description for ResultPropertiesWindow.
	/// </summary>
	public class ResultComponentsWindowGroupProp : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlResultProperties;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridResultProperties;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Button btnApply;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridComponents;
		private System.Windows.Forms.Panel panelLookUpProperties;
		private System.Windows.Forms.Splitter splitterLookupProperties;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridLookUpProperties;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ResultComponentsWindowGroupProp()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			gridComponents.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);   
			gridResultProperties.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);   
			gridLookUpProperties.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp); 
			gridComponents.RecordValueChanged += new RecordValueChangedEventHandler(gridComponents_RecordValueChanged);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ResultComponentsWindowGroupProp));
			this.pnlResultProperties = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.gridComponents = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridResultProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnApply = new System.Windows.Forms.Button();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panelLookUpProperties = new System.Windows.Forms.Panel();
			this.splitterLookupProperties = new System.Windows.Forms.Splitter();
			this.gridLookUpProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlResultProperties.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridComponents)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridResultProperties)).BeginInit();
			this.pnlBottom.SuspendLayout();
			this.panel1.SuspendLayout();
			this.panelLookUpProperties.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridLookUpProperties)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlResultProperties
			// 
			this.pnlResultProperties.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlResultProperties.Controls.Add(this.splitter1);
			this.pnlResultProperties.Controls.Add(this.gridComponents);
			this.pnlResultProperties.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlResultProperties.Location = new System.Drawing.Point(0, 0);
			this.pnlResultProperties.Name = "pnlResultProperties";
			this.pnlResultProperties.Size = new System.Drawing.Size(176, 134);
			this.pnlResultProperties.TabIndex = 0;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 129);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(174, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// gridComponents
			// 
			this.gridComponents.BackColor = System.Drawing.SystemColors.Window;
			this.gridComponents.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridComponents.Location = new System.Drawing.Point(0, 0);
			this.gridComponents.Name = "gridComponents";
			this.gridComponents.Size = new System.Drawing.Size(174, 132);
			this.gridComponents.TabIndex = 0;
			this.gridComponents.Text = "gridGroupingControl1";
			this.gridComponents.VersionInfo = "3.301.0.0";
			this.gridComponents.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridComponents_TableControlQueryAllowSortColumn);
			this.gridComponents.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridComponents_QueryCellStyleInfo);
			this.gridComponents.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridComponents_SaveCellText);
			// 
			// gridResultProperties
			// 
			this.gridResultProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridResultProperties.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridResultProperties.Location = new System.Drawing.Point(0, 0);
			this.gridResultProperties.Name = "gridResultProperties";
			this.gridResultProperties.Size = new System.Drawing.Size(325, 134);
			this.gridResultProperties.TabIndex = 0;
			this.gridResultProperties.Text = "gridGroupingControl1";
			this.gridResultProperties.VersionInfo = "3.301.0.0";
			this.gridResultProperties.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridResultProperties_TableControlQueryAllowSortColumn);
			this.gridResultProperties.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridResultProperties_QueryCellStyleInfo);
			this.gridResultProperties.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridResultProperties_SaveCellText);
			this.gridResultProperties.SizeChanged += new System.EventHandler(this.gridResultProperties_SizeChanged);
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.btnApply);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 134);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(656, 40);
			this.pnlBottom.TabIndex = 1;
			// 
			// btnApply
			// 
			this.btnApply.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnApply.Location = new System.Drawing.Point(560, 8);
			this.btnApply.Name = "btnApply";
			this.btnApply.Size = new System.Drawing.Size(80, 23);
			this.btnApply.TabIndex = 0;
			this.btnApply.Tag = "SID_APPLY";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(176, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 134);
			this.splitter2.TabIndex = 2;
			this.splitter2.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.splitterLookupProperties);
			this.panel1.Controls.Add(this.gridResultProperties);
			this.panel1.Controls.Add(this.panelLookUpProperties);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(179, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(477, 134);
			this.panel1.TabIndex = 3;
			// 
			// panelLookUpProperties
			// 
			this.panelLookUpProperties.Controls.Add(this.gridLookUpProperties);
			this.panelLookUpProperties.Dock = System.Windows.Forms.DockStyle.Right;
			this.panelLookUpProperties.Location = new System.Drawing.Point(325, 0);
			this.panelLookUpProperties.Name = "panelLookUpProperties";
			this.panelLookUpProperties.Size = new System.Drawing.Size(152, 134);
			this.panelLookUpProperties.TabIndex = 1;
			// 
			// splitterLookupProperties
			// 
			this.splitterLookupProperties.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitterLookupProperties.Location = new System.Drawing.Point(322, 0);
			this.splitterLookupProperties.Name = "splitterLookupProperties";
			this.splitterLookupProperties.Size = new System.Drawing.Size(3, 134);
			this.splitterLookupProperties.TabIndex = 2;
			this.splitterLookupProperties.TabStop = false;
			// 
			// gridLookUpProperties
			// 
			this.gridLookUpProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridLookUpProperties.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridLookUpProperties.Location = new System.Drawing.Point(0, 0);
			this.gridLookUpProperties.Name = "gridLookUpProperties";
			this.gridLookUpProperties.Size = new System.Drawing.Size(152, 134);
			this.gridLookUpProperties.TabIndex = 0;
			this.gridLookUpProperties.Text = "gridGroupingControl1";
			this.gridLookUpProperties.VersionInfo = "3.301.0.0";
			this.gridLookUpProperties.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridLookUpProperties_TableControlQueryAllowSortColumn);
			this.gridLookUpProperties.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridLookUpProperties_QueryCellStyleInfo);
			this.gridLookUpProperties.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridLookUpProperties_SaveCellText);
			this.gridLookUpProperties.SizeChanged += new System.EventHandler(this.gridLookUpProperties_SizeChanged);
			// 
			// ResultComponentsWindowDataArray
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(656, 174);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.pnlResultProperties);
			this.Controls.Add(this.pnlBottom);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "ResultComponentsWindowDataArray";
			this.ShowInTaskbar = false;
			this.pnlResultProperties.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridComponents)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridResultProperties)).EndInit();
			this.pnlBottom.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.panelLookUpProperties.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridLookUpProperties)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		LRRSiteComponentProperties _lrrSCPOrignal = new LRRSiteComponentProperties();
        /// <summary>
        /// Binds the SCP on check change.
        /// </summary>
		private void BindSCPOnCheckChange()
		{
			if(_isGroupByPlantItemView)
			{
				if(_lrrSCPOrignal.Count>0)
				{
					_lrrSiteCompProps.Clear();
					foreach(LRRSiteComponentProperty prop in _lrrSCPOrignal)
					{
						_lrrSiteCompProps.Add(prop);
					}
					_lrrSCPOrignal.Clear();
				}
				ArrayList checkedPropertyTypes = new ArrayList();
				LRRSiteComponentProperties lrrSiteCompPropsSelected = new LRRSiteComponentProperties();

				foreach(LRRLookUpQualifier luq in _lrrLookUpQualifiers)
				{
					string propertyTypeID = luq.PropertyID;
					if(!checkedPropertyTypes.Contains(propertyTypeID))
					{
						checkedPropertyTypes.Add(propertyTypeID);
						if(luq.IsSelected)
						{
							LRRSiteComponentProperties filteredProps = new LRRSiteComponentProperties();
							foreach(LRRSiteComponentProperty prop in _lrrSiteCompProps)
							{
								if(prop.Type == propertyTypeID)
									filteredProps.Add(prop);
								if(!_lrrSCPOrignal.Contains(prop))
									_lrrSCPOrignal.Add(prop);
							}
							foreach(LRRSiteComponentProperty prop in filteredProps)
							{
								if(!lrrSiteCompPropsSelected.Contains(prop))
									lrrSiteCompPropsSelected.Add(prop);
							}
						}
						else
						{
							foreach(LRRSiteComponentProperty prop in _lrrSiteCompProps)
							{
								if(!_lrrSCPOrignal.Contains(prop))
									_lrrSCPOrignal.Add(prop);
							}
						}
					}
				}
			
				gridResultProperties.CurrencyManager.List.Clear();
				foreach(LRRSiteComponentProperty lscp in lrrSiteCompPropsSelected)
				{
					gridResultProperties.CurrencyManager.List.Add(lscp);
				}

				//gridResultProperties.TableDescriptor.Columns["Name"].ReadOnly=true;
			}
			/*else
			{
				object[] _ubBoundSelectedComps = _unBoundComp.GetSelectedRecords();
				if(_lrrSCPOrignal.Count>0)
				{
					_lrrSiteCompProps.Clear();
					foreach(LRRSiteComponentProperty prop in _lrrSCPOrignal)
					{
						_lrrSiteCompProps.Add(prop);
					}
					_lrrSCPOrignal.Clear();
				}
				ArrayList checkedPlantItems = new ArrayList();
				LRRSiteComponentProperties lrrSiteCompPropsSelected = new LRRSiteComponentProperties();

				foreach(LRRSiteComponent comp in _lrrSiteComponents)
				{
					string componentID = comp.GetID();
					if(!checkedPlantItems.Contains(componentID))
					{
						checkedPlantItems.Add(componentID);
						
						foreach(LRRSiteComponent compSelected in _ubBoundSelectedComps)
						{
							if(compSelected.GetID() == componentID)
							{
								LRRSiteComponentProperties filteredProps = new LRRSiteComponentProperties();
								foreach(LRRSiteComponentProperty prop in _lrrSiteCompProps)
								{
									if(prop.ComponentID== componentID)
									{
										filteredProps.Add(prop);
									}
									if(!_lrrSCPOrignal.Contains(prop))
										_lrrSCPOrignal.Add(prop);
								}
								foreach(LRRSiteComponentProperty prop in filteredProps)
								{
									if(!lrrSiteCompPropsSelected.Contains(prop))
										lrrSiteCompPropsSelected.Add(prop);
								}
							}
						}
						
					}
				}
				if(_ubBoundSelectedComps.Length == 0)
				{
					foreach(LRRSiteComponentProperty prop in _lrrSiteCompProps)
					{
						if(!_lrrSCPOrignal.Contains(prop))
							_lrrSCPOrignal.Add(prop);
					}
				}
			
				gridResultProperties.CurrencyManager.List.Clear();
				foreach(LRRSiteComponentProperty lscp in lrrSiteCompPropsSelected)
				{
					gridResultProperties.CurrencyManager.List.Add(lscp);
				}

				//gridResultProperties.TableDescriptor.Columns["Name"].ReadOnly=true;
			}*/
		}

        /// <summary>
        /// Binds the grid.
        /// </summary>
		public void BindGrid()
		{
			_isGroupByPlantItemView = _plantItemIDForPlantView != null;
			#region PropGrid
			int col1Width = 0;
			int col2Width = 0;
			if(gridResultProperties.TableDescriptor.Columns.Count == 2)
			{
				col1Width = gridResultProperties.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_SELECT")].Width;
				col2Width = gridResultProperties.TableDescriptor.Columns["Name"].Width;
			}
			//Suspend the Layout of the Grid...
			gridResultProperties.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridResultProperties);

			//Populate the columns for the grid object

			SyncGridUtilities.InitializeGridColumns(gridResultProperties,_lrrSiteCompProps.ItemType,null,true);
			
			this.gridResultProperties.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridResultProperties.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridResultProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridResultProperties.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridResultProperties.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridResultProperties.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridResultProperties.TableDescriptor.AllowNew = false;
			this.gridResultProperties.TableDescriptor.AllowEdit = true;
			this.gridResultProperties.TableDescriptor.AllowRemove = false;

			this.gridResultProperties.SourceListSet.Add("Parent",_lrrSiteCompProps);

			this.gridResultProperties.TableDescriptor.Relations.Clear();
			this.gridResultProperties.DataSource = null;
			this.gridResultProperties.DataSource = PropertyCollection;

			this.gridResultProperties.TableDescriptor.Columns.Clear();
			
			_unBoundProp.WireGrid(gridResultProperties);

			
			GridColumnDescriptor gcd;
			GridTableCellStyleInfo gtcsi;
			gcd = new GridColumnDescriptor();
			gcd.HeaderText = "Name";
			gcd.MappingName = "Name";
			gcd.AllowFilter = true;
			gcd.Width = 250;

			gtcsi = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gtcsi.ReadOnly = true;

			this.gridResultProperties.TableDescriptor.Columns.Add(gcd);
			this.gridResultProperties.TableDescriptor.SortedColumns.Clear();
			this.gridResultProperties.TableDescriptor.SortedColumns.Add("Name",ListSortDirection.Ascending);

			if(col1Width > 0)
				gridResultProperties.TableDescriptor.Columns[0].Width = col1Width;
			if(col2Width > 0)
				gridResultProperties.TableDescriptor.Columns[1].Width = col2Width;
			gridResultProperties.ResumeLayout(true);
			
			#endregion

			#region CompGrid

			if(!_isGroupByPlantItemView)
			{
				int Compcol1Width = 0;
				int Compcol2Width = 0;
				if(gridComponents.TableDescriptor.Columns.Count == 2)
				{
					Compcol1Width = gridComponents.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_SELECT")].Width;
					Compcol2Width = gridComponents.TableDescriptor.Columns["Name"].Width;
				}
				//Suspend the Layout of the Grid...
				gridComponents.SuspendLayout();

				SyncGridUtilities.InitializeGridLookAndFeel(gridComponents);

				//Populate the columns for the grid object
				SyncGridUtilities.InitializeGridColumns(gridComponents,_lrrSiteComponents.ItemType,null,true);
			
				this.gridComponents.Appearance.AnyHeaderCell.Font.Bold = true;
				this.gridComponents.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
				this.gridComponents.BackColor = System.Drawing.SystemColors.Window;
				this.gridComponents.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
				this.gridComponents.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
				this.gridComponents.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
				this.gridComponents.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
					
				this.gridComponents.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_COMP") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
				this.gridComponents.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

				this.gridComponents.TableDescriptor.AllowNew = false;
				this.gridComponents.TableDescriptor.AllowEdit = true;
				this.gridComponents.TableDescriptor.AllowRemove = false;

				if(_isGroupByPlantItemView)
					this.gridComponents.SourceListSet.Add("Parent",_lrrQualifiers);
				else
					this.gridComponents.SourceListSet.Add("Parent",_lrrSiteComponents);

				this.gridComponents.TableDescriptor.Relations.Clear();
				this.gridComponents.DataSource = null;
				
				this.gridComponents.DataSource = SiteComponents;

				this.gridComponents.TableDescriptor.Columns.Clear();
			
				_unBoundComp.WireGrid(gridComponents);

				GridColumnDescriptor gcdComp;
				GridTableCellStyleInfo gtcsiComp;
				gcdComp = new GridColumnDescriptor();
				gcdComp.HeaderText = "Name";
				gcdComp.MappingName = "Name";
				gcdComp.AllowFilter = true;
				gcdComp.Width = 250;

				gtcsiComp = gcdComp.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
				gtcsiComp.ReadOnly = true;

				this.gridComponents.TableDescriptor.Columns.Add(gcdComp);
				this.gridComponents.TableDescriptor.SortedColumns.Clear();
				this.gridComponents.TableDescriptor.SortedColumns.Add("Name",ListSortDirection.Ascending);

				if(Compcol1Width > 0)
					gridComponents.TableDescriptor.Columns[0].Width = Compcol1Width;
				if(Compcol2Width > 0)
					gridComponents.TableDescriptor.Columns[1].Width = Compcol2Width;
				gridComponents.ResumeLayout(true);
			}
			else
			{
				_lrrPropertyTypes.Clear();
				foreach(LRRLookUpQualifier luq in _lrrLookUpQualifiers)
				{
					string propertyType = luq.PropertyID;
					LRRPropertyType propType = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(propertyType);
					if(propType != null)
						if(!_lrrPropertyTypes.Contains(propType))
							_lrrPropertyTypes.Add(propType);
				}
				GridGroupingControl gridQualifiers = gridComponents;

				//Suspend the Layout of the Grid...
				gridQualifiers.SuspendLayout();
				Hashtable columnForDisplay = new Hashtable();
				Hashtable RelativeWidths = new Hashtable();

				SyncGridUtilities.InitializeGridLookAndFeel(gridQualifiers);
			
				columnForDisplay.Add("PropertyType",null);
				gridQualifiers.DataSource = null;
				gridQualifiers.TableDescriptor.Relations.Clear();
				//Initialize the columns for the grid...
				SyncGridUtilities.InitializeGridColumns(gridQualifiers,_lrrPropertyTypes.ItemType,null,true,columnForDisplay);

				gridQualifiers.TableDescriptor.RecordFilters.Clear();
				gridQualifiers.TableDescriptor.AllowNew = false;
				gridQualifiers.TableDescriptor.AllowRemove = true;
				gridQualifiers.TableDescriptor.AllowEdit = true;
				gridQualifiers.TableDescriptor.Relations.Clear();
			
			
				//Add the parent table for the Relations...
				gridQualifiers.Engine.SourceListSet.Add("ParentTable",_lrrPropertyTypes);
			
				//Set the data source for the grid
				gridQualifiers.DataSource = _lrrPropertyTypes;

				//gridQualifiers.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_QUALIFIER")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS") + " For Qualifier - " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(_sSelectedQualifierID).Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				gridQualifiers.TableDescriptor.AllowEdit = false;
				gridQualifiers.TableDescriptor.AllowNew = false;
				gridQualifiers.TableDescriptor.AllowRemove = false;

				//Look up qualifiers
				GridRelationDescriptor grdLookUpQualifiers = new GridRelationDescriptor("Property Based Qualifier(s)");
				grdLookUpQualifiers.ChildTableName = "LookUpQualifiers";
				grdLookUpQualifiers.RelationKeys.Add("ID","PropertyID");
				grdLookUpQualifiers.RelationKind = RelationKind.RelatedMasterDetails;
				grdLookUpQualifiers.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Blue;
				grdLookUpQualifiers.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
				//grdLookUpQualifiers.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PROP_BASED_QUALIFIER")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS") + " For Qualifier - " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(_sSelectedQualifierID).Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				gridQualifiers.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
				grdLookUpQualifiers.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
				gridQualifiers.TableDescriptor.Relations.Add(grdLookUpQualifiers);
				gridQualifiers.NestedTableGroupOptions.ShowFilterBar = false;
				gridQualifiers.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
				gridQualifiers.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
				grdLookUpQualifiers.ChildTableDescriptor.Appearance.AnyCell.ShowButtons=GridShowButtons.Hide;
				gridQualifiers.Engine.SourceListSet.Add("LookUpQualifiers",_lrrLookUpQualifiers);

				Hashtable columnForChildTable = new Hashtable();
				columnForChildTable.Add("QualifierID",null);
				columnForChildTable.Add("IsSelected",null);

				RelativeWidths.Add("IsSelected",5);
				RelativeWidths.Add("Name",40);

				SyncGridUtilities.InitializeGridColumns(gridQualifiers,grdLookUpQualifiers.ChildTableDescriptor,_lrrLookUpQualifiers.ItemType,RelativeWidths,false,null,columnForChildTable,true);
				grdLookUpQualifiers.ChildTableDescriptor.Columns[grdLookUpQualifiers.ChildTableDescriptor.Columns.IndexOf("QualifierID_Name")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
				grdLookUpQualifiers.ChildTableDescriptor.Columns[grdLookUpQualifiers.ChildTableDescriptor.Columns.IndexOf("QualifierID_Name")].Appearance.AnyRecordFieldCell.ReadOnly = true;
				gridQualifiers.ResumeLayout(false);
			}

			#endregion

			#region LookUpPropGrid

			int LUPcol1Width = 0;
			int LUPcol2Width = 0;
			if(gridLookUpProperties.TableDescriptor.Columns.Count == 2)
			{
				LUPcol1Width = gridLookUpProperties.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_SELECT")].Width;
				LUPcol2Width = gridLookUpProperties.TableDescriptor.Columns["Name"].Width;
			}
			//Suspend the Layout of the Grid...
			gridLookUpProperties.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridLookUpProperties);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridLookUpProperties,_lookUpProperties.ItemType,null,true);
			
			this.gridLookUpProperties.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridLookUpProperties.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridLookUpProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridLookUpProperties.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridLookUpProperties.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridLookUpProperties.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridLookUpProperties.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridLookUpProperties.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_GROUPPROPERTY") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridLookUpProperties.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridLookUpProperties.TableDescriptor.AllowNew = false;
			this.gridLookUpProperties.TableDescriptor.AllowEdit = true;
			this.gridLookUpProperties.TableDescriptor.AllowRemove = false;

			this.gridLookUpProperties.SourceListSet.Add("Parent",_lookUpProperties);

			this.gridLookUpProperties.TableDescriptor.Relations.Clear();
			this.gridLookUpProperties.DataSource = null;
			this.gridLookUpProperties.DataSource = LookUpProperties;

			this.gridLookUpProperties.TableDescriptor.Columns.Clear();
			
			_unBoundLookUpProp.WireGrid(gridLookUpProperties);

			GridColumnDescriptor gcdLUP;
			GridTableCellStyleInfo gtcsiLUP;
			gcdLUP = new GridColumnDescriptor();
			gcdLUP.HeaderText = "Name";
			gcdLUP.MappingName = "Name";
			gcdLUP.AllowFilter = true;
			gcdLUP.Width = 250;

			gtcsiLUP = gcdLUP.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gtcsiLUP.ReadOnly = true;

			this.gridLookUpProperties.TableDescriptor.Columns.Add(gcdLUP);
			this.gridLookUpProperties.TableDescriptor.SortedColumns.Clear();
			this.gridLookUpProperties.TableDescriptor.SortedColumns.Add("Name",ListSortDirection.Ascending);

			if(LUPcol1Width > 0)
				gridLookUpProperties.TableDescriptor.Columns[0].Width = LUPcol1Width;
			if(LUPcol2Width > 0)
				gridLookUpProperties.TableDescriptor.Columns[1].Width = LUPcol2Width;
			gridLookUpProperties.ResumeLayout(true);

			#endregion


		}

		protected override void OnClosing(CancelEventArgs e)
		{
			e.Cancel = true;
			_isWindowOpen = false;
			this.Hide();
		}

		#endregion

		#region Fields
		private LRRSiteComponentProperties _lrrSiteCompProps = new LRRSiteComponentProperties(); 
		private LRRSiteComponents   _lrrSiteComponents = new LRRSiteComponents();
		private LRRLookUpQualifiers   _lrrLookUpQualifiers = new LRRLookUpQualifiers();
		private LRRQualifiers   _lrrQualifiers = new LRRQualifiers();
		private LRRLookUpProperties _lookUpProperties = new LRRLookUpProperties();
		private GridUnBoundColumn	_unBoundProp=new GridUnBoundColumn();
		private GridUnBoundColumn	_unBoundLookUpProp=new GridUnBoundColumn();
		private GridUnBoundColumn	_unBoundComp=new GridUnBoundColumn();
		private ArrayList			_unSelectedRecords = new ArrayList();
		private ArrayList			_selectedRecords = new ArrayList();
		private string _lookUpQualifierIDForQualView = null;
		private string _plantItemIDForPlantView = null;
		private bool _isGroupByPlantItemView = false;

		private bool				_isWindowOpen;
		private LRRPropertyTypes		_lrrPropertyTypes = new LRRPropertyTypes();
		#endregion

		#region Events

		public event SelectedPropertiesChanged		RecordedProperties;

		#endregion

		#region Properties

		public string LookUpQualifierIDForQualView
		{
			get{return _lookUpQualifierIDForQualView;}
			set
			{
				_lookUpQualifierIDForQualView = value;
			}
		}

		public string PlantItemIDForPlantView
		{
			get{return _plantItemIDForPlantView;}
			set
			{
				_plantItemIDForPlantView = value;
			}
		}

		public LRRSiteComponentProperties PropertyCollection
		{
			get{return _lrrSiteCompProps;}
			set
			{
				_lrrSiteCompProps = value;
			}
		}

		public LRRSiteComponents SiteComponents
		{
			get{return _lrrSiteComponents;}
			set
			{
				_lrrSiteComponents = value;
			}
		}

		public LRRLookUpQualifiers LookUpQualifiers
		{
			get{return _lrrLookUpQualifiers;}
			set
			{
				_lrrLookUpQualifiers = value;
			}
		}

		public LRRQualifiers Qualifiers
		{
			get{return _lrrQualifiers;}
			set
			{
				_lrrQualifiers = value;
			}
		}

		public LRRLookUpProperties LookUpProperties
		{
			get 
			{
				return _lookUpProperties;
			}
			set
			{
				_lookUpProperties = value;
			}
		}

		public ArrayList UnSelectedRecords
		{
			get{return _unSelectedRecords;}
			set
			{
				_unSelectedRecords = value;
			}
		}

		public ArrayList SelectedRecords
		{
			get{return _selectedRecords;}
			set
			{
				_selectedRecords = value;
			}
		}

		public bool IsWindowOpen 
		{
			get{ return _isWindowOpen;}
			set
			{
				_isWindowOpen = value;
			}
		}

		#endregion
        /// <summary>
        /// Handles the Click event of the btnApply control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnApply_Click(object sender, System.EventArgs e)
		{
			ArrayList arrSelectedPropRecordID = new ArrayList();
			ArrayList arrSelectedSiteComp = new ArrayList();
			ArrayList arrSelectedLookUpProperties = new ArrayList();
			ArrayList arrUnSelectedLookUpProperties = new ArrayList();
			 
			object[] selectedPropRecord = _unBoundProp.GetSelectedRecords(); 
			for(int i=0; i < selectedPropRecord.Length;i++)
			{
				LRRSiteComponentProperty lrrSiteCompProp = selectedPropRecord[i] as LRRSiteComponentProperty;
				if(lrrSiteCompProp != null)
				{
					arrSelectedPropRecordID.Add(lrrSiteCompProp.PropertyID);
				}
			}
			
			object[] selectedCompRecord = _unBoundComp.GetSelectedRecords();
			if(!_isGroupByPlantItemView)
			{
				for(int i = 0;i< selectedCompRecord.Length ; i++)
				{
					LRRSiteComponent lsc = selectedCompRecord[i] as LRRSiteComponent; 
					if(lsc != null)
					{
						arrSelectedSiteComp.Add(lsc);
					}
					
				}
			}
			else
			{
				foreach(LRRLookUpQualifier luq in _lrrLookUpQualifiers)
				{
					if(luq.IsSelected)
					{
						if(!arrSelectedSiteComp.Contains(luq))
							arrSelectedSiteComp.Add(luq);
					}
				}
			}
			object[] selectedLookUpPropRecord = _unBoundLookUpProp.GetSelectedRecords();
			for(int i = 0;i< selectedLookUpPropRecord.Length ; i++)
			{
				LRRLookUpProperty lup = selectedLookUpPropRecord[i] as LRRLookUpProperty; 
				if(lup != null)
				{
					arrSelectedLookUpProperties.Add(lup.LookUpPropertiesID);
				}
			}

			object[] unSelectedLookUpPropRecord = _unBoundLookUpProp.GetUnSelectedRecords();
			for(int i = 0;i< unSelectedLookUpPropRecord.Length ; i++)
			{
				LRRLookUpProperty lup = unSelectedLookUpPropRecord[i] as LRRLookUpProperty; 
				if(lup != null)
				{
					arrUnSelectedLookUpProperties.Add(lup.LookUpPropertiesID);
				}
			}

			RecordingEventArgsGroupProperties recordingEvents = new RecordingEventArgsGroupProperties();
			if(_isGroupByPlantItemView)
			{
				recordingEvents.SelectedLookUpQualifiers = arrSelectedSiteComp;
			}
			else
				(recordingEvents as RecordingEventArgs).SelectedSiteComponents = arrSelectedSiteComp;
			(recordingEvents as RecordingEventArgs).SelectedProperties = arrSelectedPropRecordID;
			recordingEvents.SelectedLookUpProperties = arrSelectedLookUpProperties;
			recordingEvents.UnSelectedLookUpProperties = arrUnSelectedLookUpProperties;
			if(_isGroupByPlantItemView)
				recordingEvents.SiteCompIDForPlantView = PlantItemIDForPlantView;
			else
				recordingEvents.LookUpQualifierIDForQualView = LookUpQualifierIDForQualView;

			if(this.RecordedProperties!=null)
				this.RecordedProperties(recordingEvents);
			this.Close();
		}
		int rowProp, colProp;
		bool PropCheckBoxValue = false;
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridResultProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
		private void gridResultProperties_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex(LRRHeaderText.GetHeaderString("SID_SELECT"), out rowProp , out colProp);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == colProp +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = PropCheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

		private void gridResultProperties_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == LRRHeaderText.GetHeaderString("SID_SELECT"))
			{
				e.AllowSort = false;
			}
		}

        /// <summary>
        /// Handles the SaveCellText event of the gridResultProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
		private void gridResultProperties_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.PropCheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lrrSiteCompProps.GetEnumerator(); 
				ArrayList selectedRecords = new ArrayList(); 
				while(iEnum.MoveNext())
				{
					LRRSiteComponentProperty ComponentProperty = iEnum.Current as LRRSiteComponentProperty; 
					if(ComponentProperty != null)
						selectedRecords.Add(ComponentProperty);  
				}
				object[] propObjSelectedRecords =new object[selectedRecords.Count];
				for(int i=0;i<selectedRecords.Count;i++)
				{
					propObjSelectedRecords[i] = selectedRecords[i];
				}
				_unBoundProp.SetSelectedRecords(propObjSelectedRecords,PropCheckBoxValue);  
				gridResultProperties.Refresh();  		
				e.Handled = true;
			}
			else
			{
				if(!bool.Parse(e.Text))
				{
					this.PropCheckBoxValue = false;
					gridResultProperties.Refresh();  		
				}
				else
				{
					object[] objSelRecords = _unBoundProp.GetSelectedRecords();
					int noOfCheckedItems = objSelRecords.Length;
					if(_lrrSiteCompProps.Count == noOfCheckedItems + 1)
					{
						this.PropCheckBoxValue = true;
						gridResultProperties.Refresh(); 
					}
				}
			}
		}
		public delegate void SelectedPropertiesChanged(RecordingEventArgsGroupProperties e);

        /// <summary>
        /// Handles the MouseUp event of the TableControl control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
		private void TableControl_MouseUp(object sender, MouseEventArgs e)
		{
			
            GridTableControl gridTableControl = sender as GridTableControl;
			if(gridTableControl.TableDescriptor.Name == "LRRSiteComponentProperties")
			{
				int rowProp, colProp;
				GridTableControl gtcProp = this.gridResultProperties.TableControl;  
				gtcProp.PointToRowCol(new Point(e.X, e.Y), out rowProp, out colProp);
				GridTableCellStyleInfo styleProp = gtcProp.Model[rowProp, colProp];

				IMouseController controller;
				gtcProp.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

				if(controller != null && controller.Name == "DragGroupHeader" && styleProp.CellType == "CheckBox")
				{
					gtcProp.GetCellRenderer(rowProp, colProp).RaiseMouseUp(rowProp, colProp, e);
				}
			}
			else if(gridTableControl.TableDescriptor.Name == "LRRSiteComponents")
			{
				int rowComp, colComp;
				GridTableControl gtcComp = this.gridComponents.TableControl;  
				gtcComp.PointToRowCol(new Point(e.X, e.Y), out rowComp, out colComp);
				GridTableCellStyleInfo styleComp = gtcComp.Model[rowComp, colComp];

				IMouseController controller;
				gtcComp.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

				if(controller != null && controller.Name == "DragGroupHeader" && styleComp.CellType == "CheckBox")
				{
					gtcComp.GetCellRenderer(rowComp, colComp).RaiseMouseUp(rowComp, colComp, e);
				}
			}
			else if(gridTableControl.TableDescriptor.Name == "LRRLookUpProperties")
			{
				int rowLUP, colLUP;
				GridTableControl gtcComp = this.gridLookUpProperties.TableControl;  
				gtcComp.PointToRowCol(new Point(e.X, e.Y), out rowLUP, out colLUP);
				GridTableCellStyleInfo styleComp = gtcComp.Model[rowLUP, colLUP];

				IMouseController controller;
				gtcComp.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

				if(controller != null && controller.Name == "DragGroupHeader" && styleComp.CellType == "CheckBox")
				{
					gtcComp.GetCellRenderer(rowLUP, colLUP).RaiseMouseUp(rowLUP, colLUP, e);
				}
			}

		}

        /// <summary>
        /// Handles the SizeChanged event of the gridResultProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gridResultProperties_SizeChanged(object sender, System.EventArgs e)
		{
			int totalColsWidth = 0;
			
			foreach(GridColumnDescriptor gcd in this.gridResultProperties.TableDescriptor.Columns)
			{
				totalColsWidth += gcd.Width;
			}

			float nPercent = (float)(this.gridResultProperties.Width - (3 + 2*(new VScrollBar()).Width))/(float)totalColsWidth;

			foreach(GridColumnDescriptor gcd in this.gridResultProperties.TableDescriptor.Columns)
			{
				gcd.Width = (int)(gcd.Width * nPercent + 0.5);
				if(gcd.Width == 0)
					gcd.Width = 1;
			}
		}

        bool CompCheclBoxValue = false;
		int rowComp,colComp;
		private void gridComponents_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == LRRHeaderText.GetHeaderString("SID_SELECT"))
			{
				e.AllowSort = false;
			}
		}

		int rowLookUpProp, colLookUpProp;
		bool LookUpPropCheckBoxValue = false;
		private void gridComponents_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex(LRRHeaderText.GetHeaderString("SID_SELECT"), out rowComp , out colComp);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == colComp +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = CompCheclBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

        /// <summary>
        /// Handles the SaveCellText event of the gridComponents control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
		private void gridComponents_SaveCellText(object sender, GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.CompCheclBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lrrSiteComponents.GetEnumerator(); 
				ArrayList selectedRecords = new ArrayList(); 
				while(iEnum.MoveNext())
				{
					LRRSiteComponent lscp  = iEnum.Current as LRRSiteComponent; 
					if(lscp != null)
						selectedRecords.Add(lscp);
					LRRLookUpQualifier luq = iEnum.Current as LRRLookUpQualifier;
					if(luq != null)
						selectedRecords.Add(lscp);
				}
				object[] compObjSelectedRecords =new object[selectedRecords.Count];
				for(int i=0;i<selectedRecords.Count;i++)
				{
					compObjSelectedRecords[i] = selectedRecords[i];
				}
				_unBoundComp.SetSelectedRecords(compObjSelectedRecords,CompCheclBoxValue);  
				gridComponents.Refresh(); 
 			   if(_isGroupByPlantItemView)
				   BindSCPOnCheckChange();
				e.Handled = true;
			}
		}

        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridLookUpProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
		private void gridLookUpProperties_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex(LRRHeaderText.GetHeaderString("SID_SELECT"), out rowLookUpProp , out colLookUpProp);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == colLookUpProp +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = LookUpPropCheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

        /// <summary>
        /// Handles the SaveCellText event of the gridLookUpProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
		private void gridLookUpProperties_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.LookUpPropCheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lookUpProperties.GetEnumerator(); 
				ArrayList selectedRecords = new ArrayList(); 
				while(iEnum.MoveNext())
				{
					LRRLookUpProperty LookUpProperty = iEnum.Current as LRRLookUpProperty; 
					if(LookUpProperty != null)
						selectedRecords.Add(LookUpProperty);  
				}
				object[] lookUpPropObjSelectedRecords =new object[selectedRecords.Count];
				for(int i=0;i<selectedRecords.Count;i++)
				{
					lookUpPropObjSelectedRecords[i] = selectedRecords[i];
				}
				_unBoundLookUpProp.SetSelectedRecords(lookUpPropObjSelectedRecords,LookUpPropCheckBoxValue);  
				gridLookUpProperties.Refresh();  		
				e.Handled = true;
			}
			else
			{
				if(!bool.Parse(e.Text))
				{
					this.LookUpPropCheckBoxValue = false;
					gridResultProperties.Refresh();  		
				}
				else
				{
					object[] objSelRecords = _unBoundLookUpProp.GetSelectedRecords();
					int noOfCheckedItems = objSelRecords.Length;
					if(_lookUpProperties.Count == noOfCheckedItems + 1)
					{
						this.LookUpPropCheckBoxValue = true;
						gridLookUpProperties.Refresh(); 
					}
				}
			}
		}

        /// <summary>
        /// Handles the SizeChanged event of the gridLookUpProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gridLookUpProperties_SizeChanged(object sender, System.EventArgs e)
		{
			int totalColsWidth = 0;
			
			foreach(GridColumnDescriptor gcd in this.gridLookUpProperties.TableDescriptor.Columns)
			{
				totalColsWidth += gcd.Width;
			}

			float nPercent = (float)(this.gridLookUpProperties.Width - (3 + 2*(new VScrollBar()).Width))/(float)totalColsWidth;

			foreach(GridColumnDescriptor gcd in this.gridLookUpProperties.TableDescriptor.Columns)
			{
				gcd.Width = (int)(gcd.Width * nPercent + 0.5);
				if(gcd.Width == 0)
					gcd.Width = 1;
			}
		}

        /// <summary>
        /// Handles the TableControlQueryAllowSortColumn event of the gridLookUpProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs"/> instance containing the event data.</param>
		private void gridLookUpProperties_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == LRRHeaderText.GetHeaderString("SID_SELECT"))
			{
				e.AllowSort = false;
			}
		}

        /// <summary>
        /// Handles the RecordValueChanged event of the gridComponents control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Grouping.RecordValueChangedEventArgs"/> instance containing the event data.</param>
		private void gridComponents_RecordValueChanged(object sender, RecordValueChangedEventArgs e)
		{
			BindSCPOnCheckChange();
		}
	}
}
