using System;
using System.Collections;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor
{
    /// <summary>
    /// Summary description for GroupedPropertiesUtility.
    /// </summary>
    public class GroupedPropertiesUtility
    {
        private LRRApp _app;

        //--Constructor
        public GroupedPropertiesUtility()
        {
            _app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

        }

        public void UpdateSiteComponentsLookUpProperties(string sMasterPropertyID)
        {
            //Cannot pick from model as new property if added will not be reflected.
            LRRMasterProperties objMasterProperties = new LRRMasterProperties();
            _app.DBManagerObj.PopulateCollection(objMasterProperties, " WHERE PropertyID in (" + sMasterPropertyID + ")", false);

            LRRSiteComponentProperties objSiteComponentProps = new LRRSiteComponentProperties();
            LRRSiteComponentProperties objSiteComponentPropsByProp = new LRRSiteComponentProperties();
            _app.DBManagerObj.PopulateCollection(objSiteComponentProps, " WHERE PropertyID in (" + sMasterPropertyID + ")", false);

            LRRGroupProperties objMasterGrpedProperties = new LRRGroupProperties();
            _app.DBManagerObj.PopulateCollection(objMasterGrpedProperties, " WHERE MasterPropertyID  in (" + sMasterPropertyID + ")", false);

            LRRSiteComponentGroupProperties groupProperties = new LRRSiteComponentGroupProperties();
            _app.DBManagerObj.PopulateCollection(groupProperties, " WHERE MasterPropID in (" + sMasterPropertyID + ")", false);
            //_app.DBManagerObj.PopulateCollection(groupProperties,false);

            LRRSiteGroupPropertyQualifierValues groupPropertyQualifierValues = new LRRSiteGroupPropertyQualifierValues();
            _app.DBManagerObj.PopulateCollection(groupPropertyQualifierValues, " WHERE MasterPropID in (" + sMasterPropertyID + ")", false);
            //_app.DBManagerObj.PopulateCollection(groupPropertyQualifierValues,false);

            ArrayList arrGroupedProps = new ArrayList();
            ArrayList arrGroupedPropsDel = new ArrayList();
            ArrayList arrAddGroupedPropQualifierValues = new ArrayList();
            ArrayList arrDelGroupedPropQualifierValues = new ArrayList();

            //--Update site component property with the group type
            foreach (LRRMasterProperty objMasterProp in objMasterProperties)
            {
                objSiteComponentPropsByProp = objSiteComponentProps.FilterPropertiesByPropertyID(objMasterProp.PropID);
                //objSiteComponentProps.ItemFilter = "PropertyID = " + objMasterProp.PropID;
                foreach (LRRSiteComponentProperty objSiteCompProp in objSiteComponentPropsByProp)
                {
                    objSiteCompProp.Type = objMasterProp.Type;

                    //--for each site component property get the grouped properties
                    string sSiteCompPropID = objSiteCompProp.ID == null ? "" : objSiteCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    LRRSiteComponentGroupProperties groupPropertiesForSiteCompProp = groupProperties.GetSiteCompGroupPropFromSiteCompPropID(sSiteCompPropID);

                    //Delete existing Site Component grouped Properties
                    foreach (LRRSiteComponentGroupProperty groupProperty in groupPropertiesForSiteCompProp)
                    {
                        if (!arrGroupedPropsDel.Contains(groupProperty))
                            arrGroupedPropsDel.Add(groupProperty);

                        //						string sGroupPropertyID = groupProperty.GroupPropertyID == null ? "" : groupProperty.GroupPropertyID.ToString();
                        //						LRRSiteGroupPropertyQualifierValues lscgpqvs = groupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID);
                        //						foreach(LRRSiteGroupPropertyQualifierValue objQualifierVal in lscgpqvs)
                        //						{
                        //							if(!arrDelGroupedPropQualifierValues.Contains(objQualifierVal))
                        //								arrDelGroupedPropQualifierValues.Add(objQualifierVal);
                        //						}
                    }

                    objMasterGrpedProperties.ItemFilter = "MasterPropertyID = '" + objMasterProp.PropID + "'";

                    //Inserts in SiteComponentGroupProperty`
                    foreach (LRRGroupProperty objMasterGrpedProperty in objMasterGrpedProperties)
                    {
                        LRRSiteComponentGroupProperty grpProp = new LRRSiteComponentGroupProperty();
                        grpProp.SiteComponentPropID = objSiteCompProp.ID;
                        grpProp.AttributeName = objMasterGrpedProperty.AttributeName;
                        grpProp.AttributeDescription = objMasterGrpedProperty.AttributeDescription;
                        grpProp.PropertyID = objMasterGrpedProperty.PropertyID;
                        grpProp.LookUpPropertiesID = objMasterGrpedProperty.LookUpPropertiesID;
                        grpProp.UOMTypeID = objSiteCompProp.UOMTypeID;
                        grpProp.ModeID = objSiteCompProp.ModeID;
                        grpProp.MasterPropID = objSiteCompProp.PropertyID;
                        if (!arrGroupedProps.Contains(grpProp))
                            arrGroupedProps.Add(grpProp);
                    }
                    objMasterGrpedProperties.ItemFilter = "";
                }
                objSiteComponentProps.ItemFilter = "";
            }
            if (objSiteComponentProps.GetChanges().Count > 0)
            {
                LRRSiteComponentProperties toSaveSiteComponentProperties = objSiteComponentProps.GetChanges();
                _app.DBManagerObj.CommitCollection(toSaveSiteComponentProperties);
            }

            //Remove SiteComponentGroupPropertyQualifiers
            for (int i = 0; i < arrDelGroupedPropQualifierValues.Count; i++)
            {
                LRRSiteGroupPropertyQualifierValue siteGrpPropQualifier = arrDelGroupedPropQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
                groupPropertyQualifierValues.Remove(siteGrpPropQualifier);
            }

            //Save SiteComponentGroupPropertyQualifiers
            if (groupPropertyQualifierValues.GetChanges().Count > 0)
            {
                LRRSiteGroupPropertyQualifierValues toSaveGroupPropertyQualifierValues = groupPropertyQualifierValues.GetChanges();
                _app.DBManagerObj.CommitCollection(toSaveGroupPropertyQualifierValues);
            }

            //Remove
            for (int i = 0; i < arrGroupedPropsDel.Count; i++)
            {
                LRRSiteComponentGroupProperty siteCompGrpProp = arrGroupedPropsDel[i] as LRRSiteComponentGroupProperty;
                groupProperties.Remove(siteCompGrpProp);
            }

            //Insert
            for (int i = 0; i < arrGroupedProps.Count; i++)
            {
                LRRSiteComponentGroupProperty siteCompGrpProp = arrGroupedProps[i] as LRRSiteComponentGroupProperty;
                groupProperties.Add(siteCompGrpProp);
            }

            //Save
            if (groupProperties.GetChanges().Count > 0)
            {
                LRRSiteComponentGroupProperties toSaveSiteComponentGroupProperties = groupProperties.GetChanges();
                _app.DBManagerObj.CommitCollection(toSaveSiteComponentGroupProperties);
            }

            //--Update site component property with the group type
            foreach (LRRMasterProperty objMasterProp in objMasterProperties)
            {
                objSiteComponentPropsByProp = objSiteComponentProps.FilterPropertiesByPropertyID(objMasterProp.PropID);
                foreach (LRRSiteComponentProperty objSiteCompProp in objSiteComponentPropsByProp)
                //				objSiteComponentProps.ItemFilter = "PropertyID = " + objMasterProp.PropID;
                //				foreach(LRRSiteComponentProperty objSiteCompProp in objSiteComponentProps)
                {
                    //objSiteCompProp.Type = objMasterProp.Type;

                    //--for each site component property get the grouped properties
                    string sSiteCompPropID = objSiteCompProp.ID == null ? "" : objSiteCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    LRRSiteComponentGroupProperties groupPropertiesForSiteCompProp = groupProperties.GetSiteCompGroupPropFromSiteCompPropID(sSiteCompPropID);

                    //Delete existing Site Component grouped Properties
                    foreach (LRRSiteComponentGroupProperty lscgp in groupPropertiesForSiteCompProp)
                    {
                        LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();
                        string sGrpType = objSiteCompProp.Type == null ? "" : objSiteCompProp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        _app.DBManagerObj.PopulateCollection(objQualifiersForGrpType, " WHERE PropertyID = '" + sGrpType + "'", false);

                        foreach (LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
                        {
                            if (lscgp.ModeID)
                            {
                                for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                {
                                    LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
                                    LRRSiteGroupPropertyQualifierValue lscgpq = new LRRSiteGroupPropertyQualifierValue();
                                    lscgpq.GroupPropertyID = lscgp.GroupPropertyID;
                                    lscgpq.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
                                    lscgpq.PropertyID = lscgp.PropertyID;
                                    lscgpq.LookUpPropertiesID = lscgp.LookUpPropertiesID;
                                    lscgpq.QualifierID = objQualifierForGrpType.QualifierID;
                                    lscgpq.ModeID = objMode.ModeId;
                                    lscgpq.MasterPropID = lscgp.MasterPropID;
                                    arrAddGroupedPropQualifierValues.Add(lscgpq);
                                }
                            }
                            else
                            {
                                LRRSiteGroupPropertyQualifierValue lscgpq = new LRRSiteGroupPropertyQualifierValue();
                                lscgpq.ModeID = "0";
                                lscgpq.GroupPropertyID = lscgp.GroupPropertyID;
                                lscgpq.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
                                lscgpq.PropertyID = lscgp.PropertyID;
                                lscgpq.LookUpPropertiesID = lscgp.LookUpPropertiesID;
                                lscgpq.QualifierID = objQualifierForGrpType.QualifierID;
                                lscgpq.MasterPropID = lscgp.MasterPropID;
                                arrAddGroupedPropQualifierValues.Add(lscgpq);
                            }
                        }
                    }
                }
                objSiteComponentProps.ItemFilter = "";
            }

            //Insert SiteComponentGroupPropertyQualifiers
            for (int i = 0; i < arrAddGroupedPropQualifierValues.Count; i++)
            {
                LRRSiteGroupPropertyQualifierValue siteGrpPropQualifier = arrAddGroupedPropQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
                groupPropertyQualifierValues.Add(siteGrpPropQualifier);
            }

            //Save SiteComponentGroupPropertyQualifiers
            if (groupPropertyQualifierValues.GetChanges().Count > 0)
            {
                LRRSiteGroupPropertyQualifierValues toSaveGroupPropertyQualifierValues = groupPropertyQualifierValues.GetChanges();
                _app.DBManagerObj.CommitCollection(toSaveGroupPropertyQualifierValues);
            }

        }


        public void UpdateGroupedPropertiesByPropertyType(string sPropertyTypeID)
        {
            ArrayList arrAddGroupedPropQualifierValues = new ArrayList();
            LRRSiteGroupPropertyQualifierValues qValues = new LRRSiteGroupPropertyQualifierValues();
            LRRSiteComponents lscs = LRRModel.SiteComponentsObj.FilterSiteComponentsByPropertyType(sPropertyTypeID);
            LRRModel.UpdateGroupPropsForQualifiers(sPropertyTypeID, out arrAddGroupedPropQualifierValues);
            for (int i = 0; i < arrAddGroupedPropQualifierValues.Count; i++)
            {
                LRRSiteGroupPropertyQualifierValue qValue = arrAddGroupedPropQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
                qValues.Add(qValue);
                LRRModel.SiteGroupPropertyQualifierValuesObj.Add(qValue);
                foreach (LRRSiteComponent lsc in lscs)
                {
                    LRRSiteComponentProperties lscps = lsc.Properties;
                    foreach (LRRSiteComponentProperty lscp in lscps)
                    {
                        LRRSiteComponentGroupProperties lscgps = lscp.GroupPpties;
                        foreach (LRRSiteComponentGroupProperty lscgp in lscgps)
                        {
                            lscgp.GroupPptiesQualifierValues.Add(qValue);
                        }
                    }
                }
            }
            _app.DBManagerObj.ExecuteBatchInsert(qValues);
            LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();

            #region Commented by Vihar to propogate changes from Model.

            /*LRRSiteComponentProperties objCompleteSiteComponentProps = new LRRSiteComponentProperties();
			_app.DBManagerObj.PopulateCollection(objCompleteSiteComponentProps," WHERE Type = '" + sPropertyTypeID + "'",false);
			

			LRRSiteComponentGroupProperties groupProperties = new LRRSiteComponentGroupProperties();
			_app.DBManagerObj.PopulateCollection(groupProperties," WHERE PropertyID = '" + sPropertyTypeID + "'",false);
			
			LRRSiteGroupPropertyQualifierValues groupPropertyQualifierValues  = new LRRSiteGroupPropertyQualifierValues();
			_app.DBManagerObj.PopulateCollection(groupPropertyQualifierValues," WHERE PropertyID = '" + sPropertyTypeID + "'",false);


			LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(objLookUpQualifiers," WHERE PropertyID = '" + sPropertyTypeID + "'",false);
			
			//--get the site component properties with the group type
			foreach(LRRSiteComponentProperty objSiteCompProp in objCompleteSiteComponentProps)
			{
				//--for each site component property get the grouped properties
				string sSiteCompPropID = objSiteCompProp.ID == null ? "" : objSiteCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				LRRSiteComponentGroupProperties groupPropertiesForSiteCompProp =groupProperties.GetSiteCompGroupPropFromSiteCompPropID(sSiteCompPropID);

				//For the existing Site Component grouped Properties
				foreach(LRRSiteComponentGroupProperty groupProperty in groupPropertiesForSiteCompProp)
				{
					string sGroupPropertyID = groupProperty.GroupPropertyID == null ? "" : groupProperty.GroupPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					//groupPropertyQualifierValues = groupProperty.GroupPptiesQualifierValues;
					LRRSiteGroupPropertyQualifierValues lscgpqvs = groupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID);
					
					LRRLookUpQualifiers	lkupQuals = objLookUpQualifiers.getLookUpQualifiersForPropType(sPropertyTypeID);

					foreach(LRRLookUpQualifier	lkupQual in lkupQuals)
					{
						bool bMatchFound = false;
						string sLkupQualID = lkupQual.LookUpQualifierID == null ? "" : lkupQual.LookUpQualifierID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

						if(lscgpqvs.GetGroupQualifierValuesFromLkupQualID(sLkupQualID).Count>0)
							bMatchFound = true;
						
						if(!bMatchFound)
						{
							if(groupProperty.ModeID)
							{
								for(int i=0;i < LRRModel.ProjectModes.Count;i++)
								{
									LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
									if(objMode.ModeId != "0")
									{
										LRRSiteGroupPropertyQualifierValue lscgpq = new LRRSiteGroupPropertyQualifierValue();
										lscgpq.GroupPropertyID = groupProperty.GroupPropertyID;
										lscgpq.LookUpQualifierID = lkupQual.LookUpQualifierID;
										lscgpq.PropertyID = groupProperty.PropertyID;
										lscgpq.LookUpPropertiesID = groupProperty.LookUpPropertiesID;
										lscgpq.QualifierID = lkupQual.QualifierID;
										lscgpq.ModeID = objMode.ModeId;
										lscgpq.MasterPropID =groupProperty.MasterPropID;
										arrAddGroupedPropQualifierValues.Add(lscgpq);
									}
								}
							}
							else
							{
								LRRSiteGroupPropertyQualifierValue lscgpq = new LRRSiteGroupPropertyQualifierValue();
								lscgpq.ModeID = "0";
								lscgpq.GroupPropertyID = groupProperty.GroupPropertyID;
								lscgpq.LookUpQualifierID = lkupQual.LookUpQualifierID;
								lscgpq.PropertyID = groupProperty.PropertyID;
								lscgpq.LookUpPropertiesID = groupProperty.LookUpPropertiesID;
								lscgpq.QualifierID = lkupQual.QualifierID;
								lscgpq.MasterPropID =groupProperty.MasterPropID;
								arrAddGroupedPropQualifierValues.Add(lscgpq);
							}
						}
					} //Qualifier loop

				} //Site Component Grouped Property loop

			} //Site Component Property Loop


			
			//Insert SiteComponentGroupPropertyQualifiers
			for(int i=0; i< arrAddGroupedPropQualifierValues.Count;i++)
			{
				LRRSiteGroupPropertyQualifierValue siteGrpPropQualifier = arrAddGroupedPropQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
				groupPropertyQualifierValues.Add(siteGrpPropQualifier);
			}

			//Save SiteComponentGroupPropertyQualifiers
			if(groupPropertyQualifierValues.GetChanges().Count > 0)
			{
				LRRSiteGroupPropertyQualifierValues toSaveGroupPropertyQualifierValues = groupPropertyQualifierValues.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveGroupPropertyQualifierValues); 
			}*/

            #endregion

        }


        public void UpdateGroupedPropertiesByMode(LRRModes modeSet)
        {
            ArrayList arrAddGroupedPropQualifierValues = new ArrayList();

            LRRSiteComponentProperties objSiteComponentProps = new LRRSiteComponentProperties();
            //_app.DBManagerObj.PopulateCollection(objSiteComponentProps," WHERE Type <> '1'",false);
            objSiteComponentProps = LRRModel.SiteComponentPropertiesObj;

            LRRSiteComponentGroupProperties groupProperties = new LRRSiteComponentGroupProperties();
            //_app.DBManagerObj.PopulateCollection(groupProperties," WHERE PropertyID <> '1'",false);
            groupProperties = LRRModel.SiteComponentGroupPropertiesObj;

            LRRSiteGroupPropertyQualifierValues groupPropertyQualifierValues = new LRRSiteGroupPropertyQualifierValues();
            //_app.DBManagerObj.PopulateCollection(groupPropertyQualifierValues," WHERE PropertyID <> '1'",false);
            groupPropertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj;

            LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();
            _app.DBManagerObj.PopulateCollection(objLookUpQualifiers, false);

            foreach (LRRSiteComponentProperty objSiteCompProp in objSiteComponentProps)
            {
                string sSiteCompPropType = objSiteCompProp.Type == null ? "" : objSiteCompProp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                if ((sSiteCompPropType != "1") && (sSiteCompPropType != "0"))
                {

                    //--for each site component property get the grouped properties
                    string sSiteCompPropID = objSiteCompProp.ID == null ? "" : objSiteCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    LRRSiteComponentGroupProperties groupPropertiesForSiteCompProp = groupProperties.GetSiteCompGroupPropFromSiteCompPropID(sSiteCompPropID);

                    //For the existing Site Component grouped Properties
                    foreach (LRRSiteComponentGroupProperty groupProperty in groupPropertiesForSiteCompProp)
                    {
                        string sGroupPropertyID = groupProperty.GroupPropertyID == null ? "" : groupProperty.GroupPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        List<IPropertyValue> lstVals = groupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID);

                        //LRRSiteGroupPropertyQualifierValues lscgpqvs = groupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID);
                        LRRLookUpQualifiers lkupQuals = objLookUpQualifiers.getLookUpQualifiersForPropType(objSiteCompProp.Type);

                        foreach (LRRMode objMode in modeSet)
                        {
                            string sModeID = objMode.ModeId == null ? "" : objMode.ModeId.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                            bool bMatchFound = false;


                            foreach (IPropertyValue val in lstVals)
                            {
                                LRRSiteGroupPropertyQualifierValue currentVal = val as LRRSiteGroupPropertyQualifierValue;
                                if (currentVal.ModeID == sModeID)
                                {
                                    bMatchFound = true;
                                }
                            }


                            if (!bMatchFound)
                            {
                                if ((groupProperty.ModeID) && (sModeID != "0"))
                                {
                                    foreach (LRRLookUpQualifier lkupQual in lkupQuals)
                                    {
                                        LRRSiteGroupPropertyQualifierValue lscgpq = new LRRSiteGroupPropertyQualifierValue();
                                        lscgpq.GroupPropertyID = groupProperty.GroupPropertyID;
                                        lscgpq.LookUpQualifierID = lkupQual.LookUpQualifierID;
                                        lscgpq.PropertyID = groupProperty.PropertyID;
                                        lscgpq.LookUpPropertiesID = groupProperty.LookUpPropertiesID;
                                        lscgpq.QualifierID = lkupQual.QualifierID;
                                        lscgpq.ModeID = objMode.ModeId;
                                        lscgpq.MasterPropID = groupProperty.MasterPropID;
                                        arrAddGroupedPropQualifierValues.Add(lscgpq);
                                    }
                                }

                            }
                        } //Qualifier loop

                    } //Site Component Grouped Property loop

                } //Site Component Property Type Check

            } //Site Component Property Loop

            //Insert SiteComponentGroupPropertyQualifiers
            for (int i = 0; i < arrAddGroupedPropQualifierValues.Count; i++)
            {
                LRRSiteGroupPropertyQualifierValue siteGrpPropQualifier = arrAddGroupedPropQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
                groupPropertyQualifierValues.Add(siteGrpPropQualifier);
            }

            //Save SiteComponentGroupPropertyQualifiers
            if (groupPropertyQualifierValues.GetChanges().Count > 0)
            {
                LRRSiteGroupPropertyQualifierValues toSaveGroupPropertyQualifierValues = groupPropertyQualifierValues.GetChanges();
                _app.DBManagerObj.CommitCollection(toSaveGroupPropertyQualifierValues);
            }

        }

    }
}
