using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for HistTrendsDialog.
	/// </summary>
	public class HistTrendsDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelStartTime;
		private System.Windows.Forms.Label labelEndTime;
		private System.Windows.Forms.DateTimePicker dateTimePickerStart;
		private System.Windows.Forms.DateTimePicker dateTimePickerEnd;
		private System.Windows.Forms.Button buttonOk;
		private System.Windows.Forms.Button buttonCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public HistTrendsDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InternationalizationUtils.GetControlText(this,null); 

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			dateTimePickerStart.Value = startTime;
			dateTimePickerEnd.Value = endTime;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(HistTrendsDialog));
			this.labelStartTime = new System.Windows.Forms.Label();
			this.labelEndTime = new System.Windows.Forms.Label();
			this.dateTimePickerStart = new System.Windows.Forms.DateTimePicker();
			this.dateTimePickerEnd = new System.Windows.Forms.DateTimePicker();
			this.buttonOk = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// labelStartTime
			// 
			this.labelStartTime.Location = new System.Drawing.Point(16, 16);
			this.labelStartTime.Name = "labelStartTime";
			this.labelStartTime.Size = new System.Drawing.Size(64, 23);
			this.labelStartTime.TabIndex = 5;
			this.labelStartTime.Tag = "SID_STARTTIME";
			// 
			// labelEndTime
			// 
			this.labelEndTime.Location = new System.Drawing.Point(16, 48);
			this.labelEndTime.Name = "labelEndTime";
			this.labelEndTime.Size = new System.Drawing.Size(64, 23);
			this.labelEndTime.TabIndex = 6;
			this.labelEndTime.Tag = "SID_ENDTIME";
			// 
			// dateTimePickerStart
			// 
			this.dateTimePickerStart.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.dateTimePickerStart.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dateTimePickerStart.Location = new System.Drawing.Point(80, 16);
			this.dateTimePickerStart.Name = "dateTimePickerStart";
			this.dateTimePickerStart.Size = new System.Drawing.Size(248, 20);
			this.dateTimePickerStart.TabIndex = 7;
			// 
			// dateTimePickerEnd
			// 
			this.dateTimePickerEnd.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.dateTimePickerEnd.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dateTimePickerEnd.Location = new System.Drawing.Point(80, 48);
			this.dateTimePickerEnd.Name = "dateTimePickerEnd";
			this.dateTimePickerEnd.Size = new System.Drawing.Size(248, 20);
			this.dateTimePickerEnd.TabIndex = 8;
			// 
			// buttonOk
			// 
			this.buttonOk.Location = new System.Drawing.Point(280, 88);
			this.buttonOk.Name = "buttonOk";
			this.buttonOk.TabIndex = 9;
			this.buttonOk.Tag = "SID_OK";
			this.buttonOk.Click += new System.EventHandler(this.buttonOk_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(384, 88);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 10;
			this.buttonCancel.Tag = "SID_CANCEL";
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			// 
			// HistTrendsDialog
			// 
			this.AcceptButton = this.buttonOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(472, 118);
			this.ControlBox = false;
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonOk);
			this.Controls.Add(this.dateTimePickerEnd);
			this.Controls.Add(this.dateTimePickerStart);
			this.Controls.Add(this.labelEndTime);
			this.Controls.Add(this.labelStartTime);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "HistTrendsDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Tag = "SID_HISTTRENDSTIMESDIALOG";
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		public static DateTime startTime = DateTime.Now;
		public static DateTime endTime = DateTime.Now.AddSeconds(1);

		#endregion

		private void buttonOk_Click(object sender, System.EventArgs e)
		{
			startTime = dateTimePickerStart.Value;
			endTime = dateTimePickerEnd.Value;
			this.DialogResult = DialogResult.OK;
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;
		}
	}
}
