using System;
using System.Text;
using System.Collections;
using Symcon.Utils.XMLUtils;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace Symcon.LightRidge.PEAdvisor.IOScreen
{
	/// <summary>
	/// Summary description for GridPersistancecs.
	/// </summary>
	public class GridPersistanceUtil
	{
		#region Constructor

		public GridPersistanceUtil()
		{
			//
			// TODO: Add constructor logic here
			//
            for (int i = 0; i < 3; i++)
            {
                _arrGridColMove[i] = new ArrayList();
                _arrGridRowMove[i] = new ArrayList();
            }
		}

		static GridPersistanceUtil()
		{
			
		}

		#endregion

		#region Fields

		private LRRGridControlSetting _gctlSetting;
		private static byte[]			_buffer;
		public ArrayList		_gridCollection;
		public /*static*/ ArrayList[] _arrGridColMove = new ArrayList[3];
		public /*static*/ ArrayList[] _arrGridRowMove = new ArrayList[3];

		#endregion

		#region Properties

		public LRRGridControlSetting GctlSetting
		{
			get
			{
				return _gctlSetting;
			}
			set
			{
				_gctlSetting = value;
			}
		}

		public ArrayList GridCollection
		{
			get{return _gridCollection;}
			set
			{
				_gridCollection = value;
			}
		}
		#endregion

		#region Private Methods

		private void clearArrGridMove()
		{
			for(int i=0;i<3;i++)
			{
				_arrGridColMove[i].Clear();
				_arrGridRowMove[i].Clear();
			}
		}

		#endregion

		#region Public Methods

		public void SaveGridSettings(bool transposeFlag, bool groupByModeFlag)
		{
			if(_gridCollection == null)
				return;
			LRRGridControlSetting gridControlSetting;
			GridControlToSave ctl;

			gridControlSetting = new LRRGridControlSetting();
			gridControlSetting.IsTranspose = transposeFlag;
			gridControlSetting.IsGroupByMode = groupByModeFlag;
			gridControlSetting.gridInstance = new GridControlToSave[_gridCollection.Count];
			for(int j=0;j<_gridCollection.Count;j++)
			{
				gridControlSetting.gridInstance[j] = new GridControlToSave();
				ctl = gridControlSetting.gridInstance[j];
				Panel pnl = _gridCollection[j] as Panel;
				
				ctl.ParentPanelVarSize = pnl.Height;

				Syncfusion.Windows.Forms.Grid.GridControl gctl = pnl.Controls[0] as Syncfusion.Windows.Forms.Grid.GridControl;
				
				ctl.GridName = "Grid:" + j.ToString();

				ctl.GridControlColumns = new gcColumns[gctl.ColCount + 1];
				ctl.GridControlRows = new gcRows[gctl.RowCount + 1];
				for(int i=0;i<gctl.ColCount + 1;i++)
				{
					ctl.GridControlColumns[i] = new gcColumns();
					ctl.GridControlColumns[i].Width = gctl.ColWidths[i];
				}
				for(int i=0;i<gctl.RowCount + 1;i++)
				{
					ctl.GridControlRows[i] = new gcRows();
					ctl.GridControlRows[i].Height = gctl.RowHeights[i];
				}

//				if(groupByModeFlag)
//				{
                    //int count =0;	
                    //for(int i=0;i<_arrGridColMove[0].Count;i++)
                    //{
                    //    if(_arrGridColMove[0][i].ToString() == gctl[0,1].Text)
                    //    {
                    //        count++;
                    //    }
                    //}
                ctl.GridControlColMove = new gcColMove[_arrGridColMove[0].Count];
                    //count = 0;
					for(int i=0;i<_arrGridColMove[0].Count;i++)
					{
                        //if(_arrGridColMove[0][i].ToString() == gctl[0,1].Text)
                        //{
                        ctl.GridControlColMove[i] = new gcColMove();
							ctl.GridControlColMove[i].From = int.Parse(_arrGridColMove[0][i].ToString(),Symcon.BusinessObjects.SymConverter.Culture);
							ctl.GridControlColMove[i].Count = int.Parse(_arrGridColMove[1][i].ToString(),Symcon.BusinessObjects.SymConverter.Culture);
							ctl.GridControlColMove[i].Target = int.Parse(_arrGridColMove[2][i].ToString(),Symcon.BusinessObjects.SymConverter.Culture);
                            //count++;
                        //}
					}
//				}
                //int count2 =0;	
                //for(int i=0;i<_arrGridRowMove[0].Count;i++)
                //{
                //    if(_arrGridRowMove[0][i].ToString() == gctl[0,1].Text)
                //    {
                //        count2++;
                //    }
                //}
				ctl.GridControlRowMove = new gcColMove[_arrGridRowMove[0].Count];
                //count2 = 0;
				for(int i=0;i<_arrGridRowMove[0].Count;i++)
				{
                    //if(_arrGridRowMove[0][i].ToString() == gctl[0,1].Text)
                    //{
                    ctl.GridControlRowMove[i] = new gcColMove();
                    ctl.GridControlRowMove[i].From = int.Parse(_arrGridRowMove[0][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                    ctl.GridControlRowMove[i].Count = int.Parse(_arrGridRowMove[1][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                    ctl.GridControlRowMove[i].Target = int.Parse(_arrGridRowMove[2][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                        //count2++;
                    //}
				}
			}
			_gctlSetting = gridControlSetting;
			//SerializeObject(gridControlSetting, typeof(LRRGridControlSetting));
		}

		public void LoadGridSettings(bool transposeFlag, bool groupByModeFlag)
		{
			clearArrGridMove();
			if(_gridCollection==null)
				return;
			
			LRRGridControlSetting gcs = _gctlSetting;
		
			if(gcs==null || gcs.gridInstance == null)
				return;
			if(transposeFlag == gcs.IsTranspose && gcs.IsGroupByMode == groupByModeFlag)
			{
				for(int k=0;k<gcs.gridInstance.Length;k++)
				{
					GridControlToSave ctl = gcs.gridInstance[k];
					if(_gridCollection.Count>0)
					{
						Type type = _gridCollection[0].GetType();
						foreach(object obj in _gridCollection)
						{
							Syncfusion.Windows.Forms.Grid.GridControl gctl = null;
							if(type == typeof(Panel))
							{
								gctl = ((Panel)obj).Controls[0] as Syncfusion.Windows.Forms.Grid.GridControl;
				//				if(ctl.ParentPanelVarSize>0)
				//					((Panel)obj).Height = ctl.ParentPanelVarSize;
							}
							else
							{
								gctl = obj as Syncfusion.Windows.Forms.Grid.GridControl;
							}
							if((ctl.GridName.Equals("Grid:" + _gridCollection.IndexOf(obj,0).ToString())) && gctl.ColCount == (ctl.GridControlColumns.Length-1) && gctl.RowCount == (ctl.GridControlRows.Length -1))
							{
								if(type == typeof(Panel))
								{
									if(ctl.ParentPanelVarSize>0)
										((Panel)obj).Height = ctl.ParentPanelVarSize;
								}
//								if(groupByModeFlag)
//								{
									if(ctl.GridControlColMove!=null)
									{
										for(int i=0;i<ctl.GridControlColMove.Length;i++)
										{
											gctl.Cols.MoveRange(ctl.GridControlColMove[i].From,ctl.GridControlColMove[i].Count,ctl.GridControlColMove[i].Target);
										}
									}	
//								}
								if(ctl.GridControlRowMove!=null)
								{
									for(int i=0;i<ctl.GridControlRowMove.Length;i++)
									{
										gctl.Rows.MoveRange(ctl.GridControlRowMove[i].From,ctl.GridControlRowMove[i].Count,ctl.GridControlRowMove[i].Target);
									}
								}
								for(int i=0;i<ctl.GridControlColumns.Length;i++)
								{
									if(ctl.GridControlColumns[i].Width != 0)
										gctl.ColWidths[i] = ctl.GridControlColumns[i].Width;
								}
								for(int i=0;i<ctl.GridControlRows.Length;i++)
								{
									if(ctl.GridControlRows[i].Height != 0)
										gctl.RowHeights[i] = ctl.GridControlRows[i].Height;
								}
								break;
							}
						}
					}
				}
			}
		}

		public void LoadGridSettings(string templateClass)
		{
			bool transposeFlag = true;
			bool groupByModeFlag = false;

			switch(templateClass)
			{
				case "Symcon.LightRidge.PEAdvisor.GridSimpleView":
					templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController";
					break;
				case "Symcon.LightRidge.PEAdvisor.GridTransposedView":
					templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController";
					break;
				case "Symcon.LightRidge.PEAdvisor.GridSimpleGroupedModeView":
					templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleGroupedModeViewController";
					break;
				case "Symcon.LightRidge.PEAdvisor.GridTransposedGroupedModeView":
					templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedGroupedModeViewController";
					break;
				default :
					templateClass = templateClass;
					break;
			}
			string className = templateClass.Substring(templateClass.LastIndexOf(".")+1);
			if(className == "GridSimpleViewController")
			{
				transposeFlag = false;
				groupByModeFlag = false;
			}
			else if(className == "GridSimpleGroupedModeViewController")
			{
				transposeFlag = false;
				groupByModeFlag = true;
			}
			else if(className == "GridTransposedViewController")
			{
				transposeFlag = true;
				groupByModeFlag = false;
			}
			else if(className == "GridTransposedGroupedModeViewController")
			{
				transposeFlag = true;
				groupByModeFlag = true;
			}
			LoadGridSettings(transposeFlag, groupByModeFlag);
		}

		public byte[] GetUserSettingsXmlBytes()
		{
            SerializeObject(this.GctlSetting, typeof(LRRGridControlSetting));
			return _buffer;
		}

		public void SetBytesToUserSettingsXml(byte[] data)
		{

			_buffer = data;
            this.GctlSetting = DeserializeObject(typeof(LRRGridControlSetting)) as LRRGridControlSetting;
		}

		public void SerializeObject(Object pObject, Type type)
		{
			try
			{
				MemoryStream memoryStream = new MemoryStream();
				XmlSerializer xs = new XmlSerializer(type);
				XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);

				xs.Serialize(xmlTextWriter, pObject);
				memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
				_buffer = memoryStream.ToArray();
			}
			catch(Exception ex)
			{
				Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(GridPersistanceUtil),ex.Message,Symcon.Utils.MessageLogger.Logger.Level.Debug);
				return;
			}
		}

		public Object DeserializeObject( Type type)
		{
			try
			{
				if(_buffer == null)
					return null;
				MemoryStream memoryStream = new MemoryStream (_buffer);
				XmlSerializer xs = new XmlSerializer(type);
				Object obj = xs.Deserialize(memoryStream);
				memoryStream.Close();
				return obj;
			}
			catch(Exception ex)
			{
				Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(GridPersistanceUtil),ex.Message,Symcon.Utils.MessageLogger.Logger.Level.Debug);
				return null;
			}
		}

		#endregion
	}

    public class GridPersistanceUtilUnified
    {
        #region Constructor

        public GridPersistanceUtilUnified()
        {
            for (int i = 0; i < 3; i++)
            {
                _arrGridColMove[i] = new ArrayList();
                _arrGridRowMove[i] = new ArrayList();
            }
        }

        #endregion

        #region Fields

        private LRRGridControlSetting _gctlSetting;
        private byte[] _buffer;
        public ArrayList _gridCollection;
        public ArrayList[] _arrGridColMove = new ArrayList[3];
        public ArrayList[] _arrGridRowMove = new ArrayList[3];

        #endregion

        #region Properties

        public LRRGridControlSetting GctlSetting
        {
            get
            {
                return _gctlSetting;
            }
            set
            {
                _gctlSetting = value;
            }
        }

        public ArrayList GridCollection
        {
            get { return _gridCollection; }
            set
            {
                _gridCollection = value;
            }
        }
        #endregion

        #region Private Methods

        private void clearArrGridMove()
        {
            for (int i = 0; i < 3; i++)
            {
                _arrGridColMove[i].Clear();
                _arrGridRowMove[i].Clear();
            }
        }

        #endregion

        #region Public Methods

        public void SaveGridSettings(bool transposeFlag, bool groupByModeFlag)
        {
            if (_gridCollection == null)
                return;
            LRRGridControlSetting gridControlSetting;
            GridControlToSave ctl;

            gridControlSetting = new LRRGridControlSetting();
            gridControlSetting.IsTranspose = transposeFlag;
            gridControlSetting.IsGroupByMode = groupByModeFlag;
            gridControlSetting.gridInstance = new GridControlToSave[_gridCollection.Count];
            for (int j = 0; j < _gridCollection.Count; j++)
            {
                gridControlSetting.gridInstance[j] = new GridControlToSave();
                ctl = gridControlSetting.gridInstance[j];
                Panel pnl = _gridCollection[j] as Panel;

                ctl.ParentPanelVarSize = pnl.Height;

                Syncfusion.Windows.Forms.Grid.GridControl gctl = pnl.Controls[0] as Syncfusion.Windows.Forms.Grid.GridControl;

                ctl.GridName = "Grid:" + j.ToString();

                ctl.GridControlColumns = new gcColumns[gctl.ColCount + 1];
                ctl.GridControlRows = new gcRows[gctl.RowCount + 1];
                for (int i = 0; i < gctl.ColCount + 1; i++)
                {
                    ctl.GridControlColumns[i] = new gcColumns();
                    ctl.GridControlColumns[i].Width = gctl.ColWidths[i];
                }
                for (int i = 0; i < gctl.RowCount + 1; i++)
                {
                    ctl.GridControlRows[i] = new gcRows();
                    ctl.GridControlRows[i].Height = gctl.RowHeights[i];
                }

                //				if(groupByModeFlag)
                //				{
                //int count = _arrGridColMove[0].Count;

                ctl.GridControlColMove = new gcColMove[_arrGridColMove[0].Count];
                //count = 0;
                for (int i = 0; i < _arrGridColMove[0].Count; i++)
                {
                    //if (_arrGridColMove[0][i].ToString() == gctl[0, 1].Text)
                    //{
                    ctl.GridControlColMove[i] = new gcColMove();
                    ctl.GridControlColMove[i].From = int.Parse(_arrGridColMove[0][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                    ctl.GridControlColMove[i].Count = int.Parse(_arrGridColMove[1][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                    ctl.GridControlColMove[i].Target = int.Parse(_arrGridColMove[2][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                        //count++;
                    //}
                }
                //				}
                //int count2 = _arrGridRowMove[0].Count;

                ctl.GridControlRowMove = new gcColMove[_arrGridRowMove[0].Count];
                //count2 = 0;
                for (int i = 0; i < _arrGridRowMove[0].Count; i++)
                {
                    //if (_arrGridRowMove[0][i].ToString() == gctl[0, 1].Text)
                    //{
                    ctl.GridControlRowMove[i] = new gcColMove();
                    ctl.GridControlRowMove[i].From = int.Parse(_arrGridRowMove[0][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                    ctl.GridControlRowMove[i].Count = int.Parse(_arrGridRowMove[1][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                    ctl.GridControlRowMove[i].Target = int.Parse(_arrGridRowMove[2][i].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                        //count2++;
                    //}
                }
            }
            _gctlSetting = gridControlSetting;
            //SerializeObject(gridControlSetting, typeof(LRRGridControlSetting));
        }

        public void LoadGridSettings(bool transposeFlag, bool groupByModeFlag)
        {
            clearArrGridMove();
            if (_gridCollection == null)
                return;

            LRRGridControlSetting gcs = _gctlSetting;

            if (gcs == null || gcs.gridInstance == null)
                return;
            if (transposeFlag == gcs.IsTranspose && gcs.IsGroupByMode == groupByModeFlag)
            {
                for (int k = 0; k < gcs.gridInstance.Length; k++)
                {
                    GridControlToSave ctl = gcs.gridInstance[k];
                    if (_gridCollection.Count > 0)
                    {
                        Type type = _gridCollection[0].GetType();
                        foreach (object obj in _gridCollection)
                        {
                            Syncfusion.Windows.Forms.Grid.GridControl gctl = null;
                            if (type == typeof(Panel))
                            {
                                gctl = ((Panel)obj).Controls[0] as Syncfusion.Windows.Forms.Grid.GridControl;
                                //				if(ctl.ParentPanelVarSize>0)
                                //					((Panel)obj).Height = ctl.ParentPanelVarSize;
                            }
                            else
                            {
                                gctl = obj as Syncfusion.Windows.Forms.Grid.GridControl;
                            }
                            if (gctl.ColCount == (ctl.GridControlColumns.Length - 1) && gctl.RowCount == (ctl.GridControlRows.Length - 1))
                            {
                                if (type == typeof(Panel))
                                {
                                    if (ctl.ParentPanelVarSize > 0)
                                        ((Panel)obj).Height = ctl.ParentPanelVarSize;
                                }
                                //								if(groupByModeFlag)
                                //								{
                                if (ctl.GridControlColMove != null)
                                {
                                    for (int i = 0; i < ctl.GridControlColMove.Length; i++)
                                    {
                                        gctl.Cols.MoveRange(ctl.GridControlColMove[i].From, ctl.GridControlColMove[i].Count, ctl.GridControlColMove[i].Target);
                                    }
                                }
                                //								}
                                if (ctl.GridControlRowMove != null)
                                {
                                    for (int i = 0; i < ctl.GridControlRowMove.Length; i++)
                                    {
                                        gctl.Rows.MoveRange(ctl.GridControlRowMove[i].From, ctl.GridControlRowMove[i].Count, ctl.GridControlRowMove[i].Target);
                                    }
                                }
                                for (int i = 0; i < ctl.GridControlColumns.Length; i++)
                                {
                                    if (ctl.GridControlColumns[i].Width != 0)
                                        gctl.ColWidths[i] = ctl.GridControlColumns[i].Width;
                                }
                                for (int i = 0; i < ctl.GridControlRows.Length; i++)
                                {
                                    if (ctl.GridControlRows[i].Height != 0)
                                        gctl.RowHeights[i] = ctl.GridControlRows[i].Height;
                                }
                                break;
                            }
                        }
                    }
                }
            }
        }

        public void LoadGridSettings(string templateClass)
        {
            bool transposeFlag = true;
            bool groupByModeFlag = false;

            switch (templateClass)
            {
                case "Symcon.LightRidge.PEAdvisor.GridSimpleView":
                    templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController";
                    break;
                case "Symcon.LightRidge.PEAdvisor.GridTransposedView":
                    templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController";
                    break;
                case "Symcon.LightRidge.PEAdvisor.GridSimpleGroupedModeView":
                    templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleGroupedModeViewController";
                    break;
                case "Symcon.LightRidge.PEAdvisor.GridTransposedGroupedModeView":
                    templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedGroupedModeViewController";
                    break;
                default:
                    templateClass = templateClass;
                    break;
            }
            string className = templateClass.Substring(templateClass.LastIndexOf(".") + 1);
            if (className == "GridSimpleViewController")
            {
                transposeFlag = false;
                groupByModeFlag = false;
            }
            else if (className == "GridSimpleGroupedModeViewController")
            {
                transposeFlag = false;
                groupByModeFlag = true;
            }
            else if (className == "GridTransposedViewController")
            {
                transposeFlag = true;
                groupByModeFlag = false;
            }
            else if (className == "GridTransposedGroupedModeViewController")
            {
                transposeFlag = true;
                groupByModeFlag = true;
            }
            LoadGridSettings(transposeFlag, groupByModeFlag);
        }

        public byte[] GetUserSettingsXmlBytes()
        {
            SerializeObject(this.GctlSetting, typeof(LRRGridControlSetting));
            return _buffer;
        }

        public void SetBytesToUserSettingsXml(byte[] data)
        {

            _buffer = data;
            this.GctlSetting = DeserializeObject(typeof(LRRGridControlSetting)) as LRRGridControlSetting;
        }

        public void SerializeObject(Object pObject, Type type)
        {
            try
            {
                MemoryStream memoryStream = new MemoryStream();
                XmlSerializer xs = new XmlSerializer(type);
                XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);

                xs.Serialize(xmlTextWriter, pObject);
                memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
                _buffer = memoryStream.ToArray();
            }
            catch (Exception ex)
            {
                Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(GridPersistanceUtil), ex.Message, Symcon.Utils.MessageLogger.Logger.Level.Debug);
                return;
            }
        }

        public Object DeserializeObject(Type type)
        {
            try
            {
                if (_buffer == null)
                    return null;
                MemoryStream memoryStream = new MemoryStream(_buffer);
                XmlSerializer xs = new XmlSerializer(type);
                Object obj = xs.Deserialize(memoryStream);
                memoryStream.Close();
                return obj;
            }
            catch (Exception ex)
            {
                Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(GridPersistanceUtil), ex.Message, Symcon.Utils.MessageLogger.Logger.Level.Debug);
                return null;
            }
        }

        #endregion
    }
}
