using System;
using System.Windows.Forms;
using System.Collections;
using Syncfusion.Windows.Forms.Grid;

using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.IOScreen
{
	/// <summary>
	/// Summary description for IGridFactory.
	/// </summary>
	public interface IGridFactory
	{
		void LoadPanel(ArrayList custCollection,LRRSearchCriteriaItemProperties srchCriteriaItemProperties);
		void ClearSort();
		ArrayList GetPanelCollection();
		void HideProperties(ArrayList arrUnSelectedRecords);
		void HideComponents(ArrayList arrUnSelectedRecords);
		void HideModes();
		void Save(string name,string desc,LRRSearchGroupLevel srchGroupLevel,bool isPublished);
		void Save();
		GridControl Export();
		void Print();
		void PrintPreview();
		SearchCriteria SearchQuery {get;set;}
		void ClearAllBindings();
		void LeftColMovement();
		void RightColMovement();
		void ChangeUOMSet(string measID);
		void UnSubscribeReconnectCompleted();
        void ResetRecordingTrendingDisplayFlag(bool displayFlag);
	}
}
