using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Utils.MessageLogger;

namespace Symcon.LightRidge.PEAdvisor
{
    /// <summary>
    /// Summary description for DimensionsDlg.
    /// </summary>
	public class FrmDimensionsDlg : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox tbWidth;
		private System.Windows.Forms.TextBox tbHeight;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FrmDimensionsDlg()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

        /// <summary>
        /// Gets or sets the width of the diagram.
        /// </summary>
        /// <value>The width of the diagram.</value>
		public float DiagramWidth
		{
			get
			{
				float value = 0.0f;

				try
				{
					value = System.Convert.ToSingle(this.tbWidth.Text,Symcon.BusinessObjects.SymConverter.Culture);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(FrmDimensionsDlg),"DiagramWidth :"+ex.Message  ,Logger.Level.Debug);

				}

				return value;
			}
			set
			{
				this.tbWidth.Text = value.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			}
		}

        /// <summary>
        /// Gets or sets the height of the diagram.
        /// </summary>
        /// <value>The height of the diagram.</value>
		public float DiagramHeight
		{
			get
			{
				float value = 0.0f;

				try
				{
					value = System.Convert.ToSingle(this.tbHeight.Text,Symcon.BusinessObjects.SymConverter.Culture);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(FrmDimensionsDlg),"DiagramHeight :"+ex.Message  ,Logger.Level.Debug);
				}

				return value;
			}
			set
			{
				this.tbHeight.Text = value.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			}
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOk = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.tbWidth = new System.Windows.Forms.TextBox();
			this.tbHeight = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// btnOk
			// 
			this.btnOk.Location = new System.Drawing.Point(64, 104);
			this.btnOk.Name = "btnOk";
			this.btnOk.Size = new System.Drawing.Size(64, 24);
			this.btnOk.TabIndex = 0;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(152, 104);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(64, 24);
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Tag = "SID_CANCEL";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(40, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 2;
			this.label1.Tag = "SID_WIDTH";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(40, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 16);
			this.label2.TabIndex = 3;
			this.label2.Tag = "SID_HEIGHT";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tbWidth
			// 
			this.tbWidth.Location = new System.Drawing.Point(120, 24);
			this.tbWidth.Name = "tbWidth";
			this.tbWidth.Size = new System.Drawing.Size(96, 20);
			this.tbWidth.TabIndex = 4;
			this.tbWidth.Text = "";
			this.tbWidth.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.tbWidth.Validating += new System.ComponentModel.CancelEventHandler(this.tbWidth_Validating);
			// 
			// tbHeight
			// 
			this.tbHeight.Location = new System.Drawing.Point(120, 56);
			this.tbHeight.Name = "tbHeight";
			this.tbHeight.Size = new System.Drawing.Size(96, 20);
			this.tbHeight.TabIndex = 5;
			this.tbHeight.Text = "";
			this.tbHeight.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// frmDimensionsDlg
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(280, 144);
			this.Controls.Add(this.tbHeight);
			this.Controls.Add(this.tbWidth);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOk);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "frmDimensionsDlg";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Tag = "SID_DIG_DIMENSIONS";
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.OK;
			this.Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;
			this.Close();
		}

		private void tbWidth_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			float value = 0.0f;

			try
			{
				value = System.Convert.ToSingle(this.tbWidth.Text,Symcon.BusinessObjects.SymConverter.Culture);
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(FrmDimensionsDlg),"tbWidth_Validating Event :"+ex.Message  ,Logger.Level.Debug);
				e.Cancel = true;
			}
		}
	}
}
