using System;
using System.Collections;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Lightridge.LRRUI;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Interface for symbol mapping based on Site Item Type
	/// </summary>
	public interface ISymbolPropertiesMapping
	{
		/// <summary>
		/// Retrives the Collecttion of Properties for the site Item 
		/// </summary>
		/// <param name="propName">Name of the Site Item</param>
		/// <returns>Custom Collection based on the Site Item Name Selected</returns>
		//CustomCollection GetDataSource(string propName);

		LRRPlantItemProperties GetDataSource(string propName);
		
		
		/// <summary>
		/// Retrives the Properties Selected for a symbol in hashtable
		/// </summary>
		/// <param name="pt">PropertyTable for the Symbol</param>
		/// <returns>The hashtable containing the selected Properties for a symbol,Key:PropertyId,Value:Property Object </returns>
		Hashtable GetSelectedProperties(PropertyTable pt,CustomCollection customCollection);


		/// <summary>
		/// Fills the Property Holder Array with selected Properties and "NullValue" for the remaining
		/// </summary>
		/// <param name="collection">Selected Properties Collection</param>
		/// <param name="arryPropIndex">Property Holder Array associated with the symbol</param>
		void AddSelection(object collection,ArrayList arryPropIndex);

		/// <summary>
		/// Retrives Selected Properties
		/// </summary>
		CustomCollection SelectedProperties
		{
			get;
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="obj"></param>
		/// <param name="arryPropIndex"></param>
		void UpdateSelection(object obj, ArrayList arryPropIndex);

		/// <summary>
		/// 
		/// </summary>
		/// <param name="index"></param>
		/// <returns></returns>
		string GetSelectedPropertyNameByIndex(int index);
	}
}
