using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Diagram;

using Symcon.Lightridge.LRRUI.Controls;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.IOScreen;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for PropertyDetailsDialog.
	/// </summary>
	public class PropertyDetailsDialog : System.Windows.Forms.Form
	{
		//private System.Windows.Forms.Panel pnlPropDetails;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


		public PropertyDetailsDialog()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			LRRModel.ProjectModes.ModesChanged+=new EventHandler(ProjectModes_ModesChanged);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
					LRRModel.ProjectModes.ModesChanged-=new EventHandler(ProjectModes_ModesChanged);
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PropertyDetailsDialog));
			this.lblInitMsg = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// lblInitMsg
			// 
			this.lblInitMsg.Location = new System.Drawing.Point(40, 104);
			this.lblInitMsg.Name = "lblInitMsg";
			this.lblInitMsg.Size = new System.Drawing.Size(216, 24);
			this.lblInitMsg.TabIndex = 0;
			this.lblInitMsg.Tag = "SID_SELECT_OBJ";
			// 
			// PropertyDetailsDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.lblInitMsg);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "PropertyDetailsDialog";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Tag = "SID_ATT_DETL";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.PropertyDetailsDialog_Closing);
			this.ResumeLayout(false);

		}
		#endregion


	

		private void PropertyDetailsDialog_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			e.Cancel = true;
			if(this.GridView != null)
			{
				IGridFactory iGridFactory = this.GridView as IGridFactory;
				iGridFactory.ClearAllBindings();
				iGridFactory.UnSubscribeReconnectCompleted();
			}
			this.Controls.Clear();
			this.Controls.Add(lblInitMsg);
			this.Hide();
		}

		private System.Windows.Forms.Label lblInitMsg;



		private object _gridView;


		public object GridView
		{
			get { return _gridView;}
			set
			{
				_gridView = value;
			}
		}

		public void ClearControls()
		{
			if(this.Controls.Count > 0)
			{
				this.Controls.Clear();
			}
		}



		public void UpdatePropertyDetailsPanel(GraphicsManagers gms)
		{
			this.SuspendLayout();
			if(this.GridView != null)
			{
				IGridFactory iGridFactory = this.GridView as IGridFactory;
				iGridFactory.ClearAllBindings();
				iGridFactory.UnSubscribeReconnectCompleted();
			}

		
			
			this.ClearControls();

			Canvas activeCanvas	 = gms.ActiveManager.CanvasObj;
			LRRSiteComponents	newlscs	= new LRRSiteComponents();
			LRRAggregates newAggregates = new LRRAggregates();
			NodeCollection snc = new NodeCollection();
			for(int	i =	0; i < activeCanvas.SelectionList.Count	; i	++)
			{
				if(activeCanvas.SelectionList[i].GetType() == typeof(DynamicGridcontainer))
				{
					DynamicGridcontainer dg = activeCanvas.SelectionList[i] as DynamicGridcontainer;
					GridCell gc = dg.SelectedCell;
					snc.Add(gc);
				}
				else if(activeCanvas.SelectionList[i].GetType().BaseType	== typeof(Symbol))
					snc.Add(activeCanvas.SelectionList[i]);
			}
			foreach(INode node	in snc)
			{
				if(node != null && node.GetType() == typeof(GridCell))
				{
					GridCell gc = node as GridCell;
					if(gc	!= null	&& gc.GetPropertyValue("PlantItem") !=	null)
					{
						string siteItemID = null;
						SiteItem si = gc.GetPropertyValue("PlantItem") as SiteItem;
						siteItemID = si.ID;

						if(gc.GetPropertyValue("MasterPlantItem") != null )
						{
                            if (si.SiteItemType == Symcon.Globals.Enums.PlantItemType.AGGREGATE)
                            {
                                Symcon.LightRidge.BusinessObjects.LRRAggregates lrrAggregates = LRRModel.AggregatesObj;//LRRDataStore.GetSiteComponent(e.ChangedItem.Value.ToString());
                                LRRAggregate lrrAggregate = lrrAggregates.GetAggregateFromID(siteItemID);
                                if (lrrAggregate != null && !newAggregates.Contains(lrrAggregate))
                                    newAggregates.Add(lrrAggregate);

                                foreach (LRRAggregateEquipment currentAggragateEqupnemt in lrrAggregate.AggregateEquipments)
                                {
                                    //toolTipText = toolTipText + currentAggragateEqupnemt.na
                                    LRRSiteComponent currentSiteComponent = LRRModel.SiteComponentsObj.GetSiteComponentByID(currentAggragateEqupnemt.EquipmentID);

                                    if (currentSiteComponent != null)
                                    {
                                        LRRSiteComponent toAddSitecmponent = new LRRSiteComponent();
                                        toAddSitecmponent = currentSiteComponent.Clone() as LRRSiteComponent;

                                        toAddSitecmponent.Properties = currentSiteComponent.Properties.FilterPropertiesByPropertyType("1");

                                        if (toAddSitecmponent != null && !newlscs.Contains(toAddSitecmponent))
                                            newlscs.Add(toAddSitecmponent);
                                    }
                                }

                            }
                            else
                            {
                                Symcon.LightRidge.BusinessObjects.LRRSiteComponents lscs = LRRModel.SiteComponentsObj;//LRRDataStore.GetSiteComponent(e.ChangedItem.Value.ToString());
                                LRRSiteComponent lrrscref = lscs.GetSiteComponentByID(siteItemID);
                                if (lrrscref != null)
                                {
                                    LRRSiteComponent toAddSitecmponent = new LRRSiteComponent();
                                    toAddSitecmponent = lrrscref.Clone() as LRRSiteComponent;
                                    toAddSitecmponent.Properties = lrrscref.Properties.FilterPropertiesByPropertyType("1");
                                    bool doNotAdd = true;
                                    foreach (LRRSiteComponent siteComp in newlscs)
                                    {
                                        if (siteComp.SiteComponentID == toAddSitecmponent.SiteComponentID)
                                        {
                                            doNotAdd = false;
                                        }
                                    }
                                    if (toAddSitecmponent != null && doNotAdd)
                                        newlscs.Add(toAddSitecmponent);
                                }
                            }
							
						}
					}
				}
				else if(node != null  && node.GetType().BaseType == typeof(Symbol))
				{
					Symbol smbl = node as Symbol;
					if(smbl	!= null	&& smbl.GetPropertyValue("PlantItem") !=	null)//&&	smbl.GetPropertyValue("SiteItem").ToString() != "Select" )
					{
						string siteItemID = GraphicsUtilities.GetSiteItemIdForSymbol(smbl);
						if(smbl.GetPropertyValue("MasterPlantItem") != null )//&& (string)smbl.GetPropertyValue("ItemType") !=	"Select")
						{
							if(smbl.GetType().Name == "Aggregates")
							{
								Symcon.LightRidge.BusinessObjects.LRRAggregates	lrrAggregates = LRRModel.AggregatesObj;//LRRDataStore.GetSiteComponent(e.ChangedItem.Value.ToString());
								LRRAggregate lrrAggregate =	lrrAggregates.GetAggregateFromID(siteItemID);
                                if (lrrAggregate != null)
                                {
                                    if (!newAggregates.Contains(lrrAggregate))
                                        newAggregates.Add(lrrAggregate);

                                    foreach (LRRAggregateEquipment currentAggragateEqupnemt in lrrAggregate.AggregateEquipments)
                                    {
                                        //toolTipText = toolTipText + currentAggragateEqupnemt.na
                                        LRRSiteComponent currentSiteComponent = LRRModel.SiteComponentsObj.GetSiteComponentByID(currentAggragateEqupnemt.EquipmentID);

                                        if (currentSiteComponent != null)
                                        {
                                            LRRSiteComponent toAddSitecmponent = new LRRSiteComponent();
                                            toAddSitecmponent = currentSiteComponent.Clone() as LRRSiteComponent;

                                            toAddSitecmponent.Properties = currentSiteComponent.Properties.FilterPropertiesByPropertyType("1");

                                            if (toAddSitecmponent != null && !newlscs.Contains(toAddSitecmponent))
                                                newlscs.Add(toAddSitecmponent);
                                        }
                                    }
                                }
							}
                            else if (smbl.GetType().Name == "DashBoardControlProperties")
                            {
                                Symcon.LightRidge.BusinessObjects.LRRAggregates lrrAggregates = LRRModel.AggregatesObj;//LRRDataStore.GetSiteComponent(e.ChangedItem.Value.ToString());
                                LRRAggregate lrrAggregate = lrrAggregates.GetAggregateFromID(siteItemID);
                                if (lrrAggregate != null)
                                {
                                    if (!newAggregates.Contains(lrrAggregate))
                                        newAggregates.Add(lrrAggregate);

                                    foreach (LRRAggregateEquipment currentAggragateEqupnemt in lrrAggregate.AggregateEquipments)
                                    {
                                        //toolTipText = toolTipText + currentAggragateEqupnemt.na
                                        LRRSiteComponent currentSiteComponent = LRRModel.SiteComponentsObj.GetSiteComponentByID(currentAggragateEqupnemt.EquipmentID);

                                        if (currentSiteComponent != null)
                                        {
                                            LRRSiteComponent toAddSitecmponent = new LRRSiteComponent();
                                            toAddSitecmponent = currentSiteComponent.Clone() as LRRSiteComponent;

                                            toAddSitecmponent.Properties = currentSiteComponent.Properties.FilterPropertiesByPropertyType("1");

                                            if (toAddSitecmponent != null && !newlscs.Contains(toAddSitecmponent))
                                                newlscs.Add(toAddSitecmponent);
                                        }
                                    }
                                }
                                else
                                {
                                    Symcon.LightRidge.BusinessObjects.LRRSiteComponents lscs = LRRModel.SiteComponentsObj;//LRRDataStore.GetSiteComponent(e.ChangedItem.Value.ToString());
                                    LRRSiteComponent lrrscref = lscs.GetSiteComponentByID(siteItemID);
                                    if (lrrscref != null)
                                    {
                                        LRRSiteComponent toAddSitecmponent = new LRRSiteComponent();
                                        toAddSitecmponent = lrrscref.Clone() as LRRSiteComponent;
                                        toAddSitecmponent.Properties = lrrscref.Properties.FilterPropertiesByPropertyType("1");
                                        bool doNotAdd = true;
                                        foreach (LRRSiteComponent siteComp in newlscs)
                                        {
                                            if (siteComp.SiteComponentID == toAddSitecmponent.SiteComponentID)
                                            {
                                                doNotAdd = false;
                                            }
                                        }
                                        if (toAddSitecmponent != null && doNotAdd)
                                            newlscs.Add(toAddSitecmponent);
                                    }
                                }
                            }
                            else
                            {
                                Symcon.LightRidge.BusinessObjects.LRRSiteComponents lscs = LRRModel.SiteComponentsObj;//LRRDataStore.GetSiteComponent(e.ChangedItem.Value.ToString());
                                LRRSiteComponent lrrscref = lscs.GetSiteComponentByID(siteItemID);
                                if (lrrscref != null)
                                {
                                    LRRSiteComponent toAddSitecmponent = new LRRSiteComponent();
                                    toAddSitecmponent = lrrscref.Clone() as LRRSiteComponent;
                                    toAddSitecmponent.Properties = lrrscref.Properties.FilterPropertiesByPropertyType("1");
                                    bool doNotAdd = true;
                                    foreach (LRRSiteComponent siteComp in newlscs)
                                    {
                                        if (siteComp.SiteComponentID == toAddSitecmponent.SiteComponentID)
                                        {
                                            doNotAdd = false;
                                        }
                                    }
                                    if (toAddSitecmponent != null && doNotAdd)
                                        newlscs.Add(toAddSitecmponent);
                                }
                            }
						}
					}
				}
			}
			if(newlscs.Count > 0 || newAggregates.Count > 0)
			{
				gms.SelectedModes.SortColumn = "ModeTypeID";
				gms.SelectedModes.Sort();
				ArrayList custCollectionList = new ArrayList();
				custCollectionList.Add(newAggregates);
				custCollectionList.Add(newlscs);
				GridSimpleViewController gridView = new GridSimpleViewController();
				gridView.LoadPanel(custCollectionList,null);
				SetPanel(gridView.GetPanelCollection());
				_gridView = gridView;
				gridView.HideModes();
			}
			this.ResumeLayout(true);
			Cursor.Current = Cursors.Default;
		}



		
		private	void SetPanel(ArrayList	pnlCollection)
		{
			int heightOfEach = this.Height/pnlCollection.Count;
			int splitCnt = 0;
			for(int i=pnlCollection.Count-1;i>=0;i--)
			{
				Panel panel = pnlCollection[i] as Panel;
				panel.Height = heightOfEach;
				this.Controls.Add(panel);
				if(splitCnt < pnlCollection.Count - 1)
				{
					Splitter splitGrid = new Splitter();
					splitGrid.Dock = DockStyle.Top;
					this.Controls.Add(splitGrid);
					splitCnt++;
				}
			}
			if(this.Controls.Count > 0)
				this.Controls[0].Dock = DockStyle.Fill;
		}

		private void ProjectModes_ModesChanged(object sender, EventArgs e)
		{
			Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory igridFactory = this.GridView as Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory;
			if(igridFactory != null)
				igridFactory.HideModes();
			else
			{
				Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory igrpGridFactory = this.GridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;
				if(igrpGridFactory != null)
					igrpGridFactory.HideModes();
			}
		}
	}
}
