using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram.Controls;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.BusinessObjects;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.LightRidge.PEAdvisor.GridUtilities;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for SetLabelsVisibility.
	/// </summary>
	public class SetLabelsVisibility : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlFill;
		private System.Windows.Forms.Panel pnlTop;
		private System.Windows.Forms.Panel pnlBottom;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Splitter splitter1;
		private Symbol _smbl = null;
		private ArrayList alst = new ArrayList();
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridLabels;
		private Model _mdl = null;


		public SetLabelsVisibility()
		{
			InitializeComponent();
		}

		public SetLabelsVisibility(Symbol smbl, Model mdl)
		{
			InitializeComponent();
			_smbl = smbl;
			_mdl = mdl;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void InitDataSource()
		{
			SyncGridUtilities.InitializeGridLookAndFeel(gridLabels);
			this.gridLabels.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails =	false;
			
			this.gridLabels.TableDescriptor.AllowNew = false;
			this.gridLabels.TableDescriptor.Relations.Clear();
			this.gridLabels.DataSource = null;
			this.gridLabels.DataSource = alst;
			this.gridLabels.TableDescriptor.Columns["Visible"].AllowDropDownCell = false;
			this.gridLabels.CurrentRecordContextChange+=new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(gridLabels_CurrentRecordContextChange);


		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor gridColumnDescriptor1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor();
            this.pnlFill = new System.Windows.Forms.Panel();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.pnlBottom = new System.Windows.Forms.Panel();
            this.btnClose = new System.Windows.Forms.Button();
            this.pnlTop = new System.Windows.Forms.Panel();
            this.gridLabels = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlFill.SuspendLayout();
            this.pnlBottom.SuspendLayout();
            this.pnlTop.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridLabels)).BeginInit();
            this.SuspendLayout();
            // 
            // pnlFill
            // 
            this.pnlFill.Controls.Add(this.splitter1);
            this.pnlFill.Controls.Add(this.pnlBottom);
            this.pnlFill.Controls.Add(this.pnlTop);
            this.pnlFill.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlFill.Location = new System.Drawing.Point(0, 0);
            this.pnlFill.Name = "pnlFill";
            this.pnlFill.Size = new System.Drawing.Size(464, 262);
            this.pnlFill.TabIndex = 0;
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 224);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(464, 3);
            this.splitter1.TabIndex = 2;
            this.splitter1.TabStop = false;
            // 
            // pnlBottom
            // 
            this.pnlBottom.Controls.Add(this.btnClose);
            this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlBottom.Location = new System.Drawing.Point(0, 224);
            this.pnlBottom.Name = "pnlBottom";
            this.pnlBottom.Size = new System.Drawing.Size(464, 38);
            this.pnlBottom.TabIndex = 1;
            // 
            // btnClose
            // 
            this.btnClose.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnClose.Location = new System.Drawing.Point(376, 8);
            this.btnClose.Name = "btnClose";
            this.btnClose.Size = new System.Drawing.Size(75, 23);
            this.btnClose.TabIndex = 0;
            this.btnClose.Text = "&Close";
            // 
            // pnlTop
            // 
            this.pnlTop.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pnlTop.Controls.Add(this.gridLabels);
            this.pnlTop.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlTop.Location = new System.Drawing.Point(0, 0);
            this.pnlTop.Name = "pnlTop";
            this.pnlTop.Size = new System.Drawing.Size(464, 224);
            this.pnlTop.TabIndex = 0;
            // 
            // gridLabels
            // 
            this.gridLabels.BackColor = System.Drawing.SystemColors.Window;
            this.gridLabels.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridLabels.Location = new System.Drawing.Point(0, 0);
            this.gridLabels.Name = "gridLabels";
            this.gridLabels.Size = new System.Drawing.Size(462, 222);
            this.gridLabels.TabIndex = 0;
            this.gridLabels.TableDescriptor.AllowNew = false;
            this.gridLabels.TableDescriptor.AllowRemove = false;
            gridColumnDescriptor1.MappingName = "Text";
            gridColumnDescriptor1.ReadOnly = true;
            this.gridLabels.TableDescriptor.Columns.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor[] {
            new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("Visible", "Visible"),
            gridColumnDescriptor1});
            this.gridLabels.TableOptions.ShowRowHeader = false;
            this.gridLabels.Text = "gridGroupingControl1";
            this.gridLabels.TopLevelGroupOptions.CaptionText = "{RecordCount} Items";
            this.gridLabels.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridLabels.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridLabels.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridLabels.VersionInfo = "3.301.0.0";
            // 
            // SetLabelsVisibility
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(464, 262);
            this.Controls.Add(this.pnlFill);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Name = "SetLabelsVisibility";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Tag = "Dialog_SetLabelVisibility";
            this.Text = "Set Header Visibility";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.SetLabelsVisibility_Closing);
            this.Load += new System.EventHandler(this.SetLabelsVisibility_Load);
            this.pnlFill.ResumeLayout(false);
            this.pnlBottom.ResumeLayout(false);
            this.pnlTop.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridLabels)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		private void SetLabelsVisibility_Load(object sender, System.EventArgs e)
		{
			if(_smbl.GetType() != typeof(DynamicGridcontainer))
			{
				alst.Add(_smbl.Labels[0]);
				foreach(Symcon.Lightridge.LRRUI.Controls.LRRLabel lbl in _smbl.Labels)
				{
					if(lbl.IsParent && !alst.Contains(lbl))
						alst.Add(lbl);
					else if(lbl.Name == "Link")
						alst.Add(lbl);
						
				}
			}
			else
			{
				alst.Add(_smbl.Labels[0]);
			}
			InitDataSource();
			ApplicationPersistanceUtil.ApplyGridSettings(gridLabels, this as ILRRUIContainer, this.Tag);
		}

		private void SetLabelsVisibility_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			ApplicationPersistanceUtil.SaveGridSettings(gridLabels, this as ILRRUIContainer, this.Tag);
		}

		private void gridLabels_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			if(e.Action ==Syncfusion.Grouping.CurrentRecordAction.EndEditComplete)
			{
					_mdl.UpdateViews();
			}
		}
	}
}
