using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for UOMChangeDialog.
	/// </summary>
	public class UOMChangeDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ComboBox cmbUOM;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.GroupBox grpSelectUOM;
		private string _id;

		public UOMChangeDialog(string uomTypeId,string selectedUOMID,string propertyName)
		{

			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			grpSelectUOM.Text = grpSelectUOM.Text + " "  + propertyName;
			LRRUOMs lrrUOMs = LRRModel.ChildModel.GetUOMsFromUOMTypeID(uomTypeId);
			lrrUOMs.SortColumn = "Name";
			lrrUOMs.Sort();
			cmbUOM.DataSource = lrrUOMs;
			cmbUOM.DisplayMember = "Name";
			cmbUOM.ValueMember = "ID";
            if(cmbUOM.Items.Count != 0)
			cmbUOM.SelectedValue = selectedUOMID;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmbUOM = new System.Windows.Forms.ComboBox();
			this.grpSelectUOM = new System.Windows.Forms.GroupBox();
			this.grpSelectUOM.SuspendLayout();
			this.SuspendLayout();
			// 
			// cmbUOM
			// 
			this.cmbUOM.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbUOM.Location = new System.Drawing.Point(45, 32);
			this.cmbUOM.Name = "cmbUOM";
			this.cmbUOM.Size = new System.Drawing.Size(144, 21);
			this.cmbUOM.TabIndex = 0;
			this.cmbUOM.SelectedIndexChanged += new System.EventHandler(this.cmbUOM_SelectedIndexChanged);
			// 
			// grpSelectUOM
			// 
			this.grpSelectUOM.Controls.Add(this.cmbUOM);
			this.grpSelectUOM.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grpSelectUOM.Location = new System.Drawing.Point(0, 0);
			this.grpSelectUOM.Name = "grpSelectUOM";
			this.grpSelectUOM.Size = new System.Drawing.Size(234, 72);
			this.grpSelectUOM.TabIndex = 1;
			this.grpSelectUOM.TabStop = false;
			this.grpSelectUOM.Tag = "SID_SELECT_IOM_FOR";
			// 
			// UOMChangeDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(234, 72);
			this.Controls.Add(this.grpSelectUOM);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.MinimizeBox = false;
			this.Name = "UOMChangeDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Tag = "SID_CHANG_DISP_UOM";
			this.grpSelectUOM.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmbUOM_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				_id = cmbUOM.SelectedValue.ToString();
				this.DialogResult = DialogResult.OK;
			}
			catch
			{
				
			}
		
		}

		public string SelectedUOMID
		{
			get
			{
				return _id;
			}

		}
	}
}
