using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Symcon.Lightridge.LRRUI;
using Syncfusion.Windows.Forms.Diagram;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.Utils.MessageDispatcher;
using System.Collections;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters;

namespace Symcon.LightRidge.PEAdvisor
{
    public partial class UpdateGraphics : Form
    {
        public UpdateGraphics()
        {
            InitializeComponent();
        }
        private LRRApp _app;
        public GraphicsManagers gms;
        private void button2_Click(object sender, EventArgs e)
        {
            lblWait.Visible = true;
            _app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            // hookup events called by ashiwn
            gms = new GraphicsManagers();
            //gms.HookUpEvents();
            GraphicsUpdate();//For syncfusion Version Update release 3.7.1 Onwards
            //GraphicalGridUpdate();//For Grid Cell To Fetch Values uer specific

        }
        #region Graphics update Patch
        private static PropertyTable GetPropertyTableForsymbol(Symbol symbol)
        {
            PropertyTable pt = symbol.GetPropertyValue("PT") as PropertyTable;
            return pt;
        }
        private LRRSavedViews lrrsvs = new LRRSavedViews();
        private void GraphicsUpdate() //For syncfusion Version Update release 3.7.1 Onwards
        {
            LRRMessagBox.ShowMessage("SID_GRAPHICS_UPDATE_STARTED", "SID_LABEL", MessageBoxButtons.OK);
            try
            {
                _app.DBManagerObj.PopulateCollection(lrrsvs);
                LRRModes lrrModes = new LRRModes();
                for (int i = 1; i < LRRModel.ProjectModes.Count; i++)
                {
                    lrrModes.Add(LRRModel.ProjectModes[i]);
                }

                //int canvasNumber = Int32.Parse(textBox1.Text);
                foreach (LRRSavedView lrrsv in lrrsvs)
                {
                    gms.CreateGraphicsManager();
                    Canvas canvas = gms.ActiveManager.LoadCanvas(lrrsv.ID);
                    gms.ActiveManager.BindSymbols(lrrModes, GraphicsManagers.PropertiesMappingMode.OPEN, GraphicsManagers.UserMode.OPERATOR,"yes");
                    Save(lrrsv.ID, canvas);
                    /*
                    foreach (INode node in canvas.Model.Nodes)
                    {
                        if (node.GetType().BaseType == typeof(Symbol))
                        {
                            Symbol sm = node as Symbol;
                            PropertyTable pt = GetPropertyTableForsymbol(sm);
                            PropertyTable myPT = pt;
                            PropertySpec siteitemps = null;
                            PropertySpec masterItem = null;
                            PropertySpec graphicallink = null;
                            Symcon.Lightridge.LRRUI.PropertyBag.PropertySpecCollection pscl = pt.Properties;
                            ArrayList alst = new ArrayList();
                            foreach (PropertySpec ps in pscl)
                            {

                                if (ps.TypeName.StartsWith("Syncfusion"))
                                {
                                    //  MessageBox.Show(ps.TypeName);
                                    ps.TypeName = sm.GetType().GetProperty(ps.Name).PropertyType.AssemblyQualifiedName;
                                    //   MessageBox.Show(ps.TypeName);
                                }
                            }
                            if (sm.GetType().Name == "DynamicGridcontainer")
                            {
                                foreach (Syncfusion.Windows.Forms.Diagram.SymbolLabel lbl in sm.Labels)
                                {
                                    if (lbl is GridCell)
                                    {
                                        GridCell gc = lbl as GridCell;
                                        PropertyTable gridCellPropTable = gc.GetPropertyValue("PT") as PropertyTable;
                                        Symcon.Lightridge.LRRUI.PropertyBag.PropertySpecCollection gridPscl = gridCellPropTable.Properties;
                                        foreach (PropertySpec ps in gridPscl)
                                        {

                                            if (ps.TypeName.StartsWith("Syncfusion"))
                                            {
                                                //  MessageBox.Show(ps.TypeName);
                                                ps.TypeName = gc.GetType().GetProperty(ps.Name).PropertyType.AssemblyQualifiedName;
                                                //   MessageBox.Show(ps.TypeName);
                                            }
                                        }
                                    }
                                }
                            }

                        }

                    }
                     Save(lrrsv.ID, canvas);
                    */

                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            lrrsvs = null;
            MessageBox.Show("Completed");
            //LRRMessagBox.ShowMessage("SID_COMPLETED", "SID_LABEL", MessageBoxButtons.OK);
        }

        private void GraphicalGridUpdate()//For Grid Cell To Fetch Values uer specific
        {
            LRRMessagBox.ShowMessage("SID_GRAPHICS_UPDATE_STARTED", "SID_LABEL", MessageBoxButtons.OK);
            try
            {
                _app.DBManagerObj.PopulateCollection(lrrsvs);
                //int canvasNumber = Int32.Parse(textBox1.Text);
                foreach (LRRSavedView lrrsv in lrrsvs)
                {
                    //if (!lrrsv.SavedViewName.EndsWith("Fresh Water Balance Diagram"))
                    //    continue;
                    //lrrsv = lrrsvs[canvasNumber] as LRRSavedView;
                    if (lrrsv == null)
                        return;
                    //if (lrrsv.SavedViewName != "Fuel_Overview_LRRI")
                    //    continue;
                    gms.CreateGraphicsManager();
                    
                    Canvas canvas = gms.ActiveManager.LoadCanvas(lrrsv.ID);
                    
                    foreach (INode node in canvas.Model.Nodes)
                    {
                        if (node.GetType().BaseType == typeof(Symbol))
                        {
                            Symbol sm = node as Symbol;
                            //PropertyTable pt = GetPropertyTableForsymbol(sm);
                            //PropertyTable myPT = pt;
                            //PropertySpec siteitemps = null;
                            //PropertySpec masterItem = null;
                            //PropertySpec graphicallink = null;
                            //Symcon.Lightridge.LRRUI.PropertyBag.PropertySpecCollection pscl = pt.Properties;
                            //ArrayList alst = new ArrayList();
                            //foreach (PropertySpec ps in pscl)
                            //{

                            //    if (ps.TypeName.StartsWith("Syncfusion"))
                            //    {
                            //        //  MessageBox.Show(ps.TypeName);
                            //        ps.TypeName = sm.GetType().GetProperty(ps.Name).PropertyType.AssemblyQualifiedName;
                            //        //   MessageBox.Show(ps.TypeName);
                            //    }
                            //}
                            if (sm.GetType().Name == "DynamicGridcontainer")
                            {
                                UpdateGridToVersion397(sm);
                            }
                            else
                            {
                               ArrayList arryPropIndex = (ArrayList)sm.GetPropertyValue("ArryIndexedProps");
                               if (arryPropIndex == null)
                               {
                                   arryPropIndex = new ArrayList();
                                   for (int i = 0; i < 4; i++)
                                   {
                                       arryPropIndex.Add("Null");
                                   }
                                   sm.SetPropertyValue("ArryIndexedProps", arryPropIndex);
                               }
                            }
                        }
                    }
                    Save(lrrsv.ID, canvas);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            lrrsvs = null;
            LRRMessagBox.ShowMessage("SID_COMPLETED", "SID_LABEL", MessageBoxButtons.OK);
        }
        private void Save(string fileId, Canvas selectedCanvas)
        {

            MemoryStream ms = null;
            BinaryReader br = null;
            try
            {
                ms = new MemoryStream();
                BinaryFormatter formatter = new BinaryFormatter();
                formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder;
                formatter.AssemblyFormat = FormatterAssemblyStyle.Simple;
                DiagramDocument doc = new DiagramDocument(selectedCanvas.Model, selectedCanvas.View, (DiagramScript)selectedCanvas.ScriptingManager.Script);
                formatter.Serialize(ms, doc);
                ms.Position = 0;
                br = new BinaryReader(ms);
                byte[] fileData = br.ReadBytes((int)ms.Length);
                LRRSavedViewData lrsvd = new LRRSavedViewData();
                lrsvd.ViewBlob = fileData;
                lrsvd.ID = fileId;
                lrsvd.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                _app.DBManagerObj.CommitObject(lrsvd);
                if (lrsvd.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
                {
                    lrsvd.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                    _app.DBManagerObj.CommitObject(lrsvd);
                }
            }
            catch (Exception ex)
            {
            }
            finally
            {
                if (br != null)
                    br.Close();
                if (ms != null)
                    ms.Close();
                ms = null;
                br = null;
            }
        }

        private void GridUpdate(Symbol openedViewSymbol)
        {
            DynamicGridcontainer dg = openedViewSymbol as DynamicGridcontainer;
            foreach (SymbolLabel lbl in dg.Labels)
            {
                if (lbl.GetType() == typeof(GridHeaderCell))
                    continue;
                else
                {
                    GridCell gCell = lbl as GridCell;
                    if (!gCell.IsBinded)
                        continue;
                    else
                    {
                        switch (gCell.Type.Name)
                        {
                            case "LRRSiteComponentPropertyValue":
                                {
                                    IPropertyValue iPropvalue = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(gCell.ID);
                                    if (iPropvalue != null)
                                    {
                                        gCell.PropertyID = iPropvalue.GetPropertyID();
                                        gCell.ID = iPropvalue.GetID();
                                    }

                                    break;
                                }
                            case "LRRSiteGroupPropertyQualifierValue":
                                {
                                    IPropertyValue iPropvalue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(gCell.ID);
                                    if (iPropvalue != null)
                                    {
                                        LRRSiteGroupPropertyQualifierValue currentPropval = iPropvalue as LRRSiteGroupPropertyQualifierValue;
                                        gCell.ID = currentPropval.LookUpQualifierID;
                                        gCell.PropertyID = currentPropval.GroupPropertyID;
                                    }
                                    break;

                                }
                            case "LRRAggregatePropertyValue":
                                {
                                    IPropertyValue iPropvalue = LRRModel.AggregatePropertyValuesObj.FindAggregatePropertyValueByID(gCell.ID);
                                    if (iPropvalue != null)
                                    {
                                        gCell.PropertyID = iPropvalue.GetPropertyID();
                                        gCell.ID = iPropvalue.GetID();
                                    }
                                    break;
                                }
                            default:
                                break;
                        }

                    }
                }
            }

        }

        private void UpdateGridToVersion397(Symbol openedViewSymbol)
        {
            DynamicGridcontainer dg = openedViewSymbol as DynamicGridcontainer;
            PropertySpec gridCellFontFamily = new PropertySpec("GridCellFontFamily",typeof(string), "Grid Information", "", null, "", "", dg);
            PropertySpec cellsForeColor = new PropertySpec("CellsForeColor", typeof(Color), "Grid Information", "", null, "", "", dg);
            PropertySpec cellsBackColor = new PropertySpec("CellsBackColor", typeof(Color), "Grid Information", "", null, "", "", dg);
            if(!dg.PT.Properties.Contains("CellsFontFamily"))
                dg.PT.Properties.Add(gridCellFontFamily);
            if (!dg.PT.Properties.Contains("CellsForeColor"))
                dg.PT.Properties.Add(cellsForeColor);
            if (!dg.PT.Properties.Contains("CellsBackColor"))
                dg.PT.Properties.Add(cellsBackColor);
            foreach (SymbolLabel lbl in dg.Labels)
            {
                if (lbl.GetType() == typeof(GridHeaderCell))
                    continue;
                else
                {
                    GridCell gCell = lbl as GridCell;
                    //PropertySpec olColSpan = new PropertySpec("OldColumnSpan", typeof(int), "Merge Information", "", null, "","", gCell);
                    //PropertySpec olRowSpan = new PropertySpec("OldRowSpan", typeof(int), "Merge Information", "", null, "", "", gCell);
                    PropertySpec colSpan = new PropertySpec("ColSpan", typeof(int), "Merge Information", "", null, "", "", gCell);
                    PropertySpec rowSpan = new PropertySpec("RowSpan", typeof(int), "Merge Information", "", null, "", "", gCell);

                    gCell.SetPropertyValue("ColSpan", 1);
                    gCell.SetPropertyValue("OldColumnSpan", 1);
                    gCell.SetPropertyValue("RowSpan", 1);
                    gCell.SetPropertyValue("OldRowSpan", 1);
                    if (!gCell.PT.Properties.Contains("ColSpan"))
                        gCell.PT.Properties.Add(colSpan);
                    if (!gCell.PT.Properties.Contains("RowSpan"))
                        gCell.PT.Properties.Add(rowSpan);
                    //if (!gCell.PT.Properties.Contains("OldColumnSpan"))
                    //    gCell.PT.Properties.Add(olColSpan);
                    //if (!gCell.PT.Properties.Contains("OldRowSpan"))
                    //    gCell.PT.Properties.Add(olRowSpan);


                    //if (!gCell.IsBinded)
                    //    continue;
                }
            }
        }
        #endregion

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}