using System;
using System.Text;
using System.Collections;
using Symcon.Utils.XMLUtils;
using Symcon.Utils.MessageLogger;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.HeaderDispatcher; 


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for InternationalizationUtils.
	/// </summary>
	public class InternationalizationUtils
	{
		static InternationalizationUtils()
		{
			LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}
		public static void Initialize(Form mainWindow)
		{
			try
			{
				_mainFrame = mainWindow;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRWaitWindowUtility),"Initialize:"+ex.Message  ,Logger.Level.Debug);
			}
		}
		public static void GetControlText(Control ctl,System.ComponentModel.ComponentCollection components)
		{
			string controlText = null;
			if(ctl.Tag != null)
			{
				if(ctl.GetType().BaseType == typeof(System.Windows.Forms.Form))
				{
					string frmText = LRRHeaderText.GetHeaderString(ctl.Tag.ToString());
					if(frmText.StartsWith("&"))
					{
						string s = frmText.Remove(0,1);
						ctl.Text = s;
					}
					else
					{
						if(frmText != "")
							ctl.Text = frmText;
					}
				}
				else
				{
					controlText = LRRHeaderText.GetHeaderString(ctl.Tag.ToString());
					if(controlText != "" && controlText != null)
					{
						ctl.Text = controlText;
					}
				}
			}
			foreach(Control ctlchild in ctl.Controls)
			{
				GetControlText(ctlchild,null);
			}
			if(ctl.GetType() == typeof(Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar))
			{
				Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar toolBar = ctl as Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar;
				for(int j=0;j<toolBar.Items.Count;j++)
				{
					if(toolBar.Items[j].Tag != null)
					{
						string s = toolBar.Items[j].Tag.ToString();
						toolBar.Items[j].Text = LRRHeaderText.GetHeaderString(s);
					}
				}
			}
			if(components != null)
			{
				for(int i = 0;i<components.Count;i++) 
                {
					System.ComponentModel.IComponent comp = components[i] ;  
					if(comp.GetType() == typeof(Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager))
					{
						Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager barMang =  comp
							as  Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager;
						for(int j =0;j<barMang.Items.Count;j++)
						{
							if(barMang.Items[j].Tag != null)
							{
								string s = barMang.Items[j].Tag.ToString(); 
								barMang.Items[j].Text = LRRHeaderText.GetHeaderString(s);
							}
						}
					}
					else if(comp.GetType() == typeof(Symcon.CCLibrary.Controls.StatusBar))
					{
						Symcon.CCLibrary.Controls.StatusBar barMang = comp as Symcon.CCLibrary.Controls.StatusBar;
						for(int j=0;j<barMang.Controls.Count;j++)
						{
							string s = barMang.Controls[j].Tag.ToString(); 
							barMang.Controls[j].Text = LRRHeaderText.GetHeaderString(s);
						}
					}
					else if(comp.GetType()==typeof(Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager))
					{
						Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager childBarMang = comp 
							as Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager;
						for(int j =0;j<childBarMang.Items.Count;j++)
						{
							if(childBarMang.Items[j].Tag != null)
							{
								string s = childBarMang.Items[j].Tag.ToString(); 
								childBarMang.Items[j].Text = LRRHeaderText.GetHeaderString(s);
							}
						}
					}
				}
			}
		}
		#region Fields

		private static Form				_mainFrame;

		#endregion

	}
}
