using System.Xml.Serialization;
using System.Collections;

namespace Symcon.LightRidge.PEAdvisor
{

	public class TrendSetting
	{
		public string SchemeName
		{
			get
			{
				return _schemeName;
			}
			set
			{
				_schemeName = value;
			}
		}
		private string _schemeName = null;

        public string UOM
        {
            get { return _uom; }
            set { _uom = value; }
        }
        private string _uom = null;

        public string YUOM
        {
            get { return _yuom; }
            set { _yuom = value; }
        }
        private string _yuom = null;

		public bool IsXLog
		{
			get
			{
				return _isXLog;
			}
			set
			{
				_isXLog = value;
			}
		}
		private bool _isXLog = false;

		public string SeriesType
		{
			get
			{
				return _seriesType;
			}
			set
			{
				_seriesType = value;
			}
		}
		private string _seriesType = Syncfusion.Windows.Forms.Chart.ChartSeriesType.Scatter.ToString();

		public string SymbolShape
		{
			get
			{
				return _symbolShape;
			}
			set
			{
				_symbolShape = value;
			}
		}
		private string _symbolShape = Syncfusion.Windows.Forms.Chart.ChartSymbolShape.Diamond.ToString();

		public string SymbolColor
		{
			get
			{
				return _symbolColor;
			}
			set
			{
				_symbolColor = value;
			}
		}
		private string _symbolColor = System.Drawing.KnownColor.DarkCyan.ToString();
		public string SeriesInteriorColor
		{
			get
			{
				return _seriesInteriorColor;
			}
			set
			{
				_seriesInteriorColor = value;
			}
		}
		private string _seriesInteriorColor = System.Drawing.KnownColor.Red.ToString();
	}

	public class PersistQuery
	{
		#region Public Properties

		public string QueryID
		{
			get
			{
				return _queryID;
			}
			set
			{
				_queryID = value;
			}
		}
			
		public IOScreen.LRRGridControlSetting GridControlSettings
		{
			get
			{
				return _gridControlSettings;
			}
			set
			{
				_gridControlSettings = value;
			}
		}

		#endregion
		
		#region Fields

		private string _queryID;
		private IOScreen.LRRGridControlSetting _gridControlSettings;

		#endregion
	}

	public class PersistQueries
	{
		public PersistQuery[] PQueries
		{
			get
			{
				return _pQuries;
			}
			set
			{
				_pQuries = value;
			}
		}

		private PersistQuery[] _pQuries;
	}
	/// <remarks/>
	[System.Xml.Serialization.XmlTypeAttribute(Namespace="urn:xmlns:Symcon-com:LRRApplicationSettings")]
	[System.Xml.Serialization.XmlRootAttribute("LRRApplicationSettings", Namespace="urn:xmlns:Symcon-com:LRRGridSetting", IsNullable=false)]
	public class LRRApplicationSettings
	{
		public TrendSetting[] TrendSettings
		{
			get
			{
				return _trendSettings;
			}
			set
			{
				_trendSettings = value;
			}
		}
		private TrendSetting[] _trendSettings;

		public PersistQueries PQuries
		{
			get
			{
				return _pQuries;
			}
			set
			{
				_pQuries = value;
			}
		}

		private PersistQueries _pQuries;
		public Syncfusion.Windows.Forms.Chart.ChartSeriesType HistTrendSeriesType
		{
			get { return HistTrends._seriesType; }
			set { HistTrends._seriesType = value; }
		}

//		public int MiscZoom
//		{
//			get { return ExcelView._lastZoom; }
//			set { ExcelView._lastZoom = value; }
//		}

		public MiscZoom[] miscZooms;

		public System.DateTime HistTrendsStartTime
		{
			get { return HistTrendsDialog.startTime; }
			set { HistTrendsDialog.startTime = value; }
		}

		public System.DateTime HistTrendsEndTime
		{
			get { return HistTrendsDialog.endTime; }
			set { HistTrendsDialog.endTime = value; }
		}

		[System.Xml.Serialization.XmlElementAttribute("OpenedWindow")]
		public OpenedWindow[] openedWindows;
		
		public PQueryList pQueryList;

		public OpenedCanvas[] openedOperatorsCanvas;

		public OpenedCanvas[] openedCanvas;

		public string ActiveOperatorsCanvas
		{
			get{ return _activeOperatorsCanvas; }
			set { _activeOperatorsCanvas = value; }
		}
		private string _activeOperatorsCanvas;

		public string ActiveCanvas
		{
			get{ return _activeCanvas; }
			set { _activeCanvas = value; }
		}
		private string _activeCanvas;

		public string ActiveMdiChildID
		{
			get{ return _activeMdiChildID; }
			set { _activeMdiChildID = value; }
		}
		private string _activeMdiChildID;

		public int SelectedQuery
		{
			get{ return _selectedQuery; }
			set { _selectedQuery = value; }
		}
		private int _selectedQuery;

		public static int SSelectedQuery
		{
			get{ return _sSelectedQuery; }
			set { _sSelectedQuery = value; }
		}
		private static int _sSelectedQuery = -1;

		public int OpenedCount
		{
			get{ return _openedCount; }
			set { _openedCount = value; }
		}
		private int _openedCount;

		public OpenedWindow GetOpenedWindowByID(string id)
		{
			if(openedWindows == null)
				return null;
			foreach(OpenedWindow ow in openedWindows)
			{
				if(ow.WindowID.Equals(id))
					return ow;
			}
			return null;
		}

		public void SetOpenWindow(OpenedWindow ow)
		{
			if(this.openedWindows == null)
				return;
			for(int i=0;i< this.openedWindows.Length;i++)
			{
				if(this.openedWindows[i].WindowID == ow.WindowID)
				{
					this.openedWindows[i] = ow;
					return;
				}
			}
		}

	}

	public class OpenedCanvas
	{
		public string FileID
		{
			get{ return _fileID; }
			set { _fileID = value; }
		}
		private string _fileID;
	}

	public class PQueryList
	{
		public bool isVisible;
		public ArrayList arrPQueries;
	}

	public class MiscZoom
	{
		public string ViewID
		{
			get { return _viewID; }
			set { _viewID = value; }
		}
		private string _viewID;

		public int nZoom;
	}
	[System.Xml.Serialization.XmlTypeAttribute(Namespace="urn:xmlns:Symcon-com:LRRApplicationSettings")]
	public class OpenedWindow
	{
		[System.Xml.Serialization.XmlElementAttribute("Grid")]
		public Grid[] gridInstance ;

		public OtherControl[] ocInstance;

		public string WindowType
		{
			get{ return _windowType; }
			set { _windowType = value; }
		}
		private string _windowType;

		public string WindowID
		{
			get{ return _windowID; }
			set { _windowID = value; }
		}
		private string _windowID;

		public int Width
		{
			get{ return _width; }
			set { _width = value; }
		}
		private int _width;

		public int Height
		{
			get{ return _height; }
			set { _height = value; }
		}
		private int _height;

		public int LocationX
		{
			get{ return _locationX; }
			set { _locationX = value; }
		}
		private int _locationX;

		public int LocationY
		{
			get{ return _locationY; }
			set { _locationY = value; }
		}
		private int _locationY;

		public System.Windows.Forms.FormWindowState WindowState
		{
			get{ return _windowState; }
			set { _windowState = value; }
		}
		private System.Windows.Forms.FormWindowState _windowState;

		public int Index
		{
			get{ return _index; }
			set { _index = value; }
		}
		private int _index;

		public Grid GetGridByName(string gridName)
		{
			foreach(Grid grid in this.gridInstance)
			{
				if(grid.GridName == gridName)
				{
					return grid;
				}
			}
			return null;
		}
	}
}
