using System;
using System.Drawing;
using System.Collections;
using System.Diagnostics;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.ProjectOptions;
using Symcon.LightRidge.ProjectOptions.ProjectInfo;
using Symcon.Utils.XMLUtils;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.Options.VersionInfo;
using Symcon.Utils.Cryptography;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for Login.
	/// </summary>
	public class Login : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.TextBox txtUsername;
		private System.Windows.Forms.Label lblUsername;
		private System.Windows.Forms.Label lblPassword;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Label lblDataBase;
		private System.Windows.Forms.ComboBox cmbDataSource;
		private System.Windows.Forms.Label lblError;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnOptions;
		private System.Windows.Forms.CheckBox chkRememberPass;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblVer;
		private System.Windows.Forms.Label lblReleaseDateTime;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label lblRelDateTime;
		private System.Windows.Forms.Label lblCopywrite;
		private System.Windows.Forms.PictureBox pictureBox2;
        private System.Windows.Forms.PictureBox pictureBox3;
        private LinkLabel linkLabelLoginPreferences;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Default Constructor
		/// </summary>
		public Login()
		{
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;//Get the app object...
			
		}

		public Login(LRROptions lrrOptionsObj)
		{
			InitializeComponent();
			_lrrOptionsObj = lrrOptionsObj;
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;//Get the app object...

			_lrrVersionInfo = _app.VersionInfo;
		}
		
		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == (Keys.Control | Keys.V)) 
				return true; 
			else if(keyData == (Keys.Control | Keys.C)) 
				return true; 
			else 
				return base.ProcessCmdKey (ref msg, keyData);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Login));
			this.txtUsername = new System.Windows.Forms.TextBox();
			this.lblUsername = new System.Windows.Forms.Label();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.lblPassword = new System.Windows.Forms.Label();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.lblDataBase = new System.Windows.Forms.Label();
			this.cmbDataSource = new System.Windows.Forms.ComboBox();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOptions = new System.Windows.Forms.Button();
			this.lblError = new System.Windows.Forms.Label();
			this.chkRememberPass = new System.Windows.Forms.CheckBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lblVer = new System.Windows.Forms.Label();
			this.lblReleaseDateTime = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.lblCopywrite = new System.Windows.Forms.Label();
			this.lblRelDateTime = new System.Windows.Forms.Label();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.pictureBox3 = new System.Windows.Forms.PictureBox();
			this.linkLabelLoginPreferences = new System.Windows.Forms.LinkLabel();
			((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).BeginInit();
			this.SuspendLayout();
			// 
			// txtUsername
			// 
			this.txtUsername.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtUsername.Location = new System.Drawing.Point(144, 192);
			this.txtUsername.Name = "txtUsername";
			this.txtUsername.Size = new System.Drawing.Size(232, 20);
			this.txtUsername.TabIndex = 0;		 
		 
			// 
			// lblUsername
			// 
			this.lblUsername.Location = new System.Drawing.Point(64, 192);
			this.lblUsername.Name = "lblUsername";
			this.lblUsername.Size = new System.Drawing.Size(74, 16);
			this.lblUsername.TabIndex = 1;
			this.lblUsername.Tag = "SID_USERNAME";
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(498, 112);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 2;
			this.pictureBox1.TabStop = false;
			// 
			// lblPassword
			// 
			this.lblPassword.Location = new System.Drawing.Point(64, 216);
			this.lblPassword.Name = "lblPassword";
			this.lblPassword.Size = new System.Drawing.Size(74, 16);
			this.lblPassword.TabIndex = 4;
			this.lblPassword.Tag = "SID_PASSWARD";
			// 
			// txtPassword
			// 
			this.txtPassword.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtPassword.Location = new System.Drawing.Point(144, 216);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(232, 20);
			this.txtPassword.TabIndex = 1;
			// 
			// btnOK
			// 
			this.btnOK.BackColor = System.Drawing.SystemColors.Control;
			this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnOK.Location = new System.Drawing.Point(144, 288);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(74, 24);
			this.btnOK.TabIndex = 4;
			this.btnOK.Tag = "SID_OK";
			this.btnOK.UseVisualStyleBackColor = false;
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// lblDataBase
			// 
			this.lblDataBase.Location = new System.Drawing.Point(64, 240);
			this.lblDataBase.Name = "lblDataBase";
			this.lblDataBase.Size = new System.Drawing.Size(74, 16);
			this.lblDataBase.TabIndex = 6;
			this.lblDataBase.Tag = "SID_DATABASE";
			// 
			// cmbDataSource
			// 
			this.cmbDataSource.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbDataSource.Location = new System.Drawing.Point(144, 240);
			this.cmbDataSource.Name = "cmbDataSource";
			this.cmbDataSource.Size = new System.Drawing.Size(232, 21);
			this.cmbDataSource.TabIndex = 2;
			this.cmbDataSource.SelectedIndexChanged += new System.EventHandler(this.cmbDataSource_SelectedIndexChanged);
			// 
			// btnCancel
			// 
			this.btnCancel.BackColor = System.Drawing.SystemColors.Control;
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnCancel.Location = new System.Drawing.Point(224, 288);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(74, 24);
			this.btnCancel.TabIndex = 5;
			this.btnCancel.Tag = "SID_CANCEL";
			this.btnCancel.UseVisualStyleBackColor = false;
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// btnOptions
			// 
			this.btnOptions.BackColor = System.Drawing.SystemColors.Control;
			this.btnOptions.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnOptions.Location = new System.Drawing.Point(304, 288);
			this.btnOptions.Name = "btnOptions";
			this.btnOptions.Size = new System.Drawing.Size(74, 24);
			this.btnOptions.TabIndex = 6;
			this.btnOptions.Tag = "SID_OPTIONS";
			this.btnOptions.UseVisualStyleBackColor = false;
			this.btnOptions.Click += new System.EventHandler(this.btnOptions_Click);
			// 
			// lblError
			// 
			this.lblError.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.lblError.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.lblError.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblError.Location = new System.Drawing.Point(-2, 320);
			this.lblError.Name = "lblError";
			this.lblError.Size = new System.Drawing.Size(502, 19);
			this.lblError.TabIndex = 10;
			this.lblError.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// chkRememberPass
			// 
			this.chkRememberPass.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.chkRememberPass.Location = new System.Drawing.Point(144, 264);
			this.chkRememberPass.Name = "chkRememberPass";
			this.chkRememberPass.Size = new System.Drawing.Size(184, 16);
			this.chkRememberPass.TabIndex = 3;
			this.chkRememberPass.Tag = "SID_REMEMBERPASSWORD";
			this.chkRememberPass.CheckedChanged += new System.EventHandler(this.chkRememberPass_CheckedChanged);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.label1.ForeColor = System.Drawing.SystemColors.ControlDark;
			this.label1.Location = new System.Drawing.Point(328, 168);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 11;
			this.label1.Tag = "SID_VERSION";
			// 
			// lblVer
			// 
			this.lblVer.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.lblVer.ForeColor = System.Drawing.SystemColors.ControlDark;
			this.lblVer.Location = new System.Drawing.Point(376, 168);
			this.lblVer.Name = "lblVer";
			this.lblVer.Size = new System.Drawing.Size(72, 16);
			this.lblVer.TabIndex = 12;
			// 
			// lblReleaseDateTime
			// 
			this.lblReleaseDateTime.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.lblReleaseDateTime.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.lblReleaseDateTime.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold);
			this.lblReleaseDateTime.ForeColor = System.Drawing.SystemColors.ControlDark;
			this.lblReleaseDateTime.Location = new System.Drawing.Point(408, 120);
			this.lblReleaseDateTime.Name = "lblReleaseDateTime";
			this.lblReleaseDateTime.Size = new System.Drawing.Size(80, 16);
			this.lblReleaseDateTime.TabIndex = 13;
			this.lblReleaseDateTime.Tag = "SID_RELEASED";
			this.lblReleaseDateTime.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblReleaseDateTime.Visible = false;
			// 
			// label2
			// 
			this.label2.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label2.Font = new System.Drawing.Font("Arial", 22F, System.Drawing.FontStyle.Bold);
			this.label2.ForeColor = System.Drawing.SystemColors.ControlText;
			this.label2.Location = new System.Drawing.Point(145, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(208, 32);
			this.label2.TabIndex = 16;
			this.label2.Tag = "SID_PEADVISOR";
			this.label2.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
			// 
			// label3
			// 
			this.label3.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.label3.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.label3.ForeColor = System.Drawing.SystemColors.ControlText;
			this.label3.Location = new System.Drawing.Point(328, 104);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 16);
			this.label3.TabIndex = 17;
			this.label3.Tag = "SID_TM";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label4
			// 
			this.label4.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.label4.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.label4.ForeColor = System.Drawing.SystemColors.ControlText;
			this.label4.Location = new System.Drawing.Point(133, 136);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(232, 16);
			this.label4.TabIndex = 18;
			this.label4.Tag = "SID_INTEGRATED";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label5
			// 
			this.label5.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.label5.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.label5.ForeColor = System.Drawing.SystemColors.ControlText;
			this.label5.Location = new System.Drawing.Point(97, 152);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(304, 16);
			this.label5.TabIndex = 19;
			this.label5.Tag = "SID_PERFOMANCE";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblCopywrite
			// 
			this.lblCopywrite.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.lblCopywrite.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblCopywrite.Location = new System.Drawing.Point(64, 371);
			this.lblCopywrite.Name = "lblCopywrite";
			this.lblCopywrite.Size = new System.Drawing.Size(368, 16);
			this.lblCopywrite.TabIndex = 20;
			this.lblCopywrite.Tag = "SID_COPY_RIGHT";
			this.lblCopywrite.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblRelDateTime
			// 
			this.lblRelDateTime.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.lblRelDateTime.ForeColor = System.Drawing.SystemColors.ControlDark;
			this.lblRelDateTime.Location = new System.Drawing.Point(368, 40);
			this.lblRelDateTime.Name = "lblRelDateTime";
			this.lblRelDateTime.Size = new System.Drawing.Size(208, 16);
			this.lblRelDateTime.TabIndex = 22;
			this.lblRelDateTime.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(392, 288);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(24, 24);
			this.pictureBox2.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox2.TabIndex = 23;
			this.pictureBox2.TabStop = false;
			this.pictureBox2.Click += new System.EventHandler(this.pictureBox2_Click);
			// 
			// pictureBox3
			// 
			this.pictureBox3.Enabled = false;
			this.pictureBox3.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox3.Image")));
			this.pictureBox3.Location = new System.Drawing.Point(184, 400);
			this.pictureBox3.Name = "pictureBox3";
			this.pictureBox3.Size = new System.Drawing.Size(144, 16);
			this.pictureBox3.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.pictureBox3.TabIndex = 24;
			this.pictureBox3.TabStop = false;
			this.pictureBox3.Visible = false;
			// 
			// linkLabelLoginPreferences
			// 
			this.linkLabelLoginPreferences.AutoSize = true;
			this.linkLabelLoginPreferences.Location = new System.Drawing.Point(206, 348);
			this.linkLabelLoginPreferences.Name = "linkLabelLoginPreferences";
			this.linkLabelLoginPreferences.Size = new System.Drawing.Size(0, 13);
			this.linkLabelLoginPreferences.TabIndex = 25;
			this.linkLabelLoginPreferences.Tag = "SID_LOGIN_PREFERENCES";
			this.linkLabelLoginPreferences.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelLoginPreferences_LinkClicked);
			// 
			// Login
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.ClientSize = new System.Drawing.Size(498, 425);
			this.ControlBox = false;
			this.Controls.Add(this.linkLabelLoginPreferences);
			this.Controls.Add(this.pictureBox3);
			this.Controls.Add(this.pictureBox2);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.lblCopywrite);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.lblVer);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lblReleaseDateTime);
			this.Controls.Add(this.chkRememberPass);
			this.Controls.Add(this.txtPassword);
			this.Controls.Add(this.txtUsername);
			this.Controls.Add(this.lblError);
			this.Controls.Add(this.btnOptions);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.cmbDataSource);
			this.Controls.Add(this.lblDataBase);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.lblPassword);
			this.Controls.Add(this.lblUsername);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.lblRelDateTime);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Login";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_PELOGIN";
			this.Load += new System.EventHandler(this.Login_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Login_Paint);
			this.Activated += new System.EventHandler(this.Login_Activated);
			((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBox2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pictureBox3)).EndInit();
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		#region Private Methods

		/// <summary>
		/// This Methos populates the combo with the database connection
		/// string information..
		/// </summary>
		private void PopulateDBCombo()
		{
			try
			{
				if(_app != null)
				{
					cmbDataSource.Items.Clear();
					foreach (Symcon.LightRidge.Options.DBOptions.DBInfo dbinf in _app.GetOptions().DataBaseConnectionInfosObj)
					{
						cmbDataSource.Items.Add(dbinf.DatabaseName);
					}

					cmbDataSource.SelectedIndex = _app.GetOptions().SelectedDBIndex;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(Login),"PopulateDBCombo:"+ex.Message  ,Logger.Level.Debug);
			}
		}
		#endregion

		#region Public Methods

		public void ShowProgress(string sProgress)
		{
			lblError.Text = sProgress;
			lblError.Refresh();
		}

		public void SetControlEnabledState(bool state)
		{
			foreach(Control ctl in this.Controls)
			{
				ctl.Enabled = state;
			}
			
			pictureBox3.Enabled = !state;
			pictureBox3.Visible = !state;
			if(!state)
			{
				this.Cursor = Cursors.WaitCursor;
			}
			else
			{
				this.Cursor = Cursors.Default;
			}
		
		}

		#endregion

		#region Event Handlers
		private void Login_Load(object sender, System.EventArgs e)
		{
			try
			{
				PopulateDBCombo();
				lblVer.Text = _lrrVersionInfo.ClientVersion;//_lrrOptionsObj.ClientVersion;
				lblRelDateTime.Text = _lrrVersionInfo.ReleaseDateTime;//_lrrOptionsObj.ReleaseDateTime;
				txtUsername.Text =  _lrrOptionsObj.LastLoggedInUser;
				txtUsername.DataBindings.Add("Text",_lrrOptionsObj,"LastLoggedInUser");
				if(_lrrOptionsObj.RememberPwd)
				{
					txtPassword.Text=	CryptographyUtils.DecryptPassword(_lrrOptionsObj.LastLoggedInUserPwd);
					chkRememberPass.Checked=true;
				}
				else
				{
					 txtPassword.Text="";
					 chkRememberPass.Checked=false;
				}
				Symcom.Utils.HelpUtility.HelpUtils.ApplyHelpSettings(this);
				
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(Login),"Login_Load Event:"+ex.Message  ,Logger.Level.Debug);

			}
		
		}

		/// <summary>
		/// Handler for the Ok Button Click
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnOK_Click(object sender, System.EventArgs e)
		{
				_app.Initialize();
		}

		/// <summary>
		/// Handler for the options button click
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnOptions_Click(object sender, System.EventArgs e)
		{
			Cursor=Cursors.WaitCursor;
			Options options = new Options("Login");
			options.ShowDialog();
			Cursor=Cursors.Default;
		}

		/// <summary>
		/// Handler when the Form gets activated...
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Login_Activated(object sender, System.EventArgs e)
		{
			PopulateDBCombo();//Populate the Combo with the most recent values in the config file.
			if(txtUsername.Text != "")
			{
				txtPassword.Focus();
			}
		}


		#endregion

		#region Fields
		private LRROptions						_lrrOptionsObj;
		private LRRApp							_app;
		private LRRProjectOptions				_lrrProjOptions;
		private LRRVersionInfo					_lrrVersionInfo;
		#endregion

		private void cmbDataSource_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			_app.GetOptions().SelectedDBIndex = cmbDataSource.SelectedIndex;
			_app.SetSelectedDBIndex = _app.GetOptions().SelectedDBIndex;
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void btnSwitchOptions_Click(object sender, System.EventArgs e)
		{
//			bool bSelected = false;
//			_lrrProjOptions = SGTXmlSerializer.DeserializeXML(projOptionsFile,typeof(LRRProjectOptions)) as LRRProjectOptions;
//			
//			int nSelectedIndex = this._lrrProjOptions.SelectedIndex;
//			
//			ProjectInfo projInf = this._lrrProjOptions.ProjectInfosObj[nSelectedIndex];
//			
//			string optionsFile = @".\config\" + projInf.OptionFilePath;
//			
//			_app.OptionsFile = optionsFile;
//			
//			int nOptions = this._lrrProjOptions.ProjectInfosObj.Count;
//			ArrayList objProjectOptionsList = new ArrayList(nOptions);
//			
//			IEnumerator iProjOptEnum	= this._lrrProjOptions.ProjectInfosObj.GetEnumerator();
//			while(iProjOptEnum.MoveNext())
//			{
//				ProjectInfo	objProjectInfo= (ProjectInfo)iProjOptEnum.Current;
//				
//				if(projInf.OptionFileName == objProjectInfo.OptionFileName)
//					bSelected = true;
//				else
//					bSelected = false;
//
//				ProjectOptionDetails objProjectOptions = new ProjectOptionDetails(objProjectInfo.OptionFileName.ToString(),objProjectInfo.OptionFilePath.ToString(),bSelected);
//				objProjectOptionsList.Add(objProjectOptions);
//			}

			//ProjectOptionsForm amp = new ProjectOptionsForm(objProjectOptionsList);
			ProjectOptionsForm amp = new ProjectOptionsForm();
			amp.ShowDialog(this);
		}


		public string UserName
		{
			get{return txtUsername.Text;}
		}

		public string PassW
		{
			get{return txtPassword.Text;}
		}


		public String ErrorMessage
		{
			set
			{
				lblError.Text = value;
			}
		}


		private void Login_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			/*System.Drawing.Drawing2D.LinearGradientBrush lgb = new System.Drawing.Drawing2D.LinearGradientBrush(this.ClientRectangle,Color.White,Color.LavenderBlush,45,false);
			e.Graphics.FillRectangle(lgb,this.ClientRectangle);*/
		    //e.Graphics.DrawRectangle(new Pen(Color.Black,2),this.ClientRectangle);
		}

		private void pictureBox2_Click(object sender, System.EventArgs e)
		{
			string sFilePath = Application.StartupPath + @"\help\PE-Advisor Help.chm";
			Help.ShowHelp(this,sFilePath);
//			Process p = new Process();
//			string sFilePath = Application.StartupPath + @"\help\PE-Advisor Help.chm";
//			p.StartInfo.FileName = sFilePath;
//			p.Start();
		}

        private void linkLabelLoginPreferences_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            LoginPreferencesDialog loginPreferencesDialog = new LoginPreferencesDialog();
            loginPreferencesDialog.StartPosition = FormStartPosition.CenterParent;
            loginPreferencesDialog.ShowDialog();
        }

		private void chkRememberPass_CheckedChanged(object sender, EventArgs e)
		{
			 if(chkRememberPass.Checked==true)
			 {		  
					 _app.RememberPwd=true;
			 }
			 else
			 {
					 _app.RememberPwd=false;
			 }
			 
		}

		 

	 

	}
}
