using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.HistorianConnect;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ManualEntryForHistPoints.
	/// </summary>
	public class ManualEntryForHistPoints : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel pnlTop;
		private System.Windows.Forms.Label lblDateTime;
		private System.Windows.Forms.DateTimePicker dtDataSetTime;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridManualEntryHistPoints;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ManualEntryForHistPoints()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			this.dtDataSetTime.Value = DateTime.Now;
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp; //Get the App Object..
			InitDataSource();
			BindGrid();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ManualEntryForHistPoints));
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.gridManualEntryHistPoints = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlTop = new System.Windows.Forms.Panel();
			this.lblDateTime = new System.Windows.Forms.Label();
			this.dtDataSetTime = new System.Windows.Forms.DateTimePicker();
			this.pnlBottom.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridManualEntryHistPoints)).BeginInit();
			this.pnlTop.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlBottom
			// 
			this.pnlBottom.BackColor = System.Drawing.SystemColors.Control;
			this.pnlBottom.Controls.Add(this.gridManualEntryHistPoints);
			this.pnlBottom.Controls.Add(this.splitter1);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlBottom.Location = new System.Drawing.Point(0, 30);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(646, 289);
			this.pnlBottom.TabIndex = 4;
			// 
			// gridManualEntryHistPoints
			// 
			this.gridManualEntryHistPoints.BackColor = System.Drawing.SystemColors.Window;
			this.gridManualEntryHistPoints.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.gridManualEntryHistPoints.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridManualEntryHistPoints.Location = new System.Drawing.Point(0, 1);
			this.gridManualEntryHistPoints.Name = "gridManualEntryHistPoints";
			this.gridManualEntryHistPoints.Size = new System.Drawing.Size(646, 288);
			this.gridManualEntryHistPoints.TabIndex = 2;
			this.gridManualEntryHistPoints.TableOptions.AllowDropDownCell = false;
			this.gridManualEntryHistPoints.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridManualEntryHistPoints.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
			this.gridManualEntryHistPoints.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridManualEntryHistPoints.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridManualEntryHistPoints.Text = "gridGroupingControl1";
			this.gridManualEntryHistPoints.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridManualEntryHistPoints.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridManualEntryHistPoints.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridManualEntryHistPoints.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridManualEntryHistPoints.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridManualEntryHistPoints.VersionInfo = "3.301.0.0";
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(646, 1);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			this.splitter1.Visible = false;
			// 
			// pnlTop
			// 
			this.pnlTop.BackColor = System.Drawing.SystemColors.ControlDark;
			this.pnlTop.Controls.Add(this.lblDateTime);
			this.pnlTop.Controls.Add(this.dtDataSetTime);
			this.pnlTop.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlTop.Location = new System.Drawing.Point(0, 0);
			this.pnlTop.Name = "pnlTop";
			this.pnlTop.Size = new System.Drawing.Size(646, 30);
			this.pnlTop.TabIndex = 6;
			// 
			// lblDateTime
			// 
			this.lblDateTime.BackColor = System.Drawing.SystemColors.ControlDark;
			this.lblDateTime.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.lblDateTime.Location = new System.Drawing.Point(15, 8);
			this.lblDateTime.Name = "lblDateTime";
			this.lblDateTime.Size = new System.Drawing.Size(152, 10);
			this.lblDateTime.TabIndex = 1;
			this.lblDateTime.Tag = "SID_DATE_TIME";
			this.lblDateTime.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// dtDataSetTime
			// 
			this.dtDataSetTime.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.dtDataSetTime.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtDataSetTime.Location = new System.Drawing.Point(171, 0);
			this.dtDataSetTime.Name = "dtDataSetTime";
			this.dtDataSetTime.Size = new System.Drawing.Size(139, 20);
			this.dtDataSetTime.TabIndex = 2;
			this.dtDataSetTime.Value = new System.DateTime(2006, 12, 6, 0, 0, 0, 0);
			// 
			// ManualEntryForHistPoints
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(646, 319);
			this.Controls.Add(this.pnlBottom);
			this.Controls.Add(this.pnlTop);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ManualEntryForHistPoints";
			this.Tag = "SID_MANUAL_ENTRY_HIST_POINTS";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.pnlBottom.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridManualEntryHistPoints)).EndInit();
			this.pnlTop.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add ManualEntryForHistPoints.LeftColMovement implementation
		}

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(this.gridManualEntryHistPoints);
		}

		public void RightLevel()
		{
			// TODO:  Add ManualEntryForHistPoints.RightLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add ManualEntryForHistPoints.UpLevel implementation
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsLevel implementation
			return false;
		}

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add ManualEntryForHistPoints.PerformDirtyChk getter implementation
				return false;
			}
		}

		public bool SupportsRefresh()
		{
			return true;
		}

		public void Undo()
		{
			// TODO:  Add ManualEntryForHistPoints.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridManualEntryHistPoints);
            Refresh();
		}

		public bool SupportsCopy()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsCopy implementation
			return false;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(this.gridManualEntryHistPoints);
		}

		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		public void PageSetup()
		{
			// TODO:  Add ManualEntryForHistPoints.PageSetup implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add ManualEntryForHistPoints.OpenQuery implementation
		}

		public void Copy()
		{
			// TODO:  Add ManualEntryForHistPoints.Copy implementation
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsPageSetup implementation
			return false;
		}

		public void ShowPropertyList()
		{
			// TODO:  Add ManualEntryForHistPoints.ShowPropertyList implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			return true;
		}

		public void RightColMovement()
		{
			// TODO:  Add ManualEntryForHistPoints.RightColMovement implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add ManualEntryForHistPoints.LeftLevel implementation
		}

		public bool SupportsClearFilter()
		{
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsDelete implementation
			return false;
		}

		public void PrintPreview()
		{
			// TODO:  Add ManualEntryForHistPoints.PrintPreview implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsPaste implementation
			return false;
		}

		public void Print()
		{
			// TODO:  Add ManualEntryForHistPoints.Print implementation
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsPrint implementation
			return false;
		}

		public void OpenView()
		{
			// TODO:  Add ManualEntryForHistPoints.OpenView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add ManualEntryForHistPoints.TransposeView implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ManualEntryForHistPoints.ArrangeColumns implementation
		}

		public void Export()
		{
			if(this.gridManualEntryHistPoints.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridManualEntryHistPoints);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public void ShowComponentList()
		{
			// TODO:  Add ManualEntryForHistPoints.ShowComponentList implementation
		}

		public void ClearFilter()
		{
			SyncGridUtilities.ClearFilter(this.gridManualEntryHistPoints);
		}

		public void OpenCompositeView()
		{
			// TODO:  Add ManualEntryForHistPoints.OpenCompositeView implementation
		}

		public void Delete()
		{
			// TODO:  Add ManualEntryForHistPoints.Delete implementation
		}

		public bool SupportsUndo()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsUndo implementation
			return true;
		}

		public bool SupportsExport()
		{
			return true;
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add ManualEntryForHistPoints.CopyUOMTypes implementation
		}

		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridManualEntryHistPoints);
		}

		public void Refresh()
		{
			this.gridManualEntryHistPoints.TableModel.CellModels.Remove("DropDownTree");  
			this.gridManualEntryHistPoints.TableDescriptor.Relations.Clear();
			this.gridManualEntryHistPoints.QueryCellStyleInfo-=new GridTableCellStyleInfoEventHandler(gridManualEntryHistPoints_QueryCellStyleInfo);  
			InitDataSource();
			BindGrid();
		}

		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void DownLevel()
		{
			// TODO:  Add ManualEntryForHistPoints.DownLevel implementation
		}

		public void Paste()
		{
			// TODO:  Add ManualEntryForHistPoints.Paste implementation
		}

		public bool SupportsSave()
		{
			return true;
		}

		public void InsertNewRows()
		{
			// TODO:  Add ManualEntryForHistPoints.InsertNewRows implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add ManualEntryForHistPoints.CopyMasterProperties implementation
		}

		public void Save()
		{
			LRRManualEntryHistorianDataSetDatas manualEntryHistDataSetDatas = _lrrManualEntryHistDataSetDatas.GetChanges();
			if(manualEntryHistDataSetDatas.Count > 0)
			{
				LRRManualEntryHistorianDataSet manualEntryHistDataSet = new LRRManualEntryHistorianDataSet();
				manualEntryHistDataSet.EffectiveTime = dtDataSetTime.Value;
				manualEntryHistDataSet.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
				
				IEnumerator iEnum = manualEntryHistDataSetDatas.GetEnumerator();
				while(iEnum.MoveNext())
				{
					LRRManualEntryHistorianDataSetData manualEntryHistDataSetData = iEnum.Current as LRRManualEntryHistorianDataSetData;
					manualEntryHistDataSetData.DataSetID = manualEntryHistDataSet.ID;
					manualEntryHistDataSetData.EffectiveTime = manualEntryHistDataSet.EffectiveTime;
				}
				
				//Commit the collections
				LRRManualEntryHistorianDataBase manualEntryHistDB = _lrrApp.GetOptions().ManualEntryHistorianDataBaseObj;
				if(manualEntryHistDB != null && manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_TUNING"))
				{
                    if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.TUNNING))
                    {
                        TuningHistorian tuningHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.TUNNING] as TuningHistorian;
                        tuningHist.CommitObject(manualEntryHistDataSet);
                        tuningHist.CommitCollection(manualEntryHistDataSetDatas);
                    }
                    
				}
				else if(manualEntryHistDB != null && manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_OFFLINE"))
				{
                    if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.OFFLINE))
                    {
                        OffLineHistorian offlineHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.OFFLINE] as OffLineHistorian;
                        offlineHist.CommitObject(manualEntryHistDataSet);
                        offlineHist.CommitCollection(manualEntryHistDataSetDatas);
                    }
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_MANUAL_HISTDB_CONFIG","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
					//MessageBox.Show("Please configure the Database in the Options");
					return;
				}
				
				Refresh();
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			}
			else
			{
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
			}
		}

		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add ManualEntryForHistPoints.SupportsCopyUOMTypes implementation
			return false;
		}

		#endregion

		#region Methods
		/// <summary>
		/// Method gets the Hist Points that does not exist on the server
		/// </summary>
		public static LRRManualEntryHistorianDataSetDatas GetHistPointsForManualEntry()
		{
			//Get the Historian Interface
            string histConnTypeStr = "";
			HistorianConnectionType histConnType = HistorianConnectionType.ONLINE;
            if (_lrrApp.ActiveRunControlSet.DataSourceType.ToUpper() == LRRHeaderText.GetHeaderString("SID_TUNING").ToUpper())
            {
                histConnType = HistorianConnectionType.TUNING;
                histConnTypeStr = _lrrApp.TUNNING;
            }
            else if (_lrrApp.ActiveRunControlSet.DataSourceType.ToUpper() == LRRHeaderText.GetHeaderString("SID_ONLINE").ToUpper())
            {
                histConnType = HistorianConnectionType.ONLINE;
                histConnTypeStr = "Online";
            }
            else if (_lrrApp.ActiveRunControlSet.DataSourceType.ToUpper() == LRRHeaderText.GetHeaderString("SID_OFFLINE").ToUpper())
            {
                histConnType = HistorianConnectionType.OFFLINE;
                histConnTypeStr = _lrrApp.OFFLINE;
            }

			//IHistorian iHist = _lrrApp.RunControllerObj.GetActiveHistorian(histConnType);

			//Get the Historian Data
			LRRHistDatas lrrHistDatas = LRRModel.HistDatas;
			
			//Loop through the points,check if it exists on the server
			LRRManualEntryHistorianDataSetDatas manualEntryHistDatas = new LRRManualEntryHistorianDataSetDatas();
			DateTime dtTime = new DateTime(1,1,1);
			IEnumerator iHistDataEnum = lrrHistDatas.GetEnumerator();
			while(iHistDataEnum.MoveNext())
			{
                 
				LRRHistData histData = iHistDataEnum.Current as LRRHistData;
                IHistorian iHist = null;
                if (histConnTypeStr != "")
                {
                    if (histConnTypeStr == _lrrApp.TUNNING)
                    {
                        if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.TUNNING))
                            iHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.TUNNING];
                        
                    }
                    else if (histConnTypeStr == _lrrApp.OFFLINE)
                    {
                        if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.OFFLINE))
                            iHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.OFFLINE];
                    }
                    else
                    {
                        string sourceInfo = histData.SourceType;
                        if (sourceInfo != null && sourceInfo.Trim() != "")
                        {
                            if (_lrrApp.LoadedOnLineHistorianAssemblies.ContainsKey(sourceInfo))
                                iHist = _lrrApp.LoadedOnLineHistorianAssemblies[sourceInfo];
                        }
                    }
                }
                if (iHist != null)
                {
                    
                
				DateTime creationDate = iHist.GetCreationDateTime(histData.HistTag,histData.ServerID);
				//If the point does not exists
				if(creationDate.CompareTo(dtTime) == 0)
				{
					LRRManualEntryHistorianDataSetData manualEntryHistData = new LRRManualEntryHistorianDataSetData();
					manualEntryHistData.HistTag = histData.HistTag;
					manualEntryHistData.UOM = histData.InterfaceUnits;
					manualEntryHistData.PlantUnit = histData.PlantUnit;
					manualEntryHistDatas.Add(manualEntryHistData);
				}
            }
			}
			return manualEntryHistDatas;
		}

		private void BindGrid()
		{
			//Suspend the Layout of the Grid...
			this.gridManualEntryHistPoints.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridManualEntryHistPoints);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridManualEntryHistPoints,_lrrManualEntryHistDataSetDatas.ItemType,null,true,null);
			
			this.gridManualEntryHistPoints.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridManualEntryHistPoints.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridManualEntryHistPoints.BackColor = System.Drawing.SystemColors.Window;
			this.gridManualEntryHistPoints.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridManualEntryHistPoints.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridManualEntryHistPoints.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridManualEntryHistPoints.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridManualEntryHistPoints.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_HIST_POINTS") +":{RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridManualEntryHistPoints.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;
			this.gridManualEntryHistPoints.GridGroupDropArea.Text = LRRHeaderText.GetHeaderString("SID_HIST_POINTS");
			this.gridManualEntryHistPoints.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridManualEntryHistPoints.TableDescriptor.AllowNew = true;
			this.gridManualEntryHistPoints.TableDescriptor.AllowEdit = true;
			this.gridManualEntryHistPoints.TableDescriptor.AllowRemove = false;

			this.gridManualEntryHistPoints.SourceListSet.Add("Parent",_lrrManualEntryHistDataSetDatas);

			this.gridManualEntryHistPoints.TableDescriptor.Relations.Clear();
			this.gridManualEntryHistPoints.DataSource = null;
			this.gridManualEntryHistPoints.DataSource = _lrrManualEntryHistDataSetDatas;

			// registration for Tree Control for Plant levels....
			this.gridManualEntryHistPoints.TableModel.CellModels.Add("DropDownTree",new PlantLevelUserFormTreeControl(this.gridManualEntryHistPoints.TableModel,new PlantLevelTreeControlStructure()));         
			this.gridManualEntryHistPoints.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridManualEntryHistPoints_QueryCellStyleInfo);

			GridTableCellStyleInfo gtc = this.gridManualEntryHistPoints.TableDescriptor.Columns["HistTag"].Appearance.AnyRecordFieldCell;
			gtc.ReadOnly = true;

			GridTableCellStyleInfo gtc2 = this.gridManualEntryHistPoints.TableDescriptor.Columns["PlantUnit_Name"].Appearance.AnyRecordFieldCell;
			gtc2.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			gtc2.ExclusiveChoiceList = false;
			gtc2.ReadOnly = true;
			
			GridTableCellStyleInfo gtc1 = this.gridManualEntryHistPoints.TableDescriptor.Columns["UOM"].Appearance.AnyRecordFieldCell;
			gtc1.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			gtc1.ExclusiveChoiceList = false;
			gtc1.ReadOnly = true;
			
			this.gridManualEntryHistPoints.ContextMenu = _contMenuViewHistory;
			_contMenuViewHistory.MenuItems.Clear();
			_contMenuViewHistory.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_HISTORY"),new EventHandler(ViewHistory)));


			this.gridManualEntryHistPoints.ResumeLayout(true);
		}

		private void InitDataSource()
		{
			if(_levels!= null)
				_levels.Clear();

			_lrrManualEntryHistDataSetDatas = GetHistPointsForManualEntry();

			_levels = new LRRLevels();
			_lrrApp.DBManagerObj.PopulateCollection(_levels,false);  
		}
		#endregion

		#region Fields
		private static LRRApp _lrrApp;
		private LRRManualEntryHistorianDataSetDatas _lrrManualEntryHistDataSetDatas;

		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;

		private ContextMenu			_contMenuViewHistory = new ContextMenu();

		private LRRLevels _levels;
		#endregion
		
		#region EventHandlers
		private void ViewHistory(object sender, System.EventArgs e)
		{
			Element eCurrentElement = this.gridManualEntryHistPoints.TableControl.Table.CurrentElement;
			GridRecord gnt = eCurrentElement as GridRecord;
			LRRManualEntryHistorianDataSetData histDataPoint = eCurrentElement.GetRecord().GetData() as LRRManualEntryHistorianDataSetData;

			ViewHistoryManualHistPoints historyForm = new ViewHistoryManualHistPoints(histDataPoint);
			historyForm.ShowDialog();
		}

		private void gridManualEntryHistPoints_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
		  try
			{
		      if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
		     {  
	             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
	             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
		     }  
			}
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
			if(e.TableCellIdentity.RowIndex < 0)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex) == null)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_LEVEL") && e.TableCellIdentity.RowIndex > 3)
			{
				e.Style.CellType = "DropDownTree";
				string displaymember = e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit") == null ? "" :e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit").ToString();          
				if(displaymember != "")
				{
					string sFilter;
					sFilter = "LevelID = " + displaymember;
					_levels.ItemFilter = sFilter;
					GridTableCellStyleInfo gsi = new GridTableCellStyleInfo();
					gsi = e.Style;
					if(gsi != null)
					{
						if(_levels.Count>0)
							gsi.FormattedText = _levels[0].Name;  
						gsi.WrapText = true;
						gsi.AutoSize = true;
					}	
					_levels.ItemFilter ="";
				}
			}
		}
		#endregion
	}
}
