using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.LightRidge.PEAdvisor.UserControls;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;  

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for Options.
	/// </summary>
	public class Options : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.TreeView tvOptions;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel1;
		private Symcon.LightRidge.PEAdvisor.UserControls.OptionsUserControl userControlOptionsMain;
		private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		private System.ComponentModel.IContainer components;
		private LRRApp						_app;
		private LRROptions				_lrrOptionsObj; //Local copy of the Options Object...
		private Database.DBManager		_dbManager;
		private Database.DataAdapter	_dataAdapter;
		private LRRDataStore			_lrrDataStore ;
		private TabControl					_parentTabControl;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ImageList imageList2;
		private TabPage						_parentTabPage;

		public Options(string Source)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InternationalizationUtils.GetControlText(this,null);

            _app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			_lrrOptionsObj = _app.GetOptions() as LRROptions;
			
			int nSelectedIndex = this._lrrOptionsObj.SelectedDBIndex;
			_dbManager = _app.DBManagerObj;
			_dataAdapter = _app.DataAdapterObj;
			_lrrDataStore= _app.LRRDataStoreObj;

			//This Method Create the Nodes
			CreateNodes();

			if(Source == "Login")
			{
				tvOptions.ExpandAll();
				tvOptions.Enabled=false;
				userControlOptionsMain.ActivateControl("SID_DB_INFO");
				userControlOptionsMain.CaptionText=LRRHeaderText.GetHeaderString("SID_DB_INFO"); 
				tvOptions.Visible=false;
			}
			else
			{
				tvOptions.Visible=true;
				this.MaximizeBox=true;
				this.MinimizeBox=true;
				tvOptions.ExpandAll();
				tvOptions.Enabled=true;
				tvOptions.BackColor=Color.White;
				this.WindowState=FormWindowState.Maximized;
			}
		}
		/// <summary>
		/// Overloaded Constructor for Options
		/// </summary>
		/// <param name="lrrOptions"></param>
		public Options(LRROptions lrrOptions)
		{
			InitializeComponent();
			_lrrOptionsObj = lrrOptions;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Options));
			this.tvOptions = new System.Windows.Forms.TreeView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.userControlOptionsMain = new Symcon.LightRidge.PEAdvisor.UserControls.OptionsUserControl();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.imageList2 = new System.Windows.Forms.ImageList(this.components);
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tvOptions
			// 
			this.tvOptions.BackColor = System.Drawing.SystemColors.Window;
			this.tvOptions.Dock = System.Windows.Forms.DockStyle.Left;
			this.tvOptions.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tvOptions.ImageIndex = -1;
			this.tvOptions.Location = new System.Drawing.Point(0, 0);
			this.tvOptions.Name = "tvOptions";
			this.tvOptions.SelectedImageIndex = -1;
			this.tvOptions.Size = new System.Drawing.Size(216, 390);
			this.tvOptions.TabIndex = 1;
			this.tvOptions.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvOptions_AfterSelect);
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(216, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 390);
			this.splitter1.TabIndex = 3;
			this.splitter1.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.userControlOptionsMain);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(219, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(573, 390);
			this.panel1.TabIndex = 4;
			// 
			// userControlOptionsMain
			// 
			this.userControlOptionsMain.ActivePane = null;
			this.userControlOptionsMain.CaptionText = "";
			this.userControlOptionsMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.userControlOptionsMain.Location = new System.Drawing.Point(0, 0);
			this.userControlOptionsMain.Name = "userControlOptionsMain";
			this.userControlOptionsMain.ParentTabControl = null;
			this.userControlOptionsMain.ParentTabPage = null;
			this.userControlOptionsMain.Size = new System.Drawing.Size(573, 390);
			this.userControlOptionsMain.TabIndex = 0;
			this.userControlOptionsMain.Tag = "SID_OPTIONSUSERCTRL";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// imageList2
			// 
			this.imageList2.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
			this.imageList2.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// Options
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 390);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.tvOptions);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Options";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_OPTIONS";
			this.Activated += new System.EventHandler(this.Options_Activated);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		private void CreateNodes()
		{
			tvOptions.ImageList=imageList2;
			TreeNode tvnProjectConfiguration = CreateParentNode(LRRHeaderText.GetHeaderString("SID_PJCTCONFIGURATION"));
			AddChildNode(tvnProjectConfiguration,"Mode Definition","SID_MODE_DEF",18);
			AddChildNode(tvnProjectConfiguration,"Mode Set Definition","SID_MODE_SETS",19);
			AddChildNode(tvnProjectConfiguration,"Data Type Definition","SID_45",20);
			AddChildNode(tvnProjectConfiguration,"UOM Definition","SID_UOM_DEF",20);
			AddChildNode(tvnProjectConfiguration,"UOM Type Definition","SID_UOM_TYPE_DEF",20);
			AddChildNode(tvnProjectConfiguration,"UOM Set Definition","SID_UOM_SET_DEF",20);
			AddChildNode(tvnProjectConfiguration,"Enumerated Valid Values Definition","SID_EVV_DEFN",23);
			AddChildNode(tvnProjectConfiguration,"Configured UOMs","SID_CONFIG_UOMS",20);
			AddChildNode(tvnProjectConfiguration,"UCF Definition","SID_UCF_DEF",21);
			AddChildNode(tvnProjectConfiguration,"Qualifiers","SID_QUALIFIERS",16);
			AddChildNode(tvnProjectConfiguration,"Chemical Components","SID_CHEMICAL_COMP",12);
			AddChildNode(tvnProjectConfiguration,"Data Arrays","SID_DATA_ARRAYS",17);
			AddChildNode(tvnProjectConfiguration,"Refrigerants","SID_AVAILABLE_REFG",23);
			AddChildNode(tvnProjectConfiguration,"Constants","SID_CONSTANT",23);
			AddChildNode(tvnProjectConfiguration,LRRHeaderText.GetHeaderString("SID_TREND_OPTIONS"),"SID_TREND_OPTIONS",23);
			AddChildNode(tvnProjectConfiguration,"Trend Templates","SID_TREND_TEMPLATES",23);
			AddChildNode(tvnProjectConfiguration,"Trend Compression","SID_TREND_COMPRESSION",23);
            AddChildNode(tvnProjectConfiguration, "Excel Views", "SID_EXCEL_VIEWS", 23);
            AddChildNode(tvnProjectConfiguration, "RollUp Type", "SID_ROLL_UP_TYPE",17);


			// Constants Historian Mappings
			AddChildNode(tvnProjectConfiguration,"Constant Historian Mapping","SID_CONST_HIST_MAPPING",23);
			AddChildNode(tvnProjectConfiguration,"Preferences","SID_PERSISTANCE",10);
			AddChildNode(tvnProjectConfiguration,"Historian Text Collection","SID_HIST_TEXT_COLLECTION",23);

            TreeNode tvnDataConInfo = new TreeNode(LRRHeaderText.GetHeaderString("SID_DATACONNECTION_INFO"));
			AddChildNode(tvnDataConInfo,"Database Information","SID_DB_INFO",11);
		//	AddChildNode(tvnDataConInfo,"Historian Information",9,14);


			AddChildNode(tvnDataConInfo,"Tuning Information","SID_13",13);
			AddChildNode(tvnDataConInfo,"Offline Information","SID_14",15);
			AddChildNode(tvnDataConInfo,"Recording Values Information","SID_15",22);
			AddChildNode(tvnDataConInfo,"Messaging Server","SID_MSG_SERVER",13);


			//Remoting Server Configuration Tab
			TreeNode tvnRemotingServerInfo = new TreeNode(LRRHeaderText.GetHeaderString("SID_REMOTING_SERVER_INFO"));
			AddChildNode(tvnRemotingServerInfo,"Remoting Server Information","SID_REMOT_SERVER_INFO",9);

			tvOptions.Nodes.Add(tvnProjectConfiguration);
			tvOptions.Nodes.Add(tvnDataConInfo);
			tvOptions.Nodes.Add(tvnRemotingServerInfo);

			TreeNode historianConnectInfo = new TreeNode(LRRHeaderText.GetHeaderString("SID_HIST_CONN_INFO"));
			AddChildNode(historianConnectInfo,"Online Historian Details","SID_ONLINE_HIST_DETL",20);
			tvOptions.Nodes.Add(historianConnectInfo);

			for(int i=0;i<tvOptions.Nodes.Count;i++)
			{
				TreeNode tNode = tvOptions.Nodes[i] as TreeNode;
				ApplyInternationalizationForOption(tNode); 
				if(tNode.Nodes.Count > 0)
				{
					for(int j=0;j<tNode.Nodes.Count;j++)
					{
						TreeNode childTNode = tNode.Nodes[j] as TreeNode; 
						ApplyInternationalizationForOption(childTNode); 
					}
				}
			}
		}

		private void ApplyInternationalizationForOption(TreeNode tNode)
		{
			if(tNode.Tag != null)
			{
				string tag = tNode.Tag.ToString();  
				string nodeText = LRRHeaderText.GetHeaderString(tag);
				tNode.Text = nodeText;
			}
        }
		public void SetInputReadState(bool state)
		{
			UserControlPersistance up = userControlOptionsMain.GetUISettingsControl();
			if(up != null)
			{
				up.SetReadInputFromEngineState(state);
			}
		}
		private TreeNode CreateParentNode(string name)
		{
			return new TreeNode(name);
		}

		private void  AddChildNode(TreeNode parentNode,string childName,string index,int imageindex)
		{
			
			TreeNode trnode = new TreeNode(childName);
			trnode.Tag = index;
			trnode.ImageIndex=imageindex;
			//Added for Applying AccessPermissions
			string sSCRN_ID = childName == null ? "" : childName;
			sSCRN_ID=sSCRN_ID.Replace("&","");
			if(sSCRN_ID != "")
			{
				//Uncomment it - Sandeep if(UIAccessController.UIACLController.IsUIEntityAccessible(sSCRN_ID))
					parentNode.Nodes.Add(trnode);
			}
			
		}
		#endregion
		private void tvOptions_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			this.Cursor=Cursors.WaitCursor;
			try
			{
				if(e.Node.Tag != null)
				{
					string id  = e.Node.Tag.ToString();
					userControlOptionsMain.CaptionText = e.Node.Text; 
					userControlOptionsMain.ActivateControl(id);
					userControlOptionsMain.Disposed+=new EventHandler(userControlOptionsMain_Disposed);  
					
				}
				else
				{
					string id="SID_18";
					userControlOptionsMain.CaptionText = LRRHeaderText.GetHeaderString(id);
					userControlOptionsMain.ActivateControl(id);
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(Options),"tvOptions_AfterSelect Event:"+ex.Message,Logger.Level.Debug);
			}
			this.Cursor=Cursors.Default;
		}
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			userControlOptionsMain.Refresh();
		}

		public void Save()
		{
			try
			{
				userControlOptionsMain.Save();
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(Options),"Exception In  Saving Options:"+ex.Message  ,Logger.Level.Debug);
			}
		
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			try
			{
				userControlOptionsMain.Print();
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(Options),"Exception In Printing Options:"+ex.Message  ,Logger.Level.Debug);

			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add ComplexEquip.ClearFilter implementation

		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			userControlOptionsMain.SelectionPaste();
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return false;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			return false;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			userControlOptionsMain.ClearSort();
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add Options.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		userControlOptionsMain.CopyUOMTypes();
		}

		public bool SupportsCopyUOMTypes()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add Options.PrintPreview implementation
			try
			{
				userControlOptionsMain.PrintPreview();
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(Options),"Exception In Print Preview:"+ex.Message  ,Logger.Level.Debug);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add Options.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add Options.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add Options.SupportsResultsFilter implementation
			return false;
		}

		#endregion
		private void userControlOptionsMain_Disposed(object sender, EventArgs e)
		{
			_gridExcelFormatter.UnwireGrid(); 
		}
		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add Options.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add Options.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add Options.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add Options.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add Options.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add Options.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add Options.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add Options.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add Options.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add Options.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add Options.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add Options.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add Options.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add Options.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private void Options_Activated(object sender, System.EventArgs e)
		{
			if(tvOptions.SelectedNode != null)
			{
				string id = tvOptions.SelectedNode.Tag as string;
				if(id == "SID_10")
				{
					UserControl userCtrl = userControlOptionsMain.GetControl(id);
					if(userCtrl != null)
					{
						UserControlUCFDefinition userCtrlUCF = userCtrl as UserControlUCFDefinition;
						userCtrlUCF.SetFormulaDataStrore();
					}
				}
			}
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add Options.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
