using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher; 
using Symcon.LightRidge.BusinessObjects.TypeEditors; 
using Symcon.LightRidge.PEAdvisor.DataStore;


namespace Symcon.LightRidge.PEAdvisor

{
	/// <summary>
	/// Summary description for OverrideFormulaWindow.
	/// </summary>
	public class OverrideFormulaWindow : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OverrideFormulaWindow()
		{
			//d
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InternationalizationUtils.GetControlText(this,null); 
			
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrFormulaOverrideModelObject = LRRModel.FormulaOverridesObj; 
			InitDataSource();
			
			BindGrid();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		#region Methods
		private void InitDataSource()
		{
			string sourceObjID = LRRFormulaDataStore.SourceObjectID;

			_lrrFormulaOverrides = LRRModel.FormulaOverridesObj.FilterFormulasBySourceObjectID(sourceObjID);

			LRRSiteComponentPropertyValue lrrPropValueObj = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(sourceObjID);
			if(lrrPropValueObj != null)
			{
				LRRFormula lrrFormula = lrrPropValueObj.FormulaObj;

				if(lrrFormula.SourceObjectID != null)
				{
					defaultFormula = _lrrFormulaOverrides.GetDefaultFormulaObj(lrrFormula.ID);
					if(defaultFormula == null)
					{
						AddDefaultFormula(sourceObjID);
						
					}

					bool activeexists = false;

					foreach(LRRFormulaOverride formulaOverride in _lrrFormulaOverrides)
					{
						if(formulaOverride.IsActive)
						{
							activeexists = true;
						}
					}
					//Set Active Formula
					if(!activeexists)
					setActiveFormulaOnUI(lrrFormula.ID);

					activeexists = false;
					
			}
				else
				{
//					LRRFormula lrrtempformula = new LRRFormula();
//					lrrtempformula.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;

					//defaultFormula = _lrrFormulaOverrides.GetDefaultFormulaObj(lrrFormula.ID);

					LRRFormulaOverride ovDefaultFormula =  _lrrFormulaOverrides.GetDefaultFormulaObjbysourceobjectID(sourceObjID);
					if(ovDefaultFormula != null)
					{
						//LRRModel.FormulasObj.Add(lrrFormula);
						lrrFormula.ID = ovDefaultFormula.FormulaID;
						lrrFormula.SourceObjectID = sourceObjID;
						lrrFormula.FormulaName = ovDefaultFormula.FormulaName;
						lrrFormula.FormulaDescription = ovDefaultFormula.FormulaDescription;
						LRRModel.FormulasObj.Add(lrrFormula);
						lrrFormula.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;

					}
					else if(LRRModel.FormulasObj.GetFormulaObjFromID(lrrFormula.ID) == null)
					{
                        LRRModel.FormulasObj.Add(lrrFormula);
						lrrFormula.SourceObjectID = sourceObjID;
						lrrFormula.FormulaName = "Default";
						lrrFormula.FormulaDescription = "For internal implementation.Not to be used for calculation";
						lrrFormula.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;

						defaultFormula = _lrrFormulaOverrides.GetDefaultFormulaObj(lrrFormula.ID);
						if(defaultFormula == null)
						{
							//AddDefaultFormula(sourceObjID);
							LRRSiteComponentPropertyValue lrrPropValueObj1 = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(sourceObjID);
							LRRFormula lrrFormula1 = lrrPropValueObj1.FormulaObj;
							defaultFormula = new LRRFormulaOverride();
							defaultFormula.FormulaID = lrrFormula1.ID;
							defaultFormula.Expression = lrrFormula1.Expression;
							defaultFormula.FormulaName = lrrFormula1.FormulaName;
							defaultFormula.FormulaDescription = lrrFormula1.FormulaDescription;
							defaultFormula.Params = lrrFormula1.Params;
							defaultFormula.IsCustomFormula = lrrFormula1.IsCustomFormula;
							defaultFormula.IsFormula = lrrFormula1.IsFormula;
							defaultFormula.MethodName = lrrFormula1.MethodName;
							defaultFormula.PostCalc = lrrFormula1.PostCalc;
							defaultFormula.PreCalc = lrrFormula1.PreCalc;
							defaultFormula.SourceCollectionName = lrrFormula1.SourceCollectionName;
							defaultFormula.SourceLookUpPropertyID = lrrFormula1.SourceLookUpPropertyID;
							defaultFormula.SourceLookUpQualifierID = lrrFormula1.SourceLookUpQualifierID;
							defaultFormula.SourceObjectID = lrrFormula1.SourceObjectID;
							defaultFormula.SourcePropertyID = lrrFormula1.SourcePropertyID;
							defaultFormula.ModeID = lrrFormula1.ModeID; 
							defaultFormula.IsDefault = true;
							bool activeexists = false;

							foreach(LRRFormulaOverride formulaOverride in _lrrFormulaOverrides)
							{
								if(formulaOverride.IsActive)
								{
									activeexists = true;
								}
							}

							if(!activeexists)
							{
								defaultFormula.IsActive = true;
								_unBound.SetRecord(defaultFormula,true);
								setActiveFormulaOnUI(lrrFormula.ID);
							}
							else
							{
								defaultFormula.IsActive = false;
							}
							
							activeexists = false;

							//defaultFormula.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;
							//_unBound.SetRecord(defaultFormula,true); 
							_lrrFormulaOverrides.Add(defaultFormula);
							_lrrFormulaOverrideModelObject.Add(defaultFormula);

						}
						//Set Active Formula
						//setActiveFormulaOnUI(lrrFormula.ID);
					}
					
				}
				
			}

			///Commented By Vihar
			/*LRRSiteComponentPropertyValue lrrPropValueObj = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(sourceObjID);
			LRRFormula lrrFormula = lrrPropValueObj.FormulaObj;
			
			if(lrrFormula != null)
			{
				LRRFormulaOverride lrrFormulaOverride = new LRRFormulaOverride();
				lrrFormulaOverride.ID = lrrFormula.ID;
				lrrFormulaOverride.FormulaID = lrrFormula.ID;
				lrrFormulaOverride.FormulaName = lrrFormula.FormulaName;
				lrrFormulaOverride.Expression = lrrFormula.Expression;
				if(lrrFormulaOverride.Expression != null && lrrFormulaOverride.Expression != "")
				{
					lrrFormulaOverride.IsActive = true;
				}
				
				_lrrFormulaOverrides.Add(lrrFormulaOverride);
			}*/
			
		}


		private void AddDefaultFormula(string sourceObjID)
		{
			LRRSiteComponentPropertyValue lrrPropValueObj = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(sourceObjID);
			LRRFormula lrrFormula = lrrPropValueObj.FormulaObj;
			defaultFormula = new LRRFormulaOverride();
			defaultFormula.FormulaID = lrrFormula.ID;
			defaultFormula.Expression = lrrFormula.Expression;
			defaultFormula.FormulaName = lrrFormula.FormulaName;
			defaultFormula.FormulaDescription = lrrFormula.FormulaDescription;
			defaultFormula.Params = lrrFormula.Params;
			defaultFormula.IsCustomFormula = lrrFormula.IsCustomFormula;
			defaultFormula.IsFormula = lrrFormula.IsFormula;
			defaultFormula.MethodName = lrrFormula.MethodName;
			defaultFormula.PostCalc = lrrFormula.PostCalc;
			defaultFormula.PreCalc = lrrFormula.PreCalc;
			defaultFormula.SourceCollectionName = lrrFormula.SourceCollectionName;
			defaultFormula.SourceLookUpPropertyID = lrrFormula.SourceLookUpPropertyID;
			defaultFormula.SourceLookUpQualifierID = lrrFormula.SourceLookUpQualifierID;
			defaultFormula.SourceObjectID = lrrFormula.SourceObjectID;
			defaultFormula.SourcePropertyID = lrrFormula.SourcePropertyID;
			defaultFormula.ModeID = lrrFormula.ModeID; 
			defaultFormula.IsDefault = true;
			defaultFormula.IsActive = true;
            _unBound.SetRecord(defaultFormula,true); 
			_lrrFormulaOverrides.Add(defaultFormula);
			_lrrFormulaOverrideModelObject.Add(defaultFormula);
		}

		private void BindGrid()
		{
			SyncGridUtilities.InitializeGridColumns(gridFormulaOverrides,gridFormulaOverrides.TableDescriptor,_lrrFormulaOverrides.ItemType,null,true,null,null,true);
			SyncGridUtilities.InitializeGridLookAndFeel(gridFormulaOverrides);
		
			gridFormulaOverrides.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_OVERRIDE_FORMULA") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");
			this.gridFormulaOverrides.TableDescriptor.AllowNew = false;

			/*if(_lrrFormulaOverrides.Count.ToString() == "1")
			{
				//
				this.gridFormulaOverrides.TableDescriptor.AllowEdit = false;
			}
			else
			{
				//
				this.gridFormulaOverrides.TableDescriptor.AllowEdit = true;
			}
			this.gridFormulaOverrides.TableDescriptor.AllowRemove = false;*/

			this.gridFormulaOverrides.TableDescriptor.Relations.Clear();
			gridFormulaOverrides.DataSource = null;	
			gridFormulaOverrides.DataSource = _lrrFormulaOverrides;	

			bool overridenflag = false;

			foreach(LRRFormulaOverride oVFormula in _lrrFormulaOverrides)
			{
				if(oVFormula.IsActive)
				{
					_unBound.SetRecord(oVFormula,true);
					overridenflag = true;
					break;
				}
			}

			if(!overridenflag)
			{
				// code for showing the default formula as active
				//
			}
			_unBound.WireGrid(gridFormulaOverrides);
			overridenflag = false;

			for(int i=0;i<gridFormulaOverrides.TableDescriptor.Columns.Count;i++)
			{
				if(gridFormulaOverrides.TableDescriptor.Columns[i].Name == LRRHeaderText.GetHeaderString("SID_SELECT"))
				{
					gridFormulaOverrides.TableDescriptor.Columns[i].HeaderText = "IsActive";
					break;
				}
			}

//			_unBound.WireGrid(gridFormulaOverrides);
//			
//			gridFormulaOverrides.TableDescriptor.Columns.Remove("ModelUOM");
//			gridFormulaOverrides.TableDescriptor.Columns.Remove("UIUOM");
//
//			gridFormulaOverrides.TableDescriptor.Columns["Locale"].Appearance.AnyRecordFieldCell.ReadOnly = true;
//			gridFormulaOverrides.TableDescriptor.Columns["Description"].Appearance.AnyRecordFieldCell.ReadOnly = true;

		}

		#endregion

		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridFormulaOverrides;
		private System.Windows.Forms.Panel pnlRight;
		private System.Windows.Forms.Panel pnlLeft;
		private System.Windows.Forms.Button btnAdd;
		private System.Windows.Forms.Button btnEdit;

		#region Fields
		private LRRFormulaOverrides _lrrFormulaOverrides;
		private LRRFormulaOverrides _lrrFormulaOverrideModelObject;
		private System.Windows.Forms.Button btnok;
		private System.Windows.Forms.Button btncancel;
		private LRRApp					_app;
		private bool					_isEdit = false;
		private LRRFormulaOverride		defaultFormula;
		private LRRFormulaOverride		activeFormulaOverride;
		private GridUnBoundColumn		_unBound  = new GridUnBoundColumn();
		private bool					isActiveChanged = false;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnDelete;
        

		Hashtable lrrFormuladatasource = new Hashtable();
		#endregion
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(OverrideFormulaWindow));
			this.gridFormulaOverrides = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlRight = new System.Windows.Forms.Panel();
			this.pnlLeft = new System.Windows.Forms.Panel();
			this.btnAdd = new System.Windows.Forms.Button();
			this.btnEdit = new System.Windows.Forms.Button();
			this.btnDelete = new System.Windows.Forms.Button();
			this.btnok = new System.Windows.Forms.Button();
			this.btncancel = new System.Windows.Forms.Button();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			((System.ComponentModel.ISupportInitialize)(this.gridFormulaOverrides)).BeginInit();
			this.pnlRight.SuspendLayout();
			this.pnlLeft.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// gridFormulaOverrides
			// 
			this.gridFormulaOverrides.BackColor = System.Drawing.SystemColors.Window;
			this.gridFormulaOverrides.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridFormulaOverrides.Location = new System.Drawing.Point(0, 0);
			this.gridFormulaOverrides.Name = "gridFormulaOverrides";
			this.gridFormulaOverrides.Size = new System.Drawing.Size(554, 261);
			this.gridFormulaOverrides.TabIndex = 0;
			this.gridFormulaOverrides.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridFormulaOverrides.Text = "gridGroupingControl1";
			this.gridFormulaOverrides.VersionInfo = "3.301.0.0";
			this.gridFormulaOverrides.TableControlCurrentCellChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridFormulaOverrides_TableControlCurrentCellChanged);
			this.gridFormulaOverrides.TableControlCurrentCellChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridFormulaOverrides_TableControlCurrentCellChanging);
			// 
			// pnlRight
			// 
			this.pnlRight.Controls.Add(this.gridFormulaOverrides);
			this.pnlRight.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlRight.Location = new System.Drawing.Point(0, 0);
			this.pnlRight.Name = "pnlRight";
			this.pnlRight.Size = new System.Drawing.Size(554, 261);
			this.pnlRight.TabIndex = 1;
			// 
			// pnlLeft
			// 
			this.pnlLeft.Controls.Add(this.btnAdd);
			this.pnlLeft.Controls.Add(this.btnEdit);
			this.pnlLeft.Controls.Add(this.btnDelete);
			this.pnlLeft.Controls.Add(this.btnok);
			this.pnlLeft.Controls.Add(this.btncancel);
			this.pnlLeft.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlLeft.Location = new System.Drawing.Point(0, 264);
			this.pnlLeft.Name = "pnlLeft";
			this.pnlLeft.Size = new System.Drawing.Size(554, 48);
			this.pnlLeft.TabIndex = 2;
			// 
			// btnAdd
			// 
			this.btnAdd.Location = new System.Drawing.Point(144, 16);
			this.btnAdd.Name = "btnAdd";
			this.btnAdd.TabIndex = 0;
			this.btnAdd.Tag = "SID_ADD";
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			// 
			// btnEdit
			// 
			this.btnEdit.Location = new System.Drawing.Point(224, 16);
			this.btnEdit.Name = "btnEdit";
			this.btnEdit.TabIndex = 1;
			this.btnEdit.Tag = "SID_EDIT";
			this.btnEdit.Click += new System.EventHandler(this.btnEdit_Click);
			// 
			// btnDelete
			// 
			this.btnDelete.Location = new System.Drawing.Point(304, 16);
			this.btnDelete.Name = "btnDelete";
			this.btnDelete.TabIndex = 4;
			this.btnDelete.Tag = "SID_DELETE";
			this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
			// 
			// btnok
			// 
			this.btnok.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnok.Location = new System.Drawing.Point(392, 16);
			this.btnok.Name = "btnok";
			this.btnok.TabIndex = 2;
			this.btnok.Tag = "SID_OK";
			this.btnok.Click += new System.EventHandler(this.btnok_Click);
			// 
			// btncancel
			// 
			this.btncancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btncancel.Location = new System.Drawing.Point(472, 16);
			this.btncancel.Name = "btncancel";
			this.btncancel.TabIndex = 3;
			this.btncancel.Tag = "SID_CANCEL";
			this.btncancel.Click += new System.EventHandler(this.btncancel_Click);
			// 
			// splitter1
			// 
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 261);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(554, 3);
			this.splitter1.TabIndex = 5;
			this.splitter1.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.pnlRight);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(554, 261);
			this.panel1.TabIndex = 6;
			// 
			// OverrideFormulaWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.ClientSize = new System.Drawing.Size(554, 312);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.pnlLeft);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "OverrideFormulaWindow";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_OVERRIDE_FORMULA";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.OverrideFormulaWindow_Closing);
			this.Load += new System.EventHandler(this.OverrideFormulaWindow_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridFormulaOverrides)).EndInit();
			this.pnlRight.ResumeLayout(false);
			this.pnlLeft.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void OverrideFormulaWindow_Load(object sender, System.EventArgs e)
		{
		
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			LRRFormula lrrformulaObj = new LRRFormula();

			string sourceObjID = LRRFormulaDataStore.SourceObjectID;
			LRRSiteComponentPropertyValue lrrPropValueObj = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(sourceObjID);
			LRRFormula lrrFormula = lrrPropValueObj.FormulaObj;
			
			if(lrrFormula != null)
			{
				lrrformulaObj.ID = lrrFormula.ID;
			}

			LRRFormulaDataStore.IsOverrided = true;
			FormulaWindow fw = new FormulaWindow(lrrformulaObj);
			fw.ShowDialog();
			InitDataSource();
			BindGrid();
			
		}

		private void btnok_Click(object sender, System.EventArgs e)
		{

			if(activeFormulaOverride != null)
			{
				LRRModel.FormulaOverridesObj.SetActiveFormulaOverride(activeFormulaOverride);   
			}
			LRRFormulaOverrides changes = _lrrFormulaOverrides.GetChanges();
			if(changes.Count > 0)
			{
				for(int i=0;i<changes.Count;i++)
				{
					LRRFormulaOverride formulaOV = changes[i] as LRRFormulaOverride;
					if (formulaOV.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
					{
						if(formulaOV.IsActive)
						{
							LRRFormulaOverride defaultFormula = _lrrFormulaOverrideModelObject.GetDefaultFormulaObj(formulaOV.FormulaID) as LRRFormulaOverride;
							if(defaultFormula != null)
							{
								_lrrFormulaOverrideModelObject.SetActiveFormulaOverride(defaultFormula);
								activeFormulaOverride = defaultFormula;
								isActiveChanged = true;
								_unBound.SetRecord(defaultFormula,true); 
								gridFormulaOverrides.Refresh(); 
							}
							_lrrFormulaOverrideModelObject.Remove(formulaOV);
  						}
					}
				}
				_app.DBManagerObj.CommitCollection(_lrrFormulaOverrideModelObject.GetChanges());
				_lrrFormulaOverrideModelObject.RefreshCollection(); 
			}

			if(isActiveChanged || LRRFormulaDataStore.IsEdit)
			{
				string sourceObjID = LRRFormulaDataStore.SourceObjectID;
				LRRSiteComponentPropertyValue lrrPropValueObj = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(sourceObjID);
				LRRFormula lrrFormula = LRRModel.FormulasObj.GetFormulaObjFromID(lrrPropValueObj.FormulaObj.ID);
				lrrPropValueObj.FormulaObj = lrrFormula;

				object[] objSelectedRecords = _unBound.GetSelectedRecords();
				for(int i = 0;i < objSelectedRecords.Length;i++)
				{
					lrrFormula.Expression = activeFormulaOverride.Expression;
					lrrPropValueObj.FormulaObj.Expression = activeFormulaOverride.Expression;
					lrrFormula.FormulaName = activeFormulaOverride.FormulaName;
					lrrFormula.FormulaDescription = activeFormulaOverride.FormulaDescription;
					lrrFormula.Params = activeFormulaOverride.Params;
					lrrFormula.IsCustomFormula = activeFormulaOverride.IsCustomFormula;
					lrrFormula.IsFormula = activeFormulaOverride.IsFormula;
					lrrFormula.MethodName = activeFormulaOverride.MethodName;
					lrrFormula.PostCalc = activeFormulaOverride.PostCalc;
					lrrFormula.PreCalc = activeFormulaOverride.PreCalc;
					lrrFormula.SourceCollectionName = activeFormulaOverride.SourceCollectionName;
					lrrFormula.SourceLookUpPropertyID = activeFormulaOverride.SourceLookUpPropertyID;
					lrrFormula.SourceLookUpQualifierID = activeFormulaOverride.SourceLookUpQualifierID;
					lrrFormula.SourceObjectID = activeFormulaOverride.SourceObjectID;
					lrrFormula.SourcePropertyID = activeFormulaOverride.SourcePropertyID;
					lrrFormula.ModeID = activeFormulaOverride.ModeID;
					if(activeFormulaOverride.IsDefault)
					{
						lrrFormula.IsOverrided = false;
					}
					else
					{
						lrrFormula.IsOverrided = true;
					}
				}
				#region Commented


				/*object[] objUnSelectedRecords = _unBound.GetUnSelectedRecords();
				for(int i = 0;i < objUnSelectedRecords.Length;i++)
				{
					LRRFormulaOverride lrrFormulaOverrideObj = objUnSelectedRecords[i] as LRRFormulaOverride;
					lrrFormulaOverrideObj.IsActive = false;
				}
		
				if((_lrrFormulaOverrides.GetChanges().Count > 0))
				{
					_app.DBManagerObj.CommitCollection(_lrrFormulaOverrides.GetChanges());
				}

				/*LRRFormulaParams lrrparams = lrrFormula.Params;  
		
				foreach(LRRFormulaOverride lrrformulaoverride in _lrrFormulaOverrides.GetChanges())
				{
					//				lrrparams.Add(lrrformulaoverride.Params);
				
					foreach(LRRFormulaParam lrrparam in lrrformulaoverride.Params)
					{
						lrrparams.Add(lrrparam);
					}
								
				}
				
//				if((lrrparams.GetChanges().Count>0))
//				{
//					_app.DBManagerObj.CommitCollection(lrrparams.GetChanges());
//				}

				lrrparams.RefreshCollection();
				_lrrFormulaOverrides.RefreshCollection();*/

					#endregion
			}
		
			LRRFormulaDataStore.IsOverrided = false;
		}

		private void btnEdit_Click(object sender, System.EventArgs e)
		{
			
			LRRFormulaDataStore.IsEdit = true; 
			LRRFormulaDataStore.IsOverrided = true;
			object[] objSelectedRecords = _unBound.GetSelectedRecords();
			for(int i = 0;i < objSelectedRecords.Length;i++)
			{
				LRRFormulaOverride lrrFormulaOverrideObj = objSelectedRecords[i] as LRRFormulaOverride;
				if(!lrrFormulaOverrideObj.IsDefault)
				{
					activeFormulaOverride = lrrFormulaOverrideObj;
					LRRFormulaParams lrrformulaparams = new LRRFormulaParams();
					LRRFormula lrrformulaobj = new LRRFormula();

					lrrformulaobj.ID = lrrFormulaOverrideObj.FormulaID;
					lrrformulaobj.Expression = lrrFormulaOverrideObj.Expression;
					lrrformulaobj.SourceObjectID = lrrFormulaOverrideObj.SourceObjectID;
					lrrformulaobj.UserID = lrrFormulaOverrideObj.UserID;
					lrrformulaobj.FormulaName = lrrFormulaOverrideObj.FormulaName;
					lrrformulaobj.FormulaDescription = lrrFormulaOverrideObj.FormulaDescription;
					lrrformulaobj.ModeID = lrrFormulaOverrideObj.ModeID;
					lrrformulaobj.IsFormula = lrrFormulaOverrideObj.IsFormula;
					lrrformulaobj.IsCustomFormula = lrrFormulaOverrideObj.IsCustomFormula;
					lrrformulaobj.MethodName = lrrFormulaOverrideObj.MethodName;
					lrrformulaobj.PostCalc = lrrFormulaOverrideObj.PostCalc;
					lrrformulaobj.PreCalc = lrrFormulaOverrideObj.PreCalc;
					lrrformulaobj.SourceCollectionName = lrrFormulaOverrideObj.SourceCollectionName;
					lrrformulaobj.SourceLookUpPropertyID = lrrFormulaOverrideObj.SourceLookUpPropertyID;
					lrrformulaobj.SourceLookUpQualifierID = lrrFormulaOverrideObj.SourceLookUpQualifierID;
					lrrformulaobj.SourcePropertyID = lrrFormulaOverrideObj.SourcePropertyID;
					lrrformulaobj.Params = lrrFormulaOverrideObj.Params;
				
					FormulaWindow fw = new FormulaWindow(lrrformulaobj);
					fw.FormulaOverrideObj = lrrFormulaOverrideObj;
					fw.ShowDialog();
					InitDataSource();
					BindGrid();
				 
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_EDIT_DEFAULT_FORMULA_WARNING","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Warning);     
					LRRFormulaDataStore.IsEdit = false; 
				}
			}
//			LRRFormulaDataStore.IsOverrided = true;
//			FormulaWindow fw = new FormulaWindow(lrrformulaobj);
//			fw.ShowDialog();
//			InitDataSource();
//			BindGrid();
						
		}

		private void gridFormulaOverrides_TableControlCurrentCellChanged(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{
			/*LRRFormulaOverride overideFormula = e.TableControl.Table.CurrentRecord.GetData() as LRRFormulaOverride;
			object[] objoverrideFormulas = _unBound.GetSelectedRecords();
			if(objoverrideFormulas.Length > 0)
			{
				for(int i=0;i<objoverrideFormulas.Length;i++)
				{
					LRRFormulaOverride objoverrideFormula = objoverrideFormulas[i] as LRRFormulaOverride;
					if(objoverrideFormula.ID != overideFormula.ID)
					{
						_unBound.SetRecord(objoverrideFormula,false);
						gridFormulaOverrides.Refresh();
					}
					else if(overideFormula.ID == overideFormula.ID)
					{	
						_unBound.SetRecord(objoverrideFormula,true);
						gridFormulaOverrides.Refresh();
					}
				}
			}			
			else
			{
				_unBound.SetRecord(overideFormula,true);
				gridFormulaOverrides.Refresh();
			}
			e.TableControl.CurrentCell.Deactivate(false);   */
		}


		private void setActiveFormulaOnUI(string formulaID)
		{
			foreach(LRRFormulaOverride formulaOverride in _lrrFormulaOverrides)
			{
				if(formulaOverride.IsActive)
				{
					_unBound.SetRecord(formulaOverride,true);
				}
			}
		}

		private void btncancel_Click(object sender, System.EventArgs e)
		{
			LRRFormulaDataStore.IsOverrided = false;
		}

		private void OverrideFormulaWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			LRRFormulaDataStore.IsOverrided = false;
			LRRFormulaDataStore.IsEdit = false;
		}

		private void gridFormulaOverrides_TableControlCurrentCellChanging(object sender, GridTableControlCancelEventArgs e)
		{
			LRRFormulaOverride overideFormula = e.TableControl.Table.CurrentRecord.GetData() as LRRFormulaOverride;
			isActiveChanged = true;
			object[] objoverrideFormulas = _unBound.GetSelectedRecords();
			if(objoverrideFormulas.Length > 0)
			{
				for(int i=0;i<objoverrideFormulas.Length;i++)
				{
					LRRFormulaOverride objoverrideFormula = objoverrideFormulas[i] as LRRFormulaOverride;
					if(objoverrideFormula.ID != overideFormula.ID)
					{
						_unBound.SetRecord(objoverrideFormula,false);
						activeFormulaOverride = overideFormula;
						gridFormulaOverrides.Refresh();
					}
					else if(overideFormula.ID == overideFormula.ID)
					{	
						isActiveChanged = false;
						e.Inner.Cancel = true; 
					}
				}
			}			
			else
			{
				_unBound.SetRecord(overideFormula,true);
				activeFormulaOverride = overideFormula;
				gridFormulaOverrides.Refresh();
			}
			e.TableControl.CurrentCell.Deactivate(false);  
		}

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			int top,bottom; 
			bool isDefault = false;
			if(gridFormulaOverrides.TableControl.CurrentCell.IsActive)
			{
				GridRangeInfoList list = gridFormulaOverrides.TableControl.Model.SelectedRanges;
				if(list.Count == 1)
				{
					GridRangeInfo range = list.ActiveRange;
					int selRows = range.Height;
					if(gridFormulaOverrides.TopLevelGroupOptions.ShowFilterBar == true)  
					{
						top  = range.Top-4;
						bottom = range.Bottom-4;
					}
					else
					{
						top = range.Top-3;
						bottom = range.Bottom-3;
					}
					for(int i=selRows;i>0;i--)
					{
						object obj = gridFormulaOverrides.TableModel.Table.Records[bottom].GetData();
						LRRFormulaOverride formulaOV = obj as LRRFormulaOverride; 
						if(formulaOV.IsDefault)
						{
							LRRMessagBox.ShowMessage("SID_EDIT_DEFAULT_FORMULA_WARNING","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Warning);        
							isDefault = true;
							break;
						}
					}
					if(!isDefault)
					{
						DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
						if(_dlgResult == DialogResult.Yes)
						{
							for(int i=selRows;i>0;i--)
							{
								try
								{
									object obj = gridFormulaOverrides.TableModel.Table.Records[bottom].GetData();
									_lrrFormulaOverrides.Remove(obj); 
									LRRModel.FormulaOverridesObj.Remove(obj);
									bottom--;
								}
								catch
								{
								}
							}
							list.Clear();  
						}
						else
						{
							return;
						}
					}
				}
  			}
		}
	}
}
