using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;

using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;


using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for PlantLevelTreeControlStructure.
	/// </summary>
	public class PlantLevelTreeControlStructure : System.Windows.Forms.Form
	{
		
		public EventHandler save;
		public EventHandler cancel;
		public System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Panel panel1;
		private System.ComponentModel.IContainer components;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		public PlantLevelTreeControlStructure()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			this.btnCancel.KeyDown+=new KeyEventHandler(btnCancel_KeyDown);
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrLevels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(_lrrLevels,false);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.btnOk = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// treeView1
			// 
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Top;
			this.treeView1.ImageIndex = -1;
			this.treeView1.Location = new System.Drawing.Point(0, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = -1;
			this.treeView1.Size = new System.Drawing.Size(194, 208);
			this.treeView1.Sorted = true;
			this.treeView1.TabIndex = 0;
			// 
			// btnOk
			// 
			this.btnOk.Anchor = System.Windows.Forms.AnchorStyles.None;
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.Location = new System.Drawing.Point(32, 216);
			this.btnOk.Name = "btnOk";
			this.btnOk.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.btnOk.TabIndex = 1;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = System.Windows.Forms.AnchorStyles.None;
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(112, 216);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Tag = "SID_CANCEL";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// panel1
			// 
			this.panel1.AutoScroll = true;
			this.panel1.Controls.Add(this.btnOk);
			this.panel1.Controls.Add(this.btnCancel);
			this.panel1.Controls.Add(this.treeView1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(194, 248);
			this.panel1.TabIndex = 3;
			// 
			// PlantLevelTreeControlStructure
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(194, 248);
			this.Controls.Add(this.panel1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "PlantLevelTreeControlStructure";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Tag = "SID_LEVELS";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		
		private bool changed = false;
		private LRRLevels				_lrrLevels=null; //Levels Object
		private LRRApp					_app;

		#endregion
		

		public void SetValuesFromString(string val)
		{
			string temp = val;
			changed = false;
			/*if(_lrrLevels.FindLevelByLevelName(val))
				this.treeView1.SelectedNode.Text = val;
				this.treeView1.SelectedNode.BackColor = System.Drawing.Color.Blue;     */
 
		}
		public string GetValuesToString()
		{
			string val= "";
			LRRLevel lrlv = this.treeView1.SelectedNode.Tag as LRRLevel;
			val = lrlv.LevelID;
			return val;
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.OK;
			this.Close();
			 
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;
			this.Close();
		}

		private void btnCancel_KeyDown(object sender, KeyEventArgs e)
		{
			/*if(e.KeyCode == Keys.Escape || e.KeyCode == Keys.F4)
				this.btnCancel.PerformClick();*/
		}
		protected override void WndProc( ref Message m ) 
		{ 
			const int WM_NCLBUTTONDOWN = 161; 
			const int WM_SYSCOMMAND = 274; 
			const int HTCAPTION = 2; 
			const int SC_MOVE = 61456; 
			if ( (m.Msg == WM_SYSCOMMAND) && (m.WParam.ToInt32() == SC_MOVE) ) 
				return; 
			if ( (m.Msg == WM_NCLBUTTONDOWN) && (m.WParam.ToInt32() == HTCAPTION) ) 
				return; 
			base.WndProc( ref m ); 
		} 
	}
}
