using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;

using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for testUnitScreen.
	/// </summary>
	public class PlantLevels : System.Windows.Forms.Form ,ILRRUIContainer
	{
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.ComponentModel.IContainer components;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private System.Windows.Forms.Splitter splitter2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btnSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btnClose;
		private System.Windows.Forms.MenuItem mnuAdd;
		private System.Windows.Forms.MenuItem mnuRemove;
		private System.Windows.Forms.MenuItem mnuRename;
		private System.Windows.Forms.Splitter splitter4;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridPlantLevelItems;
		private System.Windows.Forms.TreeView trvLevels;
		private System.Windows.Forms.MenuItem mnuInsert;
		private System.Windows.Forms.ImageList imageList2;

		
		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;



	
		public PlantLevels()
		{

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitializeComponent();
			InitDataSource();

            if (_lrrLevels.Count > 0)
            {
                PopulateLevels(trvLevels, _lrrLevels, _lrrLevelLinks);
                trvLevels.TreeViewNodeSorter = new TreeNodeSorter();
                trvLevels.Sort();
            }

			gridPlantLevelItems.SourceListSet.ClearAllWhenEngineSourceListChanged = true;
			gridPlantLevelItems.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridPlantLevelItems_QueryCellStyleInfo);
			this.gridPlantLevelItems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			
			if((trvLevels.Nodes != null) && (trvLevels.Nodes.Count > 0))
				trvLevels.Nodes[0].Checked = true;
		}

	

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PlantLevels));
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.mnuAdd = new System.Windows.Forms.MenuItem();
			this.mnuInsert = new System.Windows.Forms.MenuItem();
			this.mnuRemove = new System.Windows.Forms.MenuItem();
			this.mnuRename = new System.Windows.Forms.MenuItem();
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btnSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.btnClose = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.trvLevels = new System.Windows.Forms.TreeView();
			this.splitter4 = new System.Windows.Forms.Splitter();
			this.gridPlantLevelItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.imageList2 = new System.Windows.Forms.ImageList(this.components);
			((System.ComponentModel.ISupportInitialize)(this.gridPlantLevelItems)).BeginInit();
			this.SuspendLayout();
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.mnuAdd,
																						 this.mnuInsert,
																						 this.mnuRemove,
																						 this.mnuRename});
			this.contextMenu1.Popup += new System.EventHandler(this.contextMenu1_Popup);
			// 
			// mnuAdd
			// 
			this.mnuAdd.Index = 0;
			this.mnuAdd.Text = LRRHeaderText.GetHeaderString("SID_ADD");
			this.mnuAdd.Click += new System.EventHandler(this.mnuAdd_Click);
			// 
			// mnuInsert
			// 
			this.mnuInsert.Index = 1;
			this.mnuInsert.Text = LRRHeaderText.GetHeaderString("SID_INSERT");
			this.mnuInsert.Click += new System.EventHandler(this.mnuInsert_Click);
			// 
			// mnuRemove
			// 
			this.mnuRemove.Index = 2;
			this.mnuRemove.Text = LRRHeaderText.GetHeaderString("SID_DEL");
			this.mnuRemove.Click += new System.EventHandler(this.mnuRemove_Click);
			// 
			// mnuRename
			// 
			this.mnuRename.Index = 3;
			this.mnuRename.Text = LRRHeaderText.GetHeaderString("SID_RENAME");
			this.mnuRename.Click += new System.EventHandler(this.mnuRename_Click);
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = -1;
			this.barItem2.ID = "dfh";
			this.barItem2.Text = "dfh";
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = -1;
			this.barItem1.ID = "fgh";
			this.barItem1.Text = "fgh";
			// 
			// splitter2
			// 
			this.splitter2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter2.Location = new System.Drawing.Point(0, 467);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(912, 3);
			this.splitter2.TabIndex = 5;
			this.splitter2.TabStop = false;
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = -1;
			this.barItem3.ID = "";
			// 
			// btnSave
			// 
			this.btnSave.CategoryIndex = -1;
			this.btnSave.Enabled = false;
			this.btnSave.ID = "Save";
			this.btnSave.Text = "Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = -1;
			this.barItem4.ID = "";
			// 
			// btnClose
			// 
			this.btnClose.CategoryIndex = -1;
			this.btnClose.ID = "Close";
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// trvLevels
			// 
			this.trvLevels.BackColor = System.Drawing.Color.AliceBlue;
			this.trvLevels.ContextMenu = this.contextMenu1;
			this.trvLevels.Dock = System.Windows.Forms.DockStyle.Left;
			this.trvLevels.ImageIndex = -1;
			this.trvLevels.LabelEdit = true;
			this.trvLevels.Location = new System.Drawing.Point(0, 0);
			this.trvLevels.Name = "trvLevels";
			this.trvLevels.SelectedImageIndex = -1;
			this.trvLevels.Size = new System.Drawing.Size(221, 467);
			this.trvLevels.Sorted = true;
			this.trvLevels.TabIndex = 10;
			this.trvLevels.MouseHover += new System.EventHandler(this.trvLevels_MouseHover);
			this.trvLevels.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.trvLevels_AfterSelect);
			this.trvLevels.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.trvLevels_BeforeSelect);
			this.trvLevels.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.trvLevels_AfterLabelEdit);
			// 
			// splitter4
			// 
			this.splitter4.Location = new System.Drawing.Point(221, 0);
			this.splitter4.Name = "splitter4";
			this.splitter4.Size = new System.Drawing.Size(3, 467);
			this.splitter4.TabIndex = 11;
			this.splitter4.TabStop = false;
			// 
			// gridPlantLevelItems
			// 
			this.gridPlantLevelItems.BackColor = System.Drawing.SystemColors.Window;
			this.gridPlantLevelItems.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridPlantLevelItems.Location = new System.Drawing.Point(224, 0);
			this.gridPlantLevelItems.Name = "gridPlantLevelItems";
			this.gridPlantLevelItems.Size = new System.Drawing.Size(688, 467);
			this.gridPlantLevelItems.TabIndex = 12;
			this.gridPlantLevelItems.TableDescriptor.AllowNew = false;
			this.gridPlantLevelItems.Text = "gridPlantLevelItems";
			this.gridPlantLevelItems.ThemesEnabled = false;
			this.gridPlantLevelItems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridPlantLevelItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridPlantLevelItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridPlantLevelItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridPlantLevelItems.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridPlantLevelItems.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridPlantLevelItems.VersionInfo = "3.301.0.0";
			// 
			// imageList2
			// 
			this.imageList2.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
			this.imageList2.TransparentColor = System.Drawing.SystemColors.Desktop;
			// 
			// PlantLevels
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(912, 470);
			this.Controls.Add(this.gridPlantLevelItems);
			this.Controls.Add(this.splitter4);
			this.Controls.Add(this.trvLevels);
			this.Controls.Add(this.splitter2);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "PlantLevels";
			this.Tag = "SID_PLANT_LEVELS";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Closing += new System.ComponentModel.CancelEventHandler(this.PlantLevels_Closing);
			this.Load += new System.EventHandler(this.PlantLevels_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridPlantLevelItems)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods

		#endregion

		#region Events
		private void gridPlantLevelItems_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			 try
			   {
			     if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		}
		private void trvLevels_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
//			_lrrApp.LRRUIManagerObj.SaveGridSettings(gridPlantLevelItems,this, this.Tag);
            try
            {
                if(e.Action == TreeViewAction.ByMouse)
                    LRRWaitWindowUtility.ShowPogressIndicator(e.Node.Text);

                if (prevSelNode != null)
                {
                    prevSelNode.ForeColor = Color.Black;
                }
                e.Node.ForeColor = Color.Blue;
                prevSelNode = e.Node;
                //			_lrrApp.LRRUIManagerObj.ApplyGridSettings(gridPlantLevelItems,this, this.Tag);
                RefreshView();
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(PlantLevels), "AfterSelect: " + ex, Logger.Level.Debug);
            }
            finally
            {
                LRRWaitWindowUtility.EndProgressIndicator();
            }
		}

		/// <summary>
		/// Event handler to ask the user to save the changes before
		/// he moves to the next node(Level)..
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void trvLevels_BeforeSelect(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			
		}

		private void mnuRename_Click(object sender, System.EventArgs e)
		{
			if(trvLevels.SelectedNode!=null)
				trvLevels.SelectedNode.BeginEdit();
			
		}

		private void mnuAdd_Click(object sender, System.EventArgs e)
		{
			
			TreeNode tn = new TreeNode("");
			if(trvLevels.SelectedNode!=null)
			{
				trvLevels.SelectedNode.Nodes.Add(tn);
				trvLevels.SelectedNode = tn;

				//lvl.Parent = lvlParent.;

				tn.BeginEdit();
			}
			//			LRRLevel lvl = new LRRLevel();
			//			LRRLevel lvlParent = trvLevels.SelectedNode.Parent.Tag as LRRLevel;
			//			lvl.Name = trvLevels.SelectedNode.Text;
			//			trvLevels.SelectedNode.Tag = lvl;
			//			_lrrLevels.Add(lvl);
			//			
			//
			//			LRRLevelLink lvlLink = new LRRLevelLink();
			//			lvlLink.ChildID = lvl.LevelID;
			//
			//			//LRRLevel lvlParent = trvLevels.SelectedNode.Parent.Tag as LRRLevel;
			//			lvlLink.ParentID = lvlParent.LevelID;
			//
			//			_lrrLevelLinks.Add(lvlLink);

			//_lrrApp.DBManagerObj.CommitCollection(_lrrLevels);
			//_lrrApp.DBManagerObj.CommitCollection(_lrrLevelLinks);
			
			//trvLevels.Nodes.Add(
			/*#region Code Before Changing tables

			/*	TreeNodeAdv tn;
				string h;
				DialogResult result;
				h=InputBox("Enter the LevelName:","InputBoxDialog","LevelName");
				if(h=="")
					return;
				if(h!=null)
				{
			
					tn=new TreeNodeAdv(h);
					treeViewAdv1.SelectedNode.Nodes.Add(tn);
				
				
						string par=treeViewAdv1.SelectedNode.Text;
						string str;
						int max;
						int levelId;
						int Id;
						_lrrApp.DBManagerObj.PopulateCollection(lrrChildLevels3,"  WHERE id=(select max(id) from childlevels)");
						LRRChildLevel chlvl3 = lrrChildLevels3[0] as LRRChildLevel;
						max=int.Parse( chlvl3.ID);
						max=max+1;
						_lrrApp.DBManagerObj.PopulateCollection(lrrChildLevels2,"  where name='"+par+"'");
						LRRChildLevel chlvl = lrrChildLevels2[0] as LRRChildLevel;
						Id=int.Parse( chlvl.ID);
						levelId=int.Parse(chlvl.LID);
						levelId=levelId+1;
						da.Initialized(oleDbConnection1.ConnectionString);
						str="insert into childlevels values('"+max+"','"+h+"','"+levelId+"','"+Id+"')";
						try
						{
							da.ExecuteQuery(str);

							MessageBox.Show("Successfully stored");
						}
						catch(OleDbException e1)
						{
			
							MessageBox.Show(e1.Message.ToString());
						}
					}
			
			#endregion
		
	
			string parentId;
					
			string h;
			h=InputBox("Enter the LevelName:","InputBoxDialog","LevelName");
			if(h=="")
				return;
			if(h!=null)
			{
		
				LRRLevel lvl=treeView1.SelectedNode.Tag as LRRLevel;
				parentId=lvl.LevelID;
				lvl.Name=h;
				lvl.LevelID=Guid.NewGuid().ToString();
				lvl.ObjectState=DBOperation.INSERT;
				if(lrrLevels.GetChanges().Count != 0)
				{
					_lrrApp.DBManagerObj.CommitCollection(lrrLevels.GetChanges());
					//	treeView1.SelectedNode.Nodes.Add(h);
					MessageBox.Show("saved");
				}
				
			
				for(int i=0 ;i< lrrLevels.GetChanges().Count;i++)
				{
				foreach(LRRLevelLink llk in lrrChildLevels)
					{

//						llk.ID=Guid.NewGuid().ToString();
						llk.ParentID=parentId;
						llk.ChildID=lvl.LevelID;
						llk.ObjectState=DBOperation.INSERT;
						
						if(lrrChildLevels.GetChanges().Count != 0)
						{
							_lrrApp.DBManagerObj.CommitCollection(lrrChildLevels.GetChanges());
							
							
							
						}
						if(lrrLevels.GetChanges().Count==1)
						{
							goto s;
						}
					
					}
				}
			s:
				MessageBox.Show("saved");
					PopulateLevels(treeView1,lrrLevels,lrrChildLevels);
			
			}
		*/
		}

		private void mnuRemove_Click(object sender, System.EventArgs e)
		{
			if(trvLevels.SelectedNode != null)
			{
				if(trvLevels.SelectedNode.Parent != null)
				{
					//DialogResult dlgRslt = MessageBox.Show(this, trvLevels.SelectedNode.Text + " and all its sublevels will be deleted permanently." + '\n' + "Do you wish to continue?", this.Name, MessageBoxButtons.YesNo,MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2);
					string[] s = new string[1];
					s[0] = trvLevels.SelectedNode.Text;
					DialogResult dlgRslt = LRRMessagBox.ShowMessage(this,"SID_DELETE_LEVEL_CONFIRM","SID_LABEL",s,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      

					if(dlgRslt == DialogResult.Yes)
					{
						LRRLevel lvl =  trvLevels.SelectedNode.Tag as LRRLevel;
						string id = lvl.LevelID;
						ArrayList alist = new ArrayList();
						alist = GetAllChildLevels(id);
						for(int i = 0; i< alist.Count;  i++)
						{
							string str = alist[i] as string;
							for(int j = _lrrLevels.Count - 1; j >=0;j--)
							{
				
								LRRLevel levl = _lrrLevels[j] as LRRLevel;
								if(levl.LevelID == str)
								{
									_lrrLevels.Remove(levl);
								}
								for(int k =_lrrLevelLinks.Count-1; k>=0;k--)
								{
									LRRLevelLink lvlLink = _lrrLevelLinks[k] as LRRLevelLink;
									if(lvlLink.ChildID == str)
										_lrrLevelLinks.Remove(lvlLink);
								}
							}
						}
						/*LRRLevels toCommitLevels = _lrrLevels.GetChanges();
						LRRLevelLinks toCommitLevelLinks = _lrrLevelLinks.GetChanges();
						_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
						_lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
						_lrrLevels.RefreshCollection();
						_lrrLevelLinks.RefreshCollection();*/
						trvLevels.Nodes.Remove(trvLevels.SelectedNode);
					}
				}
				else
				{
					//MessageBox.Show(this, trvLevels.SelectedNode.Text + " cannot be deleted",this.Name, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					string[] s = new string[1];
					s[0] = trvLevels.SelectedNode.Text;
					LRRMessagBox.ShowMessage("SID_LEVEL_CANT_DEL","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Information);    
				}
			}
			/*LRRLevel lvl =treeView1.SelectedNode.Tag as LRRLevel;
			string id=lvl.LevelID;
			bool containsChildren = false;
			Hashtable toDeleteChilds = new Hashtable();
			Hashtable toDeleteParent = new Hashtable();
			foreach(LRRLevelLink ll in this.lrrChildLevels)
			{
				if(ll.ParentID == id)
				{
					toDeleteChilds.Add(ll,null);
					ll.ObjectState = DBOperation.DELETE;
					containsChildren = true;
					//break;
				}
				else if(ll.ChildID == id)
				{
					ll.ObjectState = DBOperation.DELETE;
					toDeleteParent.Add(ll,null);
				}


			}

			if(containsChildren)
			{
				if(MessageBox.Show("Contains Children do you want delete?","",MessageBoxButtons.YesNo) == DialogResult.Yes)
				{
					foreach(object obj in toDeleteChilds.Keys)
					{
						lrrChildLevels.Remove(obj);
					}

					foreach(object obj in toDeleteParent.Keys)
					{
						lrrChildLevels.Remove(obj);
					}

					LRRLevelLinks toCommitLinks = lrrChildLevels.GetChanges();
					_lrrApp.DBManagerObj.CommitCollection(toCommitLinks);
                
					//Removal of Levels
					//****************
					lrrLevels.Remove(lvl);
					LRRLevels toCommitLevels = lrrLevels.GetChanges();
					_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
					//*************8

					lrrChildLevels.RefreshCollection();
					lrrLevels.RefreshCollection();

					PopulateLevels(treeView1,lrrLevels,lrrChildLevels);
				}
				else
				{
					//dont delete
				}
			}
			else
			{
				//Removal of Level Link
				foreach(object obj in toDeleteChilds.Keys)
				{
					lrrChildLevels.Remove(obj);
				}

				foreach(object obj in toDeleteParent.Keys)
				{
					lrrChildLevels.Remove(obj);
				}

				LRRLevelLinks toCommitLinks = lrrChildLevels.GetChanges();
				_lrrApp.DBManagerObj.CommitCollection(toCommitLinks);
                
				//Removal of Levels
				//****************
				lrrLevels.Remove(lvl);
				LRRLevels toCommitLevels = lrrLevels.GetChanges();
				_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
				//*************8

				lrrChildLevels.RefreshCollection();
				lrrLevels.RefreshCollection();

				PopulateLevels(treeView1,lrrLevels,lrrChildLevels);

			}*/
		}
				
			

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			/*if(ValidateClose())
				this.Close();*/
		}
		

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			/*LRRSiteComponents toSave=lrrSiteComps.GetChanges();

			try
			{
				bool savedcalled=false;
				
					if(toSave.Count!=0)
					{	
						savedcalled=true;
					_lrrApp.DBManagerObj.CommitCollection(lrrSiteComps.GetChanges());
					lrrSiteComps.RefreshCollection();
					lrrSiteComps = new LRRSiteComponents();
					_lrrApp.DBManagerObj.PopulateCollection(lrrSiteComps);
					//gridPlantLevelItems.Engine.SourceListSet.ClearAllWhenEngineSourceListChanged = true;
					gridPlantLevelItems.DataSource=null;
					gridPlantLevelItems.DataSource=lrrSiteComps;
					gridPlantLevelItems.Engine.SourceListSet.Add("ParentTable",lrrSiteComps);
						
					
						
					}
				
				if(savedcalled)
				{
					MessageBox.Show("Saved to database");
					RefreshGrid();
				}
				else
				{
					//MessageBox.Show("No data to save");;
					LRRMessagBox.ShowMessage("SID_NODATASAVED ");  
				}
			}
			catch(Exception e1)
			{
			MessageBox.Show(e1.Message.ToString());
			}*/
		}

		private void RefreshGrid()
		{
		
			/*SyncGridUtilities.InitializeGridColumns(gridPlantLevelItems,lrrSiteComps.ItemType,null);
				gridPlantLevelItems.Engine.SourceListSet.ClearAllWhenEngineSourceListChanged = true;
				
				gridPlantLevelItems	.DataSource =lrrSiteComps ;
				
				gridPlantLevelItems.TopLevelGroupOptions.CaptionText = "TotalComponents in Plant:" + " {RecordCount} Items"; 
				gridPlantLevelItems.Engine.SourceListSet.Add("ParentTable",lrrSiteComps);*/
			
		
		}


		#endregion

		#region Fields

		private	LRRApp					_lrrApp; //All object to access the DB Manager and DB Adapter
		private LRRSiteComponents		_lrrSiteComps=null; //site Components object
		private LRRLevels				_lrrLevels=null; //Levels Object
		private LRRLevelLinks			_lrrLevelLinks = null; //Level Links object
		private TreeNode				prevSelNode = null;
		private bool					pressEsc = false;
		private LRRSiteComponents		_lrrSitecomponents = null; 
		
		#endregion

		#region Private Methods

		/// <summary>
		/// This method initializes the data source for the screen.
		/// Mainly the Levels and Level Links objects used as a 
		/// datasource for the treeview in this form..
		/// </summary>
		private void InitDataSource()
		{	
			//Initialize and populate the levels
			_lrrLevels = new LRRLevels();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLevels);
			//Initialize and populate the level links
			_lrrLevelLinks = new LRRLevelLinks();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLevelLinks);
		}
		
		/// <summary>
		/// This Method is used to populate a treeview with the level 
		/// and the link table..
		/// </summary>
		/// <param name="treeView">TreeView Instance</param>
		/// <param name="levels">levels table</param>
		/// <param name="levelLinks">level link table</param>
		/// <returns></returns>
		private bool PopulateLevels(TreeView treeView,LRRLevels levels,LRRLevelLinks levelLinks)
		{
			treeView.Nodes.Clear();
			try
			{
				Hashtable			_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRLevel l in levels)
				{
					_levelHash.Add(l.LevelID,l);
				}
				if(levelLinks.Count == 0 && levels.Count == 1)
				{
					//In here only when we have single entry on Level and No entry in Level Links
					LRRLevel lonerLevel = _levelHash["0"] as LRRLevel;
					if(lonerLevel != null)
					{
						TreeNode singleRootNode = new TreeNode(lonerLevel.Name);
						singleRootNode.Tag = lonerLevel;
						treeView.Nodes.Add(singleRootNode);
						return true;
					}
					else
					{
						return false;
					}
				}
				foreach(LRRLevelLink ll in levelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						TreeNode foundNode = _nodesHash[ll.ParentID] as TreeNode;
						LRRLevel foundLevel = _levelHash[ll.ChildID] as LRRLevel; 
						TreeNode childNode = new TreeNode(foundLevel.Name);
						childNode.Tag = foundLevel;
						foundNode.Nodes.Add(childNode);
					}
					else
					{
						LRRLevel parentLevel = _levelHash[ll.ParentID] as LRRLevel;
						LRRLevel childLevel = _levelHash[ll.ChildID] as LRRLevel;
						TreeNode parentNode = new TreeNode(parentLevel.Name);
						parentNode.Tag = parentLevel;
						TreeNode childNode = new TreeNode(childLevel.Name);
						childNode.Tag = childLevel;
						parentNode.Nodes.Add(childNode);
						_nodesHash.Add(ll.ParentID,parentNode);
					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					TreeNode  childNode = null;
					TreeNode  parentNode = null;
					if(_nodesHash.ContainsKey(childID))
					{
						childNode = _nodesHash[childID] as TreeNode;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentNode = _nodesHash[parentID] as TreeNode;
					}
					if((parentNode != null) && (childNode != null))
					{
						int index = -1;
						foreach(TreeNode f in parentNode.Nodes)
						{
							if(f.Tag == childNode.Tag)
							{
								index = f.Index;
								break;
							}
						}
						if(index != -1)
							parentNode.Nodes[index] = childNode;
					}
				}

				TreeNode rootNode = _nodesHash["0"] as TreeNode;
				treeView.Nodes.Add(rootNode);
				return true;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(PlantLevels),"PopulateLevels:"+ex.Message  ,Logger.Level.Debug);
				return false;
			}
		}

		/// <summary>
		/// Gets all the children from the Level Links 
		/// table given a node...
		/// </summary>
		/// <param name="parentLevelID">Starting node to get the child nodes from</param>
		/// <returns>List Containing the child nodes</returns>
		public ArrayList GetAllChildLevels(string parentLevelID)
		{
			try
			{
				ArrayList arlist = new ArrayList(); //To Return araylist
				Queue q = new Queue(); //Temp object for getting childrens
				q.Enqueue(parentLevelID);
				while(q.Count > 0)
				{
					string levelID = (string)q.Dequeue();
					arlist.Add(levelID);
					foreach(LRRLevelLink levelLink in _lrrLevelLinks)
					{
						if(levelLink.ParentID == levelID)
						{
							q.Enqueue(levelLink.ChildID);
						}
					}
				}
				return arlist;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(PlantLevels),"GetAllChildLevels:"+ex.Message  ,Logger.Level.Debug);
				return null;
			}
		}

		private void AddToCollection(TreeNode tn, string text)
		{
			try
			{

				LRRLevel lvl = new LRRLevel();
				LRRLevel lvlParent = tn.Parent.Tag as LRRLevel;
				lvl.Name = text;
				tn.Tag = lvl;
				_lrrLevels.Add(lvl);
				LRRLevelLink lvlLink = new LRRLevelLink();
				lvlLink.ChildID = lvl.LevelID;
				lvlLink.ParentID = lvlParent.LevelID;

				_lrrLevelLinks.Add(lvlLink);

				/*LRRLevels toCommitLevels = _lrrLevels.GetChanges();
				LRRLevelLinks toCommitLevelLinks = _lrrLevelLinks.GetChanges();
				_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
				_lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
				_lrrLevels.RefreshCollection();
				_lrrLevelLinks.RefreshCollection();*/
				
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(PlantLevels),"AddToCollection:"+ex.Message  ,Logger.Level.Debug);
			}
		}

		private void SetGridColumnStyles()
		{
			Hashtable toRemoveColumns = new Hashtable();
			gridPlantLevelItems.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = false;
            foreach(GridColumnDescriptor gcd in  gridPlantLevelItems.TableDescriptor.Columns)
			{
				gcd.ReadOnly = true;
				gcd.Appearance.AnyRecordFieldCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;        
				if(gcd.HeaderText != LRRHeaderText.GetHeaderString("SID_LEVEL") && gcd.HeaderText != LRRHeaderText.GetHeaderString("SID_MASTERPLANTITEM"))
				{
					gcd.Appearance.AnyRecordFieldCell.CellType = "Static";
				}
				else
				{
					gcd.Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;   
				}
					 
				if(gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_MASTERPLANTITEM"))
				{
					toRemoveColumns.Add(gcd,null);
				}
			}
			gridPlantLevelItems.TableDescriptor.Columns.Remove(LRRHeaderText.GetHeaderString("SID_MASTERPLANTITEM"));
		}

		public void RefreshView()
		{
			//Get the Current selected level
			try
			{
				LRRLevel currentLevel = trvLevels.SelectedNode.Tag as LRRLevel;

				if(_lrrSiteComps != null)
				{
					LRRSiteComponents toSave = _lrrSiteComps.GetChanges();
					if(toSave.Count !=0)
					{
						DialogResult k = LRRMessagBox.ShowMessage("SID_SAVEINFO_QUESTION","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
                        if(k == DialogResult.Yes) 
						{
							Save();							
						}
						else
						{

						}
					}
				}
				
				this.Cursor = Cursors.WaitCursor;
				if(currentLevel != null) //Check for null
				{
					gridPlantLevelItems.SuspendLayout();
					ApplicationPersistanceUtil.SaveGridSettings(gridPlantLevelItems,this,this.Tag);
					_lrrSiteComps = new LRRSiteComponents();
					if(currentLevel.LevelID == "0")//Its the root Seed data so get all site components
					{
						_lrrApp.DBManagerObj.PopulateCollection(_lrrSiteComps,false);
						gridPlantLevelItems.Engine.SourceListSet.Clear();
						gridPlantLevelItems.DataSource = null;
						gridPlantLevelItems.TableDescriptor.Relations.Clear();
                        Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
                        Dictionary<string, SymChildDataAttribute> childColumns;
						Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrSiteComps.ItemType,out fkColumns,out childColumns);
						Hashtable fkData = new Hashtable();
						foreach(object obj in fkColumns.Keys)
						{
							string propName = (string)obj;
                            SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
							object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
							_lrrApp.DBManagerObj.PopulateCollection(collectionObject,false);
							fkData.Add(propName,collectionObject);
						}

						SyncGridUtilities.InitializeGridColumns(gridPlantLevelItems,typeof(LRRSiteComponent),null,fkData);
						gridPlantLevelItems.DataSource = _lrrSiteComps;
						gridPlantLevelItems.Engine.SourceListSet.Add(_lrrSiteComps);
						SetGridColumnStyles();
					}
					else //not a root level 
					{
						
						//get all he children
						ArrayList childs = GetAllChildLevels(currentLevel.LevelID);
						if(childs == null)
						{
							
							return;
						}
						//Nullify the data source of the grid
						gridPlantLevelItems.DataSource = null;
						for(int i=0;i<childs.Count;i++)
						{
							string curLevel = (string)childs[i];
							LRRSiteComponents eachLevelSiteComponents = new LRRSiteComponents();
							_lrrApp.DBManagerObj.PopulateCollection(eachLevelSiteComponents," WHERE PlantUnit = '" + curLevel + "'",false);
							foreach(LRRSiteComponent lsc in eachLevelSiteComponents)
							{
								_lrrSiteComps.Add(lsc);
							}
						}
						gridPlantLevelItems.Engine.SourceListSet.Clear();
						gridPlantLevelItems.DataSource = null;
						gridPlantLevelItems.TableDescriptor.Relations.Clear();
                        Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
                        Dictionary<string, SymChildDataAttribute> childColumns;
						Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrSiteComps.ItemType,out fkColumns,out childColumns);
						Hashtable fkData = new Hashtable();
						foreach(object obj in fkColumns.Keys)
						{
							string propName = (string)obj;
                            SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
							object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
							_lrrApp.DBManagerObj.PopulateCollection(collectionObject,false);
							fkData.Add(propName,collectionObject);
						}

						SyncGridUtilities.InitializeGridColumns(gridPlantLevelItems,typeof(LRRSiteComponent),null,fkData);
						gridPlantLevelItems.DataSource = _lrrSiteComps;
						gridPlantLevelItems.Engine.SourceListSet.Add(_lrrSiteComps);
						SetGridColumnStyles();
					}
					ApplicationPersistanceUtil.ApplyGridSettings(gridPlantLevelItems,this,this.Tag);
					this.gridPlantLevelItems.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
					gridPlantLevelItems.ResumeLayout(true);
					this.Cursor = Cursors.Default;
				}
				else
				{
					this.Cursor = Cursors.Default;
					return;
				}
				this.Cursor = Cursors.Default;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(PlantLevels),"RefreshView:"+ex.Message  ,Logger.Level.Debug);
				this.Cursor = Cursors.Default;
			}
		}
		#endregion

		#region Event Handlers
		private void PlantLevels_Load(object sender, System.EventArgs e)
		{
			SyncGridUtilities.InitializeGridLookAndFeel(gridPlantLevelItems);
			//SyncGridUtilities.InitializeGridColumns(gridPlantLevelItems,typeof(LRRSiteComponent),null);
		}

		private void trvLevels_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			if(pressEsc == false)
			{
				if(e.Label != null)
				{
					if(e.Label.Trim() =="")
					{
						LRRMessagBox.ShowMessage("SID_TREENODELEBEL_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						e.Node.BeginEdit();
					}
					else if(e.Label.Length > 0)
					{
						/*TreeNode trvCurParentNode = e.Node.Parent;
						string levelParent = e.Node.Parent.Text;   */
						LRRLevel levl = e.Node.Tag as LRRLevel; 
						if(_lrrLevels.FindLevelByLevelName(levl,e.Label.ToString(Symcon.BusinessObjects.SymConverter.Culture).ToUpper()) == true)
						{
							LRRMessagBox.ShowMessage("SID_LEVEL_DUPLICATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
							e.CancelEdit = true;
							e.Node.BeginEdit();  
						}
						else if(e.Label.IndexOfAny(new char[]{'@','.', ',', '!'}) != -1)
						{
							/* Cancel the label edit action, inform the user, and 
								place the node in edit mode again. */

							LRRMessagBox.ShowMessage("SID_TREENODE_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
							e.CancelEdit = true;
							e.Node.BeginEdit();
						}
						else
						{
							LRRLevel lvl = e.Node.Tag as LRRLevel;
							if(_lrrLevels.Contains(lvl))
							{
								lvl.Name = e.Label;
                               	RefreshView(); 
							}
							else
							{
								AddToCollection(e.Node, e.Label);
							}
						}
					}
					else if(e.Label.Length == 0)
					{
				
						/* Cancel the label edit action, inform the user, and 
							place the node in edit mode again. */
				
						LRRMessagBox.ShowMessage("SID_TREENODELEBEL_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						//				
						//	e.Node.BeginEdit();
						//tn.BeginEdit();
						// To end editing mode, do this:
						// e.ContinueEditing = false;
					}
				}
				else
				{
					e.Node.BeginEdit(); 
				}
			}
			pressEsc = false;
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Escape)
			{
				pressEsc = true;  
				if(this.trvLevels.SelectedNode.Text.Trim() == "")
				{
					this.trvLevels.SelectedNode.Remove(); 
					pressEsc = false;
				}
			}
			else if(keyData == Keys.Delete)
			{
				_lrrSitecomponents = new LRRSiteComponents();
				_lrrApp.DBManagerObj.PopulateCollection(_lrrSitecomponents);
				LRRLevel lvl1 =  trvLevels.SelectedNode.Tag as LRRLevel;
				if(lvl1 == null)
                    return base.ProcessCmdKey (ref msg, keyData);
				
				string id1 = lvl1.LevelID;
				ArrayList alist1 = new ArrayList();
				alist1 = GetAllChildLevels(id1);
				for(int i = 0; i< alist1.Count;  i++)
				{
					string str = alist1[i] as string;
					for(int j = _lrrLevels.Count - 1; j >=0;j--)
					{
						LRRLevel levl = _lrrLevels[j] as LRRLevel;
						if(levl.LevelID == str)
						{
							LRRSiteComponents lsc = _lrrSitecomponents.FilterSiteComponentsByLevelID(levl.LevelID);   
							if(lsc.Count > 0)  
							{
								return base.ProcessCmdKey (ref msg, keyData);
							}
						}
					}
				}
				if(trvLevels.SelectedNode.Parent != null)
				{
					//DialogResult dlgRslt = MessageBox.Show(this, trvLevels.SelectedNode.Text + " and all its sublevels will be deleted permanently." + '\n' + "Do you wish to continue?", this.Name, MessageBoxButtons.YesNo,MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2);
					LRRLevel lvl =  trvLevels.SelectedNode.Tag as LRRLevel;
					if(lvl == null)
						return base.ProcessCmdKey (ref msg, keyData);

					string[] s = new string[1];
					s[0] = trvLevels.SelectedNode.Text;
                    DialogResult dlgRslt = LRRMessagBox.ShowMessage(this,"SID_DELETE_LEVEL_CONFIRM","SID_LABEL",s,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      

					if(dlgRslt == DialogResult.Yes)
					{
						//LRRLevel lvl =  trvLevels.SelectedNode.Tag as LRRLevel;
						string id = lvl.LevelID;
						ArrayList alist = new ArrayList();
						alist = GetAllChildLevels(id);
						for(int i = 0; i< alist.Count;  i++)
						{
							string str = alist[i] as string;
							for(int j = _lrrLevels.Count - 1; j >=0;j--)
							{
				
								LRRLevel levl = _lrrLevels[j] as LRRLevel;
								if(levl.LevelID == str)
								{
									_lrrLevels.Remove(levl);
								}
								for(int k =_lrrLevelLinks.Count-1; k>=0;k--)
								{
									LRRLevelLink lvlLink = _lrrLevelLinks[k] as LRRLevelLink;
									if(lvlLink.ChildID == str)
										_lrrLevelLinks.Remove(lvlLink);
								}
							}
						}
						LRRLevels toCommitLevels = _lrrLevels.GetChanges();
						LRRLevelLinks toCommitLevelLinks = _lrrLevelLinks.GetChanges();
						_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
						_lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
						_lrrLevels.RefreshCollection();
						_lrrLevelLinks.RefreshCollection();
						trvLevels.Nodes.Remove(trvLevels.SelectedNode);
					}
				}
				else
				{
					//MessageBox.Show(this, trvLevels.SelectedNode.Text + " cannot be deleted",this.Name, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					string[] s = new string[1];
					s[0] = trvLevels.SelectedNode.Text;
					LRRMessagBox.ShowMessage("SID_LEVEL_CANT_DEL","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Information);    
					
				}
			
			}
			
			return base.ProcessCmdKey (ref msg, keyData);
		}
	

		#endregion

		#region ILRRUIContainer Members

		public new void  Refresh()
		{
			RefreshView();
		}

		public void Save()
		{
            bool isUpdate = false;
            LRRLevels toCommitLevels = _lrrLevels.GetChanges();
            LRRLevelLinks toCommitLevelLinks = _lrrLevelLinks.GetChanges();
            if (toCommitLevels.Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
                isUpdate = true;
            }
            if (toCommitLevelLinks.Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
                isUpdate = true;
            }
            _lrrLevels.RefreshCollection();
            _lrrLevelLinks.RefreshCollection();
            if (isUpdate)
            {
                LRRMessagBox.ShowMessage("SID_SAVEDINFO", true); 
            }
            else
            {
                LRRMessagBox.ShowMessage("SID_NODATASAVED", true);
            }
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add PlantLevels.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add PlantLevels.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add PlantLevels.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add PlantLevels.Print implementation
			if(gridPlantLevelItems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridPlantLevelItems,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add PlantLevels.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add PlantLevels.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add PlantLevels.ClearFilter implementation
		}

		public void ImportToExcel()
		{

		}
		
		public void Export()
		{
			if(gridPlantLevelItems.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridPlantLevelItems);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public  void RightLevel()
		{
			TreeNode trvCurNode = trvLevels.SelectedNode;
			TreeNode trvPrevNode = trvCurNode.PrevNode;
			
			if(trvPrevNode == null)
			{
				LRRMessagBox.ShowMessage("SID_RIGHTLEVEL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				return;
			}
			
			TreeNode trvCurParentNode = trvCurNode.Parent;
			if(trvCurParentNode != null)
			{
				trvCurParentNode.Nodes.Remove(trvCurNode);
				trvPrevNode.Nodes.Add(trvCurNode);
				
				//Change the Level Links
				SaveLevels(trvCurNode,trvPrevNode);
				trvLevels.SelectedNode = trvCurNode;
			}
		}
		public  void LeftLevel()
		{
			TreeNode trvNode = trvLevels.SelectedNode;
			if(trvNode.Parent != null)
			{
				TreeNode trvParent = trvNode.Parent;
				int iIndex = trvParent.Index;
				if(trvParent.Parent != null)
				{
					trvParent.Nodes.Remove(trvNode);
					trvParent.Parent.Nodes.Insert(iIndex + 1,trvNode);
					
					//Change the Level Links
					SaveLevels(trvNode,trvParent.Parent);
					trvLevels.SelectedNode = trvNode;
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_LEFTLEVEL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				}
			}
			else
			{
				LRRMessagBox.ShowMessage("SID_LEFTLEVEL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
			}
			
		}
		public  void UpLevel()
		{
			TreeNode trvCurNode = trvLevels.SelectedNode;
			if(trvCurNode == null)
			{
				LRRMessagBox.ShowMessage("SID_UPLEVEL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				return;
			}
			TreeNode trvPrevNode = trvCurNode.PrevNode;
			if(trvPrevNode == null)
			{
				LRRMessagBox.ShowMessage("SID_UPLEVEL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				 return;
			}
			int iCurIndex = trvCurNode.Index;
			
			if(trvCurNode.Parent != null)
			{
				trvLevels.Sorted = false;
				TreeNode trvParent = trvCurNode.Parent;
				trvParent.Nodes.Remove(trvPrevNode);
				trvParent.Nodes.Insert(iCurIndex,trvPrevNode);
				trvLevels.SelectedNode = trvCurNode;
			}
		}
		public  void DownLevel()
		{
			TreeNode trvCurNode = trvLevels.SelectedNode;
			if(trvCurNode == null)
			{
				LRRMessagBox.ShowMessage("SID_DOWNLEVEL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				return;
			}
			if(trvCurNode != null)
			{
				TreeNode trvNextNode = trvCurNode.NextNode;
				int iNextIndex = 0;
				if(trvNextNode != null)
					iNextIndex = trvNextNode.Index;
			
				if(trvCurNode.Parent != null)
				{
					trvLevels.Sorted = false;
					TreeNode trvParent = trvCurNode.Parent;
					trvParent.Nodes.Remove(trvCurNode);
					trvParent.Nodes.Insert(iNextIndex,trvCurNode);
					trvLevels.SelectedNode = trvCurNode;
				}
			}
		}

		public void SaveLevels(TreeNode trvCurNode,TreeNode trvPrevNode)
		{
			LRRLevel lrrLevel = trvCurNode.Tag as LRRLevel;
			LRRLevel lrrPrevLevel = trvPrevNode.Tag as LRRLevel;
			string parentLevelID  = lrrPrevLevel.LevelID;

			IEnumerator iEnum = _lrrLevelLinks.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRLevelLink levelLink = iEnum.Current as LRRLevelLink;
				if(levelLink.ChildID == lrrLevel.LevelID)
				{
					levelLink.ParentID = parentLevelID;
				}
			}
				
			/*LRRLevelLinks toCommitLevelLinks = _lrrLevelLinks.GetChanges();
			_lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
			_lrrLevelLinks.RefreshCollection();*/
		}


		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add PlantLevels.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add PlantLevels.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add PlantLevels.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add PlantLevels.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add PlantLevels.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add PlantLevels.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add PlantLevels.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add PlantLevels.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add PlantLevels.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add PlantLevels.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			return false;
		}

		public void SelectionPaste()
		{
		
		}

		public void InsertNewRows()
		{

		}

		public bool SupportsImportToExcel()
		{
			return false;
		}

		public bool SupportsLevel()
		{
			return true;
		}

		
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		#endregion

		private void mnuInsert_Click(object sender, System.EventArgs e)
		{
			TreeNode trvSelectedNode = trvLevels.SelectedNode;
			if(trvSelectedNode!=null)
			{
				int iSelIndex = trvSelectedNode.Index;
				TreeNode trvNode = new TreeNode("");

				if(trvSelectedNode.Parent != null)
				{
					trvLevels.Sorted = false;
					TreeNode trvParentNode = trvSelectedNode.Parent;
					trvParentNode.Nodes.Insert(iSelIndex,trvNode);
					trvLevels.SelectedNode = trvNode;
					trvNode.BeginEdit();
				}
			}
		}

		private void trvLevels_MouseHover(object sender, System.EventArgs e)
		{
			
			
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add PlantLevels.ClearSort implementation
			SyncGridUtilities.ClearSort(gridPlantLevelItems);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add PlantLevels.SupportsClearSort implementation
			return true;
		}

		#endregion

		private void contextMenu1_Popup(object sender, System.EventArgs e)
		{
			mnuRemove.Enabled = true; 
			_lrrSitecomponents = new LRRSiteComponents();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSitecomponents);
			if(trvLevels.Nodes.Count>0)
			{
				LRRLevel lvl =  trvLevels.SelectedNode.Tag as LRRLevel;
				if(lvl != null)
				{
					string id = lvl.LevelID;
					ArrayList alist = new ArrayList();
					alist = GetAllChildLevels(id);
					for(int i = 0; i< alist.Count;  i++)
					{
						string str = alist[i] as string;
						for(int j = _lrrLevels.Count - 1; j >=0;j--)
						{
				
							LRRLevel levl = _lrrLevels[j] as LRRLevel;
							if(levl.LevelID == str)
							{
								LRRSiteComponents lsc = _lrrSitecomponents.FilterSiteComponentsByLevelID(levl.LevelID);   
								if(lsc.Count > 0)  
								{
									mnuRemove.Enabled = false; 
								}
							}
						}
					}
				}
			}
		}
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add PlantLevels.PrintPreview implementation
			if(gridPlantLevelItems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridPlantLevelItems,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add PlantLevels.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add PlantLevels.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add PlantLevels.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add PlantLevels.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add PlantLevels.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add PlantLevels.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add PlantLevels.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add PlantLevels.SupportsUndo implementation
			return false;
		}

		#endregion

		private void PlantLevels_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
            bool isUpdate = false;
            LRRLevels toCommitLevels = _lrrLevels.GetChanges();
            LRRLevelLinks toCommitLevelLinks = _lrrLevelLinks.GetChanges();
            if (toCommitLevels.Count > 0)
            {
                isUpdate = true;
            }
            if (toCommitLevelLinks.Count > 0)
            {
                isUpdate = true;
            }
            if (isUpdate)
            {
                DialogResult k = LRRMessagBox.ShowMessage("SID_SAVEINFO_QUESTION", "SID_LABEL", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
                if (k == DialogResult.Yes)
                {
                    Save();
                }
            }
			if(this.trvLevels.SelectedNode != null)
			{
				this.trvLevels.SelectedNode.EndEdit(true);
			}
			ApplicationPersistanceUtil.SaveGridSettings(this.trvLevels, this as ILRRUIContainer, this.Tag);
			this.trvLevels.Dispose();  
		}
		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add PlantLevels.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add PlantLevels.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add PlantLevels.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add PlantLevels.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add PlantLevels.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add PlantLevels.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add PlantLevels.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add PlantLevels.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add PlantLevels.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add PlantLevels.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}

