//public class ProjectOptions : System.Windows.Forms.Form,ILRRUIContainer
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Drawing;

using Symcon.BusinessObjects;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.ProjectOptions;
using Symcon.LightRidge.ProjectOptions.ProjectInfo;
using Symcon.Utils.XMLUtils;
using Symcon.Utils.HeaderDispatcher;
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ProjectOptions.
	/// </summary>
	public class ProjectOptionsForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel									panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl	gridProjectOptions;
		private LRRApp														_app;
		private ArrayList													_objProjectOptions;
		private System.Windows.Forms.Button									cmdOk;
		private LRRProjectOptions				_lrrProjOptions;	
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		//public ProjectOptionsForm(ArrayList collectionBase)
		public ProjectOptionsForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			//_objProjectOptions = collectionBase;
			_lrrProjOptions = SGTXmlSerializer.DeserializeXML(_app.ProjectOptionsFile,typeof(LRRProjectOptions)) as LRRProjectOptions;

			gridProjectOptions.DataSource = _lrrProjOptions.ProjectInfosObj;
			
			gridProjectOptions.Engine.RecordAsDisplayElements = true;

			SyncGridUtilities.InitializeGridLookAndFeel(gridProjectOptions);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ProjectOptionsForm));
			this.cmdOk = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.gridProjectOptions = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridProjectOptions)).BeginInit();
			this.SuspendLayout();
			// 
			// cmdOk
			// 
			this.cmdOk.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOk.Location = new System.Drawing.Point(96, 232);
			this.cmdOk.Name = "cmdOk";
			this.cmdOk.Size = new System.Drawing.Size(80, 24);
			this.cmdOk.TabIndex = 3;
			this.cmdOk.Tag = "SID_OK";
			this.cmdOk.Click += new System.EventHandler(this.cmdOk_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.gridProjectOptions);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(310, 224);
			this.panel1.TabIndex = 0;
			// 
			// gridProjectOptions
			// 
			this.gridProjectOptions.BackColor = System.Drawing.SystemColors.Window;
			this.gridProjectOptions.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridProjectOptions.Location = new System.Drawing.Point(0, 0);
			this.gridProjectOptions.Name = "gridProjectOptions";
			this.gridProjectOptions.Size = new System.Drawing.Size(310, 224);
			this.gridProjectOptions.TabIndex = 1;
			this.gridProjectOptions.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridProjectOptions.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridProjectOptions.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridProjectOptions.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridProjectOptions.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridProjectOptions.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridProjectOptions.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridProjectOptions.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridProjectOptions.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
			this.gridProjectOptions.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridProjectOptions.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridProjectOptions.Text = "gridProjectOptions";
			this.gridProjectOptions.ThemesEnabled = false;
			this.gridProjectOptions.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_HIST_DATA_PROP_MAPPED") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridProjectOptions.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridProjectOptions.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridProjectOptions.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridProjectOptions.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridProjectOptions.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridProjectOptions.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridProjectOptions.VersionInfo = "3.301.0.0";
			this.gridProjectOptions.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridProjectOptions_RecordValueChanged);
			// 
			// ProjectOptionsForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(310, 267);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.cmdOk);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ProjectOptionsForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_PJCTOPTIONS";
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridProjectOptions)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		private void cmdOk_Click(object sender, System.EventArgs e)
		{
			//SGTXmlSerializer.SerializeAsXML(_app.ProjectOptionsFile,typeof(LRRProjectOptions),_lrrProjOptions);
			_app.ReloadOptions();
		}

		private void gridProjectOptions_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			int nCtr = 0;
			ProjectInfo objProjectInfo = e.Record.GetData() as ProjectInfo;
			IEnumerator iProjOptEnum	= this._lrrProjOptions.ProjectInfosObj.GetEnumerator();
			while(iProjOptEnum.MoveNext())
			{
				ProjectInfo	objProjInfo= (ProjectInfo)iProjOptEnum.Current;
				
				if(objProjInfo.Active == true)
					objProjInfo.Active = false;
				
				if(objProjectInfo.OptionFileName != objProjInfo.OptionFileName)
					nCtr = nCtr + 1;
			}

			objProjectInfo.Active =true;
			this._lrrProjOptions.SelectedIndex = nCtr;
		}
	}
	/*public struct ProjectOptionDetails
	{ 
		private string _name; 
		private string _filepath; 
		private bool _blnSelected; 

		public ProjectOptionDetails(string sProjectOptionsName,string sProjectOptionsPath,bool blnSelected) 
		{ 
			_name = sProjectOptionsName; 
			_blnSelected = blnSelected;
			_filepath =  sProjectOptionsPath;
		} 
 
		public string Name 
		{ 
			get{ return _name; } 
			set{ _name = value;} 
		} 

		public string FilePath
		{ 
			get{ return _filepath; } 
			set{ _filepath = value;} 
		} 
		
		public bool Selected 
		{ 
			get{ return _blnSelected; } 
			set{ _blnSelected = value;} 
		} 
	}*/
}

	