using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ReconnectProgress.
	/// </summary>
	public class ReconnectProgress : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.PictureBox pictureProgress;
		private System.Windows.Forms.Label lblMessage;
		private LRRApp _app;
		private bool firstActivate = true;
		MyFilter filter;

		private delegate void ExecuteDel();
		public ReconnectProgress(LRRApp app,string message)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.lblMessage.Text = message;
			_app = app;
			 filter = new MyFilter();
			Application.AddMessageFilter(filter);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ReconnectProgress));
			this.pictureProgress = new System.Windows.Forms.PictureBox();
			this.lblMessage = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// pictureProgress
			// 
			this.pictureProgress.Image = ((System.Drawing.Image)(resources.GetObject("pictureProgress.Image")));
			this.pictureProgress.Location = new System.Drawing.Point(93, 64);
			this.pictureProgress.Name = "pictureProgress";
			this.pictureProgress.Size = new System.Drawing.Size(192, 16);
			this.pictureProgress.TabIndex = 0;
			this.pictureProgress.TabStop = false;
			// 
			// lblMessage
			// 
			this.lblMessage.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblMessage.Location = new System.Drawing.Point(53, 16);
			this.lblMessage.Name = "lblMessage";
			this.lblMessage.Size = new System.Drawing.Size(272, 32);
			this.lblMessage.TabIndex = 1;
			this.lblMessage.Text = "Reconnecting...";
			this.lblMessage.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// ReconnectProgress
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.ClientSize = new System.Drawing.Size(378, 90);
			this.ControlBox = false;
			this.Controls.Add(this.lblMessage);
			this.Controls.Add(this.pictureProgress);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ReconnectProgress";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_RECONNECTING";
			this.ResumeLayout(false);

		}
		#endregion

		public void Execute()
		{
			ExecuteDel del = new ExecuteDel(InternalExecute);
			object[] args = new object[0];
			_app.MainFrame.BeginInvoke(del,args);
		}

		private void InternalExecute()
		{
			_app.Reconnect();
			Application.RemoveMessageFilter(filter);
			this.DialogResult = DialogResult.Cancel;
			this.Dispose();

		}
	}

	class MyFilter:IMessageFilter //gets the left mouse button messages
	{
		public bool PreFilterMessage(ref Message m)
		{
			if ((m.Msg>=WM_LBUTTONDOWN && m.Msg<=WM_LBUTTONDBLCLK) ||(m.Msg>=WM_RBUTTONDOWN && m.Msg<=WM_RBUTTONDBLCLK) ||
				(m.Msg>= WM_NCLBUTTONDOWN && m.Msg<=WM_NCLBUTTONDBLCLK) ||
				(m.Msg>= WM_NCRBUTTONDOWN && m.Msg<=WM_NCRBUTTONDBLCLK) ||
				(m.Msg == WM_MDIDESTROY) ||
				(m.Msg == WM_ENDSESSION) ||
				(m.Msg == WM_QUIT)||
				(m.Msg == WM_CLOSE))
			{
				return(true);
			}
			return(false);
		}


		private const int WM_LBUTTONDOWN            = 0x0201;
		private const int  WM_LBUTTONDBLCLK          = 0x0203;
		private const int WM_RBUTTONDOWN            = 0x0204;
		private const int WM_RBUTTONDBLCLK          = 0x0206;
		private const int WM_MDIDESTROY             = 0x0221;
		private const int WM_ENDSESSION             = 0x0016;
		private const int WM_QUIT                   = 0x0012;
		private const int WM_CLOSE                  = 0x0010;

		private const int WM_NCLBUTTONDOWN          = 0x00A1;
		private const int WM_NCLBUTTONUP            = 0x00A2;
		private const int WM_NCLBUTTONDBLCLK        = 0x00A3;
		private const int WM_NCRBUTTONDOWN          = 0x00A4;
		private const int WM_NCRBUTTONDBLCLK        = 0x00A6;

	}

}
