using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections.Generic;

using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
    public delegate void ConfigData( LRRRunSet runset );

    public partial class RecordedRunSetManager : Form
    {

        public RecordedRunSetManager()
        {
            InitializeComponent();
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecSets);
            if (_lrrRunRecSets.Count != 0)
            {
                cmbRunSet.DataSource = _lrrRunRecSets;
                cmbRunSet.DisplayMember = "RunName";
                cmbRunSet.ValueMember = "RunID";
            }
        }

        private void ConfigureData(LRRRunSet activerunset)
        {

            //_activeRunSet = cmbRunSet.SelectedItem as LRRRunSet;

            List<string> list = new List<string>();

            _lrrRunRecords = new LRRRunRecords();
            _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords, " where RunSetID = '" + activerunset.RunID + "'");


            LRRSiteComponentPropertyValueChangeUserAndTimes siteComponentPropVals = new LRRSiteComponentPropertyValueChangeUserAndTimes();

            foreach (LRRRunRecord lrrr in _lrrRunRecords)
            {
                _lrrApp.RecordingValuesManagerObj.PopulateCollection(siteComponentPropVals, " Where RunID = '" + lrrr.RunID + "'");
                foreach (LRRSiteComponentPropertyValueChangeUserAndTime lscput in siteComponentPropVals)
                {
                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(lscput.EquipmentTag);
                    if (sc != null)
                    {
                        LRRSiteComponentProperties scps = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(sc.SiteComponentID);
                        LRRSiteComponentProperty scp = scps.GetSiteCompPropFromName(lscput.SiteComponentPropertyID);
                        if (scp != null && !list.Contains(scp.ID))
                        {
                            list.Add(scp.ID);
                            scp.IsTracked = true;
                        }
                        else
                        {
                            break;
                            int i = 0;
                        }

                    }
                }

                //LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(
            }

            int xyz = 0;

            LRRSiteComponentProperties scps1 = LRRModel.SiteComponentPropertiesObj.GetChanges();
            _lrrApp.DBManagerObj.CommitCollection(scps1);

        }

        private void btnConfig_Click(object sender, EventArgs e)
        {
            /*
            try
            {
                //_runset = cmbRun.SelectedItem as LRRRunSet;
                _activeRunSet = cmbRunSet.SelectedItem as LRRRunSet;

                LRRWaitWindowUtility.ShowPogressIndicator("Please wait while the Attributes are populated for active Recorded Runset  " + _activeRunSet.RunName + "......" );
                ConfigData configData = new ConfigData(ConfigureData);
                IAsyncResult result = configData.BeginInvoke(_activeRunSet, new AsyncCallback(ConfigDataCompleted),null );
                configData.EndInvoke(result);
                if (result.IsCompleted)
                {
                    

                    //LRRMessagBox.ShowMessage("SID_EXPORT_COMPLETED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            finally
            {

            }
            */

            _activeRunSet = cmbRunSet.SelectedItem as LRRRunSet;

            //MessageBox.Show(" You have selected to populate the attributes for the Recorded Runset : " + _activeRunSet.RunName + " This will take some time. Please wait.. ");
            

            List<string> list = new List<string>();
            List<string> runRecIDList = new List<string>();

            _lrrRunRecords = new LRRRunRecords();
            _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords, " where RunSetID = '" + _activeRunSet.RunID + "'");
            
            LRRSiteComponentPropertyValueChangeUserAndTimes siteComponentPropVals = new LRRSiteComponentPropertyValueChangeUserAndTimes();

            LRRRecordingValuesConnections reccons = LRRModel.RecordingValueConnections;
            string connectionString = "";
            System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand();
            System.Data.SqlClient.SqlCommand cmd1 = new System.Data.SqlClient.SqlCommand();
            

            foreach (LRRRecordingValuesConnection reccon in reccons)
            {
                if (reccon.IsActive)
                {
                    System.Data.IDataReader idr = null;
                    System.Data.IDataReader idr1 = null;
                    string scName = "";
                    string scpName = "";
                    string temp = "";
                    LRRSiteComponent sc = new LRRSiteComponent();
                    connectionString = @"Server=" + reccon.ServerName + @";Database=" + reccon.DatabaseName + @";User ID=" + reccon.UserName + ";Password=" + reccon.Passwd + ";Trusted_Connection=False";
                    System.Data.SqlClient.SqlConnection conObj = new System.Data.SqlClient.SqlConnection(connectionString);
                    conObj.Open();
                    cmd.Connection = conObj;
                    cmd1.Connection = conObj;
                    Hashtable tab = new Hashtable();
                    Object obj = new object();
                    ArrayList al = new ArrayList();
                    foreach (LRRRunRecord lrrr in _lrrRunRecords)
                    {
                        foreach (LRRSiteComponentProperty scp1 in LRRModel.SiteComponentPropertiesObj )
                        {
                            if (!list.Contains(scp1.ID))
                            {
                                LRRSiteComponent sc1 = LRRModel.SiteComponentsObj.GetSiteComponentByID(scp1.ComponentID);
                                cmd1.CommandText = "Select SiteComponentPropertyID from SiteComponentPropertyValueChangeUserAndTime Where EquipmentTag = '" + sc1.Name + "' And RunID = '" + lrrr.RunID + "' And SiteComponentPropertyID = '" + scp1.Name + "'";
                                idr1 = cmd1.ExecuteReader();
                                while (idr1.Read())
                                {
                                    list.Add(scp1.ID);
                                    temp = idr1.GetValue(0).ToString();
                                    scp1.IsTracked = true;
                                }
                                idr1.Close();
                            }
                            else
                            {
                                int abc = 0;
                            }
                        }

                        LRRSiteComponentProperties scps1 = LRRModel.SiteComponentPropertiesObj.GetChanges();
                        _lrrApp.DBManagerObj.CommitCollection(scps1);
                        #region comments3
                        /*
                        sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(scName);
                        cmd1.CommandText = "Select Distinct SiteComponentPropertyID from SiteComponentPropertyValueChangeUserAndTime Where EquipmentTag = '" + scName + "' And RunID = '" + lrrr.RunID + "'";
                        idr1 = cmd1.ExecuteReader();
                        while (idr1.Read())
                        {
                            scpName = idr1.GetValue(0).ToString();
                            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(sc.SiteComponentID).GetSiteCompPropFromName(scpName);
                            scp.IsTracked = true;
                        }
 * */
                        /*
                        while (idr.Read())
                        {
                            scName = idr.GetValue(0).ToString();
                            sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(scName);    
                            cmd1.CommandText = "Select Distinct SiteComponentPropertyID from SiteComponentPropertyValueChangeUserAndTime Where EquipmentTag = '" + scName + "' And RunID = '" + lrrr.RunID + "'";
                            idr1 = cmd1.ExecuteReader();
                            while (idr1.Read())
                            {
                                scpName = idr1.GetValue(0).ToString();
                                LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(sc.SiteComponentID).GetSiteCompPropFromName(scpName);
                                scp.IsTracked = true;
                            }
                        }*/
                        #endregion
                    }

                }

            }
            #region comments2
            /*
            foreach (LRRRecordingValuesConnection reccon in reccons)
            {
                if (reccon.IsActive)
                {
                    System.Data.IDataReader idr = null;
                    LRRSiteComponent sc = new LRRSiteComponent();
                    connectionString = @"Server=" + reccon.ServerName + @";Database=" + reccon.DatabaseName + @";User ID=" + reccon.UserName + ";Password=" + reccon.Passwd + ";Trusted_Connection=False";
                    System.Data.SqlClient.SqlConnection conObj = new System.Data.SqlClient.SqlConnection(connectionString);
                    conObj.Open();
                    if (conObj.State == System.Data.ConnectionState.Open)
                    {
                        cmd.Connection = conObj;
                        cmd1.Connection = conObj;
                        cmd.CommandText = "Select Distinct EquipmentTag from SiteComponentPropertyValueChangeUserAndTime Where RunID = '" + _activeRunSet.RunID + "'";
                        idr = cmd.ExecuteReader();
                        while (idr.Read())
                        {
                            //scName = idr.GetValue(0).ToString();
                            //sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(scName);
                            //cmd1.CommandText = "Select Distinct SiteComponentPropertyID from SiteComponentPropertyValueChangeUserAndTime Where EquipmentTag = '" + scName + "' And RunID = '" + _activeRunSet.RunID + "'";
                            while (idr.Read())
                            {
                                //scpName = idr.GetValue(0).ToString();
                                //LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(sc.SiteComponentID).GetSiteCompPropFromName(scpName);
                                //scp.IsTracked = true;
                            }
                        }
                    }
                }
            }
             * */
            //LRRSiteComponentProperties scps1 = LRRModel.SiteComponentPropertiesObj.GetChanges();
            //_lrrApp.DBManagerObj.CommitCollection(scps1);
            #endregion
            MessageBox.Show(" Recorded Attributes are flagged to Recording for Runset : " + _activeRunSet.RunName);
            #region comments1
            /*
            foreach (LRRRunRecord lrrr in _lrrRunRecords)
            {
                if (!(runRecIDList.Contains(lrrr.RunID)))
                {
                    runRecIDList.Add(lrrr.RunID);

                    _lrrApp.RecordingValuesManagerObj.PopulateCollection(siteComponentPropVals, " Where RunID = '" + lrrr.RunID + "'");
                    foreach (LRRSiteComponentPropertyValueChangeUserAndTime lscput in siteComponentPropVals)
                    {
                        LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(lscput.EquipmentTag);
                        if (sc != null)
                        {
                            //LRRSiteComponentProperties scps = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(sc.SiteComponentID);
                            //LRRSiteComponentProperty scp = scps.GetSiteCompPropFromName(lscput.SiteComponentPropertyID);
                            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(sc.SiteComponentID).GetSiteCompPropFromName(lscput.SiteComponentPropertyID);
                            if (scp != null && !list.Contains(scp.ID))
                            {
                                list.Add(scp.ID);
                                scp.IsTracked = true;
                            }
                            else
                            {
                                int i = 0;
                            }

                        }
                    }
                }
            }*/
            /*
            LRRSiteComponentProperties scps = LRRModel.SiteComponentPropertiesObj.GetChanges();
            _lrrApp.DBManagerObj.CommitCollection(scps);
            */
            #endregion
            
        }
        

        LRRRunRecords _lrrRunRecords;
        LRRRunSets _lrrRunRecSets = new LRRRunSets();
        LRRRunSet _activeRunSet = new LRRRunSet();
        private LRRApp _lrrApp;

        string svrname = "";
        string user = "";
        string pswd = "";
        string connstr = "";
        string sql = "";
        System.Data.SqlClient.SqlConnection recconn;

        string mainsvrname = "";
        string mainuser = "";
        string mianpswd = "";
        string mainconnstr = "";
        System.Data.SqlClient.SqlConnection mainconn;

        private void ConfigDataCompleted(IAsyncResult result)
        {
            LRRWaitWindowUtility.EndProgressIndicator();
            MessageBox.Show(" Recorded Attributes are flagged to Recording for Runset : " + _activeRunSet.RunName);
        }
        private void btnInitialise_Click(object sender, EventArgs e)
        {
            
        }

        private void btnMain_Click(object sender, EventArgs e)
        {
            /*
            connstr = "user id=" + user + ";password=" + pswd + ";database=" + txtTgt.Text + ";server=" + svrname;
            recconn = new System.Data.SqlClient.SqlConnection(connstr);
            try
            {
                recconn.Open();
            }
            catch (exception ex)
            {

            }
            **/
        }
    }
}