using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;




using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.Reports
{
    public partial class Report : Form
    {
        public Report()
        {
            InitializeComponent();
        }

        private void Report_Load(object sender, EventArgs e)
        {
           // reportViewer1.ServerReport.ReportServerUrl = new Uri("http://localhost:81/ReportServer");
          //  reportViewer1.ServerReport.ReportPath = "/Tutorial/TestReport1";
            //this.reportViewer1.RefreshReport();
        }
        #region fields
        private LRRApp _lrrApp;
        private DateTime _startTime = DateTime.Now;
        private DateTime _endTime = DateTime.Now.AddYears(-1500);
        private string _siteCompPropValueID;
        private LRRSiteComponentProperty _siteCompProp;
        private LRRSiteComponent _siteComp;
        private LRRMasterProperty _masterProperty;
        private LRRMasterComponent _masterComponentType;
        private LRRSiteComponentPropertyValue _siteCompPropVal;
        private LRRMode _mode;
        #endregion

        public void GenerateSingleAttributeReport(string reportServerURL, string reportPath, string masterComponentName, string masterPropertyName, string siteComponentName, DateTime starttime, DateTime endtime,string reportname)
        {
            reportViewer1.ServerReport.ReportServerUrl = new Uri(reportServerURL);
            reportViewer1.ServerReport.ReportPath = reportPath;
            reportViewer1.ServerReport.DisplayName = reportname;
            

            if (reportname == "Single Site Attribute Report")
            {
                    _masterComponentType = LRRModel.Model.GetMasterComponentTypeByName(masterComponentName);
                    _masterProperty = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByNameandComponentTypeID(masterPropertyName, _masterComponentType.ID);
                    _siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByName(siteComponentName);
                    _siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteComPropObjForMasterPropIDAndCompID(_masterProperty.PropID, _siteComp.SiteComponentID);
                    //_mode = LRRModel.Modes.GetModeByName(txtMode.Text.ToString());
                    //_siteCompPropVal = (LRRSiteComponentPropertyValue)_siteCompProp.GetPropertyValueForMode(_mode.ModeId.ToString());
                    //_siteCompPropValueID = _siteCompPropVal.ID;
                    //_startTime = datetimeStart.Value;
                    //_endTime = datetimeEnd.Value;

                    string strStarttime = starttime.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT, Symcon.BusinessObjects.SymConverter.Culture.NumberFormat);
                    string strEndtime = endtime.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT, Symcon.BusinessObjects.SymConverter.Culture.NumberFormat);

                    Microsoft.Reporting.WinForms.ReportParameter reportparam1 = new Microsoft.Reporting.WinForms.ReportParameter();
                    reportparam1.Name = "SiteComponentPropertyID";
                    reportparam1.Values.Add(_siteCompProp.ID);
                    Microsoft.Reporting.WinForms.ReportParameter reportparam2 = new Microsoft.Reporting.WinForms.ReportParameter();
                    reportparam2.Name = "StartTime";
                    reportparam2.Values.Add(strStarttime);
                    Microsoft.Reporting.WinForms.ReportParameter reportparam3 = new Microsoft.Reporting.WinForms.ReportParameter();
                    reportparam3.Name = "EndTime";
                    reportparam3.Values.Add(strEndtime);
                    Microsoft.Reporting.WinForms.ReportParameter reportparam4 = new Microsoft.Reporting.WinForms.ReportParameter();
                    reportparam4.Name = "SiteComponentPropName";
                    reportparam4.Values.Add(_siteCompProp.Name);
                    reportViewer1.ServerReport.SetParameters(new Microsoft.Reporting.WinForms.ReportParameter[] { reportparam1, reportparam2, reportparam3, reportparam4 });
                    this.reportViewer1.RefreshReport();
                
            }
            else if (reportname == "Master Attributes Report" || reportname == "Site Component Attributes Report")
            {
                this.reportViewer1.RefreshReport();
            }
            
            
            //LRRModel.PropertyValuesObj.get
        }

        private void btnViewReport_Click(object sender, EventArgs e)
        {

        }
        /*private void btnViewReport_Click(object sender, EventArgs e)
        {
            reportViewer1.ServerReport.ReportServerUrl = new Uri("http://localhost:81/ReportServer");
            reportViewer1.ServerReport.ReportPath = "/Tutorial/TestReport1";
            
            //reportViewer1.ServerReport.
            
            //reportViewer1.ServerReport.
            
            //Microsoft.Reporting.WinForms.ReportDataSourceCollection reportDSCollection = new Microsoft.Reporting.WinForms.ReportDataSourceCollection();
            Microsoft.Reporting.WinForms.ReportDataSourceInfoCollection reportDSColInfo =  reportViewer1.ServerReport.GetDataSources();

            //reportDSColInfo = reportViewer1.ServerReport.GetDataSources();

            _masterComponentType = LRRModel.Model.GetMasterComponentTypeByName(txtMasterComponentType.Text.ToString());
            _masterProperty = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByNameandComponentTypeID(txtSitePropertyName.Text.ToString(), _masterComponentType.ID);
            _siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByName(txtSiteComponentName.Text.ToString());
            _siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteComPropObjForMasterPropIDAndCompID(_masterProperty.PropID, _siteComp.SiteComponentID);
            _mode = LRRModel.Modes.GetModeByName(txtMode.Text.ToString());
            _siteCompPropVal = (LRRSiteComponentPropertyValue)_siteCompProp.GetPropertyValueForMode(_mode.ModeId.ToString());
            _siteCompPropValueID = _siteCompPropVal.ID;
            _startTime = datetimeStart.Value;
            _endTime = datetimeEnd.Value;

            string starttime = _startTime.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture.NumberFormat);
            string endtime = _endTime.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT, Symcon.BusinessObjects.SymConverter.Culture.NumberFormat);

            Microsoft.Reporting.WinForms.ReportParameter reportparam1 = new Microsoft.Reporting.WinForms.ReportParameter();
            reportparam1.Name = "SiteComponentPropertyID";
            reportparam1.Values.Add(_siteCompProp.ID);
            Microsoft.Reporting.WinForms.ReportParameter reportparam2 = new Microsoft.Reporting.WinForms.ReportParameter();
            reportparam2.Name = "StartTime";
            reportparam2.Values.Add(starttime);
            Microsoft.Reporting.WinForms.ReportParameter reportparam3 = new Microsoft.Reporting.WinForms.ReportParameter();
            reportparam3.Name = "EndTime";
            reportparam3.Values.Add(endtime);
            Microsoft.Reporting.WinForms.ReportParameter reportparam4 = new Microsoft.Reporting.WinForms.ReportParameter();
            reportparam4.Name = "SiteComponentPropName";
            reportparam4.Values.Add(_siteCompProp.Name);
            reportViewer1.ServerReport.SetParameters(new Microsoft.Reporting.WinForms.ReportParameter[] { reportparam1, reportparam2, reportparam3, reportparam4});
            this.reportViewer1.RefreshReport();
             //LRRModel.PropertyValuesObj.get

                
                
        }*/


    }
}