using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.MessageDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
    public delegate void ExportData(string fileName);

	/// <summary>
	/// Summary description for ExportRecordValues.
	/// </summary>
	public class ExportRecordValues : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtExcel;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.Label lblRun;
		private System.Windows.Forms.Label lblExcel;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.ComboBox cmbRun;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
        private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		public ExportRecordValues()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            if (_lrrApp.RecordingValuesManagerObj != null)
            {
                _lrrRunRecSets = new LRRRunSets();
                _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecSets, " where UID = '" + _lrrApp.UID + "'");
                _lrrSiteCompPropValues = new LRRSiteComponentPropertyValueChangeUserAndTimes();

                if (_lrrRunRecSets.Count == 0)
                {
                    btnOK.Enabled = false;
                }
                else
                {
                    btnOK.Enabled = true;
                }

                cmbRun.DataSource = _lrrRunRecSets;
                cmbRun.DisplayMember = "RunName";
                cmbRun.ValueMember = "RunID";
            }

            #region Old implementation
            /*
            _lrrSiteCompPropValues = new LRRSiteComponentPropertyValueChangeUserAndTimes();
//			//Populate from RecordingValues DB
//			_lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrSiteCompPropValues);

			_lrrRunRecords = new LRRRunRecords();
			//_lrrApp.DBManagerObj.PopulateCollection(_lrrRunRecords);
			_lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords);

			if(_lrrRunRecords.Count == 0)
			{
				btnOK.Enabled = false;
			}
			else
			{
				btnOK.Enabled = true;
			}

			cmbRun.DataSource = _lrrRunRecords;
			cmbRun.DisplayMember = "RunName";
			cmbRun.ValueMember = "RunID";
            */
            #endregion
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ExportRecordValues));
            this.lblRun = new System.Windows.Forms.Label();
            this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
            this.txtExcel = new System.Windows.Forms.TextBox();
            this.btnBrowse = new System.Windows.Forms.Button();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.lblExcel = new System.Windows.Forms.Label();
            this.btnOK = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.cmbRun = new System.Windows.Forms.ComboBox();
            this.SuspendLayout();
            // 
            // lblRun
            // 
            this.lblRun.Location = new System.Drawing.Point(8, 16);
            this.lblRun.Name = "lblRun";
            this.lblRun.Size = new System.Drawing.Size(144, 23);
            this.lblRun.TabIndex = 0;
            this.lblRun.Tag = "SID_SELE_RUN_TO_EXPORT";
            // 
            // saveFileDialog
            // 
            this.saveFileDialog.RestoreDirectory = true;
            // 
            // txtExcel
            // 
            this.txtExcel.Location = new System.Drawing.Point(160, 48);
            this.txtExcel.Name = "txtExcel";
            this.txtExcel.Size = new System.Drawing.Size(200, 20);
            this.txtExcel.TabIndex = 2;
            // 
            // btnBrowse
            // 
            this.btnBrowse.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnBrowse.ImageIndex = 0;
            this.btnBrowse.ImageList = this.imageList1;
            this.btnBrowse.Location = new System.Drawing.Point(368, 48);
            this.btnBrowse.Name = "btnBrowse";
            this.btnBrowse.Size = new System.Drawing.Size(75, 23);
            this.btnBrowse.TabIndex = 3;
            this.btnBrowse.Tag = "SID_BROWSE";
            this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            // 
            // lblExcel
            // 
            this.lblExcel.Location = new System.Drawing.Point(8, 48);
            this.lblExcel.Name = "lblExcel";
            this.lblExcel.Size = new System.Drawing.Size(128, 23);
            this.lblExcel.TabIndex = 3;
            this.lblExcel.Tag = "SID_SELE_EXCEL_FILE";
            // 
            // btnOK
            // 
            this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnOK.Location = new System.Drawing.Point(312, 80);
            this.btnOK.Name = "btnOK";
            this.btnOK.Size = new System.Drawing.Size(75, 23);
            this.btnOK.TabIndex = 4;
            this.btnOK.Tag = "SID_OK";
            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // btnCancel
            // 
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnCancel.ImageIndex = 4;
            this.btnCancel.ImageList = this.imageList1;
            this.btnCancel.Location = new System.Drawing.Point(392, 80);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(75, 23);
            this.btnCancel.TabIndex = 5;
            this.btnCancel.Tag = "SID_CANCEL";
            // 
            // cmbRun
            // 
            this.cmbRun.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbRun.Location = new System.Drawing.Point(160, 16);
            this.cmbRun.Name = "cmbRun";
            this.cmbRun.Size = new System.Drawing.Size(200, 21);
            this.cmbRun.TabIndex = 1;
            // 
            // ExportRecordValues
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(474, 112);
            this.Controls.Add(this.cmbRun);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnOK);
            this.Controls.Add(this.lblExcel);
            this.Controls.Add(this.btnBrowse);
            this.Controls.Add(this.txtExcel);
            this.Controls.Add(this.lblRun);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "ExportRecordValues";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Tag = "SID_EXPORT_RECORDED_VALUES";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			saveFileDialog.Filter = "Excel Files|*.xls";
            //saveFileDialog.Filter = "Excel Files|*";
			saveFileDialog.ShowDialog();
			fname = saveFileDialog.FileName; 
			txtExcel.Text = fname;
			return;
		}
        private void Export(string fileName)
        {
            //_lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrSiteCompPropertyValuesUserAndTime);//, " where RunID = '" + lrrRunRecord.RunID + "'");
            //_lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecordObjects);//, " where RunID = '" + lrrRunRecord.RunID + "'");
            //ExportRecordedValuesUtiility.exportToExcelSychFusion(fileName, _lrrSiteCompPropertyValuesUserAndTime, _lrrRunRecordObjects);


            _lrrRunRecords = new LRRRunRecords();

            _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords, " where RunSetID = '" + _runset.RunID + "'" );

            ExportRecordedValuesUtiility.exportToExcelSychFusion(fname, null, _lrrRunRecords, _runset.RunName);


        }

        LRRRunSet _runset = null;

		private void btnOK_Click(object sender, System.EventArgs e)
        {
            /*
            LRRRunSet runset = cmbRun.SelectedItem as LRRRunSet;

            _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrSiteCompPropValues, " where RunSetID = '" + runset.RunID + "'");

            string xys = "0";
             * */
            try
            {
                _runset = cmbRun.SelectedItem as LRRRunSet;

                LRRWaitWindowUtility.ShowPogressIndicator("Please wait while Time and Attribute framework is created in Excel....");
                ExportData exportData = new ExportData(Export);
                IAsyncResult result = exportData.BeginInvoke(fname, null, null);
                exportData.EndInvoke(result);
                if (result.IsCompleted)
                {
                    LRRWaitWindowUtility.EndProgressIndicator();
                    MessageBox.Show(" Time and Attribute framework created at : " + fname + " Please access the framework to export recorded data ");

                    //LRRMessagBox.ShowMessage("SID_EXPORT_COMPLETED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            finally
            {

            }

            //MessageBox.Show(" Time and Attribute framework created at : " + fname + " Please access the framework to export recorded data ");

/*

            LRRRunSet runset = cmbRun.SelectedItem as LRRRunSet;

            _lrrRunRecords = new LRRRunRecords();

            _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords, " where RunSetID = '" + runset.RunID + "'");

            ExportRecordedValuesUtiility.exportToExcelSychFusion(fname, null, _lrrRunRecords);

            LRRWaitWindowUtility.EndProgressIndicator();

            MessageBox.Show(" Time and Attribute framework created at : " + fname + " Please access the framework to export recorded data ");
 * */


            #region Old Impl
            /*
            if (fname == null || fname.Trim() == "")
			{
				LRRMessagBox.ShowMessage("SID_SELECT_CVSFILE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				return;
			}
			
			LRRRunRecord lrrRunRecord = cmbRun.SelectedItem as LRRRunRecord;

			//Populate from RecordingValues DB
			_lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrSiteCompPropValues," where RunID = '" + lrrRunRecord.RunID+ "'");

			LRRSiteComponentPropertyValueChangeUserAndTimes siteComponentPropVals = new LRRSiteComponentPropertyValueChangeUserAndTimes();
			IEnumerator siteCompPropValEnum = _lrrSiteCompPropValues.GetEnumerator();
			while(siteCompPropValEnum.MoveNext())
			{
				LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropVal = siteCompPropValEnum.Current as LRRSiteComponentPropertyValueChangeUserAndTime;
			
				if(siteCompPropVal.RunID == lrrRunRecord.RunID)
					siteComponentPropVals.Add(siteCompPropVal);
				
			}

			//ExportRecordedValuesUtiility.writeToExcel(fname,siteComponentPropVals,lrrRunRecord);
            //ExportRecordedValuesUtiility.exportToExcel(fname, siteComponentPropVals, lrrRunRecord);
            ExportRecordedValuesUtiility.exportToExcelSychFusion(fname, siteComponentPropVals, lrrRunRecord);
			LRRMessagBox.ShowMessage("SID_EXPORT_COMPLETED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
            */
            #endregion
        }

		#region Fields
		private LRRApp _lrrApp;
		private string fname = null;
		private LRRSiteComponentPropertyValueChangeUserAndTimes _lrrSiteCompPropValues;
		private LRRRunRecords	_lrrRunRecords;

        private LRRRunSet _lrrrunset;
        private LRRRunSets _lrrRunRecSets;
		#endregion
	}
}
