using System;

namespace Symcon.LightRidge.PEAdvisor
{
	public enum MessageStateEnum
	{
		PAUSED,
		RESUME,
		STOP,
		ACTIVE,
		PROCESSING,
		PROCESSED,
		NONE
	}

	public enum RunConditionEnum
	{
		CURRENT_RUN_WITH_INCREMENT,
		CURRENT_RUN_WITH_CUSTOM_TIME,
		CURRENT_RUN_WITH_INCREMENT_NEXT_STEP,
		CURRENT_RUN_AUTO_WITH_CUSTOM_BOUNDARIES,
		CURRENT_RUN_WITHOUT_INCREMENT,
		TUNING_RUN_WITH_SEQUENTIAL_DATASETS,
		TUNING_RUN_WITH_RANDOM_DATASETS,
		HISTORY_RUN_WITH_CUSTOM_TIME,
		TUNING_RUN_WITH_INCREMENT,
		OFFLINE_RUN_WITH_SEQUENTIAL_DATASETS,
		OFFLINE_RUN_WITH_RANDOM_DATASETS,
		OFFLINE_RUN_WITH_INCREMENT,
		NONE
	}
	
	public enum RunTypeEnum
	{
		SINGLE_RUN,
		AUTO_RUN,
		SINGLE_RUN_ENTERED_WINDOW,
		SINGLE_RUN_STEP_NEXT,
		SINGLE_RUN_ADVANCE_NOW,
		NONE
	}

	/// <summary>
	/// Summary description for RunMessage.
	/// </summary>
	public class RunMessage
	{
		public RunMessage()
		{

		}

		#region Properties
		public string StartTime
		{
			get { return _startTime;}
			set
			{
				_startTime = value;
			}
		}
		
		public string EndTime
		{
			get { return _endTime;}
			set
			{
				_endTime = value;
			}
		}

		public string AutoRunStartTime
		{
			get { return _autoRunStartTime;}
			set
			{
				_autoRunStartTime = value;
			}
		}
		
		public string AutoRunEndTime
		{
			get { return _autoRunEndTime;}
			set
			{
				_autoRunEndTime = value;
			}
		}

		public bool AutoRunBoundariesON
		{
			get { return _autoRunBoundariesON;}
			set
			{
				_autoRunBoundariesON = value;
			}
		}

		public MessageStateEnum MsgState
		{
			get { return _msgState;}
			set
			{
				_msgState = value;
			}
		}

		public RunTypeEnum RunType
		{
			get { return _runType;}
			set
			{
				_runType = value;
			}
		}

		public RunConditionEnum RunCondition
		{
			get { return _runCondition;}
			set
			{
				_runCondition = value;
			}
		}
		#endregion

		#region Fields
		private string				_startTime;
		private string				_endTime;
		private string				_autoRunStartTime;
		private string				_autoRunEndTime;
		private bool				_autoRunBoundariesON = false;
		private MessageStateEnum	_msgState;
		private RunTypeEnum			_runType;
		private	RunConditionEnum	_runCondition;
		#endregion
	}
}
