using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.PEAdvisor;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor.SavedViews
{
	/// <summary>
	/// Summary description for DynamicSavedCaseForm.
	/// </summary>
	public class DynamicSavedCaseForm : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSavedCase;
		private System.Windows.Forms.Panel pnlGrid;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Splitter splitter1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DynamicSavedCaseForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			BindGrid();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DynamicSavedCaseForm));
			this.gridSavedCase = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlGrid = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOk = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridSavedCase)).BeginInit();
			this.pnlGrid.SuspendLayout();
			this.pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// gridSavedCase
			// 
			this.gridSavedCase.BackColor = System.Drawing.SystemColors.Window;
			this.gridSavedCase.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.gridSavedCase.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSavedCase.Location = new System.Drawing.Point(0, 0);
			this.gridSavedCase.Name = "gridSavedCase";
			this.gridSavedCase.Size = new System.Drawing.Size(468, 114);
			this.gridSavedCase.TabIndex = 0;
			this.gridSavedCase.TableDescriptor.AllowEdit = false;
			this.gridSavedCase.TableDescriptor.AllowNew = false;
			this.gridSavedCase.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridSavedCase.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridSavedCase.Text = "gridGroupingControl1";
			this.gridSavedCase.VersionInfo = "3.301.0.0";
			this.gridSavedCase.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridSavedCase_TableControlCellClick);
			// 
			// pnlGrid
			// 
			this.pnlGrid.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlGrid.Controls.Add(this.splitter1);
			this.pnlGrid.Controls.Add(this.gridSavedCase);
			this.pnlGrid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlGrid.Location = new System.Drawing.Point(0, 0);
			this.pnlGrid.Name = "pnlGrid";
			this.pnlGrid.Size = new System.Drawing.Size(470, 116);
			this.pnlGrid.TabIndex = 1;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 111);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(468, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.btnCancel);
			this.pnlBottom.Controls.Add(this.btnOk);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 116);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(470, 48);
			this.pnlBottom.TabIndex = 2;
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(390, 16);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// btnOk
			// 
			this.btnOk.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.Location = new System.Drawing.Point(302, 16);
			this.btnOk.Name = "btnOk";
			this.btnOk.TabIndex = 0;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// DynamicSavedCaseForm
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(470, 164);
			this.Controls.Add(this.pnlGrid);
			this.Controls.Add(this.pnlBottom);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "DynamicSavedCaseForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_OPEN_CASE";
			((System.ComponentModel.ISupportInitialize)(this.gridSavedCase)).EndInit();
			this.pnlGrid.ResumeLayout(false);
			this.pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		private void InitDataSource()
		{
			_lrrSavedCases = new LRRDynamicSavedCases();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSavedCases);
		}

		private void BindGrid()
		{
			//Suspend the Layout of the Grid...
			gridSavedCase.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridSavedCase);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridSavedCase,_lrrSavedCases.ItemType,null,true,null);
			
			this.gridSavedCase.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridSavedCase.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridSavedCase.BackColor = System.Drawing.SystemColors.Window;
			this.gridSavedCase.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridSavedCase.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridSavedCase.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridSavedCase.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridSavedCase.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_SAVED_CASES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridSavedCase.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridSavedCase.TableDescriptor.AllowNew = false;
			this.gridSavedCase.TableDescriptor.AllowEdit = false;
			this.gridSavedCase.TableDescriptor.AllowRemove = true;

			this.gridSavedCase.SourceListSet.Add("Parent",_lrrSavedCases);

			this.gridSavedCase.TableDescriptor.Relations.Clear();
			this.gridSavedCase.DataSource = null;
			this.gridSavedCase.DataSource = _lrrSavedCases;

			this.gridSavedCase.ResumeLayout(true);
			this.gridSavedCase.TableDescriptor.RecordDeleting+=new Syncfusion.Grouping.RecordEventHandler(TableDescriptor_RecordDeleting);
		}

		private void UpdateModel()
		{
			LRRDynamicSavedCase savedCase = this.SelectedCase;
			string savedCaseID = savedCase.ID;

			//Update Site Components
			IEnumerator iSiteCompEnum = LRRDynamicModel.DynamicSiteComponents.GetEnumerator();
			while(iSiteCompEnum.MoveNext())
			{
				LRRDynamicSiteComponent dynamicSiteComp = iSiteCompEnum.Current as LRRDynamicSiteComponent;
				if(dynamicSiteComp.DynamicCaseID != savedCaseID)
					continue;
				LRRSiteComponent siteComponent = new LRRSiteComponent();
				siteComponent.SiteComponentID = dynamicSiteComp.SiteComponentID;
				siteComponent.Name = dynamicSiteComp.Name;
				siteComponent.MasterComponentType = dynamicSiteComp.MasterComponentType;
				siteComponent.PlantUnit = dynamicSiteComp.PlantUnit;
				siteComponent.Description = dynamicSiteComp.Description;
				siteComponent.EquipmentTag = dynamicSiteComp.EquipmentTag;
				siteComponent.EffectivePlantTime = dynamicSiteComp.EffectivePlantTime;
				LRRModel.SiteComponentsObj.Add(siteComponent);
				IEnumerator iSiteCompPropEnum = dynamicSiteComp.Properties.GetEnumerator();
				while(iSiteCompPropEnum.MoveNext())
				{
					LRRDynamicSiteComponentProperty dynamicSiteCompProp = iSiteCompPropEnum.Current as LRRDynamicSiteComponentProperty;
					LRRSiteComponentProperty siteComponentProp = new LRRSiteComponentProperty();
					siteComponentProp.ID = dynamicSiteCompProp.ID;
					siteComponentProp.Name = dynamicSiteCompProp.Name;
					siteComponentProp.Description = dynamicSiteCompProp.Description;
					siteComponentProp.UOMTypeID = dynamicSiteCompProp.UOMTypeID;
					siteComponentProp.UOM = dynamicSiteCompProp.UOM;
					siteComponentProp.ModeID = dynamicSiteCompProp.ModeID;
					siteComponentProp.ComponentID = dynamicSiteCompProp.ComponentID;
					siteComponentProp.Type	= dynamicSiteCompProp.Type;
					siteComponentProp.PropertyID = dynamicSiteCompProp.PropertyID;
					siteComponentProp.IsTracked = dynamicSiteCompProp.IsTracked;
					siteComponentProp.IsTrended = dynamicSiteCompProp.IsTrended;
					siteComponentProp.IsDynamic = true;
					siteComponentProp.ObjectState =  Symcon.Globals.Enums.DBOperation.UNCHANGED;
					siteComponent.Properties.Add(siteComponentProp);
				}

				siteComponent.IsDynamic = true;
				siteComponent.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;
				
			}
			
			//Update Site Component Properties
			IEnumerator iSiteCompPropsEnum = LRRDynamicModel.DynamicSiteComponentProperties.GetEnumerator();
			while(iSiteCompPropsEnum.MoveNext())
			{
				LRRDynamicSiteComponentProperty dynamicSiteCompProp = iSiteCompPropsEnum.Current as LRRDynamicSiteComponentProperty;
				if(dynamicSiteCompProp.DynamicCaseID != savedCaseID)
					continue;
				LRRSiteComponentProperty siteComponentProp = new LRRSiteComponentProperty();
				siteComponentProp.ID = dynamicSiteCompProp.ID;
				siteComponentProp.Name = dynamicSiteCompProp.Name;
				siteComponentProp.Description = dynamicSiteCompProp.Description;
				siteComponentProp.UOMTypeID = dynamicSiteCompProp.UOMTypeID;
				siteComponentProp.UOM = dynamicSiteCompProp.UOM;
				siteComponentProp.ModeID = dynamicSiteCompProp.ModeID;
				siteComponentProp.ComponentID = dynamicSiteCompProp.ComponentID;
				siteComponentProp.Type	= dynamicSiteCompProp.Type;
				siteComponentProp.PropertyID = dynamicSiteCompProp.PropertyID;
				siteComponentProp.IsTracked = dynamicSiteCompProp.IsTracked;
				siteComponentProp.IsTrended = dynamicSiteCompProp.IsTrended;
				siteComponentProp.EffectivePlantTime = dynamicSiteCompProp.EffectivePlantTime;
				LRRModel.SiteComponentPropertiesObj.Add(siteComponentProp);

				IEnumerator iSiteCompPropValueEnum = dynamicSiteCompProp.Values.GetEnumerator();
				while(iSiteCompPropValueEnum.MoveNext())
				{
					LRRDynamicSiteComponentPropertyValue dynamicSiteCompPropValue = iSiteCompPropValueEnum.Current as LRRDynamicSiteComponentPropertyValue;
					LRRSiteComponentPropertyValue siteComponentPropValue = new LRRSiteComponentPropertyValue();
					siteComponentPropValue.ID = dynamicSiteCompPropValue.ID;
					siteComponentPropValue.SiteComponentPropertyID = dynamicSiteCompPropValue.SiteComponentPropertyID;
					siteComponentPropValue.PropertyValue = dynamicSiteCompPropValue.PropertyValue;
					//					siteComponentPropValue.ActualPropertyValue = dynamicSiteCompPropValue.ActualPropertyValue;
					siteComponentPropValue.ModelUOM = dynamicSiteCompPropValue.ModelUOM;
					siteComponentPropValue.Derivation = dynamicSiteCompPropValue.Derivation;
					siteComponentPropValue.ModeID = dynamicSiteCompPropValue.ModeID;
					siteComponentPropValue.EffectivePlantTime = dynamicSiteCompPropValue.EffectivePlantTime;
					siteComponentPropValue.Direction = dynamicSiteCompPropValue.Direction;
					siteComponentPropValue.IsDynamic = true;
					siteComponentPropValue.ObjectState =  Symcon.Globals.Enums.DBOperation.UNCHANGED;
					siteComponentProp.Values.Add(siteComponentPropValue);
				}

				siteComponentProp.IsDynamic = true;
				siteComponentProp.ObjectState =  Symcon.Globals.Enums.DBOperation.UNCHANGED;
				
			}
			
			//Update Site Component property Values
			IEnumerator iSiteCompPropValuesEnum = LRRDynamicModel.DynamicSiteComponentPropertyValues.GetEnumerator();
			while(iSiteCompPropValuesEnum.MoveNext())
			{
				LRRDynamicSiteComponentPropertyValue dynamicSiteCompPropValue = iSiteCompPropValuesEnum.Current as LRRDynamicSiteComponentPropertyValue;
				if(dynamicSiteCompPropValue.DynamicCaseID != savedCaseID)
					continue;

				LRRSiteComponentPropertyValue siteComponentPropValue = new LRRSiteComponentPropertyValue();
				siteComponentPropValue.ID = dynamicSiteCompPropValue.ID;
				siteComponentPropValue.SiteComponentPropertyID = dynamicSiteCompPropValue.SiteComponentPropertyID;
				siteComponentPropValue.PropertyValue = dynamicSiteCompPropValue.PropertyValue;
				//				siteComponentPropValue.ActualPropertyValue = dynamicSiteCompPropValue.ActualPropertyValue;
				siteComponentPropValue.ModelUOM = dynamicSiteCompPropValue.ModelUOM;
				siteComponentPropValue.Derivation = dynamicSiteCompPropValue.Derivation;
				siteComponentPropValue.ModeID = dynamicSiteCompPropValue.ModeID;
				siteComponentPropValue.EffectivePlantTime = dynamicSiteCompPropValue.EffectivePlantTime;
				siteComponentPropValue.Direction = dynamicSiteCompPropValue.Direction;
				siteComponentPropValue.IsDynamic = true;
				siteComponentPropValue.ObjectState =  Symcon.Globals.Enums.DBOperation.UNCHANGED;
				LRRModel.PropertyValuesObj.Add(siteComponentPropValue);
			}
			
			//Update Site Component group properties
			IEnumerator iSiteCompGrpPropsEnum = LRRDynamicModel.DynamicSiteCompGrpProps.GetEnumerator();
			while(iSiteCompGrpPropsEnum.MoveNext())
			{
				LRRDynamicSiteComponentGroupProperty dynamicSiteCompGrpProp = iSiteCompGrpPropsEnum.Current as LRRDynamicSiteComponentGroupProperty;
				if(dynamicSiteCompGrpProp.DynamicCaseID != savedCaseID)
					continue;

				LRRSiteComponentGroupProperty siteComponentGrpProp = new LRRSiteComponentGroupProperty();
				siteComponentGrpProp.GroupPropertyID = dynamicSiteCompGrpProp.GroupPropertyID;
				siteComponentGrpProp.AttributeName = dynamicSiteCompGrpProp.AttributeName;
				siteComponentGrpProp.AttributeDescription = dynamicSiteCompGrpProp.AttributeDescription;
				siteComponentGrpProp.SiteComponentPropID = dynamicSiteCompGrpProp.SiteComponentPropID;
				siteComponentGrpProp.UOM = dynamicSiteCompGrpProp.UOM;
				siteComponentGrpProp.UOMTypeID = dynamicSiteCompGrpProp.UOMTypeID;
				siteComponentGrpProp.ModeID = dynamicSiteCompGrpProp.ModeID;
				siteComponentGrpProp.LookUpPropertiesID = dynamicSiteCompGrpProp.LookUpPropertiesID;
				siteComponentGrpProp.PropertyID = dynamicSiteCompGrpProp.PropertyID;
				siteComponentGrpProp.MasterPropID = dynamicSiteCompGrpProp.MasterPropID;
				siteComponentGrpProp.IsDynamic = true;
				siteComponentGrpProp.ObjectState =  Symcon.Globals.Enums.DBOperation.UNCHANGED;
				LRRModel.SiteComponentGroupPropertiesObj.Add(siteComponentGrpProp);
			}
			
			//Update Site Component Qualifier Values
			IEnumerator iSiteCompQualValueEnum = LRRDynamicModel.DynamicSiteGrpQualValues.GetEnumerator();
			while(iSiteCompQualValueEnum.MoveNext())
			{
				LRRDynamicSiteGroupPropertyQualifierValue dynamicSiteCompQualValue = iSiteCompQualValueEnum.Current as LRRDynamicSiteGroupPropertyQualifierValue;
				if(dynamicSiteCompQualValue.DynamicCaseID != savedCaseID)
					continue;

				LRRSiteGroupPropertyQualifierValue siteComponentQualValue = new LRRSiteGroupPropertyQualifierValue();
				siteComponentQualValue.SiteGroupPropertyQualifierValueID = dynamicSiteCompQualValue.SiteGroupPropertyQualifierValueID;
				siteComponentQualValue.GroupPropertyID = dynamicSiteCompQualValue.GroupPropertyID;
				siteComponentQualValue.LookUpQualifierID = dynamicSiteCompQualValue.LookUpQualifierID;
				siteComponentQualValue.LookUpPropertiesID = dynamicSiteCompQualValue.LookUpPropertiesID;
				siteComponentQualValue.PropertyID = dynamicSiteCompQualValue.PropertyID;
				siteComponentQualValue.QualifierID = dynamicSiteCompQualValue.QualifierID;
				siteComponentQualValue.PropertyValue = dynamicSiteCompQualValue.PropertyValue;
				siteComponentQualValue.ActualPropertyValue = dynamicSiteCompQualValue.ActualPropertyValue;
				siteComponentQualValue.ModeID = dynamicSiteCompQualValue.ModeID;
				siteComponentQualValue.Direction = dynamicSiteCompQualValue.Direction;
				siteComponentQualValue.Derivation = dynamicSiteCompQualValue.Derivation;
				siteComponentQualValue.MasterPropID = dynamicSiteCompQualValue.MasterPropID;
				siteComponentQualValue.SiteComponentPropID = dynamicSiteCompQualValue.SiteComponentPropID;
				siteComponentQualValue.EffectivePlantTime = dynamicSiteCompQualValue.EffectivePlantTime;
				siteComponentQualValue.IsDynamic = true;
				siteComponentQualValue.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;
				LRRModel.SiteGroupPropertyQualifierValuesObj.Add(siteComponentQualValue);
			}

			//Update Hist Prop Comp Prop mappings
			IEnumerator iHistPropCompMapEnum = LRRDynamicModel.DynamicHistPropCompPropMappings.GetEnumerator();
			while(iHistPropCompMapEnum.MoveNext())
			{
				LRRDynamicHistPropCompPropMapping dynamicLhcpm = iHistPropCompMapEnum.Current as LRRDynamicHistPropCompPropMapping;
				if(dynamicLhcpm.DynamicCaseID != savedCaseID)
					continue;

				LRRHistPropCompPropMapping histPropCompProp = new LRRHistPropCompPropMapping();
				histPropCompProp.MappingId = dynamicLhcpm.MappingId;
				histPropCompProp.HistPropID = dynamicLhcpm.HistPropID;
				histPropCompProp.GroupPropertyID = dynamicLhcpm.GroupPropertyID;
				histPropCompProp.GroupPropertyValID = dynamicLhcpm.GroupPropertyValID;
				histPropCompProp.SiteComponentPropID = dynamicLhcpm.SiteComponentPropID;
				histPropCompProp.SiteComponentPropValID = dynamicLhcpm.SiteComponentPropValID;
				histPropCompProp.HistTag = dynamicLhcpm.HistTag;
				histPropCompProp.ComponentPropertyName = dynamicLhcpm.ComponentPropertyName;
				histPropCompProp.EffectivePlantTime = dynamicLhcpm.EffectivePlantTime;
				histPropCompProp.ComponentID = dynamicLhcpm.ComponentID;
				histPropCompProp.LookupQualifierID = dynamicLhcpm.LookupQualifierID;
				histPropCompProp.LookUpPropertiesID = dynamicLhcpm.LookUpPropertiesID;
				histPropCompProp.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;
				histPropCompProp.IsDynamic = true;
				LRRModel.HistPropMaps.Add(histPropCompProp);
			}
		}
		#endregion

		#region Fields
		private LRRApp	_lrrApp;
		private LRRDynamicSavedCases _lrrSavedCases;
		private LRRDynamicSavedCase  _selectedCase;

		#endregion

		#region Properties
		private LRRDynamicSavedCase SelectedCase
		{
			get{return _selectedCase;}
			set
			{
				_selectedCase = value;
			}
		}
		#endregion
		
		#region EventHandlers
		private void btnOk_Click(object sender, System.EventArgs e)
		{
			if(this.SelectedCase == null)
			{
				this.DialogResult = DialogResult.Cancel;
				return;
			}

			Cursor.Current = Cursors.WaitCursor;
			Cursor.Show();
			
			Symcon.Utils.TimerUtils.HiPerfTimer hTimer = new Symcon.Utils.TimerUtils.HiPerfTimer();
			hTimer.Start();
			Logger.LogMessage("Open Case Start Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);

			_lrrApp.DynamicCaseID = this.SelectedCase.ID;
			//Update the Model
			UpdateModel();
			_lrrApp.SetPropertyHistorianBinding();


			Logger.LogMessage("Open Case End Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//Difference
			hTimer.Stop();
			Logger.LogMessage("Open Case Difference:" + hTimer.Duration.ToString(Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			Cursor.Hide();
		}

		private void gridSavedCase_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			CurrencyManager cm = (CurrencyManager)gridSavedCase.BindingContext[this.gridSavedCase.DataSource];
			this.SelectedCase = cm.Current as LRRDynamicSavedCase;
		}

		private void TableDescriptor_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			CurrencyManager cm = (CurrencyManager)gridSavedCase.BindingContext[this.gridSavedCase.DataSource];
			LRRDynamicSavedCase lrrSavedCase = cm.Current as LRRDynamicSavedCase;

			if(lrrSavedCase != null)
			{
				if(lrrSavedCase.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					//Check if the Saved Case to be deleted is opened by any user
					//If case is opened,prompt the user
					if(_lrrApp.DynamicCaseID == lrrSavedCase.ID)
					{
						MessageBox.Show(this,"Case has been opened. Cannot Delete the case.","",MessageBoxButtons.OK,MessageBoxIcon.Information);
						e.Cancel = true;
					}
					else
					{
						DialogResult dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
						if(dlgResult == DialogResult.Yes)
						{
							lrrSavedCase.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lrrSavedCase);
							LRRModel.ChildModel.SavedCases.Remove(lrrSavedCase);
							this.SelectedCase = null;
						}
						else
						{
							e.Cancel = true;
							return;
						}
					}
				}
				else
				{
					MessageBox.Show(this,"Case cannot be deleted by the user.Permission Denied.","",MessageBoxButtons.OK,MessageBoxIcon.Information);
					e.Cancel = true;
				}
			}
		}
		#endregion
	}
}
