using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.PEAdvisor;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.HeaderDispatcher;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor.SavedViews
{
	/// <summary>
	/// Summary description for OpenCaseForm.
	/// </summary>
	public class OpenCaseForm : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSavedCase;
		private System.Windows.Forms.Panel pnlGrid;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Splitter splitter1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OpenCaseForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			BindGrid();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(OpenCaseForm));
			this.gridSavedCase = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlGrid = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOk = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridSavedCase)).BeginInit();
			this.pnlGrid.SuspendLayout();
			this.pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// gridSavedCase
			// 
			this.gridSavedCase.BackColor = System.Drawing.SystemColors.Window;
			this.gridSavedCase.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.gridSavedCase.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSavedCase.Location = new System.Drawing.Point(0, 0);
			this.gridSavedCase.Name = "gridSavedCase";
			this.gridSavedCase.Size = new System.Drawing.Size(468, 114);
			this.gridSavedCase.TabIndex = 0;
			this.gridSavedCase.TableDescriptor.AllowEdit = false;
			this.gridSavedCase.TableDescriptor.AllowNew = false;
			this.gridSavedCase.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridSavedCase.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridSavedCase.Text = "gridGroupingControl1";
			this.gridSavedCase.VersionInfo = "3.301.0.0";
			this.gridSavedCase.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridSavedCase_TableControlCellClick);
			// 
			// pnlGrid
			// 
			this.pnlGrid.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlGrid.Controls.Add(this.splitter1);
			this.pnlGrid.Controls.Add(this.gridSavedCase);
			this.pnlGrid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlGrid.Location = new System.Drawing.Point(0, 0);
			this.pnlGrid.Name = "pnlGrid";
			this.pnlGrid.Size = new System.Drawing.Size(470, 116);
			this.pnlGrid.TabIndex = 1;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 111);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(468, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.btnCancel);
			this.pnlBottom.Controls.Add(this.btnOk);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 116);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(470, 48);
			this.pnlBottom.TabIndex = 2;
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(390, 16);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// btnOk
			// 
			this.btnOk.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.Location = new System.Drawing.Point(302, 16);
			this.btnOk.Name = "btnOk";
			this.btnOk.TabIndex = 0;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// OpenCaseForm
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(470, 164);
			this.Controls.Add(this.pnlGrid);
			this.Controls.Add(this.pnlBottom);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "OpenCaseForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_OPEN_CASE";
			((System.ComponentModel.ISupportInitialize)(this.gridSavedCase)).EndInit();
			this.pnlGrid.ResumeLayout(false);
			this.pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		private void InitDataSource()
		{
			_lrrSavedCases = new LRRSavedCases();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSavedCases);

			_savedCaseUserMaps = new LRRSavedCaseUserMaps();
			_lrrApp.DBManagerObj.PopulateCollection(_savedCaseUserMaps);
			
			_savedCases = new LRRSavedCases();
			IEnumerator iEnum = _lrrSavedCases.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRSavedCase savedCase = iEnum.Current as LRRSavedCase;
				if(savedCase.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID || savedCase.IsPublished)
				{
					_savedCases.Add(savedCase);
				}
			}
		}

		private void BindGrid()
		{
			//Suspend the Layout of the Grid...
			gridSavedCase.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridSavedCase);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridSavedCase,_savedCases.ItemType,null,true,null);
			
			this.gridSavedCase.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridSavedCase.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridSavedCase.BackColor = System.Drawing.SystemColors.Window;
			this.gridSavedCase.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridSavedCase.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridSavedCase.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridSavedCase.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridSavedCase.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_SAVED_CASES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridSavedCase.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridSavedCase.TableDescriptor.AllowNew = false;
			this.gridSavedCase.TableDescriptor.AllowEdit = false;
			this.gridSavedCase.TableDescriptor.AllowRemove = true;

			this.gridSavedCase.SourceListSet.Add("Parent",_savedCases);

			this.gridSavedCase.TableDescriptor.Relations.Clear();
			this.gridSavedCase.DataSource = null;
			this.gridSavedCase.DataSource = _savedCases;

			this.gridSavedCase.ResumeLayout(true);
			this.gridSavedCase.TableDescriptor.RecordDeleting+=new Syncfusion.Grouping.RecordEventHandler(TableDescriptor_RecordDeleting);
		}
		#endregion

		#region Fields
		private LRRApp	_lrrApp;
		private LRRSavedCases _lrrSavedCases;
		private LRRSavedCases _savedCases;
		private LRRSavedCase  _selectedCase;

		private LRRSavedCaseUserMaps _savedCaseUserMaps;
		#endregion

		#region Properties
		private LRRSavedCase SelectedCase
		{
			get{return _selectedCase;}
			set
			{
				_selectedCase = value;
			}
		}
		#endregion
		
		#region EventHandlers
		private void btnOk_Click(object sender, System.EventArgs e)
		{
			if(this.SelectedCase == null)
				return;

            //Commit Overrides
            LRROverrides objOverridesInfoToSave = LRRModel.ChildModel.Overrides.GetChanges();
            LRRGroupOverrides objGrpOverridesInfoToSave = LRRModel.ChildModel.GroupOverrides.GetChanges();
            if (objOverridesInfoToSave.Count > 0 || objGrpOverridesInfoToSave.Count > 0)
            {
                DialogResult dlgResult = MessageBox.Show("Do you want to save overrides ?", "Save Overrides", MessageBoxButtons.YesNo);
                if (dlgResult == DialogResult.Yes)
                {
                    if (objOverridesInfoToSave.Count > 0)
                        _lrrApp.DBManagerObj.CommitCollection(objOverridesInfoToSave);

                    //Commit Group Overrides
                    if (objGrpOverridesInfoToSave.Count > 0)
                        _lrrApp.DBManagerObj.CommitCollection(objGrpOverridesInfoToSave);
                }
            }

			LRRSavedCase savedCase = this.SelectedCase;
			string savedCaseID = savedCase.ID;

			Cursor.Current = Cursors.WaitCursor;
			Cursor.Show();

			//Check if the Saved Case is already opened by the user
			IEnumerator iEnum = _savedCaseUserMaps.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRSavedCaseUserMap savedCaseUserMap = iEnum.Current as LRRSavedCaseUserMap;
				if(savedCaseUserMap.SavedCaseID == savedCaseID && savedCaseUserMap.CaseOpenedByUserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					return;
				}
			}

			Symcon.Utils.TimerUtils.HiPerfTimer hTimer = new Symcon.Utils.TimerUtils.HiPerfTimer();
			hTimer.Start();
			Logger.LogMessage("Open Case Start Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);

			//Update Time Window
			if(this.SelectedCase.Compare1)
			{
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.CaseID = this.SelectedCase.ID;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.CaseName = this.SelectedCase.Name;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.StartTime = this.SelectedCase.StartTime;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.EndTime = this.SelectedCase.EndTime;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.Source = SourceEnum.REMOTE;
			}
			else
			{
				if(_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.Source != SourceEnum.REMOTE
					&& _lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.Source != SourceEnum.LIVE)
				{
					_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.StartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
					_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.EndTime = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
					_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.Source = SourceEnum.LOCAL;
				}
			}

			if(this.SelectedCase.Reference)
			{
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.CaseID = this.SelectedCase.ID;
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.CaseName = this.SelectedCase.Name;
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.StartTime = this.SelectedCase.StartTime;
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.EndTime = this.SelectedCase.EndTime;
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.Source = SourceEnum.REMOTE;
			}
			else
			{
				if(_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.Source != SourceEnum.REMOTE
					&& _lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.Source != SourceEnum.LIVE)
				{
					_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.StartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
					_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.EndTime = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
					_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.Source = SourceEnum.LOCAL;
				}
			}

			if(this.SelectedCase.Compare2)
			{
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.CaseID = this.SelectedCase.ID;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.CaseName = this.SelectedCase.Name;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.StartTime = this.SelectedCase.StartTime;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.EndTime = this.SelectedCase.EndTime;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.Source = SourceEnum.REMOTE;
			}
			else
			{
				if(_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.Source != SourceEnum.REMOTE
					&& _lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.Source != SourceEnum.LIVE)
				{
					_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.StartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
					_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.EndTime = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
					_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.Source = SourceEnum.LOCAL;
				}
			}


			//Populate Aggregate Property Values Saved Case,SiteComponentProperty values Saved Case,Qualifier Values Saved Case
			LRRAggregatePropertyValueSavedCases aggrPropValuesSavedCases = new LRRAggregatePropertyValueSavedCases();
			_lrrApp.DBManagerObj.PopulateCollection(aggrPropValuesSavedCases," where SavedCaseID = '" + savedCaseID + "'");

			LRRSiteComponentPropertyValueSavedCases siteCompPropValuesSavedCases = new LRRSiteComponentPropertyValueSavedCases();
			_lrrApp.DBManagerObj.PopulateCollection(siteCompPropValuesSavedCases," where SavedCaseID = '" + savedCaseID + "'");

			LRRSiteGroupPropertyQualifierValueSavedCases qualValSavedCases = new LRRSiteGroupPropertyQualifierValueSavedCases();
			_lrrApp.DBManagerObj.PopulateCollection(qualValSavedCases," where SavedCaseID = '" + savedCaseID + "'");
			

			//Update Aggregate Property Value Model
			IEnumerator iAggrPropValueSavedCaseEnum = aggrPropValuesSavedCases.GetEnumerator();
			while(iAggrPropValueSavedCaseEnum.MoveNext())
			{
				LRRAggregatePropertyValueSavedCase aggrPropValueSavedCase = iAggrPropValueSavedCaseEnum.Current as LRRAggregatePropertyValueSavedCase;
				string aggrPropID = aggrPropValueSavedCase.AggregateID;
				
				string modeID = null;
				if(!savedCase.IsDynamic)
				{
					string modeTypeID = aggrPropValueSavedCase.ModeTypeID;
					modeID = LRRModel.ProjectModes.GetModeByType(modeTypeID).ModeId;
				}
				else
				{
					modeID = aggrPropValueSavedCase.ModeID;
				}

				LRRAggregateProperty aggrProperty = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(aggrPropID);
				LRRAggregatePropertyValue aggrPropValue = aggrProperty.GetValueObjectForPropertyMode(modeID);
				if(aggrPropValue != null)
					aggrPropValue.PropertyValue = aggrPropValueSavedCase.PropertyValue;
			}
			
			//Update Site Component Property Value Model
			IEnumerator iSiteCompPropValueSavedCaseEnum = siteCompPropValuesSavedCases.GetEnumerator();
			while(iSiteCompPropValueSavedCaseEnum.MoveNext())
			{
				LRRSiteComponentPropertyValueSavedCase siteCompPropValueSavedCase = iSiteCompPropValueSavedCaseEnum.Current as LRRSiteComponentPropertyValueSavedCase;
				string siteCompPropID = siteCompPropValueSavedCase.SiteComponentPropertyID;

				string modeID = null;
				if(!savedCase.IsDynamic)
				{
					string modeTypeID = siteCompPropValueSavedCase.ModeTypeID;
					modeID = LRRModel.ProjectModes.GetModeByType(modeTypeID).ModeId;
				}
				else
				{
					modeID = siteCompPropValueSavedCase.ModeID;
				}

                List<IPropertyValue> arrSiteCompPropertyValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(siteCompPropID);
				if(arrSiteCompPropertyValues != null)
				{
					for(int i=0;i < arrSiteCompPropertyValues.Count;i++)
					{
						LRRSiteComponentPropertyValue siteCompPropValue = arrSiteCompPropertyValues[i] as LRRSiteComponentPropertyValue;
						if(siteCompPropValue.ModeID == modeID)
						{
							if(!savedCase.IsDynamic)
							{
								siteCompPropValue.ReadOnlyAccess = true;
								siteCompPropValue.IsEditable = false;
							}
							siteCompPropValue.PropertyValue = siteCompPropValueSavedCase.PropertyValue;
							if(modeID == "1")
								_lrrApp.RemoveBinding(siteCompPropValue);
							_lrrApp.RemoveCascadedBindings(siteCompPropValue,siteCompPropValue.IsOverrided);
						}
					}
				}
			}

			//Update Qualifier Value Model
			IEnumerator iQualValueSavedCaseEnum = qualValSavedCases.GetEnumerator();
			while(iQualValueSavedCaseEnum.MoveNext())
			{
				LRRSiteGroupPropertyQualifierValueSavedCase siteGrpPropQualValueSavedCase = iQualValueSavedCaseEnum.Current as LRRSiteGroupPropertyQualifierValueSavedCase;

				string lookUpPropID = siteGrpPropQualValueSavedCase.LookUpPropertiesID;
				string grpPropID = siteGrpPropQualValueSavedCase.GroupPropertyID;
				string lkupQualID = siteGrpPropQualValueSavedCase.LookUpQualifierID;
				string qualID = siteGrpPropQualValueSavedCase.QualifierID;
				
				string modeID = null;
				if(!savedCase.IsDynamic)
				{
					string modeTypeID = siteGrpPropQualValueSavedCase.ModeTypeID;
					modeID = LRRModel.ProjectModes.GetModeByType(modeTypeID).ModeId;
				}
				else
				{
					modeID = siteGrpPropQualValueSavedCase.ModeID;
				}

				LRRSiteGroupPropertyQualifierValue qualValueObj = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(grpPropID,lookUpPropID,qualID,modeID);
				if(qualValueObj != null)
				{
					if(!savedCase.IsDynamic)
					{
						qualValueObj.ReadOnlyAccess = true;
						qualValueObj.IsEditable = false;
					}
					qualValueObj.PropertyValue = siteGrpPropQualValueSavedCase.PropertyValue;
					if(modeID == "1")
						_lrrApp.RemoveGroupPropBinding(qualValueObj);
					_lrrApp.RemoveCascadedBindings(qualValueObj,qualValueObj.GroupPropertyID,qualValueObj.LookUpPropertiesID,qualValueObj.QualifierID,qualValueObj.IsOverrided);
				}
			}
			
			//Save in SavedCaseMap table
			if(this.SelectedCase.Compare1 && this.SelectedCase.Reference &&
				this.SelectedCase.Compare2)
			{
				_lrrApp.DBManagerObj.ExecuteBatchDelete(_savedCaseUserMaps);	
			}

			LRRSavedCaseUserMap savedCaseUserMapped = new LRRSavedCaseUserMap();
			savedCaseUserMapped.SavedCaseID = savedCaseID;
			savedCaseUserMapped.CaseOpenedByUserID = _lrrApp.DBManagerObj.AccessControlModel.UserID;
			savedCaseUserMapped.ObjectState = DBOperation.INSERT;
			_lrrApp.DBManagerObj.CommitObject(savedCaseUserMapped);

			//End time
			Logger.LogMessage("Open Case End Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//Difference
			hTimer.Stop();
			Logger.LogMessage("Open Case Difference:" + hTimer.Duration.ToString(Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			Cursor.Hide();
		}

		private void gridSavedCase_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			CurrencyManager cm = (CurrencyManager)gridSavedCase.BindingContext[this.gridSavedCase.DataSource];
			this.SelectedCase = cm.Current as LRRSavedCase;
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true; 
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void TableDescriptor_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			CurrencyManager cm = (CurrencyManager)gridSavedCase.BindingContext[this.gridSavedCase.DataSource];
			LRRSavedCase lrrSavedCase = cm.Current as LRRSavedCase;
			if(lrrSavedCase != null)
			{
				bool isOpened = false;
				if(lrrSavedCase.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					//Check if the Saved Case to be deleted is opened by any user
					IEnumerator iEnum = _savedCaseUserMaps.GetEnumerator();
					while(iEnum.MoveNext())
					{
						LRRSavedCaseUserMap savedCaseUserMap = iEnum.Current as LRRSavedCaseUserMap;
						if(savedCaseUserMap.SavedCaseID == lrrSavedCase.ID)
						{
							isOpened = true;
							break;
						}
					}

					//If case is opened,prompt the user
					if(isOpened)
					{
						MessageBox.Show(this,"Case has been opened. Cannot Delete the case.","",MessageBoxButtons.OK,MessageBoxIcon.Information);
						e.Cancel = true;
					}
					else
					{
						if(_isDeletePress)
						{
							DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
							if(_dlgResult == DialogResult.Yes)
							{
								_isRecordeDel = true; 
							}
							else
							{
								_isRecordeDel = false; 
							}
							_isDeletePress = false; 
						}
						if(_isRecordeDel)
						{
							lrrSavedCase.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lrrSavedCase);
							LRRModel.ChildModel.SavedCases.Remove(lrrSavedCase);
							this.SelectedCase = null;
						}
						else
						{
							e.Cancel = true;
							return;
						}
					}
				}
				else
				{
					MessageBox.Show(this,"Case cannot be deleted by the user.Permission Denied.","",MessageBoxButtons.OK,MessageBoxIcon.Information);
					e.Cancel = true;
				}
			}
		}
		#endregion
	}
}
