using System;
using System.Collections.Generic;
using System.Text;
using Symcon.LightRidge.BusinessObjects;
using System.Windows.Forms;
using System.IO;
using System.Xml.Serialization;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.CommonViews;
using Symcon.LightRidge.PEAdvisor.UserControls;
using Symcon.LightRidge.PEAdvisor.IOScreen;
using Symcon.LightRidge.PEAdvisor.GroupProperties;

namespace Symcon.LightRidge.PEAdvisor.ScreenManagement
{
    public static class LRRViewManager
    {
        public static void OpenCompositeView(LRRCompositeView lrrCompView)
        {
            try
            {
                LRRApp _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
                object[] obj = new object[1];
                LRRCompositeView compViewUpdated = new LRRCompositeView();
                _lrrApp.DBManagerObj.PopulateObject(compViewUpdated, typeof(LRRCompositeView), " where ID='" + lrrCompView.ID + "'");
                obj[0] = compViewUpdated;
                _lrrApp.LRRUIManagerObj.ShowWindow(lrrCompView.ID, typeof(CompositeView), obj);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        
        public static void OpenUnifiedView(LRRUnifiedViewSearchCrtiteria lrrUnifiedView)
        {
            LRRApp _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            object[] obj = new object[1];
            obj[0] = lrrUnifiedView.ID;
            _lrrApp.LRRUIManagerObj.ShowWindow(lrrUnifiedView.ID, typeof(UnifiedViewResultForm), obj);
        }

        public static void OpenExcelView(LRRExcelView lrrExcelView)
        {
            if (lrrExcelView != null)
            {
                LRRApp _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
                object[] obj = new object[1];
                obj[0] = lrrExcelView.ID;
                _lrrApp.LRRUIManagerObj.ShowWindow(lrrExcelView.ID, typeof(ExcelView), obj);
            }
        }

        public static void OpenMultiTrend(LRRMultiAttributeTrendInfo multiTrend)
        {
            LRRApp _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            MemoryStream memoryStream = new MemoryStream(multiTrend.TrendInfo);
            XmlSerializer xs = new XmlSerializer(typeof(TemplateRows));
            TemplateRows templateRows = xs.Deserialize(memoryStream) as TemplateRows;
            memoryStream.Close();

            string key = "MultiTrend:" + multiTrend.Name;
            if (_lrrApp.LRRUIManagerObj._windowStore.ContainsKey(key))
            {
                ILRRUIContainer cont = _lrrApp.LRRUIManagerObj._windowStore[key] as ILRRUIContainer;
                cont.Refresh();
                Form frm = cont as Form;
                frm.Activate();
            }
            else
            {
                object[] obj = new object[2];
                obj[0] = templateRows;
                obj[1] = multiTrend;
                _lrrApp.LRRUIManagerObj.ShowWindow(key, typeof(MultiTrend), obj);
            }
        }

        public static void OpenGraphics(LRRSavedView lrrSavedView)
        {
            try
            {
                LRRApp _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
                object[] args = new object[1];
                args[0] = 270;
                LRRWaitWindowUtility.ExecuteMethodWithWait(_lrrApp.LRRUIManagerObj, "ShowWindow", args, MethodExecutionMode.UI);
                Form frm = _lrrApp.LRRUIManagerObj._windowStore[270] as Form;
                OperatorsScreen screen = frm as OperatorsScreen;
                if (screen != null)
                {
                    screen.OpenFiles(lrrSavedView.ID);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public static void OpenQuery(LRRSearchCriteria lrrSrchCriteria)
        {
            LRRApp _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            string sSource = lrrSrchCriteria.Source == null ? "" : lrrSrchCriteria.Source.ToString(Symcon.BusinessObjects.SymConverter.Culture);
            if (sSource == "I/O")
            {
                object[] obj = new object[1];
                obj[0] = lrrSrchCriteria.ID;
                _lrrApp.LRRUIManagerObj.ShowWindow(lrrSrchCriteria.ID, typeof(ResultForm), obj);
            }
            else
            {
                object[] obj = new object[1];
                obj[0] = lrrSrchCriteria.ID;
                _lrrApp.LRRUIManagerObj.ShowWindow(lrrSrchCriteria.ID, typeof(GroupedPlantPropertiesResultForm), obj);
            }
        }
    }
}
