using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms;

using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.PEAdvisor.UserControls;
using Symcon.Utils.MessageDispatcher;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.IOScreen;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.Utils.HeaderDispatcher;  
using Symcon.LightRidge.PEAdvisor.SharingPermissions;
using Symcon.LightRidge.PEAdvisor.CommonViews;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.Text;
using System.Runtime.InteropServices;
using Symcon.LightRidge.PEAdvisor.GroupProperties;

namespace Symcon.LightRidge.PEAdvisor.ScreenManagement
{
	/// <summary>
	/// Summary description for ScreenListView.
	/// </summary>
	public class ScreenListView : System.Windows.Forms.Form
	{
        [DllImport("user32.dll")]

        private static extern int SendMessage (IntPtr hWnd, int wMsg, int wParam, int lParam);

		private System.Windows.Forms.Button btnAddQuery;
		private System.Windows.Forms.Panel pnlTop;
        private System.Windows.Forms.Panel pnlBottom;
        public TreeView trvSearchLevels;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem mnuRemove;
		private System.Windows.Forms.MenuItem mnuAdd;
		private System.Windows.Forms.MenuItem mnuInsert;
		private System.Windows.Forms.MenuItem mnuRename;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.MenuItem mnuPublishToOtherUsers;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        public ScreenListView()
        {
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
        }

		public ScreenListView(int calledFrom)
		{
			InitializeComponent();
			
			this.components = new System.ComponentModel.Container();
			this.imageListDrag = new System.Windows.Forms.ImageList(this.components);
			this.imageListDrag.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageListDrag.ImageSize = new System.Drawing.Size(16, 16);
			this.imageListDrag.TransparentColor = System.Drawing.Color.Transparent;

			SetMenuItemsText();
			InternationalizationUtils.GetControlText(this,null); 
			_calledFrom = calledFrom;
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			trvSearchLevels.CheckBoxes = false;
			trvSearchLevels.AllowDrop = false;
			trvSearchLevels.ContextMenu = null;
			this.Text = "Composite Views";
			PopulateTreeView(trvSearchLevels,_lrrSearchGroupLevels,_lrrSearchGroupLevelLinks);
            trvSearchLevels.TreeViewNodeSorter = new OrgenizeViewScreenTreeSorter();
            trvSearchLevels.Sort();
		}

		public ScreenListView(Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem barQuery,Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager)
		{
			InitializeComponent();
			
			this.components = new System.ComponentModel.Container();
			this.imageListDrag = new System.Windows.Forms.ImageList(this.components);
			this.imageListDrag.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.imageListDrag.ImageSize = new System.Drawing.Size(16, 16);
			this.imageListDrag.TransparentColor = System.Drawing.Color.Transparent;

			SetMenuItemsText();
			InternationalizationUtils.GetControlText(this,null); 
			_barQuery = barQuery;
			_mainFrameBarManager = mainFrameBarManager;
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			trvSearchLevels.ImageList = _lrrApp.MainFrame.ImageList3;
			trvSearchLevels.ImageIndex = 24;
			trvSearchLevels.SelectedImageIndex = 24;
			PopulateTreeView(trvSearchLevels,_lrrSearchGroupLevels,_lrrSearchGroupLevelLinks);
            trvSearchLevels.TreeViewNodeSorter = new OrgenizeViewScreenTreeSorter();
            trvSearchLevels.Sort();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ScreenListView));
            this.btnAddQuery = new System.Windows.Forms.Button();
            this.pnlTop = new System.Windows.Forms.Panel();
            this.trvSearchLevels = new System.Windows.Forms.TreeView();
            this.contextMenu1 = new System.Windows.Forms.ContextMenu();
            this.mnuAdd = new System.Windows.Forms.MenuItem();
            this.mnuInsert = new System.Windows.Forms.MenuItem();
            this.mnuRename = new System.Windows.Forms.MenuItem();
            this.mnuRemove = new System.Windows.Forms.MenuItem();
            this.mnuPublishToOtherUsers = new System.Windows.Forms.MenuItem();
            this.pnlBottom = new System.Windows.Forms.Panel();
            this.btnCancel = new System.Windows.Forms.Button();
            this.pnlTop.SuspendLayout();
            this.pnlBottom.SuspendLayout();
            this.SuspendLayout();
            // 
            // btnAddQuery
            // 
            this.btnAddQuery.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnAddQuery.Location = new System.Drawing.Point(296, 8);
            this.btnAddQuery.Name = "btnAddQuery";
            this.btnAddQuery.Size = new System.Drawing.Size(80, 24);
            this.btnAddQuery.TabIndex = 1;
            this.btnAddQuery.Tag = "SID_OK";
            this.btnAddQuery.Click += new System.EventHandler(this.btnAddQuery_Click);
            // 
            // pnlTop
            // 
            this.pnlTop.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pnlTop.Controls.Add(this.trvSearchLevels);
            this.pnlTop.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlTop.Location = new System.Drawing.Point(0, 0);
            this.pnlTop.Name = "pnlTop";
            this.pnlTop.Size = new System.Drawing.Size(474, 408);
            this.pnlTop.TabIndex = 2;
            // 
            // trvSearchLevels
            // 
            this.trvSearchLevels.AllowDrop = true;
            this.trvSearchLevels.CheckBoxes = true;
            this.trvSearchLevels.ContextMenu = this.contextMenu1;
            this.trvSearchLevels.Dock = System.Windows.Forms.DockStyle.Fill;
            this.trvSearchLevels.LabelEdit = true;
            this.trvSearchLevels.Location = new System.Drawing.Point(0, 0);
            this.trvSearchLevels.Name = "trvSearchLevels";
            this.trvSearchLevels.ShowNodeToolTips = true;
            this.trvSearchLevels.Size = new System.Drawing.Size(472, 406);
            this.trvSearchLevels.TabIndex = 0;
            this.trvSearchLevels.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.trvSearchLevels_AfterCheck);
            this.trvSearchLevels.DragDrop += new System.Windows.Forms.DragEventHandler(this.trvSearchLevels_DragDrop);
            this.trvSearchLevels.DragOver += new System.Windows.Forms.DragEventHandler(this.trvSearchLevels_DragOver);
            this.trvSearchLevels.NodeMouseHover += new System.Windows.Forms.TreeNodeMouseHoverEventHandler(this.trvSearchLevels_NodeMouseHover);
            this.trvSearchLevels.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.trvSearchLevels_AfterLabelEdit);
            this.trvSearchLevels.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.trvSearchLevels_AfterSelect);
            this.trvSearchLevels.MouseMove += new System.Windows.Forms.MouseEventHandler(this.trvSearchLevels_MouseMove);
            this.trvSearchLevels.GiveFeedback += new System.Windows.Forms.GiveFeedbackEventHandler(this.trvSearchLevels_GiveFeedback);
            this.trvSearchLevels.DragEnter += new System.Windows.Forms.DragEventHandler(this.trvSearchLevels_DragEnter);
            this.trvSearchLevels.BeforeLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.trvSearchLevels_BeforeLabelEdit);
            this.trvSearchLevels.MouseHover += new System.EventHandler(this.trvSearchLevels_MouseHover);
            this.trvSearchLevels.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.trvSearchLevels_ItemDrag);
            this.trvSearchLevels.MouseDown += new System.Windows.Forms.MouseEventHandler(this.trvSearchLevels_MouseDown);
            // 
            // contextMenu1
            // 
            this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuAdd,
            this.mnuInsert,
            this.mnuRename,
            this.mnuRemove,
            this.mnuPublishToOtherUsers});
            this.contextMenu1.Popup += new System.EventHandler(this.contextMenu1_Popup);
            // 
            // mnuAdd
            // 
            this.mnuAdd.Index = 0;
            this.mnuAdd.Text = "";
            this.mnuAdd.Click += new System.EventHandler(this.mnuAdd_Click);
            // 
            // mnuInsert
            // 
            this.mnuInsert.Index = 1;
            this.mnuInsert.Text = "";
            this.mnuInsert.Click += new System.EventHandler(this.mnuInsert_Click);
            // 
            // mnuRename
            // 
            this.mnuRename.Index = 2;
            this.mnuRename.Text = "";
            this.mnuRename.Click += new System.EventHandler(this.mnuRename_Click);
            // 
            // mnuRemove
            // 
            this.mnuRemove.Index = 3;
            this.mnuRemove.Text = "";
            this.mnuRemove.Click += new System.EventHandler(this.mnuRemove_Click);
            // 
            // mnuPublishToOtherUsers
            // 
            this.mnuPublishToOtherUsers.Index = 4;
            this.mnuPublishToOtherUsers.Text = "";
            this.mnuPublishToOtherUsers.Click += new System.EventHandler(this.mnuPublishToOtherUsers_Click);
            // 
            // pnlBottom
            // 
            this.pnlBottom.Controls.Add(this.btnCancel);
            this.pnlBottom.Controls.Add(this.btnAddQuery);
            this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.pnlBottom.Location = new System.Drawing.Point(0, 408);
            this.pnlBottom.Name = "pnlBottom";
            this.pnlBottom.Size = new System.Drawing.Size(474, 40);
            this.pnlBottom.TabIndex = 3;
            // 
            // btnCancel
            // 
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.Location = new System.Drawing.Point(384, 8);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(80, 24);
            this.btnCancel.TabIndex = 2;
            this.btnCancel.Tag = "SID_CANCEL";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // ScreenListView
            // 
            this.AcceptButton = this.btnAddQuery;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.btnCancel;
            this.ClientSize = new System.Drawing.Size(474, 448);
            this.Controls.Add(this.pnlBottom);
            this.Controls.Add(this.pnlTop);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "ScreenListView";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Tag = "SID_5002";
            this.pnlTop.ResumeLayout(false);
            this.pnlBottom.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		#region Fields
		private LRRApp _lrrApp = null;
		private LRRSearchCriterias _lrrSearchCriterias = null;
		private LRRSearchCriteriaQualifiers _LRRSearchCriteriaQualifiers = null;
		private LRRSearchCriteriaPropertyTypes _lrrSearchCriteriaPropertyTypes = null;
		private LRRPropertyTypes	_objPropertyTypes = null;
		private LRRSiteComponents _lrrSiteComponents = null;

		private LRRSearchGroupLevels	_lrrSearchGroupLevels=null; //Levels Object
		private LRRSearchGroupLevelLinks	_lrrSearchGroupLevelLinks = null; //Level Links object

		//Property Window
		private ResultPropertiesWindow _rsProperties;

		//Property Window
		private ResultPropertiesWindow _rsComponents;

		private GridPersistanceUtil		_gutil = new GridPersistanceUtil();
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem _barQuery = null;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager _mainFrameBarManager = null;
		
		//Composite Views
		private LRRCompositeViews _lrrCompositeViews = null;

		//Excel Views
		private LRRExcelViews	_lrrExcelViews = null;

		private ListItem _selectedItem = null;

		private int _calledFrom = 0;
		private bool _checkAllChilds = true;

		//Image List for Dragging
		private System.Windows.Forms.ImageList imageListDrag;

		//View Sharing
		private LRRViewSharings _lrrViewSharings;

		//Restore Previous State Array List
		private ArrayList		_arrRestorePrevStateList = new ArrayList();

		//Unified Views
		private LRRUnifiedViewSearchCrtiterias _lrrUnifiedSrchCriterias = null;
		
		//Multi Trend
		private LRRMultiAttributeTrendInfos	_multiTrendInfos = new LRRMultiAttributeTrendInfos();
		#endregion

		#region Public Properties
        public LRRSearchCriteriaPropertyTypes LRRSrchCriteriaPropertyTypes
        {
            get { return _lrrSearchCriteriaPropertyTypes; }
            set { _lrrSearchCriteriaPropertyTypes = value; }
        }

        public ResultPropertiesWindow RsComponents
        {
            get { return _rsComponents; }
            set { _rsComponents = value; }
        }

        public ResultPropertiesWindow RsProperties
        {
            get { return _rsProperties; }
            set { _rsProperties = value; }
        }

		public LRRSearchCriterias LRRSearchCriteriasObj
		{
			get { return _lrrSearchCriterias; }
		}

		public LRRSavedViews LRRSavedViewsObj
		{
			get { return LRRModel.SavedViews;}
		}

		public LRRExcelViews LRRExcelViewsObj
		{
			get { return _lrrExcelViews;}
		}

		public LRRCompositeViews LRRCompositeViewsObj
		{
			get { return _lrrCompositeViews;}
		}

		public LRRMultiAttributeTrendInfos MultiTrendInfosObj
		{
			get { return _multiTrendInfos;}
			set
			{
				_multiTrendInfos = value;
			}
		}

		public ListItem SelectedItemObj
		{
			get { return _selectedItem;}
			set
			{
				_selectedItem = value;
			}
		}

		#endregion

		#region Methods
		
		/// <summary>
		/// Initialize the dataSource from db
		/// </summary>
		private void InitDataSource()
		{
//			if(_lrrSearchCriterias != null)
//				_lrrSearchCriterias.Clear();
			if(_lrrSearchCriteriaPropertyTypes != null)
				_lrrSearchCriteriaPropertyTypes.Clear();
			if(_LRRSearchCriteriaQualifiers != null)
				_LRRSearchCriteriaQualifiers.Clear();

			if(_lrrSiteComponents != null)
				_lrrSiteComponents.Clear();
			if(_objPropertyTypes != null)
				_objPropertyTypes.Clear();

			if(_lrrViewSharings != null)
				_lrrViewSharings.Clear();

			if(_multiTrendInfos != null)
				_multiTrendInfos.Clear();

			_lrrSearchCriterias = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriasWithoutNewQuery();
			_lrrSearchCriteriaPropertyTypes = new LRRSearchCriteriaPropertyTypes();
			_LRRSearchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();

			_objPropertyTypes = new LRRPropertyTypes();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchCriteriaPropertyTypes,"",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_LRRSearchCriteriaQualifiers,"",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_objPropertyTypes,false);

			_lrrSiteComponents = new LRRSiteComponents();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSiteComponents,false);

			//Initialize and populate the levels
			_lrrSearchGroupLevels = new LRRSearchGroupLevels();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchGroupLevels,"",false,true);
			//Initialize and populate the level links
			_lrrSearchGroupLevelLinks = new LRRSearchGroupLevelLinks();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchGroupLevelLinks);
			
			//Get Composite Views
			//_lrrApp.DBManagerObj.PopulateCollection(_lrrCompositeViews);
			_lrrCompositeViews = LRRModel.ChildModel.CompositeViews;

			//Get Charts
			//_lrrApp.DBManagerObj.PopulateCollection(_lrrCharts);
			_lrrExcelViews = LRRModel.ChildModel.ExcelViews;

			//Get View Sharings
			_multiTrendInfos = new LRRMultiAttributeTrendInfos();
			_lrrApp.DBManagerObj.PopulateCollection(_multiTrendInfos,"",false,true);

			//Get View Sharings
			_lrrViewSharings = new LRRViewSharings();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrViewSharings,"",false,true);

			//Get Unified Views
			_lrrUnifiedSrchCriterias = LRRModel.ChildModel.UnifiedViewSearchCrtiterias;
		}
		
		/// <summary>
		/// Method sets the Menu Item Text
		/// </summary>
		public void SetMenuItemsText()
		{
			mnuAdd.Text = LRRHeaderText.GetHeaderString("SID_ADD");;
			mnuRemove.Text = LRRHeaderText.GetHeaderString("SID_DEL");;
			mnuInsert.Text = LRRHeaderText.GetHeaderString("SID_INSERT");;
			mnuRename.Text = LRRHeaderText.GetHeaderString("SID_RENAME");;
			mnuPublishToOtherUsers.Text = LRRHeaderText.GetHeaderString("SID_SHARING");

		}
		
		/// <summary>
		/// Populate Groups and queries
		/// </summary>
		/// <returns></returns>
		public bool PopulateBarItems()
		{
			try
			{
				Hashtable				_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRSearchGroupLevel l in _lrrSearchGroupLevels)
				{
					_levelHash.Add(l.LevelID,l);
				}
				foreach(LRRSearchGroupLevelLink ll in _lrrSearchGroupLevelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						ParentBarItem foundItem = _nodesHash[ll.ParentID] as ParentBarItem;
						LRRSearchGroupLevel foundLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel;
 
						AddBarItem(foundLevel,foundItem);
					}
					else
					{
						LRRSearchGroupLevel parentLevel = _levelHash[ll.ParentID] as LRRSearchGroupLevel;
						LRRSearchGroupLevel childLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel;

						ParentBarItem parentItem = new ParentBarItem(parentLevel.Name);

						//Create List Item Object
						ListItem levllistItem = new ListItem();
						levllistItem.ListItemType = "Level";
						levllistItem.ListItemObject = parentLevel;

						parentItem.Tag = levllistItem;
						_mainFrameBarManager.Items.Add(parentItem);

						//Add the Bar items
						AddBarItem(childLevel,parentItem);
						
						_nodesHash.Add(ll.ParentID,parentItem);

					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					ParentBarItem  childBarItem = null;
					ParentBarItem  parentBarItem = null;

					if(_nodesHash.ContainsKey(childID))
					{
						childBarItem = _nodesHash[childID] as ParentBarItem;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentBarItem = _nodesHash[parentID] as ParentBarItem;
					}
					if((parentBarItem != null) && (childBarItem != null))
					{
						int index = -1;
						int i = 0;
						foreach(BarItem item in parentBarItem.Items)
						{
							ListItem listItem = item.Tag as ListItem;
							ListItem childlistItem = childBarItem.Tag as ListItem;
							
							if(listItem.ListItemObject == childlistItem.ListItemObject)
							{
								index = i;
								break;
							}
							i++;
						}
						if(index != -1)
							parentBarItem.Items[index] = childBarItem;
					}
				}

				ParentBarItem rootBarItem = null;
				if(_nodesHash.Count > 0)
				{
					rootBarItem = _nodesHash["0"] as ParentBarItem;
				}
				else
				{
					LRRSearchGroupLevel srchGroupLevel = _levelHash["0"] as LRRSearchGroupLevel;

					//Create List Item Object
					ListItem listItem = new ListItem();
					listItem.ListItemType = "Level";
					listItem.ListItemObject = srchGroupLevel;
					rootBarItem = new ParentBarItem(srchGroupLevel.Name);
					rootBarItem.Tag = listItem;

				}
				
				_barQuery.Items.Add(rootBarItem);
				_mainFrameBarManager.Items.Add(rootBarItem);
				for(int i=0;i < rootBarItem.Items.Count;i++)
				{
					BarItem barItem = rootBarItem.Items[i] as BarItem;
					//_barQuery.Items.Add(barItem);
					if(i == 0)
						_barQuery.BeginGroupAt(barItem);
				}

				//Add Ungrouped views in root node
				IDictionaryEnumerator iDictEnum = _levelHash.GetEnumerator();
				while(iDictEnum.MoveNext())
				{
					DictionaryEntry dEntry = (DictionaryEntry)iDictEnum.Current;
					string levelID = (string)dEntry.Key;
					if(levelID != "0" && !_childParent.ContainsKey(levelID) && !_childParent.ContainsValue(levelID))
					{
						LRRSearchGroupLevel srchGroupLvl = (LRRSearchGroupLevel)dEntry.Value;
						if(srchGroupLvl.Type != "Level")
							AddBarItem(srchGroupLvl,rootBarItem);
					}
				}

				AddBarsFromViews(rootBarItem);

				CheckChildBarItemExists(rootBarItem);
                OrgenizeViewScreenTreeSorter sorter = new OrgenizeViewScreenTreeSorter();
                rootBarItem.Items.Sort(sorter);
				return true;

			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
				return false;
			}
		}

		private bool CheckChildBarItemExists(ParentBarItem pBarItem)
		{
			bool check = false;
			ArrayList arrToRemoveBarItems = new ArrayList();
			foreach(BarItem barItem in pBarItem.Items)
			{
				if(barItem.GetType() == typeof(ParentBarItem))
				{
					if(!CheckChildBarItemExists(barItem as ParentBarItem))
					{
						arrToRemoveBarItems.Add(barItem);
					}
					else
						check = true;
				}
				else if(barItem.GetType() == typeof(BarItem))
				{
					check = true;
				}
			}
			foreach(ParentBarItem barItem in arrToRemoveBarItems)
			{
				barItem.Visible = false;
				//pBarItem.Items.Remove(barItem);
				//_mainFrameBarManager.Items.Remove(barItem);
			}
			return check;
		}

		private void AddBarItem(LRRSearchGroupLevel level,ParentBarItem parentBarItem)
		{
			if(level == null)
				return;

			string viewID = level.LevelID;
			string uid = _lrrApp.DBManagerObj.AccessControlModel.UserID;
			LRRViewSharing viewSharing = _lrrViewSharings.GetViewSharingByUserIDAndViewID(uid,viewID);
			bool read = true;
			if(viewSharing != null && !viewSharing.ReadPermission && level.UserID != uid)
				read = false;
			if(viewSharing == null && level.UserID != uid)
				read = false;

			switch(level.Type)
			{
				case "Query" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRSearchCriteria lrrSrchCriteria = _lrrSearchCriterias.GetSearchCriteriaByID(level.LevelID);

					if(lrrSrchCriteria != null && lrrSrchCriteria.IsSelected)
					{
						//Create List Item Object
						ListItem querylistItem = new ListItem();
						querylistItem.ListItemType = "Query";
						querylistItem.ListItemObject = lrrSrchCriteria;

						BarItem barItemQuery = new BarItem();
						barItemQuery.Text = lrrSrchCriteria.Name;
						barItemQuery.ID = lrrSrchCriteria.ID;
						barItemQuery.Tag = querylistItem;
						barItemQuery.ImageList = _lrrApp.MainFrame.ImageList3;
						int imageIndex = 9;
						if(lrrSrchCriteria.Source == "I/O")
						{
							imageIndex = 44;
						}
						if(lrrSrchCriteria.Source == "GP")
						{
							imageIndex = 51;
						}
						if(lrrSrchCriteria.Source == "DA")
						{
							imageIndex = 51;
						}
						barItemQuery.ImageIndex = imageIndex;
						barItemQuery.Click+=new EventHandler(barItemQuery_Click);
						
						_mainFrameBarManager.Items.Add(barItemQuery);
						parentBarItem.Items.Add(barItemQuery);
					}
					break;
				case "Graphics" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRSavedView lrrSavedView = LRRModel.SavedViews.GetSavedViewFromID(level.LevelID);
					
					if(lrrSavedView != null && lrrSavedView.IsSelected)
					{
						//Create List Item Object
						ListItem graphicslistItem = new ListItem();
						graphicslistItem.ListItemType = "Graphics";
						graphicslistItem.ListItemObject = lrrSavedView;

						BarItem barItemGraphics = new BarItem();
						barItemGraphics.Text = lrrSavedView.SavedViewName;
						barItemGraphics.ID = lrrSavedView.ID;
						barItemGraphics.Tag = graphicslistItem;
						barItemGraphics.ImageList = _lrrApp.MainFrame.ImageList3;
						barItemGraphics.ImageIndex = 53;
						barItemGraphics.Click+=new EventHandler(barItemQuery_Click);
						
						_mainFrameBarManager.Items.Add(barItemGraphics);
						parentBarItem.Items.Add(barItemGraphics);
					}
					break;
				case "ExcelView" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRExcelView lrrExcelView = _lrrExcelViews.GetExcelViewFromID(level.LevelID);
					if(lrrExcelView != null && lrrExcelView.IsSelected)
					{
						//Create List Item Object
						ListItem chartlistItem = new ListItem();
						chartlistItem.ListItemType = "ExcelView";
						chartlistItem.ListItemObject = lrrExcelView;

						BarItem barItemChart = new BarItem();
						barItemChart.Text = level.Name;
						barItemChart.ID = lrrExcelView.ID;
						barItemChart.Tag = chartlistItem;
						barItemChart.ImageList = _lrrApp.MainFrame.ImageList3;
                        barItemChart.ImageIndex = 72;
						barItemChart.Click+=new EventHandler(barItemQuery_Click);
						
						_mainFrameBarManager.Items.Add(barItemChart);
						parentBarItem.Items.Add(barItemChart);
					}

					break;
				case "CompositeViews" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRCompositeView lrrCompositeView = _lrrCompositeViews.GetCompositeViewFromID(level.LevelID);
					if(lrrCompositeView != null && lrrCompositeView.IsSelected)
					{
						//Create List Item Object
						ListItem compositeViewlistItem = new ListItem();
						compositeViewlistItem.ListItemType = "CompositeViews";
						compositeViewlistItem.ListItemObject = lrrCompositeView;

						BarItem barItemCompositeView = new BarItem();
						barItemCompositeView.Text = lrrCompositeView.Name;
						barItemCompositeView.ID = lrrCompositeView.ID;
						barItemCompositeView.Tag = compositeViewlistItem;
						barItemCompositeView.ImageList = _lrrApp.MainFrame.ImageList3;
						barItemCompositeView.ImageIndex = 42;
						barItemCompositeView.Click+=new EventHandler(barItemQuery_Click);
						
						_mainFrameBarManager.Items.Add(barItemCompositeView);
						parentBarItem.Items.Add(barItemCompositeView);
					}

					break;
				case "UnifiedView":
					if(!read)
						break;
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = _lrrUnifiedSrchCriterias.GetUnifiedViewByID(level.LevelID);
					if(lrrUnifiedView != null && lrrUnifiedView.IsSelected)
					{
						//Create List Item Object
						ListItem unifiedViewlistItem = new ListItem();
						unifiedViewlistItem.ListItemType = "UnifiedView";
						unifiedViewlistItem.ListItemObject = lrrUnifiedView;

						BarItem barItemUnifiedView = new BarItem();
						barItemUnifiedView.Text = lrrUnifiedView.Name;
						barItemUnifiedView.ID = lrrUnifiedView.ID;
						barItemUnifiedView.Tag = unifiedViewlistItem;
						barItemUnifiedView.ImageList = _lrrApp.MainFrame.ImageList3;
                        barItemUnifiedView.ImageIndex = 47;
						barItemUnifiedView.Click+=new EventHandler(barItemQuery_Click);
						
						_mainFrameBarManager.Items.Add(barItemUnifiedView);
						parentBarItem.Items.Add(barItemUnifiedView);
					}
					break;
				case "MultiTrend" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRMultiAttributeTrendInfo lrrMultiTrendInfo = _multiTrendInfos.GetMultiTrendFromID(level.LevelID);
					if(lrrMultiTrendInfo != null && lrrMultiTrendInfo.IsSelected)
					{
						//Create List Item Object
						ListItem multiTrendItem = new ListItem();
						multiTrendItem.ListItemType = "MultiTrend";
						multiTrendItem.ListItemObject = lrrMultiTrendInfo;

						BarItem barItemMultiTrend = new BarItem();
						barItemMultiTrend.Text = level.Name;
						barItemMultiTrend.ID = lrrMultiTrendInfo.ID;
						barItemMultiTrend.Tag = multiTrendItem;
						barItemMultiTrend.ImageList = _lrrApp.MainFrame.ImageList3;
						barItemMultiTrend.ImageIndex = 67;
						barItemMultiTrend.Click+=new EventHandler(barItemQuery_Click);
						
						_mainFrameBarManager.Items.Add(barItemMultiTrend);
						parentBarItem.Items.Add(barItemMultiTrend);
					}

					break;
				default :
					ParentBarItem childBarItem = new ParentBarItem(level.Name);

					//Create List Item Object
					ListItem levllistItem = new ListItem();
					levllistItem.ListItemType = "Level";
					levllistItem.ListItemObject = level;

					childBarItem.Tag = levllistItem;

					_mainFrameBarManager.Items.Add(childBarItem);
					parentBarItem.Items.Add(childBarItem);
					break;
			}
		}
		
		private void AddBarsFromViews(ParentBarItem parentBarItem)
		{
			//Search Criterias
			IEnumerator iSrchEnum = _lrrSearchCriterias.GetEnumerator();
			while(iSrchEnum.MoveNext())
			{
				LRRSearchCriteria srchCriteria = iSrchEnum.Current as LRRSearchCriteria;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(srchCriteria.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && srchCriteria.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID
					&& srchCriteria.IsSelected)
				{
					//Create List Item Object
					ListItem querylistItem = new ListItem();
					querylistItem.ListItemType = "Query";
					querylistItem.ListItemObject = srchCriteria;

					BarItem barItemQuery = new BarItem();
					barItemQuery.Text = srchCriteria.Name;
					barItemQuery.ID = srchCriteria.ID;
					barItemQuery.Tag = querylistItem;
					barItemQuery.ImageList = _lrrApp.MainFrame.ImageList3;
					int imageIndex = 9;
					if(srchCriteria.Source == "I/O")
					{
						imageIndex = 44;
					}
					if(srchCriteria.Source == "GP")
					{
						imageIndex = 51;
					}
					if(srchCriteria.Source == "DA")
					{
						imageIndex = 51;
					}
					barItemQuery.ImageIndex = imageIndex;
					barItemQuery.Click+=new EventHandler(barItemQuery_Click);
						
					_mainFrameBarManager.Items.Add(barItemQuery);
					parentBarItem.Items.Add(barItemQuery);
				}
			}

			//Saved Views
			IEnumerator iSavedViewEnum = LRRModel.SavedViews.GetEnumerator();
			while(iSavedViewEnum.MoveNext())
			{
				LRRSavedView savedView = iSavedViewEnum.Current as LRRSavedView;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(savedView.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && savedView.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID
					&& savedView.IsSelected)
				{
					//Create List Item Object
					ListItem graphicslistItem = new ListItem();
					graphicslistItem.ListItemType = "Graphics";
					graphicslistItem.ListItemObject = savedView;

					BarItem barItemGraphics = new BarItem();
					barItemGraphics.Text = savedView.SavedViewName;
					barItemGraphics.ID = savedView.ID;
					barItemGraphics.Tag = graphicslistItem;
					barItemGraphics.ImageList = _lrrApp.MainFrame.ImageList3;
					barItemGraphics.ImageIndex = 53;
					barItemGraphics.Click+=new EventHandler(barItemQuery_Click);
						
					_mainFrameBarManager.Items.Add(barItemGraphics);
					parentBarItem.Items.Add(barItemGraphics);
				}
			}

			//Charts
			IEnumerator iExcelViewEnum = _lrrExcelViews.GetEnumerator();
			while(iExcelViewEnum.MoveNext())
			{
				LRRExcelView lrrExcelView = iExcelViewEnum.Current as LRRExcelView;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(lrrExcelView.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && lrrExcelView.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID
					&& lrrExcelView.IsSelected)
				{
					//Create List Item Object
					ListItem chartlistItem = new ListItem();
					chartlistItem.ListItemType = "ExcelView";
					chartlistItem.ListItemObject = lrrExcelView;

					BarItem barItemChart = new BarItem();
					
                    barItemChart.Text = String.Empty;
                    if ((lrrExcelView.ViewType == "Chart") || (lrrExcelView.ViewType == "Misc"))
                    {
                        LRRChart chart = new LRRChart();
                        _lrrApp.DBManagerObj.PopulateObject(chart, typeof(LRRChart), " where ID='" + lrrExcelView.ViewID + "'");

                        barItemChart.Text = chart.DisplayName;
                    }
                    else if (lrrExcelView.ViewType == "Charts")
                    {
                        LRRChartItem chartItem = new LRRChartItem();
                        _lrrApp.DBManagerObj.PopulateObject(chartItem, typeof(LRRChartItem), " where ID='" + lrrExcelView.ViewID + "'");

                        barItemChart.Text = chartItem.Name;
                    }

					barItemChart.ID = lrrExcelView.ID;
					barItemChart.Tag = chartlistItem;
					barItemChart.ImageList = _lrrApp.MainFrame.ImageList3;
					barItemChart.ImageIndex = 2;
					barItemChart.Click+=new EventHandler(barItemQuery_Click);
						
					_mainFrameBarManager.Items.Add(barItemChart);
					parentBarItem.Items.Add(barItemChart);
				}
			}

			//CompositeViews
			IEnumerator iCompositeViewEnum = _lrrCompositeViews.GetEnumerator();
			while(iCompositeViewEnum.MoveNext())
			{
				LRRCompositeView lrrCompositeView = iCompositeViewEnum.Current as LRRCompositeView;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(lrrCompositeView.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && lrrCompositeView.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID
					&& lrrCompositeView.IsSelected)
				{
					//Create List Item Object
					ListItem compositeViewlistItem = new ListItem();
					compositeViewlistItem.ListItemType = "CompositeViews";
					compositeViewlistItem.ListItemObject = lrrCompositeView;

					BarItem barItemCompositeView = new BarItem();
					barItemCompositeView.Text = lrrCompositeView.Name;
					barItemCompositeView.ID = lrrCompositeView.ID;
					barItemCompositeView.Tag = compositeViewlistItem;
					barItemCompositeView.ImageList = _lrrApp.MainFrame.ImageList3;
					barItemCompositeView.ImageIndex = 42;
					barItemCompositeView.Click+=new EventHandler(barItemQuery_Click);
						
					_mainFrameBarManager.Items.Add(barItemCompositeView);
					parentBarItem.Items.Add(barItemCompositeView);
				}
			}

			//MultiTrend
			IEnumerator iMultiTrendEnum = _multiTrendInfos.GetEnumerator();
			while(iMultiTrendEnum.MoveNext())
			{
				LRRMultiAttributeTrendInfo lrrMultiTrend = iMultiTrendEnum.Current as LRRMultiAttributeTrendInfo;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(lrrMultiTrend.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && lrrMultiTrend.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID
					&& lrrMultiTrend.IsSelected)
				{
					//Create List Item Object
					ListItem multiTrendlistItem = new ListItem();
					multiTrendlistItem.ListItemType = "MultiTrend";
					multiTrendlistItem.ListItemObject = lrrMultiTrend;

					BarItem barItemMultiTrend = new BarItem();
					barItemMultiTrend.Text = lrrMultiTrend.Name;
					barItemMultiTrend.ID = lrrMultiTrend.ID;
					barItemMultiTrend.Tag = multiTrendlistItem;
					barItemMultiTrend.ImageList = _lrrApp.MainFrame.ImageList3;
					barItemMultiTrend.ImageIndex = 42;
					barItemMultiTrend.Click+=new EventHandler(barItemQuery_Click);
						
					_mainFrameBarManager.Items.Add(barItemMultiTrend);
					parentBarItem.Items.Add(barItemMultiTrend);
				}
			}

		}
		
	
		/// <summary>
		/// Populate the tree View with groups and queries
		/// </summary>
		/// <param name="treeView"></param>
		/// <param name="levels"></param>
		/// <param name="levelLinks"></param>
		/// <returns></returns>
		private bool PopulateTreeView(TreeView treeView,LRRSearchGroupLevels levels,LRRSearchGroupLevelLinks levelLinks)
		{
			trvSearchLevels.Nodes.Clear();
			trvSearchLevels.ImageList = _lrrApp.MainFrame.ImageList3;
			try
			{
				Hashtable				_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRSearchGroupLevel l in levels)
				{
                    if (l.LevelID == "1")
                    {
                        int xyz = 0;
                    }
					_levelHash.Add(l.LevelID,l);
				}
				foreach(LRRSearchGroupLevelLink ll in levelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						TreeNode foundNode = _nodesHash[ll.ParentID] as TreeNode;
						LRRSearchGroupLevel foundLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel; 
						
						//Add Node
						AddNode(foundLevel,foundNode);
					}
					else
					{
						LRRSearchGroupLevel parentLevel = _levelHash[ll.ParentID] as LRRSearchGroupLevel;
						LRRSearchGroupLevel childLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel;
						TreeNode parentNode = new TreeNode(parentLevel.Name);

						//Create List Item Object
						ListItem lvllistItem = new ListItem();
						lvllistItem.ListItemType = "Level";
						lvllistItem.ListItemObject = parentLevel;

						parentNode.Tag = lvllistItem;
						parentNode.ImageIndex = 24;
						parentNode.SelectedImageIndex = 24;
						
						//Add Node
						AddNode(childLevel,parentNode);

						_nodesHash.Add(ll.ParentID,parentNode);
					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					TreeNode  childNode = null;
					TreeNode  parentNode = null;
					if(_nodesHash.ContainsKey(childID))
					{
						childNode = _nodesHash[childID] as TreeNode;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentNode = _nodesHash[parentID] as TreeNode;
					}
					if((parentNode != null) && (childNode != null))
					{
						int index = -1;
						foreach(TreeNode f in parentNode.Nodes)
						{
							ListItem listItem = f.Tag as ListItem;
							ListItem childlistItem = childNode.Tag as ListItem;
							
							if(listItem.ListItemObject == childlistItem.ListItemObject)
							{
								index = f.Index;
								break;
							}
						}
						if(index != -1)
							parentNode.Nodes[index] = childNode;
					}
				}
				
				TreeNode  rootNode = null;
				if(_nodesHash.Count > 0)
				{
					rootNode = _nodesHash["0"] as TreeNode;
				}
				else
				{
					LRRSearchGroupLevel srchGroupLevel = _levelHash["0"] as LRRSearchGroupLevel;

					//Create List Item Object
					ListItem listItem = new ListItem();
					listItem.ListItemType = "Level";
					listItem.ListItemObject = srchGroupLevel;
					rootNode = new TreeNode(srchGroupLevel.Name);
					rootNode.Tag = listItem;
					rootNode.ImageIndex = 24;
					rootNode.SelectedImageIndex = 24;
				}
				trvSearchLevels.Nodes.Add(rootNode);

				//Add Ungrouped views in root node
				IDictionaryEnumerator iDictEnum = _levelHash.GetEnumerator();
				while(iDictEnum.MoveNext())
				{
					DictionaryEntry dEntry = (DictionaryEntry)iDictEnum.Current;
					string levelID = (string)dEntry.Key;
					if(levelID != "0" && !_childParent.ContainsKey(levelID) && !_childParent.ContainsValue(levelID))
					{
						LRRSearchGroupLevel srchGroupLvl = (LRRSearchGroupLevel)dEntry.Value;
						if(srchGroupLvl.Type != "Level")
							AddNode(srchGroupLvl,rootNode);
					}
				}

				//Add the items in the root Node which are not in SearchGroupLevel but are present in views
				AddNodesFromViews(rootNode);

				FirstTimeParentCheck(trvSearchLevels.Nodes[0]);
				trvSearchLevels.Nodes[0].Expand();
				return true;

			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
				return false;
			}
		}

		private void AddNodesFromViews(TreeNode trvNode)
		{
			//Search Criterias
			IEnumerator iSrchEnum = _lrrSearchCriterias.GetEnumerator();
			while(iSrchEnum.MoveNext())
			{
				LRRSearchCriteria srchCriteria = iSrchEnum.Current as LRRSearchCriteria;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(srchCriteria.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && srchCriteria.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					TreeNode queryNode = new TreeNode(srchCriteria.Name);
					//Create List Item Object
					ListItem querylistItem = new ListItem();
					querylistItem.ListItemType = "Query";
					querylistItem.ListItemObject = srchCriteria;
					queryNode.Tag = querylistItem;
					int imageIndex = 9;
					if(srchCriteria.Source == "I/O")
					{
						imageIndex = 44;
					}
					if(srchCriteria.Source == "GP")
					{
						imageIndex = 51;
					}
					if(srchCriteria.Source == "DA")
					{
						imageIndex = 51;
					}
					queryNode.ImageIndex = imageIndex;
					queryNode.SelectedImageIndex = 9;
					trvNode.Nodes.Add(queryNode);
					queryNode.Checked = srchCriteria.IsSelected;
				}
			}

			//Saved Views
			IEnumerator iSavedViewEnum = LRRModel.SavedViews.GetEnumerator();
			while(iSavedViewEnum.MoveNext())
			{
				LRRSavedView savedView = iSavedViewEnum.Current as LRRSavedView;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(savedView.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && savedView.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					TreeNode graphicsNode = new TreeNode(savedView.SavedViewName);

					//Create List Item Object
					ListItem graphicslistItem = new ListItem();
					graphicslistItem.ListItemType = "Graphics";
					graphicslistItem.ListItemObject = savedView;
					
					graphicsNode.Tag = graphicslistItem;
					graphicsNode.ImageIndex = 53;
					graphicsNode.SelectedImageIndex = 53;
					trvNode.Nodes.Add(graphicsNode);
					graphicsNode.Checked = savedView.IsSelected;
				}
			}

			//Charts
			IEnumerator iExcelViewEnum = _lrrExcelViews.GetEnumerator();
			while(iExcelViewEnum.MoveNext())
			{
				LRRExcelView lrrExcelView = iExcelViewEnum.Current as LRRExcelView;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(lrrExcelView.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && lrrExcelView.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
                    string treeNodeName = String.Empty;
                    if ((lrrExcelView.ViewType == "Chart") || (lrrExcelView.ViewType == "Misc"))
                    {
                        LRRChart chart = new LRRChart();
                        _lrrApp.DBManagerObj.PopulateObject(chart, typeof(LRRChart), " where ID='" + lrrExcelView.ViewID + "'");

                        treeNodeName = chart.DisplayName;
                    }
                    else if (lrrExcelView.ViewType == "Charts")
                    {
                        LRRChartItem chartItem = new LRRChartItem();
                        _lrrApp.DBManagerObj.PopulateObject(chartItem, typeof(LRRChartItem), " where ID='" + lrrExcelView.ViewID + "'");

                        treeNodeName = chartItem.Name;
                    }
                    
                    TreeNode chartNode = new TreeNode(treeNodeName);

					//Create List Item Object
					ListItem chartlistItem = new ListItem();
					chartlistItem.ListItemType = "ExcelView";
					chartlistItem.ListItemObject = lrrExcelView;
					chartNode.Tag = chartlistItem;
					chartNode.ImageIndex = 2;
					chartNode.SelectedImageIndex = 2;
					trvNode.Nodes.Add(chartNode);
					chartNode.Checked = lrrExcelView.IsSelected;
				}
			}

			//CompositeViews
			IEnumerator iCompositeViewEnum = _lrrCompositeViews.GetEnumerator();
			while(iCompositeViewEnum.MoveNext())
			{
				LRRCompositeView lrrCompositeView = iCompositeViewEnum.Current as LRRCompositeView;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(lrrCompositeView.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && lrrCompositeView.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					TreeNode compositeViewNode = new TreeNode(lrrCompositeView.Name);

					//Create List Item Object
					ListItem compositeViewlistItem = new ListItem();
					compositeViewlistItem.ListItemType = "CompositeViews";
					compositeViewlistItem.ListItemObject = lrrCompositeView;
					compositeViewNode.Tag = compositeViewlistItem;		
					compositeViewNode.ImageIndex = 42;
					compositeViewNode.SelectedImageIndex = 42;
					trvNode.Nodes.Add(compositeViewNode);
					compositeViewNode.Checked = lrrCompositeView.IsSelected;
				}
			}

			//MultiTrend
			IEnumerator iMultiTrendEnum = _multiTrendInfos.GetEnumerator();
			while(iMultiTrendEnum.MoveNext())
			{
				LRRMultiAttributeTrendInfo lrrMultiTrend = iMultiTrendEnum.Current as LRRMultiAttributeTrendInfo;
				LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(lrrMultiTrend.ID);
				
				//If Level is not present,add in the root Node
				if(srchGroupLevel == null && lrrMultiTrend.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					TreeNode multiTrendNode = new TreeNode(lrrMultiTrend.Name);

					//Create List Item Object
					ListItem multiTrendlistItem = new ListItem();
					multiTrendlistItem.ListItemType = "MultiTrend";
					multiTrendlistItem.ListItemObject = lrrMultiTrend;
					multiTrendNode.Tag = multiTrendlistItem;		
					multiTrendNode.ImageIndex = 67;
					multiTrendNode.SelectedImageIndex = 67;
					trvNode.Nodes.Add(multiTrendNode);
					multiTrendNode.Checked = lrrMultiTrend.IsSelected;
				}
			}

		}
		
		private void AddNode(LRRSearchGroupLevel level,TreeNode trvNode)
		{
			if(level == null)
				return;

			string viewID = level.LevelID;
			string uid = _lrrApp.DBManagerObj.AccessControlModel.UserID;
			LRRViewSharing viewSharing = _lrrViewSharings.GetViewSharingByUserIDAndViewID(uid,viewID);
			bool read = true;
			if(viewSharing != null && !viewSharing.ReadPermission && level.UserID != uid)
				read = false;
			if(viewSharing == null && level.UserID != uid)
				read = false;

			switch(level.Type)
			{
				case "Query" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;		
					if(!read)
						break;
					LRRSearchCriteria lrrSrchCriteria = _lrrSearchCriterias.GetSearchCriteriaByID(level.LevelID);
					if(lrrSrchCriteria == null)
						return;
					TreeNode queryNode = new TreeNode(lrrSrchCriteria.Name);

					//Create List Item Object
					ListItem querylistItem = new ListItem();
					querylistItem.ListItemType = "Query";
					querylistItem.ListItemObject = lrrSrchCriteria;

					queryNode.Tag = querylistItem;
					
					int imageIndex = 9;
					if(lrrSrchCriteria.Source == "I/O")
					{
						imageIndex = 44;
					}
					if(lrrSrchCriteria.Source == "GP")
					{
						imageIndex = 51;
					}
					if(lrrSrchCriteria.Source == "DA")
					{
						imageIndex = 51;
					}
					
					queryNode.ImageIndex = imageIndex;
					queryNode.SelectedImageIndex = imageIndex;
					trvNode.Nodes.Add(queryNode);
					queryNode.Checked = lrrSrchCriteria.IsSelected;
					break;
				case "Graphics" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRSavedView lrrSavedView = LRRModel.SavedViews.GetSavedViewFromID(level.LevelID);
					if(lrrSavedView == null)
						return;
					TreeNode graphicsNode = new TreeNode(lrrSavedView.SavedViewName);

					//Create List Item Object
					ListItem graphicslistItem = new ListItem();
					graphicslistItem.ListItemType = "Graphics";
					graphicslistItem.ListItemObject = lrrSavedView;
					
					graphicsNode.Tag = graphicslistItem;
					graphicsNode.ImageIndex = 53;
					graphicsNode.SelectedImageIndex = 53;
					trvNode.Nodes.Add(graphicsNode);
					graphicsNode.Checked = lrrSavedView.IsSelected;
					break;
				case "ExcelView" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRExcelView lrrExcelView = _lrrExcelViews.GetExcelViewFromID(level.LevelID);
					if(lrrExcelView == null)
						return;
					TreeNode chartNode = new TreeNode(level.Name);

					//Create List Item Object
					ListItem chartlistItem = new ListItem();
					chartlistItem.ListItemType = "ExcelView";
					chartlistItem.ListItemObject = lrrExcelView;

					chartNode.Tag = chartlistItem;
					chartNode.ImageIndex = 2;
					chartNode.SelectedImageIndex = 2;
					trvNode.Nodes.Add(chartNode);
					chartNode.Checked = lrrExcelView.IsSelected;
					break;
				case "CompositeViews" :
//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
//						break;	
					if(!read)
						break;
					LRRCompositeView lrrCompositeView = _lrrCompositeViews.GetCompositeViewFromID(level.LevelID);
					if(lrrCompositeView == null)
						return;
					TreeNode compositeViewNode = new TreeNode(lrrCompositeView.Name);

					//Create List Item Object
					ListItem compositeViewlistItem = new ListItem();
					compositeViewlistItem.ListItemType = "CompositeViews";
					compositeViewlistItem.ListItemObject = lrrCompositeView;

					compositeViewNode.Tag = compositeViewlistItem;		
					compositeViewNode.ImageIndex = 42;
					compositeViewNode.SelectedImageIndex = 42;
					trvNode.Nodes.Add(compositeViewNode);
					compositeViewNode.Checked = lrrCompositeView.IsSelected;
					break;
				case "UnifiedView":
					if(!read)
						break;
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = _lrrUnifiedSrchCriterias.GetUnifiedViewByID(level.LevelID);
					if(lrrUnifiedView == null)
						return;
					TreeNode unifiedViewNode = new TreeNode(lrrUnifiedView.Name);

					//Create List Item Object
					ListItem unifiedViewlistItem = new ListItem();
					unifiedViewlistItem.ListItemType = "UnifiedView";
					unifiedViewlistItem.ListItemObject = lrrUnifiedView;

					unifiedViewNode.Tag = unifiedViewlistItem;		
					unifiedViewNode.ImageIndex = 47;
					unifiedViewNode.SelectedImageIndex = 47;
					trvNode.Nodes.Add(unifiedViewNode);
					unifiedViewNode.Checked = lrrUnifiedView.IsSelected;
					break;
				case "MultiTrend" :
					//					if(level.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID && !level.IsPublished)
					//						break;	
					if(!read)
						break;
					LRRMultiAttributeTrendInfo lrrMultiTrend = _multiTrendInfos.GetMultiTrendFromID(level.LevelID);
					if(lrrMultiTrend == null)
						return;
					TreeNode multiTrendNode = new TreeNode(lrrMultiTrend.Name);

					//Create List Item Object
					ListItem multiTrendlistItem = new ListItem();
					multiTrendlistItem.ListItemType = "CompositeViews";
					multiTrendlistItem.ListItemObject = lrrMultiTrend;

					multiTrendNode.Tag = multiTrendlistItem;		
					multiTrendNode.ImageIndex = 67;
					multiTrendNode.SelectedImageIndex = 67;
					trvNode.Nodes.Add(multiTrendNode);
					multiTrendNode.Checked = lrrMultiTrend.IsSelected;
					break;
				default :
					TreeNode childNode = new TreeNode(level.Name);

					//Create List Item Object
					ListItem lvllistItem = new ListItem();
					lvllistItem.ListItemType = "Level";
					lvllistItem.ListItemObject = level;
					childNode.Tag = lvllistItem;
					childNode.ImageIndex = 24;
					childNode.SelectedImageIndex = 24;
					trvNode.Nodes.Add(childNode);
					break;
			}
		}


		/// <summary>
		/// Get all the childs of a given group
		/// </summary>
		/// <param name="parentLevelID"></param>
		/// <returns></returns>
		private ArrayList GetAllChildLevels(string parentLevelID)
		{
			try
			{
				ArrayList arlist = new ArrayList(); //To Return araylist
				Queue q = new Queue(); //Temp object for getting childrens
				q.Enqueue(parentLevelID);
				while(q.Count > 0)
				{
					string levelID = (string)q.Dequeue();
					arlist.Add(levelID);
					foreach(LRRSearchGroupLevelLink levelLink in _lrrSearchGroupLevelLinks)
					{
						if(levelLink.ParentID == levelID)
						{
							q.Enqueue(levelLink.ChildID);
						}
					}
				}
				return arlist;
			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.Assert(false,ex.Message,ex.StackTrace);
				return null;
			}
		}

		private void UpdateLevels()
		{
			ArrayList arrItemsToDelete = new ArrayList();
			foreach(LRRSearchGroupLevel level in _lrrSearchGroupLevels)
			{
				if(level.ObjectState == DBOperation.DELETE)
				{
					RemoveListItem(level);
					arrItemsToDelete.Add(level);
				}
			}
			_lrrApp.DBManagerObj.CommitCollection(_lrrSearchGroupLevels);
			_lrrApp.DBManagerObj.CommitCollection(_lrrSearchGroupLevelLinks);

			for(int i=0;i < arrItemsToDelete.Count;i++)
			{
				LRRSearchGroupLevel grpLevel = arrItemsToDelete[i] as LRRSearchGroupLevel;
				_lrrSearchGroupLevels.Remove(grpLevel);
			}
			_lrrSearchGroupLevels.RefreshCollection();
			
//			_lrrSearchGroupLevelLinks.RefreshCollection();
//			_lrrApp.DBManagerObj.BeginTransaction();
//			_lrrApp.DBManagerObj.ExecuteBatchDelete(_lrrSearchGroupLevelLinks);
//			_lrrApp.DBManagerObj.CommitTransaction();
			_lrrSearchGroupLevelLinks.Clear();
			TreeNode trvNode = trvSearchLevels.Nodes[0];
			if(trvNode.Nodes != null && trvNode.Nodes.Count > 0)
			{
				GetAllChildLevels(trvNode);
			}
            trvSearchLevels.TreeViewNodeSorter = new OrgenizeViewScreenTreeSorter();
            trvSearchLevels.Sort();
//			_lrrApp.DBManagerObj.BeginTransaction();
//			_lrrApp.DBManagerObj.ExecuteBatchInsert(_lrrSearchGroupLevelLinks);
//			_lrrApp.DBManagerObj.CommitTransaction();
		}

			
		private void GetAllChildLevels(TreeNode trvNode)
		{
			for(int i=0;i < trvNode.Nodes.Count;i++)
			{
				TreeNode trvChildNode = trvNode.Nodes[i];
				LRRSearchGroupLevelLink lvlLink = new LRRSearchGroupLevelLink();
				lvlLink.ChildID = GetID(trvChildNode);
				lvlLink.ParentID = GetID(trvChildNode.Parent);
				_lrrSearchGroupLevelLinks.Add(lvlLink);
				if(trvChildNode.Nodes != null && trvChildNode.Nodes.Count > 0)
				{
					GetAllChildLevels(trvChildNode);
				}
			}
		}
		
		private string GetID(TreeNode trvNode)
		{
			string id = null;
			ListItem listItem = trvNode.Tag as ListItem;
			switch(listItem.ListItemType)
			{
				case "Query":
					LRRSearchCriteria lrrSrchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					id = lrrSrchCriteria.ID;
					break;
				case "Graphics":
					LRRSavedView lrrSavedView = listItem.ListItemObject as LRRSavedView;
					id = lrrSavedView.ID;
					break;
				case "CompositeViews":
					LRRCompositeView lrrCompView = listItem.ListItemObject as LRRCompositeView;
					id = lrrCompView.ID;
					break;
				case "ExcelView":
					LRRExcelView lrrExcelView = listItem.ListItemObject as LRRExcelView;
					id = lrrExcelView.ID;
					break;
				case "UnifiedView":
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					id = lrrUnifiedView.ID;
                    break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					id = lrrMultiTrend.ID;
					break;
				default:
					LRRSearchGroupLevel lrrSrchGroupLevel = listItem.ListItemObject as LRRSearchGroupLevel;
					id = lrrSrchGroupLevel.LevelID;
					break;
			}
			return id;
		}

		private BaseObject GetObject(ListItem listItem)
		{
			BaseObject baseObj = null;
			switch(listItem.ListItemType)
			{
				case "Query":
					LRRSearchCriteria lrrSrchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					baseObj = lrrSrchCriteria;
					break;
				case "Graphics":
					LRRSavedView lrrSavedView = listItem.ListItemObject as LRRSavedView;
					baseObj = lrrSavedView;
					break;
				case "CompositeViews":
					LRRCompositeView lrrCompView = listItem.ListItemObject as LRRCompositeView;
					baseObj = lrrCompView;
					break;
				case "ExcelView":
					LRRExcelView lrrExcelView = listItem.ListItemObject as LRRExcelView;
					baseObj = lrrExcelView;
					break;
				case "UnifiedView":
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					baseObj = lrrUnifiedView;
					break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					baseObj = lrrMultiTrend;
					break;
				default:
					LRRSearchGroupLevel lrrSrchGroupLevel = listItem.ListItemObject as LRRSearchGroupLevel;
					baseObj = lrrSrchGroupLevel;
					break;
			}
			return baseObj;
		}

		private string GetName(TreeNode trvNode)
		{
			string name = null;
			ListItem listItem = trvNode.Tag as ListItem;
			switch(listItem.ListItemType)
			{
				case "Query":
					LRRSearchCriteria lrrSrchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					name = lrrSrchCriteria.Name;
					break;
				case "Graphics":
					LRRSavedView lrrSavedView = listItem.ListItemObject as LRRSavedView;
					name = lrrSavedView.SavedViewName;
					break;
				case "CompositeViews":
					LRRCompositeView lrrCompView = listItem.ListItemObject as LRRCompositeView;
					name = lrrCompView.Name;
					break;
				case "ExcelView":
					LRRExcelView lrrExcelView = listItem.ListItemObject as LRRExcelView;
					//name = lrrExcelView.ViewType;
                    LRRChart chart = LRRModel.ChildModel.ExcelCharts.GetChartFromID(lrrExcelView.ViewID);
                    name = chart.DisplayName;
					break;
				case "UnifiedView":
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					name = lrrUnifiedView.Name;
					break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					name = lrrMultiTrend.Name;
					break;
				default:
					LRRSearchGroupLevel lrrSrchGroupLevel = listItem.ListItemObject as LRRSearchGroupLevel;
					name = lrrSrchGroupLevel.Name;
					break;
			}
			return name;
		}
		
		private string GetUserID(TreeNode trvNode)
		{
			string userID = null;
			ListItem listItem = trvNode.Tag as ListItem;
			switch(listItem.ListItemType)
			{
				case "Query":
					LRRSearchCriteria lrrSrchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					userID = lrrSrchCriteria.UserID;
					break;
				case "Graphics":
					LRRSavedView lrrSavedView = listItem.ListItemObject as LRRSavedView;
					userID = lrrSavedView.UserID;
					break;
				case "CompositeViews":
					LRRCompositeView lrrCompView = listItem.ListItemObject as LRRCompositeView;
					userID = lrrCompView.UserID;
					break;
				case "ExcelView":
					LRRExcelView lrrExcelView = listItem.ListItemObject as LRRExcelView;
					userID = lrrExcelView.UserID;
					break;
				case "UnifiedView":
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					userID = lrrUnifiedView.UserID;
					break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					userID = lrrMultiTrend.UserID;
					break;
				default:
					LRRSearchGroupLevel lrrSrchGroupLevel = listItem.ListItemObject as LRRSearchGroupLevel;
					userID = lrrSrchGroupLevel.UserID;
					break;
			}
			return userID;
		}

		private LRRSearchGroupLevel GetLevel(TreeNode trvNode)
		{
			string id = null;
			ListItem listItem = trvNode.Tag as ListItem;
			switch(listItem.ListItemType)
			{
				case "Query":
					LRRSearchCriteria lrrSrchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					id = lrrSrchCriteria.ID;
					break;
				case "Graphics":
					LRRSavedView lrrSavedView = listItem.ListItemObject as LRRSavedView;
					id = lrrSavedView.ID;
					break;
				case "CompositeViews":
					LRRCompositeView lrrCompView = listItem.ListItemObject as LRRCompositeView;
					id = lrrCompView.ID;
					break;
				case "ExcelView":
					LRRExcelView lrrExcelView = listItem.ListItemObject as LRRExcelView;
					id = lrrExcelView.ID;
					break;
			case "UnifiedView":
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					id = lrrUnifiedView.ID;
					break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					id = lrrMultiTrend.ID;
					break;
				default:
					LRRSearchGroupLevel lrrSrchGroupLevel = listItem.ListItemObject as LRRSearchGroupLevel;
					id = lrrSrchGroupLevel.LevelID;
					break;
			}
			LRRSearchGroupLevel lvl = _lrrSearchGroupLevels.GetLevelFromID(id);
			return lvl;
		}

		private void AddToCollection(TreeNode tn, string text)
		{
			try
			{
				LRRSearchGroupLevel lvl = new LRRSearchGroupLevel();
				lvl.Name = text;
				lvl.Type = "Level";

				ListItem listItem = new ListItem();
				listItem.ListItemType = "Level";
				listItem.ListItemObject = lvl;
				tn.Tag = listItem;
				_lrrSearchGroupLevels.Add(lvl);

				LRRSearchGroupLevelLink lvlLink = new LRRSearchGroupLevelLink();
				lvlLink.ChildID = GetID(tn);
				lvlLink.ParentID = GetID(tn.Parent);
				_lrrSearchGroupLevelLinks.Add(lvlLink);

				//LRRSearchGroupLevels toCommitLevels = _lrrSearchGroupLevels.GetChanges();
				//_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
				//_lrrSearchGroupLevels.RefreshCollection();
			}
			catch(Exception ex)
			{
				System.Diagnostics.Debug.Assert(false, ex.Message);
			}
		}

		public void Refresh()
		{
			InitDataSource();
			PopulateTreeView(trvSearchLevels,_lrrSearchGroupLevels,_lrrSearchGroupLevelLinks);
            trvSearchLevels.TreeViewNodeSorter = new OrgenizeViewScreenTreeSorter();
            trvSearchLevels.Sort();
		
		}
		#endregion
		
		#region Event Handlers
		private void btnAddQuery_Click(object sender, System.EventArgs e)
		{
			switch(_calledFrom)
			{
				case 0:
                    trvSearchLevels.BeginUpdate();
					ArrayList arrItemsToRemove = new ArrayList();
					for(int i=2;i < _barQuery.Items.Count;i++)
					{
						BarItem barItem = _barQuery.Items[i] as BarItem;
						ListItem lvItem = barItem.Tag as ListItem;
						if(lvItem != null)
						{
							LRRSearchGroupLevel lvGrpLevel = lvItem.ListItemObject as LRRSearchGroupLevel;
							if(lvGrpLevel != null && lvGrpLevel.LevelID == "0")
							{
								arrItemsToRemove.Add(barItem);
							}
						}
					}
					for(int k=0; k < arrItemsToRemove.Count;k++)
					{
						BarItem barItem = arrItemsToRemove[k] as BarItem;
						_barQuery.Items.Remove(barItem);
					}
			
					UpdateLevels();

					PopulateBarItems();
                    trvSearchLevels.TreeViewNodeSorter = new OrgenizeViewScreenTreeSorter();
                    trvSearchLevels.Sort();
                    trvSearchLevels.EndUpdate();
					LRRMessagBox.ShowMessage("SID_UPDATED_QUERYLIST","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					break;
				case 1:
					break;
				default :
					break;

			}
		}

		public void barItemQuery_Click(object sender, EventArgs e)
		{		
			BarItem barItemQuery = sender as BarItem;
			ListItem listItem = barItemQuery.Tag as ListItem;
			
			switch(listItem.ListItemType)
			{
				case "Query" :
					LRRSearchCriteria  lrrSrchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					OpenQuery(lrrSrchCriteria);
					break;
				case "Graphics" :
					LRRSavedView  lrrSavedView = listItem.ListItemObject as LRRSavedView;
					OpenGraphics(lrrSavedView);
					break;
				case "CompositeViews" :
					LRRCompositeView  lrrCompView = listItem.ListItemObject as LRRCompositeView;
					OpenCompositeView(lrrCompView);
					break;
				case "ExcelView" :
					LRRExcelView  lrrExcelView = listItem.ListItemObject as LRRExcelView;
					OpenExcelView(lrrExcelView);
					break;
				case "UnifiedView" :
					LRRUnifiedViewSearchCrtiteria  lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					OpenUnifiedView(lrrUnifiedView);
					break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					OpenMultiTrend(lrrMultiTrend);
					break;
				default :
					break;
			}
		}
		
		private void OpenQuery(LRRSearchCriteria lrrSrchCriteria)
		{


            string sSource = lrrSrchCriteria.Source == null ? "" : lrrSrchCriteria.Source.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(sSource == "I/O")
			{
                object[] obj = new object[1];
                obj[0] = lrrSrchCriteria.ID;
                _lrrApp.LRRUIManagerObj.ShowWindow(lrrSrchCriteria.ID, typeof(ResultForm), obj);
			}
			else
			{
                object[] obj = new object[1];
                obj[0] = lrrSrchCriteria.ID;
                _lrrApp.LRRUIManagerObj.ShowWindow(lrrSrchCriteria.ID, typeof(GroupedPlantPropertiesResultForm), obj);
			}
		}
	

		private void OpenGraphics(LRRSavedView lrrSavedView)
		{
			try
			{
				object[] args = new object[1];
				args[0] = 270;
				LRRWaitWindowUtility.ExecuteMethodWithWait(_lrrApp.LRRUIManagerObj,"ShowWindow",args,MethodExecutionMode.UI);
				Form frm =  _lrrApp.LRRUIManagerObj._windowStore[270] as Form;
				OperatorsScreen screen = frm as OperatorsScreen;
                if (screen != null)
                {
                    screen.OpenFiles(lrrSavedView.ID);
                }
			}
			catch(Exception	ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void OpenCompositeView(LRRCompositeView lrrCompView)
		{
			try
			{
                object[] obj = new object[1];
                LRRCompositeView compViewUpdated = new LRRCompositeView();
                _lrrApp.DBManagerObj.PopulateObject(compViewUpdated, typeof(LRRCompositeView), " where ID='" + lrrCompView.ID + "'");
                obj[0] = compViewUpdated;
                _lrrApp.LRRUIManagerObj.ShowWindow(lrrCompView.ID, typeof(CompositeView), obj);
				//Form frm =  _lrrApp.LRRUIManagerObj._windowStore[280] as Form;
                //CompositeView compView = frm as CompositeView;
                //compView.OpenCompositeView(lrrCompView);
                //compView.ParentTabPage.Text = "Composite View" + "-[" + lrrCompView.Name + "]";
               // compView.Text = "Composite View" + "-[" + lrrCompView.Name + "]";
               // _lrrApp.MainFrame.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(_lrrApp.MainFrame.CompositeViewBarObj,false);
			}
			catch(Exception	ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		private void OpenMultiTrend(LRRMultiAttributeTrendInfo multiTrend)
		{
			MemoryStream memoryStream = new MemoryStream (multiTrend.TrendInfo);
			XmlSerializer xs = new XmlSerializer(typeof(TemplateRows));
			TemplateRows templateRows = xs.Deserialize(memoryStream) as TemplateRows;
			memoryStream.Close();

			string key = "MultiTrend:" + multiTrend.Name;
			if(_lrrApp.LRRUIManagerObj._windowStore.ContainsKey(key))
			{
				ILRRUIContainer cont = _lrrApp.LRRUIManagerObj._windowStore[key] as ILRRUIContainer;
				cont.Refresh();
				Form frm = cont as Form;
				frm.Activate();
			}
			else
			{
				object[] obj = new object[2];
				obj[0] = templateRows;
				obj[1] = multiTrend;
				_lrrApp.LRRUIManagerObj.ShowWindow(key,typeof(MultiTrend),obj);
			}
		}

		private void OpenExcelView(LRRExcelView lrrExcelView)
		{
			object[] obj = new object[1];
			obj[0] = lrrExcelView.ID;
			_lrrApp.LRRUIManagerObj.ShowWindow(lrrExcelView.ID,typeof(ExcelView),obj);
		}

		private void OpenUnifiedView(LRRUnifiedViewSearchCrtiteria lrrUnifiedView)
		{
            object[] obj = new object[1];
            obj[0] = lrrUnifiedView.ID;
            _lrrApp.LRRUIManagerObj.ShowWindow(lrrUnifiedView.ID, typeof(UnifiedViewResultForm), obj);
		}

		private object GridView
		{
			get { return _gridView;}
			set
			{
				_gridView = value;
			}
		}

		private object _gridView;

		private void trvSearchLevels_AfterCheck(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			TreeNode trvNode = e.Node;
			if(_checkAllChilds)
			{
				CheckIFParentNeedsToCheck(trvNode);
				GetAllAndCheckUncheckListItems(trvNode);
                //Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversion(trvNode);
			}
            Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(trvNode);
		}

		private void GetAllAndCheckUncheckListItems(TreeNode trvNode)
		{
			if(_checkAllChilds)
				_checkAllChilds = false;
			if(trvNode.Nodes != null && trvNode.Nodes.Count > 0)
			{	
				GetAllChildNodes(trvNode);
			}
			else
			{
				CheckUncheckListItems(trvNode);
			}
			_checkAllChilds = true;
		}

		private void FirstTimeParentCheck(TreeNode trvNode)
		{
			if(_checkAllChilds)
				_checkAllChilds = false;
			if(trvNode.Nodes != null && trvNode.Nodes.Count > 0)
			{
				foreach(TreeNode childNode in trvNode.Nodes)
				{
					FirstTimeParentCheck(childNode);
				}
			}
			else
				CheckIFParentNeedsToCheck(trvNode);

			_checkAllChilds = true;
		}

		private void CheckIFParentNeedsToCheck(TreeNode trvNode)
		{
			if(_checkAllChilds)
				_checkAllChilds = false;
			if(trvNode.Parent != null)
			{
				bool check = true;
				foreach(TreeNode childTrvNode in trvNode.Parent.Nodes)
				{
					if(!childTrvNode.Checked)
						check = false;
				}
				trvNode.Parent.Checked = check;
				CheckIFParentNeedsToCheck(trvNode.Parent);
			}
		}

		private void GetAllChildNodes(TreeNode trvNode)
		{
			
			for(int i=0;i < trvNode.Nodes.Count;i++)
			{
				TreeNode trvChildNode = trvNode.Nodes[i];
				trvChildNode.Checked = trvNode.Checked;
				if(trvChildNode.Nodes != null && trvChildNode.Nodes.Count > 0)
				{
					GetAllChildNodes(trvChildNode);
				}
				else
				{
					CheckUncheckListItems(trvChildNode);
				}
			}
		}

		private void CheckUncheckListItems(TreeNode trvNode)
		{
			ListItem listItem = trvNode.Tag as ListItem;
			if(listItem != null)
			{
				//Queries
				if(listItem.ListItemType == "Query")
				{
					LRRSearchCriteria srchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					if(srchCriteria != null)
					{
						if(!_arrRestorePrevStateList.Contains(listItem))
						{
							listItem.PrevState = srchCriteria.IsSelected;
							_arrRestorePrevStateList.Add(listItem);
						}
						srchCriteria.IsSelected = trvNode.Checked;
					}

				}
				//Graphics
				if(listItem.ListItemType == "Graphics")
				{
					LRRSavedView savedView = listItem.ListItemObject as LRRSavedView;
					if(savedView != null)
					{
						if(!_arrRestorePrevStateList.Contains(listItem))
						{
							listItem.PrevState = savedView.IsSelected;
							_arrRestorePrevStateList.Add(listItem);
						}
						savedView.IsSelected = trvNode.Checked;
					}
				}
				//Composite VIews
				if(listItem.ListItemType == "CompositeViews")
				{
					LRRCompositeView compView = listItem.ListItemObject as LRRCompositeView;
					if(compView != null)
					{
						if(!_arrRestorePrevStateList.Contains(listItem))
						{
							listItem.PrevState = compView.IsSelected;
							_arrRestorePrevStateList.Add(listItem);
						}
						compView.IsSelected = trvNode.Checked;
					}
				}
				//Charts
				if(listItem.ListItemType == "ExcelView")
				{
					LRRExcelView lrrExcelView = listItem.ListItemObject as LRRExcelView;
					if(lrrExcelView != null)
					{
						if(!_arrRestorePrevStateList.Contains(listItem))
						{
							listItem.PrevState = lrrExcelView.IsSelected;
							_arrRestorePrevStateList.Add(listItem);
						}
						lrrExcelView.IsSelected = trvNode.Checked;
					}
				}
				//UnifiedView
				if(listItem.ListItemType == "UnifiedView")
				{
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					if(lrrUnifiedView != null)
					{
						if(!_arrRestorePrevStateList.Contains(listItem))
						{
							listItem.PrevState = lrrUnifiedView.IsSelected;
							_arrRestorePrevStateList.Add(listItem);
						}
						lrrUnifiedView.IsSelected = trvNode.Checked;
					}
				}
				//Level
				if(listItem.ListItemType == "Level")
				{
					LRRSearchGroupLevel level = listItem.ListItemObject as LRRSearchGroupLevel;
					if(level != null)
					{
						if(!_arrRestorePrevStateList.Contains(listItem))
						{
							listItem.PrevState = level.IsSelected;
							_arrRestorePrevStateList.Add(listItem);
						}
						level.IsSelected = trvNode.Checked;
					}
				}
				if(listItem.ListItemType == "MultiTrend")
				{
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					if(lrrMultiTrend != null)
					{
						if(!_arrRestorePrevStateList.Contains(listItem))
						{
							listItem.PrevState = lrrMultiTrend.IsSelected;
							_arrRestorePrevStateList.Add(listItem);
						}
						lrrMultiTrend.IsSelected = trvNode.Checked;
					}
				}
			}
		}

		private void mnuRemove_Click(object sender, System.EventArgs e)
		{
			TreeNode trvNode = trvSearchLevels.SelectedNode;
			if(trvNode.Nodes != null && trvNode.Nodes.Count > 0)
			{
				//DialogResult dlgRslt = MessageBox.Show(this, trvSearchLevels.SelectedNode.Text + " and all its sublevels will be deleted permanently." + '\n' + "Do you wish to continue?", this.Name, MessageBoxButtons.YesNo,MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2);
				string[] s = new string[1];
				s[0] = trvSearchLevels.SelectedNode.Text;
				DialogResult dlgRslt = LRRMessagBox.ShowMessage(this,"SID_DELETE_LEVEL_CONFIRM","SID_LABEL",s,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      
				if(dlgRslt == DialogResult.Yes)
				{
					ListItem lvlItem = trvNode.Tag as ListItem;
					LRRSearchGroupLevel lvl =  lvlItem.ListItemObject as LRRSearchGroupLevel;
					string id = lvl.LevelID;
					ArrayList alist = new ArrayList();
					alist = GetAllChildLevels(id);
					for(int i = 0; i< alist.Count;  i++)
					{
						string str = alist[i] as string;
						for(int j = _lrrSearchGroupLevels.Count - 1; j >=0;j--)
						{
							LRRSearchGroupLevel levl = _lrrSearchGroupLevels[j] as LRRSearchGroupLevel;
							if(levl.LevelID == str)
							{
								levl.ObjectState = DBOperation.DELETE;
								//_lrrSearchGroupLevels.Remove(levl);
								//RemoveListItem(levl);
							}
							for(int k =_lrrSearchGroupLevelLinks.Count-1; k>=0;k--)
							{
								LRRSearchGroupLevelLink lvlLink = _lrrSearchGroupLevelLinks[k] as LRRSearchGroupLevelLink;
								if(lvlLink.ChildID == str)
									lvlLink.ObjectState = DBOperation.DELETE;
							}
						}
					}
					//LRRSearchGroupLevels toCommitLevels = _lrrSearchGroupLevels.GetChanges();
					//LRRSearchGroupLevelLinks toCommitLevelLinks = _lrrSearchGroupLevelLinks.GetChanges();
					//_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
					//_lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
					//_lrrSearchGroupLevels.RefreshCollection();
					//_lrrSearchGroupLevelLinks.RefreshCollection();
					//_lrrSearchCriterias.RefreshCollection();
					trvSearchLevels.Nodes.Remove(trvSearchLevels.SelectedNode);
				}
				
			}
			else
			{
				//DialogResult dlgRslt = MessageBox.Show(this, trvSearchLevels.SelectedNode.Text + " will be deleted permanently." + '\n' + "Do you wish to continue?", this.Name, MessageBoxButtons.YesNo,MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2);
				string[] s = new string[1];
				s[0] = trvSearchLevels.SelectedNode.Text;
				DialogResult dlgRslt = LRRMessagBox.ShowMessage(this,"SID_DELETE_LEVEL_CONFIRM","SID_LABEL",s,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      
				if(dlgRslt == DialogResult.Yes)
				{
					ListItem listItem = trvNode.Tag as ListItem;
					//RemoveListItem(listItem);
					
					LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(GetID(trvNode));
					if(srchGroupLevel != null)
					{
						srchGroupLevel.ObjectState = DBOperation.DELETE;
						LRRSearchGroupLevelLink srchGroupLvlLink = _lrrSearchGroupLevelLinks.GetLevelLink(GetID(trvNode.Parent),GetID(trvNode));
						if(srchGroupLvlLink != null)
							srchGroupLvlLink.ObjectState = DBOperation.DELETE;
					}
                    //else
                    //{
						RemoveListItem(listItem);
                    //}
					trvSearchLevels.Nodes.Remove(trvSearchLevels.SelectedNode);

				}
			}
		}

		
		private void mnuPublishToOtherUsers_Click(object sender, System.EventArgs e)
		{
			/*
			TreeNode trvNode = trvSearchLevels.SelectedNode;
 			LRRSearchGroupLevel lvl = GetLevel(trvNode);
			if(lvl == null)
			{
				//Create the Level
				lvl = new LRRSearchGroupLevel();
				lvl.LevelID = GetID(trvNode);
				lvl.Name = GetName(trvNode);
				ListItem listItem = trvNode.Tag as ListItem;
				lvl.Type = listItem.ListItemType;
				lvl.IsPublished = false;
				lvl.UserID = _lrrApp.DBManagerObj.AccessControlModel.UserID;
				_lrrSearchGroupLevels.Add(lvl);
			}
			string[] sMsg = new string[1];
			sMsg[0] = lvl.Name;

			//If item is published,then ask for unpublishing
			if(lvl.IsPublished)
			{
				DialogResult dlgResult = LRRMessagBox.ShowMessage(this,"SID_UNPUBLISH","SID_LABEL",sMsg,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      
				if(dlgResult == DialogResult.Yes)
				{
					lvl.IsPublished = false;
					_lrrApp.DBManagerObj.CommitObject(lvl);
					LRRMessagBox.ShowMessage(this,"SID_UNPUBLISH_SUCCESSFUL","SID_LABEL",sMsg,MessageBoxButtons.OK,MessageBoxIcon.Information);
				}
			}
			//If item is unpublished,then ask for publishing
			else
			{
				DialogResult dlgResult = LRRMessagBox.ShowMessage(this,"SID_PUBLISH","SID_LABEL",sMsg,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      
				if(dlgResult == DialogResult.Yes)
				{
					lvl.IsPublished = true;
					_lrrApp.DBManagerObj.CommitObject(lvl);
					LRRMessagBox.ShowMessage(this,"SID_PUBLISH_SUCCESSFUL","SID_LABEL",sMsg,MessageBoxButtons.OK,MessageBoxIcon.Information);
				}
			}*/

			TreeNode trvNode = trvSearchLevels.SelectedNode;
			LRRSearchGroupLevel lvl = GetLevel(trvNode);
			ViewSharingForm viewSharingFrm = new ViewSharingForm(lvl.LevelID);
			viewSharingFrm.ShowDialog();

		}

        private void RemoveExcelView(LRRExcelView lrrExcelView)
        {
            if ((lrrExcelView.ViewType == "Chart") || (lrrExcelView.ViewType == "Misc"))
            {
                LRRChart chart = new LRRChart();
                _lrrApp.DBManagerObj.PopulateObject(chart, typeof(LRRChart), " where ID='" + lrrExcelView.ViewID + "'");

                chart.ObjectState = DBOperation.DELETE;
                _lrrApp.DBManagerObj.CommitObject(chart);
            }
            else if (lrrExcelView.ViewType == "Charts")
            {
                LRRChartItem chartItem = new LRRChartItem();
                _lrrApp.DBManagerObj.PopulateObject(chartItem, typeof(LRRChartItem), " where ID='" + lrrExcelView.ViewID + "'");

                LRRChartDefinitions chartDefinitions = new LRRChartDefinitions();
                _lrrApp.DBManagerObj.PopulateCollection(chartDefinitions, " where ChartItemID='" + chartItem.ID + "'", false);
                foreach (LRRChartDefinition chartDefinition in chartDefinitions)
                {
                    chartDefinition.ObjectState = DBOperation.DELETE;
                }
                _lrrApp.DBManagerObj.CommitCollection(chartDefinitions);

                chartItem.ObjectState = DBOperation.DELETE;
                _lrrApp.DBManagerObj.CommitObject(chartItem);
            }

            lrrExcelView.ObjectState = DBOperation.DELETE;
            _lrrApp.DBManagerObj.CommitObject(lrrExcelView);
        }

		private void RemoveListItem(LRRSearchGroupLevel srchGroupLevel)
		{
			switch(srchGroupLevel.Type)
			{
				case "Query":
					LRRSearchCriteria srchCriteria = _lrrSearchCriterias.GetSearchCriteriaByID(srchGroupLevel.LevelID);
					if(srchCriteria != null)
					{
						_lrrSearchCriterias.Remove(srchCriteria);
						srchCriteria.ObjectState = DBOperation.DELETE;
						LRRSearchCriteria searchCriteria = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(srchCriteria.ID);
						if(searchCriteria != null)
							LRRModel.ChildModel.SearchCriterias.Remove(searchCriteria);
						_lrrApp.DBManagerObj.CommitObject(srchCriteria);
						_lrrSearchCriterias.RefreshCollection();
					}
					break;
				case "Graphics":
					LRRSavedView savedView = LRRModel.SavedViews.GetSavedViewFromID(srchGroupLevel.LevelID);
					if(savedView != null)
					{
						savedView.ObjectState = DBOperation.DELETE;
                        LRRModel.SavedViews.Remove(savedView);
						_lrrApp.DBManagerObj.CommitObject(savedView);
                        LRRModel.SavedViews.Remove(savedView);
					}
					break;
				case "CompositeViews":
					LRRCompositeView compositeView = _lrrCompositeViews.GetCompositeViewFromID(srchGroupLevel.LevelID);
					if(compositeView != null)
					{
						compositeView.ObjectState = DBOperation.DELETE;
                        LRRModel.ChildModel.CompositeViews.Remove(compositeView); 
						_lrrApp.DBManagerObj.CommitObject(compositeView);
                        LRRModel.ChildModel.CompositeViews.Remove(compositeView);
					}
					break;
				case "ExcelView":
					LRRExcelView lrrExcelView = _lrrExcelViews.GetExcelViewFromID(srchGroupLevel.LevelID);
                    if (lrrExcelView != null)
                    {
                        RemoveExcelView(lrrExcelView);
                        LRRModel.ChildModel.ExcelViews.Remove(lrrExcelView);
                    }
					break;
			case "UnifiedView":
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = _lrrUnifiedSrchCriterias.GetUnifiedViewByID(srchGroupLevel.LevelID);
					if(lrrUnifiedView != null)
					{
						lrrUnifiedView.ObjectState = DBOperation.DELETE;
                        LRRModel.ChildModel.UnifiedViewSearchCrtiterias.Remove(lrrUnifiedView);
						_lrrApp.DBManagerObj.CommitObject(lrrUnifiedView);
                        LRRModel.ChildModel.UnifiedViewSearchCrtiterias.Remove(lrrUnifiedView);
					}
					break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = _multiTrendInfos.GetMultiTrendFromID(srchGroupLevel.LevelID);
					if(lrrMultiTrend != null)
					{
						lrrMultiTrend.ObjectState = DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(lrrMultiTrend);
					}
					break;
				default :
					break;
			}

		}

		private void RemoveListItem(ListItem listItem)
		{
			switch(listItem.ListItemType)
			{
				case "Query":
					LRRSearchCriteria srchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					if(srchCriteria != null)
					{
						_lrrSearchCriterias.Remove(srchCriteria);
						srchCriteria.ObjectState = DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(srchCriteria);
						LRRSearchCriteria searchCriteria = LRRModel.SearchCriterias.GetSearchCriteriaByID(srchCriteria.ID);
						if(searchCriteria != null)
							LRRModel.ChildModel.SearchCriterias.Remove(searchCriteria);
						_lrrSearchCriterias.RefreshCollection();

						LRRSearchGroupLevel lvl = _lrrSearchGroupLevels.GetLevelFromID(srchCriteria.ID);
						if(lvl != null)
						{
							lvl.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lvl);
						}
					}
					break;
				case "Graphics":
					LRRSavedView savedView = listItem.ListItemObject as LRRSavedView;
					if(savedView != null)
					{
						savedView.ObjectState = DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(savedView);

						LRRSearchGroupLevel lvl = _lrrSearchGroupLevels.GetLevelFromID(savedView.ID);
						if(lvl != null)
						{
							lvl.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lvl);
						}
                        LRRModel.SavedViews.Remove(savedView);
					}
					break;
				case "CompositeViews":
					LRRCompositeView compositeView = listItem.ListItemObject as LRRCompositeView;
					if(compositeView != null)
					{
						compositeView.ObjectState = DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(compositeView);

						LRRSearchGroupLevel lvl = _lrrSearchGroupLevels.GetLevelFromID(compositeView.ID);
						if(lvl != null)
						{
							lvl.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lvl);
						}
                        LRRModel.ChildModel.CompositeViews.Remove(compositeView);
					}
					break;
				case "ExcelView":
					LRRExcelView lrrExcelView = listItem.ListItemObject as LRRExcelView;
					if(lrrExcelView != null)
					{
                        RemoveExcelView(lrrExcelView);
						
						LRRSearchGroupLevel lvl = _lrrSearchGroupLevels.GetLevelFromID(lrrExcelView.ID);
						if(lvl != null)
						{
							lvl.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lvl);
						}
                        LRRModel.ChildModel.ExcelViews.Remove(lrrExcelView);
					}
					break;
				case "UnifiedView":
					LRRUnifiedViewSearchCrtiteria lrrUnifiedView = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
					if(lrrUnifiedView != null)
					{
						lrrUnifiedView.ObjectState = DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(lrrUnifiedView);
						
						LRRSearchGroupLevel lvl = _lrrSearchGroupLevels.GetLevelFromID(lrrUnifiedView.ID);
						if(lvl != null)
						{
							lvl.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lvl);
						}
                        LRRModel.ChildModel.UnifiedViewSearchCrtiterias.Remove(lrrUnifiedView);
					}
					break;
				case "MultiTrend":
					LRRMultiAttributeTrendInfo lrrMultiTrend = listItem.ListItemObject as LRRMultiAttributeTrendInfo;
					if(lrrMultiTrend != null)
					{
						lrrMultiTrend.ObjectState = DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(lrrMultiTrend);
						
						LRRSearchGroupLevel lvl = _lrrSearchGroupLevels.GetLevelFromID(lrrMultiTrend.ID);
						if(lvl != null)
						{
							lvl.ObjectState = DBOperation.DELETE;
							_lrrApp.DBManagerObj.CommitObject(lvl);
						}
					}
					break;
				default :
					break;
			}
		}

		private void contextMenu1_Popup(object sender, System.EventArgs e)
		{
			mnuRemove.Enabled = true;
			mnuRename.Enabled = false;
			mnuAdd.Enabled = false;
			mnuInsert.Enabled = false;
			mnuPublishToOtherUsers.Enabled = false;
			mnuPublishToOtherUsers.Checked = false;
			if(trvSearchLevels.Nodes.Count>0)
			{
				ListItem listItem = trvSearchLevels.SelectedNode.Tag as ListItem;
				if(listItem != null && listItem.ListItemType == "Level")
				{
					mnuAdd.Enabled = true;
					mnuInsert.Enabled = true;
					mnuRename.Enabled = true;
					LRRSearchGroupLevel lvl = listItem.ListItemObject as LRRSearchGroupLevel;
					if(lvl != null && lvl.LevelID == "0")
					{
						mnuRemove.Enabled = false;
						mnuRename.Enabled = false;
					}
				}
				else
				{
					string viewID = GetID(trvSearchLevels.SelectedNode);
					string uid = _lrrApp.DBManagerObj.AccessControlModel.UserID;
					LRRViewSharing viewSharing = _lrrViewSharings.GetViewSharingByUserIDAndViewID(uid,viewID);
					
					if(viewSharing != null)
					{
						if(viewSharing.FullControlPermission)
						{
							mnuPublishToOtherUsers.Enabled = true;
							mnuRemove.Enabled = true;
						}
						if(viewSharing.ChangePermission && !viewSharing.FullControlPermission)
						{
							mnuPublishToOtherUsers.Enabled = false;
							mnuRemove.Enabled = true;
						}
						if(viewSharing.ReadPermission && !viewSharing.ChangePermission)
						{
							mnuPublishToOtherUsers.Enabled = false;
							mnuRemove.Enabled = false;
						}
					}
					else
					{
						mnuPublishToOtherUsers.Enabled = false;
						mnuRemove.Enabled = false;
					}

					LRRSearchGroupLevel lvl = GetLevel(trvSearchLevels.SelectedNode);
					if(lvl != null)
					{
//						mnuPublishToOtherUsers.Checked = lvl.IsPublished;
						if(lvl.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
						{
//							if(UIAccessController.UIACLController.IsUIEntityAccessible("EnablePublishing"))
								mnuPublishToOtherUsers.Enabled = true;
							mnuRemove.Enabled = true;
						}
//						if(lvl.UserID != _lrrApp.DBManagerObj.AccessControlModel.UserID)
//						{
//							mnuRemove.Enabled = false;
//						}
					}
					//Check if it is present in Views
					else
					{
						string userID = GetUserID(trvSearchLevels.SelectedNode);
						if(userID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
						{
							mnuPublishToOtherUsers.Enabled = true;
							mnuRemove.Enabled = true;
						}
					}
				}
			}
		}

		TreeNode selectedNode = null;
		private void trvSearchLevels_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{
			try
			{
				this.selectedNode = (TreeNode)e.Item;

				// Reset image list used for drag image
				this.imageListDrag.Images.Clear();
				this.imageListDrag.ImageSize = 
					new Size(this.selectedNode.Bounds.Size.Width 
					+ this.trvSearchLevels.Indent, this.selectedNode.Bounds.Height);

				// Create new bitmap
				// This bitmap will contain the tree node image to be dragged
				Bitmap bmp = new Bitmap(this.selectedNode.Bounds.Width 
					+ this.trvSearchLevels.Indent, this.selectedNode.Bounds.Height);

				// Get graphics from bitmap
				Graphics gfx = Graphics.FromImage(bmp);

				// Draw node icon into the bitmap
				if(this.trvSearchLevels.ImageList.Images.Count > this.selectedNode.ImageIndex)
					gfx.DrawImage(this.trvSearchLevels.ImageList.Images[this.selectedNode.ImageIndex], 0, 0);

				// Draw node label into bitmap
				gfx.DrawString(this.selectedNode.Text,
					this.trvSearchLevels.Font,
					new SolidBrush(this.trvSearchLevels.ForeColor),
					(float)this.trvSearchLevels.Indent, 1.0f);

				// Add bitmap to imagelist
				this.imageListDrag.Images.Add(bmp);

				// Get mouse position in client coordinates
				Point p = this.trvSearchLevels.PointToClient(Control.MousePosition);

				// Compute delta between mouse position and node bounds
				int dx = p.X + this.trvSearchLevels.Indent - this.selectedNode.Bounds.Left;
				int dy = p.Y - this.selectedNode.Bounds.Top;

				// Begin dragging image
				if (DragHelper.ImageList_BeginDrag(this.imageListDrag.Handle, 0, dx, dy))
				{
					// Begin dragging
					this.trvSearchLevels.DoDragDrop(bmp, DragDropEffects.Move);
					// End dragging image
					DragHelper.ImageList_EndDrag();
				}
			}
			catch{}
		}
		
		private void trvSearchLevels_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try
			{
				DragHelper.ImageList_DragEnter(this.trvSearchLevels.Handle, e.X - this.trvSearchLevels.Left,
					e.Y - this.trvSearchLevels.Top);

				e.Effect = DragDropEffects.Move;
			}
			catch{}
		}

		private void trvSearchLevels_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try
			{
				// Compute drag position and move image
				Point formP = this.PointToClient(new Point(e.X, e.Y));
				DragHelper.ImageList_DragMove(formP.X - this.trvSearchLevels.Left, 
					formP.Y - this.trvSearchLevels.Top);

				Point  pt = this.trvSearchLevels.PointToClient(new Point(e.X, e.Y));
				TreeNode dropNode = this.trvSearchLevels.GetNodeAt(pt);
				if (dropNode == null)
				{
					e.Effect = DragDropEffects.None;
					return;
				}
		
				e.Effect = DragDropEffects.Move;
				// if mouse is on a new node select it
				DragHelper.ImageList_DragShowNolock(false);
				this.trvSearchLevels.SelectedNode = dropNode;
				DragHelper.ImageList_DragShowNolock(true);

                // Set a constant to define the autoscroll region
                const Single scrollRegion = 20;
                // See where the cursor is
                Point pt1 = this.trvSearchLevels.PointToClient(Cursor.Position);
                // See if we need to scroll up or down
                if ((pt1.Y + scrollRegion) > this.trvSearchLevels.Height)
                {
                    // Call the API to scroll down
                    SendMessage(this.trvSearchLevels.Handle, (int)277, (int)1, 0);
                }
                else if (pt1.Y < (this.trvSearchLevels.Top + scrollRegion))
                {
                    // Call thje API to scroll up
                    SendMessage(this.trvSearchLevels.Handle, (int)277, (int)0, 0);
                }
                this.trvSearchLevels.Update();
			}
			catch{}

		}

		private void trvSearchLevels_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			try
			{
				// Unlock updates
				DragHelper.ImageList_DragLeave(this.trvSearchLevels.Handle);

				Point  pt = new Point(e.X,e.Y);
				pt = trvSearchLevels.PointToClient(pt);
				TreeNode dropNode = trvSearchLevels.GetNodeAt(pt);
				TreeNode dragNode = this.selectedNode;
				if(dropNode ==  dragNode)
					return;
				if (dropNode != null)
				{
					ListItem listItem = dropNode.Tag as ListItem;
					if(listItem.ListItemType == "Level")
					{
						if(selectedNode.Parent != null )
						{
							LRRSearchGroupLevelLink oldll = _lrrSearchGroupLevelLinks.GetLevelLink(GetID(this.selectedNode.Parent),GetID(this.selectedNode));
							if(oldll != null)
							{
								if(oldll.ObjectState == DBOperation.INSERT)
								{
									_lrrSearchGroupLevelLinks.Remove(oldll);
								}
								else
								{
									oldll.ObjectState = DBOperation.DELETE;
								}
							}
							selectedNode.Parent.Nodes.Remove(this.selectedNode);

						
							dropNode.Nodes.Insert(dropNode.Index+1, dragNode);
							LRRSearchGroupLevelLink newll = _lrrSearchGroupLevelLinks.GetLevelLink(GetID(dropNode),GetID(dragNode));
							if(newll != null)
							{
								newll.ObjectState = DBOperation.UNCHANGED;
							}
							else
							{
								newll = new LRRSearchGroupLevelLink();
								newll.ParentID = GetID(dropNode);
								newll.ChildID = GetID(dragNode);
								_lrrSearchGroupLevelLinks.Add(newll);

								//Add the item to SearchGroupLevel if does not exists in the table
								ListItem listItem1 = dragNode.Tag as ListItem;
								LRRSearchGroupLevel srchGroupLvl = _lrrSearchGroupLevels.GetLevelFromID(newll.ChildID);
								if(srchGroupLvl == null)
								{
									LRRSearchGroupLevel lvl = new LRRSearchGroupLevel();
									lvl.LevelID = newll.ChildID;
									lvl.Name = GetName(dragNode);
									lvl.Type = listItem1.ListItemType;
									_lrrSearchGroupLevels.Add(lvl);
								}
							}
						}
					}
					/*
					else
					{
						if(selectedNode.Parent != null && dropNode.Parent != null)
						{
							LRRSearchGroupLevelLink oldll = _lrrSearchGroupLevelLinks.GetLevelLink(GetID(this.selectedNode.Parent),GetID(this.selectedNode));
							if(oldll != null)
							{
								if(oldll.ObjectState == DBOperation.INSERT)
								{
									_lrrSearchGroupLevelLinks.Remove(oldll);
								}
								else
								{
									oldll.ObjectState = DBOperation.DELETE;
								}
							}
						
							if(dropNode.Parent != null)
							{
								selectedNode.Parent.Nodes.Remove(this.selectedNode);
								dropNode.Parent.Nodes.Insert(dropNode.Index+1, dragNode);
								LRRSearchGroupLevelLink newll = _lrrSearchGroupLevelLinks.GetLevelLink(GetID(dropNode.Parent),GetID(dragNode));
								if(newll != null)
									newll.ObjectState = DBOperation.UNCHANGED;
								else
								{
									newll = new LRRSearchGroupLevelLink();
									newll.ParentID = GetID(dropNode.Parent);
									newll.ChildID = GetID(dragNode);
									_lrrSearchGroupLevelLinks.Add(newll);

									//Add the item to SearchGroupLevel if does not exists in the table
									ListItem listItem1 = dragNode.Tag as ListItem;
									LRRSearchGroupLevel srchGroupLvl = _lrrSearchGroupLevels.GetLevelFromID(newll.ChildID);
									if(srchGroupLvl == null)
									{
										LRRSearchGroupLevel lvl = new LRRSearchGroupLevel();
										lvl.LevelID = newll.ChildID;
										lvl.Name = GetName(dragNode);
										lvl.Type = listItem1.ListItemType;
										_lrrSearchGroupLevels.Add(lvl);
									}
								}
							}
						}
					}*/
				}
			}
			catch{}
		}

		private void mnuAdd_Click(object sender, System.EventArgs e)
		{
			TreeNode tn = new TreeNode("");
			tn.ImageIndex = 24;
			tn.SelectedImageIndex = 24;
			if(trvSearchLevels.SelectedNode!=null)
			{
				ListItem listItem = new ListItem();
				listItem.ListItemType = "Level";
				tn.Tag = listItem;
				trvSearchLevels.SelectedNode.Nodes.Add(tn);
				trvSearchLevels.SelectedNode = tn;
				tn.BeginEdit();
			}
		}

		private void mnuInsert_Click(object sender, System.EventArgs e)
		{
			TreeNode trvSelectedNode = trvSearchLevels.SelectedNode;
			if(trvSelectedNode!=null)
			{
				int iSelIndex = trvSelectedNode.Index;
				TreeNode trvNode = new TreeNode("");
				trvNode.ImageIndex = 24;
				trvNode.SelectedImageIndex = 24;

				if(trvSelectedNode.Parent != null)
				{
					TreeNode trvParentNode = trvSelectedNode.Parent;
					ListItem listItem = new ListItem();
					listItem.ListItemType = "Level";
					trvNode.Tag = listItem;
					trvParentNode.Nodes.Insert(iSelIndex,trvNode);
					trvSearchLevels.SelectedNode = trvNode;
					trvNode.BeginEdit();
				}
			}
		}

		private void mnuRename_Click(object sender, System.EventArgs e)
		{
			if(trvSearchLevels.SelectedNode!=null)
				trvSearchLevels.SelectedNode.BeginEdit();
		}

		private void trvSearchLevels_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			if(e.Label == null || e.Label.Trim() =="")
			{
				if(e.Node.Text.Trim() == "")
				{

					LRRMessagBox.ShowMessage("SID_TREENODELEBEL_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					e.Node.BeginEdit();
				}
			}
			else if(e.Label.Length > 0)
			{
				/*if(_lrrLevels.FindLevelByLevelName(e.Label.ToString().ToUpper()) == true)
				{
					//MessageBox.Show("Level already Exists:");
					LRRMessagBox.ShowMessage("SID_LEVEL_DUPLICATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					e.CancelEdit = true;
					e.Node.BeginEdit();  
				}
				else*/ if(e.Label.IndexOfAny(new char[]{'@','.', ',', '!'}) != -1)
					   {
						   /* Cancel the label edit action, inform the user, and 
							   place the node in edit mode again. */
						   //						MessageBox.Show("Invalid tree node label.\n" + 
						   //							"The invalid characters are: '@','.', ',', '!'", 
						   //							"Node Label Edit");
						   LRRMessagBox.ShowMessage("SID_TREENODE_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						   e.CancelEdit = true;
						   e.Node.BeginEdit();
					   }
					   else
					   {
						   ListItem listItem = e.Node.Tag as ListItem;
						   LRRSearchGroupLevel lvl =listItem.ListItemObject as LRRSearchGroupLevel;
						   
						   if(_lrrSearchGroupLevels.Contains(lvl))
						   {
							   lvl.Name = e.Label;
							   lvl.Type = "Level";
							   //LRRSearchGroupLevels toCommitLevels = _lrrSearchGroupLevels.GetChanges();
							   //_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
							   //_lrrSearchGroupLevels.RefreshCollection();

//							   LRRSearchGroupLevelLink lvlLink = new LRRSearchGroupLevelLink();
//							   lvlLink.ChildID = GetID(e.Node);
//							   lvlLink.ParentID = GetID(e.Node.Parent);
//							   _lrrSearchGroupLevelLinks.Add(lvlLink);

						   }
						   else
						   {
							   AddToCollection(e.Node, e.Label);
						   }
					   }
			}
			else if(e.Label.Length == 0)
			{
				LRRMessagBox.ShowMessage("SID_TREENODELEBEL_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
			}
		}

		
		private void trvSearchLevels_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			TreeNode selNode = e.Node;
			this.SelectedItemObj = selNode.Tag as ListItem;
		}

		private void trvSearchLevels_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Point  pt = new Point(e.X,e.Y);
			TreeNode node = trvSearchLevels.GetNodeAt(pt);
			if(node != null)
				trvSearchLevels.SelectedNode = node;
		}
		private void trvSearchLevels_BeforeLabelEdit(object sender, NodeLabelEditEventArgs e)
		{
			ListItem lvllistItem = e.Node.Tag as ListItem;
			if(lvllistItem == null)
			{
				e.CancelEdit = true;
				return;
			}
			LRRSearchGroupLevel lvlLevel = lvllistItem.ListItemObject as LRRSearchGroupLevel;
			if(lvlLevel != null && lvlLevel.LevelID == "0")
			{
				e.CancelEdit = true;
				return;
			}
			if(lvllistItem.ListItemType != "Level")
			{
				e.CancelEdit = true;
				return;
			}
		}

		private void trvSearchLevels_GiveFeedback(object sender, GiveFeedbackEventArgs e)
		{
			try
			{
				if(e.Effect == DragDropEffects.Move) 
				{
					// Show pointer cursor while dragging
					e.UseDefaultCursors = false;
					this.trvSearchLevels.Cursor = Cursors.Default;
				}
				else e.UseDefaultCursors = true;
			}
			catch{}
		}
		
		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			//Set to Previous State
			for(int i=0; i < _arrRestorePrevStateList.Count;i++)
			{
				ListItem listItem = _arrRestorePrevStateList[i] as ListItem;
				BaseObject baseObj = GetObject(listItem);
				if(baseObj != null)
				{
					baseObj.IsSelected = listItem.PrevState;
				}
			}
		}
		#endregion

        #region Public Methods
        /// <summary>
        /// Method opens the specified view
        /// </summary>
        /// <param name="viewID"></param>
        /// <param name="keyID"></param>
        public void OpenViews(int viewID,string keyID)
        {
            switch(viewID)
			{
               case 1:
                    LRRSavedView  lrrSavedView = LRRModel.SavedViews.GetSavedViewFromID(keyID);
					OpenGraphics(lrrSavedView);
					break;
				case 2:
                    LRRSearchCriteria  lrrSrchCriteria = _lrrSearchCriterias.GetSearchCriteriaByID(keyID);
					OpenQuery(lrrSrchCriteria);
					break;
				case 3:
					LRRCompositeView  lrrCompView = _lrrCompositeViews.GetCompositeViewFromID(keyID);
					OpenCompositeView(lrrCompView);
					break;
				case 4:
					LRRExcelView  lrrExcelView = _lrrExcelViews.GetExcelViewFromID(keyID);
					OpenExcelView(lrrExcelView);
					break;
				case 5 :
					LRRUnifiedViewSearchCrtiteria  lrrUnifiedView = _lrrUnifiedSrchCriterias.GetUnifiedViewByID(keyID);
					OpenUnifiedView(lrrUnifiedView);
					break;
				case 6:
					LRRMultiAttributeTrendInfo lrrMultiTrend = _multiTrendInfos.GetMultiTrendFromID(keyID);
					OpenMultiTrend(lrrMultiTrend);
					break;
				default :
					break;
			}
        }
        #endregion

        private void trvSearchLevels_MouseHover(object sender, EventArgs e)
        {
            
        }

        private void trvSearchLevels_NodeMouseHover(object sender, TreeNodeMouseHoverEventArgs e)
        {
            /*string toolTip = "";
            TreeNode tn = e.Node as TreeNode;
            Symcon.LightRidge.PEAdvisor.ScreenManagement.ListItem listItem = tn.Tag as Symcon.LightRidge.PEAdvisor.ScreenManagement.ListItem;
            if (listItem.ListItemType == "UnifiedView")
            {
                LRRUnifiedViewSearchCrtiteria uvSearchCriteria = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
                toolTip = uvSearchCriteria.Description + " \n " + uvSearchCriteria.TimeID;  
            }
            if (listItem.ListItemType == "Query")
            {
                LRRSearchCriteria searchCriteria = listItem.ListItemObject as LRRSearchCriteria;
                toolTip = searchCriteria.Description + " \n " + searchCriteria.TimeID;  
            }
            if (listItem.ListItemType == "Graphics")
            {
                LRRSavedView savedView = listItem.ListItemObject as LRRSavedView;
                toolTip = savedView.SavedViewDescription + " \n " + savedView.TimeID;  
            }
            if (listItem.ListItemType == "CompositeViews")
            {
                LRRCompositeView viewObj = listItem.ListItemObject as LRRCompositeView;
                toolTip = viewObj.Description + "/n" + viewObj.TimeID;
            }
            e.Node.ToolTipText = toolTip;*/
        }

        private void trvSearchLevels_MouseMove(object sender, MouseEventArgs e)
        {
            TreeNode tn = this.trvSearchLevels.GetNodeAt(e.X, e.Y);
            string toolTip = "";
            if (tn != null)
            {
                Symcon.LightRidge.PEAdvisor.ScreenManagement.ListItem listItem = tn.Tag as Symcon.LightRidge.PEAdvisor.ScreenManagement.ListItem;
                if (listItem.ListItemType == "UnifiedView")
                {
                    LRRUnifiedViewSearchCrtiteria uvSearchCriteria = listItem.ListItemObject as LRRUnifiedViewSearchCrtiteria;
                    string desc = uvSearchCriteria.Description;
                    if (String.IsNullOrEmpty(desc))
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + uvSearchCriteria.TimeID;
                    }
                    else
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_DESCRIPTION") + " : " + uvSearchCriteria.Description + " \n" + LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + uvSearchCriteria.TimeID;
                    }
                }
                if (listItem.ListItemType == "Query")
                {
                    LRRSearchCriteria searchCriteria = listItem.ListItemObject as LRRSearchCriteria;
                    string desc = searchCriteria.Description;
                    if (String.IsNullOrEmpty(desc))
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + searchCriteria.TimeID;
                    }
                    else
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_DESCRIPTION")+" : "+searchCriteria.Description + " \n" + LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + searchCriteria.TimeID;
                    }
                }
                if (listItem.ListItemType == "Graphics")
                {
                    LRRSavedView savedView = listItem.ListItemObject as LRRSavedView;
                    string desc = savedView.SavedViewDescription;
                    if (String.IsNullOrEmpty(desc))
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + savedView.TimeID;
                    }
                    else
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_DESCRIPTION") + " : " + savedView.SavedViewDescription + " \n" + LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + savedView.TimeID;
                    }
                }
                if (listItem.ListItemType == "CompositeViews")
                {
                    LRRCompositeView viewObj = listItem.ListItemObject as LRRCompositeView;
                    string desc = viewObj.Description;
                    if (String.IsNullOrEmpty(desc))
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + viewObj.TimeID;
                    }
                    else
                    {
                        toolTip = LRRHeaderText.GetHeaderString("SID_DESCRIPTION") + " : " + viewObj.Description + " \n" + LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + viewObj.TimeID;
                    }
                }
                tn.ToolTipText = toolTip;
            }
        }
    }
}
