using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor.SharingPermissions
{
	/// <summary>
	/// Summary description for AddUserForm.
	/// </summary>
	public class AddUserForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblUser;
		private System.Windows.Forms.Panel pnlUsers;
		private System.Windows.Forms.ListView listViewUsers;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.ColumnHeader colHeaderUsers;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AddUserForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			BindListViewUsers();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AddUserForm));
			this.lblUser = new System.Windows.Forms.Label();
			this.pnlUsers = new System.Windows.Forms.Panel();
			this.listViewUsers = new System.Windows.Forms.ListView();
			this.colHeaderUsers = new System.Windows.Forms.ColumnHeader();
			this.panel1 = new System.Windows.Forms.Panel();
			this.btnOk = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.pnlUsers.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblUser
			// 
			this.lblUser.Location = new System.Drawing.Point(8, 8);
			this.lblUser.Name = "lblUser";
			this.lblUser.Size = new System.Drawing.Size(100, 16);
			this.lblUser.TabIndex = 0;
			this.lblUser.Tag = "SID_SELECT_USER";
			// 
			// pnlUsers
			// 
			this.pnlUsers.Controls.Add(this.listViewUsers);
			this.pnlUsers.Location = new System.Drawing.Point(8, 32);
			this.pnlUsers.Name = "pnlUsers";
			this.pnlUsers.Size = new System.Drawing.Size(392, 144);
			this.pnlUsers.TabIndex = 2;
			// 
			// listViewUsers
			// 
			this.listViewUsers.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							this.colHeaderUsers});
			this.listViewUsers.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listViewUsers.Location = new System.Drawing.Point(0, 0);
			this.listViewUsers.Name = "listViewUsers";
			this.listViewUsers.Size = new System.Drawing.Size(392, 144);
			this.listViewUsers.TabIndex = 1;
			this.listViewUsers.View = System.Windows.Forms.View.SmallIcon;
			// 
			// colHeaderUsers
			// 
			this.colHeaderUsers.Width = 388;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnOk);
			this.panel1.Controls.Add(this.btnCancel);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 180);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(408, 40);
			this.panel1.TabIndex = 3;
			// 
			// btnOk
			// 
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.Location = new System.Drawing.Point(248, 8);
			this.btnOk.Name = "btnOk";
			this.btnOk.TabIndex = 1;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(328, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 0;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// AddUserForm
			// 
			this.AcceptButton = this.btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(408, 220);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.pnlUsers);
			this.Controls.Add(this.lblUser);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AddUserForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_ADD_USER";
			this.pnlUsers.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		
		#region EventHandlers
		private void btnOk_Click(object sender, System.EventArgs e)
		{
			if(this.listViewUsers.SelectedItems.Count > 0)
			{
				this.SelectedUser = this.listViewUsers.SelectedItems[0].Tag as LRRLogin;
			}
		}
		#endregion

		#region Private Methods
		private void BindListViewUsers()
		{
			this.listViewUsers.SmallImageList = this._lrrApp.MainFrame.ImageList3;
			this.listViewUsers.ArrangeIcons(ListViewAlignment.Top);
			IEnumerator iEnum = _lrrLogins.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRLogin lrrLogin = iEnum.Current as LRRLogin;
				if(lrrLogin.UserID != this._lrrApp.DBManagerObj.AccessControlModel.UserID)
				{
					ListViewItem lvItem = new ListViewItem(lrrLogin.UserName,66);
					lvItem.Tag = lrrLogin;
					this.listViewUsers.Items.Add(lvItem);
				}
			}
		}

		private void InitDataSource()
		{
			if(_lrrLogins != null)
				_lrrLogins.Clear();

			_lrrLogins = new LRRLogins();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLogins);
		}
		#endregion

		#region Fields
		private LRRApp _lrrApp; //...App Object
		private LRRLogins _lrrLogins; //....Login BO
		private LRRLogin _selectedUser;
		#endregion

		#region Properties
		public LRRLogin SelectedUser
		{
			get{ return _selectedUser;}
			set
			{
				_selectedUser = value;
			}
		}
		#endregion
	}
}
