using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
namespace Symcon.LightRidge.PEAdvisor.TestAutomation
{
	/// <summary>
	/// Summary description for TestResult.
	/// </summary>
	public class TestResult : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel pnlMain;
		private System.Windows.Forms.Label lblResults;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label lblFail;
		private System.Windows.Forms.Label lblPass;
		private System.Windows.Forms.Label lblTotal;
		private System.Windows.Forms.Label label1;
		private XmlDocument  oXML = new XmlDocument();
		public TestResult()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		public TestResult(XmlDocument  oResultXML)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			oXML = oResultXML;
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		/// <summary>
		/// This method is invoked to render the treeview control
		/// </summary>
		private void RenderTreeView()
		{
			treeView1.SuspendLayout();
			treeView1.Sorted = true;
			treeView1.Nodes.Clear();
			int[] folders =	new	int[1];
			folders[0] = 0;
			int[] leaf = new int[1];
			leaf[0]	= 1;
			TreeNode tnav = new TreeNode();
			tnav.Tag = oXML.DocumentElement;
			tnav.Text = oXML.DocumentElement.Name;
			tnav.Expand();
			DisplayTree(oXML.DocumentElement,tnav);
			treeView1.Nodes.Add(tnav);
			treeView1.ResumeLayout(true);
		}
		
		
		/// <summary>
		/// This method is used for rendering the tree view control for the loaded test scenarios XML
		/// </summary>
		/// <param name="node"></param>
		/// <param name="tnav"></param>
		private void DisplayTree(XmlNode node,TreeNode tnav)
		{

			if (node.HasChildNodes)
			{
				node = node.FirstChild;
				
				while (node != null)
				{
					TreeNode child = new TreeNode();
					child.Tag = node;
					if(node.Name == "BatchTestCase")
					{
						if(node.ChildNodes.Count >0)
							child.Text = node.Name + "[" + node.ChildNodes.Item(0).InnerText  + "]";
						else
							child.Text = node.Name;

						DisplayTree(node,child);
					}
					else
					{
						if(node.SelectSingleNode("Status") != null)
						{
							if(node.SelectSingleNode("Status").InnerText.ToUpper() == "FAILED")
							{
								child.ForeColor = Color.Red;
							}
							if(node.SelectSingleNode("Status").InnerText.ToUpper() == "PASSED")
							{
								child.ForeColor = Color.Green;
							}
							if(node.ChildNodes.Count >0)
								child.Text = node.ChildNodes.Item(0).InnerText + "[" + node.SelectSingleNode("Status").InnerText + "]";
							else
								child.Text = node.Name;
						}
						else
						{
							if(node.ChildNodes.Count >0)
								child.Text = node.Name + "[" + node.ChildNodes.Item(0).InnerText  + "]";
							else
								child.Text = node.Name;

							DisplayTree(node,child);
						}
					}
					
					//DisplayTree(node,child);
					tnav.Nodes.Add(child);
					node = node.NextSibling;
				}
				
			}
		}
		
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pnlMain = new System.Windows.Forms.Panel();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.lblResults = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.lblFail = new System.Windows.Forms.Label();
			this.lblPass = new System.Windows.Forms.Label();
			this.lblTotal = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.pnlMain.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlMain
			// 
			this.pnlMain.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.pnlMain.Controls.Add(this.panel1);
			this.pnlMain.Controls.Add(this.splitter2);
			this.pnlMain.Controls.Add(this.treeView1);
			this.pnlMain.Controls.Add(this.splitter1);
			this.pnlMain.Controls.Add(this.lblResults);
			this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMain.Location = new System.Drawing.Point(0, 0);
			this.pnlMain.Name = "pnlMain";
			this.pnlMain.Size = new System.Drawing.Size(736, 502);
			this.pnlMain.TabIndex = 0;
			// 
			// splitter2
			// 
			this.splitter2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splitter2.Location = new System.Drawing.Point(280, 42);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(2, 460);
			this.splitter2.TabIndex = 3;
			this.splitter2.TabStop = false;
			// 
			// treeView1
			// 
			this.treeView1.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.treeView1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Left;
			this.treeView1.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.treeView1.ForeColor = System.Drawing.Color.RoyalBlue;
			this.treeView1.ImageIndex = -1;
			this.treeView1.Location = new System.Drawing.Point(0, 42);
			this.treeView1.Name = "treeView1";
			this.treeView1.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
																				  new System.Windows.Forms.TreeNode("Test Result")});
			this.treeView1.SelectedImageIndex = -1;
			this.treeView1.Size = new System.Drawing.Size(280, 460);
			this.treeView1.TabIndex = 2;
			// 
			// splitter1
			// 
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 40);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(736, 2);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// lblResults
			// 
			this.lblResults.BackColor = System.Drawing.SystemColors.Desktop;
			this.lblResults.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblResults.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblResults.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblResults.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.lblResults.Location = new System.Drawing.Point(0, 0);
			this.lblResults.Name = "lblResults";
			this.lblResults.Size = new System.Drawing.Size(736, 40);
			this.lblResults.TabIndex = 0;
			this.lblResults.Text = "Test Execution Result(s)";
			this.lblResults.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel1.Controls.Add(this.lblFail);
			this.panel1.Controls.Add(this.lblPass);
			this.panel1.Controls.Add(this.lblTotal);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(282, 42);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(454, 460);
			this.panel1.TabIndex = 8;
			// 
			// lblFail
			// 
			this.lblFail.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.lblFail.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblFail.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblFail.Location = new System.Drawing.Point(0, 110);
			this.lblFail.Name = "lblFail";
			this.lblFail.Size = new System.Drawing.Size(452, 32);
			this.lblFail.TabIndex = 11;
			this.lblFail.Text = "    Total Failed: ";
			// 
			// lblPass
			// 
			this.lblPass.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.lblPass.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblPass.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblPass.Location = new System.Drawing.Point(0, 78);
			this.lblPass.Name = "lblPass";
			this.lblPass.Size = new System.Drawing.Size(452, 32);
			this.lblPass.TabIndex = 10;
			this.lblPass.Text = "    Total Passed: ";
			// 
			// lblTotal
			// 
			this.lblTotal.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.lblTotal.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblTotal.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTotal.Location = new System.Drawing.Point(0, 46);
			this.lblTotal.Name = "lblTotal";
			this.lblTotal.Size = new System.Drawing.Size(452, 32);
			this.lblTotal.TabIndex = 9;
			this.lblTotal.Text = "    Total Executed : ";
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.label1.Dock = System.Windows.Forms.DockStyle.Top;
			this.label1.Font = new System.Drawing.Font("Arial", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Brown;
			this.label1.Location = new System.Drawing.Point(0, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(452, 46);
			this.label1.TabIndex = 8;
			this.label1.Text = "Summary";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// TestResult
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(736, 502);
			this.Controls.Add(this.pnlMain);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Name = "TestResult";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "TestResult";
			this.Load += new System.EventHandler(this.TestResult_Load);
			this.pnlMain.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void TestResult_Load(object sender, System.EventArgs e)
		{
			RenderTreeView();
			lblTotal.Text = lblTotal.Text + " " + oXML.SelectNodes("//TestCase[Status!='Not Evaluated']").Count.ToString();
			lblPass.Text = lblPass.Text + " " + oXML.SelectNodes("//TestCase[Status='Passed']").Count.ToString();
			lblFail.Text = lblFail.Text + " " + oXML.SelectNodes("//TestCase[Status='Failed']").Count.ToString();

			treeView1.ExpandAll();
		}
	}
}
