using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for Trend.
	/// </summary>
	public class TrendGrouped : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TrendGrouped()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.Text = LRRHeaderText.GetHeaderString(this.Text);
			btnApply.Text = LRRHeaderText.GetHeaderString(btnApply.Text);
			chkLogLinear.Text = LRRHeaderText.GetHeaderString(chkLogLinear.Text);
			chkXRange.Text = LRRHeaderText.GetHeaderString(chkXRange.Text);

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			(_ucGroupedTrend as Control).Dock = DockStyle.Fill;
			this.Controls.Clear();
			this.Controls.Add(_ucGroupedTrend as Control);
			this.Controls.Add(panel1);
			//_lrrApp.RunControllerObj.RunCycleCompleted+=new EventHandler(RunControllerObj_RunCycleCompleted);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			//_lrrApp.RunControllerObj.RunCycleCompleted -= new EventHandler(RunControllerObj_RunCycleCompleted);
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Trend));
			this.panel1 = new System.Windows.Forms.Panel();
			this.chkXRange = new System.Windows.Forms.CheckBox();
			this.btnApply = new System.Windows.Forms.Button();
			this.lblDiv = new System.Windows.Forms.Label();
			this.dtpEnd = new System.Windows.Forms.DateTimePicker();
			this.dtpStart = new System.Windows.Forms.DateTimePicker();
			this.chkLogLinear = new System.Windows.Forms.CheckBox();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Controls.Add(this.chkXRange);
			this.panel1.Controls.Add(this.btnApply);
			this.panel1.Controls.Add(this.lblDiv);
			this.panel1.Controls.Add(this.dtpEnd);
			this.panel1.Controls.Add(this.dtpStart);
			this.panel1.Controls.Add(this.chkLogLinear);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(528, 40);
			this.panel1.TabIndex = 0;
			// 
			// chkXRange
			// 
			this.chkXRange.Location = new System.Drawing.Point(96, 10);
			this.chkXRange.Name = "chkXRange";
			this.chkXRange.Size = new System.Drawing.Size(72, 24);
			this.chkXRange.TabIndex = 6;
			this.chkXRange.Text = "SID_X_RANGE";
			this.chkXRange.CheckedChanged += new System.EventHandler(this.chkXRange_CheckedChanged);
			// 
			// btnApply
			// 
			this.btnApply.Enabled = false;
			this.btnApply.Location = new System.Drawing.Point(472, 8);
			this.btnApply.Name = "btnApply";
			this.btnApply.Size = new System.Drawing.Size(48, 23);
			this.btnApply.TabIndex = 5;
			this.btnApply.Text = "SID_APPLY";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// lblDiv
			// 
			this.lblDiv.Location = new System.Drawing.Point(312, 16);
			this.lblDiv.Name = "lblDiv";
			this.lblDiv.Size = new System.Drawing.Size(8, 23);
			this.lblDiv.TabIndex = 4;
			this.lblDiv.Text = "-";
			// 
			// dtpEnd
			// 
			this.dtpEnd.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.dtpEnd.Enabled = false;
			this.dtpEnd.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpEnd.Location = new System.Drawing.Point(321, 12);
			this.dtpEnd.Name = "dtpEnd";
			this.dtpEnd.Size = new System.Drawing.Size(136, 20);
			this.dtpEnd.TabIndex = 2;
			this.dtpEnd.ValueChanged += new System.EventHandler(this.dtpEnd_ValueChanged);
			// 
			// dtpStart
			// 
			this.dtpStart.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.dtpStart.Enabled = false;
			this.dtpStart.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpStart.Location = new System.Drawing.Point(175, 12);
			this.dtpStart.Name = "dtpStart";
			this.dtpStart.Size = new System.Drawing.Size(136, 20);
			this.dtpStart.TabIndex = 1;
			this.dtpStart.ValueChanged += new System.EventHandler(this.dtpStart_ValueChanged);
			// 
			// chkLogLinear
			// 
			this.chkLogLinear.Checked = true;
			this.chkLogLinear.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkLogLinear.Location = new System.Drawing.Point(8, 8);
			this.chkLogLinear.Name = "chkLogLinear";
			this.chkLogLinear.Size = new System.Drawing.Size(80, 24);
			this.chkLogLinear.TabIndex = 0;
            this.chkLogLinear.Text = "SID_SPLIT_SCALE";
			this.chkLogLinear.CheckedChanged += new System.EventHandler(this.chkLogLinear_CheckedChanged);
			// 
			// Trend
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 466);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Trend";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "SID_TREND";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		private LRRApp _lrrApp;
		UserControls.IGroupedTrend _ucGroupedTrend = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlGroupedTrendLog();
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.CheckBox chkLogLinear;
		public bool _hasError = false;
		private IPropertyValue _iPropValue;
		private System.Windows.Forms.DateTimePicker dtpStart;
		private System.Windows.Forms.DateTimePicker dtpEnd;
		private System.Windows.Forms.Label lblDiv;
		private System.Windows.Forms.Button btnApply;
		private string _currentUOM;
		private System.Windows.Forms.CheckBox chkXRange;
		private ToolTip _toolTip = new ToolTip();
		private string _trendScheme = null;

		#endregion

		#region Public Methods

		public bool IsTrendUOMChanged(string trendScheme,IPropertyValue iPropValue, string currentUOM)
		{
			if(_ucGroupedTrend != null)
			{
				bool check = _ucGroupedTrend.IsTrendUOMChanged(trendScheme,iPropValue,currentUOM);
				if(check)
				{
					_currentUOM = currentUOM;
					return true;
				}
			}
			return false;
		}

		public void LoadChart(string trendScheme,IPropertyValue iPropValue, string currentUOM)
		{
			_trendScheme = trendScheme;
			_iPropValue = iPropValue;
			_currentUOM = currentUOM;
			try
			{
				_ucGroupedTrend.InitTrend(trendScheme,iPropValue, currentUOM);
				
				if(_ucGroupedTrend.ErrorMsg != "")
				{
					_hasError = true;
					MessageBox.Show(_ucGroupedTrend.ErrorMsg);
				}
				else
				{
					_hasError = false;
					this.Owner = _ucGroupedTrend.FormOwner;
				}

				if(!_ucGroupedTrend.IsDateInitialized)
				{
					
					this.dtpStart.MinDate = _ucGroupedTrend.StartTime;
					this.dtpStart.MaxDate = _ucGroupedTrend.EndTime.AddMinutes(-1);
					this.dtpStart.Value = _ucGroupedTrend.StartTime;
					
					this.dtpEnd.MinDate = _ucGroupedTrend.StartTime.AddHours(1);
					this.dtpEnd.MaxDate = _ucGroupedTrend.EndTime;
					this.dtpEnd.Value = _ucGroupedTrend.EndTime;

					_toolTip.SetToolTip(dtpStart,LRRHeaderText.GetHeaderString("SID_MIN") + ":" + dtpStart.MinDate.ToString(dtpStart.CustomFormat) + " " + LRRHeaderText.GetHeaderString("SID_MAX") + ":" + dtpStart.MaxDate.ToString(dtpStart.CustomFormat));
				}
				else
				{
					btnApply_Click(null,null);
				}

				
			}
			catch
			{
			
			}
		}
		#endregion

		private void chkLogLinear_CheckedChanged(object sender, System.EventArgs e)
		{
			bool check = _ucGroupedTrend.IsDateInitialized;
			if(chkLogLinear.Checked)
			{
				this.Controls.Clear();
				_ucGroupedTrend = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlGroupedTrendLog();
				_ucGroupedTrend.IsDateInitialized = check;
				LoadChart(_trendScheme,_iPropValue,_currentUOM);
				(_ucGroupedTrend as Control).Dock = DockStyle.Fill;
				this.Controls.Add(_ucGroupedTrend as Control);
				this.Controls.Add(panel1);
			}
			else
			{
				this.Controls.Clear();
				_ucGroupedTrend = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlGroupedTrend();
				_ucGroupedTrend.IsDateInitialized = check;
				LoadChart(_trendScheme,_iPropValue,_currentUOM);
				(_ucGroupedTrend as Control).Dock = DockStyle.Fill;
				this.Controls.Add(_ucGroupedTrend as Control);
				this.Controls.Add(panel1);
			}
		}

		private void dtpStart_ValueChanged(object sender, System.EventArgs e)
		{
			try
			{
				if(dtpEnd.MaxDate >= dtpStart.Value.AddHours(1))
					dtpEnd.MinDate = dtpStart.Value.AddHours(1);
			}
			catch
			{
			}
			_toolTip.SetToolTip(dtpEnd,LRRHeaderText.GetHeaderString("SID_MIN") + ":" + dtpEnd.MinDate.ToString(dtpEnd.CustomFormat) + " " + LRRHeaderText.GetHeaderString("SID_MAX") + ":" + dtpEnd.MaxDate.ToString(dtpEnd.CustomFormat));
		}

		private void btnApply_Click(object sender, System.EventArgs e)
		{
			try
			{
				this.dtpStart.MinDate = _ucGroupedTrend.ActualStartTime;
				this.dtpStart.MaxDate = _ucGroupedTrend.ActualEndTime.AddHours(-1);
				if(dtpStart.Value < _ucGroupedTrend.ActualStartTime || dtpStart.Value > _ucGroupedTrend.ActualEndTime)
					dtpStart.Value = _ucGroupedTrend.ActualStartTime;
			
				if(_ucGroupedTrend.ActualStartTime.AddHours(1)>this.dtpStart.Value)
					this.dtpEnd.MinDate = _ucGroupedTrend.ActualStartTime.AddHours(1);
			
				this.dtpEnd.MaxDate = _ucGroupedTrend.ActualEndTime;
			}
			catch
			{

			}
			if(dtpStart.Value < dtpEnd.Value)
			{
				_ucGroupedTrend.StartTime = dtpStart.Value;
				_ucGroupedTrend.EndTime = dtpEnd.Value;
				_ucGroupedTrend.AdjustXScale(_trendScheme);
			}
		}

		private void dtpEnd_ValueChanged(object sender, System.EventArgs e)
		{
			_toolTip.SetToolTip(dtpEnd,LRRHeaderText.GetHeaderString("SID_MIN") + ":" + dtpEnd.MinDate.ToString(dtpEnd.CustomFormat) + " " + LRRHeaderText.GetHeaderString("SID_MAX") + ":" + dtpEnd.MaxDate.ToString(dtpEnd.CustomFormat));
		}

		private void chkXRange_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkXRange.Checked)
			{
				dtpStart.Enabled = dtpEnd.Enabled = btnApply.Enabled = true;
				_ucGroupedTrend.IsDateInitialized = true;
			}
			else
			{
				dtpStart.Value = dtpStart.MinDate;
				dtpEnd.Value = dtpEnd.MaxDate;
				dtpStart.Enabled = dtpEnd.Enabled = btnApply.Enabled = false;
				_ucGroupedTrend.IsDateInitialized = false;
				LoadChart(_trendScheme,_iPropValue,_currentUOM);
			}
		}

		private void RunControllerObj_RunCycleCompleted(object sender, EventArgs e)
		{
			RefreshTrendDel refTrendDel = new RefreshTrendDel(RefreshTrend);
			_lrrApp.MainFrame.BeginInvoke(refTrendDel);
		}

		private delegate void RefreshTrendDel();
		private void RefreshTrend()
		{
			bool check = _ucGroupedTrend.IsDateInitialized;
			if(chkLogLinear.Checked)
			{
				
				_ucGroupedTrend = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlGroupedTrendLog();
				_ucGroupedTrend.IsDateInitialized = check;
				LoadChart(_trendScheme,_iPropValue,_currentUOM);
				(_ucGroupedTrend as Control).Dock = DockStyle.Fill;
				this.Controls.Clear();
				this.Controls.Add(_ucGroupedTrend as Control);
				this.Controls.Add(panel1);
			}
			else
			{
				
				_ucGroupedTrend = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlGroupedTrend();
				_ucGroupedTrend.IsDateInitialized = check;
				LoadChart(_trendScheme,_iPropValue,_currentUOM);
				(_ucGroupedTrend as Control).Dock = DockStyle.Fill;
				this.Controls.Clear();
				this.Controls.Add(_ucGroupedTrend as Control);
				this.Controls.Add(panel1);
			}
		}
	}
}
