using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher; 

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for UsageWindow.
	/// </summary>
	public class UsageWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUsageValues;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UsageWindow(LRRIndicesXRef selectedXRef)
		{
			//
			// Required for Windows Form Designer support
			//
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_indicesXRef = selectedXRef;
			_lrrIndicesUsages = LRRModel.IndicesUsages.GetUsagesFromIndexRefID(selectedXRef.ID);
			_lrrUOMTypes = new LRRUOMTypes();
			BindGrid();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(UsageWindow));
			this.panel1 = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			this.gridUsageValues = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridUsageValues)).BeginInit();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.btnCancel);
			this.panel1.Controls.Add(this.btnOK);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 342);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(560, 40);
			this.panel1.TabIndex = 0;
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(472, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(376, 8);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 0;
			this.btnOK.Tag = "SID_OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// gridUsageValues
			// 
			this.gridUsageValues.BackColor = System.Drawing.SystemColors.Window;
			this.gridUsageValues.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUsageValues.Location = new System.Drawing.Point(0, 0);
			this.gridUsageValues.Name = "gridUsageValues";
			this.gridUsageValues.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUsageValues.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUsageValues.NestedTableGroupOptions.ShowColumnHeaders = true;
			this.gridUsageValues.Size = new System.Drawing.Size(560, 342);
			this.gridUsageValues.TabIndex = 1;
			this.gridUsageValues.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any;
			this.gridUsageValues.Text = "gridGroupingControl1";
			this.gridUsageValues.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUsageValues.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUsageValues.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUsageValues.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUsageValues.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUsageValues.VersionInfo = "3.301.0.0";
			this.gridUsageValues.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridUsageValues_RecordDeleting);
			this.gridUsageValues.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridUsageValues_TableControlCurrentCellShowingDropDown);
			// 
			// UsageWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 382);
			this.Controls.Add(this.gridUsageValues);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "UsageWindow";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_USAGE_PARAMETER";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.UsageWindow_Closing);
			this.Load += new System.EventHandler(this.UsageWindow_Load);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridUsageValues)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		private void BindGrid()
		{
			//Suspend the Layout of the Grid...
			gridUsageValues.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridUsageValues);
			gridUsageValues.DataSource = null;
			gridUsageValues.TableDescriptor.Relations.Clear();
			Dictionary<string, SymForeignKeyFieldAttribute> fkColumns = new Dictionary<string,SymForeignKeyFieldAttribute>();
			Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrIndicesUsages.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			
			//Populate the columns for the grid object
			//			_siteComponentsList.SortColumn="Name";
			//			_siteComponentsList.Sort();
			SyncGridUtilities.InitializeGridColumns(gridUsageValues,_lrrIndicesUsages.ItemType ,null,fkData);

			gridUsageValues.Engine.SourceListSet.Add("ParentTable",_lrrIndicesUsages);
			//gridUsageValues.TableModel.CellModels.Remove("EllipsisText");
			//gridUsageValues.TableModel.CellModels.Add("EllipsisText",new EllipsisCellModel(gridUsageValues.TableModel.Model));

//			gridUsageValues.TableDescriptor.Columns.Clear();		
			//gridUnBoundSiteItem.WireGrid(gridUsageValues);
			gridUsageValues.DataSource = _lrrIndicesUsages;

//			gridUsageValues.TableDescriptor.Columns.Add("UsageParameter","UsageParameter");
//			gridUsageValues.TableDescriptor.Columns.Add("Description","Description");
//			gridUsageValues.TableDescriptor.Columns.Add("Usage","UsageValue");
//			gridUsageValues.TableDescriptor.Columns.Add("UOMType","UOMType");
//			gridUsageValues.TableDescriptor.Columns.Add("UOM","UOM");

			Hashtable RelativeWidths = new Hashtable();
			RelativeWidths.Add("Name",20);
			RelativeWidths.Add("Description",30);
			RelativeWidths.Add("Usage",20);
			RelativeWidths.Add("UOMType",20);
			RelativeWidths.Add("UOM",20);
			SyncGridUtilities.InitializeGridColumnsWidth(gridUsageValues,RelativeWidths );
			//gridUsageValues.TableDescriptor.Columns["UOMType"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
			//gridUsageValues.TableDescriptor.Columns["UOMType"]
			//gridUsageValues.TableDescriptor.Columns["UOMType"].AllowFilter = true; 

			//gridUsageValues.TableDescriptor.Columns["Usage"].Appearance.AnyRecordFieldCell.CellType = "EllipsisText";


			//Set the data store 
			

			

			//gridUsageValues.TableDescriptor.AllowEdit = true;
			//gridUsageValues.TableDescriptor.AllowNew = false;
		//	gridUsageValues.TableDescriptor.Columns["Name"].ReadOnly=true;
			//		gridUsageValues.TableOptions.AllowSortColumns = false;

			//Resume the Layout of the Grid...
			gridUsageValues.ResumeLayout(false);
		}
		private void InitializeDataSource()
		{
			

		}
		#region fields
	
		private LRRIndicesUsages			_lrrIndicesUsages = null;
		private LRRIndicesXRef				_indicesXRef = null;
		private IndicesConfiguration					_indConfig = null;
		private LRRUOMTypes					_lrrUOMTypes;
		private LRRApp									_app;
		private bool							_isDeletePress = false;
		private bool							_isRecordeDel = false;

		#endregion

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			foreach(Record rec in gridUsageValues.TableModel.Table.Records)
			{
				if(rec != null)
				{
					LRRIndicesUsage indicesUsage = rec.GetData() as LRRIndicesUsage;
					if(indicesUsage.ObjectState == DBOperation.INSERT)
					{
						indicesUsage.IndicesXRefID = _indicesXRef.ID;
						LRRModel.IndicesUsages.Add(indicesUsage);
					}
				}
			}
			//_indConfig.RecieveUsages(_lrrIndicesUsages);
		}

		private void gridUsageValues_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			GridTableModel tableModel = gridUsageValues.Table.TableModel;

//			if(e.TableControl.CurrentCell.RowIndex == 3)
//				return;

			if ((tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_UOM")))
			{
				string sUOMType = "";
				try
				{
					sUOMType = ((LRRIndicesUsage)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(LRRIndicesUsage),ex.Message  ,Logger.Level.Debug);
				}
				if(sUOMType != "" && sUOMType != null)
				{
					LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
					GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
					cr.ListBoxPart.DataSource = uoms;
					uoms.SortColumn="Name";
					uoms.Sort();
					cr.Model.SupportsChoiceList = false; 
					if(uoms.Count ==0)
					{
						LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					}
				}
			}
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

		private void gridUsageValues_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","test",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
			}

			

			if(_isRecordeDel)
			{
				LRRIndicesUsage indUsage = e.Record.GetData() as LRRIndicesUsage;
				if(indUsage != null)
				{
					LRRModel.IndicesUsages.Remove(indUsage);
				}
			}

			_isRecordeDel = false;

		}

		private void UsageWindow_Load(object sender, System.EventArgs e)
		{
			ApplicationPersistanceUtil.ApplyGridSettings(this,null,this.Tag);
		}

		private void UsageWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			ApplicationPersistanceUtil.SaveGridSettings(this,null,this.Tag);
		}

//		private void gridUsageValues_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
//		{
//		
//		}
	}
}
