using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Globals.Enums;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.LightRidge.PEAdvisor.UserControls;
using Symcon.BusinessObjects; 
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor
{
	///	<summary>
	///	Summary	description	for	ModesSet.
	///	</summary>
	public class ModesSet :	System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		private System.Windows.Forms.Panel panelModesSet;
		///	<summary> 
		///	Required designer variable.
		///	</summary>
		private	System.ComponentModel.Container	components = null;

		public ModesSet()
		{
			InitializeComponent();
			gridModesSelected.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_MODES") +" { RecordCount } " + LRRHeaderText.GetHeaderString("SID_ITEMS");  
		}

		///	<summary> 
		///	Clean up any resources being used.
		///	</summary>
		protected override void	Dispose( bool disposing	)
		{
			if(	disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing	);
		}

		#region	Component Designer generated code
		///	<summary> 
		///	Required method	for	Designer support - do not modify 
		///	the	contents of	this method	with the code editor.
		///	</summary>
		private	void InitializeComponent()
		{
			this.gridModesSelected = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panelModesSet = new System.Windows.Forms.Panel();
			((System.ComponentModel.ISupportInitialize)(this.gridModesSelected)).BeginInit();
			this.panelModesSet.SuspendLayout();
			this.SuspendLayout();
			// 
			// gridModesSelected
			// 
			this.gridModesSelected.BackColor = System.Drawing.SystemColors.Window;
			this.gridModesSelected.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridModesSelected.Location = new System.Drawing.Point(0, 0);
			this.gridModesSelected.Name = "gridModesSelected";
			this.gridModesSelected.Size = new System.Drawing.Size(568, 264);
			this.gridModesSelected.TabIndex = 0;
			this.gridModesSelected.TableOptions.AllowDragColumns = false;
			this.gridModesSelected.TableOptions.AllowSortColumns = false;
			this.gridModesSelected.Text = "Mode\tSet";
			this.gridModesSelected.VersionInfo = "3.301.0.0";
			this.gridModesSelected.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridModesSelected_TableControlPrepareViewStyleInfo);
			// 
			// panelModesSet
			// 
			this.panelModesSet.Controls.Add(this.gridModesSelected);
			this.panelModesSet.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelModesSet.Location = new System.Drawing.Point(0, 0);
			this.panelModesSet.Name = "panelModesSet";
			this.panelModesSet.Size = new System.Drawing.Size(568, 264);
			this.panelModesSet.TabIndex = 0;
			// 
			// ModesSet
			// 
			this.Controls.Add(this.panelModesSet);
			this.Name = "ModesSet";
			this.Size = new System.Drawing.Size(568, 264);
			this.Tag = "SID_MODESETt";
			this.Load += new System.EventHandler(this.ModesSet_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridModesSelected)).EndInit();
			this.panelModesSet.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region	Fields

		private	Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridModesSelected;
		private	LRRModes	_lrrModesSelected;
		private	LRRApp		_lrrApp;
		private System.Windows.Forms.Panel panel1;
		private	Hashtable	_hshSelectedModes =	new	Hashtable();

		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			
		}

		public void Save()
		{
			//This method needs to be fixed due to Introduction of Data Arrays and Grouped Properties...
			return;

			SetSelectedModes();
			LRRModes selectedModes = new LRRModes();
			foreach(LRRMode lrmd in _lrrModesSelected)
			{
				if(lrmd.Selected)
				{
					selectedModes.Add(lrmd);
				}
			}
			LRRModes modesSelectedChanges = _lrrModesSelected.GetChanges();
			if(modesSelectedChanges.Count>0)
			{
				_lrrApp.DBManagerObj.CommitCollection(modesSelectedChanges);
				OptionsUserControl.saved	=true;
			}
			CreatePropertyDerivations();
			LoadModes();
			CreateModeSetPropertyValue(selectedModes);

			GroupedPropertiesUtility objUtil = new GroupedPropertiesUtility();
			objUtil.UpdateGroupedPropertiesByMode(selectedModes);

		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridModesSelected.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridModesSelected,false);
			}

		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			//Save to be fixed....
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region Events 

		private	void btnSave_Click(object sender, System.EventArgs e)
		{

			
		}

		private	void ModesSet_Load(object sender, System.EventArgs e)
		{
			_lrrApp	= AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			LoadModes();

			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of	the	Grid...
			gridModesSelected.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridModesSelected);
			columnForDisplay.Add("Selected",null);
			columnForDisplay.Add("ModeName",null);
			//Populate the columns for the grid	object
			SyncGridUtilities.InitializeGridColumns(gridModesSelected,_lrrModesSelected.ItemType,null,true,columnForDisplay);
			RelativeWidths.Add("Selected",16);
			RelativeWidths.Add("ModeName",85);
			SyncGridUtilities.InitializeGridColumnsWidth(gridModesSelected,RelativeWidths );
		
			//Set the data store 
			gridModesSelected.DataSource = _lrrModesSelected;
			gridModesSelected.TableDescriptor.Columns[0].HeaderText=LRRHeaderText.GetHeaderString("SID_MODE_INSTALLED");
			gridModesSelected.TableDescriptor.AllowNew = false;
			gridModesSelected.TableDescriptor.AllowRemove =	false;
			gridModesSelected.TableDescriptor.AllowEdit	= true;
			gridModesSelected.TableDescriptor.Columns["ModeName"].ReadOnly=true;

			
			//Resume the Layout	of the Grid...
			gridModesSelected.ResumeLayout(false);
	

			//Add the parent table for the Relations...
			gridModesSelected.Engine.SourceListSet.Add("ParentTable",_lrrModesSelected);
			SetSelectedModes();

		}


		private	void gridModesSelected_TableControlPrepareViewStyleInfo(object sender, GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			foreach(DictionaryEntry	entry in _hshSelectedModes)
			{
				if((int)entry.Key == e.Inner.RowIndex && (int)entry.Value == e.Inner.ColIndex)
				{

					if(gridModesSelected.TableModel.Model[e.Inner.RowIndex,e.Inner.ColIndex].CellType == "CheckBox")
					{
						object o = this.gridModesSelected.TableModel.Model[e.Inner.RowIndex,1].CellValue;
						if(o!= null)
						{
							bool val = o.ToString()	== true.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							if(val)
							{
								e.Inner.Style.CellType="ReadOnly";
								e.Inner.Style.BackColor	= Color.LightGray;
							}

						}
					}
				}
			}
		}

		#endregion

		#region Private Methods


		/// <summary>
		/// Populates Modes Collection and Sets Default Mode Selected True
		/// </summary>
		private	void LoadModes()
		{
			_lrrModesSelected =	new	LRRModes();
			//BB_arrIsDefaultModeSaved = new ArrayList();
			
			_lrrApp.DBManagerObj.PopulateCollection(_lrrModesSelected);

			foreach(LRRMode	mode in	_lrrModesSelected)
			{
				if(mode.IsDefault == true)
				{
					mode.Selected =	true;
				}
			}
			_lrrModesSelected.RefreshCollection();
			gridModesSelected.Refresh();
		}


		/// <summary>
		/// Adds the SiteComponentPropertyValues 
		/// for selected Modes(If not existing Already)F
		/// </summary>
		/// <param name="modeSet"></param>
		private void CreateModeSetPropertyValue(LRRModes modeSet)
		{
			LRRMasterComponents mast = LRRModel.Model;
			LRRSiteComponentPropertyValues siteCompPropValues = new LRRSiteComponentPropertyValues();
			foreach(LRRMasterComponent mc in mast)
			{
				foreach(LRRSiteComponent sc in mc.SiteComponentsObj)
				{
					foreach(LRRSiteComponentProperty scp in sc.Properties)
					{
						if(scp.ModeID)
						{
							foreach(LRRMode m in modeSet)
							{
								LRRSiteComponentPropertyValue lrrscpv = scp.GetValueObjectForPropertyMode(m.ModeId);

								if(lrrscpv == null && !m.IsDefault)
								{
									LRRSiteComponentPropertyValue lscpv = new LRRSiteComponentPropertyValue();
									lscpv.SiteComponentPropertyID = scp.ID;
									lscpv.ModeID = m.ModeId; 
									siteCompPropValues.Add(lscpv);
								}
							}
						}
					}
				}
			}
			_lrrApp.DBManagerObj.CommitCollection(siteCompPropValues.GetChanges());

		}


		/// <summary>
		/// Adds Selected Mode Row and Column Index to the Hashtable
		/// </summary>
		private void SetSelectedModes()
		{
			for(int	i =gridModesSelected.Table.Records.Count+2;i>0 ;i--)
			{
				if(gridModesSelected.TableModel.Model[i,1].CellValue.ToString()	== true.ToString(Symcon.BusinessObjects.SymConverter.Culture))
				{
					if(!_hshSelectedModes.Contains(i))
					{
						_hshSelectedModes.Add(i,1);
					}
				}
			}
		}
		/// <summary>
		/// Adds Property Derivations for the Selected Modes.
		/// </summary>
		private void CreatePropertyDerivations()
		{
			LRRPropertyDerivationTypes objPropertyDerivationTypes = new LRRPropertyDerivationTypes();	
			_lrrApp.DBManagerObj.PopulateCollection(objPropertyDerivationTypes,false);

			//For all selected modes other than default & Measurement, create custom derivation types
			for(int i = 0; i < _lrrModesSelected.Count;i++)
			{
				LRRMode lrmd = _lrrModesSelected[i];
				if(lrmd.Selected)
				{
					string sModeID =lrmd.ModeId == null ? "" : lrmd.ModeId.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					if((sModeID != "0") && (sModeID != "1"))
					{
						string sDerTypeID=sModeID + sModeID;
						LRRPropertyDerivationType objDeleteDerivationType = objPropertyDerivationTypes.GetPropertyDerivationTypeByID(sDerTypeID);
						if(objDeleteDerivationType == null)
						{
							LRRPropertyDerivationType objDerType = new LRRPropertyDerivationType();
							objDerType.DerivationType = lrmd.ModeName.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "Supplied";
							objDerType.Description = "Custom DerivationType";
							objDerType.ID =sDerTypeID;
							objPropertyDerivationTypes.Add(objDerType);
						}
					}
				}
			}

			LRRPropertyDerivationTypes objDerivationTypesToDelete = objPropertyDerivationTypes.GetChanges();
			if(objDerivationTypesToDelete.Count > 0)
			{
				_lrrApp.DBManagerObj.CommitCollection(objDerivationTypesToDelete);
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add ModesSet.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add ModesSet.SupportsClearSort implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add ModesSet.PrintPreview implementation
			if(gridModesSelected.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridModesSelected,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add ModesSet.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add ModesSet.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add ModesSet.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add ModesSet.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add ModesSet.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add ModesSet.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add ModesSet.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add ModesSet.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add ModesSet.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add ModesSet.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add ModesSet.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add ModesSet.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add ModesSet.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add ModesSet.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add ModesSet.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add ModesSet.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add ModesSet.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add ModesSet.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
