using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;  
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.
namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControUOMTypeDefinition.
	/// </summary>
	public class UserControUOMTypeDefinition : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp						_app;
		private LRRUOMTypes _lrrUOMTypes=null;
		private LRRUOMTypeXRefs		_lrrUOMTypeXRefs=null;
		private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter(); 
		private bool _uomXRef=false;
		private string				_recordValueChanged="0";
		
		
		private LRRUOMTypeXRefs		_orgUOMTypeXRefs=null;
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Splitter splitter1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUOMTye;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUOM;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControUOMTypeDefinition()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			_gridExcelFormatter.WireGrid(this.gridUOMTye);
			_gridExcelFormatter.WireGrid(this.gridUOM);
			SyncGridUtilities.InitializeGridLookAndFeel(gridUOMTye);
			SyncGridUtilities.InitializeGridLookAndFeel(gridUOM);
			BindGridgridUOMTye();
			BindGridgridUOM();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData ==  Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel3 = new System.Windows.Forms.Panel();
			this.gridUOMTye = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panel2 = new System.Windows.Forms.Panel();
			this.gridUOM = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridUOMTye)).BeginInit();
			this.panel2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridUOM)).BeginInit();
			this.SuspendLayout();
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.gridUOMTye);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel3.Location = new System.Drawing.Point(0, 0);
			this.panel3.Name = "panelUOMTD3";
			this.panel3.Size = new System.Drawing.Size(432, 592);
			this.panel3.TabIndex = 9;
			// 
			// gridUOMTye
			// 
			this.gridUOMTye.BackColor = System.Drawing.SystemColors.Window;
			this.gridUOMTye.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUOMTye.Location = new System.Drawing.Point(0, 0);
			this.gridUOMTye.Name = "gridUOMTye";
			this.gridUOMTye.Size = new System.Drawing.Size(432, 592);
			this.gridUOMTye.TabIndex = 2;
			this.gridUOMTye.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridUOMTye.Text = "gridGroupingControl1";
			this.gridUOMTye.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUOMTye.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUOMTye.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUOMTye.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUOMTye.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUOMTye.VersionInfo = "3.301.0.0";
			this.gridUOMTye.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridUOMTye_RecordDeleting);
			this.gridUOMTye.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridUOMTye_TableControlPrepareViewStyleInfo);
			this.gridUOMTye.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridUOMTye_QueryCellStyleInfo);
			this.gridUOMTye.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridUOMTye_CurrentRecordContextChange);
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.gridUOM);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(432, 0);
			this.panel2.Name = "panelUOMTD2";
			this.panel2.Size = new System.Drawing.Size(360, 592);
			this.panel2.TabIndex = 8;
			// 
			// gridUOM
			// 
			this.gridUOM.BackColor = System.Drawing.SystemColors.Window;
			this.gridUOM.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUOM.Location = new System.Drawing.Point(0, 0);
			this.gridUOM.Name = "gridUOM";
			this.gridUOM.Size = new System.Drawing.Size(360, 592);
			this.gridUOM.TabIndex = 2;
			this.gridUOM.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridUOM.Text = "gridGroupingControl2";
			this.gridUOM.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUOM.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUOM.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUOM.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUOM.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUOM.VersionInfo = "3.301.0.0";
			this.gridUOM.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridUOM_RecordDeleting);
			this.gridUOM.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridUOM_TableControlPrepareViewStyleInfo);
			this.gridUOM.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridUOM_RecordValueChanged);
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(432, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 592);
			this.splitter1.TabIndex = 10;
			this.splitter1.TabStop = false;
			// 
			// UserControUOMTypeDefinition
			// 
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel3);
			this.Name = "UserControUOMTypeDefinition";
			this.Size = new System.Drawing.Size(792, 592);
			this.Tag = "SID_UOMTYPEDEFN";
			this.panel3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridUOMTye)).EndInit();
			this.panel2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridUOM)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		#region BindGridUOMType
		private void BindGridgridUOMTye()
		{
			//			_dbManager.PopulateCollection(_lrrUOMTypes,false);
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUOMTye.TableModel.BeginUpdate();
			gridUOMTye.SuspendLayout();
			
			//Populate the columns for the grid object
			//Populate the columns for the grid object
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrUOMTypes.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj1 in fkColumns.Keys)
			{
				string propName = (string)obj1;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridUOMTye,gridUOMTye.TableDescriptor,_lrrUOMTypes.ItemType,null,true,fkData,null,false);

			//SyncGridUtilities.InitializeGridColumns(gridUOMTye,gridUOMTye.TableDescriptor,_lrrUOMTypes.ItemType,null,true,null,null,true);
			gridUOMTye.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRRUOM_TYPES") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");     
			//RelativeWidths.Add("Name",40);
			//RelativeWidths.Add("Description",57);
			//RelativeWidths.Add("Description",57);
			//SyncGridUtilities.InitializeGridColumnsWidth(gridUOMTye,RelativeWidths );
		
			//Set the data store 
			gridUOMTye.DataSource = _lrrUOMTypes;
			
			//Resume the Layout of the Grid...
			gridUOMTye.ResumeLayout(false);
			gridUOMTye.TableModel.EndUpdate();


			//Add the parent table for the Relations...
			gridUOMTye.Engine.SourceListSet.Add("ParentTable",_lrrUOMTypes);
			//this.gridUOMTye.TableModel.Model.QueryCellInfo+=new GridQueryCellInfoEventHandler(gridUOMTye_QueryCellInfo);
			this.gridUOMTye.TableModel.Model.HideCols["Base"]=true;

			string[,] arry=new string[,]{{"Description","255"}};
			Validations	obj=new Validations(gridUOMTye,arry);
		}

		private void BindGridgridUOMTye1()
		{
			//			_dbManager.PopulateCollection(_lrrUOMTypes,false);
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUOMTye.TableModel.BeginUpdate();
			gridUOMTye.SuspendLayout();
			//SyncGridUtilities.InitializeGridLookAndFeel(gridUOMTye);
			//Populate the columns for the grid object
			//Populate the columns for the grid object
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrUOMTypes.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj1 in fkColumns.Keys)
			{
				string propName = (string)obj1;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridUOMTye,gridUOMTye.TableDescriptor,_lrrUOMTypes.ItemType,null,true,fkData,null,false);

			//SyncGridUtilities.InitializeGridColumns(gridUOMTye,gridUOMTye.TableDescriptor,_lrrUOMTypes.ItemType,null,true,null,null,true);
			//gridUOMTye.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRRUOM_TYPES") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");     
			//RelativeWidths.Add("Name",40);
			//RelativeWidths.Add("Description",57);
			//RelativeWidths.Add("Description",57);
			//SyncGridUtilities.InitializeGridColumnsWidth(gridUOMTye,RelativeWidths );
		
			//Set the data store 
			gridUOMTye.DataSource = _lrrUOMTypes;
			
			//Resume the Layout of the Grid...
			gridUOMTye.ResumeLayout(false);
			gridUOMTye.TableModel.EndUpdate();


			//Add the parent table for the Relations...
			gridUOMTye.Engine.SourceListSet.Add("ParentTable",_lrrUOMTypes);
			//this.gridUOMTye.TableModel.Model.QueryCellInfo+=new GridQueryCellInfoEventHandler(gridUOMTye_QueryCellInfo);
			//this.gridUOMTye.TableModel.Model.HideCols["Base"]=true;

			//string[,] arry=new string[,]{{"Description","255"}};
			//Validations	obj=new Validations(gridUOMTye,arry);
		}

		#endregion
		#region BindGridUOM
		private void BindGridgridUOM()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUOM.SuspendLayout();
			
			//Populate the columns for the grid object
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrUOMTypeXRefs.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridUOM,_lrrUOMTypeXRefs.ItemType,null,fkData);
			RelativeWidths.Add("Name",50);
			RelativeWidths.Add("Description",95);
			SyncGridUtilities.InitializeGridColumnsWidth(gridUOM,RelativeWidths );
			
			gridUOM.DataSource = _lrrUOMTypeXRefs;
			//Add the parent table for the Relations...
			gridUOM.Engine.SourceListSet.Add("ParentTable",_lrrUOMTypeXRefs);
			
			//Resume the Layout of the Grid...
			gridUOM.ResumeLayout(false);
			gridUOM.TableDescriptor.AllowNew=true;
			gridUOM.TableDescriptor.AllowRemove=true;
			gridUOM.TableDescriptor.AllowEdit=true;
				
			gridUOM.TableDescriptor.Columns["UOM_Name"].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridUOM.TableDescriptor.Columns["UOM_Name"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridUOM.TableDescriptor.Columns["UOM_Name"].Appearance.AddNewRecordFieldCell.ReadOnly = false;
			gridUOM.TableDescriptor.Columns["UOM_Name"].Appearance.AddNewRecordFieldCell.ShowButtons = GridShowButtons.Show;
			gridUOM.TableDescriptor.Columns["UOM_Name"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridUOM.TableDescriptor.Columns["UOM_Name"].Appearance.AddNewRecordFieldCell.ExclusiveChoiceList = true;

			gridUOM.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRRUOM_XREF_TYPE") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");     

			string[,] arry=new string[,]{{"Description","255"}};
			Validations	objV=new Validations(gridUOM,arry);
			
		}
		
		#endregion
		
		# region InitDataSource
		private void InitDataSource()
		{
			if(_lrrUOMTypes != null)
			{
				_lrrUOMTypes.Clear();
				_lrrUOMTypes.RefreshCollection();
			}
			else
				_lrrUOMTypes=new LRRUOMTypes();

			if(_orgUOMTypeXRefs != null)
			{
				_orgUOMTypeXRefs.Clear();
				_orgUOMTypeXRefs.RefreshCollection();
			}
			else
				_orgUOMTypeXRefs=new LRRUOMTypeXRefs();

			if(_lrrUOMTypeXRefs != null)
			{
				_lrrUOMTypeXRefs.Clear();
				_lrrUOMTypeXRefs.RefreshCollection();
			}
			else
				_lrrUOMTypeXRefs=new LRRUOMTypeXRefs();
			

			//_lrrUOMTypes=new LRRUOMTypes();
			_app.DBManagerObj.PopulateCollection(_lrrUOMTypes," WHERE IsEVV=false",false);
			//_orgUOMTypeXRefs=new LRRUOMTypeXRefs();
			_app.DBManagerObj.PopulateCollection(_orgUOMTypeXRefs,false);
			_app.DBManagerObj.PopulateCollection(_lrrUOMTypeXRefs,false);
		}
		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			gridUOM.TableModel.ConfirmPendingChanges();
			InitDataSource();
//		
//			BindGridgridUOM();
			
//			_lrrUOMTypes.RefreshCollection();
//			_orgUOMTypeXRefs.RefreshCollection();
//			_lrrUOMTypeXRefs.RefreshCollection();
			BindGridgridUOMTye();
			BindGridgridUOM();
			_recordValueChanged="0";
		}

		public void Save()
		{
			gridUOM.Table.EndEdit();
			LRRFormulaParams oNewFormulaParams = new LRRFormulaParams();
			LRRFormulaParams oNewFormulaParamsReverse = new LRRFormulaParams();
			//***************UOMDefnitions************************UOMType
			if(_uomXRef==true)
			{
				LRRUOMTypeXRefs UOMTypeXRefs = _lrrUOMTypeXRefs.GetChanges()  ;
				if(UOMTypeXRefs.Count>0)
				{
					_app.DBManagerObj.CommitCollection(UOMTypeXRefs);
					OptionsUserControl.saved	=true;
					_uomXRef=false;
				}
				
			}
			LRRUOMType _lrrUOMType = null;
			if(gridUOMTye.CurrencyManager.Position != -1)
			{
				_lrrUOMType=gridUOMTye.CurrencyManager.Current as LRRUOMType;
			}
//			foreach (LRRUOMType  lrrUOMType in _lrrUOMTypes)
//			{
//						
//				if(lrrUOMType.Name == null || lrrUOMType.Name=="") 
//				{
//					MessageBox.Show("UOM Type not specified . Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
//					return;
//				}
//			}	
		
			foreach (LRRUOMType  lrrUOMType in _lrrUOMTypes)
			{
				string sName = lrrUOMType.Name  == null ? "" : lrrUOMType.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				string sUOMTypeID = lrrUOMType.UOMTypeID == null ? "" : lrrUOMType.UOMTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

				if(sName=="") 
				{
					LRRMessagBox.ShowMessage("SID_SAVEABORT_UOM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					return;
				}

				foreach (LRRUOMType  objUOMType in _lrrUOMTypes)
				{
					if((objUOMType.UOMTypeID != sUOMTypeID) && (objUOMType.ObjectState != DBOperation.DELETE))
					{
						string sUOMTypeName = objUOMType.Name  == null ? "" : objUOMType.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if(sUOMTypeName.ToUpper() == sName.ToUpper())
						{
							//MessageBox.Show("UOM Type - " + sUOMTypeName + " already exists. Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
							string[] s = new string[1];
							s[0] = sUOMTypeName;
							LRRMessagBox.ShowMessage("SID_PROP_DUPLICATE","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);     
							return;
						}
					}
				}
			}
			//Changes by resmi***
				
			LRRMeasurementSystems _lrrMeasurementSystems=LRRModel.MeasurementSystems;
			LRRUOMTypes uomTypesChanged=_lrrUOMTypes.GetChanges();
			foreach(LRRMeasurementSystem objMS in _lrrMeasurementSystems)
			{
				foreach(LRRUOMType uomType in uomTypesChanged)
				{
					if(uomType.ObjectState==DBOperation.INSERT)
					{
						LRRMeasurementSystemDefinition _MSDefn=new LRRMeasurementSystemDefinition();
						_MSDefn.ID=Guid.NewGuid().ToString();
						_MSDefn.UOMTypeID=uomType.UOMTypeID;
						_MSDefn.MSID=objMS.ID;
						_MSDefn.Base=false;
						LRRModel.ChildModel.MeasSysDef.Add(_MSDefn);
					}
					if(uomType.ObjectState==DBOperation.DELETE)
					{
						
					}

				}
			}
			//*****
			if(_lrrUOMTypes.GetChanges().Count>0)
			{
				LRRUOMTypes	uomTypes=_lrrUOMTypes.GetChanges();
				_app.DBManagerObj.CommitCollection(uomTypes);
				OptionsUserControl.saved	=true;
			}
			if(_lrrUOMTypes.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
			else
			{
					
				_lrrUOMTypes.RefreshCollection();

			}
			//Changes by resmi***

			LRRMeasurementSystemDefinitions msDefn=LRRModel.ChildModel.MeasSysDef.GetChanges();
			if(msDefn.Count>0)
			{
				_app.DBManagerObj.CommitCollection(msDefn);
				OptionsUserControl.saved	=true;
				LRRModel.ChildModel.MeasSysDef.RefreshCollection();
			}
		//***
			LRRUOMTypeXRefs uomTypeXRefs = _lrrUOMTypeXRefs.GetChanges();
			if(_lrrUOMType != null)
			{
				if(uomTypeXRefs.Count>0)
				{
					foreach (LRRUOMTypeXRef lrrUOMTypeXRef in uomTypeXRefs)
					{
						lrrUOMTypeXRef.UOMType=_lrrUOMType.UOMTypeID;
					}
				}
				foreach (LRRUOMTypeXRef  lrrUOMTypeXRef in _lrrUOMTypeXRefs)
				{
					if(lrrUOMTypeXRef.UOM== null || lrrUOMTypeXRef.UOM=="") 
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_UOM_NULL","SID_LABLE",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
				}
				foreach (LRRUOMTypeXRef  lrrUOMTypeXRef in _lrrUOMTypeXRefs.GetChanges())
				{
					if(lrrUOMTypeXRef.Multiplier== null || lrrUOMTypeXRef.Multiplier=="" )
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_MULTIPLIER_NULL","SID_LABLE",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
					if(lrrUOMTypeXRef.Multiplier=="0")
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_MULTIPLIER_ZERO","SID_LABLE",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
				}
				if(uomTypeXRefs.GetChanges().Count>0)
				{
					foreach(LRRUOMTypeXRef uxref in uomTypeXRefs.GetChanges())
					{
						bool found = false;
						LRRUOMTypeXRef uxrefToRemove = null;
						foreach(LRRUOMTypeXRef uxrefm in LRRModel.ChildModel.UOMTypeXRefs)
						{
							if(uxref.ID == uxrefm.ID)
							{
								uxrefToRemove = uxrefm;
								found = true;
							}
						}
						if(found)
						{
							LRRModel.ChildModel.UOMTypeXRefs.Remove(uxrefToRemove);
							LRRModel.ChildModel.UOMTypeXRefs.Add(uxref);
						}
						else
						{
							LRRModel.ChildModel.UOMTypeXRefs.Add(uxref);
						}
					}
					_app.DBManagerObj.CommitCollection(uomTypeXRefs);
					LRRModel.ChildModel.UOMTypeXRefs.RefreshCollection();
					OptionsUserControl.saved	=true;
				}
				if(uomTypeXRefs.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);	
				}
				else
				{
					#region Generate UCFs
					foreach(LRRUOMTypeXRef UOMXRef in uomTypeXRefs)
					{
						
						string sUOMTypeID = "";
						string sNewUOM = "";
						
						//Generate the UCF For this combination
						string baseUomID = "";
						ArrayList arrUCF = new ArrayList();

						//Get the uom type for the uom
						sUOMTypeID = UOMXRef.UOMType == null ? "" : UOMXRef.UOMType.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						sNewUOM = UOMXRef.UOM == null ? "" : UOMXRef.UOM.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						LRRUOM lrrUOM = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(sNewUOM);
						LRRUOMs oUOMs = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMTypeID);
						
						LRRUOMTypeXRefs oUOMXRefs = LRRModel.ChildModel.UOMTypeXRefs.getUOMsForUOMType(sUOMTypeID);
						foreach(LRRUOMTypeXRef oUOMXRef in oUOMXRefs)
						{
							try
							{
								if(double.Parse(oUOMXRef.Multiplier,Symcon.BusinessObjects.SymConverter.Culture)==1.00000000000000000000)
								{
									baseUomID = oUOMXRef.UOM;
									break;
								}
							}
							catch(Exception ex)
							{
								Debug.Assert(false,ex.Message,ex.StackTrace);
							}
						}
						
						bool baseUomFound = false;
						bool shouldLog = false;
						// Logging if base UOM not found for particular UOMType
						if(baseUomID != "")
						{
							baseUomFound = true;
						}

						foreach(LRRUOM oUOM in oUOMs)
						{
							string ToUOMID = oUOM.ID == null ? "" : oUOM.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							LRRUCF oNewUCF, oNewUCFReverse;
							LRRFormula oNewFormula, oNewFormulaReverse;
							if(!sNewUOM.Equals(ToUOMID) && !arrUCF.Contains(sNewUOM + "|" + ToUOMID))
							{
								LRRUCF oUCF = LRRModel.ChildModel.UCFs.GetUCFByFromToComb(sNewUOM + "|" + ToUOMID);
                                LRRUCF oUCFReverse = LRRModel.ChildModel.UCFs.GetUCFByFromToComb(ToUOMID + "|" + sNewUOM);
                                //if(oUCFs.Count == 0)
                                //{
                                //    oUCFs = LRRModel.ChildModel.UCFs.FilterUOMsByUCFComb(sNewUOM + "|" + ToUOMID);
                                //}
                                //if(oUCFsReverse.Count == 0)
                                //{
                                //    oUCFsReverse = LRRModel.ChildModel.UCFs.FilterUOMsByUCFComb(ToUOMID + "|" + sNewUOM);
                                //}
                                if (oUCF == null)
								{
									
									if(baseUomFound)
									{
										oNewUCF = new LRRUCF();
										

										string conversionFactor1 = UOMXRef.Multiplier.ToString(Symcon.BusinessObjects.SymConverter.Culture); //XRef - Multiplier
										string conversionFactor2 = LRRModel.ChildModel.UOMTypeXRefs.GetMultiplierForUOMID(ToUOMID,sUOMTypeID);
										//decimal conversionFactor = decimal.Parse(conversionFactor2)/decimal.Parse(conversionFactor1);
										//string conversionFormula = "A*" + conversionFactor.ToString();

										if(!(conversionFactor1 == null || conversionFactor1 == "" || conversionFactor2 == null || conversionFactor2 == ""))
										{
											string conversionFormula = "A*" + conversionFactor2 + "/" + conversionFactor1;
											oNewUCF.ToUnit  = ToUOMID;
											oNewUCF.FromUnit  = sNewUOM;
											oNewUCF.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
										
											oNewFormula = new LRRFormula();
											oNewUCF.ConversionFormula = oNewFormula.ID;
											oNewFormula.FormulaName=(lrrUOM.Name == null) ? "" : lrrUOM.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture)  + "  to  " + (oUOM.Name == null ? "" : oUOM.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture));
											oNewFormula.Expression = conversionFormula;
											oNewFormula.SourceCollectionName = "Symcon.LightRidge.BusinessObjects.LRRUCF";
											oNewFormula.SourceObjectID = oNewUCF.ID;
											oNewFormula.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
											//									
											LRRFormulaParam oNewFormulaParam = new LRRFormulaParam();
										
											oNewFormulaParam.FormulaID= oNewFormula.ID;
										
											oNewFormulaParam.ParamName = /*conversionFormula*/"A";

											oNewFormulaParam.SourceCollectioName = "Symcon.LightRidge.BusinessObjects.LRRUCF";
										
											oNewFormulaParam.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
											oNewFormula.Params.Add(oNewFormulaParam);
										
										
											arrUCF.Add(sNewUOM + "|" + ToUOMID);
											oNewUCF.ConversionFormulaObj = oNewFormula;
											LRRModel.ChildModel.UCFs.Add(oNewUCF);
											LRRModel.FormulasObj.Add(oNewFormula);
											oNewFormulaParams.Add(oNewFormulaParam);
										}
										else
										{
											shouldLog = true;
										}

									}
									else
									{
										shouldLog = true;
									}
								}
								else
								{
									//Its a case of update
									oNewUCF = oUCF;
									oNewFormula = LRRModel.FormulasObj.GetFormulaObjFromID(oNewUCF.ConversionFormula);
									
									string conversionFactor1 = UOMXRef.Multiplier.ToString(Symcon.BusinessObjects.SymConverter.Culture); //XRef - Multiplier
									string conversionFactor2 = LRRModel.ChildModel.UOMTypeXRefs.GetMultiplierForUOMID(ToUOMID,sUOMTypeID);

									if(!(conversionFactor1 == null || conversionFactor1 == "" || conversionFactor2 == null || conversionFactor2 == ""))
									{
										string conversionFormula = "A*" + conversionFactor2 + "/" + conversionFactor1;
									
										oNewFormula.Expression = conversionFormula;
										oNewFormula.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
									}
									else
									{
										shouldLog = true;
									}
								}
                                if (oUCFReverse == null)
								{
									
									if(baseUomFound)
									{
										oNewUCFReverse = new LRRUCF();

										string conversionFactor1 = UOMXRef.Multiplier.ToString(Symcon.BusinessObjects.SymConverter.Culture); //XRef - Multiplier
										string conversionFactor2 = LRRModel.ChildModel.UOMTypeXRefs.GetMultiplierForUOMID(ToUOMID,sUOMTypeID);
										//decimal conversionFactor = decimal.Parse(conversionFactor2)/decimal.Parse(conversionFactor1);
										//string conversionFormula = "A*" + conversionFactor.ToString();

										if(!(conversionFactor1 == null || conversionFactor1 == "" || conversionFactor2 == null || conversionFactor2 == ""))
										{
											string conversionFormulaReverse = "A*" + conversionFactor1 + "/" + conversionFactor2;
											oNewUCFReverse.ToUnit  = sNewUOM;
											oNewUCFReverse.FromUnit  = ToUOMID;
										
											oNewUCFReverse.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
										
											oNewFormulaReverse = new LRRFormula();
											oNewUCFReverse.ConversionFormula = oNewFormulaReverse.ID;
											oNewFormulaReverse.FormulaName= (oUOM.Name == null) ? "" : oUOM.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "  to  " + (lrrUOM.Name == null ? "" : lrrUOM.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture));
											oNewFormulaReverse.Expression = conversionFormulaReverse;
											oNewFormulaReverse.SourceCollectionName = "Symcon.LightRidge.BusinessObjects.LRRUCF";
											oNewFormulaReverse.SourceObjectID = oNewUCFReverse.ID;
											oNewFormulaReverse.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
											//		
										
											LRRFormulaParam oNewFormulaParamReverse = new LRRFormulaParam();
											oNewFormulaParamReverse.FormulaID= oNewFormulaReverse.ID;
											oNewFormulaParamReverse.ParamName = /*conversionFormulaReverse*/"A";
											oNewFormulaParamReverse.SourceCollectioName = "Symcon.LightRidge.BusinessObjects.LRRUCF";
											oNewFormulaReverse.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
										
											oNewFormulaReverse.Params.Add(oNewFormulaParamReverse);
										
											arrUCF.Add(ToUOMID + "|" + sNewUOM);
											oNewUCFReverse.ConversionFormulaObj = oNewFormulaReverse;
											LRRModel.ChildModel.UCFs.Add(oNewUCFReverse);
											LRRModel.FormulasObj.Add(oNewFormulaReverse);
											oNewFormulaParams.Add(oNewFormulaParamReverse);
										}
										else
										{
											shouldLog = true;
										}

									}
									else
									{
										shouldLog = true;
									}
								}
								else
								{
									//Its a case of update
									oNewUCFReverse = oUCFReverse;
									oNewFormulaReverse = LRRModel.FormulasObj.GetFormulaObjFromID(oNewUCFReverse.ConversionFormula);
									
									string conversionFactor1 = UOMXRef.Multiplier.ToString(Symcon.BusinessObjects.SymConverter.Culture); //XRef - Multiplier
									string conversionFactor2 = LRRModel.ChildModel.UOMTypeXRefs.GetMultiplierForUOMID(ToUOMID,sUOMTypeID);
									if(!(conversionFactor1 == null || conversionFactor1 == "" || conversionFactor2 == null || conversionFactor2 == ""))
									{
										string conversionFormulaReverse = "A*" + conversionFactor1 + "/" + conversionFactor2;
									
										oNewFormulaReverse.Expression = conversionFormulaReverse;
										oNewFormulaReverse.UserID  = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
										oNewUCFReverse.UserID = _app.DBManagerObj.AccessControlModel.UserID == null ? "" : _app.DBManagerObj.AccessControlModel.UserID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
									}
									else
									{
										shouldLog = true;
									}
								}
								
								
							}
						}
						if(shouldLog)
						{
							Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(UserControUOMTypeDefinition),"Base UOM or other multiplier(s) for UOM not found for UomType " + LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(UOMXRef.UOMType).Name + "! Some or all UCF cannot be generated for the addition/modification of UOM(Multiplier).",Symcon.Utils.MessageLogger.Logger.Level.Debug);
						}
					}
					if(LRRModel.ChildModel.UCFs.GetChanges().Count > 0)
					{
						_app.DBManagerObj.CommitCollection(LRRModel.ChildModel.UCFs.GetChanges());
					}

					if (LRRModel.FormulasObj.GetChanges().Count > 0)
					{
						_app.DBManagerObj.CommitCollection(LRRModel.FormulasObj.GetChanges());
					}

					if(oNewFormulaParams.Count > 0)
					{
						_app.DBManagerObj.CommitCollection(oNewFormulaParams.GetChanges());
						_app.DBManagerObj.CommitCollection(oNewFormulaParamsReverse.GetChanges());
					}
					LRRModel.ChildModel.UCFs.RefreshCollection();
					LRRModel.FormulasObj.RefreshCollection();
					#endregion
					uomTypeXRefs.RefreshCollection();
				}
				
				
			}

			gridUOMTye.BeginUpdate();
			gridUOM.BeginUpdate();
			InitDataSource();
			//gridUOMTye.DataSource = _lrrUOMTypes;
			BindGridgridUOMTye();
			BindGridgridUOM();
			_recordValueChanged = "0";
			gridUOMTye.EndUpdate(false);
			gridUOM.EndUpdate(false);
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridUOM.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOM,false);
			}
			if(gridUOMTye.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOMTye,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridUOM);
			SyncGridUtilities.PasteSelection(gridUOMTye);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion


		#region RefreshGridUOMs()
		private void RefreshGridUOMs()
		{
			Hashtable	RelativeWidths=new Hashtable();
			gridUOM.DataSource = null;
			//Populate the columns for the grid object
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrUOMTypeXRefs.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
		
			gridUOM.DataSource = _lrrUOMTypeXRefs;
			//Add the parent table for the Relations...
			gridUOM.Engine.SourceListSet.Add("ParentTable",_lrrUOMTypeXRefs);
		}
		#endregion
		
		private void gridUOMTye_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			try
			{
				string filterString=null;
				LRRUOMType _lrrUOMType=null;
				if(gridUOMTye.CurrencyManager.Position!=-1)
				{
					_lrrUOMType	=gridUOMTye.CurrencyManager.Current as LRRUOMType;
					if (gridUOMTye.CurrencyManager.Count == 0 )
						return;

					if(e.Table.CurrentRecord != null)
					{
						if((e.Record != null)&&(e.Action == CurrentRecordAction.EnterRecordComplete))
						{
							if(_lrrUOMType  != null)
							{
								string UOMTypeId=_lrrUOMType.UOMTypeID == null ? "" : _lrrUOMType.UOMTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
								if(UOMTypeId != "")
								{
									_lrrUOMTypeXRefs = _orgUOMTypeXRefs;
									_lrrUOMTypeXRefs = _lrrUOMTypeXRefs.getUOMsForUOMType(UOMTypeId);
									BindGridgridUOM();
									//RefreshGridUOMs();
							
									e.Cancel = true;
									return;
								}
							}
						}	

					}
					if(e.Table.CurrentRecord != null)
					{
						if((e.Table.CurrentRecord.GetType() == typeof(GridAddNewRecord)) && e.Action==CurrentRecordAction.NavigateComplete)
						{
							//				filterString =   "UOMType = null";
							//				_lrrUOMTypeXRefs.ItemFilter= filterString;
							//				_app.DBManagerObj.PopulateCollection(_lrrUOMTypeXRefs,"  where UOMType='"+null+"'");
	
							_lrrUOMTypeXRefs = _orgUOMTypeXRefs;
							_lrrUOMTypeXRefs = _lrrUOMTypeXRefs.getUOMsForUOMType(null);
							BindGridgridUOM();
	
							return;
						}
					}


					if (gridUOMTye.CurrencyManager.Count > 0 )
					{
						if(_lrrUOMType!= null)
						{
							if(e.Action == CurrentRecordAction.NavigateCalled)
							{
								if(_recordValueChanged == "1")
								{
									DialogResult k = LRRMessagBox.ShowMessage("SID_SAVEINFO_QUESTION","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);      
									if(k==DialogResult.Yes) 
									{
										e.Cancel = true;
										Save();
									}
									else
										_recordValueChanged ="0";
								}
							}
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UserControUOMTypeDefinition),"gridUOMTye_CurrentRecordContextChange Event :"+ex.Message  ,Logger.Level.Debug);
			}
		}

		private void gridUOMTye_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.RowIndex!=-1) 
			{
				if(e.TableCellIdentity.DisplayElement is GridRecordRow)
				{
					LRRUOMType obj  = e.TableCellIdentity.DisplayElement.ParentRecord.GetData() as LRRUOMType; 
					if(obj!=null)
					{
						if(obj.Base==true)
						{
							if(e.TableCellIdentity.ColIndex > 0)
							{
								e.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.LightGray);
								e.Style.ReadOnly=true;
							}
						}
						else
						{
							if(e.TableCellIdentity.ColIndex > 0)
							{
								e.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.White);
								e.Style.ReadOnly=false;
							}
						}
					}
					else
					{
						if(e.TableCellIdentity.ColIndex > 0)
						{
							e.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.White);
							e.Style.ReadOnly=false;
						}
					}
				}

			}
		}
		private void gridUOMTye_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			
//			if(e.Inner.RowIndex > 2 && e.Inner.ColIndex > 0)
//			{
//				if(this.gridUOMTye.TableModel.Model[e.Inner.RowIndex,3].CellType=="CheckBox")
//				{
//					object o = this.gridUOMTye.TableModel.Model[e.Inner.RowIndex,3].CellValue;
//					if(o!=null)
//					{
//						bool val = o.ToString() == true.ToString();
//						if(val)
//						{
//							e.Inner.Style.CellType="Static";
//							e.Inner.Style.BackColor = Color.LightGray;
//						}
//					}
//				}
//			}
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridUOM_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				_uomXRef=true;
			}
			else
			{
				e.Cancel = true;
				return;
			}
		}

		private void gridUOM_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			_recordValueChanged ="1";
		}

		private void gridUOM_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
//			if(e.Inner.RowIndex > 2 && e.Inner.ColIndex > 0)
//			{
//				if(this.gridUOM.TableModel.Model[e.Inner.RowIndex,3].CellType=="CheckBox")
//				{
//					object o = this.gridUOM.TableModel.Model[e.Inner.RowIndex,3].CellValue;
//					if(o!=null)
//					{
//						bool val = o.ToString() == true.ToString();
//						if(val)
//						{
//							e.Inner.Style.CellType="Static";
//							e.Inner.Style.BackColor = Color.LightGray;
//						}
//					}
//				}
//			}
		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}
		
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridUOM);
			SyncGridUtilities.ClearSort(gridUOMTye);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion

		
		private void gridUOMTye_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			LRRUOMType lrrUOMType=gridUOMTye.CurrencyManager.Current as LRRUOMType;
			if(lrrUOMType.Base==true)
			{
				e.Cancel=true;
			}
			else
			{
				if(_isDeletePress)
				{
					DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
					if(_dlgResult == DialogResult.Yes)
					{
						_isRecordeDel = true; 
					}
					else
					{
						_isRecordeDel = false; 
					}
					_isDeletePress = false;
				}
				if(!_isRecordeDel)
				{
					e.Cancel = true;
					return;
				}
			}
		}
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControUOMTypeDefinition.PrintPreview implementation
			if(gridUOM.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOM,true);
			}
			if(gridUOMTye.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOMTye,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControUOMTypeDefinition.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControUOMTypeDefinition.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControUOMTypeDefinition.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControUOMTypeDefinition.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControUOMTypeDefinition.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControUOMTypeDefinition.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControUOMTypeDefinition.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControUOMTypeDefinition.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControUOMTypeDefinition.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControUOMTypeDefinition.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControUOMTypeDefinition.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
