using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.Utils.HeaderDispatcher;  
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;

using Symcon.Utils.MessageDispatcher;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlAvailableRefregerants.
	/// </summary>
	public class UserControlAvailableRefregerants : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAvailableRefrigerants;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private LRRApp						_app;
		private LRRRefrigerants			_lrrRefregerants=null;
		private TabControl					_parentTabControl;
		private GridExcelFormatter	_gridExcelFormatter = new GridExcelFormatter(); 
		private TabPage						_parentTabPage;
		
		public UserControlAvailableRefregerants()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			_gridExcelFormatter.WireGrid(this.gridAvailableRefrigerants); 
			SyncGridUtilities.InitializeGridLookAndFeel(gridAvailableRefrigerants);
			BIndGridAvailableRefrigerants();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridAvailableRefrigerants = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridAvailableRefrigerants)).BeginInit();
			this.SuspendLayout();
			// 
			// gridAvailableRefrigerants
			// 
			this.gridAvailableRefrigerants.BackColor = System.Drawing.SystemColors.Window;
			this.gridAvailableRefrigerants.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridAvailableRefrigerants.Location = new System.Drawing.Point(0, 0);
			this.gridAvailableRefrigerants.Name = "gridAvailableRefrigerants";
			this.gridAvailableRefrigerants.Size = new System.Drawing.Size(736, 448);
			this.gridAvailableRefrigerants.TabIndex = 1;
			this.gridAvailableRefrigerants.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridAvailableRefrigerants.Text = "gridGroupingControl1";
			this.gridAvailableRefrigerants.TopLevelGroupOptions.CaptionText = "Available Refrigerants: {RecordCount} Items";
			this.gridAvailableRefrigerants.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridAvailableRefrigerants.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridAvailableRefrigerants.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridAvailableRefrigerants.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridAvailableRefrigerants.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridAvailableRefrigerants.VersionInfo = "3.301.0.0";
			this.gridAvailableRefrigerants.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridAvailableRefrigerants_RecordDeleting);
			this.gridAvailableRefrigerants.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridAvailableRefrigerants_TableControlPrepareViewStyleInfo);
			// 
			// UserControlAvailableRefregerants
			// 
			this.Controls.Add(this.gridAvailableRefrigerants);
			this.Name = "UserControlAvailableRefregerants";
			this.Size = new System.Drawing.Size(736, 448);
			this.Tag = "SID_REFREG";
			((System.ComponentModel.ISupportInitialize)(this.gridAvailableRefrigerants)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		# region InitDataSource
		private void InitDataSource()
		{
			
			if(_lrrRefregerants != null)
				_lrrRefregerants.Clear();
		
			_lrrRefregerants=new LRRRefrigerants();
			_app.DBManagerObj.PopulateCollection(_lrrRefregerants,false);
			
		}
		#endregion
		#region BIndGridAvailableRefrigerants
		private void BIndGridAvailableRefrigerants()
		{
			
			//			_lrrRefregerants=new LRRRefrigerants();
			//			_dbManager.PopulateCollection(_lrrRefregerants,false);
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridAvailableRefrigerants.SuspendLayout();
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridAvailableRefrigerants,gridAvailableRefrigerants.TableDescriptor,_lrrRefregerants.ItemType,null,true,null,null,true);
//			RelativeWidths.Add("RefrigerantName",50);
//			RelativeWidths.Add("RefrigerantDescription",50);
//			SyncGridUtilities.InitializeGridColumnsWidth(gridAvailableRefrigerants,RelativeWidths );

			//Set the data store 
			gridAvailableRefrigerants.DataSource = _lrrRefregerants;
			
			//Resume the Layout of the Grid...
			gridAvailableRefrigerants.ResumeLayout(false);

			gridAvailableRefrigerants.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_REFRIGERANTS") +" {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");

			//Add the parent table for the Relations...
			gridAvailableRefrigerants.Engine.SourceListSet.Add("ParentTable",_lrrRefregerants);
			this.gridAvailableRefrigerants.TableModel.Model.HideCols["Base"]=true;

			string[,] arry=new string[,]{{"RefrigerantDescription","255"}};
			Validations	obj=new Validations(gridAvailableRefrigerants,arry);
		}
		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BIndGridAvailableRefrigerants();
			
		}

		public void Save()
		{
		

			//***************Refrigerants************************

			if(_lrrRefregerants.GetChanges().Count>0)
			{
				_app.DBManagerObj.CommitCollection(_lrrRefregerants.GetChanges());
				OptionsUserControl.saved	=true;
				
			}
			if(_lrrRefregerants.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
			else
			{

				_lrrRefregerants.RefreshCollection();

			}
			InitDataSource();
			BIndGridAvailableRefrigerants();
		
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridAvailableRefrigerants.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAvailableRefrigerants,false);
			}

		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion


		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true; 
            }
			return base.ProcessCmdKey (ref msg, keyData);
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridAvailableRefrigerants_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				LRRRefrigerant lrrRefrigerant=gridAvailableRefrigerants.CurrencyManager.Current as LRRRefrigerant;
				if(lrrRefrigerant.Base==true)
				{
					e.Cancel=true;
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}


		}

		private void gridAvailableRefrigerants_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			if(e.Inner.RowIndex > 3 && e.Inner.ColIndex > 0)
			{
				if(this.gridAvailableRefrigerants.TableModel.Model[e.Inner.RowIndex,3].CellType=="CheckBox")
				{
					object o = this.gridAvailableRefrigerants.TableModel.Model[e.Inner.RowIndex,3].CellValue;
					if(o!=null)
					{
						bool val = o.ToString() == true.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if(val)
						{
							e.Inner.Style.CellType="Static";
							e.Inner.Style.BackColor = Color.LightGray;
						}
					}
				}
			}
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridAvailableRefrigerants);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlAvailableRefregerants.PrintPreview implementation
			if(gridAvailableRefrigerants.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridAvailableRefrigerants,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlAvailableRefregerants.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlAvailableRefregerants.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlAvailableRefregerants.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlAvailableRefregerants.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			// TODO:  Add UserControlAvailableRefregerants.PageSetup implementation
		}

		public void Undo()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlAvailableRefregerants.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlAvailableRefregerants.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlAvailableRefregerants.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlAvailableRefregerants.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlAvailableRefregerants.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlAvailableRefregerants.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
