using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;  
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlChemicalComponents.
	/// </summary>
	public class UserControlChemicalComponents : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp								_app;
		private LRRDataStore						_lrrDataStore ;
		private LRRLookUpQualifiers					_LRRLookUpQualifiers=null;
		private LRRLookUpProperties					_lookUpProperties=null;
		private LRRRefrigerants						_lrrRefregerants=null;
		private string								_recordValueChanged="0";
		private string								_ChemicalFormula="";
		private string								_Phase="";
		private LRRPropertyTypes					_lrrPropertyTypes=null;
		private TabControl							_parentTabControl;
		private TabPage								_parentTabPage;
		private LRRLookUpProperties					_orglookUpProperties = null;
		private LRRLookUpQualifiers					_orgLookUpQualifiers = null;
		private Hashtable							_htLookUpProperties = null;
		private Hashtable							_htLookUpQualifiers = null;
		private Hashtable							_htProperties = null;
		private LRRSiteComponentProperties			siteCompPpties=null;
		private LRRMasterProperties					masterPpties=null;
		private LRRSearchCriteriaPropertyTypes		searchCriteriaPptyTypes=null;
		private GridExcelFormatter	_gridExcelFormatter = new GridExcelFormatter(); 
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridQualities;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridChemicalComponents;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Panel panel4;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridConfiguration;

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlChemicalComponents()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrDataStore= _app.LRRDataStoreObj;
			InitDataSource();
			_gridExcelFormatter.WireGrid(this.gridConfiguration);
			_gridExcelFormatter.WireGrid(this.gridChemicalComponents);
			_gridExcelFormatter.WireGrid(this.gridQualities); 
			SyncGridUtilities.InitializeGridLookAndFeel(gridChemicalComponents);
			SyncGridUtilities.InitializeGridLookAndFeel(gridConfiguration);
			SyncGridUtilities.InitializeGridLookAndFeel(gridQualities);
			BindGridChemicalComponents();
			BindGridQualities();
			BindGridConfiguration();
			//			SyncGridUtilities.ApplyViewStyleOnGrid(gridConfiguration,gridConfiguration.TableDescriptor);
			//			SyncGridUtilities.ApplyViewStyleOnGrid(gridChemicalComponents,gridChemicalComponents.TableDescriptor);
			//			SyncGridUtilities.ApplyViewStyleOnGrid(gridQualities,gridQualities.TableDescriptor);
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.gridQualities = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panel2 = new System.Windows.Forms.Panel();
			this.gridConfiguration = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridChemicalComponents = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel4 = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.panel3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridQualities)).BeginInit();
			this.panel2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridConfiguration)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridChemicalComponents)).BeginInit();
			this.panel4.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.panel3);
			this.panel1.Controls.Add(this.splitter2);
			this.panel1.Controls.Add(this.panel2);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panelCC1";
			this.panel1.Size = new System.Drawing.Size(448, 632);
			this.panel1.TabIndex = 5;
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.gridQualities);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel3.Location = new System.Drawing.Point(0, 339);
			this.panel3.Name = "panelCC3";
			this.panel3.Size = new System.Drawing.Size(448, 293);
			this.panel3.TabIndex = 2;
			// 
			// gridQualities
			// 
			this.gridQualities.BackColor = System.Drawing.SystemColors.Window;
			this.gridQualities.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridQualities.Location = new System.Drawing.Point(0, 0);
			this.gridQualities.Name = "gridQualities";
			this.gridQualities.Size = new System.Drawing.Size(448, 293);
			this.gridQualities.TabIndex = 9;
			this.gridQualities.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridQualities.Text = "gridQualities";
			this.gridQualities.TopLevelGroupOptions.CaptionText = "Qualifier Selection: {RecordCount} Items";
			this.gridQualities.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridQualities.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridQualities.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridQualities.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridQualities.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridQualities.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridQualities_RecordDeleting);
			this.gridQualities.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridQualities_RecordValueChanged);
			this.gridQualities.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridQualities_TableControlCurrentCellShowingDropDown);
			this.gridQualities.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.gridQualities_TableControlCurrentCellCloseDropDown);
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(0, 336);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(448, 3);
			this.splitter2.TabIndex = 1;
			this.splitter2.TabStop = false;
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.gridConfiguration);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panelCC2";
			this.panel2.Size = new System.Drawing.Size(448, 336);
			this.panel2.TabIndex = 0;
			// 
			// gridConfiguration
			// 
			this.gridConfiguration.BackColor = System.Drawing.SystemColors.Window;
			this.gridConfiguration.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridConfiguration.Location = new System.Drawing.Point(0, 0);
			this.gridConfiguration.Name = "gridConfiguration";
			this.gridConfiguration.Size = new System.Drawing.Size(448, 336);
			this.gridConfiguration.TabIndex = 5;
			this.gridConfiguration.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridConfiguration.TableOptions.AllowSortColumns = true;
			this.gridConfiguration.Text = "Configuration";
			this.gridConfiguration.TopLevelGroupOptions.CaptionText = "Site Chemical Component Groups: {RecordCount} Items";
			this.gridConfiguration.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridConfiguration.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridConfiguration.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridConfiguration.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridConfiguration.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridConfiguration.VersionInfo = "3.301.0.0";
			this.gridConfiguration.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridConfiguration_RecordDeleting);
			this.gridConfiguration.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridConfiguration_TableControlPrepareViewStyleInfo);
			this.gridConfiguration.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridConfiguration_RecordValueChanged);
			this.gridConfiguration.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridConfiguration_CurrentRecordContextChange);
			this.gridConfiguration.TableControlCheckBoxClick+=new GridTableControlCellClickEventHandler(gridConfiguration_TableControlCheckBoxClick);  
			// 
			// gridChemicalComponents
			// 
			this.gridChemicalComponents.BackColor = System.Drawing.SystemColors.Window;
			this.gridChemicalComponents.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridChemicalComponents.Location = new System.Drawing.Point(0, 0);
			this.gridChemicalComponents.Name = "gridChemicalComponents";
			this.gridChemicalComponents.Size = new System.Drawing.Size(533, 632);
			this.gridChemicalComponents.TabIndex = 8;
			this.gridChemicalComponents.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridChemicalComponents.Text = "gridGroupingControl1";
			this.gridChemicalComponents.TopLevelGroupOptions.CaptionText = "Chemical Components: {RecordCount} Items";
			this.gridChemicalComponents.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridChemicalComponents.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridChemicalComponents.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridChemicalComponents.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridChemicalComponents.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridChemicalComponents.VersionInfo = "3.301.0.0";
			this.gridChemicalComponents.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridChemicalComponents_RecordDeleting);
			this.gridChemicalComponents.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridChemicalComponents_TableControlPrepareViewStyleInfo);
			this.gridChemicalComponents.TableControlCurrentCellChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridChemicalComponents_TableControlCurrentCellChanging);
			this.gridChemicalComponents.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridChemicalComponents_RecordValueChanged);
			this.gridChemicalComponents.TableControl.CurrentCellStartEditing+=new CancelEventHandler(TableControl_CurrentCellStartEditing);    
			this.gridChemicalComponents.CurrentRecordContextChange+=new CurrentRecordContextChangeEventHandler(gridChemicalComponents_CurrentRecordContextChange);
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(448, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 632);
			this.splitter1.TabIndex = 6;
			this.splitter1.TabStop = false;
			// 
			// panel4
			// 
			this.panel4.Controls.Add(this.gridChemicalComponents);
			this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel4.Location = new System.Drawing.Point(451, 0);
			this.panel4.Name = "panelCC4";
			this.panel4.Size = new System.Drawing.Size(533, 632);
			this.panel4.TabIndex = 9;
			// 
			// UserControlChemicalComponents
			// 
			this.Controls.Add(this.panel4);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel1);
			this.Name = "UserControlChemicalComponents";
			this.Size = new System.Drawing.Size(984, 632);
			this.Tag = "SID_CHEMCOMP";
			this.panel1.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridQualities)).EndInit();
			this.panel2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridConfiguration)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridChemicalComponents)).EndInit();
			this.panel4.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods

		# region InitDataSource
		private void InitDataSource()
		{
			
			if(_lrrRefregerants != null)
				_lrrRefregerants.Clear();
			
			if(_lrrPropertyTypes != null)
				_lrrPropertyTypes.Clear();
			
			if(_orglookUpProperties != null)
				_orglookUpProperties.Clear();
			
			if(_orgLookUpQualifiers != null)
				_orgLookUpQualifiers.Clear();
			
			if(_lookUpProperties != null)
				_lookUpProperties.Clear();
			
			if(_LRRLookUpQualifiers != null)
				_LRRLookUpQualifiers.Clear();

			if(siteCompPpties != null)
				siteCompPpties.Clear();
			
			if(masterPpties != null)
				masterPpties.Clear();

			if(searchCriteriaPptyTypes != null)
				searchCriteriaPptyTypes.Clear();



			_lookUpProperties=new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(_lookUpProperties," where LookUpPropertiesID =null",false);

			_orglookUpProperties=new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(_orglookUpProperties,false);//"  WHERE propertyid  in (select id from propertytypes where IsDataArray=false)",false);

			_lrrRefregerants=new LRRRefrigerants();
			_app.DBManagerObj.PopulateCollection(_lrrRefregerants,false);
			
			_LRRLookUpQualifiers=new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(_LRRLookUpQualifiers,false);

			_orgLookUpQualifiers = new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(_orgLookUpQualifiers,false);
			//			_LRRLookUpQualifiers = _orgLookUpQualifiers;

			_lrrPropertyTypes=new LRRPropertyTypes();
			_app.DBManagerObj.PopulateCollection(_lrrPropertyTypes,"  where id<>'1' and id <> '2' and IsDataArray=false",false);

			PopulateHashTables();

			siteCompPpties=new LRRSiteComponentProperties();
			_app.DBManagerObj.PopulateCollection(siteCompPpties,false);
			
			masterPpties=new LRRMasterProperties();
			_app.DBManagerObj.PopulateCollection(masterPpties,false);

			searchCriteriaPptyTypes=new LRRSearchCriteriaPropertyTypes();
			_app.DBManagerObj.PopulateCollection(searchCriteriaPptyTypes,false);

		}
		#endregion
		#region BindgridQualities

		private void BindGridQualities()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridQualities.SuspendLayout();

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_LRRLookUpQualifiers.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridQualities,_LRRLookUpQualifiers.ItemType,null,fkData);
			
			//Set the data store 
			gridQualities.DataSource = _LRRLookUpQualifiers;
			
			gridQualities.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_QUALIFIER_SELECTION") +" { RecordCount } " + LRRHeaderText.GetHeaderString("SID_ITEMS");  
			
			RelativeWidths.Add("QualifierID",25);
			RelativeWidths.Add("UOMTypeID",20);
			SyncGridUtilities.InitializeGridColumnsWidth(gridQualities,RelativeWidths );
			//Resume the Layout of the Grid...
			gridQualities.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridQualities.Engine.SourceListSet.Add("LookupQualifiers",_LRRLookUpQualifiers);
			
		}
		#endregion
		#region BindGridChemicalComponents
		private void BindGridChemicalComponents()
		{

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lookUpProperties.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridChemicalComponents,gridChemicalComponents.TableDescriptor,_lookUpProperties.ItemType,null,true,fkData,null,false);
			//SyncGridUtilities.InitializeGridColumns(gridConfiguration,gridConfiguration.TableDescriptor,_lrrPropertyTypes.ItemType,null,true,fkData,null,true);

			gridChemicalComponents.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_CHEMICAL_COMP_SELECTION") +" { RecordCount } " + LRRHeaderText.GetHeaderString("SID_ITEMS");  
			gridChemicalComponents.DataSource = _lookUpProperties;
			gridChemicalComponents.SourceListSet.Add("LookupProperties",_lookUpProperties);
			this.gridChemicalComponents.TableModel.Model.HideCols["Base"]=true;
			//this.gridChemicalComponents.TableModel.Model.HideCols["Term"]=true;
			this.gridChemicalComponents.TableDescriptor.Columns.Remove("Term");

			string[,] arry=new string[,]{{"Description","255"}};
			Validations	objValidations=new Validations(gridChemicalComponents,arry);
		}
		#endregion
		#region BindGridConfiguration

		private void BindGridConfiguration()
		{
			//			_lrrPropertyTypes=new LRRPropertyTypes();
			//			_dbManager.PopulateCollection(_lrrPropertyTypes,"  where id<>'1' and id <> '2'",false);
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridConfiguration.SuspendLayout();

			
			SyncGridUtilities.InitializeGridColumns(gridConfiguration,gridConfiguration.TableDescriptor,_lrrPropertyTypes.ItemType,null,true,null,null,true);
			gridConfiguration.TableDescriptor.Columns.Remove("UOMTypeID_Name");
            gridConfiguration.TableDescriptor.Columns.Remove("InputTypeID_Name");
            gridConfiguration.TableDescriptor.Columns.Remove("Direction_Direction");
            gridConfiguration.TableDescriptor.Columns.Remove("Derivation_DerivationType");
			//			RelativeWidths.Add("Name",50);
			//			RelativeWidths.Add("Description",65);
			//			
			//			SyncGridUtilities.InitializeGridColumnsWidth(gridConfiguration,RelativeWidths );
			//Set the data store 
			
			//			gridConfiguration.TableDescriptor.Appearance.AnyCell.ShowButtons=GridShowButtons.Show;
			gridConfiguration.TableDescriptor.AllowNew = true;
			gridConfiguration.TableDescriptor.AllowEdit = true;
            gridConfiguration.DataSource = _lrrPropertyTypes;
			gridConfiguration.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_SITE_CHEMICALCOMP_GROUP") +" { RecordCount } " + LRRHeaderText.GetHeaderString("SID_ITEMS");  
			//Resume the Layout of the Grid...
			gridConfiguration.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridConfiguration.Engine.SourceListSet.Add("ParentTable",_lrrPropertyTypes);
            this.gridConfiguration.TableModel.Model.HideCols["Base"]=true;

			string[,] arry=new string[,]{{"Description","255"}};
			Validations	obj=new Validations(gridConfiguration,arry);
		}

		#endregion
		#region RefreshGridQualifiers()
		private void RefreshGridQualifiers()
		{
			//gridQualities.DataSource = null;
			Hashtable	RelativeWidths=new Hashtable();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_LRRLookUpQualifiers.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			SyncGridUtilities.InitializeGridColumns(gridQualities,_LRRLookUpQualifiers.ItemType,null,fkData);
			//Set the data store 
			gridQualities.DataSource = _LRRLookUpQualifiers;
			gridQualities.Engine.SourceListSet.Add("LookupQualifiers",_LRRLookUpQualifiers);
		}

		#endregion
		#region RefreshGridChemicalComponents()
		private void RefreshGridChemicalComponents()
		{
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lookUpProperties.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			SyncGridUtilities.InitializeGridColumns(gridChemicalComponents,gridChemicalComponents.TableDescriptor,_lookUpProperties.ItemType,null,true,fkData,null,false);
			//SyncGridUtilities.InitializeGridColumns(gridChemicalComponents,_lookUpProperties.ItemType,null,fkData);
			gridChemicalComponents.DataSource = _lookUpProperties;
			gridChemicalComponents.SourceListSet.Add("LookupProperties",_lookUpProperties);
			this.gridChemicalComponents.TableModel.Model.HideCols["Base"]=true;
			//this.gridChemicalComponents.TableModel.Model.HideCols["Term"]=true;
			this.gridChemicalComponents.TableDescriptor.Columns.Remove("Term");
		}

		#endregion
		private void PopulateHashTables()
		{
			_htLookUpProperties = null;
			_htLookUpProperties = new Hashtable();
			foreach(LRRLookUpProperty objPropertyCons in _lookUpProperties)
			{
				_htLookUpProperties.Add(objPropertyCons.LookUpPropertiesID,objPropertyCons);
			}

			
			_htLookUpQualifiers = null;
			_htLookUpQualifiers = new Hashtable();
			foreach(LRRLookUpQualifier objPropertyQual in _LRRLookUpQualifiers)
			{
				_htLookUpQualifiers.Add(objPropertyQual.LookUpQualifierID,objPropertyQual);
			}

			//LRRModel.SiteComponentPropertiesObj.FilterPropertiesByPropertyType
			_htProperties = null;
			_htProperties = new Hashtable();
			foreach(LRRPropertyType objPropertyType in _lrrPropertyTypes)
			{
				bool blnPropertyExists = false;
				string sPropertyID = objPropertyType.ID == null ? "" : objPropertyType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

				if(LRRModel.SiteComponentPropertiesObj.FilterPropertiesByPropertyType(sPropertyID).Count > 0)
					blnPropertyExists = true;

				_htProperties.Add(sPropertyID,blnPropertyExists);
			}


		}
		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BindGridConfiguration();
			BindGridChemicalComponents();
			BindGridQualities();
			_recordValueChanged="0";
		}

		public void Save()
		{
			//***************PropertyTypes************************
			LRRPropertyType _lrrPropertyType = null;
			if(gridConfiguration.CurrencyManager.Position != -1)
			{
				_lrrPropertyType=gridConfiguration.CurrencyManager.Current as LRRPropertyType;
			}
			foreach (LRRPropertyType  lrrPropertyType in _lrrPropertyTypes)
			{
				if(lrrPropertyType.ObjectState != DBOperation.DELETE)
				{
					string sName = lrrPropertyType.PropertyType  == null ? "" : lrrPropertyType.PropertyType.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					string sPropID = lrrPropertyType.ID == null ? "" : lrrPropertyType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
		
					if(lrrPropertyType.PropertyType == null || lrrPropertyType.PropertyType=="") 
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_NAME_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
					foreach (LRRPropertyType  lrrPropType in _lrrPropertyTypes)
					{
						if((lrrPropType.ID != sPropID) && (lrrPropType.ObjectState != DBOperation.DELETE))
						{
							string sPropName = lrrPropType.PropertyType  == null ? "" : lrrPropType.PropertyType.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							if(sPropName.ToUpper() == sName.ToUpper())
							{
								//MessageBox.Show("Name - " + sPropName + " already exists. Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
								string[] s = new string[1];
								s[0] = sPropName;
								LRRMessagBox.ShowMessage("SID_PROP_DUPLICATE","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);     
								return;
							}
						}
					}
				}

			}
			if(_lrrPropertyTypes.GetChanges().Count>0)
			{
				LRRPropertyTypes lpts = _lrrPropertyTypes.GetChanges();
				foreach(LRRPropertyType lpt in lpts)
				{
					if((lpt.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE) && (lpt.ArrListUpdatedColNames.Contains("ModeID")))   
					{
						ArrayList CreatedQualiferValues = new ArrayList();
						ArrayList DeletedQualifierValues = new ArrayList();
						bool _modeID = lpt.ModeID;
						LRRModel.CascadeGPChanges(lpt,_modeID,out DeletedQualifierValues,out CreatedQualiferValues);
						LRRSiteGroupPropertyQualifierValues ToDeleteQvalues = new LRRSiteGroupPropertyQualifierValues();
						LRRSiteGroupPropertyQualifierValues ToInsertQvalues = new LRRSiteGroupPropertyQualifierValues();
						if(DeletedQualifierValues.Count > 0)
						{
							for(int i = 0;i< DeletedQualifierValues.Count;i++)
							{
								LRRSiteGroupPropertyQualifierValue qValue = DeletedQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
								LRRModel.SiteGroupPropertyQualifierValuesObj.Remove(qValue);
								ToDeleteQvalues.Add(qValue); 
							}
							for(int j = 0;j<CreatedQualiferValues.Count;j++)
							{
								LRRSiteGroupPropertyQualifierValue qValue = CreatedQualiferValues[j] as LRRSiteGroupPropertyQualifierValue;
								LRRModel.SiteGroupPropertyQualifierValuesObj.Add(qValue);
								ToInsertQvalues.Add(qValue); 
							}
							_app.DBManagerObj.ExecuteBatchDelete(ToDeleteQvalues);  
							_app.DBManagerObj.ExecuteBatchInsert(ToInsertQvalues);
							LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection(); 
						}
						LRRMasterProperties masterProperties  = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByPropType(lpt.ID);
						foreach(LRRMasterProperty lmp in masterProperties)
						{
							if(lmp.ModeID != _modeID)
							{
								lmp.ModeID = _modeID;
								LRRGroupProperties lgps = LRRModel.MasterGroupPropertiesObj.GetGroupPropertiesForPropTypeAndPropertyID(lmp.Type,lmp.PropID);
								foreach(LRRGroupProperty lgp in lgps)
								{
									lgp.ModeID = _modeID;
								}
								LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(lmp.PropID);
								foreach(LRRSiteComponentProperty lscp in lscps)
								{
									lscp.ModeID = _modeID;
									LRRSiteComponentGroupProperties lscgps = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromSiteCompPropID(lscp.ID);
									foreach(LRRSiteComponentGroupProperty lscgp in lscgps)
									{
										lscgp.ModeID = _modeID;
									}
									_app.DBManagerObj.ExecuteBatchUpdate(lscgps.GetChanges());  
								}
								_app.DBManagerObj.ExecuteBatchUpdate(lscps.GetChanges());  
								_app.DBManagerObj.ExecuteBatchUpdate(masterProperties.GetChanges());   
							}
						}
					}
				}
				_app.DBManagerObj.CommitCollection(_lrrPropertyTypes.GetChanges());
				OptionsUserControl.saved	=true;
			}
			if(_lrrPropertyTypes.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
			else
			{
				
				_lrrPropertyTypes.RefreshCollection();
			}
			//***************LooKUpPropertyTypes************************
			if(_lrrPropertyType != null)
			{
				LRRLookUpProperties lookUpProps = _lookUpProperties.GetChanges();
				if(lookUpProps.Count>0)
				{
					foreach (LRRLookUpProperty lrrLookupProperty in lookUpProps)
					{
						lrrLookupProperty.PropertyID=_lrrPropertyType.ID;
					}

                    foreach (LRRLookUpProperty lrrLookupProperty in lookUpProps)
					{
                        LRRPropertyType propType = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(lrrLookupProperty.PropertyID);    
						if(lrrLookupProperty.ObjectState != DBOperation.DELETE)
						{
							string LookupName = lrrLookupProperty.Name  == null ? "" : lrrLookupProperty.Name .ToString(Symcon.BusinessObjects.SymConverter.Culture);
							string sLookUpID = lrrLookupProperty.LookUpPropertiesID == null ? "" : lrrLookupProperty.LookUpPropertiesID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
		
							if(lrrLookupProperty.Name == null || lrrLookupProperty.Name=="") 
							{
								LRRMessagBox.ShowMessage("SID_SAVEABORT_NAME_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
								return;
							}
                            if (propType.IsChemical)
                            {
                                if (lrrLookupProperty.MaterialID.ToString(Symcon.BusinessObjects.SymConverter.Culture) == "0")
                                {
                                    LRRMessagBox.ShowMessage("SID_SAVEABORT_IUPACNAME_NULL", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                    return;
                                }
                            }
							foreach (LRRLookUpProperty  objLookUp in _lookUpProperties)
							{
								if((objLookUp.LookUpPropertiesID != sLookUpID) && (objLookUp.ObjectState != DBOperation.DELETE))
								{
									string slookUpProp = objLookUp.Name  == null ? "" : objLookUp.Name .ToString(Symcon.BusinessObjects.SymConverter.Culture);
									if(slookUpProp.ToUpper() == LookupName.ToUpper())
									{
										//MessageBox.Show("Name - " + slookUpProp + " already exists. Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
										string[] s = new string[1];
										s[0] = slookUpProp;
										LRRMessagBox.ShowMessage("SID_PROP_DUPLICATE","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);     
										return;
									}
								}
							}
						}
					}
				
					if(lookUpProps.Count>0)
					{
						_app.DBManagerObj.CommitCollection(lookUpProps);
						OptionsUserControl.saved	=true;
						for(int i = 0 ;i<lookUpProps.Count;i++)
						{
							LRRLookUpProperty lookUpProp = lookUpProps[i] as LRRLookUpProperty;
							if(lookUpProp.ObjectState == DBOperation.INSERT)
							{
								LRRModel.ChildModel.LookUpProperties.Add(lookUpProp);  
							}
						}
						LookUpPropertiesUtility lookUp = new LookUpPropertiesUtility();
						lookUp.UpdateMasterLookUpProperties(_lrrPropertyType.ID);
						lookUp.UpdateSiteComponentsLookUpProperties(_lrrPropertyType.ID);
					
				        if(lookUpProps.HasError)
						{
							LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
							return;
						}
						
						lookUpProps.RefreshCollection();
						_lookUpProperties.RefreshCollection();
					}
				}
			}
			//***************Qualifiers************************

			if(_lrrPropertyType != null)
			{
				LRRLookUpQualifiers lookUpQualifiers = _LRRLookUpQualifiers.GetChanges();
				if(lookUpQualifiers.Count>0)
				{
					foreach (LRRLookUpQualifier LRRLookUpQualifier in lookUpQualifiers)
					{
						if(LRRLookUpQualifier.ObjectState != DBOperation.DELETE)
						{
							LRRLookUpQualifier.PropertyID=_lrrPropertyType.ID;
						}
					}
					foreach (LRRLookUpQualifier LRRLookUpQualifier in lookUpQualifiers)
					{
						if(LRRLookUpQualifier.ObjectState != DBOperation.DELETE)  
						{
							if(LRRLookUpQualifier.QualifierID == null)
							{
								LRRMessagBox.ShowMessage("SID_SAVEABORT_QUALIFIERNAME_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
								return;
							}
							if(LRRLookUpQualifier.UOMTypeID == null)
							{
								LRRMessagBox.ShowMessage("SID_SAVEABORT_UOM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
								return;
							}
						}
						if(LRRLookUpQualifier.ObjectState == DBOperation.INSERT)
						{
							LRRModel.LookUpQualifiers.Add(LRRLookUpQualifier);   

						}
					}
					if(lookUpQualifiers.GetChanges().Count>0)
					{
						_app.DBManagerObj.CommitCollection(lookUpQualifiers);
						OptionsUserControl.saved	=true;
					}
					if(lookUpQualifiers.HasError)
					{
						LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
						return;
					}
					lookUpQualifiers.RefreshCollection();
					_LRRLookUpQualifiers.RefreshCollection();
					//--Incase the qualifier information has been modified, update the values
					string sPropertyTypeID =  _lrrPropertyType.ID == null ? "" : _lrrPropertyType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					//sPropertyTypeID = "'" + sPropertyTypeID + "'";
					GroupedPropertiesUtility objUtil = new GroupedPropertiesUtility();
					objUtil.UpdateGroupedPropertiesByPropertyType(sPropertyTypeID);
				}
			}
			_LRRLookUpQualifiers.RefreshCollection();
			_lrrPropertyTypes.RefreshCollection();
			_lookUpProperties.RefreshCollection();

			InitDataSource();
			BindGridConfiguration();
			BindGridChemicalComponents();
			BindGridQualities();
			_recordValueChanged = "0";
		}
		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridQualities.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridQualities,true);
			}
			if(gridChemicalComponents.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridChemicalComponents,true);
			}
			if(gridConfiguration.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridConfiguration,true);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridChemicalComponents);
			SyncGridUtilities.PasteSelection(gridQualities);
			SyncGridUtilities.PasteSelection(gridConfiguration);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region Events
		private void gridConfiguration_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			LRRPropertyType _lrrpropType=null;
			if (gridConfiguration.CurrencyManager.Position!=-1)
			{	
				_lrrpropType	=gridConfiguration.CurrencyManager.Current as LRRPropertyType;

                if (_lrrpropType != null)
                {
                    if (_lrrpropType.IsChemical)
                    {
                        ApplyStyleForChemicalGP(true);
                    }
                    else
                    {
                        ApplyStyleForChemicalGP(false);
                    }
                }
				
				if (gridConfiguration.CurrencyManager.Count == 0 )
					return;

				if(e.Table.CurrentRecord != null)
				{
					if(e.Action == CurrentRecordAction.EnterRecordComplete && e.Table.CurrentRecord.Kind.ToString(Symcon.BusinessObjects.SymConverter.Culture)!= "AddNewRecord")
					{
						string propID=_lrrpropType.ID;
						_LRRLookUpQualifiers = _orgLookUpQualifiers;
						_lookUpProperties = _orglookUpProperties;
						_LRRLookUpQualifiers = _LRRLookUpQualifiers.getLookUpQualifiersForPropType(propID);
						_lookUpProperties = _lookUpProperties.getLookUpPropertiesForPropTypeID(propID);
                        
						RefreshGridQualifiers();
						RefreshGridChemicalComponents();
						return;
					}	

				}
				if(e.Table.CurrentRecord == null && e.Action==CurrentRecordAction.EnterRecordCalled)
				{
					string propID=_lrrpropType.ID;
					_LRRLookUpQualifiers = _orgLookUpQualifiers;
					_lookUpProperties = _orglookUpProperties;
					_LRRLookUpQualifiers = _LRRLookUpQualifiers.getLookUpQualifiersForPropType(null);
					_lookUpProperties = _lookUpProperties.getLookUpPropertiesForPropTypeID(null);
					RefreshGridQualifiers();
					RefreshGridChemicalComponents();
					return;
				}
                
				if (gridConfiguration.CurrencyManager.Count > 0 )
				{
					if(_lrrpropType!= null)
					{
						if(e.Action == CurrentRecordAction.NavigateCalled)
						{
							if(_recordValueChanged == "1")
							{
								if(LRRMessagBox.ShowMessage("SID_SAVE_QUES","SID_QUES",MessageBoxButtons.YesNo,MessageBoxIcon.Question)== DialogResult.Yes)
								{
									e.Cancel = true;
									Save();
								}
								else
								{
									_recordValueChanged ="0";
									e.Cancel = true;
								}
							}
						}
					}
				}
			}
		}

		private void gridConfiguration_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			_recordValueChanged="1";
		}

		private void gridConfiguration_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			/*if(e.Inner.RowIndex > 3 && e.Inner.ColIndex > 0)
			{
				if(this.gridConfiguration.TableModel.Model[e.Inner.RowIndex,3].CellType=="CheckBox")
				{
					object o = this.gridConfiguration.TableModel.Model[e.Inner.RowIndex,3].CellValue;
					if(o!=null)
					{
						bool val = o.ToString() == true.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if(val)
						{
							e.Inner.Style.CellType="Static";
							e.Inner.Style.BackColor = Color.LightGray;
						}
					}
				}
			}*/
		}

		private void gridChemicalComponents_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			if(e.Inner.RowIndex > 3 && e.Inner.ColIndex > 0)
			{
				if(this.gridChemicalComponents.TableModel.Model[e.Inner.RowIndex,4].CellType=="StandardValuesCell")
				{
					object o = this.gridChemicalComponents.TableModel.Model[e.Inner.RowIndex,4].CellValue;
					if(o!=null)
					{
						bool val = o.ToString() == true.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if(val)
						{
							e.Inner.Style.ReadOnly=true;
							e.Inner.Style.ShowButtons=GridShowButtons.Hide;
							//e.Inner.Style.CellType="Static";
							e.Inner.Style.BackColor = Color.LightGray;
						}
					}
				}
			}
		}

		private void gridChemicalComponents_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			_recordValueChanged ="1";
			try
			{
				string sMaterialID = "";
				sMaterialID = ((LRRLookUpProperty)e.Record.GetData()).MaterialID.ToString(Symcon.BusinessObjects.SymConverter.Culture); 
				
				LRRMaterials objMaterials = (LRRMaterials)_lrrDataStore.GetCopyOfDataStoreObject(typeof(LRRMaterials));
				if(sMaterialID != "" && sMaterialID != null && sMaterialID != "0")
				{
					//objMaterials.ItemFilter  = "ID = " + sMaterialID; 
					_app.DBManagerObj.PopulateCollection(objMaterials,"  where ID="+sMaterialID);
					_ChemicalFormula= objMaterials[0].ChemicalFormula.ToString(Symcon.BusinessObjects.SymConverter.Culture); 
					e.Record.SetValue("ChemicalFormula", _ChemicalFormula);
					_Phase= objMaterials[0].Phase.ToString(Symcon.BusinessObjects.SymConverter.Culture); 
					e.Record.SetValue("Phase", _Phase);
				
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UserControlChemicalComponents),"gridChemicalComponents_RecordValueChanged Event:"+ex.Message  ,Logger.Level.Debug);
				return;
			}
		}
	
		private void gridQualities_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			_recordValueChanged="1";
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridConfiguration_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				LRRPropertyType objPropType = e.Record.GetData() as LRRPropertyType;
				if(siteCompPpties.FilterPropertiesByPropertyType(objPropType.ID).Count>0)
				{
					LRRMessagBox.ShowMessage("SID_CHEMCOMP_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
					e.Cancel=true;
					return;
				}
				if(masterPpties.GetMasterPropertiesByPropType(objPropType.ID).Count>0)
				{
					LRRMessagBox.ShowMessage("SID_CHEMCOMP_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
					e.Cancel=true;
					return;
				}
				//			if(_lookUpProperties.getLookUpPropertiesForPropTypeID(objPropType.ID).Count>0)
				//			{
				//				LRRMessagBox.ShowMessage("SID_CHEMCOMP_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
				//				e.Cancel=true;
				//				return;
				//			}
				//			if(_LRRLookUpQualifiers.getLookUpQualifiersForPropType(objPropType.ID).Count>0)
				//			{
				//				LRRMessagBox.ShowMessage("SID_CHEMCOMP_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
				//				e.Cancel=true;
				//				return;
				//			}
				if(searchCriteriaPptyTypes.FilterByPropertyType(objPropType.ID).Count>0)
				{
					LRRMessagBox.ShowMessage("SID_CHEMCOMP_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
					e.Cancel=true;
					return;
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}
		}
			
		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		
		private void gridQualities_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
				return;
			}
		}

		private void gridChemicalComponents_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			e.Cancel=true;
		}
		
		private void gridQualities_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			if(gridQualities.TableModel.GetHeaderColumnDescriptorAt(e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_QUALIFIER") )
			{
				LRRLookUpQualifier currLookUpQualifier = e.TableControl.Table.CurrentRecord.GetData() as LRRLookUpQualifier; 	
				if(currLookUpQualifier != null)
				{
					string sPropertyID = currLookUpQualifier.PropertyID == null ? "" : currLookUpQualifier.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					if(sPropertyID != "")
					{
						if(_htProperties[sPropertyID].ToString().ToUpper() == "TRUE")
						{
							string sLookupQualID = currLookUpQualifier.LookUpQualifierID == null ? "" : currLookUpQualifier.LookUpQualifierID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
							if(_htLookUpQualifiers.ContainsKey(sLookupQualID))
								e.Inner.Cancel = true;
						}
					}
				}
			}
		}

		private void gridChemicalComponents_TableControlCurrentCellChanging(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
		{
			if(gridChemicalComponents.TableModel.GetHeaderColumnDescriptorAt(e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_NAME"))
			{
				LRRLookUpProperty currLookUpProperty = e.TableControl.Table.CurrentRecord.GetData() as LRRLookUpProperty; 	
				if(currLookUpProperty != null)
				{
					string sPropertyID = currLookUpProperty.PropertyID == null ? "" : currLookUpProperty.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					if(sPropertyID != "")
					{
						if(_htProperties[sPropertyID].ToString().ToUpper() == "TRUE")
						{
							string sLookupPropID = currLookUpProperty.LookUpPropertiesID == null ? "" : currLookUpProperty.LookUpPropertiesID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
							if(_htLookUpProperties.ContainsKey(sLookupPropID))
								e.Inner.Cancel = true;
						}
					}
				}
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridQualities);
			SyncGridUtilities.ClearSort(gridChemicalComponents);
			SyncGridUtilities.ClearSort(gridConfiguration);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlChemicalComponents.PrintPreview implementation
			if(gridQualities.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridQualities,true);
			}
			if(gridChemicalComponents.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridChemicalComponents,true);
			}
			if(gridConfiguration.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridConfiguration,true);
			}

		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlChemicalComponents.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlChemicalComponents.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlChemicalComponents.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlChemicalComponents.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlChemicalComponents.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlChemicalComponents.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlChemicalComponents.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlChemicalComponents.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlChemicalComponents.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlChemicalComponents.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlChemicalComponents.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		private void gridConfiguration_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
		{
			int iRow = e.Inner.RowIndex;  
			int iCol = e.Inner.ColIndex;
            string colName = e.TableControl.Table.TableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
            if (colName == LRRHeaderText.GetHeaderString("SID_MODE"))
            {
                int iNameCol = 0;
                string oldVal = e.TableControl.Table.TableModel[iRow, iCol].FormattedText;
                for (int i = 1; i < e.TableControl.TableDescriptor.Columns.Count; i++)
                {
                    string sColHeader = e.TableControl.Table.TableModel.GetColumnDescriptorAt(iRow, i).HeaderText;
                    if (sColHeader == LRRHeaderText.GetHeaderString("SID_NAME"))
                    {
                        iNameCol = i;
                        break;
                    }
                }
                string propTypeName = e.TableControl.Table.TableModel[iRow, iNameCol].FormattedText;
                LRRPropertyType _propType = _lrrPropertyTypes.GetPropertyTypeByName(propTypeName);
                ArrayList MappedGroupProperties = new ArrayList();
                MappedGroupProperties = LRRModel.CheckForMapping(_propType);
                if (MappedGroupProperties.Count == 0)
                {
                    DialogResult dlgResult = LRRMessagBox.ShowMessage("SID_CASCADE_CHANGES_WITHOUT_RESTART", "SID_LABLE", MessageBoxButtons.YesNo, MessageBoxIcon.Question);     //MessageBox.Show("Do you want to cascade changes ? ","PE-Advisor",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
                    if (dlgResult == DialogResult.No)
                    {
                        e.Inner.Cancel = true;
                    }
                }
                else
                {
                    LRRMessagBox.ShowMessage(this, "SID_MAPPING_EXISTS", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    for (int i = 0; i < MappedGroupProperties.Count; i++)
                    {
                        LRRHistPropCompPropMapping histPropCompPropMap = MappedGroupProperties[i] as LRRHistPropCompPropMapping;
                        Logger.LogMessage(histPropCompPropMap.ComponentPropertyName + "  Mapped With HistTag  " + histPropCompPropMap.HistTag, Logger.Level.Error);
                    }
                    e.Inner.Cancel = true;
                }
            }
		}
		private void gridQualities_TableControlCurrentCellCloseDropDown(object sender, GridTableControlPopupClosedEventArgs e)
		{
			try
			{
				if(gridQualities.TableModel.GetHeaderColumnDescriptorAt(e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_QUALIFIER"))
				{
					if(e.TableControl.CurrentCell.Renderer.CurrentStyle.CellType ==  "FilterBarCell")
						return;
					int iRow = e.TableControl.CurrentCell.RowIndex;
					int iCol = e.TableControl.CurrentCell.ColIndex;
					string nVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
					string newVal = e.TableControl.CurrentCell.Renderer.ControlText.ToString();
                    string oldVal = e.TableControl.Table.TableModel[iRow,iCol].FormattedText; 
					if(oldVal != newVal)
					{
						LRRQualifier qualifier = LRRModel.Qualifiers.getQualifierObjectForQualifierID(nVal);
						if(qualifier != null)
						{
							foreach(Record rec in e.TableControl.Table.Records)
							{
								LRRLookUpQualifier oldLookUpQualifier = rec.GetData() as LRRLookUpQualifier; 
								if(oldLookUpQualifier.QualifierID != null)
								{
									if(oldLookUpQualifier.QualifierID == qualifier.QualifierID)
									{	
										string[] s = new string[1];
										s[0] = qualifier.Name;
										LRRMessagBox.ShowMessage("SID_DUPLICATE_QUALIFIERS","SID_LABLE",s,MessageBoxButtons.OK,MessageBoxIcon.Error);   
										e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
										return;
									}
								}
							}
						}
					}
				}
			}
			catch 
			{

			}
		}

		private void TableControl_CurrentCellStartEditing(object sender, CancelEventArgs e)
		{
			
		}

		private void gridChemicalComponents_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
		{
            if (this.gridConfiguration.TableControl.Table.CurrentRecord != null)
            {
                object proptype = this.gridConfiguration.TableControl.Table.CurrentRecord.GetData();
                LRRPropertyType type = proptype as LRRPropertyType;
                LRRLookUpProperties lookUpProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(type.ID);
                GridGroupingControl grid = sender as GridGroupingControl;
                if (e.Record != null)
                {
                    object recObj = e.Record.GetData();
                    if (recObj != null)
                    {
                        LRRLookUpProperty lookpProp = recObj as LRRLookUpProperty;
                        foreach (LRRLookUpProperty lkProp in lookUpProps)
                        {
                            if (lookpProp.LookUpPropertiesID == lkProp.LookUpPropertiesID)
                            {
                                e.Cancel = true;
                            }
                        }
                    }
                }
            }
		}

        private void ApplyStyleForChemicalGP(bool isChemicalGP)
        {
            foreach (GridColumnDescriptor gcd in this.gridChemicalComponents.TableDescriptor.Columns)
            {
                if (isChemicalGP)
                {
                    gcd.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Show;
                    gcd.ReadOnly = false;
                    if (gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_IUPACNAME"))
                    {
                        gcd.AllowDropDownCell = true;
                    }
                }
                else
                {
                    gcd.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
                    if (gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_IUPACNAME"))
                    {
                        gcd.AllowDropDownCell = false;
                    }
                    if (gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_NAME") || gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_DESCRIPTION"))
                    {
                        gcd.ReadOnly = false;
                    }
                    else
                    {
                        gcd.ReadOnly = true;
                    }
                }
            }
        }
	}
}
