using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.Utils.MessageDispatcher;   
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlConstants.
	/// </summary>
	public class UserControlConstants : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp						_app;
		private LRRConstants				_lrrConstants = null;
		private LRRConstantsources			_lrrConstantSource = null;
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		private LRRConstHistMappings		_lrrConstHistMapping = null;
		private GridExcelFormatter	_gridExcelFormatter = new GridExcelFormatter(); 
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridConstants;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlConstants()
		{
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_gridExcelFormatter.WireGrid(this.gridConstants);  
			InitDataSource();
			SyncGridUtilities.InitializeGridLookAndFeel(gridConstants);
			BindGridConstant();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridConstants = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridConstants)).BeginInit();
			this.SuspendLayout();
			// 
			// gridConstants
			// 
			this.gridConstants.BackColor = System.Drawing.SystemColors.Window;
			this.gridConstants.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridConstants.Location = new System.Drawing.Point(0, 0);
			this.gridConstants.Name = "gridConstants";
			this.gridConstants.Size = new System.Drawing.Size(368, 440);
			this.gridConstants.TabIndex = 0;
			this.gridConstants.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridConstants.Text = "gridGroupingControl1";
			this.gridConstants.TopLevelGroupOptions.CaptionText = "Constants for Formula: {RecordCount} Items";
			this.gridConstants.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridConstants.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridConstants.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridConstants.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridConstants.TopLevelGroupOptions.ShowFilterBar = false;  
			this.gridConstants.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridConstants.VersionInfo = "3.301.0.0";
			this.gridConstants.TableControlCurrentCellKeyPress += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventHandler(this.gridConstants_TableControlCurrentCellKeyPress);
			this.gridConstants.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridConstants_RecordDeleting);
			this.gridConstants.TableControlCurrentCellKeyDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridConstants_TableControlCurrentCellKeyDown);
			this.gridConstants.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.gridConstants_TableControlCurrentCellCloseDropDown);
			// 
			// UserControlConstants
			// 
			this.Controls.Add(this.gridConstants);
			this.Name = "UserControlConstants";
			this.Size = new System.Drawing.Size(368, 440);
			this.Tag = "SID_CONSTANTS";
			((System.ComponentModel.ISupportInitialize)(this.gridConstants)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		# region InitDataSource
		private void InitDataSource()
		{
			if(_lrrConstants != null)
				_lrrConstants.Clear();
			if(_lrrConstantSource  != null)
				_lrrConstantSource.Clear();
			if(_lrrConstHistMapping != null)
				_lrrConstHistMapping.Clear();
			
			_lrrConstHistMapping=new LRRConstHistMappings();
			_app.DBManagerObj.PopulateCollection(_lrrConstHistMapping,false);
			_lrrConstants=new LRRConstants();
			_app.DBManagerObj.PopulateCollection(_lrrConstants," Where ID <> '0'",false);
			_lrrConstantSource =new LRRConstantsources();
			_app.DBManagerObj.PopulateCollection(_lrrConstantSource,false);
		}
		#endregion
		
		#region BindGridConstant
		private void BindGridConstant()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridConstants.SuspendLayout();
			
			//Populate the columns for the grid object
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrConstants.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			SyncGridUtilities.InitializeGridColumns(gridConstants,_lrrConstants.ItemType,null,fkData);
			
//			RelativeWidths.Add("Name",30);
//			RelativeWidths.Add("Description",30);
//			RelativeWidths.Add("InputSourceID",30);
//			RelativeWidths.Add("Value",30);
			//SyncGridUtilities.InitializeGridColumnsWidth(gridConstants);
			//Set the data store 
			gridConstants.DataSource = _lrrConstants;
			//Resume the Layout of the Grid...
			gridConstants.ResumeLayout(true);
			gridConstants.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_CONSTANTS") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			//Add the parent table for the Relations...
			gridConstants.Engine.SourceListSet.Add("ParentTable",_lrrConstants);

			string[,] arry=new string[,]{{"Description","255"}};
			Validations	objValidations=new Validations(gridConstants,arry);
		}

		#endregion
		
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BindGridConstant();
		}

		public void Save()
		{
			LRRConstants changes = _lrrConstants.GetChanges();
			int nChangesCtr = 0;
			nChangesCtr = changes.Count;
			if(nChangesCtr >0)
			{
				for(int i=0;i<nChangesCtr ;i++)
				{
					LRRConstant _lrrConst = changes[i] as LRRConstant;
					if(_lrrConst.ObjectState == DBOperation.INSERT)
					{
						LRRConstant duplicate = _lrrConstants.getConstantName(_lrrConst.Name) as LRRConstant;
						if(duplicate == null)
						{
							if(_lrrConst.Name == null || _lrrConst.Name.Trim() == "")
							{
								LRRMessagBox.ShowMessage("SID_NAME_NULL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
								return;
							}
						}
						else
						{
							LRRMessagBox.ShowMessage("SID_CONST_EXIST","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);      
							return;
						}
					}
				}
				_app.DBManagerObj.CommitCollection(changes);
				OptionsUserControl.saved=true;
			}
			if(_lrrConstants.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
			else
			{
				_lrrConstants.RefreshCollection();
			}
			InitDataSource();
			BindGridConstant();
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridConstants.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridConstants,false);
			}
		}

		public void Delete()
		{
			SyncGridUtilities.DeleteRecords(gridConstants);   
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridConstants);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return true;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridConstants);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region Events
		
		private void gridConstants_TableControlCurrentCellKeyPress(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventArgs e)
		{
			GridTableModel tableModel = gridConstants.Table.TableModel;
			int iRow = e.TableControl.CurrentCell.RowIndex;
			int iCol = e.TableControl.CurrentCell.ColIndex;
			LRRConstant lrrConst = e.TableControl.Table.CurrentRecord.GetData() as LRRConstant;
			string sColHeader = "";
			if(tableModel.GetColumnDescriptorAt(iRow,iCol) != null)
			{
				sColHeader = tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
			}
			if(sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_VALUE")))
			{
				string sInputSourceID = lrrConst.InputSourceID == null ? "" : lrrConst.InputSourceID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(sInputSourceID == "2")
				{
					e.Inner.Handled = true;
				}
				else
				{
					e.Inner.Handled = false;
				}
			}
			if(lrrConst!=null)
			{
				IEnumerator mappedConst = _lrrConstHistMapping.GetEnumerator();
				while(mappedConst.MoveNext())
				{
					LRRConstantHistMapping mapping = mappedConst.Current as LRRConstantHistMapping;
					if(lrrConst.ID == mapping.ConstID)
					{
						e.Inner.Handled = true; 
					}	
				}
			}
		}
		private void gridConstants_TableControlCurrentCellKeyDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventArgs e)
		{
			GridTableModel tableModel = gridConstants.Table.TableModel;
			int iRow = e.TableControl.CurrentCell.RowIndex;
			int iCol = e.TableControl.CurrentCell.ColIndex;
			if(e.TableControl.Table.CurrentRecord != null)
			{
				LRRConstant lrrConst = e.TableControl.Table.CurrentRecord.GetData() as LRRConstant;
				string sColHeader = "";
				if(tableModel.GetColumnDescriptorAt(iRow,iCol) != null)
				{
					sColHeader = tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
				}
				if(sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_VALUE")))
				{
					string sInputSourceID = lrrConst.InputSourceID == null ? "" : lrrConst.InputSourceID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					if(sInputSourceID == "2")
					{
			
						e.Inner.Handled = true;
					}
					else
					{
						e.Inner.Handled = false;
					}
				}
				if(lrrConst!=null)
				{
					IEnumerator mappedConst = _lrrConstHistMapping.GetEnumerator();
					while(mappedConst.MoveNext())
					{
						LRRConstantHistMapping mapping = mappedConst.Current as LRRConstantHistMapping;
						if(lrrConst.ID == mapping.ConstID)
						{
							e.Inner.Handled = true;
						}	
					}
				}
			}
		}
		private void gridConstants_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
			
			GridTableModel tableModel = gridConstants.Table.TableModel;
			int iRow = e.TableControl.CurrentCell.RowIndex;
			int iCol = e.TableControl.CurrentCell.ColIndex;
			string sColHeader = "";
			if(tableModel.GetColumnDescriptorAt(iRow,iCol) != null)
			{
				sColHeader = tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
			}
			if(sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_INPUTSOURCE")))
			{
				string nVal = e.TableControl.CurrentCell.Renderer.ControlValue == null ? "" : e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
				LRRConstant lrrConst = e.TableControl.Table.CurrentRecord.GetData() as LRRConstant;
				if(lrrConst!=null)
				{
					IEnumerator mappedConst = _lrrConstHistMapping.GetEnumerator();
					while(mappedConst.MoveNext())
					{
						LRRConstantHistMapping mapping = mappedConst.Current as LRRConstantHistMapping;
						if(lrrConst.ID == mapping.ConstID)
						{
							e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
						}	
					}
				}
				if(nVal == "1")
				{
					nVal = "User";
				}
				else
				{
					nVal = "Model";
				}
				string oldVal = tableModel[iRow,iCol].FormattedText;
				if(nVal != oldVal && nVal == "Model")
				{
					lrrConst.Value = "";
				}
				if(e.TableControl.Table.CurrentRecord != null)
					e.TableControl.Table.CurrentRecord.EndEdit();
			}
		}
	

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true; 
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridConstants_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				LRRConstant constant = e.Record.GetData() as LRRConstant;
				if(constant!=null)
				{
					IEnumerator mappedConst = _lrrConstHistMapping.GetEnumerator();
					while(mappedConst.MoveNext())
					{
						LRRConstantHistMapping mapping = mappedConst.Current as LRRConstantHistMapping;
						if(constant.ID == mapping.ConstID)
						{
							LRRMessagBox.ShowMessage("SID_CONSTANT_MAPPED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
							e.Cancel=true;
							return;
						}	
					}
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlConstants.PrintPreview implementation
			if(gridConstants.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridConstants,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlConstants.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlConstants.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlConstants.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlConstants.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlConstants.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlConstants.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlConstants.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlConstants.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlConstants.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlConstants.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlConstants.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlConstants.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlConstants.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlConstants.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlConstants.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlConstants.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlConstants.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlConstants.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}

