using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  
using Symcon.Utils.MessageLogger;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlDataArrays.
	/// </summary>
	public class UserControlDataArrays : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp			_app;
		private LRRPropertyTypes _lrrPropertyTypesforStandardArrays=null;
		private LRRPropertyTypes _lrrPropertyTypesforUserDefinedArrays=null;
		private LRRLookUpProperties	_orgStdElements=null;
		private LRRLookUpProperties _lrrStandardElements=null;
		private LRRLookUpProperties _orgUDElements=null;
		private LRRLookUpProperties _lrrUserDefinedElements=null;
		private LRRUOMTypes			_lrrUOMTypes = null;
		private LRRPropertyTypes					_lrrPropertyTypes=null;
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		bool isSaved = false;
		bool gridStandardElmntsRecordDeleting=false;
		bool gridUserDefinedElmntsRecordDeleting=false;
		bool	gridStandardRecordDeleting=false;
		bool	gridUDRecordDeleting=false;
		private GridExcelFormatter	_gridExcelFormatter = new GridExcelFormatter(); 
		private string		_recordValueChanged="0";
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridStandard;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUserDefined;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUserDefinedElements;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.Panel panel5;
		private System.Windows.Forms.Panel panelDA1;
		private System.Windows.Forms.Panel panelDA2;
		private System.Windows.Forms.Panel panelDA3;
		private System.Windows.Forms.Panel panelDA5;
		private System.Windows.Forms.Panel panel4;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridStandardElements;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlDataArrays()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			//gridStandardElements.Dock = DockStyle.Fill;
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_gridExcelFormatter.WireGrid(this.gridUserDefined);
			_gridExcelFormatter.WireGrid(this.gridUserDefinedElements);  
			InitDataSource();
			SyncGridUtilities.InitializeGridLookAndFeel(gridUserDefined);
			SyncGridUtilities.InitializeGridLookAndFeel(gridStandardElements);
			SyncGridUtilities.InitializeGridLookAndFeel(gridUserDefinedElements);
			BindGridStandard();
			BindGridStandardElements();
			BindGridUserDefined();
			BindGridUserDefinedElements();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridStandard = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridUserDefined = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridUserDefinedElements = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.panelDA1 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panelDA2 = new System.Windows.Forms.Panel();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panelDA3 = new System.Windows.Forms.Panel();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.panelDA5 = new System.Windows.Forms.Panel();
			this.panel4 = new System.Windows.Forms.Panel();
			this.gridStandardElements = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridStandard)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridUserDefined)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridUserDefinedElements)).BeginInit();
			this.panelDA1.SuspendLayout();
			this.panelDA2.SuspendLayout();
			this.panelDA3.SuspendLayout();
			this.panelDA5.SuspendLayout();
			this.panel4.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridStandardElements)).BeginInit();
			this.SuspendLayout();
			// 
			// gridStandard
			// 
			this.gridStandard.Appearance.AnyRecordFieldCell.CellType = "Static";
			this.gridStandard.Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.LightGray);
			this.gridStandard.BackColor = System.Drawing.SystemColors.Window;
			this.gridStandard.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridStandard.Location = new System.Drawing.Point(0, 0);
			this.gridStandard.Name = "gridStandard";
			this.gridStandard.Size = new System.Drawing.Size(200, 100);
			this.gridStandard.TabIndex = 1;
			this.gridStandard.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)));
			this.gridStandard.Text = "gridGroupingControl1";
			this.gridStandard.TopLevelGroupOptions.CaptionText = "Standard  Data  Arrays: {RecordCount} Items";
			this.gridStandard.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridStandard.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridStandard.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridStandard.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridStandard.VersionInfo = "3.301.0.0";
			this.gridStandard.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridStandard_RecordDeleting);
			this.gridStandard.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridStandard_CurrentRecordContextChange);
			this.gridStandard.Click += new System.EventHandler(this.gridStandard_Click);
			// 
			// gridUserDefined
			// 
			this.gridUserDefined.BackColor = System.Drawing.SystemColors.Window;
			this.gridUserDefined.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUserDefined.Location = new System.Drawing.Point(0, 0);
			this.gridUserDefined.Name = "gridUserDefined";
			this.gridUserDefined.Size = new System.Drawing.Size(781, 100);
			this.gridUserDefined.TabIndex = 3;
			this.gridUserDefined.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridUserDefined.Text = "gridGroupingControl4";
			this.gridUserDefined.TopLevelGroupOptions.CaptionText = "User Defined  Data Arrays: {RecordCount} Items";
			this.gridUserDefined.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUserDefined.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUserDefined.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUserDefined.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUserDefined.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUserDefined.VersionInfo = "3.301.0.0";
			this.gridUserDefined.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridUserDefined_RecordDeleting);
			this.gridUserDefined.TableControlCheckBoxClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridUserDefined_TableControlCheckBoxClick);
			this.gridUserDefined.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridUserDefined_CurrentRecordContextChange);
			// 
			// gridUserDefinedElements
			// 
			this.gridUserDefinedElements.BackColor = System.Drawing.SystemColors.Window;
			this.gridUserDefinedElements.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUserDefinedElements.Location = new System.Drawing.Point(0, 0);
			this.gridUserDefinedElements.Name = "gridUserDefinedElements";
			this.gridUserDefinedElements.Size = new System.Drawing.Size(781, 481);
			this.gridUserDefinedElements.TabIndex = 2;
			this.gridUserDefinedElements.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridUserDefinedElements.Text = "gridGroupingControl3";
			this.gridUserDefinedElements.TopLevelGroupOptions.CaptionText = "Constituents Selection : {RecordCount} Items";
			this.gridUserDefinedElements.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUserDefinedElements.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUserDefinedElements.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUserDefinedElements.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUserDefinedElements.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUserDefinedElements.VersionInfo = "3.301.0.0";
			this.gridUserDefinedElements.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridUserDefinedElements_RecordDeleting);
			this.gridUserDefinedElements.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridUserDefinedElements_RecordValueChanged);
			this.gridUserDefinedElements.RecordValueChanging += new Syncfusion.Grouping.RecordValueChangingEventHandler(this.gridUserDefinedElements_RecordValueChanging);
			this.gridUserDefinedElements.Click += new System.EventHandler(this.gridUserDefinedElements_Click);
			// 
			// panelDA1
			// 
			this.panelDA1.Controls.Add(this.panel4);
			this.panelDA1.Controls.Add(this.splitter1);
			this.panelDA1.Controls.Add(this.panelDA2);
			this.panelDA1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panelDA1.Location = new System.Drawing.Point(0, 0);
			this.panelDA1.Name = "panelDA1";
			this.panelDA1.Size = new System.Drawing.Size(200, 584);
			this.panelDA1.TabIndex = 9;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 100);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(200, 3);
			this.splitter1.TabIndex = 3;
			this.splitter1.TabStop = false;
			// 
			// panelDA2
			// 
			this.panelDA2.Controls.Add(this.gridStandard);
			this.panelDA2.Dock = System.Windows.Forms.DockStyle.Top;
			this.panelDA2.Location = new System.Drawing.Point(0, 0);
			this.panelDA2.Name = "panelDA2";
			this.panelDA2.TabIndex = 5;
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(200, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 584);
			this.splitter2.TabIndex = 5;
			this.splitter2.TabStop = false;
			// 
			// panelDA3
			// 
			this.panelDA3.Controls.Add(this.gridUserDefined);
			this.panelDA3.Dock = System.Windows.Forms.DockStyle.Top;
			this.panelDA3.Location = new System.Drawing.Point(203, 0);
			this.panelDA3.Name = "panelDA3";
			this.panelDA3.Size = new System.Drawing.Size(781, 100);
			this.panelDA3.TabIndex = 8;
			// 
			// splitter3
			// 
			this.splitter3.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter3.Location = new System.Drawing.Point(203, 100);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(781, 3);
			this.splitter3.TabIndex = 7;
			this.splitter3.TabStop = false;
			// 
			// panelDA5
			// 
			this.panelDA5.Controls.Add(this.gridUserDefinedElements);
			this.panelDA5.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelDA5.Location = new System.Drawing.Point(203, 103);
			this.panelDA5.Name = "panelDA5";
			this.panelDA5.Size = new System.Drawing.Size(781, 481);
			this.panelDA5.TabIndex = 0;
			// 
			// panel4
			// 
			this.panel4.BackColor = System.Drawing.SystemColors.Control;
			this.panel4.Controls.Add(this.gridStandardElements);
			this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel4.Location = new System.Drawing.Point(0, 103);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(200, 481);
			this.panel4.TabIndex = 6;
			// 
			// gridStandardElements
			// 
			this.gridStandardElements.BackColor = System.Drawing.SystemColors.Window;
			this.gridStandardElements.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridStandardElements.Location = new System.Drawing.Point(0, 0);
			this.gridStandardElements.Name = "gridStandardElements";
			this.gridStandardElements.Size = new System.Drawing.Size(200, 481);
			this.gridStandardElements.TabIndex = 3;
			this.gridStandardElements.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridStandardElements.Text = "gridGroupingControl3";
			this.gridStandardElements.TopLevelGroupOptions.CaptionText = "Constituents Selection : {RecordCount} Items";
			this.gridStandardElements.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridStandardElements.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridStandardElements.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridStandardElements.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridStandardElements.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridStandardElements.VersionInfo = "3.301.0.0";
			// 
			// UserControlDataArrays
			// 
			this.Controls.Add(this.panelDA5);
			this.Controls.Add(this.splitter3);
			this.Controls.Add(this.panelDA3);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.panelDA1);
			this.Name = "UserControlDataArrays";
			this.Size = new System.Drawing.Size(984, 584);
			((System.ComponentModel.ISupportInitialize)(this.gridStandard)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridUserDefined)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridUserDefinedElements)).EndInit();
			this.panelDA1.ResumeLayout(false);
			this.panelDA2.ResumeLayout(false);
			this.panelDA3.ResumeLayout(false);
			this.panelDA5.ResumeLayout(false);
			this.panel4.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridStandardElements)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		#region Private Methods

		# region InitDataSource
		private void InitDataSource()
		{
			if(_lrrPropertyTypesforStandardArrays != null)
				_lrrPropertyTypesforStandardArrays.Clear();
			if(_lrrPropertyTypesforUserDefinedArrays != null)
				_lrrPropertyTypesforUserDefinedArrays.Clear();
			if(_lrrUserDefinedElements != null)
				_lrrUserDefinedElements.Clear();
			if(_lrrStandardElements != null)
				_lrrStandardElements.Clear();
			if(_orgUDElements!= null)
				_orgUDElements.Clear();
			if(_orgStdElements!= null)
				_orgStdElements.Clear();

			_lrrPropertyTypesforStandardArrays=new LRRPropertyTypes();
			_app.DBManagerObj.PopulateCollection(_lrrPropertyTypesforStandardArrays," where IsStandard=true",false);
			_lrrPropertyTypesforUserDefinedArrays=new LRRPropertyTypes();
			_app.DBManagerObj.PopulateCollection(_lrrPropertyTypesforUserDefinedArrays," where IsStandard=false and IsDataArray=true",false);
			_lrrStandardElements =new LRRLookUpProperties(); 
			_app.DBManagerObj.PopulateCollection(_lrrStandardElements,"  where PropertyID='"+null+"'",false);
			_lrrUserDefinedElements  =new LRRLookUpProperties(); 
			_app.DBManagerObj.PopulateCollection(_lrrUserDefinedElements,"  where PropertyID='"+null+"'",false);
			_orgUDElements  =new LRRLookUpProperties(); 
			_app.DBManagerObj.PopulateCollection(_orgUDElements,false);
			_orgStdElements  =new LRRLookUpProperties(); 
			_app.DBManagerObj.PopulateCollection(_orgStdElements,false);
			_lrrUOMTypes = LRRModel.ChildModel.UomTypes; 
			_lrrPropertyTypes = LRRModel.ChildModel.PropertyTypes; 
		}
		#endregion


		#region BindGridStandard
		private void BindGridStandard()
		{
			
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridStandard.SuspendLayout();

			//SyncGridUtilities.InitializeGridLookAndFeel(gridStandard);
			SyncGridUtilities.InitializeGridColumns(gridStandard,gridStandard.TableDescriptor,_lrrPropertyTypesforStandardArrays.ItemType,null);
			gridStandard.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_STANDARD_DATA_ARRAYS") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_NAME"),50);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),50);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_MODE"),20);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_UOM_TYPE"),50);
			SyncGridUtilities.InitializeGridColumnsWidth(gridStandard,RelativeWidths);
            foreach (GridColumnDescriptor gcd in gridStandard.TableDescriptor.Columns)
            {
                if (gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_UOM_TYPE"))
                {
                    gcd.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
                    gcd.Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
                    gcd.Appearance.AnyRecordFieldCell.DataSource = _lrrUOMTypes;
                    gcd.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide; 
                    gcd.Appearance.AnyRecordFieldCell.ValueMember = "UOMTypeID";
                    gcd.Appearance.AnyRecordFieldCell.DisplayMember = "Name";
                }
            }

            foreach (GridColumnDescriptor gcd in this.gridStandard.TableDescriptor.Columns)
            {
                if (gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_BASE") || gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_INPUTTYPE"))
                {
                    this.gridStandard.TableModel.Model.HideCols[gcd.MappingName] = true;
                }

            }
			//Set the data store 
            gridStandard.TableDescriptor.AllowNew = false;
			gridStandard.TableDescriptor.AllowRemove = false;
			gridStandard.TableDescriptor.AllowEdit = false;
			this.gridStandard.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            gridStandard.DataSource = _lrrPropertyTypesforStandardArrays;
            gridStandard.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridStandard.Engine.SourceListSet.Add("ParentTable",_lrrPropertyTypesforStandardArrays);
            //this.gridStandard.TableModel.Model.HideCols["Base"] = true;
            //this.gridStandard.TableModel.Model.HideCols[3] = true;
			string[,] arry=new string[,]{{LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"255"}};
			Validations	obj=new Validations(gridStandard,arry);
		}
		#endregion


		#region BindGridUserDefined
		private void BindGridUserDefined()
		{
			
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUserDefined.SuspendLayout();

			SyncGridUtilities.InitializeGridColumns(gridUserDefined,gridUserDefined.TableDescriptor,_lrrPropertyTypesforUserDefinedArrays.ItemType,null);
            gridUserDefined.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_USER_DEFINED_DATA_ARRAYS") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_NAME"),60);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),97);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_MODE"),20);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_UOM_TYPE"),50);
            RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_I/O"), 30);
            RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_DERIVATIONTYPE"), 50);
			SyncGridUtilities.InitializeGridColumnsWidth(gridUserDefined,RelativeWidths );
            foreach (GridColumnDescriptor gcd in this.gridUserDefined.TableDescriptor.Columns)
            {
                if (gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_BASE"))
                {
                    this.gridUserDefined.TableDescriptor.Columns.Remove(gcd.MappingName); 
                }
                if (gcd.HeaderText == LRRHeaderText.GetHeaderString("SID_INPUTTYPE"))
                {
                    this.gridUserDefined.TableModel.Model.HideCols[gcd.MappingName] = true;
                }
            }
			gridUserDefined.TableDescriptor.AllowNew = true;
			gridUserDefined.TableDescriptor.AllowRemove = true;
			gridUserDefined.TableDescriptor.AllowEdit = true;
			this.gridUserDefined.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            gridUserDefined.DataSource = _lrrPropertyTypesforUserDefinedArrays;
			gridUserDefined.ResumeLayout(false);
           
			//Add the parent table for the Relations...
			gridUserDefined.Engine.SourceListSet.Add("ParentTable",_lrrPropertyTypesforUserDefinedArrays);

			string[,] arry=new string[,]{{LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"255"}};
			Validations	obj=new Validations(gridUserDefined,arry);
		}

		#endregion


		#region BindGridStandardElements()
		private void BindGridStandardElements()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridStandardElements.SuspendLayout();

			columnForDisplay.Add("Name",LRRHeaderText.GetHeaderString("SID_NAME"));
			columnForDisplay.Add("Description",LRRHeaderText.GetHeaderString("SID_DESCRIPTION"));
			columnForDisplay.Add("Term",LRRHeaderText.GetHeaderString("SID_TERM"));

			SyncGridUtilities.InitializeGridColumns(gridStandardElements,gridStandardElements.TableDescriptor,_lrrStandardElements.ItemType,null,true,null,columnForDisplay,false);
			gridStandardElements.TableDescriptor.Columns.Clear();
			gridStandardElements.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_CONSTITUENTS_SELECTION") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");    
			gridStandardElements.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_NAME"),"Name");
			gridStandardElements.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"Description");
			gridStandardElements.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_TERM"),"Term");
			
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_NAME"),43);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),45);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_TERM"),28);
			this.gridStandardElements.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_NAME")].Appearance.AnyRecordFieldCell.CellType="Static";
			this.gridStandardElements.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_DESCRIPTION")].Appearance.AnyRecordFieldCell.CellType="Static";
			this.gridStandardElements.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_NAME")].Appearance.AnyRecordFieldCell.ReadOnly=true;
			this.gridStandardElements.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_DESCRIPTION")].Appearance.AnyRecordFieldCell.ReadOnly=true;
			this.gridStandardElements.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_NAME")].Appearance.AnyRecordFieldCell.BackColor=Color.LightGray;
			this.gridStandardElements.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_DESCRIPTION")].Appearance.AnyRecordFieldCell.BackColor=Color.LightGray;
//			SyncGridUtilities.InitializeGridColumnsWidth(gridStandardElements,RelativeWidths );
		
		//	_app.DBManagerObj.PopulateCollection(_lrrStandardElements,"  where PropertyID='"+null+"'");
			gridStandardElements.TableControl.Refresh();
			gridStandardElements.TableDescriptor.AllowNew = false;
			gridStandardElements.TableDescriptor.AllowRemove = false;
			gridStandardElements.TableDescriptor.AllowEdit = true;
			

			//gridConfiguration.TopLevelGroupOptions.CaptionText = "Lookup Group: {RecordCount} Items";
			//Resume the Layout of the Grid...
			gridStandardElements.DataSource = _lrrStandardElements;
			this.gridStandardElements.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			gridStandardElements.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridStandardElements.Engine.SourceListSet.Add("ParentTable",_lrrStandardElements);

			string[,] arry=new string[,]{{LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"255"}};
			Validations	obj=new Validations(gridStandardElements,arry);
		}
		#endregion


		#region BindGridUserDefinedElements
		private void BindGridUserDefinedElements()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			//gridStandardElements.SuspendLayout();

			SyncGridUtilities.InitializeGridColumns(gridUserDefinedElements,gridUserDefinedElements.TableDescriptor,_lrrUserDefinedElements.ItemType,null);
			gridUserDefinedElements.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_CONSTITUENTS_SELECTION") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");    
			gridUserDefinedElements.TableDescriptor.Columns.Clear();
			gridUserDefinedElements.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_NAME"),"Name");
			gridUserDefinedElements.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"Description");
			gridUserDefinedElements.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_TERM"),"Term");
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_NAME"),50);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),83);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_TERM"),25);
			SyncGridUtilities.InitializeGridColumnsWidth(gridUserDefinedElements,RelativeWidths );
			//Set the data store 
			//_app.DBManagerObj.PopulateCollection(_lrrUserDefinedElements,"  where PropertyID='"+null+"'");
//			filterString =   "PropertyID = null";
//			_lrrUserDefinedElements.ItemFilter = filterString;
			gridUserDefinedElements.TableControl.Refresh();
			gridUserDefinedElements.TableDescriptor.AllowNew = true;
			gridUserDefinedElements.TableDescriptor.AllowRemove = true;
			gridUserDefinedElements.TableDescriptor.AllowEdit = true;
			//gridConfiguration.TopLevelGroupOptions.CaptionText = "Lookup Group: {RecordCount} Items";
			
			gridUserDefinedElements.DataSource = _lrrUserDefinedElements;
			this.gridUserDefinedElements.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			//Resume the Layout of the Grid...
			gridUserDefinedElements.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridUserDefinedElements.Engine.SourceListSet.Add("ParentTable",_lrrUserDefinedElements);
			string[,] arry=new string[,]{{LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"255"}};
			Validations	obj=new Validations(gridUserDefinedElements,arry);
		}
		#endregion


		#region RefreshUserDefinedElements
		private void RefreshUserDefinedElements()
		{
			gridUserDefinedElements.DataSource = _lrrUserDefinedElements;
		
			//Add the parent table for the Relations...
			gridUserDefinedElements.Engine.SourceListSet.Add("ParentTable",_lrrUserDefinedElements);
		}
		#endregion


		#region RefreshStandardElements()
		private void RefreshStandardElements()
		{
			
			//Resume the Layout of the Grid...
			gridStandardElements.DataSource = _lrrStandardElements;
			//Add the parent table for the Relations...
			gridStandardElements.Engine.SourceListSet.Add("ParentTable",_lrrStandardElements);
		}
		#endregion
		
		#endregion


		#region Events

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true; 
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridStandardElements_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				LRRLookUpProperty lrrStdElmnt=gridStandardElements.CurrencyManager.Current as LRRLookUpProperty;
				if(lrrStdElmnt.Base==true)
				{
					e.Cancel=true;
				}
				else
				{
					gridStandardElmntsRecordDeleting=true;
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}
			
		}

		private void gridStandardElements_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			_recordValueChanged ="1";
		}

		private void gridStandardElements_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			if(e.Inner.RowIndex > 3 && e.Inner.ColIndex > 0)
			{
				if(this.gridStandardElements.TableModel.Model[e.Inner.RowIndex,3].CellType=="CheckBox")
				{
					object o = this.gridStandardElements.TableModel.Model[e.Inner.RowIndex,3].CellValue;
					if(o!=null)
					{
						bool val = o.ToString() == true.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if(val)
						{
							e.Inner.Style.ReadOnly=true;
							//e.Inner.Style.CellType="Static";
							e.Inner.Style.BackColor = Color.LightGray;
						}
					}
				}
			}
		}

		private void gridStandard_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			LRRPropertyType _lrrpropType=null;
			if(gridStandard.CurrencyManager.Position!=-1)
			{
				_lrrpropType	=gridStandard.CurrencyManager.Current as LRRPropertyType;
				if (gridStandard.CurrencyManager.Count == 0 )
					return;

				if(e.Table.CurrentRecord != null)
				{
					if(e.Action == CurrentRecordAction.EnterRecordComplete && e.Table.CurrentRecord.Kind.ToString(Symcon.BusinessObjects.SymConverter.Culture)!= "AddNewRecord")
					{
						string propID=_lrrpropType.ID;
						_lrrStandardElements = _orgStdElements;
						_lrrStandardElements = _lrrStandardElements.getLookUpPropertiesForPropTypeID(propID);
						//gridStandard.DataSource = null;
//						gridStandard.DataSource = _lrrStandardElements;
						RefreshStandardElements();
						return;
					}	

				}
				if(e.Table.CurrentRecord == null && e.Action==CurrentRecordAction.EnterRecordCalled)
				{
					string propID=_lrrpropType.ID;
					_lrrStandardElements = _orgStdElements;
					_lrrStandardElements = _lrrStandardElements.getLookUpPropertiesForPropTypeID(null);
				//	gridStandard.DataSource = null;
//					gridStandard.DataSource = _lrrStandardElements;
					RefreshStandardElements();
					return;
				}


				if (gridStandard.CurrencyManager.Count > 0 )
				{
					if(_lrrpropType!= null)
					{
						if(e.Action == CurrentRecordAction.NavigateCalled)
						{
							if(_recordValueChanged == "1")
							{
								if(LRRMessagBox.ShowMessage("SID_SAVE_QUES","SID_QUES",MessageBoxButtons.YesNo)== DialogResult.Yes)
								{
									e.Cancel = true;
									Save();
								}
								else
									_recordValueChanged ="0";
							}
						}
					}
				}
			}
		}

		
		private void gridStandard_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false; 
			}
			if(_isRecordeDel)
			{
				LRRPropertyType lrrPropType=gridStandard.CurrencyManager.Current as LRRPropertyType;
				if(lrrPropType.Base==true)
				{
					e.Cancel=true;
				}
				else
				{
					gridStandardRecordDeleting=true;
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}
		}

		private void gridUserDefinedElements_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				LRRLookUpProperty lrrStdElmnt=gridUserDefinedElements.CurrencyManager.Current as LRRLookUpProperty;
				if(lrrStdElmnt.Base==true)
				{
					e.Cancel=true;
					return;
				}
				else
				{
					gridUserDefinedElmntsRecordDeleting=true;
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}
		}

		private void gridUserDefined_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{

			LRRPropertyType _lrrpropType=null;
			if(gridUserDefined.CurrencyManager.Position!=-1)
			{
				_lrrpropType	=gridUserDefined.CurrencyManager.Current as LRRPropertyType;
				if (gridUserDefined.CurrencyManager.Count == 0 )
					return;

				if(e.Table.CurrentRecord != null)
				{
					if(e.Action == CurrentRecordAction.EnterRecordComplete && e.Table.CurrentRecord.Kind.ToString(Symcon.BusinessObjects.SymConverter.Culture)!= "AddNewRecord")
					{
						string propID=_lrrpropType.ID;
						_lrrUserDefinedElements = _orgUDElements;
						_lrrUserDefinedElements = _lrrUserDefinedElements.getLookUpPropertiesForPropTypeID(propID);
						_lrrUserDefinedElements.RefreshCollection();
//						gridUserDefinedElements.DataSource = null;
//
						//gridUserDefinedElements.DataSource = _lrrUserDefinedElements;
						RefreshUserDefinedElements();
						return;
					}	

				}
				if(e.Table.CurrentRecord == null && e.Action==CurrentRecordAction.EnterRecordCalled)
				{
					string propID=_lrrpropType.ID;
					//					filterString =   "UOMType = " + UOMTypeId;
					//					_lrrUOMTypeXRefs.ItemFilter= filterString;
					//					_app.DBManagerObj.PopulateCollection(_lrrUOMTypeXRefs,"  where UOMType='"+UOMTypeId+"'");
					_lrrUserDefinedElements = _orgUDElements;
					_lrrUserDefinedElements = _lrrUserDefinedElements.getLookUpPropertiesForPropTypeID(null);
					RefreshUserDefinedElements();
					return;
				}


				if (gridUserDefined.CurrencyManager.Count > 0 )
				{
					if(_lrrpropType!= null)
					{
						if(e.Action == CurrentRecordAction.NavigateCalled)
						{
							if(_recordValueChanged == "1")
							{
								if(LRRMessagBox.ShowMessage("SID_SAVE_QUES","SID_QUES",MessageBoxButtons.YesNo)== DialogResult.Yes)
								{
									e.Cancel = true;
									Save();
								}
								else
									_recordValueChanged ="0";
							}
						}
					}
				}
			}


			/*gridUserDefinedElements.DataSource = _lrrUserDefinedElements;
			if (gridUserDefined.CurrencyManager.Count == 0 )
				return;
			string filterString=null;
			LRRPropertyType _lrrPropertyType=gridUserDefined.CurrencyManager.Current as LRRPropertyType;
			string propertyID=_lrrPropertyType.ID;
			if(e.Table.CurrentRecord != null)
			{
				//				LRRLookUpProperty lookUpCurrent = e.Table.CurrentRecord.GetData() as LRRLookUpProperty;
				//				if(lookUpCurrent == null)
				//				{
				if(e.Table.CurrentRecord.Kind.ToString() == "AddNewRecord")
				{
//					filterString =   "PropertyID = null";
//					_lrrUserDefinedElements.ItemFilter = filterString;
					_app.DBManagerObj.PopulateCollection(_lrrUserDefinedElements,"  where PropertyID='"+null+"'");
					gridUserDefinedElements.TableControl.Refresh();
					return;
				}
				else
				{
					if(e.Action == CurrentRecordAction.NavigateComplete)
					{
//						filterString =   "PropertyID = " + propertyID;
//						_lrrUserDefinedElements.ItemFilter= filterString;
						_app.DBManagerObj.PopulateCollection(_lrrUserDefinedElements,"  where PropertyID='"+null+"'");
						return;
					}
				}
			}
			if (gridUserDefined.CurrencyManager.Count > 0 )
			{
				if(_lrrPropertyType!= null)
				{
					if(e.Action == CurrentRecordAction.NavigateCalled)
					{
						if(_recordValueChanged == "1")
						{
							if(MessageBox.Show("You have unsaved changes. Do you want to save?","Question",MessageBoxButtons.YesNo)== DialogResult.Yes)
							{
								e.Cancel = true;
								Save();
							}
							else
								_recordValueChanged ="0";
						}
					}
				}
			}*/
		}

		
		private void gridUserDefined_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
				
			}
			if(_isRecordeDel)
			{
				LRRPropertyType lrrPropType=gridUserDefined.CurrencyManager.Current as LRRPropertyType;
				if(lrrPropType.Base==true)
				{
					e.Cancel=true;
				}
				else
				{
					gridUDRecordDeleting=true;
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}
		}

		private void gridUserDefinedElements_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
		_recordValueChanged ="1";
		}
		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BindGridStandard();
			BindGridStandardElements();
			BindGridUserDefined();
			BindGridUserDefinedElements();
			_recordValueChanged="0";

		}

		public void Save()
		{
			#region Standard Data Arrays
			//***************Standard Data Arrays************************
		/*	if(gridStandardRecordDeleting==true)
			{
				LRRPropertyTypes standard = _lrrPropertyTypesforStandardArrays.GetChanges();
				if(standard.Count>0)
				{
					_app.DBManagerObj.CommitCollection(standard);
						OptionsUserControl.saved	=true;
					gridStandardRecordDeleting=false;
				}
				
			}
			foreach (LRRPropertyType  lrrPropertyType in _lrrPropertyTypesforStandardArrays)
			{
						
				if(lrrPropertyType.PropertyType == null || lrrPropertyType.PropertyType=="") 
				{
					MessageBox.Show("Name not specified . Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
					return;
				}
			}
			LRRPropertyType _lrrPropertyTypesforStandardArray = null;
			LRRPropertyTypes _lrrPropertyTypesforStdsArray = null;

			if(gridStandard.CurrencyManager.Position != -1)
			{
				_lrrPropertyTypesforStdsArray=gridStandard.CurrencyManager.List as LRRPropertyTypes;
				for(int i=0;i<_lrrPropertyTypesforStdsArray.Count;i++)
				{
					_lrrPropertyTypesforStandardArray=_lrrPropertyTypesforStdsArray[i] as LRRPropertyType;
					if(_lrrPropertyTypesforStandardArray != null)
					{
						if(_lrrPropertyTypesforStandardArray.IsDataArray==false)
							_lrrPropertyTypesforStandardArray.IsDataArray=true;
						if(_lrrPropertyTypesforStandardArray.IsStandard==false)
							_lrrPropertyTypesforStandardArray.IsStandard=true;
					}
				}
			
				if(_lrrPropertyTypesforStdsArray.GetChanges().Count>0)
				{
					_app.DBManagerObj.CommitCollection(_lrrPropertyTypesforStdsArray.GetChanges());
						OptionsUserControl.saved	=true;
				}
				if(_lrrPropertyTypesforStdsArray.HasError)
				{
					//MessageBox.Show("Save operation completed with errors");
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{
					_lrrPropertyTypesforStandardArrays.RefreshCollection();
					_lrrPropertyTypesforStdsArray.RefreshCollection();

				}
			}

			//***************StandardElements************************

			if(gridStandardElmntsRecordDeleting==true)
			{
				LRRLookUpProperties standardElements = _lrrStandardElements.GetChanges();
				if(standardElements.Count>0)
				{
					_app.DBManagerObj.CommitCollection(standardElements);
						OptionsUserControl.saved	=true;
					gridStandardElmntsRecordDeleting=false;
				}
				
			}

			foreach (LRRLookUpProperty  lrrLookUpProperty in _lrrStandardElements)
			{
						
				if(lrrLookUpProperty.Name == null || lrrLookUpProperty.Name=="") 
				{
					//MessageBox.Show("Name not specified . Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
					LRRMessagBox.ShowMessage("SID_SAVEABORT_NAME_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					return;
				}
			}
			if(_lrrPropertyTypesforStandardArray != null)
			{
				LRRLookUpProperties standardElements = _lrrStandardElements.GetChanges();
				if(standardElements.Count>0)
				{
					foreach (LRRLookUpProperty lrrstandardElement in standardElements)
					{
						lrrstandardElement.PropertyID=_lrrPropertyTypesforStandardArray.ID;
					}
					if(standardElements.GetChanges().Count>0)
					{
						_app.DBManagerObj.CommitCollection(standardElements);
							OptionsUserControl.saved	=true;
						LookUpPropertiesUtility lookUp = new LookUpPropertiesUtility();
						lookUp.UpdateMasterLookUpProperties(_lrrPropertyTypesforStandardArray.ID);
						lookUp.UpdateSiteComponentsLookUpProperties(_lrrPropertyTypesforStandardArray.ID);
						
					}
				}
				if(standardElements.HasError)
				{
					//MessageBox.Show("Save operation completed with errors");
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{

					standardElements.RefreshCollection();
					_lrrStandardElements.RefreshCollection();
				}

			}
			*/
			// Only for updating the term in Standard elemrnts
			LRRLookUpProperties standardElements = _lrrStandardElements.GetChanges();
			if(standardElements.Count>0)
			{
				_app.DBManagerObj.CommitCollection(standardElements);
				OptionsUserControl.saved	=true;
				standardElements.RefreshCollection();
				_lrrStandardElements.RefreshCollection();
			}
			#endregion

			#region UserDefined Data Arrays
			//***************UserDefined Data Arrays************************
			if(gridUserDefined.CurrencyManager.Position!=-1)
			{
				if(gridUDRecordDeleting==true)
				{
					LRRPropertyTypes UD = _lrrPropertyTypesforUserDefinedArrays.GetChanges();
					if(UD.Count>0)
					{
						_app.DBManagerObj.CommitCollection(UD);
						OptionsUserControl.saved	=true;
						gridUDRecordDeleting=false;
					}
				
				}
				foreach (LRRPropertyType  lrrPropertyType in _lrrPropertyTypesforUserDefinedArrays)
				{
						
					if(lrrPropertyType.PropertyType == null || lrrPropertyType.PropertyType=="") 
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_NAME_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
				}
			
				LRRPropertyType _lrrPropertyTypesforUserDefinedArray = null;
				LRRPropertyTypes _lrrPropertyTypesforUDArrays = null;
				if(gridUserDefined.CurrencyManager.Position != -1)
				{
					_lrrPropertyTypesforUDArrays=gridUserDefined.CurrencyManager.List as LRRPropertyTypes;
					for(int i=0;i<_lrrPropertyTypesforUDArrays.Count;i++)
					{
						_lrrPropertyTypesforUserDefinedArray=_lrrPropertyTypesforUDArrays[i] as LRRPropertyType;
						if(_lrrPropertyTypesforUserDefinedArray.IsDataArray==false)
							_lrrPropertyTypesforUserDefinedArray.IsDataArray=true;
						//	_lrrPropertyTypesforUserDefinedArray.IsStandard=false;
					}
			
					if(_lrrPropertyTypesforUDArrays.GetChanges().Count>0)
					{
						LRRPropertyTypes lpts = _lrrPropertyTypesforUDArrays.GetChanges();
						foreach(LRRPropertyType lpt in lpts)
						{
							if((lpt.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE) && (lpt.ArrListUpdatedColNames.Contains("ModeID")))   
							{
								ArrayList CreatedQualiferValues = new ArrayList();
								ArrayList DeletedQualifierValues = new ArrayList();
								bool _modeID = lpt.ModeID;
								LRRModel.CascadeGPChanges(lpt,_modeID,out DeletedQualifierValues,out CreatedQualiferValues);
								LRRSiteGroupPropertyQualifierValues ToDeleteQvalues = new LRRSiteGroupPropertyQualifierValues();
								LRRSiteGroupPropertyQualifierValues ToInsertQvalues = new LRRSiteGroupPropertyQualifierValues();
								if(DeletedQualifierValues.Count > 0)
								{
									for(int i = 0;i< DeletedQualifierValues.Count;i++)
									{
										LRRSiteGroupPropertyQualifierValue qValue = DeletedQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
										LRRModel.SiteGroupPropertyQualifierValuesObj.Remove(qValue);
										ToDeleteQvalues.Add(qValue); 
									}
									for(int j = 0;j<CreatedQualiferValues.Count;j++)
									{
										LRRSiteGroupPropertyQualifierValue qValue = CreatedQualiferValues[j] as LRRSiteGroupPropertyQualifierValue;
										LRRModel.SiteGroupPropertyQualifierValuesObj.Add(qValue);
										ToInsertQvalues.Add(qValue); 
									}
									_app.DBManagerObj.ExecuteBatchDelete(ToDeleteQvalues);  
									_app.DBManagerObj.ExecuteBatchInsert(ToInsertQvalues);
									LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection(); 
								}
								LRRMasterProperties masterProperties  = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByPropType(lpt.ID);
								foreach(LRRMasterProperty lmp in masterProperties)
								{
									if(lmp.ModeID != _modeID)
									{
										lmp.ModeID = _modeID;
										LRRGroupProperties lgps = LRRModel.MasterGroupPropertiesObj.GetGroupPropertiesForPropTypeAndPropertyID(lmp.Type,lmp.PropID);
										foreach(LRRGroupProperty lgp in lgps)
										{
											lgp.ModeID = _modeID;
										}
										LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(lmp.PropID);
										foreach(LRRSiteComponentProperty lscp in lscps)
										{
											lscp.ModeID = _modeID;
											LRRSiteComponentGroupProperties lscgps = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromSiteCompPropID(lscp.ID);
											foreach(LRRSiteComponentGroupProperty lscgp in lscgps)
											{
												lscgp.ModeID = _modeID;
											}
											_app.DBManagerObj.ExecuteBatchUpdate(lscgps.GetChanges());  
										}
										_app.DBManagerObj.ExecuteBatchUpdate(lscps.GetChanges());  
										_app.DBManagerObj.ExecuteBatchUpdate(masterProperties.GetChanges());   
									}
								}
							}
						}
						_app.DBManagerObj.CommitCollection(_lrrPropertyTypesforUDArrays.GetChanges());
                        OptionsUserControl.saved=true;
					}
					if(_lrrPropertyTypesforUDArrays.HasError)
					{
						LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
					}
					else
					{
						
						_lrrPropertyTypesforUDArrays.RefreshCollection();
						_lrrPropertyTypesforUserDefinedArrays.RefreshCollection();

					}
				
				}
				//***************UserDefinedElements************************
				if(gridUserDefinedElmntsRecordDeleting==true)
				{
				
					LRRLookUpProperties userDefinedElements = _lrrUserDefinedElements.GetChanges();
					if(userDefinedElements.Count>0)
					{
						_app.DBManagerObj.CommitCollection(userDefinedElements);
						gridUserDefinedElmntsRecordDeleting=false;
						OptionsUserControl.saved	=true;
					}
				
				}

				foreach (LRRLookUpProperty  lrrLookUpProperty in _lrrUserDefinedElements)
				{
						
					if(lrrLookUpProperty.Name == null || lrrLookUpProperty.Name=="") 
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_NAME_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
				}

				LRRPropertyType lrrPropType=gridUserDefined.CurrencyManager.Current as LRRPropertyType;
				if(lrrPropType != null)
				{
					LRRLookUpProperties userDefinedElements = _lrrUserDefinedElements.GetChanges();
					if(userDefinedElements.Count>0)
					{
						_app.DBManagerObj.CommitCollection(userDefinedElements);
						for(int i = 0 ;i<userDefinedElements.Count;i++)
						{
							LRRLookUpProperty lookUpProp = userDefinedElements[i] as LRRLookUpProperty;
							if(lookUpProp.ObjectState == DBOperation.INSERT)
							{
								LRRModel.ChildModel.LookUpProperties.Add(userDefinedElements[i]);  
							}
						}
						LookUpPropertiesUtility lookUp = new LookUpPropertiesUtility();
						lookUp.UpdateMasterLookUpProperties(lrrPropType.ID);
						lookUp.UpdateSiteComponentsLookUpProperties(lrrPropType.ID);
						
						OptionsUserControl.saved	=true;
					
						if(userDefinedElements.HasError)
						{
							LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
						}
						else
						{
							userDefinedElements.RefreshCollection();
							_lrrStandardElements.RefreshCollection();
						}
					
					}
				}
			}
			#endregion

			InitDataSource();
			BindGridStandard();
			BindGridStandardElements();
			BindGridUserDefined();
			BindGridUserDefinedElements();
			_recordValueChanged = "0";

		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridStandard.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridStandard,false);
			}
			if(gridUserDefined.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUserDefined,false);
			}
			if(gridStandardElements.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridStandardElements,false);
			}
			if(gridUserDefinedElements.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUserDefinedElements,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridUserDefined);
			SyncGridUtilities.PasteSelection(gridUserDefinedElements);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridStandard);
			SyncGridUtilities.ClearSort(gridStandardElements);
			SyncGridUtilities.ClearSort(gridUserDefined);
			SyncGridUtilities.ClearSort(gridUserDefinedElements);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion

		private void gridUserDefinedElements_RecordValueChanging(object sender, Syncfusion.Grouping.RecordValueChangingEventArgs e)
		{
			if(gridUserDefined.CurrencyManager.Position!=-1)
			{
				LRRPropertyType lrrPropType=gridUserDefined.CurrencyManager.Current as LRRPropertyType;
				if(lrrPropType != null)
				{
					LRRLookUpProperty objUserDefinedElement=e.Record.GetData() as LRRLookUpProperty;
					objUserDefinedElement.PropertyID=lrrPropType.ID;
				}
			}
		}
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		private void gridUserDefinedElements_Click(object sender, System.EventArgs e)
		{
		
		}

		private void gridStandard_Click(object sender, System.EventArgs e)
		{
		
		}
		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlDataArrays.PrintPreview implementation
			if(gridStandard.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridStandard,true);
			}
			if(gridUserDefined.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUserDefined,true);
			}
			if(gridStandardElements.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridStandardElements,true);
			}
			if(gridUserDefinedElements.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUserDefinedElements,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlDataArrays.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlDataArrays.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlDataArrays.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlDataArrays.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlDataArrays.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlDataArrays.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlDataArrays.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlDataArrays.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlDataArrays.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlDataArrays.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlDataArrays.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlDataArrays.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlDataArrays.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlDataArrays.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlDataArrays.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlDataArrays.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlDataArrays.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlDataArrays.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		private void gridUserDefined_TableControlCheckBoxClick(object sender, GridTableControlCellClickEventArgs e)
		{
			int iRow = e.Inner.RowIndex;  
			int iCol = e.Inner.ColIndex;  
			int iNameCol=0;
			string  oldVal = e.TableControl.Table.TableModel[iRow,iCol].FormattedText;
			for(int i = 1 ; i<e.TableControl.TableDescriptor.Columns.Count;i++)
			{
				string sColHeader = e.TableControl.Table.TableModel.GetColumnDescriptorAt(iRow,i).HeaderText;
				if(sColHeader == LRRHeaderText.GetHeaderString("SID_NAME"))
				{
					iNameCol = i;
					break;
				}
			}
			string propTypeName = e.TableControl.Table.TableModel[iRow,iNameCol].FormattedText;   
			LRRPropertyType _propType = _lrrPropertyTypes.GetPropertyTypeByName(propTypeName);    
			ArrayList MappedGroupProperties = new ArrayList();
			MappedGroupProperties = LRRModel.CheckForMapping(_propType);
			if(MappedGroupProperties.Count == 0)
			{
				DialogResult dlgResult =   LRRMessagBox.ShowMessage("SID_CASCADE_CHANGES_WITHOUT_RESTART","SID_LABLE",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     //MessageBox.Show("Do you want to cascade changes ? ","PE-Advisor",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(dlgResult == DialogResult.No)
				{
					e.Inner.Cancel = true; 	
				}
			}
			else
			{
				LRRMessagBox.ShowMessage(this,"SID_MAPPING_EXISTS","SID_LABLE",MessageBoxButtons.OK,MessageBoxIcon.Information);      
				for(int i = 0 ;i < MappedGroupProperties.Count;i++)
				{
					LRRHistPropCompPropMapping histPropCompPropMap = MappedGroupProperties[i] as LRRHistPropCompPropMapping; 
					Logger.LogMessage(histPropCompPropMap.ComponentPropertyName +"  Mapped With HistTag  " + histPropCompPropMap.HistTag ,Logger.Level.Error);
				}
				e.Inner.Cancel = true; 
			}

		}
	}
}
