using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Globals.Enums;
using Symcon.Utils.HeaderDispatcher;  
using Symcon.Utils.MessageLogger;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlEVVDefinitions.
	/// </summary>
	public class UserControlEVVDefinitions : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.Panel pnlFull;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUOMTye;
		private System.Windows.Forms.Panel pnlUOMType;
		private System.Windows.Forms.Splitter splitter1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridEVVs;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlEVVDefinitions()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			SyncGridUtilities.InitializeGridLookAndFeel(gridEVVs);
			SyncGridUtilities.InitializeGridLookAndFeel(gridUOMTye);
            gridEVVs.TableModel.CellModels.Add("EllipsisText", new EllipsisCellModel(gridEVVs.TableModel.Model));
            origArraySymbolColor = Enum.GetNames(typeof(KnownColor));
			BindGridgridUOMTye();
			BindGridEVV();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.pnlFull = new System.Windows.Forms.Panel();
            this.gridEVVs = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.pnlUOMType = new System.Windows.Forms.Panel();
            this.gridUOMTye = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlFull.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridEVVs)).BeginInit();
            this.pnlUOMType.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridUOMTye)).BeginInit();
            this.SuspendLayout();
            // 
            // pnlFull
            // 
            this.pnlFull.Controls.Add(this.gridEVVs);
            this.pnlFull.Controls.Add(this.splitter1);
            this.pnlFull.Controls.Add(this.pnlUOMType);
            this.pnlFull.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlFull.Location = new System.Drawing.Point(0, 0);
            this.pnlFull.Name = "pnlFull";
            this.pnlFull.Size = new System.Drawing.Size(560, 504);
            this.pnlFull.TabIndex = 0;
            // 
            // gridEVVs
            // 
            this.gridEVVs.BackColor = System.Drawing.SystemColors.Window;
            this.gridEVVs.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridEVVs.Location = new System.Drawing.Point(0, 355);
            this.gridEVVs.Name = "gridEVVs";
            this.gridEVVs.Size = new System.Drawing.Size(560, 149);
            this.gridEVVs.TabIndex = 3;
            this.gridEVVs.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            this.gridEVVs.Text = "gridGroupingControl1";
            this.gridEVVs.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridEVVs.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridEVVs.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridEVVs.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridEVVs.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridEVVs.VersionInfo = "3.301.0.0";
            this.gridEVVs.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridEVVs_TableControlPrepareViewStyleInfo);
            this.gridEVVs.DragDrop += new System.Windows.Forms.DragEventHandler(this.gridEVVs_DragDrop);
            this.gridEVVs.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.gridEVVs_TableControlCurrentCellCloseDropDown);
            this.gridEVVs.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridEVVs_QueryCellStyleInfo);
            this.gridEVVs.TableControlCellButtonClicked += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellButtonClickedEventHandler(this.gridEVVs_TableControlCellButtonClicked);
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 352);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(560, 3);
            this.splitter1.TabIndex = 2;
            this.splitter1.TabStop = false;
            // 
            // pnlUOMType
            // 
            this.pnlUOMType.Controls.Add(this.gridUOMTye);
            this.pnlUOMType.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlUOMType.Location = new System.Drawing.Point(0, 0);
            this.pnlUOMType.Name = "pnlUOMType";
            this.pnlUOMType.Size = new System.Drawing.Size(560, 352);
            this.pnlUOMType.TabIndex = 1;
            // 
            // gridUOMTye
            // 
            this.gridUOMTye.BackColor = System.Drawing.SystemColors.Window;
            this.gridUOMTye.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridUOMTye.Location = new System.Drawing.Point(0, 0);
            this.gridUOMTye.Name = "gridUOMTye";
            this.gridUOMTye.Size = new System.Drawing.Size(560, 352);
            this.gridUOMTye.TabIndex = 0;
            this.gridUOMTye.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)
                        | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            this.gridUOMTye.Text = "gridGroupingControl1";
            this.gridUOMTye.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridUOMTye.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridUOMTye.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridUOMTye.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridUOMTye.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridUOMTye.VersionInfo = "3.301.0.0";
            this.gridUOMTye.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridUOMTye_CurrentRecordContextChange);
            // 
            // UserControlEVVDefinitions
            // 
            this.Controls.Add(this.pnlFull);
            this.Name = "UserControlEVVDefinitions";
            this.Size = new System.Drawing.Size(560, 504);
            this.pnlFull.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridEVVs)).EndInit();
            this.pnlUOMType.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridUOMTye)).EndInit();
            this.ResumeLayout(false);

		}

		#endregion

		#region Fields
		private LRRApp					_app;
		private	LRREVVs					_lrrEVVs = new LRREVVs();
		private LRRUOMTypes				_lrrUOMTypes=null;
        private string[] origArraySymbolColor = null;
		#endregion

		#region Methods
		/// <summary>
		/// This method is used to intialize the datasource
		/// </summary>
		private void InitDataSource()
		{
//			if(_lrrEVVs != null)
//				_lrrEVVs.Clear();
			if(_lrrUOMTypes != null)
				_lrrUOMTypes.Clear();
			
			//_lrrEVVs=LRRModel.ChildModel.EVVs;
			_lrrUOMTypes=LRRModel.ChildModel.UomTypes.GetUOMTypesOfTypeEvvs();
		}
		
		/// <summary>
		///  This method is used to bind the UOMType grid with data
		/// </summary>
		private void BindGridgridUOMTye()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUOMTye.TableModel.BeginUpdate();
			gridUOMTye.SuspendLayout();

			//Populate the columns for the grid object
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrUOMTypes.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj1 in fkColumns.Keys)
			{
				string propName = (string)obj1;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridUOMTye,gridUOMTye.TableDescriptor,_lrrUOMTypes.ItemType,null,true,fkData,null,false);
			gridUOMTye.TableDescriptor.Columns.Clear();
			gridUOMTye.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_NAME"),"Name");
			gridUOMTye.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"Description");
			//Set the data store 
			gridUOMTye.DataSource = _lrrUOMTypes;
			
			//Resume the Layout of the Grid...
			gridUOMTye.ResumeLayout(false);
			gridUOMTye.TableModel.EndUpdate();

			//Add the parent table for the Relations...
			gridUOMTye.Engine.SourceListSet.Add("ParentTable",_lrrUOMTypes);
		}

		

		/// <summary>
		/// This method is used to bind the EVV grid with data
		/// </summary>
		private void BindGridEVV()
		{
			
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridEVVs.SuspendLayout();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrEVVs.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj1 in fkColumns.Keys)
			{
				string propName = (string)obj1;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				
				//_app.DBManagerObj.PopulateCollection(collectionObject," WHERE  false);
				collectionObject = LRRModel.ChildModel.UomTypes.GetUOMTypesOfTypeEvvs() as CustomCollection;
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridEVVs,gridEVVs.TableDescriptor,_lrrEVVs.ItemType,null,true,fkData,null,false);
            gridEVVs.TableDescriptor.Columns["Color"].Appearance.AnyRecordFieldCell.CellType = "EllipsisText";
          //  gridEVVs.TableDescriptor.Columns["Color"].Appearance.AnyRecordFieldCell.DataSource = origArraySymbolColor;
            
			//Set the data store 
			gridEVVs.DataSource = _lrrEVVs;
			gridEVVs.TableDescriptor.AllowNew = true;
			gridEVVs.TableDescriptor.AllowRemove = true;
			gridEVVs.TableDescriptor.AllowEdit = true;
			//Resume the Layout of the Grid...
			gridEVVs.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridEVVs.Engine.SourceListSet.Add("ParentTable",_lrrEVVs);

		}
		/// <summary>
		/// This method will return the EVVS for the selected UOMType
		/// </summary>
		/// 
		/// <param name="uomTypeID">Pass the UOMTypeID </param>
		/// <returns></returns>
		private LRREVVs GetEVVsForUOMTypeID(string uomTypeID)
		{
			_lrrEVVs=new LRREVVs();
			IEnumerator ieNum = LRRModel.ChildModel.EVVs.GetEnumerator();
			while(ieNum.MoveNext())
			{
				try
				{
					LRREVV lrrEVV = (LRREVV)ieNum.Current;
					if(lrrEVV != null)
					{
						if(lrrEVV.UOMTypeID == uomTypeID)
							_lrrEVVs.Add(lrrEVV);
					}
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(UserControlEVVDefinitions),"gridEVVs_CurrentRecordContextChange Event :"+ex.Message  ,Logger.Level.Debug);
				}
			}
			return _lrrEVVs;
		}
		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlEVVDefinitions.LeftColMovement implementation
		}

		public void ClearSort()
		{
			// TODO:  Add UserControlEVVDefinitions.ClearSort implementation
		}

		public void RightLevel()
		{
			// TODO:  Add UserControlEVVDefinitions.RightLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add UserControlEVVDefinitions.UpLevel implementation
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsLevel implementation
			return false;
		}

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlEVVDefinitions.PerformDirtyChk getter implementation
				return false;
			}
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsRefresh implementation
			return true;
		}

		public void Undo()
		{
			// TODO:  Add UserControlEVVDefinitions.Undo implementation
		}

		public bool SupportsCopy()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsCopy implementation
			return false;
		}

		public void SelectionPaste()
		{
			// TODO:  Add UserControlEVVDefinitions.SelectionPaste implementation
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add UserControlEVVDefinitions.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlEVVDefinitions.ParentTabPage setter implementation
			}
		}

		public void PageSetup()
		{
			// TODO:  Add UserControlEVVDefinitions.PageSetup implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlEVVDefinitions.OpenQuery implementation
		}

		public void Copy()
		{
			// TODO:  Add UserControlEVVDefinitions.Copy implementation
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsPageSetup implementation
			return false;
		}

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlEVVDefinitions.ShowPropertyList implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsClearSort implementation
			return false;
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlEVVDefinitions.RightColMovement implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add UserControlEVVDefinitions.LeftLevel implementation
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsDelete implementation
			return false;
		}

		public void PrintPreview()
		{
			// TODO:  Add UserControlEVVDefinitions.PrintPreview implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsPaste implementation
			return false;
		}

		public void Print()
		{
			// TODO:  Add UserControlEVVDefinitions.Print implementation
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsPrint implementation
			return false;
		}

		public void OpenView()
		{
			// TODO:  Add UserControlEVVDefinitions.OpenView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlEVVDefinitions.TransposeView implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add UserControlEVVDefinitions.ArrangeColumns implementation
		}

		public void Export()
		{
			// TODO:  Add UserControlEVVDefinitions.Export implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlEVVDefinitions.ShowComponentList implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add UserControlEVVDefinitions.ClearFilter implementation
		}

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlEVVDefinitions.OpenCompositeView implementation
		}

		public void Delete()
		{
			// TODO:  Add UserControlEVVDefinitions.Delete implementation
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsUndo implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsExport implementation
			return false;
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add UserControlEVVDefinitions.CopyUOMTypes implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add UserControlEVVDefinitions.ImportToExcel implementation
		}

		public void Refresh()
		{
			BindGridgridUOMTye();
			BindGridEVV();
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsSelectionPaste implementation
			return false;
		}

		public void DownLevel()
		{
			// TODO:  Add UserControlEVVDefinitions.DownLevel implementation
		}

		public void Paste()
		{
			// TODO:  Add UserControlEVVDefinitions.Paste implementation
		}

		public bool SupportsSave()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsSave implementation
			return true;
		}

		public void InsertNewRows()
		{
			// TODO:  Add UserControlEVVDefinitions.InsertNewRows implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add UserControlEVVDefinitions.CopyMasterProperties implementation
		}

		public void Save()
		{
			this.gridEVVs.Table.EndEdit(); 
			this.gridUOMTye.Table.EndEdit();
			string uomTypeID=null;
			if(gridUOMTye.CurrencyManager.Position!=-1)
			{
				LRRUOMType	uomType=gridUOMTye.CurrencyManager.Current as LRRUOMType;
				if(uomType.ObjectState!=DBOperation.DELETE)
				{
					if(uomType!=null)
					{
						uomTypeID=uomType.UOMTypeID;
					}
				}

				LRRUOMTypes lrrUOMTypesChanged=_lrrUOMTypes.GetChanges();
				foreach(LRRUOMType _uomtype in lrrUOMTypesChanged)
				{

					string sID = _uomtype.UOMTypeID;

					if(_uomtype.ObjectState!=DBOperation.DELETE)
					{
						//Checking for duplicates & null values
						string sName = _uomtype.Name  == null ? "" : _uomtype.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string sUOMTypeID = _uomtype.UOMTypeID == null ? "" : _uomtype.UOMTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
	
						if(sName=="") 
						{
							LRRMessagBox.ShowMessage("SID_SAVEABORT_UOM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
							return;
						}
	
						foreach (LRRUOMType  objUOMType in _lrrUOMTypes)
						{
							if((objUOMType.UOMTypeID != sUOMTypeID) && (objUOMType.ObjectState != DBOperation.DELETE))
							{
								string sUOMTypeName = objUOMType.Name  == null ? "" : objUOMType.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
								if(sUOMTypeName.ToUpper() == sName.ToUpper())
								{
									//MessageBox.Show("UOM Type - " + sUOMTypeName + " already exists. Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
									string[] s = new string[1];
									s[0] = sUOMTypeName;
									LRRMessagBox.ShowMessage("SID_PROP_DUPLICATE","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);     
									return;
								}
							}
						}
					}
					//inserting  UOMType
					if(_uomtype.ObjectState==DBOperation.INSERT)
					{
						if(!_uomtype.IsEVV)
							_uomtype.IsEVV=true;
						LRRModel.ChildModel.UomTypes.Add(_uomtype);
					}
					//Deleting UOMType
					if(_uomtype.ObjectState==DBOperation.DELETE)
					{
						LRRModel.ChildModel.UomTypes.Remove(LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(sID));
						//For deleting the EVVs of the deleted UOMType
						LRREVVs _evvs= LRRModel.ChildModel.GetEVVsFromUOMTypeID(sID);
//						foreach(LRREVV evv in _evvs)
//						{
//							_lrrEVVs.Remove(LRRModel.ChildModel.EVVs.GetEVVObjectFromID(evv.ID));
//							LRRModel.ChildModel.EVVs.Remove(LRRModel.ChildModel.EVVs.GetEVVObjectFromID(evv.ID));
//						}
						for(int i=0;i<_evvs.Count;i++)
						{
							_lrrEVVs.DeletedItems.Add(_evvs[i]);
							LRRModel.ChildModel.EVVs.Remove(_evvs[i]);
						}
					}
				}
				//Committing the UOMTYPES
				if(lrrUOMTypesChanged.Count>0)
				{
					_app.DBManagerObj.CommitCollection(lrrUOMTypesChanged);
					OptionsUserControl.saved=true;
				}
				if(_lrrUOMTypes.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{
					_lrrUOMTypes.RefreshCollection();
				}
				
				LRREVVs	lrrEVVsChanged=_lrrEVVs.GetChanges();
				if(lrrEVVsChanged.Count>0)
				{
					foreach (LRREVV  lrrEVV in lrrEVVsChanged)
					{
						if(lrrEVV.ObjectState==DBOperation.INSERT)
						{
							lrrEVV.ID=Guid.NewGuid().ToString();
							lrrEVV.UOMTypeID=uomTypeID;
							LRRModel.ChildModel.EVVs.Add(lrrEVV);
						}			
						if(lrrEVV.ObjectState==DBOperation.DELETE)
						{
							if(LRRModel.ChildModel.EVVs.Contains(LRRModel.ChildModel.EVVs.GetEVVObjectFromID(lrrEVV.ID)))
								LRRModel.ChildModel.EVVs.Remove(LRRModel.ChildModel.EVVs.GetEVVObjectFromID(lrrEVV.ID));
						}
					}
					//Committing the EVVs
					_app.DBManagerObj.CommitCollection(lrrEVVsChanged);
					OptionsUserControl.saved=true;
				}
				if(_lrrEVVs.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{
					_lrrEVVs.RefreshCollection();
				}

				LRRModel.ChildModel.UomTypes.RefreshCollection();
				//LRRModel.ChildModel.UomTypes.GetUOMTypesOfTypeEvvs().RefreshCollection();
				_lrrUOMTypes.RefreshCollection();
				LRRModel.ChildModel.EVVs.RefreshCollection();
				_lrrEVVs.RefreshCollection();
			}
			gridUOMTye.Table.AddNewRecord.SetCurrent();
			gridUOMTye.Table.AddNewRecord.SetSelected(true);
			
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add UserControlEVVDefinitions.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlEVVDefinitions.ParentTabControl setter implementation
			}
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add UserControlEVVDefinitions.SupportsCopyUOMTypes implementation
			return false;
		}

		#endregion
		
		
		private void gridUOMTye_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			if((e.Record != null)&&(e.Action == CurrentRecordAction.EnterRecordComplete))
			{
				LRRUOMType lrrUOMType =  (LRRUOMType)e.Record.GetData();
				if(lrrUOMType != null)
				{
					_lrrEVVs = GetEVVsForUOMTypeID(lrrUOMType.UOMTypeID);
					BindGridEVV();
				}
			}
			if(e.Table.CurrentRecord != null)
			{
				if((e.Table.CurrentRecord.GetType() == typeof(GridAddNewRecord)) && e.Action==CurrentRecordAction.NavigateComplete)
				{
					_lrrEVVs = GetEVVsForUOMTypeID(null);
					BindGridEVV();
				}
			}
		}

        private void gridEVVs_TableControlCellButtonClicked(object sender, GridTableControlCellButtonClickedEventArgs e)
        {
            gridEVVs.TableControl.GetCellRenderer(e.Inner.RowIndex, e.Inner.ColIndex).CurrentCell.Activate(e.Inner.RowIndex, e.Inner.ColIndex);
            gridEVVs.TableControl.GetCellRenderer(e.Inner.RowIndex, e.Inner.ColIndex).SupportsFocusControl = true;
            gridEVVs.TableControl.GetCellRenderer(e.Inner.RowIndex, e.Inner.ColIndex).AlwaysRaiseCellClick = true;
            gridEVVs.TableControl.Table.Records[e.Inner.RowIndex-3].SetCurrent();
            ColorDialog clrDialog = new ColorDialog();
            if (DialogResult.OK == clrDialog.ShowDialog(this))
            {
                Color cl = clrDialog.Color;
                if (e.TableControl.Table.CurrentRecord != null)
                {
                    LRREVV evv = e.TableControl.Table.CurrentRecord.GetData() as LRREVV;
                    evv.Color = cl.ToArgb();
                    e.TableControl.CurrentCell.Refresh();
                    e.TableControl.CurrentCell.Reactivate();
                }
            }
        
        }

        private void gridEVVs_TableControlCurrentCellCloseDropDown(object sender, GridTableControlPopupClosedEventArgs e)
        {
           /* LRREVV EVV = e.TableControl.Table.CurrentRecord.GetData() as LRREVV;
            if (EVV != null)
            {
                Color clr = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor),EVV.Color));
                e.TableControl.Table.TableModel[e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex].BackColor = clr;
            }*/
        }

        private void gridEVVs_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
           /* int rowIndex = e.TableCellIdentity.RowIndex;
            int colIndex = e.TableCellIdentity.ColIndex;
            
            if (e.TableCellIdentity.Table.Records.Count > rowIndex && rowIndex > 2
                && (colIndex == 0 || colIndex == 1))
            {
                string colHeader = e.TableCellIdentity.Table.GetHeaderColumnDescriptorAt(colIndex).Name;
                if (colHeader == "Color")
                {
                    LRREVV lrrEVV = e.TableCellIdentity.Table.Records[rowIndex].GetData() as LRREVV;
                    if (lrrEVV != null)
                    {
                        System.Drawing.Color clr = System.Drawing.Color.FromArgb(lrrEVV.Color);
                        e.Style.BackColor = clr;
                    }
                }
            }*/
        }

        private void gridEVVs_TableControlPrepareViewStyleInfo(object sender, GridTableControlPrepareViewStyleInfoEventArgs e)
        {
            if (e.Inner.RowIndex > 2)
            {
                GridColumnDescriptor gcd = gridEVVs.TableModel.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex);
                if (gcd != null)
                {
                    string colHeader = gcd.HeaderText;
                    if (colHeader == LRRHeaderText.GetHeaderString("SID_ACTIVE_COLOR"))
                    {
                        object obj = gridEVVs.TableModel[e.Inner.RowIndex, e.Inner.ColIndex].CellValue;
                        if (obj != null && obj != "")
                        {
                            foreach (LRREVV evvObj in _lrrEVVs)
                            {
                                if (evvObj.Color.ToString() == obj.ToString())
                                {
                                    System.Drawing.Color clr = System.Drawing.Color.FromArgb(evvObj.Color);
                                    e.Inner.Style.BackColor = clr;
                                    e.Inner.Style.TextColor = clr;
                                }
                            }
                        }
                    }
                }
            }
        }

        private void gridEVVs_DragDrop(object sender, DragEventArgs e)
        {
            
        }
	}
}
