using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.LightRidge.PEAdvisor;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlMessagingServer.
	/// </summary>
	public class UserControlMessagingServer : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox txtMSName;
		private System.Windows.Forms.TextBox txtMSPort;
		private System.Windows.Forms.TextBox txtApplicationName;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private TabPage						_parentTabPage;
		private TabControl					_parentTabControl;
		private LRRApp						_lrrApp;
		private LRROptions					_lrrOptions;

		public UserControlMessagingServer()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);  
			_lrrApp=AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrOptions=_lrrApp.GetOptions() as LRROptions;
			txtMSName.Text=_lrrOptions.MessagingServerInfoObj.ServerIP;
			txtMSPort.Text=_lrrOptions.MessagingServerInfoObj.ServerPort;
			txtApplicationName.Text=_lrrOptions.MessagingServerInfoObj.ApplicationName;
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.txtMSName = new System.Windows.Forms.TextBox();
			this.txtMSPort = new System.Windows.Forms.TextBox();
			this.txtApplicationName = new System.Windows.Forms.TextBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label1.Location = new System.Drawing.Point(104, 96);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 23);
			this.label1.TabIndex = 0;
			this.label1.Tag = "SID_MSGSERVERNAME";
			// 
			// label2
			// 
			this.label2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label2.Location = new System.Drawing.Point(104, 128);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(136, 23);
			this.label2.TabIndex = 1;
			this.label2.Tag = "SID_MSGSERVERPORT";
			// 
			// label3
			// 
			this.label3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label3.Location = new System.Drawing.Point(104, 160);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(136, 23);
			this.label3.TabIndex = 2;
			this.label3.Tag = "SID_APPLICATIONNAME";
			// 
			// txtMSName
			// 
			this.txtMSName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtMSName.Location = new System.Drawing.Point(256, 96);
			this.txtMSName.Name = "txtMSName";
			this.txtMSName.Size = new System.Drawing.Size(240, 20);
			this.txtMSName.TabIndex = 3;
			this.txtMSName.Text = "";
			// 
			// txtMSPort
			// 
			this.txtMSPort.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtMSPort.Location = new System.Drawing.Point(256, 128);
			this.txtMSPort.Name = "txtMSPort";
			this.txtMSPort.Size = new System.Drawing.Size(240, 20);
			this.txtMSPort.TabIndex = 4;
			this.txtMSPort.Text = "";
			this.txtMSPort.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.txtMSPort_KeyPress);
			// 
			// txtApplicationName
			// 
			this.txtApplicationName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtApplicationName.Location = new System.Drawing.Point(256, 160);
			this.txtApplicationName.Name = "txtApplicationName";
			this.txtApplicationName.Size = new System.Drawing.Size(240, 20);
			this.txtApplicationName.TabIndex = 5;
			this.txtApplicationName.Text = "";
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Location = new System.Drawing.Point(80, 64);
			this.panel1.Name = "panelMessagingServer";
			this.panel1.Size = new System.Drawing.Size(432, 144);
			this.panel1.TabIndex = 6;
			// 
			// UserControlMessagingServer
			// 
			this.Controls.Add(this.txtApplicationName);
			this.Controls.Add(this.txtMSPort);
			this.Controls.Add(this.txtMSName);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.panel1);
			this.Name = "UserControlMessagingServer";
			this.Size = new System.Drawing.Size(600, 376);
			this.Tag = "SID_MESSGSERVER";
			this.ResumeLayout(false);

		}
		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
		}

		public void Save()
		{

			if(_lrrOptions.MessagingServerInfoObj.ServerIP!=txtMSName.Text || _lrrOptions.MessagingServerInfoObj.ServerPort!=txtMSPort.Text || _lrrOptions.MessagingServerInfoObj.ApplicationName!=txtApplicationName.Text)
			{
				_lrrOptions.MessagingServerInfoObj.ServerIP = txtMSName.Text;
				_lrrOptions.MessagingServerInfoObj.ServerPort = txtMSPort.Text;
				_lrrOptions.MessagingServerInfoObj.ApplicationName=txtApplicationName.Text;
				_lrrApp.DBManagerObj.CommitObject(_lrrOptions.MessagingServerInfoObj);
				if(MessagingClient.IsInitialized)
				{
					MessagingClient.Terminate();
					MessagingClient.ReInitializeClient();
				}
				else
				{
					MessagingClient.ReInitializeClient();
				}
				OptionsUserControl.saved = true;
			}

			
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			

		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlQualifiers.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlQualifiers.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlQualifiers.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlQualifiers.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlQualifiers.RightColMovement implementation
		}

		#endregion

		private void txtMSPort_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if ( !( char.IsDigit( e.KeyChar) || char.IsControl( e.KeyChar ) ||(e.KeyChar== (char )46)) )
			{				
				e.Handled = true;			
			}
		}
		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlMessagingServer.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlMessagingServer.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlMessagingServer.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlMessagingServer.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlMessagingServer.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlMessagingServer.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlMessagingServer.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlMessagingServer.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlMessagingServer.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlMessagingServer.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlMessagingServer.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlMessagingServer.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlMessagingServer.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
