using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects; 
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;


namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlPersistance.
	/// </summary>
	public class UserControlPersistance : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.CheckBox chkDisablePersistance;
		private System.Windows.Forms.CheckBox chkRunStatusDialog;
		private System.Windows.Forms.CheckBox chkPerformInputRead;
		private System.Windows.Forms.CheckBox chkShowLabels;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.CheckBox chkPET;
		private System.Windows.Forms.Label labelRollOverLimit;
		private System.Windows.Forms.TextBox textBoxRollOverLimit;
		private System.Windows.Forms.CheckBox checkBoxClearAlerts;
		private System.Windows.Forms.Label lblManualEntryHistDB;
		private System.Windows.Forms.ComboBox cmbManualEntryHistDBs;
		private System.Windows.Forms.CheckBox chkBoxDefaultSettings;
		private System.Windows.Forms.ComboBox ddlGraphicsToolTip;
		private System.Windows.Forms.Label lblGraphicsToolTip;
        private ComboBox ddlFormatter;
        private Label lblFormatter;
        private Label lblWebConfig;
        private TextBox txtWebConfig;
        private Button btnWebConfig;
        private FolderBrowserDialog folderBrowserDialog1;
        private CheckBox chkPublishGraphics;
		private System.ComponentModel.IContainer components;
        private System.Windows.Forms.CheckBox chkUseTemplateForOverrides;

		public UserControlPersistance()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			InternationalizationUtils.GetControlText(this,null);  

			// TODO: Add any initialization after the InitializeComponent call
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			_lrrOptionsObj = _app.GetOptions() as LRROptions;
			

			
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				this.chkPerformInputRead.DataBindings.Clear();
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.chkDisablePersistance = new System.Windows.Forms.CheckBox();
            this.chkRunStatusDialog = new System.Windows.Forms.CheckBox();
            this.chkPerformInputRead = new System.Windows.Forms.CheckBox();
            this.chkShowLabels = new System.Windows.Forms.CheckBox();
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.chkPET = new System.Windows.Forms.CheckBox();
            this.textBoxRollOverLimit = new System.Windows.Forms.TextBox();
            this.labelRollOverLimit = new System.Windows.Forms.Label();
            this.checkBoxClearAlerts = new System.Windows.Forms.CheckBox();
            this.lblManualEntryHistDB = new System.Windows.Forms.Label();
            this.cmbManualEntryHistDBs = new System.Windows.Forms.ComboBox();
            this.chkBoxDefaultSettings = new System.Windows.Forms.CheckBox();
            this.ddlGraphicsToolTip = new System.Windows.Forms.ComboBox();
            this.lblGraphicsToolTip = new System.Windows.Forms.Label();
            this.ddlFormatter = new System.Windows.Forms.ComboBox();
            this.lblFormatter = new System.Windows.Forms.Label();
            this.lblWebConfig = new System.Windows.Forms.Label();
            this.txtWebConfig = new System.Windows.Forms.TextBox();
            this.btnWebConfig = new System.Windows.Forms.Button();
            this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
            this.chkPublishGraphics = new System.Windows.Forms.CheckBox();
            this.chkUseTemplateForOverrides = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            // 
            // chkDisablePersistance
            // 
            this.chkDisablePersistance.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkDisablePersistance.Location = new System.Drawing.Point(16, 40);
            this.chkDisablePersistance.Name = "chkDisablePersistance";
            this.chkDisablePersistance.Size = new System.Drawing.Size(216, 24);
            this.chkDisablePersistance.TabIndex = 1;
            this.chkDisablePersistance.Tag = "SID_DISABLE_PERSISTANCE";
            // 
            // chkRunStatusDialog
            // 
            this.chkRunStatusDialog.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkRunStatusDialog.Location = new System.Drawing.Point(16, 72);
            this.chkRunStatusDialog.Name = "chkRunStatusDialog";
            this.chkRunStatusDialog.Size = new System.Drawing.Size(216, 16);
            this.chkRunStatusDialog.TabIndex = 2;
            this.chkRunStatusDialog.Tag = "SID_SHOW_RUN";
            this.toolTip1.SetToolTip(this.chkRunStatusDialog, "When checked, the RunStatus Window will get displayed while making a Run");
            // 
            // chkPerformInputRead
            // 
            this.chkPerformInputRead.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkPerformInputRead.Location = new System.Drawing.Point(16, 104);
            this.chkPerformInputRead.Name = "chkPerformInputRead";
            this.chkPerformInputRead.Size = new System.Drawing.Size(216, 16);
            this.chkPerformInputRead.TabIndex = 3;
            this.chkPerformInputRead.Tag = "SID_READ_INPUT_FRM_ENGINE";
            this.toolTip1.SetToolTip(this.chkPerformInputRead, "When checked, the values will get extracted from the Model to PEAdvisor");
            // 
            // chkShowLabels
            // 
            this.chkShowLabels.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkShowLabels.Location = new System.Drawing.Point(16, 136);
            this.chkShowLabels.Name = "chkShowLabels";
            this.chkShowLabels.Size = new System.Drawing.Size(216, 16);
            this.chkShowLabels.TabIndex = 4;
            this.chkShowLabels.Tag = "SID_ALWAYS_SHOW_MODE_VALUES";
            // 
            // toolTip1
            // 
            this.toolTip1.ShowAlways = true;
            // 
            // chkPET
            // 
            this.chkPET.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkPET.Enabled = false;
            this.chkPET.Location = new System.Drawing.Point(16, 168);
            this.chkPET.Name = "chkPET";
            this.chkPET.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.chkPET.Size = new System.Drawing.Size(216, 16);
            this.chkPET.TabIndex = 5;
            this.chkPET.Tag = "SID_ENABLE_TIME";
            this.toolTip1.SetToolTip(this.chkPET, "When checked, the PET is applied ;When unchecked, the PET is not applied");
            // 
            // textBoxRollOverLimit
            // 
            this.textBoxRollOverLimit.Location = new System.Drawing.Point(216, 256);
            this.textBoxRollOverLimit.Name = "textBoxRollOverLimit";
            this.textBoxRollOverLimit.Size = new System.Drawing.Size(72, 20);
            this.textBoxRollOverLimit.TabIndex = 6;
            this.textBoxRollOverLimit.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBoxRollOverLimit_KeyPress);
            // 
            // labelRollOverLimit
            // 
            this.labelRollOverLimit.Location = new System.Drawing.Point(16, 256);
            this.labelRollOverLimit.Name = "labelRollOverLimit";
            this.labelRollOverLimit.Size = new System.Drawing.Size(104, 16);
            this.labelRollOverLimit.TabIndex = 7;
            this.labelRollOverLimit.Tag = "SID_ROLL_OVER";
            // 
            // checkBoxClearAlerts
            // 
            this.checkBoxClearAlerts.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.checkBoxClearAlerts.Location = new System.Drawing.Point(16, 192);
            this.checkBoxClearAlerts.Name = "checkBoxClearAlerts";
            this.checkBoxClearAlerts.Size = new System.Drawing.Size(216, 24);
            this.checkBoxClearAlerts.TabIndex = 8;
            this.checkBoxClearAlerts.Tag = "SID_CLEAR_ALERTS";
            // 
            // lblManualEntryHistDB
            // 
            this.lblManualEntryHistDB.Location = new System.Drawing.Point(16, 288);
            this.lblManualEntryHistDB.Name = "lblManualEntryHistDB";
            this.lblManualEntryHistDB.Size = new System.Drawing.Size(192, 16);
            this.lblManualEntryHistDB.TabIndex = 9;
            this.lblManualEntryHistDB.Tag = "SID_MANUAL_ENTRY_HIST_DB";
            // 
            // cmbManualEntryHistDBs
            // 
            this.cmbManualEntryHistDBs.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbManualEntryHistDBs.Location = new System.Drawing.Point(216, 288);
            this.cmbManualEntryHistDBs.Name = "cmbManualEntryHistDBs";
            this.cmbManualEntryHistDBs.Size = new System.Drawing.Size(121, 21);
            this.cmbManualEntryHistDBs.TabIndex = 10;
            // 
            // chkBoxDefaultSettings
            // 
            this.chkBoxDefaultSettings.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkBoxDefaultSettings.Location = new System.Drawing.Point(16, 224);
            this.chkBoxDefaultSettings.Name = "chkBoxDefaultSettings";
            this.chkBoxDefaultSettings.Size = new System.Drawing.Size(216, 24);
            this.chkBoxDefaultSettings.TabIndex = 11;
            this.chkBoxDefaultSettings.Tag = "SID_USE_DEFAULT_SETTINGS";
            // 
            // ddlGraphicsToolTip
            // 
            this.ddlGraphicsToolTip.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.ddlGraphicsToolTip.Location = new System.Drawing.Point(216, 320);
            this.ddlGraphicsToolTip.Name = "ddlGraphicsToolTip";
            this.ddlGraphicsToolTip.Size = new System.Drawing.Size(121, 21);
            this.ddlGraphicsToolTip.TabIndex = 12;
            // 
            // lblGraphicsToolTip
            // 
            this.lblGraphicsToolTip.Location = new System.Drawing.Point(16, 320);
            this.lblGraphicsToolTip.Name = "lblGraphicsToolTip";
            this.lblGraphicsToolTip.Size = new System.Drawing.Size(192, 16);
            this.lblGraphicsToolTip.TabIndex = 11;
            this.lblGraphicsToolTip.Tag = "SID_GRAPHICS_TOOLTIP_OPTION";
            // 
            // ddlFormatter
            // 
            this.ddlFormatter.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.ddlFormatter.Location = new System.Drawing.Point(216, 360);
            this.ddlFormatter.Name = "ddlFormatter";
            this.ddlFormatter.Size = new System.Drawing.Size(121, 21);
            this.ddlFormatter.TabIndex = 13;
            this.ddlFormatter.SelectedIndexChanged += new System.EventHandler(this.ddlFormatter_SelectedIndexChanged);
            // 
            // lblFormatter
            // 
            this.lblFormatter.Location = new System.Drawing.Point(16, 360);
            this.lblFormatter.Name = "lblFormatter";
            this.lblFormatter.Size = new System.Drawing.Size(104, 16);
            this.lblFormatter.TabIndex = 14;
            this.lblFormatter.Tag = "SID_FORMAT";
            // 
            // lblWebConfig
            // 
            this.lblWebConfig.Location = new System.Drawing.Point(16, 391);
            this.lblWebConfig.Name = "lblWebConfig";
            this.lblWebConfig.Size = new System.Drawing.Size(172, 17);
            this.lblWebConfig.TabIndex = 15;
            this.lblWebConfig.Tag = "SID_WEB_CONFIG";
            // 
            // txtWebConfig
            // 
            this.txtWebConfig.Enabled = false;
            this.txtWebConfig.Location = new System.Drawing.Point(216, 388);
            this.txtWebConfig.Name = "txtWebConfig";
            this.txtWebConfig.Size = new System.Drawing.Size(308, 20);
            this.txtWebConfig.TabIndex = 16;
            // 
            // btnWebConfig
            // 
            this.btnWebConfig.Location = new System.Drawing.Point(530, 386);
            this.btnWebConfig.Name = "btnWebConfig";
            this.btnWebConfig.Size = new System.Drawing.Size(27, 23);
            this.btnWebConfig.TabIndex = 17;
            this.btnWebConfig.Text = "...";
            this.btnWebConfig.UseVisualStyleBackColor = true;
            this.btnWebConfig.Click += new System.EventHandler(this.btnWebConfig_Click);
            // 
            // chkPublishGraphics
            // 
            this.chkPublishGraphics.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkPublishGraphics.Location = new System.Drawing.Point(16, 414);
            this.chkPublishGraphics.Name = "chkPublishGraphics";
            this.chkPublishGraphics.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.chkPublishGraphics.Size = new System.Drawing.Size(216, 24);
            this.chkPublishGraphics.TabIndex = 18;
            this.chkPublishGraphics.Tag = "SID_PUBLISH_GRAPHICS";
            this.chkPublishGraphics.UseVisualStyleBackColor = true;
            // 
            // chkUseTemplateForOverrides
            // 
            this.chkUseTemplateForOverrides.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.chkUseTemplateForOverrides.Location = new System.Drawing.Point(16, 440);
            this.chkUseTemplateForOverrides.Name = "chkUseTemplateForOverrides";
            this.chkUseTemplateForOverrides.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.chkUseTemplateForOverrides.Size = new System.Drawing.Size(216, 24);
            this.chkUseTemplateForOverrides.TabIndex = 19;
            this.chkUseTemplateForOverrides.Tag = "SID_USE_TEMPLATE_OVERRIDES";
            this.chkUseTemplateForOverrides.UseVisualStyleBackColor = true;
            this.chkUseTemplateForOverrides.CheckedChanged += new System.EventHandler(this.chkUseTemplateForOverrides_CheckedChanged);
            // 
            // UserControlPersistance
            // 
            this.Controls.Add(this.chkPublishGraphics);
            this.Controls.Add(this.btnWebConfig);
            this.Controls.Add(this.txtWebConfig);
            this.Controls.Add(this.lblWebConfig);
            this.Controls.Add(this.lblFormatter);
            this.Controls.Add(this.ddlFormatter);
            this.Controls.Add(this.chkBoxDefaultSettings);
            this.Controls.Add(this.ddlGraphicsToolTip);
            this.Controls.Add(this.lblGraphicsToolTip);
            this.Controls.Add(this.cmbManualEntryHistDBs);
            this.Controls.Add(this.lblManualEntryHistDB);
            this.Controls.Add(this.checkBoxClearAlerts);
            this.Controls.Add(this.labelRollOverLimit);
            this.Controls.Add(this.textBoxRollOverLimit);
            this.Controls.Add(this.chkPET);
            this.Controls.Add(this.chkShowLabels);
            this.Controls.Add(this.chkPerformInputRead);
            this.Controls.Add(this.chkRunStatusDialog);
            this.Controls.Add(this.chkDisablePersistance);
            this.Controls.Add(this.chkUseTemplateForOverrides);
            this.Name = "UserControlPersistance";
            this.Size = new System.Drawing.Size(585, 493);
            this.Tag = "SID_PERSISTANCE";
            this.Load += new System.EventHandler(this.UserControlPersistance_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void UserControlPersistance_Load(object sender, System.EventArgs e)
		{
			this.chkDisablePersistance.Checked = _lrrOptionsObj.DisablePersistance;
			this.chkRunStatusDialog.Checked = _lrrOptionsObj.ShowRunStatus;
			this.chkPerformInputRead.Checked = _lrrOptionsObj.ReadInputsFromEngine;
			this.chkShowLabels.Checked = _lrrOptionsObj.ShowLabels;
			this.chkPET.Checked = _lrrOptionsObj.EnablePET;
			this.checkBoxClearAlerts.Checked = _lrrOptionsObj.GUIPreferencesObj.ClearAlertsBetweenRun;
			this.textBoxRollOverLimit.Text = _lrrOptionsObj.GUIPreferencesObj.RollOverLimit.ToString();
			this.chkPerformInputRead.DataBindings.Add("Checked",_lrrOptionsObj,"ReadInputsFromEngine");this.chkBoxDefaultSettings.Checked = _lrrOptionsObj.UsePreSetDefaultSetting;  
			this.chkBoxDefaultSettings.Checked = _lrrOptionsObj.UsePreSetDefaultSetting;  
			this.ddlGraphicsToolTip.DataSource = Enum.GetNames(typeof(Globals.Enums.ToolTipOptions));
			this.ddlGraphicsToolTip.SelectedItem = Enum.GetName(typeof(Globals.Enums.ToolTipOptions),_lrrOptionsObj.ToolTipOptions);
            this.ddlFormatter.DataSource = _lrrOptionsObj.NumericFormat;
            this.chkPublishGraphics.Checked = _lrrOptionsObj.PublishGraphics;
            this.chkUseTemplateForOverrides.Checked = _lrrOptionsObj.UseTemplateOverrides;
            //Web Server Path
            this.txtWebConfig.Text = _lrrOptionsObj.WebConfigPath;
            
            foreach (NumericfFormatInfo var in _lrrOptionsObj.NumericFormat)
            {
                if (var.IsSelected)
                {
                    firstTime = true;
                    this.ddlFormatter.SelectedItem = var;
                }
            }
            this.ddlFormatter.DisplayMember = "DisplayName";
            this.ddlFormatter.ValueMember = "FormatName";
          
			
			//Bind the Manual Entry DBs combo
			InitManualEntryHistDBDataSource();

		}

        private bool firstTime = true;
		private void InitManualEntryHistDBDataSource()
		{
			LRRManualEntryHistorianDataBase manualEntryHistDB = _lrrOptionsObj.ManualEntryHistorianDataBaseObj;

			LRRTuningConnection tuningConn = _lrrOptionsObj.TuningConnectionObj.GetActiveTuningDB();
			LRRManualEntryHistorianDataBase manualEntryTuningDB = new LRRManualEntryHistorianDataBase();

			//Get the Active tuning DB
			if(tuningConn != null)
			{
				manualEntryTuningDB.ID = tuningConn.ConnectID;
				manualEntryTuningDB.DatabaseName = tuningConn.DatabaseName;
				manualEntryTuningDB.Type = LRRHeaderText.GetHeaderString("SID_TUNING");
				_arrManualHistDBsList.Add(manualEntryTuningDB);
			}
			
			LRROfflineConnection offlineConn = _lrrOptionsObj.OfflineConnectionObj.GetActiveOfflineDB();
			LRRManualEntryHistorianDataBase manualEntryOfflineDB = new LRRManualEntryHistorianDataBase();

			//Get the Active Offline DB
			if(offlineConn != null)
			{
				manualEntryOfflineDB.ID = offlineConn.ConnectID;
				manualEntryOfflineDB.DatabaseName = offlineConn.DatabaseName;
				manualEntryOfflineDB.Type = LRRHeaderText.GetHeaderString("SID_OFFLINE");
				_arrManualHistDBsList.Add(manualEntryOfflineDB);
			}
			

			LRRManualEntryHistorianDataBase manualEntryDB = new LRRManualEntryHistorianDataBase();
			manualEntryDB.ID = "";
			manualEntryDB.Type = "";
			manualEntryDB.DatabaseName = "";
			_arrManualHistDBsList.Add(manualEntryDB);

			this.cmbManualEntryHistDBs.DataSource = this._arrManualHistDBsList;
			this.cmbManualEntryHistDBs.DisplayMember = "DatabaseName";
			this.cmbManualEntryHistDBs.ValueMember = "ID";

			bool flag = false;
			if(manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_TUNING"))
			{
				if(manualEntryHistDB.ID == manualEntryTuningDB.ID)
				{
					this.cmbManualEntryHistDBs.SelectedIndex = 0;
				}
				else
					flag = true;
			}
			else if(manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_OFFLINE"))
			{
				if(manualEntryHistDB.ID == manualEntryOfflineDB.ID)
				{
					this.cmbManualEntryHistDBs.SelectedIndex =1;
				}
				else
					flag = true;
			}
			else
			{
				flag = true;
			}
			if(flag)
			{
				manualEntryHistDB = null;
				//if(this.cmbManualEntryHistDBs.Items.Count > 2)
                	this.cmbManualEntryHistDBs.SelectedIndex = (this.cmbManualEntryHistDBs.Items.Count - 1);
			}
		}

		#region Public Methods
		public void SetReadInputFromEngineState(bool state)
		{
			this.chkPerformInputRead.Checked = state;
		}
		#endregion

		#region Fields

		private LRRApp							_app;
		public LRROptions				_lrrOptionsObj;
		private ArrayList						_arrManualHistDBsList = new ArrayList();

		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			
		}

		public void Save()
		{
			if(_lrrOptionsObj.DisablePersistance!=this.chkDisablePersistance.Checked)
			{
				_lrrOptionsObj.DisablePersistance = this.chkDisablePersistance.Checked;
				ApplicationPersistanceUtil.DisablePersistance = this.chkDisablePersistance.Checked;
				OptionsUserControl.saved	=true;
			}

			if(_lrrOptionsObj.ShowRunStatus!=this.chkRunStatusDialog.Checked)
			{
				_lrrOptionsObj.ShowRunStatus = this.chkRunStatusDialog.Checked;
				OptionsUserControl.saved	=true;
			}

			if(_lrrOptionsObj.ReadInputsFromEngine !=this.chkPerformInputRead.Checked)
			{
				_lrrOptionsObj.ReadInputsFromEngine = this.chkPerformInputRead.Checked;
				OptionsUserControl.saved	=true;
			}
			if(_lrrOptionsObj.ShowLabels !=this.chkShowLabels.Checked)
			{
				_lrrOptionsObj.ShowLabels = this.chkShowLabels.Checked;
				OptionsUserControl.saved	=true;
			}
			int rollOverLimit = 0;
			try
			{
				rollOverLimit = Int16.Parse(this.textBoxRollOverLimit.Text, System.Globalization.NumberStyles.Integer);
			}
			catch 
			{
				rollOverLimit = 0;
			}
			if (_lrrOptionsObj.GUIPreferencesObj.RollOverLimit != rollOverLimit)
			{
				_lrrOptionsObj.GUIPreferencesObj.RollOverLimit = rollOverLimit;
				Symcon.Utils.Alert.Messages.LRRAlert.RollOverLimit = rollOverLimit;
				OptionsUserControl.saved	=true;
			}
			if (_lrrOptionsObj.GUIPreferencesObj.ClearAlertsBetweenRun != this.checkBoxClearAlerts.Checked)
			{
				_lrrOptionsObj.GUIPreferencesObj.ClearAlertsBetweenRun = this.checkBoxClearAlerts.Checked;
				OptionsUserControl.saved =true;
			}
			
			if(_lrrOptionsObj.ManualEntryHistorianDataBaseObj != this.cmbManualEntryHistDBs.SelectedItem)
			{
				_lrrOptionsObj.ManualEntryHistorianDataBaseObj = (LRRManualEntryHistorianDataBase)this.cmbManualEntryHistDBs.SelectedItem;
				OptionsUserControl.saved = true;
			}
			if(_lrrOptionsObj.UsePreSetDefaultSetting != this.chkBoxDefaultSettings.Checked)
			{
				_lrrOptionsObj.UsePreSetDefaultSetting = this.chkBoxDefaultSettings.Checked;
				OptionsUserControl.saved	=true;
			}

			if(_lrrOptionsObj.ToolTipOptions.ToString() != ddlGraphicsToolTip.SelectedValue.ToString())
			{
				_lrrOptionsObj.ToolTipOptions =  (Globals.Enums.ToolTipOptions)Enum.Parse(typeof(Globals.Enums.ToolTipOptions),ddlGraphicsToolTip.SelectedValue.ToString());
				OptionsUserControl.saved = true;
			}

            if (_lrrOptionsObj.NumericFormat != ddlFormatter.SelectedValue)
            {
                OptionsUserControl.saved = true;
            }

            if (_lrrOptionsObj.WebConfigPath != this.txtWebConfig.Text)
            {
                _lrrOptionsObj.WebConfigPath = this.txtWebConfig.Text;
                OptionsUserControl.saved = true;
            }

            if (_lrrOptionsObj.PublishGraphics != this.chkPublishGraphics.Checked)
            {
                _lrrOptionsObj.PublishGraphics = this.chkPublishGraphics.Checked;
                OptionsUserControl.saved = true;
            }
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}
	
		public TabControl	ParentTabControl
		{
			set
			{
				
			}
			get{return null;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
			}
			get
			{
				return null;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add UserControlPersistance.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlPersistance.SupportsClearSort implementation
			return false;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlPersistance.PrintPreview implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlPersistance.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlPersistance.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlPersistance.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlPersistance.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlPersistance.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlPersistance.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlPersistance.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlPersistance.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlPersistance.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlPersistance.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlPersistance.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlPersistance.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlPersistance.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlPersistance.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlPersistance.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlPersistance.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlPersistance.SupportsCompositeView implementation
			return false;
		}

		#endregion
		
			#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlPersistance.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
		
		private void textBoxRollOverLimit_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar > 31 && (e.KeyChar < '0' || e.KeyChar > '9'))
			{
				e.Handled=true;
			}
		}

        private void ddlFormatter_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!firstTime)
            {
                foreach (NumericfFormatInfo var in _lrrOptionsObj.NumericFormat)
                {
                    if (var.IsSelected)
                    {
                        var.IsSelected = false;
                    }
                }
                NumericfFormatInfo selectedFormat = ddlFormatter.SelectedItem as NumericfFormatInfo;
                selectedFormat.IsSelected = true;
            }
            firstTime = false;
        }

        private void btnWebConfig_Click(object sender, EventArgs e)
        {
            DialogResult dlgResult = this.folderBrowserDialog1.ShowDialog();
            if (dlgResult == DialogResult.OK)
            {
                this.txtWebConfig.Text = this.folderBrowserDialog1.SelectedPath;
            }
        }

        private void chkUseTemplateForOverrides_CheckedChanged(object sender, EventArgs e)
        {
            this.chkUseTemplateForOverrides.Checked = ((System.Windows.Forms.CheckBox)(sender)).Checked;
            _lrrOptionsObj.UseTemplateOverrides = ((System.Windows.Forms.CheckBox)(sender)).Checked;
        }
	}
}
