using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.Globals.Enums;
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlRemotingConnectionInfos.
	/// </summary>
	public class UserControlRemotingConnectionInfos : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridRemotingConnectInfos;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlRemotingConnectionInfos()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			BindGrid();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridRemotingConnectInfos = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridRemotingConnectInfos)).BeginInit();
			this.SuspendLayout();
			// 
			// gridRemotingConnectInfos
			// 
			this.gridRemotingConnectInfos.BackColor = System.Drawing.SystemColors.Window;
			this.gridRemotingConnectInfos.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridRemotingConnectInfos.Location = new System.Drawing.Point(0, 0);
			this.gridRemotingConnectInfos.Name = "gridRemotingConnectInfos";
			this.gridRemotingConnectInfos.Size = new System.Drawing.Size(760, 336);
			this.gridRemotingConnectInfos.TabIndex = 0;
			this.gridRemotingConnectInfos.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridRemotingConnectInfos.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridRemotingConnectInfos.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridRemotingConnectInfos.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridRemotingConnectInfos.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridRemotingConnectInfos.VersionInfo = "3.301.0.0";
			// 
			// UserControlRemotingConnectionInfos
			// 
			this.Controls.Add(this.gridRemotingConnectInfos);
			this.Name = "UserControlRemotingConnectionInfos";
			this.Size = new System.Drawing.Size(760, 336);
			this.Tag = "SID_REMOTINGCONNECT";
			((System.ComponentModel.ISupportInitialize)(this.gridRemotingConnectInfos)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region ILRRUIContainer Members

		public void Refresh()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Refresh implementation
		}

		public void Save()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Save implementation
			LRRRemotingConnectionInfos toSaveInfos = _lrrRemotingConnectInfos.GetChanges();
			if(toSaveInfos.Count > 0)
			{
				_lrrApp.DBManagerObj.CommitCollection(toSaveInfos);
				_lrrRemotingConnectInfos.RefreshCollection();
				OptionsUserControl.saved	=true;
			}
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Print implementation
			if(gridRemotingConnectInfos.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridRemotingConnectInfos,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.DownLevel implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsLevel implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add UserControlRemotingConnectionInfos.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlRemotingConnectionInfos.ParentTabControl setter implementation
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add UserControlRemotingConnectionInfos.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlRemotingConnectionInfos.ParentTabPage setter implementation
			}
		}

		#endregion

		#region Fields
		private LRRApp _lrrApp;
		private LRRRemotingConnectionInfos _lrrRemotingConnectInfos;
		
		#endregion
		
		#region Methods
		private void InitDataSource()
		{
			if(_lrrRemotingConnectInfos != null)
				_lrrRemotingConnectInfos.Clear();

			_lrrRemotingConnectInfos = new LRRRemotingConnectionInfos();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrRemotingConnectInfos);
		}

		public void BindGrid()
		{
			SyncGridUtilities.InitializeGridLookAndFeel(gridRemotingConnectInfos);
			SyncGridUtilities.InitializeGridColumns(gridRemotingConnectInfos,_lrrRemotingConnectInfos.ItemType,null,true,null);
			gridRemotingConnectInfos.SourceListSet.Add("Parent",_lrrRemotingConnectInfos);
			gridRemotingConnectInfos.DataSource = _lrrRemotingConnectInfos;
			gridRemotingConnectInfos.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_REMOTING_CONN_INFO") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   
	
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridRemotingConnectInfos);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.PrintPreview implementation
			if(gridRemotingConnectInfos.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridRemotingConnectInfos,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlRemotingConnectionInfos.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlRemotingConnectionInfos.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
