using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlTrendCompressionResolution.
	/// </summary>
	public class UserControlTrendCompressionResolution : System.Windows.Forms.UserControl
	{
		public System.Windows.Forms.Label labelPeriod;
		public System.Windows.Forms.TextBox textBoxPeriodValue;
		private System.Windows.Forms.Label labelNoOfPoints;
		public System.Windows.Forms.TextBox textBoxNoOfPoints;
		public System.Windows.Forms.ComboBox comboBoxPeriodUnit;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlTrendCompressionResolution()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
            
			comboBoxPeriodUnit.SelectedIndex = 0;
            labelPeriod.Text = LRRHeaderText.GetHeaderString("SID_PERIOD") + " 1:";
            InternationalizationUtils.GetControlText(this, null);	
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.labelPeriod = new System.Windows.Forms.Label();
            this.textBoxPeriodValue = new System.Windows.Forms.TextBox();
            this.comboBoxPeriodUnit = new System.Windows.Forms.ComboBox();
            this.labelNoOfPoints = new System.Windows.Forms.Label();
            this.textBoxNoOfPoints = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // labelPeriod
            // 
            this.labelPeriod.Location = new System.Drawing.Point(10, 8);
            this.labelPeriod.Name = "labelPeriod";
            this.labelPeriod.Size = new System.Drawing.Size(56, 23);
            this.labelPeriod.TabIndex = 0;
            // 
            // textBoxPeriodValue
            // 
            this.textBoxPeriodValue.Location = new System.Drawing.Point(134, 8);
            this.textBoxPeriodValue.Name = "textBoxPeriodValue";
            this.textBoxPeriodValue.Size = new System.Drawing.Size(48, 20);
            this.textBoxPeriodValue.TabIndex = 1;
            // 
            // comboBoxPeriodUnit
            // 
            this.comboBoxPeriodUnit.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxPeriodUnit.Items.AddRange(new object[] {
            "Hr(s)",
            "Day(s)",
            "Week(s)",
            "Months(s)",
            "Years(s)"});
            this.comboBoxPeriodUnit.Location = new System.Drawing.Point(205, 8);
            this.comboBoxPeriodUnit.Name = "comboBoxPeriodUnit";
            this.comboBoxPeriodUnit.Size = new System.Drawing.Size(56, 21);
            this.comboBoxPeriodUnit.TabIndex = 2;
            // 
            // labelNoOfPoints
            // 
            this.labelNoOfPoints.AutoSize = true;
            this.labelNoOfPoints.Location = new System.Drawing.Point(310, 11);
            this.labelNoOfPoints.Name = "labelNoOfPoints";
            this.labelNoOfPoints.Size = new System.Drawing.Size(0, 13);
            this.labelNoOfPoints.TabIndex = 3;
            this.labelNoOfPoints.Tag = "NO_OF_INTERVALS";
            // 
            // textBoxNoOfPoints
            // 
            this.textBoxNoOfPoints.Location = new System.Drawing.Point(493, 8);
            this.textBoxNoOfPoints.Name = "textBoxNoOfPoints";
            this.textBoxNoOfPoints.Size = new System.Drawing.Size(64, 20);
            this.textBoxNoOfPoints.TabIndex = 4;
            // 
            // UserControlTrendCompressionResolution
            // 
            this.Controls.Add(this.textBoxNoOfPoints);
            this.Controls.Add(this.labelNoOfPoints);
            this.Controls.Add(this.comboBoxPeriodUnit);
            this.Controls.Add(this.textBoxPeriodValue);
            this.Controls.Add(this.labelPeriod);
            this.Name = "UserControlTrendCompressionResolution";
            this.Size = new System.Drawing.Size(668, 46);
            this.Load += new System.EventHandler(this.UserControlTrendCompressionResolution_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		#region Events

		private void UserControlTrendCompressionResolution_Load(object sender, System.EventArgs e)
		{
			
		}

		#endregion

		#region Public Methods

		public void AdjustUnit()
		{
			if(comboBoxPeriodUnit.SelectedIndex == 0)
			{
				int noOfHours = int.Parse(textBoxPeriodValue.Text);
				if(noOfHours % (365*24) == 0)
				{
					textBoxPeriodValue.Text = (noOfHours / (365*24)).ToString();
					comboBoxPeriodUnit.SelectedIndex = 4;
				}
				else if(noOfHours % (30*24) == 0)
				{
					textBoxPeriodValue.Text = (noOfHours / (30*24)).ToString();
					comboBoxPeriodUnit.SelectedIndex = 3;
				}
				else if(noOfHours % (7*24) == 0)
				{
					textBoxPeriodValue.Text = (noOfHours / (7*24)).ToString();
					comboBoxPeriodUnit.SelectedIndex = 2;
				}
				else if(noOfHours % 24 == 0)
				{
					textBoxPeriodValue.Text = (noOfHours / 24).ToString();
					comboBoxPeriodUnit.SelectedIndex = 1;
				}
				else
				{
					comboBoxPeriodUnit.SelectedIndex = 0;
				}
			}
		}

		public bool Validate()
		{
			bool isThrownByCode = false;
			try
			{
				int noOfHours = int.Parse(textBoxPeriodValue.Text);
				if(noOfHours <=0)
				{
					isThrownByCode = true;
					throw new Exception(LRRHeaderText.GetHeaderString("SID_NUMBER_HOURS_ERROR"));
				}
				try
				{
					int noOfPoints = int.Parse(textBoxNoOfPoints.Text);
					if(noOfPoints<0)
					{
						throw new Exception(LRRHeaderText.GetHeaderString("SID_INVALID_POINTS_NUMBER"));
					}
				}
				catch
				{
					MessageBox.Show(this,LRRHeaderText.GetHeaderString("SID_INVALID_POINTS_NUMBER"),LRRHeaderText.GetHeaderString("SID_ERROR"));
					return false;
				}
			}
			catch(Exception ex)
			{
				if(isThrownByCode)
					MessageBox.Show(this,ex.Message,LRRHeaderText.GetHeaderString("SID_ERROR"));
				else
					MessageBox.Show(this,LRRHeaderText.GetHeaderString("SID_INVALID_HOURS"),LRRHeaderText.GetHeaderString("SID_ERROR"));
				return false;
			}
			return true;
		}

		#endregion
	}
}
