using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.BusinessObjects;
using Syncfusion.Windows.Forms.Chart;
using Symcon.Utils.HeaderDispatcher;
using Syncfusion.Drawing;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlTrend.
	/// </summary>
	public class UserControlTrendLog : System.Windows.Forms.UserControl, ITrend
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControlTrend;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlTrendLog()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			this.Load += new EventHandler(UserControlTrend_Load);
			this.Text = "Trend Chart";
			chartControlTrend.Model.Series.Clear();
			chartControlTrend.ChartFormatAxisLabel += new ChartFormatAxisLabelEventHandler(chartControlTrend_ChartFormatAxisLabelEventHandler);
			

			this.chartControlTrend.ShowToolTips = true;
			this.chartControlTrend.Legend.Visible = false;
			InitializeChartAppearance();
			chartControlTrend.Font = this.Font;
            this.chartControlTrend.DisplayChartContextMenu = false;
            _lrrApp.RunControllerObj.TrendPointRecieved += new TrendPointRecievedDel(RunControllerObj_TrendPointRecieved);
		}

        public delegate void AddPointDel(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange);

        void RunControllerObj_TrendPointRecieved(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange)
        {
             if (siteCompPropValueChange.SiteComponentPropertyValueID == _siteCompPropValueID)
             {
                AddPointDel addPointDel = new AddPointDel(AddPoint);
                _lrrApp.MainFrame.Invoke(addPointDel,new object[] {siteCompPropValueChange});
             }
           
        }

        private void AddPoint(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange)
        {

            ChartSeries series = chartControlTrend.Model.Series[0];
            chartControlTrend.Model.Series.Remove(series);
            for (int i = 0; i < series.Points.Count; i++)
            {
                TimeSpan x2 = series.Points[i].DateX - _startTime;
                series.Points[i].DateX = _startTime.AddSeconds(SplitScaleAxis.Split2DToValue(x2.TotalSeconds, _dblMaxRangeX));
                //MessageBox.Show(Math.Log(X1,A).ToString());
            }

            try
            {
                double point;
                if (double.TryParse(ConvertUOM(_iProp.GetUOM(), _currentUOM, siteCompPropValueChange.PropertyValue), System.Globalization.NumberStyles.Number, Symcon.BusinessObjects.SymConverter.Culture, out point))
                {
                    if (DateTime.Parse(siteCompPropValueChange.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < _startTime)
                        _startTime = DateTime.Parse(siteCompPropValueChange.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                    if (DateTime.Parse(siteCompPropValueChange.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > _endTime)
                        _endTime = DateTime.Parse(siteCompPropValueChange.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                    double[] points = new double[] { point, 1 };
                    series.Points.Add(DateTime.Parse(siteCompPropValueChange.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                    //series.Points.Add(DateTime.Parse(siteCompPropValueChange.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                }
            }
            catch
            {

            }
            _ts = _endTime - _startTime;
            if (_ts.TotalHours < 11 && _ts.TotalMilliseconds >= 0)
            {
                _ts = TimeSpan.FromHours(11);
                _startTime = _endTime.Subtract(_ts);
            }

            _dblMaxRangeX = (double)_ts.TotalSeconds;
            _actualStartTime = _startTime;
            _actualEndTime = _endTime;

            for (int i = 0; i < series.Points.Count; i++)
            {
                TimeSpan x2 = series.Points[i].DateX - _startTime;
                series.Points[i].DateX = _startTime.AddSeconds(SplitScaleAxis.ValueToSplit2D(x2.TotalSeconds, _dblMaxRangeX));
                //MessageBox.Show(Math.Log(X1,A).ToString());
            }

            chartControlTrend.Model.Series.Add(series);
            CreateStripLine();
            try
            {
                this.chartControlTrend.PrimaryXAxis.StripLines.Remove(altMonths1);
                this.chartControlTrend.PrimaryXAxis.StripLines.Add(altMonths1);
                InitScale();
            }
            catch
            { }


        }

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
		{
            _lrrApp.RunControllerObj.TrendPointRecieved -= new TrendPointRecievedDel(RunControllerObj_TrendPointRecieved);
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.chartControlTrend = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.SuspendLayout();
			// 
			// chartControlTrend
			// 
			this.chartControlTrend.ColumnWidthMode = Syncfusion.Windows.Forms.Chart.ChartColumnWidthMode.DefaultWidthMode;
			this.chartControlTrend.Controls.Add(this.chartControlTrend.Legend);
			this.chartControlTrend.Dock = System.Windows.Forms.DockStyle.Fill;
			// 
			// chartControlTrend.Legend
			// 
			this.chartControlTrend.Legend.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.chartControlTrend.Legend.Location = new System.Drawing.Point(506, 205);
			this.chartControlTrend.Legend.Name = "";
			this.chartControlTrend.Legend.Size = new System.Drawing.Size(76, 28);
			this.chartControlTrend.Legend.TabIndex = 3;
			this.chartControlTrend.Location = new System.Drawing.Point(0, 0);
			this.chartControlTrend.Name = "chartControlTrend";
			this.chartControlTrend.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControlTrend.PrimaryXAxis.SmartDateZoomDayLevelLabelFormat = "g";
			this.chartControlTrend.PrimaryXAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControlTrend.PrimaryYAxis.SmartDateZoomDayLevelLabelFormat = "g";
			this.chartControlTrend.PrimaryYAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControlTrend.Size = new System.Drawing.Size(592, 400);
			this.chartControlTrend.Spacing = 10F;
			this.chartControlTrend.TabIndex = 0;
			this.chartControlTrend.Text = "chartControl1";
			this.chartControlTrend.Tilt = 30F;
			// 
			// chartControlTrend.ToolBar
			// 
			this.chartControlTrend.ToolBar.Location = new System.Drawing.Point(26, 26);
			this.chartControlTrend.ZoomFactorX = 1;
			this.chartControlTrend.ZoomFactorY = 1;
			this.chartControlTrend.ZoomOutIncrement = 1.5;
			// 
			// UserControlTrendLog
			// 
			this.Controls.Add(this.chartControlTrend);
			this.Name = "UserControlTrendLog";
			this.Size = new System.Drawing.Size(592, 400);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		private LRRApp _lrrApp;
		private string _siteCompPropValueID;
		private string _siteCompPropID;
        private DateTime _startTime = DateTime.Now.AddYears(1500);
		private DateTime _endTime = DateTime.Now.AddYears(-1500);
		private TimeSpan _ts;
		private string _errorMsg = "";
		private Form _frmOwner;
		private string _newText = "";
		private string _currentUOM = null;
		private IProperty _iProp = null;
		private string _modeID = null;
		
		// The following parameters defines the display parameters of the chart. These are also used in log scale calculations
		private double _dblMaxRangeX = 100; // Maximum range of X axis in seconds
		private bool _isDateInitialized = false;
        private DateTime _actualStartTime = DateTime.Now.AddYears(1500);
		private DateTime _actualEndTime = DateTime.Now.AddYears(-1500);
		private string _trendScheme = null;
		private TrendSetting _trendSetting;
        private ChartSeries _seriesOrig;
        private ChartStripLine altMonths1 = new ChartStripLine();

		#endregion

		#region Private Methods

		private string ConvertUOM(string oldUOMValue,string newUOMValue,string propVal)
		{
			string newVal = "";
			if(propVal != null && propVal != "")
			{
				if(oldUOMValue == newUOMValue)
				{
					newVal = propVal;
				}
				else
				{
					if((oldUOMValue != null && oldUOMValue != "") &&
						(newUOMValue != null && newUOMValue != ""))
					{
						newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldUOMValue,newUOMValue,propVal,null);
					}
				}
			}
			return newVal;
		}

		private bool LoadChart(TrendSetting trendSetting)
		{
			this.chartControlTrend.Text = _newText;
			DateTime startTime = DateTime.Now;
			DateTime endTime = DateTime.Now.AddYears(-1500);

			LRRSiteComponentPropertyValueChangeUserAndTimes scpvcuts = new LRRSiteComponentPropertyValueChangeUserAndTimes();
			
			_lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts," WHERE SiteComponentPropertyValueID='" + _siteCompPropValueID + "'  AND IsRecorded='False'");

			chartControlTrend.SuspendLayout();
				
			ChartSeries series = _seriesOrig= this.chartControlTrend.Model.NewSeries("Series 0");

			foreach(LRRSiteComponentPropertyValueChangeUserAndTime scpvcut in scpvcuts)
			{
				try
				{
                    double point;
                    if (double.TryParse(ConvertUOM(_iProp.GetUOM(), _currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Number, Symcon.BusinessObjects.SymConverter.Culture, out point))
                    {
                        if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < startTime)
                            startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                        if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > endTime)
                            endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);

                        double[] points = new double[] { point, 1 };
                        series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                    }
				}
				catch
				{

				}
			}
            bool check = true;
			if(series.Points.Count == 0)
			{
				//chartControlTrend.ResumeLayout();
				if(_lrrApp.ToggleTrending)
					_errorMsg = LRRHeaderText.GetHeaderString("SID_TREND_ERROR");
				else
					_errorMsg = LRRHeaderText.GetHeaderString("SID_TREND_ENABLE");
				check = false;
			}
			//startTime.AddHours(-0.5);
			//endTime.AddMinutes(0.5);
			_errorMsg = "";
			_startTime = startTime;
			_endTime = endTime;
			series.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType),trendSetting.SeriesType);
			series.Text = series.Name;
		
			_frmOwner = _lrrApp.MainFrame.ActiveMdiChild;

			_ts = endTime - startTime;
            if (_ts.TotalHours < 11 && check)
            {
                _ts = TimeSpan.FromHours(11);
                //T//imeSpan timeMarginStart = TimeSpan.FromTicks(_ts.Ticks/10);
                _startTime = endTime.Subtract(_ts);
                //_endTime = endTime.Add(timeMarginStart);
                //_ts = _endTime - _startTime;
            }
			_dblMaxRangeX = (double)_ts.TotalSeconds; // If the range is small, it is taken as 11 hours.

			// Calculation and assignment of log _seriesLinear( display _seriesLinear) from linear _seriesLinear
			for(int i = 0;i<series.Points.Count;i++)
			{
				TimeSpan x2 = series.Points[i].DateX - _startTime;
				series.Points[i].DateX = _startTime.AddSeconds(SplitScaleAxis.ValueToSplit2D(x2.TotalSeconds,_dblMaxRangeX));
				//MessageBox.Show(Math.Log(X1,A).ToString());
			}

			series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyleMulti);

            try
            {
                series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(trendSetting.SeriesInteriorColor)), Color.Black });
            }
            catch
            {
                try
                {
                    series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SeriesInteriorColor)), Color.Black });
                }
                catch
                { }
            }

			chartControlTrend.Model.Series.Clear();
			this.chartControlTrend.Series.Add(series);

			chartControlTrend.ResumeLayout();

			_actualStartTime = _startTime;
			_actualEndTime = _endTime;
            CreateStripLine();
            try
            {
                this.chartControlTrend.PrimaryXAxis.StripLines.Remove(altMonths1);
            }
            catch
            { }
            this.chartControlTrend.PrimaryXAxis.StripLines.Add(altMonths1);
			return check;
		}

		private bool LoadChart(string trendScheme)
		{
			DateTime startTime = DateTime.Now;
			DateTime endTime = DateTime.Now.AddYears(-1500);

			LRRSiteComponentPropertyValueChangeUserAndTimes scpvcuts = new LRRSiteComponentPropertyValueChangeUserAndTimes();

            // changed by ashwin
			//_lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts," WHERE SiteComponentPropertyValueID='" + _siteCompPropValueID + "' AND IsRecorded='False'");

            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(_siteCompPropID);
            if (scp != null)
            {
                LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(scp.ComponentID);
                if (sc != null)
                {
                    _lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts, " WHERE SiteComponentPropertyID= '" + scp.Name + "' and EquipmentTag = '" + sc.Name + "'" );
                }
            }

            //_lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts, " WHERE SiteComponentPropertyID= '" + _siteCompPropID + "'");


			chartControlTrend.SuspendLayout();
				
			ChartSeries series = this.chartControlTrend.Model.NewSeries("Series 0");

			foreach(LRRSiteComponentPropertyValueChangeUserAndTime scpvcut in scpvcuts)
			{
				try
				{
                    double point;

                    if (_modeID == "2")
                    {
                        if (double.TryParse(ConvertUOM(_iProp.GetUOM(), _currentUOM, scpvcut.PropertyValue_SS), System.Globalization.NumberStyles.Number, Symcon.BusinessObjects.SymConverter.Culture, out point))
                        {
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < startTime)
                                startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > endTime)
                                endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);

                            double[] points = new double[] { point, 1 };
                            series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                        }

                    }
                    else if (_modeID == "3")
                    {
                        if (double.TryParse(ConvertUOM(_iProp.GetUOM(), _currentUOM, scpvcut.PropertyValue_SCEN), System.Globalization.NumberStyles.Number, Symcon.BusinessObjects.SymConverter.Culture, out point))
                        {
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < startTime)
                                startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > endTime)
                                endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);

                            double[] points = new double[] { point, 1 };
                            series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                        }

                    }
                    else if (_modeID == "1")
                    {
                        if (double.TryParse(ConvertUOM(_iProp.GetUOM(), _currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Number, Symcon.BusinessObjects.SymConverter.Culture, out point))
                        {
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < startTime)
                                startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > endTime)
                                endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);

                            double[] points = new double[] { point, 1 };
                            series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                        }

                    }
                    /*                    
                    if (double.TryParse(ConvertUOM(_iProp.GetUOM(), _currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Number, Symcon.BusinessObjects.SymConverter.Culture, out point))
                    {
                        if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < startTime)
                            startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                        if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > endTime)
                            endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);

                        double[] points = new double[] { point, 1 };
                        series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                    }
                     * */


                    //}
				}
				catch
				{

				}
			}
            bool check = true;
			if(series.Points.Count == 0)
			{
				//chartControlTrend.ResumeLayout();
				if(_lrrApp.ToggleTrending)
					_errorMsg = LRRHeaderText.GetHeaderString("SID_TREND_ERROR");
				else
					_errorMsg = LRRHeaderText.GetHeaderString("SID_TREND_ENABLE");
				check = false;
			}
			//startTime.AddHours(-0.5);
			//endTime.AddMinutes(0.5);
			_errorMsg = "";
			_startTime = startTime;
			_endTime = endTime;
			series.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType),UserControlTrendOptions.HtSchemes[trendScheme].ToString().Split("|".ToCharArray())[0]);
			series.Text = series.Name;
			this.chartControlTrend.Text = _newText;
			_frmOwner = _lrrApp.MainFrame.ActiveMdiChild;

			_ts = endTime - startTime;
            if (_ts.TotalHours < 11 && _ts.TotalMilliseconds>=0)
            {
                _ts = TimeSpan.FromHours(11);
                //T//imeSpan timeMarginStart = TimeSpan.FromTicks(_ts.Ticks/10);
                _startTime = endTime.Subtract(_ts);
                
            }
			//_ts = _endTime - _startTime;
            //_ts = endTime - startTime;
			
			_dblMaxRangeX = (double)_ts.TotalSeconds; // If the range is small, it is taken as 1 year.

			// Calculation and assignment of log _seriesLinear( display _seriesLinear) from linear _seriesLinear
			for(int i = 0;i<series.Points.Count;i++)
			{
				TimeSpan x2 = series.Points[i].DateX - _startTime;
				series.Points[i].DateX = _startTime.AddSeconds(SplitScaleAxis.ValueToSplit2D(x2.TotalSeconds,_dblMaxRangeX));
				//MessageBox.Show(Math.Log(X1,A).ToString());
			}

			series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);

            try
            {
                series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(UserControlTrendOptions.HtSchemes[_trendScheme].ToString().Split("|".ToCharArray())[3])), Color.Black });
            }
            catch
            {
                try
                {
                    series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), UserControlTrendOptions.HtSchemes[_trendScheme].ToString().Split("|".ToCharArray())[3])), Color.Black });
                }
                catch { }
            }

			chartControlTrend.Model.Series.Clear();
			this.chartControlTrend.Series.Add(series);

			chartControlTrend.ResumeLayout();

			_actualStartTime = _startTime;
			_actualEndTime = _endTime;
            CreateStripLine();
            try
            {
                this.chartControlTrend.PrimaryXAxis.StripLines.Remove(altMonths1);
            }
            catch
            { }
            this.chartControlTrend.PrimaryXAxis.StripLines.Add(altMonths1);
			return check;
		}

		/// <summary>
		/// Sets properties to customize the ChartControl's appearance
		/// </summary>
		private void InitializeChartAppearance()
		{			
			this.chartControlTrend.PrimaryXAxis.ValueType = ChartValueType.DateTime;
			this.chartControlTrend.PrimaryXAxis.GridLineType.ForeColor = Color.FromArgb(100,255,0,0);
			this.chartControlTrend.PrimaryYAxis.GridLineType.ForeColor = Color.FromArgb(100,255,0,0);
			this.chartControlTrend.PrimaryXAxis.Font = this.Font;
			this.chartControlTrend.PrimaryYAxis.Font = this.Font;
		}
        /// <summary>
        /// Creates Scale Break
        /// </summary>
        private void CreateStripLine()
        {
            //ChartStripLineCollection stripLines = new ChartStripLineCollection();

            altMonths1.Enabled = true;
            altMonths1.Vertical = true;
            altMonths1.StartAtAxisPosition = true;
            altMonths1.DateOffset = TimeSpan.FromSeconds(_dblMaxRangeX/3);
            altMonths1.WidthDate = TimeSpan.FromSeconds(_dblMaxRangeX / 200);
            altMonths1.PeriodDate = TimeSpan.FromSeconds(_dblMaxRangeX / 3);
            altMonths1.Text = LRRHeaderText.GetHeaderString("SID_SCALE_SPLIT");
            altMonths1.Font = new Font(altMonths1.Font.FontFamily.Name, 10);
            altMonths1.TextColor = Color.CadetBlue;
            altMonths1.Interior = new BrushInfo(100, new BrushInfo(GradientStyle.Vertical, Color.Black, Color.Black));
        }
		#endregion

		#region Event Handlers

        void comboBoxUOM_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                ComboBox comboBoxUOM = sender as ComboBox;

                string newUOM = comboBoxUOM.SelectedValue as string;
                ChartSeries seriesOrig = _seriesOrig;
                ChartSeries oldSeries = chartControlTrend.Model.Series[0];
                chartControlTrend.Model.Series.Remove(oldSeries);

                ChartSeries seriesNew = chartControlTrend.Model.NewSeries("series 0");
                for (int i = 0; i < seriesOrig.Points.Count; i++)
                {
                    ChartPoint cp = seriesOrig.Points[i];
                    seriesNew.Points.Add(cp.DateX, double.Parse(ConvertUOM(_currentUOM, newUOM, cp.YValues[0].ToString())));
                }

                

                _currentUOM = newUOM;
                seriesNew.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType), _trendSetting.SeriesType);
                seriesNew.Text = seriesNew.Name;

                try
                {
                    seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(_trendSetting.SeriesInteriorColor)), Color.Black });
                }
                catch
                {
                    try
                    {
                        seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), _trendSetting.SeriesInteriorColor)), Color.Black });
                    }
                    catch
                    { }
                }

                seriesNew.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyleMulti);
                chartControlTrend.Model.Series.Add(seriesNew);
            }
            catch
            { }
        }

		private void chartControlTrend_ChartFormatAxisLabelEventHandler(object sender,ChartFormatAxisLabelEventArgs args )
		{
			if(_ts.TotalMilliseconds != 0)
			{
				if(args.IsAxisPrimary && args.AxisOrientation == Orientation.Horizontal)
				{
					if(((_ts.TotalDays * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(this.chartControlTrend.PrimaryXAxis.Size.Width * Screen.PrimaryScreen.Bounds.Width)) < 17*111)
					{
						//this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime,_endTime, Math.Max((_ts.TotalMilliseconds * 4.5 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
                        args.Label = (_startTime.AddSeconds(SplitScaleAxis.Split2DToValue((args.ValueAsDate - _startTime).TotalSeconds, _dblMaxRangeX))).ToString("M/d/yy\nHH:mm:ss");
					}
					else
					{
						//this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime,_endTime, Math.Max((_ts.TotalMilliseconds * 2.25 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
                        args.Label = (_startTime.AddSeconds(SplitScaleAxis.Split2DToValue((args.ValueAsDate - _startTime).TotalSeconds, _dblMaxRangeX))).ToString("M/d/yy");
					}
					args.Handled = true;
				}
			}
		}

		/// <summary>
		/// Handler for the PrepareStyle event of ChartSeries. 
		/// </summary>
		/// <param name="sender">The ChartSeries object that raises this event.</param>
		/// <param name="args">The event data. Can be modified to change series appearance.</param>
		protected void ChartControlSeries_PrepareStyleMulti(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			if(series != null)
			{
				args.Style.Symbol.Shape = (ChartSymbolShape)Enum.Parse(typeof(ChartSymbolShape),_trendSetting.SymbolShape);
				args.Style.Symbol.Size = new Size(5,5);
                try
                {
                    args.Style.Symbol.Color = Color.FromArgb(int.Parse(_trendSetting.SymbolColor));
                }
                catch
                {
                    try
                    {
                        args.Style.Symbol.Color = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), _trendSetting.SymbolColor));
                    }
                    catch { }
                }
				args.Style.DisplayShadow = true;
                args.Style.ToolTip = LRRHeaderText.GetHeaderString("SID_STARTTIME") + ": " + (_startTime.AddSeconds(SplitScaleAxis.Split2DToValue((series.Points[args.Index].DateX - _startTime).TotalSeconds, _dblMaxRangeX))).ToString(Symcon.BusinessObjects.SymConverter.Culture) + "\n" + LRRHeaderText.GetHeaderString("SID_PROPERTYVALUE") + ": " + series.Points[args.Index].YValues[0];
				args.Handled = true;
			}
		}

		/// <summary>
		/// Handler for the PrepareStyle event of ChartSeries. 
		/// </summary>
		/// <param name="sender">The ChartSeries object that raises this event.</param>
		/// <param name="args">The event data. Can be modified to change series appearance.</param>
		protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			if(series != null)
			{
				args.Style.Symbol.Shape = (ChartSymbolShape)Enum.Parse(typeof(ChartSymbolShape),UserControlTrendOptions.HtSchemes[_trendScheme].ToString().Split("|".ToCharArray())[1]);
				args.Style.Symbol.Size = new Size(5,5);
                try
                {
                    args.Style.Symbol.Color = Color.FromArgb(int.Parse(UserControlTrendOptions.HtSchemes[_trendScheme].ToString().Split("|".ToCharArray())[2]));
                }
                catch
                {
                    try
                    {
                        args.Style.Symbol.Color = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), UserControlTrendOptions.HtSchemes[_trendScheme].ToString().Split("|".ToCharArray())[2]));
                    }
                    catch { }
                }

				args.Style.DisplayShadow = true;
                args.Style.ToolTip = LRRHeaderText.GetHeaderString("SID_STARTTIME") + ": " + (_startTime.AddSeconds(SplitScaleAxis.Split2DToValue((series.Points[args.Index].DateX - _startTime).TotalSeconds, _dblMaxRangeX))).ToString(Symcon.BusinessObjects.SymConverter.Culture) + "\n" + LRRHeaderText.GetHeaderString("SID_PROPERTYVALUE") + ": " + series.Points[args.Index].YValues[0];
				args.Handled = true;
			}
		}

		private void UserControlTrend_Resize(object sender, EventArgs e)
		{
			AdjustXScale(_trendScheme);
		}

		private void UserControlTrend_Load(object sender, EventArgs e)
		{
			this.Resize += new EventHandler(UserControlTrend_Resize);
		}

		#endregion

		
		#region ITrend Members

		bool Symcon.LightRidge.PEAdvisor.UserControls.ITrend.IsTrendUOMChanged(string trendScheme,IProperty iProp, string modeID, string currentUOM)
		{
			if(((iProp.GetID() == _iProp.GetID()) && (modeID == _modeID)) && (currentUOM != _currentUOM) && (trendScheme == _trendScheme))
				return true;
			return false;
		}

		void Symcon.LightRidge.PEAdvisor.UserControls.ITrend.InitTrend(string trendScheme,IProperty iProp, string modeID, string currentUOM)
		{
			_currentUOM=currentUOM;
			_iProp = iProp;
			_modeID = modeID;
			_trendScheme = trendScheme;
			if(!_lrrApp.RecordingValuesManagerObj.ExistsRecordingDB())
			{
				_errorMsg = LRRHeaderText.GetHeaderString("SID_TREND_DB_ERROR");
				return;
			}
			_siteCompPropValueID = (iProp.GetPropertyValueForMode(modeID) as IPropertyValue).GetID();

			_siteCompPropID = iProp.GetID();

			
			
			
			LRRSiteComponentProperty lrrscp = iProp as LRRSiteComponentProperty;
			_newText = LRRModel.ChildModel.Modes.GetModeByID(modeID).ModeName + ": " + LRRModel.ChildModel.SiteComponents.GetSiteComponentByID(lrrscp.ComponentID).Name + ": " + iProp.GetName();
			LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(_currentUOM);
			if(uom != null)
			{
				_newText += " (" + uom.Name + ")";
			}
			if(!IsDateInitialized)
			{
                if(LoadChart(trendScheme))
                    InitScale();
			}
			else
				AdjustXScale(trendScheme);
		}

		public string ErrorMsg
		{
			get
			{
				return _errorMsg;
			}
			set
			{
				_errorMsg = value;
			}
		}

		public Form FormOwner
		{
			get
			{
				return _frmOwner;
			}
			set
			{
				_frmOwner = value;
			}
		}

		public DateTime StartTime
		{
			get
			{
				return _startTime;
			}
			set
			{
				_startTime = value;
			}
		}

		public DateTime EndTime
		{
			get
			{
				return _endTime;
			}
			set
			{
				_endTime = value;
			}
		}

		public bool IsDateInitialized
		{
			get
			{
				return _isDateInitialized;
			}
			set
			{
				_isDateInitialized = value;
			}
		}

		private void InitScale()
		{
			if(_ts.TotalMilliseconds != 0)
			{
				if(((_ts.TotalDays * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(this.chartControlTrend.PrimaryXAxis.Size.Width * Screen.PrimaryScreen.Bounds.Width)) < 17)
					this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime,_endTime, Math.Max((_ts.TotalMilliseconds * 4.5 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
				else
					this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime,_endTime, Math.Max((_ts.TotalMilliseconds * 2.25 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
			}
		}
		
		public void AdjustXScale(string trendScheme)
		{
			try
			{
				chartControlTrend.SuspendLayout();
				LRRSiteComponentPropertyValueChangeUserAndTimes scpvcuts = new LRRSiteComponentPropertyValueChangeUserAndTimes();
			
				_lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts," WHERE SiteComponentPropertyValueID='" + _siteCompPropValueID + "' AND SiteComponentPropertyID='" + _siteCompPropID + "' AND IsRecorded='False'");



				_ts = _endTime - _startTime;

				
				_dblMaxRangeX = (double)_ts.TotalSeconds; // If the range is small, it is taken as 1 year.


				
				ChartSeries series = this.chartControlTrend.Model.NewSeries("Series 0");

				foreach(LRRSiteComponentPropertyValueChangeUserAndTime scpvcut in scpvcuts)
				{
					try
					{
                        double point;
                        if (double.TryParse(ConvertUOM(_iProp.GetUOM(), _currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Number, Symcon.BusinessObjects.SymConverter.Culture, out point))
                        {
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < _actualStartTime)
                                _actualStartTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                            if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > _actualEndTime)
                                _actualEndTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);

                            double[] points = new double[] { point, 1 };
                            series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                        }
					}
					catch
					{

					}
				}

				ArrayList arrPointsToRemove = new ArrayList();
		
				// Calculation and assignment of log _seriesLinear( display _seriesLinear) from linear _seriesLinear
				for(int i = 0;i<series.Points.Count;i++)
				{
					TimeSpan x2 = series.Points[i].DateX - _startTime;
					if(x2.TotalSeconds<=_dblMaxRangeX)
					{
                        series.Points[i].DateX = _startTime.AddSeconds(SplitScaleAxis.ValueToSplit2D(x2.TotalSeconds, _dblMaxRangeX));
					}
					else
					{
						arrPointsToRemove.Add(i);
					}
					//MessageBox.Show(Math.Log(X1,A).ToString());
				}

				arrPointsToRemove.Reverse();
				foreach(int pointIndex in arrPointsToRemove)
				{
					series.Points.Remove(pointIndex);
				}

				series.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType),UserControlTrendOptions.HtSchemes[trendScheme].ToString().Split("|".ToCharArray())[0]);
				series.Text = series.Name;
				this.chartControlTrend.Text = _newText;
				_frmOwner = _lrrApp.MainFrame.ActiveMdiChild;

				series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);

                try
                {
                    series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(UserControlTrendOptions.HtSchemes[_trendScheme].ToString().Split("|".ToCharArray())[3])), Color.Black });
                }
                catch
                {
                    try
                    {
                        series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), UserControlTrendOptions.HtSchemes[_trendScheme].ToString().Split("|".ToCharArray())[3])), Color.Black });
                    }
                    catch
                    { }
                }

				try
				{
					series.Type  = chartControlTrend.Model.Series[0].Type;
				}
				catch
				{

				}
				chartControlTrend.Model.Series.Clear();
				this.chartControlTrend.Series.Add(series);

				
				
				InitScale();
                try
                {
                    this.chartControlTrend.PrimaryXAxis.StripLines.Remove(altMonths1);
                }
                catch
                { }
                this.chartControlTrend.PrimaryXAxis.StripLines.Add(altMonths1);
				chartControlTrend.ResumeLayout();
			}
			catch
			{

			}
		}

		public DateTime ActualStartTime
		{
			get
			{
				return _actualStartTime;
			}
		}

		public DateTime ActualEndTime
		{
			get
			{
				return _actualEndTime;
			}
		}

		#endregion

		#region ITrend Members

        public void InitTrend(TrendSetting trendSetting, ComboBox comboBoxUOM)
		{
			string propValueID = trendSetting.SchemeName;
			LRRSiteComponentPropertyValue scpv = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(propValueID);
			if(scpv != null)
			{
                string modelUOM = _currentUOM = scpv.ModelUOM;
                string uomType = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(modelUOM);

                string localeID = LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID;
                string uiUom = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomType);
                if (uiUom == null)
                    uiUom = modelUOM;

                if (comboBoxUOM == null)
                {
                    _currentUOM = uiUom;
                }
                else
                {
                    if (comboBoxUOM.SelectedItem == null)
                    {
                        _currentUOM = uiUom;
                        LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(uomType);

                        comboBoxUOM.DataSource = uoms;
                        comboBoxUOM.DisplayMember = "Name";
                        comboBoxUOM.ValueMember = "ID";
                        try
                        {
                            comboBoxUOM.SelectedValue = uiUom;
                        }
                        catch
                        {
                        }
                        comboBoxUOM.SelectedIndexChanged += new EventHandler(comboBoxUOM_SelectedIndexChanged);
                    }
                    else
                    {
                        comboBoxUOM.SelectedIndexChanged -= new EventHandler(comboBoxUOM_SelectedIndexChanged);
                        _currentUOM = comboBoxUOM.SelectedValue as string;
                        comboBoxUOM.SelectedIndexChanged += new EventHandler(comboBoxUOM_SelectedIndexChanged);
                    }
                }

				_iProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(scpv.SiteComponentPropertyID) as IProperty;
				_modeID = scpv.ModeID;
				_trendScheme = null;
				_trendSetting = trendSetting;
				if(!_lrrApp.RecordingValuesManagerObj.ExistsRecordingDB())
				{
					_errorMsg = LRRHeaderText.GetHeaderString("SID_TREND_DB_ERROR");
					return;
				}
				_siteCompPropValueID = propValueID;

				_siteCompPropID = _iProp.GetID();

			
			
			
				LRRSiteComponentProperty lrrscp = _iProp as LRRSiteComponentProperty;
				_newText = LRRModel.ChildModel.Modes.GetModeByID(_modeID).ModeName + ": " + LRRModel.ChildModel.SiteComponents.GetSiteComponentByID(lrrscp.ComponentID).Name + ": " + _iProp.GetName();
                //LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(_currentUOM);
                //if(uom != null)
                //{
                //    _newText += " (" + uom.Name + ")";
                //}
				if(!IsDateInitialized)
				{
					if(LoadChart(_trendSetting))
					    InitScale();
				}
				//else
				//	AdjustXScale(_trendSetting);
			}
		}

		#endregion
	}

	#region Split Scale Axis
    public class SplitScaleAxis
    {
        public static double ValueToSplit2D(double x, double maxx)
        {
            try
            {
                double scalelength = maxx / 3;

                double lastperiod = maxx / 111;
                double middleperiod = lastperiod * 10;
                double firstperiod = middleperiod * 10;

                if (x <= firstperiod)
                {
                    return x * 111 / 300;
                }
                else if (x <= (middleperiod + firstperiod))
                {
                    return ((x - firstperiod) * 111.0) / 30.0 + scalelength;
                }
                else
                {
                    return ((x - (firstperiod + middleperiod)) * 111.0 / 3.0) + 2 * scalelength;
                }
            }
            catch
            {
                return 0.0;
            }
        }
        public static double Split2DToValue(double x, double maxx)
        {
            try
            {
                double scalelength = maxx / 3;

                double lastperiod = maxx / 111;
                double middleperiod = lastperiod * 10;
                double firstperiod = middleperiod * 10;

                if (x <= scalelength)
                {
                    return x * 300 / 111;
                }
                else if (x <= (scalelength * 2))
                {
                    return ((x - scalelength) * 30.0 / 111.0) + firstperiod;
                }
                else
                {
                    return ((x - 2 * scalelength) * 3.0 / 111.0) + firstperiod + middleperiod;
                }
            }
            catch
            {
                return 0;
            }
        }
    }       
	#endregion
}
