using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageDispatcher;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlTrendOptions.
	/// </summary>
	public class UserControlTrendOptions : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.ListBox listBoxStyles;
		private System.Windows.Forms.TextBox textBoxNewStyle;
        private System.Windows.Forms.Button buttonAdd;
		private System.Windows.Forms.ComboBox comboBoxSeriesStyle;
		private System.Windows.Forms.Label labelNewStyleScheme;
		private System.Windows.Forms.Label labelStyles;
		private System.Windows.Forms.Label labelSeriesType;
		private System.Windows.Forms.Button buttonDelete;
		private System.Windows.Forms.Label labelSymbolShape;
		private System.Windows.Forms.ComboBox comboBoxSymbolShape;
        private System.Windows.Forms.Label labelSymbolColor;
        private System.Windows.Forms.Label labelSeriesInteriorColor;
        private GroupBox groupBox1;
        private Panel panel1;
        private Panel panel2;
        private Panel pnlMain;
        private SplitContainer splitContainer1;
        private Button buttonChangeSeriesColor;
        private Label labelSeriesColor;
        private ColorDialog colorDialog1;
        private Label labelSymbolIntColor;
        private Button buttonSymbolColor;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlTrendOptions()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			this.labelStyles.Text = LRRHeaderText.GetHeaderString(this.labelStyles.Text) + ":";
			this.labelSeriesType.Text = LRRHeaderText.GetHeaderString(this.labelSeriesType.Text) + ":";
			buttonAdd.Text = LRRHeaderText.GetHeaderString(this.buttonAdd.Text);
			buttonDelete.Text = LRRHeaderText.GetHeaderString(this.buttonDelete.Text);
			
			labelNewStyleScheme.Text = LRRHeaderText.GetHeaderString(this.labelNewStyleScheme.Text) + ":";
			labelSymbolShape.Text = LRRHeaderText.GetHeaderString(this.labelSymbolShape.Text) + ":";
			labelSymbolColor.Text = LRRHeaderText.GetHeaderString(this.labelSymbolColor.Text) + ":";
            listBoxStyles.Items.Add("<" + LRRHeaderText.GetHeaderString("SID_NEW_SCHEME")+ ">");
            labelSeriesInteriorColor.Text = LRRHeaderText.GetHeaderString(this.labelSeriesInteriorColor.Text) + ":";
            listBoxStyles.SelectedIndex = 0;
            buttonSymbolColor.Text = LRRHeaderText.GetHeaderString(this.buttonSymbolColor.Text);
            buttonChangeSeriesColor.Text = LRRHeaderText.GetHeaderString(this.buttonChangeSeriesColor.Text);
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.listBoxStyles = new System.Windows.Forms.ListBox();
            this.textBoxNewStyle = new System.Windows.Forms.TextBox();
            this.labelNewStyleScheme = new System.Windows.Forms.Label();
            this.buttonAdd = new System.Windows.Forms.Button();
            this.comboBoxSeriesStyle = new System.Windows.Forms.ComboBox();
            this.labelStyles = new System.Windows.Forms.Label();
            this.labelSeriesType = new System.Windows.Forms.Label();
            this.buttonDelete = new System.Windows.Forms.Button();
            this.labelSymbolShape = new System.Windows.Forms.Label();
            this.comboBoxSymbolShape = new System.Windows.Forms.ComboBox();
            this.labelSymbolColor = new System.Windows.Forms.Label();
            this.labelSeriesInteriorColor = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.panel1 = new System.Windows.Forms.Panel();
            this.panel2 = new System.Windows.Forms.Panel();
            this.pnlMain = new System.Windows.Forms.Panel();
            this.splitContainer1 = new System.Windows.Forms.SplitContainer();
            this.colorDialog1 = new System.Windows.Forms.ColorDialog();
            this.labelSeriesColor = new System.Windows.Forms.Label();
            this.buttonChangeSeriesColor = new System.Windows.Forms.Button();
            this.buttonSymbolColor = new System.Windows.Forms.Button();
            this.labelSymbolIntColor = new System.Windows.Forms.Label();
            this.groupBox1.SuspendLayout();
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.pnlMain.SuspendLayout();
            this.splitContainer1.Panel1.SuspendLayout();
            this.splitContainer1.Panel2.SuspendLayout();
            this.splitContainer1.SuspendLayout();
            this.SuspendLayout();
            // 
            // listBoxStyles
            // 
            this.listBoxStyles.Location = new System.Drawing.Point(160, 14);
            this.listBoxStyles.Name = "listBoxStyles";
            this.listBoxStyles.Size = new System.Drawing.Size(120, 95);
            this.listBoxStyles.TabIndex = 0;
            this.listBoxStyles.SelectedIndexChanged += new System.EventHandler(this.listBoxStyles_SelectedIndexChanged);
            // 
            // textBoxNewStyle
            // 
            this.textBoxNewStyle.Location = new System.Drawing.Point(157, 22);
            this.textBoxNewStyle.Name = "textBoxNewStyle";
            this.textBoxNewStyle.Size = new System.Drawing.Size(100, 20);
            this.textBoxNewStyle.TabIndex = 1;
            this.textBoxNewStyle.TextChanged += new System.EventHandler(this.textBoxNewStyle_TextChanged);
            // 
            // labelNewStyleScheme
            // 
            this.labelNewStyleScheme.Location = new System.Drawing.Point(6, 25);
            this.labelNewStyleScheme.Name = "labelNewStyleScheme";
            this.labelNewStyleScheme.Size = new System.Drawing.Size(145, 23);
            this.labelNewStyleScheme.TabIndex = 2;
            this.labelNewStyleScheme.Text = "SID_NEW_STYLE_SCHEME";
            // 
            // buttonAdd
            // 
            this.buttonAdd.Enabled = false;
            this.buttonAdd.Location = new System.Drawing.Point(453, 120);
            this.buttonAdd.Name = "buttonAdd";
            this.buttonAdd.Size = new System.Drawing.Size(114, 23);
            this.buttonAdd.TabIndex = 3;
            this.buttonAdd.Text = "SID_ADD";
            this.buttonAdd.Click += new System.EventHandler(this.buttonAdd_Click);
            // 
            // comboBoxSeriesStyle
            // 
            this.comboBoxSeriesStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxSeriesStyle.Location = new System.Drawing.Point(157, 61);
            this.comboBoxSeriesStyle.Name = "comboBoxSeriesStyle";
            this.comboBoxSeriesStyle.Size = new System.Drawing.Size(121, 21);
            this.comboBoxSeriesStyle.TabIndex = 5;
            // 
            // labelStyles
            // 
            this.labelStyles.Location = new System.Drawing.Point(6, 14);
            this.labelStyles.Name = "labelStyles";
            this.labelStyles.Size = new System.Drawing.Size(147, 27);
            this.labelStyles.TabIndex = 6;
            this.labelStyles.Text = "SID_STYLE_SCHEMES";
            // 
            // labelSeriesType
            // 
            this.labelSeriesType.Location = new System.Drawing.Point(6, 61);
            this.labelSeriesType.Name = "labelSeriesType";
            this.labelSeriesType.Size = new System.Drawing.Size(145, 23);
            this.labelSeriesType.TabIndex = 7;
            this.labelSeriesType.Text = "SID_SERIES_TYPE";
            // 
            // buttonDelete
            // 
            this.buttonDelete.Location = new System.Drawing.Point(303, 86);
            this.buttonDelete.Name = "buttonDelete";
            this.buttonDelete.Size = new System.Drawing.Size(88, 23);
            this.buttonDelete.TabIndex = 8;
            this.buttonDelete.Text = "SID_DELETE";
            this.buttonDelete.Click += new System.EventHandler(this.buttonDelete_Click);
            // 
            // labelSymbolShape
            // 
            this.labelSymbolShape.Location = new System.Drawing.Point(335, 25);
            this.labelSymbolShape.Name = "labelSymbolShape";
            this.labelSymbolShape.Size = new System.Drawing.Size(112, 23);
            this.labelSymbolShape.TabIndex = 9;
            this.labelSymbolShape.Text = "SID_CHART_SERIES_SYMBOL_SHAPE";
            // 
            // comboBoxSymbolShape
            // 
            this.comboBoxSymbolShape.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxSymbolShape.Location = new System.Drawing.Point(453, 22);
            this.comboBoxSymbolShape.Name = "comboBoxSymbolShape";
            this.comboBoxSymbolShape.Size = new System.Drawing.Size(121, 21);
            this.comboBoxSymbolShape.TabIndex = 10;
            // 
            // labelSymbolColor
            // 
            this.labelSymbolColor.Location = new System.Drawing.Point(335, 62);
            this.labelSymbolColor.Name = "labelSymbolColor";
            this.labelSymbolColor.Size = new System.Drawing.Size(112, 23);
            this.labelSymbolColor.TabIndex = 11;
            this.labelSymbolColor.Text = "SID_CHART_SERIES_SYMBOL_COLOR";
            // 
            // labelSeriesInteriorColor
            // 
            this.labelSeriesInteriorColor.Location = new System.Drawing.Point(6, 99);
            this.labelSeriesInteriorColor.Name = "labelSeriesInteriorColor";
            this.labelSeriesInteriorColor.Size = new System.Drawing.Size(145, 24);
            this.labelSeriesInteriorColor.TabIndex = 13;
            this.labelSeriesInteriorColor.Text = "SID_SERIES_INT_COLOR";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.labelSymbolIntColor);
            this.groupBox1.Controls.Add(this.buttonSymbolColor);
            this.groupBox1.Controls.Add(this.buttonChangeSeriesColor);
            this.groupBox1.Controls.Add(this.labelSeriesColor);
            this.groupBox1.Controls.Add(this.labelNewStyleScheme);
            this.groupBox1.Controls.Add(this.textBoxNewStyle);
            this.groupBox1.Controls.Add(this.labelSeriesInteriorColor);
            this.groupBox1.Controls.Add(this.buttonAdd);
            this.groupBox1.Controls.Add(this.labelSeriesType);
            this.groupBox1.Controls.Add(this.comboBoxSeriesStyle);
            this.groupBox1.Controls.Add(this.labelSymbolColor);
            this.groupBox1.Controls.Add(this.labelSymbolShape);
            this.groupBox1.Controls.Add(this.comboBoxSymbolShape);
            this.groupBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.groupBox1.Location = new System.Drawing.Point(10, 10);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Padding = new System.Windows.Forms.Padding(5);
            this.groupBox1.Size = new System.Drawing.Size(1054, 165);
            this.groupBox1.TabIndex = 15;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Create Style Scheme";
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add(this.listBoxStyles);
            this.panel1.Controls.Add(this.labelStyles);
            this.panel1.Controls.Add(this.buttonDelete);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Padding = new System.Windows.Forms.Padding(10);
            this.panel1.Size = new System.Drawing.Size(1076, 150);
            this.panel1.TabIndex = 16;
            // 
            // panel2
            // 
            this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel2.Controls.Add(this.groupBox1);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel2.Location = new System.Drawing.Point(0, 0);
            this.panel2.Name = "panel2";
            this.panel2.Padding = new System.Windows.Forms.Padding(10);
            this.panel2.Size = new System.Drawing.Size(1076, 383);
            this.panel2.TabIndex = 17;
            // 
            // pnlMain
            // 
            this.pnlMain.Controls.Add(this.splitContainer1);
            this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlMain.Location = new System.Drawing.Point(0, 0);
            this.pnlMain.Name = "pnlMain";
            this.pnlMain.Size = new System.Drawing.Size(1076, 537);
            this.pnlMain.TabIndex = 18;
            // 
            // splitContainer1
            // 
            this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.splitContainer1.FixedPanel = System.Windows.Forms.FixedPanel.Panel1;
            this.splitContainer1.IsSplitterFixed = true;
            this.splitContainer1.Location = new System.Drawing.Point(0, 0);
            this.splitContainer1.Name = "splitContainer1";
            this.splitContainer1.Orientation = System.Windows.Forms.Orientation.Horizontal;
            // 
            // splitContainer1.Panel1
            // 
            this.splitContainer1.Panel1.Controls.Add(this.panel1);
            this.splitContainer1.Panel1MinSize = 100;
            // 
            // splitContainer1.Panel2
            // 
            this.splitContainer1.Panel2.Controls.Add(this.panel2);
            this.splitContainer1.Size = new System.Drawing.Size(1076, 537);
            this.splitContainer1.SplitterDistance = 150;
            this.splitContainer1.TabIndex = 19;
            // 
            // colorDialog1
            // 
            this.colorDialog1.Color = System.Drawing.Color.Green;
            // 
            // labelSeriesColor
            // 
            this.labelSeriesColor.AutoSize = true;
            this.labelSeriesColor.BackColor = System.Drawing.Color.Green;
            this.labelSeriesColor.Location = new System.Drawing.Point(168, 99);
            this.labelSeriesColor.Name = "labelSeriesColor";
            this.labelSeriesColor.Size = new System.Drawing.Size(19, 13);
            this.labelSeriesColor.TabIndex = 15;
            this.labelSeriesColor.Text = "    ";
            // 
            // buttonChangeSeriesColor
            // 
            this.buttonChangeSeriesColor.Location = new System.Drawing.Point(193, 94);
            this.buttonChangeSeriesColor.Name = "buttonChangeSeriesColor";
            this.buttonChangeSeriesColor.Size = new System.Drawing.Size(75, 23);
            this.buttonChangeSeriesColor.TabIndex = 16;
            this.buttonChangeSeriesColor.Text = "SID_CHANGE";
            this.buttonChangeSeriesColor.UseVisualStyleBackColor = true;
            this.buttonChangeSeriesColor.Click += new System.EventHandler(this.buttonChangeSeriesColor_Click);
            // 
            // buttonSymbolColor
            // 
            this.buttonSymbolColor.Location = new System.Drawing.Point(486, 56);
            this.buttonSymbolColor.Name = "buttonSymbolColor";
            this.buttonSymbolColor.Size = new System.Drawing.Size(75, 23);
            this.buttonSymbolColor.TabIndex = 17;
            this.buttonSymbolColor.Text = "SID_CHANGE";
            this.buttonSymbolColor.UseVisualStyleBackColor = true;
            this.buttonSymbolColor.Click += new System.EventHandler(this.buttonSymbolColor_Click);
            // 
            // labelSymbolIntColor
            // 
            this.labelSymbolIntColor.AutoSize = true;
            this.labelSymbolIntColor.BackColor = System.Drawing.Color.Green;
            this.labelSymbolIntColor.Location = new System.Drawing.Point(461, 61);
            this.labelSymbolIntColor.Name = "labelSymbolIntColor";
            this.labelSymbolIntColor.Size = new System.Drawing.Size(19, 13);
            this.labelSymbolIntColor.TabIndex = 18;
            this.labelSymbolIntColor.Text = "    ";
            // 
            // UserControlTrendOptions
            // 
            this.Controls.Add(this.pnlMain);
            this.Name = "UserControlTrendOptions";
            this.Size = new System.Drawing.Size(1076, 537);
            this.Load += new System.EventHandler(this.UserControlTrendOptions_Load);
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.panel1.ResumeLayout(false);
            this.panel2.ResumeLayout(false);
            this.pnlMain.ResumeLayout(false);
            this.splitContainer1.Panel1.ResumeLayout(false);
            this.splitContainer1.Panel2.ResumeLayout(false);
            this.splitContainer1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		private static Hashtable htSchemes = new Hashtable();
		private Symcon.LightRidge.PEAdvisor.LRRApp _lrrApp = null;

		#endregion

		#region Properties

		public static Hashtable HtSchemes
		{
			get
			{
				return htSchemes;
			}
		}

		#endregion

		#region Event Handlers

		private void UserControlTrendOptions_Load(object sender, System.EventArgs e)
		{
			string[] origArraySeriesType = Enum.GetNames(typeof(Syncfusion.Windows.Forms.Chart.ChartSeriesType));
            ArrayList actArraySeriesType = new ArrayList();
            for (int i = 0; i < origArraySeriesType.Length - 1; i++)
			{
                actArraySeriesType.Add(origArraySeriesType[i]);
			}

            actArraySeriesType.Remove("Spline");
            actArraySeriesType.Remove("RotatedSpline");
            actArraySeriesType.Remove("Bar");
            actArraySeriesType.Remove("SplineArea");

			this.comboBoxSeriesStyle.DataSource = actArraySeriesType;

			string[] origArraySymbolShape = Enum.GetNames(typeof(Syncfusion.Windows.Forms.Chart.ChartSymbolShape));
			string[] actArraySymbolShape = new string[origArraySymbolShape.Length -1];
			for(int j=1;j<origArraySymbolShape.Length;j++)
			{
				actArraySymbolShape[j-1] = origArraySymbolShape[j];
			}
			this.comboBoxSymbolShape.DataSource = actArraySymbolShape;

			if(listBoxStyles.Items.Count >= 10)
			{
				buttonAdd.Enabled = false;
				textBoxNewStyle.Enabled = false;
			}
			else
			{
				textBoxNewStyle.Enabled = true;
			}
			
			//Populate the schemes
			foreach(string schemeName in htSchemes.Keys)
			{
				if(!listBoxStyles.Items.Contains(schemeName))
				{
					this.listBoxStyles.Items.Add(schemeName);
				}
			}
		}

		private void buttonAdd_Click(object sender, System.EventArgs e)
		{
            if (buttonAdd.Text == LRRHeaderText.GetHeaderString("SID_ADD"))
            {
                if (!listBoxStyles.Items.Contains(textBoxNewStyle.Text))
                {
                    this.listBoxStyles.Items.Add(textBoxNewStyle.Text);
                    htSchemes.Add(textBoxNewStyle.Text, comboBoxSeriesStyle.SelectedItem.ToString() + "|" + comboBoxSymbolShape.SelectedItem.ToString() + "|" + labelSymbolIntColor.BackColor.ToArgb() + "|" + labelSeriesColor.BackColor.ToArgb());
                }
                else
                {
                    LRRMessagBox.ShowMessage("SID_SCHEME_EXISTS", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                textBoxNewStyle.Text = "";
                if (listBoxStyles.Items.Count >= 10)
                {
                    buttonAdd.Enabled = false;
                    textBoxNewStyle.Enabled = false;
                }
                else
                {
                    textBoxNewStyle.Enabled = true;
                }
            }
            else
            {
                if (listBoxStyles.SelectedItem == null)
                {
                    LRRMessagBox.ShowMessage("SID_SEL_SCHEME", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                htSchemes[listBoxStyles.SelectedItem] = comboBoxSeriesStyle.SelectedItem.ToString() + "|" + comboBoxSymbolShape.SelectedItem.ToString() + "|" + labelSymbolIntColor.BackColor.ToArgb() + "|" + labelSeriesColor.BackColor.ToArgb();
            }
		}

		private void textBoxNewStyle_TextChanged(object sender, System.EventArgs e)
		{
			if(textBoxNewStyle.Text == "")
				buttonAdd.Enabled = false;
			else
				buttonAdd.Enabled = true;
		}

		

		private void listBoxStyles_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(listBoxStyles.SelectedItem!= null)
			{
                if (listBoxStyles.SelectedIndex != 0)
                {
                    textBoxNewStyle.Text = listBoxStyles.SelectedItem.ToString();
                    comboBoxSeriesStyle.SelectedItem = htSchemes[listBoxStyles.SelectedItem].ToString().Split("|".ToCharArray())[0];
                    comboBoxSymbolShape.SelectedItem = htSchemes[listBoxStyles.SelectedItem].ToString().Split("|".ToCharArray())[1];
                    try
                    {
                        labelSymbolIntColor.BackColor = Color.FromArgb(int.Parse(htSchemes[listBoxStyles.SelectedItem].ToString().Split("|".ToCharArray())[2]));
                    }
                    catch
                    {
                        try
                        {
                            labelSymbolIntColor.BackColor = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), htSchemes[listBoxStyles.SelectedItem].ToString().Split("|".ToCharArray())[2]));
                        }
                        catch
                        { }
                    }
                    try
                    {
                        labelSeriesColor.BackColor = Color.FromArgb(int.Parse(htSchemes[listBoxStyles.SelectedItem].ToString().Split("|".ToCharArray())[3]));
                    }
                    catch
                    {
                        try
                        {
                            labelSeriesColor.BackColor = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), htSchemes[listBoxStyles.SelectedItem].ToString().Split("|".ToCharArray())[3]));
                        }
                        catch { }
                    }
                    buttonAdd.Text = LRRHeaderText.GetHeaderString("SID_UPD");
                    groupBox1.Text = LRRHeaderText.GetHeaderString("SID_EDIT_STYLE_SCHEME");
                    textBoxNewStyle.Enabled = false;
                    buttonDelete.Enabled = true;
                }
                else
                {
                    textBoxNewStyle.Text = "";
                    buttonAdd.Text = LRRHeaderText.GetHeaderString("SID_ADD");
                    groupBox1.Text = LRRHeaderText.GetHeaderString("SID_CREATE_STYLE_SCHEME");
                    textBoxNewStyle.Enabled = true;
                    buttonDelete.Enabled = false;
                }
			}
		}

		private void buttonDelete_Click(object sender, System.EventArgs e)
		{
			if(listBoxStyles.SelectedItem != null)
			{
				if(!_lrrApp.LRRUIManagerObj.IsSchemeInUse(listBoxStyles.SelectedItem.ToString()))
				{
					htSchemes.Remove(listBoxStyles.SelectedItem);
					listBoxStyles.Items.Remove(listBoxStyles.SelectedItem);
					textBoxNewStyle.Enabled = true;
                    listBoxStyles.SelectedIndex = 0;
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_TREND_SCHEME_IN_USE","SID_LABLE",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				}
			}
		}
        private void buttonChangeSeriesColor_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                labelSeriesColor.BackColor = colorDialog1.Color;
            }
        }

        private void buttonSymbolColor_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                labelSymbolIntColor.BackColor = colorDialog1.Color;
            }
        }

        #endregion

        #region ILRRUIContainer Members

        public void ArrangeColumns()
        {
            
        }

        public void ClearFilter()
        {
            
        }

        public void ClearSort()
        {
        }

        public void Copy()
        {
        }

        public void CopyMasterProperties()
        {
        }

        public void CopyUOMTypes()
        {
           
        }

        public void Delete()
        {
            
        }

        public void DownLevel()
        {
           
        }

        public void Export()
        {
           
        }

        public void ImportToExcel()
        {
            
        }

        public void InsertNewRows()
        {
            
        }

        public void LeftColMovement()
        {
        }

        public void LeftLevel()
        {
        }

        public void OpenCompositeView()
        {
        }

        public void OpenQuery()
        {
        }

        public void OpenView()
        {
        }

        public void PageSetup()
        {

        }

        public TabControl ParentTabControl
        {
            get
            {
                // TODO:  Add OptionsUserControl.ParentTabControl getter implementation
                return null;
            }
            set
            {
                // TODO:  Add OptionsUserControl.ParentTabControl setter implementation
            }
        }

        public TabPage ParentTabPage
        {
            get
            {
                // TODO:  Add OptionsUserControl.ParentTabControl getter implementation
                return null;
            }
            set
            {
                // TODO:  Add OptionsUserControl.ParentTabControl setter implementation
            }
        }

        public void Paste()
        {
        }

        public bool PerformDirtyChk
        {
            get
            {
                return true;
            }
        }

        public void Print()
        {
        }

        public void PrintPreview()
        {
        }

        public void RightColMovement()
        {
        }

        public void RightLevel()
        {
        }

        public void Save()
        {
        }

        public void SelectionPaste()
        {
        }

        public void ShowComponentList()
        {
        }

        public void ShowPropertyList()
        {
        }

        public bool SupportsArrangeColumns()
        {
            return false;
        }

        public bool SupportsClearFilter()
        {
            return false;
        }

        public bool SupportsClearSort()
        {
            return false;
        }

        public bool SupportsCompositeView()
        {
            return false;
        }

        public bool SupportsCopy()
        {
            return false;
        }

        public bool SupportsCopyUOMTypes()
        {
            return false;
        }

        public bool SupportsDelete()
        {
            return false;
        }

        public bool SupportsExport()
        {
            return false;
        }

        public bool SupportsImportToExcel()
        {
            return false;
        }

        public bool SupportsInsertNewRows()
        {
            return false;
        }

        public bool SupportsLevel()
        {
            return false;
        }

        public bool SupportsMasterPropertiesCopy()
        {
            return false;
        }

        public bool SupportsPageSetup()
        {
            return false;
        }

        public bool SupportsPaste()
        {
            return false;
        }

        public bool SupportsPrint()
        {
            return false;
        }

        public bool SupportsRefresh()
        {
            return false;
        }

        public bool SupportsResultsFilter()
        {
            return false;
        }

        public bool SupportsSave()
        {
            return false;
        }

        public bool SupportsSelectionPaste()
        {
            return false;
        }

        public bool SupportsUndo()
        {
            return false;
        }

        public void TransposeView()
        {
            
        }

        public void Undo()
        {
            
        }

        public void UpLevel()
        {
            
        }

        #endregion
    }
}
