using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageDispatcher;
using Symcon.BusinessObjects; 

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControl1TrendOptionsRowsHeadercs.
	/// </summary>
	public class UserControlTrendOptionsRowsHeaders : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.Label labelSeriesType;
		private System.Windows.Forms.Label labelSymbolShape;
		private System.Windows.Forms.Label labelSymbolColor;
		private System.Windows.Forms.Label labelSeriesInteriorColor;
		private System.Windows.Forms.Label labelLog;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlTrendOptionsRowsHeaders()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			this.labelSeriesType.Text = LRRHeaderText.GetHeaderString(this.labelSeriesType.Text) + ":";
			labelSymbolShape.Text = LRRHeaderText.GetHeaderString(this.labelSymbolShape.Text) + ":";
			labelSymbolColor.Text = LRRHeaderText.GetHeaderString(this.labelSymbolColor.Text) + ":";
			labelSeriesInteriorColor.Text = LRRHeaderText.GetHeaderString(this.labelSeriesInteriorColor.Text) + ":";
			this.labelLog.Text = LRRHeaderText.GetHeaderString(this.labelLog.Text) + ":";
			
			this.Resize += new EventHandler(UserControl1TrendOptionsRowsHeaders_Resize);
			
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.labelSeriesType = new System.Windows.Forms.Label();
            this.labelSymbolShape = new System.Windows.Forms.Label();
            this.labelSymbolColor = new System.Windows.Forms.Label();
            this.labelSeriesInteriorColor = new System.Windows.Forms.Label();
            this.labelLog = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // labelSeriesType
            // 
            this.labelSeriesType.AutoSize = true;
            this.labelSeriesType.Location = new System.Drawing.Point(32, 8);
            this.labelSeriesType.Name = "labelSeriesType";
            this.labelSeriesType.Size = new System.Drawing.Size(104, 13);
            this.labelSeriesType.TabIndex = 9;
            this.labelSeriesType.Text = "SID_SERIES_TYPE";
            // 
            // labelSymbolShape
            // 
            this.labelSymbolShape.AutoSize = true;
            this.labelSymbolShape.Location = new System.Drawing.Point(184, 8);
            this.labelSymbolShape.Name = "labelSymbolShape";
            this.labelSymbolShape.Size = new System.Drawing.Size(205, 13);
            this.labelSymbolShape.TabIndex = 11;
            this.labelSymbolShape.Text = "SID_CHART_SERIES_SYMBOL_SHAPE";
            // 
            // labelSymbolColor
            // 
            this.labelSymbolColor.AutoSize = true;
            this.labelSymbolColor.Location = new System.Drawing.Point(384, 8);
            this.labelSymbolColor.Name = "labelSymbolColor";
            this.labelSymbolColor.Size = new System.Drawing.Size(206, 13);
            this.labelSymbolColor.TabIndex = 13;
            this.labelSymbolColor.Text = "SID_CHART_SERIES_SYMBOL_COLOR";
            // 
            // labelSeriesInteriorColor
            // 
            this.labelSeriesInteriorColor.AutoSize = true;
            this.labelSeriesInteriorColor.Location = new System.Drawing.Point(576, 8);
            this.labelSeriesInteriorColor.Name = "labelSeriesInteriorColor";
            this.labelSeriesInteriorColor.Size = new System.Drawing.Size(171, 13);
            this.labelSeriesInteriorColor.TabIndex = 16;
            this.labelSeriesInteriorColor.Text = "SID_SERIES_INTERIOR_COLOR";
            // 
            // labelLog
            // 
            this.labelLog.AutoSize = true;
            this.labelLog.Location = new System.Drawing.Point(728, 8);
            this.labelLog.Name = "labelLog";
            this.labelLog.Size = new System.Drawing.Size(101, 13);
            this.labelLog.TabIndex = 17;
            this.labelLog.Text = "SID_SPLIT_SCALE";
            // 
            // UserControlTrendOptionsRowsHeaders
            // 
            this.Controls.Add(this.labelLog);
            this.Controls.Add(this.labelSeriesType);
            this.Controls.Add(this.labelSymbolShape);
            this.Controls.Add(this.labelSymbolColor);
            this.Controls.Add(this.labelSeriesInteriorColor);
            this.Name = "UserControlTrendOptionsRowsHeaders";
            this.Size = new System.Drawing.Size(872, 40);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void UserControl1TrendOptionsRowsHeaders_Resize(object sender, EventArgs e)
		{
			int noOfControls = this.Controls.Count + 1;
			int colWidth = this.Width/noOfControls;
			for(int i=1;i<noOfControls;i++)
			{
				this.Controls[i-1].Location = new Point(i*colWidth,this.Controls[i-1].Location.Y);
			}
		}

        #region ILRRUIContainer Members

        public void ArrangeColumns()
        {

        }

        public void ClearFilter()
        {

        }

        public void ClearSort()
        {
        }

        public void Copy()
        {
        }

        public void CopyMasterProperties()
        {
        }

        public void CopyUOMTypes()
        {

        }

        public void Delete()
        {

        }

        public void DownLevel()
        {

        }

        public void Export()
        {

        }

        public void ImportToExcel()
        {

        }

        public void InsertNewRows()
        {

        }

        public void LeftColMovement()
        {
        }

        public void LeftLevel()
        {
        }

        public void OpenCompositeView()
        {
        }

        public void OpenQuery()
        {
        }

        public void OpenView()
        {
        }

        public void PageSetup()
        {

        }

        public TabControl ParentTabControl
        {
            get
            {
                // TODO:  Add OptionsUserControl.ParentTabControl getter implementation
                return null;
            }
            set
            {
                // TODO:  Add OptionsUserControl.ParentTabControl setter implementation
            }
        }

        public TabPage ParentTabPage
        {
            get
            {
                // TODO:  Add OptionsUserControl.ParentTabControl getter implementation
                return null;
            }
            set
            {
                // TODO:  Add OptionsUserControl.ParentTabControl setter implementation
            }
        }

        public void Paste()
        {
        }

        public bool PerformDirtyChk
        {
            get
            {
                return true;
            }
        }

        public void Print()
        {
        }

        public void PrintPreview()
        {
        }

        public void RightColMovement()
        {
        }

        public void RightLevel()
        {
        }

        public void Save()
        {
        }

        public void SelectionPaste()
        {
        }

        public void ShowComponentList()
        {
        }

        public void ShowPropertyList()
        {
        }

        public bool SupportsArrangeColumns()
        {
            return false;
        }

        public bool SupportsClearFilter()
        {
            return false;
        }

        public bool SupportsClearSort()
        {
            return false;
        }

        public bool SupportsCompositeView()
        {
            return false;
        }

        public bool SupportsCopy()
        {
            return false;
        }

        public bool SupportsCopyUOMTypes()
        {
            return false;
        }

        public bool SupportsDelete()
        {
            return false;
        }

        public bool SupportsExport()
        {
            return false;
        }

        public bool SupportsImportToExcel()
        {
            return false;
        }

        public bool SupportsInsertNewRows()
        {
            return false;
        }

        public bool SupportsLevel()
        {
            return false;
        }

        public bool SupportsMasterPropertiesCopy()
        {
            return false;
        }

        public bool SupportsPageSetup()
        {
            return false;
        }

        public bool SupportsPaste()
        {
            return false;
        }

        public bool SupportsPrint()
        {
            return false;
        }

        public bool SupportsRefresh()
        {
            return false;
        }

        public bool SupportsResultsFilter()
        {
            return false;
        }

        public bool SupportsSave()
        {
            return false;
        }

        public bool SupportsSelectionPaste()
        {
            return false;
        }

        public bool SupportsUndo()
        {
            return false;
        }

        public void TransposeView()
        {

        }

        public void Undo()
        {

        }

        public void UpLevel()
        {

        }

        #endregion
    }
}
