using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageDispatcher;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlTrendTemplateRows.
	/// </summary>
	public class UserControlTrendTemplateRows : System.Windows.Forms.UserControl,ILRRUIContainer    
	{
		public System.Windows.Forms.Label labelID;
		public System.Windows.Forms.ComboBox comboBoxSeriesStyle;
        public System.Windows.Forms.ComboBox comboBoxSymbolShape;
        public System.Windows.Forms.CheckBox checkBoxLog;
        private Panel panelSeriesColor;
        private Button buttonSeriesColor;
        public Label labelSeriesColor;
        private Panel panelSymbolColor;
        private Button buttonSymbolColor;
        public Label labelSymbolColor;
        private ColorDialog colorDialog1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlTrendTemplateRows()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			string[] origArraySeriesType = Enum.GetNames(typeof(Syncfusion.Windows.Forms.Chart.ChartSeriesType));
            ArrayList actArraySeriesType = new ArrayList();
            for (int i = 0; i < origArraySeriesType.Length - 1; i++)
            {
                actArraySeriesType.Add(origArraySeriesType[i]);
            }

            actArraySeriesType.Remove("Spline");
            actArraySeriesType.Remove("RotatedSpline");
            actArraySeriesType.Remove("Bar");
            actArraySeriesType.Remove("SplineArea");

            this.comboBoxSeriesStyle.DataSource = actArraySeriesType;

			string[] origArraySymbolShape = Enum.GetNames(typeof(Syncfusion.Windows.Forms.Chart.ChartSymbolShape));
			string[] actArraySymbolShape = new string[origArraySymbolShape.Length -1];
			for(int j=1;j<origArraySymbolShape.Length;j++)
			{
				actArraySymbolShape[j-1] = origArraySymbolShape[j];
			}
			this.comboBoxSymbolShape.DataSource = actArraySymbolShape;

            this.buttonSeriesColor.Text = LRRHeaderText.GetHeaderString(this.buttonSeriesColor.Text);
            this.buttonSymbolColor.Text = LRRHeaderText.GetHeaderString(this.buttonSymbolColor.Text);

			this.Resize += new EventHandler(UserControlTrendTemplateRows_Resize);
            InternationalizationUtils.GetControlText(this, null);	
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.labelID = new System.Windows.Forms.Label();
            this.comboBoxSeriesStyle = new System.Windows.Forms.ComboBox();
            this.comboBoxSymbolShape = new System.Windows.Forms.ComboBox();
            this.checkBoxLog = new System.Windows.Forms.CheckBox();
            this.panelSeriesColor = new System.Windows.Forms.Panel();
            this.buttonSeriesColor = new System.Windows.Forms.Button();
            this.labelSeriesColor = new System.Windows.Forms.Label();
            this.panelSymbolColor = new System.Windows.Forms.Panel();
            this.buttonSymbolColor = new System.Windows.Forms.Button();
            this.labelSymbolColor = new System.Windows.Forms.Label();
            this.colorDialog1 = new System.Windows.Forms.ColorDialog();
            this.panelSeriesColor.SuspendLayout();
            this.panelSymbolColor.SuspendLayout();
            this.SuspendLayout();
            // 
            // labelID
            // 
            this.labelID.AutoSize = true;
            this.labelID.Location = new System.Drawing.Point(16, 8);
            this.labelID.Name = "labelID";
            this.labelID.Size = new System.Drawing.Size(0, 13);
            this.labelID.TabIndex = 17;
            // 
            // comboBoxSeriesStyle
            // 
            this.comboBoxSeriesStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxSeriesStyle.Location = new System.Drawing.Point(120, 8);
            this.comboBoxSeriesStyle.Name = "comboBoxSeriesStyle";
            this.comboBoxSeriesStyle.Size = new System.Drawing.Size(121, 21);
            this.comboBoxSeriesStyle.TabIndex = 18;
            // 
            // comboBoxSymbolShape
            // 
            this.comboBoxSymbolShape.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxSymbolShape.Location = new System.Drawing.Point(264, 8);
            this.comboBoxSymbolShape.Name = "comboBoxSymbolShape";
            this.comboBoxSymbolShape.Size = new System.Drawing.Size(121, 21);
            this.comboBoxSymbolShape.TabIndex = 19;
            // 
            // checkBoxLog
            // 
            this.checkBoxLog.Location = new System.Drawing.Point(80, 8);
            this.checkBoxLog.Name = "checkBoxLog";
            this.checkBoxLog.Size = new System.Drawing.Size(16, 24);
            this.checkBoxLog.TabIndex = 22;
            // 
            // panelSeriesColor
            // 
            this.panelSeriesColor.Controls.Add(this.buttonSeriesColor);
            this.panelSeriesColor.Controls.Add(this.labelSeriesColor);
            this.panelSeriesColor.Location = new System.Drawing.Point(567, 8);
            this.panelSeriesColor.Name = "panelSeriesColor";
            this.panelSeriesColor.Size = new System.Drawing.Size(116, 25);
            this.panelSeriesColor.TabIndex = 23;
            // 
            // buttonSeriesColor
            // 
            this.buttonSeriesColor.AutoSize = true;
            this.buttonSeriesColor.Location = new System.Drawing.Point(28, -1);
            this.buttonSeriesColor.Name = "buttonSeriesColor";
            this.buttonSeriesColor.Size = new System.Drawing.Size(86, 23);
            this.buttonSeriesColor.TabIndex = 1;
            this.buttonSeriesColor.Text = "SID_CHANGE";
            this.buttonSeriesColor.UseVisualStyleBackColor = true;
            this.buttonSeriesColor.Click += new System.EventHandler(this.buttonSeriesColor_Click);
            // 
            // labelSeriesColor
            // 
            this.labelSeriesColor.AutoSize = true;
            this.labelSeriesColor.BackColor = System.Drawing.Color.Green;
            this.labelSeriesColor.Location = new System.Drawing.Point(3, 3);
            this.labelSeriesColor.Name = "labelSeriesColor";
            this.labelSeriesColor.Size = new System.Drawing.Size(19, 13);
            this.labelSeriesColor.TabIndex = 0;
            this.labelSeriesColor.Text = "    ";
            // 
            // panelSymbolColor
            // 
            this.panelSymbolColor.Controls.Add(this.buttonSymbolColor);
            this.panelSymbolColor.Controls.Add(this.labelSymbolColor);
            this.panelSymbolColor.Location = new System.Drawing.Point(432, 8);
            this.panelSymbolColor.Name = "panelSymbolColor";
            this.panelSymbolColor.Size = new System.Drawing.Size(116, 25);
            this.panelSymbolColor.TabIndex = 24;
            // 
            // buttonSymbolColor
            // 
            this.buttonSymbolColor.AutoSize = true;
            this.buttonSymbolColor.Location = new System.Drawing.Point(28, -1);
            this.buttonSymbolColor.Name = "buttonSymbolColor";
            this.buttonSymbolColor.Size = new System.Drawing.Size(86, 23);
            this.buttonSymbolColor.TabIndex = 1;
            this.buttonSymbolColor.Text = "SID_CHANGE";
            this.buttonSymbolColor.UseVisualStyleBackColor = true;
            this.buttonSymbolColor.Click += new System.EventHandler(this.buttonSymbolColor_Click);
            // 
            // labelSymbolColor
            // 
            this.labelSymbolColor.AutoSize = true;
            this.labelSymbolColor.BackColor = System.Drawing.Color.Green;
            this.labelSymbolColor.Location = new System.Drawing.Point(3, 5);
            this.labelSymbolColor.Name = "labelSymbolColor";
            this.labelSymbolColor.Size = new System.Drawing.Size(19, 13);
            this.labelSymbolColor.TabIndex = 0;
            this.labelSymbolColor.Text = "    ";
            // 
            // colorDialog1
            // 
            this.colorDialog1.Color = System.Drawing.Color.Green;
            // 
            // UserControlTrendTemplateRows
            // 
            this.Controls.Add(this.panelSeriesColor);
            this.Controls.Add(this.panelSymbolColor);
            this.Controls.Add(this.comboBoxSymbolShape);
            this.Controls.Add(this.comboBoxSeriesStyle);
            this.Controls.Add(this.checkBoxLog);
            this.Controls.Add(this.labelID);
            this.Name = "UserControlTrendTemplateRows";
            this.Size = new System.Drawing.Size(1024, 42);
            this.Load += new System.EventHandler(this.UserControlTrendTemplateRows_Load);
            this.panelSeriesColor.ResumeLayout(false);
            this.panelSeriesColor.PerformLayout();
            this.panelSymbolColor.ResumeLayout(false);
            this.panelSymbolColor.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void UserControlTrendTemplateRows_Load(object sender, System.EventArgs e)
		{
			
		}

		private void UserControlTrendTemplateRows_Resize(object sender, EventArgs e)
		{
			
			int noOfControls = this.Controls.Count;
			int colWidth = this.Width/noOfControls;
			for(int i=0;i<noOfControls;i++)
			{
				if(i==0)
				{
					this.Controls[noOfControls-i-1].Location = new Point(colWidth/2,this.Controls[noOfControls-i-1].Location.Y);
				}
				else
				{
					this.Controls[noOfControls-i-1].Location = new Point(i*colWidth,this.Controls[noOfControls-i-1].Location.Y);
				}
			}
		}

        private void buttonSymbolColor_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
                labelSymbolColor.BackColor = colorDialog1.Color;
        }

        private void buttonSeriesColor_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
                labelSeriesColor.BackColor = colorDialog1.Color;
        }

        #region ILRRUIContainer Members

        public void ArrangeColumns()
        {

        }

        public void ClearFilter()
        {

        }

        public void ClearSort()
        {
        }

        public void Copy()
        {
        }

        public void CopyMasterProperties()
        {
        }

        public void CopyUOMTypes()
        {

        }

        public void Delete()
        {

        }

        public void DownLevel()
        {

        }

        public void Export()
        {

        }

        public void ImportToExcel()
        {

        }

        public void InsertNewRows()
        {

        }

        public void LeftColMovement()
        {
        }

        public void LeftLevel()
        {
        }

        public void OpenCompositeView()
        {
        }

        public void OpenQuery()
        {
        }

        public void OpenView()
        {
        }

        public void PageSetup()
        {

        }

        public TabControl ParentTabControl
        {
            get
            {
                // TODO:  Add OptionsUserControl.ParentTabControl getter implementation
                return null;
            }
            set
            {
                // TODO:  Add OptionsUserControl.ParentTabControl setter implementation
            }
        }

        public TabPage ParentTabPage
        {
            get
            {
                // TODO:  Add OptionsUserControl.ParentTabControl getter implementation
                return null;
            }
            set
            {
                // TODO:  Add OptionsUserControl.ParentTabControl setter implementation
            }
        }

        public void Paste()
        {
        }

        public bool PerformDirtyChk
        {
            get
            {
                return true;
            }
        }

        public void Print()
        {
        }

        public void PrintPreview()
        {
        }

        public void RightColMovement()
        {
        }

        public void RightLevel()
        {
        }

        public void Save()
        {
        }

        public void SelectionPaste()
        {
        }

        public void ShowComponentList()
        {
        }

        public void ShowPropertyList()
        {
        }

        public bool SupportsArrangeColumns()
        {
            return false;
        }

        public bool SupportsClearFilter()
        {
            return false;
        }

        public bool SupportsClearSort()
        {
            return false;
        }

        public bool SupportsCompositeView()
        {
            return false;
        }

        public bool SupportsCopy()
        {
            return false;
        }

        public bool SupportsCopyUOMTypes()
        {
            return false;
        }

        public bool SupportsDelete()
        {
            return false;
        }

        public bool SupportsExport()
        {
            return false;
        }

        public bool SupportsImportToExcel()
        {
            return false;
        }

        public bool SupportsInsertNewRows()
        {
            return false;
        }

        public bool SupportsLevel()
        {
            return false;
        }

        public bool SupportsMasterPropertiesCopy()
        {
            return false;
        }

        public bool SupportsPageSetup()
        {
            return false;
        }

        public bool SupportsPaste()
        {
            return false;
        }

        public bool SupportsPrint()
        {
            return false;
        }

        public bool SupportsRefresh()
        {
            return false;
        }

        public bool SupportsResultsFilter()
        {
            return false;
        }

        public bool SupportsSave()
        {
            return false;
        }

        public bool SupportsSelectionPaste()
        {
            return false;
        }

        public bool SupportsUndo()
        {
            return false;
        }

        public void TransposeView()
        {

        }

        public void Undo()
        {

        }

        public void UpLevel()
        {

        }

        #endregion
    }
}
