using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.Text;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlTrendTemplates.
	/// </summary>
	public class UserControlTrendTemplates : System.Windows.Forms.UserControl, ILRRUIContainer
	{
		private System.Windows.Forms.Label labelCreatedTemplateName;
		private System.Windows.Forms.ComboBox comboBoxCreatedTemplates;
		private System.Windows.Forms.Label labelTemplateName;
		private System.Windows.Forms.TextBox textBoxTemplateName;
		private System.Windows.Forms.Label labelNoOfRows;
		private System.Windows.Forms.ComboBox comboBoxNoOfRows;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter1;
        private CheckBox checkBoxSameGraph;
        private CheckBox checkBoxXY;
        private Button buttonDelete;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlTrendTemplates()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			comboBoxCreatedTemplates.SelectedIndexChanged += new EventHandler(comboBoxCreatedTemplates_SelectedIndexChanged);
            textBoxTemplateName.TextChanged += new EventHandler(textBoxTemplateName_TextChanged);
            buttonDelete.Text = LRRHeaderText.GetHeaderString(buttonDelete.Text);
            InternationalizationUtils.GetControlText(this, null);	
		}

        void textBoxTemplateName_TextChanged(object sender, EventArgs e)
        {
            _toSave = true;
        }

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.labelCreatedTemplateName = new System.Windows.Forms.Label();
            this.comboBoxCreatedTemplates = new System.Windows.Forms.ComboBox();
            this.labelTemplateName = new System.Windows.Forms.Label();
            this.textBoxTemplateName = new System.Windows.Forms.TextBox();
            this.labelNoOfRows = new System.Windows.Forms.Label();
            this.comboBoxNoOfRows = new System.Windows.Forms.ComboBox();
            this.panel1 = new System.Windows.Forms.Panel();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.panel2 = new System.Windows.Forms.Panel();
            this.buttonDelete = new System.Windows.Forms.Button();
            this.checkBoxXY = new System.Windows.Forms.CheckBox();
            this.checkBoxSameGraph = new System.Windows.Forms.CheckBox();
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // labelCreatedTemplateName
            // 
            this.labelCreatedTemplateName.AutoSize = true;
            this.labelCreatedTemplateName.Location = new System.Drawing.Point(16, 16);
            this.labelCreatedTemplateName.Name = "labelCreatedTemplateName";
            this.labelCreatedTemplateName.Size = new System.Drawing.Size(0, 13);
            this.labelCreatedTemplateName.TabIndex = 0;
            this.labelCreatedTemplateName.Tag = "CREATED_TEMPLATES";
            // 
            // comboBoxCreatedTemplates
            // 
            this.comboBoxCreatedTemplates.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxCreatedTemplates.Location = new System.Drawing.Point(19, 32);
            this.comboBoxCreatedTemplates.Name = "comboBoxCreatedTemplates";
            this.comboBoxCreatedTemplates.Size = new System.Drawing.Size(256, 21);
            this.comboBoxCreatedTemplates.TabIndex = 1;
            // 
            // labelTemplateName
            // 
            this.labelTemplateName.AutoSize = true;
            this.labelTemplateName.Location = new System.Drawing.Point(16, 64);
            this.labelTemplateName.Name = "labelTemplateName";
            this.labelTemplateName.Size = new System.Drawing.Size(0, 13);
            this.labelTemplateName.TabIndex = 2;
            this.labelTemplateName.Tag = "TEMPLATE_NAME";
            // 
            // textBoxTemplateName
            // 
            this.textBoxTemplateName.Location = new System.Drawing.Point(19, 86);
            this.textBoxTemplateName.Name = "textBoxTemplateName";
            this.textBoxTemplateName.Size = new System.Drawing.Size(256, 20);
            this.textBoxTemplateName.TabIndex = 3;
            // 
            // labelNoOfRows
            // 
            this.labelNoOfRows.AutoSize = true;
            this.labelNoOfRows.Location = new System.Drawing.Point(16, 112);
            this.labelNoOfRows.Name = "labelNoOfRows";
            this.labelNoOfRows.Size = new System.Drawing.Size(0, 13);
            this.labelNoOfRows.TabIndex = 4;
            this.labelNoOfRows.Tag = "NO_OF_ROWS";
            // 
            // comboBoxNoOfRows
            // 
            this.comboBoxNoOfRows.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxNoOfRows.Items.AddRange(new object[] {
            "1",
            "2",
            "3",
            "4"});
            this.comboBoxNoOfRows.Location = new System.Drawing.Point(19, 138);
            this.comboBoxNoOfRows.Name = "comboBoxNoOfRows";
            this.comboBoxNoOfRows.Size = new System.Drawing.Size(40, 21);
            this.comboBoxNoOfRows.TabIndex = 5;
            this.comboBoxNoOfRows.SelectionChangeCommitted += new System.EventHandler(this.comboBoxNoOfRows_SelectionChangeCommitted);
            // 
            // panel1
            // 
            this.panel1.AutoScroll = true;
            this.panel1.Controls.Add(this.splitter1);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 184);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(616, 424);
            this.panel1.TabIndex = 6;
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(616, 3);
            this.splitter1.TabIndex = 0;
            this.splitter1.TabStop = false;
            // 
            // panel2
            // 
            this.panel2.Controls.Add(this.buttonDelete);
            this.panel2.Controls.Add(this.checkBoxXY);
            this.panel2.Controls.Add(this.checkBoxSameGraph);
            this.panel2.Controls.Add(this.comboBoxCreatedTemplates);
            this.panel2.Controls.Add(this.labelNoOfRows);
            this.panel2.Controls.Add(this.comboBoxNoOfRows);
            this.panel2.Controls.Add(this.labelCreatedTemplateName);
            this.panel2.Controls.Add(this.labelTemplateName);
            this.panel2.Controls.Add(this.textBoxTemplateName);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel2.Location = new System.Drawing.Point(0, 0);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(616, 184);
            this.panel2.TabIndex = 7;
            // 
            // buttonDelete
            // 
            this.buttonDelete.AutoSize = true;
            this.buttonDelete.Location = new System.Drawing.Point(300, 30);
            this.buttonDelete.Name = "buttonDelete";
            this.buttonDelete.Size = new System.Drawing.Size(83, 23);
            this.buttonDelete.TabIndex = 8;
            this.buttonDelete.Text = "SID_DELETE";
            this.buttonDelete.UseVisualStyleBackColor = true;
            this.buttonDelete.Click += new System.EventHandler(this.buttonDelete_Click);
            // 
            // checkBoxXY
            // 
            this.checkBoxXY.AutoSize = true;
            this.checkBoxXY.Location = new System.Drawing.Point(92, 161);
            this.checkBoxXY.Name = "checkBoxXY";
            this.checkBoxXY.Size = new System.Drawing.Size(15, 14);
            this.checkBoxXY.TabIndex = 7;
            this.checkBoxXY.Tag = "XY_GRAPH";
            this.checkBoxXY.UseVisualStyleBackColor = true;
            this.checkBoxXY.CheckedChanged += new System.EventHandler(this.checkBoxXY_CheckedChanged);
            // 
            // checkBoxSameGraph
            // 
            this.checkBoxSameGraph.AutoSize = true;
            this.checkBoxSameGraph.Location = new System.Drawing.Point(92, 140);
            this.checkBoxSameGraph.Name = "checkBoxSameGraph";
            this.checkBoxSameGraph.Size = new System.Drawing.Size(15, 14);
            this.checkBoxSameGraph.TabIndex = 6;
            this.checkBoxSameGraph.Tag = "SHOW_IN_SAME_GRAPH";
            this.checkBoxSameGraph.UseVisualStyleBackColor = true;
            this.checkBoxSameGraph.CheckedChanged += new System.EventHandler(this.checkBoxSameGraph_CheckedChanged);
            // 
            // UserControlTrendTemplates
            // 
            this.AutoScroll = true;
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.panel2);
            this.Name = "UserControlTrendTemplates";
            this.Size = new System.Drawing.Size(616, 608);
            this.Load += new System.EventHandler(this.UserControlTrendTemplates_Load);
            this.panel1.ResumeLayout(false);
            this.panel2.ResumeLayout(false);
            this.panel2.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		private LRRApp						_lrrApp;
		private Hashtable _htTemplatesRows = new Hashtable();
        private bool _toSave = false;
        private bool _isIndexChanged = false;

		#endregion


		private void UserControlTrendTemplates_Load(object sender, System.EventArgs e)
		{
			comboBoxNoOfRows.Items.Clear();
			for(int i=1 ;i<=4; i++)
			{
				comboBoxNoOfRows.Items.Add(i.ToString());
			}
			comboBoxNoOfRows.SelectedIndex = 0;

			UserControlTrendTemplateRows templateRow =  new UserControlTrendTemplateRows();
			_htTemplatesRows.Add(1,templateRow);
            templateRow.checkBoxLog.CheckedChanged += new EventHandler(checkBoxLog_CheckedChanged);

            templateRow.labelSeriesColor.BackColorChanged += new EventHandler(labelSeriesColor_BackColorChanged);
            templateRow.labelSymbolColor.BackColorChanged += new EventHandler(labelSeriesColor_BackColorChanged);
			templateRow.Dock = DockStyle.Top;
			templateRow.labelID.Text = LRRHeaderText.GetHeaderString("SID_ROW") + " 1:";
			panel1.Controls.Add(templateRow);

			
			UserControlTrendOptionsRowsHeaders tempHeaders = new UserControlTrendOptionsRowsHeaders();

			tempHeaders.Dock = DockStyle.Top;

			panel1.Controls.Add(tempHeaders);

			LRRTrendTemplates trendTemplates = new LRRTrendTemplates();
			_lrrApp.DBManagerObj.PopulateCollection(trendTemplates);

			foreach(LRRTrendTemplate trendTemplate in trendTemplates)
			{
				comboBoxCreatedTemplates.Items.Add(trendTemplate.Name);
			}
		}

		private void comboBoxNoOfRows_SelectionChangeCommitted(object sender, System.EventArgs e)
		{
            if (_isIndexChanged)
                _toSave = true;
			int noOfRows = comboBoxNoOfRows.SelectedIndex +1 ;
			
			_htTemplatesRows.Clear();
			
			for(int i=1;i<=noOfRows;i++)
			{
				UserControlTrendTemplateRows templateRow =  new UserControlTrendTemplateRows();
				_htTemplatesRows.Add(i,templateRow);
                templateRow.checkBoxLog.CheckedChanged += new EventHandler(checkBoxLog_CheckedChanged);

                templateRow.labelSeriesColor.BackColorChanged += new EventHandler(labelSeriesColor_BackColorChanged);
                templateRow.labelSymbolColor.BackColorChanged += new EventHandler(labelSeriesColor_BackColorChanged);
				templateRow.Dock = DockStyle.Top;
				templateRow.labelID.Text = LRRHeaderText.GetHeaderString("SID_ROW") + " " + i + ":";
			}
			
			panel1.Controls.Clear();
			
			for(int i= noOfRows;i>=1;i--)
			{
				panel1.Controls.Add(_htTemplatesRows[i] as Control);
			}

			UserControlTrendOptionsRowsHeaders tempHeaders = new UserControlTrendOptionsRowsHeaders();

			tempHeaders.Dock = DockStyle.Top;

			panel1.Controls.Add(tempHeaders);

            
		}
		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlTrendTemplates.LeftColMovement implementation
		}

		public void ClearSort()
		{
			// TODO:  Add UserControlTrendTemplates.ClearSort implementation
		}

		public void RightLevel()
		{
			// TODO:  Add UserControlTrendTemplates.RightLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add UserControlTrendTemplates.UpLevel implementation
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsLevel implementation
			return false;
		}

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlTrendTemplates.PerformDirtyChk getter implementation
				return false;
			}
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsRefresh implementation
			return false;
		}

		public void Undo()
		{
			// TODO:  Add UserControlTrendTemplates.Undo implementation
		}

		public bool SupportsCopy()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsCopy implementation
			return false;
		}

		public void SelectionPaste()
		{
			// TODO:  Add UserControlTrendTemplates.SelectionPaste implementation
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add UserControlTrendTemplates.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlTrendTemplates.ParentTabPage setter implementation
			}
		}

		public void PageSetup()
		{
			// TODO:  Add UserControlTrendTemplates.PageSetup implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlTrendTemplates.OpenQuery implementation
		}

		public void Copy()
		{
			// TODO:  Add UserControlTrendTemplates.Copy implementation
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsPageSetup implementation
			return false;
		}

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlTrendTemplates.ShowPropertyList implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsClearSort implementation
			return false;
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlTrendTemplates.RightColMovement implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add UserControlTrendTemplates.LeftLevel implementation
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsDelete implementation
			return false;
		}

		public void PrintPreview()
		{
			// TODO:  Add UserControlTrendTemplates.PrintPreview implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsPaste implementation
			return false;
		}

		public void Print()
		{
			// TODO:  Add UserControlTrendTemplates.Print implementation
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsPrint implementation
			return false;
		}

		public void OpenView()
		{
			// TODO:  Add UserControlTrendTemplates.OpenView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlTrendTemplates.TransposeView implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add UserControlTrendTemplates.ArrangeColumns implementation
		}

		public void Export()
		{
			// TODO:  Add UserControlTrendTemplates.Export implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlTrendTemplates.ShowComponentList implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add UserControlTrendTemplates.ClearFilter implementation
		}

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlTrendTemplates.OpenCompositeView implementation
		}

		public void Delete()
		{
			// TODO:  Add UserControlTrendTemplates.Delete implementation
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsUndo implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsExport implementation
			return false;
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add UserControlTrendTemplates.CopyUOMTypes implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add UserControlTrendTemplates.ImportToExcel implementation
		}

		public void Refresh()
		{
			// TODO:  Add UserControlTrendTemplates.Refresh implementation
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsSelectionPaste implementation
			return false;
		}

		public void DownLevel()
		{
			// TODO:  Add UserControlTrendTemplates.DownLevel implementation
		}

		public void Paste()
		{
			// TODO:  Add UserControlTrendTemplates.Paste implementation
		}

		public bool SupportsSave()
		{
			return true;
		}

		public void InsertNewRows()
		{
			// TODO:  Add UserControlTrendTemplates.InsertNewRows implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add UserControlTrendTemplates.CopyMasterProperties implementation
		}

		public void Save()
		{
            if (_toSave)
            {
                try
                {
                    if (textBoxTemplateName.Text == "")
                    {
                        MessageBox.Show(this, LRRHeaderText.GetHeaderString("TEMPLATE_NAME_BLANK_ERROR"));
                        return;
                    }

                    bool found = false;
                    LRRTrendTemplate trendTemplate = new LRRTrendTemplate();
                    DialogResult dlgRes = DialogResult.Yes;
                    if (comboBoxCreatedTemplates.Items.Contains(textBoxTemplateName.Text))
                    {
                        dlgRes = MessageBox.Show(this, LRRHeaderText.GetHeaderString("TEMPLATE_EXISTS_ERROR"), "Warning", MessageBoxButtons.YesNo);
                        found = true;
                    }
                    if (dlgRes == DialogResult.Yes)
                    {
                        _toSave = false;
                        if (found)
                        {
                            _lrrApp.DBManagerObj.PopulateObject(trendTemplate, typeof(LRRTrendTemplate), " where Name='" + textBoxTemplateName.Text + "'");

                        }

                        int noOfRows = comboBoxNoOfRows.SelectedIndex + 1;

                        TemplateRows templateRows = new TemplateRows();
                        templateRows.TrendSettings = new TrendSetting[noOfRows];
                        templateRows.SingleGraph = checkBoxSameGraph.Checked;
                        templateRows.IsXYGraph = checkBoxXY.Checked;

                        for (int i = 0; i < noOfRows; i++)
                        {
                            TrendSetting trendSetting = templateRows.TrendSettings[i] = new TrendSetting();
                            trendSetting.SchemeName = (i + 1).ToString();

                            UserControlTrendTemplateRows templateRow = _htTemplatesRows[i + 1] as UserControlTrendTemplateRows;
                            
                            
                            trendSetting.SeriesInteriorColor = templateRow.labelSeriesColor.BackColor.ToArgb().ToString();
                            trendSetting.SeriesType = templateRow.comboBoxSeriesStyle.SelectedItem.ToString();
                            trendSetting.SymbolColor = templateRow.labelSymbolColor.BackColor.ToArgb().ToString();
                            trendSetting.SymbolShape = templateRow.comboBoxSymbolShape.SelectedItem.ToString();
                            trendSetting.IsXLog = templateRow.checkBoxLog.Checked;
                        }



                        trendTemplate.Name = textBoxTemplateName.Text;
                        trendTemplate.NoOfRows = noOfRows;
                        

                        MemoryStream memoryStream = new MemoryStream();
                        XmlSerializer xs = new XmlSerializer(typeof(TemplateRows));
                        XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);

                        xs.Serialize(xmlTextWriter, templateRows);
                        memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
                        byte[] buffer = memoryStream.ToArray();

                        trendTemplate.RowsInfo = buffer;
                        if (found)
                        {
                            trendTemplate.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                            _lrrApp.DBManagerObj.CommitObject(trendTemplate);
                            trendTemplate.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                        }
                        _lrrApp.DBManagerObj.CommitObject(trendTemplate);

                        if (!found)
                            comboBoxCreatedTemplates.Items.Add(textBoxTemplateName.Text);

                        OptionsUserControl.saved = true;
                    }

                }
                catch
                {

                }
               
            }
		}

        void labelSeriesColor_BackColorChanged(object sender, EventArgs e)
        {
            _toSave = true;
        }

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add UserControlTrendTemplates.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlTrendTemplates.ParentTabControl setter implementation
			}
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add UserControlTrendTemplates.SupportsCopyUOMTypes implementation
			return false;
		}

		#endregion

		private void comboBoxCreatedTemplates_SelectedIndexChanged(object sender, EventArgs e)
		{
            if (!_isIndexChanged)
                _isIndexChanged = true;
			string templateName = comboBoxCreatedTemplates.SelectedItem.ToString();

			LRRTrendTemplate trendTemplate = new LRRTrendTemplate();
			_lrrApp.DBManagerObj.PopulateObject(trendTemplate,typeof(LRRTrendTemplate)," where Name='" + templateName + "'");

			if(trendTemplate != null)
			{
				if(trendTemplate.NoOfRows != 0)
				{
					textBoxTemplateName.Text = templateName;
					comboBoxNoOfRows.SelectedIndex = trendTemplate.NoOfRows -1;

					MemoryStream memoryStream = new MemoryStream (trendTemplate.RowsInfo);
					XmlSerializer xs = new XmlSerializer(typeof(TemplateRows));
					TemplateRows templateRows = xs.Deserialize(memoryStream) as TemplateRows;
					memoryStream.Close();

                    checkBoxSameGraph.Checked = templateRows.SingleGraph;
                    checkBoxXY.Checked = templateRows.IsXYGraph;
					_htTemplatesRows.Clear();
					for(int i=0;i<trendTemplate.NoOfRows;i++)
					{
						TrendSetting trendSetting = templateRows.TrendSettings[i];
				
						UserControlTrendTemplateRows templateRow = new UserControlTrendTemplateRows();
						
						templateRow.labelID.Text = "Row " + (i+1).ToString() + ":";

						templateRow.checkBoxLog.Checked = trendSetting.IsXLog;
                        
                        try
                        {
                            templateRow.labelSeriesColor.BackColor = Color.FromArgb(int.Parse(trendSetting.SeriesInteriorColor));
                        }
                        catch
                        { 
                        }
                        
						SelectItem(templateRow.comboBoxSeriesStyle,trendSetting.SeriesType.ToString());

                        try
                        {
                            templateRow.labelSymbolColor.BackColor = Color.FromArgb(int.Parse(trendSetting.SymbolColor));
                        }
                        catch
                        { }
                        
						SelectItem(templateRow.comboBoxSymbolShape,trendSetting.SymbolShape.ToString());

                        templateRow.checkBoxLog.CheckedChanged += new EventHandler(checkBoxLog_CheckedChanged);

                        templateRow.labelSeriesColor.BackColorChanged += new EventHandler(labelSeriesColor_BackColorChanged);
                        templateRow.labelSymbolColor.BackColorChanged += new EventHandler(labelSeriesColor_BackColorChanged);
                        templateRow.comboBoxSeriesStyle.SelectedIndexChanged += new EventHandler(comboBoxSeriesStyle_SelectedIndexChanged);
                        templateRow.comboBoxSymbolShape.SelectedIndexChanged += new EventHandler(comboBoxSeriesStyle_SelectedIndexChanged);

						templateRow.Dock = DockStyle.Top;
						_htTemplatesRows.Add(i+1,templateRow);
					}

					panel1.Controls.Clear();
			
					for(int i= trendTemplate.NoOfRows;i>=1;i--)
					{
						panel1.Controls.Add(_htTemplatesRows[i] as Control);
					}

					UserControlTrendOptionsRowsHeaders tempHeaders = new UserControlTrendOptionsRowsHeaders();

					tempHeaders.Dock = DockStyle.Top;

					panel1.Controls.Add(tempHeaders);
				}
			}
            _toSave = false;
		}

        void comboBoxSeriesStyle_SelectedIndexChanged(object sender, EventArgs e)
        {
            _toSave = true;
        }

        void checkBoxLog_CheckedChanged(object sender, EventArgs e)
        {
            _toSave = true;
        }

		public static void SelectItem(ComboBox combo, string item)
		{
			combo.SelectedIndex = combo.Items.IndexOf(item);
		}

        private void checkBoxXY_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxXY.Checked)
            {
                checkBoxSameGraph.Enabled = false;
                comboBoxNoOfRows.SelectedIndex = 0;
                comboBoxNoOfRows_SelectionChangeCommitted(null, null);
                comboBoxNoOfRows.Enabled = false;
            }
            else
            {
                checkBoxSameGraph.Enabled = true;
                comboBoxNoOfRows.Enabled = true;
            }
        }

        private void checkBoxSameGraph_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxSameGraph.Checked)
            {
                checkBoxXY.Enabled = false;
            }
            else
            {
                checkBoxXY.Enabled = true;
            }
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            try
            {
                if (textBoxTemplateName.Text != "")
                {
                    if (comboBoxCreatedTemplates.Items.Contains(textBoxTemplateName.Text))
                    {
                        LRRTrendTemplate trendTemplate = new LRRTrendTemplate();
                        _lrrApp.DBManagerObj.PopulateObject(trendTemplate, typeof(LRRTrendTemplate), " where Name='" + textBoxTemplateName.Text + "'");
                        trendTemplate.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                        _lrrApp.DBManagerObj.CommitObject(trendTemplate);
                        comboBoxCreatedTemplates.Items.Remove(textBoxTemplateName.Text);
                        textBoxTemplateName.Text = "";
                    }
                }
            }
            catch
            {
 
            }
        }

	}

	public class TemplateRows
	{
		public TrendSetting[] TrendSettings
		{
			get
			{ 
				return _trendSettings;
			}
			set 
			{ 
				_trendSettings = value; 
			}
		}
		private TrendSetting[] _trendSettings;

        public bool SingleGraph
        {
            get { return _singleGraph; }
            set { _singleGraph = value; }
        }

        public bool IsXYGraph
        {
            get { return _isXYGraph; }
            set { _isXYGraph = value; }
        }
        private bool _isXYGraph = false;
        private bool _singleGraph = false;
	}
}
