using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlUCFDefinition.
	/// </summary>
	public class UserControlUCFDefinition : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUCF;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barAdd;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barSaveFormula;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barDelete;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barCancel;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel panelUCFD1;
		
		private LRRConstHistMappings _lrrConstHistMappings = null;
		public UserControlUCFDefinition()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_gridExcelFormatter.WireGrid(this.gridUCF); 

			//Initialize the DataSourcce
			InitDataSource();

			//Bind the Grid to DataSource
			BindGridUCFs();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panelUCFD1 = new System.Windows.Forms.Panel();
			this.gridUCF = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barAdd = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barSaveFormula = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barDelete = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barCancel = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.panelUCFD1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridUCF)).BeginInit();
			this.SuspendLayout();
			// 
			// panelUCFD1
			// 
			this.panelUCFD1.Controls.Add(this.gridUCF);
			this.panelUCFD1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelUCFD1.Location = new System.Drawing.Point(0, 0);
			this.panelUCFD1.Name = "panelUCFD1";
			this.panelUCFD1.Size = new System.Drawing.Size(848, 616);
			this.panelUCFD1.TabIndex = 0;
			// 
			// gridUCF
			// 
			this.gridUCF.BackColor = System.Drawing.SystemColors.Window;
			this.gridUCF.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUCF.Location = new System.Drawing.Point(0, 0);
			this.gridUCF.Name = "gridUCF";
			this.gridUCF.Size = new System.Drawing.Size(848, 616);
			this.gridUCF.TabIndex = 1;
			this.gridUCF.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridUCF.TableOptions.AllowSortColumns = true;
			this.gridUCF.Text = "gridGroupingControl1";
			this.gridUCF.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUCF.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUCF.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUCF.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUCF.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUCF.VersionInfo = "3.301.0.0";
			this.gridUCF.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridUCF_RecordDeleting);
			this.gridUCF.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridUCF_TableControlCellClick);
			this.gridUCF.TableControlCurrentCellKeyDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridUCF_TableControlCurrentCellKeyDown);
			this.gridUCF.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridUCF_CurrentRecordContextChange);
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = -1;
			this.barItem1.ID = "";
			// 
			// barAdd
			// 
			this.barAdd.CategoryIndex = -1;
			this.barAdd.ID = "";
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = -1;
			this.barItem2.ID = "";
			// 
			// barSaveFormula
			// 
			this.barSaveFormula.CategoryIndex = -1;
			this.barSaveFormula.ID = "";
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = -1;
			this.barItem3.ID = "";
			// 
			// barDelete
			// 
			this.barDelete.CategoryIndex = -1;
			this.barDelete.ID = "";
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = -1;
			this.barItem4.ID = "";
			// 
			// barCancel
			// 
			this.barCancel.CategoryIndex = -1;
			this.barCancel.ID = "";
			// 
			// UserControlUCFDefinition
			// 
			this.Controls.Add(this.panelUCFD1);
			this.Name = "UserControlUCFDefinition";
			this.Size = new System.Drawing.Size(848, 616);
			this.Tag = "SID_UCF";
			this.panelUCFD1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridUCF)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		
		# region InitDataSource
		/// <summary>
		///	This methods populates the datasource from the Database
		/// </summary>
		private void InitDataSource()
		{
			_lrrUCFs=new LRRUCFs();
			_lrrUCFs = LRRModel.ChildModel.UCFs;

			_lrrConstants = new LRRConstants();
			_lrrConstants = LRRModel.ChildModel.ConstantsDefined;

			_lrrConstHistMappings = new LRRConstHistMappings();
			_lrrConstHistMappings = LRRModel.ChildModel.ConstantMappings;

		}
		#endregion

		#region BindGridUCFs
		/// <summary>
		/// This method binds the grid to the datasource
		/// </summary>
		private void BindGridUCFs()
		{
			//Suspend the Layout of the Grid...
			gridUCF.SuspendLayout();
	
			SyncGridUtilities.InitializeGridLookAndFeel(gridUCF);
			gridUCF.Engine.SourceListSet.Add("ParentTable",_lrrUCFs);
			gridUCF.DataSource = _lrrUCFs;

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridUCF,_lrrUCFs.ItemType,null,true,null);
			
			gridUCF.TableDescriptor.Columns["FromUnit_Name"].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridUCF.TableDescriptor.Columns["FromUnit_Name"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridUCF.TableDescriptor.Columns["FromUnit_Name"].Appearance.AddNewRecordFieldCell.ReadOnly = false;
			gridUCF.TableDescriptor.Columns["FromUnit_Name"].Appearance.AddNewRecordFieldCell.ShowButtons = GridShowButtons.Show;
			gridUCF.TableDescriptor.Columns["FromUnit_Name"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridUCF.TableDescriptor.Columns["FromUnit_Name"].Appearance.AddNewRecordFieldCell.ExclusiveChoiceList = true;
			
			gridUCF.TableDescriptor.Columns["ToUnit_Name"].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridUCF.TableDescriptor.Columns["ToUnit_Name"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridUCF.TableDescriptor.Columns["ToUnit_Name"].Appearance.AddNewRecordFieldCell.ReadOnly = false;
			gridUCF.TableDescriptor.Columns["ToUnit_Name"].Appearance.AddNewRecordFieldCell.ShowButtons = GridShowButtons.Show;
			gridUCF.TableDescriptor.Columns["ToUnit_Name"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridUCF.TableDescriptor.Columns["ToUnit_Name"].Appearance.AddNewRecordFieldCell.ExclusiveChoiceList = true;
			
			gridUCF.TableDescriptor.Columns["ConversionFormulaObj"].Appearance.AddNewRecordFieldCell.CellType = "Static";
			gridUCF.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRRUCF") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   

			gridUCF.TopLevelGroupOptions.ShowFilterBar = true;
			
			//Resume the Layout of the Grid...
			gridUCF.ResumeLayout(false);

			gridUCF.TableDescriptor.CurrentRecordContextChange+=new CurrentRecordContextChangeEventHandler(TableDescriptor_CurrentRecordContextChange);
			
		}

		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BindGridUCFs();
		}

		public void Save()
		{
			LRRFormulas formulas = LRRUCFDataStore.ObjForms.GetChanges();
			if(formulas.Count >0)
				_app.DBManagerObj.CommitCollection(formulas);

			foreach (LRRUCF  lrrUCF in _lrrUCFs)
			{
				if(lrrUCF.ObjectState != DBOperation.DELETE)
				{
					string fromUnit = lrrUCF.FromUnit  == null ? "" : lrrUCF.FromUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					string toUnit = lrrUCF.ToUnit  == null ? "" : lrrUCF.ToUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);

					if(fromUnit=="") 
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_FROMUNIT_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
					if(toUnit=="") 
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_TOUNIT_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}

				}

			}
			LRRUCFs toSaveUCFs = _lrrUCFs.GetChanges();
			
			if(toSaveUCFs.Count > 0)
			{
				foreach(LRRUCF objUCF in toSaveUCFs)
				{
					if(objUCF.ObjectState != DBOperation.DELETE)
					{
						bool blnMatchFound = false;
						string sUCFID = objUCF.ID == null ? "" : objUCF.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string sFromUnit = objUCF.FromUnit == null ? "" : objUCF.FromUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string sToUnit = objUCF.ToUnit == null ? "" : objUCF.ToUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string sUOMCombKey = sFromUnit + "|" + sToUnit;
						LRRUCF matchedUcf = _lrrUCFs.GetUCFByFromToComb(sUOMCombKey);
                        if (matchedUcf != null)
                        {
                            blnMatchFound = true;
                        }
                        //foreach(LRRUCF objFoundMatchUCF in objUCFs)
                        //{
                        //    if(objFoundMatchUCF.ID != sUCFID)
                        //    {
                        //        blnMatchFound = true;
                        //        break;
                        //    }
                        //}
						if(blnMatchFound)
						{
							LRRMessagBox.ShowMessage("SID_UCF_DUPLICATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
							return;

						}
					}
				}
                foreach (LRRUCF ucf in toSaveUCFs)
                {
                    if (ucf.ObjectState != DBOperation.UNCHANGED)
                    {
                        try
                        {
                            string fromName = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(ucf.FromUnit).Name;
                            string toName = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(ucf.ToUnit).Name;
                            if (ucf.ObjectState == DBOperation.INSERT)
                            {
                                MessagingClient.RaiseAlert("New UCF: '" + fromName + "' to '" + toName + "' added.");
                            }
                            if (ucf.ObjectState == DBOperation.DELETE)
                            {
                                MessagingClient.RaiseAlert("UCF: '" + fromName + "' to '" + toName + "' deleted.");
                            }
                            if (ucf.ObjectState == DBOperation.UPDATE)
                            {
                                MessagingClient.RaiseAlert("UCF: '" + fromName + "' to '" + toName + "' updated.");
                            }
                        }
                        catch(Exception ex)
                        {
                            Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(UserControlUCFDefinition), "Exception on adding alert:" + ex.Message, Symcon.Utils.MessageLogger.Logger.Level.Debug);
                        }
                    }
                }
				_app.DBManagerObj.CommitCollection(toSaveUCFs);
				OptionsUserControl.saved=true;
			}
			
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridUCF.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUCF,false);
			}

		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridUCF);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region Fields

		private LRRApp						_app;
		private LRRUCFs						_lrrUCFs  = new LRRUCFs();
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		private LRRConstants							_lrrConstants;
		private GridExcelFormatter	_gridExcelFormatter = new GridExcelFormatter(); 
		#endregion

		private void gridUCF_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
			GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
			if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
			{
				return;
			}

			if(e.TableControl.CurrentCell.RowIndex == -1 || e.TableControl.CurrentCell.ColIndex == -1)
				return;

			GridTableModel tableModel = gridUCF.Table.TableModel;
			if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_CONVERSIONFORMULA"))
			{
				string fromUOMID = e.TableControl.Table.CurrentRecord.GetValue("FromUnit") == null ? "" : e.TableControl.Table.CurrentRecord.GetValue("FromUnit").ToString();
				string fromUOM = "";
				if(fromUOMID.Trim() != "")
					fromUOM = LRRModel.ChildModel.GetUOMNameFromID(fromUOMID);
				LRRUCFDataStore.FromUOM = fromUOM;

				string toUOMID = e.TableControl.Table.CurrentRecord.GetValue("ToUnit") == null ? "" : e.TableControl.Table.CurrentRecord.GetValue("ToUnit").ToString();
				string toUOM = "";
				if(toUOMID.Trim() != "")
					toUOM = LRRModel.ChildModel.GetUOMNameFromID(toUOMID);
				LRRUCFDataStore.ToUOM  = toUOM;

				string isDynamicID = e.TableControl.Table.CurrentRecord.GetValue("IsDynamic") == null ? "" : e.TableControl.Table.CurrentRecord.GetValue("IsDynamic").ToString();
				if(isDynamicID.Trim() == "True")
					LRRUCFDataStore.IsDynamic = true;
				else
					LRRUCFDataStore.IsDynamic=false;
		
				LRRUCFDataStore.SourceObject = e.TableControl.Table.CurrentRecord.GetData();

				LRRConstants objUserCons = new LRRConstants();
				LRRConstants objModelCons = new LRRConstants();

				//Form the user/modes constants list
				foreach(LRRConstant objCons in _lrrConstants)
				{
					//if user
					if(objCons.InputSourceID == "1")
					{
						objUserCons.Add(objCons);
					}
					else if(objCons.InputSourceID == "2")
					{
						objModelCons.Add(objCons);
					}

				}
				//LRRUCFDataStore.IsDynamic
				LRRUCFDataStore.LRRConstModel = objModelCons;
				LRRUCFDataStore.LRRConstUser = objUserCons;
				SetFormulaDataStrore();
			}
		}

		private void TableDescriptor_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
		{
			if(e.Action == CurrentRecordAction.EnterRecordComplete)
			{
				string fromUOMID = e.Record.GetRecord().GetValue("FromUnit") == null ? "" : e.Record.GetRecord().GetValue("FromUnit").ToString();
				string fromUOM = "";
				if(fromUOMID.Trim() != "")
					fromUOM = LRRModel.ChildModel.GetUOMNameFromID(fromUOMID);
				LRRUCFDataStore.FromUOM = fromUOM;

				string toUOMID = e.Record.GetRecord().GetValue("ToUnit") == null ? "" : e.Record.GetRecord().GetValue("ToUnit").ToString();
				string toUOM = "";
				if(toUOMID.Trim() != "")
					toUOM = LRRModel.ChildModel.GetUOMNameFromID(toUOMID);
				LRRUCFDataStore.ToUOM  = toUOM;

				string isDynamicID = e.Record.GetRecord().GetValue("IsDynamic") == null ? "" : e.Record.GetRecord().GetValue("IsDynamic").ToString();
				if(isDynamicID.Trim() == "True")
					LRRUCFDataStore.IsDynamic = true;
				else
					LRRUCFDataStore.IsDynamic=false;
				

				LRRUCFDataStore.SourceObject = e.Record.GetRecord().GetData();

				LRRConstants objUserCons = new LRRConstants();
				LRRConstants objModelCons = new LRRConstants();

				//Form the user/modes constants list
				foreach(LRRConstant objCons in _lrrConstants)
				{
					//if user
					if(objCons.InputSourceID == "1")
					{
						objUserCons.Add(objCons);
					}
					else if(objCons.InputSourceID == "2")
					{
						objModelCons.Add(objCons);
					}

				}
				//LRRUCFDataStore.IsDynamic
				LRRUCFDataStore.LRRConstModel = objModelCons;
				LRRUCFDataStore.LRRConstUser = objUserCons;
				LRRUCFDataStore.IsUCF = true;
			}

			if(e.Action == CurrentRecordAction.EndEditCalled)
			{
				Record rec = e.Record as Record;
				if(rec != null)
				{
					//ToUnit Validation
					object toUnit = rec.GetValue("ToUnit");
					if(toUnit == null)
					{
						LRRMessagBox.ShowMessage("SID_TOUNIT_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						e.Cancel = true;
					}
					
					//FromUnit Validation
					object fromUnit = rec.GetValue("FromUnit");
					if(fromUnit == null)
					{
						LRRMessagBox.ShowMessage("SID_FROMUNIT_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						e.Cancel = true;
					}
				}
			}
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridUCF);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion

		private void gridUCF_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{

		}

		private void gridUCF_TableControlCurrentCellKeyDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventArgs e)
		{
		}


		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion		

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlUCFDefinition.PrintPreview implementation
			if(gridUCF.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUCF,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlUCFDefinition.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlUCFDefinition.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlUCFDefinition.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlUCFDefinition.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlUCFDefinition.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlUCFDefinition.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlUCFDefinition.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlUCFDefinition.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlUCFDefinition.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlUCFDefinition.SupportsCompositeView implementation
			return false;
		}

		#endregion



		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridUCF_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
				return;
			}
		}

		public void SetFormulaDataStrore()
		{
			LRRUCFDataStore.IsUCF = true;
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlUCFDefinition.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
