using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlUOMDefinition.
	/// </summary>
	public class UserControlUOMDefinition : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp						_app;
		private LRRUOMs		_lrrUOMs=null;
		private LRROptions						_lrrOptionsObj;
		private Symcon.Database.DBManager							_dbManager; //Instance of the DBManager used by the APP.
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		bool isSaved = false;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUOMDefinition;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlUOMDefinition()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrOptionsObj = _app.GetOptions() as LRROptions;
			_dbManager = _app.DBManagerObj;

			InitDataSource();
			SyncGridUtilities.InitializeGridLookAndFeel(gridUOMDefinition);
			BindGridUOMDefinition();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridUOMDefinition = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridUOMDefinition)).BeginInit();
			this.SuspendLayout();
			// 
			// gridUOMDefinition
			// 
			this.gridUOMDefinition.BackColor = System.Drawing.SystemColors.Window;
			this.gridUOMDefinition.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUOMDefinition.Location = new System.Drawing.Point(0, 0);
			this.gridUOMDefinition.Name = "gridUOMDefinition";
			this.gridUOMDefinition.Size = new System.Drawing.Size(736, 488);
			this.gridUOMDefinition.TabIndex = 6;
			this.gridUOMDefinition.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridUOMDefinition.Text = "gridGroupingControl1";
			this.gridUOMDefinition.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUOMDefinition.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridUOMDefinition.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUOMDefinition.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUOMDefinition.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUOMDefinition.VersionInfo = "3.301.0.0";
			this.gridUOMDefinition.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridUOMDefinition_RecordDeleting);
			this.gridUOMDefinition.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridUOMDefinition_TableControlPrepareViewStyleInfo);
			this.gridUOMDefinition.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridUOMDefinition_QueryCellStyleInfo);
			// 
			// UserControlUOMDefinition
			// 
			this.Controls.Add(this.gridUOMDefinition);
			this.Name = "UserControlUOMDefinition";
			this.Size = new System.Drawing.Size(736, 488);
			this.Tag = "SID_UOMDEFN";
			((System.ComponentModel.ISupportInitialize)(this.gridUOMDefinition)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region BindGridUOMDefinition

		private void BindGridUOMDefinition()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUOMDefinition.SuspendLayout();

			SyncGridUtilities.InitializeGridColumns(gridUOMDefinition,gridUOMDefinition.TableDescriptor,_lrrUOMs.ItemType,null,true,null,null,true);
			gridUOMDefinition.DataSource = _lrrUOMs;
			gridUOMDefinition.TableDescriptor.AllowNew = true;
			gridUOMDefinition.TableDescriptor.AllowRemove = true;
			gridUOMDefinition.TableDescriptor.AllowEdit = true;
			gridUOMDefinition.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_UOMS") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   
//			RelativeWidths.Add("Name",50);
//			RelativeWidths.Add("Description",70);
//			SyncGridUtilities.InitializeGridColumnsWidth(gridUOMDefinition,RelativeWidths );
			//Resume the Layout of the Grid...
			gridUOMDefinition.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridUOMDefinition.Engine.SourceListSet.Add("ParentTable",_lrrUOMs);
			this.gridUOMDefinition.TableModel.Model.HideCols["Base"]=true;

			string[,] arry=new string[,]{{LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"255"}};
			Validations	obj=new Validations(gridUOMDefinition,arry);
		}

		#endregion
		# region InitDataSource
		private void InitDataSource()
		{
			_lrrUOMs=new LRRUOMs();
			_lrrUOMs=LRRModel.ChildModel.UOMs;
			//_app.DBManagerObj.PopulateCollection(_lrrUOMs,false);
		}
		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BindGridUOMDefinition();

		}

		public void Save()
		{
			//***************UOMDefinition************************

			foreach (LRRUOM  lrrUOM in _lrrUOMs)
			{
				string sName = lrrUOM.Name  == null ? "" : lrrUOM.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				string sUOMID = lrrUOM.ID == null ? "" : lrrUOM.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

				if(sName=="") 
				{
					LRRMessagBox.ShowMessage("SID_SAVEABORT_UOM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					return;
				}

				foreach (LRRUOM  objUOM in _lrrUOMs)
				{
					if((objUOM.ID != sUOMID) && (objUOM.ObjectState != DBOperation.DELETE))
					{
						string sUOMName = objUOM.Name  == null ? "" : objUOM.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if(sUOMName.ToUpper() == sName.ToUpper())
						{
							//MessageBox.Show("UOM name - " + sUOMName + " already exists. Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
							string[] s = new string[1];
							s[0] = sUOMName;
							LRRMessagBox.ShowMessage("SID_PROP_DUPLICATE","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);     
							return;
						}
					}
				}
			}
			if(_lrrUOMs.GetChanges().Count>0)
			{
                foreach (LRRUOM uom in _lrrUOMs.GetChanges())
                {
                    if (uom.ObjectState == DBOperation.INSERT)
                    {
                        MessagingClient.RaiseAlert("New UOM: " + uom.Name + " added.");
                    }
                    if (uom.ObjectState == DBOperation.DELETE)
                    {
                        MessagingClient.RaiseAlert("UOM: " + uom.Name + " deleted.");
                    }
                    if (uom.ObjectState == DBOperation.UPDATE)
                    {
                        MessagingClient.RaiseAlert("UOM: " + uom.Name + " updated.");
                    }
                }
				_app.DBManagerObj.CommitCollection(_lrrUOMs.GetChanges());
				OptionsUserControl.saved	=true;
			}
				if(_lrrUOMs.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{

					_lrrUOMs.RefreshCollection();

				}


			InitDataSource();
			BindGridUOMDefinition();
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridUOMDefinition.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOMDefinition,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridUOMDefinition);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion


		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridUOMDefinition_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			LRRUOM lrrUOM=gridUOMDefinition.CurrencyManager.Current as LRRUOM;
			if(lrrUOM.Base==true)
			{
				e.Cancel=true;
			}
			else
			{
				if(_isDeletePress)
				{
					DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
					if(_dlgResult == DialogResult.Yes)
					{
						_isRecordeDel = true; 
					}
					else
					{
						_isRecordeDel = false; 
					}
					_isDeletePress = false;
				}
				if(!_isRecordeDel)
				{
					e.Cancel = true;
					return;
				}
			}
		}

		private void gridUOMDefinition_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
//			int i=gridUOMDefinition.TableDescriptor.Columns.IndexOf("Base");
//			if(e.Inner.RowIndex > 2 && e.Inner.ColIndex > 0)
//			{
//				if(this.gridUOMDefinition.TableModel.Model[e.Inner.RowIndex,i+1].CellType=="CheckBox")
//				{
//					object o = this.gridUOMDefinition.TableModel.Model[e.Inner.RowIndex,i+1].CellValue;
//					if(o!=null)
//					{
//						bool val = o.ToString() == true.ToString();
//						if(val)
//						{
//							e.Inner.Style.CellType="Static";
//							e.Inner.Style.BackColor = Color.LightGray;
//						}
//					}
//				}
//			}
		}
		private void gridUOMDefinition_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.RowIndex!=-1) 
			{
				if(e.TableCellIdentity.DisplayElement is GridRecordRow)
				{
					LRRUOM obj  = e.TableCellIdentity.DisplayElement.ParentRecord.GetData() as LRRUOM; 
					if(obj!=null)
					{
						if(obj.Base==true)
						{
							if(e.TableCellIdentity.ColIndex > 0)
							{
								e.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.LightGray);
								e.Style.ReadOnly=true;
							}
						}
					}
				}
			}
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridUOMDefinition);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlUOMDefinition.PrintPreview implementation
			if(gridUOMDefinition.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOMDefinition,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlUOMDefinition.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlUOMDefinition.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlUOMDefinition.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlUOMDefinition.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlUOMDefinition.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlUOMDefinition.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlUOMDefinition.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlUOMDefinition.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlUOMDefinition.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlUOMDefinition.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlUOMDefinition.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
