using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.MessageService;
using Symcon.Utils.HeaderDispatcher;


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for OptionalInput.
	/// </summary>
	public class UserDataHistorianPoints : System.Windows.Forms.Form,ILRRUIContainer
	{

		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private System.Windows.Forms.Panel pnlHistorianData;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridHistorianData;
		private System.Windows.Forms.ContextMenu gridContext;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.GroupBox groupBoxUOMs;
		private System.Windows.Forms.RadioButton rdDefaultToInterfaceUOM;
		private System.Windows.Forms.RadioButton rdDefaultToModelUOM;
		private System.Windows.Forms.ToolTip toolTip2;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.ComponentModel.IContainer components;
	
		[DllImport("User32")] 
 
		private static extern bool SendMessage(IntPtr hWnd, int msg, int wParam, int lParam); 
		private const int WM_SETREDRAW = 0xB; 
		private	GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		private DuplicateValidation _duplicateChk = new DuplicateValidation(); 
		public UserDataHistorianPoints()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Get the App Object
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

		 	//Populate HistData from Model
		 	_lrrUserHistData = LRRModel.UserHistDatas; 
		 	lrrFormulaHistData.Add(0,_lrrUserHistData);
			lrrFormulaHistData.Add(1,"Historian Data");
			LRRFormulaDataStore.DataSource = lrrFormulaHistData;
			LRRFormulaDataStore.ModeFlag = false;
			LRRFormulaDataStore.ShowGroupedAttributes = false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;
			_gridExcelFormatter.WireGrid(gridHistorianData);
			_duplicateChk.ChkDuplicate(gridHistorianData,"HistTagUID",null,"HistTag",null,null);  
			InitializeGridWithData();	
			InitDataSource();

			this.Activated+=new EventHandler(DataHistorianPoints_Activated);
			
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(UserDataHistorianPoints));
			this.pnlHistorianData = new System.Windows.Forms.Panel();
			this.gridHistorianData = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridContext = new System.Windows.Forms.ContextMenu();
			this.panel1 = new System.Windows.Forms.Panel();
			this.groupBoxUOMs = new System.Windows.Forms.GroupBox();
			this.rdDefaultToInterfaceUOM = new System.Windows.Forms.RadioButton();
			this.rdDefaultToModelUOM = new System.Windows.Forms.RadioButton();
			this.toolTip2 = new System.Windows.Forms.ToolTip(this.components);
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.pnlHistorianData.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridHistorianData)).BeginInit();
			this.panel1.SuspendLayout();
			this.groupBoxUOMs.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlHistorianData
			// 
			this.pnlHistorianData.Controls.Add(this.gridHistorianData);
			this.pnlHistorianData.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlHistorianData.Location = new System.Drawing.Point(0, 32);
			this.pnlHistorianData.Name = "pnlHistorianData";
			this.pnlHistorianData.Size = new System.Drawing.Size(896, 270);
			this.pnlHistorianData.TabIndex = 25;
			// 
			// gridHistorianData
			// 
			this.gridHistorianData.BackColor = System.Drawing.SystemColors.Window;
			this.gridHistorianData.ContextMenu = this.gridContext;
			this.gridHistorianData.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridHistorianData.Location = new System.Drawing.Point(0, 0);
			this.gridHistorianData.Name = "gridHistorianData";
			this.gridHistorianData.Size = new System.Drawing.Size(896, 270);
			this.gridHistorianData.TabIndex = 18;
			this.gridHistorianData.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridHistorianData.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridHistorianData.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridHistorianData.TableOptions.DefaultColumnWidth = 150;
			this.gridHistorianData.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
			this.gridHistorianData.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridHistorianData.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridHistorianData.Text = "gridGroupingControl1";
			this.gridHistorianData.ThemesEnabled = false;
			this.gridHistorianData.TopLevelGroupOptions.CaptionText = "Historian Points : {RecordCount} Items";
			this.gridHistorianData.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridHistorianData.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridHistorianData.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridHistorianData.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridHistorianData.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridHistorianData.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridHistorianData.VersionInfo = "3.301.0.0";
			this.gridHistorianData.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(this.gridHistorianData_TableControlCurrentCellCloseDropDown);
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.ControlDark;
			this.panel1.Controls.Add(this.groupBoxUOMs);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(896, 32);
			this.panel1.TabIndex = 26;
			// 
			// groupBoxUOMs
			// 
			this.groupBoxUOMs.BackColor = System.Drawing.Color.Transparent;
			this.groupBoxUOMs.Controls.Add(this.rdDefaultToInterfaceUOM);
			this.groupBoxUOMs.Controls.Add(this.rdDefaultToModelUOM);
			this.groupBoxUOMs.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.groupBoxUOMs.Location = new System.Drawing.Point(2, -2);
			this.groupBoxUOMs.Name = "groupBoxUOMs";
			this.groupBoxUOMs.Size = new System.Drawing.Size(328, 32);
			this.groupBoxUOMs.TabIndex = 22;
			this.groupBoxUOMs.TabStop = false;
			// 
			// rdDefaultToInterfaceUOM
			// 
			this.rdDefaultToInterfaceUOM.ForeColor = System.Drawing.Color.White;
			this.rdDefaultToInterfaceUOM.Location = new System.Drawing.Point(168, 8);
			this.rdDefaultToInterfaceUOM.Name = "rdDefaultToInterfaceUOM";
			this.rdDefaultToInterfaceUOM.Size = new System.Drawing.Size(152, 24);
			this.rdDefaultToInterfaceUOM.TabIndex = 20;
			this.rdDefaultToInterfaceUOM.Tag = "SID_DEFAULT_INTERDACE_UOM";
			this.rdDefaultToInterfaceUOM.CheckedChanged += new System.EventHandler(this.rdDefaultToInterfaceUOM_CheckedChanged);
			// 
			// rdDefaultToModelUOM
			// 
			this.rdDefaultToModelUOM.ForeColor = System.Drawing.Color.White;
			this.rdDefaultToModelUOM.Location = new System.Drawing.Point(8, 8);
			this.rdDefaultToModelUOM.Name = "rdDefaultToModelUOM";
			this.rdDefaultToModelUOM.Size = new System.Drawing.Size(152, 24);
			this.rdDefaultToModelUOM.TabIndex = 21;
			this.rdDefaultToModelUOM.Tag = "SID_DEFAULT_MODEL_UOM";
			this.rdDefaultToModelUOM.CheckedChanged += new System.EventHandler(this.rdDefaultToModelUOM_CheckedChanged);
			// 
			// UserDataHistorianPoints
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(896, 302);
			this.Controls.Add(this.pnlHistorianData);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "UserDataHistorianPoints";
			this.Tag = "520";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.pnlHistorianData.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridHistorianData)).EndInit();
			this.panel1.ResumeLayout(false);
			this.groupBoxUOMs.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


		#region Private Methods

		private void DisableContextMenuItems()
		{
			gridContext.MenuItems.Clear();

			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_CHOOSE_COLUMNS"),new EventHandler(ChooseColumns)));
		}

		private void EnableContextMenuItems()
		{
			gridContext.MenuItems.Clear();

			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_CHOOSE_COLUMNS"),new EventHandler(ChooseColumns)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_OVERRIDE_HIST_DATA"),new EventHandler(Override)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_SITE_COMP_MAPPING"),new EventHandler(ViewSiteComponentProperty)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_TREND"), new EventHandler(ViewTrends)));
			gridContext.MenuItems.Add(new MenuItem(LRRHeaderText.GetHeaderString("SID_VIEW_TREND_ALL_TUNNING_DATA"), new EventHandler(ViewAllTrends)));
		}

		/// <summary>
		/// Method used to initialize the grid with the data from the Historian...
		/// </summary>
		private void InitializeGridWithData()
		{
			gridHistorianData.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridHistorianData);
			gridHistorianData.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_HIST_POINTS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
	 		Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrUserHistData.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
	 		SyncGridUtilities.InitializeGridColumns(gridHistorianData,_lrrUserHistData.ItemType,null,fkData);

	 		gridHistorianData.DataSource = _lrrUserHistData;
			gridHistorianData.SourceListSet.Add("HistDatas",_lrrUserHistData);
		 	gridHistorianData.TableDescriptor.Columns.Remove(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE"));
			gridHistorianData.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_INTERNAL_INTERFACEVALUE"),"InterfaceValue");
			gridHistorianData.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_INTERNAL_INTERFACEVALUE")].Appearance.AnyRecordFieldCell.ReadOnly = true;

			gridHistorianData.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE"),"DisplayInterfaceValue");
			gridHistorianData.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE")].ReadOnly = true;
			gridHistorianData.TableDescriptor.Columns.Add("ModelUOM","ModelUOM");
			LRRUOMs lrrUOMs = LRRModel.ChildModel.UOMs;
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.DataSource = lrrUOMs;
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].HeaderText=LRRHeaderText.GetHeaderString("SID_MODELUOM");
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.DisplayMember = "Name";
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ValueMember = "ID";
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ReadOnly = true;
			
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			
			/*
			LRRModes lrrModes = LRRModel.ProjectModes;
			gridHistorianData.TableDescriptor.Columns.Add("Modes","ModePermission");
			gridHistorianData.TableDescriptor.Columns["Modes"].Appearance.AnyRecordFieldCell.DataSource= lrrModes;
			gridHistorianData.TableDescriptor.Columns["Modes"].HeaderText=LRRHeaderText.GetHeaderString("SID_MODENAME");
			gridHistorianData.TableDescriptor.Columns["Modes"].Appearance.AnyRecordFieldCell.CellType= "ComboBox";
			gridHistorianData.TableDescriptor.Columns["Modes"].Appearance.AnyRecordFieldCell.DisplayMember="ModeName";
			gridHistorianData.TableDescriptor.Columns["Modes"].Appearance.AnyRecordFieldCell.ValueMember="ModeId";*/
//			gridHistorianData.TableDescriptor.Columns["Modes"].Appearance.AnyRecordFieldCell.ReadOnly=true;			
//			gridHistorianData.TableDescriptor.Columns["Modes"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList=false;
//			gridHistorianData.TableDescriptor.Columns["Modes"].Width = 150;

			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistTag")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("PlantUnit_Name")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("GeneralDesc")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("EquipTag")].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ServerID") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
		 	gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistDesc") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("DataQuality") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("MeasType") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("MeterOnOffStatusFlag") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ComplexEquipOnOff") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("FilterSelection") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ActiveFilterReturnValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("AverageValueForPeriodEntered") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("LastValidAverageValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("CalibrationFactor") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("StartOfPeriodValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("EndOfPeriodValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("SpotValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ValidRangeLowerLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ValidRangeUpperLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("OnOffThresholdLowerLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("OnOffThresholdUpperLimit") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("OffConditionSubstituteValue") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("FinalValueWithoutOverrides") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("FormulaObj") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("TagImportanceID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ActionsID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("StatusID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ConditionID_Type") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("Comments") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("PreFilterUserOverride") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistUnits") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("HistUnitStringFromDH") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ConversionFormulaObj") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ErrorStatus") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("PostFilterUserOverride") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);

			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("UOMTypeID_Name") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ModelUOM") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("InterfaceUnits") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE")) ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf(LRRHeaderText.GetHeaderString("SID_INTERNAL_INTERFACEVALUE")) ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(204,255,204);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("CustomFormulaObj") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns[gridHistorianData.TableDescriptor.Columns.IndexOf("ModeID_ModeName") ].Appearance.AnyRecordFieldCell.BackColor=Color.FromArgb(255,255,255);
			gridHistorianData.TableDescriptor.Columns["InterfaceUnits"].AllowFilter = false;     
			gridHistorianData.TableDescriptor.Columns["HistUnits"].AllowFilter = false;   
			gridHistorianData.TableDescriptor.Columns["ModelUOM"].AllowFilter = false;  

			// registration for Tree Control for Plant levels....
			gridHistorianData.TableModel.CellModels.Add("DropDownTree",new PlantLevelUserFormTreeControl(this.gridHistorianData.TableModel,new PlantLevelTreeControlStructure()));         
			gridHistorianData.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridHistorianData_QueryCellStyleInfo);
			

	 		gridContext.Popup +=new EventHandler(gridContext_Popup);
			gridHistorianData.ResumeLayout(false);

			string[,] arry=new string[,]{{"GeneralDesc","255"},{"HistDesc","255"},{"Comments","255"}};
			Validations	objValidations=new Validations(gridHistorianData,arry);

		}

		private void InitDataSource()
		{
			if(_lrrProjConfigs != null)
				_lrrProjConfigs.Clear();
			if(_lrrMeasSystemDefs != null)
				_lrrMeasSystemDefs.Clear();
			if(_levels!= null)
				_levels.Clear(); 

			_lrrProjConfigs = new LRRProjectConfigurations();
			_app.DBManagerObj.PopulateCollection(_lrrProjConfigs,false);

			_lrrMeasSystemDefs = new LRRMeasurementSystemDefinitions();
			_app.DBManagerObj.PopulateCollection(_lrrMeasSystemDefs,false);

			_levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(_levels,false);  
		}

		#endregion

		#region Fields

	 	private LRRUserHistDatas					_lrrUserHistData;//Local Storage for Data Historian acting as datasource
		private LRRApp							_app; //App Instance...
		private LRRUIManager					lrrUI;
		private bool							isSaved =  false;
		private ArrayList						duplicateData =new ArrayList();  
		Hashtable lrrFormulaHistData = new Hashtable();

		private LRRProjectConfigurations _lrrProjConfigs; 
		private LRRMeasurementSystemDefinitions	 _lrrMeasSystemDefs;

		private string interfaceVal="";
		private LRRLevels									_levels;
		#endregion

		#region EventHandlers


		private void ChooseColumns(object sender,EventArgs e)
		{
			_ShowGridColumnsDialog(this.gridHistorianData.Engine.TableDescriptor, "Columns", null, typeof(GridColumnDescriptorCollection));
		}

		private void Override(object sender,EventArgs e)
		{
			Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
			GridRecord gnt = eCurrentElement as GridRecord;
			LRRHistData objHistData = eCurrentElement.GetRecord().GetData() as LRRHistData;
					
			//e.TableCellIdentity.Table.GetRecord().GetData()
			LRRHistDataUserAndTimes objHistDataOverrides =new LRRHistDataUserAndTimes();
			_app.DBManagerObj.PopulateCollection(objHistDataOverrides," WHERE HistTagUID ='" + objHistData.HistTagUID + "'");
			if(objHistDataOverrides.Count == 0 )
			{
				objHistDataOverrides.Add(ConverHistDataToHistDataOverride(objHistData));
			}
			DataHistorianPointOverrides amp = new DataHistorianPointOverrides(objHistDataOverrides);
			amp.Text = amp.Text + " [" + objHistData.HistTag + "]";
			amp.ShowDialog(this);
		}
		private void ViewSiteComponentProperty(object sender,EventArgs e)
		{
			try
			{
				Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
				GridRecord gnt = eCurrentElement as GridRecord;
				LRRHistData objHistData = eCurrentElement.GetRecord().GetData() as LRRHistData;
					
				LRRHistPropCompPropMappings objHistDataCompPropMappings =new LRRHistPropCompPropMappings();

				_app.DBManagerObj.PopulateCollection(objHistDataCompPropMappings," WHERE HistPropID ='" + objHistData.HistTagUID + "'");

				string sSiteCompPropertiesID = "";
				string sGroupPropertyID = ""; 

				foreach (LRRHistPropCompPropMapping objHistDataCompPropMapping in objHistDataCompPropMappings)
				{
					if(objHistDataCompPropMapping.SiteComponentPropID.ToString(Symcon.BusinessObjects.SymConverter.Culture) != "")
					{
						if(sSiteCompPropertiesID == "")
							sSiteCompPropertiesID = "'" + objHistDataCompPropMapping.SiteComponentPropID + "'";
						else
							sSiteCompPropertiesID = sSiteCompPropertiesID  + ",'" + objHistDataCompPropMapping.SiteComponentPropID + "'";
					}
				
					if(objHistDataCompPropMapping.GroupPropertyID != null)
					{
						if(objHistDataCompPropMapping.GroupPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture) != "")
						{
							if(sGroupPropertyID == "")
								sGroupPropertyID = "'" + objHistDataCompPropMapping.GroupPropertyID + "'";
							else
								sGroupPropertyID = sGroupPropertyID  + ",'" + objHistDataCompPropMapping.GroupPropertyID + "'";
						}
					}
				}
			
				LRRSiteComponentProperties objSiteComponentProperties =new LRRSiteComponentProperties();
			
				if(sSiteCompPropertiesID != "")
					_app.DBManagerObj.PopulateCollection(objSiteComponentProperties," WHERE SiteComponentPropID IN (" + sSiteCompPropertiesID + ")");


				LRRSiteComponentGroupProperties objSiteComponentGroupProperties =new LRRSiteComponentGroupProperties();
			
				if(sGroupPropertyID != "")
					_app.DBManagerObj.PopulateCollection(objSiteComponentGroupProperties," WHERE GroupPropertyID IN (" + sGroupPropertyID + ")");
			
				int i = objSiteComponentGroupProperties.Count + objSiteComponentProperties.Count;

				ArrayList objSiteComponents = new ArrayList(i);

				IEnumerator iSiteComponentPropertiesEnum	= objSiteComponentProperties.GetEnumerator();
				while(iSiteComponentPropertiesEnum.MoveNext())
				{
					LRRSiteComponentProperty objLRRSiteComponentProperty= (LRRSiteComponentProperty)iSiteComponentPropertiesEnum.Current;
					HistorianProps objHistorianProps = new HistorianProps(objLRRSiteComponentProperty.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture),"");
					objSiteComponents.Add(objHistorianProps);
				}

				IEnumerator iSiteComponentGroupPropsEnum	= objSiteComponentGroupProperties.GetEnumerator();
				while(iSiteComponentGroupPropsEnum.MoveNext())
				{
					LRRSiteComponentGroupProperty objLRRSiteComponentGroupProperty= (LRRSiteComponentGroupProperty)iSiteComponentGroupPropsEnum.Current;
					HistorianProps objHistorianProps = new HistorianProps(objLRRSiteComponentGroupProperty.AttributeName.ToString(Symcon.BusinessObjects.SymConverter.Culture) + " [Grouped Property]","");
					objSiteComponents.Add(objHistorianProps);
				}
				if(objSiteComponents.Count == 0)
				{
					LRRMessagBox.ShowMessage("SID_MAPPEDPROPERTIES_DOESNOTEXIST","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);  
					return;
				}
                DataHistorianPointProperties amp = new DataHistorianPointProperties(objSiteComponents, objHistData.HistTag);
				amp.Text = amp.Text + " [" + objHistData.HistTag + "]";
				amp.ShowDialog(this);
			}
			catch(Exception)
			{
			}
		}

		private void ViewTrends(object sender,EventArgs e)
		{
			ShowTrends(false);
		}

		private void ViewAllTrends(object sender,EventArgs e)
		{
			ShowTrends(true);
		}

		#endregion

		#region Private Methods

		private void ShowTrends(bool showAll)
		{
			Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
			GridRecord gnt = eCurrentElement as GridRecord;
			LRRHistData objHistData = eCurrentElement.GetRecord().GetData() as LRRHistData;

			if(objHistData != null)
			{
				if(objHistData.HistTag!=null)
				{
					string key;
					if(showAll)
					{
						key = "HistTrend(All):" + objHistData.HistTag;
					}
					else
					{
						key = "HistTrend:" + objHistData.HistTag;
					}
					if(_app.LRRUIManagerObj._windowStore.ContainsKey(key))
					{
						ILRRUIContainer cont = _app.LRRUIManagerObj._windowStore[key] as ILRRUIContainer;
						cont.Refresh();
						Form frm = cont as Form;
						frm.Activate();
					}
					else
					{
						HistTrends._arrHistTags = new ArrayList();
						for(int i=0;i<gridHistorianData.TableControl.Table.Elements.Count;i++)
						{
							if(gridHistorianData.TableControl.Table.Elements[i].IsRecord())
							{
								LRRHistData histData = gridHistorianData.TableControl.Table.Elements[i].GetRecord().GetData() as LRRHistData;
								if(histData != null)
								{
									if(histData.HistTag!=null)
									{
										HistTrends._arrHistTags.Add(histData.HistTag);
									}
								}
							}
						}
						object[] obj = new object[2];
						obj[0] = objHistData.HistTag;
                        obj[1] = false;
						if(showAll)
						{
                            obj[1] = true;
							_app.LRRUIManagerObj.ShowWindow(key,typeof(HistTrends),obj);
						}
						else
						{
							HistTrendsDialog histDialog = new HistTrendsDialog();
							DialogResult dlgResult = histDialog.ShowDialog(this);
							if(dlgResult == DialogResult.OK)
							{
								_app.LRRUIManagerObj.ShowWindow(key,typeof(HistTrends),obj);
							}
						}
					}
				}
			}
		}

		internal DialogResult _ShowGridColumnsDialog(object instance, string propertyName, IServiceProvider provider, Type type)
		{
			GroupingCollectionEditor ce = new GroupingCollectionEditor(type);
			Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer esc = new Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer(provider);
			PropertyDescriptor pd = TypeDescriptor.GetProperties(instance)[propertyName];
			Syncfusion.ComponentModel.TypeDescriptorContext tdc = new Syncfusion.ComponentModel.TypeDescriptorContext(instance, pd);
			tdc.ServiceProvider = esc;
			ce.EditValue(tdc, esc, pd.GetValue(instance));
			return esc.DialogResult;
		}
		private LRRHistDataUserAndTime ConverHistDataToHistDataOverride(LRRHistData objHist)
		{
			LRRHistDataUserAndTime objHistDataOverride =new LRRHistDataUserAndTime();

			objHistDataOverride.HistTagUID= objHist.HistTagUID;
			objHistDataOverride.HistTag= objHist.HistTag;
			objHistDataOverride.GeneralDesc= objHist.GeneralDesc;
			objHistDataOverride.EquipTag= objHist.EquipTag;
			objHistDataOverride.PropertyID= objHist.PropertyID;
			objHistDataOverride.FinalValueWithoutOverrides= objHist.FinalValueWithoutOverrides;
			objHistDataOverride.InterfaceValue= objHist.InterfaceValue;
			objHistDataOverride.ServerID= objHist.ServerID;
			objHistDataOverride.HistDesc= objHist.HistDesc;
			objHistDataOverride.HistUnits= objHist.HistUnits;
			objHistDataOverride.MeasType= objHist.MeasType;
			objHistDataOverride.FilterSelection= objHist.FilterSelection;
			objHistDataOverride.ValidRangeLowerLimit= objHist.ValidRangeLowerLimit;
			objHistDataOverride.ValidRangeUpperLimit= objHist.ValidRangeUpperLimit;
			objHistDataOverride.OnOffThresholdLowerLimit= objHist.OnOffThresholdLowerLimit;
			objHistDataOverride.OnOffThresholdUpperLimit= objHist.OnOffThresholdUpperLimit;
			objHistDataOverride.OffConditionSubstituteValue= objHist.OffConditionSubstituteValue;
			objHistDataOverride.StartOfPeriodValue= objHist.StartOfPeriodValue;
			objHistDataOverride.EndOfPeriodValue= objHist.EndOfPeriodValue;
			objHistDataOverride.SpotValue= objHist.SpotValue;
			objHistDataOverride.AverageValueForPeriodEntered= objHist.AverageValueForPeriodEntered;
			objHistDataOverride.LastValidAverageValue= objHist.LastValidAverageValue;
	 		objHistDataOverride.DataQuality= objHist.DataQuality;
			objHistDataOverride.ActiveFilterReturnValue= objHist.ActiveFilterReturnValue;
			objHistDataOverride.MeterOnOffStatusFlag= objHist.MeterOnOffStatusFlag;
			objHistDataOverride.ComplexEquipOnOff= objHist.ComplexEquipOnOff;
			objHistDataOverride.CalibrationFactor= objHist.CalibrationFactor;
			objHistDataOverride.PreFilterUserOverride= objHist.PreFilterUserOverride;
			objHistDataOverride.InterfaceUnits= objHist.InterfaceUnits;
			objHistDataOverride.PostFilterUserOverride= objHist.PostFilterUserOverride;
			objHistDataOverride.Comments= objHist.Comments;
			return objHistDataOverride;
		}

		private void SetConversionFormualDataStore()
		{
			LRRUCFDataStore.IsUCF = false;
		}

		#endregion

		#region ILRRUIContainer Members
		public void Save()
		{
			//LRRHistDatas toSaveHistData = _lrrHistData.GetChanges();
			LRRUserHistDatas toSaveHistData = _lrrUserHistData.GetChanges();
			
			if(toSaveHistData.Count > 0)
			{
				for(int i=0;i<toSaveHistData.Count;i++)
				{
					LRRUserHistData  lhd = toSaveHistData[i] as LRRUserHistData;
					if(lhd.HistTag == null || lhd.HistTag.Trim() == "")
					{
						LRRMessagBox.ShowMessage("SID_HISTDATA_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);      
						return;
					}
				}
				_app.DBManagerObj.CommitCollection(toSaveHistData);
				isSaved = true;
			}
			if(toSaveHistData.HasError)
			{
				LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
			else
			{
				if(!isSaved)
				{
					LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
				}
				else
				{
					ApplicationPersistanceUtil.SaveGridSettings(gridHistorianData,this,this.Tag);

					for(int i=0;i<toSaveHistData.Count;i++)
					{
						LRRUserHistData data = toSaveHistData[i];
						if(data.ArrListUpdatedColNames.Contains("CalibrationFactor") || data.ArrListUpdatedColNames.Contains("PreFilterUserOverride") || data.ArrListUpdatedColNames.Contains("PostFilterUserOverride") )
						{
							MessagingClient.CalibrationFactorChanged(data.HistTag,data.CalibrationFactor,data.PreFilterUserOverride,data.PostFilterUserOverride);
						}
					}
		
					Refresh();
					ApplicationPersistanceUtil.ApplyGridSettings(gridHistorianData,this,this.Tag);
					LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				}
			}
		}

		public new void Refresh()
		{
		 	_lrrUserHistData.RefreshCollection();
			gridHistorianData.TableModel.CellModels.Remove("DropDownTree");  
			gridHistorianData.TableDescriptor.Relations.Clear();
			gridHistorianData.QueryCellStyleInfo-=new GridTableCellStyleInfoEventHandler(gridHistorianData_QueryCellStyleInfo);  
			InitDataSource();
			InitializeGridWithData();	
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public void CopyMasterProperties()
		{
			// TODO:  Add ComplexEquipment.CopyMasterProperties implementation
			
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquipment.Paste implementation
			
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquipment.Copy implementation
			
		}

		public void Print()
		{
			//Print Implementation
			if(gridHistorianData.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridHistorianData,false);
			}
			
		}

		public void Delete()
		{
			SyncGridUtilities.DeleteRecords(gridHistorianData);   
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquipment.ArrangeColumns implementation
			
		}

		public void ClearFilter()
		{
			SyncGridUtilities.ClearFilter(gridHistorianData);   
			//this.gridHistorianData.TableDescriptor.RecordFilters.Clear();
			//Refresh(); 
		}

		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridHistorianData);
		}
		
		public void Export()
		{
			if(gridHistorianData.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridHistorianData);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquipment.SupportsCopy implementation
			return true;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquipment.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquipment.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquipment.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquipment.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquipment.SupportsDelete implementation
			return true;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquipment.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquipment.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add SiteComponentEntry.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void SelectionPaste()
		{
			try
			{
				if(gridHistorianData.TableControl.CurrentCell.IsActive)
				{
					int rowI = gridHistorianData.TableControl.CurrentCell.RowIndex;
					int colI = gridHistorianData.TableControl.CurrentCell.ColIndex;
					string sColHeader = gridHistorianData.TableControl.Table.TableModel.GetColumnDescriptorAt(rowI,colI).HeaderText;
					if(sColHeader == LRRHeaderText.GetHeaderString("SID_INTERFACEUOM"))
					{
						GridRangeInfoList ranges = gridHistorianData.TableControl.Model.SelectedRanges;
						if(ranges.Count == 1 && ranges.ActiveRange.IsCells)
						{
							GridRangeInfo range = ranges.ActiveRange;
							for(int col = range.Left; col <= range.Right; ++col)
							{
								GridRecord _rec = gridHistorianData.TableControl.Table.CurrentRecord as GridRecord;
								LRRHistData histDataObj = _rec.GetData() as LRRHistData;  
								if(histDataObj != null)
								{
									string currentUomType = histDataObj.UOMTypeID;
									object o = gridHistorianData.TableControl.Model[range.Top, col].CellValue;
									for(int row = range.Top + 1; row <= range.Bottom; row++)
									{
										try
										{
											LRRHistData histObj = gridHistorianData.TableControl.Model.GetDisplayElementAt(row).GetData() as LRRHistData;
											if(histObj != null)
											{
												string uomType = histObj.UOMTypeID;
												if(uomType == currentUomType)
												{
//													ConvertUOM(histObj,histObj.ModelUOM,o.ToString());
													gridHistorianData.TableControl.Model[row, col].CellValue = o;
												}
												else
												{
													break;
												}
											}
										}
										catch(Exception ex)
										{
											Logger.LogMessage(typeof(SyncGridUtilities),"PasteSelection :"+ex.Message  ,Logger.Level.Debug);

										}
									}
									this.gridHistorianData.Refresh(); 
								}
							}
						}
					}
					else if(sColHeader == LRRHeaderText.GetHeaderString("SID_UOMTYPE"))
					{
						GridRangeInfoList ranges = gridHistorianData.TableControl.Model.SelectedRanges;
						if(ranges.Count == 1 && ranges.ActiveRange.IsCells)
						{
							GridRangeInfo range = ranges.ActiveRange;
							for(int col = range.Left; col <= range.Right; ++col)
							{
								GridRecord _rec = gridHistorianData.TableControl.Table.CurrentRecord as GridRecord;
								LRRHistData histDataObj = _rec.GetData() as LRRHistData;  
								if(histDataObj != null)
								{
									string currentUomType = histDataObj.UOMTypeID;
									object o = gridHistorianData.TableControl.Model[range.Top, col].CellValue;
									for(int row = range.Top + 1; row <= range.Bottom; row++)
									{
										try
										{
											LRRUserHistData histObj = gridHistorianData.TableControl.Model.GetDisplayElementAt(row).GetData() as LRRUserHistData;
											if(histObj != null)
											{
												if(currentUomType != null)
												{
													histObj.UOMTypeID = currentUomType;
													LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
													string modelUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,currentUomType);
													string uiUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemUserInterfaceID,currentUomType);
													if(modelUOMID != null && modelUOMID.Trim() != "")
													{
														histObj.ModelUOM = modelUOMID;
													}
													else
													{
														histObj.ModelUOM = "";
													}
													histObj.InterfaceUnits = uiUOMID;
													histObj.HistUnits = "";
													histObj.InterfaceValue = "";
												}
											}
										}
										catch(Exception ex)
										{
											Logger.LogMessage(typeof(SyncGridUtilities),"PasteSelection :"+ex.Message  ,Logger.Level.Debug);

										}
									}
									this.gridHistorianData.Refresh(); 
								}
							}
						}
					}
					else
					{
						if(sColHeader != LRRHeaderText.GetHeaderString("SID_CUSTOMFORMULA")
							&& sColHeader != LRRHeaderText.GetHeaderString("SID_FORMULA")
							&& sColHeader != LRRHeaderText.GetHeaderString("SID_CONVERSIONFORMULA"))
						{
							SyncGridUtilities.PasteSelection(gridHistorianData);
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SyncGridUtilities),"PasteSelection :"+ex.Message  ,Logger.Level.Debug);

			}
		}


		public void InsertNewRows()
		{
			// TODO:  Add SiteComponentEntry.InsertNewRows implementation
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		#endregion

		private void DataHistorianPoints_Activated(object sender, EventArgs e)
		{
			LRRFormulaDataStore.DataSource = lrrFormulaHistData;
			LRRFormulaDataStore.ModeFlag = false;
			LRRFormulaDataStore.ShowGroupedAttributes = false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;

			SetConversionFormualDataStore();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//this.gridHistorianData.TableModel.BeginUpdate(Syncfusion.Windows.Forms.BeginUpdateOptions.None);
			//this.gridHistorianData.Table.TableDirty = true;
			//gridHistorianData.Table.SummariesDirty = true;
			SendMessage(gridHistorianData.Handle, WM_SETREDRAW, 0, 0); 

		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			//this.gridHistorianData.TableModel.EndUpdate(true);
			//this.gridHistorianData.Table.TableDirty = false;
			//this.gridHistorianData.Refresh();
			SendMessage(gridHistorianData.Handle, WM_SETREDRAW, 1, 0); 
			gridHistorianData.Invalidate(true);
		}

		private void gridHistorianData_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			if(e.TableControl.CurrentCell.RowIndex == 3)
				return;
			GridTableModel tableModel = gridHistorianData.Table.TableModel;
			if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
				return;


			if ((tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_INTERFACEUOM"))
				|| (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_HISTUOM")))
			{
				string sUOMType = "";
				try
				{
					sUOMType = ((LRRHistData)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(DataHistorianPoints),ex.Message  ,Logger.Level.Debug);
				}
				if(sUOMType != "" && sUOMType != null)
				{
					LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
					GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
					cr.ListBoxPart.DataSource = uoms;
					uoms.SortColumn="Name";
					uoms.Sort();
					cr.Model.SupportsChoiceList = false; 
					if(uoms.Count ==0)
					{
						LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					}
				}
			}
		}

		private void gridHistorianData_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
			int iRow = e.TableControl.CurrentCell.RowIndex;
			int iCol = e.TableControl.CurrentCell.ColIndex;
			GridTableModel tableModel = gridHistorianData.Table.TableModel;
			if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
				return;

			if (tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText ==LRRHeaderText.GetHeaderString("SID_INTERFACEUOM"))
			{
				if(e.TableControl.Table.CurrentRecord == null)
					return;
				LRRUserHistData histData = ((LRRUserHistData)e.TableControl.Table.CurrentRecord.GetData());
				string oldUOM	  = histData.ModelUOM;
				string currentUOM = e.TableControl.CurrentCell.Renderer.ControlValue == null ? "" : e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
				ConvertUOM(histData,oldUOM,currentUOM);
			}

			if (tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText == LRRHeaderText.GetHeaderString("SID_UOMTYPE"))
			{
				if(e.TableControl.Table.CurrentRecord == null)
					return;
				LRRUserHistData histData = ((LRRUserHistData)e.TableControl.Table.CurrentRecord.GetData());
				string currentUOM = e.TableControl.CurrentCell.Renderer.ControlValue == null ? "" : e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
				if(currentUOM != "")
				{
					LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
					string modelUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,currentUOM);
					string uiUOMID = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemUserInterfaceID,currentUOM);
					
					if(e.TableControl.Table.CurrentRecord != null)
					{
					 	if(modelUOMID != null && modelUOMID.Trim() != "")
						{
					 		histData.ModelUOM = modelUOMID;

						}
						else
						{
							histData.ModelUOM = "";
						}
						histData.InterfaceUnits = uiUOMID;
						histData.HistUnits = "";
						histData.InterfaceValue = "";
					}
				}
			}
			if(e.TableControl.Table.CurrentRecord != null)
				e.TableControl.Table.CurrentRecord.EndEdit();

			//_app.DBManagerObj.CommitCollection(_lrrLogins);// check with abhinav and then remove comment
		
		}

		private void rdDefaultToInterfaceUOM_CheckedChanged(object sender, System.EventArgs e)
		{
			if(rdDefaultToInterfaceUOM.Checked)
			{
				LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
		 		foreach(LRRUserHistData histData in _lrrUserHistData)
				{
					string interfaceUOM = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemUserInterfaceID,histData.UOMTypeID);
					string oldUOM = histData.ModelUOM;					
					ConvertUOM(histData,oldUOM,interfaceUOM);
				}
			}
		}

		private void rdDefaultToModelUOM_CheckedChanged(object sender, System.EventArgs e)
		{
			if(rdDefaultToModelUOM.Checked)
			{
				LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
		 		foreach(LRRUserHistData histData in _lrrUserHistData)
				{
					string modelUOM = _lrrMeasSystemDefs.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,histData.UOMTypeID);
					string oldUOM = histData.ModelUOM;
					ConvertUOM(histData,oldUOM,modelUOM); 
				}
			}
		}

		private void ConvertUOM(LRRUserHistData histData,string oldUOM,string currentUOM)
		{
			string val = histData.InterfaceValue;
			string val2 = histData.PostFilterUserOverride;
			string val3 = histData.InterfaceUnits;
			histData.InterfaceUnits = currentUOM;
			if(!(val2 == null || val2 == ""))
			{
				if(val3 != currentUOM)
				{
					histData.PostFilterUserOverride = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(val3,currentUOM,val2, false,null);
				}
			}
			if(val == null || val == "")
			{
				oldUOM = histData.UnderlyingInterfaceUnits;
				val = histData.UnderlyingInterfaceValue;
				if(oldUOM == currentUOM)
				{
					histData.InterfaceValue = val;
					interfaceVal=val;
					return;
				}
			}
			if((val != null && val != "")
				&& (oldUOM != null && oldUOM != "")
				&& (currentUOM != null && currentUOM != ""))
				//&& )
			{
				if(oldUOM != currentUOM)
				{
                    string newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldUOM, currentUOM, val, null);
					histData.DisplayInterfaceValue = newVal;
					interfaceVal=newVal;
				}
				else
				{
					histData.DisplayInterfaceValue = histData.InterfaceValue;
					interfaceVal=histData.InterfaceValue;
				}
			}
		}

		private void gridHistorianData_TableControlCellMouseHover(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventArgs e)
		{
			int InterfaceValueIndex =e.TableControl.TableDescriptor.Columns.IndexOf("InterfaceValue") ;
			int PostFilterUserOverrideIndex = e.TableControl.TableDescriptor.Columns.IndexOf("PostFilterUserOverride") ;
			if(e.Inner.ColIndex==InterfaceValueIndex+e.TableControl.TableDescriptor.GetColumnIndentCount())
			{
				toolTip1.Active=false;
				this.toolTip2.Active =true;
				if(this.toolTip2 != null && this.toolTip2.Active)
					this.toolTip2.Active = false; //turn it off
				this.toolTip2.SetToolTip(this.gridHistorianData.TableControl,string.Format("Interface Value : {0}",interfaceVal)) ;
				this.toolTip2.Active = true; //make it active so it can show
			}
			if(e.Inner.ColIndex==PostFilterUserOverrideIndex+e.TableControl.TableDescriptor.GetColumnIndentCount())
			{
				toolTip2.Active=false;
				if(gridHistorianData.CurrencyManager.Position != -1)
				{
					this.toolTip1.Active = true;
					LRRUserHistData lrrHist=gridHistorianData.CurrencyManager.Current as LRRUserHistData;
					if(this.toolTip1 != null && this.toolTip1.Active)
						this.toolTip1.Active = false; //turn it off
					this.toolTip1.SetToolTip(this.gridHistorianData.TableControl,string.Format("Post Filter Override : {0}",lrrHist.PostFilterUserOverride)) ;
					this.toolTip1.Active = true; //make it active so it can show
				}
				else
				{
					this.toolTip1.Active = true;
					this.toolTip1.SetToolTip(this.gridHistorianData.TableControl,string.Format("Post Filter Override : ")) ;
				}

			}

		}

		private void gridHistorianData_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			//SourceObject ID
			if(e.Action == CurrentRecordAction.EnterRecordComplete && e.Record.GetRecord() != null)
			{
				LRRFormulaDataStore.SourceObjectID = e.Record.GetRecord().GetValue("HistTagUID") == null ? "" : e.Record.GetRecord().GetValue("HistTagUID").ToString();
				LRRFormulaDataStore.ShowGroupedAttributes = false;
				LRRFormulaDataStore.SourceLookupPropertyID = null;
				LRRFormulaDataStore.SourceLookupQualifierID = null;
				LRRConversionFormulaDataStore.SourceObjectID = e.Record.GetRecord().GetValue("HistTagUID") == null ? "" : e.Record.GetRecord().GetValue("HistTagUID").ToString();
				string fromUOMID = e.Record.GetRecord().GetValue("HistUnits") == null ? "" : e.Record.GetRecord().GetValue("HistUnits").ToString();
				string fromUOM = "";
				if(fromUOMID.Trim() != "")
					 fromUOM = LRRModel.ChildModel.GetUOMNameFromID(fromUOMID);
				LRRConversionFormulaDataStore.FromUOM = fromUOM;

				string toUOMID = e.Record.GetRecord().GetValue("ModelUOM") == null ? "" : e.Record.GetRecord().GetValue("ModelUOM").ToString();
				string toUOM = "";
				if(toUOMID.Trim() != "")
					toUOM = LRRModel.ChildModel.GetUOMNameFromID(toUOMID);
				LRRConversionFormulaDataStore.ToUOM = toUOM;
				LRRConversionFormulaDataStore.InterfaceValue = e.Record.GetRecord().GetValue("InterfaceValue") == null ? "" : e.Record.GetRecord().GetValue("InterfaceValue").ToString();
				
				LRRConstants objUserCons = new LRRConstants();

				foreach(LRRConstant objCons in LRRModel.ChildModel.ConstantsDefined)
				{
					if((objCons.InputSourceID != "2") && (objCons.ID != "0"))
					{
						objUserCons.Add(objCons);
					}
				}
			
				LRRConversionFormulaDataStore.LRRConstUser = objUserCons;
				SetConversionFormualDataStore();
			}
		}

		private void gridHistorianData_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(e.Inner.RowIndex != 2)
				return;
			GridTableModel tableModel = gridHistorianData.Table.TableModel;
			
			GridTableDescriptor tableDescriptor = e.TableControl.TableDescriptor;
			GridColumnDescriptor column = e.TableControl.Table.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex);
			string col = column.Name;
			if(col == "FormulaObj" || col == "ConversionFormulaObj" || col == "CustomFormulaObj")
			{
				int sortingOrder = 0;
				if(tableDescriptor.SortedColumns.Contains(col))
				{
					if(tableDescriptor.SortedColumns[col].SortDirection == ListSortDirection.Ascending)
						sortingOrder = 0;
					else
						sortingOrder = 1;
				}
			 	_lrrUserHistData.SortByFormulaExpression(sortingOrder,col);
				return;
			}

			if(e.TableControl.CurrentCell.RowIndex == -1 || e.TableControl.CurrentCell.ColIndex == -1)
				return;

			if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
				return;

 
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add DataHistorianPoints.ClearSort implementation
			SyncGridUtilities.ClearSort(gridHistorianData);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add DataHistorianPoints.SupportsClearSort implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add DataHistorianPoints.PrintPreview implementation
		if(gridHistorianData.TableControl.CurrentCell.IsActive)
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PrintData(gridHistorianData,true);
		}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add DataHistorianPoints.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add DataHistorianPoints.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add DataHistorianPoints.ShowComponentList implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add DataHistorianPoints.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add DataHistorianPoints.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add DataHistorianPoints.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add DataHistorianPoints.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add DataHistorianPoints.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add DataHistorianPoints.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add DataHistorianPoints.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add DataHistorianPoints.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add DataHistorianPoints.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add DataHistorianPoints.SupportsCompositeView implementation
			return false;
		}

		#endregion


		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		private void gridHistorianData_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
			}
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add DataHistorianPoints.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		private void gridHistorianData_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.RowIndex < 0)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex) == null)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_LEVEL") && e.TableCellIdentity.RowIndex > 3)
			{
				e.Style.CellType = "DropDownTree";
				string displaymember = e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit") == null ? "" :e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit").ToString();          
				if(displaymember != "")
				{
					string sFilter;
					sFilter = "LevelID = " + displaymember;
					_levels.ItemFilter = sFilter;
					GridTableCellStyleInfo gsi = new GridTableCellStyleInfo();
					gsi = e.Style;
					if(gsi != null)
					{
						if(_levels.Count>0)
							gsi.FormattedText = _levels[0].Name;  
						gsi.WrapText = true;
						gsi.AutoSize = true;
					}	
					_levels.ItemFilter ="";
				}
			}
		}

		private void gridContext_Popup(object sender, EventArgs e)
		{
			Element eCurrentElement = gridHistorianData.TableControl.Table.CurrentElement;
			GridRecord gnt = eCurrentElement as GridRecord;
			if(eCurrentElement != null)
			{
				Record rec = eCurrentElement.GetRecord();
				if(rec!=null)
				{
					LRRHistData objHistData = rec.GetData() as LRRHistData;

					if(objHistData != null)
					{
						if(objHistData.HistTag != "" && objHistData.HistTag != null)
							EnableContextMenuItems();
						else
							DisableContextMenuItems();
					}
					else
					{
						DisableContextMenuItems();
					}
				}
				else
					DisableContextMenuItems();
			}
			else
				DisableContextMenuItems();
		}
	}

}





