using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.PEAdvisor.GridUtilities;

using Symcon.BusinessObjects; 
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for LRRChart.
	/// </summary>
	public class Chart : System.Windows.Forms.Form,ILRRUIContainer, ILRRView
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Chart()
		{

		}

		public Chart(string chartID)
		{
			InitForm(chartID);
		}

		private void InitForm(string chartID)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			UserControls.UserControlChart ucChart = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlChart(chartID);
			ucChart.Dock = DockStyle.Fill;
			this.Controls.Add(ucChart);
			this.Text = ucChart.GetDisplayName();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Chart
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1064, 614);
			this.Name = "Chart";
			this.Tag = "SID_LRRCHART";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;

		}
		#endregion

		#region Fields

		private TabPage _parentTabPage;
		private TabControl _parentTabControl;

		#endregion
		
		#region ILRRUIContainer Members
		public new void Refresh()
		{
		}
		public void Save()
		{
		}
		public void CopyMasterProperties()
		{
		}
		public void Paste()
		{
		}
		public void Copy()
		{
		}
		public void Print()
		{
		}
		public void Delete()
		{
		}
		public void ArrangeColumns()
		{
		}
		public void ClearFilter()
		{
		}
		public void InsertNewRows()//Inserts New rows 
		{
		}
		public void ImportToExcel()
		{
		}
		public void Export()
		{
		}
		public void SelectionPaste()
		{
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		//Methods Suported
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsCopy()
		{
			return false;
		}
		public bool SupportsPaste()
		{
			return false;
		}
		public bool SupportsExport()
		{
			return true;
		}
		public bool SupportsSave()
		{
			return true;
		}
		public bool SupportsRefresh()
		{
			return false;
		}
		public bool SupportsDelete()
		{
			return false;
		}
		public bool SupportsPrint()
		{
			return false;
		}
		public bool SupportsArrangeColumns()
		{
			return false;
		}
		public bool SupportsClearFilter()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			return false;
		}
		public bool SupportsImportToExcel()
		{
			return false;
		}
		public bool SupportsSelectionPaste()
		{
			return false;
		}
		public bool SupportsLevel()
		{
			return false;
		}

		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add Chart.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add Chart.SupportsClearSort implementation
			return false;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add Chart.PrintPreview implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add Chart.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add Chart.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add Chart.ShowComponentList implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add Chart.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add Chart.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add Chart.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add Chart.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add Chart.SupportsUndo implementation
			return false;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add Chart.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add Chart.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add Chart.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add Chart.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add Chart.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRView Members

		public Panel Open(object id)
		{
			Panel pnl = new Panel();
			try
			{
				UserControls.UserControlChart ucChart = new Symcon.LightRidge.PEAdvisor.UserControls.UserControlChart(id.ToString());
				
				ucChart.Dock = DockStyle.Fill;
				pnl.Controls.Add(ucChart);
				
			}
			catch(Exception ex)
			{
				Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(Chart),"Could not load Chart: " + ex.Message + ex.StackTrace, Symcon.Utils.MessageLogger.Logger.Level.Debug);
			}
			return pnl;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add InputOutputViews.PerformDirtyChk getter implementation
				return false;
			}
		}

		#endregion
	}
}
