using System;
using System.Collections.Generic;
using System.Text;

namespace Symcon.LightRidge.PEAdvisor.CommonViews
{
    public static class ChangedUIUOMDictionary
    {

        static Dictionary<string, string> dictChangedUIUOMForUnifiedView = new Dictionary<string, string>();
        static Dictionary<string, string> dictChangedUIUOMForIOView = new Dictionary<string, string>();
        static Dictionary<string, string> dictChangedUIUOMForGroupedDataArrayView = new Dictionary<string, string>();
        static Dictionary<string, string> dictChangedUIUOMForGroupedSimpleView = new Dictionary<string, string>();
        //static Dictionary<string, string> dictChangedUIUOM = new Dictionary<string, string>();

        static Dictionary<Type, Dictionary<string, string>> parentDictionary = new Dictionary<Type, Dictionary<string, string>>();

        public static void AddUOM(Type objType, string ID, string ChangedUIUOM)
        {
            if (objType == typeof(Symcon.LightRidge.PEAdvisor.CommonViews.GridSavedViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.CommonViews.GridTransposedSavedViewController))
            {
                if (!dictChangedUIUOMForUnifiedView.ContainsKey(ID))
                {
                    dictChangedUIUOMForUnifiedView.Add(ID, ChangedUIUOM);
                }
                else
                {
                    dictChangedUIUOMForUnifiedView.Remove(ID);
                    dictChangedUIUOMForUnifiedView.Add(ID, ChangedUIUOM);
                }
            }

            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController))
            {
                if (!dictChangedUIUOMForIOView.ContainsKey(ID))
                {
                    dictChangedUIUOMForIOView.Add(ID, ChangedUIUOM);
                }
                else
                {
                    dictChangedUIUOMForIOView.Remove(ID);
                    dictChangedUIUOMForIOView.Add(ID, ChangedUIUOM);
                }
            }

            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierTransposedViewController))
            {
                if (!dictChangedUIUOMForGroupedSimpleView.ContainsKey(ID))
                {
                    dictChangedUIUOMForGroupedSimpleView.Add(ID, ChangedUIUOM);
                }
                else
                {
                    dictChangedUIUOMForGroupedSimpleView.Remove(ID);
                    dictChangedUIUOMForGroupedSimpleView.Add(ID, ChangedUIUOM);
                }
            }

            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayTransposeViewController))
            {
                if (!dictChangedUIUOMForGroupedDataArrayView.ContainsKey(ID))
                {
                    dictChangedUIUOMForGroupedDataArrayView.Add(ID, ChangedUIUOM);
                }
                else
                {
                    dictChangedUIUOMForGroupedDataArrayView.Remove(ID);
                    dictChangedUIUOMForGroupedDataArrayView.Add(ID, ChangedUIUOM);
                }
            }
        }



        public static string RetrieveUOM(Type objType, string ID)
        {
            if (objType == typeof(Symcon.LightRidge.PEAdvisor.CommonViews.GridSavedViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.CommonViews.GridTransposedSavedViewController))
            {
                if (dictChangedUIUOMForUnifiedView.ContainsKey(ID))
                {
                    return dictChangedUIUOMForUnifiedView[ID];
                }
                else
                    return null;
            }

            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController))
            {
                if (dictChangedUIUOMForIOView.ContainsKey(ID))
                {
                    return dictChangedUIUOMForIOView[ID];
                }
                else
                    return null;
            }

            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierTransposedViewController))
            {
                if (dictChangedUIUOMForGroupedSimpleView.ContainsKey(ID))
                {
                    return dictChangedUIUOMForGroupedSimpleView[ID];
                }
                else
                    return null;
            }

            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayViewController) || objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayTransposeViewController))
            {
                if (dictChangedUIUOMForGroupedDataArrayView.ContainsKey(ID))
                {
                    return dictChangedUIUOMForGroupedDataArrayView[ID];
                }
                else
                    return null;
            }
            return null;
        }

        public static void Clear(Type objType)
        {
            if (objType == typeof(SavedViewForm)||objType == typeof(GridSavedViewController) ||objType == typeof(GridTransposedSavedViewController))
            {
                dictChangedUIUOMForUnifiedView.Clear();
            }
            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.IOScreen.InputOutputViews))
            {
                dictChangedUIUOMForIOView.Clear();
            }
            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesView))
            {
                dictChangedUIUOMForGroupedSimpleView.Clear();
            }
            else if (objType == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantDataArrayView))
            {
                dictChangedUIUOMForGroupedDataArrayView.Clear();
            }
            
        }

    }
}
