using System;
using System.Windows.Forms;
using System.Collections;
using Syncfusion.Windows.Forms.Grid;

using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.CommonViews
{
	/// <summary>
	/// Summary description for IUnifiedGridFactory.
	/// </summary>
	public interface IUnifiedGridFactory
	{
		//void LoadPanel(ArrayList custCollection,LRRSearchCriteriaItemGroupPropertiesUIUOMs srchCriteriaUIUOMs);
        string SearchQueryID
        {
            get;
            set;
        }
        /// <summary>
        /// Loads the panel.
        /// </summary>
        /// <param name="arrXCollection">The arr X collection.</param>
        /// <param name="arrYCollection">The arr Y collection.</param>
        /// <returns></returns>
		Panel LoadPanel(ArrayList arrXCollection,ArrayList arrYCollection);
		
		/// <summary>
        /// Gets the panel collection.
        /// </summary>
        /// <returns></returns>
		ArrayList GetPanelCollection();
        /// <summary>
        /// Hides the modes.
        /// </summary>
		void HideModes();
		//void Save(string name,string desc,LRRSearchGroupLevel srchGroupLevel,bool isPublished);
        /// <summary>
        /// Saves the specified name.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="desc">The desc.</param>
        /// <param name="levelID">The level ID.</param>
		void Save(string name,string desc,string levelID);
        /// <summary>
        /// Saves this instance.
        /// </summary>
		void Save();
        /// <summary>
        /// Gets or sets the search query.
        /// </summary>
        /// <value>The search query.</value>
		UnifiedSearchCriteria SearchQuery {get;set;}
        /// <summary>
        /// Exports this instance.
        /// </summary>
        /// <returns></returns>
		GridControl Export();
        /// <summary>
        /// Prints this instance.
        /// </summary>
		void Print();
        /// <summary>
        /// Prints the preview.
        /// </summary>
		void PrintPreview();
        /// <summary>
        /// Clears all bindings.
        /// </summary>
		void ClearAllBindings();
        /// <summary>
        /// Changes the UOM set.
        /// </summary>
        /// <param name="measSysID">The meas sys ID.</param>
		void ChangeUOMSet(string measSysID);
        /// <summary>
        /// Uns the subscribe reconnect completed.
        /// </summary>
		void UnSubscribeReconnectCompleted();
        /// <summary>
        /// Clears the sort.
        /// </summary>
		void ClearSort();
        /// <summary>
        /// Lefts the col movement.
        /// </summary>
		void LeftColMovement();
        /// <summary>
        /// Rights the col movement.
        /// </summary>
		void RightColMovement();


        /// <summary>
        /// Hides the components.
        /// </summary>
        /// <param name="arrayUnSelectedRecords">The array un selected records.</param>
        void HideComponents(ArrayList arrayUnSelectedRecords);
        /// <summary>
        /// Hides the properties.
        /// </summary>
        /// <param name="arrayUnSelectedRecords">The array un selected records.</param>
        void HideProperties(ArrayList arrayUnSelectedRecords);
    }
}
