using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor.CommonViews
{
    /// <summary>
    /// Summary description for ResultWindow.
    /// </summary>
	public class ResultWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlResultProperties;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridResultProperties;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Button btnApply;
		private System.Windows.Forms.Splitter splitter1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ResultWindow()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			gridResultProperties.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);   
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ResultWindow));
			this.pnlResultProperties = new System.Windows.Forms.Panel();
			this.gridResultProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.btnApply = new System.Windows.Forms.Button();
			this.pnlResultProperties.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridResultProperties)).BeginInit();
			this.pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlResultProperties
			// 
			this.pnlResultProperties.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlResultProperties.Controls.Add(this.gridResultProperties);
			this.pnlResultProperties.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlResultProperties.Location = new System.Drawing.Point(0, 0);
			this.pnlResultProperties.Name = "pnlResultProperties";
			this.pnlResultProperties.Size = new System.Drawing.Size(472, 134);
			this.pnlResultProperties.TabIndex = 0;
			// 
			// gridResultProperties
			// 
			this.gridResultProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridResultProperties.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridResultProperties.Location = new System.Drawing.Point(0, 0);
			this.gridResultProperties.Name = "gridResultProperties";
			this.gridResultProperties.Size = new System.Drawing.Size(470, 132);
			this.gridResultProperties.TabIndex = 0;
			this.gridResultProperties.Text = "gridGroupingControl1";
			this.gridResultProperties.VersionInfo = "3.301.0.0";
			this.gridResultProperties.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridResultProperties_TableControlQueryAllowSortColumn);
			this.gridResultProperties.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridResultProperties_QueryCellStyleInfo);
			this.gridResultProperties.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridResultProperties_SaveCellText);
			this.gridResultProperties.SizeChanged += new System.EventHandler(this.gridResultProperties_SizeChanged);
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.splitter1);
			this.pnlBottom.Controls.Add(this.btnApply);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 134);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(472, 40);
			this.pnlBottom.TabIndex = 1;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(472, 2);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// btnApply
			// 
			this.btnApply.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnApply.Location = new System.Drawing.Point(376, 8);
			this.btnApply.Name = "btnApply";
			this.btnApply.Size = new System.Drawing.Size(80, 23);
			this.btnApply.TabIndex = 0;
			this.btnApply.Tag = "SID_APPLY";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// ResultPropertiesWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 174);
			this.Controls.Add(this.pnlResultProperties);
			this.Controls.Add(this.pnlBottom);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ResultPropertiesWindow";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.pnlResultProperties.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridResultProperties)).EndInit();
			this.pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
        /// <summary>
        /// Binds the grid.
        /// </summary>
		public void BindGrid()
		{

			int col1Width = 0;
			int col2Width = 0;
			if(gridResultProperties.TableDescriptor.Columns.Count == 2)
			{
				col1Width = gridResultProperties.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_SELECT")].Width;
				col2Width = gridResultProperties.TableDescriptor.Columns["Name"].Width;
			}
			//Suspend the Layout of the Grid...
			gridResultProperties.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridResultProperties);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridResultProperties,_lrrResultProps.ItemType,null,true);
			
			this.gridResultProperties.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridResultProperties.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridResultProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridResultProperties.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridResultProperties.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridResultProperties.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridResultProperties.TableDescriptor.AllowNew = false;
			this.gridResultProperties.TableDescriptor.AllowEdit = true;
			this.gridResultProperties.TableDescriptor.AllowRemove = false;

			this.gridResultProperties.SourceListSet.Add("Parent",_lrrResultProps);

			this.gridResultProperties.TableDescriptor.Relations.Clear();
			this.gridResultProperties.DataSource = null;
			this.gridResultProperties.DataSource = PropertyCollection;

			this.gridResultProperties.TableDescriptor.Columns.Clear();
			
			_unBound.WireGrid(gridResultProperties);

			object[] objArray = new object[PropertyCollection.Count];
			int k = 0;
			foreach(LRRResultProperty prop in PropertyCollection)
			{
				objArray[k] = prop;
				k++;
			}
			_unBound.SetSelectedRecords(objArray);
//			this.gridResultProperties.TableDescriptor.Columns.Add("Name");
//			this.gridResultProperties.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ReadOnly = true;

			GridColumnDescriptor gcd;
			GridTableCellStyleInfo gtcsi;
			gcd = new GridColumnDescriptor();
			gcd.HeaderText = LRRHeaderText.GetHeaderString("SID_NAME");
			gcd.MappingName = "Name";
			gcd.AllowFilter = true;
			gcd.Width = 250;

			gtcsi = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gtcsi.ReadOnly = true;

			this.gridResultProperties.TableDescriptor.Columns.Add(gcd);
			this.gridResultProperties.TableDescriptor.SortedColumns.Clear();
			this.gridResultProperties.TableDescriptor.SortedColumns.Add("Name",ListSortDirection.Ascending);

			if(col1Width > 0)
				gridResultProperties.TableDescriptor.Columns[0].Width = col1Width;
			if(col2Width > 0)
				gridResultProperties.TableDescriptor.Columns[1].Width = col2Width;
			gridResultProperties.ResumeLayout(true);
		}

        /// <summary>
        /// Sets the un selected records.
        /// </summary>
        /// <param name="arrIDs">The arr I ds.</param>
		public void SetUnSelectedRecords(ArrayList arrIDs)
		{
			object[] objArray = new object[PropertyCollection.Count];
			int k = 0;
			_unBound.ClearSelectedRecords();
			foreach(LRRResultProperty prop in PropertyCollection)
			{
				if(!arrIDs.Contains(prop.ID))
				{
					objArray[k] = prop;
					k++;
				}
			}
			if(k == PropertyCollection.Count)
				this.CheckBoxValue = true;
			else
				this.CheckBoxValue = false;
			_unBound.SetSelectedRecords(objArray);
		}

        /// <summary>
        /// Raises the <see cref="E:System.Windows.Forms.Form.Closing"></see> event.
        /// </summary>
        /// <param name="e">A <see cref="T:System.ComponentModel.CancelEventArgs"></see> that contains the event data.</param>
		protected override void OnClosing(CancelEventArgs e)
		{
			e.Cancel = true;
			_isWindowOpen = false;
			this.Hide();
		}

		#endregion

		#region Fields
		private LRRResultProperties _lrrResultProps = new LRRResultProperties();
		private GridUnBoundColumn	_unBound=new GridUnBoundColumn();
		private ArrayList			_unSelectedRecords = new ArrayList();
		private ArrayList			_selectedRecords = new ArrayList();

		private bool				_isWindowOpen;
		#endregion

		#region Events
		public event SelectedPropertiesChanged		SelectedProperties;
		public event SelectedPropertiesChanged	    UnSelectedProperties;

		public event SelectedPropertiesChanged		TrendedProperties;
		public event SelectedPropertiesChanged	    UnTrendedProperties;

		#endregion

		#region Properties
		public LRRResultProperties PropertyCollection
		{
			get{return _lrrResultProps;}
			set
			{
				_lrrResultProps = value;
			}
		}

		public ArrayList UnSelectedRecords
		{
			get{return _unSelectedRecords;}
			set
			{
				_unSelectedRecords = value;
			}
		}

		public ArrayList SelectedRecords
		{
			get{return _selectedRecords;}
			set
			{
				_selectedRecords = value;
			}
		}

		public bool IsWindowOpen 
		{
			get{ return _isWindowOpen;}
			set
			{
				_isWindowOpen = value;
			}
		}

		#endregion
        /// <summary>
        /// Handles the Click event of the btnApply control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnApply_Click(object sender, System.EventArgs e)
		{
			ArrayList arrUnSelectedRecordsID = new ArrayList();
			object[] unSelectedRecords = _unBound.GetUnSelectedRecords();
			for(int i=0; i < unSelectedRecords.Length;i++)
			{
				LRRResultProperty lrrResultProp = unSelectedRecords[i] as LRRResultProperty;
				arrUnSelectedRecordsID.Add(lrrResultProp.ID);
			}
			_unSelectedRecords = arrUnSelectedRecordsID;
			if(SelectedProperties != null)
				SelectedProperties(arrUnSelectedRecordsID);
			if(TrendedProperties != null)
				TrendedProperties(arrUnSelectedRecordsID);

			//Get Selected Records
			ArrayList arrSelectedRecordsID = new ArrayList();
			object[] selectedRecords = _unBound.GetSelectedRecords();
			for(int i=0; i < selectedRecords.Length;i++)
			{
				LRRResultProperty lrrResultProp = selectedRecords[i] as LRRResultProperty;
				arrSelectedRecordsID.Add(lrrResultProp.ID);
			}
			_selectedRecords = arrSelectedRecordsID;
			if(UnSelectedProperties != null)
				UnSelectedProperties(arrSelectedRecordsID);
			if(UnTrendedProperties != null)
				UnTrendedProperties(arrSelectedRecordsID);

			this.Close();

		}
		int row, col;
		bool CheckBoxValue = true;
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridResultProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
		private void gridResultProperties_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex(LRRHeaderText.GetHeaderString("SID_SELECT"), out row , out col);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = CheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

        /// <summary>
        /// Handles the TableControlQueryAllowSortColumn event of the gridResultProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs"/> instance containing the event data.</param>
		private void gridResultProperties_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == LRRHeaderText.GetHeaderString("SID_SELECT"))
			{
				e.AllowSort = false;
			}
		}

        /// <summary>
        /// Handles the SaveCellText event of the gridResultProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
		private void gridResultProperties_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.CheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lrrResultProps.GetEnumerator(); 
				ArrayList selectedRecords = new ArrayList(); 
				while(iEnum.MoveNext())
				{
					LRRResultProperty resultProperty = iEnum.Current as LRRResultProperty; 
					if(resultProperty != null)
						selectedRecords.Add(resultProperty);  
				}
				object[] objSelectedRecords =new object[selectedRecords.Count];
				for(int i=0;i<selectedRecords.Count;i++)
				{
					objSelectedRecords[i] = selectedRecords[i];
				}
				_unBound.SetSelectedRecords(objSelectedRecords,CheckBoxValue);  
				gridResultProperties.Refresh();  		
				e.Handled = true;
			}
			else
			{
				if(!bool.Parse(e.Text))
				{
					this.CheckBoxValue = false;
					gridResultProperties.Refresh();  		
				}
				else
				{
					object[] objSelRecords = _unBound.GetSelectedRecords();
					int noOfCheckedItems = objSelRecords.Length;
					if(_lrrResultProps.Count == noOfCheckedItems + 1)
					{
						this.CheckBoxValue = true;
						gridResultProperties.Refresh(); 
					}
				}
			}
		}
		public delegate void SelectedPropertiesChanged(ArrayList arrayUnSelectedRecords);

        /// <summary>
        /// Handles the MouseUp event of the TableControl control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
		private void TableControl_MouseUp(object sender, MouseEventArgs e)
		{
			int row, col;
			GridTableControl gridTableControl = sender as GridTableControl;
			gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
			GridTableCellStyleInfo style = gridTableControl.Model[row, col];

			IMouseController controller;
			gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

			if(controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
			{
				gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
			}

		}

        /// <summary>
        /// Handles the SizeChanged event of the gridResultProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void gridResultProperties_SizeChanged(object sender, System.EventArgs e)
		{
			int totalColsWidth = 0;
			
			foreach(GridColumnDescriptor gcd in this.gridResultProperties.TableDescriptor.Columns)
			{
				totalColsWidth += gcd.Width;
			}

			float nPercent = (float)(this.gridResultProperties.Width - (3 + 2*(new VScrollBar()).Width))/(float)totalColsWidth;

			foreach(GridColumnDescriptor gcd in this.gridResultProperties.TableDescriptor.Columns)
			{
				gcd.Width = (int)(gcd.Width * nPercent + 0.5);
				if(gcd.Width == 0)
					gcd.Width = 1;
			}
		}
	}
}
