using System;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.CommonViews
{
    public partial class SetRecordedTrendedForm : Form
    {
        #region Constructor

        public SetRecordedTrendedForm(bool isTrended) // True for trended and false for recorded
        {
            InitializeComponent();

            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            _isTrended = isTrended;

            // Enable the checkboxes for the tree view
            treeViewLeftRecordedTrended.CheckBoxes = true;

            //treeViewLeftRecordedTrended.AfterCheck += new TreeViewEventHandler(treeViewRecordedTrended_AfterCheck);
        }

        #endregion

        #region Fields

        private LRRApp _lrrApp = null;
        private bool _isTrended = false;

        //private List<string> _listAllCompCollection = new List<string>();
        private List<string> _listSelectedCompCollection = new List<string>();

        //private List<string> _listAllAttributes = new List<string>();
        private List<string> _listSelectedAttributes = new List<string>();

        private TreeNode _siteItemsHeaderNode = null;

        #endregion

        #region Public Methods

        List<string> checkedAttrListForRec = new List<string>();
        List<string> unCheckedAttrListForRec = new List<string>();
        List<string> checkedAttrListForTrend = new List<string>();
        List<string> unCheckedAttrListForTrend = new List<string>();

        //List<string> idArr = new List<string>();


        List<string> trendedMasterPropID = new List<string>();
        List<string> nonTrendedMPID = new List<string>();

        List<string> trendedSC = new List<string>();

        List<string> trendedSCP = new List<string>();

        List<string> mpList = new List<string>();

        List<string> siteCompList = new List<string>();
        List<string> recordedSCList = new List<string>();
        List<string> recordedMasterPropID = new List<string>();
        List<string> recordedSCP = new List<string>();
        List<string> nonRecMPID = new List<string>();
        List<string> nonRecSCP = new List<string>();

        public void PopulateSCPandMPList(ArrayList compHeaderCellList, ArrayList attributeHeaderCellList, string masterPlantItemName, bool isTrended)
        {
            foreach (CellHeader compCellHeader in compHeaderCellList)
            {
                if (!siteCompList.Contains(compCellHeader.ID))
                {
                    siteCompList.Add(compCellHeader.ID);
                }
            }
            foreach (CellHeader cellHeader in attributeHeaderCellList)
            {
                if (!mpList.Contains(cellHeader.ID))
                    mpList.Add(cellHeader.ID);
            }
            #region com5
            /*
            foreach (CellHeader compCellHeader in compHeaderCellList)
            {
                string compID = compCellHeader.ID;
                if (!recordedSC.Contains(compID))
                {
                    LRRSiteComponent siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(compID);
                    if (siteComp != null)
                    {
                        recordedSC.Add(compID);
                        foreach (LRRSiteComponentProperty prop in siteComp.Properties)
                        {
                            foreach (CellHeader cellHeader in attributeHeaderCellList)
                            {
                                if (prop.PropertyID == cellHeader.ID)
                                {
                                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteComPropObjForMasterPropIDAndCompID(cellHeader.ID, siteComp.SiteComponentID);
                                    if (!isTrended)
                                    {
                                        if (scp.IsTracked)
                                        {
                                            if (!recordedSCP.Contains(scp.ID))
                                            {
                                                recordedSCP.Add(scp.ID);
                                            }
                                            if (!recordedMasterPropID.Contains(scp.PropertyID))
                                            {
                                                recordedMasterPropID.Add(scp.PropertyID);
                                            }
                                        }
                                        else
                                        {
                                            if (!nonRecMPID.Contains(scp.PropertyID))
                                            {
                                                nonRecMPID.Add(scp.PropertyID);
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (scp.IsTrended)
                                        {
                                            if (!trendedSCP.Contains(scp.ID))
                                            {
                                                trendedSCP.Add(scp.ID);
                                            }
                                            if (!trendedMasterPropID.Contains(scp.PropertyID))
                                            {
                                                trendedMasterPropID.Add(scp.PropertyID);
                                            }

                                        }
                                        else
                                        {
                                            if (!nonTrendedMPID.Contains(scp.PropertyID))
                                            {
                                                nonTrendedMPID.Add(scp.PropertyID);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
             * */
            #endregion
        }
        List<string> allRecordedList = new List<string>();
        List<string> partiallyRecordedList = new List<string>();
        List<string> notRecordedList = new List<string>();
        bool calledFromTrendsWindow = false;
        List<string> sitCompIDWithRecordedAttributes = new List<string>();
        string _masterPlantItemName;
        List<string> recordedMasterPropList = new List<string>();
        public void BindTree(ArrayList compHeaderCellList, ArrayList attributeHeaderCellList, string masterPlantItemName, bool isTrended)
        {

            _masterPlantItemName = masterPlantItemName;
            recordedSCList.Clear();
            bool partialRecordingExists = false;
            calledFromTrendsWindow = isTrended;
            siteCompList.Clear();
            mpList.Clear();
            recordedSCP.Clear();
            recordedMasterPropID.Clear();
            nonRecSCP.Clear();
            nonRecMPID.Clear();
            scs.Clear();
            scpS.Clear();
            recordedMasterPropList.Clear();
            treeViewLeftRecordedTrended.Nodes.Clear();
            treeViewRightRecordedTrendedAttr.Nodes.Clear();

            TreeNode mpRootNode = new TreeNode("Master Attributes");
            mpRootNode.Name = "Master Attributes";
            treeViewRightRecordedTrendedAttr.Nodes.Add(mpRootNode);
            PopulateSCPandMPList(compHeaderCellList, attributeHeaderCellList, masterPlantItemName, isTrended);
            notRecordedList.Clear();
            partiallyRecordedList.Clear();

            allRecordedList.Clear();

            List<string> parRecSCList = new List<string>();
            parRecSCList.Clear();

            string scName = "";
            TreeNode leftRootNode = new TreeNode(masterPlantItemName);
            leftRootNode.Name = masterPlantItemName;
            treeViewLeftRecordedTrended.Nodes.Add(leftRootNode);
            TreeNode siteItemsHeaderNode = new TreeNode("Plant Items");
            siteItemsHeaderNode.Name = "Plant Items";
            leftRootNode.Nodes.Add(siteItemsHeaderNode);
            sitCompIDWithRecordedAttributes.Clear();
            Hashtable scAddedHash = new Hashtable();
            
            foreach (string masterPropID in mpList)
            {
                foreach (string siteCompID in siteCompList)
                {
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, masterPropID);
                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(siteCompID);
                    // start of changes for user specific properties by ashwin
                    TreeNode tnsiteComp = null;
                    if (sc != null)
                    {
                        scName = sc.Name;

                        if (!scAddedHash.ContainsKey(sc.Name))
                        {
                            tnsiteComp = new TreeNode(sc.Name);
                            tnsiteComp.Tag = siteCompID;
                            tnsiteComp.Name = sc.Name;
                            siteItemsHeaderNode.Nodes.Add(tnsiteComp);
                            scAddedHash.Add(sc.Name, tnsiteComp);
                        }

                    }

                    if (!isTrended)
                    {
                        if (scp != null)
                        {
                            LRRUserSpecificRecordedProperty usp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (usp != null)
                            {
                                if (!isTrended)
                                {
                                    if (tnsiteComp != null)
                                    {
                                        if (!tnsiteComp.Checked)
                                            tnsiteComp.Checked = true;
                                    }
                                    if (!sitCompIDWithRecordedAttributes.Contains(siteCompID))
                                    {
                                        sitCompIDWithRecordedAttributes.Add(siteCompID);
                                    }
                                    if (!recordedMasterPropList.Contains(masterPropID))
                                    {
                                        recordedMasterPropList.Add(masterPropID);
                                    }
                                    if (!mpS.Contains(masterPropID))
                                    {
                                        mpS.Add(masterPropID);
                                    }
                                }
                            }
                        }

                    }
                    else
                    {
                        if (scp != null)
                        {
                            LRRUserSpecificTrendedProperty usp = LRRModel.UserSpecificTrendedProperties.GetUserSpecificTrendedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (usp != null)
                            {
                                if (tnsiteComp != null)
                                {
                                    if (!tnsiteComp.Checked)
                                        tnsiteComp.Checked = true;
                                }
                                if (!sitCompIDWithRecordedAttributes.Contains(siteCompID))
                                {
                                    sitCompIDWithRecordedAttributes.Add(siteCompID);
                                }
                                if (!recordedMasterPropList.Contains(masterPropID))
                                {
                                    recordedMasterPropList.Add(masterPropID);
                                }
                                if (!tMps.Contains(masterPropID))
                                {
                                    tMps.Add(masterPropID);
                                }

                            }
                        }
                    }
                    // end of changes for user specific properties by ashwin
                    /*
                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(siteCompID);
                    if (scp != null)
                    {
                        TreeNode tnsiteComp = null;
                        if (sc != null)
                        {
                            scName = sc.Name;

                            if (!scAddedHash.ContainsKey(sc.Name))
                            {
                                tnsiteComp = new TreeNode(sc.Name);
                                tnsiteComp.Tag = siteCompID;
                                tnsiteComp.Name = sc.Name;
                                siteItemsHeaderNode.Nodes.Add(tnsiteComp);
                                scAddedHash.Add(sc.Name, tnsiteComp);
                            }

                        }
                        if (!isTrended)
                        {
                            if (scp.IsTracked)
                            {
                                if (tnsiteComp != null)
                                {
                                    if (!tnsiteComp.Checked)
                                        tnsiteComp.Checked = true;
                                }
                                if (!sitCompIDWithRecordedAttributes.Contains(siteCompID))
                                {
                                    sitCompIDWithRecordedAttributes.Add(siteCompID);
                                }
                                if (!recordedMasterPropList.Contains(masterPropID))
                                {
                                    recordedMasterPropList.Add(masterPropID);
                                }

                            }
                        }
                        else
                        {
                            if (scp.IsTrended)
                            {
                                if (tnsiteComp != null)
                                {
                                    if (!tnsiteComp.Checked)
                                        tnsiteComp.Checked = true;
                                }
                                if (!sitCompIDWithRecordedAttributes.Contains(siteCompID))
                                {
                                    sitCompIDWithRecordedAttributes.Add(siteCompID);
                                }
                                if (!recordedMasterPropList.Contains(masterPropID))
                                {
                                    recordedMasterPropList.Add(masterPropID);
                                }
                            }
                        }
                    }
                    */
                }
            }

            bool parRecExistForSC = false;
            foreach (string masterPropID in mpList)
            {
                
                bool allRecorded = true;
                bool notRecorded = true;
                
                /*
                bool allRecorded = false;
                bool notRecorded = true;
                **/
                foreach (string siteCompID in sitCompIDWithRecordedAttributes)
                {
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, masterPropID);
                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(siteCompID);
                    scName = sc.Name;
                    if (scp != null)
                    {

                        if (!isTrended)
                        {
                            // changes for handling user specific recorded attributes starts here - Ashwin
                            LRRUserSpecificRecordedProperty usp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (usp == null)
                            {
                                allRecorded = false;

                                if (!parRecSCList.Contains(sc.Name) && recordedMasterPropList.Contains(masterPropID))
                                    parRecSCList.Add(sc.Name);

                            }
                            else
                            {
                                if (!recordedSCList.Contains(sc.Name))
                                    recordedSCList.Add(sc.Name);
                                notRecorded = false;
                                //notRecorded = true;
                            }
                            // changes for handling user specific recorded attributes end here - Ashwin
                            // below code commented by ashwin
                            /*
                            if (!scp.IsTracked)
                            {
                                allRecorded = false;

                                if (!parRecSCList.Contains(sc.Name) && recordedMasterPropList.Contains(masterPropID))
                                    parRecSCList.Add(sc.Name);
                            }
                            if (scp.IsTracked)
                            {

                                if (!recordedSCList.Contains(sc.Name))
                                    recordedSCList.Add(sc.Name);
                                notRecorded = false;
                            }
                             * */
                        }
                        else
                        {
                            // changes for handling user specific recorded attributes starts here - Ashwin
                            LRRUserSpecificTrendedProperty usp = LRRModel.UserSpecificTrendedProperties.GetUserSpecificTrendedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (usp == null)
                            {
                                allRecorded = false;

                                if (!parRecSCList.Contains(sc.Name) && recordedMasterPropList.Contains(masterPropID))
                                    parRecSCList.Add(sc.Name);

                            }
                            else
                            {
                                if (!recordedSCList.Contains(sc.Name))
                                    recordedSCList.Add(sc.Name);
                                notRecorded = false;

                            }
                            // changes for handling user specific recorded attributes end here - Ashwin
                            // below code commented by ashwin
                            /*
                            if (!scp.IsTrended)
                            {
                                allRecorded = false;

                                if (!parRecSCList.Contains(sc.Name) && recordedMasterPropList.Contains(masterPropID))
                                    parRecSCList.Add(sc.Name);

                            }
                            if (scp.IsTrended)
                            {
                                if (!recordedSCList.Contains(sc.Name))
                                    recordedSCList.Add(sc.Name);
                                notRecorded = false;
                            }
                            */
                        }
                    }

                }
                LRRMasterProperty mp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);
                if (mp != null)
                {
                    TreeNode mpTreeNode = new TreeNode(mp.Name);
                    mpTreeNode.Name = mp.Name;
                    mpTreeNode.Tag = mp.PropID;
                    mpRootNode.Nodes.Add(mpTreeNode);
                    if (allRecorded && !notRecorded)
                    {
                        if (mpTreeNode.Checked != allRecorded)
                            mpTreeNode.Checked = allRecorded;
                        if (!allRecordedList.Contains(masterPropID))
                            allRecordedList.Add(masterPropID);
                        Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(mpTreeNode);
                    }
                    else if (!allRecorded && !notRecorded)
                    {
                        mpTreeNode.ForeColor = Color.OrangeRed;
                        partialRecordingExists = true;
                        partiallyRecordedList.Add(masterPropID);
                        //if (!parRecSCList.Contains(scName))
                        //{
                        //    parRecExistForSC = true;
                        //    parRecSCList.Add(scName);
                        //}
                    }
                    else if (!allRecorded && notRecorded)
                    {
                        notRecordedList.Add(masterPropID);
                    }
                }
            }
            for (int i = 0; i < recordedSCList.Count; i++)
            {
                TreeNode tn = scAddedHash[recordedSCList[i]] as TreeNode;
                if (!tn.Checked)
                    tn.Checked = true;

                GetAllChildNodes(tn);
                CheckIFParentNeedsToCheck(tn);
                Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(tn);
            }

            if (partialRecordingExists)
            {
                mpRootNode.ForeColor = Color.OrangeRed;
            }
            for (int i = 0; i < parRecSCList.Count; i++)
            {
                string scNameForTreeNode = parRecSCList[i];
                TreeNode tn = scAddedHash[scNameForTreeNode] as TreeNode;
                if (tn != null)
                {
                    parRecExistForSC = true;
                    tn.ForeColor = Color.OrangeRed;
                    leftRootNode.ForeColor = Color.OrangeRed;
                    siteItemsHeaderNode.ForeColor = Color.OrangeRed;
                }
            }
            treeViewLeftRecordedTrended.ExpandAll();
            treeViewRightRecordedTrendedAttr.ExpandAll();
        }

        private void RefreshScreen()
        {
            bool partialRecordingExists = false;
            

            //TreeNode mpRootNode = new TreeNode("Master Attributes");
            if (treeViewRightRecordedTrendedAttr.Nodes.Count == 0 )
            {
                return;
            }
            TreeNode mpRootNode = treeViewRightRecordedTrendedAttr.Nodes[0];// .TopNode;//("Master Attributes", false)[0];// .Add(mpRootNode);
            recordedSCList.Clear();
            recordedMasterPropList.Clear();
            notRecordedList.Clear();
            partiallyRecordedList.Clear();
            allRecordedList.Clear();
            List<string> parRecSCList = new List<string>();
            string scName = "";
            //TreeNode leftRootNode = new TreeNode(_masterPlantItemName);
            if (treeViewLeftRecordedTrended.Nodes.Count == 0)
            {
                return;
            }
            TreeNode leftRootNode = treeViewLeftRecordedTrended.Nodes[0];// .TopNode;// .Add(leftRootNode);
            //TreeNode siteItemsHeaderNode = new TreeNode("Plant Items");
            if (leftRootNode == null)
                return;
            if (leftRootNode.Nodes.Find("Plant Items", false).Length == 0)
                return;
            TreeNode siteItemsHeaderNode = leftRootNode.Nodes.Find("Plant Items", false)[0];// Add(siteItemsHeaderNode);

            Hashtable scAddedHash = new Hashtable();
            foreach (string masterPropID in mpList)
            {
                foreach (string siteCompID in siteCompList)
                {
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, masterPropID);
                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(siteCompID);
                    if (scp != null)
                    {
                        TreeNode tnsiteComp = null;
                        if (sc != null)
                        {
                            scName = sc.Name;
                            if (siteItemsHeaderNode.Nodes.Find(sc.Name, false).Length == 0)
                            {
                                continue;
                            }
                         
                            tnsiteComp = siteItemsHeaderNode.Nodes.Find(sc.Name, false)[0];// new TreeNode(sc.Name);
                            tnsiteComp.Tag = siteCompID;
                            if (!scAddedHash.ContainsKey(sc.Name))
                            {
                                scAddedHash.Add(sc.Name, tnsiteComp);
                            }

                        }
                        if (!calledFromTrendsWindow)
                        {
                            // start - change for handlilng user specific properties
                            LRRUserSpecificRecordedProperty uspR = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (uspR != null)
                            {
                                if (tnsiteComp != null)
                                {
                                    refreshScreen = false;
                                    if (!tnsiteComp.Checked)
                                        tnsiteComp.Checked = true;
                                }
                                if (!sitCompIDWithRecordedAttributes.Contains(siteCompID))
                                {
                                    sitCompIDWithRecordedAttributes.Add(siteCompID);
                                }
                                if (!recordedMasterPropList.Contains(masterPropID))
                                {
                                    recordedMasterPropList.Add(masterPropID);
                                }

                            }
                            // end - change for handlilng user specific properties

                            // code commented by ashwin
                            /*
                            if (scp.IsTracked)
                            {
                                if (tnsiteComp != null)
                                {
                                    refreshScreen = false;
                                    if (!tnsiteComp.Checked)
                                        tnsiteComp.Checked = true;
                                }
                                if (!sitCompIDWithRecordedAttributes.Contains(siteCompID))
                                {
                                    sitCompIDWithRecordedAttributes.Add(siteCompID);
                                }
                                if (!recordedMasterPropList.Contains(masterPropID))
                                {
                                    recordedMasterPropList.Add(masterPropID);
                                }
                            }
                            */
                        }
                        else
                        {
                            if (scp.IsTrended)
                            {
                                if (tnsiteComp != null)
                                {
                                    refreshScreen = false;
                                    if (!tnsiteComp.Checked)
                                        tnsiteComp.Checked = true;
                                }
                                if (!sitCompIDWithRecordedAttributes.Contains(siteCompID))
                                {
                                    sitCompIDWithRecordedAttributes.Add(siteCompID);
                                }
                                if (!recordedMasterPropList.Contains(masterPropID))
                                {
                                    recordedMasterPropList.Add(masterPropID);
                                }
                            }
                        }
                    }
                }
            }

            bool parRecExistForSC = false;
            foreach (string masterPropID in mpList)
            {
                // allRecorded = false and notRecorded = false Originally both true Ashwin

                bool allRecorded = false;
                bool notRecorded = true;

                foreach (string siteCompID in sitCompIDWithRecordedAttributes)
                {
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, masterPropID);
                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(siteCompID);
                    if (scp != null)
                    {
                        if (!calledFromTrendsWindow)
                        {
                            // start - change for handlilng user specific properties
                            LRRUserSpecificRecordedProperty usp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (usp != null)
                            {
                                allRecorded = false;

                                if (!parRecSCList.Contains(sc.Name) && recordedMasterPropList.Contains(masterPropID))
                                    parRecSCList.Add(sc.Name);
                            }
                            else
                            {
                                if (!recordedSCList.Contains(sc.Name))
                                    recordedSCList.Add(sc.Name);
                                // notRecorded = true by ashwin
                                notRecorded = true;

                            }
                            // end - change for handlilng user specific properties
                            // code commenetd by ashwin
                            /*
                            if (!scp.IsTracked)
                            {
                                allRecorded = false;

                                if (!parRecSCList.Contains(sc.Name) && recordedMasterPropList.Contains(masterPropID))
                                    parRecSCList.Add(sc.Name);
                            }
                            if (scp.IsTracked)
                            {
                                if (!recordedSCList.Contains(sc.Name))
                                    recordedSCList.Add(sc.Name);
                                notRecorded = false;
                            }
                            **/
                        }
                        else
                        {
                            if (!scp.IsTrended)
                            {
                                allRecorded = false;
                            }
                            if (scp.IsTrended)
                            {
                                if (!recordedSCList.Contains(sc.Name))
                                    recordedSCList.Add(sc.Name);
                                notRecorded = false;
                            }
                        }
                    }
                }
                LRRMasterProperty mp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);
                if (mp != null)
                {
                    //TreeNode mpTreeNode = new TreeNode(mp.Name);
                    TreeNode[] nodes = mpRootNode.Nodes.Find(mp.Name, false);
                    if (mpRootNode.Nodes.Find(mp.Name, false).Length == 0)
                    {
                        continue;
                    }
                    TreeNode mpTreeNode = mpRootNode.Nodes.Find(mp.Name, false)[0]; //Add(mpTreeNode);
                    if (allRecorded && !notRecorded)
                    {
                        refreshScreen = false;
                        if (mpTreeNode.Checked != allRecorded)
                            mpTreeNode.Checked = allRecorded;
                        allRecordedList.Add(masterPropID);
                        Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(mpTreeNode);
                    }
                    else if (!allRecorded && !notRecorded)
                    {
                        mpTreeNode.ForeColor = Color.OrangeRed;
                        partialRecordingExists = true;
                        partiallyRecordedList.Add(masterPropID);
                        //if (!parRecSCList.Contains(scName))
                        //{
                        //    parRecExistForSC = true;
                        //    parRecSCList.Add(scName);
                        //}
                    }
                    else if (!allRecorded && notRecorded)
                    {
                        notRecordedList.Add(masterPropID);
                    }
                }
            }
            for (int i = 0; i < recordedSCList.Count; i++)
            {
                refreshScreen = false;
                TreeNode tn = scAddedHash[recordedSCList[i]] as TreeNode;
                if (!tn.Checked)
                    tn.Checked = true;

                GetAllChildNodes(tn);
                CheckIFParentNeedsToCheck(tn);
                Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(tn);
            }

            if (partialRecordingExists)
            {
                mpRootNode.ForeColor = Color.OrangeRed;
            }
            for (int i = 0; i < parRecSCList.Count; i++)
            {
                string scNameForTreeNode = parRecSCList[i];
                TreeNode tn = scAddedHash[scNameForTreeNode] as TreeNode;
                if (tn != null)
                {
                    parRecExistForSC = true;
                    tn.ForeColor = Color.OrangeRed;
                    leftRootNode.ForeColor = Color.OrangeRed;
                    siteItemsHeaderNode.ForeColor = Color.OrangeRed;
                }
            }
        }
        #endregion

        #region Private Methods

        private List<string> GetSCPFromParentNode(TreeNode trvNode)
        {
            List<string> scpS = new List<string>();
            LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(trvNode.Text.ToString());
            if (sc != null)
            {
                for (int i = 0; i < trvNode.Nodes.Count; i++)
                {
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(sc.SiteComponentID).GetSiteCompPropFromName(trvNode.Nodes[i].Text.ToString());
                    if (scp != null)
                    {
                        if (!scpS.Contains(scp.ID))
                            scpS.Add(scp.ID);
                    }
                }
            }
            return scpS;
        }

        private void GetAllChildNodes(TreeNode trvNode)
        {
            for (int i = 0; i < trvNode.Nodes.Count; i++)
            {
                refreshScreen = true;
                TreeNode trvChildNode = trvNode.Nodes[i];
                if (trvChildNode.Checked != trvNode.Checked)
                    trvChildNode.Checked = trvNode.Checked;
                if (trvChildNode.Nodes != null && trvChildNode.Nodes.Count > 0)
                {
                    GetAllChildNodes(trvChildNode);
                }
            }
        }

        private void CheckIFParentNeedsToCheck(TreeNode trvNode)
        {
            if (trvNode.Parent != null)
            {
                bool check = true;
                foreach (TreeNode childTrvNode in trvNode.Parent.Nodes)
                {
                    if (!childTrvNode.Checked)
                        check = false;
                }
                if (trvNode.Parent.Checked != check)
                {
                    refreshScreen = check;
                    trvNode.Parent.Checked = check;
                }

                CheckIFParentNeedsToCheck(trvNode.Parent);
            }
        }

        private void AddGroupedProperties(string propID, TreeNode attrHeaderNode, LRRMasterProperty masterProp, LRRQualifier qual, LRRLookUpProperty lkupProp, LRRPropertyType propType, List<string> listNewSelectedAttributes)
        {
            TreeNode masterPropNodeFound = null;
            foreach (TreeNode childNode in attrHeaderNode.Nodes)
            {
                if (childNode.Tag.ToString() == (masterProp.PropID + "|" + propType.PropertyType))
                {
                    masterPropNodeFound = childNode;
                    break;
                }
            }

            if (masterPropNodeFound == null)
            {
                masterPropNodeFound = new TreeNode(masterProp.Name + "-" + propType.PropertyType);
                masterPropNodeFound.Tag = (masterProp.PropID + "|" + propType.PropertyType);
                attrHeaderNode.Nodes.Add(masterPropNodeFound);
            }


            TreeNode qualNodeFound = null;
            foreach (TreeNode childNode in masterPropNodeFound.Nodes)
            {
                if (childNode.Tag.ToString() == qual.QualifierID)
                {
                    qualNodeFound = childNode;
                    break;
                }
            }

            if (qualNodeFound == null)
            {
                qualNodeFound = new TreeNode(qual.Name);
                qualNodeFound.Tag = qual.QualifierID;
                masterPropNodeFound.Nodes.Add(qualNodeFound);
            }


            TreeNode lkupPropNodeFound = null;
            foreach (TreeNode childNode in qualNodeFound.Nodes)
            {
                if (childNode.Tag.ToString() == (qual.QualifierID + "|" + lkupProp.LookUpPropertiesID + "|" + masterProp.PropID))
                {
                    lkupPropNodeFound = childNode;
                    break;
                }
            }

            if (lkupPropNodeFound == null)
            {
                lkupPropNodeFound = new TreeNode(lkupProp.Name);
                lkupPropNodeFound.Tag = (qual.QualifierID + "|" + lkupProp.LookUpPropertiesID + "|" + masterProp.PropID);
                qualNodeFound.Nodes.Add(lkupPropNodeFound);

                if (_listSelectedAttributes.Contains(propID))
                {
                    lkupPropNodeFound.Checked = true;

                    listNewSelectedAttributes.Add(propID);
                }
            }
        }

        private void AddDataArrays(string propID, TreeNode attrHeaderNode, LRRMasterProperty masterProp, LRRLookUpProperty lkupProp, LRRPropertyType propType, List<string> listNewSelectedAttributes)
        {
            TreeNode masterPropNodeFound = null;
            foreach (TreeNode childNode in attrHeaderNode.Nodes)
            {
                if (childNode.Tag.ToString() == (masterProp.PropID + "|" + propType.ID))
                {
                    masterPropNodeFound = childNode;
                    break;
                }
            }

            if (masterPropNodeFound == null)
            {
                masterPropNodeFound = new TreeNode(masterProp.Name + "-" + propType.PropertyType);
                masterPropNodeFound.Tag = (masterProp.PropID + "|" + propType.ID);
                attrHeaderNode.Nodes.Add(masterPropNodeFound);
            }


            TreeNode lkupPropNodeFound = null;
            foreach (TreeNode childNode in masterPropNodeFound.Nodes)
            {
                if (childNode.Tag.ToString() == (masterProp.PropID + "|" + lkupProp.LookUpPropertiesID))
                {
                    lkupPropNodeFound = childNode;
                    break;
                }
            }

            if (lkupPropNodeFound == null)
            {
                lkupPropNodeFound = new TreeNode(lkupProp.Name);
                lkupPropNodeFound.Tag = (masterProp.PropID + "|" + lkupProp.LookUpPropertiesID);
                masterPropNodeFound.Nodes.Add(lkupPropNodeFound);

                if (_listSelectedAttributes.Contains(propID))
                {
                    lkupPropNodeFound.Checked = true;

                    listNewSelectedAttributes.Add(propID);
                }
            }
        }

        #endregion

        #region Event Handlers

        //private void treeViewRecordedTrended_AfterCheck(object sender, TreeViewEventArgs e)
        //{
        //    TreeNode currentNode = e.Node;
        //    /*
        //    if (e.Node.Parent != null)
        //    {
        //        if (e.Action.ToString() == "ByMouse" && (e.Node.Checked == true))
        //        {
        //            if (e.Node.Parent != null)
        //            {
        //                if (e.Node.Parent.Text.ToString() != "Plant Items")
        //                {
        //                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(e.Node.Parent.Text.ToString());
        //                    if (sc != null)
        //                    {
        //                        LRRSiteComponentProperty scp1 = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(sc.SiteComponentID).GetSiteCompPropFromName(e.Node.Text.ToString());
        //                        if (scp1 != null)
        //                        {
        //                            if (GridSavedViewController.CalledFromTrendedWindow)
        //                            {
        //                                if (!checkedAttrListForTrend.Contains(scp1.ID))
        //                                {
        //                                    checkedAttrListForTrend.Add(scp1.ID);
        //                                }

        //                            }
        //                            else
        //                            {
        //                                if (!checkedAttrListForRec.Contains(scp1.ID))
        //                                {
        //                                    checkedAttrListForRec.Add(scp1.ID);
        //                                }

        //                            }
        //                        }

        //                    }
        //                }
        //                else
        //                {
        //                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(e.Node.Text.ToString());
        //                    if (sc != null)
        //                    {
        //                        List<string> scps = GetSCPFromParentNode(e.Node);
        //                        GetAllChildNodes(e.Node);
        //                        CheckIFParentNeedsToCheck(e.Node);

        //                        Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(currentNode);

        //                        if (GridSavedViewController.CalledFromTrendedWindow)
        //                        {
        //                            checkedAttrListForTrend = scps;
        //                        }
        //                        else
        //                        {
        //                            checkedAttrListForRec = scps;
        //                        }
        //                    }
        //                }
        //            }
        //        }
        //        else
        //        {
        //            if ((e.Action.ToString() == "ByMouse" && (e.Node.Checked == false)))
        //            {
        //                if (e.Node.Parent != null)
        //                {
        //                    if (e.Node.Parent.Text.ToString() != "Plant Items")
        //                    {
        //                        LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(e.Node.Parent.Text.ToString());
        //                        if (sc != null)
        //                        {
        //                            LRRSiteComponentProperty scp1 = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(sc.SiteComponentID).GetSiteCompPropFromName(e.Node.Text.ToString());
        //                            if (scp1 != null)
        //                            {
        //                                if (GridSavedViewController.CalledFromTrendedWindow)
        //                                {
        //                                    if (!unCheckedAttrListForTrend.Contains(scp1.ID))
        //                                    {
        //                                        unCheckedAttrListForTrend.Add(scp1.ID);
        //                                    }
        //                                }
        //                                else
        //                                {
        //                                    if (!unCheckedAttrListForRec.Contains(scp1.ID))
        //                                    {
        //                                        unCheckedAttrListForRec.Add(scp1.ID);
        //                                    }

        //                                }
        //                            }

        //                        }
        //                    }
        //                    else
        //                    {
        //                        List<string> scps = GetSCPFromParentNode(e.Node);
        //                        if (GridSavedViewController.CalledFromTrendedWindow)
        //                        {
        //                            unCheckedAttrListForTrend = scps;
        //                        }
        //                        else
        //                        {
        //                            unCheckedAttrListForRec = scps;
        //                        }

        //                    }
        //                }
        //            }
        //        }
        //    }*/
        //}

        private void buttonApply_Click(object sender, EventArgs e)
        {
            _lrrApp.DBManagerObj.CommitCollection(LRRModel.SiteComponentPropertiesObj.GetChanges());
            LRRUserSpecificRecordedProperties recProps = new LRRUserSpecificRecordedProperties();
            LRRUserSpecificTrendedProperties trProps = new LRRUserSpecificTrendedProperties();
            /*
            RecordedProperties frm = new RecordedProperties();
            frm.InitializeRecPropsGrid();
             * */
            foreach (LRRUserSpecificRecordedProperty userSpProp in useSpecificAtts)
            {
                if (LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(userSpProp.UID, userSpProp.SiteComponentPropertyID) == null)
                {
                    userSpProp.ObjectState = DBOperation.INSERT;
                    LRRModel.UserSpecificRecordedProperties.Add(userSpProp);
                    recProps.Add(userSpProp);
                }
            }
            if (recProps.Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(recProps);
            }
            //
            //_lrrApp.DBManagerObj.CommitCollection(LRRModel.UserSpecificRecordedProperties.GetChanges());
            foreach (LRRUserSpecificTrendedProperty userSpTrProp in useSpecificTrAttrs)
            {
                if (LRRModel.UserSpecificTrendedProperties.GetUserSpecificTrendedPropertyByUIDAndSCPID(userSpTrProp.UID, userSpTrProp.SiteComponentPropertyID) == null)
                {
                    userSpTrProp.ObjectState = DBOperation.INSERT;
                    LRRModel.UserSpecificTrendedProperties.Add(userSpTrProp);
                    trProps.Add(userSpTrProp);
                }
            }
            if (trProps.Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(trProps);
            }
            //_lrrApp.DBManagerObj.CommitCollection(LRRModel.UserSpecificTrendedProperties.GetChanges());
            //LRRModel.RecordedProperties
            //recor
            //
            this.DialogResult = DialogResult.OK;
            /*
            if (LRRModel.SiteComponentPropertiesObj.GetChanges().Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(LRRModel.SiteComponentPropertiesObj.GetChanges());
            }
            */
            //LRRSiteComponentProperties scpsToSave = new LRRSiteComponentProperties();
            //LRRSiteGroupPropertyQualifierValues gpValuesToSave = new LRRSiteGroupPropertyQualifierValues();

            //for (int i = 0; i < scs.Count; i++)
            //{
            //    string scName = scs[i];


            /*
            
            
            for (int j = 0; j < scpS.Count; j++)
            {
                string scpID = scpS[j];
                LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(scpID);
                if (!calledFromTrendsWindow)
                {
                    if (scp != null)
                    {
                        scp.IsTracked = true;
                    }
                }
                else
                {
                    if (scp != null)
                    {
                        scp.IsTrended = true;
                    }
                }
            }
            for (int i = 0; i < removedSCList.Count; i++)
            {

            }

            //}
            for (int i = 0; i < nonRecSCP.Count; i++)
            {
                string scpID = nonRecSCP[i];
                LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(scpID);
                if (scp != null)
                {
                    if (!calledFromTrendsWindow)
                    {
                        scp.IsTracked = false;
                    }
                    else
                    {
                        scp.IsTrended = false;
                    }
                }
            }
            if (LRRModel.SiteComponentPropertiesObj.GetChanges().Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(LRRModel.SiteComponentPropertiesObj.GetChanges());
            }


            // commented by ashwin
            #region comments3
            /*
            foreach (string siteCompID in _listAllCompCollection)
            {
                foreach (string attrIDString in _listAllAttributes)
                {
                    string[] splitIDArr = attrIDString.Split(new char[] {'|'});
                    int countOfSubIDs = splitIDArr.Length;

                    bool flag = (_listSelectedAttributes.Contains(attrIDString) && _listSelectedCompCollection.Contains(siteCompID));

                    if (countOfSubIDs == 1) // Case of simple properties
                    {
                        string propID = attrIDString;
                        LRRMasterProperty masterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(propID);
                        if (masterProp != null)
                        {
                            LRRSiteComponentProperty siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, propID);
                            if (siteCompProp != null)
                            {
                                if (_isTrended)
                                    siteCompProp.IsTrended = flag;
                                else
                                    siteCompProp.IsTracked = flag;
                                scpsToSave.Add(siteCompProp);
                            }
                        }
                        else
                        {
                            LRRSiteComponentProperty siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propID);
                            if (siteCompProp != null)
                            {
                                if (_isTrended)
                                    siteCompProp.IsTrended = flag;
                                else
                                    siteCompProp.IsTracked = flag;
                                scpsToSave.Add(siteCompProp);
                            }
                        }
                    }
                    else if (countOfSubIDs == 2) // Case of Data Arrays
                    {
                        string masterPropID = splitIDArr[0];
                        string lookupPropID = splitIDArr[1];
                        LRRSiteComponentProperty siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, masterPropID);
                        foreach (LRRMode mode in LRRModel.ProjectModes)
                        {
                            string modeID = mode.ModeId;
                            LRRSiteGroupPropertyQualifierValue dataArrayValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForModeSiteCompAndLookUpProp(siteCompProp.ID, lookupPropID, modeID);

                            if (dataArrayValue != null)
                            {
                                if (_isTrended)
                                    dataArrayValue.IsTrended = flag;
                                else
                                    dataArrayValue.IsTracked = flag;

                                gpValuesToSave.Add(dataArrayValue);
                            }

                        }
                    }
                    else if (countOfSubIDs == 3) // Case of Grouped Properties
                    {
                        string qualifierID = splitIDArr[0];
                        string lookupPropID = splitIDArr[1];
                        string masterPropID = splitIDArr[2];

                        LRRSiteComponentProperty siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompID, masterPropID);
                        foreach (LRRMode mode in LRRModel.ProjectModes)
                        {
                            string modeID = mode.ModeId;
                            LRRSiteGroupPropertyQualifierValue grpPropValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForModeSiteCompAndLookUpProp(siteCompProp.ID, lookupPropID, modeID);

                            if (grpPropValue != null)
                            {
                                if (_isTrended)
                                    grpPropValue.IsTrended = flag;
                                else
                                    grpPropValue.IsTracked = flag;

                                gpValuesToSave.Add(grpPropValue);
                            }

                        } 
                    }
                }
            }

            // Save the data
            _lrrApp.DBManagerObj.ExecuteBatchUpdate(scpsToSave);
            _lrrApp.DBManagerObj.ExecuteBatchUpdate(gpValuesToSave);

            */
            #endregion
            /* this.DialogResult = DialogResult.OK; */
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            TimeComparer timeComparer = new TimeComparer();
            ArrayList baseObjects = new ArrayList();
            LRRSiteComponentProperties props = LRRModel.SiteComponentPropertiesObj.GetChanges();
            foreach (BaseObject obj in props)
            {
                if (obj.ObjectState != DBOperation.UNCHANGED)
                {
                    if (obj.UpdatedRecordStack.Count > 0)
                    {
                        object updatedObject = obj.UpdatedRecordStack.Peek();
                        baseObjects.Add(updatedObject);
                    }
                }
            }
            if (baseObjects.Count > 0)
            {
                baseObjects.Sort(timeComparer);
                foreach (UpdatedObject updatedObj in baseObjects)
                {
                    BaseObject obj = updatedObj.BsObject as BaseObject;
                
                    if(obj.ObjectState == DBOperation.UPDATE)
                    {
                        obj.RollBackChanges(true);
                    }
                }
                baseObjects.Clear();
            }
            //foreach (LRRSiteComponentProperty var in props)
            //{
            //    if (var.ObjectState == DBOperation.UPDATE)
            //    {
            //        var.RollBackChanges(true);
            //    }
                
            //}
            this.DialogResult = DialogResult.Cancel;
        }

        //#endregion

        //Hashtable recSCPHas = new Hashtable();
        List<string> recSCPHas = new List<string>();

        private void treeViewRecordedTrended_Click(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        LRRUserSpecificRecordedProperties useSpecificAtts = new LRRUserSpecificRecordedProperties();
        LRRUserSpecificTrendedProperties useSpecificTrAttrs = new LRRUserSpecificTrendedProperties();
        List<string> mpS = new List<string>();
        List<string> tMps = new List<string>();
        List<string> notRecordedSCP = new List<string>();
        List<string> notRecordedMP = new List<string>();
        private void treeViewRecordedTrendedAttr_AfterCheck_1(object sender, TreeViewEventArgs e)
        {
            //Right
            if (e.Action == TreeViewAction.ByKeyboard || e.Action == TreeViewAction.ByMouse || refreshScreen)
            {
                TreeNode currentNode = e.Node;
                if (currentNode != null)
                {
                    string masterPropID = string.Empty;
                    if (currentNode.Tag != null)
                    {
                        masterPropID = currentNode.Tag.ToString();
                    }
                    else
                    {
                        GetAllChildNodes(currentNode);
                        CheckIFParentNeedsToCheck(currentNode);
                        Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(currentNode);

                    }
                    if (!calledFromTrendsWindow)
                    {
                        if (masterPropID != null && masterPropID != "")
                        {
                            if (!mpS.Contains(masterPropID))
                            {
                                mpS.Add(masterPropID);
                            }
                        }
                    }
                    else
                    {
                        if (masterPropID != null && masterPropID != "")
                        {
                            if (!tMps.Contains(masterPropID))
                            {
                                tMps.Add(masterPropID);
                            }
                        }
                    }
                    foreach (string var in sitCompIDWithRecordedAttributes)
                    {
                        LRRSiteComponent sComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(var);
                        if (sComp != null)
                        {
                            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(sComp.SiteComponentID, masterPropID);
                            if (scp != null)
                            {

                                if (!calledFromTrendsWindow)
                                {
                                    LRRUserSpecificRecordedProperty uRecProp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                                    if (uRecProp == null)
                                    {
                                        uRecProp = new LRRUserSpecificRecordedProperty();
                                        uRecProp.SiteComponentPropertyID = scp.ID;
                                        uRecProp.ObjectState = DBOperation.INSERT;
                                        uRecProp.IsTracked = currentNode.Checked;
                                        uRecProp.UID = _lrrApp.UID;
                                        uRecProp.SiteComponentID = scp.ComponentID;
                                        uRecProp.Name = scp.Name;
                                        useSpecificAtts.Add(uRecProp);

                                    }
                                }
                                else
                                {
                                    LRRUserSpecificTrendedProperty uTrProp = LRRModel.UserSpecificTrendedProperties.GetUserSpecificTrendedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                                    if (uTrProp == null)
                                    {
                                        uTrProp = new LRRUserSpecificTrendedProperty();
                                        uTrProp.SiteComponentPropertyID = scp.ID;
                                        uTrProp.ObjectState = DBOperation.INSERT;
                                        uTrProp.IsTracked = currentNode.Checked;
                                        uTrProp.UID = _lrrApp.UID;
                                        uTrProp.SiteComponentID = scp.ComponentID;
                                        uTrProp.Name = scp.Name;
                                        useSpecificTrAttrs.Add(uTrProp);
                                        //scp.IsTrended = currentNode.Checked;
                                    }
                                }
                            }
                        }

                    }
                }

                RefreshScreen();
            }





            ////////////////////TreeNode currentNode = e.Node;

            ////////////////////if (e.Node.Parent != null)
            ////////////////////{
            ////////////////////    //////////if (e.Node.Checked == true)
            ////////////////////    //////////{
            ////////////////////    ////////if (e.Node.Parent != null)
            ////////////////////    ////////{
            ////////////////////    if (e.Node.Parent.Text.ToString() == "Master Attributes")
            ////////////////////    {
            ////////////////////        //LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(e.Node.Parent.Text.ToString());

            ////////////////////        for (int i = 0; i < scs.Count; i++)
            ////////////////////        {
            ////////////////////            LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(scs[i]);
            ////////////////////            if (sc != null)
            ////////////////////            {
            ////////////////////                //LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteComPropObjForMasterPropIDAndCompID(e.Node.Text.ToString(), sc.SiteComponentID);
            ////////////////////                LRRSiteComponentProperty scp = sc.Properties.GetSiteCompPropFromName(e.Node.Text.ToString());
            ////////////////////                scp.IsTracked = e.Node.Checked;
            ////////////////////                if (scp != null)
            ////////////////////                {
            ////////////////////                    if (!scpS.Contains(scp.ID))
            ////////////////////                    {
            ////////////////////                        scpS.Add(scp.ID);
            ////////////////////                        if (nonRecSCP.Contains(scp.ID))
            ////////////////////                            nonRecSCP.Remove(scp.ID);
            ////////////////////                    }
            ////////////////////                    if (!mpS.Contains(scp.PropertyID))
            ////////////////////                    {
            ////////////////////                        mpS.Add(scp.PropertyID);
            ////////////////////                    }
            ////////////////////                }
            ////////////////////            }
            ////////////////////        }
            ////////////////////        ////////}
            ////////////////////    }
            ////////}
            ////////else
            ////////{
            ////////    if (e.Node.Parent != null)
            ////////    {
            ////////        if (e.Node.Parent.Text.ToString() == "Master Attributes")
            ////////        {
            ////////            for (int i = 0; i < scs.Count; i++)
            ////////            {
            ////////                LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(scs[i]);
            ////////                if (sc != null)
            ////////                {
            ////////                    LRRSiteComponentProperty scp = sc.Properties.GetSiteCompPropFromName(e.Node.Text.ToString());
            ////////                    if (scp != null)
            ////////                    {
            ////////                        if (scpS.Contains(scp.ID))
            ////////                            scpS.Remove(scp.ID);
            ////////                        if (mpS.Contains(scp.PropertyID))
            ////////                            mpS.Remove(scp.PropertyID);
            ////////                        if (!nonRecSCP.Contains(scp.ID))
            ////////                            nonRecSCP.Add(scp.ID);
            ////////                        if (!nonRecMPID.Contains(scp.PropertyID))
            ////////                            nonRecMPID.Add(scp.PropertyID);
            ////////                    }
            ////////                }
            ////////            }
            ////////        }
            ////////    }
            ////////}

            //}
        }
        bool refreshScreen = false;
        List<string> scs = new List<string>();
        List<string> scpS = new List<string>();
        List<string> removedSCList = new List<string>();
        private void treeViewRecordedTrended_AfterCheck_1(object sender, TreeViewEventArgs e)
        {
            //Left
            if (e.Action == TreeViewAction.ByKeyboard || e.Action == TreeViewAction.ByMouse || refreshScreen)
            {
                TreeNode currentNode = e.Node;

                if (currentNode.Tag != null)
                {
                    string currentSiteCompID = string.Empty;
                    currentSiteCompID = currentNode.Tag.ToString();
                    LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(currentSiteCompID);
                    if (e.Node.Checked)
                    {
                        if (!sitCompIDWithRecordedAttributes.Contains(currentSiteCompID))
                        {
                            sitCompIDWithRecordedAttributes.Add(currentSiteCompID);
                        }
                    }
                    else
                    {
                        if (sitCompIDWithRecordedAttributes.Contains(currentSiteCompID))
                            sitCompIDWithRecordedAttributes.Remove(currentSiteCompID);
                    }
                    //List<string> recordedList = new List<string>();
                    //recordedList.AddRange(allRecordedList);
                    //recordedList.AddRange(partiallyRecordedList);
                    // code commented by ashwin
                    /*
                    foreach (string masterPropID in allRecordedList)
                    {

                        LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(currentSiteCompID, masterPropID);
                        if (calledFromTrendsWindow)
                        {
                            scp.IsTrended = e.Node.Checked;
                        }
                        else
                        {
                            scp.IsTracked = e.Node.Checked;

                        }

                    }
                     * */
                }
                else
                {
                    GetAllChildNodes(currentNode);
                    CheckIFParentNeedsToCheck(currentNode);
                    Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(currentNode);

                }
                if (mpS.Count > 0)
                {
                    if (currentNode.Tag != null)
                    {
                        string currentSiteCompID = string.Empty;
                        currentSiteCompID = currentNode.Tag.ToString();
                        for (int i = 0; i < mpS.Count; i++)
                        {
                            string masterPropID = mpS[i];
                            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(currentSiteCompID, masterPropID);
                            if (scp != null)
                            {
                                LRRUserSpecificRecordedProperty uRecProp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                                if (uRecProp == null)
                                {
                                    uRecProp = new LRRUserSpecificRecordedProperty();
                                    uRecProp.SiteComponentPropertyID = scp.ID;
                                    uRecProp.ObjectState = DBOperation.INSERT;
                                    uRecProp.IsTracked = currentNode.Checked;
                                    uRecProp.UID = _lrrApp.UID;
                                    uRecProp.SiteComponentID = scp.ComponentID;
                                    uRecProp.Name = scp.Name;
                                    useSpecificAtts.Add(uRecProp);

                                }

                            }
                        }
                    }

                }
                if (tMps.Count > 0)
                {
                    if (currentNode.Tag != null)
                    {
                        string currentSiteCompID = string.Empty;
                        currentSiteCompID = currentNode.Tag.ToString();
                        for (int i = 0; i < tMps.Count; i++)
                        {
                            string masterPropID = tMps[i];
                            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(currentSiteCompID, masterPropID);
                            if (scp != null)
                            {
                                LRRUserSpecificTrendedProperty uRecProp = LRRModel.UserSpecificTrendedProperties.GetUserSpecificTrendedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                                if (uRecProp == null)
                                {
                                    uRecProp = new LRRUserSpecificTrendedProperty();
                                    uRecProp.SiteComponentPropertyID = scp.ID;
                                    uRecProp.ObjectState = DBOperation.INSERT;
                                    uRecProp.IsTracked = currentNode.Checked;
                                    uRecProp.UID = _lrrApp.UID;
                                    uRecProp.SiteComponentID = scp.ComponentID;
                                    uRecProp.Name = scp.Name;
                                    useSpecificTrAttrs.Add(uRecProp);
                                    
                                }

                            }
                        }

                    }
                }
                RefreshScreen();
            }
            #region com6
            /*

            if (e.Node.Parent != null)
            {
                if (e.Action.ToString() == "ByMouse" && (e.Node.Checked == true))
                {
                    if (e.Node.Parent != null)
                    {
                        if (e.Node.Parent.Text.ToString() == "Master Attributes")
                        {
                            //LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(e.Node.Parent.Text.ToString());
                            foreach (LRRSiteComponentProperty scp1 in LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(e.Node.Tag.ToString()))
                            {
                                if (GridSavedViewController.CalledFromTrendedWindow)
                                {
                                    if (!checkedAttrListForTrend.Contains(scp1.ID))
                                    {
                                        checkedAttrListForTrend.Add(scp1.ID);
                                    }
                                    //scp1.IsTrended = true;
                                }
                                else
                                {
                                    if (!checkedAttrListForRec.Contains(scp1.ID))
                                    {
                                        checkedAttrListForRec.Add(scp1.ID);
                                    }
                                    //scp1.IsTracked = true;
                                }

                            }

                        }
                    }
                }
                else
                {
                    if (e.Action.ToString() == "ByMouse" && (e.Node.Parent != null) && (e.Node.Checked == false))
                    {
                        LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(e.Node.Parent.Text.ToString());
                        foreach (LRRSiteComponentProperty scp1 in LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(e.Node.Tag.ToString()))
                        {
                            if (GridSavedViewController.CalledFromTrendedWindow)
                            {
                                if (!unCheckedAttrListForTrend.Contains(scp1.ID))
                                {
                                    unCheckedAttrListForTrend.Add(scp1.ID);
                                }
                                //scp1.IsTrended = false;
                            }
                            else
                            {
                                if (!unCheckedAttrListForRec.Contains(scp1.ID))
                                {
                                    unCheckedAttrListForRec.Add(scp1.ID);
                                }
                                //scp1.IsTracked = false;
                            }

                        }
                    }
                }
                if (e.Action == TreeViewAction.ByMouse || e.Action == TreeViewAction.ByKeyboard)
                {
                    GetAllChildNodes(currentNode);
                    CheckIFParentNeedsToCheck(currentNode);
                }

                Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversionOnLoad(currentNode);
            
            }*/
            #endregion
        }
    }
}