using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Grouping;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ComplexEquipment.
	/// </summary>
	public class ComplexEquipment : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.ComponentModel.IContainer components = null;

		#region Fields
		private LRRComplexEquipments		_complexEquipmentGrpList; //Data Source for the grid to show the complex equipment groups
		
		private LRRComplexEquipGroupings	_complexEquipmentGrpItemList; //Collection to get complex equipment groups items i.e equipments already mapped.
		private LRRComplexEquipGroupings	_complexEquipItemsOrg;
		
		private LRRApp						_app;
		private LRRSiteComponents			_siteComponentsList; //Collection to get site component list.
		
		private string						_resetInvoked="0";
		
		private GridRecordNavigationControl gnc = new GridRecordNavigationControl();
		
		private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		//private LRRUIManager lrrUI=new LRRUIManager();
		private GridUnBoundColumn			gridUnBoundEquip=new GridUnBoundColumn();

		private TabControl			_parentTabControl;
		private System.Windows.Forms.Panel pnlRightCE;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridEquipmentItems;
		private System.Windows.Forms.Panel pnlleftCE;
		private System.Windows.Forms.Panel pnlFullCE;
		private System.Windows.Forms.Panel pnlLeftCEquip;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridComplexEquipment;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteComponents;
		private System.Windows.Forms.Panel pnlTop;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Splitter splitter2;
		private TabPage				_parentTabPage;

	#endregion

		#region Public & Protected Members
		public ComplexEquipment()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			InitDataSource();
			
			_gridExcelFormatter.WireGrid(gridComplexEquipment);

			bindGrids();

		}
		public void bindGrids()
		{
			bindComplexEquipmentGrid();
			bindSiteComponents();
			bindEquipmentItemsGrid();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion 

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ComplexEquipment));
			this.pnlFullCE = new System.Windows.Forms.Panel();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.pnlRightCE = new System.Windows.Forms.Panel();
			this.gridEquipmentItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlleftCE = new System.Windows.Forms.Panel();
			this.pnlLeftCEquip = new System.Windows.Forms.Panel();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.gridSiteComponents = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlTop = new System.Windows.Forms.Panel();
			this.gridComplexEquipment = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlFullCE.SuspendLayout();
			this.pnlRightCE.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridEquipmentItems)).BeginInit();
			this.pnlleftCE.SuspendLayout();
			this.pnlLeftCEquip.SuspendLayout();
			this.pnlBottom.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridSiteComponents)).BeginInit();
			this.pnlTop.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridComplexEquipment)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlFullCE
			// 
			this.pnlFullCE.Controls.Add(this.splitter2);
			this.pnlFullCE.Controls.Add(this.pnlRightCE);
			this.pnlFullCE.Controls.Add(this.pnlleftCE);
			this.pnlFullCE.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlFullCE.Location = new System.Drawing.Point(0, 0);
			this.pnlFullCE.Name = "pnlFullCE";
			this.pnlFullCE.Size = new System.Drawing.Size(1016, 590);
			this.pnlFullCE.TabIndex = 1;
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(760, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 590);
			this.splitter2.TabIndex = 4;
			this.splitter2.TabStop = false;
			// 
			// pnlRightCE
			// 
			this.pnlRightCE.Controls.Add(this.gridEquipmentItems);
			this.pnlRightCE.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlRightCE.Location = new System.Drawing.Point(760, 0);
			this.pnlRightCE.Name = "pnlRightCE";
			this.pnlRightCE.Size = new System.Drawing.Size(256, 590);
			this.pnlRightCE.TabIndex = 2;
			// 
			// gridEquipmentItems
			// 
			this.gridEquipmentItems.BackColor = System.Drawing.SystemColors.Window;
			this.gridEquipmentItems.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridEquipmentItems.Location = new System.Drawing.Point(0, 0);
			this.gridEquipmentItems.Name = "gridEquipmentItems";
			this.gridEquipmentItems.Size = new System.Drawing.Size(256, 590);
			this.gridEquipmentItems.TabIndex = 0;
			this.gridEquipmentItems.TableDescriptor.AllowEdit = false;
			this.gridEquipmentItems.TableDescriptor.AllowNew = false;
			this.gridEquipmentItems.TableDescriptor.AllowRemove = false;
			this.gridEquipmentItems.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)));
			this.gridEquipmentItems.Text = "gridEquipmentItems";
			this.gridEquipmentItems.TopLevelGroupOptions.CaptionText = "Plant Item(s) included in Complex Equipment : {RecordCount} Items";
			this.gridEquipmentItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridEquipmentItems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridEquipmentItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridEquipmentItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridEquipmentItems.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridEquipmentItems.VersionInfo = "3.301.0.0";
			// 
			// pnlleftCE
			// 
			this.pnlleftCE.Controls.Add(this.pnlLeftCEquip);
			this.pnlleftCE.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlleftCE.Location = new System.Drawing.Point(0, 0);
			this.pnlleftCE.Name = "pnlleftCE";
			this.pnlleftCE.Size = new System.Drawing.Size(760, 590);
			this.pnlleftCE.TabIndex = 0;
			// 
			// pnlLeftCEquip
			// 
			this.pnlLeftCEquip.Controls.Add(this.pnlBottom);
			this.pnlLeftCEquip.Controls.Add(this.splitter1);
			this.pnlLeftCEquip.Controls.Add(this.pnlTop);
			this.pnlLeftCEquip.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlLeftCEquip.Location = new System.Drawing.Point(0, 0);
			this.pnlLeftCEquip.Name = "pnlLeftCEquip";
			this.pnlLeftCEquip.Size = new System.Drawing.Size(760, 590);
			this.pnlLeftCEquip.TabIndex = 0;
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.gridSiteComponents);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlBottom.Location = new System.Drawing.Point(0, 308);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(760, 282);
			this.pnlBottom.TabIndex = 6;
			// 
			// gridSiteComponents
			// 
			this.gridSiteComponents.BackColor = System.Drawing.SystemColors.Window;
			this.gridSiteComponents.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSiteComponents.Location = new System.Drawing.Point(0, 0);
			this.gridSiteComponents.Name = "gridSiteComponents";
			this.gridSiteComponents.Size = new System.Drawing.Size(760, 282);
			this.gridSiteComponents.TabIndex = 3;
			this.gridSiteComponents.Text = "gridSiteComponents";
			this.gridSiteComponents.TopLevelGroupOptions.CaptionText = "Plant Item(s) available for inclusion: {RecordCount} Items";
			this.gridSiteComponents.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridSiteComponents.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridSiteComponents.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridSiteComponents.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridSiteComponents.VersionInfo = "3.301.0.0";
			this.gridSiteComponents.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridSiteComponents_RecordValueChanged);
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 304);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(760, 4);
			this.splitter1.TabIndex = 5;
			this.splitter1.TabStop = false;
			// 
			// pnlTop
			// 
			this.pnlTop.Controls.Add(this.gridComplexEquipment);
			this.pnlTop.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlTop.Location = new System.Drawing.Point(0, 0);
			this.pnlTop.Name = "pnlTop";
			this.pnlTop.Size = new System.Drawing.Size(760, 304);
			this.pnlTop.TabIndex = 4;
			// 
			// gridComplexEquipment
			// 
			this.gridComplexEquipment.BackColor = System.Drawing.SystemColors.Window;
			this.gridComplexEquipment.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridComplexEquipment.Location = new System.Drawing.Point(0, 0);
			this.gridComplexEquipment.Name = "gridComplexEquipment";
			this.gridComplexEquipment.Size = new System.Drawing.Size(760, 304);
			this.gridComplexEquipment.TabIndex = 2;
			this.gridComplexEquipment.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridComplexEquipment.Text = "gridComplexEquipment";
			this.gridComplexEquipment.TopLevelGroupOptions.CaptionText = "Complex Equipment  Definition: {RecordCount} Items";
			this.gridComplexEquipment.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridComplexEquipment.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridComplexEquipment.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridComplexEquipment.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridComplexEquipment.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridComplexEquipment.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridComplexEquipment.VersionInfo = "3.301.0.0";
			this.gridComplexEquipment.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridComplexEquipment_RecordDeleting);
			// 
			// ComplexEquipment
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1016, 590);
			this.Controls.Add(this.pnlFullCE);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ComplexEquipment";
			this.Tag = "SID_220";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.ComplexEquipment_Load);
			this.Closed += new System.EventHandler(this.ComplexEquipment_Closed);
			this.pnlFullCE.ResumeLayout(false);
			this.pnlRightCE.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridEquipmentItems)).EndInit();
			this.pnlleftCE.ResumeLayout(false);
			this.pnlLeftCEquip.ResumeLayout(false);
			this.pnlBottom.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridSiteComponents)).EndInit();
			this.pnlTop.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridComplexEquipment)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Symcon Private Methods
		
		/// <summary>
		/// This method binds the grid to the cached data store ..
		/// </summary>
		private void bindComplexEquipmentGrid()
		{
			

			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridComplexEquipment.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridComplexEquipment);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridComplexEquipment,_complexEquipmentGrpList.ItemType,null);

			RelativeWidths.Add("Name",40);
			RelativeWidths.Add("Description",65);
			SyncGridUtilities.InitializeGridColumnsWidth(gridComplexEquipment,RelativeWidths );

			gridComplexEquipment.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_COMPLEX_EQUIP_DEFINATION") + " { RecordCount } " + LRRHeaderText.GetHeaderString("SID_ITEMS");    
				
			//Set the data store 
			gridComplexEquipment.DataSource = _complexEquipmentGrpList;

			gridComplexEquipment.TableDescriptor.AllowNew = true;
			gridComplexEquipment.TableDescriptor.AllowRemove = true;
			gridComplexEquipment.TableDescriptor.AllowEdit = true;

			this.gridComplexEquipment.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			//Resume the Layout of the Grid...
			gridComplexEquipment.ResumeLayout(false);

			gridComplexEquipment.CurrentRecordContextChange+=new CurrentRecordContextChangeEventHandler(gridComplexEquipment_CurrentRecordContextChange);
			

			//Add the parent table for the Relations...
			gridComplexEquipment.Engine.SourceListSet.Add("ParentTable",_complexEquipmentGrpList);

			string[,] arry=new string[,]{{"Description","255"}};
			Validations	obj=new Validations(gridComplexEquipment,arry);

			
		}
		
		
		/// <summary>
		/// This Method initializes the data source.
		/// </summary>
		private void InitDataSource()
		{
		

			if(_resetInvoked=="0")
			{
				if(_complexEquipmentGrpList != null)
					_complexEquipmentGrpList.Clear();
			
				if(_complexEquipmentGrpItemList != null)
					_complexEquipmentGrpItemList.Clear();
			
				if(_complexEquipItemsOrg != null)
					_complexEquipItemsOrg.Clear();

				if(_siteComponentsList != null)
					_siteComponentsList.Clear();
			

				_complexEquipmentGrpList = new LRRComplexEquipments();
				_app.DBManagerObj.PopulateCollection(_complexEquipmentGrpList,false);

				_siteComponentsList = new LRRSiteComponents();
				_app.DBManagerObj.PopulateCollection(_siteComponentsList,false);

				_complexEquipItemsOrg = new LRRComplexEquipGroupings();
				_app.DBManagerObj.PopulateCollection(_complexEquipItemsOrg,false);

				_complexEquipmentGrpItemList = new LRRComplexEquipGroupings();
				_complexEquipmentGrpItemList = _complexEquipItemsOrg;



			}
			else
			{
				_complexEquipmentGrpList.RefreshCollection();
				_complexEquipmentGrpItemList.RefreshCollection();
				_siteComponentsList.RefreshCollection();
				_complexEquipItemsOrg.RefreshCollection();
			}

		}
		
		/// <summary>
		/// This Method binds the site component grid to the data source.
		/// </summary>
		private void bindEquipmentItemsGrid()
		{
			
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay = new Hashtable();

			//Suspend the Layout of the Grid...
			gridEquipmentItems.SuspendLayout();
			
			gridEquipmentItems.TopLevelGroupOptions.CaptionText =  LRRHeaderText.GetHeaderString("SID_INCLUDED_PLANTITEMS") + " { RecordCount } " + LRRHeaderText.GetHeaderString("SID_ITEMS");    
			SyncGridUtilities.InitializeGridLookAndFeel(gridEquipmentItems);
			
			ReSetGridComplexEquipItems();

			this.gridEquipmentItems.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			//Resume the Layout of the Grid...
			gridEquipmentItems.ResumeLayout(false);
			
			//Add the parent table for the Relations...
			gridEquipmentItems.Engine.SourceListSet.Add("ParentTable",_complexEquipmentGrpItemList);
			

		}

		/// <summary>
		/// This Method binds the site component grid to the data source.
		/// </summary>
		private void bindSiteComponents()
		{
			
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay = new Hashtable();

			//Suspend the Layout of the Grid...
			gridSiteComponents.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridSiteComponents);

			gridSiteComponents.TopLevelGroupOptions.CaptionText =  LRRHeaderText.GetHeaderString("SID_PLANTITEMS_FOR_INCLUSION") + " { RecordCount } " + LRRHeaderText.GetHeaderString("SID_ITEMS");    
			
			columnForDisplay.Add("Name",null);
			columnForDisplay.Add("MasterComponentType",null);
			columnForDisplay.Add("Description",null);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridSiteComponents,_siteComponentsList.ItemType,null,true,columnForDisplay);
			
			gridSiteComponents.TableDescriptor.Columns.Clear();		
			gridUnBoundEquip.WireGrid(gridSiteComponents);
			
			gridSiteComponents.TableDescriptor.Columns.Add("Name","Name");
			gridSiteComponents.TableDescriptor.Columns.Add("Description","Description");
			gridSiteComponents.TableDescriptor.Columns.Add("Master Component Type","MasterComponentType_ComponentName");
			
			RelativeWidths.Add("Name",30);
			RelativeWidths.Add("Description",33);
			RelativeWidths.Add("MasterComponentType_ComponentName",35);

			SyncGridUtilities.InitializeGridColumnsWidth(gridSiteComponents,RelativeWidths );

			gridSiteComponents.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridSiteComponents.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			
			gridSiteComponents.TableDescriptor.AllowRemove = false;
			gridSiteComponents.TableDescriptor.AllowEdit = true;
			gridSiteComponents.TableDescriptor.AllowNew = false;

			gridSiteComponents.TableDescriptor.Columns[1].ReadOnly = true;
			gridSiteComponents.TableDescriptor.Columns[2].ReadOnly = true;
			gridSiteComponents.TableDescriptor.Columns[3].ReadOnly = true;
			
			//Set the data store 
			gridSiteComponents.DataSource = _siteComponentsList;

			this.gridSiteComponents.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			//Resume the Layout of the Grid...
			gridSiteComponents.ResumeLayout(false);

			

			//Add the parent table for the Relations...
			gridSiteComponents.Engine.SourceListSet.Add("ChildTable",_siteComponentsList);
			
		}

		/// <summary>
		/// This Method resets the collection objects & rebinds the grid.
		/// </summary>
		private void resetValues()
		{
			gridComplexEquipment.TableControl.Selections.Clear();
			clearAllCollections();
			_resetInvoked="1";
			_app.DBManagerObj.PopulateCollection(_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRComplexEquipments)));
			_app.DBManagerObj.PopulateCollection(_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRComplexEquipGroupings)));

			InitDataSource();
			bindComplexEquipmentGrid();
			bindSiteComponents();
			_resetInvoked="0";		

		}

		
		/// <summary>
		/// This Method refreshes clears all the collection objects
		/// </summary>		
		private void clearAllCollections()
		{
			_complexEquipmentGrpItemList.RefreshCollection();
			_complexEquipmentGrpList.RefreshCollection();
			_siteComponentsList.RefreshCollection();
			
			//RefreshSiteCompList();
			gridComplexEquipment.TableControl.Refresh();
			gridSiteComponents.TableControl.Refresh();
		}


		/// <summary>
		/// This Method refreshes the site component list to undo the record selected based on the record in the complex equipment group
		/// </summary>		
		private void RefreshSiteCompList()
		{
			_siteComponentsList.RefreshCollection();

			//initialize the collection so that all the site components have isSelected = false
			_siteComponentsList.ItemFilter = "IsSelected = true" ;
							
			for(int j=0;j<_siteComponentsList.Count;j++)
			{
				_siteComponentsList[j].IsSelected=false;
			}
							
			_siteComponentsList.ItemFilter = "";
		}

		private void ReSetGridComplexEquipItems()
		{
			gridEquipmentItems.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_complexEquipmentGrpItemList.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridEquipmentItems,_complexEquipmentGrpItemList.ItemType,null,fkData);
			Hashtable RelativeWidths = new Hashtable();
			RelativeWidths.Add("EquipmentID_Name",180);
			SyncGridUtilities.InitializeGridColumnsWidth(gridEquipmentItems,RelativeWidths );
			gridEquipmentItems.TableDescriptor.Columns["EquipmentID_Name"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridEquipmentItems.TableDescriptor.Columns["EquipmentID_Name"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridEquipmentItems.DataSource = null;
			gridEquipmentItems.DataSource = _complexEquipmentGrpItemList;
			gridEquipmentItems.Engine.SourceListSet.Add("ParentTable",_complexEquipmentGrpItemList);
		}
		private LRRComplexEquipGroupings FormDataSourceForComplexEquipItems(string sComplexEquipID)
		{
			LRRComplexEquipGroupings objLRRComplexEquipGroupings = new LRRComplexEquipGroupings();
			IEnumerator ieNum = _complexEquipItemsOrg.GetEnumerator();
			while(ieNum.MoveNext())
			{
				try
				{
					LRRComplexEquipGrouping lrrComplexEquipGroupings = (LRRComplexEquipGrouping)ieNum.Current;
					if(lrrComplexEquipGroupings != null)
					{
						if(lrrComplexEquipGroupings.ComplexEquipID == sComplexEquipID)
							objLRRComplexEquipGroupings.Add(lrrComplexEquipGroupings);
					}
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ComplexEquipment),ex.Message  ,Logger.Level.Debug);
				}
			}
			return objLRRComplexEquipGroupings;
		}
		#endregion

		#region Event Handlers
		/// <summary>
		/// This Method is invoked when updates to the site component grid is done.
		/// </summary>		
		private void gridSiteComponents_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			string sEquipmentID;
			if (gridComplexEquipment.CurrencyManager.Count > 0 )
			{
				LRRComplexEquipment complexEquipment = gridComplexEquipment.CurrencyManager.Current as LRRComplexEquipment;
				string sComplexEquipID = complexEquipment.ComplexEquipID == null ? "" : complexEquipment.ComplexEquipID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

				if(complexEquipment!= null)
				{
					sEquipmentID = e.Record.GetValue("SiteComponentID").ToString();

					if(e.Record.GetValue("Select").ToString().ToUpper() == "TRUE")
					{
						if(_complexEquipmentGrpItemList.GetItemsByComplexEquipmentIDSiteCompID(sComplexEquipID,sEquipmentID).Count == 0)
						{
							LRRComplexEquipGrouping objLRRComplexEquipGrouping = new LRRComplexEquipGrouping();
							objLRRComplexEquipGrouping.EquipmentID = sEquipmentID;
							objLRRComplexEquipGrouping.ComplexEquipID = sComplexEquipID;
							_complexEquipmentGrpItemList.Add(objLRRComplexEquipGrouping);
							_complexEquipItemsOrg.Add(objLRRComplexEquipGrouping);
						}	
					}
					else
					{
						if(_complexEquipmentGrpItemList.GetItemsByComplexEquipmentIDSiteCompID(sComplexEquipID,sEquipmentID).Count > 0)
						{
							LRRComplexEquipGrouping objLRRComplexEquipGrouping = _complexEquipmentGrpItemList.GetItemsByComplexEquipmentIDSiteCompID(sComplexEquipID,sEquipmentID)[0];
							_complexEquipmentGrpItemList.Remove(objLRRComplexEquipGrouping);
							_complexEquipItemsOrg.Remove(objLRRComplexEquipGrouping);
						}	
					}
				}
			}
			
			
		}
		
		

		/// <summary>
		/// This Method updates the site component grid for the record selected in the complex equipment group
		/// </summary>		
		private void gridComplexEquipment_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
		{
			Cursor=Cursors.WaitCursor;	
			string sComplexEquipItemID="";
			string sComplexEquipID="";

			if(e.Action == CurrentRecordAction.NavigateComplete)
			{
				if(e.Table.CurrentRecord != null)
				{
					if(e.Table.CurrentRecord.Kind.ToString(Symcon.BusinessObjects.SymConverter.Culture) == "AddNewRecord") 
					{
						LRRComplexEquipGroupings objComplexEquipGroupings = FormDataSourceForComplexEquipItems(null);
						_complexEquipmentGrpItemList = objComplexEquipGroupings;
						
						ReSetGridComplexEquipItems();

						_siteComponentsList.RefreshCollection();
						gridUnBoundEquip.ClearSelectedRecords();
						gridSiteComponents.TableControl.Refresh();
						gridEquipmentItems.TableControl.Refresh();
						return;
					}
				}
			}
			if (gridComplexEquipment.CurrencyManager.Count > 0 )
			{
				LRRComplexEquipment complexEuipObj = gridComplexEquipment.CurrencyManager.Current as LRRComplexEquipment;
				sComplexEquipID = complexEuipObj.ComplexEquipID == null ? "" : complexEuipObj.ComplexEquipID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

				if(complexEuipObj!= null)
				{
					if(e.Action == CurrentRecordAction.NavigateComplete)
					{
						gridUnBoundEquip.ClearSelectedRecords();
						
						LRRComplexEquipGroupings objComplexEquipGroupings = FormDataSourceForComplexEquipItems(sComplexEquipID);

						object[] objArrComplexEquipGroupings=new object[objComplexEquipGroupings.Count];

						_complexEquipmentGrpItemList = objComplexEquipGroupings;

						ReSetGridComplexEquipItems();

						for(int i=0; i<_complexEquipmentGrpItemList.Count;i++)
						{
							sComplexEquipItemID = _complexEquipmentGrpItemList[i].EquipmentID;
							LRRSiteComponent objSiteComp = _siteComponentsList.GetSiteComponentByID(sComplexEquipItemID);
							if(objSiteComp != null)
							{
								objArrComplexEquipGroupings[i] = objSiteComp;
							}
						}
						gridUnBoundEquip.SetSelectedRecords(objArrComplexEquipGroupings);
						gridSiteComponents.Engine.TableControl.Refresh();
						gridEquipmentItems.Refresh();
					}
				}
			}
		}
		

		/// <summary>
		/// This Method is invoked when the user clicks on the save button in the toolbar.
		/// </summary>
		private void barItemSave_Clicked(object sender, System.EventArgs e)
		{
			Save();
			
		}	
		
		
		
		private void ComplexEquipment_Load(object sender, System.EventArgs e)
		{
			gridSiteComponents.Refresh();
		}
		

		private void ComplexEquipment_Closed(object sender, System.EventArgs e)
		{
			_gridExcelFormatter.UnwireGrid();
		}
		

	#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			
			clearAllCollections();
			_resetInvoked="0";
			InitDataSource();
			bindGrids();
			gridSiteComponents.Refresh();
		}

		public void Save()
		{
			bool isSaved = false;
			try
				{
					if(Utilities.CheckDuplicate(_complexEquipmentGrpList,"Name","ComplexEquipID")) 
						return;
				
					//--Save operation for Complex Equipment
					LRRComplexEquipments complexEquipmentToSave = _complexEquipmentGrpList.GetChanges();
					
					//Commit the changes to the database
					if(complexEquipmentToSave.Count >0)
					{
						_app.DBManagerObj.CommitCollection(complexEquipmentToSave);
						
						if(complexEquipmentToSave.HasError)
						{
							LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
							return;
						}
						else
							isSaved=true;
					}

					//-- Save operation for Complex Equipment Group Items
					LRRComplexEquipGroupings complexEquipmentItemsToSave = _complexEquipItemsOrg.GetChanges();
					//Commit the changes to the database
					if(complexEquipmentItemsToSave.Count > 0)
					{
						bool bSameItemInAnotherCE = false;

						foreach(LRRComplexEquipGrouping complexEquipmentItem in complexEquipmentItemsToSave)
						{
							string sCompID =complexEquipmentItem.EquipmentID == null ? "" : complexEquipmentItem.EquipmentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							string sCompEquipID =complexEquipmentItem.ComplexEquipID == null ? "" : complexEquipmentItem.ComplexEquipID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							foreach(LRRComplexEquipGrouping complexEquipmentOtherItem in _complexEquipItemsOrg)
							{
								if((complexEquipmentOtherItem.EquipmentID == sCompID) && (complexEquipmentOtherItem.ComplexEquipID != sCompEquipID))
								{
									bSameItemInAnotherCE = true;
									break;
								}
							}
							if(bSameItemInAnotherCE)
							{
								LRRMessagBox.ShowMessage("SID_CE_EQUIP_WARNING","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Warning);
								break;
							}
						}
						_app.DBManagerObj.CommitCollection(complexEquipmentItemsToSave);
						if (complexEquipmentItemsToSave.HasError)
						{		
							LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
						}
						else
							isSaved=true;
					}
					
					complexEquipmentToSave = null;
					complexEquipmentItemsToSave = null;
					resetValues();
					if(isSaved)
					{
						LRRMessagBox.ShowMessage("SID_SAVEDINFO",true); 
					}					
					else
					{
						LRRMessagBox.ShowMessage("SID_NODATASAVED",true);  
					}				
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ComplexEquipment),"Error in Save:"+ex.Message  ,Logger.Level.Error);
				}
		}

		public void CopyMasterProperties()
		{
			
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridComplexEquipment.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridComplexEquipment,false);
			}
			if(gridEquipmentItems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridEquipmentItems,false);
			}
			if(this.gridSiteComponents.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSiteComponents,false);
			}

		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add ComplexEquip.ClearFilter implementation
			this.gridComplexEquipment.TableDescriptor.RecordFilters.Clear();
			this.gridSiteComponents.TableDescriptor.RecordFilters.Clear();
			
		}
		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridComplexEquipment);
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridComplexEquipment);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			InsertNewRowsForm insNewRows = new InsertNewRowsForm();
			DialogResult dlgResult = insNewRows.ShowDialog(this);
			int iNumofRows = insNewRows.iNewRows;
			if(dlgResult == DialogResult.OK)
			{
				for(int i = 0; i < iNumofRows;i++)
				{
					LRRComplexEquipment ce = new LRRComplexEquipment();
					_complexEquipmentGrpList.Add(ce);
				}
				gridComplexEquipment.Refresh();
			}
			else
			{
				return;
			}
		}

		public void Export()
		{
			if(gridComplexEquipment.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridComplexEquipment);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		public void ClearSort()
		{
			//ComplexEquipment.ClearSort implementation
			SyncGridUtilities.ClearSort(gridComplexEquipment);
			SyncGridUtilities.ClearSort(gridSiteComponents);
		}

		public bool SupportsClearSort()
		{
			// ComplexEquipment.SupportsClearSort implementation
			return true;
		}

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		public void PrintPreview()
		{
			// TODO:  Add ComplexEquipment.PrintPreview implementation
			if(gridComplexEquipment.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridComplexEquipment,true);
			}
			if(gridEquipmentItems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridEquipmentItems,true);
			}
			if(this.gridSiteComponents.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSiteComponents,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add ComplexEquipment.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add ComplexEquipment.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add ComplexEquipment.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add ComplexEquipment.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add ComplexEquipment.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
            SyncGridUtilities.RollBackChanges(this.gridComplexEquipment);
            SyncGridUtilities.RollBackChanges(this.gridEquipmentItems);
            SyncGridUtilities.RollBackChanges(this.gridSiteComponents);
            Refresh();
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add ComplexEquipment.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add ComplexEquipment.SupportsUndo implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add ComplexEquipment.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add ComplexEquipment.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add ComplexEquipment.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add ComplexEquipment.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add ComplexEquipment.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add ComplexEquipment.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add ComplexEquipment.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add ComplexEquipment.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add ComplexEquipment.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}
		private void gridComplexEquipment_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{	
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
			}
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add ComplexEquipment.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
