using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects;
using Symcon.Lightridge.LRRUI.Controls;


using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;    

namespace Symcon.LightRidge.PEAdvisor
{

	/// <summary>
	/// Summary description for CompositeFileDialog.
	/// </summary>
	public class CompositeFileDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnCancel;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridCompositeViews;
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CompositeFileDialog()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);

		}

		public CompositeFileDialog(CustomCollection custCollection)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitializeGrid(custCollection);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CompositeFileDialog));
            this.panel1 = new System.Windows.Forms.Panel();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.gridCompositeViews = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.btnCancel = new System.Windows.Forms.Button();
            this.btnOpen = new System.Windows.Forms.Button();
            this.panel2 = new System.Windows.Forms.Panel();
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridCompositeViews)).BeginInit();
            this.panel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel1.Controls.Add(this.splitter1);
            this.panel1.Controls.Add(this.gridCompositeViews);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(450, 192);
            this.panel1.TabIndex = 1;
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter1.Enabled = false;
            this.splitter1.Location = new System.Drawing.Point(0, 187);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(448, 3);
            this.splitter1.TabIndex = 9;
            this.splitter1.TabStop = false;
            this.splitter1.Visible = false;
            // 
            // gridCompositeViews
            // 
            this.gridCompositeViews.Appearance.TopLeftHeaderCell.CellAppearance = Syncfusion.Windows.Forms.Grid.GridCellAppearance.Flat;
            this.gridCompositeViews.Appearance.TopLeftHeaderCell.CellType = "Row Header Cell";
            this.gridCompositeViews.Appearance.TopLeftHeaderCell.Clickable = false;
            this.gridCompositeViews.Appearance.TopLeftHeaderCell.ReadOnly = true;
            this.gridCompositeViews.Appearance.TopLeftHeaderCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
            this.gridCompositeViews.BackColor = System.Drawing.SystemColors.Window;
            this.gridCompositeViews.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.gridCompositeViews.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridCompositeViews.Location = new System.Drawing.Point(0, 0);
            this.gridCompositeViews.Name = "gridCompositeViews";
            this.gridCompositeViews.Size = new System.Drawing.Size(448, 190);
            this.gridCompositeViews.TabIndex = 8;
            this.gridCompositeViews.TableDescriptor.AllowEdit = false;
            this.gridCompositeViews.TableDescriptor.AllowNew = false;
            this.gridCompositeViews.TableDescriptor.AllowRemove = false;
            this.gridCompositeViews.TableDescriptor.Appearance.TopLeftHeaderCell.Clickable = false;
            this.gridCompositeViews.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridCompositeViews.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridCompositeViews.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridCompositeViews.TableDescriptor.TopLevelGroupOptions.ShowCaption = false;
            this.gridCompositeViews.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridCompositeViews.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridCompositeViews.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
            this.gridCompositeViews.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
            this.gridCompositeViews.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
            this.gridCompositeViews.TableOptions.ShowRowHeader = false;
            this.gridCompositeViews.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridCompositeViews.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridCompositeViews.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridCompositeViews.TopLevelGroupOptions.ShowCaption = false;
            this.gridCompositeViews.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridCompositeViews.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridCompositeViews.VersionInfo = "3.301.0.0";
            this.gridCompositeViews.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridCompositeViews_TableControlCellClick);
            this.gridCompositeViews.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridCompositeViews_RecordDeleting);
            // 
            // btnCancel
            // 
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.Location = new System.Drawing.Point(352, 8);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(80, 24);
            this.btnCancel.TabIndex = 5;
            this.btnCancel.Tag = "SID_CANCEL";
            // 
            // btnOpen
            // 
            this.btnOpen.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnOpen.Location = new System.Drawing.Point(256, 8);
            this.btnOpen.Name = "btnOpen";
            this.btnOpen.Size = new System.Drawing.Size(80, 24);
            this.btnOpen.TabIndex = 4;
            this.btnOpen.Tag = "SID_OPEN";
            this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
            // 
            // panel2
            // 
            this.panel2.Controls.Add(this.btnOpen);
            this.panel2.Controls.Add(this.btnCancel);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel2.Location = new System.Drawing.Point(0, 192);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(450, 48);
            this.panel2.TabIndex = 9;
            // 
            // CompositeFileDialog
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(450, 240);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.panel2);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "CompositeFileDialog";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Tag = "SID_OPENS";
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridCompositeViews)).EndInit();
            this.panel2.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		#region Fields
		private object			_objSelected;
		private LRRApp			_lrrApp;
		#endregion

		#region Methods
	
		private void InitializeGrid(CustomCollection custCollection)
		{
			Hashtable columnForDisplay=new Hashtable();
			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridCompositeViews.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridCompositeViews);

			if(custCollection.ItemType == typeof(LRRSavedView))
			{
				columnForDisplay.Add("SavedViewName",null);
				columnForDisplay.Add("SavedViewDescription",null);
                columnForDisplay.Add("Date/Time", null);
			}
			else
			{
				columnForDisplay.Add("Name",null);
				columnForDisplay.Add("Description",null);
				columnForDisplay.Add("Source",null);
                columnForDisplay.Add("TimeID", null);
			}

			if(custCollection.ItemType == typeof(LRRCompositeView))
			{
				gridCompositeViews.TableDescriptor.AllowRemove = true;
				gridCompositeViews.TableOptions.ShowRowHeader = true;
				gridCompositeViews.RecordDeleted+=new Syncfusion.Grouping.RecordEventHandler(gridCompositeViews_RecordDeleted);

			

			}

			SyncGridUtilities.InitializeGridColumns(gridCompositeViews,custCollection.ItemType,null,true,columnForDisplay);
			gridCompositeViews.DataSource = custCollection;

			for(int i = 0; i<gridCompositeViews.TableDescriptor.Columns.Count; i++)
			{
				gridCompositeViews.TableDescriptor.Columns[i].Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell).CellType = "Static";
				gridCompositeViews.TableDescriptor.Columns[i].Appearance.GetStyle(GridTableCellType.AlternateRecordFieldCell).BackColor = Color.White;
			}
			gridCompositeViews.TableDescriptor.Appearance.GetStyle(GridTableCellType.AlternateRecordFieldCell).AutoSize = true;
			//Resume the Layout of the Grid...
			gridCompositeViews.ResumeLayout(false);
		}

		#endregion

		private void gridCompositeViews_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			try
			{
				if(e.Inner.RowIndex == 1)
					return;
				ObjSelected = e.TableControl.Table.CurrentRecord.GetData();
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(ComplexEquipment),ex.Message  ,Logger.Level.Debug);
				return;
			}
		}

		private void btnOpen_Click(object sender, System.EventArgs e)
		{
			if(ObjSelected == null)
			{
				LRRMessagBox.ShowMessage("SID_ITEMNOTSELECTED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
				this.DialogResult = DialogResult.None;
				return;
			}
		}

		public object ObjSelected
		{
			get{ return _objSelected;}
			set
			{
				_objSelected = value;
			}
		}

		private void gridCompositeViews_RecordDeleted(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			BaseObject obj =  _objSelected as BaseObject;
			if(obj != null)
			{
				obj.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
				_lrrApp.DBManagerObj.CommitObject(_objSelected);
				_objSelected = null;
			}
		}

        private void gridCompositeViews_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
        {
            DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (_dlgResult == DialogResult.Yes)
            {
                object delobj = e.Record.GetData();
                string id = delobj.GetType().GetProperty("ID").GetValue(delobj, null).ToString();
                LRRCompositeView compositeView = LRRModel.ChildModel.CompositeViews.GetCompositeViewFromID(id);
                LRRSearchGroupLevel searchGropLevel = LRRModel.SearchGroupLevels.GetLevelFromID(id);
                LRRModel.SearchGroupLevels.Remove(searchGropLevel);
                _lrrApp.DBManagerObj.CommitCollection(LRRModel.SearchGroupLevels.GetChanges());
                LRRModel.SearchGroupLevels.RefreshCollection();
                LRRModel.ChildModel.CompositeViews.Remove(compositeView);
                _lrrApp.DBManagerObj.CommitCollection(LRRModel.ChildModel.CompositeViews.GetChanges());
                LRRModel.ChildModel.CompositeViews.RefreshCollection();
                MessageBox.Show(LRRHeaderText.GetHeaderString("SID_DELETE_CONFIRMATION"), LRRHeaderText.GetHeaderString("SID_LABLE"), MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                e.Cancel = true;
            }
        }
	}
}
