using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Grouping;
using Syncfusion.ComponentModel;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;


//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for CopyUOMTypes.
	/// </summary>
	public class CopyUOMTypes : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox listUOMSetDefinition;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel panel2;
		private LRRApp								_lrrApp;
		private LRRMeasurementSystems				_lrrMeasurementSystems=null;
		private System.Windows.Forms.Button btnOK;
		private LRRMeasurementSystemDefinitions		_lrrMeasurementSystemsDefinitionsClone=null;
		public CopyUOMTypes()
		{
			InitializeComponent();
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrMeasurementSystems=new LRRMeasurementSystems();
			_lrrApp.DBManagerObj.PopulateCollection (_lrrMeasurementSystems,false);
			InternationalizationUtils.GetControlText(this,null); 
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listUOMSetDefinition = new System.Windows.Forms.ListBox();
			this.panel2 = new System.Windows.Forms.Panel();
			this.btnOK = new System.Windows.Forms.Button();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// listUOMSetDefinition
			// 
			this.listUOMSetDefinition.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listUOMSetDefinition.Location = new System.Drawing.Point(0, 0);
			this.listUOMSetDefinition.Name = "listUOMSetDefinition";
			this.listUOMSetDefinition.Size = new System.Drawing.Size(474, 121);
			this.listUOMSetDefinition.TabIndex = 0;
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.listUOMSetDefinition);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(474, 128);
			this.panel2.TabIndex = 5;
			// 
			// btnOK
			// 
			this.btnOK.Location = new System.Drawing.Point(392, 136);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 2;
			this.btnOK.Tag = "SID_OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// CopyUOMTypes
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(474, 168);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.btnOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "CopyUOMTypes";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Tag = "SID_COPYFRMUOMSET";
			this.Load += new System.EventHandler(this.CopyUOMTypes_Load);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void CopyUOMTypes_Load(object sender, System.EventArgs e)
		{
			_lrrMeasurementSystems=new LRRMeasurementSystems();
			_lrrApp.DBManagerObj.PopulateCollection (_lrrMeasurementSystems,false);
			listUOMSetDefinition.DataSource = _lrrMeasurementSystems;
			listUOMSetDefinition.DisplayMember = "Locale";
			listUOMSetDefinition.ValueMember = "ID";
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			this.DialogResult=DialogResult.OK;
			this.Close();
		}
		public LRRMeasurementSystemDefinitions CopyMSDefinitions()
		{
			if(this.DialogResult==DialogResult.OK)
			{
				LRRMeasurementSystem	lrrMeasSystem=listUOMSetDefinition.SelectedItem as LRRMeasurementSystem;
				if(lrrMeasSystem!=null)
				{
					LRRMeasurementSystemDefinitions _lrrMeasurementSystemsDefinitions=null;
					_lrrMeasurementSystemsDefinitions	=new LRRMeasurementSystemDefinitions();
					_lrrApp.DBManagerObj.PopulateCollection (_lrrMeasurementSystemsDefinitions,false);
					_lrrMeasurementSystemsDefinitions = _lrrMeasurementSystemsDefinitions.GetUOMTypesForMSID(lrrMeasSystem.ID);
					_lrrMeasurementSystemsDefinitionsClone=_lrrMeasurementSystemsDefinitions.Clone() as LRRMeasurementSystemDefinitions;
					IEnumerator	iEnumerator=_lrrMeasurementSystemsDefinitionsClone.GetEnumerator();
					while(iEnumerator.MoveNext())
					{
						LRRMeasurementSystemDefinition lrrMSD = (LRRMeasurementSystemDefinition)iEnumerator.Current;
						if(lrrMSD != null)
						{
							lrrMSD.ID=	Guid.NewGuid().ToString();
						}
					}
					return _lrrMeasurementSystemsDefinitionsClone;
				}
				else
					return null;
			}
			else 
				return null;
		}
		
		
		
		
	}
}
