using System;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.DashBoard
{
    public partial class DBScreen2UC : UserControl
    {
        public DBScreen2UC()
        {
            InitializeComponent();
        }

        public DBScreen2UC(XmlDashBoard xmlDashBoard)
        {
            InitializeComponent();
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            this.DashBoardXML = xmlDashBoard;
            BindControls();

        }

        #region Fields/Properties
        private XmlDashBoard _xmlDashBoard;
        public XmlDashBoard DashBoardXML
        {
            get { return _xmlDashBoard; }
            set { _xmlDashBoard = value; }
        }

        private LRRDashBoardSettings _lrrDashBoardSettings;

        private LRRApp _lrrApp;
        #endregion

        #region Methods
        public void BindControls()
        {
            this.txtName.DataBindings.Clear();
            this.NUDRows.DataBindings.Clear();
            this.NUDColums.DataBindings.Clear();

            this.txtName.DataBindings.Add("Text", this.DashBoardXML, "Name");  
            this.NUDRows.DataBindings.Add("Value", this.DashBoardXML, "Rows");
            this.NUDColums.DataBindings.Add("Value", this.DashBoardXML, "Cols");
        }
        #endregion

    }

}
