using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.DashBoard
{
    public partial class DBWelcomeScreenUC : UserControl
    {
        public DBWelcomeScreenUC()
        {
            InitializeComponent();
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
        }

        public DBWelcomeScreenUC(XmlDashBoard xmlDashBoard)
        {
            InitializeComponent();
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            this.DashBoardXML = xmlDashBoard;
            InitDataSource();
            BindControls();
        }

        #region Fields/Properties
        private XmlDashBoard _xmlDashBoard = new XmlDashBoard();
        public XmlDashBoard DashBoardXML
        {
            get { return _xmlDashBoard; }
            set { _xmlDashBoard = value; }
        }

        private bool _createNew;
        public bool CreateNew
        {
            get {return _createNew; }
            set
            {
                _createNew = value;
            }
        }

        private DashBoardTemplateSetting _dashBoardTemplateSetting;
        public DashBoardTemplateSetting DBoardTemplateSetting
        {
            get { return _dashBoardTemplateSetting; }
            set
            {
                _dashBoardTemplateSetting = value;
            }
        }

        public bool LoadExist
        {
            get { return rbLoad.Checked; }
        }

        private LRRApp _lrrApp;
        private LRRDashBoardSettings _lrrDashBoardSettings;
        #endregion

        #region Event Handlers
        private void rbCreateNew_CheckedChanged(object sender, EventArgs e)
        {
            this.CreateNew = rbCreateNew.Checked;
          
        }
        private void rbLoad_CheckedChanged(object sender, EventArgs e)
        {
            if (rbLoad.Checked)
            {
                cmbTemplates.Visible = true;
            }
            else
            {
                cmbTemplates.Visible = false;
            }
        }

        private void cmbTemplates_SelectedIndexChanged(object sender, EventArgs e)
        {
            DashBoardTemplateSetting dbSetting = this.cmbTemplates.SelectedItem as DashBoardTemplateSetting;
            this.DBoardTemplateSetting = dbSetting;
        }
        #endregion

        #region Methods
        private void InitDataSource()
        {
            if (_lrrDashBoardSettings != null)
                _lrrDashBoardSettings.Clear();

            _lrrDashBoardSettings = new LRRDashBoardSettings();
            _lrrApp.DBManagerObj.PopulateCollection(_lrrDashBoardSettings);
        }

        private void BindControls()
        {
            ArrayList arrSettings = new ArrayList();
            DashBoardTemplateSetting dashBoardTemplate1 = new DashBoardTemplateSetting();
            arrSettings.Add(dashBoardTemplate1);

            IEnumerator iEnum = this._lrrDashBoardSettings.GetEnumerator();
            while (iEnum.MoveNext())
            {
                LRRDashBoardSetting lrrDashBoardSetting = iEnum.Current as LRRDashBoardSetting;
                DashBoardTemplateSetting dashBoardTemplate = new DashBoardTemplateSetting();
                dashBoardTemplate.ID = lrrDashBoardSetting.ID;
                dashBoardTemplate.Name = lrrDashBoardSetting.Name;

                arrSettings.Add(dashBoardTemplate);
            }

            this.cmbTemplates.DataSource = arrSettings;
            this.cmbTemplates.ValueMember = "ID";
            this.cmbTemplates.DisplayMember = "Name";
        }
        #endregion


    }
}
