using System;
using System.Diagnostics;
using Symcon.Utils.MessageLogger;
using Symcon.BusinessObjects;


//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.


namespace Symcon.LightRidge.PEAdvisor.DataStore
{
	/// <summary>
	/// Summary description for LRRDataSourceUtils.
	/// </summary>
	public class LRRDataSourceUtils
	{
		public LRRDataSourceUtils()
		{
			
		}

		/// <summary>
		/// This methods check for the object type 
		/// and puts the filter on the store..
		/// </summary>
		/// <param name="obj"></param>
		/// <param name="filter"></param>
		/// <returns></returns>
		public static bool SetFilterOnDataStore(object obj,string filter)
		{
			try
			{
				CustomCollection customColection = obj as CustomCollection;
				customColection.ItemFilter = filter;
				return true;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataSourceUtils),ex.Message  ,Logger.Level.Debug);
				return false;
			}

		}
	}
}
