using System;
using System.Collections;
using System.Diagnostics;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Database;
using Symcon.BusinessObjects;
using System.Windows.Forms;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.DataStore
{
	/// <summary>
	/// Summary description for LRRDataStore.
	/// </summary>
	public class LRRDataStore
	{
		/// <summary>
		/// Lrr Data Store needs and Instance of the DB Manager to
		/// Populate the data in the data Store...
		/// All the objects initialized are stored in 
		/// the internal hash of the data store for 
		/// Retrieval. The client needs to call
		/// the appropriate methods to refresh 
		/// the data in the stores.
		/// </summary>
		public LRRDataStore(DBManager dbManager)
		{
			
			//Initialize the private members..
			_dbManager = dbManager; //Store the DBManager Instance..

			try
			{
				//Create instance of the internal data store..
				_typedObjectStore = new Hashtable();

				//Component Types table
				//_lrrComponentTypesObj = new LRRComponentTypes();
				//_typedObjectStore.Add(_lrrComponentTypesObj.GetType(),_lrrComponentTypesObj);

				//Master Component Table
				//_lrrMasterComponentObj = new LRRMasterComponents();
				//_typedObjectStore.Add(_lrrMasterComponentObj.GetType(),_lrrMasterComponentObj);

				//Master Properties Table
				//_lrrMasterPropertiesObj = new LRRMasterProperties();
				//_typedObjectStore.Add(_lrrMasterPropertiesObj.GetType(),_lrrMasterPropertiesObj);

				//Site Component Table
				//_lrrSiteComponentObj = new LRRSiteComponents();
				//_typedObjectStore.Add(_lrrSiteComponentObj.GetType(),_lrrSiteComponentObj);

				//Site component properties table
				//_lrrSiteComponentPropertiesObj = new LRRSiteComponentProperties();
				//_typedObjectStore.Add(_lrrSiteComponentPropertiesObj.GetType(),_lrrSiteComponentPropertiesObj);

				//UOM Types table
				//_lrrUOMTypesObj = new LRRUOMTypes();
				//_typedObjectStore.Add(_lrrUOMTypesObj.GetType(),_lrrUOMTypesObj);

				//_lrrUOMsObj = new LRRUOMs();
				//_typedObjectStore.Add(_lrrUOMsObj.GetType(),_lrrUOMsObj);

				//_lrrUnitsObj = new LRRUnits();
				//_typedObjectStore.Add(_lrrUnitsObj.GetType(),_lrrUnitsObj);

				//_lrrAdditionalInfosObj = new LRRSiteComponentAdditionalInformations();
				//_typedObjectStore.Add(_lrrAdditionalInfosObj.GetType(),_lrrAdditionalInfosObj);

				//_lrrHisDatasObj = new LRRHistDatas();
				//_typedObjectStore.Add(_lrrHisDatasObj.GetType(),_lrrHisDatasObj);

				//_lrrHisShortDatasObj = new LRRHistShortDatas();
				//_typedObjectStore.Add(_lrrHisShortDatasObj.GetType(),_lrrHisShortDatasObj);


				//_lrrModesObj = new LRRModes();
				//_typedObjectStore.Add(_lrrModesObj.GetType(),_lrrModesObj);
				
				//_lrrHistPropCompMappingsObj = new LRRHistPropCompPropMappings();
				//_typedObjectStore.Add(_lrrHistPropCompMappingsObj.GetType(),_lrrHistPropCompMappingsObj);

				/*_lrrSiteComponentPropsUserAndTimesObj = new LRRSiteComponentPropertyUserAndTimes();
				_typedObjectStore.Add(_lrrSiteComponentPropsUserAndTimesObj.GetType(),_lrrSiteComponentPropsUserAndTimesObj);*/

				/*_lrrUOMNamedTypesObj = new LRRUOMNamedTypes();
				_typedObjectStore.Add(_lrrUOMNamedTypesObj.GetType(),_lrrUOMNamedTypesObj);*/

				//_lrrConnectorTypesObj = new LRRConnectorTypes();
				//_typedObjectStore.Add(_lrrConnectorTypesObj.GetType(),_lrrConnectorTypesObj);

				//_lrrLevelsObj = new LRRLevels();
				//_typedObjectStore.Add(_lrrLevelsObj.GetType(),_lrrLevelsObj);

				//_lrrLevelLinksObj = new LRRLevelLinks();
				//_typedObjectStore.Add(_lrrLevelLinksObj.GetType(),_lrrLevelLinksObj);

				//_lrrAggregatesObj = new LRRAggregates();
				//_typedObjectStore.Add(_lrrAggregatesObj.GetType(),_lrrAggregatesObj);

				//_lrrAggregatedEquipments = new LRRAggregateEquipments();
				//_typedObjectStore.Add(_lrrAggregatedEquipments.GetType(),_lrrAggregatedEquipments);

				//_lrrComplexEquipmentObj = new LRRComplexEquipments();
				//_typedObjectStore.Add(_lrrComplexEquipmentObj.GetType(),_lrrComplexEquipmentObj);

				//_lrrComplexEquipmentGroupingsObj = new LRRComplexEquipGroupings();
				//_typedObjectStore.Add(_lrrComplexEquipmentGroupingsObj.GetType(),_lrrComplexEquipmentGroupingsObj);

				
				//_lrrPropertyDerivationTypesObj = new LRRPropertyDerivationTypes();
				//_typedObjectStore.Add(_lrrPropertyDerivationTypesObj.GetType(),_lrrPropertyDerivationTypesObj);

				//_lrrPropertyDirectionsObj = new LRRPropertyDirections();
				//_typedObjectStore.Add(_lrrPropertyDirectionsObj.GetType(),_lrrPropertyDirectionsObj);

				//_lrrPropertyTypesObj = new LRRPropertyTypes();
				//_typedObjectStore.Add(_lrrPropertyTypesObj.GetType(),_lrrPropertyTypesObj);

				//_lrrSiteComponentPropertyTypesObj = new LRRSiteComponentPropertyTypes();
				//_typedObjectStore.Add(_lrrSiteComponentPropertyTypesObj.GetType(),_lrrSiteComponentPropertyTypesObj);

				//_lrrMeasurementSystemsObj = new LRRMeasurementSystems();
				//_typedObjectStore.Add(_lrrMeasurementSystemsObj.GetType(),_lrrMeasurementSystemsObj);

				
				//_lrrMeasurementSystemDefinitionsObj = new LRRMeasurementSystemDefinitions();
				//_typedObjectStore.Add(_lrrMeasurementSystemDefinitionsObj.GetType(),_lrrMeasurementSystemDefinitionsObj);

				//_lrrModeTypesObj = new LRRModeTypes();
				//_typedObjectStore.Add(_lrrModeTypesObj.GetType(), _lrrModeTypesObj);

				
				//_objLRRMaterials = new LRRMaterials();
				//_typedObjectStore.Add(_objLRRMaterials.GetType(),_objLRRMaterials);
				

				
				/*_lrrSiteComponentPropertyValuesObj = new LRRSiteComponentPropertyValues();
				_typedObjectStore.Add(_lrrSiteComponentPropertyValuesObj.GetType(), _lrrSiteComponentPropertyValuesObj);*/
				

				//_lrrInputTypes = new LRRInputTypes();
				//_typedObjectStore.Add(_lrrInputTypes.GetType(), _lrrInputTypes);

				//_lrrQualifiers = new LRRQualifiers();
				//_typedObjectStore.Add(_lrrQualifiers.GetType(), _lrrQualifiers);

				//_lrrGenericFormulas = new LRRGenericFormulas();
				//_typedObjectStore.Add(_lrrGenericFormulas.GetType(), _lrrGenericFormulas);

//				_lrrSiteGroupPropertyQualifiers = new LRRSiteGroupPropertyQualifiers();
//				_typedObjectStore.Add(_lrrSiteGroupPropertyQualifiers.GetType(), _lrrSiteGroupPropertyQualifiers);

				//_lrrSiteGroupPropertyQualifierValues = new LRRSiteGroupPropertyQualifierValues();
				//_typedObjectStore.Add(_lrrSiteGroupPropertyQualifierValues.GetType(), _lrrSiteGroupPropertyQualifierValues);

				//_lrrSiteComponentGroupProperties = new LRRSiteComponentGroupProperties();
				//_typedObjectStore.Add(_lrrSiteComponentGroupProperties.GetType(), _lrrSiteComponentGroupProperties);

				//Data Confidence Levels
				//_lrrDataConfidenceLevelsOBj = new LRRDataConfidenceLevels();
				//_typedObjectStore.Add(_lrrDataConfidenceLevelsOBj.GetType(), _lrrDataConfidenceLevelsOBj);

				//Call to the Init data store method to prepopulate the collection
				//object in the store...
				//InitializedDataStore();
				_initialized = true;

				//_ObjectsChanged = new Hashtable();
				//_typedObjectStore.Add("ObjectsChanged",_ObjectsChanged);
				

				//SetComponentPropHisPointBinding();

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataStore),ex.Message  ,Logger.Level.Debug);
				_initialized = false;
			}


		}

		
		#region Public Methods

		/// <summary>
		/// Pull the corresponding object from the data store
		/// </summary>
		/// <param name="id">ID of the object to be pulled</param>
		/// <returns>the collection object</returns>
		public object GetObject(int id)
		{
			object ret = null;
			switch(id)
			{
				case 0:
					ret = _lrrComponentTypesObj;
					break;
				case 1:
					ret = _lrrMasterComponentObj;
					break;
				case 2:
					ret = _lrrMasterPropertiesObj;
					break;
				case 3:
					ret = _lrrSiteComponentObj;
					break;
				case 4:
					ret = _lrrSiteComponentPropertiesObj;
					break;
				case 5:
					ret = _lrrSiteComponentPropertyValuesObj;
					break;
				default:
					ret = null;
					break;
			}
			return ret;
		}

		/// <summary>
		/// This method return a particular type
		/// of business object from the internal
		/// hash...
		/// </summary>
		/// <param name="type">Type of the Business object</param>
		/// <returns>Actual Intsance of the Type requested..</returns>
		public object GetDataStoreObject(Type type)
		{
			if(!_initialized)
			{
				throw new Exception("Data Store not Initialized!");
			}

			try
			{
				CustomCollection customCollection = LRRModel.GetObjectCopy(type);
				if(customCollection == null)
				{
					MessageBox.Show(type.ToString());
					return null;
				}
				else
				{
					return customCollection;
				}
				
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataStore),ex.Message  ,Logger.Level.Debug);
				return null;
			}
		}

		/// <summary>
		/// This method return a copy of the object
		/// from the store using clone.
		/// 
		/// </summary>
		/// <param name="type"> type to get from the store</param>
		/// <returns> type to be returned.</returns>
		public object GetCopyOfDataStoreObject(Type type)
		{
			if(!_initialized)
			{
				throw new Exception("Data Store not Initialized!");
			}

			try
			{
				CustomCollection customCollection = LRRModel.GetObjectCopy(type);
				if(customCollection == null)
				{
					MessageBox.Show(type.ToString());
					return null;
				}
				else
				{
					return customCollection.Clone();
				}
				
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataStore),ex.Message  ,Logger.Level.Debug);
				return null;
			}


		}


		/// <summary>
		/// Static Method returns a copy of the object
		/// from the store using clone.
		/// </summary>
		/// <param name="type"> type to get from the store</param>
		/// <returns> type to be returned.</returns>
		public static object GetDataStoreObjectCopy(Type type, string whereClause)
		{
			if(!_initialized)
			{
				throw new Exception("Data Store not Initialized!");
			}

			try
			{
				CustomCollection customCollection = _typedObjectStore[type] as CustomCollection;
				CustomCollection clone = customCollection.Clone() as CustomCollection;
				clone.ItemFilter = whereClause;
				return clone;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataStore),ex.Message  ,Logger.Level.Debug);
				return null;
			}


		}

		/// <summary>
		/// Static Method returns a copy of the object
		/// from the store using clone.
		/// </summary>
		/// <param name="type"> type to get from the store</param>
		/// <returns> type to be returned.</returns>
		public static object GetDataStoreObjectCopy(Type type)
		{
			if(!_initialized)
			{
				throw new Exception("Data Store not Initialized!");
			}

			try
			{
				/*CustomCollection customCollection = _typedObjectStore[type] as CustomCollection;
				return customCollection.Clone();*/
				CustomCollection customCollection = LRRModel.GetObjectCopy(type);
				if(customCollection == null)
				{
					MessageBox.Show(type.ToString());
					return null;
				}
				else
				{
					return customCollection;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataStore),ex.Message  ,Logger.Level.Debug);
				return null;
			}


		}


		/// <summary>
		/// Pull the corresponding object from the data store
		/// </summary>
		/// <param name="id">ID of the object to be pulled</param>
		/// <returns>the collection object</returns>
		public object GetCopyOfObject(int id)
		{
			object ret = null;
			switch(id)
			{
				case 0:
					ret = _lrrComponentTypesObj.Clone();
					break;
				case 1:
					ret = _lrrMasterComponentObj.Clone();
					break;
				case 2:
					ret = _lrrMasterPropertiesObj.Clone();
					break;
				case 3:
					ret = _lrrSiteComponentObj.Clone();
					break;
				case 4:
					ret = _lrrSiteComponentPropertiesObj.Clone();
					break;
				case 5:
					ret = _lrrSiteComponentPropertyValuesObj.Clone();
					break;
				default:
					ret = null;
					break;
			}
			
			return ret;
		}


		/// <summary>
		/// Pull the corresponding object from the data store
		/// </summary>
		/// <param name="id">ID of the object to be pulled</param>
		/// <param name="type">ref of the type of the object pulled from the data store</param>
		/// <returns>the collection object</returns>
		public object GetObject(int id,ref Type type)
		{
			object ret = null;
			switch(id)
			{
				case 0:
					ret = _lrrComponentTypesObj;
					type = _lrrComponentTypesObj.GetType();
					break;
				case 1:
					ret = _lrrMasterComponentObj;
					type = _lrrMasterComponentObj.GetType();
					break;
				case 2:
					ret = _lrrMasterPropertiesObj;
					type = _lrrMasterPropertiesObj.GetType();
					break;
				default:
					ret = null;
					type = null;
					break;
			}
			return ret;
		}

        /// <summary>
        /// Sets the component prop his point binding.
        /// </summary>
		public void SetComponentPropHisPointBinding()
		{
			_bindingManager.RemoveBinding();
			LRRHistPropCompPropMappings hisMaps = GetDataStoreObject(typeof(LRRHistPropCompPropMappings)) as LRRHistPropCompPropMappings;
			LRRSiteComponents _siteComps = GetDataStoreObject(typeof(LRRSiteComponents)) as LRRSiteComponents;

			//LRRHistDatas _hisDatas = GetDataStoreObject(typeof(LRRHistDatas)) as LRRHistDatas;
			//Populate HistDatas from Model
			LRRHistDatas _hisDatas = LRRModel.HistDatas;
			
			foreach(LRRHistPropCompPropMapping map in hisMaps)
			{
				LRRSiteComponent foundsc = null;
				LRRHistData foundHistData = null;
				foreach(LRRSiteComponent lsc in _siteComps)
				{
					if(lsc.SiteComponentID == map.ComponentID)
					{
						foundsc = lsc;
						break;
					}
				}
				foreach(LRRHistData lhd in _hisDatas)
				{
					if(lhd.HistTagUID ==  map.HistPropID)
					{
						foundHistData = lhd;
						break;
					}
				}
				if(foundsc != null)
				{
					foreach(LRRSiteComponentProperty lscp in foundsc.Properties)
					{
						if(lscp.ID == map.SiteComponentPropID)
						{
							if(foundHistData!= null)
							{
								//lscp.DataBindings.Add("PropertyValue",foundHistData,"SpotValue");
								_bindingManager.AddBinding(foundHistData,"StartOfPeriodValue",lscp,"PropertyValue");
							}
						}
					}
				}
			}

		}


		
		#endregion

		#region Properties

		/// <summary>
		/// Flag to indicate if the Data Source is
		/// initialized with data.
		/// </summary>
		public bool Initialized
		{
			get{return _initialized;}
			set
			{
				_initialized = value;
			}
		}

		#endregion

		#region Private Methods

		/// <summary>
		/// This method is used to get a copy of the data store when it is intialized..
		/// </summary>
		private void InitializedDataStore()
		{
			try
			{
				foreach(object obj in _typedObjectStore.Values)
				{
					_dbManager.PopulateCollection(obj,false);
					//System.Threading.Thread.Sleep(2000);
				}

				_lrrModeSetDefinitionsObj = new LRRModeSetDefinitions();
                _dbManager.PopulateCollection(_lrrModeSetDefinitionsObj," WHERE ModeSetID = '1'",false);
				_typedObjectStore.Add(_lrrModeSetDefinitionsObj.GetType(),_lrrModeSetDefinitionsObj);
				//Set the binding information....

				_initialized = true;

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataStore),ex.Message  ,Logger.Level.Debug);
				_initialized = false;
			}

		}
		#endregion

        /// <summary>
        /// Gets the site component.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <returns></returns>
		public static LRRSiteComponent GetSiteComponent(string name)
		{
			LRRSiteComponents lscs = _typedObjectStore[typeof(LRRSiteComponents)] as LRRSiteComponents;
			foreach(LRRSiteComponent lsc in lscs)
			{
				if(name == lsc.Name)
				{
					return lsc;
				}
				else
				{
					continue;
				}
			}
			return null;
		}

		/// <summary>
		/// This method return a particular type
		/// of business object from the internal
		/// hash...
		/// </summary>
		/// <param name="type">Type of the Business object</param>
		/// <returns>Actual Intsance of the Type requested..</returns>
		public object GetDataStoreObject(string sName)
		{
			if(!_initialized)
			{
				throw new Exception("Data Store not Initialized!");
			}

			try
			{
				return _typedObjectStore[sName];
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRDataStore),ex.Message  ,Logger.Level.Debug);
				return null;
			}
		}

		#region Fields

		private LRRComponentTypes					_lrrComponentTypesObj; //ID = 0; Collection storing all the Component Types; 
		private LRRMasterComponents					_lrrMasterComponentObj; //ID = 1;Collection storing all the MasterComponents;
		private LRRMasterProperties					_lrrMasterPropertiesObj; //ID = 2;Collection storing all the Master Properties
		private LRRSiteComponents					_lrrSiteComponentObj;//ID = 3;Collection Storing all the site components
		private LRRSiteComponentProperties			_lrrSiteComponentPropertiesObj;//ID =4; Collection storing all the Site Component Properties.
		private LRRSiteComponentPropertyUserAndTimes _lrrSiteComponentPropsUserAndTimesObj;//Prop Pverrides
		private LRRUOMTypes							_lrrUOMTypesObj;//ID = 5; Collection storing all the UOM Types..
		private LRRUOMs								_lrrUOMsObj; //All the UOMs in the DB
		private LRRUnits							_lrrUnitsObj;//Units for the site..
		private LRRSiteComponentAdditionalInformations _lrrAdditionalInfosObj;// Store for the additional info data..
		private LRRHistDatas							_lrrHisDatasObj;
		private LRRHistShortDatas						_lrrHisShortDatasObj;
		private LRRModes								_lrrModesObj;
		private LRRHistPropCompPropMappings				_lrrHistPropCompMappingsObj; //His tag to comp prop map..
		private LRRUOMNamedTypes						_lrrUOMNamedTypesObj;
		private LRRConnectorTypes						_lrrConnectorTypesObj;
		private LRRLevels								_lrrLevelsObj;
		private LRRLevelLinks							_lrrLevelLinksObj;
		private LRRAggregates							_lrrAggregatesObj;
		private LRRAggregateEquipments					_lrrAggregatedEquipments;
		private LRRComplexEquipments					_lrrComplexEquipmentObj;
		private LRRComplexEquipGroupings				_lrrComplexEquipmentGroupingsObj;
		
		private LRRPropertyDerivationTypes				_lrrPropertyDerivationTypesObj;
		private LRRPropertyDirections					_lrrPropertyDirectionsObj; 
		private LRRPropertyTypes						_lrrPropertyTypesObj;
		private LRRSiteComponentPropertyTypes			_lrrSiteComponentPropertyTypesObj;

		private LRRMeasurementSystems					_lrrMeasurementSystemsObj;
		private LRRMeasurementSystemDefinitions			_lrrMeasurementSystemDefinitionsObj;

		private LRRModeSetDefinitions					_lrrModeSetDefinitionsObj;

		private LRRSiteComponentPropertyValues			_lrrSiteComponentPropertyValuesObj;

		private	LRRMaterials							_objLRRMaterials;

		//Data Confidence Levels
		private LRRDataConfidenceLevels					_lrrDataConfidenceLevelsOBj;
		
		private static Hashtable					_typedObjectStore;
        
		private static bool							_initialized = false; //Flag for Initialized state of the Data Store..

		private DBManager							_dbManager; //Instance of the DBManager used by the APP.

		private LRRBindingManager					_bindingManager = new LRRBindingManager();

		private Hashtable							_ObjectsChanged;
		private LRRModeTypes							_lrrModeTypesObj;//ICollection storing all the Mode Types..

		private LRRInputTypes						_lrrInputTypes;
		private LRRQualifiers						_lrrQualifiers;
		private LRRGenericFormulas					_lrrGenericFormulas ;
		private LRRSiteComponentGroupProperties		_lrrSiteComponentGroupProperties;
		//private LRRSiteGroupPropertyQualifiers		_lrrSiteGroupPropertyQualifiers;
		private LRRSiteGroupPropertyQualifierValues	_lrrSiteGroupPropertyQualifierValues;


		#endregion
	}
}
