using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using System.Xml.Serialization;
using System.Xml;
using System.Data;
using System.IO;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.Utils.MessageLogger;
using Symcon.BusinessObjects; 
using Symcon.Utils.HeaderDispatcher;  
namespace Symcon.LightRidge.PEAdvisor
{
	///	<summary>
	///	Summary	description	for	EventLogger.
	///	</summary>
	public class EventLogger : System.Windows.Forms.Form,ILRRUIContainer
	{
		private	System.Windows.Forms.Panel panelEventLogger;
		private	System.Windows.Forms.Timer timer1;
		private	System.ComponentModel.IContainer components;
		private	System.Windows.Forms.GroupBox grpBoxArchivedFiles;
		private	Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridEventLogs1;
		private	System.Windows.Forms.Panel panelTop;
		private	System.Windows.Forms.ComboBox cmbArchiveList;
		private	System.Windows.Forms.Panel pnlArchivedList;
		private	System.Windows.Forms.Splitter splitterVertical;
		private	System.Windows.Forms.Splitter splitterHorz;
		private	System.Windows.Forms.Panel panelShowCurrent;
		private	Symcon.Utils.EventLogger.EventLogs evtlogs;
		private	TabControl			_parentTabControl;
		private	TabPage				_parentTabPage;

		public EventLogger()
		{
			evtlogs	= new Symcon.Utils.EventLogger.EventLogs();
			InitializeComponent();
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridEventLogs1);
			this.Load+=new EventHandler(EventLogger_Load);
//			timer1.Tick+=new EventHandler(timer1_Tick);
			this.Closing+=new CancelEventHandler(EventLogger_Closing);
			evtlogs	=  evtlogs.LoadFile();

			gridEventLogs1.SourceListSet.Add("Parent",evtlogs.listEventLog);
			gridEventLogs1.DataSource =	evtlogs.listEventLog;//	evtlogs.listEventLog;
			WireArchiveList();
			this.cmbArchiveList.SelectedIndexChanged +=	new	System.EventHandler(this.cmbArchiveList_SelectedIndexChanged);
			for(int	i =	0 ;	i <	gridEventLogs1.TableDescriptor.Columns.Count; i++)
			{
				gridEventLogs1.TableDescriptor.Columns[i].AllowFilter =	true;
			}

			gridEventLogs1.TableControlCellClick+=new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(gridEventLogs1_TableControlCellClick);
		}

		///	<summary>
		///	Clean up any resources being used.
		///	</summary>
		protected override void	Dispose( bool disposing	)
		{
			if(	disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing	);
		}

		#region	Windows	Form Designer generated	code
		///	<summary>
		///	Required method	for	Designer support - do not modify
		///	the	contents of	this method	with the code editor.
		///	</summary>
		private	void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(EventLogger));
			this.panelEventLogger = new System.Windows.Forms.Panel();
			this.pnlArchivedList = new System.Windows.Forms.Panel();
			this.gridEventLogs1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitterVertical = new System.Windows.Forms.Splitter();
			this.panelTop = new System.Windows.Forms.Panel();
			this.panelShowCurrent = new System.Windows.Forms.Panel();
			this.grpBoxArchivedFiles = new System.Windows.Forms.GroupBox();
			this.cmbArchiveList = new System.Windows.Forms.ComboBox();
			this.splitterHorz = new System.Windows.Forms.Splitter();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.panelEventLogger.SuspendLayout();
			this.pnlArchivedList.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridEventLogs1)).BeginInit();
			this.panelTop.SuspendLayout();
			this.panelShowCurrent.SuspendLayout();
			this.grpBoxArchivedFiles.SuspendLayout();
			this.SuspendLayout();
			// 
			// panelEventLogger
			// 
			this.panelEventLogger.Controls.Add(this.pnlArchivedList);
			this.panelEventLogger.Controls.Add(this.splitterVertical);
			this.panelEventLogger.Controls.Add(this.panelTop);
			this.panelEventLogger.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelEventLogger.Location = new System.Drawing.Point(0, 0);
			this.panelEventLogger.Name = "panelEventLogger";
			this.panelEventLogger.Size = new System.Drawing.Size(672, 366);
			this.panelEventLogger.TabIndex = 0;
			// 
			// pnlArchivedList
			// 
			this.pnlArchivedList.Controls.Add(this.gridEventLogs1);
			this.pnlArchivedList.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlArchivedList.Location = new System.Drawing.Point(314, 0);
			this.pnlArchivedList.Name = "pnlArchivedList";
			this.pnlArchivedList.Size = new System.Drawing.Size(358, 366);
			this.pnlArchivedList.TabIndex = 4;
			// 
			// gridEventLogs1
			// 
			this.gridEventLogs1.AllowDrop = true;
			this.gridEventLogs1.Appearance.AnyRecordFieldCell.ReadOnly = true;
			this.gridEventLogs1.Appearance.AnyRecordFieldCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			this.gridEventLogs1.BackColor = System.Drawing.SystemColors.Window;
			this.gridEventLogs1.Dock = System.Windows.Forms.DockStyle.Right;
			this.gridEventLogs1.Location = new System.Drawing.Point(-314, 0);
			this.gridEventLogs1.Name = "gridEventLogs1";
			this.gridEventLogs1.Size = new System.Drawing.Size(672, 366);
			this.gridEventLogs1.TabIndex = 0;
			this.gridEventLogs1.TableDescriptor.AllowEdit = false;
			this.gridEventLogs1.TableDescriptor.AllowNew = false;
			this.gridEventLogs1.TableDescriptor.AllowRemove = false;
			this.gridEventLogs1.Text = "Event Viewer";
			this.gridEventLogs1.TopLevelGroupOptions.CaptionText = "Event Viewer: {RecordCount}\tItems";
			this.gridEventLogs1.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridEventLogs1.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridEventLogs1.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridEventLogs1.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridEventLogs1.VersionInfo = "3.301.0.0";
			// 
			// splitterVertical
			// 
			this.splitterVertical.Location = new System.Drawing.Point(312, 0);
			this.splitterVertical.Name = "splitterVertical";
			this.splitterVertical.Size = new System.Drawing.Size(2, 366);
			this.splitterVertical.TabIndex = 3;
			this.splitterVertical.TabStop = false;
			// 
			// panelTop
			// 
			this.panelTop.Controls.Add(this.panelShowCurrent);
			this.panelTop.Controls.Add(this.splitterHorz);
			this.panelTop.Dock = System.Windows.Forms.DockStyle.Left;
			this.panelTop.Location = new System.Drawing.Point(0, 0);
			this.panelTop.Name = "panelTop";
			this.panelTop.Size = new System.Drawing.Size(312, 366);
			this.panelTop.TabIndex = 2;
			// 
			// panelShowCurrent
			// 
			this.panelShowCurrent.Controls.Add(this.grpBoxArchivedFiles);
			this.panelShowCurrent.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelShowCurrent.Location = new System.Drawing.Point(0, 2);
			this.panelShowCurrent.Name = "panelShowCurrent";
			this.panelShowCurrent.Size = new System.Drawing.Size(312, 364);
			this.panelShowCurrent.TabIndex = 5;
			// 
			// grpBoxArchivedFiles
			// 
			this.grpBoxArchivedFiles.Controls.Add(this.cmbArchiveList);
			this.grpBoxArchivedFiles.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grpBoxArchivedFiles.Location = new System.Drawing.Point(0, 0);
			this.grpBoxArchivedFiles.Name = "grpBoxArchivedFiles";
			this.grpBoxArchivedFiles.Size = new System.Drawing.Size(312, 364);
			this.grpBoxArchivedFiles.TabIndex = 2;
			this.grpBoxArchivedFiles.TabStop = false;
			this.grpBoxArchivedFiles.Tag = "SID_EVENTLOGS";
			// 
			// cmbArchiveList
			// 
			this.cmbArchiveList.Dock = System.Windows.Forms.DockStyle.Fill;
			this.cmbArchiveList.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple;
			this.cmbArchiveList.Location = new System.Drawing.Point(3, 16);
			this.cmbArchiveList.Name = "cmbArchiveList";
			this.cmbArchiveList.Size = new System.Drawing.Size(306, 345);
			this.cmbArchiveList.TabIndex = 3;
			// 
			// splitterHorz
			// 
			this.splitterHorz.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitterHorz.Enabled = false;
			this.splitterHorz.Location = new System.Drawing.Point(0, 0);
			this.splitterHorz.Name = "splitterHorz";
			this.splitterHorz.Size = new System.Drawing.Size(312, 2);
			this.splitterHorz.TabIndex = 4;
			this.splitterHorz.TabStop = false;
			// 
			// EventLogger
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(672, 366);
			this.Controls.Add(this.panelEventLogger);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "EventLogger";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Event Viewer";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.panelEventLogger.ResumeLayout(false);
			this.pnlArchivedList.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridEventLogs1)).EndInit();
			this.panelTop.ResumeLayout(false);
			this.panelShowCurrent.ResumeLayout(false);
			this.grpBoxArchivedFiles.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region	Events

		private	void timer1_Tick(object	sender,	EventArgs e)
		{
			Symcon.Utils.EventLogger.LRREventLog lrrevtLog = new Symcon.Utils.EventLogger.LRREventLog();
			lrrevtLog.Description =	"AAAA";
			lrrevtLog.Source =	"BBBB";
			evtlogs.AddItem(lrrevtLog);
		}

		private	void EventLogger_Load(object sender, EventArgs e)
		{
			
			this.timer1.Interval = 500;
			this.timer1.Start();
		}



		private	void EventLogger_Closing(object	sender,	CancelEventArgs	e)
		{
			try
			{
				XmlSerializer s	= new XmlSerializer( typeof( Symcon.Utils.EventLogger.EventLogs	) );
				TextWriter w = new StreamWriter(Application.StartupPath	+@"\test.xml");
				s.Serialize( w,	evtlogs	);
				w.Close();
			}
			catch(Exception	ex)
			{
				Logger.LogMessage(typeof(EventLogger),ex.Message  ,Logger.Level.Error);
			}
		}

		private	void cmbArchiveList_SelectedIndexChanged(object	sender,	System.EventArgs e)
		{
			if(cmbArchiveList.SelectedIndex	!= 0)
			{
				ViewArchive();
			}
			else
			{
				ShowCurrentEventLog();
			}
		}

		private	void btnShowCurrent_Click(object sender, System.EventArgs e)
		{
			cmbArchiveList.SelectedIndex = 0;
		}

		#endregion

		#region	Private	Methods

		private	void ShowCurrentEventLog()
		{
			
			gridEventLogs1.DataSource =	null;
			gridEventLogs1.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("18") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS"); 
			gridEventLogs1.DataSource =	evtlogs.listEventLog;
		}

		private	void ViewArchive()
		{
			if(cmbArchiveList.SelectedItem != null)
			{
				string str = Application.StartupPath + @"\Archive\"	+ cmbArchiveList.SelectedItem.ToString();
				if(File.Exists(str))
				{
					Symcon.Utils.EventLogger.EventLogs	eventLogs  = new Symcon.Utils.EventLogger.EventLogs();
					eventLogs =	 eventLogs.LoadFile(str);
					gridEventLogs1.DataSource =	null;
					gridEventLogs1.DataSource =	eventLogs.listEventLog;
					gridEventLogs1.Refresh(); 
				}
			}
		}

		private	void WireArchiveList()
		{
			string sPath = Application.StartupPath + @"\Archive";
			string[] sFiles;
			if(!System.IO.Directory.Exists(sPath))
			{
				System.IO.Directory.CreateDirectory(sPath);
			}
			sFiles = System.IO.Directory.GetFiles(sPath); 
			string[] displayFiles =	new	string[sFiles.Length + 1]; 

			displayFiles[0]	= LRRHeaderText.GetHeaderString("SID_CURRENT"); 

			for(int	i =	0 ;	i< sFiles.Length;i++) 
			{ 
				displayFiles[i+1] =Path.GetFileName(sFiles[i]);
			}
			cmbArchiveList.DataSource =	displayFiles;
		}

		#endregion

		#region	ILRRUIContainer	Members

		public void	Refresh()
		{
			this.gridEventLogs1.Update();
			this.gridEventLogs1.Refresh();

			this.cmbArchiveList.Update();
			this.cmbArchiveList.Refresh();
		}

		public void	Save()
		{
			// TODO:  Add EventLogger.Save implementation
		}

		public void	CopyMasterProperties()
		{
			// TODO:  Add EventLogger.CopyMasterProperties implementation
		}

		public void	Paste()
		{
			// TODO:  Add EventLogger.Paste	implementation
		}

		public void	Copy()
		{
			// TODO:  Add EventLogger.Copy implementation
		}

		public void	Print()
		{
			if(gridEventLogs1.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridEventLogs1,false);
			}
		}

		public void	PrintPreview()
		{
			if(gridEventLogs1.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridEventLogs1,true);
			}
		}

		public void	Delete()
		{
			// TODO:  Add EventLogger.Delete implementation
		}

		public void	ArrangeColumns()
		{
			// TODO:  Add EventLogger.ArrangeColumns implementation
		}

		public void	ClearFilter()
		{
			SyncGridUtilities.ClearFilter(gridEventLogs1);   
		}

		public void	InsertNewRows()
		{
			// TODO:  Add EventLogger.InsertNewRows	implementation
		}

		public void	ImportToExcel()
		{
			// TODO:  Add EventLogger.ImportToExcel	implementation
		}

		public void	Export()
		{
			if(gridEventLogs1.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridEventLogs1);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public void	SelectionPaste()
		{
			// TODO:  Add EventLogger.SelectionPaste implementation
		}

		public void	RightLevel()
		{
			// TODO:  Add EventLogger.RightLevel implementation
		}

		public void	LeftLevel()
		{
			// TODO:  Add EventLogger.LeftLevel	implementation
		}

		public void	UpLevel()
		{
			// TODO:  Add EventLogger.UpLevel implementation
		}

		public void	DownLevel()
		{
			// TODO:  Add EventLogger.DownLevel	implementation
		}

		public void	ClearSort()
		{
			SyncGridUtilities.ClearSort(gridEventLogs1);
		}

		public void	CopyUOMTypes()
		{
			// TODO:  Add EventLogger.CopyUOMTypes implementation
		}

		public bool	SupportsMasterPropertiesCopy()
		{
			// TODO:  Add EventLogger.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool	SupportsCopy()
		{
			// TODO:  Add EventLogger.SupportsCopy implementation
			return false;
		}

		public bool	SupportsPaste()
		{
			// TODO:  Add EventLogger.SupportsPaste	implementation
			return false;
		}

		public bool	SupportsExport()
		{
			// TODO:  Add EventLogger.SupportsExport implementation
			return true;
		}

		public bool	SupportsSave()
		{
			// TODO:  Add EventLogger.SupportsSave implementation
			return false;
		}

		public bool	SupportsRefresh()
		{
			// TODO:  Add EventLogger.SupportsRefresh implementation
			return true;
		}

		public bool	SupportsDelete()
		{
			// TODO:  Add EventLogger.SupportsDelete implementation
			return false;
		}

		public bool	SupportsPrint()
		{
			// TODO:  Add EventLogger.SupportsPrint	implementation
			return true;
		}

		public bool	SupportsArrangeColumns()
		{
			// TODO:  Add EventLogger.SupportsArrangeColumns implementation
			return false;
		}

		public bool	SupportsClearFilter()
		{
			// TODO:  Add EventLogger.SupportsClearFilter implementation
			return true;
		}

		public bool	SupportsInsertNewRows()
		{
			// TODO:  Add EventLogger.SupportsInsertNewRows	implementation
			return false;
		}

		public bool	SupportsImportToExcel()
		{
			// TODO:  Add EventLogger.SupportsImportToExcel	implementation
			return false;
		}

		public bool	SupportsSelectionPaste()
		{
			// TODO:  Add EventLogger.SupportsSelectionPaste implementation
			return false;
		}

		public bool	SupportsLevel()
		{
			// TODO:  Add EventLogger.SupportsLevel	implementation
			return false;
		}

		public bool	SupportsClearSort()
		{
			// TODO:  Add EventLogger.SupportsClearSort	implementation
			return true;
		}

		public bool	SupportsCopyUOMTypes()
		{
			// TODO:  Add EventLogger.SupportsCopyUOMTypes implementation
			return false;
		}


		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl =	value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		#endregion

		#region	ILRRUIContainer	Members

		public void	ShowPropertyList()
		{
			// TODO:  Add EventLogger.ShowPropertyList implementation
		}

		public void	ShowComponentList()
		{
			// TODO:  Add EventLogger.ShowComponentList	implementation
		}

		public bool	SupportsResultsFilter()
		{
			// TODO:  Add EventLogger.SupportsResultsFilter	implementation
			return false;
		}

		#endregion



		private	void gridEventLogs1_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(((Control.ModifierKeys &	Keys.Control) != 0))

			{

				// Cancel the default sorting...
				e.Inner.Cancel = true;
				GridColumnDescriptor column	= e.TableControl.Table.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex);
				string col = column.Name;
				if(this.gridEventLogs1.TableDescriptor.SortedColumns.Contains(col))
				{
					if(this.gridEventLogs1.TableDescriptor.SortedColumns[col].SortDirection	== ListSortDirection.Ascending)
					{
						this.gridEventLogs1.TableDescriptor.SortedColumns[col].SortDirection = ListSortDirection.Descending;
					}
					else
					{
						this.gridEventLogs1.TableDescriptor.SortedColumns[col].SortDirection = ListSortDirection.Ascending;
					}
				}
				else
				{
					this.gridEventLogs1.TableDescriptor.SortedColumns.Add(col, ListSortDirection.Ascending);
				}
			}
		}
		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add EventLogger.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add EventLogger.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add EventLogger.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add EventLogger.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add EventLogger.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add EventLogger.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add EventLogger.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add EventLogger.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add EventLogger.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add EventLogger.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add EventLogger.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add EventLogger.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add EventLogger.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add EventLogger.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add EventLogger.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
