using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.ExecutionEngine;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for EngineValueExtractor.
	/// </summary>
	public class EngineValueExtractor : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnStart;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private LRRApp				_app;
		private bool				_isRunning;

		public EngineValueExtractor(LRRApp app)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_app = app;

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.btnStart = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(520, 56);
			this.label1.TabIndex = 0;
			this.label1.Text = "This utility will extract the values from the engine and store it in to database." +
				" To Start the extraction process please click on the start button.";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// btnStart
			// 
			this.btnStart.Location = new System.Drawing.Point(248, 72);
			this.btnStart.Name = "btnStart";
			this.btnStart.TabIndex = 2;
			this.btnStart.Text = "&Start";
			this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
			// 
			// EngineValueExtractor
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 104);
			this.Controls.Add(this.btnStart);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "EngineValueExtractor";
			this.Text = "Engine Value Extractor";
			this.ResumeLayout(false);

		}
		#endregion

		private void btnStart_Click(object sender, System.EventArgs e)
		{
			LRRExecutionEngine ee = new LRRExecutionEngine(_app.SymExcelWrapperObj,_app.GetOptions(),_app.ActiveRunControlSet);
			this.btnStart.Text = "Working";
			_app.GetOptions().ReadInputsFromEngine = true;
			_isRunning = true;
			ee.internalExecuteWriteCycle();
			_app.GetOptions().ReadInputsFromEngine = false;
			_isRunning = false;
			DialogResult dlgRes = LRRMessagBox.ShowMessage("SID_EXTRACT_VALUES","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Information);
			if(dlgRes == DialogResult.Yes)
			{
				_app.DBManagerObj.CommitCollection(Symcon.LightRidge.BusinessObjects.LRRModel.PropertyValuesObj.GetChanges());
				_app.DBManagerObj.CommitCollection(Symcon.LightRidge.BusinessObjects.LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges());

				this.Close();
			}
			else
			{
				this.Close();
			}
			this.btnStart.Text =  "Completed";
		}
	}
}
