using System;
using System.Drawing;
using System.Data;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.ExcelWrapper;
using Symcon.Utils.MessageDispatcher;
using System.Data.OleDb;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.HistorianConnect;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.Lightridge.LRRUI;
using Syncfusion.Windows.Forms.Diagram.Controls;
using Syncfusion.Windows.Forms.Diagram;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters;
using System.IO;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.ExecutionEngine;
using Symcon.LightRidge.ExecutionEngine.Model;
using System.Collections.Generic;



namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ExecutionEngine.
	/// </summary>
	public class ExecutionEngine : System.Windows.Forms.Form
	{
		#region Fields

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private ExcelWrapper.SymExcelWrapper		_symExcelWrapper;
		private LRRApp								_app;
		private LRRMasterComponents							masterComponents;
		private LRRSiteComponents							siteComponents;
		private LRRSiteComponentProperties					siteComponentProperties;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Button button8;
		private System.Windows.Forms.TextBox txtPropValID;
		private System.Windows.Forms.TextBox txtMode;
		private System.Windows.Forms.Label lblPV;
		private System.Windows.Forms.Label lblAPV;
		private System.Windows.Forms.Label lblOV;
		private System.Windows.Forms.Label lblAOV;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Button btnCalc;
		private System.Windows.Forms.Label lblSiteCompPropID;
		private System.Windows.Forms.Label lblModeID;
		private System.Windows.Forms.GroupBox grpUpdate;
		private System.Windows.Forms.Label lblDBPath;
		private System.Windows.Forms.TextBox txtDBPath;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button btnExcelBrowse;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.Button btnUpdate;
		private LRRSiteComponentPropertyValues				siteComponentPropertyValues;

		private OleDbConnection _connection;
		private OleDbCommand _command;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button cmdBrowse;
		private System.Windows.Forms.TextBox txtExcelFile;
		private System.Windows.Forms.Button button10;
		private System.Windows.Forms.Button button9;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button btnProcessNow;
		private System.Windows.Forms.Button button11;
		private System.Windows.Forms.Button button12;
		private System.Windows.Forms.Button button13;
		private System.Windows.Forms.Button button14;
		private System.Windows.Forms.Button btnProcessModeless;
		private System.Windows.Forms.Button button15;
		private System.Windows.Forms.TextBox txtMasterModeUpdateFile;
		private System.Windows.Forms.Button button16;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.Button btnGPDerivations;
		private System.Windows.Forms.Button btnGPDirectionExcelMapper;
		private System.Windows.Forms.Button btnGPBrowse;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button button17;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.DateTimePicker tagDateTime;
		private System.Windows.Forms.TextBox txtHistValue;
		private System.Windows.Forms.TextBox txtHistServer;
		private System.Windows.Forms.TextBox txtHistTag;
		private System.Windows.Forms.Button btnUpdateGraphics;
		private DataTable _dt;
		private GraphicsManagers gms = new GraphicsManagers();
		private System.Windows.Forms.Button btnPortGraphics;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.ComboBox cmbDBType;
		private System.Windows.Forms.Button button18;
		private System.Windows.Forms.TextBox txtTargetDB;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.TextBox txtTargetDBName;
		private System.Windows.Forms.TextBox txtTargetServer;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.TextBox txtTargetUserName;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox txtTargetPWD;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Button button19;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.TextBox txtManualExcel;
		private System.Windows.Forms.TextBox txtTunDBPath;
		private System.Windows.Forms.Button btnTunDBUpdate;
		private System.Windows.Forms.Button btnManXLBrowse;
		private System.Windows.Forms.Button btnTunDBBrowse;
		private System.Windows.Forms.Label lblprogress;
		private System.Windows.Forms.Label lblprogress1;
		private LRRSavedViews lrrsvs = new LRRSavedViews();
		#endregion

		public ExecutionEngine()
		{
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_symExcelWrapper = /*new SymExcelWrapper(@"C:\Ashutosh\Projects\LightRidge\Source_02_Nov_2005\DesktopApplication_US\ExternalLib");*/ _app.SymExcelWrapperObj;
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button6 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.button7 = new System.Windows.Forms.Button();
			this.button8 = new System.Windows.Forms.Button();
			this.txtPropValID = new System.Windows.Forms.TextBox();
			this.txtMode = new System.Windows.Forms.TextBox();
			this.lblPV = new System.Windows.Forms.Label();
			this.lblAPV = new System.Windows.Forms.Label();
			this.lblOV = new System.Windows.Forms.Label();
			this.lblAOV = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.btnCalc = new System.Windows.Forms.Button();
			this.lblSiteCompPropID = new System.Windows.Forms.Label();
			this.lblModeID = new System.Windows.Forms.Label();
			this.grpUpdate = new System.Windows.Forms.GroupBox();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.btnExcelBrowse = new System.Windows.Forms.Button();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.lblDBPath = new System.Windows.Forms.Label();
			this.txtDBPath = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.cmdBrowse = new System.Windows.Forms.Button();
			this.txtExcelFile = new System.Windows.Forms.TextBox();
			this.button10 = new System.Windows.Forms.Button();
			this.button9 = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.btnProcessNow = new System.Windows.Forms.Button();
			this.button11 = new System.Windows.Forms.Button();
			this.button12 = new System.Windows.Forms.Button();
			this.button13 = new System.Windows.Forms.Button();
			this.button14 = new System.Windows.Forms.Button();
			this.btnProcessModeless = new System.Windows.Forms.Button();
			this.button15 = new System.Windows.Forms.Button();
			this.txtMasterModeUpdateFile = new System.Windows.Forms.TextBox();
			this.button16 = new System.Windows.Forms.Button();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.btnGPBrowse = new System.Windows.Forms.Button();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.btnGPDirectionExcelMapper = new System.Windows.Forms.Button();
			this.btnGPDerivations = new System.Windows.Forms.Button();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.label9 = new System.Windows.Forms.Label();
			this.tagDateTime = new System.Windows.Forms.DateTimePicker();
			this.button17 = new System.Windows.Forms.Button();
			this.txtHistValue = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.txtHistServer = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtHistTag = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.btnUpdateGraphics = new System.Windows.Forms.Button();
			this.btnPortGraphics = new System.Windows.Forms.Button();
			this.label10 = new System.Windows.Forms.Label();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.txtTargetPWD = new System.Windows.Forms.TextBox();
			this.label15 = new System.Windows.Forms.Label();
			this.txtTargetUserName = new System.Windows.Forms.TextBox();
			this.label14 = new System.Windows.Forms.Label();
			this.txtTargetServer = new System.Windows.Forms.TextBox();
			this.label13 = new System.Windows.Forms.Label();
			this.txtTargetDBName = new System.Windows.Forms.TextBox();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.button18 = new System.Windows.Forms.Button();
			this.txtTargetDB = new System.Windows.Forms.TextBox();
			this.cmbDBType = new System.Windows.Forms.ComboBox();
			this.button19 = new System.Windows.Forms.Button();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.lblprogress1 = new System.Windows.Forms.Label();
			this.lblprogress = new System.Windows.Forms.Label();
			this.btnTunDBUpdate = new System.Windows.Forms.Button();
			this.btnManXLBrowse = new System.Windows.Forms.Button();
			this.btnTunDBBrowse = new System.Windows.Forms.Button();
			this.label16 = new System.Windows.Forms.Label();
			this.txtManualExcel = new System.Windows.Forms.TextBox();
			this.label17 = new System.Windows.Forms.Label();
			this.txtTunDBPath = new System.Windows.Forms.TextBox();
			this.grpUpdate.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.groupBox6.SuspendLayout();
			this.SuspendLayout();
			// 
			// button6
			// 
			this.button6.Location = new System.Drawing.Point(240, 8);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(160, 24);
			this.button6.TabIndex = 5;
			this.button6.Text = "Write To Excel";
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(20, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(188, 24);
			this.button1.TabIndex = 6;
			this.button1.Text = "Recreate Mode Specific Values";
			this.button1.Click += new System.EventHandler(this.button1_Click_1);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(240, 56);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(160, 24);
			this.button2.TabIndex = 7;
			this.button2.Text = "Read From Excel";
			this.button2.Click += new System.EventHandler(this.button2_Click_1);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(240, 104);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(160, 24);
			this.button3.TabIndex = 8;
			this.button3.Text = "Get All Named Ranges";
			this.button3.Click += new System.EventHandler(this.button3_Click_1);
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(20, 56);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(188, 24);
			this.button4.TabIndex = 9;
			this.button4.Text = "Recrete Mapping Info";
			this.button4.Click += new System.EventHandler(this.button4_Click_1);
			// 
			// button5
			// 
			this.button5.Location = new System.Drawing.Point(20, 152);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(188, 24);
			this.button5.TabIndex = 10;
			this.button5.Text = "button5";
			this.button5.Click += new System.EventHandler(this.button5_Click_1);
			// 
			// button7
			// 
			this.button7.Location = new System.Drawing.Point(240, 152);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(160, 24);
			this.button7.TabIndex = 11;
			this.button7.Text = "Get Group Property";
			this.button7.Click += new System.EventHandler(this.button7_Click);
			// 
			// button8
			// 
			this.button8.Location = new System.Drawing.Point(20, 104);
			this.button8.Name = "button8";
			this.button8.Size = new System.Drawing.Size(188, 24);
			this.button8.TabIndex = 12;
			this.button8.Text = "button8";
			this.button8.Click += new System.EventHandler(this.button8_Click);
			// 
			// txtPropValID
			// 
			this.txtPropValID.Location = new System.Drawing.Point(24, 224);
			this.txtPropValID.Name = "txtPropValID";
			this.txtPropValID.Size = new System.Drawing.Size(216, 20);
			this.txtPropValID.TabIndex = 13;
			this.txtPropValID.Text = "";
			// 
			// txtMode
			// 
			this.txtMode.Location = new System.Drawing.Point(24, 280);
			this.txtMode.Name = "txtMode";
			this.txtMode.Size = new System.Drawing.Size(216, 20);
			this.txtMode.TabIndex = 14;
			this.txtMode.Text = "";
			// 
			// lblPV
			// 
			this.lblPV.Location = new System.Drawing.Point(288, 208);
			this.lblPV.Name = "lblPV";
			this.lblPV.Size = new System.Drawing.Size(104, 23);
			this.lblPV.TabIndex = 15;
			// 
			// lblAPV
			// 
			this.lblAPV.Location = new System.Drawing.Point(288, 240);
			this.lblAPV.Name = "lblAPV";
			this.lblAPV.TabIndex = 16;
			// 
			// lblOV
			// 
			this.lblOV.Location = new System.Drawing.Point(288, 272);
			this.lblOV.Name = "lblOV";
			this.lblOV.TabIndex = 17;
			// 
			// lblAOV
			// 
			this.lblAOV.Location = new System.Drawing.Point(288, 304);
			this.lblAOV.Name = "lblAOV";
			this.lblAOV.TabIndex = 18;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(408, 200);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(104, 23);
			this.label5.TabIndex = 19;
			this.label5.Text = "Property Value";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(408, 232);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(104, 23);
			this.label6.TabIndex = 20;
			this.label6.Text = "Actual Prop Value";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(408, 264);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(104, 23);
			this.label7.TabIndex = 21;
			this.label7.Text = "Overrided Value";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(416, 304);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(128, 23);
			this.label8.TabIndex = 22;
			this.label8.Text = "Actual Overrided Value";
			// 
			// btnCalc
			// 
			this.btnCalc.Location = new System.Drawing.Point(40, 320);
			this.btnCalc.Name = "btnCalc";
			this.btnCalc.Size = new System.Drawing.Size(160, 23);
			this.btnCalc.TabIndex = 23;
			this.btnCalc.Text = "Calculate Property Values";
			this.btnCalc.Click += new System.EventHandler(this.btnCalc_Click);
			// 
			// lblSiteCompPropID
			// 
			this.lblSiteCompPropID.Location = new System.Drawing.Point(24, 200);
			this.lblSiteCompPropID.Name = "lblSiteCompPropID";
			this.lblSiteCompPropID.Size = new System.Drawing.Size(184, 16);
			this.lblSiteCompPropID.TabIndex = 24;
			this.lblSiteCompPropID.Text = "Site Component Property ID";
			// 
			// lblModeID
			// 
			this.lblModeID.Location = new System.Drawing.Point(24, 248);
			this.lblModeID.Name = "lblModeID";
			this.lblModeID.Size = new System.Drawing.Size(144, 23);
			this.lblModeID.TabIndex = 25;
			this.lblModeID.Text = "Mode ID";
			// 
			// grpUpdate
			// 
			this.grpUpdate.Controls.Add(this.btnUpdate);
			this.grpUpdate.Controls.Add(this.btnExcelBrowse);
			this.grpUpdate.Controls.Add(this.btnBrowse);
			this.grpUpdate.Controls.Add(this.label1);
			this.grpUpdate.Controls.Add(this.textBox1);
			this.grpUpdate.Controls.Add(this.lblDBPath);
			this.grpUpdate.Controls.Add(this.txtDBPath);
			this.grpUpdate.Location = new System.Drawing.Point(16, 352);
			this.grpUpdate.Name = "grpUpdate";
			this.grpUpdate.Size = new System.Drawing.Size(408, 128);
			this.grpUpdate.TabIndex = 30;
			this.grpUpdate.TabStop = false;
			this.grpUpdate.Text = "Update Site Component Sort Index";
			// 
			// btnUpdate
			// 
			this.btnUpdate.Location = new System.Drawing.Point(296, 80);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.Size = new System.Drawing.Size(96, 24);
			this.btnUpdate.TabIndex = 10;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// btnExcelBrowse
			// 
			this.btnExcelBrowse.Location = new System.Drawing.Point(296, 48);
			this.btnExcelBrowse.Name = "btnExcelBrowse";
			this.btnExcelBrowse.Size = new System.Drawing.Size(96, 24);
			this.btnExcelBrowse.TabIndex = 9;
			this.btnExcelBrowse.Text = "Browse";
			this.btnExcelBrowse.Click += new System.EventHandler(this.btnExcelBrowse_Click);
			// 
			// btnBrowse
			// 
			this.btnBrowse.Location = new System.Drawing.Point(296, 16);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(96, 24);
			this.btnBrowse.TabIndex = 8;
			this.btnBrowse.Text = "Browse";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 64);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.TabIndex = 7;
			this.label1.Text = "Excel Path";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(104, 58);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(176, 20);
			this.textBox1.TabIndex = 6;
			this.textBox1.Text = "";
			// 
			// lblDBPath
			// 
			this.lblDBPath.Location = new System.Drawing.Point(16, 32);
			this.lblDBPath.Name = "lblDBPath";
			this.lblDBPath.Size = new System.Drawing.Size(80, 16);
			this.lblDBPath.TabIndex = 4;
			this.lblDBPath.Text = "Database Path";
			// 
			// txtDBPath
			// 
			this.txtDBPath.Location = new System.Drawing.Point(104, 26);
			this.txtDBPath.Name = "txtDBPath";
			this.txtDBPath.Size = new System.Drawing.Size(176, 20);
			this.txtDBPath.TabIndex = 3;
			this.txtDBPath.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.cmdBrowse);
			this.groupBox1.Controls.Add(this.txtExcelFile);
			this.groupBox1.Controls.Add(this.button10);
			this.groupBox1.Controls.Add(this.button9);
			this.groupBox1.Location = new System.Drawing.Point(416, 488);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(392, 160);
			this.groupBox1.TabIndex = 31;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Simple Properties";
			// 
			// cmdBrowse
			// 
			this.cmdBrowse.Location = new System.Drawing.Point(296, 72);
			this.cmdBrowse.Name = "cmdBrowse";
			this.cmdBrowse.Size = new System.Drawing.Size(64, 24);
			this.cmdBrowse.TabIndex = 33;
			this.cmdBrowse.Text = "Browse";
			this.cmdBrowse.Click += new System.EventHandler(this.button11_Click);
			// 
			// txtExcelFile
			// 
			this.txtExcelFile.Location = new System.Drawing.Point(32, 72);
			this.txtExcelFile.Name = "txtExcelFile";
			this.txtExcelFile.Size = new System.Drawing.Size(255, 20);
			this.txtExcelFile.TabIndex = 32;
			this.txtExcelFile.Text = "";
			// 
			// button10
			// 
			this.button10.Location = new System.Drawing.Point(32, 112);
			this.button10.Name = "button10";
			this.button10.Size = new System.Drawing.Size(328, 32);
			this.button10.TabIndex = 31;
			this.button10.Text = "Update Directions Using Excel Mapper";
			this.button10.Click += new System.EventHandler(this.button10_Click);
			// 
			// button9
			// 
			this.button9.Location = new System.Drawing.Point(31, 24);
			this.button9.Name = "button9";
			this.button9.Size = new System.Drawing.Size(328, 32);
			this.button9.TabIndex = 30;
			this.button9.Text = "Meas Mode Direction/Derivations and SS/SC Derivations ";
			this.button9.Click += new System.EventHandler(this.button9_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.btnProcessNow);
			this.groupBox2.Location = new System.Drawing.Point(536, 200);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(336, 112);
			this.groupBox2.TabIndex = 32;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Process Master and Propogate for Plant Unit & Notes & Comments ";
			// 
			// btnProcessNow
			// 
			this.btnProcessNow.Location = new System.Drawing.Point(32, 40);
			this.btnProcessNow.Name = "btnProcessNow";
			this.btnProcessNow.Size = new System.Drawing.Size(272, 48);
			this.btnProcessNow.TabIndex = 0;
			this.btnProcessNow.Text = "Process Now";
			this.btnProcessNow.Click += new System.EventHandler(this.btnProcessNow_Click);
			// 
			// button11
			// 
			this.button11.Location = new System.Drawing.Point(888, 232);
			this.button11.Name = "button11";
			this.button11.Size = new System.Drawing.Size(96, 56);
			this.button11.TabIndex = 33;
			this.button11.Text = "Create Data for User 10 Gary";
			this.button11.Click += new System.EventHandler(this.button11_Click_1);
			// 
			// button12
			// 
			this.button12.Location = new System.Drawing.Point(1008, 232);
			this.button12.Name = "button12";
			this.button12.Size = new System.Drawing.Size(96, 56);
			this.button12.TabIndex = 34;
			this.button12.Text = "Create Data for User 11 Joe";
			this.button12.Click += new System.EventHandler(this.button12_Click);
			// 
			// button13
			// 
			this.button13.Location = new System.Drawing.Point(888, 16);
			this.button13.Name = "button13";
			this.button13.Size = new System.Drawing.Size(176, 40);
			this.button13.TabIndex = 35;
			this.button13.Text = "Set Model UOM for Historian Data";
			this.button13.Click += new System.EventHandler(this.button13_Click);
			// 
			// button14
			// 
			this.button14.Location = new System.Drawing.Point(888, 72);
			this.button14.Name = "button14";
			this.button14.Size = new System.Drawing.Size(176, 48);
			this.button14.TabIndex = 36;
			this.button14.Text = "Set Site Property UOM Type from Master";
			this.button14.Click += new System.EventHandler(this.button14_Click);
			// 
			// btnProcessModeless
			// 
			this.btnProcessModeless.Location = new System.Drawing.Point(888, 192);
			this.btnProcessModeless.Name = "btnProcessModeless";
			this.btnProcessModeless.Size = new System.Drawing.Size(208, 24);
			this.btnProcessModeless.TabIndex = 37;
			this.btnProcessModeless.Text = "Set Modeless";
			this.btnProcessModeless.Click += new System.EventHandler(this.btnProcessModeless_Click);
			// 
			// button15
			// 
			this.button15.Location = new System.Drawing.Point(1056, 144);
			this.button15.Name = "button15";
			this.button15.Size = new System.Drawing.Size(56, 24);
			this.button15.TabIndex = 38;
			this.button15.Text = "Browse";
			this.button15.Click += new System.EventHandler(this.button15_Click);
			// 
			// txtMasterModeUpdateFile
			// 
			this.txtMasterModeUpdateFile.Location = new System.Drawing.Point(888, 144);
			this.txtMasterModeUpdateFile.Name = "txtMasterModeUpdateFile";
			this.txtMasterModeUpdateFile.Size = new System.Drawing.Size(160, 20);
			this.txtMasterModeUpdateFile.TabIndex = 39;
			this.txtMasterModeUpdateFile.Text = "";
			// 
			// button16
			// 
			this.button16.Location = new System.Drawing.Point(888, 296);
			this.button16.Name = "button16";
			this.button16.Size = new System.Drawing.Size(216, 48);
			this.button16.TabIndex = 40;
			this.button16.Text = "Update UOM Type From Master";
			this.button16.Click += new System.EventHandler(this.button16_Click);
			// 
			// groupBox3
			// 
			this.groupBox3.BackColor = System.Drawing.SystemColors.Control;
			this.groupBox3.Controls.Add(this.btnGPBrowse);
			this.groupBox3.Controls.Add(this.textBox2);
			this.groupBox3.Controls.Add(this.btnGPDirectionExcelMapper);
			this.groupBox3.Controls.Add(this.btnGPDerivations);
			this.groupBox3.Location = new System.Drawing.Point(16, 488);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(392, 152);
			this.groupBox3.TabIndex = 41;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Grouped Properties";
			// 
			// btnGPBrowse
			// 
			this.btnGPBrowse.Location = new System.Drawing.Point(296, 72);
			this.btnGPBrowse.Name = "btnGPBrowse";
			this.btnGPBrowse.Size = new System.Drawing.Size(64, 24);
			this.btnGPBrowse.TabIndex = 33;
			this.btnGPBrowse.Text = "Browse";
			this.btnGPBrowse.Click += new System.EventHandler(this.button17_Click);
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(32, 72);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(255, 20);
			this.textBox2.TabIndex = 32;
			this.textBox2.Text = "";
			// 
			// btnGPDirectionExcelMapper
			// 
			this.btnGPDirectionExcelMapper.Location = new System.Drawing.Point(32, 112);
			this.btnGPDirectionExcelMapper.Name = "btnGPDirectionExcelMapper";
			this.btnGPDirectionExcelMapper.Size = new System.Drawing.Size(328, 32);
			this.btnGPDirectionExcelMapper.TabIndex = 31;
			this.btnGPDirectionExcelMapper.Text = "Update Directions Using Excel Mapper";
			this.btnGPDirectionExcelMapper.Click += new System.EventHandler(this.btnGPDirectionExcelMapper_Click);
			// 
			// btnGPDerivations
			// 
			this.btnGPDerivations.Location = new System.Drawing.Point(31, 24);
			this.btnGPDerivations.Name = "btnGPDerivations";
			this.btnGPDerivations.Size = new System.Drawing.Size(328, 32);
			this.btnGPDerivations.TabIndex = 30;
			this.btnGPDerivations.Text = "Meas Mode Direction/Derivations and SS/SC Derivations ";
			this.btnGPDerivations.Click += new System.EventHandler(this.btnGPDerivations_Click);
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.label9);
			this.groupBox4.Controls.Add(this.tagDateTime);
			this.groupBox4.Controls.Add(this.button17);
			this.groupBox4.Controls.Add(this.txtHistValue);
			this.groupBox4.Controls.Add(this.label4);
			this.groupBox4.Controls.Add(this.txtHistServer);
			this.groupBox4.Controls.Add(this.label3);
			this.groupBox4.Controls.Add(this.txtHistTag);
			this.groupBox4.Controls.Add(this.label2);
			this.groupBox4.Location = new System.Drawing.Point(536, 16);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(328, 176);
			this.groupBox4.TabIndex = 42;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Set Historian Value";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(16, 88);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(72, 23);
			this.label9.TabIndex = 8;
			this.label9.Text = "Date Time";
			// 
			// tagDateTime
			// 
			this.tagDateTime.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.tagDateTime.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.tagDateTime.Location = new System.Drawing.Point(104, 88);
			this.tagDateTime.Name = "tagDateTime";
			this.tagDateTime.Size = new System.Drawing.Size(176, 20);
			this.tagDateTime.TabIndex = 7;
			// 
			// button17
			// 
			this.button17.Location = new System.Drawing.Point(144, 144);
			this.button17.Name = "button17";
			this.button17.TabIndex = 6;
			this.button17.Text = "Set";
			this.button17.Click += new System.EventHandler(this.button17_Click_1);
			// 
			// txtHistValue
			// 
			this.txtHistValue.Location = new System.Drawing.Point(104, 120);
			this.txtHistValue.Name = "txtHistValue";
			this.txtHistValue.Size = new System.Drawing.Size(176, 20);
			this.txtHistValue.TabIndex = 5;
			this.txtHistValue.Text = "200.67";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 122);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(64, 23);
			this.label4.TabIndex = 4;
			this.label4.Text = "Value(float)";
			// 
			// txtHistServer
			// 
			this.txtHistServer.Location = new System.Drawing.Point(104, 56);
			this.txtHistServer.Name = "txtHistServer";
			this.txtHistServer.Size = new System.Drawing.Size(176, 20);
			this.txtHistServer.TabIndex = 3;
			this.txtHistServer.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 24);
			this.label3.TabIndex = 2;
			this.label3.Text = "Server";
			// 
			// txtHistTag
			// 
			this.txtHistTag.Location = new System.Drawing.Point(104, 32);
			this.txtHistTag.Name = "txtHistTag";
			this.txtHistTag.Size = new System.Drawing.Size(176, 20);
			this.txtHistTag.TabIndex = 1;
			this.txtHistTag.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 32);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 24);
			this.label2.TabIndex = 0;
			this.label2.Text = "Hist Tag";
			// 
			// btnUpdateGraphics
			// 
			this.btnUpdateGraphics.Location = new System.Drawing.Point(424, 11);
			this.btnUpdateGraphics.Name = "btnUpdateGraphics";
			this.btnUpdateGraphics.Size = new System.Drawing.Size(96, 165);
			this.btnUpdateGraphics.TabIndex = 43;
			this.btnUpdateGraphics.Text = "Update Graphics";
			this.btnUpdateGraphics.Click += new System.EventHandler(this.btnUpdateGraphics_Click);
			// 
			// btnPortGraphics
			// 
			this.btnPortGraphics.Location = new System.Drawing.Point(128, 304);
			this.btnPortGraphics.Name = "btnPortGraphics";
			this.btnPortGraphics.Size = new System.Drawing.Size(88, 32);
			this.btnPortGraphics.TabIndex = 44;
			this.btnPortGraphics.Text = "Port Graphics";
			this.btnPortGraphics.Click += new System.EventHandler(this.btnPortGraphics_Click);
			// 
			// label10
			// 
			this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label10.Location = new System.Drawing.Point(13, 24);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(99, 32);
			this.label10.TabIndex = 45;
			this.label10.Text = "Target Database Type";
			// 
			// groupBox5
			// 
			this.groupBox5.BackColor = System.Drawing.SystemColors.Control;
			this.groupBox5.Controls.Add(this.txtTargetPWD);
			this.groupBox5.Controls.Add(this.label15);
			this.groupBox5.Controls.Add(this.txtTargetUserName);
			this.groupBox5.Controls.Add(this.label14);
			this.groupBox5.Controls.Add(this.txtTargetServer);
			this.groupBox5.Controls.Add(this.label13);
			this.groupBox5.Controls.Add(this.txtTargetDBName);
			this.groupBox5.Controls.Add(this.label12);
			this.groupBox5.Controls.Add(this.label11);
			this.groupBox5.Controls.Add(this.button18);
			this.groupBox5.Controls.Add(this.txtTargetDB);
			this.groupBox5.Controls.Add(this.cmbDBType);
			this.groupBox5.Controls.Add(this.label10);
			this.groupBox5.Controls.Add(this.btnPortGraphics);
			this.groupBox5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox5.Location = new System.Drawing.Point(888, 368);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(224, 344);
			this.groupBox5.TabIndex = 46;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Export Graphics";
			// 
			// txtTargetPWD
			// 
			this.txtTargetPWD.Location = new System.Drawing.Point(80, 272);
			this.txtTargetPWD.Name = "txtTargetPWD";
			this.txtTargetPWD.Size = new System.Drawing.Size(128, 20);
			this.txtTargetPWD.TabIndex = 57;
			this.txtTargetPWD.Text = "";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(16, 272);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(56, 24);
			this.label15.TabIndex = 56;
			this.label15.Text = "Password";
			// 
			// txtTargetUserName
			// 
			this.txtTargetUserName.Location = new System.Drawing.Point(80, 232);
			this.txtTargetUserName.Name = "txtTargetUserName";
			this.txtTargetUserName.Size = new System.Drawing.Size(128, 20);
			this.txtTargetUserName.TabIndex = 55;
			this.txtTargetUserName.Text = "";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(16, 232);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(56, 24);
			this.label14.TabIndex = 54;
			this.label14.Text = "User Name";
			// 
			// txtTargetServer
			// 
			this.txtTargetServer.Location = new System.Drawing.Point(80, 200);
			this.txtTargetServer.Name = "txtTargetServer";
			this.txtTargetServer.Size = new System.Drawing.Size(128, 20);
			this.txtTargetServer.TabIndex = 53;
			this.txtTargetServer.Text = "";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(16, 200);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(56, 24);
			this.label13.TabIndex = 52;
			this.label13.Text = "Server";
			// 
			// txtTargetDBName
			// 
			this.txtTargetDBName.Location = new System.Drawing.Point(80, 160);
			this.txtTargetDBName.Name = "txtTargetDBName";
			this.txtTargetDBName.Size = new System.Drawing.Size(128, 20);
			this.txtTargetDBName.TabIndex = 51;
			this.txtTargetDBName.Text = "";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(16, 160);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(56, 32);
			this.label12.TabIndex = 50;
			this.label12.Text = "Database Name";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(16, 72);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(80, 16);
			this.label11.TabIndex = 49;
			this.label11.Text = "Database Path";
			// 
			// button18
			// 
			this.button18.Location = new System.Drawing.Point(136, 120);
			this.button18.Name = "button18";
			this.button18.Size = new System.Drawing.Size(72, 24);
			this.button18.TabIndex = 48;
			this.button18.Text = "Browse";
			this.button18.Click += new System.EventHandler(this.button18_Click);
			// 
			// txtTargetDB
			// 
			this.txtTargetDB.Location = new System.Drawing.Point(16, 88);
			this.txtTargetDB.Name = "txtTargetDB";
			this.txtTargetDB.Size = new System.Drawing.Size(192, 20);
			this.txtTargetDB.TabIndex = 47;
			this.txtTargetDB.Text = "";
			// 
			// cmbDBType
			// 
			this.cmbDBType.Items.AddRange(new object[] {
														   "ACCESS",
														   "SQLSERVER"});
			this.cmbDBType.Location = new System.Drawing.Point(120, 24);
			this.cmbDBType.Name = "cmbDBType";
			this.cmbDBType.Size = new System.Drawing.Size(96, 21);
			this.cmbDBType.TabIndex = 46;
			// 
			// button19
			// 
			this.button19.Location = new System.Drawing.Point(48, 648);
			this.button19.Name = "button19";
			this.button19.Size = new System.Drawing.Size(184, 48);
			this.button19.TabIndex = 47;
			this.button19.Text = "Analyze UOM Types";
			this.button19.Click += new System.EventHandler(this.button19_Click);
			// 
			// groupBox6
			// 
			this.groupBox6.BackColor = System.Drawing.SystemColors.Control;
			this.groupBox6.Controls.Add(this.lblprogress1);
			this.groupBox6.Controls.Add(this.lblprogress);
			this.groupBox6.Controls.Add(this.btnTunDBUpdate);
			this.groupBox6.Controls.Add(this.btnManXLBrowse);
			this.groupBox6.Controls.Add(this.btnTunDBBrowse);
			this.groupBox6.Controls.Add(this.label16);
			this.groupBox6.Controls.Add(this.txtManualExcel);
			this.groupBox6.Controls.Add(this.label17);
			this.groupBox6.Controls.Add(this.txtTunDBPath);
			this.groupBox6.Location = new System.Drawing.Point(424, 352);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(456, 128);
			this.groupBox6.TabIndex = 47;
			this.groupBox6.TabStop = false;
			this.groupBox6.Text = "Update Tuning Database";
			// 
			// lblprogress1
			// 
			this.lblprogress1.Location = new System.Drawing.Point(150, 95);
			this.lblprogress1.Name = "lblprogress1";
			this.lblprogress1.Size = new System.Drawing.Size(178, 23);
			this.lblprogress1.TabIndex = 16;
			// 
			// lblprogress
			// 
			this.lblprogress.Location = new System.Drawing.Point(16, 92);
			this.lblprogress.Name = "lblprogress";
			this.lblprogress.Size = new System.Drawing.Size(120, 23);
			this.lblprogress.TabIndex = 15;
			// 
			// btnTunDBUpdate
			// 
			this.btnTunDBUpdate.Location = new System.Drawing.Point(344, 88);
			this.btnTunDBUpdate.Name = "btnTunDBUpdate";
			this.btnTunDBUpdate.Size = new System.Drawing.Size(96, 24);
			this.btnTunDBUpdate.TabIndex = 14;
			this.btnTunDBUpdate.Text = "Update";
			this.btnTunDBUpdate.Click += new System.EventHandler(this.btnTunDBUpdate_Click);
			// 
			// btnManXLBrowse
			// 
			this.btnManXLBrowse.Location = new System.Drawing.Point(344, 56);
			this.btnManXLBrowse.Name = "btnManXLBrowse";
			this.btnManXLBrowse.Size = new System.Drawing.Size(96, 24);
			this.btnManXLBrowse.TabIndex = 13;
			this.btnManXLBrowse.Text = "Browse";
			this.btnManXLBrowse.Click += new System.EventHandler(this.btnManXLBrowse_Click);
			// 
			// btnTunDBBrowse
			// 
			this.btnTunDBBrowse.Location = new System.Drawing.Point(344, 24);
			this.btnTunDBBrowse.Name = "btnTunDBBrowse";
			this.btnTunDBBrowse.Size = new System.Drawing.Size(96, 24);
			this.btnTunDBBrowse.TabIndex = 12;
			this.btnTunDBBrowse.Text = "Browse";
			this.btnTunDBBrowse.Click += new System.EventHandler(this.btnTunDBBrowse_Click);
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(8, 64);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(80, 16);
			this.label16.TabIndex = 11;
			this.label16.Text = "Excel Path";
			// 
			// txtManualExcel
			// 
			this.txtManualExcel.Location = new System.Drawing.Point(112, 56);
			this.txtManualExcel.Name = "txtManualExcel";
			this.txtManualExcel.Size = new System.Drawing.Size(208, 20);
			this.txtManualExcel.TabIndex = 10;
			this.txtManualExcel.Text = "";
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(8, 32);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(96, 16);
			this.label17.TabIndex = 9;
			this.label17.Text = "Tuning DB Path";
			// 
			// txtTunDBPath
			// 
			this.txtTunDBPath.Location = new System.Drawing.Point(112, 24);
			this.txtTunDBPath.Name = "txtTunDBPath";
			this.txtTunDBPath.Size = new System.Drawing.Size(208, 20);
			this.txtTunDBPath.TabIndex = 8;
			this.txtTunDBPath.Text = "";
			// 
			// ExecutionEngine
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.ClientSize = new System.Drawing.Size(994, 683);
			this.Controls.Add(this.button19);
			this.Controls.Add(this.groupBox6);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.btnUpdateGraphics);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.button16);
			this.Controls.Add(this.txtMasterModeUpdateFile);
			this.Controls.Add(this.txtMode);
			this.Controls.Add(this.txtPropValID);
			this.Controls.Add(this.button15);
			this.Controls.Add(this.btnProcessModeless);
			this.Controls.Add(this.button14);
			this.Controls.Add(this.button13);
			this.Controls.Add(this.button12);
			this.Controls.Add(this.button11);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.grpUpdate);
			this.Controls.Add(this.lblModeID);
			this.Controls.Add(this.lblSiteCompPropID);
			this.Controls.Add(this.btnCalc);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.lblAOV);
			this.Controls.Add(this.lblOV);
			this.Controls.Add(this.lblAPV);
			this.Controls.Add(this.lblPV);
			this.Controls.Add(this.button8);
			this.Controls.Add(this.button7);
			this.Controls.Add(this.button5);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.button6);
			this.Name = "ExecutionEngine";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Execution Engine";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.ExecutionEngine_Load);
			this.grpUpdate.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.groupBox6.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			LRRComponentTypes compTypes = new LRRComponentTypes();
			LRRMasterComponents masterComponents = new LRRMasterComponents();
			_app.DBManagerObj.PopulateCollection(masterComponents," WHERE ID = '8747c0ff-8fa1-4d53-ab28-5bd849323c3f'",true);
			int rowCount;
			int colCount;
			string[] headers = _symExcelWrapper.GetHeadersForRange("Sample.xls","FIRED_BOILERS",out rowCount,out colCount);

			ArrayList propList = new ArrayList(); //Array Holding the properties for the item
			ArrayList genList = new ArrayList(); //Array Holding the attributes for the item
			for(int i=0;i<headers.Length;i++)
			{
				string currentHeader = headers[i];
				//Get the properties
				if(currentHeader.StartsWith("PROP_"))
				{
					currentHeader = currentHeader.Replace("PROP_","");
					propList.Add(currentHeader);
				}
				else if(currentHeader.StartsWith("COMP_")) //Get The Attributes
				{
					currentHeader = currentHeader.Replace("COMP_","");
					genList.Add(currentHeader);
				}
			}

			string[,] data = new string[rowCount,colCount];
			InitializeNullValuesForArray(data);
			data[0,0] = "0";
			data[0,1] = "1";
			data[0,2] = "2";
			_symExcelWrapper.PutDataIntoNamedRange("Sample.xls","FIRED_BOILERS",data);
		}


		private bool InitializeNullValuesForArray(string[,] array)
		{
			int yIndex = array.GetUpperBound(0);
			int xIndex = array.GetUpperBound(1);
			for(int i=0;i<=yIndex;i++)
			{
				for(int j=0;j<=xIndex;j++)
				{
					array[i,j] = "'";
				}
			}
			return true;
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			/*LRRMasterComponents masterComponents = new LRRMasterComponents();
			_app.DBManagerObj.PopulateCollection(masterComponents,"",true);*/

			LRRExecutionEngineModels allModels = new LRRExecutionEngineModels();
			_app.DBManagerObj.PopulateCollection(allModels,"",true);

			//Temporary filter to select only the steam model ID = 1
			LRRExecutionEngineModel currentModel = null;
			foreach(LRRExecutionEngineModel m in allModels)
			{
				currentModel = m;
			
				//Get the list of the current euipments used in the model...
				LRRExecutionEngineModelEquipments currentModelEquipments = new LRRExecutionEngineModelEquipments();
				_app.DBManagerObj.PopulateCollection(currentModelEquipments," WHERE ModelID='" + currentModel.ID + "'",true);

				foreach(LRRExecutionEngineModelEquipment eeModelEquipment in currentModelEquipments)
				{
					string masterCompID = eeModelEquipment.MasterCompID;  //Get the type of the equipment in scope..
					LRRMasterComponent lmc = masterComponents.GetMasterComponentByID(masterCompID); //Get the master Component
					//Since this is a hierarcy of the model it will contain
					//all the site components which belong to this group
					//of the master component..

					string workBookName = "";
					string workSheet = "";
					string rangeName = "";
					int rangeWidth = 0;
					int rangeHeight = 0;
				
					//Loop through the sets which contain info for read write form excel for a particular type of equipment.
					foreach(LRRExecutionEngineModelEquipmentSection sec in eeModelEquipment.ModelEquipmentSectionObj)
					{
						if(sec.SectionType.ToUpper() != "INPUT")
							continue;
						workBookName = currentModel.WorkBookName;
						workSheet = currentModel.WorkSheetName;
						rangeName = sec.RangeName;
						rangeWidth = 0;
						rangeHeight = 0;

						if(sec.Orientation == "R" || sec.Orientation == "C")
						{
							//Get the Header Information from the range...
							string[] Headers = _symExcelWrapper.GetHeadersForRange(workBookName,rangeName,sec.Orientation,out rangeHeight,out rangeWidth);

							string[,] array = new string[rangeHeight,rangeWidth];
							InitializeNullValuesForArray(array);
							sec.EquipmentModelData.Data = array;

							ArrayList propList = new ArrayList(); //Array Holding the properties for the item
							ArrayList genList = new ArrayList(); //Array Holding the attributes for the item
							for(int i=0;i<Headers.Length;i++)
							{
								string currentHeader = Headers[i];
								//Get the properties
								if(currentHeader.Trim() != "")
								{
									//currentHeader = currentHeader.Replace("PROP_","");
									if(currentHeader.IndexOf("_") > 0)
									{
										int ind =currentHeader.LastIndexOf("_"); 
										currentHeader = currentHeader.Substring(ind+1);
										propList.Add(currentHeader);
										sec.EquipmentModelData.Properties.Add(currentHeader);
										sec.EquipmentModelData.PropertyIDIndex.Add(currentHeader,i);
									}
									else //Get The Attributes
									{
										genList.Add(currentHeader);
										sec.EquipmentModelData.Arrtrs.Add(currentHeader);
										sec.EquipmentModelData.PropertyIDIndex.Add(currentHeader,i);
									}
								}
							}
						}

						//Populate the Array...
						
						for(int i=0;i<lmc.SiteComponentsObj.Count;i++)
						{
							//Set the Site Components in order
							LRRSiteComponent lsc = lmc.SiteComponentsObj[i];

							if(sec.Orientation == "R")
							{
								foreach(object obj in sec.EquipmentModelData.Arrtrs)
								{
									if((string)obj == "Name")
									{
										int colIndex = (int)sec.EquipmentModelData.PropertyIDIndex["Name"];
										int rowIndex = i;
										string val = lsc.Name;
										sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
									}
									if((string)obj == "PlantUnit")
									{
										int colIndex = (int)sec.EquipmentModelData.PropertyIDIndex["PlantUnit"];
										int rowIndex = i;
										string val = lsc.PlantUnit;
										sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
									}
//									if((string)obj == "Tag")
//									{
//										int colIndex = (int)sec.EquipmentModelData.PropertyIDIndex["Tag"];
//										int rowIndex = i;
//										string val = lsc.PlantMeterTag;
//										sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
//									}
								}

								foreach(object obj in sec.EquipmentModelData.Properties)
								{
									LRRSiteComponentProperty lscp = lsc.GetPropertyFromMasterPropID((string)obj);
									string valueToWrite = "";
									if(lscp != null)
									{
										valueToWrite = lscp.GetValueForPropertyMode(sec.ModeID);
										if(lscp != null)
										{
											int colIndex = (int)sec.EquipmentModelData.PropertyIDIndex[lscp.PropertyID];
											int rowIndex = i;
											sec.EquipmentModelData.Data[rowIndex,colIndex] = valueToWrite;
										}
									}
								}
							}
							else
							{

								foreach(object obj in sec.EquipmentModelData.Arrtrs)
								{
									if((string)obj == "Name")
									{
										int colIndex = /*(int)sec.EquipmentModelData.PropertyIDIndex["Name"]*/i;
										int rowIndex = /*i*/(int)sec.EquipmentModelData.PropertyIDIndex["Name"];
										string val = lsc.Name;
										sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
									}
									if((string)obj == "PlantUnit")
									{
										int colIndex = /*(int)sec.EquipmentModelData.PropertyIDIndex["PlantUnit"]*/i;
										int rowIndex = (int)sec.EquipmentModelData.PropertyIDIndex["PlantUnit"]/*i*/;
										string val = lsc.PlantUnit;
										sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
									}
//									if((string)obj == "Tag")
//									{
//										int colIndex = /*(int)sec.EquipmentModelData.PropertyIDIndex["Tag"]*/i;
//										int rowIndex = /*i*/(int)sec.EquipmentModelData.PropertyIDIndex["Tag"];
//										string val = lsc.PlantMeterTag;
//										sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
//									}
								}

								foreach(object obj in sec.EquipmentModelData.Properties)
								{
									LRRSiteComponentProperty lscp = lsc.GetPropertyFromMasterPropID((string)obj);
									string valueToWrite = "";
									if(lscp != null)
									{
										valueToWrite = lscp.GetValueForPropertyMode(sec.ModeID);
										if(lscp != null)
										{
											int colIndex = /*(int)sec.EquipmentModelData.PropertyIDIndex[lscp.PropertyID]*/i;
											int rowIndex = /*i*/(int)sec.EquipmentModelData.PropertyIDIndex[lscp.PropertyID];
											sec.EquipmentModelData.Data[rowIndex,colIndex] = valueToWrite;
										}
									}
								}

							}
						}

						//Write the data to the excel sheets...
						_symExcelWrapper.PutDataIntoNamedRange(workBookName,sec.RangeName,sec.Orientation,sec.EquipmentModelData.Data);

						//Sample Call the Run Macro...
						//_symExcelWrapper.ExecuteMacro("Sample","Test",new string[]{"TEST"});
                    
					}
				}
			}

			LRRMessagBox.ShowMessage("SID_DONE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			LRRExecutionEngineModels allModels = new LRRExecutionEngineModels();
			_app.DBManagerObj.PopulateCollection(allModels,"",true);

			//Temporary filter to select only the steam model ID = 1
			LRRExecutionEngineModel currentModel = null;
			foreach(LRRExecutionEngineModel m in allModels)
			{
				if(m.ID == "1") //ID i for Stem Model Sheet for System Status
				{
					currentModel = m;
					break;
				}
			}

			//Get the list of the current euipments used in the model...
			LRRExecutionEngineModelEquipments currentModelEquipments = new LRRExecutionEngineModelEquipments();
			_app.DBManagerObj.PopulateCollection(currentModelEquipments," WHERE ModelID='" + currentModel.ID + "'",true);

			foreach(LRRExecutionEngineModelEquipment eeModelEquipment in currentModelEquipments)
			{
				string masterCompID = eeModelEquipment.MasterCompID;  //Get the type of the equipment in scope..
				LRRMasterComponent lmc = masterComponents.GetMasterComponentByID(masterCompID); //Get the master Component
				//Since this is a hierarcy of the model it will contain
				//all the site components which belong to this group
				//of the master component..

				string workBookName = "";
				string workSheet = "";
				string rangeName = "";
				int rangeWidth = 0;
				int rangeHeight = 0;
				
				//Loop through the sets which contain info for read write form excel for a particular type of equipment.
				foreach(LRRExecutionEngineModelEquipmentSection sec in eeModelEquipment.ModelEquipmentSectionObj)
				{
					if(sec.SectionType.ToUpper() != "INPUT")
						continue;
					workBookName = currentModel.WorkBookName;
					workSheet = currentModel.WorkSheetName;
					rangeName = sec.RangeName;
					rangeWidth = 0;
					rangeHeight = 0;

					//Get the Header Information from the range...
					string[] Headers = _symExcelWrapper.GetHeadersForRange(workBookName,rangeName,out rangeHeight,out rangeWidth);

					//string[,] array = new string[rangeHeight,rangeWidth];
					object[,] array = _symExcelWrapper.GetDataFromNamedRangeAsObjectArray(workBookName,rangeName,sec.Orientation);
					//InitializeNullValuesForArray(array);
					sec.EquipmentModelData.Data = array;

					/*ArrayList propList = new ArrayList(); //Array Holding the properties for the item
					ArrayList genList = new ArrayList(); //Array Holding the attributes for the item
					for(int i=0;i<Headers.Length;i++)
					{
						string currentHeader = Headers[i];
						//Get the properties
						if(currentHeader.StartsWith("PROP_"))
						{
							currentHeader = currentHeader.Replace("PROP_","");
							propList.Add(currentHeader);
							sec.EquipmentModelData.Properties.Add(currentHeader);
						}
						else if(currentHeader.StartsWith("COMP_")) //Get The Attributes
						{
							currentHeader = currentHeader.Replace("COMP_","");
							genList.Add(currentHeader);
							sec.EquipmentModelData.Arrtrs.Add(currentHeader);
						}
					}

					int j=0;
					for(j=0;j<genList.Count;j++)
					{
						sec.EquipmentModelData.PropertyIDIndex.Add((string)genList[j],j);
					}
					for(int k=0;k<propList.Count;k++)
					{
						sec.EquipmentModelData.PropertyIDIndex.Add((string)propList[k],k+j);
					}

					for(int i=0;i<lmc.SiteComponentsObj.Count;i++)
					{
						//Set the Site Components in order
						LRRSiteComponent lsc = lmc.SiteComponentsObj[i];

						foreach(object obj in sec.EquipmentModelData.Arrtrs)
						{
							if((string)obj == "Name")
							{
								int colIndex = (int)sec.EquipmentModelData.PropertyIDIndex["Name"];
								int rowIndex = i;
								string val = lsc.Name;
								sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
							}
							if((string)obj == "Description")
							{
								int colIndex = (int)sec.EquipmentModelData.PropertyIDIndex["Description"];
								int rowIndex = i;
								string val = lsc.Description;
								sec.EquipmentModelData.Data[rowIndex,colIndex] = val;
							}
						}

						foreach(object obj in sec.EquipmentModelData.Properties)
						{
							LRRSiteComponentProperty lscp = lsc.GetPropertyFromMasterPropID((string)obj);
							if(lscp != null)
							{
								int colIndex = (int)sec.EquipmentModelData.PropertyIDIndex[lscp.PropertyID];
								int rowIndex = i;
								sec.EquipmentModelData.Data[rowIndex,colIndex] = lscp.PropertyValue;
							}
						}
					}

					//Write the data to the excel sheets...
					_symExcelWrapper.PutDataIntoNamedRange(workBookName,sec.RangeName,sec.EquipmentModelData.Data);

					//Sample Call the Run Macro...
					_symExcelWrapper.ExecuteMacro("Sample","Test",new string[]{"TEST"});*/
                    
				}
			}


		}

		private void ExecutionEngine_Load(object sender, System.EventArgs e)
		{
			//RefreshModel();
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			RefreshModel();
		}

		private void RefreshModel()
		{
			/*masterComponents = new LRRMasterComponents();
			_app.DBManagerObj.PopulateCollection(masterComponents,"",false);

			siteComponents = new LRRSiteComponents();
			//siteComponents.ItemAdded+=new EventHandler(siteComponents_ItemAdded);
			_app.DBManagerObj.PopulateCollection(siteComponents,"",false);

			siteComponentProperties = new LRRSiteComponentProperties();
			//siteComponentProperties.ItemAdded+=new EventHandler(siteComponentProperties_ItemAdded);
			_app.DBManagerObj.PopulateCollection(siteComponentProperties,"",false);

			siteComponentPropertyValues = new LRRSiteComponentPropertyValues();
			//siteComponentPropertyValues.ItemAdded+=new EventHandler(siteComponentPropertyValues_ItemAdded);
			_app.DBManagerObj.PopulateCollection(siteComponentPropertyValues,"",false);


			IEnumerator sitePropValuesEnum = siteComponentPropertyValues.GetEnumerator();
			while(sitePropValuesEnum.MoveNext())
			{
				LRRSiteComponentPropertyValue lscpv = sitePropValuesEnum.Current as LRRSiteComponentPropertyValue;
				siteComponentProperties.GetSiteCompPropFromID(lscpv.SiteComponentPropertyID).PropertyValues.Add(lscpv);
			}

			IEnumerator sitePropsEnum = siteComponentProperties.GetEnumerator();
			while(sitePropsEnum.MoveNext())
			{
				LRRSiteComponentProperty lscp = sitePropsEnum.Current as LRRSiteComponentProperty;
				siteComponents.GetSiteComponentByID(lscp.ComponentID).Properties.Add(lscp);
			}

			IEnumerator siteCompEnum = siteComponents.GetEnumerator();
			while(siteCompEnum.MoveNext())
			{
				LRRSiteComponent  lsc = siteCompEnum.Current as LRRSiteComponent;
				masterComponents.GetMasterComponentByID(lsc.MasterComponentType).SiteComponentsObj.Add(lsc);
			}

			MessageBox.Show("Done!");*/

		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			LRRSiteComponentPropertyValues siteCompPropValues = new LRRSiteComponentPropertyValues();
			LRRModes modes = new LRRModes();
			_app.DBManagerObj.PopulateCollection(modes);
			/*_app.DBManagerObj.PopulateCollection(siteCompPropValues);
			foreach(LRRSiteComponentPropertyValue val in siteCompPropValues)
			{
				val.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
			}

			_app.DBManagerObj.CommitCollection(siteCompPropValues.GetChanges());*/


			foreach(LRRMasterComponent mc in masterComponents)
			{
				foreach(LRRSiteComponent sc in mc.SiteComponentsObj)
				{
					foreach(LRRSiteComponentProperty scp in sc.Properties)
					{
						foreach(LRRMode m in modes)
						{
							LRRSiteComponentPropertyValue lscpv = new LRRSiteComponentPropertyValue();
							lscpv.SiteComponentPropertyID = scp.ID;
							lscpv.ModeID = m.ModeId; 
							siteCompPropValues.Add(lscpv);
						}
					}
				}
			}

			_app.DBManagerObj.CommitCollection(siteCompPropValues.GetChanges());
			
		}

		private void siteComponents_ItemAdded(object sender, EventArgs e)
		{
			LRRSiteComponent lsc = sender as LRRSiteComponent;
			masterComponents.GetMasterComponentByID(lsc.MasterComponentType).SiteComponentsObj.Add(lsc);
		}

		private void siteComponentProperties_ItemAdded(object sender, EventArgs e)
		{
			LRRSiteComponentProperty lscp = sender as LRRSiteComponentProperty;
			siteComponents.GetSiteComponentByID(lscp.ComponentID).Properties.Add(lscp);

		}

		private void siteComponentPropertyValues_ItemAdded(object sender, EventArgs e)
		{
			LRRSiteComponentPropertyValue lscpv = sender as LRRSiteComponentPropertyValue;
			siteComponentProperties.GetSiteCompPropFromID(lscpv.SiteComponentPropertyID).Values.Add(lscpv);
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			LRRExecutionEngine ee = new LRRExecutionEngine(_app.SymExcelWrapperObj,_app.GetOptions(),_app.ActiveRunControlSet);
			//ee.OpenAllWorkBooks();
			ee.internalExecuteWriteCycle();
			_app.SymExcelWrapperObj.SaveAllWorkBooks();
			//ee.SaveAllWorkBooks();
			LRRMessagBox.ShowMessage("SID_COMPLETED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
		}

		private void button1_Click_1(object sender, System.EventArgs e)
		{
			LRRMasterComponents mast = LRRModel.Model;

			LRRSiteComponentPropertyValues siteCompPropValues = new LRRSiteComponentPropertyValues();
			LRRModes modes = new LRRModes();
			_app.DBManagerObj.PopulateCollection(modes);
			
			foreach(LRRMasterComponent mc in mast)
			{
				foreach(LRRSiteComponent sc in mc.SiteComponentsObj)
				{
					foreach(LRRSiteComponentProperty scp in sc.Properties)
					{
						foreach(LRRMode m in modes)
						{
							if((m.ModeId == "3"))
							{
								LRRSiteComponentPropertyValue lscpv = new LRRSiteComponentPropertyValue();
								lscpv.SiteComponentPropertyID = scp.ID;
								lscpv.ModeID = m.ModeId; 
								siteCompPropValues.Add(lscpv);
							}
						}
					}
				}
			}

			_app.DBManagerObj.CommitCollection(siteCompPropValues.GetChanges());

		}

		private void button2_Click_1(object sender, System.EventArgs e)
		{
			LRRExecutionEngine ee = new LRRExecutionEngine(_app.SymExcelWrapperObj,_app.GetOptions(),_app.ActiveRunControlSet);
			//ee.OpenAllWorkBooks();
			ArrayList arrPropValuesTransferList = new ArrayList();
			ArrayList arrGroupPropValuesTransferList = new ArrayList();
			ee.internalExecuteReadCycle(out arrPropValuesTransferList,out arrGroupPropValuesTransferList);

			for(int i=0;i < arrPropValuesTransferList.Count;i++)
			{
				PropertyValueTransfer propValTransferObj = arrPropValuesTransferList[i] as PropertyValueTransfer;
				string propValueID = propValTransferObj.PropValueID;
				LRRSiteComponentPropertyValue siteCompPropValueObj = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(propValueID);
				if(siteCompPropValueObj != null)
					siteCompPropValueObj.PropertyValue = propValTransferObj.PropertyValue;
			}

			for(int i=0;i < arrGroupPropValuesTransferList.Count;i++)
			{
				PropertyValueTransfer propValTransferObj = arrGroupPropValuesTransferList[i] as PropertyValueTransfer;
				string propValueID = propValTransferObj.PropValueID;
				LRRSiteGroupPropertyQualifierValue siteGroupPropQualValueObj = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(propValueID);
				if(siteGroupPropQualValueObj != null)
					siteGroupPropQualValueObj.PropertyValue = propValTransferObj.PropertyValue;
			}
			//ee.SaveAllWorkBooks();
			LRRMessagBox.ShowMessage("SID_COMPLETED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
		
		}

		private void button3_Click_1(object sender, System.EventArgs e)
		{
			LRRExecutionEngine ee = new LRRExecutionEngine(_app.SymExcelWrapperObj,_app.GetOptions(),_app.ActiveRunControlSet);
			//ee.OpenAllWorkBooks();
			ee.WriteSingleCellValues();
			//ee.ReadSingleCellValues();
			//ee.SaveAllWorkBooks();

			LRRMessagBox.ShowMessage("SID_COMPLETED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
		
		}

		private void button4_Click_1(object sender, System.EventArgs e)
		{
			LRRHistPropCompPropMappings _comMaps = new LRRHistPropCompPropMappings();
			_app.DBManagerObj.PopulateCollection(_comMaps);
			IEnumerator ienum =  _comMaps.GetEnumerator();
			while(ienum.MoveNext())
			{
				LRRHistPropCompPropMapping map =  ienum.Current  as LRRHistPropCompPropMapping; 
				LRRSiteComponentProperty prop = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(map.SiteComponentPropID);
				if(prop == null)
					LRRMessagBox.ShowMessage("SID_HOUSTONPROB","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
				else
				{
					//prop.GetValueObjectForPropertyMode("1").ID;
					map.SiteComponentPropValID = prop.GetValueObjectForPropertyMode("1").ID;
				}
			}

			_app.DBManagerObj.CommitCollection(_comMaps.GetChanges());

		}

		private void button5_Click_1(object sender, System.EventArgs e)
		{
			_symExcelWrapper.ExecuteMacro("Advisor Options form","ShowOptions");
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
			LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID("3f4c5cc1-b324-4131-823f-5761d3bf51eb");
			LRRSiteComponentProperties lscprops = lsc.Properties.FilterPropertiesByPropertyType("0182614a-099e-407a-9b8d-6af7f82faa76");
            
			LRRSiteComponentProperty lscp =  lscprops[0];
			string siteCompID = lscp.ID;

			//"3f1a292a-3197-4a24-8ad6-26f36bd29ddd"
			
			string siteGroupPropID = LRRModel.SiteComponentGroupPropertiesObj.GetSiteGroupPropID(lscp.ID,"e840cfa4-366c-4470-abb4-27ed73bc4833"); //Argon


			string val1 = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValue(siteGroupPropID,"d2d8a44b-2f7c-4206-8556-187c4a5b92b3","1");





			LRRSiteComponentGroupProperties lscgp = lscp.GroupPpties.FilterGroupPropertiesForLkUpQualifierID("e185ac85-cf8f-4425-8c23-f219c6ee82b2");
			LRRSiteComponentGroupProperty gp = lscgp.GetSiteCompGroupPropFromName("Ar");

			string val = gp.GroupPptiesQualifierValues.GetQualifierValueForPropertyMode("1");





			//LRRSiteGroupPropertyQualifierValues vals = lscp.GroupPpties.GetSiteCompGroupPropFromID(a67245cf-b442-44be-a47d-ba6b82346a3e).GroupPptiesQualifierValues.GetGroupQualifierValuesFromLkupQualID("a67245cf-b442-44be-a47d-ba6b82346a3e");



			
			//LRRSiteComponentGroupProperties  lscgps = lscp.GroupPpties.FilterGroupPropertiesForLkUpQualifierID("a5add011-6c87-44bb-b589-acf887093bcc");
			int c = 30;


		}

		private void button8_Click(object sender, System.EventArgs e)
		{
			_app.StartExecutionEngine();
		}

		private void btnCalc_Click(object sender, System.EventArgs e)
		{
			LRRSiteComponentProperty prop = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(txtPropValID.Text);
			LRRSiteComponentPropertyValue propvalue = prop.GetValueObjectForPropertyMode(txtMode.Text);
			lblPV.Text = propvalue.PropertyValue;
			lblAPV.Text = propvalue.ActualPropertyValue;
			lblOV.Text = propvalue.OverridedValue;
			lblAOV.Text = propvalue.ActualOverridedValue;

		}

		private void button9_Click(object sender, System.EventArgs e)
		{
			LRRModel.PropertyValuesObj.SortColumn = "ModeID";
			LRRModel.PropertyValuesObj.SortingOrder = Symcon.BusinessObjects.GenericComparer.SortOrder.Ascending;
			LRRModel.PropertyValuesObj.Sort();

			foreach(LRRSiteComponentPropertyValue propVal in LRRModel.PropertyValuesObj)
			{
				if(propVal.ModeID == "0") //No Mode Situation Defaulting to Input and User Supplied...
				{
					propVal.Direction = "1";
					propVal.Derivation = "4";
				}
				else if(propVal.ModeID == "1") //Only For Measurement Mode....
				{
					LRRHistPropCompPropMapping mapObj = LRRModel.HistPropMaps.GetHistMapObjFromValID(propVal.SiteComponentPropertyID);
					if(mapObj != null) //Point is Mapped so set the direction
					{
						propVal.Direction = "1"; //Set Direction of the property Value as Input as it is mapped...

						LRRHistData histData = LRRModel.HistDatas.GetHistDataFromHistTagUID(mapObj.HistPropID);
						if(histData.FormulaID != null && histData.FormulaID != "")
						{
                            propVal.Derivation = "3"; //Measured Derived 
						}
						else
						{
							propVal.Derivation = "2"; //Mesured Directly...
						}
					}
					else //Not Mapped Property....
					{
						if(propVal.PropertyValue != null && propVal.PropertyValue != "")
						{
							propVal.Direction = "1"; //Input Direction
							propVal.Derivation = "4";//User Supplied...
						}
						else
						{
							propVal.Direction = "1";//Input Direction
							propVal.Derivation = "1"; //Not Measured Derivation..
						}
					}
				}
				else //Mode 2,3 System Status and Scenarios...
				{
					string siteCompPropID = propVal.SiteComponentPropertyID;
					LRRSiteComponentProperty lrrSiteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(siteCompPropID);
					LRRSiteComponentPropertyValue measModeObj = lrrSiteCompProp.GetValueObjectForPropertyMode("1");

					if(propVal.ModeID == "2") //System Status
					{
						LRRHistPropCompPropMapping mapObj = LRRModel.HistPropMaps.GetHistMapObjFromValID(measModeObj.SiteComponentPropertyID);

						if(mapObj != null) //Check of the Meas Mode for this SS or SC is mapped
						{
							//Parent Mode has Mapping
							propVal.Derivation = "11";
						}
						else
						{
							if(measModeObj.Derivation == "1" || measModeObj.Derivation == "4")
							{
								propVal.Direction = "1";
								propVal.Derivation = "4";
							}
						}
					}
					else if(propVal.ModeID == "3") //Scenarios
					{
						propVal.Direction =  "1"; //Set the Default Direction for Scenarios to Inputs...
						propVal.Derivation = "22";
					}
				}
			}

			LRRSiteComponentPropertyValues valsToCommit = LRRModel.PropertyValuesObj.GetChanges();

			IEnumerator ieNum = valsToCommit.GetEnumerator();

			string appPath = Application.StartupPath;

			string fPath = appPath + @"\SimplePropertyUpdate.sql";

			System.IO.StreamWriter fs = new System.IO.StreamWriter(fPath);
			string sql = "Update SiteComponentPropertyValue Set DirectionType ='#', DerivationType = '%' where ID = '^'";
			while(ieNum.MoveNext())
			{
				LRRSiteComponentPropertyValue valOnj = (LRRSiteComponentPropertyValue)ieNum.Current;
				string updDirection =  valOnj.Direction;
				string updDerivation = valOnj.Derivation;
				string tsql = sql;
				tsql =  tsql.Replace("#",updDirection);
				tsql = tsql.Replace("%",updDerivation);
				tsql =  tsql.Replace("^",valOnj.ID);
				fs.WriteLine(tsql);
				fs.WriteLine("");

				try
				{
					_app.DBManagerObj.CommitSQL(tsql);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
					fs.WriteLine("ERROR in - " + tsql);
				}
				
			}
			fs.Close();
			//MessageBox.Show("Completed and saved file " + fPath);
			string[] s = new string[1];
			s[0] = fPath;
			LRRMessagBox.ShowMessage("SID_FILE_SAVED","SID_LABEL",s);  
			//_app.DBManagerObj.CommitCollection(valsToCommit);

		}

		private void button11_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog sfd = new OpenFileDialog();
			sfd.ShowDialog();
			txtExcelFile.Text = sfd.FileName;
		}

		private void button10_Click(object sender, System.EventArgs e)
		{

			//*****************************************************************************************
			//For DBMapAttribute...
			//Load the Excel File into the System
			string[] sheets = Symcon.Utils.ExcelUtils.ExcelUtils.GetExcelSheetNames(@txtExcelFile.Text);
			DataTable dt = Symcon.Utils.ExcelUtils.ExcelUtils.GetTable("DBMapAttributes"); //Using DB Mapped Attributes... for Master Properties...
			string targetDBPath = txtExcelFile.Text;

			int dtrowcount = dt.Rows.Count;

			
			string appPath = Application.StartupPath;

			string fPath = appPath +  @"\MasterPropDirectionUpdate.sql";
			string fPath1 = appPath +  @"\SitePropValueDirectionUpdate.sql";


			System.IO.StreamWriter mPropDirectionUpdate = new System.IO.StreamWriter(fPath);
			System.IO.StreamWriter sPropDirectionUpdate = new System.IO.StreamWriter(fPath1);

			string sqlUpdMasterProp = "Update MasterProperties set DirectionType = '#' where PropertyID = '^'";
			string sqlUpdSitePropVale = "Update SiteComponentPropertyValue Set DirectionType = '#' where ID = '^'";

			Hashtable duplicateMarker = new Hashtable();
			for(int cnt = 3;cnt< dtrowcount ; cnt++)
			{
				string masterPropID = dt.Rows[cnt][1].ToString();
				string mode = dt.Rows[cnt][12].ToString().ToUpper();
				string direction = dt.Rows[cnt][10].ToString().ToUpper();

				if(direction == "I")
				{
					direction = "1";
				}
				else if(direction == "O")
				{
					direction =  "2";
				}

				if(masterPropID != "" && mode != "" && direction != "")
				{
					if(duplicateMarker.ContainsKey(masterPropID + "|" + mode))
					{
						//Found Duplicate Combination check the existing and new direction 
						//If different set I/O for Direction of this Master propertyValue
						string getDirection = (string)duplicateMarker[masterPropID + "|" + mode];
						if((getDirection == direction) || (getDirection == "3"))
						{
							continue;
						}
						else
						{
							duplicateMarker[masterPropID + "|" + mode] = "3";
						}

					}
					else
					{
						duplicateMarker.Add(masterPropID + "|" + mode,direction);
					}
				}

			}

			Hashtable checkDuplicateMasterProps = new Hashtable();

			for(int i = 3;i< dtrowcount ; i++)
			{
				string masterPropID = dt.Rows[i][1].ToString();
				string mode = dt.Rows[i][12].ToString().ToUpper();
				string direction = dt.Rows[i][10].ToString().ToUpper();

				string tsqlUpdMaster = sqlUpdMasterProp;
				string tsqlUpdSite = sqlUpdSitePropVale;

			
				if(masterPropID != "" && mode != "" && direction != "")
				{
					direction = (string)duplicateMarker[masterPropID + "|" + mode];
				
					if(mode == "2") //Update Mater Properties and also Site Component Property Values with Mode 2
					{

						LRRMasterProperty masterPropObj = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);
						if(masterPropObj != null)
						{
							if(!checkDuplicateMasterProps.ContainsKey(masterPropObj.PropID))
							{
								masterPropObj.Direction = direction;
								tsqlUpdMaster = tsqlUpdMaster.Replace("#",direction);
								tsqlUpdMaster = tsqlUpdMaster.Replace("^",masterPropObj.PropID);

								//Log to the file
								mPropDirectionUpdate.WriteLine(tsqlUpdMaster);

								//Fire Update on Master
								try
								{
									_app.DBManagerObj.CommitSQL(tsqlUpdMaster);
								}
								catch(Exception ex)
								{
									Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
									mPropDirectionUpdate.WriteLine("ERROR in - " + tsqlUpdMaster);

								}

                                List<LRRSiteComponentPropertyValue> listOfSiteCompPropValue = LRRModel.MasterPropertyDictionaryObj.Get(masterPropID);
								if(listOfSiteCompPropValue != null)
								{
									foreach(LRRSiteComponentPropertyValue val in listOfSiteCompPropValue)
									{
										if(val.ModeID == mode)
										{
											val.Direction = direction;
											tsqlUpdSite = tsqlUpdSite.Replace("#",direction);
											tsqlUpdSite = tsqlUpdSite.Replace("^",val.ID);
											//Log Site Diection Update 
											sPropDirectionUpdate.WriteLine(tsqlUpdSite);

											//Fire Update on Site
											try
											{
												_app.DBManagerObj.CommitSQL(tsqlUpdSite);
											}
											catch(Exception ex)
											{
												Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
												sPropDirectionUpdate.WriteLine("ERROR in - " + tsqlUpdSite);

											}
							
										}
									}
								}
								checkDuplicateMasterProps.Add(masterPropObj.PropID,null);
							}
						}
					}
					else if(mode == "3") //Update Only site Component Property Values..
					{
                        List<LRRSiteComponentPropertyValue> listOfSiteCompPropValue = LRRModel.MasterPropertyDictionaryObj.Get(masterPropID);
						if(listOfSiteCompPropValue != null)
						{
							foreach(LRRSiteComponentPropertyValue val in listOfSiteCompPropValue)
							{
								if(val.ModeID == mode)
								{
									val.Direction = direction;
									tsqlUpdSite = tsqlUpdSite.Replace("#",direction);
									tsqlUpdSite = tsqlUpdSite.Replace("^",val.ID);
									//Log Site Diection Update 
									sPropDirectionUpdate.WriteLine(tsqlUpdSite);

									//Fire Update on Site
									try
									{
										_app.DBManagerObj.CommitSQL(tsqlUpdSite);
									}
									catch(Exception ex)
									{
										Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
										sPropDirectionUpdate.WriteLine("ERROR in - " + tsqlUpdSite);
									}
							
								}
							}
						}

					}
					else if(mode == "0") //The Master Property Mode is 0 so Propogate to all the childs....
					{

                        List<LRRSiteComponentPropertyValue> listOfSiteCompPropValue = LRRModel.MasterPropertyDictionaryObj.Get(masterPropID);
						if(listOfSiteCompPropValue != null)
						{
							foreach(LRRSiteComponentPropertyValue val in listOfSiteCompPropValue)
							{
								if(val.ModeID == mode)
								{
									val.Direction = direction;
									tsqlUpdSite = tsqlUpdSite.Replace("#",direction);
									tsqlUpdSite = tsqlUpdSite.Replace("^",val.ID);
									//Log Site Diection Update 
									sPropDirectionUpdate.WriteLine(tsqlUpdSite);

									//Fire Update on Site
									try
									{
										_app.DBManagerObj.CommitSQL(tsqlUpdSite);
									}
									catch(Exception ex)
									{
										Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
										sPropDirectionUpdate.WriteLine("ERROR in - " + tsqlUpdSite);
									}
							
								}
							}
						}
					}
				}
				
			}

			mPropDirectionUpdate.Close();
			sPropDirectionUpdate.Close();

			//Completed DB mapped Attributes

			//***********************************
			//Start of DB Mapped Cells
			DataTable dt1 = Symcon.Utils.ExcelUtils.ExcelUtils.GetTable("DBMapCells"); //Using DB Mapped Attributes... for Master Properties...

			int dtrowcount1 = dt1.Rows.Count;


			string fPathDBMappedCells = appPath + @"\SitePropValueDirectionUpdateDBMappedCells.sql";


			System.IO.StreamWriter sPropDirectionUpdateMappedCells = new System.IO.StreamWriter(fPathDBMappedCells);

			string sqlUpdSitePropValeMapCells = "Update SiteComponentPropertyValue Set DirectionType = '#' where ID = '^'";

			Hashtable duplicateMarkerMappedCells = new Hashtable();

			for(int cnt1 = 2;cnt1< dtrowcount1 ; cnt1++)
			{
				string siteCompPropID = dt1.Rows[cnt1][0].ToString();
				string mode = dt1.Rows[cnt1][7].ToString().ToUpper();
				string direction = dt1.Rows[cnt1][8].ToString().ToUpper();

				if(direction == "I")
				{
					direction = "1";
				}
				else if(direction == "O")
				{
					direction =  "2";
				}

				if(siteCompPropID != "" && mode != "" && direction != "")
				{
					if(duplicateMarkerMappedCells.ContainsKey(siteCompPropID + "|" + mode))
					{
						//Found Duplicate Combination check the existing and new direction 
						//If different set I/O for Direction of this Master propertyValue
						string getDirection = (string)duplicateMarkerMappedCells[siteCompPropID + "|" + mode];
						if((getDirection == direction) || (getDirection == "3"))
						{
							continue;
						}
						else
						{
							duplicateMarkerMappedCells[siteCompPropID + "|" + mode] = "3";
						}

					}
					else
					{
						duplicateMarkerMappedCells.Add(siteCompPropID + "|" + mode,direction);
					}
				}

			}

			Hashtable checkDuplicateSiteProps = new Hashtable();

			for(int k = 2;k< dtrowcount1 ; k++)
			{
				string siteCompPropID = dt1.Rows[k][0].ToString();
				string mode = dt1.Rows[k][7].ToString().ToUpper();
				string direction = dt1.Rows[k][8].ToString().ToUpper();

				string tsqlUpdSite = sqlUpdSitePropValeMapCells;

			
				if(siteCompPropID != "" && mode != "" && direction != "")
				{
					direction = (string)duplicateMarkerMappedCells[siteCompPropID + "|" + mode];
				
					if(mode == "2" || mode == "3" || mode == "0") //Update Mater Properties and also Site Component Property Values with Mode 2
					{
						LRRSiteComponentProperty siteCOmpProp =  LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(siteCompPropID);
						if(siteCOmpProp != null)
						{
							LRRSiteComponentPropertyValue siteCompPropVal = siteCOmpProp.GetValueObjectForPropertyMode(mode);
							if(siteCompPropVal != null)
							{

								tsqlUpdSite =  tsqlUpdSite.Replace("#",direction);
								tsqlUpdSite = tsqlUpdSite.Replace("^",siteCompPropVal.ID);

								//Log for DB Mapped Cells..
								sPropDirectionUpdateMappedCells.WriteLine(tsqlUpdSite);

								//Commit to DB
								try
								{
									_app.DBManagerObj.CommitSQL(tsqlUpdSite);
								}
								catch(Exception ex)
								{
									Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
									sPropDirectionUpdateMappedCells.WriteLine("ERROR in -" + tsqlUpdSite);
								}
							}

						}
					}
				}
			}
						
			sPropDirectionUpdateMappedCells.Close();
			string files = fPath + "\r\n" + fPath1 + "\r\n" + fPathDBMappedCells + "\r\n";
			string[] s = new string[1];
			s[0] = files;
			LRRMessagBox.ShowMessage("SID_FILE_SAVED","SID_LABEL",s);
			//MessageBox.Show("Done Saved Files " + files);
	
		}

		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog sfd = new OpenFileDialog();
			sfd.ShowDialog();
			txtDBPath.Text = sfd.FileName;

			string connectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + @txtDBPath.Text + @";User Id=Admin;";

			_connection = new OleDbConnection(connectionString);
			_connection.Open();
			LRRMessagBox.ShowMessage("SID_SUCCESS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  

		}

		private void btnExcelBrowse_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog sfd = new OpenFileDialog();
			sfd.ShowDialog();
			txtExcelFile.Text = sfd.FileName;

			Symcon.Utils.ExcelUtils.ExcelUtils.GetExcelSheetNames(@txtExcelFile.Text);
			_dt = Symcon.Utils.ExcelUtils.ExcelUtils.GetTable("May3ImportFinal");
		}

		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			int dtrowcount = _dt.Rows.Count;
			string updateQuery = "Update SiteComponents Set InternalSortIndex = # Where SiteComponentID = '^'";
			_command = new OleDbCommand();
			_command.Connection = _connection;
			for(int cnt = 0;cnt< dtrowcount ; cnt++)
			{
				string siteComponentID = _dt.Rows[cnt][0].ToString();
				int integerValue;
				if(_dt.Rows[cnt][4] != DBNull.Value)
				{
					integerValue = Int32.Parse(_dt.Rows[cnt][4].ToString(),Symcon.BusinessObjects.SymConverter.Culture);
				}
				else
				{
					integerValue = 0;
				}
				string sortIndex = integerValue.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				string tmpUpdQuery = updateQuery;
				tmpUpdQuery = tmpUpdQuery.Replace("#",sortIndex);
				tmpUpdQuery = tmpUpdQuery.Replace("^",siteComponentID);
				_command.CommandText = tmpUpdQuery;
				try
				{
					_command.ExecuteNonQuery();

				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Error);
					//MessageBox.Show(tmpUpdQuery);
				}

			}
			LRRMessagBox.ShowMessage("SID_UPDATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    

		}

		private void btnProcessNow_Click(object sender, System.EventArgs e)
		{
			string updateMasterPropertyMode = "Update MasterProperties Set ModeID = 0 where PropertyID='^'";
			string upDateSitePropMode = "Update SiteComponentProperties Set ModeID = 0 where PropertyID='^'";
			string updateSitePropValMode = "Update SiteComponentPropertyValue Set ModeID = '0' where ID ='^'";
			string deleteSitePropVal = "Delete from SiteComponentPropertyValue where ID = '^'";

			string appPath = Application.StartupPath;

			string fPath = appPath +  @"\MasterPropModeUpdate.sql";
			string fPath1 = appPath +  @"\SitePropModeUpdate.sql";
			string fPath2 = appPath +  @"\SitePropValueModeUpdate.sql";
			string fPath3 = appPath +  @"\SitePropValueModeDelete.sql";
            

			System.IO.StreamWriter mPropModeUpdate = new System.IO.StreamWriter(fPath);
			System.IO.StreamWriter sPropModeUpdate = new System.IO.StreamWriter(fPath1);
			System.IO.StreamWriter sPropValModeUpdate = new System.IO.StreamWriter(fPath2);
			System.IO.StreamWriter sPropValModeDelete = new System.IO.StreamWriter(fPath3);

			Hashtable alreadyUpdatedsPropMode = new Hashtable();
			foreach(LRRMasterProperty mp in LRRModel.MasterComponentPropertiesObj)
			{
				if(mp.Name == "PlantUnit" || mp.Name == "NotesAndComments" || mp.Name == "Unit Code" || mp.Name == "Unit Number")
				{
					//mp.ModeID = false;
					string tupdateMasterPropertyMode = updateMasterPropertyMode;
					tupdateMasterPropertyMode = tupdateMasterPropertyMode.Replace("^",mp.PropID);
					
					mPropModeUpdate.WriteLine(tupdateMasterPropertyMode);

					try
					{
						_app.DBManagerObj.CommitSQL(tupdateMasterPropertyMode);
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
						mPropModeUpdate.WriteLine("ERROR IN - " + tupdateMasterPropertyMode);

					}

					string tupDateSitePropMode = upDateSitePropMode;
					tupDateSitePropMode = tupDateSitePropMode.Replace("^",mp.PropID);

					sPropModeUpdate.WriteLine(tupDateSitePropMode);

					try
					{
						_app.DBManagerObj.CommitSQL(tupDateSitePropMode);
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
						mPropModeUpdate.WriteLine("ERROR IN - " + tupDateSitePropMode);

					}


                    List<LRRSiteComponentPropertyValue> arList = LRRModel.MasterPropertyDictionaryObj.Get(mp.PropID); //Arraylist of Site Component Property Values....

					if(arList != null)
					{
						foreach(LRRSiteComponentPropertyValue propVal in arList)
						{
							if(propVal.ModeID == "1") //Currently Measurement Update to Default...
							{
								string tupdateSitePropValMode = updateSitePropValMode;
								tupdateSitePropValMode = tupdateSitePropValMode.Replace("^",propVal.ID);

								sPropValModeUpdate.WriteLine(tupdateSitePropValMode);

								try
								{
									_app.DBManagerObj.CommitSQL(tupdateSitePropValMode);

								}
								catch(Exception ex)
								{
									Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
									sPropValModeUpdate.WriteLine("ERROR IN -" + tupdateSitePropValMode);

								}

							}
							else if(propVal.ModeID == "2" || propVal.ModeID == "3") //Delete System Status and Scenorios..
							{

								string tdeleteSitePropVal = deleteSitePropVal;
								tdeleteSitePropVal = tdeleteSitePropVal.Replace("^",propVal.ID);

								sPropValModeDelete.WriteLine(tdeleteSitePropVal);

								try
								{
									_app.DBManagerObj.CommitSQL(tdeleteSitePropVal);

								}
								catch(Exception ex)
								{
									Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
									sPropValModeDelete.WriteLine("ERROR IN -" + tdeleteSitePropVal);

								}

							}
							else
							{

								sPropValModeDelete.WriteLine("SHOULD NEVER BE HERE " + propVal.ID + "|" + propVal.ModeID + "|" + propVal.SiteComponentPropertyID);
							}
						}
					}
				}
			}

			mPropModeUpdate.Close();
			sPropModeUpdate.Close();
			sPropValModeDelete.Close();
			sPropValModeUpdate.Close();
		}

		private void button11_Click_1(object sender, System.EventArgs e)
		{
			string insertIntoPropValUser10 = "Insert into SiteComponentPropertyValue (ID,SiteComponentPropertyID,PropertyValue,ModeID,UID,TID,EffectivePlantTime,Formula,IsDefault,DerivationType,DirectionType,HistTagID,LRRDataType,LRRUIPrecision) Values ('@ID','@SiteComponentPropertyID','@PropertyValue','@ModeID','10','@TID','@EffectivePlantTime','@Formula',@IsDefault,'@DerivationType','@DirectionType','@HistTagID','@LRRDataType','@LRRUIPrecision')";

			
			string appPath = Application.StartupPath;

			string fPath = appPath +  @"\SiteComponentPropertyValuesUser.sql";
			
			System.IO.StreamWriter sitePropValInserUser10 = new System.IO.StreamWriter(fPath);
																																													 
			foreach(LRRSiteComponentPropertyValue val in LRRModel.PropertyValuesObj)
			{
				string tmpInsertPropValUser = insertIntoPropValUser10;
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@ID",Guid.NewGuid().ToString());
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@SiteComponentPropertyID",val.SiteComponentPropertyID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@PropertyValue",val.PropertyValue);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@ModeID",val.ModeID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@TID",val.TimeID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@EffectivePlantTime","");
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@Formula",val.FormulaID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@IsDefault",val.IsDefault.ToString(Symcon.BusinessObjects.SymConverter.Culture));
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@DerivationType",val.Derivation);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@DirectionType",val.Direction);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@HistTagID","");
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@LRRDataType",val.LRRDataType);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@LRRUIPrecision","");

				sitePropValInserUser10.WriteLine(tmpInsertPropValUser);

				try
				{
					_app.DBManagerObj.CommitSQL(tmpInsertPropValUser);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
					sitePropValInserUser10.WriteLine("ERROR IN " + tmpInsertPropValUser);
				}


			}

			sitePropValInserUser10.Close();


			//Create Group Property Values for User 10
			string fPath1 = appPath +  @"\SiteComponentGroupedPropertyValuesUser.sql";
			
			System.IO.StreamWriter siteGPropValInserUser10 = new System.IO.StreamWriter(fPath1);

			string insertIntoGPropValUser10 = "Insert into SiteGroupPropertyQualifierValue (SiteGroupPropertyQualifierValueID,LookUpPropertiesID,GroupPropertyID,LookupQualifierID,QualifierID,PropertyID,PropertyValue,ModeID,Derivation,DirectionType,HistTagID,UID,TID,Formula,EffectivePlantTime,MasterPropID) Values ('@SiteGroupPropertyQualifierValueID','@LookUpPropertiesID','@GroupPropertyID','@LookupQualifierID','@QualifierID','@PropertyID','@PropertyValue','@ModeID','@Derivation','@DirectionType','@HistTagID','10','@TID','@Formula','','@MasterPropID')";

			foreach(LRRSiteGroupPropertyQualifierValue gpqv in LRRModel.SiteGroupPropertyQualifierValuesObj)
			{
				string tmpInsertIntoGPropValUser10 = insertIntoGPropValUser10;

				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@SiteGroupPropertyQualifierValueID",Guid.NewGuid().ToString());
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@LookUpPropertiesID",gpqv.LookUpPropertiesID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@GroupPropertyID",gpqv.GroupPropertyID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@LookupQualifierID",gpqv.LookUpQualifierID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@QualifierID",gpqv.QualifierID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@PropertyID",gpqv.PropertyID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@PropertyValue",gpqv.PropertyValue);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@ModeID",gpqv.ModeID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@Derivation",gpqv.Derivation);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@DirectionType",gpqv.Direction);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@HistTagID",gpqv.HistTagID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@TID",gpqv.TID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@Formula",gpqv.FormulaID);
				//tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@EffectivePlantTime",gpqv.EffectivePlantTime);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@MasterPropID",gpqv.MasterPropID);

				siteGPropValInserUser10.WriteLine(tmpInsertIntoGPropValUser10);

				try
				{
					_app.DBManagerObj.CommitSQL(tmpInsertIntoGPropValUser10);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
					siteGPropValInserUser10.WriteLine("ERROR IN " + tmpInsertIntoGPropValUser10);
				}

			}

			siteGPropValInserUser10.Close();

			button12_Click(this,new EventArgs());


		}

		private void button13_Click(object sender, System.EventArgs e)
		{
			LRRProjectConfigurations _lrrProjConfigs = new LRRProjectConfigurations();
			_app.DBManagerObj.PopulateCollection(_lrrProjConfigs);
			LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;
			foreach(LRRHistData data in LRRModel.HistDatas)
			{
				if(data.ModelUOM == null || data.ModelUOM =="")
				{
					if(data.UOMTypeID != "" && data.UOMTypeID != null)
					{
						
						
						
						string modelUOM = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,data.UOMTypeID);

						data.ModelUOM = modelUOM;
						
					}
				}
			}

			LRRMessagBox.ShowMessage("SID_DONE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
		}

		private void button14_Click(object sender, System.EventArgs e)
		{

			string appPath = Application.StartupPath;

			//Create Group Property Values for User 10
			string fPath1 = appPath +  @"\AmbiguosSPUOMTypeID.sql";
			
			System.IO.StreamWriter sitePropAmbUOMType = new System.IO.StreamWriter(fPath1);
			LRRProjectConfigurations _lrrProjConfigs = new LRRProjectConfigurations();

			_app.DBManagerObj.PopulateCollection(_lrrProjConfigs);
			LRRProjectConfiguration lrrProjConfig = _lrrProjConfigs[0] as LRRProjectConfiguration;


			foreach(LRRMasterProperty mp in LRRModel.MasterComponentPropertiesObj)
			{
				string UOMTypeID = mp.MasterPropertyUOMTypeID;
				if(UOMTypeID != null && UOMTypeID != "")
				{
					LRRSiteComponentProperties props = new LRRSiteComponentProperties();
					_app.DBManagerObj.PopulateCollection(props," WHERE PropertyID = '" + mp.PropID + "'");
					foreach(LRRSiteComponentProperty sp in props)
					{
						if(sp.UOMTypeID != UOMTypeID)
						{
							//Ambiguityu
							sitePropAmbUOMType.WriteLine("Component Name:" + LRRModel.SiteComponentsObj.GetSiteComponentByID(sp.ComponentID).Name + "|PropName:" + sp.Name + "|Master Uom Type:" + LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(mp.MasterPropertyUOMTypeID).Name);
							string modelUOM = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(lrrProjConfig.MeasurementSystemCEID,UOMTypeID);
							sp.UOM = modelUOM;
							sp.UOMTypeID = UOMTypeID;
						}
					}

				}
				
			}

			sitePropAmbUOMType.Close();
			LRRMessagBox.ShowMessage("SID_DONE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
		}

		private void button12_Click(object sender, System.EventArgs e)
		{
			string insertIntoPropValUser10 = "Insert into SiteComponentPropertyValue (ID,SiteComponentPropertyID,PropertyValue,ModeID,UID,TID,EffectivePlantTime,Formula,IsDefault,DerivationType,DirectionType,HistTagID,LRRDataType,LRRUIPrecision) Values ('@ID','@SiteComponentPropertyID','@PropertyValue','@ModeID','11','@TID','@EffectivePlantTime','@Formula',@IsDefault,'@DerivationType','@DirectionType','@HistTagID','@LRRDataType','@LRRUIPrecision')";

			
			string appPath = Application.StartupPath;

			string fPath = appPath +  @"\SiteComponentPropertyValuesUser11.sql";
			
			System.IO.StreamWriter sitePropValInserUser10 = new System.IO.StreamWriter(fPath);
																																													 
			foreach(LRRSiteComponentPropertyValue val in LRRModel.PropertyValuesObj)
			{
				string tmpInsertPropValUser = insertIntoPropValUser10;
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@ID",Guid.NewGuid().ToString());
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@SiteComponentPropertyID",val.SiteComponentPropertyID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@PropertyValue",val.PropertyValue);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@ModeID",val.ModeID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@TID",val.TimeID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@EffectivePlantTime","");
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@Formula",val.FormulaID);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@IsDefault",val.IsDefault.ToString(Symcon.BusinessObjects.SymConverter.Culture));
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@DerivationType",val.Derivation);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@DirectionType",val.Direction);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@HistTagID","");
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@LRRDataType",val.LRRDataType);
				tmpInsertPropValUser = tmpInsertPropValUser.Replace("@LRRUIPrecision","");

				sitePropValInserUser10.WriteLine(tmpInsertPropValUser);

				try
				{
					_app.DBManagerObj.CommitSQL(tmpInsertPropValUser);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
					sitePropValInserUser10.WriteLine("ERROR IN " + tmpInsertPropValUser);
				}


			}

			sitePropValInserUser10.Close();


			//Create Group Property Values for User 10
			string fPath1 = appPath +  @"\SiteComponentGroupedPropertyValuesUser11.sql";
			
			System.IO.StreamWriter siteGPropValInserUser10 = new System.IO.StreamWriter(fPath1);

			string insertIntoGPropValUser10 = "Insert into SiteGroupPropertyQualifierValue (SiteGroupPropertyQualifierValueID,LookUpPropertiesID,GroupPropertyID,LookupQualifierID,QualifierID,PropertyID,PropertyValue,ModeID,Derivation,DirectionType,HistTagID,UID,TID,Formula,EffectivePlantTime,MasterPropID) Values ('@SiteGroupPropertyQualifierValueID','@LookUpPropertiesID','@GroupPropertyID','@LookupQualifierID','@QualifierID','@PropertyID','@PropertyValue','@ModeID','@Derivation','@DirectionType','@HistTagID','11','@TID','@Formula','','@MasterPropID')";

			foreach(LRRSiteGroupPropertyQualifierValue gpqv in LRRModel.SiteGroupPropertyQualifierValuesObj)
			{
				string tmpInsertIntoGPropValUser10 = insertIntoGPropValUser10;

				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@SiteGroupPropertyQualifierValueID",Guid.NewGuid().ToString());
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@LookUpPropertiesID",gpqv.LookUpPropertiesID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@GroupPropertyID",gpqv.GroupPropertyID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@LookupQualifierID",gpqv.LookUpQualifierID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@QualifierID",gpqv.QualifierID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@PropertyID",gpqv.PropertyID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@PropertyValue",gpqv.PropertyValue);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@ModeID",gpqv.ModeID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@Derivation",gpqv.Derivation);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@DirectionType",gpqv.Direction);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@HistTagID",gpqv.HistTagID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@TID",gpqv.TID);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@Formula",gpqv.FormulaID);
				//tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@EffectivePlantTime",gpqv.EffectivePlantTime);
				tmpInsertIntoGPropValUser10 = tmpInsertIntoGPropValUser10.Replace("@MasterPropID",gpqv.MasterPropID);

				siteGPropValInserUser10.WriteLine(tmpInsertIntoGPropValUser10);

				try
				{
					_app.DBManagerObj.CommitSQL(tmpInsertIntoGPropValUser10);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
					siteGPropValInserUser10.WriteLine("ERROR IN " + tmpInsertIntoGPropValUser10);
				}

			}

			siteGPropValInserUser10.Close();

			LRRMessagBox.ShowMessage("SID_DONE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  

		}

		private void btnProcessModeless_Click(object sender, System.EventArgs e)
		{
			string[] sheets = Symcon.Utils.ExcelUtils.ExcelUtils.GetExcelSheetNames(@txtMasterModeUpdateFile.Text);
			DataTable dt = Symcon.Utils.ExcelUtils.ExcelUtils.GetTable("Sheet1"); //Using DB Mapped Attributes... for Master Properties...
			//string targetDBPath = txtExcelFile.Text;

			int dtrowcount = dt.Rows.Count;

			string updateMasterPropertyMode = "Update MasterProperties Set ModeID = 0 where PropertyID='^'";
			string upDateSitePropMode = "Update SiteComponentProperties Set ModeID = 0 where PropertyID='^'";
			string updateSitePropValMode = "Update SiteComponentPropertyValue Set ModeID = '0' where ID ='^'";
			string deleteSitePropVal = "Delete from SiteComponentPropertyValue where ID = '^'";

			string appPath = Application.StartupPath;

			string fPath = appPath +  @"\MasterPropMode0Update.sql";
			string fPath1 = appPath +  @"\SitePropMode0Update.sql";
			string fPath2 = appPath +  @"\SitePropValueMode0Update.sql";
			string fPath3 = appPath +  @"\SitePropValueMode0Delete.sql";
            

			System.IO.StreamWriter mPropModeUpdate = new System.IO.StreamWriter(fPath);
			System.IO.StreamWriter sPropModeUpdate = new System.IO.StreamWriter(fPath1);
			System.IO.StreamWriter sPropValModeUpdate = new System.IO.StreamWriter(fPath2);
			System.IO.StreamWriter sPropValModeDelete = new System.IO.StreamWriter(fPath3);

			Hashtable alreadyUpdatedsPropMode = new Hashtable();
			for(int i=2;i<dtrowcount;i++)
			{
				string isModeless = dt.Rows[i][0].ToString();
				string masterPropID = dt.Rows[i][2].ToString();

				if(isModeless == "modeless")
				{
					if(!alreadyUpdatedsPropMode.ContainsKey(masterPropID))
					{
						
							LRRMasterProperty mp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);							//mp.ModeID = false;
							string tupdateMasterPropertyMode = updateMasterPropertyMode;
							tupdateMasterPropertyMode = tupdateMasterPropertyMode.Replace("^",mp.PropID);
				
							mPropModeUpdate.WriteLine(tupdateMasterPropertyMode);

							try
							{
								_app.DBManagerObj.CommitSQL(tupdateMasterPropertyMode);
							}
							catch(Exception ex)
							{
								Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
								mPropModeUpdate.WriteLine("ERROR IN - " + tupdateMasterPropertyMode);

							}

							string tupDateSitePropMode = upDateSitePropMode;
							tupDateSitePropMode = tupDateSitePropMode.Replace("^",mp.PropID);

							sPropModeUpdate.WriteLine(tupDateSitePropMode);

							try
							{
								_app.DBManagerObj.CommitSQL(tupDateSitePropMode);
							}
							catch(Exception ex)
							{
								Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
								mPropModeUpdate.WriteLine("ERROR IN - " + tupDateSitePropMode);

							}


                            List<LRRSiteComponentPropertyValue> arList = LRRModel.MasterPropertyDictionaryObj.Get(mp.PropID); //Arraylist of Site Component Property Values....

						if(arList != null)
						{
							foreach(LRRSiteComponentPropertyValue propVal in arList)
							{
								if(propVal.ModeID == "1") //Currently Measurement Update to Default...
								{
									string tupdateSitePropValMode = updateSitePropValMode;
									tupdateSitePropValMode = tupdateSitePropValMode.Replace("^",propVal.ID);

									sPropValModeUpdate.WriteLine(tupdateSitePropValMode);

									try
									{
										_app.DBManagerObj.CommitSQL(tupdateSitePropValMode);

									}
									catch(Exception ex)
									{
										Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
										sPropValModeUpdate.WriteLine("ERROR IN -" + tupdateSitePropValMode);

									}

								}
								else if(propVal.ModeID == "2" || propVal.ModeID == "3") //Delete System Status and Scenorios..
								{

									string tdeleteSitePropVal = deleteSitePropVal;
									tdeleteSitePropVal = tdeleteSitePropVal.Replace("^",propVal.ID);

									sPropValModeDelete.WriteLine(tdeleteSitePropVal);

									try
									{
										_app.DBManagerObj.CommitSQL(tdeleteSitePropVal);

									}
									catch(Exception ex)
									{
										Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
										sPropValModeDelete.WriteLine("ERROR IN -" + tdeleteSitePropVal);

									}

								}
								else
								{

									sPropValModeDelete.WriteLine("SHOULD NEVER BE HERE " + propVal.ID + "|" + propVal.ModeID + "|" + propVal.SiteComponentPropertyID);
								}
							}
						
						}
						alreadyUpdatedsPropMode.Add(masterPropID,"");
					}
				}
			}

			mPropModeUpdate.Close();
			sPropModeUpdate.Close();
			sPropValModeDelete.Close();
			sPropValModeUpdate.Close();
		}

		private void button15_Click(object sender, System.EventArgs e)
		{
			
			OpenFileDialog sfd = new OpenFileDialog();
			sfd.ShowDialog();
			txtMasterModeUpdateFile.Text = sfd.FileName;

			
		}

		private void button16_Click(object sender, System.EventArgs e)
		{
			foreach(LRRSiteComponentProperty p in LRRModel.SiteComponentPropertiesObj)
			{
				if(p.PropertyID != null && p.PropertyID != "")
				{
					//Get Master Property 
					LRRMasterProperty mp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(p.PropertyID);
					if(mp!=null)
					{
						if(mp.MasterPropertyUOMTypeID != p.UOMTypeID)
						{
							p.UOMTypeID = mp.MasterPropertyUOMTypeID;
							p.UOM = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM("2",p.UOMTypeID);
						}
					}
				}
			}

			LRRSiteComponentProperties props = LRRModel.SiteComponentPropertiesObj.GetChanges();

			_app.DBManagerObj.CommitCollection(props);
		}

		private void btnGPDerivations_Click(object sender, System.EventArgs e)
		{
			LRRModel.SiteGroupPropertyQualifierValuesObj.SortColumn = "ModeID";
			LRRModel.SiteGroupPropertyQualifierValuesObj.SortingOrder = Symcon.BusinessObjects.GenericComparer.SortOrder.Ascending;
			LRRModel.SiteGroupPropertyQualifierValuesObj.Sort();

			foreach(LRRSiteGroupPropertyQualifierValue propVal in LRRModel.SiteGroupPropertyQualifierValuesObj)
			{
				if(propVal.ModeID == "0") //No Mode Situation Defaulting to Input and User Supplied...
				{
					propVal.Direction = "1";
					propVal.Derivation = "4";
				}
				else if(propVal.ModeID == "1") //Only For Measurement Mode....
				{
					LRRHistPropCompPropMapping mapObj = LRRModel.HistPropMaps.GetHistMapObjFromGrpValID(propVal.SiteGroupPropertyQualifierValueID);
					if(mapObj != null) //Point is Mapped so set the direction
					{
						propVal.Direction = "1"; //Set Direction of the property Value as Input as it is mapped...

						LRRHistData histData = LRRModel.HistDatas.GetHistDataFromHistTagUID(mapObj.HistPropID);
						if(histData.FormulaID != null && histData.FormulaID != "")
						{
							propVal.Derivation = "3"; //Measured Derived 
						}
						else
						{
							propVal.Derivation = "2"; //Mesured Directly...
						}
					}
					else //Not Mapped Property....
					{
						if(propVal.PropertyValue != null && propVal.PropertyValue != "")
						{
							propVal.Direction = "1"; //Input Direction
							propVal.Derivation = "4";//User Supplied...
						}
						else
						{
							propVal.Direction = "1";//Input Direction
							propVal.Derivation = "1"; //Not Measured Derivation..
						}
					}
				}
				else //Mode 2,3 System Status and Scenarios...
				{

					string siteCompGroupPropID = propVal.GroupPropertyID;
					string lkupQualifierID = propVal.QualifierID;
					string lnupPropID = propVal.LookUpPropertiesID;

					LRRSiteComponentGroupProperty lrrSiteCompGroupProp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(siteCompGroupPropID);
                    //LRRSiteGroupPropertyQualifierValue measModeObj;
                    //Dictionary<string, List<IPropertyValue>> dctPropVals = lrrSiteCompGroupProp.GroupPptiesQualifierValues.GetGroupQualifierValuesFromGroupPropID(siteCompGroupPropID);
                    //foreach (List<IPropertyValue> lstVals in dctPropVals.Values)
                    //{
                    //    foreach (IPropertyValue val in lstVals)
                    //    {
		                   
                    //    }
                    //}
                    LRRSiteGroupPropertyQualifierValue measModeObj = lrrSiteCompGroupProp.GroupPptiesQualifierValues.GetQualifierValueObjectForPropertyMode(siteCompGroupPropID, lnupPropID, lkupQualifierID, "1"); ;

					if(propVal.ModeID == "2") //System Status
					{
						LRRHistPropCompPropMapping mapObj = LRRModel.HistPropMaps.GetHistMapObjFromGrpValID(measModeObj.SiteGroupPropertyQualifierValueID);

						if(mapObj != null) //Check of the Meas Mode for this SS or SC is mapped
						{
							//Parent Mode has Mapping
							propVal.Derivation = "11";
						}
						else
						{
							if(measModeObj.Derivation == "1" || measModeObj.Derivation == "4")
							{
								propVal.Direction = "1";
								propVal.Derivation = "4";
							}
						}
					}
					else if(propVal.ModeID == "3") //Scenarios
					{
						propVal.Direction =  "1"; //Set the Default Direction for Scenarios to Inputs...
						propVal.Derivation = "22";
					}
				}
			}

			LRRSiteGroupPropertyQualifierValues valsToCommit = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();

			IEnumerator ieNum = valsToCommit.GetEnumerator();

			string appPath = Application.StartupPath;

			string fPath = appPath + @"\GroupedPropertyUpdate.sql";

			System.IO.StreamWriter fs = new System.IO.StreamWriter(fPath);
			string sql = "Update SiteGroupPropertyQualifierValue Set DirectionType ='#', Derivation = '%' where SiteGroupPropertyQualifierValueID = '^'";
			while(ieNum.MoveNext())
			{
				LRRSiteGroupPropertyQualifierValue valOnj = (LRRSiteGroupPropertyQualifierValue)ieNum.Current;
				string updDirection =  valOnj.Direction;
				string updDerivation = valOnj.Derivation;
				string tsql = sql;
				tsql =  tsql.Replace("#",updDirection);
				tsql = tsql.Replace("%",updDerivation);
				tsql =  tsql.Replace("^",valOnj.SiteGroupPropertyQualifierValueID);
				fs.WriteLine(tsql);
				fs.WriteLine("");

				try
				{
					//_app.DBManagerObj.CommitSQL(tsql);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Debug);
					fs.WriteLine("ERROR in - " + tsql);
				}
				
			}
			fs.Close();

			//MessageBox.Show("Completed and saved file " + fPath);
			string[] s = new string[1];
			s[0] = fPath;
			LRRMessagBox.ShowMessage("SID_FILE_SAVED","SID_LABEL",s);
			//_app.DBManagerObj.CommitCollection(valsToCommit);
		}

		private void btnGPDirectionExcelMapper_Click(object sender, System.EventArgs e)
		{
			
			//*****************************************************************************************
			//For DBMapGroupedProps...
			//Load the Excel File into the System
			string[] sheets = Symcon.Utils.ExcelUtils.ExcelUtils.GetExcelSheetNames(@textBox2.Text);
			DataTable dt = Symcon.Utils.ExcelUtils.ExcelUtils.GetTable("DBMapGroupedProps"); //Using DB Mapped Attributes... for Master Properties...
			
			string appPath = Application.StartupPath;

			string fPath = appPath +  @"\SiteGroupPropertyQualifierValueUpdate.sql";

			System.IO.StreamWriter sPropDirectionUpdate = new System.IO.StreamWriter(fPath);

			string sqlUpdSitePropValue = "Update SiteGroupPropertyQualifierValue Set DirectionType = '#' where PropertyID = '^' and LookupQualifierID = '*' and ModeID = '$'";

			Hashtable duplicateMarker = new Hashtable();
			
//			int dtscrowcount = 18;
//			int dtptrowcount = 29;
//			int dtlkuprowcount = 65;
//			int dtlkupQualrowcount = 29;
			int dtscrowcount = dt.Rows.Count;
			string propTypeID;
			string sLookupQualID;
			string direction;
			string mode;
			//string tsqlUpdSiteGroupQual = sqlUpdSitePropValue;

			#region Section #1
			for(int sccnt = 4;sccnt< dtscrowcount ; sccnt++)
			{
				direction = dt.Rows[sccnt][11].ToString().ToUpper();

				if(direction != null && direction != "")
				{
					propTypeID = dt.Rows[sccnt][0].ToString();
					sLookupQualID = dt.Rows[sccnt][2].ToString();
					direction = dt.Rows[sccnt][11].ToString().ToUpper();
					mode = dt.Rows[sccnt][13].ToString().ToUpper();
					string tsql = sqlUpdSitePropValue;

					if(direction == "I")
					{
						direction = "1";
					}
					else if(direction == "O")
					{
						direction =  "2";
						//derivation = "7";
					}

					tsql = tsql.Replace("#",direction);
					tsql = tsql.Replace("^",propTypeID);
					tsql = tsql.Replace("*",sLookupQualID);
					tsql = tsql.Replace("$",mode);
					sPropDirectionUpdate.WriteLine(tsql);
				}

					
			}
//			for(int sccnt = 4;sccnt< dtscrowcount ; sccnt++)
//			{
//				string siteCompID = dt.Rows[sccnt][0].ToString();
//
//				for(int propTypeCnt = 19;propTypeCnt< dtptrowcount ; propTypeCnt++)
//				{
//					string propTypeID = dt.Rows[propTypeCnt][0].ToString();
//					
//					//Get the site component property id
//					LRRSiteComponentProperties objProps = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(siteCompID).FilterPropertiesByPropertyType(propTypeID);
//					foreach(LRRSiteComponentProperty objProp in objProps)
//					{
//						//Loop through the lookup properties section
//						for(int lkupCnt = 30;lkupCnt< dtlkuprowcount ; lkupCnt++)
//						{
//							string sLookupPropID = dt.Rows[lkupCnt][0].ToString();
//							LRRSiteComponentGroupProperties objGrpProps = objProp.GetGroupProperties() as LRRSiteComponentGroupProperties;
//							string sGroupPropertyID = objGrpProps.GetSiteGroupPropID(objProp.ID,sLookupPropID);
//
//							//Loop through the qualifier properties section
//							for(int lkupQualCnt = 19;lkupQualCnt< dtlkupQualrowcount ; lkupQualCnt++)
//							{
//								string tsqlUpdSiteGroupQual = sqlUpdSitePropValue;
//								string sLookupQualID = dt.Rows[lkupQualCnt][2].ToString();
//								LRRSiteGroupPropertyQualifierValues objQualValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID).GetGroupQualifierValuesFromLkupQualID(sLookupQualID);
//								//update direction based on the mode
//
//								string mode = dt.Rows[lkupQualCnt][13].ToString().ToUpper();
//								string direction = dt.Rows[lkupQualCnt][11].ToString().ToUpper();
//								string sQualValID = objQualValues.GetQualifierValueObjectForPropertyMode(mode).SiteGroupPropertyQualifierValueID;
//								
//								if(direction == "I")
//								{
//									direction = "1";
//								}
//								else if(direction == "O")
//								{
//									direction =  "2";
//								}
//
//								tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("#",direction);
//								tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("^",sQualValID);
//								//Log Site Diection Update 
//								sPropDirectionUpdate.WriteLine(tsqlUpdSiteGroupQual);
//
//							}
//						}
//
//					}
//
//				}
//			}
//
			#endregion 

			sPropDirectionUpdate.WriteLine("Update SiteGroupPropertyQualifierValue set Derivation = '7' where DirectionType = '2'"); 
//			LRRMessagBox.ShowMessage("SID_DONE1","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
//
//
//			#region Section #2
//			dtscrowcount = 70;
//			dtptrowcount = 73;
//			dtlkuprowcount = 79;
//			dtlkupQualrowcount = 73;
//			for(int sccnt = 67;sccnt< dtscrowcount ; sccnt++)
//			{
//				string siteCompID = dt.Rows[sccnt][0].ToString();
//
//				for(int propTypeCnt = 72;propTypeCnt< dtptrowcount ; propTypeCnt++)
//				{
//					string propTypeID = dt.Rows[propTypeCnt][0].ToString();
//					
//					//Get the site component property id
//					LRRSiteComponentProperties objProps = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(siteCompID).FilterPropertiesByPropertyType(propTypeID);
//					foreach(LRRSiteComponentProperty objProp in objProps)
//					{
//						//Loop through the lookup properties section
//						for(int lkupCnt = 75;lkupCnt< dtlkuprowcount ; lkupCnt++)
//						{
//							string sLookupPropID = dt.Rows[lkupCnt][0].ToString();
//							LRRSiteComponentGroupProperties objGrpProps = objProp.GetGroupProperties() as LRRSiteComponentGroupProperties;
//							string sGroupPropertyID = objGrpProps.GetSiteGroupPropID(objProp.ID,sLookupPropID);
//
//							//Loop through the qualifier properties section
//							for(int lkupQualCnt = 72;lkupQualCnt< dtlkupQualrowcount ; lkupQualCnt++)
//							{
//								string tsqlUpdSiteGroupQual = sqlUpdSitePropValue;
//								string sLookupQualID = dt.Rows[lkupQualCnt][2].ToString();
//								LRRSiteGroupPropertyQualifierValues objQualValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID).GetGroupQualifierValuesFromLkupQualID(sLookupQualID);
//								//update direction based on the mode
//								if(objQualValues.Count > 0)
//								{
//									string mode = dt.Rows[lkupQualCnt][13].ToString().ToUpper();
//									string direction = dt.Rows[lkupQualCnt][11].ToString().ToUpper();
//									if(objQualValues.GetQualifierValueObjectForPropertyMode(mode) != null)
//									{
//										string sQualValID = objQualValues.GetQualifierValueObjectForPropertyMode(mode).SiteGroupPropertyQualifierValueID;
//								
//										if(direction == "I")
//										{
//											direction = "1";
//										}
//										else if(direction == "O")
//										{
//											direction =  "2";
//										}
//
//										tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("#",direction);
//										tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("^",sQualValID);
//										//Log Site Diection Update 
//										sPropDirectionUpdate.WriteLine(tsqlUpdSiteGroupQual);
//									}
//								}
//
//							}
//						}
//
//					}
//
//				}
//			}
//
//			#endregion
//			
//			LRRMessagBox.ShowMessage("SID_DONE2","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
//
//			#region Section #3
//			dtscrowcount = 85;
//			dtptrowcount = 94;
//			dtlkuprowcount = 130;
//			dtlkupQualrowcount = 94;
//			for(int sccnt = 82;sccnt< dtscrowcount ; sccnt++)
//			{
//				string siteCompID = dt.Rows[sccnt][0].ToString();
//
//				for(int propTypeCnt = 87;propTypeCnt< dtptrowcount ; propTypeCnt++)
//				{
//					string propTypeID = dt.Rows[propTypeCnt][0].ToString();
//					
//					//Get the site component property id
//					LRRSiteComponentProperties objProps = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(siteCompID).FilterPropertiesByPropertyType(propTypeID);
//					foreach(LRRSiteComponentProperty objProp in objProps)
//					{
//						//Loop through the lookup properties section
//						for(int lkupCnt = 96;lkupCnt< dtlkuprowcount ; lkupCnt++)
//						{
//							string sLookupPropID = dt.Rows[lkupCnt][0].ToString();
//							LRRSiteComponentGroupProperties objGrpProps = objProp.GetGroupProperties() as LRRSiteComponentGroupProperties;
//							string sGroupPropertyID = objGrpProps.GetSiteGroupPropID(objProp.ID,sLookupPropID);
//
//							//Loop through the qualifier properties section
//							for(int lkupQualCnt = 87;lkupQualCnt< dtlkupQualrowcount ; lkupQualCnt++)
//							{
//								string tsqlUpdSiteGroupQual = sqlUpdSitePropValue;
//								string sLookupQualID = dt.Rows[lkupQualCnt][2].ToString();
//								LRRSiteGroupPropertyQualifierValues objQualValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID).GetGroupQualifierValuesFromLkupQualID(sLookupQualID);
//								//update direction based on the mode
//								if(objQualValues.Count > 0)
//								{
//									string mode = dt.Rows[lkupQualCnt][13].ToString().ToUpper();
//									string direction = dt.Rows[lkupQualCnt][11].ToString().ToUpper();
//									if(objQualValues.GetQualifierValueObjectForPropertyMode(mode) != null)
//									{
//										string sQualValID = objQualValues.GetQualifierValueObjectForPropertyMode(mode).SiteGroupPropertyQualifierValueID;
//								
//										if(direction == "I")
//										{
//											direction = "1";
//										}
//										else if(direction == "O")
//										{
//											direction =  "2";
//										}
//
//										tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("#",direction);
//										tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("^",sQualValID);
//										//Log Site Diection Update 
//										sPropDirectionUpdate.WriteLine(tsqlUpdSiteGroupQual);
//									}
//								}
//							}
//						}
//
//					}
//
//				}
//			}
//
//			#endregion
//			
//			LRRMessagBox.ShowMessage("SID_DONE3","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
//
//			#region Section #4
//			dtscrowcount = 151;
//			dtptrowcount = 160;
//			dtlkuprowcount = 197;
//			dtlkupQualrowcount = 160;
//			for(int sccnt = 133;sccnt< dtscrowcount ; sccnt++)
//			{
//				string siteCompID = dt.Rows[sccnt][0].ToString();
//
//				for(int propTypeCnt = 153;propTypeCnt< dtptrowcount ; propTypeCnt++)
//				{
//					string propTypeID = dt.Rows[propTypeCnt][0].ToString();
//					
//					//Get the site component property id
//					LRRSiteComponentProperties objProps = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(siteCompID).FilterPropertiesByPropertyType(propTypeID);
//					foreach(LRRSiteComponentProperty objProp in objProps)
//					{
//						//Loop through the lookup properties section
//						for(int lkupCnt = 162;lkupCnt< dtlkuprowcount ; lkupCnt++)
//						{
//							string sLookupPropID = dt.Rows[lkupCnt][0].ToString();
//							LRRSiteComponentGroupProperties objGrpProps = objProp.GetGroupProperties() as LRRSiteComponentGroupProperties;
//							string sGroupPropertyID = objGrpProps.GetSiteGroupPropID(objProp.ID,sLookupPropID);
//
//							//Loop through the qualifier properties section
//							for(int lkupQualCnt = 153;lkupQualCnt< dtlkupQualrowcount ; lkupQualCnt++)
//							{
//								string tsqlUpdSiteGroupQual = sqlUpdSitePropValue;
//								string sLookupQualID = dt.Rows[lkupQualCnt][2].ToString();
//								LRRSiteGroupPropertyQualifierValues objQualValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(sGroupPropertyID).GetGroupQualifierValuesFromLkupQualID(sLookupQualID);
//								//update direction based on the mode
//								if(objQualValues.Count > 0)
//								{
//									string mode = dt.Rows[lkupQualCnt][13].ToString().ToUpper();
//									string direction = dt.Rows[lkupQualCnt][11].ToString().ToUpper();
//									if(objQualValues.GetQualifierValueObjectForPropertyMode(mode) != null)
//									{
//										string sQualValID = objQualValues.GetQualifierValueObjectForPropertyMode(mode).SiteGroupPropertyQualifierValueID;
//								
//										if(direction == "I")
//										{
//											direction = "1";
//										}
//										else if(direction == "O")
//										{
//											direction =  "2";
//										}
//
//										tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("#",direction);
//										tsqlUpdSiteGroupQual = tsqlUpdSiteGroupQual.Replace("^",sQualValID);
//										//Log Site Diection Update 
//										sPropDirectionUpdate.WriteLine(tsqlUpdSiteGroupQual);
//									}
//								}
//							}
//						}
//
//					}
//
//				}
//			}
//
//			#endregion
//
//			LRRMessagBox.ShowMessage("SID_DONE4","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  

			sPropDirectionUpdate.Close();

			//Completed DB mapped Attributes
			string files = fPath + "\r\n" ;
//			MessageBox.Show("Done Saved Files " + files);
			string[] s = new string[1];
			s[0] = files;
			LRRMessagBox.ShowMessage("SID_FILE_SAVED","SID_LABEL",s);
		}

		private void button17_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog sfd = new OpenFileDialog();
			sfd.ShowDialog();
			textBox2.Text = sfd.FileName;
		}

		private void button17_Click_1(object sender, System.EventArgs e)
		{
			bool ret = true;/* = _app.RunControllerObj.GetActiveHistorian(HistorianConnectionType.ONLINE).SetPoint(txtHistTag.Text,txtHistServer.Text,float.Parse(txtHistValue.Text),tagDateTime.Value);*/
			if(ret == true)
			{
				MessageBox.Show("Success");
			}
			else
			{
				MessageBox.Show("Failure");
			}
		
		}

		private void btnUpdateGraphics_Click(object sender, System.EventArgs e)
		{
			LRRMessagBox.ShowMessage("SID_GRAPHICS_UPDATE_STARTED","SID_LABEL",MessageBoxButtons.OK);    
			
			_app.DBManagerObj.PopulateCollection(lrrsvs);
			//int canvasNumber = Int32.Parse(textBox1.Text);
			foreach(LRRSavedView lrrsv in lrrsvs)
			{
				//lrrsv = lrrsvs[canvasNumber] as LRRSavedView;
				if(lrrsv == null)
					return;
				gms.CreateGraphicsManager();
				Canvas canvas = gms.ActiveManager.LoadCanvas(lrrsv.ID);
                ArrayList arrGroupedNodes = new ArrayList();

                //Find Grouped Nodes and add to arrayList -arrGroupedNodes
                foreach (INode nde in canvas.Model.Nodes)
                {
                    if (nde.GetType() == typeof(Syncfusion.Windows.Forms.Diagram.Group))
                    {
                        arrGroupedNodes.Add(nde);
                    }
                }

                //Ungroup Grouped Nodes 
                foreach (INode grpNode in arrGroupedNodes)
                {
                    //Syncfusion.Windows.Forms.Diagram.UngroupCmd unGroup = new UngroupCmd();
                  
                    //unGroup.Nodes.Add(grpNode);
                    //canvas.Controller.ExecuteCommand(unGroup);
                    
                    
                    
                    

                }
                arrGroupedNodes.Clear();
				foreach(INode node in canvas.Model.Nodes)
				{
					if(node.GetType().BaseType == typeof(Symbol))
					{
						Symbol sm = node as Symbol;
						PropertyTable pt =  GetPropertyTableForsymbol(sm);
						PropertyTable myPT = pt;
						PropertySpec siteitemps = null;
						PropertySpec masterItem = null;
						PropertySpec graphicallink = null;
						Symcon.Lightridge.LRRUI.PropertyBag.PropertySpecCollection pscl	= pt.Properties;
						ArrayList alst = new ArrayList();
						foreach(PropertySpec ps	in pscl)
						{
							if(ps.Category == "Binding Information")
							{
								alst.Add(ps);
							}
							else if(ps.Category == "Link")
							{
								alst.Add(ps);
							}

						}

						foreach(PropertySpec ps	in alst)
						{
							string str = ps.DefaultValue as string;
							string psName = ps.Name;
							if(ps.Name == "SiteItem")
							{
                                object obj = sm.GetPropertyContainerByName(ps.Name);
								if(obj != null && obj.ToString() != "Select")
								{
									string siteitem = ExtractPropertyNameFromSiteItem(sm);
									if(sm.GetType() != typeof(Symcon.Lightridge.LRRUI.Controls.Aggregates))
									{
										LRRSiteComponent lsc =  LRRModel.SiteComponentsObj.GetSiteComponentByName(siteitem);
										SiteItem si = null;// = new SiteItem();
										if(lsc != null)
										{
											si = new SiteItem();
											si.Name = lsc.Name;
											si.ID = lsc.SiteComponentID;
										}
								
										//sm.SetPropertyValue("PlantItem",si);
										siteitemps = new PropertySpec("PlantItem",typeof(SiteItem),"Binding Information","Lists the Plant Item objects of Selected Master Plant Item" ,null,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.ObjectNameConverter),sm);
										myPT.Properties.Add(siteitemps);
										myPT.Properties.Remove("SiteItem");
									}
									else
									{
										LRRAggregate lsc =  LRRModel.AggregatesObj.GetAggregateFromName(siteitem);
										SiteItem si = null;// = new SiteItem();
										if(lsc != null)
										{
											si = new SiteItem();
											si.Name = lsc.Name;
											si.ID = lsc.AggregateID;
										}
										//sm.SetPropertyValue("PlantItem",si);
                                        
										siteitemps = new PropertySpec("PlantItem",typeof(SiteItem),"Binding Information","Lists the Plant Item objects of Selected Master Plant Item" ,null,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.ObjectNameConverter),sm);
										myPT.Properties.Add(siteitemps);
										myPT.Properties.Remove("SiteItem");
										int i = 10; 
									}
								}
								else
								{
									//sm.SetPropertyValue("PlantItem",null);
									siteitemps = new PropertySpec("PlantItem",typeof(SiteItem),"Binding Information","Lists the Plant Item objects of Selected Master Plant Item" ,null,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.ObjectNameConverter),sm);
									myPT.Properties.Add(siteitemps);
									myPT.Properties.Remove("SiteItem");
								}
							}
							else if(ps.Name == "ItemType")
							{
                                string mastername = sm.GetPropertyContainerByName(ps.Name) as string;
								if(mastername != null && mastername != "Select" )
								{
									LRRMasterComponent mastercomponent = GetMaster(mastername);
									MasterPlantItem mp = null;//= new MasterPlantItem();
									if(mastercomponent != null)
									{
										mp = new MasterPlantItem();
										mp.Name = mastercomponent.ComponentName;
										mp.ID = mastercomponent.ID;
									}
									//sm.SetPropertyValue("MasterPlantItem",mp);
									masterItem = new PropertySpec("MasterPlantItem",typeof(MasterPlantItem),"Binding Information","Lists of Master Plant Item",null,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.SymbolTypeConverter),sm);
									myPT.Properties.Add(masterItem);
									myPT.Properties.Remove("ItemType");
									int u = 2;
								}
								else
								{
									//sm.SetPropertyValue("MasterPlantItem",null);
									masterItem = new PropertySpec("MasterPlantItem",typeof(MasterPlantItem),"Binding Information","Lists of Master Plant Item",null,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.SymbolTypeConverter),sm);
									myPT.Properties.Add(masterItem);
									myPT.Properties.Remove("ItemType");
								}
							}
							else if(ps.Name == "Link")
							{
                                string linkName = sm.GetPropertyContainerByName(ps.Name) as string;
								if(linkName != null && linkName != "Enter Link Here" )
								{
									GraphicalLink grphLink = GetGraphicalLink(linkName);
									//MasterPlantItem mp = null;//= new MasterPlantItem();
									//if(mastercomponent != null)
									//{
									//										mp = new MasterPlantItem();
									//										mp.Name = mastercomponent.ComponentName;
									//										mp.ID = mastercomponent.ID;
									//									}
									//sm.SetPropertyValue("Link",grphLink);
                                    
									graphicallink = new PropertySpec("Link",typeof(GraphicalLink),"Link","Select the Link for the Symbol",null,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.LinkTypeConverter),sm);
									myPT.Properties.Remove("Link");
									myPT.Properties.Add(graphicallink);
									int u = 2;
								}
								else
								{
									//sm.SetPropertyValue("Link",null);
									graphicallink = new PropertySpec("Link",typeof(GraphicalLink),"Link","Select the Link for the Symbol",null,"",typeof(Symcon.LightRidge.BusinessObjects.TypeConverters.LinkTypeConverter),sm);
									myPT.Properties.Remove("Link");
									//sm.RemoveProperty("Link");
									myPT.Properties.Add(graphicallink);
								}
							}
						}
						//sm.RemoveProperty("SiteItem");
                        
                        
						//sm.RemoveProperty("ItemType");
						int l = 99;
					}
				}
				Save(lrrsv.ID,canvas);
			}
			LRRMessagBox.ShowMessage("SID_COMPLETED","SID_LABEL",MessageBoxButtons.OK); 
		}

		private void Save(string fileId,Canvas selectedCanvas)
		{

			MemoryStream ms	= null;
			BinaryReader br	= null;
			try
			{
				ms = new MemoryStream();
				BinaryFormatter	formatter =	new	BinaryFormatter();
				formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder;
				formatter.AssemblyFormat = FormatterAssemblyStyle.Simple;
				//DiagramDocument	doc	= new DiagramDocument(selectedCanvas.Model,	selectedCanvas.View,(DiagramScript)selectedCanvas.ScriptingManager.Script);
				//formatter.Serialize(ms,	doc);
				ms.Position	= 0;
				br = new BinaryReader(ms);
				byte[] fileData	= br.ReadBytes((int)ms.Length);
				LRRSavedViewData lrsvd = new LRRSavedViewData();
				lrsvd.ViewBlob = fileData;
				lrsvd.ID = fileId;
				lrsvd.ObjectState =	Symcon.Globals.Enums.DBOperation.DELETE;
				_app.DBManagerObj.CommitObject(lrsvd);
				if(lrsvd.ObjectState ==	Symcon.Globals.Enums.DBOperation.DELETE)
				{
					lrsvd.ObjectState =	Symcon.Globals.Enums.DBOperation.INSERT;
					_app.DBManagerObj.CommitObject(lrsvd);
				}
			}
			catch(Exception	ex)
			{
			}
			finally
			{
				if(br != null)
					br.Close();
				if(ms != null)
					ms.Close();
				ms = null; 
				br = null;
			}
		}

		private LRRMasterComponent GetMaster(string name)
		{
			foreach(LRRMasterComponent lmc in LRRModel.Model)
			{
				if(lmc.ComponentName == name)
				{
					return lmc;
				}
			}
			return null;
		}


		private GraphicalLink GetGraphicalLink(string str)
		{
			if(str != null && str.Length > 0 &&	!str.Equals("Enter Link	Here"))
			{
				string fileID =	null;
				bool isSavedView = false;
				foreach(LRRSavedView lrsv in LRRModel.SavedViews)
				{
					if(lrsv.SavedViewName == str)
					{
						//fileID = lrsv.ID;
						isSavedView = true;
						GraphicalLink grhlink = new GraphicalLink();
						grhlink.ID = lrsv.ID;
						grhlink.Name = lrsv.SavedViewName;
						grhlink.LinkTypeID = 1;
						return grhlink;
					}
				}
				if(!isSavedView)
				{
					foreach(LRRSearchCriteria lrrsc in LRRModel.ChildModel.SearchCriterias)
					{
						if(lrrsc.Name == str)
						{
							GraphicalLink grhlink = new GraphicalLink();
							grhlink.ID = lrrsc.ID;
							grhlink.Name = lrrsc.Name;
							grhlink.LinkTypeID = 2;
							return grhlink;
						}
					}
				}
			}
			return null;

		}

		public string ExtractPropertyNameFromSiteItem(Symbol smbl)
		{
			string propName = null;
			if(smbl.GetPropertyContainerByName("ItemType") != null	&& (string)smbl.GetPropertyContainerByName("ItemType") !=	"Select")
			{
                if (smbl.GetPropertyContainerByName("SiteItem").ToString().EndsWith("]"))
				{
                    propName = smbl.GetPropertyContainerByName("SiteItem").ToString().Substring(0, smbl.GetPropertyContainerByName("SiteItem").ToString().IndexOfAny("[".ToCharArray()));
				}
				else
				{
                    propName = smbl.GetPropertyContainerByName("SiteItem").ToString();
				}
			}
			return propName.Trim();

		}

		private static PropertyTable GetPropertyTableForsymbol(Symbol symbol)
		{
			PropertyTable pt = symbol.GetPropertyContainerByName("PT") as PropertyTable;
			return pt;
		}

		private void button18_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fdTargetDB = new OpenFileDialog();
			fdTargetDB.ShowDialog();
			txtTargetDB.Text = fdTargetDB.FileName;
		}

		private void btnPortGraphics_Click(object sender, System.EventArgs e)
		{
			DialogResult result = LRRMessagBox.ShowMessage("SID_GRAPHICS_PORT_CONFIRMATION","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question); 
			if(result == DialogResult.Yes)
			{
				LRRMessagBox.ShowMessage("SID_GRAPHICS_PORT_STARTED","SID_LABEL",MessageBoxButtons.OK);
				LRRSavedViews lrrSourceSVS = new LRRSavedViews();
				LRRSavedViewDatas lrrSourceSVDS = new LRRSavedViewDatas();

				LRRSavedViews lrrTargetSVS = new LRRSavedViews();
				LRRSavedViewDatas lrrTargetSVDS = new LRRSavedViewDatas();

				_app.DBManagerObj.PopulateCollection(lrrSourceSVS);
				_app.DBManagerObj.PopulateCollection(lrrSourceSVDS);

				//Create Target database.
				DBInfo dbInf = null;
				
				switch(cmbDBType.Text) 
				{
					case "SQLSERVER":
						dbInf = new DBInfo(txtTargetDBName.Text,txtTargetServer.Text,Symcon.Globals.Enums.DBType.SQLSERVER);
						dbInf.DatabaseUser = txtTargetUserName.Text;
						dbInf.DatabasePWD = txtTargetPWD.Text;
						break;
					case "ACCESS":
						dbInf = new DBInfo();
						dbInf.DatabaseFilePath = txtTargetDB.Text;
						dbInf.DatabaseUser = "Admin";
						break;
				}
				Symcon.Database.DBManager dbTargetManager = new Symcon.Database.DBManager(dbInf);
				dbTargetManager.Login(_app.LoggedUser,_app.LoggedUserPWD);
				
				dbTargetManager.PopulateCollection(lrrTargetSVS);
				dbTargetManager.PopulateCollection(lrrTargetSVDS);
				
				//Update/Create target views

				foreach(LRRSavedView lrrsv in lrrSourceSVS)
				{
					string sID = lrrsv.ID;
					LRRSavedView lrrtsv = lrrTargetSVS.GetSavedViewFromID(sID);
					string sSourceName = lrrsv.SavedViewName;
					string sSourceDescription = lrrsv.SavedViewDescription == null ? "" : lrrsv.SavedViewDescription;
						
					//Incase the view is not there in the target, add the view
					if(lrrtsv == null)
					{
						LRRSavedView savedView = new LRRSavedView();
						savedView.ID = sID;
						savedView.SavedViewName = sSourceName;
						savedView.SavedViewDescription = sSourceDescription;
						lrrTargetSVS.Add(savedView);

						LRRSavedViewData savedViewData= new LRRSavedViewData();
						savedViewData.ID = sID;
						byte[] byteArray =lrrSourceSVDS.GetSavedViewDataFromID(sID).ViewBlob;
						savedViewData.ViewBlob = byteArray;
						lrrTargetSVDS.Add(savedViewData);
					}
					else //update the blob
					{
						string sTargetName = lrrtsv.SavedViewName;
						string sTargetDescription = lrrtsv.SavedViewDescription == null ? "" : lrrtsv.SavedViewDescription;

						if(sTargetName.ToUpper() != sSourceName.ToUpper())
							lrrtsv.SavedViewName = sSourceName;
						
						if(sTargetDescription.ToUpper() != sSourceDescription.ToUpper())
							lrrtsv.SavedViewDescription = sSourceDescription;
						
						lrrTargetSVDS.GetSavedViewDataFromID(sID).ViewBlob = lrrSourceSVDS.GetSavedViewDataFromID(sID).ViewBlob;
					}
				}
				
				if(lrrTargetSVS.GetChanges().Count > 0)
				{
					LRRSavedViews lrrToSave = new LRRSavedViews();
					lrrToSave = lrrTargetSVS.GetChanges();
					foreach(LRRSavedView view in lrrToSave)
						dbTargetManager.CommitObject(view);
				}
				
				if(lrrTargetSVDS.GetChanges().Count > 0)
				{
					LRRSavedViewDatas lrrToSave = new LRRSavedViewDatas();
					lrrToSave = lrrTargetSVDS.GetChanges();
					foreach(LRRSavedViewData data in lrrToSave)
						dbTargetManager.CommitObject(data);
				}
				LRRMessagBox.ShowMessage("SID_GRAPHICS_PORT_COMPLETED","SID_LABEL",MessageBoxButtons.OK);

			}
		}
		
		private void button19_Click(object sender, System.EventArgs e)
		{
			UOMTypeAnalysis frmUOMType = new UOMTypeAnalysis();
			frmUOMType.ShowDialog();
		}


		private void btnTunDBBrowse_Click(object sender, System.EventArgs e)
		{
			try
			{
				OpenFileDialog sfd = new OpenFileDialog();
				sfd.ShowDialog();
				txtTunDBPath.Text = sfd.FileName;

				string connectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + @txtTunDBPath.Text + @";User Id=Admin;";

				_connection = new OleDbConnection(connectionString);
				_connection.Open();
//				LRRMessagBox.ShowMessage("SID_SUCCESS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Error);
				//MessageBox.Show(tmpUpdQuery);
			}
			
			
		}

		private void btnManXLBrowse_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog sfd = new OpenFileDialog();
			sfd.ShowDialog();
			txtManualExcel.Text = sfd.FileName;
		}
	

		private void btnTunDBUpdate_Click(object sender, System.EventArgs e)
		{
			
			string[] sheets = Symcon.Utils.ExcelUtils.ExcelUtils.GetExcelSheetNames(@txtManualExcel.Text);
			
			string updateQuery = "Update HistorianDataSetData Set StartOfPeriodValue = '#',EndOfPeriodValue = '#',AverageValueForPeriodEntered = '#' Where DataSetID = '^' and HistTag = '$'";
			_command = new OleDbCommand();
			_command.Connection = _connection;

			LRRTuningConnections tunningconns = new LRRTuningConnections();

			
			int dscount;
//			int dscount1;
			ArrayList arrHistTags = new ArrayList();
			Hashtable htTimes = new Hashtable();
			string sqlquery2 = "Select distinct HistTag from HistorianDataSetData";
			_command.CommandText = sqlquery2;
			OleDbDataReader reader = _command.ExecuteReader();
			while(reader.Read())
			{
				arrHistTags.Add(reader[0].ToString());
			}

			reader.Close();
			string sqlquery1 = "Select StartTime + '|' + EndTime, ID from HistorianDataSets";
			_command.CommandText = sqlquery1;
			reader = _command.ExecuteReader();
			while(reader.Read())
			{
				htTimes.Add(reader[0].ToString(),reader[1].ToString());
			}

			reader.Close();
		for(int i = 0;i < sheets.Length;i++)
		{
				DataTable dt = Symcon.Utils.ExcelUtils.ExcelUtils.GetTable(sheets[i].Replace("$",""));

				lblprogress1.Text = dt.TableName;
				lblprogress1.Refresh();
			try
			{
				for(dscount = 1;dscount < dt.Rows.Count;dscount++)
				{
					string datasetExcel = null;
					string histtagExcel = null;
					string histTagValue = null;
						//= dt.Rows[dscount][0].ToString();
					string starttime = dt.Rows[dscount][1].ToString();
					string endtime = dt.Rows[dscount][2].ToString();
					
					//string sqlquery1 = "Select ID from HistorianDataSets where StartTime = '&' and EndTime = '@'";
					if((starttime != null && starttime != "") && (endtime != null && endtime != ""))
					{

						//					_app.DBManagerObj.PopulateObject(tunningconns,typeof(LRRTuningConnection)," where StartTime = " + starttime + " and EndTime = "+ " endtime ");   
						datasetExcel = htTimes[starttime + "|" + endtime] as string;

						if(datasetExcel != null && datasetExcel != "")
						{
							for(int histTagcount = 3;histTagcount < 236 ; histTagcount++)
							{
								histtagExcel = dt.Rows[0][histTagcount].ToString();
								histTagValue = dt.Rows[dscount][histTagcount].ToString();

								lblprogress.Text = histtagExcel;
								lblprogress.Refresh();

								//in the hist tag is not present then insert the same in the tuning db
								if(histtagExcel != null && histtagExcel != "")
								{
									if(!arrHistTags.Contains(histtagExcel))
									{
										string sqlquery3 = "Insert Into  HistorianDataSetData (ID,DataSetID,HistTag,StartOfPeriodValue,EndOfPeriodValue,SpotValue,AverageValueForPeriodEntered) values ('%','$','~',NULL,NULL,NULL,NULL)";
										sqlquery3 = sqlquery3.Replace("%",Guid.NewGuid().ToString());
										sqlquery3 = sqlquery3.Replace("$",datasetExcel);
										sqlquery3 = sqlquery3.Replace("~",histtagExcel);
										_command.CommandText = sqlquery3;
										try
										{
											_command.ExecuteNonQuery();
				
										}
										catch(Exception ex)
										{
											Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Error);
										}
								
									}
							
									string tmpUpdQuery = updateQuery;

									if(histTagValue != null && histTagValue != "")
									{
										tmpUpdQuery = tmpUpdQuery.Replace("#",histTagValue);
										tmpUpdQuery = tmpUpdQuery.Replace("^",datasetExcel);
										tmpUpdQuery = tmpUpdQuery.Replace("$",histtagExcel);
										_command.CommandText = tmpUpdQuery;
										try
										{
											_command.ExecuteNonQuery();
				
										}
										catch(Exception ex)
										{
											Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Error);
										}
										//									try
										//									{
										//										_command.ExecuteNonQuery();
										//
										//									}
										//									catch(Exception ex)
										//									{
										//										Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Error);
										//										//MessageBox.Show(tmpUpdQuery);
										//									}
									}
					
								}
														
							}
						}
					}

				}

			}
		catch(Exception ex)
		{
			Logger.LogMessage(typeof(ExecutionEngine),ex.Message  ,Logger.Level.Error);
		}
	}
			
			lblprogress1.Text = "";
			lblprogress1.Refresh();
			lblprogress.Text = " Completed ";
			lblprogress.Refresh();
//			_connection.Close();
//			reader.Close();

		}
	}
}
