using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;
using System.IO;

using Symcon.Utils.ExcelUtils;
using Symcon.Utils.XMLUtils;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Tools;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using System.Reflection;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ExcelMapping.
	/// </summary>
	public class ExcelMapping : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlOperation;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button btnMap;
		private System.Windows.Forms.Button btnBrows;
		private System.Windows.Forms.Label lblSelectItem;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel pmlExcelfields;
		private System.Windows.Forms.TextBox txtFile;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControlExcelFields;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Label lblPk;

		private ArrayList arrTargetDataSource = new ArrayList();

		private DataTable excelTable = new DataTable();
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Label lblSheets;
		private System.Windows.Forms.ComboBox cmbSheets;

		LRRImportInfos _lrrImports = null;

		string parentID = "";
		string childField = null;
		string[] ckExcel = {""};
		string[] ckTarget = {""};

		ArrayList arrDuplicates = new ArrayList();
		ArrayList arrExcelDuplicates = new ArrayList();
		private System.Windows.Forms.Label lblExcelDuplicates;
		private System.Windows.Forms.Label lblPKduplicates;
		private System.Windows.Forms.Label lblTargetPK;
		Hashtable htExcelDuplicates = new Hashtable();
		Hashtable htMapping = new Hashtable();
		bool isSaved = false;
		bool isTargetProperty = false;
		private System.Windows.Forms.ListBox listTargetCK;

		private System.Windows.Forms.ListBox listSourceCK;
		private System.Windows.Forms.ImageList imageList1;
		Hashtable htMapTarget = new Hashtable();
		Hashtable hashSourceData;

		Hashtable referencedColumns = new Hashtable();
		public ExcelMapping()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			//this.listTargetCK.SelectedValueChanged+=new EventHandler(listTargetCK_SelectedValueChanged);  

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public ExcelMapping(ArrayList arrDataSource)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);  
			arrTargetDataSource = arrDataSource;
			mandatoryHash = new Hashtable();

		}

		public ExcelMapping(ArrayList arrDataSource,string parentID,string childField)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);  
            arrTargetDataSource = arrDataSource;
			mandatoryHash = new Hashtable();
			this.parentID = parentID;
			this.childField = childField;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ExcelMapping));
			this.pnlOperation = new System.Windows.Forms.Panel();
			this.lblPKduplicates = new System.Windows.Forms.Label();
			this.lblExcelDuplicates = new System.Windows.Forms.Label();
			this.btnSave = new System.Windows.Forms.Button();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.btnClose = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.txtFile = new System.Windows.Forms.TextBox();
			this.btnMap = new System.Windows.Forms.Button();
			this.btnBrows = new System.Windows.Forms.Button();
			this.lblSelectItem = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.listSourceCK = new System.Windows.Forms.ListBox();
			this.listTargetCK = new System.Windows.Forms.ListBox();
			this.lblTargetPK = new System.Windows.Forms.Label();
			this.cmbSheets = new System.Windows.Forms.ComboBox();
			this.lblSheets = new System.Windows.Forms.Label();
			this.lblPk = new System.Windows.Forms.Label();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pmlExcelfields = new System.Windows.Forms.Panel();
			this.gridGroupingControlExcelFields = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlOperation.SuspendLayout();
			this.panel1.SuspendLayout();
			this.pmlExcelfields.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControlExcelFields)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlOperation
			// 
			this.pnlOperation.Controls.Add(this.lblPKduplicates);
			this.pnlOperation.Controls.Add(this.lblExcelDuplicates);
			this.pnlOperation.Controls.Add(this.btnSave);
			this.pnlOperation.Controls.Add(this.btnClose);
			this.pnlOperation.Controls.Add(this.button2);
			this.pnlOperation.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlOperation.Location = new System.Drawing.Point(0, 408);
			this.pnlOperation.Name = "pnlOperation";
			this.pnlOperation.Size = new System.Drawing.Size(522, 40);
			this.pnlOperation.TabIndex = 19;
			// 
			// lblPKduplicates
			// 
			this.lblPKduplicates.Location = new System.Drawing.Point(160, 8);
			this.lblPKduplicates.Name = "lblPKduplicates";
			this.lblPKduplicates.Size = new System.Drawing.Size(112, 23);
			this.lblPKduplicates.TabIndex = 16;
			this.lblPKduplicates.Tag = "SID_PKDUPLICATES";
			// 
			// lblExcelDuplicates
			// 
			this.lblExcelDuplicates.Location = new System.Drawing.Point(16, 8);
			this.lblExcelDuplicates.Name = "lblExcelDuplicates";
			this.lblExcelDuplicates.Size = new System.Drawing.Size(128, 23);
			this.lblExcelDuplicates.TabIndex = 15;
			this.lblExcelDuplicates.Tag = "SID_EXCELDUPLICATES";
			// 
			// btnSave
			// 
			this.btnSave.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSave.Enabled = false;
			this.btnSave.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnSave.ImageIndex = 3;
			this.btnSave.ImageList = this.imageList1;
			this.btnSave.Location = new System.Drawing.Point(360, 8);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(71, 24);
			this.btnSave.TabIndex = 14;
			this.btnSave.Tag = "SID_UPLOAD";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// btnClose
			// 
			this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnClose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnClose.ImageIndex = 4;
			this.btnClose.ImageList = this.imageList1;
			this.btnClose.Location = new System.Drawing.Point(440, 8);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(72, 24);
			this.btnClose.TabIndex = 13;
			this.btnClose.Tag = "SID_CLOS";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// button2
			// 
			this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.button2.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.button2.ImageIndex = 2;
			this.button2.ImageList = this.imageList1;
			this.button2.Location = new System.Drawing.Point(280, 8);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(72, 24);
			this.button2.TabIndex = 12;
			this.button2.Tag = "SID_FILTER";
			this.button2.Visible = false;
			// 
			// txtFile
			// 
			this.txtFile.Location = new System.Drawing.Point(176, 8);
			this.txtFile.Name = "txtFile";
			this.txtFile.Size = new System.Drawing.Size(176, 20);
			this.txtFile.TabIndex = 16;
			this.txtFile.Text = "";
			// 
			// btnMap
			// 
			this.btnMap.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnMap.ImageIndex = 1;
			this.btnMap.ImageList = this.imageList1;
			this.btnMap.Location = new System.Drawing.Point(440, 8);
			this.btnMap.Name = "btnMap";
			this.btnMap.Size = new System.Drawing.Size(72, 24);
			this.btnMap.TabIndex = 17;
			this.btnMap.Tag = "SID_ANALYSE";
			this.btnMap.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnMap.Click += new System.EventHandler(this.btnMap_Click);
			// 
			// btnBrows
			// 
			this.btnBrows.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnBrows.ImageIndex = 0;
			this.btnBrows.ImageList = this.imageList1;
			this.btnBrows.Location = new System.Drawing.Point(360, 8);
			this.btnBrows.Name = "btnBrows";
			this.btnBrows.Size = new System.Drawing.Size(72, 24);
			this.btnBrows.TabIndex = 16;
			this.btnBrows.Tag = "SID_BROWSE";
			this.btnBrows.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnBrows.Click += new System.EventHandler(this.btnBrows_Click);
			// 
			// lblSelectItem
			// 
			this.lblSelectItem.ForeColor = System.Drawing.Color.Black;
			this.lblSelectItem.Location = new System.Drawing.Point(8, 10);
			this.lblSelectItem.Name = "lblSelectItem";
			this.lblSelectItem.Size = new System.Drawing.Size(168, 23);
			this.lblSelectItem.TabIndex = 15;
			this.lblSelectItem.Tag = "SID_SELECTEXCELTOIMPORT";
			this.lblSelectItem.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.listSourceCK);
			this.panel1.Controls.Add(this.listTargetCK);
			this.panel1.Controls.Add(this.lblTargetPK);
			this.panel1.Controls.Add(this.cmbSheets);
			this.panel1.Controls.Add(this.lblSheets);
			this.panel1.Controls.Add(this.lblSelectItem);
			this.panel1.Controls.Add(this.txtFile);
			this.panel1.Controls.Add(this.btnBrows);
			this.panel1.Controls.Add(this.btnMap);
			this.panel1.Controls.Add(this.lblPk);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(522, 112);
			this.panel1.TabIndex = 18;
			// 
			// listSourceCK
			// 
			this.listSourceCK.Location = new System.Drawing.Point(88, 48);
			this.listSourceCK.Name = "listSourceCK";
			this.listSourceCK.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple;
			this.listSourceCK.Size = new System.Drawing.Size(80, 56);
			this.listSourceCK.TabIndex = 41;
			this.listSourceCK.SelectedValueChanged += new System.EventHandler(this.listSourceCK_SelectedValueChanged);
			this.listSourceCK.Click+=new EventHandler(listSourceCK_Click);  
			// 
			// listTargetCK
			// 
			this.listTargetCK.Location = new System.Drawing.Point(272, 48);
			this.listTargetCK.Name = "listTargetCK";
			this.listTargetCK.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple;
			this.listTargetCK.Size = new System.Drawing.Size(80, 56);
			this.listTargetCK.TabIndex = 40;
			this.listTargetCK.SelectedValueChanged += new System.EventHandler(this.listTargetCK_SelectedValueChanged);
			this.listTargetCK.Click +=new EventHandler(listTargetCK_Click); 
			// 
			// lblTargetPK
			// 
			this.lblTargetPK.Location = new System.Drawing.Point(176, 48);
			this.lblTargetPK.Name = "lblTargetPK";
			this.lblTargetPK.Size = new System.Drawing.Size(96, 32);
			this.lblTargetPK.TabIndex = 39;
			this.lblTargetPK.Tag = "SID_TARGETCK";
			// 
			// cmbSheets
			// 
			this.cmbSheets.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbSheets.Location = new System.Drawing.Point(408, 48);
			this.cmbSheets.Name = "cmbSheets";
			this.cmbSheets.Size = new System.Drawing.Size(104, 21);
			this.cmbSheets.TabIndex = 38;
			this.cmbSheets.SelectedValueChanged += new System.EventHandler(this.cmbSheets_SelectedValueChanged);
			this.cmbSheets.SelectedIndexChanged += new System.EventHandler(this.cmbSheets_SelectedIndexChanged);
			// 
			// lblSheets
			// 
			this.lblSheets.Location = new System.Drawing.Point(360, 48);
			this.lblSheets.Name = "lblSheets";
			this.lblSheets.Size = new System.Drawing.Size(48, 16);
			this.lblSheets.TabIndex = 37;
			this.lblSheets.Tag = "SID_SHEETS";
			// 
			// lblPk
			// 
			this.lblPk.ForeColor = System.Drawing.Color.Black;
			this.lblPk.Location = new System.Drawing.Point(8, 48);
			this.lblPk.Name = "lblPk";
			this.lblPk.Size = new System.Drawing.Size(72, 32);
			this.lblPk.TabIndex = 35;
			this.lblPk.Tag = "SID_SELECTEXCELCK";
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(0, 112);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 296);
			this.splitter1.TabIndex = 21;
			this.splitter1.TabStop = false;
			// 
			// pmlExcelfields
			// 
			this.pmlExcelfields.Controls.Add(this.gridGroupingControlExcelFields);
			this.pmlExcelfields.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pmlExcelfields.Location = new System.Drawing.Point(3, 112);
			this.pmlExcelfields.Name = "pmlExcelfields";
			this.pmlExcelfields.Size = new System.Drawing.Size(519, 296);
			this.pmlExcelfields.TabIndex = 25;
			// 
			// gridGroupingControlExcelFields
			// 
			this.gridGroupingControlExcelFields.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridGroupingControlExcelFields.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridGroupingControlExcelFields.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControlExcelFields.Location = new System.Drawing.Point(0, 0);
			this.gridGroupingControlExcelFields.Name = "gridGroupingControlExcelFields";
			this.gridGroupingControlExcelFields.Size = new System.Drawing.Size(520, 296);
			this.gridGroupingControlExcelFields.TabIndex = 34;
			this.gridGroupingControlExcelFields.TableDescriptor.AllowNew = false;
			this.gridGroupingControlExcelFields.TableDescriptor.AllowRemove = false;
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.GroupCaptionCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.GroupCaptionCell.TextMargins.Left = 2;
			this.gridGroupingControlExcelFields.TableDescriptor.Appearance.GroupCaptionCell.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Middle;
			this.gridGroupingControlExcelFields.TableOptions.CaptionRowHeight = 20;
			this.gridGroupingControlExcelFields.TableOptions.ColumnHeaderRowHeight = 30;
			this.gridGroupingControlExcelFields.Text = "gridGroupingControl1";
			this.gridGroupingControlExcelFields.ThemesEnabled = false;
			this.gridGroupingControlExcelFields.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_EXCEL_FILE") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS"); 
			this.gridGroupingControlExcelFields.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridGroupingControlExcelFields.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridGroupingControlExcelFields.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridGroupingControlExcelFields.VersionInfo = "3.301.0.0";
			this.gridGroupingControlExcelFields.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridGroupingControlExcelFields_QueryCellStyleInfo);
			// 
			// ExcelMapping
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnClose;
			this.ClientSize = new System.Drawing.Size(522, 448);
			this.Controls.Add(this.pmlExcelfields);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.pnlOperation);
			this.Controls.Add(this.panel1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "ExcelMapping";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_EXCELMAPTODATAHISTORIAN";
			this.pnlOperation.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.pmlExcelfields.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControlExcelFields)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		private Hashtable mandatoryHash;

		private void btnBrows_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog flDialog = new OpenFileDialog();
			flDialog.Filter ="Excel files | *.xls";

			if(flDialog.ShowDialog() == DialogResult.OK)
			{
				if(flDialog.FileName != null && flDialog.CheckFileExists == true)
				{
					txtFile.Text = flDialog.FileName;
					string[] sheetnames = ExcelUtils.GetExcelSheetNames(txtFile.Text);
					if(sheetnames == null)
						return;
					this.cmbSheets.Items.Clear();
					this.cmbSheets.Items.AddRange(sheetnames);
					
					if(sheetnames.Length > -1)
						this.cmbSheets.SelectedIndex = 0;
				}
				btnSave.Enabled = false;
				lblPKduplicates.Text = "PK Duplicates:";
				lblExcelDuplicates.Text = "Excel Duplicates:";
			}
		}

		public void BindToGrid(DataTable excelTable)
		{
			ArrayList arrTargetGridDataSource = new ArrayList();
			ArrayList arrSourceGridDataSource = new ArrayList();
					
			referencedColumns.Clear();
			hashSourceData = new Hashtable();
					
			//LoadMapSettings();
			if(excelTable.Rows.Count == 0)
			{
				LRRMessagBox.ShowMessage("SID_EXCELSHEET_EMPTY","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);  
				gridGroupingControlExcelFields.DataSource = null;
				return;
			}
			for(int j=0; j < arrTargetDataSource.Count; j++)
			{
				CustomCollection targetCollection = (CustomCollection)arrTargetDataSource[j];
				
				PropertyInfo[] props = targetCollection.ItemType.GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly| BindingFlags.Public);
				
				for(int k =0; k< props.Length; k++)
				{
					PropertyInfo prop = props[k];
					//Check for foreign field
					SymForeignKeyFieldAttribute[] fkField = (SymForeignKeyFieldAttribute[])
						prop.GetCustomAttributes(typeof(SymForeignKeyFieldAttribute),
						false);
					if(fkField.Length > 0)
					{
						//referencedColumns
						SymForeignKeyFieldAttribute sFKeyFA = fkField[0];
						referencedColumns.Add(prop.Name,sFKeyFA);
					}
					SymDataFieldAttribute[] field = (SymDataFieldAttribute[])
						prop.GetCustomAttributes(typeof(SymDataFieldAttribute),
						false);
					if (field.Length > 0)
					{
						SymDataFieldAttribute sDFA = field[0];
						if(sDFA.IsVisible)
						{
							arrTargetGridDataSource.Add(/*prop.Name*/LRRHeaderText.GetHeaderString(sDFA.DisplayName));
							if(sDFA.IsMandatory)
							{
								if(!mandatoryHash.Contains(LRRHeaderText.GetHeaderString(sDFA.DisplayName)))
                                	mandatoryHash.Add(LRRHeaderText.GetHeaderString(sDFA.DisplayName),prop.Name); 
							}
							if(LRRHeaderText.GetHeaderString(sDFA.DisplayName) != "")
							{
								if(!hashSourceData.ContainsKey(LRRHeaderText.GetHeaderString(sDFA.DisplayName)))  
									hashSourceData.Add(LRRHeaderText.GetHeaderString(sDFA.DisplayName),prop.Name);
							}
						}
					}
				}
			}
			LoadMapSettings();
			DataColumnCollection excelColumns = excelTable.Columns;

			this.listTargetCK.DataSource = arrTargetGridDataSource;

			for(int i=0;i<this.listTargetCK.Items.Count;i++)
			{
				string propName = this.listTargetCK.Items[i].ToString();
				if(mandatoryHash.ContainsKey(propName))
				{
					this.listTargetCK.SetSelected(i,true);
				}
			}
			_lrrImports = new LRRImportInfos();
			for(int i=0; i < excelTable.Columns.Count; i++)
			{
				LRRImportInfo lrrImport = new LRRImportInfo();
				lrrImport.SourceColumn = excelColumns[i].ToString();
				lrrImport.SourceColumnDataType = excelColumns[i].DataType;
				if(htMapTarget.Contains(lrrImport.SourceColumn))
					lrrImport.TargetProperty = htMapTarget[lrrImport.SourceColumn] as string;
				else
					lrrImport.TargetProperty = "";
				lrrImport.IsPersistent = true;
				lrrImport.IsDirty = false;
				lrrImport.ObjectState = Symcon.Globals.Enums.DBOperation.UNCHANGED;
				_lrrImports.Add(lrrImport);
				arrSourceGridDataSource.Add(excelColumns[i].ToString());
				// Code for mapping
			}
			
			this.listSourceCK.DataSource = arrSourceGridDataSource;
			for(int i=0;i<this.listSourceCK.Items.Count;i++)
			{
				string propName = this.listSourceCK.Items[i].ToString();
				if(mandatoryHash.ContainsKey(propName))
				{
					this.listSourceCK.SetSelected(i,true);
				}
			}

			gridGroupingControlExcelFields.DataSource = _lrrImports;

			gridGroupingControlExcelFields.TableDescriptor.Columns.Clear();

			gridGroupingControlExcelFields.TableDescriptor.Columns.Add("SourceColumn");
			gridGroupingControlExcelFields.TableDescriptor.Columns.Add("TargetProperty");
			
			gridGroupingControlExcelFields.TableDescriptor.Columns[0].Width=(gridGroupingControlExcelFields.Width/2) - 10;
			gridGroupingControlExcelFields.TableDescriptor.Columns[1].Width=(gridGroupingControlExcelFields.Width/2) - 10;

			GridTableCellStyleInfo gts1 = gridGroupingControlExcelFields.TableDescriptor.Columns["SourceColumn"].Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gts1.ReadOnly = true;

			GridTableCellStyleInfo gts = gridGroupingControlExcelFields.TableDescriptor.Columns["TargetProperty"].Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gts.CellType = "ComboBox";
			gts.DataSource = arrTargetGridDataSource;
		}

		private void LoadMapSettings()
		{
			ExcelMap mapSetting = new ExcelMap();
			bool check = false;
			int checkCount=0;
			int instanceCount = -1;
			string sMapSettingsPath = Application.StartupPath + @"\config\MapSettings.xml";
			if(System.IO.File.Exists(sMapSettingsPath))
			{
				mapSetting = SGTXmlSerializer.DeserializeXML(sMapSettingsPath,typeof(ExcelMap)) as ExcelMap;
				if(mapSetting == null)
					return;
				instanceCount=0;
				
				for(int j=0;j< mapSetting.mapInstance.Length;j++,instanceCount++)
				{
					if(!mapSetting.mapInstance[j].EntryName.Equals(this.arrTargetDataSource[0].ToString()))
					{
						check = false;
						continue;
					}
					else
					{
						checkCount=0;
						for(int k=0;k<this.excelTable.Columns.Count;k++)
						{
							for(int i=0;i<mapSetting.mapInstance[j].EntryColumns.Length;i++)
							{
								if(this.excelTable.Columns[k].Caption.Equals(mapSetting.mapInstance[j].EntryColumns[i].Source))
								{
									checkCount++;
								}
							}
						}
						if(checkCount>0)
						{
							check=true;
							break;
						}
					}
				}
				if(check==true)
				{
					for(int i=0;i<mapSetting.mapInstance[instanceCount].EntryColumns.Length;i++)
					{
						if(!htMapTarget.ContainsKey(mapSetting.mapInstance[instanceCount].EntryColumns[i].Source))
						{
							string target = mapSetting.mapInstance[instanceCount].EntryColumns[i].Target;
							target = GetTargetValue(target);
							target = target == null ? "" : target.ToString();
							htMapTarget.Add(mapSetting.mapInstance[instanceCount].EntryColumns[i].Source,target);//mapSetting.mapInstance[instanceCount].EntryColumns[i].Target);
							htMapping.Add(mapSetting.mapInstance[instanceCount].EntryColumns[i].Source,target);//mapSetting.mapInstance[instanceCount].EntryColumns[i].Target);
						}
					}
				}
			}
		}

		private string GetTargetValue(string targetVal)
		{
			IDictionaryEnumerator iDictEnum = hashSourceData.GetEnumerator();
			while(iDictEnum.MoveNext())
			{
				string propertyName = (string)iDictEnum.Value;
				string displayName = (string)iDictEnum.Key;
				if(propertyName == displayName)
				{
					if(targetVal == propertyName)
						return targetVal;
				}
				else
				{
					if(targetVal == propertyName)
					{
						return displayName;
					}
					else if(targetVal == displayName)
						return displayName;
				}
			}
			return null;
		}

		private void SaveMapSettings()
		{
			if(isSaved)
			{
				ExcelMap mapSetting = new ExcelMap();
				ExcelMap mapSetting2 = new ExcelMap();
				bool check = false;
				int instanceCount = -1;
				int icount = 0;
				ICollection ic = htMapping.Keys;
				IEnumerator ie = ic.GetEnumerator();
				bool ieEmpty = true;
				while(ie.MoveNext())
				{
					icount++;
					ieEmpty=false;
				}
				if(ieEmpty)
					return;

				string sMapSettingsPath = Application.StartupPath + @"\config\MapSettings.xml";

				if(System.IO.File.Exists(sMapSettingsPath))
				{
					mapSetting = SGTXmlSerializer.DeserializeXML(sMapSettingsPath,typeof(ExcelMap)) as ExcelMap;
					if(mapSetting == null)
						return;
					instanceCount=0;
					for(int j=0;j< mapSetting.mapInstance.Length;j++,instanceCount++)
					{
						if(!mapSetting.mapInstance[j].EntryName.Equals(this.arrTargetDataSource[0].ToString()))
						{
							check = false;
							continue;
						}
						else
						{
							check=true;
							break;	
						}
					}
					
					if(check==true)
					{
						ie.Reset();
						int j=0;
						Entry mapControl = new Entry();
						mapControl.EntryName = arrTargetDataSource[0].ToString();
						mapControl.EntryColumns = new nColumns[icount];
						while(ie.MoveNext())
						{
							string key = ie.Current as string;
							string val = htMapping[key] as string;
							nColumns col = new nColumns();
							col.Source = key;
							col.Target = val;
							mapControl.EntryColumns[j]=col;
							j++;
						}
						mapSetting.mapInstance[instanceCount] = mapControl;
						System.IO.File.Delete(sMapSettingsPath);
						SGTXmlSerializer.SerializeAsXML(sMapSettingsPath,typeof(ExcelMap),mapSetting);
					}
					else
					{
						instanceCount = mapSetting.mapInstance.Length;
						ie.Reset();
						int j=0;
							
						Entry mapControl = new Entry();
						mapControl.EntryName = arrTargetDataSource[0].ToString();
						mapControl.EntryColumns = new nColumns[icount];
						while(ie.MoveNext())
						{
							string key = ie.Current as string;
							string val = htMapping[key] as string;
							nColumns col = new nColumns();
							col.Source = key;
							col.Target = val;
							mapControl.EntryColumns[j]=col;
							j++;
						}
						mapSetting2.mapInstance = new Entry[mapSetting.mapInstance.Length + 1];
						mapSetting.mapInstance.CopyTo(mapSetting2.mapInstance,0);
						mapSetting2.mapInstance[mapSetting.mapInstance.Length] = mapControl;
						System.IO.File.Delete(sMapSettingsPath);
						SGTXmlSerializer.SerializeAsXML(sMapSettingsPath,typeof(ExcelMap),mapSetting2);
					}
				}
				else
				{
					mapSetting.mapInstance = new Entry[1];
					Entry mapControl = new Entry();
					mapControl.EntryName = arrTargetDataSource[0].ToString();
					mapControl.EntryColumns = new nColumns[icount];
					ie.Reset();
					int j=0;
					while(ie.MoveNext())
					{
						string key = ie.Current as string;
						string val = htMapping[key] as string;
						nColumns col = new nColumns();
						col.Source = key;
						col.Target = val;
						mapControl.EntryColumns[j]=col;
						j++;
					}
					mapSetting.mapInstance[0] = mapControl;
					System.IO.File.Delete(sMapSettingsPath);
					SGTXmlSerializer.SerializeAsXML(sMapSettingsPath,typeof(ExcelMap),mapSetting);
				}
			}
		}

		private void btnMap_Click(object sender, System.EventArgs e)
		{
			if(this.listSourceCK.SelectedItems.Count == this.listTargetCK.SelectedItems.Count && this.listSourceCK.SelectedItems.Count>0)
			{
				Hashtable htGridValue = new Hashtable();
				ArrayList arrExcel = new ArrayList();
				Type[] targetPropertyDataType = new Type[this.listSourceCK.SelectedItems.Count];
				ckExcel = new string[this.listSourceCK.SelectedItems.Count];
				ckTarget = new string[this.listTargetCK.SelectedItems.Count];
				for(int i=0;i<this.listTargetCK.SelectedItems.Count;i++)
				{
					ckExcel[i] = this.listSourceCK.SelectedItems[i].ToString();
					ckTarget[i] = hashSourceData[this.listTargetCK.SelectedItems[i].ToString()].ToString();
					//ckTarget[i] = this.listTargetCK.SelectedItems[i].ToString();
					targetPropertyDataType[i] = null;
				}

				arrExcelDuplicates.Clear();
				arrDuplicates.Clear();
				htExcelDuplicates.Clear();

				for(int j=0; j < arrTargetDataSource.Count; j++)
				{
					CustomCollection targetCollection = (CustomCollection)arrTargetDataSource[j];
					PropertyInfo[] props = targetCollection.ItemType.GetProperties();

					for(int l=0; l < targetCollection.Count; l++)
					{
						string sGridValue = "";
						for(int i=0;i<this.listTargetCK.SelectedItems.Count;i++)
						{
							//Get the target column
							string targetColumn = ckTarget[i];
							object colValue = targetCollection[l].GetType().GetProperty(ckTarget[i]).GetValue(targetCollection[l],null);
							//Check for foreign key
							if(referencedColumns.ContainsKey(targetColumn))
							{
								SymForeignKeyFieldAttribute sFKeyFld = (SymForeignKeyFieldAttribute)referencedColumns[targetColumn];
								object collectionObj  = Symcon.LightRidge.PEAdvisor.DataStore.LRRDataStore.GetDataStoreObjectCopy(sFKeyFld.CollectionType);
								string displayMember = sFKeyFld.DisplayMemeber;
								string valueMember = sFKeyFld.ValueMemeber;
								colValue = GetName(collectionObj,displayMember,valueMember,colValue);
							}

							if(colValue != null)
								sGridValue += colValue.ToString() + "|";
							else
								sGridValue += "|";
							targetPropertyDataType[i] = targetCollection[l].GetType().GetProperty(ckTarget[i]).PropertyType;
						}
						object gridValue = sGridValue;
						
						if(!(gridValue == null || htGridValue.Contains(gridValue)))
						{
							//Check if record belongs to selected child grid
							if(childField != null)
							{
								object obj = targetCollection[l];
								string parentField = obj.GetType().GetProperty(childField).GetValue(obj,null) == null ? "" : obj.GetType().GetProperty(childField).GetValue(obj,null).ToString();
								if(parentField == parentID)
									htGridValue.Add(gridValue,targetCollection[l]);
							}
							else
							{
								htGridValue.Add(gridValue,targetCollection[l]);
							}
						}
					}
						
			
					for(int k=0; k < excelTable.Rows.Count; k++)
					{
						Type[] sourceType = new Type[ckExcel.Length];
						string sColValue = "";
						bool isKeyColEmpty = false;
						for(int i=0;i<ckExcel.Length;i++)
						{
							sourceType[i] = excelTable.Columns[ckExcel[i]].DataType;
							sColValue += SymExcelConverter.Convert(sourceType[i],excelTable.Rows[k][ckExcel[i]],targetPropertyDataType[i])== null ? "" :SymExcelConverter.Convert(sourceType[i],excelTable.Rows[k][ckExcel[i]],targetPropertyDataType[i]).ToString() + "|";

							object objExcelData = excelTable.Rows[k][ckExcel[i]];
							if(objExcelData == null || objExcelData.ToString() == "")
								isKeyColEmpty = true;
							
						}
						if(isKeyColEmpty)
							Symcon.Utils.MessageLogger.Logger.LogMessage(this.GetType(),"Blank key found for workbook: " + txtFile.Text + " Sheet: " + cmbSheets.SelectedText + " at Row: " + k,Symcon.Utils.MessageLogger.Logger.Level.Debug);
						
						object colValue = sColValue;

						if(colValue != null && htGridValue.ContainsKey(colValue))
						{
							arrDuplicates.Add(excelTable.Rows[k]);
						}

						string sArrExcelTableRow = "";
						for(int i=0;i<ckExcel.Length;i++)
						{
							sArrExcelTableRow += excelTable.Rows[k][ckExcel[i]] + "|";
						}
						if(arrExcel.Contains(sArrExcelTableRow))
						{
							int l = (int)htExcelDuplicates[sArrExcelTableRow];
							if(!arrExcelDuplicates.Contains(excelTable.Rows[l]))
								arrExcelDuplicates.Add(excelTable.Rows[l]);
							arrExcelDuplicates.Add(excelTable.Rows[k]);
						}
						else
						{
							arrExcel.Add(sArrExcelTableRow);
							htExcelDuplicates.Add(sArrExcelTableRow,k);
						}
					}
			
					if(arrDuplicates.Count > 0)
					{
						string sRecord = "";
						if(this.ckExcel.Length==1)
							Logger.LogMessage("Primary Key Duplicates:-",Logger.Level.Debug);
						else
							Logger.LogMessage("Composite Key Duplicates:-",Logger.Level.Debug);
						for(int n=0; n < arrDuplicates.Count;n++)
						{
							sRecord = "";
							DataRow row = arrDuplicates[n] as DataRow;
							object[] rowArray = row.ItemArray;
							int i = rowArray.Length - 1;
							j = 0;
							while(j <= i)
							{
								sRecord = sRecord + rowArray[j].ToString() + "|";
								j++;
							}
							Logger.LogMessage(sRecord,Logger.Level.Debug);
						}
						if(this.ckExcel.Length==1)
							LRRMessagBox.ShowMessage(this,"SID_PK_DUPLICATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						else
							LRRMessagBox.ShowMessage(this,"SID_CK_DUPLICATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
					}

					if(arrExcelDuplicates.Count > 0)
					{
						string sRecord = "";
						Logger.LogMessage("Excel Duplicates:-",Logger.Level.Debug);
						for(int n=0; n < arrExcelDuplicates.Count;n++)
						{
							sRecord = "";
							DataRow row = arrExcelDuplicates[n] as DataRow;
							object[] rowArray = row.ItemArray;
							int i = rowArray.Length - 1;
							j = 0;
							while(j <= i)
							{
								sRecord = sRecord + rowArray[j].ToString() + "|";
								j++;
							}
							Logger.LogMessage(sRecord,Logger.Level.Debug);
						}
						LRRMessagBox.ShowMessage(this,"SID_EXCEL_DUPLICATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
					}
			
					if(arrDuplicates.Count == 0 && arrExcelDuplicates.Count == 0)
					{
						LRRMessagBox.ShowMessage(this,"SID__ANALYSIS_DONE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
						Logger.LogMessage("Analysis done successfully",Logger.Level.Debug);
					}
					btnSave.Enabled = true;
					lblPKduplicates.Text = "PK Duplicates:"+ arrDuplicates.Count;
					lblExcelDuplicates.Text = "Excel Duplicates:" + arrExcelDuplicates.Count;
				}
			}
			else
				if(this.listSourceCK.Items.Count == 0 && this.listTargetCK.Items.Count == 0)
				{
					return;
				}
				else
				{
					if(this.listSourceCK.SelectedItems.Count==0 && this.listTargetCK.SelectedItems.Count==0)
						LRRMessagBox.ShowMessage("SID_SELECT_CK","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					else
						LRRMessagBox.ShowMessage("SID_EXCELCK_TARGETCK_SELECTION","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				}
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			LRRImportInfos lrrchanges = _lrrImports;
			for(int j =0; j < arrTargetDataSource.Count; j++)
			{
				CustomCollection cc = arrTargetDataSource[j] as CustomCollection;

				for(int i=0; i < excelTable.Rows.Count; i++)
				{
					bool flag = false;
					int checkCount = 0;
					for(int k=0;k < arrExcelDuplicates.Count;k++)
					{
						DataRow excelRow = arrExcelDuplicates[k] as DataRow;
						for(int m=0;m<ckExcel.Length;m++)
						{
							if(excelTable.Rows[i][ckExcel[m]] == excelRow[ckExcel[m]])
							{
								checkCount++;
							}
						}
						if(checkCount==ckExcel.Length)
						{
							flag = true;
							break;
						}
					}
					checkCount=0;
					for(int l=0;l < arrDuplicates.Count;l++)
					{
						DataRow excelRow2 = arrDuplicates[l] as DataRow;
						for(int m=0;m<ckExcel.Length;m++)
						{
							if(excelTable.Rows[i][ckExcel[m]] == excelRow2[ckExcel[m]])
							{
								checkCount++;
							}
						}
						if(checkCount==ckExcel.Length)
						{
							flag = true;
							break;
						}
					}

					if(flag)
						continue;

					object obj = Activator.CreateInstance(cc.ItemType);
					foreach(LRRImportInfo lrrImp in lrrchanges)
					{
						Type sourceType = lrrImp.SourceColumnDataType;
						if(mandatoryHash.Contains(lrrImp.SourceColumn.ToString()))
						{	
							if(lrrImp.TargetProperty == "")
							{
								LRRMessagBox.ShowMessage("SID_MENDATORY_FIELDS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
								return;
							}
						}
						if(lrrImp.TargetProperty != "")
						{
							if(obj.GetType().GetProperty(hashSourceData[lrrImp.TargetProperty].ToString())!=null)
							{
								Type targetPropertyDataType = obj.GetType().GetProperty(hashSourceData[lrrImp.TargetProperty].ToString()).PropertyType;
								if(!htMapping.ContainsKey(lrrImp.SourceColumn))
									htMapping.Add(lrrImp.SourceColumn,lrrImp.TargetProperty);
								else
									htMapping[lrrImp.SourceColumn]=lrrImp.TargetProperty;
								object colValue = SymExcelConverter.Convert(sourceType,excelTable.Rows[i][lrrImp.SourceColumn],targetPropertyDataType);
								if(colValue != DBNull.Value)
								{
								
									//Check for foreign key
									if(referencedColumns.ContainsKey(hashSourceData[lrrImp.TargetProperty].ToString()))
									{
										SymForeignKeyFieldAttribute sFKeyFld = (SymForeignKeyFieldAttribute)referencedColumns[hashSourceData[lrrImp.TargetProperty].ToString()];
										object collectionObj  = Symcon.LightRidge.PEAdvisor.DataStore.LRRDataStore.GetDataStoreObjectCopy(sFKeyFld.CollectionType);
										string displayMember = sFKeyFld.DisplayMemeber;
										string valueMember = sFKeyFld.ValueMemeber;
										colValue = GetValue(collectionObj,displayMember,valueMember,colValue);

									}
									obj.GetType().GetProperty(hashSourceData[lrrImp.TargetProperty].ToString()).SetValue(obj,colValue,null);
								}
								isTargetProperty = true;
							}
						}
//						
					}
					/*MethodInfo miSelectedState =  obj.GetType().GetMethod("SetSelectedState");
					if(miSelectedState != null)
					{
						object[] parameters = new object[0];
						miSelectedState.Invoke(obj,parameters);
					}*/
					if(childField != null)
						obj.GetType().GetProperty(childField).SetValue(obj,parentID,null);
					if(isTargetProperty)
					{
						cc.Add(obj);
					}
					else
					{
						LRRMessagBox.ShowMessage("SID_SELECTTARGETPROPERTY","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}
//					obj.GetType().GetProperty("ObjectState").SetValue(obj,Symcon.Globals.Enums.DBOperation.INSERT,null);
//					obj.GetType().GetProperty("IsPersistent").SetValue(obj,true,null);
//					obj.GetType().GetProperty("IsDirty").SetValue(obj,false,null);
//					obj.GetType().GetProperty("IsNewFlag").SetValue(obj,false,null);

				}
			}
			//MessageBox.Show("Import completed successfully");
			LRRMessagBox.ShowMessage("SID_IMPORTCOMPLATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
			isSaved = true;
			btnSave.Enabled = false;
		}
		
		private object GetValue(object collectionObj,string displayMember,string valueMember,object colValue)
		{
			CustomCollection custCollection = collectionObj as CustomCollection;
			IEnumerator iEnum = custCollection.GetEnumerator();
			while(iEnum.MoveNext())
			{
				BaseObject obj = iEnum.Current as BaseObject;
				object objValue = obj.GetType().GetProperty(displayMember).GetValue(obj,null);
				if(objValue != null)
				{
					string sValue = objValue.ToString();
					if(sValue == colValue.ToString())
					{
						object objColValue = obj.GetType().GetProperty(valueMember).GetValue(obj,null);
						return objColValue;
					}
				}
			}
			return null;
		}

		private object GetName(object collectionObj,string displayMember,string valueMember,object colValue)
		{
			CustomCollection custCollection = collectionObj as CustomCollection;
			IEnumerator iEnum = custCollection.GetEnumerator();
			while(iEnum.MoveNext())
			{
				BaseObject obj = iEnum.Current as BaseObject;
				object objValue = obj.GetType().GetProperty(valueMember).GetValue(obj,null);
				if(objValue != null)
				{
					string sValue = objValue.ToString();
					if(sValue == colValue.ToString())
					{
						object objColValue = obj.GetType().GetProperty(displayMember).GetValue(obj,null);
						return objColValue;
					}
				}
			}
			return null;
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.SaveMapSettings();
			this.Close();
			return;
		}

		private void cmbSheets_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(cmbSheets.SelectedItem == null)
				return;
			excelTable = ExcelUtils.GetTable(this.cmbSheets.SelectedItem.ToString());
			if(excelTable != null)
			{
				BindToGrid(excelTable);
			}
		}

		private void gridGroupingControlExcelFields_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{

		}

		private void listSourceCK_SelectedValueChanged(object sender, System.EventArgs e)
		{
			btnSave.Enabled=false;
		}

		private void listTargetCK_SelectedValueChanged(object sender, System.EventArgs e)
		{
			btnSave.Enabled=false;
		}

		private void cmbSheets_SelectedValueChanged(object sender, System.EventArgs e)
		{
			btnSave.Enabled=false;
		}

		private void listTargetCK_Click(object sender, EventArgs e)
		{
			ListBox l1 = sender as ListBox;
			for(int i =0;i<l1.Items.Count ;i++)
			{
				if(!l1.GetSelected(i)) 
				{
					if(mandatoryHash.Contains(l1.Items[i].ToString()))
					{
						this.listTargetCK.SetSelected(i,true);
					}
				}
			}
		}

		private void listSourceCK_Click(object sender, EventArgs e)
		{
			ListBox l1 = sender as ListBox;
			for(int i =0;i<l1.Items.Count ;i++)
			{
				if(!l1.GetSelected(i)) 
				{
					if(mandatoryHash.Contains(l1.Items[i].ToString()))
					{
						this.listSourceCK.SetSelected(i,true);
					}
				}
			}
		}
	}
}
