using System;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using System.Text.RegularExpressions;
using System.Collections.Generic;
using Symcom.Evaluator;
using Symcon.LightRidge.BusinessObjects.TypeEditors;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for FormulaExpression.
	/// </summary>
	/// 
	
	public class FormulaExpression
	{
		public FormulaExpression(LRRFormulaParams objParams)
        {

            htdataSource = LRRFormulaDataStore.DataSource as Hashtable;
            dataSource  = htdataSource[0] as CustomCollection;
            _objFormulaParamsParams = objParams;
            foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
            {
                paramsArray.Add(fParam);
            }
            _lrrModes = LRRModel.Modes; 
		}
        public FormulaExpression(Hashtable objParamsCollectionHash)
        {
            htdataSource = LRRFormulaDataStore.DataSource as Hashtable;
            dataSource = htdataSource[0] as CustomCollection;
            _lrrModes = LRRModel.Modes;
        }

		#region Public Properties
			public string MethodType
			{
				get{return _methodType;}
				set
				{
					_methodType = value;
				}
			}
		#endregion
		
		#region Generate Formula Expression for Simple Aggregate.

        public Hashtable WEIGHTEDAVERAGE(Hashtable objParamsCollectionHash,LRRAggregateProperty aggregateProperty)
        {
            IEnumerator iEnum = objParamsCollectionHash.GetEnumerator();

            string masterPropID = aggregateProperty.MasterPropertyID;

            LRRWeightedFacterMapping weightedFacterMapping = LRRModel.WeightedFacterMappings.GetWeightedFacterFromPropID(masterPropID);

            string weightedPropID = weightedFacterMapping.WeightedPropertyID;

            ArrayList weightParamsList = new ArrayList();

            if (!weightedFacterMapping.IsConstant)
            {
                while (iEnum.MoveNext())
                {
                    DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;

                    string ModeID = dEntry.Key.ToString();

                    LRRFormulaParams fParmas = dEntry.Value as LRRFormulaParams;

                    foreach (LRRFormulaParam fParam in fParmas)
                    {
                        string sourceObjID = fParam.SourceOBJID;
                        if (fParam.SourceCollectioName == "Symcon.LightRidge.BusinessObjects.LRRAggregatePropertyValue")
                        {
                            LRRAggregateProperty aggregateProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(sourceObjID);
                            LRRAggregateProperties aggregateProps = LRRModel.AggregatePropertiesObj.FilterPropertiesByAggregate(aggregateProp.AggregateID);
                            foreach (LRRAggregateProperty aggProp in aggregateProps)
                            {
                                if (aggProp.MasterPropertyID == weightedPropID)
                                {
                                    LRRAggregatePropertyValues aggPropValues = LRRModel.AggregatePropertyValuesObj.GetPropValuesCollectionByPropID(aggProp.ID);
                                    foreach (LRRAggregatePropertyValue aggPropValue in aggPropValues)
                                    {
                                        if (aggPropValue.ModeID == ModeID)
                                        {
                                            LRRFormulaParam _formulaParam = new LRRFormulaParam();
                                            _formulaParam.FormulaID = fParam.FormulaID;
                                            _formulaParam.ParamName = "WF" + fParam.ParamName;
                                            _formulaParam.ParamPath = "Aggregates\\" + aggProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                            _formulaParam.SourceOBJID = aggProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                            _formulaParam.SourceCollectioName = aggPropValue.TypeOfObject.ToString();
                                            _formulaParam.CurrentValue = aggPropValue.PropertyValue;
                                            _formulaParam.PropertyName = aggProp.Name;
                                            _formulaParam.ModeID = ModeID;
                                            _formulaParam.ModeName = fParam.ModeName;
                                            _formulaParam.UOM = aggProp.UOM;
                                            weightParamsList.Add(_formulaParam);
                                            break;
                                        }
                                    }
                                    break;
                                }
                            }
                        }
                        else if (fParam.SourceCollectioName == "Symcon.LightRidge.BusinessObjects.LRRSiteComponentPropertyValue")
                        {
                            LRRSiteComponentProperty siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sourceObjID);
                            LRRSiteComponentProperties siteComponentProperties = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(siteCompProp.ComponentID);

                            foreach (LRRSiteComponentProperty siteComponentProp in siteComponentProperties)
                            {
                                if (siteComponentProp.PropertyID == weightedPropID)
                                {
                                    LRRSiteComponentPropertyValues sPropValues = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(siteComponentProp.ID);
                                    foreach (LRRSiteComponentPropertyValue sPropValue in sPropValues)
                                    {
                                        if (sPropValue.ModeID == ModeID)
                                        {
                                            LRRFormulaParam _formulaParam = new LRRFormulaParam();
                                            _formulaParam.FormulaID = fParam.FormulaID;
                                            _formulaParam.ParamName = "WF" + fParam.ParamName;
                                            _formulaParam.ParamPath = "Aggregates\\" + siteComponentProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                            _formulaParam.SourceOBJID = siteComponentProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                            _formulaParam.SourceCollectioName = sPropValue.TypeOfObject.ToString();
                                            _formulaParam.CurrentValue = sPropValue.PropertyValue;
                                            _formulaParam.PropertyName = siteComponentProp.Name;
                                            _formulaParam.ModeID = ModeID;
                                            _formulaParam.ModeName = fParam.ModeName;
                                            _formulaParam.UOM = siteComponentProp.UOM;
                                            weightParamsList.Add(_formulaParam);
                                            break;
                                        }
                                    }
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                while (iEnum.MoveNext())
                {
                    DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;

                    string ModeID = dEntry.Key.ToString();

                    LRRFormulaParams fParmas = dEntry.Value as LRRFormulaParams;

                    foreach (LRRFormulaParam fParam in fParmas)
                    {
                        LRRFormulaParam lfp = new LRRFormulaParam();
                        lfp.ParamName = "WF" + fParam.ParamName;
                        lfp.PropertyName = weightedFacterMapping.ConstantName;
                        lfp.CurrentValue = weightedFacterMapping.ConstantValue;
                        lfp.FormulaID = fParam.FormulaID;
                        lfp.SourceCollectioName = typeof(LRRConstant).ToString();
                        weightParamsList.Add(lfp);
                    }
                }
            }

            if (weightParamsList.Count > 0)
            {
                for (int i = 0; i < weightParamsList.Count; i++)
                {
                    LRRFormulaParam fParam = weightParamsList[i] as LRRFormulaParam;
                    LRRFormula formulaObj = LRRModel.FormulasObj.GetFormulaObjFromID(fParam.FormulaID);
                    formulaObj.Params.Add(fParam);
                }
                IEnumerator iEnumParams = objParamsCollectionHash.GetEnumerator();
                while (iEnumParams.MoveNext())
                {
                    Hashtable weightedParamMapHash = new Hashtable();
                    DictionaryEntry dEntry = (DictionaryEntry)iEnumParams.Current;
                    string ModeID = dEntry.Key.ToString();
                    LRRFormulaParams _objFormulaParamsParams = dEntry.Value as LRRFormulaParams;
                    foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
                    {
                        if (!fParam.ParamName.StartsWith("WF"))
                        {
                            string fParamName = fParam.ParamName;
                            foreach (LRRFormulaParam weightedFParam in _objFormulaParamsParams)
                            {
                                if (weightedFParam.ParamName.StartsWith("WF"))
                                {
                                    if (weightedFParam.ParamName.EndsWith(fParamName))
                                    {
                                        weightedParamMapHash.Add(fParam, weightedFParam);
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    string sPropExpressionSumetion = "(";
                    string sPropExpressionDivisionBy = "(";
                    string sPropExpression = string.Empty;
                    IEnumerator iEnumWeightedParam = weightedParamMapHash.GetEnumerator();
                    while (iEnumWeightedParam.MoveNext())
                    {
                        DictionaryEntry dEntryVal = (DictionaryEntry)iEnumWeightedParam.Current;
                        LRRFormulaParam fParam = dEntryVal.Key as LRRFormulaParam;
                        LRRFormulaParam weightedFParam = dEntryVal.Value as LRRFormulaParam;
                        sPropExpressionSumetion = sPropExpressionSumetion + "(" + fParam.ParamName + "*" + weightedFParam.ParamName + ")+";
                        sPropExpressionDivisionBy = sPropExpressionDivisionBy + weightedFParam.ParamName + "+";
                    }

                    sPropExpressionSumetion = sPropExpressionSumetion.Remove(sPropExpressionSumetion.LastIndexOf("+"), 1);
                    sPropExpressionSumetion = sPropExpressionSumetion + ")";
                    sPropExpressionDivisionBy = sPropExpressionDivisionBy.Remove(sPropExpressionDivisionBy.LastIndexOf("+"), 1);
                    sPropExpressionDivisionBy = sPropExpressionDivisionBy + ")";

                    sPropExpression = sPropExpressionSumetion + "/" + sPropExpressionDivisionBy;
                    FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
                    fExpressionObj.FormulaExpression = sPropExpression;
                    fExpressionObj.Params = _objFormulaParamsParams;
                    fExpressionObj.IsFormula = true;
                    FormulaExpHash.Add(ModeID, fExpressionObj);
                }
            }
            return FormulaExpHash;
        }


        public Hashtable SUM(Hashtable FormulaParamsForMode)
        {
            IEnumerator iEnum = FormulaParamsForMode.GetEnumerator();
            while (iEnum.MoveNext())
            {
                DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;
                string ModeID = dEntry.Key.ToString();
                LRRFormulaParams _objFormulaParamsParams = dEntry.Value as LRRFormulaParams;
                string sPropExpression = "(";
                foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
                {
                    sPropExpression = sPropExpression + fParam.ParamName + "+";
                }
                sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf("+"), 1);
                sPropExpression = sPropExpression + ")";
                FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
                fExpressionObj.FormulaExpression = sPropExpression;
                fExpressionObj.Params = _objFormulaParamsParams;
                fExpressionObj.IsFormula = true;
                FormulaExpHash.Add(ModeID, fExpressionObj);
            }
            return FormulaExpHash;
        }

        public Hashtable COUNT(Hashtable FormulaParamsForMode,string MasterPropertyID)
        {
            /*
            IEnumerator iEnum = FormulaParamsForMode.GetEnumerator();
            while (iEnum.MoveNext())
            {
                DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;
                string ModeID = dEntry.Key.ToString();
                LRRFormulaParams _objFormulaParamsParams = dEntry.Value as LRRFormulaParams;
                string sPropExpression = "COUNT(";
                foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
                {
                    sPropExpression = sPropExpression + fParam.ParamName + ",";
                }
                sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf(","), 1);
                sPropExpression = sPropExpression + ")";
                sPropExpression = "RESULT = " + sPropExpression + ";";
                FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
                fExpressionObj.FormulaExpression = sPropExpression;
                fExpressionObj.IsFormula = false;
                fExpressionObj.Params = _objFormulaParamsParams;
                FormulaExpHash.Add(ModeID, fExpressionObj);
            }
            return FormulaExpHash;
             * */
            LRRMasterProperty mp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(MasterPropertyID);
            if (mp != null)
            {
                IEnumerator iEnum = FormulaParamsForMode.GetEnumerator();
                while (iEnum.MoveNext())
                {
                    DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;
                    string ModeID = dEntry.Key.ToString();
                    LRRFormulaParams _objFormulaParamsParams = dEntry.Value as LRRFormulaParams;
                    string sPropExpression = "Count(" + mp.CountIF + ",";
                    foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
                    {
                        sPropExpression = sPropExpression + fParam.ParamName + ",";
                    }
                    sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf(","), 1);
                    sPropExpression = sPropExpression + ")";
                    FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
                    fExpressionObj.FormulaExpression = sPropExpression;
                    fExpressionObj.Params = _objFormulaParamsParams;
                    fExpressionObj.IsFormula = true;
                    FormulaExpHash.Add(ModeID, fExpressionObj);
                }
                return FormulaExpHash;
            }
            return null;
        }
        
        public Hashtable AVERAGE(Hashtable FormulaParamsForMode)
        {
            IEnumerator iEnum = FormulaParamsForMode.GetEnumerator();
            while (iEnum.MoveNext())
            {
                DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;
                string ModeID = dEntry.Key.ToString();
                LRRFormulaParams _objFormulaParamsParams = dEntry.Value as LRRFormulaParams;
                string sPropExpression = "(";
                foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
                {
                    sPropExpression = sPropExpression + fParam.ParamName + "+";
                }
                sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf("+"), 1);
                sPropExpression = sPropExpression + ")";
                sPropExpression = sPropExpression + "/" + _objFormulaParamsParams.Count;
                FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
                fExpressionObj.FormulaExpression = sPropExpression;
                fExpressionObj.Params = _objFormulaParamsParams;
                fExpressionObj.IsFormula = true;
                FormulaExpHash.Add(ModeID, fExpressionObj);
            }
            return FormulaExpHash;
		}

        public string EvaluateFormula(string input, LRRFormulaParams localCopyOfParams, LRRFormula FormulaObj)
        {
            if (FormulaObj.IsFormula)
            {
                string resultValue = Calculate(input, localCopyOfParams, FormulaObj);
                return resultValue;
            }
            else
            {
                Symcon.LightRidge.BusinessObjects.TypeEditors.InbuildFormulas inBuildFormula = new Symcon.LightRidge.BusinessObjects.TypeEditors.InbuildFormulas(paramsArray, dataSource);
                inBuildFormula.ScriptWnd = frmScriptEditor;
                inBuildFormula.EvaluteFunction(input);
                string FormulaValue = frmScriptEditor.ScriptValue;
                return FormulaValue;
            }
        }


        private string Calculate(string input, LRRFormulaParams localCopyOfParams, LRRFormula FormulaObj)
        {
            Regex regex = new Regex("[[(\\w)]]", RegexOptions.IgnoreCase);
            MatchCollection match = regex.Matches(input);
            int foundCount = 0;

            Dictionary<string, LRRFormulaParam> htFormulaParam = new Dictionary<string, LRRFormulaParam>();
            foreach (LRRFormulaParam lrrFormulaParam in localCopyOfParams)
            {
                htFormulaParam.Add(lrrFormulaParam.ParamName, lrrFormulaParam);
            }
            //Symcom.Evaluator.Evaluator = new Symcom.Evaluator.Evaluator();

            //--Inline Operator--
            string[] inlineOperator = input.Split(new char[] { '?' });
            if (inlineOperator.Length > 1)
            {
                string exp = inlineOperator[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                string[] param = exp.Split(new char[] { '=', '>', '<' });
                int greaterThanIndex = exp.IndexOf('>');
                int lesserThanIndex = exp.IndexOf('<');
                int equalToIndex = exp.IndexOf('=');
                string oper = null;
                if (greaterThanIndex != -1)
                {
                    oper = ">";
                }
                else if (lesserThanIndex != -1)
                {
                    oper = "<";
                }
                else if (equalToIndex != -1)
                {
                    oper = "=";
                }

                if (param.Length > 1)
                {
                    string param1 = param[0].ToString(Symcon.BusinessObjects.SymConverter.Culture).Trim();
                    string param2 = param[1].ToString(Symcon.BusinessObjects.SymConverter.Culture).Trim();
                    if (htFormulaParam.ContainsKey(param1))
                    {
                        LRRFormulaParam lrrFormulaParam1 = htFormulaParam[param1] as LRRFormulaParam;
                        string[] result = inlineOperator[1].Split(new char[] { ':' });

                        try
                        {
                            //Get the current Value
                            string curVal = GetCurrentValueInUIUOM(lrrFormulaParam1); //GetCurrentValue(lrrFormulaParam1);
                            //check for operator
                            switch (oper)
                            {
                                case ">":
                                    double cmp1 = Convert.ToDouble(lrrFormulaParam1.CurrentValue, Symcon.BusinessObjects.SymConverter.Culture);
                                    double cmp2 = Convert.ToDouble(param2, Symcon.BusinessObjects.SymConverter.Culture);
                                    if (cmp1 > cmp2)
                                    {
                                        //										lblResult.Text = result[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                        return result[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                    }
                                    else
                                    {
                                        //										lblResult.Text = result[1].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                        return result[1].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                    }
                                case "<":
                                    double cmp3 = Convert.ToDouble(lrrFormulaParam1.CurrentValue, Symcon.BusinessObjects.SymConverter.Culture);
                                    double cmp4 = Convert.ToDouble(param2, Symcon.BusinessObjects.SymConverter.Culture);
                                    if (cmp3 < cmp4)
                                    {
                                        //										lblResult.Text = result[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                        return result[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                    }
                                    else
                                    {
                                        //										lblResult.Text = result[1].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                        return result[1].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                    }
                                case "=":
                                    if (lrrFormulaParam1.CurrentValue == param2)
                                    {
                                        //										lblResult.Text = result[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                        return result[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                    }
                                    else
                                    {
                                        //										lblResult.Text = result[1].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                        return result[1].ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                    }
                                default:
                                    break;

                            }
                        }
                        catch (Exception ex)
                        {
                            //							lblResult.Text = "Validation failed";
                            System.Diagnostics.Debug.Assert(false, ex.Message, ex.StackTrace);
                            return "Validation failed";

                        }
                    }
                }
            }
            //--End--

            Symcom.Evaluator.Evaluator.Variables = new Hashtable();
            Symcom.Evaluator.Evaluator.ParseIt(input);

            for (int i = 0; i < match.Count; i++)
            {
                Match m = match[i];
                string foundItem = m.Value.TrimEnd(new char[] { ']' });
                foreach (LRRFormulaParam lfp in FormulaObj.Params)
                {
                    if (lfp.ParamName == foundItem)
                    {
                        foundCount++;
                        int val = Int32.Parse(lfp.CurrentValue, Symcon.BusinessObjects.SymConverter.Culture);
                        if (!Symcom.Evaluator.Evaluator.Variables.ContainsKey(lfp.ParamName))
                        {
                            Symcom.Evaluator.Evaluator.Variables.Add(lfp.ParamName, val);
                        }
                    }
                }
            }
            try
            {
                return CalculateFunctionsExpression(input, htFormulaParam);
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.Assert(false, ex.Message, ex.StackTrace);
                return "Validation failed";
            }
        }

        private string GetCurrentValueInUIUOM(LRRFormulaParam lrrFormulaParam)
        {
            string curVal = "";

            if (!lrrFormulaParam.IsPESteamParam)
            {
                //If the collection is SiteComponent
                if (lrrFormulaParam.SourceCollectioName.Trim() == typeof(LRRSiteComponentPropertyValue).ToString())
                {
                    if (lrrFormulaParam.SourceOBJID == null || lrrFormulaParam.SourceOBJID.Trim() == "")
                    {
                        curVal = lrrFormulaParam.CurrentValue;
                    }
                    else
                    {
                        //Convert to UI UOM
                        if (LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrFormulaParam.SourceOBJID) != null)
                        {
                            LRRSiteComponentProperty propObj = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrFormulaParam.SourceOBJID);
                            LRRSiteComponentPropertyValue propValueObj = propObj.GetValueObjectForPropertyMode(lrrFormulaParam.ModeID);
                            if (propValueObj != null)
                            {
                                curVal = propValueObj.GetPropertyValueForUOM(propValueObj.GetUOMID(), propObj.GetUIUOMID(), propValueObj.ActualPropertyValue);
                                //Set UI UOM
                                lrrFormulaParam.UIUOM = propObj.GetUIUOMID();
                            }
                        }
                    }
                }
                //If the collection is SiteComponent Group Qualifier
                //Added by Nidhi For Grouped Properties - Chemical components and Data Arrays
                else if (lrrFormulaParam.SourceCollectioName.Trim() == typeof(LRRSiteGroupPropertyQualifierValue).ToString())
                {
                    if (lrrFormulaParam.SourceOBJID == null || lrrFormulaParam.SourceOBJID.Trim() == "")
                    {
                        curVal = lrrFormulaParam.CurrentValue;
                    }
                    else
                    {
                        //Convert to UI UOM
                        if (LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(lrrFormulaParam.SourceOBJID) != null)
                        {
                            string sQualifierID = "";
                            if ((lrrFormulaParam.SourceLookUpQualifierID != null) && (lrrFormulaParam.SourceLookUpQualifierID != ""))
                                sQualifierID = LRRModel.ChildModel.LookUpQualifiers.getLookUpQualifierForLkupQualifierID(lrrFormulaParam.SourceLookUpQualifierID).QualifierID;

                            LRRSiteGroupPropertyQualifierValue lrrSiteCompGroupPropQVal = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(lrrFormulaParam.SourceOBJID).GroupPptiesQualifierValues.GetQualifierValueObjectForPropertyMode(lrrFormulaParam.SourceOBJID, lrrFormulaParam.SourceLookUpPropertyID, sQualifierID, lrrFormulaParam.ModeID);

                            if (lrrSiteCompGroupPropQVal != null)
                            {
                                string lkupQualID = lrrSiteCompGroupPropQVal.LookUpQualifierID;
                                LRRLookUpQualifier lkupQualObj = LRRModel.LookUpQualifiers.getLookUpQualifierForLkupQualifierID(lkupQualID);
                                //Group Property
                                if (lkupQualObj != null)
                                {
                                    string uomTypeID = lkupQualObj.UOMTypeID;
                                    //Get the UI UOM
                                    LRRMeasurementSystemDefinitions lrrMSDs = LRRModel.ChildModel.MeasSysDef;
                                    string uiUOMID = lrrMSDs.GetLocaleUOM(LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID, uomTypeID);

                                    curVal = ConvertUOM(lrrSiteCompGroupPropQVal.GetUOMID(), uiUOMID, lrrSiteCompGroupPropQVal.ActualPropertyValue);

                                    //Set UI UOM
                                    lrrFormulaParam.UIUOM = uiUOMID;
                                }
                                else //Data Arrays
                                {
                                    LRRSiteComponentGroupProperty objGrpProp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(lrrSiteCompGroupPropQVal.GroupPropertyID);
                                    if (objGrpProp != null)
                                    {
                                        string propType = objGrpProp.PropertyID;
                                        LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(propType);
                                        if (propTypeObj != null)
                                        {
                                            //Get the UI UOM
                                            LRRMeasurementSystemDefinitions lrrMSDs = LRRModel.ChildModel.MeasSysDef;
                                            string uiUOMID = lrrMSDs.GetLocaleUOM(LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID, propTypeObj.UOMTypeID);
                                            curVal = ConvertUOM(lrrSiteCompGroupPropQVal.GetUOMID(), uiUOMID, lrrSiteCompGroupPropQVal.ActualPropertyValue);

                                            //Set UI UOM
                                            lrrFormulaParam.UIUOM = uiUOMID;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                //If the collection is Hist Data
                else if (lrrFormulaParam.SourceCollectioName.Trim() == typeof(LRRHistData).ToString())
                {
                    if (lrrFormulaParam.SourceOBJID == null || lrrFormulaParam.SourceOBJID.Trim() == "")
                    {
                        curVal = lrrFormulaParam.CurrentValue;
                    }
                    else
                    {
                        //Populate from Model
                        LRRHistDatas lrrhistDatas = LRRModel.HistDatas;
                        LRRHistData lrrhistData = lrrhistDatas.GetHistDataFromHistTagUID(lrrFormulaParam.SourceOBJID);

                        string uomID = lrrhistData.ModelUOM;
                        string uiUOMId = lrrhistData.InterfaceUnits;
                        curVal = ConvertUOM(uomID, uiUOMId, lrrhistData.InterfaceValue);

                        //Set UI UOM
                        lrrFormulaParam.UIUOM = uiUOMId;
                    }
                }
                else if (lrrFormulaParam.SourceCollectioName.Trim() == typeof(LRRAggregatePropertyValue).ToString())
                {
                    if (lrrFormulaParam.SourceOBJID == null || lrrFormulaParam.SourceOBJID.Trim() == "")
                    {
                        curVal = lrrFormulaParam.CurrentValue;
                    }
                    else
                    {
                        //Convert to UI UOM
                        if (LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(lrrFormulaParam.SourceOBJID) != null)
                        {
                            LRRAggregateProperty aggPropObj = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(lrrFormulaParam.SourceOBJID);
                            LRRAggregatePropertyValue propValueObj = aggPropObj.GetValueObjectForPropertyMode(lrrFormulaParam.ModeID);
                            if (propValueObj != null)
                            {
                                curVal = propValueObj.GetPropertyValueForUOM(propValueObj.GetUOMID(), aggPropObj.GetUIUOMID(), propValueObj.ActualPropertyValue);
                                //Set UI UOM
                                lrrFormulaParam.UIUOM = aggPropObj.GetUIUOMID();
                            }
                        }
                    }
                }
                //If constant
                else
                {
                    curVal = lrrFormulaParam.CurrentValue;
                }
            }
            else
            {
                curVal = lrrFormulaParam.CurrentValue;
            }

            if (curVal == null || curVal.Trim() == "")
                curVal = "0";

            return curVal;
        }


        private string ConvertUOM(string fromUOMID, string newUOMID, string currentValue)
        {
            string newVal = "";
            if (currentValue != null && currentValue != "")
            {
                if (fromUOMID == newUOMID)
                {
                    newVal = currentValue;
                }
                else
                {
                    if ((fromUOMID != null && fromUOMID != "") &&
                        (newUOMID != null && newUOMID != ""))
                    {
                        newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(fromUOMID, newUOMID, currentValue,null);
                    }
                }
            }
            return newVal;
        }



        private string CalculateFunctionsExpression(string expression, Dictionary<string, LRRFormulaParam> htFormulaParam)
        {
            ExecutionQueue eq = Evaluator.ParseIt(expression);
            ExecutionQueue newEq = new ExecutionQueue();
            ExecutionItem ei;

            while (eq.Count > 0)
            {
                ei = eq.Dequeue();
                switch (ei.ItemType)
                {
                    case ItemType.itString:
                        if (htFormulaParam.ContainsKey(ei.ItemString))
                        {
                            LRRFormulaParam lrrFormulaParam = htFormulaParam[ei.ItemString] as LRRFormulaParam;
                            if (!lrrFormulaParam.IsPESteamParam)
                            {
                                string curVal = GetCurrentValueInUIUOM(lrrFormulaParam);//GetCurrentValue(lrrFormulaParam);

                                double res;
                                if (double.TryParse(curVal, out res))
                                    newEq.Enqueue(new ExecutionItem(ItemType.itDigit, curVal));
                                else
                                    newEq.Enqueue(new ExecutionItem(ItemType.itString, curVal));
                            }
                            else
                            {
                                string curVal = PESteamFunctionCalculation.CalulatePESteamFunction(lrrFormulaParam); // PESteamFunctionCalculation.CalulatePESteamFunction(lrrFormulaParam);

                                double res;
                                if (double.TryParse(curVal, out res))
                                    newEq.Enqueue(new ExecutionItem(ItemType.itDigit, curVal));
                                else
                                    newEq.Enqueue(new ExecutionItem(ItemType.itString, curVal));
                            }
                        }
                        else
                        {
                            newEq.Enqueue(ei);
                        }
                        break;
                    case ItemType.itFunction:
                        System.Collections.Specialized.StringCollection itParamsNew = new System.Collections.Specialized.StringCollection();
                        foreach (string itParam in ei.ItemParams)
                        {
                            itParamsNew.Add(CalculateFunctionsExpression(itParam, htFormulaParam));
                        }
                        ei.ItemParams = itParamsNew;
                        newEq.Enqueue(ei);
                        break;
                    default:
                        newEq.Enqueue(ei);
                        break;
                }
            }

            Variant var = Evaluator.CalcIt(newEq);
            return var.oValue.ToString();
        }

        
        public Hashtable MAX(Hashtable FormulaParamsForMode)
        {
            IEnumerator iEnum = FormulaParamsForMode.GetEnumerator();
            while (iEnum.MoveNext())
            {
                DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;
                string ModeID = dEntry.Key.ToString();
                LRRFormulaParams _objFormulaParamsParams = dEntry.Value as LRRFormulaParams;

                string sPropExpression = "MAX(";
                foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
                {
                    sPropExpression = sPropExpression + fParam.ParamName + ",";
                }
                sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf(","), 1);
                sPropExpression = sPropExpression + ")";
                sPropExpression = "RESULT = " + sPropExpression + ";";
                FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
                fExpressionObj.FormulaExpression = sPropExpression;
                fExpressionObj.Params = _objFormulaParamsParams;
                fExpressionObj.IsFormula = false;
                FormulaExpHash.Add(ModeID, fExpressionObj);
            }
            return FormulaExpHash;
        }

        public Hashtable MIN(Hashtable FormulaParamsForMode)
        {
            IEnumerator iEnum = FormulaParamsForMode.GetEnumerator();
            while (iEnum.MoveNext())
            {
                DictionaryEntry dEntry = (DictionaryEntry)iEnum.Current;
                string ModeID = dEntry.Key.ToString();
                LRRFormulaParams _objFormulaParamsParams = dEntry.Value as LRRFormulaParams;
                string sPropExpression = "MIN(";
                foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
                {
                    sPropExpression = sPropExpression + fParam.ParamName + ",";
                }
                sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf(","), 1);
                sPropExpression = sPropExpression + ")";
                sPropExpression = "RESULT = " + sPropExpression + ";";
                FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
                fExpressionObj.FormulaExpression = sPropExpression;
                fExpressionObj.Params = _objFormulaParamsParams;
                fExpressionObj.IsFormula = false;
                FormulaExpHash.Add(ModeID, fExpressionObj);
            }
            return FormulaExpHash;
        }

        #endregion

        #region Generate Formula Expression For DataArray AggreGates



        public FormulaExpressionObjects WEIGHTEDAVERAGE(LRRFormulaParams objFormulaParams, string aggGrpPropID)
        {
            LRRAggregateGroupedProperty aggGrpProp = LRRModel.AggregateGroupedPropertiesObj.GetAggregateGroupPropFromID(aggGrpPropID);

            string masterPropID = aggGrpProp.MasterPropID;

            LRRWeightedFacterMapping weightedFacterMapping = LRRModel.WeightedFacterMappings.GetWeightedFacterFromPropID(masterPropID);

            string weightedPropID = weightedFacterMapping.WeightedPropertyID;

            string componentID = weightedFacterMapping.ComponentID; 

            ArrayList weightParamsList = new ArrayList();

            if (!weightedFacterMapping.IsConstant)
            {
                foreach (LRRFormulaParam fParam in objFormulaParams)
                {
                    string ModeID = fParam.ModeID;
                    string siteComGrpPropID = fParam.SourceOBJID;
                    LRRSiteComponentGroupProperty siteComGrpProp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(siteComGrpPropID);
                    LRRSiteComponentProperty siteComponentProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(siteComGrpProp.SiteComponentPropID);
                    LRRSiteComponentProperties siteComponentProperties = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(siteComponentProperty.ComponentID); 
                    foreach (LRRSiteComponentProperty lscp in siteComponentProperties)
                    {
                        if (lscp.GroupPpties.Count > 0)
                        {
                            foreach (LRRSiteComponentGroupProperty lscgp in lscp.GroupPpties)
                            {
                                if (lscgp.MasterPropID != weightedPropID)
                                {
                                    break;
                                }
                                else if(fParam.PropertyName == lscgp.AttributeName)
                                {
                                    LRRSiteGroupPropertyQualifierValues lscgpvs = lscgp.GroupPptiesQualifierValues;
                                    foreach (LRRSiteGroupPropertyQualifierValue lscgpv in lscgpvs)
                                    {
                                        if (lscgpv.ModeID == ModeID)
                                        {
                                            LRRFormulaParam _formulaParam = new LRRFormulaParam();
                                            _formulaParam.FormulaID = fParam.FormulaID;
                                            _formulaParam.ParamName = "WF" + fParam.ParamName;
                                            _formulaParam.ParamPath = "Aggregates\\" + lscgp.GroupPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                            _formulaParam.SourceOBJID = lscgp.GroupPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                            _formulaParam.SourceCollectioName = lscgpv.TypeOfObject.ToString();
                                            _formulaParam.SourceLookUpPropertyID = lscgpv.LookUpPropertiesID;
                                            _formulaParam.SourceLookUpQualifierID = lscgpv.LookUpQualifierID;  
                                            _formulaParam.CurrentValue = lscgpv.PropertyValue;
                                            _formulaParam.PropertyName = lscgp.AttributeName;
                                            _formulaParam.ModeID = ModeID;
                                            _formulaParam.ModeName = fParam.ModeName;
                                            _formulaParam.UOM = lscgp.UOM;
                                            weightParamsList.Add(_formulaParam);
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                foreach (LRRFormulaParam fParam in objFormulaParams)
                {
                    LRRFormulaParam lfp = new LRRFormulaParam();
                    lfp.ParamName = "WF" + fParam.ParamName;
                    lfp.PropertyName = weightedFacterMapping.ConstantName;
                    lfp.CurrentValue = weightedFacterMapping.ConstantValue;
                    lfp.FormulaID = fParam.FormulaID;
                    lfp.SourceCollectioName = typeof(LRRConstant).ToString();
                    weightParamsList.Add(lfp);
                }
            }

            for (int i = 0; i < weightParamsList.Count; i++)
            {
                LRRFormulaParam fParam = weightParamsList[i] as LRRFormulaParam;
                LRRFormula formulaObj = LRRModel.FormulasObj.GetFormulaObjFromID(fParam.FormulaID);
                formulaObj.Params.Add(fParam);
            }

            Hashtable weightedParamMapHash = new Hashtable();
            foreach (LRRFormulaParam formulaParam in objFormulaParams)
            {
                if (!formulaParam.ParamName.StartsWith("WF"))
                {
                    string fParamName = formulaParam.ParamName;
                    foreach (LRRFormulaParam weightedFParam in objFormulaParams)
                    {
                        if (weightedFParam.ParamName.StartsWith("WF"))
                        {
                            if (weightedFParam.ParamName.EndsWith(fParamName))
                            {
                                weightedParamMapHash.Add(formulaParam, weightedFParam);
                                break;
                            }
                        }
                    }
                }
            }
            string sPropExpressionSumetion = "(";
            string sPropExpressionDivisionBy = "(";
            string sPropExpression = string.Empty;
            IEnumerator iEnumWeightedParam = weightedParamMapHash.GetEnumerator();
            while (iEnumWeightedParam.MoveNext())
            {
                DictionaryEntry dEntryVal = (DictionaryEntry)iEnumWeightedParam.Current;
                LRRFormulaParam fParam = dEntryVal.Key as LRRFormulaParam;
                LRRFormulaParam weightedFParam = dEntryVal.Value as LRRFormulaParam;
                sPropExpressionSumetion = sPropExpressionSumetion + "(" + fParam.ParamName + "*" + weightedFParam.ParamName + ")+";
                sPropExpressionDivisionBy = sPropExpressionDivisionBy + weightedFParam.ParamName + "+";
            }
            sPropExpressionSumetion = sPropExpressionSumetion.Remove(sPropExpressionSumetion.LastIndexOf("+"), 1);
            sPropExpressionSumetion = sPropExpressionSumetion + ")";
            sPropExpressionDivisionBy = sPropExpressionDivisionBy.Remove(sPropExpressionDivisionBy.LastIndexOf("+"), 1);
            sPropExpressionDivisionBy = sPropExpressionDivisionBy + ")";
            sPropExpression = sPropExpressionSumetion + "/" + sPropExpressionDivisionBy;
            FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
            fExpressionObj.FormulaExpression = sPropExpression;
            fExpressionObj.IsFormula = true;
            fExpressionObj.Params = objFormulaParams;
            return fExpressionObj;
        }

        public FormulaExpressionObjects SUM(LRRFormulaParams _objFormulaParamsParams)
        {
            string sPropExpression = "(";
            string ModeID = "";
            foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
            {
                sPropExpression = sPropExpression + fParam.ParamName + "+";
                ModeID = fParam.ModeID;
            }
            sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf("+"), 1);
            sPropExpression = sPropExpression + ")";
            FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
            fExpressionObj.FormulaExpression = sPropExpression;
            fExpressionObj.IsFormula = true;
            fExpressionObj.Params = _objFormulaParamsParams;
            return fExpressionObj;
        }

        public FormulaExpressionObjects COUNT(LRRFormulaParams _objFormulaParamsParams)
        {
            /*
            string sPropExpression = "COUNT(";
            string ModeID = "";
            foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
            {
                sPropExpression = sPropExpression + fParam.ParamName + ",";
                ModeID = fParam.ModeID;
            }
            sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf(","), 1);
            sPropExpression = sPropExpression + ")";
            sPropExpression = "RESULT = " + sPropExpression + ";";
            FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
            fExpressionObj.FormulaExpression = sPropExpression;
            fExpressionObj.IsFormula = false;
            fExpressionObj.Params = _objFormulaParamsParams;
            return fExpressionObj;
             * */
            string sPropExpression = "(";
            string ModeID = "";
            foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
            {
                sPropExpression = sPropExpression + fParam.ParamName + "+";
                ModeID = fParam.ModeID;
            }
            sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf("+"), 1);
            sPropExpression = sPropExpression + ")";
            FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
            fExpressionObj.FormulaExpression = sPropExpression;
            fExpressionObj.IsFormula = true;
            fExpressionObj.Params = _objFormulaParamsParams;
            return fExpressionObj;
        }

        public FormulaExpressionObjects AVERAGE(LRRFormulaParams _objFormulaParamsParams)
        {
            string sPropExpression = "(";
            string ModeID = "";
            foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
            {
                sPropExpression = sPropExpression + fParam.ParamName + "+";
                ModeID = fParam.ModeID;
            }
            sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf("+"), 1);
            sPropExpression = sPropExpression + ")";
            sPropExpression = sPropExpression + "/" + _objFormulaParamsParams.Count;
            FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
            fExpressionObj.FormulaExpression = sPropExpression;
            fExpressionObj.IsFormula = true;
            fExpressionObj.Params = _objFormulaParamsParams;
            return fExpressionObj;
        }
        public FormulaExpressionObjects MAX(LRRFormulaParams _objFormulaParamsParams)
        {
            string sPropExpression = "MAX(";
            string ModeID = "";
            foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
            {
                sPropExpression = sPropExpression + fParam.ParamName + ",";
                ModeID = fParam.ModeID;
            }
            sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf(","), 1);
            sPropExpression = sPropExpression + ")";
            sPropExpression = "RESULT = " + sPropExpression + ";";
            FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
            fExpressionObj.FormulaExpression = sPropExpression;
            fExpressionObj.Params = _objFormulaParamsParams;
            fExpressionObj.IsFormula = false;
            return fExpressionObj;
        }

        public FormulaExpressionObjects MIN(LRRFormulaParams _objFormulaParamsParams)
        {
            string sPropExpression = "MIN(";
            string ModeID = "";
            foreach (LRRFormulaParam fParam in _objFormulaParamsParams)
            {
                sPropExpression = sPropExpression + fParam.ParamName + ",";
                ModeID = fParam.ModeID;
            }
            sPropExpression = sPropExpression.Remove(sPropExpression.LastIndexOf(","), 1);
            sPropExpression = sPropExpression + ")";
            sPropExpression = "RESULT = " + sPropExpression + ";";
            FormulaExpressionObjects fExpressionObj = new FormulaExpressionObjects();
            fExpressionObj.FormulaExpression = sPropExpression;
            fExpressionObj.Params = _objFormulaParamsParams;
            fExpressionObj.IsFormula = false;
            return fExpressionObj;
        }
		#endregion

		#region Fields
			private LRRFormulaParams _objFormulaParamsParams = new LRRFormulaParams();
			private string _methodType = "";
            private Hashtable htdataSource = new Hashtable();
            private CustomCollection dataSource = null;
            private ArrayList paramsArray = new ArrayList();
            private Symcon.LightRidge.BusinessObjects.TypeEditors.ScriptEditor frmScriptEditor = new Symcon.LightRidge.BusinessObjects.TypeEditors.ScriptEditor();
            private LRRModes _lrrModes;
            private Hashtable FormulaExpHash = new Hashtable();
            private LRRFormula _lrrFormula = null;
		#endregion
	}
}



