using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.Runcontrol;
using Symcon.LightRidge.BusinessObjects;  
using Symcon.LightRidge.PEAdvisor.SavedViews;
using Symcon.ColorSchemes;
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for TimeWindow.
	/// </summary>
	public class TimeWindow : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TimeWindow()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			this.Load+=new EventHandler(TimeWindow_Load);
			LRRModel.ProjectModes.ModesChanged += new EventHandler(ProjectModes_ModesChanged);  
			_lrrApp.RunControllerObj.RunStarted+=new RunStartedDel(RunControllerObj_RunStarted);
			this._modeSlots.Compare1Mode.SourceChanged+=new EventHandler(Compare1Mode_SourceChanged);
			this._modeSlots.Compare2Mode.SourceChanged+=new EventHandler(Compare2Mode_SourceChanged);
			this._modeSlots.RefMode.SourceChanged+=new EventHandler(RefMode_SourceChanged);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}



		protected override void OnClosing(CancelEventArgs e)
		{
			e.Cancel = true;
			this.Hide();
			_lrrApp.MainFrame.Activate();
        }

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TimeWindow));
			this.panel1 = new System.Windows.Forms.Panel();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.groupBox9 = new System.Windows.Forms.GroupBox();
			this.groupBox8 = new System.Windows.Forms.GroupBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.groupBox7 = new System.Windows.Forms.GroupBox();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.txtEndTimeComp2 = new System.Windows.Forms.Label();
			this.txtEndTimeRef = new System.Windows.Forms.Label();
			this.txtEndTimeComp1 = new System.Windows.Forms.Label();
			this.txtStartTimeComp2 = new System.Windows.Forms.Label();
			this.txtStartTimeRef = new System.Windows.Forms.Label();
			this.txtStartTimeComp1 = new System.Windows.Forms.Label();
			this.lblCmp2SavedCaseMode = new System.Windows.Forms.Label();
			this.lblRefSavedCaseMode = new System.Windows.Forms.Label();
			this.lblCmp1SavedCaseMode = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.labelComp2Mode = new System.Windows.Forms.Label();
			this.labelRefMode = new System.Windows.Forms.Label();
			this.labelComp1Mode = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.lblEndTime = new System.Windows.Forms.Label();
			this.lblStartTime = new System.Windows.Forms.Label();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel2 = new System.Windows.Forms.Panel();
			this.textBoxNextRunStartTimeComp2 = new System.Windows.Forms.Label();
			this.textBoxNextRunStartTimeRef = new System.Windows.Forms.Label();
			this.textBoxNextRunStartTimeComp1 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.groupBox5);
			this.panel1.Controls.Add(this.label4);
			this.panel1.Controls.Add(this.label8);
			this.panel1.Controls.Add(this.label5);
			this.panel1.Controls.Add(this.label6);
			this.panel1.Controls.Add(this.groupBox9);
			this.panel1.Controls.Add(this.groupBox8);
			this.panel1.Controls.Add(this.groupBox4);
			this.panel1.Controls.Add(this.groupBox2);
			this.panel1.Controls.Add(this.groupBox7);
			this.panel1.Controls.Add(this.groupBox6);
			this.panel1.Controls.Add(this.groupBox3);
			this.panel1.Controls.Add(this.groupBox1);
			this.panel1.Controls.Add(this.txtEndTimeComp2);
			this.panel1.Controls.Add(this.txtEndTimeRef);
			this.panel1.Controls.Add(this.txtEndTimeComp1);
			this.panel1.Controls.Add(this.txtStartTimeComp2);
			this.panel1.Controls.Add(this.txtStartTimeRef);
			this.panel1.Controls.Add(this.txtStartTimeComp1);
			this.panel1.Controls.Add(this.lblCmp2SavedCaseMode);
			this.panel1.Controls.Add(this.lblRefSavedCaseMode);
			this.panel1.Controls.Add(this.lblCmp1SavedCaseMode);
			this.panel1.Controls.Add(this.label7);
			this.panel1.Controls.Add(this.labelComp2Mode);
			this.panel1.Controls.Add(this.labelRefMode);
			this.panel1.Controls.Add(this.labelComp1Mode);
			this.panel1.Controls.Add(this.label3);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Controls.Add(this.lblEndTime);
			this.panel1.Controls.Add(this.lblStartTime);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(474, 125);
			this.panel1.TabIndex = 24;
			// 
			// groupBox5
			// 
			this.groupBox5.Location = new System.Drawing.Point(8, 52);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(465, 2);
			this.groupBox5.TabIndex = 47;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "groupBox5";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(25, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(92, 16);
			this.label4.TabIndex = 54;
			this.label4.Tag = "SID_TIME_SOURCE";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label8
			// 
			this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label8.Image = ((System.Drawing.Image)(resources.GetObject("label8.Image")));
			this.label8.Location = new System.Drawing.Point(63, 32);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(16, 24);
			this.label8.TabIndex = 57;
			this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 20.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Image = ((System.Drawing.Image)(resources.GetObject("label5.Image")));
			this.label5.Location = new System.Drawing.Point(117, 4);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(19, 24);
			this.label5.TabIndex = 55;
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(20, 6);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(104, 16);
			this.label6.TabIndex = 56;
			this.label6.Tag = "SID_MODE_SLOTS";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// groupBox9
			// 
			this.groupBox9.Location = new System.Drawing.Point(372, 28);
			this.groupBox9.Name = "groupBox9";
			this.groupBox9.Size = new System.Drawing.Size(96, 2);
			this.groupBox9.TabIndex = 53;
			this.groupBox9.TabStop = false;
			this.groupBox9.Text = "groupBox9";
			// 
			// groupBox8
			// 
			this.groupBox8.Location = new System.Drawing.Point(147, 28);
			this.groupBox8.Name = "groupBox8";
			this.groupBox8.Size = new System.Drawing.Size(104, 2);
			this.groupBox8.TabIndex = 52;
			this.groupBox8.TabStop = false;
			this.groupBox8.Text = "groupBox8";
			// 
			// groupBox4
			// 
			this.groupBox4.Location = new System.Drawing.Point(263, 28);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(96, 2);
			this.groupBox4.TabIndex = 51;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "groupBox4";
			// 
			// groupBox2
			// 
			this.groupBox2.Location = new System.Drawing.Point(144, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(2, 136);
			this.groupBox2.TabIndex = 50;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "groupBox2";
			// 
			// groupBox7
			// 
			this.groupBox7.Location = new System.Drawing.Point(8, 100);
			this.groupBox7.Name = "groupBox7";
			this.groupBox7.Size = new System.Drawing.Size(465, 2);
			this.groupBox7.TabIndex = 49;
			this.groupBox7.TabStop = false;
			this.groupBox7.Text = "groupBox7";
			// 
			// groupBox6
			// 
			this.groupBox6.Location = new System.Drawing.Point(8, 76);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(465, 2);
			this.groupBox6.TabIndex = 48;
			this.groupBox6.TabStop = false;
			this.groupBox6.Text = "groupBox6";
			// 
			// groupBox3
			// 
			this.groupBox3.Location = new System.Drawing.Point(364, -8);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(2, 136);
			this.groupBox3.TabIndex = 45;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "groupBox3";
			// 
			// groupBox1
			// 
			this.groupBox1.Location = new System.Drawing.Point(254, -8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(2, 136);
			this.groupBox1.TabIndex = 43;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "groupBox1";
			// 
			// txtEndTimeComp2
			// 
			this.txtEndTimeComp2.Location = new System.Drawing.Point(364, 80);
			this.txtEndTimeComp2.Name = "txtEndTimeComp2";
			this.txtEndTimeComp2.Size = new System.Drawing.Size(110, 20);
			this.txtEndTimeComp2.TabIndex = 42;
			this.txtEndTimeComp2.Text = "88-88-8888 88:88:88";
			this.txtEndTimeComp2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtEndTimeRef
			// 
			this.txtEndTimeRef.Location = new System.Drawing.Point(254, 80);
			this.txtEndTimeRef.Name = "txtEndTimeRef";
			this.txtEndTimeRef.Size = new System.Drawing.Size(110, 20);
			this.txtEndTimeRef.TabIndex = 41;
			this.txtEndTimeRef.Text = "88-88-8888 88:88:88";
			this.txtEndTimeRef.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtEndTimeComp1
			// 
			this.txtEndTimeComp1.Location = new System.Drawing.Point(144, 80);
			this.txtEndTimeComp1.Name = "txtEndTimeComp1";
			this.txtEndTimeComp1.Size = new System.Drawing.Size(110, 20);
			this.txtEndTimeComp1.TabIndex = 40;
			this.txtEndTimeComp1.Text = "88-88-8888 88:88:88";
			this.txtEndTimeComp1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtStartTimeComp2
			// 
			this.txtStartTimeComp2.Location = new System.Drawing.Point(364, 56);
			this.txtStartTimeComp2.Name = "txtStartTimeComp2";
			this.txtStartTimeComp2.Size = new System.Drawing.Size(110, 20);
			this.txtStartTimeComp2.TabIndex = 39;
			this.txtStartTimeComp2.Text = "88-88-8888 88:88:88";
			this.txtStartTimeComp2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtStartTimeRef
			// 
			this.txtStartTimeRef.Location = new System.Drawing.Point(254, 56);
			this.txtStartTimeRef.Name = "txtStartTimeRef";
			this.txtStartTimeRef.Size = new System.Drawing.Size(110, 20);
			this.txtStartTimeRef.TabIndex = 38;
			this.txtStartTimeRef.Text = "88-88-8888 88:88:88";
			this.txtStartTimeRef.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtStartTimeComp1
			// 
			this.txtStartTimeComp1.Location = new System.Drawing.Point(144, 56);
			this.txtStartTimeComp1.Name = "txtStartTimeComp1";
			this.txtStartTimeComp1.Size = new System.Drawing.Size(110, 20);
			this.txtStartTimeComp1.TabIndex = 37;
			this.txtStartTimeComp1.Text = "88-88-8888 88:88:88";
			this.txtStartTimeComp1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblCmp2SavedCaseMode
			// 
			this.lblCmp2SavedCaseMode.Location = new System.Drawing.Point(379, 106);
			this.lblCmp2SavedCaseMode.Name = "lblCmp2SavedCaseMode";
			this.lblCmp2SavedCaseMode.Size = new System.Drawing.Size(80, 12);
			this.lblCmp2SavedCaseMode.TabIndex = 36;
			this.lblCmp2SavedCaseMode.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblCmp2SavedCaseMode.TextChanged += new System.EventHandler(this.lblCmp2SavedCaseMode_TextChanged);
			// 
			// lblRefSavedCaseMode
			// 
			this.lblRefSavedCaseMode.Location = new System.Drawing.Point(269, 106);
			this.lblRefSavedCaseMode.Name = "lblRefSavedCaseMode";
			this.lblRefSavedCaseMode.Size = new System.Drawing.Size(80, 12);
			this.lblRefSavedCaseMode.TabIndex = 35;
			this.lblRefSavedCaseMode.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblRefSavedCaseMode.TextChanged += new System.EventHandler(this.lblRefSavedCaseMode_TextChanged);
			// 
			// lblCmp1SavedCaseMode
			// 
			this.lblCmp1SavedCaseMode.Location = new System.Drawing.Point(159, 106);
			this.lblCmp1SavedCaseMode.Name = "lblCmp1SavedCaseMode";
			this.lblCmp1SavedCaseMode.Size = new System.Drawing.Size(80, 12);
			this.lblCmp1SavedCaseMode.TabIndex = 34;
			this.lblCmp1SavedCaseMode.Tag = "SID_REMOTE";
			this.lblCmp1SavedCaseMode.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblCmp1SavedCaseMode.TextChanged += new System.EventHandler(this.lblCmp1SavedCaseMode_TextChanged);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(8, 104);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(112, 12);
			this.label7.TabIndex = 33;
			this.label7.Tag = "SID_SOURCE";
			// 
			// labelComp2Mode
			// 
			this.labelComp2Mode.BackColor = System.Drawing.SystemColors.ControlDarkDark;
			this.labelComp2Mode.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelComp2Mode.ForeColor = System.Drawing.Color.Yellow;
			this.labelComp2Mode.Location = new System.Drawing.Point(367, 32);
			this.labelComp2Mode.Name = "labelComp2Mode";
			this.labelComp2Mode.Size = new System.Drawing.Size(105, 18);
			this.labelComp2Mode.TabIndex = 32;
			this.labelComp2Mode.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.labelComp2Mode.Click += new System.EventHandler(this.labelComp2Mode_Click);
			// 
			// labelRefMode
			// 
			this.labelRefMode.BackColor = System.Drawing.SystemColors.ControlDarkDark;
			this.labelRefMode.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelRefMode.ForeColor = System.Drawing.Color.Cyan;
			this.labelRefMode.Location = new System.Drawing.Point(257, 32);
			this.labelRefMode.Name = "labelRefMode";
			this.labelRefMode.Size = new System.Drawing.Size(105, 18);
			this.labelRefMode.TabIndex = 31;
			this.labelRefMode.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// labelComp1Mode
			// 
			this.labelComp1Mode.BackColor = System.Drawing.SystemColors.ControlDarkDark;
			this.labelComp1Mode.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelComp1Mode.ForeColor = System.Drawing.Color.Orange;
			this.labelComp1Mode.Location = new System.Drawing.Point(147, 32);
			this.labelComp1Mode.Name = "labelComp1Mode";
			this.labelComp1Mode.Size = new System.Drawing.Size(105, 18);
			this.labelComp1Mode.TabIndex = 30;
			this.labelComp1Mode.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(379, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 16);
			this.label3.TabIndex = 25;
			this.label3.Tag = "SID_COMAPARE2";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.label3.Click += new System.EventHandler(this.label3_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(269, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 24;
			this.label2.Tag = "SID_REFERENCE";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(159, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.TabIndex = 23;
			this.label1.Tag = "SID_COMAPARE1";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblEndTime
			// 
			this.lblEndTime.Location = new System.Drawing.Point(8, 83);
			this.lblEndTime.Name = "lblEndTime";
			this.lblEndTime.Size = new System.Drawing.Size(136, 16);
			this.lblEndTime.TabIndex = 20;
			this.lblEndTime.Tag = "SID_END_RUN_TIME";
			this.lblEndTime.Click += new System.EventHandler(this.lblEndTime_Click);
			// 
			// lblStartTime
			// 
			this.lblStartTime.Location = new System.Drawing.Point(8, 59);
			this.lblStartTime.Name = "lblStartTime";
			this.lblStartTime.Size = new System.Drawing.Size(136, 16);
			this.lblStartTime.TabIndex = 19;
			this.lblStartTime.Tag = "SID_START_RUN_TIME";
			// 
			// splitter1
			// 
			this.splitter1.BackColor = System.Drawing.SystemColors.ControlText;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 125);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(474, 1);
			this.splitter1.TabIndex = 25;
			this.splitter1.TabStop = false;
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.textBoxNextRunStartTimeComp2);
			this.panel2.Controls.Add(this.textBoxNextRunStartTimeRef);
			this.panel2.Controls.Add(this.textBoxNextRunStartTimeComp1);
			this.panel2.Controls.Add(this.label11);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 126);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(474, 34);
			this.panel2.TabIndex = 26;
			// 
			// textBoxNextRunStartTimeComp2
			// 
			this.textBoxNextRunStartTimeComp2.Location = new System.Drawing.Point(364, 6);
			this.textBoxNextRunStartTimeComp2.Name = "textBoxNextRunStartTimeComp2";
			this.textBoxNextRunStartTimeComp2.Size = new System.Drawing.Size(110, 20);
			this.textBoxNextRunStartTimeComp2.TabIndex = 29;
			this.textBoxNextRunStartTimeComp2.Text = "88-88-8888 88:88:88";
			this.textBoxNextRunStartTimeComp2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// textBoxNextRunStartTimeRef
			// 
			this.textBoxNextRunStartTimeRef.Location = new System.Drawing.Point(254, 6);
			this.textBoxNextRunStartTimeRef.Name = "textBoxNextRunStartTimeRef";
			this.textBoxNextRunStartTimeRef.Size = new System.Drawing.Size(110, 20);
			this.textBoxNextRunStartTimeRef.TabIndex = 28;
			this.textBoxNextRunStartTimeRef.Text = "88-88-8888 88:88:88";
			this.textBoxNextRunStartTimeRef.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// textBoxNextRunStartTimeComp1
			// 
			this.textBoxNextRunStartTimeComp1.Location = new System.Drawing.Point(144, 6);
			this.textBoxNextRunStartTimeComp1.Name = "textBoxNextRunStartTimeComp1";
			this.textBoxNextRunStartTimeComp1.Size = new System.Drawing.Size(110, 20);
			this.textBoxNextRunStartTimeComp1.TabIndex = 27;
			this.textBoxNextRunStartTimeComp1.Text = "88-88-8888 88:88:88";
			this.textBoxNextRunStartTimeComp1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(8, 7);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(136, 18);
			this.label11.TabIndex = 23;
			this.label11.Tag = "SID_NEXT_RUN_STARTTIME";
			this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// TimeWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.ClientSize = new System.Drawing.Size(474, 160);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "TimeWindow";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_TIME_WND";
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

        /// <summary>
        /// Handles the Load event of the TimeWindow control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void TimeWindow_Load(object sender, EventArgs e)
		{
			//Bind ActiveRunControl Set and result screens start and end time
			DateTime _nextRunStartDateTime;
			txtStartTimeComp2.DataBindings.Clear();
			txtStartTimeRef.DataBindings.Clear();
			txtEndTimeComp1.DataBindings.Clear();
			txtEndTimeRef.DataBindings.Clear();
			txtEndTimeComp2.DataBindings.Clear();
//			txtStartTimeComp1.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"StartTimeValue");
//			txtStartTimeComp2.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"StartTimeValue");
//			txtStartTimeRef.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"StartTimeValue");
//            txtEndTimeComp1.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"EndTimeValue");
//			txtEndTimeComp2.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"EndTimeValue");
//			txtEndTimeRef.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"EndTimeValue");
			SetModeText(); 
			SetColorForMode();
			string _nextRunStartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;//txtStartTimeComp1.Text;
			this.timeSpanUnits = Convert.ToString(_lrrApp.ActiveRunControlSet.DataWindowObj.DataWindowUnits);
			this.timeSpanValue = Convert.ToString(_lrrApp.ActiveRunControlSet.DataWindowObj.DataWindowSize);     
			DateTime _nextRunSTime = Convert.ToDateTime(_nextRunStartTime);
			if(this.timeSpanUnits == "Hr") 
			{
				_nextRunStartDateTime = _nextRunSTime.AddHours(Convert.ToDouble(this.timeSpanValue));   
			}
			else if(this.timeSpanUnits == "Min")
			{
				_nextRunStartDateTime = _nextRunSTime.AddMinutes(Convert.ToDouble(this.timeSpanValue));   
			}
			else
			{
				_nextRunStartDateTime= _nextRunSTime.AddSeconds(Convert.ToDouble(this.timeSpanValue)); 
				
			}
			_nextRunStartTime = _nextRunStartDateTime.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture.NumberFormat); /*Convert.ToString(_nextRunStartDateTime,Symcon.BusinessObjects.SymConverter.Culture);*/
			this.textBoxNextRunStartTimeComp1.Text = _nextRunStartTime;
			this.textBoxNextRunStartTimeComp2.Text = _nextRunStartTime;
			this.textBoxNextRunStartTimeRef.Text =  _nextRunStartTime;
			StartTimeRef = txtStartTimeRef.Text;
			EndTimeRef = txtEndTimeRef.Text;
			StartTimeComp1 =txtStartTimeComp1.Text;
			EndTimeComp1 =  txtEndTimeComp1.Text;
			StartTimeComp2 = txtStartTimeComp2.Text; 
			EndTimeComp2 = txtEndTimeRef.Text;

			//Bind labels for Saved cases
			lblCmp1SavedCaseMode.DataBindings.Clear();
			lblRefSavedCaseMode.DataBindings.Clear();
			lblCmp2SavedCaseMode.DataBindings.Clear();

			lblCmp1SavedCaseMode.DataBindings.Add("Text",this.ModeSlotsObj.Compare1Mode,"Source");
			lblRefSavedCaseMode.DataBindings.Add("Text",this.ModeSlotsObj.RefMode,"Source");
			lblCmp2SavedCaseMode.DataBindings.Add("Text",this.ModeSlotsObj.Compare2Mode,"Source");

			txtStartTimeComp1.DataBindings.Add("Text",this.ModeSlotsObj.Compare1Mode,"StartTime");
			txtStartTimeComp2.DataBindings.Add("Text",this.ModeSlotsObj.Compare2Mode,"StartTime");
			txtStartTimeRef.DataBindings.Add("Text",this.ModeSlotsObj.RefMode,"StartTime");
			txtEndTimeComp1.DataBindings.Add("Text",this.ModeSlotsObj.Compare1Mode,"EndTime");
			txtEndTimeComp2.DataBindings.Add("Text",this.ModeSlotsObj.Compare2Mode,"EndTime");
			txtEndTimeRef.DataBindings.Add("Text",this.ModeSlotsObj.RefMode,"EndTime");

		}

		#region Fields
		private LRRApp  _lrrApp;
		public string timeSpanValue = null;
        public string timeSpanUnits = null;
		public string StartTimeRef = null;
		public string EndTimeRef = null;
		public string StartTimeComp1 = null;
		public string EndTimeComp1 = null;
		public string StartTimeComp2 = null;
		public string EndTimeComp2 = null;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label lblCmp2SavedCaseMode;
		private System.Windows.Forms.Label lblRefSavedCaseMode;
		private System.Windows.Forms.Label lblCmp1SavedCaseMode;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label labelComp2Mode;
		private System.Windows.Forms.Label labelRefMode;
		private System.Windows.Forms.Label labelComp1Mode;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblEndTime;
		private System.Windows.Forms.Label lblStartTime;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label txtStartTimeComp1;
		private System.Windows.Forms.Label txtStartTimeRef;
		private System.Windows.Forms.Label txtStartTimeComp2;
		private System.Windows.Forms.Label txtEndTimeComp1;
		private System.Windows.Forms.Label txtEndTimeRef;
		private System.Windows.Forms.Label txtEndTimeComp2;
		private System.Windows.Forms.Label textBoxNextRunStartTimeComp1;
		private System.Windows.Forms.Label textBoxNextRunStartTimeRef;
		private System.Windows.Forms.Label textBoxNextRunStartTimeComp2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.GroupBox groupBox7;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.GroupBox groupBox8;
		private System.Windows.Forms.GroupBox groupBox9;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label8;

		private ModeSlots _modeSlots = new ModeSlots();
		#endregion

		#region Properties
		public ModeSlots ModeSlotsObj
		{
			get{return _modeSlots;}
			set
			{
				_modeSlots = value;
			}
		}
		#endregion

        /// <summary>
        /// Handles the ModesChanged event of the ProjectModes control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void ProjectModes_ModesChanged(object sender, EventArgs e)
		{
			SetModeText();
			SetColorForMode();
		}

        /// <summary>
        /// Runs the controller obj_ run started.
        /// </summary>
        /// <param name="e">The <see cref="Symcon.LightRidge.PEAdvisor.RunStartedEventArgs"/> instance containing the event data.</param>
		private void RunControllerObj_RunStarted(RunStartedEventArgs e)
		{
			if(this.ModeSlotsObj.Compare1Mode.Source == SourceEnum.LOCAL)
			{
				this.ModeSlotsObj.Compare1Mode.StartTime = e.StartTime;
				this.ModeSlotsObj.Compare1Mode.EndTime = e.EndTime;
			}
			if(this.ModeSlotsObj.RefMode.Source == SourceEnum.LOCAL)
			{
				this.ModeSlotsObj.RefMode.StartTime = e.StartTime;
				this.ModeSlotsObj.RefMode.EndTime = e.EndTime;
			}
			if(this.ModeSlotsObj.Compare2Mode.Source == SourceEnum.LOCAL)
			{
				this.ModeSlotsObj.Compare2Mode.StartTime = e.StartTime;
				this.ModeSlotsObj.Compare2Mode.EndTime = e.EndTime;
			}
		}

		# region Private Methods

		private void SetModeText()
		{
			LRRMode lrrCmp1Mode = LRRModel.ProjectModes.GetModeByType("1");
			LRRMode lrrRefMode = LRRModel.ProjectModes.GetModeByType("2");
			LRRMode lrrCmp2Mode = LRRModel.ProjectModes.GetModeByType("3");

			string comp1Mode = "";
			string refMode = "";
			string comp2Mode = "";

			if(lrrCmp1Mode != null)
				comp1Mode = lrrCmp1Mode.ModeId;
			if(lrrRefMode != null)
				refMode = lrrRefMode.ModeId;
			if(lrrCmp2Mode != null)
				comp2Mode = lrrCmp2Mode.ModeId;


			if(comp1Mode == "1")
			{
				labelComp1Mode.Text = LRRHeaderText.GetHeaderString("SID_MEAS");
			}	
			else if(comp1Mode == "2")
			{
				labelComp1Mode.Text = LRRHeaderText.GetHeaderString("SID_SS");
			}
			else if(comp1Mode == "3")
			{
				labelComp1Mode.Text = LRRHeaderText.GetHeaderString("SID_SCENARIOS");
			}
			if(comp2Mode == "1")
			{
				labelComp2Mode.Text = LRRHeaderText.GetHeaderString("SID_MEAS");
			}	
			else if(comp2Mode == "2")
			{
				labelComp2Mode.Text = LRRHeaderText.GetHeaderString("SID_SS");
			}
			else if(comp2Mode == "3")
			{
				labelComp2Mode.Text = LRRHeaderText.GetHeaderString("SID_SCENARIOS");
			}
			if(refMode == "1")
			{
				labelRefMode.Text = LRRHeaderText.GetHeaderString("SID_MEAS");
			}	
			else if(refMode == "2")
			{
				labelRefMode.Text = LRRHeaderText.GetHeaderString("SID_SS");
			}
			else if(refMode == "3")
			{
				labelRefMode.Text = LRRHeaderText.GetHeaderString("SID_SCENARIOS");
			}
		}
		private void SetColorForMode()
		{
			ColorScheme colorScheme = _lrrApp.LRRUIManagerObj.ColorSchemeObj;
			if(labelComp1Mode.Text == LRRHeaderText.GetHeaderString("SID_MEAS"))
			{
				labelComp1Mode.ForeColor = colorScheme.GroupPropertiesColors.MeasModeColor;
			}
			if(labelComp2Mode.Text == LRRHeaderText.GetHeaderString("SID_MEAS"))
			{
				labelComp2Mode.ForeColor = colorScheme.GroupPropertiesColors.MeasModeColor;
			}
			if(labelRefMode.Text == LRRHeaderText.GetHeaderString("SID_MEAS"))
			{
				labelRefMode.ForeColor  = colorScheme.GroupPropertiesColors.MeasModeColor;
			}
			if(labelComp1Mode.Text == LRRHeaderText.GetHeaderString("SID_SS"))
			{
				labelComp1Mode.ForeColor = colorScheme.GroupPropertiesColors.SsModeColor;
			}
			if(labelComp2Mode.Text == LRRHeaderText.GetHeaderString("SID_SS"))
			{
				labelComp2Mode.ForeColor = colorScheme.GroupPropertiesColors.SsModeColor;
			}
			if(labelRefMode.Text == LRRHeaderText.GetHeaderString("SID_SS"))
			{
				labelRefMode.ForeColor = colorScheme.GroupPropertiesColors.SsModeColor;
			}
			if(labelComp1Mode.Text == LRRHeaderText.GetHeaderString("SID_SCENARIOS"))
			{
				labelComp1Mode.ForeColor = colorScheme.GroupPropertiesColors.ScenarioModeColor;
			}
			if(labelComp2Mode.Text == LRRHeaderText.GetHeaderString("SID_SCENARIOS"))
			{
				labelComp2Mode.ForeColor = colorScheme.GroupPropertiesColors.ScenarioModeColor;
			}
			if(labelRefMode.Text == LRRHeaderText.GetHeaderString("SID_SCENARIOS"))
			{
				labelRefMode.ForeColor = colorScheme.GroupPropertiesColors.ScenarioModeColor;
			}
		}

#endregion


		private void txtEndTimeComp2_TextChanged(object sender, System.EventArgs e)
		{
		
		}

		private void labelComp2Mode_Click(object sender, System.EventArgs e)
		{
		
		}

		private void label3_Click(object sender, System.EventArgs e)
		{
		
		}

        /// <summary>
        /// Clears the saved case.
        /// </summary>
        /// <param name="caseID">The case ID.</param>
        /// <param name="modeID">The mode ID.</param>
		private void ClearSavedCase(string caseID,string modeID)
		{
			LRRSavedCaseUserMap savedCaseUserMap = new LRRSavedCaseUserMap();
			_lrrApp.DBManagerObj.PopulateObject(savedCaseUserMap,typeof(LRRSavedCaseUserMap)," where SavedCaseID = '" + caseID + "' AND CaseOpenedByUserID = '" + _lrrApp.DBManagerObj.AccessControlModel.UserID + "'"); 
				
			savedCaseUserMap.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
			_lrrApp.DBManagerObj.CommitObject(savedCaseUserMap);
			
			//Populate Aggregate Property Value,SiteComponentPropertyValues,Qualifier Value
			LRRAggregatePropertyValues aggrPropvalues = new LRRAggregatePropertyValues();
			_lrrApp.DBManagerObj.PopulateCollection(aggrPropvalues," WHERE ModeID ='" + modeID + "'");

			LRRSiteComponentPropertyValues siteCompPropvalues = new LRRSiteComponentPropertyValues();
			_lrrApp.DBManagerObj.PopulateCollection(siteCompPropvalues," WHERE ModeID ='" + modeID + "'");

			LRRSiteGroupPropertyQualifierValues siteGrpPropQualvalues = new LRRSiteGroupPropertyQualifierValues();
			_lrrApp.DBManagerObj.PopulateCollection(siteGrpPropQualvalues," WHERE ModeID ='" + modeID + "'");

			//Update Aggregate Property Value Model
			IEnumerator iAggrPropValueEnum = aggrPropvalues.GetEnumerator();
			while(iAggrPropValueEnum.MoveNext())
			{
				LRRAggregatePropertyValue aggrPropValue = iAggrPropValueEnum.Current as LRRAggregatePropertyValue;
				LRRAggregatePropertyValue modelAggrPropValue = LRRModel.AggregatePropertyValuesObj.FindAggregatePropertyValueByID(aggrPropValue.ID);
				if(modelAggrPropValue != null)
				{
					modelAggrPropValue.PropertyValue = aggrPropValue.PropertyValue;
					modelAggrPropValue.ReadOnlyAccess = aggrPropValue.ReadOnlyAccess;
				}
			}
			
			//Update Site Component Property Value Model
			IEnumerator iSiteCompPropValueEnum = siteCompPropvalues.GetEnumerator();
			while(iSiteCompPropValueEnum.MoveNext())
			{
				LRRSiteComponentPropertyValue siteCompPropValue = iSiteCompPropValueEnum.Current as LRRSiteComponentPropertyValue;
				LRRSiteComponentPropertyValue modelSitePropValue = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(siteCompPropValue.ID);
				if(modelSitePropValue != null)
				{
					modelSitePropValue.ReadOnlyAccess = siteCompPropValue.ReadOnlyAccess;
					modelSitePropValue.IsEditable = siteCompPropValue.IsEditable;
					modelSitePropValue.PropertyValue = siteCompPropValue.PropertyValue;
				}
			}

			//Update Qualifier Value Model
			IEnumerator iQualValueEnum = siteGrpPropQualvalues.GetEnumerator();
			while(iQualValueEnum.MoveNext())
			{
				LRRSiteGroupPropertyQualifierValue siteGrpPropQualValue = iQualValueEnum.Current as LRRSiteGroupPropertyQualifierValue;
				LRRSiteGroupPropertyQualifierValue modelQualValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(siteGrpPropQualValue.SiteGroupPropertyQualifierValueID);
				if(modelQualValue != null)
				{
					modelQualValue.ReadOnlyAccess = siteGrpPropQualValue.ReadOnlyAccess;
					modelQualValue.IsEditable = siteGrpPropQualValue.IsEditable;
					modelQualValue.PropertyValue = siteGrpPropQualValue.PropertyValue;
				}
			}
		}

		private void Compare1Mode_SourceChanged(object sender, EventArgs e)
		{
//			ModeSlot currentModeSlot = sender as ModeSlot;
//			LRRMode compare1Mode =  LRRModel.ProjectModes.GetModeByType("1");
//			if(currentModeSlot.Source != SourceEnum.LIVE)
//			{
////				if(MessagingClient.IsInitialized)
////					MessagingClient.SrvObj.RemoveSubscribedMode(compare1Mode.ModeId);
//			}
//			if(currentModeSlot.Source != SourceEnum.REMOTE)
//			{
//				if(currentModeSlot.CaseID != null && currentModeSlot.CaseID.Trim() != "")
//					ClearSavedCase(currentModeSlot.CaseID,compare1Mode.ModeId);
//			}
		}

		private void Compare2Mode_SourceChanged(object sender, EventArgs e)
		{
//			ModeSlot currentModeSlot = sender as ModeSlot;
//			LRRMode compare2Mode =  LRRModel.ProjectModes.GetModeByType("3");
//			if(currentModeSlot.Source != SourceEnum.LIVE)
//			{
////				if(MessagingClient.IsInitialized)
////					MessagingClient.SrvObj.RemoveSubscribedMode(compare2Mode.ModeId);
//			}
//			if(currentModeSlot.Source != SourceEnum.REMOTE)
//			{
//				if(currentModeSlot.CaseID != null && currentModeSlot.CaseID.Trim() != "")
//					ClearSavedCase(currentModeSlot.CaseID,compare2Mode.ModeId );
//			}
		}

		private void RefMode_SourceChanged(object sender, EventArgs e)
		{
//			ModeSlot currentModeSlot = sender as ModeSlot;
//			LRRMode refMode =  LRRModel.ProjectModes.GetModeByType("2");
//			if(currentModeSlot.Source != SourceEnum.LIVE)
//			{
////				if(MessagingClient.IsInitialized)
////					MessagingClient.SrvObj.RemoveSubscribedMode(refMode.ModeId);
//			}
//			if(currentModeSlot.Source != SourceEnum.REMOTE)
//			{
//				if(currentModeSlot.CaseID != null && currentModeSlot.CaseID.Trim() != "")
//					ClearSavedCase(currentModeSlot.CaseID,refMode.ModeId);
//			}
		}

		private void lblEndTime_Click(object sender, System.EventArgs e)
		{
		
		}

        /// <summary>
        /// Handles the TextChanged event of the lblCmp1SavedCaseMode control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void lblCmp1SavedCaseMode_TextChanged(object sender, System.EventArgs e)
		{
			if(lblCmp1SavedCaseMode.Text == "LOCAL")
			{
				lblCmp1SavedCaseMode.Text = LRRHeaderText.GetHeaderString("SID_LOCAL");
			}
			else
			{
				lblCmp1SavedCaseMode.Text = LRRHeaderText.GetHeaderString("SID_REMOTE");
			}
		}

		private void lblRefSavedCaseMode_TextChanged(object sender, System.EventArgs e)
		{
			if(lblRefSavedCaseMode.Text == "LOCAL")
			{
				lblRefSavedCaseMode.Text = LRRHeaderText.GetHeaderString("SID_LOCAL");
			}
			else
			{
				lblRefSavedCaseMode.Text = LRRHeaderText.GetHeaderString("SID_REMOTE");
			}
		}

        /// <summary>
        /// Handles the TextChanged event of the lblCmp2SavedCaseMode control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void lblCmp2SavedCaseMode_TextChanged(object sender, System.EventArgs e)
		{
			if(lblCmp2SavedCaseMode.Text == "LOCAL")
			{
				lblCmp2SavedCaseMode.Text = LRRHeaderText.GetHeaderString("SID_LOCAL");
			}
			else
			{
				lblCmp2SavedCaseMode.Text = LRRHeaderText.GetHeaderString("SID_REMOTE");
			}
		}
	}
}
