using System;
using System.Collections;
using Symcon.BusinessObjects;
using Symcon.Globals; 

namespace Symcon.LightRidge.PEAdvisor.GridUtilities
{
	/// <summary>
	/// Summary description for TimeComparer.
	/// </summary>
	public class TimeComparer:IComparer
	{
		public TimeComparer()
		{
			//
			// TODO: Add constructor logic here
			//
		}

        /// <summary>
        /// Column(public property of the class) to be sorted.
        /// </summary>
        /// <value>The sort column.</value>
		public string SortColumn
		{
			get{return sortcolumn;}set{sortcolumn = value;}
		}
		
		/// <summary>
		/// Sorting order.
		/// </summary>
		public int SortingOrder
		{
			get{return sortingOrder;}set{sortingOrder = value;}
		}
		#region Fields
		public string sortcolumn = "";
		public int sortingOrder = 0;
		#endregion


		#region IComparer Members

        /// <summary>
        /// Compares two objects and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <param name="x">The first object to compare.</param>
        /// <param name="y">The second object to compare.</param>
        /// <returns>
        /// Value Condition Less than zero x is less than y. Zero x equals y. Greater than zero x is greater than y.
        /// </returns>
        /// <exception cref="T:System.ArgumentException">Neither x nor y implements the <see cref="T:System.IComparable"></see> interface.-or- x and y are of different types and neither one can handle comparisons with the other. </exception>
		public int Compare(object x, object y)
		{
			return CheckSort(x, y,0);
		}

        /// <summary>
        /// Checks the sort.
        /// </summary>
        /// <param name="x">The x.</param>
        /// <param name="y">The y.</param>
        /// <param name="sortLevel">The sort level.</param>
        /// <returns></returns>
		public int CheckSort(object x,object y, int sortLevel)
		{
			UpdatedObject obj1 = (UpdatedObject)x;
			UpdatedObject obj2 = (UpdatedObject)y;

			//Compare based on the sorting order.
			int result = -2;
			if(sortLevel == 0)
			{
				if(sortingOrder == 0)
				{
					result = obj2.Tick.CompareTo(obj1.Tick);   
				}
			}
			return result;
		}

		#endregion
	}
}
