using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageLogger;


namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
	/// <summary>
	/// Summary description for GroupedPlantDataArrays.
	/// </summary>
	public class GroupedPlantDataArrays : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.TreeView trvGroupType;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


		private TabControl							_parentTabControl;
		private TabPage								_parentTabPage;
		private	LRRApp								_lrrApp; //All object to access the DB Manager and DB Adapter
		private LRRPropertyTypes					_lrrPropertyTypes;
		private LRRLookUpQualifiers					_lrrLookUpQualifiers;
	//	private LRRLookUpProperties					_lrrLkUpPpties;
		private LRRSiteComponents					_siteComponents=null ; //Instance for the site components ...
		private LRRSiteComponentProperties			_siteCompProperties=null; //Instance for the properties...
		private LRRSiteComponentGroupProperties		_siteCompGroupedProperties=null;
		private LRRSiteGroupPropertyQualifierValues	_siteGroupPropertyQualifierValues=null;
		private LRRHistDatas						_lrrHistdata;
		private LRRUOMs								_lrrUOMs;
		private string								_sSelectedQualifierID;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGP;
		private Hashtable							_lrrFormulaGroupedProperties = new Hashtable();
		private string								_groupPropId=null;
        private LRRAggregates _lrrAggregates;
        private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
        
		public GroupedPlantDataArrays()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            this.gridGP.TableControlCurrentCellKeyPress += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventHandler(this.gridGP_TableControlCurrentCellKeyPress);
            this.gridGP.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridGP_RecordDeleting);
            this.gridGP.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridGP_CurrentRecordContextChange);
		

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridGP);
			InitDataSource();

			BindGridGPType();

            _gridExcelFormatter.WireGrid(gridGP);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.trvGroupType = new System.Windows.Forms.TreeView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.gridGP = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGP)).BeginInit();
			this.SuspendLayout();
			// 
			// trvGroupType
			// 
			this.trvGroupType.Dock = System.Windows.Forms.DockStyle.Left;
			this.trvGroupType.ImageIndex = -1;
			this.trvGroupType.Location = new System.Drawing.Point(0, 0);
			this.trvGroupType.Name = "trvGroupType";
			this.trvGroupType.SelectedImageIndex = -1;
			this.trvGroupType.Size = new System.Drawing.Size(176, 390);
			this.trvGroupType.Sorted = true;
			this.trvGroupType.TabIndex = 0;
			this.trvGroupType.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.trvGroupType_AfterSelect);
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(176, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 390);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// gridGP
			// 
			this.gridGP.BackColor = System.Drawing.SystemColors.Window;
			this.gridGP.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridGP.Location = new System.Drawing.Point(179, 0);
			this.gridGP.Name = "gridGP";
			this.gridGP.Size = new System.Drawing.Size(541, 390);
			this.gridGP.TabIndex = 2;
			this.gridGP.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridGP.Text = "gridGP";
			this.gridGP.VersionInfo = "3.301.0.0";
			// 
			// GroupedPlantDataArrays
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(720, 390);
			this.Controls.Add(this.gridGP);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.trvGroupType);
			this.Name = "GroupedPlantDataArrays";
			this.Text = "GroupedPlantDataArrays";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Activated += new System.EventHandler(this.GroupedPlantDataArrays_Activated);
			((System.ComponentModel.ISupportInitialize)(this.gridGP)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		#region private methods


        /// <summary>
        /// Inits the data source.
        /// </summary>
		private void InitDataSource()
		{
			if(_lrrPropertyTypes != null)
				_lrrPropertyTypes.Clear();
				
			if(_lrrLookUpQualifiers != null)
				_lrrLookUpQualifiers.Clear();

//			if(_lrrLkUpPpties != null)
//				_lrrLkUpPpties.Clear();
				
			_lrrPropertyTypes=new LRRPropertyTypes();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrPropertyTypes," WHERE ID NOT IN ('0','1','2') and IsDataArray=true ", false);
				
			_lrrLookUpQualifiers=new LRRLookUpQualifiers();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLookUpQualifiers,false);

            _lrrAggregates = LRRModel.AggregatesObj;

//			_lrrLkUpPpties=new LRRLookUpProperties();
//			_lrrApp.DBManagerObj.PopulateCollection(_lrrLkUpPpties,false);

			_siteComponents = LRRModel.SiteComponentsObj;
			_siteCompProperties = LRRModel.SiteComponentPropertiesObj;
			_siteCompGroupedProperties = LRRModel.SiteComponentGroupPropertiesObj;
			_siteGroupPropertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj;
			_lrrHistdata = LRRModel.HistDatas;
			_lrrUOMs = LRRModel.ChildModel.UOMs;
		
			_sSelectedQualifierID = "6";

			LRRMasterComponents masterComponents = LRRModel.Model;
			_lrrFormulaGroupedProperties.Clear();
			_lrrFormulaGroupedProperties.Add(0,masterComponents);
			_lrrFormulaGroupedProperties.Add(1,"MasterComponents");
			_lrrFormulaGroupedProperties.Add(2,"SiteComponentsObj");
			_lrrFormulaGroupedProperties.Add(3,"Properties");
			_lrrFormulaGroupedProperties.Add(4,"GroupPpties");
			_lrrFormulaGroupedProperties.Add(5,"GroupPptiesQualifierValues");
			_lrrFormulaGroupedProperties.Add(6,_lrrLookUpQualifiers);
			//_lrrFormulaGroupedProperties.Add(7,_lrrLkUpPpties);
            _lrrFormulaGroupedProperties.Add(7, _lrrAggregates);
			LRRFormulaDataStore.ShowGroupedAttributes = true;
			LRRFormulaDataStore.DataSource = _lrrFormulaGroupedProperties ;
			LRRFormulaDataStore.ModeFlag = true;
			
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;
			LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteGroupPropertyQualifierValue).ToString();
		}

        /// <summary>
        /// Binds the type of the grid GP.
        /// </summary>
		private void BindGridGPType()
		{
			trvGroupType.Sorted = true;
			trvGroupType.Nodes.Clear();
			trvGroupType.SuspendLayout();
			TreeNode tnav = new TreeNode();
			tnav.Text = "Group Data Arrays";
			tnav.Expand();

			tnav = CreateChildForNode(tnav);

			trvGroupType.Nodes.Add(tnav);
			if(trvGroupType.Nodes.Count > 0)
				trvGroupType.SelectedNode = trvGroupType.Nodes[0];
			trvGroupType.ResumeLayout(true);
            trvGroupType.TreeViewNodeSorter = new TreeNodeSorter();
            trvGroupType.Sort();
		}

        /// <summary>
        /// Creates the child for node.
        /// </summary>
        /// <param name="oNode">The o node.</param>
        /// <returns></returns>
		private TreeNode CreateChildForNode(TreeNode oNode)
		{
			foreach(LRRPropertyType oPropertyType in _lrrPropertyTypes)
			{
				TreeNode child = new TreeNode();
				child.Tag =	oPropertyType;
				child.Text = oPropertyType.PropertyType;
				child = CreateQualifiersChildForNode(child,oPropertyType.ID);
				oNode.Nodes.Add(child);
			}
			return oNode;
		}
        /// <summary>
        /// Creates the qualifiers child for node.
        /// </summary>
        /// <param name="oNode">The o node.</param>
        /// <param name="sPropTypeID">The s prop type ID.</param>
        /// <returns></returns>
		private TreeNode CreateQualifiersChildForNode(TreeNode oNode, string sPropTypeID)
		{
			LRRLookUpQualifiers oQualifiersForPropType = _lrrLookUpQualifiers.getLookUpQualifiersForPropType(sPropTypeID);

			foreach(LRRLookUpQualifier oLkupQualifier in oQualifiersForPropType)
			{
				TreeNode child = new TreeNode();
				child.Tag =	oLkupQualifier;
				LRRQualifier oQualifier =LRRModel.Qualifiers.getQualifierObjectForQualifierID(oLkupQualifier.QualifierID);
				if(oQualifier != null)
				{
					child.Text = oQualifier.Name == null ? "" : oQualifier.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					oNode.Nodes.Add(child);
				}
			}
			return oNode;
		}

		/// <summary>
		/// This method is used to bind the Grouping Grid
		/// </summary>
		private void BindGridGP()
		{
			
			//Suspend the Layout of the Grid...
            gridGP.BeginUpdate();
			gridGP.SuspendLayout();
			this.gridGP.TableDescriptor.RecordFilters.Clear();
			this.gridGP.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			
			gridGP.TableDescriptor.Relations.Clear();
			gridGP.Engine.SourceListSet.Clear();

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_siteComponents.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_lrrApp.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

			SyncGridUtilities.InitializeGridColumns(gridGP,_siteComponents.ItemType,null,fkData);
			//Set the data source for the grid
			
			gridGP.DataSource = _siteComponents;
			//Add the parent table for the Relations...
			gridGP.Engine.SourceListSet.Add("ParentTable",_siteComponents);
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("PlantUnit_Name")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("PlantUnit_Name")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("MasterComponentType_ComponentName")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("MasterComponentType_ComponentName")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			
			gridGP.TableDescriptor.AllowRemove = false;
			gridGP.TableDescriptor.AllowNew = false;
			gridGP.TableDescriptor.AllowEdit = true;//false;

			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("PlantUnit_Name")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("MasterComponentType_ComponentName")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("Name")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("EquipmentTag")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridGP.TableDescriptor.Columns[gridGP.TableDescriptor.Columns.IndexOf("EffectivePlantTime")].Appearance.AnyRecordFieldCell.ReadOnly = true;


            
            

			//Properties for the site component
			GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
			grdCompProps.ChildTableName = "Properties";
			grdCompProps.RelationKeys.Add("SiteComponentID","ComponentID");
			grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.DarkGoldenrod;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");
			gridGP.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
			grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			gridGP.TableDescriptor.Relations.Add(grdCompProps);
			gridGP.Engine.SourceListSet.Add("Properties",_siteCompProperties);

			SyncGridUtilities.InitializeGridColumns(gridGP,grdCompProps.ChildTableDescriptor,_siteCompProperties.ItemType,null);
			grdCompProps.ChildTableDescriptor.Columns["UOM"].AllowFilter = false;
			grdCompProps.ChildTableDescriptor.Columns["HistTagID"].AllowFilter = false;
			grdCompProps.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";

			GridTableCellStyleInfo gtc1 = grdCompProps.ChildTableDescriptor.Columns["UOM"].Appearance.AnyRecordFieldCell;
			gtc1.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;					
			gtc1.ExclusiveChoiceList = false;
			
			
			//			GridTableCellStyleInfo gtc = grdCompProps.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell;
			//			gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			//			gtc.DataSource = _lrrHistdata; 
			//			gtc.ValueMember	= "HistTagUID";
			//			gtc.DisplayMember =	"HistTag";
			grdCompProps.ChildTableDescriptor.Columns.Remove("HistTagID");
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOM")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOM")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("Type_PropertyType")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("Type_PropertyType")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("IsTracked")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("IsTracked")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

			grdCompProps.ChildTableDescriptor.AllowRemove = false;
			grdCompProps.ChildTableDescriptor.AllowNew = false;
			grdCompProps.ChildTableDescriptor.AllowEdit = true;//false;

			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOM")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("Type_PropertyType")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("IsTracked")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("IsTrended")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("EffectivePlantTime")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("Name")].Appearance.AnyRecordFieldCell.ReadOnly = true;


						
			//Grouped Properties for the site component
			GridRelationDescriptor grdCompGroupedProps = new GridRelationDescriptor("GroupedProperties");
			grdCompGroupedProps.ChildTableName = "GroupedProperties";
			grdCompGroupedProps.RelationKeys.Add("ID","SiteComponentPropID");
			grdCompGroupedProps.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompGroupedProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Red;
			grdCompGroupedProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;

			grdCompGroupedProps.ChildTableDescriptor.AllowEdit = true;//false;
			grdCompGroupedProps.ChildTableDescriptor.AllowRemove = false;
			grdCompGroupedProps.ChildTableDescriptor.AllowNew= false;

			grdCompGroupedProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_VALUES")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");
			grdCompGroupedProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			grdCompProps.ChildTableDescriptor.Relations.Add(grdCompGroupedProps);
			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("GroupedProperties",_siteCompGroupedProperties); 
			SyncGridUtilities.InitializeGridColumns(gridGP,grdCompGroupedProps.ChildTableDescriptor,_siteCompGroupedProperties.ItemType,null);
			
			grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			grdCompGroupedProps.ChildTableDescriptor.Columns.Remove("HistTagID");

			grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("AttributeName")].Appearance.AnyRecordFieldCell.ReadOnly = true;
			grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ReadOnly = true;

						//***************************************************************************************

			//Property Values for the Grouped Property
			GridRelationDescriptor grdCompPropGrpValues = new GridRelationDescriptor("GroupPropertyValues");
			grdCompPropGrpValues.ChildTableName = "GroupPropertyValues";
			grdCompPropGrpValues.RelationKeys.Add("GroupPropertyID","GroupPropertyID");
			grdCompPropGrpValues.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompPropGrpValues.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.OrangeRed;
			grdCompPropGrpValues.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;

			grdCompPropGrpValues.ChildTableDescriptor.AllowEdit = true;
			grdCompPropGrpValues.ChildTableDescriptor.AllowRemove = true;
			grdCompPropGrpValues.ChildTableDescriptor.AllowNew = false;
			

			grdCompPropGrpValues.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_VALUES")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");
			grdCompPropGrpValues.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			grdCompGroupedProps.ChildTableDescriptor.Relations.Add(grdCompPropGrpValues);
			grdCompGroupedProps.ChildTableDescriptor.Engine.SourceListSet.Add("GroupPropertyValues",_siteGroupPropertyQualifierValues); 
			SyncGridUtilities.InitializeGridColumns(gridGP,grdCompPropGrpValues.ChildTableDescriptor,_siteGroupPropertyQualifierValues.ItemType,null);
			grdCompPropGrpValues.ChildTableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			GridTableCellStyleInfo gtc2 = grdCompPropGrpValues.ChildTableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell;
			gtc2.CellType = "ComboBox";
			gtc2.DataSource = _lrrUOMs; 
			gtc2.DisplayMember = "Name";
			gtc2.ValueMember = "ID";

			grdCompPropGrpValues.ChildTableDescriptor.Columns[grdCompPropGrpValues.ChildTableDescriptor.Columns.IndexOf("ModelUOM")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompPropGrpValues.ChildTableDescriptor.Columns[grdCompPropGrpValues.ChildTableDescriptor.Columns.IndexOf("ModelUOM")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

			gridGP.NestedTableGroupOptions.ShowFilterBar = true;
			grdCompPropGrpValues.ChildTableDescriptor.Columns[grdCompPropGrpValues.ChildTableDescriptor.Columns.IndexOf("ModeID_ModeName")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompPropGrpValues.ChildTableDescriptor.Columns[grdCompPropGrpValues.ChildTableDescriptor.Columns.IndexOf("ModeID_ModeName")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			grdCompPropGrpValues.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";
			GridTableCellStyleInfo gtcs = grdCompPropGrpValues.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell;
			gtcs.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			gtcs.DataSource = _lrrHistdata; 
			gtcs.ValueMember	= "HistTagUID";
			gtcs.DisplayMember =	"HistTag";

			gridGP.TableControlQueryAllowSortColumn+=new GridQueryAllowSortColumnEventHandler(gridGP_TableControlQueryAllowSortColumn);
			gridGP.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridGP_QueryCellStyleInfo);
			grdCompPropGrpValues.ChildTableDescriptor.RecordDeleting+=new RecordEventHandler(ChildTableDescriptor_RecordDeleting);
			//Resume the Layout of the Grid...
			gridGP.ResumeLayout(true);
            gridGP.EndUpdate(false);
		}

	
		#endregion

		#region Events
		private TreeNode prevSelNode=null;

		private void trvGroupType_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
            try
            {
                if (e.Action == TreeViewAction.Unknown)
                {
                    return;
                }
                if(e.Action == TreeViewAction.ByMouse || e.Action == TreeViewAction.ByKeyboard)
                    LRRWaitWindowUtility.ShowPogressIndicator(e.Node.Text);
                this.Cursor = Cursors.WaitCursor;

                ApplicationPersistanceUtil.SaveGridSettings(gridGP, this as ILRRUIContainer, this.Tag);
                if (prevSelNode != null)
                    prevSelNode.ForeColor = Color.Black;
                e.Node.ForeColor = Color.Blue;
                prevSelNode = e.Node;
                LRRPropertyType groupType = null;
                _siteCompGroupedProperties = new LRRSiteComponentGroupProperties();
                _siteGroupPropertyQualifierValues = new LRRSiteGroupPropertyQualifierValues();
                if (this.trvGroupType.SelectedNode.Tag != null)
                {
                    switch (this.trvGroupType.SelectedNode.Tag.GetType().ToString())
                    {
                        case "Symcon.LightRidge.BusinessObjects.LRRPropertyType":
                            groupType = this.trvGroupType.SelectedNode.Tag as LRRPropertyType;
                            break;
                        default:
                            break;
                    }
                    if (groupType != null)
                    {
                        _siteComponents = LRRModel.SiteComponentsObj.FilterSiteComponentsByPropertyType(groupType.ID);
                        _siteCompProperties = LRRModel.SiteComponentPropertiesObj.FilterPropertiesByPropertyType(groupType.ID);
                        foreach (LRRSiteComponentProperty oProp in _siteCompProperties)
                        {
                            LRRSiteComponentGroupProperties oGpProps = oProp.GroupPpties;
                            foreach (LRRSiteComponentGroupProperty oGProp in oGpProps)
                            {
                                _siteCompGroupedProperties.Add(oGProp);
                                List<IPropertyValue> oGroupPropertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(oGProp.GroupPropertyID);
                                if (oGroupPropertyQualifierValues != null)
                                {
                                    foreach (LRRSiteGroupPropertyQualifierValue grpPropQualvalue in oGroupPropertyQualifierValues)
                                    {
                                        _siteGroupPropertyQualifierValues.Add(grpPropQualvalue);
                                    }
                                }
                            }
                        }
                    }
                    BindGridGP();
                }
                else
                {
                    _siteComponents = LRRModel.SiteComponentsObj.FilterSiteComponentsByID(null);
                    BindGridGP();
                }
                ApplicationPersistanceUtil.ApplyGridSettings(gridGP, this as ILRRUIContainer, this.Tag);
                this.Cursor = Cursors.Default;
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(GroupedPlantDataArrays), "AfterSelect : " + ex, Logger.Level.Debug);
            }
            finally
            {
                if (e.Action == TreeViewAction.ByMouse || e.Action == TreeViewAction.ByKeyboard)
                    LRRWaitWindowUtility.EndProgressIndicator();
            }
		}

		private void gridGP_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
		  try
		   {
		     if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
		     {  
	             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
	             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
		     }  
		  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		}
		private void gridGP_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			if(e.Action == CurrentRecordAction.EnterRecordComplete)
			{
				if(gridGP.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridGP.TableControl.Table.CurrentElement;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}

					string sType = gnt.ParentRecord.GetValue("Type") == null ? "" : gnt.ParentRecord.GetValue("Type").ToString();
					
					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					
					if(childTable.Name.Equals("GroupPropertyValues"))
					{
						if(e.Record.IsCaption())
							return;
						string modeID = e.Record.GetRecord().GetValue("ModeID") == null ? "" : e.Record.GetRecord().GetValue("ModeID").ToString();
						LRRFormulaDataStore.ModeID = modeID;
						LRRFormulaDataStore.SourceObjectID= e.Record.GetRecord().GetValue("SiteGroupPropertyQualifierValueID") == null ? "" : e.Record.GetRecord().GetValue("SiteGroupPropertyQualifierValueID").ToString();
						LRRFormulaDataStore.SourcePropertyID= e.Record.GetRecord().GetValue("GroupPropertyID") == null ? "" : e.Record.GetRecord().GetValue("GroupPropertyID").ToString();
						LRRFormulaDataStore.SourceLookupPropertyID= e.Record.GetRecord().GetValue("LookUpPropertiesID")== null ? "" : e.Record.GetRecord().GetValue("LookUpPropertiesID").ToString() ;
						LRRFormulaDataStore.SourceLookupQualifierID= e.Record.GetRecord().GetValue("LookUpQualifierID")== null ? "" : e.Record.GetRecord().GetValue("LookUpQualifierID").ToString();
						LRRFormulaDataStore.ShowGroupedAttributes = true;
						LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteGroupPropertyQualifierValue).ToString();
					}
				}
			}
		}
	
		#endregion

		#region ILRRUIContainer Members
		public new void Refresh()
		{
			InitDataSource();
			BindGridGPType();
			this.trvGroupType.SelectedNode=trvGroupType.Nodes[0];
		}
		public void Save() //Method to save the contents of the form...
		{
			bool isSaved = false;
			if(_siteComponents.GetChanges().Count>0)
			{
				LRRSiteComponents	toSaveSiteComponents =_siteComponents.GetChanges();
				_lrrApp.DBManagerObj.CommitCollection(toSaveSiteComponents); 
				if(toSaveSiteComponents.HasError)
				{
					LRRMessagBox.ShowMessage("SID_HASH_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
				}
				isSaved = true;
			}
			if(_siteCompProperties.GetChanges().Count>0)
			{
				LRRSiteComponentProperties	toSaveProperties=_siteCompProperties.GetChanges();
				_lrrApp.DBManagerObj.CommitCollection(toSaveProperties); 
				if(toSaveProperties.HasError)
				{
					LRRMessagBox.ShowMessage("SID_HASH_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
				}
				isSaved = true;
			}
			if(_siteCompGroupedProperties.GetChanges().Count > 0)
			{
				LRRSiteComponentGroupProperties tosaveSiteComponentGroupedProps = _siteCompGroupedProperties.GetChanges();
				_lrrApp.DBManagerObj.CommitCollection(tosaveSiteComponentGroupedProps); 
				isSaved = true;
			}
			if(_siteGroupPropertyQualifierValues.GetChanges().Count > 0)
			{
				LRRSiteGroupPropertyQualifierValues toSaveQualifierValues = _siteGroupPropertyQualifierValues.GetChanges();
                setDerivations(toSaveQualifierValues);
				_lrrApp.DBManagerObj.CommitCollection(toSaveQualifierValues); 
				isSaved = true;
			}

			if(!isSaved)
			{
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
			}
			else
			{
				_siteComponents.RefreshCollection();
				_siteCompProperties.RefreshCollection();
				_siteCompGroupedProperties.RefreshCollection();
				_siteGroupPropertyQualifierValues.RefreshCollection();
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			}
		}

        private void setDerivations(LRRSiteGroupPropertyQualifierValues toSaveQualifierValues)
        {
            foreach (LRRSiteGroupPropertyQualifierValue sgpQValue in toSaveQualifierValues)
            {
                if (sgpQValue.FormulaObj != null)
                {
                    if (sgpQValue.FormulaObj.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                    {
                        LRRModel.FormulasObj.Add(sgpQValue.FormulaObj);
                        if (sgpQValue.ModeID == "1")
                        {
                            if (sgpQValue.HistTagID == null || sgpQValue.HistTagID == "")
                            {
                                sgpQValue.Derivation = "5";
                            }
                        }
                        else
                        {
                            if (sgpQValue.Direction == "1")
                            {
                                sgpQValue.Derivation = "5";
                            }
                        }
                    }
                }
            }
        }

		public void CopyMasterProperties()
		{
		}
		public void Paste()
		{
		}
		public void Copy()
		{
		}
		public void Print()
		{
			if(gridGP.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridGP,false);
			}
		}
		public void Delete()
		{
		}
		public void ArrangeColumns()
		{
		}
		public void ClearFilter()
		{
			SyncGridUtilities.ClearFilter(gridGP);   
		}
		public void InsertNewRows()//Inserts New rows 
		{
		}
		public void ImportToExcel()
		{
		}
		public void Export()
		{
            if (gridGP.TableControl.CurrentCell.IsActive)
            {
                ExportToExcel excelExpForm = new ExportToExcel(this.gridGP);
                excelExpForm.ShowDialog(this);
            }
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}
		public void SelectionPaste()
		{
			
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		//Methods Suported
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsCopy()
		{
			return false;
		}
		public bool SupportsPaste()
		{
			return false;
		}
		public bool SupportsExport()
		{
			return true;
		}
		public bool SupportsSave()
		{
			return true;
		}
		public bool SupportsRefresh()
		{
			return true;
		}
		public bool SupportsDelete()
		{
			return false;
		}
		public bool SupportsPrint()
		{
			return true;
		}
		public bool SupportsArrangeColumns()
		{
			return false;
		}
		public bool SupportsClearFilter()
		{
			return true;
		}
		public bool SupportsInsertNewRows()
		{
			return false;
		}
		public bool SupportsImportToExcel()
		{
			return false;
		}
		public bool SupportsSelectionPaste()
		{
			return false;
		}
		public bool SupportsLevel()
		{
			return false;
		}


		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		public void LeftColMovement()
		{
			// TODO:  Add GroupedPlantPropertiesView.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add GroupedPlantPropertiesView.RightColMovement implementation
		}

		public void ClearSort()
		{
			//Add GroupedPlantPropertiesView.ClearSort implementation
			SyncGridUtilities.ClearSort(gridGP);
		}

		public bool SupportsClearSort()
		{
			// Add GroupedPlantPropertiesView.SupportsClearSort implementation
			return true;
		}
		

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		
		public void PrintPreview()
		{
			if(gridGP.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridGP,true);
			}
		}

	
		public void ShowPropertyList()
		{
			// TODO:  Add GroupedPlantPropertiesView.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add GroupedPlantPropertiesView.SupportsResultsFilter implementation
			return false;
		}

	
		public void ShowComponentList()
		{
			// TODO:  Add GroupedPlantPropertiesView.ShowComponentList implementation
		}

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add GroupedPlantItems.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridGP);
            Refresh();
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add GroupedPlantItems.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add GroupedPlantItems.SupportsUndo implementation
			return true;
		}

		public void OpenCompositeView()
		{
			// TODO:  Add GroupedPlantItems.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add GroupedPlantItems.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add GroupedPlantItems.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add GroupedPlantItems.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add GroupedPlantItems.SupportsCompositeView implementation
			return false;
		}

		private void GroupedPlantDataArrays_Activated(object sender, System.EventArgs e)
		{
			LRRFormulaDataStore.DataSource = _lrrFormulaGroupedProperties ;
			LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteGroupPropertyQualifierValue).ToString();
			LRRFormulaDataStore.ModeFlag = true;
			LRRFormulaDataStore.ShowGroupedAttributes = true;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;
		}


		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}
		private void gridGP_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
//			if(_isDeletePress)
//			{
//				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
//				if(_dlgResult == DialogResult.Yes)
//				{
//					_isRecordeDel = true; 
//				}
//				else
//				{
//					_isRecordeDel = false; 
//				}
//				_isDeletePress = false;
//			}
//			if(!_isRecordeDel)
//			{
//				e.Cancel = true;
//			}
		}

		private void gridGP_TableControlCurrentCellKeyPress(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventArgs e)
		{
			if(e.TableControl.TableDescriptor.Name == "GroupPropertyValues")
			{
				Record rec=e.TableControl.Table.CurrentRecord as Record;
				LRRSiteGroupPropertyQualifierValue prop= e.TableControl.Table.CurrentRecord.GetData() as LRRSiteGroupPropertyQualifierValue;
				if(prop != null)
				{
					if(prop.Direction==null || prop.Direction==""  || prop.Direction=="2")
						e.Inner.Handled = true;
					else
						e.Inner.Handled = false;
				}
			}
		}
		private void ChildTableDescriptor_RecordDeleting(object sender, RecordEventArgs e)
		{
			e.Cancel=true;
		}
		
		private void gridGP_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
		{
			if(e.TableControl.TableDescriptor.Name == "GroupPropertyValues")
			{
				e.AllowSort = false;
			}
		}
		
		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add GroupedPlantItems.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		
	}
}
