using System;
using System.Collections;

namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
	/// <summary>
	/// Summary description for GroupRowHeaderCell.
	/// </summary>
	public class GroupRowHeaderCell
	{
		public GroupRowHeaderCell()
		{
		}

		#region Properties
		public string ID
		{
			get{return _id;}
			set
			{
				_id = value;
			}
		}
		public string Name
		{
			get{return _name;}
			set
			{
				_name = value;
			}
		}
		public string UOMName
		{
			get{return _uomName;}
			set
			{
				_uomName = value;
			}
		}
		public string GroupPropertyType
		{
			get{return _groupPropertyType;}
			set
			{
				_groupPropertyType = value;
			}
		}
		public string LookUpPropertyID
		{
			get { return _lookUpPropertyID; }
			set { _lookUpPropertyID = value; }
		}

        private string _lookUpQualifierID;

        public string LookUpQualifierID
        {
            get { return _lookUpQualifierID; }
            set { _lookUpQualifierID = value; }
        }

        private string _propertyID;

        public string PropertyID
        {
            get { return _propertyID; }
            set { _propertyID = value; }
        }

        private string  _propertyType;

        public string  PropertyType
        {
            get { return _propertyType; }
            set { _propertyType = value; }
        }

        private string _qualifierID;

        public string QualifierID
        {
            get { return _qualifierID; }
            set { _qualifierID = value; }
        }


        private string _uiUomID;

        public string UIUOMId
        {
            get { return _uiUomID; }
            set { _uiUomID = value; }
        }

        private string _uomTypeID;

        public string UomTypeID
        {
            get { return _uomTypeID; }
            set { _uomTypeID = value; }
        }

        private bool _isVisible;

        public bool IsVisible
        {
            get { return _isVisible; }
            set
            {
                _isVisible = value;
            }
        }
		#endregion

		#region Fields
		private string _name;
		private string _id;
		private string _uomName;
		private string _groupPropertyType;
		private string _lookUpPropertyID;
		#endregion
	}

	public class Comparer : IComparer
	{

		/// <summary>
		/// Column(public property of the class) to be sorted.
		/// </summary>
		public string SortColumn
		{
			get{return sortcolumn;}set{sortcolumn = value;}
		}
		
		/// <summary>
		/// Sorting order.
		/// </summary>
		public int SortingOrder
		{
			get{return sortingOrder;}set{sortingOrder = value;}
		}
		#region Fields
		public string sortcolumn = "";
		public int sortingOrder = 0;
		#endregion

		#region Methods
		/// <summary>
		/// Compare interface implementation
		/// </summary>
		/// <param name="x">Object 1</param>
		/// <param name="y">Object 2</param>
		/// <returns>Result of comparison</returns>
		public int Compare(object x, object y)
		{
			return CheckSort(x,y,0);
		}

		public int CheckSort(object x,object y, int sortLevel)
		{
			GroupRowHeaderCell obj1 = (GroupRowHeaderCell)x;
			GroupRowHeaderCell obj2 = (GroupRowHeaderCell)y;

			//Compare based on the sorting order.
			int result = -2;
			if(sortLevel == 0)
			{
				if(sortingOrder == 0)
				{
					switch(sortcolumn)
					{
						case "Name" :
							result = obj1.Name.CompareTo(obj2.Name);
							break;
						case "UOMName" :
							result = obj1.UOMName.CompareTo(obj2.UOMName);
							break;
						case "GroupPropertyType" :
							result = obj1.GroupPropertyType.CompareTo(obj2.GroupPropertyType);
							break;

					}
				}
				if(sortingOrder == 1)
				{
					switch(sortcolumn)
					{
						case "Name" :
							result =  obj2.Name.CompareTo(obj1.Name);
							break;
						case "UOMName" :
							result = obj2.UOMName.CompareTo(obj1.UOMName);
							break;
						case "GroupPropertyType" :
							result = obj2.GroupPropertyType.CompareTo(obj1.GroupPropertyType);
							break;
					}
				}
			}

			return result;
		}
		#endregion
	}
}
