using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
	/// <summary>
	/// Summary description for GroupedAggregates.
	/// </summary>
    public class GroupedAggregates : System.Windows.Forms.Form, ILRRUIContainer
    {
        private System.Windows.Forms.TreeView trvGroupType;
        private System.Windows.Forms.Splitter splitter1;
        private System.Windows.Forms.Panel pnlAggregares;
        private System.Windows.Forms.Splitter splitter2;
        private System.Windows.Forms.Panel pnlSitecomps;
        private System.Windows.Forms.Splitter splitter3;
        private System.Windows.Forms.Panel pnlAggregatesOfAggregates;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregates;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregateEqpmnts;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregateOfAggregates;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public GroupedAggregates()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            InitDataSource();

            BindTreeViewGPType();
            BindAggregateEqpmntsGrid();
            BindAggregateOfAggregatesGrid();

            //--Form the datasource for the formula
            LRRMasterComponents masterComponents = LRRModel.Model;
            lrrFormulaSiteComponents.Clear();
            lrrFormulaSiteComponents.Add(0, masterComponents);
            lrrFormulaSiteComponents.Add(1, "MasterComponents");
            lrrFormulaSiteComponents.Add(2, "SiteComponentsObj");
            lrrFormulaSiteComponents.Add(3, "Properties");
            lrrFormulaSiteComponents.Add(4, "GroupPpties");
            lrrFormulaSiteComponents.Add(5, "GroupPptiesQualifierValues");
            lrrFormulaSiteComponents.Add(6, LRRModel.ChildModel.LookUpQualifiers);

            LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
            LRRFormulaDataStore.ModeFlag = true;
            LRRFormulaDataStore.ShowGroupedAttributes = true;
            LRRFormulaDataStore.SourceLookupPropertyID = null;
            LRRFormulaDataStore.SourceLookupQualifierID = null;
            _lrrFormulas = new LRRFormulas();
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.trvGroupType = new System.Windows.Forms.TreeView();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.pnlAggregares = new System.Windows.Forms.Panel();
            this.gridAggregates = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.pnlSitecomps = new System.Windows.Forms.Panel();
            this.gridAggregateEqpmnts = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter3 = new System.Windows.Forms.Splitter();
            this.pnlAggregatesOfAggregates = new System.Windows.Forms.Panel();
            this.gridAggregateOfAggregates = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlAggregares.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregates)).BeginInit();
            this.pnlSitecomps.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregateEqpmnts)).BeginInit();
            this.pnlAggregatesOfAggregates.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregateOfAggregates)).BeginInit();
            this.SuspendLayout();
            // 
            // trvGroupType
            // 
            this.trvGroupType.Dock = System.Windows.Forms.DockStyle.Left;
            this.trvGroupType.ImageIndex = -1;
            this.trvGroupType.Location = new System.Drawing.Point(0, 0);
            this.trvGroupType.Name = "trvGroupType";
            this.trvGroupType.SelectedImageIndex = -1;
            this.trvGroupType.Size = new System.Drawing.Size(184, 746);
            this.trvGroupType.TabIndex = 0;
            this.trvGroupType.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.trvGroupType_AfterSelect);
            // 
            // splitter1
            // 
            this.splitter1.Location = new System.Drawing.Point(184, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(3, 746);
            this.splitter1.TabIndex = 1;
            this.splitter1.TabStop = false;
            // 
            // pnlAggregares
            // 
            this.pnlAggregares.Controls.Add(this.gridAggregates);
            this.pnlAggregares.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlAggregares.Location = new System.Drawing.Point(187, 0);
            this.pnlAggregares.Name = "pnlAggregares";
            this.pnlAggregares.Size = new System.Drawing.Size(841, 368);
            this.pnlAggregares.TabIndex = 2;
            // 
            // gridAggregates
            // 
            this.gridAggregates.BackColor = System.Drawing.SystemColors.Window;
            this.gridAggregates.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridAggregates.Location = new System.Drawing.Point(0, 0);
            this.gridAggregates.Name = "gridAggregates";
            this.gridAggregates.Size = new System.Drawing.Size(841, 368);
            this.gridAggregates.TabIndex = 0;
            this.gridAggregates.TableDescriptor.AllowEdit = false;
            this.gridAggregates.TableDescriptor.AllowNew = false;
            this.gridAggregates.TableDescriptor.AllowRemove = false;
            this.gridAggregates.Text = "gridGroupingControl1";
            this.gridAggregates.VersionInfo = "3.301.0.0";
            this.gridAggregates.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridAggregates_RecordDeleting);
            this.gridAggregates.RecordExpanding += new Syncfusion.Grouping.RecordEventHandler(this.gridAggregates_RecordExpanding);
            this.gridAggregates.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridAggregates_CurrentRecordContextChange);
            // 
            // splitter2
            // 
            this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter2.Location = new System.Drawing.Point(187, 368);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(841, 3);
            this.splitter2.TabIndex = 3;
            this.splitter2.TabStop = false;
            // 
            // pnlSitecomps
            // 
            this.pnlSitecomps.Controls.Add(this.gridAggregateEqpmnts);
            this.pnlSitecomps.Dock = System.Windows.Forms.DockStyle.Left;
            this.pnlSitecomps.Location = new System.Drawing.Point(187, 371);
            this.pnlSitecomps.Name = "pnlSitecomps";
            this.pnlSitecomps.Size = new System.Drawing.Size(397, 375);
            this.pnlSitecomps.TabIndex = 4;
            // 
            // gridAggregateEqpmnts
            // 
            this.gridAggregateEqpmnts.BackColor = System.Drawing.SystemColors.Window;
            this.gridAggregateEqpmnts.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridAggregateEqpmnts.Location = new System.Drawing.Point(0, 0);
            this.gridAggregateEqpmnts.Name = "gridAggregateEqpmnts";
            this.gridAggregateEqpmnts.Size = new System.Drawing.Size(397, 375);
            this.gridAggregateEqpmnts.TabIndex = 0;
            this.gridAggregateEqpmnts.TableDescriptor.AllowEdit = false;
            this.gridAggregateEqpmnts.TableDescriptor.AllowNew = false;
            this.gridAggregateEqpmnts.TableDescriptor.AllowRemove = false;
            this.gridAggregateEqpmnts.Text = "gridGroupingControl2";
            this.gridAggregateEqpmnts.VersionInfo = "3.301.0.0";
            // 
            // splitter3
            // 
            this.splitter3.Location = new System.Drawing.Point(584, 371);
            this.splitter3.Name = "splitter3";
            this.splitter3.Size = new System.Drawing.Size(3, 375);
            this.splitter3.TabIndex = 5;
            this.splitter3.TabStop = false;
            // 
            // pnlAggregatesOfAggregates
            // 
            this.pnlAggregatesOfAggregates.Controls.Add(this.gridAggregateOfAggregates);
            this.pnlAggregatesOfAggregates.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlAggregatesOfAggregates.Location = new System.Drawing.Point(587, 371);
            this.pnlAggregatesOfAggregates.Name = "pnlAggregatesOfAggregates";
            this.pnlAggregatesOfAggregates.Size = new System.Drawing.Size(441, 375);
            this.pnlAggregatesOfAggregates.TabIndex = 6;
            // 
            // gridAggregateOfAggregates
            // 
            this.gridAggregateOfAggregates.BackColor = System.Drawing.SystemColors.Window;
            this.gridAggregateOfAggregates.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridAggregateOfAggregates.Location = new System.Drawing.Point(0, 0);
            this.gridAggregateOfAggregates.Name = "gridAggregateOfAggregates";
            this.gridAggregateOfAggregates.Size = new System.Drawing.Size(441, 375);
            this.gridAggregateOfAggregates.TabIndex = 0;
            this.gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
            this.gridAggregateOfAggregates.TableDescriptor.AllowNew = false;
            this.gridAggregateOfAggregates.TableDescriptor.AllowRemove = false;
            this.gridAggregateOfAggregates.Text = "gridGroupingControl3";
            this.gridAggregateOfAggregates.VersionInfo = "3.301.0.0";
            // 
            // GroupedAggregates
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(1028, 746);
            this.Controls.Add(this.pnlAggregatesOfAggregates);
            this.Controls.Add(this.splitter3);
            this.Controls.Add(this.pnlSitecomps);
            this.Controls.Add(this.splitter2);
            this.Controls.Add(this.pnlAggregares);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.trvGroupType);
            this.Name = "GroupedAggregates";
            this.Text = "GroupedAggregates";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Activated += new System.EventHandler(this.GroupedAggregates_Activated);
            this.pnlAggregares.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregates)).EndInit();
            this.pnlSitecomps.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregateEqpmnts)).EndInit();
            this.pnlAggregatesOfAggregates.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregateOfAggregates)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        #region fields
        private LRRApp _lrrApp; //All object to access the DB Manager and DB Adapter
        private LRRPropertyTypes _lrrPropertyTypes;
        private LRRLookUpQualifiers _lrrLookUpQualifiers;
        private TabControl _parentTabControl;
        private TabPage _parentTabPage;

        private LRRAggregates _lrrAggregates;
        private LRRAggregates _lrrAggregatesforAggregates;
        private LRRAggregates _lrrOrgAggregates;
        private LRRAggregateEquipments _lrrAggregateEquipments;
        private LRRAggregateEquipments _lrrAggregateEquipmentsforSite;
        private LRRSiteComponents _siteComponentsList; //Collection to get site component list.
        private Hashtable _AllEquips = new Hashtable(); //Hash table which has all the site components with ID = EquipID & Obj = Site COmponent.
        private GridUnBoundColumn gridUnBoundEquip = new GridUnBoundColumn();
        private GridUnBoundColumn gridUnBoundAgg = new GridUnBoundColumn();
        private string _recordValueChanged = "0";
        private string _recordAggID = "";

        private LRRAggregateProperties _lrrAggregateProperties;
        private LRRAggregateGroupedProperties _lrrAggregateGroupedProperties = null;
        private LRRAggregateGroupedPropertyValues _lrrAggregatePropertyValues;
        private Hashtable lrrMasterPropertyDirections = new Hashtable();
        private string _LocaleID;
        private LRRMasterProperties _lrrMasterCompPpties;
        private LRRMasterComponents _lrrMasterComps = new LRRMasterComponents();
        private LRRFormulas _lrrFormulas = null;
        private Hashtable lrrFormulaSiteComponents = new Hashtable();
        private Dictionary<string, LRRSiteComponent> lrrSiteComponentList = new Dictionary<string, LRRSiteComponent>();
        private string _sSiteComponentList = "";
        private AggregateFormula objAggregateFormula = new AggregateFormula();
        private LRRAggregates _Aggregates = new LRRAggregates();
        private LRRFormulas objFormulas = new LRRFormulas();
        private LRRFormulas _lrrTotalFormulas;
        private ArrayList _arrAggregates = new ArrayList();
        private ArrayList _arrAggregateEquipment = new ArrayList();
        private ArrayList _arrSiteComponent = new ArrayList();
        private ArrayList _arrAggregateProperties = new ArrayList();
        private ArrayList _arrAggregatePropertyValues = new ArrayList();
        Hashtable htSiteComponents = new Hashtable();
        #endregion

        #region Methods


        /// <summary>
        /// method used to initialize the datasources
        /// </summary>
        private void InitDataSource()
        {
            if (_lrrPropertyTypes != null)
                _lrrPropertyTypes.Clear();
            if (_lrrLookUpQualifiers != null)
                _lrrLookUpQualifiers.Clear();

            _lrrPropertyTypes = new LRRPropertyTypes();
            _lrrApp.DBManagerObj.PopulateCollection(_lrrPropertyTypes, " WHERE ID NOT IN ('0','1','2') and IsDataArray=true ", false);

            _lrrLookUpQualifiers = new LRRLookUpQualifiers();
            _lrrApp.DBManagerObj.PopulateCollection(_lrrLookUpQualifiers, false);

            LRRSiteComponents siteComponents;

            if (_lrrAggregatesforAggregates != null)
                _lrrAggregatesforAggregates.Clear();

            _siteComponentsList = new LRRSiteComponents();
            _lrrAggregatesforAggregates = new LRRAggregates();
            _arrAggregates = new ArrayList();
            _arrAggregateEquipment = new ArrayList();
            _arrAggregateProperties = new ArrayList();
            _arrAggregatePropertyValues = new ArrayList();
            _arrSiteComponent = new ArrayList();

            _Aggregates = LRRModel.AggregatesObj;
            _lrrAggregates = LRRModel.AggregatesObj;
            _lrrAggregateEquipments = LRRModel.AggregateEquipmentsObj;
            _lrrAggregateEquipmentsforSite = LRRModel.AggregateEquipmentsObj;
            _lrrOrgAggregates = LRRModel.AggregatesObj;
            _lrrAggregateProperties = LRRModel.AggregatePropertiesObj;
            _lrrAggregateGroupedProperties = LRRModel.AggregateGroupedPropertiesObj;
            _lrrAggregatePropertyValues = LRRModel.AggregateGroupedPropertyValuesObj;
            _lrrMasterCompPpties = LRRModel.MasterComponentPropertiesObj;
            _lrrTotalFormulas = LRRModel.FormulasObj;

            //_lrrApp.DBManagerObj.PopulateCollection(_lrrAggregatesforAggregates,false);

            _lrrAggregatePropertyValues.SortColumn = "ModeID";
            _lrrAggregatePropertyValues.Sort();

            foreach (LRRAggregate objAgg in _lrrAggregates)
            {
                _arrAggregates.Add(objAgg);
            }
            siteComponents = LRRModel.SiteComponentsObj;

            foreach (LRRSiteComponent objSiteComp in siteComponents)
            {
                _arrSiteComponent.Add(objSiteComp);
            }

            IEnumerator aggrPropValuesEnum = _lrrAggregatePropertyValues.GetEnumerator();
            while (aggrPropValuesEnum.MoveNext())
            {
                LRRAggregatePropertyValue laggrpv = aggrPropValuesEnum.Current as LRRAggregatePropertyValue;
                _arrAggregatePropertyValues.Add(laggrpv);
            }

            IEnumerator aggrPropsEnum = _lrrAggregateProperties.GetEnumerator();
            while (aggrPropsEnum.MoveNext())
            {
                LRRAggregateProperty laggrp = aggrPropsEnum.Current as LRRAggregateProperty;
                _arrAggregateProperties.Add(laggrp);
            }

            IEnumerator aggrEquipsEnum = _lrrAggregateEquipments.GetEnumerator();
            while (aggrEquipsEnum.MoveNext())
            {
                LRRAggregateEquipment laggrEquip = aggrEquipsEnum.Current as LRRAggregateEquipment;
                _arrAggregateEquipment.Add(laggrEquip);
            }
        }

        /// <summary>
        /// This method is to bind the treeview with the groupproperties
        /// </summary>
        private void BindTreeViewGPType()
        {
            trvGroupType.Sorted = true;
            trvGroupType.Nodes.Clear();
            trvGroupType.SuspendLayout();
            TreeNode tnav = new TreeNode();
            tnav.Text = "Group Data Arrays";
            tnav.Expand();

            tnav = CreateChildForNode(tnav);

            trvGroupType.Nodes.Add(tnav);
            if (trvGroupType.Nodes.Count > 0)
                trvGroupType.SelectedNode = trvGroupType.Nodes[0];
            trvGroupType.ResumeLayout(true);
        }
        /// <summary>
        /// this method is used to create childnode
        /// </summary>
        /// <param name="oNode"></param>
        /// <returns></returns>
        private TreeNode CreateChildForNode(TreeNode oNode)
        {
            foreach (LRRPropertyType oPropertyType in _lrrPropertyTypes)
            {
                TreeNode child = new TreeNode();
                child.Tag = oPropertyType;
                child.Text = oPropertyType.PropertyType;
                child = CreateQualifiersChildForNode(child, oPropertyType.ID);
                oNode.Nodes.Add(child);

            }
            return oNode;
        }
        /// <summary>
        /// Creates the qualifiers child for node.
        /// </summary>
        /// <param name="oNode">The o node.</param>
        /// <param name="sPropTypeID">The s prop type ID.</param>
        /// <returns></returns>
        private TreeNode CreateQualifiersChildForNode(TreeNode oNode, string sPropTypeID)
        {
            LRRLookUpQualifiers oQualifiersForPropType = _lrrLookUpQualifiers.getLookUpQualifiersForPropType(sPropTypeID);

            foreach (LRRLookUpQualifier oLkupQualifier in oQualifiersForPropType)
            {
                TreeNode child = new TreeNode();
                child.Tag = oLkupQualifier;
                LRRQualifier oQualifier = LRRModel.Qualifiers.getQualifierObjectForQualifierID(oLkupQualifier.QualifierID);
                if (oQualifier != null)
                {
                    child.Text = oQualifier.Name == null ? "" : oQualifier.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    oNode.Nodes.Add(child);
                }
            }
            return oNode;
        }




        /// <summary>
        /// This Method binds the Aggregate grid to the data source.
        /// </summary>
        private void BindAggregateGrid()
        {
            Hashtable RelativeWidths = new Hashtable();
            //Suspend the Layout of the Grid...
            gridAggregates.SuspendLayout();
            gridAggregates.TableDescriptor.Relations.Clear();
            gridAggregates.Engine.SourceListSet.Clear();
            gridAggregates.DataSource = null;

            SyncGridUtilities.InitializeGridLookAndFeel(gridAggregates);

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
            Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregates.ItemType, out fkColumns, out childColumns);
            Hashtable fkData = new Hashtable();
            foreach (object obj in fkColumns.Keys)
            {
                string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
                object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
                _lrrApp.DBManagerObj.PopulateCollection(collectionObject, false);
                fkData.Add(propName, collectionObject);
            }

				gridAggregates.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridAggregates_QueryCellStyleInfo);
            //Populate the columns for the grid object
            SyncGridUtilities.InitializeGridColumns(gridAggregates, _lrrAggregates.ItemType, null, fkData);

            gridAggregates.TableDescriptor.Columns[gridAggregates.TableDescriptor.Columns.IndexOf("IsAggregateOfAggregates")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            gridAggregates.TableDescriptor.Columns[gridAggregates.TableDescriptor.Columns.IndexOf("IsAggregateOfAggregates")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            gridAggregates.TableDescriptor.Columns[gridAggregates.TableDescriptor.Columns.IndexOf("EquipmentTypeID_ComponentName")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            gridAggregates.TableDescriptor.Columns[gridAggregates.TableDescriptor.Columns.IndexOf("EquipmentTypeID_ComponentName")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            //Add the parent table for the Relations...
            RelativeWidths.Add("Name", 30);
            RelativeWidths.Add("Description", 30);
            RelativeWidths.Add("IsAggregateOfAggregates", 10);
            RelativeWidths.Add("EquipmentTypeID_ComponentName", 25);


            //Initilaize the columns widths for the grid object
            SyncGridUtilities.InitializeGridColumnsWidth(gridAggregates, RelativeWidths);
            gridAggregates.Engine.SourceListSet.Add("ParentTable", _lrrAggregates);
            //Set the data store 
            gridAggregates.DataSource = _lrrAggregates;

            //Properties for the Aggregate
            GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
            grdCompProps.ChildTableName = "Properties";
            grdCompProps.RelationKeys.Add("AggregateID", "AggregateID");
            grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
            grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.DarkGoldenrod;
            grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
            grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Attributes: {RecordCount} Items";
            grdCompProps.ChildTableDescriptor.AllowRemove = false;
            grdCompProps.ChildTableDescriptor.AllowNew = false;
            grdCompProps.ChildTableDescriptor.AllowEdit = false;
            gridAggregates.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
            grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
            gridAggregates.TableDescriptor.Relations.Add(grdCompProps);
            gridAggregates.NestedTableGroupOptions.ShowFilterBar = true;
            gridAggregates.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
            gridAggregates.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumnsforProp;
            Dictionary<string, SymChildDataAttribute> childColumnsforProp;
            //Hashtable fkColumnsforProp;
            //Hashtable childColumnsforProp;
            Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregateProperties.ItemType, out fkColumnsforProp, out childColumnsforProp);
            Hashtable fkDataforProp = new Hashtable();
            foreach (object obj in fkColumnsforProp.Keys)
            {
                string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttrforProp = fkColumnsforProp[propName] as SymForeignKeyFieldAttribute;
                object collectionObject = Activator.CreateInstance(fkAttrforProp.CollectionType);
                _lrrApp.DBManagerObj.PopulateCollection(collectionObject, false);
                fkDataforProp.Add(propName, collectionObject);
            }
            //			_lrrAggregateProperties.SortColumn = "Name";
            //			_lrrAggregateProperties.Sort();
            SyncGridUtilities.InitializeGridColumns(gridAggregates, grdCompProps.ChildTableDescriptor, _lrrAggregateProperties.ItemType, null, fkDataforProp);
            grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Properties", _lrrAggregateProperties);
            grdCompProps.ChildTableDescriptor.Columns["Name"].ReadOnly = true;
            grdCompProps.ChildTableDescriptor.Columns["Description"].ReadOnly = true;

            //GroupProperties for the Aggregates
            GridRelationDescriptor grdCompGroupedProps = new GridRelationDescriptor("GroupedProperties");
            grdCompGroupedProps.ChildTableName = "GroupedProperties";
            grdCompGroupedProps.RelationKeys.Add("ID", "AggregatePropertyID");
            grdCompGroupedProps.RelationKind = RelationKind.RelatedMasterDetails;
            grdCompGroupedProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Red;
            grdCompGroupedProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
            grdCompGroupedProps.ChildTableDescriptor.AllowEdit = false;
            grdCompGroupedProps.ChildTableDescriptor.AllowRemove = false;
            grdCompGroupedProps.ChildTableDescriptor.AllowNew = false;
            grdCompGroupedProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Grouped Properties: {RecordCount} Items";
            grdCompGroupedProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
            grdCompProps.ChildTableDescriptor.Relations.Add(grdCompGroupedProps);
            grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("GroupedProperties", _lrrAggregateGroupedProperties);
            SyncGridUtilities.InitializeGridColumns(gridAggregates, grdCompGroupedProps.ChildTableDescriptor, _lrrAggregateGroupedProperties.ItemType, null);

            grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
            grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("UOM_Name")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("UOM_Name")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
            grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompGroupedProps.ChildTableDescriptor.Columns[grdCompGroupedProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
            grdCompGroupedProps.ChildTableDescriptor.Columns.Remove("HistTagID");




            //Property Values for the property
            GridRelationDescriptor grdCompPropValues = new GridRelationDescriptor("Values");
            grdCompPropValues.ChildTableName = "Values";
            grdCompPropValues.RelationKeys.Add("AggregateGroupedPropertyID", "AggregateGroupPropertyID");
            grdCompPropValues.RelationKind = RelationKind.RelatedMasterDetails;
            grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.OrangeRed;
            grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
            grdCompPropValues.ChildTableDescriptor.AllowEdit = true;//false;
            grdCompPropValues.ChildTableDescriptor.AllowRemove = false;
            grdCompPropValues.ChildTableDescriptor.AllowNew = false;

            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("Formula_Expression")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("Formula_Expression")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOM")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("UOM")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("HistTagID")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("HistTagID")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            grdCompProps.ChildTableDescriptor.Columns[grdCompProps.ChildTableDescriptor.Columns.IndexOf("ModeID")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            grdCompPropValues.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Values: {RecordCount} Items";
            grdCompPropValues.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
            grdCompGroupedProps.ChildTableDescriptor.Relations.Add(grdCompPropValues);

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumnsforPropVals;
            Dictionary<string, SymChildDataAttribute> childColumnsforPropVals;
            //Hashtable fkColumnsforPropVals;
            //Hashtable childColumnsforPropVals;
            Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregatePropertyValues.ItemType, out fkColumnsforPropVals, out childColumnsforPropVals);
            Hashtable fkDataforPropVals = new Hashtable();
            foreach (object obj in fkColumnsforPropVals.Keys)
            {
                string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttrforPropVals = fkColumnsforPropVals[propName] as SymForeignKeyFieldAttribute;
                object collectionObject = Activator.CreateInstance(fkAttrforPropVals.CollectionType);
                _lrrApp.DBManagerObj.PopulateCollection(collectionObject, false);
                fkDataforPropVals.Add(propName, collectionObject);
            }
            SyncGridUtilities.InitializeGridColumns(gridAggregates, grdCompPropValues.ChildTableDescriptor, _lrrAggregatePropertyValues.ItemType, null, fkDataforPropVals);
            grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Values", _lrrAggregatePropertyValues);
            GridTableCellStyleInfo gtc = grdCompPropValues.ChildTableDescriptor.Columns["ModeID_ModeName"].Appearance.AnyRecordFieldCell;
            gtc.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
            grdCompPropValues.ChildTableDescriptor.Columns["ModeID_ModeName"].ReadOnly = true;
            grdCompPropValues.ChildTableDescriptor.Columns["ModeID_ModeName"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

            gridAggregates.NestedTableGroupOptions.ShowFilterBar = true;
            gridAggregates.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
            gridAggregates.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;


            gridAggregates.NestedTableGroupOptions.ShowFilterBar = true;
            gridAggregates.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
            gridAggregates.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;

            // sort column
            gridAggregates.TableDescriptor.Relations["Properties"].ChildTableDescriptor.SortedColumns.Add("Name");

            this.gridAggregates.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            //Resume the Layout of the Grid...
            gridAggregates.ResumeLayout(false);

            string[,] arry = new string[,] { { "Description", "255" } };
            Validations objValidations = new Validations(gridAggregates, arry);

        }

	

        /// <summary>
        /// This Method binds the AggregateEqpmnts grid to the data source.
        /// </summary>
        private void BindAggregateEqpmntsGrid()
        {

            //Suspend the Layout of the Grid...
            gridAggregateEqpmnts.SuspendLayout();
            SyncGridUtilities.InitializeGridLookAndFeel(gridAggregateEqpmnts);
            gridAggregateEqpmnts.DataSource = null;
            gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
            Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_siteComponentsList.ItemType, out fkColumns, out childColumns);
            Hashtable fkData = new Hashtable();
            foreach (object obj in fkColumns.Keys)
            {
                string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
                object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
                _lrrApp.DBManagerObj.PopulateCollection(collectionObject, false);
                fkData.Add(propName, collectionObject);
            }
				gridAggregateEqpmnts.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridAggregateEqpmnts_QueryCellStyleInfo);
            //Populate the columns for the grid object
            //			_siteComponentsList.SortColumn="Name";
            //			_siteComponentsList.Sort();
            SyncGridUtilities.InitializeGridColumns(gridAggregateEqpmnts, _siteComponentsList.ItemType, null, fkData);
            gridAggregateEqpmnts.TableDescriptor.Columns.Clear();
            gridUnBoundEquip.WireGrid(gridAggregateEqpmnts);
            gridAggregateEqpmnts.TableDescriptor.Columns.Add("Name", "Name");
            gridAggregateEqpmnts.TableDescriptor.Columns.Add("Description", "Description");

            Hashtable RelativeWidths = new Hashtable();
            RelativeWidths.Add("Name", 40);
            RelativeWidths.Add("Description", 40);
            SyncGridUtilities.InitializeGridColumnsWidth(gridAggregateEqpmnts, RelativeWidths);

            //Set the data store 
            gridAggregateEqpmnts.Engine.SourceListSet.Add("ParentTable", _siteComponentsList);

            gridAggregateEqpmnts.DataSource = _siteComponentsList;

            gridAggregateEqpmnts.TableDescriptor.AllowEdit = false;
            gridAggregateEqpmnts.TableDescriptor.AllowNew = false;
            gridAggregateEqpmnts.TableDescriptor.Columns["Name"].ReadOnly = true;
            //		gridAggregateEqpmnts.TableOptions.AllowSortColumns = false;

            this.gridAggregateEqpmnts.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            //Resume the Layout of the Grid...
            gridAggregateEqpmnts.ResumeLayout(false);

        }

		


        /// <summary>
        /// This Method binds the AggregateOfAggregates grid to the data source.
        /// </summary>
        private void BindAggregateOfAggregatesGrid()
        {
            //Suspend the Layout of the Grid...
            gridAggregateOfAggregates.SuspendLayout();
            gridAggregateOfAggregates.DataSource = null;
            SyncGridUtilities.InitializeGridLookAndFeel(gridAggregateOfAggregates);
            gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
            Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrAggregatesforAggregates.ItemType, out fkColumns, out childColumns);
            Hashtable fkData = new Hashtable();
            foreach (object obj in fkColumns.Keys)
            {
                string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
                object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
                _lrrApp.DBManagerObj.PopulateCollection(collectionObject, false);
                fkData.Add(propName, collectionObject);
            }

            //			_lrrAggregatesforAggregates.SortColumn="Name";
            //			_lrrAggregatesforAggregates.Sort();
				gridAggregateOfAggregates.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridAggregateOfAggregates_QueryCellStyleInfo);
            //Populate the columns for the grid object
            SyncGridUtilities.InitializeGridColumns(gridAggregateOfAggregates, _lrrAggregatesforAggregates.ItemType, null, fkData);

            gridAggregateOfAggregates.TableDescriptor.Columns.Clear();
            gridUnBoundAgg.WireGrid(gridAggregateOfAggregates);
            gridAggregateOfAggregates.TableDescriptor.Columns.Add("Name", "Name");
            gridAggregateOfAggregates.TableDescriptor.Columns.Add("Description", "Description");

            Hashtable RelativeWidths = new Hashtable();
            RelativeWidths.Add("Name", 60);
            RelativeWidths.Add("Description", 60);
            SyncGridUtilities.InitializeGridColumnsWidth(gridAggregateOfAggregates, RelativeWidths);

            //Add the parent table for the Relations...
            gridAggregateOfAggregates.Engine.SourceListSet.Add("ParentTable", _lrrAggregatesforAggregates);

            //Set the data store 
            gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;


            gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
            gridAggregateOfAggregates.TableDescriptor.AllowNew = false;
            //			gridAggregateOfAggregates.TableOptions.AllowSortColumns = false;

            this.gridAggregateOfAggregates.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            //Resume the Layout of the Grid...
            gridAggregateOfAggregates.ResumeLayout(false);

        }

		


        /// <summary>
        /// This function is used to apply filter based on the aggrgate group being selected.
        /// </summary>
        /// <param name="sAggregateID"></param>
        /// <param name="sCompType"></param>
        /// <param name="bAggSelected"></param>
        private void ApplyFinerFilterForAggGroupGrid(string sAggregateID, string sCompType, bool bAggSelected)
        {
            _siteComponentsList = new LRRSiteComponents();
            LRRSiteComponents oSCs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(sCompType);
            foreach (LRRSiteComponent oSC in oSCs)
            {
                if (!htSiteComponents.Contains(oSC.SiteComponentID))
                    htSiteComponents.Add(oSC.SiteComponentID, oSC);
            }
            LRRAggregate aggregate = _lrrAggregates.GetAggregateFromID(sAggregateID);

            object[] objAgg = gridUnBoundAgg.GetSelectedRecords();
            IEnumerator enumeratorAgg = objAgg.GetEnumerator();
            while (enumeratorAgg.MoveNext())
            {
                if (enumeratorAgg.Current.ToString() == "Symcon.LightRidge.BusinessObjects.LRRAggregate")
                {
                    LRRAggregate lrrAggr = enumeratorAgg.Current as LRRAggregate;
                    if ((lrrAggr.AggregateID == sAggregateID) && (bAggSelected))
                    {

                        //--get all the selected aggregates and corresponding  components
                        GetSiteComponentsForAggregates(lrrAggr, _lrrAggregatesforAggregates);
                        _sSiteComponentList = "";

                        //--form the filter criteria
                        IEnumerator enumSC1 = lrrSiteComponentList.Keys.GetEnumerator();
                        while (enumSC1.MoveNext())
                        {
                            _sSiteComponentList = enumSC1.Current.ToString();

                            if (htSiteComponents.Contains(_sSiteComponentList))
                                htSiteComponents.Remove(_sSiteComponentList);

                        }
                        lrrSiteComponentList.Clear();
                        _sSiteComponentList = "";
                    }
                    else if (lrrAggr.AggregateID != sAggregateID)
                    {
                        //--get all the selected aggregates and corresponding  components
                        GetSiteComponentsForAggregates(lrrAggr, _lrrAggregatesforAggregates);
                        _sSiteComponentList = "";

                        //--form the filter criteria
                        IEnumerator enumSC1 = lrrSiteComponentList.Keys.GetEnumerator();
                        while (enumSC1.MoveNext())
                        {
                            _sSiteComponentList = enumSC1.Current.ToString();

                            if (htSiteComponents.Contains(_sSiteComponentList))
                                htSiteComponents.Remove(_sSiteComponentList);

                        }
                        lrrSiteComponentList.Clear();
                        _sSiteComponentList = "";
                    }
                }
            }

            if (bAggSelected)
            {
                GetSiteComponentsForAggregates(aggregate, _lrrAggregates);
                _sSiteComponentList = "";

                //--form the filter criteria
                IEnumerator enumSC = lrrSiteComponentList.Keys.GetEnumerator();
                while (enumSC.MoveNext())
                {
                    _sSiteComponentList = enumSC.Current.ToString();

                    if (htSiteComponents.Contains(_sSiteComponentList))
                        htSiteComponents.Remove(_sSiteComponentList);
                }
                lrrSiteComponentList.Clear();
                _sSiteComponentList = "";
            }

            IEnumerator enumHtSC = htSiteComponents.Keys.GetEnumerator();
            while (enumHtSC.MoveNext())
            {
                string sCompID = enumHtSC.Current.ToString();

                if (htSiteComponents.Contains(sCompID))
                {
                    _siteComponentsList.Add(htSiteComponents[sCompID]);
                }
            }

            gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
            gridAggregateEqpmnts.DataSource = null;
            gridAggregateEqpmnts.DataSource = _siteComponentsList;

        }


        /// <summary>
        /// The function is used to apply filter based on the equipment type being selected.
        /// </summary>
        /// <param name="sCompType"></param>
        /// <param name="sAggregatable"></param>
        /// <param name="sAggregateID"></param>
        /// <param name="bAddNew"></param>
        private void ApplyFiltersForAggDtlGrids(string sCompType, string sAggregatable, string sAggregateID, bool bAddNew)
        {
            string filterString = "";
            _siteComponentsList = new LRRSiteComponents();
            if (bAddNew)
                filterString = sAggregateID + "|";
            else
                filterString = sAggregateID + "|" + sCompType;

            _lrrAggregatesforAggregates = new LRRAggregates();
            foreach (LRRAggregate objAgg in _lrrOrgAggregates)
            {
                if (objAgg.AggregateID != sAggregateID)
                    _lrrAggregatesforAggregates.Add(objAgg);
            }

            _lrrAggregatesforAggregates = _lrrAggregatesforAggregates.GetAggregatesByMasterComponentID(sCompType);

            filterString = "MasterComponentType = '" + sCompType + "'";

            LRRSiteComponents oSCs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(sCompType);
            foreach (LRRSiteComponent oSC in oSCs)
            {
                if (!htSiteComponents.Contains(oSC.SiteComponentID))
                    htSiteComponents.Add(oSC.SiteComponentID, oSC);
            }

            IEnumerator enumSC = htSiteComponents.Keys.GetEnumerator();
            while (enumSC.MoveNext())
            {
                string sCompID = enumSC.Current.ToString();

                if (htSiteComponents.Contains(sCompID))
                {
                    _siteComponentsList.Add(htSiteComponents[sCompID]);
                }
            }

            gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
            gridAggregateEqpmnts.DataSource = null;
            gridAggregateEqpmnts.DataSource = _siteComponentsList;

            gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
            gridAggregateOfAggregates.DataSource = null;
            gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;


        }

        /// <summary>
        /// Filters the aggregate equipment.
        /// </summary>
        /// <param name="blnParent">if set to <c>true</c> [BLN parent].</param>
        /// <param name="sAggregateID">The s aggregate ID.</param>
        /// <returns></returns>
        private LRRAggregateEquipments FilterAggregateEquipment(bool blnParent, string sAggregateID)
        {
            LRRAggregateEquipments objAggEquip = new LRRAggregateEquipments();
            for (int i = 0; i < _lrrAggregateEquipments.Count; i++)
            {
                LRRAggregateEquipment currentAggEquip = _lrrAggregateEquipments[i] as LRRAggregateEquipment;
                if (blnParent)
                {
                    if (currentAggEquip.ParentAggregateID == sAggregateID)
                        objAggEquip.Add(currentAggEquip);
                }
                else
                {
                    if (currentAggEquip.ChildAggregateID == sAggregateID)
                        objAggEquip.Add(currentAggEquip);

                }
            }
            return objAggEquip;
        }

        /// <summary>
        /// Gets the master comp ppties for aggregate ID.
        /// </summary>
        /// <param name="aggregateID">The aggregate ID.</param>
        /// <returns></returns>
        private Dictionary<string, LRRMasterProperty> GetMasterCompPptiesForAggregateID(string aggregateID)
        {
            Dictionary<string, LRRMasterProperty> masterProps = new Dictionary<string, LRRMasterProperty>();
            string sAggID = "";
            string sMasterPropID = "";
            foreach (LRRAggregateProperty objAggProp in _lrrAggregateProperties)
            {
                sAggID = objAggProp.AggregateID == null ? "" : objAggProp.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                if (sAggID == aggregateID)
                {
                    sMasterPropID = objAggProp.MasterPropertyID == null ? "" : objAggProp.MasterPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    masterProps.Add(sMasterPropID, _lrrMasterCompPpties.GetMasterPropertyByID(sMasterPropID));
                }
            }
            return masterProps;
        }


        /// <summary>
        /// Gets the site components for aggregates.
        /// </summary>
        /// <param name="objAggregate">The obj aggregate.</param>
        /// <param name="objAggregates">The obj aggregates.</param>
        public void GetSiteComponentsForAggregates(LRRAggregate objAggregate, LRRAggregates objAggregates)
        {

            string sSiteComponentID = "";
            string sAggregateID = "";
            string sSourceAggregateID = "";
            string sParentAggregateID = "";

            if (objAggregate != null)
            {
                sSourceAggregateID = objAggregate.AggregateID == null ? "" : objAggregate.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                bool bAggregatable = objAggregate.IsAggregateOfAggregates;

                for (int j = 0; j < _arrAggregateEquipment.Count; j++)
                {
                    LRRAggregateEquipment objAggregateEquipment = _arrAggregateEquipment[j] as LRRAggregateEquipment;

                    sParentAggregateID = objAggregateEquipment.ParentAggregateID == null ? "" : objAggregateEquipment.ParentAggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    if (sParentAggregateID == sSourceAggregateID)
                    {
                        sSiteComponentID = "";
                        sAggregateID = "";
                        sAggregateID = objAggregateEquipment.ChildAggregateID == null ? "" : objAggregateEquipment.ChildAggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        if (sAggregateID != "")
                        {
                            //For this aggregate, get all the Child Aggregates
                            LRRAggregate objAgg = objAggregates.GetAggregateFromID(sAggregateID);
                            GetSiteComponentsForAggregates(objAgg, objAggregates);
                            //objAggregates.ItemFilter = "";
                        }
                        else
                        {
                            //For this aggregate, get all the equipment
                            sSiteComponentID = objAggregateEquipment.EquipmentID == null ? "" : objAggregateEquipment.EquipmentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            if (!lrrSiteComponentList.ContainsKey(sSiteComponentID))
                                lrrSiteComponentList.Add(sSiteComponentID, LRRModel.SiteComponentsObj.GetSiteComponentByID(sSiteComponentID));
                        }
                    }
                }

            }

        }

        #endregion

        #region Events

        private TreeNode prevSelNode = null;

       private void trvGroupType_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            try
            {
                this.Cursor = Cursors.WaitCursor;
                if (e.Action == TreeViewAction.ByMouse)
                    LRRWaitWindowUtility.ShowPogressIndicator(e.Node.Text);
                ApplicationPersistanceUtil.SaveGridSettings(gridAggregates, this as ILRRUIContainer, this.Tag);
                if (prevSelNode != null)
                    prevSelNode.ForeColor = Color.Black;
                e.Node.ForeColor = Color.Blue;
                prevSelNode = e.Node;
                LRRPropertyType groupType = null;
                LRRLookUpQualifier lookupQualifier = null;
                _lrrAggregatePropertyValues = new LRRAggregateGroupedPropertyValues();
                _lrrAggregateProperties = new LRRAggregateProperties();
                _lrrAggregates = new LRRAggregates();
                _lrrAggregatePropertyValues = new LRRAggregateGroupedPropertyValues();

                if (this.trvGroupType.SelectedNode.Tag != null)
                {
                    switch (this.trvGroupType.SelectedNode.Tag.GetType().ToString())
                    {
                        case "Symcon.LightRidge.BusinessObjects.LRRPropertyType":
                            groupType = this.trvGroupType.SelectedNode.Tag as LRRPropertyType;
                            break;
                        case "Symcon.LightRidge.BusinessObjects.LRRLookUpQualifier":
                            lookupQualifier = this.trvGroupType.SelectedNode.Tag as LRRLookUpQualifier;
                            break;
                        default:
                            break;
                    }
                    if (groupType != null)
                    {
                        _lrrAggregates = LRRModel.AggregatesObj.FilterAggreGatesByPropertyType(groupType.ID);
                        _lrrAggregateProperties = LRRModel.AggregatePropertiesObj.FilterPropertiesByPropertyType(groupType.ID);
                        _lrrAggregateGroupedProperties = LRRModel.AggregateGroupedPropertiesObj.FilterGroupPropertiesByPropertyType(groupType.ID);
                        foreach (LRRAggregateGroupedProperty aggGrpProp in _lrrAggregateGroupedProperties)
                        {
                            LRRAggregateGroupedPropertyValues aggPropValues = LRRModel.AggregateGroupedPropertyValuesObj.GetGroupedValuesFromGroupPropID(aggGrpProp.AggregateGroupedPropertyID);
                            foreach (LRRAggregateGroupedPropertyValue aggGrpPropValue in aggPropValues)
                            {
                                _lrrAggregatePropertyValues.Add(aggGrpPropValue);
                            }
                        }
                    }
                    BindAggregateGrid();
                }
                else
                {
                    _lrrAggregates = LRRModel.AggregatesObj.FilterAggreGatesByPropertyType(null);
                    BindAggregateGrid();
                }
                this.Cursor = Cursors.Default;
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(GroupedAggregates), "AfterCheck: " + ex, Logger.Level.Debug);
            }
            finally
            {
                LRRWaitWindowUtility.EndProgressIndicator();
            }
        }

		 private void gridAggregates_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		 {
			try
			{
			 if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			  {  
						 string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
						 e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			  }  
			}
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		 }

		 private void gridAggregateEqpmnts_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		 {
		  try
			   {
			       if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		 }
		 private void gridAggregateOfAggregates_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		 {
			try
			   {
			       if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			} 
		 }

        private void gridAggregates_RecordExpanding(object sender, Syncfusion.Grouping.RecordEventArgs e)
        {

        }

        private void gridAggregates_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
        {
            Cursor = Cursors.WaitCursor;
            try
            {
                string aggrEquipID = "";
                string sAggregateID = "";
                string sTableName = "";
                if (e.Action == CurrentRecordAction.EnterRecordComplete)
                {
                    gridUnBoundEquip.ClearSelectedRecords();
                    gridUnBoundAgg.ClearSelectedRecords();
                    htSiteComponents.Clear();

                    if (gridAggregates.TableControl.Table.CurrentRecord == null)
                    {
                        Element eCurrentElement = gridAggregates.TableControl.Table.CurrentElement;
                        GridNestedTable gnt = eCurrentElement as GridNestedTable;
                        GridNestedTable gnt1 = gnt;
                        GridTableDescriptor gtd = null;
                        GridTableModel tableModel = new GridTableModel();
                        while (gnt1 != null && gnt1.ChildTable != null)
                        {
                            gnt = gnt1;
                            gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                            gtd = gnt.ParentTable.ParentTableDescriptor;
                        }
                        if (gnt != null)
                        {
                            string sType = gnt.ParentRecord.GetValue("Type") == null ? "" : gnt.ParentRecord.GetValue("Type").ToString();

                            GridChildTable childTable = gnt.ChildTable as GridChildTable;
                            if (childTable != null)
                            {
                                sTableName = childTable.Name == null ? "" : childTable.Name.ToString();
                                if (childTable.Name.Equals("Values"))
                                {
                                    if (e.Record.IsCaption())
                                        return;
                                    string modeID = e.Record.GetRecord().GetValue("ModeID") == null ? "" : e.Record.GetRecord().GetValue("ModeID").ToString();
                                    string sValID = e.Record.GetRecord().GetValue("AggregateGroupedPropertyValueID") == null ? "" : e.Record.GetRecord().GetValue("AggregateGroupedPropertyValueID").ToString();
                                    string aggregatePropID = e.Record.GetRecord().GetValue("AggregatePropertyID") == null ? "" : e.Record.GetRecord().GetValue("AggregatePropertyID").ToString();
                                    string aggregateID = "";
                                    for (int i = 0; i < _arrAggregateProperties.Count; i++)
                                    {
                                        LRRAggregateProperty currentAggProp = _arrAggregateProperties[i] as LRRAggregateProperty;
                                        if (currentAggProp.ID == aggregatePropID)
                                        {
                                            aggregateID = currentAggProp.AggregateID == null ? "" : currentAggProp.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                                        }
                                    }
                                    LRRFormulaDataStore.SourceObjectID = sValID;
                                    LRRFormulaDataStore.ModeID = modeID;
                                    LRRFormulaDataStore.SourcePropertyID = aggregatePropID;
                                    LRRFormulaDataStore.ShowGroupedAttributes = true;

                                    LRRFormulaDataStore.SourceLookupPropertyID = null;
                                    LRRFormulaDataStore.SourceLookupQualifierID = null;
                                    LRRFormulaDataStore.ObjectSource = typeof(LRRAggregateGroupedPropertyValue).ToString();
                                    LRRAggregate objAgg = _lrrAggregates.GetAggregateFromID(aggregateID);
                                    if (objAgg != null)
                                    {
                                        lrrSiteComponentList.Clear();
                                        GetSiteComponentsForAggregates(objAgg, _lrrAggregates);
                                        LRRFormulaDataStore.SiteComponents = lrrSiteComponentList;
                                        LRRFormulaDataStore.MasterProperties = GetMasterCompPptiesForAggregateID(aggregateID);
                                    }
                                }
                            }
                        }
                    }
                }
                if (e.Action == CurrentRecordAction.NavigateComplete)
                {
                    if (e.Table.CurrentRecord != null)
                    {
                        if (e.Table.CurrentRecord.Kind.ToString(Symcon.BusinessObjects.SymConverter.Culture) == "AddNewRecord")
                        {
                            LRRAggregate aggrObj = e.Table.CurrentRecord.GetData() as LRRAggregate;
                            _siteComponentsList = new LRRSiteComponents();
                            gridUnBoundEquip.ClearSelectedRecords();
                            gridUnBoundAgg.ClearSelectedRecords();
                            htSiteComponents.Clear();
                            if ((aggrObj == null) || (aggrObj.EquipmentTypeID == null) || (aggrObj.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture) == ""))
                            {
                                gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                                _lrrAggregatesforAggregates.RefreshCollection();
                                gridAggregateOfAggregates.TableControl.Refresh();
                                gridAggregateEqpmnts.TableControl.Refresh();
                                return;
                            }

                        }
                    }
                }
                if (gridAggregates.CurrencyManager.Count > 0)
                {
                    LRRAggregate aggrEquipment = gridAggregates.CurrencyManager.Current as LRRAggregate;
                    sAggregateID = aggrEquipment.AggregateID == null ? "" : aggrEquipment.AggregateID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    if (aggrEquipment != null)
                    {
                        if (e.Action == CurrentRecordAction.LeaveRecordCalled)
                        {
                            if ((_recordValueChanged == "1") && (sTableName == ""))
                            {
                                DialogResult k = LRRMessagBox.ShowMessage("SID_SAVEINFO_QUESTION", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                                if (k == DialogResult.Yes)
                                {
                                    e.Cancel = true;
                                    Save();
                                }
                                else
                                {
                                    _recordValueChanged = "0";

                                    if (_recordAggID != "")
                                    {
                                        LRRAggregate objAgg = _lrrAggregates.GetAggregateFromID(_recordAggID);
                                        int nIndex = _lrrAggregates.IndexOf(_lrrAggregates.GetAggregateFromID(_recordAggID));
                                        _lrrAggregates.RemoveAt(nIndex);

                                        Dictionary<string, LRRAggregate> objAggHash = new Dictionary<string, LRRAggregate>();
                                        objAggHash = _lrrAggregates.AggregatesHash;

                                        if (objAggHash.ContainsKey(_recordAggID))
                                            objAggHash.Remove(_recordAggID);

                                        Dictionary<string, List<LRRAggregate>> objAggCompTypeHash = new Dictionary<string, List<LRRAggregate>>();
                                        objAggCompTypeHash = _lrrAggregates.AggCompTypeHash;

                                        string sAggType = "";
                                        sAggType = _recordAggID + "|" + sAggType;

                                        if (objAggCompTypeHash.ContainsKey(sAggType))
                                            objAggCompTypeHash.Remove(sAggType);

                                        sAggType = objAgg.EquipmentTypeID;
                                        sAggType = _recordAggID + "|" + sAggType;

                                        if (objAggCompTypeHash.ContainsKey(sAggType))
                                            objAggCompTypeHash.Remove(sAggType);

                                        _lrrAggregates.AggCompTypeHash = objAggCompTypeHash;
                                        _lrrAggregates.AggregatesHash = objAggHash;
                                    }

                                    _lrrAggregatesforAggregates = _lrrOrgAggregates;
                                    gridUnBoundEquip.ClearSelectedRecords();
                                    gridUnBoundAgg.ClearSelectedRecords();
                                    _siteComponentsList = new LRRSiteComponents();
                                    htSiteComponents.Clear();
                                    gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                                    gridAggregateEqpmnts.Refresh();
                                    gridAggregateOfAggregates.Refresh();
                                    _recordAggID = "";
                                    e.Cancel = true;
                                }
                            }
                        }
                        if (e.Action == CurrentRecordAction.NavigateComplete)
                        {
                            gridUnBoundEquip.ClearSelectedRecords();
                            gridUnBoundAgg.ClearSelectedRecords();

                            aggrEquipID = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                            LRRAggregateEquipments objAggEquips = FilterAggregateEquipment(true, sAggregateID);
                            object[] objArrAggregateEquipment = new object[objAggEquips.Count];

                            gridAggregateEqpmnts.TableDescriptor.Relations.Clear();
                            gridAggregateEqpmnts.DataSource = null;
                            _siteComponentsList = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(aggrEquipID);
                            gridAggregateEqpmnts.DataSource = _siteComponentsList;

                            for (int i = 0; i < _siteComponentsList.Count; i++)
                            {
                                LRRSiteComponent site = _siteComponentsList[i] as LRRSiteComponent;
                                for (int j = 0; j < objAggEquips.Count; j++)
                                {
                                    LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                    if (lrrAggrEquipment.EquipmentID == site.SiteComponentID)
                                        objArrAggregateEquipment[j] = site;
                                }
                            }

                            if (aggrEquipment.IsAggregateOfAggregates == false)
                            {
                                gridAggregateOfAggregates.TableDescriptor.Relations.Clear();
                                gridAggregateOfAggregates.DataSource = null;
                                _lrrAggregatesforAggregates = _lrrOrgAggregates.GetAggregatesByMasterComponentID(aggrEquipID);
                                gridAggregateOfAggregates.DataSource = _lrrAggregatesforAggregates;
                                //_lrrAggregatesforAggregates.RefreshCollection();
                                gridAggregateOfAggregates.TableDescriptor.AllowEdit = false;
                            }

                            if (aggrEquipment.IsAggregateOfAggregates == true)
                            {
                                object[] objArrChildAggregates = new object[objAggEquips.Count];

                                string aggrID11 = aggrEquipment.EquipmentTypeID == null ? "" : aggrEquipment.EquipmentTypeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                                ApplyFiltersForAggDtlGrids(aggrID11, "true", sAggregateID, false);

                                for (int i = 0; i < _lrrAggregatesforAggregates.Count; i++)
                                {
                                    LRRAggregate aggregate = _lrrAggregatesforAggregates[i] as LRRAggregate;
                                    for (int j = 0; j < objAggEquips.Count; j++)
                                    {
                                        LRRAggregateEquipment lrrAggrEquipment = objAggEquips[j] as LRRAggregateEquipment;
                                        if (lrrAggrEquipment.ChildAggregateID == aggregate.AggregateID)
                                            objArrChildAggregates[j] = aggregate;
                                    }
                                }

                                gridUnBoundAgg.SetSelectedRecords(objArrChildAggregates);

                                gridAggregateOfAggregates.TableDescriptor.AllowEdit = true;
                                gridAggregateOfAggregates.TableDescriptor.Columns["Name"].ReadOnly = true;

                                gridAggregateOfAggregates.TableControl.Refresh();

                                ApplyFinerFilterForAggGroupGrid(sAggregateID, aggrID11, false);
                            }
                            gridUnBoundEquip.SetSelectedRecords(objArrAggregateEquipment);
                            gridAggregateEqpmnts.Refresh();
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(AggregateDetails), ex.Message, Logger.Level.Debug);
            }
            Cursor = Cursors.Default;
        }

        private void GroupedAggregates_Activated(object sender, System.EventArgs e)
        {
            LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
            LRRFormulaDataStore.ModeFlag = true;
            LRRFormulaDataStore.ShowGroupedAttributes = true;
            LRRFormulaDataStore.ObjectSource = typeof(LRRAggregateGroupedPropertyValue).ToString();

            LRRFormulaDataStore.SourceLookupPropertyID = null;
            LRRFormulaDataStore.SourceLookupQualifierID = null;
        }

        #endregion

        #region ILRRUIContainer Members
        public new void Refresh()
        {
            InitDataSource();
            BindAggregateGrid();
            BindAggregateOfAggregatesGrid();
            BindAggregateEqpmntsGrid();
            this.trvGroupType.SelectedNode = trvGroupType.Nodes[0];  
        }
        public void Save() //Method to save the contents of the form...
        {
            bool isSaved = false;
            if (_lrrAggregatePropertyValues.GetChanges().Count > 0)
            {
                LRRAggregateGroupedPropertyValues toSaveGroupedPropertyValues = _lrrAggregatePropertyValues.GetChanges();

                _lrrApp.DBManagerObj.CommitCollection(toSaveGroupedPropertyValues); //Commit Site Components
                if (toSaveGroupedPropertyValues.HasError)
                {
                    LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    _recordValueChanged = "0";
                    _recordAggID = "";
                    return;
                }
                isSaved = true;
                _lrrAggregatePropertyValues.RefreshCollection();
            }
            if (!isSaved)
            {
                LRRMessagBox.ShowMessage("SID_NODATASAVED", true);
            }

        }


        public void CopyMasterProperties()
        {
        }
        public void Paste()
        {
        }
        public void Copy()
        {
        }
        public void Print()
        {
            if (gridAggregates.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridAggregates, false);
            }
            if (gridAggregateEqpmnts.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridAggregateEqpmnts, false);
            }
            if (gridAggregateOfAggregates.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridAggregateOfAggregates, false);
            }
        }
        public void Delete()
        {
        }
        public void ArrangeColumns()
        {
        }
        public void ClearFilter()
        {
            SyncGridUtilities.ClearFilter(gridAggregates);
            SyncGridUtilities.ClearFilter(gridAggregateEqpmnts);
            SyncGridUtilities.ClearFilter(gridAggregateOfAggregates);
        }
        public void InsertNewRows()//Inserts New rows 
        {
        }
        public void ImportToExcel()
        {
        }
        public void Export()
        {
            if (gridAggregates.TableControl.CurrentCell.IsActive)
            {
                ExportToExcel excelExpForm = new ExportToExcel(this.gridAggregates);
                excelExpForm.ShowDialog(this);
            }
            if (gridAggregateEqpmnts.TableControl.CurrentCell.IsActive)
            {
                ExportToExcel excelExpForm = new ExportToExcel(this.gridAggregateEqpmnts);
                excelExpForm.ShowDialog(this);
            }
            if (gridAggregateOfAggregates.TableControl.CurrentCell.IsActive)
            {
                ExportToExcel excelExpForm = new ExportToExcel(this.gridAggregateOfAggregates);
                excelExpForm.ShowDialog(this);
            }
        }
        public void SelectionPaste()
        {

        }

        public void RightLevel()
        {

        }
        public void LeftLevel()
        {

        }
        public void UpLevel()
        {

        }
        public void DownLevel()
        {

        }


        //Methods Suported
        public bool SupportsMasterPropertiesCopy()
        {
            return false;
        }
        public bool SupportsCopy()
        {
            return false;
        }
        public bool SupportsPaste()
        {
            return false;
        }
        public bool SupportsExport()
        {
            return true;
        }
        public bool SupportsSave()
        {
            return true;
        }
        public bool SupportsRefresh()
        {
            return true;
        }
        public bool SupportsDelete()
        {
            return false;
        }
        public bool SupportsPrint()
        {
            return true;
        }
        public bool SupportsArrangeColumns()
        {
            return false;
        }
        public bool SupportsClearFilter()
        {
            return true;
        }
        public bool SupportsInsertNewRows()
        {
            return false;
        }
        public bool SupportsImportToExcel()
        {
            return false;
        }
        public bool SupportsSelectionPaste()
        {
            return false;
        }
        public bool SupportsLevel()
        {
            return false;
        }


        public TabControl ParentTabControl
        {
            set
            {
                _parentTabControl = value;
            }
            get { return _parentTabControl; }
        }

        public TabPage ParentTabPage
        {
            set
            {
                _parentTabPage = value;
            }
            get
            {
                return _parentTabPage;
            }
        }
        public void LeftColMovement()
        {
            // TODO:  Add GroupedPlantPropertiesView.LeftColMovement implementation
        }

        public void RightColMovement()
        {
            // TODO:  Add GroupedPlantPropertiesView.RightColMovement implementation
        }

        public void ClearSort()
        {
            //Add GroupedPlantPropertiesView.ClearSort implementation
            SyncGridUtilities.ClearSort(gridAggregates);
            SyncGridUtilities.ClearSort(gridAggregateEqpmnts);
            SyncGridUtilities.ClearSort(gridAggregateOfAggregates);
        }

        public bool SupportsClearSort()
        {
            // Add GroupedPlantPropertiesView.SupportsClearSort implementation
            return true;
        }


        public void CopyUOMTypes()
        {

        }

        public bool SupportsCopyUOMTypes()
        {
            return false;
        }


        public void PrintPreview()
        {
            if (gridAggregates.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridAggregates, true);
            }
            if (gridAggregateEqpmnts.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridAggregateEqpmnts, true);
            }
            if (gridAggregateOfAggregates.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridAggregateOfAggregates, true);
            }
        }


        public void ShowPropertyList()
        {
            // TODO:  Add GroupedPlantPropertiesView.ShowPropertyList implementation
        }

        public bool SupportsResultsFilter()
        {
            // TODO:  Add GroupedPlantPropertiesView.SupportsResultsFilter implementation
            return false;
        }


        public void ShowComponentList()
        {
            // TODO:  Add GroupedPlantPropertiesView.ShowComponentList implementation
        }

        public void PageSetup()
        {
            GridGroupingPrint ggPrint = new GridGroupingPrint();
            ggPrint.PageSetUp();
        }

        public void Undo()
        {
            // TODO:  Add GroupedPlantItems.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridAggregateEqpmnts);
            SyncGridUtilities.RollBackChanges(this.gridAggregateOfAggregates);
            SyncGridUtilities.RollBackChanges(this.gridAggregates);
            Refresh();

        }

        public bool SupportsPageSetup()
        {
            // TODO:  Add GroupedPlantItems.SupportsPageSetup implementation
            return true;
        }

        public bool SupportsUndo()
        {
            // TODO:  Add GroupedPlantItems.SupportsUndo implementation
            return true;
        }

        public void OpenCompositeView()
        {
            // TODO:  Add GroupedPlantItems.OpenCompositeView implementation
        }

        public void TransposeView()
        {
            // TODO:  Add GroupedPlantItems.TransposeView implementation
        }

        public void OpenQuery()
        {
            // TODO:  Add GroupedPlantItems.OpenQuery implementation
        }

        public void OpenView()
        {
            // TODO:  Add GroupedPlantItems.OpenView implementation
        }

        public bool SupportsCompositeView()
        {
            // TODO:  Add GroupedPlantItems.SupportsCompositeView implementation
            return false;
        }


        private bool _isDeletePress = false;
        private bool _isRecordeDel = false;

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Delete)
            {
                _isDeletePress = true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        private void gridAggregates_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
        {
            if (_isDeletePress)
            {
                DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (_dlgResult == DialogResult.Yes)
                {
                    _isRecordeDel = true;
                }
                else
                {
                    _isRecordeDel = false;
                }
                _isDeletePress = false;
            }
            if (!_isRecordeDel)
            {
                e.Cancel = true;
            }
        }





        public bool PerformDirtyChk
        {
            get
            {
                // TODO:  Add GroupedPlantItems.PerformDirtyChk getter implementation
                return true;
            }
        }

        #endregion
    }
}