using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageLogger; 

using Symcon.LightRidge.PEAdvisor.IOScreen;

namespace Symcon.LightRidge.PEAdvisor.GroupProperties
{
    /// <summary>
    /// Summary description for GroupProperties.
    /// </summary>
    public class GroupedPlantPropertiesView : System.Windows.Forms.Form, ILRRUIContainer, ILRRUISpecificContainer
    {
        private System.ComponentModel.IContainer components;
        private System.Windows.Forms.Panel pnlGroupedPropertiesOutput;
        private System.Windows.Forms.Panel pnlGroupedPropMain;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSave;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemCopy;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPaste;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemClear;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDelete;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemArrangeCols;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPrint;
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemExport;
        private System.Windows.Forms.Splitter splitter1;
        private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager1;
        private System.Windows.Forms.Splitter splitter2;
        private System.Windows.Forms.ImageList imageList3;
        private TabControl _parentTabControl;
        private System.Windows.Forms.ImageList imageList2;
        public System.Windows.Forms.Panel pnlGridContainer;
        private System.Windows.Forms.Splitter splitter6;
        private System.Windows.Forms.Panel pnlSeachMain;
        private System.Windows.Forms.Panel pnlQuery;
        private System.Windows.Forms.Splitter splitter3;
        private System.Windows.Forms.Panel pnlSearchCriteria;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.RadioButton rdQuality;
        private System.Windows.Forms.RadioButton rdGroupByItems;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridQualifiers;
        private System.Windows.Forms.Panel pnlGroupedProperties;
        private System.Windows.Forms.Panel pnlPlantItems;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridPlantItems;
        private System.Windows.Forms.Splitter splitter7;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupedProperties;
        private System.Windows.Forms.Button btnExecute;
        private System.Windows.Forms.Label lblQuery;
        private System.Windows.Forms.ComboBox cmbQueryList;
        private System.Windows.Forms.Splitter splitter5;
        private System.Windows.Forms.Panel pnlGrpPropQualifierModes;
        private System.Windows.Forms.Panel pnlGroupedProp;
        private System.Windows.Forms.Splitter splitter8;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.Panel pnlQualifiers;
        private TabPage _parentTabPage;
        Hashtable lrrFormulaGroupedProperties = new Hashtable();
        private Button button1;
        private Button btnTransPosed;
        private Button btnSaveView;
        private ImageList imageList1;
        private LRRLookUpProperties _objLookUpProperties = new LRRLookUpProperties();
        public bool IsChanged = false;
        public static bool BPropertyValChanged = false;



        /// <summary>
        /// Initializes a new instance of the <see cref="GroupedPlantPropertiesView"/> class.
        /// </summary>
        public GroupedPlantPropertiesView()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            _lrrApp.LRRUIManagerObj.PerformDataDirtyCheck = false;

            InitDataSource();
            BindGridQualifiers();
            BindGridGroupedProperties();
            BindGridPlantItems();

            LRRMasterComponents masterComponents = LRRModel.Model;
            lrrFormulaGroupedProperties.Clear();
            lrrFormulaGroupedProperties.Add(0, masterComponents);
            lrrFormulaGroupedProperties.Add(1, "MasterComponents");
            lrrFormulaGroupedProperties.Add(2, "SiteComponentsObj");
            lrrFormulaGroupedProperties.Add(3, "Properties");
            lrrFormulaGroupedProperties.Add(4, "GroupPpties");
            lrrFormulaGroupedProperties.Add(5, "GroupPptiesQualifierValues");
            lrrFormulaGroupedProperties.Add(6, _objLookupQualifiers);


            LRRFormulaDataStore.DataSource = lrrFormulaGroupedProperties;
            LRRFormulaDataStore.ModeFlag = true;
            LRRFormulaDataStore.ShowGroupedAttributes = true;
            LRRFormulaDataStore.SourceLookupPropertyID = null;
            LRRFormulaDataStore.SourceLookupQualifierID = null;

            this.Closing += new CancelEventHandler(GroupedPlantPropertiesView_Closing);

            LRRModel.ProjectModes.ModesChanged += new EventHandler(ProjectModes_ModesChanged);

        }
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupedPlantPropertiesView"/> class.
        /// </summary>
        /// <param name="b">if set to <c>true</c> [b].</param>
        public GroupedPlantPropertiesView(bool b)
        {
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            LRRMasterComponents masterComponents = LRRModel.Model;

            lrrFormulaGroupedProperties.Clear();
            lrrFormulaGroupedProperties.Add(0, masterComponents);
            lrrFormulaGroupedProperties.Add(1, "MasterComponents");
            lrrFormulaGroupedProperties.Add(2, "SiteComponentsObj");
            lrrFormulaGroupedProperties.Add(3, "Properties");
            lrrFormulaGroupedProperties.Add(4, "GroupPpties");
            lrrFormulaGroupedProperties.Add(5, "GroupPptiesQualifierValues");
            lrrFormulaGroupedProperties.Add(6, _objLookupQualifiers);
            LRRFormulaDataStore.ShowGroupedAttributes = true;
            LRRFormulaDataStore.DataSource = lrrFormulaGroupedProperties;
            LRRFormulaDataStore.ModeFlag = true;
            LRRFormulaDataStore.SourceLookupPropertyID = null;
            LRRFormulaDataStore.SourceLookupQualifierID = null;

            this.Closing += new CancelEventHandler(GroupedPlantPropertiesView_Closing);
            LRRModel.ProjectModes.ModesChanged += new EventHandler(ProjectModes_ModesChanged);

        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(GroupedPlantPropertiesView));
            this.pnlGroupedPropertiesOutput = new System.Windows.Forms.Panel();
            this.pnlGridContainer = new System.Windows.Forms.Panel();
            this.splitter6 = new System.Windows.Forms.Splitter();
            this.pnlGroupedPropMain = new System.Windows.Forms.Panel();
            this.pnlSeachMain = new System.Windows.Forms.Panel();
            this.pnlSearchCriteria = new System.Windows.Forms.Panel();
            this.pnlGroupedProperties = new System.Windows.Forms.Panel();
            this.pnlGrpPropQualifierModes = new System.Windows.Forms.Panel();
            this.panel1 = new System.Windows.Forms.Panel();
            this.pnlQualifiers = new System.Windows.Forms.Panel();
            this.gridQualifiers = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter8 = new System.Windows.Forms.Splitter();
            this.pnlGroupedProp = new System.Windows.Forms.Panel();
            this.gridGroupedProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter5 = new System.Windows.Forms.Splitter();
            this.pnlPlantItems = new System.Windows.Forms.Panel();
            this.gridPlantItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter7 = new System.Windows.Forms.Splitter();
            this.splitter3 = new System.Windows.Forms.Splitter();
            this.pnlQuery = new System.Windows.Forms.Panel();
            this.btnTransPosed = new System.Windows.Forms.Button();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.cmbQueryList = new System.Windows.Forms.ComboBox();
            this.lblQuery = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.rdQuality = new System.Windows.Forms.RadioButton();
            this.rdGroupByItems = new System.Windows.Forms.RadioButton();
            this.btnExecute = new System.Windows.Forms.Button();
            this.imageList3 = new System.Windows.Forms.ImageList(this.components);
            this.btnSaveView = new System.Windows.Forms.Button();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.imageList2 = new System.Windows.Forms.ImageList(this.components);
            this.barItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemPrint = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemCopy = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemDelete = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemClear = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemArrangeCols = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemExport = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
            this.pnlGroupedPropertiesOutput.SuspendLayout();
            this.pnlGridContainer.SuspendLayout();
            this.pnlGroupedPropMain.SuspendLayout();
            this.pnlSeachMain.SuspendLayout();
            this.pnlSearchCriteria.SuspendLayout();
            this.pnlGroupedProperties.SuspendLayout();
            this.pnlGrpPropQualifierModes.SuspendLayout();
            this.panel1.SuspendLayout();
            this.pnlQualifiers.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridQualifiers)).BeginInit();
            this.pnlGroupedProp.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupedProperties)).BeginInit();
            this.pnlPlantItems.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems)).BeginInit();
            this.pnlQuery.SuspendLayout();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
            this.SuspendLayout();
            // 
            // pnlGroupedPropertiesOutput
            // 
            this.pnlGroupedPropertiesOutput.AutoScroll = true;
            this.pnlGroupedPropertiesOutput.Controls.Add(this.pnlGridContainer);
            this.pnlGroupedPropertiesOutput.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGroupedPropertiesOutput.Location = new System.Drawing.Point(0, 2);
            this.pnlGroupedPropertiesOutput.Name = "pnlGroupedPropertiesOutput";
            this.pnlGroupedPropertiesOutput.Size = new System.Drawing.Size(1028, 619);
            this.pnlGroupedPropertiesOutput.TabIndex = 8;
            // 
            // pnlGridContainer
            // 
            this.pnlGridContainer.AutoScroll = true;
            this.pnlGridContainer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pnlGridContainer.Controls.Add(this.splitter6);
            this.pnlGridContainer.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGridContainer.Location = new System.Drawing.Point(0, 0);
            this.pnlGridContainer.Name = "pnlGridContainer";
            this.pnlGridContainer.Size = new System.Drawing.Size(1028, 619);
            this.pnlGridContainer.TabIndex = 9;
            // 
            // splitter6
            // 
            this.splitter6.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter6.Location = new System.Drawing.Point(0, 614);
            this.splitter6.Name = "splitter6";
            this.splitter6.Size = new System.Drawing.Size(1026, 3);
            this.splitter6.TabIndex = 0;
            this.splitter6.TabStop = false;
            // 
            // pnlGroupedPropMain
            // 
            this.pnlGroupedPropMain.AutoScroll = true;
            this.pnlGroupedPropMain.Controls.Add(this.pnlSeachMain);
            this.pnlGroupedPropMain.Controls.Add(this.splitter2);
            this.dockingManager1.SetEnableDocking(this.pnlGroupedPropMain, true);
            this.pnlGroupedPropMain.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.pnlGroupedPropMain.Location = new System.Drawing.Point(1, 21);
            this.pnlGroupedPropMain.Name = "pnlGroupedPropMain";
            this.pnlGroupedPropMain.Size = new System.Drawing.Size(659, 597);
            this.pnlGroupedPropMain.TabIndex = 0;
            // 
            // pnlSeachMain
            // 
            this.pnlSeachMain.Controls.Add(this.pnlSearchCriteria);
            this.pnlSeachMain.Controls.Add(this.splitter3);
            this.pnlSeachMain.Controls.Add(this.pnlQuery);
            this.pnlSeachMain.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlSeachMain.Location = new System.Drawing.Point(0, 2);
            this.pnlSeachMain.Name = "pnlSeachMain";
            this.pnlSeachMain.Size = new System.Drawing.Size(659, 595);
            this.pnlSeachMain.TabIndex = 2;
            // 
            // pnlSearchCriteria
            // 
            this.pnlSearchCriteria.Controls.Add(this.pnlGroupedProperties);
            this.pnlSearchCriteria.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlSearchCriteria.Location = new System.Drawing.Point(0, 86);
            this.pnlSearchCriteria.Name = "pnlSearchCriteria";
            this.pnlSearchCriteria.Size = new System.Drawing.Size(659, 509);
            this.pnlSearchCriteria.TabIndex = 2;
            // 
            // pnlGroupedProperties
            // 
            this.pnlGroupedProperties.Controls.Add(this.pnlGrpPropQualifierModes);
            this.pnlGroupedProperties.Controls.Add(this.splitter5);
            this.pnlGroupedProperties.Controls.Add(this.pnlPlantItems);
            this.pnlGroupedProperties.Controls.Add(this.splitter7);
            this.pnlGroupedProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGroupedProperties.Location = new System.Drawing.Point(0, 0);
            this.pnlGroupedProperties.Name = "pnlGroupedProperties";
            this.pnlGroupedProperties.Size = new System.Drawing.Size(659, 509);
            this.pnlGroupedProperties.TabIndex = 8;
            // 
            // pnlGrpPropQualifierModes
            // 
            this.pnlGrpPropQualifierModes.Controls.Add(this.panel1);
            this.pnlGrpPropQualifierModes.Controls.Add(this.splitter8);
            this.pnlGrpPropQualifierModes.Controls.Add(this.pnlGroupedProp);
            this.pnlGrpPropQualifierModes.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGrpPropQualifierModes.Location = new System.Drawing.Point(2, 0);
            this.pnlGrpPropQualifierModes.Name = "pnlGrpPropQualifierModes";
            this.pnlGrpPropQualifierModes.Size = new System.Drawing.Size(286, 509);
            this.pnlGrpPropQualifierModes.TabIndex = 4;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.pnlQualifiers);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 226);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(286, 283);
            this.panel1.TabIndex = 12;
            // 
            // pnlQualifiers
            // 
            this.pnlQualifiers.Controls.Add(this.gridQualifiers);
            this.pnlQualifiers.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlQualifiers.Location = new System.Drawing.Point(0, 0);
            this.pnlQualifiers.Name = "pnlQualifiers";
            this.pnlQualifiers.Size = new System.Drawing.Size(286, 283);
            this.pnlQualifiers.TabIndex = 0;
            // 
            // gridQualifiers
            // 
            this.gridQualifiers.BackColor = System.Drawing.SystemColors.Window;
            this.gridQualifiers.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridQualifiers.Location = new System.Drawing.Point(0, 0);
            this.gridQualifiers.Name = "gridQualifiers";
            this.gridQualifiers.Size = new System.Drawing.Size(286, 283);
            this.gridQualifiers.TabIndex = 0;
            this.gridQualifiers.Text = "gridGroupingControl1";
            this.gridQualifiers.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridQualifiers.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridQualifiers.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridQualifiers.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridQualifiers.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridQualifiers.VersionInfo = "3.301.0.0";
            // 
            // splitter8
            // 
            this.splitter8.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter8.Location = new System.Drawing.Point(0, 224);
            this.splitter8.Name = "splitter8";
            this.splitter8.Size = new System.Drawing.Size(286, 2);
            this.splitter8.TabIndex = 11;
            this.splitter8.TabStop = false;
            // 
            // pnlGroupedProp
            // 
            this.pnlGroupedProp.Controls.Add(this.gridGroupedProperties);
            this.pnlGroupedProp.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlGroupedProp.Location = new System.Drawing.Point(0, 0);
            this.pnlGroupedProp.Name = "pnlGroupedProp";
            this.pnlGroupedProp.Size = new System.Drawing.Size(286, 224);
            this.pnlGroupedProp.TabIndex = 0;
            // 
            // gridGroupedProperties
            // 
            this.gridGroupedProperties.BackColor = System.Drawing.SystemColors.Window;
            this.gridGroupedProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridGroupedProperties.Location = new System.Drawing.Point(0, 0);
            this.gridGroupedProperties.Name = "gridGroupedProperties";
            this.gridGroupedProperties.Size = new System.Drawing.Size(286, 224);
            this.gridGroupedProperties.TabIndex = 0;
            this.gridGroupedProperties.Text = "gridGroupingControl3";
            this.gridGroupedProperties.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridGroupedProperties.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridGroupedProperties.VersionInfo = "3.301.0.0";
            this.gridGroupedProperties.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridGroupedProperties_RecordValueChanged);
            // 
            // splitter5
            // 
            this.splitter5.Dock = System.Windows.Forms.DockStyle.Right;
            this.splitter5.Location = new System.Drawing.Point(288, 0);
            this.splitter5.Name = "splitter5";
            this.splitter5.Size = new System.Drawing.Size(2, 509);
            this.splitter5.TabIndex = 3;
            this.splitter5.TabStop = false;
            // 
            // pnlPlantItems
            // 
            this.pnlPlantItems.Controls.Add(this.gridPlantItems);
            this.pnlPlantItems.Dock = System.Windows.Forms.DockStyle.Right;
            this.pnlPlantItems.Location = new System.Drawing.Point(290, 0);
            this.pnlPlantItems.Name = "pnlPlantItems";
            this.pnlPlantItems.Size = new System.Drawing.Size(369, 509);
            this.pnlPlantItems.TabIndex = 2;
            // 
            // gridPlantItems
            // 
            this.gridPlantItems.BackColor = System.Drawing.SystemColors.Window;
            this.gridPlantItems.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridPlantItems.Location = new System.Drawing.Point(0, 0);
            this.gridPlantItems.Name = "gridPlantItems";
            this.gridPlantItems.Size = new System.Drawing.Size(369, 509);
            this.gridPlantItems.TabIndex = 0;
            this.gridPlantItems.Text = "gridGroupingControl2";
            this.gridPlantItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridPlantItems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridPlantItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridPlantItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridPlantItems.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridPlantItems.VersionInfo = "3.301.0.0";
            // 
            // splitter7
            // 
            this.splitter7.Location = new System.Drawing.Point(0, 0);
            this.splitter7.Name = "splitter7";
            this.splitter7.Size = new System.Drawing.Size(2, 509);
            this.splitter7.TabIndex = 1;
            this.splitter7.TabStop = false;
            // 
            // splitter3
            // 
            this.splitter3.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter3.Location = new System.Drawing.Point(0, 84);
            this.splitter3.Name = "splitter3";
            this.splitter3.Size = new System.Drawing.Size(659, 2);
            this.splitter3.TabIndex = 1;
            this.splitter3.TabStop = false;
            // 
            // pnlQuery
            // 
            this.pnlQuery.Controls.Add(this.btnTransPosed);
            this.pnlQuery.Controls.Add(this.cmbQueryList);
            this.pnlQuery.Controls.Add(this.lblQuery);
            this.pnlQuery.Controls.Add(this.groupBox1);
            this.pnlQuery.Controls.Add(this.btnExecute);
            this.pnlQuery.Controls.Add(this.btnSaveView);
            this.pnlQuery.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlQuery.Location = new System.Drawing.Point(0, 0);
            this.pnlQuery.Name = "pnlQuery";
            this.pnlQuery.Size = new System.Drawing.Size(659, 84);
            this.pnlQuery.TabIndex = 0;
            // 
            // btnTransPosed
            // 
            this.btnTransPosed.ImageAlign = System.Drawing.ContentAlignment.TopRight;
            this.btnTransPosed.ImageIndex = 11;
            this.btnTransPosed.ImageList = this.imageList1;
            this.btnTransPosed.Location = new System.Drawing.Point(575, 58);
            this.btnTransPosed.Name = "btnTransPosed";
            this.btnTransPosed.Size = new System.Drawing.Size(72, 24);
            this.btnTransPosed.TabIndex = 14;
            this.btnTransPosed.Tag = "SID_TRANSPOSE";
            this.btnTransPosed.TextAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnTransPosed.TextImageRelation = System.Windows.Forms.TextImageRelation.TextBeforeImage;
            this.btnTransPosed.Click += new System.EventHandler(this.button1_Click);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            this.imageList1.Images.SetKeyName(5, "");
            this.imageList1.Images.SetKeyName(6, "");
            this.imageList1.Images.SetKeyName(7, "");
            this.imageList1.Images.SetKeyName(8, "");
            this.imageList1.Images.SetKeyName(9, "");
            this.imageList1.Images.SetKeyName(10, "");
            this.imageList1.Images.SetKeyName(11, "");
            this.imageList1.Images.SetKeyName(12, "");
            // 
            // cmbQueryList
            // 
            this.cmbQueryList.Location = new System.Drawing.Point(88, 24);
            this.cmbQueryList.Name = "cmbQueryList";
            this.cmbQueryList.Size = new System.Drawing.Size(192, 21);
            this.cmbQueryList.TabIndex = 13;
            this.cmbQueryList.Tag = "SID_QUERY_LIST";
            this.cmbQueryList.SelectedIndexChanged += new System.EventHandler(this.cmbQueryList_SelectedIndexChanged);
            this.cmbQueryList.DropDown += new System.EventHandler(this.cmbQueryList_DropDown);
            // 
            // lblQuery
            // 
            this.lblQuery.Location = new System.Drawing.Point(8, 24);
            this.lblQuery.Name = "lblQuery";
            this.lblQuery.Size = new System.Drawing.Size(72, 24);
            this.lblQuery.TabIndex = 12;
            this.lblQuery.Tag = "SID_QUERY";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.rdQuality);
            this.groupBox1.Controls.Add(this.rdGroupByItems);
            this.groupBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.groupBox1.Location = new System.Drawing.Point(288, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(272, 56);
            this.groupBox1.TabIndex = 11;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "View Output By";
            // 
            // rdQuality
            // 
            this.rdQuality.Checked = true;
            this.rdQuality.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.rdQuality.Location = new System.Drawing.Point(168, 24);
            this.rdQuality.Name = "rdQuality";
            this.rdQuality.Size = new System.Drawing.Size(88, 16);
            this.rdQuality.TabIndex = 6;
            this.rdQuality.TabStop = true;
            this.rdQuality.Text = "Qualifiers";
            this.rdQuality.CheckedChanged +=new EventHandler(rdQuality_CheckedChanged);
            // 
            // rdGroupByItems
            // 
            this.rdGroupByItems.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.rdGroupByItems.Location = new System.Drawing.Point(24, 24);
            this.rdGroupByItems.Name = "rdGroupByItems";
            this.rdGroupByItems.Size = new System.Drawing.Size(136, 16);
            this.rdGroupByItems.TabIndex = 5;
            this.rdGroupByItems.Text = "Plant Item";
            this.rdGroupByItems.CheckedChanged +=new EventHandler(rdGroupByItems_CheckedChanged);
            // 
            // btnExecute
            // 
            this.btnExecute.ImageAlign = System.Drawing.ContentAlignment.TopRight;
            this.btnExecute.ImageIndex = 8;
            this.btnExecute.ImageList = this.imageList3;
            this.btnExecute.Location = new System.Drawing.Point(575, 1);
            this.btnExecute.Name = "btnExecute";
            this.btnExecute.Size = new System.Drawing.Size(72, 24);
            this.btnExecute.TabIndex = 7;
            this.btnExecute.Tag = "SID_EXECUTE";
            this.btnExecute.TextAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnExecute.Click += new System.EventHandler(this.btnExecute_Click);
            // 
            // imageList3
            // 
            this.imageList3.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList3.ImageStream")));
            this.imageList3.TransparentColor = System.Drawing.SystemColors.Desktop;
            this.imageList3.Images.SetKeyName(0, "");
            this.imageList3.Images.SetKeyName(1, "");
            this.imageList3.Images.SetKeyName(2, "");
            this.imageList3.Images.SetKeyName(3, "");
            this.imageList3.Images.SetKeyName(4, "");
            this.imageList3.Images.SetKeyName(5, "");
            this.imageList3.Images.SetKeyName(6, "");
            this.imageList3.Images.SetKeyName(7, "");
            this.imageList3.Images.SetKeyName(8, "");
            // 
            // btnSaveView
            // 
            this.btnSaveView.Location = new System.Drawing.Point(575, 29);
            this.btnSaveView.Name = "btnSaveView";
            this.btnSaveView.Size = new System.Drawing.Size(72, 24);
            this.btnSaveView.TabIndex = 7;
            this.btnSaveView.Tag = "SID_SAVE_VIEW";
            this.btnSaveView.Click += new System.EventHandler(this.btnSaveView_Click);
            // 
            // splitter2
            // 
            this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter2.Location = new System.Drawing.Point(0, 0);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(659, 2);
            this.splitter2.TabIndex = 1;
            this.splitter2.TabStop = false;
            // 
            // imageList2
            // 
            this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
            this.imageList2.TransparentColor = System.Drawing.SystemColors.Desktop;
            this.imageList2.Images.SetKeyName(0, "");
            this.imageList2.Images.SetKeyName(1, "");
            this.imageList2.Images.SetKeyName(2, "");
            this.imageList2.Images.SetKeyName(3, "");
            this.imageList2.Images.SetKeyName(4, "");
            this.imageList2.Images.SetKeyName(5, "");
            this.imageList2.Images.SetKeyName(6, "");
            this.imageList2.Images.SetKeyName(7, "");
            // 
            // barItemSave
            // 
            this.barItemSave.CategoryIndex = -1;
            this.barItemSave.ID = "Save";
            this.barItemSave.ImageIndex = 0;
            this.barItemSave.ImageList = this.imageList2;
            this.barItemSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemSave.Tag = "SID_SAVE";
            this.barItemSave.Tooltip = "Click here to save";
            // 
            // barItemPrint
            // 
            this.barItemPrint.CategoryIndex = -1;
            this.barItemPrint.ID = "Print";
            this.barItemPrint.ImageIndex = 1;
            this.barItemPrint.ImageList = this.imageList2;
            this.barItemPrint.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemPrint.Tag = "SID_PRINT";
            this.barItemPrint.Tooltip = "Click here to print.";
            // 
            // barItemCopy
            // 
            this.barItemCopy.CategoryIndex = -1;
            this.barItemCopy.ID = "Copy";
            this.barItemCopy.ImageIndex = 2;
            this.barItemCopy.ImageList = this.imageList2;
            this.barItemCopy.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
            this.barItemCopy.Tag = "SID_COPY";
            this.barItemCopy.Tooltip = "Click here to copy a row or the selection";
            // 
            // barItemPaste
            // 
            this.barItemPaste.CategoryIndex = -1;
            this.barItemPaste.ID = "Paste";
            this.barItemPaste.ImageIndex = 3;
            this.barItemPaste.ImageList = this.imageList2;
            this.barItemPaste.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
            this.barItemPaste.Tag = "SID_PASTE";
            this.barItemPaste.Tooltip = "Click here to paste a row or the selection";
            // 
            // barItemDelete
            // 
            this.barItemDelete.CategoryIndex = -1;
            this.barItemDelete.ID = "Delete";
            this.barItemDelete.ImageIndex = 4;
            this.barItemDelete.ImageList = this.imageList2;
            this.barItemDelete.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemDelete.Tag = "SID_DEL";
            this.barItemDelete.Tooltip = "Click here to delete the row.";
            // 
            // barItemClear
            // 
            this.barItemClear.CategoryIndex = -1;
            this.barItemClear.ID = "Clear Filter";
            this.barItemClear.ImageIndex = 5;
            this.barItemClear.ImageList = this.imageList2;
            this.barItemClear.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemClear.Tag = "SID_CLEAR_FILTER";
            this.barItemClear.Tooltip = "Click here to clear the filter criteria specified.";
            // 
            // barItemArrangeCols
            // 
            this.barItemArrangeCols.CategoryIndex = -1;
            this.barItemArrangeCols.ID = "Arrange columns";
            this.barItemArrangeCols.ImageIndex = 7;
            this.barItemArrangeCols.ImageList = this.imageList2;
            this.barItemArrangeCols.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemArrangeCols.Tag = "SID_ARRANGE_COL";
            this.barItemArrangeCols.Tooltip = "Click here to specify the columns";
            // 
            // barItemExport
            // 
            this.barItemExport.CategoryIndex = -1;
            this.barItemExport.ID = "Export";
            this.barItemExport.ImageIndex = 6;
            this.barItemExport.ImageList = this.imageList2;
            this.barItemExport.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemExport.Tag = "SID_EXPORT";
            this.barItemExport.Tooltip = "Click here to export the data";
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(1028, 2);
            this.splitter1.TabIndex = 2;
            this.splitter1.TabStop = false;
            // 
            // dockingManager1
            // 
            this.dockingManager1.AutoHideInterval = 200;
            this.dockingManager1.CloseEnabled = false;
            this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
            this.dockingManager1.HostControl = this;
            this.dockingManager1.ShowToolTips = true;
            this.dockingManager1.AutoHideAnimationStart += new Syncfusion.Windows.Forms.Tools.AutoHideAnimationEventHandler(this.dockingManager1_AutoHideAnimationStart);
            this.dockingManager1.SetDockLabel(this.pnlGroupedPropMain, "View Criteria");
            this.dockingManager1.SetAutoHideOnLoad(this.pnlGroupedPropMain, true);
            // 
            // GroupedPlantPropertiesView
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(1028, 621);
            this.Controls.Add(this.pnlGroupedPropertiesOutput);
            this.Controls.Add(this.splitter1);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "GroupedPlantPropertiesView";
            this.Text = "Plant Item Properties(Grouped) View";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.GroupedPlantPropertiesView_Load);
            this.Closed += new System.EventHandler(this.GroupedPlantPropertiesView_Closed);
            this.Activated += new System.EventHandler(this.GroupedPlantPropertiesView_Activated);
            this.Deactivate += new EventHandler(GroupedPlantPropertiesView_Deactivate);
            this.pnlGroupedPropertiesOutput.ResumeLayout(false);
            this.pnlGridContainer.ResumeLayout(false);
            this.pnlGroupedPropMain.ResumeLayout(false);
            this.pnlSeachMain.ResumeLayout(false);
            this.pnlSearchCriteria.ResumeLayout(false);
            this.pnlGroupedProperties.ResumeLayout(false);
            this.pnlGrpPropQualifierModes.ResumeLayout(false);
            this.panel1.ResumeLayout(false);
            this.pnlQualifiers.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridQualifiers)).EndInit();
            this.pnlGroupedProp.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridGroupedProperties)).EndInit();
            this.pnlPlantItems.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems)).EndInit();
            this.pnlQuery.ResumeLayout(false);
            this.groupBox1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();
            this.ResumeLayout(false);

        }


        /// <summary>
        /// Handles the Click event of the btnSaveView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        void btnSaveView_Click(object sender, EventArgs e)
        {
            SaveQuery();
        }
        #endregion

        #region ILRRUIContainer Members
        public new void Refresh()
        {
            //Method to Refresh the User Interface form..
            //			LRRUIManager lrrUI=new LRRUIManager();
            //			
            //			lrrUI.SaveGridSettings(gridPlantItems,this);
            //			lrrUI.SaveGridSettings(gridGroupingModes,this);
            //			lrrUI.SaveGridSettings(gridPlantItems2,this);
            //			lrrUI.SaveGridSettings(gridQualifiers,this);
            //
            //			lrrUI.ApplyGridSettings(gridPlantItems,this);
            //			lrrUI.ApplyGridSettings(gridGroupingModes,this);
            //			lrrUI.ApplyGridSettings(gridPlantItems2,this);
            //			lrrUI.ApplyGridSettings(gridQualifiers,this);

        }
        public void Save() //Method to save the contents of the form...
        {
            LRRSiteGroupPropertyQualifierValues propertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();

            if (propertyQualifierValues.Count > 0)
            {
                _lrrApp.DBManagerObj.CommitCollection(propertyQualifierValues); //Commit Site Components


                if (propertyQualifierValues.HasError)
                {
                    LRRMessagBox.ShowMessage("SID_PLANTEFFICTIVETIME_BLANK_ERROR", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                foreach (LRRSiteGroupPropertyQualifierValue siteGrpPropQualifierVal in propertyQualifierValues)
                {
                    if (siteGrpPropQualifierVal.Direction == "1" && siteGrpPropQualifierVal.Derivation == "4")
                    {
                        MessagingClient.GroupedPropertyValueChanged(siteGrpPropQualifierVal.LookUpQualifierID, siteGrpPropQualifierVal.GroupPropertyID, siteGrpPropQualifierVal.ModeID, siteGrpPropQualifierVal.PropertyValue);
                    }
                }
                _lrrApp.SetGroupPropertyValueBinding(propertyQualifierValues);
                LRRMessagBox.ShowMessage("SID_UPDATED_QUALIFIER", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);

                LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                //propertyQualifierValues.RefreshCollection();
                LRRMessagBox.ShowMessage("SID_SAVEDINFO", true);
            }
            else
                LRRMessagBox.ShowMessage("SID_NODATASAVED", true);
            BPropertyValChanged = false;


            
            /*//			SaveQueryForm saveQueryForm = new SaveQueryForm();

            if (gridView  == null)
            {
                MessageBox.Show("Please execute the query before saving!");
                return;
            }
            string queryName = cmbQueryList.Text;
            if (cmbQueryList.SelectedValue != null && cmbQueryList.SelectedValue.ToString() == "0")
                queryName = "";

            //			PrepareQuery();
            SaveQueryForm saveQueryForm = new SaveQueryForm(queryName, "Query");
            //Incase output is rendered, check for saving the query along with the output
            if (this.pnlGridContainer.Controls.Count > 1)
            {
                DialogResult resultQueryForm = saveQueryForm.ShowDialog();
                if (resultQueryForm == DialogResult.OK)
                {
                    SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
                }
                //SaveOutput();
                return;
            }
            //Incase output is not rendered, save only the query
            DialogResult result = saveQueryForm.ShowDialog();

            if (result == DialogResult.OK)
            {
                SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
            }
            IsChanged = false;*/
        }


        public void SaveOutput()
        {
            /*LRRSiteGroupPropertyQualifierValues propertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();

               if (propertyQualifierValues.Count > 0)
               {
                   _lrrApp.DBManagerObj.CommitCollection(propertyQualifierValues); //Commit Site Components

                   if (propertyQualifierValues.HasError)
                   {
                       LRRMessagBox.ShowMessage("SID_PLANTEFFICTIVETIME_BLANK_ERROR", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                       return;
                   }

                   foreach (LRRSiteGroupPropertyQualifierValue siteGrpPropQualifierVal in propertyQualifierValues)
                   {
                       if (siteGrpPropQualifierVal.Direction == "1" && siteGrpPropQualifierVal.Derivation == "4")
                       {
                           MessagingClient.GroupedPropertyValueChanged(siteGrpPropQualifierVal.LookUpQualifierID, siteGrpPropQualifierVal.GroupPropertyID, siteGrpPropQualifierVal.ModeID, siteGrpPropQualifierVal.PropertyValue);
                       }
                   }
                   _lrrApp.SetGroupPropertyValueBinding(propertyQualifierValues);
                   LRRMessagBox.ShowMessage("SID_UPDATED_QUALIFIER", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);

                   LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                   //propertyQualifierValues.RefreshCollection();*/
        }

        public void SaveQuery()
        {
            if (gridView == null)
            {
                MessageBox.Show("Please execute the query before saving!");
                return;
            }
            string queryName = cmbQueryList.Text;
            if (cmbQueryList.SelectedValue != null && cmbQueryList.SelectedValue.ToString() == "0")
                queryName = "";

            //			PrepareQuery();
            SaveQueryForm saveQueryForm = new SaveQueryForm(queryName, "Query");
            //Incase output is rendered, check for saving the query along with the output
            if (this.pnlGridContainer.Controls.Count > 1)
            {
                DialogResult resultQueryForm = saveQueryForm.ShowDialog();
                if (resultQueryForm == DialogResult.OK)
                {
                    SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
                }
                //SaveOutput();
                return;
            }
            //Incase output is not rendered, save only the query
            DialogResult result = saveQueryForm.ShowDialog();

            if (result == DialogResult.OK)
            {
                SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
            }
            IsChanged = false;
        }

        public void CopyMasterProperties()
        {
        }

        public void Paste()
        {
        }

        public void Copy()
        {
        }

        public void Print()
        {
            if (gridView != null)
                gridView.Print();
        }

        public void Delete()
        {
        }

        public void ArrangeColumns()
        {
        }

        public void ClearFilter()
        {
        }

        public void InsertNewRows()//Inserts New rows 
        {
        }

        public void ImportToExcel()
        {
        }

        public void Export()
        {
            if (gridView != null && gridView.Export() != null)
            {
                ExportToExcel excelExpForm = new ExportToExcel(gridView.Export());
                excelExpForm.ShowDialog(this);
            }
            else
            {
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
        }

        public void SelectionPaste()
        {
        }

        public void RightLevel()
        {

        }

        public void LeftLevel()
        {

        }

        public void UpLevel()
        {

        }

        public void DownLevel()
        {

        }


        //Methods Suported
        public bool SupportsMasterPropertiesCopy()
        {
            return false;
        }

        public bool SupportsCopy()
        {
            return false;
        }
        public bool SupportsPaste()
        {
            return false;
        }

        public bool SupportsExport()
        {
            return true;
        }

        public bool SupportsSave()
        {
            return true;
        }

        public bool SupportsRefresh()
        {
            return false;
        }

        public bool SupportsDelete()
        {
            return false;
        }

        public bool SupportsPrint()
        {
            return true;
        }

        public bool SupportsArrangeColumns()
        {
            return false;
        }

        public bool SupportsClearFilter()
        {
            return true;
        }

        public bool SupportsInsertNewRows()
        {
            return false;
        }

        public bool SupportsImportToExcel()
        {
            return false;
        }

        public bool SupportsSelectionPaste()
        {
            return false;
        }

        public bool SupportsLevel()
        {
            return false;
        }

        public TabControl ParentTabControl
        {
            set
            {
                _parentTabControl = value;
            }
            get { return _parentTabControl; }
        }

        public TabPage ParentTabPage
        {
            set
            {
                _parentTabPage = value;
            }
            get
            {
                return _parentTabPage;
            }
        }
        #endregion

        #region Private Methods

        /// <summary>
        /// Inits the data source.
        /// </summary>
        private void InitDataSource()
        {
            if (_lrrSiteCompoProps != null)
                _lrrSiteCompoProps.Clear();

            if (_objPropertyTypes != null)
                _objPropertyTypes.Clear();

            if (_objSiteComponents != null)
                _objSiteComponents.Clear();

            if (_objQualifiers != null)
                _objQualifiers.Clear();

            if (_objLookupQualifiers != null)
                _objLookupQualifiers.Clear();

            if (_lrrSearchCriterias != null)
                _lrrSearchCriterias.Clear();

            if (_objLookUpProperties != null)
                _objLookUpProperties.Clear();

            _objPropertyTypes = new LRRPropertyTypes();
            _lrrApp.DBManagerObj.PopulateCollection(_objPropertyTypes, " WHERE ID NOT IN ('0','1','2') ", false);

            _objSiteComponents = new LRRSiteComponents();



            // only see PI's that have at least one attribute <> "simple" 

            foreach (LRRSiteComponent objsite in LRRModel.SiteComponentsObj)
            {
                LRRSiteComponentProperties sitCompPpties = LRRModel.SiteComponentPropertiesObj.GetSiteCompPptiesByIDWithTypeNotSimple_DataArray(objsite.SiteComponentID);
                if (sitCompPpties != null)
                {
                    if (sitCompPpties.Count > 0)
                    {
                        _objSiteComponents.Add(objsite);
                    }
                }
            }
            _lrrSiteCompoProps = LRRModel.ChildModel.SiteComponentProperties;

            _objQualifiers = new LRRQualifiers();
            _objQualifiers = LRRModel.Qualifiers;

            _objLookupQualifiers = new LRRLookUpQualifiers();
            _lrrApp.DBManagerObj.PopulateCollection(_objLookupQualifiers, false);

            _lrrSearchCriterias = new LRRSearchCriterias();
            _lrrApp.DBManagerObj.PopulateCollection(_lrrSearchCriterias, " WHERE (Source = 'GP' OR  Source is null) ", false, true);
            _lrrSearchCriterias = _lrrSearchCriterias.FilterForUserByUserID();

            _objLookUpProperties = new LRRLookUpProperties();
            _lrrApp.DBManagerObj.PopulateCollection(_objLookUpProperties, false);
            //-- complete list for Qualifiers
            for (int j = 0; j < _objQualifiers.Count; j++)
            {
                _AllQualifiers.Add(_objQualifiers[j].QualifierID, _objQualifiers[j]);
            }


            for (int j = 0; j < _objSiteComponents.Count; j++)
            {
                _AllComponents.Add(_objSiteComponents[j].SiteComponentID, _objSiteComponents[j]);
            }
        }
        /// <summary>
        /// Binds the grid qualifiers.
        /// </summary>
        private void BindGridQualifiers()
        {
            //Suspend the Layout of the Grid...
            gridQualifiers.SuspendLayout();
            Hashtable columnForDisplay = new Hashtable();
            Hashtable RelativeWidths = new Hashtable();

            SyncGridUtilities.InitializeGridLookAndFeel(gridQualifiers);

            columnForDisplay.Add("PropertyType", null);
            gridQualifiers.TableDescriptor.Relations.Clear();
            //Initialize the columns for the grid...
            SyncGridUtilities.InitializeGridColumns(gridQualifiers, _lrrPropertyTypes.ItemType, null, true, columnForDisplay);

            this.gridQualifiers.TableDescriptor.RecordFilters.Clear();
            gridQualifiers.TableDescriptor.AllowNew = false;
            gridQualifiers.TableDescriptor.AllowRemove = true;
            gridQualifiers.TableDescriptor.AllowEdit = true;
            gridQualifiers.TableDescriptor.Relations.Clear();


            //Add the parent table for the Relations...
            gridQualifiers.Engine.SourceListSet.Add("ParentTable", _lrrPropertyTypes);

            //Set the data source for the grid
            gridQualifiers.DataSource = _lrrPropertyTypes;

            //gridQualifiers.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_QUALIFIER")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS") + " For Qualifier - " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(_sSelectedQualifierID).Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
            gridQualifiers.TableDescriptor.AllowEdit = false;
            gridQualifiers.TableDescriptor.AllowNew = false;
            gridQualifiers.TableDescriptor.AllowRemove = false;

            //Look up qualifiers
            GridRelationDescriptor grdLookUpQualifiers = new GridRelationDescriptor("Property Based Qualifier(s)");
            grdLookUpQualifiers.ChildTableName = "LookUpQualifiers";
            grdLookUpQualifiers.RelationKeys.Add("ID", "PropertyID");
            grdLookUpQualifiers.RelationKind = RelationKind.RelatedMasterDetails;
            grdLookUpQualifiers.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Blue;
            grdLookUpQualifiers.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
            //grdLookUpQualifiers.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PROP_BASED_QUALIFIER")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS") + " For Qualifier - " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(_sSelectedQualifierID).Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
            gridQualifiers.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
            grdLookUpQualifiers.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
            gridQualifiers.TableDescriptor.Relations.Add(grdLookUpQualifiers);
            gridQualifiers.NestedTableGroupOptions.ShowFilterBar = false;
            gridQualifiers.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
            gridQualifiers.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
            grdLookUpQualifiers.ChildTableDescriptor.Appearance.AnyCell.ShowButtons = GridShowButtons.Hide;
            gridQualifiers.Engine.SourceListSet.Add("LookUpQualifiers", _lrrLookUpQualifiers);

            Hashtable columnForChildTable = new Hashtable();
            columnForChildTable.Add("QualifierID", null);
            columnForChildTable.Add("IsSelected", null);

            RelativeWidths.Add("IsSelected", 5);
            RelativeWidths.Add("Name", 40);

            SyncGridUtilities.InitializeGridColumns(gridQualifiers, grdLookUpQualifiers.ChildTableDescriptor, _lrrLookUpQualifiers.ItemType, RelativeWidths, false, null, columnForChildTable, true);
            grdLookUpQualifiers.ChildTableDescriptor.Columns[grdLookUpQualifiers.ChildTableDescriptor.Columns.IndexOf("QualifierID_Name")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
            grdLookUpQualifiers.ChildTableDescriptor.Columns[grdLookUpQualifiers.ChildTableDescriptor.Columns.IndexOf("QualifierID_Name")].Appearance.AnyRecordFieldCell.ReadOnly = true;
            gridQualifiers.ResumeLayout(false);

            //Events for check/uncheck all items
            gridQualifiers.TableControlQueryAllowSortColumn += new GridQueryAllowSortColumnEventHandler(gridGroupedProperties_TableControlQueryAllowSortColumn);
            gridQualifiers.TableControl.MouseUp += new MouseEventHandler(TableControl_MouseUp1);
            gridQualifiers.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridQualifiers_QueryCellStyleInfo);
            gridQualifiers.SaveCellText += new GridCellTextEventHandler(gridQualifiers_SaveCellText);

        }

        /// <summary>
        /// Binds the grid grouped properties.
        /// </summary>
        private void BindGridGroupedProperties()
        {
            Hashtable RelativeWidths = new Hashtable();
            Hashtable columnForDisplay = new Hashtable();
            //Suspend the Layout of the Grid...
            gridGroupedProperties.SuspendLayout();

            SyncGridUtilities.InitializeGridLookAndFeel(gridGroupedProperties);

            columnForDisplay.Add("IsSelected", null);
            columnForDisplay.Add("PropertyType", null);

            _objPropertyTypes = _objPropertyTypes.FilterPropertyTypesByDataArray(false);

            //Populate the columns for the grid object
            SyncGridUtilities.InitializeGridColumns(gridGroupedProperties, _objPropertyTypes.ItemType, null, true, columnForDisplay);

            RelativeWidths.Add("IsSelected", 16);
            RelativeWidths.Add("PropertyType", 80);

            //Populate the columns for the grid object
            SyncGridUtilities.InitializeGridColumnsWidth(gridGroupedProperties, RelativeWidths);
            //Set the data store 
            gridGroupedProperties.DataSource = _objPropertyTypes;

            gridGroupedProperties.TableDescriptor.AllowNew = false;
            gridGroupedProperties.TableDescriptor.AllowRemove = false;
            gridGroupedProperties.TableDescriptor.AllowEdit = true;

            foreach (GridColumnDescriptor objCol in gridGroupedProperties.TableDescriptor.Columns)
            {
                if (objCol.MappingName != "IsSelected")
                    objCol.ReadOnly = true;
            }
            //gridGroupedProperties.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_GRP_PROPERTIES")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS") + " For Qualifier - " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(_sSelectedQualifierID).Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);

            //Resume the Layout of the Grid...
            gridGroupedProperties.ResumeLayout(false);


            //Add the parent table for the Relations...
            gridGroupedProperties.Engine.SourceListSet.Add("ParentTable", _objPropertyTypes);

            //Events for check/uncheck all items
            gridGroupedProperties.TableControlQueryAllowSortColumn += new GridQueryAllowSortColumnEventHandler(gridGroupedProperties_TableControlQueryAllowSortColumn);
            gridGroupedProperties.TableControl.MouseUp += new MouseEventHandler(TableControl_MouseUp);
            gridGroupedProperties.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupedProperties_QueryCellStyleInfo);
            gridGroupedProperties.SaveCellText += new GridCellTextEventHandler(gridGroupedProperties_SaveCellText);
        }
        /// <summary>
        /// Binds the grid plant items.
        /// </summary>
        private void BindGridPlantItems()
        {
            Hashtable RelativeWidths = new Hashtable();
            Hashtable columnForDisplay = new Hashtable();
            //Suspend the Layout of the Grid...
            gridPlantItems.SuspendLayout();

            SyncGridUtilities.InitializeGridLookAndFeel(gridPlantItems);
            columnForDisplay.Add("IsSelected", null);
            columnForDisplay.Add("Name", null);
            columnForDisplay.Add("MasterComponentType", null);

            int i = gridPlantItems.TableDescriptor.SortedColumns.Add("Name");

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
            Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_objSiteComponents.ItemType, out fkColumns, out childColumns);
            Hashtable fkData = new Hashtable();
            foreach (object obj in fkColumns.Keys)
            {
                string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
                object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
                _lrrApp.DBManagerObj.PopulateCollection(collectionObject, false);
                fkData.Add(propName, collectionObject);
            }

            //Populate the columns for the grid object
            SyncGridUtilities.InitializeGridColumns(gridPlantItems, _objSiteComponents.ItemType, null, true, columnForDisplay, fkData);


            RelativeWidths.Add("IsSelected", 5);
            RelativeWidths.Add("Name", 30);
            RelativeWidths.Add("MasterComponentType_ComponentName", 60);

            SyncGridUtilities.InitializeGridColumnsWidth(gridPlantItems, RelativeWidths);

            gridPlantItems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");
            gridPlantItems.TableDescriptor.AllowEdit = true;
            gridPlantItems.TableDescriptor.AllowNew = false;
            gridPlantItems.TableDescriptor.AllowRemove = false;
            gridPlantItems.TopLevelGroupOptions.ShowFilterBar = true;
            gridPlantItems.TableDescriptor.Appearance.AnyCell.ShowButtons = GridShowButtons.Hide;

            foreach (GridColumnDescriptor objCol in gridPlantItems.TableDescriptor.Columns)
            {
                if (objCol.MappingName != "IsSelected")
                    objCol.ReadOnly = true;
            }


            //Set the data store 
            gridPlantItems.DataSource = _objSiteComponents;


            //Resume the Layout of the Grid...
            gridPlantItems.ResumeLayout(false);


            //Add the parent table for the Relations...
            gridPlantItems.Engine.SourceListSet.Add("ParentTable", _objSiteComponents);

            //Events for check/uncheck all items
            gridPlantItems.TableControlQueryAllowSortColumn += new GridQueryAllowSortColumnEventHandler(gridGroupedProperties_TableControlQueryAllowSortColumn);
            gridPlantItems.TableControl.MouseUp += new MouseEventHandler(TableControl_MouseUp);
            gridPlantItems.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridPlantItems_QueryCellStyleInfo);
            gridPlantItems.SaveCellText += new GridCellTextEventHandler(gridPlantItems_SaveCellText);

        }

        #endregion

        # region events
      
        /// <summary>
        /// Handles the CheckedChanged event of the rdGroupByItems control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void rdGroupByItems_CheckedChanged(object sender, System.EventArgs e)
        {
            if (rdGroupByItems.Checked)
            {
                rdQuality.Checked = false;
                _lrrApp.MainFrame.barItemComponentList.Text = LRRHeaderText.GetHeaderString("SID_QUALIFIER_LIST");
                //string str = LRRHeaderText.GetHeaderString("SID_QUALIFIER_LIST");
            }
            else
                rdQuality.Checked = true;
        }

        /// <summary>
        /// Handles the CheckedChanged event of the rdQuality control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void rdQuality_CheckedChanged(object sender, System.EventArgs e)
        {
            if (rdQuality.Checked)
            {
                rdGroupByItems.Checked = false;
                _lrrApp.MainFrame.barItemComponentList.Text = LRRHeaderText.GetHeaderString("SID_COMP_LIST");
            }
            else
                rdGroupByItems.Checked = true;
        }

        /// <summary>
        /// Handles the Click event of the btnExecute control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void btnExecute_Click(object sender, System.EventArgs e)
        {
            try
            {
                int nModesCol = 0;
                transposeFlag = false;
                LRRSiteComponents objSiteCompCollection = new LRRSiteComponents();
                LRRSiteComponents objModelComponent = LRRModel.SiteComponentsObj;
                LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();

                foreach (LRRMode lrrMode in LRRModel.ProjectModes)//_objModes)
                {
                    if (lrrMode.ViewSelection)
                        nModesCol++;
                }

                if (nModesCol == 0)
                {
                    LRRMessagBox.ShowMessage("SID_MODENOTSPECIFIED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                foreach (LRRSiteComponent objSiteComp in _objSiteComponents)
                {
                    if (objSiteComp.IsSelected)
                    {
                        LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComp.SiteComponentID);
                        objSiteCompCollection.Add(objModelSiteComponent);
                    }
                }
                if (objSiteCompCollection.Count == 0)
                {
                    LRRMessagBox.ShowMessage("SID_PLANTITEMNOTSPECIFIED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;

                }

                foreach (LRRLookUpQualifier objLkupQual in _lrrLookUpQualifiers)
                {
                    if (objLkupQual.IsSelected)
                    {
                        objLookUpQualifiers.Add(objLkupQual);
                    }
                }

                if (objLookUpQualifiers.Count == 0)
                {
                    LRRMessagBox.ShowMessage("SID_QUALIFIERNOTSPECIFIED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    _objSiteComponents.RefreshCollection();
                    return;
                }

                this.pnlGridContainer.Controls.Clear();

                //Clear All Bindings
                if (gridView != null)
                {
                    gridView.ClearAllBindings();
                    gridView.UnSubscribeReconnectCompleted();
                }

                if (rdGroupByItems.Checked)
                {
                    gridView = new GridPlantViewController();
                    if (objSiteCompCollection.Count > 5)
                    {
                        LRRMessagBox.ShowMessage("SID_NERROW_DOWN_SEARCH", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                }
                else
                {
                    gridView = new GridQualifierViewController();
                    if (objLookUpQualifiers.Count > 5)
                    {
                        LRRMessagBox.ShowMessage("SID_NERROW_DOWN_SEARCH", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                }
                LRRWaitWindowUtility.ShowPogressIndicator(LRRHeaderText.GetHeaderString(""));

                ArrayList custCollection = new ArrayList();
                custCollection.Add(objSiteCompCollection);
                custCollection.Add(objLookUpQualifiers);

                LRRSearchCriteriaItemGroupPropertiesUIUOMs srchCriteriaUIUOMs = null;
                LRRSearchCriteria searchCriteriaObj = this.cmbQueryList.SelectedItem as LRRSearchCriteria;
                if (searchCriteriaObj != null)
                {
                    if (!searchCriteriaObj.ID.Equals("0"))
                    {
                        srchCriteriaUIUOMs = new LRRSearchCriteriaItemGroupPropertiesUIUOMs();
                        this._lrrApp.DBManagerObj.PopulateCollection(srchCriteriaUIUOMs, " where SearchCriteriaID = '" + searchCriteriaObj.ID + "'");
                    }
                }
                else
                {
                    srchCriteriaUIUOMs = null;
                }
                gridView.LoadPanel(custCollection, srchCriteriaUIUOMs);

                if (gridView.GetType() == typeof(GridPlantViewController) || gridView.GetType() == typeof(GridPlantTransposedViewController))
                {
                    ////Show the Properties Form
                    LRRResultProperties resultProperties = SearchRetrievalUtility.ShowPlantPropertiesWIndow(objLookUpQualifiers, objSiteCompCollection);
                    _rsProperties.PropertyCollection = resultProperties;
                    _rsProperties.Text = "Result Properties Window";
                    _rsProperties.BindGrid();
                    _rsProperties.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsProperties_SelectedProperties);
                    _rsProperties.Owner = this;

                    // Show the Component List Form
                    LRRResultProperties resultQualifiers = SearchRetrievalUtility.ShowQualifiers(objLookUpQualifiers,objSiteCompCollection);
                    _rsComponents.PropertyCollection = resultQualifiers;
                    _rsComponents.Text = "Result Qualifier Window";
                    _rsComponents.BindGrid();
                    _rsComponents.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsComponents_SelectedProperties);
                    _rsComponents.Owner = this;
                }
                else
                {
                    //Show the Properties Form
                    LRRResultProperties resultProperties = SearchRetrievalUtility.ShowGroupedPropertiesWindow(objSiteCompCollection,objLookUpQualifiers, gridView.GetType());
                    _rsProperties.PropertyCollection = resultProperties;
                    _rsProperties.Text = "Result Properties Window";
                    _rsProperties.BindGrid();
                    _rsProperties.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsProperties_SelectedProperties);
                    _rsProperties.Owner = this;


                    // Show the Component List Form
                    LRRResultProperties resultComponents = SearchRetrievalUtility.ShowComponents(objSiteCompCollection, null);
                    _rsComponents.PropertyCollection = resultComponents;
                    _rsComponents.Text = "Result Components Window";
                    _rsComponents.BindGrid();
                    _rsComponents.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsComponents_SelectedProperties);
                    _rsComponents.Owner = this;
                }
                //Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
                //_lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter, true);

                gridView.HideProperties(_rsProperties.UnSelectedRecords);
                gridView.HideComponents(_rsComponents.UnSelectedRecords);

                ArrayList pnlCollection = gridView.GetPanelCollection();
                if (pnlCollection.Count == 0)
                {
                    LRRMessagBox.ShowMessage(this, "SID_VERIFY_QUALIFIERS", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
                else
                {
                    SetPanel(pnlCollection);
                    gridView.HideModes();
                    if (this.dockingManager1 != null)
                    {
                        this.dockingManager1.HideAutoHiddenControl();
                        pnlGroupedPropertiesOutput.DockPadding.Left = this.dockingManager1.DockTabHeight;
                    }
                    _objSiteComponents.RefreshCollection();
                    objSiteCompCollection.RefreshCollection();
                    Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
                    _lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter, true);
                }
                IsChanged = true;
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(GroupedPlantPropertiesView), "ExecuteClick: " + ex, Logger.Level.Debug);
            }
            finally
            {
                LRRWaitWindowUtility.EndProgressIndicator();
            }
        }

        void _rsProperties_SelectedProperties(ArrayList arrayUnSelectedRecords)
        {
            gridView.HideProperties(arrayUnSelectedRecords);
        }

        void _rsComponents_SelectedProperties(ArrayList arrayUnSelectedRecords)
        {
            gridView.HideComponents(arrayUnSelectedRecords);
        }

        /// <summary>
        /// Handles the Load event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void GroupedPlantPropertiesView_Load(object sender, System.EventArgs e)
        {
            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriterias, " WHERE (Source = 'GP' OR  Source is null) ", false, true);
            _SearchCriterias = _SearchCriterias.FilterForUserByUserID();

            _lrrApp.DBManagerObj.PopulateCollection(_SearchModes, " WHERE (Source = 'GP' OR  Source is null) ", false, true);

            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItems, " WHERE (Source = 'GP' OR  Source is null) ", false, true);

            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaPropertyTypes, "", false, true);

            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaQualifiers, "", false, true);

            cmbQueryList.DataSource = _lrrSearchCriterias;
            cmbQueryList.DisplayMember = "Name";
            cmbQueryList.ValueMember = "ID";

            LRRSearchCriteria srchCriteria = _lrrSearchCriterias.GetSearchCriteriaByID("0");
            if (srchCriteria != null)
                cmbQueryList.SelectedItem = srchCriteria;

            Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
            _lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter, false);

        }
        #endregion 
        /// <summary>
        /// Sets the height of the panel.
        /// </summary>
        private void SetPanelHeight()
        {
            int iNumPanels = pnlGridContainer.Controls.Count / 2;
            if (iNumPanels != 0)
            {
                //int pnlHeight = this.pnlGroupedPropMain.Height - (SystemInformation.HorizontalScrollBarHeight);
                int pnlHeight = this.pnlGroupedPropertiesOutput.Height - (SystemInformation.HorizontalScrollBarHeight);
                int gridPnlHeight = (pnlHeight) / iNumPanels;
                foreach (Control ctl in pnlGridContainer.Controls)
                {
                    if (ctl.GetType() == typeof(Panel))
                    {
                        ctl.Height = gridPnlHeight;
                    }
                }
            }
        }

        /// <summary>
        /// Sets the panel.
        /// </summary>
        /// <param name="pnlCollection">The PNL collection.</param>
        private void SetPanel(ArrayList pnlCollection)
        {
            int heightOfEach = pnlGridContainer.Height / pnlCollection.Count;
            int splitCnt = 0;
            for (int i = pnlCollection.Count - 1; i >= 0; i--)
            {
                Panel panel = pnlCollection[i] as Panel;
                panel.Height = heightOfEach;
                this.pnlGridContainer.Controls.Add(panel);
                if (splitCnt < pnlCollection.Count - 1)
                {
                    Splitter splitGrid = new Splitter();
                    splitGrid.Dock = DockStyle.Top;
                    this.pnlGridContainer.Controls.Add(splitGrid);
                    splitCnt++;
                }
            }
            if (this.pnlGridContainer.Controls.Count > 0)
                this.pnlGridContainer.Controls[0].Dock = DockStyle.Fill;
        }

        /// <summary>
        /// Binds the site components on check changed.
        /// </summary>
        private void bindSiteComponentsOnCheckChanged()
        {
            //IsChanged = true;
            _lrrSiteCompsList = new LRRSiteComponents();

            foreach (LRRPropertyType objPropertyType in _objPropertyTypes)
            {
                if (objPropertyType.IsSelected)
                {
                    _lrrSiteComps2 = new LRRSiteComponents();
                    _lrrSiteComps2 = LRRModel.SiteComponentsObj;

                    _objSelectedComponents = _lrrSiteComps2.FilterSiteComponentsByPropertyType(objPropertyType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture));

                    foreach (LRRSiteComponent objComp in _objSelectedComponents)
                    {
                        LRRSiteComponent objCompCloned = objComp.Clone() as LRRSiteComponent;
                        bool blnCompExists = false;
                        foreach (LRRSiteComponent objCompToAdd in _lrrSiteCompsList)
                        {
                            if (objCompToAdd.SiteComponentID.Equals(objCompCloned.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture)))
                                blnCompExists = true;

                        }
                        if (!blnCompExists)
                            _lrrSiteCompsList.Add(objCompCloned);
                    }
                }
                else
                {
                    //Unselect Lookup Qualifiers & corresponding Site Components.
                    _lrrSiteComps2 = new LRRSiteComponents();
                    _lrrSiteComps2 = LRRModel.SiteComponentsObj;

                    _objSelectedComponents = _lrrSiteComps2.FilterSiteComponentsByPropertyType(objPropertyType.ID);

                    foreach (LRRSiteComponent objComp in _objSelectedComponents)
                    {
                        objComp.IsSelected = false;
                    }
                }
            }


            _objSiteComponents = _lrrSiteCompsList;

            gridPlantItems.CurrencyManager.List.Clear();
            foreach (LRRSiteComponent lsc in _objSiteComponents)
            {
                gridPlantItems.CurrencyManager.List.Add(lsc);
            }

            gridPlantItems.TableDescriptor.Columns["Name"].ReadOnly = true;
            gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].ReadOnly = true;
            gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
            gridPlantItems.TableDescriptor.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
        }
        /// <summary>
        /// Handles the RecordValueChanged event of the gridGroupedProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Grouping.RecordValueChangedEventArgs"/> instance containing the event data.</param>
        private void gridGroupedProperties_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
        {
            //IsChanged = true;
            CheckUncheckGroupProps();
        }

        /// <summary>
        /// Checks the uncheck group props.
        /// </summary>
        private void CheckUncheckGroupProps()
        {
            //IsChanged = true;
            ReBindQualifierGrid();

            //			if(!rdGroupByItems.Checked)
            //			{
            bindSiteComponentsOnCheckChanged();
            //			}
        }

        /// <summary>
        /// Res the bind qualifier grid.
        /// </summary>
        private void ReBindQualifierGrid()
        {
            //IsChanged = true;
            _lrrPropertyTypes.Clear();
            _lrrLookUpQualifiers.Clear();


            ArrayList arrPropertyType = new ArrayList();
            ArrayList arrLookupQualifierObjs = new ArrayList();

            foreach (LRRPropertyType lrrPropType in _objPropertyTypes)
            {
                if (lrrPropType.IsSelected)
                {
                    string sPropType = lrrPropType.ID == null ? "" : lrrPropType.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    LRRLookUpQualifiers lrrLookUpQualifiers = _objLookupQualifiers.getLookUpQualifiersForPropType(sPropType);
                    foreach (LRRLookUpQualifier lrrLookUpQualifier in lrrLookUpQualifiers)
                    {
                        if (!arrLookupQualifierObjs.Contains(lrrLookUpQualifier.LookUpQualifierID))
                        {
                            arrLookupQualifierObjs.Add(lrrLookUpQualifier.LookUpQualifierID);
                            lrrLookUpQualifier.IsSelected = false;
                            _lrrLookUpQualifiers.Add(lrrLookUpQualifier);
                        }
                    }

                    if (!arrPropertyType.Contains(lrrPropType.ID))
                    {
                        arrPropertyType.Add(lrrPropType.ID);
                        _lrrPropertyTypes.Add(lrrPropType);
                    }
                }
            }
        }


        #region Private Fields
        private LRRApp _lrrApp; //All object to access the DB Manager and DB Adapter
        private LRRPropertyTypes _objPropertyTypes = null;
        private LRRSiteComponents _objSiteComponents = null;
        private LRRSiteComponents _objSelectedComponents = null;
        //		private	LRRModes				_objModes		  = null;
        private LRRModes _objSelectedModes = null;
        private LRRQualifiers _objQualifiers = null;
        private LRRLookUpQualifiers _objLookupQualifiers = null;
        private Hashtable _AllQualifiers = new Hashtable(); //Hash table which has all the Qualifiers with ID = QualifierID & Obj = LRRQualifier.
        private Hashtable _AllComponents = new Hashtable(); //Hash table which has all the site components with ID = sitecomponentid & Obj = LRRSiteComponent.
        public IGroupGridFactory gridView;
        private LRRSiteComponents _lrrSiteComps2 = null;
        private LRRSiteComponents _lrrSiteCompsList = new LRRSiteComponents();
        ArrayList gridCollection = new ArrayList();
        ArrayList gridInstanceCollection = new ArrayList();
        private LRRSearchCriterias _lrrSearchCriterias;
        private LRRSearchCriterias _SearchCriterias = new LRRSearchCriterias();
        private LRRSearchCriteriaModes _SearchModes = new LRRSearchCriteriaModes();
        private LRRSearchCriteriaItems _SearchCriteriaItems = new LRRSearchCriteriaItems();
        private LRRSearchCriteriaQualifiers _SearchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();
        private LRRSearchCriteriaPropertyTypes _SearchCriteriaPropertyTypes = new LRRSearchCriteriaPropertyTypes();
        private LRRPropertyTypes _lrrPropTypes = null;
        bool bFlag = true;
        ArrayList arrPptytype = new ArrayList();
        private LRRPropertyTypes _lrrPropertyTypes = new LRRPropertyTypes();
        private LRRLookUpQualifiers _lrrLookUpQualifiers = new LRRLookUpQualifiers();
        private ResultComponentsWindowGroupProp _resultComptsWindowGrpProp = new ResultComponentsWindowGroupProp();
        private LRRSiteComponentProperties _lrrSiteCompoProps = new LRRSiteComponentProperties();


        //Results Filter Windows
        private ResultPropertiesWindow _rsProperties = new ResultPropertiesWindow();
        private ResultPropertiesWindow _rsComponents = new ResultPropertiesWindow();

        #endregion

        /// <summary>
        /// Handles the SelectedIndexChanged event of the cmbQueryList control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void cmbQueryList_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (!bFlag)
            {
                bFlag = true;
                return;
            }
            LRRSearchCriteria searchCriteriaObj = cmbQueryList.SelectedItem as LRRSearchCriteria;
            if (searchCriteriaObj == null)
                return;
            //_gutil.SetBytesToSizeXml(searchCriteria.SizeXml);

            //			_objModes.RefreshCollection();
            _objSiteComponents.RefreshCollection();
            _objPropertyTypes.RefreshCollection();
            _objQualifiers.RefreshCollection();

            if (!searchCriteriaObj.ID.Equals("0"))
            {
                _SearchModes.ItemFilter = "SearchCriteriaID = '" + searchCriteriaObj.ID + "'";
                _SearchCriteriaItems.ItemFilter = "SearchCriteriaID = '" + searchCriteriaObj.ID + "'";
                _SearchCriteriaPropertyTypes.ItemFilter = "SearchCriteriaID = '" + searchCriteriaObj.ID + "'";
                _SearchCriteriaQualifiers.ItemFilter = "SearchCriteriaID = '" + searchCriteriaObj.ID + "'";

                //Plant Items
                foreach (LRRSearchCriteriaItem searchCriteriaItem in _SearchCriteriaItems)
                {
                    foreach (LRRSiteComponent siteComponentObj in _objSiteComponents)
                    {
                        if (searchCriteriaItem.ItemID.Equals(siteComponentObj.SiteComponentID))
                        {
                            siteComponentObj.IsSelected = true;
                        }
                    }
                }
                //Property Type
                foreach (LRRSearchCriteriaPropertyType searchCriteriaPropType in _SearchCriteriaPropertyTypes)
                {
                    foreach (LRRPropertyType propTypeObj in _objPropertyTypes)
                    {
                        if (searchCriteriaPropType.PropertyType.Equals(propTypeObj.ID))
                        {
                            propTypeObj.IsSelected = true;
                        }
                    }
                }

                ReBindQualifierGrid();

                foreach (LRRLookUpQualifier QualifierObj in _lrrLookUpQualifiers)
                {
                    QualifierObj.IsSelected = false;
                }
                //Qualifiers
                foreach (LRRSearchCriteriaQualifier searchCriteriaQualifier in _SearchCriteriaQualifiers)
                {
                    foreach (LRRLookUpQualifier QualifierObj in _lrrLookUpQualifiers)
                    {
                        if (searchCriteriaQualifier.QualifierID.Equals(QualifierObj.LookUpQualifierID))//.QualifierID))
                        {
                            QualifierObj.IsSelected = true;
                            break;
                        }
                    }
                }
                IsChanged = false;

            }
            else
            {
                foreach (LRRPropertyType propTypeObj in _objPropertyTypes)
                {
                    propTypeObj.IsSelected = false;
                }
                foreach (LRRSiteComponent siteComponentObj in _objSiteComponents)
                {
                    siteComponentObj.IsSelected = false;
                }
                ReBindQualifierGrid();
            }
            gridGroupedProperties.Refresh();
            gridPlantItems.Refresh();
            gridQualifiers.Refresh();

        }

        /// <summary>
        /// Prepares the query.
        /// </summary>
        /// <param name="searchQueryID">The search query ID.</param>
        public void PrepareQuery(string searchQueryID)
        {
            GroupSearchCriteria query = new GroupSearchCriteria();
            LRRSearchCriteria searchCriteria = new LRRSearchCriteria();
            if (searchQueryID != null)
                searchCriteria.ID = searchQueryID;
            searchCriteria.Source = "GP";

            string template = "";
            if (rdGroupByItems.Checked)
            {
                template = "Symcon.LightRidge.PEAdvisor.GroupProperties.GridPlantViewController";
            }
            else
            {
                template = "Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierViewController";
            }
            searchCriteria.TemplateClass = template;

            LRRSearchCriteriaPropertyTypes searchCriteriaPropTypesObj = new LRRSearchCriteriaPropertyTypes();
            foreach (LRRPropertyType propTypeObj in _objPropertyTypes)
            {
                BaseObject bo = propTypeObj as BaseObject;
                if (bo.IsSelected)
                {
                    LRRSearchCriteriaPropertyType searchCriteriaPropType = new LRRSearchCriteriaPropertyType();
                    searchCriteriaPropType.SearchCriteriaID = searchCriteria.ID;
                    searchCriteriaPropType.PropertyType = propTypeObj.ID;
                    searchCriteriaPropTypesObj.Add(searchCriteriaPropType);
                }
            }


            LRRSearchCriteriaItems searchCriteriaItems = new LRRSearchCriteriaItems();
            foreach (LRRSiteComponent siteComponentObj in _objSiteComponents)
            {
                BaseObject bo = siteComponentObj as BaseObject;
                if (bo.IsSelected)
                {
                    LRRSearchCriteriaItem searchCriteriaItem = new LRRSearchCriteriaItem();
                    searchCriteriaItem.SearchCriteriaID = searchCriteria.ID;
                    searchCriteriaItem.ItemID = siteComponentObj.SiteComponentID;
                    searchCriteriaItem.Source = "GP";
                    searchCriteriaItems.Add(searchCriteriaItem);
                }
            }

            ArrayList arrLookupQualifierObjs = new ArrayList();
            LRRSearchCriteriaQualifiers searchCriteriaQualifiersObj = new LRRSearchCriteriaQualifiers();
            foreach (LRRLookUpQualifier objLkupQual in _lrrLookUpQualifiers)
            {
                if (objLkupQual.IsSelected)
                {
                    LRRSearchCriteriaQualifier searchCriteriaQualifier = new LRRSearchCriteriaQualifier();
                    searchCriteriaQualifier.SearchCriteriaID = searchCriteria.ID;
                    searchCriteriaQualifier.QualifierID = objLkupQual.LookUpQualifierID;
                    searchCriteriaQualifiersObj.Add(searchCriteriaQualifier);
                }
            }

            //Assign to searchcriteria object
            query.SearchQuery = searchCriteria;
            query.SearchCriteriaItems = searchCriteriaItems;
            query.SearchCriteriaPropTypes = searchCriteriaPropTypesObj;
            query.SearchCriteriaQualifiers = searchCriteriaQualifiersObj;
            gridView.SearchQuery = query;
        }

        /// <summary>
        /// Saves the query.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="desc">The desc.</param>
        /// <param name="groupLevel">The group level.</param>
        /// <param name="isPublished">if set to <c>true</c> [is published].</param>
        public void SaveQuery(string name, string desc, LRRSearchGroupLevel groupLevel, bool isPublished)
        {
            //			_gutil._gridCollection = gridView.GetGridInstanceCollection();
            //			_gutil.SaveGridSettings(transposeFlag, chkGroupMode.Checked);
            //			searchCriteria.SizeXml = _gutil.GetSizeXmlBytes();
            string searchQueryID = null;
            string userSettingsID = null;
            string userID = this._lrrApp.DBManagerObj.AccessControlModel.UserID;
            IEnumerator iEnum = LRRModel.ChildModel.SearchCriterias.GetEnumerator();//_SearchCriterias.GetEnumerator();
            while (iEnum.MoveNext())
            {
                LRRSearchCriteria srch = iEnum.Current as LRRSearchCriteria;
                if (srch.Name == name)
                {
                    DialogResult dlgResult = LRRMessagBox.ShowMessage("SID_QUERYNAME_DUPLICATE", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (dlgResult == DialogResult.No)
                    {
                        return;
                    }

                    searchQueryID = srch.ID;
                    userSettingsID = srch.UserSettingsID;

                    srch.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                    _lrrApp.DBManagerObj.CommitObject(srch);
                    //					_SearchCriterias.Remove(srch);

                    //Remove from Model
                    LRRSearchCriteria srchCriteria = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(srch.ID);
                    if (srchCriteria != null)
                    {
                        userID = srchCriteria.UserID;
                        srchCriteria.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                        LRRModel.ChildModel.SearchCriterias.Remove(srchCriteria);

                        //Remove from Levels and Level Link tables
                        LRRSearchGroupLevel lrrSrchGroupLevel = new LRRSearchGroupLevel();
                        lrrSrchGroupLevel.LevelID = srchCriteria.ID;
                        lrrSrchGroupLevel.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                        _lrrApp.DBManagerObj.CommitObject(lrrSrchGroupLevel);

                        LRRSearchGroupLevelLink lrrSrchGroupLevelLink = new LRRSearchGroupLevelLink();
                        _lrrApp.DBManagerObj.PopulateObject(lrrSrchGroupLevelLink, typeof(LRRSearchGroupLevelLink), " where ChildID = '" + srchCriteria.ID + "'");

                        //Delete the Object
                        lrrSrchGroupLevelLink.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                        _lrrApp.DBManagerObj.CommitObject(lrrSrchGroupLevelLink);
                    }

                    break;
                }
            }

            if (gridView != null)
            {
                PrepareQuery(searchQueryID);
                if (userID == null || userID.Trim() == "")
                    userID = this._lrrApp.DBManagerObj.AccessControlModel.UserID;
                gridView.SearchQuery.UserID = userID;
                gridView.SearchQuery.SearchQuery.UserSettingsID = userSettingsID;
                gridView.Save(name, desc, groupLevel, isPublished);
            }
            else
                return;
            LRRMessagBox.ShowMessage("SID_SAVEDINFO", true);

            bFlag = false;

            if (_SearchModes != null)
                _SearchModes.Clear();
            if (_SearchCriterias != null)
                _SearchCriterias = new LRRSearchCriterias();
            if (_SearchCriteriaPropertyTypes != null)
                _SearchCriteriaPropertyTypes.Clear();
            if (_SearchCriteriaItems != null)
                _SearchCriteriaItems.Clear();
            if (_SearchCriteriaQualifiers != null)
                _SearchCriteriaQualifiers.Clear();

            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriterias, " WHERE (Source = 'GP' OR  Source is null) ", false, true);
            _SearchCriterias = _SearchCriterias.FilterForUserByUserID();
            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaPropertyTypes, null, false, true);
            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItems, " WHERE (Source = 'GP' OR  Source is null) ", false, true);
            _lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaQualifiers, null, false, true);
            _lrrApp.DBManagerObj.PopulateCollection(_SearchModes, " WHERE (Source = 'GP' OR  Source is null) ", false, true);

            _lrrSearchCriterias = _SearchCriterias;
            cmbQueryList.DataSource = _lrrSearchCriterias;

            LRRSearchCriteria srchCriteria1 = _lrrSearchCriterias.GetSearchCriteriaByID(gridView.SearchQuery.SearchQuery.ID);
            if (srchCriteria1 != null)
                cmbQueryList.SelectedItem = srchCriteria1;

            //Update in Model
            LRRSearchCriterias srchCriterias = new LRRSearchCriterias();
            _lrrApp.DBManagerObj.PopulateCollection(srchCriterias, "", false, true);
            LRRModel.ChildModel.SearchCriterias = srchCriterias;


        }

        /// <summary>
        /// Handles the Activated event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void GroupedPlantPropertiesView_Activated(object sender, System.EventArgs e)
        {
            LRRFormulaDataStore.DataSource = lrrFormulaGroupedProperties;
            LRRFormulaDataStore.ModeFlag = true;
            LRRFormulaDataStore.ShowGroupedAttributes = true;
            LRRFormulaDataStore.SourceLookupPropertyID = null;
            LRRFormulaDataStore.SourceLookupQualifierID = null;

            if (_rsProperties != null && _rsProperties.IsWindowOpen)
                _rsProperties.Show();
            if (_rsComponents != null && _rsComponents.IsWindowOpen)
                _rsComponents.Show();
        }


        /// <summary>
        /// Handles the Deactivate event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        void GroupedPlantPropertiesView_Deactivate(object sender, EventArgs e)
        {
            if (_rsProperties != null)
                _rsProperties.Hide();
            if (_rsComponents != null)
                _rsComponents.Hide();

            _lrrApp.MainFrame.barItemComponentList.Text = LRRHeaderText.GetHeaderString("SID_COMP_LIST");
        }
        /// <summary>
        /// Handles the RecordValueChanged event of the gridOutputModes control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Grouping.RecordValueChangedEventArgs"/> instance containing the event data.</param>
        private void gridOutputModes_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
        {

        }

        /// <summary>
        /// Handles the ModesChanged event of the ProjectModes control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void ProjectModes_ModesChanged(object sender, EventArgs e)
        {
            if (gridView != null)
                gridView.HideModes();
        }

        /// <summary>
        /// Handles the Closing event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.ComponentModel.CancelEventArgs"/> instance containing the event data.</param>
        private void GroupedPlantPropertiesView_Closing(object sender, CancelEventArgs e)
        {
            Form frm = sender as Form;
            GridCheckForViewChanges.CheckForViewChanges(IsChanged, null, gridView, frm, null, null, false, null, null, null, null,false);
            LRRModel.ProjectModes.ModesChanged -= new EventHandler(ProjectModes_ModesChanged);
            IsChanged = false;
            BPropertyValChanged = false;

            if (gridView != null)
            {
                gridView.ClearAllBindings();
                gridView.UnSubscribeReconnectCompleted();
            }

            //CommonViews.ChangedUIUOMDictionary.Clear(this.GetType());
            
            /*//Clear All Bindings
            if (gridView != null)
            {
                gridView.ClearAllBindings();
                gridView.UnSubscribeReconnectCompleted();
            }
            LRRModel.ProjectModes.ModesChanged -= new EventHandler(ProjectModes_ModesChanged);
            if (_isChanged)
            {
                DialogResult k = LRRMessagBox.ShowMessage("SID_SAVE_QUERY", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (k == DialogResult.Yes)
                {
                    Save();
                }
            }

            // Save For Property Values
            LRRSiteGroupPropertyQualifierValues propertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetChanges();

            if (propertyQualifierValues.Count > 0)
            {
                DialogResult dlgResult = LRRMessagBox.ShowMessage(this, "SID_SAVE_PROPVALUE", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (dlgResult == DialogResult.Yes)
                {
                    SaveOutput();
                }
                else
                {
                    foreach (LRRSiteGroupPropertyQualifierValue propertyQualifierValue in propertyQualifierValues)
                    {
                        LRRSiteComponentProperty objProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propertyQualifierValue.SiteComponentPropID);
                        string groupPropID = LRRModel.SiteComponentGroupPropertiesObj.GetSiteGroupPropID(propertyQualifierValue.SiteComponentPropID, propertyQualifierValue.LookUpPropertiesID);
                        LRRSiteGroupPropertyQualifierValue objPropValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID, propertyQualifierValue.LookUpPropertiesID, propertyQualifierValue.QualifierID, propertyQualifierValue.ModeID);
                        objPropValue.RollBackChanges(true);
                    }
                }
            }*/
        }
        #region ILRRUIContainer Members

        public void ClearSort()
        {
            //Add GroupedPlantPropertiesView.ClearSort implementation
            SyncGridUtilities.ClearSort(gridPlantItems);
            SyncGridUtilities.ClearSort(gridQualifiers);
            SyncGridUtilities.ClearSort(gridGroupedProperties);

            //Clear Sort
            if (gridView != null)
            {
                gridView.ClearSort();
            }
        }

        public bool SupportsClearSort()
        {
            // Add GroupedPlantPropertiesView.SupportsClearSort implementation
            return true;
        }

        #endregion

        #region ILRRUIContainer Members

        public void CopyUOMTypes()
        {

        }

        public bool SupportsCopyUOMTypes()
        {
            return false;
        }

        #endregion

        #region ILRRUIContainer Members

        public void PrintPreview()
        {
            if (gridView != null)
                gridView.PrintPreview();
        }

        #endregion

        #region ILRRUIContainer Members

        public void ShowPropertyList()
        {
            //Add GroupedPlantPropertiesView.ShowPropertyList implementation
            if (_rsProperties != null)
            {
                _rsProperties.IsWindowOpen = true;
                _rsProperties.Show();
            }
        }

        public bool SupportsResultsFilter()
        {
            return true;
        }

        #endregion

        #region ILRRUIContainer Members

        public void ShowComponentList()
        {
            //Add GroupedPlantPropertiesView.ShowComponentList implementation
            if (_rsComponents != null)
            {
                _rsComponents.IsWindowOpen = true;
                _rsComponents.Show();
            }
        }

        #endregion

        /// <summary>
        /// Handles the Closed event of the GroupedPlantPropertiesView control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void GroupedPlantPropertiesView_Closed(object sender, System.EventArgs e)
        {
            _lrrApp.LRRUIManagerObj.PerformDataDirtyCheck = true;

        }

        /// <summary>
        /// Handles the TableControlQueryAllowSortColumn event of the gridGroupedProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs"/> instance containing the event data.</param>
        private void gridGroupedProperties_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
        {
            if (e.Column.Name == "IsSelected")
            {
                e.AllowSort = false;
            }
        }

        /// <summary>
        /// Handles the MouseUp event of the TableControl control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
        private void TableControl_MouseUp(object sender, MouseEventArgs e)
        {
            int row, col;
            GridTableControl gridTableControl = sender as GridTableControl;
            gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
            GridTableCellStyleInfo style = gridTableControl.Model[row, col];

            IMouseController controller;
            gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

            if (controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
            {
                gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
            }
        }

        int row, col;
        bool CheckBoxValue = false;
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridGroupedProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
        private void gridGroupedProperties_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row, out col);
            if (e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col + 1)
            {
                e.Style.CellType = "CheckBox";
                e.Style.ReadOnly = false;
                e.Style.CellAppearance = GridCellAppearance.Raised;
                e.Style.CellValue = CheckBoxValue;
                e.Style.CellValueType = typeof(bool);
                e.Style.Enabled = true;
            }
            e.Handled = true;
        }

        private void gridGroupedProperties_SaveCellText(object sender, GridCellTextEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
            if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
            {
                this.CheckBoxValue = bool.Parse(e.Text);
                IEnumerator iEnum = _objPropertyTypes.GetEnumerator();
                while (iEnum.MoveNext())
                {
                    LRRPropertyType propertyType = iEnum.Current as LRRPropertyType;
                    if (propertyType != null)
                        propertyType.IsSelected = this.CheckBoxValue;
                }
                gridGroupedProperties.Refresh();
                CheckUncheckGroupProps();
                e.Handled = true;
            }

        }

        bool siteCompCheckBoxValue = false;
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridPlantItems control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
        private void gridPlantItems_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row, out col);
            if (e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col + 1)
            {
                e.Style.CellType = "CheckBox";
                e.Style.ReadOnly = false;
                e.Style.CellAppearance = GridCellAppearance.Raised;
                e.Style.CellValue = siteCompCheckBoxValue;
                e.Style.CellValueType = typeof(bool);
                e.Style.Enabled = true;
            }
            e.Handled = true;
        }

        /// <summary>
        /// Handles the SaveCellText event of the gridPlantItems control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
        private void gridPlantItems_SaveCellText(object sender, GridCellTextEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
            if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
            {
                this.siteCompCheckBoxValue = bool.Parse(e.Text);
                IEnumerator iEnum = _objSiteComponents.GetEnumerator();
                while (iEnum.MoveNext())
                {
                    LRRSiteComponent siteComp = iEnum.Current as LRRSiteComponent;
                    if (siteComp != null)
                        siteComp.IsSelected = this.siteCompCheckBoxValue;
                }
                gridPlantItems.Refresh();
                e.Handled = true;
            }
        }

        /// <summary>
        /// Handles the MouseUp1 event of the TableControl control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.MouseEventArgs"/> instance containing the event data.</param>
        private void TableControl_MouseUp1(object sender, MouseEventArgs e)
        {
            int row, col;
            GridTableControl gridTableControl = gridQualifiers.GetTableControl("LookUpQualifiers");
            gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
            GridTableCellStyleInfo style = gridTableControl.Model[row, col];

            IMouseController controller;
            gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

            if (controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
            {
                gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
            }
        }

        Hashtable qualifiersCheckBoxValue = new Hashtable();
        /// <summary>
        /// Handles the QueryCellStyleInfo event of the gridQualifiers control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs"/> instance containing the event data.</param>
        private void gridQualifiers_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row, out col);
            if (e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col + 1)
            {
                e.Style.CellType = "CheckBox";
                e.Style.ReadOnly = false;
                e.Style.CellAppearance = GridCellAppearance.Raised;

                bool qualifierCheckBoxValue = false;
                //Get the cell value
                int iCount = e.TableCellIdentity.Table.Elements.Count - 1;
                LRRLookUpQualifier lkUpQualifier = e.TableCellIdentity.Table.Elements[iCount].GetData() as LRRLookUpQualifier;
                if (lkUpQualifier != null)
                {
                    string propTypeID = lkUpQualifier.PropertyID;
                    if (qualifiersCheckBoxValue.ContainsKey(propTypeID))
                    {
                        qualifierCheckBoxValue = (bool)qualifiersCheckBoxValue[propTypeID];
                    }
                }
                e.Style.CellValue = qualifierCheckBoxValue;
                e.Style.CellValueType = typeof(bool);
                e.Style.Enabled = true;
            }
            e.Handled = true;
        }

        /// <summary>
        /// Handles the SaveCellText event of the gridQualifiers control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs"/> instance containing the event data.</param>
        private void gridQualifiers_SaveCellText(object sender, GridCellTextEventArgs e)
        {
            GridTableCellStyleInfo style = (GridTableCellStyleInfo)e.Style;
            if (style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
            {
                int iCount = style.TableCellIdentity.Table.Elements.Count - 1;
                //Get the PropID
                LRRLookUpQualifier lrrLkUpQualifier = style.TableCellIdentity.Table.Elements[iCount].GetData() as LRRLookUpQualifier;
                string propTypeID = null;
                bool checkBox = bool.Parse(e.Text);
                if (lrrLkUpQualifier != null)
                {
                    propTypeID = lrrLkUpQualifier.PropertyID;
                    if (!qualifiersCheckBoxValue.ContainsKey(propTypeID))
                        qualifiersCheckBoxValue.Add(propTypeID, checkBox);
                    else
                    {
                        qualifiersCheckBoxValue[propTypeID] = checkBox;
                    }
                }
                IEnumerator iEnum = _lrrLookUpQualifiers.GetEnumerator();
                while (iEnum.MoveNext())
                {
                    LRRLookUpQualifier lkUpQualifier = iEnum.Current as LRRLookUpQualifier;
                    if (lkUpQualifier != null && lkUpQualifier.PropertyID == propTypeID)
                        lkUpQualifier.IsSelected = checkBox;
                }
                gridQualifiers.Refresh();
                e.Handled = true;
            }
        }
        #region ILRRUIContainer Members

        public void LeftColMovement()
        {
            if (gridView != null)
                gridView.LeftColMovement();
        }

        public void RightColMovement()
        {
            if (gridView != null)
                gridView.RightColMovement();
        }

        #endregion

        #region ILRRUIContainer Members

        public void PageSetup()
        {
            GridGroupingPrint ggPrint = new GridGroupingPrint();
            ggPrint.PageSetUp();
        }

        public void Undo()
        {
            // TODO:  Add GroupedPlantPropertiesView.Undo implementation
        }

        public bool SupportsPageSetup()
        {
            // TODO:  Add GroupedPlantPropertiesView.SupportsPageSetup implementation
            return true;
        }

        public bool SupportsUndo()
        {
            // TODO:  Add GroupedPlantPropertiesView.SupportsUndo implementation
            return false;
        }

        #endregion

        #region ILRRUIContainer Members

        public void OpenCompositeView()
        {
            // TODO:  Add GroupedPlantPropertiesView.OpenCompositeView implementation
        }

        public void TransposeView()
        {
            // TODO:  Add GroupedPlantPropertiesView.TransposeView implementation
        }

        public void OpenQuery()
        {
            // TODO:  Add GroupedPlantPropertiesView.OpenQuery implementation
        }

        public void OpenView()
        {
            // TODO:  Add GroupedPlantPropertiesView.OpenView implementation
        }

        public bool SupportsCompositeView()
        {
            // TODO:  Add GroupedPlantPropertiesView.SupportsCompositeView implementation
            return false;
        }

        #endregion

        #region ILRRUIContainer Members

        public bool PerformDirtyChk
        {
            get
            {
                // TODO:  Add GroupedPlantPropertiesView.PerformDirtyChk getter implementation
                return true;
            }
        }

        #endregion

        #region ILRRUISpecificContainer Members

        public void ChangeUOMSet()
        {
            if (gridView != null)
            {
                ChangeUOMSetDefinitionForm chngUOMSetDefn = new ChangeUOMSetDefinitionForm();
                DialogResult dlgResult = chngUOMSetDefn.ShowDialog();
                if (dlgResult == DialogResult.OK && chngUOMSetDefn.MeasSysID != null)
                {
                    gridView.ChangeUOMSet(chngUOMSetDefn.MeasSysID);
                }
            }
        }

        public bool SupportsChangeUOMSet()
        {
            return true;
        }

        #endregion

        /// <summary>
        /// Handles the DropDown event of the cmbQueryList control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void cmbQueryList_DropDown(object sender, System.EventArgs e)
        {
            ComboBox senderComboBox = (ComboBox)sender;
            int width = senderComboBox.DropDownWidth;
            Graphics g = senderComboBox.CreateGraphics();
            Font font = senderComboBox.Font;
            int vertScrollBarWidth =
                (senderComboBox.Items.Count > senderComboBox.MaxDropDownItems)
                ? SystemInformation.VerticalScrollBarWidth : 0;

            int newWidth;
            foreach (LRRSearchCriteria searchCriteria in ((ComboBox)sender).Items)
            {
                string s = searchCriteria.Name;
                newWidth = (int)g.MeasureString(s, font).Width
                    + vertScrollBarWidth;
                if (width < newWidth)
                {
                    width = newWidth;
                }
            }
            senderComboBox.DropDownWidth = width;
        }

        bool isOpen = false;
        /// <summary>
        /// Handles the AutoHideAnimationStart event of the dockingManager1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="arg">The <see cref="Syncfusion.Windows.Forms.Tools.AutoHideAnimationEventArgs"/> instance containing the event data.</param>
        private void dockingManager1_AutoHideAnimationStart(object sender, Syncfusion.Windows.Forms.Tools.AutoHideAnimationEventArgs arg)
        {
            if (!isOpen)
            {
                InternationalizationUtils.GetControlText(this, this.components.Components);
            }

        }
        private bool transposeFlag = false;
        private GroupPropertiesSchemes _gutil = new GroupPropertiesSchemes();
        /// <summary>
        /// Handles the Click event of the button1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void button1_Click(object sender, EventArgs e)
        {
            if (!transposeFlag)
                transposeFlag = true;
            else
                transposeFlag = false;

            //Clear All Bindings			
            if (gridView != null)
            {
                gridView.ClearAllBindings();
                gridView.UnSubscribeReconnectCompleted();
            }
            if (transposeFlag && rdGroupByItems.Checked)
            {
                gridView = new Symcon.LightRidge.PEAdvisor.GroupProperties.GridPlantTransposedViewController();
            }
            else if (!transposeFlag && rdGroupByItems.Checked)
            {
                gridView = new Symcon.LightRidge.PEAdvisor.GroupProperties.GridPlantViewController();
            }

            if (!transposeFlag && !rdGroupByItems.Checked)
            {
                gridView = new Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierViewController();
            }
            else if (transposeFlag && !rdGroupByItems.Checked)
            {
                gridView = new Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierTransposedViewController();
            }

            this.SuspendLayout();

            LRRSiteComponents objSiteCompCollection = new LRRSiteComponents();
            LRRSiteComponents objModelComponent = LRRModel.SiteComponentsObj;
            LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();

            foreach (LRRSiteComponent objSiteComp in _objSiteComponents)
            {
                if (objSiteComp.IsSelected)
                {
                    LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComp.SiteComponentID);
                    objSiteCompCollection.Add(objModelSiteComponent);
                }
            }
            if (objSiteCompCollection.Count == 0)
            {
                LRRMessagBox.ShowMessage("SID_PLANTITEMNOTSPECIFIED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;

            }

            foreach (LRRLookUpQualifier objLkupQual in _lrrLookUpQualifiers)
            {
                if (objLkupQual.IsSelected)
                {
                    objLookUpQualifiers.Add(objLkupQual);
                }
            }

            if (objLookUpQualifiers.Count == 0)
            {
                LRRMessagBox.ShowMessage("SID_QUALIFIERNOTSPECIFIED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                _objSiteComponents.RefreshCollection();
                return;
            }

            ArrayList custCollection = new ArrayList();
            custCollection.Add(objSiteCompCollection);
            custCollection.Add(objLookUpQualifiers);

            LRRSearchCriteriaItemGroupPropertiesUIUOMs srchCriteriaUIUOMs = null;
            LRRSearchCriteria searchCriteriaObj = this.cmbQueryList.SelectedItem as LRRSearchCriteria;
            if (searchCriteriaObj != null)
            {
                if (!searchCriteriaObj.ID.Equals("0"))
                {
                    srchCriteriaUIUOMs = new LRRSearchCriteriaItemGroupPropertiesUIUOMs();
                    this._lrrApp.DBManagerObj.PopulateCollection(srchCriteriaUIUOMs, " where SearchCriteriaID = '" + searchCriteriaObj.ID + "'");
                }
            }
            else
            {
                srchCriteriaUIUOMs = null;
            }

            gridView.LoadPanel(custCollection, srchCriteriaUIUOMs);

            ArrayList pnlCollection = gridView.GetPanelCollection();
            if (pnlCollection.Count == 0)
            {
                LRRMessagBox.ShowMessage(this, "SID_VERIFY_QUALIFIERS", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
            else
            {
                this.pnlGridContainer.Controls.Clear();
                SetPanel(pnlCollection);
                gridView.HideModes();
                if (this.dockingManager1 != null)
                {
                    this.dockingManager1.HideAutoHiddenControl();
                    pnlGroupedPropertiesOutput.DockPadding.Left = this.dockingManager1.DockTabHeight;
                }
                _objSiteComponents.RefreshCollection();
                Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
                _lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter, true);
            }
        }
    }
}
