using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools;
using Symcon.LightRidge.PEAdvisor;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Globals;
using System.Collections.Specialized;
using Symcon.Globals.Enums;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for HistTagUserPermissions.
	/// </summary>
	public class HistTagUserPermissions : System.Windows.Forms.Form,ILRRUIContainer
	{
		private Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar xpToolBar1;
		private System.Windows.Forms.ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barAssignUsers;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel pnlHistdata;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Splitter splitter3;

		private System.Windows.Forms.Panel pnlFull;
		private System.Windows.Forms.Splitter splitter4;
		private System.Windows.Forms.Panel pnlUp;
		private System.Windows.Forms.Panel pnlHistTag;
		private System.Windows.Forms.Splitter splitter5;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUser;
		private System.Windows.Forms.Splitter splitter6;
		private System.Windows.Forms.Panel panel2;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridHistTagUserPermissions;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridHistTag;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barBeginAssignment;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barTransfer;
		private System.Windows.Forms.ImageList smallImageList;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		private System.ComponentModel.IContainer components;

		
		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;



		public HistTagUserPermissions()
		{
			_lrrapp	= AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitializeComponent();
			BindGrids();
	
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(HistTagUserPermissions));
			this.xpToolBar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar();
			this.barBeginAssignment = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barAssignUsers = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barTransfer = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.smallImageList = new System.Windows.Forms.ImageList(this.components);
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.splitter4 = new System.Windows.Forms.Splitter();
			this.pnlFull = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.gridHistTagUserPermissions = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter6 = new System.Windows.Forms.Splitter();
			this.pnlUp = new System.Windows.Forms.Panel();
			this.panel1 = new System.Windows.Forms.Panel();
			this.gridUser = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter5 = new System.Windows.Forms.Splitter();
			this.pnlHistTag = new System.Windows.Forms.Panel();
			this.gridHistTag = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlFull.SuspendLayout();
			this.panel2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridHistTagUserPermissions)).BeginInit();
			this.pnlUp.SuspendLayout();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridUser)).BeginInit();
			this.pnlHistTag.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridHistTag)).BeginInit();
			this.SuspendLayout();
			// 
			// xpToolBar1
			// 
			this.xpToolBar1.Bar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(null, "", ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder))), null, null);
			this.xpToolBar1.Dock = System.Windows.Forms.DockStyle.Top;
			this.xpToolBar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									this.barBeginAssignment,
																									this.barItem1,
																									this.barAssignUsers,
																									this.barItem2,
																									this.barItem3,
																									this.barItem4,
																									this.barTransfer});
			this.xpToolBar1.Location = new System.Drawing.Point(0, 0);
			this.xpToolBar1.Name = "xpToolBar1";
			this.xpToolBar1.Size = new System.Drawing.Size(944, 25);
			this.xpToolBar1.TabIndex = 0;
			this.xpToolBar1.Text = "xpToolBar1";
			// 
			// barBeginAssignment
			// 
			this.barBeginAssignment.CategoryIndex = -1;
			this.barBeginAssignment.ID = "BeginAssignment";
			this.barBeginAssignment.ImageIndex = 3;
			this.barBeginAssignment.ImageList = this.imageList1;
			this.barBeginAssignment.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barBeginAssignment.Tag = "SID_STARTASSIGNUSER";
			this.barBeginAssignment.Tooltip = "Start Assigning User(s)";
			this.barBeginAssignment.Click += new System.EventHandler(this.barBeginAssignment_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = -1;
			this.barItem1.ID = "";
			// 
			// barAssignUsers
			// 
			this.barAssignUsers.CategoryIndex = -1;
			this.barAssignUsers.ID = "AssignUsers";
			this.barAssignUsers.ImageIndex = 1;
			this.barAssignUsers.ImageList = this.imageList1;
			this.barAssignUsers.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barAssignUsers.Tag = "SID_STARTASSIGNUSER=Start Assigning User(s)";
			this.barAssignUsers.Tooltip = "Click here if you have completed assigning the users";
			this.barAssignUsers.Click += new System.EventHandler(this.barAssignUsers_Click);
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = -1;
			this.barItem2.ID = "";
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = -1;
			this.barItem3.ID = "";
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = -1;
			this.barItem4.ID = "";
			// 
			// barTransfer
			// 
			this.barTransfer.CategoryIndex = -1;
			this.barTransfer.ID = "TransferPermission";
			this.barTransfer.ImageIndex = 31;
			this.barTransfer.ImageList = this.smallImageList;
			this.barTransfer.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barTransfer.Tag = "SID_TRASPERM";
			this.barTransfer.Tooltip = "TransferPermission";
			this.barTransfer.Click += new System.EventHandler(this.barTransfer_Click);
			// 
			// smallImageList
			// 
			this.smallImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.smallImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smallImageList.ImageStream")));
			this.smallImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// splitter1
			// 
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 25);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(944, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// splitter4
			// 
			this.splitter4.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter4.Location = new System.Drawing.Point(0, 360);
			this.splitter4.Name = "splitter4";
			this.splitter4.Size = new System.Drawing.Size(944, 32);
			this.splitter4.TabIndex = 4;
			this.splitter4.TabStop = false;
			// 
			// pnlFull
			// 
			this.pnlFull.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlFull.Controls.Add(this.panel2);
			this.pnlFull.Controls.Add(this.splitter6);
			this.pnlFull.Controls.Add(this.pnlUp);
			this.pnlFull.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlFull.Location = new System.Drawing.Point(0, 28);
			this.pnlFull.Name = "pnlFull";
			this.pnlFull.Size = new System.Drawing.Size(944, 466);
			this.pnlFull.TabIndex = 2;
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.gridHistTagUserPermissions);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 259);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(940, 203);
			this.panel2.TabIndex = 2;
			// 
			// gridHistTagUserPermissions
			// 
			this.gridHistTagUserPermissions.BackColor = System.Drawing.SystemColors.Window;
			this.gridHistTagUserPermissions.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridHistTagUserPermissions.Location = new System.Drawing.Point(0, 0);
			this.gridHistTagUserPermissions.Name = "gridHistTagUserPermissions";
			this.gridHistTagUserPermissions.Size = new System.Drawing.Size(940, 203);
			this.gridHistTagUserPermissions.TabIndex = 0;
			this.gridHistTagUserPermissions.TableDescriptor.AllowNew = false;
			this.gridHistTagUserPermissions.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridHistTagUserPermissions.Text = "gridGroupingControl2";
			this.gridHistTagUserPermissions.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_HIST_TAG_USER_PERMISSION") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridHistTagUserPermissions.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridHistTagUserPermissions.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridHistTagUserPermissions.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridHistTagUserPermissions.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridHistTagUserPermissions.VersionInfo = "3.301.0.0";
			this.gridHistTagUserPermissions.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridHistTagUserPermissions_TableControlCellClick);
			// 
			// splitter6
			// 
			this.splitter6.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter6.Location = new System.Drawing.Point(0, 256);
			this.splitter6.Name = "splitter6";
			this.splitter6.Size = new System.Drawing.Size(940, 3);
			this.splitter6.TabIndex = 1;
			this.splitter6.TabStop = false;
			// 
			// pnlUp
			// 
			this.pnlUp.Controls.Add(this.panel1);
			this.pnlUp.Controls.Add(this.splitter5);
			this.pnlUp.Controls.Add(this.pnlHistTag);
			this.pnlUp.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlUp.Location = new System.Drawing.Point(0, 0);
			this.pnlUp.Name = "pnlUp";
			this.pnlUp.Size = new System.Drawing.Size(940, 256);
			this.pnlUp.TabIndex = 0;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.gridUser);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(667, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(273, 256);
			this.panel1.TabIndex = 2;
			// 
			// gridUser
			// 
			this.gridUser.BackColor = System.Drawing.SystemColors.Window;
			this.gridUser.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUser.Location = new System.Drawing.Point(0, 0);
			this.gridUser.Name = "gridUser";
			this.gridUser.Size = new System.Drawing.Size(273, 256);
			this.gridUser.TabIndex = 0;
			this.gridUser.TableDescriptor.AllowEdit = false;
			this.gridUser.TableDescriptor.AllowNew = false;
			this.gridUser.TableDescriptor.AllowRemove = false;
			this.gridUser.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridUser.Text = "gridGroupingControl2";
			this.gridUser.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_LOGIN") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridUser.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUser.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUser.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUser.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUser.VersionInfo = "3.301.0.0";
			this.gridUser.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridUser_TableControlCellClick);
			this.gridUser.Click += new System.EventHandler(this.gridUser_Click);
			// 
			// splitter5
			// 
			this.splitter5.Location = new System.Drawing.Point(664, 0);
			this.splitter5.Name = "splitter5";
			this.splitter5.Size = new System.Drawing.Size(3, 256);
			this.splitter5.TabIndex = 1;
			this.splitter5.TabStop = false;
			// 
			// pnlHistTag
			// 
			this.pnlHistTag.Controls.Add(this.gridHistTag);
			this.pnlHistTag.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlHistTag.Location = new System.Drawing.Point(0, 0);
			this.pnlHistTag.Name = "pnlHistTag";
			this.pnlHistTag.Size = new System.Drawing.Size(664, 256);
			this.pnlHistTag.TabIndex = 0;
			// 
			// gridHistTag
			// 
			this.gridHistTag.BackColor = System.Drawing.SystemColors.Window;
			this.gridHistTag.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridHistTag.Location = new System.Drawing.Point(0, 0);
			this.gridHistTag.Name = "gridHistTag";
			this.gridHistTag.Size = new System.Drawing.Size(664, 256);
			this.gridHistTag.TabIndex = 0;
			this.gridHistTag.TableDescriptor.AllowEdit = false;
			this.gridHistTag.TableDescriptor.AllowNew = false;
			this.gridHistTag.TableDescriptor.AllowRemove = false;
			this.gridHistTag.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridHistTag.Text = "gridGroupingControl1";
			this.gridHistTag.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_HIST_DATA") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridHistTag.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridHistTag.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridHistTag.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridHistTag.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridHistTag.VersionInfo = "3.301.0.0";
			this.gridHistTag.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridHistTag_TableControlCellClick);
			// 
			// HistTagUserPermissions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(944, 494);
			this.Controls.Add(this.pnlFull);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.xpToolBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "HistTagUserPermissions";
			this.Tag = "SID_HISTTAG_PERMISSION";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.pnlFull.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridHistTagUserPermissions)).EndInit();
			this.pnlUp.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridUser)).EndInit();
			this.pnlHistTag.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridHistTag)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods

		private void BindGrids()
		{
			//**************************************GridHistTag***********************************

			_lrrHist = new LRRHistDatas();
			_lrrapp.DBManagerObj.PopulateCollection(_lrrHist,false);	
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridHistTag);
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrHist.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_lrrapp.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridHistTag,_lrrHist.ItemType,null,fkData);
			gridHistTag.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_HIST_DATA") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			gridHistTag.TableDescriptor.Columns.Clear();
			gridHistTag.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_HISTTAG"),"HistTag");
			gridHistTag.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_GENERAL_DESC"),"GeneralDesc");
			gridHistTag.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_COMMENTS"),"Comments");
			Hashtable RelativeWidths=new Hashtable();
			RelativeWidths.Add("HistTag",30);
			RelativeWidths.Add("GeneralDesc",50);
			RelativeWidths.Add("Comments",25);
			SyncGridUtilities.InitializeGridColumnsWidth(gridHistTag,RelativeWidths );
			gridHistTag.SourceListSet.Add("Parent",_lrrHist);
			gridHistTag.DataSource	= _lrrHist;

			//**************************************GridUser***********************************

			_lrrLogins = new LRRLogins();
			_lrrapp.DBManagerObj.PopulateCollection(_lrrLogins,false);	
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridUser);
			gridUser.TopLevelGroupOptions.CaptionText =  LRRHeaderText.GetHeaderString("SID_LRR_LOGIN") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			SyncGridUtilities.InitializeGridColumns(gridUser,gridUser.TableDescriptor,_lrrLogins.ItemType,null);
			gridUser.TableDescriptor.Columns.Clear();
			gridUser.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_USERNAME"),"UserName");
			Hashtable RelativeWidths1=new Hashtable();
			RelativeWidths1.Add("User Name",100);
			SyncGridUtilities.InitializeGridColumnsWidth(gridUser,RelativeWidths1);
			gridUser.DataSource	=_lrrLogins;


			//**************************************GridHistTagUserPermissions***********************************

			_lrrHistTagUserPermissions = new LRRHistTagUserPermissions();
			_lrrapp.DBManagerObj.PopulateCollection(_lrrHistTagUserPermissions,false);	
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridHistTagUserPermissions);
			SyncGridUtilities.InitializeGridColumns(gridHistTagUserPermissions,gridHistTagUserPermissions.TableDescriptor,_lrrHistTagUserPermissions.ItemType,null);
			gridHistTagUserPermissions.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_HIST_TAG_USER_PERMISSION") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			gridHistTagUserPermissions.TableDescriptor.Columns.Clear();
			gridHistTagUserPermissions.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_HISTTAG"),"HistTag");
			gridHistTagUserPermissions.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_USERNAME"),"UserName");
			GridColumnDescriptor gcd = new GridColumnDescriptor();
			gcd.HeaderText = LRRHeaderText.GetHeaderString("SID_USER_PERMISSION");
			gcd.MappingName	= "UserPermission";
			GridTableCellStyleInfo style = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			style.CellType	= "ComboBox";
			StringCollection objACLPermissionAssigned = new StringCollection();
			objACLPermissionAssigned.Add(Symcon.Globals.Enums.ACLPermissionAssigned.FULLCONTROL.ToString(Symcon.BusinessObjects.SymConverter.Culture));
			objACLPermissionAssigned.Add(Symcon.Globals.Enums.ACLPermissionAssigned.READONLY.ToString(Symcon.BusinessObjects.SymConverter.Culture));
			objACLPermissionAssigned.Add(Symcon.Globals.Enums.ACLPermissionAssigned.NOPERMISSIONS.ToString(Symcon.BusinessObjects.SymConverter.Culture));
			style.ChoiceList = objACLPermissionAssigned;
			style.DropDownStyle=GridDropDownStyle.Exclusive;
			gridHistTagUserPermissions.TableDescriptor.Columns.Add(gcd);
			Hashtable RelativeWidths2=new Hashtable();
			RelativeWidths2.Add("HistTag",30);
			RelativeWidths2.Add("UserName",40);
			RelativeWidths2.Add("UserPermission",30);
			SyncGridUtilities.InitializeGridColumnsWidth(gridHistTagUserPermissions,RelativeWidths2);

			gridHistTagUserPermissions.DataSource	=_lrrHistTagUserPermissions;
			gridHistTagUserPermissions.TableDescriptor.AllowEdit=true;
			gridHistTagUserPermissions.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_USER_PERMISSION")].ReadOnly=false;
			gridHistTagUserPermissions.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_HISTTAG")].ReadOnly=true;
			gridHistTagUserPermissions.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_USERNAME")].ReadOnly=true;
			

			//**************************************Common***********************************

			gridHistTag.TableControl.Selections.Clear();
			gridUser.TableControl.Selections.Clear();
			gridHistTagUserPermissions.TableControl.Selections.Clear();
			checkAssign=true;
		}

		private void Transfer(string frmUserID,string toUserID,string toUserName,Hashtable ht)
		{
			 LRRHistTagUserPermissions	_lrrHistTagUserPermissionsTransfer;
			_lrrHistTagUserPermissionsTransfer = new LRRHistTagUserPermissions();
			_lrrapp.DBManagerObj.PopulateCollection(_lrrHistTagUserPermissionsTransfer,false);	

			Hashtable hashHistTagId=new Hashtable();
			Hashtable hashHistTag=new Hashtable();
			hashHistTagId.Clear();
			hashHistTag.Clear();
			for(int j=0 ;j<ht.Count;j++)
			{
				LRRHistTagUserPermission lrrHistTagUserPermission=ht[j] as LRRHistTagUserPermission;
				hashHistTagId.Add(j,lrrHistTagUserPermission.HistTagID);
				hashHistTag.Add(j,lrrHistTagUserPermission.HistTag);
			}
			for(int k=0;k<hashHistTagId.Count;k++)
			{
				string filterString="";
				filterString =   "UserID = " + frmUserID;
				_lrrHistTagUserPermissionsTransfer.ItemFilter= filterString;
				filterString =   "HistTagID = " + hashHistTagId[k].ToString();
				_lrrHistTagUserPermissionsTransfer.ItemFilter= filterString;

				for(int i=0;i<_lrrHistTagUserPermissionsTransfer.Count;i++)
				{
					LRRHistTagUserPermission histTagUserObj=_lrrHistTagUserPermissionsTransfer[i] as LRRHistTagUserPermission;
					histTagUserObj.UserID=toUserID;
					histTagUserObj.UserName=toUserName;
					histTagUserObj.HistTagID=hashHistTagId[k].ToString();
					histTagUserObj.HistTag=hashHistTag[k].ToString();
					histTagUserObj.ObjectState=DBOperation.UPDATE;
				}
			}
			if(_lrrHistTagUserPermissionsTransfer.GetChanges().Count>0)
			{
				if(LRRMessagBox.ShowMessage("SID_UPDATE_QUESTION","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question) == DialogResult.Yes)
				{
					_lrrapp.DBManagerObj.CommitCollection(_lrrHistTagUserPermissionsTransfer.GetChanges());
					_lrrHistTagUserPermissionsTransfer.RefreshCollection();
					_lrrHistTagUserPermissions.RefreshCollection();
					BindGrids();
					//LRRMessagBox.ShowMessage("SID_SAVEDINFO","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);   
					LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				}
				else
				{
					_lrrHistTagUserPermissions.RefreshCollection();
					_lrrHistTagUserPermissionsTransfer.RefreshCollection();
					return;
				}
			}
	
		}

		#endregion 

		#region	Fields

		private	LRRApp				_lrrapp;
		//private LRRUIManager lrrUI=new LRRUIManager();
		private LRRHistDatas _lrrHist;
		private LRRLogins  _lrrLogins;
		private LRRHistTagUserPermissions	_lrrHistTagUserPermissions;
		private bool checkAssign=false;

		#endregion

		#region Events

		private void barAssignUsers_Click(object sender, System.EventArgs e)
		{
			bool found = false;
			LRRHistTagUserPermission foundObj	= null;
			if(checkAssign==true)
			{
				LRRMessagBox.ShowMessage("SID_CLICK_ONSTART","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
    
			}
			if(checkAssign==false)
			{
				LRRLogin loginObj=null;
				LRRHistData	 histData =	null;

				GridRangeInfoList list;
				list = this.gridUser.TableControl.Selections.GetSelectedRows(false, false);
				GridRangeInfoList listTag;
				listTag = this.gridHistTag.TableControl.Selections.GetSelectedRows(false, false);
				foreach(GridRangeInfo range in list)
				{
					for(int i = range.Top; i <= range.Bottom; i++)
					{
						for(int j= 1; j <= 1; j++)
						{
							foreach(GridRangeInfo rangeTag in listTag)
							{
								for(int iTag = rangeTag.Top; iTag <= rangeTag.Bottom; iTag++)
								{
									for(int jTag= 1; jTag <= 1; jTag++)
									{
										string nameUser=this.gridUser.TableModel[i, j].Text;
										string nameTag=this.gridHistTag.TableModel[iTag, jTag].Text;
										if(nameUser!=""&&nameTag!="")
										{
											LRRHistTagUserPermission lrrHTUP =	new	LRRHistTagUserPermission();
											histData = gridHistTag.TableModel.Table.Records[iTag-3].GetData()	as LRRHistData;
											loginObj =	 gridUser.TableModel.Table.Records[i-3].GetData()	as LRRLogin;
											if((histData!= null) &&	(loginObj != null))
											{
												lrrHTUP.ID= Guid.NewGuid().ToString();
												lrrHTUP.HistTagID=histData.HistTagUID;
												lrrHTUP.HistTag=histData.HistTag;
												lrrHTUP.UserID=loginObj.UserID;
												lrrHTUP.UserName=loginObj.UserName;


												foreach(LRRHistTagUserPermission objHistHistTagUserPermission in _lrrHistTagUserPermissions)
												{
													if(objHistHistTagUserPermission.HistTagID == lrrHTUP.HistTagID && objHistHistTagUserPermission.UserID == lrrHTUP.UserID )
													{
														LRRMessagBox.ShowMessage("SID_DUPLICATE_MAPPING","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);     
														return;
													}
												}
										
												_lrrHistTagUserPermissions.Add(lrrHTUP);

											}
										}
									}
								}
							}
						}
					}
				}
				gridHistTag.TableControl.Selections.Clear();
				gridUser.TableControl.Selections.Clear();
				gridHistTagUserPermissions.TableControl.Selections.Clear();
				checkAssign=true;
			}
		}
		

		private void gridHistTagUserPermissions_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(e.TableControl.Table.Records.Count > 0)
			{
				this.Cursor=Cursors.WaitCursor;
				gridHistTag.TableControl.Selections.Clear();
				gridUser.TableControl.Selections.Clear();
				gridHistTag.TableControl.CurrentCell.Deactivate(true);
				gridUser.TableControl.CurrentCell.Deactivate(true);
				LRRHistTagUserPermission lrrHTUP =	 gridHistTagUserPermissions.CurrencyManager.Current as LRRHistTagUserPermission;
			
				for(int	i =	0; i< gridUser.CurrencyManager.List.Count; i++)
				{
					LRRLogin login =	 gridUser.CurrencyManager.List[i] as	LRRLogin;
					if(lrrHTUP.UserID ==	login.UserID)
					{
						gridUser.TableControl.CurrentCell.Activate(i+3,0);
						gridUser.TableModel.Selections.SelectRange(GridRangeInfo.Row(i+3),true);
						gridUser.Table.Records[i].SetCurrent();
						gridUser.Refresh();
					}
				}
				for(int	j=0; j<gridHistTag.CurrencyManager.List.Count;	j++)
				{
					LRRHistData	histData = gridHistTag.CurrencyManager.List[j]	as LRRHistData;
					if(lrrHTUP.HistTagID ==	histData.HistTagUID)
					{
						gridUser.TableControl.CurrentCell.Activate(j+3,0);
						gridHistTag.TableModel.Selections.SelectRange(GridRangeInfo.Row(j+3),true);
						gridHistTag.Table.Records[j].SetCurrent();
						gridHistTag.Refresh();
					}
				}
				this.Cursor=Cursors.Default;
			}
			
		}

		private void gridHistTag_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{

			if(checkAssign==true)
			{
				this.Cursor=Cursors.WaitCursor;
				gridHistTagUserPermissions.TableControl.Selections.Clear();
				gridUser.TableControl.Selections.Clear();
				LRRHistData lrrHD =	 gridHistTag.CurrencyManager.Current as LRRHistData;
				gridHistTagUserPermissions.TableControl.CurrentCell.Deactivate(true);
				gridUser.TableControl.CurrentCell.Deactivate(true);

				for(int	j=0; j<gridHistTagUserPermissions.CurrencyManager.List.Count;j++)
				{
					LRRHistTagUserPermission	histTagUser = gridHistTagUserPermissions.CurrencyManager.List[j]	as LRRHistTagUserPermission;
					if(lrrHD.HistTagUID ==	histTagUser.HistTagID)
					{
						gridHistTagUserPermissions.TableControl.CurrentCell.Activate(j+3,0);
						gridHistTagUserPermissions.TableModel.Selections.SelectRange(GridRangeInfo.Row(j+3),true);
						gridHistTagUserPermissions.Table.Records[j].SetCurrent();
						gridUser.Refresh();
						for(int	k=0; k<gridUser.CurrencyManager.List.Count;	k++)
						{
							LRRLogin	login = gridUser.CurrencyManager.List[k]	as LRRLogin;
							if(histTagUser.UserID ==	login.UserID)
							{
								gridUser.TableControl.CurrentCell.Activate(k+3,0);
								gridUser.TableModel.Selections.SelectRange(GridRangeInfo.Row(k+3),true);
								gridUser.Table.Records[k].SetCurrent();
							}
						}
					}
					gridHistTagUserPermissions.Refresh();
				}
				this.Cursor=Cursors.Default;
			}
		}

		private void gridUser_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{

			if(checkAssign==true)
			{
				this.Cursor=Cursors.WaitCursor;
				gridHistTagUserPermissions.TableControl.Selections.Clear();
				gridHistTag.TableControl.Selections.Clear();
				LRRLogin lrrLogin =	 gridUser.CurrencyManager.Current as LRRLogin;
				gridHistTagUserPermissions.TableControl.CurrentCell.Deactivate(true);
				gridHistTag.TableControl.CurrentCell.Deactivate(true);

				for(int	j=0; j<gridHistTagUserPermissions.CurrencyManager.List.Count;	j++)
				{
					LRRHistTagUserPermission	histTagUser = gridHistTagUserPermissions.CurrencyManager.List[j]	as LRRHistTagUserPermission;
					if(lrrLogin.UserID ==	histTagUser.UserID)
					{
						gridHistTagUserPermissions.TableControl.CurrentCell.Activate(j+3,0);
						gridHistTagUserPermissions.TableModel.Selections.SelectRange(GridRangeInfo.Row(j+3),true);
						gridHistTagUserPermissions.Table.Records[j].SetCurrent();
						gridUser.Refresh();
						for(int	k=0; k<gridUser.CurrencyManager.List.Count;	k++)
						{
							LRRHistData	histData = gridHistTag.CurrencyManager.List[k]	as LRRHistData;
							if(histTagUser.HistTagID ==	histData.HistTagUID)
							{
								gridHistTag.TableControl.CurrentCell.Activate(k+3,0);
								gridHistTag.TableModel.Selections.SelectRange(GridRangeInfo.Row(k+3),true);
								gridHistTag.Table.Records[k].SetCurrent();
							}
						}
					}
					gridHistTagUserPermissions.Refresh();
				}
				this.Cursor=Cursors.Default;
			}
		}

		private void barBeginAssignment_Click(object sender, System.EventArgs e)
		{
			checkAssign=false;
			gridHistTag.TableControl.Selections.Clear();
			gridUser.TableControl.Selections.Clear();
			gridHistTagUserPermissions.TableControl.Selections.Clear();		
		}

		private void barTransfer_Click(object sender, System.EventArgs e)
		{
			TransferPermissionDialog transferPermissionDialog = new TransferPermissionDialog();
			DialogResult result = transferPermissionDialog.ShowDialog();
		
			if(result == DialogResult.OK)
			{
				Transfer(transferPermissionDialog.frmUserID,transferPermissionDialog.toUserID,transferPermissionDialog.toUserName,transferPermissionDialog.ht);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			this.Cursor = Cursors.WaitCursor;
			BindGrids();
			this.Cursor = Cursors.Default;
		}

		public void Save()
		{
			this.Cursor=Cursors.WaitCursor;
			try
			{
				bool savedCalled = false;
				
				if(_lrrHistTagUserPermissions.GetChanges().Count != 0)
				{
					savedCalled	= true;
					LRRHistTagUserPermissions histTagUserPer = _lrrHistTagUserPermissions.GetChanges();
					_lrrapp.DBManagerObj.CommitCollection(histTagUserPer);

				}
				
				if(savedCalled)
				{
                    LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);					
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
				}
				_lrrHist.RefreshCollection();
				_lrrLogins.RefreshCollection();
				_lrrHistTagUserPermissions.RefreshCollection();

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(HistTagUserPermissions),"Save :"+ex.Message  ,Logger.Level.Error);
			}
			this.Cursor=Cursors.Default;
			gridHistTag.TableControl.Selections.Clear();
			gridUser.TableControl.Selections.Clear();
			gridHistTagUserPermissions.TableControl.Selections.Clear();
			checkAssign=true;
		}
		public void Paste()
		{

		}

		public void Copy()
		{
		}

		public void Print()
		{

		}

		public void Delete()
		{
   
		}

		public void ArrangeColumns()
		{

		}
		public bool SupportsCopyRecord()
		{
			return true;
		}
		public bool SupportsPasteRecord()
		{
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}

		public void ClearFilter()
		{
			
		}

		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(gridHistTagUserPermissions);
		}

		public void Export()
		{
			
		}

		public bool SupportsCopy()
		{
			return false;
		}

		public bool SupportsPaste()
		{
			return false;
		}

		public bool SupportsExport()
		{
			return false;
		}

		public bool SupportsSave()
		{
			return true;
		}

		public bool SupportsRefresh()
		{
			return true;
		}

		public bool SupportsDelete()
		{
			return false;
		}

		public bool SupportsPrint()
		{
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			return false;
		}

		public bool SupportsClearFilter()
		{
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsSelectionPaste()
		{
			return true;
		}
		public void InsertNewRows()
		{}

		public void CopyMasterProperties()
		{
			// TODO:  Add MasterPlantItems.CopyMasterProperties implementation
		}
		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridHistTagUserPermissions);
		}
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}
		public bool SupportsLevel()
		{
			return false;
		}

		private void gridUser_Click(object sender, System.EventArgs e)
		{
		
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// HistTagUserPermissions.ClearSort implementation
			SyncGridUtilities.ClearSort(gridHistTag);
			SyncGridUtilities.ClearSort(gridUser);
			SyncGridUtilities.ClearSort(gridHistTagUserPermissions);
		}

		public bool SupportsClearSort()
		{
			// HistTagUserPermissions.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add HistTagUserPermissions.PrintPreview implementation
			if(gridHistTag.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridHistTag,true);
			}
			
			if(gridHistTagUserPermissions.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridHistTagUserPermissions,true);
			}

			if(gridUser.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUser,true);
			}

		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add HistTagUserPermissions.ShowPropertyList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add HistTagUserPermissions.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowComponentList()
		{
			// TODO:  Add HistTagUserPermissions.ShowComponentList implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add HistTagUserPermissions.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add HistTagUserPermissions.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add HistTagUserPermissions.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridHistTag);
            SyncGridUtilities.RollBackChanges(this.gridHistTagUserPermissions);
            SyncGridUtilities.RollBackChanges(this.gridUser);
            Refresh();
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add HistTagUserPermissions.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add HistTagUserPermissions.SupportsUndo implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add HistTagUserPermissions.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add HistTagUserPermissions.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add HistTagUserPermissions.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add HistTagUserPermissions.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add HistTagUserPermissions.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add HistTagUserPermissions.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add HistTagUserPermissions.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add HistTagUserPermissions.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add HistTagUserPermissions.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add HistTagUserPermissions.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
