using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Chart;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.HistorianConnect;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects; 
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.MessageDispatcher;  

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for HistTrends.
	/// </summary>
	public class HistTrends : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.ComponentModel.IContainer components;

		public HistTrends(string histTag, bool showAllTrends)
		{
            _showAllTrends = showAllTrends;

            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            System.Diagnostics.Process p1 = new System.Diagnostics.Process();
            p1.StartInfo.WorkingDirectory = _lrrApp.AppPath; ;
            p1.StartInfo.FileName = "ProgressIndicator.exe";
            p1.StartInfo.Arguments = "\"" + this.Text + "\"";
            p1.Start();
            p1.Refresh();
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.panelDateTime.Location = new System.Drawing.Point(((this.Width - this.panelDateTime.Width)/2)>0 ? ((this.Width - this.panelDateTime.Width)/2): 0,((this.panelDateTimeContainer.Height - this.panelDateTime.Height)/2)>0 ? ((this.panelDateTimeContainer.Height - this.panelDateTime.Height)/2): 0);

			chartControlTrends.ChartFormatAxisLabel += new ChartFormatAxisLabelEventHandler(chartControlTrends_ChartFormatAxisLabelEventHandler);
			
			_histTag = histTag;
						
			Symcon.LightRidge.Options.DBOptions.DBInfo dbinfo = _lrrApp.GetOptions().TuningConnectionObj.GetActiveTuningDBInfo();
            if (dbinfo != null)
            {
                _tuningHistorian = new TuningHistorian();
                try
                {
                    _tuningHistorian.Initialize(dbinfo);
                    if (!_tuningHistorian.Initialized)
                    {
                        try
                        {
                            p1.Kill();
                        }
                        catch
                        { }
                        throw new Exception();
                    }
                }
                catch
                {
                    try
                    {
                        p1.Kill();
                    }
                    catch
                    { }
                    _lrrApp.MainFrame.Activate();
                    throw new Exception();
                }
            }
            else
            {
                p1.Kill();
                throw new Exception();
            }

			InitializeChartAppearance();
			
			
			chartControlTrends.Model.Series.Clear();

			this.Resize += new EventHandler(HistTrends_Resize);

			this.Text = LRRHeaderText.GetHeaderString("SID_HISTTREND") + _histTag;
			
			if(_arrHistTags != null)
			{
				foreach(string arrHistTag in _arrHistTags)
				{
					comboBoxBarItem1.ChoiceList.Add(arrHistTag);
					if(arrHistTag.Equals(histTag))
					{
						_currentIndex = _arrHistTags.IndexOf(arrHistTag);
						_isTagPresent = true;
						comboBoxBarItem1.TextBoxValue = histTag;
						break;
					}
				}
			}

			
			if(!_isTagPresent)
				this.childFrameBarManager1.Dispose();
            this.FormClosed += new FormClosedEventHandler(HistTrends_FormClosed);

            if (this.Tag.ToString().IndexOf("HistTrend(All):") != -1)
                _showAllTrends = true;

            // Activate Mainframe so that another application is not activated.
            _lrrApp.MainFrame.Activate();

            if (!_showAllTrends)
            {
                this.dateTimePickerStart.Value = HistTrendsDialog.startTime;
                this.dateTimePickerEnd.Value = HistTrendsDialog.endTime;
                this.Text = "Hist Trend: " + _histTag;
                
            }
            else
            {
                panelDateTimeContainer.Dock = DockStyle.None;
                panelDateTimeContainer.Hide();
                this.Text = LRRHeaderText.GetHeaderString("SID_HISTTRENDTUNING") + _histTag;
                //_showAllTrends = true;
                //_parentTabPage.Text = LRRHeaderText.GetHeaderString("SID_HISTTRENDALL") + _histTag;
            }



            //_tuningHistorian.PrepareCollection(this.dateTimePickerStart.Value.ToString(),this.dateTimePickerEnd.Value.ToString(),_histTag);
            

            try
            {
                LoadChart();
                if (_isTagPresent)
                {
                    EnableDisableBarItems();
                    _isTagPresent = false;
                }

               
               p1.Kill();
               
            }
            catch
            {

            }
            _isFirstTime = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(HistTrends));
			this.chartControlTrends = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.dateTimePickerStart = new System.Windows.Forms.DateTimePicker();
			this.dateTimePickerEnd = new System.Windows.Forms.DateTimePicker();
			this.buttonReload = new System.Windows.Forms.Button();
			this.labelStartTime = new System.Windows.Forms.Label();
			this.labelEndTime = new System.Windows.Forms.Label();
			this.panelDateTimeContainer = new System.Windows.Forms.Panel();
			this.panelDateTime = new System.Windows.Forms.Panel();
			this.childFrameBarManager1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager(this.components, this);
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.childFrameBarManager1, "Navigation");
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.comboBoxBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.panelDateTimeContainer.SuspendLayout();
			this.panelDateTime.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).BeginInit();
			this.SuspendLayout();
			// 
			// chartControlTrends
			// 
			this.chartControlTrends.ColumnWidthMode = Syncfusion.Windows.Forms.Chart.ChartColumnWidthMode.DefaultWidthMode;
			this.chartControlTrends.Controls.Add(this.chartControlTrends.Legend);
			this.chartControlTrends.Dock = System.Windows.Forms.DockStyle.Fill;
			this.chartControlTrends.EnableYZooming = true;
			this.chartControlTrends.KeyZoom = true;
			// 
			// chartControlTrends.Legend
			// 
			this.chartControlTrends.Legend.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.chartControlTrends.Legend.Location = new System.Drawing.Point(706, 218);
			this.chartControlTrends.Legend.Name = "";
			this.chartControlTrends.Legend.Size = new System.Drawing.Size(76, 28);
			this.chartControlTrends.Legend.TabIndex = 3;
			this.chartControlTrends.Location = new System.Drawing.Point(0, 32);
			this.chartControlTrends.Name = "chartControlTrends";
			//this.chartControlTrends.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControlTrends.PrimaryXAxis.SmartDateZoomDayLevelLabelFormat = "g";
			this.chartControlTrends.PrimaryXAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControlTrends.PrimaryYAxis.SmartDateZoomDayLevelLabelFormat = "g";
			this.chartControlTrends.PrimaryYAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControlTrends.Size = new System.Drawing.Size(792, 454);
			this.chartControlTrends.Spacing = 10F;
			this.chartControlTrends.TabIndex = 0;
			this.chartControlTrends.Tag = "";
			this.chartControlTrends.Tilt = 30F;
			// 
			// chartControlTrends.ToolBar
			// 
			this.chartControlTrends.ToolBar.Location = new System.Drawing.Point(26, 26);
			this.chartControlTrends.ZoomFactorX = 1;
			this.chartControlTrends.ZoomFactorY = 1;
			this.chartControlTrends.ZoomOutIncrement = 1.5;
			// 
			// dateTimePickerStart
			// 
			this.dateTimePickerStart.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.dateTimePickerStart.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dateTimePickerStart.Location = new System.Drawing.Point(72, 8);
			this.dateTimePickerStart.Name = "dateTimePickerStart";
			this.dateTimePickerStart.Size = new System.Drawing.Size(152, 20);
			this.dateTimePickerStart.TabIndex = 1;
			// 
			// dateTimePickerEnd
			// 
			this.dateTimePickerEnd.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
			this.dateTimePickerEnd.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dateTimePickerEnd.Location = new System.Drawing.Point(312, 8);
			this.dateTimePickerEnd.Name = "dateTimePickerEnd";
			this.dateTimePickerEnd.Size = new System.Drawing.Size(152, 20);
			this.dateTimePickerEnd.TabIndex = 2;
			// 
			// buttonReload
			// 
			this.buttonReload.Location = new System.Drawing.Point(280, 32);
			this.buttonReload.Name = "buttonReload";
			this.buttonReload.Size = new System.Drawing.Size(0, 0);
			this.buttonReload.TabIndex = 3;
			this.buttonReload.Tag = "SID_RELOAD";
			this.buttonReload.Click += new System.EventHandler(this.buttonReload_Click);
			// 
			// labelStartTime
			// 
			this.labelStartTime.Location = new System.Drawing.Point(8, 8);
			this.labelStartTime.Name = "labelStartTime";
			this.labelStartTime.Size = new System.Drawing.Size(64, 23);
			this.labelStartTime.TabIndex = 4;
			this.labelStartTime.Tag = "SID_STARTTIME";
			// 
			// labelEndTime
			// 
			this.labelEndTime.Location = new System.Drawing.Point(248, 8);
			this.labelEndTime.Name = "labelEndTime";
			this.labelEndTime.Size = new System.Drawing.Size(64, 23);
			this.labelEndTime.TabIndex = 5;
			this.labelEndTime.Tag = "SID_ENDTIME";
			// 
			// panelDateTimeContainer
			// 
			this.panelDateTimeContainer.Controls.Add(this.panelDateTime);
			this.panelDateTimeContainer.Dock = System.Windows.Forms.DockStyle.Top;
			this.panelDateTimeContainer.Location = new System.Drawing.Point(0, 0);
			this.panelDateTimeContainer.Name = "panelDateTimeContainer";
			this.panelDateTimeContainer.Size = new System.Drawing.Size(792, 32);
			this.panelDateTimeContainer.TabIndex = 6;
			// 
			// panelDateTime
			// 
			this.panelDateTime.Controls.Add(this.dateTimePickerStart);
			this.panelDateTime.Controls.Add(this.buttonReload);
			this.panelDateTime.Controls.Add(this.labelEndTime);
			this.panelDateTime.Controls.Add(this.labelStartTime);
			this.panelDateTime.Controls.Add(this.dateTimePickerEnd);
			this.panelDateTime.Location = new System.Drawing.Point(192, 0);
			this.panelDateTime.Name = "panelDateTime";
			this.panelDateTime.Size = new System.Drawing.Size(474, 80);
			this.panelDateTime.TabIndex = 6;
			// 
			// childFrameBarManager1
			// 
			this.childFrameBarManager1.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("childFrameBarManager1.BarPositionInfo")));
			this.childFrameBarManager1.Bars.Add(this.bar1);
			this.childFrameBarManager1.Categories.Add("Navigation");
			this.childFrameBarManager1.CurrentBaseFormType = "";
			this.childFrameBarManager1.DisabledImageList = null;
			this.childFrameBarManager1.DisabledLargeImageList = null;
			this.childFrameBarManager1.Form = this;
			this.childFrameBarManager1.ImageList = null;
			this.childFrameBarManager1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											   this.barItem1,
																											   this.barItem2,
																											   this.barItem3,
																											   this.barItem4,
																											   this.comboBoxBarItem1});
			this.childFrameBarManager1.LargeImageList = null;
			this.childFrameBarManager1.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
			// 
			// bar1
			// 
			this.bar1.AllowCustomizing = false;
			this.bar1.BarName = "Navigation";
			this.bar1.Caption = "Navigation";
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItem1,
																							  this.barItem2,
																							  this.comboBoxBarItem1,
																							  this.barItem3,
																							  this.barItem4});
			this.bar1.Manager = this.childFrameBarManager1;
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 0;
			this.barItem1.ID = "First";
			this.barItem1.Text = "<< First";
			this.barItem1.Click += new System.EventHandler(this.barItem1_Click);
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = 0;
			this.barItem2.ID = "Prev";
			this.barItem2.Text = "< Prev";
			this.barItem2.Click += new System.EventHandler(this.barItem2_Click);
			// 
			// comboBoxBarItem1
			// 
			this.comboBoxBarItem1.CategoryIndex = 0;
			this.comboBoxBarItem1.ID = "HistTag";
			this.comboBoxBarItem1.MinWidth = 150;
			this.comboBoxBarItem1.Text = "HistTag";
			this.comboBoxBarItem1.Click += new System.EventHandler(this.comboBoxBarItem1_Click);
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = 0;
			this.barItem3.ID = "Next";
			this.barItem3.Text = "Next >";
			this.barItem3.Click += new System.EventHandler(this.barItem3_Click);
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = 0;
			this.barItem4.ID = "Last";
			this.barItem4.Text = "Last >>";
			this.barItem4.Click += new System.EventHandler(this.barItem4_Click);
			// 
			// HistTrends
			// 
			this.AcceptButton = this.buttonReload;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(792, 486);
			this.Controls.Add(this.chartControlTrends);
			this.Controls.Add(this.panelDateTimeContainer);
			this.MinimumSize = new System.Drawing.Size(500, 0);
			this.Name = "HistTrends";
			this.Tag = "SID_HISTTRENDS";
			this.Text = "Hist Trend";
			this.Load += new System.EventHandler(this.HistTrends_Load);
			this.panelDateTimeContainer.ResumeLayout(false);
			this.panelDateTime.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.childFrameBarManager1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		private LRRApp	_lrrApp;
		private string	_histTag;
		private TabPage _parentTabPage;
		private TabControl _parentTabControl;
		private System.Windows.Forms.DateTimePicker dateTimePickerStart;
		private System.Windows.Forms.DateTimePicker dateTimePickerEnd;
		private System.Windows.Forms.Label labelStartTime;
		private System.Windows.Forms.Label labelEndTime;
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControlTrends;
		private System.Windows.Forms.Button buttonReload;
		private System.Windows.Forms.Panel panelDateTimeContainer;
		private System.Windows.Forms.Panel panelDateTime;
		private TuningHistorian	_tuningHistorian;
		private bool _showAllTrends = false;
		private TimeSpan _ts;
		public static ChartSeriesType _seriesType = ChartSeriesType.Scatter;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ChildFrameBarManager childFrameBarManager1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		public static ArrayList _arrHistTags;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ComboBoxBarItem comboBoxBarItem1;
		private int _currentIndex = 0;
		private int _lastIndex = 0;
		private bool _isTagPresent = false;
        private bool _isFirstTime = true;

		#endregion

		#region Private Methods
		
		private void LoadChart()
		{
			
			if(! _showAllTrends && dateTimePickerStart.Value >= dateTimePickerEnd.Value)
			{
				MessageBox.Show(this, "End time is less than or equal to the start time!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

            System.Diagnostics.Process p1 = new System.Diagnostics.Process();
            if (!_isFirstTime)
            {
                p1.StartInfo.WorkingDirectory = _lrrApp.AppPath; ;
                p1.StartInfo.FileName = "ProgressIndicator.exe";
                p1.StartInfo.Arguments = "\"" + this.Text + "\"";
                p1.Start();
                p1.Refresh();
            }

            LRRHistSavedSets histSavedSets = null;
           
            if (_showAllTrends)
            {
                histSavedSets = _tuningHistorian.GetSavedSets();
                _tuningHistorian.PrepareCollection(_histTag);
            }
            else
            {
                //string sTuningDateTimeFormat = "MM-dd-yyyy hh:mm:ss";
                string sDataSetStart = HistTrendsDialog.startTime.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                string sDataSetEnd = HistTrendsDialog.endTime.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                histSavedSets = _tuningHistorian.GetSavedSets(sDataSetStart, sDataSetEnd);
                _tuningHistorian.PrepareCollection(sDataSetStart, sDataSetEnd, _histTag);
            }

           
            //_tuningHistorian.PrepareCollection(_histTag);
            

            double maxYCalculated = double.MinValue; //initializing calculated max of y for y-axis
            double minYCalculated = double.MaxValue; //initializing calculated min of y for y-axis
			try
			{
				//chartControlTrends.SuspendLayout();
				
				chartControlTrends.Model.Series.Clear();
				ChartSeries series = this.chartControlTrends.Model.NewSeries("Series 0");
                
               

				bool isFirstTime = true;
				foreach(LRRHistSavedSet histSavedSet in histSavedSets)
				{
                    try
                    {

                        if (_showAllTrends)
                        {
                            DateTime startTime = histSavedSet.StartTime;
                            if (dateTimePickerStart.Value > startTime)
                            {
                                dateTimePickerStart.Value = startTime;
                            }
                            if (isFirstTime)
                            {
                                dateTimePickerEnd.Value = startTime.AddSeconds(10);
                                isFirstTime = false;
                            }
                            else if (dateTimePickerEnd.Value < startTime)
                            {
                                dateTimePickerEnd.Value = startTime;
                            }
                        }
                        //_tuningHistorian.PrepareCollection(histSavedSet.ID, _histTag);
                        double point;
                        if(!double.TryParse(_tuningHistorian.GetPoint(histSavedSet.ID),out point))
                        {
                            continue;
                        }
                        double[] points = new double[] { point, 1 };

                        // Getting min and max y values
                        if (minYCalculated > points[0])
                        {
                            minYCalculated = points[0];
                        }
                        if (maxYCalculated < points[0])
                        {
                            maxYCalculated = points[0];
                        }
                        //						
                        //						ChartCustomPoint cp = new ChartCustomPoint();
                        //						cp.CustomType = ChartCustomPointType.ChartCoordinates;
                        //						cp.DateXValue = DateTime.Parse(histSavedSet.StartTime);
                        //						cp.XValue = double.Parse(point.AverageValueForPeriodEntered);
                        //						cp.Symbol.Shape = ChartSymbolShape.Circle;
                        //						cp.Symbol.Color = Color.Red;
                        //						cp.Text = "";
                        //						
                        //						this.chartControlTrends.CustomPoints.Add(cp);
                        series.Points.Add(histSavedSet.StartTime, points);

                    }
                    catch
                    {
                    }
				}

               

				series.Type = _seriesType;
				series.Text = series.Name;
				series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyle);
				this.chartControlTrends.Series.Add(series);
			
				if(!_showAllTrends)
				{
					HistTrendsDialog.startTime = this.dateTimePickerStart.Value;
					HistTrendsDialog.endTime = this.dateTimePickerEnd.Value;
				}

				LRRHistData histData = new LRRHistData();
				_lrrApp.DBManagerObj.PopulateObject(histData,typeof(LRRHistData)," WHERE HistTag='" + _histTag + "'");

				LRRUOM uom = new LRRUOM();
				_lrrApp.DBManagerObj.PopulateObject(uom,typeof(LRRUOM)," WHERE ID='" + histData.HistUnits + "'");
				
				
				chartControlTrends.Text = LRRHeaderText.GetHeaderString("SID_HISTAG") + _histTag;
			
				if(histData.GeneralDesc !=null)
					if(histData.GeneralDesc.Trim() != "")
						chartControlTrends.Text += ","+ LRRHeaderText.GetHeaderString("SID_GENERAL_DESC")+ histData.GeneralDesc.Trim();
			
				if(histData.HistDesc !=null)
					if(histData.HistDesc.Trim() != "")
						chartControlTrends.Text += ","+LRRHeaderText.GetHeaderString("SID_HISTDESC")+ histData.HistDesc.Trim();

				//chartControlTrends.Axes[0].Title = "Start Time -->";
				chartControlTrends.Axes[1].Title = LRRHeaderText.GetHeaderString("SID_AVERAGEVALEFORPERIODENTERD");
				if(uom.Name != null)
					if(uom.Name.Trim() != "")
						chartControlTrends.Axes[1].Title += " (" + uom.Name.Trim() + ")";

                if (maxYCalculated > minYCalculated)
                {
                    double yScaleLengthCalculated = maxYCalculated - minYCalculated;
                    double yScaleMargin = 0.01;

                    if (yScaleLengthCalculated < 0.05)
                    {
                        minYCalculated = minYCalculated - 0.01;
                        maxYCalculated = maxYCalculated + 0.01;
                    }
                    else
                    {
                        yScaleMargin = yScaleLengthCalculated / 10; // 10% margin
                    }

                    // Calculate the actual max and min values for chart
                    double maxYActual = maxYCalculated + yScaleMargin;
                    double minYActual = minYCalculated - yScaleMargin;

                    // Now apply the max and min values to axis
                    this.chartControlTrends.PrimaryYAxis.RangeType = ChartAxisRangeType.Set;
                    this.chartControlTrends.PrimaryYAxis.PreferZero = true;

                    this.chartControlTrends.PrimaryYAxis.Range = new MinMaxInfo(minYActual, maxYActual, (maxYActual - minYActual) / 10);

                }
				_ts = dateTimePickerEnd.Value - dateTimePickerStart.Value;
				if(((_ts.TotalDays * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrends.PrimaryXAxis.Size.Width)))/(this.chartControlTrends.PrimaryXAxis.Size.Width * Screen.PrimaryScreen.Bounds.Width)) < 17)
					this.chartControlTrends.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(dateTimePickerStart.Value,dateTimePickerEnd.Value, Math.Max((_ts.TotalMilliseconds * 4.5 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrends.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrends.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
				else
					this.chartControlTrends.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(dateTimePickerStart.Value,dateTimePickerEnd.Value, Math.Max((_ts.TotalMilliseconds * 2.25 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrends.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrends.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
			
				//this.chartControlTrends.PrimaryXAxis.LabelRotate = true;
				//this.chartControlTrends.PrimaryXAxis.LabelRotateAngle = 315;
			
				this.chartControlTrends.ShowToolTips = true;
				this.chartControlTrends.Legend.Visible = false;

				//chartControlTrends.ResumeLayout();
			}
			catch
			{	
			}
			try
			{
                if (!_isFirstTime)
				    p1.Kill();
			}
			catch
			{
			}
		}

		/// <summary>
		/// Sets properties to customize the ChartControl's appearance
		/// </summary>
		protected void InitializeChartAppearance()
		{			
			this.chartControlTrends.PrimaryXAxis.ValueType = ChartValueType.DateTime;
			this.chartControlTrends.PrimaryXAxis.GridLineType.ForeColor = Color.FromArgb(100,255,0,0);
			this.chartControlTrends.PrimaryYAxis.GridLineType.ForeColor = Color.FromArgb(100,255,0,0);
			this.chartControlTrends.Font = this.dateTimePickerStart.Font;
			this.chartControlTrends.PrimaryXAxis.Font = this.dateTimePickerStart.Font;
			this.chartControlTrends.PrimaryYAxis.Font = this.dateTimePickerStart.Font;
			//this.chartControlTrends.PrimaryXAxis.LabelIntersectAction = ChartLabelIntersectAction.MultipleRows;
			//this.chartControlTrends.PrimaryXAxis.IntervalType = ChartDateTimeIntervalType.Auto;
			//this.chartControlTrends.PrimaryXAxis.CustomOrigin = true;
			//this.chartControlTrends.PrimaryXAxis.OriginDate = dateTimePickerStart.Value;
			//this.chartControlTrends.PrimaryXAxis.DateTimeFormat = "MM/dd/yyyy hh:mm:ss";
			//this.chartControlTrends.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(dateTimePickerStart.Value,dateTimePickerEnd.Value, 1, ChartDateTimeIntervalType.Minutes);
		}

		#endregion

		#region Event Handlers

        private void HistTrends_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (_lrrApp.LRRUIManagerObj._windowStore.ContainsKey(150))
                (_lrrApp.LRRUIManagerObj._windowStore[150] as Form).Activate();
        }

		private void buttonReload_Click(object sender, System.EventArgs e)
		{
			try
			{
				LoadChart();
			}
			catch
			{

			}
		}

		private void HistTrends_Resize(object sender, EventArgs e)
		{
			try
			{
				this.panelDateTime.Location = new System.Drawing.Point(((this.Width - this.panelDateTime.Width)/2)>0 ? ((this.Width - this.panelDateTime.Width)/2): 0,((this.panelDateTimeContainer.Height - this.panelDateTime.Height)/2)>0 ? ((this.panelDateTimeContainer.Height - this.panelDateTime.Height)/2): 0);
				if(dateTimePickerStart.Value < dateTimePickerEnd.Value)
				{
					if(((_ts.TotalDays * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrends.PrimaryXAxis.Size.Width)))/(this.chartControlTrends.PrimaryXAxis.Size.Width * Screen.PrimaryScreen.Bounds.Width)) < 17)
						this.chartControlTrends.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(dateTimePickerStart.Value,dateTimePickerEnd.Value, Math.Max((_ts.TotalMilliseconds * 4.5 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrends.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrends.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
					else
						this.chartControlTrends.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(dateTimePickerStart.Value,dateTimePickerEnd.Value, Math.Max((_ts.TotalMilliseconds * 2.25 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrends.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrends.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
				}
			}
			catch
			{

			}
		}

		private void chartControlTrends_ChartFormatAxisLabelEventHandler(object sender,ChartFormatAxisLabelEventArgs args )
		{
			if(args.IsAxisPrimary)
			{
				if(((_ts.TotalDays * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrends.PrimaryXAxis.Size.Width)))/(this.chartControlTrends.PrimaryXAxis.Size.Width * Screen.PrimaryScreen.Bounds.Width)) < 17)
					args.Label = args.ValueAsDate.ToString("M/d/yy HH:mm:ss");
				else
					args.Label = args.ValueAsDate.ToString("M/d/yy");
				args.Handled = true;
			}
		}

		/// <summary>
		/// Handler for the PrepareStyle event of ChartSeries. 
		/// </summary>
		/// <param name="sender">The ChartSeries object that raises this event.</param>
		/// <param name="args">The event data. Can be modified to change series appearance.</param>
		protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
			if(series != null)
			{
				args.Style.Symbol.Shape = ChartSymbolShape.Diamond;
				args.Style.Symbol.Size = new Size(5,5);
				args.Style.Symbol.Color = Color.DarkCyan;
				args.Style.DisplayShadow = true;
				args.Style.ToolTip = "Start Time: " + series.Points[args.Index].DateX.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "\nAverage Value: " + series.Points[args.Index].YValues[0];
				args.Handled = true;
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void Refresh()
		{
			try
			{
				LoadChart();
			}
			catch
			{

			}
		}

		public void Save()
		{
			if(this.chartControlTrends.Series.Count > 0)
			{
				if(_seriesType != this.chartControlTrends.Series[0].Type)
				{
					_seriesType = this.chartControlTrends.Series[0].Type;
					LRRMessagBox.ShowMessage("SID_SAVEDINFO",true); 
					return;
				}
			}
			
			LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add HistTrends.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add HistTrends.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add HistTrends.Copy implementation
		}

		public void Print()
		{
			//chartControlTrends.PrintDocument.Print();
			// TODO:  Add HistTrends.Print implementation
		}

		public void PrintPreview()
		{
			// TODO:  Add HistTrends.PrintPreview implementation
		}

		public void PageSetup()
		{
//			GridGroupingPrint ggPrint = new GridGroupingPrint();
//			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add HistTrends.Undo implementation
		}

		public void Delete()
		{
			// TODO:  Add HistTrends.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add HistTrends.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add HistTrends.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add HistTrends.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add HistTrends.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add HistTrends.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add HistTrends.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add HistTrends.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add HistTrends.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add HistTrends.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add HistTrends.DownLevel implementation
		}

		public void ClearSort()
		{
			// TODO:  Add HistTrends.ClearSort implementation
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add HistTrends.CopyUOMTypes implementation
		}

		public void ShowPropertyList()
		{
			// TODO:  Add HistTrends.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add HistTrends.ShowComponentList implementation
		}

		public void LeftColMovement()
		{
			// TODO:  Add HistTrends.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add HistTrends.RightColMovement implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add HistTrends.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add HistTrends.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add HistTrends.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add HistTrends.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add HistTrends.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add HistTrends.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add HistTrends.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add HistTrends.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add HistTrends.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add HistTrends.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add HistTrends.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add HistTrends.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add HistTrends.SupportsLevel implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add HistTrends.SupportsClearSort implementation
			return false;
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add HistTrends.SupportsCopyUOMTypes implementation
			return false;
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add HistTrends.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add HistTrends.SupportsPageSetup implementation
			return false;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add HistTrends.SupportsUndo implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			get
			{
				return _parentTabControl;
			}
			set
			{
				_parentTabControl = value;
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				return _parentTabPage;
			}
			set
			{
				_parentTabPage = value;
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add HistTrends.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add HistTrends.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add HistTrends.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add HistTrends.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add HistTrends.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add HistTrends.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add HistTrends.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add HistTrends.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add HistTrends.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private void HistTrends_Load(object sender, System.EventArgs e)
		{
            _parentTabPage.Text = this.Text;
            

            //// Activate Mainframe so that another application is not activated.
            //_lrrApp.MainFrame.Activate();

            if (!_showAllTrends)
            {
                this.dateTimePickerStart.Value = HistTrendsDialog.startTime;
                this.dateTimePickerEnd.Value = HistTrendsDialog.endTime;
                this.Text = "Hist Trend: " + _histTag;
                _parentTabPage.Text = this.Text;
            }
            else
            {
                panelDateTimeContainer.Dock = DockStyle.None;
                panelDateTimeContainer.Hide();
                this.Text = LRRHeaderText.GetHeaderString("SID_HISTTRENDTUNING") + _histTag;
                //_showAllTrends = true;
                _parentTabPage.Text = LRRHeaderText.GetHeaderString("SID_HISTTRENDALL") + _histTag;
            }

			

            ////_tuningHistorian.PrepareCollection(this.dateTimePickerStart.Value.ToString(),this.dateTimePickerEnd.Value.ToString(),_histTag);
            //if (_showAllTrends)
            //{
            //    _tuningHistorian.PrepareCollection(_histTag);
            //}
            //else
            //{
            //    _tuningHistorian.PrepareCollection(dateTimePickerStart.Value.ToString(), dateTimePickerEnd.Value.ToString(), _histTag);
            //}
			
            //try
            //{
            //    LoadChart();
            //    if(_isTagPresent)
            //    {
            //        EnableDisableBarItems();
            //        _isTagPresent = false;
            //    }
            //}
            //catch
            //{

            //}
		}

		private void HistTagChangedPlusLoad()
		{
			HistTagChanged();
			this.HistTrends_Load(this, new EventArgs());
            this.LoadChart();
		}

		private void HistTagChanged()
		{
			_histTag = _arrHistTags[_currentIndex] as string;
			

			string newTag = "";
			if(_showAllTrends)
				newTag = "HistTrend(All):" + _histTag;
			else
				newTag = "HistTrend:" + _histTag;

			if(_lrrApp.LRRUIManagerObj._windowStore.Contains(newTag))
			{
				_currentIndex = _lastIndex;
				_histTag = _arrHistTags[_currentIndex] as string;
				ILRRUIContainer cont = _lrrApp.LRRUIManagerObj._windowStore[newTag] as ILRRUIContainer;
				cont.Refresh();
				Form frm = cont as Form;
				frm.Activate();
			}
			else
			{
				_lrrApp.LRRUIManagerObj._windowStore.Remove(this.Tag);
				this.Tag = newTag;
				_lrrApp.LRRUIManagerObj._windowStore.Add(newTag,this);
				comboBoxBarItem1.TextBoxValue = _histTag;
				
				EnableDisableBarItems();

			}

			

			
		}

		private void EnableDisableBarItems()
		{
			if(_currentIndex <= 0)
			{
				barItem1.Enabled = false;
				barItem2.Enabled = false;
				if(_currentIndex < 0)
					_currentIndex = 0;
			}
			else
			{
				barItem1.Enabled = true;
				barItem2.Enabled = true;
			}
			if(_currentIndex >= (_arrHistTags.Count-1))
			{
				barItem3.Enabled = false;
				barItem4.Enabled = false;
				if(_currentIndex > (_arrHistTags.Count-1))
					_currentIndex = (_arrHistTags.Count-1);
			}
			else
			{
				barItem3.Enabled = true;
				barItem4.Enabled = true;
			}
		}

		private void barItem1_Click(object sender, System.EventArgs e)
		{
			_lastIndex = _currentIndex;
			_currentIndex = 0;
			HistTagChangedPlusLoad();
		}

		private void barItem2_Click(object sender, System.EventArgs e)
		{
			_lastIndex = _currentIndex;
			_currentIndex -= 1;
			HistTagChangedPlusLoad();
		}

		private void barItem3_Click(object sender, System.EventArgs e)
		{
			_lastIndex = _currentIndex;
			_currentIndex +=1;
			HistTagChangedPlusLoad();
		}

		private void barItem4_Click(object sender, System.EventArgs e)
		{
			_lastIndex = _currentIndex;
			_currentIndex = _arrHistTags.Count - 1;
			HistTagChangedPlusLoad();
		}

		private void comboBoxBarItem1_Click(object sender, System.EventArgs e)
		{
			if(comboBoxBarItem1.TextBoxValue != "")
			{
				string selectedTag = comboBoxBarItem1.TextBoxValue;
				if(!selectedTag.Equals(_histTag))
				{
					_lastIndex = _currentIndex;
					_currentIndex = comboBoxBarItem1.ChoiceList.IndexOf(selectedTag);
					HistTagChangedPlusLoad();
				}
			}
		}
		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add HistTrends.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
