using System;
using System.Windows.Forms;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ILRRUI.
	/// </summary>
	public interface ILRRUIContainer
	{
		void Refresh(); //Method to Refresh the User Interface form..
		void Save(); //Method to save the contents of the form...
		void CopyMasterProperties();
		void Paste();
		void Copy();
		void Print();
		void PrintPreview();
		void PageSetup();
		void Undo();
		void Delete();
		void ArrangeColumns();
		void ClearFilter();
		void InsertNewRows(); //Inserts New rows 
		void ImportToExcel();
		void Export();
		void SelectionPaste();
		void RightLevel();
		void LeftLevel();
		void UpLevel();
		void DownLevel();
		void ClearSort();
		void CopyUOMTypes();
		void ShowPropertyList();
		void ShowComponentList();
		void LeftColMovement();
		void RightColMovement();
		void OpenCompositeView();
		void TransposeView();
		void OpenQuery();
		void OpenView();
		bool PerformDirtyChk
		{
			get;
		}

		//Methods Suported
		bool SupportsMasterPropertiesCopy();
		bool SupportsCopy();
		bool SupportsPaste();
		bool SupportsExport();
		bool SupportsSave();
		bool SupportsRefresh();
		bool SupportsDelete();
		bool SupportsPrint();
		bool SupportsArrangeColumns();
		bool SupportsClearFilter();
		bool SupportsInsertNewRows(); 
		bool SupportsImportToExcel();
		bool SupportsSelectionPaste();
		bool SupportsLevel();
		bool SupportsClearSort();
		bool SupportsCopyUOMTypes();
		bool SupportsResultsFilter();
		bool SupportsCompositeView();
		bool SupportsPageSetup();
		bool SupportsUndo();
		
		TabControl	ParentTabControl{set;get;}
		TabPage     ParentTabPage{set;get;}
		
	}
}
