using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.PEAdvisor;
using Symcon.Utils.MessageDispatcher;
using Symcon.Globals.Enums;

namespace Symcon.LightRidge.PEAdvisor.IOScreen
{
	/// <summary>
	/// Summary description for QueryListView.
	/// </summary>
	public class QueryListView : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnAddQuery;
		private System.Windows.Forms.Panel pnlTop;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.TreeView trvSearchLevels;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem mnuRemove;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public QueryListView()
		{
			InitializeComponent();
		}

		public QueryListView(Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem barQuery,Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager)
		{
			InitializeComponent();
			
			_barQuery = barQuery;
			_mainFrameBarManager = mainFrameBarManager;
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			if(_lrrSearchCriterias.Count == 0)
			{
				btnAddQuery.Enabled = false;
			}
			else
			{
				btnAddQuery.Enabled = true;
			}
			PopulateTreeView(trvSearchLevels,_lrrSearchGroupLevels,_lrrSearchGroupLevelLinks);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(QueryListView));
			this.btnAddQuery = new System.Windows.Forms.Button();
			this.pnlTop = new System.Windows.Forms.Panel();
			this.trvSearchLevels = new System.Windows.Forms.TreeView();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.mnuRemove = new System.Windows.Forms.MenuItem();
			this.pnlTop.SuspendLayout();
			this.pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnAddQuery
			// 
			this.btnAddQuery.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnAddQuery.Location = new System.Drawing.Point(48, 8);
			this.btnAddQuery.Name = "btnAddQuery";
			this.btnAddQuery.Size = new System.Drawing.Size(160, 24);
			this.btnAddQuery.TabIndex = 1;
			this.btnAddQuery.Text = "Add/Update Active Query List";
			this.btnAddQuery.Click += new System.EventHandler(this.btnAddQuery_Click);
			// 
			// pnlTop
			// 
			this.pnlTop.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlTop.Controls.Add(this.trvSearchLevels);
			this.pnlTop.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlTop.Location = new System.Drawing.Point(0, 0);
			this.pnlTop.Name = "pnlTop";
			this.pnlTop.Size = new System.Drawing.Size(266, 336);
			this.pnlTop.TabIndex = 2;
			// 
			// trvSearchLevels
			// 
			this.trvSearchLevels.CheckBoxes = true;
			this.trvSearchLevels.ContextMenu = this.contextMenu1;
			this.trvSearchLevels.Dock = System.Windows.Forms.DockStyle.Fill;
			this.trvSearchLevels.ImageIndex = -1;
			this.trvSearchLevels.Location = new System.Drawing.Point(0, 0);
			this.trvSearchLevels.Name = "trvSearchLevels";
			this.trvSearchLevels.SelectedImageIndex = -1;
			this.trvSearchLevels.Size = new System.Drawing.Size(264, 334);
			this.trvSearchLevels.TabIndex = 0;
			this.trvSearchLevels.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.trvSearchLevels_AfterCheck);
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.btnAddQuery);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 336);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(266, 48);
			this.pnlBottom.TabIndex = 3;
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.mnuRemove});
			this.contextMenu1.Popup += new System.EventHandler(this.contextMenu1_Popup);
			// 
			// mnuRemove
			// 
			this.mnuRemove.Index = 0;
			this.mnuRemove.Text = "Remove";
			this.mnuRemove.Click += new System.EventHandler(this.mnuRemove_Click);
			// 
			// QueryListView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(266, 384);
			this.Controls.Add(this.pnlBottom);
			this.Controls.Add(this.pnlTop);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "QueryListView";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "QueryListView";
			this.pnlTop.ResumeLayout(false);
			this.pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields
		private LRRApp _lrrApp = null;
		private LRRSearchCriterias _lrrSearchCriterias = null;
		private LRRSearchCriteriaQualifiers _LRRSearchCriteriaQualifiers = null;
		private LRRSearchCriteriaPropertyTypes _lrrSearchCriteriaPropertyTypes = null;
		private LRRPropertyTypes	_objPropertyTypes = null;
		private LRRSiteComponents _lrrSiteComponents = null;

		private LRRSearchGroupLevels	_lrrSearchGroupLevels=null; //Levels Object
		private LRRSearchGroupLevelLinks	_lrrSearchGroupLevelLinks = null; //Level Links object

		//Property Window
		private ResultPropertiesWindow _rsProperties;

		//Property Window
		private ResultPropertiesWindow _rsComponents;

		//		private LRRSiteComponentProperties _lrrSiteComponentProperties = null;
		private GridPersistanceUtil		_gutil = new GridPersistanceUtil();
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem _barQuery = null;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager _mainFrameBarManager = null;
		#endregion

		#region Public Properties
		
		public LRRSearchCriterias LRRSearchCriteriasObj
		{
			get { return _lrrSearchCriterias; }
		}

		#endregion

		#region Methods
		
		/// <summary>
		/// Initialize the dataSource from db
		/// </summary>
		private void InitDataSource()
		{
//			if(_lrrSearchCriterias != null)
//				_lrrSearchCriterias.Clear();
			if(_lrrSearchCriteriaPropertyTypes != null)
				_lrrSearchCriteriaPropertyTypes.Clear();
			if(_LRRSearchCriteriaQualifiers != null)
				_LRRSearchCriteriaQualifiers.Clear();

			if(_lrrSiteComponents != null)
				_lrrSiteComponents.Clear();
			if(_objPropertyTypes != null)
				_objPropertyTypes.Clear();

			_lrrSearchCriterias = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriasWithoutNewQuery();//new LRRSearchCriterias();
			_lrrSearchCriteriaPropertyTypes = new LRRSearchCriteriaPropertyTypes();
			_LRRSearchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();

			_objPropertyTypes = new LRRPropertyTypes();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchCriteriaPropertyTypes,false);
			_lrrApp.DBManagerObj.PopulateCollection(_LRRSearchCriteriaQualifiers,false);
			_lrrApp.DBManagerObj.PopulateCollection(_objPropertyTypes,false);

			_lrrSiteComponents = new LRRSiteComponents();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSiteComponents,false);

			//Initialize and populate the levels
			_lrrSearchGroupLevels = new LRRSearchGroupLevels();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchGroupLevels);
			//Initialize and populate the level links
			_lrrSearchGroupLevelLinks = new LRRSearchGroupLevelLinks();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchGroupLevelLinks);
		}
		
		/// <summary>
		/// Populate Groups and queries
		/// </summary>
		/// <returns></returns>
		public bool PopulateBarItems()
		{
			try
			{
				Hashtable				_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRSearchGroupLevel l in _lrrSearchGroupLevels)
				{
					_levelHash.Add(l.LevelID,l);
				}
				foreach(LRRSearchGroupLevelLink ll in _lrrSearchGroupLevelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						ParentBarItem foundItem = _nodesHash[ll.ParentID] as ParentBarItem;
						LRRSearchGroupLevel foundLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel; 
						ParentBarItem childBarItem = new ParentBarItem(foundLevel.Name);
						childBarItem.Tag = foundLevel;
						foundItem.Items.Add(childBarItem);
						_mainFrameBarManager.Items.Add(childBarItem);

						//Add the Queries
						AddQueries(foundLevel.LevelID,childBarItem);
						
						//Add the Graphics
						AddGraphics(foundLevel.LevelID,childBarItem);
					}
					else
					{
						LRRSearchGroupLevel parentLevel = _levelHash[ll.ParentID] as LRRSearchGroupLevel;
						LRRSearchGroupLevel childLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel;
						ParentBarItem parentItem = new ParentBarItem(parentLevel.Name);
						parentItem.Tag = parentLevel;
						_mainFrameBarManager.Items.Add(parentItem);

						//Add the Queries
						AddQueries(parentLevel.LevelID,parentItem);

						//Add the Graphics
						AddGraphics(parentLevel.LevelID,parentItem);

						ParentBarItem childBarItem = new ParentBarItem(childLevel.Name);
						childBarItem.Tag = childLevel;
						parentItem.Items.Add(childBarItem);
						_mainFrameBarManager.Items.Add(childBarItem);

						//Add the Queries
						AddQueries(childLevel.LevelID,childBarItem);

						//Add the Graphics
						AddGraphics(childLevel.LevelID,childBarItem);

						_nodesHash.Add(ll.ParentID,parentItem);

					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					ParentBarItem  childBarItem = null;
					ParentBarItem  parentBarItem = null;

					if(_nodesHash.ContainsKey(childID))
					{
						childBarItem = _nodesHash[childID] as ParentBarItem;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentBarItem = _nodesHash[parentID] as ParentBarItem;
					}
					if((parentBarItem != null) && (childBarItem != null))
					{
						int index = -1;
						int i = 0;
						foreach(ParentBarItem item in parentBarItem.Items)
						{
							if(item.Tag == childBarItem.Tag)
							{
								index = i;
								break;
							}
							i++;
						}
						if(index != -1)
							parentBarItem.Items[index] = childBarItem;
					}
				}

				ParentBarItem rootBarItem = _nodesHash["0"] as ParentBarItem;
				_barQuery.Items.Add(rootBarItem);
				_mainFrameBarManager.Items.Add(rootBarItem);

				return true;

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(QueryListView),"PopulateBarItems:"+ex.Message  ,Logger.Level.Debug);
				return false;
			}
		}
		
		private void AddQueries(string levelID,ParentBarItem childBarItem)
		{
			LRRSearchCriterias lrrSrchCriterias = _lrrSearchCriterias.GetSearchCriteriasByGroupID(levelID);
			foreach(LRRSearchCriteria lrrSrchCriteria in lrrSrchCriterias)
			{
				if(lrrSrchCriteria.IsSelected)
				{
					BarItem barItemQuery = new BarItem();
					barItemQuery.Text = lrrSrchCriteria.Name;
					barItemQuery.ID = lrrSrchCriteria.ID;
					barItemQuery.Tag = lrrSrchCriteria;
					barItemQuery.ImageList = _lrrApp.MainFrame.SmallImageList;
					barItemQuery.ImageIndex = 94;
					barItemQuery.Click+=new EventHandler(barItemQuery_Click);
					childBarItem.Items.Add(barItemQuery);
					_mainFrameBarManager.Items.Add(barItemQuery);
				}
			}
		}

		private void AddGraphics(string levelID,ParentBarItem childBarItem)
		{
			LRRSavedViews lrrSavedViews = LRRModel.SavedViews.GetSavedViewsByGroupID(levelID);
			foreach(LRRSavedView lrrSavedView in lrrSavedViews)
			{
				if(lrrSavedView.IsSelected)
				{
					BarItem barItemQuery = new BarItem();
					barItemQuery.Text = lrrSavedView.SavedViewName;
					barItemQuery.ID = lrrSavedView.ID;
					barItemQuery.Tag = lrrSavedView;
					barItemQuery.ImageList = _lrrApp.MainFrame.SmallImageList;
					barItemQuery.ImageIndex = 92;
					barItemQuery.Click+=new EventHandler(barItemQuery_Click);
					childBarItem.Items.Add(barItemQuery);
					_mainFrameBarManager.Items.Add(barItemQuery);
				}
			}
		}
		
		/// <summary>
		/// Populate the tree View with groups and queries
		/// </summary>
		/// <param name="treeView"></param>
		/// <param name="levels"></param>
		/// <param name="levelLinks"></param>
		/// <returns></returns>
		private bool PopulateTreeView(TreeView treeView,LRRSearchGroupLevels levels,LRRSearchGroupLevelLinks levelLinks)
		{
			trvSearchLevels.Nodes.Clear();
			trvSearchLevels.ImageList = _lrrApp.MainFrame.SmallImageList;
			try
			{
				Hashtable				_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRSearchGroupLevel l in levels)
				{
					_levelHash.Add(l.LevelID,l);
				}
				foreach(LRRSearchGroupLevelLink ll in levelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						TreeNode foundNode = _nodesHash[ll.ParentID] as TreeNode;
						LRRSearchGroupLevel foundLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel; 
						TreeNode childNode = new TreeNode(foundLevel.Name);
						childNode.Tag = foundLevel;
						foundNode.Nodes.Add(childNode);
						
						//Add Query Tree Node
						AddQueryTreeNode(foundLevel.LevelID,childNode);

						//Add Graphics Tree Node
						AddGraphicsTreeNode(foundLevel.LevelID,childNode);
					}
					else
					{
						LRRSearchGroupLevel parentLevel = _levelHash[ll.ParentID] as LRRSearchGroupLevel;
						LRRSearchGroupLevel childLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel;
						TreeNode parentNode = new TreeNode(parentLevel.Name);
						parentNode.Tag = parentLevel;
						
						//Add Query Tree Node
						AddQueryTreeNode(parentLevel.LevelID,parentNode);

						//Add Graphics Tree Node
						AddGraphicsTreeNode(parentLevel.LevelID,parentNode);

						TreeNode childNode = new TreeNode(childLevel.Name);
						childNode.Tag = childLevel;
						parentNode.Nodes.Add(childNode);
						
						//Add Query Tree Node
						AddQueryTreeNode(childLevel.LevelID,childNode);

						//Add Graphics Tree Node
						AddGraphicsTreeNode(childLevel.LevelID,childNode);

						_nodesHash.Add(ll.ParentID,parentNode);
					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					TreeNode  childNode = null;
					TreeNode  parentNode = null;
					if(_nodesHash.ContainsKey(childID))
					{
						childNode = _nodesHash[childID] as TreeNode;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentNode = _nodesHash[parentID] as TreeNode;
					}
					if((parentNode != null) && (childNode != null))
					{
						int index = -1;
						foreach(TreeNode f in parentNode.Nodes)
						{
							if(f.Tag == childNode.Tag)
							{
								index = f.Index;
								break;
							}
						}
						if(index != -1)
							parentNode.Nodes[index] = childNode;
					}
				}

				TreeNode rootNode = _nodesHash["0"] as TreeNode;
				trvSearchLevels.Nodes.Add(rootNode);
				trvSearchLevels.Nodes[0].Expand();
				return true;

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(QueryListView),"PopulateTreeView:"+ex.Message  ,Logger.Level.Debug);
				return false;
			}
		}
		
		private void AddQueryTreeNode(string levelID,TreeNode trvNode)
		{
			LRRSearchCriterias lrrSrchCriterias = _lrrSearchCriterias.GetSearchCriteriasByGroupID(levelID);
			foreach(LRRSearchCriteria lrrSrchCriteria in lrrSrchCriterias)
			{
				TreeNode queryNode = new TreeNode(lrrSrchCriteria.Name);

				//Create List Item Object
				ListItem listItem = new ListItem();
				listItem.ListItemType = "Query";
				listItem.ListItemObject = lrrSrchCriteria;

				queryNode.Tag = listItem;
				queryNode.Checked = lrrSrchCriteria.IsSelected;
				queryNode.ImageIndex = 94;
				trvNode.Nodes.Add(queryNode);
			}
		}

		private void AddGraphicsTreeNode(string levelID,TreeNode trvNode)
		{
			LRRSavedViews lrrSavedViews = LRRModel.SavedViews.GetSavedViewsByGroupID(levelID);
			foreach(LRRSavedView lrrSavedView in lrrSavedViews)
			{
				TreeNode queryNode = new TreeNode(lrrSavedView.SavedViewName);

				//Create List Item Object
				ListItem listItem = new ListItem();
				listItem.ListItemType = "Graphics";
				listItem.ListItemObject = lrrSavedView;

				queryNode.Tag = listItem;
				queryNode.Checked = lrrSavedView.IsSelected;
				queryNode.ImageIndex = 92;
				trvNode.Nodes.Add(queryNode);
			}
		}
		/// <summary>
		/// Remove the queries for a given group
		/// </summary>
		/// <param name="levelID"></param>
		private void RemoveQueries(string levelID)
		{
			ArrayList arrQueries = new ArrayList();
			foreach(LRRSearchCriteria srchCriteria in _lrrSearchCriterias)
			{
				if(srchCriteria.GroupID == levelID)
				{
					arrQueries.Add(srchCriteria);
				}
			}
			for(int i=0;i < arrQueries.Count;i++)
			{
				LRRSearchCriteria srchCriteria =  arrQueries[i] as LRRSearchCriteria;
				srchCriteria.ObjectState = DBOperation.DELETE;
				_lrrSearchCriterias.Remove(srchCriteria);
				_lrrApp.DBManagerObj.CommitObject(srchCriteria);
			}
		}


		/// <summary>
		/// Get all the childs of a given group
		/// </summary>
		/// <param name="parentLevelID"></param>
		/// <returns></returns>
		private ArrayList GetAllChildLevels(string parentLevelID)
		{
			try
			{
				ArrayList arlist = new ArrayList(); //To Return araylist
				Queue q = new Queue(); //Temp object for getting childrens
				q.Enqueue(parentLevelID);
				while(q.Count > 0)
				{
					string levelID = (string)q.Dequeue();
					arlist.Add(levelID);
					foreach(LRRSearchGroupLevelLink levelLink in _lrrSearchGroupLevelLinks)
					{
						if(levelLink.ParentID == levelID)
						{
							q.Enqueue(levelLink.ChildID);
						}
					}
				}
				return arlist;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(QueryListView),"GetAllChildLevels:"+ex.Message  ,Logger.Level.Debug);
				return null;
			}
		}
		#endregion
		
		#region Event Handlers
		private void btnAddQuery_Click(object sender, System.EventArgs e)
		{
//			bool isAdded = false;
			ArrayList arrItemsToRemove = new ArrayList();
			for(int i=0;i < _barQuery.Items.Count;i++)
			{
				arrItemsToRemove.Add(_barQuery.Items[i]);
			}
			for(int k=0; k < arrItemsToRemove.Count;k++)
			{
				BarItem barItem = arrItemsToRemove[k] as BarItem;
				_barQuery.Items.Remove(barItem);
				_mainFrameBarManager.Items.Remove(barItem);
			}

			PopulateBarItems();
//			if(isAdded)
				LRRMessagBox.ShowMessage("SID_UPDATED_QUERYLIST","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
		}

		public void barItemQuery_Click(object sender, EventArgs e)
		{
			_rsProperties = new ResultPropertiesWindow();
			_rsComponents = new ResultPropertiesWindow();

			Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemQuery = sender as Syncfusion.Windows.Forms.Tools.XPMenus.BarItem;
//			string searchCriteriaID = barItemQuery.ID;
			LRRSearchCriteria lrrSrchCriteria = barItemQuery.Tag as LRRSearchCriteria;
			string searchCriteriaID = lrrSrchCriteria.ID;

			LRRModes lrrModes = LRRModel.ProjectModes;
			SearchRetrievalUtility searchUtil = new SearchRetrievalUtility();
			LRRSiteComponents lrrSiteComponents = searchUtil.PopulateSiteComponents(searchCriteriaID);
		
			//Aggregates
			LRRAggregates lrrResultAggregates = searchUtil.PopulateAggregates(searchCriteriaID);

			LRRSearchCriteria lrrSearchCriteria =  _lrrSearchCriterias.GetSearchCriteriaByID(searchCriteriaID);
			
			string sSource = lrrSearchCriteria.Source == null ? "" : lrrSearchCriteria.Source.ToString();
			if(sSource == "I/O")
			{
				string templateClass = lrrSearchCriteria.TemplateClass; 
				switch(templateClass)
				{
					case "Symcon.LightRidge.PEAdvisor.GridSimpleView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController";
						break;
					case "Symcon.LightRidge.PEAdvisor.GridTransposedView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController";
						break;
					case "Symcon.LightRidge.PEAdvisor.GridSimpleGroupedModeView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleGroupedModeViewController";
						break;
					case "Symcon.LightRidge.PEAdvisor.GridTransposedGroupedModeView":
						templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedGroupedModeViewController";
						break;
					default :
						templateClass = templateClass;
						break;
				}
				
				Type gridType = Type.GetType(templateClass);
				object gridView = Activator.CreateInstance(gridType);
				GridView = gridView;
				IGridFactory objGrid = gridView as IGridFactory;

				ArrayList custCollection = new ArrayList();
				custCollection.Add(lrrSiteComponents);
				custCollection.Add(lrrResultAggregates);
				objGrid.SearchQuery.SearchQuery.SizeXml = lrrSearchCriteria.SizeXml;
				objGrid.LoadPanel(custCollection);
				
				LRRResultProperties resultProperties = SearchRetrievalUtility.ShowPropertiesWindow(lrrSiteComponents,lrrResultAggregates);
				_rsProperties.PropertyCollection = resultProperties;
				_rsProperties.Text = "Result Properties Window";
				_rsProperties.BindGrid();

				//Show the Component List Form
				LRRResultProperties resultComponents = SearchRetrievalUtility.ShowComponents(lrrSiteComponents,lrrResultAggregates);
				_rsComponents.PropertyCollection = resultComponents;
				_rsComponents.Text = "Result Components Window";
				_rsComponents.BindGrid();

				ArrayList arrParams = new ArrayList();
				arrParams.Add(objGrid);
				arrParams.Add(_rsProperties);
				arrParams.Add(_rsComponents);

				_lrrApp.LRRUIManagerObj.ShowWindow(250,arrParams,lrrSearchCriteria.Name,true);
			}
			else
			{
				Type gridType = Type.GetType(lrrSearchCriteria.TemplateClass);
				object gridView = Activator.CreateInstance(gridType);
				GridView = gridView;
				Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory objGrid = gridView as Symcon.LightRidge.PEAdvisor.GroupProperties.IGroupGridFactory;

				LRRLookUpQualifiers objLookUpQualifiers = new LRRLookUpQualifiers();
				LRRSiteComponents objModelComponent = LRRModel.SiteComponentsObj;
				LRRSiteComponents objSiteCompCollection	 = new LRRSiteComponents();
				string qualIDs = "";
				
				LRRSearchCriteriaQualifiers lrrSrchCriteriaQualifiers = new LRRSearchCriteriaQualifiers();
				_lrrApp.DBManagerObj.PopulateCollection(lrrSrchCriteriaQualifiers,false);
				LRRSearchCriteriaQualifiers lrrSrchCriteriaQuals = lrrSrchCriteriaQualifiers.FilterBySearchCriteriaID(searchCriteriaID); 
				foreach(LRRSearchCriteriaQualifier lrrSearchCriteriaQual in lrrSrchCriteriaQuals)
				{
					if( qualIDs=="")
					{
						qualIDs="'" + lrrSearchCriteriaQual.QualifierID + "'";
					}
					else
						qualIDs=qualIDs + ",'" + lrrSearchCriteriaQual.QualifierID + "'";
				
				}

				_lrrApp.DBManagerObj.PopulateCollection(objLookUpQualifiers," WHERE LookupQualifierID IN (" + qualIDs + ")",false);
				foreach(LRRSiteComponent objSiteComponent in lrrSiteComponents)
				{
					LRRSiteComponent objModelSiteComponent = objModelComponent.GetSiteComponentByID(objSiteComponent.SiteComponentID);
					objSiteCompCollection.Add(objModelSiteComponent);
				}
				
				ArrayList custCollection = new ArrayList();
				custCollection.Add(objSiteCompCollection);
				custCollection.Add(objLookUpQualifiers);
				objGrid.LoadPanel(custCollection);

				ArrayList arrParams = new ArrayList();
				arrParams.Add(gridView);
				//_lrrApp.LRRUIManagerObj.ShowWindow(301,arrParams);
				_lrrApp.LRRUIManagerObj.ShowWindow(301,arrParams,lrrSearchCriteria.Name,true);
			}
		}
	
		private object GridView
		{
			get { return _gridView;}
			set
			{
				_gridView = value;
			}
		}

		private object _gridView;

		private void trvSearchLevels_AfterCheck(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			TreeNode trvNode = e.Node;
			if(trvNode.Nodes != null && trvNode.Nodes.Count > 0)
			{
				GetAllChildNodes(trvNode);
			}
			else
			{
				CheckUncheckListItems(trvNode);
			}
		}

		private void GetAllChildNodes(TreeNode trvNode)
		{
			for(int i=0;i < trvNode.Nodes.Count;i++)
			{
				TreeNode trvChildNode = trvNode.Nodes[i];
				trvChildNode.Checked = trvNode.Checked;
				if(trvChildNode.Nodes != null && trvChildNode.Nodes.Count > 0)
				{
					GetAllChildNodes(trvChildNode);
				}
				else
				{
					CheckUncheckListItems(trvNode);
				}
			}
		}

		private void CheckUncheckListItems(TreeNode trvNode)
		{
			ListItem listItem = trvNode.Tag as ListItem;
			if(listItem != null)
			{
				//Queries
				if(listItem.ListItemType == "Query")
				{
					LRRSearchCriteria srchCriteria = listItem.ListItemObject as LRRSearchCriteria;
					if(srchCriteria != null)
						srchCriteria.IsSelected = trvNode.Checked;

				}
				//Graphics
				if(listItem.ListItemType == "Graphics")
				{
					LRRSavedView savedView = listItem.ListItemObject as LRRSavedView;
					if(savedView != null)
						savedView.IsSelected = trvNode.Checked;
				}
			}
		}

		private void mnuRemove_Click(object sender, System.EventArgs e)
		{
			TreeNode trvNode = trvSearchLevels.SelectedNode;
			if(trvNode.Nodes != null && trvNode.Nodes.Count > 0)
			{
				//DialogResult dlgRslt = MessageBox.Show(this, trvSearchLevels.SelectedNode.Text + " and all its sublevels will be deleted permanently." + '\n' + "Do you wish to continue?", this.Name, MessageBoxButtons.YesNo,MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2);
				string[] s = new string[1];
				s[0] = trvSearchLevels.SelectedNode.Text;
				DialogResult dlgRslt = LRRMessagBox.ShowMessage(this,"SID_DELETE_LEVEL_CONFIRM","SID_LABEL",s,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      
				if(dlgRslt == DialogResult.Yes)
				{
					LRRSearchGroupLevel lvl =  trvNode.Tag as LRRSearchGroupLevel;
					string id = lvl.LevelID;
					ArrayList alist = new ArrayList();
					alist = GetAllChildLevels(id);
					for(int i = 0; i< alist.Count;  i++)
					{
						string str = alist[i] as string;
						for(int j = _lrrSearchGroupLevels.Count - 1; j >=0;j--)
						{
							LRRSearchGroupLevel levl = _lrrSearchGroupLevels[j] as LRRSearchGroupLevel;
							if(levl.LevelID == str)
							{
								_lrrSearchGroupLevels.Remove(levl);
								RemoveQueries(levl.LevelID);
							}
							for(int k =_lrrSearchGroupLevelLinks.Count-1; k>=0;k--)
							{
								LRRSearchGroupLevelLink lvlLink = _lrrSearchGroupLevelLinks[k] as LRRSearchGroupLevelLink;
								if(lvlLink.ChildID == str)
									_lrrSearchGroupLevelLinks.Remove(lvlLink);
							}
						}
					}
					LRRSearchGroupLevels toCommitLevels = _lrrSearchGroupLevels.GetChanges();
					LRRSearchGroupLevelLinks toCommitLevelLinks = _lrrSearchGroupLevelLinks.GetChanges();
					_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
					_lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
					_lrrSearchGroupLevels.RefreshCollection();
					_lrrSearchGroupLevelLinks.RefreshCollection();
					_lrrSearchCriterias.RefreshCollection();
					trvSearchLevels.Nodes.Remove(trvSearchLevels.SelectedNode);
				}
				
			}
			else
			{
				//DialogResult dlgRslt = MessageBox.Show(this, trvSearchLevels.SelectedNode.Text + " will be deleted permanently." + '\n' + "Do you wish to continue?", this.Name, MessageBoxButtons.YesNo,MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2);
				string[] s = new string[1];
				s[0] = trvSearchLevels.SelectedNode.Text;
				DialogResult dlgRslt = LRRMessagBox.ShowMessage(this,"SID_DELETE_LEVEL_CONFIRM","SID_LABEL",s,MessageBoxButtons.YesNo,MessageBoxIcon.Warning,MessageBoxDefaultButton.Button2);      
				if(dlgRslt == DialogResult.Yes)
				{
					LRRSearchCriteria srchCriteria = trvNode.Tag as LRRSearchCriteria;
					if(srchCriteria != null)
					{
						_lrrSearchCriterias.Remove(srchCriteria);
						srchCriteria.ObjectState = DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(srchCriteria);
						_lrrSearchCriterias.RefreshCollection();
					}
					trvSearchLevels.Nodes.Remove(trvSearchLevels.SelectedNode);
				}
			}
		}



		private void contextMenu1_Popup(object sender, System.EventArgs e)
		{
			mnuRemove.Enabled = true;
			if(trvSearchLevels.Nodes.Count>0)
			{
				LRRSearchGroupLevel lvl =  trvSearchLevels.SelectedNode.Tag as LRRSearchGroupLevel;
				if(lvl != null && (lvl.LevelID == "0" || lvl.LevelID == "1" || lvl.LevelID == "2"))
					mnuRemove.Enabled = false;
			}
		}
		#endregion
	}
	
}