using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;

using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.HeaderDispatcher;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor.IOScreen
{
	/// <summary>
	/// Summary description for ResultPropertiesWindow.
	/// </summary>
	public class ResultComponentsWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlResultProperties;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridResultProperties;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Button btnApply;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridComponents;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ResultComponentsWindow(bool calledFromTrend)
		{
            _calledFromTrend = calledFromTrend;
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			gridComponents.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);   
			gridResultProperties.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ResultComponentsWindow));
			this.pnlResultProperties = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.gridComponents = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridResultProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnApply = new System.Windows.Forms.Button();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pnlResultProperties.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridComponents)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.gridResultProperties)).BeginInit();
			this.pnlBottom.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlResultProperties
			// 
			this.pnlResultProperties.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlResultProperties.Controls.Add(this.splitter1);
			this.pnlResultProperties.Controls.Add(this.gridComponents);
			this.pnlResultProperties.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlResultProperties.Location = new System.Drawing.Point(0, 0);
			this.pnlResultProperties.Name = "pnlResultProperties";
			this.pnlResultProperties.Size = new System.Drawing.Size(224, 134);
			this.pnlResultProperties.TabIndex = 0;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 129);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(222, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// gridComponents
			// 
			this.gridComponents.BackColor = System.Drawing.SystemColors.Window;
			this.gridComponents.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridComponents.Location = new System.Drawing.Point(0, 0);
			this.gridComponents.Name = "gridComponents";
			this.gridComponents.Size = new System.Drawing.Size(222, 132);
			this.gridComponents.TabIndex = 0;
			this.gridComponents.Text = "gridGroupingControl1";
			this.gridComponents.VersionInfo = "3.301.0.0";
			this.gridComponents.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridComponents_TableControlQueryAllowSortColumn);
			this.gridComponents.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridComponents_QueryCellStyleInfo);
			this.gridComponents.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridComponents_SaveCellText);
			// 
			// gridResultProperties
			// 
			this.gridResultProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridResultProperties.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridResultProperties.Location = new System.Drawing.Point(0, 0);
			this.gridResultProperties.Name = "gridResultProperties";
			this.gridResultProperties.Size = new System.Drawing.Size(245, 134);
			this.gridResultProperties.TabIndex = 0;
			this.gridResultProperties.Text = "gridGroupingControl1";
			this.gridResultProperties.VersionInfo = "3.301.0.0";
			this.gridResultProperties.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridResultProperties_TableControlQueryAllowSortColumn);
			this.gridResultProperties.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridResultProperties_QueryCellStyleInfo);
			this.gridResultProperties.SaveCellText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(this.gridResultProperties_SaveCellText);
			this.gridResultProperties.SizeChanged += new System.EventHandler(this.gridResultProperties_SizeChanged);
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.btnApply);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 134);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(472, 40);
			this.pnlBottom.TabIndex = 1;
			// 
			// btnApply
			// 
			this.btnApply.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnApply.Location = new System.Drawing.Point(376, 8);
			this.btnApply.Name = "btnApply";
			this.btnApply.Size = new System.Drawing.Size(80, 23);
			this.btnApply.TabIndex = 0;
			this.btnApply.Tag = "SID_APPLY";
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(224, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 134);
			this.splitter2.TabIndex = 2;
			this.splitter2.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.gridResultProperties);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(227, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(245, 134);
			this.panel1.TabIndex = 3;
			// 
			// ResultComponentsWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 174);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.pnlResultProperties);
			this.Controls.Add(this.pnlBottom);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "ResultComponentsWindow";
			this.ShowInTaskbar = false;
			this.pnlResultProperties.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridComponents)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.gridResultProperties)).EndInit();
			this.pnlBottom.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		public void BindGrid()
		{
			#region PropGrid
			int col1Width = 0;
			int col2Width = 0;
			if(gridResultProperties.TableDescriptor.Columns.Count == 2)
			{
				col1Width = gridResultProperties.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_SELECT")].Width;
				col2Width = gridResultProperties.TableDescriptor.Columns["Name"].Width;
			}
			//Suspend the Layout of the Grid...
			gridResultProperties.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridResultProperties);

			//Populate the columns for the grid object
            // changed by item type changed by ashwin for handling user specific recorded attributes
			//SyncGridUtilities.InitializeGridColumns(gridResultProperties,_lrrSiteCompProps.ItemType,null,true);
            SyncGridUtilities.InitializeGridColumns(gridResultProperties, LRRModel.UserSpecificRecordedProperties.ItemType, null, true);
			
			this.gridResultProperties.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridResultProperties.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridResultProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridResultProperties.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridResultProperties.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridResultProperties.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridResultProperties.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridResultProperties.TableDescriptor.AllowNew = false;
			this.gridResultProperties.TableDescriptor.AllowEdit = true;
			this.gridResultProperties.TableDescriptor.AllowRemove = false;

			this.gridResultProperties.SourceListSet.Add("Parent",_lrrSiteCompProps);

			this.gridResultProperties.TableDescriptor.Relations.Clear();
			this.gridResultProperties.DataSource = null;
			this.gridResultProperties.DataSource = PropertyCollection;

			this.gridResultProperties.TableDescriptor.Columns.Clear();
			
			_unBoundProp.WireGrid(gridResultProperties);

			
			GridColumnDescriptor gcd;
			GridTableCellStyleInfo gtcsi;
			gcd = new GridColumnDescriptor();
			gcd.HeaderText = "Name";
			gcd.MappingName = "Name";
			gcd.AllowFilter = true;
			gcd.Width = 250;

			gtcsi = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gtcsi.ReadOnly = true;

			this.gridResultProperties.TableDescriptor.Columns.Add(gcd);
			this.gridResultProperties.TableDescriptor.SortedColumns.Clear();
			this.gridResultProperties.TableDescriptor.SortedColumns.Add("Name",ListSortDirection.Ascending);

			if(col1Width > 0)
				gridResultProperties.TableDescriptor.Columns[0].Width = col1Width;
			if(col2Width > 0)
				gridResultProperties.TableDescriptor.Columns[1].Width = col2Width;
			gridResultProperties.ResumeLayout(true);
			
			#endregion

			#region CompGrid

			int Compcol1Width = 0;
			int Compcol2Width = 0;
			if(gridComponents.TableDescriptor.Columns.Count == 2)
			{
				Compcol1Width = gridComponents.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_SELECT")].Width;
				Compcol2Width = gridComponents.TableDescriptor.Columns["Name"].Width;
			}
			//Suspend the Layout of the Grid...
			gridComponents.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridComponents);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridComponents,_lrrSiteComponents.ItemType,null,true);
			
			this.gridComponents.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridComponents.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridComponents.BackColor = System.Drawing.SystemColors.Window;
			this.gridComponents.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridComponents.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridComponents.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridComponents.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridComponents.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_COMP") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridComponents.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridComponents.TableDescriptor.AllowNew = false;
			this.gridComponents.TableDescriptor.AllowEdit = true;
			this.gridComponents.TableDescriptor.AllowRemove = false;

			this.gridComponents.SourceListSet.Add("Parent",_lrrSiteComponents);

			this.gridComponents.TableDescriptor.Relations.Clear();
			this.gridComponents.DataSource = null;
			this.gridComponents.DataSource = SiteComponents;

			this.gridComponents.TableDescriptor.Columns.Clear();
			
			_unBoundComp.WireGrid(gridComponents);

			GridColumnDescriptor gcdComp;
			GridTableCellStyleInfo gtcsiComp;
			gcdComp = new GridColumnDescriptor();
			gcdComp.HeaderText = "Name";
			gcdComp.MappingName = "Name";
			gcdComp.AllowFilter = true;
			gcdComp.Width = 250;

			gtcsiComp = gcdComp.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gtcsiComp.ReadOnly = true;

			this.gridComponents.TableDescriptor.Columns.Add(gcdComp);
			this.gridComponents.TableDescriptor.SortedColumns.Clear();
			this.gridComponents.TableDescriptor.SortedColumns.Add("Name",ListSortDirection.Ascending);

			if(Compcol1Width > 0)
				gridComponents.TableDescriptor.Columns[0].Width = Compcol1Width;
			if(Compcol2Width > 0)
				gridComponents.TableDescriptor.Columns[1].Width = Compcol2Width;
			gridComponents.ResumeLayout(true);

			#endregion

		}

		protected override void OnClosing(CancelEventArgs e)
		{
			e.Cancel = true;
			_isWindowOpen = false;
			this.Hide();
		}

		#endregion

		#region Fields
        private LRRApp _lrrApp = null;
		private LRRSiteComponentProperties _lrrSiteCompProps = new LRRSiteComponentProperties(); 
		private LRRSiteComponents   _lrrSiteComponents = new LRRSiteComponents();
		private GridUnBoundColumn	_unBoundProp=new GridUnBoundColumn();
		private GridUnBoundColumn	_unBoundComp=new GridUnBoundColumn();
		private ArrayList			_unSelectedRecords = new ArrayList();
		private ArrayList			_selectedRecords = new ArrayList();

		private bool				_isWindowOpen;
        private bool _calledFromTrend;
		#endregion

		#region Events

		public event SelectedPropertiesChanged		RecordedProperties;

		#endregion

		#region Properties
		public LRRSiteComponentProperties PropertyCollection
		{
			get{return _lrrSiteCompProps;}
			set
			{
				_lrrSiteCompProps = value;
			}
		}
		public LRRSiteComponents SiteComponents
		{
			get{return _lrrSiteComponents;}
			set
			{
				_lrrSiteComponents = value;
			}
		}
		public ArrayList UnSelectedRecords
		{
			get{return _unSelectedRecords;}
			set
			{
				_unSelectedRecords = value;
			}
		}

		public ArrayList SelectedRecords
		{
			get{return _selectedRecords;}
			set
			{
				_selectedRecords = value;
			}
		}

		public bool IsWindowOpen 
		{
			get{ return _isWindowOpen;}
			set
			{
				_isWindowOpen = value;
			}
		}

		#endregion
		private void btnApply_Click(object sender, System.EventArgs e)
		{
			ArrayList arrUnselectedPropRecordID = new ArrayList(); 
			ArrayList arrSelectedPropRecordID = new ArrayList();
			ArrayList arrSelectedSiteComp = new ArrayList();
			object[] unSelectedPropRecord = _unBoundProp.GetUnSelectedRecords();
			for(int i=0; i < unSelectedPropRecord.Length;i++)
			{
				LRRSiteComponentProperty lrrSiteCompProp = unSelectedPropRecord[i] as LRRSiteComponentProperty;
				arrUnselectedPropRecordID.Add(lrrSiteCompProp.PropertyID);
			}
            object[] unSelectedCompRecord = _unBoundComp.GetUnSelectedRecords(); 
			object[] selectedPropRecord = _unBoundProp.GetSelectedRecords(); 
			for(int i=0; i < selectedPropRecord.Length;i++)
			{
				LRRSiteComponentProperty lrrSiteCompProp = selectedPropRecord[i] as LRRSiteComponentProperty;
				arrSelectedPropRecordID.Add(lrrSiteCompProp.PropertyID);
                // added by ashwin for handling user specific recorded properties
			}
			object[] selectedCompRecord = _unBoundComp.GetSelectedRecords();
			for(int i = 0;i< selectedCompRecord.Length ; i++)
			{
				LRRSiteComponent lsc = selectedCompRecord[i] as LRRSiteComponent; 
				arrSelectedSiteComp.Add(lsc);
			}
            LRRUserSpecificTrendedProperties committedTProps = new LRRUserSpecificTrendedProperties();
            LRRUserSpecificRecordedProperties committedRecProps = new LRRUserSpecificRecordedProperties();
            if (!_calledFromTrend)
            {
                for (int i = 0; i < arrSelectedPropRecordID.Count; i++)
                {
                    string mpID = arrSelectedPropRecordID[i] as string;
                    for (int j = 0; j < arrSelectedSiteComp.Count; j++)
                    {
                        LRRSiteComponent scID = arrSelectedSiteComp[j] as LRRSiteComponent;
                        LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(scID.SiteComponentID, mpID);
                        if (scp != null)
                        {
                            LRRUserSpecificRecordedProperty uSPRecProp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (uSPRecProp == null)
                            {
                                uSPRecProp = new LRRUserSpecificRecordedProperty();
                                uSPRecProp.SiteComponentID = scp.ComponentID;
                                uSPRecProp.SiteComponentPropertyID = scp.ID;
                                uSPRecProp.UID = _lrrApp.UID;
                                uSPRecProp.Name = scp.Name;
                                uSPRecProp.IsTracked = true;
                                uSPRecProp.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                                LRRModel.UserSpecificRecordedProperties.Add(uSPRecProp);
                                //_lrrApp.DBManagerObj.CommitCollection(LRRModel.UserSpecificRecordedProperties.GetChanges());
                                committedRecProps.Add(uSPRecProp);
                            }

                        }
                    }
                }
                if (committedRecProps.Count > 0)
                {
                    _lrrApp.DBManagerObj.CommitCollection(committedRecProps);
                }
                committedRecProps.Clear();
            }
            else
            {
                for (int i = 0; i < arrSelectedPropRecordID.Count; i++)
                {
                    string mpID = arrSelectedPropRecordID[i] as string;
                    for (int j = 0; j < arrSelectedSiteComp.Count; j++)
                    {
                        LRRSiteComponent scID = arrSelectedSiteComp[j] as LRRSiteComponent;
                        LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(scID.SiteComponentID, mpID);
                        if (scp != null)
                        {
                            LRRUserSpecificTrendedProperty uSPTProp = LRRModel.UserSpecificTrendedProperties.GetUserSpecificTrendedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                                //GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (uSPTProp == null)
                            {
                                uSPTProp = new LRRUserSpecificTrendedProperty();
                                uSPTProp.SiteComponentID = scp.ComponentID;
                                uSPTProp.SiteComponentPropertyID = scp.ID;
                                uSPTProp.UID = _lrrApp.UID;
                                uSPTProp.Name = scp.Name;
                                uSPTProp.IsTracked = true;
                                uSPTProp.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                                LRRModel.UserSpecificTrendedProperties.Add(uSPTProp);
                                committedTProps.Add(uSPTProp);
                            }

                        }
                    }
                }
                if (committedTProps.Count > 0)
                {
                    _lrrApp.DBManagerObj.CommitCollection(committedTProps);
                }
                committedTProps.Clear();
            }
            if (!_calledFromTrend)
            {
                for (int i = 0; i < arrUnselectedPropRecordID.Count; i++)
                {
                    string mpID = arrUnselectedPropRecordID[i] as string;
                    for (int j = 0; j < arrSelectedSiteComp.Count; j++)
                    {
                        LRRSiteComponent scID = arrSelectedSiteComp[j] as LRRSiteComponent;
                        LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(scID.SiteComponentID, mpID);
                        if (scp != null)
                        {
                            LRRUserSpecificRecordedProperty uSPRecProp = LRRModel.UserSpecificRecordedProperties.GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (uSPRecProp != null)
                            {
                                uSPRecProp.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                                committedRecProps.Add(uSPRecProp);
                                LRRModel.UserSpecificRecordedProperties.Remove(uSPRecProp);
                            }
                        }
                    }
                }
                if (committedRecProps.Count > 0)
                {
                    _lrrApp.DBManagerObj.CommitCollection(committedRecProps);
                }
            }
            else
            {
                for (int i = 0; i < arrUnselectedPropRecordID.Count; i++)
                {
                    string mpID = arrUnselectedPropRecordID[i] as string;
                    for (int j = 0; j < arrSelectedSiteComp.Count; j++)
                    {
                        LRRSiteComponent scID = arrSelectedSiteComp[j] as LRRSiteComponent;
                        LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(scID.SiteComponentID, mpID);
                        if (scp != null)
                        {
                            LRRUserSpecificTrendedProperty uSPRecProp = LRRModel.UserSpecificTrendedProperties.GetUserSpecificTrendedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                                //GetUserSpecificRecordedPropertyByUIDAndSCPID(_lrrApp.UID, scp.ID);
                            if (uSPRecProp != null)
                            {
                                uSPRecProp.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                                committedTProps.Add(uSPRecProp);
                                LRRModel.UserSpecificTrendedProperties.Remove(uSPRecProp);
                            }
                        }
                    }
                }
                if (committedTProps.Count > 0)
                {
                    _lrrApp.DBManagerObj.CommitCollection(committedTProps);
                }

            }
			RecordingEventArgs recordingEvents = new RecordingEventArgs();
			recordingEvents.SelectedSiteComponents = arrSelectedSiteComp;
			recordingEvents.SelectedProperties = arrSelectedPropRecordID;
			recordingEvents.UnSelectedSiteProperties = arrUnselectedPropRecordID;
            //_lrrApp.DBManagerObj.PopulateCollection(LRRModel.UserSpecificRecordedProperties.GetChanges());
			if(this.RecordedProperties!=null)
				this.RecordedProperties(recordingEvents);
			this.Close();
		}
		int rowProp, colProp;
		bool PropCheckBoxValue = false;
		private void gridResultProperties_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex(LRRHeaderText.GetHeaderString("SID_SELECT"), out rowProp , out colProp);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == colProp +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = PropCheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

		private void gridResultProperties_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == LRRHeaderText.GetHeaderString("SID_SELECT"))
			{
				e.AllowSort = false;
			}
		}
        List<LRRSiteComponentProperty> selectedSCPIDs;
        private void gridResultProperties_SaveCellText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
		{
            selectedSCPIDs = new List<LRRSiteComponentProperty>();
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.PropCheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lrrSiteCompProps.GetEnumerator(); 
				ArrayList selectedRecords = new ArrayList(); 
				while(iEnum.MoveNext())
				{
					LRRSiteComponentProperty ComponentProperty = iEnum.Current as LRRSiteComponentProperty; 
					if(ComponentProperty != null)
						selectedRecords.Add(ComponentProperty);  
				}
				object[] propObjSelectedRecords =new object[selectedRecords.Count];
				for(int i=0;i<selectedRecords.Count;i++)
				{
					propObjSelectedRecords[i] = selectedRecords[i];
				}
				_unBoundProp.SetSelectedRecords(propObjSelectedRecords,PropCheckBoxValue);  
				gridResultProperties.Refresh();  		
				e.Handled = true;
			}
			else
			{
				if(!bool.Parse(e.Text))
				{
					this.PropCheckBoxValue = false;
					gridResultProperties.Refresh();  		
				}
				else
				{
                    IEnumerator iEnum = _lrrSiteCompProps.GetEnumerator();
                    while (iEnum.MoveNext())
                    {
                        LRRSiteComponentProperty componentProperty = iEnum.Current as LRRSiteComponentProperty;
                        if (componentProperty != null)
                        {
                            //selectedSCPIDs.Add(componentProperty.ID);
                            if (!selectedSCPIDs.Contains(componentProperty))
                            {
                                selectedSCPIDs.Add(componentProperty);
                            }
                        }
                    }

					object[] objSelRecords = _unBoundProp.GetSelectedRecords();
					int noOfCheckedItems = objSelRecords.Length;
					if(_lrrSiteCompProps.Count == noOfCheckedItems + 1)
					{
						this.PropCheckBoxValue = true;
						gridResultProperties.Refresh(); 
					}
				}
			}
		}
		public delegate void SelectedPropertiesChanged(RecordingEventArgs e);

		private void TableControl_MouseUp(object sender, MouseEventArgs e)
		{
			
            GridTableControl gridTableControl = sender as GridTableControl;
			if(gridTableControl.TableDescriptor.Name == "LRRSiteComponentProperties")
			{
				int rowProp, colProp;
				GridTableControl gtcProp = this.gridResultProperties.TableControl;  
				gtcProp.PointToRowCol(new Point(e.X, e.Y), out rowProp, out colProp);
				GridTableCellStyleInfo styleProp = gtcProp.Model[rowProp, colProp];

				IMouseController controller;
				gtcProp.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

				if(controller != null && controller.Name == "DragGroupHeader" && styleProp.CellType == "CheckBox")
				{
					gtcProp.GetCellRenderer(rowProp, colProp).RaiseMouseUp(rowProp, colProp, e);
				}
			}
			else if(gridTableControl.TableDescriptor.Name == "LRRSiteComponents")
			{
				int rowComp, colComp;
				GridTableControl gtcComp = this.gridComponents.TableControl;  
				gtcComp.PointToRowCol(new Point(e.X, e.Y), out rowComp, out colComp);
				GridTableCellStyleInfo styleComp = gtcComp.Model[rowComp, colComp];

				IMouseController controller;
				gtcComp.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

				if(controller != null && controller.Name == "DragGroupHeader" && styleComp.CellType == "CheckBox")
				{
					gtcComp.GetCellRenderer(rowComp, colComp).RaiseMouseUp(rowComp, colComp, e);
				}
			}

		}

		private void gridResultProperties_SizeChanged(object sender, System.EventArgs e)
		{
			int totalColsWidth = 0;
			
			foreach(GridColumnDescriptor gcd in this.gridResultProperties.TableDescriptor.Columns)
			{
				totalColsWidth += gcd.Width;
			}

			float nPercent = (float)(this.gridResultProperties.Width - (3 + 2*(new VScrollBar()).Width))/(float)totalColsWidth;

			foreach(GridColumnDescriptor gcd in this.gridResultProperties.TableDescriptor.Columns)
			{
				gcd.Width = (int)(gcd.Width * nPercent + 0.5);
				if(gcd.Width == 0)
					gcd.Width = 1;
			}
		}

        bool CompCheclBoxValue = false;
		int rowComp,colComp;
		private void gridComponents_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == LRRHeaderText.GetHeaderString("SID_SELECT"))
			{
				e.AllowSort = false;
			}
		}
		private void gridComponents_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex(LRRHeaderText.GetHeaderString("SID_SELECT"), out rowComp , out colComp);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == colComp +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = CompCheclBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}
        List<string> selectedSiteComponentIDs;
		private void gridComponents_SaveCellText(object sender, GridCellTextEventArgs e)
		{
            selectedSiteComponentIDs = new List<string>();
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.CompCheclBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lrrSiteComponents.GetEnumerator(); 
				ArrayList selectedRecords = new ArrayList(); 
				while(iEnum.MoveNext())
				{
					LRRSiteComponent lsc  = iEnum.Current as LRRSiteComponent;
                    if (lsc != null)
                        if (!selectedSiteComponentIDs.Contains(lsc.SiteComponentID))
                        {
                            selectedSiteComponentIDs.Add(lsc.SiteComponentID);
                        }
                        selectedRecords.Add(lsc);  
				}
				object[] compObjSelectedRecords =new object[selectedRecords.Count];
				for(int i=0;i<selectedRecords.Count;i++)
				{
					compObjSelectedRecords[i] = selectedRecords[i];
				}
				_unBoundComp.SetSelectedRecords(compObjSelectedRecords,CompCheclBoxValue);  
				gridComponents.Refresh();  		
				e.Handled = true;
			}
            // added by ashwin for handling user specific recorded attributes
            else if (style.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell && e.Style.CellType == "CheckBox")
            {
                IEnumerator iEnum = _lrrSiteComponents.GetEnumerator();
                ArrayList selectedRecords = new ArrayList();
                while (iEnum.MoveNext())
                {
                    LRRSiteComponent lsc = iEnum.Current as LRRSiteComponent;
                    if (lsc != null)
                        if (!selectedSiteComponentIDs.Contains(lsc.SiteComponentID))
                        {
                            selectedSiteComponentIDs.Add(lsc.SiteComponentID);
                        }
                    //selectedRecords.Add(lsc);
                }

            }

		}
	}
}
