using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;

using Syncfusion.Windows.Forms.Grid;
using Symcon.Utils.MessageDispatcher;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.CommonViews;

namespace Symcon.LightRidge.PEAdvisor.IOScreen
{
	/// <summary>
	/// Summary description for SearchForm.
	/// </summary>
	public class ResultForm : System.Windows.Forms.Form,ILRRUIContainer,ILRRUISpecificContainer
	{

		
		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private System.Windows.Forms.Panel panel1;
		private LRRApp				_lrrApp;
        public static bool          BIOViewsResultFormChange = false;
        private static LRRSiteComponentPropertyValues _rollBackPropertyValues = new LRRSiteComponentPropertyValues();
       
       		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
        
		public ResultForm()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}
        public static LRRSiteComponentPropertyValues RollBackPropertyValues
        {
            get { return _rollBackPropertyValues; }
            set { _rollBackPropertyValues = value; }
        }

		public ResultForm(IGridFactory gridView,ResultPropertiesWindow rsPropertiesWindow,ResultPropertiesWindow rsComponentsWindow)
		{
            InitForm(gridView, rsPropertiesWindow, rsComponentsWindow);
		}

        public ResultForm(string searchCriteriaID)
        {
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            LRRSearchCriteria lrrSrchCriteria = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(searchCriteriaID);
            OpenQuery(lrrSrchCriteria);
            this.Text =  Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_RESULT") + "-" + "[" + lrrSrchCriteria.Name + "]";
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ResultForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(832, 582);
			this.panel1.TabIndex = 2;
			// 
			// ResultForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(832, 582);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "ResultForm";
			this.Text = "";
			this.Tag="SID_RESULT";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.ResumeLayout(false);

		}
		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
		}

		public void Save()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null)
			{
				iGridView.Save();
                LRRModel.PropertyValuesObj.RefreshCollection();
                BIOViewsResultFormChange = false;
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			}
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			
		}

		public void Copy()
		{
			
		}

		public void Print()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null)
				iGridView.Print();
		}

		public void Delete()
		{
			
		}

		public void ArrangeColumns()
		{
			
		}

		public void ClearFilter()
		{
		}
		public void ImportToExcel()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		public bool SupportsSelectionPaste()
		{
			return false;
		}

		public void SelectionPaste()
		{
		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return false;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			return false;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}
		public void Export()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null && iGridView.Export() != null)
			{
				ExportToExcel excelExpForm = new ExportToExcel(iGridView.Export());
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}
		
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region Methods

        public void InitForm(IGridFactory gridView, ResultPropertiesWindow rsPropertiesWindow, ResultPropertiesWindow rsComponentsWindow)
        {
            InitializeComponent();
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            GridView = gridView;
            ArrayList pnlCollection = gridView.GetPanelCollection();
            if (pnlCollection.Count > 0)
            {
                SetPanel(pnlCollection);
            }
            else
            {
                LRRMessagBox.ShowMessage(this, "SID_INVALID_QUERY", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            _rsResultWindow = rsPropertiesWindow;
            _rsResultWindow.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(rsPropertiesWindow_SelectedProperties);
            _rsResultWindow.Owner = this;

            _rsResultComponentsWindow = rsComponentsWindow;
            _rsResultComponentsWindow.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsResultComponentsWindow_SelectedProperties);
            _rsResultComponentsWindow.Owner = this;

            //Populate Items
            LRRSearchCriteriaItems srchItems = new LRRSearchCriteriaItems();
            _lrrApp.DBManagerObj.PopulateCollection(srchItems, " where SearchCriteriaID = '" + gridView.SearchQuery.SearchQuery.ID + "'");

            //Populate User Specific Items
            LRRSearchCriteriaUserSpecificItems srchCriteriaUserSpecificItems = new LRRSearchCriteriaUserSpecificItems();
            _lrrApp.DBManagerObj.PopulateCollection(srchCriteriaUserSpecificItems);

            LRRSearchCriteriaItemProperties srchItemProps = new LRRSearchCriteriaItemProperties();
            _lrrApp.DBManagerObj.PopulateCollection(srchItemProps, " where SearchCriteriaID = '" + gridView.SearchQuery.SearchQuery.ID + "'");

            LRRSearchCriteriaUserSpecificUIUOMs srchCriteriaUserSpecificUIUOMs = new LRRSearchCriteriaUserSpecificUIUOMs();
            _lrrApp.DBManagerObj.PopulateCollection(srchCriteriaUserSpecificUIUOMs);

            //User Specific Components 
            _rsResultComponentsWindow.UnSelectedRecords.Clear();
            ArrayList arrIDs = new ArrayList();
            IEnumerator iEnum = srchItems.GetEnumerator();
            while (iEnum.MoveNext())
            {
                LRRSearchCriteriaItem srchItem = iEnum.Current as LRRSearchCriteriaItem;
                LRRSearchCriteriaUserSpecificItem srchUIItem = srchCriteriaUserSpecificItems.GetUIItemObjectByItemID(srchItem.ID);
                if (srchUIItem != null && !srchUIItem.IsVisible)
                {
                    _rsResultComponentsWindow.UnSelectedRecords.Add(srchItem.ItemID);
                    arrIDs.Add(srchItem.ItemID);
                }
            }
            _rsResultComponentsWindow.SetUnSelectedRecords(arrIDs);
            gridView.HideComponents(_rsResultComponentsWindow.UnSelectedRecords);


            //User Specific Properties
            _rsResultComponentsWindow.UnSelectedRecords.Clear();
            ArrayList arrItemPropIDs = new ArrayList();
            IEnumerator iPropEnum = srchItemProps.GetEnumerator();
            while (iPropEnum.MoveNext())
            {
                LRRSearchCriteriaItemProperty srchItemProp = iPropEnum.Current as LRRSearchCriteriaItemProperty;
                LRRSearchCriteriaUserSpecificUIUOM srchUIUOMItem = srchCriteriaUserSpecificUIUOMs.GetUIUOMObjectByPropertyID(srchItemProp.ID);
                if (srchUIUOMItem != null && !srchUIUOMItem.IsVisible)
                {
                    _rsResultWindow.UnSelectedRecords.Add(srchItemProp.ItemPropertyID);
                    arrItemPropIDs.Add(srchItemProp.ItemPropertyID);
                }
            }
            _rsResultWindow.SetUnSelectedRecords(arrItemPropIDs);
            gridView.HideProperties(_rsResultWindow.UnSelectedRecords);


            LRRModel.ProjectModes.ModesChanged += new EventHandler(ProjectModes_ModesChanged);
            this.Closing += new CancelEventHandler(ResultForm_Closing);
            this.Activated += new EventHandler(ResultForm_Activated);
            this.Deactivate += new EventHandler(ResultForm_Deactivate);
        }

        private void OpenQuery(LRRSearchCriteria lrrSrchCriteria)
        {
            ResultPropertiesWindow rsProperties = _lrrApp.MainFrame.LRRScreenListView.RsProperties = new ResultPropertiesWindow();
            ResultPropertiesWindow rsComponents = _lrrApp.MainFrame.LRRScreenListView.RsComponents = new ResultPropertiesWindow();

            string searchCriteriaID = lrrSrchCriteria.ID;

            LRRModes lrrModes = LRRModel.ProjectModes;
            SearchRetrievalUtility searchUtil = new SearchRetrievalUtility();
            LRRSiteComponents lrrSiteComponents = searchUtil.PopulateSiteComponents(searchCriteriaID);

            //Aggregates
            LRRAggregates lrrResultAggregates = searchUtil.PopulateAggregates(searchCriteriaID);

            LRRSearchCriteria lrrSearchCriteria = lrrSrchCriteria;

            string sSource = lrrSearchCriteria.Source == null ? "" : lrrSearchCriteria.Source.ToString(Symcon.BusinessObjects.SymConverter.Culture);
            if (sSource == "I/O")
            {
                string templateClass = lrrSearchCriteria.TemplateClass;
                switch (templateClass)
                {
                    case "Symcon.LightRidge.PEAdvisor.GridSimpleView":
                        templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController";
                        break;
                    case "Symcon.LightRidge.PEAdvisor.GridTransposedView":
                        templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController";
                        break;
                    case "Symcon.LightRidge.PEAdvisor.GridSimpleGroupedModeView":
                        templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleGroupedModeViewController";
                        break;
                    case "Symcon.LightRidge.PEAdvisor.GridTransposedGroupedModeView":
                        templateClass = "Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedGroupedModeViewController";
                        break;
                    default:
                        templateClass = templateClass;
                        break;
                }

                Type gridType = Type.GetType(templateClass);
                object gridView = Activator.CreateInstance(gridType);
                GridView = gridView;
                IGridFactory objGrid = gridView as IGridFactory;

                ArrayList custCollection = new ArrayList();
                custCollection.Add(lrrSiteComponents);
                custCollection.Add(lrrResultAggregates);
                objGrid.SearchQuery.SearchQuery.UserSettingsID = lrrSearchCriteria.UserSettingsID;
                objGrid.SearchQuery.SearchQuery.ID = lrrSearchCriteria.ID;

                LRRSearchCriteriaItemProperties srchCriteriaItemProps = new LRRSearchCriteriaItemProperties();
                this._lrrApp.DBManagerObj.PopulateCollection(srchCriteriaItemProps, " where SearchCriteriaID = '" + searchCriteriaID + "'");

                objGrid.LoadPanel(custCollection, srchCriteriaItemProps);

                LRRResultProperties resultProperties = SearchRetrievalUtility.ShowPropertiesWindow(lrrSiteComponents, lrrResultAggregates);
                rsProperties.PropertyCollection = resultProperties;
                rsProperties.Text = "Result Properties Window";
                rsProperties.BindGrid();

                //Show the Component List Form
                LRRResultProperties resultComponents = SearchRetrievalUtility.ShowComponents(lrrSiteComponents, lrrResultAggregates);
                rsComponents.PropertyCollection = resultComponents;
                rsComponents.Text = "Result Components Window";
                rsComponents.BindGrid();

                //ArrayList arrParams = new ArrayList();
                //arrParams.Add(objGrid);
                //arrParams.Add(_rsProperties);
                //arrParams.Add(_rsComponents);
                InitForm(objGrid, rsProperties, rsComponents);
               // _lrrApp.LRRUIManagerObj.ShowWindow(250, arrParams, lrrSearchCriteria.Name, true);
            }
        }

		private void SetPanel(ArrayList pnlCollection)
		{
            bool check = true; //!ApplicationPersistanceUtil.HtUserQueries.ContainsKey((GridView as IGridFactory).SearchQuery.SearchQuery.ID);
            //if(!check)
            //{
            //    try
            //    {
            //        LRRGridControlSetting gcs = ApplicationPersistanceUtil.HtUserQueries[(GridView as IGridFactory).SearchQuery.SearchQuery.ID] as LRRGridControlSetting;
            //        if(gcs.gridInstance[0].ParentPanelVarSize == -1)
            //        {
            //            check = true;
            //        }
            //    }
            //    catch
            //    {
            //        check = true;
            //    }
            //}
			int heightOfEach = panel1.Height/pnlCollection.Count;
			int splitCnt = 0;
			for(int i=pnlCollection.Count-1;i>=0;i--)
			{
				Panel panel = pnlCollection[i] as Panel;
                panel.Name = "SavedViews:" + i;
				if(check)
					panel.Height = heightOfEach;
				
				this.panel1.Controls.Add(panel);
				if(splitCnt < pnlCollection.Count - 1)
				{
					Splitter splitGrid = new Splitter();
					splitGrid.Dock = DockStyle.Top;
					this.panel1.Controls.Add(splitGrid);
					splitCnt++;
				}
			}
			if(this.panel1.Controls.Count > 0)
				this.panel1.Controls[0].Dock = DockStyle.Fill;
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null)
				iGridView.ClearSort();
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add ResultForm.SupportsClearSort implementation
			return true;
		}

		#endregion
	#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		private void ProjectModes_ModesChanged(object sender, EventArgs e)
		{
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null)
				iGridView.HideModes();
		}
        
        private void ResultForm_Closing(object sender, CancelEventArgs e)
		{
            
  			//Clear All Bindings
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null)
			{
				iGridView.ClearAllBindings();
				iGridView.UnSubscribeReconnectCompleted();
			}

			//Save the Property Values
		    LRRSiteComponentPropertyValues toSaveSiteCompPropValues = LRRModel.PropertyValuesObj.GetChanges();
            if (toSaveSiteCompPropValues.Count > 0)
            {
                //DialogResult dlgResult = MessageBox.Show(this,"Do you want to save the property values?","Question",MessageBoxButtons.YesNo,MessageBoxIcon.Question); 
                DialogResult dlgResult = LRRMessagBox.ShowMessage(this, "SID_SAVE_PROPVALUE", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

            
               if (dlgResult == DialogResult.Yes)
                 {
                    _lrrApp.DBManagerObj.CommitCollection(toSaveSiteCompPropValues);
            
                 }

                else if(dlgResult == DialogResult.No)
                {
                    foreach (LRRSiteComponentPropertyValue lscpv in toSaveSiteCompPropValues)
                    {
                        LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lscpv.SiteComponentPropertyID);
                        LRRSiteComponentPropertyValue lscpvObj = LRRModel.GetPropertyValueObject(typeof(LRRSiteComponent), lscpv.ModeID, lscpv.SiteComponentPropertyID, lscp.ComponentID) as LRRSiteComponentPropertyValue;
                        lscpvObj.RollBackChanges(true);
                    }               
                }
               
                    LRRModel.PropertyValuesObj.RefreshCollection();    
            } 
                
            BIOViewsResultFormChange =false;
			LRRModel.ProjectModes.ModesChanged-=new EventHandler(ProjectModes_ModesChanged);
			_rsResultWindow.SelectedProperties-=new ResultPropertiesWindow.SelectedPropertiesChanged(rsPropertiesWindow_SelectedProperties);
			_rsResultComponentsWindow.SelectedProperties-=new ResultPropertiesWindow.SelectedPropertiesChanged(_rsResultComponentsWindow_SelectedProperties);
			_rsResultWindow.Dispose();
			_rsResultComponentsWindow.Dispose(); 
         
        }
        
   
		#region Properties
		private object GridView
		{
			get { return _gridView;}
			set
			{
				_gridView = value;
			}
		}

		private object _gridView;
		
		private ResultPropertiesWindow _rsResultWindow;
		private ResultPropertiesWindow _rsResultComponentsWindow;
		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null)
				iGridView.PrintPreview();
		}

		#endregion

		private void rsPropertiesWindow_SelectedProperties(ArrayList arrayUnSelectedRecords)
		{
			IGridFactory iGridView = GridView as IGridFactory;
			iGridView.HideProperties(arrayUnSelectedRecords);
		}

		private void ResultForm_Activated(object sender, EventArgs e)
		{
			if(_rsResultWindow != null && _rsResultWindow.IsWindowOpen)
				_rsResultWindow.Show();
			if(_rsResultComponentsWindow != null && _rsResultComponentsWindow.IsWindowOpen)
				_rsResultComponentsWindow.Show();
		}

		private void ResultForm_Deactivate(object sender, EventArgs e)
		{
			if(_rsResultWindow != null)
				_rsResultWindow.Hide();
			if(_rsResultComponentsWindow != null)
				_rsResultComponentsWindow.Hide();
           
		}

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add ResultForm.ShowPropertyList implementation
			if(_rsResultWindow != null && _rsResultWindow.PropertyCollection.Count > 0)
			{
				_rsResultWindow.Show();
				_rsResultWindow.IsWindowOpen = true;
			}
		}

		public void ShowComponentList()
		{
			// TODO:  Add ResultForm.ShowComponentList implementation
			if(_rsResultComponentsWindow != null && _rsResultComponentsWindow.PropertyCollection.Count > 0)
			{
				_rsResultComponentsWindow.Show();
				_rsResultComponentsWindow.IsWindowOpen = true;
			}
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add ResultForm.SupportsResultsFilter implementation
			return true;
		}

		#endregion

		private void _rsResultComponentsWindow_SelectedProperties(ArrayList arrayUnSelectedRecords)
		{
			IGridFactory iGridView = GridView as IGridFactory;
			iGridView.HideComponents(arrayUnSelectedRecords);
		}
		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			iGridView.LeftColMovement();
		}

		public void RightColMovement()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			iGridView.RightColMovement();
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridControlPrint ggPrint = new GridControlPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add ResultForm.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add ResultForm.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add ResultForm.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add ResultForm.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add ResultForm.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add ResultForm.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add ResultForm.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add ResultForm.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add ResultForm.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add ResultForm.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add ResultForm.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add ResultForm.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		#region ILRRUISpecificContainer Members

		public void ChangeUOMSet()
		{
			IGridFactory iGridView = GridView as IGridFactory;
			if(iGridView != null)
			{
				ChangeUOMSetDefinitionForm chngUOMSetDefn = new ChangeUOMSetDefinitionForm();
				DialogResult dlgResult = chngUOMSetDefn.ShowDialog();
				if(dlgResult == DialogResult.OK  && chngUOMSetDefn.MeasSysID != null)
				{
					iGridView.ChangeUOMSet(chngUOMSetDefn.MeasSysID);
				}
			}
		}

		public bool SupportsChangeUOMSet()
		{
			return true;
		}

		#endregion
	}
}
