using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.Lightridge.LRRUI;
using Symcon.LightRidge.BusinessObjects.TypeConverters;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.HeaderDispatcher;   

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using System.Collections.Generic;
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ConditionalFormattingDialog.
	/// </summary>
	public class ConditionalFormattingDialog : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteCompProps;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Panel pnlLeft;
		private LRRMode _selectedMode;
        private List<IPropertyValue> lscpv = new List<IPropertyValue>();
		private IProperty _selectedItem;
		private System.Windows.Forms.GroupBox grpBoxCondition;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.CheckBox chkCondition1;
		private System.Windows.Forms.CheckBox chkCondition2;
		private System.Windows.Forms.CheckBox chkCondition3;
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.Label lblIsinRange1;
		private LRRApp _app;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.Panel pnlRight;
		private System.Windows.Forms.Panel pnlCond1;
		private System.Windows.Forms.Panel pnlTxtCond1;
		private System.Windows.Forms.Panel pnlTxtCond2;
		private System.Windows.Forms.Panel pnlTxtComd3;
		private System.Windows.Forms.Panel pnlMain;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Splitter splitter4;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Splitter splitter5;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.FontDialog fontDialog1;
		private System.Windows.Forms.ColorDialog colorDialog1;
		private System.Windows.Forms.ColorDialog colorDialog2;
		private System.Windows.Forms.ColorDialog colorDialog3;
		private System.Windows.Forms.FontDialog fontDialog2;
		private System.Windows.Forms.FontDialog fontDialog3;
		private System.Windows.Forms.Label lblPreview1;
		private System.Windows.Forms.Label lblPreView3;
		private System.Windows.Forms.Label lblPreView2;
		private System.Windows.Forms.Label lblIsInRange2;
		private System.Windows.Forms.Label lblIsInRange3;
		private System.Windows.Forms.Button btnFormat1;
		private System.Windows.Forms.TextBox txtMax1;
		private System.Windows.Forms.TextBox txtMin1;
		private System.Windows.Forms.TextBox txtMax2;
		private System.Windows.Forms.TextBox txtMin2;
		private System.Windows.Forms.TextBox txtMax3;
		private System.Windows.Forms.TextBox txtMin3;
		private System.Windows.Forms.Button btnSetColor1;
		private System.Windows.Forms.Button btnSetColor2;
		private System.Windows.Forms.Button btnFormat2;
		private System.Windows.Forms.Button btnSetColor3;
		private System.Windows.Forms.Button btnFormat3;
		private System.Windows.Forms.Panel pnlModes;
		private Font defaultFont = null;
		private System.Windows.Forms.ErrorProvider errorProvider1;
        private System.Windows.Forms.Label lblError;
        private CheckBox chkApplytoSymbol;
        private ComboBox cmbEVV1;
        private Panel pnlEVV1;
        private Panel pnlEVV2;
        private ComboBox cmbEVV2;
        private Panel pnlEVV3;
        private ComboBox cmbEVV3;
        private IContainer components;

        /// <summary>
        /// Initializes a new instance of the <see cref="ConditionalFormattingDialog"/> class.
        /// </summary>
		public ConditionalFormattingDialog()
		{
			InitializeComponent();
            InternationalizationUtils.GetControlText(this, null); 
			defaultFont = new Font(fontDialog1.Font,System.Drawing.FontStyle.Regular);
		}
	
        private ISymbolPropertiesMapping _myISymbolMapping;

        /// <summary>
        /// Initializes a new instance of the <see cref="ConditionalFormattingDialog"/> class.
        /// </summary>
        /// <param name="iSymbolMapping">The i symbol mapping.</param>
        /// <param name="customCollection">The custom collection.</param>
        public ConditionalFormattingDialog(ISymbolPropertiesMapping iSymbolMapping,CustomCollection customCollection)
		{
			_myISymbolMapping = iSymbolMapping;


			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 

			this.gridSiteCompProps.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails =	false;
			gridSiteCompProps.TableDescriptor.Relations.Clear();
			gridSiteCompProps.DataSource = null;
			gridSiteCompProps.DataSource = customCollection;
			gridSiteCompProps.TableDescriptor.Columns.Clear();
			gridSiteCompProps.TableDescriptor.Columns.Add("Name");
			gridSiteCompProps.TableDescriptor.Columns["Name"].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridSiteCompProps.TableDescriptor.Columns["Name"].HeaderText = LRRHeaderText.GetHeaderString("SID_NAME");
			gridSiteCompProps.CurrentRecordContextChange+=new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(gridSiteCompProps_CurrentRecordContextChange);
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			groupBox2.Enabled = false;
			groupBox3.Enabled = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ConditionalFormattingDialog));
            this.pnlLeft = new System.Windows.Forms.Panel();
            this.pnlModes = new System.Windows.Forms.Panel();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.splitter3 = new System.Windows.Forms.Splitter();
            this.gridSiteCompProps = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlRight = new System.Windows.Forms.Panel();
            this.chkCondition1 = new System.Windows.Forms.CheckBox();
            this.chkCondition3 = new System.Windows.Forms.CheckBox();
            this.chkCondition2 = new System.Windows.Forms.CheckBox();
            this.pnlCond1 = new System.Windows.Forms.Panel();
            this.grpBoxCondition = new System.Windows.Forms.GroupBox();
            this.lblIsinRange1 = new System.Windows.Forms.Label();
            this.btnSetColor1 = new System.Windows.Forms.Button();
            this.btnFormat1 = new System.Windows.Forms.Button();
            this.label2 = new System.Windows.Forms.Label();
            this.lblPreview1 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.pnlTxtCond1 = new System.Windows.Forms.Panel();
            this.label4 = new System.Windows.Forms.Label();
            this.txtMax1 = new System.Windows.Forms.TextBox();
            this.txtMin1 = new System.Windows.Forms.TextBox();
            this.pnlEVV1 = new System.Windows.Forms.Panel();
            this.cmbEVV1 = new System.Windows.Forms.ComboBox();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.lblIsInRange2 = new System.Windows.Forms.Label();
            this.btnSetColor2 = new System.Windows.Forms.Button();
            this.btnFormat2 = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.lblPreView2 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.pnlTxtCond2 = new System.Windows.Forms.Panel();
            this.label7 = new System.Windows.Forms.Label();
            this.txtMax2 = new System.Windows.Forms.TextBox();
            this.txtMin2 = new System.Windows.Forms.TextBox();
            this.pnlEVV2 = new System.Windows.Forms.Panel();
            this.cmbEVV2 = new System.Windows.Forms.ComboBox();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.btnSetColor3 = new System.Windows.Forms.Button();
            this.btnFormat3 = new System.Windows.Forms.Button();
            this.label8 = new System.Windows.Forms.Label();
            this.lblPreView3 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.lblIsInRange3 = new System.Windows.Forms.Label();
            this.pnlTxtComd3 = new System.Windows.Forms.Panel();
            this.label11 = new System.Windows.Forms.Label();
            this.txtMax3 = new System.Windows.Forms.TextBox();
            this.txtMin3 = new System.Windows.Forms.TextBox();
            this.pnlEVV3 = new System.Windows.Forms.Panel();
            this.cmbEVV3 = new System.Windows.Forms.ComboBox();
            this.fontDialog1 = new System.Windows.Forms.FontDialog();
            this.colorDialog1 = new System.Windows.Forms.ColorDialog();
            this.pnlMain = new System.Windows.Forms.Panel();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.splitter4 = new System.Windows.Forms.Splitter();
            this.pnlBottom = new System.Windows.Forms.Panel();
            this.chkApplytoSymbol = new System.Windows.Forms.CheckBox();
            this.lblError = new System.Windows.Forms.Label();
            this.btnCancel = new System.Windows.Forms.Button();
            this.btnOk = new System.Windows.Forms.Button();
            this.splitter5 = new System.Windows.Forms.Splitter();
            this.colorDialog2 = new System.Windows.Forms.ColorDialog();
            this.colorDialog3 = new System.Windows.Forms.ColorDialog();
            this.fontDialog2 = new System.Windows.Forms.FontDialog();
            this.fontDialog3 = new System.Windows.Forms.FontDialog();
            this.errorProvider1 = new System.Windows.Forms.ErrorProvider(this.components);
            this.pnlLeft.SuspendLayout();
            this.pnlModes.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridSiteCompProps)).BeginInit();
            this.pnlRight.SuspendLayout();
            this.pnlCond1.SuspendLayout();
            this.grpBoxCondition.SuspendLayout();
            this.pnlTxtCond1.SuspendLayout();
            this.pnlEVV1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.pnlTxtCond2.SuspendLayout();
            this.pnlEVV2.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.pnlTxtComd3.SuspendLayout();
            this.pnlEVV3.SuspendLayout();
            this.pnlMain.SuspendLayout();
            this.pnlBottom.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider1)).BeginInit();
            this.SuspendLayout();
            // 
            // pnlLeft
            // 
            this.pnlLeft.Controls.Add(this.pnlModes);
            this.pnlLeft.Controls.Add(this.splitter3);
            this.pnlLeft.Controls.Add(this.gridSiteCompProps);
            this.pnlLeft.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlLeft.Location = new System.Drawing.Point(0, 0);
            this.pnlLeft.Name = "pnlLeft";
            this.pnlLeft.Padding = new System.Windows.Forms.Padding(6);
            this.pnlLeft.Size = new System.Drawing.Size(460, 443);
            this.pnlLeft.TabIndex = 0;
            // 
            // pnlModes
            // 
            this.pnlModes.Controls.Add(this.groupBox1);
            this.pnlModes.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlModes.Location = new System.Drawing.Point(6, 315);
            this.pnlModes.Name = "pnlModes";
            this.pnlModes.Padding = new System.Windows.Forms.Padding(2);
            this.pnlModes.Size = new System.Drawing.Size(448, 122);
            this.pnlModes.TabIndex = 6;
            // 
            // groupBox1
            // 
            this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.groupBox1.Location = new System.Drawing.Point(2, 2);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(444, 118);
            this.groupBox1.TabIndex = 2;
            this.groupBox1.TabStop = false;
            this.groupBox1.Tag = "SID_MODE_SELECT";
            // 
            // splitter3
            // 
            this.splitter3.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter3.Enabled = false;
            this.splitter3.Location = new System.Drawing.Point(6, 312);
            this.splitter3.Name = "splitter3";
            this.splitter3.Size = new System.Drawing.Size(448, 3);
            this.splitter3.TabIndex = 5;
            this.splitter3.TabStop = false;
            // 
            // gridSiteCompProps
            // 
            this.gridSiteCompProps.BackColor = System.Drawing.SystemColors.Window;
            this.gridSiteCompProps.Dock = System.Windows.Forms.DockStyle.Top;
            this.gridSiteCompProps.Location = new System.Drawing.Point(6, 6);
            this.gridSiteCompProps.Name = "gridSiteCompProps";
            this.gridSiteCompProps.Size = new System.Drawing.Size(448, 306);
            this.gridSiteCompProps.TabIndex = 1;
            this.gridSiteCompProps.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
            this.gridSiteCompProps.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
            this.gridSiteCompProps.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
            this.gridSiteCompProps.TableOptions.ShowRowHeader = false;
            this.gridSiteCompProps.Text = "gridSiteCompProps";
            this.gridSiteCompProps.TopLevelGroupOptions.CaptionText = "Attributes : {RecordCount} Items";
            this.gridSiteCompProps.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridSiteCompProps.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridSiteCompProps.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridSiteCompProps.VersionInfo = "3.301.0.0";
            // 
            // pnlRight
            // 
            this.pnlRight.Controls.Add(this.chkCondition1);
            this.pnlRight.Controls.Add(this.chkCondition3);
            this.pnlRight.Controls.Add(this.chkCondition2);
            this.pnlRight.Controls.Add(this.pnlCond1);
            this.pnlRight.Controls.Add(this.splitter2);
            this.pnlRight.Controls.Add(this.groupBox2);
            this.pnlRight.Controls.Add(this.groupBox3);
            this.pnlRight.Dock = System.Windows.Forms.DockStyle.Right;
            this.pnlRight.Location = new System.Drawing.Point(460, 0);
            this.pnlRight.Name = "pnlRight";
            this.pnlRight.Padding = new System.Windows.Forms.Padding(6);
            this.pnlRight.Size = new System.Drawing.Size(432, 443);
            this.pnlRight.TabIndex = 2;
            // 
            // chkCondition1
            // 
            this.chkCondition1.Checked = true;
            this.chkCondition1.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkCondition1.Enabled = false;
            this.chkCondition1.Location = new System.Drawing.Point(24, 5);
            this.chkCondition1.Name = "chkCondition1";
            this.chkCondition1.Size = new System.Drawing.Size(80, 16);
            this.chkCondition1.TabIndex = 13;
            this.chkCondition1.Tag = "SID_CONDITION1";
            // 
            // chkCondition3
            // 
            this.chkCondition3.Location = new System.Drawing.Point(24, 294);
            this.chkCondition3.Name = "chkCondition3";
            this.chkCondition3.Size = new System.Drawing.Size(80, 16);
            this.chkCondition3.TabIndex = 12;
            this.chkCondition3.Tag = "SID_CONDITION3";
            this.chkCondition3.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
            // 
            // chkCondition2
            // 
            this.chkCondition2.Location = new System.Drawing.Point(24, 152);
            this.chkCondition2.Name = "chkCondition2";
            this.chkCondition2.Size = new System.Drawing.Size(80, 16);
            this.chkCondition2.TabIndex = 7;
            this.chkCondition2.Tag = "SID_CONDITION2";
            this.chkCondition2.CheckedChanged += new System.EventHandler(this.chkCondition2_CheckedChanged);
            // 
            // pnlCond1
            // 
            this.pnlCond1.Controls.Add(this.grpBoxCondition);
            this.pnlCond1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlCond1.Location = new System.Drawing.Point(6, 6);
            this.pnlCond1.Name = "pnlCond1";
            this.pnlCond1.Size = new System.Drawing.Size(420, 144);
            this.pnlCond1.TabIndex = 12;
            // 
            // grpBoxCondition
            // 
            this.grpBoxCondition.Controls.Add(this.lblIsinRange1);
            this.grpBoxCondition.Controls.Add(this.btnSetColor1);
            this.grpBoxCondition.Controls.Add(this.btnFormat1);
            this.grpBoxCondition.Controls.Add(this.label2);
            this.grpBoxCondition.Controls.Add(this.lblPreview1);
            this.grpBoxCondition.Controls.Add(this.label1);
            this.grpBoxCondition.Controls.Add(this.comboBox1);
            this.grpBoxCondition.Controls.Add(this.pnlTxtCond1);
            this.grpBoxCondition.Controls.Add(this.pnlEVV1);
            this.grpBoxCondition.Dock = System.Windows.Forms.DockStyle.Fill;
            this.grpBoxCondition.Location = new System.Drawing.Point(0, 0);
            this.grpBoxCondition.Name = "grpBoxCondition";
            this.grpBoxCondition.Size = new System.Drawing.Size(420, 144);
            this.grpBoxCondition.TabIndex = 0;
            this.grpBoxCondition.TabStop = false;
            // 
            // lblIsinRange1
            // 
            this.lblIsinRange1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblIsinRange1.Location = new System.Drawing.Point(16, 40);
            this.lblIsinRange1.Name = "lblIsinRange1";
            this.lblIsinRange1.Size = new System.Drawing.Size(128, 16);
            this.lblIsinRange1.TabIndex = 10;
            this.lblIsinRange1.Tag = "SID_IN_RANGE";
            this.lblIsinRange1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // btnSetColor1
            // 
            this.btnSetColor1.Location = new System.Drawing.Point(280, 72);
            this.btnSetColor1.Name = "btnSetColor1";
            this.btnSetColor1.Size = new System.Drawing.Size(112, 24);
            this.btnSetColor1.TabIndex = 6;
            this.btnSetColor1.Tag = "SID_SET_BACK_COLOR";
            this.btnSetColor1.Click += new System.EventHandler(this.button1_Click);
            // 
            // btnFormat1
            // 
            this.btnFormat1.Location = new System.Drawing.Point(152, 72);
            this.btnFormat1.Name = "btnFormat1";
            this.btnFormat1.Size = new System.Drawing.Size(112, 24);
            this.btnFormat1.TabIndex = 5;
            this.btnFormat1.Tag = "SID_SET_FONT";
            this.btnFormat1.Click += new System.EventHandler(this.btnFormat_Click);
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(24, 104);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(136, 32);
            this.label2.TabIndex = 7;
            this.label2.Tag = "SID_PREVIEW_OF_FORMATE_WHEN_TRUE";
            // 
            // lblPreview1
            // 
            this.lblPreview1.BackColor = System.Drawing.Color.White;
            this.lblPreview1.Location = new System.Drawing.Point(152, 104);
            this.lblPreview1.Name = "lblPreview1";
            this.lblPreview1.Size = new System.Drawing.Size(240, 32);
            this.lblPreview1.TabIndex = 5;
            this.lblPreview1.Tag = "SID_PREVIEW";
            this.lblPreview1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(140, 23);
            this.label1.TabIndex = 0;
            this.label1.Tag = "SID_SELECTED_PROP_VALUE_IS";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // comboBox1
            // 
            this.comboBox1.ItemHeight = 13;
            this.comboBox1.Items.AddRange(new object[] {
            "between",
            "not between",
            "equal to",
            "not equal to",
            "greater than",
            "less than",
            "greater than or equal to",
            "less than or equal to"});
            this.comboBox1.Location = new System.Drawing.Point(72, 112);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(48, 21);
            this.comboBox1.TabIndex = 3;
            this.comboBox1.Visible = false;
            // 
            // pnlTxtCond1
            // 
            this.pnlTxtCond1.Controls.Add(this.label4);
            this.pnlTxtCond1.Controls.Add(this.txtMax1);
            this.pnlTxtCond1.Controls.Add(this.txtMin1);
            this.pnlTxtCond1.Location = new System.Drawing.Point(144, 32);
            this.pnlTxtCond1.Name = "pnlTxtCond1";
            this.pnlTxtCond1.Size = new System.Drawing.Size(272, 32);
            this.pnlTxtCond1.TabIndex = 6;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(112, 8);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(30, 23);
            this.label4.TabIndex = 7;
            this.label4.Tag = "SID_AND";
            this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // txtMax1
            // 
            this.txtMax1.Location = new System.Drawing.Point(144, 8);
            this.txtMax1.Name = "txtMax1";
            this.txtMax1.Size = new System.Drawing.Size(100, 20);
            this.txtMax1.TabIndex = 4;
            // 
            // txtMin1
            // 
            this.txtMin1.Location = new System.Drawing.Point(8, 8);
            this.txtMin1.Name = "txtMin1";
            this.txtMin1.Size = new System.Drawing.Size(100, 20);
            this.txtMin1.TabIndex = 3;
            // 
            // pnlEVV1
            // 
            this.pnlEVV1.Controls.Add(this.cmbEVV1);
            this.pnlEVV1.Location = new System.Drawing.Point(144, 32);
            this.pnlEVV1.Name = "pnlEVV1";
            this.pnlEVV1.Size = new System.Drawing.Size(272, 32);
            this.pnlEVV1.TabIndex = 8;
            this.pnlEVV1.Visible = false;
            // 
            // cmbEVV1
            // 
            this.cmbEVV1.FormattingEnabled = true;
            this.cmbEVV1.Location = new System.Drawing.Point(10, 5);
            this.cmbEVV1.Name = "cmbEVV1";
            this.cmbEVV1.Size = new System.Drawing.Size(122, 21);
            this.cmbEVV1.TabIndex = 11;
            // 
            // splitter2
            // 
            this.splitter2.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter2.Enabled = false;
            this.splitter2.Location = new System.Drawing.Point(6, 150);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(420, 3);
            this.splitter2.TabIndex = 11;
            this.splitter2.TabStop = false;
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.lblIsInRange2);
            this.groupBox2.Controls.Add(this.btnSetColor2);
            this.groupBox2.Controls.Add(this.btnFormat2);
            this.groupBox2.Controls.Add(this.label3);
            this.groupBox2.Controls.Add(this.lblPreView2);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.pnlTxtCond2);
            this.groupBox2.Controls.Add(this.pnlEVV2);
            this.groupBox2.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.groupBox2.Location = new System.Drawing.Point(6, 153);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(420, 142);
            this.groupBox2.TabIndex = 10;
            this.groupBox2.TabStop = false;
            // 
            // lblIsInRange2
            // 
            this.lblIsInRange2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblIsInRange2.Location = new System.Drawing.Point(16, 40);
            this.lblIsInRange2.Name = "lblIsInRange2";
            this.lblIsInRange2.Size = new System.Drawing.Size(128, 16);
            this.lblIsInRange2.TabIndex = 11;
            this.lblIsInRange2.Tag = "SID_IN_RANGE";
            this.lblIsInRange2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // btnSetColor2
            // 
            this.btnSetColor2.Location = new System.Drawing.Point(280, 72);
            this.btnSetColor2.Name = "btnSetColor2";
            this.btnSetColor2.Size = new System.Drawing.Size(112, 24);
            this.btnSetColor2.TabIndex = 11;
            this.btnSetColor2.Tag = "SID_SET_BACK_COLOR";
            this.btnSetColor2.Click += new System.EventHandler(this.btnSetColor2_Click);
            // 
            // btnFormat2
            // 
            this.btnFormat2.Location = new System.Drawing.Point(152, 72);
            this.btnFormat2.Name = "btnFormat2";
            this.btnFormat2.Size = new System.Drawing.Size(112, 24);
            this.btnFormat2.TabIndex = 10;
            this.btnFormat2.Tag = "SID_SET_FONT";
            this.btnFormat2.Click += new System.EventHandler(this.btnFormat2_Click);
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(24, 104);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(136, 32);
            this.label3.TabIndex = 7;
            this.label3.Tag = "SID_PREVIEW_OF_FORMATE_WHEN_TRUE";
            // 
            // lblPreView2
            // 
            this.lblPreView2.BackColor = System.Drawing.Color.White;
            this.lblPreView2.Location = new System.Drawing.Point(152, 104);
            this.lblPreView2.Name = "lblPreView2";
            this.lblPreView2.Size = new System.Drawing.Size(240, 32);
            this.lblPreView2.TabIndex = 5;
            this.lblPreView2.Tag = "SID_PREVIEW";
            this.lblPreView2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(8, 16);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(140, 23);
            this.label6.TabIndex = 0;
            this.label6.Tag = "SID_SELECTED_PROP_VALUE_IS";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // pnlTxtCond2
            // 
            this.pnlTxtCond2.Controls.Add(this.label7);
            this.pnlTxtCond2.Controls.Add(this.txtMax2);
            this.pnlTxtCond2.Controls.Add(this.txtMin2);
            this.pnlTxtCond2.Location = new System.Drawing.Point(144, 32);
            this.pnlTxtCond2.Name = "pnlTxtCond2";
            this.pnlTxtCond2.Size = new System.Drawing.Size(272, 32);
            this.pnlTxtCond2.TabIndex = 6;
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(112, 8);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(30, 23);
            this.label7.TabIndex = 7;
            this.label7.Tag = "SID_AND";
            this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // txtMax2
            // 
            this.txtMax2.Location = new System.Drawing.Point(144, 8);
            this.txtMax2.Name = "txtMax2";
            this.txtMax2.Size = new System.Drawing.Size(100, 20);
            this.txtMax2.TabIndex = 9;
            // 
            // txtMin2
            // 
            this.txtMin2.Location = new System.Drawing.Point(8, 8);
            this.txtMin2.Name = "txtMin2";
            this.txtMin2.Size = new System.Drawing.Size(100, 20);
            this.txtMin2.TabIndex = 8;
            // 
            // pnlEVV2
            // 
            this.pnlEVV2.Controls.Add(this.cmbEVV2);
            this.pnlEVV2.Location = new System.Drawing.Point(144, 32);
            this.pnlEVV2.Name = "pnlEVV2";
            this.pnlEVV2.Size = new System.Drawing.Size(272, 32);
            this.pnlEVV2.TabIndex = 12;
            this.pnlEVV2.Visible = false;
            // 
            // cmbEVV2
            // 
            this.cmbEVV2.FormattingEnabled = true;
            this.cmbEVV2.Location = new System.Drawing.Point(10, 5);
            this.cmbEVV2.Name = "cmbEVV2";
            this.cmbEVV2.Size = new System.Drawing.Size(122, 21);
            this.cmbEVV2.TabIndex = 11;
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.btnSetColor3);
            this.groupBox3.Controls.Add(this.btnFormat3);
            this.groupBox3.Controls.Add(this.label8);
            this.groupBox3.Controls.Add(this.lblPreView3);
            this.groupBox3.Controls.Add(this.label10);
            this.groupBox3.Controls.Add(this.lblIsInRange3);
            this.groupBox3.Controls.Add(this.pnlTxtComd3);
            this.groupBox3.Controls.Add(this.pnlEVV3);
            this.groupBox3.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.groupBox3.Location = new System.Drawing.Point(6, 295);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(420, 142);
            this.groupBox3.TabIndex = 10;
            this.groupBox3.TabStop = false;
            // 
            // btnSetColor3
            // 
            this.btnSetColor3.Location = new System.Drawing.Point(280, 72);
            this.btnSetColor3.Name = "btnSetColor3";
            this.btnSetColor3.Size = new System.Drawing.Size(112, 24);
            this.btnSetColor3.TabIndex = 16;
            this.btnSetColor3.Tag = "SID_SET_BACK_COLOR";
            this.btnSetColor3.Click += new System.EventHandler(this.btnSetColor3_Click);
            // 
            // btnFormat3
            // 
            this.btnFormat3.Location = new System.Drawing.Point(152, 72);
            this.btnFormat3.Name = "btnFormat3";
            this.btnFormat3.Size = new System.Drawing.Size(112, 24);
            this.btnFormat3.TabIndex = 15;
            this.btnFormat3.Tag = "SID_SET_FONT";
            this.btnFormat3.Click += new System.EventHandler(this.btnFormat3_Click);
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(24, 104);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(136, 32);
            this.label8.TabIndex = 7;
            this.label8.Tag = "SID_PREVIEW_OF_FORMATE_WHEN_TRUE";
            // 
            // lblPreView3
            // 
            this.lblPreView3.BackColor = System.Drawing.Color.White;
            this.lblPreView3.Location = new System.Drawing.Point(152, 104);
            this.lblPreView3.Name = "lblPreView3";
            this.lblPreView3.Size = new System.Drawing.Size(240, 32);
            this.lblPreView3.TabIndex = 5;
            this.lblPreView3.Tag = "SID_PREVIEW";
            this.lblPreView3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(8, 16);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(140, 23);
            this.label10.TabIndex = 0;
            this.label10.Tag = "SID_SELECTED_PROP_VALUE_IS";
            this.label10.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // lblIsInRange3
            // 
            this.lblIsInRange3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblIsInRange3.Location = new System.Drawing.Point(16, 40);
            this.lblIsInRange3.Name = "lblIsInRange3";
            this.lblIsInRange3.Size = new System.Drawing.Size(128, 16);
            this.lblIsInRange3.TabIndex = 12;
            this.lblIsInRange3.Tag = "SID_IN_RANGE";
            this.lblIsInRange3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // pnlTxtComd3
            // 
            this.pnlTxtComd3.Controls.Add(this.label11);
            this.pnlTxtComd3.Controls.Add(this.txtMax3);
            this.pnlTxtComd3.Controls.Add(this.txtMin3);
            this.pnlTxtComd3.Location = new System.Drawing.Point(144, 32);
            this.pnlTxtComd3.Name = "pnlTxtComd3";
            this.pnlTxtComd3.Size = new System.Drawing.Size(272, 32);
            this.pnlTxtComd3.TabIndex = 6;
            // 
            // label11
            // 
            this.label11.Location = new System.Drawing.Point(112, 8);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(30, 23);
            this.label11.TabIndex = 7;
            this.label11.Tag = "SID_AND";
            this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // txtMax3
            // 
            this.txtMax3.Location = new System.Drawing.Point(144, 8);
            this.txtMax3.Name = "txtMax3";
            this.txtMax3.Size = new System.Drawing.Size(100, 20);
            this.txtMax3.TabIndex = 14;
            // 
            // txtMin3
            // 
            this.txtMin3.Location = new System.Drawing.Point(8, 8);
            this.txtMin3.Name = "txtMin3";
            this.txtMin3.Size = new System.Drawing.Size(100, 20);
            this.txtMin3.TabIndex = 13;
            // 
            // pnlEVV3
            // 
            this.pnlEVV3.Controls.Add(this.cmbEVV3);
            this.pnlEVV3.Location = new System.Drawing.Point(144, 32);
            this.pnlEVV3.Name = "pnlEVV3";
            this.pnlEVV3.Size = new System.Drawing.Size(272, 32);
            this.pnlEVV3.TabIndex = 17;
            this.pnlEVV3.Visible = false;
            // 
            // cmbEVV3
            // 
            this.cmbEVV3.FormattingEnabled = true;
            this.cmbEVV3.Location = new System.Drawing.Point(10, 5);
            this.cmbEVV3.Name = "cmbEVV3";
            this.cmbEVV3.Size = new System.Drawing.Size(122, 21);
            this.cmbEVV3.TabIndex = 11;
            // 
            // fontDialog1
            // 
            this.fontDialog1.AllowScriptChange = false;
            this.fontDialog1.AllowSimulations = false;
            this.fontDialog1.AllowVectorFonts = false;
            this.fontDialog1.AllowVerticalFonts = false;
            this.fontDialog1.FontMustExist = true;
            this.fontDialog1.ScriptsOnly = true;
            this.fontDialog1.ShowColor = true;
            this.fontDialog1.Apply += new System.EventHandler(this.fontDialog_Apply);
            // 
            // pnlMain
            // 
            this.pnlMain.Controls.Add(this.splitter1);
            this.pnlMain.Controls.Add(this.pnlLeft);
            this.pnlMain.Controls.Add(this.pnlRight);
            this.pnlMain.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlMain.Location = new System.Drawing.Point(5, 5);
            this.pnlMain.Name = "pnlMain";
            this.pnlMain.Size = new System.Drawing.Size(892, 443);
            this.pnlMain.TabIndex = 0;
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
            this.splitter1.Enabled = false;
            this.splitter1.Location = new System.Drawing.Point(457, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(3, 443);
            this.splitter1.TabIndex = 3;
            this.splitter1.TabStop = false;
            // 
            // splitter4
            // 
            this.splitter4.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter4.Location = new System.Drawing.Point(5, 448);
            this.splitter4.Name = "splitter4";
            this.splitter4.Size = new System.Drawing.Size(892, 3);
            this.splitter4.TabIndex = 2;
            this.splitter4.TabStop = false;
            // 
            // pnlBottom
            // 
            this.pnlBottom.Controls.Add(this.chkApplytoSymbol);
            this.pnlBottom.Controls.Add(this.lblError);
            this.pnlBottom.Controls.Add(this.btnCancel);
            this.pnlBottom.Controls.Add(this.btnOk);
            this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlBottom.Location = new System.Drawing.Point(5, 448);
            this.pnlBottom.Name = "pnlBottom";
            this.pnlBottom.Size = new System.Drawing.Size(892, 50);
            this.pnlBottom.TabIndex = 1;
            // 
            // chkApplytoSymbol
            // 
            this.chkApplytoSymbol.AutoSize = true;
            this.chkApplytoSymbol.Location = new System.Drawing.Point(485, 20);
            this.chkApplytoSymbol.Name = "chkApplytoSymbol";
            this.chkApplytoSymbol.Size = new System.Drawing.Size(15, 14);
            this.chkApplytoSymbol.TabIndex = 19;
            this.chkApplytoSymbol.Tag = "SID_APPLY_TO_SYMBOL";
            this.chkApplytoSymbol.UseVisualStyleBackColor = true;
            // 
            // lblError
            // 
            this.lblError.Location = new System.Drawing.Point(24, 15);
            this.lblError.Name = "lblError";
            this.lblError.Size = new System.Drawing.Size(184, 24);
            this.lblError.TabIndex = 18;
            this.lblError.TextAlign = System.Drawing.ContentAlignment.BottomRight;
            // 
            // btnCancel
            // 
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.Location = new System.Drawing.Point(687, 11);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(75, 23);
            this.btnCancel.TabIndex = 17;
            this.btnCancel.Tag = "SID_CANCEL";
            // 
            // btnOk
            // 
            this.btnOk.Location = new System.Drawing.Point(783, 11);
            this.btnOk.Name = "btnOk";
            this.btnOk.Size = new System.Drawing.Size(75, 23);
            this.btnOk.TabIndex = 0;
            this.btnOk.Tag = "SID_OK";
            this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
            // 
            // splitter5
            // 
            this.splitter5.Location = new System.Drawing.Point(5, 451);
            this.splitter5.Name = "splitter5";
            this.splitter5.Size = new System.Drawing.Size(3, 47);
            this.splitter5.TabIndex = 3;
            this.splitter5.TabStop = false;
            // 
            // fontDialog2
            // 
            this.fontDialog2.AllowScriptChange = false;
            this.fontDialog2.AllowSimulations = false;
            this.fontDialog2.AllowVectorFonts = false;
            this.fontDialog2.AllowVerticalFonts = false;
            this.fontDialog2.FontMustExist = true;
            this.fontDialog2.ScriptsOnly = true;
            this.fontDialog2.ShowColor = true;
            // 
            // fontDialog3
            // 
            this.fontDialog3.AllowScriptChange = false;
            this.fontDialog3.AllowSimulations = false;
            this.fontDialog3.AllowVectorFonts = false;
            this.fontDialog3.AllowVerticalFonts = false;
            this.fontDialog3.FontMustExist = true;
            this.fontDialog3.ScriptsOnly = true;
            this.fontDialog3.ShowColor = true;
            // 
            // errorProvider1
            // 
            this.errorProvider1.ContainerControl = this;
            // 
            // ConditionalFormattingDialog
            // 
            this.AcceptButton = this.btnOk;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.btnCancel;
            this.ClientSize = new System.Drawing.Size(902, 503);
            this.Controls.Add(this.splitter5);
            this.Controls.Add(this.splitter4);
            this.Controls.Add(this.pnlBottom);
            this.Controls.Add(this.pnlMain);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.MinimumSize = new System.Drawing.Size(560, 162);
            this.Name = "ConditionalFormattingDialog";
            this.Padding = new System.Windows.Forms.Padding(5);
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Tag = "SID_CONDITIONAL_FORMATING";
            this.Closed += new System.EventHandler(this.ConditionalFormattingDialog_Closed);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.ConditionalFormattingDialog_Closing);
            this.pnlLeft.ResumeLayout(false);
            this.pnlModes.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridSiteCompProps)).EndInit();
            this.pnlRight.ResumeLayout(false);
            this.pnlCond1.ResumeLayout(false);
            this.grpBoxCondition.ResumeLayout(false);
            this.pnlTxtCond1.ResumeLayout(false);
            this.pnlTxtCond1.PerformLayout();
            this.pnlEVV1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.pnlTxtCond2.ResumeLayout(false);
            this.pnlTxtCond2.PerformLayout();
            this.pnlEVV2.ResumeLayout(false);
            this.groupBox3.ResumeLayout(false);
            this.pnlTxtComd3.ResumeLayout(false);
            this.pnlTxtComd3.PerformLayout();
            this.pnlEVV3.ResumeLayout(false);
            this.pnlMain.ResumeLayout(false);
            this.pnlBottom.ResumeLayout(false);
            this.pnlBottom.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.errorProvider1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

        /// <summary>
        /// Handles the DoubleClick event of the splitter1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void splitter1_DoubleClick(object sender, System.EventArgs e)
		{
			pnlLeft.Visible = !pnlLeft.Visible;
		}

        /// <summary>
        /// Handles the Click event of the btnFormat control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnFormat_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == fontDialog1.ShowDialog(this))
			{
				lblPreview1.Font = fontDialog1.Font;
				lblPreview1.ForeColor = fontDialog1.Color;
			}
		}

        /// <summary>
        /// Handles the Click event of the button1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void button1_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == colorDialog1.ShowDialog(this))
			{
				lblPreview1.BackColor = colorDialog1.Color;
			}
		}

		private void fontDialog_Apply(object sender, System.EventArgs e)
		{
		
		}

        bool isEVV = false;
        /// <summary>
        /// Handles the CurrentRecordContextChange event of the gridSiteCompProps control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Syncfusion.Grouping.CurrentRecordContextChangeEventArgs"/> instance containing the event data.</param>
		private void gridSiteCompProps_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			if(e.Action == Syncfusion.Grouping.CurrentRecordAction.NavigateComplete)
			{
				LRRPlantItemProperty plProp =  gridSiteCompProps.CurrencyManager.Current as LRRPlantItemProperty;
				IProperty						myProp = null;
				
				if(plProp.ID != null)
				{
					if(plProp.GroupPropertyID == null && plProp.ID != null)
					{
						if(_myISymbolMapping is Symcon.LightRidge.PEAdvisor.AggregatesMapping)
						{
							myProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(plProp.ID);
						}
						else
						{
							myProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(plProp.ID);
						}
					}
					else if(plProp.GroupPropertyID != null)
					{
						myProp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(plProp.GroupPropertyID);
					}
				}

                string uomTypeID = myProp.GetUOMType();
                if (uomTypeID != null && uomTypeID.Trim() != "")
                {
                    LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
                    if (lrrUOMType != null && lrrUOMType.IsEVV)
                    {
                        ArrayList evvs1 = LRRModel.ChildModel.EvvDictionary.Get(lrrUOMType.UOMTypeID);
                        ArrayList evvs2 = LRRModel.ChildModel.EvvDictionary.Get(lrrUOMType.UOMTypeID);
                        ArrayList evvs3 = LRRModel.ChildModel.EvvDictionary.Get(lrrUOMType.UOMTypeID);
                        if (evvs1 != null)
                        {
                            pnlTxtCond1.Visible = false;
                            pnlEVV1.Visible = true;
                            cmbEVV1.DataSource = evvs1;
                            cmbEVV1.DisplayMember = "EVVValue";
                            cmbEVV1.ValueMember = "EVVID";

                            pnlTxtCond2.Visible = false;
                            pnlEVV2.Visible = true;
                            cmbEVV2.DataSource = evvs1.Clone();
                            cmbEVV2.DisplayMember = "EVVValue";
                            cmbEVV2.ValueMember = "EVVID";

                            pnlTxtComd3.Visible = false;
                            pnlEVV3.Visible = true;
                            cmbEVV3.DataSource = evvs1.Clone();
                            cmbEVV3.DisplayMember = "EVVValue";
                            cmbEVV3.ValueMember = "EVVID";
                            isEVV = true;
                        }
                    }
                    else 
                    {
                        pnlTxtCond1.Visible = true;
                        pnlEVV1.Visible = false;

                        pnlTxtCond2.Visible = true;
                        pnlEVV2.Visible = false;

                        pnlTxtComd3.Visible = true;
                        pnlEVV3.Visible = false;
                        isEVV = false;
                    }
                }

				if(_myISymbolMapping is  Symcon.LightRidge.PEAdvisor.AggregatesMapping)
				{
                    lscpv = new List<IPropertyValue>();
					lscpv = LRRModel.AggregatePropertyValuesObj.GetPropValuesByPropID(plProp.ID);   
				}
				else
				{
					if(myProp.GetPropertyType() == "1")
                    {
                        lscpv = new List<IPropertyValue>();
						lscpv = LRRModel.PropertyValuesObj.GetPropValuesByPropID(myProp.GetID());     
					}
					else
					{
						if(plProp.LookupQualifierID != null && plProp.LookupQualifierID.Trim() != "")
							lscpv = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValuesFromGrpPropIdAndLkupQualId(plProp.GroupPropertyID,plProp.LookupQualifierID);
						else
							lscpv = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesinArrayFromGroupPropID(plProp.GroupPropertyID);
					}
				}
				if(lscpv != null)
				{
					groupBox1.Controls.Clear();
					int yPos = 30;
					lscpv.Sort(_propertyValuesSortOnMode);
					
					foreach(IPropertyValue ipropVal in lscpv)
					{
						//LRRModel.ProjectModes.SortColumn = "ModeName";
						//LRRModel.ProjectModes.Sort();
						LRRMode lrrmode = LRRModel.ProjectModes.GetModeByID(ipropVal.GetModeID());
						RadioButton rb = new RadioButton();
						rb.Text = lrrmode.ModeName;
						rb.Tag = lrrmode;
						groupBox1.Controls.Add(rb);
						rb.Location = new Point(20,yPos);
						yPos = yPos+30;
					}
				}
				_selectedItem = myProp;	
				if(plProp.CondFormatsObj != null)
				{
					ResetAllControls();
					ApplyConditionalFormatInfo(plProp.CondFormatsObj);
				}
				else
				{
					ResetAllControls();

				}
			}

		}

        private PropertyValuesSorter<IPropertyValue> _propertyValuesSortOnMode = new PropertyValuesSorter<IPropertyValue>();

        /// <summary>
        /// Resets all controls.
        /// </summary>
        private void ResetAllControls()
		{
			chkCondition2.Checked = false;
			chkCondition3.Checked = false;
			colorDialog2.Reset();
			colorDialog3.Reset();
			colorDialog1.Reset();
			fontDialog1.Reset();
			fontDialog2.Reset();
			fontDialog3.Reset();
			fontDialog1.ShowColor = true;
			fontDialog2.ShowColor = true;
			fontDialog3.ShowColor = true;
			lblPreview1.BackColor = System.Drawing.Color.White;;
			lblPreView2.BackColor = System.Drawing.Color.White;;
			lblPreView3.BackColor = System.Drawing.Color.White;;
			lblPreview1.ForeColor = SystemColors.Control;
			lblPreView2.ForeColor = SystemColors.Control;
			lblPreView3.ForeColor = SystemColors.Control;
			lblPreview1.Font = defaultFont;
			lblPreView2.Font = defaultFont;
			lblPreView3.Font = defaultFont;
			lblPreView2.ForeColor = fontDialog2.Color;
			txtMax1.Text = "";
			txtMax2.Text = "";
			txtMax3.Text = "";
			txtMin1.Text = "";
			txtMin2.Text = "";
			txtMin3.Text = "";
		}

        /// <summary>
        /// Applies the conditional format info.
        /// </summary>
        /// <param name="condFormatsObj">The cond formats obj.</param>
		private void ApplyConditionalFormatInfo(ConditionalFormats condFormatsObj)
		{
			foreach(ConditionalFormat condiFormat in condFormatsObj.CondFormats)
			{
				switch(condiFormat.ConditionID)
				{
					case "1":
					{
						fontDialog1.Color =  Color.FromArgb(Int32.Parse(condiFormat.ForeColor));
						colorDialog1.Color = Color.FromArgb(Int32.Parse(condiFormat.BackColor));
						lblPreview1.ForeColor = Color.FromArgb(Int32.Parse(condiFormat.ForeColor));
						lblPreview1.BackColor = Color.FromArgb(Int32.Parse(condiFormat.BackColor));

                        
						foreach(RadioButton rb in groupBox1.Controls)
						{
							LRRMode lrrMode = rb.Tag as LRRMode;
							if(lrrMode.ModeId == condiFormat.ModeID)
							{
								rb.Checked = true;;
								break;
							}
						}
                        if (isEVV)
                        {
                            cmbEVV1.Text = "";
                            cmbEVV1.SelectedText = condiFormat.Condition;
                        }
                        else
                        {
                            txtMin1.Text = condiFormat.MinValue.ToString();
                            txtMax1.Text = condiFormat.MaxValue.ToString();
                        }
						break;
					}
					case "2":
					{
						chkCondition2.Checked = true;
						fontDialog2.Color = Color.FromArgb(Int32.Parse(condiFormat.ForeColor));
						colorDialog2.Color = Color.FromArgb(Int32.Parse(condiFormat.BackColor));
						lblPreView2.ForeColor = Color.FromArgb(Int32.Parse(condiFormat.ForeColor));
						lblPreView2.BackColor = Color.FromArgb(Int32.Parse(condiFormat.BackColor));

                        if (isEVV)
                        {
                            cmbEVV2.Text = "";
                            cmbEVV2.SelectedText = condiFormat.Condition;
                        }
                        else
                        {
                            txtMin2.Text = condiFormat.MinValue.ToString();
                            txtMax2.Text = condiFormat.MaxValue.ToString();
                        }
						break;
					}
					case "3":
					{
						chkCondition3.Checked = true;
						fontDialog3.Color = Color.FromArgb(Int32.Parse(condiFormat.ForeColor));
						colorDialog3.Color = Color.FromArgb(Int32.Parse(condiFormat.BackColor));
						lblPreView3.ForeColor = Color.FromArgb(Int32.Parse(condiFormat.ForeColor));
						lblPreView3.BackColor = Color.FromArgb(Int32.Parse(condiFormat.BackColor));
	

                        if (isEVV)
                        {
                            cmbEVV3.Text = "";
                            cmbEVV3.SelectedText = condiFormat.Condition;
                        }
                        else
                        {
                            txtMin3.Text = condiFormat.MinValue.ToString();
                            txtMax3.Text = condiFormat.MaxValue.ToString();
                        }
						break;
					}
				}
			}
		}
	
		private void ConditionalFormattingDialog_Closed(object sender, System.EventArgs e)
		{

		}

		private void ConditionalFormattingDialog_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
		}

        /// <summary>
        /// Handles the CheckedChanged event of the chkCondition2 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void chkCondition2_CheckedChanged(object sender, System.EventArgs e)
		{
			groupBox2.Enabled = chkCondition2.Checked;
			if(!chkCondition2.Checked)
				chkCondition3.Checked = false;
		}

        /// <summary>
        /// Handles the CheckedChanged event of the checkBox1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			if(!chkCondition2.Checked && chkCondition3.Checked)
			{
				chkCondition3.Checked = false;
				groupBox3.Enabled = chkCondition3.Checked;
			}
			else
			{
				groupBox3.Enabled = chkCondition3.Checked;
			}
		}


        /// <summary>
        /// Handles the Click event of the btnOk control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnOk_Click(object sender, System.EventArgs e)
		{ 
			if(_selectedItem == null)
			{
				errorProvider1.SetError(lblError,LRRHeaderText.GetHeaderString("SID_ATTRIBUTE_NOT_SELECTED"));
				lblError.Text = LRRHeaderText.GetHeaderString("SID_ATTRIBUTE_NOT_SELECTED");
				return;
			}
			else
			{
                errorProvider1.SetError(lblError, "");
				lblError.Text = "";
			}

            if (isEVV)
            {
                foreach (RadioButton rb in groupBox1.Controls)
                {
                    if (rb.Checked)
                    {
                        _selectedMode = rb.Tag as LRRMode;
                        break;
                    }
                }

                if (_selectedMode != null)
                {
                    errorProvider1.SetError(lblError, "");
                    lblError.Text = "";

                    int conditionCount = 1;
                    if (chkCondition2.Checked)
                        conditionCount = conditionCount + 1;
                    if (chkCondition3.Checked)
                        conditionCount = conditionCount + 1;


                    LRRSiteComponentProperty scp = _selectedItem as LRRSiteComponentProperty;
                    ConditionalFormats condFormatsObj = new ConditionalFormats();
                    ConditionalFormat[] condFormats = new ConditionalFormat[conditionCount];
                    condFormats[0] = new ConditionalFormat();
                    condFormats[0].ConditionID = "1";
                    condFormats[0].Condition = cmbEVV1.Text;

                    condFormats[0].ID = Guid.NewGuid().ToString();
                    condFormats[0].PropertyID = scp.ID;
                    condFormats[0].ModeID = _selectedMode.ModeId;
                    condFormats[0].Italic = fontDialog1.Font.Italic;
                    condFormats[0].UnderLine = fontDialog1.Font.Underline;
                    condFormats[0].Bold = fontDialog1.Font.Bold;
                    condFormats[0].StrikeOut = fontDialog1.Font.Strikeout;
                    //   condFormats[0].MinValue = Int32.Parse(txtMin1.Text);
                    //  condFormats[0].MaxValue = Int32.Parse(txtMax1.Text);
                    condFormats[0].FontSize = (int)fontDialog1.Font.Size;
                    condFormats[0].FontName = fontDialog1.Font.Name;
                    condFormats[0].ForeColor = fontDialog1.Color.ToArgb().ToString();
                    condFormats[0].BackColor = colorDialog1.Color.ToArgb().ToString();


                    if (condFormats.Length > 1)
                    {
                        condFormats[1] = new ConditionalFormat();
                        condFormats[1].ConditionID = "2";
                        condFormats[1].Condition = cmbEVV2.Text;

                        condFormats[1].ID = Guid.NewGuid().ToString();
                        condFormats[1].PropertyID = scp.ID;
                        condFormats[1].ModeID = _selectedMode.ModeId;
                        condFormats[1].Italic = fontDialog2.Font.Italic;
                        condFormats[1].UnderLine = fontDialog2.Font.Underline;
                        condFormats[1].Bold = fontDialog2.Font.Bold;
                        condFormats[1].StrikeOut = fontDialog2.Font.Strikeout;
                        //condFormats[1].MinValue = Int32.Parse(txtMin2.Text);
                        //condFormats[1].MaxValue = Int32.Parse(txtMax2.Text);
                        condFormats[1].FontSize = (int)fontDialog2.Font.Size;
                        condFormats[1].FontName = fontDialog2.Font.Name;
                        condFormats[1].ForeColor = fontDialog2.Color.ToArgb().ToString();
                        condFormats[1].BackColor = colorDialog2.Color.ToArgb().ToString();

                    }

                    if (condFormats.Length > 2)
                    {
                        condFormats[2] = new ConditionalFormat();
                        condFormats[2].ConditionID = "3";
                        condFormats[2].Condition = cmbEVV3.Text;

                        condFormats[2].ID = Guid.NewGuid().ToString();
                        condFormats[2].PropertyID = scp.ID;
                        condFormats[2].ModeID = _selectedMode.ModeId;
                        condFormats[2].Italic = fontDialog3.Font.Italic;
                        condFormats[2].UnderLine = fontDialog3.Font.Underline;
                        condFormats[2].Bold = fontDialog3.Font.Bold;
                        condFormats[2].StrikeOut = fontDialog3.Font.Strikeout;
                        //condFormats[2].MinValue = Int32.Parse(txtMin3.Text);
                        //  condFormats[2].MaxValue = Int32.Parse(txtMax3.Text);
                        condFormats[2].FontSize = (int)fontDialog3.Font.Size;
                        condFormats[2].FontName = fontDialog3.Font.Name;
                        condFormats[2].ForeColor = fontDialog3.Color.ToArgb().ToString();
                        condFormats[2].BackColor = colorDialog3.Color.ToArgb().ToString();

                    }
                    if (scp.ConditionalFormatXML != null)
                    {
                        LRRConditionalFormat lrrCondFormat = LRRModel.ConditionalFormatObj.GetFormatByPropertyID(scp.ID);
                        lrrCondFormat.ObjectState = Globals.Enums.DBOperation.DELETE;
                        LRRModel.ConditionalFormatObj.Remove(lrrCondFormat);
                        _app.DBManagerObj.CommitObject(lrrCondFormat);
                    }

                    condFormatsObj.CondFormats = condFormats;
                    scp.ConditionalFormatsObj = condFormatsObj;
                    LRRConditionalFormat condit = new LRRConditionalFormat();
                    condit.PropertyID = scp.ID;
                    condit.FormatXml = scp.ConditionalFormatXML;

                    _app.DBManagerObj.CommitObject(condit);
                    LRRModel.ConditionalFormatObj.Add(condit);
                    _selectedPropertyValue = (LRRSiteComponentPropertyValue)scp.GetPropertyValueForMode(_selectedMode.ModeId);
                    this.DialogResult = DialogResult.OK;
                }
                else
                {
                    errorProvider1.SetError(lblError, LRRHeaderText.GetHeaderString("SID_MODE_NOT_SELECTED"));
                    lblError.Text = LRRHeaderText.GetHeaderString("SID_MODE_NOT_SELECTED");
                    return;
                }
            }
            else
            {
                bool isValidated = true;
                ValidateForNumeric(txtMin1, ref isValidated);
                ValidateForNumeric(txtMax1, ref isValidated);

                if (!isValidated)
                    return;

                if (chkCondition2.Checked)
                {
                    ValidateForNumeric(txtMin2, ref isValidated);
                    ValidateForNumeric(txtMax2, ref isValidated);
                    if (!isValidated)
                        return;
                    bool isInRange = false;
                    double min1 = double.Parse(txtMin1.Text);
                    double max1 = double.Parse(txtMax1.Text);
                    double min2 = double.Parse(txtMin2.Text);
                    double max2 = double.Parse(txtMax2.Text);

                    isInRange = Symcon.Utils.Validator.Validator.IsDoubleNumberInRange(min2, min1, max1);
                    if (isInRange)
                    {
                        errorProvider1.SetError(txtMin2, LRRHeaderText.GetHeaderString("SID_RANGE_OVERLAPE_WITH_C1"));
                        return;
                    }

                    isInRange = Symcon.Utils.Validator.Validator.IsDoubleNumberInRange(max2, min1, max1);
                    if (isInRange)
                    {
                        errorProvider1.SetError(txtMax2, LRRHeaderText.GetHeaderString("SID_RANGE_OVERLAPE_WITH_C1"));
                        return;
                    }
                }

                if (chkCondition3.Checked)
                {
                    ValidateForNumeric(txtMin3, ref isValidated);
                    ValidateForNumeric(txtMax3, ref isValidated);
                    if (!isValidated)
                        return;
                    bool isInRange = false;
                    double min2 = double.Parse(txtMin2.Text);
                    double max2 = double.Parse(txtMax2.Text);
                    double min3 = double.Parse(txtMin3.Text);
                    double max3 = double.Parse(txtMax3.Text);

                    isInRange = Symcon.Utils.Validator.Validator.IsDoubleNumberInRange(min3, min2, max2);
                    if (isInRange)
                    {
                        errorProvider1.SetError(txtMin3, LRRHeaderText.GetHeaderString("SID_RANGE_OVERLAPE_WITH_C2"));
                        return;
                    }

                    isInRange = Symcon.Utils.Validator.Validator.IsDoubleNumberInRange(max3, min2, max2);
                    if (isInRange)
                    {
                        errorProvider1.SetError(txtMax3, LRRHeaderText.GetHeaderString("SID_RANGE_OVERLAPE_WITH_C2"));
                        return;
                    }
                }
                if (!isValidated)
                    return;


                foreach (RadioButton rb in groupBox1.Controls)
                {
                    if (rb.Checked)
                    {
                        _selectedMode = rb.Tag as LRRMode;
                        break;
                    }
                }

                if (_selectedMode != null)
                {
                    errorProvider1.SetError(lblError, "");
                    lblError.Text = "";

                    int conditionCount = 1;
                    if (chkCondition2.Checked)
                        conditionCount = conditionCount + 1;
                    if (chkCondition3.Checked)
                        conditionCount = conditionCount + 1;


                    IProperty scp = _selectedItem;
                    ConditionalFormats condFormatsObj = new ConditionalFormats();
                    ConditionalFormat[] condFormats = new ConditionalFormat[conditionCount];
                    condFormats[0] = new ConditionalFormat();
                    condFormats[0].ConditionID = "1";
                    condFormats[0].Condition = lblIsinRange1.Text;

                    condFormats[0].ID = Guid.NewGuid().ToString();
                    condFormats[0].PropertyID = scp.GetID();
                    condFormats[0].ModeID = _selectedMode.ModeId;
                    condFormats[0].Italic = fontDialog1.Font.Italic;
                    condFormats[0].UnderLine = fontDialog1.Font.Underline;
                    condFormats[0].Bold = fontDialog1.Font.Bold;
                    condFormats[0].StrikeOut = fontDialog1.Font.Strikeout;
                    condFormats[0].MinValue = double.Parse(txtMin1.Text);
                    condFormats[0].MaxValue = double.Parse(txtMax1.Text);
                    condFormats[0].FontSize = (int)fontDialog1.Font.Size;
                    condFormats[0].FontName = fontDialog1.Font.Name;
                    condFormats[0].ForeColor = fontDialog1.Color.ToArgb().ToString();
                    condFormats[0].BackColor = colorDialog1.Color.ToArgb().ToString();

                    if (condFormats.Length > 1)
                    {
                        condFormats[1] = new ConditionalFormat();
                        condFormats[1].ConditionID = "2";
                        condFormats[1].Condition = lblIsInRange2.Text;

                        condFormats[1].ID = Guid.NewGuid().ToString();
                        condFormats[1].PropertyID = scp.GetID();
                        condFormats[1].ModeID = _selectedMode.ModeId;
                        condFormats[1].Italic = fontDialog2.Font.Italic;
                        condFormats[1].UnderLine = fontDialog2.Font.Underline;
                        condFormats[1].Bold = fontDialog2.Font.Bold;
                        condFormats[1].StrikeOut = fontDialog2.Font.Strikeout;
                        condFormats[1].MinValue = double.Parse(txtMin2.Text);
                        condFormats[1].MaxValue = double.Parse(txtMax2.Text);
                        condFormats[1].FontSize = (int)fontDialog2.Font.Size;
                        condFormats[1].FontName = fontDialog2.Font.Name;
                        condFormats[1].ForeColor = fontDialog2.Color.ToArgb().ToString();
                        condFormats[1].BackColor = colorDialog2.Color.ToArgb().ToString();

                    }

                    if (condFormats.Length > 2)
                    {
                        condFormats[2] = new ConditionalFormat();
                        condFormats[2].ConditionID = "3";
                        condFormats[2].Condition = lblIsInRange3.Text;

                        condFormats[2].ID = Guid.NewGuid().ToString();
                        condFormats[2].PropertyID = scp.GetID();
                        condFormats[2].ModeID = _selectedMode.ModeId;
                        condFormats[2].Italic = fontDialog3.Font.Italic;
                        condFormats[2].UnderLine = fontDialog3.Font.Underline;
                        condFormats[2].Bold = fontDialog3.Font.Bold;
                        condFormats[2].StrikeOut = fontDialog3.Font.Strikeout;
                        condFormats[2].MinValue = double.Parse(txtMin3.Text);
                        condFormats[2].MaxValue = double.Parse(txtMax3.Text);
                        condFormats[2].FontSize = (int)fontDialog3.Font.Size;
                        condFormats[2].FontName = fontDialog3.Font.Name;
                        condFormats[2].ForeColor = fontDialog3.Color.ToArgb().ToString();
                        condFormats[2].BackColor = colorDialog3.Color.ToArgb().ToString();

                    }
                    if (scp.ConditionalFormatXML != null)
                    {
                        LRRConditionalFormat lrrCondFormat = LRRModel.ConditionalFormatObj.GetFormatByPropertyID(scp.GetID());
                        lrrCondFormat.ObjectState = Globals.Enums.DBOperation.DELETE;
                        LRRModel.ConditionalFormatObj.Remove(lrrCondFormat);
                        _app.DBManagerObj.CommitObject(lrrCondFormat);
                    }

                    condFormatsObj.CondFormats = condFormats;
                    scp.ConditionalFormatsObj = condFormatsObj;
                    LRRConditionalFormat condit = new LRRConditionalFormat();
                    condit.PropertyID = scp.GetID();
                    condit.FormatXml = scp.ConditionalFormatXML;

                    _app.DBManagerObj.CommitObject(condit);
                    LRRModel.ConditionalFormatObj.Add(condit);
                    _selectedPropertyValue = (IPropertyValue)scp.GetPropertyValueForMode(_selectedMode.ModeId);
                    this.DialogResult = DialogResult.OK;

                }
                else
                {
                    errorProvider1.SetError(lblError, LRRHeaderText.GetHeaderString("SID_MODE_NOT_SELECTED"));
                    lblError.Text = LRRHeaderText.GetHeaderString("SID_MODE_NOT_SELECTED");
                    return;
                }
            }
		}

        private IPropertyValue _selectedPropertyValue;

        /// <summary>
        /// Gets or sets the selected property value.
        /// </summary>
        /// <value>The selected property value.</value>
        public IPropertyValue SelectedPropertyValue
        {
            get { return _selectedPropertyValue; }
            set { _selectedPropertyValue = value; }
        }

        public bool IsSymbolSelected
        {
            get { return chkApplytoSymbol.Checked; }
        }

        /// <summary>
        /// Handles the Click event of the btnFormat2 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnFormat2_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == fontDialog2.ShowDialog(this))
			{
				lblPreView2.Font = fontDialog2.Font;
				lblPreView2.ForeColor = fontDialog2.Color;
			}
		}

        /// <summary>
        /// Handles the Click event of the btnFormat3 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnFormat3_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == fontDialog3.ShowDialog(this))
			{
				lblPreView3.Font = fontDialog3.Font;
				lblPreView3.ForeColor = fontDialog3.Color;
			}
		}

        /// <summary>
        /// Handles the Click event of the btnSetColor2 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnSetColor2_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == colorDialog2.ShowDialog(this))
			{
				lblPreView2.BackColor = colorDialog2.Color;
			}
		}

        /// <summary>
        /// Handles the Click event of the btnSetColor3 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private void btnSetColor3_Click(object sender, System.EventArgs e)
		{
			if(DialogResult.OK == colorDialog3.ShowDialog(this))
			{
				lblPreView3.BackColor = colorDialog3.Color;
			}
		}

        /// <summary>
        /// Validates for numeric.
        /// </summary>
        /// <param name="txtBox">The TXT box.</param>
        /// <param name="isValidated">if set to <c>true</c> [is validated].</param>
        /// <returns></returns>
		private bool ValidateForNumeric(TextBox txtBox,ref bool isValidated)
		{
			if(!Symcon.Utils.Validator.Validator.IsNumber(txtBox.Text) || txtBox.Text == "")
			{
                errorProvider1.SetError(txtBox, LRRHeaderText.GetHeaderString("SID_INVALID_NUMBER"));
				isValidated = false;
			}
			else
			{
				errorProvider1.SetError (txtBox, "");
			}
			return isValidated;
		}
	}
}

