using System;
using System.Collections;
using System.Data;
using System.ComponentModel;


namespace Symcon.LightRidge.PEAdvisor
{

	[Serializable()]
	public class LabelController 
	{
		private		Hashtable				symbolsCollection;
		private		Hashtable				businessObjectCollection;
		private		Hashtable				symbolObjectBinding;
		
		public LabelController()
		{
			#region Fields
			
			symbolsCollection			= new Hashtable();
			businessObjectCollection	= new Hashtable();
			symbolObjectBinding			= new Hashtable();
			
			#endregion
		}

		/// <summary>
		/// Collection of all the Symbols on the Canvas
		/// Updates in Canvas Children Changing Complete Event
		/// Name	: Symbol Name
		/// Value	: Symbol
		/// </summary>
		public Hashtable SymbolsCollection
		{
			get
			{
				return symbolsCollection;
			}
			set
			{
				symbolsCollection = value;
			}
		}

		/// <summary>
		/// Collection of Symbol And associated Object
		/// Name	: Symbol Name
		/// Value	: Business Object Associated With The Symbol
		/// Updates Name at ChildrenChangingComplete Event
		/// Updates Value at PropertyGridValue Changed Event
		/// </summary>
		public Hashtable BusinessObjectCollection
		{
			get
			{
				return businessObjectCollection;
			}
			set
			{
				businessObjectCollection = value;
			}
		}

		/// <summary>
		/// Collection of PropertyValues of BoundObject and Symbol Label
		/// Name	: BoundObject Property Name
		/// Value	: Symbol Label Property Name
		/// </summary>
		public Hashtable SymbolObjectBinding
		{
			get
			{
				return symbolObjectBinding;
			}
			set
			{
				symbolsCollection = value;
			}
		}

		private object GetBusinessObject()
		{
			object obj = new object();
			obj = symbolsCollection;
			return obj;
		}
	
	}

	/// <summary>
	/// 
	/// </summary>
	public class LabelLookup
	{
		private string symbolID;
		private string propertyID;
		private string propertyName;
		private object propertyValue;
		private string propertyMode;


		public LabelLookup()
		{

		}

		/// <summary>
		/// Name of the Symbol in SymbolObjectBinding Collection
		/// </summary>
		public string SymbolID
		{
			get
			{
				return symbolID;
			}
			set
			{
				symbolID = value;
			}
		}

		/// <summary>
		/// Name of the Property in SymbolObjectBinding Collection
		/// </summary>
		public string PropertyName
		{
			get
			{
				return propertyName;
			}
			set
			{
				propertyName = value;
			}
		}

		public object PropertyValue
		{
			get
			{
				return propertyValue;
			}
			set
			{
				propertyValue = value;
				if(PropertyValueChanged != null)
					PropertyValueChanged(this,"PropertyValue");
			}
		}

		
		public string PropertyMode
		{
			get
			{
				return propertyMode;
			}
			set
			{
				propertyMode = value;
			}
		}

		public string PropertyID
		{
			get
			{
				return propertyID;
			}
			set
			{
				propertyID = value;
			}
		}


		public event Symcon.LightRidge.BusinessObjects.PropertyChanged	PropertyValueChanged;
	}
}
