using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Symcon.LightRidge.PEAdvisor
{
    public partial class EditMarkersDialog : Form
    {
        private List<float> _verticalMarkers;
        private List<float> _hotizontalMarkers;
        private float _canvasWidth;
        private float _canvasHeight;
        public EditMarkersDialog()
        {
            InitializeComponent();
        }

        public EditMarkersDialog(List<float> verticalMarkers, List<float> hotizontalMarkers,float canvasWidth,float canvasHeight)
        {
            this._canvasWidth = canvasWidth;
            this._canvasHeight = canvasHeight;
            this._verticalMarkers = verticalMarkers;
            this._hotizontalMarkers = hotizontalMarkers;
            InitializeComponent();
        }

        private void btnAddMarker_Click(object sender, EventArgs e)
        {
            List<float> markers = listMarkers.Tag as List<float>;
            markers.Add(0.0f);
            listMarkers.Tag = markers;
            listMarkers.DataSource = null;
            listMarkers.DataSource = markers;
            listMarkers.SelectedIndex = markers.Count - 1;
           // txtSelectedMarker.Focus();
            msktxtSelectedMarker.Focus();
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            List<float> markers = listMarkers.Tag as List<float>;
            foreach (int var in listMarkers.SelectedIndices)
            {
                markers.RemoveAt(var);
                listMarkers.DataSource = null;
                listMarkers.DataSource = markers;
                listMarkers.Tag = markers;
                if (markers.Count != 0)
                {
                    listMarkers.SelectedIndex = var-1 == -1?var: var-1;
                }

            }
        }

        private void rbVerticalMarkers_CheckedChanged(object sender, EventArgs e)
        {
            if (rbVerticalMarkers.Checked)
            {
                //dgPoints.AutoGenerateColumns = true;
                //dgPoints.Columns.Clear();
                //dgPoints.Columns.Add("Value", "Value");
                //cmbMarkers.DataSource = _verticalMarkers;
                //cmbMarkers.Tag = _verticalMarkers;
                //cmbMarkers.DisplayMember = "Value";
                listMarkers.Tag = _verticalMarkers;
                listMarkers.DataSource = _verticalMarkers;
                
            }
            else if (rbHorizontalMarkers.Checked)
            {
                listMarkers.Tag = _hotizontalMarkers;
                listMarkers.DataSource = _hotizontalMarkers;
                
                //dgPoints.DataSource = _hotizontalMarkers;
                //dgPoints.Tag = _hotizontalMarkers;
            }
        }

        private void EditMarkersDialog_Load(object sender, EventArgs e)
        {
           // txtSelectedMarker.DataBindings.Add("Text", listMarkers, "SelectedValue");
           // txtSelectedMarker.DataBindings.Add("Tag", listMarkers, "SelectedIndex");
           
            if (_verticalMarkers.Count != 0)
            {
                rbVerticalMarkers.Checked = true;    
            }
            else if (_hotizontalMarkers.Count != 0)
            {
                rbHorizontalMarkers.Checked = true;    
            }
            
        }

    //    private void txtSelectedMarker_TextChanged(object sender, EventArgs e)
    //    {
    //        List<float> markers =  listMarkers.Tag as List<float>;

    //        if (listMarkers.SelectedIndex != -1 && txtSelectedMarker.Text != string.Empty)
    //{
    //    markers[listMarkers.SelectedIndex] = float.Parse(txtSelectedMarker.Text);
    //    listMarkers.DataSource = null;
    //    listMarkers.DataSource = markers;
    //    listMarkers.Refresh();
    //}
        //}

        private void listMarkers_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listMarkers.Tag != null && listMarkers.SelectedIndex != -1)
            {
                //txtSelectedMarker.Focus();
                //txtSelectedMarker.Text = ((List<float>)listMarkers.Tag)[listMarkers.SelectedIndex].ToString();
                msktxtSelectedMarker.Text = ((List<float>)listMarkers.Tag)[listMarkers.SelectedIndex].ToString();

                
            }
        }

        private void maskedTextBox1_TextChanged(object sender, EventArgs e)
        {
            List<float> markers = listMarkers.Tag as List<float>;
            if (msktxtSelectedMarker.Text != string.Empty && rbHorizontalMarkers.Checked && float.Parse(msktxtSelectedMarker.Text) > _canvasWidth )
            {
                MessageBox.Show("Invalid Value", "Invalid Marker", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            else if (msktxtSelectedMarker.Text != string.Empty && rbVerticalMarkers.Checked && float.Parse(msktxtSelectedMarker.Text) > _canvasHeight) 
            {
                MessageBox.Show("Invalid Value", "Invalid Marker", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (listMarkers.SelectedIndex != -1 && msktxtSelectedMarker.Text != string.Empty)
            {
                markers[listMarkers.SelectedIndex] = float.Parse(msktxtSelectedMarker.Text);
                listMarkers.DataSource = null;
                listMarkers.DataSource = markers;
                listMarkers.Refresh();
            }
        }
    }
}