using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Lightridge.LRRUI.Controls;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for GridDimensionDialog.
	/// </summary>
	public class GridDimensionDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlMain;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.RadioButton rdBtnGridDeminsions;
		private System.Windows.Forms.Panel pnlSelectedCellDim;
		private System.Windows.Forms.Panel pnlGridDim;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Button brnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.GroupBox grpDimensions;
		private System.Windows.Forms.Label lblGridRowSize;
		private System.Windows.Forms.Label lblCellColumnWidth;
		private System.Windows.Forms.NumericUpDown numTxtCellRowHeight;
		private System.Windows.Forms.NumericUpDown numTxtCellColumnWidth;
		private System.Windows.Forms.NumericUpDown numTxtGridRowHeight;
		private System.Windows.Forms.NumericUpDown numTxtGridColumnWidth;
		private DynamicGridcontainer _dGrid = null;
		private System.Windows.Forms.RadioButton rdBtnCellDeminsion;
		private System.Windows.Forms.Splitter splitter1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public GridDimensionDialog()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);

		}


		public GridDimensionDialog(DynamicGridcontainer dGrid)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);
			_dGrid = dGrid; 
			GridCell gCell = dGrid.SelectedCell;

			//numTxtCellColumnWidth.Value = (decimal)gCell.Width;
            numTxtCellColumnWidth.Value = (decimal)gCell.OffsetX;
            numTxtCellRowHeight.Value = (decimal)gCell.OffsetY;

			rdBtnCellDeminsion.Checked = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pnlMain = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.grpDimensions = new System.Windows.Forms.GroupBox();
			this.pnlGridDim = new System.Windows.Forms.Panel();
			this.numTxtGridColumnWidth = new System.Windows.Forms.NumericUpDown();
			this.numTxtGridRowHeight = new System.Windows.Forms.NumericUpDown();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.pnlSelectedCellDim = new System.Windows.Forms.Panel();
			this.numTxtCellColumnWidth = new System.Windows.Forms.NumericUpDown();
			this.numTxtCellRowHeight = new System.Windows.Forms.NumericUpDown();
			this.lblGridRowSize = new System.Windows.Forms.Label();
			this.lblCellColumnWidth = new System.Windows.Forms.Label();
			this.rdBtnGridDeminsions = new System.Windows.Forms.RadioButton();
			this.rdBtnCellDeminsion = new System.Windows.Forms.RadioButton();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.brnOK = new System.Windows.Forms.Button();
			this.pnlMain.SuspendLayout();
			this.panel2.SuspendLayout();
			this.grpDimensions.SuspendLayout();
			this.pnlGridDim.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numTxtGridColumnWidth)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numTxtGridRowHeight)).BeginInit();
			this.pnlSelectedCellDim.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numTxtCellColumnWidth)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numTxtCellRowHeight)).BeginInit();
			this.pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlMain
			// 
			this.pnlMain.Controls.Add(this.panel2);
			this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMain.Location = new System.Drawing.Point(0, 0);
			this.pnlMain.Name = "pnlMain";
			this.pnlMain.Size = new System.Drawing.Size(322, 239);
			this.pnlMain.TabIndex = 0;
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.splitter1);
			this.panel2.Controls.Add(this.grpDimensions);
			this.panel2.Controls.Add(this.pnlBottom);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(322, 239);
			this.panel2.TabIndex = 3;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 196);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(322, 3);
			this.splitter1.TabIndex = 7;
			this.splitter1.TabStop = false;
			// 
			// grpDimensions
			// 
			this.grpDimensions.Controls.Add(this.pnlGridDim);
			this.grpDimensions.Controls.Add(this.pnlSelectedCellDim);
			this.grpDimensions.Controls.Add(this.rdBtnGridDeminsions);
			this.grpDimensions.Controls.Add(this.rdBtnCellDeminsion);
			this.grpDimensions.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grpDimensions.Location = new System.Drawing.Point(0, 0);
			this.grpDimensions.Name = "grpDimensions";
			this.grpDimensions.Size = new System.Drawing.Size(322, 199);
			this.grpDimensions.TabIndex = 0;
			this.grpDimensions.TabStop = false;
			this.grpDimensions.Tag = "SID_CHANGE_DIMENSIONS_FOR";
			// 
			// pnlGridDim
			// 
			this.pnlGridDim.Controls.Add(this.numTxtGridColumnWidth);
			this.pnlGridDim.Controls.Add(this.numTxtGridRowHeight);
			this.pnlGridDim.Controls.Add(this.label2);
			this.pnlGridDim.Controls.Add(this.label3);
			this.pnlGridDim.Location = new System.Drawing.Point(8, 128);
			this.pnlGridDim.Name = "pnlGridDim";
			this.pnlGridDim.Size = new System.Drawing.Size(304, 56);
			this.pnlGridDim.TabIndex = 5;
			// 
			// numTxtGridColumnWidth
			// 
			this.numTxtGridColumnWidth.DecimalPlaces = 2;
			this.numTxtGridColumnWidth.Location = new System.Drawing.Point(136, 32);
			this.numTxtGridColumnWidth.Maximum = new System.Decimal(new int[] {
																				  500,
																				  0,
																				  0,
																				  0});
			this.numTxtGridColumnWidth.Name = "numTxtGridColumnWidth";
			this.numTxtGridColumnWidth.Size = new System.Drawing.Size(75, 20);
			this.numTxtGridColumnWidth.TabIndex = 9;
			this.numTxtGridColumnWidth.ThousandsSeparator = true;
			this.numTxtGridColumnWidth.Value = new System.Decimal(new int[] {
																				50,
																				0,
																				0,
																				0});
			// 
			// numTxtGridRowHeight
			// 
			this.numTxtGridRowHeight.DecimalPlaces = 2;
			this.numTxtGridRowHeight.Location = new System.Drawing.Point(136, 8);
			this.numTxtGridRowHeight.Maximum = new System.Decimal(new int[] {
																				500,
																				0,
																				0,
																				0});
			this.numTxtGridRowHeight.Name = "numTxtGridRowHeight";
			this.numTxtGridRowHeight.Size = new System.Drawing.Size(75, 20);
			this.numTxtGridRowHeight.TabIndex = 8;
			this.numTxtGridRowHeight.ThousandsSeparator = true;
			this.numTxtGridRowHeight.Value = new System.Decimal(new int[] {
																			  20,
																			  0,
																			  0,
																			  0});
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 20);
			this.label2.TabIndex = 2;
			this.label2.Tag = "SID_ROWS_HEIGHT";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 32);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 20);
			this.label3.TabIndex = 3;
			this.label3.Tag = "SID_COLS_WIDTH";
			// 
			// pnlSelectedCellDim
			// 
			this.pnlSelectedCellDim.Controls.Add(this.numTxtCellColumnWidth);
			this.pnlSelectedCellDim.Controls.Add(this.numTxtCellRowHeight);
			this.pnlSelectedCellDim.Controls.Add(this.lblGridRowSize);
			this.pnlSelectedCellDim.Controls.Add(this.lblCellColumnWidth);
			this.pnlSelectedCellDim.Location = new System.Drawing.Point(8, 40);
			this.pnlSelectedCellDim.Name = "pnlSelectedCellDim";
			this.pnlSelectedCellDim.Size = new System.Drawing.Size(304, 56);
			this.pnlSelectedCellDim.TabIndex = 4;
			// 
			// numTxtCellColumnWidth
			// 
			this.numTxtCellColumnWidth.DecimalPlaces = 2;
			this.numTxtCellColumnWidth.Location = new System.Drawing.Point(136, 32);
			this.numTxtCellColumnWidth.Maximum = new System.Decimal(new int[] {
																				  500,
																				  0,
																				  0,
																				  0});
			this.numTxtCellColumnWidth.Name = "numTxtCellColumnWidth";
			this.numTxtCellColumnWidth.Size = new System.Drawing.Size(75, 20);
			this.numTxtCellColumnWidth.TabIndex = 7;
			this.numTxtCellColumnWidth.ThousandsSeparator = true;
			// 
			// numTxtCellRowHeight
			// 
			this.numTxtCellRowHeight.DecimalPlaces = 2;
			this.numTxtCellRowHeight.Location = new System.Drawing.Point(136, 8);
			this.numTxtCellRowHeight.Maximum = new System.Decimal(new int[] {
																				500,
																				0,
																				0,
																				0});
			this.numTxtCellRowHeight.Name = "numTxtCellRowHeight";
			this.numTxtCellRowHeight.Size = new System.Drawing.Size(75, 20);
			this.numTxtCellRowHeight.TabIndex = 6;
			this.numTxtCellRowHeight.ThousandsSeparator = true;
			// 
			// lblGridRowSize
			// 
			this.lblGridRowSize.Location = new System.Drawing.Point(24, 8);
			this.lblGridRowSize.Name = "lblGridRowSize";
			this.lblGridRowSize.Size = new System.Drawing.Size(100, 20);
			this.lblGridRowSize.TabIndex = 2;
			this.lblGridRowSize.Tag = "SID_ROW_HEIGHT";
			// 
			// lblCellColumnWidth
			// 
			this.lblCellColumnWidth.Location = new System.Drawing.Point(24, 32);
			this.lblCellColumnWidth.Name = "lblCellColumnWidth";
			this.lblCellColumnWidth.Size = new System.Drawing.Size(100, 20);
			this.lblCellColumnWidth.TabIndex = 3;
			this.lblCellColumnWidth.Tag = "SID_COL_WIDTH";
			// 
			// rdBtnGridDeminsions
			// 
			this.rdBtnGridDeminsions.Location = new System.Drawing.Point(16, 104);
			this.rdBtnGridDeminsions.Name = "rdBtnGridDeminsions";
			this.rdBtnGridDeminsions.Size = new System.Drawing.Size(256, 24);
			this.rdBtnGridDeminsions.TabIndex = 1;
			this.rdBtnGridDeminsions.Tag = "SID_ALL_CELLS";
			this.rdBtnGridDeminsions.CheckedChanged += new System.EventHandler(this.rdBtnRowColumnDeminsion_CheckedChanged);
			// 
			// rdBtnCellDeminsion
			// 
			this.rdBtnCellDeminsion.Location = new System.Drawing.Point(16, 16);
			this.rdBtnCellDeminsion.Name = "rdBtnCellDeminsion";
			this.rdBtnCellDeminsion.Size = new System.Drawing.Size(256, 24);
			this.rdBtnCellDeminsion.TabIndex = 0;
			this.rdBtnCellDeminsion.Tag = "SID_ROW_COL_SELECTED_CELL";
			this.rdBtnCellDeminsion.CheckedChanged += new System.EventHandler(this.rdBtnRowColumnDeminsion_CheckedChanged);
			// 
			// pnlBottom
			// 
			this.pnlBottom.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlBottom.Controls.Add(this.btnCancel);
			this.pnlBottom.Controls.Add(this.brnOK);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.DockPadding.All = 10;
			this.pnlBottom.Location = new System.Drawing.Point(0, 199);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(322, 40);
			this.pnlBottom.TabIndex = 6;
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(232, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// brnOK
			// 
			this.brnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.brnOK.Location = new System.Drawing.Point(136, 8);
			this.brnOK.Name = "brnOK";
			this.brnOK.TabIndex = 0;
			this.brnOK.Tag = "SID_OK";
			this.brnOK.Click += new System.EventHandler(this.brnOK_Click);
			// 
			// GridDimensionDialog
			// 
			this.AcceptButton = this.brnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(322, 239);
			this.Controls.Add(this.pnlMain);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "GridDimensionDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Tag = "SID_GRID_DIMENSIONS_TITLE";
			this.pnlMain.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.grpDimensions.ResumeLayout(false);
			this.pnlGridDim.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numTxtGridColumnWidth)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numTxtGridRowHeight)).EndInit();
			this.pnlSelectedCellDim.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numTxtCellColumnWidth)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numTxtCellRowHeight)).EndInit();
			this.pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void brnOK_Click(object sender, System.EventArgs e)
		{
			if(rdBtnCellDeminsion.Checked)
			{
				_dGrid.ResizeColumn((float)numTxtCellColumnWidth.Value);
				_dGrid.ResizeRow((float)numTxtCellRowHeight.Value);
			}
			else if(rdBtnGridDeminsions.Checked)
			{
				_dGrid.ResizeAllColumnsWidth((float)numTxtGridColumnWidth.Value);
				_dGrid.ResizeAllRowsHeight((float)numTxtGridRowHeight.Value);

			}
		}

		private void rdBtnRowColumnDeminsion_CheckedChanged(object sender, System.EventArgs e)
		{
			if(rdBtnGridDeminsions.Checked)
			{
				pnlSelectedCellDim.Enabled = false;
				pnlGridDim.Enabled = true;
			}
			else
			{
				pnlSelectedCellDim.Enabled = true;
				pnlGridDim.Enabled = false;
			}
		}
	}
}
