using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;
using System.IO;
using System.Resources;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters;
using System.Data.OleDb;

using Symcon.Lightridge.LRRUI;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.LightRidge.BusinessObjects.TypeConverters;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.HeaderDispatcher;   

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using System.Collections.Generic;


namespace Symcon.LightRidge.PEAdvisor
{
	///	<summary>
	///	Summary	description	for	PropertiesMap.
	///	</summary>
	public class PropertiesMap : System.Windows.Forms.Form
	{
		private	System.Windows.Forms.Panel panel1;
		private	System.Windows.Forms.Button	btnOk;
		private	ArrayList arrProp =	new	ArrayList();
		private	PropertyTable myPT;
	//	private	CustomCollection selectedProperties ;
		private	ArrayList alst = new ArrayList();
		//private GraphicsUtils propMapGraphicsUtils = new GraphicsUtils();
		private	GridUnBoundColumn unboundGc = new GridUnBoundColumn();
		//private PathNode mySymbol;
        private Group mySymbol;
        private ArrayList arryPropIndex;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteCompProps;
		private ISymbolPropertiesMapping myISymbolMapping;
        private SplitContainer splitContainer1;
        private SplitContainer splitContainer2;
        private CheckedListBox checkedListBox1;
        LRRApp _app;
        List<bool> _visibilityList;
        private SplitContainer splitContainerLblvisiblty;
        private System.Windows.Forms.Label lblLabelVisibilityHdr;
        private CheckBox chkResetAlignment;
		private CheckBox chbEquipmentName;

		///	<summary>
		///	Required designer variable.
		///	</summary>
		private	System.ComponentModel.Container	components = null;

		public PropertiesMap()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
		}


		/// <summary>
		/// PropertiesMap dialog, Shows Properties of Selected object
		/// </summary>
		/// <param name="iSymbolMapping">Interface based on symbol type</param>
		/// <param name="pt">PropertyTable of the symbol</param>
		/// <param name="smbl">Symbol</param>
		public PropertiesMap(ISymbolPropertiesMapping iSymbolMapping,PropertyTable pt,Group smbl)
		{
            _app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			myISymbolMapping = iSymbolMapping;
			arryPropIndex = (ArrayList)smbl.GetPropertyContainerByName("ArryIndexedProps");	//Gets the indexed Properties for Symbol

			string siteItemID = GraphicsUtilities.GetSiteItemIdForSymbol(smbl);

			//For Legacy Graphics need to add Property Holder Array
			bool oldImageFound = false; 												//Support for old XML
			if(arryPropIndex == null)												
			{
				oldImageFound = true;
		
                arryPropIndex = new ArrayList();
				for(int i=0;i<4;i++)
				{
					arryPropIndex.Add("Null");
				}
			}
			myPT = pt;
			mySymbol = smbl;
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 

			//CustomCollection customCollection = iSymbolMapping.GetDataSource(propName);
			CustomCollection customCollection = iSymbolMapping.GetDataSource(siteItemID);
			this.gridSiteCompProps.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails =	false;
			
			gridSiteCompProps.TableDescriptor.Relations.Clear();
			gridSiteCompProps.DataSource = null;
			gridSiteCompProps.DataSource = customCollection;
			gridSiteCompProps.TableDescriptor.Columns.Clear();
            _visibilityList = _app.GetOptions().GraphicsLblsVisibility;
            if (_visibilityList == null)
            {
                _visibilityList = new List<bool>();
            }
            if (_visibilityList.Count == 0)
            {
                for (int i = 0; i < 10; i++)
                {
                    _app.GetOptions().GraphicsLblsVisibility.Add(true);
                }
            }


            string plantItem = smbl.GetPropertyContainerByName("PlantItem").ToString();// as string;//pt["PlantItem"].ToString();	  
			this.checkedListBox1.Tag =	plantItem;	
			string [] PIDetails= plantItem.Split(new char[]{'[',']'});
			string plantItemName =PIDetails[0];
            if (((smbl.Labels[0]).Name == plantItemName) || PIDetails.Length == 1)
				SetEquipmentName=true;
			if(iSymbolMapping.GetType().Name=="AggregatesMapping")
			{
				SetEquipmentName=true;
				this.checkedListBox1.Tag =null;
			}								 			
			if(this.SetEquipmentName)
			{		
				this.checkedListBox1.Items.Add(plantItem);
				this.checkedListBox1.SetItemChecked(0, _visibilityList[0]);
				this.chbEquipmentName.Checked=true; 
				 
			}
			else
			{
                if (PIDetails.Length > 2)
                {
                    string equipmentTag = PIDetails[3];
                    if (string.IsNullOrEmpty(equipmentTag))
                        equipmentTag = "Equipment tag not set";
                    this.checkedListBox1.Items.Add(equipmentTag);
                    this.checkedListBox1.SetItemChecked(0, _visibilityList[0]);
                    this.chbEquipmentName.Checked = false;
                }
				 
			}	   
			
			
			Hashtable hshSelectedProps = iSymbolMapping.GetSelectedProperties(myPT,customCollection);
			object[] objArray = new object[hshSelectedProps.Count];
			int k = 0;
			
			if(oldImageFound)
			{
				//smbl.SetPropertyValue("ArryIndexedProps",arryPropIndex);
			}

			iSymbolMapping.AddSelection(customCollection,arryPropIndex);
			foreach (LRRPlantItemProperty plantItemProperty in this.SelectedProperties)
			{
				if (plantItemProperty.Name == "NullValue")
				{
					continue;
				}
				objArray[k] = plantItemProperty;
				if (oldImageFound == true)
				{
					arryPropIndex[k] = plantItemProperty.ID;
				}
				k++;
				//LRRPlantItemProperty prop = dentry.Value as LRRPlantItemProperty;
				checkedListBox1.Items.Add(plantItemProperty.Name);
				checkedListBox1.Items.Add(plantItemProperty.Name + " UOM");
			}
			unboundGc.SetSelectedRecords(objArray);
			unboundGc.WireGrid(gridSiteCompProps);
			gridSiteCompProps.TableDescriptor.Columns.Add("Name");
			gridSiteCompProps.TableDescriptor.Columns["Name"].Appearance.AnyRecordFieldCell.ReadOnly = true;
			gridSiteCompProps.TableDescriptor.Columns["Name"].HeaderText = LRRHeaderText.GetHeaderString("SID_NAME");
		//	gridSiteCompProps.TableDescriptor.Columns.Add("EquipmentTag");
			gridSiteCompProps.TableDescriptor.Columns.Add("Description");
			gridSiteCompProps.TableDescriptor.Columns["Description"].HeaderText = LRRHeaderText.GetHeaderString("SID_DESCRIPTION");
		//	gridSiteCompProps.TableDescriptor.Columns["EquipmentTag"].Appearance.AnyRecordFieldCell.ReadOnly = true;
		//	gridSiteCompProps.TableDescriptor.Columns["EquipmentTag"].HeaderText = "EquipmentTag";//LRRHeaderText.GetHeaderString("SID_EQUIPTAG");
			gridSiteCompProps.TableControlCurrentCellChanged+=new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(gridSiteCompProps_TableControlCurrentCellChanged);
			gridSiteCompProps.CurrentRecordContextChange+=new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(gridSiteCompProps_CurrentRecordContextChange);
     	 
            for (int i = 0; i < checkedListBox1.Items.Count; i++)
            {
                checkedListBox1.SetItemChecked(i, _visibilityList[i]);
            }
            this.checkedListBox1.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.checkedListBox1_ItemCheck);
		}

		///	<summary>
		///	Clean up any resources being used.
		///	</summary>
		protected override void	Dispose( bool disposing	)
		{
			if(	disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing	);
		}



		#region	Windows	Form Designer generated	code
		///	<summary>
		///	Required method	for	Designer support - do not modify
		///	the	contents of	this method	with the code editor.
		///	</summary>
		private	void InitializeComponent()
		{
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(PropertiesMap));
			this.panel1 = new System.Windows.Forms.Panel();
			this.chbEquipmentName = new System.Windows.Forms.CheckBox();
			this.chkResetAlignment = new System.Windows.Forms.CheckBox();
			this.btnOk = new System.Windows.Forms.Button();
			this.gridSiteCompProps = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitContainer1 = new System.Windows.Forms.SplitContainer();
			this.splitContainer2 = new System.Windows.Forms.SplitContainer();
			this.splitContainerLblvisiblty = new System.Windows.Forms.SplitContainer();
			this.lblLabelVisibilityHdr = new System.Windows.Forms.Label();
			this.checkedListBox1 = new System.Windows.Forms.CheckedListBox();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridSiteCompProps)).BeginInit();
			this.splitContainer1.Panel1.SuspendLayout();
			this.splitContainer1.Panel2.SuspendLayout();
			this.splitContainer1.SuspendLayout();
			this.splitContainer2.Panel1.SuspendLayout();
			this.splitContainer2.Panel2.SuspendLayout();
			this.splitContainer2.SuspendLayout();
			this.splitContainerLblvisiblty.Panel1.SuspendLayout();
			this.splitContainerLblvisiblty.Panel2.SuspendLayout();
			this.splitContainerLblvisiblty.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.chbEquipmentName);
			this.panel1.Controls.Add(this.chkResetAlignment);
			this.panel1.Controls.Add(this.btnOk);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(460, 40);
			this.panel1.TabIndex = 1;
			// 
			// chbEquipmentName
			// 
			this.chbEquipmentName.AutoSize = true;
			this.chbEquipmentName.Location = new System.Drawing.Point(147, 11);
			this.chbEquipmentName.Name = "chbEquipmentName";
			this.chbEquipmentName.Size = new System.Drawing.Size(107, 17);
			this.chbEquipmentName.TabIndex = 2;
			this.chbEquipmentName.Text = "Equipment Name";
			this.chbEquipmentName.UseVisualStyleBackColor = true;
			this.chbEquipmentName.CheckedChanged += new System.EventHandler(this.chbEquipmentTag_CheckedChanged);
			// 
			// chkResetAlignment
			// 
			this.chkResetAlignment.AutoSize = true;
			this.chkResetAlignment.Location = new System.Drawing.Point(262, 11);
			this.chkResetAlignment.Name = "chkResetAlignment";
			this.chkResetAlignment.Size = new System.Drawing.Size(88, 17);
			this.chkResetAlignment.TabIndex = 1;
			this.chkResetAlignment.Text = "Reset Labels";
			this.chkResetAlignment.UseVisualStyleBackColor = true;
			// 
			// btnOk
			// 
			this.btnOk.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.Location = new System.Drawing.Point(372, 8);
			this.btnOk.Name = "btnOk";
			this.btnOk.Size = new System.Drawing.Size(75, 23);
			this.btnOk.TabIndex = 0;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// gridSiteCompProps
			// 
			this.gridSiteCompProps.BackColor = System.Drawing.SystemColors.Window;
			this.gridSiteCompProps.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSiteCompProps.Location = new System.Drawing.Point(0, 0);
			this.gridSiteCompProps.Name = "gridSiteCompProps";
			this.gridSiteCompProps.Size = new System.Drawing.Size(460, 250);
			this.gridSiteCompProps.TabIndex = 2;
			this.gridSiteCompProps.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridSiteCompProps.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridSiteCompProps.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridSiteCompProps.Text = "gridSiteCompProps";
			this.gridSiteCompProps.TopLevelGroupOptions.CaptionText = "Attributes: {RecordCount} Items";
			this.gridSiteCompProps.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridSiteCompProps.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridSiteCompProps.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridSiteCompProps.VersionInfo = "3.301.0.0";
			// 
			// splitContainer1
			// 
			this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.splitContainer1.FixedPanel = System.Windows.Forms.FixedPanel.Panel2;
			this.splitContainer1.IsSplitterFixed = true;
			this.splitContainer1.Location = new System.Drawing.Point(0, 0);
			this.splitContainer1.Name = "splitContainer1";
			this.splitContainer1.Orientation = System.Windows.Forms.Orientation.Horizontal;
			// 
			// splitContainer1.Panel1
			// 
			this.splitContainer1.Panel1.Controls.Add(this.gridSiteCompProps);
			// 
			// splitContainer1.Panel2
			// 
			this.splitContainer1.Panel2.Controls.Add(this.panel1);
			this.splitContainer1.Panel2MinSize = 40;
			this.splitContainer1.Size = new System.Drawing.Size(460, 294);
			this.splitContainer1.SplitterDistance = 250;
			this.splitContainer1.TabIndex = 5;
			// 
			// splitContainer2
			// 
			this.splitContainer2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.splitContainer2.Location = new System.Drawing.Point(0, 0);
			this.splitContainer2.Name = "splitContainer2";
			// 
			// splitContainer2.Panel1
			// 
			this.splitContainer2.Panel1.Controls.Add(this.splitContainer1);
			this.splitContainer2.Panel1MinSize = 460;
			// 
			// splitContainer2.Panel2
			// 
			this.splitContainer2.Panel2.Controls.Add(this.splitContainerLblvisiblty);
			this.splitContainer2.Size = new System.Drawing.Size(639, 294);
			this.splitContainer2.SplitterDistance = 460;
			this.splitContainer2.TabIndex = 6;
			// 
			// splitContainerLblvisiblty
			// 
			this.splitContainerLblvisiblty.Dock = System.Windows.Forms.DockStyle.Fill;
			this.splitContainerLblvisiblty.FixedPanel = System.Windows.Forms.FixedPanel.Panel1;
			this.splitContainerLblvisiblty.IsSplitterFixed = true;
			this.splitContainerLblvisiblty.Location = new System.Drawing.Point(0, 0);
			this.splitContainerLblvisiblty.Name = "splitContainerLblvisiblty";
			this.splitContainerLblvisiblty.Orientation = System.Windows.Forms.Orientation.Horizontal;
			// 
			// splitContainerLblvisiblty.Panel1
			// 
			this.splitContainerLblvisiblty.Panel1.Controls.Add(this.lblLabelVisibilityHdr);
			// 
			// splitContainerLblvisiblty.Panel2
			// 
			this.splitContainerLblvisiblty.Panel2.Controls.Add(this.checkedListBox1);
			this.splitContainerLblvisiblty.Size = new System.Drawing.Size(175, 294);
			this.splitContainerLblvisiblty.SplitterDistance = 52;
			this.splitContainerLblvisiblty.TabIndex = 11;
			// 
			// lblLabelVisibilityHdr
			// 
			this.lblLabelVisibilityHdr.BackColor = System.Drawing.SystemColors.Desktop;
			this.lblLabelVisibilityHdr.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lblLabelVisibilityHdr.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.lblLabelVisibilityHdr.ForeColor = System.Drawing.SystemColors.HighlightText;
			this.lblLabelVisibilityHdr.Location = new System.Drawing.Point(0, 0);
			this.lblLabelVisibilityHdr.Name = "lblLabelVisibilityHdr";
			this.lblLabelVisibilityHdr.Size = new System.Drawing.Size(175, 52);
			this.lblLabelVisibilityHdr.TabIndex = 0;
			this.lblLabelVisibilityHdr.Text = "Set Symbol\'s Labels visibility on Canvas";
			this.lblLabelVisibilityHdr.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// checkedListBox1
			// 
			this.checkedListBox1.CheckOnClick = true;
			this.checkedListBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.checkedListBox1.FormattingEnabled = true;
			this.checkedListBox1.Location = new System.Drawing.Point(0, 0);
			this.checkedListBox1.Name = "checkedListBox1";
			this.checkedListBox1.Size = new System.Drawing.Size(175, 229);
			this.checkedListBox1.TabIndex = 10;
			// 
			// PropertiesMap
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(639, 294);
			this.Controls.Add(this.splitContainer2);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MinimumSize = new System.Drawing.Size(647, 318);
			this.Name = "PropertiesMap";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Tag = "SID_PROP_MAPPING";
			this.panel1.ResumeLayout(false);
			this.panel1.PerformLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridSiteCompProps)).EndInit();
			this.splitContainer1.Panel1.ResumeLayout(false);
			this.splitContainer1.Panel2.ResumeLayout(false);
			this.splitContainer1.ResumeLayout(false);
			this.splitContainer2.Panel1.ResumeLayout(false);
			this.splitContainer2.Panel2.ResumeLayout(false);
			this.splitContainer2.ResumeLayout(false);
			this.splitContainerLblvisiblty.Panel1.ResumeLayout(false);
			this.splitContainerLblvisiblty.Panel2.ResumeLayout(false);
			this.splitContainerLblvisiblty.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion


        /// <summary>
        /// Handles the Click event of the btnOk control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
		private	void btnOk_Click(object	sender,	EventArgs e)
		{
           
                //_app.GetOptions().GraphicsLblsVisibility.Add(var.Checked);
       
			object[] objArray = unboundGc.GetSelectedRecords();
			if(objArray.Length >4)
			{
				LRRMessagBox.ShowMessage(this,"SID_PROPERTIESSELECTION_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Stop);       
				this.DialogResult = DialogResult.None;

				unboundGc.SetRecord(unboundGc.LastRecord,false);
				return;
			}
			else
			{
				for(int j=0; j < myISymbolMapping.SelectedProperties.Count;j++)
				{
					if(myISymbolMapping.GetSelectedPropertyNameByIndex(j) != "NullValue")
						return;
				}
				for(int i= myPT.Properties.Count; i>0;i--)
				{
					PropertySpec ps =  myPT.Properties[i-1] as PropertySpec;
					if(ps.Category == "Bound Properties")
					{
						myPT.Properties.Remove(ps);
					}
				}
				for(int i = mySymbol.Labels.Count;i>0;i--)
				{
					LRRLabel lbl =  mySymbol.Labels[i-1] as LRRLabel;
					mySymbol.Labels[i-1].Text = "";
					lbl.ParentID = "";
					
				}

				for(int j = 0;j<arryPropIndex.Count;j++)
				{
					arryPropIndex[j] = "Null";
				}
			}
		}

		public CustomCollection SelectedProperties
		{
			get
			{
				return myISymbolMapping.SelectedProperties;
			}
		}

      public bool ResetAlignment
      {
            get { return chkResetAlignment.Checked; }
      }

	 

		private bool _setEquipmentName;

		public bool SetEquipmentName
		{
			get { return _setEquipmentName; }
			set { _setEquipmentName = value; }
		}
	

		private void gridSiteCompProps_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			if(e.Action == Syncfusion.Grouping.CurrentRecordAction.EndEditComplete)
			{
				object[] objArray = unboundGc.GetSelectedRecords();
				if(objArray.Length > 4)
				{
					LRRMessagBox.ShowMessage(this,"SID_PROPERTIESSELECTION_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Stop);       
					this.DialogResult = DialogResult.None;
					unboundGc.SetRecord(unboundGc.LastRecord,false);
					
					return;
				}
				//checkedListBox1.Items.Clear();
				//chbEquipmentTag_CheckedChanged(null, null);

				//LRRPlantItemProperties plantItemProps =unboundGc.GetSelectedRecords() ;
				//plantItemProps.SortColumn = "Name";
				//plantItemProps.Sort();

				
			}
		}

		
		private void gridSiteCompProps_TableControlCurrentCellChanged(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{			
			e.TableControl.CurrentCell.ConfirmChanges();
			myISymbolMapping.UpdateSelection(gridSiteCompProps.CurrencyManager.Current,arryPropIndex);
            LRRPlantItemProperty selectRecord = gridSiteCompProps.CurrencyManager.Current as LRRPlantItemProperty;

				checkedListBox1.Items.Clear();
				chbEquipmentTag_CheckedChanged(null, null);
				foreach (LRRPlantItemProperty var in SelectedProperties)
				{
					if (var.Name == "NullValue")
					{
						continue;

					}
					int nameIndex = checkedListBox1.Items.Add(var.Name);
					int uomIndex = checkedListBox1.Items.Add(var.Name + " UOM");
					checkedListBox1.SetItemChecked(nameIndex, _visibilityList[nameIndex]);
					checkedListBox1.SetItemChecked(uomIndex, _visibilityList[uomIndex]);


				}
				//if (!checkedListBox1.Items.Contains(selectRecord.Name))
				//{
                
				//    checkedListBox1.Items.Add(selectRecord.Name);
				//    checkedListBox1.Items.Add(selectRecord.Name + " UOM");
				//   //////// //int index = arryPropIndex.IndexOf(selectRecord.ID);
				//   ////////// index = (index * 2) + 1;
				//   //////// //checkedListBox1.Items[index] = selectRecord.Name;
				//   //////// //checkedListBox1.Items[index + 1] = selectRecord.Name + " UOM";
				//   //////// //checkedListBox1.SetItemChecked(index, _visibilityList[index]);
				//   //////// //checkedListBox1.SetItemChecked(index + 1, _visibilityList[index + 1]);
				//   //////// //for (int i = 0; i < checkedListBox1.Items.Count; i++)
				//   //////// //{
				//   //////// //    checkedListBox1.SetItemChecked(i, _visibilityList[i]);
				//   //////// //}
				//}
				//else
				//{
				//    for (int i = 0; i < checkedListBox1.Items.Count; i++)
				//    {
				//        //////////checkedListBox1.SetItemChecked(i, _visibilityList[i]);
				//        if (selectRecord.Name == checkedListBox1.Items[i].ToString())
				//        {
				//            //////////checkedListBox1.Items.RemoveAt(i);
				//            //////////checkedListBox1.Items.RemoveAt(i + 1);
                       

				//            checkedListBox1.Items.Remove(selectRecord.Name);
				//            checkedListBox1.Items.Remove(selectRecord.Name + " UOM");

				//            //////////checkedListBox1.Items[i] = "";
				//            //////////checkedListBox1.Items[i+1] = "";
				//            break;
				//        }
				//    }
				//}
				//for (int i = 0; i < checkedListBox1.Items.Count; i++)
				//{
                
				//}

          //////////  object[] objArray = unboundGc.GetSelectedRecords();
           
		}

        private void checkedListBox1_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (e.NewValue == CheckState.Checked)
            {
                _visibilityList[e.Index] = true;
            }
            else
            {
                _visibilityList[e.Index] = false;
            }
        }

		private void chbEquipmentTag_CheckedChanged(object sender, EventArgs e)
		{
				
			if( this.checkedListBox1.Tag!=null)
			{
				string  plantItemName =	 this.checkedListBox1.Tag.ToString();
				string [] PIDetails= plantItemName.Split(new char[]{'[',']'});	 	 
			 			  
				if(chbEquipmentName.Checked)
				{
					this.SetEquipmentName =true;
					if (this.checkedListBox1.Items.Count > 0)
					{
						this.checkedListBox1.Items[0] = plantItemName;	
					}
					else
					{
						this.checkedListBox1.Items.Add(plantItemName);	
					}
					
				}
				else
				{
                    string equipmentTag = "";
                    if (PIDetails.Length > 2)
                    {
                        equipmentTag = PIDetails[3];
                    }
					if(string.IsNullOrEmpty(equipmentTag))
						equipmentTag="Equipment tag not set";	  
					 this.SetEquipmentName =false;
					 if (this.checkedListBox1.Items.Count > 0)
					 {
						 this.checkedListBox1.Items[0] = equipmentTag;
					 }
					 else
					 {
						 this.checkedListBox1.Items.Add(equipmentTag);
					 }
					 //this.checkedListBox1.Items[0] =	equipmentTag;
				    
            }
			}
			else
			{					
				chbEquipmentName.Checked=true;
			}

				
				//for (int i = 0; i < checkedListBox1.Items.Count; i++)
				//{
				//    checkedListBox1.SetItemChecked(i, _visibilityList[i]);
				//}
				//this.checkedListBox1.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.checkedListBox1_ItemCheck);
			 
		}
	}
}
