using System;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Lightridge.LRRUI;
using System.Collections;
using Symcon.LightRidge.MessageService;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for SiteComponentMapping.
	/// </summary>
	public class SiteComponentMapping : ISymbolPropertiesMapping
	{

		#region Fields

		private LRRPlantItemProperties _selectedProps = new LRRPlantItemProperties();
		CustomCollection customCollection = new LRRSiteComponentProperties();
		LRRPlantItemProperties propertiesObj= new LRRPlantItemProperties();
		#endregion
		public SiteComponentMapping()
		{

		}
		#region ISymbolPropertiesMapping Members

//		public Symcon.BusinessObjects.CustomCollection GetDataSource(string propName)
//		{
//			Symcon.LightRidge.BusinessObjects.LRRSiteComponents	lscs = LRRModel.SiteComponentsObj;
//			LRRSiteComponent lsc = lscs.GetSiteComponentByName(propName.Trim());
//			lsc.Properties.SortColumn = "Name";
//			lsc.Properties.Sort();
//			customCollection.Clear();
//			LRRSiteComponentProperties lscp = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(lsc.SiteComponentID);     
//			foreach(LRRSiteComponentProperty lrrscp in  lscp)
//			{
//				if(lrrscp.Type == "1")
//				{
//					LRRPlantItemProperty propertyObj=new LRRPlantItemProperty();
//					propertyObj.ID=lrrscp.ID;
//					propertyObj.PropertyID=lrrscp.ID;
//					propertyObj.Name=lrrscp.Name;
//					propertyObj.Description=lrrscp.Description;
//					customCollection.Add(propertyObj);
//					propertyObj = null;
//				}
//				LRRSiteComponentGroupProperties _siteCompGroupedProperties = LRRModel.SiteComponentGroupPropertiesObj;
//				LRRSiteComponentGroupProperties grprop = _siteCompGroupedProperties.GetSiteCompGroupPropFromSiteCompPropID(lrrscp.ID);
//				LRRSiteGroupPropertyQualifierValues _siteGroupPropertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj;
//				foreach(LRRSiteComponentGroupProperty gp in grprop)
//				{
//					if(gp.SiteComponentPropID != lrrscp.ID)
//						continue;
//					LRRSiteGroupPropertyQualifierValues grPropValues = _siteGroupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(gp.GroupPropertyID);
//					foreach(LRRSiteGroupPropertyQualifierValue grPropValue in grPropValues)
//					{
//						string sModeID = "";
//						sModeID = grPropValue.ModeID == null ? "" : grPropValue.ModeID.ToString();
//						if(sModeID == "1")
//						{
//							string grpPropIdentifier = "";
//							if(grPropValue.QualifierID != null && grPropValue.QualifierID != "")
//							{
//								grpPropIdentifier	= lrrscp.Name + " / " + gp.AttributeName + " / " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(grPropValue.QualifierID).Name +  LRRMessages.GetMessageString("SID_GROUP");
//							}
//							else
//							{
//								grpPropIdentifier	= lrrscp.Name + " / " + gp.AttributeName + LRRMessages.GetMessageString("SID_DATA_ARRAY");
//							}
//
//							LRRPlantItemProperty propertyObj1=new LRRPlantItemProperty();
//							
//							propertyObj1.ID = grPropValue.SiteGroupPropertyQualifierValueID/*gp.SiteComponentPropID*/;
//							propertyObj1.PropertyID=gp.SiteComponentPropID;
//							propertyObj1.GroupPropertyID=gp.GroupPropertyID;
//							propertyObj1.SiteGroupPropertyQualifierValueID = grPropValue.SiteGroupPropertyQualifierValueID;
//							propertyObj1.Name=/*ex.Name + " / " + gp.AttributeName + " / " + sQualifierName + " [ Grouped ]"*/grpPropIdentifier;
//							propertyObj1.Description=gp.AttributeDescription;
//							propertyObj1.LookupQualifierID = grPropValue.LookUpQualifierID;
//							propertyObj1.LookupPropertiesID = grPropValue.LookUpPropertiesID;
//							customCollection.Add(propertyObj1);
//							propertyObj1 = null;
//						}
//					}
//				}
//			}
//			return customCollection;
//		}


		public LRRPlantItemProperties GetDataSource(string siteItemID)
		{
			Symcon.LightRidge.BusinessObjects.LRRSiteComponents	lscs = LRRModel.SiteComponentsObj;
			LRRSiteComponent lsc = lscs.GetSiteComponentByID(siteItemID);
			LRRSiteComponentProperties prop ;//=	new	LRRSiteComponentProperties();
			LRRSiteComponentGroupProperties grprop =	new	LRRSiteComponentGroupProperties();
			LRRSiteGroupPropertyQualifierValues grPropValues =	new	LRRSiteGroupPropertyQualifierValues();
			if(lsc != null)
			{
				prop = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(lsc.SiteComponentID);
				foreach(LRRSiteComponentProperty ex in prop)
				{
					if(ex.Type == "1" && ex.ModeID)
					{
						LRRPlantItemProperty propertyObj=new LRRPlantItemProperty();
						propertyObj.ID=ex.ID;
						propertyObj.PropertyID=ex.ID;
						propertyObj.Name=ex.Name;
						propertyObj.EquipmentTag = lsc.EquipmentTag;
						propertyObj.Description=ex.Description;
						propertyObj.SerializedID = ex.ID;
						if(ex.ConditionalFormatXML != null)
							propertyObj.CondFormatsObj = ex.ConditionalFormatsObj;
						propertiesObj.Add(propertyObj);
						propertyObj = null;
					}

					//--Revised the logic to implement changes in GP
					LRRSiteGroupPropertyQualifierValues _siteGroupPropertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj;
					LRRSiteComponentGroupProperties _siteCompGroupedProperties = LRRModel.SiteComponentGroupPropertiesObj;
					grprop = _siteCompGroupedProperties.GetSiteCompGroupPropFromSiteCompPropID(ex.ID);
					foreach(LRRSiteComponentGroupProperty gp in grprop)
					{
						
						if(!gp.ModeID)
							continue;
						if(gp.SiteComponentPropID != ex.ID)
							continue;
                        List<IPropertyValue> lstVals = _siteGroupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(gp.GroupPropertyID);

                            foreach (IPropertyValue val in lstVals)
                            {
                                LRRSiteGroupPropertyQualifierValue grPropValue = val as LRRSiteGroupPropertyQualifierValue;
                                string sModeID = "";

                                sModeID = grPropValue.ModeID == null ? "" : grPropValue.ModeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                                if (sModeID == "1")
                                {
                                    string grpPropIdentifier = "";

                                    if (grPropValue.QualifierID != null && grPropValue.QualifierID != "")
                                    {
                                        grpPropIdentifier = ex.Name + " / " + gp.AttributeName + " / " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(grPropValue.QualifierID).Name + LRRMessages.GetMessageString("SID_GROUP_MAPPING");
                                    }
                                    else
                                    {
                                        grpPropIdentifier = ex.Name + " / " + gp.AttributeName + LRRMessages.GetMessageString("SID_DATA_ARRAY_MAPPING");
                                    }

                                    LRRPlantItemProperty propertyObj1 = new LRRPlantItemProperty();

                                    propertyObj1.ID = grPropValue.SiteGroupPropertyQualifierValueID/*gp.SiteComponentPropID*/;
                                    propertyObj1.PropertyID = gp.SiteComponentPropID;
                                    propertyObj1.GroupPropertyID = gp.GroupPropertyID;
                                    propertyObj1.SiteGroupPropertyQualifierValueID = grPropValue.SiteGroupPropertyQualifierValueID;
                                    propertyObj1.Name =/*ex.Name + " / " + gp.AttributeName + " / " + sQualifierName + " [ Grouped ]"*/grpPropIdentifier;
                                    propertyObj1.Description = gp.AttributeDescription;
                                    propertyObj1.LookupQualifierID = grPropValue.LookUpQualifierID;
                                    //propertyObj1.LookupPropertiesID = grPropValue.LookUpPropertiesID;
                                    propertyObj1.SerializedID = propertyObj1.LookupQualifierID + "|" + propertyObj1.GroupPropertyID;
                                    propertiesObj.Add(propertyObj1);
                                    propertyObj1 = null;
                                }
                            }
                        //grPropValues = _siteGroupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(gp.GroupPropertyID);
                        //foreach(LRRSiteGroupPropertyQualifierValue grPropValue in grPropValues)
                        //{
							
                        //}
					}
				}
			}
			propertiesObj.SortColumn = "Name";
			propertiesObj.Sort();
			return propertiesObj;
		}



		public System.Collections.Hashtable GetSelectedProperties(PropertyTable pt,CustomCollection customCollection)
		{
			PropertyTable myPT = pt;
			Hashtable hashSelectedSiteCompProps = new Hashtable();
			Symcon.Lightridge.LRRUI.PropertyBag.PropertySpecCollection pscl = pt.Properties;
			foreach(PropertySpec ps in pscl)
			{
				if(ps.Category == "Bound Properties")
				{
					LRRSiteComponentProperty lrrcp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(ps.ObjectRef.ToString());
					if(lrrcp != null)
					{
						IEnumerator enumerator = customCollection.GetEnumerator();
						while(enumerator.MoveNext())
						{
							LRRPlantItemProperty lrrplprop = enumerator.Current as LRRPlantItemProperty; 
							if(lrrplprop.ID == lrrcp.ID && lrrplprop.Name == lrrcp.Name)
							{
								if(!hashSelectedSiteCompProps.ContainsKey(lrrplprop.SerializedID))
								{
									hashSelectedSiteCompProps.Add(lrrplprop.ID,lrrplprop);
									break;
								}
							}
						}
					}
					else
					{
					
						IEnumerator enumerator = customCollection.GetEnumerator();
						while(enumerator.MoveNext())
						{
							LRRPlantItemProperty lrrplprop = enumerator.Current as LRRPlantItemProperty; 
							if(lrrplprop.SerializedID == ps.ObjectRef.ToString())
							{
								if(!hashSelectedSiteCompProps.ContainsKey(lrrplprop.SerializedID))
								{
									hashSelectedSiteCompProps.Add(lrrplprop.SerializedID,lrrplprop);
									break;
								}
							}
						}
					}
				}
			}
			return hashSelectedSiteCompProps;
		}

		public void GetSelectedProperties(ArrayList arryPropIndex)
		{
			//LRRPlantItemProperties siteCompProps = collection as LRRPlantItemProperties;
			
			if (arryPropIndex != null)
			{
				for (int j = 0; j < arryPropIndex.Count; j++)
				{
					
					if (arryPropIndex[j].ToString() == "Null")
					{
						//LRRPlantItemProperty lrrscp = new LRRPlantItemProperty();
						//lrrscp.Name = "NullValue";
						//this._selectedProps.Add(lrrscp);

					}
					else
					{
						//LRRSiteComponentProperty lrrcp = siteCompProps.SiteComponentPropertiesObj.GetSiteCompPropFromID(arryPropIndex[j]);
						//hashSelectedSiteCompProps.Add(lrrcp.PropertyID);
						////foreach (LRRPlantItemProperty lrrplprop in siteCompProps)
						////{
						//   if (lrrplprop.ID == arryPropIndex[j].ToString())
						//   {
						//      this._selectedProps.Add(lrrplprop);
						//      break;
						//   }
						//}
					}
				}
			}
		}

		public void AddSelection(object collection, ArrayList arryPropIndex)
		{

			LRRPlantItemProperties siteCompProps =  collection as LRRPlantItemProperties;

			if(arryPropIndex != null)
			{
				for(int j = 0;j<arryPropIndex.Count;j++)
				{
					if(arryPropIndex[j].ToString() == "Null")
					{
						LRRPlantItemProperty lrrscp = new LRRPlantItemProperty(); 
						lrrscp.Name = "NullValue";
						this._selectedProps.Add(lrrscp);

					}
					else
					{
						foreach(LRRPlantItemProperty lrrplprop in siteCompProps)
						{
							if(lrrplprop.ID == arryPropIndex[j].ToString())
							{
								this._selectedProps.Add(lrrplprop);
								break;
							}
						}
					}
				}
			}
		}

		public CustomCollection SelectedProperties
		{
			get
			{
				return _selectedProps;
			}
		}

		public void UpdateSelection(object obj, ArrayList arryPropIndex)
		{
			LRRPlantItemProperty propertyObj=null;
			try
			{
				propertyObj =	obj	as LRRPlantItemProperty;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithoutPET:"+ex.Message  ,Logger.Level.Debug);
				return;
			}
			if(arryPropIndex.Contains(propertyObj.ID))
			{
				int index = arryPropIndex.IndexOf(propertyObj.ID);
				arryPropIndex[index] = "Null";
				_selectedProps.RemoveAt(index);
				LRRPlantItemProperty lrrscp = new LRRPlantItemProperty();
				lrrscp.Name = "NullValue";
				_selectedProps.Insert(index,lrrscp);
			}
			else
			{
				for(int i=0;i < arryPropIndex.Count;i++)
				{
					if(arryPropIndex[i].ToString() == "Null")
					{
						arryPropIndex[i] = propertyObj.ID;
						_selectedProps.RemoveAt(i);
						_selectedProps.Insert(i,propertyObj);
						break;
					}
				}
			}
		}


		public string GetSelectedPropertyNameByIndex(int index)
		{
			return _selectedProps[index].Name;
		}

		#endregion
	}
}
