using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher; 

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for IndicesConfiguration.
	/// </summary>
	public class IndicesConfiguration : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.TextBox txtIndicesDesc;
		private System.Windows.Forms.ComboBox cmbProdrawmatlist;
		private System.Windows.Forms.Button btnAddIndElements;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridIndicesItems;
		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private System.Windows.Forms.Label lblprod;
		private System.Windows.Forms.Label lbldesc;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public IndicesConfiguration()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			//_LocaleID = _app.AppLocaleID;

			InitializeIndicesCombo();
			//InitializeDataSource();
			//BindSiteItemsGrid();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(IndicesConfiguration));
			this.panel1 = new System.Windows.Forms.Panel();
			this.lbldesc = new System.Windows.Forms.Label();
			this.lblprod = new System.Windows.Forms.Label();
			this.btnAddIndElements = new System.Windows.Forms.Button();
			this.txtIndicesDesc = new System.Windows.Forms.TextBox();
			this.cmbProdrawmatlist = new System.Windows.Forms.ComboBox();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.gridIndicesItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridIndicesItems)).BeginInit();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.lbldesc);
			this.panel1.Controls.Add(this.lblprod);
			this.panel1.Controls.Add(this.btnAddIndElements);
			this.panel1.Controls.Add(this.txtIndicesDesc);
			this.panel1.Controls.Add(this.cmbProdrawmatlist);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(600, 80);
			this.panel1.TabIndex = 0;
			// 
			// lbldesc
			// 
			this.lbldesc.Location = new System.Drawing.Point(32, 48);
			this.lbldesc.Name = "lbldesc";
			this.lbldesc.TabIndex = 4;
			this.lbldesc.Tag = "SID_DESCRIPTION";
			// 
			// lblprod
			// 
			this.lblprod.Location = new System.Drawing.Point(32, 16);
			this.lblprod.Name = "lblprod";
			this.lblprod.TabIndex = 3;
			this.lblprod.Tag = "SID_IND_PRODUCT";
			// 
			// btnAddIndElements
			// 
			this.btnAddIndElements.Location = new System.Drawing.Point(368, 16);
			this.btnAddIndElements.Name = "btnAddIndElements";
			this.btnAddIndElements.TabIndex = 2;
			this.btnAddIndElements.Tag = "SID_ADD";
			this.btnAddIndElements.Click += new System.EventHandler(this.btnAddIndElements_Click);
			// 
			// txtIndicesDesc
			// 
			this.txtIndicesDesc.BackColor = System.Drawing.Color.White;
			this.txtIndicesDesc.Location = new System.Drawing.Point(152, 48);
			this.txtIndicesDesc.Name = "txtIndicesDesc";
			this.txtIndicesDesc.ReadOnly = true;
			this.txtIndicesDesc.Size = new System.Drawing.Size(288, 20);
			this.txtIndicesDesc.TabIndex = 1;
			this.txtIndicesDesc.Text = "";
			// 
			// cmbProdrawmatlist
			// 
			this.cmbProdrawmatlist.Location = new System.Drawing.Point(152, 16);
			this.cmbProdrawmatlist.MaxDropDownItems = 10;
			this.cmbProdrawmatlist.Name = "cmbProdrawmatlist";
			this.cmbProdrawmatlist.Size = new System.Drawing.Size(176, 21);
			this.cmbProdrawmatlist.TabIndex = 0;
			this.cmbProdrawmatlist.SelectedIndexChanged += new System.EventHandler(this.cmbProdrawmatlist_SelectedIndexChanged);
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 80);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(600, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// gridIndicesItems
			// 
			this.gridIndicesItems.BackColor = System.Drawing.SystemColors.Window;
			this.gridIndicesItems.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridIndicesItems.Location = new System.Drawing.Point(0, 83);
			this.gridIndicesItems.Name = "gridIndicesItems";
			this.gridIndicesItems.Size = new System.Drawing.Size(600, 259);
			this.gridIndicesItems.TabIndex = 1;
			this.gridIndicesItems.TableDescriptor.AllowEdit = false;
			this.gridIndicesItems.TableDescriptor.AllowNew = false;
			this.gridIndicesItems.TableDescriptor.AllowRemove = false;
			this.gridIndicesItems.Tag = "SID_PLANT_INDICES";
			this.gridIndicesItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridIndicesItems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridIndicesItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridIndicesItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridIndicesItems.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridIndicesItems.VersionInfo = "3.301.0.0";
			this.gridIndicesItems.TableControlCellButtonClicked += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellButtonClickedEventHandler(this.gridIndicesItems_TableControlCellButtonClicked);
			this.gridIndicesItems.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridIndicesItems_TableControlCellClick);
			// 
			// IndicesConfiguration
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 342);
			this.Controls.Add(this.gridIndicesItems);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "IndicesConfiguration";
			this.Tag = "SID_PLANT_INDICES";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridIndicesItems)).EndInit();
			this.ResumeLayout(false);

		}
		private void InitializeDataSource()
		{
			//_siteComponentsList = LRRModel.SiteComponentsObj;
			_indicesXrefsList = LRRModel.IndicesXRefs.GetSiteItemXRefsByIndexID(selectedSiteItem);
		}
		private void BindSiteItemsGrid()
		{
			//Suspend the Layout of the Grid...
			gridIndicesItems.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridIndicesItems);
			gridIndicesItems.DataSource = null;
			//gridIndicesItems.TableDescriptor.Relations.Clear();
			//Hashtable fkColumns;
			//Hashtable childColumns;
			/*Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_indicesXrefsList.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
				SymForeignKeyFieldAttribute fkAttr = fkColumns[obj] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}
			
			//Populate the columns for the grid object
			//			_siteComponentsList.SortColumn="Name";
			//			_siteComponentsList.Sort();
			SyncGridUtilities.InitializeGridColumns(gridIndicesItems,_indicesXrefsList.ItemType,null,fkData);
			gridIndicesItems.Engine.SourceListSet.Add("ParentTable",_indicesXrefsList);*/
			gridIndicesItems.TableModel.CellModels.Remove("EllipsisText");
			gridIndicesItems.TableModel.CellModels.Add("EllipsisText",new EllipsisCellModel(gridIndicesItems.TableModel.Model));

			gridIndicesItems.TableDescriptor.Columns.Clear();		
			//gridUnBoundSiteItem.WireGrid(gridIndicesItems);
			gridIndicesItems.DataSource = _indicesXrefsList;

			gridIndicesItems.TableDescriptor.Columns.Add("Name","Name");
			gridIndicesItems.TableDescriptor.Columns.Add("Description","Description");
			gridIndicesItems.TableDescriptor.Columns.Add("Usage","UsageValue");
			gridIndicesItems.TableDescriptor.Columns.Add("MasterComponentType","MasterComponentType");

			Hashtable RelativeWidths = new Hashtable();
			RelativeWidths.Add("Name",40);
			RelativeWidths.Add("Description",60);
			RelativeWidths.Add("MasterComponentType",40);
			RelativeWidths.Add("Usage",20);
			//SyncGridUtilities.InitializeGridColumnsWidth(gridIndicesItems,RelativeWidths );
			//gridIndicesItems.TableDescriptor.Columns["Usage"]
		gridIndicesItems.TableDescriptor.Columns["Usage"].Appearance.AnyRecordFieldCell.CellType = "EllipsisText";

			
			//Set the data store 
			//gridIndicesItems.Engine.SourceListSet.Add("ParentTable",_siteComponentsList);

			

			gridIndicesItems.TableDescriptor.AllowEdit = true;
			gridIndicesItems.TableDescriptor.AllowNew = false;
			gridIndicesItems.TableDescriptor.Columns["Name"].ReadOnly=true;
			//		gridIndicesItems.TableOptions.AllowSortColumns = false;

			//Resume the Layout of the Grid...
			gridIndicesItems.ResumeLayout(false);
			
		}

		private void BindSiteItemsGrid(LRRIndicesXRefs indexXrefs)
		{
			//Suspend the Layout of the Grid...
			gridIndicesItems.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridIndicesItems);
			gridIndicesItems.DataSource = null;
			gridIndicesItems.TableDescriptor.Relations.Clear();
            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_indicesXrefsList.ItemType,out fkColumns,out childColumns);
			//gridSiteComponent.TableModel.CellModels.Add("EllipsisText",new PlantLevelUserFormTreeControl(this.gridSiteComponent.TableModel,new PlantLevelTreeControlStructure()));         
			//gridIndicesItems.TableModel.CellModels.Add("EllipsisText",new PlantLevelUserFormTreeControl(this.gridSiteComponent.TableModel,new PlantLevelTreeControlStructure()));         
			//gridControl1.CellModels.Add("EllipsisText", new EllipsisCellModel(gridControl1.Model));
			gridIndicesItems.TableModel.CellModels.Remove("EllipsisText");
			gridIndicesItems.TableModel.CellModels.Add("EllipsisText",new EllipsisCellModel(gridIndicesItems.TableModel.Model));
			//Hashtable fkData = new Hashtable();
			/*foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
				SymForeignKeyFieldAttribute fkAttr = fkColumns[obj] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}*/
			
			//Populate the columns for the grid object
			//			_siteComponentsList.SortColumn="Name";
			//			_siteComponentsList.Sort();
			//SyncGridUtilities.InitializeGridColumns(gridIndicesItems,_siteComponentsList.ItemType,null,fkData);
			
			//gridControl1.CellModels.Add("EllipsisText", new EllipsisCellModel(gridControl1.Model));
			//gridIndicesItems.gr

			gridIndicesItems.TableDescriptor.Columns.Clear();		
			//gridUnBoundSiteItem.WireGrid(gridIndicesItems);
			gridIndicesItems.DataSource = indexXrefs;

			gridIndicesItems.TableDescriptor.Columns.Add("Name","Name");
			gridIndicesItems.TableDescriptor.Columns.Add("Description","Description");
			gridIndicesItems.TableDescriptor.Columns.Add("Usage","UsageValue");
			gridIndicesItems.TableDescriptor.Columns.Add("MasterComponentType","MasterComponentType");
			
			Hashtable RelativeWidths = new Hashtable();
			RelativeWidths.Add("Name",40);
			RelativeWidths.Add("Description",60);
			RelativeWidths.Add("MasterComponentType",40);
			RelativeWidths.Add("Usage",20);
			//SyncGridUtilities.InitializeGridColumnsWidth(gridIndicesItems,RelativeWidths );
			
			gridIndicesItems.TableDescriptor.Columns["Usage"].Appearance.AnyRecordFieldCell.CellType = "EllipsisText";
			


			//grdCompPropValues.ChildTableDescriptor.Columns[0].Appearance.

			//Set the data store 
			//gridIndicesItems.Engine.SourceListSet.Add("ParentTable",_siteComponentsList);

			

			gridIndicesItems.TableDescriptor.AllowEdit = true;
			gridIndicesItems.TableDescriptor.AllowNew = false;
			gridIndicesItems.TableDescriptor.Columns["Name"].ReadOnly=true;
			gridIndicesItems.TableDescriptor.Columns["MasterComponentType"].ReadOnly=true;
			//		gridIndicesItems.TableOptions.AllowSortColumns = false;

			//Resume the Layout of the Grid...
			gridIndicesItems.ResumeLayout(false);
		}

		private void InitializeIndicesCombo()
		{
			
			_mastercomponentsComboList = new LRRMasterComponents();
			
			//LRRComponentType cmp = cmps.GetComponentTypeByName("COMPPROD");
			LRRMasterComponents mcmprods = LRRModel.Model.FilterMasterComponentsByComponentTypeID("COMPPROD");
			LRRMasterComponents mcmrawmats = LRRModel.Model.FilterMasterComponentsByComponentTypeID("COMPRAWMAT");
			LRRMasterComponents mcmprodlines = LRRModel.Model.FilterMasterComponentsByComponentTypeID("COMPPRODLINE");
			
			foreach(LRRMasterComponent mc in mcmprods)
			{
				_mastercomponentsComboList.Add(mc);
			}
			foreach(LRRMasterComponent mc in mcmrawmats)
			{
				_mastercomponentsComboList.Add(mc);
			}
			foreach(LRRMasterComponent mc in mcmprodlines)
			{
				_mastercomponentsComboList.Add(mc);
			}

			_siteComponentsComboList = new LRRSiteComponents();

			foreach(LRRMasterComponent mcmp in _mastercomponentsComboList)
			{
				LRRSiteComponents lscs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(mcmp.ID);	
				foreach(LRRSiteComponent lsc in lscs)
				{
					_siteComponentsComboList.Add(lsc);
					cmbProdrawmatlist.Items.Add(lsc.Name);
				}
			}
			if(_siteComponentsComboList.Count > 0)
			{
				cmbProdrawmatlist.SelectedIndex = 0;
				LRRSiteComponent lsc1 = LRRModel.SiteComponentsObj.GetSiteComponentByName(cmbProdrawmatlist.SelectedItem.ToString());
				txtIndicesDesc.Text = lsc1.Description;
				selectedSiteItem = lsc1.SiteComponentID;
				InitializeDataSource();
				BindSiteItemsGrid();
			}
	
		}
		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add IndicesConfiguration.LeftColMovement implementation
		}

		public void ClearSort()
		{
			// TODO:  Add IndicesConfiguration.ClearSort implementation
		}

		public void RightLevel()
		{
			// TODO:  Add IndicesConfiguration.RightLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add IndicesConfiguration.UpLevel implementation
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add IndicesConfiguration.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add IndicesConfiguration.SupportsLevel implementation
			return false;
		}

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add IndicesConfiguration.PerformDirtyChk getter implementation
				return false;
			}
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add IndicesConfiguration.SupportsRefresh implementation
			return false;
		}

		public void Undo()
		{
			// TODO:  Add IndicesConfiguration.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridIndicesItems);
            Refresh();
		}

		public bool SupportsCopy()
		{
			// TODO:  Add IndicesConfiguration.SupportsCopy implementation
			return false;
		}

		public void SelectionPaste()
		{
			// TODO:  Add IndicesConfiguration.SelectionPaste implementation
		}

		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		public void PageSetup()
		{
			// TODO:  Add IndicesConfiguration.PageSetup implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add IndicesConfiguration.OpenQuery implementation
		}

		public void Copy()
		{
			// TODO:  Add IndicesConfiguration.Copy implementation
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add IndicesConfiguration.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add IndicesConfiguration.SupportsPageSetup implementation
			return false;
		}

		public void ShowPropertyList()
		{
			// TODO:  Add IndicesConfiguration.ShowPropertyList implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add IndicesConfiguration.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add IndicesConfiguration.SupportsClearSort implementation
			return false;
		}

		public void RightColMovement()
		{
			// TODO:  Add IndicesConfiguration.RightColMovement implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add IndicesConfiguration.LeftLevel implementation
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add IndicesConfiguration.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add IndicesConfiguration.SupportsDelete implementation
			return false;
		}

		public void PrintPreview()
		{
			// TODO:  Add IndicesConfiguration.PrintPreview implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add IndicesConfiguration.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add IndicesConfiguration.SupportsPaste implementation
			return false;
		}

		public void Print()
		{
			// TODO:  Add IndicesConfiguration.Print implementation
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add IndicesConfiguration.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add IndicesConfiguration.SupportsPrint implementation
			return false;
		}

		public void OpenView()
		{
			// TODO:  Add IndicesConfiguration.OpenView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add IndicesConfiguration.TransposeView implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add IndicesConfiguration.ArrangeColumns implementation
		}

		public void Export()
		{
			// TODO:  Add IndicesConfiguration.Export implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add IndicesConfiguration.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public void ShowComponentList()
		{
			// TODO:  Add IndicesConfiguration.ShowComponentList implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add IndicesConfiguration.ClearFilter implementation
		}

		public void OpenCompositeView()
		{
			// TODO:  Add IndicesConfiguration.OpenCompositeView implementation
		}

		public void Delete()
		{
			// TODO:  Add IndicesConfiguration.Delete implementation
		}

		public bool SupportsUndo()
		{
			// TODO:  Add IndicesConfiguration.SupportsUndo implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add IndicesConfiguration.SupportsExport implementation
			return false;
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add IndicesConfiguration.CopyUOMTypes implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add IndicesConfiguration.ImportToExcel implementation
		}

		public void Refresh()
		{
			// TODO:  Add IndicesConfiguration.Refresh implementation
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add IndicesConfiguration.SupportsSelectionPaste implementation
			return false;
		}

		public void DownLevel()
		{
			// TODO:  Add IndicesConfiguration.DownLevel implementation
		}

		public void Paste()
		{
			// TODO:  Add IndicesConfiguration.Paste implementation
		}

		public bool SupportsSave()
		{
			// TODO:  Add IndicesConfiguration.SupportsSave implementation
			return true;
		}

		public void InsertNewRows()
		{
			// TODO:  Add IndicesConfiguration.InsertNewRows implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add IndicesConfiguration.CopyMasterProperties implementation
		}

		public void Save()
		{
			isSaved = false;

			int Count = _indicesXrefsList.GetChanges().Count;
			if(Count > 0)
			{
				foreach(LRRIndicesXRef indxref in _indicesXrefsList.GetChanges())
				{
					if(indxref.ObjectState == DBOperation.INSERT)
					{
						LRRModel.IndicesXRefs.Add(indxref);
					}
					else if(indxref.ObjectState == DBOperation.DELETE)
					{
						LRRModel.IndicesXRefs.Remove(indxref);
					}
				}
				LRRModel.IndicesXRefs.RefreshCollection();   
				_app.DBManagerObj.CommitCollection(_indicesXrefsList.GetChanges());  
				_indicesXrefsList.RefreshCollection();
				isSaved = true;
			}
//			Count = _lrrindUsages.GetChanges().Count;
//			if(Count>0)
//			{
//				foreach(LRRIndicesUsage indusage in _lrrindUsages.GetChanges())
//				{
//					if(indusage.ObjectState == DBOperation.INSERT)
//					{
//						LRRModel.IndicesUsages.Add(indusage);
//					}
//					else if(indusage.ObjectState == DBOperation.DELETE)
//					{
//						LRRModel.IndicesUsages.Remove(indusage);
//					}
//				}
//			//	LRRIndicesUsages xrefusages = LRRModel.IndicesUsages.GetChanges();
//				_app.DBManagerObj.CommitCollection(_lrrindUsages.GetChanges());
//				_lrrindUsages.RefreshCollection();
			/*foreach(LRRIndicesXRef indexRef in _indicesXrefsList)
			{
				LRRIndicesUsages indiceUsages = LRRModel.IndicesUsages.GetUsagesFromIndexRefID(indexRef.ID);
				if(indiceUsages.GetChanges().Count > 0)
				{
					foreach(LRRIndicesUsage indiceUsage in indiceUsages)
					{
						if(indiceUsage.ObjectState == DBOperation.INSERT)
						{
							LRRModel.IndicesUsages.Add(indiceUsage);   
						}
						else if(indiceUsage.ObjectState == DBOperation.DELETE)
						{
							LRRModel.IndicesUsages.Remove(indiceUsage); 
						}
					}
					_app.DBManagerObj.CommitCollection(indiceUsages.GetChanges());  
				}
			}*/
			if(LRRModel.IndicesUsages.GetChanges().Count>0)
			{
				_app.DBManagerObj.CommitCollection(LRRModel.IndicesUsages.GetChanges());
				LRRModel.IndicesUsages.RefreshCollection();
				isSaved = true;
			}
			Refresh();
			if(isSaved)
			{
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);	
			}
			isSaved = false;
			ApplicationPersistanceUtil.SaveGridSettings(gridIndicesItems,this,this.Tag);

		}

		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add IndicesConfiguration.SupportsCopyUOMTypes implementation
			return false;
		}
	

		#endregion

		#region fields
		private LRRSiteComponents						_siteComponentsList;
		private GridUnBoundColumn						gridUnBoundSiteItem=new GridUnBoundColumn();
		private LRRApp									_app;
		private string									_LocaleID;
		private LRRMasterComponents						_mastercomponentsComboList;
		private LRRSiteComponents						_siteComponentsComboList;
		private LRRIndicesXRefs							_indicesXrefsList;
		static string									selectedSiteItem;
		private LRRIndicesUsages						_lrrindUsages;
		private bool									isSaved;
		#endregion

		private void cmbProdrawmatlist_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//txtIndicesDesc
			LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByName(cmbProdrawmatlist.SelectedItem.ToString());
			txtIndicesDesc.Text = lsc.Description;
			selectedSiteItem = lsc.SiteComponentID;
			InitializeDataSource();
			BindSiteItemsGrid();
		}

		private void btnAddIndElements_Click(object sender, System.EventArgs e)
		{
			LRRSiteComponents lscs = new LRRSiteComponents();
			//LRRIndicesXRefs lrrxrefs = LRRModel.IndicesXRefs.GetSiteItemXRefsByIndexID(selectedSiteItem);
			if(selectedSiteItem != null)
			{
				foreach(LRRIndicesXRef selectedCRef in LRRModel.IndicesXRefs.GetSiteItemXRefsByIndexID(selectedSiteItem))
				{
					LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(selectedCRef.SiteComponentID);
					lscs.Add(lsc);
				}
				AddIndicesItems frmaddIndices = new AddIndicesItems(_siteComponentsComboList,selectedSiteItem,lscs,this);
				//frmaddIndices.Show();
				frmaddIndices.ShowDialog();
			}
			//InitializeDataSource();
			//BindSiteItemsGrid();
			/*gridIndicesItems.DataSource = null; 
			gridIndicesItems.TableDescriptor.Relations.Clear();
			gridIndicesItems.DataSource  = LRRModel.IndicesXRefs.GetSiteItemXRefsByIndexID(selectedSiteItem);*/
		}

		public void BindSiteItemGridWithXref(LRRIndicesXRefs indexXrefs)
		{
			ApplicationPersistanceUtil.SaveGridSettings(gridIndicesItems,null,this.Tag);
			BindSiteItemsGrid(indexXrefs);
			ApplicationPersistanceUtil.ApplyGridSettings(gridIndicesItems,null,this.Tag);
			_indicesXrefsList = indexXrefs;
		}
		public void RecieveUsages(LRRIndicesUsages indUsages)
		{
			_lrrindUsages = indUsages;
		}

		private void gridIndicesItems_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			/*GridTableDescriptor tableDescriptor = e.TableControl.TableDescriptor;
			GridColumnDescriptor column = e.TableControl.Table.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex);
			string col = column.Name;
			if(col == "Usage")
			{
				int xyz = 0;
			}

			/*if(e.Inner.MouseEventArgs.Button == MouseButtons.Right
				&& e.TableControl.TableDescriptor.Name == "Usage")
			{
				//this.gridContext.Show(this.gridSiteComponent, this.gridSiteComponent.PointToClient(Control.MousePosition));
				int xyz = 0;

			}*/
		}

		private void gridIndicesItems_TableControlCellButtonClicked(object sender, GridTableControlCellButtonClickedEventArgs e)
		{
			//GridTableDescriptor tableDescriptor = e.TableControl.TableDescriptor;
			//e.TableControl.Table.TableModel.Selections.SelectRange(GridRangeInfo.Row(e.Inner.RowIndex),true); 
			//e.TableControl.Table.TableModel.ScrollCellInView(GridRangeInfo.Row(e.Inner.RowIndex),GridScrollCurrentCellReason.Any);      
			GridColumnDescriptor column = e.TableControl.Table.GetColumnDescriptorAt(e.Inner.RowIndex, e.Inner.ColIndex);
			LRRIndicesXRef curXRef = e.TableControl.Table.CurrentRecord.GetData() as LRRIndicesXRef;
			string col = column.Name;
			if(col == "Usage")
			{
				UsageWindow frmUsageWin = new UsageWindow(curXRef);
				frmUsageWin.ShowDialog();
			}
			gridIndicesItems.TableModel.Table.SelectedRecords.Clear(); 
		}

		
	}
}
