using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Symcon.LightRidge.Options;
using Symcon.Utils.XMLUtils;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using System.Threading; 
using System.Reflection;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for LRRWaitWindow.
	/// </summary>
	public class LRRWaitWindow
	{
		
		#region constructor
		public LRRWaitWindow()
		{
			_mainframe = new PEMainWindow();
			lrrapp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_pw = new ProgressWindow();
		}
		#endregion


		#region method

		private void LRRShowWaitWindow(object obj)
		{
			if(_mainframe.InvokeRequired) 
			{
				object[] args = new object[1];
				args[0] = null;
				_pw.Refresh();
				_mainframe.Invoke(new WaitCallback(LRRShowWaitWindow),args); 
			}
			else
			{
				lrrapp.LRRUIManagerObj.ShowWindow(_windowID);   
			}
			_pw.Dispose();
		}
		


		public void ShowWaitWindow(PEMainWindow _main,LRRApp app, int Id)
		{
			_mainframe = _main; 
			lrrapp = app;
			_windowID = Id;
			ThreadPool.QueueUserWorkItem(new WaitCallback(LRRShowWaitWindow));
			_pw.ShowDialog(_mainframe); 
		}
		public void ExecuteMethodWithWait(object sourceObject,string methodName,object[] arguments)
		{
			sourceObject.GetType().GetMethod(methodName).Invoke(sourceObject,arguments);
		}
		#endregion



		#region private Fields
        
		private PEMainWindow					_mainframe;
		private ProgressWindow					_pw;
		private LRRApp							lrrapp;
		private int _windowID;
		private System.Windows.Forms.Form		_objForm = new Form();
		private string s;
		
		#endregion
	}

}
