using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Utils.MessageLogger;
using Symcon.Globals;
using Symcon.LightRidge.BusinessObjects;
//using Syncfusion.Windows.Forms.Diagram.Controls;
//using Syncfusion.Windows.Forms.Diagram;
using System.IO;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for LevelDefinitions.
	/// </summary>
	public class LevelDefinitions : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private LRRApp				_app;
		private LRRLevels			_lrrLevels = new LRRLevels();
		private System.Windows.Forms.Button button2;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private LRRLevelLinks		_lrrLevelLinks = new LRRLevelLinks();
		


		public LevelDefinitions()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_app.DBManagerObj.PopulateCollection(_lrrLevels);
			_app.DBManagerObj.PopulateCollection(_lrrLevelLinks);

			/*foreach(LRRLevel l in this._lrrLevels)
			{
				_levelHash.Add(l.LevelID,l);
			}

			foreach(LRRLevelLink ll in this._lrrLevelLinks)
			{
				_linkDictionary.Add(ll.ParentID,_levelHash[ll.ChildID] as LRRLevel);
				_childParent.Add(ll.ChildID,ll.ParentID);
			}*/
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LevelDefinitions));
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).BeginInit();
			this.SuspendLayout();
			// 
			// treeView1
			// 
			this.treeView1.ImageIndex = -1;
			this.treeView1.Location = new System.Drawing.Point(8, 8);
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = -1;
			this.treeView1.Size = new System.Drawing.Size(200, 344);
			this.treeView1.Sorted = true;
			this.treeView1.TabIndex = 0;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(376, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 40);
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(360, 112);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(120, 48);
			this.button2.TabIndex = 2;
			this.button2.Text = "button2";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// diagram1
			// 
			this.diagram1.AllowDrop = true;
			// 
			// diagram1.Controller
			// 
			//this.diagram1.Controller.MaxHistory = 256;
			this.diagram1.HScroll = true;
			this.diagram1.LayoutManager = null;
			this.diagram1.Location = new System.Drawing.Point(48, 8);
			// 
			// diagram1.Model
			// 
			this.diagram1.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram1.Model.BackgroundStyle.GradientAngle = 90F;
			//this.diagram1.Model.BackgroundStyle.GradientStartColor = System.Drawing.Color.White;
            
			this.diagram1.Model.BackgroundStyle.Texture = null;
			this.diagram1.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram1.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.Solid;
			this.diagram1.Model.BoundaryConstraintsEnabled = true;
			this.diagram1.Model.BackgroundStyle.ColorAlphaFactor= 255;
			this.diagram1.Model.BackgroundStyle.Color = System.Drawing.Color.LightGray;
			this.diagram1.Model.BackgroundStyle.GradientAngle = 90F;
			//this.diagram1.Model.BackgroundStyle.GradientStartColor = System.Drawing.Color.LightGray;
			this.diagram1.Model.BackgroundStyle.Texture = null;
			this.diagram1.Model.BackgroundStyle.TextureWrapMode = System.Drawing.Drawing2D.WrapMode.Tile;
			this.diagram1.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.Solid;
			//this.diagram1.Model.Height = 1056F;
            
            
            
			this.diagram1.Model.LineStyle.DashCap = System.Drawing.Drawing2D.DashCap.Flat;
			this.diagram1.Model.LineStyle.DashOffset = 0F;
			this.diagram1.Model.LineStyle.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
			this.diagram1.Model.LineStyle.EndCap = System.Drawing.Drawing2D.LineCap.Flat;
			this.diagram1.Model.LineStyle.LineColor = System.Drawing.Color.Black;
			this.diagram1.Model.LineStyle.LineJoin = System.Drawing.Drawing2D.LineJoin.Bevel;
			this.diagram1.Model.LineStyle.LineWidth = 2F;
			this.diagram1.Model.LineStyle.MiterLimit = 10F;
			//this.diagram1.Model.MeasurementScale = 1F;
            
			//this.diagram1.Model.MeasurementUnits = System.Drawing.GraphicsUnit.Pixel;
			this.diagram1.Model.Name = "Model";
       
			//this.diagram1.Model.PrintData.Culture = new System.Globalization.CultureInfo("en-US");
			//this.diagram1.Model.PrintData.Footer.BorderStyle.Color = System.Drawing.Color.Black;
			//this.diagram1.Model.PrintData.Footer.BorderStyle.ShowBorder = false;
			//this.diagram1.Model.PrintData.Footer.BorderStyle.Style = System.Drawing.Drawing2D.DashStyle.Solid;
			//this.diagram1.Model.PrintData.Footer.Bounds.Height = 0F;
			//this.diagram1.Model.PrintData.Footer.Bounds.LeftMargin = 0F;
			//this.diagram1.Model.PrintData.Footer.Bounds.PageWidth = 650F;
			//this.diagram1.Model.PrintData.Footer.Bounds.RealHeight = 0F;
			//this.diagram1.Model.PrintData.Footer.Bounds.RealWidth = 0F;
			//this.diagram1.Model.PrintData.Footer.Bounds.RightMargin = 0F;
			//this.diagram1.Model.PrintData.Footer.Bounds.Width = 650F;
			//this.diagram1.Model.PrintData.Footer.Bounds.XLocation = 0F;
			//this.diagram1.Model.PrintData.Footer.Bounds.YLocation = 0F;
			//this.diagram1.Model.PrintData.Footer.Center = "";
			//this.diagram1.Model.PrintData.Footer.Culture = new System.Globalization.CultureInfo("en-US");
			//this.diagram1.Model.PrintData.Footer.CurrentPage = 0;
			//this.diagram1.Model.PrintData.Footer.ForeColor = System.Drawing.SystemColors.ControlText;
			//this.diagram1.Model.PrintData.Footer.Left = "";
			//this.diagram1.Model.PrintData.Footer.MarginLeft = 0F;
			//this.diagram1.Model.PrintData.Footer.MarginRight = 0F;
			//this.diagram1.Model.PrintData.Footer.Right = "";
			//this.diagram1.Model.PrintData.Footer.TotalPages = 0;
			//this.diagram1.Model.PrintData.Footer.Visible = false;
			//this.diagram1.Model.PrintData.Header.BorderStyle.Color = System.Drawing.Color.Black;
            
            
			//this.diagram1.Model.PrintData.Header.BorderStyle.ShowBorder = false;
			//this.diagram1.Model.PrintData.Header.BorderStyle.Style = System.Drawing.Drawing2D.DashStyle.Solid;
			//this.diagram1.Model.PrintData.Header.Bounds.Height = 0F;
			//this.diagram1.Model.PrintData.Header.Bounds.LeftMargin = 0F;
			//this.diagram1.Model.PrintData.Header.Bounds.PageWidth = 650F;
			//this.diagram1.Model.PrintData.Header.Bounds.RealHeight = 0F;
			//this.diagram1.Model.PrintData.Header.Bounds.RealWidth = 0F;
			//this.diagram1.Model.PrintData.Header.Bounds.RightMargin = 0F;
			//this.diagram1.Model.PrintData.Header.Bounds.Width = 650F;
            //this.diagram1.View.PageSettings.Bounds.Width = 650F;
			//this.diagram1.Model.PrintData.Header.Bounds.XLocation = 0F;
			//this.diagram1.Model.PrintData.Header.Bounds.YLocation = 0F;
			//this.diagram1.Model.PrintData.Header.Center = "";
			//this.diagram1.Model.PrintData.Header.Culture = new System.Globalization.CultureInfo("en-US");
			//this.diagram1.Model.PrintData.Header.CurrentPage = 0;
            
			//this.diagram1.Model.PrintData.Header.ForeColor = System.Drawing.SystemColors.ControlText;
			//this.diagram1.Model.PrintData.Header.Left = "";
			//this.diagram1.Model.PrintData.Header.MarginLeft = 0F;
			//this.diagram1.Model.PrintData.Header.MarginRight = 0F;
			//this.diagram1.Model.PrintData.Header.Right = "";
			//this.diagram1.Model.PrintData.Header.TotalPages = 0;
            
			//this.diagram1.Model.PrintData.Header.Visible = false;
          
			//this.diagram1.Model.PrintData.PrintingZoom = 0F;
            //this.diagram1.View.PrintZoom.PrintingZoom = 0F;
            
            //this.diagram1.Controller.View.PrintZoom = 0F;
			this.diagram1.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.Default;
			//this.diagram1.Model.ShadowStyle.AlphaFactor = 128;
            this.diagram1.Model.ShadowStyle.ColorAlphaFactor = 128;
			this.diagram1.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram1.Model.ShadowStyle.OffsetX = 6F;
			this.diagram1.Model.ShadowStyle.OffsetY = 6F;
			this.diagram1.Model.ShadowStyle.Visible = false;
			//this.diagram1.Model.Width = 816F;
			this.diagram1.Name = "diagram1";
			this.diagram1.NudgeIncrement = 1F;
			this.diagram1.ScrollGranularity = 0.5F;
			this.diagram1.Size = new System.Drawing.Size(236, 440);
			this.diagram1.SmartSizeBox = false;
			this.diagram1.TabIndex = 4;
			this.diagram1.Text = "diagram1";
			// 
			// diagram1.View
			// 
			this.diagram1.View.BackgroundColor = System.Drawing.Color.DarkGray;
			this.diagram1.View.Grid.Color = System.Drawing.Color.Black;
			this.diagram1.View.Grid.DashOffset = 4F;
			this.diagram1.View.Grid.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
			this.diagram1.View.Grid.GridStyle = Syncfusion.Windows.Forms.Diagram.GridStyle.Point;
			this.diagram1.View.Grid.HorizontalSpacing = 10F;
			this.diagram1.View.Grid.SnapToGrid = true;
			this.diagram1.View.Grid.VerticalSpacing = 10F;
			this.diagram1.View.Grid.Visible = true;
			this.diagram1.View.HandleAnchorColor = System.Drawing.Color.LightGray;
			this.diagram1.View.HandleColor = System.Drawing.Color.White;
			this.diagram1.View.HandleDisabledColor = System.Drawing.Color.Black;
			this.diagram1.View.HandleSize = 6;
			//this.diagram1.View.HorizontalRuler.Visible = false;
			this.diagram1.View.MouseTrackingEnabled = true;
			this.diagram1.View.PasteOffsetX = 10;
			this.diagram1.View.PasteOffsetY = 10;
            
			//this.diagram1.View.RulerFillColor = System.Drawing.Color.LightGray;
			//this.diagram1.View.RulerLineColor = System.Drawing.Color.Black;
			//this.diagram1.View.RulerScale = 1;
			//this.diagram1.View.RulerSize = 16;
            //this.diagram1.Controller.Viewer.RulersHeight = 16;
			//this.diagram1.View.RulerUnits = Syncfusion.Windows.Forms.Diagram.MeasurementsUnit.Inches;
            
			//this.diagram1.View.ShowPageBounds = true;
			//this.diagram1.View.VerticalRuler.Visible = false;
			this.diagram1.VScroll = true;
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(352, 200);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(128, 48);
			this.button3.TabIndex = 5;
			this.button3.Text = "button3";
			// 
			// button4
			// 
			this.button4.Location = new System.Drawing.Point(352, 280);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(112, 56);
			this.button4.TabIndex = 6;
			this.button4.Text = "button4";
			// 
			// LevelDefinitions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 486);
			this.Controls.Add(this.button4);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.diagram1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.treeView1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "LevelDefinitions";
			this.Text = "LevelDefinitions";
			((System.ComponentModel.ISupportInitialize)(this.diagram1.Model)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			/*IDictionaryEnumerator DicEnum = _linkDictionary.GetEnumerator();
			while(DicEnum.MoveNext())
			{
				string ParentID =  (string)DicEnum.Key;
				LRRLevel currentParentLevel = _levelHash[ParentID] as LRRLevel;
                TreeNode tn = new TreeNode(currentParentLevel.Name);
				tn.Tag = currentParentLevel;
                ArrayList child = DicEnum.Value as ArrayList;
				for(int i=0;i<child.Count;i++)
				{
					LRRLevel childLevel = child[i] as LRRLevel;
					TreeNode childNode = new TreeNode(childLevel.Name);
					childNode.Tag = childLevel;
					tn.Nodes.Add(childNode);
				}
				_nodesHash.Add(ParentID,tn);
			}

			foreach(object k in _childParent.Keys)
			{
				string childID = (string)k;
				string parentID = (string)_childParent[k];
				TreeNode  childNode = null;
				TreeNode  parentNode = null;
				if(_nodesHash.ContainsKey(childID))
				{
					childNode = _nodesHash[childID] as TreeNode;
				}
				if(_nodesHash.ContainsKey(parentID))
				{
					parentNode = _nodesHash[parentID] as TreeNode;
				}
				if((parentNode != null) && (childNode != null))
				{
					int index = -1;
					foreach(TreeNode f in parentNode.Nodes)
					{
						if(f.Tag == childNode.Tag)
						{
							index = f.Index;
							break;
						}
					}
					if(index != -1)
						parentNode.Nodes[index] = childNode;
				}
			}

			TreeNode rootNode = _nodesHash["0"] as TreeNode;
			treeView1.Nodes.Add(rootNode);*/
			PopulateLevels(treeView1,_lrrLevels,_lrrLevelLinks);
		
		}

		/// <summary>
		/// This Method is used to populate a treeview with the level 
		/// and the link table..
		/// </summary>
		/// <param name="treeView">TreeView Instance</param>
		/// <param name="levels">levels table</param>
		/// <param name="levelLinks">level link table</param>
		/// <returns></returns>
		private bool PopulateLevels(TreeView treeView,LRRLevels levels,LRRLevelLinks levelLinks)
		{
			try
			{
				Hashtable			_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRLevel l in levels)
				{
					_levelHash.Add(l.LevelID,l);
				}
				foreach(LRRLevelLink ll in levelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						TreeNode foundNode = _nodesHash[ll.ParentID] as TreeNode;
						LRRLevel foundLevel = _levelHash[ll.ChildID] as LRRLevel; 
						TreeNode childNode = new TreeNode(foundLevel.Name);
						childNode.Tag = foundLevel;
						foundNode.Nodes.Add(childNode);
					}
					else
					{
						LRRLevel parentLevel = _levelHash[ll.ParentID] as LRRLevel;
						LRRLevel childLevel = _levelHash[ll.ChildID] as LRRLevel;
						TreeNode parentNode = new TreeNode(parentLevel.Name);
						parentNode.Tag = parentLevel;
						TreeNode childNode = new TreeNode(childLevel.Name);
						childNode.Tag = childLevel;
						parentNode.Nodes.Add(childNode);
						_nodesHash.Add(ll.ParentID,parentNode);
					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					TreeNode  childNode = null;
					TreeNode  parentNode = null;
					if(_nodesHash.ContainsKey(childID))
					{
						childNode = _nodesHash[childID] as TreeNode;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentNode = _nodesHash[parentID] as TreeNode;
					}
					if((parentNode != null) && (childNode != null))
					{
						int index = -1;
						foreach(TreeNode f in parentNode.Nodes)
						{
							if(f.Tag == childNode.Tag)
							{
								index = f.Index;
								break;
							}
						}
						if(index != -1)
							parentNode.Nodes[index] = childNode;
					}
				}

				TreeNode rootNode = _nodesHash["0"] as TreeNode;
				treeView.Nodes.Add(rootNode);
				return true;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LevelDefinitions),"PopulateLevels:"+ex.Message  ,Logger.Level.Debug);
				return false;
			}
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			string sourceFilePath = @"E:\Ashutosh\Company\BLOBSample\bin\Debug\doc2.edd";
			FileStream fileStream = new FileStream(sourceFilePath,FileMode.Open,FileAccess.Read);
			byte[] fileContents = new byte[fileStream.Length];
			fileStream.Read(fileContents,0,fileContents.Length);
			fileStream.Close();
			LRRLevels levels = new LRRLevels();
			LRRLevel l = new LRRLevel();
			l.Description  = "TEST";
			l.Name = "TESTBLOB";
			levels.Add(l);
			_app.DBManagerObj.CommitCollection(levels);
		}

		/*private void button3_Click(object sender, System.EventArgs e)
		{
			LRRLevels levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(levels," WHERE ID = 'dfd16a37-9f29-43cf-b4f4-0860d2125df8'");
			LRRLevel l = levels[0];

			Stream sr = new MemoryStream(l.Blob);

			//MessageBox.Show(sr.Position.ToString());
			diagram1.LoadBinary(sr);

		}*/

		/*private void button4_Click(object sender, System.EventArgs e)
		{
			LRRLevels levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(levels," WHERE ID = 'dfd16a37-9f29-43cf-b4f4-0860d2125df8'");
			LRRLevel l = levels[0];

			Stream sr = new MemoryStream(l.Blob);

			//MessageBox.Show(sr.Position.ToString());
			diagram1.LoadBinary(sr);

			l.ObjectState = Symcon.Globals.Enums.DBOperation.UPDATE;

			LRRLevels ls = levels.GetChanges();

			_app.DBManagerObj.CommitCollection(ls);
			
		}*/

	}
	
}
