using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.Utils.MessageDispatcher;  
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects; 
using Symcon.LightRidge.ExecutionEngine.Model;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for Log.
	/// </summary>
	public class Log : System.Windows.Forms.Form,ILRRUIContainer
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Log(string logId)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.richTextBoxLog.Dock = DockStyle.Fill;

			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			LRRModelConfiguration modelConf = new LRRModelConfiguration();
			_lrrApp.DBManagerObj.PopulateObject(modelConf,typeof(LRRModelConfiguration), " where ID='" + logId + "' and ParamName='Log'");
			if(modelConf.ParamValue!=null)
			{
				_filePath = modelConf.ParamValue;
				this.Text = "Log: " + _filePath.Substring(_filePath.LastIndexOf("\\") + 1);
				ShowFile();
			}
			else
			{
				throw new Exception("Cannot populate chart object");
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.richTextBoxLog = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// richTextBoxLog
			// 
			this.richTextBoxLog.Location = new System.Drawing.Point(64, 48);
			this.richTextBoxLog.Name = "richTextBoxLog";
			this.richTextBoxLog.ReadOnly = true;
			this.richTextBoxLog.TabIndex = 0;
			this.richTextBoxLog.Text = "";
			// 
			// Log
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.richTextBoxLog);
			this.Name = "Log";
			this.Tag = "SID_LOG";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Log_Closing);
			this.Load += new System.EventHandler(this.Log_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#region Fields

		private string _filePath;
		private LRRApp _lrrApp;
		private TabPage _parentTabPage;
		private System.Windows.Forms.RichTextBox richTextBoxLog;
		private TabControl _parentTabControl;

		#endregion

		#region Private Methods

		private void ShowFile()
		{
			if(File.Exists(_filePath))
			{
				FileStream file = new FileStream(_filePath, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
				StreamReader sr = new StreamReader(file);
				richTextBoxLog.Clear();
				richTextBoxLog.AppendText(sr.ReadToEnd());
				sr.Close();
				file.Close();
			}
			else
			{
				//MessageBox.Show(this, "File \"" + _filePath + "\" not found","Error", MessageBoxButtons.OK,MessageBoxIcon.Error);
				string[] s = new string[1];
				s[0] = _filePath;
				LRRMessagBox.ShowMessage(this,"SID_FILE_NOT_FOUND","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);    
				throw new FileNotFoundException("Log file not found.");
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void Refresh()
		{
			// TODO:  Add FinancialOverview.Refresh implementation
			ShowFile();
		}

		public void Save()
		{
			// TODO:  Add FinancialOverview.Save implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add FinancialOverview.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add FinancialOverview.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add FinancialOverview.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add FinancialOverview.Print implementation
		}

		public void PrintPreview()
		{
			// TODO:  Add FinancialOverview.PrintPreview implementation
		}

		public void Delete()
		{
			// TODO:  Add FinancialOverview.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add FinancialOverview.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add FinancialOverview.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add FinancialOverview.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add FinancialOverview.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add FinancialOverview.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add FinancialOverview.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add FinancialOverview.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add FinancialOverview.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add FinancialOverview.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add FinancialOverview.DownLevel implementation
		}

		public void ClearSort()
		{
			// TODO:  Add FinancialOverview.ClearSort implementation
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add FinancialOverview.CopyUOMTypes implementation
		}

		public void ShowPropertyList()
		{
			// TODO:  Add FinancialOverview.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add FinancialOverview.ShowComponentList implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add FinancialOverview.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add FinancialOverview.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add FinancialOverview.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add FinancialOverview.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add FinancialOverview.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add FinancialOverview.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add FinancialOverview.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add FinancialOverview.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add FinancialOverview.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add FinancialOverview.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add FinancialOverview.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add FinancialOverview.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add FinancialOverview.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add FinancialOverview.SupportsLevel implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add FinancialOverview.SupportsClearSort implementation
			return false;
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add FinancialOverview.SupportsCopyUOMTypes implementation
			return false;
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add FinancialOverview.SupportsResultsFilter implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add FinancialOverview.ParentTabControl getter implementation
				return _parentTabControl;
			}
			set
			{
				// TODO:  Add FinancialOverview.ParentTabControl setter implementation
				_parentTabControl = value;
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add FinancialOverview.ParentTabPage getter implementation
				return _parentTabPage;
			}
			set
			{
				// TODO:  Add FinancialOverview.ParentTabPage setter implementation
				_parentTabPage = value;
			}
		}
		public 	void LeftColMovement()
		{
		}
		public void RightColMovement()
		{
		}
		#endregion
		private void Log_Load(object sender, System.EventArgs e)
		{
			_lrrApp.RunControllerObj.RunCycleCompleted += new EventHandler(RunControllerObj_RunCycleCompleted);
		}

		private void RunControllerObj_RunCycleCompleted(object sender, EventArgs e)
		{
			ShowFile();
		}

		private void Log_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			_lrrApp.RunControllerObj.RunCycleCompleted -= new EventHandler(RunControllerObj_RunCycleCompleted);
		}
		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add Log.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add Log.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add Log.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add Log.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add Log.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add Log.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add Log.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add Log.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add Log.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add Log.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add Log.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add Log.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add Log.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
