using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.Utils.MessageDispatcher;  
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects; 


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for LoggerLog.
	/// </summary>
	public class LoggerLog : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.RichTextBox richTextLog;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private string _filePath=Application.StartupPath+@"\"+"LRRLog.log";
		private TabPage _parentTabPage;
		private TabControl _parentTabControl;

		public LoggerLog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			ShowFiles();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Private Method
		/// <summary>
		/// This method is to show the The LogFile
		/// </summary>
		private void ShowFiles()
		{
			if(File.Exists(_filePath))
			{
				FileStream	fileStream=new FileStream(_filePath,FileMode.Open,FileAccess.Read,FileShare.ReadWrite);
				StreamReader streamReader=new StreamReader(fileStream);
				richTextLog.Clear();
				richTextLog.AppendText(streamReader.ReadToEnd());
				streamReader.Close();
				fileStream.Close();
			}
			else
			{
				string[] s = new string[1];
				s[0] = _filePath;
				LRRMessagBox.ShowMessage(this,"SID_FILE_NOT_FOUND","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);   
			}
		}

		#endregion



		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.richTextLog = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// richTextLog
			// 
			this.richTextLog.Dock = System.Windows.Forms.DockStyle.Fill;
			this.richTextLog.Location = new System.Drawing.Point(0, 0);
			this.richTextLog.Name = "richTextLog";
			this.richTextLog.ReadOnly = true;
			this.richTextLog.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Vertical;
			this.richTextLog.Size = new System.Drawing.Size(292, 273);
			this.richTextLog.TabIndex = 0;
			this.richTextLog.Text = "";
			// 
			// LoggerLog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.Add(this.richTextLog);
			this.Name = "LoggerLog";
			this.Tag = "SID_APPLLOG";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.ResumeLayout(false);

		}
		#endregion

		#region ILRRUIContainer Members

		public void Refresh()
		{
			// TODO:  Add FinancialOverview.Refresh implementation
			ShowFiles();
		}

		public void Save()
		{
			// TODO:  Add FinancialOverview.Save implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add FinancialOverview.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add FinancialOverview.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add FinancialOverview.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add FinancialOverview.Print implementation
		}

		public void PrintPreview()
		{
			// TODO:  Add FinancialOverview.PrintPreview implementation
		}

		public void Delete()
		{
			// TODO:  Add FinancialOverview.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add FinancialOverview.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add FinancialOverview.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add FinancialOverview.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add FinancialOverview.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add FinancialOverview.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add FinancialOverview.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add FinancialOverview.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add FinancialOverview.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add FinancialOverview.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add FinancialOverview.DownLevel implementation
		}

		public void ClearSort()
		{
			// TODO:  Add FinancialOverview.ClearSort implementation
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add FinancialOverview.CopyUOMTypes implementation
		}

		public void ShowPropertyList()
		{
			// TODO:  Add FinancialOverview.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add FinancialOverview.ShowComponentList implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add FinancialOverview.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add FinancialOverview.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add FinancialOverview.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add FinancialOverview.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add FinancialOverview.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add FinancialOverview.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add FinancialOverview.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add FinancialOverview.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add FinancialOverview.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add FinancialOverview.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add FinancialOverview.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add FinancialOverview.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add FinancialOverview.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add FinancialOverview.SupportsLevel implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add FinancialOverview.SupportsClearSort implementation
			return false;
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add FinancialOverview.SupportsCopyUOMTypes implementation
			return false;
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add FinancialOverview.SupportsResultsFilter implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add FinancialOverview.ParentTabControl getter implementation
				return _parentTabControl;
			}
			set
			{
				// TODO:  Add FinancialOverview.ParentTabControl setter implementation
				_parentTabControl = value;
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add FinancialOverview.ParentTabPage getter implementation
				return _parentTabPage;
			}
			set
			{
				// TODO:  Add FinancialOverview.ParentTabPage setter implementation
				_parentTabPage = value;
			}
		}
		public 	void LeftColMovement()
		{
		}
		public void RightColMovement()
		{
		}

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add Log.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add Log.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add Log.SupportsUndo implementation
			return false;
		}
		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add LoggerLog.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add LoggerLog.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add LoggerLog.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add LoggerLog.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add LoggerLog.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add LoggerLog.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add LoggerLog.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add LoggerLog.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add LoggerLog.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add LoggerLog.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
