using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Symcon.LightRidge.PEAdvisor
{
    public partial class LoginPreferencesDialog : Form
    {
        public LoginPreferencesDialog()
        {
            InitializeComponent();
            InternationalizationUtils.GetControlText(this, null);

            _app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;//Get the app object...

            _lrrOptionsObj = _app.GetOptions() as Symcon.LightRidge.Options.LRROptions;
        }

        
        #region Events

        private void buttonOk_Click(object sender, EventArgs e)
        {
            _lrrOptionsObj.DisablePersistance = !checkBoxEnablePersistance.Checked;
            _app.ResetNamedRangesFile = checkBoxDeleteNamedRangesFile.Checked;
            _app.ResetMenus = checkBoxResetMenus.Checked;
            
            this.DialogResult = DialogResult.OK;
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        #endregion

        
        #region Fields

        private LRRApp _app = null;
        private Symcon.LightRidge.Options.LRROptions _lrrOptionsObj;

        #endregion
    }
}