using System;
using System.Collections;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for LookUpPropertiesUtility.
	/// </summary>
	public class LookUpPropertiesUtility
	{
		private LRRApp							_app;
		public LookUpPropertiesUtility()
		{
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}

		#region Fields

		LRRGroupProperties groupPropsInserted = new LRRGroupProperties();
		LRRGroupProperties groupPropsDeleted = new LRRGroupProperties();
		LRRSiteComponentGroupProperties siteCompGroupPropsInserted = new LRRSiteComponentGroupProperties();
		LRRSiteComponentGroupProperties siteCompGroupPropsDeleted = new LRRSiteComponentGroupProperties();
		LRRSiteGroupPropertyQualifierValues createdQValues = new LRRSiteGroupPropertyQualifierValues(); 
		ArrayList createdMasterGroupProps = new ArrayList();
		ArrayList deletedMasterGroupProps = new ArrayList();
		ArrayList createdSiteGroupProps = new ArrayList();
		ArrayList deletedSiteGroupProps = new ArrayList();
		ArrayList arrQValues = new ArrayList();
		LRRSiteComponentGroupProperties lscgp = LRRModel.SiteComponentGroupPropertiesObj; 
		LRRSiteGroupPropertyQualifierValues qualiferValues = LRRModel.SiteGroupPropertyQualifierValuesObj;

		#endregion

		/// <summary>
		/// For cascade LookUpProperties Changes to MasterGroupProperties
		/// </summary>
		public void UpdateSiteComponentsLookUpProperties()
		{
			#region New Implementetion By Vihar.

			LRRModel.UpdateSiteComponentsLookUpProperties(out createdSiteGroupProps,out deletedSiteGroupProps,out arrQValues);
			LRRSiteComponentGroupProperty groupProp = createdSiteGroupProps[1] as LRRSiteComponentGroupProperty;
			string propertyID = groupProp.PropertyID;
			LRRSiteComponents lscs = LRRModel.SiteComponentsObj.FilterSiteComponentsByPropertyType(propertyID);
			for(int i=0;i<createdSiteGroupProps.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGroupProp = createdSiteGroupProps[i] as LRRSiteComponentGroupProperty;
				siteCompGroupPropsInserted.Add(siteCompGroupProp);
				lscgp.Add(siteCompGroupProp);
				foreach(LRRSiteComponent lsc in lscs)
				{
					foreach(LRRSiteComponentProperty lscp in lsc.Properties)
					{
						lscp.GroupPpties.Add(siteCompGroupProp);
					}
				}
			}
			for(int i=0;i<deletedSiteGroupProps.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGroupProp = deletedSiteGroupProps[i] as LRRSiteComponentGroupProperty;
				siteCompGroupPropsDeleted.Remove(siteCompGroupProp);
				lscgp.Remove(siteCompGroupProp);
			}
			for(int i=0;i<createdQValues.Count;i++)
			{	
				LRRSiteGroupPropertyQualifierValue qValue =  createdQValues[i] as LRRSiteGroupPropertyQualifierValue;
				createdQValues.Add(qValue);
				qualiferValues.Add(qValue);  
				foreach(LRRSiteComponent lsc in lscs)
				{
					foreach(LRRSiteComponentProperty lscp in lsc.Properties)
					{
						foreach(LRRSiteComponentGroupProperty lscgp in lscp.GroupPpties)
						{
							lscgp.GroupPptiesQualifierValues.Add(qValue);   
						}
					}
				}

			}
			_app.DBManagerObj.ExecuteBatchInsert(siteCompGroupPropsInserted);
			_app.DBManagerObj.ExecuteBatchDelete(siteCompGroupPropsDeleted);
			_app.DBManagerObj.ExecuteBatchInsert(createdQValues);  

			#endregion

			#region Old Code Commented By Vihar.
			/*LRRLookUpProperties lookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(lookUpProperties,false);

			//Update Site Component grouped Properties
			LRRSiteComponentGroupProperties groupProperties = new LRRSiteComponentGroupProperties();
			_app.DBManagerObj.PopulateCollection(groupProperties,false);

			ArrayList arrGroupedProps = new ArrayList();
			ArrayList arrPropertyIDs	= new ArrayList();
			ArrayList arrGroupedPropsDel = new ArrayList();
			

			foreach(LRRSiteComponentGroupProperty groupProperty in groupProperties)
			{
				bool flag = false;
				//Updates in LookUpProperty
				foreach(LRRLookUpProperty lookUpProperty in	lookUpProperties)
				{
					if(groupProperty.PropertyID == lookUpProperty.PropertyID && groupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
					{
						groupProperty.AttributeName = lookUpProperty.Name;
						groupProperty.AttributeDescription = lookUpProperty.Description;
						flag = true;
						break;
					}
				}

				//Inserts in LookUpProperty
				if(!flag)
				{
					LRRSiteComponentGroupProperty siteCompgroupProp = new LRRSiteComponentGroupProperty(); 
					foreach(LRRLookUpProperty lookUpProperty in	lookUpProperties)
					{
						if(groupProperty.PropertyID == lookUpProperty.PropertyID)
						{
							siteCompgroupProp.SiteComponentPropID = groupProperty.SiteComponentPropID;
							siteCompgroupProp.AttributeName = lookUpProperty.Name;
							siteCompgroupProp.AttributeDescription = lookUpProperty.Description;
							siteCompgroupProp.PropertyID = lookUpProperty.PropertyID;
							siteCompgroupProp.LookUpPropertiesID = lookUpProperty.LookUpPropertiesID;
							if(!arrGroupedProps.Contains(siteCompgroupProp))
								arrGroupedProps.Add(siteCompgroupProp);
							break;
						}
					}
				}
	
				if(!arrPropertyIDs.Contains(groupProperty.PropertyID))
					arrPropertyIDs.Add(groupProperty.PropertyID);
			}

			//Deletes in LookUpProperty
			for(int j=0;j < arrPropertyIDs.Count;j++)
			{
				lookUpProperties.ItemFilter = "PropertyID = '" + arrPropertyIDs[j].ToString() + "'";
				int props = lookUpProperties.Count;
				groupProperties.ItemFilter = "PropertyID = '" + arrPropertyIDs[j].ToString() + "'";
				int siteCompProps = groupProperties.Count;
				if(props < siteCompProps)
				{
					foreach(LRRSiteComponentGroupProperty groupProperty in groupProperties)
					{
						bool flag = false;
						foreach(LRRLookUpProperty lookUpProperty in lookUpProperties)
						{
							if(groupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
							{
								flag =true;
								break;
							}
						}
						if(!flag)
						{
							if(!arrGroupedPropsDel.Contains(groupProperty))
								arrGroupedPropsDel.Add(groupProperty);
						}
					}
				}
			}
			
			//Remove
			for(int i=0; i< arrGroupedPropsDel.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGrpProp = arrGroupedPropsDel[i] as LRRSiteComponentGroupProperty;
				groupProperties.Remove(siteCompGrpProp);
			}
			
			//Insert
			for(int i=0; i< arrGroupedProps.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGrpProp = arrGroupedProps[i] as LRRSiteComponentGroupProperty;
				groupProperties.Add(siteCompGrpProp);
			}

			//Save
			if(groupProperties.GetChanges().Count > 0)
			{
				LRRSiteComponentGroupProperties toSaveSiteComponentGroupProperties = groupProperties.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveSiteComponentGroupProperties); 
			}*/

			#endregion
		}

		public void UpdateMasterLookUpProperties()
		{
			#region New Implementetion By Vihar.
			LRRModel.UpdateMasterLookUpProperties(out createdMasterGroupProps,out deletedMasterGroupProps);    
			for(int i=0;i<createdMasterGroupProps.Count;i++)
			{
							
				LRRGroupProperty groupProp = createdMasterGroupProps[i] as LRRGroupProperty;
				groupPropsInserted.Add(groupProp);
				LRRModel.MasterGroupPropertiesObj.Add(groupProp);
			}
			for(int i=0;i<deletedMasterGroupProps.Count;i++)
			{
				LRRGroupProperty groupProp = deletedMasterGroupProps[i] as LRRGroupProperty;
				groupPropsDeleted.Remove(groupProp);
				LRRModel.MasterGroupPropertiesObj.Remove(groupProp);
			}
			_app.DBManagerObj.ExecuteBatchInsert(groupPropsInserted);
			_app.DBManagerObj.ExecuteBatchDelete(groupPropsDeleted);
			LRRModel.MasterGroupPropertiesObj.RefreshCollection(); 
			#endregion

			#region Old Code Commented By Vihar.

			/*LRRLookUpProperties lookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(lookUpProperties,false);

			//Update MasterGrouped Properties
			LRRGroupProperties masterGroupProperties = new LRRGroupProperties();
			_app.DBManagerObj.PopulateCollection(masterGroupProperties,false);

			ArrayList arrMasterGroupedProps = new ArrayList();
			ArrayList arrPropertyIDs	= new ArrayList();
			ArrayList arrMasterGroupedPropsDel = new ArrayList();
			
			
			foreach(LRRGroupProperty masterGroupProperty in masterGroupProperties)
			{
				bool flag = false;
				//Updates in LookUpProperty
				foreach(LRRLookUpProperty lookUpProperty in	lookUpProperties)
				{
					if(masterGroupProperty.PropertyID == lookUpProperty.PropertyID && masterGroupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
					{
						masterGroupProperty.AttributeName = lookUpProperty.Name;
						masterGroupProperty.AttributeDescription = lookUpProperty.Description;
						flag = true;
						break;
					}
				}
				
				//Inserts in LookUpProperty
				if(!flag)
				{
					LRRGroupProperty masterCompgroupProp = new LRRGroupProperty(); 
					foreach(LRRLookUpProperty lookUpProperty in	lookUpProperties)
					{
						if(masterGroupProperty.PropertyID == lookUpProperty.PropertyID)
						{
							masterCompgroupProp.MasterPropertyID = masterGroupProperty.MasterPropertyID;
							masterCompgroupProp.AttributeName = lookUpProperty.Name;
							masterCompgroupProp.AttributeDescription = lookUpProperty.Description;
							masterCompgroupProp.PropertyID = lookUpProperty.PropertyID;
							masterCompgroupProp.LookUpPropertiesID = lookUpProperty.LookUpPropertiesID;
							if(!arrMasterGroupedProps.Contains(masterCompgroupProp))
								arrMasterGroupedProps.Add(masterCompgroupProp);
							break;
						}
					}
				}
				
				if(!arrPropertyIDs.Contains(masterGroupProperty.PropertyID))
					arrPropertyIDs.Add(masterGroupProperty.PropertyID);
			}
			
			//Deletes in LookUpProperty
			for(int j=0;j < arrPropertyIDs.Count;j++)
			{
				lookUpProperties.ItemFilter = "PropertyID = '" + arrPropertyIDs[j].ToString() + "'";
				int props = lookUpProperties.Count;
				masterGroupProperties.ItemFilter = "PropertyID = '" + arrPropertyIDs[j].ToString() + "'";
				int masterProps = masterGroupProperties.Count;
				if(props < masterProps)
				{
					foreach(LRRGroupProperty groupProperty in masterGroupProperties)
					{
						bool flag = false;
						foreach(LRRLookUpProperty lookUpProperty in lookUpProperties)
						{
							if(groupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
							{
								flag =true;
								break;
							}
						}
						if(!flag)
						{
							if(!arrMasterGroupedPropsDel.Contains(groupProperty))
								arrMasterGroupedPropsDel.Add(groupProperty);
						}
					}
				}
			}
			
			//Remove
			for(int i=0; i< arrMasterGroupedPropsDel.Count;i++)
			{
				LRRGroupProperty masterCompGrpProp = arrMasterGroupedPropsDel[i] as LRRGroupProperty;
				masterGroupProperties.Remove(masterCompGrpProp);
			}
			
			//Insert
			for(int i=0; i< arrMasterGroupedProps.Count;i++)
			{
				LRRGroupProperty masterCompGrpProp = arrMasterGroupedProps[i] as LRRGroupProperty;
				masterGroupProperties.Add(masterCompGrpProp);
			}

			//Save
			if(masterGroupProperties.GetChanges().Count > 0)
			{
				LRRGroupProperties toSaveMasterGroupProperties = masterGroupProperties.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveMasterGroupProperties); 
			}*/
			#endregion
		}

		public void UpdateMasterLookUpProperties(string propertyID)
		{
			#region New Implementetion By Vihar.
			LRRModel.UpdateMasterLookUpProperties(propertyID,out createdMasterGroupProps,out deletedMasterGroupProps);
			for(int i=0;i<createdMasterGroupProps.Count;i++)
			{
							
				LRRGroupProperty groupProp = createdMasterGroupProps[i] as LRRGroupProperty;
				groupPropsInserted.Add(groupProp);
				LRRModel.MasterGroupPropertiesObj.Add(groupProp);
			}
			for(int i=0;i<deletedMasterGroupProps.Count;i++)
			{
				LRRGroupProperty groupProp = deletedMasterGroupProps[i] as LRRGroupProperty;
				groupPropsDeleted.Remove(groupProp);
				LRRModel.MasterGroupPropertiesObj.Remove(groupProp);
			}
			_app.DBManagerObj.ExecuteBatchInsert(groupPropsInserted);
			_app.DBManagerObj.ExecuteBatchDelete(groupPropsDeleted);
			LRRModel.MasterGroupPropertiesObj.RefreshCollection(); 
			#endregion

			#region Old Code Commented By Vihar.

			/*LRRLookUpProperties lookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(lookUpProperties,false);
			lookUpProperties.ItemFilter = "PropertyID = '" + propertyID + "'";

			//Update MasterGrouped Properties
			LRRGroupProperties masterGroupProperties = new LRRGroupProperties();
			_app.DBManagerObj.PopulateCollection(masterGroupProperties,false);
			masterGroupProperties.ItemFilter = "PropertyID = '" + propertyID + "'";

			ArrayList arrMasterGroupedProps = new ArrayList();
			ArrayList arrMasterGroupedPropsDel = new ArrayList();
			
			
			foreach(LRRGroupProperty masterGroupProperty in masterGroupProperties)
			{
				bool flag = false;
				//Updates in LookUpProperty
				foreach(LRRLookUpProperty lookUpProperty in	lookUpProperties)
				{
					if(masterGroupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
					{
						masterGroupProperty.AttributeName = lookUpProperty.Name;
						masterGroupProperty.AttributeDescription = lookUpProperty.Description;
						flag = true;
						break;
					}
				}
				
				//Deletes in LookUpProperty
				if(!flag)
				{
					if(!arrMasterGroupedPropsDel.Contains(masterGroupProperty))
						arrMasterGroupedPropsDel.Add(masterGroupProperty);
				}
			}
			
			//Inserts in LookUpProperty

			LRRGroupProperty grpProp1 = new LRRGroupProperty();
			foreach(LRRLookUpProperty lookUpProperty in lookUpProperties)
			{
				bool flag = false;
				string grpPropMasterPropertyID = "";
				
				foreach(LRRGroupProperty groupProperty in masterGroupProperties)
				{
					if(groupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
					{
						flag =true;
						break;
					}
					grpPropMasterPropertyID = groupProperty.MasterPropertyID;
					grpProp1 = groupProperty;
				}
				if(!flag)
				{
					LRRGroupProperties grpProps = masterGroupProperties.Clone() as LRRGroupProperties;
					grpProps.ItemFilter = "LookUpPropertiesID = " + grpProp1.LookUpPropertiesID;
					
					foreach(LRRGroupProperty grp in grpProps)
					{
						LRRGroupProperty grpProp = new LRRGroupProperty();
						grpProp.MasterPropertyID = grp.MasterPropertyID;//grpPropMasterPropertyID;

						grpProp.AttributeName = lookUpProperty.Name;
						grpProp.AttributeDescription = lookUpProperty.Description;
						grpProp.PropertyID = lookUpProperty.PropertyID;
						grpProp.LookUpPropertiesID = lookUpProperty.LookUpPropertiesID;

						if(!arrMasterGroupedProps.Contains(grpProp))
							arrMasterGroupedProps.Add(grpProp);
					}
				}
			}

			
			//Remove
			for(int i=0; i< arrMasterGroupedPropsDel.Count;i++)
			{
				LRRGroupProperty masterCompGrpProp = arrMasterGroupedPropsDel[i] as LRRGroupProperty;
				masterGroupProperties.Remove(masterCompGrpProp);
			}
			
			//Insert
			for(int i=0; i< arrMasterGroupedProps.Count;i++)
			{
				LRRGroupProperty masterCompGrpProp = arrMasterGroupedProps[i] as LRRGroupProperty;
				masterGroupProperties.Add(masterCompGrpProp);
			}

			//Save
			if(masterGroupProperties.GetChanges().Count > 0)
			{
				LRRGroupProperties toSaveMasterGroupProperties = masterGroupProperties.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveMasterGroupProperties); 
			}*/
			#endregion
		}

		public void UpdateSiteComponentsLookUpProperties(string propertyID)
		{
			#region New Implementetion By Vihar.

			LRRModel.UpdateSiteComponentsLookUpProperties(propertyID,out createdSiteGroupProps,out deletedSiteGroupProps,out arrQValues);
			LRRSiteComponents lscs = LRRModel.SiteComponentsObj.FilterSiteComponentsByPropertyType(propertyID);
			for(int i=0;i<createdSiteGroupProps.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGroupProp = createdSiteGroupProps[i] as LRRSiteComponentGroupProperty;
				siteCompGroupPropsInserted.Add(siteCompGroupProp);
				lscgp.Add(siteCompGroupProp);
				foreach(LRRSiteComponent lsc in lscs)
				{
					foreach(LRRSiteComponentProperty lscp in lsc.Properties)
					{
						lscp.GroupPpties.Add(siteCompGroupProp);
					}
				}
			}
			for(int i=0;i<deletedSiteGroupProps.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGroupProp = deletedSiteGroupProps[i] as LRRSiteComponentGroupProperty;
				siteCompGroupPropsDeleted.Remove(siteCompGroupProp);
				lscgp.Remove(siteCompGroupProp);
			}
			for(int i=0;i<arrQValues.Count;i++)
			{	
				LRRSiteGroupPropertyQualifierValue qValue =  arrQValues[i] as LRRSiteGroupPropertyQualifierValue;
				createdQValues.Add(qValue);
				qualiferValues.Add(qValue);  
			}
			_app.DBManagerObj.ExecuteBatchInsert(siteCompGroupPropsInserted);
			_app.DBManagerObj.ExecuteBatchDelete(siteCompGroupPropsDeleted);
			_app.DBManagerObj.ExecuteBatchInsert(createdQValues);  
			#endregion

			#region Old Code Commented By Vihar.

			/*LRRLookUpProperties lookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(lookUpProperties,false);
			lookUpProperties.ItemFilter = "PropertyID = '" + propertyID + "'";

			//Update Site Component grouped Properties
			LRRSiteComponentGroupProperties groupProperties = new LRRSiteComponentGroupProperties();
			_app.DBManagerObj.PopulateCollection(groupProperties,false);
			groupProperties.ItemFilter = "PropertyID = '" + propertyID + "'";

			ArrayList arrGroupedProps = new ArrayList();
			ArrayList arrGroupedPropsDel = new ArrayList();

			foreach(LRRSiteComponentGroupProperty groupProperty in groupProperties)
			{
				bool flag = false;
				//Updates in LookUpProperty
				foreach(LRRLookUpProperty lookUpProperty in	lookUpProperties)
				{
					if(groupProperty.PropertyID == lookUpProperty.PropertyID && groupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
					{
						groupProperty.AttributeName = lookUpProperty.Name;
						groupProperty.AttributeDescription = lookUpProperty.Description;
						flag = true;
						break;
					}
				}

				//Deletes in LookUpProperty
				if(!flag)
				{
					if(!arrGroupedPropsDel.Contains(groupProperty))
						arrGroupedPropsDel.Add(groupProperty);
				}
			}

			//Inserts in LookUpProperty

			LRRSiteComponentGroupProperty grpProp1 = new LRRSiteComponentGroupProperty();
			foreach(LRRLookUpProperty lookUpProperty in lookUpProperties)
			{
				bool flag = false;
				
				foreach(LRRSiteComponentGroupProperty groupProperty in groupProperties)
				{
					if(groupProperty.LookUpPropertiesID == lookUpProperty.LookUpPropertiesID)
					{
						flag =true;
						break;
					}
					grpProp1 = groupProperty;
				}
				if(!flag)
				{
					LRRSiteComponentGroupProperties grpProps = groupProperties.Clone() as LRRSiteComponentGroupProperties;
					grpProps.ItemFilter = "LookUpPropertiesID = " + grpProp1.LookUpPropertiesID;
					
					foreach(LRRSiteComponentGroupProperty grp in grpProps)
					{
						LRRSiteComponentGroupProperty grpProp = new LRRSiteComponentGroupProperty();
						grpProp.SiteComponentPropID = grp.SiteComponentPropID;

						grpProp.AttributeName = lookUpProperty.Name;
						grpProp.AttributeDescription = lookUpProperty.Description;
						grpProp.PropertyID = lookUpProperty.PropertyID;
						grpProp.LookUpPropertiesID = lookUpProperty.LookUpPropertiesID;

						if(!arrGroupedProps.Contains(grpProp))
							arrGroupedProps.Add(grpProp);
					}
				}
			}

			
			//Remove
			for(int i=0; i< arrGroupedPropsDel.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGrpProp = arrGroupedPropsDel[i] as LRRSiteComponentGroupProperty;
				groupProperties.Remove(siteCompGrpProp);
			}
			
			//Insert
			for(int i=0; i< arrGroupedProps.Count;i++)
			{
				LRRSiteComponentGroupProperty siteCompGrpProp = arrGroupedProps[i] as LRRSiteComponentGroupProperty;
				groupProperties.Add(siteCompGrpProp);
			}

			//Save
			if(groupProperties.GetChanges().Count > 0)
			{
				LRRSiteComponentGroupProperties toSaveSiteComponentGroupProperties = groupProperties.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveSiteComponentGroupProperties); 
			}*/
			#endregion
		}
	}
}
