using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Utils.MessageLogger;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.ComponentModel;
using Symcon.Globals.Enums;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;
using System.Collections.Generic;


//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.


namespace Symcon.LightRidge.PEAdvisor
{
    /// <summary>
    /// Summary description for MasterPlantItems.
    /// </summary>
    public class MasterPlantItems : System.Windows.Forms.Form, ILRRUIContainer
    {

	//	 private  System.Windows.Forms.ToolTip toolTip1;
        public MasterPlantItems()
        {
				 
            InitializeComponent();
			//	  toolTip1 = new System.Windows.Forms.ToolTip();
            //Get the App Object
            _app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            InitDataSource();
            //Set the look and feel for the grid...
            SyncGridUtilities.InitializeMasterGridLookAndFeel(gridMasterPlantItems);
            //InitializeForm();
           // _gridExcelFormatter.WireGrid(gridMasterPlantItems);
            //chkDuplicate.ChkDuplicate(gridMasterPlantItems,"ComponentName");
            chkDuplicate.ChkDuplicate(gridMasterPlantItems, "ID", "PropID", "ComponentName", "Name", "ComponentID");


            //InitializeForm();

            this.barItemSave.Click += new EventHandler(barItemSave_Click);
            this.barItemRefresh.Click += new EventHandler(barItemRefresh_Click);

        }
        public void InitDataSource()
        {
            //			if(_masterGroupedProperties != null)
            //				_masterGroupedProperties.Clear();
            _lrrMasterProperties = LRRModel.MasterComponentPropertiesObj;
            _lrrMasterComponents = LRRModel.Model;
            _lrrPropertyTypes = LRRModel.ChildModel.PropertyTypes;
            _lrrLookUpProperties = LRRModel.LookUpProperties;
            //_masterGroupedProperties = new LRRGroupProperties();
            _masterGroupedProperties = LRRModel.MasterGroupPropertiesObj;
            //_app.DBManagerObj.PopulateCollection(_masterGroupedProperties,false);
        }
        public void InitializeForm()
        {
            try
            {
                _suspendEvents = true;

                gridMasterPlantItems.TableDescriptor.Relations.Clear();
                gridMasterPlantItems.DataSource = null;


                //Initialize the columns for the grid...

                SyncGridUtilities.InitializeGridColumns(gridMasterPlantItems, gridMasterPlantItems.TableDescriptor, _lrrMasterComponents.ItemType, null);

                gridMasterPlantItems.Engine.SourceListSet.Add("ParentTable", _lrrMasterComponents);

                gridMasterPlantItems.DataSource = _lrrMasterComponents;

                gridMasterPlantItems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_MASTER_PLANT_ITEMS") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");


                //Properties for the site component
                GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
                grdCompProps.ChildTableName = "Properties";
                grdCompProps.RelationKeys.Add("ID", "ComponentID");
                grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
                grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.CornflowerBlue;
                grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
                grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");  /*"Attributes: {RecordCount} Items";*/
                gridMasterPlantItems.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
                grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Lavender;
                gridMasterPlantItems.TableDescriptor.Relations.Add(grdCompProps);
                gridMasterPlantItems.NestedTableGroupOptions.ShowFilterBar = true;
                gridMasterPlantItems.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
                gridMasterPlantItems.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
                gridMasterPlantItems.Engine.SourceListSet.Add("Properties", _lrrMasterProperties);
                SyncGridUtilities.InitializeGridColumns(gridMasterPlantItems, grdCompProps.ChildTableDescriptor, _lrrMasterProperties.ItemType, null);
                grdCompProps.ChildTableDescriptor.RecordExpanding += new RecordEventHandler(ChildTableDescriptor_RecordExpanding);

                //Properties for the site component
                GridRelationDescriptor grdGrpProps = new GridRelationDescriptor("GroupedProperties");
                grdGrpProps.ChildTableName = "GroupedProperties";
                grdGrpProps.RelationKeys.Add("PropID", "MasterPropertyID");
                grdGrpProps.RelationKind = RelationKind.RelatedMasterDetails;
                grdGrpProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.CornflowerBlue;
                grdGrpProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
                grdGrpProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_GRP_PROPERTIES") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");  /*"Grouped Properties: {RecordCount} Items";*/
                gridMasterPlantItems.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
                grdGrpProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.Lavender;
                grdCompProps.ChildTableDescriptor.Relations.Add(grdGrpProps);
                grdGrpProps.ChildTableDescriptor.AllowRemove = false;

                gridMasterPlantItems.NestedTableGroupOptions.ShowFilterBar = true;
                gridMasterPlantItems.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
                gridMasterPlantItems.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
                //grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Properties",_lrrMasterProperties);
                grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("GroupedProperties", _masterGroupedProperties);
                SyncGridUtilities.InitializeGridColumns(gridMasterPlantItems, grdGrpProps.ChildTableDescriptor, _masterGroupedProperties.ItemType, null);

                _suspendEvents = false;

                gridMasterPlantItems.TableModel.CommandStack.Enabled = true;
                gridMasterPlantItems.TableControl.Refresh();
                gridMasterPlantItems.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(gridMasterPlantItems_TableControlCurrentCellCloseDropDown);
				//	 gridMasterPlantItems.TableControlCellMouseHover +=new GridTableControlCellMouseEventHandler(gridMasterPlantItems_TableControlCellMouseHover);
					 gridMasterPlantItems.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridMasterPlantItems_QueryCellStyleInfo);
                //ACL Change
                //SyncGridUtilities.ApplyViewStyleOnGrid(gridMasterPlantItems,gridMasterPlantItems.TableDescriptor);


                string[,] arry = new string[,] { { "Description", "255" } };
                Validations obj = new Validations(gridMasterPlantItems, arry);

            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(MasterPlantItems), "InitializeForm:" + ex.Message, Logger.Level.Debug);
                return;
            }
        }

		 void gridMasterPlantItems_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		 {
			  try
			   {
			       if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		 }

	 

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MasterPlantItems));
            this.barItemRefresh = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.pnlMasterItemGrid = new System.Windows.Forms.Panel();
            this.gridMasterPlantItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlMasterItemGrid.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridMasterPlantItems)).BeginInit();
            this.SuspendLayout();
			  
			 // this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            // 
            // barItemRefresh
            // 
            this.barItemRefresh.CategoryIndex = -1;
            this.barItemRefresh.ID = "Refresh";
            this.barItemRefresh.Text = "Refresh";
            // 
            // barItemSave
            // 
            this.barItemSave.CategoryIndex = -1;
            this.barItemSave.ID = "Save";
            this.barItemSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemSave.Text = "Save";
            // 
            // pnlMasterItemGrid
            // 
            this.pnlMasterItemGrid.Controls.Add(this.gridMasterPlantItems);
            this.pnlMasterItemGrid.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlMasterItemGrid.Location = new System.Drawing.Point(0, 0);
            this.pnlMasterItemGrid.Name = "pnlMasterItemGrid";
            this.pnlMasterItemGrid.Size = new System.Drawing.Size(528, 406);
            this.pnlMasterItemGrid.TabIndex = 1;
            // 
            // gridMasterPlantItems
            // 
            this.gridMasterPlantItems.BackColor = System.Drawing.SystemColors.Window;
            this.gridMasterPlantItems.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridMasterPlantItems.Location = new System.Drawing.Point(0, 0);
            this.gridMasterPlantItems.Name = "gridMasterPlantItems";
            this.gridMasterPlantItems.Size = new System.Drawing.Size(528, 406);
            this.gridMasterPlantItems.TabIndex = 17;
            this.gridMasterPlantItems.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
            this.gridMasterPlantItems.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridMasterPlantItems.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridMasterPlantItems.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridMasterPlantItems.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridMasterPlantItems.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridMasterPlantItems.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
            this.gridMasterPlantItems.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            this.gridMasterPlantItems.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
            this.gridMasterPlantItems.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
            this.gridMasterPlantItems.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
            this.gridMasterPlantItems.Text = "gridMasterPlantItems";
            this.gridMasterPlantItems.ThemesEnabled = false;
            this.gridMasterPlantItems.TopLevelGroupOptions.CaptionText = "Master Plant Items: {RecordCount} Items";
            this.gridMasterPlantItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowFilterBar = true;
            this.gridMasterPlantItems.VersionInfo = "3.301.0.0";
            this.gridMasterPlantItems.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridMasterPlantItems_RecordDeleting);
            this.gridMasterPlantItems.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridMasterPlantItems_TableControlCellClick);
            this.gridMasterPlantItems.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridMasterPlantItems_TableControlCurrentCellShowingDropDown);
            this.gridMasterPlantItems.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridMasterPlantItems_CurrentRecordContextChange);
            this.gridMasterPlantItems.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
            this.gridMasterPlantItems.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
            this.gridMasterPlantItems.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
            this.gridMasterPlantItems.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;

            // 
            // MasterPlantItems
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(528, 406);
            this.Controls.Add(this.pnlMasterItemGrid);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "MasterPlantItems";
            this.Tag = "SID_MASTER_PLANT_ITEMS";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.MasterPlantItems_Load);
            this.pnlMasterItemGrid.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridMasterPlantItems)).EndInit();
            this.ResumeLayout(false);

        }

        #endregion

        #region Fields

        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSave;
        private System.Windows.Forms.Panel pnlMasterItemGrid;
        private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridMasterPlantItems;
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        private LRRComponentTypes _lrrComponentTypes = new LRRComponentTypes();
        private LRRMasterComponents _lrrMasterComponents = new LRRMasterComponents();
        private DuplicateValidation chkDuplicate = new DuplicateValidation();
        private LRRMasterProperties _lrrMasterProperties = new LRRMasterProperties();
        private bool _suspendEvents = false;
        private LRRGroupProperties _masterGroupedProperties;
        private LRRLookUpProperties _lrrLookUpProperties = new LRRLookUpProperties();
        private LRRPropertyTypes _lrrPropertyTypes = null; //--Modified by Nidhig on 26th Jan to get the property type object for grouped properties impl.
        private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemRefresh; //Data Source for the Master Components
        private LRRApp _app; //Instance of the app object
        private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
        //private LRRUIManager lrrUI = new LRRUIManager();
        private bool initializing = false;
        private bool _isPropertyTypeChanged = false;
        private bool _isAggExists = false;
        private bool _isNewPropTypeSimple = false; 
        private bool _isDeletePress = false;
        private bool _isRecordeDel = false;
        private bool _isCascadeChanges = false;
        private bool _isUOMTypeChanged = false;
        private bool _isModeChange = false;
        private TabControl _parentTabControl;
        private TabPage _parentTabPage;
        #endregion

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void barItemSave_Click(object sender, EventArgs e)
        {
            Save();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void MasterPlantItems_Load(object sender, System.EventArgs e)
        {
            /*int colCount =  gridMasterPlantItems.TableDescriptor.Columns.Count;
            int colWidth =  this.Width/colCount - SystemInformation.VerticalScrollBarWidth;
            foreach(GridColumnDescriptor gc in this.gridMasterPlantItems.TableDescriptor.Columns)
            {
                gc.Width = colWidth;
            }*/
            InitializeForm();
            _lrrMasterProperties.ItemAdded += new EventHandler(_lrrMasterProperties_ItemAdded);
            _gridExcelFormatter.WireGrid(gridMasterPlantItems);
        }

        private void barItemRefresh_Click(object sender, EventArgs e)
        {
            this.gridMasterPlantItems.TableModel.CommandStack.Undo();
        }
        #region ILRRUIContainer Members

        public new void Refresh()
        {
            InitDataSource();
            InitializeForm();
        }

        private bool IsMasterPropertiesDuplicate()
        {

            LRRMasterProperties modifiedMasterProperties = _lrrMasterProperties.Clone() as LRRMasterProperties;

            //Check if duplicate exists in Master Properties grid
            if (modifiedMasterProperties.GetChanges().Count != 0)
            {
                LRRMasterProperties changes = modifiedMasterProperties.GetChanges();
                int nLRRDuplicate = 0;
                string[] name = new string[changes.Count];
                string[] AddId = new string[changes.Count];
                string[] PropId = new string[changes.Count];
                string sfilter;
                foreach (LRRMasterProperty duplicate in changes)
                {
                    if (duplicate.ObjectState != DBOperation.DELETE)
                    {
                        name[nLRRDuplicate] = duplicate.Name;
                        AddId[nLRRDuplicate] = duplicate.ComponentID;
                        PropId[nLRRDuplicate] = duplicate.PropID;
                        nLRRDuplicate++;
                        if (gridMasterPlantItems.CurrencyManager.Count > 0)
                        {
                            for (int j = 0; j < nLRRDuplicate; j++)
                            {
                                sfilter = "Name = '" + name[j] + "' and ComponentID = '" + AddId[j] + "' and PropID != '" + PropId[j] + "' ";
                                modifiedMasterProperties.ItemFilter = sfilter;
                                if (modifiedMasterProperties.Count > 0)
                                {
                                    MessageBox.Show("Duplicate attribute name - '" + name[j] + "' exists. Can not continue with save operation!");
                                    modifiedMasterProperties = null;
                                    return true;
                                }
                            }

                        }
                    }
                }
            }

            modifiedMasterProperties = null;
            return false;

        }
        public void Save()
        {
            this.gridMasterPlantItems.Table.EndEdit();
            if (this.gridMasterPlantItems.GetTable("Properties") != null)
                this.gridMasterPlantItems.GetTable("Properties").EndEdit();
            gridMasterPlantItems.TableModel.ConfirmPendingChanges();
            string sPropertyID = "";
            bool isSaved = false;
            bool blnMasterPropertyModified = false;
            bool blnMasterPropertyAddRemove = false;
            LRRFormulas formulasToSave = new LRRFormulas();
            ArrayList masterPropIDList = new ArrayList();
            if (_lrrMasterComponents.GetChanges().Count != 0)
            {
                LRRMasterComponents changes = _lrrMasterComponents.GetChanges();
                int changesCount = _lrrMasterComponents.GetChanges().Count;
                for (int i = 0; i < changesCount; i++)
                {
                    LRRMasterComponent lmc = changes[i] as LRRMasterComponent;
                    if (lmc.ObjectState != DBOperation.DELETE)
                    {
                        if (lmc.ComponentName == null || lmc.ComponentName.Trim() == "")
                        {

                            LRRMessagBox.ShowMessage("SID_MASTERPLANTITEM_NULL", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }
                        if (lmc.ComponentID == null)
                        {
                            string[] s = new string[1];
                            s[0] = lmc.ComponentName;
                            LRRMessagBox.ShowMessage("SID_MASTER_NULL", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }
                    }
                }
                _app.DBManagerObj.CommitCollection(changes);
                isSaved = true;
            }
            if (_lrrMasterProperties.GetChanges().Count != 0)
            {
                LRRMasterProperties changes = _lrrMasterProperties.GetChanges();
                foreach (LRRMasterProperty objMasterProp in changes)
                {
                    if (objMasterProp.PropID != "" && objMasterProp.PropID != null)
                    {
                        if (objMasterProp.ObjectState == DBOperation.DELETE || objMasterProp.ObjectState == DBOperation.UPDATE)
                        {
                            masterPropIDList.Add(objMasterProp.PropID);
                        }
                    }
                }
                int changesCount = _lrrMasterProperties.GetChanges().Count;
                for (int i = 0; i < changesCount; i++)
                {
                    LRRMasterProperty lmc = changes[i] as LRRMasterProperty;
                    if (lmc.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE && _isPropertyTypeChanged)
                    {
                        LRRSiteComponentProperties siteCompProps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(lmc.PropID);
                        foreach (LRRSiteComponentProperty lscp in siteCompProps)
                        {
                            if (lscp.Type == "1")
                            {
                                LRRSiteComponentPropertyValues toDeletePropValues = new LRRSiteComponentPropertyValues();
                                List<IPropertyValue> propertyValues = LRRModel.PropertyValuesObj.GetPropertyValuesFromPropID(lscp.ID);
                                foreach (LRRSiteComponentPropertyValue propValue in propertyValues)
                                {
                                    toDeletePropValues.Add(propValue);
                                    LRRModel.PropertyValuesObj.Remove(propValue);
                                }
                                _app.DBManagerObj.ExecuteBatchDelete(propertyValues);
                            }
                            else
                            {
                                LRRSiteComponentGroupProperties toDeleteSiteCompGropProp = new LRRSiteComponentGroupProperties();
                                LRRSiteGroupPropertyQualifierValues toDeleteSiteCompGrpPropValues = new LRRSiteGroupPropertyQualifierValues();
                                LRRSiteComponentGroupProperties siteCompGrpProps = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromSiteCompPropID(lscp.ID);
                                foreach (LRRSiteComponentGroupProperty siteCompGrpProp in siteCompGrpProps)
                                {
                                    LRRSiteGroupPropertyQualifierValues grpPropValues = siteCompGrpProp.GroupPptiesQualifierValues;
                                    foreach (LRRSiteGroupPropertyQualifierValue grpPropValue in grpPropValues)
                                    {
                                        toDeleteSiteCompGrpPropValues.Add(grpPropValue);
                                    }
                                    toDeleteSiteCompGropProp.Add(siteCompGrpProp);
                                }
                                foreach (LRRSiteGroupPropertyQualifierValue grpPropValue in toDeleteSiteCompGrpPropValues)
                                {
                                    LRRModel.SiteGroupPropertyQualifierValuesObj.Remove(grpPropValue);
                                }
                                foreach (LRRSiteComponentGroupProperty siteCompGrpProp in toDeleteSiteCompGropProp)
                                {
                                    LRRModel.SiteComponentGroupPropertiesObj.Remove(siteCompGrpProp);
                                    lscp.GroupPpties.Remove(siteCompGrpProp);
                                }
                                _app.DBManagerObj.ExecuteBatchDelete(toDeleteSiteCompGrpPropValues);
                                _app.DBManagerObj.ExecuteBatchDelete(toDeleteSiteCompGropProp);
                                LRRModel.SiteComponentGroupPropertiesObj.RefreshCollection();
                                LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                            }
                            lscp.Type = lmc.Type; 
                        }
                        if (!_isNewPropTypeSimple)
                        {
                            SiteComponentEntry siteCompEntry = new SiteComponentEntry();
                            foreach (LRRSiteComponentProperty siteCompProp in siteCompProps)
                            {
                                siteCompEntry.ConvertMasterGrpPropertiesToSiteGroupProperties(siteCompProp,true);
                                siteCompProp.UIUomID = "";
                                siteCompProp.UOMTypeID = ""; 
                            }
                            _app.DBManagerObj.ExecuteBatchUpdate(siteCompProps);
                            siteCompProps.RefreshCollection();
                        }
                        else
                        {
                            foreach (LRRSiteComponentProperty lscp in siteCompProps)
                            {
                                CreatePropertyValues(lmc.ModeID, lscp.ID);
                            }
                        }
                        _app.DBManagerObj.ExecuteBatchUpdate(siteCompProps);
                        siteCompProps.RefreshCollection();
                    }
                    if (lmc.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE && _isUOMTypeChanged)
                    {
                        UpdateUOM(lmc.PropID);
                    }
                    if (lmc.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE && _isModeChange)
                    {
                        LRRSiteComponentProperties siteCompProps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(lmc.PropID);
                        foreach (LRRSiteComponentProperty siteCompProp in siteCompProps)
                        {
                            CreatePropertyValues(siteCompProp.ModeID, siteCompProp.ID);
                        }
                        _app.DBManagerObj.ExecuteBatchUpdate(siteCompProps);
                    }
                    if ((lmc.Name == null || lmc.Name.Trim() == "") && lmc.ObjectState != DBOperation.DELETE)
                    {
                        LRRMessagBox.ShowMessage("SID_ATTRIBUTE_NULL", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }

                    if (lmc.ObjectState == DBOperation.UPDATE)
                        blnMasterPropertyModified = true;
                    else
                        blnMasterPropertyAddRemove = true;

                    if (lmc.ObjectState != DBOperation.DELETE && lmc.Type == "1")
                    {
                        if (lmc.MasterPropertyUOMTypeID == "" || lmc.MasterPropertyUOMTypeID == null)
                        {
                            string[] s = new string[1];
                            s[0] = lmc.Name;
                            LRRMessagBox.ShowMessage("SID_UOMNUL_MASTER", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Warning);
                            return;
                        }
                    }
                    else if (lmc.ObjectState == DBOperation.DELETE)
                    {
                        CascadeDeleteChanges(lmc.ComponentID, lmc.PropID);
                    }
                }

                foreach (LRRMasterProperty lmp in changes)
                {
                    if (lmp.IndexRuleFormulaObj != null)
                    {
                        if (lmp.IndexRuleFormulaObj.ObjectState != DBOperation.DELETE)
                        {
                            formulasToSave.Add(lmp.IndexRuleFormulaObj); 
                        }
                    }
                }

                CascadeMasterPropertiesChanges(changes);
                _app.DBManagerObj.CommitCollection(formulasToSave);
                _app.DBManagerObj.CommitCollection(changes);
                isSaved = true;
            }
            if (_masterGroupedProperties.GetChanges().Count != 0)
            {
                LRRGroupProperties changes = _masterGroupedProperties.GetChanges();
                foreach (LRRGroupProperty objProp in changes)
                {
                    if (objProp.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                    {
                        if (sPropertyID == "")
                            sPropertyID = "'" + objProp.MasterPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "'";
                        else
                            sPropertyID = sPropertyID + ",'" + objProp.MasterPropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "'";

                        if (objProp.ObjectState != DBOperation.DELETE)
                        {
                            if (objProp.AttributeName == "")
                            {
                                LRRMessagBox.ShowMessage("SID_ATTRIBUTENAME_BLANK_ERROR", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                return;
                            }
                        }
                    }
                }
                _app.DBManagerObj.CommitCollection(changes);
                isSaved = true;
            }

            DialogResult k = DialogResult.None;
            if (blnMasterPropertyModified)
            {
                ArrayList toUpdateAggPropList = new ArrayList();
                for (int i = 0; i < masterPropIDList.Count; i++)
                {
                    string masterPropID = masterPropIDList[i].ToString();
                    LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);
                    LRRAggregates aggreGates = LRRModel.AggregatesObj.GetAggregatesByMasterComponentID(lmp.ComponentID);
                    if (aggreGates.Count > 0)
                    {
                        foreach (LRRAggregate agg in aggreGates)
                        {
                            LRRAggregateEquipments aggEquips = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(agg.AggregateID);
                            foreach (LRRAggregateEquipment aggEquip in aggEquips)
                            {
                                LRRSiteComponent siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(aggEquip.EquipmentID);
                                if (siteComp != null)
                                {
                                    foreach (LRRSiteComponentProperty lscp in siteComp.Properties)
                                    {
                                        if (lscp.PropertyID == lmp.PropID)
                                        {
                                            if (!toUpdateAggPropList.Contains(lmp.PropID))
                                                toUpdateAggPropList.Add(lmp.PropID);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                if (toUpdateAggPropList.Count > 0)
                {
                    k = LRRMessagBox.ShowMessage("SID_CASCADE_CHANGES_WITHOUT_RESTART", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                    if (k == DialogResult.Yes)
                    {
                        AggregateUtility objAggregateUtility = new AggregateUtility();
                        objAggregateUtility.UpdateAggregateProperties(toUpdateAggPropList);
                    }
                    blnMasterPropertyModified = false;
                }
            }
            if (blnMasterPropertyAddRemove)
            {
                for (int i = 0; i < masterPropIDList.Count; i++)
                {
                    string masterPropID = masterPropIDList[i].ToString();
                    LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);
                    LRRAggregates aggreGates = LRRModel.AggregatesObj.GetAggregatesByMasterComponentID(lmp.ComponentID);
                    if (aggreGates.Count > 0)
                    {
                        AggregateUtility objAggregateUtility = new AggregateUtility();
                        objAggregateUtility.UpdateAggregateProperties(masterPropIDList);
                    }
                }
                blnMasterPropertyAddRemove = false;
            }

            #region Commented By Vihar. Logic taken care above.
            /*if (_isPropertyTypeChanged)
            {
                if (k == DialogResult.None)
                    k = LRRMessagBox.ShowMessage("SID_CASCADE_CHANGES", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);

                if (k == DialogResult.Yes)
                {
                    GroupedPropertiesUtility objCascadeChanges = new GroupedPropertiesUtility();
                    if (!_isCascadeChanges)
                    {
                        objCascadeChanges.UpdateSiteComponentsLookUpProperties(sPropertyID);
                    }

                    AggregateUtility objAggregateUtility = new AggregateUtility();
                    objAggregateUtility.UpdateAggregateProperties(masterPropIDList);
                }
                _isPropertyTypeChanged = false;
            }*/
            #endregion

            if (!isSaved)
            {
                LRRMessagBox.ShowMessage("SID_NODATASAVED", true);
            }
            else
            {
                _isNewPropTypeSimple = false;
                _isPropertyTypeChanged = false;
                _isModeChange = false;
                _isUOMTypeChanged = false;
                _lrrComponentTypes.RefreshCollection();
                _lrrMasterComponents.RefreshCollection();
                _lrrLookUpProperties.RefreshCollection();
                _masterGroupedProperties.RefreshCollection();
                _lrrMasterProperties.RefreshCollection();
                LRRMessagBox.ShowMessage("SID_SAVEDINFO", true);
            }
        }

        private void CascadeMasterPropertiesChanges(LRRMasterProperties masterPropChanges)
        {
            foreach (LRRMasterProperty masterProp in masterPropChanges)
            {
                if (masterProp.ArrListUpdatedColNames.Contains("Name"))
                {
                    LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(masterProp.PropID);
                    if (lscps != null)
                    {
                        foreach (LRRSiteComponentProperty lscp in lscps)
                        {
                            lscp.Name = masterProp.Name;
                            LRRHistPropCompPropMappings histPropSiteCompMaps = LRRModel.HistPropMaps.FilterBySiteCompPropID(lscp.ID);
                            if (histPropSiteCompMaps != null)
                            {
                                foreach (LRRHistPropCompPropMapping histPropSiteCompMap in histPropSiteCompMaps)
                                {
                                    histPropSiteCompMap.ComponentPropertyName = lscp.Name;
                                }
                            }
                        }
                    }
                    LRRAggregateProperties aggProps = LRRModel.AggregatePropertiesObj.FilterPropertiesByMasterProperty(masterProp.PropID);
                    if (aggProps != null)
                    {
                        foreach (LRRAggregateProperty aggProp in aggProps)
                        {
                            aggProp.Name = masterProp.Name;
                        }
                    }
                }
            }
            if (LRRModel.SiteComponentPropertiesObj.GetChanges().Count > 0)
            {
                _app.DBManagerObj.CommitCollection(LRRModel.SiteComponentPropertiesObj.GetChanges());
                LRRModel.SiteComponentPropertiesObj.RefreshCollection();
            }
            if (LRRModel.AggregatePropertiesObj.GetChanges().Count > 0)
            {
                _app.DBManagerObj.CommitCollection(LRRModel.AggregatePropertiesObj.GetChanges());
                LRRModel.AggregatePropertiesObj.RefreshCollection();
            }
            if (LRRModel.HistPropMaps.GetChanges().Count > 0)
            {
                _app.DBManagerObj.CommitCollection(LRRModel.HistPropMaps.GetChanges());
                LRRModel.HistPropMaps.RefreshCollection();
            }
        }

        public void Export()
        {
            if (gridMasterPlantItems.TableControl.CurrentCell.IsActive)
            {
                ExportToExcel excelExpForm = new ExportToExcel(this.gridMasterPlantItems);
                excelExpForm.ShowDialog(this);
            }
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
        }

        public bool SupportsMasterPropertiesCopy()
        {
            return false;
        }

        #endregion

        #region ILRRUIContainer Members

        public void CopyMasterProperties()
        {
            // TODO:  Add MasterPlantItems.CopyMasterProperties implementation
        }

        public void Paste()
        {
            // TODO:  Add MasterPlantItems.Paste implementation
        }

        public void Copy()
        {
            // TODO:  Add MasterPlantItems.Copy implementation
        }


        public void Print()
        {
            //Print Implementation
            if (gridMasterPlantItems.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridMasterPlantItems, false);
            }

        }

        public void Delete()
        {
            //Critical
            //Please do not enable the delete for this screen.
            //			SyncGridUtilities.DeleteRecords(gridMasterPlantItems);   
        }

        public void ArrangeColumns()
        {
            // TODO:  Add MasterPlantItems.ArrangeColumns implementation
        }

        public void ClearFilter()
        {
            // TODO:  Add MasterPlantItems.ClearFilter implementation
            //this.gridMasterPlantItems.TableDescriptor.RecordFilters.Clear();

            SyncGridUtilities.ClearFilter(gridMasterPlantItems);
            //Refresh(); 
        }

        public void ImportToExcel()
        {
            SyncGridUtilities.ImportFromExcel(this.gridMasterPlantItems);
        }

        public void RightLevel()
        {

        }
        public void LeftLevel()
        {

        }
        public void UpLevel()
        {

        }
        public void DownLevel()
        {

        }


        public bool SupportsCopy()
        {
            // TODO:  Add MasterPlantItems.SupportsCopy implementation
            return true;
        }

        public bool SupportsPaste()
        {
            // TODO:  Add MasterPlantItems.SupportsPaste implementation
            return true;
        }

        public bool SupportsExport()
        {
            // TODO:  Add MasterPlantItems.SupportsExport implementation
            return true;
        }

        public bool SupportsSave()
        {
            // TODO:  Add MasterPlantItems.SupportsSave implementation
            return true;
        }

        public bool SupportsRefresh()
        {
            // TODO:  Add MasterPlantItems.SupportsRefresh implementation
            return true;
        }

        public bool SupportsDelete()
        {
            // TODO:  Add MasterPlantItems.SupportsDelete implementation
            //Critical
            //Please do not enable the delete for this screen.
            return false;
        }

        public bool SupportsPrint()
        {
            // TODO:  Add MasterPlantItems.SupportsPrint implementation
            return true;
        }

        public bool SupportsArrangeColumns()
        {
            // TODO:  Add MasterPlantItems.SupportsArrangeColumns implementation
            return false;
        }

        public bool SupportsClearFilter()
        {
            // TODO:  Add MasterPlantItems.SupportsClearFilter implementation
            return true;
        }
        public bool SupportsInsertNewRows()
        {
            // TODO:  Add MasterProperties.SupportsClearFilter implementation
            return true;
        }

        public bool SupportsSelectionPaste()
        {
            return true;
        }

        public bool SupportsLevel()
        {
            return false;
        }

        public void SelectionPaste()
        {
            SyncGridUtilities.PasteSelection(gridMasterPlantItems);
        }

        public void InsertNewRows()
        {
            InsertNewRowsForm insNewRows = new InsertNewRowsForm();
            DialogResult dlgResult = insNewRows.ShowDialog(this);
            int iNumofRows = insNewRows.iNewRows;
            if (dlgResult == DialogResult.OK)
            {
                SyncGridUtilities.InsertNewRows(gridMasterPlantItems, iNumofRows);
            }
            else
            {
                return;
            }

        }

        public bool SupportsImportToExcel()
        {
            return true;
        }



        public TabControl ParentTabControl
        {
            set
            {
                _parentTabControl = value;
            }
            get { return _parentTabControl; }
        }

        public TabPage ParentTabPage
        {
            set
            {
                _parentTabPage = value;
            }
            get
            {
                return _parentTabPage;
            }
        }


        #endregion

        private void _lrrMasterProperties_ItemAdded(object sender, EventArgs e)
        {
            LRRMasterProperty lp = sender as LRRMasterProperty;
            LRRPropertyTypes types = (LRRPropertyTypes)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRPropertyTypes));
            string getDefaultValueforType = "";

            foreach (LRRPropertyType lpt in types)
            {
                if (lpt.IsDefault)
                    getDefaultValueforType = lpt.ID;
            }
            if (getDefaultValueforType != "")
                lp.Type = getDefaultValueforType;
        }

        private void gridMasterPlantItems_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
        {
            if (e.Action == CurrentRecordAction.EnterRecordComplete)
            {
                if (gridMasterPlantItems.TableControl.Table.CurrentRecord == null)
                {
                    Element eCurrentElement = gridMasterPlantItems.TableControl.Table.CurrentElement;
                    GridNestedTable gnt = eCurrentElement as GridNestedTable;
                    GridNestedTable gnt1 = gnt;
                    GridTableDescriptor gtd = null;
                    GridTableModel tableModel = new GridTableModel();
                    while (gnt1 != null && gnt1.ChildTable != null)
                    {
                        gnt = gnt1;
                        gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                        gtd = gnt.ParentTable.ParentTableDescriptor;
                    }

                    string sType = gnt.ParentRecord.GetValue("Type") == null ? "" : gnt.ParentRecord.GetValue("Type").ToString();

                    GridChildTable childTable = gnt.ChildTable as GridChildTable;
                    if (childTable.Name.ToString() == "Properties")
                    {
                        if (e.Table.CurrentRecord != null)
                        {
                            LRRMasterProperty lmp = e.Table.CurrentRecord.GetData() as LRRMasterProperty;
                            if (lmp != null)
                            {
                                LRRFormulaDataStore.SourceCollectionName = typeof(LRRMasterProperty).ToString();
                                LRRFormulaDataStore.SourceObjectID = lmp.PropID;
                                LRRFormulaDataStore.SourcePropertyID = lmp.PropID;
                            }
                        }
                    }
                    if (sType.Equals("1"))
                    {
                        childTable.ParentTableDescriptor.AllowEdit = false;
                        childTable.ParentTableDescriptor.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
                    }
                    if (sType.Equals("2"))
                    {
                        childTable.ParentTableDescriptor.AllowEdit = true;
                        childTable.ParentTableDescriptor.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;

                        if (e.Record.Kind == DisplayElementKind.AddNewRecord)
                        {
                            LRRGroupProperty lrrGroupProperty = new LRRGroupProperty();


                            if (gnt.ParentRecord.GetValue("PropID") != null)
                                lrrGroupProperty.MasterPropertyID = gnt.ParentRecord.GetRecord().GetValue("PropID").ToString();
                            if (gnt.ParentRecord.GetValue("MasterPropertyUOMTypeID") != null)
                                lrrGroupProperty.MasterPropertyUOMTypeID = gnt.ParentRecord.GetRecord().GetValue("MasterPropertyUOMTypeID").ToString();
                            if (gnt.ParentRecord.GetValue("Direction") != null)
                                lrrGroupProperty.Direction = gnt.ParentRecord.GetRecord().GetValue("Direction").ToString();
                            if (gnt.ParentRecord.GetValue("Derivation") != null)
                                lrrGroupProperty.Derivation = gnt.ParentRecord.GetRecord().GetValue("Derivation").ToString();
                            lrrGroupProperty.ModeID = (bool)gnt.ParentRecord.GetRecord().GetValue("ModeID");
                            _masterGroupedProperties.Add(lrrGroupProperty);
                        }
                    }
                    if (sType != "" && !(sType.Equals("1") || sType.Equals("2")))
                    {
                        gridMasterPlantItems.TableControl.Table.GetInnerMostCurrentElement().GetRecord().SetExpanded(true, false, false);
                        childTable.ParentTableDescriptor.AllowNew = true;
                        childTable.ParentTableDescriptor.AllowEdit = true;
                        childTable.ParentTableDescriptor.Columns["AttributeName"].ReadOnly = true;
                        childTable.ParentTableDescriptor.Columns["AttributeDescription"].ReadOnly = true;

                    }
                }
            }
        }

        private void gridMasterPlantItems_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
        {
            if(gridMasterPlantItems.TableControl.Table.CurrentRecord == null)
            {
                Element eCurrentElement = gridMasterPlantItems.TableControl.Table.CurrentElement;
                if (eCurrentElement == null)
                    return;
                GridNestedTable gnt = eCurrentElement as GridNestedTable;
                GridNestedTable gnt1 = gnt;
                GridTableDescriptor gtd = null;
                GridTableModel tableModel = new GridTableModel();
                while (gnt1 != null && gnt1.ChildTable != null)
                {
                    gnt = gnt1;
                    gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                    gtd = gnt.ParentTable.ParentTableDescriptor;
                }

                GridChildTable childTable = gnt.ChildTable as GridChildTable;
                tableModel = childTable.ParentTable.TableModel;

                int iRow = e.TableControl.CurrentCell.RowIndex;
                int iCol = e.TableControl.CurrentCell.ColIndex;
                string sColHeader = tableModel.GetColumnDescriptorAt(iRow, iCol).HeaderText;

                //Added by NidhiG to restrict setting of aggregatable falg for GP
                if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_AGGREGATABLE")))
                {
                    LRRMasterProperty masterProp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                    if (masterProp != null)
                    {
                        string sType = masterProp.Type == null ? "" : masterProp.Type;
                        LRRPropertyType propType = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sType);
                        if((!propType.IsDefault) && (!propType.IsDataArray))
                        {
                            LRRMessagBox.ShowMessage("SID_AGGREGATECHANGE_RESTRICTED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                            return;
                        }
                        else
                        {
                            string nVal = e.TableControl.CurrentCell.Renderer.ControlText.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                            if (nVal == "False")
                            {
                                masterProp.AggregationRule = "";
                            }
                        }
                    }
                }
                if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_SIMPLEGROUP")))
                {
                    if (e.TableControl.CurrentCell.Renderer == null)
                        return;
                    string nVal = e.TableControl.CurrentCell.Renderer.ControlText.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    string oldVal = tableModel[iRow, iCol].FormattedText;
                    string newValue = e.TableControl.CurrentCell.Renderer.ControlValue.ToString(); 
                    LRRMasterProperty masterProp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                    bool isPropertyMapped = CheckForMapping(masterProp);
                    if (!isPropertyMapped)
                    {
                        try
                        {
                            if (nVal != oldVal)
                            {
                                _isPropertyTypeChanged = true;
                                if (e.TableControl.Table.CurrentRecord.NestedTables.Count > 0)
                                {
                                    if (e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"] != null)
                                    {
                                        if (e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable != null)
                                        {
                                            if (e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.Records.Count > 0)
                                            {
                                                DialogResult k = LRRMessagBox.ShowMessage("SID_LOSE_PROPERTYVALUE", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                                                if (k == DialogResult.Yes)
                                                {
                                                    for (int i = e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.Records.Count - 1; i >= 0; i--)
                                                    {
                                                        object obj = e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.Records[i].GetData();
                                                        _masterGroupedProperties.Remove(obj);
                                                    }
                                                }
                                                else
                                                {
                                                    e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                                                    return;
                                                }
                                            }
                                        }
                                    }
                                }
                                if (nVal.Equals("Simple"))
                                {
                                    gridMasterPlantItems.TableControl.Table.GetInnerMostCurrentElement().GetRecord().IsExpanded = false;
                                    //e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.SetExpanded(false,true,true);
                                    e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.ParentTableDescriptor.AllowEdit = false;
                                    GridTableDescriptor gtd1 = e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.ParentTableDescriptor as GridTableDescriptor;
                                    gtd1.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
                                    _isNewPropTypeSimple = true;
                                }
                                else if (nVal.StartsWith("Standard Group"))
                                {
                                    e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.ParentTableDescriptor.AllowEdit = true;
                                    gridMasterPlantItems.TableControl.Table.GetInnerMostCurrentElement().GetRecord().IsExpanded = true;
                                    GridTableDescriptor gtd1 = e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.ParentTableDescriptor as GridTableDescriptor;
                                    gtd1.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
                                }
                                else
                                {
                                    LRRMasterProperty lmp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                                    if (lmp.MasterPropertyUOMTypeID != null)
                                    {
                                        lmp.MasterPropertyUOMTypeID = null;
                                    }
                                    string propertyType = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
                                    _lrrLookUpProperties = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(propertyType);
                                    AddToGroupGrid(_lrrLookUpProperties);
                                    GridTableDescriptor gtd1 = e.TableControl.Table.CurrentRecord.NestedTables["GroupedProperties"].ChildTable.ParentTableDescriptor as GridTableDescriptor;
                                    gtd1.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
                                    gridMasterPlantItems.TableControl.Table.GetInnerMostCurrentElement().GetRecord().IsExpanded = true;
                                    gtd1.AllowEdit = true;
                                    gtd1.AllowNew = true;
                                    gtd1.Columns["AttributeName"].ReadOnly = true;
                                    gtd1.Columns["AttributeDescription"].ReadOnly = true;
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            Logger.LogMessage(typeof(MasterPlantItems), "gridMasterPlantItems_TableControlCurrentCellCloseDropDown :" + ex.Message, Logger.Level.Debug);
                            return;
                        }
                    }
                    else
                    {
                        LRRMessagBox.ShowMessage("SID_MAPPING_EXISTS", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                        return;
                    }
                }
                else if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_MODES")) && (childTable.Name == "Properties"))
                {
                    if (e.TableControl.CurrentCell.Renderer == null)
                        return;
                    LRRMasterProperty masterProp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                    bool isPropertyMapped = CheckForMapping(masterProp);
                    if (!isPropertyMapped)
                    {
                        string nVal = e.TableControl.CurrentCell.Renderer.ControlText.ToString();
                        string oldVal = tableModel[iRow, iCol].FormattedText;
                        if (nVal != oldVal)
                        {
                            if (masterProp != null)
                            {
                                DialogResult dlgResult = LRRMessagBox.ShowMessage("SID_CASCADE_CHANGES_WITHOUT_RESTART", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                                if (dlgResult == DialogResult.Yes)
                                {
                                    LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(masterProp.PropID);
                                    foreach (LRRSiteComponentProperty lscp in lscps)
                                    {
                                        if (nVal == "False")
                                        {
                                            lscp.ModeID = false;
                                        }
                                        else
                                        {
                                            lscp.ModeID = true;
                                        }
                                    }
                                    _isModeChange = true;
                                }
                                else
                                {
                                    e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                                    return;
                                }
                            }
                        }
                    }
                    else
                    {
                        LRRMessagBox.ShowMessage("SID_MAPPING_EXISTS", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                        return;
                    }
                }
                else if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_AGGRAGATIONRULE")))
                {
                    string oVal = tableModel[iRow, iCol].CellValue.ToString(); 
                    string nVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
                    if (nVal == "6")
                    {
                        LRRMasterProperty lmp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                        LRRMasterProperties masterProperties = _lrrMasterProperties.GetMasterPropertiesByType(lmp.ComponentID);
                        WeighedAverageMapping weightedAvgMaping = new WeighedAverageMapping(masterProperties, lmp);
                        weightedAvgMaping.ShowDialog();
                    }
                    if (oVal == "6" && oVal != nVal)
                    {
                        LRRMasterProperty lmp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                        LRRWeightedFacterMapping weightedFmapping = LRRModel.WeightedFacterMappings.GetWeightedFacterFromPropID(lmp.PropID);
                        LRRModel.WeightedFacterMappings.Remove(weightedFmapping);
                        _app.DBManagerObj.CommitCollection(LRRModel.WeightedFacterMappings.GetChanges());
                        LRRModel.WeightedFacterMappings.RefreshCollection();
                    }
                }
                else if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_UOM_TYPE")))
                {
                    if (e.TableControl.CurrentCell.Renderer == null)
                        return;
                    string nVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
                    string oldVal = tableModel[iRow, iCol].CellValue.ToString();
                    LRRMasterProperty masterProp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                    if (oldVal != nVal)
                    {
                        if (oldVal != "" && oldVal != null)
                        {
                            DialogResult dlgResult = LRRMessagBox.ShowMessage("SID_CASCADE_CHANGES_WITHOUT_RESTART", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                            if (dlgResult == DialogResult.Yes)
                            {
                                _isUOMTypeChanged = true;
                                LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(masterProp.PropID);
                                foreach (LRRSiteComponentProperty lscp in lscps)
                                {
                                    lscp.UOMTypeID = nVal;
                                }

                                LRRSiteComponentProperties propertiesToCommite = LRRModel.SiteComponentPropertiesObj.GetChanges();
                                if (propertiesToCommite.Count > 0)
                                {
                                    _app.DBManagerObj.CommitCollection(propertiesToCommite);
                                }
                                LRRAggregates aggregates = LRRModel.AggregatesObj.GetAggregatesByMasterComponentID(masterProp.ComponentID);
                                foreach (LRRAggregate agg in aggregates)
                                {
                                    LRRAggregateProperties aggProps = LRRModel.AggregatePropertiesObj.FilterPropertiesByAggregate(agg.AggregateID);  
                                    foreach(LRRAggregateProperty aggProp in aggProps)
                                    {
                                        if (aggProp.MasterPropertyID == masterProp.PropID)
                                        {
                                            aggProp.UOMTypeID = nVal;
                                            break;
                                        }
                                    }
                                }
                                LRRAggregateProperties aggPropertiesToCommite = LRRModel.AggregatePropertiesObj.GetChanges();
                                if (aggPropertiesToCommite.Count > 0)
                                {
                                    _app.DBManagerObj.CommitCollection(aggPropertiesToCommite);
                                }

                            }
                            else
                            {
                                e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                            }
                        }
                        else
                        {
                            _isUOMTypeChanged = true;
                            LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(masterProp.PropID);
                            foreach (LRRSiteComponentProperty lscp in lscps)
                            {
                                lscp.UOMTypeID = nVal;
                            }
                            LRRAggregates aggregates = LRRModel.AggregatesObj.GetAggregatesByMasterComponentID(masterProp.ComponentID);
                            foreach (LRRAggregate agg in aggregates)
                            {
                                LRRAggregateProperty aggProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromMasterPropertyID(agg.AggregateID, masterProp.PropID);
                                if (aggProp != null)
                                {
                                    aggProp.UOMTypeID = nVal;
                                }
                            }
                        }
                    }
                }
            }
        }

        private void UpdateUOM(string masterPropID)
        {
            LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
            LRRMeasurementSystem lrrMeas = LRRModel.MeasurementSystems.GetCurrentModelUOM();
            string modelLocaleID = lrrMeas.ID;
            LRRMasterProperty masterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(masterPropID);
            if (masterProp.Type == "1")
            {
                //For Sitecomponent Properties.
                LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(masterPropID);
                foreach (LRRSiteComponentProperty lscp in lscps)
                {
                    lscp.UOM = _lrrMSD.GetLocaleUOM(modelLocaleID, lscp.UOMTypeID);
                    LRRSiteComponentPropertyValues  propValues = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(lscp.ID);
                    foreach (LRRSiteComponentPropertyValue propValue in propValues)
                    {
                        propValue.ModelUOM = lscp.UOM;
                    }
                    if (LRRModel.PropertyValuesObj.GetChanges().Count > 0)
                    {
                        _app.DBManagerObj.CommitCollection(LRRModel.PropertyValuesObj.GetChanges());
                    }
                }
                //For Aggregate Properties.
                LRRAggregates aggregatesObj = LRRModel.AggregatesObj.GetAggregatesByMasterComponentID(masterProp.ComponentID);
                foreach (LRRAggregate aggregate in aggregatesObj)
                {
                    LRRAggregateProperty aggregateProp = LRRModel.AggregatePropertiesObj.GetAggregatePropFromMasterPropertyID(aggregate.AggregateID, masterPropID);
                    if (aggregateProp != null)
                    {
                        aggregateProp.UOM = _lrrMSD.GetLocaleUOM(modelLocaleID, aggregateProp.UOMTypeID);
                        LRRAggregatePropertyValues aggPropValues = LRRModel.AggregatePropertyValuesObj.GetPropValuesCollectionByPropID(aggregateProp.ID);
                        foreach (LRRAggregatePropertyValue aggPropValue in aggPropValues)
                        {
                            aggPropValue.ModelUOM = aggregateProp.UOM;
                        }
                        if (LRRModel.AggregatePropertyValuesObj.GetChanges().Count > 0)
                        {
                            _app.DBManagerObj.CommitCollection(LRRModel.AggregatePropertyValuesObj.GetChanges());
                        }
                    }
                }
            }
        }
        private void CreatePropertyValues(bool currentModeFlag, string sPropID)
        {
            LRRSiteComponentProperty sProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
            List<IPropertyValue> propValues = LRRModel.PropertyValuesObj.GetPropertyValuesFromPropID(sPropID);
            if (propValues != null)
            {
                LRRSiteComponentPropertyValues propValuesToDelete = new LRRSiteComponentPropertyValues();
                foreach (LRRSiteComponentPropertyValue propVal in propValues)
                {
                    propValuesToDelete.Add(propVal);
                    sProp.Values.Remove(propVal);
                }
                foreach (LRRSiteComponentPropertyValue value in propValuesToDelete)
                {
                    LRRModel.PropertyValuesObj.Remove(value);
                }
            }
            if (currentModeFlag)
            {
                for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                {
                    LRRMode mode = LRRModel.ProjectModes[i] as LRRMode;
                    if (mode.ModeId != "0")
                    {
                        LRRMeasurementSystem lms = LRRModel.MeasurementSystems.GetCurrentModelUOM();
                        LRRMeasurementSystemDefinitions lmsd = LRRModel.ChildModel.MeasSysDef.GetUOMTypesForMSID(lms.ID);
                        LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
                        LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscp.PropertyID);
                        string modelUom = lmsd.GetLocaleUOM(lms.ID, lscp.UOMTypeID);
                        LRRSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRSiteComponentPropertyValue();
                        lrrSiteComponentPropertyValue.ModeID = mode.ModeId;
                        lrrSiteComponentPropertyValue.ModelUOM = modelUom;
                        lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
                        lrrSiteComponentPropertyValue.IsEditable = true;
                        lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
                        lrrSiteComponentPropertyValue.Direction = lmp.Direction;
                        //Add Cascading logic here
                        LRRModel.PropertyValuesObj.Add(lrrSiteComponentPropertyValue);
                        lscp.Values.Add(lrrSiteComponentPropertyValue);
                    }
                }
            }
            else
            {
                LRRSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRSiteComponentPropertyValue();
                lrrSiteComponentPropertyValue.ModeID = "0";
                lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
                lrrSiteComponentPropertyValue.Direction = "1";
                lrrSiteComponentPropertyValue.Derivation = "4";
                lrrSiteComponentPropertyValue.IsEditable = true;
                lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
                //Add Cascading logic here
                LRRModel.PropertyValuesObj.Add(lrrSiteComponentPropertyValue);
                if (sProp != null)
                {
                    sProp.Values.Add(lrrSiteComponentPropertyValue);
                }
            }
            _app.DBManagerObj.CommitCollection(LRRModel.PropertyValuesObj.GetChanges());
            LRRModel.PropertyValuesObj.RefreshCollection();
        }


        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Delete)
            {
                _isDeletePress = true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }



        private void gridMasterPlantItems_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
        {
            if (_isDeletePress)
            {
                DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (_dlgResult == DialogResult.Yes)
                {
                    if (e.Record.GetData().GetType() == typeof(LRRMasterProperty))
                    {
                        bool checkForDelete = CheckForMapping();
                        if (!checkForDelete)
                        {
                            LRRMessagBox.ShowMessage("SID_MAPPING_EXISTS", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            //							MessageBox.Show("Mapping Exists Cannot Delete Property");
                            e.Cancel = true;
                            _isDeletePress = false;
                            _isRecordeDel = false;
                            return;
                        }
                    }
                    _isRecordeDel = true;
                }
                else
                {
                    _isRecordeDel = false;
                }
                _isDeletePress = false;
            }
            if (_isRecordeDel)
            {
                if (e.Record.GetData().GetType() == typeof(LRRMasterComponent))
                {
                    object delobj = e.Record.GetData();
                    string id = delobj.GetType().GetProperty("ID").GetValue(delobj, null).ToString();
                    string compName = delobj.GetType().GetProperty("ComponentName").GetValue(delobj, null).ToString();
                    int no = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(id).Count;
                    if (no > 0)
                    {
                        //DialogResult k =  MessageBox.Show("There are "+no+" SiteComponents of type '"+compName+"'\n Do you want to continue with delete operation ?","Master Plant Item",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
                        string[] s = new string[2];
                        s[0] = no.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        s[1] = compName;
                        LRRMessagBox.ShowMessage("SID_DEL_MASTER_CONFIRM", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Information);
                        e.Cancel = true;
                        return;
                    }
                }
                else if (e.Record.GetData().GetType() == typeof(LRRMasterProperty))
                {
                    NestedTable groupPropTable = e.Record.NestedTables["GroupedProperties"];
                    for (int j = groupPropTable.ChildTable.Records.Count - 1; j >= 0; j--)
                    {
                        object grpObj = groupPropTable.ChildTable.Records[j].GetData();
                        _masterGroupedProperties.Remove(grpObj);
                    }
                }

            }
            else
            {
                e.Cancel = true;
                _isDeletePress = false;
                return;
            }
        }

        private bool CheckForMapping(LRRMasterProperty masterProp)
        {
            ArrayList arlist = null;
            //Check for Simple Property
            if (masterProp.Type == "1")
            {
                arlist = LRRModel.CheckForSimplePropertyMapping(masterProp);
            }
            else
            {
                arlist = LRRModel.CheckForMapping(masterProp);
            }
            if (arlist != null && arlist.Count > 0)
            {
                for (int i = 0; i < arlist.Count; i++)
                {
                    LRRHistPropCompPropMapping histPropCompPropMap = arlist[i] as LRRHistPropCompPropMapping;
                    Logger.LogMessage(histPropCompPropMap.ComponentPropertyName + "  Mapped With HistTag  " + histPropCompPropMap.HistTag, Logger.Level.Error);
                }
                return true;
            }
            return false;
        }

        private bool CheckForMapping()
        {

            Element eCurrentInnerElement = gridMasterPlantItems.Table.GetInnerMostCurrentElement();
            GridTable gt = eCurrentInnerElement.ParentTable as GridTable;

            LRRMasterProperties masterProperties = new LRRMasterProperties();
            if (gt != null)
            {
                GridRangeInfoList ranges = gt.TableModel.SelectedRanges;
                if (ranges.Count > 0)
                {
                    for (int i = 0; i < ranges.Count; i++)
                    {
                        GridRangeInfo range = ranges[i];
                        int top = range.Top;
                        int bottom = range.Bottom;

                        for (int row = top; row <= bottom; row++)
                        {
                            try
                            {
                                LRRMasterProperty masterPropObj = gt.TableModel.GetDisplayElementAt(row).GetData() as LRRMasterProperty;
                                if (masterPropObj != null)
                                    masterProperties.Add(masterPropObj);
                            }
                            catch (Exception ex)
                            {
                                Logger.LogMessage(typeof(MasterPlantItems), "Delete Record :" + ex.Message, Logger.Level.Debug);
                            }
                        }
                    }
                }
            }

            foreach (LRRMasterProperty masterProp in masterProperties)
            {
                ArrayList arlist = null;
                //Check for Simple Property
                if (masterProp.Type == "1")
                {
                    arlist = LRRModel.CheckForSimplePropertyMapping(masterProp);
                }
                else
                {
                    arlist = LRRModel.CheckForMapping(masterProp);
                }
                if (arlist != null && arlist.Count > 0)
                {
                    for (int i = 0; i < arlist.Count; i++)
                    {
                        LRRHistPropCompPropMapping histPropCompPropMap = arlist[i] as LRRHistPropCompPropMapping;
                        Logger.LogMessage(histPropCompPropMap.ComponentPropertyName + "  Mapped With HistTag  " + histPropCompPropMap.HistTag, Logger.Level.Error);
                    }
                    return false;
                }
            }
            return true;
        }

        public void AddToGroupGrid(LRRLookUpProperties lrrLookUpProperties)
        {
            LRRMasterProperty lrrMasterProperty = gridMasterPlantItems.TableControl.Table.GetInnerMostCurrentElement().GetData() as LRRMasterProperty;

            foreach (LRRLookUpProperty lookUpProperty in lrrLookUpProperties)
            {
                //--Modified by Nidhig on 26th Jan to inherit the Derivation, Direction & Mode from the property type
                //-- incase of grouped properties
                LRRPropertyType objPropertyType = _lrrPropertyTypes.getPropertyTypeForID(lookUpProperty.PropertyID);

                LRRGroupProperty lrrGroupProperty = new LRRGroupProperty();
                lrrGroupProperty.AttributeName = lookUpProperty.Name;
                lrrGroupProperty.AttributeDescription = lookUpProperty.Description;
                lrrGroupProperty.PropertyID = lookUpProperty.PropertyID;
                lrrGroupProperty.LookUpPropertiesID = lookUpProperty.LookUpPropertiesID;

                lrrGroupProperty.MasterPropertyID = lrrMasterProperty.PropID;
                lrrGroupProperty.MasterPropertyUOMTypeID = lrrMasterProperty.MasterPropertyUOMTypeID;
                lrrGroupProperty.Direction = objPropertyType.Direction;
                lrrGroupProperty.Derivation = objPropertyType.Derivation;
                lrrGroupProperty.ModeID = objPropertyType.ModeID;
                //Set the default mode as the property mode
                lrrMasterProperty.ModeID = objPropertyType.ModeID;
                _masterGroupedProperties.Add(lrrGroupProperty);
            }
        }

        private void ChildTableDescriptor_RecordExpanding(object sender, RecordEventArgs e)
        {
            if (e.Record.GetValue("Type") != null)
            {
                if (e.Record.GetValue("Type").ToString() == "1")
                {
                    e.Cancel = true;
                }
            }
        }
        #region ILRRUIContainer Members

        public void ClearSort()
        {
            // TODO:  Add MasterPlantItems.ClearSort implementation
            SyncGridUtilities.ClearSort(gridMasterPlantItems);
        }

        public bool SupportsClearSort()
        {
            // TODO:  Add MasterPlantItems.SupportsClearSort implementation
            return true;
        }

        #endregion

        #region ILRRUIContainer Members

        public void CopyUOMTypes()
        {

        }

        public bool SupportsCopyUOMTypes()
        {
            return false;
        }

        #endregion

        #region ILRRUIContainer Members

        public void PrintPreview()
        {
            // TODO:  Add MasterPlantItems.PrintPreview implementation
            if (gridMasterPlantItems.TableControl.CurrentCell.IsActive)
            {
                GridGroupingPrint ggPrint = new GridGroupingPrint();
                ggPrint.PrintData(gridMasterPlantItems, true);
            }
        }

        #endregion

        #region ILRRUIContainer Members

        public void ShowPropertyList()
        {
            // TODO:  Add MasterPlantItems.ShowPropertyList implementation
        }

        public void ShowComponentList()
        {
            // TODO:  Add MasterPlantItems.ShowComponentList implementation
        }

        public bool SupportsResultsFilter()
        {
            // TODO:  Add MasterPlantItems.SupportsResultsFilter implementation
            return false;
        }

        #endregion

        private void gridMasterPlantItems_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
        {
            GridTableModel tableModel = null;
            GridGroupingControl grid = sender as GridGroupingControl;
            if (grid.TableControl.Table.CurrentRecord == null)
            {
                Element eCurrentElement = grid.TableControl.Table.CurrentElement;
                GridNestedTable gnt = eCurrentElement as GridNestedTable;
                GridNestedTable gnt1 = gnt;
                GridTableDescriptor gtd = null;
                while (gnt1 != null && gnt1.ChildTable != null)
                {
                    gnt = gnt1;
                    gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                    gtd = gnt.ParentTable.ParentTableDescriptor;
                }

                if (gnt == null)
                    return;
                GridChildTable childTable = gnt.ChildTable as GridChildTable;
                tableModel = childTable.ParentTable.TableModel;

                if (e.TableControl.CurrentCell.RowIndex == -1 || e.TableControl.CurrentCell.ColIndex == -1)
                    return;
                if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex) == null)
                    return;

                if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex).MappingName == "AggregationRule_Expression")
                {
                    bool isAggregatable = true;
                    try
                    {
                        isAggregatable = ((LRRMasterProperty)e.TableControl.Table.CurrentRecord.GetData()).IsAggregatable;
                    }
                    catch (Exception ex)
                    {
                        Logger.LogMessage(typeof(MasterPlantItems), "gridMasterPlantItems_TableControlCellClick :" + ex.Message, Logger.Level.Debug);
                        return;
                    }
                    if (isAggregatable == false)
                    {
                        string aggRule = ((LRRMasterProperty)e.TableControl.Table.CurrentRecord.GetData()).AggregationRule;
                        if (!(aggRule == null || aggRule == ""))
                        {
                            ((LRRMasterProperty)e.TableControl.Table.CurrentRecord.GetData()).AggregationRule = null;
                        }
                        e.TableControl.CurrentCell.Deactivate(true);
                        e.Inner.Cancel = true;
                    }
                }
            }
        }

        private void gridMasterPlantItems_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
        {
            GridTableModel tableModel = null;
            GridGroupingControl grid = sender as GridGroupingControl;
            if (e.TableControl.CurrentCell.Renderer.CurrentStyle.CellType == "FilterBarCell")
                return;
            if (grid.TableControl.Table.CurrentRecord == null)
            {
                Element eCurrentElement = grid.TableControl.Table.CurrentElement;
                GridNestedTable gnt = eCurrentElement as GridNestedTable;
                GridNestedTable gnt1 = gnt;
                GridTableDescriptor gtd = null;
                while (gnt1 != null && gnt1.ChildTable != null)
                {
                    gnt = gnt1;
                    gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                    gtd = gnt.ParentTable.ParentTableDescriptor;
                }

                if (gnt == null)
                    return;
                GridChildTable childTable = gnt.ChildTable as GridChildTable;
                tableModel = childTable.ParentTable.TableModel;

                int iRow = e.TableControl.CurrentCell.RowIndex;
                int iCol = e.TableControl.CurrentCell.ColIndex;
                string sColHeader = tableModel.GetColumnDescriptorAt(iRow, iCol).HeaderText;

                if (e.TableControl.CurrentCell.RowIndex == -1 || e.TableControl.CurrentCell.ColIndex == -1)
                    return;
                if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex) == null)
                    return;

                if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex).MappingName == "AggregationRule_Expression")
                {
                    bool isAggregatable = true;
                    try
                    {
                        isAggregatable = ((LRRMasterProperty)e.TableControl.Table.CurrentRecord.GetData()).IsAggregatable;
                    }
                    catch (Exception ex)
                    {
                        Logger.LogMessage(typeof(MasterPlantItems), "gridMasterPlantItems_TableControlCurrentCellShowingDropDown :" + ex.Message, Logger.Level.Debug);
                        return;
                    }
                    if (isAggregatable == false)
                    {
                        string aggRule = ((LRRMasterProperty)e.TableControl.Table.CurrentRecord.GetData()).AggregationRule;
                        if (!(aggRule == null || aggRule == ""))
                        {
                            ((LRRMasterProperty)e.TableControl.Table.CurrentRecord.GetData()).AggregationRule = null;
                        }
                        e.TableControl.CurrentCell.Deactivate(true);
                        e.Inner.Cancel = true;
                    }
                }
                else if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_UOM_TYPE")))
                {
                    try
                    {
                        LRRMasterProperty lmp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                        if (lmp.Type != "1" && lmp.Type != null)
                        {
                            LRRMessagBox.ShowMessage(this, "SID_UOM_CHECK", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            e.Inner.Cancel = true;
                        }
                    }
                    catch (Exception ex)
                    {
                        Logger.LogMessage(typeof(MasterPlantItems), "gridMasterPlantItems_TableControlCurrentCellCloseDropDown :" + ex.Message, Logger.Level.Debug);
                        return;
                    }
                }
                else if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_MODES"))) //Added by Nidhig to restrict change of Mode for Grouped Properties
                {
                    try
                    {
                        //Gets the current Master Property
                        LRRMasterProperty lmp = e.TableControl.Table.CurrentRecord.GetData() as LRRMasterProperty;
                        if (lmp.Type != "1" && lmp.Type != null)
                        {
                            LRRMessagBox.ShowMessage("SID_MODECHANGE_RESTRICTED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            e.Inner.Cancel = true;
                        }
                    }
                    catch (Exception ex)
                    {
                        Logger.LogMessage(typeof(MasterPlantItems), "gridMasterPlantItems_TableControlCurrentCellCloseDropDown :" + ex.Message, Logger.Level.Debug);
                        return;
                    }
                }

            }
        }

        #region ILRRUIContainer Members

        public void LeftColMovement()
        {
            // TODO:  Add MasterPlantItems.LeftColMovement implementation
        }

        public void RightColMovement()
        {
            // TODO:  Add MasterPlantItems.RightColMovement implementation
        }

        #endregion

        #region ILRRUIContainer Members

        public void PageSetup()
        {
            GridGroupingPrint ggPrint = new GridGroupingPrint();
            ggPrint.PageSetUp();
        }

        public void Undo()
        {
            SyncGridUtilities.RollBackChanges(gridMasterPlantItems);
            Refresh();
        }

        public bool SupportsPageSetup()
        {
            // TODO:  Add MasterPlantItems.SupportsPageSetup implementation
            return true;
        }

        public bool SupportsUndo()
        {
            // TODO:  Add MasterPlantItems.SupportsUndo implementation
            return true;
        }

        #endregion

        #region ILRRUIContainer Members

        public void OpenCompositeView()
        {
            // TODO:  Add MasterPlantItems.OpenCompositeView implementation
        }

        public void TransposeView()
        {
            // TODO:  Add MasterPlantItems.TransposeView implementation
        }

        public void OpenQuery()
        {
            // TODO:  Add MasterPlantItems.OpenQuery implementation
        }

        public void OpenView()
        {
            // TODO:  Add MasterPlantItems.OpenView implementation
        }

        public bool SupportsCompositeView()
        {
            // TODO:  Add MasterPlantItems.SupportsCompositeView implementation
            return false;
        }

        #endregion


        private void CascadeDeleteChanges(string masterCompID, string mastePropID)
        {
            LRRSiteComponents objSiteComponents = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(masterCompID);
            LRRSiteComponentProperties lscps = new LRRSiteComponentProperties();
            foreach (LRRSiteComponent siteCompObj in objSiteComponents)
            {
                LRRSiteComponentProperty objSiteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(siteCompObj.SiteComponentID, mastePropID);
                if (objSiteCompProp != null)
                {
                    LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(objSiteCompProp.ID);
                    if (lscp != null)
                    {
                        LRRModel.SiteComponentPropertiesObj.Remove(lscp);
                        lscps.Add(lscp);
                    }
                }
            }
            if (lscps.Count > 0)
            {
                _app.DBManagerObj.ExecuteBatchDelete(lscps);
            }
        }
        #region ILRRUIContainer Members

        public bool PerformDirtyChk
        {
            get
            {
                // TODO:  Add MasterPlantItems.PerformDirtyChk getter implementation
                return true;
            }
        }


        #endregion
    }
}


