using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.SavedViews;
using Symcon.LightRidge.PEAdvisor.UserControls;
using System.IO;
using System.Xml;
using System.Xml.Serialization;
using System.Text;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;
using Symcon.LightRidge.PEAdvisor.CommonViews;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for SavedViewForm.
	/// </summary>
	public class MultiTrendForm : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.TreeView trvMasterProps;
		private System.Windows.Forms.Button btnExec;
		private System.Windows.Forms.Panel pnlGrid;
		private System.Windows.Forms.Panel pnlTreeControl;
		private System.Windows.Forms.Panel pnlButton;
		private System.Windows.Forms.Panel pnlLeft;
		private System.Windows.Forms.Splitter splBottom;
		private System.Windows.Forms.Label labelTemplate;
		private System.Windows.Forms.ComboBox comboBoxTemplates;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Splitter splVertical;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label labelMultiTrendName;
		private System.Windows.Forms.TextBox textBoxMultiTrendName;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MultiTrendForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			InitializeTree();
            trvMasterProps.TreeViewNodeSorter = new TreeNodeSorter();
            trvMasterProps.Sort();
			PopulateComboTemplates();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MultiTrendForm));
			this.trvMasterProps = new System.Windows.Forms.TreeView();
			this.btnExec = new System.Windows.Forms.Button();
			this.pnlTreeControl = new System.Windows.Forms.Panel();
			this.pnlGrid = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.textBoxMultiTrendName = new System.Windows.Forms.TextBox();
			this.labelMultiTrendName = new System.Windows.Forms.Label();
			this.labelTemplate = new System.Windows.Forms.Label();
			this.comboBoxTemplates = new System.Windows.Forms.ComboBox();
			this.pnlButton = new System.Windows.Forms.Panel();
			this.pnlLeft = new System.Windows.Forms.Panel();
			this.panel4 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.splVertical = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.splBottom = new System.Windows.Forms.Splitter();
			this.pnlTreeControl.SuspendLayout();
			this.panel3.SuspendLayout();
			this.pnlButton.SuspendLayout();
			this.pnlLeft.SuspendLayout();
			this.panel4.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// trvMasterProps
			// 
			this.trvMasterProps.Dock = System.Windows.Forms.DockStyle.Fill;
			this.trvMasterProps.ImageIndex = -1;
			this.trvMasterProps.Location = new System.Drawing.Point(0, 0);
			this.trvMasterProps.Name = "trvMasterProps";
			this.trvMasterProps.SelectedImageIndex = -1;
			this.trvMasterProps.Size = new System.Drawing.Size(232, 412);
			this.trvMasterProps.TabIndex = 0;
			this.trvMasterProps.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.trvMasterProps_AfterSelect);
			// 
			// btnExec
			// 
			this.btnExec.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnExec.Location = new System.Drawing.Point(144, 16);
			this.btnExec.Name = "btnExec";
			this.btnExec.TabIndex = 1;
			this.btnExec.Tag = "SID_EXECUTE";
			this.btnExec.Text = "SID_EXECUTE";
			this.btnExec.Click += new System.EventHandler(this.btnExec_Click);
			// 
			// pnlTreeControl
			// 
			this.pnlTreeControl.Controls.Add(this.trvMasterProps);
			this.pnlTreeControl.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlTreeControl.Location = new System.Drawing.Point(0, 0);
			this.pnlTreeControl.Name = "pnlTreeControl";
			this.pnlTreeControl.Size = new System.Drawing.Size(232, 412);
			this.pnlTreeControl.TabIndex = 2;
			// 
			// pnlGrid
			// 
			this.pnlGrid.Location = new System.Drawing.Point(608, 0);
			this.pnlGrid.Name = "pnlGrid";
			this.pnlGrid.Size = new System.Drawing.Size(304, 462);
			this.pnlGrid.TabIndex = 3;
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.textBoxMultiTrendName);
			this.panel3.Controls.Add(this.labelMultiTrendName);
			this.panel3.Controls.Add(this.labelTemplate);
			this.panel3.Controls.Add(this.comboBoxTemplates);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel3.Location = new System.Drawing.Point(0, 0);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(677, 56);
			this.panel3.TabIndex = 3;
			// 
			// textBoxMultiTrendName
			// 
			this.textBoxMultiTrendName.Location = new System.Drawing.Point(488, 16);
			this.textBoxMultiTrendName.Name = "textBoxMultiTrendName";
			this.textBoxMultiTrendName.Size = new System.Drawing.Size(168, 20);
			this.textBoxMultiTrendName.TabIndex = 3;
			this.textBoxMultiTrendName.Text = "";
			// 
			// labelMultiTrendName
			// 
			this.labelMultiTrendName.Location = new System.Drawing.Point(416, 16);
			this.labelMultiTrendName.Name = "labelMultiTrendName";
			this.labelMultiTrendName.Size = new System.Drawing.Size(72, 23);
			this.labelMultiTrendName.TabIndex = 2;
			this.labelMultiTrendName.Text = "Trend Name:";
			// 
			// labelTemplate
			// 
			this.labelTemplate.Location = new System.Drawing.Point(48, 16);
			this.labelTemplate.Name = "labelTemplate";
			this.labelTemplate.Size = new System.Drawing.Size(96, 23);
			this.labelTemplate.TabIndex = 1;
			this.labelTemplate.Text = "Select Template:";
			// 
			// comboBoxTemplates
			// 
			this.comboBoxTemplates.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxTemplates.Location = new System.Drawing.Point(168, 16);
			this.comboBoxTemplates.Name = "comboBoxTemplates";
			this.comboBoxTemplates.Size = new System.Drawing.Size(184, 21);
			this.comboBoxTemplates.TabIndex = 0;
			this.comboBoxTemplates.SelectedIndexChanged += new System.EventHandler(this.comboBoxTemplates_SelectedIndexChanged);
			// 
			// pnlButton
			// 
			this.pnlButton.Controls.Add(this.btnExec);
			this.pnlButton.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlButton.Location = new System.Drawing.Point(0, 412);
			this.pnlButton.Name = "pnlButton";
			this.pnlButton.Size = new System.Drawing.Size(232, 48);
			this.pnlButton.TabIndex = 4;
			// 
			// pnlLeft
			// 
			this.pnlLeft.Controls.Add(this.panel4);
			this.pnlLeft.Controls.Add(this.splVertical);
			this.pnlLeft.Controls.Add(this.panel1);
			this.pnlLeft.Controls.Add(this.splBottom);
			this.pnlLeft.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlLeft.Location = new System.Drawing.Point(0, 0);
			this.pnlLeft.Name = "pnlLeft";
			this.pnlLeft.Size = new System.Drawing.Size(912, 462);
			this.pnlLeft.TabIndex = 6;
			// 
			// panel4
			// 
			this.panel4.Controls.Add(this.panel2);
			this.panel4.Controls.Add(this.splitter2);
			this.panel4.Controls.Add(this.panel3);
			this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel4.Location = new System.Drawing.Point(235, 0);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(677, 460);
			this.panel4.TabIndex = 8;
			// 
			// panel2
			// 
			this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 59);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(677, 401);
			this.panel2.TabIndex = 6;
			// 
			// splitter2
			// 
			this.splitter2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(0, 56);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(677, 3);
			this.splitter2.TabIndex = 5;
			this.splitter2.TabStop = false;
			// 
			// splVertical
			// 
			this.splVertical.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splVertical.Location = new System.Drawing.Point(232, 0);
			this.splVertical.Name = "splVertical";
			this.splVertical.Size = new System.Drawing.Size(3, 460);
			this.splVertical.TabIndex = 7;
			this.splVertical.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.pnlTreeControl);
			this.panel1.Controls.Add(this.pnlButton);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(232, 460);
			this.panel1.TabIndex = 6;
			// 
			// splBottom
			// 
			this.splBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splBottom.Enabled = false;
			this.splBottom.Location = new System.Drawing.Point(0, 460);
			this.splBottom.Name = "splBottom";
			this.splBottom.Size = new System.Drawing.Size(912, 2);
			this.splBottom.TabIndex = 5;
			this.splBottom.TabStop = false;
			// 
			// MultiTrendForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(912, 462);
			this.Controls.Add(this.pnlLeft);
			this.Controls.Add(this.pnlGrid);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MultiTrendForm";
			this.Tag = "SID_MULTI_TREND";
			this.Text = "";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.pnlTreeControl.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.pnlButton.ResumeLayout(false);
			this.pnlLeft.ResumeLayout(false);
			this.panel4.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void PopulateComboTemplates()
		{
            string selectedItem = null;
			LRRTrendTemplates trendTemplates = new LRRTrendTemplates();
			_lrrApp.DBManagerObj.PopulateCollection(trendTemplates);
            if (comboBoxTemplates.SelectedItem != null)
                selectedItem = comboBoxTemplates.SelectedItem.ToString();
			comboBoxTemplates.Items.Clear();
            _htTemplates.Clear();

			foreach(LRRTrendTemplate trendTemplate in trendTemplates)
			{
				comboBoxTemplates.Items.Add(trendTemplate.Name);
				_htTemplates.Add(trendTemplate.Name,trendTemplate);
			}
            if (selectedItem != null)
            {
                try
                {
                    comboBoxTemplates.SelectedItem = selectedItem;
                }
                catch
                {

                }
                
            }
            if (comboBoxTemplates.SelectedIndex == -1)
                if (comboBoxTemplates.Items.Count > 0)
                    comboBoxTemplates.SelectedIndex = 0;
		}

		private void InitDataSource()
		{
			_lrrMasterComps = LRRModel.Model;
			_lrrPropertyTypes = LRRModel.ChildModel.PropertyTypes;

			_lrrCompTypes = new LRRComponentTypes();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrCompTypes);
		}

		private void InitializeTree()
		{
			TreeNode root = new TreeNode("Components");
			IEnumerator compTypeEnum = _lrrCompTypes.GetEnumerator();

			while(compTypeEnum.MoveNext())
			{
				LRRComponentType lrrCompType = compTypeEnum.Current as LRRComponentType;

				//Create Component Type Node
				TreeNode compTypeNode = new TreeNode(lrrCompType.Name);
				root.Nodes.Add(compTypeNode);
				
				//Filter Master Components on master Component Type
				LRRMasterComponents lrrMasterComps = _lrrMasterComps.FilterMasterComponentsByComponentTypeID(lrrCompType.ID);
				IEnumerator iMasterCompEnum = lrrMasterComps.GetEnumerator();
				while(iMasterCompEnum.MoveNext())
				{
					LRRMasterComponent lrrMasterComp = iMasterCompEnum.Current as LRRMasterComponent;

					//Create Master Component Node
					TreeNode masterCompNode = new TreeNode(lrrMasterComp.ComponentName);
					compTypeNode.Nodes.Add(masterCompNode);
					
					
					
					//Get Site Components
					LRRSiteComponents lrrSiteComps = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(lrrMasterComp.ID);
					TreeNode siteNode = null;
					if(lrrSiteComps.Count > 0)
					{
						siteNode = new TreeNode("SiteComponents");
						masterCompNode.Nodes.Add(siteNode);
					}
					IEnumerator iSiteCompEnum = lrrSiteComps.GetEnumerator();
					while(iSiteCompEnum.MoveNext())
					{
						LRRSiteComponent lrrSiteComp = iSiteCompEnum.Current as LRRSiteComponent;

						//Create Site Component Node
						TreeNode siteCompNode = new TreeNode(lrrSiteComp.Name);

						siteNode.Nodes.Add(siteCompNode);

						LRRMasterProperties lrrMasterProps = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByType(lrrMasterComp.ID);
						TreeNode masterNode = null;
						if(lrrMasterProps.Count > 0)
						{
							masterNode = new TreeNode("Master Properties");
							siteCompNode.Nodes.Add(masterNode);
						}
						IEnumerator iPropTypeEnum = _lrrPropertyTypes.GetEnumerator();
						while(iPropTypeEnum.MoveNext())
						{

							LRRPropertyType lrrPropType = iPropTypeEnum.Current as LRRPropertyType;

							LRRMasterProperties lrrMasterProperties = lrrMasterProps.GetMasterPropertiesByPropType(lrrPropType.ID);
							IEnumerator iMasterPropEnum = lrrMasterProperties.GetEnumerator();
							while(iMasterPropEnum.MoveNext())
							{
								LRRMasterProperty lrrMasterProp = iMasterPropEnum.Current as LRRMasterProperty;

								LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(lrrSiteComp.GetID(),lrrMasterProp.PropID);
                                if (scp == null)
                                    continue;
								//Create Master Property Node(MasterProperties --> BFWFlow)
								if(lrrMasterProp.Type == "1")
								{
									TreeNode masterPropNode = new TreeNode(lrrMasterProp.Name);
	
									masterNode.Nodes.Add(masterPropNode);
									foreach(LRRMode mode in LRRModel.ProjectModes)
									{
										try
										{
											TreeNode modeNode = new TreeNode(mode.ModeName);

                                            List<IPropertyValue> propValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(scp.ID);
											if(propValues != null)
											{
												foreach(LRRSiteComponentPropertyValue propValue in propValues)
												{
													if(propValue.ModeID == mode.ModeId)
													{
														modeNode.Tag = propValue;
														break;
													}
												}
											}
											masterPropNode.Nodes.Add(modeNode);
										}
										catch
										{
										}
										
									}
								}

								if(lrrMasterProp.Type != "1")
								{
									//Property Type Node (MasterProperties --> BFWFlow-->Air Components)
									TreeNode childNode1 = new TreeNode(lrrMasterProp.Name + "-" + lrrPropType.PropertyType);
									masterNode.Nodes.Add(childNode1);
							
									//Check for Data Array
									if(!lrrPropType.IsDataArray)
									{
										LRRLookUpQualifiers lrrLkUpQuals = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lrrPropType.ID);
										IEnumerator iLkUpEnum = lrrLkUpQuals.GetEnumerator();
										while(iLkUpEnum.MoveNext())
										{
											LRRLookUpQualifier lrrLkUpQual = iLkUpEnum.Current as LRRLookUpQualifier;
											LRRQualifier qual = LRRModel.Qualifiers.getQualifierObjectForQualifierID(lrrLkUpQual.QualifierID);

											//Qualifier Node (MasterProperties --> BFWFlow-->Air Components --> Mol Fraction)
											TreeNode childNode2 = new TreeNode(qual.Name);
											childNode1.Nodes.Add(childNode2);

											//Get the Group properties
											LRRLookUpProperties lrrLkUpProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(lrrPropType.ID);
											IEnumerator iLkUpPropEnum = lrrLkUpProps.GetEnumerator();
											while(iLkUpPropEnum.MoveNext())
											{
												LRRLookUpProperty lrrLkUpProp = iLkUpPropEnum.Current as LRRLookUpProperty;
									
												//Grp Property Node (MasterProperties --> BFWFlow-->Air Components --> Mol Fraction --> Ar)
												TreeNode childNode3 = new TreeNode(lrrLkUpProp.Name);
												
												foreach(LRRMode mode in LRRModel.ProjectModes)
												{
													try
													{
														string  gpID = LRRModel.SiteComponentGroupPropertiesObj.GetSiteGroupPropID(scp.GetID(),lrrLkUpProp.LookUpPropertiesID);
														TreeNode modeNode = new TreeNode(mode.ModeName);
                                                        List<IPropertyValue> propValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValuesFromGrpPropIdAndLkupQualId(gpID, lrrLkUpQual.LookUpQualifierID);
														if(propValues != null)
														{
															foreach(LRRSiteGroupPropertyQualifierValue propValue in propValues)
															{
																if(propValue.ModeID == mode.ModeId)
																{
																	modeNode.Tag = propValue;
																	break;
																}
															}
														}
														childNode3.Nodes.Add(modeNode);
													}
													catch
													{
													}
										
												}

												childNode2.Nodes.Add(childNode3);
											}
										}
									}
									else
									{
										//Get the Group properties
										LRRLookUpProperties lrrLkUpProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(lrrPropType.ID);
										IEnumerator iLkUpPropEnum = lrrLkUpProps.GetEnumerator();
										while(iLkUpPropEnum.MoveNext())
										{
											LRRLookUpProperty lrrLkUpProp = iLkUpPropEnum.Current as LRRLookUpProperty;
									
											//Grp Property Node (MasterProperties --> BFWFlow-->Air Components --> C00)
											TreeNode childNode2 = new TreeNode(lrrLkUpProp.Name);

											foreach(LRRMode mode in LRRModel.ProjectModes)
											{
												try
												{
													string  gpID = LRRModel.SiteComponentGroupPropertiesObj.GetSiteGroupPropID(scp.GetID(),lrrLkUpProp.LookUpPropertiesID);
													TreeNode modeNode = new TreeNode(mode.ModeName);
                                                    List<IPropertyValue> propValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValuesFromGrpPropIdAndLkupQualId(gpID, null);
													if(propValues != null)
													{
														foreach(LRRSiteGroupPropertyQualifierValue propValue in propValues)
														{
															if(propValue.ModeID == mode.ModeId)
															{
																modeNode.Tag = propValue;
																break;
															}
														}
													}
													childNode2.Nodes.Add(modeNode);
												}
												catch
												{
												}
										
											}

											childNode1.Nodes.Add(childNode2);
										}
									}
								}
							}
						}

						LRRSiteComponentProperties lrrSiteCompProps = lrrSiteComp.Properties.FilterPropertiesByPropertyID(null);
						IEnumerator iSitePropEnum = lrrSiteCompProps.GetEnumerator();
						while(iSitePropEnum.MoveNext())
						{
							LRRSiteComponentProperty lrrSiteCompProp = iSitePropEnum.Current as LRRSiteComponentProperty;

							//Create Site Comp Property Node
							TreeNode siteCompPropNode = new TreeNode(lrrSiteCompProp.Name);

							siteCompNode.Nodes.Add(siteCompPropNode);
							foreach(LRRMode mode in LRRModel.ProjectModes)
							{
								try
								{
									TreeNode modeNode = new TreeNode(mode.ModeName);
                                    List<IPropertyValue> propValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(lrrSiteCompProp.ID);
									if(propValues != null)
									{
                                        for (int i = 0; i < propValues.Count; i++)
                                        {
                                            LRRSiteComponentPropertyValue propValue = propValues[i] as LRRSiteComponentPropertyValue;
                                            if (propValue.ModeID == mode.ModeId)
                                            {
                                                modeNode.Tag = propValue;
                                                break;
                                            }
                                            
                                        }
									}
									siteCompPropNode.Nodes.Add(modeNode);
								}
								catch
								{

								}
							}
						}
				
						//Master Properties

						/*LRRMasterProperties lrrMasterProps = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByType(lrrMasterComp.ID);
						TreeNode masterNode = null;
						if(lrrMasterProps.Count > 0)
						{
							masterNode = new TreeNode("Master Properties");
							masterCompNode.Nodes.Add(masterNode);
						}
						IEnumerator iPropTypeEnum = _lrrPropertyTypes.GetEnumerator();
						while(iPropTypeEnum.MoveNext())
						{
							LRRPropertyType lrrPropType = iPropTypeEnum.Current as LRRPropertyType;

							LRRMasterProperties lrrMasterProperties = lrrMasterProps.GetMasterPropertiesByPropType(lrrPropType.ID);
							IEnumerator iMasterPropEnum = lrrMasterProperties.GetEnumerator();
							while(iMasterPropEnum.MoveNext())
							{
								LRRMasterProperty lrrMasterProp = iMasterPropEnum.Current as LRRMasterProperty;

								//Create Master Property Node(MasterProperties --> BFWFlow)
								if(lrrMasterProp.Type == "1")
								{
									TreeNode masterPropNode = new TreeNode(lrrMasterProp.Name);
	
									masterNode.Nodes.Add(masterPropNode);
									foreach(LRRMode mode in LRRModel.ProjectModes)
									{
										TreeNode modeNode = new TreeNode(mode.ModeName);
										LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(lrrSiteComp.ID,lrrMasterProp.PropID);
										LRRSiteComponentPropertyValues propValues = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(scp.ID);
										if(propValues != null)
										{
											foreach(LRRSiteComponentPropertyValue propValue in propValues)
											{
												if(propValue.ModeID == mode.ModeId)
												{
													modeNode.Tag = propValue;
													break;
												}
											}
										}
										masterPropNode.Nodes.Add(modeNode);
									}
								}*/

						//Check if Property is Simple
						/*if(lrrMasterProp.Type != "1")
								{
									//Property Type Node (MasterProperties --> BFWFlow-->Air Components)
									TreeNode childNode1 = new TreeNode(lrrMasterProp.Name + "-" + lrrPropType.PropertyType);
									masterNode.Nodes.Add(childNode1);
							
									//Check for Data Array
									if(!lrrPropType.IsDataArray)
									{
										LRRLookUpQualifiers lrrLkUpQuals = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lrrPropType.ID);
										IEnumerator iLkUpEnum = lrrLkUpQuals.GetEnumerator();
										while(iLkUpEnum.MoveNext())
										{
											LRRLookUpQualifier lrrLkUpQual = iLkUpEnum.Current as LRRLookUpQualifier;
											LRRQualifier qual = LRRModel.Qualifiers.getQualifierObjectForQualifierID(lrrLkUpQual.QualifierID);

											//Qualifier Node (MasterProperties --> BFWFlow-->Air Components --> Mol Fraction)
											TreeNode childNode2 = new TreeNode(qual.Name);
											childNode1.Nodes.Add(childNode2);

											//Get the Group properties
											LRRLookUpProperties lrrLkUpProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(lrrPropType.ID);
											IEnumerator iLkUpPropEnum = lrrLkUpProps.GetEnumerator();
											while(iLkUpPropEnum.MoveNext())
											{
												LRRLookUpProperty lrrLkUpProp = iLkUpPropEnum.Current as LRRLookUpProperty;
									
												//Grp Property Node (MasterProperties --> BFWFlow-->Air Components --> Mol Fraction --> Ar)
												TreeNode childNode3 = new TreeNode(lrrLkUpProp.Name);
											
												SearchCriteria criteria = new SearchCriteria();
												criteria.ObjType = typeof(LRRSiteGroupPropertyQualifierValue);
												ArrayList arrConditions = new ArrayList();
												SearchCondition condition1 = GetConditionObj("LookUpPropertiesID",lrrLkUpProp.LookUpPropertiesID,"=");
												arrConditions.Add(condition1);
												SearchCondition condition2 = GetConditionObj("LookUpQualifierID",lrrLkUpQual.LookUpQualifierID,"=");
												arrConditions.Add(condition2);
												SearchCondition condition3 = GetConditionObj("MasterPropID",lrrMasterProp.PropID,"=");
												arrConditions.Add(condition3);

												criteria.ArrListSearchCondition = arrConditions;
												childNode3.Tag = criteria;
												childNode2.Nodes.Add(childNode3);
											}
										}
									}
									else
									{
										//Get the Group properties
										LRRLookUpProperties lrrLkUpProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(lrrPropType.ID);
										IEnumerator iLkUpPropEnum = lrrLkUpProps.GetEnumerator();
										while(iLkUpPropEnum.MoveNext())
										{
											LRRLookUpProperty lrrLkUpProp = iLkUpPropEnum.Current as LRRLookUpProperty;
									
											//Grp Property Node (MasterProperties --> BFWFlow-->Air Components --> C00)
											TreeNode childNode2 = new TreeNode(lrrLkUpProp.Name);

											SearchCriteria criteria = new SearchCriteria();
											criteria.ObjType = typeof(LRRSiteGroupPropertyQualifierValue);
											ArrayList arrConditions = new ArrayList();
											SearchCondition condition1 = GetConditionObj("LookUpPropertiesID",lrrLkUpProp.LookUpPropertiesID,"=");
											arrConditions.Add(condition1);
											SearchCondition condition2 = GetConditionObj("MasterPropID",lrrMasterProp.PropID,"=");
											arrConditions.Add(condition2);

											criteria.ArrListSearchCondition = arrConditions;

											childNode2.Tag = criteria;
											childNode1.Nodes.Add(childNode2);
										}
									}
								}*/
					}
				}
			}
			trvMasterProps.Nodes.Add(root);
			
		}


		#region fields
		private LRRApp _lrrApp;
		private LRRMasterComponents _lrrMasterComps = new LRRMasterComponents();
		private LRRPropertyTypes _lrrPropertyTypes;
		private LRRComponentTypes _lrrCompTypes;
		private ArrayList _arrCollection = new ArrayList();

		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private GridSavedViewController _gridView;
		private Hashtable _htTemplates = new Hashtable();
		private TemplateRows _templateRows = null;
		private LRRMultiAttributeTrendInfo _trendInfo = null;

		#endregion


		private void btnExec_Click(object sender, System.EventArgs e)
		{
			if(_templateRows != null)
			{
				string key = "MultiTrend:" + _trendInfo.Name;
				if(_lrrApp.LRRUIManagerObj._windowStore.ContainsKey(key))
				{
					ILRRUIContainer cont = _lrrApp.LRRUIManagerObj._windowStore[key] as ILRRUIContainer;
					cont.Refresh();
					Form frm = cont as Form;
					frm.Activate();
				}
				else
				{
					object[] obj = new object[2];
					obj[0] = _templateRows;
					obj[1] = _trendInfo;
					_lrrApp.LRRUIManagerObj.ShowWindow(key,typeof(MultiTrend),obj);
				}
//				MultiTrend multiTrendForm = new MultiTrend(_templateRows,_trendInfo);
//				multiTrendForm.Owner = this;
//				multiTrendForm.Show();
			}
		}
		

		private void splitter2_DoubleClick(object sender, System.EventArgs e)
		{
			if(pnlLeft.Visible)
			{
				pnlLeft.Visible = false;
				pnlGrid.Dock = DockStyle.Fill;
				splVertical.Dock = DockStyle.Left;
			}
			else if(!pnlLeft.Visible)
			{
				pnlLeft.Visible = true;
				pnlGrid.Dock = DockStyle.Right;
				splVertical.Dock = DockStyle.Right;
			}
		}
		#region ILRRUIContainer Members

		public void Refresh()
		{
			PopulateComboTemplates();
		}

		public void Save()
		{
            if (comboBoxTemplates.SelectedIndex == -1)
            {
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_TEMPLATE_BLANK_ERROR"));
                return;
            }
			if(textBoxMultiTrendName.Text == "")
			{
                MessageBox.Show(this, LRRHeaderText.GetHeaderString("SID_TREND_NAME_BLANK_ERROR"));
				return;
			}

			LRRMultiAttributeTrendInfos trendInfos = new LRRMultiAttributeTrendInfos();

			LRRMultiAttributeTrendInfo trendInfo = new LRRMultiAttributeTrendInfo();

			_lrrApp.DBManagerObj.PopulateCollection(trendInfos);

			bool found = false;

			foreach(LRRMultiAttributeTrendInfo trendInfoObj in trendInfos)
			{
				if(trendInfoObj.Name == textBoxMultiTrendName.Text)
				{
					
					trendInfo = trendInfoObj;
					found = true;
					break;
				}
			}

			DialogResult dlgRes = DialogResult.Yes;
			if(found)
			{
				dlgRes =  MessageBox.Show(this,LRRHeaderText.GetHeaderString("SID_TREND_EXISTS_ERROR"),LRRHeaderText.GetHeaderString("SID_WARNING"),MessageBoxButtons.YesNo);
			}

            if (dlgRes == DialogResult.Yes)
            {
                LRRTrendTemplate trendTemplate = null;
                try
                {
                    trendTemplate = _htTemplates[comboBoxTemplates.SelectedItem.ToString()] as LRRTrendTemplate;
                }
                catch
                {

                }
                if(trendTemplate != null)
                {
                    MemoryStream memoryStream = new MemoryStream(trendTemplate.RowsInfo);
                    XmlSerializer xs = new XmlSerializer(typeof(TemplateRows));
                    TemplateRows templateRows = xs.Deserialize(memoryStream) as TemplateRows;
                    memoryStream.Close();

                    bool isRowEmpty = false;
                    templateRows.TrendSettings[0].SchemeName = "";

                    if (templateRows.IsXYGraph)
                    {
                        bool firstRow = true;
                        foreach (UserControlMultiTrendSelectionRow row in panel2.Controls)
                        {
                            if ((row.labelRowNo.Text == LRRHeaderText.GetHeaderString("SID_X_AXIS") + ":") || (row.labelRowNo.Text == LRRHeaderText.GetHeaderString("SID_Y_AXIS") + ":"))
                            {
                                if (row.labelRowDetails.Tag != null)
                                {
                                    if (firstRow)
                                    {
                                        if (row.labelRowNo.Text == LRRHeaderText.GetHeaderString("SID_X_AXIS") + ":")
                                            templateRows.TrendSettings[0].SchemeName = row.labelRowDetails.Tag.ToString();
                                        else
                                            templateRows.TrendSettings[0].SchemeName += "|" + row.labelRowDetails.Tag.ToString();
                                    }
                                    else
                                    {
                                        if (row.labelRowNo.Text == LRRHeaderText.GetHeaderString("SID_X_AXIS") + ":")
                                            templateRows.TrendSettings[0].SchemeName = row.labelRowDetails.Tag.ToString() + templateRows.TrendSettings[0].SchemeName;
                                        else
                                            templateRows.TrendSettings[0].SchemeName = "|" + row.labelRowDetails.Tag.ToString();
                                    }

                                }
                                else
                                {
                                    isRowEmpty = true;
                                }
                            }
                            firstRow = false;
                        }
                    }
                    else
                    {
                        for (int i = 0; i < trendTemplate.NoOfRows; i++)
                        {
                            foreach (UserControlMultiTrendSelectionRow row in panel2.Controls)
                            {
                                if (row.labelRowNo.Text == "Row " + (i + 1).ToString() + ":")
                                {
                                    if (row.labelRowDetails.Tag != null)
                                    {
                                        templateRows.TrendSettings[i].SchemeName = row.labelRowDetails.Tag.ToString();
                                    }
                                    else
                                    {
                                        isRowEmpty = true;
                                    }
                                    break;
                                }
                            }
                            if (isRowEmpty)
                                break;
                        }
                    }

                    if (isRowEmpty)
                    {
                        MessageBox.Show(this, LRRHeaderText.GetHeaderString("TREND_ROW_UNASSIGNED_ERROR"), LRRHeaderText.GetHeaderString("SID_ERROR"));
                        return;
                    }


                    trendInfo.TemplateID = trendTemplate.ID;
                    trendInfo.Name = textBoxMultiTrendName.Text;

                    memoryStream = new MemoryStream();
                    xs = new XmlSerializer(typeof(TemplateRows));
                    XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);

                    xs.Serialize(xmlTextWriter, templateRows);
                    memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
                    byte[] buffer = memoryStream.ToArray();

                    trendInfo.TrendInfo = buffer;

                    _templateRows = templateRows;
                    _trendInfo = trendInfo;

                    if (found)
                    {
                        trendInfo.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                        _lrrApp.DBManagerObj.CommitObject(trendInfo);
                        trendInfo.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                    }
                    _lrrApp.DBManagerObj.CommitObject(trendInfo);
                    LRRMessagBox.ShowMessage("SID_SAVEDINFO", true);
                }
            }
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add SavedViewForm.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add SavedViewForm.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add SavedViewForm.Copy implementation
		}

		public void Print()
		{
			if(_gridView != null)
			{
				_gridView.Print();
			}
		}

		public void PrintPreview()
		{
			if(_gridView != null)
			{
				_gridView.PrintPreview();
			}
		}

		public void PageSetup()
		{
			GridControlPrint gcPrint = new GridControlPrint();
			gcPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add SavedViewForm.Undo implementation
		}

		public void Delete()
		{
			// TODO:  Add SavedViewForm.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add SavedViewForm.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add SavedViewForm.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add SavedViewForm.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add SavedViewForm.ImportToExcel implementation
		}

		public void Export()
		{
			
		}

		public void SelectionPaste()
		{
			// TODO:  Add SavedViewForm.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add SavedViewForm.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add SavedViewForm.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add SavedViewForm.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add SavedViewForm.DownLevel implementation
		}

		public void ClearSort()
		{
			// TODO:  Add SavedViewForm.ClearSort implementation
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add SavedViewForm.CopyUOMTypes implementation
		}

		public void ShowPropertyList()
		{
			// TODO:  Add SavedViewForm.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add SavedViewForm.ShowComponentList implementation
		}

		public void LeftColMovement()
		{
			// TODO:  Add SavedViewForm.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add SavedViewForm.RightColMovement implementation
		}

		public void OpenCompositeView()
		{
			// TODO:  Add SavedViewForm.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add SavedViewForm.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add SavedViewForm.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add SavedViewForm.OpenView implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add SavedViewForm.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add SavedViewForm.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add SavedViewForm.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add SavedViewForm.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			return true;
		}

		public bool SupportsRefresh()
		{
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add SavedViewForm.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add SavedViewForm.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add SavedViewForm.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add SavedViewForm.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add SavedViewForm.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add SavedViewForm.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add SavedViewForm.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add SavedViewForm.SupportsLevel implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add SavedViewForm.SupportsClearSort implementation
			return false;
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add SavedViewForm.SupportsCopyUOMTypes implementation
			return false;
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add SavedViewForm.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add SavedViewForm.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add SavedViewForm.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add SavedViewForm.SupportsUndo implementation
			return false;
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		public bool PerformDirtyChk
		{
			get
			{
				return true;
			}
		}

		#endregion

		IPropertyValue _propVal = null;
		private void trvMasterProps_AfterSelect(object sender, TreeViewEventArgs e)
		{
			try
			{
				object objTag = e.Node.Tag;
				if(objTag is LRRSiteComponentPropertyValue || objTag is LRRSiteGroupPropertyQualifierValue)
				{
					_propVal = objTag as IPropertyValue;
				}
				else
				{
					_propVal = null;
				}
			}
			catch
			{
				_propVal = null;
			}
		}

		private void comboBoxTemplates_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			LRRTrendTemplate trendTemplate = _htTemplates[comboBoxTemplates.SelectedItem.ToString()] as LRRTrendTemplate;
			panel2.Controls.Clear();
            
            MemoryStream memoryStream = new MemoryStream(trendTemplate.RowsInfo);
            XmlSerializer xs = new XmlSerializer(typeof(TemplateRows));
            TemplateRows templateRows = xs.Deserialize(memoryStream) as TemplateRows;
            memoryStream.Close();

            if (templateRows.IsXYGraph)
            {
                UserControlMultiTrendSelectionRow trendRow = new UserControlMultiTrendSelectionRow();
                trendRow.labelRowNo.Text = LRRHeaderText.GetHeaderString("SID_Y_AXIS") + ":";
                trendRow.buttonAdd.Click += new EventHandler(buttonAdd_Click);
                trendRow.Dock = DockStyle.Top;
                panel2.Controls.Add(trendRow);
                trendRow.Tag = "XY Graph";

                trendRow = new UserControlMultiTrendSelectionRow();
                trendRow.labelRowNo.Text = LRRHeaderText.GetHeaderString("SID_X_AXIS") + ":";
                trendRow.buttonAdd.Click += new EventHandler(buttonAdd_Click);
                trendRow.Dock = DockStyle.Top;
                panel2.Controls.Add(trendRow);
                trendRow.Tag = "XY Graph";
            }
            else
            {
                int noOfRows = trendTemplate.NoOfRows;
                for (int i = noOfRows - 1; i >= 0; i--)
                {
                    UserControlMultiTrendSelectionRow trendRow = new UserControlMultiTrendSelectionRow();
                    trendRow.labelRowNo.Text = "Row " + (i + 1).ToString() + ":";
                    trendRow.buttonAdd.Click += new EventHandler(buttonAdd_Click);
                    trendRow.Dock = DockStyle.Top;
                    panel2.Controls.Add(trendRow);
                }
            }
		}

		private void buttonAdd_Click(object sender, EventArgs e)
		{
			try
			{
				Button button = sender as Button;
				UserControlMultiTrendSelectionRow trendRow = button.Parent as UserControlMultiTrendSelectionRow;
				if(_propVal != null)
				{
					if(_propVal is LRRSiteComponentPropertyValue)
					{
						string propertyID = _propVal.GetPropertyID();
						string modeID = _propVal.GetModeID();
						LRRSiteComponentProperty prop = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propertyID);
						string compID = prop.ComponentID;
						LRRSiteComponent comp = LRRModel.SiteComponentsObj.GetSiteComponentByID(compID);
						LRRMode mode = LRRModel.Modes.GetModeByID(modeID);

						trendRow.labelRowDetails.Text = comp.Name + ":" + prop.Name + ":" + mode.ModeName;
						trendRow.labelRowDetails.Tag = _propVal.GetID();
					}
					else if(_propVal is LRRSiteGroupPropertyQualifierValue)
					{
						LRRSiteGroupPropertyQualifierValue gpqv = _propVal as LRRSiteGroupPropertyQualifierValue;
						trendRow.labelRowDetails.Text = LRRModel.ChildModel.Modes.GetModeByID(_propVal.GetModeID()).ModeName + ":" + LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(gpqv.MasterPropID).Name;
						if(gpqv.QualifierID != null)
						{
							trendRow.labelRowDetails.Text += ":" + LRRModel.Qualifiers.getQualifierObjectForQualifierID(gpqv.QualifierID).Name;
						}
						trendRow.labelRowDetails.Text+= ":" + LRRModel.ChildModel.LookUpProperties.getLookUpPropertyForLkupPropID(gpqv.LookUpPropertiesID).Name;
						trendRow.labelRowDetails.Tag = _propVal.GetID();
					}
				}
			}
			catch
			{

			}
		}
	}
}

