using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;

using Symcon.LightRidge.PEAdvisor.GridUtilities;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for OptionalInput.
	/// </summary>
	public class OptionalInput : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlOperation;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel pnlHistorianData;
		private System.Windows.Forms.Label lblHistorianData;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridHistorianData;
		private System.Windows.Forms.ComboBox cmbComponents;
		private System.Windows.Forms.Label lblSelectItem;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OptionalInput()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Get the App Object
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			_lrrHistData = new LRRHistDatas();

			//_app.DBManagerObj.PopulateCollection(_lrrHistData);
			//_lrrHistData = _app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRHistDatas)) as LRRHistDatas;
			//Populate from Model
			_lrrHistData = LRRModel.HistDatas;

			
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(OptionalInput));
			this.pnlOperation = new System.Windows.Forms.Panel();
			this.btnSave = new System.Windows.Forms.Button();
			this.btnClose = new System.Windows.Forms.Button();
			this.btnSearch = new System.Windows.Forms.Button();
			this.panel2 = new System.Windows.Forms.Panel();
			this.lblSelectItem = new System.Windows.Forms.Label();
			this.cmbComponents = new System.Windows.Forms.ComboBox();
			this.pnlHistorianData = new System.Windows.Forms.Panel();
			this.gridHistorianData = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.lblHistorianData = new System.Windows.Forms.Label();
			this.pnlOperation.SuspendLayout();
			this.panel2.SuspendLayout();
			this.pnlHistorianData.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridHistorianData)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlOperation
			// 
			this.pnlOperation.Controls.Add(this.btnSave);
			this.pnlOperation.Controls.Add(this.btnClose);
			this.pnlOperation.Controls.Add(this.btnSearch);
			this.pnlOperation.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlOperation.Location = new System.Drawing.Point(0, 262);
			this.pnlOperation.Name = "pnlOperation";
			this.pnlOperation.Size = new System.Drawing.Size(632, 40);
			this.pnlOperation.TabIndex = 17;
			// 
			// btnSave
			// 
			this.btnSave.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSave.Location = new System.Drawing.Point(480, 8);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(72, 24);
			this.btnSave.TabIndex = 14;
			this.btnSave.Text = "&Save";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// btnClose
			// 
			this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnClose.Location = new System.Drawing.Point(560, 8);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(72, 24);
			this.btnClose.TabIndex = 13;
			this.btnClose.Text = "&Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// btnSearch
			// 
			this.btnSearch.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSearch.Location = new System.Drawing.Point(400, 8);
			this.btnSearch.Name = "btnSearch";
			this.btnSearch.Size = new System.Drawing.Size(72, 24);
			this.btnSearch.TabIndex = 12;
			this.btnSearch.Text = "Fi&lter";
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.lblSelectItem);
			this.panel2.Controls.Add(this.cmbComponents);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(632, 24);
			this.panel2.TabIndex = 18;
			// 
			// lblSelectItem
			// 
			this.lblSelectItem.ForeColor = System.Drawing.Color.Red;
			this.lblSelectItem.Location = new System.Drawing.Point(0, 0);
			this.lblSelectItem.Name = "lblSelectItem";
			this.lblSelectItem.Size = new System.Drawing.Size(64, 23);
			this.lblSelectItem.TabIndex = 14;
			this.lblSelectItem.Text = "Select Item";
			this.lblSelectItem.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cmbComponents
			// 
			this.cmbComponents.Location = new System.Drawing.Point(64, 2);
			this.cmbComponents.Name = "cmbComponents";
			this.cmbComponents.Size = new System.Drawing.Size(112, 21);
			this.cmbComponents.TabIndex = 6;
			// 
			// pnlHistorianData
			// 
			this.pnlHistorianData.Controls.Add(this.gridHistorianData);
			this.pnlHistorianData.Controls.Add(this.lblHistorianData);
			this.pnlHistorianData.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlHistorianData.Location = new System.Drawing.Point(0, 24);
			this.pnlHistorianData.Name = "pnlHistorianData";
			this.pnlHistorianData.Size = new System.Drawing.Size(632, 238);
			this.pnlHistorianData.TabIndex = 19;
			// 
			// gridHistorianData
			// 
			this.gridHistorianData.AllowDragSelectedCols = true;
			this.gridHistorianData.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridHistorianData.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridHistorianData.Location = new System.Drawing.Point(0, 24);
			this.gridHistorianData.Name = "gridHistorianData";
			this.gridHistorianData.OptimizeInsertRemoveCells = true;
			this.gridHistorianData.Properties.BackgroundColor = System.Drawing.SystemColors.ControlLightLight;
			this.gridHistorianData.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridHistorianData.Size = new System.Drawing.Size(632, 214);
			this.gridHistorianData.SmartSizeBox = false;
			this.gridHistorianData.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridHistorianData.TabIndex = 4;
			this.gridHistorianData.Text = "gridDataBoundGrid1";
			this.gridHistorianData.UseListChangedEvent = true;
			// 
			// lblHistorianData
			// 
			this.lblHistorianData.BackColor = System.Drawing.SystemColors.ControlDark;
			this.lblHistorianData.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblHistorianData.Dock = System.Windows.Forms.DockStyle.Top;
			this.lblHistorianData.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblHistorianData.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(0)), ((System.Byte)(0)));
			this.lblHistorianData.Location = new System.Drawing.Point(0, 0);
			this.lblHistorianData.Name = "lblHistorianData";
			this.lblHistorianData.Size = new System.Drawing.Size(632, 24);
			this.lblHistorianData.TabIndex = 3;
			this.lblHistorianData.Text = "Total Plant Historian Data ";
			this.lblHistorianData.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// OptionalInput
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 302);
			this.Controls.Add(this.pnlHistorianData);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.pnlOperation);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "OptionalInput";
			this.Text = "Optional Input";
			this.Load += new System.EventHandler(this.OptionalInput_Load);
			this.pnlOperation.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.pnlHistorianData.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridHistorianData)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
		
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
		
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
		
		}

		private void OptionalInput_Load(object sender, System.EventArgs e)
		{

			InitializeGridWithData();			
		
		}

		#region Private Methods

		/// <summary>
		/// Method used to initialize the grid with the data from the Historian...
		/// </summary>
		private void InitializeGridWithData()
		{

			SyncGridUtilities.InitializeGridColumns(gridHistorianData,_lrrHistData.ItemType,null);

			gridHistorianData.DataSource = _lrrHistData;

			SyncGridUtilities.SetFilterHeader(gridHistorianData);
			
		}

		#endregion

		#region Fields

		private LRRHistDatas					_lrrHistData; //Local Storage for Data Historian acting as datasource
		private LRRApp							_app; //App Instance...
		#endregion
	}
}
