using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools;
using Symcon.LightRidge.PEAdvisor;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using System.Diagnostics;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for OverrideHistMapping.
	/// </summary>
	public class OverrideHistMapping : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.Panel panelHistMapping;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panelProperty;
		private System.Windows.Forms.Panel panelHistData;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridComponentProperties;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridHistTags;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridComponentHistMapping;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar xpToolBar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemMap;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSave;
		private System.Windows.Forms.ImageList imageList2;
		private System.ComponentModel.IContainer components;

		public OverrideHistMapping(LRRHistPropCompPropMapping histPropCompMapping)
		{
			//
			// Required for Windows Form Designer support
			//
			_lrrapp	= AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_histPropCompMapping = histPropCompMapping;
			InitializeComponent();
			SetActiveMapping(histPropCompMapping.MappingId);  
			_lrrSiteCompPpties = LRRModel.SiteComponentPropertiesObj; 
			BindGrids(_histPropCompMapping);
			this.barItemMap.Click+=new EventHandler(barItemMap_Click);  
			this.barItemSave.Click+=new EventHandler(barItemSave_Click);
            //this.Parent = _lrrapp.MainFrame;
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		#region Fields
		
		private LRRHistDatas							_lrrHist;
		private LRRSiteComponentGroupProperties			_siteCompGroupedProperties;
		private LRRSiteGroupPropertyQualifierValues		_siteGroupPropertyQualifierValues;
		private	LRRSiteComponentProperties				_lrrSiteCompPpties;
		private	LRRSiteGroupPropertyQualifierValues		_lrrSiteCompGrpQualifierValues;
		private LRRHistPropCompPropMapping				_histPropCompMapping;
		private GridUnBoundColumn						_unBound = new GridUnBoundColumn();
		private	LRRApp									_lrrapp;
		private LRROverrideHistMappings					overrideHistPropMappings;
		private LRROverrideHistMappings					overridHistMappingModelObject = LRRModel.OverrideHistPropMaps; 
		private LRRPlantItemProperties							propertiesObj;
		private LRROverrideHistMappings							overrideMappings ;
		private	LRRSiteComponent						selectedSiteComponent = null;
		private	LRRSiteComponentProperty				selectedSiteComponentPpty = null;
		private LRROverrideHistMapping					activeHistMapping;
		LRROverrideHistMapping							defaultMapObject;
        //ToolTip											tooltip = new ToolTip();
		private bool									isActiveChanged = false;

		
	
		
		#endregion




		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void BindGrids(LRRHistPropCompPropMapping histPropComPropObj)
		{
			#region HistData

			_lrrHist = LRRModel.HistDatas;
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridComponentProperties);
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridComponentHistMapping);
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridHistTags);
			gridHistTags.TableDescriptor.Columns.Clear();
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_HISTTAG"),"HistTag");
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_GENERAL_DESC"),"GeneralDesc");
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_COMMENTS"),"Comments");
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE"),"DisplayInterfaceValue");
			gridHistTags.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_HISTTAG")].AllowFilter	= true;
			gridHistTags.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_GENERAL_DESC")].AllowFilter	= true;
			gridHistTags.TopLevelGroupOptions.CaptionText =	LRRHeaderText.GetHeaderString("SID_HISTTAG")+ ":" + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEM"); 
			gridHistTags.DataSource	= _lrrHist;

			#endregion

			#region Properties

			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridComponentProperties);
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridComponentHistMapping);
			gridComponentProperties.TableDescriptor.Columns.Clear();
			gridComponentProperties.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME"),"Name");
			gridComponentProperties.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_ATTRIBUTEDESC"),"Description");
			gridComponentProperties.TableOptions.AllowDropDownCell = true;
			gridComponentProperties.TopLevelGroupOptions.CaptionText =	 " {RecordCount} Items"; 
			//gridComponentProperties.TableControl.ActivateToolTip+=new GridActivateToolTipEventHandler(TableControl_ActivateToolTip);   
			propertiesObj= new LRRPlantItemProperties();
			if(_histPropCompMapping.GroupPropertyID == null)
			{
				string propertyID = _histPropCompMapping.SiteComponentPropID;
				LRRSiteComponentProperty siteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propertyID);
				LRRPlantItemProperty propertyObj=new LRRPlantItemProperty();
				propertyObj.ID=siteCompProp.ID;
				propertyObj.PropertyID=siteCompProp.ID;
				propertyObj.Name=siteCompProp.Name;
				propertyObj.Description=siteCompProp.Description;
				propertiesObj.Add(propertyObj);
			}
			else
			{
				string groupPropertyID = _histPropCompMapping.GroupPropertyID;
				LRRSiteComponentGroupProperty gProp = LRRModel.SiteComponentGroupPropertiesObj.GetSiteCompGroupPropFromID(groupPropertyID);
				LRRSiteGroupPropertyQualifierValue gPropValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(_histPropCompMapping.GroupPropertyValID);
				LRRPlantItemProperty propertyObj1=new LRRPlantItemProperty();
				propertyObj1.ID = gPropValue.SiteGroupPropertyQualifierValueID /*gProp.SiteComponentPropID*/;
				propertyObj1.PropertyID=gProp.SiteComponentPropID;
				propertyObj1.GroupPropertyID=gProp.GroupPropertyID;
				propertyObj1.SiteGroupPropertyQualifierValueID = gPropValue.SiteGroupPropertyQualifierValueID;
				propertyObj1.Name= _histPropCompMapping.ComponentPropertyName;
				propertyObj1.Description=gProp.AttributeDescription;
				propertyObj1.LookupQualifierID = gPropValue.LookUpQualifierID;
				propertyObj1.LookupPropertiesID = gPropValue.LookUpPropertiesID;
				propertiesObj.Add(propertyObj1);
			}
			gridComponentProperties.DataSource = propertiesObj;
			
			#endregion

			#region OverrideMapping
			
			overrideHistPropMappings = overridHistMappingModelObject.GetOverrideMappingsFromHistPropMappingID(_histPropCompMapping.MappingId);
			foreach(LRROverrideHistMapping ovHistMap in overrideHistPropMappings)
			{
				if(ovHistMap.GroupPropertyValID != null && ovHistMap.GroupPropertyValID != "")
				{
					//Get Previous Object State..
					Symcon.Globals.Enums.DBOperation previousObjectState = ovHistMap.ObjectState;
					ovHistMap.SiteComponentPropID = ovHistMap.GroupPropertyValID;
					//assign the previous object state...
					ovHistMap.ObjectState = previousObjectState;
				}
			}
			//Default Mapping add to Collection
			LRROverrideHistMapping defaultMapObj = overridHistMappingModelObject.GetDefaultMapping(_histPropCompMapping.MappingId);
			if(defaultMapObj == null)
			{
				AddDefaultMapObject();
			}
			gridComponentHistMapping.DataSource = null;
			gridComponentHistMapping.DataSource = overrideHistPropMappings;
			gridComponentHistMapping.TableDescriptor.Relations.Clear();
			gridComponentHistMapping.TableDescriptor.Columns.Clear();
			gridComponentHistMapping.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME"),"SiteComponentPropID");
			if(gridComponentHistMapping.TableDescriptor.Columns[0].Name == LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME"))
			{
				gridComponentHistMapping.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
				GridTableCellStyleInfo gtc = gridComponentHistMapping.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell;
				gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
				gtc.ReadOnly = true;
				gtc.DisplayMember =	"Name";
				gtc.ValueMember	= "ID";
				gtc.DataSource=propertiesObj;
				gtc.AutoSize=true;
			}
			gridComponentHistMapping.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_HISTTAG"),"HistPropID");
			//gridComponentHistMapping.TableControl.ActivateToolTip+=new GridActivateToolTipEventHandler(TableControl_ActivateToolTip);
			if(gridComponentHistMapping.TableDescriptor.Columns[1].Name	== LRRHeaderText.GetHeaderString("SID_HISTTAG"))
			{
				gridComponentHistMapping.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
				GridTableCellStyleInfo gtc = gridComponentHistMapping.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell;
				gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
				gtc.ReadOnly = true;
				gtc.DisplayMember =	"HistTag";
				gtc.ValueMember	= "HistTagUID";
				gtc.ReadOnly = true;
				gtc.DataSource = _lrrHist;
				gtc.AutoSize=true;
			}

			GridColumnDescriptor gcd = new GridColumnDescriptor();
			gcd.HeaderText = LRRHeaderText.GetHeaderString("SID_EFFECTIVEPLANTTIME");
			gcd.MappingName	= "EffectivePlantTime";
			GridTableCellStyleInfo style = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);

			style.CellType	= "MonthCalendar";
			style.CellValueType	= DateTime.Now.GetType();
			style.Format = Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT;
			gridComponentHistMapping.TableDescriptor.Columns.Add(gcd);

			gridComponentHistMapping.TableDescriptor.AllowEdit=true;
			gridComponentHistMapping.TableDescriptor.AllowRemove = true;
			gridComponentHistMapping.TopLevelGroupOptions.ShowFilterBar	= true;
			gridComponentHistMapping.NestedTableGroupOptions.ShowFilterBar = true;
			gridComponentHistMapping.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME")].AllowFilter	= true;
			gridComponentHistMapping.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_HISTTAG")].AllowFilter	= true;
			gridComponentHistMapping.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_HISTTAG")].AllowGroupByColumn = false;
			gridComponentHistMapping.TableDescriptor.Columns["EffectivePlantTime"].AllowGroupByColumn = false;

			gridComponentHistMapping.TableDescriptor.SortedColumns.Clear();
			gridComponentHistMapping.TableDescriptor.SortedColumns.Add("SiteComponentPropID");
			gridComponentHistMapping.TableDescriptor.SortedColumns.Add("EffectivePlantTime");

			gridComponentHistMapping.TableDescriptor.Appearance.GroupCaptionSummaryCell.BackColor = Color.Orange;
			gridComponentHistMapping.TableDescriptor.Appearance.GroupCaptionSummaryCell.TextColor = Color.White;

			_unBound.WireGrid(gridComponentHistMapping);  

			for(int i=0;i<gridComponentHistMapping.TableDescriptor.Columns.Count;i++)
			{
				if(gridComponentHistMapping.TableDescriptor.Columns[i].Name	== LRRHeaderText.GetHeaderString("SID_SELECT"))
				{
					gridComponentHistMapping.TableDescriptor.Columns[i].HeaderText = "IsActive";
					break;
				}
			}
			#endregion
		}

		
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(OverrideHistMapping));
            this.panelHistMapping = new System.Windows.Forms.Panel();
            this.gridComponentHistMapping = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.panelProperty = new System.Windows.Forms.Panel();
            this.xpToolBar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar();
            this.barItemMap = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.imageList2 = new System.Windows.Forms.ImageList(this.components);
            this.barItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.gridComponentProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.panelHistData = new System.Windows.Forms.Panel();
            this.gridHistTags = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.panel1 = new System.Windows.Forms.Panel();
            this.panelHistMapping.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridComponentHistMapping)).BeginInit();
            this.panelProperty.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridComponentProperties)).BeginInit();
            this.panelHistData.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridHistTags)).BeginInit();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // panelHistMapping
            // 
            this.panelHistMapping.Controls.Add(this.gridComponentHistMapping);
            this.panelHistMapping.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panelHistMapping.Location = new System.Drawing.Point(0, 318);
            this.panelHistMapping.Name = "panelHistMapping";
            this.panelHistMapping.Size = new System.Drawing.Size(592, 248);
            this.panelHistMapping.TabIndex = 0;
            // 
            // gridComponentHistMapping
            // 
            this.gridComponentHistMapping.BackColor = System.Drawing.SystemColors.Window;
            this.gridComponentHistMapping.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridComponentHistMapping.Location = new System.Drawing.Point(0, 0);
            this.gridComponentHistMapping.Name = "gridComponentHistMapping";
            this.gridComponentHistMapping.Size = new System.Drawing.Size(592, 248);
            this.gridComponentHistMapping.TabIndex = 1;
            this.gridComponentHistMapping.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
            this.gridComponentHistMapping.Text = "gridGroupingControl3";
            this.gridComponentHistMapping.VersionInfo = "3.301.0.0";
            this.gridComponentHistMapping.TableControlCurrentCellChanging += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridComponentHistMapping_TableControlCurrentCellChanging);
            this.gridComponentHistMapping.TableControlCurrentCellChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.gridComponentHistMapping_TableControlCurrentCellChanged);
            this.gridComponentHistMapping.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridComponentHistMapping_QueryCellStyleInfo);
            this.gridComponentHistMapping.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridComponentHistMapping_RecordDeleting);
            // 
            // splitter1
            // 
            this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter1.Location = new System.Drawing.Point(0, 315);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(592, 3);
            this.splitter1.TabIndex = 1;
            this.splitter1.TabStop = false;
            // 
            // panelProperty
            // 
            this.panelProperty.Controls.Add(this.xpToolBar1);
            this.panelProperty.Dock = System.Windows.Forms.DockStyle.Top;
            this.panelProperty.Location = new System.Drawing.Point(0, 0);
            this.panelProperty.Name = "panelProperty";
            this.panelProperty.Size = new System.Drawing.Size(592, 24);
            this.panelProperty.TabIndex = 2;
            // 
            // xpToolBar1
            // 
            this.xpToolBar1.Dock = System.Windows.Forms.DockStyle.Top;
            this.xpToolBar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItemMap,
            this.barItemSave});
            this.xpToolBar1.Location = new System.Drawing.Point(0, 0);
            this.xpToolBar1.Name = "xpToolBar1";
            this.xpToolBar1.Size = new System.Drawing.Size(592, 25);
            this.xpToolBar1.TabIndex = 0;
            this.xpToolBar1.Text = "xpToolBar1";
            // 
            // barItemMap
            // 
            this.barItemMap.CategoryIndex = -1;
            this.barItemMap.ID = "Map";
            this.barItemMap.ImageIndex = 3;
            this.barItemMap.ImageList = this.imageList2;
            this.barItemMap.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemMap.Text = "Map";
            // 
            // imageList2
            // 
            this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
            this.imageList2.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList2.Images.SetKeyName(0, "");
            this.imageList2.Images.SetKeyName(1, "");
            this.imageList2.Images.SetKeyName(2, "");
            this.imageList2.Images.SetKeyName(3, "");
            this.imageList2.Images.SetKeyName(4, "");
            // 
            // barItemSave
            // 
            this.barItemSave.CategoryIndex = -1;
            this.barItemSave.ID = "Save";
            this.barItemSave.ImageIndex = 4;
            this.barItemSave.ImageList = this.imageList2;
            this.barItemSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemSave.Text = "Save";
            // 
            // gridComponentProperties
            // 
            this.gridComponentProperties.BackColor = System.Drawing.SystemColors.Window;
            this.gridComponentProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridComponentProperties.Location = new System.Drawing.Point(0, 0);
            this.gridComponentProperties.Name = "gridComponentProperties";
            this.gridComponentProperties.Size = new System.Drawing.Size(296, 291);
            this.gridComponentProperties.TabIndex = 1;
            this.gridComponentProperties.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
            this.gridComponentProperties.Text = "gridGroupingControl2";
            this.gridComponentProperties.VersionInfo = "3.301.0.0";
            // 
            // panelHistData
            // 
            this.panelHistData.Controls.Add(this.gridComponentProperties);
            this.panelHistData.Dock = System.Windows.Forms.DockStyle.Left;
            this.panelHistData.Location = new System.Drawing.Point(0, 24);
            this.panelHistData.Name = "panelHistData";
            this.panelHistData.Size = new System.Drawing.Size(296, 291);
            this.panelHistData.TabIndex = 4;
            // 
            // gridHistTags
            // 
            this.gridHistTags.BackColor = System.Drawing.SystemColors.Window;
            this.gridHistTags.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridHistTags.Location = new System.Drawing.Point(0, 0);
            this.gridHistTags.Name = "gridHistTags";
            this.gridHistTags.Size = new System.Drawing.Size(293, 291);
            this.gridHistTags.TabIndex = 0;
            this.gridHistTags.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
            this.gridHistTags.Text = "gridHistTags";
            this.gridHistTags.VersionInfo = "3.301.0.0";
            // 
            // splitter2
            // 
            this.splitter2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.splitter2.Location = new System.Drawing.Point(296, 24);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(3, 291);
            this.splitter2.TabIndex = 5;
            this.splitter2.TabStop = false;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.gridHistTags);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(299, 24);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(293, 291);
            this.panel1.TabIndex = 6;
            // 
            // OverrideHistMapping
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(592, 566);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.splitter2);
            this.Controls.Add(this.panelHistData);
            this.Controls.Add(this.panelProperty);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.panelHistMapping);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MaximumSize = new System.Drawing.Size(600, 600);
            this.Name = "OverrideHistMapping";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "OverrideHistMapping";
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.OverrideHistMapping_FormClosing);
            this.Load += new System.EventHandler(this.OverrideHistMapping_Load);
            this.panelHistMapping.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridComponentHistMapping)).EndInit();
            this.panelProperty.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridComponentProperties)).EndInit();
            this.panelHistData.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridHistTags)).EndInit();
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add OverrideHistMapping.LeftColMovement implementation
		}

		public void ClearSort()
		{
			// TODO:  Add OverrideHistMapping.ClearSort implementation
		}

		public void RightLevel()
		{
			// TODO:  Add OverrideHistMapping.RightLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add OverrideHistMapping.UpLevel implementation
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add OverrideHistMapping.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add OverrideHistMapping.SupportsLevel implementation
			return false;
		}

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add OverrideHistMapping.PerformDirtyChk getter implementation
				return false;
			}
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add OverrideHistMapping.SupportsRefresh implementation
			return false;
		}

		public void Undo()
		{
			// TODO:  Add OverrideHistMapping.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridComponentHistMapping);
            Refresh();
		}

		public bool SupportsCopy()
		{
			// TODO:  Add OverrideHistMapping.SupportsCopy implementation
			return false;
		}

		public void SelectionPaste()
		{
			// TODO:  Add OverrideHistMapping.SelectionPaste implementation
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add OverrideHistMapping.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OverrideHistMapping.ParentTabPage setter implementation
			}
		}

		public void PageSetup()
		{
			// TODO:  Add OverrideHistMapping.PageSetup implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add OverrideHistMapping.OpenQuery implementation
		}

		public void Copy()
		{
			// TODO:  Add OverrideHistMapping.Copy implementation
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add OverrideHistMapping.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add OverrideHistMapping.SupportsPageSetup implementation
			return false;
		}

		public void ShowPropertyList()
		{
			// TODO:  Add OverrideHistMapping.ShowPropertyList implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add OverrideHistMapping.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add OverrideHistMapping.SupportsClearSort implementation
			return false;
		}

		public void RightColMovement()
		{
			// TODO:  Add OverrideHistMapping.RightColMovement implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add OverrideHistMapping.LeftLevel implementation
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add OverrideHistMapping.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add OverrideHistMapping.SupportsDelete implementation
			return false;
		}

		public void PrintPreview()
		{
			// TODO:  Add OverrideHistMapping.PrintPreview implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add OverrideHistMapping.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add OverrideHistMapping.SupportsPaste implementation
			return false;
		}

		public void Print()
		{
			// TODO:  Add OverrideHistMapping.Print implementation
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add OverrideHistMapping.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add OverrideHistMapping.SupportsPrint implementation
			return false;
		}

		public void OpenView()
		{
			// TODO:  Add OverrideHistMapping.OpenView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add OverrideHistMapping.TransposeView implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add OverrideHistMapping.ArrangeColumns implementation
		}

		public void Export()
		{
			// TODO:  Add OverrideHistMapping.Export implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add OverrideHistMapping.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public void ShowComponentList()
		{
			// TODO:  Add OverrideHistMapping.ShowComponentList implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add OverrideHistMapping.ClearFilter implementation
		}

		public void OpenCompositeView()
		{
			// TODO:  Add OverrideHistMapping.OpenCompositeView implementation
		}

		public void Delete()
		{
			
		}

		public bool SupportsUndo()
		{
			// TODO:  Add OverrideHistMapping.SupportsUndo implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add OverrideHistMapping.SupportsExport implementation
			return false;
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add OverrideHistMapping.CopyUOMTypes implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add OverrideHistMapping.ImportToExcel implementation
		}

		public void Refresh()
		{
			// TODO:  Add OverrideHistMapping.Refresh implementation
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add OverrideHistMapping.SupportsSelectionPaste implementation
			return false;
		}

		public void DownLevel()
		{
			// TODO:  Add OverrideHistMapping.DownLevel implementation
		}

		public void Paste()
		{
			// TODO:  Add OverrideHistMapping.Paste implementation
		}

		public bool SupportsSave()
		{
			// TODO:  Add OverrideHistMapping.SupportsSave implementation
			return false;
		}

		public void InsertNewRows()
		{
			// TODO:  Add OverrideHistMapping.InsertNewRows implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add OverrideHistMapping.CopyMasterProperties implementation
		}

		public void Save()
		{
			// TODO:  Add OverrideHistMapping.Save implementation
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add OverrideHistMapping.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OverrideHistMapping.ParentTabControl setter implementation
			}
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add OverrideHistMapping.SupportsCopyUOMTypes implementation
			return false;
		}

		#endregion

		private void gridComponentHistMapping_TableControlCurrentCellChanged(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{
			/*LRROverrideHistMapping overrideHistMap = e.TableControl.Table.CurrentRecord.GetData() as LRROverrideHistMapping;
			isActiveChanged = true;
			object[] objoverrideMapping = _unBound.GetSelectedRecords();
			if(objoverrideMapping.Length > 0)
			{
				for(int i=0;i<objoverrideMapping.Length;i++)
				{
					LRROverrideHistMapping objoverrideMap = objoverrideMapping[i] as LRROverrideHistMapping;
					if(objoverrideMap.OverrideMappingID != overrideHistMap.OverrideMappingID)
					{
						activeHistMapping = new LRROverrideHistMapping();
						_unBound.SetRecord(objoverrideMap,false);
						activeHistMapping = overrideHistMap;
						gridComponentHistMapping.Refresh();
					}
				}
			}
			else
			{
				activeHistMapping = new LRROverrideHistMapping();
				_unBound.SetRecord(overrideHistMap,true);
				activeHistMapping = overrideHistMap;
				gridComponentHistMapping.Refresh();
			}*/
		}

		private void SetActiveMapping(string mappingId)
		{
			LRROverrideHistMapping activeMapping = overridHistMappingModelObject.GetActiveMapping(mappingId);
			if(activeMapping != null)
			{
				_unBound.SetRecord(activeMapping,true); 
				if(activeMapping.IsDefaultMapping)
				{
					_histPropCompMapping.IsOverride = false;
				}
			}
		}

		private void barItemMap_Click(object sender, EventArgs e)
		{	
			gridComponentHistMapping.ChildGroupOptions.IsExpandedInitialValue = true;
			if(!_lrrapp.GetOptions().EnablePET)
				MappingWithoutPET();
			else
				MappingWithPET();
		}

		private void MappingWithPET()
		{
			GetSelectedSiteComponent(_histPropCompMapping.ComponentID);
			LRRHistData	 histData =	null;
			LRRPlantItemProperty propertyObj=null;
			try
			{
				histData = gridHistTags.CurrencyManager.Current	as LRRHistData;
				propertyObj =	gridComponentProperties.CurrencyManager.Current	as LRRPlantItemProperty;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithPET:"+ex.Message  ,Logger.Level.Debug);
				return;
			}
			if((histData!= null) &&	(propertyObj != null))
			{
				try
				{
					LRROverrideHistMapping  lohpcpm =	new	LRROverrideHistMapping();
					lohpcpm.ComponentPropertyName = propertyObj.Name;
					//get the property ID for measurement mode
					lohpcpm.SiteComponentPropID = propertyObj.ID;

					string site=lohpcpm.SiteComponentPropID;
                    List<IPropertyValue> arrScpValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(propertyObj.ID);
					if(arrScpValues != null)
					{
						for(int i=0;i < arrScpValues.Count;i++)
						{
							LRRSiteComponentPropertyValue lscpv = arrScpValues[i] as LRRSiteComponentPropertyValue;
							if(lscpv.ModeID == "1" && lscpv.SiteComponentPropertyID != "" && lscpv.SiteComponentPropertyID != null)
							{
								lohpcpm.SiteComponentPropValID = lscpv.ID;
								break;
							}
						}
					}

					lohpcpm.GroupPropertyID = propertyObj.GroupPropertyID;

					LRRSiteGroupPropertyQualifierValue lscgpv = new LRRSiteGroupPropertyQualifierValue();
					LRRSiteGroupPropertyQualifierValues grPropValues = new LRRSiteGroupPropertyQualifierValues();
					string sSiteGroupPropertyQualifierValueID = propertyObj.SiteGroupPropertyQualifierValueID == null ? "" : propertyObj.SiteGroupPropertyQualifierValueID;
					string lookupQualifierID = propertyObj.LookupQualifierID;
					string lookupPropertiesID = propertyObj.LookupPropertiesID;  

					if(sSiteGroupPropertyQualifierValueID != "")
					{
						lohpcpm.GroupPropertyValID = sSiteGroupPropertyQualifierValueID;
						lohpcpm.LookupQualifierID = lookupQualifierID;
						lohpcpm.LookUpPropertiesID = lookupPropertiesID; 
						
					}
					lohpcpm.HistPropID =	histData.HistTagUID;
					lohpcpm.EffectivePlantTime =	new DateTime(1,1,1,0,0,0);//DateTime.Now; 
					lohpcpm.HistTag = histData.HistTag;
					lohpcpm.ComponentID = _histPropCompMapping.ComponentID;
					string sitePropID = lohpcpm.SiteComponentPropID;
					gridComponentHistMapping.DataSource	= null;
					//Check for Dynamic Case
					/*if(selectedSiteComponent.IsDynamic)
					{
						lhpcpm.IsDynamic = true;

						LRRDynamicHistPropCompPropMapping dynamicHistProp = new LRRDynamicHistPropCompPropMapping();
						dynamicHistProp.HistPropID = lhpcpm.HistPropID;
						dynamicHistProp.HistTag = lhpcpm.HistTag;
						dynamicHistProp.SiteComponentPropID = lhpcpm.SiteComponentPropID;
						dynamicHistProp.SiteComponentPropValID = lhpcpm.SiteComponentPropValID;
						dynamicHistProp.ComponentID = lhpcpm.ComponentID;
						dynamicHistProp.ComponentPropertyName = lhpcpm.ComponentPropertyName;
						dynamicHistProp.GroupPropertyID = lhpcpm.GroupPropertyID;
						dynamicHistProp.GroupPropertyValID = lhpcpm.GroupPropertyValID;
						dynamicHistProp.LookupQualifierID = lhpcpm.LookupQualifierID;
						dynamicHistProp.EffectivePlantTime = lhpcpm.EffectivePlantTime;
						dynamicHistProp.LookUpPropertiesID = lhpcpm.LookUpPropertiesID; 

						LRRDynamicModel.DynamicHistPropCompPropMappings.Add(dynamicHistProp);	
					}*/

                    LRROverrideHistMapping obj = overrideHistPropMappings.GetOverrideMapingFromHistTagIDandPropID(histData.HistTagUID, propertyObj.ID);
                    if (obj == null)
                    {
                        string defaultMapping = LRRModel.HistPropMaps.GetHistTagUIDFromSiteComponentPropertyID(propertyObj.ID);
                        
                        if (defaultMapping != null)
                        {
                            /*
                            LRROverrideHistMapping defaultOverridedMapping = new LRROverrideHistMapping();
                            LRRSiteComponentPropertyValue scpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(propertyObj.ID, "1");
                            if (scpv != null)
                            {
                                defaultOverridedMapping.SiteComponentPropValID = scpv.ID;
                                LRRHistPropCompPropMapping defaultMap = LRRModel.HistPropMaps.GetHistMapObjFromValID(propertyObj.ID);
                                if (defaultMap != null)
                                {
                                    defaultOverridedMapping.HistTag = defaultMap.HistTag;
                                    defaultOverridedMapping.ComponentPropertyName = propertyObj.Name;
                                    defaultOverridedMapping.ComponentID = defaultMap.ComponentID;
                                    defaultOverridedMapping.UserID = defaultMap.UserID;

                                    defaultOverridedMapping.MappingId = defaultMap.MappingId;
                                    defaultOverridedMapping.MappingId = lohpcpm.MappingId;
                                    defaultOverridedMapping.SiteComponentPropID = propertyObj.ID;
                                    defaultOverridedMapping.IsDefaultMapping = true;
                                    defaultOverridedMapping.HistPropID = histData.HistTagUID;
                                    defaultOverridedMapping.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                                    
                                    if (!overrideHistPropMappings.Contains(defaultOverridedMapping))
                                    {
                                        overrideHistPropMappings.Add(defaultOverridedMapping);
                                    }
                                }
                            }
                            */

                        }
                        if (!overrideHistPropMappings.Contains(lohpcpm))
                        {
                            lohpcpm.IsPersistent = true;
                            lohpcpm.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                            overrideHistPropMappings.Add(lohpcpm);
                            overridHistMappingModelObject.Add(lohpcpm);
                        }
                        gridComponentHistMapping.DataSource = overrideHistPropMappings;
                        gridComponentHistMapping.Refresh();
                        SetFoucsOnLastMappingRecord(lohpcpm.MappingId);


                        /*
                        overrideHistPropMappings.Add(lohpcpm);
                        overridHistMappingModelObject.Add(lohpcpm);
                        gridComponentHistMapping.DataSource = overrideHistPropMappings;
                        gridComponentHistMapping.Refresh();
                        //SetFoucsOnLastMappingRecord(lohpcpm.MappingId);

                        lohpcpm.IsPersistent = true;
                        lohpcpm.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                        **/
                    }

				}
				catch(Exception	ex)
				{
					Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithPET:"+ex.Message  ,Logger.Level.Debug);
				}
				
			}
		}

		private void MappingWithoutPET()
		{
			GetSelectedSiteComponent(_histPropCompMapping.ComponentID);
			LRRHistData	 histData =	null;
			LRRPlantItemProperty propertyObj=null;
			try
			{
				histData = gridHistTags.CurrencyManager.Current	as LRRHistData;
				propertyObj =	gridComponentProperties.CurrencyManager.Current	as LRRPlantItemProperty;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithoutPET:"+ex.Message  ,Logger.Level.Debug);
				return;
			}

			if((histData!= null) &&	(propertyObj != null))
			{
				try
				{
					foreach(LRROverrideHistMapping ovHistMap in overrideHistPropMappings)
					{
						if((ovHistMap.HistTag == histData.HistTag)&& (ovHistMap.ComponentPropertyName == propertyObj.Name))
						{
							LRRMessagBox.ShowMessage("SID_DUPLICATE_HISTMAPPING_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
							return;
						}
					}
					LRROverrideHistMapping  lohpcpm =	new	LRROverrideHistMapping();
					lohpcpm.MappingId = _histPropCompMapping.MappingId;
					lohpcpm.ComponentPropertyName = propertyObj.Name;
					//get the property ID for measurement mode
					lohpcpm.SiteComponentPropID = propertyObj.ID;
					
					string site=lohpcpm.SiteComponentPropID;
                    List<IPropertyValue> arrScpValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(propertyObj.ID);
					if(arrScpValues != null)
					{
						for(int i=0;i < arrScpValues.Count;i++)
						{
							LRRSiteComponentPropertyValue lscpv = arrScpValues[i] as LRRSiteComponentPropertyValue;
							if(lscpv.ModeID == "1" && lscpv.SiteComponentPropertyID != "" && lscpv.SiteComponentPropertyID != null)
							{
								lohpcpm.SiteComponentPropValID = lscpv.ID;
								break;
							}
						}
					}
					lohpcpm.GroupPropertyID = propertyObj.GroupPropertyID;
					LRRSiteGroupPropertyQualifierValue lscgpv = new LRRSiteGroupPropertyQualifierValue();
					LRRSiteGroupPropertyQualifierValues grPropValues = new LRRSiteGroupPropertyQualifierValues();
					string sSiteGroupPropertyQualifierValueID = propertyObj.SiteGroupPropertyQualifierValueID == null ? "" : propertyObj.SiteGroupPropertyQualifierValueID;
					string lookupQualifierID = propertyObj.LookupQualifierID;
					string lookupPropertiesID = propertyObj.LookupPropertiesID;
					if(sSiteGroupPropertyQualifierValueID != "")
					{
						lohpcpm.GroupPropertyValID = sSiteGroupPropertyQualifierValueID;
						lohpcpm.LookupQualifierID = lookupQualifierID;
						lohpcpm.LookUpPropertiesID = lookupPropertiesID;
					}
					lohpcpm.HistPropID =	histData.HistTagUID;
					lohpcpm.EffectivePlantTime =	new DateTime(1,1,1,0,0,0);//DateTime.Now; 
					lohpcpm.HistTag = histData.HistTag;
					lohpcpm.ComponentID = _histPropCompMapping.ComponentID;
					string sitePropID = lohpcpm.SiteComponentPropID;
					gridComponentHistMapping.DataSource	= null;
					//Check for Dynamic Case
					/*if(selectedSiteComponent.IsDynamic)
					{
						lhpcpm.IsDynamic = true;

						LRRDynamicHistPropCompPropMapping dynamicHistProp = new LRRDynamicHistPropCompPropMapping();
						dynamicHistProp.HistPropID = lhpcpm.HistPropID;
						dynamicHistProp.HistTag = lhpcpm.HistTag;
						dynamicHistProp.SiteComponentPropID = lhpcpm.SiteComponentPropID;
						dynamicHistProp.SiteComponentPropValID = lhpcpm.SiteComponentPropValID;
						dynamicHistProp.ComponentID = lhpcpm.ComponentID;
						dynamicHistProp.ComponentPropertyName = lhpcpm.ComponentPropertyName;
						dynamicHistProp.GroupPropertyID = lhpcpm.GroupPropertyID;
						dynamicHistProp.GroupPropertyValID = lhpcpm.GroupPropertyValID;
						dynamicHistProp.LookupQualifierID = lhpcpm.LookupQualifierID;
						dynamicHistProp.EffectivePlantTime = lhpcpm.EffectivePlantTime;
						dynamicHistProp.LookUpPropertiesID = lhpcpm.LookUpPropertiesID;
						LRRDynamicModel.DynamicHistPropCompPropMappings.Add(dynamicHistProp);
					}*/
					overrideHistPropMappings.Add(lohpcpm); 
					overridHistMappingModelObject.Add(lohpcpm);
					gridComponentHistMapping.DataSource	= overrideHistPropMappings;
					gridComponentHistMapping.Refresh();
					SetFoucsOnLastMappingRecord(lohpcpm.MappingId); 
					lohpcpm.IsPersistent	= true;
					lohpcpm.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
				}
				catch(Exception	ex)
				{
					Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithoutPET :"+ex.Message  ,Logger.Level.Debug);
				}
			}
		}
		private void SetFoucsOnLastMappingRecord(string _mappingId)
		{
			foreach(Record _rec in this.gridComponentHistMapping.TableControl.Table.Records)
			{
				LRRHistPropCompPropMapping lhpcpm = _rec.GetData() as LRRHistPropCompPropMapping;
				if(lhpcpm != null)
				{
					if(lhpcpm.MappingId == _mappingId)
					{
						_rec.SetCurrent();
						_rec.SetSelected(true);
						this.gridComponentHistMapping.TableControl.Table.SelectedRecords.Add(_rec);
					}
				}
			}
		}

		private void GetSelectedSiteComponent(string siteComponentID)
		{
			selectedSiteComponent = LRRModel.SiteComponentsObj.GetSiteComponentByID(siteComponentID);  
		}

		private void barItemSave_Click(object sender, EventArgs e)
		{

			#region Save Changes to Override Mapping Table
   
			object[] selectedRecord =  _unBound.GetSelectedRecords();
			if(selectedRecord.Length == 0)
			{
				foreach(LRROverrideHistMapping ovHistMapObj in overrideHistPropMappings)
				{
					if(ovHistMapObj.IsDefaultMapping)
					{
						ovHistMapObj.IsActive = true; 
						_unBound.SetRecord(ovHistMapObj,true);
						
					}
					else
					{
						ovHistMapObj.IsActive = false;	
						_unBound.SetRecord(ovHistMapObj,false);
					}
					gridComponentHistMapping.Refresh();
				}
			}
			if(activeHistMapping != null)
			{
				overridHistMappingModelObject.SetActiveMapping(activeHistMapping);
			}
			if(overrideHistPropMappings.GetChanges().Count > 0)
			{
				LRROverrideHistMappings ovHistMapChanges = overrideHistPropMappings.GetChanges() as LRROverrideHistMappings;
				for(int i = 0 ;i < ovHistMapChanges.Count;i++)
				{
					LRROverrideHistMapping ovHistMap = ovHistMapChanges[i] as LRROverrideHistMapping;
                    if (ovHistMap != null)
                    {
                        if (ovHistMap.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
                        {
                            if (ovHistMap.IsActive)
                            {
                                SetDefaultMappingActive();
                            }
                            overridHistMappingModelObject.Remove(ovHistMap);
                        }
                    }
				}
				_lrrapp.DBManagerObj.CommitCollection(overridHistMappingModelObject.GetChanges());
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				overridHistMappingModelObject.RefreshCollection();
			}
			else
			{
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
			}
			#endregion

			#region Update Active Mapping to HistPropComPropMapping
			if(isActiveChanged)
			{
				object[] selectedRecords = _unBound.GetSelectedRecords();
				for(int i=0;i<selectedRecords.Length;i++)
				{
					LRROverrideHistMapping histMapOvObj = selectedRecords[i] as LRROverrideHistMapping;
					if(histMapOvObj.IsDefaultMapping)
					{
						SetDefaultMappingActive();
                        LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(activeHistMapping.SiteComponentPropID);
                        if (scp != null)
                        {
                            scp.HistTagID = histMapOvObj.HistPropID;
                            _lrrapp.DBManagerObj.CommitObject(scp);
                        }
					}
					else
					{
						string mappingID = _histPropCompMapping.MappingId;
						LRRHistPropCompPropMapping histPropComMapping = LRRModel.HistPropMaps.GetMapObjectByMappingID(_histPropCompMapping.MappingId);  
                        
						if(histPropComMapping != null && activeHistMapping.ObjectState != Symcon.Globals.Enums.DBOperation.DELETE)
						{
							histPropComMapping.ComponentID = activeHistMapping.ComponentID;
							histPropComMapping.ComponentPropertyName = activeHistMapping.ComponentPropertyName;
							histPropComMapping.EffectivePlantTime = activeHistMapping.EffectivePlantTime;
							histPropComMapping.GroupPropertyID = activeHistMapping.GroupPropertyID;
							histPropComMapping.GroupPropertyValID = activeHistMapping.GroupPropertyValID;
							histPropComMapping.HistPropID = activeHistMapping.HistPropID;
							histPropComMapping.HistTag = activeHistMapping.HistTag;
							histPropComMapping.LookUpPropertiesID = activeHistMapping.LookUpPropertiesID;
							histPropComMapping.LookupQualifierID = activeHistMapping.LookupQualifierID;
							histPropComMapping.SiteComponentPropID = activeHistMapping.SiteComponentPropID;
							histPropComMapping.SiteComponentPropValID = activeHistMapping.SiteComponentPropValID;
							histPropComMapping.TimeID = activeHistMapping.TimeID;
							histPropComMapping.UserID = activeHistMapping.UserID;
							histPropComMapping.IsOverride = true;

                            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(activeHistMapping.SiteComponentPropID);
                            if (scp != null)
                            {
                                scp.HistTagID = activeHistMapping.HistPropID;
                                _lrrapp.DBManagerObj.CommitObject(scp);
                            }
							
						}
					}
				}
			}
			#endregion
		}
		
		private void gridComponentHistMapping_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.RowIndex!=-1) 
			{
				if(e.TableCellIdentity.DisplayElement is GridRecordRow)
				{
					LRROverrideHistMapping  obj  = e.TableCellIdentity.DisplayElement.ParentRecord.GetData() as LRROverrideHistMapping; 
					if(obj!=null)
					{
						if(obj.IsDefaultMapping)
						{
							if(e.TableCellIdentity.ColIndex > 0)
							{
								e.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.CornflowerBlue);
							}
						}
					}
				}
			}
		}

		/// <summary>
		/// Add default HistPropCompPropMappingObject To OverrideMapping Collection
		/// </summary>
		private void AddDefaultMapObject()
		{
			if(!_histPropCompMapping.IsOverride)
			{
				defaultMapObject = new LRROverrideHistMapping();
				defaultMapObject.ComponentID = _histPropCompMapping.ComponentID;
				defaultMapObject.MappingId = _histPropCompMapping.MappingId;
				defaultMapObject.ComponentPropertyName = _histPropCompMapping.ComponentPropertyName;
				defaultMapObject.EffectivePlantTime = _histPropCompMapping.EffectivePlantTime;
				defaultMapObject.GroupPropertyID = _histPropCompMapping.GroupPropertyID;
				defaultMapObject.GroupPropertyValID = _histPropCompMapping.GroupPropertyValID;
				defaultMapObject.HistPropID = _histPropCompMapping.HistPropID;
				defaultMapObject.HistTag = _histPropCompMapping.HistTag;
				defaultMapObject.LookUpPropertiesID = _histPropCompMapping.LookUpPropertiesID;
				defaultMapObject.LookupQualifierID = _histPropCompMapping.LookupQualifierID;
				defaultMapObject.SiteComponentPropID = _histPropCompMapping.SiteComponentPropID;
				defaultMapObject.SiteComponentPropValID = _histPropCompMapping.SiteComponentPropValID;
				defaultMapObject.TimeID = _histPropCompMapping.TimeID;
				defaultMapObject.UserID = _histPropCompMapping.UserID;
				defaultMapObject.IsDefaultMapping  = true;
				_unBound.SetRecord(defaultMapObject,true); 
				//_lrrapp.DBManagerObj.CommitObject(defaultMapObject);
                //if (!overridHistMappingModelObject.Contains(defaultMapObject))
                //{
                    //defaultMapObject.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                    overridHistMappingModelObject.Add(defaultMapObject);
                    overrideHistPropMappings.Add(defaultMapObject);
                //}
			}
		}
		private void SetDefaultMappingActive()
		{
			string mappingID = _histPropCompMapping.MappingId;
			LRRHistPropCompPropMapping histPropComMapping = LRRModel.HistPropMaps.GetMapObjectByMappingID(_histPropCompMapping.MappingId);  
			if(histPropComMapping != null)
			{
				LRROverrideHistMapping defaultMapping = overridHistMappingModelObject.GetDefaultMapping(_histPropCompMapping.MappingId);
				histPropComMapping.ComponentID = defaultMapping.ComponentID;
				histPropComMapping.ComponentPropertyName = defaultMapping.ComponentPropertyName;
				histPropComMapping.EffectivePlantTime = defaultMapping.EffectivePlantTime;
				histPropComMapping.GroupPropertyID = defaultMapping.GroupPropertyID;
				histPropComMapping.GroupPropertyValID = defaultMapping.GroupPropertyValID;
				histPropComMapping.HistPropID = defaultMapping.HistPropID;
				histPropComMapping.HistTag = defaultMapping.HistTag;
				histPropComMapping.LookUpPropertiesID = defaultMapping.LookUpPropertiesID;
				histPropComMapping.LookupQualifierID = defaultMapping.LookupQualifierID;
				histPropComMapping.SiteComponentPropID = defaultMapping.SiteComponentPropID;
				histPropComMapping.SiteComponentPropValID = defaultMapping.SiteComponentPropValID;
				histPropComMapping.TimeID = defaultMapping.TimeID;
				histPropComMapping.UserID = defaultMapping.UserID;
				histPropComMapping.IsOverride = false;
				defaultMapping.IsActive = true;
				_unBound.SetRecord(defaultMapping,true);
				gridComponentHistMapping.Refresh();
			}
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

		private void gridComponentHistMapping_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 

				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
			}
		}

		private void gridComponentHistMapping_TableControlCurrentCellChanging(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
		{
			LRROverrideHistMapping overrideHistMap =  e.TableControl.Table.CurrentRecord.GetData() as LRROverrideHistMapping;
			isActiveChanged = true;
			object[] objoverrideMapping = _unBound.GetSelectedRecords();
			if(objoverrideMapping.Length > 0)
			{
				for(int i=0;i<objoverrideMapping.Length;i++)
				{
					LRROverrideHistMapping objoverrideMap = objoverrideMapping[i] as LRROverrideHistMapping;
					if(objoverrideMap.OverrideMappingID != overrideHistMap.OverrideMappingID)
					{
						activeHistMapping = new LRROverrideHistMapping();
						_unBound.SetRecord(objoverrideMap,false);
						activeHistMapping = overrideHistMap;
						gridComponentHistMapping.Refresh();
					}
					else if(objoverrideMap.OverrideMappingID == overrideHistMap.OverrideMappingID)
					{
						isActiveChanged = false;
						e.Inner.Cancel = true; 
					}
				}
			}
			else
			{
				activeHistMapping = new LRROverrideHistMapping();
				_unBound.SetRecord(overrideHistMap,true);
				activeHistMapping = overrideHistMap;
				gridComponentHistMapping.Refresh();
			}
			e.TableControl.CurrentCell.Deactivate(false);   
		}
        /*
		private void TableControl_ActivateToolTip(object sender, GridActivateToolTipEventArgs e)
		{
			string toolTip = null;
			try
			{
				if(e.RowIndex > 2)
				{
					string uomName = null;
					string uomType = null;
					string propTypeId = null;
					string propTypeName = null;
					string interfaceUom = null;
					gridComponentProperties.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = null;
					gridHistTags.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = null;
					gridComponentHistMapping.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = null;   
					if((e.RowIndex-2) <= gridHistTags.Table.Records.Count)
					{
						object objhistTag  = gridHistTags.Table.Records[e.RowIndex - 3].GetData();     
						if(objhistTag != null)
						{
							string uomTypeId = objhistTag.GetType().GetProperty("UOMTypeID").GetValue(objhistTag,null) == null ? "" : objhistTag.GetType().GetProperty("UOMTypeID").GetValue(objhistTag,null).ToString();  
							if(uomTypeId != "")
							{
								LRRUOMType uomTypobj = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeId);
								uomType = uomTypobj.Name; 
							}
							string uomNameID = objhistTag.GetType().GetProperty("ModelUOM").GetValue(objhistTag,null) == null ? "" : objhistTag.GetType().GetProperty("ModelUOM").GetValue(objhistTag,null).ToString();  
							if(uomNameID != null)
							{
								uomName = LRRModel.ChildModel.GetUOMNameFromID(uomNameID) ; 
							}
							string interfaceUomID = objhistTag.GetType().GetProperty("InterfaceUnits").GetValue(objhistTag,null) == null ? "" : objhistTag.GetType().GetProperty("InterfaceUnits").GetValue(objhistTag,null).ToString();  
							if(interfaceUomID != null)
							{
								interfaceUom = LRRModel.ChildModel.GetUOMNameFromID(uomNameID);  
							}
							if(uomName != "" && interfaceUom != "" && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+ uomName +"\n"+LRRHeaderText.GetHeaderString("SID_INTERFACEUOM")+":"+interfaceUom+"\n"+LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType; 
							}
							if(uomName == "" && interfaceUom != "" && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_INTERFACEUOM")+":"+interfaceUom+"\n"+uomType; 
							}
							if(uomName == "" && interfaceUom == "" && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType; 
							}
							if(uomName != null && interfaceUom == null && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+uomName+"\n"+LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType; 
							}
							gridHistTags.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = toolTip;
						}
					}
					if(gridComponentProperties.DataSource == null)
					{
						return;
					}
					object objcomprop  = gridComponentProperties.Table.Records[0].GetData();
					if(objcomprop != null)
					{
						string propID = objcomprop.GetType().GetProperty("ID").GetValue(objcomprop,null) == null ? "" : objcomprop.GetType().GetProperty("ID").GetValue(objcomprop,null).ToString();   
						if(propID != "")
						{
							LRRSiteComponentProperty prop = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propID);   
							if(prop == null)
								return;
							if(prop.UOM != null && prop.UOM.Trim() != "")
							{
								uomName = LRRModel.ChildModel.GetUOMNameFromID(prop.UOM);
							}
							else
							{
								uomName = "";
							}
							if(prop.UOMTypeID != null && prop.UOMTypeID.Trim() != "")
							{
								LRRUOMType uomtyp = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(prop.UOMTypeID);
								uomType = uomtyp.Name;
							}
							else
							{
								uomType = "";
							}
							   
							propTypeId = prop.Type == null ? "" : prop.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							if(propTypeId == "1")
							{
								propTypeName = "Simple";
							}
							else
							{
								propTypeName = "Group";
							}
							if(uomName != null && uomType!=null && propTypeName != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+uomName+"\n"+LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType+"\n"+LRRHeaderText.GetHeaderString("SID_PROPERTYTYPE")+":"+propTypeName;
							}
							if(uomName == "" && uomType!=null && propTypeName != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+uomType+"\n"+LRRHeaderText.GetHeaderString("SID_PROPERTYTYPE")+":"+propTypeName;
							}
							gridComponentProperties.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = toolTip;
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"TableControl_ActivateToolTip Event:"+ex.Message  ,Logger.Level.Debug);
			}
		}
         */

        private void OverrideHistMapping_Load(object sender, EventArgs e)
        {

        }

        private void OverrideHistMapping_FormClosing(object sender, FormClosingEventArgs e)
        {

        }
	}
}
