using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Reflection;
using System.Diagnostics;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Grouping;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for PlantItemConnectors.
	/// </summary>
	public class PlantItemConnectors : System.Windows.Forms.Form,ILRRUIContainer
	{
		#region Fields
		private System.ComponentModel.IContainer components;
		private LRRApp _app;
		
		private LRRConnectors			_lrrConnectors;//Data Source for the grid to show the Connectors equipment groups
		private LRRConnectorGroupItems	_lrrConnectorGroupItems;//Data Source for the grid to show the ConnectorGroups equipment groups
		private LRRModes				_lrrModes;
		private LRRSiteComponents		_lrrSystems;
		private LRRSiteComponents		_lrrEquipment;
		private bool					isSaved = false;
		
		//private LRRUIManager lrrUI=new LRRUIManager();
		private System.Windows.Forms.Panel pnlMain;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.Panel panel5;
		private System.Windows.Forms.Splitter splitter4;
		private System.Windows.Forms.Panel panel6;
		private System.Windows.Forms.Panel panel7;
		private System.Windows.Forms.Splitter splitter5;
		private System.Windows.Forms.Panel panel8;
		private System.Windows.Forms.Label lblPlantEffectiveDateTime;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridPlantItemConnectors;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridConnectorEquipments;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridModesForConnectors;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSystems;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Button btnUndoConnect;
		private System.Windows.Forms.Button btnConnectToSystem;
		private System.Windows.Forms.Button btnConnectToEquipment;
		
		private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		
		
		private TabControl			_parentTabControl;
		private System.Windows.Forms.DateTimePicker dtPlantEffectiveTime;
		private TabPage				_parentTabPage;

		
		#endregion
		
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PlantItemConnectors));
			this.pnlMain = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.gridPlantItemConnectors = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel6 = new System.Windows.Forms.Panel();
			this.panel8 = new System.Windows.Forms.Panel();
			this.dtPlantEffectiveTime = new System.Windows.Forms.DateTimePicker();
			this.lblPlantEffectiveDateTime = new System.Windows.Forms.Label();
			this.splitter5 = new System.Windows.Forms.Splitter();
			this.panel7 = new System.Windows.Forms.Panel();
			this.gridModesForConnectors = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter4 = new System.Windows.Forms.Splitter();
			this.panel5 = new System.Windows.Forms.Panel();
			this.gridSystems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.panel4 = new System.Windows.Forms.Panel();
			this.btnUndoConnect = new System.Windows.Forms.Button();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.btnConnectToSystem = new System.Windows.Forms.Button();
			this.btnConnectToEquipment = new System.Windows.Forms.Button();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panel3 = new System.Windows.Forms.Panel();
			this.gridConnectorEquipments = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlMain.SuspendLayout();
			this.panel2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridPlantItemConnectors)).BeginInit();
			this.panel1.SuspendLayout();
			this.panel6.SuspendLayout();
			this.panel8.SuspendLayout();
			this.panel7.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridModesForConnectors)).BeginInit();
			this.panel5.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridSystems)).BeginInit();
			this.panel4.SuspendLayout();
			this.panel3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridConnectorEquipments)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlMain
			// 
			this.pnlMain.AutoScroll = true;
			this.pnlMain.Controls.Add(this.panel2);
			this.pnlMain.Controls.Add(this.splitter1);
			this.pnlMain.Controls.Add(this.panel1);
			this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMain.Location = new System.Drawing.Point(0, 0);
			this.pnlMain.Name = "pnlMain";
			this.pnlMain.Size = new System.Drawing.Size(1028, 741);
			this.pnlMain.TabIndex = 0;
			// 
			// panel2
			// 
			this.panel2.AutoScroll = true;
			this.panel2.Controls.Add(this.gridPlantItemConnectors);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 467);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(1028, 274);
			this.panel2.TabIndex = 2;
			// 
			// gridPlantItemConnectors
			// 
			this.gridPlantItemConnectors.BackColor = System.Drawing.SystemColors.Window;
			this.gridPlantItemConnectors.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridPlantItemConnectors.IntelliMousePanning = true;
			this.gridPlantItemConnectors.Location = new System.Drawing.Point(0, 0);
			this.gridPlantItemConnectors.Name = "gridPlantItemConnectors";
			this.gridPlantItemConnectors.Size = new System.Drawing.Size(1028, 274);
			this.gridPlantItemConnectors.TabIndex = 0;
			this.gridPlantItemConnectors.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridPlantItemConnectors.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridPlantItemConnectors.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.gridPlantItemConnectors.Text = "gridPlantItemConnectors";
			this.gridPlantItemConnectors.TopLevelGroupOptions.CaptionText = "Connectors : {RecordCount} Items";
			this.gridPlantItemConnectors.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridPlantItemConnectors.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridPlantItemConnectors.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridPlantItemConnectors.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridPlantItemConnectors.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridPlantItemConnectors.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridPlantItemConnectors.VersionInfo = "3.301.0.0";
			this.gridPlantItemConnectors.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridPlantItemConnectors_RecordDeleting);
			this.gridPlantItemConnectors.Click += new System.EventHandler(this.gridPlantItemConnectors_Click);
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 464);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(1028, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.AutoScroll = true;
			this.panel1.Controls.Add(this.panel6);
			this.panel1.Controls.Add(this.splitter4);
			this.panel1.Controls.Add(this.panel5);
			this.panel1.Controls.Add(this.splitter3);
			this.panel1.Controls.Add(this.panel4);
			this.panel1.Controls.Add(this.splitter2);
			this.panel1.Controls.Add(this.panel3);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(1028, 464);
			this.panel1.TabIndex = 0;
			// 
			// panel6
			// 
			this.panel6.AutoScroll = true;
			this.panel6.Controls.Add(this.panel8);
			this.panel6.Controls.Add(this.splitter5);
			this.panel6.Controls.Add(this.panel7);
			this.panel6.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel6.Location = new System.Drawing.Point(795, 0);
			this.panel6.Name = "panel6";
			this.panel6.Size = new System.Drawing.Size(233, 464);
			this.panel6.TabIndex = 6;
			// 
			// panel8
			// 
			this.panel8.AutoScroll = true;
			this.panel8.Controls.Add(this.dtPlantEffectiveTime);
			this.panel8.Controls.Add(this.lblPlantEffectiveDateTime);
			this.panel8.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel8.Location = new System.Drawing.Point(0, 395);
			this.panel8.Name = "panel8";
			this.panel8.Size = new System.Drawing.Size(233, 69);
			this.panel8.TabIndex = 2;
			// 
			// dtPlantEffectiveTime
			// 
			this.dtPlantEffectiveTime.CustomFormat = " MM/dd/yyyy hh:mm:ss";
			this.dtPlantEffectiveTime.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtPlantEffectiveTime.Location = new System.Drawing.Point(192, 24);
			this.dtPlantEffectiveTime.Name = "dtPlantEffectiveTime";
			this.dtPlantEffectiveTime.Size = new System.Drawing.Size(136, 20);
			this.dtPlantEffectiveTime.TabIndex = 11;
			this.dtPlantEffectiveTime.Value = new System.DateTime(2006, 1, 27, 16, 58, 51, 893);
			this.dtPlantEffectiveTime.ValueChanged += new System.EventHandler(this.dtPlantEffectiveTime_ValueChanged);
			// 
			// lblPlantEffectiveDateTime
			// 
			this.lblPlantEffectiveDateTime.Location = new System.Drawing.Point(16, 24);
			this.lblPlantEffectiveDateTime.Name = "lblPlantEffectiveDateTime";
			this.lblPlantEffectiveDateTime.Size = new System.Drawing.Size(160, 23);
			this.lblPlantEffectiveDateTime.TabIndex = 10;
			this.lblPlantEffectiveDateTime.Tag = "SID_PLANTEFFECDATETIME";
			// 
			// splitter5
			// 
			this.splitter5.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter5.Location = new System.Drawing.Point(0, 392);
			this.splitter5.Name = "splitter5";
			this.splitter5.Size = new System.Drawing.Size(233, 3);
			this.splitter5.TabIndex = 1;
			this.splitter5.TabStop = false;
			// 
			// panel7
			// 
			this.panel7.AutoScroll = true;
			this.panel7.Controls.Add(this.gridModesForConnectors);
			this.panel7.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel7.Location = new System.Drawing.Point(0, 0);
			this.panel7.Name = "panel7";
			this.panel7.Size = new System.Drawing.Size(233, 392);
			this.panel7.TabIndex = 0;
			this.panel7.Paint += new System.Windows.Forms.PaintEventHandler(this.panel7_Paint);
			// 
			// gridModesForConnectors
			// 
			this.gridModesForConnectors.BackColor = System.Drawing.SystemColors.Window;
			this.gridModesForConnectors.Location = new System.Drawing.Point(16, 0);
			this.gridModesForConnectors.Name = "gridModesForConnectors";
			this.gridModesForConnectors.Size = new System.Drawing.Size(296, 288);
			this.gridModesForConnectors.TabIndex = 0;
			this.gridModesForConnectors.Text = "gridModesForConnectors";
			this.gridModesForConnectors.TopLevelGroupOptions.CaptionText = "Modes : {RecordCount} Items";
			this.gridModesForConnectors.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridModesForConnectors.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridModesForConnectors.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridModesForConnectors.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridModesForConnectors.VersionInfo = "3.301.0.0";
			this.gridModesForConnectors.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridModesForConnectors_RecordValueChanged);
			// 
			// splitter4
			// 
			this.splitter4.Location = new System.Drawing.Point(792, 0);
			this.splitter4.Name = "splitter4";
			this.splitter4.Size = new System.Drawing.Size(3, 464);
			this.splitter4.TabIndex = 5;
			this.splitter4.TabStop = false;
			// 
			// panel5
			// 
			this.panel5.AutoScroll = true;
			this.panel5.Controls.Add(this.gridSystems);
			this.panel5.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel5.Location = new System.Drawing.Point(467, 0);
			this.panel5.Name = "panel5";
			this.panel5.Size = new System.Drawing.Size(325, 464);
			this.panel5.TabIndex = 4;
			// 
			// gridSystems
			// 
			this.gridSystems.BackColor = System.Drawing.SystemColors.Window;
			this.gridSystems.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSystems.Location = new System.Drawing.Point(0, 0);
			this.gridSystems.Name = "gridSystems";
			this.gridSystems.Size = new System.Drawing.Size(325, 464);
			this.gridSystems.TabIndex = 0;
			this.gridSystems.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridSystems.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridSystems.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.gridSystems.Text = "gridSystems";
			this.gridSystems.TopLevelGroupOptions.CaptionText = "Systems: {RecordCount} Items";
			this.gridSystems.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridSystems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridSystems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridSystems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridSystems.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridSystems.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridSystems.VersionInfo = "3.301.0.0";
			this.gridSystems.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridSystems_TableControlCellClick);
			this.gridSystems.DragDrop += new System.Windows.Forms.DragEventHandler(this.gridSystems_DragDrop);
			this.gridSystems.Click += new System.EventHandler(this.gridSystems_Click);
			// 
			// splitter3
			// 
			this.splitter3.Location = new System.Drawing.Point(464, 0);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(3, 464);
			this.splitter3.TabIndex = 3;
			this.splitter3.TabStop = false;
			// 
			// panel4
			// 
			this.panel4.AutoScroll = true;
			this.panel4.Controls.Add(this.btnUndoConnect);
			this.panel4.Controls.Add(this.btnConnectToSystem);
			this.panel4.Controls.Add(this.btnConnectToEquipment);
			this.panel4.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel4.Location = new System.Drawing.Point(355, 0);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(109, 464);
			this.panel4.TabIndex = 2;
			// 
			// btnUndoConnect
			// 
			this.btnUndoConnect.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
			this.btnUndoConnect.ImageIndex = 4;
			this.btnUndoConnect.ImageList = this.imageList1;
			this.btnUndoConnect.Location = new System.Drawing.Point(16, 256);
			this.btnUndoConnect.Name = "btnUndoConnect";
			this.btnUndoConnect.Size = new System.Drawing.Size(72, 32);
			this.btnUndoConnect.TabIndex = 2;
			this.btnUndoConnect.Tag = "SID_CLEARSELECTION";
			this.btnUndoConnect.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnUndoConnect.Click += new System.EventHandler(this.btnUndoConnect_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// btnConnectToSystem
			// 
			this.btnConnectToSystem.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
			this.btnConnectToSystem.ImageIndex = 0;
			this.btnConnectToSystem.ImageList = this.imageList1;
			this.btnConnectToSystem.Location = new System.Drawing.Point(8, 160);
			this.btnConnectToSystem.Name = "btnConnectToSystem";
			this.btnConnectToSystem.Size = new System.Drawing.Size(88, 32);
			this.btnConnectToSystem.TabIndex = 1;
			this.btnConnectToSystem.Tag = "SID_CONNECTTOSYS";
			this.btnConnectToSystem.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnConnectToSystem.Click += new System.EventHandler(this.btnConnectToSystem_Click);
			// 
			// btnConnectToEquipment
			// 
			this.btnConnectToEquipment.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
			this.btnConnectToEquipment.ImageIndex = 1;
			this.btnConnectToEquipment.ImageList = this.imageList1;
			this.btnConnectToEquipment.Location = new System.Drawing.Point(8, 208);
			this.btnConnectToEquipment.Name = "btnConnectToEquipment";
			this.btnConnectToEquipment.Size = new System.Drawing.Size(88, 32);
			this.btnConnectToEquipment.TabIndex = 1;
			this.btnConnectToEquipment.Tag = "SID_CONNECTTOEQUIP";
			this.btnConnectToEquipment.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnConnectToEquipment.Click += new System.EventHandler(this.btnConnectToEquipment_Click);
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(352, 0);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 464);
			this.splitter2.TabIndex = 1;
			this.splitter2.TabStop = false;
			// 
			// panel3
			// 
			this.panel3.AutoScroll = true;
			this.panel3.Controls.Add(this.gridConnectorEquipments);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel3.Location = new System.Drawing.Point(0, 0);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(352, 464);
			this.panel3.TabIndex = 0;
			// 
			// gridConnectorEquipments
			// 
			this.gridConnectorEquipments.BackColor = System.Drawing.SystemColors.Window;
			this.gridConnectorEquipments.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridConnectorEquipments.Location = new System.Drawing.Point(0, 0);
			this.gridConnectorEquipments.Name = "gridConnectorEquipments";
			this.gridConnectorEquipments.Size = new System.Drawing.Size(352, 464);
			this.gridConnectorEquipments.TabIndex = 0;
			this.gridConnectorEquipments.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridConnectorEquipments.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridConnectorEquipments.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.gridConnectorEquipments.Text = "gridConnectorEquipments";
			this.gridConnectorEquipments.TopLevelGroupOptions.CaptionText = "Plant Items: {RecordCount} Items";
			this.gridConnectorEquipments.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridConnectorEquipments.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridConnectorEquipments.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridConnectorEquipments.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridConnectorEquipments.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridConnectorEquipments.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridConnectorEquipments.VersionInfo = "3.301.0.0";
			this.gridConnectorEquipments.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridConnectorEquipments_TableControlCellClick);
			// 
			// PlantItemConnectors
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.ClientSize = new System.Drawing.Size(1028, 741);
			this.Controls.Add(this.pnlMain);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "PlantItemConnectors";
			this.Tag = "SID_PLANT_CONNECTORS";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.PlantItemConnectors_Load);
			this.Closed += new System.EventHandler(this.PlantItemConnectors_Closed);
			this.pnlMain.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridPlantItemConnectors)).EndInit();
			this.panel1.ResumeLayout(false);
			this.panel6.ResumeLayout(false);
			this.panel8.ResumeLayout(false);
			this.panel7.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridModesForConnectors)).EndInit();
			this.panel5.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridSystems)).EndInit();
			this.panel4.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridConnectorEquipments)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Form Constructor And Destructor
		public PlantItemConnectors()
		{

			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			_gridExcelFormatter.WireGrid(gridPlantItemConnectors);
			
			InitDataSource();
			
			bindGrids();

            this.FormClosing += new FormClosingEventHandler(PlantItemConnectors_FormClosing);
		}
		
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion
		
		#region Private Methods
		public void InitDataSource()
		{
			
			if(_lrrConnectorGroupItems != null)
				_lrrConnectorGroupItems.Clear();
			
			if(_lrrModes != null)
				_lrrModes.Clear();
			
			if(_lrrSystems != null)
				_lrrSystems.Clear();
			
			if(_lrrEquipment != null)
				_lrrEquipment.Clear();
			

			_lrrConnectorGroupItems = new LRRConnectorGroupItems();
			_app.DBManagerObj.PopulateCollection(_lrrConnectorGroupItems,false);
//
			_lrrModes = new LRRModes();
//			_app.DBManagerObj.PopulateCollection(_lrrModes,false);
			for(int i=0;i < LRRModel.ProjectModes.Count;i++)
			{
				LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
				_lrrModes.Add(objMode);
			}
				
			_lrrSystems = new LRRSiteComponents();
			_app.DBManagerObj.PopulateCollection(_lrrSystems," WHERE ComponentTypeID IN (SELECT ID From MasterComponentTypes Where ComponentID = (SELECT ID FROM ComponentTypes WHERE Name = 'System'))",false);

			_lrrEquipment = new LRRSiteComponents();
			_app.DBManagerObj.PopulateCollection(_lrrEquipment," WHERE ComponentTypeID IN (SELECT ID From MasterComponentTypes Where ComponentID = (SELECT ID FROM ComponentTypes WHERE Name = 'Equipment'))",false);

		}
		public void bindGrids()
		{
			bindConnectorGroupItemsGrid();
			bindConnectorEquipmentsGrid();
			bindModesForConnectorsGrid();
			bindSystemsGrid();
			
		}
		private void bindConnectorGroupItemsGrid()
		{	
			_lrrConnectorGroupItems.RefreshCollection();
			gridPlantItemConnectors.SuspendLayout();
			
			this.gridConnectorEquipments.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_CONNECTORS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
		
			SyncGridUtilities.InitializeGridLookAndFeel(gridPlantItemConnectors);
			gridConnectorEquipments.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridConnectorEquipments_QueryCellStyleInfo);
			gridPlantItemConnectors.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridPlantItemConnectors_QueryCellStyleInfo);
			gridPlantItemConnectors.TableDescriptor.Relations.Clear();

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_lrrConnectorGroupItems.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

			SyncGridUtilities.InitializeGridColumns(gridPlantItemConnectors,_lrrConnectorGroupItems.ItemType,null,fkData);

			//Add the parent table for the Relations...
			gridPlantItemConnectors.Engine.SourceListSet.Add("ParentTable",_lrrConnectorGroupItems);

			gridPlantItemConnectors.DataSource = _lrrConnectorGroupItems;

			gridPlantItemConnectors.TableDescriptor.AllowEdit = true;
			gridPlantItemConnectors.TableDescriptor.AllowNew = false;
			gridPlantItemConnectors.TableDescriptor.AllowRemove = true;
			foreach(GridColumnDescriptor gcd in this.gridPlantItemConnectors.TableDescriptor.Columns)
			{
				if(gcd.MappingName != "ConnectorType_Name" && gcd.MappingName != "EffectivePlantTime" && gcd.MappingName != "Description")
				{
					gcd.ReadOnly = true;
					gcd.Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;  
					gcd.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
				}
			}
		
			gridPlantItemConnectors.ResumeLayout(false);
		}

	

	
		public void bindConnectorEquipmentsGrid()
		{
			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridConnectorEquipments.SuspendLayout();
			
			this.gridConnectorEquipments.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  

			SyncGridUtilities.InitializeGridLookAndFeel(gridConnectorEquipments);
			gridConnectorEquipments.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridConnectorEquipments_QueryCellStyleInfo);
			Hashtable columnForDisplay = new Hashtable();
			columnForDisplay.Add("Name",null);
			columnForDisplay.Add("MasterComponentType",null);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridConnectorEquipments,_lrrEquipment.ItemType,null,true,columnForDisplay);

			RelativeWidths.Add("Name",50);
			RelativeWidths.Add("MasterComponentType",48);
			SyncGridUtilities.InitializeGridColumnsWidth(gridConnectorEquipments,RelativeWidths );

			//Set the data store 
			gridConnectorEquipments.DataSource = _lrrEquipment;

			gridConnectorEquipments.TableDescriptor.AllowNew = false;
			gridConnectorEquipments.TableDescriptor.AllowRemove = false;
			gridConnectorEquipments.TableDescriptor.AllowEdit = false;

			//Resume the Layout of the Grid...
			gridConnectorEquipments.ResumeLayout(false);

			//Add the parent table for the Relations...
			gridConnectorEquipments.Engine.SourceListSet.Add("ParentTable",_lrrEquipment);
			
			foreach(GridColumnDescriptor gcd in this.gridConnectorEquipments.TableDescriptor.Columns)
			{
				gcd.ReadOnly = true;
				gcd.Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;  
				gcd.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			}
			
			//gridConnectorEquipments.TableDescriptor.SelectedRecordsChanged+=new	SelectedRecordsChangedEventHandler(gridConnectorEquipments_SelectedRecordsChanged);
		}
		
		public void bindModesForConnectorsGrid()
		{
			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridModesForConnectors.SuspendLayout();

            this.gridConnectorEquipments.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_EQUIPMENTS") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");  

			SyncGridUtilities.InitializeGridLookAndFeel(gridModesForConnectors);
			gridModesForConnectors.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridModesForConnectors_QueryCellStyleInfo);
			Hashtable columnForDisplay = new Hashtable();
			columnForDisplay.Add("ModeName",null);
			columnForDisplay.Add("IsSelected",null);
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridModesForConnectors,_lrrModes.ItemType,null,true,columnForDisplay);

			RelativeWidths.Add("ModeName",85);
			RelativeWidths.Add("IsSelected",15);
			//RelativeWidths.Add("Description",68);
			SyncGridUtilities.InitializeGridColumnsWidth(gridModesForConnectors,RelativeWidths );

			//Set the data store 
			gridModesForConnectors.DataSource =_lrrModes;

			gridModesForConnectors.TableDescriptor.AllowNew = false;
			gridModesForConnectors.TableDescriptor.AllowRemove = false;
			gridModesForConnectors.TableDescriptor.AllowEdit = true;

			//Resume the Layout of the Grid...
			gridModesForConnectors.ResumeLayout(false);

			//Add the parent table for the Relations...
			gridModesForConnectors.Engine.SourceListSet.Add("ParentTable",_lrrModes);
			
			foreach(GridColumnDescriptor gcd in this.gridModesForConnectors.TableDescriptor.Columns)
			{
				if(gcd.MappingName != "IsSelected")
					gcd.ReadOnly = true;
			}
		}


		public void bindSystemsGrid()
		{
			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridSystems.SuspendLayout();
			
			gridSystems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_SYSTEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  

			SyncGridUtilities.InitializeGridLookAndFeel(gridSystems);		  
			gridSystems.QueryCellStyleInfo +=new GridTableCellStyleInfoEventHandler(gridSystems_QueryCellStyleInfo);
			Hashtable columnForDisplay = new Hashtable();
			columnForDisplay.Add("Name",null);
			columnForDisplay.Add("MasterComponentType",null);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridSystems,_lrrSystems.ItemType,null,true,columnForDisplay);

			RelativeWidths.Add("Name",50);
			RelativeWidths.Add("MasterComponentType",48);
			SyncGridUtilities.InitializeGridColumnsWidth(gridSystems,RelativeWidths );

			//Set the data store 
			gridSystems.DataSource = _lrrSystems;

			gridSystems.TableDescriptor.AllowNew = false;
			gridSystems.TableDescriptor.AllowRemove = false;
			gridSystems.TableDescriptor.AllowEdit = false;
			

			//Resume the Layout of the Grid...
			gridSystems.ResumeLayout(false);

			//Add the parent table for the Relations...
			gridSystems.Engine.SourceListSet.Add("ParentTable",_lrrSystems);
			
			foreach(GridColumnDescriptor gcd in this.gridSystems.TableDescriptor.Columns)
			{
				gcd.ReadOnly = true;
				gcd.Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;  
				gcd.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;

			}
		}

	

		private bool chkIfConnectorsExists(string SourceItemID, string DestItemID)
		{
			LRRConnectorGroupItems objConnectorGrpItems =  _lrrConnectorGroupItems.Clone() as LRRConnectorGroupItems;
			objConnectorGrpItems.ItemFilter = "DestinationItemID = " + DestItemID + " and SourceItemID = " + SourceItemID;
			if(objConnectorGrpItems.Count > 0)
				return true;
			else
				return false;
		}
		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			
			
//			lrrUI.SaveGridSettings(gridPlantItemConnectors,this, this.Tag);
//			lrrUI.SaveGridSettings(gridConnectorEquipments,this, this.Tag);
//			lrrUI.SaveGridSettings(gridModesForConnectors,this, this.Tag);
//			lrrUI.SaveGridSettings(gridSystems,this, this.Tag);

			InitDataSource();
			bindGrids();

			
//			lrrUI.ApplyGridSettings(gridPlantItemConnectors,this, this.Tag);
//			lrrUI.ApplyGridSettings(gridConnectorEquipments,this, this.Tag);
//			lrrUI.ApplyGridSettings(gridModesForConnectors,this, this.Tag);
//			lrrUI.ApplyGridSettings(gridSystems,this, this.Tag);
		}

		public void Save()
		{
			LRRConnectorGroupItems connectorGroupItemsToSave = _lrrConnectorGroupItems.GetChanges();
			//Commit the changes to the database
			if(connectorGroupItemsToSave.Count >0)
			{
				isSaved = true;
				_app.DBManagerObj.CommitCollection(connectorGroupItemsToSave);
				if(connectorGroupItemsToSave.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					return;
				}
				else
				{
					_lrrConnectorGroupItems.RefreshCollection();
					LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				}
			}
			if(!isSaved)
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
		}
		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			
		}

		public void Copy()
		{
			
		}

		public void Print()
		{
			if(gridConnectorEquipments.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridConnectorEquipments,false);
			}
			if(gridPlantItemConnectors.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridPlantItemConnectors,false);
			}
			if(gridSystems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSystems,false);
			}
			if(gridModesForConnectors.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridModesForConnectors,false);
			}
			
		}

		public void Delete()
		{
			
		}

		public void ArrangeColumns()
		{
			
		}

		public void ClearFilter()
		{
			
			SyncGridUtilities.ClearFilter(gridPlantItemConnectors);
			SyncGridUtilities.ClearFilter(gridConnectorEquipments);
			SyncGridUtilities.ClearFilter(gridModesForConnectors);
			SyncGridUtilities.ClearFilter(gridSystems);
//			this.gridPlantItemConnectors.TableDescriptor.RecordFilters.Clear();
//			this.gridConnectorEquipments.TableDescriptor.RecordFilters.Clear();
//			this.gridModesForConnectors.TableDescriptor.RecordFilters.Clear();
//			this.gridSystems.TableDescriptor.RecordFilters.Clear();

		}
		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridPlantItemConnectors);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridPlantItemConnectors);
		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}
		public void Export()
		{
			if(gridPlantItemConnectors.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridPlantItemConnectors);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		
		#endregion
		
		#region Events

        private void PlantItemConnectors_FormClosing(object sender, FormClosingEventArgs e)
        {
            LRRConnectorGroupItems connectorGroupItemsToSave = _lrrConnectorGroupItems.GetChanges();
            //Commit the changes to the database
            if (connectorGroupItemsToSave.Count > 0)
            {
                DialogResult dlgResult = LRRMessagBox.ShowMessage(this, "SID_SAVEINFO_QUESTION", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (dlgResult == DialogResult.Yes)
                {
                    Save();
                }
            }
        }

		private void barClose_Click(object sender, System.EventArgs e)
		{
			//			if(ValidateClose())
			//			{
			//				this.Close();
			//			}		
		}

					 
		private void gridModesForConnectors_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			try
			  {
			       if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		}
		private	void gridPlantItemConnectors_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
				try
			  {
			     if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		}
		private	void gridConnectorEquipments_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			try
			  {
			     if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		}
		private void gridSystems_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			try
			  {
			     if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
		}
		private void PlantItemConnectors_Load(object sender, System.EventArgs e)
		{
			if(gridPlantItemConnectors.Table.Records.Count>0)
				gridPlantItemConnectors.Table.Records[0].SetCurrent();
//			
//			if(gridConnectorEquipments.Table.Records.Count>0)
//				gridConnectorEquipments.Table.Records[0].SetCurrent();
		}

		
		private void PlantItemConnectors_Closed(object sender, System.EventArgs e)
		{
			_gridExcelFormatter.UnwireGrid();
		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}

		private void gridConnectorEquipments_SelectedRecordsChanged(object sender, Syncfusion.Grouping.SelectedRecordsChangedEventArgs e)
		{
			MessageBox.Show(e.Table.SelectedRecords.Count.ToString(Symcon.BusinessObjects.SymConverter.Culture));
		}

		private void gridConnectorEquipments_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(e.TableControl.Model.SelectedRanges.Count > 1)
				gridSystems.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			else
				gridSystems.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
		}

		private void gridSystems_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(e.TableControl.Model.SelectedRanges.Count > 1)
				gridConnectorEquipments.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			else
				gridConnectorEquipments.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
		}
		
	

		private void btnConnectToSystem_Click(object sender, System.EventArgs e)
		{
		
			if(gridSystems.TableControl.Selections.GetSelectedRows(false,true).ActiveRange.Height == 0)
			{
				LRRMessagBox.ShowMessage("SID_NOSYS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
				
				return;	
			}

			if(gridSystems.TableControl.Selections.GetSelectedRows(false,true).ActiveRange.Height > 1)
			{
				LRRMessagBox.ShowMessage("SID_NO_MULTIPLESYS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
				return;	
			}
			IEnumerator iSystemEnumerator	= gridSystems.TableControl.Model.SelectedRanges.GetEnumerator();
			string sDestItemName="";
			string sDestItemID="";
			_lrrModes.ItemFilter ="IsSelected = true";

			while(iSystemEnumerator.MoveNext())
			{
				GridRangeInfo objGridRangeInfo= (GridRangeInfo)iSystemEnumerator.Current;
				
				int nRow = objGridRangeInfo.Bottom;
				nRow = nRow -4;
				if(nRow < 0)
				{
					LRRMessagBox.ShowMessage("SID_NOSYS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
					return;
				}
				LRRSiteComponent objSelectedSystem = gridSystems.TableControl.Table.Records[nRow].GetData() as LRRSiteComponent;
				sDestItemName = objSelectedSystem.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				sDestItemID =  objSelectedSystem.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			}

			IEnumerator iEquipEnumerator	= gridConnectorEquipments.TableControl.Model.SelectedRanges.GetEnumerator();
			while(iEquipEnumerator.MoveNext())
			{
				GridRangeInfo objGridRangeInfo= (GridRangeInfo)iEquipEnumerator.Current;
				
				int nRow = objGridRangeInfo.Bottom;
				int tRow = objGridRangeInfo.Top;
				nRow = nRow -4;
				tRow = tRow -4;
				if(nRow >= 0)
				{
					for(int j=nRow;j>=tRow;j--)
					{
						LRRSiteComponent objSelectedEquipment = gridConnectorEquipments.TableControl.Table.Records[j].GetData() as LRRSiteComponent;
						LRRConnectorGroupItem objConnectorGrpItem = new LRRConnectorGroupItem();
						objConnectorGrpItem.Name = objSelectedEquipment.Name + " - to - " + sDestItemName;
						objConnectorGrpItem.SourceItemID = objSelectedEquipment.SiteComponentID;
						objConnectorGrpItem.DestinationItemID = sDestItemID;
						objConnectorGrpItem.EffectivePlantTime = Convert.ToDateTime(dtPlantEffectiveTime.Text,Symcon.BusinessObjects.SymConverter.Culture);
							//dtPlantEffectiveTime.Text;
					
						if(_lrrModes.Count > 0 )
							objConnectorGrpItem.ModeID = _lrrModes[0].ModeId;
					
						if (chkIfConnectorsExists(objSelectedEquipment.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture),sDestItemID) == false)
							_lrrConnectorGroupItems.Add(objConnectorGrpItem);
						else
						{
							//MessageBox.Show("[" + objSelectedEquipment.Name + " - to - " + sDestItemName + "] Connector already exists.");
							string[] s = new string[2];
							s[0] = objSelectedEquipment.Name;
							s[1] = sDestItemName;
							LRRMessagBox.ShowMessage("SID_CONN_EXITS","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Information);      
						}
				

					}

				}
			}
			_lrrModes.ItemFilter ="";

		}

		private void btnConnectToEquipment_Click(object sender, System.EventArgs e)
		{
			
			if(gridConnectorEquipments.TableControl.Selections.GetSelectedRows(false,true).ActiveRange.Height == 0)
			{
				LRRMessagBox.ShowMessage("SID_NOSYS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
				return;	
			}

			if(gridConnectorEquipments.TableControl.Selections.GetSelectedRows(false,true).ActiveRange.Height> 1)
			{
				LRRMessagBox.ShowMessage("SID_MULTIPLEEQUIP","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
				return;	
			}

			
			IEnumerator iEquipEnumerator	= gridConnectorEquipments.TableControl.Model.SelectedRanges.GetEnumerator();
			string sDestItemName="";
			string sDestItemID="";
			_lrrModes.ItemFilter ="IsSelected = true";

			while(iEquipEnumerator.MoveNext())
			{
				GridRangeInfo objGridRangeInfo= (GridRangeInfo)iEquipEnumerator.Current;
				
				int nRow = objGridRangeInfo.Bottom;
				nRow = nRow -4;
				if(nRow < 0)
				{
					LRRMessagBox.ShowMessage("SID_NOEQUIP","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
					return;
				}
				LRRSiteComponent objSelectedEquip = gridConnectorEquipments.TableControl.Table.Records[nRow].GetData() as LRRSiteComponent;
				sDestItemName = objSelectedEquip.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				sDestItemID =  objSelectedEquip.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			}

			IEnumerator iSystemEnumerator = gridSystems.TableControl.Model.SelectedRanges.GetEnumerator();
			while(iSystemEnumerator.MoveNext())
			{
				GridRangeInfo objGridRangeInfo= (GridRangeInfo)iSystemEnumerator.Current;
				
				int nRow = objGridRangeInfo.Bottom;
				int tRow = objGridRangeInfo.Top;
				nRow = nRow -4;
				tRow = tRow -4;
				if(nRow >= 0)
				{
					for(int j=nRow;j>=tRow;j--)
					{
						LRRSiteComponent objSelectedSystem = gridSystems.TableControl.Table.Records[j].GetData() as LRRSiteComponent;
						LRRConnectorGroupItem objConnectorGrpItem = new LRRConnectorGroupItem();
						objConnectorGrpItem.Name = objSelectedSystem.Name + " - to - " + sDestItemName;
						objConnectorGrpItem.SourceItemID = objSelectedSystem.SiteComponentID;
						objConnectorGrpItem.DestinationItemID = sDestItemID;
						objConnectorGrpItem.EffectivePlantTime =  Convert.ToDateTime(dtPlantEffectiveTime.Text,Symcon.BusinessObjects.SymConverter.Culture);
				
						if(_lrrModes.Count > 0 )
							objConnectorGrpItem.ModeID = _lrrModes[0].ModeId;
				

						if (chkIfConnectorsExists(objSelectedSystem.SiteComponentID.ToString(Symcon.BusinessObjects.SymConverter.Culture),sDestItemID) == false)
							_lrrConnectorGroupItems.Add(objConnectorGrpItem);
						else
						{
							//MessageBox.Show("[" + objSelectedSystem.Name + " - to - " + sDestItemName + "] Connector already exists.");
							string[] s = new string[2];
							s[0] = objSelectedSystem.Name;
							s[1] = sDestItemName;
							LRRMessagBox.ShowMessage("SID_CONN_EXITS","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Information);      
						}
					
					}
				}

			}
			_lrrModes.ItemFilter ="";
		}

		private void btnUndoConnect_Click(object sender, System.EventArgs e)
		{
			gridConnectorEquipments.TableControl.Selections.Clear();
			gridSystems.TableControl.Selections.Clear();
			gridConnectorEquipments.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			gridConnectorEquipments.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			gridConnectorEquipments.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			
			gridSystems.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			gridSystems.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			gridSystems.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
		}

		private void dtPlantEffectiveTime_ValueChanged(object sender, System.EventArgs e)
		{
		
		}
		#endregion

		private void gridModesForConnectors_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			foreach(LRRMode objMode in _lrrModes)
			{
				LRRMode objSelectedMode =  e.Record.GetData() as LRRMode ;
				if(objMode.ModeId != objSelectedMode.ModeId)
					objMode.IsSelected = false;
			}
			
			
		}

		private void gridSystems_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
		
		}

		private void gridSystems_Click(object sender, System.EventArgs e)
		{
		
		}

		private void gridPlantItemConnectors_Click(object sender, System.EventArgs e)
		{
		
		}

		private void panel7_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			//PlantItemConnectors.ClearSort implementation
			SyncGridUtilities.ClearSort(gridConnectorEquipments);
			SyncGridUtilities.ClearSort(gridPlantItemConnectors);
			SyncGridUtilities.ClearSort(gridSystems);
			SyncGridUtilities.ClearSort(gridModesForConnectors);
		}

		public bool SupportsClearSort()
		{
			// PlantItemConnectors.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add PlantItemConnectors.PrintPreview implementation
			if(gridConnectorEquipments.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridConnectorEquipments,true);
			}
			if(gridPlantItemConnectors.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridPlantItemConnectors,true);
			}
			if(gridSystems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSystems,true);
			}
			if(gridModesForConnectors.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridModesForConnectors,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add PlantItemConnectors.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add PlantItemConnectors.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add PlantItemConnectors.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add PlantItemConnectors.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add PlantItemConnectors.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add PlantItemConnectors.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridPlantItemConnectors);
            Refresh();
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add PlantItemConnectors.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add PlantItemConnectors.SupportsUndo implementation
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add PlantItemConnectors.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add PlantItemConnectors.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add PlantItemConnectors.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add PlantItemConnectors.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add PlantItemConnectors.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add PlantItemConnectors.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add PlantItemConnectors.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add PlantItemConnectors.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add PlantItemConnectors.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}
		private void gridPlantItemConnectors_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
			}
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add PlantItemConnectors.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}

