using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.Serialization;

using Syncfusion.Drawing;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
   


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for PlantLevelUserFormTreeControl.
	/// </summary>
	public class PlantLevelUserFormTreeControl : GridStaticCellModel 
	{
		# region Unused

		/*internal PlantLevelTreeControlStructure  pltcs;

		protected PlantLevelUserFormTreeControl(SerializationInfo info, StreamingContext context)
			: base(info, context)
		{
			ButtonBarSize = new Size(14, 14);
		}
	

		// sets ddForm and also reserves space for our button...
		public PlantLevelUserFormTreeControl(GridModel grid, PlantLevelTreeControlStructure  pltcs)
			: base(grid)
		{
			this.pltcs = pltcs;
			ButtonBarSize = new Size(14, 18);
		}
		//note that this method create our new derived renderer
		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new PlantLevelUserFormTreeControlRenderer(control, this);
		}

		protected override Size OnQueryPrefferedClientSize(Graphics g, int rowIndex, int colIndex, GridStyleInfo style, GridQueryBounds queryBounds)
		{
			Size sz =  base.OnQueryPrefferedClientSize (g, rowIndex, colIndex, style, queryBounds);
			sz.Width = sz.Width + ButtonBarSize.Width;

			return sz;
		}


		public  class PlantLevelUserFormTreeControlRenderer : GridStaticCellRenderer
		{
			internal PlantLevelTreeControlStructure  pltcs;
			private LRRLevels				_lrrLevels=null; //Levels Object
			private LRRLevelLinks			_lrrLevelLinks = null; //Level Links object	
			private LRRApp					_app;
			private bool					isPopulate = false;
			public void initDataStore()
			{
				_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
				_lrrLevels = new LRRLevels();
				_app.DBManagerObj.PopulateCollection(_lrrLevels,false);
				_lrrLevelLinks = new LRRLevelLinks();
				_app.DBManagerObj.PopulateCollection(_lrrLevelLinks,false);   
			}
			public PlantLevelUserFormTreeControlRenderer(GridControlBase grid,GridCellModelBase cellModel)
				: base(grid,cellModel)
			{
				this.pltcs= ((PlantLevelUserFormTreeControl)this.Model).pltcs;
				this.pltcs.Visible = false;
				this.AddButton(new GridCellComboBoxButton(this));
				DropDownPart = new GridDropDownCellImp(this);
				DropDownButton = new GridCellComboBoxButton(this);
				this.pltcs.save += new EventHandler(Opt_save);
				this.pltcs.cancel += new EventHandler(Opt_cancel);  
			}
			public new GridDropDownContainer DropDownContainer
			{
				get{return (GridDropDownContainer)base.DropDownContainer;}
			}
			//			protected override void InitializeDropDownContainer()
			//			{
			//				base.InitializeDropDownContainer ();
			//				if (this.DropDownContainer != null)
			//				{
			//					this.DropDownContainer.Controls.Add(this.pltcs);
			//				}
			//			}
			protected override void OnBeginEdit()
			{
				base.OnBeginEdit ();
				GridCurrentCell cc = this.Grid.CurrentCell;
			}

			protected override void OnButtonClicked(int rowIndex, int colIndex, int button)
			{
				base.OnButtonClicked (rowIndex, colIndex, button);
				GridCurrentCell cc = this.Grid.CurrentCell;
				this.DropDownContainer.Size = pltcs.Size;
				this.pltcs.SetValuesFromString(this.ControlText);
				pltcs.Visible = true;
				//				if(isPopulate == false)
				//				{
				initDataStore();
				populateTree(pltcs.treeView1,_lrrLevels,_lrrLevelLinks); 
				pltcs.treeView1.ExpandAll(); 
				isPopulate = true;
				//}
			}

			public override void DropDownContainerCloseDropDown(object sender, PopupClosedEventArgs e)
			{
				//base.DropDownContainerCloseDropDown (sender, e);
				if (e.PopupCloseType == PopupCloseType.Done)
				{
					if (this.NotifyCurrentCellChanging())
					{
						ControlValue = this.pltcs.GetValuesToString();
						this.NotifyCurrentCellChanged();
					}
				}
				Grid.CurrentCell.EndEdit();
				Grid.CurrentCell.Refresh();      
				base.DropDownContainerCloseDropDown (sender, e);
			}
			protected override void OnDraw(Graphics g, Rectangle clientRectangle, int rowIndex, int colIndex, GridStyleInfo style)
			{
				base.OnDraw (g, clientRectangle, rowIndex, colIndex, style);
				pltcs.Width = clientRectangle.Width;
			}
			protected override void OnInitialize(int rowIndex, int colIndex)
			{
				base.OnInitialize (rowIndex, colIndex);
				pltcs.SetValuesFromString(this.Grid.Model[rowIndex, colIndex].Text);
			}
			protected override bool OnSaveChanges()
			{
				string s = this.pltcs.GetValuesToString();
				this.Grid.Model[this.RowIndex, this.ColIndex].Text = s;
				return true;
			}
			private void Opt_save(object sender, EventArgs e)
			{
				// close the dropdown with a Done setting
				this.Grid.CurrentCell.CloseDropDown(Syncfusion.Windows.Forms.PopupCloseType.Done);
			}
			private void Opt_cancel(object sender, EventArgs e)
			{
				// close the dropdown with a Canceled setting
				this.Grid.CurrentCell.CloseDropDown(Syncfusion.Windows.Forms.PopupCloseType.Canceled);
			}
			protected override void OnClick(int rowIndex, int colIndex, MouseEventArgs e)
			{
				base.OnClick (rowIndex, colIndex, e);
				GridCurrentCell cc = this.Grid.CurrentCell;
				cc.BeginEdit(true); 
			}


			
		}*/
		#endregion

		internal PlantLevelTreeControlStructure pltcs;

		protected PlantLevelUserFormTreeControl(SerializationInfo info,StreamingContext context):base(info,context)
		{

		}
		public PlantLevelUserFormTreeControl(GridModel grid,PlantLevelTreeControlStructure pltcs):base(grid)
		{
			this.pltcs = pltcs;
			ButtonBarSize = new Size(14,14);   
		}
		public override GridCellRendererBase CreateRenderer(GridControlBase control)
		{
			return new PlantLevelUserFormTreeControlRenderer(control,this);
		}
		protected override Size OnQueryPrefferedClientSize(Graphics g, int rowIndex, int colIndex, GridStyleInfo style, GridQueryBounds queryBounds)
		{
			Size sz = base.OnQueryPrefferedClientSize (g, rowIndex, colIndex, style, queryBounds);
			sz.Width = sz.Width +ButtonBarSize.Width;  

			return sz;
		}


		
		public class PlantLevelUserFormTreeControlRenderer : GridStaticCellRenderer 
		{
			internal PlantLevelTreeControlStructure pltcs;
			private LRRLevels				_lrrLevels=null; //Levels Object
			private LRRLevelLinks			_lrrLevelLinks = null; //Level Links object	
			private LRRApp					_app;
			private bool					isPopulate = false;
			private Hashtable				_levelNodeMap = new Hashtable();
			public void initDataStore()
			{
				_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
				_lrrLevels = new LRRLevels();
				_app.DBManagerObj.PopulateCollection(_lrrLevels,false);
				_lrrLevelLinks = new LRRLevelLinks();
				_app.DBManagerObj.PopulateCollection(_lrrLevelLinks,false);   
			}
			public PlantLevelUserFormTreeControlRenderer(GridControlBase grid,GridCellModelBase cellModel)
				:base(grid,cellModel)
			{
				this.pltcs = ((PlantLevelUserFormTreeControl)this.Model).pltcs;
				this.AddButton(new GridCellComboBoxButton(this));
 
			}
			protected override void OnButtonClicked(int rowIndex, int colIndex, int button)
			{
				GridCurrentCell cc = this.Grid.CurrentCell;
				
			/*	this.DropDownContainer.Size = pltcs.Size;
				//this.plts.SetValuesFromString(this.ControlText);*/
				//pltcs.Visible = true;
				if(isPopulate == false)
				{
					initDataStore();
					populateTree(pltcs.treeView1,_lrrLevels,_lrrLevelLinks); 
					isPopulate = true;
				}
				pltcs.treeView1.ExpandAll(); 
				this.Grid.CurrentCell.MoveTo(rowIndex,colIndex);
				this.pltcs.SetValuesFromString(this.Grid.Model[rowIndex, colIndex].Text);
				Rectangle rect = this.Grid.RangeInfoToRectangle(GridRangeInfo.Cell(rowIndex, colIndex));
				int screenBottom = System.Windows.Forms.SystemInformation.WorkingArea.Height;
				int currentPosition =  screenBottom - pltcs.Height;
				if((rect.Bottom + pltcs.Height + rect.Height + 60) > screenBottom)
				{
					this.pltcs.Location = this.Grid.PointToScreen(new Point(rect.Left, rect.Top - pltcs.Height));
				}
				else
				{
					this.pltcs.Location = this.Grid.PointToScreen(new Point(rect.Left, rect.Bottom));
				}

				SetActiveNode(this.Grid.Model[rowIndex, colIndex].Text);

				if(this.pltcs.ShowDialog() == DialogResult.OK)
				{
					this.Grid.Model[rowIndex, colIndex].Text = this.pltcs.GetValuesToString();
				}
					//base.OnButtonClicked (rowIndex, colIndex, button);
			}
			/// <summary>
			/// Has been commented for having Fixed size for Dropdowntree for Levels--- Vihar
			/// </summary>
//			protected override void OnDraw(Graphics g, Rectangle clientRectangle, int rowIndex, int colIndex, GridStyleInfo style)
//			{
//				base.OnDraw (g, clientRectangle, rowIndex, colIndex, style);
//				this.pltcs.Width = clientRectangle.Width;    
//			}

			private bool populateTree(TreeView treeView,LRRLevels levels,LRRLevelLinks levelLinks)
			{
				treeView.Nodes.Clear();
				try
				{
					Hashtable				_levelHash = new Hashtable();
					Hashtable				_nodesHash = new Hashtable();
					Hashtable				_childParent = new Hashtable();

					foreach(LRRLevel l in levels)
					{
						_levelHash.Add(l.LevelID,l);
					}
					foreach(LRRLevelLink ll in levelLinks)
					{
						_childParent.Add(ll.ChildID,ll.ParentID);

						if(_nodesHash.ContainsKey(ll.ParentID))
						{
							TreeNode foundNode = _nodesHash[ll.ParentID] as TreeNode;
							LRRLevel foundLevel = _levelHash[ll.ChildID] as LRRLevel; 
							TreeNode childNode = new TreeNode(foundLevel.Name);
							childNode.Tag = foundLevel;
							foundNode.Nodes.Add(childNode);
							
							if(!_levelNodeMap.ContainsKey(foundLevel.Name))
								_levelNodeMap.Add(foundLevel.Name,childNode);
						}
						else
						{
							LRRLevel parentLevel = _levelHash[ll.ParentID] as LRRLevel;
							LRRLevel childLevel = _levelHash[ll.ChildID] as LRRLevel;
							TreeNode parentNode = new TreeNode(parentLevel.Name);
							parentNode.Tag = parentLevel;
							TreeNode childNode = new TreeNode(childLevel.Name);
							childNode.Tag = childLevel;
							parentNode.Nodes.Add(childNode);
							_nodesHash.Add(ll.ParentID,parentNode);
							if(!_levelNodeMap.ContainsKey(childLevel.Name))
								_levelNodeMap.Add(childLevel.Name,childNode);
							if(!_levelNodeMap.ContainsKey(parentLevel.Name))
								_levelNodeMap.Add(parentLevel.Name,parentNode);
							
						}
					}

					foreach(object k in _childParent.Keys)
					{
						string childID = (string)k;
						string parentID = (string)_childParent[k];
						TreeNode  childNode = null;
						TreeNode  parentNode = null;
						if(_nodesHash.ContainsKey(childID))
						{
							childNode = _nodesHash[childID] as TreeNode;
						}
						if(_nodesHash.ContainsKey(parentID))
						{
							parentNode = _nodesHash[parentID] as TreeNode;
						}
						if((parentNode != null) && (childNode != null))
						{
							int index = -1;
							foreach(TreeNode f in parentNode.Nodes)
							{
								if(f.Tag == childNode.Tag)
								{
									index = f.Index;
									break;
								}
							}
							if(index != -1)
								parentNode.Nodes[index] = childNode;
						}
					}
					TreeNode rootNode = _nodesHash["0"] as TreeNode;
					treeView.Nodes.Add(rootNode);
					return true;
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(PlantLevelUserFormTreeControl),"populateTree:"+ex.Message  ,Logger.Level.Debug);
					return false;
				}
				
			}

			public void SetActiveNode(string name)
			{
				try
				{
					//pltcs.treeView1.SelectedNode = (TreeNode)_levelNodeMap[name];
					SetSelected(pltcs.treeView1.Nodes[0],name);
					//this.pltcs.treeView1.Select();
					//this.pltcs.treeView1.Refresh();   
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(PlantLevelUserFormTreeControl),"SetActiveNode:"+ex.Message  ,Logger.Level.Debug);
				}
			}

			private void SetSelected(TreeNode tn,string treeNodeText)
			{
				foreach(TreeNode tn1 in tn.Nodes)
				{
					if(tn1.Text == treeNodeText)
					{
						pltcs.treeView1.SelectedNode = tn1;
						this.pltcs.treeView1.Select();
						this.pltcs.treeView1.Refresh();   
						return;
					}
					if(tn1.Nodes.Count> 0)
					{
						SetSelected(tn1,treeNodeText);
					}
				}
				pltcs.treeView1.SelectedNode = pltcs.treeView1.Nodes[0];
			}
		}
			
	}

}


