using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Tools;
using Symcon.LightRidge.PEAdvisor;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using System.Diagnostics;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;
using System.Collections.Generic;

namespace Symcon.LightRidge.PEAdvisor
{
	///	<summary>
	///	Summary	description	for	PlantTreeStructure.
	///	</summary>
	public class PropHistorianSiteCompMapping :	System.Windows.Forms.Form,ILRRUIContainer
	{
		private	System.ComponentModel.IContainer components;

		private	LRRMasterComponents	mcs;
		private	System.Windows.Forms.Panel pnlPlantStructure;
		private	System.Windows.Forms.Splitter splitter1;
		private	System.Windows.Forms.Panel pnlTreeFind;
		private	Syncfusion.Windows.Forms.Tools.TreeViewAdv treeViewAdv1;
		private	System.Windows.Forms.Panel pnlMappingResults;
		private	System.Windows.Forms.Splitter splitter3;
		private	System.Windows.Forms.Panel pnlHistorianMap;
		private	System.Windows.Forms.Panel pnlMapping;
		private	System.Windows.Forms.Panel panel1;
		private	System.Windows.Forms.Panel pnlHistorianTags;
		private	Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridHistTags;
		private	System.Windows.Forms.Splitter splitter2;
		private	System.Windows.Forms.Panel pnlSiteCompProps;
		private	System.Windows.Forms.Panel mapToolBar;
		private	Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar xpToolBar1;
		private	Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridComponentProperties;
		private	Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridComponentHistMapping;


		private	LRRSiteComponent selectedSiteComponent = null;
		private	LRRSiteComponentProperty selectedSiteComponentPpty = null;
		

		private	Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btnMap;
		private	System.Windows.Forms.ImageList imageList1;
		private	System.Windows.Forms.Label label1;
		private	System.Windows.Forms.TextBox txtFind;
		private	System.Windows.Forms.Button	btnFind;

		private	LRRComponentTypes lrrCompTypes = null;
		private bool isFound;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuEdit;
		Hashtable _oForAlerts;

		
		private TabControl			_parentTabControl;
		private System.Windows.Forms.Label lblMappingName;
		private System.Windows.Forms.ContextMenu contextMenuOverrideMapping;
		private System.Windows.Forms.MenuItem menuItem1;
		private TabPage				_parentTabPage;


		public PropHistorianSiteCompMapping()
		{

			_lrrapp	= AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			
			InitializeComponent();

			treeViewAdv1.AfterSelect+=new EventHandler(treeViewAdv_AfterSelect);

			_siteCompGroupedProperties = LRRModel.SiteComponentGroupPropertiesObj;//new LRRSiteComponentGroupProperties();
			//_lrrapp.DBManagerObj.PopulateCollection(_siteCompGroupedProperties,false);

			//--get the grouped property values where the hist tag will be maped for modeid = 1
			//_siteGroupPropertyQualifierValues = new LRRSiteGroupPropertyQualifierValues();

//			 LEGACY CODE
//			_lrrapp.DBManagerObj.PopulateCollection(_siteGroupPropertyQualifierValues,false);
			_siteGroupPropertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj;

			BindGrids();
			//Map to the Save and the Click	for	the	XP Toolbar...
			
			
			this.btnMap.Click+=new EventHandler(Map_Click);
			//this.btnSave.Click+=new	EventHandler(Save_Click);


			//Population of	the	Tree View...
			PopulateTreeView();

			//			gridComponentProperties.TableOptions.ListBoxSelectionColorOptions =	GridListBoxSelectionColorOptions.ApplySelectionColor;
			//			gridComponentProperties.TableOptions.SelectionBackColor	= Color.Red;

			_oForAlerts = _lrrapp.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;
			gridComponentProperties.TableDescriptor.Name = "LRRPlantItemProperties";
			gridComponentHistMapping.TableDescriptor.Name = "LRRCompPropHistPropMappings";
			

		}

		///	<summary>
		///	Clean up any resources being used.
		///	</summary>
		protected override void	Dispose( bool disposing	)
		{
			if(	disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing	);
		}

		#region	Windows	Form Designer generated	code
		///	<summary>
		///	Required method	for	Designer support - do not modify
		///	the	contents of	this method	with the code editor.
		///	</summary>
		private	void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(PropHistorianSiteCompMapping));
			Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo treeNodeAdvStyleInfo1 = new Syncfusion.Windows.Forms.Tools.TreeNodeAdvStyleInfo();
			this.btnMap = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.pnlPlantStructure = new System.Windows.Forms.Panel();
			this.treeViewAdv1 = new Syncfusion.Windows.Forms.Tools.TreeViewAdv();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuEdit = new System.Windows.Forms.MenuItem();
			this.pnlTreeFind = new System.Windows.Forms.Panel();
			this.btnFind = new System.Windows.Forms.Button();
			this.txtFind = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlMappingResults = new System.Windows.Forms.Panel();
			this.pnlHistorianMap = new System.Windows.Forms.Panel();
			this.lblMappingName = new System.Windows.Forms.Label();
			this.gridComponentHistMapping = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.pnlMapping = new System.Windows.Forms.Panel();
			this.panel1 = new System.Windows.Forms.Panel();
			this.pnlHistorianTags = new System.Windows.Forms.Panel();
			this.gridHistTags = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.pnlSiteCompProps = new System.Windows.Forms.Panel();
			this.gridComponentProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.mapToolBar = new System.Windows.Forms.Panel();
			this.xpToolBar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar();
			this.contextMenuOverrideMapping = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.pnlPlantStructure.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.treeViewAdv1)).BeginInit();
			this.pnlTreeFind.SuspendLayout();
			this.pnlHistorianMap.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridComponentHistMapping)).BeginInit();
			this.pnlMapping.SuspendLayout();
			this.panel1.SuspendLayout();
			this.pnlHistorianTags.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridHistTags)).BeginInit();
			this.pnlSiteCompProps.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridComponentProperties)).BeginInit();
			this.mapToolBar.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnMap
			// 
			this.btnMap.CategoryIndex = -1;
			this.btnMap.ID = "MAP";
			this.btnMap.ImageIndex = 3;
			this.btnMap.ImageList = this.imageList1;
			this.btnMap.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.btnMap.Tag = "SID_MAPPPTY";
			// 
			// imageList1
			// 
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			this.imageList1.Images.SetKeyName(0, "");
			this.imageList1.Images.SetKeyName(1, "");
			this.imageList1.Images.SetKeyName(2, "");
			this.imageList1.Images.SetKeyName(3, "");
			this.imageList1.Images.SetKeyName(4, "");
			// 
			// pnlPlantStructure
			// 
			this.pnlPlantStructure.Controls.Add(this.treeViewAdv1);
			this.pnlPlantStructure.Controls.Add(this.pnlTreeFind);
			this.pnlPlantStructure.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlPlantStructure.Location = new System.Drawing.Point(0, 0);
			this.pnlPlantStructure.Name = "pnlPlantStructure";
			this.pnlPlantStructure.Size = new System.Drawing.Size(280, 526);
			this.pnlPlantStructure.TabIndex = 13;
			// 
			// treeViewAdv1
			// 
			this.treeViewAdv1.AllowMouseBasedSelection = true;
			treeNodeAdvStyleInfo1.EnsureDefaultOptionedChild = true;
			this.treeViewAdv1.BaseStylePairs.AddRange(new Syncfusion.Windows.Forms.Tools.StyleNamePair[] {
            new Syncfusion.Windows.Forms.Tools.StyleNamePair("Standard", treeNodeAdvStyleInfo1)});
			this.treeViewAdv1.Border3DStyle = System.Windows.Forms.Border3DStyle.Adjust;
			this.treeViewAdv1.BorderColor = System.Drawing.Color.Black;
			this.treeViewAdv1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.treeViewAdv1.ContextMenu = this.contextMenu1;
			this.treeViewAdv1.Dock = System.Windows.Forms.DockStyle.Fill;
			// 
			// 
			// 
			this.treeViewAdv1.HelpTextControl.BackColor = System.Drawing.SystemColors.InactiveCaption;
			this.treeViewAdv1.HelpTextControl.BackgroundColor = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.Info);
			this.treeViewAdv1.HelpTextControl.Border3DStyle = System.Windows.Forms.Border3DStyle.Sunken;
			this.treeViewAdv1.HelpTextControl.BorderSingle = System.Windows.Forms.ButtonBorderStyle.Solid;
			this.treeViewAdv1.HelpTextControl.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.treeViewAdv1.HelpTextControl.IgnoreKeys = true;
			this.treeViewAdv1.HelpTextControl.InheritHostCursor = true;
			this.treeViewAdv1.HelpTextControl.Location = new System.Drawing.Point(732, 0);
			this.treeViewAdv1.HelpTextControl.Name = "helpText";
			this.treeViewAdv1.HelpTextControl.RestrictWidth = 0;
			this.treeViewAdv1.HelpTextControl.Size = new System.Drawing.Size(50, 17);
			this.treeViewAdv1.HelpTextControl.TabIndex = 0;
			this.treeViewAdv1.HelpTextControl.Text = "help text";
			this.treeViewAdv1.HelpTextControl.Visible = false;
			this.treeViewAdv1.HorizontalThumbTrack = true;
			this.treeViewAdv1.KeepDottedSelection = true;
			this.treeViewAdv1.KeepDragCapturePoint = false;
			this.treeViewAdv1.LeftImageList = this.imageList1;
			this.treeViewAdv1.Location = new System.Drawing.Point(0, 40);
			this.treeViewAdv1.Name = "treeViewAdv1";
			this.treeViewAdv1.Size = new System.Drawing.Size(280, 486);
			this.treeViewAdv1.SmartSizeBox = false;
			this.treeViewAdv1.TabIndex = 2;
			this.treeViewAdv1.Text = "treeViewAdv1";
			// 
			// 
			// 
			this.treeViewAdv1.ToolTipControl.BackColor = System.Drawing.SystemColors.Info;
			this.treeViewAdv1.ToolTipControl.BackgroundColor = new Syncfusion.Drawing.BrushInfo();
			this.treeViewAdv1.ToolTipControl.Border3DStyle = System.Windows.Forms.Border3DStyle.Sunken;
			this.treeViewAdv1.ToolTipControl.BorderSingle = System.Windows.Forms.ButtonBorderStyle.Solid;
			this.treeViewAdv1.ToolTipControl.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.treeViewAdv1.ToolTipControl.IgnoreKeys = true;
			this.treeViewAdv1.ToolTipControl.InheritHostCursor = true;
			this.treeViewAdv1.ToolTipControl.Location = new System.Drawing.Point(642, 0);
			this.treeViewAdv1.ToolTipControl.Name = "toolTip";
			this.treeViewAdv1.ToolTipControl.RestrictWidth = 0;
			this.treeViewAdv1.ToolTipControl.Size = new System.Drawing.Size(41, 17);
			this.treeViewAdv1.ToolTipControl.TabIndex = 1;
			this.treeViewAdv1.ToolTipControl.Text = "toolTip";
			this.treeViewAdv1.ToolTipControl.Visible = false;
			this.treeViewAdv1.VerticalThumbTrack = true;
			this.treeViewAdv1.VScrollPos = 1;
			this.treeViewAdv1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.treeViewAdv1_MouseMove);
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuEdit});
			// 
			// menuEdit
			// 
			this.menuEdit.Index = 0;
			this.menuEdit.Shortcut = System.Windows.Forms.Shortcut.CtrlM;
			this.menuEdit.Text = "Modify Plant Item";
			this.menuEdit.Click += new System.EventHandler(this.menuEdit_Click);
			// 
			// pnlTreeFind
			// 
			this.pnlTreeFind.BackColor = System.Drawing.SystemColors.Control;
			this.pnlTreeFind.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlTreeFind.Controls.Add(this.btnFind);
			this.pnlTreeFind.Controls.Add(this.txtFind);
			this.pnlTreeFind.Controls.Add(this.label1);
			this.pnlTreeFind.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlTreeFind.Location = new System.Drawing.Point(0, 0);
			this.pnlTreeFind.Name = "pnlTreeFind";
			this.pnlTreeFind.Size = new System.Drawing.Size(280, 40);
			this.pnlTreeFind.TabIndex = 0;
			// 
			// btnFind
			// 
			this.btnFind.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
			this.btnFind.ImageIndex = 2;
			this.btnFind.ImageList = this.imageList1;
			this.btnFind.Location = new System.Drawing.Point(208, 8);
			this.btnFind.Name = "btnFind";
			this.btnFind.Size = new System.Drawing.Size(64, 24);
			this.btnFind.TabIndex = 3;
			this.btnFind.Tag = "SID_FIND";
			this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
			// 
			// txtFind
			// 
			this.txtFind.Location = new System.Drawing.Point(64, 8);
			this.txtFind.Name = "txtFind";
			this.txtFind.Size = new System.Drawing.Size(128, 20);
			this.txtFind.TabIndex = 2;
			this.txtFind.TextChanged += new System.EventHandler(this.txtFind_TextChanged);
			// 
			// label1
			// 
			this.label1.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 1;
			this.label1.Tag = "SID_FINDITEM";
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(280, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 526);
			this.splitter1.TabIndex = 14;
			this.splitter1.TabStop = false;
			// 
			// pnlMappingResults
			// 
			this.pnlMappingResults.Location = new System.Drawing.Point(160, -8);
			this.pnlMappingResults.Name = "pnlMappingResults";
			this.pnlMappingResults.Size = new System.Drawing.Size(432, 216);
			this.pnlMappingResults.TabIndex = 12;
			// 
			// pnlHistorianMap
			// 
			this.pnlHistorianMap.Controls.Add(this.lblMappingName);
			this.pnlHistorianMap.Controls.Add(this.gridComponentHistMapping);
			this.pnlHistorianMap.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlHistorianMap.Location = new System.Drawing.Point(283, 310);
			this.pnlHistorianMap.Name = "pnlHistorianMap";
			this.pnlHistorianMap.Size = new System.Drawing.Size(653, 216);
			this.pnlHistorianMap.TabIndex = 15;
			// 
			// lblMappingName
			// 
			this.lblMappingName.BackColor = System.Drawing.SystemColors.ControlDark;
			this.lblMappingName.Location = new System.Drawing.Point(8, 8);
			this.lblMappingName.Name = "lblMappingName";
			this.lblMappingName.Size = new System.Drawing.Size(208, 16);
			this.lblMappingName.TabIndex = 1;
			this.lblMappingName.Text = "Historian Mapping";
			this.lblMappingName.Visible = false;
			// 
			// gridComponentHistMapping
			// 
			this.gridComponentHistMapping.Appearance.GroupCaptionCell.AutoSize = true;
			this.gridComponentHistMapping.Appearance.GroupCaptionCell.Trimming = System.Drawing.StringTrimming.None;
			this.gridComponentHistMapping.Appearance.GroupCaptionCell.WrapText = false;
			this.gridComponentHistMapping.BackColor = System.Drawing.SystemColors.Window;
			this.gridComponentHistMapping.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridComponentHistMapping.Location = new System.Drawing.Point(0, 0);
			this.gridComponentHistMapping.Name = "gridComponentHistMapping";
			this.gridComponentHistMapping.Size = new System.Drawing.Size(653, 216);
			this.gridComponentHistMapping.TabIndex = 0;
			this.gridComponentHistMapping.TableDescriptor.AllowEdit = false;
			this.gridComponentHistMapping.TableDescriptor.AllowNew = false;
			this.gridComponentHistMapping.TableDescriptor.AllowRemove = false;
			this.gridComponentHistMapping.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Table)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)
							| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridComponentHistMapping.TableOptions.AllowSortColumns = true;
			this.gridComponentHistMapping.Text = "gridGroupingControl1";
			this.gridComponentHistMapping.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridComponentHistMapping.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridComponentHistMapping.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridComponentHistMapping.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridComponentHistMapping.VersionInfo = "3.301.0.0";
			this.gridComponentHistMapping.TableControlCurrentCellValidating += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventHandler(this.gridComponentHistMapping_TableControlCurrentCellValidating);
			this.gridComponentHistMapping.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridComponentHistMapping_TableControlCellClick);
			this.gridComponentHistMapping.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.gridComponentHistMapping_QueryCellStyleInfo);
			this.gridComponentHistMapping.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridComponentHistMapping_RecordDeleting);
			// 
			// splitter3
			// 
			this.splitter3.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter3.Location = new System.Drawing.Point(283, 307);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(653, 3);
			this.splitter3.TabIndex = 16;
			this.splitter3.TabStop = false;
			// 
			// pnlMapping
			// 
			this.pnlMapping.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlMapping.Controls.Add(this.panel1);
			this.pnlMapping.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMapping.Location = new System.Drawing.Point(283, 0);
			this.pnlMapping.Name = "pnlMapping";
			this.pnlMapping.Size = new System.Drawing.Size(653, 307);
			this.pnlMapping.TabIndex = 17;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.pnlHistorianTags);
			this.panel1.Controls.Add(this.splitter2);
			this.panel1.Controls.Add(this.pnlSiteCompProps);
			this.panel1.Controls.Add(this.mapToolBar);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(651, 305);
			this.panel1.TabIndex = 18;
			// 
			// pnlHistorianTags
			// 
			this.pnlHistorianTags.Controls.Add(this.gridHistTags);
			this.pnlHistorianTags.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlHistorianTags.Location = new System.Drawing.Point(291, 40);
			this.pnlHistorianTags.Name = "pnlHistorianTags";
			this.pnlHistorianTags.Size = new System.Drawing.Size(360, 265);
			this.pnlHistorianTags.TabIndex = 18;
			// 
			// gridHistTags
			// 
			this.gridHistTags.Appearance.GroupCaptionCell.AutoSize = true;
			this.gridHistTags.Appearance.GroupCaptionCell.WrapText = false;
			this.gridHistTags.BackColor = System.Drawing.SystemColors.Window;
			this.gridHistTags.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridHistTags.Location = new System.Drawing.Point(0, 0);
			this.gridHistTags.Name = "gridHistTags";
			this.gridHistTags.Size = new System.Drawing.Size(360, 265);
			this.gridHistTags.TabIndex = 15;
			this.gridHistTags.TableDescriptor.AllowEdit = false;
			this.gridHistTags.TableDescriptor.AllowNew = false;
			this.gridHistTags.TableDescriptor.AllowRemove = false;
			this.gridHistTags.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridHistTags.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridHistTags.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridHistTags.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridHistTags.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridHistTags.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridHistTags.TableOptions.AllowSortColumns = true;
			this.gridHistTags.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridHistTags.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridHistTags.Text = "gridGroupingControl1";
			this.gridHistTags.ThemesEnabled = false;
			this.gridHistTags.VersionInfo = "3.301.0.0";
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(288, 40);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 265);
			this.splitter2.TabIndex = 17;
			this.splitter2.TabStop = false;
			// 
			// pnlSiteCompProps
			// 
			this.pnlSiteCompProps.Controls.Add(this.gridComponentProperties);
			this.pnlSiteCompProps.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlSiteCompProps.Location = new System.Drawing.Point(0, 40);
			this.pnlSiteCompProps.Name = "pnlSiteCompProps";
			this.pnlSiteCompProps.Size = new System.Drawing.Size(288, 265);
			this.pnlSiteCompProps.TabIndex = 16;
			// 
			// gridComponentProperties
			// 
			this.gridComponentProperties.Appearance.GroupCaptionCell.AutoSize = true;
			this.gridComponentProperties.Appearance.GroupCaptionCell.WrapText = false;
			this.gridComponentProperties.BackColor = System.Drawing.SystemColors.Window;
			this.gridComponentProperties.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridComponentProperties.Location = new System.Drawing.Point(0, 0);
			this.gridComponentProperties.Name = "gridComponentProperties";
			this.gridComponentProperties.Size = new System.Drawing.Size(288, 265);
			this.gridComponentProperties.TabIndex = 16;
			this.gridComponentProperties.TableDescriptor.AllowEdit = false;
			this.gridComponentProperties.TableDescriptor.AllowNew = false;
			this.gridComponentProperties.TableDescriptor.AllowRemove = false;
			this.gridComponentProperties.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridComponentProperties.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridComponentProperties.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridComponentProperties.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridComponentProperties.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridComponentProperties.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row;
			this.gridComponentProperties.TableOptions.AllowSortColumns = true;
			this.gridComponentProperties.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridComponentProperties.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridComponentProperties.Text = "gridGroupingControl1";
			this.gridComponentProperties.ThemesEnabled = false;
			this.gridComponentProperties.VersionInfo = "3.301.0.0";
			this.gridComponentProperties.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridComponentProperties_TableControlCellClick);
			// 
			// mapToolBar
			// 
			this.mapToolBar.Controls.Add(this.xpToolBar1);
			this.mapToolBar.Dock = System.Windows.Forms.DockStyle.Top;
			this.mapToolBar.Location = new System.Drawing.Point(0, 0);
			this.mapToolBar.Name = "mapToolBar";
			this.mapToolBar.Size = new System.Drawing.Size(651, 40);
			this.mapToolBar.TabIndex = 15;
			// 
			// xpToolBar1
			// 
			this.xpToolBar1.Dock = System.Windows.Forms.DockStyle.Top;
			this.xpToolBar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.btnMap});
			this.xpToolBar1.Location = new System.Drawing.Point(0, 0);
			this.xpToolBar1.Name = "xpToolBar1";
			this.xpToolBar1.Size = new System.Drawing.Size(651, 31);
			this.xpToolBar1.TabIndex = 19;
			this.xpToolBar1.Text = "xpToolBar1";
			this.xpToolBar1.ThemesEnabled = true;
			this.xpToolBar1.Click += new System.EventHandler(this.xpToolBar1_Click);
			// 
			// contextMenuOverrideMapping
			// 
			this.contextMenuOverrideMapping.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "Override Mapping";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click_1);
			// 
			// PropHistorianSiteCompMapping
			// 
			this.AcceptButton = this.btnFind;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(936, 526);
			this.Controls.Add(this.pnlMapping);
			this.Controls.Add(this.splitter3);
			this.Controls.Add(this.pnlHistorianMap);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.pnlPlantStructure);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "PropHistorianSiteCompMapping";
			this.Tag = "530";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.pnlPlantStructure.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.treeViewAdv1)).EndInit();
			this.pnlTreeFind.ResumeLayout(false);
			this.pnlTreeFind.PerformLayout();
			this.pnlHistorianMap.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridComponentHistMapping)).EndInit();
			this.pnlMapping.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.pnlHistorianTags.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridHistTags)).EndInit();
			this.pnlSiteCompProps.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridComponentProperties)).EndInit();
			this.mapToolBar.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region	Fields

		private	LRRApp									_lrrapp;
		//private LRRUIManager							lrrUI=new LRRUIManager();
		private LRRUserHistDatas							_lrrHist;
		private LRRSiteComponentGroupProperties			_siteCompGroupedProperties;
		private LRRSiteGroupPropertyQualifierValues		_siteGroupPropertyQualifierValues;
		private	LRRSiteComponentProperties				_lrrSiteCompPpties;
		private	LRRSiteGroupPropertyQualifierValues		_lrrSiteCompGrpQualifierValues;
		private LRRHistDatas							_lrrHistDataUp;
		ToolTip											tooltip = new ToolTip();
		int												oldIndex = -1;
		private	LRRApp									lrrApp;

		#endregion


		private	void treeViewAdv_AfterSelect(object	sender,	System.EventArgs e)
		{
			
			this.Cursor=Cursors.WaitCursor;
			bool isGrouped = false;

			gridHistTags.TableControl.Model.Selections.Clear();
			gridComponentProperties.TableControl.Model.Selections.Clear();
			gridComponentHistMapping.TableControl.Model.Selections.Clear();
			LRRPlantItemProperties propertiesObj= new LRRPlantItemProperties();
			LRRSiteComponentProperties prop =	new	LRRSiteComponentProperties();
			LRRSiteComponentGroupProperties grprop =	new	LRRSiteComponentGroupProperties();
			LRRSiteGroupPropertyQualifierValues grPropValues =	new	LRRSiteGroupPropertyQualifierValues();
			LRRCompPropHistPropMappings hMaps = new LRRCompPropHistPropMappings();
			
			LRRSiteComponent lsc = treeViewAdv1.SelectedNode.Tag  as LRRSiteComponent;  
			selectedSiteComponent =	lsc;

			if(lsc != null)
			{
				if(!lsc.IsDynamic)
				{
					prop = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(lsc.SiteComponentID);
					//_lrrapp.DBManagerObj.PopulateCollection(prop," WHERE	ComponentID	= '" + lsc.SiteComponentID + "'",true);
					//foreach(LRRHistPropCompPropMapping map in LRRModel.HistPropMaps)
					foreach(LRRCompPropHistPropMapping map in LRRModel.CompPropHistPropMappings)

					{
						if(map.ComponentID == lsc.SiteComponentID)
						{
							//This check is to assign the proxy SiteCompoentPropID for the view manipulation...
							if(map.GroupPropertyValID != null && map.GroupPropertyValID != "")
							{
								//Get Previous Object State..
								Symcon.Globals.Enums.DBOperation previousObjectState = map.ObjectState;
								map.SiteComponentPropID = map.GroupPropertyValID;
								//assign the previous object state...
								map.ObjectState = previousObjectState;
							}
							hMaps.Add(map);
						}
						 
					}
				}
				else
				{
//					LRRDynamicSiteComponentProperties dynamicSiteCompProps = LRRDynamicModel.DynamicSiteComponentProperties.GetDynamicSiteComponentPropertiesByComponentID(lsc.SiteComponentID);
//					IEnumerator iEnum = dynamicSiteCompProps.GetEnumerator();
//					while(iEnum.MoveNext())
//					{
//						LRRDynamicSiteComponentProperty lrrDynamicSiteComponentProperty = iEnum.Current as LRRDynamicSiteComponentProperty;
//						LRRSiteComponentProperty lrrSiteCompProp = new LRRSiteComponentProperty();
//						lrrSiteCompProp.ID = lrrDynamicSiteComponentProperty.ID;
//						lrrSiteCompProp.HistTagID = lrrDynamicSiteComponentProperty.HistTagID;
//						lrrSiteCompProp.ComponentID = lrrDynamicSiteComponentProperty.ComponentID;
//						lrrSiteCompProp.EffectivePlantTime = lrrDynamicSiteComponentProperty.EffectivePlantTime;
//						lrrSiteCompProp.IsDynamic = true;
//						lrrSiteCompProp.ModeID = lrrDynamicSiteComponentProperty.ModeID;
//						lrrSiteCompProp.Name = lrrDynamicSiteComponentProperty.Name;
//						lrrSiteCompProp.PropertyID = lrrDynamicSiteComponentProperty.PropertyID;
//						lrrSiteCompProp.Type = lrrDynamicSiteComponentProperty.Type;
//						prop.Add(lrrSiteCompProp);
//					}
//
//					//_lrrapp.DBManagerObj.PopulateCollection(prop," WHERE	ComponentID	= '" + lsc.SiteComponentID + "'",true);
//					foreach(LRRDynamicHistPropCompPropMapping map in LRRDynamicModel.DynamicHistPropCompPropMappings)
//					{
//						if(map.ComponentID == lsc.SiteComponentID)
//						{
//							//This check is to assign the proxy SiteCompoentPropID for the view manipulation...
//							if(map.GroupPropertyValID != null && map.GroupPropertyValID != "")
//							{
//								//Get Previous Object State..
//								Symcon.Globals.Enums.DBOperation previousObjectState = map.ObjectState;
//								map.SiteComponentPropID = map.GroupPropertyValID;
//								//assign the previous object state...
//								map.ObjectState = previousObjectState;
//							}
//
//							LRRHistPropCompPropMapping histMap = new LRRHistPropCompPropMapping();
//							histMap.ComponentID = map.ComponentID;
//							histMap.ComponentPropertyName = map.ComponentPropertyName;
//							histMap.EffectivePlantTime = map.EffectivePlantTime;
//							histMap.GroupPropertyID = map.GroupPropertyID;
//							histMap.GroupPropertyValID = map.GroupPropertyValID;
//							histMap.HistPropID = map.HistPropID;
//							histMap.HistTag = map.HistTag;
//							histMap.LookUpPropertiesID = map.LookUpPropertiesID;
//							histMap.LookupQualifierID = map.LookupQualifierID;
//							histMap.MappingId = map.MappingId;
//							histMap.SiteComponentPropID = map.SiteComponentPropID;
//							histMap.SiteComponentPropValID = map.SiteComponentPropValID;
//							histMap.IsDynamic = true;
//							hMaps.Add(histMap);
//						}
//					}
				}
				//_lrrapp.DBManagerObj.PopulateCollection(hMaps," WHERE ComponentID = '" + lsc.SiteComponentID + "'",true);
				lsc.Properties = prop;
			 	lsc.WriteHisMaps = hMaps;

				foreach(LRRSiteComponentProperty ex in lsc.Properties)
                {
                    if (ex.Type == "1" && ex.ModeID == true)
                    {
                        LRRPlantItemProperty propertyObj = new LRRPlantItemProperty();
                        propertyObj.ID = ex.ID;
                        propertyObj.PropertyID = ex.ID;
                        propertyObj.Name = ex.Name;
                        propertyObj.Description = ex.Description;
                        propertiesObj.Add(propertyObj);
                        propertyObj = null;
                    }
                    //LRRSiteComponentProperty sp = prop[0] as LRRSiteComponentProperty;

                    //Commented by Nidhig as this can be retrieved from the existing grpProp collection
                    //_lrrapp.DBManagerObj.PopulateCollection(grprop," WHERE	SiteComponentPropID	= '" + ex.ID + "'",true);

                    //--Revised the logic to implement changes in GP
                    grprop = _siteCompGroupedProperties.GetSiteCompGroupPropFromSiteCompPropID(ex.ID);
                    foreach (LRRSiteComponentGroupProperty gp in grprop)
                    {

                        if (gp.SiteComponentPropID != ex.ID)
                            continue;

                        foreach (IPropertyValue IgrPropValue in _siteGroupPropertyQualifierValues.GetGroupQualifierValuesFromGroupPropID(gp.GroupPropertyID))
                        {
                            LRRSiteGroupPropertyQualifierValue grPropValue = IgrPropValue as LRRSiteGroupPropertyQualifierValue;
                            string sModeID = "";

                            sModeID = grPropValue.ModeID == null ? "" : grPropValue.ModeID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                            if (sModeID == "1")
                            {
                                string grpPropIdentifier = "";

                                //ex.Name + " / " + gp.AttributeName + " / " + sQualifierName + " [ Grouped ]"
                                if (grPropValue.QualifierID != null && grPropValue.QualifierID != "")
                                {
                                    grpPropIdentifier = ex.Name + " / " + gp.AttributeName + " / " + LRRModel.Qualifiers.getQualifierObjectForQualifierID(grPropValue.QualifierID).Name + LRRMessages.GetMessageString("SID_GROUP_MAPPING");
                                }
                                else
                                {
                                    grpPropIdentifier = ex.Name + " / " + gp.AttributeName + LRRMessages.GetMessageString("SID_DATA_ARRAY_MAPPING");
                                }

                                LRRPlantItemProperty propertyObj1 = new LRRPlantItemProperty();

                                propertyObj1.ID = grPropValue.SiteGroupPropertyQualifierValueID/*gp.SiteComponentPropID*/;
                                propertyObj1.PropertyID = gp.SiteComponentPropID;
                                propertyObj1.GroupPropertyID = gp.GroupPropertyID;
                                propertyObj1.SiteGroupPropertyQualifierValueID = grPropValue.SiteGroupPropertyQualifierValueID;
                                propertyObj1.Name =/*ex.Name + " / " + gp.AttributeName + " / " + sQualifierName + " [ Grouped ]"*/grpPropIdentifier;
                                propertyObj1.Description = gp.AttributeDescription;
                                propertyObj1.LookupQualifierID = grPropValue.LookUpQualifierID;
                                propertyObj1.LookupPropertiesID = grPropValue.LookUpPropertiesID;
                                propertiesObj.Add(propertyObj1);
                                propertyObj1 = null;
                            }
                        }
                    }
                }

				gridComponentProperties.DataSource = null;
				gridComponentProperties.DataSource=propertiesObj;
				//gridComponentProperties.TableDescriptor.Columns.Clear();
				//gridComponentProperties.TableDescriptor.Columns.Add("Attribute Name","Name");
				//gridComponentProperties.TableDescriptor.Columns.Add("Attribute Description","Description");

				gridComponentProperties.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES_FOR")+	lsc.Name + ", [ " + LRRHeaderText.GetHeaderString("SID_EQUIP_TAG") + lsc.EquipmentTag + "] : {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS"); 
				gridComponentHistMapping.TopLevelGroupOptions.CaptionText =	LRRHeaderText.GetHeaderString("SID_HIST_MAPPING_FOR")+ lsc.Name + ", [ " + LRRHeaderText.GetHeaderString("SID_EQUIP_TAG") + lsc.EquipmentTag + "] : {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS"); 
				
				gridComponentHistMapping.TableDescriptor.Relations.Clear();
				gridComponentHistMapping.TableDescriptor.RelationChildColumns.Clear();
				if(gridComponentHistMapping.TableDescriptor.GroupedColumns.Count > 0)
					isGrouped = true;

				gridComponentHistMapping.TableDescriptor.GroupedColumns.Clear();

				gridComponentHistMapping.DataSource	= null;
	 			gridComponentHistMapping.DataSource	= lsc.WriteHisMaps;
			
				for(int i=0;i<gridComponentHistMapping.TableDescriptor.Columns.Count;i++)
				{
					if(gridComponentHistMapping.TableDescriptor.Columns[i].Name	== LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME"))
					{
						GridTableCellStyleInfo gtc = gridComponentHistMapping.TableDescriptor.Columns[i].Appearance.AnyRecordFieldCell;
						gtc.DataSource = propertiesObj;
						break;
					}
				}

			}
			else
			{
				gridComponentProperties.DataSource = null;
				gridComponentProperties.TopLevelGroupOptions.CaptionText = " {RecordCount} " +LRRHeaderText.GetHeaderString("SID_ITEMS");
				gridComponentHistMapping.TopLevelGroupOptions.CaptionText =	" {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");	

				gridComponentHistMapping.TableDescriptor.Relations.Clear();
				gridComponentHistMapping.TableDescriptor.RelationChildColumns.Clear();
				if(gridComponentHistMapping.TableDescriptor.GroupedColumns.Count > 0)
					isGrouped = true;
				gridComponentHistMapping.TableDescriptor.GroupedColumns.Clear();
				gridComponentHistMapping.DataSource	= null;
			}
			
			GridSummaryColumnDescriptor sd0 = new GridSummaryColumnDescriptor();
			sd0.Name = "Name";
			sd0.DataMember = "SiteComponentPropID";
			sd0.DisplayColumn = "SiteComponentPropID";
			sd0.Format = "{Name}";
			sd0.SummaryType = SummaryType.Custom;
			
			gridComponentHistMapping.TableDescriptor.SummaryRows.Clear();
			gridComponentHistMapping.TableDescriptor.SummaryRows.Add(new GridSummaryRowDescriptor("Row 0", "Name", sd0));
			gridComponentHistMapping.TableDescriptor.SummaryRows["Row 0"].Visible = false;

			// Setup custom summaries
			gridComponentHistMapping.QueryCustomSummary -= new GridQueryCustomSummaryEventHandler(gridComponentHistMapping_QueryCustomSummary);
			gridComponentHistMapping.QueryCustomSummary += new GridQueryCustomSummaryEventHandler(gridComponentHistMapping_QueryCustomSummary);
			//gridComponentHistMapping.TableDescriptor.GroupedColumns.Clear();
			if(isGrouped)
				gridComponentHistMapping.TableDescriptor.GroupedColumns.Add("SiteComponentPropID");
			gridComponentHistMapping.ChildGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") + "-" + "{Row 0.Name}"+ ": {RecordCount} " +LRRHeaderText.GetHeaderString("SID_ITEMS");

			this.Cursor=Cursors.Default;
		}

		private	void Map_Click(object sender, EventArgs	e)
		{
			gridComponentHistMapping.ChildGroupOptions.IsExpandedInitialValue = true;
			if(!_lrrapp.GetOptions().EnablePET)
				MappingWithoutPET();
			else
				MappingWithPET();
		}

		private void MappingWithPET()
		{
			int	k =	 lrrCompTypes.Count; 
			if(selectedSiteComponent ==	null)
				return;

	 		LRRUserHistData	 histData =	null;
			LRRPlantItemProperty propertyObj=null;
			try
			{
				histData = gridHistTags.CurrencyManager.Current	as LRRUserHistData;
				propertyObj =	gridComponentProperties.CurrencyManager.Current	as LRRPlantItemProperty;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithPET:"+ex.Message  ,Logger.Level.Debug);
				return;
			}

			if((histData!= null) &&	(propertyObj != null))
			{
				try
				{
					LRRCompPropHistPropMapping lhpcpm =	new	LRRCompPropHistPropMapping();
					lhpcpm.ComponentPropertyName = propertyObj.Name;
					//get the property ID for measurement mode
					lhpcpm.SiteComponentPropID = propertyObj.ID;

					string site=lhpcpm.SiteComponentPropID;
                    List<IPropertyValue> arrScpValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(propertyObj.ID);
					if(arrScpValues != null)
					{
						for(int i=0;i < arrScpValues.Count;i++)
						{
							LRRSiteComponentPropertyValue lscpv = arrScpValues[i] as LRRSiteComponentPropertyValue;
							if(lscpv.ModeID == "1" && lscpv.SiteComponentPropertyID != "" && lscpv.SiteComponentPropertyID != null)
							{
								lhpcpm.SiteComponentPropValID = lscpv.ID;
								break;
							}
						}
					}

					lhpcpm.GroupPropertyID = propertyObj.GroupPropertyID;

					LRRSiteGroupPropertyQualifierValue lscgpv = new LRRSiteGroupPropertyQualifierValue();
					LRRSiteGroupPropertyQualifierValues grPropValues = new LRRSiteGroupPropertyQualifierValues();
					string sSiteGroupPropertyQualifierValueID = propertyObj.SiteGroupPropertyQualifierValueID == null ? "" : propertyObj.SiteGroupPropertyQualifierValueID;
					string lookupQualifierID = propertyObj.LookupQualifierID;
					string lookupPropertiesID = propertyObj.LookupPropertiesID;  

					if(sSiteGroupPropertyQualifierValueID != "")
					{
						lhpcpm.GroupPropertyValID = sSiteGroupPropertyQualifierValueID;
						lhpcpm.LookupQualifierID = lookupQualifierID;
						lhpcpm.LookUpPropertiesID = lookupPropertiesID; 
						
					}
					lhpcpm.HistPropID =	histData.HistTagUID;
					lhpcpm.EffectivePlantTime =	new DateTime(1,1,1,0,0,0);//DateTime.Now; 
					lhpcpm.HistTag = histData.HistTag;
					lhpcpm.ComponentID = selectedSiteComponent.SiteComponentID;
					string sitePropID = lhpcpm.SiteComponentPropID;
					gridComponentHistMapping.DataSource	= null;
					//selectedSiteComponent.HisMaps.Add(lhpcpm);
					selectedSiteComponent.WriteHisMaps.Add(lhpcpm);
					
					//Check for Dynamic Case
//					if(selectedSiteComponent.IsDynamic)
//					{
//						lhpcpm.IsDynamic = true;
//
//						LRRDynamicHistPropCompPropMapping dynamicHistProp = new LRRDynamicHistPropCompPropMapping();
//						dynamicHistProp.HistPropID = lhpcpm.HistPropID;
//						dynamicHistProp.HistTag = lhpcpm.HistTag;
//						dynamicHistProp.SiteComponentPropID = lhpcpm.SiteComponentPropID;
//						dynamicHistProp.SiteComponentPropValID = lhpcpm.SiteComponentPropValID;
//						dynamicHistProp.ComponentID = lhpcpm.ComponentID;
//						dynamicHistProp.ComponentPropertyName = lhpcpm.ComponentPropertyName;
//						dynamicHistProp.GroupPropertyID = lhpcpm.GroupPropertyID;
//						dynamicHistProp.GroupPropertyValID = lhpcpm.GroupPropertyValID;
//						dynamicHistProp.LookupQualifierID = lhpcpm.LookupQualifierID;
//						dynamicHistProp.EffectivePlantTime = lhpcpm.EffectivePlantTime;
//						dynamicHistProp.LookUpPropertiesID = lhpcpm.LookUpPropertiesID; 
//
//						LRRDynamicModel.DynamicHistPropCompPropMappings.Add(dynamicHistProp);	
//					}
					//LRRModel.HistPropMaps.Add(lhpcpm);
					LRRModel.CompPropHistPropMappings.Add(lhpcpm);

					gridComponentHistMapping.DataSource	= selectedSiteComponent.WriteHisMaps;
                    gridComponentHistMapping.Refresh();
					SetFoucsOnLastMappingRecord(lhpcpm.MappingId); 
//						gridComponentHistMapping.Table.Records[gridComponentHistMapping.TableModel.Model.RowCount-4].SetSelected(true);              
//						gridComponentHistMapping.Table.Records[gridComponentHistMapping.TableModel.Model.RowCount-4].SetCurrent();              

					lhpcpm.IsPersistent	= true;
					lhpcpm.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
				}
				catch(Exception	ex)
				{
					Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithPET:"+ex.Message  ,Logger.Level.Debug);
				}
				
			}
		}

		private void MappingWithoutPET()
		{
			int	k =	 lrrCompTypes.Count; 
			if(selectedSiteComponent ==	null)
				return;
			LRRUserHistData	 histData =	null;
			LRRPlantItemProperty propertyObj=null;
			try
			{
				histData = gridHistTags.CurrencyManager.Current	as LRRUserHistData;
				propertyObj =	gridComponentProperties.CurrencyManager.Current	as LRRPlantItemProperty;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithoutPET:"+ex.Message  ,Logger.Level.Debug);
				return;
			}

			if((histData!= null) &&	(propertyObj != null))
			{
				try
				{
					LRRCompPropHistPropMapping lhpcpm =	new	LRRCompPropHistPropMapping();
					lhpcpm.ComponentPropertyName = propertyObj.Name;
					//get the property ID for measurement mode
					lhpcpm.SiteComponentPropID = propertyObj.ID;
					
					string site=lhpcpm.SiteComponentPropID;
                    List<IPropertyValue> arrScpValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(propertyObj.ID);
					if(arrScpValues != null)
					{
						for(int i=0;i < arrScpValues.Count;i++)
						{
							LRRSiteComponentPropertyValue lscpv = arrScpValues[i] as LRRSiteComponentPropertyValue;
							if(lscpv.ModeID == "1" && lscpv.SiteComponentPropertyID != "" && lscpv.SiteComponentPropertyID != null)
							{
								lhpcpm.SiteComponentPropValID = lscpv.ID;
								break;
							}
						}
					}

					lhpcpm.GroupPropertyID = propertyObj.GroupPropertyID;

					LRRSiteGroupPropertyQualifierValue lscgpv = new LRRSiteGroupPropertyQualifierValue();
					LRRSiteGroupPropertyQualifierValues grPropValues = new LRRSiteGroupPropertyQualifierValues();
					string sSiteGroupPropertyQualifierValueID = propertyObj.SiteGroupPropertyQualifierValueID == null ? "" : propertyObj.SiteGroupPropertyQualifierValueID;
					string lookupQualifierID = propertyObj.LookupQualifierID;
					string lookupPropertiesID = propertyObj.LookupPropertiesID;
					
					
					if(sSiteGroupPropertyQualifierValueID != "")
					{
						lhpcpm.GroupPropertyValID = sSiteGroupPropertyQualifierValueID;
						lhpcpm.LookupQualifierID = lookupQualifierID;
						lhpcpm.LookUpPropertiesID = lookupPropertiesID;
					}
					lhpcpm.HistPropID =	histData.HistTagUID;
					lhpcpm.EffectivePlantTime =	new DateTime(1,1,1,0,0,0);//DateTime.Now; 
					lhpcpm.HistTag = histData.HistTag;
					lhpcpm.ComponentID = selectedSiteComponent.SiteComponentID;
					bool found = false;
					LRRCompPropHistPropMapping foundObj	= null;
					string sitePropID = lhpcpm.SiteComponentPropID;
			
					foreach(LRRCompPropHistPropMapping objHistPropCompPropMapping in selectedSiteComponent.WriteHisMaps)
					{
						if(objHistPropCompPropMapping.HistPropID == lhpcpm.HistPropID)
						{
							foundObj = objHistPropCompPropMapping;
							found =	true;
							break;
						}
					}	
					if(found)
					{
						DialogResult result = LRRMessagBox.ShowMessage("SID_DUPLICATE_HISTMAPPING","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
						if(result == DialogResult.Yes)
						{
							foundObj.SiteComponentPropID = lhpcpm.SiteComponentPropID;
							foundObj.ComponentPropertyName = lhpcpm.ComponentPropertyName;
							foundObj.HistPropID	= lhpcpm.HistPropID;
							foundObj.HistTag = lhpcpm.HistTag;
							foundObj.EffectivePlantTime	= new DateTime(1,1,1,0,0,0);//lhpcpm.EffectivePlantTime;
							foundObj.ComponentID = selectedSiteComponent.SiteComponentID;
							
							//Update in HistPropMap Model Object if Mapping is overwritten
							LRRCompPropHistPropMapping histPropCompMap = null;
							if(sSiteGroupPropertyQualifierValueID != "")
							{
								histPropCompMap = LRRModel.CompPropHistPropMappings.GetCompHistMapObjFromGrpValID(lhpcpm.GroupPropertyValID);
							}
							else
							{
								histPropCompMap = LRRModel.CompPropHistPropMappings.GetHistMapObjFromValID(lhpcpm.SiteComponentPropID);
							}
							histPropCompMap.SiteComponentPropID = lhpcpm.SiteComponentPropID;
							histPropCompMap.ComponentPropertyName = lhpcpm.ComponentPropertyName;
							histPropCompMap.HistPropID	= lhpcpm.HistPropID;
							histPropCompMap.HistTag = lhpcpm.HistTag;
							histPropCompMap.EffectivePlantTime	= new DateTime(1,1,1,0,0,0);//lhpcpm.EffectivePlantTime;
							histPropCompMap.ComponentID = selectedSiteComponent.SiteComponentID;
							gridComponentHistMapping.Refresh();
							SetFoucsOnLastMappingRecord(histPropCompMap.MappingId);   


							//selectedSiteComponent.HisMaps.Add(lhpcpm);
						}
					}
					else
					{
						//todo nidhi
						gridComponentHistMapping.DataSource	= null;
						selectedSiteComponent.WriteHisMaps.Add(lhpcpm);
						//selectedSiteComponent.HisMaps.Add(lhpcpm);
						//Check for Dynamic Case
//						if(selectedSiteComponent.IsDynamic)
//						{
//							lhpcpm.IsDynamic = true;
//
//							LRRDynamicHistPropCompPropMapping dynamicHistProp = new LRRDynamicHistPropCompPropMapping();
//							dynamicHistProp.HistPropID = lhpcpm.HistPropID;
//							dynamicHistProp.HistTag = lhpcpm.HistTag;
//							dynamicHistProp.SiteComponentPropID = lhpcpm.SiteComponentPropID;
//							dynamicHistProp.SiteComponentPropValID = lhpcpm.SiteComponentPropValID;
//							dynamicHistProp.ComponentID = lhpcpm.ComponentID;
//							dynamicHistProp.ComponentPropertyName = lhpcpm.ComponentPropertyName;
//							dynamicHistProp.GroupPropertyID = lhpcpm.GroupPropertyID;
//							dynamicHistProp.GroupPropertyValID = lhpcpm.GroupPropertyValID;
//							dynamicHistProp.LookupQualifierID = lhpcpm.LookupQualifierID;
//							dynamicHistProp.EffectivePlantTime = lhpcpm.EffectivePlantTime;
//							dynamicHistProp.LookUpPropertiesID = lhpcpm.LookUpPropertiesID;
//
//							LRRDynamicModel.DynamicHistPropCompPropMappings.Add(dynamicHistProp);
//						}

						LRRModel.CompPropHistPropMappings.Add(lhpcpm);

						gridComponentHistMapping.DataSource	= selectedSiteComponent.WriteHisMaps;
						gridComponentHistMapping.Refresh();
						SetFoucsOnLastMappingRecord(lhpcpm.MappingId); 
						lhpcpm.IsPersistent	= true;
						lhpcpm.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
					}
				}
				catch(Exception	ex)
				{
					Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"MappingWithoutPET :"+ex.Message  ,Logger.Level.Debug);
				}
			}
		}


		//Event	Handler	for	the	save of	the	Mappings
		private	void Save_Click(object sender, EventArgs e)
		{
			Save();
		}
		private void BindGrids()
		{
			//Populate from Model
		 	_lrrHist = LRRModel.UserHistDatas;
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridComponentProperties);
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridComponentHistMapping);
			gridComponentProperties.TableDescriptor.Columns.Clear();
			gridComponentProperties.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME"),"Name");
			gridComponentProperties.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_ATTRIBUTEDESC"),"Description");
			gridComponentProperties.TableOptions.AllowDropDownCell = true;
			gridComponentProperties.TopLevelGroupOptions.CaptionText =	 " {RecordCount} Items"; 
			gridComponentProperties.TableControl.ActivateToolTip+=new GridActivateToolTipEventHandler(TableControl_ActivateToolTip);
		
			Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.InitializeGridLookAndFeel(gridHistTags);
			gridHistTags.TableDescriptor.Columns.Clear();
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_HISTTAG"),"HistTag");
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_GENERAL_DESC"),"GeneralDesc");
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_COMMENTS"),"Comments");
//			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE"),"InterfaceValue");
			gridHistTags.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_INTERFACEVALUE_UIUOM"),"DisplayInterfaceValue");
			gridHistTags.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_HISTTAG")].AllowFilter	= true;
			gridHistTags.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_GENERAL_DESC")].AllowFilter	= true;
			gridHistTags.TableControl.ActivateToolTip+=new GridActivateToolTipEventHandler(TableControl_ActivateToolTip);

			
			gridComponentHistMapping.TableDescriptor.Columns.Clear();
			gridComponentHistMapping.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME"),"SiteComponentPropID");
			if(gridComponentHistMapping.TableDescriptor.Columns[0].Name == LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME"))
			{
				gridComponentHistMapping.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
				GridTableCellStyleInfo gtc = gridComponentHistMapping.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell;
				gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
				gtc.ReadOnly = true;
				gtc.DisplayMember =	"Name";
				gtc.ValueMember	= "ID";
				gtc.AutoSize=true;
			}
			gridComponentHistMapping.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_HISTTAG"),"HistPropID");
			if(gridComponentHistMapping.TableDescriptor.Columns[1].Name	== LRRHeaderText.GetHeaderString("SID_HISTTAG"))
			{
				gridComponentHistMapping.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
				GridTableCellStyleInfo gtc = gridComponentHistMapping.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell;
				gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
				gtc.ReadOnly = true;
				gtc.DisplayMember =	"HistTag";
				gtc.ValueMember	= "HistTagUID";
				gtc.ReadOnly = true;
				gtc.DataSource = _lrrHist;
				gtc.AutoSize=true;
			}
			GridColumnDescriptor gcd = new GridColumnDescriptor();
			gcd.HeaderText = LRRHeaderText.GetHeaderString("SID_EFFECTIVEPLANTTIME");
			gcd.MappingName	= "EffectivePlantTime";
			GridTableCellStyleInfo style = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);

			style.CellType	= "MonthCalendar";
			style.CellValueType	= DateTime.Now.GetType();
			style.Format = Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT;
			gridComponentHistMapping.TableDescriptor.Columns.Add(gcd);
			gridComponentHistMapping.TableDescriptor.AllowEdit=true;

			gridHistTags.TopLevelGroupOptions.CaptionText =	LRRHeaderText.GetHeaderString("SID_HISTTAG")+ ":" + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEM"); 
			gridComponentHistMapping.TableDescriptor.AllowRemove = true;
			gridComponentHistMapping.TopLevelGroupOptions.ShowFilterBar	= true;
			gridComponentHistMapping.NestedTableGroupOptions.ShowFilterBar = true;
			gridComponentHistMapping.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_ATTRIBUTENAME")].AllowFilter	= true;
			gridComponentHistMapping.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_HISTTAG")].AllowFilter	= true;
			gridComponentHistMapping.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_HISTTAG")].AllowGroupByColumn = false;
			gridComponentHistMapping.TableDescriptor.Columns["EffectivePlantTime"].AllowGroupByColumn = false;

			gridComponentHistMapping.TableDescriptor.SortedColumns.Clear();
			gridComponentHistMapping.TableDescriptor.SortedColumns.Add("SiteComponentPropID");
			gridComponentHistMapping.TableDescriptor.SortedColumns.Add("EffectivePlantTime");

			gridComponentHistMapping.TableDescriptor.Appearance.GroupCaptionSummaryCell.BackColor = Color.Orange;
			gridComponentHistMapping.TableDescriptor.Appearance.GroupCaptionSummaryCell.TextColor = Color.White;

			gridHistTags.DataSource	= _lrrHist;
			gridComponentProperties.TableOptions.ListBoxSelectionColorOptions =	GridListBoxSelectionColorOptions.ApplySelectionColor;
			gridComponentProperties.TableOptions.SelectionBackColor	= Color.Red;
			Hashtable RelativeWidths=new Hashtable();
			RelativeWidths.Add("SiteComponentPropID",30);
			RelativeWidths.Add("HistTag",50);
			RelativeWidths.Add("EffectivePlantTime",20);
			
			gridComponentProperties.DataSource=null;
			gridComponentHistMapping.DataSource=null;
			gridComponentHistMapping.Refresh();
			gridComponentProperties.Refresh();	
			gridHistTags.Refresh();/////??????
			gridHistTags.TableControl.Model.Selections.Clear();////????
			gridComponentProperties.TableControl.Model.Selections.Clear();////????
			gridComponentProperties.TableControl.Model.Selections.Clear();////????
			
		}

		private void PopulateTreeView()
		{
			treeViewAdv1.SuspendLayout();
			treeViewAdv1.SelectedNodes.Clear();
			treeViewAdv1.Nodes.Clear();
			lrrCompTypes = new LRRComponentTypes();

			_lrrapp.DBManagerObj.PopulateCollection(lrrCompTypes,true);
			
			int[] folders =	new	int[1];
			folders[0] = 0;
			int[] leaf = new int[1];
			leaf[0]	= 1;
			LRRMasterComponents masterComponents = LRRModel.Model;

			IEnumerator compTypeEnum = lrrCompTypes.GetEnumerator();
			while(compTypeEnum.MoveNext())
			{
				LRRMasterComponents masterComps = new LRRMasterComponents();
				LRRComponentType compType = compTypeEnum.Current as LRRComponentType;
				IEnumerator masterCompEnum = masterComponents.GetEnumerator();

				TreeNodeAdv	tnav = new TreeNodeAdv();
				tnav.Text =	compType.Name;
				tnav.LeftImageIndices =	folders;
				while(masterCompEnum.MoveNext())
				{
					LRRMasterComponent masterComp = masterCompEnum.Current as LRRMasterComponent;
					if(compType.ID == masterComp.ComponentID)
					{
						compType.MasterComponentObj = masterComponents;
						masterComp.SiteComponentsObj = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(masterComp.ID);
						if(masterComp.SiteComponentsObj.Count > 0)
						{
							TreeNodeAdv	child =	new	TreeNodeAdv();
							child.Text = masterComp.ComponentName;
							child.Tag =	masterComp;
							child.LeftImageIndices = folders;
							tnav.Nodes.Add(child);
							tnav.Nodes.Sort(SortOrder.Ascending);
							LRRLevels lvl =	new	LRRLevels();
							
							foreach(LRRSiteComponent sc	in masterComp.SiteComponentsObj)
							{
								TreeNodeAdv	grandChild = new TreeNodeAdv();
								string sLevelId = sc.PlantUnit == null? "" : sc.PlantUnit.ToString(Symcon.BusinessObjects.SymConverter.Culture); 
								if(sLevelId != "") 
								{ 
									LRRLevel levl = LRRModel.ChildModel.Levels.getLevelByLevelID(sLevelId); 
									if(levl!=null) 
									{
										grandChild.Text = sc.Name+" [" + levl.Name +" ]" ; 
									}
									else grandChild.Text = sc.Name + " [ Level not defined ]"; 
								}
								else
								{
									grandChild.Text = sc.Name + " [ Level not defined ]";
								}
								grandChild.Text	= grandChild.Text + " [" + sc.EquipmentTag + "]";

								grandChild.Tag = sc;
								grandChild.LeftImageIndices	= leaf;
								child.Nodes.Add(grandChild);
								child.Nodes.Sort(SortOrder.Ascending);
							}
							
						}
						else
						{
							masterComps.Add(masterComp);
						}
					}
				}
				
				masterComps.SortColumn = "ComponentName";
				masterComps.Sort();
				
				IEnumerator mastCompEnum = masterComps.GetEnumerator();
				while(mastCompEnum.MoveNext())
				{
					LRRMasterComponent mastComp = mastCompEnum.Current as LRRMasterComponent;
					if(compType.ID == mastComp.ComponentID)
					{
						TreeNodeAdv	child =	new	TreeNodeAdv();
						child.Text = mastComp.ComponentName;
						child.Tag =	mastComp;
						child.LeftImageIndices = folders;
						tnav.Nodes.Add(child);
					}
				}
				treeViewAdv1.Nodes.Add(tnav);
			}
			treeViewAdv1.ResumeLayout();
		}

		//String Search
		private Syncfusion.Windows.Forms.Tools.TreeNodeAdv tempNode;
		public TreeNodeAdv FindNodeByText(Syncfusion.Windows.Forms.Tools.TreeNodeAdvCollection nodeCollection, string text)
		{
			if (nodeCollection == null)
			{
				return null;
			}

			foreach (TreeNodeAdv node in nodeCollection)
			{
				if (node.Text.ToUpper().StartsWith(text.ToUpper()))
				{
					return node;
				}
				else
				{
					TreeNodeAdv tempNode = FindNodeByText(node.Nodes, text);
					if (tempNode != null)
					{
						return tempNode;
					}
				}
			}

			return null;
		}

		public TreeNodeAdv GetNextNode(Syncfusion.Windows.Forms.Tools.TreeNodeAdv node)
		{
			if(node!=null)
			{
				if (node.HasChildren == true)
				{
					return node.Nodes[0];
				}
				else if (node.NextNode != null)
				{
					return node.NextNode;
				}
				else if (node != null)
				{
					return GetParentNode(node);
				}
				else
				{
					return null;
				}
			}
			else
			{
				return null;
			}
		}

		public TreeNodeAdv GetParentNode ( TreeNodeAdv node )
		{
			if (node.Parent == null)
			{
				return null;
			}
			else if ( node.Parent.NextNode == null )
			{
				return GetParentNode ( node.Parent );
			}
			else
			{
				return node.Parent.NextNode ;
			}
		}

		public TreeNodeAdv FindNodeByText(Syncfusion.Windows.Forms.Tools.TreeNodeAdv node , string text)
		{

			if (node != null)
			{
				if (node.Text.ToUpper().StartsWith(text.ToUpper()))
				{
					return node;
				}
				else
				{
					node = FindNodeByText(GetNextNode(node), text);
				}
			}

			return node;
		}


		private	void btnFind_Click(object sender, System.EventArgs e)
		{
			//			isFound = false;
			//			FindInTreeView();
			//			if(isFound==false)
			//			{
			//				treeViewAdv1.CollapseAll();
			//				LRRMessagBox.ShowMessage("SID_ITEM_NOTFOUND","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);  
			//			}
			if(txtFind.Text==null || txtFind.Text=="")
			{
				//MessageBox.Show("No Data to Search");
				LRRMessagBox.ShowMessage("SID_NODATA_SEARCH","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
				return;
			}

			if (tempNode == null)
			{
				tempNode = FindNodeByText(this.treeViewAdv1.Nodes, this.txtFind.Text);
			}
			else 
			{
				tempNode = FindNodeByText( GetNextNode ( this.treeViewAdv1.SelectedNode ) , this.txtFind.Text);
			}

			if (tempNode != null)
			{
				this.treeViewAdv1.CollapseAll();
				this.treeViewAdv1.SelectedNode = tempNode;
				treeViewAdv1.SelectedNode.Expand();
				this.treeViewAdv1.Focus();
			}
			else
			{
				LRRMessagBox.ShowMessage("SID_ITEM_NOTFOUND","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);  
			}
		}


		private	void gridComponentHistMapping_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{

            
			GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
			GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
            
            
			if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
			{
				return;
			}
			if(e.Inner.MouseEventArgs.Button == MouseButtons.Right && e.Inner.RowIndex >3 && e.Inner.ColIndex >=1)
			{
				this.contextMenuOverrideMapping.Show(this.gridComponentHistMapping, this.gridComponentHistMapping.PointToClient(Control.MousePosition));
			}
			else
			{
				gridComponentHistMapping.TableControl.SelectRecords.Clear();   
				gridHistTags.TableControl.Selections.Clear();
				gridComponentProperties.TableControl.Selections.Clear();
				gridHistTags.TableControl.CurrentCell.Deactivate(true);
				gridComponentProperties.TableControl.CurrentCell.Deactivate(true);
				LRRCompPropHistPropMapping lhpcpm =	 gridComponentHistMapping.CurrencyManager.Current as LRRCompPropHistPropMapping;
			
				for(int	i =	0; i< gridComponentProperties.Table.Records.Count; i++)
				{
					LRRPlantItemProperty lscp = gridComponentProperties.Table.Records[i].GetData() as LRRPlantItemProperty;
					if(lhpcpm.SiteComponentPropID.ToString(Symcon.BusinessObjects.SymConverter.Culture) ==	lscp.ID)
					{
						gridComponentProperties.TableControl.CurrentCell.Activate(i,0);
						//gridComponentProperties.TableControl.Selections.Clear();
						gridComponentProperties.TableModel.Selections.SelectRange(GridRangeInfo.Row(i),false);
						gridComponentProperties.Table.Records[i].SetCurrent(); 
						gridComponentProperties.Refresh();
						break;
					}
				}
				for(int	j=0; j<gridHistTags.Table.Records.Count; j++)
				{
					
					LRRUserHistData	histData = gridHistTags.Table.Records[j].GetData() as LRRUserHistData;
					if(lhpcpm.HistPropID ==	histData.HistTagUID)
					{
						gridHistTags.TableControl.CurrentCell.Activate(j,0);
						gridHistTags.TableModel.Selections.SelectRange(GridRangeInfo.Row(j),false); 
						gridHistTags.Table.Records[j].SetCurrent();
						gridHistTags.Refresh();
						break;
					}
				}
			}
            

		}

		

	
		
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			this.Cursor=Cursors.WaitCursor;
//			LRRUIManager lrrUI=new LRRUIManager();
//			lrrUI.SaveColumnOrder(gridHistTags,this);
//			lrrUI.SaveGridSettings(gridHistTags,this, this.Tag);
//			lrrUI.SaveColumnOrder(gridComponentHistMapping,this);
//			lrrUI.SaveGridSettings(gridComponentHistMapping,this, this.Tag);
//			lrrUI.SaveColumnOrder(gridComponentProperties,this);
//			lrrUI.SaveGridSettings(gridComponentProperties,this, this.Tag);

			PopulateTreeView();
			BindGrids();
			
			this.Cursor=Cursors.Default;
//			lrrUI.ApplyGridSettings(gridHistTags,this, this.Tag);
//			lrrUI.ApplyColumOrder(gridHistTags,this);
//			lrrUI.ApplyGridSettings(gridComponentHistMapping,this, this.Tag);
//			lrrUI.ApplyColumOrder(gridComponentHistMapping,this);
//			lrrUI.ApplyGridSettings(gridComponentProperties,this, this.Tag);
//			lrrUI.ApplyColumOrder(gridComponentProperties,this);			
	}
		public bool SupportsCopyRecord()
		{
			return true;
		}
		public bool SupportsPasteRecord()
		{
			return true;
		}
	

		public void Save()
		{
			try
			{
				bool savedCalled = false;
				foreach(LRRComponentType lct in	lrrCompTypes)
				{
					foreach(LRRMasterComponent lmc in lct.MasterComponentObj)
					{
						foreach(LRRSiteComponent lsc in	lmc.SiteComponentsObj)
						{
							if(lsc.WriteHisMaps.GetChanges().Count != 0)
							{
								savedCalled	= true;
								LRRCompPropHistPropMappings	lhcpms1 = lsc.WriteHisMaps.GetChanges();

								//Check for Dynamic Cases
								LRRCompPropHistPropMappings lhcpms = new LRRCompPropHistPropMappings();
								//LRRDynamicHistPropCompPropMappings dynamicLhcpms = new LRRDynamicHistPropCompPropMappings();
								IEnumerator iHistPropCompMap = lhcpms1.GetEnumerator();
								while(iHistPropCompMap.MoveNext())
								{	
									LRRCompPropHistPropMapping histPropCompProp = iHistPropCompMap.Current as LRRCompPropHistPropMapping;
									if(!histPropCompProp.IsOverride)
									{	
										/*
										if(histPropCompProp.IsDynamic)
										{
											LRRDynamicHistPropCompPropMapping dynamicLhcpm = LRRDynamicModel.DynamicHistPropCompPropMappings.GetMapObjectByMappingID(histPropCompProp.MappingId);
											if(dynamicLhcpm == null)
											{
												dynamicLhcpm = new LRRDynamicHistPropCompPropMapping();
												dynamicLhcpm.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
											}
											else
											{
												dynamicLhcpm.ObjectState = Symcon.Globals.Enums.DBOperation.UPDATE;
											}
											dynamicLhcpm.MappingId = histPropCompProp.MappingId;
											dynamicLhcpm.HistPropID = histPropCompProp.HistPropID;
											dynamicLhcpm.GroupPropertyID = histPropCompProp.GroupPropertyID;
											dynamicLhcpm.GroupPropertyValID = histPropCompProp.GroupPropertyValID;
											dynamicLhcpm.SiteComponentPropID = histPropCompProp.SiteComponentPropID;
											dynamicLhcpm.SiteComponentPropValID = histPropCompProp.SiteComponentPropValID;
											dynamicLhcpm.HistTag = histPropCompProp.HistTag;
											dynamicLhcpm.ComponentPropertyName = histPropCompProp.ComponentPropertyName;
											dynamicLhcpm.EffectivePlantTime = histPropCompProp.EffectivePlantTime;
											dynamicLhcpm.ComponentID = histPropCompProp.ComponentID;
											dynamicLhcpm.LookupQualifierID = histPropCompProp.LookupQualifierID;
											dynamicLhcpm.LookUpPropertiesID = histPropCompProp.LookUpPropertiesID;
											dynamicLhcpms.Add(dynamicLhcpm);
										}
										else
										{*/
											lhcpms.Add(histPropCompProp);
										//}
									}
								}

								if(lhcpms.Count>0)
								{
									for(int i=0;i<lhcpms.Count;i++)
									{
										bool isRemoved = false;
										LRRCompPropHistPropMapping	map=lhcpms[i] as LRRCompPropHistPropMapping;


										LRRSiteComponentProperty  sitecomProp = LRRModel.SiteComponentPropertiesObj.GetSiteComPropObjForPropIDAndCompID(map.SiteComponentPropID,map.ComponentID);
										if(sitecomProp != null)
										{
											if(map.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
											{
												sitecomProp.HistTagID = "";
											}
											else
											{
												sitecomProp .HistTagID = map.HistPropID;
											}
											_lrrapp.DBManagerObj.CommitObject(sitecomProp);  
										}
										else
										{
											string sGroupQualifierValueID = map.GroupPropertyValID == null ? "" : map.GroupPropertyValID;
											if(sGroupQualifierValueID != "")
											{
												LRRSiteGroupPropertyQualifierValue objGrpPptyQualVal=LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(sGroupQualifierValueID);
												if(objGrpPptyQualVal!=null)
												{
													if(map.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
													{
														objGrpPptyQualVal.HistTagID = "";
													}
													else
													{
														objGrpPptyQualVal .HistTagID = map.HistPropID;
													}
													_lrrapp.DBManagerObj.CommitObject(objGrpPptyQualVal);  
												}
											}
										}
										if(map.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
										{
											LRRModel.CompPropHistPropMappings.Remove(map);
											isRemoved = true;
										}

										if(!isRemoved)
										{
											//This check is for the nullifying the effect of the proxy SiteComponent Prop ID
											// in the mapping object...
											if(map.SiteComponentPropValID == "" || map.SiteComponentPropValID == null)
												map.SiteComponentPropID = "";
											if(map.GroupPropertyValID == null || map.GroupPropertyValID == "")
											{
												map.GroupPropertyID = "";
												map.LookupQualifierID  = "";
												map.LookUpPropertiesID = "";
											}
										}
									}
								}
							
								_lrrapp.DBManagerObj.CommitCollection(lhcpms);
//								_lrrapp.DBManagerObj.CommitCollection(dynamicLhcpms);
								lsc.WriteHisMaps.RefreshCollection();
								//lhcpms.RefreshCollection();
							}
						}
					}
				}
			

				if(savedCalled)
				{
					if(_lrrSiteCompGrpQualifierValues != null)
						_lrrSiteCompGrpQualifierValues.RefreshCollection();
					_lrrapp.SetHistorianPropertyBinding();
					LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				}
				else
				{
					//MessageBox.Show(this,"No Data to save.",this.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
					//LRRMessagBox.ShowMessage("SID_NODATASAVED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
				}

				_lrrapp.DBManagerObj.PopulateCollection(LRRModel.CompPropHistPropMappings,false);
				this.txtFind.Clear();

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"Save:"+ex.Message  ,Logger.Level.Error);
			}
		}
		public void Export()
		{
			if(gridComponentHistMapping.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridComponentHistMapping);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members
		public void CopyRecord()
		{
		}
		public void PasteRecord()
		{}

		public void CopyMasterProperties()
		{
			// TODO:  Add MasterPlantItems.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add MasterPlantItems.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add MasterPlantItems.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add MasterPlantItems.Print implementation
			if(gridComponentHistMapping.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridComponentHistMapping,false);
			}
			if(gridComponentProperties.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridComponentProperties,false);
			}
			if(gridHistTags.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridHistTags,false);
			}
		}

		public void Delete()
		{
			SyncGridUtilities.DeleteRecords(gridComponentHistMapping); 
		}

		public void ArrangeColumns()
		{
			// TODO:  Add MasterPlantItems.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			this.gridComponentHistMapping.TableDescriptor.RecordFilters.Clear();
			this.gridHistTags.TableDescriptor.RecordFilters.Clear();
			this.gridComponentProperties.TableDescriptor.RecordFilters.Clear();  
		}

		public void ImportToExcel()
		{
		//	SyncGridUtilities.ImportFromExcel(this.gridMasterPlantItems);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		public bool SupportsCopy()
		{
			// TODO:  Add MasterPlantItems.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add MasterPlantItems.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add MasterPlantItems.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add MasterPlantItems.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add MasterPlantItems.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add MasterPlantItems.SupportsDelete implementation
			return true;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add MasterPlantItems.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add MasterPlantItems.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add MasterPlantItems.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridComponentHistMapping);
		}

		public void InsertNewRows()
		{
//			InsertNewRowsForm insNewRows = new InsertNewRowsForm();
//			DialogResult dlgResult = insNewRows.ShowDialog(this);
//			int iNumofRows = insNewRows.iNewRows;
//			if(dlgResult == DialogResult.OK)
//			{
//				SyncGridUtilities.InsertNewRows(gridMasterPlantItems,iNumofRows);
//			}
//			else
//			{
//				return;
//			}
		}
		public bool SupportsImportToExcel()
		{
			return false;
		}
		public bool SupportsLevel()
		{
			return false;
		}

		
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		private void gridComponentProperties_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
            
			
            gridComponentHistMapping.TableControl.SelectRecords.Clear();       
			gridComponentHistMapping.TableControl.Selections.Clear();
			gridHistTags.TableControl.Selections.Clear();
			gridComponentHistMapping.TableControl.CurrentCell.Deactivate(true);
			gridHistTags.TableControl.CurrentCell.Deactivate(true);
            

            
			LRRPlantItemProperty lrrsp = gridComponentProperties.CurrencyManager.Current as	LRRPlantItemProperty;
			LRRSiteComponent lsc = treeViewAdv1.SelectedNode.Tag as	LRRSiteComponent;
             
			
			for(int	i =	0; i< gridComponentHistMapping.Table.Records.Count; i++)
			{
				LRRCompPropHistPropMapping lhpcpm =	 gridComponentHistMapping.Table.Records[i].GetData() as LRRCompPropHistPropMapping;
				if(lhpcpm.SiteComponentPropID.ToString(Symcon.BusinessObjects.SymConverter.Culture) ==	lrrsp.ID)
				{
					gridComponentHistMapping.TableControl.CurrentCell.Activate(i+4,0);
					gridComponentHistMapping.TableModel.Selections.SelectRange(GridRangeInfo.Row(i+4),true);
					gridHistTags.Table.Records[i+4].SetCurrent();
					gridComponentHistMapping.Refresh();
					for(int	j=0; j<gridHistTags.Table.Records.Count;j++)
					{
				 		LRRUserHistData	histData = gridHistTags.Table.Records[j].GetData() as LRRUserHistData;
						if(lhpcpm.HistPropID ==	histData.HistTagUID)
						{
							gridHistTags.TableControl.CurrentCell.Activate(j,0);
							gridHistTags.TableModel.Selections.SelectRange(GridRangeInfo.Row(j),false);
							gridHistTags.Table.Records[j].SetCurrent();
							gridHistTags.Refresh();
							break;
						}
					}
					break;
				}
				else
				{
					gridHistTags.TableModel.Selections.Clear();
					gridHistTags.Refresh();
        			gridComponentHistMapping.TableModel.Selections.Clear();
					gridComponentHistMapping.Refresh();
					gridComponentProperties.TableModel.Selections.Clear();
					gridComponentProperties.Refresh();
				}
			}
            
             
		}

		private void treeViewAdv1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			TreeNodeAdv tn = this.treeViewAdv1.GetNodeAtPoint(e.X,e.Y);
			if(tn!=null)
			{
				string toolTipText  = "";

				int currentNodeIndex = tn.Index; 
				
				if(currentNodeIndex != oldIndex) 
				{ 
					oldIndex = currentNodeIndex; 
					object objNode = tn.Tag;
					if(objNode == null)
						return;
					if(objNode.GetType().Name.Equals("LRRSiteComponent"))
					{
						string desc = objNode.GetType().GetProperty("Description").GetValue(objNode,null) == null ? "" : objNode.GetType().GetProperty("Description").GetValue(objNode,null).ToString();
						string level = objNode.GetType().GetProperty("PlantUnit").GetValue(objNode,null) == null ? "" : objNode.GetType().GetProperty("PlantUnit").GetValue(objNode,null).ToString();
						string equipTag = objNode.GetType().GetProperty("EquipmentTag").GetValue(objNode,null) == null ? "" : objNode.GetType().GetProperty("EquipmentTag").GetValue(objNode,null).ToString();
						LRRChildModel lrrChildModel = LRRModel.ChildModel;
						string levelName = "";
						if((level != null) && (level != ""))
							levelName = lrrChildModel.GetPlantLevelName(level);
						if(desc == "")
							toolTipText  = levelName + " \n " + equipTag ; 
						else if (levelName == "")
							toolTipText = desc + " \n " + equipTag ; 
						else if (equipTag == "")
							toolTipText  =  desc + " \n " + levelName; 
						else  
							toolTipText  =  desc + " \n " + levelName + " \n " + equipTag ; 

					}
					tn.HelpText = toolTipText;
					
				}
				
			}

		}
		private void txtFind_TextChanged(object sender, System.EventArgs e)
		{
			tempNode=null;	
		}

		private void menuEdit_Click(object sender, System.EventArgs e)
		{
			TreeNodeAdv tn = this.treeViewAdv1.SelectedNode;   
			if(tn!=null) 
			{
				object objNode = tn.Tag;
				if(objNode == null)
					return;
				if(objNode.GetType().Name.Equals("LRRSiteComponent"))
				{
					string sSiteComponentID = objNode.GetType().GetProperty("SiteComponentID").GetValue(objNode,null) == null ? "" : objNode.GetType().GetProperty("SiteComponentID").GetValue(objNode,null).ToString(); 
					ArrayList objArrayList = new ArrayList();
					objArrayList.Add(sSiteComponentID);
					_lrrapp.LRRUIManagerObj.ShowWindow(240,objArrayList); 
					SiteComponentEntry sc = new SiteComponentEntry(sSiteComponentID); 
					
				}
			}
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			//SiteCompPropHistorianMapping.ClearSort implementation
			SyncGridUtilities.ClearSort(gridComponentHistMapping);
			SyncGridUtilities.ClearSort(gridComponentProperties);
			SyncGridUtilities.ClearSort(gridHistTags);
		}

		public bool SupportsClearSort()
		{
			//SiteCompPropHistorianMapping.SupportsClearSort implementation
			return true;
		}

		#endregion

		private void TableControl_ActivateToolTip(object sender, GridActivateToolTipEventArgs e)
		{
			string toolTip = null;
			try
			{
				if(e.RowIndex > 2)
				{
					string uomName = null;
					string uomType = null;
					string propTypeId = null;
					string propTypeName = null;
					string interfaceUom = null;
					gridComponentProperties.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = null;
					gridHistTags.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = null;
					if((e.RowIndex-2) <= gridHistTags.Table.Records.Count)
					{
						object objhistTag  = gridHistTags.Table.Records[e.RowIndex - 3].GetData();     
						if(objhistTag != null)
						{
							string uomTypeId = objhistTag.GetType().GetProperty("UOMTypeID").GetValue(objhistTag,null) == null ? "" : objhistTag.GetType().GetProperty("UOMTypeID").GetValue(objhistTag,null).ToString();  
							if(uomTypeId != "")
							{
								LRRUOMType uomTypobj = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeId);
								uomType = uomTypobj.Name; 
							}
							string uomNameID = objhistTag.GetType().GetProperty("ModelUOM").GetValue(objhistTag,null) == null ? "" : objhistTag.GetType().GetProperty("ModelUOM").GetValue(objhistTag,null).ToString();  
							if(uomNameID != null)
							{
								uomName = LRRModel.ChildModel.GetUOMNameFromID(uomNameID) ; 
							}
							string interfaceUomID = objhistTag.GetType().GetProperty("InterfaceUnits").GetValue(objhistTag,null) == null ? "" : objhistTag.GetType().GetProperty("InterfaceUnits").GetValue(objhistTag,null).ToString();  
							if(interfaceUomID != null)
							{
								interfaceUom = LRRModel.ChildModel.GetUOMNameFromID(uomNameID);  
							}
							if(uomName != "" && interfaceUom != "" && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+ uomName +"\n"+LRRHeaderText.GetHeaderString("SID_UIUOM")+":"+interfaceUom+"\n"+LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType; 
							}
							if(uomName == "" && interfaceUom != "" && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_UIUOM")+":"+interfaceUom+"\n"+uomType; 
							}
							if(uomName == "" && interfaceUom == "" && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType; 
							}
							if(uomName != null && interfaceUom == null && uomType != null)
							{
								toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+uomName+"\n"+LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType; 
							}
							gridHistTags.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = toolTip;
						}
					}
					if(gridComponentProperties.DataSource == null)
					{
						return;
					}
					if((e.RowIndex-2) <= gridComponentProperties.Table.Records.Count)
					{
						object objcomprop  = gridComponentProperties.Table.Records[e.RowIndex - 3].GetData();
						if(objcomprop != null)
						{
							string propID = objcomprop.GetType().GetProperty("ID").GetValue(objcomprop,null) == null ? "" : objcomprop.GetType().GetProperty("ID").GetValue(objcomprop,null).ToString();   
							if(propID != "")
							{

								LRRSiteComponentProperty prop = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propID);   
								if(prop == null)
									return;
								if(prop.UOM != null && prop.UOM.Trim() != "")
								{
									uomName = LRRModel.ChildModel.GetUOMNameFromID(prop.UOM);
								}
								else
								{
									uomName = "";
								}
								if(prop.UOMTypeID != null && prop.UOMTypeID.Trim() != "")
								{
									LRRUOMType uomtyp = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(prop.UOMTypeID);
									uomType = uomtyp.Name;
								}
								else
								{
									uomType = "";
								}
							   
								propTypeId = prop.Type == null ? "" : prop.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
								if(propTypeId == "1")
								{
									propTypeName = "Simple";
								}
								else
								{
									propTypeName = "Group";
								}
								if(uomName != null && uomType!=null && propTypeName != null)
								{
									toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+uomName+"\n"+LRRHeaderText.GetHeaderString("SID_UOMTYPE")+":"+uomType+"\n"+LRRHeaderText.GetHeaderString("SID_PROPERTYTYPE")+":"+propTypeName;
								}
								if(uomName == "" && uomType!=null && propTypeName != null)
								{
									toolTip = LRRHeaderText.GetHeaderString("SID_MODELUOM")+":"+uomType+"\n"+LRRHeaderText.GetHeaderString("SID_PROPERTYTYPE")+":"+propTypeName;
								}
								gridComponentProperties.TableDescriptor.Appearance.AnyRecordFieldCell.CellTipText = toolTip;
							}
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteCompPropHistorianMapping),"TableControl_ActivateToolTip Event:"+ex.Message  ,Logger.Level.Debug);
			}

		}
	
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add SiteCompPropHistorianMapping.PrintPreview implementation
			if(gridComponentHistMapping.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridComponentHistMapping,true);
			}
			if(gridComponentProperties.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridComponentProperties,true);
			}
			if(gridHistTags.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridHistTags,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add SiteCompPropHistorianMapping.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add SiteCompPropHistorianMapping.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add SiteCompPropHistorianMapping.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		/// <summary>
		/// Custom Sumaries - associate with CreateSummaryMethod
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void gridComponentHistMapping_QueryCustomSummary(object sender, GridQueryCustomSummaryEventArgs e)
		{
			switch (e.SummaryColumn.Name)
			{
				case "Name":
				{
					e.SummaryDescriptor.CreateSummaryMethod = new CreateSummaryDelegate(PropertyNameSummary.CreateSummaryMethod);
					break;
				}
			}
			
		}

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add SiteCompPropHistorianMapping.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add SiteCompPropHistorianMapping.RightColMovement implementation
		}

		#endregion

		private void gridComponentHistMapping_TableControlCurrentCellValidating(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
		{
	 		LRRCompPropHistPropMapping histPropCompPropMapping = gridComponentHistMapping.CurrencyManager.Current as LRRCompPropHistPropMapping;
			string siteCompPropID = histPropCompPropMapping.SiteComponentPropID;
			if(e.TableControl.CurrentCell.Renderer.ControlValue==null)
				return;
			DateTime currentPET =  (DateTime)e.TableControl.CurrentCell.Renderer.ControlValue;
			
			LRRCompPropHistPropMappings histPropCompPropMappings = null;
			if(siteCompPropID != null && siteCompPropID.Trim() != "")
			{
				histPropCompPropMappings = LRRModel.CompPropHistPropMappings.FilterBySiteCompPropID(siteCompPropID);
			}
			else
			{
				histPropCompPropMappings = LRRModel.CompPropHistPropMappings.FilterByGroupPropID(histPropCompPropMapping.GroupPropertyID,histPropCompPropMapping.GroupPropertyValID);
			}
			IEnumerator iEnum = histPropCompPropMappings.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRCompPropHistPropMapping histMap = iEnum.Current as LRRCompPropHistPropMapping;
				DateTime histMapPET = histMap.EffectivePlantTime;
				TimeSpan ts = histMapPET.Subtract(currentPET);
				if(ts.Ticks == 0 && histMap.HistPropID != histPropCompPropMapping.HistPropID)
				{
					MessageBox.Show(this,"Cannot have two records with same Plant Effective Time!!");
					e.TableControl.CurrentCell.RejectChanges();
					e.Inner.Cancel= true;
					return;
				}
			}
		}
		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add SiteCompPropHistorianMapping.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add SiteCompPropHistorianMapping.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add SiteCompPropHistorianMapping.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add SiteCompPropHistorianMapping.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add SiteCompPropHistorianMapping.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add SiteCompPropHistorianMapping.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add SiteCompPropHistorianMapping.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add SiteCompPropHistorianMapping.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private void SetFoucsOnLastMappingRecord(string _mappingId)
		{
			foreach(Record _rec in this.gridComponentHistMapping.TableControl.Table.Records)
			{
                LRRCompPropHistPropMapping lhpcpm = _rec.GetData() as LRRCompPropHistPropMapping;
				if(lhpcpm != null)
				{
					if(lhpcpm.MappingId == _mappingId)
					{
						_rec.SetCurrent();
						_rec.SetSelected(true);
						this.gridComponentHistMapping.TableControl.Table.SelectedRecords.Add(_rec);
					}
				}
			}
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}
		private void gridComponentHistMapping_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
			}
		}

		private void gridComponentHistMapping_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.RowIndex!=-1) 
			{
				if(e.TableCellIdentity.DisplayElement is GridRecordRow)
				{
					LRRCompPropHistPropMapping  obj  = e.TableCellIdentity.DisplayElement.ParentRecord.GetData() as LRRCompPropHistPropMapping; 
					if(obj!=null)
					{
						if(obj.IsOverride)
						{
							if(e.TableCellIdentity.ColIndex > 0)
							{
								e.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.CornflowerBlue);
							}
						}
					}
				}
			}
		}

		private void menuItem1_Click_1(object sender, System.EventArgs e)
		{
//			Record rec = this.gridComponentHistMapping.TableControl.Table.CurrentRecord;
//			if(rec != null)
//			{
//				LRRHistPropCompPropMapping histPropComMap = rec.GetData() as LRRHistPropCompPropMapping;
//				OverrideHistMapping	overrideHistMapping = new OverrideHistMapping(histPropComMap);
//				overrideHistMapping.ShowDialog(); 
//			}
		}

		private void xpToolBar1_Click(object sender, System.EventArgs e)
		{
		
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add SiteCompPropHistorianMapping.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
