using System;
using System.IO;
using System.Collections;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.MessageLogger;
using Syncfusion.ExcelRW;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ExportRecordedValuesUtiility.
	/// </summary>
	public class ExportRecordedValuesUtiility
	{
		public ExportRecordedValuesUtiility()
		{
		}
		
		#region Methods
		public static void writeToExcel(string filename,LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteCompPropvalues,LRRRunRecord lrrRunRecord)
		{
			string sRecordedValues = null;
			
			StreamWriter sw = new StreamWriter(filename);
			//Header
			sRecordedValues = "RunName | RunDescription | StartTime | EndTime | SiteComponent | ";
			sRecordedValues = sRecordedValues + "SiteComponentProperty | ";
			for(int i=0 ; i < LRRModel.ProjectModes.Count; i++)
			{
				LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
				sRecordedValues = sRecordedValues + lrrMode.ModeName + "|";
			}
			
			
			sw.WriteLine(sRecordedValues);
			
			ArrayList arrSiteCompPropIDs = new ArrayList();
			//Recorded Values Rows
			foreach(LRRSiteComponentPropertyValueChangeUserAndTime lrrSiteCompPropvalue in lrrSiteCompPropvalues)
			{
				try
				{
					sRecordedValues = null;
	
					//filter By SiteComponentProperty And StartTime,EndTime
                    
					LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteComps = lrrSiteCompPropvalues.FilterSiteComponentsBySiteComponentID(lrrSiteCompPropvalue.SiteComponentPropertyID,lrrSiteCompPropvalue.StartTime,lrrSiteCompPropvalue.EndTime);
					sRecordedValues = sRecordedValues + lrrRunRecord.RunName + "|" + lrrRunRecord.RunDescription + "|";
					if(arrSiteCompPropIDs.Contains(lrrSiteCompPropvalue.SiteComponentPropertyID + lrrSiteCompPropvalue.StartTime + lrrSiteCompPropvalue.EndTime))
					{
						continue;
					}
					else
					{
						arrSiteCompPropIDs.Add(lrrSiteCompPropvalue.SiteComponentPropertyID + lrrSiteCompPropvalue.StartTime + lrrSiteCompPropvalue.EndTime);
					}

					sRecordedValues = sRecordedValues + lrrSiteCompPropvalue.StartTime + "|" + lrrSiteCompPropvalue.EndTime + "|";

					LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrSiteCompPropvalue.SiteComponentPropertyID);
				
					if(lrrSiteCompProperty != null)
					{
						LRRSiteComponent siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(lrrSiteCompProperty.ComponentID);
						//Site Component
						string sName = "";
						if(siteComp != null)
						{
							sName = siteComp.Name;
						}
						sRecordedValues = sRecordedValues + sName + "|";

						//SiteComponent Property
						sRecordedValues = sRecordedValues + lrrSiteCompProperty.Name + "|" ;
					}


					//Property Values
					Hashtable htModeIDs = new Hashtable();
					foreach(LRRSiteComponentPropertyValueChangeUserAndTime siteComp in lrrSiteComps)
					{
						string modeID = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(siteComp.SiteComponentPropertyValueID).ModeID;
						if(!htModeIDs.ContainsKey(modeID))
						{
							ArrayList arrPropValuesList = new ArrayList();
							arrPropValuesList.Add(siteComp.PropertyValue);
							htModeIDs.Add(modeID,arrPropValuesList);
						}
						else
						{
							ArrayList arrPropValuesList = htModeIDs[modeID] as ArrayList;
							arrPropValuesList.Add(siteComp.PropertyValue);
						}
					}

					string propValues = null;
					for(int i=0; i < LRRModel.ProjectModes.Count; i++)
					{
						int j = i + 1;
						string key = j.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string propValue = "";
						if(htModeIDs[key] != null)
						{
							ArrayList arrPropValuesList = htModeIDs[key] as ArrayList;
							for(int k = 0;k < arrPropValuesList.Count;k++)
							{
								string curVal = arrPropValuesList[k] == null ? "" : arrPropValuesList[k].ToString();
								if(k == arrPropValuesList.Count - 1)
									propValue = propValue + curVal;
								else
									propValue = propValue + curVal + ";";
							}
						}

						propValues = propValues + propValue + "|";
					
					}
					sRecordedValues = sRecordedValues + propValues;
					sw.WriteLine(sRecordedValues);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExportRecordedValuesUtiility),"Exception in exporting recording values :- " + ex.Message,Logger.Level.Debug);
				}
			}
			
			sw.Close();

		}
       /* public static void exportToExcel(string filename, LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteCompPropvalues, LRRRunRecord lrrRunRecord)
        {
            Microsoft.Office.Interop.Excel.Application app = new Application();
            Workbook workbook = null;
            workbook = app.Workbooks.Add(1);
            ArrayList arrSheets = lrrSiteCompPropvalues.GetSiteComponentsByRunID(lrrRunRecord.RunID);
            foreach (string sheetname in arrSheets)
            {
                Worksheet ws = null;
                //Range range = null;
                int scpColStartcount = 5;
                int startrowCount = 4;

                LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(sheetname);

                ws = (Worksheet)workbook.Worksheets.Add(System.Type.Missing, System.Type.Missing, System.Type.Missing, System.Type.Missing);
                ws.Name = sheetname;
                ((Range)ws.Cells[3, 1]).Value2 = "RunName";
                ((Range)ws.Cells[3, 2]).Value2 = "RunDescription";
                ((Range)ws.Cells[3, 3]).Value2 = "StartTime";
                ((Range)ws.Cells[3, 4]).Value2 = "EndTime";

                ArrayList arrColName = lrrSiteCompPropvalues.GetSiteComponentPropsByPlantItemandRunID(sheetname, lrrRunRecord.RunID);
                ArrayList startTimeList = lrrSiteCompPropvalues.GetStartTimeList(lrrRunRecord.RunID);
                Hashtable htTimeDetails = lrrSiteCompPropvalues.GetTimeDetails(lrrRunRecord.RunID);

                IEnumerator enumhtTimeDetails = htTimeDetails.GetEnumerator();
                int startrow = 4;
                foreach (string starttime in startTimeList)
                {
                    string endtime = (string)htTimeDetails[starttime];
                    ((Range)ws.Cells[startrow, 1]).Value2 = lrrRunRecord.RunName;
                    ((Range)ws.Cells[startrow, 2]).Value2 = lrrRunRecord.RunDescription;
                    ((Range)ws.Cells[startrow, 3]).Value2 = starttime ;
                    ((Range)ws.Cells[startrow, 4]).Value2 = endtime;

                    startrow++;
                }

                arrColName.Sort();
                
                foreach (string colName in arrColName)
                {
                    Range range = null;
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(colName);

                    range = ws.get_Range(ws.Cells[1, scpColStartcount], ws.Cells[1, scpColStartcount+2]);
                    range.Merge(3);
                    ((Range)ws.Cells[1, scpColStartcount]).Value2 = scp.Name;

                    range = ws.get_Range(ws.Cells[2, scpColStartcount], ws.Cells[2, scpColStartcount + 2]);
                    range.Merge(3);
                    ((Range)ws.Cells[2, scpColStartcount]).Value2 = scp.UOM;

                    LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);
                    if (uom != null)
                    {
                        ((Range)ws.Cells[2, scpColStartcount]).Value2 = uom.Name;
                    }

                    LRRSiteComponentPropertyValueChangeUserAndTimes scpvUAT = lrrSiteCompPropvalues.GetSCPVChangeUserAndTimesByRunIDandSCPID(lrrRunRecord.RunID, scp.ID);

                    for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                    {
                        LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                        int temprowcount = 4; 
                   
                        int tempMode = scpColStartcount;
                        if(lrrMode.ModeName != "Default")
                        {
                            tempMode = scpColStartcount + i - 1;
                            ((Range)ws.Cells[3, tempMode]).Value2 = lrrMode.ModeDisplayName;

                            foreach (string starttime in startTimeList)
                            {
                                foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpv in scpvUAT.FilterSiteComponentsBySiteComponentID(scp.ID,starttime,(string)htTimeDetails[starttime] ))
                                {
                                    if (scpv.ModeName == lrrMode.ModeName)
                                    {
                                        ((Range)ws.Cells[temprowcount, tempMode]).Value2 = scpv.PropertyValue;
                                       // temprowcount = temprowcount + 1;
                                    }
                                }

                                temprowcount = temprowcount + 1;
                            }
                        }
                    }
                    //startrowCount = startrowCount + 1;
                    scpColStartcount = scpColStartcount + 3;
                   // range.Interior.Color = System.Drawing.Color.Turquoise.ToArgb();
                }
            }
            workbook.SaveAs(filename, XlFileFormat.xlXMLSpreadsheet, System.Type.Missing, System.Type.Missing, false, false, XlSaveAsAccessMode.xlNoChange, System.Type.Missing, System.Type.Missing, System.Type.Missing, System.Type.Missing, System.Type.Missing);
            app.Quit();
        }
        */
        public static void exportToExcelSychFusion(string filename, LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteCompPropvalues, LRRRunRecord lrrRunRecord)
        {
            ExcelEngine excelEngine = new ExcelEngine();
            bool isUpend = false;
            IWorkbook myWorkBook = null;
            IApplication application = excelEngine.Excel;

            myWorkBook = excelEngine.Excel.Workbooks.Add();


            ArrayList arrSheets = lrrSiteCompPropvalues.GetSiteComponentsByRunID(lrrRunRecord.RunID);
            foreach (string sheetname in arrSheets)
            {
               // IWorksheet sheet = myWorkBook.Worksheets[0];
                int scpColStartcount = 5;

                myWorkBook.Worksheets.Create(sheetname);

                IWorksheet sheet = myWorkBook.Worksheets[sheetname];
                sheet.Range[3, 1].Value2 = "RunName";
                sheet.Range[3, 2].Value2 = "RunDescription";
                sheet.Range[3, 3].Value2 = "StartTime";
                sheet.Range[3, 4].Value2 = "EndTime";

                ArrayList arrColName = lrrSiteCompPropvalues.GetSiteComponentPropsByPlantItemandRunID(sheetname, lrrRunRecord.RunID);
                ArrayList startTimeList = lrrSiteCompPropvalues.GetStartTimeList(lrrRunRecord.RunID);
                Hashtable htTimeDetails = lrrSiteCompPropvalues.GetTimeDetails(lrrRunRecord.RunID);

                int startrow = 4;
                foreach (string starttime in startTimeList)
                {
                    string endtime = (string)htTimeDetails[starttime];
                    sheet.Range[startrow, 1].Value2 = lrrRunRecord.RunName;
                    sheet.Range[startrow, 2].Value2 = lrrRunRecord.RunDescription;
                    sheet.Range[startrow, 3].Value2 = starttime;
                    sheet.Range[startrow, 4].Value2 = endtime;
                    startrow++;
                }

                arrColName.Sort();

                foreach (string colName in arrColName)
                {
                    Syncfusion.ExcelRW.IRange range = null;
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(colName);
                    range = sheet.Range[1,scpColStartcount,1,scpColStartcount+2];
                    range.Merge();
                    sheet.Range[1, scpColStartcount].Value2 = scp.Name;
                    range = sheet.Range[2, scpColStartcount, 2, scpColStartcount + 2];
                    range.Merge();
                    LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);
                    if (uom != null)
                    {
                        sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                    }

                    LRRSiteComponentPropertyValueChangeUserAndTimes scpvUAT = lrrSiteCompPropvalues.GetSCPVChangeUserAndTimesByRunIDandSCPID(lrrRunRecord.RunID, scp.ID);

                    for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                    {
                        LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                        int temprowcount = 4;

                        int tempMode = scpColStartcount;
                        if (lrrMode.ModeName != "Default")
                        {
                            tempMode = scpColStartcount + i - 1;
                            sheet.Range[3, tempMode].Value2 = lrrMode.ModeDisplayName;
                            foreach (string starttime in startTimeList)
                            {
                                /*
                                foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpv in scpvUAT.FilterSiteComponentsBySiteComponentID(scp.ID, starttime, (string)htTimeDetails[starttime]))
                                {
                                    if (scpv.ModeName == lrrMode.ModeName)
                                    {
                                        sheet.Range[temprowcount, tempMode].Value2 = scpv.PropertyValue;
                                    }
                                }
                                temprowcount = temprowcount + 1;
                                */
                                foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpv in scpvUAT.FilterSiteComponentsBySiteComponentID(scp.ID, starttime, (string)htTimeDetails[starttime]))
                                {
                                    sheet.Range[temprowcount, tempMode].Value2 = scpv.PropertyValue;
                                    sheet.Range[temprowcount + 1, tempMode].Value2 = scpv.PropertyValue_SS;
                                    sheet.Range[temprowcount + 2, tempMode].Value2 = scpv.PropertyValue_SCEN;
                                }
                            }
                        }
                    }
                    scpColStartcount = scpColStartcount + 3;
                }
            }
            myWorkBook.SaveAs(filename);
            excelEngine.ThrowNotSavedOnDestroy = false;
            excelEngine.Dispose();
        }
        
		#endregion

		#region Fields
		#endregion
	}
}
