using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.MessageLogger;
using Microsoft.Office.Interop.Excel;
//using Syncfusion.ExcelRW;


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ExportRecordedValuesUtiility.
	/// </summary>
	public class ExportRecordedValuesUtiility
	{
		public ExportRecordedValuesUtiility()
		{
		}
		
		#region Methods
		public static void writeToExcel(string filename,LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteCompPropvalues,LRRRunRecord lrrRunRecord)
		{
			string sRecordedValues = null;
			
			StreamWriter sw = new StreamWriter(filename);
			//Header
			sRecordedValues = "RunName | RunDescription | StartTime | EndTime | SiteComponent | ";
			sRecordedValues = sRecordedValues + "SiteComponentProperty | ";
			for(int i=0 ; i < LRRModel.ProjectModes.Count; i++)
			{
				LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
				sRecordedValues = sRecordedValues + lrrMode.ModeName + "|";
			}
			
			
			sw.WriteLine(sRecordedValues);
			
			ArrayList arrSiteCompPropIDs = new ArrayList();
			//Recorded Values Rows
			foreach(LRRSiteComponentPropertyValueChangeUserAndTime lrrSiteCompPropvalue in lrrSiteCompPropvalues)
			{
				try
				{
					sRecordedValues = null;
	
					//filter By SiteComponentProperty And StartTime,EndTime
                    
					LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteComps = lrrSiteCompPropvalues.FilterSiteComponentsBySiteComponentID(lrrSiteCompPropvalue.SiteComponentPropertyID,lrrSiteCompPropvalue.StartTime,lrrSiteCompPropvalue.EndTime);
					sRecordedValues = sRecordedValues + lrrRunRecord.RunName + "|" + lrrRunRecord.RunDescription + "|";
					if(arrSiteCompPropIDs.Contains(lrrSiteCompPropvalue.SiteComponentPropertyID + lrrSiteCompPropvalue.StartTime + lrrSiteCompPropvalue.EndTime))
					{
						continue;
					}
					else
					{
						arrSiteCompPropIDs.Add(lrrSiteCompPropvalue.SiteComponentPropertyID + lrrSiteCompPropvalue.StartTime + lrrSiteCompPropvalue.EndTime);
					}

					sRecordedValues = sRecordedValues + lrrSiteCompPropvalue.StartTime + "|" + lrrSiteCompPropvalue.EndTime + "|";

					LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrSiteCompPropvalue.SiteComponentPropertyID);
				
					if(lrrSiteCompProperty != null)
					{
						LRRSiteComponent siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(lrrSiteCompProperty.ComponentID);
						//Site Component
						string sName = "";
						if(siteComp != null)
						{
							sName = siteComp.Name;
						}
						sRecordedValues = sRecordedValues + sName + "|";

						//SiteComponent Property
						sRecordedValues = sRecordedValues + lrrSiteCompProperty.Name + "|" ;
					}


					//Property Values
					Hashtable htModeIDs = new Hashtable();
					foreach(LRRSiteComponentPropertyValueChangeUserAndTime siteComp in lrrSiteComps)
					{
						string modeID = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(siteComp.SiteComponentPropertyValueID).ModeID;
						if(!htModeIDs.ContainsKey(modeID))
						{
							ArrayList arrPropValuesList = new ArrayList();
							arrPropValuesList.Add(siteComp.PropertyValue);
							htModeIDs.Add(modeID,arrPropValuesList);
						}
						else
						{
							ArrayList arrPropValuesList = htModeIDs[modeID] as ArrayList;
							arrPropValuesList.Add(siteComp.PropertyValue);
						}
					}

					string propValues = null;
					for(int i=0; i < LRRModel.ProjectModes.Count; i++)
					{
						int j = i + 1;
						string key = j.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string propValue = "";
						if(htModeIDs[key] != null)
						{
							ArrayList arrPropValuesList = htModeIDs[key] as ArrayList;
							for(int k = 0;k < arrPropValuesList.Count;k++)
							{
								string curVal = arrPropValuesList[k] == null ? "" : arrPropValuesList[k].ToString();
								if(k == arrPropValuesList.Count - 1)
									propValue = propValue + curVal;
								else
									propValue = propValue + curVal + ";";
							}
						}

						propValues = propValues + propValue + "|";
					
					}
					sRecordedValues = sRecordedValues + propValues;
					sw.WriteLine(sRecordedValues);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(ExportRecordedValuesUtiility),"Exception in exporting recording values :- " + ex.Message,Logger.Level.Debug);
				}
			}
			
			sw.Close();

		}
       /* public static void exportToExcel(string filename, LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteCompPropvalues, LRRRunRecord lrrRunRecord)
        {
            Microsoft.Office.Interop.Excel.Application app = new Application();
            Workbook workbook = null;
            workbook = app.Workbooks.Add(1);
            ArrayList arrSheets = lrrSiteCompPropvalues.GetSiteComponentsByRunID(lrrRunRecord.RunID);
            foreach (string sheetname in arrSheets)
            {
                Worksheet ws = null;
                //Range range = null;
                int scpColStartcount = 5;
                int startrowCount = 4;

                LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByName(sheetname);

                ws = (Worksheet)workbook.Worksheets.Add(System.Type.Missing, System.Type.Missing, System.Type.Missing, System.Type.Missing);
                ws.Name = sheetname;
                ((Range)ws.Cells[3, 1]).Value2 = "RunName";
                ((Range)ws.Cells[3, 2]).Value2 = "RunDescription";
                ((Range)ws.Cells[3, 3]).Value2 = "StartTime";
                ((Range)ws.Cells[3, 4]).Value2 = "EndTime";

                ArrayList arrColName = lrrSiteCompPropvalues.GetSiteComponentPropsByPlantItemandRunID(sheetname, lrrRunRecord.RunID);
                ArrayList startTimeList = lrrSiteCompPropvalues.GetStartTimeList(lrrRunRecord.RunID);
                Hashtable htTimeDetails = lrrSiteCompPropvalues.GetTimeDetails(lrrRunRecord.RunID);

                IEnumerator enumhtTimeDetails = htTimeDetails.GetEnumerator();
                int startrow = 4;
                foreach (string starttime in startTimeList)
                {
                    string endtime = (string)htTimeDetails[starttime];
                    ((Range)ws.Cells[startrow, 1]).Value2 = lrrRunRecord.RunName;
                    ((Range)ws.Cells[startrow, 2]).Value2 = lrrRunRecord.RunDescription;
                    ((Range)ws.Cells[startrow, 3]).Value2 = starttime ;
                    ((Range)ws.Cells[startrow, 4]).Value2 = endtime;

                    startrow++;
                }

                arrColName.Sort();
                
                foreach (string colName in arrColName)
                {
                    Range range = null;
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(colName);

                    range = ws.get_Range(ws.Cells[1, scpColStartcount], ws.Cells[1, scpColStartcount+2]);
                    range.Merge(3);
                    ((Range)ws.Cells[1, scpColStartcount]).Value2 = scp.Name;

                    range = ws.get_Range(ws.Cells[2, scpColStartcount], ws.Cells[2, scpColStartcount + 2]);
                    range.Merge(3);
                    ((Range)ws.Cells[2, scpColStartcount]).Value2 = scp.UOM;

                    LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);
                    if (uom != null)
                    {
                        ((Range)ws.Cells[2, scpColStartcount]).Value2 = uom.Name;
                    }

                    LRRSiteComponentPropertyValueChangeUserAndTimes scpvUAT = lrrSiteCompPropvalues.GetSCPVChangeUserAndTimesByRunIDandSCPID(lrrRunRecord.RunID, scp.ID);

                    for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                    {
                        LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                        int temprowcount = 4; 
                   
                        int tempMode = scpColStartcount;
                        if(lrrMode.ModeName != "Default")
                        {
                            tempMode = scpColStartcount + i - 1;
                            ((Range)ws.Cells[3, tempMode]).Value2 = lrrMode.ModeDisplayName;

                            foreach (string starttime in startTimeList)
                            {
                                foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpv in scpvUAT.FilterSiteComponentsBySiteComponentID(scp.ID,starttime,(string)htTimeDetails[starttime] ))
                                {
                                    if (scpv.ModeName == lrrMode.ModeName)
                                    {
                                        ((Range)ws.Cells[temprowcount, tempMode]).Value2 = scpv.PropertyValue;
                                       // temprowcount = temprowcount + 1;
                                    }
                                }

                                temprowcount = temprowcount + 1;
                            }
                        }
                    }
                    //startrowCount = startrowCount + 1;
                    scpColStartcount = scpColStartcount + 3;
                   // range.Interior.Color = System.Drawing.Color.Turquoise.ToArgb();
                }
            }
            workbook.SaveAs(filename, XlFileFormat.xlXMLSpreadsheet, System.Type.Missing, System.Type.Missing, false, false, XlSaveAsAccessMode.xlNoChange, System.Type.Missing, System.Type.Missing, System.Type.Missing, System.Type.Missing, System.Type.Missing);
            app.Quit();
        }
        */

        /*public static void exportToExcelSychFusion(string filename, LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteCompPropvalues, LRRRunRecords lrrRunRecords,string runsetName  )
        {

            ExcelEngine excelEngine = new ExcelEngine();
            excelEngine.ThrowNotSavedOnDestroy = false;
            bool isUpend = false;
            IWorkbook myWorkBook = null;
            IApplication application = excelEngine.Excel;

            LRRSiteComponents lscs = new LRRSiteComponents();
            LRRSiteComponentProperties lscps = new LRRSiteComponentProperties();
            LRRMasterComponents lmcs = LRRModel.ChildModel.MasterComponents;
            lmcs.SortColumn = "ComponentName";
            lmcs.Sort();

            //myWorkBook = excelEngine.Excel.Workbooks.Add();
            myWorkBook = ExcelUtils.CreateWorkBookUsingTemplate(System.Windows.Forms.Application.StartupPath + "\\" + "Template.xlt");

            LRRUserSpecificRecordedProperties usRps = LRRModel.UserSpecificRecordedProperties;
            if (usRps != null)
            {
                usRps.SortColumn = "SiteComponentID";
                usRps.Sort();
            }

            int scpColStartcount = 5;
            int scpColStartcount1 = 5;
            int sheetCount = 1;
            List<string> sheetList = new List<string>();
            List<string> sheetList1 = new List<string>();

            SortedList<string, string> sortedPI = new SortedList<string, string>();
            LRRSiteComponents scs = new LRRSiteComponents();
            foreach (LRRUserSpecificRecordedProperty usp in usRps)
            {
                LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(usp.SiteComponentID);
                LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(usp.SiteComponentPropertyID);
                if (sc != null)
                {
                    IWorksheet sheet = null;
                    if (!sheetList.Contains(sc.Name))
                    {
                        scpColStartcount = 5;
                        string sheetname = sc.Name;
                        sheetname = sheetname.Replace("/", "_");
                        sheetname = sheetname.Replace("?", "_");
                        sheetname = sheetname.Replace("*", "_");
                        sheetname = sheetname.Replace("+", "_");
                        myWorkBook.Worksheets.Create(sc.Name);
                        sheet = myWorkBook.Worksheets[sc.Name];
                        sheetList.Add(sc.Name);
                        int startrow = 4;
                        LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);

                        sheet.Range[1, 1].Value2 = sc.Name;
                        sheet.Range[1, scpColStartcount].Value2 = scp.Name;
                        sheet.Range[1, scpColStartcount + 1].Value2 = scp.Name;
                        sheet.Range[1, scpColStartcount + 2].Value2 = scp.Name;
                        if (uom != null)
                        {
                            sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                            sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                            sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;
                        }
                        for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                        {
                            LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                            if (lrrMode.ModeDisplayName != "Default")
                            {
                                sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                            }
                        }
                        scpColStartcount = scpColStartcount + 3;
                    }
                    else
                    {
                        if (scpColStartcount > 253)
                        {
                            scpColStartcount1 = 5;
                            sheetCount = sheetCount + 1;
                            string sheetname = sc.Name + "1";
                            sheetname = sheetname.Replace("/", "_");
                            sheetname = sheetname.Replace("?", "_");
                            sheetname = sheetname.Replace("*", "_");
                            sheetname = sheetname.Replace("+", "_");
                            myWorkBook.Worksheets.Create(sc.Name + "1");
                            sheet = myWorkBook.Worksheets[sc.Name + "1"];
                            sheetList1.Add(sc.Name + "1");
                            int startrow = 4;
                            LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);

                            sheet.Range[1, 1].Value2 = sc.Name;
                            sheet.Range[1, scpColStartcount1].Value2 = scp.Name;
                            sheet.Range[1, scpColStartcount1 + 1].Value2 = scp.Name;
                            sheet.Range[1, scpColStartcount1 + 2].Value2 = scp.Name;
                            if (uom != null)
                            {
                                sheet.Range[2, scpColStartcount1].Value2 = uom.Name;
                                sheet.Range[2, scpColStartcount1 + 1].Value2 = uom.Name;
                                sheet.Range[2, scpColStartcount1 + 2].Value2 = uom.Name;
                            }
                            for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                            {
                                LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                if (lrrMode.ModeDisplayName != "Default")
                                {
                                    sheet.Range[3, scpColStartcount1 + i - 1].Value2 = lrrMode.ModeDisplayName;
                                }
                            }
                            scpColStartcount1 = scpColStartcount1 + 3;
                            scpColStartcount = scpColStartcount + 3;

                        }
                        else
                        {
                            sheet = myWorkBook.Worksheets[sc.Name];

                            LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);

                            sheet.Range[1, scpColStartcount].Value2 = scp.Name;
                            sheet.Range[1, scpColStartcount + 1].Value2 = scp.Name;
                            sheet.Range[1, scpColStartcount + 2].Value2 = scp.Name;
                            if (uom != null)
                            {
                                sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                                sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                                sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;
                            }
                            for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                            {
                                LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                if (lrrMode.ModeDisplayName != "Default")
                                {
                                    sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                                }
                            }
                            scpColStartcount = scpColStartcount + 3;

                        }
                    }
                }
                
            }

            
           
            #region before new implementation
            /*
            foreach (LRRMasterComponent mc in lmcs)
            {
                lscs = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(mc.ID);
                if (lscs != null && lscs.Count != 0)
                {
                    lscs.SortColumn = "Name";
                    lscs.Sort();
                    try
                    {
                        #region sheets
                        foreach (LRRSiteComponent sc in lscs)
                        {
                            int x = 1;
                            IWorksheet sheet = null;
                            int scpColStartcount = 5;
                            string sheetname = sc.Name;
                            sheetname = sheetname.Replace("/", "_");
                            sheetname = sheetname.Replace("?", "_");
                            sheetname = sheetname.Replace("*", "_");
                            sheetname = sheetname.Replace("+", "_");


                            lscps = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(sc.SiteComponentID);
                            lscps = LRRModel.SiteComponentPropertiesObj.GetAllRecordedPropertiesByComponentID(sc.SiteComponentID);
                            
                            if (lscps != null)
                            {
                                lscps.SortColumn = "Name";
                                lscps.Sort();

                                foreach (LRRSiteComponentProperty lscp in lscps)
                                {
                                    if (lscp.IsTracked)
                                    {

                                        int startrow = 4;

                                        if (x == 1)
                                        {
                                            if (sheet == null)
                                            {
                                                myWorkBook.Worksheets.Create(sc.Name);
                                                sheet = myWorkBook.Worksheets[sc.Name];
                                            }

                                            sheet.Range[3, 1].Value2 = "RunName";
                                            sheet.Range[3, 2].Value2 = "RunDescription";
                                            sheet.Range[3, 3].Value2 = "StartTime";
                                            sheet.Range[3, 4].Value2 = "EndTime";


                                            LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(lscp.UOM);

                                            sheet.Range[1, scpColStartcount].Value2 = lscp.Name;
                                            sheet.Range[1, scpColStartcount + 1].Value2 = lscp.Name;
                                            sheet.Range[1, scpColStartcount + 2].Value2 = lscp.Name;


                                            if (uom != null)
                                            {

                                                sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                                                sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                                                sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;
                                            }

                                            for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                            {
                                                LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                                if (lrrMode.ModeDisplayName != "Default")
                                                {
                                                    sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                                                }

                                            }

                                            lrrRunRecords.SortColumn = "StartTime";
                                            lrrRunRecords.SortingOrder = Symcon.BusinessObjects.GenericComparer.SortOrder.Ascending;
                                            lrrRunRecords.Sort();
                                            try
                                            {
                                                foreach (LRRRunRecord runrec in lrrRunRecords)
                                                {
                                                    sheet.Range[startrow, 1].Value2 = runrec.RunName;
                                                    sheet.Range[startrow, 2].Value2 = runrec.RunDescription;
                                                    sheet.Range[startrow, 3].Value2 = runrec.StartTime;
                                                    sheet.Range[startrow, 4].Value2 = runrec.EndTime;
                                                    startrow++;
                                                }

                                                x++;
                                                scpColStartcount = scpColStartcount + 3;
                                            }
                                            catch (Exception ex)
                                            {
                                                goto Continue;
                                            }

                                        }
                                        else if (x > 1)
                                        {
                                            if (scpColStartcount < 254)
                                            {
                                                sheet = myWorkBook.Worksheets[sc.Name];
                                                sheet.Range[1, scpColStartcount].Value2 = lscp.Name;

                                                sheet.Range[1, scpColStartcount].Value2 = lscp.Name;
                                                sheet.Range[1, scpColStartcount + 1].Value2 = lscp.Name;
                                                sheet.Range[1, scpColStartcount + 2].Value2 = lscp.Name;


                                                LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(lscp.UOM);
                                                if (uom != null)
                                                {

                                                    sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                                                    sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                                                    sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;

                                                }

                                                for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                                {
                                                    LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                                    if (lrrMode.ModeDisplayName != "Default")
                                                    {
                                                        sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                                                    }
                                                }
                                            }

                                            scpColStartcount = scpColStartcount + 3;
                                            x++;
                                        }
                                    }
                                }
                            }
                        }
                        #endregion

                    }
                    catch (Exception ex)
                    {
                        goto Continue;
                    }
                }
            }
            */
#endregion

            #region beforeUSP
            /*
            List<string> sheetList = new List<string>();
            List<string> sheetList1 = new List<string>();
            LRRSiteComponentProperties recAttrList = LRRModel.SiteComponentPropertiesObj.GetRecordedAttributeList();
            recAttrList.SortColumn = "ComponentID";
            recAttrList.Sort();

            foreach (LRRSiteComponentProperty scp in recAttrList)
            {
                
                LRRSiteComponent sc = LRRModel.SiteComponentsObj.GetSiteComponentByID(scp.ComponentID);
                
                if (sc != null)
                {
                    IWorksheet sheet = null;

                    if (!sheetList.Contains(sc.Name))
                    {
                        scpColStartcount = 5;
                        string sheetname = sc.Name;
                        sheetname = sheetname.Replace("/", "_");
                        sheetname = sheetname.Replace("?", "_");
                        sheetname = sheetname.Replace("*", "_");
                        sheetname = sheetname.Replace("+", "_");
                        myWorkBook.Worksheets.Create(sc.Name);
                        sheet = myWorkBook.Worksheets[sc.Name];
                        sheetList.Add(sc.Name);
                        int startrow = 4;
                        LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);

                        sheet.Range[1, 1].Value2 = sc.Name;
                        sheet.Range[1, scpColStartcount].Value2 = scp.Name;
                        sheet.Range[1, scpColStartcount + 1].Value2 = scp.Name;
                        sheet.Range[1, scpColStartcount + 2].Value2 = scp.Name;
                        if (uom != null)
                        {
                            sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                            sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                            sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;
                        }
                        for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                        {
                            LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                            if (lrrMode.ModeDisplayName != "Default")
                            {
                                sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                            }
                        }
                        scpColStartcount = scpColStartcount + 3;
                    }
                    else
                    {
                        if (scpColStartcount > 253)
                        {
                            sheet = null;
                            if (!sheetList1.Contains(sc.Name + "1"))
                            {
                                scpColStartcount1 = 5;
                                sheetCount = sheetCount + 1;
                                string sheetname = sc.Name + "1";
                                sheetname = sheetname.Replace("/", "_");
                                sheetname = sheetname.Replace("?", "_");
                                sheetname = sheetname.Replace("*", "_");
                                sheetname = sheetname.Replace("+", "_");
                                myWorkBook.Worksheets.Create(sc.Name + "1");
                                sheet = myWorkBook.Worksheets[sc.Name + "1"];
                                sheetList1.Add(sc.Name + "1");
                                int startrow = 4;
                                LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);

                                sheet.Range[1, 1].Value2 = sc.Name;
                                sheet.Range[1, scpColStartcount1].Value2 = scp.Name;
                                sheet.Range[1, scpColStartcount1 + 1].Value2 = scp.Name;
                                sheet.Range[1, scpColStartcount1 + 2].Value2 = scp.Name;
                                if (uom != null)
                                {
                                    sheet.Range[2, scpColStartcount1].Value2 = uom.Name;
                                    sheet.Range[2, scpColStartcount1 + 1].Value2 = uom.Name;
                                    sheet.Range[2, scpColStartcount1 + 2].Value2 = uom.Name;
                                }
                                for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                {
                                    LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                    if (lrrMode.ModeDisplayName != "Default")
                                    {
                                        sheet.Range[3, scpColStartcount1 + i - 1].Value2 = lrrMode.ModeDisplayName;
                                    }
                                }
                                scpColStartcount1 = scpColStartcount1 + 3;
                                scpColStartcount = scpColStartcount + 3;

                            }
                            else
                            {
                                sheet = myWorkBook.Worksheets[sc.Name + "1"];

                                LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);

                                sheet.Range[1, scpColStartcount1].Value2 = scp.Name;
                                sheet.Range[1, scpColStartcount1 + 1].Value2 = scp.Name;
                                sheet.Range[1, scpColStartcount1 + 2].Value2 = scp.Name;
                                if (uom != null)
                                {
                                    sheet.Range[2, scpColStartcount1].Value2 = uom.Name;
                                    sheet.Range[2, scpColStartcount1 + 1].Value2 = uom.Name;
                                    sheet.Range[2, scpColStartcount1 + 2].Value2 = uom.Name;
                                }
                                for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                {
                                    LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                    if (lrrMode.ModeDisplayName != "Default")
                                    {
                                        sheet.Range[3, scpColStartcount1 + i - 1].Value2 = lrrMode.ModeDisplayName;
                                    }
                                }
                                scpColStartcount = scpColStartcount + 3;
                                scpColStartcount1 = scpColStartcount1 + 3;
                            }
                            //goto loop;
                        }
                        else
                        {
                            sheet = myWorkBook.Worksheets[sc.Name];

                            LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);

                            sheet.Range[1, scpColStartcount].Value2 = scp.Name;
                            sheet.Range[1, scpColStartcount + 1].Value2 = scp.Name;
                            sheet.Range[1, scpColStartcount + 2].Value2 = scp.Name;
                            if (uom != null)
                            {
                                sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                                sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                                sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;
                            }
                            for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                            {
                                LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                if (lrrMode.ModeDisplayName != "Default")
                                {
                                    sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                                }
                            }
                            scpColStartcount = scpColStartcount + 3;
                        }

                    }
                }
            }
            */
            #endregion



            #region sheets
        /*
            foreach (LRRSiteComponent sc in lscs)
            {
                int x = 1;
                IWorksheet sheet = null;
                int scpColStartcount = 5;
                lscps = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(sc.SiteComponentID);

                if (lscps != null)
                {
                    lscps.SortColumn = "Name";
                    lscps.Sort();

                    foreach (LRRSiteComponentProperty lscp in LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(sc.SiteComponentID))
                    {
                        if (lscp.IsTracked)
                        {

                            int startrow = 4;

                            if (x == 1)
                            {
                                if (sheet == null)
                                {
                                    myWorkBook.Worksheets.Create(sc.Name);
                                    sheet = myWorkBook.Worksheets[sc.Name];
                                }

                                sheet.Range[3, 1].Value2 = "RunName";
                                sheet.Range[3, 2].Value2 = "RunDescription";
                                sheet.Range[3, 3].Value2 = "StartTime";
                                sheet.Range[3, 4].Value2 = "EndTime";



                                LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(lscp.UOM);

                                sheet.Range[1, scpColStartcount].Value2 = lscp.Name;
                                sheet.Range[1, scpColStartcount + 1].Value2 = lscp.Name;
                                sheet.Range[1, scpColStartcount + 2].Value2 = lscp.Name;


                                if (uom != null)
                                {

                                    sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                                    sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                                    sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;
                                }

                                for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                {
                                    LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                    if (lrrMode.ModeDisplayName != "Default")
                                    {
                                        sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                                    }

                                }

                                lrrRunRecords.SortColumn = "StartTime";
                                lrrRunRecords.SortingOrder = Symcon.BusinessObjects.GenericComparer.SortOrder.Ascending;
                                lrrRunRecords.Sort();

                                foreach (LRRRunRecord runrec in lrrRunRecords)
                                {
                                    sheet.Range[startrow, 1].Value2 = runrec.RunName;
                                    sheet.Range[startrow, 2].Value2 = runrec.RunDescription;
                                    sheet.Range[startrow, 3].Value2 = runrec.StartTime;
                                    sheet.Range[startrow, 4].Value2 = runrec.EndTime;
                                    startrow++;
                                }

                                x++;
                                scpColStartcount = scpColStartcount + 3;
                                //break;

                            }
                            else if (x > 1)
                            {
                                if (scpColStartcount < 254)
                                {
                                    sheet = myWorkBook.Worksheets[sc.Name];
                                    sheet.Range[1, scpColStartcount].Value2 = lscp.Name;

                                    sheet.Range[1, scpColStartcount].Value2 = lscp.Name;
                                    sheet.Range[1, scpColStartcount + 1].Value2 = lscp.Name;
                                    sheet.Range[1, scpColStartcount + 2].Value2 = lscp.Name;


                                    LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(lscp.UOM);
                                    if (uom != null)
                                    {

                                        sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                                        sheet.Range[2, scpColStartcount + 1].Value2 = uom.Name;
                                        sheet.Range[2, scpColStartcount + 2].Value2 = uom.Name;

                                    }

                                    for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                                    {
                                        LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                                        if (lrrMode.ModeDisplayName != "Default")
                                        {
                                            sheet.Range[3, scpColStartcount + i - 1].Value2 = lrrMode.ModeDisplayName;
                                        }
                                    }
                                }

                                scpColStartcount = scpColStartcount + 3;
                                x++;
                            }
                        }
                    }
                }
                // end
            }
*/
            #endregion
            //end
            #region comments
            /*
            Dictionary<string, LRRSiteComponentProperties> lscpsForSiteComponents = new Dictionary<string, LRRSiteComponentProperties>();
            List<string> arrSheets = lrrSiteCompPropvalues.GetSiteComponentsNameAndProperties(out lscpsForSiteComponents);
            foreach (string sheetname in arrSheets)
            {
                int scpColStartcount = 5;

                myWorkBook.Worksheets.Create(sheetname);

                IWorksheet sheet = myWorkBook.Worksheets[sheetname];
                sheet.Range[3, 1].Value2 = "RunName";
                sheet.Range[3, 2].Value2 = "RunDescription";
                sheet.Range[3, 3].Value2 = "StartTime";
                sheet.Range[3, 4].Value2 = "EndTime";

                int measModeCol = 0;
                int ssModeCol = 0;
                int scenModeCol = 0;

                LRRSiteComponentProperties lscps = lscpsForSiteComponents[sheetname];
                List<string> processedProperites = new List<string>();
                foreach (LRRSiteComponentProperty lscp in lscps)
                {
                    int startrow = 4;
                    if (scpColStartcount == 255)
                    {
                        int xyz = 0;
                    }
                    try
                    {
                        foreach (LRRRunRecord runRecObj in lrrRunRecords)
                        {
                            LRRSiteComponentPropertyValueChangeUserAndTime scpvUAT = lrrSiteCompPropvalues.GetSiteComponetValueUAT(runRecObj.RunID, lscp.ID);
                            if (scpvUAT != null)
                            {
                                if (scpColStartcount > 252)
                                {
                                    int xyz1 = 0;
                                    break;
                                }
                                sheet.Range[startrow, 1].Value2 = runRecObj.RunName;
                                sheet.Range[startrow, 2].Value2 = runRecObj.RunName;
                                sheet.Range[startrow, 3].Value2 = runRecObj.StartTime;
                                sheet.Range[startrow, 4].Value2 = runRecObj.EndTime;

                                Syncfusion.ExcelRW.IRange range = null;
                                int tempMode = scpColStartcount;


                                range = sheet.Range[1, scpColStartcount, 1, scpColStartcount + 2];
                                range.Merge();
                                sheet.Range[1, scpColStartcount].Value2 = lscp.Name;
                                range = sheet.Range[2, scpColStartcount, 2, scpColStartcount + 2];
                                range.Merge();
                                LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(lscp.UOM);
                                if (uom != null)
                                {
                                    sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                                }
                                scpvUAT = null;
                                startrow++;
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        Logger.LogMessage(null, "Exception during Record Export:- " + ex.Message, Logger.Level.Debug);
                    }
                    if (scpColStartcount > 252)
                    {
                        int xyz1 = 0;
                        break;
                    }

                    scpColStartcount = scpColStartcount + 3;
                    
                }
            }
             * */
//            arrSheets.Clear();
            //          lscpsForSiteComponents.Clear();
            #endregion

            //Continue:
            //IWorksheet sheet1 = null;

           // sheet1 = myWorkBook.Worksheets["Sheet1"];

            //sheet = myWorkBook.Worksheets(1);
            //LRRApp _app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            //Symcon.LightRidge.Options.DBOptions.DBInfo dbi = _app.RecordingValuesManagerObj.RecordingValuesDBManagerObj.DatabaseInfo;
            //sheet1.Range[4, 4].Value2 = dbi.DatabaseName;
            //sheet1.Range[8, 4].Value2 = dbi.ServerName;
            //sheet1.Range[9, 4].Value2 = dbi.DatabaseUser;
            //sheet1.Range[10, 4].Value2 = dbi.DatabasePWD;
            //sheet1.Range[13, 4].Value2 = runsetName;
            //Symcon.LightRidge.ExcelWrapper.SymExcelWrapper	ew = new Symcon.LightRidge.ExcelWrapper.SymExcelWrapper;
            //ew.OpenWorkBook(filename);


            //myWorkBook.SaveAs(filename);

            //myWorkBook.Activate();

            

            
            //_app.RecordingValuesManagerObj.RecordingValuesDBManagerObj.
            //sheet.Range[4,4].Value2 = _app.

            //sheet.Range[4, 4].Value2 = lrrap;
            
            //excelEngine.ThrowNotSavedOnDestroy = false;
            //excelEngine.Dispose();

        //}*/
        /*public static void exportToExcelSychFusion(string filename, LRRSiteComponentPropertyValueChangeUserAndTimes lrrSiteCompPropvalues, LRRRunRecord lrrRunRecord)
        {
            ExcelEngine excelEngine = new ExcelEngine();
            Syncfusion.ExcelRW.ExcelUtils utils = new Syncfusion.ExcelRW.ExcelUtils();
            

            bool isUpend = false;
            IWorkbook myWorkBook = null;
            IApplication application = excelEngine.Excel;

            myWorkBook = excelEngine.Excel.Workbooks.Add();
            

            ArrayList arrSheets = lrrSiteCompPropvalues.GetSiteComponentsByRunID(lrrRunRecord.RunID);
            foreach (string sheetname in arrSheets)
            {
               // IWorksheet sheet = myWorkBook.Worksheets[0];
                int scpColStartcount = 5;

                myWorkBook.Worksheets.Create(sheetname);

                IWorksheet sheet = myWorkBook.Worksheets[sheetname];
                sheet.Range[3, 1].Value2 = "RunName";
                sheet.Range[3, 2].Value2 = "RunDescription";
                sheet.Range[3, 3].Value2 = "StartTime";
                sheet.Range[3, 4].Value2 = "EndTime";

                //sheet

                ArrayList arrColName = lrrSiteCompPropvalues.GetSiteComponentPropsByPlantItemandRunID(sheetname, lrrRunRecord.RunID);
                ArrayList startTimeList = lrrSiteCompPropvalues.GetStartTimeList(lrrRunRecord.RunID);
                Hashtable htTimeDetails = lrrSiteCompPropvalues.GetTimeDetails(lrrRunRecord.RunID);

                int startrow = 4;
                foreach (string starttime in startTimeList)
                {
                    string endtime = (string)htTimeDetails[starttime];
                    sheet.Range[startrow, 1].Value2 = lrrRunRecord.RunName;
                    sheet.Range[startrow, 2].Value2 = lrrRunRecord.RunDescription;
                    sheet.Range[startrow, 3].Value2 = starttime;
                    sheet.Range[startrow, 4].Value2 = endtime;
                    startrow++;
                }

                arrColName.Sort();

                foreach (string colName in arrColName)
                {
                    Syncfusion.ExcelRW.IRange range = null;
                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(colName);
                    range = sheet.Range[1,scpColStartcount,1,scpColStartcount+2];
                    range.Merge();
                    sheet.Range[1, scpColStartcount].Value2 = scp.Name;
                    range = sheet.Range[2, scpColStartcount, 2, scpColStartcount + 2];
                    range.Merge();
                    LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(scp.UOM);
                    if (uom != null)
                    {
                        sheet.Range[2, scpColStartcount].Value2 = uom.Name;
                    }

                    LRRSiteComponentPropertyValueChangeUserAndTimes scpvUAT = lrrSiteCompPropvalues.GetSCPVChangeUserAndTimesByRunIDandSCPID(lrrRunRecord.RunID, scp.ID);

                    for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                    {
                        LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
                        int temprowcount = 4;

                        int tempMode = scpColStartcount;
                        if (lrrMode.ModeName != "Default")
                        {
                            tempMode = scpColStartcount + i - 1;
                            sheet.Range[3, tempMode].Value2 = lrrMode.ModeDisplayName;
                            foreach (string starttime in startTimeList)
                            {
                                /* commented by ashwin
                                foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpv in scpvUAT.FilterSiteComponentsBySiteComponentID(scp.ID, starttime, (string)htTimeDetails[starttime]))
                                {
                                    if (scpv.ModeName == lrrMode.ModeName)
                                    {
                                        sheet.Range[temprowcount, tempMode].Value2 = scpv.PropertyValue;
                                    }
                                }
                                temprowcount = temprowcount + 1;
                                */
                                //foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpv in scpvUAT.FilterSiteComponentsBySiteComponentID(scp.ID, starttime, (string)htTimeDetails[starttime]))
                                //{
                                   // sheet.Range[temprowcount, tempMode].Value2 = scpv.PropertyValue;
                                    //sheet.Range[temprowcount + 1, tempMode].Value2 = scpv.PropertyValue_SS;
                                    //sheet.Range[temprowcount + 2, tempMode].Value2 = scpv.PropertyValue_SCEN;
                               // }
                            //}
                        //}
                    //}
                    //scpColStartcount = scpColStartcount + 3;
                //}
            //}

            //ExcelUtils.CreateWorkBookUsingTemplate("c:\");

            //myWorkBook.SaveAs(filename);
            //excelEngine.ThrowNotSavedOnDestroy = false;
            //excelEngine.Dispose();
        //}
        
		

		#region Fields
		#endregion
	}
}
