using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.Runcontrol;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.BusinessObjects;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.Options;
using Symcon.Globals.Enums;
using Symcon.Utils.MessageDispatcher;
using Symcon.BusinessObjects;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for RunControlPanelDialog.
	/// </summary>
	
	public class RunControlPanelDialog : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.ComponentModel.IContainer components;

		private System.Threading.Timer timer;
		private DateTime timeSliceStart;
		private DateTime timeSliceEnd;
		private DateTime startSeris;
		private DateTime timeTandemSeries;
		private LRRModes _lrrModes;
		private Queue _runQueue = new Queue();
		private LRROptions _lrrOptions;
		private string _sDBName="";
		private TimeWindow _timeWnd;
        private bool _isEndDateTimeClose = true;
        private bool _isDateTimePickerAutoRunEndTime = true;
        private bool _isDateTimePickerAutoRunStartTime = true;
        private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.GroupBox groupBox8;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ComboBox cmbTandemOffsetUnits;
		private System.Windows.Forms.TextBox txtTandemOffset;
		private System.Windows.Forms.CheckBox chkTandemRuns;
		private System.Windows.Forms.ComboBox cmbIncrementUnits;
		private System.Windows.Forms.TextBox txtTimeIncrment;
		private System.Windows.Forms.RadioButton rbSequentialDataSets;
		private System.Windows.Forms.RadioButton rbRandomSets;
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Button btnRun;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnNew;
		private System.Windows.Forms.Button btnInitializeModels;
		private System.Windows.Forms.Button btnRunAdvance;
		private System.Windows.Forms.Button btnRunEnteredWindow;
		private System.Windows.Forms.CheckBox chkRecordValues;
		private System.Windows.Forms.CheckBox chkAutoRun;
		private System.Windows.Forms.CheckBox chkSaveDataSets;
		private System.Windows.Forms.GroupBox groupBoxAutoRun;
		private System.Windows.Forms.DateTimePicker dateTimePickerAutoRunEnd;
		private System.Windows.Forms.Label lblAutoRunEndDateTime;
		private System.Windows.Forms.DateTimePicker dateTimePickerAutoRunStart;
		private System.Windows.Forms.Label lblAutoRunStartTime;
		private System.Windows.Forms.CheckBox chkAutoRunBoundries;
		private System.Windows.Forms.ComboBox cmbRunControlSet;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label lblDBName;
		private System.Windows.Forms.Label lblTuningDB;
		private System.Windows.Forms.ComboBox cmbOfflineDataSource;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ComboBox cmbDataSourceType;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.GroupBox groupBox2;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridModes;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.ComboBox cmbDataWindowUnits;
		private System.Windows.Forms.TextBox txtDataWindowSize;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.DateTimePicker dateTimeDataWindowEnd;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.DateTimePicker dateTimeDataWindowStart;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.ComboBox cmbLagUnits;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtLag;
		private System.Windows.Forms.RadioButton rbForwardLooking;
		private System.Windows.Forms.RadioButton rbHistorical;
		private System.Windows.Forms.RadioButton rbCurrent;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.DateTimePicker dateTimeSeriesEnd;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.DateTimePicker dateTimeSeriesStart;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Button BtnRunNextStep;
		private System.Windows.Forms.RadioButton chkTimeIncrement;
		private System.Windows.Forms.GroupBox grpRecordRun;
		private System.Windows.Forms.Label lblRunName;
		private System.Windows.Forms.Label lblDesc;
		private System.Windows.Forms.TextBox txtDesc;
		private System.Windows.Forms.ComboBox cmbRecordRun;
		private bool isAborted = false;
        private System.Windows.Forms.CheckBox chkEnableBackfilling;
        private CheckBox chkSaveOfflinehistorian;

		private GridUnBoundColumn _unBoundModes;

		public RunControlPanelDialog()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			bindDataSorceTypeComboBox();
            this._runController.CurrentTunningDBChanged += new EventHandler(_runController_CurrentTunningDBChanged);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

        void _runController_CurrentTunningDBChanged(object sender, EventArgs e)
        {
            lblTuningDB.Text = sender as string;
        }

		private void bindDataSorceTypeComboBox()
		{
			this.cmbDataSourceType.Items.Add(LRRHeaderText.GetHeaderString("SID_ONLINE"));
			this.cmbDataSourceType.Items.Add(LRRHeaderText.GetHeaderString("SID_OFFLINE"));
			this.cmbDataSourceType.Items.Add(LRRHeaderText.GetHeaderString("SID_OFFLINE_FEEDBACK_ONLINE"));
			this.cmbDataSourceType.Items.Add(LRRHeaderText.GetHeaderString("SID_TUNING"));
		}
		public RunControlPanelDialog(RunOptions runOptions,TimeWindow timeWnd)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_timeWnd = timeWnd;

			_runOptionsObj = runOptions;
			//Get the App Object
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

		
            //_lrrModes=new LRRModes();
            //_app.DBManagerObj.PopulateCollection(_lrrModes,null);
            _lrrModes = LRRModel.ProjectModes;
			
			bindDataSorceTypeComboBox();
			BindGridModes();
			//Initialize the run controller...
			_runController = _app.RunControllerObj; 
			//_runController.Initialize();
			_runController.RunStarted+=new RunStartedDel(_runController_RunStarted);
			_runController.ReceivedPoint+=new ReceivedPointDataDel(_runController_ReceivedPoint);
			_runController.RunCompleted+=new EventHandler(_runController_RunCompleted);	
			_runController.RunStopped+=new EventHandler(_runController_RunStopped);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			int nCtr = 0;
			_lrrOptions = _app.GetOptions();
            this._runController.CurrentTunningDBChanged += new EventHandler(_runController_CurrentTunningDBChanged);
//			for(nCtr =0;nCtr < _lrrOptions.HistorianConnectionInfosObj.Count;nCtr ++)
//			{
//				if((_lrrOptions.HistorianConnectionInfosObj[nCtr].IsActive == true) && (_lrrOptions.HistorianConnectionInfosObj[nCtr].HistorainType == HistTypes.TUNING))
//				{
//					_sDBName = _lrrOptions.HistorianConnectionInfosObj[nCtr].DatabaseName;
//				}
//				
//			}
			try
			{
				Symcon.LightRidge.Options.DBOptions.DBInfo dbInfo =  _lrrOptions.TuningConnectionObj.GetActiveTuningDBInfo();
				if(dbInfo != null)
				{
					_sDBName = dbInfo.DatabaseName;
				}

				//Check for Recording Values DB/Set the Record Values UI
				if(CheckRecordingValuesDB())
				{
					//Bind the Run records combo Box
					BindRecordRunCombo();
					if(_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RecordValues)
					{
						SetRecordRunActivityUI(true);
						SetRecordRunDesc();
					}
					else
						SetRecordRunActivityUI(false);
				}
				else
					SetRecordRunActivityUI(false);
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(RunControlPanel),"RunControlPanelDialog:"+ex.Message  ,Logger.Level.Error);
			}
		}

		private void BindGridModes()
		{
			this.gridModes.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridModes.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridModes.BackColor = System.Drawing.SystemColors.Window;
			this.gridModes.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridModes.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridModes.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridModes.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridModes.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_MODES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridModes.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridModes.TableDescriptor.AllowNew = false;
			this.gridModes.TableDescriptor.AllowEdit = true;
			this.gridModes.TableDescriptor.AllowRemove = false;
			this.gridModes.DataSource = _lrrModes;
			this.gridModes.TableDescriptor.Columns.Clear();

            _unBoundModes = new GridUnBoundColumn();
            _unBoundModes.WireGrid(gridModes);
            LRRModes selectedMode = new LRRModes();
            ArrayList objSelectedMode = _runOptionsObj.RunControlSetsObj[_runOptionsObj.RunControlSetsObj.SelectedIndex].SelectedModes;
            foreach (object obj in objSelectedMode)
            {
                string modeId = obj.ToString();
                LRRMode mode = _lrrModes.GetModeByID(modeId);
                if (mode != null)
                {
                    selectedMode.Add(mode);
                }
            }

            foreach (LRRMode mode in selectedMode)
            {
                _unBoundModes.SetRecord(mode, true);
            }
			
			
			gridModes.TableDescriptor.Columns[0].Appearance.AnyHeaderCell.BackColor = Color.Blue;
			gridModes.TableDescriptor.Columns[0].HeaderText = LRRHeaderText.GetHeaderString("SID_IS_SELECTED"); 
			gridModes.TableDescriptor.Columns[0].Appearance.ColumnHeaderCell.TextColor = Color.White;

			GridColumnDescriptor gcd;
			GridTableCellStyleInfo gtcsi;
			GridTableCellStyleInfo gtcsi1;

//			gcd = new GridColumnDescriptor();
//			gcd.HeaderText = " ";
//			gcd.MappingName = "IsSelected";
//			gcd.AllowFilter = true;

//			gtcsi = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
//			gtcsi1 = gcd.Appearance.GetStyle(GridTableCellType.ColumnHeaderCell);
//			gtcsi1.BackColor = Color.Blue;
//
//			gtcsi.CellType = "CheckBox";
//			//gtcsi.BackColor = Color.White;
//			gtcsi.ReadOnly = false;
//			gcd.Width= 35;
//			this.gridModes.TableDescriptor.Columns.Add(gcd);

			gcd = new GridColumnDescriptor();
			gcd.HeaderText = LRRHeaderText.GetHeaderString("SID_MODENAME");
			gcd.MappingName = "ModeName";
			gcd.AllowFilter = true;
			gcd.Width = 193;

			gtcsi = gcd.Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			gtcsi1 = gcd.Appearance.GetStyle(GridTableCellType.ColumnHeaderCell);
			gtcsi1.BackColor = Color.Blue;
			gtcsi1.TextColor = Color.White;


			//gtcsi.BackColor = Color.LightGray;
			//gtcsi.BackColor = Color.Blue;
			gtcsi.ReadOnly = true;

			this.gridModes.TableDescriptor.Columns.Add(gcd);

			this.gridModes.TableControlCurrentCellChanged+=new GridTableControlEventHandler(gridModes_TableControlCurrentCellChanged);
            this.gridModes.TableControlResizingColumns += new GridTableControlResizingColumnsEventHandler(gridModes_TableControlResizingColumns);
		}

        void gridModes_TableControlResizingColumns(object sender, GridTableControlResizingColumnsEventArgs e)
        {
            e.Inner.Cancel = true;
        }

		private void BindRunControlPanelToRunControlSet(RunControlSet rcs)
		{
			//rcs.DataBindings.AddBinding(cmbDataSourceType,"Text",rcs,"DataSourceType");
			/*cmbDataSourceType.TextChanged+=new EventHandler(_TextChanged);			
			.DisplayMemberChanged+=new EventHandler(_DisplayMemberChanged);*/
		}
		
		/// <summary>
		/// Method checks for RecordingValues DB
		/// </summary>
		/// <returns></returns>
		private bool CheckRecordingValuesDB()
		{
			bool flag = false;
			//Check for Recording Values DB
			if(!_app.RecordingValuesManagerObj.ExistsRecordingDB())
			{
				_app.ActiveRunControlSet.RecordValues = false;
				//				this.chkRecordValues.Checked = false;
				this.chkRecordValues.Enabled = false;
				flag = false;
			}
			else
			{
				this.chkRecordValues.Enabled = true;
				flag = true;
			}
			return flag;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			ClearBindings(this);
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RunControlPanelDialog));
            this.panel1 = new System.Windows.Forms.Panel();
            this.chkSaveOfflinehistorian = new System.Windows.Forms.CheckBox();
            this.chkEnableBackfilling = new System.Windows.Forms.CheckBox();
            this.groupBox8 = new System.Windows.Forms.GroupBox();
            this.chkTimeIncrement = new System.Windows.Forms.RadioButton();
            this.label5 = new System.Windows.Forms.Label();
            this.cmbTandemOffsetUnits = new System.Windows.Forms.ComboBox();
            this.txtTandemOffset = new System.Windows.Forms.TextBox();
            this.chkTandemRuns = new System.Windows.Forms.CheckBox();
            this.cmbIncrementUnits = new System.Windows.Forms.ComboBox();
            this.txtTimeIncrment = new System.Windows.Forms.TextBox();
            this.rbSequentialDataSets = new System.Windows.Forms.RadioButton();
            this.rbRandomSets = new System.Windows.Forms.RadioButton();
            this.btnDelete = new System.Windows.Forms.Button();
            this.lblStatus = new System.Windows.Forms.Label();
            this.btnRun = new System.Windows.Forms.Button();
            this.btnSave = new System.Windows.Forms.Button();
            this.btnNew = new System.Windows.Forms.Button();
            this.btnInitializeModels = new System.Windows.Forms.Button();
            this.btnRunAdvance = new System.Windows.Forms.Button();
            this.btnRunEnteredWindow = new System.Windows.Forms.Button();
            this.chkAutoRun = new System.Windows.Forms.CheckBox();
            this.chkSaveDataSets = new System.Windows.Forms.CheckBox();
            this.groupBoxAutoRun = new System.Windows.Forms.GroupBox();
            this.dateTimePickerAutoRunEnd = new System.Windows.Forms.DateTimePicker();
            this.lblAutoRunEndDateTime = new System.Windows.Forms.Label();
            this.dateTimePickerAutoRunStart = new System.Windows.Forms.DateTimePicker();
            this.lblAutoRunStartTime = new System.Windows.Forms.Label();
            this.chkAutoRunBoundries = new System.Windows.Forms.CheckBox();
            this.cmbRunControlSet = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.lblDBName = new System.Windows.Forms.Label();
            this.lblTuningDB = new System.Windows.Forms.Label();
            this.cmbOfflineDataSource = new System.Windows.Forms.ComboBox();
            this.label3 = new System.Windows.Forms.Label();
            this.cmbDataSourceType = new System.Windows.Forms.ComboBox();
            this.label2 = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.gridModes = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.groupBox5 = new System.Windows.Forms.GroupBox();
            this.cmbDataWindowUnits = new System.Windows.Forms.ComboBox();
            this.txtDataWindowSize = new System.Windows.Forms.TextBox();
            this.label10 = new System.Windows.Forms.Label();
            this.dateTimeDataWindowEnd = new System.Windows.Forms.DateTimePicker();
            this.label7 = new System.Windows.Forms.Label();
            this.dateTimeDataWindowStart = new System.Windows.Forms.DateTimePicker();
            this.label6 = new System.Windows.Forms.Label();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.cmbLagUnits = new System.Windows.Forms.ComboBox();
            this.label4 = new System.Windows.Forms.Label();
            this.txtLag = new System.Windows.Forms.TextBox();
            this.rbForwardLooking = new System.Windows.Forms.RadioButton();
            this.rbHistorical = new System.Windows.Forms.RadioButton();
            this.rbCurrent = new System.Windows.Forms.RadioButton();
            this.groupBox6 = new System.Windows.Forms.GroupBox();
            this.dateTimeSeriesEnd = new System.Windows.Forms.DateTimePicker();
            this.label8 = new System.Windows.Forms.Label();
            this.dateTimeSeriesStart = new System.Windows.Forms.DateTimePicker();
            this.label9 = new System.Windows.Forms.Label();
            this.BtnRunNextStep = new System.Windows.Forms.Button();
            this.grpRecordRun = new System.Windows.Forms.GroupBox();
            this.txtDesc = new System.Windows.Forms.TextBox();
            this.lblDesc = new System.Windows.Forms.Label();
            this.cmbRecordRun = new System.Windows.Forms.ComboBox();
            this.lblRunName = new System.Windows.Forms.Label();
            this.chkRecordValues = new System.Windows.Forms.CheckBox();
            this.panel1.SuspendLayout();
            this.groupBox8.SuspendLayout();
            this.groupBoxAutoRun.SuspendLayout();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridModes)).BeginInit();
            this.groupBox5.SuspendLayout();
            this.groupBox3.SuspendLayout();
            this.groupBox6.SuspendLayout();
            this.grpRecordRun.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.chkSaveOfflinehistorian);
            this.panel1.Controls.Add(this.chkEnableBackfilling);
            this.panel1.Controls.Add(this.groupBox8);
            this.panel1.Controls.Add(this.btnDelete);
            this.panel1.Controls.Add(this.lblStatus);
            this.panel1.Controls.Add(this.btnRun);
            this.panel1.Controls.Add(this.btnSave);
            this.panel1.Controls.Add(this.btnNew);
            this.panel1.Controls.Add(this.btnInitializeModels);
            this.panel1.Controls.Add(this.btnRunAdvance);
            this.panel1.Controls.Add(this.btnRunEnteredWindow);
            this.panel1.Controls.Add(this.chkAutoRun);
            this.panel1.Controls.Add(this.chkSaveDataSets);
            this.panel1.Controls.Add(this.groupBoxAutoRun);
            this.panel1.Controls.Add(this.cmbRunControlSet);
            this.panel1.Controls.Add(this.label1);
            this.panel1.Controls.Add(this.groupBox1);
            this.panel1.Controls.Add(this.groupBox2);
            this.panel1.Controls.Add(this.groupBox5);
            this.panel1.Controls.Add(this.groupBox3);
            this.panel1.Controls.Add(this.groupBox6);
            this.panel1.Controls.Add(this.BtnRunNextStep);
            this.panel1.Controls.Add(this.grpRecordRun);
            this.panel1.Location = new System.Drawing.Point(8, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(568, 585);
            this.panel1.TabIndex = 0;
            // 
            // chkSaveOfflinehistorian
            // 
            this.chkSaveOfflinehistorian.ForeColor = System.Drawing.Color.Brown;
            this.chkSaveOfflinehistorian.Location = new System.Drawing.Point(8, 505);
            this.chkSaveOfflinehistorian.Name = "chkSaveOfflinehistorian";
            this.chkSaveOfflinehistorian.Size = new System.Drawing.Size(408, 19);
            this.chkSaveOfflinehistorian.TabIndex = 53;
            this.chkSaveOfflinehistorian.Tag = "SID_SAVE_DATA_AFTER_EXEC_MODEL";
            this.chkSaveOfflinehistorian.Text = "Save data in PE-Advisor Online Plant Database post models execution...";
            this.chkSaveOfflinehistorian.CheckedChanged += new System.EventHandler(this.chkSaveOfflinehistorian_CheckedChanged);
            // 
            // chkEnableBackfilling
            // 
            this.chkEnableBackfilling.ForeColor = System.Drawing.Color.Brown;
            this.chkEnableBackfilling.Location = new System.Drawing.Point(424, 492);
            this.chkEnableBackfilling.Name = "chkEnableBackfilling";
            this.chkEnableBackfilling.Size = new System.Drawing.Size(128, 24);
            this.chkEnableBackfilling.TabIndex = 51;
            this.chkEnableBackfilling.Tag = "SID_BACKFILL_QUESTION";
            // 
            // groupBox8
            // 
            this.groupBox8.Controls.Add(this.chkTimeIncrement);
            this.groupBox8.Controls.Add(this.label5);
            this.groupBox8.Controls.Add(this.cmbTandemOffsetUnits);
            this.groupBox8.Controls.Add(this.txtTandemOffset);
            this.groupBox8.Controls.Add(this.chkTandemRuns);
            this.groupBox8.Controls.Add(this.cmbIncrementUnits);
            this.groupBox8.Controls.Add(this.txtTimeIncrment);
            this.groupBox8.Controls.Add(this.rbSequentialDataSets);
            this.groupBox8.Controls.Add(this.rbRandomSets);
            this.groupBox8.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.groupBox8.Location = new System.Drawing.Point(296, 38);
            this.groupBox8.Name = "groupBox8";
            this.groupBox8.Size = new System.Drawing.Size(264, 117);
            this.groupBox8.TabIndex = 44;
            this.groupBox8.TabStop = false;
            // 
            // chkTimeIncrement
            // 
            this.chkTimeIncrement.Location = new System.Drawing.Point(8, 12);
            this.chkTimeIncrement.Name = "chkTimeIncrement";
            this.chkTimeIncrement.Size = new System.Drawing.Size(104, 24);
            this.chkTimeIncrement.TabIndex = 33;
            this.chkTimeIncrement.Tag = "SID_TIEM_INCRE";
            this.chkTimeIncrement.CheckedChanged += new System.EventHandler(this.chkTimeIncrement_CheckStateChanged);
            // 
            // label5
            // 
            this.label5.Enabled = false;
            this.label5.Location = new System.Drawing.Point(112, 95);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(40, 16);
            this.label5.TabIndex = 29;
            this.label5.Tag = "SID_OFFSETS";
            // 
            // cmbTandemOffsetUnits
            // 
            this.cmbTandemOffsetUnits.Enabled = false;
            this.cmbTandemOffsetUnits.Items.AddRange(new object[] {
            "Hr",
            "Min",
            "Sec"});
            this.cmbTandemOffsetUnits.Location = new System.Drawing.Point(200, 88);
            this.cmbTandemOffsetUnits.Name = "cmbTandemOffsetUnits";
            this.cmbTandemOffsetUnits.Size = new System.Drawing.Size(56, 21);
            this.cmbTandemOffsetUnits.TabIndex = 28;
            // 
            // txtTandemOffset
            // 
            this.txtTandemOffset.Enabled = false;
            this.txtTandemOffset.Location = new System.Drawing.Point(160, 88);
            this.txtTandemOffset.Name = "txtTandemOffset";
            this.txtTandemOffset.Size = new System.Drawing.Size(32, 20);
            this.txtTandemOffset.TabIndex = 27;
            // 
            // chkTandemRuns
            // 
            this.chkTandemRuns.Enabled = false;
            this.chkTandemRuns.Location = new System.Drawing.Point(7, 88);
            this.chkTandemRuns.Name = "chkTandemRuns";
            this.chkTandemRuns.Size = new System.Drawing.Size(96, 24);
            this.chkTandemRuns.TabIndex = 26;
            this.chkTandemRuns.Tag = "SID_TANDEM_RUNS";
            // 
            // cmbIncrementUnits
            // 
            this.cmbIncrementUnits.Enabled = false;
            this.cmbIncrementUnits.Items.AddRange(new object[] {
            "Hr",
            "Min",
            "Sec",
            "Day"});
            this.cmbIncrementUnits.Location = new System.Drawing.Point(200, 11);
            this.cmbIncrementUnits.Name = "cmbIncrementUnits";
            this.cmbIncrementUnits.Size = new System.Drawing.Size(56, 21);
            this.cmbIncrementUnits.TabIndex = 20;
            // 
            // txtTimeIncrment
            // 
            this.txtTimeIncrment.Enabled = false;
            this.txtTimeIncrment.Location = new System.Drawing.Point(160, 12);
            this.txtTimeIncrment.Name = "txtTimeIncrment";
            this.txtTimeIncrment.Size = new System.Drawing.Size(32, 20);
            this.txtTimeIncrment.TabIndex = 19;
            // 
            // rbSequentialDataSets
            // 
            this.rbSequentialDataSets.Location = new System.Drawing.Point(8, 40);
            this.rbSequentialDataSets.Name = "rbSequentialDataSets";
            this.rbSequentialDataSets.Size = new System.Drawing.Size(136, 16);
            this.rbSequentialDataSets.TabIndex = 31;
            this.rbSequentialDataSets.Tag = "SID_SEQU_DATASETS";
            this.rbSequentialDataSets.CheckedChanged += new System.EventHandler(this.rbSequentialDataSets_CheckedChanged);
            // 
            // rbRandomSets
            // 
            this.rbRandomSets.Location = new System.Drawing.Point(8, 64);
            this.rbRandomSets.Name = "rbRandomSets";
            this.rbRandomSets.Size = new System.Drawing.Size(128, 16);
            this.rbRandomSets.TabIndex = 32;
            this.rbRandomSets.Tag = "SID_RAND_DATASETS";
            // 
            // btnDelete
            // 
            this.btnDelete.Location = new System.Drawing.Point(480, 14);
            this.btnDelete.Name = "btnDelete";
            this.btnDelete.Size = new System.Drawing.Size(70, 24);
            this.btnDelete.TabIndex = 45;
            this.btnDelete.Tag = "SID_DEL";
            this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
            // 
            // lblStatus
            // 
            this.lblStatus.Location = new System.Drawing.Point(320, 488);
            this.lblStatus.Name = "lblStatus";
            this.lblStatus.Size = new System.Drawing.Size(240, 16);
            this.lblStatus.TabIndex = 43;
            this.lblStatus.Visible = false;
            // 
            // btnRun
            // 
            this.btnRun.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnRun.ImageIndex = 57;
            this.btnRun.Location = new System.Drawing.Point(480, 446);
            this.btnRun.Name = "btnRun";
            this.btnRun.Size = new System.Drawing.Size(80, 32);
            this.btnRun.TabIndex = 42;
            this.btnRun.Tag = "SID_RUN";
            this.btnRun.Click += new System.EventHandler(this.btnRun_Click);
            // 
            // btnSave
            // 
            this.btnSave.Enabled = false;
            this.btnSave.Location = new System.Drawing.Point(400, 14);
            this.btnSave.Name = "btnSave";
            this.btnSave.Size = new System.Drawing.Size(70, 24);
            this.btnSave.TabIndex = 41;
            this.btnSave.Tag = "SID_SAVE";
            this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
            // 
            // btnNew
            // 
            this.btnNew.Location = new System.Drawing.Point(320, 14);
            this.btnNew.Name = "btnNew";
            this.btnNew.Size = new System.Drawing.Size(70, 24);
            this.btnNew.TabIndex = 40;
            this.btnNew.Tag = "SID_NEW";
            this.btnNew.Click += new System.EventHandler(this.btnNew_Click);
            // 
            // btnInitializeModels
            // 
            this.btnInitializeModels.Enabled = false;
            this.btnInitializeModels.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnInitializeModels.ImageIndex = 81;
            this.btnInitializeModels.Location = new System.Drawing.Point(0, 446);
            this.btnInitializeModels.Name = "btnInitializeModels";
            this.btnInitializeModels.Size = new System.Drawing.Size(88, 32);
            this.btnInitializeModels.TabIndex = 39;
            this.btnInitializeModels.Tag = "SID_EXECUTE_MODEL_TUNING";
            this.btnInitializeModels.Click += new System.EventHandler(this.btnInitializeModels_Click);
            // 
            // btnRunAdvance
            // 
            this.btnRunAdvance.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnRunAdvance.ImageIndex = 67;
            this.btnRunAdvance.Location = new System.Drawing.Point(384, 446);
            this.btnRunAdvance.Name = "btnRunAdvance";
            this.btnRunAdvance.Size = new System.Drawing.Size(88, 32);
            this.btnRunAdvance.TabIndex = 38;
            this.btnRunAdvance.Tag = "SUD_RUN_ADVANCE";
            this.btnRunAdvance.Click += new System.EventHandler(this.btnRunAdvance_Click);
            // 
            // btnRunEnteredWindow
            // 
            this.btnRunEnteredWindow.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnRunEnteredWindow.ImageIndex = 66;
            this.btnRunEnteredWindow.Location = new System.Drawing.Point(288, 446);
            this.btnRunEnteredWindow.Name = "btnRunEnteredWindow";
            this.btnRunEnteredWindow.Size = new System.Drawing.Size(88, 32);
            this.btnRunEnteredWindow.TabIndex = 37;
            this.btnRunEnteredWindow.Tag = "SID_RUN_ENTEREDWND";
            this.btnRunEnteredWindow.Click += new System.EventHandler(this.btnRunEnteredWindow_Click);
            // 
            // chkAutoRun
            // 
            this.chkAutoRun.Appearance = System.Windows.Forms.Appearance.Button;
            this.chkAutoRun.BackColor = System.Drawing.SystemColors.Control;
            this.chkAutoRun.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.chkAutoRun.ImageIndex = 80;
            this.chkAutoRun.Location = new System.Drawing.Point(96, 446);
            this.chkAutoRun.Name = "chkAutoRun";
            this.chkAutoRun.Size = new System.Drawing.Size(88, 32);
            this.chkAutoRun.TabIndex = 48;
            this.chkAutoRun.Tag = "";
            this.chkAutoRun.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            this.chkAutoRun.UseVisualStyleBackColor = false;
            this.chkAutoRun.CheckStateChanged += new System.EventHandler(this.chkAutoRun_CheckStateChanged);
            this.chkAutoRun.CheckedChanged += new System.EventHandler(this.chkAutoRun_CheckedChanged);
            // 
            // chkSaveDataSets
            // 
            this.chkSaveDataSets.ForeColor = System.Drawing.Color.Brown;
            this.chkSaveDataSets.Location = new System.Drawing.Point(8, 482);
            this.chkSaveDataSets.Name = "chkSaveDataSets";
            this.chkSaveDataSets.Size = new System.Drawing.Size(408, 16);
            this.chkSaveDataSets.TabIndex = 47;
            this.chkSaveDataSets.Tag = "SID_SAVE_DATA_WITHOUT_EXEC_MODEL";
            this.chkSaveDataSets.Text = "Save datasets in offline without executing models...";
            this.chkSaveDataSets.CheckedChanged += new System.EventHandler(this.chkSaveDataSets_CheckedChanged);
            // 
            // groupBoxAutoRun
            // 
            this.groupBoxAutoRun.Controls.Add(this.dateTimePickerAutoRunEnd);
            this.groupBoxAutoRun.Controls.Add(this.lblAutoRunEndDateTime);
            this.groupBoxAutoRun.Controls.Add(this.dateTimePickerAutoRunStart);
            this.groupBoxAutoRun.Controls.Add(this.lblAutoRunStartTime);
            this.groupBoxAutoRun.Controls.Add(this.chkAutoRunBoundries);
            this.groupBoxAutoRun.Location = new System.Drawing.Point(295, 351);
            this.groupBoxAutoRun.Name = "groupBoxAutoRun";
            this.groupBoxAutoRun.Size = new System.Drawing.Size(265, 88);
            this.groupBoxAutoRun.TabIndex = 46;
            this.groupBoxAutoRun.TabStop = false;
            // 
            // dateTimePickerAutoRunEnd
            // 
            this.dateTimePickerAutoRunEnd.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dateTimePickerAutoRunEnd.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimePickerAutoRunEnd.Location = new System.Drawing.Point(96, 52);
            this.dateTimePickerAutoRunEnd.Name = "dateTimePickerAutoRunEnd";
            this.dateTimePickerAutoRunEnd.Size = new System.Drawing.Size(152, 20);
            this.dateTimePickerAutoRunEnd.TabIndex = 7;
            this.dateTimePickerAutoRunEnd.ValueChanged += new System.EventHandler(this.dateTimePickerAutoRunEnd_ValueChanged);
            this.dateTimePickerAutoRunEnd.DropDown += new System.EventHandler(this.dateTimePickerAutoRunEnd_DropDown);
            this.dateTimePickerAutoRunEnd.CloseUp += new System.EventHandler(this.dateTimePickerAutoRunEnd_CloseUp);
            // 
            // lblAutoRunEndDateTime
            // 
            this.lblAutoRunEndDateTime.Location = new System.Drawing.Point(10, 58);
            this.lblAutoRunEndDateTime.Name = "lblAutoRunEndDateTime";
            this.lblAutoRunEndDateTime.Size = new System.Drawing.Size(135, 16);
            this.lblAutoRunEndDateTime.TabIndex = 6;
            this.lblAutoRunEndDateTime.Tag = "SID_END_DATETIME";
            // 
            // dateTimePickerAutoRunStart
            // 
            this.dateTimePickerAutoRunStart.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dateTimePickerAutoRunStart.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimePickerAutoRunStart.Location = new System.Drawing.Point(96, 24);
            this.dateTimePickerAutoRunStart.Name = "dateTimePickerAutoRunStart";
            this.dateTimePickerAutoRunStart.Size = new System.Drawing.Size(152, 20);
            this.dateTimePickerAutoRunStart.TabIndex = 5;
            this.dateTimePickerAutoRunStart.ValueChanged += new System.EventHandler(this.dateTimePickerAutoRunStart_ValueChanged);
            this.dateTimePickerAutoRunStart.DropDown += new System.EventHandler(this.dateTimePickerAutoRunStart_DropDown);
            this.dateTimePickerAutoRunStart.CloseUp += new System.EventHandler(this.dateTimePickerAutoRunStart_CloseUp);
            // 
            // lblAutoRunStartTime
            // 
            this.lblAutoRunStartTime.Location = new System.Drawing.Point(9, 28);
            this.lblAutoRunStartTime.Name = "lblAutoRunStartTime";
            this.lblAutoRunStartTime.Size = new System.Drawing.Size(136, 16);
            this.lblAutoRunStartTime.TabIndex = 4;
            this.lblAutoRunStartTime.Tag = "SID_START_DATETIME";
            // 
            // chkAutoRunBoundries
            // 
            this.chkAutoRunBoundries.BackColor = System.Drawing.SystemColors.Control;
            this.chkAutoRunBoundries.Location = new System.Drawing.Point(6, 1);
            this.chkAutoRunBoundries.Name = "chkAutoRunBoundries";
            this.chkAutoRunBoundries.Size = new System.Drawing.Size(178, 16);
            this.chkAutoRunBoundries.TabIndex = 25;
            this.chkAutoRunBoundries.Tag = "SID_CURRENT_BOUNDARIES";
            this.chkAutoRunBoundries.UseVisualStyleBackColor = false;
            this.chkAutoRunBoundries.CheckedChanged += new System.EventHandler(this.chkAutoRunBoundries_CheckedChanged);
            // 
            // cmbRunControlSet
            // 
            this.cmbRunControlSet.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbRunControlSet.Location = new System.Drawing.Point(120, 11);
            this.cmbRunControlSet.Name = "cmbRunControlSet";
            this.cmbRunControlSet.Size = new System.Drawing.Size(160, 21);
            this.cmbRunControlSet.TabIndex = 31;
            this.cmbRunControlSet.SelectedIndexChanged += new System.EventHandler(this.cmbRunControlSet_SelectedIndexChanged);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(1, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(111, 16);
            this.label1.TabIndex = 30;
            this.label1.Tag = "SID_RUNCONTROL_SETS";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.lblDBName);
            this.groupBox1.Controls.Add(this.lblTuningDB);
            this.groupBox1.Controls.Add(this.cmbOfflineDataSource);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.cmbDataSourceType);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Location = new System.Drawing.Point(0, 38);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(288, 80);
            this.groupBox1.TabIndex = 29;
            this.groupBox1.TabStop = false;
            this.groupBox1.Tag = "SID_DATA_SOURCE";
            // 
            // lblDBName
            // 
            this.lblDBName.Location = new System.Drawing.Point(8, 56);
            this.lblDBName.Name = "lblDBName";
            this.lblDBName.Size = new System.Drawing.Size(112, 16);
            this.lblDBName.TabIndex = 4;
            this.lblDBName.Tag = "SID_SELECTED_TUNINGDB";
            this.lblDBName.Visible = false;
            // 
            // lblTuningDB
            // 
            this.lblTuningDB.Location = new System.Drawing.Point(116, 45);
            this.lblTuningDB.Name = "lblTuningDB";
            this.lblTuningDB.Size = new System.Drawing.Size(150, 24);
            this.lblTuningDB.TabIndex = 5;
            this.lblTuningDB.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
            this.lblTuningDB.Visible = false;
            // 
            // cmbOfflineDataSource
            // 
            this.cmbOfflineDataSource.Location = new System.Drawing.Point(160, 44);
            this.cmbOfflineDataSource.Name = "cmbOfflineDataSource";
            this.cmbOfflineDataSource.Size = new System.Drawing.Size(112, 21);
            this.cmbOfflineDataSource.TabIndex = 3;
            this.cmbOfflineDataSource.Visible = false;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 56);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(144, 16);
            this.label3.TabIndex = 2;
            this.label3.Tag = "SID_SELE_OFFLINE_DB";
            this.label3.Visible = false;
            // 
            // cmbDataSourceType
            // 
            this.cmbDataSourceType.Location = new System.Drawing.Point(120, 16);
            this.cmbDataSourceType.Name = "cmbDataSourceType";
            this.cmbDataSourceType.Size = new System.Drawing.Size(160, 21);
            this.cmbDataSourceType.TabIndex = 1;
            this.cmbDataSourceType.SelectedIndexChanged += new System.EventHandler(this.cmbDataSourceType_SelectedIndexChanged);
            this.cmbDataSourceType.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cmbDataSourceType_KeyPress);
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 19);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(136, 13);
            this.label2.TabIndex = 0;
            this.label2.Tag = "SID_DATA_SOURCE_TYPE";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.gridModes);
            this.groupBox2.Location = new System.Drawing.Point(0, 223);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(288, 216);
            this.groupBox2.TabIndex = 32;
            this.groupBox2.TabStop = false;
            this.groupBox2.Tag = "SID_SELECT_MOD_RUN";
            // 
            // gridModes
            // 
            this.gridModes.Appearance.ColumnHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(128)))), ((int)(((byte)(255))))));
            this.gridModes.BackColor = System.Drawing.SystemColors.Window;
            this.gridModes.Location = new System.Drawing.Point(8, 19);
            this.gridModes.Name = "gridModes";
            this.gridModes.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridModes.NestedTableGroupOptions.ShowCaption = false;
            this.gridModes.NestedTableGroupOptions.ShowColumnHeaders = true;
            this.gridModes.Size = new System.Drawing.Size(272, 189);
            this.gridModes.TabIndex = 0;
            this.gridModes.TableDescriptor.Appearance.ColumnHeaderCell.AutoSize = true;
            this.gridModes.TableOptions.AllowDragColumns = false;
            this.gridModes.TableOptions.AllowSortColumns = false;
            this.gridModes.TableOptions.ShowRowHeader = false;
            this.gridModes.Text = "gridGroupingControl1";
            this.gridModes.ThemesEnabled = false;
            this.gridModes.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridModes.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridModes.TopLevelGroupOptions.ShowCaption = false;
            this.gridModes.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridModes.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridModes.TopLevelGroupOptions.ShowSummaries = false;
            this.gridModes.VersionInfo = "3.301.0.0";
            // 
            // groupBox5
            // 
            this.groupBox5.Controls.Add(this.cmbDataWindowUnits);
            this.groupBox5.Controls.Add(this.txtDataWindowSize);
            this.groupBox5.Controls.Add(this.label10);
            this.groupBox5.Controls.Add(this.dateTimeDataWindowEnd);
            this.groupBox5.Controls.Add(this.label7);
            this.groupBox5.Controls.Add(this.dateTimeDataWindowStart);
            this.groupBox5.Controls.Add(this.label6);
            this.groupBox5.Location = new System.Drawing.Point(296, 158);
            this.groupBox5.Name = "groupBox5";
            this.groupBox5.Size = new System.Drawing.Size(264, 100);
            this.groupBox5.TabIndex = 34;
            this.groupBox5.TabStop = false;
            this.groupBox5.Tag = "SID_DATAWND_FOR_RUN";
            // 
            // cmbDataWindowUnits
            // 
            this.cmbDataWindowUnits.Items.AddRange(new object[] {
            "Hr",
            "Min",
            "Sec"});
            this.cmbDataWindowUnits.Location = new System.Drawing.Point(134, 45);
            this.cmbDataWindowUnits.Name = "cmbDataWindowUnits";
            this.cmbDataWindowUnits.Size = new System.Drawing.Size(56, 21);
            this.cmbDataWindowUnits.TabIndex = 10;
            this.cmbDataWindowUnits.SelectedIndexChanged += new System.EventHandler(this.cmbDataWindowUnits_SelectedIndexChanged);
            // 
            // txtDataWindowSize
            // 
            this.txtDataWindowSize.Location = new System.Drawing.Point(96, 46);
            this.txtDataWindowSize.Name = "txtDataWindowSize";
            this.txtDataWindowSize.Size = new System.Drawing.Size(32, 20);
            this.txtDataWindowSize.TabIndex = 9;
            this.txtDataWindowSize.TextChanged += new System.EventHandler(this.txtDataWindowSize_TextChanged);
            this.txtDataWindowSize.Validating += new System.ComponentModel.CancelEventHandler(this.txtDataWindowSize_Validating);
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(8, 48);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(88, 16);
            this.label10.TabIndex = 4;
            this.label10.Tag = "SID_DATAWND";
            // 
            // dateTimeDataWindowEnd
            // 
            this.dateTimeDataWindowEnd.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dateTimeDataWindowEnd.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimeDataWindowEnd.Location = new System.Drawing.Point(96, 72);
            this.dateTimeDataWindowEnd.Name = "dateTimeDataWindowEnd";
            this.dateTimeDataWindowEnd.Size = new System.Drawing.Size(160, 20);
            this.dateTimeDataWindowEnd.TabIndex = 3;
            this.dateTimeDataWindowEnd.ValueChanged += new System.EventHandler(this.dateTimeDataWindowEnd_ValueChanged);
            this.dateTimeDataWindowEnd.DropDown += new System.EventHandler(this.dateTimeDataWindowEnd_DropDown);
            this.dateTimeDataWindowEnd.CloseUp += new System.EventHandler(this.dateTimeDataWindowEnd_CloseUp);
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(8, 75);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(88, 16);
            this.label7.TabIndex = 2;
            this.label7.Tag = "SID_END_DATETIME";
            // 
            // dateTimeDataWindowStart
            // 
            this.dateTimeDataWindowStart.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dateTimeDataWindowStart.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimeDataWindowStart.Location = new System.Drawing.Point(96, 20);
            this.dateTimeDataWindowStart.Name = "dateTimeDataWindowStart";
            this.dateTimeDataWindowStart.Size = new System.Drawing.Size(160, 20);
            this.dateTimeDataWindowStart.TabIndex = 1;
            this.dateTimeDataWindowStart.ValueChanged += new System.EventHandler(this.dateTimeWindow_ValueChanged);
            this.dateTimeDataWindowStart.Validating += new System.ComponentModel.CancelEventHandler(this.dateTimeDataWindowStart_Validating);
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(8, 24);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(88, 16);
            this.label6.TabIndex = 0;
            this.label6.Tag = "SID_START_DATETIME";
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.cmbLagUnits);
            this.groupBox3.Controls.Add(this.label4);
            this.groupBox3.Controls.Add(this.txtLag);
            this.groupBox3.Controls.Add(this.rbForwardLooking);
            this.groupBox3.Controls.Add(this.rbHistorical);
            this.groupBox3.Controls.Add(this.rbCurrent);
            this.groupBox3.Location = new System.Drawing.Point(0, 123);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(288, 96);
            this.groupBox3.TabIndex = 33;
            this.groupBox3.TabStop = false;
            this.groupBox3.Tag = "SID_RUN_SETTINGS";
            // 
            // cmbLagUnits
            // 
            this.cmbLagUnits.Items.AddRange(new object[] {
            "Min",
            "Sec",
            "Hrs",
            "Days"});
            this.cmbLagUnits.Location = new System.Drawing.Point(225, 16);
            this.cmbLagUnits.Name = "cmbLagUnits";
            this.cmbLagUnits.Size = new System.Drawing.Size(56, 21);
            this.cmbLagUnits.TabIndex = 5;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(160, 20);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(29, 16);
            this.label4.TabIndex = 4;
            this.label4.Tag = "SID_LAG";
            // 
            // txtLag
            // 
            this.txtLag.Location = new System.Drawing.Point(192, 16);
            this.txtLag.Name = "txtLag";
            this.txtLag.Size = new System.Drawing.Size(32, 20);
            this.txtLag.TabIndex = 3;
            // 
            // rbForwardLooking
            // 
            this.rbForwardLooking.Enabled = false;
            this.rbForwardLooking.Location = new System.Drawing.Point(8, 64);
            this.rbForwardLooking.Name = "rbForwardLooking";
            this.rbForwardLooking.Size = new System.Drawing.Size(112, 24);
            this.rbForwardLooking.TabIndex = 2;
            this.rbForwardLooking.Tag = "SID_FORWARD_LOOKING";
            // 
            // rbHistorical
            // 
            this.rbHistorical.Location = new System.Drawing.Point(8, 40);
            this.rbHistorical.Name = "rbHistorical";
            this.rbHistorical.Size = new System.Drawing.Size(104, 24);
            this.rbHistorical.TabIndex = 1;
            this.rbHistorical.Tag = "SID_HISTORICAL";
            this.rbHistorical.CheckedChanged += new System.EventHandler(this.rbHistorical_CheckedChanged);
            // 
            // rbCurrent
            // 
            this.rbCurrent.AutoCheck = false;
            this.rbCurrent.Location = new System.Drawing.Point(8, 16);
            this.rbCurrent.Name = "rbCurrent";
            this.rbCurrent.Size = new System.Drawing.Size(72, 24);
            this.rbCurrent.TabIndex = 0;
            this.rbCurrent.Tag = "SID_CURRENT";
            this.rbCurrent.CheckedChanged += new System.EventHandler(this.rbCurrent_CheckedChanged);
            // 
            // groupBox6
            // 
            this.groupBox6.Controls.Add(this.dateTimeSeriesEnd);
            this.groupBox6.Controls.Add(this.label8);
            this.groupBox6.Controls.Add(this.dateTimeSeriesStart);
            this.groupBox6.Controls.Add(this.label9);
            this.groupBox6.Location = new System.Drawing.Point(296, 261);
            this.groupBox6.Name = "groupBox6";
            this.groupBox6.Size = new System.Drawing.Size(264, 88);
            this.groupBox6.TabIndex = 35;
            this.groupBox6.TabStop = false;
            this.groupBox6.Tag = "SID_HISTORICAL_BOUNDARIES";
            // 
            // dateTimeSeriesEnd
            // 
            this.dateTimeSeriesEnd.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dateTimeSeriesEnd.Enabled = false;
            this.dateTimeSeriesEnd.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimeSeriesEnd.Location = new System.Drawing.Point(96, 47);
            this.dateTimeSeriesEnd.Name = "dateTimeSeriesEnd";
            this.dateTimeSeriesEnd.Size = new System.Drawing.Size(160, 20);
            this.dateTimeSeriesEnd.TabIndex = 7;
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(9, 53);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(88, 16);
            this.label8.TabIndex = 6;
            this.label8.Tag = "SID_END_DATETIME";
            // 
            // dateTimeSeriesStart
            // 
            this.dateTimeSeriesStart.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dateTimeSeriesStart.Enabled = false;
            this.dateTimeSeriesStart.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimeSeriesStart.Location = new System.Drawing.Point(96, 19);
            this.dateTimeSeriesStart.Name = "dateTimeSeriesStart";
            this.dateTimeSeriesStart.Size = new System.Drawing.Size(160, 20);
            this.dateTimeSeriesStart.TabIndex = 5;
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(8, 23);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(88, 16);
            this.label9.TabIndex = 4;
            this.label9.Tag = "SID_START_DATETIME";
            // 
            // BtnRunNextStep
            // 
            this.BtnRunNextStep.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.BtnRunNextStep.ImageIndex = 65;
            this.BtnRunNextStep.Location = new System.Drawing.Point(192, 446);
            this.BtnRunNextStep.Name = "BtnRunNextStep";
            this.BtnRunNextStep.Size = new System.Drawing.Size(88, 32);
            this.BtnRunNextStep.TabIndex = 36;
            this.BtnRunNextStep.Tag = "SID_RUN_NEXTSTEP";
            this.BtnRunNextStep.Click += new System.EventHandler(this.BtnRunNextStep_Click);
            // 
            // grpRecordRun
            // 
            this.grpRecordRun.Controls.Add(this.txtDesc);
            this.grpRecordRun.Controls.Add(this.lblDesc);
            this.grpRecordRun.Controls.Add(this.cmbRecordRun);
            this.grpRecordRun.Controls.Add(this.lblRunName);
            this.grpRecordRun.Controls.Add(this.chkRecordValues);
            this.grpRecordRun.ForeColor = System.Drawing.Color.Brown;
            this.grpRecordRun.Location = new System.Drawing.Point(8, 525);
            this.grpRecordRun.Name = "grpRecordRun";
            this.grpRecordRun.Size = new System.Drawing.Size(544, 56);
            this.grpRecordRun.TabIndex = 50;
            this.grpRecordRun.TabStop = false;
            this.grpRecordRun.Tag = "SID_RECORD_RUN_DETL";
            // 
            // txtDesc
            // 
            this.txtDesc.Location = new System.Drawing.Point(376, 23);
            this.txtDesc.Name = "txtDesc";
            this.txtDesc.Size = new System.Drawing.Size(160, 20);
            this.txtDesc.TabIndex = 53;
            this.txtDesc.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.txtDesc_KeyPress);
            // 
            // lblDesc
            // 
            this.lblDesc.ForeColor = System.Drawing.Color.Brown;
            this.lblDesc.Location = new System.Drawing.Point(304, 24);
            this.lblDesc.Name = "lblDesc";
            this.lblDesc.Size = new System.Drawing.Size(72, 23);
            this.lblDesc.TabIndex = 52;
            this.lblDesc.Tag = "SID_DESCRIPTION";
            // 
            // cmbRecordRun
            // 
            this.cmbRecordRun.Location = new System.Drawing.Point(208, 23);
            this.cmbRecordRun.Name = "cmbRecordRun";
            this.cmbRecordRun.Size = new System.Drawing.Size(88, 21);
            this.cmbRecordRun.TabIndex = 51;
            this.cmbRecordRun.SelectedIndexChanged += new System.EventHandler(this.cmbRecordRun_SelectedIndexChanged);
            this.cmbRecordRun.TextChanged += new System.EventHandler(this.cmbRecordRun_TextChanged);
            // 
            // lblRunName
            // 
            this.lblRunName.ForeColor = System.Drawing.Color.Brown;
            this.lblRunName.Location = new System.Drawing.Point(150, 24);
            this.lblRunName.Name = "lblRunName";
            this.lblRunName.Size = new System.Drawing.Size(56, 16);
            this.lblRunName.TabIndex = 50;
            this.lblRunName.Tag = "SID_NAME";
            // 
            // chkRecordValues
            // 
            this.chkRecordValues.ForeColor = System.Drawing.Color.Brown;
            this.chkRecordValues.Location = new System.Drawing.Point(8, 24);
            this.chkRecordValues.Name = "chkRecordValues";
            this.chkRecordValues.Size = new System.Drawing.Size(128, 16);
            this.chkRecordValues.TabIndex = 49;
            this.chkRecordValues.Tag = "SID_RECORD_RUN";
            this.chkRecordValues.CheckedChanged += new System.EventHandler(this.chkRecordValues_CheckedChanged);
            // 
            // RunControlPanelDialog
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(578, 590);
            this.Controls.Add(this.panel1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "RunControlPanelDialog";
            this.ShowInTaskbar = false;
            this.Tag = "310";
            this.Load += new System.EventHandler(this.RunControlPanelDialog_Load);
            this.Activated += new System.EventHandler(this.RunControlPanelDialog_Activated);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.RunControlPanelDialog_Closing);
            this.panel1.ResumeLayout(false);
            this.groupBox8.ResumeLayout(false);
            this.groupBox8.PerformLayout();
            this.groupBoxAutoRun.ResumeLayout(false);
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridModes)).EndInit();
            this.groupBox5.ResumeLayout(false);
            this.groupBox5.PerformLayout();
            this.groupBox3.ResumeLayout(false);
            this.groupBox3.PerformLayout();
            this.groupBox6.ResumeLayout(false);
            this.grpRecordRun.ResumeLayout(false);
            this.grpRecordRun.PerformLayout();
            this.ResumeLayout(false);

		}

        void dateTimePickerAutoRunStart_CloseUp(object sender, EventArgs e)
        {
            _isDateTimePickerAutoRunStartTime = true;
            dateTimePickerAutoRunStart_ValueChanged(dateTimePickerAutoRunStart, new EventArgs()); 
        }

        void dateTimePickerAutoRunStart_DropDown(object sender, EventArgs e)
        {
            _isDateTimePickerAutoRunStartTime = false;

        }

        void dateTimePickerAutoRunStart_ValueChanged(object sender, EventArgs e)
        {
            if (_isDateTimePickerAutoRunStartTime)
            {
                TimeSpan dataWindow = new TimeSpan(0);
                dataWindow = dateTimePickerAutoRunEnd.Value.Subtract(dateTimePickerAutoRunStart.Value);
                if (dataWindow.TotalHours < 0.0 || dataWindow.TotalSeconds < 0.0 || dataWindow.TotalMinutes < 0.0)
                {
                    LRRMessagBox.ShowMessage(_app.MainFrame, "SID_INVALID_ETIME", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Warning); // Message changed by Sandeep as it was wrong
                    RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    dateTimePickerAutoRunStart.Value = rcs.AutoRunsObj.StartTime;
                    return;
                }
            }
        }

        void dateTimePickerAutoRunEnd_DropDown(object sender, EventArgs e)
        {
            _isDateTimePickerAutoRunEndTime = false;   
        }

        void dateTimePickerAutoRunEnd_CloseUp(object sender, EventArgs e)
        {
            _isDateTimePickerAutoRunEndTime = true;
            dateTimePickerAutoRunEnd_ValueChanged(dateTimePickerAutoRunEnd, new EventArgs());
        }

        void dateTimePickerAutoRunEnd_ValueChanged(object sender, EventArgs e)
        {
            if (_isDateTimePickerAutoRunEndTime)
            {
                TimeSpan dataWindow = new TimeSpan(0);
                dataWindow = dateTimePickerAutoRunEnd.Value.Subtract(dateTimePickerAutoRunStart.Value);
                if (dataWindow.TotalHours < 0.0 || dataWindow.TotalSeconds < 0.0 || dataWindow.TotalMinutes < 0.0)
                {
                    LRRMessagBox.ShowMessage(_app.MainFrame, "SID_INVALID_ETIME", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Warning); // Message changed by Sandeep as it was wrong
                    RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    dateTimePickerAutoRunEnd.Value = rcs.AutoRunsObj.EndTime;
                    return;
                }
            }
        }

        

        void dateTimeDataWindowEnd_DropDown(object sender, EventArgs e)
        {
            _isEndDateTimeClose = false;
        }

        void dateTimeDataWindowEnd_CloseUp(object sender, EventArgs e)
        {
            _isEndDateTimeClose = true;
            dateTimeDataWindowEnd_ValueChanged(dateTimeDataWindowEnd, new EventArgs());
            //dateTimeDataWindowEnd.Value = dateTimeDataWindowEnd.Value.AddSeconds(1.0);
        }
		#endregion

		private void RunControlPanelDialog_Load(object sender, System.EventArgs e)
		{
			/*txtLag.DataBindings.Add("Text",_runControlSet.RunSettingsObj,"LagTime");
			cmbDataSourceType.DataBindings.Add("Text",_runControlSet,"DataSourceType");*/
			foreach(RunControlSet rcs in _runOptionsObj.RunControlSetsObj)
			{
				cmbRunControlSet.Items.Add(rcs.SetName);
			}
			cmbRunControlSet.SelectedIndex = _runOptionsObj.SelectedRunControlIndex; 
			ToolTip toolTip = new ToolTip();
			toolTip.SetToolTip(btnInitializeModels,LRRMessages.GetMessageString("SID_TOOLTIP_INITIALIZE_MODEL"));
			toolTip.SetToolTip(chkAutoRun,LRRMessages.GetMessageString("SID_TOOLTIP_CHK_AUTORUN"));
			toolTip.SetToolTip(BtnRunNextStep,LRRMessages.GetMessageString("SID_TOOLTIP_RUN_NEXT_STEP"));
			toolTip.SetToolTip(btnRunEnteredWindow,LRRMessages.GetMessageString("SID_TOOLTIP_RUN_ENTERED_WND"));
			toolTip.SetToolTip(btnRunAdvance,LRRMessages.GetMessageString("SID_TOOLTIP_RUN_ADVANCE"));
			toolTip.SetToolTip(btnRun,LRRMessages.GetMessageString("SID_TOOL_TIP_RUN"));
			BindGridModes();
            //BindForm(_runOptionsObj);			

            string query = "Select CurrentRunStartTime,CurrentRunEndTime,DWSize,DWUnits From DetailsForWebApp Where UID = '" + _app.DBManagerObj.AccessControlModel.UserID + "'";
            System.Data.IDataReader dr = _app.DBManagerObj.DataAdapterObj.GetDataReader(query);
            while (dr.Read())
            {
                dateTimeDataWindowStart.Value = DateTime.Parse(dr[0].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                dateTimeDataWindowEnd.Value = DateTime.Parse(dr[1].ToString(), Symcon.BusinessObjects.SymConverter.Culture);
                cmbDataWindowUnits.Text = dr[2].ToString();
                txtDataWindowSize.Text = dr[3].ToString();
            }
		}

		private void BindForm(RunControlSet runControlSet)
		{
			ClearBindings(this);
			if(runControlSet != null)
			{
				//Bind Auto Run On/Off
				chkAutoRun.DataBindings.Add("Checked",runControlSet,"AutoRun");

				cmbRunControlSet.DataBindings.Add("Text",runControlSet,"SetName");
				cmbDataSourceType.DataBindings.Add("Text",runControlSet,"DataSourceType");
				cmbOfflineDataSource.DataBindings.Add("Text",runControlSet,"OffLineDBSelection");

				//Run Settings
				rbCurrent.DataBindings.Add("Checked",runControlSet.RunSettingsObj,"IsCurrent");
				rbHistorical.DataBindings.Add("Checked",runControlSet.RunSettingsObj,"IsHistorical");
				rbForwardLooking.DataBindings.Add("Checked",runControlSet.RunSettingsObj,"ForwardLooking");
				txtLag.DataBindings.Add("Text",runControlSet.RunSettingsObj,"LagTime");
				cmbLagUnits.DataBindings.Add("Text",runControlSet.RunSettingsObj,"LagTimeUnits");

				//Run Schedules
				//rbSingleRun.DataBindings.Add("Checked",runControlSet.RunSchedulesObj,"SingleRun");
				//rbMultipleRuns.DataBindings.Add("Checked",runControlSet.RunSchedulesObj,"MultipleRuns");
				chkTimeIncrement.DataBindings.Add("Checked",runControlSet.RunSchedulesObj,"TimeIncrementFlag");
				rbSequentialDataSets.DataBindings.Add("Checked",runControlSet.RunSchedulesObj,"SequentialDataSetFlag");
				rbRandomSets.DataBindings.Add("Checked",runControlSet.RunSchedulesObj,"RandomDataSetFlag");
				//chkPause.DataBindings.Add("Checked",runControlSet.RunSchedulesObj,"PauseBetweenRuns");
				//txtPauseDuration.DataBindings.Add("Text",runControlSet.RunSchedulesObj,"PauseTime");
				//cmbPauseDurationUnits.DataBindings.Add("Text",runControlSet.RunSchedulesObj,"PauseUnits");
				chkTandemRuns.DataBindings.Add("Checked",runControlSet.RunSchedulesObj,"TandomRuns");
				txtTandemOffset.DataBindings.Add("Text",runControlSet.RunSchedulesObj,"TandomOffsetTime");
				cmbTandemOffsetUnits.DataBindings.Add("Text",runControlSet.RunSchedulesObj,"TandomOffsetUnits");
				txtTimeIncrment.DataBindings.Add("Text",runControlSet.RunSchedulesObj,"TimeIncrement");
				cmbIncrementUnits.DataBindings.Add("Text",runControlSet.RunSchedulesObj,"TimeIncrementUnits");

				//Data Window
				dateTimeDataWindowStart.DataBindings.Add("Value",runControlSet.DataWindowObj,"StartTime");
				dateTimeDataWindowEnd.DataBindings.Add("Value",runControlSet.DataWindowObj,"EndTime");
				txtDataWindowSize.DataBindings.Add("Text",runControlSet.DataWindowObj,"DataWindowSize");
				cmbDataWindowUnits.DataBindings.Add("Text",runControlSet.DataWindowObj,"DataWindowUnits");
				

				//Time Series
				dateTimeSeriesStart.DataBindings.Add("Value",runControlSet.TimeSeriesObj,"StartTime");
				dateTimeSeriesEnd.DataBindings.Add("Value",runControlSet.TimeSeriesObj,"EndTime");

				//Auto Run
				chkAutoRunBoundries.DataBindings.Add("Checked",runControlSet.AutoRunsObj,"AutoRun");
                dateTimePickerAutoRunStart.DataBindings.Add("Value", runControlSet.AutoRunsObj, "StartTime");
                dateTimePickerAutoRunEnd.DataBindings.Add("Value", runControlSet.AutoRunsObj, "EndTime");
				
				//Save datasets in offline without executing models...
				chkSaveDataSets.DataBindings.Add("Checked",runControlSet,"SaveDataSets");
                chkSaveOfflinehistorian.DataBindings.Add("Checked", runControlSet, "SaveToOfflineHistorian");

				//Backfill datasets....
				chkEnableBackfilling.DataBindings.Add("Checked",runControlSet,"BackFillDatasets");

                chkEnableBackfilling.Enabled = chkSaveDataSets.Checked || chkSaveOfflinehistorian.Checked; 
				if(chkEnableBackfilling.Checked)
				{
					chkEnableBackfilling.Checked = chkEnableBackfilling.Enabled && chkEnableBackfilling.Checked;
				}
				


				//Bind Record Values
				chkRecordValues.DataBindings.Add("Checked",runControlSet,"RecordValues");
			}

			SetUI();

		}
		
		/// <summary>
		/// Bind the Run Records Name combo
		/// </summary>
		private void BindRecordRunCombo()
		{
			//Populate from Recording DB
            // commented by ashwin
            /*
			_app.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords);

			cmbRecordRun.DataSource = _lrrRunRecords;
			cmbRecordRun.DisplayMember = "RunName";
			cmbRecordRun.ValueMember = "RunID";
             * */

            _app.RecordingValuesManagerObj.PopulateCollection(_lrrRunSets);
            cmbRecordRun.DataSource = _lrrRunSets;
            cmbRecordRun.DisplayMember = "RunName";
            cmbRecordRun.ValueMember = "RunID";
		}

		private void btnNew_Click(object sender, System.EventArgs e)
		{
			SaveDataSetForm saveDataSet = new SaveDataSetForm();
			DialogResult result = saveDataSet.ShowDialog();

			if(result == DialogResult.OK)
			{
				if(!cmbRunControlSet.Items.Contains(saveDataSet.name))
				{
					cmbRunControlSet.Items.Add(saveDataSet.name);
					ToolTip toolTip = new ToolTip();
					toolTip.SetToolTip(cmbRunControlSet,"Description:" + saveDataSet.desc);
					RunControlSet rs = new RunControlSet();
					rs.SetName = saveDataSet.name;
					rs.SetDescription = saveDataSet.desc;
					_runOptionsObj.RunControlSetsObj.Add(rs);
					cmbRunControlSet.SelectedIndex = cmbRunControlSet.Items.Count - 1;
					btnSave.Enabled = true;
					btnNew.Enabled = false;
					btnDelete.Text = LRRHeaderText.GetHeaderString("SID_CANCEL");
				}
				else
				{
					//MessageBox.Show(this,"Run Control Set '" + saveDataSet.name + "' already exists.","Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
					string[] s = new string[1];
					s[0] = saveDataSet.Name;
					LRRMessagBox.ShowMessage(this,"SID_DATASET_EXISTS","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);      
				}

			}
		}

		private void cmbRunControlSet_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(btnSave.Enabled)
			{
				if(LRRMessagBox.ShowMessage("SID_ON_CHANGE","SID_LABEL",MessageBoxButtons.YesNo) == DialogResult.Yes)
				{
					cmbRunControlSet.Items.RemoveAt(_runOptionsObj.SelectedRunControlIndex);
					cmbRunControlSet.Refresh();
					_runOptionsObj.RunControlSetsObj.RemoveAt(_runOptionsObj.SelectedRunControlIndex);
					SaveOptions();
					btnSave.Enabled = false;
					btnNew.Enabled = true;
					btnDelete.Text = LRRHeaderText.GetHeaderString("SID_DELETE");
				}
				else
				{
					return;
				}
			}
			else
			{
				_runOptionsObj.SelectedRunControlIndex = cmbRunControlSet.SelectedIndex;

				RunControlSet rcs = _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex];
				if(rcs!=null)
				{
					BindForm(rcs);
					_app.ActiveRunControlSet = rcs;
				}
				//_runOptionsObj.SelectedRunControlIndex = cmbRunControlSet.SelectedIndex;
				ToolTip toolTip = new ToolTip();
				toolTip.SetToolTip(cmbRunControlSet,"Description:" + rcs.SetDescription);
				SetUI();
			}
		}

		private void ClearBindings(Control c)
		{
			Binding[] bindings = new Binding[c.DataBindings.Count];
			c.DataBindings.CopyTo(bindings, 0);
			c.DataBindings.Clear();
			foreach (Binding binding in bindings)
			{
				TypeDescriptor.Refresh(binding.DataSource);
			}
			foreach (Control cc in c.Controls)
			{
				ClearBindings(cc);
			}
		}

		private void SaveOptions()
		{
			this.Validate();
//			string filePath = Application.StartupPath + @"\Runoptions.xml";
//			Symcon.Utils.XMLUtils.SGTXmlSerializer.SerializeAsXML(@filePath,typeof(RunOptions),_runOptionsObj,false);
		}

		/// <summary>
		/// Call the Run Method...
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnRun_Click(object sender, System.EventArgs e)
		{
			/*if(_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].AutoRun)
			{
				//this.panel1.Enabled = false;
				//SetControlsEnableState(this.Controls[0],false);
				string runID = RecordRunActivity();
				_runController.Start(RunTypeEnum.AUTO_RUN,_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex],runID);
				_app.LRRUIManagerObj.ShowRunStatusDialog();
			}
			else
			{
				if(_lastExecutedMethod != null)
				{
					_lastExecutedMethod(sender,e);
					_app.LRRUIManagerObj.ShowRunStatusDialog();
				}
			}*/
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			SetSelectedModes();
			if(RecordRunActivity())
				_app.DoRun();
		}

		private void SetSelectedModes()
		{
			_app.ActiveRunControlSet.SelectedModes.Clear();
			object[] objSelModes = _unBoundModes.GetSelectedRecords();
			for(int i=0;i < objSelModes.GetLength(0);i++)
			{
				LRRMode mode = objSelModes.GetValue(i) as LRRMode;
				_app.ActiveRunControlSet.SelectedModes.Add(mode.ModeId);
			}
		}

		private void checkAndRun(object objSavedSet)
		{
			LRRHistSavedSet savedSet = objSavedSet as LRRHistSavedSet;
			DateTime endSeries = dateTimeSeriesEnd.Value;

			//DataWindow
			TimeSpan offSet = new TimeSpan(0);
			if(cmbDataWindowUnits.Text == "Min")
			{
				int slice = Int32.Parse(txtDataWindowSize.Text,Symcon.BusinessObjects.SymConverter.Culture);
				offSet = new TimeSpan(0,slice,0);
			}
			if(cmbDataWindowUnits.Text == "Hr")
			{
				int slice = Int32.Parse(txtDataWindowSize.Text,Symcon.BusinessObjects.SymConverter.Culture);
				offSet = new TimeSpan(slice,0,0);
			}
			if(cmbDataWindowUnits.Text == "Sec")
			{
				int slice = Int32.Parse(txtDataWindowSize.Text,Symcon.BusinessObjects.SymConverter.Culture);
				offSet = new TimeSpan(0,0,slice);
			}

			//Symcon.Utils.MessageLogger.Logger.LogMessage("Current Start Time " + DateTime.Now.ToString("dd-MMM-yyyy HH:mm:ss") ,Logger.Level.Debug);
			DateTime currentStartTime = timeSliceStart;
			DateTime currentEndTime = timeSliceStart.Add(offSet);
			Symcon.Utils.MessageLogger.Logger.LogMessage("Run Start Time:" + currentStartTime.ToString("dd-MMM-yyyy HH:mm:ss") + "Run End Time:" + currentEndTime.ToString("dd-MMM-yyyy HH:mm:ss"),Logger.Level.Debug);
			
			//Single Run
			/*if(rbSingleRun.Checked)
			{
				//Current
				if(rbCurrent.Checked)
				{
					//Lag
					TimeSpan lag = new TimeSpan(0);
					if(cmbLagUnits.Text == "Mins")
					{
						int slice = Int32.Parse(txtLag.Text);
						lag = new TimeSpan(0,slice,0);
					}
					if(cmbLagUnits.Text == "Hrs")
					{
						int slice = Int32.Parse(txtLag.Text);
						lag = new TimeSpan(slice,0,0);
					}
					if(cmbLagUnits.Text == "Sec")
					{
						int slice = Int32.Parse(txtLag.Text);
						lag = new TimeSpan(0,0,slice);
					}
					if(cmbLagUnits.Text == "Days")
					{
						int slice = Int32.Parse(txtLag.Text);
						lag = new TimeSpan(slice,0,0,0);
					}

					_savedSet = new LRRHistSavedSet();
					_savedSet.Name = "DataSet " + currentStartTime.ToShortDateString() + " " + currentStartTime.ToShortTimeString();
					_savedSet.StartTime = currentStartTime.ToString();
					_savedSet.EndTime = currentEndTime.ToString();
					_savedSet.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
					_savedPoints = new LRRHistorianPoints();

					_runController.Run(currentStartTime.ToString(),currentEndTime.ToString());

					//wait
					System.Threading.Thread.Sleep(lag);
					//Symcon.Utils.MessageLogger.Logger.LogMessage("Current End Time " + DateTime.Now.ToString("dd-MMM-yyyy HH:mm:ss"),Logger.Level.Debug);
					timer.Dispose();
					lblStatus.Text = "Run Completed!";
				}
				
				//Historical
				if(rbHistorical.Checked)
				{
					_savedSet = new LRRHistSavedSet();
					_savedSet.Name = "DataSet " + currentStartTime.ToShortDateString() + " " + currentStartTime.ToShortTimeString();
					_savedSet.StartTime = currentStartTime.ToString();
					_savedSet.EndTime = currentEndTime.ToString();
					_savedSet.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
					_savedPoints = new LRRHistorianPoints();

					_runController.Run(currentStartTime.ToString(),currentEndTime.ToString());
					//Symcon.Utils.MessageLogger.Logger.LogMessage("Current End Time " + DateTime.Now.ToString("dd-MMM-yyyy HH:mm:ss"),Logger.Level.Debug);
					timer.Dispose();
				}
			}*/
			
			//Multiple Runs
			/*if(rbMultipleRuns.Checked)
			{
				//Current
//				if(rbCurrent.Checked)
//				{
					//Lag
//					TimeSpan lag = new TimeSpan(0);
//					if(cmbLagUnits.Text == "Mins")
//					{
//						int slice = Int32.Parse(txtLag.Text);
//						lag = new TimeSpan(0,slice,0);
//					}
//					if(cmbLagUnits.Text == "Hrs")
//					{
//						int slice = Int32.Parse(txtLag.Text);
//						lag = new TimeSpan(slice,0,0);
//					}
//					if(cmbLagUnits.Text == "Sec")
//					{
//						int slice = Int32.Parse(txtLag.Text);
//						lag = new TimeSpan(0,0,slice);
//					}
//					if(cmbLagUnits.Text == "Days")
//					{
//						int slice = Int32.Parse(txtLag.Text);
//						lag = new TimeSpan(slice,0,0,0);
//					}

					if(timeSliceStart.CompareTo(endSeries) < 0)
					{
						_savedSet = new LRRHistSavedSet();
						_savedSet.Name = "DataSet " + currentStartTime.ToShortDateString() + " " + currentStartTime.ToShortTimeString();
						_savedSet.StartTime = currentStartTime.ToString();
						_savedSet.EndTime = currentEndTime.ToString();
						_savedSet.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
						_savedPoints = new LRRHistorianPoints();

						_runController.Run(currentStartTime.ToString(),currentEndTime.ToString());
						//wait
//						System.Threading.Thread.Sleep(lag);
//						timeSliceStart = timeSliceStart.Add(lag);
						//Symcon.Utils.MessageLogger.Logger.LogMessage("Current End Time " + DateTime.Now.ToString("dd-MMM-yyyy HH:mm:ss"),Logger.Level.Debug);
						
						//Time Increment
						TimeSpan timeIncrement = new TimeSpan(0);
						if(cmbIncrementUnits.Text == "Min")
						{
							int slice = Int32.Parse(txtTimeIncrment.Text);
							timeIncrement = new TimeSpan(0,slice,0);
						}
						if(cmbIncrementUnits.Text == "Hr")
						{
							int slice = Int32.Parse(txtTimeIncrment.Text);
							timeIncrement = new TimeSpan(slice,0,0);
						}
						if(cmbIncrementUnits.Text == "Sec")
						{
							int slice = Int32.Parse(txtTimeIncrment.Text);
							timeIncrement = new TimeSpan(0,0,slice);
						}
						if(cmbIncrementUnits.Text == "Day")
						{
							int slice = Int32.Parse(txtTimeIncrment.Text);
							timeIncrement = new TimeSpan(slice,0,0,0);
						}

						//Pause between runs
//						TimeSpan pause = new TimeSpan(0);
//						if(cmbPauseDurationUnits.Text == "Min")
//						{
//							int slice = Int32.Parse(txtPauseDuration.Text);
//							pause = new TimeSpan(0,slice,0);
//						}
//						if(cmbPauseDurationUnits.Text == "Hr")
//						{
//							int slice = Int32.Parse(txtPauseDuration.Text);
//							pause = new TimeSpan(slice,0,0);
//						}
//						if(cmbPauseDurationUnits.Text == "Sec")
//						{
//							int slice = Int32.Parse(txtPauseDuration.Text);
//							pause = new TimeSpan(0,0,slice);
//						}
//						System.Threading.Thread.Sleep(pause);
//						timeSliceStart = timeSliceStart.Add(pause);

						timeSliceStart = timeSliceStart.Add(timeIncrement);
						timer.Change(new TimeSpan(0),new TimeSpan(-1));
					}
					else
					{
						//Tandem
						TimeSpan tandemOffSet = new TimeSpan(0);
						if(cmbTandemOffsetUnits.Text == "Min")
						{
							int slice = Int32.Parse(txtTandemOffset.Text);
							tandemOffSet = new TimeSpan(0,slice,0);
						}
						if(cmbTandemOffsetUnits.Text == "Hr")
						{
							int slice = Int32.Parse(txtTandemOffset.Text);
							tandemOffSet = new TimeSpan(slice,0,0);
						}
						if(cmbTandemOffsetUnits.Text == "Sec")
						{
							int slice = Int32.Parse(txtTandemOffset.Text);
							tandemOffSet = new TimeSpan(0,0,slice);
						}

						DateTime timeTandem = timeTandemSeries.Add(tandemOffSet);
						DateTime timeCheck = startSeris.Add(new TimeSpan(24,0,0));

						if(timeTandem.CompareTo(timeCheck) < 0)
						{
							timeSliceStart = timeTandem;
							timeTandemSeries = timeSliceStart;
							timer.Change(new TimeSpan(0),new TimeSpan(-1));
						}
						else
						{
							timer.Dispose();
							lblStatus.Text = "Run Completed!";
						}
					}
//				}
			}*/
		}
		
		private void RunControlPanelDialog_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			SaveOptions();
            this._runController.CurrentTunningDBChanged -= new EventHandler(_runController_CurrentTunningDBChanged);
		}

		//Handler which gets called when the Point is received
		private void _runController_ReceivedPoint(Symcon.LightRidge.BusinessObjects.LRRHistData point,string startTime,string endTime)
		{
			if(lblStatus.InvokeRequired)
			{
				object[] args = new object[1];
				args[0] = "Received Point " + point.HistTag;
				lblStatus.Invoke(new SetLabelDel(SetLabel),args);
			}
		}

		

		private void SetLabel(string text)
		{
			lblStatus.Text = text;
		}

		//Handler which gets called when the run gets completed...
		[System.Runtime.CompilerServices.MethodImpl(System.Runtime.CompilerServices.MethodImplOptions.Synchronized)]
		private void _runController_RunCompleted(object sender, EventArgs e)
		{
			if(_savedSet != null)
			{
				String s  = LRRHeaderText.GetHeaderString("SID_SAVEING_DATASET");
				lblStatus.Text = s + _savedSet.Name;
				//			_app.DBManagerObj.CommitObject(_savedSet);
				//			_app.DBManagerObj.CommitCollection(_savedPoints);
				String s2  = LRRHeaderText.GetHeaderString("SID_SAVED_DATASET");
				lblStatus.Text = s2  + _savedSet.Name;
				_flagged = true;
			}

			lblStatus.Text = "Starting Exec Engine Write and Read!";
			//_app.StartExecutionEngine();

			lblStatus.Text = "Exec Engine Completed";


			if(_runQueue.Count > 0)
			{
				if(isAborted)
				{
					_runQueue.Clear();
					this.Enabled = true;
					return;
				}
				LRRHistSavedSet histSet = _runQueue.Dequeue() as LRRHistSavedSet;
				foreach (Symcon.LightRidge.HistorianConnect.IHistorian iHistObj in _app.LoadedOnLineHistorianAssemblies.Values)
                {
                    iHistObj.PrepareCollection(histSet.ID); 
                }
				//_runController.Run(histSet.StartTime,histSet.EndTime);
			}
			
			this.panel1.Enabled = true;
            TrackingController.TrackUIUpdate = true;	
		}

		#region Fields
		private RunOptions					_runOptionsObj;
		private RunController				_runController;
		private LRRApp						_app;
		private LRRHistSavedSet				_savedSet;
		private LRRHistorianPoints			_savedPoints;
		private bool						_flagged = false;
		private EventHandler				_lastExecutedMethod;
		private TabPage						_parentTabPage;
		private TabControl					_parentTabControl;
		private LRRRunRecords				_lrrRunRecords = new LRRRunRecords();
        private LRRRunSets                  _lrrRunSets = new LRRRunSets();
        private int                         _numberOfPasses = 0;
		#endregion	

		private void cmbDataSourceType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
            //if (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING"))
            //{
            //    Symcon.LightRidge.Options.DBOptions.DBInfo dbinfo = _lrrOptions.TuningConnectionObj.GetActiveTuningDBInfo();
            //    // Symcon.LightRidge.Options.DBOptions.DBInfo dbOfflineInfo = _lrrOptions.OfflineConnectionObj.GetActiveOfflineDBInfo();
            //    if (_app.LoadedOffLineHistorianAssemblies.ContainsKey(_app.TUNNING))
            //    {
            //        Symcon.LightRidge.HistorianConnect.TuningHistorian tunningHist = _app.LoadedOffLineHistorianAssemblies[_app.TUNNING] as Symcon.LightRidge.HistorianConnect.TuningHistorian;
            //        tunningHist.Initialize(dbinfo);
            //        if (!tunningHist.Initialized)
            //        {
            //            MessageBox.Show("Tuning Db not set");
            //            cmbDataSourceType.SelectedIndex = 0;
            //            return;
            //        }

            //    }
            //    else
            //    {
            //        MessageBox.Show("Tuning Db not set");
            //        cmbDataSourceType.SelectedIndex = 0;
            //        return;
            //    }
            //}
			SetUI();

            //cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE")
			//Added by Nidhi G as the behaviour of tuning & offline is the same
			if((cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING")) || (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE")))// && rbMultipleRuns.Checked)
			{
				rbSequentialDataSets.Enabled = true;
				rbRandomSets.Enabled = true;
				//chkTimeIncrement.Enabled = false;
				//chkPause.Enabled = false;
				chkTandemRuns.Enabled = false;
				txtTimeIncrment.Enabled = false;
				cmbIncrementUnits.Enabled = false;
				//txtPauseDuration.Enabled = false;
				//cmbPauseDurationUnits.Enabled = false;
				txtTandemOffset.Enabled = false;
				cmbTandemOffsetUnits.Enabled = false;
				//dateTimeDataWindowEnd.Enabled = false;
				dateTimeSeriesStart.Enabled = false;
				if(rbSequentialDataSets.Checked || rbRandomSets.Checked)
				{
					txtDataWindowSize.Enabled = false;
					dateTimeDataWindowStart.Enabled = false; 
					cmbDataWindowUnits.Enabled = false;
				}
				else
				{
					txtTimeIncrment.Enabled = true;
					cmbIncrementUnits.Enabled = true;
					txtDataWindowSize.Enabled = true;
					cmbDataWindowUnits.Enabled = true;
					dateTimeDataWindowStart.Enabled = true;
					chkAutoRunBoundries.Enabled = true;
				}

				dateTimeSeriesEnd.Enabled = false;
				
				_runController.ActiveHistorianIndex = 0;//3;
                if (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE"))
                {
                    Symcon.LightRidge.Options.DBOptions.DBInfo dbOfflineInfo = _lrrOptions.OfflineConnectionObj.GetActiveOfflineDBInfo();
                    if (dbOfflineInfo != null)
                    {
                        lblTuningDB.Text = dbOfflineInfo.DatabaseName;
                    }
                    else
                    {
                        lblTuningDB.Text = "";
                    }
                }
                else
                {
                    lblTuningDB.Text = _sDBName;
                    if (_app.GetOptions().TunningConfigurationChanged)
                    {
                        Symcon.LightRidge.Options.DBOptions.DBInfo dbinfo = _lrrOptions.TuningConnectionObj.GetActiveTuningDBInfo();
                        if (dbinfo != null)
                        {
                        lblTuningDB.Text = dbinfo.DatabaseName;
                        if (_app.LoadedOffLineHistorianAssemblies.ContainsKey(_app.TUNNING))
                        {
                            Symcon.LightRidge.HistorianConnect.TuningHistorian tunningHist = _app.LoadedOffLineHistorianAssemblies[_app.TUNNING] as Symcon.LightRidge.HistorianConnect.TuningHistorian;
                            if (tunningHist != null)
                            {
                                LRRHistSavedSets histSavedDatas = tunningHist.GetFirstTwoDataSet();
                                if (histSavedDatas != null && histSavedDatas.Count > 0)
                                {
                                    LRRHistSavedSet firstHistSaveDataSet = histSavedDatas[0] as LRRHistSavedSet;
                                    if (firstHistSaveDataSet != null)
                                    {
                                        this.dateTimeDataWindowStart.Value = firstHistSaveDataSet.StartTime;
                                        this.dateTimeDataWindowEnd.Value = firstHistSaveDataSet.EndTime;
                                        _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].DataWindowObj.StartTime = this.dateTimeDataWindowStart.Value;
                                        _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].DataWindowObj.EndTime = this.dateTimeDataWindowEnd.Value;
                                    }
                                    LRRHistSavedSet secoundhistSaveDataSet = histSavedDatas[1] as LRRHistSavedSet;
                                    TimeSpan ts = secoundhistSaveDataSet.StartTime.Subtract(firstHistSaveDataSet.StartTime);
                                    if (!(ts.TotalSeconds.ToString().StartsWith("-")))
                                    {
                                        if (ts.TotalSeconds < 60.0)
                                        {
                                            _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RunSchedulesObj.TimeIncrement = Convert.ToInt16(ts.TotalSeconds);
                                            _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RunSchedulesObj.TimeIncrementUnits = "Sec";
                                            this.txtTimeIncrment.Text = Convert.ToInt16(ts.TotalSeconds).ToString();
                                            this.cmbIncrementUnits.Text = "Sec";
                                        }
                                        else if (ts.TotalMinutes < 60.0)
                                        {
                                            _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RunSchedulesObj.TimeIncrement = Convert.ToInt16(ts.TotalMinutes);
                                            _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RunSchedulesObj.TimeIncrementUnits = "Min";
                                            this.txtTimeIncrment.Text = Convert.ToInt16(ts.TotalMinutes).ToString();
                                            this.cmbIncrementUnits.Text = "Min";
                                        }
                                        else
                                        {
                                            _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RunSchedulesObj.TimeIncrement = Convert.ToInt16(ts.TotalHours);
                                            _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RunSchedulesObj.TimeIncrementUnits = "Hr";
                                            this.txtTimeIncrment.Text = Convert.ToInt16("10").ToString();
                                            this.cmbIncrementUnits.Text = "Hr";
                                        }
                                    }
                                }
                            }
                        }
                    }
                        _app.GetOptions().TunningConfigurationChanged = false;
                    }
                }

				lblTuningDB.Visible = true;
				lblDBName.Visible = true;


				/*btnRunAdvance.Enabled= false;
				btnRunEnteredWindow.Enabled = false;
				BtnRunNextStep.Enabled = false;
				chkAutoRun.Text = "Auto Run ON";
				chkAutoRun.Enabled = false;
				chkAutoRun.Checked = true;
				chkAutoRun.BackColor = Color.Red;*/

				

				rbCurrent.Enabled = false;
				rbHistorical.Enabled = false;
				txtLag.Enabled = false;
				cmbLagUnits.Enabled = false;

				chkSaveDataSets.Checked = false;
				chkEnableBackfilling.Checked = false;
                chkSaveOfflinehistorian.Checked = false;
				_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].SaveDataSets = false;
                _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].SaveToOfflineHistorian = false;
				_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].BackFillDatasets = false;
				chkSaveDataSets.Enabled = false;
				chkEnableBackfilling.Enabled = false;
                chkSaveOfflinehistorian.Enabled = false;
				btnRunAdvance.Enabled = false;

					if(chkAutoRun.Checked == false)
					{
						chkTimeIncrement.Checked = true;
						rbSequentialDataSets.Enabled = false;
						rbRandomSets.Enabled = false;
					}
					else
					{
						//chkTimeIncrement.Checked = true;
						rbSequentialDataSets.Enabled = true;
						rbRandomSets.Enabled = true;

					}
				Validate();

					return;
			}
			else
			{
				rbSequentialDataSets.Enabled = false;
				rbRandomSets.Enabled = false;
				chkTimeIncrement.Enabled = true;
				//chkPause.Enabled = true;
//				chkTandemRuns.Enabled = true;
				if(chkTimeIncrement.Checked)
				{
					txtTimeIncrment.Enabled = true;
					cmbIncrementUnits.Enabled = true;
				}
				//txtPauseDuration.Enabled = true;
				//cmbPauseDurationUnits.Enabled = true;
//				txtTandemOffset.Enabled = true;
//				cmbTandemOffsetUnits.Enabled = true;
//				dateTimeDataWindowEnd.Enabled = true;
				dateTimeDataWindowStart.Enabled = true;
//				dateTimeSeriesStart.Enabled = true;
//				dateTimeSeriesEnd.Enabled = true;
				txtDataWindowSize.Enabled = true;
				cmbDataWindowUnits.Enabled = true;
				lblTuningDB.Text = "";
				lblDBName.Visible = false;

				chkAutoRun.Enabled = true;
				rbCurrent.Enabled = true;
				rbHistorical.Enabled = false;
				if(rbCurrent.Checked)
				{
					txtLag.Enabled = true;
					cmbLagUnits.Enabled = true;
				}
				
				chkSaveDataSets.Enabled = true;
                chkSaveOfflinehistorian.Enabled = true;
				if(chkAutoRun.Checked == false)
				{
					btnRunAdvance.Enabled = true;
				}
				else
				{
					btnRunAdvance.Enabled = false;
				}
				if(chkTimeIncrement.Checked == false)
				{
					 chkTimeIncrement.Checked = true;
					_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].RunSchedulesObj.TimeIncrementFlag = true;
				}
			} 

			if(cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_ONLINE"))
			{
				_runController.ActiveHistorianIndex = 1;
			}
			else if((cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING")) || (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE")))
			{
				_runController.ActiveHistorianIndex = 0;//3;
			}
			else
			{
				_runController.ActiveHistorianIndex = 2;
			}
			_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].DataSourceType = cmbDataSourceType.Text;

			Validate();
			
		}

		private void rbCurrent_CheckedChanged(object sender, System.EventArgs e)
		{
			SetUI();
		}

		private void txtDataWindowSize_TextChanged(object sender, System.EventArgs e)
		{
            int dataWindowValue;
            int slice; // Added by Sandeep
            if (Int32.TryParse(txtDataWindowSize.Text,out slice)) // Added by Sandeep
            {
                TimeSpan dataWindow = new TimeSpan(0);
                if (cmbDataWindowUnits.Text == "Min")
                {
                    dataWindowValue = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    if(dataWindowValue <= 1440)
                    {
                        //int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture); Commented by Sandeep
                        dataWindow = new TimeSpan(0, slice, 0);
                    }
                    else
                    {
                        MessageBox.Show(" Minutes of Data Windows Entered is not correct. It should be less than or equal to 1440 ");
                        txtDataWindowSize.Focus();
                        txtDataWindowSize.Text = "";
                        return;
                    }
                }
                if (cmbDataWindowUnits.Text == "Hr")
                {
                    dataWindowValue = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    if (dataWindowValue <= 24)
                    {
                        //int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture); Commented by Sandeep
                        dataWindow = new TimeSpan(slice, 0, 0);
                    }
                    else
                    {
                        MessageBox.Show(" Hours of Data Window Entered is not correct. It should by less than or equal to 24 ");
                        txtDataWindowSize.Focus();
                        txtDataWindowSize.Text = "";
                        return;
                    }
                }
                if (cmbDataWindowUnits.Text == "Sec")
                {
                    dataWindowValue = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    if (dataWindowValue <= 86400)
                    {
                        //int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture); Commented by Sandeep
                        dataWindow = new TimeSpan(0, 0, slice);
                    }
                    else
                    {
                        MessageBox.Show(" Seconds of Data Window Entered is not correct. It should by less than or equal to 86400 ");
                        txtDataWindowSize.Focus();
                        txtDataWindowSize.Text = "";
                        return;
                    }
                }
                dateTimeDataWindowEnd.Value = dateTimeDataWindowStart.Value.Add(dataWindow);
                RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                rcs.DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;

                
                dataWindow = dateTimeDataWindowEnd.Value.Subtract(dateTimeDataWindowStart.Value);
                if (dataWindow.TotalHours < 0.0 || dataWindow.TotalSeconds < 0.0 || dataWindow.TotalMinutes < 0.0)
                {
                    //LRRMessagBox.ShowMessage(_app.MainFrame, "SID_INVALID_ETIME", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Warning); // Message changed by Sandeep as it was wrong
                    //rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    //dateTimeDataWindowEnd.Value = rcs.DataWindowObj.EndTime;
                    //return;
                }
                if (dataWindow.TotalHours > 24.0)
                {
                    //LRRMessagBox.ShowMessage(_app.MainFrame, "SID_INVALID_TIME", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Warning); // Message changed by Sandeep as it was wrong
                    //rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    //dateTimeDataWindowEnd.Value = rcs.DataWindowObj.EndTime;
                    //return;
                }
                else
                {
                    if (/*dataWindow.TotalSeconds < 60.0*/ cmbDataWindowUnits.Text == "Sec")
                    {
                        //cmbDataWindowUnits.Text = "Sec";
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalSeconds).ToString();
                    }
                    else if (/*dataWindow.TotalMinutes < 60.0*/ cmbDataWindowUnits.Text == "Min")
                    {
                        //cmbDataWindowUnits.Text = "Min";
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalMinutes).ToString();
                    }
                    else
                    {
                        //cmbDataWindowUnits.Text = "Hr";
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalHours).ToString();
                    }
                    rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    if (rcs.DataWindowObj.EndTime != dateTimeDataWindowEnd.Value)
                        rcs.DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;
                    if (rcs.DataWindowObj.DataWindowSize != Convert.ToInt16(txtDataWindowSize.Text))
                        rcs.DataWindowObj.DataWindowSize = Convert.ToInt16(txtDataWindowSize.Text);
                    if (rcs.DataWindowObj.DataWindowUnits != cmbDataWindowUnits.Text)
                        rcs.DataWindowObj.DataWindowUnits = cmbDataWindowUnits.Text;
                }

            }
            else
            {
                txtDataWindowSize.Text = "";
            }
		}

		private void cmbDataWindowUnits_SelectedIndexChanged(object sender, System.EventArgs e)
		{
            /* commented by ashwin
             
            TimeSpan dataWindow = new TimeSpan(0);
            if (txtDataWindowSize.Text != "")
            {
                if (cmbDataWindowUnits.Text == "Min")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(0, slice, 0);
                }
                if (cmbDataWindowUnits.Text == "Hr")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(slice, 0, 0);
                }
                if (cmbDataWindowUnits.Text == "Sec")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(0, 0, slice);
                }

                RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                dateTimeDataWindowEnd.Value = dateTimeDataWindowStart.Value.Add(dataWindow);
                rcs.DataWindowObj.DataWindowUnits = cmbDataWindowUnits.Text;
                rcs.DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;
            }
             * */

            int dataWindowValue;
            int slice; 
            if (Int32.TryParse(txtDataWindowSize.Text, out slice)) // Added by Sandeep
            {
                TimeSpan dataWindow = new TimeSpan(0);
                if (cmbDataWindowUnits.Text == "Min")
                {
                    dataWindowValue = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    if (dataWindowValue < 1440)
                    {
                        dataWindow = new TimeSpan(0, slice, 0);
                    }
                    else
                    {
                        MessageBox.Show(" Minutes of Data Windows Entered is not correct. It should be less than or equal to 1440 ");
                        txtDataWindowSize.Focus();
                        txtDataWindowSize.Text = "";
                        return;
                    }
                }
                if (cmbDataWindowUnits.Text == "Hr")
                {
                    dataWindowValue = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    if (dataWindowValue < 24)
                    {
                        dataWindow = new TimeSpan(slice, 0, 0);
                    }
                    else
                    {
                        MessageBox.Show(" Hours of Data Window Entered is not correct. It should by less than or equal to 24 ");
                        txtDataWindowSize.Focus();
                        txtDataWindowSize.Text = "";
                        return;
                    }
                }
                if (cmbDataWindowUnits.Text == "Sec")
                {
                    dataWindowValue = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    if (dataWindowValue < 86400)
                    {
                        dataWindow = new TimeSpan(0, 0, slice);
                    }
                    else
                    {
                        MessageBox.Show(" Seconds of Data Window Entered is not correct. It should by less than or equal to 86400 ");
                        txtDataWindowSize.Focus();
                        txtDataWindowSize.Text = "";
                        return;
                    }
                }
                dateTimeDataWindowEnd.Value = dateTimeDataWindowStart.Value.Add(dataWindow);
                RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                rcs.DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;


                dataWindow = dateTimeDataWindowEnd.Value.Subtract(dateTimeDataWindowStart.Value);
                if (dataWindow.TotalHours > 24.0)
                {
                }
                else
                {
                    if (cmbDataWindowUnits.Text == "Sec")
                    {
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalSeconds).ToString();
                    }
                    else if (cmbDataWindowUnits.Text == "Min")
                    {
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalMinutes).ToString();
                    }
                    else
                    {
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalHours).ToString();
                    }
                    rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    if (rcs.DataWindowObj.EndTime != dateTimeDataWindowEnd.Value)
                        rcs.DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;
                    if (rcs.DataWindowObj.DataWindowSize != Convert.ToInt16(txtDataWindowSize.Text))
                        rcs.DataWindowObj.DataWindowSize = Convert.ToInt16(txtDataWindowSize.Text);
                    if (rcs.DataWindowObj.DataWindowUnits != cmbDataWindowUnits.Text)
                        rcs.DataWindowObj.DataWindowUnits = cmbDataWindowUnits.Text;
                }

            }
            else
            {
                txtDataWindowSize.Text = "";
            }

		}

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			if(btnDelete.Text == LRRHeaderText.GetHeaderString("SID_DELETE"))
			{
				if(_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].SetName == "Default")
				{
					LRRMessagBox.ShowMessage("SID_DEFAULTSET_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);      
					return;
				}

				if(LRRMessagBox.ShowMessage(this,"SID_DELETESET_CONFIMATION","SID_LABEL",MessageBoxButtons.YesNo) == DialogResult.Yes)
				{
					RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
					_runOptionsObj.RunControlSetsObj.Remove(rcs);
					cmbRunControlSet.Items.Remove(rcs.SetName);
					cmbRunControlSet.Refresh();
					SaveOptions();
					LRRMessagBox.ShowMessage("SID_DELETE_CONFIRMATION","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
					btnSave.Enabled = false;
					btnNew.Enabled = true;
					//btnDelete.Text = "Cancel";
					cmbRunControlSet.SelectedIndex = cmbRunControlSet.Items.Count - 1;
				}
			}
			else
			{
				RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
				if(rcs.SetName == "Default")
				{
					LRRMessagBox.ShowMessage("SID_DEFAULTSET_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);      
					return;
				}
				_runOptionsObj.RunControlSetsObj.Remove(rcs);
				cmbRunControlSet.Items.Remove(rcs.SetName);
				
				LRRMessagBox.ShowMessage("SID_DELETE_CONFIRMATION","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Stop);    
				btnSave.Enabled = false;
				btnNew.Enabled = true;
				btnDelete.Text = LRRHeaderText.GetHeaderString("SID_DELETE");
				cmbRunControlSet.SelectedIndex = cmbRunControlSet.Items.Count - 1;
				SaveOptions();
				cmbRunControlSet.Refresh();
			}
		}

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			SaveOptions();
			LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			btnSave.Enabled = false;
			btnNew.Enabled = true;
			btnDelete.Text = LRRHeaderText.GetHeaderString("SID_DELETE");
		}

		private void dateTimeWindow_ValueChanged(object sender, System.EventArgs e)
		{

			if(_timeWnd == null)
			{
				_timeWnd = TimeWnd;
			}
			if(_timeWnd != null)
			{
//				_timeWnd.txtStartTime.Text = this.dateTimeDataWindowStart.Value.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			}

            TimeSpan dataWindow = new TimeSpan(0);
            if (txtDataWindowSize.Text != "")
            {
                if (cmbDataWindowUnits.Text == "Min")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(0, slice, 0);
                }
                if (cmbDataWindowUnits.Text == "Hr")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(slice, 0, 0);
                }
                if (cmbDataWindowUnits.Text == "Sec")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(0, 0, slice);
                }

                /*
                dateTimeDataWindowStart.Value = DateTime.Now.Subtract(dataWindow);
                RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                rcs.DataWindowObj.StartTime = DateTime.Now.Subtract(dataWindow);*/
                dateTimeDataWindowEnd.Value = dateTimeDataWindowStart.Value.Add(dataWindow);
            }

		}

//        private void _timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
//        {
////			InputOutputViews.sRunStartTime = this.dateTimeDataWindowStart.Value.ToString();
////			InputOutputViews.sRunEndTime = this.dateTimeDataWindowEnd.Value.ToString();
////			InputOutputViews o=new InputOutputViews();
////			o.textBox3.Text=this.dateTimeDataWindowStart.Value.ToString();

//        }

		private void dateTimeDataWindowEnd_ValueChanged(object sender, System.EventArgs e)
		{
            
            /*
            if (_isEndDateTimeClose)
            {
                if (_timeWnd == null)
                {
                    _timeWnd = TimeWnd;
                }
                if (_timeWnd != null)
                {
                    //				_timeWnd.txtEndTime.Text = this.dateTimeDataWindowEnd.Value.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                }
                
                TimeSpan dataWindow = new TimeSpan(0);
                dataWindow = dateTimeDataWindowEnd.Value.Subtract(dateTimeDataWindowStart.Value);
                if (dataWindow.TotalHours < 0.0 || dataWindow.TotalSeconds < 0.0 || dataWindow.TotalMinutes < 0.0)
                {
                    LRRMessagBox.ShowMessage(_app.MainFrame, "SID_INVALID_ETIME", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Warning); // Message changed by Sandeep as it was wrong
                    RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    dateTimeDataWindowEnd.Value = rcs.DataWindowObj.EndTime;
                    return;
                }
                if (dataWindow.TotalHours > 24.0)
                {
                    LRRMessagBox.ShowMessage(_app.MainFrame, "SID_INVALID_TIME", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Warning); // Message changed by Sandeep as it was wrong
                    RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    dateTimeDataWindowEnd.Value = rcs.DataWindowObj.EndTime;
                    return;
                }
                else
                {
                    if (dataWindow.TotalSeconds < 60.0)
                    {
                        cmbDataWindowUnits.Text = "Sec";
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalSeconds).ToString();
                    }
                    else if (dataWindow.TotalMinutes < 60.0)
                    {
                        cmbDataWindowUnits.Text = "Min";
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalMinutes).ToString();
                    }
                    else
                    {
                        cmbDataWindowUnits.Text = "Hr";
                        txtDataWindowSize.Text = Convert.ToInt16(dataWindow.TotalHours).ToString();
                    }
                    RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                    if (rcs.DataWindowObj.EndTime != dateTimeDataWindowEnd.Value)
                        rcs.DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;
                    if (rcs.DataWindowObj.DataWindowSize != Convert.ToInt16(txtDataWindowSize.Text))
                        rcs.DataWindowObj.DataWindowSize = Convert.ToInt16(txtDataWindowSize.Text);
                    if (rcs.DataWindowObj.DataWindowUnits != cmbDataWindowUnits.Text)
                        rcs.DataWindowObj.DataWindowUnits = cmbDataWindowUnits.Text;
                }
                
                
            }
            */

		}

		#region Properties
		public TimeWindow TimeWnd
		{
			get{return timeWindow;}
			set
			{
				timeWindow = value;
			}
		}

		public TimeWindow timeWindow;
		#endregion

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			//isAborted = true;
			//this.Enabled = false;
			_runController.Stop();
		}

		private void checkedListBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			
		}

		/// <summary>
		/// This method holds the logic for the user 
		/// interface settings
		/// </summary>
		private void SetUI()
		{
			if(rbCurrent.Checked && rbCurrent.Enabled) //Current is selected
			{
				//dateTimeDataWindowEnd.Enabled = false;
				chkTandemRuns.Enabled = false;
				txtTandemOffset.Enabled = false;
				cmbTandemOffsetUnits.Enabled = false;
				dateTimeSeriesStart.Enabled = false;
				dateTimeSeriesEnd.Enabled = false;
				txtLag.Enabled = true;
				cmbLagUnits.Enabled = true;
				dateTimePickerAutoRunEnd.Enabled = true;
				dateTimePickerAutoRunStart.Enabled = true;

			}
			else if(rbHistorical.Checked)
			{
				if((cmbDataSourceType.Text != LRRHeaderText.GetHeaderString("SID_TUNING")) && (cmbDataSourceType.Text != LRRHeaderText.GetHeaderString("SID_OFFLINE")))
				{
					txtLag.Enabled = false;
					cmbLagUnits.Enabled = false;
					dateTimeSeriesStart.Enabled = false;
					dateTimeSeriesEnd.Enabled = false;
					dateTimePickerAutoRunEnd.Enabled = false;
					dateTimePickerAutoRunStart.Enabled = false;
					chkAutoRunBoundries.Enabled = false;
				}

			}

			if(chkAutoRun.Checked)
			{
				btnRunAdvance.Enabled= false;
				btnRunEnteredWindow.Enabled = false;
				BtnRunNextStep.Enabled = false;
				chkAutoRun.Text = LRRHeaderText.GetHeaderString("SID_AUTORUN_ON");
				chkAutoRunBoundries.Enabled = true;
				dateTimePickerAutoRunEnd.Enabled = true;
				dateTimePickerAutoRunStart.Enabled = true;
			}
			else
			{
				btnRunAdvance.Enabled= true;
				btnRunEnteredWindow.Enabled = true;
				BtnRunNextStep.Enabled = true;
				chkAutoRun.Text = LRRHeaderText.GetHeaderString("SID_AUTORUN_OFF");
				chkAutoRunBoundries.Enabled = false;
				dateTimePickerAutoRunEnd.Enabled = false;
				dateTimePickerAutoRunStart.Enabled = false;
			}

			if(chkTimeIncrement.Checked)
			{
				txtTimeIncrment.Enabled = true;
				cmbIncrementUnits.Enabled = true;
			}
			else
			{
				txtTimeIncrment.Enabled = false;
				cmbIncrementUnits.Enabled = false;
			}

			if(chkAutoRunBoundries.Enabled == true)
			{
				if(chkAutoRunBoundries.Checked)
				{
					dateTimePickerAutoRunEnd.Enabled = true;
					dateTimePickerAutoRunStart.Enabled = true;
				}
				else
				{
					dateTimePickerAutoRunEnd.Enabled = false;
					dateTimePickerAutoRunStart.Enabled = false;
				}
			}
			else
			{
				dateTimePickerAutoRunEnd.Enabled = false;
				dateTimePickerAutoRunStart.Enabled = false;
			}

			if(rbSequentialDataSets.Checked && (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING") || cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE")))
			{
				txtDataWindowSize.Enabled = false;
				cmbDataWindowUnits.Enabled = false;
				dateTimeDataWindowStart.Enabled = false;
				dateTimePickerAutoRunEnd.Enabled = false;
				dateTimePickerAutoRunStart.Enabled = false;
				chkAutoRunBoundries.Enabled = false;
			}

			if(rbRandomSets.Checked && (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING") || cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE")))
			{
				txtDataWindowSize.Enabled = false;
				cmbDataWindowUnits.Enabled = false;
				dateTimeDataWindowStart.Enabled = false;
				dateTimePickerAutoRunEnd.Enabled = false;
				dateTimePickerAutoRunStart.Enabled = false;
				chkAutoRunBoundries.Enabled = false;
			}

			if(chkTimeIncrement.Checked && (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING") || cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE")))
			{
				txtDataWindowSize.Enabled = true;
				cmbDataWindowUnits.Enabled = true;
				dateTimeDataWindowStart.Enabled = true;
			}
			if((cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING")) || (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_OFFLINE")))
			{
                
				btnRunAdvance.Enabled = false;
				if(chkAutoRun.Checked == false)
				{
					chkTimeIncrement.Checked = true;
					_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].RunSchedulesObj.TimeIncrementFlag = true;
					rbSequentialDataSets.Enabled = false;
					rbRandomSets.Enabled = false;
				}
				else
				{
					//chkTimeIncrement.Checked = true;
					rbSequentialDataSets.Enabled = true;
					rbRandomSets.Enabled = true;

				}
			}
			else
			{
                
				//chkTimeIncrement.Checked = true;
				rbSequentialDataSets.Enabled = false;
				rbRandomSets.Enabled = false;
				if(chkAutoRun.Checked == true)
				{
					btnRunAdvance.Enabled = false;
				}
				else
				{
					btnRunAdvance.Enabled = true;
				}
			}
            if (cmbDataSourceType.Text == LRRHeaderText.GetHeaderString("SID_TUNING") && chkAutoRun.Checked)
            {
                btnInitializeModels.Enabled = true;
            }
            else
            {
                btnInitializeModels.Enabled = false;
            }
			Validate();
		}

		

		private void rbHistorical_CheckedChanged(object sender, System.EventArgs e)
		{
			SetUI();
		}

		private void chkAutoRunBoundries_CheckedChanged(object sender, System.EventArgs e)
		{
			SetUI();
		}


		private void btnRunEnteredWindow_Click(object sender, System.EventArgs e)
		{
			/*string runID = RecordRunActivity();
			//this.Enabled = false;
			this.panel1.Enabled = false;
			//SetControlsEnableState(this.Controls[0],false);
			_runController.Start(RunTypeEnum.SINGLE_RUN_ENTERED_WINDOW,_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex],runID);
			_lastExecutedMethod = new EventHandler(btnRunEnteredWindow_Click);
			_app.LRRUIManagerObj.ShowRunStatusDialog();*/
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			SetSelectedModes();
			if(RecordRunActivity())
				_app.RunEnteredWindow();
		}

		private void BtnRunNextStep_Click(object sender, System.EventArgs e)
		{
			/*string runID = RecordRunActivity();
			//this.Enabled = false;
			this.panel1.Enabled = false;
			//SetControlsEnableState(this.Controls[0],false);
			if(!_runController.Start(RunTypeEnum.SINGLE_RUN_STEP_NEXT,_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex],runID))
			{
				MessageBox.Show(_runController.ErroMessage);
			}
			else
			{
				_lastExecutedMethod = new EventHandler(BtnRunNextStep_Click);
				_app.LRRUIManagerObj.ShowRunStatusDialog();
			}*/
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			SetSelectedModes();
			if(RecordRunActivity())
				_app.RunNextStep();
		}

		private void btnRunAdvance_Click(object sender, System.EventArgs e)
		{
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			SetSelectedModes();
			if(RecordRunActivity())
				_app.RunAdvanceToNow();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].DataWindowObj.StartTime = DateTime.Now;
			
		}

		private void _runController_RunStarted(RunStartedEventArgs e)
		{
            TrackingController.TrackUIUpdate = false;
            dateTimeDataWindowStart.Value = DateTime.Parse(e.StartTime, Symcon.BusinessObjects.SymConverter.Culture); // This line is moved up by Sandeep as it was showing wrong message on Autorun.
			dateTimeDataWindowEnd.Value = DateTime.Parse(e.EndTime,Symcon.BusinessObjects.SymConverter.Culture);
			_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].DataWindowObj.StartTime = dateTimeDataWindowStart.Value;
			_runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex].DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;

		}

		private void chkAutoRun_CheckStateChanged(object sender, System.EventArgs e)
		{
			if(chkAutoRun.Checked)
			{
				chkAutoRun.BackColor = Color.Red;
			}
			else
			{
				chkAutoRun.BackColor = Color.FromKnownColor(KnownColor.Control);
			}

			SetUI();
		}

		private bool RecordRunActivity()
		{
			//If Record Values is not checked,return true
			if(!chkRecordValues.Checked)
				return true;
			LRRRunRecord lrrRunRecord = cmbRecordRun.SelectedItem as LRRRunRecord;
			//Set run record details
			if(lrrRunRecord != null)
			{
				_app.RecordingValuesManagerObj.RunRecordID = lrrRunRecord.RunID;
				_app.RecordingValuesManagerObj.RunRecordName = lrrRunRecord.RunName;
				_app.RecordingValuesManagerObj.RunRecordDesc = lrrRunRecord.RunDescription;
				return true;
			}
			else
			{
				if(cmbRecordRun.Text == null || cmbRecordRun.Text.Trim() == "")
				{
					LRRMessagBox.ShowMessage("SID_VALIDNAME","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
					cmbRecordRun.Focus();
					return false;
				}
				else
				{
					_app.RecordingValuesManagerObj.RunRecordID = null;
					_app.RecordingValuesManagerObj.RunRecordName = cmbRecordRun.Text;
					_app.RecordingValuesManagerObj.RunRecordDesc = txtDesc.Text;
					return true;
				}
			}
		}
		
		/// <summary>
		/// Sets the Record Run Activity UI
		/// </summary>
		/// <param name="state"></param>
		private void SetRecordRunActivityUI(bool state)
		{
			cmbRecordRun.Enabled = state;
			txtDesc.Enabled = state;
		}
		
		/// <summary>
		/// Enable/Disable Record Run Desc Text Box
		/// </summary>
		private void SetRecordRunDesc()
		{
			IEnumerator lrrRecordEnum = _lrrRunRecords.GetEnumerator();
			while(lrrRecordEnum.MoveNext())
			{
				LRRRunRecord lrrRunRecord = lrrRecordEnum.Current as LRRRunRecord;
				if(lrrRunRecord.RunName == cmbRecordRun.Text)
				{
					txtDesc.Text = lrrRunRecord.RunDescription;
					txtDesc.Enabled = false;
					return;
				}
			}
			
			txtDesc.Text = "";
			txtDesc.Enabled = true;
		}

		private void _runController_RunStopped(object sender, EventArgs e)
		{
			this.panel1.Enabled = true;
            TrackingController.TrackUIUpdate = false;
		}

		private void chkTimeIncrement_CheckStateChanged(object sender, System.EventArgs e)
		{
			SetUI();
		}

		#region ILRRUIContainer Members
		public new void Refresh()
		{
		}
		public void Save()
		{
		}
		public void CopyMasterProperties()
		{
		}
		public void Paste()
		{
		}
		public void Copy()
		{
		}
		public void Print()
		{
		}
		public void Delete()
		{
		}
		public void ArrangeColumns()
		{
		}
		public void ClearFilter()
		{
		}
		public void InsertNewRows()//Inserts New rows 
		{
		}
		public void ImportToExcel()
		{
		}
		public void Export()
		{
		}
		public void SelectionPaste()
		{
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		//Methods Suported
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsCopy()
		{
			return false;
		}
		public bool SupportsPaste()
		{
			return false;
		}
		public bool SupportsExport()
		{
			return true;
		}
		public bool SupportsSave()
		{
			return true;
		}
		public bool SupportsRefresh()
		{
			return false;
		}
		public bool SupportsDelete()
		{
			return false;
		}
		public bool SupportsPrint()
		{
			return false;
		}
		public bool SupportsArrangeColumns()
		{
			return false;
		}
		public bool SupportsClearFilter()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			return false;
		}
		public bool SupportsImportToExcel()
		{
			return false;
		}
		public bool SupportsSelectionPaste()
		{
			return false;
		}
		public bool SupportsLevel()
		{
			return false;
		}

		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add RunControlPanelDialog.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add RunControlPanelDialog.SupportsClearSort implementation
			return false;
		}

		#endregion

		private void cmbDataSourceType_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			e.Handled = true;
		}

		private void cmbDataSourceType_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			e.Handled = true;
		}

		private void cmbIncrementUnits_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			e.Handled = true;
		}

		private void cmbIncrementUnits_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			e.Handled = true;
		}

		private void cmbLagUnits_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			e.Handled = true;
		}

		private void cmbLagUnits_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			e.Handled = true;
		}

		private void cmbDataWindowUnits_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			e.Handled = true;
		}

		private void cmbDataWindowUnits_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			e.Handled = true;
		}
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add RunControlPanelDialog.PrintPreview implementation
		}

		#endregion


		private void rbSequentialDataSets_CheckedChanged(object sender, System.EventArgs e)
		{
			
		}

		private void txtDataWindowSize_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{

			/*TimeSpan dataWindow = new TimeSpan(0);
			if(cmbDataWindowUnits.Text == "Min")
			{
				int slice = Int32.Parse(txtDataWindowSize.Text,Symcon.BusinessObjects.SymConverter.Culture);
				dataWindow = new TimeSpan(0,slice,0);
			}
			if(cmbDataWindowUnits.Text == "Hr")
			{
				int slice = Int32.Parse(txtDataWindowSize.Text,Symcon.BusinessObjects.SymConverter.Culture);
				dataWindow = new TimeSpan(slice,0,0);
			}
			if(cmbDataWindowUnits.Text == "Sec")
			{
				int slice = Int32.Parse(txtDataWindowSize.Text,Symcon.BusinessObjects.SymConverter.Culture);
				dataWindow = new TimeSpan(0,0,slice);
			}
			dateTimeDataWindowEnd.Value = dateTimeDataWindowStart.Value.Add(dataWindow);
			RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
			rcs.DataWindowObj.EndTime  = dateTimeDataWindowEnd.Value;*/
			
		
		}

		private void dateTimeDataWindowStart_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
            // if condition added by ashwin
            if (txtDataWindowSize.Text != "")
            {
                TimeSpan dataWindow = new TimeSpan(0);
                if (cmbDataWindowUnits.Text == "Min")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(0, slice, 0);
                }
                if (cmbDataWindowUnits.Text == "Hr")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(slice, 0, 0);
                }
                if (cmbDataWindowUnits.Text == "Sec")
                {
                    int slice = Int32.Parse(txtDataWindowSize.Text, Symcon.BusinessObjects.SymConverter.Culture);
                    dataWindow = new TimeSpan(0, 0, slice);
                }
                dateTimeDataWindowEnd.Value = dateTimeDataWindowStart.Value.Add(dataWindow);
                RunControlSet rcs = _runOptionsObj.RunControlSetsObj[cmbRunControlSet.SelectedIndex];
                rcs.DataWindowObj.EndTime = dateTimeDataWindowEnd.Value;
            }
		
		}


		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add RunControlPanelDialog.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add RunControlPanelDialog.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add RunControlPanelDialog.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		private void chkRecordValues_CheckedChanged(object sender, System.EventArgs e)
		{
			//Check the Record Activity State
			bool recordActivityState = chkRecordValues.Checked;

			//Enable/Disable the record activity options
			if(recordActivityState)
			{
				SetRecordRunActivityUI(true);
				SetRecordRunDesc();
			}
			else
				SetRecordRunActivityUI(false);
		}

		private void cmbRecordRun_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			LRRRunRecord lrrRunRecord = cmbRecordRun.SelectedItem as LRRRunRecord;
			if(lrrRunRecord != null)
			{
				txtDesc.Text = lrrRunRecord.RunDescription;
				txtDesc.Enabled = false;
			}
		}

		private void cmbRecordRun_TextChanged(object sender, System.EventArgs e)
		{
			SetRecordRunDesc();
		}

		private void RunControlPanelDialog_Activated(object sender, System.EventArgs e)
		{
			if(_lrrRunRecords.Count > 0)
			{
				//				cmbRecordRun.SelectedItem = _lrrRunRecords[0];
				cmbRecordRun.SelectedIndex = 0;
			}
		}
		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add RunControlPanelDialog.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add RunControlPanelDialog.RightColMovement implementation
		}

		#endregion

		private void txtDesc_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if(txtDesc.Text.Length >254)
			{
				LRRMessagBox.ShowMessage("SID_RUN_CHARAC","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
			}
		}
		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add RunControlPanelDialog.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add RunControlPanelDialog.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add RunControlPanelDialog.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add RunControlPanelDialog.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add RunControlPanelDialog.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add RunControlPanelDialog.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add RunControlPanelDialog.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add RunControlPanelDialog.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add RunControlPanelDialog.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add RunControlPanelDialog.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add RunControlPanelDialog.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add RunControlPanelDialog.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private void chkAutoRun_CheckedChanged(object sender, System.EventArgs e)
		{
		
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add RunControlPanelDialog.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		private void gridModes_TableControlCurrentCellChanged(object sender, GridTableControlEventArgs e)
		{
			LRRMode mode = e.TableControl.Table.CurrentRecord.GetData() as LRRMode;
			bool isSelected = false;
			object[] objModes = _unBoundModes.GetSelectedRecords();
			ArrayList arrSelModes = new ArrayList();
			for(int i= 0; i < objModes.Length;i++)
			{
				LRRMode objMode = objModes[i] as LRRMode;
				if(objMode.ModeId == mode.ModeId)
					isSelected = true;
				arrSelModes.Add(objMode.ModeId);
			}
	
			if(!isSelected)
			{
				//If mode is System Status,check Meas Mode
				if(mode.ModeId == "2")
				{
					LRRMode objMeasMode = _lrrModes.GetModeByID("1");
					_unBoundModes.SetRecord(objMeasMode,true);
				}
				//If mode is Scenarios,check Meas and System Status mode
				else if(mode.ModeId == "3")
				{
					LRRMode objMeasMode = _lrrModes.GetModeByID("1");
					_unBoundModes.SetRecord(objMeasMode,true);

					LRRMode objSSMode = _lrrModes.GetModeByID("2");
					_unBoundModes.SetRecord(objSSMode,true);
				}
			}
			else
			{
				if(mode.ModeId == "2")
				{
					if(arrSelModes.Contains("3"))
					{
//						MessageBox.Show("UnChecking this Mode not allowed.");
						e.TableControl.CurrentCell.Deactivate(true);
					}
				}
				if(mode.ModeId == "1")
				{
					if(arrSelModes.Contains("2") || arrSelModes.Contains("3"))
					{
//						MessageBox.Show("UnChecking this Mode not allowed.");
						e.TableControl.CurrentCell.Deactivate(true);
					}
				}
			}
			gridModes.Refresh();
		}

		private void chkSaveDataSets_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkSaveDataSets.Checked)
			{
				chkEnableBackfilling.Enabled = true;
			}
			else if(!chkSaveOfflinehistorian.Checked)
			{
				chkEnableBackfilling.Enabled = false;
				chkEnableBackfilling.Checked = false;
			}
		}

		public void chkSaveDataSets_SetText()
		{
			string sActivTuningDBName = "???";
            string sOnlinePlantDataName = "???";
			if(_lrrOptions!=null)
			{
				LRRTuningConnections objTuningConns = _lrrOptions.TuningConnectionObj;
                LRROfflineConnections objOfflineHisCons = _lrrOptions.OfflineConnectionObj;
				if(objTuningConns != null)
				{
					LRRTuningConnection objActiveTuningDB = objTuningConns.GetActiveTuningDB();
					if(objActiveTuningDB !=null)
					{
						if(objActiveTuningDB.DatabaseName != null && objActiveTuningDB.DatabaseName != "")
							sActivTuningDBName = objActiveTuningDB.DatabaseName;
					}
				}
                if (objOfflineHisCons != null)
                {
                    LRROfflineConnection objActiveOflineDB = objOfflineHisCons.GetActiveOfflineDB();
                    if (objActiveOflineDB != null)
                    {
                        if (objActiveOflineDB.DatabaseName != null && objActiveOflineDB.DatabaseName != "")
                        {
                            sOnlinePlantDataName = objActiveOflineDB.DatabaseName;
                        }
                    }
                }
			}
			chkSaveDataSets.Text = chkSaveDataSets.Text.Replace("{0:S}",sActivTuningDBName);
            chkSaveOfflinehistorian.Text = chkSaveOfflinehistorian.Text.Replace("{0:S}", sOnlinePlantDataName);
		}

        private void btnInitializeModels_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(LRRHeaderText.GetHeaderString("SID_TUNING_TOOL_CHECK1"), LRRHeaderText.GetHeaderString("SID_WARNING") + "!", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.Yes)
            {
                TuningToolSettingsDialog tuningToolSettingsDialog = new TuningToolSettingsDialog();
                if (tuningToolSettingsDialog.ShowDialog() == DialogResult.OK)
                {
                    if (MessageBox.Show(LRRHeaderText.GetHeaderString("SID_TUNING_TOOL_CHECK2"), LRRHeaderText.GetHeaderString("SID_WARNING") + "!", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.Yes)
                    {
                        //chkAutoRun.Checked = true;
                        if (_app.ActiveRunControlSet.LeastSqureMode)
                        {
                            

                            if(_app.ActiveRunControlSet.NumberOfPasses >0)
                            {
                                _app.ActiveRunControlSet.IfRunTuningTool = true;

                                // Loading of TuningTool
                                string tuningToolWBFileName = Symcon.LightRidge.ExecutionEngine.Model.LRREEModel.ModelConfigs.GetValueForParam("TuningToolWB");
                                _app.SymExcelWrapperObj.OpenWorkBook(tuningToolWBFileName);

                                _app.DoRun();
                                _numberOfPasses = 1;
                                try
                                {
                                    _app.RunControllerObj.RunCompleted -= new EventHandler(RunControllerObj_RunCompleted);
                                    _app.RunControllerObj.RunStopped -= new EventHandler(RunControllerObj_RunStopped);
                                }
                                catch
                                { 
                                }
                                _app.RunControllerObj.RunCompleted += new EventHandler(RunControllerObj_RunCompleted);
                                _app.RunControllerObj.RunStopped += new EventHandler(RunControllerObj_RunStopped);
                            }
                        }
                        else
                        {
                            _app.ActiveRunControlSet.IfRunTuningTool = true;

                            // Loading of TuningTool
                            string tuningToolWBFileName = Symcon.LightRidge.ExecutionEngine.Model.LRREEModel.ModelConfigs.GetValueForParam("TuningToolWB");
                            _app.SymExcelWrapperObj.OpenWorkBook(tuningToolWBFileName);

                            _app.DoRun();
                            try
                            {
                                _app.RunControllerObj.RunCompleted -= new EventHandler(RunControllerObj_RunCompleted);
                                _app.RunControllerObj.RunStopped -= new EventHandler(RunControllerObj_RunStopped);
                            }
                            catch
                            {
                            }
                            _app.RunControllerObj.RunCompleted += new EventHandler(RunControllerObj_RunCompleted);
                            _app.RunControllerObj.RunStopped += new EventHandler(RunControllerObj_RunStopped);
                        }
                    }
                }
            }
        }

        void RunControllerObj_RunStopped(object sender, EventArgs e)
        {
            try
            {
                _app.RunControllerObj.RunCompleted -= new EventHandler(RunControllerObj_RunCompleted);
            }
            catch
            { 
            }

            _app.ActiveRunControlSet.IfRunTuningTool = false;

            string tuningToolWBFileName = Symcon.LightRidge.ExecutionEngine.Model.LRREEModel.ModelConfigs.GetValueForParam("TuningToolWB");
            _app.SymExcelWrapperObj.SaveAndCloseWorkBook(tuningToolWBFileName);
        }

        void RunControllerObj_RunCompleted(object sender, EventArgs e)
        {
            if (_app.ActiveRunControlSet.LeastSqureMode)
            {
                _numberOfPasses++;
                if (_numberOfPasses <= _app.ActiveRunControlSet.NumberOfPasses)
                {
                    _app.DoRun();
                }
                else
                {
                    _app.ActiveRunControlSet.IfRunTuningTool = false;

                    string tuningToolWBFileName = Symcon.LightRidge.ExecutionEngine.Model.LRREEModel.ModelConfigs.GetValueForParam("TuningToolWB");
                    _app.SymExcelWrapperObj.SaveAndCloseWorkBook(tuningToolWBFileName);
                }
            }
            else
            {
                _app.ActiveRunControlSet.IfRunTuningTool = false;

                string tuningToolWBFileName = Symcon.LightRidge.ExecutionEngine.Model.LRREEModel.ModelConfigs.GetValueForParam("TuningToolWB");
                _app.SymExcelWrapperObj.SaveAndCloseWorkBook(tuningToolWBFileName);
            }
        }

        private void chkSaveOfflinehistorian_CheckedChanged(object sender, EventArgs e)
        {
            if (chkSaveOfflinehistorian.Checked)
            {
                chkEnableBackfilling.Enabled = true;
            }
            else if(!chkSaveDataSets.Checked)
            {
                chkEnableBackfilling.Enabled = false;
                chkEnableBackfilling.Checked = false;
            }
        }


	}

	public delegate void SetLabelDel(string text);
}
