using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Utils.HeaderDispatcher ; 
 
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for RunStatusDialog.
	/// </summary>
	public class RunStatusDialog : System.Windows.Forms.Form
	{
		#region Fields
		private System.Windows.Forms.ProgressBar progressBar1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button cmdPause;
		private System.Windows.Forms.Button cmdStop;
		private System.Windows.Forms.Label lblStartTime;
		private System.Windows.Forms.Label lblEndtime;
		private System.Windows.Forms.Label lblPoint;

		private LRRApp					_app = null;
		private bool					_bStopFlag = false;

		#endregion
		private System.Windows.Forms.Button cmdRunAdvancedToNow;
		private System.Windows.Forms.Button cmdRunNextStep;
		private System.Windows.Forms.Button cmdRunEnteredWindow;
		private System.Windows.Forms.ToolTip toolTipButton;
		private System.Windows.Forms.Label lblDataWnd;
		private System.Windows.Forms.Label lblDataWindowSize;
		private System.Windows.Forms.Label lblTimeToRun;
		private System.Windows.Forms.ImageList smallImageList;
		private System.ComponentModel.IContainer components;

		public RunStatusDialog()
		{
			InitializeComponent();
			
			InternationalizationUtils.GetControlText(this,null);  
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			_app.RunControllerObj.ReceivedPoint+=new ReceivedPointDataDel(RunControllerObj_ReceivedPoint);
			_app.RunControllerObj.RunCompleted+=new EventHandler(RunControllerObj_RunCompleted);
			_app.RunControllerObj.RunStarted+=new RunStartedDel(RunControllerObj_RunStarted);
			_app.RunControllerObj.FeedBack+=new GiveFeedbackDel(RunControllerObj_FeedBack);

			this.Activated+=new EventHandler(RunStatusDialog_Activated);
			//_runController.ReceivedPoint+=new ReceivedPointDataDel(_runController_ReceivedPoint);
			//_runController.RunCompleted+=new EventHandler(_runController_RunCompleted);

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RunStatusDialog));
            this.cmdRunNextStep = new System.Windows.Forms.Button();
            this.smallImageList = new System.Windows.Forms.ImageList(this.components);
            this.cmdPause = new System.Windows.Forms.Button();
            this.cmdStop = new System.Windows.Forms.Button();
            this.progressBar1 = new System.Windows.Forms.ProgressBar();
            this.lblStartTime = new System.Windows.Forms.Label();
            this.lblEndtime = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.lblPoint = new System.Windows.Forms.Label();
            this.cmdRunAdvancedToNow = new System.Windows.Forms.Button();
            this.cmdRunEnteredWindow = new System.Windows.Forms.Button();
            this.toolTipButton = new System.Windows.Forms.ToolTip(this.components);
            this.lblDataWnd = new System.Windows.Forms.Label();
            this.lblDataWindowSize = new System.Windows.Forms.Label();
            this.lblTimeToRun = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // cmdRunNextStep
            // 
            this.cmdRunNextStep.ImageIndex = 65;
            this.cmdRunNextStep.ImageList = this.smallImageList;
            this.cmdRunNextStep.Location = new System.Drawing.Point(328, 80);
            this.cmdRunNextStep.Name = "cmdRunNextStep";
            this.cmdRunNextStep.Size = new System.Drawing.Size(40, 32);
            this.cmdRunNextStep.TabIndex = 0;
            this.toolTipButton.SetToolTip(this.cmdRunNextStep, "Run[NextStep]");
            this.cmdRunNextStep.Click += new System.EventHandler(this.cmdRunNextStep_Click);
            // 
            // smallImageList
            // 
            this.smallImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smallImageList.ImageStream")));
            this.smallImageList.TransparentColor = System.Drawing.Color.Transparent;
            this.smallImageList.Images.SetKeyName(0, "");
            this.smallImageList.Images.SetKeyName(1, "");
            this.smallImageList.Images.SetKeyName(2, "");
            this.smallImageList.Images.SetKeyName(3, "");
            this.smallImageList.Images.SetKeyName(4, "");
            this.smallImageList.Images.SetKeyName(5, "");
            this.smallImageList.Images.SetKeyName(6, "");
            this.smallImageList.Images.SetKeyName(7, "");
            this.smallImageList.Images.SetKeyName(8, "");
            this.smallImageList.Images.SetKeyName(9, "");
            this.smallImageList.Images.SetKeyName(10, "");
            this.smallImageList.Images.SetKeyName(11, "");
            this.smallImageList.Images.SetKeyName(12, "");
            this.smallImageList.Images.SetKeyName(13, "");
            this.smallImageList.Images.SetKeyName(14, "");
            this.smallImageList.Images.SetKeyName(15, "");
            this.smallImageList.Images.SetKeyName(16, "");
            this.smallImageList.Images.SetKeyName(17, "");
            this.smallImageList.Images.SetKeyName(18, "");
            this.smallImageList.Images.SetKeyName(19, "");
            this.smallImageList.Images.SetKeyName(20, "");
            this.smallImageList.Images.SetKeyName(21, "");
            this.smallImageList.Images.SetKeyName(22, "");
            this.smallImageList.Images.SetKeyName(23, "");
            this.smallImageList.Images.SetKeyName(24, "");
            this.smallImageList.Images.SetKeyName(25, "");
            this.smallImageList.Images.SetKeyName(26, "");
            this.smallImageList.Images.SetKeyName(27, "");
            this.smallImageList.Images.SetKeyName(28, "");
            this.smallImageList.Images.SetKeyName(29, "");
            this.smallImageList.Images.SetKeyName(30, "");
            this.smallImageList.Images.SetKeyName(31, "");
            this.smallImageList.Images.SetKeyName(32, "");
            this.smallImageList.Images.SetKeyName(33, "");
            this.smallImageList.Images.SetKeyName(34, "");
            this.smallImageList.Images.SetKeyName(35, "");
            this.smallImageList.Images.SetKeyName(36, "");
            this.smallImageList.Images.SetKeyName(37, "");
            this.smallImageList.Images.SetKeyName(38, "");
            this.smallImageList.Images.SetKeyName(39, "");
            this.smallImageList.Images.SetKeyName(40, "");
            this.smallImageList.Images.SetKeyName(41, "");
            this.smallImageList.Images.SetKeyName(42, "");
            this.smallImageList.Images.SetKeyName(43, "");
            this.smallImageList.Images.SetKeyName(44, "");
            this.smallImageList.Images.SetKeyName(45, "");
            this.smallImageList.Images.SetKeyName(46, "");
            this.smallImageList.Images.SetKeyName(47, "");
            this.smallImageList.Images.SetKeyName(48, "");
            this.smallImageList.Images.SetKeyName(49, "");
            this.smallImageList.Images.SetKeyName(50, "");
            this.smallImageList.Images.SetKeyName(51, "");
            this.smallImageList.Images.SetKeyName(52, "");
            this.smallImageList.Images.SetKeyName(53, "");
            this.smallImageList.Images.SetKeyName(54, "");
            this.smallImageList.Images.SetKeyName(55, "");
            this.smallImageList.Images.SetKeyName(56, "");
            this.smallImageList.Images.SetKeyName(57, "");
            this.smallImageList.Images.SetKeyName(58, "");
            this.smallImageList.Images.SetKeyName(59, "");
            this.smallImageList.Images.SetKeyName(60, "");
            this.smallImageList.Images.SetKeyName(61, "");
            this.smallImageList.Images.SetKeyName(62, "");
            this.smallImageList.Images.SetKeyName(63, "");
            this.smallImageList.Images.SetKeyName(64, "");
            this.smallImageList.Images.SetKeyName(65, "");
            this.smallImageList.Images.SetKeyName(66, "");
            this.smallImageList.Images.SetKeyName(67, "");
            this.smallImageList.Images.SetKeyName(68, "");
            this.smallImageList.Images.SetKeyName(69, "");
            this.smallImageList.Images.SetKeyName(70, "");
            this.smallImageList.Images.SetKeyName(71, "");
            this.smallImageList.Images.SetKeyName(72, "");
            this.smallImageList.Images.SetKeyName(73, "");
            this.smallImageList.Images.SetKeyName(74, "");
            this.smallImageList.Images.SetKeyName(75, "");
            this.smallImageList.Images.SetKeyName(76, "");
            this.smallImageList.Images.SetKeyName(77, "");
            this.smallImageList.Images.SetKeyName(78, "");
            this.smallImageList.Images.SetKeyName(79, "");
            this.smallImageList.Images.SetKeyName(80, "");
            this.smallImageList.Images.SetKeyName(81, "");
            this.smallImageList.Images.SetKeyName(82, "");
            // 
            // cmdPause
            // 
            this.cmdPause.ImageIndex = 82;
            this.cmdPause.ImageList = this.smallImageList;
            this.cmdPause.Location = new System.Drawing.Point(424, 80);
            this.cmdPause.Name = "cmdPause";
            this.cmdPause.Size = new System.Drawing.Size(40, 32);
            this.cmdPause.TabIndex = 1;
            this.cmdPause.Tag = "Pause";
            this.toolTipButton.SetToolTip(this.cmdPause, "Pause");
            this.cmdPause.Click += new System.EventHandler(this.cmdPause_Click);
            // 
            // cmdStop
            // 
            this.cmdStop.ImageIndex = 58;
            this.cmdStop.ImageList = this.smallImageList;
            this.cmdStop.Location = new System.Drawing.Point(376, 80);
            this.cmdStop.Name = "cmdStop";
            this.cmdStop.Size = new System.Drawing.Size(40, 32);
            this.cmdStop.TabIndex = 2;
            this.toolTipButton.SetToolTip(this.cmdStop, "Stop");
            this.cmdStop.Click += new System.EventHandler(this.cmdStop_Click);
            // 
            // progressBar1
            // 
            this.progressBar1.Location = new System.Drawing.Point(8, 56);
            this.progressBar1.Name = "progressBar1";
            this.progressBar1.Size = new System.Drawing.Size(456, 16);
            this.progressBar1.TabIndex = 3;
            // 
            // lblStartTime
            // 
            this.lblStartTime.Location = new System.Drawing.Point(70, 8);
            this.lblStartTime.Name = "lblStartTime";
            this.lblStartTime.Size = new System.Drawing.Size(137, 16);
            this.lblStartTime.TabIndex = 5;
            // 
            // lblEndtime
            // 
            this.lblEndtime.Location = new System.Drawing.Point(70, 29);
            this.lblEndtime.Name = "lblEndtime";
            this.lblEndtime.Size = new System.Drawing.Size(137, 16);
            this.lblEndtime.TabIndex = 6;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(64, 16);
            this.label1.TabIndex = 7;
            this.label1.Tag = "SID_STARTTIME";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 29);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(64, 16);
            this.label4.TabIndex = 8;
            this.label4.Tag = "SID_ENDTIME";
            // 
            // lblPoint
            // 
            this.lblPoint.Location = new System.Drawing.Point(8, 87);
            this.lblPoint.Name = "lblPoint";
            this.lblPoint.Size = new System.Drawing.Size(168, 32);
            this.lblPoint.TabIndex = 9;
            // 
            // cmdRunAdvancedToNow
            // 
            this.cmdRunAdvancedToNow.ImageIndex = 67;
            this.cmdRunAdvancedToNow.ImageList = this.smallImageList;
            this.cmdRunAdvancedToNow.Location = new System.Drawing.Point(280, 80);
            this.cmdRunAdvancedToNow.Name = "cmdRunAdvancedToNow";
            this.cmdRunAdvancedToNow.Size = new System.Drawing.Size(40, 32);
            this.cmdRunAdvancedToNow.TabIndex = 10;
            this.toolTipButton.SetToolTip(this.cmdRunAdvancedToNow, "Run[Advanced]");
            this.cmdRunAdvancedToNow.Click += new System.EventHandler(this.cmdRunAdvancedToNow_Click);
            // 
            // cmdRunEnteredWindow
            // 
            this.cmdRunEnteredWindow.ImageIndex = 66;
            this.cmdRunEnteredWindow.ImageList = this.smallImageList;
            this.cmdRunEnteredWindow.Location = new System.Drawing.Point(232, 80);
            this.cmdRunEnteredWindow.Name = "cmdRunEnteredWindow";
            this.cmdRunEnteredWindow.Size = new System.Drawing.Size(40, 32);
            this.cmdRunEnteredWindow.TabIndex = 11;
            this.toolTipButton.SetToolTip(this.cmdRunEnteredWindow, "Run[Entered Window]");
            this.cmdRunEnteredWindow.Click += new System.EventHandler(this.cmdRunEnteredWindow_Click);
            // 
            // lblDataWnd
            // 
            this.lblDataWnd.Location = new System.Drawing.Point(207, 8);
            this.lblDataWnd.Name = "lblDataWnd";
            this.lblDataWnd.Size = new System.Drawing.Size(104, 16);
            this.lblDataWnd.TabIndex = 12;
            this.lblDataWnd.Tag = "SID_DATAWINDOWSIZE";
            // 
            // lblDataWindowSize
            // 
            this.lblDataWindowSize.Location = new System.Drawing.Point(312, 8);
            this.lblDataWindowSize.Name = "lblDataWindowSize";
            this.lblDataWindowSize.Size = new System.Drawing.Size(56, 16);
            this.lblDataWindowSize.TabIndex = 13;
            // 
            // lblTimeToRun
            // 
            this.lblTimeToRun.Location = new System.Drawing.Point(207, 29);
            this.lblTimeToRun.Name = "lblTimeToRun";
            this.lblTimeToRun.Size = new System.Drawing.Size(200, 16);
            this.lblTimeToRun.TabIndex = 14;
            // 
            // RunStatusDialog
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(474, 122);
            this.Controls.Add(this.lblTimeToRun);
            this.Controls.Add(this.lblDataWindowSize);
            this.Controls.Add(this.lblDataWnd);
            this.Controls.Add(this.cmdRunEnteredWindow);
            this.Controls.Add(this.cmdRunAdvancedToNow);
            this.Controls.Add(this.lblPoint);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.lblEndtime);
            this.Controls.Add(this.lblStartTime);
            this.Controls.Add(this.progressBar1);
            this.Controls.Add(this.cmdStop);
            this.Controls.Add(this.cmdPause);
            this.Controls.Add(this.cmdRunNextStep);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "RunStatusDialog";
            this.ShowInTaskbar = false;
            this.Text = "Run Status Dialog";
            this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.RunStatusDialog_FormClosing);
            this.ResumeLayout(false);

		}
		#endregion

		private void RunControllerObj_ReceivedPoint(Symcon.LightRidge.BusinessObjects.LRRHistData point, string startTime, string endTime)
		{
			lblPoint.Text = point.HistTag;
			lblPoint.Refresh();

			if(progressBar1.Value < progressBar1.Maximum)
				progressBar1.Value++;
		}

		private void RunControllerObj_RunCompleted(object sender, EventArgs e)
		{
			lblPoint.Text = LRRHeaderText.GetHeaderString("SID_RUN_COMPLETED");
			lblTimeToRun.Text = "";
			if(_bStopFlag)
				this.Close();
		}

        public void SetContentOnDialog(string startTime, string endTime, string dataWindowSize)
        {
            lblPoint.Text = "Processing";
            ResetProgressBar();
            lblStartTime.Text = DateTime.Parse(startTime, Symcon.BusinessObjects.SymConverter.Culture).ToString("dd-MMM-yyyy HH:mm:ss", Symcon.BusinessObjects.SymConverter.Culture);
            lblEndtime.Text = DateTime.Parse(endTime, Symcon.BusinessObjects.SymConverter.Culture).ToString("dd-MMM-yyyy HH:mm:ss", Symcon.BusinessObjects.SymConverter.Culture);
            lblDataWindowSize.Text = dataWindowSize;
            //progressBar1.Maximum = e.TotalPoints;
            //this.Text = LRRHeaderText.GetHeaderString("SID_RUN_STATUS") + e.DatabaseType;
            _bStopFlag = false;
            lblTimeToRun.Text = "";

        }

		private void RunControllerObj_RunStarted(RunStartedEventArgs e)
		{
			lblPoint.Text = "Processing";
			ResetProgressBar();
			lblStartTime.Text = DateTime.Parse(e.StartTime,Symcon.BusinessObjects.SymConverter.Culture).ToString("dd-MMM-yyyy HH:mm:ss",Symcon.BusinessObjects.SymConverter.Culture); 
			lblEndtime.Text = DateTime.Parse(e.EndTime,Symcon.BusinessObjects.SymConverter.Culture).ToString("dd-MMM-yyyy HH:mm:ss",Symcon.BusinessObjects.SymConverter.Culture);
			lblDataWindowSize.Text = e.DataWindowSize.ToString(Symcon.BusinessObjects.SymConverter.Culture) + " " + e.DataWindowUnits;
			progressBar1.Maximum = e.TotalPoints; 
			this.Text = LRRHeaderText.GetHeaderString("SID_RUN_STATUS") + e.DatabaseType;
			_bStopFlag = false;
			lblTimeToRun.Text = "";
		}

		protected override void OnClosing(CancelEventArgs e)
		{
			if(_app.RunControllerObj.InPauseState)
			{	
				base.OnClosing (e);
				e.Cancel = true;
				_app.RunControllerObj.Resume();
				cmdPause.Tag = LRRHeaderText.GetHeaderString("SID_PAUSE");
				cmdPause.ImageIndex = 82;
				toolTipButton.SetToolTip(cmdPause,LRRHeaderText.GetHeaderString("SID_PAUSE"));
				_app.RunControllerObj.Stop();


			}
			else
			{
				base.OnClosing (e);
				e.Cancel = true;
				this.Hide();
			}
			
		}

		private void cmdStop_Click(object sender, System.EventArgs e)
		{
			_app.RunControllerObj.Stop();

			//Set Stop Enabled
			//_app.LRRUIManagerObj.SetStopEnabled(false);

			_bStopFlag = true;
//			if(progressBar1.Value == progressBar1.Maximum)
//				this.Close();
		}

		private void cmdPause_Click(object sender, System.EventArgs e)
		{
			//if in run state Then Pause
			if(cmdPause.Tag.ToString() == LRRHeaderText.GetHeaderString("SID_PAUSE"))
			{
				_app.RunControllerObj.Pause();
				cmdPause.Tag = LRRHeaderText.GetHeaderString("20");
				toolTipButton.SetToolTip(cmdPause,LRRHeaderText.GetHeaderString("20"));
				cmdPause.ImageIndex = 57;
				SetEnabled(false);
				cmdPause.Enabled = true;
				_app.MainFrame.SetStopEnabled(false);
				//this.ControlBox = false;
			}
			else
			{
				//if in Pause State then Run
				_app.RunControllerObj.Resume();
				cmdPause.Tag = LRRHeaderText.GetHeaderString("SID_PAUSE");
				cmdPause.ImageIndex = 82;
				toolTipButton.SetToolTip(cmdPause,LRRHeaderText.GetHeaderString("SID_PAUSE"));
				SetEnabled(true);
				_app.MainFrame.SetStopEnabled(true);
				//this.ControlBox = true;
			}
		}

		public void SetPauseEnabled(bool enabled)
		{
			cmdPause.Enabled = enabled;
		}

		private void SetEnabled(bool enabled)
		{
			cmdRunAdvancedToNow.Enabled = enabled;
			cmdRunEnteredWindow.Enabled = enabled;
			cmdRunNextStep.Enabled		= enabled;
			cmdStop.Enabled				= enabled;
			cmdPause.Enabled			= enabled;
		}

		private void RunControllerObj_FeedBack(string timeRemaining)
		{
            lblTimeToRun.Text = "Waiting (hh:mm:ss):     " + timeRemaining;
            lblPoint.Text = "Waiting for next Cycle";
            SetStopEnabled(true);
		}

        private void RunStatusDialog_Activated(object sender, EventArgs e)
		{
//			progressBar1.Value = 0;
//			progressBar1.Refresh();
		}

		public void ResetProgressBar()
		{
			progressBar1.Value = 0;
			progressBar1.Refresh();
		}

		public void SetMessage(string message)
		{
            SetMeaasgeDel sm = new SetMeaasgeDel(InternalSetMessage);
            this.Invoke(sm, new object[] { message });
		}

        public delegate void SetMeaasgeDel(string message);

        private void InternalSetMessage(string message)
        {
            lblPoint.Text = message;
            this.Refresh();
        }

		public void SetStopEnabled(bool enabled)
		{
			cmdStop.Enabled = enabled;
			cmdStop.Enabled = enabled;

		}

		public void SetRunningState(bool isRunning)
		{
			cmdRunAdvancedToNow.Enabled = !isRunning;
			cmdRunEnteredWindow.Enabled = !isRunning;
			cmdRunNextStep.Enabled = !isRunning;
		}

		private void cmdRunEnteredWindow_Click(object sender, System.EventArgs e)
		{
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			_app.RunEnteredWindow();
		}

		private void cmdRunAdvancedToNow_Click(object sender, System.EventArgs e)
		{
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			_app.RunAdvanceToNow();
		}

		private void cmdRunNextStep_Click(object sender, System.EventArgs e)
		{
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			_app.RunNextStep();
		}

        private void RunStatusDialog_FormClosing(object sender, FormClosingEventArgs e)
        {
            _app.LRRUIManagerObj.RunStatusWindowVisible = false;
           // this.Close();
            
        }


	}
}
