using System;
using System.Messaging;
using System.Threading;
using System.Collections;
using Symcon.LightRidge.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor
{

	public class SubscriberUpdater
	{
		public SubscriberUpdater()
		{
			_serverPoller = new System.Threading.Timer(new System.Threading.TimerCallback(serverPoller_Tick),null,0,100);
			//_serverPollerTimer.Tick+=new EventHandler(_serverPollerTimer_Tick);
			//_serverPollerTimer.Interval = 100;
			//_serverPollerTimer.Start();



		}

		#region Fields

		private Queue							_serverUpdatesQueue = new Queue();
		private	System.Threading.Timer			_serverPoller;
		private System.Windows.Forms.Timer		_serverPollerTimer = new System.Windows.Forms.Timer();
		private bool _update = false;
				
		#endregion


		public Queue ServerUpdateQue
		{
			get
			{
				return _serverUpdatesQueue;
			}
		}

		public bool Update
		{
			get
			{
				return _update;
			}
			set
			{
				_update = value;
			}
		}

		//Handler which gets called when the run gets completed...
		[System.Runtime.CompilerServices.MethodImpl(System.Runtime.CompilerServices.MethodImplOptions.Synchronized)]
		private void serverPoller_Tick(object sender)
		{
			if(_update)
				return;
			while(_serverUpdatesQueue.Count > 0)
			{
				IPropertyValue ipropVal = _serverUpdatesQueue.Dequeue() as IPropertyValue;
				if(ipropVal.GetObjectType() == typeof(Symcon.LightRidge.BusinessObjects.LRRSiteComponentPropertyValue))
				{
					Symcon.LightRidge.PEAdvisor.MessagingClient.PropertyValueChangeForUser(ipropVal.GetPropertyID(),ipropVal.GetPropertyValue(),ipropVal.GetModeID());
				}
				else if(ipropVal.GetObjectType() == typeof(Symcon.LightRidge.BusinessObjects.LRRSiteGroupPropertyQualifierValue))
				{
					LRRSiteGroupPropertyQualifierValue currentPropVal = ipropVal as 	LRRSiteGroupPropertyQualifierValue;
					Symcon.LightRidge.PEAdvisor.MessagingClient.GroupedPropertyValueChangeForUsers(currentPropVal.LookUpQualifierID,currentPropVal.GroupPropertyID,currentPropVal.ModeID,currentPropVal.PropertyValue);
				}
			}

		}

		[System.Runtime.CompilerServices.MethodImpl(System.Runtime.CompilerServices.MethodImplOptions.Synchronized)]
		private void _serverPollerTimer_Tick(object sender, EventArgs e)
		{
//			if(MessagingClient.IsInitialized)
//			{
				if(_serverUpdatesQueue.Count > 0)
				{
					IPropertyValue ipropVal = _serverUpdatesQueue.Dequeue() as IPropertyValue;
					if(ipropVal.GetObjectType() == typeof(Symcon.LightRidge.BusinessObjects.LRRSiteComponentPropertyValue))
					{
						Symcon.LightRidge.PEAdvisor.MessagingClient.PropertyValueChangeForUser(ipropVal.GetPropertyID(),ipropVal.GetPropertyValue(),ipropVal.GetModeID());
					}
					else if(ipropVal.GetObjectType() == typeof(Symcon.LightRidge.BusinessObjects.LRRSiteGroupPropertyQualifierValue))
					{
						LRRSiteGroupPropertyQualifierValue currentPropVal = ipropVal as 	LRRSiteGroupPropertyQualifierValue;
						Symcon.LightRidge.PEAdvisor.MessagingClient.GroupedPropertyValueChangeForUsers(currentPropVal.LookUpQualifierID,currentPropVal.GroupPropertyID,currentPropVal.ModeID,currentPropVal.PropertyValue);
					}
				}
//			}

		}
	}
}
