using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
    public partial class TuningToolSettingsDialog : Form
    {
        #region Constructor
        
        public TuningToolSettingsDialog()
        {
            InitializeComponent();

            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            InternationalizationUtils.GetControlText(this, null);
        }

        #endregion


        #region Fields

        private LRRApp _lrrApp = null;

        #endregion

        
        #region Event Handlers

        private void checkBoxLeastSquareMode_CheckedChanged(object sender, EventArgs e)
        {
            textBoxNoOfPasses.Enabled = checkBoxLeastSquareMode.Checked;

            int noOfPasses;
            if (!checkBoxLeastSquareMode.Checked)
            {
                buttonOK.Enabled = true;
            }
            else if (!int.TryParse(textBoxNoOfPasses.Text, out noOfPasses))
            {
                buttonOK.Enabled = false;
            }
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            try
            {
                _lrrApp.ActiveRunControlSet.LeastSqureMode = checkBoxLeastSquareMode.Checked;

                if (checkBoxLeastSquareMode.Checked)
                {
                    _lrrApp.ActiveRunControlSet.NumberOfPasses = int.Parse(textBoxNoOfPasses.Text);
                }
                _lrrApp.ActiveRunControlSet.CyclesPerDataSet = int.Parse(textBoxCyclesPerDataSet.Text);
                _lrrApp.ActiveRunControlSet.SaveTrackingFileEveryXthRun = int.Parse(textBoxSaveTrackingFileEveryXthRun.Text);
                this.DialogResult = DialogResult.OK;
            }
            catch
            { 
            }
        }

        private void textBoxNoOfPasses_TextChanged(object sender, EventArgs e)
        {
            int noOfPasses;

            if (!int.TryParse(textBoxNoOfPasses.Text, out noOfPasses))
            {
                textBoxNoOfPasses.Text = "";
                buttonOK.Enabled = false;
            }
            else
            {
                buttonOK.Enabled = true;
            }
        }

        #endregion

    }
}