using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.HistorianConnect;
using Symcon.Utils.MessageDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for RunControlPanel.
	/// </summary>
	public class RunControlPanel : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblHistorian;
		private System.Windows.Forms.ComboBox cmdHistorianConnections;
		private System.Windows.Forms.Button cmdAutoRun;
		private System.Windows.Forms.Button cmdRun;
		private System.Windows.Forms.ComboBox cmbEndtime;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox cmbStartTime;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblSavedSets;
		private System.Windows.Forms.ComboBox cmbSelectSet;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public RunControlPanel()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Get the App Object
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			//Initialize the run controller...
			_runController.Initialize();

			_runController.RunCompleted+=new EventHandler(_runController_RunCompleted);

			
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblHistorian = new System.Windows.Forms.Label();
			this.cmdHistorianConnections = new System.Windows.Forms.ComboBox();
			this.cmdAutoRun = new System.Windows.Forms.Button();
			this.cmdRun = new System.Windows.Forms.Button();
			this.cmbEndtime = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.cmbStartTime = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lblSavedSets = new System.Windows.Forms.Label();
			this.cmbSelectSet = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// lblHistorian
			// 
			this.lblHistorian.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(0)), ((System.Byte)(0)));
			this.lblHistorian.Location = new System.Drawing.Point(8, 8);
			this.lblHistorian.Name = "lblHistorian";
			this.lblHistorian.Size = new System.Drawing.Size(56, 24);
			this.lblHistorian.TabIndex = 43;
			this.lblHistorian.Tag = "SID_HISTORIAN";
			this.lblHistorian.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cmdHistorianConnections
			// 
			this.cmdHistorianConnections.BackColor = System.Drawing.SystemColors.Menu;
			this.cmdHistorianConnections.Location = new System.Drawing.Point(72, 8);
			this.cmdHistorianConnections.Name = "cmdHistorianConnections";
			this.cmdHistorianConnections.Size = new System.Drawing.Size(224, 21);
			this.cmdHistorianConnections.TabIndex = 42;
			this.cmdHistorianConnections.SelectedIndexChanged += new System.EventHandler(this.cmdHistorianConnections_SelectedIndexChanged);
			// 
			// cmdAutoRun
			// 
			this.cmdAutoRun.BackColor = System.Drawing.SystemColors.ControlLight;
			this.cmdAutoRun.Location = new System.Drawing.Point(174, 144);
			this.cmdAutoRun.Name = "cmdAutoRun";
			this.cmdAutoRun.Size = new System.Drawing.Size(80, 24);
			this.cmdAutoRun.TabIndex = 41;
			this.cmdAutoRun.Tag = "SID_CLOSE";
			this.cmdAutoRun.Click += new System.EventHandler(this.cmdAutoRun_Click);
			// 
			// cmdRun
			// 
			this.cmdRun.BackColor = System.Drawing.SystemColors.ControlLight;
			this.cmdRun.Location = new System.Drawing.Point(70, 144);
			this.cmdRun.Name = "cmdRun";
			this.cmdRun.Size = new System.Drawing.Size(80, 24);
			this.cmdRun.TabIndex = 40;
			this.cmdRun.Tag = "SID_RUN";
			this.cmdRun.Click += new System.EventHandler(this.cmdRun_Click);
			// 
			// cmbEndtime
			// 
			this.cmbEndtime.Location = new System.Drawing.Point(72, 104);
			this.cmbEndtime.Name = "cmbEndtime";
			this.cmbEndtime.Size = new System.Drawing.Size(224, 21);
			this.cmbEndtime.TabIndex = 39;
			// 
			// label2
			// 
			this.label2.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(0)), ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 24);
			this.label2.TabIndex = 38;
			this.label2.Tag = "SID_ENDTIME";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cmbStartTime
			// 
			this.cmbStartTime.Location = new System.Drawing.Point(72, 72);
			this.cmbStartTime.Name = "cmbStartTime";
			this.cmbStartTime.Size = new System.Drawing.Size(224, 21);
			this.cmbStartTime.TabIndex = 37;
			// 
			// label1
			// 
			this.label1.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(0)), ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 72);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 24);
			this.label1.TabIndex = 36;
			this.label1.Tag = "SID_STARTTIME";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblSavedSets
			// 
			this.lblSavedSets.ForeColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(0)), ((System.Byte)(0)));
			this.lblSavedSets.Location = new System.Drawing.Point(8, 40);
			this.lblSavedSets.Name = "lblSavedSets";
			this.lblSavedSets.Size = new System.Drawing.Size(64, 24);
			this.lblSavedSets.TabIndex = 35;
			this.lblSavedSets.Tag = "SID-SAVEDSETS";
			this.lblSavedSets.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cmbSelectSet
			// 
			this.cmbSelectSet.BackColor = System.Drawing.SystemColors.Menu;
			this.cmbSelectSet.Location = new System.Drawing.Point(72, 40);
			this.cmbSelectSet.Name = "cmbSelectSet";
			this.cmbSelectSet.Size = new System.Drawing.Size(224, 21);
			this.cmbSelectSet.TabIndex = 34;
			// 
			// RunControlPanel
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Control;
			this.ClientSize = new System.Drawing.Size(306, 184);
			this.Controls.Add(this.lblHistorian);
			this.Controls.Add(this.cmdHistorianConnections);
			this.Controls.Add(this.cmdAutoRun);
			this.Controls.Add(this.cmdRun);
			this.Controls.Add(this.cmbEndtime);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.cmbStartTime);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lblSavedSets);
			this.Controls.Add(this.cmbSelectSet);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "RunControlPanel";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_RUNCONTROL";
			this.TopMost = true;
			this.Load += new System.EventHandler(this.RunControlPanel_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdHistorianConnections_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if(isInitializing)
				return;

			_runController.ActiveHistorianIndex = cmdHistorianConnections.SelectedIndex;


			//_lrrSavedSets = _runController.GetActiveHistorian().GetSavedSets();
			//oleDbDataAdapter1.Fill(dataSet11);
			//cmbSelectSet.DataSource = dataSet11.Tables[0];
			cmbSelectSet.DataSource = _lrrSavedSets;
			cmbSelectSet.DisplayMember =  "Name";
			cmbSelectSet.ValueMember = "ID";

			//cmbStartTime.DataSource = dataSet11.Tables[0];
			cmbStartTime.DataSource = _lrrSavedSets;
			cmbStartTime.DisplayMember = "StartTime";

			//cmbEndtime.DataSource = dataSet11.Tables[0];
			cmbEndtime.DataSource = _lrrSavedSets;
			cmbEndtime.DisplayMember = "EndTime";
		}

		#region Fields
		
		private LRRHistSavedSets		_lrrSavedSets = new LRRHistSavedSets();
		private LRRApp					_app;
		private RunController			_runController = new RunController();

		private bool isInitializing = false;

		#endregion

		private void RunControlPanel_Load(object sender, System.EventArgs e)
		{

			isInitializing = true;
			cmdHistorianConnections.DataSource = _runController.HistorianConnections;
			cmdHistorianConnections.DisplayMember = "HistConnectionName";
			isInitializing = false;
			try
			{
				cmdHistorianConnections_SelectedIndexChanged(cmdHistorianConnections,new EventArgs());
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(RunControlPanel),"RunControlPanel_Load Event:"+ex.Message  ,Logger.Level.Debug);
			}
			
		}

		private void cmdRun_Click(object sender, System.EventArgs e)
		{
			cmdRun.Enabled = false;
			//cmdAutoRun.Enabled = false;
			_runController.Run(cmbStartTime.Text,cmbEndtime.Text);
			
		}

		private void _runController_RunCompleted(object sender, EventArgs e)
		{
			LRRMessagBox.ShowMessage(this._app.LRRUIManagerObj.MainFrameObj,"SID_RUNCOMPLATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
			cmdRun.Enabled = true;
		}

		private void cmdAutoRun_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
