using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for SaveQueryForm.
	/// </summary>
	public class SaveQueryForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblQueryName;
		private System.Windows.Forms.TextBox txtQuery;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox txtDescription;
		private System.Windows.Forms.Label lblDescription;

		public string queryName;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TreeView trvGroups;
		private System.Windows.Forms.ContextMenu contMenu;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuAdd;
		private System.Windows.Forms.MenuItem mnuRename;
		private System.Windows.Forms.MenuItem mnuInsert;
		private System.Windows.Forms.CheckBox chkPublish;
        //private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridScreenListView;
		public string queryDesc = "";

		public SaveQueryForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public SaveQueryForm(string queryName,string type)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
//			chkPublish.Enabled = UIAccessController.UIACLController.IsUIEntityAccessible("EnablePublishing");
			InitDataSource();
			txtQuery.Text = queryName;
			_type = type;
			trvGroups.ImageList = _lrrApp.MainFrame.ImageList3;
			trvGroups.ImageIndex = 24;
			trvGroups.SelectedImageIndex = 24;
			PopulateTreeView(trvGroups,_lrrSearchGroupLevels,_lrrSearchGroupLevelLinks);
            trvGroups.Sort();
		}

		public SaveQueryForm(string queryName, string labelText,string type):this(queryName,type)
		{
			this.lblQueryName.Text = labelText;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(SaveQueryForm));
            this.lblQueryName = new System.Windows.Forms.Label();
            this.txtQuery = new System.Windows.Forms.TextBox();
            this.btnOK = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.txtDescription = new System.Windows.Forms.TextBox();
            this.lblDescription = new System.Windows.Forms.Label();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.button1 = new System.Windows.Forms.Button();
            this.trvGroups = new System.Windows.Forms.TreeView();
            this.contMenu = new System.Windows.Forms.ContextMenu();
            this.mnuAdd = new System.Windows.Forms.MenuItem();
            this.mnuRename = new System.Windows.Forms.MenuItem();
            this.mnuInsert = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.chkPublish = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            // 
            // lblQueryName
            // 
            this.lblQueryName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblQueryName.Location = new System.Drawing.Point(8, 360);
            this.lblQueryName.Name = "lblQueryName";
            this.lblQueryName.Size = new System.Drawing.Size(128, 16);
            this.lblQueryName.TabIndex = 0;
            this.lblQueryName.Tag = "SID_QUERYNAME";
            // 
            // txtQuery
            // 
            this.txtQuery.Location = new System.Drawing.Point(96, 360);
            this.txtQuery.Name = "txtQuery";
            this.txtQuery.Size = new System.Drawing.Size(200, 20);
            this.txtQuery.Text = queryName;
            this.txtQuery.TabIndex = 2;
            // 
            // btnOK
            // 
            this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnOK.Location = new System.Drawing.Point(304, 416);
            this.btnOK.Name = "btnOK";
            this.btnOK.Size = new System.Drawing.Size(75, 23);
            this.btnOK.TabIndex = 4;
            this.btnOK.Tag = "SID_SAVES";
            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // btnCancel
            // 
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.Location = new System.Drawing.Point(392, 416);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(75, 23);
            this.btnCancel.TabIndex = 5;
            this.btnCancel.Tag = "SID_CANCEL";
            // 
            // txtDescription
            // 
            this.txtDescription.Location = new System.Drawing.Point(96, 392);
            this.txtDescription.Name = "txtDescription";
            this.txtDescription.Size = new System.Drawing.Size(200, 20);
            this.txtDescription.TabIndex = 3;
            // 
            // lblDescription
            // 
            this.lblDescription.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblDescription.Location = new System.Drawing.Point(8, 392);
            this.lblDescription.Name = "lblDescription";
            this.lblDescription.Size = new System.Drawing.Size(88, 16);
            this.lblDescription.TabIndex = 4;
            this.lblDescription.Tag = "SID_DESCRIPTION";
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(136, 360);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(160, 20);
            this.textBox1.TabIndex = 2;
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(8, 360);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(88, 16);
            this.label1.TabIndex = 4;
            this.label1.Text = "Description :";
            // 
            // button1
            // 
            this.button1.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.button1.Location = new System.Drawing.Point(392, 416);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 4;
            this.button1.Text = "Cancel";
            // 
            // trvGroups
            // 
            this.trvGroups.AllowDrop = true;
            this.trvGroups.LabelEdit = true;
            this.trvGroups.Location = new System.Drawing.Point(8, 16);
            this.trvGroups.Name = "trvGroups";
            this.trvGroups.ShowNodeToolTips = true;
            this.trvGroups.Size = new System.Drawing.Size(456, 304);
            this.trvGroups.TabIndex = 0;
            this.trvGroups.NodeMouseHover += new System.Windows.Forms.TreeNodeMouseHoverEventHandler(this.trvGroups_NodeMouseHover);
            this.trvGroups.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.trvGroups_AfterLabelEdit);
            this.trvGroups.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.trvGroups_AfterSelect);
            this.trvGroups.BeforeLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.trvGroups_BeforeLabelEdit);
            this.trvGroups.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.trvGroups_BeforeSelect);
            this.trvGroups.MouseDown += new System.Windows.Forms.MouseEventHandler(this.trvGroups_MouseDown);
            // 
            // contMenu
            // 
            this.contMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuAdd,
            this.mnuRename,
            this.mnuInsert,
            this.menuItem1});
            this.contMenu.Popup += new System.EventHandler(this.contMenu_Popup);
            // 
            // mnuAdd
            // 
            this.mnuAdd.Index = 0;
            this.mnuAdd.Text = "Add";
            this.mnuAdd.Click += new System.EventHandler(this.mnuAdd_Click);
            // 
            // mnuRename
            // 
            this.mnuRename.Index = 1;
            this.mnuRename.Text = "Rename";
            this.mnuRename.Click += new System.EventHandler(this.mnuRename_Click);
            // 
            // mnuInsert
            // 
            this.mnuInsert.Index = 2;
            this.mnuInsert.Text = "Insert";
            this.mnuInsert.Click += new System.EventHandler(this.mnuInsert_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 3;
            this.menuItem1.Text = "";
            // 
            // chkPublish
            // 
            this.chkPublish.Location = new System.Drawing.Point(16, 328);
            this.chkPublish.Name = "chkPublish";
            this.chkPublish.Size = new System.Drawing.Size(392, 24);
            this.chkPublish.TabIndex = 1;
            this.chkPublish.Tag = "SID_PUBLISHTOOTHERUSERS";
            // 
            // SaveQueryForm
            // 
            this.AcceptButton = this.btnOK;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.btnCancel;
            this.ClientSize = new System.Drawing.Size(474, 448);
            this.Controls.Add(this.chkPublish);
            this.Controls.Add(this.trvGroups);
            this.Controls.Add(this.txtDescription);
            this.Controls.Add(this.txtQuery);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.lblDescription);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnOK);
            this.Controls.Add(this.lblQueryName);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.button1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "SaveQueryForm";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Tag = "SID_SAVEAS";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion


		#region Fields

		private	LRRApp					_lrrApp; //All object to access the DB Manager and DB Adapter
		private LRRSearchGroupLevels	_lrrSearchGroupLevels=null; //Levels Object
		private LRRSearchGroupLevelLinks	_lrrSearchGroupLevelLinks = null; //Level Links object
		private TreeNode					prevSelNode = null;
		private LRRSearchGroupLevel			_selectedLevel = null;
		private bool					_isPublished = false;
		private string					_type;
		
		#endregion

		#region Properties
		public LRRSearchGroupLevel SelectedLevel
		{
			get{return _selectedLevel;}
			set
			{
				_selectedLevel = value;
			}
		}

		public bool IsPublished
		{
			get{return _isPublished;}
			set
			{
				_isPublished = value;
			}
		}
		#endregion

		#region Methods
		/// <summary>
		/// Method populates the data from database
		/// </summary>
		private void InitDataSource()
		{
			//Initialize and populate the levels
			_lrrSearchGroupLevels = new LRRSearchGroupLevels();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchGroupLevels);
			//Initialize and populate the level links
			_lrrSearchGroupLevelLinks = new LRRSearchGroupLevelLinks();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchGroupLevelLinks);
		}
		
		/// <summary>
		/// Method populates the Tree
		/// </summary>
		/// <param name="treeView"></param>
		/// <param name="levels"></param>
		/// <param name="levelLinks"></param>
		/// <returns></returns>
		private bool PopulateTreeView(TreeView treeView,LRRSearchGroupLevels levels,LRRSearchGroupLevelLinks levelLinks)
		{
			trvGroups.Nodes.Clear();
			try
			{
				Hashtable				_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRSearchGroupLevel l in levels)
				{
					_levelHash.Add(l.LevelID,l);
				}
				foreach(LRRSearchGroupLevelLink ll in levelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						TreeNode foundNode = _nodesHash[ll.ParentID] as TreeNode;
						LRRSearchGroupLevel foundLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel; 

						if(foundLevel.Type == "Level" || foundLevel.Type == _type)
						{
							TreeNode childNode = new TreeNode(foundLevel.Name);
							childNode.Tag = foundLevel;
							if(foundLevel.Type == "Level")
							{
								childNode.ImageIndex = 24;
								childNode.SelectedImageIndex = 24;
							}
							else
							{
								int imageIndex = GetImageIndex(foundLevel.Type,foundLevel);
								childNode.ImageIndex = imageIndex;
								childNode.SelectedImageIndex = imageIndex;
							}
							foundNode.Nodes.Add(childNode);
						}
					}
					else
					{
						LRRSearchGroupLevel parentLevel = _levelHash[ll.ParentID] as LRRSearchGroupLevel;
						LRRSearchGroupLevel childLevel = _levelHash[ll.ChildID] as LRRSearchGroupLevel;

						if(childLevel.Type == "Level" || childLevel.Type == _type)
						{
							TreeNode parentNode = new TreeNode(parentLevel.Name);
							parentNode.Tag = parentLevel;
							TreeNode childNode = new TreeNode(childLevel.Name);
							childNode.Tag = childLevel;
							if(childLevel.Type == "Level")
							{
								childNode.ImageIndex = 24;
								childNode.SelectedImageIndex = 24;
							}
							else
							{
								int imageIndex = GetImageIndex(childLevel.Type,childLevel);
								childNode.ImageIndex = imageIndex;
								childNode.SelectedImageIndex = imageIndex;
							}
							parentNode.Nodes.Add(childNode);
							_nodesHash.Add(ll.ParentID,parentNode);
						}
					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					TreeNode  childNode = null;
					TreeNode  parentNode = null;
					if(_nodesHash.ContainsKey(childID))
					{
						childNode = _nodesHash[childID] as TreeNode;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentNode = _nodesHash[parentID] as TreeNode;
					}
					if((parentNode != null) && (childNode != null))
					{
						int index = -1;
						foreach(TreeNode f in parentNode.Nodes)
						{
							if(f.Tag == childNode.Tag)
							{
								index = f.Index;
								break;
							}
						}
						if(index != -1)
							parentNode.Nodes[index] = childNode;
					}
				}

				TreeNode rootNode = null;
				if( _nodesHash.Count > 0)
				{
					rootNode = _nodesHash["0"] as TreeNode;
				}
				else
				{
					LRRSearchGroupLevel srchGroupLevel = _levelHash["0"] as LRRSearchGroupLevel;
					rootNode = new TreeNode(srchGroupLevel.Name);
					rootNode.Tag = srchGroupLevel;
					rootNode.ImageIndex = 24;
					rootNode.SelectedImageIndex = 24;
				}
				trvGroups.Nodes.Add(rootNode);

				//Add the items in the root Node which are not in SearchGroupLevel but are present in views
				AddNodesFromViews(rootNode);

				trvGroups.Nodes[0].Expand();
				return true;

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SaveQueryForm),"PopulateTreeView :"+ex.Message  ,Logger.Level.Debug);
				return false;
			}

		}

		private int GetImageIndex(string type,LRRSearchGroupLevel level)
		{
			int imageIndex = 9;
			if(type == "Query")
			{
				LRRSearchCriteria lrrSrchCriteria = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(level.LevelID);
				if(lrrSrchCriteria != null)
				{
					if(lrrSrchCriteria.Source == "I/O")
					{
						imageIndex = 44;
					}
					if(lrrSrchCriteria.Source == "GP")
					{
						imageIndex = 51;
					}
					if(lrrSrchCriteria.Source == "DA")
					{
						imageIndex = 51;
					}
				}
			}
			if(type == "CompositeViews")
			{
				imageIndex = 42;
			}
            if (type == "UnifiedView")
            {
                imageIndex = 47;
            }
			return imageIndex;
		}

		
		private void AddNodesFromViews(TreeNode trvNode)
		{
			if(_type == "Query")
			{
				//Search Criterias
				IEnumerator iSrchEnum = LRRModel.ChildModel.SearchCriterias.GetEnumerator();
				while(iSrchEnum.MoveNext())
				{
					LRRSearchCriteria srchCriteria = iSrchEnum.Current as LRRSearchCriteria;
					LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(srchCriteria.ID);
				
					//If Level is not present,add in the root Node
					if(srchGroupLevel == null && srchCriteria.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
					{
						TreeNode queryNode = new TreeNode(srchCriteria.Name);
						int imageIndex = 9;
						if(srchCriteria.Source == "I/O")
						{
							imageIndex = 44;
						}
						if(srchCriteria.Source == "GP")
						{
							imageIndex = 51;
						}
						if(srchCriteria.Source == "DA")
						{
							imageIndex = 51;
						}
						queryNode.ImageIndex = imageIndex;
						queryNode.SelectedImageIndex = imageIndex;
						trvNode.Nodes.Add(queryNode);
					}
				}
			}
			if(_type == "CompositeViews")
			{
				//CompositeViews
				IEnumerator iCompositeViewEnum = LRRModel.ChildModel.CompositeViews.GetEnumerator();
				while(iCompositeViewEnum.MoveNext())
				{
					LRRCompositeView lrrCompositeView = iCompositeViewEnum.Current as LRRCompositeView;
					LRRSearchGroupLevel srchGroupLevel = _lrrSearchGroupLevels.GetLevelFromID(lrrCompositeView.ID);
				
					//If Level is not present,add in the root Node
					if(srchGroupLevel == null && lrrCompositeView.UserID == _lrrApp.DBManagerObj.AccessControlModel.UserID)
					{
						TreeNode compositeViewNode = new TreeNode(lrrCompositeView.Name);
						compositeViewNode.ImageIndex = 42;
						compositeViewNode.SelectedImageIndex = 42;
						trvNode.Nodes.Add(compositeViewNode);
					}
				}
			}

		}
		
		/// <summary>
		/// Adds to the Collection
		/// </summary>
		/// <param name="tn"></param>
		/// <param name="text"></param>
		private void AddToCollection(TreeNode tn, string text)
		{
			try
			{
				LRRSearchGroupLevel lvl = new LRRSearchGroupLevel();
				LRRSearchGroupLevel lvlParent = tn.Parent.Tag as LRRSearchGroupLevel;
				lvl.Name = text;
				lvl.Type = "Level";
				tn.Tag = lvl;
				_lrrSearchGroupLevels.Add(lvl);
				LRRSearchGroupLevelLink lvlLink = new LRRSearchGroupLevelLink();
				lvlLink.ChildID = lvl.LevelID;
				lvlLink.ParentID = lvlParent.LevelID;

				_lrrSearchGroupLevelLinks.Add(lvlLink);

				LRRSearchGroupLevels toCommitLevels = _lrrSearchGroupLevels.GetChanges();
				LRRSearchGroupLevelLinks toCommitLevelLinks = _lrrSearchGroupLevelLinks.GetChanges();
				_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
				_lrrApp.DBManagerObj.CommitCollection(toCommitLevelLinks);
				_lrrSearchGroupLevels.RefreshCollection();
				_lrrSearchGroupLevelLinks.RefreshCollection();
				
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SaveQueryForm),"AddToCollection :"+ex.Message  ,Logger.Level.Debug);
			}

		}
		#endregion

		#region Event Handlers

		private void mnuAdd_Click(object sender, System.EventArgs e)
		{
			TreeNode tn = new TreeNode("");
			if(trvGroups.SelectedNode!=null)
			{
				trvGroups.SelectedNode.Nodes.Add(tn);
				trvGroups.SelectedNode = tn;
				tn.BeginEdit();
			}
		}

		private void mnuInsert_Click(object sender, System.EventArgs e)
		{
			TreeNode trvSelectedNode = trvGroups.SelectedNode;
			if(trvSelectedNode!=null)
			{
				int iSelIndex = trvSelectedNode.Index;
				TreeNode trvNode = new TreeNode("");

				if(trvSelectedNode.Parent != null)
				{
					TreeNode trvParentNode = trvSelectedNode.Parent;
					trvParentNode.Nodes.Insert(iSelIndex,trvNode);
					trvGroups.SelectedNode = trvNode;
					trvNode.BeginEdit();
				}
			}
		}

		private void mnuRename_Click(object sender, System.EventArgs e)
		{
			if(trvGroups.SelectedNode!=null)
				trvGroups.SelectedNode.BeginEdit();
		}

		private void contMenu_Popup(object sender, System.EventArgs e)
		{
			mnuAdd.Enabled = true;
			mnuInsert.Enabled = true;
			mnuRename.Enabled = true;
			if(trvGroups.Nodes.Count>0)
			{
				LRRSearchGroupLevel lvl =  trvGroups.SelectedNode.Tag as LRRSearchGroupLevel;
				if(lvl.LevelID == "0")
				{
					mnuRename.Enabled = false;
				}
			}
		}

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			if(txtQuery.Text == null || txtQuery.Text.Trim() == "")
			{
				LRRMessagBox.ShowMessage(this,"SID_NAME_NULL_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Stop);      
				this.DialogResult = DialogResult.None;
				return;
			}
			if(this.SelectedLevel == null)
			{
				LRRMessagBox.ShowMessage(this,"SID_VALIDLEVEL","SID_INVAL_LEVE",MessageBoxButtons.OK,MessageBoxIcon.Stop);      
				this.DialogResult = DialogResult.None;
				return;
			}
			queryName = txtQuery.Text;
			queryDesc = txtDescription.Text;
			
//			string sUserRoleType = _lrrApp.DBManagerObj.AccessControlModel.UserRoleTypeID;
//			if(sUserRoleType == "1")
//			{
				//The user belongs to the implementer role
				_isPublished = chkPublish.Checked;
//			}
//			else
//			{
//				_isPublished = true;
//			}
		}

		private void trvGroups_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			if(e.Label == null || e.Label.Trim() =="")
			{
				if(e.Node.Text.Trim() == "")
				{

					LRRMessagBox.ShowMessage("SID_TREENODELEBEL_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					e.Node.BeginEdit();
				}
			}
			else if(e.Label.Length > 0)
			{
				/*if(_lrrLevels.FindLevelByLevelName(e.Label.ToString().ToUpper()) == true)
				{
					//MessageBox.Show("Level already Exists:");
					LRRMessagBox.ShowMessage("SID_LEVEL_DUPLICATE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					e.CancelEdit = true;
					e.Node.BeginEdit();  
				}
				else*/ if(e.Label.IndexOfAny(new char[]{'@','.', ',', '!'}) != -1)
				{
					/* Cancel the label edit action, inform the user, and 
						place the node in edit mode again. */
					//						MessageBox.Show("Invalid tree node label.\n" + 
					//							"The invalid characters are: '@','.', ',', '!'", 
					//							"Node Label Edit");
					LRRMessagBox.ShowMessage("SID_TREENODE_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					e.CancelEdit = true;
					e.Node.BeginEdit();
				}
				else
				{
					LRRSearchGroupLevel lvl = e.Node.Tag as LRRSearchGroupLevel;
					if(_lrrSearchGroupLevels.Contains(lvl))
					{
						lvl.Name = e.Label;
						lvl.Type = "Level";
						LRRSearchGroupLevels toCommitLevels = _lrrSearchGroupLevels.GetChanges();
						_lrrApp.DBManagerObj.CommitCollection(toCommitLevels);
						_lrrSearchGroupLevels.RefreshCollection();
					}
					else
					{
						AddToCollection(e.Node, e.Label);
					}
				}
			}
			else if(e.Label.Length == 0)
			{
				LRRMessagBox.ShowMessage("SID_TREENODELEBEL_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
			}
		}

		private void trvGroups_BeforeLabelEdit(object sender, NodeLabelEditEventArgs e)
		{
			e.CancelEdit = true;
		}

		private void trvGroups_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			this.SelectedLevel = e.Node.Tag as LRRSearchGroupLevel;
			if(prevSelNode != null)
			{
				prevSelNode.ForeColor = Color.Black;
			}
			e.Node.ForeColor = Color.Blue;
			prevSelNode = e.Node;
		}

		private void trvGroups_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Point  pt = new Point(e.X,e.Y);
			TreeNode node = trvGroups.GetNodeAt(pt);
			if(node != null)
			{
				LRRSearchGroupLevel lvl = node.Tag as LRRSearchGroupLevel;
				if(lvl != null && lvl.Type == "Level")
					trvGroups.SelectedNode = node;
			}
		}
		
		private void trvGroups_BeforeSelect(object sender, TreeViewCancelEventArgs e)
		{
			TreeNode node = e.Node;
			if(node != null)
			{
				LRRSearchGroupLevel lvl = node.Tag as LRRSearchGroupLevel;
                if (lvl == null || (lvl.Type != "Level" && lvl.LevelID != "0"))
                {
                    if (lvl.Type != "Level" && lvl.LevelID != "0")
                    {
                        txtQuery.Text = lvl.Name;
                        txtDescription.Text = lvl.Description;
                        trvGroups.SelectedNode = e.Node.Parent;
                    }
                    e.Cancel = true;
                }
			}
		}
		#endregion
        
        private void trvGroups_NodeMouseHover(object sender, TreeNodeMouseHoverEventArgs e)
        {
            string toolTip = "";
            TreeNode tn = e.Node as TreeNode;
            if (tn != null && tn.Tag != null)
            {
                LRRSearchGroupLevel searchGrpLevel = tn.Tag as LRRSearchGroupLevel;
                string desc = searchGrpLevel.Description;
                if (String.IsNullOrEmpty(desc))
                {
                    toolTip = LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + searchGrpLevel.TimeID;
                }
                else
                {
                    toolTip = LRRHeaderText.GetHeaderString("SID_DESCRIPTION") + " : " + searchGrpLevel.Description + " \n" + LRRHeaderText.GetHeaderString("SID_CREATED_DATE_TIME") + " : " + searchGrpLevel.TimeID;
                }
                tn.ToolTipText = toolTip;
            }
        }
	}

}

