using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.LightRidge.PEAdvisor;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.HeaderDispatcher;

namespace Symcon.LightRidge.PEAdvisor.SavedViews
{
	/// <summary>
	/// Summary description for ClearCaseForm.
	/// </summary>
	public class ClearCaseForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlGrid;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridClearCase;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Splitter splitter1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ClearCaseForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			BindGrid();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ClearCaseForm));
			this.pnlGrid = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.gridClearCase = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOk = new System.Windows.Forms.Button();
			this.pnlGrid.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridClearCase)).BeginInit();
			this.pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlGrid
			// 
			this.pnlGrid.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlGrid.Controls.Add(this.splitter1);
			this.pnlGrid.Controls.Add(this.gridClearCase);
			this.pnlGrid.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlGrid.Location = new System.Drawing.Point(0, 0);
			this.pnlGrid.Name = "pnlGrid";
			this.pnlGrid.Size = new System.Drawing.Size(470, 232);
			this.pnlGrid.TabIndex = 0;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Enabled = false;
			this.splitter1.Location = new System.Drawing.Point(0, 227);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(468, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// gridClearCase
			// 
			this.gridClearCase.BackColor = System.Drawing.SystemColors.Window;
			this.gridClearCase.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridClearCase.Location = new System.Drawing.Point(0, 0);
			this.gridClearCase.Name = "gridClearCase";
			this.gridClearCase.Size = new System.Drawing.Size(468, 230);
			this.gridClearCase.TabIndex = 0;
			this.gridClearCase.Text = "gridGroupingControl1";
			this.gridClearCase.VersionInfo = "3.301.0.0";
			// 
			// pnlBottom
			// 
			this.pnlBottom.Controls.Add(this.btnCancel);
			this.pnlBottom.Controls.Add(this.btnOk);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 124);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(470, 40);
			this.pnlBottom.TabIndex = 1;
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(384, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// btnOk
			// 
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.Location = new System.Drawing.Point(296, 8);
			this.btnOk.Name = "btnOk";
			this.btnOk.TabIndex = 0;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// ClearCaseForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(470, 164);
			this.Controls.Add(this.pnlBottom);
			this.Controls.Add(this.pnlGrid);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ClearCaseForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_CLEAR_CASE";
			this.pnlGrid.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridClearCase)).EndInit();
			this.pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		private void InitDataSource()
		{
			string cmp1CaseID = _lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.CaseID;
			string cmp2CaseID = _lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.CaseID;
			string refCaseID  = _lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.CaseID;

			_lrrSavedCases = new LRRSavedCases();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSavedCases);

			_lrrClearCases = new LRRClearCases();
			IEnumerator iEnum = _lrrSavedCases.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRSavedCase lrrSavedCase = iEnum.Current as LRRSavedCase;
				if(lrrSavedCase.ID == cmp1CaseID ||
					lrrSavedCase.ID == refCaseID ||
					lrrSavedCase.ID == cmp2CaseID)
				{
					LRRClearCase lrrClearCase = new LRRClearCase();
					if(lrrSavedCase.ID == cmp1CaseID)
					{
						lrrClearCase.SavedCaseID = lrrSavedCase.ID;
						lrrClearCase.Name = lrrSavedCase.Name;
						lrrClearCase.Compare1 = true;
					}
					if(lrrSavedCase.ID == refCaseID)
					{
						lrrClearCase.SavedCaseID = lrrSavedCase.ID;
						lrrClearCase.Name = lrrSavedCase.Name;
						lrrClearCase.Reference = true;
					}
					if(lrrSavedCase.ID == cmp2CaseID)
					{
						lrrClearCase.SavedCaseID = lrrSavedCase.ID;
						lrrClearCase.Name = lrrSavedCase.Name;
						lrrClearCase.Compare2 = true;
					}
					_lrrClearCases.Add(lrrClearCase);
				}
			}
		}

		private void BindGrid()
		{
			//Suspend the Layout of the Grid...
			this.gridClearCase.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(this.gridClearCase);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(this.gridClearCase,_lrrClearCases.ItemType,null,true);
			
			this.gridClearCase.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridClearCase.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridClearCase.BackColor = System.Drawing.SystemColors.Window;
			this.gridClearCase.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridClearCase.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridClearCase.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridClearCase.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridClearCase.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_SAVED_CASES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridClearCase.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridClearCase.TableDescriptor.AllowNew = false;
			this.gridClearCase.TableDescriptor.AllowEdit = true;
			this.gridClearCase.TableDescriptor.AllowRemove = false;

			this.gridClearCase.SourceListSet.Add("Parent",_lrrClearCases);

			this.gridClearCase.TableDescriptor.Relations.Clear();
			this.gridClearCase.DataSource = null;
			this.gridClearCase.DataSource = _lrrClearCases;

			this.gridClearCase.TableDescriptor.Columns.Clear();

			this.gridClearCase.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_NAME"),"Name");
			this.gridClearCase.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ReadOnly = true;
			this.gridClearCase.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);

			this.gridClearCase.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_COMAPARE1"),"Compare1");
			this.gridClearCase.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.CellType = "CheckBox";
			this.gridClearCase.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ReadOnly = true;
			this.gridClearCase.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);

			this.gridClearCase.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_COMAPARE2"),"Compare2");
			this.gridClearCase.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.CellType = "CheckBox";
			this.gridClearCase.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.ReadOnly = true;
			this.gridClearCase.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);

			this.gridClearCase.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_REFERENCE"),"Reference");
			this.gridClearCase.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell.CellType = "CheckBox";
			this.gridClearCase.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell.ReadOnly = true;
			this.gridClearCase.TableDescriptor.Columns[3].Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);

			_unBoundColumn = new GridUnBoundColumn();
			_unBoundColumn.WireGrid(this.gridClearCase);

			object[] objArray = new object[_lrrClearCases.Count];
			int k = 0;
			foreach(LRRClearCase lrrClearCase in _lrrClearCases)
			{
				objArray[k] = lrrClearCase;
				k++;
			}
			_unBoundColumn.SetSelectedRecords(objArray);

			this.gridClearCase.ResumeLayout(true);
		}
		#endregion

		#region Fields
		private LRRApp	_lrrApp;
		private LRRSavedCases _lrrSavedCases;
		private LRRClearCases _lrrClearCases;
		private GridUnBoundColumn _unBoundColumn;
		#endregion
		
		#region Event Handlers
		private void btnOk_Click(object sender, System.EventArgs e)
		{
			bool bCmp1 = false;
			bool bRef = false;
			bool bCmp2 = false;

			string cmp1ModeID = null;
			string refModeID = null;
			string cmp2ModeID = null;

			Cursor.Current = Cursors.WaitCursor;
			Cursor.Show();

			Symcon.Utils.TimerUtils.HiPerfTimer hTimer = new Symcon.Utils.TimerUtils.HiPerfTimer();
			hTimer.Start();
			Logger.LogMessage("Clear Case Start Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			
			object[] objSelCases = _unBoundColumn.GetUnSelectedRecords();
			for(int i=0;i < objSelCases.GetLength(0);i++)
			{
				LRRClearCase lrrClearCase = objSelCases.GetValue(i) as LRRClearCase;
				if(lrrClearCase.Compare1)
					bCmp1 = true;
				if(lrrClearCase.Reference)
					bRef = true;
				if(lrrClearCase.Compare2)
					bCmp2 = true;
				
				LRRSavedCaseUserMap savedCaseUserMap = new LRRSavedCaseUserMap();
				_lrrApp.DBManagerObj.PopulateObject(savedCaseUserMap,typeof(LRRSavedCaseUserMap)," where SavedCaseID = '" + lrrClearCase.SavedCaseID + "' AND CaseOpenedByUserID = '" + _lrrApp.DBManagerObj.AccessControlModel.UserID + "'"); 
				
				savedCaseUserMap.ObjectState = DBOperation.DELETE;
				_lrrApp.DBManagerObj.CommitObject(savedCaseUserMap);
				
			}
			
			if(bCmp1)
			{
				cmp1ModeID = LRRModel.ProjectModes.GetModeByType("1").ModeId;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.Source = SourceEnum.LOCAL;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.CaseID = "";
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.StartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare1Mode.EndTime = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
			}
			if(bRef)
			{
				refModeID = LRRModel.ProjectModes.GetModeByType("2").ModeId;
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.Source = SourceEnum.LOCAL;
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.CaseID = "";
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.StartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
				_lrrApp.TimeWindowObj.ModeSlotsObj.RefMode.EndTime = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
			}
			if(bCmp2)
			{
				cmp2ModeID = LRRModel.ProjectModes.GetModeByType("3").ModeId;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.Source = SourceEnum.LOCAL;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.CaseID = "";
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.StartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
				_lrrApp.TimeWindowObj.ModeSlotsObj.Compare2Mode.EndTime = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
			}
			
			//Clear the overrides
			bool isDynamicCaseCleared = false;
			if(cmp1ModeID == "3" || cmp2ModeID == "3" || refModeID == "3")
			{
				isDynamicCaseCleared = true;
			}
			if(isDynamicCaseCleared)
				_lrrApp.OverridesWindow.ClearSavedCaseOverrides();

			//Populate Aggregate Property Value,SiteComponentPropertyValues,Qualifier Value
			LRRAggregatePropertyValues aggrPropvalues = new LRRAggregatePropertyValues();
			_lrrApp.DBManagerObj.PopulateCollection(aggrPropvalues," WHERE ModeID IN ('" + cmp1ModeID + "','" + refModeID + "','" + cmp2ModeID + "')");

			LRRSiteComponentPropertyValues siteCompPropvalues = new LRRSiteComponentPropertyValues();
			_lrrApp.DBManagerObj.PopulateCollection(siteCompPropvalues," WHERE ModeID IN ('" + cmp1ModeID + "','" + refModeID + "','" + cmp2ModeID + "')");

			LRRSiteGroupPropertyQualifierValues siteGrpPropQualvalues = new LRRSiteGroupPropertyQualifierValues();
			_lrrApp.DBManagerObj.PopulateCollection(siteGrpPropQualvalues," WHERE ModeID IN ('" + cmp1ModeID + "','" + refModeID + "','" + cmp2ModeID + "')");

			//Update Aggregate Property Value Model
			IEnumerator iAggrPropValueEnum = aggrPropvalues.GetEnumerator();
			while(iAggrPropValueEnum.MoveNext())
			{
				LRRAggregatePropertyValue aggrPropValue = iAggrPropValueEnum.Current as LRRAggregatePropertyValue;
				LRRAggregatePropertyValue modelAggrPropValue = LRRModel.AggregatePropertyValuesObj.FindAggregatePropertyValueByID(aggrPropValue.ID);
				if(modelAggrPropValue != null)
				{
					modelAggrPropValue.PropertyValue = aggrPropValue.PropertyValue;
					modelAggrPropValue.ReadOnlyAccess = aggrPropValue.ReadOnlyAccess;
				}
			}
			
			//Update Site Component Property Value Model
			IEnumerator iSiteCompPropValueEnum = siteCompPropvalues.GetEnumerator();
			while(iSiteCompPropValueEnum.MoveNext())
			{
				LRRSiteComponentPropertyValue siteCompPropValue = iSiteCompPropValueEnum.Current as LRRSiteComponentPropertyValue;
				LRRSiteComponentPropertyValue modelSitePropValue = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(siteCompPropValue.ID);
				if(modelSitePropValue != null)
				{
					modelSitePropValue.ReadOnlyAccess = siteCompPropValue.ReadOnlyAccess;
					modelSitePropValue.IsEditable = siteCompPropValue.IsEditable;
					modelSitePropValue.PropertyValue = siteCompPropValue.PropertyValue;
				}
			}

			//Update Qualifier Value Model
			IEnumerator iQualValueEnum = siteGrpPropQualvalues.GetEnumerator();
			while(iQualValueEnum.MoveNext())
			{
				LRRSiteGroupPropertyQualifierValue siteGrpPropQualValue = iQualValueEnum.Current as LRRSiteGroupPropertyQualifierValue;
				LRRSiteGroupPropertyQualifierValue modelQualValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(siteGrpPropQualValue.SiteGroupPropertyQualifierValueID);
				if(modelQualValue != null)
				{
					modelQualValue.ReadOnlyAccess = siteGrpPropQualValue.ReadOnlyAccess;
					modelQualValue.IsEditable = siteGrpPropQualValue.IsEditable;
					modelQualValue.PropertyValue = siteGrpPropQualValue.PropertyValue;
				}
			}

            _lrrApp.ApplyOverrides();
            _lrrApp.ApplyGroupOverrides();
			_lrrApp.SetPropertyValueBinding();
			_lrrApp.SetGroupPropertyValueBinding();
			
			//End time
			Logger.LogMessage("Clear Case End Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//Difference
			hTimer.Stop();
			Logger.LogMessage("Clear Case Difference:" + hTimer.Duration.ToString(Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);

			Cursor.Hide();

		}
		#endregion

	}
}
