using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Grouping;
using Syncfusion.ComponentModel;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  



//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.


namespace Symcon.LightRidge.PEAdvisor.SavedViews
{
	/// <summary>
	/// Summary description for EquipmentEntry.
	/// </summary>
	public class DynamicSiteComponentEntry : System.Windows.Forms.Form,ILRRUIContainer
	{
		#region Fields

		private LRRDynamicSiteComponents					_lrrSiteComponents = null; //Instance for the site components.
		private bool										_called = false;
		private string										_siteCompontId;
		private LRRDynamicSiteComponents					_siteComponents = new LRRDynamicSiteComponents(); //Instance for the site components ...
		private LRRDynamicSiteComponentProperties			_siteCompProperties; //Instance for the properties...
//		private LRRSiteComponentAdditionalInformations		_siteCompAdditionalinfos; //Instance atoring the additional infos..
//		private LRRSiteComponentPropertyUserAndTimes		_siteCompPropsUserAndTimes; //Overrides
		private LRRDynamicSiteComponentPropertyValues		_siteComponentPropertyValues;
		private LRRDynamicSiteComponentPropertyValues  			_siteComponentPropertyOriginalValues;
		private LRRLookUpProperties							_lrrLookUpProperties;
		private LRRPropertyTypes							_lrrPropertyTypes;
//		private LRRModes									_modes;
		private LRRLevels									_levels;
		private LRRHistDatas								_lrrHistdata;
		private LRRLevel									_level;

		private LRRDynamicSiteComponentGroupProperties			_siteCompGroupedProperties;
		private LRRDynamicSiteGroupPropertyQualifierValues			_siteGroupPropertyQualifierValues;
		//private LRRSiteComponentGroupPropertyValues			_siteCompGroupPropertyValues;

		private GridRelatedCellStyleHelper		_gridRelatedCellStyleHelper = new GridRelatedCellStyleHelper();

		//private GridRecordStateFormatter		_siteCompRowStateFormatter = new GridRecordStateFormatter(); //Formats the row color as the state of the object changes.
		//private GridRecordStateFormatter		_siteComPropRowStateFormatter = new GridRecordStateFormatter();
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ContextMenu contextMenuSiteCompProperties;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barMasterProperties;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barDerivedProperties;
		private LRRApp							_app;
		
		private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		private DuplicateValidation _chkDuplicate	= new DuplicateValidation();
		//private LRRUIManager lrrUI=new LRRUIManager();
		Hashtable lrrFormulaSiteComponents = new Hashtable();
		Hashtable lrrMasterPropertyDirections = new Hashtable();
		private System.ComponentModel.IContainer components;

		private GridRecordNavigationControl gnc = new GridRecordNavigationControl();
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barShowProperties;
		private System.Windows.Forms.Panel mainPanel;
		//private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteComponent;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barPaste;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteComponent;

		//private GridRecordStateFormatter gridRecStateFormatter = new GridRecordStateFormatter();
		private bool initializing = false;
		private string _LocaleID;
		private System.Windows.Forms.ContextMenu gridContext;
		public static bool copyToAll = false;
		Hashtable oForAlerts;
		bool editFlag = true;
		bool groupPropertyeditFlag = true;
		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;

		
		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private string				_dynamicCaseID;
		
		#endregion
		public DynamicSiteComponentEntry()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			_LocaleID = _app.AppLocaleID;

			_dynamicCaseID = _app.DynamicCaseID;;

			InitDataSource(_dynamicCaseID);

			SyncGridUtilities.InitializeGridLookAndFeel(gridSiteComponent);

			_chkDuplicate.ChkDuplicate(gridSiteComponent,"SiteComponentID","ID","Name","Name","ComponentID");
		
					
			//_siteCompRowStateFormatter.WireGrid(gridSiteCompProperties);

//			_gridExcelFormatter.WireGrid(gridSiteComponent);

			//this.gridSiteComponent.TableOptions.
			//SyncGridUtilities.InitializeGridLookAndFeel(gridSiteCompProperties);
			//gridSiteComponent.Binder.CurrentPositionChanged+=new EventHandler(Binder_CurrentPositionChanged);

			this.Activated+=new EventHandler(SiteComponentEntry_Activated);
			//Tool Bar for the Master Properties Section...
			this.barDerivedProperties.Click+=new EventHandler(bar_Click);
			this.barMasterProperties.Click+=new EventHandler(bar_Click);
			this.barSave.Click+=new EventHandler(barSave_Click);
			this.barShowProperties.Click+=new EventHandler(barShowProperties_Click);
			this.barPaste.Click+=new EventHandler(barPaste_Click);
			


			//this.gridSiteComponent.TableDescriptor.Relations = relations;*/
			InitializeGrid();
			initializing = true;
			//oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
			//oForAlerts.Clear();
		}

		/*
		public DynamicSiteComponentEntry(string sSiteCompID)
		{

			InitializeComponent();
		
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			_LocaleID = _app.AppLocaleID;

			InitDataSource(sSiteCompID); 

			SyncGridUtilities.InitializeGridLookAndFeel(gridSiteComponent);


			_gridExcelFormatter.WireGrid(gridSiteComponent);


			this.Activated+=new EventHandler(SiteComponentEntry_Activated);
			//Tool Bar for the Master Properties Section...
			this.barDerivedProperties.Click+=new EventHandler(bar_Click);
			this.barMasterProperties.Click+=new EventHandler(bar_Click);
			this.barSave.Click+=new EventHandler(barSave_Click);
			this.barShowProperties.Click+=new EventHandler(barShowProperties_Click);
			this.barPaste.Click+=new EventHandler(barPaste_Click);
			
		
			initializing = true;
			InitializeGrid();
			//oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
			//oForAlerts.Clear();
		}*/

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DynamicSiteComponentEntry));
			this.barMasterProperties = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.barDerivedProperties = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barShowProperties = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.contextMenuSiteCompProperties = new System.Windows.Forms.ContextMenu();
			this.mainPanel = new System.Windows.Forms.Panel();
			this.gridSiteComponent = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridContext = new System.Windows.Forms.ContextMenu();
			this.mainPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridSiteComponent)).BeginInit();
			this.SuspendLayout();
			// 
			// barMasterProperties
			// 
			this.barMasterProperties.CategoryIndex = -1;
			this.barMasterProperties.ID = "MP";
			this.barMasterProperties.ImageIndex = 1;
			this.barMasterProperties.ImageList = this.imageList1;
			this.barMasterProperties.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barMasterProperties.Shortcut = System.Windows.Forms.Shortcut.Ins;
			this.barMasterProperties.Text = "Add MasterProperties";
			this.barMasterProperties.Tooltip = "Add the Master Properties to the Equipment/System";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// barDerivedProperties
			// 
			this.barDerivedProperties.CategoryIndex = -1;
			this.barDerivedProperties.ID = "DP";
			this.barDerivedProperties.ImageIndex = 0;
			this.barDerivedProperties.ImageList = this.imageList1;
			this.barDerivedProperties.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barDerivedProperties.Text = "Create Derived Properties";
			// 
			// barSave
			// 
			this.barSave.CategoryIndex = -1;
			this.barSave.ID = "Save";
			this.barSave.ImageIndex = 7;
			this.barSave.ImageList = this.imageList1;
			this.barSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barSave.Text = "Save";
			// 
			// barShowProperties
			// 
			this.barShowProperties.CategoryIndex = -1;
			this.barShowProperties.ID = "Select Columns";
			this.barShowProperties.Text = "Select Columns";
			// 
			// barPaste
			// 
			this.barPaste.CategoryIndex = -1;
			this.barPaste.ID = "Paste";
			this.barPaste.Text = "Paste";
			// 
			// mainPanel
			// 
			this.mainPanel.Controls.Add(this.gridSiteComponent);
			this.mainPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.mainPanel.Location = new System.Drawing.Point(0, 0);
			this.mainPanel.Name = "mainPanel";
			this.mainPanel.Size = new System.Drawing.Size(560, 624);
			this.mainPanel.TabIndex = 1;
			// 
			// gridSiteComponent
			// 
			this.gridSiteComponent.Appearance.FilterBarCell.AllowEnter = true;
			this.gridSiteComponent.Appearance.FilterBarCell.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Editable;
			this.gridSiteComponent.BackColor = System.Drawing.SystemColors.Window;
			this.gridSiteComponent.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSiteComponent.Location = new System.Drawing.Point(0, 0);
			this.gridSiteComponent.Name = "gridSiteComponent";
			this.gridSiteComponent.Size = new System.Drawing.Size(560, 624);
			this.gridSiteComponent.TabIndex = 18;
			this.gridSiteComponent.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridSiteComponent.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridSiteComponent.TableOptions.AllowSortColumns = true;
			this.gridSiteComponent.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
			this.gridSiteComponent.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridSiteComponent.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridSiteComponent.Text = "gridSiteComponent";
			this.gridSiteComponent.ThemesEnabled = false;
			this.gridSiteComponent.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridSiteComponent.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridSiteComponent.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridSiteComponent.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridSiteComponent.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridSiteComponent.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridSiteComponent.VersionInfo = "3.301.0.0";
			this.gridSiteComponent.TableControlCurrentCellKeyPress += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventHandler(this.gridSiteComponent_TableControlCurrentCellKeyPress);
			this.gridSiteComponent.TableControlKeyUp += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridSiteComponent_TableControlKeyUp);
			this.gridSiteComponent.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridSiteComponent_TableControlCellClick);
			this.gridSiteComponent.TableControlCurrentCellKeyDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridSiteComponent_TableControlCurrentCellKeyDown);
			this.gridSiteComponent.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridSiteComponent_CurrentRecordContextChange);
			// 
			// DynamicSiteComponentEntry
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 624);
			this.Controls.Add(this.mainPanel);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "DynamicSiteComponentEntry";
			this.Tag = "440";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.EquipmentEntry_Load);
			this.Closed += new System.EventHandler(this.EquipmentEntry_Closed);
			this.Activated += new System.EventHandler(this.SiteComponentEntry_Activated_1);
			this.mainPanel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridSiteComponent)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Event Handlers

		/// <summary>
		/// Event Handler for the Combo box of the Site Component Pointer to
		/// the Master Component Table for the Property changes..
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void gridSiteComponents_CurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs e)
		{
			/*GridCurrentCell cc;

			cc = this.gridSiteComponents.CurrentCell;

			int rowIndex = cc.RowIndex;
			int colIndex = cc.ColIndex;

			string oldValue = "";
			string newValue = "";

			if(cc.ColIndex == 3)
			{
				newValue = cc.Renderer.GetCellValue().ToString();
				if(this.gridSiteComponents[cc.RowIndex,cc.ColIndex].CellValue == null)
				{
					oldValue = "";
				}
				else
				{
					oldValue = this.gridSiteComponents[cc.RowIndex,cc.ColIndex].CellValue.ToString();
				}
				if(oldValue != newValue)
				{
					if(MessageBox.Show(this,"On Changing this value you will loose the properties for this equipment.Do you wish to continue?","Loss of properties",MessageBoxButtons.YesNo,MessageBoxIcon.Error) == DialogResult.No)
					{
						cc.ResetCurrentCellWithoutDeactivate();
						cc.Activate(rowIndex,colIndex);
					}
					else
					{
						//Value is forced to change so call the Refresh 
						cc.Activate(rowIndex,colIndex);

						//Resets the Data Source as the mastercompoent ID has changed...
						ResetDataSourceForPropGrid(newValue);
					}
				}
			}*/

		}

		#endregion

		#region Private Methods

		/// <summary>
		/// This Method initializes the data source.
		/// It should be used as reference for coding the initialization
		/// of data source in all the other forms.
		/// 1. Get the referenced table using the type of the items in the collection.
		/// 2. Initialize the properties holding the child tables using reflection.
		/// </summary>
		public void InitDataSource()
		{
			if(_lrrLookUpProperties != null)
				_lrrLookUpProperties.Clear();
			if(_lrrPropertyTypes!=null)
				_lrrPropertyTypes.Clear();
			if(_levels!= null)
				_levels.Clear(); 
			
			ResetCollectionState(LRRDynamicModel.DynamicSiteComponents);
			ResetCollectionState(LRRDynamicModel.DynamicSiteComponentProperties);
			ResetCollectionState(LRRDynamicModel.DynamicSiteComponentPropertyValues);
			ResetCollectionState(LRRDynamicModel.DynamicSiteCompGrpProps);
//			ResetCollectionState(LRRModel.HistDatas);
//			ResetCollectionState(LRRModel.Model);


			_siteComponents = LRRDynamicModel.DynamicSiteComponents;
			_siteCompProperties = LRRDynamicModel.DynamicSiteComponentProperties;
			
			_siteComponentPropertyValues = LRRDynamicModel.DynamicSiteComponentPropertyValues;

			_siteComponentPropertyOriginalValues = _siteComponentPropertyValues;
			_siteCompGroupedProperties = LRRDynamicModel.DynamicSiteCompGrpProps;//LRRModel.SiteComponentGroupPropertiesObj;
			
			_siteGroupPropertyQualifierValues = new LRRDynamicSiteGroupPropertyQualifierValues();
			
			//Populate from Model
			_lrrHistdata = LRRModel.HistDatas;

			_lrrLookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(_lrrLookUpProperties,false);
			
			_lrrPropertyTypes = new LRRPropertyTypes();
			_app.DBManagerObj.PopulateCollection(_lrrPropertyTypes,false);

			_levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(_levels,false);  
			

//			LRRMasterComponents masterComponents = LRRModel.Model;
//			lrrFormulaSiteComponents.Clear();
//			lrrFormulaSiteComponents.Add(0,masterComponents);
//			lrrFormulaSiteComponents.Add(1,"MasterComponents");
//			lrrFormulaSiteComponents.Add(2,"SiteComponentsObj");
//			lrrFormulaSiteComponents.Add(3,"Properties");
//
//			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
//			LRRFormulaDataStore.ModeFlag = true;
			
//			_siteComponentPropertyValues.SortColumn = "ModeID";
//			_siteComponentPropertyValues.Sort();
	
			_siteCompProperties.ItemAdded+=new EventHandler(_siteCompProperties_ItemAdded);
		
		}


		private void ResetCollectionState(CustomCollection customCollection)
		{
			foreach(BaseObject obj in customCollection.DeletedItems)
			{
				obj.ResetObjectState();
				customCollection.Add(obj);
			}
			customCollection.DeletedItems.Clear();
		}

		public void InitDataSource(string dynamicCaseID)
		{
			_called = true;
			if(_lrrLookUpProperties != null)
				_lrrLookUpProperties.Clear();
			if(_levels!= null)
				_levels.Clear(); 

			if(_lrrPropertyTypes!=null)
				_lrrPropertyTypes.Clear();


			ResetCollectionState(LRRDynamicModel.DynamicSiteComponents);
			ResetCollectionState(LRRDynamicModel.DynamicSiteComponentProperties);
			ResetCollectionState(LRRDynamicModel.DynamicSiteComponentPropertyValues);
			ResetCollectionState(LRRDynamicModel.DynamicSiteCompGrpProps);
//			ResetCollectionState(LRRModel.HistDatas);
//			ResetCollectionState(LRRModel.Model);
			
			_siteComponents = LRRDynamicModel.DynamicSiteComponents.FilterDynamicSiteComponentsByDynamicCaseID(dynamicCaseID);
			_siteCompProperties = LRRDynamicModel.DynamicSiteComponentProperties;
			_siteComponentPropertyValues = LRRDynamicModel.DynamicSiteComponentPropertyValues;
			_siteComponentPropertyOriginalValues = _siteComponentPropertyValues;
			_siteCompGroupedProperties = LRRDynamicModel.DynamicSiteCompGrpProps;//LRRModel.SiteComponentGroupPropertiesObj;
			
			_siteGroupPropertyQualifierValues = new LRRDynamicSiteGroupPropertyQualifierValues();
			_lrrLookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(_lrrLookUpProperties,false);
			

			_lrrPropertyTypes = new LRRPropertyTypes();
			_app.DBManagerObj.PopulateCollection(_lrrPropertyTypes,false);

			_levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(_levels,false);  
			
			//Populate from Model
			_lrrHistdata = LRRModel.HistDatas;


//			LRRMasterComponents masterComponents = LRRModel.Model;
//			lrrFormulaSiteComponents.Clear();
//			lrrFormulaSiteComponents.Add(0,masterComponents);
//			lrrFormulaSiteComponents.Add(1,"MasterComponents");
//			lrrFormulaSiteComponents.Add(2,"SiteComponentsObj");
//			lrrFormulaSiteComponents.Add(3,"Properties");
//
//			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
//			LRRFormulaDataStore.ModeFlag = true;
//			
//			_siteComponentPropertyValues.SortColumn = "ModeID";
//			_siteComponentPropertyValues.Sort();


			_siteCompProperties.ItemAdded+=new EventHandler(_siteCompProperties_ItemAdded);

		}


		/// <summary>
		/// 1. Initialises the Columns of the Grid using the type of the collection
		/// 2. Sets the Filter to the Grid.
		/// 3. Hooks up to the relative cell helper instance.
		/// </summary>
		private void InitializeGrid()
		{
			//Suspend the Layout of the Grid...
			gridSiteComponent.SuspendLayout();
			
			this.gridSiteComponent.TableDescriptor.RecordFilters.Clear();
			this.gridSiteComponent.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			gridSiteComponent.TableDescriptor.AllowNew = true;
			gridSiteComponent.TableDescriptor.AllowRemove = true;
			gridSiteComponent.TableDescriptor.AllowEdit = true;
			gridSiteComponent.TableControlCurrentCellCloseDropDown+=new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(gridSiteComponent_TableControlCurrentCellCloseDropDown);
			gridSiteComponent.TableControlCurrentCellShowingDropDown+=new GridTableControlCurrentCellShowingDropDownEventHandler(gridSiteComponent_TableControlCurrentCellShowingDropDown);			
			gridSiteComponent.TableDescriptor.Relations.Clear();
			gridSiteComponent.Engine.SourceListSet.Clear();

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_siteComponents.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,_siteComponents.ItemType,null,fkData);

			//Add the parent table for the Relations...
			gridSiteComponent.Engine.SourceListSet.Add("ParentTable",_siteComponents);
			
			//Set the data source for the grid
			
			gridSiteComponent.DataSource = null;
			gridSiteComponent.DataSource = _siteComponents;

			//Properties for the site component
			GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
			grdCompProps.ChildTableName = "Properties";
			grdCompProps.RelationKeys.Add("SiteComponentID","ComponentID");
			grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.DarkGoldenrod;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");
			gridSiteComponent.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
			grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			gridSiteComponent.TableDescriptor.Relations.Add(grdCompProps);
			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			gridSiteComponent.Engine.SourceListSet.Add("Properties",_siteCompProperties);

			// registration for Tree Control for Plant levels....
			gridSiteComponent.TableModel.CellModels.Add("DropDownTree",new PlantLevelUserFormTreeControl(this.gridSiteComponent.TableModel,new PlantLevelTreeControlStructure()));         
			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grdCompProps.ChildTableDescriptor,_siteCompProperties.ItemType,null);
			gridSiteComponent.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridSiteComponent_QueryCellStyleInfo);  
			grdCompProps.ChildTableDescriptor.RecordExpanding+=new RecordEventHandler(ChildTableDescriptor_RecordExpanding);
			grdCompProps.ChildTableDescriptor.RecordCollapsing+=new RecordEventHandler(ChildTableDescriptor_RecordCollapsing);
			
		
			grdCompProps.ChildTableDescriptor.Columns["UOM"].AllowFilter = false;
//			grdCompProps.ChildTableDescriptor.Columns["ModelUOM"].AllowFilter = false;
			grdCompProps.ChildTableDescriptor.Columns["HistTagID"].AllowFilter = false;
			grdCompProps.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";
//			grdCompProps.ChildTableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";

			GridTableCellStyleInfo gtc1 = grdCompProps.ChildTableDescriptor.Columns["UOM"].Appearance.AnyRecordFieldCell;
			gtc1.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;					
			gtc1.ExclusiveChoiceList = false;
			
			
			GridTableCellStyleInfo gtc = grdCompProps.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell;
			gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			gtc.DataSource = _lrrHistdata; 
			gtc.ValueMember	= "HistTagUID";
			gtc.DisplayMember =	"HistTag";

			
			//Property Values for the property
			GridRelationDescriptor grdCompPropValues = new GridRelationDescriptor("PropertyValues");
			grdCompPropValues.ChildTableName = "PropertyValues";
			grdCompPropValues.RelationKeys.Add("ID","SiteComponentPropertyID");
			grdCompPropValues.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.OrangeRed;
			grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompPropValues.ChildTableDescriptor.AllowEdit = true;//false;
			grdCompPropValues.ChildTableDescriptor.AllowRemove = false;
			grdCompPropValues.ChildTableDescriptor.AllowNew = false;
			grdCompPropValues.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_VALUES")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");
			grdCompPropValues.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			grdCompProps.ChildTableDescriptor.Relations.Add(grdCompPropValues);
			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Properties",_siteCompProperties);
			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("PropertyValues",_siteComponentPropertyValues); 
			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			grdCompPropValues.ChildTableDescriptor.TopLevelGroupOptions.ShowFilterBar = false;
			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grdCompPropValues.ChildTableDescriptor,_siteComponentPropertyValues.ItemType,null);
			grdCompPropValues.ChildTableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompPropValues.ChildTableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

			GridTableCellStyleInfo gtc2 = grdCompPropValues.ChildTableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell;
			gtc2.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;					
			gtc2.ExclusiveChoiceList = false;

			grdCompPropValues.ChildTableDescriptor.GroupExpanding+=new GroupEventHandler(ChildTableDescriptor_GroupExpanding);

			//Resume the Layout of the Grid...
			gridSiteComponent.ResumeLayout(true);

			string[,] arry=new string[,]{{"Description","255"},{"Comments","255"}};
			Validations	objValidations=new Validations(gridSiteComponent,arry);
			
		}


		private void EquipmentEntry_Load(object sender, System.EventArgs e)
		{
			//Standard Method to initialize the grid component

			initializing = true;
			gridSiteComponent.RecordDeleting+=new RecordEventHandler(gridSiteComponent_RecordDeleting);
			_gridExcelFormatter.WireGrid(gridSiteComponent);
			//gridSiteCompProperties.RecordDeleting+=new RecordEventHandler(gridSiteComponent_RecordDeleting);
			//gridSiteComponent.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridSiteComponent_QueryCellStyleInfo);  
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private LRRDynamicSiteComponentProperty ConverMaterPropToSiteCompProp(LRRMasterProperty lmpObj)
		{
			LRRDynamicSiteComponentProperty lscp = new LRRDynamicSiteComponentProperty();
			lscp.ComponentID = lmpObj.ComponentID;
			lscp.Name = lmpObj.Name;
			lscp.Description = lmpObj.Description;
			lscp.UOMTypeID = lmpObj.MasterPropertyUOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.UOM = _lrrMSD.GetLocaleUOM(_LocaleID,lscp.UOMTypeID);
			//lscp.Derivation = lmpObj.Derivation;
			//lscp.Direction = lmpObj.Direction;
			if (lrrMasterPropertyDirections.Contains(lmpObj.PropID) == false)
			{
				if(lmpObj.Direction == null)
					lrrMasterPropertyDirections.Add(lmpObj.PropID,"");
				else
					lrrMasterPropertyDirections.Add(lmpObj.PropID,lmpObj.Direction);
			}
			lscp.Type = lmpObj.Type;
			lscp.ModeID = lmpObj.ModeID;
			lscp.PropertyID = lmpObj.PropID;
			
			//Create Property Values if the Type = "1"
			string sType = lscp.Type == null? "" : lscp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(sType == "1")
				CreatePropertyValues(lscp.ModeID,lscp.ID);
			
			return lscp;
		}

		public LRRDynamicSiteComponentGroupProperty ConverMaterGrpPropToSiteCompGrpProp(LRRGroupProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string sPropID)
		{
			LRRDynamicSiteComponentGroupProperty lscp = new LRRDynamicSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.AttributeName;
			lscp.AttributeDescription = lmgp.AttributeDescription;
			lscp.UOMTypeID = lmgp.MasterPropertyUOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = lmgp.ModeID;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			lscp.MasterPropID =lmgp.MasterPropertyID;
			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						QualifierPropertyValue.ModeID = objMode.ModeId;
						QualifierPropertyValue.SiteComponentPropID = sPropID;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
						string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if((sDirection == "Input/Output") || (sDirection == "3"))
						{
							if(objMode.ModeId == "1")
								sDirection = "1";
						}
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = lmgp.Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
//						LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
						
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					QualifierPropertyValue.ModeID = "0";
					QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
					QualifierPropertyValue.SiteComponentPropID = sPropID;
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = lmgp.Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
//					LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
				}

			}
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}
		public LRRDynamicSiteComponentGroupProperty ConverLookupPropToSiteCompGrpProp(LRRLookUpProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string sPropID)
		{
			LRRDynamicSiteComponentGroupProperty lscp = new LRRDynamicSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.Name;
			lscp.AttributeDescription = lmgp.Description;
			//lscp.UOMTypeID = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID). UOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = blnModeFlag;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			
			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
							
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						
						QualifierPropertyValue.ModeID = objMode.ModeId;
						QualifierPropertyValue.SiteComponentPropID = sPropID;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						
						string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
					
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					QualifierPropertyValue.SiteComponentPropID = sPropID;
					
					QualifierPropertyValue.ModeID = "0";
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					
				}

			}
			
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}

		public LRRDynamicSiteComponentGroupProperty ConverMaterGrpPropToSiteCompGrpPropForDataArrays(LRRGroupProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string siteCompPropID)
		{
			LRRDynamicSiteComponentGroupProperty lscp = new LRRDynamicSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.AttributeName;
			lscp.AttributeDescription = lmgp.AttributeDescription;
			lscp.UOMTypeID = lmgp.MasterPropertyUOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = lmgp.ModeID;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			lscp.MasterPropID =lmgp.MasterPropertyID;
//			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
//			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						QualifierPropertyValue.ModeID = objMode.ModeId;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
						QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
						string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if((sDirection == "Input/Output") || (sDirection == "3"))
						{
							if(objMode.ModeId == "1")
								sDirection = "1";
						}
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = lmgp.Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
//						LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
						
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					QualifierPropertyValue.ModeID = "0";
					QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
					QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = lmgp.Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
//					LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
				}

//			}
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}
		public LRRDynamicSiteComponentGroupProperty ConverLookupPropToSiteCompGrpPropForDataArrays(LRRLookUpProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string siteCompPropID)
		{
			LRRDynamicSiteComponentGroupProperty lscp = new LRRDynamicSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.Name;
			lscp.AttributeDescription = lmgp.Description;
			//lscp.UOMTypeID = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID). UOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = blnModeFlag;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			
//			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
//			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
							
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						
						QualifierPropertyValue.ModeID = objMode.ModeId;
						QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						
						string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRDynamicSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRDynamicSiteGroupPropertyQualifierValue();
					
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					
					QualifierPropertyValue.ModeID = "0";
					QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					
				}

//			}
			
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}
		#endregion

		/// <summary>
		/// Event Handler for the XP Style Menu click...
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void bar_Click(object sender, EventArgs e)
		{
			BarItem item = sender as BarItem;
			if(item.ID == "MP")
			{
				LRRSiteComponent sc = (LRRSiteComponent)gridSiteComponent.CurrencyManager.Current;
				LRRMasterProperties lmps = new LRRMasterProperties();
				if(sc != null)
				{
					if(sc.MasterComponentType != null)
					{
						if(!sc.MasterComponentType.Trim().Equals(""))
						{
							//lmps = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByType(sc.MasterComponentType);
							_app.DBManagerObj.PopulateCollection(lmps," WHERE ComponentTypeID ='" + sc.MasterComponentType + "'" + " AND PropertyID NOT IN(SELECT PropertyID FROM SiteComponentProperties WHERE ComponentID = '" + sc.MasterComponentType + "')");
						}
						
					}
				}

				AddMasterProperties amp = new AddMasterProperties(lmps,sc.SiteComponentID);
				amp.ShowDialog(this);

				foreach(LRRMasterProperty lmp in lmps)
				{
					BaseObject bo = lmp as BaseObject;
					if(bo.IsSelected == true)
					{
						sc.Properties.Add(ConverMaterPropToSiteCompProp(lmp));
					}
				}

			}
			else
			{
				LRRSiteComponent lsc = gridSiteComponent.CurrencyManager.Current as LRRSiteComponent; 
				//LRRSiteComponentProperty lscp = gridSiteCompProperties.CurrencyManager.Current as LRRSiteComponentProperty;
				//FormulaWindow fw = new FormulaWindow(/*_siteComponents,lscp.ID*/);
				//fw.ShowDialog(this);
			}
		}

		private void EquipmentEntry_Closed(object sender, System.EventArgs e)
		{
			_gridExcelFormatter.UnwireGrid();
		}

		//Call the save Method
		private void barSave_Click(object sender, EventArgs e)
		{
			Save();
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true; 
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}


		private void gridSiteComponent_RecordDeleting(object sender, RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false; 
			}
			if(_isRecordeDel)
			{
				if(e.Record.GetData().GetType() == typeof(LRRSiteComponent))
				{
					NestedTable nt = e.Record.NestedTables["Properties"];
					for(int i=nt.ChildTable.Records.Count - 1;i>=0;i--)
					{
				
						NestedTable propValuesTable = nt.ChildTable.Records[i].NestedTables["PropertyValues"];
						for(int k= propValuesTable.ChildTable.Records.Count -1;k>=0;k--)
						{
							object propValObj = propValuesTable.ChildTable.Records[k].GetData();
							_siteComponentPropertyValues.Remove(propValObj);
						}
						object obj = nt.ChildTable.Records[i].GetData();
						_siteCompProperties.Remove(obj);
					}
				}
				else if(e.Record.GetData().GetType() == typeof(LRRSiteComponentProperty))
				{
	

					NestedTable propValuesTable = e.Record.NestedTables["PropertyValues"];
					for(int j= propValuesTable.ChildTable.Records.Count -1;j>=0;j--)
					{
						object propValObj = propValuesTable.ChildTable.Records[j].GetData();
						_siteComponentPropertyValues.Remove(propValObj);
					}
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}

		}

		private void barShowProperties_Click(object sender, EventArgs e)
		{
			_ShowGridColumnsDialog(gridSiteComponent.Engine.TableDescriptor,"Columns",null,typeof(GridColumnDescriptorCollection));
		}

		internal DialogResult _ShowGridColumnsDialog(object instance, string propertyName, IServiceProvider provider, Type type)
		{
			GroupingCollectionEditor ce = new GroupingCollectionEditor(type);
			Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer esc = new Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer(provider);
			PropertyDescriptor pd = TypeDescriptor.GetProperties(instance)[propertyName];
			Syncfusion.ComponentModel.TypeDescriptorContext tdc = new Syncfusion.ComponentModel.TypeDescriptorContext(instance, pd);
			tdc.ServiceProvider = esc;

			ce.EditValue(tdc, esc, pd.GetValue(instance));

			return esc.DialogResult;
		}

		/// <summary>
		/// Hook up to the event of the sitecomponet property addition..
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void _siteCompProperties_ItemAdded(object sender, EventArgs e)
		{
			LRRDynamicSiteComponentProperty lscp = sender as LRRDynamicSiteComponentProperty;
			string sPropertyType = "";
			sPropertyType = lscp.Type == null ? "" : lscp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if((sPropertyType == "1") && (sPropertyType == "2"))
			{
				if(lscp.ModeID ==  true)
				{
					LRRModeSetDefinitions tmpObj = (LRRModeSetDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRModeSetDefinitions));
					foreach(LRRModeSetDefinition lmsd in tmpObj)
					{
						LRRSiteComponentPropertyValue lscpv = new LRRSiteComponentPropertyValue();
						lscpv.ModeID = lmsd.ModeID;
						lscpv.SiteComponentPropertyID = lscp.ID;
						if(lscp.PropertyID != null)
						{
							if(lrrMasterPropertyDirections[lscp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)] != null)
							{
								string sDirection = lrrMasterPropertyDirections[lscp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString();
								lscpv.Direction=sDirection ;
								if((sDirection == "Input/Output") || (sDirection == "3"))
								{
									if(lmsd.ModeID == "1")
										lscpv.Direction = "1";
								}
								//Hook Cascading logic here
							}
						}
						_siteComponentPropertyValues.Add(lscpv);
					}
					gridSiteComponent.Refresh();
					
				}
			}
		}

		private void gridSiteComponent_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
			try
			{
			
				if(gridSiteComponent.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
					Element eCurrentInnerElement = gridSiteComponent.TableControl.Table.GetInnerMostCurrentElement();    
					if(eCurrentElement == null)
						return;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}

					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					tableModel = childTable.ParentTable.TableModel;
					int iRow = e.TableControl.CurrentCell.RowIndex;
					int iCol = e.TableControl.CurrentCell.ColIndex;
					string sColHeader = "";
					if(tableModel.GetColumnDescriptorAt(iRow,iCol) != null)
					{
						sColHeader = tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
					}

					//--Added the following code by Nidhig on 26th Jan to implement the revised logic of grouped properties
					if(sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_SIMPLEGROUP")) || sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_MODE"))|| sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_UIUOM")))
					{
						if(e.TableControl.CurrentCell.Renderer == null)
							return;
						
						string nVal = e.TableControl.CurrentCell.Renderer.ControlText.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string nControlVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
						string oldVal = tableModel[iRow,iCol].FormattedText;

						if(nVal == oldVal)
							return;

						string currentSimpleGoruped = "";
						bool currentModeFlag;
						//Gets the current Site Component Property
						LRRDynamicSiteComponentProperty objCompProp = e.TableControl.Table.CurrentRecord.GetData() as LRRDynamicSiteComponentProperty;
						string sPropID = objCompProp.ID;
						currentSimpleGoruped = objCompProp.Type;
						currentModeFlag = objCompProp.ModeID;
						string masterPropID = objCompProp.PropertyID;

						//Gets the values in case of simple properties
						LRRDynamicSiteComponentPropertyValues objValues = new LRRDynamicSiteComponentPropertyValues();
						//Gets the grouped properties
						LRRDynamicSiteComponentGroupProperties objGrpProps = null;//_siteCompGroupedProperties.GetSiteCompGroupPropFromSiteCompPropID(sPropID);
						
						ArrayList arrChildRecords = new ArrayList();
						if(e.TableControl.Table.CurrentRecord.Kind != DisplayElementKind.AddNewRecord)
						{
							arrChildRecords = GetChildRecords(e,"PropertyValues");
						}
						for(int i=0;i < arrChildRecords.Count;i++)
						{
							objValues.Add(arrChildRecords[i]);
						}
						if((objGrpProps.Count > 0) || (objValues.Count>0))
						{
							/*
							if(sColHeader.StartsWith("UI UOM"))
							{
								Hashtable propValuesHash = new Hashtable();
								int modeCount = LRRModel.ProjectModes.Count;  
								ArrayList arrPropValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(objCompProp.ID);
								Hashtable htPropValues = new Hashtable();
								for(int i=0;i < arrPropValues.Count;i++)
								{
									LRRSiteComponentPropertyValue scpvalue = arrPropValues[i] as LRRSiteComponentPropertyValue;
									htPropValues.Add(scpvalue.ModeID,scpvalue);
								}
								for(int j=modeCount;j>=0;j--)
								{
									LRRSiteComponentPropertyValue propValue = htPropValues[j.ToString(Symcon.BusinessObjects.SymConverter.Culture)] as LRRSiteComponentPropertyValue;//objCompProp.GetValueObjectForPropertyMode(j.ToString(Symcon.BusinessObjects.SymConverter.Culture));  
									string oldValueID= objCompProp.UOM;
									string newValueID= e.TableControl.CurrentCell.Renderer.ControlValue.ToString();    
									if(propValue != null)
									{
										string propertyValue = _app.UOMConversionUtilityObj.ConvertUOM(oldValueID,newValueID,propValue.PropertyValue);    
										propValuesHash.Add(propValue,propertyValue);
									}
								}
								e.TableControl.CurrentCell.ConfirmChanges(true);
								for(int j=modeCount;j>=0;j--)
								{
									LRRSiteComponentPropertyValue propValue = htPropValues[j.ToString(Symcon.BusinessObjects.SymConverter.Culture)] as LRRSiteComponentPropertyValue;//objCompProp.GetValueObjectForPropertyMode(j.ToString(Symcon.BusinessObjects.SymConverter.Culture)); 
									if(propValue != null && propValuesHash.ContainsKey(propValue))
									{
										string propertyValue = propValuesHash[propValue] == null ? null : propValuesHash[propValue].ToString();
										propValue.PropertyValue = propertyValue;
									}
								}
                                return;
							}*/
							DialogResult k = LRRMessagBox.ShowMessage("SID_LOSE_PROPERTYVALUE","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
							if(k == DialogResult.Yes) 
							{
								for(int i= objGrpProps.Count - 1;i >=0;i--)
								{
									LRRDynamicSiteComponentGroupProperty obj = objGrpProps[i];
									_siteCompGroupedProperties.Remove(obj);
								}
								foreach(LRRDynamicSiteComponentPropertyValue objValue in objValues)
								{
									_siteComponentPropertyValues.Remove(objValue);
								}
							}
							else
							{
								e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
								return;
							}
						}

						//Check for "Simple/Grouped" OR "Mode"
						if(sColHeader == "Simple/Grouped")
						{
							//Creating the Properties on change of simple /grouped
//							if(currentModeFlag)
//							{
								if(nVal == "Simple")
								{
									CreatePropertyValues(currentModeFlag,sPropID);
								}
								else
								{
									LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(nControlVal);
									if(propTypeObj != null && propTypeObj.IsDataArray)
									{
										//Create Grouped Properties for Data Arrays
										CreateGroupPropertiesForDataArrays(currentModeFlag,objCompProp,nControlVal);
									}
									else
									{
										//Create Grouped Properties
										CreateGroupProperties(currentModeFlag,objCompProp,nControlVal);
									}
								}
//							}
//							else
//							{
//								if(nVal == "Simple")
//								{
//									CreatePropertyValues(currentModeFlag,sPropID);
//								}
//								else
//								{
//
//									//Create Grouped Properties
//									CreateGroupProperties(currentModeFlag,objCompProp,nControlVal);
//									
//								}
//							}
						}
						else if(sColHeader == "Mode")
						{
							//Creation of the ptroperties on change of mode true/false..
							//Creating the Properties on change of simple /grouped

							string sType = objCompProp.Type == null? "" : objCompProp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);

							if(nVal == "True")
							{
								if(currentSimpleGoruped == "1")
								{
									CreatePropertyValues(true,sPropID);
								}
								else
								{
									LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sType);
									if(propTypeObj != null && propTypeObj.IsDataArray)
									{
										//Create Grouped Properties for Data Arrays
										CreateGroupPropertiesForDataArrays(true,objCompProp,sType);
									}
									else
									{
										//Create Grouped Properties
										CreateGroupProperties(true,objCompProp,sType);
									}
								}
							}
							else
							{
								if(currentSimpleGoruped == "1")
								{
									CreatePropertyValues(false,sPropID);
								}
								else
								{
									LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sType);
									if(propTypeObj != null && propTypeObj.IsDataArray)
									{
										//Create Grouped Properties for Data Arrays
										CreateGroupPropertiesForDataArrays(false,objCompProp,sType);
									}
									else
									{
										//Create Grouped Properties
										CreateGroupProperties(false,objCompProp,sType);
									}
								}
							}

						}
						else
						{
							return;
						}
						e.TableControl.CurrentCell.ConfirmChanges();

					}
				}

				if(e.TableControl.TableDescriptor.IsForeignKeyRelationChildTableDescriptor()) //Check if the Drop Down is in the child table
				{
					int isDerivedIndex = e.TableControl.TableDescriptor.Fields.IndexOf("IsDerived") +  e.TableControl.TableDescriptor.GetColumnIndentCount();
					if(e.TableControl.CurrentCell.ColIndex !=  isDerivedIndex)
					{
						return;
					}
				}
				else
				{
					LRRDynamicSiteComponent currentLRRSC = gridSiteComponent.CurrencyManager.Current as LRRDynamicSiteComponent; 
					int masterComponentTypeIndex = gridSiteComponent.TableDescriptor.Fields.IndexOf("MasterComponentType") - 2;
					if(gridSiteComponent.TableModel.GetHeaderColumnDescriptorAt(e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_MASTERPLANTITEM"))
					{
						//gridSiteComponent.TableModel.
						if(e.TableControl.Table.CurrentRecord == null)
						{
							return;
						}
						if(e.TableControl.Table.CurrentRecord.Kind != DisplayElementKind.AddNewRecord) 
						{
							if(e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records.Count > 0)
							{
								if(e.TableControl.CurrentCell.Renderer.CurrentStyle.CellType ==  "FilterBarCell")
									return;
							
								string nVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
								string oldVal = currentLRRSC.MasterComponentType; 
								if(oldVal != nVal)
								{
									DialogResult k = LRRMessagBox.ShowMessage("SID_LOSE_PROPERTYVALUE","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
									if(k == DialogResult.Yes) 
									{
										for(int i=e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records.Count - 1;i>=0;i--)
										{
											object obj = e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records[i].GetData();
											LRRDynamicSiteComponentProperty lrrscp = obj as LRRDynamicSiteComponentProperty;

											foreach(LRRDynamicSiteComponentPropertyValue lrrscpv in lrrscp.Values)
												_siteComponentPropertyValues.Remove(lrrscpv);

											_siteCompProperties.Remove(obj);
										}
									}
									else
									{
										e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
									}
								}
							}
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCurrentCellCloseDropDown Event:"+ex.Message  ,Logger.Level.Debug);
			}

			
		}

		private void CreateGroupProperties(bool currentModeFlag,LRRDynamicSiteComponentProperty objCompProp,string nControlVal)
		{
			string sMasterPropertyID = objCompProp.PropertyID == null ? "" : objCompProp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			string sPropType = nControlVal;
			LRRLookUpProperties objLookUpProperties = new LRRLookUpProperties();
			string sPropID = objCompProp.ID == null ? "" : objCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
			LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sPropType + "'",false);
		   			
			if(sMasterPropertyID == "")
			{
				objLookUpProperties = _lrrLookUpProperties.getLookUpPropertiesForPropTypeID(sPropType);
				foreach(LRRLookUpProperty objLookUpProperty in objLookUpProperties)
				{
					LRRDynamicSiteComponentGroupProperty lsgp = ConverLookupPropToSiteCompGrpProp(objLookUpProperty,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}
			else
			{
				LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMasterPropertyID);
				LRRGroupProperties objMasterGrpProps = objMasterProp.GroupPpties;
				foreach(LRRGroupProperty objGrpProp in objMasterGrpProps)
				{
					LRRDynamicSiteComponentGroupProperty lsgp = ConverMaterGrpPropToSiteCompGrpProp(objGrpProp,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}
		}

		private void CreateGroupPropertiesForDataArrays(bool currentModeFlag,LRRDynamicSiteComponentProperty objCompProp,string nControlVal)
		{
			string sMasterPropertyID = objCompProp.PropertyID == null ? "" : objCompProp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			string sPropType = nControlVal;
			LRRLookUpProperties objLookUpProperties = new LRRLookUpProperties();
			string sPropID = objCompProp.ID == null ? "" : objCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
			LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sPropType + "'",false);
		   			
			if(sMasterPropertyID == "")
			{
				objLookUpProperties = _lrrLookUpProperties.getLookUpPropertiesForPropTypeID(sPropType);
				foreach(LRRLookUpProperty objLookUpProperty in objLookUpProperties)
				{
					LRRDynamicSiteComponentGroupProperty lsgp = ConverLookupPropToSiteCompGrpPropForDataArrays(objLookUpProperty,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}
			else
			{
				LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMasterPropertyID);
				LRRGroupProperties objMasterGrpProps = objMasterProp.GroupPpties;
				foreach(LRRGroupProperty objGrpProp in objMasterGrpProps)
				{
					LRRDynamicSiteComponentGroupProperty lsgp = ConverMaterGrpPropToSiteCompGrpPropForDataArrays(objGrpProp,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}
		}

		private void CreatePropertyValues(bool currentModeFlag,string sPropID)
		{
			if(currentModeFlag)
			{
				for(int i=0;i < LRRModel.ProjectModes.Count;i++)
				{
					LRRMode mode = LRRModel.ProjectModes[i] as LRRMode;
					if(mode.ModeId != "0")
					{
						LRRDynamicSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRDynamicSiteComponentPropertyValue();
						lrrSiteComponentPropertyValue.ModeID = mode.ModeId;
						lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
						lrrSiteComponentPropertyValue.IsEditable = true;
						lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
						//Add Cascading logic here
						_siteComponentPropertyValues.Add(lrrSiteComponentPropertyValue);
					}
				}
			}
			else
			{
				LRRDynamicSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRDynamicSiteComponentPropertyValue();
				lrrSiteComponentPropertyValue.ModeID = "0";
				lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
				lrrSiteComponentPropertyValue.Direction = "1";
				lrrSiteComponentPropertyValue.Derivation = "4";
				lrrSiteComponentPropertyValue.IsEditable = true;
				lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
				//Add Cascading logic here
				_siteComponentPropertyValues.Add(lrrSiteComponentPropertyValue);
			}

		}

		private ArrayList GetChildRecords(Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e,string childGrid)
		{	
			ArrayList arrObjs = new ArrayList();
			for(int i= e.TableControl.Table.CurrentRecord.NestedTables[childGrid].ChildTable.Records.Count - 1;i >=0;i--)
			{
				object obj = e.TableControl.Table.CurrentRecord.NestedTables[childGrid].ChildTable.Records[i].GetData();
				arrObjs.Add(obj);
			}
			return arrObjs;
		}

		GridRelationDescriptor AddRelation(string name, GridRelationDescriptorCollection relations,string propName)
		{
			GridRelationDescriptor children = new GridRelationDescriptor();
			children.RelationKind = RelationKind.UniformChildList;
			children.MappingName = propName;
			children.Name = name;
			relations.Add(children);
			return children;
		}

		private void barPaste_Click(object sender, EventArgs e)
		{
			IDataObject obj = Clipboard.GetDataObject();
			string text = (string)obj.GetData(DataFormats.Text);
			MessageBox.Show(text);
		}

		//When new Property Override gets added...
		private void _siteCompPropsUserAndTimes_ItemAdded(object sender, EventArgs e)
		{
			LRRSiteComponentProperty lscp = sender as LRRSiteComponentProperty;
			if(lscp.ModeID ==  true)
			{
				LRRModeSetDefinitions tmpObj = (LRRModeSetDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRModeSetDefinitions));
				foreach(LRRModeSetDefinition lmsd in tmpObj)
				{
					LRRSiteComponentPropertyValue lscpv = new LRRSiteComponentPropertyValue();
					lscpv.ModeID = lmsd.ModeID;
					lscpv.SiteComponentPropertyID = lscp.ID;
					
					string sDirection = lrrMasterPropertyDirections[lscp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString();
					lscpv.Direction=sDirection ;
					if((sDirection == "Input/Output") || (sDirection == "3"))
					{
						if(lmsd.ModeID == "1")
							lscpv.Direction = "1";
					}
					//Hook Cascading logic here
					_siteComponentPropertyValues.Add(lscpv);
				}
				gridSiteComponent.Refresh();
			}

		}
		
		/// <summary>
		/// To BE REMOVED
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Override(object sender,EventArgs e)
		{
		
			Element eCurrentInnerElement = gridSiteComponent.Table.GetInnerMostCurrentElement(); 
			//GridRecord gnt = eCurrentInnerElement as GridRecord;

			Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
			GridNestedTable gnt = eCurrentElement as GridNestedTable;
			GridNestedTable gnt1 = gnt;
			GridTableDescriptor gtd = null;
			GridTableModel tableModel = new GridTableModel();
			while(gnt1 != null && gnt1.ChildTable != null)
			{
				gnt = gnt1;
				gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
				gtd = gnt.ParentTable.ParentTableDescriptor;
			}

			bool bTrack = (bool)gnt.ParentRecord.GetValue("IsTracked");
			

			LRRSiteComponentPropertyValue  objPropertyValue = eCurrentInnerElement.GetRecord().GetData() as LRRSiteComponentPropertyValue;
			if(eCurrentInnerElement.GetRecord().GetData() != null && bTrack)
			{
				LRRSiteComponentPropertyValueChanges objPropertyValueChanges = new LRRSiteComponentPropertyValueChanges();
				LRRMode objMode = new LRRMode();
				_app.DBManagerObj.PopulateCollection(objPropertyValueChanges," WHERE SiteComponentPropertyID ='" + objPropertyValue.SiteComponentPropertyID + "' and ModeID = '"+objPropertyValue.ModeID+"' ");
				_app.DBManagerObj.PopulateObject(objMode,typeof(LRRMode)," Where ModeID = '"+objPropertyValue.ModeID+"'");    
				if(objPropertyValueChanges.Count == 0 )
				{
					objPropertyValueChanges.Add(ConverChanges(objPropertyValue));
				}
				SiteComponentPropertyValueOverrides amp = new SiteComponentPropertyValueOverrides(objPropertyValueChanges);
				amp.Text = amp.Text + " [" + objMode.ModeName + "]";
				amp.ShowDialog(this);
			}
			else
			{
				LRRMessagBox.ShowMessage("SID_PROPVALUE_OVERRIDE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);      
			}
		}


		private LRRSiteComponentPropertyValueChange ConverChanges(LRRSiteComponentPropertyValue objPropValue)
		{
			
			LRRSiteComponentPropertyValueChange  propValChange = new LRRSiteComponentPropertyValueChange();
			propValChange.SiteComponentPropertyValueID = objPropValue.ID;
			propValChange.SiteComponentPropertyID = objPropValue.SiteComponentPropertyID;
			propValChange.PropertyValue= objPropValue.PropertyValue;
			propValChange.ModeID= objPropValue.ModeID;
			//&&&&propValChange.FormulaID= objPropValue.FormulaID;
			propValChange.EffectivePlantTime = objPropValue.EffectivePlantTime;
			return propValChange;
		}
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			
			this.Cursor = Cursors.WaitCursor;
			_gridExcelFormatter.UnwireGrid();
//			if(_called)
//			{
				InitDataSource(_dynamicCaseID);

//			}	
//			else
//			{	
				//InitDataSource();
//			}		
			gridSiteComponent.TableModel.CellModels.Remove("DropDownTree");  
			gridSiteComponent.TableDescriptor.Relations.Clear();
			gridSiteComponent.QueryCellStyleInfo-=new GridTableCellStyleInfoEventHandler(gridSiteComponent_QueryCellStyleInfo);  
			InitializeGrid();
			//oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
			//oForAlerts.Clear();
			_gridExcelFormatter.WireGrid(gridSiteComponent);
			this.Cursor = Cursors.Default;
		}

		public void Save()
		{
			this.gridSiteComponent.Table.EndEdit();    
			this.gridSiteComponent.GetTable("Properties").EndEdit();	
			bool isSaved = false;
			if(_siteComponents.GetChanges().Count > 0)
			{
				LRRDynamicSiteComponents toSaveSiteComponents = _siteComponents.GetChanges();
				int changesCount = _siteComponents.GetChanges().Count;
				for(int i=0;i<changesCount;i++)
				{
					LRRDynamicSiteComponent lsc = toSaveSiteComponents[i] as LRRDynamicSiteComponent;
					if(lsc.ObjectState != DBOperation.DELETE)
					{
                        lsc.DynamicCaseID = _dynamicCaseID;
						if(lsc.Name == null || lsc.Name.Trim()=="")
						{
							LRRMessagBox.ShowMessage("SID_PLANTITEM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
							return;
						}
						if(lsc.MasterComponentType == null)
						{
							string[] s = new string[1];
							s[0] = lsc.Name;
							LRRMessagBox.ShowMessage("SID_MASTERPLANT_NULL","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);      
							return;
						}
					}
				}
				_app.DBManagerObj.CommitCollection(toSaveSiteComponents); //Commit Site Components
				
				if(toSaveSiteComponents.HasError)
				{
					LRRMessagBox.ShowMessage("SID_REFERENTIALINTEGRITY_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					return;
				}
				
				//Add to Model
				IEnumerator iSiteCompEnum = toSaveSiteComponents.GetEnumerator();
				while(iSiteCompEnum.MoveNext())
				{
					LRRDynamicSiteComponent dynamicSiteComp = iSiteCompEnum.Current as LRRDynamicSiteComponent;

                    if (dynamicSiteComp.ObjectState != DBOperation.DELETE)
                    {
                        LRRSiteComponent siteComponent = new LRRSiteComponent();
                        siteComponent.SiteComponentID = dynamicSiteComp.SiteComponentID;
                        siteComponent.Name = dynamicSiteComp.Name;
                        siteComponent.MasterComponentType = dynamicSiteComp.MasterComponentType;
                        siteComponent.PlantUnit = dynamicSiteComp.PlantUnit;
                        siteComponent.Description = dynamicSiteComp.Description;
                        siteComponent.EquipmentTag = dynamicSiteComp.EquipmentTag;
                        siteComponent.EffectivePlantTime = dynamicSiteComp.EffectivePlantTime;
                        siteComponent.IsDynamic = true;
                        siteComponent.ObjectState = DBOperation.UNCHANGED;
                        LRRModel.SiteComponentsObj.Add(siteComponent);
                        LRRDynamicModel.DynamicSiteComponents.Add(dynamicSiteComp);
                    }
                    else
                    {
                        LRRSiteComponent siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(dynamicSiteComp.SiteComponentID);
                        LRRModel.SiteComponentsObj.Remove(siteComp);
                        LRRDynamicModel.DynamicSiteComponents.Remove(dynamicSiteComp);
                    }
				}

				isSaved = true;
			}
			if(_siteCompProperties.GetChanges().Count > 0)
			{
				LRRDynamicSiteComponentProperties  toSaveProperties = _siteCompProperties.GetChanges();
				for(int i=0;i<toSaveProperties.Count;i++)
				{
					LRRDynamicSiteComponentProperty lscp = toSaveProperties[i] as LRRDynamicSiteComponentProperty; 
					lscp.DynamicCaseID = _dynamicCaseID;
					if(lscp.ObjectState != DBOperation.DELETE)
					{
						if(lscp.Name == null || lscp.Name.Trim()=="")
						{
							LRRMessagBox.ShowMessage("SID_PROPERTY_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
							return;
						}
					}
				}
				_app.DBManagerObj.CommitCollection(toSaveProperties); //Commit Site Components
				if(toSaveProperties.HasError)
				{
					LRRMessagBox.ShowMessage("SID_HASH_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
				}

				//Add to Model
				IEnumerator iSiteCompPropsEnum = toSaveProperties.GetEnumerator();
				while(iSiteCompPropsEnum.MoveNext())
				{
					LRRDynamicSiteComponentProperty dynamicSiteCompProp = iSiteCompPropsEnum.Current as LRRDynamicSiteComponentProperty;

					LRRSiteComponentProperty siteComponentProp = new LRRSiteComponentProperty();
					siteComponentProp.ID = dynamicSiteCompProp.ID;
					siteComponentProp.Name = dynamicSiteCompProp.Name;
					siteComponentProp.Description = dynamicSiteCompProp.Description;
					siteComponentProp.UOMTypeID = dynamicSiteCompProp.UOMTypeID;
					siteComponentProp.UOM = dynamicSiteCompProp.UOM;
					siteComponentProp.ModeID = dynamicSiteCompProp.ModeID;
					siteComponentProp.ComponentID = dynamicSiteCompProp.ComponentID;
					siteComponentProp.Type	= dynamicSiteCompProp.Type;
					siteComponentProp.PropertyID = dynamicSiteCompProp.PropertyID;
					siteComponentProp.IsTracked = dynamicSiteCompProp.IsTracked;
					siteComponentProp.IsTrended = dynamicSiteCompProp.IsTrended;
					siteComponentProp.EffectivePlantTime = dynamicSiteCompProp.EffectivePlantTime;
					siteComponentProp.IsDynamic = true;
					siteComponentProp.ObjectState = DBOperation.UNCHANGED;
					LRRModel.SiteComponentPropertiesObj.Add(siteComponentProp);
				}
				isSaved = true;
			}
			
			if(_siteComponentPropertyValues.GetChanges().Count > 0)
			{
				LRRDynamicSiteComponentPropertyValues toSavePropertyvalues = _siteComponentPropertyValues.GetChanges();
				
//				foreach(LRRDynamicSiteComponentPropertyValue toPropogatePropertyvalue in  toSavePropertyvalues)
//				{
//					if(toPropogatePropertyvalue.Direction == "1" && toPropogatePropertyvalue.Derivation == "4")
//					{
//						MessagingClient.PropertyValueChanged(toPropogatePropertyvalue.SiteComponentPropertyID,toPropogatePropertyvalue.PropertyValue,toPropogatePropertyvalue.ModeID);
//					}
//				}
				_siteComponentPropertyValues.RefreshCollection();  
				
				//Add to Model
				IEnumerator iSiteCompPropValueEnum = toSavePropertyvalues.GetEnumerator();
				while(iSiteCompPropValueEnum.MoveNext())
				{
					LRRDynamicSiteComponentPropertyValue dynamicSiteCompPropValue = iSiteCompPropValueEnum.Current as LRRDynamicSiteComponentPropertyValue;
					dynamicSiteCompPropValue.DynamicCaseID = _dynamicCaseID;

					LRRSiteComponentPropertyValue siteComponentPropValue = new LRRSiteComponentPropertyValue();
					siteComponentPropValue.ID = dynamicSiteCompPropValue.ID;
					siteComponentPropValue.SiteComponentPropertyID = dynamicSiteCompPropValue.SiteComponentPropertyID;
					siteComponentPropValue.PropertyValue = dynamicSiteCompPropValue.PropertyValue;
					siteComponentPropValue.ActualPropertyValue = dynamicSiteCompPropValue.ActualPropertyValue;
					siteComponentPropValue.ModelUOM = dynamicSiteCompPropValue.ModelUOM;
					siteComponentPropValue.Derivation = dynamicSiteCompPropValue.Derivation;
					siteComponentPropValue.ModeID = dynamicSiteCompPropValue.ModeID;
					siteComponentPropValue.EffectivePlantTime = dynamicSiteCompPropValue.EffectivePlantTime;
					siteComponentPropValue.Direction = dynamicSiteCompPropValue.Direction;
					siteComponentPropValue.IsDynamic = true;
					siteComponentPropValue.ObjectState = DBOperation.UNCHANGED;
					LRRModel.PropertyValuesObj.Add(siteComponentPropValue);
				}
				_app.DBManagerObj.CommitCollection(toSavePropertyvalues);
				isSaved = true;
			}
			if(_siteCompGroupedProperties.GetChanges().Count > 0)
			{
				LRRDynamicSiteComponentGroupProperties toSaveGroupProperties = _siteCompGroupedProperties.GetChanges();
				//Commit Site Components

				//Add to Model
				IEnumerator iSiteCompGrpPropsEnum = toSaveGroupProperties.GetEnumerator();
				while(iSiteCompGrpPropsEnum.MoveNext())
				{
					LRRDynamicSiteComponentGroupProperty dynamicSiteCompGrpProp = iSiteCompGrpPropsEnum.Current as LRRDynamicSiteComponentGroupProperty;
					dynamicSiteCompGrpProp.DynamicCaseID = _dynamicCaseID;

					LRRSiteComponentGroupProperty siteComponentGrpProp = new LRRSiteComponentGroupProperty();
					siteComponentGrpProp.GroupPropertyID = dynamicSiteCompGrpProp.GroupPropertyID;
					siteComponentGrpProp.AttributeName = dynamicSiteCompGrpProp.AttributeName;
					siteComponentGrpProp.AttributeDescription = dynamicSiteCompGrpProp.AttributeDescription;
					siteComponentGrpProp.SiteComponentPropID = dynamicSiteCompGrpProp.SiteComponentPropID;
					siteComponentGrpProp.UOM = dynamicSiteCompGrpProp.UOM;
					siteComponentGrpProp.UOMTypeID = dynamicSiteCompGrpProp.UOMTypeID;
					siteComponentGrpProp.ModeID = dynamicSiteCompGrpProp.ModeID;
					siteComponentGrpProp.LookUpPropertiesID = dynamicSiteCompGrpProp.LookUpPropertiesID;
					siteComponentGrpProp.PropertyID = dynamicSiteCompGrpProp.PropertyID;
					siteComponentGrpProp.MasterPropID = dynamicSiteCompGrpProp.MasterPropID;

					siteComponentGrpProp.IsDynamic = true;
					siteComponentGrpProp.ObjectState = DBOperation.UNCHANGED;
					LRRModel.SiteComponentGroupPropertiesObj.Add(siteComponentGrpProp);
				}
				_app.DBManagerObj.CommitCollection(toSaveGroupProperties); 
				isSaved = true;
			}
			if(_siteGroupPropertyQualifierValues.GetChanges().Count > 0)
			{
				LRRDynamicSiteGroupPropertyQualifierValues toSaveQualifierValues = _siteGroupPropertyQualifierValues.GetChanges();
				 //Commit Site GroupPropertyQualifiers Values

				//Add to Model
				IEnumerator iSiteCompQualValueEnum = toSaveQualifierValues.GetEnumerator();
				while(iSiteCompQualValueEnum.MoveNext())
				{
					LRRDynamicSiteGroupPropertyQualifierValue dynamicSiteCompQualValue = iSiteCompQualValueEnum.Current as LRRDynamicSiteGroupPropertyQualifierValue;
					dynamicSiteCompQualValue.DynamicCaseID = _dynamicCaseID;

					LRRSiteGroupPropertyQualifierValue siteComponentQualValue = new LRRSiteGroupPropertyQualifierValue();
					siteComponentQualValue.SiteGroupPropertyQualifierValueID = dynamicSiteCompQualValue.SiteGroupPropertyQualifierValueID;
					siteComponentQualValue.GroupPropertyID = dynamicSiteCompQualValue.GroupPropertyID;
					siteComponentQualValue.LookUpQualifierID = dynamicSiteCompQualValue.LookUpQualifierID;
					siteComponentQualValue.LookUpPropertiesID = dynamicSiteCompQualValue.LookUpPropertiesID;
					siteComponentQualValue.PropertyID = dynamicSiteCompQualValue.PropertyID;
					siteComponentQualValue.QualifierID = dynamicSiteCompQualValue.QualifierID;
					siteComponentQualValue.PropertyValue = dynamicSiteCompQualValue.PropertyValue;
					siteComponentQualValue.ActualPropertyValue = dynamicSiteCompQualValue.ActualPropertyValue;
					siteComponentQualValue.ModeID = dynamicSiteCompQualValue.ModeID;
					siteComponentQualValue.Direction = dynamicSiteCompQualValue.Direction;
					siteComponentQualValue.Derivation = dynamicSiteCompQualValue.Derivation;
					siteComponentQualValue.MasterPropID = dynamicSiteCompQualValue.MasterPropID;
					siteComponentQualValue.SiteComponentPropID = dynamicSiteCompQualValue.SiteComponentPropID;
					siteComponentQualValue.EffectivePlantTime = dynamicSiteCompQualValue.EffectivePlantTime;
					
					siteComponentQualValue.IsDynamic = true;
					siteComponentQualValue.ObjectState = DBOperation.UNCHANGED;
					LRRModel.SiteGroupPropertyQualifierValuesObj.Add(siteComponentQualValue);
				}
				_app.DBManagerObj.CommitCollection(toSaveQualifierValues);
				isSaved = true;
			}
			
			// TO DO:
			// Uncomment the following code once the same is being looked at for Plant Operator
			// For Implementor, the save functionality of Property values is not supported.
			//			if(_siteCompGroupPropertyValues.GetChanges().Count > 0)
			//			{
			//				LRRSiteComponentGroupPropertyValues toSaveGroupPropertyValues = _siteCompGroupPropertyValues.GetChanges();
			//				_app.DBManagerObj.CommitCollection(toSaveGroupPropertyValues); //Commit Site Components
			//				isSaved = true;
			//			}
			//			if(_siteComponentPropertyValues.GetChanges().Count > 0)
			//			{
			//				LRRSiteComponentPropertyValues  toPropertyValues = _siteComponentPropertyValues.GetChanges();
			//				_app.DBManagerObj.CommitCollection(toPropertyValues); //Commit Site Components
			//				isSaved = true;
			//			}
			
			if(!isSaved)
			{
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
			}
			else
			{
				_siteComponents.RefreshCollection();
				_siteCompProperties.RefreshCollection();
				_siteCompGroupedProperties.RefreshCollection();
				_siteGroupPropertyQualifierValues.RefreshCollection();
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			}
		}

		public bool SupportsMasterPropertiesCopy()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void CopyMasterProperties()
		{
			try
			{
				if(gridSiteComponent.TableModel.Table.Records.Count == 0)
				{
					LRRMessagBox.ShowMessage("SID_SELECTEDITEM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
				}
				else
				{
					LRRDynamicSiteComponent sc = (LRRDynamicSiteComponent)gridSiteComponent.TableModel.Table.GetCurrencyManager().Current;
					LRRMasterProperties lmps = new LRRMasterProperties();
					LRRGroupProperties lmgps = new LRRGroupProperties();
					ChildTable ct = null;
					if(gridSiteComponent.TableModel.Table.CurrentRecord != null)
					{
						ct = gridSiteComponent.TableModel.Table.CurrentRecord.NestedTables["Properties"].ChildTable;
					}
					else
					{
						Element innerElement = gridSiteComponent.TableModel.Table.GetInnerMostCurrentElement();
						if(innerElement.ParentChildTable.Name == "PropertyOverrides")
						{
							ct = innerElement.ParentDisplayElement.ParentChildTable;
						}
						else if(innerElement.ParentChildTable.Name == "Properties")
						{
							ct = innerElement.ParentChildTable;
						}
						else
						{
							ct = null;
						}
					}
					if(ct == null)
					{
						LRRMessagBox.ShowMessage("SID_CHILDTABLE_NOTEXISTS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);    
						return;
					}
					string clause = "";
					foreach(Record rec in ct.Records)
					{
						LRRDynamicSiteComponentProperty lscp =  (LRRDynamicSiteComponentProperty)rec.GetData();
						if(lscp.PropertyID != "")
						{
							if(clause != "")
							{
								clause = clause + ",'" + lscp.PropertyID + "'"; 
							}
							else
							{
								clause = "'" + lscp.PropertyID + "'"; 
							}
						}
					}

					if(sc != null)
					{
						if(sc.MasterComponentType != null)
						{
							if(sc.MasterComponentType == "")
							{
								LRRMessagBox.ShowMessage("SID_SELECTEDMASTERPLANTITEM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
								return;
							}

							if(!sc.MasterComponentType.Trim().Equals(""))
							{
								_app.DBManagerObj.PopulateCollection(lmps," WHERE ComponentTypeID ='" + sc.MasterComponentType + "'" + " AND PropertyID NOT IN(SELECT PropertyID FROM DynamicSiteComponentProperties WHERE ComponentID = '" + sc.MasterComponentType + "')");
								if(lmps.Count == 0)
								{
									LRRMessagBox.ShowMessage("SID_MASTERPROPERTIES_NOTEXISTS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
									return;
								}
								else
								{
									string inClause = "";
									if(clause != "")
									{
										inClause = " AND PropertyID NOT IN(" + clause + ")";
									}	
									_app.DBManagerObj.PopulateCollection(lmps," WHERE ComponentTypeID ='" + sc.MasterComponentType + "'" + inClause);
									if(lmps.Count == 0)
									{
										LRRMessagBox.ShowMessage("SID_ALLMASTERPROPERTIES_ADDED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
										return;
									}
								}
							}
						}
						else
						{
							LRRMessagBox.ShowMessage("SID_SELECTEDMASTERPLANTITEM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
							return;
						}
					} 
					AddMasterProperties amp = new AddMasterProperties(lmps,sc.SiteComponentID);
					amp.Text = amp.Text + " [" + sc.Name + "]";
					DialogResult dlgResult = amp.ShowDialog(this);

					if(dlgResult == DialogResult.OK)
					{
						_LocaleID = amp.sLocaleID;

						_app.DBManagerObj.PopulateCollection(lmgps);
						string masterCompID = ((LRRMasterProperty)lmps[0]).ComponentID;
						
						ArrayList list = new ArrayList();
						Hashtable indexes  = new Hashtable();
						for(int i=0;i<gridSiteComponent.TableModel.Table.Records.Count;i++)
						{
							LRRDynamicSiteComponent sc2 = (LRRDynamicSiteComponent)gridSiteComponent.TableModel.Table.Records[i].GetData();
							if(sc2.MasterComponentType==masterCompID)
							{
								list.Add(sc2.SiteComponentID);
								indexes.Add(sc2.SiteComponentID,i);
							}
						}
						if(copyToAll == true)
						{
							foreach(LRRMasterProperty lmp in lmps)
							{
								BaseObject bo = lmp as BaseObject;
								if(bo.IsSelected == true)
								{
									for(int j=0;j<list.Count;j++)
									{
										Hashtable existingHash = new Hashtable();
										ChildTable ct1 = gridSiteComponent.TableModel.Table.Records[(int)indexes[list[j]]].NestedTables["Properties"].ChildTable; 
										for(int k=0;k<ct1.Records.Count;k++)
										{
											LRRDynamicSiteComponentProperty scpOld =(LRRDynamicSiteComponentProperty)ct1.Records[k].GetData();
											if(scpOld.PropertyID != null && scpOld.PropertyID.Trim() != "")
											{
												existingHash.Add(scpOld.PropertyID,"");
											}
										}
										if(!existingHash.ContainsKey(lmp.PropID))
										{
											LRRDynamicSiteComponentProperty lscp = ConverMaterPropToSiteCompProp(lmp);
											lscp.ComponentID = (string)list[j]; 
											_siteCompProperties.Add(lscp);
											foreach(LRRGroupProperty lmgp in lmgps)
											{
												if(lmgp.MasterPropertyID == lmp.PropID)
												{
													string sGrpType = lmp.Type == null ? "" : lmp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
													LRRDynamicSiteComponentGroupProperty lsgp = null;
													LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sGrpType);
													if(propTypeObj != null && propTypeObj.IsDataArray)
													{
														//Create Grouped Properties for Data Arrays
														lsgp = ConverMaterGrpPropToSiteCompGrpPropForDataArrays(lmgp,null,lmgp.ModeID,lscp.ID);
													}
													else
													{
														LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();//LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(sGrpType);// new LRRLookUpQualifiers();
														_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sGrpType + "'",false);
														lsgp = ConverMaterGrpPropToSiteCompGrpProp(lmgp,objQualifiersForGrpType,lmgp.ModeID,lscp.ID);
													}
													
													lsgp.SiteComponentPropID = lscp.ID;
													_siteCompGroupedProperties.Add(lsgp);
												}
											}
										}
									}
								}
							}
						}
						else
						{
							//lmp.ComponentID = sc.SiteComponentID;
							Hashtable existingHash = new Hashtable();
							ChildTable ct1 = gridSiteComponent.TableModel.Table.Records[(int)indexes[sc.SiteComponentID]].NestedTables["Properties"].ChildTable; 
							for(int k=0;k<ct1.Records.Count;k++)
							{
								LRRDynamicSiteComponentProperty scpOld =(LRRDynamicSiteComponentProperty)ct1.Records[k].GetData();
								if(scpOld.PropertyID != null && scpOld.PropertyID.Trim() != "")
								{
									existingHash.Add(scpOld.PropertyID,"");
								}
							}

							foreach(LRRMasterProperty lmp in lmps)
							{
								BaseObject bo = lmp as BaseObject;
								if(bo.IsSelected == true)
								{
									lmp.ComponentID = sc.SiteComponentID;
									if(!existingHash.ContainsKey(lmp.PropID))
									{
										LRRDynamicSiteComponentProperty lscp = ConverMaterPropToSiteCompProp(lmp);
										lscp.ComponentID = sc.SiteComponentID; 
										_siteCompProperties.Add(lscp);
										foreach(LRRGroupProperty lmgp in lmgps)
										{
											if(lmgp.MasterPropertyID == lmp.PropID)
											{
												string sGrpType = lmp.Type == null ? "" : lmp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
												LRRDynamicSiteComponentGroupProperty lsgp = null;
												LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sGrpType);
												if(propTypeObj != null && propTypeObj.IsDataArray)
												{
													//Create Grouped Properties for Data Arrays
													lsgp = ConverMaterGrpPropToSiteCompGrpPropForDataArrays(lmgp,null,lmgp.ModeID,lscp.ID);
												}
												else
												{
													LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();//LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(sGrpType);// new LRRLookUpQualifiers();
													_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sGrpType + "'",false);
													lsgp = ConverMaterGrpPropToSiteCompGrpProp(lmgp,objQualifiersForGrpType,lmgp.ModeID,lscp.ID);
												}
												lsgp.SiteComponentPropID = lscp.ID;
												_siteCompGroupedProperties.Add(lsgp);
											}
										}
									}
								}
							}
						}
								
						copyToAll = false;
					}
					else
					{
						copyToAll = false;
						return;
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"CopyMasterProperties :"+ex.Message  ,Logger.Level.Error);
				//LRRMessagBox.ShowMessage("SID_COPYMASTERPROPERTY_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);      
				return;
			}
		}

		public void Paste()
		{
			// TODO:  Add SiteComponentEntry.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add SiteComponentEntry.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add SiteComponentEntry.Print implementation
			if(gridSiteComponent.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSiteComponent,false);
			}
		}

		public void Delete()
		{
			SyncGridUtilities.DeleteRecords(gridSiteComponent);   
		}

		public void ArrangeColumns()
		{
			// TODO:  Add SiteComponentEntry.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add SiteComponentEntry.ClearFilter implementation
			this.Cursor = Cursors.WaitCursor; 
			SyncGridUtilities.ClearFilter(gridSiteComponent);   
			this.Cursor = Cursors.Default;   
//			this.gridSiteComponent.TableDescriptor.RecordFilters.Clear();
//			this.gridSiteComponent.GetTable("Properties").TableDescriptor.RecordFilters.Clear();     
			//Refresh(); 
		}

		public void ImportToExcel()
		{
			SyncGridUtilities.ImportFromExcel(this.gridSiteComponent);
		}

		public void Export()
		{
			if(gridSiteComponent.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridSiteComponent);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add SiteComponentEntry.SupportsCopy implementation
			return true;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add SiteComponentEntry.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add SiteComponentEntry.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add SiteComponentEntry.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add SiteComponentEntry.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add SiteComponentEntry.SupportsDelete implementation
			return true;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add SiteComponentEntry.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add SiteComponentEntry.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add SiteComponentEntry.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridSiteComponent);
		}

		public void InsertNewRows()
		{
			InsertNewRowsForm insNewRows = new InsertNewRowsForm();
			DialogResult dlgResult = insNewRows.ShowDialog(this);
			int iNumofRows = insNewRows.iNewRows;
			if(dlgResult == DialogResult.OK)
			{
				SyncGridUtilities.InsertNewRows(gridSiteComponent,iNumofRows);
			}
			else
			{
				return;
			}
		}


		
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		private void gridSiteComponent_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			/*
			if(e.Action == CurrentRecordAction.EndEditCalled)
			{	
				if(gridSiteComponent.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}
					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					if(childTable.Name == "Properties")
					{
						LRRMeasurementSystem lms = LRRModel.MeasurementSystems.GetCurrentModelUOM(); 
						LRRMeasurementSystemDefinitions  lmsd = LRRModel.ChildModel.MeasSysDef.GetUOMTypesForMSID(lms.ID);   
						LRRDynamicSiteComponentProperty lscp = e.Record.GetData() as LRRDynamicSiteComponentProperty;
						if(lscp!=null)
						{
							string modelUom = lmsd.GetLocaleUOM(lms.ID,lscp.UOMTypeID);
							lscp.UOM = modelUom;
							ArrayList arrPropValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(lscp.ID);
							if(arrPropValues != null)
							{
								for(int i=0;i < arrPropValues.Count;i++)
								{
									LRRSiteComponentPropertyValue lscpValue = arrPropValues[i] as LRRSiteComponentPropertyValue;
									lscpValue.ModelUOM = modelUom;
								}
							}
						}					     
					}
				}
			}
			if(e.Action == CurrentRecordAction.EnterRecordComplete)
			{
				if(gridSiteComponent.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}

					string sType = gnt.ParentRecord.GetValue("Type") == null ? "" : gnt.ParentRecord.GetValue("Type").ToString();
					
					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					
					if(childTable.Name.Equals("PropertyValues"))
					{
						if(e.Record.IsCaption())
							return;
						string modeID = e.Record.GetRecord().GetValue("ModeID") == null ? "" : e.Record.GetRecord().GetValue("ModeID").ToString();
						string bParentMode = gnt.ParentRecord.GetValue("ModeID") == null ? "" : gnt.ParentRecord.GetValue("ModeID").ToString();
						string propID = e.Record.GetRecord().GetValue("ID") == null ? "" : e.Record.GetRecord().GetValue("ID").ToString();

//						LRRFormulaDataStore.ModeID = modeID;
//						LRRFormulaDataStore.SourceObjectID = propID;
						
						string sPropId = gnt.ParentRecord.GetValue("PropertyID")== null ? "" : gnt.ParentRecord.GetValue("PropertyID").ToString();
						LRRSiteComponentPropertyValue propValueObj = null;
						try
						{
							propValueObj =  (LRRSiteComponentPropertyValue)e.Record.GetData();
						}
						catch(Exception ex)
						{
							Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_CurrentRecordContextChange Event:"+ex.Message  ,Logger.Level.Debug);
						}
						
						if(propValueObj != null)
						{
							LRRFormulaDataStore.SourcePropertyID = propValueObj.SiteComponentPropertyID;
						}
						else
						{
							LRRFormulaDataStore.SourcePropertyID = sPropId;
						}

						if(sPropId != "")
						{
							bool overridable = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sPropId).Overridable;
							
							if(propValueObj != null)
							{
								IPropertyValue ip = propValueObj as IPropertyValue;
								editFlag = ip.GetEditableState();
							}
							else
							{
								editFlag = true;
							}
							
						}
						else
						{
							editFlag = true;
						}

						//--For EVVs--
						//						string parentUOMType = gnt.ParentRecord.GetValue("UOMTypeID") == null ? "" : gnt.ParentRecord.GetValue("UOMTypeID").ToString();
						//						LRRUOMTypes lrrUOMTypes = new LRRUOMTypes();
						//						if(parentUOMType != "")
						//						{
						//							_app.DBManagerObj.PopulateCollection(lrrUOMTypes," where ID = '" + parentUOMType + "'",false);
						//							LRRUOMType lrrUOMType = lrrUOMTypes[0];
						//							if(lrrUOMType.IsEVV)
						//							{
						//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
						//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Show;
						//							}
						//							else
						//							{
						//								//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.CellType = "TextBox";
						//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
						//							}
						//						}

						//--End--
					}
					string sPropertyType ="";
					//					if(childTable.Name.Equals("Properties"))
					//					{
					//						sPropertyType = e.Record.GetRecord().GetValue("Type") == null ? "" : e.Record.GetRecord().GetValue("Type").ToString();
					//						if((sPropertyType != "0") && (sPropertyType != "1") && (sPropertyType != "2"))
					//						{
					//							childTable.ParentTableDescriptor.Appearance.RecordPlusMinusCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
					//						}
					//						else
					//						{
					//							childTable.ParentTableDescriptor.Appearance.RecordPlusMinusCell.ShowButtons= Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
					//						}
					//					}
					//					if(childTable.Name.Equals("Properties"))
					//					{
					//						string mode = e.Record.GetRecord().GetValue("ModeID") == null ? "" : e.Record.GetRecord().GetValue("ModeID").ToString();
					//						string sFilter;
					//						if(mode == "True")
					//						{
					//							sFilter = "IsDefault = false";
					//						}
					//						else
					//						{
					//							sFilter = "IsDefault = true";
					//						}
					//						_siteComponentPropertyValues.ItemFilter = sFilter;
					//
					//
					//					}
					//					if(childTable.Name.Equals("GroupedProperties") && sType.Equals("1"))
					//					{
					//						//childTable.ParentTableDescriptor.AllowEdit = false;
					//						groupPropertyeditFlag = false;
					//						childTable.ParentTableDescriptor.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
					//					}
					//					if(childTable.Name.Equals("GroupedProperties") && sType.Equals("2"))
					//					{
					//						//childTable.ParentTableDescriptor.AllowEdit = true;
					//						groupPropertyeditFlag = true;
					//						childTable.ParentTableDescriptor.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
					//
					//						if(e.Record.Kind == DisplayElementKind.AddNewRecord)
					//						{
					//							LRRSiteComponentGroupProperty lrrGroupProperty = new LRRSiteComponentGroupProperty();
					//							
					//							
					//							if(gnt.ParentRecord.GetValue("ID") != null)
					//								lrrGroupProperty.SiteComponentPropID =  gnt.ParentRecord.GetRecord().GetValue("ID").ToString();
					//							if(gnt.ParentRecord.GetValue("UOMTypeID") != null)
					//								lrrGroupProperty.UOMTypeID = gnt.ParentRecord.GetRecord().GetValue("UOMTypeID").ToString();
					////							if(gnt.ParentRecord.GetValue("Direction") != null)
					////								lrrGroupProperty.Direction =  gnt.ParentRecord.GetRecord().GetValue("Direction").ToString();
					////							if(gnt.ParentRecord.GetValue("Derivation") != null)
					////								lrrGroupProperty.Derivation =  gnt.ParentRecord.GetRecord().GetValue("Derivation").ToString();
					//							if(gnt.ParentRecord.GetValue("UOM") != null)
					//								lrrGroupProperty.UOM = gnt.ParentRecord.GetRecord().GetValue("UOM").ToString();
					//							lrrGroupProperty.ModeID = (bool)gnt.ParentRecord.GetRecord().GetValue("ModeID");
					//
					//							_siteCompGroupedProperties.Add(lrrGroupProperty);
					////							e.Table.LastChangedRecord.SetSelected(false);
					//						}
					//					}
					//					if(childTable.Name.Equals("GroupedProperties") && sType != "" && !(sType.Equals("1") || sType.Equals("2")))
					//					{
					//						childTable.ParentTableDescriptor.AllowNew = true;
					//						//childTable.ParentTableDescriptor.AllowEdit = true;
					//						groupPropertyeditFlag = true;
					//						childTable.ParentTableDescriptor.Columns["AttributeName"].ReadOnly = true;
					//						childTable.ParentTableDescriptor.Columns["AttributeDescription"].ReadOnly = true;
					//					}
				}
			}*/
		}

		private void gridSiteComponent_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
			GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
			if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
			{
				return;
			}
			GridTableModel tableModel = null;
			GridGroupingControl grid = sender as GridGroupingControl;
			if(grid.TableControl.Table.CurrentRecord == null)
			{
				Element eCurrentElement = grid.TableControl.Table.CurrentElement;
				GridNestedTable gnt = eCurrentElement as GridNestedTable;
				GridNestedTable gnt1 = gnt;
				GridTableDescriptor gtd = null;
				while(gnt1 != null && gnt1.ChildTable != null)
				{
					gnt = gnt1;
					gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
					gtd = gnt.ParentTable.ParentTableDescriptor;
				}

				GridChildTable childTable = gnt.ChildTable as GridChildTable;
				tableModel = childTable.ParentTable.TableModel;
				
				if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
					return;

				if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).MappingName == "UOM")
				{
					string sUOMType = "";
					try
					{
						sUOMType = ((LRRDynamicSiteComponentProperty)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
					}
					catch
					{
					}
					if(sUOMType != "" && sUOMType != null)
					{

						LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
						GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
						cr.ListBoxPart.DataSource = uoms;
						uoms.SortColumn="Name";
						uoms.Sort();
						cr.Model.SupportsChoiceList = false;
						if(uoms.Count ==0)
						{
							e.TableControl.CurrentCell.ConfirmChanges();
							LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
						}
					}
				}
			}
		}

		private void SiteComponentEntry_Activated(object sender, EventArgs e)
		{
//			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
//			LRRFormulaDataStore.ModeFlag = true;
//			LRRFormulaDataStore.ShowGroupedAttributes = false;
		}
		private void gridSiteComponent_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(e.Inner.MouseEventArgs.Button == MouseButtons.Right
				&& e.TableControl.TableDescriptor.Name == "PropertyValues")
			{
				this.gridContext.Show(this.gridSiteComponent, this.gridSiteComponent.PointToClient(Control.MousePosition));

			}
			GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
			GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
			if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
			{
				return;
			}
			GridTableModel tableModel = null;
			GridGroupingControl grid = sender as GridGroupingControl;
			if(grid.TableControl.Table.CurrentRecord == null)
			{
				Element eCurrentElement = grid.TableControl.Table.CurrentElement;
				GridNestedTable gnt = eCurrentElement as GridNestedTable;
				GridNestedTable gnt1 = gnt;
				GridTableDescriptor gtd = null;
				while(gnt1 != null && gnt1.ChildTable != null)
				{
					gnt = gnt1;
					gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
					gtd = gnt.ParentTable.ParentTableDescriptor;
				}
				
				if(gnt == null)
					return;
				GridChildTable childTable = gnt.ChildTable as GridChildTable;
				tableModel = childTable.ParentTable.TableModel;
				
				if(e.TableControl.CurrentCell.RowIndex == -1 || e.TableControl.CurrentCell.ColIndex == -1)
					return;
				if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
					return;

				if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).MappingName == "UOM")
				{
					string sUOMType = "";
					try
					{
						sUOMType = ((LRRDynamicSiteComponentProperty)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCellClick Event:"+ex.Message  ,Logger.Level.Debug);
					}
					if(sUOMType != "" && sUOMType != null)
					{

						LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
						GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
						cr.ListBoxPart.DataSource = uoms;
//						if(uoms.Count ==0)
//						{
//							e.TableControl.CurrentCell.ConfirmChanges();
//							//MessageBox.Show("UOM not defined for the selected UOM Type.");
//							LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
//						}
					}
				}
			}

		}

		public void AddToGroupGrid(LRRLookUpProperties lrrLookUpProperties)
		{
			LRRDynamicSiteComponentProperty lrrSiteComponentProperty = gridSiteComponent.TableControl.Table.GetInnerMostCurrentElement().GetData() as LRRDynamicSiteComponentProperty;
			
			foreach(LRRLookUpProperty lookUpProperty in lrrLookUpProperties)
			{
				LRRDynamicSiteComponentGroupProperty lrrGroupProperty = new LRRDynamicSiteComponentGroupProperty();
				lrrGroupProperty.AttributeName = lookUpProperty.Name;
				lrrGroupProperty.AttributeDescription = lookUpProperty.Description;
				lrrGroupProperty.PropertyID = lookUpProperty.PropertyID;
				lrrGroupProperty.LookUpPropertiesID = lookUpProperty.LookUpPropertiesID;
				lrrGroupProperty.MasterPropID = lrrSiteComponentProperty.PropertyID;
				lrrGroupProperty.SiteComponentPropID =  lrrSiteComponentProperty.ID;
				lrrGroupProperty.UOMTypeID = lrrSiteComponentProperty.UOMTypeID;
				//				lrrGroupProperty.Direction =  lrrSiteComponentProperty.Direction;
				//				lrrGroupProperty.Derivation =  lrrSiteComponentProperty.Derivation;
				lrrGroupProperty.ModeID = lrrSiteComponentProperty.ModeID;
				_siteCompGroupedProperties.Add(lrrGroupProperty);
			}
		}

		private void ChildTableDescriptor_GroupExpanding(object sender, GroupEventArgs e)
		{
			GridChildTable childTable = e.Group as GridChildTable;
			string sType = childTable.ParentNestedTable.ParentRecord.GetValue("Type").ToString();
			
			if(!(sType == "1"))
				e.Cancel = true;
		}
		private void gridSiteComponent_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{

			if(e.TableCellIdentity.RowIndex < 0)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex) == null)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_LEVEL") && e.TableCellIdentity.RowIndex > 3)
			{
				e.Style.CellType = "DropDownTree";
				//e.Style.CellType = "DropDownTree";
				string displaymember = e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit") == null ? "" :e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit").ToString();          
				if(displaymember != "")
				{
					string sFilter;
					sFilter = "LevelID = " + displaymember;
					_levels.ItemFilter = sFilter;
					GridTableCellStyleInfo gsi = new GridTableCellStyleInfo();
					gsi = e.Style;
					if(gsi != null)
					{
						if(_levels.Count>0)
							gsi.FormattedText = _levels[0].Name;  
						gsi.WrapText = true;
						gsi.AutoSize = true;
					}	
					_levels.ItemFilter ="";
				}

			}
			
		}

		private void SiteComponentEntry_Activated_1(object sender, System.EventArgs e)
		{
			if(!initializing)
			{
//				oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
//				if((oForAlerts.Contains("LRRSiteComponentGroupProperty")) || (oForAlerts.Contains("LRRSiteComponentProperty")))
//				{
//					//MessageBox.Show("There are changes in data you are viewing \n Please commit your changes and refresh the screen.","Site Component Entry");
//					LRRMessagBox.ShowMessage("SID_COMMIT_CHANGES","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);      
//				}
			}
//			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
//			LRRFormulaDataStore.ModeFlag = true;
//			LRRFormulaDataStore.ObjectSource = typeof(LRRSiteComponent).ToString();
//			LRRFormulaDataStore.ShowGroupedAttributes = false;
			initializing = false;
		}

		private void gridSiteComponent_TableControlCurrentCellKeyPress(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventArgs e)
		{
			if(e.TableControl.TableDescriptor.Name == "PropertyValues" && !editFlag)
			{
				e.Inner.Handled = true;
			}
			//			if(e.TableControl.TableDescriptor.Name == "GroupedProperties" && !groupPropertyeditFlag)
			//			{
			//				e.Inner.Handled = true;
			//			}
		}
		
		private void gridSiteComponent_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
		{
			try
			{
				if(e.Inner.KeyCode==Keys.Tab || e.Inner.KeyCode==Keys.Left || e.Inner.KeyCode==Keys.Right|| e.Inner.KeyCode==Keys.Up || e.Inner.KeyCode==Keys.Down)
				{
					return;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCurrentCellKeyDown Event:"+ex.Message  ,Logger.Level.Debug);
			}
			if(e.TableControl.TableDescriptor.Name == "PropertyValues" && !editFlag)
			{
				e.Inner.Handled = true;
			}
			//			if(e.TableControl.TableDescriptor.Name == "GroupedProperties" && !groupPropertyeditFlag)
			//			{
			//				e.Inner.Handled = true;
			//			}
			try
			{
				int iCol = e.TableControl.CurrentCell.ColIndex - e.TableControl.TableDescriptor.GetColumnIndentCount();
				if(iCol > 0)
				{
					if(e.TableControl.TableDescriptor.Columns[iCol].FieldDescriptor.IsRelatedField())
						e.Inner.Handled = true;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCurrentCellKeyDown Event:"+ex.Message  ,Logger.Level.Debug);
			}
		}

		private void ChildTableDescriptor_RecordExpanding(object sender, RecordEventArgs e)
		{
			string sPropertyType = e.Record.GetValue("Type") == null ? "" : e.Record.GetValue("Type").ToString();
		
			if((sPropertyType != "0") && (sPropertyType != "1") && (sPropertyType != "2") && (sPropertyType != ""))
			{
				e.Record.GetRecord().NestedTables["GroupedProperties"].IsExpanded = false;
			}
		}
		private void ChildTableDescriptor_RecordCollapsing(object sender, RecordEventArgs e)
		{
			string sPropertyType = e.Record.GetValue("Type") == null ? "" : e.Record.GetValue("Type").ToString();
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add SiteComponentEntry.ClearSort implementation
			SyncGridUtilities.ClearSort(gridSiteComponent);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add SiteComponentEntry.SupportsClearSort implementation
			return true;
		}

		#endregion
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add SiteComponentEntry.PrintPreview implementation
			if(gridSiteComponent.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSiteComponent,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add SiteComponentEntry.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add SiteComponentEntry.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add SiteComponentEntry.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add SiteComponentEntry.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add SiteComponentEntry.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add SiteComponentEntry.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add SiteComponentEntry.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add SiteComponentEntry.SupportsUndo implementation
			return false;
		}

		#endregion


		private void gridSiteComponent_TableControlKeyUp(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventArgs e)
		{
			if(e.Inner.KeyCode == Keys.Delete)
			{
				if(_siteCompProperties.DeletedItems.Count >0)
				{
					//LRRSiteComponents deletedSiteComponents = _siteComponents.GetChanges();
					foreach(LRRSiteComponentProperty deletedSiteCompProperty in _siteCompProperties.DeletedItems)
					{
						LRRHistPropCompPropMappings hisCompPropMappings = LRRModel.HistPropMaps.FilterBySiteCompPropID(deletedSiteCompProperty.ID);
						if(hisCompPropMappings.Count >0)
						{
							for(int i = hisCompPropMappings.Count; i>0;i--)
							{
								LRRHistPropCompPropMapping toDeleteHisMap = hisCompPropMappings[i-1] as LRRHistPropCompPropMapping;
								LRRModel.HistPropMaps.Remove(toDeleteHisMap);
							}
						}
					}
				}
			}
		}
		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add SiteComponentEntry.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add SiteComponentEntry.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add SiteComponentEntry.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add SiteComponentEntry.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add SiteComponentEntry.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add SiteComponentEntry.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add SiteComponentEntry.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add SiteComponentEntry.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add SiteComponentEntry.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add SiteComponentEntry.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
