using System;

namespace Symcon.LightRidge.PEAdvisor.SavedViews
{
	public enum SourceEnum
	{
		LOCAL,
		REMOTE,
		LIVE,
		NONE
	}
	/// <summary>
	/// Summary description for ModeSlot.
	/// </summary>
	public class ModeSlot
	{
		public ModeSlot()
		{
		}

		#region Properties
		public SourceEnum Source
		{
			get{return _source;}
			set
			{
				_source = value;
				if(SourceChanged != null)
					SourceChanged(this,new EventArgs());
			}
		}
		public string StartTime
		{
			get{return _startTime;}
			set
			{
				_startTime = value;
				if(StartTimeChanged != null)
					StartTimeChanged(this,new EventArgs());
			}

		}
		public string EndTime
		{
			get{return _endTime;}
			set
			{
				_endTime = value;
				if(EndTimeChanged != null)
					EndTimeChanged(this,new EventArgs());
			}

		}
		
		public string CaseID
		{
			get{return _caseID;}
			set
			{
				_caseID = value;
			}
		}

		public string CaseName
		{
			get{return _caseName;}
			set
			{
				_caseName = value;
			}
		}

		#endregion

		#region Fields
		private SourceEnum _source;
		private string _startTime = "";
		private string _endTime = "";
		private string _caseID;
		private string _caseName;
		public event EventHandler SourceChanged;
		public event EventHandler StartTimeChanged;
		public event EventHandler EndTimeChanged;
		#endregion
	}
}
