using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;

namespace Symcon.LightRidge.PEAdvisor.SavedViews
{
	/// <summary>
	/// Summary description for SaveSetForm.
	/// </summary>
	public class SaveSetForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox txtDescription;
		private System.Windows.Forms.Label lblDescription;

		private System.Windows.Forms.Label lblName;
		private System.Windows.Forms.Label lblStartTime;
		private System.Windows.Forms.Label lblEndRunTime;
		private System.Windows.Forms.Label lblStartRunTimeValue;
		private System.Windows.Forms.Label lblEndRunTimeValue;
		private System.Windows.Forms.Label lblCmp1;
		private System.Windows.Forms.Label lblCmp2;
		private System.Windows.Forms.Label lblRef;
		private System.Windows.Forms.Label lblCmp1Mode;
		private System.Windows.Forms.Label lblCmp2Mode;
		private System.Windows.Forms.Label lblRefMode;
		private System.Windows.Forms.RadioButton rdbPrivate;
		private System.Windows.Forms.RadioButton rdbPublic;
		private System.Windows.Forms.GroupBox gpPublish;
		private System.Windows.Forms.GroupBox savedCaseType;
		private System.Windows.Forms.RadioButton rdbStatic;
		private System.Windows.Forms.RadioButton rdbDynamic;
		private System.Windows.Forms.TextBox txtName;
		

		public SaveSetForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			//Assign values to start time,end time, mode slots
			lblStartRunTimeValue.Text = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
			lblEndRunTimeValue.Text = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
			
			ArrayList arrSelModesList = _lrrApp.ActiveRunControlSet.SelectedModes;
			for(int i=0;i < arrSelModesList.Count;i++)
			{
				string modeID = (string)arrSelModesList[i];
				LRRMode mode = LRRModel.ProjectModes.GetModeByID(modeID);
				if(mode.ModeTypeID == "1")
					lblCmp1Mode.Text = mode.ModeName;
				if(mode.ModeTypeID == "2")
					lblRefMode.Text = mode.ModeName;
				if(mode.ModeTypeID == "3")
					lblCmp2Mode.Text = mode.ModeName;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SaveSetForm));
			this.lblName = new System.Windows.Forms.Label();
			this.txtName = new System.Windows.Forms.TextBox();
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.txtDescription = new System.Windows.Forms.TextBox();
			this.lblDescription = new System.Windows.Forms.Label();
			this.lblStartTime = new System.Windows.Forms.Label();
			this.lblStartRunTimeValue = new System.Windows.Forms.Label();
			this.lblEndRunTime = new System.Windows.Forms.Label();
			this.lblEndRunTimeValue = new System.Windows.Forms.Label();
			this.lblCmp1 = new System.Windows.Forms.Label();
			this.lblCmp2 = new System.Windows.Forms.Label();
			this.lblRef = new System.Windows.Forms.Label();
			this.lblCmp1Mode = new System.Windows.Forms.Label();
			this.lblCmp2Mode = new System.Windows.Forms.Label();
			this.lblRefMode = new System.Windows.Forms.Label();
			this.rdbPrivate = new System.Windows.Forms.RadioButton();
			this.rdbPublic = new System.Windows.Forms.RadioButton();
			this.gpPublish = new System.Windows.Forms.GroupBox();
			this.savedCaseType = new System.Windows.Forms.GroupBox();
			this.rdbDynamic = new System.Windows.Forms.RadioButton();
			this.rdbStatic = new System.Windows.Forms.RadioButton();
			this.gpPublish.SuspendLayout();
			this.savedCaseType.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblName
			// 
			this.lblName.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblName.Location = new System.Drawing.Point(8, 8);
			this.lblName.Name = "lblName";
			this.lblName.Size = new System.Drawing.Size(88, 16);
			this.lblName.TabIndex = 0;
			this.lblName.Tag = "SID_NAME";
			// 
			// txtName
			// 
			this.txtName.Location = new System.Drawing.Point(104, 8);
			this.txtName.Name = "txtName";
			this.txtName.Size = new System.Drawing.Size(208, 20);
			this.txtName.TabIndex = 1;
			this.txtName.Text = "";
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(304, 168);
			this.btnOK.Name = "btnOK";
			this.btnOK.TabIndex = 3;
			this.btnOK.Tag = "SID_OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(392, 168);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 4;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// txtDescription
			// 
			this.txtDescription.Location = new System.Drawing.Point(104, 32);
			this.txtDescription.Name = "txtDescription";
			this.txtDescription.Size = new System.Drawing.Size(312, 20);
			this.txtDescription.TabIndex = 2;
			this.txtDescription.Text = "";
			// 
			// lblDescription
			// 
			this.lblDescription.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblDescription.Location = new System.Drawing.Point(8, 32);
			this.lblDescription.Name = "lblDescription";
			this.lblDescription.Size = new System.Drawing.Size(88, 16);
			this.lblDescription.TabIndex = 4;
			this.lblDescription.Tag = "SID_DESCRIPTION";
			// 
			// lblStartTime
			// 
			this.lblStartTime.Location = new System.Drawing.Point(8, 64);
			this.lblStartTime.Name = "lblStartTime";
			this.lblStartTime.Size = new System.Drawing.Size(88, 16);
			this.lblStartTime.TabIndex = 5;
			this.lblStartTime.Tag = "SID_START_RUN_TIME";
			// 
			// lblStartRunTimeValue
			// 
			this.lblStartRunTimeValue.Location = new System.Drawing.Point(104, 64);
			this.lblStartRunTimeValue.Name = "lblStartRunTimeValue";
			this.lblStartRunTimeValue.Size = new System.Drawing.Size(112, 16);
			this.lblStartRunTimeValue.TabIndex = 6;
			// 
			// lblEndRunTime
			// 
			this.lblEndRunTime.Location = new System.Drawing.Point(248, 64);
			this.lblEndRunTime.Name = "lblEndRunTime";
			this.lblEndRunTime.Size = new System.Drawing.Size(88, 16);
			this.lblEndRunTime.TabIndex = 7;
			this.lblEndRunTime.Tag = "SID_END_RUN_TIME";
			// 
			// lblEndRunTimeValue
			// 
			this.lblEndRunTimeValue.Location = new System.Drawing.Point(344, 64);
			this.lblEndRunTimeValue.Name = "lblEndRunTimeValue";
			this.lblEndRunTimeValue.Size = new System.Drawing.Size(112, 16);
			this.lblEndRunTimeValue.TabIndex = 8;
			// 
			// lblCmp1
			// 
			this.lblCmp1.Location = new System.Drawing.Point(8, 88);
			this.lblCmp1.Name = "lblCmp1";
			this.lblCmp1.Size = new System.Drawing.Size(104, 16);
			this.lblCmp1.TabIndex = 9;
			this.lblCmp1.Tag = "SID_COMAPARE1_MODE";
			// 
			// lblCmp2
			// 
			this.lblCmp2.Location = new System.Drawing.Point(8, 120);
			this.lblCmp2.Name = "lblCmp2";
			this.lblCmp2.Size = new System.Drawing.Size(112, 16);
			this.lblCmp2.TabIndex = 10;
			this.lblCmp2.Tag = "SID_COMAPARE2_MODE";
			// 
			// lblRef
			// 
			this.lblRef.Location = new System.Drawing.Point(8, 152);
			this.lblRef.Name = "lblRef";
			this.lblRef.Size = new System.Drawing.Size(112, 16);
			this.lblRef.TabIndex = 11;
			this.lblRef.Tag = "SID_REFERENCE_MODE";
			// 
			// lblCmp1Mode
			// 
			this.lblCmp1Mode.Location = new System.Drawing.Point(104, 88);
			this.lblCmp1Mode.Name = "lblCmp1Mode";
			this.lblCmp1Mode.Size = new System.Drawing.Size(104, 16);
			this.lblCmp1Mode.TabIndex = 12;
			// 
			// lblCmp2Mode
			// 
			this.lblCmp2Mode.Location = new System.Drawing.Point(104, 120);
			this.lblCmp2Mode.Name = "lblCmp2Mode";
			this.lblCmp2Mode.Size = new System.Drawing.Size(112, 16);
			this.lblCmp2Mode.TabIndex = 13;
			// 
			// lblRefMode
			// 
			this.lblRefMode.Location = new System.Drawing.Point(104, 152);
			this.lblRefMode.Name = "lblRefMode";
			this.lblRefMode.Size = new System.Drawing.Size(104, 16);
			this.lblRefMode.TabIndex = 14;
			// 
			// rdbPrivate
			// 
			this.rdbPrivate.Checked = true;
			this.rdbPrivate.Location = new System.Drawing.Point(8, 16);
			this.rdbPrivate.Name = "rdbPrivate";
			this.rdbPrivate.Size = new System.Drawing.Size(64, 24);
			this.rdbPrivate.TabIndex = 15;
			this.rdbPrivate.TabStop = true;
			this.rdbPrivate.Tag = "SID_PRIVATE";
			// 
			// rdbPublic
			// 
			this.rdbPublic.Location = new System.Drawing.Point(8, 40);
			this.rdbPublic.Name = "rdbPublic";
			this.rdbPublic.Size = new System.Drawing.Size(56, 24);
			this.rdbPublic.TabIndex = 16;
			this.rdbPublic.Tag = "SID_PUBLIC";
			// 
			// gpPublish
			// 
			this.gpPublish.Controls.Add(this.rdbPublic);
			this.gpPublish.Controls.Add(this.rdbPrivate);
			this.gpPublish.Location = new System.Drawing.Point(368, 88);
			this.gpPublish.Name = "gpPublish";
			this.gpPublish.Size = new System.Drawing.Size(96, 72);
			this.gpPublish.TabIndex = 17;
			this.gpPublish.TabStop = false;
			this.gpPublish.Tag = "SID_PUBLIC_PRIVATE";
			// 
			// savedCaseType
			// 
			this.savedCaseType.Controls.Add(this.rdbDynamic);
			this.savedCaseType.Controls.Add(this.rdbStatic);
			this.savedCaseType.Location = new System.Drawing.Point(248, 88);
			this.savedCaseType.Name = "savedCaseType";
			this.savedCaseType.Size = new System.Drawing.Size(104, 72);
			this.savedCaseType.TabIndex = 18;
			this.savedCaseType.TabStop = false;
			this.savedCaseType.Tag = "SID_STATIC_DYNAMIC";
			// 
			// rdbDynamic
			// 
			this.rdbDynamic.Location = new System.Drawing.Point(8, 40);
			this.rdbDynamic.Name = "rdbDynamic";
			this.rdbDynamic.Size = new System.Drawing.Size(80, 24);
			this.rdbDynamic.TabIndex = 1;
			this.rdbDynamic.Tag = "SID_DYNAMIC";
			// 
			// rdbStatic
			// 
			this.rdbStatic.Checked = true;
			this.rdbStatic.Location = new System.Drawing.Point(8, 16);
			this.rdbStatic.Name = "rdbStatic";
			this.rdbStatic.Size = new System.Drawing.Size(64, 24);
			this.rdbStatic.TabIndex = 0;
			this.rdbStatic.TabStop = true;
			this.rdbStatic.Tag = "SID_STATIC";
			// 
			// SaveSetForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(474, 200);
			this.Controls.Add(this.savedCaseType);
			this.Controls.Add(this.gpPublish);
			this.Controls.Add(this.lblRefMode);
			this.Controls.Add(this.lblCmp2Mode);
			this.Controls.Add(this.lblCmp1Mode);
			this.Controls.Add(this.lblRef);
			this.Controls.Add(this.lblCmp2);
			this.Controls.Add(this.lblCmp1);
			this.Controls.Add(this.lblEndRunTimeValue);
			this.Controls.Add(this.lblEndRunTime);
			this.Controls.Add(this.lblStartRunTimeValue);
			this.Controls.Add(this.lblStartTime);
			this.Controls.Add(this.txtDescription);
			this.Controls.Add(this.txtName);
			this.Controls.Add(this.lblDescription);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.Controls.Add(this.lblName);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "SaveSetForm";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_SAVEAS";
			this.gpPublish.ResumeLayout(false);
			this.savedCaseType.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnOK_Click(object sender, System.EventArgs e)
		{
			if(txtName.Text.Trim() == "")
			{
				LRRMessagBox.ShowMessage("SID_VALID_RUNCONTROLSET","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
				txtName.Focus();
				this.DialogResult = DialogResult.None;
				return;
			}
			name = txtName.Text.Trim();
			desc = txtDescription.Text;
			
			//Check if the Saved Case with same name exists
			
			LRRSavedCase lrrSavedCase = new LRRSavedCase();
			_lrrApp.DBManagerObj.PopulateObject(lrrSavedCase,typeof(LRRSavedCase)," where Name = '" + name + "'");
			if(lrrSavedCase.Name == name)
			{
				//Saved Case already exists? Do you want to overwrite?
				DialogResult dlgResult =  MessageBox.Show(this,"Saved Case already exists? Do you want to overwrite?","Question",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
				if(dlgResult == DialogResult.No)
				{
					return;
				}
				else
				{
					lrrSavedCase.ObjectState = DBOperation.DELETE;
					_lrrApp.DBManagerObj.CommitObject(lrrSavedCase);
				}
			}
			
			Cursor.Current = Cursors.WaitCursor;
			Cursor.Show();

			//Start Time
			Symcon.Utils.TimerUtils.HiPerfTimer hTimer = new Symcon.Utils.TimerUtils.HiPerfTimer();
			hTimer.Start();
			Logger.LogMessage("Saved Case Save Start Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);

			//Save SavedCase 
			LRRSavedCase savedCase = new LRRSavedCase();
			savedCase.ObjectState = DBOperation.INSERT;
			savedCase.Name = name;
			savedCase.Description = desc;
			savedCase.StartTime = _lrrApp.ActiveRunControlSet.DataWindowObj.StartTimeValue;
			savedCase.EndTime = _lrrApp.ActiveRunControlSet.DataWindowObj.EndTimeValue;
			savedCase.IsPublished = rdbPublic.Checked;
			savedCase.IsDynamic = rdbDynamic.Checked;

			//Save Cpm1,Cmp2,Ref
			ArrayList selModesList = _lrrApp.ActiveRunControlSet.SelectedModes;
			for(int i=0;i < selModesList.Count;i++)
			{
				string modeID = (string)selModesList[i];
				LRRMode mode = LRRModel.ProjectModes.GetModeByID(modeID);

				//Check for Dynamic Case
				if(savedCase.IsDynamic)
				{
					if(mode.ModeId == "3")
					{
						if(mode.ModeTypeID == "1")
							savedCase.Compare1 = true;
						if(mode.ModeTypeID == "2")
							savedCase.Reference = true;
						if(mode.ModeTypeID == "3")
							savedCase.Compare2 = true;
					}
				}
				else
				{
					if(mode.ModeTypeID == "1")
						savedCase.Compare1 = true;
					if(mode.ModeTypeID == "2")
						savedCase.Reference = true;
					if(mode.ModeTypeID == "3")
						savedCase.Compare2 = true;
				}
			}
			
			_lrrApp.DBManagerObj.CommitObject(savedCase);

			LRRModel.ChildModel.SavedCases.Add(savedCase);

			//Save SiteComponentPropertyValues
			LRRSiteComponentPropertyValueSavedCases siteCompPropValueSavedCases = new LRRSiteComponentPropertyValueSavedCases();
			IEnumerator iSiteCompPropValueEnum = LRRModel.PropertyValuesObj.GetEnumerator();
			while(iSiteCompPropValueEnum.MoveNext())
			{
				LRRSiteComponentPropertyValue siteCompPropValue = iSiteCompPropValueEnum.Current as LRRSiteComponentPropertyValue;
				
				//Check for Dynamic Case
				if(savedCase.IsDynamic && siteCompPropValue.ModeID != "3")
					continue;
				if(_lrrApp.ActiveRunControlSet.SelectedModes.Contains(siteCompPropValue.ModeID))
				{
					LRRSiteComponentPropertyValueSavedCase siteCompPropValueSavedCase = new LRRSiteComponentPropertyValueSavedCase();
					siteCompPropValueSavedCase.SavedCaseID = savedCase.ID;
					siteCompPropValueSavedCase.SiteComponentPropertyID = siteCompPropValue.SiteComponentPropertyID;
					siteCompPropValueSavedCase.PropertyValue = siteCompPropValue.PropertyValue;
					siteCompPropValueSavedCase.ModeID = siteCompPropValue.ModeID;

					LRRMode mode = LRRModel.ProjectModes.GetModeByID(siteCompPropValue.ModeID);
					siteCompPropValueSavedCase.ModeTypeID = mode.ModeTypeID;

					siteCompPropValueSavedCases.Add(siteCompPropValueSavedCase);
				}

			}

			_lrrApp.DBManagerObj.BeginTransaction();
			_lrrApp.DBManagerObj.ExecuteBatchInsert(siteCompPropValueSavedCases);
			_lrrApp.DBManagerObj.CommitTransaction();

			//Save Aggregate Property Values
			LRRAggregatePropertyValueSavedCases aggrPropValueSavedCases = new LRRAggregatePropertyValueSavedCases();
			IEnumerator iAggrPropValueEnum = LRRModel.AggregatePropertyValuesObj.GetEnumerator();
			while(iAggrPropValueEnum.MoveNext())
			{
				LRRAggregatePropertyValue aggrPropValue = iAggrPropValueEnum.Current as LRRAggregatePropertyValue;
				//Check for Dynamic Case
				if(savedCase.IsDynamic && aggrPropValue.ModeID != "3")
					continue;
				if(_lrrApp.ActiveRunControlSet.SelectedModes.Contains(aggrPropValue.ModeID))
				{
					LRRAggregatePropertyValueSavedCase aggrPropValueSavedCase = new LRRAggregatePropertyValueSavedCase();
					aggrPropValueSavedCase.SavedCaseID = savedCase.ID;
					aggrPropValueSavedCase.AggregateID = aggrPropValue.AggregateID;
					aggrPropValueSavedCase.PropertyValue = aggrPropValue.PropertyValue;
					aggrPropValueSavedCase.ModeID = aggrPropValue.ModeID;

					LRRMode mode = LRRModel.ProjectModes.GetModeByID(aggrPropValue.ModeID);
					aggrPropValueSavedCase.ModeTypeID = mode.ModeTypeID;

					aggrPropValueSavedCases.Add(aggrPropValueSavedCase);
				}
			}
			_lrrApp.DBManagerObj.BeginTransaction();
			_lrrApp.DBManagerObj.ExecuteBatchInsert(aggrPropValueSavedCases);
			_lrrApp.DBManagerObj.CommitTransaction();

			//Save Group Property Qualifier Values
			LRRSiteGroupPropertyQualifierValueSavedCases siteGrpPropQualValueSavedCases = new LRRSiteGroupPropertyQualifierValueSavedCases();
			IEnumerator iSiteGrpPropQualValueEnum = LRRModel.SiteGroupPropertyQualifierValuesObj.GetEnumerator();
			while(iSiteGrpPropQualValueEnum.MoveNext())
			{
				LRRSiteGroupPropertyQualifierValue siteGrpPropQualValue = iSiteGrpPropQualValueEnum.Current as LRRSiteGroupPropertyQualifierValue;
				//Check for Dynamic Case
				if(savedCase.IsDynamic && siteGrpPropQualValue.ModeID != "3")
					continue;
				if(_lrrApp.ActiveRunControlSet.SelectedModes.Contains(siteGrpPropQualValue.ModeID))
				{
					LRRSiteGroupPropertyQualifierValueSavedCase siteGrpPropQualValueSavedCase = new LRRSiteGroupPropertyQualifierValueSavedCase();
					siteGrpPropQualValueSavedCase.SavedCaseID = savedCase.ID;
					siteGrpPropQualValueSavedCase.LookUpPropertiesID = siteGrpPropQualValue.LookUpPropertiesID;
					siteGrpPropQualValueSavedCase.GroupPropertyID = siteGrpPropQualValue.GroupPropertyID;
					siteGrpPropQualValueSavedCase.LookUpQualifierID = siteGrpPropQualValue.LookUpQualifierID;
					siteGrpPropQualValueSavedCase.QualifierID = siteGrpPropQualValue.QualifierID;
					siteGrpPropQualValueSavedCase.PropertyID = siteGrpPropQualValue.PropertyID;
					siteGrpPropQualValueSavedCase.ModeID = siteGrpPropQualValue.ModeID;
					siteGrpPropQualValueSavedCase.PropertyValue = siteGrpPropQualValue.PropertyValue;

					LRRMode mode = LRRModel.ProjectModes.GetModeByID(siteGrpPropQualValue.ModeID);
					siteGrpPropQualValueSavedCase.ModeTypeID = mode.ModeTypeID;

					siteGrpPropQualValueSavedCase.MasterPropID = siteGrpPropQualValue.MasterPropID;
					siteGrpPropQualValueSavedCase.SiteComponentPropID = siteGrpPropQualValue.SiteComponentPropID;

					siteGrpPropQualValueSavedCases.Add(siteGrpPropQualValueSavedCase);
				}
			}
			_lrrApp.DBManagerObj.BeginTransaction();
			_lrrApp.DBManagerObj.ExecuteBatchInsert(siteGrpPropQualValueSavedCases);
			_lrrApp.DBManagerObj.CommitTransaction();

			//End time
			Logger.LogMessage("Saved Case Save End Time:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//Difference
			hTimer.Stop();
			Logger.LogMessage("Saved Case Save Difference:" + hTimer.Duration.ToString(Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);

			Cursor.Hide();
		}

		#region Fields
		private string name;
		private string desc;
		private LRRApp _lrrApp;
		#endregion
	}
}
