using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.SavedViews
{
	/// <summary>
	/// Summary description for SavedViewForm.
	/// </summary>
	public class SavedViewForm : System.Windows.Forms.Form,ILRRUIContainer
	{
		private System.Windows.Forms.TreeView trvMasterProps;
		private System.Windows.Forms.Button btnExec;
		private System.Windows.Forms.Panel pnlGrid;
		private System.Windows.Forms.Panel pnlTreeControl;
		private System.Windows.Forms.Panel pnlButton;
		private System.Windows.Forms.Panel pnlLeft;
		private System.Windows.Forms.Splitter splBottom;
		private System.Windows.Forms.Splitter splVertical;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SavedViewForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			InitializeTree();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SavedViewForm));
			this.trvMasterProps = new System.Windows.Forms.TreeView();
			this.btnExec = new System.Windows.Forms.Button();
			this.pnlTreeControl = new System.Windows.Forms.Panel();
			this.pnlGrid = new System.Windows.Forms.Panel();
			this.pnlButton = new System.Windows.Forms.Panel();
			this.pnlLeft = new System.Windows.Forms.Panel();
			this.splBottom = new System.Windows.Forms.Splitter();
			this.splVertical = new System.Windows.Forms.Splitter();
			this.pnlTreeControl.SuspendLayout();
			this.pnlButton.SuspendLayout();
			this.pnlLeft.SuspendLayout();
			this.SuspendLayout();
			// 
			// trvMasterProps
			// 
			this.trvMasterProps.CheckBoxes = true;
			this.trvMasterProps.Dock = System.Windows.Forms.DockStyle.Fill;
			this.trvMasterProps.ImageIndex = -1;
			this.trvMasterProps.Location = new System.Drawing.Point(0, 0);
			this.trvMasterProps.Name = "trvMasterProps";
			this.trvMasterProps.SelectedImageIndex = -1;
			this.trvMasterProps.Size = new System.Drawing.Size(320, 414);
			this.trvMasterProps.TabIndex = 0;
			this.trvMasterProps.AfterCheck += new System.Windows.Forms.TreeViewEventHandler(this.trvMasterProps_AfterCheck);
			// 
			// btnExec
			// 
			this.btnExec.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnExec.Location = new System.Drawing.Point(224, 16);
			this.btnExec.Name = "btnExec";
			this.btnExec.TabIndex = 1;
			this.btnExec.Text = "SID_EXECUTE";
			this.btnExec.Click += new System.EventHandler(this.btnExec_Click);
			// 
			// pnlTreeControl
			// 
			this.pnlTreeControl.Controls.Add(this.trvMasterProps);
			this.pnlTreeControl.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlTreeControl.Location = new System.Drawing.Point(0, 0);
			this.pnlTreeControl.Name = "pnlTreeControl";
			this.pnlTreeControl.Size = new System.Drawing.Size(320, 414);
			this.pnlTreeControl.TabIndex = 2;
			// 
			// pnlGrid
			// 
			this.pnlGrid.Dock = System.Windows.Forms.DockStyle.Right;
			this.pnlGrid.Location = new System.Drawing.Point(320, 0);
			this.pnlGrid.Name = "pnlGrid";
			this.pnlGrid.Size = new System.Drawing.Size(592, 462);
			this.pnlGrid.TabIndex = 3;
			// 
			// pnlButton
			// 
			this.pnlButton.Controls.Add(this.btnExec);
			this.pnlButton.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlButton.Location = new System.Drawing.Point(0, 414);
			this.pnlButton.Name = "pnlButton";
			this.pnlButton.Size = new System.Drawing.Size(320, 48);
			this.pnlButton.TabIndex = 4;
			// 
			// pnlLeft
			// 
			this.pnlLeft.Controls.Add(this.splBottom);
			this.pnlLeft.Controls.Add(this.pnlTreeControl);
			this.pnlLeft.Controls.Add(this.pnlButton);
			this.pnlLeft.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlLeft.Location = new System.Drawing.Point(0, 0);
			this.pnlLeft.Name = "pnlLeft";
			this.pnlLeft.Size = new System.Drawing.Size(320, 462);
			this.pnlLeft.TabIndex = 6;
			// 
			// splBottom
			// 
			this.splBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splBottom.Enabled = false;
			this.splBottom.Location = new System.Drawing.Point(0, 412);
			this.splBottom.Name = "splBottom";
			this.splBottom.Size = new System.Drawing.Size(320, 2);
			this.splBottom.TabIndex = 5;
			this.splBottom.TabStop = false;
			// 
			// splVertical
			// 
			this.splVertical.BackColor = System.Drawing.SystemColors.Highlight;
			this.splVertical.Dock = System.Windows.Forms.DockStyle.Right;
			this.splVertical.Location = new System.Drawing.Point(315, 0);
			this.splVertical.Name = "splVertical";
			this.splVertical.Size = new System.Drawing.Size(5, 462);
			this.splVertical.TabIndex = 7;
			this.splVertical.TabStop = false;
			this.splVertical.DoubleClick += new System.EventHandler(this.splitter2_DoubleClick);
			// 
			// SavedViewForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(912, 462);
			this.Controls.Add(this.splVertical);
			this.Controls.Add(this.pnlLeft);
			this.Controls.Add(this.pnlGrid);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "SavedViewForm";
			this.Tag = "410";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.pnlTreeControl.ResumeLayout(false);
			this.pnlButton.ResumeLayout(false);
			this.pnlLeft.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitDataSource()
		{
			_lrrMasterComps = LRRModel.Model;
			_lrrPropertyTypes = LRRModel.ChildModel.PropertyTypes;

			_lrrCompTypes = new LRRComponentTypes();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrCompTypes);
		}

		private void InitializeTree()
		{
			TreeNode root = new TreeNode("Components");
			IEnumerator compTypeEnum = _lrrCompTypes.GetEnumerator();

			while(compTypeEnum.MoveNext())
			{
				LRRComponentType lrrCompType = compTypeEnum.Current as LRRComponentType;

				//Create Component Type Node
				TreeNode compTypeNode = new TreeNode(lrrCompType.Name);
				root.Nodes.Add(compTypeNode);
				
				//Filter Master Components on master Component Type
				LRRMasterComponents lrrMasterComps = _lrrMasterComps.FilterMasterComponentsByComponentTypeID(lrrCompType.ID);
				IEnumerator iMasterCompEnum = lrrMasterComps.GetEnumerator();
				while(iMasterCompEnum.MoveNext())
				{
					LRRMasterComponent lrrMasterComp = iMasterCompEnum.Current as LRRMasterComponent;

					//Create Master Component Node
					TreeNode masterCompNode = new TreeNode(lrrMasterComp.ComponentName);
					compTypeNode.Nodes.Add(masterCompNode);
					
					//Get Site Components
					LRRSiteComponents lrrSiteComps = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(lrrMasterComp.ID);
					TreeNode siteNode = null;
					if(lrrSiteComps.Count > 0)
					{
						siteNode = new TreeNode("SiteComponents");
						masterCompNode.Nodes.Add(siteNode);
					}
					IEnumerator iSiteCompEnum = lrrSiteComps.GetEnumerator();
					while(iSiteCompEnum.MoveNext())
					{
						LRRSiteComponent lrrSiteComp = iSiteCompEnum.Current as LRRSiteComponent;

						//Create Site Component Node
						TreeNode siteCompNode = new TreeNode(lrrSiteComp.Name);

						SearchCondition condition = GetConditionObj("SiteComponentID",lrrSiteComp.SiteComponentID,"=");
						SearchCriteria criteria = new SearchCriteria();
						criteria.ObjType = typeof(LRRSiteComponent);
						ArrayList arrList = new ArrayList();
						arrList.Add(condition);
						criteria.ArrListSearchCondition = arrList;

						siteCompNode.Tag =  criteria;
						siteNode.Nodes.Add(siteCompNode);

						LRRSiteComponentProperties lrrSiteCompProps = lrrSiteComp.Properties.FilterPropertiesByPropertyID(null);
						IEnumerator iSitePropEnum = lrrSiteCompProps.GetEnumerator();
						while(iSitePropEnum.MoveNext())
						{
							LRRSiteComponentProperty lrrSiteCompProp = iSitePropEnum.Current as LRRSiteComponentProperty;

							//Create Site Comp Property Node
							TreeNode siteCompPropNode = new TreeNode(lrrSiteCompProp.Name);

							SearchCondition condition1 = GetConditionObj("SiteComponentPropertyID",lrrSiteCompProp.ID,"=");
							SearchCriteria criteria1 = new SearchCriteria();
							criteria1.ObjType = typeof(LRRSiteComponentPropertyValue);
							ArrayList arrList1 = new ArrayList();
							arrList1.Add(condition1);
							criteria1.ArrListSearchCondition = arrList1;

							siteCompPropNode.Tag = criteria1;
							siteCompNode.Nodes.Add(siteCompPropNode);
						}
					}
				
					//Master Properties

					LRRMasterProperties lrrMasterProps = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByType(lrrMasterComp.ID);
					TreeNode masterNode = null;
					if(lrrMasterProps.Count > 0)
					{
						masterNode = new TreeNode("Master Properties");
						masterCompNode.Nodes.Add(masterNode);
					}
					IEnumerator iPropTypeEnum = _lrrPropertyTypes.GetEnumerator();
					while(iPropTypeEnum.MoveNext())
					{
						LRRPropertyType lrrPropType = iPropTypeEnum.Current as LRRPropertyType;

						LRRMasterProperties lrrMasterProperties = lrrMasterProps.GetMasterPropertiesByPropType(lrrPropType.ID);
						IEnumerator iMasterPropEnum = lrrMasterProperties.GetEnumerator();
						while(iMasterPropEnum.MoveNext())
						{
							LRRMasterProperty lrrMasterProp = iMasterPropEnum.Current as LRRMasterProperty;

							//Create Master Property Node(MasterProperties --> BFWFlow)
							if(lrrMasterProp.Type == "1")
							{
								TreeNode masterPropNode = new TreeNode(lrrMasterProp.Name);
								SearchCondition condition1 = GetConditionObj("SiteComponentPropertyID",lrrMasterProp.PropID,"=");
								SearchCriteria criteria1 = new SearchCriteria();
								criteria1.ObjType = typeof(LRRSiteComponentPropertyValue);
								ArrayList arrList1 = new ArrayList();
								arrList1.Add(condition1);
								criteria1.ArrListSearchCondition = arrList1;
								masterPropNode.Tag = criteria1;
								masterNode.Nodes.Add(masterPropNode);
							}

							//Check if Property is Simple
							if(lrrMasterProp.Type != "1")
							{
								//Property Type Node (MasterProperties --> BFWFlow-->Air Components)
								TreeNode childNode1 = new TreeNode(lrrMasterProp.Name + "-" + lrrPropType.PropertyType);
								masterNode.Nodes.Add(childNode1);
							
								//Check for Data Array
								if(!lrrPropType.IsDataArray)
								{
									LRRLookUpQualifiers lrrLkUpQuals = LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(lrrPropType.ID);
									IEnumerator iLkUpEnum = lrrLkUpQuals.GetEnumerator();
									while(iLkUpEnum.MoveNext())
									{
										LRRLookUpQualifier lrrLkUpQual = iLkUpEnum.Current as LRRLookUpQualifier;
										LRRQualifier qual = LRRModel.Qualifiers.getQualifierObjectForQualifierID(lrrLkUpQual.QualifierID);

										//Qualifier Node (MasterProperties --> BFWFlow-->Air Components --> Mol Fraction)
										TreeNode childNode2 = new TreeNode(qual.Name);
										childNode1.Nodes.Add(childNode2);

										//Get the Group properties
										LRRLookUpProperties lrrLkUpProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(lrrPropType.ID);
										IEnumerator iLkUpPropEnum = lrrLkUpProps.GetEnumerator();
										while(iLkUpPropEnum.MoveNext())
										{
											LRRLookUpProperty lrrLkUpProp = iLkUpPropEnum.Current as LRRLookUpProperty;
									
											//Grp Property Node (MasterProperties --> BFWFlow-->Air Components --> Mol Fraction --> Ar)
											TreeNode childNode3 = new TreeNode(lrrLkUpProp.Name);
											
											SearchCriteria criteria = new SearchCriteria();
											criteria.ObjType = typeof(LRRSiteGroupPropertyQualifierValue);
											ArrayList arrConditions = new ArrayList();
											SearchCondition condition1 = GetConditionObj("LookUpPropertiesID",lrrLkUpProp.LookUpPropertiesID,"=");
											arrConditions.Add(condition1);
											SearchCondition condition2 = GetConditionObj("LookUpQualifierID",lrrLkUpQual.LookUpQualifierID,"=");
											arrConditions.Add(condition2);
											SearchCondition condition3 = GetConditionObj("MasterPropID",lrrMasterProp.PropID,"=");
											arrConditions.Add(condition3);

											criteria.ArrListSearchCondition = arrConditions;
											childNode3.Tag = criteria;
											childNode2.Nodes.Add(childNode3);
										}
									}
								}
								else
								{
									//Get the Group properties
									LRRLookUpProperties lrrLkUpProps = LRRModel.LookUpProperties.getLookUpPropertiesForPropTypeID(lrrPropType.ID);
									IEnumerator iLkUpPropEnum = lrrLkUpProps.GetEnumerator();
									while(iLkUpPropEnum.MoveNext())
									{
										LRRLookUpProperty lrrLkUpProp = iLkUpPropEnum.Current as LRRLookUpProperty;
									
										//Grp Property Node (MasterProperties --> BFWFlow-->Air Components --> C00)
										TreeNode childNode2 = new TreeNode(lrrLkUpProp.Name);

										SearchCriteria criteria = new SearchCriteria();
										criteria.ObjType = typeof(LRRSiteGroupPropertyQualifierValue);
										ArrayList arrConditions = new ArrayList();
										SearchCondition condition1 = GetConditionObj("LookUpPropertiesID",lrrLkUpProp.LookUpPropertiesID,"=");
										arrConditions.Add(condition1);
										SearchCondition condition2 = GetConditionObj("MasterPropID",lrrMasterProp.PropID,"=");
										arrConditions.Add(condition2);

										criteria.ArrListSearchCondition = arrConditions;

										childNode2.Tag = criteria;
										childNode1.Nodes.Add(childNode2);
									}
								}
							}
						}
					}
				}
			}
			trvMasterProps.Nodes.Add(root);
			
		}

		private SearchCondition GetConditionObj(string name,string val,string oper)
		{
			SearchCondition condition = new SearchCondition();
			condition.Name = name;
			condition.Value = val;
			condition.Operator = oper;
			return condition;
		}

		private void GetAllChildNodes(TreeNode trvNode)
		{
			for(int i=0;i < trvNode.Nodes.Count;i++)
			{
				TreeNode trvChildNode = trvNode.Nodes[i];
				trvChildNode.Checked = trvNode.Checked;
				if(trvChildNode.Nodes != null && trvChildNode.Nodes.Count > 0)
				{
					GetAllChildNodes(trvChildNode);
				}
				else
				{
					CheckUncheckListItems(trvNode);
				}
			}
		}

		private void CheckUncheckListItems(TreeNode trvNode)
		{
			SearchCriteria criteria = trvNode.Tag as SearchCriteria;
			if(trvNode.Checked)
			{
				if(!_arrCollection.Contains(criteria))
					_arrCollection.Add(criteria);
			}
			else
			{
				if(_arrCollection.Contains(criteria))
					_arrCollection.Remove(criteria);
			}
		}

		private void SetPanel(ArrayList pnlCollection)
		{
			if(pnlCollection.Count == 0)
				return;
			int heightOfEach = this.pnlGrid.Height/pnlCollection.Count;
			int splitCnt = 0;
			for(int i= pnlCollection.Count-1;i>=0;i--)
			{
				Panel panel = pnlCollection[i] as Panel;
				panel.Height = heightOfEach;
				this.pnlGrid.Controls.Add(panel);
				if(splitCnt < pnlCollection.Count - 1)
				{
					Splitter splitGrid = new Splitter();
					splitGrid.Dock = DockStyle.Top;
					this.pnlGrid.Controls.Add(splitGrid);
					splitCnt++;
				}
			}
			if(this.pnlGrid.Controls.Count > 0)
				this.pnlGrid.Controls[0].Dock = DockStyle.Fill;
		}

		#region fields
		private LRRApp _lrrApp;
		private LRRMasterComponents _lrrMasterComps = new LRRMasterComponents();
		private LRRPropertyTypes _lrrPropertyTypes;
		private LRRComponentTypes _lrrCompTypes;
		private ArrayList _arrCollection = new ArrayList();

		private TabControl			_parentTabControl;
		private TabPage				_parentTabPage;
		private GridSavedViewController _gridView;

		#endregion

		private void trvMasterProps_AfterCheck(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			TreeNode trvNode = e.Node;
			if(trvNode.Nodes != null && trvNode.Nodes.Count > 0)
			{
				GetAllChildNodes(trvNode);
			}
			else
			{
				CheckUncheckListItems(trvNode);
			}
		}

		private void btnExec_Click(object sender, System.EventArgs e)
		{
			//Split arrayList into x and y
			ArrayList arrXCollection = new ArrayList();
			ArrayList arrYCollection = new ArrayList();
			for(int i=0;i < _arrCollection.Count;i++)
			{
				SearchCriteria criteria = _arrCollection[i] as SearchCriteria;
				if(criteria != null)
				{
					if(criteria.ObjType == typeof(LRRSiteComponent))
					{
						arrXCollection.Add(criteria);
					}
					else
					{
						arrYCollection.Add(criteria);
					}
				}
			}

			_gridView = new GridSavedViewController();
			Panel pnl = _gridView.LoadPanel(arrXCollection,arrYCollection);
			this.pnlGrid.Controls.Clear();
			SetPanel(_gridView.GetPanelCollection());
		}
		

		private void splitter2_DoubleClick(object sender, System.EventArgs e)
		{
			if(pnlLeft.Visible)
			{
				pnlLeft.Visible = false;
				pnlGrid.Dock = DockStyle.Fill;
				splVertical.Dock = DockStyle.Left;
			}
			else if(!pnlLeft.Visible)
			{
				pnlLeft.Visible = true;
				pnlGrid.Dock = DockStyle.Right;
				splVertical.Dock = DockStyle.Right;
			}
		}
		#region ILRRUIContainer Members

		public void Refresh()
		{
			// TODO:  Add SavedViewForm.Refresh implementation
		}

		public void Save()
		{
			// TODO:  Add SavedViewForm.Save implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add SavedViewForm.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add SavedViewForm.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add SavedViewForm.Copy implementation
		}

		public void Print()
		{
			if(_gridView != null)
			{
				_gridView.Print();
			}
		}

		public void PrintPreview()
		{
			if(_gridView != null)
			{
				_gridView.PrintPreview();
			}
		}

		public void PageSetup()
		{
			GridControlPrint gcPrint = new GridControlPrint();
			gcPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add SavedViewForm.Undo implementation
		}

		public void Delete()
		{
			// TODO:  Add SavedViewForm.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add SavedViewForm.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add SavedViewForm.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add SavedViewForm.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add SavedViewForm.ImportToExcel implementation
		}

		public void Export()
		{
			if(_gridView.Export() != null)
			{
				ExportToExcel excelExpForm = new ExportToExcel(_gridView.Export());
				excelExpForm.ShowDialog(this);
			}
		}

		public void SelectionPaste()
		{
			// TODO:  Add SavedViewForm.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add SavedViewForm.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add SavedViewForm.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add SavedViewForm.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add SavedViewForm.DownLevel implementation
		}

		public void ClearSort()
		{
			// TODO:  Add SavedViewForm.ClearSort implementation
		}

		public void CopyUOMTypes()
		{
			// TODO:  Add SavedViewForm.CopyUOMTypes implementation
		}

		public void ShowPropertyList()
		{
			// TODO:  Add SavedViewForm.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add SavedViewForm.ShowComponentList implementation
		}

		public void LeftColMovement()
		{
			// TODO:  Add SavedViewForm.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add SavedViewForm.RightColMovement implementation
		}

		public void OpenCompositeView()
		{
			// TODO:  Add SavedViewForm.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add SavedViewForm.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add SavedViewForm.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add SavedViewForm.OpenView implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add SavedViewForm.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add SavedViewForm.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add SavedViewForm.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add SavedViewForm.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add SavedViewForm.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add SavedViewForm.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add SavedViewForm.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add SavedViewForm.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add SavedViewForm.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add SavedViewForm.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add SavedViewForm.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add SavedViewForm.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add SavedViewForm.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add SavedViewForm.SupportsLevel implementation
			return false;
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add SavedViewForm.SupportsClearSort implementation
			return false;
		}

		public bool SupportsCopyUOMTypes()
		{
			// TODO:  Add SavedViewForm.SupportsCopyUOMTypes implementation
			return false;
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add SavedViewForm.SupportsResultsFilter implementation
			return false;
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add SavedViewForm.SupportsCompositeView implementation
			return false;
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add SavedViewForm.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add SavedViewForm.SupportsUndo implementation
			return false;
		}

		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}

		public bool PerformDirtyChk
		{
			get
			{
				return true;
			}
		}

		#endregion
	}
}

