using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;  

namespace Symcon.LightRidge.PEAdvisor.SharingPermissions
{
	/// <summary>
	/// Summary description for SharingUserControl.
	/// </summary>
	public class SharingUserControl : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Label lblRoles;
		private System.Windows.Forms.Panel pnlLblRoles;
		private System.Windows.Forms.Panel pnlUsersAndRoles;
		private System.Windows.Forms.ListView listViewUsersAndRoles;
		private System.Windows.Forms.Panel pnlAddRmvUser;
		private System.Windows.Forms.Panel pnlPermissions;
		private System.Windows.Forms.Button btnRemoveRole;
		private System.Windows.Forms.Button btnAddRole;
		private System.Windows.Forms.Label lblPermissions;
		private System.Windows.Forms.Label lblAllow;
		private System.Windows.Forms.ColumnHeader colHeaderRoles;
		private System.Windows.Forms.DataGrid dataGridPermissions;
		private System.Windows.Forms.DataGridTableStyle dataGridTableStyle1;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SharingUserControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblRoles = new System.Windows.Forms.Label();
			this.pnlLblRoles = new System.Windows.Forms.Panel();
			this.pnlUsersAndRoles = new System.Windows.Forms.Panel();
			this.listViewUsersAndRoles = new System.Windows.Forms.ListView();
			this.colHeaderRoles = new System.Windows.Forms.ColumnHeader();
			this.pnlAddRmvUser = new System.Windows.Forms.Panel();
			this.lblAllow = new System.Windows.Forms.Label();
			this.lblPermissions = new System.Windows.Forms.Label();
			this.btnAddRole = new System.Windows.Forms.Button();
			this.btnRemoveRole = new System.Windows.Forms.Button();
			this.pnlPermissions = new System.Windows.Forms.Panel();
			this.dataGridPermissions = new System.Windows.Forms.DataGrid();
			this.dataGridTableStyle1 = new System.Windows.Forms.DataGridTableStyle();
			this.pnlLblRoles.SuspendLayout();
			this.pnlUsersAndRoles.SuspendLayout();
			this.pnlAddRmvUser.SuspendLayout();
			this.pnlPermissions.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dataGridPermissions)).BeginInit();
			this.SuspendLayout();
			// 
			// lblRoles
			// 
			this.lblRoles.Location = new System.Drawing.Point(8, 16);
			this.lblRoles.Name = "lblRoles";
			this.lblRoles.Size = new System.Drawing.Size(144, 16);
			this.lblRoles.TabIndex = 0;
			this.lblRoles.Tag = "SID_ROLES";
			// 
			// pnlLblRoles
			// 
			this.pnlLblRoles.Controls.Add(this.lblRoles);
			this.pnlLblRoles.Location = new System.Drawing.Point(8, 8);
			this.pnlLblRoles.Name = "pnlLblRoles";
			this.pnlLblRoles.Size = new System.Drawing.Size(376, 40);
			this.pnlLblRoles.TabIndex = 2;
			// 
			// pnlUsersAndRoles
			// 
			this.pnlUsersAndRoles.Controls.Add(this.listViewUsersAndRoles);
			this.pnlUsersAndRoles.Location = new System.Drawing.Point(8, 48);
			this.pnlUsersAndRoles.Name = "pnlUsersAndRoles";
			this.pnlUsersAndRoles.Size = new System.Drawing.Size(376, 112);
			this.pnlUsersAndRoles.TabIndex = 3;
			// 
			// listViewUsersAndRoles
			// 
			this.listViewUsersAndRoles.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																									this.colHeaderRoles});
			this.listViewUsersAndRoles.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listViewUsersAndRoles.Location = new System.Drawing.Point(0, 0);
			this.listViewUsersAndRoles.MultiSelect = false;
			this.listViewUsersAndRoles.Name = "listViewUsersAndRoles";
			this.listViewUsersAndRoles.Size = new System.Drawing.Size(376, 112);
			this.listViewUsersAndRoles.TabIndex = 0;
			this.listViewUsersAndRoles.View = System.Windows.Forms.View.SmallIcon;
			this.listViewUsersAndRoles.SelectedIndexChanged += new System.EventHandler(this.listViewUsersAndRoles_SelectedIndexChanged);
			// 
			// colHeaderRoles
			// 
			this.colHeaderRoles.Width = 376;
			// 
			// pnlAddRmvUser
			// 
			this.pnlAddRmvUser.Controls.Add(this.lblAllow);
			this.pnlAddRmvUser.Controls.Add(this.lblPermissions);
			this.pnlAddRmvUser.Controls.Add(this.btnAddRole);
			this.pnlAddRmvUser.Controls.Add(this.btnRemoveRole);
			this.pnlAddRmvUser.Location = new System.Drawing.Point(8, 160);
			this.pnlAddRmvUser.Name = "pnlAddRmvUser";
			this.pnlAddRmvUser.Size = new System.Drawing.Size(376, 64);
			this.pnlAddRmvUser.TabIndex = 4;
			// 
			// lblAllow
			// 
			this.lblAllow.Location = new System.Drawing.Point(312, 40);
			this.lblAllow.Name = "lblAllow";
			this.lblAllow.Size = new System.Drawing.Size(40, 16);
			this.lblAllow.TabIndex = 3;
			this.lblAllow.Tag = "SID_ALLOW";
			// 
			// lblPermissions
			// 
			this.lblPermissions.Location = new System.Drawing.Point(8, 40);
			this.lblPermissions.Name = "lblPermissions";
			this.lblPermissions.Size = new System.Drawing.Size(144, 16);
			this.lblPermissions.TabIndex = 2;
			this.lblPermissions.Tag = "SID_PERMISSIONS_LABEL";
			// 
			// btnAddRole
			// 
			this.btnAddRole.Location = new System.Drawing.Point(216, 8);
			this.btnAddRole.Name = "btnAddRole";
			this.btnAddRole.TabIndex = 1;
			this.btnAddRole.Tag = "SID_ADD";
			this.btnAddRole.Click += new System.EventHandler(this.btnAddRole_Click);
			// 
			// btnRemoveRole
			// 
			this.btnRemoveRole.Enabled = false;
			this.btnRemoveRole.Location = new System.Drawing.Point(296, 8);
			this.btnRemoveRole.Name = "btnRemoveRole";
			this.btnRemoveRole.TabIndex = 0;
			this.btnRemoveRole.Tag = "SID_DEL";
			this.btnRemoveRole.Click += new System.EventHandler(this.btnRemoveRole_Click);
			// 
			// pnlPermissions
			// 
			this.pnlPermissions.Controls.Add(this.dataGridPermissions);
			this.pnlPermissions.Location = new System.Drawing.Point(8, 224);
			this.pnlPermissions.Name = "pnlPermissions";
			this.pnlPermissions.Size = new System.Drawing.Size(376, 144);
			this.pnlPermissions.TabIndex = 5;
			// 
			// dataGridPermissions
			// 
			this.dataGridPermissions.BackgroundColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.dataGridPermissions.CaptionBackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.dataGridPermissions.CaptionVisible = false;
			this.dataGridPermissions.ColumnHeadersVisible = false;
			this.dataGridPermissions.DataMember = "";
			this.dataGridPermissions.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dataGridPermissions.ForeColor = System.Drawing.Color.Black;
			this.dataGridPermissions.GridLineColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.dataGridPermissions.GridLineStyle = System.Windows.Forms.DataGridLineStyle.None;
			this.dataGridPermissions.HeaderForeColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.dataGridPermissions.LinkColor = System.Drawing.SystemColors.ControlLightLight;
			this.dataGridPermissions.Location = new System.Drawing.Point(0, 0);
			this.dataGridPermissions.Name = "dataGridPermissions";
			this.dataGridPermissions.ParentRowsForeColor = System.Drawing.SystemColors.InactiveBorder;
			this.dataGridPermissions.RowHeadersVisible = false;
			this.dataGridPermissions.SelectionBackColor = System.Drawing.SystemColors.ActiveBorder;
			this.dataGridPermissions.SelectionForeColor = System.Drawing.Color.Silver;
			this.dataGridPermissions.Size = new System.Drawing.Size(376, 144);
			this.dataGridPermissions.TabIndex = 0;
			this.dataGridPermissions.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
																											this.dataGridTableStyle1});
			this.dataGridPermissions.MouseUp += new System.Windows.Forms.MouseEventHandler(this.dataGridPermissions_MouseUp);
			// 
			// dataGridTableStyle1
			// 
			this.dataGridTableStyle1.AllowSorting = false;
			this.dataGridTableStyle1.ColumnHeadersVisible = false;
			this.dataGridTableStyle1.DataGrid = this.dataGridPermissions;
			this.dataGridTableStyle1.GridLineColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.dataGridTableStyle1.GridLineStyle = System.Windows.Forms.DataGridLineStyle.None;
			this.dataGridTableStyle1.HeaderBackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.dataGridTableStyle1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridTableStyle1.MappingName = "Permissions";
			this.dataGridTableStyle1.RowHeadersVisible = false;
			this.dataGridTableStyle1.SelectionBackColor = System.Drawing.SystemColors.ActiveCaptionText;
			// 
			// SharingUserControl
			// 
			this.Controls.Add(this.pnlPermissions);
			this.Controls.Add(this.pnlAddRmvUser);
			this.Controls.Add(this.pnlUsersAndRoles);
			this.Controls.Add(this.pnlLblRoles);
			this.Name = "SharingUserControl";
			this.Size = new System.Drawing.Size(392, 376);
			this.pnlLblRoles.ResumeLayout(false);
			this.pnlUsersAndRoles.ResumeLayout(false);
			this.pnlAddRmvUser.ResumeLayout(false);
			this.pnlPermissions.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dataGridPermissions)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Private Methods
		/// <summary>
		/// Adds items to List View users and roles
		/// </summary>
		private void BindListViewUsersAndRoles()
		{
			this.listViewUsersAndRoles.SmallImageList = this._lrrApp.MainFrame.ImageList3;
			this.listViewUsersAndRoles.ArrangeIcons(ListViewAlignment.Top);
			IEnumerator iEnum = _lrrRoles.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRRole lrrRole = iEnum.Current as LRRRole;
				ListViewItem lvItem = new ListViewItem(lrrRole.RoleName,65);
				ListItem listItemObj = new ListItem();
				listItemObj.ItemType = "Role";
				listItemObj.ItemObject = lrrRole;
				lvItem.Tag = listItemObj;
				this.listViewUsersAndRoles.Items.Add(lvItem);
			}
			IEnumerator iViewEnum = _lrrViewSharings.GetViewSharingsByViewID(this.ViewID).GetEnumerator();
			while(iViewEnum.MoveNext())
			{
				LRRViewSharing viewSharing = iViewEnum.Current as LRRViewSharing;
				if(!viewSharing.IsRole)
				{
					LRRLogin lrrLogin = _lrrLogins.GetLRRLoginObjFromID(viewSharing.UserID);
					if(lrrLogin != null)
					{
						ListViewItem lvItem = new ListViewItem(lrrLogin.UserName,66);
						ListItem listItemObj = new ListItem();
						listItemObj.ItemType = "User";
						listItemObj.ItemObject = lrrLogin;
						lvItem.Tag = listItemObj;
						this.listViewUsersAndRoles.Items.Add(lvItem);
						this.btnRemoveRole.Enabled = true;
					}
				}
			}
			
			
			if(this.listViewUsersAndRoles.Items.Count > 0)
				this.listViewUsersAndRoles.Items[0].Selected = true;
		}
		
		/// <summary>
		/// Adds items to Data Grid View Permissions
		/// </summary>
		private void BindUserPermissions()
		{
			DataTable dtTable = new DataTable("Permissions");
			DataRow drRow;
 
			dtTable.Columns.Add(new DataColumn("Name", typeof(string)));
			dtTable.Columns.Add(new DataColumn("Allow", typeof(bool)));
 
			for (int i = 0; i < 3; i++) 
			{
				drRow = dtTable.NewRow();
				
				if(i == 0)
					drRow[0] = "FullControl";
				if(i == 1)
					drRow[0] = "Change";
				if(i == 2)
					drRow[0] = "Read";
				drRow[1] = false;
 
				dtTable.Rows.Add(drRow);
			}
			
			DataView dvView = new DataView(dtTable);
			this.dataGridPermissions.DataSource = dvView;
			dvView.AllowNew = false;

			DataGridTextBoxColumn nameCol = this.dataGridPermissions.TableStyles[0].GridColumnStyles["Name"] as DataGridTextBoxColumn;
			nameCol.MappingName = "Name";
			nameCol.Width = 290;
			nameCol.ReadOnly = true;
			
			DataGridBoolColumn allowCol = this.dataGridPermissions.TableStyles[0].GridColumnStyles["Allow"] as DataGridBoolColumn;
			allowCol.AllowNull = false;
			allowCol.MappingName = "Allow";
			allowCol.Width = 76;
			allowCol.ReadOnly = false;
		}
		
		/// <summary>
		/// Initializes the datasource
		/// </summary>
		private void InitDataSource()
		{
			if(_lrrRoles != null)
				_lrrRoles.Clear();
			if(_lrrViewSharings != null)
				_lrrViewSharings.Clear();
			if(_lrrUserRoleMappings != null)
				_lrrUserRoleMappings.Clear();
			if(_lrrLogins != null)
				_lrrLogins.Clear();

			_lrrRoles = new LRRRoles();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrRoles);
//			LRRRoles lrrRoles = new LRRRoles();
//			_lrrApp.DBManagerObj.PopulateCollection(lrrRoles);

			_lrrViewSharings = new LRRViewSharings();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrViewSharings,"",false,true);

			_lrrUserRoleMappings = new LRRUserRoleMappings();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrUserRoleMappings);
				
//			string userRoleID = this._lrrApp.DBManagerObj.AccessControlModel.UserRoleID;
//			LRRRole lrrRole = lrrRoles.getRoleObjectForRoleID(userRoleID);
//			_lrrRoles.Add(lrrRole);
//			SetRoles(lrrRoles,userRoleID);
//			
//			string userIDList = "";
//			foreach(LRRRole role in _lrrRoles)
//			{
//				LRRUserRoleMappings lrrUserRoleMappings = _lrrUserRoleMappings.GetUserRoleMappingForRoleId(role.ID);
//				foreach(LRRUserRoleMapping lrrUserRoleMapping in lrrUserRoleMappings)
//				{
//					if (userIDList == "")
//						userIDList ="'" + lrrUserRoleMapping.UID + "'";
//					else
//						userIDList = userIDList + ", '" + lrrUserRoleMapping.UID + "'" ;
//				}
//			}

			_lrrLogins = new LRRLogins();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLogins);
		}
		
//		private void SetRoles(LRRRoles lrrRoles,string roleID)
//		{	
//			foreach(LRRRole role in lrrRoles)
//			{
//				if(role.ParentRoleID == roleID
//					&& role.ID != roleID)
//				{
//					_lrrRoles.Add(role);
//					SetRoles(lrrRoles,role.ID);
//				}
//			}
//		}
		#endregion

		#region Public Methods
		/// <summary>
		/// Initializes the Control
		/// </summary>
		public void InitializeControl()
		{
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			InitDataSource();
			BindListViewUsersAndRoles();
			BindUserPermissions();
		}
		
		/// <summary>
		/// Applies the permissions
		/// </summary>
		public void ApplyPermissions()
		{
			CurrencyManager cm =(CurrencyManager) BindingContext[this.dataGridPermissions.DataSource];
			DataView dataView = (DataView) cm.List;
			DataRowView drViewFullControl = dataView[0];
			DataRowView drViewChange = dataView[1];
			DataRowView drViewRead = dataView[2];
			
			if(this.listViewUsersAndRoles.SelectedItems.Count <= 0)
				return;

			ListViewItem lvItem = this.listViewUsersAndRoles.SelectedItems[0];
			
			LRRViewSharings lrrViewSharings = new LRRViewSharings();
			ListItem listItemObj = lvItem.Tag as ListItem;
			if(listItemObj.ItemType == "Role")
			{
				LRRRole lrrRole = listItemObj.ItemObject as LRRRole;
				LRRViewSharing roleSharing = _lrrViewSharings.GetViewSharingByRoleIDAndViewID(lrrRole.ID,this.ViewID);
				if(roleSharing != null)
					lrrViewSharings.Add(roleSharing);
			}

			if(listItemObj.ItemType == "User")
			{
				LRRLogin lrrLogin = listItemObj.ItemObject as LRRLogin;
				LRRViewSharing viewSharing = _lrrViewSharings.GetViewSharingOnlyByUserIDAndViewID(lrrLogin.UserID,this.ViewID);
				if(viewSharing != null)
					lrrViewSharings.Add(viewSharing);
				else
				{
					viewSharing = new LRRViewSharing();
					viewSharing.ViewID = this.ViewID;
					viewSharing.UserID = lrrLogin.UserID;
					viewSharing.FullControlPermission = false;
					viewSharing.ChangePermission = false;
					viewSharing.ReadPermission = false;
					lrrViewSharings.Add(viewSharing);
				}
			}
			
			if(lrrViewSharings.Count > 0)
				_lrrApp.DBManagerObj.CommitCollection(lrrViewSharings);

			lrrViewSharings.RefreshCollection();
		}
		
		/// <summary>
		/// Saves the permissions
		/// </summary>
		public void Save()
		{
			if(_lrrViewSharings.GetChanges().Count > 0)
				_lrrApp.DBManagerObj.CommitCollection(_lrrViewSharings.GetChanges());
		}
		#endregion

		#region Fields
		private LRRApp _lrrApp;  //...App Object
		private LRRRoles _lrrRoles; //..BO for Roles
		private LRRViewSharings _lrrViewSharings; //...BO for View Sharings
		private LRRUserRoleMappings _lrrUserRoleMappings; //...BO for User Role Mappings
		private ListViewItem  prevSelectedItem;
		private LRRViewSharings _lrrTempViewSharings = new LRRViewSharings(); 
		private string			_viewID; //...View ID
		private LRRLogins		_lrrLogins; //...BO for Logins
		#endregion

		#region Properties
		public string ViewID
		{
			get{return _viewID;}
			set
			{
				_viewID = value;
			}
		}
		#endregion
		
		#region EventHandlers
		private void dataGridPermissions_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int rowIndex = this.dataGridPermissions.CurrentRowIndex;
			int colIndex = this.dataGridPermissions.CurrentCell.ColumnNumber;
			if(colIndex == 0)
				return;
			if(this.listViewUsersAndRoles.SelectedItems.Count <= 0)
				return;

			DataGrid.HitTestInfo hti = this.dataGridPermissions.HitTest( e.X, e.Y );
			try
			{
				if ( hti.Type == DataGrid.HitTestType.Cell)
					this.dataGridPermissions[ hti.Row, hti.Column ] = ! (bool) this.dataGridPermissions[ hti.Row, hti.Column ];
			}
			catch( Exception ex )
			{
				MessageBox.Show( ex.Message );
			}


			CurrencyManager cm =(CurrencyManager) BindingContext[this.dataGridPermissions.DataSource];
			DataView dataView = (DataView) cm.List;
			DataRowView drRowView = cm.Current as DataRowView;
			bool bVal = (bool)drRowView["Allow"];
			for(int i = rowIndex ;i < 3;i++)
			{
				DataRowView drView = dataView[i];
				if(bVal == true)
					drView[colIndex] = true;
			}

			for(int i = rowIndex;i >= 0;i--)
			{
				DataRowView drView = dataView[i];
				if(bVal == false)
					drView[colIndex] = false;
			}

			DataRowView drViewFullControl = dataView[0];
			DataRowView drViewChange = dataView[1];
			DataRowView drViewRead = dataView[2];

			//Update in temp View Sharings
			ListViewItem lvItem = this.listViewUsersAndRoles.SelectedItems[0];
			ListItem listItemObj = lvItem.Tag as ListItem;
			if(listItemObj.ItemType == "Role")
			{
				LRRRole lrrRole = listItemObj.ItemObject as LRRRole;
				LRRViewSharing roleSharing = _lrrViewSharings.GetViewSharingByRoleIDAndViewID(lrrRole.ID,this.ViewID);
				if(roleSharing == null)
				{
					roleSharing = new LRRViewSharing();
					_lrrViewSharings.Add(roleSharing);
				}
				roleSharing.ViewID = this.ViewID;
				roleSharing.RoleID = lrrRole.ID;
				roleSharing.FullControlPermission = (bool)drViewFullControl["Allow"];
				roleSharing.ChangePermission = (bool)drViewChange["Allow"];
				roleSharing.ReadPermission = (bool)drViewRead["Allow"];
				roleSharing.IsRole = true;
			
			}

			if(listItemObj.ItemType == "User")
			{
				LRRLogin lrrLogin = listItemObj.ItemObject as LRRLogin;
				
				//Validation for User
				LRRUserRoleMapping userRoleMap = _lrrUserRoleMappings.GetUserRoleMappingForUserId(lrrLogin.UserID);
				string roleID = userRoleMap.RoleID;
				LRRViewSharing roleSharing = _lrrViewSharings.GetViewSharingByRoleIDAndViewID(roleID,this.ViewID);
				bool fullControl = false;
				bool change  = false;
				bool read  = false;
				bool isAllowed = true;
				if(roleSharing != null)
				{
					if(roleSharing.FullControlPermission)
					{
						fullControl = (bool)drViewFullControl["Allow"];
						change = (bool)drViewChange["Allow"];;
						read = (bool)drViewRead["Allow"];
					}
					else if(roleSharing.ChangePermission)
					{
						fullControl = false;
						if((bool)drViewFullControl["Allow"] == true)
							isAllowed = false;
						change = (bool)drViewChange["Allow"];
						read = (bool)drViewRead["Allow"];
					}
					else if(roleSharing.ReadPermission)
					{
						fullControl = false;
						change = false;
						if((bool)drViewFullControl["Allow"] == true || (bool)drViewChange["Allow"] == true) 
							isAllowed = false;
						read = (bool)drViewRead["Allow"];
					}
					else
					{
						fullControl = false;
						change = false;
						read = false;
						
						if((bool)drViewFullControl["Allow"] == true || (bool)drViewChange["Allow"] == true
							|| (bool)drViewRead["Allow"] == true) 
							isAllowed = false;
					}
				}
				else
				{
					isAllowed = false;
				}

				if(!isAllowed)
				{
					//						MessageBox.Show("Permissions not allowed for this user.");
					LRRMessagBox.ShowMessage("SID_PERMISSIONS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Warning);
				}

				LRRViewSharing viewSharing = _lrrViewSharings.GetViewSharingOnlyByUserIDAndViewID(lrrLogin.UserID,this.ViewID);
				if(viewSharing == null)
				{
					viewSharing = new LRRViewSharing();
					_lrrViewSharings.Add(viewSharing);
				}
				viewSharing.ViewID = this.ViewID;
				viewSharing.UserID = lrrLogin.UserID;
				viewSharing.FullControlPermission = fullControl;
				viewSharing.ChangePermission = change;
				viewSharing.ReadPermission = read;
				
				try
				{
					drViewFullControl[1] = fullControl;
					drViewChange[1] = change;
					drViewRead[1] = read;
					drViewFullControl.Row.AcceptChanges();
					drViewChange.Row.AcceptChanges();
					drViewRead.Row.AcceptChanges();
//					this.dataGridPermissions[0,1] = fullControl;
//					this.dataGridPermissions[1,1] = change;
//					this.dataGridPermissions[2,1] = read;
				}
				catch{}
			}
			this.dataGridPermissions.Refresh();
		}
		
		private void listViewUsersAndRoles_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ListView listView = sender as ListView;
			if(prevSelectedItem != null)
				prevSelectedItem.BackColor = System.Drawing.SystemColors.Window;
			if(listView.SelectedItems.Count > 0)
			{
				ListViewItem lvItem = listView.SelectedItems[0];
				if(lvItem != null)
				{
					lvItem.BackColor = System.Drawing.SystemColors.ControlLight;
					prevSelectedItem = lvItem;
					
					CurrencyManager cm =(CurrencyManager) BindingContext[this.dataGridPermissions.DataSource];
					DataView dataView = (DataView) cm.List;
					DataRowView drViewFullControl = dataView[0];
					DataRowView drViewChange = dataView[1];
					DataRowView drViewRead = dataView[2];
					
					ListItem listItemObj = lvItem.Tag as ListItem;
					LRRViewSharing lrrViewSharing = null;
					if(listItemObj.ItemType == "Role")
					{
						LRRRole lrrRole = listItemObj.ItemObject as LRRRole;
						lrrViewSharing = _lrrViewSharings.GetViewSharingByRoleIDAndViewID(lrrRole.ID,this.ViewID);
					}
					else if(listItemObj.ItemType == "User")
					{
						LRRLogin lrrLogin = listItemObj.ItemObject as LRRLogin;
						lrrViewSharing = _lrrViewSharings.GetViewSharingOnlyByUserIDAndViewID(lrrLogin.UserID,this.ViewID);
					}

					if(lrrViewSharing != null)
					{
						if(lrrViewSharing.FullControlPermission)
						{
							drViewFullControl["Allow"] = true;
							drViewChange["Allow"] = true;
							drViewRead["Allow"] = true;
						}
						else if(lrrViewSharing.ChangePermission)
						{
							drViewChange["Allow"] = true;
							drViewRead["Allow"] = true;
							drViewFullControl["Allow"] = false;
						} 
						else if(lrrViewSharing.ReadPermission)
						{
							drViewRead["Allow"] = true;

							drViewFullControl["Allow"] = false;
							drViewChange["Allow"] = false;
						}
						else
						{
							drViewFullControl["Allow"] = false;
							drViewChange["Allow"] = false;
							drViewRead["Allow"] = false;
						}
					}
					else
					{
//						this.dataGridPermissions[0,1] = false;
						drViewFullControl["Allow"] = false;
						drViewChange["Allow"] = false;
						drViewRead["Allow"] = false;
					}
					drViewFullControl.Row.AcceptChanges();
					drViewChange.Row.AcceptChanges();
					drViewRead.Row.AcceptChanges();
				}
			}


			this.dataGridPermissions.Refresh();
		}
		
		private void btnAddRole_Click(object sender, System.EventArgs e)
		{
			AddUserForm addUserFrm = new AddUserForm();
			DialogResult dlgResult = addUserFrm.ShowDialog();
			if(dlgResult == DialogResult.OK)
			{
				if(addUserFrm.SelectedUser != null)
				{
					LRRLogin selectedlrrLogin = addUserFrm.SelectedUser;
					for(int i=0; i < this.listViewUsersAndRoles.Items.Count;i++)
					{
						ListViewItem listViewItem = listViewUsersAndRoles.Items[i];
						ListItem lvItemObj = listViewItem.Tag as ListItem;
						if(lvItemObj != null && lvItemObj.ItemType == "User")
						{
							LRRLogin lvLogin = lvItemObj.ItemObject as LRRLogin;
							if(lvLogin.UserName == selectedlrrLogin.UserName)
								return;
						}
					}

					ListViewItem lvItem = new ListViewItem(selectedlrrLogin.UserName,66);
					ListItem listItemObj = new ListItem();
					listItemObj.ItemType = "User";
					listItemObj.ItemObject = selectedlrrLogin;
					lvItem.Tag = listItemObj;
					this.listViewUsersAndRoles.Items.Add(lvItem);
					this.listViewUsersAndRoles.Items[lvItem.Index].Selected = true;
					this.btnRemoveRole.Enabled = true;
				}
			}
		}

		private void btnRemoveRole_Click(object sender, System.EventArgs e)
		{
			if(this.listViewUsersAndRoles.SelectedItems.Count > 0)
			{
				ListViewItem listViewItem = this.listViewUsersAndRoles.SelectedItems[0];
				ListItem lvItem = listViewItem.Tag as ListItem;
				if(lvItem != null && lvItem.ItemType == "User")
				{
					this.listViewUsersAndRoles.Items.Remove(listViewItem);
					LRRLogin lrrLogin = lvItem.ItemObject as LRRLogin;
					LRRViewSharing viewSharing = _lrrViewSharings.GetViewSharingOnlyByUserIDAndViewID(lrrLogin.UserID,this.ViewID);
					if(viewSharing != null)
					{
						_lrrViewSharings.Remove(viewSharing);
						this.dataGridPermissions[0,1] = false;
						this.dataGridPermissions[1,1] = false;
						this.dataGridPermissions[2,1] = false;
						this.dataGridPermissions.Refresh();
					}
				}
				bool bFlag = false;
				for(int i=0;i < this.listViewUsersAndRoles.Items.Count;i++)
				{
					ListViewItem listViewItem1 = this.listViewUsersAndRoles.Items[i];
					ListItem lvItem1 = listViewItem1.Tag as ListItem;
					if(lvItem1 != null && lvItem1.ItemType == "User")
					{
						this.btnRemoveRole.Enabled = true;
						bFlag = true;
						break;
					}
				}
				if(!bFlag)
				{
					this.btnRemoveRole.Enabled = false;
				}
			}
		}
		#endregion
	}
}
