using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using Syncfusion.Grouping;
using Syncfusion.ComponentModel;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;
using System.Collections.Generic;

using Symcon.AccessControl;
using Symcon.AccessControl.Model;
using Symcon.Globals.Enums;




//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for EquipmentEntry.
	/// </summary>
	public class SiteComponentEntry : System.Windows.Forms.Form,ILRRUIContainer
	{
		#region Fields

		private LRRSiteComponents							_lrrSiteComponents = null; //Instance for the site components.
		private bool										_called = false;
		private string										_siteCompontId;
		private LRRSiteComponents							_siteComponents = new LRRSiteComponents(); //Instance for the site components ...
		private LRRSiteComponentProperties					_siteCompProperties; //Instance for the properties...
		private LRRSiteComponentAdditionalInformations		_siteCompAdditionalinfos; //Instance atoring the additional infos..
		private LRRSiteComponentPropertyUserAndTimes		_siteCompPropsUserAndTimes; //Overrides
		private LRRSiteComponentPropertyValues				_siteComponentPropertyValues;
		private LRRSiteComponentPropertyValues  			_siteComponentPropertyOriginalValues;
		private LRRLookUpProperties							_lrrLookUpProperties;
		private LRRPropertyTypes							_lrrPropertyTypes;
//		private LRRModes									_modes;
		private LRRLevels									_levels;
		private LRRHistDatas								_lrrHistdata;
		private LRRLevel									_level;
		private LRRAggregates					_lrrAggregates;

		private LRRSiteComponentGroupProperties				_siteCompGroupedProperties;
		private LRRSiteGroupPropertyQualifierValues			_siteGroupPropertyQualifierValues;
        LRRFormulas formulasToCommit = new LRRFormulas();
		//private LRRSiteComponentGroupPropertyValues			_siteCompGroupPropertyValues;

		private GridRelatedCellStyleHelper		_gridRelatedCellStyleHelper = new GridRelatedCellStyleHelper();

		//private GridRecordStateFormatter		_siteCompRowStateFormatter = new GridRecordStateFormatter(); //Formats the row color as the state of the object changes.
		//private GridRecordStateFormatter		_siteComPropRowStateFormatter = new GridRecordStateFormatter();
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ContextMenu contextMenuSiteCompProperties;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barMasterProperties;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barDerivedProperties;
		private LRRApp							_app;
        private AggregateUtility objAggregateUtility;
		
		private GridExcelFormatter _gridExcelFormatter = new GridExcelFormatter();
		private DuplicateValidation _chkDuplicate	= new DuplicateValidation();
		private LRRUIManager lrrUI=new LRRUIManager();
		Hashtable lrrFormulaSiteComponents = new Hashtable();
		Hashtable lrrMasterPropertyDirections = new Hashtable();
		private System.ComponentModel.IContainer components;

		private GridRecordNavigationControl gnc = new GridRecordNavigationControl();
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barShowProperties;
		private System.Windows.Forms.Panel mainPanel;
		//private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteComponent;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barPaste;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteComponent;

		//private GridRecordStateFormatter gridRecStateFormatter = new GridRecordStateFormatter();
		private bool initializing = false;
		private string _LocaleID;
		private System.Windows.Forms.ContextMenu gridContext;
		public static bool copyToAll = false;
		Hashtable oForAlerts;
		bool editFlag = true;
		bool groupPropertyeditFlag = true;

		
		private TabControl			_parentTabControl;
		private System.Windows.Forms.MenuItem menuoverrideformula;
		private TabPage				_parentTabPage;

        private ArrayList _arrPlantItemsForRebuildWaterModel = new ArrayList();
        private ArrayList _arrPlantItemsForRebuildWaterModel2 = new ArrayList();

		
				
		#endregion
		public SiteComponentEntry()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			_LocaleID = _app.AppLocaleID;

			InitDataSource();

			SyncGridUtilities.InitializeGridLookAndFeel(gridSiteComponent);

			_chkDuplicate.ChkDuplicate(gridSiteComponent,"SiteComponentID","ID","Name","Name","ComponentID");
		
					
			//_siteCompRowStateFormatter.WireGrid(gridSiteCompProperties);

//			_gridExcelFormatter.WireGrid(gridSiteComponent);

			//this.gridSiteComponent.TableOptions.
			//SyncGridUtilities.InitializeGridLookAndFeel(gridSiteCompProperties);
			//gridSiteComponent.Binder.CurrentPositionChanged+=new EventHandler(Binder_CurrentPositionChanged);

			this.Activated+=new EventHandler(SiteComponentEntry_Activated);
			//Tool Bar for the Master Properties Section...
			this.barDerivedProperties.Click+=new EventHandler(bar_Click);
			this.barMasterProperties.Click+=new EventHandler(bar_Click);
			this.barSave.Click+=new EventHandler(barSave_Click);
			this.barShowProperties.Click+=new EventHandler(barShowProperties_Click);
			this.barPaste.Click+=new EventHandler(barPaste_Click);
			


			//this.gridSiteComponent.TableDescriptor.Relations = relations;*/
			InitializeGrid();
			initializing = true;
			//oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
			//oForAlerts.Clear();

            PopulatePlantItemsForRebuildWaterModel();
		}


		public SiteComponentEntry(string sSiteCompID)
		{

			InitializeComponent();
		
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			_LocaleID = _app.AppLocaleID;

			InitDataSource(sSiteCompID); 

			SyncGridUtilities.InitializeGridLookAndFeel(gridSiteComponent);


			//_gridExcelFormatter.WireGrid(gridSiteComponent);


			this.Activated+=new EventHandler(SiteComponentEntry_Activated);
			//Tool Bar for the Master Properties Section...
			this.barDerivedProperties.Click+=new EventHandler(bar_Click);
			this.barMasterProperties.Click+=new EventHandler(bar_Click);
			this.barSave.Click+=new EventHandler(barSave_Click);
			this.barShowProperties.Click+=new EventHandler(barShowProperties_Click);
			this.barPaste.Click+=new EventHandler(barPaste_Click);
			
		
			initializing = true;
			InitializeGrid();
			//oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
			//oForAlerts.Clear();
            PopulatePlantItemsForRebuildWaterModel();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SiteComponentEntry));
			this.barMasterProperties = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.barDerivedProperties = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barShowProperties = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.contextMenuSiteCompProperties = new System.Windows.Forms.ContextMenu();
			this.mainPanel = new System.Windows.Forms.Panel();
			this.gridSiteComponent = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.gridContext = new System.Windows.Forms.ContextMenu();
			this.menuoverrideformula = new System.Windows.Forms.MenuItem();
			this.mainPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridSiteComponent)).BeginInit();
			this.SuspendLayout();
			// 
			// barMasterProperties
			// 
			this.barMasterProperties.CategoryIndex = -1;
			this.barMasterProperties.ID = "MP";
			this.barMasterProperties.ImageIndex = 1;
			this.barMasterProperties.ImageList = this.imageList1;
			this.barMasterProperties.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barMasterProperties.Shortcut = System.Windows.Forms.Shortcut.Ins;
			this.barMasterProperties.Text = "Add MasterProperties";
			this.barMasterProperties.Tooltip = "Add the Master Properties to the Equipment/System";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// barDerivedProperties
			// 
			this.barDerivedProperties.CategoryIndex = -1;
			this.barDerivedProperties.ID = "DP";
			this.barDerivedProperties.ImageIndex = 0;
			this.barDerivedProperties.ImageList = this.imageList1;
			this.barDerivedProperties.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barDerivedProperties.Text = "Create Derived Properties";
			// 
			// barSave
			// 
			this.barSave.CategoryIndex = -1;
			this.barSave.ID = "Save";
			this.barSave.ImageIndex = 7;
			this.barSave.ImageList = this.imageList1;
			this.barSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
			this.barSave.Text = "Save";
			// 
			// barShowProperties
			// 
			this.barShowProperties.CategoryIndex = -1;
			this.barShowProperties.ID = "Select Columns";
			this.barShowProperties.Text = "Select Columns";
			// 
			// barPaste
			// 
			this.barPaste.CategoryIndex = -1;
			this.barPaste.ID = "Paste";
			this.barPaste.Text = "Paste";
			// 
			// mainPanel
			// 
			this.mainPanel.Controls.Add(this.gridSiteComponent);
			this.mainPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			this.mainPanel.Location = new System.Drawing.Point(0, 0);
			this.mainPanel.Name = "mainPanel";
			this.mainPanel.Size = new System.Drawing.Size(560, 624);
			this.mainPanel.TabIndex = 1;
			// 
			// gridSiteComponent
			// 
			this.gridSiteComponent.Appearance.FilterBarCell.AllowEnter = true;
			this.gridSiteComponent.Appearance.FilterBarCell.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.Editable;
			this.gridSiteComponent.BackColor = System.Drawing.SystemColors.Window;
			this.gridSiteComponent.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridSiteComponent.Location = new System.Drawing.Point(0, 0);
			this.gridSiteComponent.Name = "gridSiteComponent";
			this.gridSiteComponent.Size = new System.Drawing.Size(560, 624);
			this.gridSiteComponent.TabIndex = 18;
			this.gridSiteComponent.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridSiteComponent.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridSiteComponent.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridSiteComponent.TableOptions.AllowSortColumns = true;
			this.gridSiteComponent.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
			this.gridSiteComponent.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridSiteComponent.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridSiteComponent.Text = "gridSiteComponent";
			this.gridSiteComponent.ThemesEnabled = false;
			this.gridSiteComponent.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridSiteComponent.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridSiteComponent.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridSiteComponent.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridSiteComponent.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridSiteComponent.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridSiteComponent.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridSiteComponent.VersionInfo = "3.301.0.0";
			this.gridSiteComponent.TableControlCurrentCellKeyPress += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventHandler(this.gridSiteComponent_TableControlCurrentCellKeyPress);
			this.gridSiteComponent.KeyUp += new System.Windows.Forms.KeyEventHandler(this.gridSiteComponent_KeyUp);
			this.gridSiteComponent.TableControlKeyUp += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridSiteComponent_TableControlKeyUp);
			this.gridSiteComponent.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridSiteComponent_TableControlCellClick);
			this.gridSiteComponent.TableControlQueryAllowSortColumn += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventHandler(this.gridSiteComponent_TableControlQueryAllowSortColumn);
			this.gridSiteComponent.TableControlCurrentCellKeyDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventHandler(this.gridSiteComponent_TableControlCurrentCellKeyDown);
			this.gridSiteComponent.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridSiteComponent_CurrentRecordContextChange);
			// 
			// gridContext
			// 
			this.gridContext.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuoverrideformula});
			// 
			// menuoverrideformula
			// 
			this.menuoverrideformula.Index = 0;
			this.menuoverrideformula.Text = "OverrideFormula";
			this.menuoverrideformula.Click += new System.EventHandler(this.menuoverrideformula_Click);
			// 
			// SiteComponentEntry
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 624);
			this.Controls.Add(this.mainPanel);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "SiteComponentEntry";
			this.Tag = "SID_PLANTITEMANDATTR";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Load += new System.EventHandler(this.EquipmentEntry_Load);
            this.Closing += new CancelEventHandler(SiteComponentEntry_Closing);
			this.Closed += new System.EventHandler(this.EquipmentEntry_Closed);
			this.Activated += new System.EventHandler(this.SiteComponentEntry_Activated_1);
			this.mainPanel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridSiteComponent)).EndInit();
			this.ResumeLayout(false);

		}

        void SiteComponentEntry_Closing(object sender, CancelEventArgs e)
        {
            
            if (_siteCompPropsUserAndTimes != null)
                _siteCompPropsUserAndTimes.Clear();
            if (_siteCompAdditionalinfos != null)
                _siteCompAdditionalinfos.Clear();
            if (_lrrLookUpProperties != null)
                _lrrLookUpProperties.Clear();
            if (_lrrPropertyTypes != null)
                _lrrPropertyTypes.Clear();
            if (_levels != null)
                _levels.Clear();
             

            
            _lrrSiteComponents = null;
            _siteComponents = null;
            _siteCompProperties = null;
            _siteCompAdditionalinfos = null;
            _siteCompPropsUserAndTimes = null;
            _siteComponentPropertyValues = null;
            _siteComponentPropertyOriginalValues = null;
            _lrrLookUpProperties = null;
            _lrrPropertyTypes = null;
            _levels = null;
            _lrrHistdata = null;
            _level = null;
            _lrrAggregates = null;

            _siteCompGroupedProperties = null;
            _siteGroupPropertyQualifierValues = null;
            formulasToCommit = null;
             

            //_app = null;
            

            lrrFormulaSiteComponents = null;
            lrrMasterPropertyDirections = null;

            //oForAlerts = null;

            //_parentTabControl = null;

            //_parentTabPage = null;


            GC.Collect();
        }
		#endregion

		#region Event Handlers

		/// <summary>
		/// Event Handler for the Combo box of the Site Component Pointer to
		/// the Master Component Table for the Property changes..
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void gridSiteComponents_CurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs e)
		{
            
            
            
                
			/*GridCurrentCell cc;

			cc = this.gridSiteComponents.CurrentCell;

			int rowIndex = cc.RowIndex;
			int colIndex = cc.ColIndex;

			string oldValue = "";
			string newValue = "";

			if(cc.ColIndex == 3)
			{
				newValue = cc.Renderer.GetCellValue().ToString();
				if(this.gridSiteComponents[cc.RowIndex,cc.ColIndex].CellValue == null)
				{
					oldValue = "";
				}
				else
				{
					oldValue = this.gridSiteComponents[cc.RowIndex,cc.ColIndex].CellValue.ToString();
				}
				if(oldValue != newValue)
				{
					if(MessageBox.Show(this,"On Changing this value you will loose the properties for this equipment.Do you wish to continue?","Loss of properties",MessageBoxButtons.YesNo,MessageBoxIcon.Error) == DialogResult.No)
					{
						cc.ResetCurrentCellWithoutDeactivate();
						cc.Activate(rowIndex,colIndex);
					}
					else
					{
						//Value is forced to change so call the Refresh 
						cc.Activate(rowIndex,colIndex);

						//Resets the Data Source as the mastercompoent ID has changed...
						ResetDataSourceForPropGrid(newValue);
					}
				}
			}*/

		}

		#endregion

		#region Private Methods

		/// <summary>
		/// This Method initializes the data source.
		/// It should be used as reference for coding the initialization
		/// of data source in all the other forms.
		/// 1. Get the referenced table using the type of the items in the collection.
		/// 2. Initialize the properties holding the child tables using reflection.
		/// </summary>
		public void InitDataSource()
		{
//			if(_siteComponents != null)
//				_siteComponents.Clear();
//			if(_siteCompProperties != null)
//				_siteCompProperties.Clear();
			if(_siteCompPropsUserAndTimes != null)
				_siteCompPropsUserAndTimes.Clear();
			if(_siteCompAdditionalinfos != null)
				_siteCompAdditionalinfos.Clear();
			
			/*if(_siteComponentPropertyValues != null)
				_siteComponentPropertyValues.Clear();*/
//			if(_siteCompGroupedProperties != null)
//				_siteCompGroupedProperties.Clear();
			
//			if(_siteGroupPropertyQualifierValues != null)
//				_siteGroupPropertyQualifierValues.Clear();

//			if(_siteCompGroupPropertyValues != null)
//				_siteCompGroupPropertyValues.Clear();

			if(_lrrLookUpProperties != null)
				_lrrLookUpProperties.Clear();
			if(_lrrPropertyTypes!=null)
				_lrrPropertyTypes.Clear();

			//			if(_lrrHistdata != null)
			//				_lrrHistdata.Clear();
			
			if(_levels!= null)
				_levels.Clear(); 
		
			ResetCollectionState(LRRModel.SiteComponentsObj);
			ResetCollectionState(LRRModel.SiteComponentPropertiesObj);
			ResetCollectionState(LRRModel.PropertyValuesObj);
			ResetCollectionState(LRRModel.SiteComponentGroupPropertiesObj);
			ResetCollectionState(LRRModel.HistDatas);
			ResetCollectionState(LRRModel.Model);
			ResetCollectionState(LRRModel.SiteGroupPropertyQualifierValuesObj);

			_siteComponents = LRRModel.SiteComponentsObj;
			_siteCompProperties = LRRModel.SiteComponentPropertiesObj;
			_siteCompPropsUserAndTimes = new LRRSiteComponentPropertyUserAndTimes();
			_app.DBManagerObj.PopulateCollection(_siteCompPropsUserAndTimes,false);
			_siteCompAdditionalinfos = new LRRSiteComponentAdditionalInformations();
			_app.DBManagerObj.PopulateCollection(_siteCompAdditionalinfos,false);
			
			 _lrrAggregates = LRRModel.AggregatesObj;

			_siteComponentPropertyValues = LRRModel.PropertyValuesObj;

			_siteComponentPropertyOriginalValues = _siteComponentPropertyValues;
			_siteCompGroupedProperties = LRRModel.SiteComponentGroupPropertiesObj;//new LRRSiteComponentGroupProperties();
			
			//_siteGroupPropertyQualifierValues = new LRRSiteGroupPropertyQualifierValues();
			_siteGroupPropertyQualifierValues  = LRRModel.SiteGroupPropertyQualifierValuesObj;
			
			//Populate from Model
			_lrrHistdata = LRRModel.HistDatas;

			_lrrLookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(_lrrLookUpProperties,false);
			
			
			_lrrPropertyTypes = new LRRPropertyTypes();
			_app.DBManagerObj.PopulateCollection(_lrrPropertyTypes,false);

			
			
			_levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(_levels,false);  
			
 
			

			LRRMasterComponents masterComponents = LRRModel.Model;
			lrrFormulaSiteComponents.Clear();
			lrrFormulaSiteComponents.Add(0,masterComponents);
			lrrFormulaSiteComponents.Add(1,"MasterComponents");
			lrrFormulaSiteComponents.Add(2,"SiteComponentsObj");
			lrrFormulaSiteComponents.Add(3,"Properties");
			
			//Added for showing Group Properties and DataArrays
			lrrFormulaSiteComponents.Add(4,"GroupPpties");
			lrrFormulaSiteComponents.Add(5,"GroupPptiesQualifierValues");
			lrrFormulaSiteComponents.Add(6,LRRModel.LookUpQualifiers);
			lrrFormulaSiteComponents.Add(7,_lrrAggregates);
			LRRFormulaDataStore.ShowGroupedAttributes = true;
			LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteComponentPropertyValue).ToString();

			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
			LRRFormulaDataStore.ModeFlag = true;
			
			_siteComponentPropertyValues.SortColumn = "ModeID";
			_siteComponentPropertyValues.Sort();
	


			_siteCompProperties.ItemAdded+=new EventHandler(_siteCompProperties_ItemAdded);
		
		}

        private void ResetCollectionState(CustomCollection customCollection)
		{
			foreach(BaseObject obj in customCollection.DeletedItems)
			{
				obj.ResetObjectState();
				customCollection.Add(obj);
			}
			customCollection.DeletedItems.Clear();
		}

        private void PopulatePlantItemsForRebuildWaterModel()
        {
            _arrPlantItemsForRebuildWaterModel.Clear();
            _arrPlantItemsForRebuildWaterModel.Add("13");
            _arrPlantItemsForRebuildWaterModel.Add("57");
            _arrPlantItemsForRebuildWaterModel.Add("111");
            _arrPlantItemsForRebuildWaterModel.Add("112");
            _arrPlantItemsForRebuildWaterModel2.Clear();
            foreach (LRRSiteComponent comp in _siteComponents)
            {
                if (_arrPlantItemsForRebuildWaterModel.Contains(comp.GetMasterComponentID()))
                {
                    _arrPlantItemsForRebuildWaterModel2.Add(comp.GetID());
                }
            }
        }

		public void InitDataSource(string sSiteCompID)
		{
			
			_called = true;
			_siteCompontId = sSiteCompID;

			if(_siteCompPropsUserAndTimes != null)
				_siteCompPropsUserAndTimes.Clear();
			if(_siteCompAdditionalinfos != null)
				_siteCompAdditionalinfos.Clear();

			if(_lrrLookUpProperties != null)
				_lrrLookUpProperties.Clear();
			if(_levels!= null)
				_levels.Clear(); 

			if(_lrrPropertyTypes!=null)
				_lrrPropertyTypes.Clear();


			ResetCollectionState(LRRModel.SiteComponentsObj);
			ResetCollectionState(LRRModel.SiteComponentPropertiesObj);
			ResetCollectionState(LRRModel.PropertyValuesObj);
			ResetCollectionState(LRRModel.SiteComponentGroupPropertiesObj);
			ResetCollectionState(LRRModel.HistDatas);
			ResetCollectionState(LRRModel.Model);
			ResetCollectionState(LRRModel.SiteGroupPropertyQualifierValuesObj);

			LRRSiteComponent _siteComponent = LRRModel.SiteComponentsObj.GetSiteComponentByID(sSiteCompID);
			if(!_siteComponents.Contains(_siteComponent))
				_siteComponents.Add(_siteComponent);
			_siteCompProperties = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(sSiteCompID);// new LRRSiteComponentProperties();
			_siteCompPropsUserAndTimes = new LRRSiteComponentPropertyUserAndTimes();
			_app.DBManagerObj.PopulateCollection(_siteCompPropsUserAndTimes," where ComponentID = '"+ sSiteCompID + "' ",false);
			_siteCompAdditionalinfos = new LRRSiteComponentAdditionalInformations();
			_app.DBManagerObj.PopulateCollection(_siteCompAdditionalinfos," where ComponentID = '"+ sSiteCompID + "' ",false);
			
			_siteComponentPropertyValues = LRRModel.PropertyValuesObj;

			_siteComponentPropertyOriginalValues = _siteComponentPropertyValues;
			
			_siteCompGroupedProperties = LRRModel.SiteComponentGroupPropertiesObj;//new LRRSiteComponentGroupProperties();
			
			
			//_siteGroupPropertyQualifierValues = new LRRSiteGroupPropertyQualifierValues();
			_siteGroupPropertyQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj;
			
			_lrrLookUpProperties = new LRRLookUpProperties();
			_app.DBManagerObj.PopulateCollection(_lrrLookUpProperties,false);
			

			_lrrPropertyTypes = new LRRPropertyTypes();
			_app.DBManagerObj.PopulateCollection(_lrrPropertyTypes,false);

			_levels = new LRRLevels();
			_app.DBManagerObj.PopulateCollection(_levels,false);  
			
			//Populate from Model
			_lrrHistdata = LRRModel.HistDatas;

			_lrrAggregates = LRRModel.AggregatesObj;

			
			
			

			LRRMasterComponents masterComponents = LRRModel.Model;
			lrrFormulaSiteComponents.Clear();
			lrrFormulaSiteComponents.Add(0,masterComponents);
			lrrFormulaSiteComponents.Add(1,"MasterComponents");
			lrrFormulaSiteComponents.Add(2,"SiteComponentsObj");
			lrrFormulaSiteComponents.Add(3,"Properties");

			lrrFormulaSiteComponents.Add(4,"GroupPpties");
			lrrFormulaSiteComponents.Add(5,"GroupPptiesQualifierValues");
			lrrFormulaSiteComponents.Add(6,LRRModel.LookUpQualifiers);
			lrrFormulaSiteComponents.Add(7,_lrrAggregates);
			LRRFormulaDataStore.ShowGroupedAttributes = true;
			LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteComponentPropertyValue).ToString();

			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
			LRRFormulaDataStore.ModeFlag = true;
			
			_siteComponentPropertyValues.SortColumn = "ModeID";
			_siteComponentPropertyValues.Sort();


			_siteCompProperties.ItemAdded+=new EventHandler(_siteCompProperties_ItemAdded);

		}


		/// <summary>
		/// 1. Initialises the Columns of the Grid using the type of the collection
		/// 2. Sets the Filter to the Grid.
		/// 3. Hooks up to the relative cell helper instance.
		/// </summary>
		private void InitializeGrid()
		{
			//Suspend the Layout of the Grid...
			gridSiteComponent.SuspendLayout();
			
			this.gridSiteComponent.TableDescriptor.RecordFilters.Clear();
			this.gridSiteComponent.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_PLANT_ITEMS") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			gridSiteComponent.TableDescriptor.AllowNew = true;
			gridSiteComponent.TableDescriptor.AllowRemove = true;
			gridSiteComponent.TableDescriptor.AllowEdit = true;
			gridSiteComponent.TableControlCurrentCellCloseDropDown+=new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(gridSiteComponent_TableControlCurrentCellCloseDropDown);
			gridSiteComponent.TableControlCurrentCellShowingDropDown+=new GridTableControlCurrentCellShowingDropDownEventHandler(gridSiteComponent_TableControlCurrentCellShowingDropDown);
			gridSiteComponent.TableDescriptor.Relations.Clear();
			gridSiteComponent.Engine.SourceListSet.Clear();

            Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
            Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_siteComponents.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,_siteComponents.ItemType,null,fkData);

			//Add the parent table for the Relations...
			gridSiteComponent.Engine.SourceListSet.Add("ParentTable",_siteComponents);
			
			//Set the data source for the grid
			
			gridSiteComponent.DataSource = null;
			gridSiteComponent.DataSource = _siteComponents;

			//Properties for the site component
			GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
			grdCompProps.ChildTableName = "Properties";
			grdCompProps.RelationKeys.Add("SiteComponentID","ComponentID");
			grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.DarkGoldenrod;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");
			gridSiteComponent.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
			grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			gridSiteComponent.TableDescriptor.Relations.Add(grdCompProps);
			//gridSiteComponent.NestedTableGroupOptions.CaptionText = "Properties : {RecordCount} Items";
			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			//gridSiteComponent.Appearance.NestedTableRowHeaderCell.BackColor = Color.Red;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			gridSiteComponent.Engine.SourceListSet.Add("Properties",_siteCompProperties);

			//			


			// registration for Tree Control for Plant levels....
            if(!gridSiteComponent.TableModel.CellModels.ContainsKey("DropDownTree"))
            {
			    gridSiteComponent.TableModel.CellModels.Add("DropDownTree",new PlantLevelUserFormTreeControl(this.gridSiteComponent.TableModel,new PlantLevelTreeControlStructure()));         
            }
			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grdCompProps.ChildTableDescriptor,_siteCompProperties.ItemType,null);
			gridSiteComponent.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridSiteComponent_QueryCellStyleInfo);  
			grdCompProps.ChildTableDescriptor.RecordExpanding+=new RecordEventHandler(ChildTableDescriptor_RecordExpanding);
			grdCompProps.ChildTableDescriptor.RecordCollapsing+=new RecordEventHandler(ChildTableDescriptor_RecordCollapsing);
			

			
			grdCompProps.ChildTableDescriptor.Columns["UOM"].AllowFilter = false;
//			grdCompProps.ChildTableDescriptor.Columns["ModelUOM"].AllowFilter = false;
			grdCompProps.ChildTableDescriptor.Columns["HistTagID"].AllowFilter = false;
			grdCompProps.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";
//			grdCompProps.ChildTableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell.CellType = "GridListControl";

			GridTableCellStyleInfo gtc1 = grdCompProps.ChildTableDescriptor.Columns["UOM"].Appearance.AnyRecordFieldCell;
			gtc1.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;					
			gtc1.ExclusiveChoiceList = false;
			
			
			GridTableCellStyleInfo gtc = grdCompProps.ChildTableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell;
			gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			gtc.DataSource = _lrrHistdata; 
			gtc.ValueMember	= "HistTagUID";
			gtc.DisplayMember =	"HistTag";
		
			//***************************************************************************************

			//Properties for the site component
			//			GridRelationDescriptor grdCompPropsOverrides = new GridRelationDescriptor("PropertyOverrides");
			//			grdCompPropsOverrides.ChildTableName = "PropertyOverrides";
			//			grdCompPropsOverrides.RelationKeys.Add("ID","SiteComponentPropID");
			//			grdCompPropsOverrides.RelationKind = RelationKind.RelatedMasterDetails;
			//			grdCompPropsOverrides.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Red;
			//			grdCompPropsOverrides.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			//			grdCompPropsOverrides.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Overrides: {RecordCount} Items";
			//			grdCompPropsOverrides.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			//			grdCompProps.ChildTableDescriptor.Relations.Add(grdCompPropsOverrides);
			//			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Properties",_siteCompProperties);
			//			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("PropertyOverrides",_siteCompPropsUserAndTimes); 
			//			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			//			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			//			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			//			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grdCompPropsOverrides.ChildTableDescriptor,_siteCompPropsUserAndTimes.ItemType,null);
			
			//***************************************************************************************

			
			//Property Values for the property
			GridRelationDescriptor grdCompPropValues = new GridRelationDescriptor("PropertyValues");
			grdCompPropValues.ChildTableName = "PropertyValues";
			grdCompPropValues.RelationKeys.Add("ID","SiteComponentPropertyID");
			grdCompPropValues.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.OrangeRed;
			grdCompPropValues.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompPropValues.ChildTableDescriptor.AllowEdit = true;//false;
			grdCompPropValues.ChildTableDescriptor.AllowRemove = false;
			grdCompPropValues.ChildTableDescriptor.AllowNew = false;
			grdCompPropValues.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_VALUES")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");
			grdCompPropValues.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			grdCompProps.ChildTableDescriptor.Relations.Add(grdCompPropValues);
			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Properties",_siteCompProperties);
			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("PropertyValues",_siteComponentPropertyValues); 
			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			grdCompPropValues.ChildTableDescriptor.TopLevelGroupOptions.ShowFilterBar = false;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grdCompPropValues.ChildTableDescriptor,_siteComponentPropertyValues.ItemType,null);
			grdCompPropValues.ChildTableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			grdCompPropValues.ChildTableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

			GridTableCellStyleInfo gtc2 = grdCompPropValues.ChildTableDescriptor.Columns["ModelUOM"].Appearance.AnyRecordFieldCell;
			gtc2.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;					
			gtc2.ExclusiveChoiceList = false;

			//			LRREVVs evvs = LRRModel.ChildModel.EVVs.Clone() as LRREVVs;
			//			GridTableCellStyleInfo gts = grdCompPropValues.ChildTableDescriptor.Columns["PropertyValue"].Appearance.GetStyle(GridTableCellType.AnyRecordFieldCell);
			//			gts.CellType = "ComboBox";
			//			gts.DataSource = evvs;
			//			gts.ValueMember = "EVV";
			//			gts.DisplayMember = "EVV";
			grdCompPropValues.ChildTableDescriptor.GroupExpanding+=new GroupEventHandler(ChildTableDescriptor_GroupExpanding);
			//***************************************************************************************

			//Properties for the site component
			//			GridRelationDescriptor grdCompPropsOverrides = new GridRelationDescriptor("GroupedProperties");
			//			grdCompPropsOverrides.ChildTableName = "GroupedProperties";
			//			grdCompPropsOverrides.RelationKeys.Add("ID","SiteComponentPropID");
			//			grdCompPropsOverrides.RelationKind = RelationKind.RelatedMasterDetails;
			//			grdCompPropsOverrides.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Red;
			//			grdCompPropsOverrides.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			//			grdCompPropsOverrides.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Grouped Properties: {RecordCount} Items";
			//			grdCompPropsOverrides.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			//			grdCompProps.ChildTableDescriptor.Relations.Add(grdCompPropsOverrides);
			//			//grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("Properties",_siteCompProperties);
			//			grdCompProps.ChildTableDescriptor.Engine.SourceListSet.Add("GroupedProperties",_siteCompGroupedProperties); 
			//			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			//			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			//			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			//			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grdCompPropsOverrides.ChildTableDescriptor,_siteCompGroupedProperties.ItemType,null);
			//			grdCompPropsOverrides.ChildTableDescriptor.GroupExpanding+=new GroupEventHandler(ChildTableDescriptor_GroupExpanding);
			//			
			//			//***************************************************************************************
			//
			//			//Property Values for the Grouped Property
			//			GridRelationDescriptor grdCompPropGrpValues = new GridRelationDescriptor("GroupPropertyValues");
			//			grdCompPropGrpValues.ChildTableName = "GroupPropertyValues";
			//			grdCompPropGrpValues.RelationKeys.Add("SiteComponentPropID","SiteComponentPropertyID");
			//			grdCompPropGrpValues.RelationKind = RelationKind.RelatedMasterDetails;
			//			grdCompPropGrpValues.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.OrangeRed;
			//			grdCompPropGrpValues.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			//			grdCompPropGrpValues.ChildTableDescriptor.AllowEdit = false;
			//			grdCompPropGrpValues.ChildTableDescriptor.AllowRemove = false;
			//			grdCompPropGrpValues.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = "Values: {RecordCount} Items";
			//			grdCompPropGrpValues.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LightYellow;
			//			grdCompPropsOverrides.ChildTableDescriptor.Relations.Add(grdCompPropGrpValues);
			////			grdCompPropsOverrides.ChildTableDescriptor.Engine.SourceListSet.Add("Properties",_siteCompProperties);
			//			grdCompPropsOverrides.ChildTableDescriptor.Engine.SourceListSet.Add("GroupPropertyValues",_siteCompGroupPropertyValues); 
			//			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			//			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			//			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
			//			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grdCompPropGrpValues.ChildTableDescriptor,_siteCompGroupPropertyValues.ItemType,null);
			//			grdCompPropGrpValues.ChildTableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
			//			gridContext.MenuItems.Add(new MenuItem("ViewOverridable",new EventHandler(Override)));



			//***************************************************************************************


			

			//****************************************************************
			//Additional Information for the Site Component
			GridRelationDescriptor grd = new GridRelationDescriptor("AddInfos");
			grd.ChildTableName = "AdditionalInfos";
			grd.RelationKeys.Add("SiteComponentID","ComponentID");
			grd.RelationKind = RelationKind.RelatedMasterDetails;
			grd.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Maroon;
			grd.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grd.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ADDITIONAL_INFO")+" {RecordCount} "+LRRHeaderText.GetHeaderString("SID_ITEMS");
			grd.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.BackColor = Color.LavenderBlush;
			gridSiteComponent.TableDescriptor.Relations.Add(grd);
			gridSiteComponent.NestedTableGroupOptions.ShowFilterBar = true;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridSiteComponent.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = true;
			gridSiteComponent.Engine.SourceListSet.Add("AdditionalInfos",_siteCompAdditionalinfos);
			SyncGridUtilities.InitializeGridColumns(gridSiteComponent,grd.ChildTableDescriptor,_siteCompAdditionalinfos.ItemType,null);
			
			
			//***************************************************************************************

			
			//Resume the Layout of the Grid...
			gridSiteComponent.ResumeLayout(true);

			string[,] arry=new string[,]{{"Description","255"},{"Comments","255"}};
			Validations	objValidations=new Validations(gridSiteComponent,arry);
//menuoverrideformula_Click
//			gridContext.Popup +=new EventHandler(gridContext_Popup);
		}
		
		/// <summary>
		/// This method sets the data source for the property grid on the form..
		/// </summary>
		/// <summary>
		/// This method sets the data source for the property grid on the form..
		/// Deprecated...
		/// </summary>
		private void SetDataSourceForAdditionalInfo()
		{
			//gridAdditionalInfo.BeginUpdateModel(Syncfusion.Windows.Forms.BeginUpdateOptions.None,true);
            
			if(_siteComponents != null)
			{
				CurrencyManager cm = (CurrencyManager)gridSiteComponent.BindingContext[this.gridSiteComponent.DataSource];

				LRRSiteComponent sc = (LRRSiteComponent)cm.Current;

				if(sc != null)
				{
					object obj = sc.AdditionaInfo;
					if(obj != null)
					{
						//						gridAdditionalInfo.Binder.SetDataBinding(obj,"");
						//SyncGridUtilities.SetFilterHeader(gridAdditionalInfo);
					}
				}
			}

			//gridAdditionalInfo.EndUpdateModel(false,true);
		}



		private void EquipmentEntry_Load(object sender, System.EventArgs e)
		{
			//Standard Method to initialize the grid component
			
			
			initializing = true;
			gridSiteComponent.RecordDeleting+=new RecordEventHandler(gridSiteComponent_RecordDeleting);
			_gridExcelFormatter.WireGrid(gridSiteComponent);
			//gridSiteCompProperties.RecordDeleting+=new RecordEventHandler(gridSiteComponent_RecordDeleting);
			//gridSiteComponent.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridSiteComponent_QueryCellStyleInfo);  
			

		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private LRRSiteComponentProperty ConverMaterPropToSiteCompProp(LRRMasterProperty lmpObj)
		{
			LRRSiteComponentProperty lscp = new LRRSiteComponentProperty();
			lscp.ComponentID = lmpObj.ComponentID;
			lscp.Name = lmpObj.Name;
			lscp.Description = lmpObj.Description;
			lscp.UOMTypeID = lmpObj.MasterPropertyUOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));

			//Get the Current Measurement System Model UOM Set
			LRRMeasurementSystem lrrMeas = LRRModel.MeasurementSystems.GetCurrentModelUOM();
			string modelLocaleID = lrrMeas.ID;
			lscp.UOM = _lrrMSD.GetLocaleUOM(modelLocaleID,lscp.UOMTypeID);
			//lscp.Derivation = lmpObj.Derivation;
			//lscp.Direction = lmpObj.Direction;
			if (lrrMasterPropertyDirections.Contains(lmpObj.PropID) == false)
			{
				if(lmpObj.Direction == null)
					lrrMasterPropertyDirections.Add(lmpObj.PropID,"");
				else
					lrrMasterPropertyDirections.Add(lmpObj.PropID,lmpObj.Direction);
			}
			lscp.Type = lmpObj.Type;
			lscp.ModeID = lmpObj.ModeID;
			lscp.PropertyID = lmpObj.PropID;
			
			//Create Property Values if the Type = "1"
			/*string sType = lscp.Type == null? "" : lscp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(sType == "1")
				CreatePropertyValues(lscp.ModeID,lscp.ID);*/
			
			return lscp;
		}

		//Create SiteComponentGroupProperties and SiteComponentGroupPropertyQualifierValues for siteComponentProperties 
		public void ConvertMasterGrpPropertiesToSiteGroupProperties(LRRSiteComponentProperty lscp,bool isCommitChanges)
		{	
			ArrayList CreatedGroupProperties = new ArrayList();
			ArrayList CreatedGroupQualifiersValues = new ArrayList();
			LRRModel.CreateGroupedProperties(lscp,out CreatedGroupProperties,out CreatedGroupQualifiersValues);
			for(int i=0;i<CreatedGroupProperties.Count;i++)
			{
				LRRSiteComponentGroupProperty lsgp = CreatedGroupProperties[i] as LRRSiteComponentGroupProperty;
				//LRRModel.SiteComponentGroupPropertiesObj.Add(lsgp);
				_siteCompGroupedProperties.Add(lsgp);  
			}
			for(int i=0;i<CreatedGroupQualifiersValues.Count;i++)
			{
				LRRSiteGroupPropertyQualifierValue lsgpqv = CreatedGroupQualifiersValues[i] as LRRSiteGroupPropertyQualifierValue;
				//LRRModel.SiteGroupPropertyQualifierValuesObj.Add(lsgpqv);
				_siteGroupPropertyQualifierValues.Add(lsgpqv); 
			}
            if (isCommitChanges)
            {
                _app.DBManagerObj.CommitCollection(_siteGroupPropertyQualifierValues);
                _app.DBManagerObj.CommitCollection(_siteCompGroupedProperties);
                _siteGroupPropertyQualifierValues.RefreshCollection();
                _siteCompGroupedProperties.RefreshCollection();
            }
			
		}
		#region Commented ConverMaterGrpPropToSiteCompGrpProp
		/*
		public LRRSiteComponentGroupProperty ConverMaterGrpPropToSiteCompGrpProp(LRRGroupProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string sPropID)
		{
			LRRSiteComponentGroupProperty lscp = new LRRSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.AttributeName;
			lscp.AttributeDescription = lmgp.AttributeDescription;
			lscp.UOMTypeID = lmgp.MasterPropertyUOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = lmgp.ModeID;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			lscp.MasterPropID =lmgp.MasterPropertyID;
			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						QualifierPropertyValue.ModeID = objMode.ModeId;
						QualifierPropertyValue.SiteComponentPropID = sPropID;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
						string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if((sDirection == "Input/Output") || (sDirection == "3"))
						{
							if(objMode.ModeId == "1")
								sDirection = "1";
						}
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = lmgp.Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
						//LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
						lscp.GroupPptiesQualifierValues.Add(QualifierPropertyValue);
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					QualifierPropertyValue.ModeID = "0";
					QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
					QualifierPropertyValue.SiteComponentPropID = sPropID;
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = lmgp.Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					//LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
					lscp.GroupPptiesQualifierValues.Add(QualifierPropertyValue);
				}

			}
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}
		*/
		#endregion

		#region Commented  ConverLookupPropToSiteCompGrpProp

		/*
		public LRRSiteComponentGroupProperty ConverLookupPropToSiteCompGrpProp(LRRLookUpProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string sPropID)
		{
			LRRSiteComponentGroupProperty lscp = new LRRSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.Name;
			lscp.AttributeDescription = lmgp.Description;
			//lscp.UOMTypeID = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID). UOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = blnModeFlag;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			
			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
							
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						
						QualifierPropertyValue.ModeID = objMode.ModeId;
						QualifierPropertyValue.SiteComponentPropID = sPropID;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						
						string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
						lscp.GroupPptiesQualifierValues.Add(QualifierPropertyValue);
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
					
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					QualifierPropertyValue.SiteComponentPropID = sPropID;
					
					QualifierPropertyValue.ModeID = "0";
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					lscp.GroupPptiesQualifierValues.Add(QualifierPropertyValue);
					
				}

			}
			
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}
		*/
		#endregion

		#region Commented ConverMaterGrpPropToSiteCompGrpPropForDataArrays
		/*
		public LRRSiteComponentGroupProperty ConverMaterGrpPropToSiteCompGrpPropForDataArrays(LRRGroupProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string siteCompPropID)
		{
			LRRSiteComponentGroupProperty lscp = new LRRSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.AttributeName;
			lscp.AttributeDescription = lmgp.AttributeDescription;
			lscp.UOMTypeID = lmgp.MasterPropertyUOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = lmgp.ModeID;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			lscp.MasterPropID =lmgp.MasterPropertyID;
//			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
//			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						QualifierPropertyValue.ModeID = objMode.ModeId;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
						QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
						string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						if((sDirection == "Input/Output") || (sDirection == "3"))
						{
							if(objMode.ModeId == "1")
								sDirection = "1";
						}
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = lmgp.Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
						//LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
						
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					QualifierPropertyValue.ModeID = "0";
					QualifierPropertyValue.MasterPropID	=lmgp.MasterPropertyID;
					QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = lmgp.Direction == null ? "" : lmgp.Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = lmgp.Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					//LRRModel.SiteGroupPropertyQualifierValuesObj.Add(QualifierPropertyValue);      
				}

//			}
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}
		*/
		#endregion

		#region Commented ConverLookupPropToSiteCompGrpPropForDataArrays
		/*
		public LRRSiteComponentGroupProperty ConverLookupPropToSiteCompGrpPropForDataArrays(LRRLookUpProperty lmgp,LRRLookUpQualifiers objQualifiersForGrpType,bool blnModeFlag,string siteCompPropID)
		{
			LRRSiteComponentGroupProperty lscp = new LRRSiteComponentGroupProperty();
			lscp.AttributeName = lmgp.Name;
			lscp.AttributeDescription = lmgp.Description;
			//lscp.UOMTypeID = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID). UOMTypeID;
			LRRMeasurementSystemDefinitions _lrrMSD = (LRRMeasurementSystemDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRMeasurementSystemDefinitions));
			lscp.ModeID = blnModeFlag;
			lscp.PropertyID = lmgp.PropertyID;
			lscp.LookUpPropertiesID = lmgp.LookUpPropertiesID;
			
//			foreach(LRRLookUpQualifier objQualifierForGrpType in objQualifiersForGrpType)
//			{
				//--To change once the modes are picked from mode set defined for the project
				if(blnModeFlag)
				{
					for(int i=0;i < LRRModel.ProjectModes.Count;i++)
					{
						LRRMode objMode = LRRModel.ProjectModes[i] as LRRMode;
						//_siteGroupPropertyQualifierValues
						LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
							
						QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//						QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//						QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
						QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
						QualifierPropertyValue.PropertyID = lscp.PropertyID;
						
						QualifierPropertyValue.ModeID = objMode.ModeId;
						QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
						//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
						
						string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						QualifierPropertyValue.Direction=sDirection ;
						QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

						//Add Cascading logic here
						_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
						lscp.GroupPptiesQualifierValues.Add(QualifierPropertyValue);
					}
				}
				else
				{
					//_siteGroupPropertyQualifierValues
					LRRSiteGroupPropertyQualifierValue QualifierPropertyValue = new LRRSiteGroupPropertyQualifierValue();
					
					QualifierPropertyValue.GroupPropertyID = lscp.GroupPropertyID;
//					QualifierPropertyValue.LookUpQualifierID = objQualifierForGrpType.LookUpQualifierID;
//					QualifierPropertyValue.QualifierID = objQualifierForGrpType.QualifierID;
					QualifierPropertyValue.LookUpPropertiesID = lscp.LookUpPropertiesID;
					QualifierPropertyValue.PropertyID = lscp.PropertyID;
					
					QualifierPropertyValue.ModeID = "0";
					QualifierPropertyValue.SiteComponentPropID = siteCompPropID;
					//QualifierPropertyValue.SiteGroupPropertyQualifierID= lscgpq.SiteGroupPropertyQualifierID;
					string sDirection = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction == null ? "" : _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Direction.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					QualifierPropertyValue.Direction=sDirection ;
					QualifierPropertyValue.Derivation = _lrrPropertyTypes.getPropertyTypeForID(lmgp.PropertyID).Derivation;

					//Add Cascading logic here
					_siteGroupPropertyQualifierValues.Add(QualifierPropertyValue);
					lscp.GroupPptiesQualifierValues.Add(QualifierPropertyValue);
				}

//			}
			
			//lscp.GroupPptiesQualifiers.Add(lscgpqs);
			return lscp;
		}
			*/
		#endregion

		#endregion

		/// <summary>
		/// Event Handler for the XP Style Menu click...
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void bar_Click(object sender, EventArgs e)
		{
			BarItem item = sender as BarItem;
			if(item.ID == "MP")
			{
				LRRSiteComponent sc = (LRRSiteComponent)gridSiteComponent.CurrencyManager.Current;
				LRRMasterProperties lmps = new LRRMasterProperties();
				if(sc != null)
				{
					if(sc.MasterComponentType != null)
					{
						if(!sc.MasterComponentType.Trim().Equals(""))
						{
							//lmps = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByType(sc.MasterComponentType);
							_app.DBManagerObj.PopulateCollection(lmps," WHERE ComponentTypeID ='" + sc.MasterComponentType + "'" + " AND PropertyID NOT IN(SELECT PropertyID FROM SiteComponentProperties WHERE ComponentID = '" + sc.MasterComponentType + "')");
						}
						
					}
				}

				AddMasterProperties amp = new AddMasterProperties(lmps,sc.SiteComponentID);
				amp.ShowDialog(this);

				foreach(LRRMasterProperty lmp in lmps)
				{
					BaseObject bo = lmp as BaseObject;
					if(bo.IsSelected == true)
					{
						sc.Properties.Add(ConverMaterPropToSiteCompProp(lmp));
					}
				}

			}
			else
			{
				LRRSiteComponent lsc = gridSiteComponent.CurrencyManager.Current as LRRSiteComponent; 
				//LRRSiteComponentProperty lscp = gridSiteCompProperties.CurrencyManager.Current as LRRSiteComponentProperty;
				//FormulaWindow fw = new FormulaWindow(/*_siteComponents,lscp.ID*/);
				//fw.ShowDialog(this);
			}
		}

		private void EquipmentEntry_Closed(object sender, System.EventArgs e)
		{
			_gridExcelFormatter.UnwireGrid();
		}

		//Call the save Method
		private void barSave_Click(object sender, EventArgs e)
		{
			Save();
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true; 
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridSiteComponent_RecordDeleting(object sender, RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				while(gridSiteComponent.TableControl.Updating)    
					gridSiteComponent.TableControl.CancelUpdate();
				DialogResult _dlgResult = LRRMessagBox.ShowMessage(this,"SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				
				if(_dlgResult == DialogResult.Yes)
				{
					if(e.Record.GetData().GetType() == typeof(LRRSiteComponentProperty))
					{
                        string error = string.Empty;
                        bool checkForDelete = CheckForDelete(ref error);
                        if (!checkForDelete)
                        {
                            //							MessageBox.Show("Mapping Exists Cannot Delete Property");
                            //LRRMessagBox.ShowMessage("SID_AGG_PROP_EXIST", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            MessageBox.Show(this, "Mapping Exists Cannot Delete selected attribute." + "\n\nDetails: " + '\n' + error + "\nCheck Log for further reference.", "PE-Advisor", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            e.Cancel = true;
                            _isDeletePress = false;
                            _isRecordeDel = false;
                            return;
                        }
                        else
                        {
                            //string aggerror = string.Empty;
                            bool checkForAggPropBeforDelete = IsAggregatePropExists(ref error);
                            if (checkForAggPropBeforDelete)
                            {
                                //LRRMessagBox.ShowMessage("The selected attribute is a part of existing aggregate(s)." + '\n' + "Details: " + '\n' + error, "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                MessageBox.Show(this, "The selected attribute is a part of existing aggregate(s)." + '\n' + "Details: " + '\n' + error + "\nCheck Log for further reference.", "PE-Advisor", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                e.Cancel = true;
                                _isDeletePress = false;
                                _isRecordeDel = false;
                                return;
                            }
                        }
					}
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				if(e.Record.GetData().GetType() == typeof(LRRSiteComponent))
				{
					LRRSiteComponent lrrSiteComponent = e.Record.GetData() as LRRSiteComponent;
					LRRSiteComponentProperties siteCompProperties = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(lrrSiteComponent.SiteComponentID);
                    ArrayList arlist = new ArrayList();
					foreach(LRRSiteComponentProperty siteCompProperty in siteCompProperties)
					{
						
						//Check for Simple Property
						if(siteCompProperty.Type == "1")
						{
							arlist.AddRange(LRRModel.CheckForSimplePropertyMapping(siteCompProperty));
						}
						else
						{
							arlist = LRRModel.CheckForMapping(siteCompProperty);
						}
						
					}
                    if (arlist != null && arlist.Count > 0)
                    {

                        LRRHistPropCompPropMapping histPropCompPropMap;
                        string error = string.Empty;
                        for (int i = 0; i < arlist.Count; i++)
                        {
                            histPropCompPropMap = arlist[i] as LRRHistPropCompPropMapping;
                            error += histPropCompPropMap.ComponentPropertyName + " Mapped With HistTag " + histPropCompPropMap.HistTag + '\n';
                            Logger.LogMessage(histPropCompPropMap.ComponentPropertyName + "  Mapped With HistTag  " + histPropCompPropMap.HistTag, Logger.Level.Error);
                        }
                        //LRRMessagBox.ShowMessage("SID_COMP_MAPPING_EXISTS", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        MessageBox.Show(this, "Mapping Exists Cannot Delete SiteComponent" + "\n\nDetails: " + '\n' + error + "\nCheck Log for further reference.", "PE-Advisor", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        //							MessageBox.Show("Mapping Exists Cannot Delete SiteComponent");
                        e.Cancel = true;
                        return;
                    }
					NestedTable nt = e.Record.NestedTables["Properties"];
					for(int i=nt.ChildTable.Records.Count - 1;i>=0;i--)
					{
				
						NestedTable propValuesTable = nt.ChildTable.Records[i].NestedTables["PropertyValues"];
						for(int k= propValuesTable.ChildTable.Records.Count -1;k>=0;k--)
						{
							object propValObj = propValuesTable.ChildTable.Records[k].GetData();
							_siteComponentPropertyValues.Remove(propValObj);
						}
						object obj = nt.ChildTable.Records[i].GetData();
						_siteCompProperties.Remove(obj);
					}
				}
				else if(e.Record.GetData().GetType() == typeof(LRRSiteComponentProperty))
				{
	
					LRRSiteComponentProperty lscp =  e.Record.GetData() as LRRSiteComponentProperty;
					if(lscp != null)
					{
						LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(lscp.ComponentID);
						if(lsc != null)
						{
							lsc.Properties.Remove(lscp);
						}
					}
					NestedTable propValuesTable = e.Record.NestedTables["PropertyValues"];
					for(int j= propValuesTable.ChildTable.Records.Count -1;j>=0;j--)
					{
						object propValObj = propValuesTable.ChildTable.Records[j].GetData();
						_siteComponentPropertyValues.Remove(propValObj);
					}
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}

		}

		private bool CheckForDelete(ref string  error)
		{
			Element eCurrentInnerElement = gridSiteComponent.Table.GetInnerMostCurrentElement();
			GridTable gt = eCurrentInnerElement.ParentTable as GridTable;
						
			LRRSiteComponentProperties siteCompProperties = new LRRSiteComponentProperties();
			if(gt != null)
			{
				GridRangeInfoList ranges = gt.TableModel.SelectedRanges;
				if(ranges.Count > 0)
				{
					for(int i=0; i < ranges.Count;i ++)
					{
						GridRangeInfo range = ranges[i];
						int top = range.Top;
						int bottom = range.Bottom;

						for(int row = top; row <= bottom; row++)
						{
							try
							{
								LRRSiteComponentProperty siteCompPropObj = gt.TableModel.GetDisplayElementAt(row).GetData() as LRRSiteComponentProperty;
								if(siteCompPropObj != null)
									siteCompProperties.Add(siteCompPropObj); 
							}
							catch(Exception ex)
							{
								Logger.LogMessage(typeof(SiteComponentEntry),"Delete Record :"+ex.Message  ,Logger.Level.Debug);
							}
						}
					}
				}
			}

			foreach(LRRSiteComponentProperty siteCompProp in siteCompProperties)
			{
				ArrayList arlist = null;
				//Check for Simple Property
				if(siteCompProp.Type == "1")
				{
					arlist = LRRModel.CheckForSimplePropertyMapping(siteCompProp);
				}
				else
				{
					arlist = LRRModel.CheckForMapping(siteCompProp);
				}
				if(arlist != null && arlist.Count > 0)
				{
					for(int i = 0 ;i < arlist.Count;i++)
					{
                        
						LRRHistPropCompPropMapping histPropCompPropMap = arlist[i] as LRRHistPropCompPropMapping;
                        error += histPropCompPropMap.ComponentPropertyName + "  Mapped With HistTag  " + histPropCompPropMap.HistTag + '\n';
                        Logger.LogMessage(histPropCompPropMap.ComponentPropertyName + "  Mapped With HistTag  " + histPropCompPropMap.HistTag, Logger.Level.Error);
					}
					return false;
				}
			}
			return true;
		}

        private bool IsAggregatePropExists(ref string error)
        {
            Element eCurrentInnerElement = gridSiteComponent.Table.GetInnerMostCurrentElement();
			GridTable gt = eCurrentInnerElement.ParentTable as GridTable;
						
			LRRSiteComponentProperties siteCompProperties = new LRRSiteComponentProperties();
			if(gt != null)
			{
				GridRangeInfoList ranges = gt.TableModel.SelectedRanges;
				if(ranges.Count > 0)
				{
					for(int i=0; i < ranges.Count;i ++)
					{
						GridRangeInfo range = ranges[i];
						int top = range.Top;
						int bottom = range.Bottom;

						for(int row = top; row <= bottom; row++)
						{
							try
							{
								LRRSiteComponentProperty siteCompPropObj = gt.TableModel.GetDisplayElementAt(row).GetData() as LRRSiteComponentProperty;
								if(siteCompPropObj != null)
									siteCompProperties.Add(siteCompPropObj); 
							}
							catch(Exception ex)
							{
								Logger.LogMessage(typeof(SiteComponentEntry),"Delete Record :"+ex.Message  ,Logger.Level.Debug);
							}
						}
					}
				}
			}
			foreach(LRRSiteComponentProperty siteCompProp in siteCompProperties)
			{
                LRRAggregateProperties aggregateProps = LRRModel.AggregatePropertiesObj.FilterPropertiesByMasterProperty(siteCompProp.PropertyID);
                if (aggregateProps.Count > 0)
                {
                    error = siteCompProp.Name + "  is a part of aggregate(s)";
                    Logger.LogMessage(error, Logger.Level.Error);
                    return true;
                }
                else
                {
                    return false;
                }
			}
            return true;
        }
		private void barShowProperties_Click(object sender, EventArgs e)
		{
			_ShowGridColumnsDialog(gridSiteComponent.Engine.TableDescriptor,"Columns",null,typeof(GridColumnDescriptorCollection));
		}

		internal DialogResult _ShowGridColumnsDialog(object instance, string propertyName, IServiceProvider provider, Type type)
		{
			GroupingCollectionEditor ce = new GroupingCollectionEditor(type);
			Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer esc = new Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer(provider);
			PropertyDescriptor pd = TypeDescriptor.GetProperties(instance)[propertyName];
			Syncfusion.ComponentModel.TypeDescriptorContext tdc = new Syncfusion.ComponentModel.TypeDescriptorContext(instance, pd);
			tdc.ServiceProvider = esc;

			ce.EditValue(tdc, esc, pd.GetValue(instance));

			return esc.DialogResult;
		}

		/// <summary>
		/// Hook up to the event of the sitecomponet property addition..
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void _siteCompProperties_ItemAdded(object sender, EventArgs e)
		{
			LRRSiteComponentProperty lscp = sender as LRRSiteComponentProperty;
			string sPropertyType = "";
			sPropertyType = lscp.Type == null ? "" : lscp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if((sPropertyType == "1") && (sPropertyType == "2"))
			{
				if(lscp.ModeID ==  true)
				{
					LRRModeSetDefinitions tmpObj = (LRRModeSetDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRModeSetDefinitions));
					foreach(LRRModeSetDefinition lmsd in tmpObj)
					{
						LRRSiteComponentPropertyValue lscpv = new LRRSiteComponentPropertyValue();
						lscpv.ModeID = lmsd.ModeID;
						lscpv.SiteComponentPropertyID = lscp.ID;
						if(lscp.PropertyID != null)
						{
							if(lrrMasterPropertyDirections[lscp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)] != null)
							{
								string sDirection = lrrMasterPropertyDirections[lscp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString();
								lscpv.Direction=sDirection ;
								if((sDirection == "Input/Output") || (sDirection == "3"))
								{
									if(lmsd.ModeID == "1")
										lscpv.Direction = "1";
								}
								//Hook Cascading logic here
							}
						}
						_siteComponentPropertyValues.Add(lscpv);
					}
					gridSiteComponent.Refresh();
					
				}
			}
		}

		private void gridSiteComponent_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
		{
			try
			{
                GridGroupingControl grid = sender as GridGroupingControl;
                GridCurrentCell oCurrCell = grid.TableControl.CurrentCell as GridCurrentCell;
                // GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
                GridTableCellStyleInfoIdentity tableCellInfo = grid.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
                if (tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
                {
                    try
                    {
                        grid.Table.AddNewRecord.SetCurrent();
                        return;
                    }
                    catch
                    { }
                }
				if(gridSiteComponent.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
					Element eCurrentInnerElement = gridSiteComponent.TableControl.Table.GetInnerMostCurrentElement();    
					if(eCurrentElement == null)
						return;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}

					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					tableModel = childTable.ParentTable.TableModel;
					int iRow = e.TableControl.CurrentCell.RowIndex;
					int iCol = e.TableControl.CurrentCell.ColIndex;
					string sColHeader = "";
					if(tableModel.GetColumnDescriptorAt(iRow,iCol) != null)
					{
						sColHeader = tableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
					}

					//--Added the following code by Nidhig on 26th Jan to implement the revised logic of grouped properties
					if(sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_SIMPLEGROUP")) || sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_MODE"))|| sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_UIUOM")))
					{
						if(e.TableControl.CurrentCell.Renderer == null)
							return;
						
						string nVal = e.TableControl.CurrentCell.Renderer.ControlText.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						string nControlVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
						string oldVal = tableModel[iRow,iCol].FormattedText;

						if(nVal == oldVal)
							return;

						string currentSimpleGoruped = "";
						bool currentModeFlag;
						//Gets the current Site Component Property
						LRRSiteComponentProperty objCompProp = e.TableControl.Table.CurrentRecord.GetData() as LRRSiteComponentProperty;
						string sPropID = objCompProp.ID;
						currentSimpleGoruped = objCompProp.Type;
						currentModeFlag = objCompProp.ModeID;
						string masterPropID = objCompProp.PropertyID;
                        //Check for site specific properties...
						//Gets the values in case of simple properties
						LRRSiteComponentPropertyValues objValues = new LRRSiteComponentPropertyValues();
						//Gets the grouped properties
						LRRSiteComponentGroupProperties objGrpProps = _siteCompGroupedProperties.GetSiteCompGroupPropFromSiteCompPropID(sPropID);
						
						ArrayList arrChildRecords = new ArrayList();
						if(e.TableControl.Table.CurrentRecord.Kind != DisplayElementKind.AddNewRecord)
						{
							arrChildRecords = GetChildRecords(e,"PropertyValues");
						}
						for(int i=0;i < arrChildRecords.Count;i++)
						{
							objValues.Add(arrChildRecords[i]);
						}
                        if ((objGrpProps.Count > 0) || (objValues.Count > 0))
                        {
                            if (sColHeader.StartsWith("UI UOM"))
                            {
                                Hashtable propValuesHash = new Hashtable();
                                int modeCount = LRRModel.ProjectModes.Count;
                                List<IPropertyValue> arrPropValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(objCompProp.ID);
                                Hashtable htPropValues = new Hashtable();
                                for (int i = 0; i < arrPropValues.Count; i++)
                                {
                                    LRRSiteComponentPropertyValue scpvalue = arrPropValues[i] as LRRSiteComponentPropertyValue;
                                    htPropValues.Add(scpvalue.ModeID, scpvalue);
                                }
                                for (int j = modeCount; j >= 0; j--)
                                {
                                    LRRSiteComponentPropertyValue propValue = htPropValues[j.ToString(Symcon.BusinessObjects.SymConverter.Culture)] as LRRSiteComponentPropertyValue;//objCompProp.GetValueObjectForPropertyMode(j.ToString(Symcon.BusinessObjects.SymConverter.Culture));  
                                    string oldValueID = objCompProp.UOM;
                                    string newValueID = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
                                    if (propValue != null)
                                    {
                                        string propertyValue = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldValueID, newValueID, propValue.PropertyValue, propValue.LRRDataType);
                                        propValuesHash.Add(propValue, propertyValue);
                                    }
                                }
                                e.TableControl.CurrentCell.ConfirmChanges(true);
                                for (int j = modeCount; j >= 0; j--)
                                {
                                    LRRSiteComponentPropertyValue propValue = htPropValues[j.ToString(Symcon.BusinessObjects.SymConverter.Culture)] as LRRSiteComponentPropertyValue;//objCompProp.GetValueObjectForPropertyMode(j.ToString(Symcon.BusinessObjects.SymConverter.Culture)); 
                                    if (propValue != null && propValuesHash.ContainsKey(propValue))
                                    {
                                        string propertyValue = propValuesHash[propValue] == null ? null : propValuesHash[propValue].ToString();
                                        propValue.PropertyValue = propertyValue;
                                    }
                                }
                                return;
                            }
                            masterPropID = masterPropID == null ? "" : masterPropID;

                            if ((masterPropID != "") && (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_SIMPLEGROUP")) || ((objGrpProps.Count > 0) && (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_MODE"))))))
                            {
                                if (sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_MODE")))
                                    LRRMessagBox.ShowMessage("SID_MODECHANGE_RESTRICTED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                else
                                    LRRMessagBox.ShowMessage("SID_PROPCHANGE_RESTRICTED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                                return;
                            }
                            ArrayList arlist = null;
                            arlist = LRRModel.CheckForSimplePropertyMapping(objCompProp);
                            if (arlist != null && arlist.Count <= 0)
                            {
                                DialogResult k = LRRMessagBox.ShowMessage("SID_LOSE_PROPERTYVALUE", "SID_LABEL", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                                if (k == DialogResult.Yes)
                                {
                                    for (int i = objGrpProps.Count - 1; i >= 0; i--)
                                    {
                                        LRRSiteComponentGroupProperty obj = objGrpProps[i];
                                        foreach (LRRSiteGroupPropertyQualifierValue objGPValue in obj.GroupPptiesQualifierValues)
                                        {
                                            _siteGroupPropertyQualifierValues.Remove(objGPValue);
                                        }
                                        _siteCompGroupedProperties.Remove(obj);
                                    }
                                    foreach (LRRSiteComponentPropertyValue objValue in objValues)
                                    {
                                        _siteComponentPropertyValues.Remove(objValue);
                                    }
                                }
                                else
                                {
                                    e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                                    return;
                                }
                                //Check for "Simple/Grouped" OR "Mode"
                                if (sColHeader == "Simple/Grouped")
                                {
                                    if (nVal == "Simple")
                                    {
                                        CreatePropertyValues(currentModeFlag, sPropID);
                                    }
                                    else
                                    {
                                        LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(nControlVal);
                                        if (propTypeObj != null && propTypeObj.IsDataArray)
                                        {
                                            //Create Grouped Properties for Data Arrays
                                            CreateGroupPropertiesForDataArrays(currentModeFlag, objCompProp, nControlVal);
                                        }
                                        else
                                        {
                                            //Create Grouped Properties
                                            CreateGroupProperties(currentModeFlag, objCompProp, nControlVal);
                                        }
                                    }
                                }
                                else if (sColHeader == "Mode")
                                {
                                    //Creation of the ptroperties on change of mode true/false..
                                    //Creating the Properties on change of simple /grouped

                                    string sType = objCompProp.Type == null ? "" : objCompProp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                                    if (nVal == "True")
                                    {
                                        if (currentSimpleGoruped == "1")
                                        {
                                            CreatePropertyValues(true, sPropID);
                                        }
                                        else
                                        {
                                            LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sType);
                                            if (propTypeObj != null && propTypeObj.IsDataArray)
                                            {
                                                //Create Grouped Properties for Data Arrays
                                                CreateGroupPropertiesForDataArrays(true, objCompProp, sType);
                                            }
                                            else
                                            {
                                                //Create Grouped Properties
                                                CreateGroupProperties(true, objCompProp, sType);
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (currentSimpleGoruped == "1")
                                        {
                                            CreatePropertyValues(false, sPropID);
                                        }
                                        else
                                        {
                                            LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sType);
                                            if (propTypeObj != null && propTypeObj.IsDataArray)
                                            {
                                                //Create Grouped Properties for Data Arrays
                                                CreateGroupPropertiesForDataArrays(false, objCompProp, sType);
                                            }
                                            else
                                            {
                                                //Create Grouped Properties
                                                CreateGroupProperties(false, objCompProp, sType);
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                LRRMessagBox.ShowMessage("SID_MAPPING_EXISTS", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                                e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                                return;
                            }
                        }
                        //For Site Specific properties.
                        else if (objCompProp.PropertyID == null || objCompProp.PropertyID == "")
                        {
                            CreateSiteSpecifeicPropertyValues(objCompProp.ModeID, objCompProp.ID);
                        }
                        else
                        {
                            return;
                        }
						e.TableControl.CurrentCell.ConfirmChanges();
					}
				}

				if(e.TableControl.TableDescriptor.IsForeignKeyRelationChildTableDescriptor()) //Check if the Drop Down is in the child table
				{
					int isDerivedIndex = e.TableControl.TableDescriptor.Fields.IndexOf("IsDerived") +  e.TableControl.TableDescriptor.GetColumnIndentCount();
					if(e.TableControl.CurrentCell.ColIndex !=  isDerivedIndex)
					{
						return;
					}
				}
				else
				{
					LRRSiteComponent currentLRRSC = gridSiteComponent.CurrencyManager.Current as LRRSiteComponent; 
					int masterComponentTypeIndex = gridSiteComponent.TableDescriptor.Fields.IndexOf("MasterComponentType") - 2;
					if(gridSiteComponent.TableModel.GetHeaderColumnDescriptorAt(e.TableControl.CurrentCell.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_MASTERPLANTITEM"))
					{
						//gridSiteComponent.TableModel.
						if(e.TableControl.Table.CurrentRecord == null)
						{
							return;
						}
						if(e.TableControl.Table.CurrentRecord.Kind != DisplayElementKind.AddNewRecord) 
						{
							if(e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records.Count > 0)
							{
								if(e.TableControl.CurrentCell.Renderer.CurrentStyle.CellType ==  "FilterBarCell")
									return;
							
								string nVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
								string oldVal = currentLRRSC.MasterComponentType; 
								if(oldVal != nVal)
								{
									DialogResult k = LRRMessagBox.ShowMessage("SID_LOSE_PROPERTYVALUE","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);
									if(k == DialogResult.Yes) 
									{
										for(int i=e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records.Count - 1;i>=0;i--)
										{
											object obj = e.TableControl.Table.CurrentRecord.NestedTables["Properties"].ChildTable.Records[i].GetData();
											LRRSiteComponentProperty lrrscp = obj as LRRSiteComponentProperty;

											foreach(LRRSiteComponentPropertyValue lrrscpv in lrrscp.Values)
												_siteComponentPropertyValues.Remove(lrrscpv);

											_siteCompProperties.Remove(obj);
										}
										Symcon.LightRidge.Options.LRROptions _lrrOptionsObj = _app.GetOptions() as Symcon.LightRidge.Options.LRROptions;
										if(_lrrOptionsObj.UsePreSetDefaultSetting)
										{
											//GridGroupingControl grid = sender as GridGroupingControl;
											ApplyDefaultSettings(grid,e);
                                            foreach (LRRSiteComponentProperty lscp in _siteCompProperties.GetChanges())
                                            {
                                                if (lscp.ObjectState == DBOperation.INSERT)
                                                {
                                                    CreateIndexRuleFormulas(lscp);
                                                }
                                            }
                                            _app.DBManagerObj.CommitCollection(formulasToCommit);
										}
									}
									else
									{
										e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
									}
								}
							}
							else
							{
								Symcon.LightRidge.Options.LRROptions _lrrOptionsObj = _app.GetOptions() as Symcon.LightRidge.Options.LRROptions;
								if(_lrrOptionsObj.UsePreSetDefaultSetting)
								{
									//GridGroupingControl grid = sender as GridGroupingControl;
									ApplyDefaultSettings(grid,e);
                                    foreach (LRRSiteComponentProperty lscp in _siteCompProperties.GetChanges())
                                    {
                                        if (lscp.ObjectState == DBOperation.INSERT)
                                        {
                                            CreateIndexRuleFormulas(lscp);
                                        }
                                    }
                                    _app.DBManagerObj.CommitCollection(formulasToCommit);
								}
							}
						}
						else
						{
							Symcon.LightRidge.Options.LRROptions _lrrOptionsObj = _app.GetOptions() as Symcon.LightRidge.Options.LRROptions;
							if(_lrrOptionsObj.UsePreSetDefaultSetting)
							{
								//GridGroupingControl grid = sender as GridGroupingControl;
								ApplyDefaultSettings(grid,e);
                                foreach (LRRSiteComponentProperty lscp in _siteCompProperties.GetChanges())
                                {
                                    if (lscp.ObjectState == DBOperation.INSERT)
                                    {
                                        CreateIndexRuleFormulas(lscp);
                                    }
                                }
                                _app.DBManagerObj.CommitCollection(formulasToCommit);
							}
						}
					}
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCurrentCellCloseDropDown Event:"+ex.Message  ,Logger.Level.Debug);
			}

		}

		private void ApplyDefaultSettings(GridGroupingControl grid,GridTableControlPopupClosedEventArgs e)
		{
			int iRow = e.TableControl.CurrentCell.RowIndex;
			int iCol = e.TableControl.CurrentCell.ColIndex;
			string sColHeader = "";
			if(gridSiteComponent.Table.TableModel.GetColumnDescriptorAt(iRow,iCol) != null)
			{
				sColHeader = gridSiteComponent.Table.TableModel.GetColumnDescriptorAt(iRow,iCol).HeaderText;
			}

			if(sColHeader.StartsWith(LRRHeaderText.GetHeaderString("SID_MASTERPLANTITEM")))
			{
				LRRSiteComponent sc = e.TableControl.Table.CurrentRecord.GetData() as LRRSiteComponent;  
				string nVal = e.TableControl.CurrentCell.Renderer.ControlText.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				string nControlVal = e.TableControl.CurrentCell.Renderer.ControlValue.ToString();
				string oldVal = gridSiteComponent.Table.TableModel[iRow,iCol].FormattedText;
				if(oldVal != nVal)
				{
					LRRSiteComponents siteComps = LRRModel.SiteComponentsObj.FilterSiteComponentsByMasterComponentID(nControlVal);
					if(siteComps.Count > 0)
					{
                        siteComps.SortColumn = "InternalSortIndex";
						siteComps.SortingOrder = Symcon.BusinessObjects.GenericComparer.SortOrder.Ascending;
						siteComps.Sort();  
						LRRSiteComponent lsc = siteComps[0] as LRRSiteComponent;
						LRRSiteComponentProperties lscps = lsc.Properties; 
						if(lscps.Count > 0)
						{
							LRRMasterProperties lmps = LRRModel.MasterComponentPropertiesObj.GetMasterPropertiesByType(nControlVal);
							foreach(LRRMasterProperty lmp in lmps)
							{
								foreach(LRRSiteComponentProperty lscp in lscps)
								{
									string siteComponentPropID = "";
									bool _isGrouped = false;
									if(lmp.PropID == lscp.PropertyID)
									{
										LRRSiteComponentProperty createLscp = ConverMaterPropToSiteCompProp(lmp);
										siteComponentPropID = createLscp.ID; 
										createLscp.ComponentID = sc.SiteComponentID; 
										_siteCompProperties.Add(createLscp);
										sc.Properties.Add(createLscp);
										string sType = createLscp.Type == null? "" : lscp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
										if(sType == "1")
										{
											CreatePropertyValues(createLscp.ModeID,createLscp.ID);
										}
										else
										{
											ConvertMasterGrpPropertiesToSiteGroupProperties(createLscp,false); 
											_isGrouped = true;
										}

                                        if (!_isGrouped)
                                        {
                                            LRRSiteComponentPropertyValues defaultLscpvs = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(lscp.ID);
                                            LRRSiteComponentPropertyValues createdLscpvs = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(siteComponentPropID);
                                            foreach (LRRSiteComponentPropertyValue defauLtlscpv in defaultLscpvs)
                                            {
                                                foreach (LRRSiteComponentPropertyValue createdLscpv in createdLscpvs)
                                                {
                                                    if (defauLtlscpv.ModeID == createdLscpv.ModeID)
                                                    {
                                                        createdLscpv.Direction = defauLtlscpv.Direction;
                                                        if (createdLscpv.ModeID == "1")
                                                        {
                                                            if (createdLscpv.PropertyValue != null && createdLscpv.PropertyValue != "")
                                                            {
                                                                createdLscpv.Derivation = "4";
                                                            }
                                                            else
                                                            {
                                                                createdLscpv.Derivation = "1";
                                                            }
                                                        }
                                                        else if (createdLscpv.ModeID == "2")
                                                        {
                                                            if (createdLscpv.Direction != "2")
                                                            {
                                                                createdLscpv.Derivation = "4";
                                                            }
                                                            else
                                                            {
                                                                createdLscpv.Derivation = "7";
                                                            }
                                                        }
                                                        else if (createdLscpv.ModeID == "3")
                                                        {
                                                            if (createdLscpv.Direction != "2")
                                                            {
                                                                createdLscpv.Derivation = "22";
                                                            }
                                                            else
                                                            {
                                                                createdLscpv.Derivation = "7";
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            LRRSiteGroupPropertyQualifierValues defaultSiteGrpQvalues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromSiteComPropID(lscp.ID);
                                            LRRSiteGroupPropertyQualifierValues createdSiteGrpQvalues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromSiteComPropID(siteComponentPropID);
                                            foreach (LRRSiteGroupPropertyQualifierValue defaultSiteGrpQvalue in defaultSiteGrpQvalues)
                                            {
                                                foreach (LRRSiteGroupPropertyQualifierValue createdSiteGrpQvalue in createdSiteGrpQvalues)
                                                {
                                                    if (createdSiteGrpQvalue.LookUpQualifierID == defaultSiteGrpQvalue.LookUpQualifierID && createdSiteGrpQvalue.ModeID == defaultSiteGrpQvalue.ModeID && createdSiteGrpQvalue.LookUpPropertiesID == defaultSiteGrpQvalue.LookUpPropertiesID)
                                                    {
                                                        createdSiteGrpQvalue.Direction = defaultSiteGrpQvalue.Direction;
                                                        if (createdSiteGrpQvalue.ModeID == "1")
                                                        {
                                                            if (createdSiteGrpQvalue.PropertyValue != null && createdSiteGrpQvalue.PropertyValue != "")
                                                            {
                                                                createdSiteGrpQvalue.Derivation = "4";
                                                            }
                                                            else
                                                            {
                                                                createdSiteGrpQvalue.Derivation = "1";
                                                            }
                                                        }
                                                        else if (createdSiteGrpQvalue.ModeID == "2")
                                                        {
                                                            if (createdSiteGrpQvalue.Direction != "2")
                                                            {
                                                                createdSiteGrpQvalue.Derivation = "4";
                                                            }
                                                            else
                                                            {
                                                                createdSiteGrpQvalue.Derivation = "7";
                                                            }
                                                        }
                                                        else if (createdSiteGrpQvalue.ModeID == "3")
                                                        {
                                                            if (createdSiteGrpQvalue.Direction != "2")
                                                            {
                                                                createdSiteGrpQvalue.Derivation = "22";
                                                            }
                                                            else
                                                            {
                                                                createdSiteGrpQvalue.Derivation = "7";
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
									}
								}
							}
						}
					}
				}
			}
		}

		private void CreateGroupProperties(bool currentModeFlag,LRRSiteComponentProperty objCompProp,string nControlVal)
		{
			string sMasterPropertyID = objCompProp.PropertyID == null ? "" : objCompProp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			string sPropType = nControlVal;
			LRRLookUpProperties objLookUpProperties = new LRRLookUpProperties();
			string sPropID = objCompProp.ID == null ? "" : objCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(objCompProp.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
			{
				ConvertMasterGrpPropertiesToSiteGroupProperties(objCompProp,false);
			}
			else
			{
				ArrayList DeletedQvalues = new ArrayList();
				ArrayList CreatedQvalues = new ArrayList();
				LRRModel.CascadeGPChanges(objCompProp,currentModeFlag,out DeletedQvalues,out CreatedQvalues);
				for(int i = 0;i<DeletedQvalues.Count;i++)
				{
					LRRSiteGroupPropertyQualifierValue lsgpqv = DeletedQvalues[i] as LRRSiteGroupPropertyQualifierValue;
					_siteGroupPropertyQualifierValues.Remove(lsgpqv);
				}
				for(int j = 0;j<CreatedQvalues.Count;j++)
				{
					LRRSiteGroupPropertyQualifierValue lsgpqv = CreatedQvalues[j] as LRRSiteGroupPropertyQualifierValue;
					_siteGroupPropertyQualifierValues.Add(lsgpqv);
				}
			}
			#region Commented
			/*LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sPropType + "'",false);
		   			
			if(sMasterPropertyID == "")
			{
				objLookUpProperties = _lrrLookUpProperties.getLookUpPropertiesForPropTypeID(sPropType);
				foreach(LRRLookUpProperty objLookUpProperty in objLookUpProperties)
				{
					LRRSiteComponentGroupProperty lsgp = ConverLookupPropToSiteCompGrpProp(objLookUpProperty,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}
			else
			{
				LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMasterPropertyID);
				LRRGroupProperties objMasterGrpProps = objMasterProp.GroupPpties;
				foreach(LRRGroupProperty objGrpProp in objMasterGrpProps)
				{
					LRRSiteComponentGroupProperty lsgp = ConverMaterGrpPropToSiteCompGrpProp(objGrpProp,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}*/
			#endregion
		}
		private void CreateGroupPropertiesForDataArrays(bool currentModeFlag,LRRSiteComponentProperty objCompProp,string nControlVal)
		{
			string sMasterPropertyID = objCompProp.PropertyID == null ? "" : objCompProp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			string sPropType = nControlVal;
			LRRLookUpProperties objLookUpProperties = new LRRLookUpProperties();
			string sPropID = objCompProp.ID == null ? "" : objCompProp.ID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(objCompProp.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
			{
				ConvertMasterGrpPropertiesToSiteGroupProperties(objCompProp,false);
			}
			else
			{
				ArrayList DeletedQvalues = new ArrayList();
				ArrayList CreatedQvalues = new ArrayList();
				LRRModel.CascadeGPChanges(objCompProp,currentModeFlag,out DeletedQvalues,out CreatedQvalues);
				for(int i = 0;i<DeletedQvalues.Count;i++)
				{
					LRRSiteGroupPropertyQualifierValue lsgpqv = DeletedQvalues[i] as LRRSiteGroupPropertyQualifierValue;
					_siteGroupPropertyQualifierValues.Remove(lsgpqv);
				}
				for(int j = 0;j<CreatedQvalues.Count;j++)
				{
					LRRSiteGroupPropertyQualifierValue lsgpqv = CreatedQvalues[j] as LRRSiteGroupPropertyQualifierValue;
					_siteGroupPropertyQualifierValues.Add(lsgpqv);
				}
			}
			#region Commented


			/*LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sPropType + "'",false);
		   			
			if(sMasterPropertyID == "")
			{
				objLookUpProperties = _lrrLookUpProperties.getLookUpPropertiesForPropTypeID(sPropType);
				foreach(LRRLookUpProperty objLookUpProperty in objLookUpProperties)
				{
					LRRSiteComponentGroupProperty lsgp = ConverLookupPropToSiteCompGrpPropForDataArrays(objLookUpProperty,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}
			else
			{
				LRRMasterProperty objMasterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sMasterPropertyID);
				LRRGroupProperties objMasterGrpProps = objMasterProp.GroupPpties;
				foreach(LRRGroupProperty objGrpProp in objMasterGrpProps)
				{
					LRRSiteComponentGroupProperty lsgp = ConverMaterGrpPropToSiteCompGrpPropForDataArrays(objGrpProp,objQualifiersForGrpType,currentModeFlag,sPropID);
					lsgp.SiteComponentPropID = sPropID;
					_siteCompGroupedProperties.Add(lsgp);
				}
			}*/

			#endregion
		}

        private void CreateIndexRuleFormulas(LRRSiteComponentProperty lscp)
        {
            LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscp.PropertyID);   
            if (lmp.IndexRuleFormulaID != "" && lmp.IndexRuleFormulaID != null)
            {
                LRRFormula formulaObj = LRRModel.FormulasObj.GetFormulaObjFromID(lmp.IndexRuleFormulaID);
                LRRFormulaParams formulaParams = formulaObj.Params;
                LRRSiteComponentPropertyValues lscpvs = lscp.Values;
                foreach (LRRSiteComponentPropertyValue value in lscpvs)
                {
                    LRRFormula formula = new LRRFormula();
                    formula.FormulaName = "Auto Generated IndexRule Formula";
                    LRRModel.FormulasObj.Add(formula);
                    formula.Expression = formulaObj.Expression;
                    value.FormulaID = formula.ID;
                    value.FormulaObj = formula;
                    LRRFormulaParams localCopyofParams = new LRRFormulaParams();
                    foreach (LRRFormulaParam fParam in formulaParams)
                    {
                        LRRSiteComponentProperty sourcrParamProps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromMasterPropertyID(lscp.ComponentID, fParam.SourceOBJID);
                        LRRFormulaParam localParam = new LRRFormulaParam();
                        localParam.FormulaID = formula.ID;
                        localParam.ParamName = fParam.ParamName;
                        localParam.ModeID = value.ModeID;
                        localParam.ModeName = LRRModel.Modes.GetModeByID(value.ModeID).ModeName; 
                        localParam.SourceCollectioName = "Symcon.LightRidge.BusinessObjects.LRRSiteComponentPropertyValue";
                        LRRSiteComponent lsc = LRRModel.SiteComponentsObj.GetSiteComponentByID(sourcrParamProps.ComponentID);
                        string varPath = "SiteComponents\\" + lsc.Name + "\\" + sourcrParamProps.Name + "-" + localParam.ModeName;
                        localParam.ParamPath = varPath;
                        localParam.CurrentValue = sourcrParamProps.Values.GetPropValueBysiteCompAndModeID(sourcrParamProps.ID, localParam.ModeID).ActualPropertyValue;
                        localParam.UOM = sourcrParamProps.UOM;
                        localParam.UIUOM = sourcrParamProps.UIUomID;
                        localParam.SourceOBJID = sourcrParamProps.ID;
                        localParam.PropertyName = sourcrParamProps.Name;
                        localParam.CurrentValueInUIUOM = ConvertUOM(sourcrParamProps.UOM, sourcrParamProps.UIUomID, localParam.CurrentValue, null);
                        localCopyofParams.Add(localParam);
                    }
                    formula.ModeID = value.ModeID;
                    formula.Params = localCopyofParams;
                    formula.IsFormula = true;
                    formula.SourceCollectionName = "Symcon.LightRidge.BusinessObjects.LRRSiteComponentPropertyValue";
                    formula.SourceObjectID = value.ID;
                    formula.SourcePropertyID = lscp.ID;
                    formulasToCommit.Add(formula);
                }
            }
            
        }

        private string ConvertUOM(string fromUOMID, string newUOMID, string currentValue,string lrrDataTypeID)
        {
            string newVal = "";
            if (currentValue != null && currentValue != "")
            {
                if (fromUOMID == newUOMID)
                {
                    newVal = currentValue;
                }
                else
                {
                    if ((fromUOMID != null && fromUOMID != "") &&
                        (newUOMID != null && newUOMID != ""))
                    {
                        newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(fromUOMID, newUOMID, currentValue, lrrDataTypeID);
                    }
                }
            }
            return newVal;
        }

        
        private void CreatePropertyValues(bool currentModeFlag, string sPropID)
		{
			if(currentModeFlag)
			{
                for(int i=0;i < LRRModel.ProjectModes.Count;i++)
				{
					LRRMode mode = LRRModel.ProjectModes[i] as LRRMode;
					if(mode.ModeId != "0")
					{
						LRRMeasurementSystem lms = LRRModel.MeasurementSystems.GetCurrentModelUOM();
						LRRMeasurementSystemDefinitions  lmsd = LRRModel.ChildModel.MeasSysDef.GetUOMTypesForMSID(lms.ID);
                        LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
                        LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscp.PropertyID);
                        string modelUom = lmsd.GetLocaleUOM(lms.ID, lscp.UOMTypeID);
						LRRSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRSiteComponentPropertyValue();
						lrrSiteComponentPropertyValue.ModeID = mode.ModeId;
						lrrSiteComponentPropertyValue.ModelUOM = modelUom;
						lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
						lrrSiteComponentPropertyValue.IsEditable = true;
						lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
						lrrSiteComponentPropertyValue.Direction = lmp.Direction;  
						//Add Cascading logic here
						_siteComponentPropertyValues.Add(lrrSiteComponentPropertyValue);
                        LRRSiteComponentProperty sProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
                        if (sProp != null)
                        {
                            sProp.Values.Add(lrrSiteComponentPropertyValue);
                        }
					}
				}
			}
			else
			{
				LRRSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRSiteComponentPropertyValue();
				lrrSiteComponentPropertyValue.ModeID = "0";
				lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
				lrrSiteComponentPropertyValue.Direction = "1";
				lrrSiteComponentPropertyValue.Derivation = "4";
				lrrSiteComponentPropertyValue.IsEditable = true;
				lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
				//Add Cascading logic here
				_siteComponentPropertyValues.Add(lrrSiteComponentPropertyValue);
                LRRSiteComponentProperty sProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
                if (sProp != null)
                {
                    sProp.Values.Add(lrrSiteComponentPropertyValue);
                }
			}
		}

        private void CreateSiteSpecifeicPropertyValues(bool currentModeFlag, string sPropID)
        {
            if (currentModeFlag)
            {
                for (int i = 0; i < LRRModel.ProjectModes.Count; i++)
                {
                    LRRMode mode = LRRModel.ProjectModes[i] as LRRMode;
                    if (mode.ModeId != "0")
                    {
                        LRRMeasurementSystem lms = LRRModel.MeasurementSystems.GetCurrentModelUOM();
                        LRRMeasurementSystemDefinitions lmsd = LRRModel.ChildModel.MeasSysDef.GetUOMTypesForMSID(lms.ID);
                        LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
                        string modelUom = lmsd.GetLocaleUOM(lms.ID, lscp.UOMTypeID);
                        LRRSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRSiteComponentPropertyValue();
                        lrrSiteComponentPropertyValue.ModeID = mode.ModeId;
                        lrrSiteComponentPropertyValue.ModelUOM = modelUom;
                        lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
                        lrrSiteComponentPropertyValue.IsEditable = true;
                        lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
                        //Add Cascading logic here
                        _siteComponentPropertyValues.Add(lrrSiteComponentPropertyValue);
                        LRRSiteComponentProperty sProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
                        if (sProp != null)
                        {
                            sProp.Values.Add(lrrSiteComponentPropertyValue);
                        }
                    }
                }
            }
            else
            {
                LRRSiteComponentPropertyValue lrrSiteComponentPropertyValue = new LRRSiteComponentPropertyValue();
                lrrSiteComponentPropertyValue.ModeID = "0";
                lrrSiteComponentPropertyValue.SiteComponentPropertyID = sPropID;
                lrrSiteComponentPropertyValue.Direction = "1";
                lrrSiteComponentPropertyValue.Derivation = "4";
                lrrSiteComponentPropertyValue.IsEditable = true;
                lrrSiteComponentPropertyValue.ReadOnlyAccess = false;
                //Add Cascading logic here
                _siteComponentPropertyValues.Add(lrrSiteComponentPropertyValue);
                LRRSiteComponentProperty sProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(sPropID);
                if (sProp != null)
                {
                    sProp.Values.Add(lrrSiteComponentPropertyValue);
                }
            }
        }
		private ArrayList GetChildRecords(Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e,string childGrid)
		{	
			ArrayList arrObjs = new ArrayList();
			for(int i= e.TableControl.Table.CurrentRecord.NestedTables[childGrid].ChildTable.Records.Count - 1;i >=0;i--)
			{
				object obj = e.TableControl.Table.CurrentRecord.NestedTables[childGrid].ChildTable.Records[i].GetData();
				arrObjs.Add(obj);
			}
			return arrObjs;
		}

		GridRelationDescriptor AddRelation(string name, GridRelationDescriptorCollection relations,string propName)
		{
			GridRelationDescriptor children = new GridRelationDescriptor();
			children.RelationKind = RelationKind.UniformChildList;
			children.MappingName = propName;
			children.Name = name;
			relations.Add(children);
			return children;
		}

		private void barPaste_Click(object sender, EventArgs e)
		{
			IDataObject obj = Clipboard.GetDataObject();
			string text = (string)obj.GetData(DataFormats.Text);
			MessageBox.Show(text);
		}

		//When new Property Override gets added...
		private void _siteCompPropsUserAndTimes_ItemAdded(object sender, EventArgs e)
		{
			LRRSiteComponentProperty lscp = sender as LRRSiteComponentProperty;
			if(lscp.ModeID ==  true)
			{
				LRRModeSetDefinitions tmpObj = (LRRModeSetDefinitions)_app.LRRDataStoreObj.GetDataStoreObject(typeof(LRRModeSetDefinitions));
				foreach(LRRModeSetDefinition lmsd in tmpObj)
				{
					LRRSiteComponentPropertyValue lscpv = new LRRSiteComponentPropertyValue();
					lscpv.ModeID = lmsd.ModeID;
					lscpv.SiteComponentPropertyID = lscp.ID;
					
					string sDirection = lrrMasterPropertyDirections[lscp.PropertyID.ToString(Symcon.BusinessObjects.SymConverter.Culture)].ToString();
					lscpv.Direction=sDirection ;
					if((sDirection == "Input/Output") || (sDirection == "3"))
					{
						if(lmsd.ModeID == "1")
							lscpv.Direction = "1";
					}
					//Hook Cascading logic here
					_siteComponentPropertyValues.Add(lscpv);
				}
				gridSiteComponent.Refresh();
			}

		}
		
		/// <summary>
		/// To BE REMOVED
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Override(object sender,EventArgs e)
		{
		
			Element eCurrentInnerElement = gridSiteComponent.Table.GetInnerMostCurrentElement(); 
			//GridRecord gnt = eCurrentInnerElement as GridRecord;

			Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
			GridNestedTable gnt = eCurrentElement as GridNestedTable;
			GridNestedTable gnt1 = gnt;
			GridTableDescriptor gtd = null;
			GridTableModel tableModel = new GridTableModel();
			while(gnt1 != null && gnt1.ChildTable != null)
			{
				gnt = gnt1;
				gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
				gtd = gnt.ParentTable.ParentTableDescriptor;
			}

			bool bTrack = (bool)gnt.ParentRecord.GetValue("IsTracked");
			

			LRRSiteComponentPropertyValue  objPropertyValue = eCurrentInnerElement.GetRecord().GetData() as LRRSiteComponentPropertyValue;
			if(eCurrentInnerElement.GetRecord().GetData() != null && bTrack)
			{
				LRRSiteComponentPropertyValueChanges objPropertyValueChanges = new LRRSiteComponentPropertyValueChanges();
				LRRMode objMode = new LRRMode();
				_app.DBManagerObj.PopulateCollection(objPropertyValueChanges," WHERE SiteComponentPropertyID ='" + objPropertyValue.SiteComponentPropertyID + "' and ModeID = '"+objPropertyValue.ModeID+"' ");
				_app.DBManagerObj.PopulateObject(objMode,typeof(LRRMode)," Where ModeID = '"+objPropertyValue.ModeID+"'");    
				if(objPropertyValueChanges.Count == 0 )
				{
					objPropertyValueChanges.Add(ConvertChanges(objPropertyValue));
				}
				SiteComponentPropertyValueOverrides amp = new SiteComponentPropertyValueOverrides(objPropertyValueChanges);
				amp.Text = amp.Text + " [" + objMode.ModeName + "]";
				amp.ShowDialog(this);
			}
			else
			{
				LRRMessagBox.ShowMessage("SID_PROPVALUE_OVERRIDE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);      
			}
		}


		private LRRSiteComponentPropertyValueChange ConvertChanges(LRRSiteComponentPropertyValue objPropValue)
		{
			
			LRRSiteComponentPropertyValueChange  propValChange = new LRRSiteComponentPropertyValueChange();
			propValChange.SiteComponentPropertyValueID = objPropValue.ID;
			propValChange.SiteComponentPropertyID = objPropValue.SiteComponentPropertyID;
			propValChange.PropertyValue= objPropValue.PropertyValue;
			propValChange.ModeID= objPropValue.ModeID;
			//&&&&propValChange.FormulaID= objPropValue.FormulaID;
			propValChange.EffectivePlantTime = objPropValue.EffectivePlantTime;
			return propValChange;
		}
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			
			this.Cursor = Cursors.WaitCursor;
			_gridExcelFormatter.UnwireGrid();
			if(_called)
			{
				InitDataSource(_siteCompontId);
			}	
			else
			{	
				InitDataSource();
			}		
			gridSiteComponent.TableModel.CellModels.Remove("DropDownTree");  
			gridSiteComponent.TableDescriptor.Relations.Clear();
			gridSiteComponent.QueryCellStyleInfo-=new GridTableCellStyleInfoEventHandler(gridSiteComponent_QueryCellStyleInfo);  
			InitializeGrid();
			//oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
			//oForAlerts.Clear();
			_gridExcelFormatter.WireGrid(gridSiteComponent);
			this.Cursor = Cursors.Default;
		}

        public bool ScreenAvailableForSave(LRRSiteComponent lsc)
        {
            AccessControlUIEntities objACLUI = new AccessControlUIEntities();
            bool ret = false;

            if (_app.DBManagerObj != null)
            {
                objACLUI = (AccessControlUIEntities)_app.DBManagerObj.AccessControlManager.GetUIAccessControlModel();
                if (objACLUI.Count > 0)
                {
                    IEnumerator iUIEntityEnum = objACLUI.GetEnumerator();
                    bool assigned = false;
                    while (iUIEntityEnum.MoveNext())
                    {
                        AccessControlUIEntity objUIEntity = (AccessControlUIEntity)iUIEntityEnum.Current;
                        UIEntity uiEntityObj = _app.DBManagerObj.AccessControlModel.UIEntitiesDefined.GetUIEntityFromID(objUIEntity.UIEntitiesID);
                        if ((objUIEntity.UIEntitiesID == this.Text.ToString()))
                        {
                            ACLPermissionAssigned aclPermissions = GetUIEntityPermission(objUIEntity);
                            if (aclPermissions == ACLPermissionAssigned.NOPERMISSIONS)
                            {
                                MessageBox.Show(" The User " + _app.LoggedUser + " Does not have any permission for modification of Historian Mapping ");
                                ret = false;
                            }
                        }
                        else if (uiEntityObj != null && uiEntityObj.ItemName == this.Text.ToString())
                        {
                            ACLPermissionAssigned aclPermissions = GetUIEntityPermission(objUIEntity);
                            if (aclPermissions == ACLPermissionAssigned.NOPERMISSIONS)
                            {
                                MessageBox.Show(" The User " + _app.LoggedUser + " Does not have any permission for modification of Historian Mapping ");
                                ret = false;
                            }
                            else if (aclPermissions == ACLPermissionAssigned.READONLY)
                            {
                                if (lsc.ObjectState != Symcon.Globals.Enums.DBOperation.UNCHANGED)
                                {
                                    MessageBox.Show(" Historian Mapping Screen is Read-Only for " + _app.LoggedUser);
                                    ret = false;
                                }
                            }
                        }
                        return ret;
                    }
                }
                return ret;
            }
            return ret;
        }

		public void Save()
		{
			this.gridSiteComponent.Table.EndEdit();    
			this.gridSiteComponent.GetTable("Properties").EndEdit();	
			this.gridSiteComponent.GetTable("AdditionalInfos").EndEdit();   
			bool isSaved = false;
			bool isPropertySaved = false;
            bool isPrpertyValueSave = false;
			int maxSortIndex=0;
			int secMaxSortindex=0;
			if(_siteComponents.GetChanges().Count > 0)
			{
				LRRSiteComponents toSaveSiteComponents = _siteComponents.GetChanges();
				int changesCount = _siteComponents.GetChanges().Count;
				ArrayList arr=new ArrayList();
				Hashtable ht=new Hashtable();

                if (!LRRModel.RebuildWaterModel)
                {
                    foreach (LRRSiteComponent siteComp in toSaveSiteComponents)
                    {
                        if (siteComp.ArrListUpdatedColNames.Contains("ComponentTypeID") || siteComp.ObjectState == DBOperation.INSERT || siteComp.ObjectState == DBOperation.DELETE)
                        {
                            if (_arrPlantItemsForRebuildWaterModel.Contains(siteComp.MasterComponentType))
                                LRRModel.RebuildWaterModel = true;
                            else if(_arrPlantItemsForRebuildWaterModel2.Contains(siteComp.GetID()))
                                LRRModel.RebuildWaterModel = true;
                        }
                    }
                }

				for(int i=0;i<changesCount;i++)
				{
					LRRSiteComponent lsc = toSaveSiteComponents[i] as LRRSiteComponent;
                    if (ScreenAvailableForSave(lsc))
                    {
                        if (lsc.ObjectState != DBOperation.DELETE)
                        {
                            if (lsc.Name == null || lsc.Name.Trim() == "")
                            {
                                LRRMessagBox.ShowMessage("SID_PLANTITEM_NULL", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                return;
                            }
                            if (lsc.MasterComponentType == null)
                            {
                                string[] s = new string[1];
                                s[0] = lsc.Name;
                                LRRMessagBox.ShowMessage("SID_MASTERPLANT_NULL", "SID_LABEL", s, MessageBoxButtons.OK, MessageBoxIcon.Error);
                                return;
                            }

                            AccessControlUIEntities objACLUI = new AccessControlUIEntities();
                            bool ret = false;
                            //if (_app.DBManagerObj != null)


                            if (lsc.ObjectState == DBOperation.UPDATE && !lsc.ArrListUpdatedColNames.Contains("ComponentTypeID"))
                                continue;

                            //for getting the max of internal sort index
                            string compType = lsc.MasterComponentType;
                            if (!arr.Contains(lsc.MasterComponentType))
                            {
                                arr.Add(lsc.MasterComponentType);
                                LRRSiteComponents siteComps = new LRRSiteComponents();
                                _app.DBManagerObj.PopulateCollection(siteComps, " WHERE internalsortindex=(select max( internalsortindex) from sitecomponents where ComponentTypeID='" + compType + "') and ComponentTypeID='" + compType + "'");
                                if (siteComps.Count == 0)
                                    maxSortIndex = -1;
                                else
                                {
                                    LRRSiteComponent sc = siteComps[0] as LRRSiteComponent;
                                    if (sc.InternalSortIndex == 0)
                                        maxSortIndex = 0;
                                    else
                                        maxSortIndex = sc.InternalSortIndex;
                                }
                            }
                            else
                            {
                                IDictionaryEnumerator myEnumerator = ht.GetEnumerator();
                                while (myEnumerator.MoveNext())
                                {
                                    if (lsc.MasterComponentType == myEnumerator.Key.ToString())
                                    {
                                        maxSortIndex = int.Parse(myEnumerator.Value.ToString());
                                    }
                                }
                            }

                    }

						//Special case for InternalSortIndex = 9999
						if(maxSortIndex==9999)
						{
							LRRSiteComponents siteCompss=new LRRSiteComponents();
							//to get the 2nd max of internal sort index
							_app.DBManagerObj.PopulateCollection(siteCompss," where internalsortindex=(select max(internalsortindex)FROM sitecomponents WHERE internalsortindex not in ("+maxSortIndex+") and ComponentTypeID='"+compType+"') and ComponentTypeID='"+compType+"'");
							if(siteCompss.Count > 0)
							{
								LRRSiteComponent scp=siteCompss[0] as LRRSiteComponent;
								secMaxSortindex=scp.InternalSortIndex;
								maxSortIndex=secMaxSortindex+1;
							}
							else
							{
								maxSortIndex = 0;
								if(arr.Contains(compType))
								{
									IDictionaryEnumerator myEnumerator = ht.GetEnumerator();
									while ( myEnumerator.MoveNext() )
									{
										if(lsc.MasterComponentType==myEnumerator.Key.ToString())
										{
											maxSortIndex=int.Parse( myEnumerator.Value.ToString());
											if(maxSortIndex == 9999)
											{
												maxSortIndex = 0;
												ht[lsc.MasterComponentType] = maxSortIndex;
												break;
											}
										}
									}
								}
								else
								{
									maxSortIndex = 0;
								}
							}
						}
						else
						{
							maxSortIndex++;
						}
						//Null check for Master Component Type
						if(lsc.MasterComponentType != null && !ht.Contains(lsc.MasterComponentType))
							ht.Add(lsc.MasterComponentType,maxSortIndex);

						lsc.InternalSortIndex=maxSortIndex;
					}
				}
                foreach (LRRSiteComponent siteComp in toSaveSiteComponents)
                {
                    if (siteComp.ObjectState == DBOperation.INSERT)
                    {
                        LRRMasterComponent mastrComp = LRRModel.Model.GetMasterComponentByID(siteComp.MasterComponentType);
                        if (mastrComp != null)
                        {
                            mastrComp.SiteComponentsObj.Add(siteComp); 
                        }
                    }
                    if (siteComp.ObjectState == DBOperation.DELETE)
                    {
                        LRRMasterComponent mastrComp = LRRModel.Model.GetMasterComponentByID(siteComp.MasterComponentType);
                        if (mastrComp != null)
                        {
                            mastrComp.SiteComponentsObj.Remove(siteComp);
                        }
                    }
                }
				_app.DBManagerObj.CommitCollection(toSaveSiteComponents); //Commit Site Components
				
				if(toSaveSiteComponents.HasError)
				{
					LRRMessagBox.ShowMessage("SID_REFERENTIALINTEGRITY_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					return;
				}
				
				isSaved = true;
			}
			if(_siteCompProperties.GetChanges().Count > 0)
			{
                
				LRRSiteComponentProperties  toSaveProperties = _siteCompProperties.GetChanges();
				for(int i=0;i<toSaveProperties.Count;i++)
				{
					LRRSiteComponentProperty lscp = toSaveProperties[i] as LRRSiteComponentProperty; 
					if(lscp.ObjectState != DBOperation.DELETE)
					{
						if(lscp.Name == null || lscp.Name.Trim()=="")
						{
							LRRMessagBox.ShowMessage("SID_PROPERTY_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
							return;
						}
					}
					if(lscp.PropertyID == null && lscp.ObjectState == DBOperation.INSERT)
					{
						///For SiteSpecific Prioperties
						ConvertMasterGrpPropertiesToSiteGroupProperties(lscp,false);  
					}
				}
                //AggregateUtility objAggregateUtility = new AggregateUtility();
                ArrayList insertedProperties = new ArrayList();
                foreach (LRRSiteComponentProperty lscp in toSaveProperties)
                {
                    LRRMasterProperty lmp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscp.PropertyID);
					 if(lmp!=null)
					 {
						 if (lmp.IsAggregatable)
						  {
								LRRAggregates aggregates = LRRModel.AggregatesObj.GetAggregatesByMasterComponentID(lmp.ComponentID);
                                if (aggregates.Count > 0)
								{
                                    foreach (LRRAggregate aggreGate in aggregates)
                                    {
                                        LRRAggregateEquipments aggEquips = LRRModel.AggregateEquipmentsObj.GetAggregateEquipsFromParentAggregateID(aggreGate.AggregateID);
                                        foreach (LRRAggregateEquipment aggEquip in aggEquips)
                                        {
                                            if (aggEquip.EquipmentID == lscp.ComponentID)
                                            {
                                                if (!insertedProperties.Contains(lmp.PropID))
                                                {
                                                    if (lscp.ObjectState == DBOperation.DELETE || lscp.ObjectState == DBOperation.INSERT)
                                                    {
                                                        insertedProperties.Add(lmp.PropID);
                                                        if (lscp.ObjectState == DBOperation.INSERT)
                                                        {
                                                            lmp.ObjectState = DBOperation.INSERT;
                                                        }
                                                        else if (lscp.ObjectState == DBOperation.DELETE)
                                                        {
                                                            lmp.ObjectState = DBOperation.DELETE;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
								}
						  }
					 }
                }
                if (insertedProperties.Count > 0)
                {
                    if (objAggregateUtility == null)
                    {
                        objAggregateUtility = new AggregateUtility();
                    }
                    objAggregateUtility.UpdateAggregateProperties(insertedProperties);
                    objAggregateUtility.CreateAggFormulas(toSaveProperties);
                }
                _app.DBManagerObj.CommitCollection(toSaveProperties); //Commit Site Components
				if(toSaveProperties.HasError)
				{
					LRRMessagBox.ShowMessage("SID_HASH_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
				}
				isSaved = true;
				isPropertySaved = true;
			}
			
			if(_siteComponentPropertyValues.GetChanges().Count > 0)
			{
				LRRSiteComponentPropertyValues toSavePropertyvalues = _siteComponentPropertyValues.GetChanges();
				SaveFormulas(toSavePropertyvalues);
                _app.DBManagerObj.CommitCollection(toSavePropertyvalues);
                _app.SetPropertyValueBinding(toSavePropertyvalues);
				foreach(LRRSiteComponentPropertyValue toPropogatePropertyvalue in  toSavePropertyvalues)
				{
					if(toPropogatePropertyvalue.Direction == "1" && toPropogatePropertyvalue.Derivation == "4")
					{
						MessagingClient.PropertyValueChanged(toPropogatePropertyvalue.SiteComponentPropertyID,toPropogatePropertyvalue.PropertyValue,toPropogatePropertyvalue.ModeID);
					}
				}
				_siteComponentPropertyValues.RefreshCollection();
                isPrpertyValueSave = true;
				isSaved = true;
			}
			if(_siteCompAdditionalinfos.GetChanges().Count > 0)
			{
				
				LRRSiteComponentAdditionalInformations toSaveAddInfos = _siteCompAdditionalinfos.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveAddInfos); //Commit Site Components
				isSaved = true;
			}
			if(_siteCompGroupedProperties.GetChanges().Count > 0 && isPropertySaved)
			{
				LRRSiteComponentGroupProperties toSaveGroupProperties = _siteCompGroupedProperties.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveGroupProperties); //Commit Site Components
				isSaved = true;
			}
			else if(_siteCompGroupedProperties.GetChanges().Count > 0 && !isPropertySaved)
			{
				LRRSiteComponentGroupProperties toSaveGroupProperties = _siteCompGroupedProperties.GetChanges();
				for(int i=0;i<toSaveGroupProperties.Count;i++)
				{
					LRRSiteComponentGroupProperty lscgp =  toSaveGroupProperties[i] as LRRSiteComponentGroupProperty;
					_siteCompGroupedProperties.Remove(lscgp); 
				}
			}
			if(_siteGroupPropertyQualifierValues.GetChanges().Count > 0  && isPropertySaved)
			{
				LRRSiteGroupPropertyQualifierValues toSaveQualifierValues = _siteGroupPropertyQualifierValues.GetChanges();
				_app.DBManagerObj.CommitCollection(toSaveQualifierValues); //Commit Site GroupPropertyQualifiers Values
                _app.SetGroupPropertyValueBinding(toSaveQualifierValues);
				isSaved = true;
			}
			else if(_siteGroupPropertyQualifierValues.GetChanges().Count > 0  && !isPropertySaved)
			{
				LRRSiteGroupPropertyQualifierValues toSaveQualifierValues = _siteGroupPropertyQualifierValues.GetChanges();
				for(int i = 0 ;i< toSaveQualifierValues.Count;i++)
				{
					LRRSiteGroupPropertyQualifierValue qValue =  toSaveQualifierValues[i] as LRRSiteGroupPropertyQualifierValue;
					_siteGroupPropertyQualifierValues.Remove(qValue);
                }
                _app.SetGroupPropertyValueBinding(toSaveQualifierValues);
			}
			// TO DO:
			// Uncomment the following code once the same is being looked at for Plant Operator
			// For Implementor, the save functionality of Property values is not supported.
			//			if(_siteCompGroupPropertyValues.GetChanges().Count > 0)
			//			{
			//				LRRSiteComponentGroupPropertyValues toSaveGroupPropertyValues = _siteCompGroupPropertyValues.GetChanges();
			//				_app.DBManagerObj.CommitCollection(toSaveGroupPropertyValues); //Commit Site Components
			//				isSaved = true;
			//			}
			//			if(_siteComponentPropertyValues.GetChanges().Count > 0)
			//			{
			//				LRRSiteComponentPropertyValues  toPropertyValues = _siteComponentPropertyValues.GetChanges();
			//				_app.DBManagerObj.CommitCollection(toPropertyValues); //Commit Site Components
			//				isSaved = true;
			//			}

            if (!isPrpertyValueSave)
            {
                LRRFormulas formulasToCommit = LRRModel.FormulasObj.GetChanges();
                if (formulasToCommit.Count > 0)
                {
                    _app.DBManagerObj.CommitCollection(formulasToCommit);
                    LRRModel.FormulasObj.RefreshCollection();
                    isSaved = true;
                }

                LRRFormulaOverrides formulaOverridesToCommit = LRRModel.FormulaOverridesObj.GetChanges();
                if (formulaOverridesToCommit.Count > 0)
                {
                    _app.DBManagerObj.CommitCollection(formulaOverridesToCommit);
                    LRRModel.FormulaOverridesObj.RefreshCollection();
                    isSaved = true;
                }
            }

			if(!isSaved)
			{
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
			}
			else
			{
               // _app.SetPropertyValueBinding();
               // _app.SetGroupPropertyValueBinding();
				_siteComponents.RefreshCollection();
				_siteCompProperties.RefreshCollection();
				_siteCompAdditionalinfos.RefreshCollection();
				_siteCompGroupedProperties.RefreshCollection();
				_siteGroupPropertyQualifierValues.RefreshCollection();
                LRRMasterComponents masterComponents = LRRModel.Model;
                lrrFormulaSiteComponents.Clear();
                lrrFormulaSiteComponents.Add(0, masterComponents);
                lrrFormulaSiteComponents.Add(1, "MasterComponents");
                lrrFormulaSiteComponents.Add(2, "SiteComponentsObj");
                lrrFormulaSiteComponents.Add(3, "Properties");

                lrrFormulaSiteComponents.Add(4, "GroupPpties");
                lrrFormulaSiteComponents.Add(5, "GroupPptiesQualifierValues");
                lrrFormulaSiteComponents.Add(6, LRRModel.LookUpQualifiers);
					 lrrFormulaSiteComponents.Add(7,_lrrAggregates);

                LRRFormulaDataStore.ShowGroupedAttributes = true;
                LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteComponentPropertyValue).ToString();

                LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
                LRRFormulaDataStore.ModeFlag = true;
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
			}
		}

        private ACLPermissionAssigned GetUIEntityPermission(AccessControlUIEntity objUIEntity)
        {
            
        }


		private void SetFormula(LRRSiteComponentPropertyValues toSavePropertyvalues)
		{
			foreach(LRRSiteComponentPropertyValue scpValue in toSavePropertyvalues)
			{
				
				if(scpValue.FormulaObj.IsOverrided)
				{
					LRRFormulaOverride  formulaOverride = LRRModel.FormulaOverridesObj.GetDefaultFormulaObj(scpValue.FormulaObj.ID);

					if(formulaOverride != null)
					{
						scpValue.FormulaObj.ID = formulaOverride.FormulaID;
						scpValue.FormulaObj.FormulaName = formulaOverride.FormulaName;
						scpValue.FormulaObj.FormulaDescription = formulaOverride.FormulaDescription;
					
						scpValue.FormulaObj.Expression = formulaOverride.Expression;
						scpValue.FormulaObj.SourceCollectionName = formulaOverride.SourceCollectionName;
						scpValue.FormulaObj.SourceLookUpPropertyID = formulaOverride.SourceLookUpPropertyID;
						scpValue.FormulaObj.SourceLookUpQualifierID = formulaOverride.SourceLookUpQualifierID;
						scpValue.FormulaObj.SourceObjectID = formulaOverride.SourceObjectID;
						scpValue.FormulaObj.SourcePropertyID = formulaOverride.SourcePropertyID;
						scpValue.FormulaObj.MethodName = formulaOverride.MethodName;
						scpValue.FormulaObj.ModeID = formulaOverride.ModeID;
						scpValue.FormulaObj.Params = formulaOverride.Params;
						scpValue.FormulaObj.IsCustomFormula = formulaOverride.IsCustomFormula;
						scpValue.FormulaObj.IsFormula = formulaOverride.IsFormula;
						scpValue.FormulaObj.PostCalc = formulaOverride.PostCalc;
						scpValue.FormulaObj.PreCalc = formulaOverride.PreCalc;
					}
					
				}
			}
		}

        private void SaveFormulas(LRRSiteComponentPropertyValues toSavePropertyvalues)
        {
            LRRFormulaOverrides formulaoverridechanges = new LRRFormulaOverrides();
            LRRFormulas formulachanges = new LRRFormulas();
            bool isDeleted = false;

            foreach (LRRSiteComponentPropertyValue scpValue in toSavePropertyvalues)
            {
                LRRSiteComponentPropertyValue lrrSiteCompPropVal = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(scpValue.ID);

                if (scpValue.FormulaObj != null && scpValue.FormulaObj.IsOverrided)
                {
                    LRRFormulaOverrides formulaOverrides = LRRModel.FormulaOverridesObj.FilterFormulasBySourceObjectID(scpValue.ID);
                    if (formulaOverrides != null)
                    {
                        foreach (LRRFormulaOverride formulaoverride in formulaOverrides)
                        {
                            if (formulaoverride.IsActive)
                            {
                                formulaoverride.FormulaName = scpValue.FormulaObj.FormulaName;
                                formulaoverride.FormulaDescription = scpValue.FormulaObj.FormulaDescription;
                                formulaoverride.FormulaID = scpValue.FormulaObj.ID;
                                formulaoverride.Expression = scpValue.FormulaObj.Expression;
                                formulaoverride.SourceCollectionName = scpValue.FormulaObj.SourceCollectionName;
                                formulaoverride.SourceLookUpPropertyID = scpValue.FormulaObj.SourceLookUpPropertyID;
                                formulaoverride.SourceLookUpQualifierID = scpValue.FormulaObj.SourceLookUpQualifierID;
                                formulaoverride.SourceObjectID = scpValue.FormulaObj.SourceObjectID;
                                formulaoverride.SourcePropertyID = scpValue.FormulaObj.SourcePropertyID;
                                formulaoverride.MethodName = scpValue.FormulaObj.MethodName;
                                formulaoverride.ModeID = scpValue.FormulaObj.ModeID;
                                formulaoverride.Params = scpValue.FormulaObj.Params;
                                formulaoverride.PostCalc = scpValue.FormulaObj.PostCalc;
                                formulaoverride.PreCalc = scpValue.FormulaObj.PreCalc;
                                formulaoverride.IsFormula = scpValue.FormulaObj.IsFormula;
                                formulaoverride.IsCustomFormula = scpValue.FormulaObj.IsCustomFormula;
                                formulaoverridechanges.Add(formulaoverride);
                            }
                        }



                    }
                }
                else
                {


                    if (scpValue.FormulaObj.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                    {
                        LRRModel.FormulasObj.Add(scpValue.FormulaObj);


                        if (lrrSiteCompPropVal.ModeID == "1")
                        {
                            LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrSiteCompPropVal.SiteComponentPropertyID);
                            if (!(scp == null))
                            {
                                LRRHistData lhisttag = LRRModel.HistDatas.GetHistDataFromHistTagUID(scp.HistTagID);
                                if (lhisttag == null)
                                {
                                    if (lrrSiteCompPropVal.ModeID == "1")
                                    {
                                        lrrSiteCompPropVal.Derivation = "5";
                                        scpValue.Derivation = "5";
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (lrrSiteCompPropVal.Direction == "1" || lrrSiteCompPropVal.Direction == "3")
                            {
                                lrrSiteCompPropVal.Derivation = "5";
                                scpValue.Derivation = "5";
                            }
                        }
                        formulachanges.Add(scpValue.FormulaObj);
                    }
                    else if (scpValue.FormulaObj.ObjectState == DBOperation.DELETE)
                    {
                        formulachanges.Add(scpValue.FormulaObj);
                        isDeleted = true;
                        if (lrrSiteCompPropVal.PropertyValue != null && lrrSiteCompPropVal.PropertyValue != "")
                        {
                            lrrSiteCompPropVal.Derivation = "4";
                            scpValue.Derivation = "4";
                        }
                        else
                        {
                            lrrSiteCompPropVal.Derivation = "1";
                            scpValue.Derivation = "1";                            
                        }
                    }   
                    else if (scpValue.FormulaObj.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE)
                    {
                        formulachanges.Add(scpValue.FormulaObj);
                    }
                   
                }
                //else if (scpValue.FormulaObj.ObjectState == Symcon.Globals.Enums.DBOperation.DELETE)
                //{
                //    formulachanges.Remove(scpValue.FormulaObj);
                //}

                if (formulaoverridechanges.Count > 0)
                {
                    _app.DBManagerObj.CommitCollection(formulaoverridechanges);
                }
                if (formulachanges.Count > 0)
                {
                    _app.DBManagerObj.CommitCollection(formulachanges);
                    LRRPESteamFormulas peSteamForumalsChages = LRRModel.PESteamFormulaObj.GetChanges();
                    if (peSteamForumalsChages.Count > 0)
                    {
                        _app.DBManagerObj.CommitCollection(peSteamForumalsChages);
                    }
                    if (isDeleted)
                    {
                        LRRFormula formulaOBj = new LRRFormula();
                        lrrSiteCompPropVal.FormulaID = formulaOBj.ID;
                        lrrSiteCompPropVal.FormulaObj = formulaOBj;
                        lrrSiteCompPropVal.FormulaObj.ObjectState = DBOperation.UNCHANGED; 
                    }
                }
                LRRModel.FormulasObj.RefreshCollection();
                LRRModel.FormulaOverridesObj.RefreshCollection();
                LRRModel.PESteamFormulaObj.RefreshCollection();
                isDeleted = false;
            }
        }
	
		public bool SupportsMasterPropertiesCopy()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void CopyMasterProperties()
		{
			try
			{
				if(gridSiteComponent.TableModel.Table.Records.Count == 0)
				{
					LRRMessagBox.ShowMessage("SID_SELECTEDITEM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
				}
				else
				{
					LRRSiteComponent sc = (LRRSiteComponent)gridSiteComponent.TableModel.Table.GetCurrencyManager().Current;
					LRRMasterProperties lmps = new LRRMasterProperties();
					LRRGroupProperties lmgps = new LRRGroupProperties();
					ChildTable ct = null;
					if(gridSiteComponent.TableModel.Table.CurrentRecord != null)
					{
						ct = gridSiteComponent.TableModel.Table.CurrentRecord.NestedTables["Properties"].ChildTable;
					}
					else
					{
						Element innerElement = gridSiteComponent.TableModel.Table.GetInnerMostCurrentElement();
						if(innerElement.ParentChildTable.Name == "PropertyOverrides")
						{
							ct = innerElement.ParentDisplayElement.ParentChildTable;
						}
						else if(innerElement.ParentChildTable.Name == "Properties")
						{
							ct = innerElement.ParentChildTable;
						}
						else
						{
							ct = null;
						}
					}
					if(ct == null)
					{
						LRRMessagBox.ShowMessage("SID_CHILDTABLE_NOTEXISTS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Exclamation);    
						return;
					}
					string clause = "";
					foreach(Record rec in ct.Records)
					{
						LRRSiteComponentProperty lscp =  (LRRSiteComponentProperty)rec.GetData();
						if(lscp.PropertyID != "")
						{
							if(clause != "")
							{
								clause = clause + ",'" + lscp.PropertyID + "'"; 
							}
							else
							{
								clause = "'" + lscp.PropertyID + "'"; 
							}
						}
					}

					if(sc != null)
					{
						if(sc.MasterComponentType != null)
						{
							if(sc.MasterComponentType == "")
							{
								LRRMessagBox.ShowMessage("SID_SELECTEDMASTERPLANTITEM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
								return;
							}

							if(!sc.MasterComponentType.Trim().Equals(""))
							{
								_app.DBManagerObj.PopulateCollection(lmps," WHERE ComponentTypeID ='" + sc.MasterComponentType + "'" + " AND PropertyID NOT IN(SELECT PropertyID FROM SiteComponentProperties WHERE ComponentID = '" + sc.MasterComponentType + "')");
								if(lmps.Count == 0)
								{
									LRRMessagBox.ShowMessage("SID_MASTERPROPERTIES_NOTEXISTS","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
									return;
								}
								else
								{
									string inClause = "";
									if(clause != "")
									{
										inClause = " AND PropertyID NOT IN(" + clause + ")";
									}	
									_app.DBManagerObj.PopulateCollection(lmps," WHERE ComponentTypeID ='" + sc.MasterComponentType + "'" + inClause);
									if(lmps.Count == 0)
									{
										LRRMessagBox.ShowMessage("SID_ALLMASTERPROPERTIES_ADDED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);     
										return;
									}
								}
							}
						}
						else
						{
							LRRMessagBox.ShowMessage("SID_SELECTEDMASTERPLANTITEM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);    
							return;
						}
					} 
					AddMasterProperties amp = new AddMasterProperties(lmps,sc.SiteComponentID);
					amp.Text = amp.Text + " [" + sc.Name + "]";
					DialogResult dlgResult = amp.ShowDialog(this);

					if(dlgResult == DialogResult.OK)
					{
						_LocaleID = amp.sLocaleID;

						_app.DBManagerObj.PopulateCollection(lmgps);
						string masterCompID = ((LRRMasterProperty)lmps[0]).ComponentID;
						
						ArrayList list = new ArrayList();
						Hashtable indexes  = new Hashtable();
						for(int i=0;i<gridSiteComponent.TableModel.Table.Records.Count;i++)
						{
							LRRSiteComponent sc2 = (LRRSiteComponent)gridSiteComponent.TableModel.Table.Records[i].GetData();
							if(sc2.MasterComponentType==masterCompID)
							{
								list.Add(sc2.SiteComponentID);
								indexes.Add(sc2.SiteComponentID,i);
							}
						}
						if(copyToAll == true)
						{
							foreach(LRRMasterProperty lmp in lmps)
							{
								BaseObject bo = lmp as BaseObject;
								if(bo.IsSelected == true)
								{
									for(int j=0;j<list.Count;j++)
									{
										Hashtable existingHash = new Hashtable();
										ChildTable ct1 = gridSiteComponent.TableModel.Table.Records[(int)indexes[list[j]]].NestedTables["Properties"].ChildTable; 
										for(int k=0;k<ct1.Records.Count;k++)
										{
											LRRSiteComponentProperty scpOld =(LRRSiteComponentProperty)ct1.Records[k].GetData();
											if(scpOld.PropertyID != null && scpOld.PropertyID.Trim() != "")
											{
												existingHash.Add(scpOld.PropertyID,"");
											}
										}
										if(!existingHash.ContainsKey(lmp.PropID))
										{
											LRRSiteComponentProperty lscp = ConverMaterPropToSiteCompProp(lmp);
											lscp.ComponentID = (string)list[j]; 
											_siteCompProperties.Add(lscp);
											LRRSiteComponent siteComp = LRRModel.SiteComponentsObj.GetSiteComponentByID(lscp.ComponentID);
											if(siteComp != null)
											{
												siteComp.Properties.Add(lscp);
											}
											string sType = lscp.Type == null? "" : lscp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
											if(sType == "1")
												CreatePropertyValues(lscp.ModeID,lscp.ID);
											else
												ConvertMasterGrpPropertiesToSiteGroupProperties(lscp,false); 
											/*foreach(LRRGroupProperty lmgp in lmgps)
											{
												if(lmgp.MasterPropertyID == lmp.PropID)
												{
													string sGrpType = lmp.Type == null ? "" : lmp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
													LRRSiteComponentGroupProperty lsgp = null;
													LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sGrpType);
													if(propTypeObj != null && propTypeObj.IsDataArray)
													{
														//Create Grouped Properties for Data Arrays
														lsgp = ConverMaterGrpPropToSiteCompGrpPropForDataArrays(lmgp,null,lmgp.ModeID,lscp.ID);
													}
													else
													{
														LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();//LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(sGrpType);// new LRRLookUpQualifiers();
														_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sGrpType + "'",false);
														lsgp = ConverMaterGrpPropToSiteCompGrpProp(lmgp,objQualifiersForGrpType,lmgp.ModeID,lscp.ID);
													}
													
													lsgp.SiteComponentPropID = lscp.ID;
													_siteCompGroupedProperties.Add(lsgp);
												}
											}*/
										}
									}
								}
							}
						}
						else
						{
							//lmp.ComponentID = sc.SiteComponentID;
							Hashtable existingHash = new Hashtable();
							ChildTable ct1 = gridSiteComponent.TableModel.Table.Records[(int)indexes[sc.SiteComponentID]].NestedTables["Properties"].ChildTable; 
							for(int k=0;k<ct1.Records.Count;k++)
							{
								LRRSiteComponentProperty scpOld =(LRRSiteComponentProperty)ct1.Records[k].GetData();
								if(scpOld.PropertyID != null && scpOld.PropertyID.Trim() != "")
								{
									existingHash.Add(scpOld.PropertyID,"");
								}
							}

							foreach(LRRMasterProperty lmp in lmps)
							{
								BaseObject bo = lmp as BaseObject;
								if(bo.IsSelected == true)
								{
									lmp.ComponentID = sc.SiteComponentID;
									if(!existingHash.ContainsKey(lmp.PropID))
									{
										LRRSiteComponentProperty lscp = ConverMaterPropToSiteCompProp(lmp);
										lscp.ComponentID = sc.SiteComponentID; 
										_siteCompProperties.Add(lscp);
										sc.Properties.Add(lscp);
										string sType = lscp.Type == null? "" : lscp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
										if(sType == "1")
											CreatePropertyValues(lscp.ModeID,lscp.ID);
										else
											ConvertMasterGrpPropertiesToSiteGroupProperties(lscp,false); 
										/*foreach(LRRGroupProperty lmgp in lmgps)
										{
											if(lmgp.MasterPropertyID == lmp.PropID)
											{
												string sGrpType = lmp.Type == null ? "" : lmp.Type.ToString(Symcon.BusinessObjects.SymConverter.Culture);
												LRRSiteComponentGroupProperty lsgp = null;
												LRRPropertyType propTypeObj = LRRModel.ChildModel.PropertyTypes.getPropertyTypeForID(sGrpType);
												if(propTypeObj != null && propTypeObj.IsDataArray)
												{
													//Create Grouped Properties for Data Arrays
													lsgp = ConverMaterGrpPropToSiteCompGrpPropForDataArrays(lmgp,null,lmgp.ModeID,lscp.ID);
												}
												else
												{
													LRRLookUpQualifiers objQualifiersForGrpType = new LRRLookUpQualifiers();//LRRModel.LookUpQualifiers.getLookUpQualifiersForPropType(sGrpType);// new LRRLookUpQualifiers();
													_app.DBManagerObj.PopulateCollection(objQualifiersForGrpType," WHERE PropertyID = '" + sGrpType + "'",false);
													lsgp = 
													ConverMaterGrpPropToSiteCompGrpProp(lmgp,objQualifiersForGrpType,lmgp.ModeID,lscp.ID);
												}
												lsgp.SiteComponentPropID = lscp.ID;
												_siteCompGroupedProperties.Add(lsgp);
											}
										}*/
									}
								}
							}
						}
								
						copyToAll = false;
					}
					else
					{
						copyToAll = false;
						return;
					}
				}
                foreach (LRRSiteComponentProperty lscp in _siteCompProperties.GetChanges())
                {
                    if (lscp.ObjectState == DBOperation.INSERT)
                    {
                        CreateIndexRuleFormulas(lscp);
                    }
                }
                _app.DBManagerObj.CommitCollection(formulasToCommit);
                
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"CopyMasterProperties :"+ex.Message  ,Logger.Level.Error);
				//LRRMessagBox.ShowMessage("SID_COPYMASTERPROPERTY_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);      
				return;
			}
		}

		public void Paste()
		{
			// TODO:  Add SiteComponentEntry.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add SiteComponentEntry.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add SiteComponentEntry.Print implementation
			if(gridSiteComponent.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSiteComponent,false);
			}
		}

		public void Delete()
		{
			//Critical
			//Please do not enable the delete for this screen.
//			SyncGridUtilities.DeleteRecords(gridSiteComponent);   
		}

		public void ArrangeColumns()
		{
			// TODO:  Add SiteComponentEntry.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add SiteComponentEntry.ClearFilter implementation
			this.Cursor = Cursors.WaitCursor; 
			SyncGridUtilities.ClearFilter(gridSiteComponent);   
			this.Cursor = Cursors.Default;   
//			this.gridSiteComponent.TableDescriptor.RecordFilters.Clear();
//			this.gridSiteComponent.GetTable("Properties").TableDescriptor.RecordFilters.Clear();     
			//Refresh(); 
		}

		public void ImportToExcel()
		{
			if(gridSiteComponent.TableControl.Table.CurrentRecord == null)
			{
				LRRMessagBox.ShowMessage("SID_IMPORT_FROM_EXCEL_DENIED","SID_LABLE",MessageBoxButtons.OK,MessageBoxIcon.Information);   
			}
			else
			{
				SyncGridUtilities.ImportFromExcel(this.gridSiteComponent);
			}
		}

		public void Export()
		{
			if(gridSiteComponent.TableControl.CurrentCell.IsActive)
			{
				ExportToExcel excelExpForm = new ExportToExcel(this.gridSiteComponent);
				excelExpForm.ShowDialog(this);
			}
            else
            {
                MessageBox.Show(this, Symcon.Utils.HeaderDispatcher.LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add SiteComponentEntry.SupportsCopy implementation
			return true;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add SiteComponentEntry.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add SiteComponentEntry.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add SiteComponentEntry.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add SiteComponentEntry.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add SiteComponentEntry.SupportsDelete implementation
			//Critical
			//Please do not enable the delete for this screen.
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add SiteComponentEntry.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add SiteComponentEntry.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add SiteComponentEntry.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void SelectionPaste()
		{
			///SyncGridUtilities.PasteSelection(gridSiteComponent);
			///
			try
			{
				int rowI = gridSiteComponent.TableControl.CurrentCell.RowIndex;
				int colI = gridSiteComponent.TableControl.CurrentCell.ColIndex;
				string sColHeader = gridSiteComponent.TableControl.Table.TableModel.GetColumnDescriptorAt(rowI,colI).HeaderText;
				if(sColHeader == LRRHeaderText.GetHeaderString("SID_MASTERPLANTITEM"))
				{
					GridRangeInfoList ranges = gridSiteComponent.TableControl.Model.SelectedRanges;
					if(ranges == null)
						return;
					if(ranges.Count == 1 && ranges.ActiveRange.IsCells)
					{
						GridRangeInfo range = ranges.ActiveRange;
						if(range == null)
							return;
						for(int col = range.Left; col <= range.Right; ++col)
						{
							GridRecord _rec = gridSiteComponent.TableControl.Table.CurrentRecord as GridRecord;
							if(_rec ==  null)
								return;
							LRRSiteComponent lsc = _rec.GetData() as LRRSiteComponent;
						  	if(lsc != null && lsc.MasterComponentType != null)
							{
								object o = gridSiteComponent.TableControl.Model[range.Top, col].CellValue;
								for(int row = range.Top + 1; row <= range.Bottom; row++)
								{
									LRRSiteComponent lsc1 = gridSiteComponent.TableControl.Model.GetDisplayElementAt(row).GetData() as LRRSiteComponent;
									if(lsc1 != null && lsc1.MasterComponentType != null)
									{
										break;
									}
									else
									{
										gridSiteComponent.TableControl.Model[row, col].CellValue = o;
									}
								}
							}
						}
					}
				}
				else
				{
					SyncGridUtilities.PasteSelection(gridSiteComponent);
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCurrentCellKeyDown Event:"+ex.Message  ,Logger.Level.Debug);
			}
		}

		public void InsertNewRows()
		{
			InsertNewRowsForm insNewRows = new InsertNewRowsForm();
			DialogResult dlgResult = insNewRows.ShowDialog(this);
			int iNumofRows = insNewRows.iNewRows;
			if(dlgResult == DialogResult.OK)
			{
				SyncGridUtilities.InsertNewRows(gridSiteComponent,iNumofRows);
			}
			else
			{
				return;
			}
		}


		
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		private void gridSiteComponent_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			if(e.Action == CurrentRecordAction.EndEditCalled)
			{	
				if(gridSiteComponent.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}
					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					if(childTable.Name == "Properties")
					{
						LRRMeasurementSystem lms = LRRModel.MeasurementSystems.GetCurrentModelUOM(); 
						LRRMeasurementSystemDefinitions  lmsd = LRRModel.ChildModel.MeasSysDef.GetUOMTypesForMSID(lms.ID);   
						LRRSiteComponentProperty lscp = e.Record.GetData() as LRRSiteComponentProperty;
						if(lscp!=null)
						{
							string modelUom = lmsd.GetLocaleUOM(lms.ID,lscp.UOMTypeID);
							lscp.UOM = modelUom;
                            List<IPropertyValue> arrPropValues = LRRModel.PropertyValuesObj.GetPropValuesByPropID(lscp.ID);
							if(arrPropValues != null)
							{
								for(int i=0;i < arrPropValues.Count;i++)
								{
									LRRSiteComponentPropertyValue lscpValue = arrPropValues[i] as LRRSiteComponentPropertyValue;
									lscpValue.ModelUOM = modelUom;
								}
							}
						}					     
					}
				}
			}
			if(e.Action == CurrentRecordAction.EnterRecordComplete)
			{
				if(gridSiteComponent.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = gridSiteComponent.TableControl.Table.CurrentElement;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					GridTableModel tableModel = new GridTableModel();
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}

					string sType = gnt.ParentRecord.GetValue("Type") == null ? "" : gnt.ParentRecord.GetValue("Type").ToString();
					
					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					
					if(childTable.Name.Equals("PropertyValues"))
					{
						if(e.Record.IsCaption())
							return;
						string modeID = e.Record.GetRecord().GetValue("ModeID") == null ? "" : e.Record.GetRecord().GetValue("ModeID").ToString();
						string bParentMode = gnt.ParentRecord.GetValue("ModeID") == null ? "" : gnt.ParentRecord.GetValue("ModeID").ToString();
						string propID = e.Record.GetRecord().GetValue("ID") == null ? "" : e.Record.GetRecord().GetValue("ID").ToString();

						LRRFormulaDataStore.ModeID = modeID;
						LRRFormulaDataStore.SourceObjectID = propID;
						LRRFormulaDataStore.ShowGroupedAttributes = true;//false;
						LRRFormulaDataStore.SourceLookupPropertyID = null;
						LRRFormulaDataStore.SourceLookupQualifierID = null;
						LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteComponentPropertyValue).ToString();

						string sPropId = gnt.ParentRecord.GetValue("PropertyID")== null ? "" : gnt.ParentRecord.GetValue("PropertyID").ToString();
						LRRSiteComponentPropertyValue propValueObj = null;
						try
						{
							propValueObj =  (LRRSiteComponentPropertyValue)e.Record.GetData();
						}
						catch(Exception ex)
						{
							Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_CurrentRecordContextChange Event:"+ex.Message  ,Logger.Level.Debug);
						}
						
						if(propValueObj != null)
						{
							LRRFormulaDataStore.SourcePropertyID = propValueObj.SiteComponentPropertyID;
						}
						else
						{
							LRRFormulaDataStore.SourcePropertyID = sPropId;
						}

						if(sPropId != "")
						{
							bool overridable = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(sPropId).Overridable;
							
							if(propValueObj != null)
							{
								IPropertyValue ip = propValueObj as IPropertyValue;
								editFlag = ip.GetEditableState();
								/*if(!overridable) 
								{
									editFlag = false;
								}
								else 
								{
									editFlag = true;
								}*/
							}
							else
							{
								editFlag = true;
							}
							
						}
						else
						{
							editFlag = true;
						}

						//--For EVVs--
						//						string parentUOMType = gnt.ParentRecord.GetValue("UOMTypeID") == null ? "" : gnt.ParentRecord.GetValue("UOMTypeID").ToString();
						//						LRRUOMTypes lrrUOMTypes = new LRRUOMTypes();
						//						if(parentUOMType != "")
						//						{
						//							_app.DBManagerObj.PopulateCollection(lrrUOMTypes," where ID = '" + parentUOMType + "'",false);
						//							LRRUOMType lrrUOMType = lrrUOMTypes[0];
						//							if(lrrUOMType.IsEVV)
						//							{
						//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
						//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Show;
						//							}
						//							else
						//							{
						//								//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.CellType = "TextBox";
						//								childTable.ParentTableDescriptor.Columns["PropertyValue"].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
						//							}
						//						}

						//--End--
					}
					string sPropertyType ="";
					//					if(childTable.Name.Equals("Properties"))
					//					{
					//						sPropertyType = e.Record.GetRecord().GetValue("Type") == null ? "" : e.Record.GetRecord().GetValue("Type").ToString();
					//						if((sPropertyType != "0") && (sPropertyType != "1") && (sPropertyType != "2"))
					//						{
					//							childTable.ParentTableDescriptor.Appearance.RecordPlusMinusCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
					//						}
					//						else
					//						{
					//							childTable.ParentTableDescriptor.Appearance.RecordPlusMinusCell.ShowButtons= Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
					//						}
					//					}
					//					if(childTable.Name.Equals("Properties"))
					//					{
					//						string mode = e.Record.GetRecord().GetValue("ModeID") == null ? "" : e.Record.GetRecord().GetValue("ModeID").ToString();
					//						string sFilter;
					//						if(mode == "True")
					//						{
					//							sFilter = "IsDefault = false";
					//						}
					//						else
					//						{
					//							sFilter = "IsDefault = true";
					//						}
					//						_siteComponentPropertyValues.ItemFilter = sFilter;
					//
					//
					//					}
					//					if(childTable.Name.Equals("GroupedProperties") && sType.Equals("1"))
					//					{
					//						//childTable.ParentTableDescriptor.AllowEdit = false;
					//						groupPropertyeditFlag = false;
					//						childTable.ParentTableDescriptor.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
					//					}
					//					if(childTable.Name.Equals("GroupedProperties") && sType.Equals("2"))
					//					{
					//						//childTable.ParentTableDescriptor.AllowEdit = true;
					//						groupPropertyeditFlag = true;
					//						childTable.ParentTableDescriptor.Appearance.AnyCell.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Show;
					//
					//						if(e.Record.Kind == DisplayElementKind.AddNewRecord)
					//						{
					//							LRRSiteComponentGroupProperty lrrGroupProperty = new LRRSiteComponentGroupProperty();
					//							
					//							
					//							if(gnt.ParentRecord.GetValue("ID") != null)
					//								lrrGroupProperty.SiteComponentPropID =  gnt.ParentRecord.GetRecord().GetValue("ID").ToString();
					//							if(gnt.ParentRecord.GetValue("UOMTypeID") != null)
					//								lrrGroupProperty.UOMTypeID = gnt.ParentRecord.GetRecord().GetValue("UOMTypeID").ToString();
					////							if(gnt.ParentRecord.GetValue("Direction") != null)
					////								lrrGroupProperty.Direction =  gnt.ParentRecord.GetRecord().GetValue("Direction").ToString();
					////							if(gnt.ParentRecord.GetValue("Derivation") != null)
					////								lrrGroupProperty.Derivation =  gnt.ParentRecord.GetRecord().GetValue("Derivation").ToString();
					//							if(gnt.ParentRecord.GetValue("UOM") != null)
					//								lrrGroupProperty.UOM = gnt.ParentRecord.GetRecord().GetValue("UOM").ToString();
					//							lrrGroupProperty.ModeID = (bool)gnt.ParentRecord.GetRecord().GetValue("ModeID");
					//
					//							_siteCompGroupedProperties.Add(lrrGroupProperty);
					////							e.Table.LastChangedRecord.SetSelected(false);
					//						}
					//					}
					//					if(childTable.Name.Equals("GroupedProperties") && sType != "" && !(sType.Equals("1") || sType.Equals("2")))
					//					{
					//						childTable.ParentTableDescriptor.AllowNew = true;
					//						//childTable.ParentTableDescriptor.AllowEdit = true;
					//						groupPropertyeditFlag = true;
					//						childTable.ParentTableDescriptor.Columns["AttributeName"].ReadOnly = true;
					//						childTable.ParentTableDescriptor.Columns["AttributeDescription"].ReadOnly = true;
					//					}
				}
			}
		}
		private void gridSiteComponent_TableControlCurrentCellStartEditing(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
		{
			/*GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
			
			if(oCurrCellModel.GetType().Name.ToString() == "GridTableDropDownListCellModel")
			{
				GridTableModel tableModel = null;
				GridGroupingControl grid = sender as GridGroupingControl;
				if(grid.TableControl.Table.CurrentRecord == null)
				{
					Element eCurrentElement = grid.TableControl.Table.CurrentElement;
					GridNestedTable gnt = eCurrentElement as GridNestedTable;
					GridNestedTable gnt1 = gnt;
					GridTableDescriptor gtd = null;
					while(gnt1 != null && gnt1.ChildTable != null)
					{
						gnt = gnt1;
						gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
						gtd = gnt.ParentTable.ParentTableDescriptor;
					}

					GridChildTable childTable = gnt.ChildTable as GridChildTable;
					tableModel = childTable.ParentTable.TableModel;

				}
				if (e.TableControl.Table.TableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).HeaderText == "Uom Name")
				{
					string sUOMType = tableModel[e.TableControl.CurrentCell.RowIndex,4].Text;
					SourceListSet srcList = grid.SourceListSet;
					CustomCollection cust = (CustomCollection)(((LRRUOMs)(((IList)(((Syncfusion.Grouping.SourceListSetEntry)((srcList["UOM"]))).List)))));
					if(sUOMType == "")
						cust.ItemFilter = "";
					else
						cust.ItemFilter = "UOMTypeID = " + sUOMType ;
									
				}
			}*/
		}

        private void gridSiteComponent_TableControlCurrentCellShowingDropDown(object sender, GridTableControlCurrentCellShowingDropDownEventArgs e)
        {
            GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
            GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
            GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
            GridGroupingControl grid = sender as GridGroupingControl;
            if (tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
            {

                return;
            }
            GridTableModel tableModel = null;
            if (grid.TableControl.Table.CurrentRecord == null)
            {
                Element eCurrentElement = grid.TableControl.Table.CurrentElement;
                GridNestedTable gnt = eCurrentElement as GridNestedTable;
                GridNestedTable gnt1 = gnt;
                GridTableDescriptor gtd = null;
                while (gnt1 != null && gnt1.ChildTable != null)
                {
                    gnt = gnt1;
                    gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
                    gtd = gnt.ParentTable.ParentTableDescriptor;
                }

                GridChildTable childTable = gnt.ChildTable as GridChildTable;
                tableModel = childTable.ParentTable.TableModel;
                int iRow = e.TableControl.CurrentCell.RowIndex;
                int iCol = e.TableControl.CurrentCell.ColIndex;
                string sColHeader = "";
                if (tableModel.GetColumnDescriptorAt(iRow, iCol) != null)
                {
                    sColHeader = tableModel.GetColumnDescriptorAt(iRow, iCol).HeaderText;
                }
                if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex) == null)
                    return;

                if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex).MappingName == "UOM")
                {
                    string sUOMType = "";
                    try
                    {
                        sUOMType = ((LRRSiteComponentProperty)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID;
                    }
                    catch
                    {
                    }
                    if (sUOMType != "" && sUOMType != null)
                    {

                        LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
                        GridComboBoxCellRenderer cr = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
                        cr.ListBoxPart.DataSource = uoms;
                        uoms.SortColumn = "Name";
                        uoms.Sort();
                        cr.Model.SupportsChoiceList = false;
                        if (uoms.Count == 0)
                        {
                            e.TableControl.CurrentCell.ConfirmChanges();
                            LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        }
                    }
                }
                else if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex).MappingName == "UOMTypeID_Name")
                {
                    LRRSiteComponentProperty lscp = e.TableControl.Table.CurrentRecord.GetData() as LRRSiteComponentProperty;
                    if (lscp.Type != "1")
                    {
                        LRRMessagBox.ShowMessage(this, "SID_UOM_CHECK", "SID_LABLE", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        e.Inner.Cancel = true;
                    }
                }
                else if (sColHeader.Trim().ToUpper().StartsWith(LRRHeaderText.GetHeaderString("SID_UOM_TYPE").Trim().ToUpper())) //Added by Nidhig to restrict change of UOM type for Grouped Properties
                {
                    try
                    {
                        //Gets the current Site Component Property
                        LRRSiteComponentProperty objCompProp = e.TableControl.Table.CurrentRecord.GetData() as LRRSiteComponentProperty;

                        if (objCompProp.Type != "1" && objCompProp.Type != null)
                        {
                            LRRMessagBox.ShowMessage(this, "SID_UOM_CHECK", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            //e.TableControl.CurrentCell.ResetCurrentCellWithoutDeactivate();
                            e.Inner.Cancel = true;
                            return;
                        }
                    }
                    catch (Exception ex)
                    {
                        Logger.LogMessage(typeof(MasterPlantItems), "gridMasterPlantItems_TableControlCurrentCellCloseDropDown :" + ex.Message, Logger.Level.Debug);
                        return;
                    }
                }
                //--For EVVs
                /*if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).MappingName == "PropertyValue")
                {
                    string sUOMType = "";
                    try
                    {
                        sUOMType = gnt.ParentRecord.GetValue("UOMTypeID") == null ? "" : gnt.ParentRecord.GetValue("UOMTypeID").ToString();
                    }
                    catch
                    {
                    }
                    if(sUOMType != "" && sUOMType != null)
                    {
                        LRRUOMTypes lrrUOMTypes = new LRRUOMTypes();
                        _app.DBManagerObj.PopulateCollection(lrrUOMTypes," where ID = '" + sUOMType + "'",false);
                        LRRUOMType lrrUOMType = lrrUOMTypes[0];
                        if(lrrUOMType.IsEVV)
                        {
                            LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(sUOMType);
                            GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
                            cr.ListBoxPart.DataSource = evvs;
                            cr.ListBoxPart.DisplayMember = "EVV";
                            cr.ListBoxPart.ValueMember = "EVV";
                        }
                        else
                        {
                            e.Inner.Cancel = true;
                        }
                    }
                }*/
                //--End--
            }
            else
            {
                LRRSiteComponent siteComponent = tableCellInfo.Table.CurrentRecord.GetData() as LRRSiteComponent;
                LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(siteComponent.SiteComponentID);
                foreach (LRRSiteComponentProperty siteCompProperty in lscps)
                {
                    ArrayList arlist = null;
                    //Check for Simple Property
                    if (siteCompProperty.Type == "1")
                    {
                        arlist = LRRModel.CheckForSimplePropertyMapping(siteCompProperty);
                    }
                    else
                    {
                        arlist = LRRModel.CheckForMapping(siteCompProperty);
                    }
                    if (arlist != null && arlist.Count > 0)
                    {
                        LRRMessagBox.ShowMessage("SID_RESTRICT_CHANGE_MPI", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        for (int i = 0; i < arlist.Count; i++)
                        {
                            LRRHistPropCompPropMapping histPropCompPropMap = arlist[i] as LRRHistPropCompPropMapping;
                            Logger.LogMessage(histPropCompPropMap.ComponentPropertyName + "  Mapped With HistTag  " + histPropCompPropMap.HistTag, Logger.Level.Error);
                        }
                        e.Inner.Cancel = true;
                        break;
                    }
                }
            }
        }
		private void TableDescriptor_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			/*try
			{
				bool process = false;
				try
				{
					if(e.TableCellIdentity.Table.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex,e.TableCellIdentity.ColIndex).MappingName == "Uom Name")
					{
						process = true;
					}
				}
				catch
				{
					process = false;
					return;
				}
				if(process)
				{
					string sUOMType = "";
					try
					{
						sUOMType = ((LRRSiteComponentProperty)e.TableCellIdentity.Table.GetRecord().GetData()).UOMTypeID; 
					}
					catch
					{
					}
					if(sUOMType!= "")
					{
						LRRUOMs uoms = (LRRUOMs)_app.LRRDataStoreObj.GetCopyOfDataStoreObject(typeof(LRRUOMs));
						uoms.ItemFilter  = "UOMTypeID = " + sUOMType ;
						//e.TableControl.CurrentCell.Renderer.CurrentStyle.DataSource = uoms;	
						e.Style.DataSource = uoms;
					}
				}
			}*/
		}

		private void SiteComponentEntry_Activated(object sender, EventArgs e)
		{
			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
			LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteComponentPropertyValue).ToString();
			LRRFormulaDataStore.ModeFlag = true;
			LRRFormulaDataStore.ShowGroupedAttributes = true;//false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;
		}
		private void gridSiteComponent_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
			if(e.Inner.MouseEventArgs.Button == MouseButtons.Right
				&& e.TableControl.TableDescriptor.Name == "PropertyValues")
			{
				this.gridContext.Show(this.gridSiteComponent, this.gridSiteComponent.PointToClient(Control.MousePosition));

			}
//			GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
//			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
//			GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
//			if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
//			{
//				return;
//			}
			//GridTableModel tableModel = null;
			//GridGroupingControl grid = sender as GridGroupingControl;
			/*if(grid.TableControl.Table.CurrentRecord == null)
			{
//				Element eCurrentElement = grid.TableControl.Table.CurrentElement;
//				GridNestedTable gnt = eCurrentElement as GridNestedTable;
//				GridNestedTable gnt1 = gnt;
//				GridTableDescriptor gtd = null;
//				while(gnt1 != null && gnt1.ChildTable != null)
//				{
//					gnt = gnt1;
//					gnt1 = gnt.ChildTable.ParentTable.CurrentElement as GridNestedTable;
//					gtd = gnt.ParentTable.ParentTableDescriptor;
//				}
				
//				if(gnt == null)
//					return;
//				GridChildTable childTable = gnt.ChildTable as GridChildTable;
//				tableModel = childTable.ParentTable.TableModel;
//				
//				if(e.TableControl.CurrentCell.RowIndex == -1 || e.TableControl.CurrentCell.ColIndex == -1)
//					return;
//				if(tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex) == null)
//					return;

				/*if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).MappingName == "UOM")
				{
					string sUOMType = "";
					try
					{
						sUOMType = ((LRRSiteComponentProperty)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCellClick Event:"+ex.Message  ,Logger.Level.Debug);
					}
//					if(sUOMType != "" && sUOMType != null)
//					{
//
//						LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
//						GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
//						cr.ListBoxPart.DataSource = uoms;
//
//				// for multi user formila override
//
////						if(uoms.Count ==0)
////						{
////							e.TableControl.CurrentCell.ConfirmChanges();
////							//MessageBox.Show("UOM not defined for the selected UOM Type.");
////							LRRMessagBox.ShowMessage("SID_UOMNOTDEFINED","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
////						}
//
//					}
				}*/

				//--For EVVs
				/*if (tableModel.GetColumnDescriptorAt(e.TableControl.CurrentCell.RowIndex,e.TableControl.CurrentCell.ColIndex).MappingName == "PropertyValue")
				{
					string sUOMType = "";
					try
					{
						sUOMType = gnt.ParentRecord.GetValue("UOMTypeID") == null ? "" : gnt.ParentRecord.GetValue("UOMTypeID").ToString();
					}
					catch
					{
					}
					if(sUOMType != "" && sUOMType != null)
					{
						LRRUOMTypes lrrUOMTypes = new LRRUOMTypes();
						_app.DBManagerObj.PopulateCollection(lrrUOMTypes," where ID = '" + sUOMType + "'",false);
						LRRUOMType lrrUOMType = lrrUOMTypes[0];
						if(lrrUOMType.IsEVV)
						{
							LRREVVs evvs = LRRModel.ChildModel.GetEVVsFromUOMTypeID(sUOMType);
							GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
							cr.ListBoxPart.DataSource = evvs;
							cr.ListBoxPart.DisplayMember = "EVV";
							cr.ListBoxPart.ValueMember = "EVV";
						}
						else
						{
							e.Inner.Cancel = true;
						}
					}
				}*/
				//--End--
		//	}*/

		}

		public void AddToGroupGrid(LRRLookUpProperties lrrLookUpProperties)
		{
			LRRSiteComponentProperty lrrSiteComponentProperty = gridSiteComponent.TableControl.Table.GetInnerMostCurrentElement().GetData() as LRRSiteComponentProperty;
			
			foreach(LRRLookUpProperty lookUpProperty in lrrLookUpProperties)
			{
				LRRSiteComponentGroupProperty lrrGroupProperty = new LRRSiteComponentGroupProperty();
				lrrGroupProperty.AttributeName = lookUpProperty.Name;
				lrrGroupProperty.AttributeDescription = lookUpProperty.Description;
				lrrGroupProperty.PropertyID = lookUpProperty.PropertyID;
				lrrGroupProperty.LookUpPropertiesID = lookUpProperty.LookUpPropertiesID;
				lrrGroupProperty.MasterPropID = lrrSiteComponentProperty.PropertyID;
				lrrGroupProperty.SiteComponentPropID =  lrrSiteComponentProperty.ID;
				lrrGroupProperty.UOMTypeID = lrrSiteComponentProperty.UOMTypeID;
				//				lrrGroupProperty.Direction =  lrrSiteComponentProperty.Direction;
				//				lrrGroupProperty.Derivation =  lrrSiteComponentProperty.Derivation;
				lrrGroupProperty.ModeID = lrrSiteComponentProperty.ModeID;
				_siteCompGroupedProperties.Add(lrrGroupProperty);
			}
		}

		private void ChildTableDescriptor_GroupExpanding(object sender, GroupEventArgs e)
		{
			GridChildTable childTable = e.Group as GridChildTable;
			string sType = childTable.ParentNestedTable.ParentRecord.GetValue("Type").ToString();
			
			if(!(sType == "1"))
				e.Cancel = true;
		}
		private void gridSiteComponent_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
		  try
			   {
			     if ((e.TableCellIdentity.TableCellType == GridTableCellType.AnyRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell))  
			     {  
			             string toolTxtDes= LRRHeaderText.GetHeaderString("SID_"+e.Style.Text+"_DESC");  			 
			             e.Style.CellTipText = toolTxtDes ;  	//Tool tip 
			     }  
			  }
			catch(Exception ex)
			{
			   MessageBox.Show(ex.Message);
			}
			if(e.TableCellIdentity.RowIndex < 0)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex) == null)
				return;
			if(e.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.TableCellIdentity.RowIndex ,e.TableCellIdentity.ColIndex).HeaderText == LRRHeaderText.GetHeaderString("SID_LEVEL") && e.TableCellIdentity.RowIndex > 3)
			{
				e.Style.CellType = "DropDownTree";
				//e.Style.CellType = "DropDownTree";
				string displaymember = e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit") == null ? "" :e.TableCellIdentity.DisplayElement.GetRecord().GetValue("PlantUnit").ToString();          
				if(displaymember != "")
				{
					LRRLevel level = LRRModel.ChildModel.Levels.getLevelByLevelID(displaymember);
                    _levels.Add(level);
                    GridTableCellStyleInfo gsi = new GridTableCellStyleInfo();
					gsi = e.Style;
					if(gsi != null)
					{
						if(_levels.Count>0)
							gsi.FormattedText = _levels[0].Name;  
						gsi.WrapText = true;
						gsi.AutoSize = true;
					}	
                    _levels.Clear();
				}

			}
			
		}

		private void SiteComponentEntry_Activated_1(object sender, System.EventArgs e)
		{
			if(!initializing)
			{
//				oForAlerts = _app.LRRDataStoreObj.GetDataStoreObject("ObjectsChanged") as Hashtable;	
//				if((oForAlerts.Contains("LRRSiteComponentGroupProperty")) || (oForAlerts.Contains("LRRSiteComponentProperty")))
//				{
//					//MessageBox.Show("There are changes in data you are viewing \n Please commit your changes and refresh the screen.","Site Component Entry");
//					LRRMessagBox.ShowMessage("SID_COMMIT_CHANGES","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);      
//				}
			}
			LRRFormulaDataStore.DataSource = lrrFormulaSiteComponents;
			LRRFormulaDataStore.SourceCollectionName = typeof(LRRSiteComponentPropertyValue).ToString();
			LRRFormulaDataStore.ModeFlag = true;
			LRRFormulaDataStore.ObjectSource = typeof(LRRSiteComponent).ToString();
			LRRFormulaDataStore.ShowGroupedAttributes = true;//false;
			LRRFormulaDataStore.SourceLookupPropertyID = null;
			LRRFormulaDataStore.SourceLookupQualifierID = null;
			initializing = false;
		}

		private void gridSiteComponent_TableControlCurrentCellKeyPress(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyPressEventArgs e)
		{
			if(e.TableControl.TableDescriptor.Name == "PropertyValues" && !editFlag)
			{
				e.Inner.Handled = true;
			}
			if(e.TableControl.TableDescriptor.Name == "PropertyValues")
			{
				Record rec=e.TableControl.Table.CurrentRecord as Record;
				LRRSiteComponentPropertyValue prop= e.TableControl.Table.CurrentRecord.GetData() as LRRSiteComponentPropertyValue;
				if(prop.Direction==null ||prop.Direction=="" || prop.Direction=="2")
					e.Inner.Handled = true;
				else
					e.Inner.Handled = false;
			}
			
			//			if(e.TableControl.TableDescriptor.Name == "GroupedProperties" && !groupPropertyeditFlag)
			//			{
			//				e.Inner.Handled = true;
			//			}
		}
		
		private void gridSiteComponent_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
		{
			try
			{
				if(e.Inner.KeyCode==Keys.Tab || e.Inner.KeyCode==Keys.Left || e.Inner.KeyCode==Keys.Right|| e.Inner.KeyCode==Keys.Up || e.Inner.KeyCode==Keys.Down)
				{
					return;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCurrentCellKeyDown Event:"+ex.Message  ,Logger.Level.Debug);
			}
			if(e.TableControl.TableDescriptor.Name == "PropertyValues" && !editFlag)
			{
				e.Inner.Handled = true;
			}
			//			if(e.TableControl.TableDescriptor.Name == "GroupedProperties" && !groupPropertyeditFlag)
			//			{
			//				e.Inner.Handled = true;
			//			}
			try
			{
				int iCol = e.TableControl.CurrentCell.ColIndex - e.TableControl.TableDescriptor.GetColumnIndentCount();
				if(iCol > 0)
				{
					if(e.TableControl.TableDescriptor.Columns[iCol].FieldDescriptor.IsRelatedField())
						e.Inner.Handled = true;
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(SiteComponentEntry),"gridSiteComponent_TableControlCurrentCellKeyDown Event:"+ex.Message  ,Logger.Level.Debug);
			}
		}

		private void ChildTableDescriptor_RecordExpanding(object sender, RecordEventArgs e)
		{
			string sPropertyType = e.Record.GetValue("Type") == null ? "" : e.Record.GetValue("Type").ToString();
		
			if((sPropertyType != "0") && (sPropertyType != "1") && (sPropertyType != "2") && (sPropertyType != ""))
			{
				e.Record.GetRecord().NestedTables["GroupedProperties"].IsExpanded = false;
			}
			
		}
		private void ChildTableDescriptor_RecordCollapsing(object sender, RecordEventArgs e)
		{
			string sPropertyType = e.Record.GetValue("Type") == null ? "" : e.Record.GetValue("Type").ToString();
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add SiteComponentEntry.ClearSort implementation
			SyncGridUtilities.ClearSort(gridSiteComponent);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add SiteComponentEntry.SupportsClearSort implementation
			return true;
		}

		#endregion
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add SiteComponentEntry.PrintPreview implementation
			if(gridSiteComponent.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridSiteComponent,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add SiteComponentEntry.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add SiteComponentEntry.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add SiteComponentEntry.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add SiteComponentEntry.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add SiteComponentEntry.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add SiteComponentEntry.Undo implementation
            SyncGridUtilities.RollBackChanges(this.gridSiteComponent);
            Refresh();
            InitializeGrid();
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add SiteComponentEntry.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add SiteComponentEntry.SupportsUndo implementation
			return true;
		}

		#endregion

		
		private void gridSiteComponent_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{

		}

		private void gridSiteComponent_TableControlKeyUp(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlKeyEventArgs e)
		{
//			LRRSiteComponentProperties deletedSiteCompProperties = ;

			
			if(e.Inner.KeyCode == Keys.Delete)
			{
				if(_siteCompProperties.DeletedItems.Count >0)
				{
					//LRRSiteComponents deletedSiteComponents = _siteComponents.GetChanges();
					foreach(LRRSiteComponentProperty deletedSiteCompProperty in _siteCompProperties.DeletedItems)
					{
						LRRHistPropCompPropMappings hisCompPropMappings = LRRModel.HistPropMaps.FilterBySiteCompPropID(deletedSiteCompProperty.ID);
						if(hisCompPropMappings.Count >0)
						{
							for(int i = hisCompPropMappings.Count; i>0;i--)
							{
								LRRHistPropCompPropMapping toDeleteHisMap = hisCompPropMappings[i-1] as LRRHistPropCompPropMapping;
								LRRModel.HistPropMaps.Remove(toDeleteHisMap);
							}
						}
					}
				}
			}
		}
		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add SiteComponentEntry.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add SiteComponentEntry.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add SiteComponentEntry.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add SiteComponentEntry.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add SiteComponentEntry.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add SiteComponentEntry.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add SiteComponentEntry.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add SiteComponentEntry.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add SiteComponentEntry.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private void gridSiteComponent_TableControlQueryAllowSortColumn(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryAllowSortColumnEventArgs e)
		{
			if(e.TableControl.TableDescriptor.Name == "PropertyValues")
			{
				e.AllowSort = false;
			}
		}

		private void menuoverrideformula_Click(object sender, System.EventArgs e)
		{
			OverrideFormulaWindow ofw = new OverrideFormulaWindow();
			ofw.ShowDialog();
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add SiteComponentEntry.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
