//public class SiteComponentGroupProperty : System.Windows.Forms.Form,ILRRUIContainer
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.Utils.HeaderDispatcher; 

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Drawing;

using Symcon.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for SiteComponentGroupProperty.
	/// </summary>
	public class SiteComponentGroupProperty : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel				panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridQualifierValue;
		private LRRApp									_app;
		private LRRSiteGroupPropertyQualifierValues		_objQualifierValues;
		private LRRHistDatas							_lrrHist;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SiteComponentGroupProperty(LRRSiteGroupPropertyQualifierValues collectionBase)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			
			_objQualifierValues = collectionBase;
			
			gridQualifierValue.DataSource = _objQualifierValues;
			_lrrHist = LRRModel.HistDatas;
			
			SyncGridUtilities.InitializeGridLookAndFeel(gridQualifierValue);
//			
//			
//			Hashtable fkColumns;
//			Hashtable childColumns;
//			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_objQualifierValues.ItemType,out fkColumns,out childColumns);
//			Hashtable fkData = new Hashtable();
//			foreach(object obj in fkColumns.Keys)
//			{
//				string propName = (string)obj;
//				SymForeignKeyFieldAttribute fkAttr = fkColumns[obj] as SymForeignKeyFieldAttribute;
//				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
//				_app.DBManagerObj.PopulateCollection(collectionObject,false);
//				fkData.Add(propName,collectionObject);
//			}
//			Hashtable columnForDisplay=new Hashtable();
//			columnForDisplay.Add("ModeID",null);
//			columnForDisplay.Add("Direction",null);
//			columnForDisplay.Add("Derivation",null);
//			columnForDisplay.Add("EffectivePlantTime",null);
//			columnForDisplay.Add("FormulaObj",null);
//			
//
//			//Populate the columns for the grid object
//			SyncGridUtilities.InitializeGridColumns(gridQualifierValue,_objQualifierValues.ItemType,null,true,columnForDisplay,fkData);
//			
			SyncGridUtilities.InitializeGridColumns(gridQualifierValue,_objQualifierValues.ItemType,null);
			
			this.gridQualifierValue.TableModel.Model.HideCols["Mode"]=true;
			//this.gridQualifierValue.TableDescriptor.Columns["HistTagID"].ReadOnly = true;
			GridTableCellStyleInfo gtc = gridQualifierValue.TableDescriptor.Columns["HistTagID"].Appearance.AnyRecordFieldCell;
			gtc.ShowButtons	= Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			gtc.ReadOnly = true;
			gtc.CellType = "ComboBox";
			gtc.DisplayMember =	"HistTag";
			gtc.ValueMember	= "HistTagUID";
			gtc.ReadOnly = true;
			gtc.DataSource = _lrrHist;
			gtc.AutoSize=true;
			this.gridQualifierValue.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_SITECOMPGRPPROPQUALVAL")+"  {RecordCount} " +LRRHeaderText.GetHeaderString("SID_ITEMS");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SiteComponentGroupProperty));
			this.panel1 = new System.Windows.Forms.Panel();
			this.gridQualifierValue = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridQualifierValue)).BeginInit();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.gridQualifierValue);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(474, 224);
			this.panel1.TabIndex = 0;
			// 
			// gridQualifierValue
			// 
			this.gridQualifierValue.BackColor = System.Drawing.SystemColors.Window;
			this.gridQualifierValue.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridQualifierValue.Location = new System.Drawing.Point(0, 0);
			this.gridQualifierValue.Name = "gridQualifierValue";
			this.gridQualifierValue.Size = new System.Drawing.Size(474, 224);
			this.gridQualifierValue.TabIndex = 1;
			this.gridQualifierValue.TableDescriptor.AllowNew = false;
			this.gridQualifierValue.TableDescriptor.AllowRemove = false;
			this.gridQualifierValue.TableDescriptor.Appearance.AddNewRecordRowHeaderCell.AllowEnter = false;
			this.gridQualifierValue.TableDescriptor.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridQualifierValue.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridQualifierValue.TableDescriptor.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridQualifierValue.TableDescriptor.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridQualifierValue.TableDescriptor.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridQualifierValue.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridQualifierValue.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridQualifierValue.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.None;
			this.gridQualifierValue.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridQualifierValue.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.None;
			this.gridQualifierValue.Text = "gridQualifierValue";
			this.gridQualifierValue.ThemesEnabled = false;
			this.gridQualifierValue.TopLevelGroupOptions.CaptionText = "Site Component Group Property Qualifier Value: {RecordCount} Items";
			this.gridQualifierValue.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridQualifierValue.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridQualifierValue.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridQualifierValue.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridQualifierValue.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridQualifierValue.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridQualifierValue.VersionInfo = "3.301.0.0";
			// 
			// SiteComponentGroupProperty
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(474, 164);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "SiteComponentGroupProperty";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_SITECOMPGRPPROPQUALVAL";
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridQualifierValue)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		


		
	}
}

	