using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.Reflection;
using System.Xml.XPath;
using System.Text;
using System.IO;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.TestAutomation;

namespace Symcon.LightRidge.PEAdvisor.TestAutomation
{
	[Flags()]
	public enum TestConditionEnum
	{
		I=1,
		U=2,
		D=4
	}

	
	/// <summary>
	/// Summary description for FunctionTest.
	/// </summary>
	/// 
	public class FunctionTest : System.Windows.Forms.Form
	{
		# region Member Fields
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtTestTemplate;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.Button btnLoad;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel pnlMain;
		private System.Windows.Forms.Panel pnlLocation;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel pnlTestScenarios;
		private System.Windows.Forms.Panel pnlTreeview;
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Panel pnlTestDetails;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label lblTestID;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtCondition;
		private System.Windows.Forms.TextBox txtScreenName;
		private System.Windows.Forms.TextBox txtTestID;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtScreenID;
		private System.Windows.Forms.CheckBox chkUseTestSequence;
		private System.Windows.Forms.DataGrid dgTestCases;
		TreeNode oSelectedNode= null;
		Assembly boAssembly = null;
		private XmlDocument  oXML = new XmlDocument();
		private System.Windows.Forms.Label lblBatchDesc;
		private DataTable _dtBatchCases = null;
		private SaveBatch frmSaveBatch = null;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Button btnValidate;
		private System.Windows.Forms.Button btnBatchTest;
		private System.Windows.Forms.Button btnGenerateXML;
		private System.Windows.Forms.Button btnPerformTest;
		private System.Windows.Forms.Button btnGenerateDataFiles;
		private LRRApp _lrrApp;

		#endregion

		public FunctionTest()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp; //Get the App Object..
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.label1 = new System.Windows.Forms.Label();
			this.txtTestTemplate = new System.Windows.Forms.TextBox();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.btnLoad = new System.Windows.Forms.Button();
			this.pnlMain = new System.Windows.Forms.Panel();
			this.pnlTestScenarios = new System.Windows.Forms.Panel();
			this.pnlTestDetails = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.btnValidate = new System.Windows.Forms.Button();
			this.btnBatchTest = new System.Windows.Forms.Button();
			this.btnGenerateXML = new System.Windows.Forms.Button();
			this.btnPerformTest = new System.Windows.Forms.Button();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.lblBatchDesc = new System.Windows.Forms.Label();
			this.dgTestCases = new System.Windows.Forms.DataGrid();
			this.txtScreenID = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.txtCondition = new System.Windows.Forms.TextBox();
			this.txtScreenName = new System.Windows.Forms.TextBox();
			this.txtTestID = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.lblTestID = new System.Windows.Forms.Label();
			this.pnlTreeview = new System.Windows.Forms.Panel();
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.pnlLocation = new System.Windows.Forms.Panel();
			this.chkUseTestSequence = new System.Windows.Forms.CheckBox();
			this.btnGenerateDataFiles = new System.Windows.Forms.Button();
			this.pnlMain.SuspendLayout();
			this.pnlTestScenarios.SuspendLayout();
			this.pnlTestDetails.SuspendLayout();
			this.panel2.SuspendLayout();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dgTestCases)).BeginInit();
			this.pnlTreeview.SuspendLayout();
			this.pnlLocation.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 12);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(144, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Select Test Template";
			// 
			// txtTestTemplate
			// 
			this.txtTestTemplate.BackColor = System.Drawing.Color.OldLace;
			this.txtTestTemplate.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtTestTemplate.Location = new System.Drawing.Point(160, 12);
			this.txtTestTemplate.Name = "txtTestTemplate";
			this.txtTestTemplate.Size = new System.Drawing.Size(392, 20);
			this.txtTestTemplate.TabIndex = 1;
			this.txtTestTemplate.Text = "";
			// 
			// btnBrowse
			// 
			this.btnBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnBrowse.BackColor = System.Drawing.SystemColors.Control;
			this.btnBrowse.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnBrowse.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnBrowse.Location = new System.Drawing.Point(560, 11);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.TabIndex = 2;
			this.btnBrowse.Text = "Br&owse";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// btnLoad
			// 
			this.btnLoad.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnLoad.BackColor = System.Drawing.SystemColors.Control;
			this.btnLoad.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnLoad.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnLoad.Location = new System.Drawing.Point(640, 11);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.Size = new System.Drawing.Size(136, 23);
			this.btnLoad.TabIndex = 3;
			this.btnLoad.Text = "&Load Test Scenario";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// pnlMain
			// 
			this.pnlMain.Controls.Add(this.pnlTestScenarios);
			this.pnlMain.Controls.Add(this.splitter1);
			this.pnlMain.Controls.Add(this.pnlLocation);
			this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMain.Location = new System.Drawing.Point(0, 0);
			this.pnlMain.Name = "pnlMain";
			this.pnlMain.Size = new System.Drawing.Size(786, 584);
			this.pnlMain.TabIndex = 4;
			// 
			// pnlTestScenarios
			// 
			this.pnlTestScenarios.Controls.Add(this.pnlTestDetails);
			this.pnlTestScenarios.Controls.Add(this.pnlTreeview);
			this.pnlTestScenarios.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlTestScenarios.Location = new System.Drawing.Point(0, 66);
			this.pnlTestScenarios.Name = "pnlTestScenarios";
			this.pnlTestScenarios.Size = new System.Drawing.Size(786, 518);
			this.pnlTestScenarios.TabIndex = 6;
			// 
			// pnlTestDetails
			// 
			this.pnlTestDetails.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlTestDetails.Controls.Add(this.panel2);
			this.pnlTestDetails.Controls.Add(this.splitter2);
			this.pnlTestDetails.Controls.Add(this.panel1);
			this.pnlTestDetails.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlTestDetails.Location = new System.Drawing.Point(280, 0);
			this.pnlTestDetails.Name = "pnlTestDetails";
			this.pnlTestDetails.Size = new System.Drawing.Size(506, 518);
			this.pnlTestDetails.TabIndex = 1;
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.panel2.Controls.Add(this.btnGenerateDataFiles);
			this.panel2.Controls.Add(this.btnValidate);
			this.panel2.Controls.Add(this.btnBatchTest);
			this.panel2.Controls.Add(this.btnGenerateXML);
			this.panel2.Controls.Add(this.btnPerformTest);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(0, 458);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(504, 58);
			this.panel2.TabIndex = 4;
			// 
			// btnValidate
			// 
			this.btnValidate.BackColor = System.Drawing.SystemColors.Control;
			this.btnValidate.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnValidate.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnValidate.Location = new System.Drawing.Point(112, 24);
			this.btnValidate.Name = "btnValidate";
			this.btnValidate.Size = new System.Drawing.Size(88, 23);
			this.btnValidate.TabIndex = 5;
			this.btnValidate.Text = "&Validate XML";
			this.btnValidate.Click += new System.EventHandler(this.btnValidate_Click);
			// 
			// btnBatchTest
			// 
			this.btnBatchTest.BackColor = System.Drawing.SystemColors.Control;
			this.btnBatchTest.Enabled = false;
			this.btnBatchTest.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnBatchTest.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnBatchTest.Location = new System.Drawing.Point(304, 24);
			this.btnBatchTest.Name = "btnBatchTest";
			this.btnBatchTest.Size = new System.Drawing.Size(96, 23);
			this.btnBatchTest.TabIndex = 3;
			this.btnBatchTest.Text = "Define &Batch";
			this.btnBatchTest.Click += new System.EventHandler(this.btnBatchTest_Click);
			// 
			// btnGenerateXML
			// 
			this.btnGenerateXML.BackColor = System.Drawing.SystemColors.Control;
			this.btnGenerateXML.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnGenerateXML.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnGenerateXML.Location = new System.Drawing.Point(8, 24);
			this.btnGenerateXML.Name = "btnGenerateXML";
			this.btnGenerateXML.Size = new System.Drawing.Size(96, 23);
			this.btnGenerateXML.TabIndex = 2;
			this.btnGenerateXML.Text = "&Generate XML";
			this.btnGenerateXML.Click += new System.EventHandler(this.btnGenerateXML_Click);
			// 
			// btnPerformTest
			// 
			this.btnPerformTest.BackColor = System.Drawing.SystemColors.Control;
			this.btnPerformTest.Enabled = false;
			this.btnPerformTest.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnPerformTest.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnPerformTest.Location = new System.Drawing.Point(408, 24);
			this.btnPerformTest.Name = "btnPerformTest";
			this.btnPerformTest.Size = new System.Drawing.Size(88, 23);
			this.btnPerformTest.TabIndex = 0;
			this.btnPerformTest.Text = "&Perform Test";
			this.btnPerformTest.Click += new System.EventHandler(this.btnPerformTest_Click);
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(0, 456);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(504, 2);
			this.splitter2.TabIndex = 2;
			this.splitter2.TabStop = false;
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.panel1.Controls.Add(this.splitter3);
			this.panel1.Controls.Add(this.lblBatchDesc);
			this.panel1.Controls.Add(this.dgTestCases);
			this.panel1.Controls.Add(this.txtScreenID);
			this.panel1.Controls.Add(this.label4);
			this.panel1.Controls.Add(this.txtCondition);
			this.panel1.Controls.Add(this.txtScreenName);
			this.panel1.Controls.Add(this.txtTestID);
			this.panel1.Controls.Add(this.label3);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Controls.Add(this.lblTestID);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(504, 456);
			this.panel1.TabIndex = 1;
			// 
			// splitter3
			// 
			this.splitter3.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter3.Location = new System.Drawing.Point(0, 156);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(504, 4);
			this.splitter3.TabIndex = 11;
			this.splitter3.TabStop = false;
			// 
			// lblBatchDesc
			// 
			this.lblBatchDesc.BackColor = System.Drawing.Color.OldLace;
			this.lblBatchDesc.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.lblBatchDesc.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblBatchDesc.ForeColor = System.Drawing.SystemColors.ControlText;
			this.lblBatchDesc.Location = new System.Drawing.Point(0, 160);
			this.lblBatchDesc.Name = "lblBatchDesc";
			this.lblBatchDesc.Size = new System.Drawing.Size(504, 16);
			this.lblBatchDesc.TabIndex = 10;
			this.lblBatchDesc.Text = "Test Cases In The Selected Batch";
			this.lblBatchDesc.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.lblBatchDesc.Visible = false;
			// 
			// dgTestCases
			// 
			this.dgTestCases.AlternatingBackColor = System.Drawing.Color.WhiteSmoke;
			this.dgTestCases.BackColor = System.Drawing.Color.Gainsboro;
			this.dgTestCases.BackgroundColor = System.Drawing.Color.DarkGray;
			this.dgTestCases.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.dgTestCases.CaptionBackColor = System.Drawing.Color.DarkKhaki;
			this.dgTestCases.CaptionFont = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.dgTestCases.CaptionForeColor = System.Drawing.Color.Black;
			this.dgTestCases.CaptionVisible = false;
			this.dgTestCases.DataMember = "";
			this.dgTestCases.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.dgTestCases.FlatMode = true;
			this.dgTestCases.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.dgTestCases.ForeColor = System.Drawing.Color.Black;
			this.dgTestCases.GridLineColor = System.Drawing.Color.Silver;
			this.dgTestCases.HeaderBackColor = System.Drawing.Color.DimGray;
			this.dgTestCases.HeaderFont = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.dgTestCases.HeaderForeColor = System.Drawing.Color.White;
			this.dgTestCases.LinkColor = System.Drawing.Color.DarkSlateBlue;
			this.dgTestCases.Location = new System.Drawing.Point(0, 176);
			this.dgTestCases.Name = "dgTestCases";
			this.dgTestCases.ParentRowsBackColor = System.Drawing.Color.LightGray;
			this.dgTestCases.ParentRowsForeColor = System.Drawing.Color.DimGray;
			this.dgTestCases.PreferredColumnWidth = 190;
			this.dgTestCases.PreferredRowHeight = 20;
			this.dgTestCases.ReadOnly = true;
			this.dgTestCases.RowHeaderWidth = 20;
			this.dgTestCases.SelectionBackColor = System.Drawing.Color.NavajoWhite;
			this.dgTestCases.SelectionForeColor = System.Drawing.Color.Black;
			this.dgTestCases.Size = new System.Drawing.Size(504, 280);
			this.dgTestCases.TabIndex = 9;
			this.dgTestCases.Visible = false;
			this.dgTestCases.MouseUp += new System.Windows.Forms.MouseEventHandler(this.dgTestCases_MouseUp);
			// 
			// txtScreenID
			// 
			this.txtScreenID.BackColor = System.Drawing.Color.OldLace;
			this.txtScreenID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtScreenID.Enabled = false;
			this.txtScreenID.Location = new System.Drawing.Point(120, 80);
			this.txtScreenID.Name = "txtScreenID";
			this.txtScreenID.Size = new System.Drawing.Size(40, 20);
			this.txtScreenID.TabIndex = 8;
			this.txtScreenID.Text = "";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(16, 80);
			this.label4.Name = "label4";
			this.label4.TabIndex = 7;
			this.label4.Text = "Screen ID";
			// 
			// txtCondition
			// 
			this.txtCondition.BackColor = System.Drawing.Color.OldLace;
			this.txtCondition.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtCondition.Enabled = false;
			this.txtCondition.Location = new System.Drawing.Point(120, 112);
			this.txtCondition.Name = "txtCondition";
			this.txtCondition.Size = new System.Drawing.Size(40, 20);
			this.txtCondition.TabIndex = 6;
			this.txtCondition.Text = "";
			// 
			// txtScreenName
			// 
			this.txtScreenName.BackColor = System.Drawing.Color.OldLace;
			this.txtScreenName.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtScreenName.Enabled = false;
			this.txtScreenName.Location = new System.Drawing.Point(120, 48);
			this.txtScreenName.Name = "txtScreenName";
			this.txtScreenName.Size = new System.Drawing.Size(304, 20);
			this.txtScreenName.TabIndex = 5;
			this.txtScreenName.Text = "";
			// 
			// txtTestID
			// 
			this.txtTestID.BackColor = System.Drawing.Color.OldLace;
			this.txtTestID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtTestID.Enabled = false;
			this.txtTestID.Location = new System.Drawing.Point(120, 16);
			this.txtTestID.Name = "txtTestID";
			this.txtTestID.Size = new System.Drawing.Size(304, 20);
			this.txtTestID.TabIndex = 4;
			this.txtTestID.Text = "";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(16, 112);
			this.label3.Name = "label3";
			this.label3.TabIndex = 2;
			this.label3.Text = "Test Operation";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(16, 48);
			this.label2.Name = "label2";
			this.label2.TabIndex = 1;
			this.label2.Text = "Screen Name";
			// 
			// lblTestID
			// 
			this.lblTestID.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTestID.Location = new System.Drawing.Point(16, 16);
			this.lblTestID.Name = "lblTestID";
			this.lblTestID.TabIndex = 0;
			this.lblTestID.Text = "Test Case ID";
			// 
			// pnlTreeview
			// 
			this.pnlTreeview.Controls.Add(this.treeView1);
			this.pnlTreeview.Dock = System.Windows.Forms.DockStyle.Left;
			this.pnlTreeview.Location = new System.Drawing.Point(0, 0);
			this.pnlTreeview.Name = "pnlTreeview";
			this.pnlTreeview.Size = new System.Drawing.Size(280, 518);
			this.pnlTreeview.TabIndex = 0;
			// 
			// treeView1
			// 
			this.treeView1.BackColor = System.Drawing.SystemColors.Window;
			this.treeView1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.treeView1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.treeView1.ForeColor = System.Drawing.SystemColors.ActiveCaption;
			this.treeView1.ImageIndex = -1;
			this.treeView1.Location = new System.Drawing.Point(0, 0);
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = -1;
			this.treeView1.Size = new System.Drawing.Size(280, 518);
			this.treeView1.TabIndex = 0;
			this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
			// 
			// splitter1
			// 
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 64);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(786, 2);
			this.splitter1.TabIndex = 5;
			this.splitter1.TabStop = false;
			// 
			// pnlLocation
			// 
			this.pnlLocation.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.pnlLocation.Controls.Add(this.chkUseTestSequence);
			this.pnlLocation.Controls.Add(this.btnBrowse);
			this.pnlLocation.Controls.Add(this.btnLoad);
			this.pnlLocation.Controls.Add(this.label1);
			this.pnlLocation.Controls.Add(this.txtTestTemplate);
			this.pnlLocation.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlLocation.Location = new System.Drawing.Point(0, 0);
			this.pnlLocation.Name = "pnlLocation";
			this.pnlLocation.Size = new System.Drawing.Size(786, 64);
			this.pnlLocation.TabIndex = 4;
			// 
			// chkUseTestSequence
			// 
			this.chkUseTestSequence.BackColor = System.Drawing.Color.Transparent;
			this.chkUseTestSequence.Enabled = false;
			this.chkUseTestSequence.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.chkUseTestSequence.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.chkUseTestSequence.Location = new System.Drawing.Point(8, 40);
			this.chkUseTestSequence.Name = "chkUseTestSequence";
			this.chkUseTestSequence.Size = new System.Drawing.Size(184, 24);
			this.chkUseTestSequence.TabIndex = 4;
			this.chkUseTestSequence.Text = "Run Test As Batch Test Case ";
			this.chkUseTestSequence.CheckedChanged += new System.EventHandler(this.chkUseTestSequence_CheckedChanged);
			// 
			// btnGenerateDataFiles
			// 
			this.btnGenerateDataFiles.BackColor = System.Drawing.SystemColors.Control;
			this.btnGenerateDataFiles.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnGenerateDataFiles.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnGenerateDataFiles.Location = new System.Drawing.Point(208, 24);
			this.btnGenerateDataFiles.Name = "btnGenerateDataFiles";
			this.btnGenerateDataFiles.Size = new System.Drawing.Size(88, 23);
			this.btnGenerateDataFiles.TabIndex = 6;
			this.btnGenerateDataFiles.Text = "Cr&eate Data";
			this.btnGenerateDataFiles.Click += new System.EventHandler(this.btnGenerateDataFiles_Click);
			// 
			// FunctionTest
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.ClientSize = new System.Drawing.Size(786, 584);
			this.Controls.Add(this.pnlMain);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "FunctionTest";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "FunctionTest";
			this.Load += new System.EventHandler(this.FunctionTest_Load);
			this.pnlMain.ResumeLayout(false);
			this.pnlTestScenarios.ResumeLayout(false);
			this.pnlTestDetails.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dgTestCases)).EndInit();
			this.pnlTreeview.ResumeLayout(false);
			this.pnlLocation.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		# region Form Private Methods
		
		/// <summary>
		/// This method is invoked to render the treeview control
		/// </summary>
		private void RenderTreeView()
		{
			treeView1.SuspendLayout();
			treeView1.Sorted = true;
			treeView1.Nodes.Clear();
			int[] folders =	new	int[1];
			folders[0] = 0;
			int[] leaf = new int[1];
			leaf[0]	= 1;
			TreeNode tnav = new TreeNode();
			tnav.Tag = oXML.DocumentElement;
			tnav.Text = oXML.DocumentElement.Name;
			tnav.Expand();
			DisplayTree(oXML.DocumentElement,tnav);
			treeView1.Nodes.Add(tnav);
			treeView1.ResumeLayout(true);
		}
		
		
		/// <summary>
		/// This method is used for rendering the tree view control for the loaded test scenarios XML
		/// </summary>
		/// <param name="node"></param>
		/// <param name="tnav"></param>
		private void DisplayTree(XmlNode node,TreeNode tnav)
		{

			if (node.HasChildNodes)
			{
				node = node.FirstChild;
				
				while (node != null)
				{
					TreeNode child = new TreeNode();
					
					if(node.Name.Equals("BatchTestCase"))
						child.ForeColor = Color.Maroon;

					if(node.ChildNodes.Count >0)
						child.Text = node.Name + "[" + node.ChildNodes.Item(0).InnerText + "]";
					else
						child.Text = node.Name;
					child.Tag = node;
					DisplayTree(node,child);
					tnav.Nodes.Add(child);
					node = node.NextSibling;
				}
				
			}
		}
		
		
		/// <summary>
		/// Verify Test Results
		/// </summary>
		/// <param name="oNode"></param>
		private void VerifyTestResults(XmlNode oNode)
		{
			//_lrrApp.DBManagerObj.DataAdapterObj.ExecuteQuery("DELETE FROM TestResults");

			string sTestName = oNode.SelectSingleNode("ID").InnerText;
			XmlNodeList oNodes = oNode.SelectNodes("ExpectedResult/TableName");
			foreach(XmlNode oCurrElement in oNodes)
			{
				string sSource = oCurrElement.SelectSingleNode("SourceOfValue").InnerText;
				switch(sSource)
				{
					case "F":
						string sFName = oCurrElement.SelectSingleNode("Path").InnerText;
						if(sFName != "")
							VerifyFromFlatFile(oNode,oCurrElement,sFName,sTestName);
						break;
					case "T":
						UserTextInput(oCurrElement);
						break;
					default:
						break;
				}
			}
		}
		/// <summary>
		/// This method performs verification of the test results
		/// </summary>
		/// <param name="oCurrElement"></param>
		/// <param name="sFName"></param>
		/// <param name="sOperation"></param>
		/// <param name="sModel"></param>
		private void VerifyFromFlatFile(XmlNode oParentElement,XmlNode oCurrElement, string sFName,string sTestID)
		{
			string sWhereClause = "";
			string sSelect = "SELECT 1 ";
			string sSelectFrom = "";
			//string sQuery = "";
			bool bTestFailed = false;
			if(oCurrElement.SelectSingleNode("Name") != null)
			{
				sSelectFrom = " FROM " + oCurrElement.SelectSingleNode("Name").InnerText;

				//Load File and extract Data for the fields from the file.
				using (CSVParser csv = new CSVParser(sFName)) 
				{
					string[] fields;
					string sFieldName = "";
					

					while ((fields = csv.GetCSVLine()) != null) 
					{
						StringBuilder sqlVerify = new StringBuilder(2000);
						sqlVerify.Append(sSelect);
						sqlVerify.Append(sSelectFrom);

						int nColumns = fields.Length;
						int nCurrentCol = 0;
						string sShouldExists = fields[0].ToString();

						XmlNodeList oNodes = oCurrElement.SelectSingleNode("Fields").SelectNodes("Field");
						for(int nCtr = 1; nCtr < nColumns;	nCtr++)		
						//foreach (string field in fields)
						{
							string field = fields[nCtr].ToString();

							XmlNode oChildElement = oNodes[nCurrentCol] as XmlNode;
							sFieldName = oChildElement.SelectSingleNode("Name").InnerText;
							if (sWhereClause.Equals(""))
							{
								sWhereClause = " WHERE " + sFieldName  + " = '" + field + "'";
							}
							else
							{
								sWhereClause = sWhereClause + " AND " + sFieldName  + " = '" + field + "'";
							}

							nCurrentCol = nCurrentCol + 1;
							if(nCurrentCol + 1 == 	nColumns)
								break;
						}
						
						sqlVerify.Append(sWhereClause);
						sWhereClause = "";
						IDataReader idr = _lrrApp.DBManagerObj.DataAdapterObj.GetDataReader(sqlVerify.ToString());
						if(idr != null)
						{
							while(idr.Read())
							{
								if(sShouldExists.Equals("N"))
								{
									bTestFailed = true;
									break;
								}

							}
						}
						else
						{
							if(sShouldExists.Equals("Y"))
								bTestFailed = true;
						}

						if(bTestFailed)
							break;
					}
				
				}
			}
//			if(bTestFailed)
//				sQuery = "INSERT INTO TestResults VALUES('" + sTestID + "','FAILED')";
//			else
//				sQuery = "INSERT INTO TestResults VALUES('" + sTestID + "','PASSED')";
//
//			_lrrApp.DBManagerObj.DataAdapterObj.ExecuteQuery(sQuery);
			
			XmlNodeList oNodesToUpdate = oXML.SelectNodes("//TestCase[ID = '" + sTestID + "']");

			if(bTestFailed)
			{
				foreach(XmlNode oFailedElement in oNodesToUpdate)
				{
					oFailedElement.SelectSingleNode("Status").InnerText = "Failed";
				}
			}
			else
			{
				foreach(XmlNode oPassedElement in oNodesToUpdate)
				{
					oPassedElement.SelectSingleNode("Status").InnerText = "Passed";
				}
			}
	
		}
		/// <summary>
		/// Performs the test operation based on the selected node
		/// </summary>
		/// <param name="oTNode"></param>
		private void CreateTestForCondition(TreeNode oTNode)
		{
			XmlNode oNode = oTNode.Tag as XmlNode;
			XmlNodeList oNodes = oNode.SelectNodes("TableName");
			string sCondition = oNode.SelectSingleNode("Condition").InnerText;
			string sModel = "true";
			if(oNode.SelectSingleNode("Model") != null)
			{
				sModel = oNode.SelectSingleNode("Model").InnerText;
			}
			
			foreach(XmlNode oCurrElement in oNodes)
			{
				string sSource = oCurrElement.SelectSingleNode("SourceOfValue").InnerText;
				switch(sSource)
				{
					case "F":
						string sFName = oCurrElement.SelectSingleNode("Path").InnerText;
						if(sFName != "")
							OperateFromFlatFile(oCurrElement,sFName,sCondition,sModel);
						break;
					case "T":
						UserTextInput(oCurrElement);
						break;
					default:
						break;
				}

			}
		}
		
		
		/// <summary>
		/// This method performs the add/update/delete of the base object in the custom collection
		/// based on the oCurrElement - one of the parameter
		/// </summary>
		/// <param name="oCurrElement"></param>
		/// <param name="sFName"></param>
		/// <param name="sOperation"></param>
		/// <param name="sModel"></param>
		private void OperateFromFlatFile(XmlNode oCurrElement, string sFName,string sOperation,string sModel)
		{
			CustomCollection oCustomColl = null;
			string sWhereClause = "";
			object instance = null;
			object[] index = null;
			bool bLocalCopy = false;

			if(oCurrElement.SelectSingleNode("PrimaryKey") != null)
				sWhereClause = oCurrElement.SelectSingleNode("PrimaryKey").InnerText;

			PropertyInfo[] modelProperties = typeof(LRRModel).GetProperties();
			
			XmlNodeList oNodes = oCurrElement.SelectSingleNode("Fields").SelectNodes("//Field");		
			foreach (PropertyInfo mproperty in modelProperties)
			{
				Type oProp = mproperty.PropertyType;
							
				if(oProp.ToString() == oCurrElement.SelectSingleNode("CollectionName").InnerText)
				{
					oCustomColl = mproperty.GetValue(instance,index) as CustomCollection;
								
				}
			}
			//For the cases where the save happens through local copy of collection object
			if(oCustomColl == null)
			{
				if(sModel.Equals("false"))
				{
					oCustomColl = Activator.CreateInstance(boAssembly.GetType(oCurrElement.SelectSingleNode("CollectionName").InnerText)) as CustomCollection;
					_lrrApp.DBManagerObj.PopulateCollection(oCustomColl,false);
					bLocalCopy = true;
				}
				else
					bLocalCopy = false;
				
			}
			
			if(oCustomColl != null)
			{
				//Load File and extract Data for the fields from the file.
				using (CSVParser csv = new CSVParser(sFName)) 
				{
					string[] fields;
					string sFieldName = "";

					while ((fields = csv.GetCSVLine()) != null) 
					{
						int nColumns = fields.Length;
						int nCurrentCol = 0;
						
						switch(sOperation)
						{
							case "I":
								BaseObject oInsertObj = FillValues(nColumns,oCurrElement,fields,oCustomColl) as BaseObject;
								oCustomColl.Add(oInsertObj);
								break;
							case "U":
								BaseObject oUpdateObj = FillValues(nColumns,oCurrElement,fields,oCustomColl) as BaseObject;
								nCurrentCol = 0;
								sFieldName = "";
								foreach(BaseObject oBaseObj in oCustomColl)
								{
									if(oBaseObj.GetType().GetProperty(sWhereClause) != null)
									{
										if(oUpdateObj.GetType().GetProperty(sWhereClause) != null)
										{
											string dataFileVal = oBaseObj.GetType().GetProperty(sWhereClause).GetValue(oBaseObj,null).ToString();
											string originalVal = oUpdateObj.GetType().GetProperty(sWhereClause).GetValue(oUpdateObj,null).ToString();
											if(originalVal == dataFileVal) //It is the same object
											{
												foreach(XmlNode oChildElement in oNodes)
												{
													sFieldName = oChildElement.SelectSingleNode("Name").InnerText;
													if(oBaseObj.GetType().GetProperty(sFieldName) != null)
													{
														string newVal = oBaseObj.GetType().GetProperty(sFieldName).GetValue(oBaseObj,null) == null ? "" : oBaseObj.GetType().GetProperty(sFieldName).GetValue(oBaseObj,null).ToString();
														string fieldVal = oUpdateObj.GetType().GetProperty(sFieldName).GetValue(oUpdateObj,null) == null ? "" : oUpdateObj.GetType().GetProperty(sFieldName).GetValue(oUpdateObj,null).ToString();
														if(newVal != fieldVal) //Get the value
														{
															oBaseObj.GetType().GetProperty(sFieldName).SetValue(oBaseObj,oUpdateObj.GetType().GetProperty(sFieldName).GetValue(oUpdateObj,null),null);
														}
													}

												}
												break;
											}
										}
									}
									nCurrentCol = nCurrentCol + 1;
								}
								break;
							case "D":
								BaseObject oDeleteObj = FillValues(nColumns,oCurrElement,fields,oCustomColl) as BaseObject;
								nCurrentCol = 0;
								sFieldName = "";
								foreach(BaseObject oBaseObj in oCustomColl)
								{
									if(oBaseObj.GetType().GetProperty(sWhereClause) != null)
									{
										if(oDeleteObj.GetType().GetProperty(sWhereClause) != null)
										{
											string dataFileVal = oBaseObj.GetType().GetProperty(sWhereClause).GetValue(oBaseObj,null).ToString();
											string originalVal = oDeleteObj.GetType().GetProperty(sWhereClause).GetValue(oDeleteObj,null).ToString();
											if(originalVal == dataFileVal) //It is the same object
											{
												oCustomColl.Remove(oBaseObj);
												break;
											}
										}
									}
									
								}
								break;
						}
					}
					
				}
			}

			if(bLocalCopy)
			{
				MessageBox.Show("Save started for " + oCurrElement.SelectSingleNode("CollectionName").InnerText + ". The changes will be visible \r\n On either of the following options: \r\n a) Logout \r\n b) Reconnect \r\n c) Restart PE-Advisor");
				_lrrApp.DBManagerObj.CommitCollection(oCustomColl.GetChanges());
			}
		}
		
		
		/// <summary>
		/// This methods creates an object of the base object specified as one of the parameter 
		/// and fills in the value from the csv file. 
		/// </summary>
		/// <param name="nColumns"></param>
		/// <param name="oCurrElement"></param>
		/// <param name="fields"></param>
		/// <param name="oCustomColl"></param>
		/// <returns></returns>
		private BaseObject FillValues(int nColumns ,XmlNode oCurrElement,string[] fields,CustomCollection oCustomColl )
		{
			int nCurrentCol =0;
			//Fill the values
			BaseObject oObj = Activator.CreateInstance(oCustomColl.ItemType) as BaseObject;
			XmlNodeList oNodes = oCurrElement.SelectSingleNode("Fields").SelectNodes("Field");
									
			//Fill the values
			foreach (string field in fields)
			{
				XmlNode oChildElement = oNodes[nCurrentCol] as XmlNode;
				string sFieldName = oChildElement.SelectSingleNode("Name").InnerText;
				if(oObj.GetType().GetProperty(sFieldName) != null)
				{
					Type propType = oObj.GetType().GetProperty(sFieldName).PropertyType;
					switch(propType.ToString())
					{
						case "System.Boolean":
							if(field.ToUpper() == "TRUE")
								oObj.GetType().GetProperty(sFieldName).SetValue(oObj,true,null);
							else
								oObj.GetType().GetProperty(sFieldName).SetValue(oObj,false,null);
							break;
						case "System.DateTime":
							if(field != "")
								oObj.GetType().GetProperty(sFieldName).SetValue(oObj,DateTime.Parse(field),null);
							break;
						case "System.Int32":
							oObj.GetType().GetProperty(sFieldName).SetValue(oObj,Int32.Parse(field=="" ? "0" : field),null);
							break;
						default:
							oObj.GetType().GetProperty(sFieldName).SetValue(oObj,field,null);
							break;
					}
										
				}
				nCurrentCol = nCurrentCol + 1;
									
			}
			return oObj;
		}
		
		
		/// <summary>
		/// This method should contain the logic to consume user specified data in the test scenarios XML
		/// instead of data file
		/// </summary>
		/// <param name="oCurrElement"></param>
		/// <remarks>
		/// Support not provided.
		/// </remarks>
		private void UserTextInput(XmlNode oCurrElement)
		{
			//XmlNode oNode = oSelectedNode.Tag as XmlNode;
			//extract Data for the fields from the XML
			MessageBox.Show("User Text Input in XML support not provided");
		}
		
		
		/// <summary>
		/// This method is invoked to save modified custom collection from the respective screen
		/// </summary>
		/// <param name="id"></param>
		private void ApplyTestChanges(int id)
		{
			
			switch(id)
			{
				case 100:
					MasterPlantItems frmMasterPlantItems = new MasterPlantItems();
					frmMasterPlantItems.Save();
					break;
				case 130:
					SiteComponentEntry frmSiteComponentEntry = new SiteComponentEntry();
					frmSiteComponentEntry.Save();
					break;
				case 260:
					Symcon.LightRidge.PEAdvisor.UserControls.OptionsUserControl userControlOptionsMain = new Symcon.LightRidge.PEAdvisor.UserControls.OptionsUserControl();
					userControlOptionsMain.ActivateControl("SID_0");
					userControlOptionsMain.ActivateControl("SID_1");
					userControlOptionsMain.ActivateControl("SID_2");
					userControlOptionsMain.ActivateControl("SID_3");
					userControlOptionsMain.ActivateControl("SID_4");
					userControlOptionsMain.ActivateControl("SID_5");
					userControlOptionsMain.ActivateControl("SID_6");
					userControlOptionsMain.ActivateControl("SID_7");
					userControlOptionsMain.ActivateControl("SID_8");
					userControlOptionsMain.ActivateControl("SID_10");
					userControlOptionsMain.ActivateControl("SID_11");
					userControlOptionsMain.ActivateControl("SID_12");
					userControlOptionsMain.ActivateControl("SID_13");
					userControlOptionsMain.ActivateControl("SID_14");
					userControlOptionsMain.ActivateControl("SID_15");
					userControlOptionsMain.ActivateControl("SID_17");
					userControlOptionsMain.ActivateControl("SID_19");
					userControlOptionsMain.ActivateControl("SID_20");
					userControlOptionsMain.ActivateControl("SID_21");
					userControlOptionsMain.ActivateControl("SID_22");
					userControlOptionsMain.ActivateControl("SID_23");
					
					userControlOptionsMain.Save();
					
					break;
				default:
					
					break;
			}
			
		}

		
		/// <summary>
		/// This method is used to display the details of the testcase
		///  on selection of the same from the treeview
		/// </summary>
		/// <param name="oNode"></param>
		private void SetLabels(XmlNode oNode)
		{
			if(oNode != null)
			{
				switch(oNode.Name)
				{
					case "ID":
						txtTestID.Text = oNode.InnerText;
						break;
					case "Condition":
						txtCondition.Text = oNode.InnerText;
						break;
					case "ScreenName":
						txtScreenName.Text = oNode.InnerText;
						break;
					case "ScreenID":
						txtScreenID.Text = oNode.InnerText;
						break;
					default:
						break;
				}
			}
			else
			{
				txtTestID.Text = "";
				txtCondition.Text = "";
				txtScreenName.Text =  "";
				txtScreenID.Text = "";
			}
		}
		

		#endregion

		# region Event Handlers
		/// <summary>
		/// This method is the event handler for Form loadevent
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		private void FunctionTest_Load(object sender, System.EventArgs e)
		{
			boAssembly = Assembly.LoadWithPartialName("Symcon.LightRidge.BusinessObjects");
			
		}

		/// <summary>
		/// This method is the event handler for btnBrowse click event
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// This method loads Open File Dialog window to select the test scenario XML location
		/// </remarks>
		private void btnBrowse_Click(object sender, System.EventArgs e)
		{
			openFileDialog1.Filter = "XML Files|*.xml";
			openFileDialog1.ShowDialog();
			txtTestTemplate.Text = openFileDialog1.FileName;

		}
		/// <summary>
		/// This method is the event handler for btnLoad click event
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// This method loads the test scenarios XML & invokes RenderTreeView() to 
		/// render tree view control based on the loaded test scenarios XML
		/// </remarks>
		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			chkUseTestSequence.Checked = false;
			chkUseTestSequence.Enabled = false;
			
			oXML.Load(txtTestTemplate.Text);
			
			RenderTreeView();

			chkUseTestSequence.Enabled = true;
			btnPerformTest.Enabled = true;
			
		}

		
		/// <summary>
		/// This method is the event handler for btnPerformTest click event
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// This method invokes CreateTestForCondition() & ApplyTestChanges() to completion
		/// execution of a testcase based on the details provided by test scenarios XML
		/// </remarks>
		private void btnPerformTest_Click(object sender, System.EventArgs e)
		{
			this.Cursor = Cursors.WaitCursor;
			if((oSelectedNode != null) && (oSelectedNode.Text.ToUpper().IndexOf("TESTCASES",0) == -1) && (oSelectedNode.Text.ToUpper().IndexOf("BATCHTESTCASE",0) == -1))
			{
				CreateTestForCondition(oSelectedNode);
				if(txtScreenID.Text != "")
				{
					ApplyTestChanges(int.Parse(txtScreenID.Text));
				}
				XmlNode oNode = oSelectedNode.Tag as XmlNode;
				VerifyTestResults(oNode);
			}
			else
			{
				foreach(DataRow dr in _dtBatchCases.Rows)
				{
					string sTestCaseID = dr[0].ToString().ToUpper();
					foreach(TreeNode oTNode in treeView1.Nodes[0].Nodes)
					{
						XmlNode oNode = oTNode.Tag as XmlNode;
						if(oNode.SelectSingleNode("ID") != null)
						{
							if(oNode.SelectSingleNode("ID").InnerText.ToUpper() == sTestCaseID)
							{
								XmlNode oFirstChild = oNode.FirstChild;
								while (oFirstChild!= null)
								{
									SetLabels(oFirstChild);
									oFirstChild = oFirstChild.NextSibling;
								}
								
								CreateTestForCondition(oTNode);

								if(oNode.SelectSingleNode("ScreenID").InnerText != "")
								{
									ApplyTestChanges(int.Parse(oNode.SelectSingleNode("ScreenID").InnerText));
				
								}

								
								VerifyTestResults(oNode);
								break;
							}
						}
					}

				}
			}

			TestResult frmTestResult = new TestResult(oXML);
			frmTestResult.ShowDialog();
			this.Cursor = Cursors.Default;
		}

		public DataTable CreateDataSource(XmlNode oRootNode)
		{
			DataRow dr;
			DataTable dtSelectedTestCases = new DataTable("TestCases");

			// Define the columns of the table.
			dtSelectedTestCases.Columns.Add(new DataColumn("Test Case", typeof(string)));
			dtSelectedTestCases.Columns.Add(new DataColumn("Execution Order", typeof(string)));
			
			XmlNodeList oNodes = oRootNode.SelectNodes("TestCase");
			int nCtr = 1;
			foreach (XmlNode oNode in oNodes) 
			{
				dr = dtSelectedTestCases.NewRow();
				XmlNode oSeqNode = oRootNode.SelectSingleNode("TestCase[SequenceNumber = '" + nCtr + "']");
				if(oSeqNode != null)
				{
					dr[0] = oSeqNode.SelectSingleNode("ID").InnerText;
					dr[1] = oSeqNode.SelectSingleNode("SequenceNumber").InnerText;
				}
				else
				{
					dr[0] = oNode.SelectSingleNode("ID").InnerText;
					dr[1] = oNode.SelectSingleNode("SequenceNumber").InnerText;
				}
				dtSelectedTestCases.Rows.Add(dr);
				nCtr = nCtr + 1;
			}
			return dtSelectedTestCases;
		}
		/// <summary>
		/// This method is the event handler for treeView1 Select. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// This method sets the selected node used for reference later and invokes SetLabels method
		/// for filling selected test case details.
		/// </remarks>
		private void treeView1_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			string sNodeText = treeView1.SelectedNode.Text.ToUpper();
			if((sNodeText.IndexOf("BATCHTESTCASE",0) != -1))
			{
				oSelectedNode= new TreeNode();
				oSelectedNode = treeView1.SelectedNode;
				XmlNode oNode = oSelectedNode.Tag as XmlNode;
				
				_dtBatchCases = CreateDataSource(oNode);

				if(_dtBatchCases.Rows.Count > 0)
				{
					dgTestCases.Visible = true;
					lblBatchDesc.Visible = true;
					dgTestCases.DataSource = _dtBatchCases;
				}
				btnBatchTest.Enabled = true;
				SetLabels(null);
			}
			else
			{
				dgTestCases.Visible = false;
				lblBatchDesc.Visible = false;
				dgTestCases.DataSource = null;
			}
			if((sNodeText.IndexOf("TESTCASE",0) != -1) && (chkUseTestSequence.Checked == false))
			{
				oSelectedNode= new TreeNode();
				oSelectedNode = treeView1.SelectedNode;
				XmlNode oNode = oSelectedNode.Tag as XmlNode;
			
				if (oNode.HasChildNodes)
				{
					oNode = oNode.FirstChild;
					while (oNode!= null)
					{
						SetLabels(oNode);
						oNode = oNode.NextSibling;
					}
				}
			}
			else
			{
				oSelectedNode= null;
			}
		}
		
		
		/// <summary>
		/// This method generated the xml for all the custom collection in the business objects
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnGenerateXML_Click(object sender, System.EventArgs e)
		{
			System.Type[] typeInfo = boAssembly.GetTypes();
			int nCtr = 1; 
			string sStartupPath = Application.StartupPath;    
			XmlTextWriter objXmlTextWriter = 
				new XmlTextWriter(sStartupPath +  @"\GeneratedScenarios.xml",null);
			objXmlTextWriter.Formatting = Formatting.Indented;
			objXmlTextWriter.WriteStartDocument();
			objXmlTextWriter.WriteStartElement("TestCases");
			
		
			
			foreach(Type type in typeInfo )
			{
				//TestCase
				if(type.IsClass)
				{
					PropertyInfo[] oProperties = type.GetProperties(BindingFlags.Instance | BindingFlags.DeclaredOnly| BindingFlags.Public);
				
					if(oProperties.Length > 0)
					{
						objXmlTextWriter.WriteStartElement("TestCase");
				
						objXmlTextWriter.WriteStartElement("ID");
						objXmlTextWriter.WriteString(type.Name + "_00" + nCtr.ToString()); 
						objXmlTextWriter.WriteEndElement();
				
						objXmlTextWriter.WriteStartElement("Condition");
						objXmlTextWriter.WriteString(""); 
						objXmlTextWriter.WriteEndElement();
						
						objXmlTextWriter.WriteStartElement("Status");
						objXmlTextWriter.WriteString("Not Evaluated"); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("ScreenName");
						objXmlTextWriter.WriteString(""); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("ScreenID");
						objXmlTextWriter.WriteString(""); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("SequenceNumber");
						objXmlTextWriter.WriteString(nCtr.ToString()); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("Model");
						objXmlTextWriter.WriteString(""); 
						objXmlTextWriter.WriteEndElement();
						
						#region TableName
						objXmlTextWriter.WriteStartElement("TableName");

						objXmlTextWriter.WriteStartElement("CollectionName");
						objXmlTextWriter.WriteString(type.ToString()); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("SourceOfValue");
						objXmlTextWriter.WriteString("F"); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("Path");
						objXmlTextWriter.WriteString(sStartupPath +  @"\" + type.Name + "_00" + nCtr.ToString() + ".csv"); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("PrimaryKey");
						objXmlTextWriter.WriteString(""); 
						objXmlTextWriter.WriteEndElement();

						#region Fill Fields
						objXmlTextWriter.WriteStartElement("Fields");
						
						foreach (PropertyInfo mproperty in oProperties)
						{
							SymDataFieldAttribute[] field = (SymDataFieldAttribute[])
								mproperty.GetCustomAttributes(typeof(SymDataFieldAttribute),
								false);
							if (field.Length > 0)
							{
								//Add in the XML
								objXmlTextWriter.WriteStartElement("Field");
								objXmlTextWriter.WriteStartElement("Name");
								objXmlTextWriter.WriteString(field[0].PropName); 
								objXmlTextWriter.WriteEndElement();
								objXmlTextWriter.WriteEndElement();
							}
						}
						objXmlTextWriter.WriteEndElement();
						#endregion

						objXmlTextWriter.WriteEndElement();
						#endregion

						objXmlTextWriter.WriteStartElement("ExpectedResult");

						#region Expected Result TableName
						objXmlTextWriter.WriteStartElement("TableName");

						objXmlTextWriter.WriteStartElement("CollectionName");
						objXmlTextWriter.WriteString(type.ToString()); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("SourceOfValue");
						objXmlTextWriter.WriteString("F"); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("Path");
						objXmlTextWriter.WriteString(sStartupPath +  @"\" + type.Name + "_00" + nCtr.ToString() + "_V.csv"); 
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteStartElement("PrimaryKey");
						objXmlTextWriter.WriteString(""); 
						objXmlTextWriter.WriteEndElement();

						#region Expected Result Fields
						objXmlTextWriter.WriteStartElement("Fields");
						
						foreach (PropertyInfo mproperty in oProperties)
						{
							SymDataFieldAttribute[] field = (SymDataFieldAttribute[])
								mproperty.GetCustomAttributes(typeof(SymDataFieldAttribute),
								false);
							if (field.Length > 0)
							{
								//Add in the XML
								objXmlTextWriter.WriteStartElement("Field");
								objXmlTextWriter.WriteStartElement("Name");
								objXmlTextWriter.WriteString(field[0].PropName); 
								objXmlTextWriter.WriteEndElement();
								objXmlTextWriter.WriteEndElement();
							}
						}
						objXmlTextWriter.WriteEndElement();
						#endregion

						objXmlTextWriter.WriteEndElement();
						#endregion
						
						objXmlTextWriter.WriteEndElement();

						objXmlTextWriter.WriteEndElement();

						nCtr = nCtr + 1;
					}
				}
			}
			objXmlTextWriter.WriteEndElement();
			objXmlTextWriter.WriteEndDocument();
			objXmlTextWriter.Flush();
			objXmlTextWriter.Close();
			MessageBox.Show("The following file has been successfully created\r\n" 
				+ sStartupPath 
				+ @"\GeneratedScenarios.xml","XML",MessageBoxButtons.OK,
				MessageBoxIcon.Information );
		}
		
		
		/// <summary>
		/// This method is the event handler for Run a batch checkbox. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// This method invokes BatchTestCase form & SaveBatch form to capture information required 
		/// for creating a batch of test cases.
		/// </remarks>
		private void chkUseTestSequence_CheckedChanged(object sender, System.EventArgs e)
		{
			if(chkUseTestSequence.Checked == true)
			{
				frmSaveBatch = new SaveBatch();
				frmSaveBatch.ShowDialog();

				BatchTestCase frmBatchTestCase = new BatchTestCase();
				frmBatchTestCase.SourceXML = oXML;
				frmBatchTestCase.ShowDialog();

				_dtBatchCases = frmBatchTestCase.BatchTestCases;
				
				if(_dtBatchCases.Rows.Count > 0)
				{
					dgTestCases.Visible = true;
					lblBatchDesc.Visible = true;
					dgTestCases.DataSource = _dtBatchCases;
				}
				btnBatchTest.Enabled = true;
				SetLabels(null);
				CreateBatch(frmSaveBatch.BatchName,frmSaveBatch.BatchSeq);
			}
			else
			{
				dgTestCases.DataSource = null;
				dgTestCases.Visible = false;
				lblBatchDesc.Visible = false;
				btnBatchTest.Enabled = false;
			}


		}

		
		/// <summary>
		/// Based on the inputs provided by the user. This method is invoked to spit the 
		/// information in the test scenarios xml loaded
		/// </summary>
		/// <param name="sBatchName"></param>
		/// <param name="sBatchSequence"></param>
		private void CreateBatch(string sBatchName, string sBatchSequence)
		{
			if(sBatchName != "")
			{
				XmlNode oElement ;
				if(oXML.SelectSingleNode("//BatchTestCase[ID='" + sBatchName + "']") == null)
				{
					oElement = oXML.CreateNode(XmlNodeType.Element,"BatchTestCase",null);
					XmlElement oTextElement = oXML.CreateElement("ID");
					oTextElement.InnerText = sBatchName;
					oElement.AppendChild(oTextElement);

					XmlElement oSeqElement = oXML.CreateElement("SequenceNumber");
					oSeqElement.InnerText = sBatchSequence;
					oElement.AppendChild(oSeqElement);
				}
				else
				{
					oElement = oXML.SelectSingleNode("//BatchTestCase[ID='" + sBatchName + "']");
				}
				foreach(DataRow dr in  _dtBatchCases.Rows)
				{
					string sTestCaseID = dr[0].ToString().ToUpper();
					foreach(TreeNode oTNode in treeView1.Nodes[0].Nodes)
					{
						XmlNode oNode = oTNode.Tag as XmlNode;
						if(oNode.SelectSingleNode("ID") != null)
						{
							if(oNode.SelectSingleNode("ID").InnerText.ToUpper() == sTestCaseID)
							{
								if(oElement.SelectSingleNode("TestCase[ID='" + oNode.SelectSingleNode("ID").InnerText + "']") == null)
								{
									oElement.AppendChild(oNode.Clone());
								}
								break;
							}
						}
					}
				}
				if(_dtBatchCases.Rows.Count > 0)
				{
					oXML.DocumentElement.AppendChild(oElement);
					oXML.Save(txtTestTemplate.Text);
					RenderTreeView();
				}
				
			}
		}
		
		
		/// <summary>
		/// This method is the event handler for Define Batch button click. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		/// <remarks>
		/// This method loads BatchTestCase form to allow the user to either create or edit 
		/// ordering of testcases or inclusion/exclusion of testcases as a part of a batch
		/// test case
		/// </remarks>
		private void btnBatchTest_Click(object sender, System.EventArgs e)
		{
			BatchTestCase frmBatchTestCase = new BatchTestCase();
			frmBatchTestCase.SourceXML = oXML;
			frmBatchTestCase.BatchTestCases = _dtBatchCases;
			frmBatchTestCase.ShowDialog();

			DataTable dtBatchTestCases = frmBatchTestCase.BatchTestCases;
			_dtBatchCases = dtBatchTestCases;
			if(dtBatchTestCases.Rows.Count > 0)
			{
				dgTestCases.Visible = true;
				lblBatchDesc.Visible = true;
				dgTestCases.DataSource = dtBatchTestCases;
			}
			else
			{
				dgTestCases.Visible = false;
				lblBatchDesc.Visible = false;
				dgTestCases.DataSource = null;
			}
			if(!(frmSaveBatch == null))
				CreateBatch(frmSaveBatch.BatchName,frmSaveBatch.BatchSeq);
		}

		
		/// <summary>
		/// This method is the event handler for datagrid click. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void dgTestCases_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int nRowIndex = dgTestCases.CurrentRowIndex;
			DataRow dr = _dtBatchCases.Rows[nRowIndex];
			string sTestCaseID = dr[0].ToString().ToUpper();
			foreach(TreeNode oTNode in treeView1.Nodes[0].Nodes)
			{
				XmlNode oNode = oTNode.Tag as XmlNode;
				if(oNode.SelectSingleNode("ID") != null)
				{
					if(oNode.SelectSingleNode("ID").InnerText.ToUpper() == sTestCaseID)
					{
						XmlNode oFirstChild = oNode.FirstChild;
						while (oFirstChild!= null)
						{
							SetLabels(oFirstChild);
							oFirstChild = oFirstChild.NextSibling;
						}
						break;
					}
				}
			}

		}

		
		/// <summary>
		/// This method is the event handler for Cancel button click. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		
		/// <summary>
		/// This method is the event handler for validate button click. 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void btnValidate_Click(object sender, System.EventArgs e)
		{
			string sStartupPath = Application.StartupPath +  @"\GeneratedScenarios.xml" ;
			XmlDocument oValidateXML = new XmlDocument();
			oValidateXML.Load(sStartupPath);
			
			foreach (XmlNode oNode in oValidateXML.SelectNodes("//TestCase")) 
			{
				foreach (XmlNode oTableNode in oNode.SelectNodes("TableName")) 
				{
					if(oTableNode.SelectSingleNode("Fields").SelectNodes("Field").Count == 0)
					{
						oValidateXML.SelectSingleNode("TestCases").RemoveChild(oNode);
					}
				}
			}
			MessageBox.Show("The following file has been successfully validated\r\n" 
				+ sStartupPath ,"XML",MessageBoxButtons.OK,
				MessageBoxIcon.Information );
			oValidateXML.Save(sStartupPath);
		}



		#endregion

		private void btnGenerateDataFiles_Click(object sender, System.EventArgs e)
		{
			foreach (XmlNode oNode in oXML.SelectNodes("//TestCase")) 
			{
				foreach (XmlNode oTableNode in oNode.SelectNodes("TableName")) 
				{
					string theFile = oTableNode.SelectSingleNode("Path").InnerText;
					int nBatchSize = int.Parse(oTableNode.SelectSingleNode("BatchSize").InnerText);
					StreamWriter sw = new StreamWriter(theFile);
					string sLine = "";
					foreach (XmlNode oFieldNode in oTableNode.SelectSingleNode("Fields").SelectNodes("Field")) 
					{
						

						
						

					}
					sw.WriteLine(sLine);
					sw.Close();
				}
			}
		}
	}
	
	
}