using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.HistorianConnect;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for TestRunControl.
	/// </summary>
	public class TestRunControl : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Button cmdAutoRun;
		private System.Windows.Forms.Button cmdRun;
		private System.Windows.Forms.ComboBox cmbEndtime;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox cmbStartTime;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblSavedSets;
		private System.Windows.Forms.ComboBox cmbSelectSet;

		private LRRHistSavedSets		_lrrSavedSets = new LRRHistSavedSets();
		private LRRApp					_app;

		private RunController			_runController = new RunController();
		private System.Windows.Forms.ComboBox cmdHistorianConnections;
		private System.Windows.Forms.Label lblHistorian;

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public TestRunControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			//Get the App Object
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			//Initialize the run controller...
			_runController.Initialize();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.cmdAutoRun = new System.Windows.Forms.Button();
            this.cmdRun = new System.Windows.Forms.Button();
            this.cmbEndtime = new System.Windows.Forms.ComboBox();
            this.label2 = new System.Windows.Forms.Label();
            this.cmbStartTime = new System.Windows.Forms.ComboBox();
            this.label1 = new System.Windows.Forms.Label();
            this.lblSavedSets = new System.Windows.Forms.Label();
            this.cmbSelectSet = new System.Windows.Forms.ComboBox();
            this.cmdHistorianConnections = new System.Windows.Forms.ComboBox();
            this.lblHistorian = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // cmdAutoRun
            // 
            this.cmdAutoRun.BackColor = System.Drawing.SystemColors.ControlLight;
            this.cmdAutoRun.Location = new System.Drawing.Point(152, 152);
            this.cmdAutoRun.Name = "cmdAutoRun";
            this.cmdAutoRun.Size = new System.Drawing.Size(88, 32);
            this.cmdAutoRun.TabIndex = 31;
            this.cmdAutoRun.Tag = "SID_AUTORUN";
            this.cmdAutoRun.UseVisualStyleBackColor = false;
            this.cmdAutoRun.Click += new System.EventHandler(this.cmdAutoRun_Click);
            // 
            // cmdRun
            // 
            this.cmdRun.BackColor = System.Drawing.SystemColors.ControlLight;
            this.cmdRun.Location = new System.Drawing.Point(48, 152);
            this.cmdRun.Name = "cmdRun";
            this.cmdRun.Size = new System.Drawing.Size(88, 32);
            this.cmdRun.TabIndex = 30;
            this.cmdRun.Tag = "SID_RUN";
            this.cmdRun.UseVisualStyleBackColor = false;
            this.cmdRun.Click += new System.EventHandler(this.cmdRun_Click);
            // 
            // cmbEndtime
            // 
            this.cmbEndtime.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.cmbEndtime.Location = new System.Drawing.Point(72, 112);
            this.cmbEndtime.Name = "cmbEndtime";
            this.cmbEndtime.Size = new System.Drawing.Size(200, 21);
            this.cmbEndtime.TabIndex = 29;
            // 
            // label2
            // 
            this.label2.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.label2.Location = new System.Drawing.Point(8, 112);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(56, 24);
            this.label2.TabIndex = 28;
            this.label2.Tag = "SID_ENDTIME";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // cmbStartTime
            // 
            this.cmbStartTime.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.cmbStartTime.Location = new System.Drawing.Point(72, 72);
            this.cmbStartTime.Name = "cmbStartTime";
            this.cmbStartTime.Size = new System.Drawing.Size(200, 21);
            this.cmbStartTime.TabIndex = 27;
            // 
            // label1
            // 
            this.label1.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.label1.Location = new System.Drawing.Point(8, 72);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(56, 24);
            this.label1.TabIndex = 26;
            this.label1.Tag = "SID_STARTTIME";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblSavedSets
            // 
            this.lblSavedSets.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.lblSavedSets.Location = new System.Drawing.Point(8, 40);
            this.lblSavedSets.Name = "lblSavedSets";
            this.lblSavedSets.Size = new System.Drawing.Size(64, 24);
            this.lblSavedSets.TabIndex = 25;
            this.lblSavedSets.Tag = "SID-SAVEDSETS";
            this.lblSavedSets.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // cmbSelectSet
            // 
            this.cmbSelectSet.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.cmbSelectSet.BackColor = System.Drawing.SystemColors.Menu;
            this.cmbSelectSet.Location = new System.Drawing.Point(72, 40);
            this.cmbSelectSet.Name = "cmbSelectSet";
            this.cmbSelectSet.Size = new System.Drawing.Size(200, 21);
            this.cmbSelectSet.TabIndex = 24;
            // 
            // cmdHistorianConnections
            // 
            this.cmdHistorianConnections.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.cmdHistorianConnections.BackColor = System.Drawing.SystemColors.Menu;
            this.cmdHistorianConnections.Location = new System.Drawing.Point(72, 8);
            this.cmdHistorianConnections.Name = "cmdHistorianConnections";
            this.cmdHistorianConnections.Size = new System.Drawing.Size(200, 21);
            this.cmdHistorianConnections.TabIndex = 32;
            this.cmdHistorianConnections.SelectedIndexChanged += new System.EventHandler(this.cmdHistorianConnections_SelectedIndexChanged);
            // 
            // lblHistorian
            // 
            this.lblHistorian.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.lblHistorian.Location = new System.Drawing.Point(8, 8);
            this.lblHistorian.Name = "lblHistorian";
            this.lblHistorian.Size = new System.Drawing.Size(56, 24);
            this.lblHistorian.TabIndex = 33;
            this.lblHistorian.Tag = "SID_HISTORIAN";
            this.lblHistorian.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // TestRunControl
            // 
            this.AutoScroll = true;
            this.BackColor = System.Drawing.SystemColors.InactiveBorder;
            this.Controls.Add(this.lblHistorian);
            this.Controls.Add(this.cmdHistorianConnections);
            this.Controls.Add(this.cmdAutoRun);
            this.Controls.Add(this.cmdRun);
            this.Controls.Add(this.cmbEndtime);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.cmbStartTime);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.lblSavedSets);
            this.Controls.Add(this.cmbSelectSet);
            this.Name = "TestRunControl";
            this.Size = new System.Drawing.Size(288, 192);
            this.Load += new System.EventHandler(this.TestRunControl_Load);
            this.Resize += new System.EventHandler(this.TestRunControl_Resize);
            this.ResumeLayout(false);

		}
		#endregion

		private void TestRunControl_Resize(object sender, System.EventArgs e)
		{
		
		}

		private void TestRunControl_Load(object sender, System.EventArgs e)
		{

			cmdHistorianConnections.DataSource = _runController.HistorianConnections;
			cmdHistorianConnections.DisplayMember = "HistConnectionName";
			
			/*_app.DBManagerObj.PopulateCollection(_lrrSavedSets);
			cmbSelectSet.DataSource = _lrrSavedSets;
			//oleDbDataAdapter1.Fill(dataSet11);
			//cmbSelectSet.DataSource = dataSet11.Tables[0];
			cmbSelectSet.DataSource = _lrrSavedSets;
			cmbSelectSet.DisplayMember =  "Name";
			cmbSelectSet.ValueMember = "ID";

			//cmbStartTime.DataSource = dataSet11.Tables[0];
			cmbStartTime.DataSource = _lrrSavedSets;
			cmbStartTime.DisplayMember = "StartTime";


			//cmbEndtime.DataSource = dataSet11.Tables[0];
			cmbEndtime.DataSource = _lrrSavedSets;
			cmbEndtime.DisplayMember = "EndTime";*/

		
		}

		private void cmdRun_Click(object sender, System.EventArgs e)
		{
            if (!_app.CheckConnection())
            {
                return;
            }
            _app.CheckForSaveBeforeRun();
			_runController.Run(cmbStartTime.Text,cmbEndtime.Text);
		}

		private void cmdHistorianConnections_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			_runController.ActiveHistorianIndex = cmdHistorianConnections.SelectedIndex;


			//_lrrSavedSets = _runController.GetActiveHistorian().GetSavedSets();
			//oleDbDataAdapter1.Fill(dataSet11);
			//cmbSelectSet.DataSource = dataSet11.Tables[0];
			cmbSelectSet.DataSource = _lrrSavedSets;
			cmbSelectSet.DisplayMember =  "Name";
			cmbSelectSet.ValueMember = "ID";

			//cmbStartTime.DataSource = dataSet11.Tables[0];
			cmbStartTime.DataSource = _lrrSavedSets;
			cmbStartTime.DisplayMember = "StartTime";


			//cmbEndtime.DataSource = dataSet11.Tables[0];
			cmbEndtime.DataSource = _lrrSavedSets;
			cmbEndtime.DisplayMember = "EndTime";
		
		}

        private void cmdAutoRun_Click(object sender, EventArgs e)
        {

        }
	}
}
