using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using System.Data;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;


using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;

//using Syncfusion.ExcelRW;
using Syncfusion.Drawing;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for TransferPermissionDialog.
	/// </summary>
	public class TransferPermissionDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.Button btnOk;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox cmbFrmUser;
		private System.Windows.Forms.Label lblHistTagsAssociated;
		private System.Windows.Forms.ListBox listBoxHistTag;
		private System.Windows.Forms.ComboBox cmbToUser;

		public TransferPermissionDialog()
		{
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitializeComponent();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLoginsFrm,false);
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLoginsTo,false);
			_lrrApp.DBManagerObj.PopulateCollection (_lrrHistTagUserPermissions,false);
			_lrrApp.DBManagerObj.PopulateCollection (_orgHistTagUserPermissions,false);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TransferPermissionDialog));
			this.btnOk = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.btnCancel = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.cmbFrmUser = new System.Windows.Forms.ComboBox();
			this.cmbToUser = new System.Windows.Forms.ComboBox();
			this.listBoxHistTag = new System.Windows.Forms.ListBox();
			this.lblHistTagsAssociated = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnOk
			// 
			this.btnOk.Location = new System.Drawing.Point(160, 384);
			this.btnOk.Name = "btnOk";
			this.btnOk.TabIndex = 0;
			this.btnOk.Tag = "SID_OK";
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(82, 16);
			this.label1.TabIndex = 2;
			this.label1.Tag = "SID_TRANSFERFRM";
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(240, 384);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 3;
			this.btnCancel.Tag = "SID_CANCEL";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(16, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(69, 16);
			this.label2.TabIndex = 5;
			this.label2.Tag = "SID_TRANSFERTO";
			// 
			// cmbFrmUser
			// 
			this.cmbFrmUser.Location = new System.Drawing.Point(96, 16);
			this.cmbFrmUser.Name = "cmbFrmUser";
			this.cmbFrmUser.Size = new System.Drawing.Size(176, 21);
			this.cmbFrmUser.TabIndex = 6;
			this.cmbFrmUser.SelectedIndexChanged += new System.EventHandler(this.cmbFrmUser_SelectedIndexChanged);
			// 
			// cmbToUser
			// 
			this.cmbToUser.Location = new System.Drawing.Point(96, 48);
			this.cmbToUser.Name = "cmbToUser";
			this.cmbToUser.Size = new System.Drawing.Size(176, 21);
			this.cmbToUser.TabIndex = 7;
			this.cmbToUser.SelectedIndexChanged += new System.EventHandler(this.cmbToUser_SelectedIndexChanged);
			// 
			// listBoxHistTag
			// 
			this.listBoxHistTag.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.listBoxHistTag.Location = new System.Drawing.Point(16, 112);
			this.listBoxHistTag.Name = "listBoxHistTag";
			this.listBoxHistTag.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.listBoxHistTag.Size = new System.Drawing.Size(256, 238);
			this.listBoxHistTag.TabIndex = 8;
			// 
			// lblHistTagsAssociated
			// 
			this.lblHistTagsAssociated.Location = new System.Drawing.Point(8, 88);
			this.lblHistTagsAssociated.Name = "lblHistTagsAssociated";
			this.lblHistTagsAssociated.Size = new System.Drawing.Size(248, 16);
			this.lblHistTagsAssociated.TabIndex = 9;
			this.lblHistTagsAssociated.Tag = "SID_LISTHISTTAGS";
			// 
			// TransferPermissionDialog
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(322, 416);
			this.ControlBox = false;
			this.Controls.Add(this.lblHistTagsAssociated);
			this.Controls.Add(this.listBoxHistTag);
			this.Controls.Add(this.cmbToUser);
			this.Controls.Add(this.cmbFrmUser);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnOk);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "TransferPermissionDialog";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Tag = "SID_TRANSFERPERMIS";
			this.Load += new System.EventHandler(this.TransferPermissionDialog_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = DialogResult.Cancel;
			this.Close();
			return;
		}

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			ht.Clear();
			if(frmUserName==toUserName)
			{
				LRRMessagBox.ShowMessage("SID_TEANSFER_ABORT","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Stop);    
				return;
			}
			else
			{
				this.DialogResult = DialogResult.OK;
				this.Close();
			}
			for(int i=0 ;i<listBoxHistTag.SelectedItems.Count;i++)
			{
				ht.Add(i,listBoxHistTag.SelectedItems[i]);
			}

		}

		private void TransferPermissionDialog_Load(object sender, System.EventArgs e)
		{
			//******************Loadind the combos*********************************
			cmbFrmUser.DataSource = _lrrLoginsFrm;
			cmbFrmUser.DisplayMember = "UserName";
			cmbFrmUser.ValueMember = "UserID";
			cmbToUser.DataSource = _lrrLoginsTo;
			cmbToUser.DisplayMember = "UserName";
			cmbToUser.ValueMember = "UserID";

			//******************Loadind the ListBox*********************************
			listBoxHistTag.DataSource = _lrrHistTagUserPermissions;
			listBoxHistTag.DisplayMember = "HistTag";
			listBoxHistTag.ValueMember = "ID";
		}

		#region Fields

		public string frmUserName = "";
		public string toUserName = "";
		public string frmUserID;
		public string toUserID;
		private LRRLogins _lrrLoginsFrm=new LRRLogins();
		private LRRLogins _lrrLoginsTo=new LRRLogins();
		private LRRHistTagUserPermissions	_lrrHistTagUserPermissions=new LRRHistTagUserPermissions();
		private LRRHistTagUserPermissions	_orgHistTagUserPermissions=new LRRHistTagUserPermissions();
		private LRRApp _lrrApp;
		public Hashtable ht=new Hashtable();//to store selected HistTags

		bool loaded=false;
		#endregion

		private void cmbFrmUser_SelectedIndexChanged(object sender, System.EventArgs e)
		{		
			LRRLogin _lrrLoginFrm=cmbFrmUser.SelectedItem as LRRLogin;
			frmUserID = _lrrLoginFrm.UserID;
			frmUserName = cmbFrmUser.Text;
			//******************Filtering HistTags acco: to the selected user**********
			_lrrHistTagUserPermissions=_orgHistTagUserPermissions;
			_lrrHistTagUserPermissions=_lrrHistTagUserPermissions.GetHistTagsForUserID(frmUserID);
			//******************Loadind the ListBox*********************************
			listBoxHistTag.DataSource = _lrrHistTagUserPermissions;
			listBoxHistTag.DisplayMember = "HistTag";
			listBoxHistTag.ValueMember = "ID";
		}

		private void cmbToUser_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			LRRLogin _lrrLoginTo=cmbToUser.SelectedItem as LRRLogin;
			toUserName = cmbToUser.Text;
			toUserID = _lrrLoginTo.UserID;

		}
	}
}
