using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for TuningRunController.
	/// </summary>
	public class TuningRunController : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		private LRRApp					_app;
		private System.Windows.Forms.Button cmdAutoRun;
		private System.Windows.Forms.Button cmdRun;
		private System.Windows.Forms.ComboBox cmbEndtime;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox cmbStartTime;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lblStartTime;
		private System.Windows.Forms.ComboBox cmbSelectSet;
		private LRRHistSavedSets		_lrrSavedSets = new LRRHistSavedSets();

		

		public TuningRunController()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Get the App Object
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

			

			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdAutoRun = new System.Windows.Forms.Button();
			this.cmdRun = new System.Windows.Forms.Button();
			this.cmbEndtime = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.cmbStartTime = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lblStartTime = new System.Windows.Forms.Label();
			this.cmbSelectSet = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// cmdAutoRun
			// 
			this.cmdAutoRun.Location = new System.Drawing.Point(376, 128);
			this.cmdAutoRun.Name = "cmdAutoRun";
			this.cmdAutoRun.Size = new System.Drawing.Size(88, 24);
			this.cmdAutoRun.TabIndex = 23;
			this.cmdAutoRun.Tag = "SID_AUTORUN";
			this.cmdAutoRun.Click += new System.EventHandler(this.cmdAutoRun_Click);
			// 
			// cmdRun
			// 
			this.cmdRun.Location = new System.Drawing.Point(272, 128);
			this.cmdRun.Name = "cmdRun";
			this.cmdRun.Size = new System.Drawing.Size(88, 24);
			this.cmdRun.TabIndex = 22;
			this.cmdRun.Tag = "SID_RUN";
			this.cmdRun.Click += new System.EventHandler(this.cmdRun_Click);
			// 
			// cmbEndtime
			// 
			this.cmbEndtime.Location = new System.Drawing.Point(80, 96);
			this.cmbEndtime.Name = "cmbEndtime";
			this.cmbEndtime.Size = new System.Drawing.Size(200, 21);
			this.cmbEndtime.TabIndex = 21;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 24);
			this.label2.TabIndex = 20;
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cmbStartTime
			// 
			this.cmbStartTime.Location = new System.Drawing.Point(80, 56);
			this.cmbStartTime.Name = "cmbStartTime";
			this.cmbStartTime.Size = new System.Drawing.Size(200, 21);
			this.cmbStartTime.TabIndex = 19;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 24);
			this.label1.TabIndex = 18;
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblStartTime
			// 
			this.lblStartTime.Location = new System.Drawing.Point(8, 16);
			this.lblStartTime.Name = "lblStartTime";
			this.lblStartTime.Size = new System.Drawing.Size(56, 24);
			this.lblStartTime.TabIndex = 17;
			this.lblStartTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cmbSelectSet
			// 
			this.cmbSelectSet.Location = new System.Drawing.Point(80, 16);
			this.cmbSelectSet.Name = "cmbSelectSet";
			this.cmbSelectSet.Size = new System.Drawing.Size(200, 21);
			this.cmbSelectSet.TabIndex = 16;
			// 
			// TuningRunController
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(472, 166);
			this.Controls.Add(this.cmdAutoRun);
			this.Controls.Add(this.cmdRun);
			this.Controls.Add(this.cmbEndtime);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.cmbStartTime);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lblStartTime);
			this.Controls.Add(this.cmbSelectSet);
			this.Name = "TuningRunController";
			this.Tag = "SID_TUNINGRUNCTRLLER";
			this.TopMost = true;
			this.Load += new System.EventHandler(this.TuningRunController_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void TuningRunController_Load(object sender, System.EventArgs e)
		{

			_app.DBManagerObj.PopulateCollection(_lrrSavedSets);
			cmbSelectSet.DataSource = _lrrSavedSets;
			//oleDbDataAdapter1.Fill(dataSet11);
			//cmbSelectSet.DataSource = dataSet11.Tables[0];
			cmbSelectSet.DataSource = _lrrSavedSets;
			cmbSelectSet.DisplayMember =  "Name";
			cmbSelectSet.ValueMember = "ID";

			//cmbStartTime.DataSource = dataSet11.Tables[0];
			cmbStartTime.DataSource = _lrrSavedSets;
			cmbStartTime.DisplayMember = "StartTime";


			//cmbEndtime.DataSource = dataSet11.Tables[0];
			cmbEndtime.DataSource = _lrrSavedSets;
			cmbEndtime.DisplayMember = "EndTime";


		
		}

		private void cmdAutoRun_Click(object sender, System.EventArgs e)
		{
		
		}

		private void cmdRun_Click(object sender, System.EventArgs e)
		{
		
		}
	}
}
