using System;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using System.Windows.Forms;
using System.Collections;
using Symcom.Evaluator;
using Symcon.Utils.MessageLogger;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for UOMConversionUtility.
	/// </summary>
	public class UOMConversionUtility
	{
		LRRApp _lrrApp;
		LRRUCFs _lrrUCFs = new LRRUCFs();

		public UOMConversionUtility()
		{
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			//_lrrApp.DBManagerObj.PopulateCollection(_lrrUCFs,false);
			//_lrrUCFs = LRRModel.ChildModel.UCFs;
		}

		public string ConvertUOM(string fromUnit,string toUnit,string originalValue)
		{
			double val = 0;
			string val1 = "";
			string sFormulaID = "";
			string sFormula = "";

			LRRFormulaParams lrrFormulaParams = new LRRFormulaParams();
			LRRFormula lrrFormula = null;

			//_lrrUCFs.ItemFilter = "FromUnit = " + fromUnit + " AND ToUnit = " + toUnit;
			LRRUCF  objLRRUCF = LRRModel.ChildModel.GetUCFFromConversionUnits(fromUnit,toUnit);

			if(objLRRUCF == null)
				return val1;

			sFormulaID = objLRRUCF.ConversionFormula == null ? "" : objLRRUCF.ConversionFormula.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(sFormulaID == "")
				return val1;
			
			lrrFormula = LRRModel.FormulasObj.GetFormulaObjFromID(sFormulaID);
			
			if(lrrFormula == null)
				return val1;
			
			sFormula = lrrFormula.Expression == null ? "" : lrrFormula.Expression.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
			lrrFormulaParams = lrrFormula.Params;
			//Symcom.Evaluator.UOMConversionUtility uomC = new Symcom.Evaluator.UOMConversionUtility();
			
			try
			{
				if(originalValue != null && originalValue != "")
				{
					originalValue = Math.Round(Double.Parse(originalValue,Symcon.BusinessObjects.SymConverter.Culture),2).ToString(Symcon.BusinessObjects.SymConverter.Culture);
					val1 = Calculate(lrrFormulaParams,sFormula,originalValue);
					val1 = Math.Round(Double.Parse(val1,Symcon.BusinessObjects.SymConverter.Culture),2).ToString(Symcon.BusinessObjects.SymConverter.Culture);
					//val1 = Math.Round(Double.Parse(uomC.ConvertUOM(_lrrUCFs[0].ConversionFormula,originalValue)),2).ToString(Symcon.BusinessObjects.SymConverter.Culture);
				}
				return val1;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UOMConversionUtility),"ConvertUOM:"+ex.Message  ,Logger.Level.Debug);
				return originalValue;
			}
			
			//_lrrUCFs.ItemFilter = "";
		}

		public string ConvertUOM(string fromUnit,string toUnit,string originalValue,bool roundOffValue)
		{
			double val = 0;
			string val1 = originalValue;
			string sFormulaID = "";
			string sFormula = "";

			LRRFormulaParams lrrFormulaParams = new LRRFormulaParams();
			LRRFormula lrrFormula = null;

			//_lrrUCFs.ItemFilter = "FromUnit = " + fromUnit + " AND ToUnit = " + toUnit;
			LRRUCF  objLRRUCF = LRRModel.ChildModel.GetUCFFromConversionUnits(fromUnit,toUnit);

			if(objLRRUCF == null)
				return val1;

			sFormulaID = objLRRUCF.ConversionFormula == null ? "" : objLRRUCF.ConversionFormula.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			if(sFormulaID == "")
				return val1;
			
			lrrFormula = LRRModel.FormulasObj.GetFormulaObjFromID(sFormulaID);
			
			if(lrrFormula == null)
				return val1;
			
			sFormula = lrrFormula.Expression == null ? "" : lrrFormula.Expression.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
			lrrFormulaParams = lrrFormula.Params;
			//Symcom.Evaluator.UOMConversionUtility uomC = new Symcom.Evaluator.UOMConversionUtility();
			
			try
			{
				if(originalValue != null && originalValue != "")
				{
					if(roundOffValue)
					{
						originalValue = Math.Round(Double.Parse(originalValue,Symcon.BusinessObjects.SymConverter.Culture),2).ToString(Symcon.BusinessObjects.SymConverter.Culture);
					}
					else
					{
						originalValue = Double.Parse(originalValue,Symcon.BusinessObjects.SymConverter.Culture).ToString(Symcon.BusinessObjects.SymConverter.Culture);
					}
					val1 = Calculate(lrrFormulaParams,sFormula,originalValue);
					if(roundOffValue)
					{
						val1 = Math.Round(Double.Parse(val1,Symcon.BusinessObjects.SymConverter.Culture),2).ToString(Symcon.BusinessObjects.SymConverter.Culture);
					}
					else
					{
						val1 = Double.Parse(val1,Symcon.BusinessObjects.SymConverter.Culture).ToString(Symcon.BusinessObjects.SymConverter.Culture);
					}
					//val1 = Math.Round(Double.Parse(uomC.ConvertUOM(_lrrUCFs[0].ConversionFormula,originalValue)),2).ToString();
				}
				return val1;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UOMConversionUtility),"ConvertUOM:"+ex.Message  ,Logger.Level.Debug);
				return originalValue;
			}
			
			//_lrrUCFs.ItemFilter = "";
		}


		public string Calculate(LRRFormulaParams lrrFormulaParams,string formula,string originalValue)
		{
			string oldValueStrig = originalValue;
			try
			{
				Hashtable htFormulaParam = new Hashtable();
				foreach(LRRFormulaParam lrrFormulaParam in lrrFormulaParams)
				{
					if(!htFormulaParam.Contains(lrrFormulaParam.ParamName))
						htFormulaParam.Add(lrrFormulaParam.ParamName,lrrFormulaParam);
				}

				//--Inline Operator--
				string[] inlineOperator = formula.Split(new char[]{'?'});
				if(inlineOperator.Length > 1)
				{
					string exp = inlineOperator[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
					string[] param = exp.Split(new char[]{'='});
					if(param.Length > 1)
					{
						string param1 = param[0].ToString(Symcon.BusinessObjects.SymConverter.Culture).Trim();
						string param2 = param[1].ToString(Symcon.BusinessObjects.SymConverter.Culture).Trim();
						if(htFormulaParam.Contains(param1))
						{
							LRRFormulaParam lrrFormulaParam1 = htFormulaParam[param1] as LRRFormulaParam;
							string[] result = inlineOperator[1].Split(new char[]{':'});
							if(lrrFormulaParam1.CurrentValue == param2)
							{
								return result[0].ToString(Symcon.BusinessObjects.SymConverter.Culture);
							}
							else
							{
								return result[1].ToString(Symcon.BusinessObjects.SymConverter.Culture);
							}
						}
					}
				}
				//--End--

				ExecutionQueue eq = Evaluator.ParseIt(formula);
				ExecutionQueue newEq = new ExecutionQueue(); 
				ExecutionItem ei;
				while(eq.Count > 0)
				{
					ei = eq.Dequeue();
					switch(ei.itemType)
					{
						case ItemType.itString:
							if(htFormulaParam.Contains(ei.itemString))
							{
								LRRFormulaParam lrrFormula = htFormulaParam[ei.itemString] as LRRFormulaParam;
								string curVal = "";
								if(lrrFormula.SourceCollectioName == typeof(LRRSiteComponentPropertyValue).ToString())
								{
									if(lrrFormula.SourceOBJID == null || lrrFormula.SourceOBJID.Trim() == "")
									{
										curVal = lrrFormula.CurrentValue;
									}
									else
									{
										if(LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrFormula.SourceOBJID)!= null)
											curVal = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrFormula.SourceOBJID).GetValueForPropertyMode(lrrFormula.ModeID);
									}
								}
								else if(lrrFormula.SourceCollectioName == typeof(LRRHistData).ToString())
								{
									if(lrrFormula.SourceOBJID == null || lrrFormula.SourceOBJID.Trim() == "")
									{
										curVal = lrrFormula.CurrentValue;
									}
									else
									{
										//Populate from Model
										LRRHistDatas lrrhistDatas = LRRModel.HistDatas;
										LRRHistData lrrhistData = lrrhistDatas.GetHistDataFromHistTagUID(lrrFormula.SourceOBJID);
										curVal = lrrhistData.InterfaceValue;
									}
								}
								else if(lrrFormula.SourceCollectioName == typeof(LRRConstant).ToString())
								{
									if(lrrFormula.SourceOBJID == null || lrrFormula.SourceOBJID.Trim() == "")
									{
										curVal = lrrFormula.CurrentValue;
									}
									else
									{
										//Populate from Model
										LRRConstants lrrConstants = LRRModel.ChildModel.ConstantsDefined;
										LRRConstant lrrConstant = lrrConstants.GetConstantFromID(lrrFormula.SourceOBJID);
										curVal = lrrConstant.Value == null ? "" : lrrConstant.Value.ToString(Symcon.BusinessObjects.SymConverter.Culture);
									}
								}
								else if(lrrFormula.SourceCollectioName == typeof(LRRUCF).ToString())
								{
									curVal = originalValue == "" ? "0": originalValue;
								}
								if(curVal == null || curVal.Trim() == "")
									curVal = "0";

								newEq.Enqueue(new ExecutionItem(ItemType.itDigit,curVal));
							}
							break;
						default:
							newEq.Enqueue(ei);
							break;
					}
				}

				Variant var  =  Evaluator.CalcIt(newEq);
				string val =  var.oValue.ToString();
				return val;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UOMConversionUtility),"Calculate:"+ex.Message  ,Logger.Level.Debug);
				return oldValueStrig;
			}
		}

	}
}
