using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Reflection;
using Symcon.LightRidge.DataQualityConfiguration;
namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for DQLegend.
	/// </summary>
	public class DQLegend : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;
		private LRRBindingManager				_bindingManager = new LRRBindingManager();
		private int nStartXPos = 10;
		private System.Windows.Forms.Panel pnlCotrols;
		private int nStartYPos = 10;
		public DQLegend()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}

		#region Public Properties
		public LegendDetails LegendDetailsObj
		{
			get{return _legendDetailsObj;}
			set
			{
				_legendDetailsObj = value;
			}
		}
		public Panel PanelsObj
		{
			get{return this.pnlCotrols;}
			
		}
		public int StartXPos
		{
			get{return nStartXPos;}
			
		}
		public int StartYPos
		{
			get{return nStartYPos;}
			
		}
		#endregion
		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
			
		#region Fields
			private LegendDetails _legendDetailsObj = new LegendDetails();
			private Hashtable _bindingCollection = new Hashtable();
		#endregion

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(DQLegend));
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.pnlCotrols = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// pnlCotrols
			// 
			this.pnlCotrols.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlCotrols.Location = new System.Drawing.Point(0, 0);
			this.pnlCotrols.Name = "pnlCotrols";
			this.pnlCotrols.Size = new System.Drawing.Size(296, 176);
			this.pnlCotrols.TabIndex = 0;
			// 
			// DQLegend
			// 
			this.AutoScroll = true;
			this.Controls.Add(this.pnlCotrols);
			this.Name = "DQLegend";
			this.Size = new System.Drawing.Size(296, 176);
			this.Tag = "SID_DQLEGEND";
			this.ResumeLayout(false);

		}
		#endregion

		public void PopulateControls()
		{
			this.pnlCotrols.Controls.Clear();
			nStartXPos = 10;
			nStartYPos = 10;
			foreach(LegendDetail legendDetailObj in _legendDetailsObj)
			{
				Label lblValue   = new Label();
				lblValue.Location = new System.Drawing.Point(nStartXPos, nStartYPos);
				lblValue.Height = 16;
				lblValue.Width = 16;
				lblValue.ImageList = imageList1;
				lblValue.Tag= legendDetailObj;
				lblValue.DataBindings.Add("Image",legendDetailObj,"DQImage");
				
				this.pnlCotrols.Controls.Add(lblValue);
				nStartYPos = nStartYPos + 20;
		
				//Add For Label
				TextBox txtLegendName = new TextBox();
				txtLegendName.Location = new System.Drawing.Point(nStartXPos + 20, nStartYPos -20);
				txtLegendName.Height = 16;
				txtLegendName.Width = 200;
				txtLegendName.BorderStyle = BorderStyle.None;
				txtLegendName.Font = new System.Drawing.Font("Arial Narrow", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
				txtLegendName.Tag= legendDetailObj;
				txtLegendName.DataBindings.Add("Text",legendDetailObj,"Name");
				txtLegendName.ReadOnly = true;
				this.pnlCotrols.Controls.Add(txtLegendName);
				
			}
		}
	}
//	public class LegendDetails : CustomCollection
//	{
//		#region Constructor
//
//		/// <summary>
//		/// Default Contructor for LRRDQSettings ,should initialize the private memebers
//		/// </summary>
//		public LegendDetails()
//		{
//			this.ItemType = typeof(LegendDetail);
//			this.ItemAdded+=new EventHandler(LegendDetails_ItemAdded);
//		}
//
//		#endregion
//
//		#region Public Methods
//		public new LegendDetail this[int index] 
//		{
//			get 
//			{
//				return (LegendDetail)(base[index]);
//			}
//			set 
//			{
//				base[index] = value;
//			}
//		}
//		public new LegendDetails GetChanges()
//		{
//			return (LegendDetails) base.GetChanges();
//		}
//		public LegendDetail GetLegendDetailFromID(string ID)
//		{
//			try
//			{
//				return (LegendDetail)_legendDetailHash[ID];
//			}
//			catch
//			{
//				return null;
//			}
//		}
//		private void LegendDetails_ItemAdded(object sender, EventArgs e)
//		{
//			LegendDetail legendDetail = sender as LegendDetail;
//			if(legendDetail.ID != null && !_legendDetailHash.ContainsKey(legendDetail.ID))
//				_legendDetailHash.Add(legendDetail.ID,legendDetail);
//		}
//		#endregion
//		#region Fields
//			private Hashtable	_legendDetailHash = new Hashtable();
//		#endregion
//
//	}
//	public class LegendDetail : BaseObject
//	{
//		#region Constructor
//
//		/// <summary>
//		/// Default Contructor for LRRDQSettings ,should initialize the private memebers
//		/// </summary>
//		public LegendDetail()
//		{
//			//
//			// TODO: Add constructor logic here
//			//
//		}
//
//		#endregion
//
//		#region Public Properties
//		public string Name
//		{
//			get{return _name;}
//			set
//			{
//				_name = value;
//				if(NameChanged != null)
//					NameChanged(this,new EventArgs());
//			}
//		}
//		public string ID
//		{
//			get{return _ID;}
//			set
//			{
//				_ID = value;
//			}
//		}
//
//		public string Value
//		{
//		 	get{return _value;}
//		 	set
//			{
//				_value = value;
//				if(_value != "")
//				{
//					float nRange =float.Parse(_value);
//					string nRangeIndex = AnalyzeDataQuality.GetDQRangeImageIndex(nRange);
//					if(nRangeIndex != "")
//						this.Image=int.Parse(nRangeIndex);
//				}
//				else
//					this.Image= 0;
//			}
//		}
//		public int Image
//		{
//			get{return _Image;}
//			set
//			{
//				_Image = value;
//				if(ImageChanged != null)
//					ImageChanged(this,new EventArgs());
//			}
//		}
//
//		#endregion
//
//		#region Fields
//		private string _name = "";
//		private string _value = "";
//		private string _ID = "";
//		private int _Image = 0;
//		#endregion
//
//		#region Fields
//			public event EventHandler  NameChanged; 
//			public event EventHandler  ImageChanged; 
//		#endregion
//		
//
//	}

}
