using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.BusinessObjects;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for ITrend.
	/// </summary>
	public interface ITrend
	{
		bool IsTrendUOMChanged(string trendScheme, IProperty iProp, string modeID, string currentUOM);
		
		void InitTrend(string trendScheme, IProperty iProp, string modeID, string currentUOM);

        void InitTrend(TrendSetting trendSetting, ComboBox comboBoxUOM);

		string ErrorMsg
		{
			get;
			set;
		}
		
		System.Windows.Forms.Form FormOwner
		{
			get;
			set;
		}

		DateTime StartTime
		{
			get;
			set;
		}

		DateTime EndTime
		{
			get;
			set;
		}

		DateTime ActualStartTime
		{
			get;
		}

		DateTime ActualEndTime
		{
			get;
		}

		bool IsDateInitialized
		{
			get;
			set;
		}

		void AdjustXScale(string trendScheme);
	}
}
