using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageLogger;
using Symcon.BusinessObjects; 
namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControl1.
	/// </summary>
	public class OptionsUserControl : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.Panel pnlLabel;
		private System.Windows.Forms.Label lblText;
		private System.Windows.Forms.UserControl _activeUserControl;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;

		private Hashtable	_userControlHashMap = null;
		public static bool saved=false;

		private string _activeID;

		public OptionsUserControl()
		{

			InitializeComponent();
			_userControlHashMap = new Hashtable();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pnlLabel = new System.Windows.Forms.Panel();
			this.lblText = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.pnlLabel.SuspendLayout();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlLabel
			// 
			this.pnlLabel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlLabel.Controls.Add(this.lblText);
			this.pnlLabel.Dock = System.Windows.Forms.DockStyle.Top;
			this.pnlLabel.Location = new System.Drawing.Point(0, 0);
			this.pnlLabel.Name = "pnlOUCLabel";
			this.pnlLabel.Size = new System.Drawing.Size(552, 32);
			this.pnlLabel.TabIndex = 5;
			// 
			// lblText
			// 
			this.lblText.BackColor = System.Drawing.SystemColors.AppWorkspace;
			this.lblText.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lblText.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblText.ForeColor = System.Drawing.SystemColors.ControlLightLight;
			this.lblText.Location = new System.Drawing.Point(0, 0);
			this.lblText.Name = "lblText";
			this.lblText.Size = new System.Drawing.Size(550, 30);
			this.lblText.TabIndex = 1;
			this.lblText.Tag = "SID_PJCTCONFIGURATION";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.panel2);
			this.panel1.Controls.Add(this.pnlLabel);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panelOUC1";
			this.panel1.Size = new System.Drawing.Size(552, 360);
			this.panel1.TabIndex = 6;
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.Color.White;
			this.panel2.Controls.Add(this.panel3);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.DockPadding.Top = 1;
			this.panel2.Location = new System.Drawing.Point(0, 32);
			this.panel2.Name = "panelOUC2";
			this.panel2.Size = new System.Drawing.Size(552, 328);
			this.panel2.TabIndex = 6;
			// 
			// panel3
			// 
			this.panel3.BackColor = System.Drawing.Color.White;
			this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel3.DockPadding.Top = 1;
			this.panel3.Location = new System.Drawing.Point(0, 1);
			this.panel3.Name = "panelOUC3";
			this.panel3.Size = new System.Drawing.Size(552, 327);
			this.panel3.TabIndex = 7;
			// 
			// OptionsUserControl
			// 
			this.Controls.Add(this.panel1);
			this.Name = "OptionsUserControl";
			this.Size = new System.Drawing.Size(552, 360);
			this.Tag = "SID_OPTIONSUSERCTRL";
			this.pnlLabel.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Properties

		public string CaptionText
		{
			get{return lblText.Text;}
			set
			{
				lblText.Text = value;
			}
		}

		public UserControl ActivePane
		{
			get
			{
				return _activeUserControl;
			}
			set
			{
				this.panel2.Controls.Clear();
				_activeUserControl = value;
				if(value!=null)
					this.panel2.Controls.Add(_activeUserControl);
					//_activeUserControl.Dock=DockStyle.Fill;
			}
		}
		#endregion

		#region Methods

		public void AddUserControl(UserControl ctl,int identifier)
		{
			if(_userControlHashMap != null)
			{
				if(!_userControlHashMap.ContainsKey(identifier))
					_userControlHashMap.Add(identifier,ctl);
			}

		}
		
		public UserControl GetControl(string id)
		{
			if(_userControlHashMap != null)
			{
				if(_userControlHashMap.ContainsKey(id))
				{
					UserControl userCtrl = _userControlHashMap[id] as UserControl;
					return userCtrl;
				}
			}
			return null;
		}

		public void ActivateControl(string id)
		{
			_activeID = id;
			if(_userControlHashMap != null)
			{
				panel2.BringToFront();
				if(_userControlHashMap.ContainsKey(id))
				{
					UserControl cont  = (UserControl)_userControlHashMap[id];
					cont.BringToFront();
				}
				else
				{
					try
					{
						UserControl cont  = CreateUserControl(id);
						_userControlHashMap.Add(id,cont);
						panel2.Controls.Add(cont);
						cont.BringToFront();
					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(OptionsUserControl),"ActivateControl:"+ex.Message  ,Logger.Level.Debug);
					}
				}

			}
			else
			{
				panel3.BringToFront();
			}
		}

		public UserControlPersistance GetUISettingsControl()
		{
			if(_userControlHashMap.ContainsKey(12))
			{
				return (UserControlPersistance)_userControlHashMap[12];
			}
			else
			{
				return null;
			}
		}

		#endregion

		#region Private Methods

		public UserControl CreateUserControl(string id)
		{
			UserControl uc = null;
			try
			{
				
				switch(id)
				{
					case "SID_MODE_DEF":
						uc = new UserControlModeDefn();
						break;
					case "SID_MODE_SETS":
						uc = new ModesSet();
						break;
					case "SID_UOM_DEF":
						uc = new UserControlUOMDefinition();
						break;
					case "SID_UOM_TYPE_DEF":
						uc = new UserControUOMTypeDefinition();
						break;
					case "SID_UOM_SET_DEF":
						uc = new UserControlUOMSetDefinition();
						break;
					case "SID_QUALIFIERS":
						uc = new UserControlQualifiers();
						break;
					case "SID_CHEMICAL_COMP":
						uc = new UserControlChemicalComponents();
						break;
					case "SID_DATA_ARRAYS":
						uc = new UserControlDataArrays();
						break;
					case "SID_DB_INFO":
						uc = new UserControlDataBase();
						break;
					case "SID_9":
						uc = new UserControlHistorianInfo();
						break;
					case "SID_UCF_DEF":
						uc = new UserControlUCFDefinition();
						break;
					case "SID_AVAILABLE_REFG":
						uc = new UserControlAvailableRefregerants();
						break;
					case "SID_PERSISTANCE":
						uc = new UserControlPersistance();
						break;
					case "SID_13":
						uc = new UserControlDataBaseConnectionInfos(CollectionNames.TUNING);
						break;
					case "SID_14":
						uc = new UserControlDataBaseConnectionInfos(CollectionNames.OFFLINE);
						break;
					case "SID_15":
						uc = new UserControlDataBaseConnectionInfos(CollectionNames.RECORDING_VALUES);
						break;
					case "SID_REMOT_SERVER_INFO":
						uc = new UserControlRemotingConnectionInfos();
						break;
					case "SID_CONFIG_UOMS":
						uc = new UserControlConfiguredUOMs();
						break;
					case "SID_18":
						uc = new UserControlBlank();
						break;
					case "SID_CONSTANT":
						uc = new UserControlConstants();
						break;
					case "SID_CONST_HIST_MAPPING":
						uc = new UserControlConstantHistMapping();
						break;
					case "SID_HIST_TEXT_COLLECTION":
						uc= new UserControlHistorianTextCollection();
						break;
					case "SID_MSG_SERVER":
						uc= new UserControlMessagingServer();
						break;
					case "SID_EVV_DEFN":
						uc= new UserControlEVVDefinitions();
						break;
					case "SID_ONLINE_HIST_DETL":
						uc = new UserControlDataHistorian/*UserControlHistorianConnectionDetails*/();
						break;
					case "SID_45":
						uc = new UserControlDataTypeDefinition();
						break;
					case "SID_TREND_OPTIONS":
						uc = new UserControlTrendOptions();
						break;
					case "SID_TREND_TEMPLATES":
						uc = new UserControlTrendTemplates();
						break;
					case "SID_TREND_COMPRESSION":
						uc = new UserControlTrendCompressionOptions();
						break;
                    case "SID_ROLL_UP_TYPE":
                        uc = new UserControlRollUpType(); 
                        break;
                    case "SID_EXCEL_VIEWS":
                        uc = new UserControlExcelViewConfig();
                        break;
					default:
						break;
				}
				uc.Dock = DockStyle.Fill;
				uc.Load += new EventHandler(uc_Load);
				return uc;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(OptionsUserControl),"CreateUserControl:"+ex.Message  ,Logger.Level.Debug);
				return uc;
			}



		}
		private void uc_Load(object sender, EventArgs e)
		{
//			if(sender.GetType() != typeof(UserControlDataBaseConnectionInfos))
				ApplicationPersistanceUtil.ApplyGridSettings(sender as Control,this, "260");
		}

		#endregion

		#region ILRRUIContainer Members

		public void Refresh()
		{
			foreach(ILRRUIContainer cont in _userControlHashMap.Values)
			{
				
				cont.Refresh();
				
			}
		}

		public void Save()
		{
			// TODO:  Add OptionsUserControl.Save implementation
			saved=false;
			try
			{
				foreach(object cont in _userControlHashMap.Values)
				{
                    ILRRUIContainer uiContainer = cont as ILRRUIContainer;
                    if (uiContainer != null)
                    {
                        uiContainer.Save();    
                    }
				}
			}
			catch(Exception	ex)
			{
				Logger.LogMessage(typeof(OptionsUserControl),"Save:"+ex.Message  ,Logger.Level.Error);
			}
			if(saved==true)
			{
				LRRMessagBox.ShowMessage("SID_SAVEDINFO",true);
				saved=false;
			}
			else
			{
				LRRMessagBox.ShowMessage("SID_NODATASAVED",true);
				saved=false;
			}
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add OptionsUserControl.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add OptionsUserControl.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add OptionsUserControl.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add OptionsUserControl.Print implementation
//			foreach(ILRRUIContainer cont in _userControlHashMap.Values)
//			{
				ILRRUIContainer cont = _userControlHashMap[_activeID] as ILRRUIContainer;
				cont.Print();
//			}
		}

		public void Delete()
		{
			// TODO:  Add OptionsUserControl.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add OptionsUserControl.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add OptionsUserControl.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add OptionsUserControl.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add OptionsUserControl.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add OptionsUserControl.Export implementation
		}

		public void SelectionPaste()
		{
			foreach(ILRRUIContainer cont in _userControlHashMap.Values)
			{
				
				cont.SelectionPaste();
				
			}
		}

		public void RightLevel()
		{
			// TODO:  Add OptionsUserControl.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add OptionsUserControl.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add OptionsUserControl.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add OptionsUserControl.DownLevel implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add OptionsUserControl.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add OptionsUserControl.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add OptionsUserControl.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add OptionsUserControl.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add OptionsUserControl.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add OptionsUserControl.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add OptionsUserControl.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add OptionsUserControl.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add OptionsUserControl.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add OptionsUserControl.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add OptionsUserControl.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add OptionsUserControl.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add OptionsUserControl.SupportsSelectionPaste implementation
			return true;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add OptionsUserControl.SupportsLevel implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add OptionsUserControl.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OptionsUserControl.ParentTabControl setter implementation
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add OptionsUserControl.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OptionsUserControl.ParentTabPage setter implementation
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			foreach(ILRRUIContainer cont in _userControlHashMap.Values)
			{
				cont.ClearSort();
			}
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add OptionsUserControl.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
			foreach(ILRRUIContainer cont in _userControlHashMap.Values)
			{
				
				cont.CopyUOMTypes();
				
			}
		}

		public bool SupportsCopyUOMTypes()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add OptionsUserControl.PrintPreview implementation
//			foreach(ILRRUIContainer cont in _userControlHashMap.Values)
//			{
				ILRRUIContainer cont = _userControlHashMap[_activeID] as ILRRUIContainer;
				cont.PrintPreview();
//			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add OptionsUserControl.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add OptionsUserControl.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add OptionsUserControl.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add OptionsUserControl.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add OptionsUserControl.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add OptionsUserControl.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add OptionsUserControl.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add OptionsUserControl.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add OptionsUserControl.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add OptionsUserControl.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add OptionsUserControl.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add OptionsUserControl.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add OptionsUserControl.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add OptionsUserControl.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add OptionsUserControl.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add OptionsUserControl.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add OptionsUserControl.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add OptionsUserControl.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
