using System;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.Utils.MessageLogger;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals;
using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.Globals.Enums;
using Symcon.LightRidge.HistorianConnect;
using Symcon.Utils.HeaderDispatcher;


namespace Symcon.LightRidge.PEAdvisor.UserControls
{

	public enum CollectionNames
	{
		TUNING,
		OFFLINE,
		RECORDING_VALUES,
		NONE
	}

	/// <summary>
	/// Summary description for DataBaseConnectionInfosForm.
	/// </summary>
	public class UserControlDataBaseConnectionInfos: System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.Panel pnlFull;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridInfo;
		private System.Windows.Forms.Button btnTestConn;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panelDBCI1;
        private SplitContainer splitContainer1;
        private GroupBox grpPurgeRecording;
        private Label lblRecDBConnectionStatus;
        private Button btnPurgeRecording;
        private RadioButton rbRecByRunset;
        private GroupBox grpRunset;
        private Label label1;
        private ComboBox cmbRunSets;
        private RadioButton rbRecByDate;
        private GroupBox grpByDate;
        private DateTimePicker dtRecStartDate;
        private Label lblStartDate;
        private Label lblEndDate;
        private DateTimePicker dtRecEndDate;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlDataBaseConnectionInfos()
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);  
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}
        private CollectionNames _collectionName;
		public UserControlDataBaseConnectionInfos(CollectionNames collectionName)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);  
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            _collectionName = collectionName;
			switch(collectionName)
			{
				case CollectionNames.TUNING:
					CustCollection = _lrrApp.GetOptions().TuningConnectionObj;
					break;
				case CollectionNames.OFFLINE:
					CustCollection = _lrrApp.GetOptions().OfflineConnectionObj;
					break;
				case CollectionNames.RECORDING_VALUES:
					CustCollection = _lrrApp.GetOptions().RecordingValuesConnectionObj;
					break;
			}
            InitializePurgePanel();
			BindGrid();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.pnlFull = new System.Windows.Forms.Panel();
            this.splitContainer1 = new System.Windows.Forms.SplitContainer();
            this.gridInfo = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.grpPurgeRecording = new System.Windows.Forms.GroupBox();
            this.rbRecByRunset = new System.Windows.Forms.RadioButton();
            this.btnPurgeRecording = new System.Windows.Forms.Button();
            this.grpRunset = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.cmbRunSets = new System.Windows.Forms.ComboBox();
            this.rbRecByDate = new System.Windows.Forms.RadioButton();
            this.grpByDate = new System.Windows.Forms.GroupBox();
            this.dtRecStartDate = new System.Windows.Forms.DateTimePicker();
            this.lblStartDate = new System.Windows.Forms.Label();
            this.lblEndDate = new System.Windows.Forms.Label();
            this.dtRecEndDate = new System.Windows.Forms.DateTimePicker();
            this.btnTestConn = new System.Windows.Forms.Button();
            this.panelDBCI1 = new System.Windows.Forms.Panel();
            this.lblRecDBConnectionStatus = new System.Windows.Forms.Label();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.pnlFull.SuspendLayout();
            this.splitContainer1.Panel1.SuspendLayout();
            this.splitContainer1.Panel2.SuspendLayout();
            this.splitContainer1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridInfo)).BeginInit();
            this.grpPurgeRecording.SuspendLayout();
            this.grpRunset.SuspendLayout();
            this.grpByDate.SuspendLayout();
            this.panelDBCI1.SuspendLayout();
            this.SuspendLayout();
            // 
            // pnlFull
            // 
            this.pnlFull.Controls.Add(this.splitContainer1);
            this.pnlFull.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlFull.Location = new System.Drawing.Point(0, 0);
            this.pnlFull.Name = "pnlFull";
            this.pnlFull.Size = new System.Drawing.Size(760, 343);
            this.pnlFull.TabIndex = 0;
            // 
            // splitContainer1
            // 
            this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.splitContainer1.Location = new System.Drawing.Point(0, 0);
            this.splitContainer1.Name = "splitContainer1";
            this.splitContainer1.Orientation = System.Windows.Forms.Orientation.Horizontal;
            // 
            // splitContainer1.Panel1
            // 
            this.splitContainer1.Panel1.Controls.Add(this.gridInfo);
            // 
            // splitContainer1.Panel2
            // 
            this.splitContainer1.Panel2.Controls.Add(this.grpPurgeRecording);
            this.splitContainer1.Panel2.Padding = new System.Windows.Forms.Padding(5);
            this.splitContainer1.Size = new System.Drawing.Size(760, 343);
            this.splitContainer1.SplitterDistance = 169;
            this.splitContainer1.TabIndex = 1;
            // 
            // gridInfo
            // 
            this.gridInfo.BackColor = System.Drawing.SystemColors.Window;
            this.gridInfo.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridInfo.Location = new System.Drawing.Point(0, 0);
            this.gridInfo.Name = "gridInfo";
            this.gridInfo.Size = new System.Drawing.Size(760, 169);
            this.gridInfo.TabIndex = 0;
            this.gridInfo.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridInfo.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridInfo.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridInfo.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridInfo.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridInfo.VersionInfo = "3.301.0.0";
            this.gridInfo.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridInfo_RecordDeleting);
            this.gridInfo.TableControlCellButtonClicked += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellButtonClickedEventHandler(this.gridInfo_TableControlCellButtonClicked);
            this.gridInfo.TableControlCheckBoxClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridInfo_TableControlCheckBoxClick);
            // 
            // grpPurgeRecording
            // 
            this.grpPurgeRecording.Controls.Add(this.rbRecByRunset);
            this.grpPurgeRecording.Controls.Add(this.btnPurgeRecording);
            this.grpPurgeRecording.Controls.Add(this.grpRunset);
            this.grpPurgeRecording.Controls.Add(this.rbRecByDate);
            this.grpPurgeRecording.Controls.Add(this.grpByDate);
            this.grpPurgeRecording.Dock = System.Windows.Forms.DockStyle.Fill;
            this.grpPurgeRecording.Location = new System.Drawing.Point(5, 5);
            this.grpPurgeRecording.Name = "grpPurgeRecording";
            this.grpPurgeRecording.Size = new System.Drawing.Size(750, 160);
            this.grpPurgeRecording.TabIndex = 1;
            this.grpPurgeRecording.TabStop = false;
            this.grpPurgeRecording.Tag = "SID_PURGE_DATA";
            this.grpPurgeRecording.Text = "Purge Data";
            // 
            // rbRecByRunset
            // 
            this.rbRecByRunset.AutoSize = true;
            this.rbRecByRunset.Location = new System.Drawing.Point(26, 71);
            this.rbRecByRunset.Name = "rbRecByRunset";
            this.rbRecByRunset.Size = new System.Drawing.Size(78, 17);
            this.rbRecByRunset.TabIndex = 1;
            this.rbRecByRunset.Tag = "SID_BY_RUN_SET";
            this.rbRecByRunset.Text = "by Run Set";
            this.rbRecByRunset.UseVisualStyleBackColor = true;
            this.rbRecByRunset.CheckedChanged += new System.EventHandler(this.rbRecByDate_CheckedChanged);
            // 
            // btnPurgeRecording
            // 
            this.btnPurgeRecording.Location = new System.Drawing.Point(669, 128);
            this.btnPurgeRecording.Name = "btnPurgeRecording";
            this.btnPurgeRecording.Size = new System.Drawing.Size(75, 23);
            this.btnPurgeRecording.TabIndex = 9;
            this.btnPurgeRecording.Tag = "SID_PURGE";
            this.btnPurgeRecording.Text = "Purge";
            this.btnPurgeRecording.UseVisualStyleBackColor = true;
            this.btnPurgeRecording.Click += new System.EventHandler(this.btnPurgeRecording_Click);
            // 
            // grpRunset
            // 
            this.grpRunset.Controls.Add(this.label1);
            this.grpRunset.Controls.Add(this.cmbRunSets);
            this.grpRunset.Location = new System.Drawing.Point(16, 73);
            this.grpRunset.Name = "grpRunset";
            this.grpRunset.Size = new System.Drawing.Size(728, 46);
            this.grpRunset.TabIndex = 8;
            this.grpRunset.TabStop = false;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(7, 24);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(46, 13);
            this.label1.TabIndex = 6;
            this.label1.Tag = "SID_RUN_SET";
            this.label1.Text = "Run Set";
            // 
            // cmbRunSets
            // 
            this.cmbRunSets.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.Append;
            this.cmbRunSets.FormattingEnabled = true;
            this.cmbRunSets.Location = new System.Drawing.Point(70, 19);
            this.cmbRunSets.Name = "cmbRunSets";
            this.cmbRunSets.Size = new System.Drawing.Size(121, 21);
            this.cmbRunSets.TabIndex = 6;
            // 
            // rbRecByDate
            // 
            this.rbRecByDate.AutoSize = true;
            this.rbRecByDate.Checked = true;
            this.rbRecByDate.Location = new System.Drawing.Point(26, 15);
            this.rbRecByDate.Name = "rbRecByDate";
            this.rbRecByDate.Size = new System.Drawing.Size(62, 17);
            this.rbRecByDate.TabIndex = 0;
            this.rbRecByDate.TabStop = true;
            this.rbRecByDate.Tag = "SID_BY_DATE";
            this.rbRecByDate.Text = "by Date";
            this.rbRecByDate.UseVisualStyleBackColor = true;
            this.rbRecByDate.CheckedChanged += new System.EventHandler(this.rbRecByDate_CheckedChanged);
            // 
            // grpByDate
            // 
            this.grpByDate.Controls.Add(this.dtRecStartDate);
            this.grpByDate.Controls.Add(this.lblStartDate);
            this.grpByDate.Controls.Add(this.lblEndDate);
            this.grpByDate.Controls.Add(this.dtRecEndDate);
            this.grpByDate.Location = new System.Drawing.Point(16, 17);
            this.grpByDate.Name = "grpByDate";
            this.grpByDate.Size = new System.Drawing.Size(728, 50);
            this.grpByDate.TabIndex = 7;
            this.grpByDate.TabStop = false;
            // 
            // dtRecStartDate
            // 
            this.dtRecStartDate.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dtRecStartDate.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dtRecStartDate.Location = new System.Drawing.Point(95, 16);
            this.dtRecStartDate.Name = "dtRecStartDate";
            this.dtRecStartDate.Size = new System.Drawing.Size(200, 20);
            this.dtRecStartDate.TabIndex = 2;
            // 
            // lblStartDate
            // 
            this.lblStartDate.AutoSize = true;
            this.lblStartDate.Location = new System.Drawing.Point(7, 19);
            this.lblStartDate.Name = "lblStartDate";
            this.lblStartDate.Size = new System.Drawing.Size(84, 13);
            this.lblStartDate.TabIndex = 3;
            this.lblStartDate.Tag = "SID_START_DATETIME";
            this.lblStartDate.Text = "Start Date & Time";
            // 
            // lblEndDate
            // 
            this.lblEndDate.AutoSize = true;
            this.lblEndDate.Location = new System.Drawing.Point(310, 20);
            this.lblEndDate.Name = "lblEndDate";
            this.lblEndDate.Size = new System.Drawing.Size(81, 13);
            this.lblEndDate.TabIndex = 5;
            this.lblEndDate.Tag = "SID_END_DATETIME";
            this.lblEndDate.Text = "End Date & Time";
            // 
            // dtRecEndDate
            // 
            this.dtRecEndDate.CustomFormat = "dd-MMM-yyyy HH:mm:ss";
            this.dtRecEndDate.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dtRecEndDate.Location = new System.Drawing.Point(394, 15);
            this.dtRecEndDate.Name = "dtRecEndDate";
            this.dtRecEndDate.Size = new System.Drawing.Size(200, 20);
            this.dtRecEndDate.TabIndex = 4;
            // 
            // btnTestConn
            // 
            this.btnTestConn.Location = new System.Drawing.Point(368, 13);
            this.btnTestConn.Name = "btnTestConn";
            this.btnTestConn.Size = new System.Drawing.Size(96, 23);
            this.btnTestConn.TabIndex = 1;
            this.btnTestConn.Tag = "SID_TESTCONNECTTION";
            this.btnTestConn.Click += new System.EventHandler(this.btnTestConn_Click);
            // 
            // panelDBCI1
            // 
            this.panelDBCI1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panelDBCI1.Controls.Add(this.lblRecDBConnectionStatus);
            this.panelDBCI1.Controls.Add(this.btnTestConn);
            this.panelDBCI1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panelDBCI1.Location = new System.Drawing.Point(0, 343);
            this.panelDBCI1.Name = "panelDBCI1";
            this.panelDBCI1.Size = new System.Drawing.Size(760, 67);
            this.panelDBCI1.TabIndex = 4;
            // 
            // lblRecDBConnectionStatus
            // 
            this.lblRecDBConnectionStatus.AutoSize = true;
            this.lblRecDBConnectionStatus.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblRecDBConnectionStatus.ForeColor = System.Drawing.Color.Maroon;
            this.lblRecDBConnectionStatus.Location = new System.Drawing.Point(27, 18);
            this.lblRecDBConnectionStatus.Name = "lblRecDBConnectionStatus";
            this.lblRecDBConnectionStatus.Size = new System.Drawing.Size(0, 13);
            this.lblRecDBConnectionStatus.TabIndex = 10;
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter1.Enabled = false;
            this.splitter1.Location = new System.Drawing.Point(0, 340);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(760, 3);
            this.splitter1.TabIndex = 3;
            this.splitter1.TabStop = false;
            // 
            // UserControlDataBaseConnectionInfos
            // 
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.pnlFull);
            this.Controls.Add(this.panelDBCI1);
            this.Name = "UserControlDataBaseConnectionInfos";
            this.Size = new System.Drawing.Size(760, 410);
            this.Tag = "SID_DBCONINFO";
            this.pnlFull.ResumeLayout(false);
            this.splitContainer1.Panel1.ResumeLayout(false);
            this.splitContainer1.Panel2.ResumeLayout(false);
            this.splitContainer1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridInfo)).EndInit();
            this.grpPurgeRecording.ResumeLayout(false);
            this.grpPurgeRecording.PerformLayout();
            this.grpRunset.ResumeLayout(false);
            this.grpRunset.PerformLayout();
            this.grpByDate.ResumeLayout(false);
            this.grpByDate.PerformLayout();
            this.panelDBCI1.ResumeLayout(false);
            this.panelDBCI1.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		public void BindGrid()
		{
			SyncGridUtilities.InitializeGridLookAndFeel(gridInfo);
			CustomCollection custCollection = CustCollection as CustomCollection;
			SyncGridUtilities.InitializeGridColumns(gridInfo,custCollection.ItemType,null,true,null);

			gridInfo.TableModel.Model.CellModels.Add("EllipsisText", new  EllipsisCellModel(gridInfo.TableModel.Model));
			this.gridInfo.TableDescriptor.Columns[1].Appearance.AddNewRecordFieldCell.CellType ="TextBox";
			this.gridInfo.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.CellType ="EllipsisText";
			this.gridInfo.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.CellType ="ComboBox";
			this.gridInfo.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.DataSource = _lrrApp.GetOptions().DBTypes;
			this.gridInfo.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.ShowCurrentCell;
			/*this.gridInfo.TableDescriptor.Columns[7].Appearance.AnyRecordFieldCell.CellType ="CheckBox";
			this.gridInfo.TableDescriptor.Columns[7].Appearance.AnyRecordFieldCell.HorizontalAlignment=GridHorizontalAlignment.Center;*/

			gridInfo.DataSource = custCollection;

			this.gridInfo.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
	
		}

		public DBInfo GetDBInfo()
		{
			CustomCollection custCollection = CustCollection as CustomCollection;
			DBInfo dbInfo = null;
			if(custCollection.ItemType == typeof(LRRTuningConnection))
			    dbInfo = _lrrApp.GetOptions().TuningConnectionObj.GetActiveTuningDBInfo();
			else if(custCollection.ItemType == typeof(LRRRecordingValuesConnection))
				dbInfo = _lrrApp.GetOptions().RecordingValuesConnectionObj.GetActiveRecordingValuesDBInfo();
			else if(custCollection.ItemType == typeof(LRROfflineConnection))
				dbInfo = _lrrApp.GetOptions().OfflineConnectionObj.GetActiveOfflineDBInfo();
			return dbInfo;

		}
		#endregion

		#region Properties
		public object CustCollection
		{
			get{ return _custCollection;}
			set
			{
				_custCollection = value;
			}
		}
		#endregion

		#region Fields
		private object _custCollection;
		private LRRApp _lrrApp;
		#endregion

		private void gridInfo_TableControlCellButtonClicked(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellButtonClickedEventArgs e)
		{
			if(e.TableControl.Table.TableModel.Model[e.Inner.RowIndex,e.Inner.ColIndex].CellType=="EllipsisText")
			{
				OpenFileDialog flDialog = new OpenFileDialog();
                flDialog.Filter = "*.mdb |";
				if(flDialog.ShowDialog() == DialogResult.OK)
				{
					string fName=Path.GetFullPath(flDialog.FileName);
					GridTableCellStyleInfo gtsif = gridInfo.TableControl.Model[e.Inner.RowIndex,e.Inner.ColIndex];
					gtsif.ApplyText(fName);
				}
			}
		}

		private void gridInfo_TableControlCheckBoxClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
//			object current = gridInfo.CurrencyManager.Current;
//			CustomCollection custCollection = CustCollection as CustomCollection;
//			for(int i=0;i < custCollection.Count;i++)
//			{
//				object bo = custCollection[i];
//				if(bo.Equals(current))
//					continue;
//				if(bo.GetType().GetProperty("IsActive") != null)
//				{
//					bo.GetType().GetProperty("IsActive").SetValue(bo,false,null);
//				}
//			}
//			for(int i = 4; i < gridInfo.Table.TableModel.RowCount;i++)
//			{
//				if(i == e.Inner.RowIndex)
//					continue;
//
//				GridTableCellStyleInfo gtsif = gridInfo.TableControl.Model[i,e.Inner.ColIndex];
//				gtsif.CellValue = false;
//			}
//			gridInfo.Refresh();
		}
		#region ILRRUIContainer Members

		public void Refresh()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Refresh implementation
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Print implementation
			if(gridInfo.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridInfo,true);
			}

		}

		public void Delete()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.DownLevel implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsLevel implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add UserControlDataBaseConnectionInfos.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlDataBaseConnectionInfos.ParentTabControl setter implementation
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add UserControlDataBaseConnectionInfos.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add UserControlDataBaseConnectionInfos.ParentTabPage setter implementation
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void Save()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Save implementation
			CustomCollection custCollection = CustCollection as CustomCollection;
			if(custCollection.GetChanges().Count > 0)
			{
				_lrrApp.DBManagerObj.CommitCollection(custCollection.GetChanges());
				_lrrApp.RunControllerObj.Initialize();
				_lrrApp.RecordingValuesManagerObj.Initialize();
				custCollection.RefreshCollection();
				OptionsUserControl.saved	=true;
                if (custCollection.GetType() == typeof(LRRTuningConnections))
                {
                    _lrrApp.GetOptions().TunningConfigurationChanged = true;
                }
                InitializePurgePanel();
			}
		}

		#endregion

        private bool TestConnection()
        {
            DBInfo dbInfo = GetDBInfo();
            if (dbInfo!= null)
            {
                DBManager dbManager;
                try
                {
                    dbManager = new DBManager(dbInfo);
                }
                catch 
                {
                    return false;
                }
                return dbManager.TestConnection(dbInfo);
            }
            return false;
        }

		private void btnTestConn_Click(object sender, System.EventArgs e)
		{
            if (TestConnection())
            {
                LRRMessagBox.ShowMessage("SID_TEST_SUCCESS","SID_TESTSUCCESS",MessageBoxButtons.OK,MessageBoxIcon.Information);    
            }
            else
            {
                LRRMessagBox.ShowMessage("SID_TEST_FAILURE", "SID_TESTFAIL", MessageBoxButtons.OK, MessageBoxIcon.Information);    
            }
            InitializePurgePanel();
            //try
            //{
            //    DBInfo dbInfo = GetDBInfo();
            //    if(dbInfo != null)
            //    {
            //        DBManager dbManager;
            //        try
            //        {
            //            dbManager = new DBManager(dbInfo);
            //        }
            //        catch
            //        {
						
            //            return;
            //        }
            //        bool test = dbManager.TestConnection(dbInfo);
            //        if(test)
            //        {
            //            LRRMessagBox.ShowMessage("SID_TEST_SUCCESS","SID_TESTSUCCESS",MessageBoxButtons.OK,MessageBoxIcon.Information);    
            //        }
            //        else
            //        {
            //            LRRMessagBox.ShowMessage("SID_TEST_FAILURE","SID_TESTFAIL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
            //        }
            //    }
            //    else
            //    {
            //        LRRMessagBox.ShowMessage("SID_TEST_FAILURE","SID_TESTFAIL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
            //    }
            //}
            //catch(Exception ex)
            //{
            //    //LRRMessagBox.ShowMessage("SID_TEST_FAILURE","SID_TESTFAIL",MessageBoxButtons.OK,MessageBoxIcon.Information);    
            //    Logger.LogMessage(typeof(UserControlDataBaseConnectionInfos),"btnTestConn_Click Event:"+ex.Message  ,Logger.Level.Error);
            //}
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridInfo);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.PrintPreview implementation
			if(gridInfo.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridInfo,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsCompositeView implementation
			return false;
		}

		#endregion

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridInfo_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(!_isRecordeDel)
			{
				e.Cancel = true;
				return;
			}
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlDataBaseConnectionInfos.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

        private void btnPurgeRecording_Click(object sender, EventArgs e)
        {
            switch (_collectionName)
            {
                case CollectionNames.TUNING:
                    PurgeTuningData();
                    break;
                case CollectionNames.RECORDING_VALUES:
                    PurgeRecordingValues();
                    break;
                default:
                    break;
            }
            
        }

        private void PurgeTuningData()
        {
            TuningHistorian tuninghist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.TUNNING] as TuningHistorian;
            tuninghist.PurgeData(dtRecStartDate.Value.ToString(Symcon.BusinessObjects.SymConverter.Culture), dtRecEndDate.Value.ToString(Symcon.BusinessObjects.SymConverter.Culture));
        }

        private void PurgeRecordingValues()
        {
            if (rbRecByDate.Checked)
            {
                string sqlSiteComponentPropertyValueChangeUserAndTime = @"Delete From SiteComponentPropertyValueChangeUserAndTime
Where Cast(startTime As DateTime) >= '" + dtRecStartDate.Value.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "' and Cast(EndTime As DateTime) <= '" + dtRecEndDate.Value.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "'";
                _lrrApp.RecordingValuesManagerObj.RecordingValuesDBManagerObj.CommitSQL(sqlSiteComponentPropertyValueChangeUserAndTime);

            }
            else
            {
                LRRRunRecords _lrrRunRecords = new LRRRunRecords();
                string sqlRunRecords = "Delete from RunRecords where RunID = '" + cmbRunSets.SelectedValue + "'";
                _lrrApp.RecordingValuesManagerObj.RecordingValuesDBManagerObj.CommitSQL(sqlRunRecords);
                string sqlSiteComponentPropertyValueChangeUserAndTime = "Delete from SiteComponentPropertyValueChangeUserAndTime where RunID = '" + cmbRunSets.SelectedValue + "'";
                _lrrApp.RecordingValuesManagerObj.RecordingValuesDBManagerObj.CommitSQL(sqlSiteComponentPropertyValueChangeUserAndTime);
                _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords);
                cmbRunSets.DataSource = null;
                cmbRunSets.DataSource = _lrrRunRecords;
                cmbRunSets.DisplayMember = "RunName";
                cmbRunSets.ValueMember = "RunID";
            }
        }

        private void rbRecByDate_CheckedChanged(object sender, EventArgs e)
        {
            grpByDate.Enabled = rbRecByDate.Checked;
            grpRunset.Enabled = rbRecByRunset.Enabled;
        }

        private void InitializePurgePanel()
        {
            switch (_collectionName)
            {
                case CollectionNames.TUNING:
                    InitializePurgePanelForTuning();
                    break;
                case CollectionNames.OFFLINE:
                    grpPurgeRecording.Visible = false;
                    break;
                case CollectionNames.RECORDING_VALUES:
                    InitializePurgePanelForRecordingValues();
                    break;
                case CollectionNames.NONE:
                    break;
                default:
                    break;
            }

        }

        private void InitializePurgePanelForTuning()
        {
            grpPurgeRecording.Text = LRRHeaderText.GetHeaderString("SID_Purge_DATABASE").Replace("{0:S}", "Tuning");// "Purge Tuninig Database";
            if (TestConnection())
            {
                rbRecByDate.Visible = false;
                rbRecByRunset.Visible = false;
                grpPurgeRecording.Enabled = true;
                grpRunset.Visible = false;
                lblRecDBConnectionStatus.Text = LRRHeaderText.GetHeaderString("SID_CONNECTED_TO") /*"Connected to: "*/ + GetDBInfo().DatabaseName;
            }
            else
            {
                lblRecDBConnectionStatus.Text = LRRHeaderText.GetHeaderString("SID_CONNECTION_FAILED").Replace("{0:S}", "Tuning"); ;//"Connection to Tuninig database could not be established";
                grpPurgeRecording.Enabled = false;
            }
        }

        private void InitializePurgePanelForRecordingValues()
        {
            grpPurgeRecording.Text = LRRHeaderText.GetHeaderString("SID_Purge_DATABASE").Replace("{0:S}", "Recording") ;//"Purge Recording Database";
            if (TestConnection())
            {
                LRRRunRecords _lrrRunRecords = new LRRRunRecords();
                _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords);
                //cmbRunSets.Items.Add("NULL");
                cmbRunSets.DataSource = _lrrRunRecords;
                cmbRunSets.DisplayMember = "RunName";
                cmbRunSets.ValueMember = "RunID";
                grpPurgeRecording.Enabled = true;
                grpByDate.Enabled = rbRecByDate.Checked;
                grpRunset.Enabled = rbRecByRunset.Checked;
                lblRecDBConnectionStatus.Text = LRRHeaderText.GetHeaderString("SID_CONNECTED_TO") + GetDBInfo().DatabaseName;
            }
            else
            {
                lblRecDBConnectionStatus.Text = LRRHeaderText.GetHeaderString("SID_CONNECTION_FAILED").Replace("{0:S}", "Recording");//"Connection to Recording database could not be established";
                grpPurgeRecording.Enabled = false;
            }
        }

        //private void InitializePurgePanelForOffline()
        //{
        //    grpPurgeRecording.Text = "Purge Offline Database";
        //    if (TestConnection())
        //    {
        //        _lrrRunRecords = new LRRRunRecords();
        //        _lrrApp.RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords);
        //        //cmbRunSets.Items.Add("NULL");
        //        cmbRunSets.DataSource = _lrrRunRecords;
        //        cmbRunSets.DisplayMember = "RunName";
        //        cmbRunSets.ValueMember = "RunID";
        //        grpPurgeRecording.Enabled = true;
        //        grpByDate.Enabled = rbDate.Checked;
        //        grpRunset.Enabled = rbRunset.Checked;
        //        lblRecDBConnectionStatus.Text = "Connected to: " + GetDBInfo().DatabaseName;
        //    }
        //    else
        //    {
        //        lblRecDBConnectionStatus.Text = "Connection to Offline database could not be established";
        //        grpPurgeRecording.Enabled = false;
        //    }
        //}
    }
}
