using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.Utils.HeaderDispatcher;  
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlConfiguredUOMs.
	/// </summary>
	public class UserControlConfiguredUOMs : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp						_app;
		string MSCEID="";			
		string MSUIID="";
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TextBox txtActiveModelUOM;
		private System.Windows.Forms.TextBox txtActiveUIUOM;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblActiveUIUOM;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel4;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridActiveUOMSetUI;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridActiveUOMSetMode;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlConfiguredUOMs()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			TextBoxFilling();
			BingGridConfiguredUoms();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.panel2 = new System.Windows.Forms.Panel();
            this.panel4 = new System.Windows.Forms.Panel();
            this.gridActiveUOMSetMode = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.panel3 = new System.Windows.Forms.Panel();
            this.gridActiveUOMSetUI = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.panel1 = new System.Windows.Forms.Panel();
            this.txtActiveModelUOM = new System.Windows.Forms.TextBox();
            this.txtActiveUIUOM = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.lblActiveUIUOM = new System.Windows.Forms.Label();
            this.groupBox1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.panel4.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridActiveUOMSetMode)).BeginInit();
            this.panel3.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridActiveUOMSetUI)).BeginInit();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.panel2);
            this.groupBox1.Controls.Add(this.splitter1);
            this.groupBox1.Controls.Add(this.panel1);
            this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.groupBox1.Location = new System.Drawing.Point(0, 0);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(1072, 608);
            this.groupBox1.TabIndex = 0;
            this.groupBox1.TabStop = false;
            // 
            // panel2
            // 
            this.panel2.Controls.Add(this.panel4);
            this.panel2.Controls.Add(this.splitter2);
            this.panel2.Controls.Add(this.panel3);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel2.Location = new System.Drawing.Point(3, 107);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(1066, 498);
            this.panel2.TabIndex = 2;
            // 
            // panel4
            // 
            this.panel4.Controls.Add(this.gridActiveUOMSetMode);
            this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel4.Location = new System.Drawing.Point(443, 0);
            this.panel4.Name = "panel4";
            this.panel4.Size = new System.Drawing.Size(623, 498);
            this.panel4.TabIndex = 2;
            // 
            // gridActiveUOMSetMode
            // 
            this.gridActiveUOMSetMode.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.LightGray);
            this.gridActiveUOMSetMode.Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.LightGray);
            this.gridActiveUOMSetMode.BackColor = System.Drawing.Color.LightGray;
            this.gridActiveUOMSetMode.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridActiveUOMSetMode.Location = new System.Drawing.Point(0, 0);
            this.gridActiveUOMSetMode.Name = "gridActiveUOMSetMode";
            this.gridActiveUOMSetMode.Size = new System.Drawing.Size(623, 498);
            this.gridActiveUOMSetMode.TabIndex = 1;
            this.gridActiveUOMSetMode.TableDescriptor.AllowEdit = false;
            this.gridActiveUOMSetMode.TableDescriptor.AllowNew = false;
            this.gridActiveUOMSetMode.TableDescriptor.AllowRemove = false;
            this.gridActiveUOMSetMode.Text = "gridGroupingControl1";
            this.gridActiveUOMSetMode.TopLevelGroupOptions.CaptionText = "Configured UOMs for Model: {RecordCount} Items";
            this.gridActiveUOMSetMode.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridActiveUOMSetMode.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridActiveUOMSetMode.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridActiveUOMSetMode.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridActiveUOMSetMode.VersionInfo = "3.301.0.0";
            this.gridActiveUOMSetMode.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridActiveUOMSetMode_TableControlCurrentCellShowingDropDown);
            this.gridActiveUOMSetMode.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridActiveUOMSetMode_TableControlCellClick);
            // 
            // splitter2
            // 
            this.splitter2.Location = new System.Drawing.Point(440, 0);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(3, 498);
            this.splitter2.TabIndex = 1;
            this.splitter2.TabStop = false;
            // 
            // panel3
            // 
            this.panel3.Controls.Add(this.gridActiveUOMSetUI);
            this.panel3.Dock = System.Windows.Forms.DockStyle.Left;
            this.panel3.Location = new System.Drawing.Point(0, 0);
            this.panel3.Name = "panel3";
            this.panel3.Size = new System.Drawing.Size(440, 498);
            this.panel3.TabIndex = 0;
            // 
            // gridActiveUOMSetUI
            // 
            this.gridActiveUOMSetUI.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.LightGray);
            this.gridActiveUOMSetUI.Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.LightGray);
            this.gridActiveUOMSetUI.BackColor = System.Drawing.Color.LightGray;
            this.gridActiveUOMSetUI.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridActiveUOMSetUI.Location = new System.Drawing.Point(0, 0);
            this.gridActiveUOMSetUI.Name = "gridActiveUOMSetUI";
            this.gridActiveUOMSetUI.Size = new System.Drawing.Size(440, 498);
            this.gridActiveUOMSetUI.TabIndex = 1;
            this.gridActiveUOMSetUI.TableDescriptor.AllowEdit = false;
            this.gridActiveUOMSetUI.TableDescriptor.AllowNew = false;
            this.gridActiveUOMSetUI.TableDescriptor.AllowRemove = false;
            this.gridActiveUOMSetUI.Text = "gridGroupingControl1";
            this.gridActiveUOMSetUI.TopLevelGroupOptions.CaptionText = "Configured UOMs for User Interface: {RecordCount} Items";
            this.gridActiveUOMSetUI.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridActiveUOMSetUI.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridActiveUOMSetUI.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridActiveUOMSetUI.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridActiveUOMSetUI.VersionInfo = "3.301.0.0";
            this.gridActiveUOMSetUI.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridActiveUOMSetUI_TableControlCurrentCellShowingDropDown);
            this.gridActiveUOMSetUI.TableControlCellClick += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventHandler(this.gridActiveUOMSetUI_TableControlCellClick);
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(3, 104);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(1066, 3);
            this.splitter1.TabIndex = 1;
            this.splitter1.TabStop = false;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.txtActiveModelUOM);
            this.panel1.Controls.Add(this.txtActiveUIUOM);
            this.panel1.Controls.Add(this.label2);
            this.panel1.Controls.Add(this.lblActiveUIUOM);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Location = new System.Drawing.Point(3, 16);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(1066, 88);
            this.panel1.TabIndex = 0;
            // 
            // txtActiveModelUOM
            // 
            this.txtActiveModelUOM.Location = new System.Drawing.Point(440, 56);
            this.txtActiveModelUOM.Name = "txtActiveModelUOM";
            this.txtActiveModelUOM.ReadOnly = true;
            this.txtActiveModelUOM.Size = new System.Drawing.Size(168, 20);
            this.txtActiveModelUOM.TabIndex = 7;
            // 
            // txtActiveUIUOM
            // 
            this.txtActiveUIUOM.Location = new System.Drawing.Point(440, 16);
            this.txtActiveUIUOM.Name = "txtActiveUIUOM";
            this.txtActiveUIUOM.ReadOnly = true;
            this.txtActiveUIUOM.Size = new System.Drawing.Size(168, 20);
            this.txtActiveUIUOM.TabIndex = 6;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(112, 56);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(0, 13);
            this.label2.TabIndex = 5;
            this.label2.Tag = "SID_ACTIVEUOMSETMODEL";
            // 
            // lblActiveUIUOM
            // 
            this.lblActiveUIUOM.AutoSize = true;
            this.lblActiveUIUOM.Location = new System.Drawing.Point(112, 16);
            this.lblActiveUIUOM.Name = "lblActiveUIUOM";
            this.lblActiveUIUOM.Size = new System.Drawing.Size(0, 13);
            this.lblActiveUIUOM.TabIndex = 4;
            this.lblActiveUIUOM.Tag = "SID_ACTIVEUOMSETUI";
            // 
            // UserControlConfiguredUOMs
            // 
            this.Controls.Add(this.groupBox1);
            this.Name = "UserControlConfiguredUOMs";
            this.Size = new System.Drawing.Size(1072, 608);
            this.Tag = "SID_CONFIGUOMS";
            this.groupBox1.ResumeLayout(false);
            this.panel2.ResumeLayout(false);
            this.panel4.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridActiveUOMSetMode)).EndInit();
            this.panel3.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridActiveUOMSetUI)).EndInit();
            this.panel1.ResumeLayout(false);
            this.panel1.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		#region TextBoxFilling_In_ConfoguredUOMs
		private void TextBoxFilling()
		{
			//To select the MeasurementSystem 
			LRRProjectConfigurations pjctConfigs=new LRRProjectConfigurations();
			_app.DBManagerObj.PopulateCollection(pjctConfigs,false);
			if(pjctConfigs.Count>0)
			{
				LRRProjectConfiguration pjctConfig=pjctConfigs[0] as LRRProjectConfiguration;
				string filter = "";
				string CEUOM="";
				string UIUOM="";
				MSUIID=pjctConfig.MeasurementSystemUserInterfaceID;
				MSCEID=pjctConfig.MeasurementSystemCEID;
				LRRMeasurementSystem measmntSys=null;
				LRRMeasurementSystems	_lrrmeasyrementSys=new LRRMeasurementSystems();
				if(MSUIID != null)
				{
					_app.DBManagerObj.PopulateCollection(_lrrmeasyrementSys,false);
					//				filter =   "ID = " + MSUIID;
					//				_lrrmeasyrementSys.ItemFilter= filter;
					_app.DBManagerObj.PopulateCollection(_lrrmeasyrementSys,"  where ID='"+MSUIID+"'");
					measmntSys=_lrrmeasyrementSys[0] as LRRMeasurementSystem;
					UIUOM=measmntSys.Locale;
					_lrrmeasyrementSys.RefreshCollection();
				}
				if(MSCEID != null)
				{
					//				filter =   "ID = " +MSCEID;
					//				_lrrmeasyrementSys.ItemFilter= filter;
					_app.DBManagerObj.PopulateCollection(_lrrmeasyrementSys,"  where ID='"+MSCEID+"'");
					LRRMeasurementSystem measmntSys1=_lrrmeasyrementSys[0] as LRRMeasurementSystem;

					CEUOM=measmntSys1.Locale;
					_lrrmeasyrementSys.RefreshCollection();
				}
				txtActiveUIUOM.Text=UIUOM;
				txtActiveModelUOM.Text=CEUOM;
			}
		}

		#endregion
		#region BingGridConfiguredUoms

		private void BingGridConfiguredUoms()
		{

			LRRMeasurementSystemDefinitions lrrMESDef_UIUOM=new LRRMeasurementSystemDefinitions();
			_app.DBManagerObj.PopulateCollection(lrrMESDef_UIUOM," where MSID='"+MSUIID+"' "  ,false);
			Hashtable RelativeWidths = new Hashtable();
			//Suspend the Layout of the Grid...
			gridActiveUOMSetUI.SuspendLayout();
			//			SyncGridUtilities.InitializeGridLookAndFeel(gridActiveUOMSetUI);
			gridActiveUOMSetUI.Engine.SourceListSet.Add("ParentTable",lrrMESDef_UIUOM);
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridActiveUOMSetUI,gridActiveUOMSetUI.TableDescriptor,lrrMESDef_UIUOM.ItemType,null);
			this.gridActiveUOMSetUI.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.Hide;
			this.gridActiveUOMSetUI.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.Hide;
			gridActiveUOMSetUI.DataSource = lrrMESDef_UIUOM;
			RelativeWidths.Add("UOMTypeID",80);
			RelativeWidths.Add("UOMID",75);
			SyncGridUtilities.InitializeGridColumnsWidth(gridActiveUOMSetUI,RelativeWidths );
			this.gridActiveUOMSetUI.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			//Resume the Layout of the Grid...
			gridActiveUOMSetUI.ResumeLayout(false);


			LRRMeasurementSystemDefinitions lrrMESDef_CEUOM=new LRRMeasurementSystemDefinitions();
			_app.DBManagerObj.PopulateCollection(lrrMESDef_CEUOM," where MSID='"+MSCEID+"' "  ,false);
			Hashtable RelativeWidths1 = new Hashtable();
			//Suspend the Layout of the Grid...
			gridActiveUOMSetMode.SuspendLayout();
			//			SyncGridUtilities.InitializeGridLookAndFeel(gridActiveUOMSetMode);
			gridActiveUOMSetMode.Engine.SourceListSet.Add("ParentTable",lrrMESDef_CEUOM);
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridActiveUOMSetMode,gridActiveUOMSetMode.TableDescriptor,lrrMESDef_CEUOM.ItemType,null);
			this.gridActiveUOMSetMode.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.Hide;
			this.gridActiveUOMSetMode.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ShowButtons=GridShowButtons.Hide;
			gridActiveUOMSetMode.DataSource = lrrMESDef_CEUOM;
			RelativeWidths1.Add("UOMTypeID",95);
			RelativeWidths1.Add("UOMID",85);
			SyncGridUtilities.InitializeGridColumnsWidth(gridActiveUOMSetMode,RelativeWidths1 );
			this.gridActiveUOMSetMode.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			//Resume the Layout of the Grid...
			gridActiveUOMSetMode.ResumeLayout(false);
		}


		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			TextBoxFilling();
			BingGridConfiguredUoms();
		}

		public void Save()
		{
		

		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridActiveUOMSetMode.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridActiveUOMSetMode,false);
			}
			if(gridActiveUOMSetUI.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridActiveUOMSetUI,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion
		private void gridActiveUOMSetUI_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
				
		}

		private void gridActiveUOMSetMode_TableControlCellClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
		{
				
		}

		private void gridActiveUOMSetUI_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
				e.Inner.Cancel=true;
		}

		private void gridActiveUOMSetMode_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
				e.Inner.Cancel=true;
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridActiveUOMSetMode);
			SyncGridUtilities.ClearSort(gridActiveUOMSetUI);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlConfiguredUOMs.PrintPreview implementation
			if(gridActiveUOMSetMode.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridActiveUOMSetMode,true);
			}
			if(gridActiveUOMSetUI.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridActiveUOMSetUI,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlConfiguredUOMs.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlConfiguredUOMs.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlConfiguredUOMs.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlConfiguredUOMs.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlConfiguredUOMs.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlConfiguredUOMs.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlConfiguredUOMs.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlConfiguredUOMs.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlConfiguredUOMs.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlConfiguredUOMs.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlConfiguredUOMs.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
