using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.BusinessObjects; 
using Symcon.Utils.HeaderDispatcher;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using System.Reflection;
using Symcon.LightRidge.HistorianConnect;
using System.Collections.Generic;  

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlBlank.
	/// </summary>
	public class UserControlHistorianConnectionDetails : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtPort;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtHistProviderName;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.RadioButton rbRemoteProvider;
		private System.Windows.Forms.ComboBox cmbHistType;
		private System.Windows.Forms.Label lblHistorianType;
		private System.Windows.Forms.RadioButton rbProviderLocal;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cmbProtocol;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox txtServiceName;
		private System.Windows.Forms.CheckBox chkUseSimulator;
        private GroupBox grpSquareDConnectionInfo;
        private Label lblSquareDDBPassword;
        private Label lblSquareDDBUserName;
        private Label lblSquareDPortNumber;
        private Label lblSquareDDatabaseType;
        private Label lblSquareDServerName;
        private Label lblSquareDDBName;
        private Button btnConnectSquareD;
        private TextBox txtSquareDdbPassword;
        private TextBox txtSquareDUserName;
        private TextBox txtSquareDPortNumber;
        private TextBox txtSquareDDbType;
        private TextBox txtSquareDServer;
        private TextBox txtSquareDBName;
        private GroupBox grpWestingConnectInfo;
        private Button btnWstngConnect;
        private Label label6;
        private TextBox txtWestingHouseDBName;
        private Label label7;
        private TextBox txtWestinghouseServer;
        private TextBox txtWestingHouseDbType;
        private Label label8;
        private TextBox txtWestingHousePortNumber;
        private Label label9;
        private TextBox txtWestinghousedbPassword;
        private TextBox txtWestinghouseUserName;
        private Label label10;
        private Label label11;
        private TextBox txtInterval;
        private Label lblInterval;
        private ComboBox cmbHistorianOption;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlHistorianConnectionDetails()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null);
            InitializeSquareDInfo();
			// TODO: Add any initialization after the InitializeComponent call
            InitializeWestingDBInfo();
		}

        Symcon.LightRidge.Options.DBOptions.DBInfo _squareDBoptions = new Symcon.LightRidge.Options.DBOptions.DBInfo();
        Symcon.LightRidge.Options.DBOptions.DBInfo _wstngDBoptions = new Symcon.LightRidge.Options.DBOptions.DBInfo();

        private void InitializeSquareDInfo()
        {

            _squareDBoptions = SGTXmlSerializer.DeserializeXML("SquareDConfig.xml", typeof(Symcon.LightRidge.Options.DBOptions.DBInfo)) as Symcon.LightRidge.Options.DBOptions.DBInfo;
            if (_squareDBoptions != null)
            {
                txtSquareDBName.Text = _squareDBoptions.DatabaseName;
                txtSquareDServer.Text = _squareDBoptions.ServerName;
                txtSquareDDbType.Text = _squareDBoptions.DatabaseType.ToString();
                txtSquareDPortNumber.Text = _squareDBoptions.PortNumber.ToString();
                txtSquareDUserName.Text = _squareDBoptions.DatabaseUser;
                txtSquareDdbPassword.Text = _squareDBoptions.DatabasePWD;
                txtInterval.Text = _squareDBoptions.DatabaseFilePath;
            }
        }

        private void InitializeWestingDBInfo()
        {
            _wstngDBoptions = SGTXmlSerializer.DeserializeXML("WestingHouseConfig.xml", typeof(Symcon.LightRidge.Options.DBOptions.DBInfo)) as Symcon.LightRidge.Options.DBOptions.DBInfo;
            if (_wstngDBoptions != null)
            {
                txtWestingHouseDBName.Text = _wstngDBoptions.DatabaseName;
                txtWestinghouseServer.Text = _wstngDBoptions.ServerName;
                txtWestingHouseDbType.Text = _wstngDBoptions.DatabaseType.ToString();
                txtWestingHousePortNumber.Text = _wstngDBoptions.PortNumber.ToString();
                txtWestinghouseUserName.Text = _wstngDBoptions.DatabaseUser;
                txtWestinghousedbPassword.Text = _wstngDBoptions.DatabasePWD;
                //_westinghouseHistorianType = cmbHistorianOption.SelectedText.ToString();
                cmbHistorianOption.SelectedIndex = 1;
               LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

               app.WestinghouseHistorianType = cmbHistorianOption.SelectedText.ToString();
               

            }
 
        }

        private bool InitalizeSquareDBConnection()
        {
            bool isConnected = false;
            _squareDBoptions.DatabaseName = txtSquareDBName.Text;
            _squareDBoptions.ServerName = txtSquareDServer.Text;
            int portNumber;
            Int32.TryParse(txtSquareDPortNumber.Text, out portNumber);
            _squareDBoptions.PortNumber = portNumber;
            _squareDBoptions.DatabaseUser = txtSquareDUserName.Text;
            _squareDBoptions.DatabasePWD = txtSquareDdbPassword.Text;
            _squareDBoptions.DatabaseFilePath = txtInterval.Text;

            SGTXmlSerializer.SerializeAsXML("SquareDConfig.xml", typeof(Symcon.LightRidge.Options.DBOptions.DBInfo), _squareDBoptions, false);

            LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
            Dictionary<string, IHistorian> loadedAssemblies = app.LoadedOnLineHistorianAssemblies;
            LRRHistTagSourceInfo sourceInfo = LRRModel.ChildModel.TagSourceInfos.GetSourceInfoByID("2");
            if (loadedAssemblies.ContainsKey(sourceInfo.AssemblyName))
            {
                if (DialogResult.Yes != MessageBox.Show(this,"Do You wish to Reset Previous Connection","Connection Already Exists",MessageBoxButtons.YesNo))
                {
                    return true;
                }
                else
                {
                    Assembly asm = Assembly.LoadFrom(Application.StartupPath + "\\" + sourceInfo.AssemblyName);
                    IHistorian iHist = (IHistorian)Activator.CreateInstance(asm.GetType("Symcon.LightRidge.SquareDAdapter"));
                    loadedAssemblies[sourceInfo.AssemblyName] = iHist;
                    if (iHist.Initialized)
                    {
                        isConnected =  true;
                    }
                }
            }
            else
	        {
                Assembly asm = Assembly.LoadFrom(Application.StartupPath + "\\" + sourceInfo.AssemblyName);
                IHistorian iHist = (IHistorian)Activator.CreateInstance(asm.GetType(sourceInfo.TypeName));
                iHist.Initialize(app.AppPath, app.DBManagerObj);   
                
                if (iHist.Initialized)
                {
                    isConnected = true;
                    loadedAssemblies.Add(sourceInfo.AssemblyName, iHist);
                }
	        }
            return isConnected;
        }

        private bool InitalizeWestingHouseConnection()
        {
            bool isConnected = false;

            _wstngDBoptions.DatabaseName = txtWestingHouseDBName.Text;
            _wstngDBoptions.ServerName = txtWestinghouseServer.Text;
            int portNumber;
            Int32.TryParse(txtWestingHousePortNumber.Text, out portNumber);
            _wstngDBoptions.PortNumber = portNumber;
            _wstngDBoptions.DatabaseUser = txtWestinghouseUserName.Text;
            _wstngDBoptions.DatabasePWD = txtWestinghousedbPassword.Text;

            SGTXmlSerializer.SerializeAsXML("WestingHouseConfig.xml", typeof(Symcon.LightRidge.Options.DBOptions.DBInfo), _wstngDBoptions, false);

            LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            app.WestinghouseHistorianType = cmbHistorianOption.SelectedItem.ToString();

            Dictionary<string, IHistorian> loadedAssemblies = app.LoadedOnLineHistorianAssemblies;
            string typeofAdapter = "";
            LRRHistTagSourceInfo sourceInfo = LRRModel.ChildModel.TagSourceInfos.GetSourceInfoByID("1");
            if (loadedAssemblies.ContainsKey(sourceInfo.AssemblyName))
            {
                if (DialogResult.Yes != MessageBox.Show(this, "Do You wish to Reset Previous Connection", "Connection Already Exists", MessageBoxButtons.YesNo))
                {
                    MessageBox.Show(this, "Your Previous connection settings will be Retained \n Incase you wish to apply current settings, please click on connect again");
                    return false;// loadedAssemblies[sourceInfo.AssemblyName].Initialized;
                }
                else
                {
                    if (sourceInfo.AssemblyName == "Symcon.LightRidge.WestingHouseAdapter.dll")
                    {
                        if (app.WestinghouseHistorianType == "Historical")
                        {
                            typeofAdapter = "Symcon.LightRidge.WestingHouseAdapter";
                        }
                        else if (app.WestinghouseHistorianType == "Online")
                        {
                            typeofAdapter = "Symcon.LightRidge.OnlineWestingHouseAdapter";
                        }
                    }

                    Assembly asm = Assembly.LoadFrom(Application.StartupPath + "\\" + sourceInfo.AssemblyName);
                    IHistorian iHist = (IHistorian)Activator.CreateInstance(asm.GetType(typeofAdapter));
                    if (iHist.Initialized)
                    {
                        loadedAssemblies[sourceInfo.AssemblyName] = iHist;
                        isConnected = true;
                    }
                }
            }
            else
            {

                if (sourceInfo.AssemblyName == "Symcon.LightRidge.WestingHouseAdapter.dll")
                {
                    if (app.WestinghouseHistorianType == "Historical")
                    {
                        typeofAdapter = "Symcon.LightRidge.WestingHouseAdapter";
                    }
                    else if (app.WestinghouseHistorianType == "Online")
                    {
                        typeofAdapter = "Symcon.LightRidge.OnlineWestingHouseAdapter";
                    }
                }

                Assembly asm = Assembly.LoadFrom(Application.StartupPath + "\\" + sourceInfo.AssemblyName);
                IHistorian iHist = (IHistorian)Activator.CreateInstance(asm.GetType(typeofAdapter));
                iHist.Initialize(app.AppPath, app.DBManagerObj);
                
                if (iHist.Initialized)
                {
                    isConnected = true;
                    loadedAssemblies.Add(sourceInfo.AssemblyName, iHist);
                }
            }
            return isConnected;
        }


		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.txtServiceName = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.txtPort = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.txtHistProviderName = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.rbRemoteProvider = new System.Windows.Forms.RadioButton();
            this.cmbHistType = new System.Windows.Forms.ComboBox();
            this.lblHistorianType = new System.Windows.Forms.Label();
            this.rbProviderLocal = new System.Windows.Forms.RadioButton();
            this.label1 = new System.Windows.Forms.Label();
            this.cmbProtocol = new System.Windows.Forms.ComboBox();
            this.label5 = new System.Windows.Forms.Label();
            this.chkUseSimulator = new System.Windows.Forms.CheckBox();
            this.grpSquareDConnectionInfo = new System.Windows.Forms.GroupBox();
            this.lblInterval = new System.Windows.Forms.Label();
            this.txtInterval = new System.Windows.Forms.TextBox();
            this.btnConnectSquareD = new System.Windows.Forms.Button();
            this.txtSquareDdbPassword = new System.Windows.Forms.TextBox();
            this.txtSquareDUserName = new System.Windows.Forms.TextBox();
            this.txtSquareDPortNumber = new System.Windows.Forms.TextBox();
            this.txtSquareDDbType = new System.Windows.Forms.TextBox();
            this.txtSquareDServer = new System.Windows.Forms.TextBox();
            this.txtSquareDBName = new System.Windows.Forms.TextBox();
            this.lblSquareDDBPassword = new System.Windows.Forms.Label();
            this.lblSquareDDBUserName = new System.Windows.Forms.Label();
            this.lblSquareDPortNumber = new System.Windows.Forms.Label();
            this.lblSquareDDatabaseType = new System.Windows.Forms.Label();
            this.lblSquareDServerName = new System.Windows.Forms.Label();
            this.lblSquareDDBName = new System.Windows.Forms.Label();
            this.grpWestingConnectInfo = new System.Windows.Forms.GroupBox();
            this.cmbHistorianOption = new System.Windows.Forms.ComboBox();
            this.txtWestinghousedbPassword = new System.Windows.Forms.TextBox();
            this.txtWestinghouseUserName = new System.Windows.Forms.TextBox();
            this.label10 = new System.Windows.Forms.Label();
            this.label11 = new System.Windows.Forms.Label();
            this.txtWestingHousePortNumber = new System.Windows.Forms.TextBox();
            this.label9 = new System.Windows.Forms.Label();
            this.txtWestingHouseDbType = new System.Windows.Forms.TextBox();
            this.label8 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.txtWestinghouseServer = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.txtWestingHouseDBName = new System.Windows.Forms.TextBox();
            this.btnWstngConnect = new System.Windows.Forms.Button();
            this.grpSquareDConnectionInfo.SuspendLayout();
            this.grpWestingConnectInfo.SuspendLayout();
            this.SuspendLayout();
            // 
            // txtServiceName
            // 
            this.txtServiceName.Location = new System.Drawing.Point(384, 205);
            this.txtServiceName.Name = "txtServiceName";
            this.txtServiceName.Size = new System.Drawing.Size(224, 20);
            this.txtServiceName.TabIndex = 13;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(256, 207);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(100, 16);
            this.label4.TabIndex = 12;
            this.label4.Tag = "SID_SERVICE_NAME";
            // 
            // txtPort
            // 
            this.txtPort.Location = new System.Drawing.Point(144, 203);
            this.txtPort.Name = "txtPort";
            this.txtPort.Size = new System.Drawing.Size(80, 20);
            this.txtPort.TabIndex = 11;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(16, 205);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 16);
            this.label3.TabIndex = 10;
            this.label3.Tag = "SID_PORT";
            // 
            // txtHistProviderName
            // 
            this.txtHistProviderName.Location = new System.Drawing.Point(384, 168);
            this.txtHistProviderName.Name = "txtHistProviderName";
            this.txtHistProviderName.Size = new System.Drawing.Size(224, 20);
            this.txtHistProviderName.TabIndex = 9;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(256, 170);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 8;
            this.label2.Tag = "SID_SERV_NAME";
            // 
            // rbRemoteProvider
            // 
            this.rbRemoteProvider.Location = new System.Drawing.Point(16, 128);
            this.rbRemoteProvider.Name = "rbRemoteProvider";
            this.rbRemoteProvider.Size = new System.Drawing.Size(256, 24);
            this.rbRemoteProvider.TabIndex = 5;
            this.rbRemoteProvider.Tag = "SID_REMOTE_PROVIDER";
            this.rbRemoteProvider.MouseEnter += new System.EventHandler(this.rbRemoteProvider_MouseEnter);
            this.rbRemoteProvider.CheckedChanged += new System.EventHandler(this.rbRemoteProvider_CheckedChanged);
            this.rbRemoteProvider.MouseHover += new System.EventHandler(this.rbRemoteProvider_MouseHover);
            // 
            // cmbHistType
            // 
            this.cmbHistType.Items.AddRange(new object[] {
            "PI"});
            this.cmbHistType.Location = new System.Drawing.Point(184, 52);
            this.cmbHistType.Name = "cmbHistType";
            this.cmbHistType.Size = new System.Drawing.Size(121, 21);
            this.cmbHistType.TabIndex = 3;
            // 
            // lblHistorianType
            // 
            this.lblHistorianType.Location = new System.Drawing.Point(16, 54);
            this.lblHistorianType.Name = "lblHistorianType";
            this.lblHistorianType.Size = new System.Drawing.Size(168, 16);
            this.lblHistorianType.TabIndex = 2;
            this.lblHistorianType.Tag = "SID_HISTORIAN_TYPE";
            this.lblHistorianType.Click += new System.EventHandler(this.lblHistorianType_Click);
            // 
            // rbProviderLocal
            // 
            this.rbProviderLocal.Checked = true;
            this.rbProviderLocal.Location = new System.Drawing.Point(16, 96);
            this.rbProviderLocal.Name = "rbProviderLocal";
            this.rbProviderLocal.Size = new System.Drawing.Size(256, 24);
            this.rbProviderLocal.TabIndex = 4;
            this.rbProviderLocal.TabStop = true;
            this.rbProviderLocal.Tag = "SID_LOCAL_PROVIDER";
            this.rbProviderLocal.CheckedChanged += new System.EventHandler(this.rbProviderLocal_CheckedChanged);
            this.rbProviderLocal.MouseHover += new System.EventHandler(this.rbProviderLocal_MouseHover);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(328, 51);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(280, 23);
            this.label1.TabIndex = 25;
            this.label1.Tag = "SID_PLEASE_SELECT_HIST_TYPE";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.label1.Click += new System.EventHandler(this.label1_Click);
            // 
            // cmbProtocol
            // 
            this.cmbProtocol.Items.AddRange(new object[] {
            "http",
            "tcp"});
            this.cmbProtocol.Location = new System.Drawing.Point(144, 166);
            this.cmbProtocol.Name = "cmbProtocol";
            this.cmbProtocol.Size = new System.Drawing.Size(72, 21);
            this.cmbProtocol.TabIndex = 7;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(16, 168);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(100, 16);
            this.label5.TabIndex = 6;
            this.label5.Tag = "SID_PROTOCOL";
            // 
            // chkUseSimulator
            // 
            this.chkUseSimulator.Location = new System.Drawing.Point(16, 16);
            this.chkUseSimulator.Name = "chkUseSimulator";
            this.chkUseSimulator.Size = new System.Drawing.Size(320, 24);
            this.chkUseSimulator.TabIndex = 1;
            this.chkUseSimulator.Tag = "SID_USES_SIMULATOR";
            this.chkUseSimulator.CheckedChanged += new System.EventHandler(this.chkUseSimulator_CheckedChanged);
            this.chkUseSimulator.MouseHover += new System.EventHandler(this.chkUseSimulator_MouseHover);
            // 
            // grpSquareDConnectionInfo
            // 
            this.grpSquareDConnectionInfo.Controls.Add(this.lblInterval);
            this.grpSquareDConnectionInfo.Controls.Add(this.txtInterval);
            this.grpSquareDConnectionInfo.Controls.Add(this.btnConnectSquareD);
            this.grpSquareDConnectionInfo.Controls.Add(this.txtSquareDdbPassword);
            this.grpSquareDConnectionInfo.Controls.Add(this.txtSquareDUserName);
            this.grpSquareDConnectionInfo.Controls.Add(this.txtSquareDPortNumber);
            this.grpSquareDConnectionInfo.Controls.Add(this.txtSquareDDbType);
            this.grpSquareDConnectionInfo.Controls.Add(this.txtSquareDServer);
            this.grpSquareDConnectionInfo.Controls.Add(this.txtSquareDBName);
            this.grpSquareDConnectionInfo.Controls.Add(this.lblSquareDDBPassword);
            this.grpSquareDConnectionInfo.Controls.Add(this.lblSquareDDBUserName);
            this.grpSquareDConnectionInfo.Controls.Add(this.lblSquareDPortNumber);
            this.grpSquareDConnectionInfo.Controls.Add(this.lblSquareDDatabaseType);
            this.grpSquareDConnectionInfo.Controls.Add(this.lblSquareDServerName);
            this.grpSquareDConnectionInfo.Controls.Add(this.lblSquareDDBName);
            this.grpSquareDConnectionInfo.Location = new System.Drawing.Point(3, 252);
            this.grpSquareDConnectionInfo.Name = "grpSquareDConnectionInfo";
            this.grpSquareDConnectionInfo.Size = new System.Drawing.Size(650, 124);
            this.grpSquareDConnectionInfo.TabIndex = 26;
            this.grpSquareDConnectionInfo.TabStop = false;
            this.grpSquareDConnectionInfo.Tag = "SID_SQUARED_INFO";
            // 
            // lblInterval
            // 
            this.lblInterval.AutoSize = true;
            this.lblInterval.Location = new System.Drawing.Point(368, 74);
            this.lblInterval.Name = "lblInterval";
            this.lblInterval.Size = new System.Drawing.Size(0, 13);
            this.lblInterval.TabIndex = 15;
            this.lblInterval.Tag = "SID_INTERAL_MINS";
            // 
            // txtInterval
            // 
            this.txtInterval.Location = new System.Drawing.Point(365, 94);
            this.txtInterval.Name = "txtInterval";
            this.txtInterval.Size = new System.Drawing.Size(100, 20);
            this.txtInterval.TabIndex = 14;
            // 
            // btnConnectSquareD
            // 
            this.btnConnectSquareD.Location = new System.Drawing.Point(530, 95);
            this.btnConnectSquareD.Name = "btnConnectSquareD";
            this.btnConnectSquareD.Size = new System.Drawing.Size(75, 23);
            this.btnConnectSquareD.TabIndex = 12;
            this.btnConnectSquareD.Tag = "SID_CONNECT";
            this.btnConnectSquareD.UseVisualStyleBackColor = true;
            this.btnConnectSquareD.Click += new System.EventHandler(this.btnConnectSquareD_Click);
            // 
            // txtSquareDdbPassword
            // 
            this.txtSquareDdbPassword.Location = new System.Drawing.Point(186, 95);
            this.txtSquareDdbPassword.Name = "txtSquareDdbPassword";
            this.txtSquareDdbPassword.Size = new System.Drawing.Size(100, 20);
            this.txtSquareDdbPassword.TabIndex = 11;
            // 
            // txtSquareDUserName
            // 
            this.txtSquareDUserName.Location = new System.Drawing.Point(16, 95);
            this.txtSquareDUserName.Name = "txtSquareDUserName";
            this.txtSquareDUserName.Size = new System.Drawing.Size(100, 20);
            this.txtSquareDUserName.TabIndex = 10;
            // 
            // txtSquareDPortNumber
            // 
            this.txtSquareDPortNumber.Location = new System.Drawing.Point(504, 46);
            this.txtSquareDPortNumber.Name = "txtSquareDPortNumber";
            this.txtSquareDPortNumber.Size = new System.Drawing.Size(100, 20);
            this.txtSquareDPortNumber.TabIndex = 9;
            // 
            // txtSquareDDbType
            // 
            this.txtSquareDDbType.Location = new System.Drawing.Point(365, 46);
            this.txtSquareDDbType.Name = "txtSquareDDbType";
            this.txtSquareDDbType.ReadOnly = true;
            this.txtSquareDDbType.Size = new System.Drawing.Size(100, 20);
            this.txtSquareDDbType.TabIndex = 8;
            // 
            // txtSquareDServer
            // 
            this.txtSquareDServer.Location = new System.Drawing.Point(186, 46);
            this.txtSquareDServer.Name = "txtSquareDServer";
            this.txtSquareDServer.Size = new System.Drawing.Size(137, 20);
            this.txtSquareDServer.TabIndex = 7;
            // 
            // txtSquareDBName
            // 
            this.txtSquareDBName.Location = new System.Drawing.Point(16, 46);
            this.txtSquareDBName.Name = "txtSquareDBName";
            this.txtSquareDBName.Size = new System.Drawing.Size(134, 20);
            this.txtSquareDBName.TabIndex = 6;
            // 
            // lblSquareDDBPassword
            // 
            this.lblSquareDDBPassword.AutoSize = true;
            this.lblSquareDDBPassword.Location = new System.Drawing.Point(186, 74);
            this.lblSquareDDBPassword.Name = "lblSquareDDBPassword";
            this.lblSquareDDBPassword.Size = new System.Drawing.Size(0, 13);
            this.lblSquareDDBPassword.TabIndex = 5;
            this.lblSquareDDBPassword.Tag = "SID_DB_PASSWORD";
            // 
            // lblSquareDDBUserName
            // 
            this.lblSquareDDBUserName.AutoSize = true;
            this.lblSquareDDBUserName.Location = new System.Drawing.Point(16, 74);
            this.lblSquareDDBUserName.Name = "lblSquareDDBUserName";
            this.lblSquareDDBUserName.Size = new System.Drawing.Size(0, 13);
            this.lblSquareDDBUserName.TabIndex = 4;
            this.lblSquareDDBUserName.Tag = "SID_DB_USER_NAME";
            // 
            // lblSquareDPortNumber
            // 
            this.lblSquareDPortNumber.AutoSize = true;
            this.lblSquareDPortNumber.Location = new System.Drawing.Point(504, 25);
            this.lblSquareDPortNumber.Name = "lblSquareDPortNumber";
            this.lblSquareDPortNumber.Size = new System.Drawing.Size(0, 13);
            this.lblSquareDPortNumber.TabIndex = 3;
            this.lblSquareDPortNumber.Tag = "SID_PORTNO";
            // 
            // lblSquareDDatabaseType
            // 
            this.lblSquareDDatabaseType.AutoSize = true;
            this.lblSquareDDatabaseType.Location = new System.Drawing.Point(365, 25);
            this.lblSquareDDatabaseType.Name = "lblSquareDDatabaseType";
            this.lblSquareDDatabaseType.Size = new System.Drawing.Size(0, 13);
            this.lblSquareDDatabaseType.TabIndex = 2;
            this.lblSquareDDatabaseType.Tag = "SID_DBTYPE";
            // 
            // lblSquareDServerName
            // 
            this.lblSquareDServerName.AutoSize = true;
            this.lblSquareDServerName.Location = new System.Drawing.Point(186, 25);
            this.lblSquareDServerName.Name = "lblSquareDServerName";
            this.lblSquareDServerName.Size = new System.Drawing.Size(0, 13);
            this.lblSquareDServerName.TabIndex = 1;
            this.lblSquareDServerName.Tag = "SID_SERVERNAME";
            // 
            // lblSquareDDBName
            // 
            this.lblSquareDDBName.AutoSize = true;
            this.lblSquareDDBName.Location = new System.Drawing.Point(16, 25);
            this.lblSquareDDBName.Name = "lblSquareDDBName";
            this.lblSquareDDBName.Size = new System.Drawing.Size(0, 13);
            this.lblSquareDDBName.TabIndex = 0;
            this.lblSquareDDBName.Tag = "SID_DBENAME";
            // 
            // grpWestingConnectInfo
            // 
            this.grpWestingConnectInfo.Controls.Add(this.cmbHistorianOption);
            this.grpWestingConnectInfo.Controls.Add(this.txtWestinghousedbPassword);
            this.grpWestingConnectInfo.Controls.Add(this.txtWestinghouseUserName);
            this.grpWestingConnectInfo.Controls.Add(this.label10);
            this.grpWestingConnectInfo.Controls.Add(this.label11);
            this.grpWestingConnectInfo.Controls.Add(this.txtWestingHousePortNumber);
            this.grpWestingConnectInfo.Controls.Add(this.label9);
            this.grpWestingConnectInfo.Controls.Add(this.txtWestingHouseDbType);
            this.grpWestingConnectInfo.Controls.Add(this.label8);
            this.grpWestingConnectInfo.Controls.Add(this.label7);
            this.grpWestingConnectInfo.Controls.Add(this.txtWestinghouseServer);
            this.grpWestingConnectInfo.Controls.Add(this.label6);
            this.grpWestingConnectInfo.Controls.Add(this.txtWestingHouseDBName);
            this.grpWestingConnectInfo.Controls.Add(this.btnWstngConnect);
            this.grpWestingConnectInfo.Location = new System.Drawing.Point(3, 398);
            this.grpWestingConnectInfo.Name = "grpWestingConnectInfo";
            this.grpWestingConnectInfo.Size = new System.Drawing.Size(650, 149);
            this.grpWestingConnectInfo.TabIndex = 27;
            this.grpWestingConnectInfo.TabStop = false;
            this.grpWestingConnectInfo.Tag = "SID_WEASTING_HOUSE_INFO";
            this.grpWestingConnectInfo.Enter += new System.EventHandler(this.grpWestingConnectInfo_Enter);
            // 
            // cmbHistorianOption
            // 
            this.cmbHistorianOption.FormattingEnabled = true;
            this.cmbHistorianOption.Items.AddRange(new object[] {
            "Historical",
            "Online"});
            this.cmbHistorianOption.Location = new System.Drawing.Point(16, 19);
            this.cmbHistorianOption.Name = "cmbHistorianOption";
            this.cmbHistorianOption.Size = new System.Drawing.Size(121, 21);
            this.cmbHistorianOption.TabIndex = 19;
            this.cmbHistorianOption.SelectedIndexChanged += new System.EventHandler(this.cmbHistorianOption_SelectedIndexChanged);
            // 
            // txtWestinghousedbPassword
            // 
            this.txtWestinghousedbPassword.Location = new System.Drawing.Point(186, 120);
            this.txtWestinghousedbPassword.Name = "txtWestinghousedbPassword";
            this.txtWestinghousedbPassword.Size = new System.Drawing.Size(100, 20);
            this.txtWestinghousedbPassword.TabIndex = 18;
            // 
            // txtWestinghouseUserName
            // 
            this.txtWestinghouseUserName.Location = new System.Drawing.Point(16, 120);
            this.txtWestinghouseUserName.Name = "txtWestinghouseUserName";
            this.txtWestinghouseUserName.Size = new System.Drawing.Size(100, 20);
            this.txtWestinghouseUserName.TabIndex = 17;
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Location = new System.Drawing.Point(186, 99);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(0, 13);
            this.label10.TabIndex = 16;
            this.label10.Tag = "SID_DB_PASSWORD";
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Location = new System.Drawing.Point(16, 99);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(0, 13);
            this.label11.TabIndex = 15;
            this.label11.Tag = "SID_DB_USER_NAME";
            // 
            // txtWestingHousePortNumber
            // 
            this.txtWestingHousePortNumber.Location = new System.Drawing.Point(504, 69);
            this.txtWestingHousePortNumber.Name = "txtWestingHousePortNumber";
            this.txtWestingHousePortNumber.Size = new System.Drawing.Size(100, 20);
            this.txtWestingHousePortNumber.TabIndex = 14;
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Location = new System.Drawing.Point(504, 48);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(0, 13);
            this.label9.TabIndex = 13;
            this.label9.Tag = "SID_PORTNO";
            // 
            // txtWestingHouseDbType
            // 
            this.txtWestingHouseDbType.Location = new System.Drawing.Point(365, 69);
            this.txtWestingHouseDbType.Name = "txtWestingHouseDbType";
            this.txtWestingHouseDbType.ReadOnly = true;
            this.txtWestingHouseDbType.Size = new System.Drawing.Size(100, 20);
            this.txtWestingHouseDbType.TabIndex = 12;
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(365, 48);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(0, 13);
            this.label8.TabIndex = 11;
            this.label8.Tag = "SID_DBTYPE";
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(186, 48);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(0, 13);
            this.label7.TabIndex = 10;
            this.label7.Tag = "SID_SERVERNAME";
            // 
            // txtWestinghouseServer
            // 
            this.txtWestinghouseServer.Location = new System.Drawing.Point(186, 69);
            this.txtWestinghouseServer.Name = "txtWestinghouseServer";
            this.txtWestinghouseServer.Size = new System.Drawing.Size(137, 20);
            this.txtWestinghouseServer.TabIndex = 9;
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Location = new System.Drawing.Point(16, 48);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(0, 13);
            this.label6.TabIndex = 8;
            this.label6.Tag = "SID_DBENAME";
            // 
            // txtWestingHouseDBName
            // 
            this.txtWestingHouseDBName.Location = new System.Drawing.Point(16, 69);
            this.txtWestingHouseDBName.Name = "txtWestingHouseDBName";
            this.txtWestingHouseDBName.Size = new System.Drawing.Size(100, 20);
            this.txtWestingHouseDBName.TabIndex = 7;
            // 
            // btnWstngConnect
            // 
            this.btnWstngConnect.Location = new System.Drawing.Point(520, 117);
            this.btnWstngConnect.Name = "btnWstngConnect";
            this.btnWstngConnect.Size = new System.Drawing.Size(75, 23);
            this.btnWstngConnect.TabIndex = 6;
            this.btnWstngConnect.Tag = "SID_CONNECT";
            this.btnWstngConnect.UseVisualStyleBackColor = true;
            this.btnWstngConnect.Click += new System.EventHandler(this.btnWstngConnect_Click);
            // 
            // UserControlHistorianConnectionDetails
            // 
            this.AutoScroll = true;
            this.BackColor = System.Drawing.Color.White;
            this.Controls.Add(this.grpWestingConnectInfo);
            this.Controls.Add(this.grpSquareDConnectionInfo);
            this.Controls.Add(this.chkUseSimulator);
            this.Controls.Add(this.cmbProtocol);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.txtServiceName);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.txtPort);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.txtHistProviderName);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.rbRemoteProvider);
            this.Controls.Add(this.cmbHistType);
            this.Controls.Add(this.lblHistorianType);
            this.Controls.Add(this.rbProviderLocal);
            this.Name = "UserControlHistorianConnectionDetails";
            this.Size = new System.Drawing.Size(656, 587);
            this.Load += new System.EventHandler(this.UserControlHistorianConnectionDetails_Load);
            this.grpSquareDConnectionInfo.ResumeLayout(false);
            this.grpSquareDConnectionInfo.PerformLayout();
            this.grpWestingConnectInfo.ResumeLayout(false);
            this.grpWestingConnectInfo.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		#region ILRRUIContainer Members

		public void Refresh()
		{
			
		}

		public void Save()
		{
			this.Validate();
			LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp; //Get the App Object..
            foreach (IHistorian iHistObj in app.LoadedOnLineHistorianAssemblies.Values)
            {
                Symcon.LightRidge.BusinessObjects.LRRHistorianConnection connectionObj = iHistObj.HistorianConnectionObj;
                if (connectionObj != null)
                {
                    if (connectionObj.ArrListUpdatedColNames.Count > 0)
                    {
                        OptionsUserControl.saved = true;
                        app.DBManagerObj.CommitObject(connectionObj);
                        connectionObj.ResetObjectState();
                        iHistObj.Initialize(connectionObj);
                    }
                }
            }
		}

		public void CopyMasterProperties()
		{
			// TODO:  Add OptionsUserControl.CopyMasterProperties implementation
		}

		public void Paste()
		{
			// TODO:  Add OptionsUserControl.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add OptionsUserControl.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add OptionsUserControl.Print implementation
		}

		public void Delete()
		{
			// TODO:  Add OptionsUserControl.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add OptionsUserControl.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			// TODO:  Add OptionsUserControl.ClearFilter implementation
		}

		public void InsertNewRows()
		{
			// TODO:  Add OptionsUserControl.InsertNewRows implementation
		}

		public void ImportToExcel()
		{
			// TODO:  Add OptionsUserControl.ImportToExcel implementation
		}

		public void Export()
		{
			// TODO:  Add OptionsUserControl.Export implementation
		}

		public void SelectionPaste()
		{
			// TODO:  Add OptionsUserControl.SelectionPaste implementation
		}

		public void RightLevel()
		{
			// TODO:  Add OptionsUserControl.RightLevel implementation
		}

		public void LeftLevel()
		{
			// TODO:  Add OptionsUserControl.LeftLevel implementation
		}

		public void UpLevel()
		{
			// TODO:  Add OptionsUserControl.UpLevel implementation
		}

		public void DownLevel()
		{
			// TODO:  Add OptionsUserControl.DownLevel implementation
		}

		public bool SupportsMasterPropertiesCopy()
		{
			// TODO:  Add OptionsUserControl.SupportsMasterPropertiesCopy implementation
			return false;
		}

		public bool SupportsCopy()
		{
			// TODO:  Add OptionsUserControl.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add OptionsUserControl.SupportsPaste implementation
			return false;
		}

		public bool SupportsExport()
		{
			// TODO:  Add OptionsUserControl.SupportsExport implementation
			return false;
		}

		public bool SupportsSave()
		{
			// TODO:  Add OptionsUserControl.SupportsSave implementation
			return false;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add OptionsUserControl.SupportsRefresh implementation
			return false;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add OptionsUserControl.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add OptionsUserControl.SupportsPrint implementation
			return false;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add OptionsUserControl.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add OptionsUserControl.SupportsClearFilter implementation
			return false;
		}

		public bool SupportsInsertNewRows()
		{
			// TODO:  Add OptionsUserControl.SupportsInsertNewRows implementation
			return false;
		}

		public bool SupportsImportToExcel()
		{
			// TODO:  Add OptionsUserControl.SupportsImportToExcel implementation
			return false;
		}

		public bool SupportsSelectionPaste()
		{
			// TODO:  Add OptionsUserControl.SupportsSelectionPaste implementation
			return false;
		}

		public bool SupportsLevel()
		{
			// TODO:  Add OptionsUserControl.SupportsLevel implementation
			return false;
		}

		public TabControl ParentTabControl
		{
			get
			{
				// TODO:  Add OptionsUserControl.ParentTabControl getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OptionsUserControl.ParentTabControl setter implementation
			}
		}

		public TabPage ParentTabPage
		{
			get
			{
				// TODO:  Add OptionsUserControl.ParentTabPage getter implementation
				return null;
			}
			set
			{
				// TODO:  Add OptionsUserControl.ParentTabPage setter implementation
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// TODO:  Add OptionsUserControl.ClearSort implementation
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add OptionsUserControl.SupportsClearSort implementation
			return false;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlBlank.PrintPreview implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlBlank.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlBlank.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlBlank.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlBlank.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlBlank.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlBlank.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlBlank.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlBlank.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlBlank.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlBlank.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlBlank.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlBlank.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlBlank.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlBlank.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlBlank.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlBlank.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlBlank.SupportsCompositeView implementation
			return false;
		}

		#endregion

		private void label2_Click(object sender, System.EventArgs e)
		{
		
		}

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlBlank.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		private void SetUI()
		{

			if(chkUseSimulator.Checked)
			{
				rbProviderLocal.Enabled = false;
				rbRemoteProvider.Enabled = false;
				cmbHistType.Enabled = false;
				txtHistProviderName.Enabled = false;
				txtPort.Enabled = false;
				cmbProtocol.Enabled = false;
				txtServiceName.Enabled = false;
			}
			else
			{
				rbProviderLocal.Enabled = true;
				rbRemoteProvider.Enabled = true;
				cmbHistType.Enabled = true;

				if(rbProviderLocal.Checked)
				{
					txtHistProviderName.Enabled = false;
					txtPort.Enabled = false;
					cmbProtocol.Enabled = false;
					txtServiceName.Enabled = false;
				}
				else
				{
					txtHistProviderName.Enabled = true;
					txtPort.Enabled = true;
					cmbProtocol.Enabled = true;
					txtServiceName.Enabled = true;

				}
			}

			this.Validate();
		}

		private void rbProviderLocal_CheckedChanged(object sender, System.EventArgs e)
		{
			SetUI();
			LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp; //Get the App Object..
            foreach (IHistorian iHistObj in app.LoadedOnLineHistorianAssemblies.Values)
            {
                Symcon.LightRidge.BusinessObjects.LRRHistorianConnection connectionObj = iHistObj.HistorianConnectionObj;
                connectionObj.IsLocal = rbProviderLocal.Checked;
            }
		}

		private void rbRemoteProvider_CheckedChanged(object sender, System.EventArgs e)
		{
			SetUI();
			LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp; //Get the App Object..
            foreach (IHistorian iHistObj in app.LoadedOnLineHistorianAssemblies.Values)
            {
                Symcon.LightRidge.BusinessObjects.LRRHistorianConnection connectionObj = iHistObj.HistorianConnectionObj;
                connectionObj.IsRemote = rbRemoteProvider.Checked;
            }
		}

		private void UserControlHistorianConnectionDetails_Load(object sender, System.EventArgs e)
		{
			LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp; //Get the App Object..
			//Symcon.LightRidge.BusinessObjects.LRRHistorianConnection connectionObj = app.RunControllerObj.GetActiveHistorian(HistorianConnect.HistorianConnectionType.ONLINE).HistorianConnectionObj;
            Symcon.LightRidge.BusinessObjects.LRRHistorianConnection connectionObj = app.LoadedOnLineHistorianAssemblies["Symcon.LightRidge.HistorianConnect.dll"].HistorianConnectionObj;
            if (connectionObj != null)
            {
                cmbHistType.DataBindings.Add("Text", connectionObj, "HistorianType");
                chkUseSimulator.DataBindings.Add("Checked", connectionObj, "UseSimulator");
                //rbProviderLocal.DataBindings.Add("Checked",connectionObj,"IsLocal");
                //rbRemoteProvider.DataBindings.Add("Checked",connectionObj,"IsRemote");
                txtHistProviderName.DataBindings.Add("Text", connectionObj, "ServerName");
                txtServiceName.DataBindings.Add("Text", connectionObj, "ServiceName");
                txtPort.DataBindings.Add("Text", connectionObj, "Port");
                cmbProtocol.DataBindings.Add("Text", connectionObj, "Protocol");
                rbProviderLocal.Checked = connectionObj.IsLocal;
                rbRemoteProvider.Checked = connectionObj.IsRemote;
                SetUI();
            }
		}

		private void chkUseSimulator_CheckedChanged(object sender, System.EventArgs e)
		{
			SetUI();
		}

		private void label1_Click(object sender, System.EventArgs e)
		{
		
		}

		private void lblHistorianType_Click(object sender, System.EventArgs e)
		{
		
		}

		private void rbProviderLocal_MouseHover(object sender, System.EventArgs e)
		{
			ToolTip tp = new ToolTip();
			string tooltip = LRRHeaderText.GetHeaderString("SID_LOCAL_PROVIDER"); 
			tp.SetToolTip(this.rbProviderLocal,tooltip);  
		}

		private void rbRemoteProvider_MouseEnter(object sender, System.EventArgs e)
		{
		}
		private void rbRemoteProvider_MouseHover(object sender, System.EventArgs e)
		{
			ToolTip tp = new ToolTip();
			string tooltip = LRRHeaderText.GetHeaderString("SID_REMOTE_PROVIDER"); 
			tp.SetToolTip(this.rbRemoteProvider,tooltip); 
		}

		private void chkUseSimulator_MouseHover(object sender, System.EventArgs e)
		{
			ToolTip tp = new ToolTip();
			string tooltip = LRRHeaderText.GetHeaderString("SID_USES_SIMULATOR"); 
			tp.SetToolTip(this.chkUseSimulator,tooltip);
		}

        private void btnConnectSquareD_Click(object sender, EventArgs e)
        {
            try
            {
                bool isInitialized = InitalizeSquareDBConnection();
                if (isInitialized)
                {
                    MessageBox.Show("Connection Sucessful");
                }
                else
                {
                    MessageBox.Show("Connection Falied, Please Check the information Entered");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Connection Falied, Please Check the information Entered");
            }
        }

        private void btnWstngConnect_Click(object sender, EventArgs e)
        {
            try
            {
                bool isInitialized = InitalizeWestingHouseConnection();
                if (isInitialized)
                {
                    MessageBox.Show("Connection Sucessful");
                }
                else
                {
                    MessageBox.Show("Connection Falied, Please Check the information Entered");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Connection Falied, Please Check the information Entered");
            }
        }

        private void cmbHistorianOption_SelectedIndexChanged(object sender, EventArgs e)
        {
            LRRApp app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            app.WestinghouseHistorianType = cmbHistorianOption.SelectedItem.ToString();
            
            if(cmbHistorianOption.SelectedItem.ToString() == "Historical")
            {
                label6.Text = "DatabaseName";
                txtWestingHouseDBName.Enabled = true;
                txtWestinghousedbPassword.Enabled = true;
                txtWestingHouseDbType.Enabled = true;
                txtWestingHousePortNumber.Enabled = true;
                txtWestinghouseServer.Enabled = true;
                txtWestinghouseUserName.Enabled = true;

                label7.Visible = true;
                label8.Visible = true;
                label9.Visible = true;
                label10.Visible = true;
                label11.Visible = true;
            }
            else if(cmbHistorianOption.SelectedItem.ToString() == "Online")
            {
                label6.Text = "DSN";
                txtWestingHouseDBName.Enabled = true;
                txtWestinghousedbPassword.Enabled = false;
                txtWestingHouseDbType.Enabled = false;
                txtWestingHousePortNumber.Enabled = false;
                txtWestinghouseServer.Enabled = false;
                txtWestinghouseUserName.Enabled = false;

                label7.Visible = false;
                label8.Visible = false;
                label9.Visible = false;
                label10.Visible = false;
                label11.Visible = false;

            }

            
        }

        private void grpWestingConnectInfo_Enter(object sender, EventArgs e)
        {

        }
	}
}
