using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.Utils.HeaderDispatcher;  
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlModeDefn.
	/// </summary>
	public class UserControlModeDefn : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp						_app;
		private LRRModes	_lrrModes=null;
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridModeDefinitions;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlModeDefn()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			BindGridModeDefinitions();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridModeDefinitions = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridModeDefinitions)).BeginInit();
			this.SuspendLayout();
			// 
			// gridModeDefinitions
			// 
			this.gridModeDefinitions.Appearance.AnyRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.Color.LightGray);
			this.gridModeDefinitions.BackColor = System.Drawing.SystemColors.Window;
			this.gridModeDefinitions.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridModeDefinitions.Location = new System.Drawing.Point(0, 0);
			this.gridModeDefinitions.Name = "gridModeDefinitions";
			this.gridModeDefinitions.Size = new System.Drawing.Size(816, 512);
			this.gridModeDefinitions.TabIndex = 6;
			this.gridModeDefinitions.TableDescriptor.AllowEdit = false;
			this.gridModeDefinitions.TableDescriptor.AllowNew = false;
			this.gridModeDefinitions.TableDescriptor.AllowRemove = false;
			this.gridModeDefinitions.TableOptions.AllowSelection = Syncfusion.Windows.Forms.Grid.GridSelectionFlags.None;
			this.gridModeDefinitions.Text = "gridGroupingControl1";
			this.gridModeDefinitions.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridModeDefinitions.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridModeDefinitions.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridModeDefinitions.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridModeDefinitions.VersionInfo = "3.301.0.0";
			// 
			// UserControlModeDefn
			// 
			this.Controls.Add(this.gridModeDefinitions);
			this.Name = "UserControlModeDefn";
			this.Size = new System.Drawing.Size(816, 512);
			this.Tag = "SID_MODEDEFN";
			((System.ComponentModel.ISupportInitialize)(this.gridModeDefinitions)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		# region InitDataSource
		private void InitDataSource()
		{
			if(_lrrModes != null)
				_lrrModes.Clear();
			_lrrModes=new LRRModes();
			_app.DBManagerObj.PopulateCollection(_lrrModes,false);
		}
		#endregion
		#region BindGridModeDefinitions
		private void BindGridModeDefinitions()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridModeDefinitions.SuspendLayout();
			//SyncGridUtilities.InitializeGridLookAndFeel(gridModeDefinitions);
			gridModeDefinitions.Appearance.AnyRecordFieldCell.CellType="Static";
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridModeDefinitions,gridModeDefinitions.TableDescriptor,_lrrModes.ItemType,null);
			gridModeDefinitions.TableDescriptor.Columns.Clear();
			gridModeDefinitions.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_MODENAME"),"ModeName");
			gridModeDefinitions.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_MODEDESC"),"ModeDescription");
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_MODENAME"),50);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_MODEDESC"),50);
			gridModeDefinitions.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_LRR_MODES") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			SyncGridUtilities.InitializeGridColumnsWidth(gridModeDefinitions,RelativeWidths );
			gridModeDefinitions.Engine.SourceListSet.Add("ParentTable",_lrrModes);
			gridModeDefinitions.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			//Set the data store 
			gridModeDefinitions.DataSource = _lrrModes;
			//Resume the Layout of the Grid...
			gridModeDefinitions.ResumeLayout(true);

			//Add the parent table for the Relations...
			
		}

		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BindGridModeDefinitions();
		}

		public void Save()
		{
			

		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridModeDefinitions.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridModeDefinitions,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridModeDefinitions);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlModeDefn.PrintPreview implementation
			if(gridModeDefinitions.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridModeDefinitions,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlModeDefn.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlModeDefn.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlModeDefn.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlModeDefn.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlModeDefn.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlModeDefn.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlModeDefn.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlModeDefn.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlModeDefn.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlModeDefn.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlModeDefn.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlModeDefn.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlModeDefn.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlModeDefn.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlModeDefn.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlModeDefn.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlModeDefn.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlModeDefn.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
