using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.BusinessObjects;
using Syncfusion.Windows.Forms.Chart;
using Symcon.Utils.HeaderDispatcher;
using Symcon.LightRidge.PEAdvisor.UserControls;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
    public partial class UserControlMultiTrendSingleGraph : UserControl
    {
        public UserControlMultiTrendSingleGraph()
        {
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            InitializeComponent();
            this.Text = "Trend Chart";
            chartControlTrend.Model.Series.Clear();
            chartControlTrend.ChartFormatAxisLabel += new Syncfusion.Windows.Forms.Chart.ChartFormatAxisLabelEventHandler(chartControlTrend_ChartFormatAxisLabel);
            this.chartControlTrend.Legend.Visible = false;
            chartControlTrend.Dock = DockStyle.Fill;
            this.chartControlTrend.DisplayChartContextMenu = false;
            _lrrApp.RunControllerObj.TrendPointRecieved += new TrendPointRecievedDel(RunControllerObj_TrendPointRecieved);
		}

        public delegate void AddPointDel(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange);

        void RunControllerObj_TrendPointRecieved(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange)
        {
            try
            {
                if (_htSeries.ContainsKey(siteCompPropValueChange.SiteComponentPropertyValueID))
                {
                    AddPointDel addPointDel = new AddPointDel(AddPoint);
                    _lrrApp.MainFrame.Invoke(addPointDel, new object[] { siteCompPropValueChange });
                }
            }
            catch
            {

            }
           
        }

        private void AddPoint(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange)
        {

            LRRSiteComponentPropertyValueChangeUserAndTime scpvcut = siteCompPropValueChange;
            ChartSeries series = _htSeries[siteCompPropValueChange.SiteComponentPropertyValueID] as ChartSeries;
            for (int i = 0; i < _htSeries.Count; i++)
            {
                if (_htOrigChartSeries[i].Equals(series))
                {

                    int index = i;
                    ChartSeries currSeries = _htCurrSeries[i] as ChartSeries;
                    TemplateRows templateRow = _templateRows;
                    TrendSetting trendSetting = templateRow.TrendSettings[i];
                    UserControlTrendTemplateRowsWithUOM tempRow = _htTemplateRows[i + 1] as UserControlTrendTemplateRowsWithUOM;

                    ComboBox comboBoxUOM = tempRow.comboBoxUOM;
                    string propValueID = trendSetting.SchemeName;

                    string localeID = LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID;
                    //DateTime startTime = DateTime.Now;
                    //DateTime endTime = DateTime.Now.AddYears(-1500);

                    LRRSiteComponentPropertyValue scpv = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(propValueID);
                    string currentUOM = null;
                    if (scpv != null)
                    {
                        string modelUOM = scpv.ModelUOM;
                        currentUOM = modelUOM;
                        string uomType = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(currentUOM);

                        string uiUom = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomType);

                        IProperty iProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(scpv.SiteComponentPropertyID) as IProperty;
                        string modeID = scpv.ModeID;

                        if (uiUom == null)
                            uiUom = currentUOM;

                        if (comboBoxUOM.SelectedItem == null)
                        {
                            currentUOM = uiUom;

                            if (trendSetting.UOM != null)
                            {
                                currentUOM = trendSetting.UOM;
                            }
                        }
                        try
                        {
                            double point;
                            if (double.TryParse(ConvertUOM(modelUOM, currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Float, Symcon.BusinessObjects.SymConverter.Culture, out point))
                            {
                                if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < _startTime)
                                    _startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                                if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > _endTime)
                                    _endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                                double[] points = new double[] { point, 1 };
                                series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                            }
                        }
                        catch
                        {

                        }
                    }
                    else
                    {
                        LRRSiteGroupPropertyQualifierValue gpqv = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(propValueID);

                        if (gpqv != null)
                        {
                            string modelUOM = gpqv.ModelUOM;
                            currentUOM = modelUOM;
                            string uomType = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(currentUOM);

                            string uiUom = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomType);

                            if (uiUom == null)
                                uiUom = currentUOM;

                            if (comboBoxUOM.SelectedItem == null)
                            {
                                currentUOM = uiUom;

                                if (trendSetting.UOM != null)
                                {
                                    currentUOM = trendSetting.UOM;
                                }
                            }
                            try
                            {
                                double point;
                                if (double.TryParse(ConvertUOM(modelUOM, currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Float, Symcon.BusinessObjects.SymConverter.Culture, out point))
                                {
                                    if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < _startTime)
                                        _startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                                    if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > _endTime)
                                        _endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                                    double[] points = new double[] { point, 1 };
                                    series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                                }
                            }
                            catch
                            {

                            }
                        }
                    }
                    //_startTime = startTime;
                    

                    //_endTime = endTime;

                    TimeSpan ts = _endTime - _startTime;
                    if (ts.TotalHours < 11 && ts.TotalMilliseconds >= 0)
                    {
                        ts = TimeSpan.FromHours(11);
                        //T//imeSpan timeMarginStart = TimeSpan.FromTicks(_ts.Ticks/10);
                        _startTime = _endTime.Subtract(ts);

                    }
                    // comboBoxUOM_SelectedIndexChanged(comboBoxUOM, null);
                    string newUOM = comboBoxUOM.SelectedValue as string;
                    ChartSeries seriesOrig = _htOrigChartSeries[i] as ChartSeries;
                    ChartSeries oldSeries = _htCurrSeries[i] as ChartSeries;
                    oldSeries.YAxis = null;
                    chartControlTrend.Model.Series.Remove(oldSeries);

                    ChartSeries seriesNew = chartControlTrend.Model.NewSeries("series " + i);
                    for (int j = 0; j < seriesOrig.Points.Count; j++)
                    {
                        ChartPoint cp = seriesOrig.Points[j];
                        seriesNew.Points.Add(cp.DateX, double.Parse(ConvertUOM(currentUOM, newUOM, cp.YValues[0].ToString())));
                    }


                    //TrendSetting trendSetting = _htTrendSettings[i] as TrendSetting;
                    seriesNew.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType), trendSetting.SeriesType);
                    seriesNew.Text = seriesNew.Name;

                    try
                    {
                        seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(trendSetting.SeriesInteriorColor)), Color.Black });
                    }
                    catch
                    {
                        try
                        {
                            seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SeriesInteriorColor)), Color.Black });
                        }
                        catch
                        { }
                    }

                    seriesNew.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyleMulti);

                    ChartAxis secYAxis2 = _htSecYAxis[i] as ChartAxis;
                    chartControlTrend.Axes.Remove(secYAxis2);
                    ChartAxis secYAxis = new ChartAxis();
                    //secYAxis.Orientation = Orientation.Vertical;
                    chartControlTrend.Axes.Add(secYAxis);
                    //secYAxis.Range = new MinMaxInfo(0, 1000, 100);
                    try
                    {
                        secYAxis.ForeColor = Color.FromArgb(int.Parse(trendSetting.SymbolColor));
                    }
                    catch
                    {
                        try
                        {
                            secYAxis.ForeColor = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SymbolColor));
                        }
                        catch
                        { }
                    }
                    secYAxis.Title = _htAxisTitle[i] as string;
                    secYAxis.LocationType = ChartAxisLocationType.Set;

                    secYAxis.Location = new PointF(100 * (i + 1), chartControlTrend.PrimaryYAxis.Location.Y);
                    secYAxis.OpposedPosition = false;
                    seriesNew.YAxis = secYAxis;
                    _htSecYAxis[i] = secYAxis;
                    chartControlTrend.Model.Series.Add(seriesNew);
                    AdjustXScale();

                    _htCurrSeries[i] = seriesNew;
                }
            }

        }


        #region Fields

        private TemplateRows _templateRows = null;
        private LRRApp _lrrApp;
        private Hashtable _htTrendSettings = new Hashtable();
        private Hashtable _htTemplateRows = new Hashtable();
        private Hashtable _htSeries = new Hashtable();
        DateTime _startTime = DateTime.Now;
        DateTime _endTime = DateTime.Now;
        Hashtable _htTemplatesRows = new Hashtable();
        Hashtable _htOrigChartSeries = new Hashtable();
        Hashtable _htCurrSeries = new Hashtable();
        Hashtable _htOrigUOMS = new Hashtable();
        Hashtable _htSecYAxis = new Hashtable();
        Hashtable _htAxisTitle = new Hashtable();

        #endregion

        void chartControlTrend_ChartFormatAxisLabel(object sender, Syncfusion.Windows.Forms.Chart.ChartFormatAxisLabelEventArgs args)
        {
            TimeSpan _ts = _endTime - _startTime;
            if (_ts.TotalMilliseconds > 0)
            {
                if (args.IsAxisPrimary)
                {
                    if (((_ts.TotalDays * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width))) / (this.chartControlTrend.PrimaryXAxis.Size.Width * Screen.PrimaryScreen.Bounds.Width)) < 17)
                    {
                        //this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime,_endTime, Math.Max((_ts.TotalMilliseconds * 4.5 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
                        args.Label = args.ValueAsDate.ToString("M/d/yy\nHH:mm:ss");
                    }
                    else
                    {
                        //this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime,_endTime, Math.Max((_ts.TotalMilliseconds * 2.25 * 1152 *(Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width)))/(2.0*24*1000* Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width),1) , ChartDateTimeIntervalType.Seconds);
                        args.Label = args.ValueAsDate.ToString("M/d/yy");
                    }
                    args.Handled = true;
                }
                else if (args.IsAxisPrimary)
                {
                    args.Label = "";
                    args.Handled = true;
                }
            }
        }

        private void UserControlMultiTrendSingleGraph_Load(object sender, EventArgs e)
        {

        }

        protected void ChartControlSeries_PrepareStyleMulti(object sender, ChartPrepareStyleInfoEventArgs args)
		{
			// Style formatting using a callback. You can apply the same settings directly on the series style on the
			// point styles.
			ChartSeries series = sender as ChartSeries;
            int index = chartControlTrend.Model.Series.IndexOf(series);
            TrendSetting trendSetting = _htTrendSettings[index] as TrendSetting;
			if(series != null)
			{
				args.Style.Symbol.Shape = (ChartSymbolShape)Enum.Parse(typeof(ChartSymbolShape),trendSetting.SymbolShape);
				args.Style.Symbol.Size = new Size(5,5);
                try
                {
                    args.Style.Symbol.Color = Color.FromArgb(int.Parse(trendSetting.SymbolColor));
                }
                catch
                {
                    try
                    {
                        args.Style.Symbol.Color = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SymbolColor));
                    }
                    catch { }
                }
				args.Style.DisplayShadow = true;
				args.Style.ToolTip = LRRHeaderText.GetHeaderString("SID_STARTTIME") + ": " + series.Points[args.Index].DateX.ToString(Symcon.BusinessObjects.SymConverter.Culture) + "\n" + LRRHeaderText.GetHeaderString("SID_PROPERTYVALUE") + ": " + series.Points[args.Index].YValues[0];
				args.Handled = true;
			}
		}

        #region Public Methods
        
        public void InitTrend(TemplateRows templateRows,Hashtable htTemplateRows)
        {
            _htTemplateRows = htTemplateRows;
            _templateRows = templateRows;
            _htTrendSettings.Clear();
            _htOrigUOMS.Clear();
            _htOrigChartSeries.Clear();
            _htCurrSeries.Clear();
            _htTemplatesRows = htTemplateRows;
            int noOfSeries = templateRows.TrendSettings.Length;
            string localeID = LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID;
            DateTime startTime = DateTime.Now.AddYears(1500);
            DateTime endTime = DateTime.Now.AddYears(-1500);
            
            chartControlTrend.Model.Series.Clear();
            
            for (int i = 0; i < noOfSeries; i++)
            {
                TrendSetting trendSetting = templateRows.TrendSettings[i];

                _htTrendSettings.Add(i,trendSetting);
                UserControlTrendTemplateRowsWithUOM tempRow = htTemplateRows[i + 1] as UserControlTrendTemplateRowsWithUOM;
                ComboBox comboBoxUOM = tempRow.comboBoxUOM;
                string propValueID = trendSetting.SchemeName;
			    LRRSiteComponentPropertyValue scpv = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(propValueID);
                if (scpv != null)
                {
                    string modelUOM = scpv.ModelUOM;
                    string currentUOM = modelUOM;
                    string uomType = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(currentUOM);
                    
                    string uiUom = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomType);

                    IProperty iProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(scpv.SiteComponentPropertyID) as IProperty;
                    string modeID = scpv.ModeID;

                    if (uiUom == null)
                        uiUom = currentUOM;

                    if (comboBoxUOM.SelectedItem == null)
                    {
                        currentUOM = uiUom;
                        
                        if (trendSetting.UOM != null)
                        {
                            currentUOM = trendSetting.UOM;
                        }
                        LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(uomType);

                        comboBoxUOM.DataSource = uoms;
                        comboBoxUOM.DisplayMember = "Name";
                        comboBoxUOM.ValueMember = "ID";
                        try
                        {
                            comboBoxUOM.SelectedValue = currentUOM;
                        }
                        catch
                        {
                        }
                        comboBoxUOM.SelectedIndexChanged += new EventHandler(comboBoxUOM_SelectedIndexChanged);
                    }
                    else
                    {
                        comboBoxUOM.SelectedIndexChanged -= new EventHandler(comboBoxUOM_SelectedIndexChanged);
                        currentUOM = comboBoxUOM.SelectedValue as string;
                        comboBoxUOM.SelectedIndexChanged += new EventHandler(comboBoxUOM_SelectedIndexChanged);
                    }
                    //if (!_lrrApp.RecordingValuesManagerObj.ExistsRecordingDB())
                    //{
                    //    _errorMsg = LRRHeaderText.GetHeaderString("SID_TREND_DB_ERROR");
                    //    return;
                    //}
                    string siteCompPropValueID = propValueID;

                    //InitializeChartAppearance();

                    chartControlTrend.Font = this.Font;
                    LRRSiteComponentProperty lrrscp = iProp as LRRSiteComponentProperty;
                    string newText = LRRModel.ChildModel.Modes.GetModeByID(modeID).ModeName + ": " + LRRModel.ChildModel.SiteComponents.GetSiteComponentByID(lrrscp.ComponentID).Name + ": " + iProp.GetName();
                    //LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(currentUOM);
                    //if (uom != null)
                    //{
                    //    newText += " (" + uom.Name + ")";
                    //}
                    _htAxisTitle.Add(i,newText);
                    _htOrigUOMS.Add(i,currentUOM);

                    string siteCompPropID = iProp.GetID();
                    // string siteCompPropValueID = scpv.ID;

                    LRRSiteComponentPropertyValueChangeUserAndTimes scpvcuts = new LRRSiteComponentPropertyValueChangeUserAndTimes();

                    //_lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts, " WHERE SiteComponentPropertyValueID='" + siteCompPropValueID + "' AND IsRecorded=False");

                    //where clause changed by Ashwin
                    _lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts, " WHERE SiteComponentPropertyID= " + "'" + siteCompPropID + "'");



                    ChartSeries series = this.chartControlTrend.Model.NewSeries("Series " + i);
                    _htSeries.Add(siteCompPropValueID, series);
                    _htOrigChartSeries.Add(i,series);
                    _htCurrSeries.Add(i,series);
                    foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpvcut in scpvcuts)
                    {
                        try
                        {
                            double point;
                            if (double.TryParse(ConvertUOM(modelUOM, currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Float, Symcon.BusinessObjects.SymConverter.Culture, out point))
                            {
                                if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < startTime)
                                    startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                                if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > endTime)
                                    endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                                double[] points = new double[] { point, 1 };
                                series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                            }
                        }
                        catch
                        {

                        }
                    }



                    series.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType), trendSetting.SeriesType);
                    series.Text = series.Name;



                    series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyleMulti);

                    try 
                    {
                        series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(trendSetting.SeriesInteriorColor)), Color.Black });
                    }
                    catch
                    {
                        try
                        {
                            series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SeriesInteriorColor)), Color.Black });
                        }
                        catch
                        { 
                        }
                    }

                    //chartControlTrend.Model.Series.Clear();
                    this.chartControlTrend.Series.Add(series);



                    ChartAxis secYAxis = new ChartAxis();
                    //secYAxis.Orientation = Orientation.Vertical;
                    chartControlTrend.Axes.Add(secYAxis);
                    //secYAxis.Range = new MinMaxInfo(0, 1000, 100);
                    try
                    {
                        secYAxis.ForeColor = Color.FromArgb(int.Parse(trendSetting.SymbolColor));
                    }
                    catch
                    {
                        try
                        {
                            secYAxis.ForeColor = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SymbolColor));
                        }
                        catch
                        { }
                    }
                    secYAxis.Title = newText;
                    secYAxis.LocationType = ChartAxisLocationType.Set;

                    secYAxis.Location = new PointF(100 * (i+1), chartControlTrend.PrimaryYAxis.Location.Y);
                    secYAxis.OpposedPosition = false;
                    series.YAxis = secYAxis;

                    _htSecYAxis.Add(i, secYAxis);



                }
                else
                {
                    LRRSiteGroupPropertyQualifierValue gpqv = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(propValueID);

                    if (gpqv != null)
                    {
                        string modelUOM = gpqv.ModelUOM;
                        string currentUOM = modelUOM;
                        string uomType = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(currentUOM);
                        
                        string uiUom = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomType);

                        if (uiUom == null)
                            uiUom = currentUOM;

                        if (comboBoxUOM.SelectedItem == null)
                        {
                            currentUOM = uiUom;
                            
                            if (trendSetting.UOM != null)
                            {
                                currentUOM = trendSetting.UOM;
                            }
                            LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(uomType);

                            comboBoxUOM.DataSource = uoms;
                            comboBoxUOM.DisplayMember = "Name";
                            comboBoxUOM.ValueMember = "ID";
                            try
                            {
                                comboBoxUOM.SelectedValue = currentUOM;
                            }
                            catch
                            {
                            }
                        }
                        else
                        {
                            comboBoxUOM.SelectedIndexChanged -= new EventHandler(comboBoxUOM_SelectedIndexChanged);
                            currentUOM = comboBoxUOM.SelectedValue as string;
                            comboBoxUOM.SelectedIndexChanged += new EventHandler(comboBoxUOM_SelectedIndexChanged);
                        }

                        IPropertyValue iPropValue = gpqv;
                        
                        string newText = LRRModel.ChildModel.Modes.GetModeByID(iPropValue.GetModeID()).ModeName + ":" + LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(gpqv.MasterPropID).Name;
                        if (gpqv.LookUpQualifierID != null)
                        {
                            LRRLookUpQualifier lrrLkUpQual = LRRModel.ChildModel.LookUpQualifiers.getLookUpQualifierForLkupQualifierID(gpqv.LookUpQualifierID);
                            newText += ":" + LRRModel.Qualifiers.getQualifierObjectForQualifierID(lrrLkUpQual.QualifierID).Name;
                        }
                        newText += ":" + LRRModel.ChildModel.LookUpProperties.getLookUpPropertyForLkupPropID(gpqv.LookUpPropertiesID).Name;

                        //LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(currentUOM);
                        //if (uom != null)
                        //{
                        //    newText += " (" + uom.Name + ")";
                        //}
                        _htAxisTitle.Add(i, newText);
                        _htOrigUOMS.Add(i,currentUOM);

                        string siteGroupPropertyQualifierValueID = iPropValue.GetID();


                        LRRSiteComponentPropertyValueChangeUserAndTimes scpvcuts = new LRRSiteComponentPropertyValueChangeUserAndTimes();

                        _lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcuts, " WHERE  SiteComponentPropertyValueID='" + siteGroupPropertyQualifierValueID + "' AND IsRecorded=False");



                        ChartSeries series = this.chartControlTrend.Model.NewSeries("Series " + i);
                        _htSeries.Add(siteGroupPropertyQualifierValueID, series);
                        _htOrigChartSeries.Add(i,series);
                        _htCurrSeries.Add(i,series);
                        foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpvcut in scpvcuts)
                        {
                            try
                            {
                                double point;
                                if (double.TryParse(ConvertUOM(modelUOM, currentUOM, scpvcut.PropertyValue), System.Globalization.NumberStyles.Float, Symcon.BusinessObjects.SymConverter.Culture, out point))
                                {
                                    if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) < startTime)
                                        startTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                                    if (DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture) > endTime)
                                        endTime = DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture);

                                    double[] points = new double[] { point, 1 };
                                    series.Points.Add(DateTime.Parse(scpvcut.StartTime, Symcon.BusinessObjects.SymConverter.Culture), points);
                                }
                            }
                            catch
                            {

                            }
                        }


                        series.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType), trendSetting.SeriesType);
                        series.Text = series.Name;

                        series.PrepareStyle += new ChartPrepareStyleInfoHandler(this.ChartControlSeries_PrepareStyleMulti);

                        try
                        {
                            series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(trendSetting.SeriesInteriorColor)), Color.Black });
                        }
                        catch
                        {
                            try
                            {
                                series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SeriesInteriorColor)), Color.Black });
                            }
                            catch
                            { }
                        }


                        //chartControlTrend.Model.Series.Clear();
                        this.chartControlTrend.Series.Add(series);

                        ChartAxis secYAxis = new ChartAxis();
                        //secYAxis.Orientation = Orientation.Vertical;
                        chartControlTrend.Axes.Add(secYAxis);
                        //secYAxis.Range = new MinMaxInfo(0, 1000, 100);
                        try
                        {
                            secYAxis.ForeColor = Color.FromArgb(int.Parse(trendSetting.SymbolColor));
                        }
                        catch
                        {
                            try
                            {
                                secYAxis.ForeColor = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SymbolColor));
                            }
                            catch
                            { 
                            }
                        }
                        secYAxis.Title = newText;
                        secYAxis.LocationType = ChartAxisLocationType.Set;

                        secYAxis.Location = new PointF(100 * (i + 1), chartControlTrend.PrimaryYAxis.Location.Y);
                        secYAxis.OpposedPosition = false;
                        series.YAxis = secYAxis;

                        _htSecYAxis.Add(i, secYAxis);
                    }
                }
            }

            _startTime = startTime;
            

            _endTime = endTime;

            TimeSpan ts = endTime - startTime;
            if (ts.TotalHours < 11 && ts.TotalMilliseconds >=0 )
            {
                ts = TimeSpan.FromHours(11);
                //T//imeSpan timeMarginStart = TimeSpan.FromTicks(_ts.Ticks/10);
                _startTime = endTime.Subtract(ts);

            }

            this.chartControlTrend.ShowToolTips = true;
            ChartAxis secYAxis2 = new ChartAxis();
            //secYAxis2.Orientation = Orientation.Vertical;
            chartControlTrend.Axes.Add(secYAxis2);
            //secYAxis.Range = new MinMaxInfo(0, 1000, 100);
            secYAxis2.ForeColor = Color.Transparent;
            secYAxis2.DrawGrid = false;
            //secYAxis2.Size = new SizeF(0, 0);
            secYAxis2.LocationType = ChartAxisLocationType.Set;

            secYAxis2.Location = new PointF(chartControlTrend.PrimaryYAxis.Location.X + 100, chartControlTrend.PrimaryYAxis.Location.Y);
            secYAxis2.OpposedPosition = false;

            AdjustXScale();
        }

        void comboBoxUOM_SelectedIndexChanged(object sender, EventArgs e)
        {
            ComboBox comboBoxUOM = sender as ComboBox;
            for (int i = 0; i < _htTemplatesRows.Count; i++)
            {
                UserControlTrendTemplateRowsWithUOM tempRow = _htTemplatesRows[i + 1] as UserControlTrendTemplateRowsWithUOM;
                ComboBox comboBoxUOM2 = tempRow.comboBoxUOM;
                if (comboBoxUOM == comboBoxUOM2)
                {
                    try
                    {
                        string newUOM = comboBoxUOM.SelectedValue as string;
                        ChartSeries seriesOrig = _htOrigChartSeries[i] as ChartSeries;
                        ChartSeries oldSeries = _htCurrSeries[i] as ChartSeries;
                        oldSeries.YAxis = null;
                        chartControlTrend.Model.Series.Remove(oldSeries);

                        ChartSeries seriesNew = chartControlTrend.Model.NewSeries("series " + i);
                        for (int j = 0; j < seriesOrig.Points.Count; j++)
                        {
                            ChartPoint cp = seriesOrig.Points[j];
                            seriesNew.Points.Add(cp.DateX, double.Parse(ConvertUOM(_htOrigUOMS[i] as string, newUOM, cp.YValues[0].ToString())));
                        }


                        TrendSetting trendSetting = _htTrendSettings[i] as TrendSetting;
                        seriesNew.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType), trendSetting.SeriesType);
                        seriesNew.Text = seriesNew.Name;

                        try
                        {
                            seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(trendSetting.SeriesInteriorColor)), Color.Black });
                        }
                        catch
                        {
                            try
                            {
                                seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SeriesInteriorColor)), Color.Black });
                            }
                            catch
                            { }
                        }

                        seriesNew.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyleMulti);
                        
                        ChartAxis secYAxis2 = _htSecYAxis[i] as ChartAxis;
                        chartControlTrend.Axes.Remove(secYAxis2);
                        ChartAxis secYAxis = new ChartAxis();
                        //secYAxis.Orientation = Orientation.Vertical;
                        chartControlTrend.Axes.Add(secYAxis);
                        //secYAxis.Range = new MinMaxInfo(0, 1000, 100);
                        try
                        {
                            secYAxis.ForeColor = Color.FromArgb(int.Parse(trendSetting.SymbolColor));
                        }
                        catch
                        {
                            try
                            {
                                secYAxis.ForeColor = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SymbolColor));
                            }
                            catch
                            { }
                        }
                        secYAxis.Title = _htAxisTitle[i] as string;
                        secYAxis.LocationType = ChartAxisLocationType.Set;

                        secYAxis.Location = new PointF(100 * (i + 1), chartControlTrend.PrimaryYAxis.Location.Y);
                        secYAxis.OpposedPosition = false;
                        seriesNew.YAxis = secYAxis;
                        _htSecYAxis[i] = secYAxis;
                        chartControlTrend.Model.Series.Add(seriesNew);

                        _htCurrSeries[i] = seriesNew;
                    }
                    catch
                    { }
                    break;
                }
            }
            ComboBox combo = sender as ComboBox;
            for (int i = 0; i < _htTemplatesRows.Count; i++)
            {
                UserControlTrendTemplateRowsWithUOM tempRow = _htTemplatesRows[i+1] as UserControlTrendTemplateRowsWithUOM;
                ComboBox combo2 = tempRow.comboBoxUOM;
                if (combo == combo2)
                {
                    TrendSetting trendSetting = _htTrendSettings[i] as TrendSetting;
                    trendSetting.UOM = combo.SelectedValue.ToString();
                    break;
                }
            }
        }

        #endregion

        private void AdjustXScale()
        {
            try
            {
                TimeSpan _ts = _endTime - _startTime;
                if (_ts.TotalMilliseconds != 0)
                {
                    if (((_ts.TotalDays * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width))) / (this.chartControlTrend.PrimaryXAxis.Size.Width * Screen.PrimaryScreen.Bounds.Width)) < 17)
                        this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime, _endTime, Math.Max((_ts.TotalMilliseconds * 4.5 * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width))) / (2.0 * 24 * 1000 * Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width), 1), ChartDateTimeIntervalType.Seconds);
                    else
                        this.chartControlTrend.PrimaryXAxis.DateTimeRange = new ChartDateTimeRange(_startTime, _endTime, Math.Max((_ts.TotalMilliseconds * 2.25 * 1152 * (Screen.PrimaryScreen.Bounds.Width - (this.Width - this.chartControlTrend.PrimaryXAxis.Size.Width))) / (2.0 * 24 * 1000 * Screen.PrimaryScreen.Bounds.Width * this.chartControlTrend.PrimaryXAxis.Size.Width), 1), ChartDateTimeIntervalType.Seconds);
                }
            }
            catch
            {

            }
        }

        private string ConvertUOM(string oldUOMValue, string newUOMValue, string propVal)
        {
            string newVal = "";
            if (propVal != null && propVal != "")
            {
                if (oldUOMValue == newUOMValue)
                {
                    newVal = propVal;
                }
                else
                {
                    if ((oldUOMValue != null && oldUOMValue != "") &&
                        (newUOMValue != null && newUOMValue != ""))
                    {
                        newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldUOMValue, newUOMValue, propVal,null);
                    }
                }
            }
            return newVal;
        }
    }
}
