using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Utils.HeaderDispatcher;   
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.Utils.MessageDispatcher;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.
namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlQualifiers.
	/// </summary>
	public class UserControlQualifiers : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		private LRRApp						_app;
		private LRRQualifiers		_lrrQualifiers;
		private LRRLookUpQualifiers _lrrLookUpQualifiers;
		private bool deleteLookUpQualifier=false;
		private TabControl					_parentTabControl;
		private TabPage						_parentTabPage;
		private GridExcelFormatter	_gridExcelFormatter = new GridExcelFormatter(); 
		bool isSaved = false;
        private ArrayList _arrQualifiers = new ArrayList();
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridQualifiers;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UserControlQualifiers()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_gridExcelFormatter.WireGrid(this.gridQualifiers);
			InitDataSource();
			SyncGridUtilities.InitializeGridLookAndFeel(gridQualifiers);
			BindgridQualifier();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridQualifiers = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridQualifiers)).BeginInit();
			this.SuspendLayout();
			// 
			// gridQualifiers
			// 
			this.gridQualifiers.BackColor = System.Drawing.SystemColors.Window;
			this.gridQualifiers.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridQualifiers.Location = new System.Drawing.Point(0, 0);
			this.gridQualifiers.Name = "gridQualifiers";
			this.gridQualifiers.Size = new System.Drawing.Size(744, 376);
			this.gridQualifiers.TabIndex = 6;
			this.gridQualifiers.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Any | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.MixRangeType)));
			this.gridQualifiers.Text = "gridGroupingControl1";
			this.gridQualifiers.TopLevelGroupOptions.CaptionText = "Qualifiers : {RecordCount} Items";
			this.gridQualifiers.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridQualifiers.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridQualifiers.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridQualifiers.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridQualifiers.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridQualifiers.VersionInfo = "3.301.0.0";
			this.gridQualifiers.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridQualifiers_RecordDeleting);
			// 
			// UserControlQualifiers
			// 
			this.Controls.Add(this.gridQualifiers);
			this.Name = "UserControlQualifiers";
			this.Size = new System.Drawing.Size(744, 376);
			this.Tag = "SID_QUALIFIER";
			((System.ComponentModel.ISupportInitialize)(this.gridQualifiers)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		# region InitDataSource
		private void InitDataSource()
		{
			if(_lrrQualifiers != null)
				_lrrQualifiers.Clear();
			_lrrQualifiers=new LRRQualifiers();
			_app.DBManagerObj.PopulateCollection(_lrrQualifiers,false);
            foreach (LRRQualifier qual in _lrrQualifiers)
            {
                _arrQualifiers.Add(qual.Name);
            }
			if(_lrrLookUpQualifiers != null)
				_lrrLookUpQualifiers.Clear();
			_lrrLookUpQualifiers=new LRRLookUpQualifiers();
			_app.DBManagerObj.PopulateCollection(_lrrLookUpQualifiers,false);
		}
		#endregion
		#region BindGridQualifier

		private void BindgridQualifier()
		{
			
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridQualifiers.SuspendLayout();
			SyncGridUtilities.InitializeGridColumns(gridQualifiers,gridQualifiers.TableDescriptor,_lrrQualifiers.ItemType,null);
			RelativeWidths.Add( LRRHeaderText.GetHeaderString("SID_NAME"),50);
			RelativeWidths.Add(LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),70);
			gridQualifiers.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_QUALIFIER") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			SyncGridUtilities.InitializeGridColumnsWidth(gridQualifiers,RelativeWidths );
			//Set the data store 
			gridQualifiers.DataSource = _lrrQualifiers;
			gridQualifiers.TableDescriptor.AllowNew = true;
			gridQualifiers.TableDescriptor.AllowRemove = true;
			gridQualifiers.TableDescriptor.AllowEdit = true;
			//Resume the Layout of the Grid...
			gridQualifiers.ResumeLayout(false);
			//Add the parent table for the Relations...
			gridQualifiers.Engine.SourceListSet.Add("ParentTable",_lrrQualifiers);

			string[,] arry=new string[,]{{LRRHeaderText.GetHeaderString("SID_DESCRIPTION"),"255"}};
			Validations	obj=new Validations(gridQualifiers,arry);
		}

		#endregion
		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			
			BindgridQualifier();
		}

		public void Save()
		{

			foreach (LRRQualifier  lrrQuality in _lrrQualifiers)
			{
				if(lrrQuality.ObjectState != DBOperation.DELETE)
				{
					string sName = lrrQuality.Name  == null ? "" : lrrQuality.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					string sQualID = lrrQuality.QualifierID == null ? "" : lrrQuality.QualifierID.ToString(Symcon.BusinessObjects.SymConverter.Culture);

					if(sName=="") 
					{
						LRRMessagBox.ShowMessage("SID_SAVEABORT_QUALIFIERNAME_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
						return;
					}

					foreach (LRRQualifier  objQualifier in _lrrQualifiers)
					{
						if((objQualifier.QualifierID != sQualID) && (objQualifier.ObjectState != DBOperation.DELETE))
						{
							string sQualName = objQualifier.Name  == null ? "" : objQualifier.Name.ToString(Symcon.BusinessObjects.SymConverter.Culture);
							if(sQualName.ToUpper() == sName.ToUpper())
							{
								//MessageBox.Show("Qualifier name - " + sQualName + " already exists. Save operation aborted!","Message",MessageBoxButtons.OK,MessageBoxIcon.Information);
								string[] s = new string[1];
								s[0] = sQualName;
								LRRMessagBox.ShowMessage("SID_PROP_DUPLICATE","SID_LABEL",s,MessageBoxButtons.OK,MessageBoxIcon.Error);     
								
								return;
							}
						}
					}
				}

			}
			if(_lrrQualifiers.GetChanges().Count>0)
			{
                foreach (LRRQualifier qual in _lrrQualifiers.GetChanges())
                {
                    if (qual.ObjectState == DBOperation.INSERT)
                    {
                        MessagingClient.RaiseAlert("Qualifier: " + qual.Name + " added.");
                        if(!_arrQualifiers.Contains(qual.Name))
                            _arrQualifiers.Add(qual.Name);
                    }
                    if(_arrQualifiers.Contains(qual.Name))
                    {
                        if (qual.ObjectState == DBOperation.UPDATE)
                        {
                            MessagingClient.RaiseAlert("Qualifier: " + qual.Name + " updated.");
                        }
                        
                        if (qual.ObjectState == DBOperation.DELETE)
                        {
                            MessagingClient.RaiseAlert("Qualifier: " + qual.Name + " deleted.");
                            _arrQualifiers.Remove(qual.Name);
                        }
                    }
                }
				_app.DBManagerObj.CommitCollection(_lrrQualifiers.GetChanges());
				OptionsUserControl.saved	=true;
			}
				if(_lrrQualifiers.HasError)
				{
					LRRMessagBox.ShowMessage("SID_SAVE_WITHERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
				else
				{

					_lrrQualifiers.RefreshCollection();

				}

			InitDataSource();
			
			BindgridQualifier();
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridQualifiers.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridQualifiers,false);
			}

		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return true;
		}

		public void SelectionPaste()
		{
			SyncGridUtilities.PasteSelection(gridQualifiers);
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion


		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true ; 
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}
		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridQualifiers_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(_isDeletePress)
			{
				DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
				if(_dlgResult == DialogResult.Yes)
				{
					_isRecordeDel = true; 
				}
				else
				{
					_isRecordeDel = false; 
				}
				_isDeletePress = false;
			}
			if(_isRecordeDel)
			{
				deleteLookUpQualifier=true;
				LRRQualifier objQualifier = e.Record.GetData() as LRRQualifier;
				if(objQualifier!=null)
				{
					IEnumerator GrpQualifierEnum = _lrrLookUpQualifiers.GetEnumerator();
					while(GrpQualifierEnum.MoveNext())
					{
						LRRLookUpQualifier GrpQualifier = GrpQualifierEnum.Current as LRRLookUpQualifier;
			
						if(GrpQualifier.QualifierID == objQualifier.QualifierID)
						{
							LRRMessagBox.ShowMessage("SID_QUALIFIER_DELETE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
							e.Cancel=true;
						
							return;
						}
				
					}
				}
			}
			else
			{
				e.Cancel = true;
				return;
			}
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridQualifiers);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlQualifiers.PrintPreview implementation
			if(gridQualifiers.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridQualifiers,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlQualifiers.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlQualifiers.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlQualifiers.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlQualifiers.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlQualifiers.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlQualifiers.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlQualifiers.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlQualifiers.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlQualifiers.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlQualifiers.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlQualifiers.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlQualifiers.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlQualifiers.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlQualifiers.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlQualifiers.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlQualifiers.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlQualifiers.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlQualifiers.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
