using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Symcon.LightRidge.PEAdvisor;
using Symcon.LightRidge.BusinessObjects;
using Syncfusion.Windows.Forms.Chart;
using Symcon.Utils.HeaderDispatcher;
using Symcon.LightRidge.PEAdvisor.UserControls;

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
    public partial class UserControlTrendXY : UserControl
    {
        #region Constructor

        public UserControlTrendXY()
        {
            InitializeComponent();
            _lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;

            buttonShowAll.Text = LRRHeaderText.GetHeaderString(buttonShowAll.Text);
            buttonApply.Text = LRRHeaderText.GetHeaderString(buttonApply.Text);
            labelDTEnd.Text = LRRHeaderText.GetHeaderString(labelDTEnd.Text) + ":";
            labelDTStart.Text = LRRHeaderText.GetHeaderString(labelDTStart.Text) + ":";
            labelXUOM.Text = LRRHeaderText.GetHeaderString(labelXUOM.Text) + ":";
            labelYUOM.Text = LRRHeaderText.GetHeaderString(labelYUOM.Text) + ":";
            chartControlTrend.Text = LRRHeaderText.GetHeaderString(chartControlTrend.Text);
            this.chartControlTrend.DisplayChartContextMenu = false;
            _lrrApp.RunControllerObj.TrendPointRecieved += new TrendPointRecievedDel(RunControllerObj_TrendPointRecieved);
		}

        public delegate void AddPointDel(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange);

        void RunControllerObj_TrendPointRecieved(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange)
        {
            try
            {
                if ((siteCompPropValueChange.SiteComponentPropertyValueID == _xAxisIPropValueID) || (siteCompPropValueChange.SiteComponentPropertyValueID == _yAxisIPropValueID))
                {
                    AddPointDel addPointDel = new AddPointDel(AddPoint);
                    _lrrApp.MainFrame.Invoke(addPointDel, new object[] { siteCompPropValueChange });
                }
            }
            catch
            {

            }
           
        }

        private void AddPoint(LRRSiteComponentPropertyValueChangeUserAndTime siteCompPropValueChange)
        {

            if (siteCompPropValueChange.SiteComponentPropertyValueID == _xAxisIPropValueID)
            {
                _pointRecievedX = siteCompPropValueChange;
            }
            if (siteCompPropValueChange.SiteComponentPropertyValueID == _yAxisIPropValueID)
            {
                _pointRecievedY = siteCompPropValueChange;
            }
            if ((_pointRecievedX != null) && (_pointRecievedY != null))
            {
                try
                {
                    ChartSeries series = chartControlTrend.Model.Series[0];
                    DateTime pointStartTime = DateTime.Parse(_pointRecievedX.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
                    if (!_isDateInitialized)
                    {
                        if (_pointRecievedX.StartTime == _pointRecievedY.StartTime)
                        {
                            double pointX, pointY;
                            if (double.TryParse(ConvertUOM(_modelUOMX, _currentUOMX, _pointRecievedX.PropertyValue), out pointX) && double.TryParse(ConvertUOM(_modelUOMY, _currentUOMY, _pointRecievedY.PropertyValue), out pointY))
                            {
                                series.Points.Add(pointX, pointY);

                                if (pointStartTime < _startTime)
                                    _startTime = pointStartTime;
                                if (pointStartTime > _endTime)
                                    _endTime = pointStartTime;
                            }
                        }
                        //check = true;
                    }
                    else
                    {
                        if (pointStartTime >= _startTime && pointStartTime <= _endTime)
                        {
                            if (_pointRecievedX.StartTime == _pointRecievedY.StartTime)
                            {
                                double pointX, pointY;
                                if (double.TryParse(ConvertUOM(_modelUOMX, _currentUOMX, _pointRecievedX.PropertyValue), out pointX) && double.TryParse(ConvertUOM(_modelUOMY, _currentUOMY, _pointRecievedY.PropertyValue), out pointY))
                                {
                                    series.Points.Add(pointX, pointY);
                                }

                            }
                        }
                    }

                }
                catch(Exception ex)
                {
                    
                }
                _pointRecievedX = null;
                _pointRecievedY = null;
                //chartControlTrend.Refresh();
            }

        }

        #endregion

        #region Fields

        private LRRApp _lrrApp = null;
        private TrendSetting _trendSetting = null;
        private DateTime _startTime = DateTime.Now;
        private DateTime _endTime = DateTime.Now.AddYears(-1500);
        private TemplateRows _tempRows = null;
        private bool _isDateInitialized = false;
        private bool _allowUOMChange = false;
        private string _currentUOMX = "";
        private string _modelUOMX = "";
        private string _currentUOMY = "";
        private string _modelUOMY = "";
        private string _xAxisIPropValueID;
        private string _yAxisIPropValueID;
        private LRRSiteComponentPropertyValueChangeUserAndTime _pointRecievedX = null;
        private LRRSiteComponentPropertyValueChangeUserAndTime _pointRecievedY = null;

        #endregion

        #region Public Methods

        public void InitTrend(TemplateRows templateRows)
        {
            _tempRows = templateRows;
            this.chartControlTrend.Model.Series.Clear();

            DateTime startTime = DateTime.Now;
            DateTime endTime = DateTime.Now.AddYears(-1500);

            LRRSiteComponentPropertyValueChangeUserAndTimes scpvcutsX = new LRRSiteComponentPropertyValueChangeUserAndTimes();

            LRRSiteComponentPropertyValueChangeUserAndTimes scpvcutsY = new LRRSiteComponentPropertyValueChangeUserAndTimes();

            _trendSetting = templateRows.TrendSettings[0];

            string xAxisIPropValueID = _trendSetting.SchemeName.Split(new char[] { '|' })[0];
            string yAxisIPropValueID = _trendSetting.SchemeName.Split(new char[] { '|' })[1];

            _xAxisIPropValueID = xAxisIPropValueID;
            _yAxisIPropValueID = yAxisIPropValueID;

            LRRSiteComponentPropertyValue scpvX = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(xAxisIPropValueID);

            string modelUomX = "";
            string modelUomY = "";
            string uiUomX = "";
            string uiUomY = "";
            string uomTypeX = "";
            string uomTypeY = "";
            string xAxisTitle = "";
            string yAxisTitle = "";

            string localeID = LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID;
            if (scpvX != null)
            {
                _modelUOMX = modelUomX = scpvX.ModelUOM;
                uomTypeX = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(modelUomX);
                uiUomX = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomTypeX);

                IProperty iProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(scpvX.SiteComponentPropertyID) as IProperty;
                string modeID = scpvX.ModeID;

                LRRSiteComponentProperty lrrscp = iProp as LRRSiteComponentProperty;
                xAxisTitle = LRRModel.ChildModel.Modes.GetModeByID(modeID).ModeName + ": " + LRRModel.ChildModel.SiteComponents.GetSiteComponentByID(lrrscp.ComponentID).Name + ": " + iProp.GetName();
                //LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(uiUomX);
                //if (uom != null)
                //{
                //    xAxisTitle += " (" + uom.Name + ")";
                //}

                _lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcutsX, " WHERE SiteComponentPropertyValueID='" + xAxisIPropValueID + "' AND IsRecorded=False");
            }
            else
            {
                LRRSiteGroupPropertyQualifierValue gpqvX = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(xAxisIPropValueID);
                _modelUOMX = modelUomX = gpqvX.ModelUOM;
                uomTypeX = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(modelUomX);
                uiUomX = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomTypeX);
                
                IPropertyValue iPropValue = gpqvX;

                xAxisTitle = LRRModel.ChildModel.Modes.GetModeByID(iPropValue.GetModeID()).ModeName + ":" + LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(gpqvX.MasterPropID).Name;
                if (gpqvX.LookUpQualifierID != null)
                {
                    LRRLookUpQualifier lrrLkUpQual = LRRModel.ChildModel.LookUpQualifiers.getLookUpQualifierForLkupQualifierID(gpqvX.LookUpQualifierID);
                    xAxisTitle += ":" + LRRModel.Qualifiers.getQualifierObjectForQualifierID(lrrLkUpQual.QualifierID).Name;
                }
                xAxisTitle += ":" + LRRModel.ChildModel.LookUpProperties.getLookUpPropertyForLkupPropID(gpqvX.LookUpPropertiesID).Name;

                //LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(uiUomX);
                //if (uom != null)
                //{
                //    xAxisTitle += " (" + uom.Name + ")";
                //}

                _lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcutsX, " WHERE  SiteComponentPropertyValueID='" + xAxisIPropValueID + "' AND IsRecorded=False");


            }

            LRRSiteComponentPropertyValue scpvY = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(yAxisIPropValueID);
            if (scpvY != null)
            {
                _modelUOMY = modelUomY = scpvY.ModelUOM;
                uomTypeY = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(modelUomY);
                uiUomY = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomTypeY);

                IProperty iProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(scpvY.SiteComponentPropertyID) as IProperty;
                string modeID = scpvY.ModeID;

                LRRSiteComponentProperty lrrscp = iProp as LRRSiteComponentProperty;
                yAxisTitle = LRRModel.ChildModel.Modes.GetModeByID(modeID).ModeName + ": " + LRRModel.ChildModel.SiteComponents.GetSiteComponentByID(lrrscp.ComponentID).Name + ": " + iProp.GetName();
                //LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(uiUomY);
                //if (uom != null)
                //{
                //    yAxisTitle += " (" + uom.Name + ")";
                //}

                _lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcutsY, " WHERE SiteComponentPropertyValueID='" + yAxisIPropValueID + "' AND IsRecorded=False");

            }
            else
            {
                LRRSiteGroupPropertyQualifierValue gpqvY = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(yAxisIPropValueID);
                _modelUOMY = modelUomY = gpqvY.ModelUOM;
                uomTypeY = LRRModel.ChildModel.UOMTypeXRefs.GetUOMTypeIDFromUOMID(modelUomY);
                uiUomY = LRRModel.ChildModel.MeasSysDef.GetLocaleUOM(localeID, uomTypeY);

                IPropertyValue iPropValue = gpqvY;

                yAxisTitle = LRRModel.ChildModel.Modes.GetModeByID(iPropValue.GetModeID()).ModeName + ":" + LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(gpqvY.MasterPropID).Name;
                if (gpqvY.LookUpQualifierID != null)
                {
                    LRRLookUpQualifier lrrLkUpQual = LRRModel.ChildModel.LookUpQualifiers.getLookUpQualifierForLkupQualifierID(gpqvY.LookUpQualifierID);
                    xAxisTitle += ":" + LRRModel.Qualifiers.getQualifierObjectForQualifierID(lrrLkUpQual.QualifierID).Name;
                }
                xAxisTitle += ":" + LRRModel.ChildModel.LookUpProperties.getLookUpPropertyForLkupPropID(gpqvY.LookUpPropertiesID).Name;

                //LRRUOM uom = LRRModel.ChildModel.UOMs.GetUOMObjectFromID(uiUomX);
                //if (uom != null)
                //{
                //    xAxisTitle += " (" + uom.Name + ")";
                //}

                _lrrApp.RecordingValuesManagerObj.PopulateCollection(scpvcutsY, " WHERE  SiteComponentPropertyValueID='" + yAxisIPropValueID + "' AND IsRecorded=False");
            }

            if (uiUomX == null)
                uiUomX = modelUomX;

            if (uiUomY == null)
                uiUomY = modelUomY;
            

            ChartSeries series = this.chartControlTrend.Model.NewSeries("series 0");

            bool check = false;
            // Adding points to the series.
            foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpvcutX in scpvcutsX)
            {
                foreach (LRRSiteComponentPropertyValueChangeUserAndTime scpvcutY in scpvcutsY)
                {
                    try
                    {
                        DateTime pointStartTime = DateTime.Parse(scpvcutX.StartTime,Symcon.BusinessObjects.SymConverter.Culture);
                        if (!_isDateInitialized)
                        {
                            if (scpvcutX.StartTime == scpvcutY.StartTime)
                            {
                                double pointX, pointY;
                                if (double.TryParse(ConvertUOM(modelUomX, uiUomX, scpvcutX.PropertyValue), out pointX) && double.TryParse(ConvertUOM(modelUomY, uiUomY, scpvcutY.PropertyValue), out pointY))
                                {
                                    series.Points.Add(pointX, pointY);

                                    if (pointStartTime < startTime)
                                        startTime = pointStartTime;
                                    if (pointStartTime > endTime)
                                        endTime = pointStartTime;
                                }
                            }
                            check = true;
                        }
                        else
                        {
                            if (pointStartTime >= _startTime && pointStartTime <= _endTime)
                            {
                                if (scpvcutX.StartTime == scpvcutY.StartTime)
                                {
                                    double pointX, pointY;
                                    if (double.TryParse(ConvertUOM(modelUomX, uiUomX, scpvcutX.PropertyValue), out pointX) && double.TryParse(ConvertUOM(modelUomY, uiUomY, scpvcutY.PropertyValue), out pointY))
                                    {
                                        series.Points.Add(pointX, pointY);
                                    }

                                }
                            }
                        }
                    }
                    catch
                    {
                    }
                }
            }

            if (check)
            {
                try
                {
                    dateTimePicker1.Value = _startTime = startTime;
                    dateTimePicker2.Value = _endTime = endTime;
                }
                catch
                { 
                }
            }

            series.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType), _trendSetting.SeriesType);
            series.Text = series.Name;

            try
            {
                series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse(_trendSetting.SeriesInteriorColor)), Color.Black });
            }
            catch
            {
                try
                {
                    series.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), _trendSetting.SeriesInteriorColor)), Color.Black });
                }
                catch
                { }
            }

            this.chartControlTrend.PrimaryXAxis.Title = xAxisTitle;
            this.chartControlTrend.PrimaryYAxis.Title = yAxisTitle;

            chartControlTrend.Font = this.Font;

            chartControlTrend.Legend.Visible = false;
            series.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyle);
            chartControlTrend.Model.Series.Add(series);
            chartControlTrend.ShowToolTips = true;

            LRRUOMs uomsX = LRRModel.ChildModel.GetUOMsFromUOMTypeID(uomTypeX);
            LRRUOMs uomsY = LRRModel.ChildModel.GetUOMsFromUOMTypeID(uomTypeY);

            comboBoxXUOM.DataSource = uomsX;
            comboBoxXUOM.DisplayMember = "Name";
            comboBoxXUOM.ValueMember = "ID";
            try
            {
                comboBoxXUOM.SelectedValue = uiUomX;
            }
            catch
            { }
            _currentUOMX = uiUomX;

            comboBoxYUOM.DataSource = uomsY;
            comboBoxYUOM.DisplayMember = "Name";
            comboBoxYUOM.ValueMember = "ID";
            try
            {
                comboBoxYUOM.SelectedValue = uiUomY;
            }
            catch
            { }
            _currentUOMY = uiUomY;
            
            //comboBoxXUOM.Visible = false;
            //comboBoxYUOM.Visible = false;

            _allowUOMChange = true;
        }

        #endregion

        #region Events

        protected void ChartControlSeries_PrepareStyle(object sender, ChartPrepareStyleInfoEventArgs args)
        {
            // Style formatting using a callback. You can apply the same settings directly on the series style on the
            // point styles.
            ChartSeries series = sender as ChartSeries;
            int index = chartControlTrend.Model.Series.IndexOf(series);
            TrendSetting trendSetting = _trendSetting;
            if (series != null)
            {
                args.Style.Symbol.Shape = (ChartSymbolShape)Enum.Parse(typeof(ChartSymbolShape), trendSetting.SymbolShape);
                args.Style.Symbol.Size = new Size(5, 5);
                try
                {
                    args.Style.Symbol.Color = Color.FromArgb(int.Parse(trendSetting.SymbolColor));
                }
                catch
                {
                    try
                    {
                        args.Style.Symbol.Color = Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), trendSetting.SymbolColor));
                    }
                    catch { }
                }
                args.Style.DisplayShadow = true;
                try
                {
                    args.Style.ToolTip = "X: " + series.Points[args.Index].X + "\n" + "Y: " + series.Points[args.Index].YValues[0];
                }
                catch
                { 
                }
                args.Handled = true;
            }
        }
        
        private void buttonApply_Click(object sender, EventArgs e)
        {
            _isDateInitialized = true;
            _startTime = dateTimePicker1.Value;
            _endTime = dateTimePicker2.Value;
            InitTrend(_tempRows);
        }

        private void buttonShowAll_Click(object sender, EventArgs e)
        {
            _isDateInitialized = false;
            _startTime = DateTime.Now;
            _endTime = DateTime.Now.AddYears(-1500);
            InitTrend(_tempRows);
        }

        private void comboBoxXUOM_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                ChangeUOM(_currentUOMX,comboBoxXUOM.SelectedValue.ToString(), true);
                _currentUOMX = comboBoxXUOM.SelectedValue.ToString();
            }
            catch
            { }
        }

        private void comboBoxYUOM_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                ChangeUOM(_currentUOMY,comboBoxYUOM.SelectedValue.ToString() , false);
                _currentUOMY = comboBoxYUOM.SelectedValue.ToString();
            }
            catch
            { }
        }

        #endregion

        #region Private Methods

        private string ConvertUOM(string oldUOMValue, string newUOMValue, string propVal)
        {
            string newVal = "";
            if (propVal != null && propVal != "")
            {
                if (oldUOMValue == newUOMValue)
                {
                    newVal = propVal;
                }
                else
                {
                    if ((oldUOMValue != null && oldUOMValue != "") &&
                        (newUOMValue != null && newUOMValue != ""))
                    {
                        newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldUOMValue, newUOMValue, propVal,null);
                    }
                }
            }
            return newVal;
        }

        private void ChangeUOM(string oldUOMValue, string newUOMValue, bool isXAxisUOMChanged)
        {
            if (_allowUOMChange)
            {
                ChartSeries series = chartControlTrend.Model.Series[0];
                
                chartControlTrend.Model.Series.Clear();
                ChartSeries seriesNew = chartControlTrend.Model.NewSeries("series 0");

                for (int i = 0; i < series.Points.Count; i++)
                {
                    if (isXAxisUOMChanged)
                    {
                        try
                        {
                            seriesNew.Points.Add(Double.Parse(ConvertUOM(oldUOMValue, newUOMValue, series.Points[i].X.ToString())),series.Points[i].YValues[0]);
                        }
                        catch
                        {

                        }
                    }
                    else
                    {
                        try
                        {
                            seriesNew.Points.Add(series.Points[i].X,Double.Parse(ConvertUOM(oldUOMValue, newUOMValue, series.Points[i].YValues[0].ToString())));
                        }
                        catch
                        { 
                        }
                    }
                }
                seriesNew.Type = (ChartSeriesType)Enum.Parse(typeof(ChartSeriesType), _trendSetting.SeriesType);
                seriesNew.Text = seriesNew.Name;

                try
                {
                    seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromArgb(int.Parse( _trendSetting.SeriesInteriorColor)), Color.Black });
                }
                catch
                {
                    try
                    {
                        seriesNew.Style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, new Color[] { Color.FromKnownColor((KnownColor)Enum.Parse(typeof(KnownColor), _trendSetting.SeriesInteriorColor)), Color.Black });
                    }
                    catch
                    { }
                }
                
                seriesNew.PrepareStyle += new ChartPrepareStyleInfoHandler(ChartControlSeries_PrepareStyle);

                chartControlTrend.Model.Series.Add(seriesNew);
            }
        }

        #endregion
    }
}
