using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.Data;
using System.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using System.Collections.Specialized;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using System.IO;
using System.Text.RegularExpressions;
using Symcom.Evaluator;
using System.Xml;
using System.Xml.Serialization;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher;  
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.UserControls
{
	/// <summary>
	/// Summary description for UserControlUOMSetDefinition.
	/// </summary>
	public class UserControlUOMSetDefinition : System.Windows.Forms.UserControl,ILRRUIContainer
	{
		#region Fields
		private LRRApp								_app;
		private LRRMeasurementSystems				_lrrMeasurementSystemsObj=null;
		private LRRMeasurementSystemDefinitions		_lrrMeasurementSystemDefinitionsObj=null;
		private TabControl							_parentTabControl;
		private TabPage								_parentTabPage;
		public LRRMeasurementSystemDefinitions							_gridSystemDefsDataSource = new LRRMeasurementSystemDefinitions();
		private LRRProjectConfigurations _lrrProjectConfigurations=null;
		private bool addNewRecord=false;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridMeasurementSystems;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;

		#endregion
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridUOMSetDefinitions;
		private System.Windows.Forms.Panel panelUOMSD1;
		private System.Windows.Forms.Panel panelUOMSD3;
		private System.Windows.Forms.Panel panelUOMSD2;


		private System.ComponentModel.IContainer components;

		public UserControlUOMSetDefinition()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			_app = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			InitDataSource();
			
			//BindGridMeasurementSystems();
			//BindGridUOMSetDefinitions();
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panelUOMSD1 = new System.Windows.Forms.Panel();
			this.panelUOMSD3 = new System.Windows.Forms.Panel();
			this.gridMeasurementSystems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panelUOMSD2 = new System.Windows.Forms.Panel();
			this.gridUOMSetDefinitions = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.panelUOMSD1.SuspendLayout();
			this.panelUOMSD3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridMeasurementSystems)).BeginInit();
			this.panelUOMSD2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridUOMSetDefinitions)).BeginInit();
			this.SuspendLayout();
			// 
			// panelUOMSD1
			// 
			this.panelUOMSD1.Controls.Add(this.panelUOMSD3);
			this.panelUOMSD1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panelUOMSD1.Location = new System.Drawing.Point(0, 0);
			this.panelUOMSD1.Name = "panelUOMSD1";
			this.panelUOMSD1.Size = new System.Drawing.Size(776, 100);
			this.panelUOMSD1.TabIndex = 8;
			// 
			// panelUOMSD3
			// 
			this.panelUOMSD3.Controls.Add(this.gridMeasurementSystems);
			this.panelUOMSD3.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelUOMSD3.Location = new System.Drawing.Point(0, 0);
			this.panelUOMSD3.Name = "panelUOMSD3";
			this.panelUOMSD3.TabIndex = 0;
			// 
			// gridMeasurementSystems
			// 
			this.gridMeasurementSystems.BackColor = System.Drawing.SystemColors.Window;
			this.gridMeasurementSystems.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridMeasurementSystems.Location = new System.Drawing.Point(0, 0);
			this.gridMeasurementSystems.Name = "gridMeasurementSystems";
			this.gridMeasurementSystems.Size = new System.Drawing.Size(776, 293);
			this.gridMeasurementSystems.TabIndex = 1;
			this.gridMeasurementSystems.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Keyboard)));
			this.gridMeasurementSystems.Text = "gridGroupingControl1";
			this.gridMeasurementSystems.TopLevelGroupOptions.CaptionText = "UOM Set Selection: {RecordCount} Items";
			this.gridMeasurementSystems.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridMeasurementSystems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
			this.gridMeasurementSystems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridMeasurementSystems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridMeasurementSystems.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridMeasurementSystems.VersionInfo = "3.301.0.0";
			this.gridMeasurementSystems.RecordDeleting += new Syncfusion.Grouping.RecordEventHandler(this.gridMeasurementSystems_RecordDeleting);
			this.gridMeasurementSystems.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridMeasurementSystems_TableControlPrepareViewStyleInfo);
			this.gridMeasurementSystems.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(this.gridMeasurementSystems_CurrentRecordContextChange);
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(0, 100);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(776, 3);
			this.splitter2.TabIndex = 7;
			this.splitter2.TabStop = false;
			// 
			// panelUOMSD2
			// 
			this.panelUOMSD2.Controls.Add(this.gridUOMSetDefinitions);
			this.panelUOMSD2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panelUOMSD2.Location = new System.Drawing.Point(0, 103);
			this.panelUOMSD2.Name = "panelUOMSD2";
			this.panelUOMSD2.Size = new System.Drawing.Size(776, 489);
			this.panelUOMSD2.TabIndex = 0;
			// 
			// gridUOMSetDefinitions
			// 
			this.gridUOMSetDefinitions.BackColor = System.Drawing.SystemColors.Window;
			this.gridUOMSetDefinitions.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridUOMSetDefinitions.Location = new System.Drawing.Point(0, 0);
			this.gridUOMSetDefinitions.Name = "gridUOMSetDefinitions";
			this.gridUOMSetDefinitions.Size = new System.Drawing.Size(776, 296);
			this.gridUOMSetDefinitions.TabIndex = 3;
			this.gridUOMSetDefinitions.Text = "gridGroupingControl1";
			this.gridUOMSetDefinitions.ThemesEnabled = false;
			this.gridUOMSetDefinitions.TopLevelGroupOptions.CaptionText = "UOM Types: {RecordCount} Items";
			this.gridUOMSetDefinitions.TopLevelGroupOptions.IsExpandedInitialValue = true;
			this.gridUOMSetDefinitions.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
			this.gridUOMSetDefinitions.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
			this.gridUOMSetDefinitions.TopLevelGroupOptions.ShowColumnHeaders = true;
			this.gridUOMSetDefinitions.VersionInfo = "3.301.0.0";
			this.gridUOMSetDefinitions.TableControlPrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventHandler(this.gridUOMSetDefinitions_TableControlPrepareViewStyleInfo);
			this.gridUOMSetDefinitions.TableControlCurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventHandler(this.gridUOMSetDefinitions_TableControlCurrentCellShowingDropDown);
			// 
			// UserControlUOMSetDefinition
			// 
			this.Controls.Add(this.panelUOMSD2);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.panelUOMSD1);
			this.Name = "UserControlUOMSetDefinition";
			this.Size = new System.Drawing.Size(776, 592);
			this.Tag = "SID_UOMSETDEFN";
			this.Load += new System.EventHandler(this.UserControlUOMSetDefinition_Load);
			this.panelUOMSD1.ResumeLayout(false);
			this.panelUOMSD3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridMeasurementSystems)).EndInit();
			this.panelUOMSD2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridUOMSetDefinitions)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		# region InitDataSource
		private void InitDataSource()
		{
			if(_lrrMeasurementSystemsObj != null)
				_lrrMeasurementSystemsObj.ItemAdded -=new EventHandler(_lrrMeasurementSystemsObj_ItemAdded); 

			_lrrMeasurementSystemsObj = new LRRMeasurementSystems();
			//_lrrMeasurementSystemsObj.ItemAdded +=new EventHandler(_lrrMeasurementSystemsObj_ItemAdded); 

			_app.DBManagerObj.PopulateCollection(_lrrMeasurementSystemsObj);
			_lrrMeasurementSystemDefinitionsObj = new LRRMeasurementSystemDefinitions();
			_app.DBManagerObj.PopulateCollection(_lrrMeasurementSystemDefinitionsObj);
			_lrrMeasurementSystemsObj.UIUomChanged+=new EventHandler(_lrrMeasurementSystemsObj_UIUomChanged);
			_lrrProjectConfigurations=new LRRProjectConfigurations();
			_app.DBManagerObj.PopulateCollection(_lrrProjectConfigurations,false);
			_lrrMeasurementSystemsObj.ItemAdded+=new EventHandler(_lrrMeasurementSystemsObj_ItemAdded);
		}
		#endregion

		#region BindGridMeasurementSystems

		private void BindGridMeasurementSystems()
		{

			gridMeasurementSystems.DataSource = _lrrMeasurementSystemsObj;
			gridMeasurementSystems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_UOM_SET_SELECTION") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");     
		
			
		}

		private void BindGridMeasurementSystemDefinitions()
		{

			gridUOMSetDefinitions.DataSource = null;
			gridUOMSetDefinitions.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_UOM_TYPES") + "{RecordCount}" + LRRHeaderText.GetHeaderString("SID_ITEMS");     
		
			
		}
		#endregion

		#region BindGridUOMSetDefinitions

		private void BindGridUOMSetDefinitions()
		{
			
		}
		#endregion

		#region ILRRUIContainer Members

		public new void Refresh()
		{
			InitDataSource();
			BindGridMeasurementSystems();
			BindGridMeasurementSystemDefinitions();
//			if(gridMeasurementSystems.CurrencyManager.Position!= -1)
//				SetGridColumns();
		}

		public void Save()
		{
			gridMeasurementSystems.TableControl.CurrentCell.ConfirmChanges();
			gridUOMSetDefinitions.TableControl.CurrentCell.ConfirmChanges();
			bool IsUIUOM=false;
			if(gridMeasurementSystems.CurrencyManager.Position!= -1)
			{
				foreach (LRRMeasurementSystem  lrrMeasurementSystem in _lrrMeasurementSystemsObj)
				{
					if(lrrMeasurementSystem.UIUOM==true)
					{
						IsUIUOM=true;
                        if (lrrMeasurementSystem.ObjectState == DBOperation.UPDATE)
                        {
                            MessagingClient.RaiseAlert("UIUOM Set Changed");
                        }
						break;
					}     
				}
				if(IsUIUOM==false)
				{
					LRRMessagBox.ShowMessage("SID_SAVEABORT_UIUOM_NULL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);  
					return;
				}
				bool isSaved = false;
				if(_lrrMeasurementSystemsObj.GetChanges().Count > 0)
				{
					foreach(LRRMeasurementSystem objMS in _lrrMeasurementSystemsObj )
					{
						if(objMS.UIUOM.ToString(Symcon.BusinessObjects.SymConverter.Culture).ToUpper() == "TRUE")
						{
							if(_lrrProjectConfigurations.Count >0)
							{
								_lrrProjectConfigurations[0].MeasurementSystemUserInterfaceID = objMS.ID;
								//Update in Model
								LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID = objMS.ID;
							}
						}
					}
					_app.DBManagerObj.CommitCollection(_lrrMeasurementSystemsObj.GetChanges());
					_lrrMeasurementSystemsObj.RefreshCollection();
					isSaved = true;
				}
				if(_lrrMeasurementSystemDefinitionsObj.GetChanges().Count > 0)
				{
					//LRRMessagBox.ShowMessage("SID_CHANGES_UOMTYPES","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);  
					_app.DBManagerObj.CommitCollection(_lrrMeasurementSystemDefinitionsObj.GetChanges());
					_lrrMeasurementSystemDefinitionsObj.RefreshCollection();
					isSaved = true;
				}
				LRRProjectConfigurations objToSaveProjConfig = _lrrProjectConfigurations.GetChanges();
				if(objToSaveProjConfig.Count > 0)
				{
					_app.DBManagerObj.CommitCollection(objToSaveProjConfig);
					_lrrProjectConfigurations.RefreshCollection();
					isSaved = true;
				}

				if(isSaved)
				{
					OptionsUserControl.saved	=true;
					InitDataSource();
					BindGridMeasurementSystems();
					BindGridMeasurementSystemDefinitions();
				}
			}
		}

		public void CopyMasterProperties()
		{
		
		}

		public void Paste()
		{
			// TODO:  Add ComplexEquip.Paste implementation
		}

		public void Copy()
		{
			// TODO:  Add ComplexEquip.Copy implementation
		}

		public void Print()
		{
			// TODO:  Add ComplexEquip.Print implementation
			if(gridMeasurementSystems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridMeasurementSystems,false);
			}
			if(gridUOMSetDefinitions.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOMSetDefinitions,false);
			}
		}

		public void Delete()
		{
			// TODO:  Add ComplexEquip.Delete implementation
		}

		public void ArrangeColumns()
		{
			// TODO:  Add ComplexEquip.ArrangeColumns implementation
		}

		public void ClearFilter()
		{
			
		}
		public void ImportToExcel()
		{
		}
		public bool SupportsSelectionPaste()
		{
			return false;
		}

		public void SelectionPaste()
		{
		}

		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}

		public bool SupportsCopy()
		{
			// TODO:  Add ComplexEquip.SupportsCopy implementation
			return false;
		}

		public bool SupportsPaste()
		{
			// TODO:  Add ComplexEquip.SupportsPaste implementation
			return true;
		}

		public bool SupportsExport()
		{
			// TODO:  Add ComplexEquip.SupportsExport implementation
			return true;
		}

		public bool SupportsSave()
		{
			// TODO:  Add ComplexEquip.SupportsSave implementation
			return true;
		}

		public bool SupportsRefresh()
		{
			// TODO:  Add ComplexEquip.SupportsRefresh implementation
			return true;
		}

		public bool SupportsDelete()
		{
			// TODO:  Add ComplexEquip.SupportsDelete implementation
			return false;
		}

		public bool SupportsPrint()
		{
			// TODO:  Add ComplexEquip.SupportsPrint implementation
			return true;
		}

		public bool SupportsArrangeColumns()
		{
			// TODO:  Add ComplexEquip.SupportsArrangeColumns implementation
			return false;
		}

		public bool SupportsClearFilter()
		{
			// TODO:  Add ComplexEquip.SupportsClearFilter implementation
			return true;
		}
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			// TODO:  Add MasterProperties.SupportsClearFilter implementation
			return true;
		}

		public bool SupportsImportToExcel()
		{
			return true;
		}

		public bool SupportsLevel()
		{
			return false;
		}

		public void InsertNewRows()
		{
			
		}

		public void Export()
		{
			
		}

	
		public TabControl	ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		private void gridMeasurementSystems_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
			if((e.Record != null)&&(e.Action == CurrentRecordAction.EnterRecordComplete))
			{
				LRRMeasurementSystem lrrMS =  (LRRMeasurementSystem)e.Record.GetData();
				if(lrrMS != null)
				{
					_gridSystemDefsDataSource = GetDataSourceForMSID(lrrMS.ID);
					//gridUOMSetDefinitions.DataSource = _gridSystemDefsDataSource;
					SetGridColumns();

					//addNewRecord=false;
					if(lrrMS.ModelUOM==true)
						gridUOMSetDefinitions.TableDescriptor.AllowEdit=false;
					else
						gridUOMSetDefinitions.TableDescriptor.AllowEdit=true;
				}
			}
			if((e.Action == CurrentRecordAction.EndEditCalled)&& e.Record.Kind.ToString(Symcon.BusinessObjects.SymConverter.Culture)=="AddNewRecord")
			{	
				_gridSystemDefsDataSource = GetDataSourceForMSID(null);
				LRRMeasurementSystemDefinitions lrrMSDefn=new LRRMeasurementSystemDefinitions();
				LRRMeasurementSystem ms = e.Record.GetData() as LRRMeasurementSystem;
				if(ms != null)
				{
					foreach(LRRUOMType uomType in LRRModel.ChildModel.UomTypes)
					{
						LRRMeasurementSystemDefinition lrrMSD = new LRRMeasurementSystemDefinition();
						lrrMSD.MSID = ms.ID;
						lrrMSD.UOMTypeID = uomType.UOMTypeID;
						lrrMSDefn.Add(lrrMSD);
						_lrrMeasurementSystemDefinitionsObj.Add(lrrMSD);
					}
					//_lrrMeasurementSystemDefinitionsObj = lrrMSDefn;
					_gridSystemDefsDataSource=lrrMSDefn;
					//gridUOMSetDefinitions.DataSource = _gridSystemDefsDataSource;
					SetGridColumns();
					//addNewRecord=true;
				}
			}
			if(e.Table.CurrentRecord != null)
			{
				if((e.Table.CurrentRecord.GetType() == typeof(GridAddNewRecord)) && e.Action==CurrentRecordAction.NavigateComplete)
				{
					//addNewRecord=true;
					_gridSystemDefsDataSource = new LRRMeasurementSystemDefinitions();
					SetGridColumns();
				}
			}
		}

		private void SetGridColumns()
		{
			int typeWidth = 0;
			int uomWidth = 0;

			Hashtable columnForDisplay=new Hashtable();
			//Suspend the Layout of the Grid...
			gridUOMSetDefinitions.SuspendLayout();
			SyncGridUtilities.InitializeGridLookAndFeel(gridUOMSetDefinitions);
			columnForDisplay.Add("UOMTypeID",null);
			columnForDisplay.Add("UOMID",null);

			Dictionary<string, SymForeignKeyFieldAttribute> fkColumns;
			Dictionary<string, SymChildDataAttribute> childColumns;
			Symcon.LightRidge.BusinessObjects.Utilities.LRRBusinessObjectUtilities.GetObjectInfo(_gridSystemDefsDataSource.ItemType,out fkColumns,out childColumns);
			Hashtable fkData = new Hashtable();
			foreach(object obj in fkColumns.Keys)
			{
				string propName = (string)obj;
                SymForeignKeyFieldAttribute fkAttr = fkColumns[propName] as SymForeignKeyFieldAttribute;
				object collectionObject = Activator.CreateInstance(fkAttr.CollectionType);
				_app.DBManagerObj.PopulateCollection(collectionObject,false);
				fkData.Add(propName,collectionObject);
			}

			if(gridUOMSetDefinitions.TableDescriptor.Columns.Count == 2)
			{
				typeWidth = gridUOMSetDefinitions.TableDescriptor.Columns[0].Width;
				uomWidth = gridUOMSetDefinitions.TableDescriptor.Columns[1].Width;
			}

			SyncGridUtilities.InitializeGridColumns(gridUOMSetDefinitions,_gridSystemDefsDataSource.ItemType,null,false,columnForDisplay,fkData);
			//SyncGridUtilities.InitializeGridColumns(gridUOMSetDefinitions,gridUOMSetDefinitions.TableDescriptor,LRRModel.ChildModel.UOMs.ItemType,null);

			gridUOMSetDefinitions.Engine.SourceListSet.Add(_gridSystemDefsDataSource);
			//Set the data store 
			gridUOMSetDefinitions.DataSource = _gridSystemDefsDataSource;

			
				
//			gridUOMSetDefinitions.TableDescriptor.Columns.Clear();
//			gridUOMSetDefinitions.TableDescriptor.Columns.Add("UOM Type","UOMTypeID");
//			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.CellType = "GridListControl";
//			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.DataSource = LRRModel.ChildModel.UomTypes;
//			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.DisplayMember = "Name";
//			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ValueMember = "UOMTypeID";
			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;
            gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
//			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ReadOnly = true;
//			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.Clickable = false;
//			gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;

			//gridUOMSetDefinitions.TableDescriptor.Columns[0].Appearance.AnyRecordFieldCell.CellIdentity.
			if(typeWidth > 0)
			{
				gridUOMSetDefinitions.TableDescriptor.Columns[0].Width = typeWidth;
			}
			else
			{
				gridUOMSetDefinitions.TableDescriptor.Columns[0].Width = gridUOMSetDefinitions.Width/2 - SystemInformation.VerticalScrollBarWidth;
			}


//			gridUOMSetDefinitions.TableDescriptor.Columns.Add("Uom" ,"UOMID");
//			gridUOMSetDefinitions.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
//			gridUOMSetDefinitions.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.DataSource = LRRModel.ChildModel.UomTypes;
//			gridUOMSetDefinitions.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = true;
//			gridUOMSetDefinitions.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.DropDownStyle = GridDropDownStyle.Exclusive;
//
//			gridUOMSetDefinitions.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.DisplayMember = "Name";
//			gridUOMSetDefinitions.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ValueMember = "UOMTypeID";
			if(uomWidth > 0)
			{
				gridUOMSetDefinitions.TableDescriptor.Columns[1].Width = uomWidth;
			}
			else
			{
				gridUOMSetDefinitions.TableDescriptor.Columns[1].Width = gridUOMSetDefinitions.Width/2 - SystemInformation.VerticalScrollBarWidth;
			}

			gridUOMSetDefinitions.TableDescriptor.Columns["UOMID"].AllowFilter	= false;
			gridUOMSetDefinitions.TopLevelGroupOptions.ShowFilterBar	= true;
			gridUOMSetDefinitions.ResumeLayout();
                  
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
		{
			if(keyData == Keys.Delete)
			{
				_isDeletePress = true;
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}



		private bool _isDeletePress = false;
		private bool _isRecordeDel = false;
		private void gridMeasurementSystems_RecordDeleting(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if((e.Record != null))
			{
				string currentMSID = "";
				LRRMeasurementSystem lrrMS =  (LRRMeasurementSystem)e.Record.GetData();
				currentMSID = lrrMS.ID;
				if((lrrMS.UIUOM) || (lrrMS.ModelUOM))
				{
					LRRMessagBox.ShowMessage("SID_REF_DEL","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);    					e.Cancel = true;
					e.Cancel = true;
					return;
				}
				if((lrrMS.Base==true))
				{
					e.Cancel = true;
					return;
				}
				else 
				{
					if(_isDeletePress)
					{
						DialogResult _dlgResult = LRRMessagBox.ShowMessage("SID_DELETE_RECORD","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);     
						if(_dlgResult == DialogResult.Yes)
						{
							_isRecordeDel = true; 
						}
						else
						{
							_isRecordeDel = false; 
						}
						_isDeletePress = false;
					}
					if(_isRecordeDel)
					{
						if((e.Record != null))
						{
							string _currentMSID = "";
							LRRMeasurementSystem _lrrMS =  (LRRMeasurementSystem)e.Record.GetData();
							_currentMSID = _lrrMS.ID;
							for(int i=_lrrMeasurementSystemDefinitionsObj.Count - 1;i>=0;i--)
							{
								LRRMeasurementSystemDefinition _lrrMSD = _lrrMeasurementSystemDefinitionsObj[i];
								if(_lrrMSD.MSID == _currentMSID)
								{
									_lrrMeasurementSystemDefinitionsObj.RemoveAt(i);
								}
							}
						}

					}
					else
					{
						e.Cancel = true;
						return;
					}
				}
			}
		}
		private void gridMeasurementSystems_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			
			//Row and COlumn index check
//			if(e.Inner.RowIndex <=3 || e.Inner.ColIndex <= 0)
//			{
//				return;
//			}

			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Inner.Style;
			//Do not Process the Non Record Cell Types
//			if(style.TableCellIdentity.TableCellType != Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellType.AnyRecordFieldCell)
//			{
//				return;
//			}
//			if(style.TableCellIdentity.Table.TableModel.GetColumnDescriptorAt(e.Inner.RowIndex,e.Inner.ColIndex).HeaderText == "UI UOM")
//			{
//				return;
//			}

			

			LRRMeasurementSystem ms = null;
			try
			{
				if(style.TableCellIdentity.DisplayElement.ParentRecord!=null)
				{
					ms = (LRRMeasurementSystem)style.TableCellIdentity.DisplayElement.ParentRecord.GetData();
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UserControlUOMSetDefinition),"gridMeasurementSystems_TableControlPrepareViewStyleInfo1 Event:"+ex.Message  ,Logger.Level.Debug);
				return;
			}
			if(ms!= null)
			{
				if(ms.Base)
				{
					try
					{
						int colindex = this.gridMeasurementSystems.TableModel.NameToColIndex("UIUOM");
						if(!(colindex == e.Inner.ColIndex))// && e.Inner.RowIndex == rowindex)
						{
							e.Inner.Style.ReadOnly = true;
							e.Inner.Style.BackColor = Color.LightGray;
//							gridUOMSetDefinitions.TableDescriptor.AllowEdit=false;
//							gridUOMSetDefinitions.TableDescriptor.Columns[gridUOMSetDefinitions.TableDescriptor.Columns.IndexOf("UOMID")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList=false;
						}

					}
					catch(Exception ex)
					{
						Logger.LogMessage(typeof(UserControlUOMSetDefinition),"gridMeasurementSystems_TableControlPrepareViewStyleInfo2 Event:"+ex.Message  ,Logger.Level.Debug);
						return;
					}
				}
				else
				{
					gridUOMSetDefinitions.TableDescriptor.AllowEdit=true;
					gridUOMSetDefinitions.TableDescriptor.Columns[gridUOMSetDefinitions.TableDescriptor.Columns.IndexOf("UOMTypeID_Name")].Appearance.AnyRecordFieldCell.Clickable = false;
					gridUOMSetDefinitions.TableDescriptor.Columns[gridUOMSetDefinitions.TableDescriptor.Columns.IndexOf("UOMID")].Appearance.AnyRecordFieldCell.ExclusiveChoiceList=true;
				}
			}
		}

		private void gridUOMSetDefinitions_TableControlCurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellShowingDropDownEventArgs e)
		{
			GridCurrentCell oCurrCell = e.TableControl.CurrentCell as GridCurrentCell;
			GridCellModelBase oCurrCellModel = oCurrCell.Model as GridCellModelBase;
			GridTableCellStyleInfoIdentity tableCellInfo = e.TableControl.Model[oCurrCell.RowIndex, oCurrCell.ColIndex].CellIdentity as GridTableCellStyleInfoIdentity;
			if(tableCellInfo.TableCellType == GridTableCellType.FilterBarCell)
			{
				return;
			}

			string sUOMType = "";
			try
			{
				sUOMType = ((LRRMeasurementSystemDefinition)e.TableControl.Table.CurrentRecord.GetData()).UOMTypeID; 
				if(tableCellInfo.Column.MappingName == "UOMTypeID")
					return;

			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UserControlUOMSetDefinition),"gridUOMSetDefinitions_TableControlCurrentCellShowingDropDown Event :"+ex.Message  ,Logger.Level.Debug);
			}
			
			if(sUOMType != "" && sUOMType != null)
			{
				LRRUOMs uoms = LRRModel.ChildModel.GetUOMsFromUOMTypeID(sUOMType);
				GridComboBoxCellRenderer cr  = e.TableControl.CurrentCell.Renderer as GridComboBoxCellRenderer;
                if (cr != null)
                {
                    uoms.SortColumn = "Name";
                    uoms.Sort();
                    cr.ListBoxPart.DataSource = uoms;
                    cr.Model.SupportsChoiceList = false;

                    if (uoms.Count == 0)
                    {
                        e.TableControl.CurrentCell.ConfirmChanges();
                        LRRMessagBox.ShowMessage("SID_NO_UOM", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);

                    }
                }
			}
			
			
		}

		private void UserControlUOMSetDefinition_Load(object sender, System.EventArgs e)
		{
			BindGridMeasurementSystems();
			BindGridMeasurementSystemDefinitions();
			SyncGridUtilities.InitializeGridColumns(gridMeasurementSystems,gridMeasurementSystems.TableDescriptor,_lrrMeasurementSystemsObj.ItemType,null,true,null,null,true);
			SyncGridUtilities.InitializeGridLookAndFeel(gridMeasurementSystems);
			SetGridColumns();
		}

		private void _lrrMeasurementSystemsObj_UIUomChanged(object sender, EventArgs e)
		{
			gridMeasurementSystems.Refresh();
		}


		/// <summary>
		/// Item Added to the Measurement Systems Object ..
		/// Here the Child Items needs to be Created for the Measurement Systems Definitions...
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void _lrrMeasurementSystemsObj_ItemAdded(object sender, EventArgs e)
		{
//			LRRMeasurementSystem ms = sender as LRRMeasurementSystem;
//			if(ms != null)
//			{
//				foreach(LRRUOMType uomType in LRRModel.ChildModel.UomTypes)
//				{
//					LRRMeasurementSystemDefinition lrrMSD = new LRRMeasurementSystemDefinition();
//					lrrMSD.MSID = ms.ID;
//					lrrMSD.UOMTypeID = uomType.UOMTypeID;
//					_lrrMeasurementSystemDefinitionsObj.Add(lrrMSD);
//				}
//			}

		}
		private void gridUOMSetDefinitions_TableControlPrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Inner.Style;
			LRRMeasurementSystemDefinition msd = null;
			try
			{
				if(style.TableCellIdentity.DisplayElement.ParentRecord!=null)
				{
					msd = (LRRMeasurementSystemDefinition)style.TableCellIdentity.DisplayElement.ParentRecord.GetData();
				}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(UserControlUOMSetDefinition),"gridUOMSetDefinitions_TableControlPrepareViewStyleInfo Event:"+ex.Message  ,Logger.Level.Debug);
				return;
			}
			if(msd!= null)
			{
				if(msd.Base)
				{
					try
					{
						e.Inner.Style.ReadOnly = true;
					}

					catch(Exception ex)
					{
						Logger.LogMessage(typeof(UserControlUOMSetDefinition),"gridMeasurementSystems_TableControlPrepareViewStyleInfo2 Event:"+ex.Message  ,Logger.Level.Debug);
						return;
					}
				}
				else
				{
					string j=msd.UOMTypeID;
				}
	
			}
		}

		private LRRMeasurementSystemDefinitions GetDataSourceForMSID(string msID)
		{
			LRRMeasurementSystemDefinitions ret = new LRRMeasurementSystemDefinitions();
			IEnumerator ieNum = _lrrMeasurementSystemDefinitionsObj.GetEnumerator();
			while(ieNum.MoveNext())
			{
				try
				{
					LRRMeasurementSystemDefinition lrrMSD = (LRRMeasurementSystemDefinition)ieNum.Current;
					if(lrrMSD != null)
					{
						if(lrrMSD.MSID == msID)
							ret.Add(lrrMSD);
					}
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(UserControlUOMSetDefinition),"gridUOMTye_CurrentRecordContextChange Event :"+ex.Message  ,Logger.Level.Debug);
				}
			}
			return ret;
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			SyncGridUtilities.ClearSort(gridMeasurementSystems);
			SyncGridUtilities.ClearSort(gridUOMSetDefinitions);
		}

		public bool SupportsClearSort()
		{
			// TODO:  Add UserControlDataBaseConnectionInfos.SupportsClearSort implementation
			return true;
		}

		#endregion
		
		#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
			//if(addNewRecord==true)
			//{
				LRRMeasurementSystem	objLRRMS = gridMeasurementSystems.CurrencyManager.Current as LRRMeasurementSystem;
			if(objLRRMS.Base == true)
			{
				LRRMessagBox.ShowMessage("SID_CANT_EDIT_SYSTYPE","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Warning);
				return;
			}
				
			CopyUOMTypes objCopyUOMTypes = new CopyUOMTypes();
			objCopyUOMTypes.ShowDialog();
			if(objCopyUOMTypes.DialogResult==DialogResult.OK)
			{
				LRRMeasurementSystemDefinitions defs = objCopyUOMTypes.CopyMSDefinitions();
				LRRMeasurementSystemDefinitions sourceObjs = _lrrMeasurementSystemDefinitionsObj.GetUOMTypesForMSID(objLRRMS.ID);
				if(defs!=null)
				{
					IEnumerator	iEnumerator= defs.GetEnumerator();
				
					while(iEnumerator.MoveNext())
					{
						LRRMeasurementSystemDefinition lrrMSD = (LRRMeasurementSystemDefinition)iEnumerator.Current;
						if(lrrMSD != null)
						{
							IEnumerator ienum1 = sourceObjs.GetEnumerator();
							while(ienum1.MoveNext())
							{
								LRRMeasurementSystemDefinition lrrMSDSrc = (LRRMeasurementSystemDefinition)ienum1.Current;
								if(lrrMSDSrc.UOMTypeID == lrrMSD.UOMTypeID)
								{
									lrrMSDSrc.UOMID = lrrMSD.UOMID;
								}
							}
						}
					} 
				}
				_gridSystemDefsDataSource = sourceObjs;
				SetGridColumns();
//				gridUOMSetDefinitions.DataSource= _gridSystemDefsDataSource;
			}
			else
			{
			}
		}

		public bool SupportsCopyUOMTypes()
		{
			return true;
		}

		#endregion

		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			// TODO:  Add UserControlUOMSetDefinition.PrintPreview implementation
			if(gridMeasurementSystems.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridMeasurementSystems,true);
			}
			if(gridUOMSetDefinitions.TableControl.CurrentCell.IsActive)
			{
				GridGroupingPrint ggPrint = new GridGroupingPrint();
				ggPrint.PrintData(gridUOMSetDefinitions,true);
			}
		}

		#endregion

		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			// TODO:  Add UserControlUOMSetDefinition.ShowPropertyList implementation
		}

		public void ShowComponentList()
		{
			// TODO:  Add UserControlUOMSetDefinition.ShowComponentList implementation
		}

		public bool SupportsResultsFilter()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsResultsFilter implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			// TODO:  Add UserControlUOMSetDefinition.LeftColMovement implementation
		}

		public void RightColMovement()
		{
			// TODO:  Add UserControlUOMSetDefinition.RightColMovement implementation
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridGroupingPrint ggPrint = new GridGroupingPrint();
			ggPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add UserControlUOMSetDefinition.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsPageSetup implementation
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add UserControlUOMSetDefinition.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add UserControlUOMSetDefinition.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add UserControlUOMSetDefinition.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add UserControlUOMSetDefinition.OpenView implementation
		}

		public bool SupportsOpenCompositeView()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsOpenCompositeView implementation
			return false;
		}

		public bool SupportsTransposeView()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsTransposeView implementation
			return false;
		}

		public bool SupportsOpenQuery()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsOpenQuery implementation
			return false;
		}

		public bool SupportsOpenView()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsOpenView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool SupportsCompositeView()
		{
			// TODO:  Add UserControlUOMSetDefinition.SupportsCompositeView implementation
			return false;
		}

		#endregion


		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add UserControlUOMSetDefinition.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion
	}
}
