using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Symcon.BusinessObjects;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.HistorianConnect;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.Utils.HeaderDispatcher;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for ViewHistoryManualHistPoints.
	/// </summary>
	public class ViewHistoryManualHistPoints : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel pnlGrid;
		private System.Windows.Forms.Panel pnlBottom;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridViewHistory;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ViewHistoryManualHistPoints()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public ViewHistoryManualHistPoints(LRRManualEntryHistorianDataSetData histDataPoint)
		{
			InitializeComponent();
			InternationalizationUtils.GetControlText(this,null); 
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp; //Get the App Object..
			InitDataSource(histDataPoint.HistTag);
			BindGrid();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ViewHistoryManualHistPoints));
			this.pnlGrid = new System.Windows.Forms.Panel();
			this.gridViewHistory = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.pnlBottom = new System.Windows.Forms.Panel();
			this.btnCancel = new System.Windows.Forms.Button();
			this.btnOK = new System.Windows.Forms.Button();
			this.pnlGrid.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gridViewHistory)).BeginInit();
			this.pnlBottom.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlGrid
			// 
			this.pnlGrid.Controls.Add(this.gridViewHistory);
			this.pnlGrid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlGrid.Location = new System.Drawing.Point(0, 0);
			this.pnlGrid.Name = "pnlGrid";
			this.pnlGrid.Size = new System.Drawing.Size(470, 164);
			this.pnlGrid.TabIndex = 0;
			// 
			// gridViewHistory
			// 
			this.gridViewHistory.BackColor = System.Drawing.SystemColors.Window;
			this.gridViewHistory.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridViewHistory.Location = new System.Drawing.Point(0, 0);
			this.gridViewHistory.Name = "gridViewHistory";
			this.gridViewHistory.Size = new System.Drawing.Size(470, 164);
			this.gridViewHistory.TabIndex = 1;
			this.gridViewHistory.Text = "gridGroupingControl1";
			this.gridViewHistory.VersionInfo = "3.301.0.0";
			// 
			// pnlBottom
			// 
			this.pnlBottom.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlBottom.Controls.Add(this.btnCancel);
			this.pnlBottom.Controls.Add(this.btnOK);
			this.pnlBottom.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlBottom.Location = new System.Drawing.Point(0, 124);
			this.pnlBottom.Name = "pnlBottom";
			this.pnlBottom.Size = new System.Drawing.Size(470, 40);
			this.pnlBottom.TabIndex = 1;
			// 
			// btnCancel
			// 
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(384, 8);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(80, 24);
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Tag = "SID_CANCEL";
			// 
			// btnOK
			// 
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(296, 8);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(80, 24);
			this.btnOK.TabIndex = 0;
			this.btnOK.Tag = "SID_OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// ViewHistoryManualHistPoints
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(470, 164);
			this.Controls.Add(this.pnlBottom);
			this.Controls.Add(this.pnlGrid);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ViewHistoryManualHistPoints";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Tag = "SID_VIEW_HISTORY";
			this.pnlGrid.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gridViewHistory)).EndInit();
			this.pnlBottom.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region Methods
		private void BindGrid()
		{
			//Suspend the Layout of the Grid...
			this.gridViewHistory.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridViewHistory);

			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridViewHistory,_lrrManualEntryHistDataSetDatas.ItemType,null,true,null);
			
			this.gridViewHistory.Appearance.AnyHeaderCell.Font.Bold = true;
			this.gridViewHistory.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridViewHistory.BackColor = System.Drawing.SystemColors.Window;
			this.gridViewHistory.TableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			this.gridViewHistory.TableDescriptor.Appearance.AnyHeaderCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.ControlLight);
			this.gridViewHistory.TableDescriptor.Appearance.GroupCaptionCell.Font.Bold = true;
			this.gridViewHistory.TableDescriptor.Appearance.GroupCaptionCell.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.PatternStyle.None, System.Drawing.SystemColors.WindowText, System.Drawing.Color.RoyalBlue);
			this.gridViewHistory.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_HIST_POINTS") +":{RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			this.gridViewHistory.TableDescriptor.Appearance.GroupCaptionCell.TextColor = System.Drawing.Color.White;

			this.gridViewHistory.TableDescriptor.AllowNew = false;
			this.gridViewHistory.TableDescriptor.AllowEdit = true;
			this.gridViewHistory.TableDescriptor.AllowRemove = true;

			this.gridViewHistory.SourceListSet.Add("Parent",_lrrManualEntryHistDataSetDatas);

			this.gridViewHistory.TableDescriptor.Relations.Clear();
			this.gridViewHistory.DataSource = null;
			this.gridViewHistory.DataSource = _lrrManualEntryHistDataSetDatas;

			GridTableCellStyleInfo gtc = this.gridViewHistory.TableDescriptor.Columns["HistTag"].Appearance.AnyRecordFieldCell;
			gtc.ReadOnly = true;
			
			this.gridViewHistory.TableDescriptor.Columns.Remove("PlantUnit_Name");

			GridTableCellStyleInfo gtc1 = this.gridViewHistory.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_UOM")].Appearance.AnyRecordFieldCell;
			gtc1.ShowButtons = Syncfusion.Windows.Forms.Grid.GridShowButtons.Hide;
			gtc1.ExclusiveChoiceList = false;
			gtc1.ReadOnly = true;
			
			this.gridViewHistory.TableDescriptor.Columns.Add(LRRHeaderText.GetHeaderString("SID_TIME"));
			GridTableCellStyleInfo gtc2 = this.gridViewHistory.TableDescriptor.Columns[LRRHeaderText.GetHeaderString("SID_TIME")].Appearance.AnyRecordFieldCell;
			gtc2.ReadOnly = true;
		
			this.gridViewHistory.ResumeLayout(true);
		}

		private void InitDataSource(string histTag)
		{
			if(_lrrManualEntryHistDataSetDatas != null)
				_lrrManualEntryHistDataSetDatas.Clear();
			_lrrManualEntryHistDataSetDatas = new LRRManualEntryHistorianDataSetDatas();

			LRRManualEntryHistorianDataBase manualEntryHistDB = _lrrApp.GetOptions().ManualEntryHistorianDataBaseObj;
			if(manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_TUNING"))
			{
                if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.TUNNING))
                {
                    TuningHistorian tuningHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.TUNNING] as TuningHistorian;
                    _lrrManualEntryHistDataSetDatas = tuningHist.GetManualEntryHistDataSetDatasByHistTag(histTag);
                }
			}
			if(manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_OFFLINE"))
			{
                if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.OFFLINE))
                {
                    OffLineHistorian offlineHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.OFFLINE] as OffLineHistorian;
                    _lrrManualEntryHistDataSetDatas = offlineHist.GetManualEntryHistDataSetDatasByHistTag(histTag);
                }
			}
		}
		#endregion

		#region Fields
		private LRRApp _lrrApp;
		private LRRManualEntryHistorianDataSetDatas _lrrManualEntryHistDataSetDatas;
		#endregion
		
		#region Event Handlers
		private void btnOK_Click(object sender, System.EventArgs e)
		{
			LRRManualEntryHistorianDataSetDatas histDataSetDatas = _lrrManualEntryHistDataSetDatas.GetChanges();
			if(histDataSetDatas.Count > 0)
			{
				LRRManualEntryHistorianDataBase manualEntryHistDB = _lrrApp.GetOptions().ManualEntryHistorianDataBaseObj;
				if(manualEntryHistDB != null && manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_TUNING"))
				{
                    if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.TUNNING))
                    {
                        TuningHistorian tuningHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.TUNNING] as TuningHistorian;
                        tuningHist.CommitCollection(histDataSetDatas);
                    }
				}
				else if(manualEntryHistDB != null && manualEntryHistDB.Type == LRRHeaderText.GetHeaderString("SID_OFFLINE"))
				{
                    if (_lrrApp.LoadedOffLineHistorianAssemblies.ContainsKey(_lrrApp.OFFLINE))
                    {
                        OffLineHistorian offlineHist = _lrrApp.LoadedOffLineHistorianAssemblies[_lrrApp.OFFLINE] as OffLineHistorian;
                        offlineHist.CommitCollection(histDataSetDatas);
                    }
				}
				else
				{
					LRRMessagBox.ShowMessage("SID_MANUAL_HISTDB_CONFIG","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);
					//MessageBox.Show("Please configure the Database in the Options");
				}
			}
		}
		#endregion
	}
}
