// Type: Symcon.CCLibrary.Controls.StatusBar
// Assembly: Symcon.CCLib, Version=1.0.3743.23230, Culture=neutral
// Assembly location: E:\WorkArea\Lightridge\DesktopApplication\ExternalLib\Symcon.CCLib.dll

using Symcon.CCLibrary.Common;
using Symcon.LightRidge.DataQualityConfiguration;
using System;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;

namespace Symcon.CCLibrary.Controls
{
    [ToolboxBitmap(typeof (Bitmap), "Symcon.CCLibrary.Controls.StatusBar.bmp")]
    public class StatusBar : System.Windows.Forms.StatusBar
    {
        protected Color _activityDownColor;
        protected Color _activityInProgressColor;
        protected Color _activityUpColor;
        protected string _applicationMsgText;
        protected Color _applicationMsgTextColor;
        protected Font _applicationMsgTextFont;
        protected Color _backColor;
        protected string _dateFormat;
        protected string _dbName;
        protected string _dbPath;
        protected string _dbType;
        protected Color _linkDownColor;
        protected Color _linkUpColor;
        protected string _timeFormat;
        protected string _userName;
        public StatusBar(IContainer container);
        public StatusBar();

        [RefreshProperties(RefreshProperties.Repaint)]
        [Browsable(true)]
        [Category("Symcon Properties")]
        [DefaultValue("Green")]
        public Color LinkUpColor { get; set; }

        [Category("Symcon Properties")]
        [Browsable(true)]
        [RefreshProperties(RefreshProperties.Repaint)]
        [DefaultValue("Red")]
        public Color LinkDownColor { get; set; }

        [RefreshProperties(RefreshProperties.Repaint)]
        [Category("Symcon Properties")]
        [Browsable(true)]
        [DefaultValue("Green")]
        public Color ActivityUpColor { get; set; }

        [Category("Symcon Properties")]
        [DefaultValue("Green")]
        [RefreshProperties(RefreshProperties.Repaint)]
        [Browsable(true)]
        public Color ActivityDownColor { get; set; }

        [RefreshProperties(RefreshProperties.Repaint)]
        [Browsable(true)]
        [Category("Symcon Properties")]
        [DefaultValue("Green")]
        public Color ActivityInProgressColor { get; set; }

        [RefreshProperties(RefreshProperties.Repaint)]
        [Category("Symcon Properties")]
        [Browsable(true)]
        [DefaultValue("-")]
        public string ApplicationMsgText { get; set; }

        [DefaultValue("Black")]
        [RefreshProperties(RefreshProperties.Repaint)]
        [Category("Symcon Properties")]
        [Browsable(true)]
        public Color ApplicationMsgTextColor { get; set; }

        [Category("Symcon Properties")]
        [Browsable(true)]
        [DefaultValue(typeof (Font), "Microsoft Sans Serif, 8.25pt")]
        [RefreshProperties(RefreshProperties.Repaint)]
        public Font ApplicationMsgTextFont { get; set; }

        [DefaultValue("-")]
        [Category("Symcon Properties")]
        [Browsable(true)]
        [RefreshProperties(RefreshProperties.Repaint)]
        public string UserName { get; set; }

        [Browsable(true)]
        [Category("Symcon Properties")]
        [DefaultValue("-")]
        [RefreshProperties(RefreshProperties.Repaint)]
        public string DBName { get; set; }

        [Browsable(true)]
        [DefaultValue("-")]
        [RefreshProperties(RefreshProperties.Repaint)]
        [Category("Symcon Properties")]
        public string DBType { get; set; }

        [RefreshProperties(RefreshProperties.Repaint)]
        [DefaultValue("-")]
        [Browsable(true)]
        [Category("Symcon Properties")]
        public string DBPath { get; set; }

        [Category("Symcon Properties")]
        [Browsable(true)]
        [DefaultValue("-")]
        [RefreshProperties(RefreshProperties.Repaint)]
        public string DateFormat { get; set; }

        [DefaultValue("-")]
        [Browsable(true)]
        [Category("Symcon Properties")]
        [RefreshProperties(RefreshProperties.Repaint)]
        public string TimeFormat { get; set; }

        protected override void Dispose(bool disposing);
        protected override void OnDrawItem(StatusBarDrawItemEventArgs sbdievent);
        protected override void OnMouseMove(MouseEventArgs e);
        protected override void OnResize(EventArgs e);
        protected override void OnGotFocus(EventArgs e);
        protected override void OnLeave(EventArgs e);
        protected override void OnParentVisibleChanged(EventArgs e);
        public void OnIdle(object sender, EventArgs e);
        public void NetworkConnectionUpdate(object sender, EventArgs e);
        public void SetDQInfo(UserControl objForm, LegendDetails LegendDetailsObj);
        public void SetDQInfo(LegendDetails LegendDetailsObj);
        public void SetOverridesInfo(LegendDetails LegendDetailsObj);
        public void SetConnectionInfo(DataSrcConnectionInfos ConnectionInfos);
        public void SetConnectionInfo(DataSrcConnectionInfos ConnectionInfos, DataSrcConnectionInfo ISConnectionInfo);
        public Image GetImage(ProviderConnectionState state);
        public Image GetImage(ImageToApply state);
    }
}
