using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using System.IO;
using CrypKey; 
using Symcon.Utils.MessageLogger;
using Symcon.LightRidge.Options;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.Utils.XMLUtils;
using Symcon.LightRidge.ProjectOptions;
using Symcon.LightRidge.ProjectOptions.ProjectInfo;
using Symcon.Database;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.ExcelWrapper;
using Syncfusion.Windows.Forms.Tools;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.DataQualityConfiguration;
using Symcon.LightRidge.Runcontrol;
using Symcon.Utils.Cryptography;
using Symcon.Utils.Alert.Messages;
using Symcon.Utils.HeaderDispatcher;  
using Symcon.LightRidge.PEAdvisor.SavedViews;
using Symcon.LightRidge.Options.VersionInfo;
using Symcon.LightRidge.ExecutionEngine;
using Symcon.LightRidge.ExecutionEngine.Model;
using Symcon.Lightridge.LRRUI.Controls;
using Symcon.LightRidge.PEAdvisor.GridUtilities;


using Microsoft.Win32;
using System.Collections.Generic;
using Symcon.LightRidge.HistorianConnect;
using Symcon.Lightrige.ScriptRunner;
using System.Reflection;
using Symcon.LightRidge.BusinessObjects.Utilities;
using Symcon.LightRidge.PEAdvisor.CommonViews;
//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.


namespace Symcon.LightRidge.PEAdvisor
{
	/// <summary>
	/// Summary description for LRRApp.
	/// </summary>
	public class LRRApp
	{
        public delegate void RollBackChangesDel(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl ggc);   
			private Login loginForm;
        private CrypKeyNET2 license;
        bool userAuthentication = true;

        #region Const

        public const string USER_KEY = "C8E54030D18E342A559787";
        public const string MASTER_KEY = "355965c2191f0394b935fb47007613ca29a6ae3f9af8bd7eba6583512628e99ef12a9a719f086c894179f3fdf935639e60993d0ba46f7e5e1f9c40764d8bc2379742ba043b2eb59670d694d8963e30ed6722beccbdb5eeb881abf7e2d4ad329952410adac7250357aecd75aa2bd9091714b7bb5c14ebfe66fa5e0506f27c485a";
        public const string LICENSE_FILE_NAME = "MXSTEAMA.DLL";
        public const string LICENSE_SERVICE_FILE = "SetupEx.exe";

        #endregion

        #region Constructor
        public LRRApp(string[] args)
        {

            //Cryp Key implementation.
            /*
            #region CrypKey Check.
            #if (DEBUG)
            string sAppSettingsPath = Application.StartupPath;
            try
            {
                System.ServiceProcess.ServiceController serviceController = new System.ServiceProcess.ServiceController("Crypkey License");
                string displayName = serviceController.DisplayName;
                if (serviceController.Status == System.ServiceProcess.ServiceControllerStatus.Stopped || serviceController.Status == System.ServiceProcess.ServiceControllerStatus.Paused)
                {
                    serviceController.Start(); 
                }
            }
            catch(Exception ex)
            {
                if (ex.Message == "Service Crypkey License was not found on computer '.'.")
                {
                    StartService();
                }
            }

            

            license = new CrypKeyNET2();

            int nError = (int)license.InitCrypKey("C:\\PEAdvisor"+ "\\" + LICENSE_FILE_NAME, MASTER_KEY, USER_KEY, 0, 300);

            license.KillLicense();

            if (nError == 0)
            {
                int err = (int)license.GetAuthorization2(1);

                if (err == 0)
                {
                    userAuthentication = true;
                }
                else
                {
                    // MessageBox.Show("Please Enter the Site Key in the text Box and Press Validate");
                    string siteCode = license.GetSiteCode2();
                    CrypKeySetUp crypKeySetUp = new CrypKeySetUp(siteCode, license);
                    crypKeySetUp.ShowDialog();
                    userAuthentication = crypKeySetUp.Authenticated;
                }
            }
            AppDomain.CurrentDomain.SetData("CRYPKEY", license);
            #endif
            #endregion
            */
            if (userAuthentication)
            {
                //Please DO NOT DELETE THIS COMMENTED CODE
                //************* Starts Here ************************
                string keyval = Read("");
                if (keyval == null)
                {
                    MessageBox.Show("Please check the previlages to run this application.", "PE-ADvisor", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    return;
                }
                long l = Int64.Parse(keyval);
                long currentl = DateTime.Now.Ticks;

                long diff = currentl - l;
                /*
                if (currentl < l)
                {
                    MessageBox.Show("Your evaluation period has expired.", "PE-Advisor", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    return;
                }
                else if (TimeSpan.FromTicks(diff).TotalDays > 90)
                {
                    MessageBox.Show("Your evaluation period has expired.", "PE-Advisor", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    return;
                }
                 * */
                //****************** Ends Here ****************************

                AppDomain.CurrentDomain.SetData("AppObject", this);

                //Application.ApplicationExit+=new EventHandler(Application_ApplicationExit);

                _appPath = Application.StartupPath;

                bool check = false;
                if (args.Length > 0)
                {
                    if (args[0] == "BrownFox")
                    {
                        check = true;
                    }
                }
                else
                {

                    Process[] procs = Process.GetProcessesByName("Symcon.LightRidge.PEAdvisor");
                    if (procs.Length == 1)
                    {
                        check = true;
                    }
                    else
                    {
                        Process[] procs2 = Process.GetProcessesByName("Symcon.LightRidge.PEAdvisor.vshost");
                        if (procs2.Length == 1)
                        {
                            check = true;
                        }
                    }

                }
                if (!check)
                {
                    LRRMessagBox.ShowMessage("SID_PERUNNING", "SID_ERROR", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    return;
                }
                if (!LoadOptions()) //If Options load fails return...
                    return;

                _mainframe = new PEMainWindow(this);

                Symcon.Utils.MessageDispatcher.LRRMessagBox.ParentForm = _mainframe;


                _uiManager = new LRRUIManager(_mainframe);

                if (_lrrOptions.DataBaseConnectionInfosObj.Count == 0)
                {
                    Options opt = new Options("Login");
                    opt.ShowDialog();
                }

                loginForm = new Login(_lrrOptions);

                InternationalizationUtils.GetControlText(loginForm, null);

                DialogResult dlgResult = loginForm.ShowDialog();

                if (dlgResult == DialogResult.Cancel)
                {
                    //System.Threading.Thread.CurrentThread.Abort();
                    Application.Exit();
                    return;
                }

                if (!_runController.Initialize())
                {
                    LRRMessagBox.ShowMessage("SID_RUNCONTROL_INFO", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    _runController.ReceivedPoint += new ReceivedPointDataDel(_runController_ReceivedPoint);
                    _runController.RunCycleCompleted += new EventHandler(_runController_RunCycleCompleted);
                    _runController.RunCompleted += new EventHandler(_runController_RunCompleted);
                    _runController.RunStarted += new RunStartedDel(_runController_RunStarted);
                }

                //			_uomConversionUtility = new UOMConversionUtility();

                //Initialize RecordingValues DB Info
                _recordingValuesManager = new RecordingValuesManager();
                _recordingValuesManager.Initialize();

                //Messaging System initialized...
                MessagingClient.InitializeClient();

                Application.ApplicationExit += new EventHandler(Application_ApplicationExit);
                Symcon.BusinessObjects.CustomCollection.IsInitialized = true;
                Application.Run(_mainframe);
                
            }
        }

        private void StartService()
        {
            ProcessStartInfo proceStatrInfo = new ProcessStartInfo(Application.StartupPath + "\\" + LICENSE_SERVICE_FILE);
            proceStatrInfo.UseShellExecute = false;
            Process.Start(proceStatrInfo);
        }

        private void CheckSnapShotForRebuildWaterModel()
        {
            //Check the snapshot for RebuildWaterModel
            foreach (LRRSiteComponentPropertyValue propValue in LRRModel.PropertyValuesObj)
            {
                if (_htSnapShotForRebuildWaterModel.Contains(propValue.ID))
                {
                    if ((_htSnapShotForRebuildWaterModel[propValue.ID] as string) != propValue.PropertyValue)
                    {
                        LRRModel.RebuildWaterModel = true;
                        break;
                    }
                }

            }

        }

        private  void _runController_RunCycleCompleted(object sender, EventArgs e)
        {
            try
            {
                // null check added by Ashwin
                //if (_scriptingAppDomain != null)
                //{
                    AppDomain.Unload(_scriptingAppDomain);
                //}
                //_scriptingAppDomain = null;
                //GC.Collect();
                //MessageBox.Show("Loaded Assemblies Count: " + AppDomain.CurrentDomain.GetAssemblies().Length);
                this.MainFrame.Invalidate(true);
                ProcessSnapShotForRebuildWaterModelDel myDel = new ProcessSnapShotForRebuildWaterModelDel(CheckSnapShotForRebuildWaterModel);

                myDel.BeginInvoke(null, null);
                              
                // call to process graphics irrespective of web publishing mdae by ashwin for handling flagging
                /*
                //Check if Publishing of Graphics is on in Options
                if (!this.GetOptions().PublishGraphics)
                    return;

                //Check if directory for publishing graphics exists
                if (!System.IO.Directory.Exists(this.GetOptions().WebConfigPath))
                    return;
                 * */
                
                // logging done by ashwin
                Symcon.Utils.MessageLogger.Logger.LogMessage("Inside Run Cycle Completed before process graphics ", Symcon.Utils.MessageLogger.Logger.Level.Debug);
                bool publishtoWeb = false;
                string graphicsFolderPath = "";

                //Check if Graphics Managers are loadded,if not load the graphics managers
                if ((this.GetOptions().PublishGraphics && this.GraphicsManagersObj == null) || (!this.GetOptions().PublishGraphics && this.GraphicsManagersObj != null))
                {
                    ProcessGraphics();
                }
                else if(this.GetOptions().PublishGraphics && this.GraphicsManagersObj != null)
                {
                    bool processOnlyPublisherInformation = false;
                    bool processCanvas = true;
                    if (this.GetOptions().PublishGraphics && _mainframe.tlbPublishToWeb.Checked)
                    {
                        publishtoWeb = true;
                    }
                    if (publishtoWeb)
                    {
                        LRRWebPublisherUser webpublishUser = LRRModel.WebPublishUsers.GetWebPublishUserFromID(this.DBManagerObj.AccessControlModel.UserID);
                        if (webpublishUser == null)
                        {
                            webpublishUser = new LRRWebPublisherUser();
                            webpublishUser.PublisherName = this.DBManagerObj.AccessControlLayer.Model.UserName;
                            webpublishUser.PublisherUID = this.DBManagerObj.AccessControlLayer.Model.UserID;
                            webpublishUser.ModeID = "";
                            webpublishUser.IPAddress = System.Environment.MachineName;
                            LRRModel.WebPublishUsers.Add(webpublishUser);
                            this.DBManagerObj.CommitCollection(LRRModel.WebPublishUsers.GetChanges());
                        }

                    }
                    
                    if (publishtoWeb)
                    {
                        string publisherFolderName = this.DBManagerObj.AccessControlLayer.Model.UserName;
                        graphicsFolderPath = this._lrrOptions.WebConfigPath + @"\" + publisherFolderName + @"\";
                        if (!Directory.Exists(graphicsFolderPath))
                        {
                            System.IO.Directory.CreateDirectory(graphicsFolderPath);
                        }
                    }

                    foreach (DictionaryEntry dEntry1 in this.GraphicsManagersObj.HashGraphicsManagerList)
                    {
                        try
                        {
                            GraphicsManager gm = dEntry1.Value as GraphicsManager;
                            //Save the graphics for Web Publishing
                            // changed to publish only shared views as Ashwin
                            Canvas canvas = gm.CanvasObj as Canvas;
                            ProcessCanvasForFlagging(canvas);
                            LRRUserRoleMapping userRoleMap = LRRModel.UserRoleMappings.GetUserRoleMappingForUserId(this.DBManagerObj.AccessControlModel.UserID);
                            if (userRoleMap.RoleID != "1")
                            {
                                if (publishtoWeb)
                                {
                                    LRRViewSharing viewSharing = LRRModel.ViewSharings.GetViewSharingByRoleIDAndViewID(userRoleMap.RoleID, canvas.FileID);
                                    if (viewSharing != null)
                                    {
                                        System.Drawing.Bitmap bitMapImage = canvas.ExportDiagramAsImage();
                                        bitMapImage.Save(graphicsFolderPath + @"\" + canvas.FileName + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                                    }
                                }
                            }
                            else
                            {
                                if (publishtoWeb)
                                {
                                    System.Drawing.Bitmap bitMapImage = canvas.ExportDiagramAsImage();
                                    bitMapImage.Save(graphicsFolderPath + @"\" + canvas.FileName + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                                }
                            }
                            
                        }
                        catch
                        {
                            continue;
                        }

                    }
                }
                else if (!(this.GetOptions().PublishGraphics) && this.GraphicsManagersObj == null)
                {
                    _graphicsManagers = new GraphicsManagers();
                    foreach (LRRSavedView savedView in LRRModel.SavedViews)
                    {
                        this.GraphicsManagersObj.CreateGraphicsManager(savedView.ID);
                        Canvas canvas = GraphicsManagersObj.ActiveManager.CanvasObj;
                        ProcessCanvasForFlagging(canvas);
                        LRRUserRoleMapping userRoleMap = LRRModel.UserRoleMappings.GetUserRoleMappingForUserId(this.DBManagerObj.AccessControlModel.UserID);
                        if (userRoleMap.RoleID != "1")
                        {
                            if (publishtoWeb)
                            {
                                LRRViewSharing viewSharing = LRRModel.ViewSharings.GetViewSharingByRoleIDAndViewID(userRoleMap.RoleID, canvas.FileID);
                                if (viewSharing != null)
                                {
                                    System.Drawing.Bitmap bitMapImage = canvas.ExportDiagramAsImage();
                                    bitMapImage.Save(graphicsFolderPath + @"\" + canvas.FileName + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                                }
                            }
                        }
                        else
                        {
                            if (publishtoWeb)
                            {
                                System.Drawing.Bitmap bitMapImage = canvas.ExportDiagramAsImage();
                                bitMapImage.Save(graphicsFolderPath + @"\" + canvas.FileName + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                            }
                        }

                    }
                }
                // logging done by ashwin
                Symcon.Utils.MessageLogger.Logger.LogMessage("Inside Run Cycle Completed after process graphics ", Symcon.Utils.MessageLogger.Logger.Level.Debug);

                // remove this change of calling the DBManager method if not required
                _dbManager.RunDQSP();  
           
            }
            catch { }
        }

		#endregion

        #region Constant Historian Names
        public readonly string OFFLINE = "OffLine";
        public readonly string TUNNING = "Tunning";
        public readonly string PI = "PI";
        #endregion

        #region Public Properties

        public AppDomain ScriptingAppDomain
        {
            get { return _scriptingAppDomain; }
        }

        public LRRBindingManager LRRCascadeBindingManagerObj
        {
            get { return _cascadingBindingManager; }
        }

        public bool ResetNamedRangesFile
        {
            get { return _resetNamedRangesFile; }
            set { _resetNamedRangesFile = value; }
        }

        public bool ResetMenus
        {
            get { return _resetMenus; }
            set { _resetMenus = value; }
        }

		public PEMainWindow MainFrame
		{
			get{return _mainframe;}
		}
		public string LoggedUser
		{
			get{return loginForm.UserName;}
		}
		public string LoggedUserPWD
		{
			get{return loginForm.PassW ;}
		}
		public TimeWindow TimeWindowObj
		{
			get{return _timeWindow;}
			set
			{
				_timeWindow = value;
			}
		}

		public OverridesWindow OverridesWindow
		{
			get{return _overridesWindow;}
			set
			{
				_overridesWindow = value;
			}
		}

		public TransPosedView TransPosedView
		{
			get{return _transPosedView;}
			set
			{
				_transPosedView = value;
			}
		}

		public DBManager DBManagerObj
		{
			get{return _dbManager;}
			set
			{
				_dbManager = value;
			}
		}
		private DBManager SessionDBManagerObj
		{
			get{return _dbSessionManager;}
			set
			{
				_dbSessionManager = value;
			}
		}
		public DataAdapter DataAdapterObj
		{
			get{return _dataAdapter;}
			set
			{
				_dataAdapter = value;
			}

		}

		public LRRDataStore LRRDataStoreObj
		{
			get{return _lrrDataStore;}
			set
			{
				_lrrDataStore = value;
			}
		}

		public LRRUIManager	LRRUIManagerObj
		{
			get{return _uiManager;}
			set
			{
				_uiManager = value;
			}
		}

		public SymExcelWrapper SymExcelWrapperObj
		{
			get{return _symExcelWrapper;}
			set
			{
				_symExcelWrapper = value;
			}
		}

		public string AppLocale
		{
			get{return _appLocale;}
			set
			{
				_appLocale = value;
			}
		}

		public string AppLocaleID
		{
			get{return _appLocaleID;}
			set
			{
				_appLocaleID = value;
			}
		}

		public string UID
		{
			get{return _uid;}
			set
			{
				_uid = value;
			}
		}


		public string AppPath
		{
			get{return _appPath;}
			set
			{
				_appPath = value;
			}
		}

		public string OptionsFile
		{
			get{return _appPath + optionsFile;}
			set
			{
				optionsFile = value;
			}
			
		}
		public int SetSelectedDBIndex
		{
			get {return _nSelectedIndex;}
			set
			{
				_nSelectedIndex = value;
			}
		}
		
		public string ProjectOptionsFile
		{
			get{return _appPath + projOptionsFile;}
		}

		public RunController RunControllerObj
		{
			get{return _runController;}
		}

//		public Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility	UOMConversionUtilityObj
//		{
//			get{return Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility;}
//		}

		//		public ModesDialog ModesPanel
		//		{
		//			get{return _modeDialog;}
		//
		//		}

		public RunControlSet ActiveRunControlSet
		{
			get{return _activeRunControlSet;}
			set
			{
				_activeRunControlSet = value;
			}
		}

		public RunOptions RunOptionsObj
		{
			get{return _runOptionsObj;}
			set
			{
				_runOptionsObj = value;
			}
		}

		public bool OnlineHistorianSimulator
		{
			get{return _onlineHistorianSimulator;}
			set
			{
				_onlineHistorianSimulator = value;
			}
		}

		public RecordingValuesManager RecordingValuesManagerObj
		{
			get{return _recordingValuesManager;}
			set
			{
				_recordingValuesManager = value;
			}
		}
		
		public bool IsMainFrameClosingCalled
		{
			get { return _isMainFrameClosingCalled; }
			set { _isMainFrameClosingCalled = value; }
		}
		
		public PrintDialog PrintDialogObj
		{
			get{return _printDialog;}
			set
			{
				_printDialog = value;
			}
		}

		public PrintPreviewDialog PrintPreviewDialogObj
		{
			get{return _printPreviewDialog;}
			set
			{
				_printPreviewDialog = value;
			}
		}

		public PageSetupDialog PageSetupDialogObj
		{
			get{return _pageSetupDialog;}
			set
			{
				_pageSetupDialog = value;
			}
		}

		public string DynamicCaseID
		{
			get{return _dynamicCaseID;}
			set
			{
				_dynamicCaseID = value;
			}
		}

		public LRRVersionInfo VersionInfo
		{
			get{return _lrrVersionInfo;}
			set
			{
				_lrrVersionInfo = value;
			}
		}

		public bool ToggleRecording
		{
			get{return _toggleRecording;}
			set
			{
				_toggleRecording = value;
			}
		}

		public bool ToggleTrending
		{
			get{return _toggleTrending;}
			set
			{
				_toggleTrending = value;
			}
		}

        private string _currentNumericFormat;

        public string CurrentNumericFormat
        {
            get 
            {
                foreach (NumericfFormatInfo var in _lrrOptions.NumericFormat)
                {
                    if (var.IsSelected)
                    {
                        _currentNumericFormat = var.FormatName;
                        break;
                    }
                }
                return _currentNumericFormat;
            }
        }

        public GraphicsManagers GraphicsManagersObj
        {
            get { return _graphicsManagers; }
            set
            {
                _graphicsManagers = value;
            }
        }

        /*public Dictionary<string, IHistorian> LoadedAssemblies
        {
            get
            {
                return _loadedAssemblies;
            }
        }*/

        public Dictionary<string, IHistorian> LoadedOnLineHistorianAssemblies
        {
            get
            {
                return _loadedOnLineHistorianAssemblies;
            }
        }

        public Dictionary<string, IHistorian> LoadedOffLineHistorianAssemblies
        {
            get
            {
                return _loadedOffLineHistorianAssemblies;
            }
        }

        //public AppDomain ScriptingAppDomain
        //{
        //    get
        //    {
        //        return _scriptingAppDomain;
        //    }
        //}

		  

		  public bool RememberPwd
		  {
			  get { return _rememberPwd; }
			  set { _rememberPwd = value; }
		  }

        public LRRScriptRunner ScriptRunner
        {
            get { return _scriptRunner; }
        }

		#endregion

		#region Public Methods

		
		public void Initialize()
		{
			int nSelectedIndex = this._lrrOptions.SelectedDBIndex;
			DBInfo dbinf = this._lrrOptions.DataBaseConnectionInfosObj[nSelectedIndex];
			if(dbinf.DatabaseFilePath.StartsWith(@".\"))
			{
				dbinf.DatabaseFilePath =  dbinf.DatabaseFilePath.Replace(@".\",_appPath + @"\");//Application.StartupPath + @"\");
			}

			string initDatabase = LRRHeaderText.GetHeaderString("SID_INIT_DATABASE");
			loginForm.ShowProgress(initDatabase);
			//loginForm.ShowProgress("Initializing Database Manager...");
			try
			{
                // only for login added by ashwin
				//_dbManager = new DBManager(dbinf);
                _dbManager = new DBManager(dbinf,true);
			}
			catch(Exception ex)
			{
                MessageBox.Show(ex.Message, "PE-Advisor login error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				loginForm.ErrorMessage = ex.Message;   
				return;
			}

			
			//Check if the same  user is logged in any other system, if yes, throw error & exit the application
			/*if(!_dbManager.SameUserLogin(loginForm.UserName))
			{
				string loginFail = LRRMessages.GetMessageString("SID_LOGIN_FAILED_SAME_USER");  
				loginForm.ErrorMessage = loginFail;   
				//loginForm.ErrorMessage = "Invalid User Name & Password. Retry!";
				return;
			}*/
			//Authenticate the login credentials
			//Check if the same  user is logged in any other system, if yes, throw error & exit the application
			try
			{
				if(!_dbManager.Login(loginForm.UserName,loginForm.PassW))
				{
					string loginFail = LRRHeaderText.GetHeaderString("SID_LOGIN_FAILED");  
					loginForm.ErrorMessage = loginFail;   
					//loginForm.ErrorMessage = "Invalid User Name & Password. Retry!";
					return;
				}
			}
			catch(Exception e)
			{
				loginForm.ErrorMessage = e.Message;
				return;
			}
			
			_lrrLogin = new LRRLogin();
			this.DBManagerObj.PopulateObject(_lrrLogin,typeof(LRRLogin)," where UserID = '" + this.DBManagerObj.AccessControlModel.UserID + "'");
            // usre ID assignment added by ashwin for handling user specific recorded properties
            UID = _lrrLogin.UserID;
			_lrrLogin.LoginDateTime = DateTime.UtcNow;
			
			if(dbinf != null)
			{
				if(this.SessionDBManagerObj == null)
				{
					try
					{
						this.SessionDBManagerObj = new DBManager(dbinf);
					}
					catch
					{
						return;
					}
				}

				SessionDBManagerObj.Login(loginForm.UserName,loginForm.PassW,true);
				
			}

			 //save user details if remember password is checked 
			if(this.RememberPwd)
			{
				_lrrOptions.RememberPwd=true;
				_lrrOptions.LastLoggedInUserPwd=CryptographyUtils.EncryptedPassword(loginForm.PassW);
				
			}
			else
			{
				_lrrOptions.RememberPwd=false;
				_lrrOptions.LastLoggedInUserPwd="";

			}



            //Added by Sandeep. Deleting flat files for named ranges
            if (this.ResetNamedRangesFile)
            {
                string[] tempFilesList = Directory.GetFiles(Application.StartupPath, "*.temp");
                foreach (string tempFileName in tempFilesList)
                {
                    FileInfo tempFileInfo = new FileInfo(tempFileName);

                    tempFileInfo.Delete();

                }

            }

			//Update the session
			UpdateSession();

			//Initialize the timer
			_loginTimer = new System.Threading.Timer(new System.Threading.TimerCallback(loginTimer_Tick),null,0,30000);
			 
			//Initialize the BindingManagers
			_bindingManager = new LRRBindingManager();
			_cascadingBindingManager = new LRRBindingManager();
			_compPropHistPropBindingManager = new LRRBindingManager();
			
			//			_dataAdapter = new DataAdapter();
			//			_dataAdapter.Initialized(dbinf);

			LRRModelConfiguration modelConfigForEEPath = new LRRModelConfiguration();
			_dbManager.PopulateObject(modelConfigForEEPath,typeof(LRRModelConfiguration)," WHERE ParamName ='ModelFolder'");
			string modelFolder = modelConfigForEEPath.ParamValue;
			/*if((modelFolder == null)||(!System.IO.Directory.Exists(modelFolder)))
			{
				MessageBox.Show("Execution Engine not Configured.Make sure the directory '" + modelFolder + "' exists in your application folder.");
				Terminate();
				Application.Exit();
				return;
			}*/
			
			//Initializing DB Infos
			LRRTuningConnections tuningConnections = new LRRTuningConnections();
			_dbManager.PopulateCollection(tuningConnections);
			this._lrrOptions.TuningConnectionObj = tuningConnections;

			LRROfflineConnections offlineConnections = new LRROfflineConnections();
			_dbManager.PopulateCollection(offlineConnections);
			this._lrrOptions.OfflineConnectionObj = offlineConnections;

			LRRRecordingValuesConnections recordingValuesConnections = new LRRRecordingValuesConnections();
			_dbManager.PopulateCollection(recordingValuesConnections);
			this._lrrOptions.RecordingValuesConnectionObj = recordingValuesConnections;

			//Initialize Messaging Server Info
			LRRMessagingServerInfo messagingServerInfo = new LRRMessagingServerInfo();
			_dbManager.PopulateObject(messagingServerInfo,typeof(LRRMessagingServerInfo),null);
			this._lrrOptions.MessagingServerInfoObj = messagingServerInfo;

			string initDataStore = LRRHeaderText.GetHeaderString("SID_INIT_DATASTORE");
			loginForm.ShowProgress(initDataStore);
			//loginForm.ShowProgress("Initializing Data Store.....");
			_lrrDataStore = new LRRDataStore(_dbManager);

			
			string loadExcel = LRRHeaderText.GetHeaderString("SID_LOAD_EXCEL");
			loginForm.ShowProgress(loadExcel);
			//loginForm.ShowProgress("Loading Excel Wrapper...");
			_symExcelWrapper = new SymExcelWrapper(/*_appPath + @"\" +*/ modelFolder);//Application.StartupPath + @"\ExecutionEngine");

			_executionEngine.SymExcelWrapperObj = _symExcelWrapper;

			string inItModel = LRRHeaderText.GetHeaderString("SID_INIT_LRR_MODEL");
			loginForm.ShowProgress(inItModel);   
			//loginForm.ShowProgress("Initializing LightRidge Model....");
			loginForm.SetControlEnabledState(false);
			//Symcon.Utils.TimerUtils.HiPerfTimer hTimer = new Symcon.Utils.TimerUtils.HiPerfTimer();
			//hTimer.Start();
			Logger.LogMessage("Start of Model Loading:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			LRRModel.Initialize(_dbManager);
			
			//End time
			Logger.LogMessage("End of Model Loading:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//Difference
			//hTimer.Stop();
			//Logger.LogMessage("Total time taken in Model Loading:" + hTimer.Duration.ToString(Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//End Model Loading

			string initExcel = LRRHeaderText.GetHeaderString("SID_INIT_EXCEL");
			loginForm.ShowProgress(initExcel);
			//loginForm.ShowProgress("Initializing Excel Wrapper...");
			LRREEModel.Initialize(_dbManager,_symExcelWrapper);

			string projectConfig = LRRHeaderText.GetHeaderString("SID_LOAD_PROJECT_CONFIG");
			loginForm.ShowProgress(projectConfig); 
			//loginForm.ShowProgress("Loading Project Configuration...");
			LRRProjectConfiguration pc = new LRRProjectConfiguration();

			string initMainFrame = LRRHeaderText.GetHeaderString("SID_INIT_MAIN_FRAME");
			loginForm.ShowProgress(initMainFrame); 
			//loginForm.ShowProgress("Initializing Main Frame...");
			LRRWaitWindowUtility.Initialize(_mainframe);

			string populateProjConfig = LRRHeaderText.GetHeaderString("SID_POPULATE_PROJECT_CONFIG");
            loginForm.ShowProgress(populateProjConfig); 
			//loginForm.ShowProgress("Populating Project Configuration...");
			//_dbManager.PopulateObject(pc,typeof(LRRProjectConfiguration),null);
			
			this._appLocaleID =  LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID;

			this.GetOptions().EnablePET = LRRModel.ChildModel.LRRProjConfigObj.EnablePET;
			
			//Deserialize RunOptions
			this.RunOptionsObj = (RunOptions)SGTXmlSerializer.DeserializeXML(Application.StartupPath + @"\Runoptions.xml" , typeof(Symcon.LightRidge.Runcontrol.RunOptions));
			this.ActiveRunControlSet = this.RunOptionsObj.RunControlSetsObj[this.RunOptionsObj.SelectedRunControlIndex];
			
			string setPropertyHistBinding = LRRHeaderText.GetHeaderString("SID_SET_HIST_BINDING"); 
			loginForm.ShowProgress(setPropertyHistBinding);

			SetPropertyHistorianBinding();

			//LRRUIManagerObj.InitializeModesDialog();
			LRRUIManagerObj.InitializeDataQualityWindow();
			LRRUIManagerObj.RefreshDataQualityGrid(true);
			UpdateOverridePoints();
			//Application.ApplicationExit+=new EventHandler(Application_ApplicationExit);

			string loadMainFrame = LRRHeaderText.GetHeaderString("SID_LOAD_MAIN_FRAME");
			loginForm.ShowProgress(loadMainFrame); 
			//loginForm.ShowProgress("Loading Main Frame...");
			SetPEStatusBar(dbinf);
			
			//_uomConversionUtility = new Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility();
			//Set Overrides
			ApplyOverrides();
			ApplyGroupOverrides();

			SetPropertyValueBinding();
			SetGroupPropertyValueBinding();

			//Set Overrides
//			_uomConversionUtility = new UOMConversionUtility();
//			ApplyOverrides();
//			ApplyGroupOverrides();

			loginForm.DialogResult = DialogResult.OK;
			_lrrOptions.ShowRunStatus = true; 
			
			LRRAlert.RollOverLimit = _lrrOptions.GUIPreferencesObj.RollOverLimit;
			this.InitializeMessagePanel();

			loginForm.SetControlEnabledState(true);

			//LRRExecutionEngine ee = new LRRExecutionEngine(this._symExcelWrapper,GetOptions(),ActiveRunControlSet);
            
            //Process Graphic Screens for web publishing
            // process graphics commented by ashwin
            //ProcessGraphics();
		    this._symExcelWrapper.ShowWindow(false);
			
		}
		
		public void InitializeMessagePanel()
		{
			MessagePanel msgPanel = new MessagePanel();
			msgPanel.Opacity = 0;
			
			//msgPanel.Initialize();
			Symcon.Utils.Alert.Messages.LRRAlert.InitializeMessagePanel(msgPanel);
			msgPanel.Show();
			LRRAlert.Hide();
			msgPanel.Opacity = 1;
		}
		public void InitializeReconnect()
		{
			//loginForm.Show();
			int nSelectedIndex = this._lrrOptions.SelectedDBIndex;
			DBInfo dbinf = this._lrrOptions.DataBaseConnectionInfosObj[nSelectedIndex];
			if(dbinf.DatabaseFilePath.StartsWith(@".\"))
			{
				dbinf.DatabaseFilePath =  dbinf.DatabaseFilePath.Replace(@".\",_appPath + @"\");//Application.StartupPath + @"\");
			}

			//loginForm.Refresh();

			string reInitDatabase = LRRHeaderText.GetHeaderString("SID_REINIT_DATABASE");
			//loginForm.ShowProgress(reInitDatabase);
			//loginForm.ShowProgress("ReInitializing Database Manager...");
			try
			{
				_dbManager = new DBManager(dbinf);
			}
			catch
			{
				return;
			}

			if(dbinf != null)
			{
				if(this.SessionDBManagerObj != null)
					TerminateSession();
				else
				{
					try
					{
						this.SessionDBManagerObj = new DBManager(dbinf);
					}
					catch
					{
						return;
					}
				}
			}
			else
			{
				this.Terminate();
			}

			

			//Check if the same  user is logged in any other system, if yes, throw error & exit the application
//			if(!_dbManager.SameUserLogin(this.loginForm.UserName))
//			{
//				string loginFail = LRRHeaderText.GetHeaderString("SID_LOGIN_FAILED_SAME_USER");  
//				loginForm.ShowProgress( loginFail);   
//				//loginForm.ErrorMessage = "Invalid User Name & Password. Retry!";
//				return;
//			}
			//Authenticate the login credentials
			try
			{
				if(!_dbManager.Login(this.loginForm.UserName,this.loginForm.PassW))
				{
					string loginFail = LRRHeaderText.GetHeaderString("SID_LOGIN_FAILED");  
					//loginForm.ShowProgress(loginFail);
					//loginForm.ShowProgress("Invalid User Name & Password.");
					return;
				}
			}
			catch(Exception e)
			{
//				loginForm.ErrorMessage = e.Message;
				return;
			}
			
			_lrrLogin = new LRRLogin();
			this.DBManagerObj.PopulateObject(_lrrLogin,typeof(LRRLogin)," where UserID = '" + this.DBManagerObj.AccessControlModel.UserID + "'");
			_lrrLogin.LoginDateTime = DateTime.UtcNow;

			if(dbinf != null)
			{
				SessionDBManagerObj.Login(this.loginForm.UserName,this.loginForm.PassW,true);
			}
			
			//Update the session
			UpdateSession();

			//Initialize the timer
			_loginTimer = new System.Threading.Timer(new System.Threading.TimerCallback(loginTimer_Tick),null,0,30000);

			_dataAdapter = new DataAdapter();
			_dataAdapter.Initialized(dbinf);

			//Initialize the BindingManagers
			_bindingManager = new LRRBindingManager();
			_cascadingBindingManager = new LRRBindingManager();
			_compPropHistPropBindingManager = new LRRBindingManager();

			LRRModelConfiguration modelConfigForEEPath = new LRRModelConfiguration();
			_dbManager.PopulateObject(modelConfigForEEPath,typeof(LRRModelConfiguration)," WHERE ParamName ='ModelFolder'");
			string modelFolder = modelConfigForEEPath.ParamValue;
			/*if((modelFolder == null)||(!System.IO.Directory.Exists(_appPath + @"\" + modelFolder)))
			{
				MessageBox.Show("Execution Engine not Configured.Make sure the directory '" + modelFolder + "' exists in your application folder.");
				Terminate();
				Application.Exit();
				return;
			}  */
			
			//Initializing DB Infos
			LRRTuningConnections tuningConnections = new LRRTuningConnections();
			_dbManager.PopulateCollection(tuningConnections);
			this._lrrOptions.TuningConnectionObj = tuningConnections;

			LRROfflineConnections offlineConnections = new LRROfflineConnections();
			_dbManager.PopulateCollection(offlineConnections);
			this._lrrOptions.OfflineConnectionObj = offlineConnections;

			LRRRecordingValuesConnections recordingValuesConnections = new LRRRecordingValuesConnections();
			_dbManager.PopulateCollection(recordingValuesConnections);
			this._lrrOptions.RecordingValuesConnectionObj = recordingValuesConnections;

			//loginForm.Refresh();

			string initDataStore = LRRHeaderText.GetHeaderString("SID_INIT_DATASTORE");
			loginForm.ShowProgress(initDataStore);
			//loginForm.ShowProgress("Initializing Data Store.....");
			_lrrDataStore = new LRRDataStore(_dbManager);
		

			//loginForm.Refresh();

			string loadExcel = LRRHeaderText.GetHeaderString("SID_LOAD_EXCEL");
			//loginForm.ShowProgress(loadExcel);
			//loginForm.ShowProgress("Loading Excel Wrapper...");
			_symExcelWrapper = new SymExcelWrapper(/*_appPath + @"\ExecutionEngine"*//*_appPath + @"\" +*/ modelFolder);//Application.StartupPath + @"\ExecutionEngine");

			_executionEngine.SymExcelWrapperObj = _symExcelWrapper;

			//loginForm.Refresh();
			string inItModel = LRRHeaderText.GetHeaderString("SID_INIT_LRR_MODEL");
			//loginForm.ShowProgress(inItModel);   
			//loginForm.ShowProgress("Initializing LightRidge Model....");

			//Start Model Loading
			Symcon.Utils.TimerUtils.HiPerfTimer hTimer = new Symcon.Utils.TimerUtils.HiPerfTimer();
			hTimer.Start();
			Logger.LogMessage("Start of Model Loading:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);

			LRRModel.Initialize(_dbManager);
			
			//End time
			Logger.LogMessage("End of Model Loading:" + DateTime.Now.ToString(Symcon.BusinessObjects.SymConverter.LRR_DATE_TIME_FORMAT,Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//Difference
			hTimer.Stop();
			Logger.LogMessage("Total time taken in Model Loading:" + hTimer.Duration.ToString(Symcon.BusinessObjects.SymConverter.Culture),Logger.Level.Debug);
			//End Model Loading

			//loginForm.Refresh();
			string initExcel = LRRHeaderText.GetHeaderString("SID_INIT_EXCEL");
			//loginForm.ShowProgress(initExcel);
			//loginForm.ShowProgress("Initializing Excel Wrapper...");
			LRREEModel.Initialize(_dbManager,_symExcelWrapper);

			//loginForm.Refresh();
			string projectConfig = LRRHeaderText.GetHeaderString("SID_LOAD_PROJECT_CONFIG");
			//loginForm.ShowProgress(projectConfig); 
			//loginForm.ShowProgress("Loading Project Configuration...");
//			LRRProjectConfiguration pc = new LRRProjectConfiguration();

			//loginForm.Refresh();
			string initMainFrame = LRRHeaderText.GetHeaderString("SID_INIT_MAIN_FRAME");
			//loginForm.ShowProgress(initMainFrame); 
			//loginForm.ShowProgress("Initializing Main Frame...");
			LRRWaitWindowUtility.Initialize(_mainframe);

			//loginForm.Refresh();
			string populateProjConfig = LRRHeaderText.GetHeaderString("SID_POPULATE_PROJECT_CONFIG");
			//loginForm.ShowProgress(populateProjConfig); 
		//	loginForm.ShowProgress("Populating Project Configuration...");
//			_dbManager.PopulateObject(pc,typeof(LRRProjectConfiguration),null);
			
			this._appLocaleID =  LRRModel.ChildModel.LRRProjConfigObj.MeasurementSystemUserInterfaceID;

			this.GetOptions().EnablePET = LRRModel.ChildModel.LRRProjConfigObj.EnablePET;
			
			//Serialize RunOptions
//			if(this.ActiveRunControlSet != null)
//			{
//				//Serialize Run Options
//				string filePath = Application.StartupPath + @"\Runoptions.xml";
//				Symcon.Utils.XMLUtils.SGTXmlSerializer.SerializeAsXML(@filePath,typeof(RunOptions),this.RunOptionsObj,false);
//			}

			//Deserialize RunOptions
//			this.RunOptionsObj = (RunOptions)SGTXmlSerializer.DeserializeXML(Application.StartupPath + @"\Runoptions.xml" , typeof(Symcon.LightRidge.Runcontrol.RunOptions));
//			this.ActiveRunControlSet = this.RunOptionsObj.RunControlSetsObj[this.RunOptionsObj.SelectedRunControlIndex];

			string setHistBinding = LRRHeaderText.GetHeaderString("SID_SET_HIST_BINDING");
			//loginForm.ShowProgress(setHistBinding);
			//	loginForm.ShowProgress("Setting Property Historian Binding...");
			SetPropertyHistorianBinding();

			//Application.ApplicationExit+=new EventHandler(Application_ApplicationExit);
            try
            {
                LRRUIManagerObj.InitializeModesDialog();
            }
            catch
            { }
			//LRRUIManagerObj.InitializeDataQualityWindow();
			LRRUIManagerObj.RefreshDataQualityGrid(true);
			UpdateOverridePoints();
			//
			//TO DO:Have to change InitializeDataQualityWindow Implementation
			//
			//LRRUIManagerObj.InitializeDataQualityWindow();

			string loadMainFrame = LRRHeaderText.GetHeaderString("SID_LOAD_MAIN_FRAME");
			//loginForm.ShowProgress(loadMainFrame); 
			//loginForm.ShowProgress("Loading Main Frame...");
			SetPEStatusBar(dbinf);
			
			//_uomConversionUtility = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility();
			//Set Overrides
			ApplyOverrides();
			ApplyGroupOverrides();

			SetPropertyValueBinding();
			SetGroupPropertyValueBinding();

			//Set Overrides
//			ApplyOverrides();
//			ApplyGroupOverrides();

			loginForm.DialogResult = DialogResult.OK;

			LRRAlert.RollOverLimit = _lrrOptions.GUIPreferencesObj.RollOverLimit;
		    this._symExcelWrapper.ShowWindow(false); 
		}

        public void UnLoadScriptingAppDomain(AppDomain scriptingAppDomainToUnload)
        {
            AppDomain.Unload(scriptingAppDomainToUnload);
            _scriptingAppDomain = null;
            GC.Collect();   
        }

        public void ReloadScriptingAppDomain()
        {
            //UnLoadScriptingAppDomain(_scriptingAppDomain);
            _scriptingAppDomain = AppDomain.CreateDomain(Guid.NewGuid().ToString());

            AssemblyName assembName = AssemblyName.GetAssemblyName(Application.StartupPath + "\\Symcon.Lightrige.ScriptRunner.dll");
            _scriptingAppDomain.Load(assembName);////"Symcon.Lightrige.ScriptRunner.dll");

            System.Runtime.Remoting.ObjectHandle scriptRunnerObjectHandel = _scriptingAppDomain.CreateInstance(assembName.Name, "Symcon.Lightrige.ScriptRunner.LRRScriptRunner");
            _scriptRunner = (Symcon.Lightrige.ScriptRunner.LRRScriptRunner)scriptRunnerObjectHandel.Unwrap();
        }

		public void SetPropertyValueBinding()
		{
			Symcon.BusinessObjects.TrackingController.SetTracking(false);
			
			foreach(LRRSiteComponentProperty lrrSiteCompProp in LRRModel.SiteComponentPropertiesObj)
			{
				try
				{
					AddPropertyValueBindings(lrrSiteCompProp);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(LRRApp),"Exception in Property Value Cascading Bindings of Property ID:- " + lrrSiteCompProp.ID + ex.Message,Logger.Level.Debug);
				}
			}

			Symcon.BusinessObjects.TrackingController.SetTracking(true);
			
		}

        public void SetPropertyValueBinding(LRRSiteComponentPropertyValues lrrSiteCompPropvalues)
        {
            Symcon.BusinessObjects.TrackingController.SetTracking(false);
            if (lrrSiteCompPropvalues != null)
            {
                AddPropertyValueBindings(lrrSiteCompPropvalues);
            }
            Symcon.BusinessObjects.TrackingController.SetTracking(true);

        }

		public void SetGroupPropertyValueBinding()
		{
			Symcon.BusinessObjects.TrackingController.SetTracking(false);
			
			foreach(LRRSiteComponentGroupProperty lrrSiteCompGrpProperty in LRRModel.SiteComponentGroupPropertiesObj)
			{
				string grpID = lrrSiteCompGrpProperty.GroupPropertyID;
				//LRRSiteGroupPropertyQualifierValues lrrSiteGrpQualifierValues = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(grpID);

                List<IPropertyValue>  lstVals = LRRModel.SiteGroupPropertyQualifierValuesObj.GetGroupQualifierValuesFromGroupPropID(grpID);
                if (lstVals != null)
                {
                    foreach (IPropertyValue val in lstVals)
                    {
                        LRRSiteGroupPropertyQualifierValue lrrSiteGrpQualifierValue = val as LRRSiteGroupPropertyQualifierValue;
                        try
                        {
                            string qualifierID = lrrSiteGrpQualifierValue.QualifierID;
                            string lkUpPropertiesID = lrrSiteGrpQualifierValue.LookUpPropertiesID;
                            string modeID = lrrSiteGrpQualifierValue.ModeID;
                            AddGroupPropertyValueBindings(grpID, qualifierID, lkUpPropertiesID, modeID);
                        }
                        catch (Exception ex)
                        {
                            Logger.LogMessage(typeof(LRRApp), "Exception in GroupPropertyValue Cascading Bindings of Qualifier ID:- " + lrrSiteGrpQualifierValue.QualifierID + ",LookUpPropertiesID:- " + lrrSiteGrpQualifierValue.LookUpPropertiesID + ex.Message, Logger.Level.Debug);
                        }
                    }
                }
            //foreach(LRRSiteGroupPropertyQualifierValue lrrSiteGrpQualifierValue in lrrSiteGrpQualifierValues)
                //{

                //}
	
			}

			Symcon.BusinessObjects.TrackingController.SetTracking(true);
			
		}

		public void SetGroupPropertyValueBinding(LRRSiteGroupPropertyQualifierValues lrrSiteGrpQualifierValues)
		{
			Symcon.BusinessObjects.TrackingController.SetTracking(false);
			foreach(LRRSiteGroupPropertyQualifierValue lrrSiteGrpQualifierValue in lrrSiteGrpQualifierValues)
			{
				try
				{
					string grpID = lrrSiteGrpQualifierValue.GroupPropertyID;
					string qualifierID = lrrSiteGrpQualifierValue.QualifierID;
					string lkUpPropertiesID = lrrSiteGrpQualifierValue.LookUpPropertiesID;
					string modeID = lrrSiteGrpQualifierValue.ModeID;
					AddGroupPropertyValueBindings(grpID,qualifierID,lkUpPropertiesID,modeID);
				}
				catch(Exception ex)
				{
					Logger.LogMessage(typeof(LRRApp),"Exception in GroupPropertyValueBinding Cascading Bindings of Qualifier ID:- " + lrrSiteGrpQualifierValue.QualifierID + ",LookUpPropertiesID:- " + lrrSiteGrpQualifierValue.LookUpPropertiesID + ex.Message,Logger.Level.Debug);
				}
			}
			Symcon.BusinessObjects.TrackingController.SetTracking(true);
			
		}

		//--Added the code on Jan 27th to set the status bar panel labels
		private void SetPEStatusBar( DBInfo dbinf)
		{
			string sDatabaseFilePath = "";

			sDatabaseFilePath = dbinf.DatabaseFilePath;


			if(sDatabaseFilePath == "")
				sDatabaseFilePath =dbinf.ServerName;

				
			_mainframe.PanelUserName = loginForm.UserName;
			_mainframe.PanelDBName= dbinf.DatabaseName;
			_mainframe.PanelDBType= dbinf.DatabaseTypeStr;
			_mainframe.PanelDBPath="Server: " + sDatabaseFilePath;

		}
		private void EnCryptyPassword(LRROptions lrrOptionsObj)
		{
			int nRow = 0;
			int nTotal = 0;
			DBConnectionInfos objDBConnectionInfos = lrrOptionsObj.DataBaseConnectionInfosObj;
			nTotal = objDBConnectionInfos.Count;
			for(nRow = 0; nRow <nTotal;nRow++)
			{
				string sPWD = objDBConnectionInfos[nRow].DatabasePWD == null ? "" :  objDBConnectionInfos[nRow].DatabasePWD.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(sPWD != "")
				{
					sPWD = CryptographyUtils.EncryptedPassword(sPWD);
					objDBConnectionInfos[nRow].DatabasePWD = sPWD;
				}
			}
			
		}
		private void DecryptyPassword()
		{
			int nRow = 0;
			int nTotal = 0;
			DBConnectionInfos objDBConnectionInfos = _lrrOptions.DataBaseConnectionInfosObj;
			nTotal = objDBConnectionInfos.Count;
			for(nRow = 0; nRow <nTotal;nRow++)
			{
				string sPWD = objDBConnectionInfos[nRow].DatabasePWD == null ? "" :  objDBConnectionInfos[nRow].DatabasePWD.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				if(sPWD != "")
				{
					sPWD = CryptographyUtils.DecryptPassword(sPWD);
					objDBConnectionInfos[nRow].DatabasePWD = sPWD;
				}
			}
			
		}
		public void Terminate()
		{
			EnCryptyPassword(this.GetOptions());
			SGTXmlSerializer.SerializeAsXML(this.GetOptionFileName(),typeof(LRROptions),this.GetOptions());
			if(this.SymExcelWrapperObj != null)
			{
				this.SymExcelWrapperObj.Terminate();
			}
			
			if(this.ActiveRunControlSet != null)
			{
				//Serialize Run Options
				string filePath = Application.StartupPath + @"\Runoptions.xml";
				Symcon.Utils.XMLUtils.SGTXmlSerializer.SerializeAsXML(@filePath,typeof(RunOptions),this.RunOptionsObj,false);
			}
			
			//Commit Overrides
			this.OverridesWindow.ClearSavedCaseOverrides();
			LRROverrides objOverridesInfoToSave = LRRModel.ChildModel.Overrides.GetChanges();
			if(objOverridesInfoToSave.Count > 0)
				this.DBManagerObj.CommitCollection(objOverridesInfoToSave);

			//Commit Group Overrides
			LRRGroupOverrides objGrpOverridesInfoToSave = LRRModel.ChildModel.GroupOverrides.GetChanges();
			if(objGrpOverridesInfoToSave.Count > 0)
				this.DBManagerObj.CommitCollection(objGrpOverridesInfoToSave);

			//commit Aggregate Overrides
			LRRAggregateOverrides objAggOverridesInfoToSave = LRRModel.ChildModel.AggregateOverrides.GetChanges();
			if(objAggOverridesInfoToSave.Count>0)
					this.DBManagerObj.CommitCollection(objAggOverridesInfoToSave);

			//commit Group Aggregate Overrides
			LRRAggGroupOverrides objGrpAggOverridesInfoToSave = LRRModel.ChildModel.GroupAggOverrides.GetChanges();
			if(objGrpAggOverridesInfoToSave.Count>0)
				this.DBManagerObj.CommitCollection(objGrpAggOverridesInfoToSave);

            if (this.LoadedOffLineHistorianAssemblies.ContainsKey(OFFLINE))
            {
                LRRHistorianConnection connection = this.LoadedOffLineHistorianAssemblies[OFFLINE].HistorianConnectionObj;
                if (connection != null)
                    this.DBManagerObj.CommitObject(connection);
            }

			//Update the Login Details
			TerminateSession();
		}
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args) 
		{
			new LRRApp(args);
		}

		/// <summary>
		/// Gets the Options Object..
		/// </summary>
		/// <returns></returns>
		public LRROptions GetOptions()
		{
			return _lrrOptions;
		}

		public string GetOptionFileName()
		{
			return _appPath + optionsFile;
		}
		
		public void ApplyOverrides()
		{
			LRROverrides lrrOverrides = LRRModel.ChildModel.Overrides;
			foreach(LRROverride lrrOverride in lrrOverrides)
			{
				string siteCompPropertyID = lrrOverride.SiteComponentPropertyID;
				string modeID = lrrOverride.ModeID;
				LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(siteCompPropertyID);
				if(lrrSiteCompProperty != null)
				{
					LRRSiteComponentPropertyValue lrrSiteCompPropValue = lrrSiteCompProperty.GetValueObjectForPropertyMode(modeID);
					if(lrrSiteCompPropValue != null)
					{
						lrrSiteCompPropValue.IsOverrided = true;
						lrrSiteCompPropValue.DataConfidenceLevelID = lrrOverride.DataConfidenceLevelID;

						//Pre/Post Override Values
						lrrSiteCompPropValue.PropertyValue = ConvertUOM(lrrOverride.UOM,lrrSiteCompPropValue.GetUOMID(),lrrOverride.PostOverrideValue);
						lrrSiteCompPropValue.OverridedValue = ConvertUOM(lrrOverride.UOM,lrrSiteCompPropValue.GetUOMID(),lrrOverride.PreOverrideValue);
					}
				}
			}
		}

		/// <summary>
		/// Converts Property value from one UOM to another
		/// </summary>
		/// <param name="oldUOMValue"></param>
		/// <param name="newUOMValue"></param>
		/// <param name="propVal"></param>
		/// <returns></returns>
		private string ConvertUOM(string oldUOMValue,string newUOMValue,string propVal)
		{
			string newVal = "";
			if(propVal != null && propVal != "")
			{
				if(oldUOMValue == newUOMValue)
				{
					newVal = propVal;
				}
				else
				{
					if((oldUOMValue != null && oldUOMValue != "") &&
						(newUOMValue != null && newUOMValue != ""))
					{
                        newVal = Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility.ConvertUOM(oldUOMValue, newUOMValue, propVal, null);
					}
				}
			}
			return newVal;
		}

		public void ApplyGroupOverrides()
		{
			LRRGroupOverrides lrrGrpOverrides = LRRModel.ChildModel.GroupOverrides;
			foreach(LRRGroupOverride lrrGrpOverride in lrrGrpOverrides)
			{
				string qualifierValueID = lrrGrpOverride.SiteGroupPropertyQualifierValueID;
				LRRSiteGroupPropertyQualifierValue lrrSiteGrpQualifierValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(qualifierValueID);
				if(lrrSiteGrpQualifierValue != null)
				{
					lrrSiteGrpQualifierValue.IsOverrided = true;
					lrrSiteGrpQualifierValue.DataConfidenceLevelID = lrrGrpOverride.DataConfidenceLevelID;

					//Pre/Post Override Values
					lrrSiteGrpQualifierValue.PropertyValue = ConvertUOM(lrrGrpOverride.UOM,lrrSiteGrpQualifierValue.GetUOMID(),lrrGrpOverride.PostOverrideValue);
					lrrSiteGrpQualifierValue.OverridedValue = ConvertUOM(lrrGrpOverride.UOM,lrrSiteGrpQualifierValue.GetUOMID(),lrrGrpOverride.PreOverrideValue);
				}
			}
		}

		public void SetPropertyHistorianBinding()
		{
			Symcon.BusinessObjects.TrackingController.SetTracking(false);
			
			//Clear all bindings
			_bindingManager.RemoveBinding();
			
			//Check for Binding for Mode Slots
			if(!CheckForBinding("1"))
				return;
			
			LRRHistPropCompPropMappings maps = new LRRHistPropCompPropMappings();
			maps = LRRModel.HistPropMaps;
			//_dbManager.PopulateCollection(maps,false);
			//LRRHistDatas hisDatas = (LRRHistDatas)LRRDataStoreObj.GetDataStoreObject(typeof(LRRHistDatas));
			//Set the Model HistPropCompMapping
			LRRModel.ChildModel.HistPropCompPropMappings = maps;

			//Populate from Model
			LRRHistDatas hisDatas = LRRModel.HistDatas;
			
			LRRHistPropCompPropMappings histMaps = null;
			//If the run is online
//			if(this.ActiveRunControlSet.DataSourceType == "Online")
            

			if(!this.GetOptions().EnablePET)
				histMaps = maps.GetLatestMappings();
			else
			{
				//DateTime dtPET = this.ActiveRunControlSet.DataWindowObj.StartTime;
                DateTime dtPET = this.ActiveRunControlSet.DataWindowObj.StartTime;

                    //DateTime.Parse(this.ActiveRunControlSet.DataWindowObj.StartTime, Symcon.BusinessObjects.SymConverter.Culture);
				histMaps = maps.GetMappingsWithPET(dtPET);
			}

            _histPropHashforHandlingPET.Clear();
			_histPropHash.Clear();
            

			_histGroupPropHash.Clear();
			foreach(LRRHistPropCompPropMapping map in histMaps)//maps)
			{
				try
				{
					if((map.SiteComponentPropValID == null) || (map.SiteComponentPropValID == ""))
					{
						//Its a group prop
						if((map.GroupPropertyValID != null) && (map.GroupPropertyValID != ""))
						{

							LRRSiteGroupPropertyQualifierValue val =  LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(map.GroupPropertyValID);
							LRRHistData hist = hisDatas.GetHistDataFromHistTagUID(map.HistPropID);//hisDatas[map.HistTag];

							if(hist != null && val != null)
							{
								//Check for Overrides
								LRRGroupOverride lrrModelOverride = LRRModel.ChildModel.GroupOverrides.GetOverrideObjectByValueID(val.SiteGroupPropertyQualifierValueID);
								if(lrrModelOverride != null)
								{
									_bindingManager.AddBinding(hist,"InterfaceValue",val,"OverridedValue");
								}
								else
								{
									_bindingManager.AddBinding(hist,"InterfaceValue",val,"PropertyValue",false);
                                    //_bindingManager.AddBinding(hist, "TimeStamp", val, "TimeStamp");
								}
								_histGroupPropHash.Add(val.SiteGroupPropertyQualifierValueID,hist);
							}
						}
					}
					else
					{
						//its a simple property
						//LRRSiteComponentPropertyValue val =  LRRModel.PropertyValuesObj.FindBySiteComponentPropID(map.SiteComponentPropValID);
                        LRRSiteComponentPropertyValue val = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(map.SiteComponentPropID, "1");
						LRRHistData hist = hisDatas.GetHistDataFromHistTagUID(map.HistPropID);//hisDatas[map.HistTag];
						//if(GetOptions().
						//_bindingManager.AddBinding(hist,"SpotValue",val,"PropertyValue");
						if(hist != null && val != null)
						{
                            if (!_histPropHash.ContainsKey(val.ID))
                            {
                                //Check for Overrides
                                LRROverride lrrOverride = LRRModel.ChildModel.Overrides.GetOverrideObjectByPropertyAndModeID(val.SiteComponentPropertyID, val.ModeID);
                                if (lrrOverride != null)
                                {
                                    _bindingManager.AddBinding(hist, "InterfaceValue", val, "OverridedValue");
                                }
                                else
                                {
                                    _bindingManager.AddBinding(hist, "InterfaceValue", val, "PropertyValue", false);
                                }

                                //if (!_histPropHash.ContainsKey(val.ID))
                                //{
                                    _histPropHash.Add(val.ID, hist);
                                    LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(val.SiteComponentPropertyID);
                                    LRRHistPropCompPropMapping hMap = LRRModel.HistPropMaps.GetMapObjectByMappingID(map.MappingId);
                                    if (scp != null)
                                    {
                                        scp.HistTagID = hist.HistTagUID;
                                        //val.PropertyValue = hist.InterfaceValue;
                                    }

                                //}
                            }
						}
						else
						{
							Symcon.Utils.MessageLogger.Logger.LogMessage("Could not Create Mapping for Site Component " + map.SiteComponentPropValID + " AND " + map.HistPropID,Symcon.Utils.MessageLogger.Logger.Level.Error); 
						}

                        if (map.SiteComponentPropID != null)
                        {
                            /*
                            foreach (LRRSiteComponentPropertyValue scpv in LRRModel.PropertyValuesObj.GetPropertyValuesFromPropID(map.SiteComponentPropID))
                            {
                                if (!_histPropHashforHandlingPET.ContainsKey(scpv.ID) && scpv.ModeID == "1")
                                {
                                        _histPropHashforHandlingPET.Add(scpv.ID, hist);
                                        scpv.PropertyValue = hist.InterfaceValue;
                                        _bindingManager.AddBinding(hist, "InterfaceValue", scpv, "PropertyValue", false);
                                }
                            }
                             * */

                            _bindingManager.AddBinding(hist, "TimeStamp", val, "TimeStamp");
                        }

					}
				}
				catch(Exception ex)
				{
					Logger.LogMessage("Exception in Mapping for Site Component " + map.SiteComponentPropValID + " AND " + map.HistPropID,Symcon.Utils.MessageLogger.Logger.Level.Error); 
				}
                /*
                if (map.SiteComponentPropID != null)
                {
                    LRRHistData hist = hisDatas.GetHistDataFromHistTagUID(map.HistPropID);//hisDatas[map.HistTag];

                    foreach (LRRSiteComponentPropertyValue scpv in LRRModel.PropertyValuesObj.GetPropertyValuesFromPropID(map.SiteComponentPropID))
                    {
                        // if condition added by ashwin
                        if (scpv.ID == map.SiteComponentPropValID)
                        {
                            scpv.PropertyValue = hist.InterfaceValue;
                            _bindingManager.AddBinding(hist, "InterfaceValue", scpv, "PropertyValue", false);
                        }
                        _bindingManager.AddBinding(hist, "TimeStamp", scpv, "TimeStamp");
                    }
                }
                 * */

			}

			Symcon.BusinessObjects.TrackingController.SetTracking(true);
			

		}


        public void SetPropertyHistorianBinding(LRRHistPropCompPropMappings histPropMappings)
        {
            Symcon.BusinessObjects.TrackingController.SetTracking(false);

            //Check for Binding for Mode Slots
            if (!CheckForBinding("1"))
                return;

            LRRHistPropCompPropMappings maps = new LRRHistPropCompPropMappings();
            
            maps = LRRModel.HistPropMaps;
            //Set the Model HistPropCompMapping
            LRRModel.ChildModel.HistPropCompPropMappings = maps;

            //Populate from Model
            LRRHistDatas hisDatas = LRRModel.HistDatas;

            LRRHistPropCompPropMappings histMaps = null;
            //If the run is online
            //			if(this.ActiveRunControlSet.DataSourceType == "Online")
            if (!this.GetOptions().EnablePET)
                histMaps = histPropMappings;
            else
            {
                DateTime dtPET = this.ActiveRunControlSet.DataWindowObj.StartTime;
                histMaps = histPropMappings.GetMappingsWithPET(dtPET);
            }
            
            foreach (LRRHistPropCompPropMapping map in histMaps)//maps)
            {
                try
                {
                    LRRHistPropCompPropMapping histPropMapping = LRRModel.HistPropMaps.GetMapObjectByMappingID(map.MappingId);
                    if ((histPropMapping.SiteComponentPropValID == null) || (histPropMapping.SiteComponentPropValID == ""))
                    {
                        //Its a group prop
                        if ((histPropMapping.GroupPropertyValID != null) && (histPropMapping.GroupPropertyValID != ""))
                        {
                            LRRSiteGroupPropertyQualifierValue val = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(histPropMapping.GroupPropertyValID);
                            LRRHistData hist = hisDatas.GetHistDataFromHistTagUID(histPropMapping.HistPropID);//hisDatas[map.HistTag];

                            if (hist != null && val != null)
                            {
                                //Check for Overrides
                                LRRGroupOverride lrrModelOverride = LRRModel.ChildModel.GroupOverrides.GetOverrideObjectByValueID(val.SiteGroupPropertyQualifierValueID);
                                if (lrrModelOverride != null)
                                {
                                    _bindingManager.RemoveBinding(hist, "InterfaceValue", val);
                                    if(map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                        _bindingManager.AddBinding(hist, "InterfaceValue", val, "OverridedValue");
                                }
                                else
                                {
                                    _bindingManager.RemoveBinding(hist, "InterfaceValue", val, false);
                                    if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                        _bindingManager.AddBinding(hist, "InterfaceValue", val, "PropertyValue", false);
                                    //_bindingManager.AddBinding(hist, "TimeStamp", val, "TimeStamp");
                                }
                                if (!_histGroupPropHash.ContainsKey(val.SiteGroupPropertyQualifierValueID))
                                {
                                    if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                        _histGroupPropHash.Add(val.SiteGroupPropertyQualifierValueID, hist);
                                }
                                else
                                {
                                    _histGroupPropHash.Remove(val.SiteGroupPropertyQualifierValueID);
                                    if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                        _histGroupPropHash.Add(val.SiteGroupPropertyQualifierValueID, hist);
                                }
                            }
                        }
                    }
                    else
                    {
                        //its a simple property
                        LRRSiteComponentPropertyValue val = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(histPropMapping.SiteComponentPropValID);
                        LRRHistData hist = hisDatas.GetHistDataFromHistTagUID(histPropMapping.HistPropID);//hisDatas[map.HistTag];
                        //if(GetOptions().
                        //_bindingManager.AddBinding(hist,"SpotValue",val,"PropertyValue");
                        if (hist != null && val != null)
                        {
                            //Check for Overrides
                            LRROverride lrrOverride = LRRModel.ChildModel.Overrides.GetOverrideObjectByPropertyAndModeID(val.SiteComponentPropertyID, val.ModeID);
                            if (lrrOverride != null)
                            {
                                _bindingManager.RemoveBinding(hist, "InterfaceValue", val);
                                if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                    _bindingManager.AddBinding(hist, "InterfaceValue", val, "OverridedValue");
                            }
                            else
                            {
                                _bindingManager.RemoveBinding(hist, "InterfaceValue", val, false);
                                if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                    _bindingManager.AddBinding(hist, "InterfaceValue", val, "PropertyValue", false);
                            }
                            if (!_histPropHash.ContainsKey(val.ID))
                            {
                                if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                    _histPropHash.Add(val.ID, hist);
                            }
                            else
                            {
                                _histPropHash.Remove(val.ID);
                                if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                    _histPropHash.Add(val.ID, hist);
                            }
                        }
                        else
                        {
                            Symcon.Utils.MessageLogger.Logger.LogMessage("Could not Create Mapping for Site Component " + map.SiteComponentPropValID + " AND " + map.HistPropID, Symcon.Utils.MessageLogger.Logger.Level.Error);
                        }

                        if (histPropMapping.SiteComponentPropID != null)
                        {
                            foreach (LRRSiteComponentPropertyValue scpv in LRRModel.PropertyValuesObj.GetPropertyValuesFromPropID(map.SiteComponentPropID))
                            {
                                _bindingManager.RemoveBinding(hist, "TimeStamp", scpv);
                                if (map.ObjectState == Symcon.Globals.Enums.DBOperation.UPDATE || map.ObjectState == Symcon.Globals.Enums.DBOperation.INSERT)
                                    _bindingManager.AddBinding(hist, "TimeStamp", scpv, "TimeStamp");
                            }
                        }


                    }
                }
                catch (Exception ex)
                {
                    Logger.LogMessage("Exception in Mapping for Site Component " + map.SiteComponentPropValID + " AND " + map.HistPropID, Symcon.Utils.MessageLogger.Logger.Level.Error);
                }
            }

            Symcon.BusinessObjects.TrackingController.SetTracking(true);


        }




		/// <summary>
		/// function to bind the property value to Hostorian point
		/// </summary>
		public void SetHistorianPropertyBinding()
		{
			Symcon.BusinessObjects.TrackingController.SetTracking(false);
			
			//Clear all bindings
			_compPropHistPropBindingManager.RemoveBinding();
			
			_compPropHistPropBindingManager.BindingCalled-=new Symcon.LightRidge.PEAdvisor.DataStore.LRRBindingManager.BindingCallDel(_compPropHistPropBindingManager_BindingCalled);
			_compPropHistPropBindingManager.BindingCalled+=new Symcon.LightRidge.PEAdvisor.DataStore.LRRBindingManager.BindingCallDel(_compPropHistPropBindingManager_BindingCalled);
			//Check for Binding for Mode Slots
			/*if(!CheckForBinding("1"))
				return;*/
			
			LRRCompPropHistPropMappings maps = new LRRCompPropHistPropMappings();
			maps = LRRModel.CompPropHistPropMappings;
			 
			//Populate from Model
			LRRUserHistDatas hisDatas = LRRModel.UserHistDatas;
			
			LRRCompPropHistPropMappings histMaps = null;
			//If the run is online
			//			if(this.ActiveRunControlSet.DataSourceType == "Online")

			if(!this.GetOptions().EnablePET)
				histMaps = maps.GetLatestMappings();
			else
			{
				DateTime dtPET = this.ActiveRunControlSet.DataWindowObj.StartTime;
				histMaps = maps.GetMappingsWithPET(dtPET);
			}
			
			//_histPropHash.Clear();
			//_histGroupPropHash.Clear();
			foreach(LRRCompPropHistPropMapping map in histMaps)//maps)
			{
				try
				{
					if((map.SiteComponentPropValID == null) || (map.SiteComponentPropValID == ""))
					{
						//Its a group prop
						if((map.GroupPropertyValID != null) && (map.GroupPropertyValID != ""))
						{
							LRRSiteGroupPropertyQualifierValue val =  LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(map.GroupPropertyValID);
							LRRUserHistData hist = hisDatas.GetHistDataFromHistTagUID(map.HistPropID);//hisDatas[map.HistTag];
							string siteCompPropID= map.SiteComponentPropID;

							string groupPropID = val.GroupPropertyID;
							string lkupPropID  = val.LookUpPropertiesID;
							string qualID      = val.QualifierID;

							if(hist != null && val != null)
							{
								/*
								for(int i=0;i < LRRModel.ProjectModes.Count;i++)
								{
									LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
									LRRSiteGroupPropertyQualifierValue siteGroupPropQualValObj = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID,lkupPropID,qualID,lrrMode.ModeId);
									if(siteGroupPropQualValObj !=null)
									{								
										if(siteGroupPropQualValObj.ModeID == "1")
											_compPropHistPropBindingManager.AddBinding(siteGroupPropQualValObj,"PropertyValue",hist,"Measurement",false);
										if(siteGroupPropQualValObj.ModeID == "2")
											_compPropHistPropBindingManager.AddBinding(siteGroupPropQualValObj,"PropertyValue",hist,"SystemStatus",false);
										if(siteGroupPropQualValObj.ModeID == "3")
											_compPropHistPropBindingManager.AddBinding(siteGroupPropQualValObj,"PropertyValue",hist,"Scenario",false);
									}
								}*/
								if(val !=null)
								{								
									_compPropHistPropBindingManager.AddBinding(val,"PropertyValue",hist,"InterfaceValue",false);
								}
							}
						}
					}
					else
					{
						//its a simple property
 						LRRUserHistData hist = hisDatas.GetHistDataFromHistTagUID(map.HistPropID);//hisDatas[map.HistTag];
					 	string siteCompPropID = map.SiteComponentPropID;
						if(hist != null && siteCompPropID != null)
						{
							LRRSiteComponentPropertyValue val = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(map.SiteComponentPropValID);
							if(val != null)
							{
                                _compPropHistPropBindingManager.AddBinding(val, "PropertyValue", hist, "InterfaceValue", false);

                                /*
                                LRRHistPropCompPropMapping hMapObj = LRRModel.HistPropMaps.GetHistMapObjFromValID(val.ID);
                                if (hMapObj != null)
                                {
                                    hMapObj.HistPropID = map.HistPropID;
                                    hMapObj.HistTag = map.HistTag;
                                }
								**/
                                
							}
							/*
							LRRSiteComponentProperty lrrSiteCompProp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(siteCompPropID);
							if(lrrSiteCompProp != null)
							{
								for(int i=0;i < LRRModel.ProjectModes.Count;i++)
								{
									LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
									LRRSiteComponentPropertyValue val = lrrSiteCompProp.GetValueObjectForPropertyMode(lrrMode.ModeId);
									if(val != null)
									{
										if(val.ModeID == "1")
											_compPropHistPropBindingManager.AddBinding(val,"PropertyValue",hist,"Measurement",false);
										if(val.ModeID == "2")
											_compPropHistPropBindingManager.AddBinding(val,"PropertyValue",hist,"SystemStatus",false);
										if(val.ModeID == "3")
											_compPropHistPropBindingManager.AddBinding(val,"PropertyValue",hist,"Scenario",false);
									}
								}
							}*/

						}
						else
						{
							Symcon.Utils.MessageLogger.Logger.LogMessage("Could not Create Mapping for Site Component " + map.SiteComponentPropValID + " AND " + map.HistPropID,Symcon.Utils.MessageLogger.Logger.Level.Error); 
						}

                        if (map.SiteComponentPropID != null)
                        {
                            LRRHistData histDataObj = LRRModel.HistDatas.GetHistDataFromHistTagUID(map.HistPropID);  
                            foreach (LRRSiteComponentPropertyValue scpv in LRRModel.PropertyValuesObj.GetPropertyValuesFromPropID(map.SiteComponentPropID))
                            {
                                _bindingManager.AddBinding(histDataObj, "TimeStamp", scpv, "TimeStamp", false);
                            }
                        }
					
					}
				}
				catch(Exception ex)
				{
					Logger.LogMessage("Exception in Mapping for Site Component " + map.SiteComponentPropValID + " AND " + map.HistPropID,Symcon.Utils.MessageLogger.Logger.Level.Error); 
				}
			}

			Symcon.BusinessObjects.TrackingController.SetTracking(true);
			

		}

		public void SwapBindings(LRRSiteComponentPropertyValue lrrSiteCompPropVal,bool switchFlag)
		{
			if(_histPropHash[lrrSiteCompPropVal.ID] != null)
			{
				LRRHistData hist = _histPropHash[lrrSiteCompPropVal.ID] as LRRHistData;
				if(hist != null)
				{
					//Remove the PropertyValue Binding and Add binding to OverridedValue
					if(switchFlag)
					{
						//Remove Binding
						//_bindingManager.RemoveBinding(hist,"SpotValue",lrrSiteCompPropVal);
						_bindingManager.RemoveBinding(hist,"InterfaceValue",lrrSiteCompPropVal);
						//AddBinding
						//_bindingManager.AddBinding(hist,"SpotValue",lrrSiteCompPropVal,"OverridedValue");
						_bindingManager.AddBinding(hist,"InterfaceValue",lrrSiteCompPropVal,"OverridedValue");
					}
						//Remove the OverridedValue Binding and Add binding to PropertyValue
					else
					{
						//Remove Binding
						//_bindingManager.RemoveBinding(hist,"SpotValue",lrrSiteCompPropVal);
						_bindingManager.RemoveBinding(hist,"InterfaceValue",lrrSiteCompPropVal);

						//AddBinding
						//_bindingManager.AddBinding(hist,"SpotValue",lrrSiteCompPropVal,"PropertyValue");
						_bindingManager.AddBinding(hist,"InterfaceValue",lrrSiteCompPropVal,"PropertyValue");
					}
				}
			}
		}
		
		public void RemoveBinding(LRRSiteComponentPropertyValue lrrSiteCompPropVal)
		{
			if(_histPropHash[lrrSiteCompPropVal.ID] != null)
			{
				LRRHistData hist = _histPropHash[lrrSiteCompPropVal.ID] as LRRHistData;
				if(hist != null)
				{
					//Remove the PropertyValue Binding
					_bindingManager.RemoveBinding(hist,"InterfaceValue",lrrSiteCompPropVal);
				}
			}
		}

		public void RemoveCascadedBindings(LRRSiteComponentPropertyValue lrrSiteCompPropVal,bool switchFlag)
		{
			if(lrrSiteCompPropVal.Derivation != null)
			{
				string modeID = LRRModel.ModeCodes.GetModeIDFromDerivation(lrrSiteCompPropVal.Derivation);
				if(modeID != null)
				{
					LRRSiteComponentPropertyValue sourcelrrSiteComppropVal = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrSiteCompPropVal.SiteComponentPropertyID).GetValueObjectForPropertyMode(modeID);
				
					//Bindings in override case true
					if(switchFlag)
					{
						_cascadingBindingManager.RemoveBinding(sourcelrrSiteComppropVal,"ActualPropertyValue",lrrSiteCompPropVal);
						//Check for Binding for Mode Slots
						if(CheckForBinding(lrrSiteCompPropVal.ModeID))
							_cascadingBindingManager.AddBinding(sourcelrrSiteComppropVal,"ActualPropertyValue",lrrSiteCompPropVal,"OverridedValue");
					}
						//Bindings in override case false
					else
					{
						_cascadingBindingManager.RemoveBinding(sourcelrrSiteComppropVal,"ActualPropertyValue",lrrSiteCompPropVal);
						//Check for Binding for Mode Slots
						if(CheckForBinding(lrrSiteCompPropVal.ModeID))
							_cascadingBindingManager.AddBinding(sourcelrrSiteComppropVal,"ActualPropertyValue",lrrSiteCompPropVal,"ProxyPropertyValue");
					}
				}

			}
		}


        public void RemoveCascadedBindings(LRRAggregatePropertyValue lrrAggregatepPropVal, bool switchFlag)
        {
            if (lrrAggregatepPropVal.Derivation != null)
            {
                string modeID = LRRModel.ModeCodes.GetModeIDFromDerivation(lrrAggregatepPropVal.Derivation);
                if (modeID != null)
                {
                    LRRAggregatePropertyValue sourcelrrAggpropVal = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(lrrAggregatepPropVal.AggregateID).GetValueObjectForPropertyMode(modeID);

                    //Bindings in override case true
                    if (switchFlag)
                    {
                        _cascadingBindingManager.RemoveBinding(sourcelrrAggpropVal, "ActualPropertyValue", lrrAggregatepPropVal);
                        //Check for Binding for Mode Slots
                        if (CheckForBinding(lrrAggregatepPropVal.ModeID))
                            _cascadingBindingManager.AddBinding(sourcelrrAggpropVal, "ActualPropertyValue", lrrAggregatepPropVal, "OverridedValue");
                    }
                    //Bindings in override case false
                    else
                    {
                        _cascadingBindingManager.RemoveBinding(sourcelrrAggpropVal, "ActualPropertyValue", lrrAggregatepPropVal);
                        //Check for Binding for Mode Slots
                        if (CheckForBinding(lrrAggregatepPropVal.ModeID))
                            _cascadingBindingManager.AddBinding(sourcelrrAggpropVal, "ActualPropertyValue", lrrAggregatepPropVal, "ProxyPropertyValue");
                    }
                }
            }
        }
		

		
		public void SwapGroupPropBindings(object objPropVal,bool switchFlag)
		{
			IPropertyValue iPropVal = objPropVal as IPropertyValue;
			if(_histGroupPropHash[iPropVal.GetID()] != null)
			{
				LRRHistData hist = _histGroupPropHash[iPropVal.GetID()] as LRRHistData;
				if(hist != null)
				{
					//Remove the PropertyValue Binding and Add binding to OverridedValue
					if(switchFlag)
					{
						//Remove Binding
						//_bindingManager.RemoveBinding(hist,"SpotValue",lrrSiteCompPropVal);
						_bindingManager.RemoveBinding(hist,"InterfaceValue",objPropVal);
						//AddBinding
						//_bindingManager.AddBinding(hist,"SpotValue",lrrSiteCompPropVal,"OverridedValue");
						_bindingManager.AddBinding(hist,"InterfaceValue",objPropVal,"OverridedValue");
					}
						//Remove the OverridedValue Binding and Add binding to PropertyValue
					else
					{
						//Remove Binding
						//_bindingManager.RemoveBinding(hist,"SpotValue",lrrSiteCompPropVal);
						_bindingManager.RemoveBinding(hist,"InterfaceValue",objPropVal);

						//AddBinding
						//_bindingManager.AddBinding(hist,"SpotValue",lrrSiteCompPropVal,"PropertyValue");
						_bindingManager.AddBinding(hist,"InterfaceValue",objPropVal,"PropertyValue");
					}
				}
			}
		}

		public void RemoveGroupPropBinding(LRRSiteGroupPropertyQualifierValue siteGrpPropQualValue)
		{
			if(_histGroupPropHash[siteGrpPropQualValue.SiteGroupPropertyQualifierValueID] != null)
			{
				LRRHistData hist = _histGroupPropHash[siteGrpPropQualValue.SiteGroupPropertyQualifierValueID] as LRRHistData;
				if(hist != null)
				{
					//Remove the PropertyValue Binding
					_bindingManager.RemoveBinding(hist,"InterfaceValue",siteGrpPropQualValue);
				}
			}
		}

		public void SwapBindings(object objPropVal,bool switchFlag)
		{
			IPropertyValue iPropVal = objPropVal as IPropertyValue;
			if(_histPropHash[iPropVal.GetID()] != null)
			{
				LRRHistData hist = _histPropHash[iPropVal.GetID()] as LRRHistData;
				if(hist != null)
				{
					//Remove the PropertyValue Binding and Add binding to OverridedValue
					if(switchFlag)
					{
						//Remove Binding
						//_bindingManager.RemoveBinding(hist,"SpotValue",lrrSiteCompPropVal);
						_bindingManager.RemoveBinding(hist,"InterfaceValue",objPropVal);
						//AddBinding
						//_bindingManager.AddBinding(hist,"SpotValue",lrrSiteCompPropVal,"OverridedValue");
						_bindingManager.AddBinding(hist,"InterfaceValue",objPropVal,"OverridedValue");
					}
						//Remove the OverridedValue Binding and Add binding to PropertyValue
					else
					{
						//Remove Binding
						//_bindingManager.RemoveBinding(hist,"SpotValue",lrrSiteCompPropVal);
						_bindingManager.RemoveBinding(hist,"InterfaceValue",objPropVal);

						//AddBinding
						//_bindingManager.AddBinding(hist,"SpotValue",lrrSiteCompPropVal,"PropertyValue");
						_bindingManager.AddBinding(hist,"InterfaceValue",objPropVal,"PropertyValue");
					}
				}
			}
		}

		public void RemoveCascadedBindings(object objPropVal,Type objectType,string propertyID,string compID,bool switchFlag)
		{
			IPropertyValue iPropVal = objPropVal as IPropertyValue;
			if(iPropVal.GetDerivation() != null)
			{
				string modeID = LRRModel.ModeCodes.GetModeIDFromDerivation(iPropVal.GetDerivation());
				if(modeID != null)
				{
					object objSourcePropertyValue = LRRModel.GetPropertyValueObject(objectType,modeID,propertyID,compID);
					//Bindings in override case true
					if(switchFlag)
					{
						_cascadingBindingManager.RemoveBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal);
						//Check for Binding for Mode Slots
						if(CheckForBinding(iPropVal.GetModeID()))
							_cascadingBindingManager.AddBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal,"OverridedValue");
					}
						//Bindings in override case false
					else
					{
						_cascadingBindingManager.RemoveBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal);
						//Check for Binding for Mode Slots
						if(CheckForBinding(iPropVal.GetModeID()))
							_cascadingBindingManager.AddBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal,"ProxyPropertyValue");
					}
				}

			}
		}

		public void RemoveCascadedBindings(object objPropVal,string groupPropID,string lookUpPropID,string qualifierID,bool switchFlag)
		{
			IPropertyValue iPropVal = objPropVal as IPropertyValue;
			if(iPropVal.GetDerivation() != null)
			{
				string modeID = LRRModel.ModeCodes.GetModeIDFromDerivation(iPropVal.GetDerivation());
				if(modeID != null)
				{
					object objSourcePropertyValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID,lookUpPropID,qualifierID,modeID);
					//Bindings in override case true
					if(switchFlag)
					{
						_cascadingBindingManager.RemoveBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal);
						//Check for Binding for Mode Slots
						if(CheckForBinding(iPropVal.GetModeID()))
							_cascadingBindingManager.AddBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal,"OverridedValue");
					}
						//Bindings in override case false
					else
					{
						_cascadingBindingManager.RemoveBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal);
						//Check for Binding for Mode Slots
						if(CheckForBinding(iPropVal.GetModeID()))
							_cascadingBindingManager.AddBinding(objSourcePropertyValue,"ActualPropertyValue",objPropVal,"ProxyPropertyValue");
					}
				}

			}
		}
		
		public void AddGroupPropertyValueBindings(string groupPropID,string qualifierID,string lookUpPropID,string modeID)
		{
			if(modeID != "0" && modeID != "1")
			{
				LRRSiteGroupPropertyQualifierValue lrrSiteGrpPropQualifierValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID,lookUpPropID,qualifierID,modeID);
				if(lrrSiteGrpPropQualifierValue !=null && lrrSiteGrpPropQualifierValue.Derivation != null && (lrrSiteGrpPropQualifierValue.Direction == "1" || lrrSiteGrpPropQualifierValue.Direction == "3"))
				{
					string nextModeID = LRRModel.ModeCodes.GetModeIDFromDerivation(lrrSiteGrpPropQualifierValue.Derivation);
					if(nextModeID != null && nextModeID != modeID)
					{
						LRRSiteGroupPropertyQualifierValue sourcelrrSiteGrpPropQualifierValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID,lookUpPropID,qualifierID,nextModeID);

						//if(sourcelrrSiteGrpPropQualifierValue.IsOverrided)
						if(lrrSiteGrpPropQualifierValue.IsOverrided)
						{
							_cascadingBindingManager.RemoveBinding(sourcelrrSiteGrpPropQualifierValue,"ActualPropertyValue",lrrSiteGrpPropQualifierValue);
							//Check for Binding for Mode Slots
							if(CheckForBinding(lrrSiteGrpPropQualifierValue.ModeID))
								_cascadingBindingManager.AddBinding(sourcelrrSiteGrpPropQualifierValue,"ActualPropertyValue",lrrSiteGrpPropQualifierValue,"OverridedValue");
						}
						//Bindings in override case false
						else
						{
							_cascadingBindingManager.RemoveBinding(sourcelrrSiteGrpPropQualifierValue,"ActualPropertyValue",lrrSiteGrpPropQualifierValue);
							//Check for Binding for Mode Slots
							if(CheckForBinding(lrrSiteGrpPropQualifierValue.ModeID))
								_cascadingBindingManager.AddBinding(sourcelrrSiteGrpPropQualifierValue,"ActualPropertyValue",lrrSiteGrpPropQualifierValue,"ProxyPropertyValue");
						}

						//AddBinding
//						_cascadingBindingManager.AddBinding(sourcelrrSiteGrpPropQualifierValue,"ActualPropertyValue",lrrSiteGrpPropQualifierValue,"ProxyPropertyValue");
					}
				}
                if (lrrSiteGrpPropQualifierValue != null && lrrSiteGrpPropQualifierValue.Derivation != null && (lrrSiteGrpPropQualifierValue.Direction == "2"))
                {
                    string nextModeID = LRRModel.ModeCodes.GetModeIDFromDerivation(lrrSiteGrpPropQualifierValue.Derivation);
                    if (nextModeID != null && nextModeID != modeID)
                    {
                        LRRSiteGroupPropertyQualifierValue sourcelrrSiteGrpPropQualifierValue = LRRModel.SiteGroupPropertyQualifierValuesObj.GetQualifierValueObjectForPropertyMode(groupPropID, lookUpPropID, qualifierID, nextModeID);

                        _cascadingBindingManager.RemoveBinding(sourcelrrSiteGrpPropQualifierValue, "ActualPropertyValue", lrrSiteGrpPropQualifierValue);
                    }
                }
			}
		}

		public void AddPropertyValueBindings(LRRSiteComponentProperty lrrSiteCompProp)
		{
			for(int i=0;i < LRRModel.ProjectModes.Count;i++)
			{
				LRRMode lrrMode = LRRModel.ProjectModes[i] as LRRMode;
				LRRSiteComponentPropertyValue lrrSiteCompPropValue = lrrSiteCompProp.GetValueObjectForPropertyMode(lrrMode.ModeId);
				if(lrrMode.ModeId != "0" && lrrMode.ModeId != "1")
				{
					if(lrrSiteCompPropValue !=null && lrrSiteCompPropValue.Derivation != null && (lrrSiteCompPropValue.Direction == "1" || lrrSiteCompPropValue.Direction == "3"))
					{
						string modeID = LRRModel.ModeCodes.GetModeIDFromDerivation(lrrSiteCompPropValue.Derivation);
						if(modeID != null)
						{
							LRRSiteComponentPropertyValue sourcelrrSiteCompPropValue = lrrSiteCompProp.GetValueObjectForPropertyMode(modeID) as LRRSiteComponentPropertyValue;

							//Bindings in override case true
							//if(sourcelrrSiteCompPropValue.IsOverrided)
							if(lrrSiteCompPropValue.IsOverrided)
							{
								_cascadingBindingManager.RemoveBinding(sourcelrrSiteCompPropValue,"ActualPropertyValue",lrrSiteCompPropValue);
								//Check for Binding for Mode Slots
								if(CheckForBinding(lrrSiteCompPropValue.ModeID))
									_cascadingBindingManager.AddBinding(sourcelrrSiteCompPropValue,"ActualPropertyValue",lrrSiteCompPropValue,"OverridedValue");
							}
								//Bindings in override case false
							else
							{
								_cascadingBindingManager.RemoveBinding(sourcelrrSiteCompPropValue,"ActualPropertyValue",lrrSiteCompPropValue);
								//Check for Binding for Mode Slots
								if(CheckForBinding(lrrSiteCompPropValue.ModeID))
									_cascadingBindingManager.AddBinding(sourcelrrSiteCompPropValue,"ActualPropertyValue",lrrSiteCompPropValue,"ProxyPropertyValue");
							}

							//AddBinding
//							_cascadingBindingManager.AddBinding(sourcelrrSiteCompPropValue,"ActualPropertyValue",lrrSiteCompPropValue,"ProxyPropertyValue");
						}
					}
                    else if (lrrSiteCompPropValue != null && lrrSiteCompPropValue.Derivation != null && (lrrSiteCompPropValue.Direction == "2"))
                    {
                        string modeID = LRRModel.ModeCodes.GetModeIDFromDerivation(lrrSiteCompPropValue.Derivation);
                        if (modeID != null)
                        {
                            LRRSiteComponentPropertyValue sourcelrrSiteCompPropValue = lrrSiteCompProp.GetValueObjectForPropertyMode(modeID) as LRRSiteComponentPropertyValue;
                            _cascadingBindingManager.RemoveBinding(sourcelrrSiteCompPropValue, "ActualPropertyValue", lrrSiteCompPropValue);
                        }

                    }
				}
			}
		}

        public void AddPropertyValueBindings(LRRSiteComponentPropertyValues lrrSiteCompPropValues)
        {
            List<string> lscpList  = new List<string>();
            foreach (LRRSiteComponentPropertyValue lscpv in lrrSiteCompPropValues)
            {
                LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lscpv.SiteComponentPropertyID);
                if (!lscpList.Contains(lscp.ID))
                {
                    AddPropertyValueBindings(lscp);
                    lscpList.Add(lscp.ID);
                }
            }
        }


		public void StartExecutionEngine()
		{
			try
			{
                string s2 = LRRMessages.GetMessageString("SID_EXECUTING") + " " + LRRMessages.GetMessageString("SID_PRE_MODEL_CALC");
                this.LRRUIManagerObj.SetMessageOnRunStatusDialog(s2.ToString(Symcon.BusinessObjects.SymConverter.Culture));

				RunControllerObj.InitiatePreCalc();
                _cascadingBindingManager.CallCascadeBindings(true, true);
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRApp),"StartExecutionEngine:"+ex.Message  ,Logger.Level.Debug);

			}
			_executionEngine.RunControlSetObj = ActiveRunControlSet;
			_executionEngine.OptionsObj = GetOptions();
			_executionEngine.SymExcelWrapperObj = _symExcelWrapper;

			string s1=LRRMessages.GetMessageString("SID_INPUT_DELOVERING");    
			this.LRRUIManagerObj.SetMessageOnRunStatusDialog(s1.ToString(Symcon.BusinessObjects.SymConverter.Culture));
			
			ProcessReadWriteDelegate processDelegate = new ProcessReadWriteDelegate(ProcessReadWrite);

			AsyncCallback callBackDelegate = new AsyncCallback(Callback);
            
			IAsyncResult rs =  processDelegate.BeginInvoke(callBackDelegate,processDelegate);

			
		}

		private void ProcessReadWrite()
		{
			ArrayList arrPropValuesTransferList = new ArrayList();
			ArrayList arrGroupPropValuesTransferList = new ArrayList();

			_executionEngine.internalExecuteWriteCycle();
			string s2=LRRMessages.GetMessageString("SID_EXEC_MODELENGINE");  
			this.LRRUIManagerObj.SetMessageOnRunStatusDialog(s2.ToString(Symcon.BusinessObjects.SymConverter.Culture));
			_executionEngine.ExecuteEntryPointMethod();
			this.LRRUIManagerObj.SetMessageOnRunStatusDialog("Model Execution Completed.");
			string s4=LRRMessages.GetMessageString("SID_OUTPUTSFROM_MODELENGINE");  
			this.LRRUIManagerObj.SetMessageOnRunStatusDialog(s4.ToString(Symcon.BusinessObjects.SymConverter.Culture));
			_executionEngine.internalExecuteReadCycle(out arrPropValuesTransferList,out arrGroupPropValuesTransferList);
			_arrValuesTransferList.Clear();
			_arrValuesTransferList.Add(arrPropValuesTransferList);
			_arrValuesTransferList.Add(arrGroupPropValuesTransferList);
            
		}

		private void Callback(IAsyncResult ar)
		{

			ProcessReadWriteDelegate processDelegate =  (ProcessReadWriteDelegate)ar.AsyncState;
			processDelegate.EndInvoke(ar);
			PostProcessReadWriteDel postDelegate = new PostProcessReadWriteDel(PostProcessReadWrite);
			MainFrame.BeginInvoke(postDelegate,null);
			RunControllerObj.EndRunCycle();
		}


		private void PostProcessReadWrite()
		{
             //commented  by ashwin. Models saving added specifically for SCT
            /*
            if (_symExcelWrapper != null)
            {
                _symExcelWrapper.SaveAllWorkBooks();
            }
             */
			ArrayList arrPropValuesTransferList = _arrValuesTransferList[0] as ArrayList;
			ArrayList arrGroupPropValuesTransferList = _arrValuesTransferList[1] as ArrayList;

            // Disable the cascading when applying the values from read cycle
            this._cascadingBindingManager.SuspendCascading = true;

            

			for(int i=0;i < arrPropValuesTransferList.Count;i++)
			{
				PropertyValueTransfer propValTransferObj = arrPropValuesTransferList[i] as PropertyValueTransfer;
				string propValueID = propValTransferObj.PropValueID;
				LRRSiteComponentPropertyValue siteCompPropValueObj = LRRModel.PropertyValuesObj.FindBySiteComponentPropID(propValueID);
				if(siteCompPropValueObj != null)
					siteCompPropValueObj.PropertyValue = propValTransferObj.PropertyValue;
			}

			for(int i=0;i < arrGroupPropValuesTransferList.Count;i++)
			{
				PropertyValueTransfer propValTransferObj = arrGroupPropValuesTransferList[i] as PropertyValueTransfer;
				string propValueID = propValTransferObj.PropValueID;
				LRRSiteGroupPropertyQualifierValue siteGroupPropQualValueObj = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(propValueID);
				if(siteGroupPropQualValueObj != null)
					siteGroupPropQualValueObj.PropertyValue = propValTransferObj.PropertyValue;
			}

            // Enable the cascading after applying the values from read cycle
            this._cascadingBindingManager.SuspendCascading = false;
			
			try
			{
                string s1 = LRRMessages.GetMessageString("SID_EXECUTING") + " " + LRRMessages.GetMessageString("SID_POST_MODEL_CALC");
                this.LRRUIManagerObj.SetMessageOnRunStatusDialog(s1.ToString(Symcon.BusinessObjects.SymConverter.Culture));

                RunControllerObj.InitiatePostCalc();
                _cascadingBindingManager.CallCascadeBindings(true, false);

                //if (ToggleRecording)
                //{
                    //RunControllerObj.SaveRecordingValues(RunControllerObj.currentStartTime, RunControllerObj.currentEndTime);
                //}
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRUIManager),"StartExecutionEngine:"+ex.Message  ,Logger.Level.Debug);
			}

			//this.LRRUIManagerObj.SetMessageOnRunStatusDialog("Completed Read Cycle.");

			//ee.WriteSingleCellValues();
			//ee.ReadSingleCellValues();
			this.LRRUIManagerObj.RefreshDataQualityGrid(false);

		}

		public void ReloadOptions()
		{
			LoadOptions();
		}


		public void RunNextStep()
		{
			if(!CheckReadIputsFromEngine())
				return;

            //string runID = SaveRunset();
			//this.Enabled = false;
			//this.panel1.Enabled = false;
			//SetControlsEnableState(this.Controls[0],false);
			if(!_runController.Start(RunTypeEnum.SINGLE_RUN_STEP_NEXT,_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex]))
			{
				//MessageBox.Show(_runController.ErroMessage);
			}
			else
			{
				_lastExecutedMethod = new LastExecutedRunDel(RunNextStep);
				LRRUIManagerObj.ShowRunStatusDialog();
//				if(GetOptions().ShowRunStatus)
//					Symcon.Utils.Alert.Messages.LRRAlert.AddAlert(Symcon.CCLibrary.Controls.MessageType.Type3,"Run Next Step Called!");
			}
		}

		public void RunEnteredWindow()
		{
			if(!CheckReadIputsFromEngine())
				return;

            //string runID = SaveRunset();
			//this.Enabled = false;
			//this.panel1.Enabled = false;
			//SetControlsEnableState(this.Controls[0],false);
			_runController.Start(RunTypeEnum.SINGLE_RUN_ENTERED_WINDOW,_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex]);
			_lastExecutedMethod = new LastExecutedRunDel(RunEnteredWindow);
			//LRRUIManagerObj.ShowRunStatusDialog();

			//if(GetOptions().ShowRunStatus)
				//Symcon.Utils.Alert.Messages.LRRAlert.AddAlert(Symcon.CCLibrary.Controls.MessageType.Type1,"Run Entered Window Called!");
		}

		public void RunAdvanceToNow()
		{
			if(!CheckReadIputsFromEngine())
				return;

            //string runID = SaveRunset();
			//this.Enabled = false;
			//this.panel1.Enabled = false;
			//SetControlsEnableState(this.Controls[0],false);
			_runController.Start(RunTypeEnum.SINGLE_RUN_ADVANCE_NOW,_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex]);
			LRRUIManagerObj.ShowRunStatusDialog();
			_lastExecutedMethod = new LastExecutedRunDel(RunAdvanceToNow);
//			if(GetOptions().ShowRunStatus)
//			Symcon.Utils.Alert.Messages.LRRAlert.AddAlert(Symcon.CCLibrary.Controls.MessageType.Type2,"Run Advance to Now Called!");
		}

		public void DoRun()
		{
            //this.ActiveRunControlSet.DataWindowObj.StartTime



			if(!CheckReadIputsFromEngine())
				return;

			if(_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].AutoRun)
			{
				//this.panel1.Enabled = false;
				//SetControlsEnableState(this.Controls[0],false);
                //string runID = SaveRunset();
				if(_runController.Start(RunTypeEnum.AUTO_RUN,_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex]))
				{
					//LRRUIManagerObj.ShowRunStatusDialog();
				}
			}
			else
			{
				if(_lastExecutedMethod != null)
				{
					_lastExecutedMethod();

					//LRRUIManagerObj.ShowRunStatusDialog();
				}
			}
        }

        #region Check For Save before save.
        public LRRSiteComponentPropertyValues RollBackPropertyValuesGSVC
        {
            get { return _rollBackPropertyValuesGSVC; }
            set { _rollBackPropertyValuesGSVC = value; }
        }
        public LRRSiteComponentPropertyValues RollBackPropertyValuesGTSVC
        {
            get { return _rollBackPropertyValuesGTSVC; }
            set { _rollBackPropertyValuesGTSVC = value; }
        }
        public Hashtable RollBackPropertyValueGSVCSettingsHash
        {
            get { return _rollBackSettingsGSVCHash; }
            set { _rollBackSettingsGSVCHash = value; }
        }
        public Hashtable RollBackPropertyValueGTSVCSettingsHash
        {
            get { return _rollBackSettingsGTSVCHash; }
            set { _rollBackSettingsGTSVCHash = value; }
        }
        public LRROverrides RollBackPVOverridesGSVC
        {
            get { return _rollBackPVOverridesGSVC; }
            set { _rollBackPVOverridesGSVC = value; }
        }
        public LRROverrides RollBackPVOverridesGTSVC
        {
            get { return _rollBackPVOverridesGTSVC; }
            set { _rollBackPVOverridesGTSVC = value; }
        }
        public LRRGroupOverrides RollBackQVOverridesGSVC
        {
            get { return _rollBackQVOverridesGSVC; }
            set { _rollBackQVOverridesGSVC = value; }
        }
        public LRRGroupOverrides RollBackQVOverridesGTSVC
        {
            get { return _rollBackQVOverridesGTSVC; }
            set { _rollBackQVOverridesGTSVC = value; }
        }

        private LRRSiteComponentPropertyValues _rollBackPropertyValuesGSVC = new LRRSiteComponentPropertyValues();
        private LRRSiteComponentPropertyValues _rollBackPropertyValuesGTSVC = new LRRSiteComponentPropertyValues();
        private ArrayList _arrRollBakcPropertyValueGSVC = new ArrayList();
        private ArrayList _arrRollBakcPropertyValueGTSVC = new ArrayList();
        public Hashtable _rollBackSettingsGSVCHash = new Hashtable();
        public Hashtable _rollBackSettingsGTSVCHash = new Hashtable();

        private LRRSiteGroupPropertyQualifierValues _rollBackQualifierValuesGSVC = new LRRSiteGroupPropertyQualifierValues();
        private ArrayList _arrRolleBackQualifierValuesGSVC = new ArrayList();
        public Hashtable _rollBackQualifierSettingsGSVCHash = new Hashtable();
        private LRRSiteGroupPropertyQualifierValues _rollBackQualifierValuesGTSVC = new LRRSiteGroupPropertyQualifierValues();
        private ArrayList _arrRolleBackQualifierValuesGTSVC = new ArrayList();
        public Hashtable _rollBackQualifierSettingsGTSVCHash = new Hashtable();

        public LRROverrides _rollBackPVOverridesGSVC = new LRROverrides();
        public LRROverrides _rollBackPVOverridesGTSVC = new LRROverrides();
        public LRRGroupOverrides _rollBackQVOverridesGSVC = new LRRGroupOverrides();
        public LRRGroupOverrides _rollBackQVOverridesGTSVC = new LRRGroupOverrides();

        public LRRSiteGroupPropertyQualifierValues RollBackQualifierValuesGSVC
        {
            get { return _rollBackQualifierValuesGSVC; }
            set { _rollBackQualifierValuesGSVC = value; }
        }
        public Hashtable RollBackQualifierValueGSVCSettingsHash
        {
            get { return _rollBackQualifierSettingsGSVCHash; }
            set { _rollBackQualifierSettingsGSVCHash = value; }
        }
        public LRRSiteGroupPropertyQualifierValues RollBackQualifierValuesGTSVC
        {
            get { return _rollBackQualifierValuesGTSVC; }
            set { _rollBackQualifierValuesGTSVC = value; }
        }
        public Hashtable RollBackQualifierValueGTSVCSettingsHash
        {
            get { return _rollBackQualifierSettingsGTSVCHash; }
            set { _rollBackQualifierSettingsGTSVCHash = value; }
        }
        
        

        public void CheckForSaveBeforeRun()
        {
            foreach (Form frm in this.MainFrame.MdiChildren)
            {
                Symcon.BusinessObjects.ILRRUIContainer cont = frm as Symcon.BusinessObjects.ILRRUIContainer;
                if (cont.PerformDirtyChk)
                {
                    try
                    {
                        foreach (Control ctl in frm.Controls)
                        {
                            CheckForSaveBeforRun(ctl, cont, frm);
                        }
                    }
                    catch
                    {

                    }
                }
            }
        }

        public bool CheckConnection()
        {
           RunControlSet  runControlSet = _runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex];
            
            bool returnVal = true;
            if (runControlSet.DataSourceType == "Offline")
            {    
                Symcon.LightRidge.Options.DBOptions.DBInfo dbinfo = _lrrOptions.TuningConnectionObj.GetActiveTuningDBInfo();
                if (LoadedOffLineHistorianAssemblies.ContainsKey(TUNNING))
                {
                    Symcon.LightRidge.HistorianConnect.IHistorian tunningHist = LoadedOffLineHistorianAssemblies[TUNNING] as Symcon.LightRidge.HistorianConnect.IHistorian;
                    tunningHist.Initialize(dbinfo);
                    if (!tunningHist.Initialized)
                    {
                        MessageBox.Show(MainFrame, "Run cannot be performed as connection to Offline Database could not be established \n Please update the connection settings and try again", "Connection Failed", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        returnVal = false;
                    }

                }
                else
                {
                    MessageBox.Show(MainFrame, "Run cannot be performed as connection to Offline Database could not be established \n Please update the connection settings and try again", "Connection Failed", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    returnVal = false;
                }
            }
            if (runControlSet.DataSourceType == "PE-Advisor Online Plant Data")
            {
                Symcon.LightRidge.Options.DBOptions.DBInfo dbinfo = _lrrOptions.OfflineConnectionObj.GetActiveOfflineDBInfo();
                if (LoadedOffLineHistorianAssemblies.ContainsKey(OFFLINE))
                {
                    Symcon.LightRidge.HistorianConnect.IHistorian tunningHist = LoadedOffLineHistorianAssemblies[OFFLINE] as Symcon.LightRidge.HistorianConnect.IHistorian;
                    tunningHist.Initialize(dbinfo);
                    if (!tunningHist.Initialized)
                    {
                        MessageBox.Show(MainFrame, "Run cannot be performed as connection to PE-Advisor Online Plant Database could not be established \n Please update the connection settings and try again", "Connection Failed", MessageBoxButtons.OK, MessageBoxIcon.Error);
                        returnVal = false;
                    }

                }
                else
                {
                    MessageBox.Show(MainFrame, "Run cannot be performed as connection to PE-Advisor Online Plant Database could not be established \n Please update the connection settings and try again", "Connection Failed", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    returnVal = false;
                }
            }
            return returnVal;
        }
        public void ProcessRollBackForQvs(LRRSiteGroupPropertyQualifierValues toSaveQvs)
        {
            foreach (LRRSiteGroupPropertyQualifierValue scQv in toSaveQvs)
            {
                LRRGroupOverride overrideobj = LRRModel.ChildModel.GroupOverrides.GetOverrideObjectByValueID(scQv.SiteGroupPropertyQualifierValueID);
                if (overrideobj != null && !RollBackQVOverridesGSVC.Contains(overrideobj) && !RollBackQVOverridesGTSVC.Contains(overrideobj))
                {
                    overrideobj.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                    this.DBManagerObj.CommitObject(overrideobj);
                    LRRModel.ChildModel.GroupOverrides.Remove(overrideobj);
                    this.RemoveCascadedBindings(scQv, scQv.GroupPropertyID, scQv.LookUpPropertiesID, scQv.QualifierID, false);
                    //_lrrApp.RemoveCascadedBindings(scQv, false);
                    scQv.SetPropertyValue(scQv.GetActualOverridedValue());
                }
                LRRSiteGroupPropertyQualifierValue siteCompQValuRollBackObj;
                LRRSiteGroupPropertyQualifierValue siteCompQValuModelObj = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(scQv.SiteGroupPropertyQualifierValueID);

                if (RollBackQualifierValueGSVCSettingsHash.Count > 0)
                {
                    if (siteCompQValuModelObj != null)
                    {
                        if (siteCompQValuModelObj.LookUpQualifierID != null && siteCompQValuModelObj.LookUpQualifierID.Trim() != "")
                        {
                            string lokUpQID = siteCompQValuModelObj.LookUpQualifierID;
                            siteCompQValuRollBackObj = RollBackQualifierValuesGSVC.GetQualifierValueObjectForPropertyMode(scQv.GroupPropertyID, scQv.LookUpPropertiesID, scQv.QualifierID, scQv.ModeID);
                                //GridSavedViewController.RollBackQValues.GetQualifierValueObjectForPropertyMode(scQv.GroupPropertyID, scQv.LookUpPropertiesID, scQv.QualifierID, scQv.ModeID);
                            if (siteCompQValuRollBackObj != null)
                            {
                                siteCompQValuModelObj = siteCompQValuRollBackObj;
                                this.RemoveCascadedBindings(scQv, siteCompQValuModelObj.GroupPropertyID, siteCompQValuModelObj.LookUpPropertiesID, siteCompQValuModelObj.QualifierID, false);
                                siteCompQValuModelObj.SetPropertyValue(siteCompQValuModelObj.GetActualOverridedValue());
                            }
                        }
                        else
                        {
                            siteCompQValuRollBackObj = RollBackQualifierValuesGSVC.GetGroupQualifierValueFromGroupPropIDandModeID(scQv.GroupPropertyID, scQv.ModeID);
                                //GridSavedViewController.RollBackQValues.GetGroupQualifierValueFromGroupPropIDandModeID(scQv.GroupPropertyID, scQv.ModeID);
                            if (siteCompQValuRollBackObj != null)
                            {
                                siteCompQValuModelObj = siteCompQValuRollBackObj;
                                this.RemoveCascadedBindings(scQv, siteCompQValuModelObj.GroupPropertyID, siteCompQValuModelObj.LookUpPropertiesID, siteCompQValuModelObj.QualifierID, false);
                                siteCompQValuModelObj.SetPropertyValue(siteCompQValuModelObj.GetActualOverridedValue());
                            }
                        }
                    }
                    siteCompQValuModelObj.RollBackChanges(true);
                    ArrayList arrRollBackSettings = RollBackQualifierValueGSVCSettingsHash[siteCompQValuModelObj] as ArrayList;
                        //hashrollbackSettings[siteCompQValuModelObj] as ArrayList;
                    if (arrRollBackSettings != null)
                    {
                        scQv.PropertyValue = arrRollBackSettings[0].ToString();
                        scQv.ActualPropertyValue = arrRollBackSettings[1].ToString();
                        scQv.ErrCode = (Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode)arrRollBackSettings[2];
                        scQv.ForeColor = (System.Drawing.Color)arrRollBackSettings[3];
                        scQv.UnderLine = (bool)arrRollBackSettings[4];
                        scQv.TrustedState = arrRollBackSettings[5].ToString();
                    }
                    scQv.IsOverrided = siteCompQValuModelObj.IsOverrided;
                    scQv.SetOverrideState(false);
                    scQv.Validate();

                }
                else if (RollBackQualifierValueGTSVCSettingsHash.Count > 0)
                {
                    if (siteCompQValuModelObj != null)
                    {
                        if (siteCompQValuModelObj.LookUpQualifierID != null && siteCompQValuModelObj.LookUpQualifierID.Trim() != "")
                        {
                            string lokUpQID = siteCompQValuModelObj.LookUpQualifierID;
                            siteCompQValuRollBackObj = RollBackQualifierValuesGTSVC.GetQualifierValueObjectForPropertyMode(scQv.GroupPropertyID, scQv.LookUpPropertiesID, scQv.QualifierID, scQv.ModeID);
                                //RollBackQualifierValuesGSVC.GetQualifierValueObjectForPropertyMode(scQv.GroupPropertyID, scQv.LookUpPropertiesID, scQv.QualifierID, scQv.ModeID);
                            //GridSavedViewController.RollBackQValues.GetQualifierValueObjectForPropertyMode(scQv.GroupPropertyID, scQv.LookUpPropertiesID, scQv.QualifierID, scQv.ModeID);
                            if (siteCompQValuRollBackObj != null)
                            {
                                siteCompQValuModelObj = siteCompQValuRollBackObj;
                                this.RemoveCascadedBindings(scQv, siteCompQValuModelObj.GroupPropertyID, siteCompQValuModelObj.LookUpPropertiesID, siteCompQValuModelObj.QualifierID, false);
                                siteCompQValuModelObj.SetPropertyValue(siteCompQValuModelObj.GetActualOverridedValue());
                            }
                        }
                        else
                        {
                            siteCompQValuRollBackObj = RollBackQualifierValuesGTSVC.GetGroupQualifierValueFromGroupPropIDandModeID(scQv.GroupPropertyID, scQv.ModeID);
                                //RollBackQualifierValuesGSVC.GetGroupQualifierValueFromGroupPropIDandModeID(scQv.GroupPropertyID, scQv.ModeID);
                            //GridSavedViewController.RollBackQValues.GetGroupQualifierValueFromGroupPropIDandModeID(scQv.GroupPropertyID, scQv.ModeID);
                            if (siteCompQValuRollBackObj != null)
                            {
                                siteCompQValuModelObj = siteCompQValuRollBackObj;
                                this.RemoveCascadedBindings(scQv, siteCompQValuModelObj.GroupPropertyID, siteCompQValuModelObj.LookUpPropertiesID, siteCompQValuModelObj.QualifierID, false);
                                siteCompQValuModelObj.SetPropertyValue(siteCompQValuModelObj.GetActualOverridedValue());
                            }
                        }
                    }
                    siteCompQValuModelObj.RollBackChanges(true);
                    ArrayList arrRollBackSettings = RollBackQualifierValueGTSVCSettingsHash[siteCompQValuModelObj] as ArrayList;
                        //RollBackQualifierValueGSVCSettingsHash[siteCompQValuModelObj] as ArrayList;
                    //hashrollbackSettings[siteCompQValuModelObj] as ArrayList;
                    if (arrRollBackSettings != null)
                    {
                        scQv.PropertyValue = arrRollBackSettings[0].ToString();
                        scQv.ActualPropertyValue = arrRollBackSettings[1].ToString();
                        scQv.ErrCode = (Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode)arrRollBackSettings[2];
                        scQv.ForeColor = (System.Drawing.Color)arrRollBackSettings[3];
                        scQv.UnderLine = (bool)arrRollBackSettings[4];
                        scQv.TrustedState = arrRollBackSettings[5].ToString();
                    }
                    scQv.IsOverrided = siteCompQValuModelObj.IsOverrided;
                    scQv.SetOverrideState(false);
                    scQv.Validate();

                }
            }
        }
        public void ProcessRollBackForPVs(LRRSiteComponentPropertyValues toSavePvs)
        {
            foreach (LRRSiteComponentPropertyValue lscpv in toSavePvs)
            {
                LRROverride overrideobj = LRRModel.ChildModel.Overrides.GetChanges().GetOverrideObjectByPropertyAndModeID(lscpv.SiteComponentPropertyID, lscpv.ModeID);
                if (overrideobj != null && !RollBackPVOverridesGSVC.Contains(overrideobj)&& !RollBackPVOverridesGTSVC.Contains(overrideobj))
                {
                    overrideobj.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                    this.DBManagerObj.CommitObject(overrideobj);
                    LRRModel.ChildModel.Overrides.Remove(overrideobj);
                    this.RemoveCascadedBindings(lscpv, false);
                    lscpv.SetPropertyValue(lscpv.GetActualOverridedValue());
                }
                if (RollBackPropertyValueGSVCSettingsHash.Count > 0)
                {
                    LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lscpv.SiteComponentPropertyID);
                    LRRSiteComponentPropertyValue lscpvChanged = LRRModel.GetPropertyValueObject(typeof(LRRSiteComponent), lscpv.ModeID, lscp.ID, lscp.ComponentID) as LRRSiteComponentPropertyValue;
                    Hashtable hashrollbackSettings = RollBackPropertyValueGSVCSettingsHash;
                    //GridSavedViewController.RollBackSettingsHash;
                    if (lscpvChanged != null)
                    {
                        LRRSiteComponentPropertyValue modelPV = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(lscpvChanged.SiteComponentPropertyID, lscpvChanged.ModeID);
                        if (modelPV != null)
                        {
                            if (RollBackPropertyValuesGSVC.Contains(modelPV))
                            {
                                LRRSiteComponentPropertyValue scpv = RollBackPropertyValuesGSVC.GetPropValueBysiteCompAndModeID(lscpvChanged.SiteComponentPropertyID, lscpvChanged.ModeID);
                                //GridSavedViewController.RollBackPropertyValues.GetPropValueBysiteCompAndModeID(lscpvChanged.SiteComponentPropertyID, lscpvChanged.ModeID);
                                if (scpv != null)
                                {
                                    lscpvChanged = scpv;
                                    this.RemoveCascadedBindings(lscpvChanged, false);
                                    lscpvChanged.SetPropertyValue(lscpvChanged.GetActualOverridedValue());
                                }

                            }
                        }
                    }
                    lscpvChanged.RollBackChanges(true);
                    ArrayList arrRollBackSettings = hashrollbackSettings[lscpvChanged] as ArrayList;
                    if (arrRollBackSettings != null)
                    {
                        lscpv.PropertyValue = arrRollBackSettings[0].ToString();
                        lscpv.ActualPropertyValue = arrRollBackSettings[1].ToString();
                        lscpv.ErrCode = (Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode)arrRollBackSettings[2];
                        lscpv.ForeColor = (System.Drawing.Color)arrRollBackSettings[3];
                        lscpv.UnderLine = (bool)arrRollBackSettings[4];
                        lscpv.TrustedState = arrRollBackSettings[5].ToString();

                    }
                    lscpv.IsOverrided = lscpvChanged.IsOverrided;
                    lscpv.SetOverrideState(false);
                    lscpv.Validate();
                }
                else if (RollBackPropertyValueGTSVCSettingsHash.Count > 0)
                {
                    LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lscpv.SiteComponentPropertyID);
                    LRRSiteComponentPropertyValue lscpvChanged = LRRModel.GetPropertyValueObject(typeof(LRRSiteComponent), lscpv.ModeID, lscp.ID, lscp.ComponentID) as LRRSiteComponentPropertyValue;
                    Hashtable hashrollbackSettings = RollBackPropertyValueGTSVCSettingsHash;
                    //GridTransposedSavedViewController.RollBackSettingsHash;
                    if (lscpvChanged != null)
                    {
                        LRRSiteComponentPropertyValue scpv = RollBackPropertyValuesGTSVC.GetPropValueBysiteCompAndModeID(lscpvChanged.SiteComponentPropertyID, lscpvChanged.ModeID);
                        //GridTransposedSavedViewController.RollBackPropertyValues.GetPropValueBysiteCompAndModeID(lscpvChanged.SiteComponentPropertyID, lscpvChanged.ModeID);
                        if (scpv != null)
                        {
                            lscpvChanged = scpv;
                            this.RemoveCascadedBindings(lscpvChanged, false);
                            lscpvChanged.SetPropertyValue(lscpvChanged.GetActualOverridedValue());
                        }
                    }
                    lscpvChanged.RollBackChanges(true);
                    ArrayList arrRollBackSettings = hashrollbackSettings[lscpvChanged] as ArrayList;
                    if (arrRollBackSettings != null)
                    {
                        lscpv.PropertyValue = arrRollBackSettings[0].ToString();
                        lscpv.ActualPropertyValue = arrRollBackSettings[1].ToString();
                        lscpv.ErrCode = (Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode)arrRollBackSettings[2];
                        lscpv.ForeColor = (System.Drawing.Color)arrRollBackSettings[3];
                        lscpv.UnderLine = (bool)arrRollBackSettings[4];
                        lscpv.TrustedState = arrRollBackSettings[5].ToString();

                    }
                    lscpv.IsOverrided = lscpvChanged.IsOverrided;
                    lscpv.SetOverrideState(false);
                    lscpv.Validate();
                }


            }
        }
        public void ProcessRollbackforPVOverrides(LRROverrides pvoverrides)
        {
            foreach (LRROverride ovrd in pvoverrides)
            {
                LRROverride overrideobj = LRRModel.ChildModel.Overrides.GetOverrideObjByID(ovrd.ID);
                //GridSavedViewController.RollBackPVOverrides.GetOverrideObjByID(pvoverrides);
                //LRRModel.ChildModel.Overrides.GetChanges().GetOverrideObjectByPropertyAndModeID(lscpv.SiteComponentPropertyID, lscpv.ModeID);
                if (overrideobj != null)
                {
                    LRRSiteComponentPropertyValue scpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(overrideobj.SiteComponentPropertyID, overrideobj.ModeID);
                    if (scpv != null)
                    {
                        scpv.SetOverrideState(true);
                        //scpv.SetOverrideValue(overrideobj.PostOverrideValue);
                        //scpv.OverridedValue = overrideobj.PostOverrideValue;
                        scpv.PropertyValue = overrideobj.PostOverrideValue;
                        scpv.IsOverrided = true;
                        scpv.Validate();
                        if (!LRRModel.ChildModel.Overrides.Contains(overrideobj))
                        {
                            LRRModel.ChildModel.Overrides.Add(overrideobj);
                        }
                    }
                }
            }
        }
        public void ProcessRollBackforQVOverrides(LRRGroupOverrides qvOverrides)
        {
            foreach (LRRGroupOverride groupeOverride in qvOverrides)
            {
                LRRGroupOverride grpOverrideobj = LRRModel.ChildModel.GroupOverrides.GetOverrideObjectByValueID(groupeOverride.SiteGroupPropertyQualifierValueID);
                if (grpOverrideobj != null)
                {
                    LRRSiteGroupPropertyQualifierValue scGQV = LRRModel.SiteGroupPropertyQualifierValuesObj.GetSiteCompGroupPropFracValFromID(grpOverrideobj.SiteGroupPropertyQualifierValueID);
                    if (scGQV != null)
                    {
                        scGQV.SetOverrideState(true);
                        scGQV.PropertyValue = grpOverrideobj.PostOverrideValue;
                        scGQV.IsOverrided = true;
                        scGQV.Validate();

                        if (!LRRModel.ChildModel.GroupOverrides.Contains(grpOverrideobj))
                        {
                            LRRModel.ChildModel.GroupOverrides.Add(grpOverrideobj);
                        }

                    }
                }
            }
        }

        private void CheckForSaveBeforRun(Control ctl, Symcon.BusinessObjects.ILRRUIContainer container, Form frm)
        {
            Symcon.BusinessObjects.ILRRUIContainer cont = frm as Symcon.BusinessObjects.ILRRUIContainer;
            try
            {
                string formName = frm.Text;
                string formType = frm.GetType().ToString();
                if (container.GetType() == typeof(Symcon.LightRidge.PEAdvisor.CommonViews.SavedViewForm))
                {
                    string[] sLabelId = new string[1];
                    sLabelId[0] = formName;
                    Symcon.LightRidge.PEAdvisor.CommonViews.SavedViewForm objSavedViewForm = frm as Symcon.LightRidge.PEAdvisor.CommonViews.SavedViewForm;

                    if (CommonViews.SavedViewForm.BPropertyValChanged == true)
                    {
                        objSavedViewForm.CheckForChanges(frm,true);
                        CommonViews.SavedViewForm.BPropertyValChanged = false;
                    }
                }
                else if (container.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesView))
                {
                    string[] sLabelId = new string[1];
                    sLabelId[0] = formName;
                    Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesView objGroupedPIA = frm as Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesView;
 
                    if (GroupProperties.GroupedPlantPropertiesView.BPropertyValChanged == true)
                    {
                        GridCheckForViewChanges.CheckForViewChanges(objGroupedPIA.IsChanged, null, objGroupedPIA.gridView, frm, null, null, false, null, null, null, null,true);
                        GroupProperties.GroupedPlantPropertiesView.BPropertyValChanged = false;
                    }
                }
                else if (container.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantDataArrayView))
                {
                    string[] sLabelId = new string[1];
                    sLabelId[0] = formName;
                    Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantDataArrayView objGroupedPlantDAV = frm as Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantDataArrayView;

                    if (GroupProperties.GroupedPlantDataArrayView.BPropertyValChanged == true)
                    {
                        GridCheckForViewChanges.CheckForViewChanges(objGroupedPlantDAV.IsChanged, null, objGroupedPlantDAV.gridView, frm, null, null, false, null, null, null, null,true);
                        GroupProperties.GroupedPlantDataArrayView.BPropertyValChanged = false;
                        
                    }
                }
                else if (container.GetType() == typeof(Symcon.LightRidge.PEAdvisor.IOScreen.InputOutputViews))
                {
                    string[] sLabelId = new string[1];
                    sLabelId[0] = formName;
                    Symcon.LightRidge.PEAdvisor.IOScreen.InputOutputViews objIOViews = frm as Symcon.LightRidge.PEAdvisor.IOScreen.InputOutputViews;
                    
                    if (IOScreen.InputOutputViews.BPropertyValChanged == true)
                    {
                        objIOViews.CheckForIOViewsChanges(frm,true);
                        IOScreen.InputOutputViews.BPropertyValChanged = false;
                    }
                }
                else if (container.GetType() == typeof(Symcon.LightRidge.PEAdvisor.CommonViews.UnifiedViewResultForm))
                {
                    string[] sLabelId = new string[1];
                    sLabelId[0] = formName;
                    CommonViews.UnifiedViewResultForm objUnifiedViewRF = frm as CommonViews.UnifiedViewResultForm;
                    if (Symcon.LightRidge.PEAdvisor.CommonViews.UnifiedViewResultForm.BUnifiedResultFormChange == true)
                    {
                        DialogResult k = LRRMessagBox.ShowMessage("SID_UNSAVED_FORM", "SID_LABEL", sLabelId, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                        if (k == DialogResult.Yes)
                        {
                            objUnifiedViewRF.Save();
                        }// no part added by ashwin
                        else 
                        {
                            /*
                            LRRSiteComponentPropertyValues toSavePVsinUV = RollBackPropertyValuesGSVC;
                            LRRSiteComponentPropertyValues toSavePVsinTUV = RollBackPropertyValuesGTSVC;
                            ProcessRollBackForPVs(toSavePVsinUV);
                            ProcessRollBackForPVs(toSavePVsinTUV);

                            LRRSiteGroupPropertyQualifierValues toSaveQVsinUV = RollBackQualifierValuesGSVC;
                            LRRSiteGroupPropertyQualifierValues toSaveQVsinTUV = RollBackQualifierValuesGTSVC;
                            ProcessRollBackForQvs(toSaveQVsinUV);
                            ProcessRollBackForQvs(toSaveQVsinTUV);


                            LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                            LRROverrides toSavePVOverridesinUV = RollBackPVOverridesGSVC;
                            LRROverrides toSavePVOverridesinTUV = RollBackPVOverridesGTSVC;
                            ProcessRollbackforPVOverrides(toSavePVOverridesinUV);
                            ProcessRollbackforPVOverrides(toSavePVOverridesinTUV);
                            LRRGroupOverrides toSaveGroupOverridesinUV = RollBackQVOverridesGSVC;
                            LRRGroupOverrides toSaveGroupOverridesinTUV = RollBackQVOverridesGTSVC;
                            ProcessRollBackforQVOverrides(toSaveGroupOverridesinUV);
                            ProcessRollBackforQVOverrides(toSaveGroupOverridesinTUV);

                            LRRModel.PropertyValuesObj.RefreshCollection();
                            LRRModel.SiteGroupPropertyQualifierValuesObj.RefreshCollection();
                            LRRModel.ChildModel.GroupOverrides.RefreshCollection();
                            LRRModel.ChildModel.Overrides.RefreshCollection();
                            RollBackQualifierValuesGSVC.Clear();
                            RollBackQualifierValuesGTSVC.Clear();
                            RollBackPropertyValuesGSVC.Clear();
                            RollBackPropertyValuesGTSVC.Clear();
                            RollBackPVOverridesGSVC.Clear();
                            RollBackPVOverridesGTSVC.Clear();
                            RollBackQVOverridesGSVC.Clear();
                            RollBackQVOverridesGTSVC.Clear();
                            */
                        }
                        Symcon.LightRidge.PEAdvisor.CommonViews.UnifiedViewResultForm.BUnifiedResultFormChange = false;

                    }
                }
                else if (container.GetType() == typeof(Symcon.LightRidge.PEAdvisor.IOScreen.ResultForm))
                {
                    string[] sLabelId = new string[1];
                    sLabelId[0] = formName;
                    if (Symcon.LightRidge.PEAdvisor.IOScreen.ResultForm.BIOViewsResultFormChange == true)
                    {
                        IOScreen.ResultForm objIOViewsResultForm = frm as IOScreen.ResultForm;
                        DialogResult k = LRRMessagBox.ShowMessage("SID_UNSAVED_FORM", "SID_LABEL", sLabelId, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                        if (k == DialogResult.Yes)
                        {
                            objIOViewsResultForm.Save();
                        }
                        Symcon.LightRidge.PEAdvisor.IOScreen.ResultForm.BIOViewsResultFormChange = false;
                    }
                }
                else if (container.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesResultForm))
                {
                    string[] sLabelId = new string[1];
                    sLabelId[0] = formName;
  
                    Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesResultForm objGroupedPlnPropsResultForm = frm as GroupProperties.GroupedPlantPropertiesResultForm;
                    
                    if (objGroupedPlnPropsResultForm.GridView.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridQualifierViewController) && Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesResultForm.BGroupedPlantPropertiesResultFormChange == true)
                    {
                        DialogResult k = LRRMessagBox.ShowMessage("SID_UNSAVED_FORM", "SID_LABEL", sLabelId, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                        if (k == DialogResult.Yes)
                        {
                            objGroupedPlnPropsResultForm.Save();
                        }
                        GroupProperties.GroupedPlantPropertiesResultForm.BGroupedPlantPropertiesResultFormChange = false;
                    }
                    else if (objGroupedPlnPropsResultForm.GridView.GetType() == typeof(Symcon.LightRidge.PEAdvisor.GroupProperties.GridDataArrayViewController) && Symcon.LightRidge.PEAdvisor.GroupProperties.GroupedPlantPropertiesResultForm.BGroupedPlantPropertiesDataArrayResultFormChange == true)
                    {
                        DialogResult k = LRRMessagBox.ShowMessage("SID_UNSAVED_FORM", "SID_LABEL", sLabelId, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                        if (k == DialogResult.Yes)
                        {
                            objGroupedPlnPropsResultForm.Save();
                        }
                        GroupProperties.GroupedPlantPropertiesResultForm.BGroupedPlantPropertiesDataArrayResultFormChange = false;
                    }
                }
                else
                {
                    if (ctl.GetType() == typeof(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl))
                    {

                        Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl ggc = ctl as Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl;
                        //Form frm =  ggc.FindForm();
                        if (GridChangedRecordLists.GetInstance().Count > 0)
                        {
                            IEnumerator ieNumChangedRecordLists = GridChangedRecordLists.GetInstance().GetEnumerator();
                            while (ieNumChangedRecordLists.MoveNext())
                            {
                                string recordScreenName = ((GridChangedRecord)(ieNumChangedRecordLists.Current)).ScreenName.ToString();
                                if (frm.Text == recordScreenName)
                                {
                                    if (((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList != null && ((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList.Count != 0)
                                    {
                                        string[] sLabelId = new string[1];
                                        sLabelId[0] = recordScreenName;

                                        if (((GridChangedRecord)(ieNumChangedRecordLists.Current)).ChangedRecordList.Count > 0)
                                        {
                                            DialogResult k = LRRMessagBox.ShowMessage("SID_UNSAVED_FORM", "SID_LABEL", sLabelId, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button3);
                                            if (k == DialogResult.Yes)
                                            {
                                                container.Save();
                                                GridChangedRecordLists.GetInstance().Remove(recordScreenName);
                                            }
                                            else
                                            {
                                                RollBackChangesDel rollBackDel = new RollBackChangesDel(RollBackAllChanges);
                                                IAsyncResult result = rollBackDel.BeginInvoke(ggc, null, null);
                                                while (!result.IsCompleted)
                                                {
                                                    Application.DoEvents();
                                                    System.Threading.Thread.Sleep(10);
                                                }
                                                ggc.Refresh();
                                                rollBackDel.EndInvoke(result);
                                                //call function to remove the items in the GridChangedRecordLists 
                                                GridChangedRecordLists.GetInstance().Remove(formName);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {

            }
            foreach (Control innerCtl in ctl.Controls)
            {
                CheckForSaveBeforRun(innerCtl, cont, frm);
            }


        }

		  private void RollBackAllChanges(Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl ggc)
        {
            Symcon.LightRidge.PEAdvisor.GridUtilities.SyncGridUtilities.RollBackChanges(ggc,true);
        }

        #endregion

        //		public void SetReadInputFromEngineState(bool state)
//		{
//			Options opt = LRRUIManagerObj.GetOptionsWindow();
//			if(opt != null && opt.IsDisposed != true)
//			{
//				opt.SetInputReadState(state);
//			}
//		}
		#endregion

		#region Events

		public event EventHandler  ReconnectCompleted;

		#endregion

		#region Overrides

		#endregion

		#region Event Handlers
		private void loginTimer_Tick(object sender)
		{
			UpdateSession();
		}
		
		#endregion

		#region Private Properties

		#endregion

		#region Private Methods
		
		/// <summary>
		/// This method loads the options for  the LRR App.
		/// </summary>
		/// <returns>true in success else false</returns>
		private bool LoadOptions()
		{
			try
			{
				/*_lrrProjOptions = SGTXmlSerializer.DeserializeXML(projOptionsFile,typeof(LRRProjectOptions)) as LRRProjectOptions;
				int nSelectedIndex = this._lrrProjOptions.SelectedIndex;
				ProjectInfo projInf = this._lrrProjOptions.ProjectInfosObj[nSelectedIndex];
				optionsFile = @".\config\" + projInf.OptionFilePath;*/

				_lrrOptions = SGTXmlSerializer.DeserializeXML(_appPath + optionsFile,typeof(LRROptions)) as LRROptions;

				if(_lrrOptions == null)
				{
					//LRRMessagBox.ShowMessage("SID_LOADOPTION","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Information);
					//return false;
					_lrrOptions = new LRROptions(true);
				}

                _lrrOptions.LoadDefaultFormats();

				//Deserialize Version Info
				_lrrVersionInfo = SGTXmlSerializer.DeserializeXML(_appPath + versionFile,typeof(LRRVersionInfo)) as LRRVersionInfo;
				if(_lrrVersionInfo == null)
				{
					return false;
				}

				int nSelectedIndex = this._lrrOptions.SelectedDBIndex;
				if(_lrrOptions.DataBaseConnectionInfosObj.Count > 0)
				{
					DBInfo dbinf = this._lrrOptions.DataBaseConnectionInfosObj[nSelectedIndex];
					if(dbinf.DatabaseFilePath.StartsWith(@".\"))
					{
						dbinf.DatabaseFilePath =  dbinf.DatabaseFilePath.Replace(@".\",_appPath + @"\");//Application.StartupPath + @"\");
					}
					DecryptyPassword();
				}
				if(_lrrOptions.HistTextCollection != null)
				{
					string[] histTexts = _lrrOptions.HistTextCollection;
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts = new ArrayList();
					foreach(string histText in histTexts)
					{
						Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add(histText);
					
					}
				}
				/*
				else
				{
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts = new ArrayList();
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("ON");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("OFF");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("LOW");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("MED");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("HIGH");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("SLOW");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("RUNNING");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("STOPPED");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("NO");
					Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Add("YES");
					_lrrOptions.HistTextCollection = new string[Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Count];
					for(int i=0;i<Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts.Count;i++)
					{
						_lrrOptions.HistTextCollection[i] = Symcon.LightRidge.HistorianConnect.HistorianUtilities.ArrHistTexts[i].ToString();
					}
				}*/
				return true;
			}
			catch(Exception ex)
			{
				Logger.LogMessage(typeof(LRRUIManager),"ShowWindow:"+ex.Message  ,Logger.Level.Debug);
				return false;
			}

		}


		public string SaveRunset()
		{
			string runID = null;
			if(_runOptionsObj.RunControlSetsObj[_runOptionsObj.SelectedRunControlIndex].RecordValues)
			{
                #region Old Implementation.
                //runID = this.RecordingValuesManagerObj.RunRecordID;
                //if(runID == null)
                //{
                //    runID = Guid.NewGuid().ToString();
                //    LRRRunRecord lrrRunRecord = new LRRRunRecord();
                //    lrrRunRecord.RunID = runID;
                //    lrrRunRecord.RunName = this.RecordingValuesManagerObj.RunRecordName;//sRunForm.name;
                //    lrrRunRecord.RunDescription = this.RecordingValuesManagerObj.RunRecordDesc;//sRunForm.desc;
                //    lrrRunRecord.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                //    this.RecordingValuesManagerObj.CommitObject(lrrRunRecord);
                //} 
                #endregion

                //RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords, " where RunSetID = '" + _runset.RunID + "'");
                //RecordingValuesManagerObj.PopulateCollection(_lrrRunRecords, " where RunSetID = '" + _runset.RunID + "'");

                LRRRunSets lrrrunsets = new LRRRunSets();
                LRRRunSet runsetobj = new LRRRunSet();
                RecordingValuesManagerObj.PopulateCollection((lrrrunsets), " where RunName = '" + this.RecordingValuesManagerObj.RunRecordName + "'");
                //DBManagerObj.PopulateObject(runsetobj, null,"where RunName = '" + this.RecordingValuesManagerObj.RunRecordName + "'");

                if ((lrrrunsets.Count == 0))
                {
                    runID = this.RecordingValuesManagerObj.RunRecordID;
                    if (runID == null)
                    {
                        runID = Guid.NewGuid().ToString();
                        LRRRunSet lrrRunSetObject = new LRRRunSet();
                        lrrRunSetObject.RunID = runID;
                        lrrRunSetObject.UserID = _lrrLogin.UserID;
                        lrrRunSetObject.RunName = this.RecordingValuesManagerObj.RunRecordName;//sRunForm.name;
                        //lrrRunRecord.RunDescription = this.RecordingValuesManagerObj.RunRecordDesc;//sRunForm.desc;
                        lrrRunSetObject.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                        this.RecordingValuesManagerObj.CommitObject(lrrRunSetObject);
                    }

                }
                else
                {
                    runsetobj = lrrrunsets[0];
                    return runsetobj.RunID;
                }

                /*
                runID = this.RecordingValuesManagerObj.RunRecordID;
                if (runID == null)
                {
                    runID = Guid.NewGuid().ToString();
                    LRRRunSet lrrRunSetObject = new LRRRunSet();
                    lrrRunSetObject.RunID = runID;
                    lrrRunSetObject.RunName = this.RecordingValuesManagerObj.RunRecordName;//sRunForm.name;
                    //lrrRunRecord.RunDescription = this.RecordingValuesManagerObj.RunRecordDesc;//sRunForm.desc;
                    lrrRunSetObject.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                    this.RecordingValuesManagerObj.CommitObject(lrrRunSetObject);
                } 
                */
			}
                 
			return runID;
		}

		private bool CheckReadIputsFromEngine()
		{
			if(this.GetOptions().ReadInputsFromEngine == true)
			{
				System.Windows.Forms.DialogResult dlgResult =LRRMessagBox.ShowMessage("SID_FLAG","SID_ENGINERUN",System.Windows.Forms.MessageBoxButtons.YesNo,System.Windows.Forms.MessageBoxIcon.Question); 
				if(dlgResult == System.Windows.Forms.DialogResult.No)
				{
					return false;
				}
				else 
				{
					return true;
				}
			}
			else
			{
				return true;
			}
		}


		private void UpdateSession()
		{
			_lrrLogin.CurrentDateTime = DateTime.UtcNow;
			_lrrLogin.IsLoggedIn = true;
			this.SessionDBManagerObj.CommitObject(_lrrLogin);
		}

		private void TerminateSession()
		{
			_lrrLogin.CurrentDateTime = DateTime.UtcNow;
            // publish to web commented by ashwin
            //_mainframe.PublishToWeb(true);
			_lrrLogin.IsLoggedIn = false;
			this.SessionDBManagerObj.CommitObject(_lrrLogin);
		}


		#endregion


		

		#region Fields

		private PEMainWindow					_mainframe;//Handle to the mainframe of the application..
		private LRROptions						_lrrOptions; //Options at the LRR Level...
		private LRRProjectOptions				_lrrProjOptions;		
		private DBManager						_dbManager; //Instance of the DBManager...
		private DataAdapter						_dataAdapter;//Instance of DataAdapter...
		private LRRDataStore					_lrrDataStore;
		private LRRUIManager					_uiManager;
		private string							_appLocale = "en-US";
		private string							_appLocaleID = "1";
		private string							_uid = "";
		private Symcon.LightRidge.ExcelWrapper.SymExcelWrapper	_symExcelWrapper;
		private LRRBindingManager				_bindingManager;// = new LRRBindingManager();
		private LRRBindingManager				_cascadingBindingManager;// = new LRRBindingManager();
		private int _nSelectedIndex;
		private bool _rememberPwd;
		 	
		//Run Controller
		private RunController					_runController = new RunController();

		//private Symcon.LightRidge.BusinessObjects.Utilities.UOMConversionUtility 	_uomConversionUtility;

		private string							_appPath;

        private Hashtable _histPropHashforHandlingPET = new Hashtable();
		private Hashtable						_histPropHash = new Hashtable();
		private Hashtable						_histGroupPropHash = new Hashtable();

		//Current Active RunControlSet
		private RunControlSet					_activeRunControlSet;// = new RunControlSet();
		private RunOptions						_runOptionsObj;

		private bool							_onlineHistorianSimulator;

		private	LegendDetails					_legendDetails = new LegendDetails();

		private LastExecutedRunDel				_lastExecutedMethod;

		//Recording Values Manager Instance
		private RecordingValuesManager			_recordingValuesManager;
		private bool							_isMainFrameClosingCalled = false;

		//Print Options
		private  PrintPreviewDialog _printPreviewDialog = new PrintPreviewDialog();
		private  PrintDialog		_printDialog = new PrintDialog();
		private  PageSetupDialog    _pageSetupDialog = new PageSetupDialog();

		private TimeWindow			_timeWindow;

		private OverridesWindow     _overridesWindow;

		private TransPosedView		_transPosedView;

		private System.Threading.Timer _loginTimer;
		private LRRLogin			_lrrLogin;
		
		private string				_dynamicCaseID;
		private DBManager						_dbSessionManager; //Instance of the DBManager...

		private LRRVersionInfo		_lrrVersionInfo = new LRRVersionInfo();

		LRRExecutionEngine			_executionEngine = new LRRExecutionEngine();

		private Waithandle writeWaitHandle = new Waithandle();

		private ArrayList					_arrValuesTransferList = new ArrayList();

		//Toggle Recording On/Off
		private bool		_toggleRecording = false;
		
		//Toggle Trending On/Off
		private bool		_toggleTrending = false;

		//Historian Write Map Binding Manager
		private LRRBindingManager _compPropHistPropBindingManager;

        //Graphics Managers
        private GraphicsManagers _graphicsManagers;
        //Dictionary<string, IHistorian> _loadedAssemblies = new Dictionary<string, IHistorian>();
        Dictionary<string, IHistorian> _loadedOffLineHistorianAssemblies = new Dictionary<string, IHistorian>();
        Dictionary<string, IHistorian> _loadedOnLineHistorianAssemblies = new Dictionary<string, IHistorian>();
        Hashtable _htSnapShotForRebuildWaterModel = new Hashtable();
        private AppDomain _scriptingAppDomain = null;

        public static string _westinghouseHistorianType = "Online";

        private bool _resetNamedRangesFile = false;
        private bool _resetMenus = false;
        private LRRScriptRunner _scriptRunner = null;

		#endregion

		#region Constants

		string optionsFile = @"\config\options.xml";
		string projOptionsFile = @"\config\ProjectOptions.xml";
		string versionFile = @"\config\version.xml";
	 
		#endregion
		
		public void Reconnect()
		{
			//ProgressWindow pw = new ProgressWindow();
			InitializeReconnect();

			if(ReconnectCompleted != null)
				ReconnectCompleted(this,new EventArgs());
			
			//pw.Close();
		}

        public string WestinghouseHistorianType
        {
            get
            {
                return _westinghouseHistorianType;
            }
            set
            {
                _westinghouseHistorianType = value;
            }
        }

		private void _runController_ReceivedPoint(LRRHistData point, string startTime, string endTime)
		{

		}

		private void _runController_RunCompleted(object sender, EventArgs e)
		{
            Symcon.Utils.MessageLogger.Logger.LogMessage("RUN COMPLETED",Symcon.Utils.MessageLogger.Logger.Level.Debug);
             HistorianConnect.IHistorian tuningHistorian = null;
             HistorianConnect.IHistorian onlineHistorian = null;
			if(this.ActiveRunControlSet.SaveDataSets)
			{
                if(LoadedOffLineHistorianAssemblies.ContainsKey(TUNNING))
                     tuningHistorian = LoadedOffLineHistorianAssemblies[TUNNING];

                if (tuningHistorian != null)
                {
                    //DialogResult res = LRRMessagBox.ShowMessage("SID_BACKFILL_QUESTION","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question,MessageBoxDefaultButton.Button2,MessageBoxOptions.DefaultDesktopOnly);
                    if (/*res == DialogResult.Yes*/ this.ActiveRunControlSet.BackFillDatasets)
                    {

                        tuningHistorian.BackFill(onlineHistorian, new AsyncCallback(BackFillingCompleted));
                    }
                    else
                    {
                        SetUIOnRunCompleteDel setUIDel = new SetUIOnRunCompleteDel(SetUIOnRunComplete);
                        MainFrame.Invoke(setUIDel);
                    }
                }

                else
                {
                    SetUIOnRunCompleteDel setUIDel = new SetUIOnRunCompleteDel(SetUIOnRunComplete);
                    MainFrame.Invoke(setUIDel);
                }
            }
            
            if (this.ActiveRunControlSet.SaveToOfflineHistorian)
            {
                if (LoadedOffLineHistorianAssemblies.ContainsKey(OFFLINE))
                    onlineHistorian = LoadedOffLineHistorianAssemblies[OFFLINE];
                if (onlineHistorian != null && this.ActiveRunControlSet.BackFillDatasets)
                {
                    onlineHistorian = LoadedOffLineHistorianAssemblies[OFFLINE];
                    onlineHistorian.BackFill(onlineHistorian, new AsyncCallback(BackFillingCompleted));
                }
                else
                {
                    SetUIOnRunCompleteDel setUIDel = new SetUIOnRunCompleteDel(SetUIOnRunComplete);
                    MainFrame.Invoke(setUIDel);
                }

            }
			else
			{
				//_mainframe.Text = "PE-Advisor (" + this.ActiveRunControlSet.DataWindowObj.StartTimeValue + " - " + this.ActiveRunControlSet.DataWindowObj.EndTimeValue + ")";
				SetUIOnRunCompleteDel setUIDel = new SetUIOnRunCompleteDel(SetUIOnRunComplete);
				MainFrame.Invoke(setUIDel);
			}
            CalculateRollUpValues(); 
			//Symcon.Utils.Alert.Messages.LRRAlert.AddAlert(Symcon.CCLibrary.Controls.MessageType.Type1,"Run Completed!");
		}

        public void CalculateRollUpValues()
        {
            LRRLevels levels = LRRModel.ChildModel.Levels;
            
            Hashtable RollUpLevelHash = new Hashtable();
            try
            {
                foreach (LRRLevel level in levels)
                {
                    ArrayList RollUpValuesObjects = new ArrayList();
                    LRRSiteComponents siteComps = LRRModel.SiteComponentsObj.FilterSiteComponentsByLevelID(level.LevelID);
                    foreach (LRRSiteComponent siteComp in siteComps)
                    {
                        foreach (LRRSiteComponentProperty lscp in siteComp.Properties)
                        {
                            LRRMasterProperty masterProp = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lscp.PropertyID);
                            if (masterProp != null)
                            {
                                if (masterProp.RollUpTypeID != "" && masterProp.RollUpTypeID != null)
                                {
                                    LRRRollUpType rollUpType = LRRModel.RollUpTypes.GetRollUpTypeByID(masterProp.RollUpTypeID);
                                    if (rollUpType != null)
                                    {
                                        RollUpValuesProperties rollUpValueProps = new RollUpValuesProperties();
                                        rollUpValueProps.LevelID = level.LevelID;
                                        rollUpValueProps.RollUpTypeID = rollUpType.ID;
                                        rollUpValueProps.SiteComponentPropertyID = lscp.ID;
                                        RollUpValuesObjects.Add(rollUpValueProps);
                                    }
                                }
                            }
                        }
                    }
                    RollUpLevelHash.Add(level.LevelID, RollUpValuesObjects);
                }
            }
            catch
            {

            }

            #region Rate Calulation
            try
            {
                foreach (LRRLevel level in levels)
                {
                    ArrayList rolUpValuePropsList = RollUpLevelHash[level.LevelID] as ArrayList;
                    if (rolUpValuePropsList != null)
                    {
                        if (rolUpValuePropsList.Count > 0)
                        {
                            foreach (LRRRollUpType rollUpType in LRRModel.RollUpTypes)
                            {
                                double sumOfPropValueMeas = 0;
                                double sumOfPropValueSS = 0;
                                double sumOfPropValuesScen = 0;
                                if (rollUpType.RollUpType == "FuelRate" || rollUpType.RollUpType == "SteamRate" || rollUpType.RollUpType == "PowerRate")
                                {
                                    for (int i = 0; i < rolUpValuePropsList.Count; i++)
                                    {
                                        RollUpValuesProperties rollUpValueProp = rolUpValuePropsList[i] as RollUpValuesProperties;
                                        if (rollUpValueProp.RollUpTypeID == rollUpType.ID)
                                        {
                                            LRRSiteComponentPropertyValues lscpvs = LRRModel.PropertyValuesObj.GetPropValuesCollectionByPropID(rollUpValueProp.SiteComponentPropertyID);
                                            if (lscpvs != null)
                                            {
                                                foreach (LRRSiteComponentPropertyValue lscpv in lscpvs)
                                                {
                                                    if (lscpv.ModeID == "1")
                                                    {
                                                        sumOfPropValueMeas = sumOfPropValueMeas + Convert.ToDouble(lscpv.PropertyValue);
                                                    }
                                                    else if (lscpv.ModeID == "2")
                                                    {
                                                        sumOfPropValueSS = sumOfPropValueSS + Convert.ToDouble(lscpv.PropertyValue);
                                                    }
                                                    else if (lscpv.ModeID == "3")
                                                    {
                                                        sumOfPropValuesScen = sumOfPropValuesScen + Convert.ToDouble(lscpv.PropertyValue);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    foreach (LRRMode mode in LRRModel.ProjectModes)
                                    {
                                        LRRRollUpValue rollUpValue = LRRModel.RollUpValues.GetRollUpValueObjByLevelAndRollUpTypeAndMode(level.LevelID, rollUpType.ID, mode.ModeId);
                                        if (rollUpValue != null)
                                        {
                                            if (mode.ModeId == "1")
                                            {
                                                rollUpValue.RollUpValue = sumOfPropValueMeas.ToString();
                                            }
                                            else if (mode.ModeId == "2")
                                            {
                                                rollUpValue.RollUpValue = sumOfPropValuesScen.ToString();
                                            }
                                            else if (mode.ModeId == "3")
                                            {
                                                rollUpValue.RollUpValue = sumOfPropValuesScen.ToString();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch
            {

            }
            #endregion

            #region Cost/ConsumptionIndex Calculation
            try
            {
                foreach (LRRRollUpValue rollUpValue in LRRModel.RollUpValues)
                {
                    LRRRollUpType rollUpType = LRRModel.RollUpTypes.GetRollUpTypeByID(rollUpValue.RollUpTypeID);
                    if (rollUpType != null)
                    {
                        LRRRollUpValue rateRollUpValue = null;
                        double calculatedCostValue = 0.0;
                        if (rollUpType.RollUpType == "FuelCost")
                        {
                            LRRRollUpType FuelRateType = LRRModel.RollUpTypes.GetRollUpTypeByName("FuelRate");
                            rateRollUpValue = LRRModel.RollUpValues.GetRollUpValueObjByLevelAndRollUpTypeAndMode(rollUpValue.LevelID, FuelRateType.ID, rollUpValue.ModeID);
                            if (rateRollUpValue.RollUpValue != null && rateRollUpValue.RollUpValue != "")
                            {
                                LRREffectivePrice effectivePrice = LRRModel.EffectivePrices.GetEffectivePriceObjForLevel(rollUpValue.LevelID);
                                if (effectivePrice != null)
                                {
                                    string propID = effectivePrice.FuelEffectivePriceID;
                                    if (propID != null)
                                    {
                                        LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(propID);
                                        if (lscps != null)
                                        {
                                            LRRSiteComponentPropertyValue lscpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(lscps[0].ID, rollUpValue.ModeID);
                                            if (lscpv != null)
                                            {
                                                calculatedCostValue = Convert.ToDouble(rateRollUpValue.RollUpValue) * Convert.ToDouble(lscpv.PropertyValue);
                                                rollUpValue.RollUpValue = calculatedCostValue.ToString();
                                            }
                                        }
                                    }
                                }

                            }
                        }
                        else if (rollUpType.RollUpType == "SteamCost")
                        {
                            LRRRollUpType SteamRateType = LRRModel.RollUpTypes.GetRollUpTypeByName("SteamRate");
                            rateRollUpValue = LRRModel.RollUpValues.GetRollUpValueObjByLevelAndRollUpTypeAndMode(rollUpValue.LevelID, SteamRateType.ID, rollUpValue.ModeID);
                            if (rateRollUpValue.RollUpValue != null && rateRollUpValue.RollUpValue != "")
                            {
                                LRREffectivePrice effectivePrice = LRRModel.EffectivePrices.GetEffectivePriceObjForLevel(rollUpValue.LevelID);
                                if (effectivePrice != null)
                                {
                                    string propID = effectivePrice.SteamEffectivePriceID;
                                    if (propID != null)
                                    {
                                        LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(propID);
                                        if (lscps != null)
                                        {
                                            LRRSiteComponentPropertyValue lscpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(lscps[0].ID, rollUpValue.ModeID);
                                            if (lscpv != null)
                                            {
                                                calculatedCostValue = Convert.ToDouble(rateRollUpValue.RollUpValue) * Convert.ToDouble(lscpv.PropertyValue);
                                                rollUpValue.RollUpValue = calculatedCostValue.ToString();
                                            }
                                        }
                                    }

                                }
                            }
                        }
                        else if (rollUpType.RollUpType == "PowereCost")
                        {
                            LRRRollUpType PowerRateType = LRRModel.RollUpTypes.GetRollUpTypeByName("PowerRate");
                            rateRollUpValue = LRRModel.RollUpValues.GetRollUpValueObjByLevelAndRollUpTypeAndMode(rollUpValue.LevelID, PowerRateType.ID, rollUpValue.ModeID);
                            if (rateRollUpValue.RollUpValue != null && rateRollUpValue.RollUpValue != "")
                            {
                                LRREffectivePrice effectivePrice = LRRModel.EffectivePrices.GetEffectivePriceObjForLevel(rollUpValue.LevelID);
                                if (effectivePrice != null)
                                {
                                    string propID = effectivePrice.PowerEffectivePriceID;
                                    if (propID != null)
                                    {
                                        LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(propID);
                                        if (lscps != null)
                                        {
                                            LRRSiteComponentPropertyValue lscpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(lscps[0].ID, rollUpValue.ModeID);
                                            if (lscpv != null)
                                            {
                                                calculatedCostValue = Convert.ToDouble(rateRollUpValue.RollUpValue) * Convert.ToDouble(lscpv.PropertyValue);
                                                rollUpValue.RollUpValue = calculatedCostValue.ToString();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else if (rollUpType.RollUpType == "FuelConsumptionIndex")
                        {
                            LRRRollUpType FuelRateType = LRRModel.RollUpTypes.GetRollUpTypeByName("FuelRate");
                            rateRollUpValue = LRRModel.RollUpValues.GetRollUpValueObjByLevelAndRollUpTypeAndMode(rollUpValue.LevelID, FuelRateType.ID, rollUpValue.ModeID);
                            if (rateRollUpValue.RollUpValue != null && rateRollUpValue.RollUpValue != "")
                            {
                                LRREffectivePrice effectivePrice = LRRModel.EffectivePrices.GetEffectivePriceObjForLevel(rollUpValue.LevelID);
                                if (effectivePrice != null)
                                {
                                    string propID = effectivePrice.DividingFactorID;
                                    if (propID != null)
                                    {
                                        LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(propID);
                                        if (lscps != null)
                                        {
                                            LRRSiteComponentPropertyValue lscpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(lscps[0].ID, rollUpValue.ModeID);
                                            if (lscpv != null)
                                            {
                                                calculatedCostValue = Convert.ToDouble(rateRollUpValue.RollUpValue) / Convert.ToDouble(lscpv.PropertyValue);
                                                rollUpValue.RollUpValue = calculatedCostValue.ToString();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else if (rollUpType.RollUpType == "SteamConsumptionIndex")
                        {
                            LRRRollUpType SteamRateType = LRRModel.RollUpTypes.GetRollUpTypeByName("SteamRate");
                            rateRollUpValue = LRRModel.RollUpValues.GetRollUpValueObjByLevelAndRollUpTypeAndMode(rollUpValue.LevelID, SteamRateType.ID, rollUpValue.ModeID);
                            if (rateRollUpValue.RollUpValue != null && rateRollUpValue.RollUpValue != "")
                            {
                                LRREffectivePrice effectivePrice = LRRModel.EffectivePrices.GetEffectivePriceObjForLevel(rollUpValue.LevelID);
                                if (effectivePrice != null)
                                {
                                    string propID = effectivePrice.DividingFactorID;
                                    if (propID != null)
                                    {
                                        LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(propID);
                                        if (lscps != null)
                                        {
                                            LRRSiteComponentPropertyValue lscpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(lscps[0].ID, rollUpValue.ModeID);
                                            if (lscpv != null)
                                            {
                                                calculatedCostValue = Convert.ToDouble(rateRollUpValue.RollUpValue) / Convert.ToDouble(lscpv.PropertyValue);
                                                rollUpValue.RollUpValue = calculatedCostValue.ToString();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else if (rollUpType.RollUpType == "PowerConsumptionIndex")
                        {
                            LRRRollUpType PowerRateType = LRRModel.RollUpTypes.GetRollUpTypeByName("PowerRate");
                            rateRollUpValue = LRRModel.RollUpValues.GetRollUpValueObjByLevelAndRollUpTypeAndMode(rollUpValue.LevelID, PowerRateType.ID, rollUpValue.ModeID);
                            if (rateRollUpValue.RollUpValue != null && rateRollUpValue.RollUpValue != "")
                            {
                                LRREffectivePrice effectivePrice = LRRModel.EffectivePrices.GetEffectivePriceObjForLevel(rollUpValue.LevelID);
                                if (effectivePrice != null)
                                {
                                    string propID = effectivePrice.DividingFactorID;
                                    if (propID != null)
                                    {
                                        LRRSiteComponentProperties lscps = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropsFromMasterPropertyID(propID);
                                        if (lscps != null)
                                        {
                                            LRRSiteComponentPropertyValue lscpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(lscps[0].ID, rollUpValue.ModeID);
                                            if (lscpv != null)
                                            {
                                                calculatedCostValue = Convert.ToDouble(rateRollUpValue.RollUpValue) / Convert.ToDouble(lscpv.PropertyValue);
                                                rollUpValue.RollUpValue = calculatedCostValue.ToString();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch
            {

            }

            #endregion

            LRRRollUPValues rollUpValueChanges = new LRRRollUPValues();
            rollUpValueChanges = LRRModel.RollUpValues.GetChanges();
            this.DBManagerObj.CommitCollection(rollUpValueChanges);
            LRRModel.RollUpValues.GetChanges().RefreshCollection();
        }
		
		
		private void BackFillingCompleted(IAsyncResult ar)
		{
			HistorianConnect.InternalBackFillDel del = (HistorianConnect.InternalBackFillDel)ar.AsyncState;
			del.EndInvoke(ar);
			SetUIOnRunCompleteDel setUIDel = new SetUIOnRunCompleteDel(SetUIOnRunComplete);
			MainFrame.Invoke(setUIDel);
		}


		private delegate void SetUIOnRunCompleteDel();
		private void SetUIOnRunComplete()
		{
			_uiManager.SetStopEnabled(false);
			_uiManager.SetRunningState(false);
			this._mainframe.tblRun.Enabled = true;
			this._mainframe.barItem4.Enabled = true;
			_uiManager.SetPauseSate(false);
		}

        private void TakeSnapShotForRebuildWaterModel()
        {
            // Take the snapshot for WaterModelRebuild

            _htSnapShotForRebuildWaterModel.Clear();
            foreach (LRRSiteComponentPropertyValue propValue in LRRModel.PropertyValuesObj)
            {
                LRRSiteComponentProperty scp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(propValue.GetPropertyID());
                if (scp != null)
                {
                    LRRMasterProperty mprop = LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(scp.PropertyID);
                    if (mprop != null)
                    {
                        if (LRRModel.HtRebuildWaterModelPropIds.ContainsKey(mprop.ComponentID))
                        {
                            List<string> arrRebuildWaterModelPropIds = LRRModel.HtRebuildWaterModelPropIds[mprop.ComponentID] as List<string>;
                            if (arrRebuildWaterModelPropIds.Contains(scp.PropertyID))
                            {
                                _htSnapShotForRebuildWaterModel.Add(propValue.ID, propValue.PropertyValue);
                            }
                        }
                    }
                }
            }

        }

        

		private void _runController_RunStarted(RunStartedEventArgs e)
		{

            _scriptingAppDomain = AppDomain.CreateDomain("ScriptingAppDomain");

            AssemblyName assembName = AssemblyName.GetAssemblyName(Application.StartupPath + "\\Symcon.Lightrige.ScriptRunner.dll");
            _scriptingAppDomain.Load(assembName);////"Symcon.Lightrige.ScriptRunner.dll");

            //newDomain.ExecuteAssembly(Application.StartupPath + "\\Symcon.Lightridge.ScriptingInDiffAppDomain.exe");
            System.Runtime.Remoting.ObjectHandle scriptRunnerObjectHandel = _scriptingAppDomain.CreateInstance(assembName.Name, "Symcon.Lightrige.ScriptRunner.LRRScriptRunner");
            _scriptRunner = (Symcon.Lightrige.ScriptRunner.LRRScriptRunner)scriptRunnerObjectHandel.Unwrap();

            ProcessSnapShotForRebuildWaterModelDel myDel = new ProcessSnapShotForRebuildWaterModelDel(TakeSnapShotForRebuildWaterModel);
            myDel.BeginInvoke(null, null);
          
			Symcon.Utils.MessageLogger.Logger.LogMessage("RUN CYCLE STARTED",Symcon.Utils.MessageLogger.Logger.Level.Debug);
			_uiManager.ShowRunStatusDialog();
			_uiManager.SetStopEnabled(true);
			_uiManager.SetRunningState(true);
			_uiManager.HideRunControlPanelDialog();
			this._mainframe.tblRun.Enabled = false;
			this._mainframe.barItem4.Enabled = false;
			if(_lrrOptions.GUIPreferencesObj.ClearAlertsBetweenRun)
				Symcon.Utils.Alert.Messages.LRRAlert.Clear();
            
            
		}

		
		public void UpdateOverridePoints()
		{
			Symcon.CCLibrary.Controls.StatusBar mainFrameStatusBar = MainFrame.GetStatusBar();
			InitializeOverridePoints();
			mainFrameStatusBar.SetOverridesInfo(_legendDetails);
		}

        public void UpdateAggregateOverridePoints()
        {
            Symcon.CCLibrary.Controls.StatusBar mainFrameStatusBar = MainFrame.GetStatusBar();
            InitializeAggregateOverridePoints();
            mainFrameStatusBar.SetOverridesInfo(_legendDetails);
        }
		public void UpdataGrpAggOverridePoints()
		{
			Symcon.CCLibrary.Controls.StatusBar mainFrameStatusBar = MainFrame.GetStatusBar();
           InitializeAggGroupOverridePoints();
            mainFrameStatusBar.SetOverridesInfo(_legendDetails);
		}
		public void UpdateGrpOverridePoints()
		{
			  Symcon.CCLibrary.Controls.StatusBar mainFrameStatusBar = MainFrame.GetStatusBar();
            InitializeGroupOverridePoints();
            mainFrameStatusBar.SetOverridesInfo(_legendDetails);
		}

		public void InitializeAggGroupOverridePoints()
		{
			_legendDetails.Clear();
			LRRAggGroupOverrides lrrAggGrpModelOverrides = LRRModel.ChildModel.GroupAggOverrides; 

				LRRDataConfidenceLevels objLRRDataConfidenceLevels = LRRDataStoreObj.GetDataStoreObject(typeof(LRRDataConfidenceLevels)) as LRRDataConfidenceLevels;
			if(objLRRDataConfidenceLevels != null)
			{
				if(objLRRDataConfidenceLevels.Count>0)
				{
					int nTotalUnCertain =0; //ID = 3
					int nTotalTempTrusted =0; //ID = 2
					int nTotalTrusted =0; //ID = 1
			
					string sUnCertainLabel =""; //ID = 3
					string sTempTrustedLabel =""; //ID = 2
					string sTrustedLabel =""; //ID = 1

					string sDataConfidenceLevelID = "";
			
					sDataConfidenceLevelID = "1";
					LRRDataConfidenceLevel objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
					sDataConfidenceLevelID = "2";
					objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sTempTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				
					sDataConfidenceLevelID = "3";
					objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sUnCertainLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					
					sDataConfidenceLevelID = "";

					foreach(LRRAggGroupOverride objModelOverride in lrrAggGrpModelOverrides)
					{
						sDataConfidenceLevelID = objModelOverride.DataConfidenceLevelID == null ? "0" : objModelOverride.DataConfidenceLevelID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
						switch(sDataConfidenceLevelID)
						{
							case "1" :
								nTotalTrusted = nTotalTrusted + 1;
								break;
							case "2" :
								nTotalTempTrusted = nTotalTempTrusted + 1;
								break;
							case "3" :
								nTotalUnCertain = nTotalUnCertain + 1;
								break;
							default:
								break;
						}
					}

					LegendDetail objLegDtl;

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sUnCertainLabel;
					objLegDtl.Value = nTotalUnCertain.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sTempTrustedLabel;
					objLegDtl.Value = nTotalTempTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sTrustedLabel;
					objLegDtl.Value = nTotalTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);

				}
			}

		}
		public void InitializeGroupOverridePoints()
		{
			_legendDetails.Clear();
			LRRGroupOverrides lrrGrpModelOverrides = LRRModel.ChildModel.GroupOverrides; 
			LRRDataConfidenceLevels objLRRDataConfidenceLevels = LRRDataStoreObj.GetDataStoreObject(typeof(LRRDataConfidenceLevels)) as LRRDataConfidenceLevels;
			if(objLRRDataConfidenceLevels != null)
			{
				if(objLRRDataConfidenceLevels.Count>0)
				{
					int nTotalUnCertain =0; //ID = 3
					int nTotalTempTrusted =0; //ID = 2
					int nTotalTrusted =0; //ID = 1
			
					string sUnCertainLabel =""; //ID = 3
					string sTempTrustedLabel =""; //ID = 2
					string sTrustedLabel =""; //ID = 1

					string sDataConfidenceLevelID = "";
			
					sDataConfidenceLevelID = "1";
					LRRDataConfidenceLevel objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
					sDataConfidenceLevelID = "2";
					objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sTempTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				
					sDataConfidenceLevelID = "3";
					objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sUnCertainLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					
					sDataConfidenceLevelID = "";

					foreach(LRRGroupOverride objModelOverride in lrrGrpModelOverrides)
					{
						sDataConfidenceLevelID = objModelOverride.DataConfidenceLevelID == null ? "0" : objModelOverride.DataConfidenceLevelID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
						switch(sDataConfidenceLevelID)
						{
							case "1" :
								nTotalTrusted = nTotalTrusted + 1;
								break;
							case "2" :
								nTotalTempTrusted = nTotalTempTrusted + 1;
								break;
							case "3" :
								nTotalUnCertain = nTotalUnCertain + 1;
								break;
							default:
								break;
						}
					}

					LegendDetail objLegDtl;

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sUnCertainLabel;
					objLegDtl.Value = nTotalUnCertain.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sTempTrustedLabel;
					objLegDtl.Value = nTotalTempTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sTrustedLabel;
					objLegDtl.Value = nTotalTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);
		 
				}
			} 
	}
        public void InitializeAggregateOverridePoints()
        {
            _legendDetails.Clear();
            LRRAggregateOverrides lrrAggModelOverrides = LRRModel.ChildModel.AggregateOverrides;

            LRRDataConfidenceLevels objLRRDataConfidenceLevels = LRRDataStoreObj.GetDataStoreObject(typeof(LRRDataConfidenceLevels)) as LRRDataConfidenceLevels;
            if (objLRRDataConfidenceLevels != null)
            {
                if (objLRRDataConfidenceLevels.Count > 0)
                {
                    int nTotalUnCertain = 0; //ID = 3
                    int nTotalTempTrusted = 0; //ID = 2
                    int nTotalTrusted = 0; //ID = 1

                    string sUnCertainLabel = ""; //ID = 3
                    string sTempTrustedLabel = ""; //ID = 2
                    string sTrustedLabel = ""; //ID = 1

                    string sDataConfidenceLevelID = "";

                    sDataConfidenceLevelID = "1";
                    LRRDataConfidenceLevel objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
                    sTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    sDataConfidenceLevelID = "2";
                    objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
                    sTempTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    sDataConfidenceLevelID = "3";
                    objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
                    sUnCertainLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);

                    sDataConfidenceLevelID = "";
                    //foreach (LRROverride objModelOverride in lrrModelOverrides)
                    foreach (LRRAggregateOverride objModelAggOverride in lrrAggModelOverrides)
                    {
                        sDataConfidenceLevelID = objModelAggOverride.DataConfidenceLevelID == null ? "0" : objModelAggOverride.DataConfidenceLevelID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                        objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
                        switch (sDataConfidenceLevelID)
                        {
                            case "1":
                                nTotalTrusted = nTotalTrusted + 1;
                                break;
                            case "2":
                                nTotalTempTrusted = nTotalTempTrusted + 1;
                                break;
                            case "3":
                                nTotalUnCertain = nTotalUnCertain + 1;
                                break;
                            default:
                                break;
                        }
                    }

                    LegendDetail objLegDtl;

                    objLegDtl = new LegendDetail();
                    objLegDtl.Name = sUnCertainLabel;
                    objLegDtl.Value = nTotalUnCertain.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    _legendDetails.Add(objLegDtl);

                    objLegDtl = new LegendDetail();
                    objLegDtl.Name = sTempTrustedLabel;
                    objLegDtl.Value = nTotalTempTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    _legendDetails.Add(objLegDtl);

                    objLegDtl = new LegendDetail();
                    objLegDtl.Name = sTrustedLabel;
                    objLegDtl.Value = nTotalTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    _legendDetails.Add(objLegDtl);
                }
            }
        }
		
		public void InitializeOverridePoints()
		{
			_legendDetails.Clear();
			LRROverrides lrrModelOverrides = LRRModel.ChildModel.Overrides; 
			LRRDataConfidenceLevels objLRRDataConfidenceLevels = LRRDataStoreObj.GetDataStoreObject(typeof(LRRDataConfidenceLevels)) as LRRDataConfidenceLevels;
			if(objLRRDataConfidenceLevels != null)
			{
				if(objLRRDataConfidenceLevels.Count>0)
				{
					int nTotalUnCertain =0; //ID = 3
					int nTotalTempTrusted =0; //ID = 2
					int nTotalTrusted =0; //ID = 1
			
					string sUnCertainLabel =""; //ID = 3
					string sTempTrustedLabel =""; //ID = 2
					string sTrustedLabel =""; //ID = 1

					string sDataConfidenceLevelID = "";
			
					sDataConfidenceLevelID = "1";
					LRRDataConfidenceLevel objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
			
					sDataConfidenceLevelID = "2";
					objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sTempTrustedLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				
					sDataConfidenceLevelID = "3";
					objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
					sUnCertainLabel = objLRRDataConfidenceLevel.ConfidenceLevel == null ? "" : objLRRDataConfidenceLevel.ConfidenceLevel.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					
					sDataConfidenceLevelID = "";
					foreach(LRROverride objModelOverride in lrrModelOverrides)
					{
						sDataConfidenceLevelID = objModelOverride.DataConfidenceLevelID == null ? "0" : objModelOverride.DataConfidenceLevelID.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						objLRRDataConfidenceLevel = objLRRDataConfidenceLevels.GetConfidenceLevelFromID(sDataConfidenceLevelID);
						switch(sDataConfidenceLevelID)
						{
							case "1" :
								nTotalTrusted = nTotalTrusted + 1;
								break;
							case "2" :
								nTotalTempTrusted = nTotalTempTrusted + 1;
								break;
							case "3" :
								nTotalUnCertain = nTotalUnCertain + 1;
								break;
							default:
								break;
						}
					}

					LegendDetail objLegDtl;

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sUnCertainLabel;
					objLegDtl.Value = nTotalUnCertain.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sTempTrustedLabel;
					objLegDtl.Value = nTotalTempTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);

					objLegDtl = new LegendDetail();
					objLegDtl.Name = sTrustedLabel;
					objLegDtl.Value = nTotalTrusted.ToString(Symcon.BusinessObjects.SymConverter.Culture);
					_legendDetails.Add(objLegDtl);
				}
			}
		}

		private bool CheckForBinding(string modeID)
		{
			LRRMode mode = LRRModel.ProjectModes.GetModeByID(modeID);
			ModeSlot modeSlot = this.TimeWindowObj.ModeSlotsObj.GetModeSlot(mode.ModeTypeID);			
			if(modeSlot != null && (modeSlot.Source == SourceEnum.REMOTE || modeSlot.Source == SourceEnum.LIVE))
				return false;
			else
				return true;
			
		}

		private void Application_ApplicationExit(object sender, EventArgs e)
		{
			if(!_isMainFrameClosingCalled)
				_mainframe.Close();
		}

		public string Read(string KeyName)
		{
			try
			{
				// Opening the registry key
                RegistryKey rk = Registry.LocalMachine.OpenSubKey("SOFTWARE\\LSoftPE\\{{{{C77CB689-26C1-45c7-9494-E53836AE17EB}}}}");
				if(rk == null)
				{
					//Could not find the key create one
                    RegistryKey rk1 = Registry.LocalMachine.CreateSubKey("SOFTWARE\\LSoftPE\\{{{{C77CB689-26C1-45c7-9494-E53836AE17EB}}}}");
					string val = DateTime.Now.Ticks.ToString();
					rk1.SetValue("WINDOWS_TCODE",val);
					return val;
				}
				else
				{
					try 
					{
						// If the RegistryKey exists I get its value
						// or null is returned.
						string retVal = (string)rk.GetValue("WINDOWS_TCODE");
						return retVal;

					}
					catch (Exception e)
					{
						return null;
					}
				}
			}
			catch
			{
				return null;
			}
		}

        /// <summary>
        /// Method saves the graphics for web publishing.
        /// </summary>
        public void ProcessGraphics()
        {
			  string graphicsFolderPath="";
              // viewsNotPublished  added by ashwin
              bool processFlaggingAndPublishing = false;
              bool processOnlyPublisherInformation = false;

              bool publishtoWeb = false;
              bool processCanvas = true;
            try
            {
                if (this.GetOptions().PublishGraphics && _mainframe.tlbPublishToWeb.Checked)
                {
                    publishtoWeb = true;
                }
                // check for publishing disabled for processing the flagging by ashwin
                if (this.GetOptions().PublishGraphics)
                {
                    processFlaggingAndPublishing = true;
                    if (_mainframe.tlbPublishToWeb.Checked)
                    {
                        processOnlyPublisherInformation = true;
                    }
                }
                else if (_mainframe.tlbPublishToWeb.Checked)
                {
                    processOnlyPublisherInformation = true;
                    processFlaggingAndPublishing = false;
                }
                else
                {
                    processFlaggingAndPublishing = false;
                }
                if (publishtoWeb)
                {
                    LRRWebPublisherUser webpublishUser = LRRModel.WebPublishUsers.GetWebPublishUserFromID(this.DBManagerObj.AccessControlModel.UserID);
                    if (webpublishUser == null)
                    {
                        webpublishUser = new LRRWebPublisherUser();
                        webpublishUser.PublisherName = this.DBManagerObj.AccessControlLayer.Model.UserName;
                        webpublishUser.PublisherUID = this.DBManagerObj.AccessControlLayer.Model.UserID;
                        webpublishUser.ModeID = "";
                        webpublishUser.IPAddress = System.Environment.MachineName;
                        LRRModel.WebPublishUsers.Add(webpublishUser);
                        this.DBManagerObj.CommitCollection(LRRModel.WebPublishUsers.GetChanges());
                    }

                }
                if (publishtoWeb)
                {
                    if (!Directory.Exists(this._lrrOptions.WebConfigPath))
                    {
                        System.IO.Directory.CreateDirectory(this._lrrOptions.WebConfigPath);
                    }
                }
                if (processOnlyPublisherInformation)
                {
                    //this.DBManagerObj.AccessControlModel.UserID   
                }
                    //return;


                LRRModes lrrModes = new LRRModes();
                for (int i = 1; i < LRRModel.ProjectModes.Count; i++)
                {
                    lrrModes.Add(LRRModel.ProjectModes[i]);
                }

                // hookup events called by ashwin
                _graphicsManagers = new GraphicsManagers();
                //_graphicsManagers.HookUpEvents();
                IEnumerator iEnum = LRRModel.SavedViews.GetEnumerator();
                while (iEnum.MoveNext())
                {
                    try
                    {
                        LRRSavedView lrrSavedView = iEnum.Current as LRRSavedView;

                        //LRRViewSharing viewSharing = LRRModel.ViewSharings.get
                        // changed by ashwin for publishing only the sahed views to web application
                        GraphicsManagersObj.CreateGraphicsManager(lrrSavedView.ID);
                        Canvas canvas = GraphicsManagersObj.ActiveManager.CanvasObj;
                        ProcessCanvasForFlagging(canvas);
                            //LoadPublishCanvas(lrrModes, lrrSavedView);
                        
                        LRRUserRoleMapping userRoleMap = LRRModel.UserRoleMappings.GetUserRoleMappingForUserId(this.DBManagerObj.AccessControlModel.UserID);
                        if (userRoleMap.RoleID != "1")
                        {
                            LRRViewSharing viewSharing = LRRModel.ViewSharings.GetViewSharingByRoleIDAndViewID(userRoleMap.RoleID, lrrSavedView.ID);
                            if (viewSharing != null)
                            {
                                if (publishtoWeb)
                                {
                                    string publisherFolderName = this.DBManagerObj.AccessControlLayer.Model.UserName;
                                    //check if the folder exists if not create a new one 
                                    graphicsFolderPath = this._lrrOptions.WebConfigPath + @"\" + publisherFolderName + @"\";
                                    if (!Directory.Exists(graphicsFolderPath))
                                    {
                                        System.IO.Directory.CreateDirectory(graphicsFolderPath);
                                    }
                                    Bitmap bitMapImage = canvas.ExportDiagramAsImage();
                                    bitMapImage.Save(graphicsFolderPath + canvas.FileName + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                                }
                            }
                        }
                        else
                        {
                            if (publishtoWeb)
                            {
                                string publisherFolderName = this.DBManagerObj.AccessControlLayer.Model.UserName;
                                //check if the folder exists if not create a new one 
                                graphicsFolderPath = this._lrrOptions.WebConfigPath + @"\" + publisherFolderName + @"\";
                                if (!Directory.Exists(graphicsFolderPath))
                                {
                                    System.IO.Directory.CreateDirectory(graphicsFolderPath);
                                }
                                Bitmap bitMapImage = canvas.ExportDiagramAsImage();
                                bitMapImage.Save(graphicsFolderPath + canvas.FileName + ".jpg", System.Drawing.Imaging.ImageFormat.Jpeg);
                            }
                        }
                    }
                    catch
                    {
                        continue;
                    }
                }
            }
            catch { }
        }

        public void ProcessCanvasForFlagging(Canvas canvas)
        {
            LRRMode refMode = GetReferenceMode();
            LRRModes modes = LRRModel.ProjectModes;
            foreach (Syncfusion.Windows.Forms.Diagram.INode nde in canvas.Model.Nodes)
            {
                Syncfusion.Windows.Forms.Diagram.Symbol openedViewSymbol = nde as Syncfusion.Windows.Forms.Diagram.Symbol;
                if (openedViewSymbol != null && openedViewSymbol.GetType() == typeof(DynamicGridcontainer))
                {
                    DynamicGridcontainer dg = openedViewSymbol as DynamicGridcontainer;
                    foreach (Syncfusion.Windows.Forms.Diagram.SymbolLabel lbl in dg.Labels)
                    {
                        if (lbl.GetType() == typeof(GridHeaderCell))
                            continue;
                        else
                        {
                            GridCell gCell = lbl as GridCell;
                            if (!gCell.IsBinded)
                                continue;
                            else
                            {
                                double minValue = 0;
                                double maxValue = 0;
                                double decPropValue = 0;

                                switch (gCell.Type.Name)
                                {
                                    case "LRRSiteComponentPropertyValue":
                                        {
                                            LRRSiteComponentProperty prop = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(gCell.PropertyID);
                                            LRRUOMType currentUOMTypeObj = null;


                                            if (prop != null)
                                            {
                                                string modeId;
                                                ErrorCode errCode = ErrorCode.NONE;
                                                LRRSiteComponentPropertyValue scpv = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(gCell.PropertyID, gCell.ModeID);
                                                modeId = scpv.ModeID;
                                                if (prop.UOMTypeID != null && prop.UOMTypeID != "")
                                                {
                                                    currentUOMTypeObj = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(prop.UOMTypeID);
                                                    if (currentUOMTypeObj != null)
                                                    {
                                                        if (modeId == refMode.ModeId)
                                                        {
                                                            Validate(scpv);
                                                        }
                                                        else
                                                        {
                                                            LRRSiteComponentPropertyValue siteCompRefPropValue = LRRModel.PropertyValuesObj.GetPropValueBysiteCompAndModeID(prop.ID, refMode.ModeId);
                                                            //prop.GetValueObjectForPropertyMode(refMode.ModeId);
                                                            if (siteCompRefPropValue == null || siteCompRefPropValue.Direction == null)
                                                            {
                                                                errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.NONE;
                                                            }
                                                            if (siteCompRefPropValue.ActualPropertyValue == null || siteCompRefPropValue.ActualPropertyValue.Trim() == "")
                                                            {
                                                                errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.NONE;
                                                            }

                                                            string propValue = scpv.ActualPropertyValue;
                                                            if (propValue == null || propValue.Trim() == "")
                                                            {
                                                                errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.NONE;
                                                            }

                                                            GetReferenceValues(currentUOMTypeObj, siteCompRefPropValue, out minValue, out maxValue);
                                                            double tempValue = Math.Min(minValue, maxValue);
                                                            maxValue = Math.Max(minValue, maxValue);
                                                            minValue = tempValue;

                                                            if (propValue != null && propValue.Trim() != "")
                                                                decPropValue = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), propValue, typeof(double));

                                                            if (minValue == maxValue && minValue == decPropValue)
                                                            {
                                                            }
                                                            else if (decPropValue >= maxValue || decPropValue <= minValue)
                                                            {
                                                                if (scpv.ModeID == "1")
                                                                {
                                                                    errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.MEAS_DEVIATION_FLAG;
                                                                }
                                                                else if (scpv.ModeID == "2")
                                                                {
                                                                    errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.SS_DEVIATION_FLAG;
                                                                }
                                                                else if (scpv.ModeID == "3")
                                                                {
                                                                    errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.SCEN_DEVIATION_FLAG;
                                                                }
                                                                else
                                                                {
                                                                    errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.OTHER_MODES_DEVIATION_FLAG;
                                                                }
                                                            }
                                                            ColourCodes colCode = new ColourCodes();
                                                            colCode.SetColor(errCode);
                                                            //lbl.FillStyle.Color = scpv.GetForeColor();
                                                            scpv.ErrCode = errCode;
                                                            lbl.FillStyle.Color = colCode.ForeColor;
                                                            lbl.BackgroundStyle.Color = colCode.BackColor;

                                                            Color borderColor = scpv.GetBorderColor();
                                                            int borderThickness = scpv.GetBorderThickness();
                                                            if (borderThickness == 2)
                                                            {
                                                                lbl.BorderStyle.ShowBorder = true;
                                                                lbl.BorderStyle.BorderWidth = 2;
                                                                lbl.BorderStyle.BorderColor = borderColor;
                                                            }

                                                        }
                                                    }
                                                }
                                            }
                                        }

                                        break;
                                    case "LRRAggregatePropertyValue":
                                        {
                                            LRRAggregateProperty prop = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(gCell.PropertyID);

                                            LRRUOMType currentUOMTypeObj = null;

                                            if (prop != null)
                                            {

                                                string modeId;
                                                ErrorCode errCode = ErrorCode.NONE;
                                                LRRAggregatePropertyValue agpv = LRRModel.AggregatePropertyValuesObj.GetAggregateValueObjectForPropertyMode(gCell.ModeID,gCell.PropertyID);

                                                if (agpv != null)
                                                {
                                                    modeId = agpv.ModeID;
                                                    if (prop.UOMTypeID != null && prop.UOMTypeID != "")
                                                    {
                                                        currentUOMTypeObj = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(prop.UOMTypeID);
                                                        if (currentUOMTypeObj != null)
                                                        {
                                                            if (modeId == refMode.ModeId)
                                                            {
                                                                ValidateAgPV(agpv);
                                                            }
                                                            else
                                                            {

                                                                LRRAggregatePropertyValue siteCompRefPropValue = LRRModel.AggregatePropertyValuesObj.GetAggregateValueObjectForPropertyMode(refMode.ModeId, prop.ID);
                                                                    //prop.GetValueObjectForPropertyMode(refMode.ModeId);
                                                                if (siteCompRefPropValue == null || siteCompRefPropValue.Direction == null)
                                                                {
                                                                    errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.NONE;
                                                                }
                                                                if (siteCompRefPropValue.ActualPropertyValue == null || siteCompRefPropValue.ActualPropertyValue.Trim() == "")
                                                                {
                                                                    errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.NONE;
                                                                }

                                                                string propValue = agpv.ActualPropertyValue;
                                                                if (propValue == null || propValue.Trim() == "")
                                                                {
                                                                    errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.NONE;
                                                                }

                                                                GetReferenceValuesforAgPV(currentUOMTypeObj, siteCompRefPropValue, out minValue, out maxValue);
                                                                double tempValue = Math.Min(minValue, maxValue);
                                                                maxValue = Math.Max(minValue, maxValue);
                                                                minValue = tempValue;

                                                                if (propValue != null && propValue.Trim() != "")
                                                                    decPropValue = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), propValue, typeof(double));
                                                                if (minValue == maxValue && minValue == decPropValue)
                                                                {
                                                                }
                                                                else if (decPropValue >= maxValue || decPropValue <= minValue)
                                                                {
                                                                    if (agpv.ModeID == "1")
                                                                    {
                                                                        errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.MEAS_DEVIATION_FLAG;

                                                                    }
                                                                    else if (agpv.ModeID == "2")
                                                                    {
                                                                        errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.SS_DEVIATION_FLAG;
                                                                    }
                                                                    else if (agpv.ModeID == "3")
                                                                    {
                                                                        errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.SCEN_DEVIATION_FLAG;
                                                                    }
                                                                    else
                                                                    {
                                                                        errCode = Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode.OTHER_MODES_DEVIATION_FLAG;
                                                                    }
                                                                }


                                                                ColourCodes colCode = new ColourCodes();
                                                                colCode.SetColor(errCode);
                                                                agpv.ErrCode = errCode;
                                                                //lbl.FillStyle.Color = agpv.GetForeColor();
                                                                lbl.FillStyle.Color = colCode.ForeColor;
                                                                lbl.BackgroundStyle.Color = colCode.BackColor;

                                                                Color borderColor = agpv.GetBorderColor();
                                                                int borderThickness = agpv.GetBorderThickness();
                                                                if (borderThickness == 2)
                                                                {
                                                                    lbl.BorderStyle.ShowBorder = true;
                                                                    lbl.BorderStyle.BorderWidth = 2;
                                                                    lbl.BorderStyle.BorderColor = borderColor;
                                                                }

                                                            }
                                                        }
                                                    }

                                                }
                                            }

                                        }
                                        break;
                                }
                            }

                        }
                    }
                }
            }

            /*
            MemoryStream ms = null;
            BinaryReader br = null;
            try
            {
                ms = new MemoryStream();
                System.Runtime.Serialization.Formatters.Binary.BinaryFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Binder = Syncfusion.Runtime.Serialization.AppStateSerializer.CustomBinder;
                formatter.AssemblyFormat = System.Runtime.Serialization.Formatters.FormatterAssemblyStyle.Simple;
                Syncfusion.Windows.Forms.Diagram.DiagramDocument doc = new Syncfusion.Windows.Forms.Diagram.DiagramDocument(canvas.Model, canvas.View, (Syncfusion.Windows.Forms.Diagram.DiagramScript)canvas.ScriptingManager.Script);
                formatter.Serialize(ms, doc);
                ms.Position = 0;
                br = new BinaryReader(ms);
                byte[] fileData = br.ReadBytes((int)ms.Length);
                LRRSavedView lrrsv = new LRRSavedView();
                lrrsv.SavedViewName = canvas.FileName;
                lrrsv.ID = canvas.FileID;
                lrrsv.SavedViewDescription = canvas.FileDescription;
                LRRSavedViewData lrsvd = new LRRSavedViewData();
                lrsvd.ViewBlob = fileData;
                lrsvd.ID = canvas.FileID;
                LRRSavedView modelSavedView = LRRModel.SavedViews.GetSavedViewFromID(canvas.FileID);
                if (modelSavedView != null)
                {
                    modelSavedView = lrrsv;
                    modelSavedView.ObjectState = Symcon.Globals.Enums.DBOperation.UPDATE;
                    lrsvd.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
                    this.DBManagerObj.CommitObject(modelSavedView);
                    this.DBManagerObj.CommitObject(lrsvd);
                    lrsvd.ObjectState = Symcon.Globals.Enums.DBOperation.INSERT;
                    this.DBManagerObj.CommitObject(lrsvd);

                }

            }
            catch (Exception ex)
            {

            }
            finally
            {
                if (br != null)
                    br.Close();
                if (ms != null)
                    ms.Close();
                ms = null;
                br = null;

            }
             * */
        }

        // UpdateGridCell added by ashwin for handling flagging
        public static void UpdateGridCell(GridCell gCell)
        {
            string newUOMID = gCell.UIUOMID;
            IPropertyValue lrrscpv = gCell.Tag as IPropertyValue;
            gCell.Text = GraphicsUtilities.ChangeUOM(lrrscpv.GetUOMID(), newUOMID, lrrscpv.GetPropertyValue(), lrrscpv.GetDataType());
            Symcon.Lightridge.LRRUI.PropertyTable myPT = gCell.PT;
            for (int i = myPT.Properties.Count; i > 0; i--)
            {
                Symcon.Lightridge.LRRUI.PropertySpec ps = myPT.Properties[i - 1] as Symcon.Lightridge.LRRUI.PropertySpec;
                if (ps.Category == "Bound Properties")
                {
                    ps.DefaultValue = gCell.Text;
                    Attribute[] attrib = new Attribute[1];
                    System.ComponentModel.BrowsableAttribute browsableAttrib;
                    browsableAttrib = new System.ComponentModel.BrowsableAttribute(false);
                    attrib[0] = browsableAttrib;
                    ps.AttributesNew = attrib;
                    break;
                }
            }
            string newUOMName = LRRModel.ChildModel.GetUOMNameFromID(newUOMID);
            gCell.UIUOMID = newUOMID;

        }

        public Canvas LoadPublishCanvas(LRRModes lrrModes, LRRSavedView lrrSavedView)
        {
            _graphicsManagers.CreateGraphicsManager();
            Canvas canvas = _graphicsManagers.ActiveManager.LoadCanvas(lrrSavedView.ID);
            canvas.FileName = lrrSavedView.SavedViewName;
            canvas.FileID = lrrSavedView.ID;
            //changed by ashwin
            //_graphicsManagers.ActiveManager.BindSymbols(lrrModes, GraphicsManagers.PropertiesMappingMode.NORMAL, GraphicsManagers.UserMode.IMPLEMENTOR);
            _graphicsManagers.ActiveManager.BindSymbols(lrrModes, GraphicsManagers.PropertiesMappingMode.OPEN, GraphicsManagers.UserMode.OPERATOR);
            if (_graphicsManagers.OpenedViews.ContainsKey(lrrSavedView.ID))
            {
                _graphicsManagers.OpenedViews[lrrSavedView.ID] = canvas;
            }
            else
            {
                _graphicsManagers.OpenedViews.Add(lrrSavedView.ID, canvas);
            }
            if (_graphicsManagers.HashGmIDFileIDMap.ContainsKey(canvas.FileID))
            {
                _graphicsManagers.HashGmIDFileIDMap[canvas.FileID] = _graphicsManagers.ActiveManager.ID;
            }
            else
            {
                _graphicsManagers.HashGmIDFileIDMap.Add(canvas.FileID, _graphicsManagers.ActiveManager.ID);
            }
            
            return canvas;
        }

        // GetReferenceMode added by ashwin
        private static LRRMode GetReferenceMode()
        {
            LRRMode refMode = null;
            LRRModes modes = LRRModel.ProjectModes;
            for (int i = 0; i < modes.Count; i++)
            {
                LRRMode mode = modes[i];
                if (mode.ModeTypeID != null && mode.ModeTypeID == "2")
                {
                    refMode = mode;
                    break;
                }
            }
            return refMode;

        }

        //Validate added by ashwin
        private static void Validate(object obj)
        {
            LRRSiteComponentPropertyValue lrrSiteCompPropValue = obj as LRRSiteComponentPropertyValue;
            LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrSiteCompPropValue.GetPropertyID());

            bool isFormatApplied = false;
            bool evvColorFormatApplied = false;
            if (lrrSiteCompProperty.ConditionalFormatXML != null)
            {
                isFormatApplied = ApplyConditionalFormat(lrrSiteCompProperty);
            }
            if (!isFormatApplied)
            {
                Symcon.LightRidge.BusinessObjects.Utilities.ErrorCode errCode = ErrorCode.NONE;

                //Get the Property ID
                string siteCompPropID = lrrSiteCompPropValue.SiteComponentPropertyID;
                //LRRSiteComponentProperty lrrSiteCompProperty = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(siteCompPropID);
                //Check if property is Mode Dependent
                if (!lrrSiteCompProperty.ModeID)
                {
                    if (lrrSiteCompPropValue.Derivation == "4")
                    {
                        errCode = ErrorCode.USER_SUPPLIED;
                    }
                    ColourCodes colCode = new ColourCodes();
                    colCode.SetColor(errCode);

                    lrrSiteCompPropValue.BackColor = colCode.BackColor;
                    lrrSiteCompPropValue.GraphicsBackGroundColor = colCode.GraphicsBackGroundColor;
                    lrrSiteCompPropValue.ForeColor = colCode.ForeColor;
                    lrrSiteCompPropValue.ErrCode = errCode;//Do not move this up
                    return;
                }

                //Check for Override State
                if (!lrrSiteCompPropValue.GetOverrideState())
                {
                    if (lrrSiteCompPropValue.TrustedState == "0")
                    {
                        errCode = ErrorCode.UNCERTAIN;
                    }
                    else if (lrrSiteCompPropValue.TrustedState == "1")
                    {
                        errCode = ErrorCode.TRUSTED;
                    }
                    else if (lrrSiteCompPropValue.TrustedState == "2")
                    {
                        errCode = ErrorCode.TEMPTRUSTED;
                    }
                    else if (lrrSiteCompPropValue.Derivation == "4" && lrrSiteCompPropValue.TrustedState == "-1")
                    {
                        errCode = ErrorCode.USER_SUPPLIED;
                    }
                    else
                    {
                    }
                    lrrSiteCompPropValue.UnderLine = false;
                }
                else
                {
                    if (lrrSiteCompPropValue.DataConfidenceLevelID == "1")
                    {
                        errCode = ErrorCode.TRUSTED | ErrorCode.OVERRIDED;
                    }
                    if (lrrSiteCompPropValue.DataConfidenceLevelID == "2")
                    {
                        errCode = ErrorCode.TEMPTRUSTED | ErrorCode.OVERRIDED;
                    }
                    if (lrrSiteCompPropValue.DataConfidenceLevelID == "3")
                    {
                        errCode = ErrorCode.UNCERTAIN | ErrorCode.OVERRIDED;
                    }
                    lrrSiteCompPropValue.UnderLine = true;
                }

                //Get the Mapping Info and Set the Color codes according to DH and Tag Importance
                if (lrrSiteCompPropValue.ModeID == "1")
                {
                    ErrorCode errDHCode = setCodeBasedOnDHTagImportance(lrrSiteCompPropValue);
                    if (errDHCode != (ErrorCode.NONE))
                    {
                        if (!lrrSiteCompPropValue.GetOverrideState())
                        {
                            //XOR DataConfidence
                            if ((errCode & (ErrorCode.TEMPTRUSTED)) == (ErrorCode.TEMPTRUSTED))
                            {
                                errCode = errCode ^ ErrorCode.TEMPTRUSTED;
                            }
                            if ((errCode & (ErrorCode.UNCERTAIN)) == (ErrorCode.UNCERTAIN))
                            {
                                errCode = errCode ^ ErrorCode.UNCERTAIN;
                            }
                            if ((errCode & (ErrorCode.TRUSTED)) == (ErrorCode.TRUSTED))
                            {
                                errCode = errCode ^ ErrorCode.TRUSTED;
                            }
                        }

                        errCode = errCode | errDHCode;
                    }
                    errCode = errCode | ErrorCode.MEAS_BACK_COLOR;
                }

                //Apply Deviation rule
                ErrorCode errDeviationCode = ErrorCode.NONE;
                if (errDeviationCode != (ErrorCode.NONE))
                {
                    errCode = errCode | errDeviationCode;
                }

                //Set code for read only
                if (!lrrSiteCompPropValue.IsEditable)
                    errCode = errCode | ErrorCode.READ_ONLY;

                //Set code for Is Recorded
                if (lrrSiteCompProperty.IsTracked)
                    errCode = errCode | ErrorCode.IS_RECORDED;


                string uomTypeID = lrrSiteCompProperty.UOMTypeID;
                if (uomTypeID != null && uomTypeID.Trim() != "")
                {
                    LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);

                    if (lrrUOMType != null && lrrUOMType.IsEVV)
                    {
                        ArrayList evvs = LRRModel.ChildModel.EvvDictionary.Get(lrrUOMType.UOMTypeID);
                        if (evvs != null)
                        {
                            for (int i = 0; i < evvs.Count; i++)
                            {
                                EVVsObject evvObj = evvs[i] as EVVsObject;
                                if (evvObj.EVVValue == lrrSiteCompPropValue.PropertyValue)
                                {
                                    LRREVV evv = LRRModel.ChildModel.EVVs.GetEVVObjectFromID(evvObj.EVVID);
                                    int colInt = evv.Color;
                                    if (colInt != 0)
                                    {
                                        System.Drawing.Color color = System.Drawing.Color.FromArgb(colInt);
                                        lrrSiteCompPropValue.BackColor = color;
                                        evvColorFormatApplied = true;
                                    }
                                }
                            }
                        }
                    }
                }

                //Assign the Color Codes according to ErrorCodes
                ColourCodes colorCode = new ColourCodes();
                colorCode.SetColor(errCode);

                if (!evvColorFormatApplied)
                {
                    //lrrSiteCompPropValue.BackColor = colorCode.BackColor;
                }


                lrrSiteCompPropValue.GraphicsBackGroundColor = colorCode.GraphicsBackGroundColor;
                lrrSiteCompPropValue.ForeColor = colorCode.ForeColor;
                lrrSiteCompPropValue.BorderColor = colorCode.BorderColor;
                lrrSiteCompPropValue.BorderThickness = colorCode.BorderThickness;
                lrrSiteCompPropValue.ErrCode = errCode;//Do not move this up
                lrrSiteCompPropValue.DeviationCode = errDeviationCode;
                if (errDeviationCode != (ErrorCode.NONE))
                {
                }
                else
                {
                }
            }
        }
        // ValidateAgPV added by ashwin
        private static void ValidateAgPV(object obj)
        {
            LRRAggregatePropertyValue lrrAggregatePropValue = obj as LRRAggregatePropertyValue;
            LRRAggregateProperty lrrAggregateProperty = LRRModel.AggregatePropertiesObj.GetAggregatePropFromID(lrrAggregatePropValue.GetPropertyID());
            bool isFormatApplied = false;
            if (lrrAggregateProperty.ConditionalFormatXML != null)
            {
                isFormatApplied = ApplyConditionalFormatAG(lrrAggregateProperty);
            }
            if (!isFormatApplied)
            {
                ErrorCode errCode = ErrorCode.NONE;

                //Get the Property ID
                string aggregatePropID = lrrAggregatePropValue.AggregateID;

                //Check if property is Mode Dependent
                if (!lrrAggregateProperty.ModeID)
                {
                    if (lrrAggregatePropValue.Derivation == "4")
                    {
                        errCode = ErrorCode.USER_SUPPLIED;
                    }
                    ColourCodes colCode = new ColourCodes();
                    colCode.SetColor(errCode);
                    lrrAggregatePropValue.BackColor = colCode.BackColor;
                    lrrAggregatePropValue.GraphicsBackGroundColor = colCode.GraphicsBackGroundColor;
                    lrrAggregatePropValue.ForeColor = colCode.ForeColor;
                    lrrAggregatePropValue.ErrCode = errCode;//Do not move this up
                    return;

                }

                //Check for Override State
                if (!lrrAggregatePropValue.GetOverrideState())
                {
                    if (lrrAggregatePropValue.TrustedState == "0")
                    {
                        errCode = ErrorCode.UNCERTAIN;
                    }

                    else if (lrrAggregatePropValue.TrustedState == "1")
                    {
                        errCode = ErrorCode.TRUSTED;
                    }
                    else if (lrrAggregatePropValue.TrustedState == "2")
                    {
                        errCode = ErrorCode.TEMPTRUSTED;
                    }
                    else if (lrrAggregatePropValue.Derivation == "4" && lrrAggregatePropValue.TrustedState == "-1")
                    {
                        errCode = ErrorCode.USER_SUPPLIED;
                    }

                    else
                    {
                    }
                    lrrAggregatePropValue.UnderLine = false;
                }
                else
                {
                    if (lrrAggregatePropValue.DataConfidenceLevelID == "1")
                    {
                        errCode = ErrorCode.TRUSTED | ErrorCode.OVERRIDED;
                    }
                    if (lrrAggregatePropValue.DataConfidenceLevelID == "2")
                    {
                        errCode = ErrorCode.TEMPTRUSTED | ErrorCode.OVERRIDED;
                    }
                    if (lrrAggregatePropValue.DataConfidenceLevelID == "3")
                    {
                        errCode = ErrorCode.UNCERTAIN | ErrorCode.OVERRIDED;
                    }
                    lrrAggregatePropValue.UnderLine = true;
                }
                //Get the Mapping Info and Set the Color codes according to DH and Tag Importance
                if (lrrAggregatePropValue.ModeID == "1")
                {
                    ErrorCode errDHCode = setCodeBasedOnDHTagImportanceAG(lrrAggregatePropValue);
                    if (errDHCode != (ErrorCode.NONE))
                    {
                        if (!lrrAggregatePropValue.GetOverrideState())
                        {
                            //XOR DataConfidence
                            if ((errCode & (ErrorCode.TEMPTRUSTED)) == (ErrorCode.TEMPTRUSTED))
                            {
                                errCode = errCode ^ ErrorCode.TEMPTRUSTED;
                            }
                            if ((errCode & (ErrorCode.UNCERTAIN)) == (ErrorCode.UNCERTAIN))
                            {
                                errCode = errCode ^ ErrorCode.UNCERTAIN;
                            }
                            if ((errCode & (ErrorCode.TRUSTED)) == (ErrorCode.TRUSTED))
                            {
                                errCode = errCode ^ ErrorCode.TRUSTED;
                            }
                        }

                        errCode = errCode | errDHCode;
                    }
                    errCode = errCode | ErrorCode.MEAS_BACK_COLOR;
                }

                //Apply Deviation rule
                ErrorCode errDeviationCode = ErrorCode.NONE;
                if (errDeviationCode != (ErrorCode.NONE))
                {
                    errCode = errCode | errDeviationCode;
                }
                //Set code for read only
                if (!lrrAggregatePropValue.IsEditable)
                    errCode = errCode | ErrorCode.READ_ONLY;

                //Set code for Is Recorded
                if (lrrAggregateProperty.IsTracked)
                    errCode = errCode | ErrorCode.IS_RECORDED;

                string uomTypeID = lrrAggregateProperty.UOMTypeID;
                if (uomTypeID != null && uomTypeID.Trim() != "")
                {
                    LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
                    if (lrrUOMType != null && lrrUOMType.IsEVV)
                    {
                        ArrayList evvs = LRRModel.ChildModel.EvvDictionary.Get(lrrUOMType.UOMTypeID);
                        if (evvs != null)
                        {
                            for (int i = 0; i < evvs.Count; i++)
                            {
                                EVVsObject evvObj = evvs[i] as EVVsObject;
                                if (evvObj.EVVValue == lrrAggregatePropValue.PropertyValue)
                                {
                                    LRREVV evv = LRRModel.ChildModel.EVVs.GetEVVObjectFromID(evvObj.EVVID);
                                    int colInt = evv.Color;
                                    if (colInt != 0)
                                    {
                                        System.Drawing.Color color = System.Drawing.Color.FromArgb(colInt);
                                        lrrAggregatePropValue.ForeColor = color;
                                    }
                                }
                            }
                        }
                    }
                }

                //Assign the Color Codes according to ErrorCodes
                ColourCodes colorCode = new ColourCodes();
                colorCode.SetColor(errCode);

                lrrAggregatePropValue.GraphicsBackGroundColor = colorCode.GraphicsBackGroundColor;
                lrrAggregatePropValue.ForeColor = colorCode.ForeColor;
                lrrAggregatePropValue.BorderColor = colorCode.BorderColor;
                lrrAggregatePropValue.BorderThickness = colorCode.BorderThickness;
                lrrAggregatePropValue.ErrCode = errCode;//Do not move this up
                lrrAggregatePropValue.DeviationCode = errDeviationCode;
                if (errDeviationCode != (ErrorCode.NONE))
                {
                }
                else
                {
                }

            }
        }
        // setCodeBasedOnDHTagImportance added by ashwin
        private static ErrorCode setCodeBasedOnDHTagImportance(LRRSiteComponentPropertyValue lrrSiteCompPropValue)
        {
            ErrorCode errCode = ErrorCode.NONE;
            //Get the Property ID
            string siteCompPropID = lrrSiteCompPropValue.SiteComponentPropertyID;

            //Get Hist Tag ID mapped to this property ID
            string histTagUID = LRRModel.ChildModel.HistPropCompPropMappings.GetHistTagUIDFromSiteComponentPropertyID(siteCompPropID);

            //Get the Historian Object for this ID
            if (histTagUID != null)
            {
                LRRHistData histData = LRRModel.HistDatas.GetHistDataFromHistTagUID(histTagUID);
                //Get the Tag Importance And DH Filter Value
                string tagImportanceID = histData.TagImportanceID;
                string dataQualityValue = histData.DataQuality;

                //Assign the Error Codes
                if (tagImportanceID == "0" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.VERY_HIGH | ErrorCode.BAD;
                }
                if (tagImportanceID == "0" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.VERY_HIGH | ErrorCode.GOOD;
                }
                if (tagImportanceID == "1" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.HIGH | ErrorCode.BAD;
                }
                if (tagImportanceID == "1" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.HIGH | ErrorCode.GOOD;
                }
                if (tagImportanceID == "2" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.MEDIUM | ErrorCode.BAD;
                }
                if (tagImportanceID == "2" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.MEDIUM | ErrorCode.GOOD;
                }
                if (tagImportanceID == "3" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.LOW | ErrorCode.BAD;
                }
                if (tagImportanceID == "3" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.LOW | ErrorCode.GOOD;
                }
            }
            return errCode;
        }
        // setCodeBasedOnDHTagImportanceAG added by ashwin
        private static ErrorCode setCodeBasedOnDHTagImportanceAG(LRRAggregatePropertyValue lrrSiteCompPropValue)
        {
            ErrorCode errCode = ErrorCode.NONE;
            //Get the Property ID
            string siteCompPropID = lrrSiteCompPropValue.GetPropertyID();

            //Get Hist Tag ID mapped to this property ID
            string histTagUID = LRRModel.ChildModel.HistPropCompPropMappings.GetHistTagUIDFromSiteComponentPropertyID(siteCompPropID);

            //Get the Historian Object for this ID
            if (histTagUID != null)
            {
                LRRHistData histData = LRRModel.HistDatas.GetHistDataFromHistTagUID(histTagUID);
                //Get the Tag Importance And DH Filter Value
                string tagImportanceID = histData.TagImportanceID;
                string dataQualityValue = histData.DataQuality;

                //Assign the Error Codes
                if (tagImportanceID == "0" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.VERY_HIGH | ErrorCode.BAD;
                }
                if (tagImportanceID == "0" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.VERY_HIGH | ErrorCode.GOOD;
                }
                if (tagImportanceID == "1" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.HIGH | ErrorCode.BAD;
                }
                if (tagImportanceID == "1" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.HIGH | ErrorCode.GOOD;
                }
                if (tagImportanceID == "2" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.MEDIUM | ErrorCode.BAD;
                }
                if (tagImportanceID == "2" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.MEDIUM | ErrorCode.GOOD;
                }
                if (tagImportanceID == "3" && dataQualityValue == "0")
                {
                    errCode = ErrorCode.LOW | ErrorCode.BAD;
                }
                if (tagImportanceID == "3" && dataQualityValue == "1")
                {
                    errCode = ErrorCode.LOW | ErrorCode.GOOD;
                }

            }

            return errCode;
        }
        // GetReferenceValues added by ashwin for handling flagging
        private static void GetReferenceValues(LRRUOMType currentUOMTypeObj, LRRSiteComponentPropertyValue siteCompPropValue, out double minValue, out double maxValue)
        {
            double currentRefValue = 0;
            double currentTolerance = 0;
            maxValue = 0;
            minValue = 0;

            if (currentUOMTypeObj != null && !currentUOMTypeObj.IsEVV)
            {
                if (siteCompPropValue != null)
                {
                    if (siteCompPropValue.ActualPropertyValue != null && siteCompPropValue.ActualPropertyValue.Trim() != "")
                    {
                        currentRefValue = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), siteCompPropValue.ActualPropertyValue, typeof(double));
                        currentTolerance = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), currentUOMTypeObj.Tolerance, typeof(double));

                    }
                }
            }
            if (currentUOMTypeObj != null && currentUOMTypeObj.Tolerance != null && !currentUOMTypeObj.IsEVV)
            {
                currentTolerance = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), currentUOMTypeObj.Tolerance, typeof(double));//Decimal.Parse(currentUOMTypeObj.Tolerance);
                minValue = currentRefValue - (currentRefValue * currentTolerance);
                maxValue = currentRefValue + (currentRefValue * currentTolerance);
            }

        }
        // GetReferenceValuesforAgPV added by ashwin
        private static void GetReferenceValuesforAgPV(LRRUOMType currentUOMTypeObj, LRRAggregatePropertyValue siteCompPropValue, out double minValue, out double maxValue)
        {
            double currentRefValue = 0;
            double currentTolerance = 0;
            maxValue = 0;
            minValue = 0;


            if (currentUOMTypeObj != null && !currentUOMTypeObj.IsEVV)
            {
                if (siteCompPropValue != null)
                {
                    if (siteCompPropValue.ActualPropertyValue != null && siteCompPropValue.ActualPropertyValue.Trim() != "")
                    {
                        currentRefValue = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), siteCompPropValue.ActualPropertyValue, typeof(double));
                        currentTolerance = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), currentUOMTypeObj.Tolerance, typeof(double));

                    }
                }
            }
            if (currentUOMTypeObj != null && currentUOMTypeObj.Tolerance != null && !currentUOMTypeObj.IsEVV)
            {
                currentTolerance = (double)Symcon.BusinessObjects.SymExcelConverter.Convert(typeof(string), currentUOMTypeObj.Tolerance, typeof(double));//Decimal.Parse(currentUOMTypeObj.Tolerance);
                minValue = currentRefValue - (currentRefValue * currentTolerance);
                maxValue = currentRefValue + (currentRefValue * currentTolerance);
            }

        }
        // ApplyConditionalFormat added by ashwin
        private static bool ApplyConditionalFormat(LRRSiteComponentProperty lrrSiteCompProperty)
        {
            string uomTypeID = lrrSiteCompProperty.UOMTypeID;
            bool isFormatApplied = false;
            ConditionalFormats cFormats = lrrSiteCompProperty.ConditionalFormatsObj;
            if (uomTypeID != null && uomTypeID.Trim() != "")
            {
                LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
                if (lrrUOMType != null && lrrUOMType.IsEVV)
                {
                    foreach (ConditionalFormat cFormat in cFormats.CondFormats)
                    {
                        LRRSiteComponentPropertyValue lrrscpValue = lrrSiteCompProperty.GetPropertyValueForMode(cFormat.ModeID) as LRRSiteComponentPropertyValue;
                        //   double propVal;
                        //    Double.TryParse(lrrscpValue.PropertyValue, out propVal);
                        if (lrrscpValue.PropertyValue == cFormat.Condition)
                        {
                            lrrscpValue.ForeColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.ForeColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.GraphicsBackGroundColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            //lrrscpValue.ErrCode = ErrorCode.USER_SUPPLIED;
                            isFormatApplied = true;
                        }
                    }
                }
                else
                {
                    foreach (ConditionalFormat cFormat in cFormats.CondFormats)
                    {
                        LRRSiteComponentPropertyValue lrrscpValue = lrrSiteCompProperty.GetPropertyValueForMode(cFormat.ModeID) as LRRSiteComponentPropertyValue;
                        double propVal;
                        Double.TryParse(lrrscpValue.PropertyValue, out propVal);
                        if (propVal >= cFormat.MinValue && propVal <= cFormat.MaxValue)
                        {
                            lrrscpValue.ForeColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.ForeColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.GraphicsBackGroundColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            //lrrscpValue.ErrCode = ErrorCode.USER_SUPPLIED;
                            isFormatApplied = true;
                        }
                    }

                }
            }
            return isFormatApplied;
        }
        // ApplyConditionalFormatAG added by ashwin
        private static bool ApplyConditionalFormatAG(LRRAggregateProperty lrrSiteCompProperty)
        {
            string uomTypeID = lrrSiteCompProperty.UOMTypeID;
            bool isFormatApplied = false;
            ConditionalFormats cFormats = lrrSiteCompProperty.ConditionalFormatsObj;
            if (uomTypeID != null && uomTypeID.Trim() != "")
            {
                LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(uomTypeID);
                if (lrrUOMType != null && lrrUOMType.IsEVV)
                {
                    foreach (ConditionalFormat cFormat in cFormats.CondFormats)
                    {
                        LRRAggregatePropertyValue lrrscpValue = lrrSiteCompProperty.GetPropertyValueForMode(cFormat.ModeID) as LRRAggregatePropertyValue;
                        //   double propVal;
                        //    Double.TryParse(lrrscpValue.PropertyValue, out propVal);
                        if (lrrscpValue.PropertyValue == cFormat.Condition)
                        {
                            lrrscpValue.ForeColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.ForeColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.GraphicsBackGroundColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            //lrrscpValue.ErrCode = ErrorCode.USER_SUPPLIED;
                            isFormatApplied = true;
                        }
                    }
                }
                else
                {
                    foreach (ConditionalFormat cFormat in cFormats.CondFormats)
                    {
                        LRRAggregatePropertyValue lrrscpValue = lrrSiteCompProperty.GetPropertyValueForMode(cFormat.ModeID) as LRRAggregatePropertyValue;
                        double propVal;
                        Double.TryParse(lrrscpValue.PropertyValue, out propVal);
                        if (propVal >= cFormat.MinValue && propVal <= cFormat.MaxValue)
                        {
                            lrrscpValue.ForeColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.ForeColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.GraphicsBackGroundColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            lrrscpValue.BackColor = System.Drawing.Color.FromArgb(Int32.Parse(cFormat.BackColor));
                            //lrrscpValue.ErrCode = ErrorCode.USER_SUPPLIED;
                            isFormatApplied = true;
                        }
                    }

                }
            }
            return isFormatApplied;
        } 
		private void _compPropHistPropBindingManager_BindingCalled(object source, object target)
		{
			//LRRUserHistData userHistData = target as LRRUserHistData;
			//userHistData.InterfaceValue = userHistData.Measurement + "|" + userHistData.SystemStatus + "|" + userHistData.Scenario;
		}
	}

	#region Delegates

    public delegate void ProcessSnapShotForRebuildWaterModelDel();
    public delegate void CheckForSaveBeforRunDel();
	public delegate void LastExecutedRunDel();
	public delegate void ProcessReadWriteDelegate();
	public delegate void PostProcessReadWriteDel();

	#endregion

	public class Waithandle
	{
		public object DelegateObject;
		public bool State = false;
	}
}
