using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using System.Data;
using System.Collections.Generic;

using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Symcon.Utils.MessageLogger;
using Symcon.Utils.HeaderDispatcher; 

using Symcon.Database;
using Symcon.LightRidge.Options.DBOptions;
using Symcon.LightRidge.BusinessObjects;
using Symcon.BusinessObjects;
using Symcon.Globals.Enums;
using Symcon.LightRidge.PEAdvisor.DataStore;
using Symcon.LightRidge.PEAdvisor.GridUtilities;
using Symcon.Utils.MessageDispatcher;
using Symcon.LightRidge.PEAdvisor;
using Symcon.Utils.MessageLogger;

//using Syncfusion.ExcelRW;
using Syncfusion.Drawing;
using Syncfusion.Grouping;

//Copyright (C) 2004-2005 Symcom Global Technologies.  All rights reserved.

namespace Symcon.LightRidge.PEAdvisor.IOScreen
{
	/// <summary>
	/// Summary description for InputOutputViews.
	/// </summary>
	public class InputOutputViews : System.Windows.Forms.Form,ILRRUIContainer,ILRRUISpecificContainer
    {
        #region private members

        private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager1;
		private Syncfusion.Windows.Forms.Tools.GroupView gpVPlantItems;
		private Syncfusion.Windows.Forms.Tools.GroupView gpVTemplates;
		private Syncfusion.Windows.Forms.Tools.GroupView gpvScenarios;
		private Syncfusion.Windows.Forms.Tools.GroupView gpVModes;
		private System.Windows.Forms.RadioButton rdBtnSavedViews;
		private System.Windows.Forms.Panel pnlScenarios;
		private System.Windows.Forms.RadioButton rdBtDynamicCase;
		private System.Windows.Forms.ComboBox cmbUsers;
		private System.Windows.Forms.Label lblUser;
		private System.Windows.Forms.Panel pnlFilterSection;
		private System.Windows.Forms.Panel pnlTemplates;
		private System.Windows.Forms.CheckedListBox chkLstTemplates;
		private System.Windows.Forms.Panel pnlModes;

		private System.Windows.Forms.CheckedListBox chkLstModes;
		private System.Windows.Forms.ImageList imageList1;
		private System.ComponentModel.IContainer components;

		private Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar xpToolBar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSave;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemCopy;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPaste;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemClear;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDelete;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemArrangeCols;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemPrint;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemExport;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem btnExecute;
		private System.Windows.Forms.ImageList imageList3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private System.Windows.Forms.ImageList imageList4;
		private System.Windows.Forms.Panel pnlLeft;
		private System.Windows.Forms.Panel pnlCombo;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.ComboBox cmbMasterPlantItem;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.ComboBox cmbOpen;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Panel pnlUp;
		private System.Windows.Forms.Splitter splitter4;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.DateTimePicker dtPickerEnd;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.DateTimePicker dtPickerStart;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox chkTimeSeriesData;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridPlantItems;
		private System.Windows.Forms.ImageList imageList2;

		LRRSiteComponents _siteComponents = null;
		LRRModes		  _modes		  = new LRRModes();
		LRRUOMs	  _uoms		  = new LRRUOMs();

		Hashtable modes		= new Hashtable();

		private System.Windows.Forms.DateTimePicker dateTimePicker1;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.DateTimePicker dateTimePicker2;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Button btnExec;
		ArrayList gridCollection = new ArrayList();
		ArrayList gridInstanceCollection = new ArrayList();
		
		ArrayList arLevels = new ArrayList();

		private LRRSearchCriterias _SearchCriterias = new LRRSearchCriterias();
		private LRRSearchCriteriaModes _SearchModes = new LRRSearchCriteriaModes();
		private LRRSearchCriteriaLevels _SearchLevels = new LRRSearchCriteriaLevels();
		private LRRSearchCriteriaItems _SearchCriteriaItems = new LRRSearchCriteriaItems();
		private LRRSearchCriteriaItemProperties _SearchCriteriaItemProperties = new LRRSearchCriteriaItemProperties();

		//MasterItems And Comp Types
		private LRRSearchCriteriaComponentTypes _SearchCriteriaComponentTypes = new LRRSearchCriteriaComponentTypes();
		private LRRSearchCriteriaMasterItems	_SearchCriteriaMasterItems = new LRRSearchCriteriaMasterItems();

		//Aggregates
		private LRRSearchCriteriaAggregateItems _SearchCriteriaAggregateItems = new LRRSearchCriteriaAggregateItems();

		private LRRUIManager _lrrUI = new LRRUIManager();
		private GridDataBoundGrid gridPlantItems2;
		public static DateTime startDateTime = new DateTime();
		public static DateTime endDateTime = new DateTime();

		//Results Filter Windows
		private ResultPropertiesWindow _rsProperties;
		private ResultPropertiesWindow _rsComponents;

		private System.Windows.Forms.TextBox textBox2;
//		private System.Windows.Forms.Label lblRunEndTime;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label lblRunStartTime;
		private System.Windows.Forms.Panel pnlFull;
		public static string sRunEndTime = "";
		private System.Windows.Forms.Panel panel1;
        //private Syncfusion.Windows.Forms.Tools.TreeViewAdv trvLevels;
		private TreeView trvLevels;
		private System.Windows.Forms.GroupBox groupBox4;
		public static string sRunStartTime = "";
		private bool flag = true;
		private bool isRootSelected = false;
		private System.Windows.Forms.Button btnSelectAll;
		private System.Windows.Forms.CheckBox chkAutomatic;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDropDownProperties;
		private System.Windows.Forms.Panel pnlGridMasterPlantItems;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridMasterPlantItems;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridSiteSpecificProperties;
		private System.Windows.Forms.Panel panel8;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridProperties2;
		private LRRLevel rootLevel = null;
		private bool transposeFlag = false;
		
		private TabControl			_parentTabControl;
		private System.Windows.Forms.CheckBox chkGroupMode;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.Panel pnlSiteComps;
		private Syncfusion.Windows.Forms.Tools.ComboBoxBase comboBoxBase1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Panel panel5;
		private System.Windows.Forms.CheckedListBox checkedListBox1;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Splitter splitter3;
		private TabPage				_parentTabPage;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter5;
		private System.Windows.Forms.Panel pnlAggregates;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridAggregates;
		private System.Windows.Forms.Panel panel6;
		private System.Windows.Forms.Splitter splitter8;
        private System.Windows.Forms.Panel pnlRun;
		private System.Windows.Forms.Button btnTranspose;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label lblRunStart;
		private System.Windows.Forms.Label lblEndRun;
		private System.Windows.Forms.TextBox txtRunStartTime;
		private System.Windows.Forms.TextBox txtRunEndTime;
		private System.Windows.Forms.Panel pnlGridContainer;
		
		bool bFlag = true;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel7;
		private System.Windows.Forms.Panel panel9;
		private System.Windows.Forms.Splitter splitter6;
		private System.Windows.Forms.Panel panel10;
        private CheckBox chkRecTrendingFlag;
        private Button btnSaveView;
		
		private Symcon.LightRidge.PEAdvisor.IOScreen.IGridFactory iGridView;
        //private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager2;

        #endregion

        public InputOutputViews()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
			_lrrApp.LRRUIManagerObj.PerformDataDirtyCheck = false;
			InitDataSource();
//			BindGridModes();
            if (_lrrLevels.Count > 0 && _lrrLevelLinks.Count > 0)
            {
                PopulateLevels(trvLevels, _lrrLevels, _lrrLevelLinks);
                trvLevels.ExpandAll();
                //trvLevels.Nodes[0].BringIntoView();
                trvLevels.Nodes[0].EnsureVisible();
            }
			BindGridPlantItems();
			BindGridProperties();
			BindGridMasterPlantItems();
			BindGridPlantSpecficProperties();
			
			//-- Check if the user belongs to the implementer role
			string sRoleType = _lrrApp.DBManagerObj.AccessControlModel.UserRoleTypeID;
			if(sRoleType == "1")
			{
				bImplementer = true;
			}

			//Bind Aggregates
			BindAggregates();

			BindChkBoxListMastCompType();
			gridPlantItems2.CurrentCellChanged += new System.EventHandler(gridPlantItems2_CurrentCellChanged);
			_lrrUI.PerformDataDirtyCheck = false;
			//trvLevels.AfterCheck +=new TreeNodeAdvEventHandler(trvLevels_AfterCheck);
            trvLevels.AfterCheck +=new TreeViewEventHandler(trvLevels_AfterCheck);
			checkedListBox1.ItemCheck+=new ItemCheckEventHandler(checkedListBox1_ItemCheck);
            

			LRRModel.ProjectModes.ModesChanged+=new EventHandler(ProjectModes_ModesChanged);

			startDateTime = dateTimePicker2.Value;
			endDateTime   = dateTimePicker1.Value;
			
			this.Activated+=new EventHandler(InputOutputViews_Activated);
			this.Deactivate+=new EventHandler(InputOutputViews_Deactivate);
		}

        void  trvLevels_AfterCheck(object sender, TreeViewEventArgs e)
        {
 	        //IsChanged = true;
			        //Get the Current selected level
			        try
			        {
                        TreeView trv = sender as TreeView;
                        trv.BeginUpdate();
				        ArrayList arChildLevels = new ArrayList();

				        LRRLevel currLevel = e.Node.Tag as LRRLevel;
				        if(e.Node.Checked)
				        {
			    	        if(!isRootSelected)
					        {
						        if(chkAutomatic.Checked)
						        {	
							        if(currLevel.LevelID == "0")
							        {
								        isRootSelected = true;
								        rootLevel = currLevel;
							        }
                                    foreach (TreeNode tna in e.Node.Nodes)
                                    {
                                        flag = false;
                                        //if (tna.Checked && isRootSelected && tna.HasChildren)
                                        //{
                                        //    foreach (TreeNodeAdv tna2 in tna.Nodes)
                                        //    {
                                        //        tna2.Checked = true;
                                        //    }
                                        //}
                                        //else
                                        //    tna.Checked = true;
                                    }
                                    if (e.Action != TreeViewAction.Unknown) //&& isRootSelected)
                                    {
                                        CheckNodes(e.Node);
                                    }
                                    flag = false;
                                    //if(isRootSelected)
                                    
							        flag = true;
						        }
					        }
					        else
					        {
						        foreach(TreeNode tna in e.Node.Nodes)
						        {
							        flag = false;
							        tna.Checked = true;
						        }
						        flag = true;
					        }

                            Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversion(e.Node);
                            //if(!arLevels.Contains(e.Node.Tag) && e.Action != TreeViewAction.Unknown)
                            if (!arLevels.Contains(e.Node.Tag))
					            arLevels.Add(e.Node.Tag);
					        if(e.Node.Tag.Equals(rootLevel))
						        isRootSelected = false;
				        }
                
				        else
				        {
                            if (e.Action != TreeViewAction.Unknown)
                            {
                                e.Node.ForeColor = Color.Black;
                                if(arLevels.Contains(e.Node.Tag))
                                    arLevels.Remove(e.Node.Tag);
                                UncheckNodes(e.Node);
                                Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversion(e.Node); 
                            }
					        
				        }
				        if(flag && !isRootSelected)
				        {
					        ApplicationPersistanceUtil.SaveGridSettings(gridPlantItems,this,this.Tag);

					        Hashtable RelativeWidths = new Hashtable();
					        Hashtable columnForDisplay = new Hashtable();

					        columnForDisplay.Add("IsSelected",null);
					        columnForDisplay.Add("Name",null);
					        columnForDisplay.Add("MasterComponentType",null);

					        //Suspend the Layout of the Grid...
					        gridPlantItems.SuspendLayout();

					        SyncGridUtilities.InitializeGridLookAndFeel(gridPlantItems);

					        gridPlantItems.Engine.SourceListSet.Clear();
					        gridPlantItems.DataSource = null;
					        gridPlantItems.TableDescriptor.Relations.Clear();

					        _lrrSiteComps = new LRRSiteComponents();
					        _lrrSiteComps2 = new LRRSiteComponents();
					        SyncGridUtilities.InitializeGridColumns(gridPlantItems,_lrrSiteComps.ItemType,null,true,columnForDisplay);
        					
					        for(int k=0;k < arLevels.Count;k++)
					        {
						        LRRLevel currentLevel = arLevels[k] as LRRLevel;
        				
						        LRRLevelLinks levelLinks = currentLevel.LevelLinks as LRRLevelLinks;
						        int l = levelLinks.Count;

						        if(currentLevel != null) //Check for null
						        {
							        LRRSiteComponents eachLevelSiteComponents = LRRModel.SiteComponentsObj.Clone() as LRRSiteComponents;
							        IEnumerator iEnum = eachLevelSiteComponents.GetEnumerator();
							        while(iEnum.MoveNext())
							        {
								        LRRSiteComponent siteComponent = iEnum.Current as LRRSiteComponent;
								        siteComponent.IsSelected = false;
							        }
        							
							        LRRSiteComponents eachLvlSiteComps = eachLevelSiteComponents.FilterSiteComponentsByLevelID(currentLevel.LevelID) ;
							        //_lrrApp.DBManagerObj.PopulateCollection(eachLevelSiteComponents," WHERE PlantUnit = '" + currentLevel.LevelID + "'",false);
							        foreach(LRRSiteComponent lsc in eachLvlSiteComps)
							        {
								        if(!arChildLevels.Contains(lsc.Name))
								        {
									        _lrrSiteComps.Add(lsc);
									        _lrrSiteComps2.Add(lsc);
									        arChildLevels.Add(lsc.Name);
								        }
							        }
						        }
						        else
						        {
                                    trv.EndUpdate();
							        return;
						        }
					        }
				        }
                        trv.EndUpdate();
			        }
			        catch(Exception ex)
			        {
				        Logger.LogMessage(typeof(InputOutputViews),"TreeView:"+ex.Message  ,Logger.Level.Debug);
			        }

			        if(flag && !isRootSelected)
			        {
				        gridPlantItems.DataSource = _lrrSiteComps;
				        gridPlantItems.Engine.SourceListSet.Add(_lrrSiteComps);
				        ApplicationPersistanceUtil.ApplyGridSettings(gridPlantItems,this,this.Tag);
				        gridPlantItems.ResumeLayout(true);
				        this.checkPlantItems();
			        }
			        FilterSiteComponents();
                }


        private void CheckNodes(TreeNode winTreeNode)
        {
            List<TreeNode> parentNodeList = new List<TreeNode>();
            GetParentList(winTreeNode, ref parentNodeList);
            foreach (TreeNode tnNode in parentNodeList)
            {
                if (AllChildCheck(tnNode))
                {
                    if (tnNode.Checked != winTreeNode.Checked)
                    {
                        tnNode.Checked = winTreeNode.Checked;
                        //if (!arLevels.Contains(tnNode.Tag))
                            //arLevels.Add(tnNode.Tag);
                    }
                }
            }
            foreach (TreeNode node in winTreeNode.Nodes)
            {
                node.Checked = winTreeNode.Checked;
                //if(!arLevels.Contains(node.Tag))
                    //arLevels.Add(node.Tag);
                if (node.Nodes.Count > 0)
                {
                    // If the current node has child nodes, call the CheckAllChildsNodes method recursively.
                    CheckNodes(node);
                }

            }

        }

        private void UncheckNodes(TreeNode winTreeNode)
        {
            List<TreeNode> parentNodeList = new List<TreeNode>();
            GetParentList(winTreeNode, ref parentNodeList);
            foreach (TreeNode tnNode in parentNodeList)
            {
                if (tnNode.Checked != winTreeNode.Checked)
                {
                    tnNode.Checked = winTreeNode.Checked;
                    if(arLevels.Contains(tnNode.Tag))
                        arLevels.Remove(tnNode.Tag);
                }
            }
            foreach (TreeNode node in winTreeNode.Nodes)
            {
                node.Checked = winTreeNode.Checked;
                if (arLevels.Contains(node.Tag))
                    arLevels.Remove(node.Tag);
                if (node.Nodes.Count > 0)
                {
                    // If the current node has child nodes, call the UncheckAllNodes method recursively.
                    UncheckNodes(node);
                }
            }
        }

        private void GetParentList(TreeNode trNode, ref List<TreeNode> parentNodeList)
        {
            if (trNode.Parent != null)
            {
                TreeNode trParent = trNode.Parent;
                parentNodeList.Add(trParent);
                GetParentList(trParent, ref parentNodeList);
            }
        }

        private bool AllChildCheck(TreeNode tn)
        {
            bool retVal = true;
            foreach (TreeNode tnNode in tn.Nodes)
            {
                if (!tnNode.Checked)
                {
                    retVal = false;
                    return retVal;
                }
            }
            return retVal;
        }


		public InputOutputViews(bool b)
		{
			_lrrApp = AppDomain.CurrentDomain.GetData("AppObject") as LRRApp;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

        /// <summary>
        /// Gets all tree levels.
        /// </summary>
        /// <param name="currentNode">The current node.</param>
        /// <param name="parentNodeList">The parent node list.</param>
        private void GetAllTreeLevels(TreeNode currentNode, ref List<TreeNode> parentNodeList)
        {
            if (currentNode != null)
            {
                if (currentNode.Nodes.Count > 0)
                {
                    foreach (TreeNode node in currentNode.Nodes)
                    {
                        parentNodeList.Add(node);
                        GetAllTreeLevels(node, ref parentNodeList);
                    }
                }
                else
                    foreach (TreeNode node in currentNode.Nodes)
                    {
                        parentNodeList.Add(node);
                    }
            }
        }

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(InputOutputViews));
            this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
            this.pnlFilterSection = new System.Windows.Forms.Panel();
            this.splitter2 = new System.Windows.Forms.Splitter();
            this.pnlUp = new System.Windows.Forms.Panel();
            this.splitter3 = new System.Windows.Forms.Splitter();
            this.panel4 = new System.Windows.Forms.Panel();
            this.panel7 = new System.Windows.Forms.Panel();
            this.panel10 = new System.Windows.Forms.Panel();
            this.gridSiteSpecificProperties = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter6 = new System.Windows.Forms.Splitter();
            this.panel9 = new System.Windows.Forms.Panel();
            this.gridProperties2 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter1 = new System.Windows.Forms.Splitter();
            this.pnlSiteComps = new System.Windows.Forms.Panel();
            this.splitter8 = new System.Windows.Forms.Splitter();
            this.panel6 = new System.Windows.Forms.Panel();
            this.gridPlantItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlAggregates = new System.Windows.Forms.Panel();
            this.gridAggregates = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.splitter5 = new System.Windows.Forms.Splitter();
            this.panel3 = new System.Windows.Forms.Panel();
            this.checkedListBox1 = new System.Windows.Forms.CheckedListBox();
            this.panel2 = new System.Windows.Forms.Panel();
            this.chkTimeSeriesData = new System.Windows.Forms.CheckBox();
            this.btnExec = new System.Windows.Forms.Button();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.groupBox4 = new System.Windows.Forms.GroupBox();
            this.dateTimePicker1 = new System.Windows.Forms.DateTimePicker();
            this.label8 = new System.Windows.Forms.Label();
            this.dateTimePicker2 = new System.Windows.Forms.DateTimePicker();
            this.label9 = new System.Windows.Forms.Label();
            this.btnSelectAll = new System.Windows.Forms.Button();
            this.chkGroupMode = new System.Windows.Forms.CheckBox();
            this.panel5 = new System.Windows.Forms.Panel();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.dtPickerEnd = new System.Windows.Forms.DateTimePicker();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.dtPickerStart = new System.Windows.Forms.DateTimePicker();
            this.splitter4 = new System.Windows.Forms.Splitter();
            this.panel8 = new System.Windows.Forms.Panel();
            this.pnlLeft = new System.Windows.Forms.Panel();
            this.panel1 = new System.Windows.Forms.Panel();
            this.gridMasterPlantItems = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
            this.pnlCombo = new System.Windows.Forms.Panel();
            this.label1 = new System.Windows.Forms.Label();
            this.comboBoxBase1 = new Syncfusion.Windows.Forms.Tools.ComboBoxBase();
            this.pnlGridMasterPlantItems = new System.Windows.Forms.Panel();
            this.trvLevels = new System.Windows.Forms.TreeView();
            this.chkAutomatic = new System.Windows.Forms.CheckBox();
            this.label6 = new System.Windows.Forms.Label();
            this.cmbMasterPlantItem = new System.Windows.Forms.ComboBox();
            this.cmbOpen = new System.Windows.Forms.ComboBox();
            this.label7 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.imageList4 = new System.Windows.Forms.ImageList(this.components);
            this.btnExecute = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.imageList3 = new System.Windows.Forms.ImageList(this.components);
            this.pnlModes = new System.Windows.Forms.Panel();
            this.chkLstModes = new System.Windows.Forms.CheckedListBox();
            this.pnlTemplates = new System.Windows.Forms.Panel();
            this.chkLstTemplates = new System.Windows.Forms.CheckedListBox();
            this.pnlScenarios = new System.Windows.Forms.Panel();
            this.lblUser = new System.Windows.Forms.Label();
            this.cmbUsers = new System.Windows.Forms.ComboBox();
            this.rdBtDynamicCase = new System.Windows.Forms.RadioButton();
            this.rdBtnSavedViews = new System.Windows.Forms.RadioButton();
            this.gpVTemplates = new Syncfusion.Windows.Forms.Tools.GroupView();
            this.gpVModes = new Syncfusion.Windows.Forms.Tools.GroupView();
            this.gpVPlantItems = new Syncfusion.Windows.Forms.Tools.GroupView();
            this.gpvScenarios = new Syncfusion.Windows.Forms.Tools.GroupView();
            this.xpToolBar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar();
            this.barItemSave = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.imageList2 = new System.Windows.Forms.ImageList(this.components);
            this.barItemPrint = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemCopy = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemDelete = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemClear = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemArrangeCols = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.barItemExport = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            this.gridPlantItems2 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.lblRunStartTime = new System.Windows.Forms.Label();
            this.pnlFull = new System.Windows.Forms.Panel();
            this.pnlGridContainer = new System.Windows.Forms.Panel();
            this.pnlRun = new System.Windows.Forms.Panel();
            this.btnSaveView = new System.Windows.Forms.Button();
            this.chkRecTrendingFlag = new System.Windows.Forms.CheckBox();
            this.btnTranspose = new System.Windows.Forms.Button();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.lblRunStart = new System.Windows.Forms.Label();
            this.lblEndRun = new System.Windows.Forms.Label();
            this.txtRunStartTime = new System.Windows.Forms.TextBox();
            this.txtRunEndTime = new System.Windows.Forms.TextBox();
            this.gridDropDownProperties = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
            this.pnlFilterSection.SuspendLayout();
            this.pnlUp.SuspendLayout();
            this.panel4.SuspendLayout();
            this.panel7.SuspendLayout();
            this.panel10.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridSiteSpecificProperties)).BeginInit();
            this.panel9.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridProperties2)).BeginInit();
            this.pnlSiteComps.SuspendLayout();
            this.panel6.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems)).BeginInit();
            this.pnlAggregates.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregates)).BeginInit();
            this.panel3.SuspendLayout();
            this.groupBox4.SuspendLayout();
            this.groupBox1.SuspendLayout();
            this.pnlLeft.SuspendLayout();
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridMasterPlantItems)).BeginInit();
            this.pnlCombo.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.comboBoxBase1)).BeginInit();
            this.pnlGridMasterPlantItems.SuspendLayout();
            this.pnlModes.SuspendLayout();
            this.pnlTemplates.SuspendLayout();
            this.pnlScenarios.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems2)).BeginInit();
            this.pnlFull.SuspendLayout();
            this.pnlRun.SuspendLayout();
            this.groupBox2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridDropDownProperties)).BeginInit();
            this.SuspendLayout();
            // 
            // dockingManager1
            // 
            this.dockingManager1.AutoHideInterval = 200;
            this.dockingManager1.CloseEnabled = false;
            this.dockingManager1.DisallowFloating = true;
            this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
            this.dockingManager1.HostControl = this;
            this.dockingManager1.PersistState = true;
            this.dockingManager1.ShowToolTips = true;
            this.dockingManager1.AutoHideAnimationStart += new Syncfusion.Windows.Forms.Tools.AutoHideAnimationEventHandler(this.dockingManager1_AutoHideAnimationStart);
            this.dockingManager1.SetDockLabel(this.pnlFilterSection, "Search");
            this.dockingManager1.SetAutoHideOnLoad(this.pnlFilterSection, true);
            // 
            // pnlFilterSection
            // 
            this.pnlFilterSection.AutoScroll = true;
            this.pnlFilterSection.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.pnlFilterSection.Controls.Add(this.splitter2);
            this.pnlFilterSection.Controls.Add(this.pnlUp);
            this.pnlFilterSection.Controls.Add(this.pnlLeft);
            this.dockingManager1.SetEnableDocking(this.pnlFilterSection, true);
            this.pnlFilterSection.Location = new System.Drawing.Point(1, 21);
            this.pnlFilterSection.Name = "pnlFilterSection";
            this.pnlFilterSection.Size = new System.Drawing.Size(791, 554);
            this.pnlFilterSection.TabIndex = 2;
            // 
            // splitter2
            // 
            this.splitter2.Location = new System.Drawing.Point(200, 0);
            this.splitter2.Name = "splitter2";
            this.splitter2.Size = new System.Drawing.Size(3, 554);
            this.splitter2.TabIndex = 49;
            this.splitter2.TabStop = false;
            // 
            // pnlUp
            // 
            this.pnlUp.Controls.Add(this.splitter3);
            this.pnlUp.Controls.Add(this.panel4);
            this.pnlUp.Controls.Add(this.panel3);
            this.pnlUp.Controls.Add(this.splitter4);
            this.pnlUp.Controls.Add(this.panel8);
            this.pnlUp.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlUp.Location = new System.Drawing.Point(200, 0);
            this.pnlUp.Name = "pnlUp";
            this.pnlUp.Size = new System.Drawing.Size(591, 554);
            this.pnlUp.TabIndex = 48;
            // 
            // splitter3
            // 
            this.splitter3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.splitter3.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter3.Enabled = false;
            this.splitter3.Location = new System.Drawing.Point(3, 144);
            this.splitter3.Name = "splitter3";
            this.splitter3.Size = new System.Drawing.Size(588, 3);
            this.splitter3.TabIndex = 58;
            this.splitter3.TabStop = false;
            // 
            // panel4
            // 
            this.panel4.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.panel4.Controls.Add(this.panel7);
            this.panel4.Controls.Add(this.splitter1);
            this.panel4.Controls.Add(this.pnlSiteComps);
            this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel4.Location = new System.Drawing.Point(3, 144);
            this.panel4.Name = "panel4";
            this.panel4.Size = new System.Drawing.Size(588, 410);
            this.panel4.TabIndex = 57;
            // 
            // panel7
            // 
            this.panel7.Controls.Add(this.panel10);
            this.panel7.Controls.Add(this.splitter6);
            this.panel7.Controls.Add(this.panel9);
            this.panel7.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel7.Location = new System.Drawing.Point(282, 0);
            this.panel7.Name = "panel7";
            this.panel7.Size = new System.Drawing.Size(306, 410);
            this.panel7.TabIndex = 8;
            // 
            // panel10
            // 
            this.panel10.Controls.Add(this.gridSiteSpecificProperties);
            this.panel10.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel10.Location = new System.Drawing.Point(146, 0);
            this.panel10.Name = "panel10";
            this.panel10.Size = new System.Drawing.Size(160, 410);
            this.panel10.TabIndex = 2;
            // 
            // gridSiteSpecificProperties
            // 
            this.gridSiteSpecificProperties.Appearance.AnyHeaderCell.AutoSize = true;
            this.gridSiteSpecificProperties.BackColor = System.Drawing.SystemColors.Window;
            this.gridSiteSpecificProperties.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridSiteSpecificProperties.Location = new System.Drawing.Point(0, 0);
            this.gridSiteSpecificProperties.Name = "gridSiteSpecificProperties";
            this.gridSiteSpecificProperties.Size = new System.Drawing.Size(160, 410);
            this.gridSiteSpecificProperties.TabIndex = 1;
            this.gridSiteSpecificProperties.Text = "gridGroupingControl1";
            this.gridSiteSpecificProperties.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridSiteSpecificProperties.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridSiteSpecificProperties.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridSiteSpecificProperties.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridSiteSpecificProperties.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridSiteSpecificProperties.VersionInfo = "3.301.0.0";
            // 
            // splitter6
            // 
            this.splitter6.Location = new System.Drawing.Point(144, 0);
            this.splitter6.Name = "splitter6";
            this.splitter6.Size = new System.Drawing.Size(2, 410);
            this.splitter6.TabIndex = 1;
            this.splitter6.TabStop = false;
            // 
            // panel9
            // 
            this.panel9.Controls.Add(this.gridProperties2);
            this.panel9.Dock = System.Windows.Forms.DockStyle.Left;
            this.panel9.Location = new System.Drawing.Point(0, 0);
            this.panel9.Name = "panel9";
            this.panel9.Size = new System.Drawing.Size(144, 410);
            this.panel9.TabIndex = 0;
            // 
            // gridProperties2
            // 
            this.gridProperties2.BackColor = System.Drawing.SystemColors.Window;
            this.gridProperties2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridProperties2.Location = new System.Drawing.Point(0, 0);
            this.gridProperties2.Name = "gridProperties2";
            this.gridProperties2.Size = new System.Drawing.Size(144, 410);
            this.gridProperties2.TabIndex = 0;
            this.gridProperties2.Text = "gridGroupingControl1";
            this.gridProperties2.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridProperties2.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridProperties2.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridProperties2.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridProperties2.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridProperties2.VersionInfo = "3.301.0.0";
            // 
            // splitter1
            // 
            this.splitter1.Location = new System.Drawing.Point(280, 0);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(2, 410);
            this.splitter1.TabIndex = 7;
            this.splitter1.TabStop = false;
            // 
            // pnlSiteComps
            // 
            this.pnlSiteComps.Controls.Add(this.splitter8);
            this.pnlSiteComps.Controls.Add(this.panel6);
            this.pnlSiteComps.Controls.Add(this.pnlAggregates);
            this.pnlSiteComps.Controls.Add(this.splitter5);
            this.pnlSiteComps.Dock = System.Windows.Forms.DockStyle.Left;
            this.pnlSiteComps.Location = new System.Drawing.Point(0, 0);
            this.pnlSiteComps.Name = "pnlSiteComps";
            this.pnlSiteComps.Size = new System.Drawing.Size(280, 410);
            this.pnlSiteComps.TabIndex = 0;
            // 
            // splitter8
            // 
            this.splitter8.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitter8.Location = new System.Drawing.Point(0, 151);
            this.splitter8.Name = "splitter8";
            this.splitter8.Size = new System.Drawing.Size(280, 3);
            this.splitter8.TabIndex = 4;
            this.splitter8.TabStop = false;
            // 
            // panel6
            // 
            this.panel6.Controls.Add(this.gridPlantItems);
            this.panel6.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel6.Location = new System.Drawing.Point(0, 3);
            this.panel6.Name = "panel6";
            this.panel6.Size = new System.Drawing.Size(280, 151);
            this.panel6.TabIndex = 3;
            // 
            // gridPlantItems
            // 
            this.gridPlantItems.BackColor = System.Drawing.SystemColors.Window;
            this.gridPlantItems.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridPlantItems.Location = new System.Drawing.Point(0, 0);
            this.gridPlantItems.Name = "gridPlantItems";
            this.gridPlantItems.Size = new System.Drawing.Size(280, 151);
            this.gridPlantItems.TabIndex = 0;
            this.gridPlantItems.Text = "gridGroupingControl1";
            this.gridPlantItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridPlantItems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridPlantItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridPlantItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridPlantItems.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridPlantItems.VersionInfo = "3.301.0.0";
            this.gridPlantItems.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridPlantItems_RecordValueChanged);
            // 
            // pnlAggregates
            // 
            this.pnlAggregates.Controls.Add(this.gridAggregates);
            this.pnlAggregates.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.pnlAggregates.Location = new System.Drawing.Point(0, 154);
            this.pnlAggregates.Name = "pnlAggregates";
            this.pnlAggregates.Size = new System.Drawing.Size(280, 256);
            this.pnlAggregates.TabIndex = 2;
            // 
            // gridAggregates
            // 
            this.gridAggregates.BackColor = System.Drawing.SystemColors.Window;
            this.gridAggregates.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridAggregates.Location = new System.Drawing.Point(0, 0);
            this.gridAggregates.Name = "gridAggregates";
            this.gridAggregates.Size = new System.Drawing.Size(280, 256);
            this.gridAggregates.TabIndex = 1;
            this.gridAggregates.Text = "gridGroupingControl1";
            this.gridAggregates.VersionInfo = "3.301.0.0";
            this.gridAggregates.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridAggregates_RecordValueChanged);
            // 
            // splitter5
            // 
            this.splitter5.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter5.Location = new System.Drawing.Point(0, 0);
            this.splitter5.Name = "splitter5";
            this.splitter5.Size = new System.Drawing.Size(280, 3);
            this.splitter5.TabIndex = 1;
            this.splitter5.TabStop = false;
            // 
            // panel3
            // 
            this.panel3.Controls.Add(this.checkedListBox1);
            this.panel3.Controls.Add(this.panel2);
            this.panel3.Controls.Add(this.chkTimeSeriesData);
            this.panel3.Controls.Add(this.btnExec);
            this.panel3.Controls.Add(this.groupBox4);
            this.panel3.Controls.Add(this.btnSelectAll);
            this.panel3.Controls.Add(this.chkGroupMode);
            this.panel3.Controls.Add(this.panel5);
            this.panel3.Controls.Add(this.groupBox1);
            this.panel3.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel3.Location = new System.Drawing.Point(3, 0);
            this.panel3.Name = "panel3";
            this.panel3.Size = new System.Drawing.Size(588, 144);
            this.panel3.TabIndex = 55;
            // 
            // checkedListBox1
            // 
            this.checkedListBox1.CheckOnClick = true;
            this.checkedListBox1.Location = new System.Drawing.Point(280, 8);
            this.checkedListBox1.Name = "checkedListBox1";
            this.checkedListBox1.Size = new System.Drawing.Size(120, 94);
            this.checkedListBox1.Sorted = true;
            this.checkedListBox1.TabIndex = 57;
            // 
            // panel2
            // 
            this.panel2.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.panel2.Dock = System.Windows.Forms.DockStyle.Left;
            this.panel2.Location = new System.Drawing.Point(0, 0);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(8, 144);
            this.panel2.TabIndex = 4;
            // 
            // chkTimeSeriesData
            // 
            this.chkTimeSeriesData.Location = new System.Drawing.Point(16, 8);
            this.chkTimeSeriesData.Name = "chkTimeSeriesData";
            this.chkTimeSeriesData.Size = new System.Drawing.Size(112, 16);
            this.chkTimeSeriesData.TabIndex = 5;
            this.chkTimeSeriesData.Tag = "SID_TIME_SERIES_DATA";
            // 
            // btnExec
            // 
            this.btnExec.ImageAlign = System.Drawing.ContentAlignment.TopLeft;
            this.btnExec.ImageIndex = 8;
            this.btnExec.ImageList = this.imageList1;
            this.btnExec.Location = new System.Drawing.Point(496, 112);
            this.btnExec.Name = "btnExec";
            this.btnExec.Size = new System.Drawing.Size(75, 23);
            this.btnExec.TabIndex = 51;
            this.btnExec.Tag = "SID_EXECUTE";
            this.btnExec.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.btnExec.Click += new System.EventHandler(this.btnExec_Click);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "");
            this.imageList1.Images.SetKeyName(4, "");
            this.imageList1.Images.SetKeyName(5, "");
            this.imageList1.Images.SetKeyName(6, "");
            this.imageList1.Images.SetKeyName(7, "");
            this.imageList1.Images.SetKeyName(8, "");
            this.imageList1.Images.SetKeyName(9, "");
            this.imageList1.Images.SetKeyName(10, "");
            this.imageList1.Images.SetKeyName(11, "");
            this.imageList1.Images.SetKeyName(12, "");
            // 
            // groupBox4
            // 
            this.groupBox4.Controls.Add(this.dateTimePicker1);
            this.groupBox4.Controls.Add(this.label8);
            this.groupBox4.Controls.Add(this.dateTimePicker2);
            this.groupBox4.Controls.Add(this.label9);
            this.groupBox4.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.groupBox4.Location = new System.Drawing.Point(272, 8);
            this.groupBox4.Name = "groupBox4";
            this.groupBox4.Size = new System.Drawing.Size(296, 96);
            this.groupBox4.TabIndex = 1;
            this.groupBox4.TabStop = false;
            // 
            // dateTimePicker1
            // 
            this.dateTimePicker1.CustomFormat = "MM-dd-yyyy HH:mm:ss";
            this.dateTimePicker1.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimePicker1.Location = new System.Drawing.Point(152, 56);
            this.dateTimePicker1.Name = "dateTimePicker1";
            this.dateTimePicker1.Size = new System.Drawing.Size(128, 20);
            this.dateTimePicker1.TabIndex = 11;
            this.dateTimePicker1.ValueChanged += new System.EventHandler(this.dateTimePicker1_ValueChanged);
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(8, 56);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(112, 24);
            this.label8.TabIndex = 10;
            this.label8.Tag = "SID_END_PLT";
            // 
            // dateTimePicker2
            // 
            this.dateTimePicker2.CustomFormat = "MM-dd-yyyy HH:mm:ss";
            this.dateTimePicker2.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dateTimePicker2.Location = new System.Drawing.Point(152, 24);
            this.dateTimePicker2.Name = "dateTimePicker2";
            this.dateTimePicker2.Size = new System.Drawing.Size(128, 20);
            this.dateTimePicker2.TabIndex = 9;
            this.dateTimePicker2.ValueChanged += new System.EventHandler(this.dateTimePicker2_ValueChanged);
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(8, 24);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(160, 32);
            this.label9.TabIndex = 8;
            this.label9.Tag = "SID_SART_PLT";
            // 
            // btnSelectAll
            // 
            this.btnSelectAll.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnSelectAll.ImageIndex = 12;
            this.btnSelectAll.ImageList = this.imageList1;
            this.btnSelectAll.Location = new System.Drawing.Point(24, 112);
            this.btnSelectAll.Name = "btnSelectAll";
            this.btnSelectAll.Size = new System.Drawing.Size(75, 23);
            this.btnSelectAll.TabIndex = 53;
            this.btnSelectAll.Tag = "SID_CHECK_ALL";
            this.btnSelectAll.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.btnSelectAll.Visible = false;
            this.btnSelectAll.Click += new System.EventHandler(this.btnSelectAll_Click);
            // 
            // chkGroupMode
            // 
            this.chkGroupMode.Location = new System.Drawing.Point(384, 112);
            this.chkGroupMode.Name = "chkGroupMode";
            this.chkGroupMode.Size = new System.Drawing.Size(104, 24);
            this.chkGroupMode.TabIndex = 54;
            this.chkGroupMode.Tag = "SID_GRP_BYMODE";
            // 
            // panel5
            // 
            this.panel5.Location = new System.Drawing.Point(-56, 8);
            this.panel5.Name = "panel5";
            this.panel5.Size = new System.Drawing.Size(48, 72);
            this.panel5.TabIndex = 56;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.dtPickerEnd);
            this.groupBox1.Controls.Add(this.label4);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.dtPickerStart);
            this.groupBox1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(256, 96);
            this.groupBox1.TabIndex = 6;
            this.groupBox1.TabStop = false;
            this.groupBox1.Tag = "SID_TIME_SERIES_DATA";
            // 
            // dtPickerEnd
            // 
            this.dtPickerEnd.CustomFormat = "MM-dd-yyyy HH:mm:ss";
            this.dtPickerEnd.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dtPickerEnd.Location = new System.Drawing.Point(120, 64);
            this.dtPickerEnd.Name = "dtPickerEnd";
            this.dtPickerEnd.Size = new System.Drawing.Size(128, 20);
            this.dtPickerEnd.TabIndex = 3;
            this.dtPickerEnd.Validated += new System.EventHandler(this.dtPickerEnd_Validated);
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 64);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(104, 16);
            this.label4.TabIndex = 2;
            this.label4.Tag = "SID_END_DATETIME";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(104, 16);
            this.label3.TabIndex = 0;
            this.label3.Tag = "SID_START_DATETIME";
            // 
            // dtPickerStart
            // 
            this.dtPickerStart.CustomFormat = "MM-dd-yyyy HH:mm:ss";
            this.dtPickerStart.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
            this.dtPickerStart.Location = new System.Drawing.Point(120, 32);
            this.dtPickerStart.Name = "dtPickerStart";
            this.dtPickerStart.Size = new System.Drawing.Size(128, 20);
            this.dtPickerStart.TabIndex = 1;
            // 
            // splitter4
            // 
            this.splitter4.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.splitter4.Location = new System.Drawing.Point(0, 0);
            this.splitter4.Name = "splitter4";
            this.splitter4.Size = new System.Drawing.Size(3, 554);
            this.splitter4.TabIndex = 1;
            this.splitter4.TabStop = false;
            // 
            // panel8
            // 
            this.panel8.Location = new System.Drawing.Point(880, 432);
            this.panel8.Name = "panel8";
            this.panel8.Size = new System.Drawing.Size(56, 56);
            this.panel8.TabIndex = 2;
            // 
            // pnlLeft
            // 
            this.pnlLeft.Controls.Add(this.panel1);
            this.pnlLeft.Controls.Add(this.pnlCombo);
            this.pnlLeft.Dock = System.Windows.Forms.DockStyle.Left;
            this.pnlLeft.Location = new System.Drawing.Point(0, 0);
            this.pnlLeft.Name = "pnlLeft";
            this.pnlLeft.Size = new System.Drawing.Size(200, 554);
            this.pnlLeft.TabIndex = 38;
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.gridMasterPlantItems);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 272);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(200, 282);
            this.panel1.TabIndex = 2;
            // 
            // gridMasterPlantItems
            // 
            this.gridMasterPlantItems.BackColor = System.Drawing.SystemColors.Window;
            this.gridMasterPlantItems.Dock = System.Windows.Forms.DockStyle.Fill;
            this.gridMasterPlantItems.Location = new System.Drawing.Point(0, 0);
            this.gridMasterPlantItems.Name = "gridMasterPlantItems";
            this.gridMasterPlantItems.Size = new System.Drawing.Size(200, 282);
            this.gridMasterPlantItems.TabIndex = 0;
            this.gridMasterPlantItems.Text = "gridGroupingControl1";
            this.gridMasterPlantItems.TopLevelGroupOptions.IsExpandedInitialValue = true;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowCaptionPlusMinus = false;
            this.gridMasterPlantItems.TopLevelGroupOptions.ShowColumnHeaders = true;
            this.gridMasterPlantItems.VersionInfo = "3.301.0.0";
            this.gridMasterPlantItems.RecordValueChanged += new Syncfusion.Grouping.RecordValueChangedEventHandler(this.gridMasterPlantItems_RecordValueChanged);
            // 
            // pnlCombo
            // 
            this.pnlCombo.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.pnlCombo.Controls.Add(this.label1);
            this.pnlCombo.Controls.Add(this.comboBoxBase1);
            this.pnlCombo.Controls.Add(this.pnlGridMasterPlantItems);
            this.pnlCombo.Controls.Add(this.chkAutomatic);
            this.pnlCombo.Controls.Add(this.label6);
            this.pnlCombo.Controls.Add(this.cmbMasterPlantItem);
            this.pnlCombo.Controls.Add(this.cmbOpen);
            this.pnlCombo.Controls.Add(this.label7);
            this.pnlCombo.Controls.Add(this.label2);
            this.pnlCombo.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlCombo.Location = new System.Drawing.Point(0, 0);
            this.pnlCombo.Name = "pnlCombo";
            this.pnlCombo.Size = new System.Drawing.Size(200, 272);
            this.pnlCombo.TabIndex = 0;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 192);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(176, 16);
            this.label1.TabIndex = 10;
            this.label1.Tag = "SID_SELE_MASTER_COMP_TYPE";
            // 
            // comboBoxBase1
            // 
            this.comboBoxBase1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBoxBase1.IgnoreThemeBackground = true;
            this.comboBoxBase1.ListControl = this.checkedListBox1;
            this.comboBoxBase1.Location = new System.Drawing.Point(8, 215);
            this.comboBoxBase1.Name = "comboBoxBase1";
            this.comboBoxBase1.Size = new System.Drawing.Size(168, 21);
            this.comboBoxBase1.TabIndex = 9;
            this.comboBoxBase1.SelectionChangeCommitted += new System.EventHandler(this.comboBoxBase1_SelectionChangeCommitted);
            // 
            // pnlGridMasterPlantItems
            // 
            this.pnlGridMasterPlantItems.Controls.Add(this.trvLevels);
            this.pnlGridMasterPlantItems.Location = new System.Drawing.Point(0, 64);
            this.pnlGridMasterPlantItems.Name = "pnlGridMasterPlantItems";
            this.pnlGridMasterPlantItems.Size = new System.Drawing.Size(200, 120);
            this.pnlGridMasterPlantItems.TabIndex = 8;
            // 
            // trvLevels
            // 
            this.trvLevels.BackColor = System.Drawing.Color.WhiteSmoke;
            this.trvLevels.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.trvLevels.CheckBoxes = true;
            this.trvLevels.Dock = System.Windows.Forms.DockStyle.Fill;
            this.trvLevels.Location = new System.Drawing.Point(0, 0);
            this.trvLevels.Name = "trvLevels";
            this.trvLevels.Size = new System.Drawing.Size(200, 120);
            this.trvLevels.TabIndex = 0;
            // 
            // chkAutomatic
            // 
            this.chkAutomatic.Location = new System.Drawing.Point(72, 40);
            this.chkAutomatic.Name = "chkAutomatic";
            this.chkAutomatic.Size = new System.Drawing.Size(136, 16);
            this.chkAutomatic.TabIndex = 7;
            this.chkAutomatic.Tag = "SID_SELE_CHILDLEV";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(0, 40);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(80, 16);
            this.label6.TabIndex = 5;
            this.label6.Tag = "SID_SELECT_LEVEL";
            // 
            // cmbMasterPlantItem
            // 
            this.cmbMasterPlantItem.Location = new System.Drawing.Point(130, 32);
            this.cmbMasterPlantItem.Name = "cmbMasterPlantItem";
            this.cmbMasterPlantItem.Size = new System.Drawing.Size(0, 21);
            this.cmbMasterPlantItem.TabIndex = 4;
            this.cmbMasterPlantItem.Visible = false;
            this.cmbMasterPlantItem.SelectedIndexChanged += new System.EventHandler(this.cmbMasterPlantItem_SelectedIndexChanged);
            // 
            // cmbOpen
            // 
            this.cmbOpen.Location = new System.Drawing.Point(96, 8);
            this.cmbOpen.Name = "cmbOpen";
            this.cmbOpen.Size = new System.Drawing.Size(104, 21);
            this.cmbOpen.TabIndex = 1;
            this.cmbOpen.SelectedIndexChanged += new System.EventHandler(this.cmbOpen_SelectedIndexChanged);
            this.cmbOpen.DropDown += new System.EventHandler(this.cmbOpen_DropDown);
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(0, 8);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(104, 24);
            this.label7.TabIndex = 0;
            this.label7.Tag = "SID_OPEN/NEW_QUERY";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 243);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(140, 16);
            this.label2.TabIndex = 3;
            this.label2.Tag = "SID_SELE_MASTER_PLANT_ITEM";
            // 
            // barItem1
            // 
            this.barItem1.CategoryIndex = -1;
            this.barItem1.ID = "     Execute";
            this.barItem1.ImageIndex = 3;
            this.barItem1.ImageList = this.imageList4;
            this.barItem1.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItem1.Tag = "SID_EXECUTE";
            // 
            // imageList4
            // 
            this.imageList4.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList4.ImageStream")));
            this.imageList4.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList4.Images.SetKeyName(0, "");
            this.imageList4.Images.SetKeyName(1, "");
            this.imageList4.Images.SetKeyName(2, "");
            this.imageList4.Images.SetKeyName(3, "");
            this.imageList4.Images.SetKeyName(4, "");
            // 
            // btnExecute
            // 
            this.btnExecute.CategoryIndex = -1;
            this.btnExecute.ID = "     Execute";
            this.btnExecute.ImageIndex = 3;
            this.btnExecute.ImageList = this.imageList3;
            this.btnExecute.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.btnExecute.Tag = "SID_EXECUTE";
            // 
            // imageList3
            // 
            this.imageList3.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList3.ImageStream")));
            this.imageList3.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList3.Images.SetKeyName(0, "");
            this.imageList3.Images.SetKeyName(1, "");
            this.imageList3.Images.SetKeyName(2, "");
            this.imageList3.Images.SetKeyName(3, "");
            this.imageList3.Images.SetKeyName(4, "");
            // 
            // pnlModes
            // 
            this.pnlModes.Controls.Add(this.chkLstModes);
            this.pnlModes.Location = new System.Drawing.Point(2, 90);
            this.pnlModes.Name = "pnlModes";
            this.pnlModes.Size = new System.Drawing.Size(276, 484);
            this.pnlModes.TabIndex = 3;
            // 
            // chkLstModes
            // 
            this.chkLstModes.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.chkLstModes.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.chkLstModes.ForeColor = System.Drawing.SystemColors.WindowText;
            this.chkLstModes.Items.AddRange(new object[] {
            "Measurements",
            "System Status",
            "Scenarios",
            "Optimizer",
            "Model",
            "FLO"});
            this.chkLstModes.Location = new System.Drawing.Point(8, 8);
            this.chkLstModes.Name = "chkLstModes";
            this.chkLstModes.Size = new System.Drawing.Size(232, 90);
            this.chkLstModes.TabIndex = 0;
            this.chkLstModes.ThreeDCheckBoxes = true;
            // 
            // pnlTemplates
            // 
            this.pnlTemplates.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.pnlTemplates.Controls.Add(this.chkLstTemplates);
            this.pnlTemplates.Location = new System.Drawing.Point(2, 24);
            this.pnlTemplates.Name = "pnlTemplates";
            this.pnlTemplates.Size = new System.Drawing.Size(252, 0);
            this.pnlTemplates.TabIndex = 2;
            // 
            // chkLstTemplates
            // 
            this.chkLstTemplates.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.chkLstTemplates.Items.AddRange(new object[] {
            "View Plant Items(Standard)",
            "View Plant Items(Implementor)",
            "View Plant Items(Operator)"});
            this.chkLstTemplates.Location = new System.Drawing.Point(8, 8);
            this.chkLstTemplates.Name = "chkLstTemplates";
            this.chkLstTemplates.Size = new System.Drawing.Size(240, 90);
            this.chkLstTemplates.TabIndex = 0;
            // 
            // pnlScenarios
            // 
            this.pnlScenarios.Controls.Add(this.lblUser);
            this.pnlScenarios.Controls.Add(this.cmbUsers);
            this.pnlScenarios.Controls.Add(this.rdBtDynamicCase);
            this.pnlScenarios.Controls.Add(this.rdBtnSavedViews);
            this.pnlScenarios.Location = new System.Drawing.Point(2, 544);
            this.pnlScenarios.Name = "pnlScenarios";
            this.pnlScenarios.Size = new System.Drawing.Size(252, 0);
            this.pnlScenarios.TabIndex = 2;
            // 
            // lblUser
            // 
            this.lblUser.Location = new System.Drawing.Point(8, 16);
            this.lblUser.Name = "lblUser";
            this.lblUser.Size = new System.Drawing.Size(40, 24);
            this.lblUser.TabIndex = 3;
            this.lblUser.Tag = "SID_USER";
            // 
            // cmbUsers
            // 
            this.cmbUsers.Location = new System.Drawing.Point(56, 8);
            this.cmbUsers.Name = "cmbUsers";
            this.cmbUsers.Size = new System.Drawing.Size(160, 21);
            this.cmbUsers.TabIndex = 2;
            // 
            // rdBtDynamicCase
            // 
            this.rdBtDynamicCase.Location = new System.Drawing.Point(112, 40);
            this.rdBtDynamicCase.Name = "rdBtDynamicCase";
            this.rdBtDynamicCase.Size = new System.Drawing.Size(104, 24);
            this.rdBtDynamicCase.TabIndex = 1;
            this.rdBtDynamicCase.Tag = "SID_DYNAMIC_CASE";
            // 
            // rdBtnSavedViews
            // 
            this.rdBtnSavedViews.Location = new System.Drawing.Point(16, 40);
            this.rdBtnSavedViews.Name = "rdBtnSavedViews";
            this.rdBtnSavedViews.Size = new System.Drawing.Size(104, 24);
            this.rdBtnSavedViews.TabIndex = 0;
            this.rdBtnSavedViews.Tag = "SID_SAVED_VIEWS";
            // 
            // gpVTemplates
            // 
            this.gpVTemplates.BackColor = System.Drawing.SystemColors.ControlLightLight;
            this.gpVTemplates.GroupViewItems.AddRange(new Syncfusion.Windows.Forms.Tools.GroupViewItem[] {
            new Syncfusion.Windows.Forms.Tools.GroupViewItem("Choose Templates", -1)});
            this.gpVTemplates.LargeImageList = null;
            this.gpVTemplates.Location = new System.Drawing.Point(2, 24);
            this.gpVTemplates.Name = "gpVTemplates";
            this.gpVTemplates.Size = new System.Drawing.Size(316, 0);
            this.gpVTemplates.SmallImageList = null;
            this.gpVTemplates.TabIndex = 3;
            this.gpVTemplates.Text = "groupView1";
            // 
            // gpVModes
            // 
            this.gpVModes.GroupViewItems.AddRange(new Syncfusion.Windows.Forms.Tools.GroupViewItem[] {
            new Syncfusion.Windows.Forms.Tools.GroupViewItem("Select Modes", -1)});
            this.gpVModes.LargeImageList = null;
            this.gpVModes.Location = new System.Drawing.Point(2, 90);
            this.gpVModes.Name = "gpVModes";
            this.gpVModes.Size = new System.Drawing.Size(316, 476);
            this.gpVModes.SmallImageList = null;
            this.gpVModes.TabIndex = 0;
            this.gpVModes.Text = "groupView1";
            // 
            // gpVPlantItems
            // 
            this.gpVPlantItems.GroupViewItems.AddRange(new Syncfusion.Windows.Forms.Tools.GroupViewItem[] {
            new Syncfusion.Windows.Forms.Tools.GroupViewItem("PlantItems", -1)});
            this.gpVPlantItems.LargeImageList = null;
            this.gpVPlantItems.Location = new System.Drawing.Point(2, 46);
            this.gpVPlantItems.Name = "gpVPlantItems";
            this.gpVPlantItems.Size = new System.Drawing.Size(316, 0);
            this.gpVPlantItems.SmallImageList = null;
            this.gpVPlantItems.TabIndex = 2;
            this.gpVPlantItems.Text = "groupView1";
            // 
            // gpvScenarios
            // 
            this.gpvScenarios.GroupViewItems.AddRange(new Syncfusion.Windows.Forms.Tools.GroupViewItem[] {
            new Syncfusion.Windows.Forms.Tools.GroupViewItem("User", -1),
            new Syncfusion.Windows.Forms.Tools.GroupViewItem("Saved Views", -1),
            new Syncfusion.Windows.Forms.Tools.GroupViewItem("Dynamic View", -1)});
            this.gpvScenarios.LargeImageList = null;
            this.gpvScenarios.Location = new System.Drawing.Point(2, 68);
            this.gpvScenarios.Name = "gpvScenarios";
            this.gpvScenarios.Size = new System.Drawing.Size(236, 380);
            this.gpvScenarios.SmallImageList = null;
            this.gpvScenarios.TabIndex = 1;
            this.gpvScenarios.Text = "groupView1";
            // 
            // xpToolBar1
            // 
            this.xpToolBar1.Dock = System.Windows.Forms.DockStyle.Top;
            this.xpToolBar1.Enabled = false;
            this.xpToolBar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItemSave,
            this.barItemPrint,
            this.barItemCopy,
            this.barItemPaste,
            this.barItemDelete,
            this.barItemClear,
            this.barItemArrangeCols,
            this.barItemExport});
            this.xpToolBar1.Location = new System.Drawing.Point(1, 0);
            this.xpToolBar1.Name = "xpToolBar1";
            this.xpToolBar1.Size = new System.Drawing.Size(702, 25);
            this.xpToolBar1.TabIndex = 0;
            this.xpToolBar1.Text = "xpToolBar1";
            this.xpToolBar1.ThemesEnabled = true;
            // 
            // barItemSave
            // 
            this.barItemSave.CategoryIndex = -1;
            this.barItemSave.ID = "Save";
            this.barItemSave.ImageIndex = 0;
            this.barItemSave.ImageList = this.imageList2;
            this.barItemSave.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemSave.Tag = "SID_SAVE";
            this.barItemSave.Tooltip = "Click here to save";
            // 
            // imageList2
            // 
            this.imageList2.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList2.ImageStream")));
            this.imageList2.TransparentColor = System.Drawing.SystemColors.Desktop;
            this.imageList2.Images.SetKeyName(0, "");
            this.imageList2.Images.SetKeyName(1, "");
            this.imageList2.Images.SetKeyName(2, "");
            this.imageList2.Images.SetKeyName(3, "");
            this.imageList2.Images.SetKeyName(4, "");
            this.imageList2.Images.SetKeyName(5, "");
            this.imageList2.Images.SetKeyName(6, "");
            this.imageList2.Images.SetKeyName(7, "");
            // 
            // barItemPrint
            // 
            this.barItemPrint.CategoryIndex = -1;
            this.barItemPrint.ID = "Print";
            this.barItemPrint.ImageIndex = 1;
            this.barItemPrint.ImageList = this.imageList2;
            this.barItemPrint.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemPrint.Tag = "SID_PRINT";
            this.barItemPrint.Tooltip = "Click here to print.";
            // 
            // barItemCopy
            // 
            this.barItemCopy.CategoryIndex = -1;
            this.barItemCopy.ID = "Copy";
            this.barItemCopy.ImageIndex = 2;
            this.barItemCopy.ImageList = this.imageList2;
            this.barItemCopy.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
            this.barItemCopy.Tag = "SID_COPY";
            this.barItemCopy.Tooltip = "Click here to copy a row or the selection";
            // 
            // barItemPaste
            // 
            this.barItemPaste.CategoryIndex = -1;
            this.barItemPaste.ID = "Paste";
            this.barItemPaste.ImageIndex = 3;
            this.barItemPaste.ImageList = this.imageList2;
            this.barItemPaste.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
            this.barItemPaste.Tag = "SID_PASTE";
            this.barItemPaste.Tooltip = "Click here to paste a row or the selection";
            // 
            // barItemDelete
            // 
            this.barItemDelete.CategoryIndex = -1;
            this.barItemDelete.ID = "Delete";
            this.barItemDelete.ImageIndex = 4;
            this.barItemDelete.ImageList = this.imageList2;
            this.barItemDelete.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemDelete.Tag = "SID_DEL";
            this.barItemDelete.Tooltip = "Click here to delete the row.";
            // 
            // barItemClear
            // 
            this.barItemClear.CategoryIndex = -1;
            this.barItemClear.ID = "Clear Filter";
            this.barItemClear.ImageIndex = 5;
            this.barItemClear.ImageList = this.imageList2;
            this.barItemClear.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemClear.Tag = "SID_CLEAR_FILTER";
            this.barItemClear.Tooltip = "Click here to clear the filter criteria specified.";
            // 
            // barItemArrangeCols
            // 
            this.barItemArrangeCols.CategoryIndex = -1;
            this.barItemArrangeCols.ID = "Arrange columns";
            this.barItemArrangeCols.ImageIndex = 7;
            this.barItemArrangeCols.ImageList = this.imageList2;
            this.barItemArrangeCols.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemArrangeCols.Tag = "SID_ARRANGE_COL";
            this.barItemArrangeCols.Tooltip = "Click here to specify the columns";
            // 
            // barItemExport
            // 
            this.barItemExport.CategoryIndex = -1;
            this.barItemExport.ID = "Export";
            this.barItemExport.ImageIndex = 6;
            this.barItemExport.ImageList = this.imageList2;
            this.barItemExport.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.ImageAndText;
            this.barItemExport.Tag = "SID_EXPORT";
            this.barItemExport.Tooltip = "Click here to export the data";
            // 
            // gridPlantItems2
            // 
            this.gridPlantItems2.AllowDragSelectedCols = true;
            this.gridPlantItems2.EnableAddNew = false;
            this.gridPlantItems2.EnableRemove = false;
            this.gridPlantItems2.Location = new System.Drawing.Point(0, 0);
            this.gridPlantItems2.Name = "gridPlantItems2";
            this.gridPlantItems2.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
            this.gridPlantItems2.Size = new System.Drawing.Size(130, 80);
            this.gridPlantItems2.SmartSizeBox = false;
            this.gridPlantItems2.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
            // 
            // textBox2
            // 
            this.textBox2.Location = new System.Drawing.Point(536, 8);
            this.textBox2.Name = "textBox2";
            this.textBox2.ReadOnly = true;
            this.textBox2.Size = new System.Drawing.Size(136, 20);
            this.textBox2.TabIndex = 29;
            // 
            // textBox1
            // 
            this.textBox1.Location = new System.Drawing.Point(240, 8);
            this.textBox1.Name = "textBox1";
            this.textBox1.ReadOnly = true;
            this.textBox1.Size = new System.Drawing.Size(136, 20);
            this.textBox1.TabIndex = 27;
            // 
            // lblRunStartTime
            // 
            this.lblRunStartTime.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.lblRunStartTime.Location = new System.Drawing.Point(144, 8);
            this.lblRunStartTime.Name = "lblRunStartTime";
            this.lblRunStartTime.Size = new System.Drawing.Size(110, 23);
            this.lblRunStartTime.TabIndex = 26;
            // 
            // pnlFull
            // 
            this.pnlFull.AutoScroll = true;
            this.pnlFull.Controls.Add(this.pnlGridContainer);
            this.pnlFull.Controls.Add(this.pnlRun);
            this.pnlFull.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlFull.Location = new System.Drawing.Point(0, 0);
            this.pnlFull.Name = "pnlFull";
            this.pnlFull.Size = new System.Drawing.Size(802, 576);
            this.pnlFull.TabIndex = 8;
            // 
            // pnlGridContainer
            // 
            this.pnlGridContainer.AutoScroll = true;
            this.pnlGridContainer.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.pnlGridContainer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pnlGridContainer.Dock = System.Windows.Forms.DockStyle.Fill;
            this.pnlGridContainer.Location = new System.Drawing.Point(0, 80);
            this.pnlGridContainer.Name = "pnlGridContainer";
            this.pnlGridContainer.Size = new System.Drawing.Size(802, 496);
            this.pnlGridContainer.TabIndex = 5;
            this.pnlGridContainer.Click += new System.EventHandler(this.pnlGridContainer_Click);
            // 
            // pnlRun
            // 
            this.pnlRun.AutoScroll = true;
            this.pnlRun.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.pnlRun.Controls.Add(this.btnSaveView);
            this.pnlRun.Controls.Add(this.chkRecTrendingFlag);
            this.pnlRun.Controls.Add(this.btnTranspose);
            this.pnlRun.Controls.Add(this.groupBox2);
            this.pnlRun.Dock = System.Windows.Forms.DockStyle.Top;
            this.pnlRun.Location = new System.Drawing.Point(0, 0);
            this.pnlRun.Name = "pnlRun";
            this.pnlRun.Size = new System.Drawing.Size(802, 80);
            this.pnlRun.TabIndex = 4;
            this.pnlRun.Click += new System.EventHandler(this.pnlGridContainer_Click);
            // 
            // btnSaveView
            // 
            this.btnSaveView.Location = new System.Drawing.Point(682, 30);
            this.btnSaveView.Name = "btnSaveView";
            this.btnSaveView.Size = new System.Drawing.Size(67, 23);
            this.btnSaveView.TabIndex = 34;
            this.btnSaveView.Tag = "SID_SAVE_VIEW";
            this.btnSaveView.Text = "Save View";
            this.btnSaveView.UseVisualStyleBackColor = false;
            this.btnSaveView.Click += new System.EventHandler(this.btnSaveView_Click);
            // 
            // chkRecTrendingFlag
            // 
            this.chkRecTrendingFlag.AutoSize = true;
            this.chkRecTrendingFlag.Checked = true;
            this.chkRecTrendingFlag.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkRecTrendingFlag.Location = new System.Drawing.Point(760, 34);
            this.chkRecTrendingFlag.Name = "chkRecTrendingFlag";
            this.chkRecTrendingFlag.Size = new System.Drawing.Size(15, 14);
            this.chkRecTrendingFlag.TabIndex = 35;
            this.chkRecTrendingFlag.Tag = "SID_REC_TREND_FLAG";
            this.chkRecTrendingFlag.UseVisualStyleBackColor = true;
            this.chkRecTrendingFlag.CheckedChanged += new System.EventHandler(this.chkRecTrendingFlag_CheckedChanged);
            // 
            // btnTranspose
            // 
            this.btnTranspose.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.btnTranspose.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.btnTranspose.ImageIndex = 11;
            this.btnTranspose.ImageList = this.imageList1;
            this.btnTranspose.Location = new System.Drawing.Point(602, 30);
            this.btnTranspose.Name = "btnTranspose";
            this.btnTranspose.Size = new System.Drawing.Size(75, 23);
            this.btnTranspose.TabIndex = 34;
            this.btnTranspose.Tag = "SID_TRANSPOSE";
            this.btnTranspose.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.btnTranspose.UseVisualStyleBackColor = false;
            this.btnTranspose.Click += new System.EventHandler(this.btnTranspose_Click);
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.lblRunStart);
            this.groupBox2.Controls.Add(this.lblEndRun);
            this.groupBox2.Controls.Add(this.txtRunStartTime);
            this.groupBox2.Controls.Add(this.txtRunEndTime);
            this.groupBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.groupBox2.Location = new System.Drawing.Point(40, 8);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(556, 64);
            this.groupBox2.TabIndex = 32;
            this.groupBox2.TabStop = false;
            this.groupBox2.Tag = "SID_TIME_SERIES_DATA";
            // 
            // lblRunStart
            // 
            this.lblRunStart.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.lblRunStart.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblRunStart.Location = new System.Drawing.Point(8, 32);
            this.lblRunStart.Name = "lblRunStart";
            this.lblRunStart.Size = new System.Drawing.Size(120, 23);
            this.lblRunStart.TabIndex = 30;
            this.lblRunStart.Tag = "SID_RUN_START_DATETIME";
            // 
            // lblEndRun
            // 
            this.lblEndRun.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.lblEndRun.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lblEndRun.Location = new System.Drawing.Point(288, 32);
            this.lblEndRun.Name = "lblEndRun";
            this.lblEndRun.Size = new System.Drawing.Size(112, 23);
            this.lblEndRun.TabIndex = 31;
            this.lblEndRun.Tag = "SID_RUN_DATE_DATETIME";
            // 
            // txtRunStartTime
            // 
            this.txtRunStartTime.AcceptsReturn = true;
            this.txtRunStartTime.Enabled = false;
            this.txtRunStartTime.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.txtRunStartTime.Location = new System.Drawing.Point(136, 32);
            this.txtRunStartTime.Name = "txtRunStartTime";
            this.txtRunStartTime.Size = new System.Drawing.Size(136, 20);
            this.txtRunStartTime.TabIndex = 36;
            // 
            // txtRunEndTime
            // 
            this.txtRunEndTime.Enabled = false;
            this.txtRunEndTime.ForeColor = System.Drawing.SystemColors.WindowText;
            this.txtRunEndTime.Location = new System.Drawing.Point(408, 32);
            this.txtRunEndTime.Name = "txtRunEndTime";
            this.txtRunEndTime.Size = new System.Drawing.Size(136, 20);
            this.txtRunEndTime.TabIndex = 37;
            // 
            // gridDropDownProperties
            // 
            this.gridDropDownProperties.AllowDragSelectedCols = true;
            this.gridDropDownProperties.EnableAddNew = false;
            this.gridDropDownProperties.EnableRemove = false;
            this.gridDropDownProperties.Location = new System.Drawing.Point(0, 0);
            this.gridDropDownProperties.Name = "gridDropDownProperties";
            this.gridDropDownProperties.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
            this.gridDropDownProperties.Size = new System.Drawing.Size(130, 80);
            this.gridDropDownProperties.SmartSizeBox = false;
            this.gridDropDownProperties.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
            // 
            // InputOutputViews
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(224)))), ((int)(((byte)(224)))), ((int)(((byte)(224)))));
            this.ClientSize = new System.Drawing.Size(802, 576);
            this.Controls.Add(this.pnlFull);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "InputOutputViews";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Tag = "SID_IO_VIEWS";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Load += new System.EventHandler(this.InputOutputViews_Load);
            this.Closed += new System.EventHandler(this.InputOutputViews_Closed);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.InputOutputViews_Closing);
            ((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();
            this.pnlFilterSection.ResumeLayout(false);
            this.pnlUp.ResumeLayout(false);
            this.panel4.ResumeLayout(false);
            this.panel7.ResumeLayout(false);
            this.panel10.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridSiteSpecificProperties)).EndInit();
            this.panel9.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridProperties2)).EndInit();
            this.pnlSiteComps.ResumeLayout(false);
            this.panel6.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems)).EndInit();
            this.pnlAggregates.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridAggregates)).EndInit();
            this.panel3.ResumeLayout(false);
            this.groupBox4.ResumeLayout(false);
            this.groupBox1.ResumeLayout(false);
            this.pnlLeft.ResumeLayout(false);
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridMasterPlantItems)).EndInit();
            this.pnlCombo.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.comboBoxBase1)).EndInit();
            this.pnlGridMasterPlantItems.ResumeLayout(false);
            this.pnlModes.ResumeLayout(false);
            this.pnlTemplates.ResumeLayout(false);
            this.pnlScenarios.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.gridPlantItems2)).EndInit();
            this.pnlFull.ResumeLayout(false);
            this.pnlRun.ResumeLayout(false);
            this.pnlRun.PerformLayout();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.gridDropDownProperties)).EndInit();
            this.ResumeLayout(false);

		}

        void btnSaveView_Click(object sender, EventArgs e)
        {
            SaveQuery();
        }
		#endregion



		#region Private Methods
		
		#region InitDataSource
		/// <summary>
		/// This method initializes the data source for the screen.
		/// Mainly the Levels and Level Links objects used as a 
		/// datasource for the treeview in this form..
		/// </summary>
		private void InitDataSource()
		{	

			if(_lrrLevels != null)
				_lrrLevels.Clear();
			if(_lrrLevelLinks != null)
				_lrrLevelLinks.Clear();
			if(_lrrModes != null)
				_lrrModes.Clear();
			if(_lrrSiteComps != null)
				_lrrSiteComps.Clear();
			if(_lrrSearchTables != null)
				_lrrSearchTables.Clear();
			if(_lrrResultViewTemplates != null)
				_lrrResultViewTemplates.Clear();
			if(_lrrSearchCriterias != null)
				_lrrSearchCriterias.Clear();
			if(lrrComptypes != null)
				lrrComptypes.Clear();
//			if(_lrrComplexEquipments != null)
//				_lrrComplexEquipments.Clear();

			//For Aggregates
			if(_lrrAggregates != null)
				_lrrAggregates.Clear();
			if(_lrrAggregateProperties != null)
				_lrrAggregateProperties.Clear();
			if(_lrrAggregatePropertyValues != null)
				_lrrAggregatePropertyValues.Clear();
			
			//Initialize and populate the levels
			_lrrLevels = new LRRLevels();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLevels,false);

			//Initialize and populate the level links
			_lrrLevelLinks = new LRRLevelLinks();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrLevelLinks,false);

//			_lrrModes = new LRRModes();
//			_lrrApp.DBManagerObj.PopulateCollection(_lrrModes,null);

			_lrrSiteComps=new LRRSiteComponents();
			//			_lrrApp.DBManagerObj.PopulateCollection(_lrrSiteComps,null);

			_lrrSiteComps3 = new LRRSiteComponents();


//			_lrrSearchTables=new LRRSearchTables();
//			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchTables,null);

//			_lrrResultViewTemplates=new LRRResultViewTemplates();
//			_lrrApp.DBManagerObj.PopulateCollection(_lrrResultViewTemplates,null);

			_lrrSearchCriterias=new LRRSearchCriterias();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchCriterias," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_lrrSearchCriterias = _lrrSearchCriterias.FilterForUserByUserID();

//			_lrrComplexEquipments=new LRRComplexEquipments();
//			_lrrApp.DBManagerObj.PopulateCollection(_lrrComplexEquipments,false);
			
			_lrrMasterComponents = new LRRMasterComponents();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrMasterComponents,false);
			
			_lrrMasterComponents2 = new LRRMasterComponents();

			_lrrMasterProperties = new LRRMasterProperties();
//			_lrrApp.DBManagerObj.PopulateCollection(_lrrMasterProperties,false);

			/* lrrMasterProperties = new LRRMasterProperties();
			_lrrApp.DBManagerObj.PopulateCollection(lrrMasterProperties,false);*/
			lrrMasterProperties = LRRModel.MasterComponentPropertiesObj; 
			


			lrrComptypes = new LRRComponentTypes();
			_lrrApp.DBManagerObj.PopulateCollection(lrrComptypes,false);

//			_lrrProperties = new LRRSiteComponentProperties();
//			_lrrApp.DBManagerObj.PopulateCollection(_lrrProperties,false);

			siteComponents2 = LRRModel.SiteComponentsObj.Clone() as LRRSiteComponents;
			//_lrrApp.DBManagerObj.PopulateCollection(siteComponents2,false);//LRRModel.SiteComponentsObj.Clone() as LRRSiteComponents;
			//siteComponents2 = _lrrApp.LRRDataStoreObj.GetCopyOfDataStoreObject(typeof(LRRSiteComponents)) as LRRSiteComponents;
			siteComponentPlantSpecificProps = new LRRSiteComponentProperties();
//			_lrrApp.DBManagerObj.PopulateCollection(siteComponentPlantSpecificProps,false);

			siteComponentPlantSpecific = new LRRSiteComponents();
//			_lrrApp.DBManagerObj.PopulateCollection(siteComponentPlantSpecific,false);

			//Populate Aggregates
			_lrrAggregates = new LRRAggregates();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrAggregates,false);

			_lrrGridAggregates = new LRRAggregates();

			_lrrAggregateProperties = new LRRAggregateProperties();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrAggregateProperties,false);

			_lrrAggregatePropertyValues = new LRRAggregatePropertyValues();
			_lrrApp.DBManagerObj.PopulateCollection(_lrrAggregatePropertyValues,false);

			_lrrResultAggregates = new LRRAggregates();

			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriterias," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_SearchCriterias = _SearchCriterias.FilterForUserByUserID();

			_lrrApp.DBManagerObj.PopulateCollection(_SearchModes," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchLevels,"",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItems," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItemProperties,"",false,true);
			//Aggregates
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaAggregateItems," WHERE (Source = 'I/O' OR  Source is null) ",false,true);

			//Populate Master Items and Comp Types
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaMasterItems,"",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaComponentTypes,"",false,true);
		}
		#endregion
		#region MasterComponentTypes
		private void BindChkBoxListMastCompType()
		{
			for(int i=0;i<lrrComptypes.Count;i++)
			{
				LRRComponentType  compType=lrrComptypes[i] as LRRComponentType;
				checkedListBox1.Items.Add(compType.Name,System.Windows.Forms.CheckState.Checked);
			}
		}

		#endregion

		#region PopulateLevels
		/// <summary>
		/// This Method is used to populate a treeview with the level 
		/// and the link table..
		/// </summary>
		/// <param name="treeView">TreeView Instance</param>
		/// <param name="levels">levels table</param>
		/// <param name="levelLinks">level link table</param>
		/// <returns></returns>
		private bool PopulateLevels(TreeView treeView,LRRLevels levels,LRRLevelLinks levelLinks)
		{
			//treeView.Nodes.Clear();
			try
			{
				Hashtable			_levelHash = new Hashtable();
				Hashtable				_nodesHash = new Hashtable();
				Hashtable				_childParent = new Hashtable();

				foreach(LRRLevel l in levels)
				{
					_levelHash.Add(l.LevelID,l);
				}
				foreach(LRRLevelLink ll in levelLinks)
				{
					_childParent.Add(ll.ChildID,ll.ParentID);

					if(_nodesHash.ContainsKey(ll.ParentID))
					{
						TreeNode foundNode = _nodesHash[ll.ParentID] as TreeNode;
						LRRLevel foundLevel = _levelHash[ll.ChildID] as LRRLevel; 
						TreeNode childNode = new TreeNode(foundLevel.Name);
						childNode.Tag = foundLevel;
						foundNode.Nodes.Add(childNode);
                        //foundNode.Nodes.Sort(SortOrder.Ascending); 
                        
					}
					else
					{
						LRRLevel parentLevel = _levelHash[ll.ParentID] as LRRLevel;
						LRRLevel childLevel = _levelHash[ll.ChildID] as LRRLevel;
						TreeNode parentNode = new TreeNode(parentLevel.Name);
						parentNode.Tag = parentLevel;
						TreeNode childNode = new TreeNode(childLevel.Name);
						childNode.Tag = childLevel;
						parentNode.Nodes.Add(childNode);
                        //parentNode.Nodes.Sort(SortOrder.Ascending);
						_nodesHash.Add(ll.ParentID,parentNode);
					}
				}

				foreach(object k in _childParent.Keys)
				{
					string childID = (string)k;
					string parentID = (string)_childParent[k];
					TreeNode  childNode = null;
					TreeNode  parentNode = null;
					if(_nodesHash.ContainsKey(childID))
					{
						childNode = _nodesHash[childID] as TreeNode;
					}
					if(_nodesHash.ContainsKey(parentID))
					{
						parentNode = _nodesHash[parentID] as TreeNode;
					}
					if((parentNode != null) && (childNode != null))
					{
						int index = -1;
						foreach(TreeNode f in parentNode.Nodes)
						{
							if(f.Tag == childNode.Tag)
							{
								index = f.Index;
								break;
							}
						}
						if(index != -1)
							parentNode.Nodes[index] = childNode;
					}
				}

				TreeNode rootNode = _nodesHash["0"] as TreeNode;
                treeView.Nodes.Add(rootNode);
				return true;
			}
			catch(Exception ex)
			{
				string j=ex.Message.ToString(Symcon.BusinessObjects.SymConverter.Culture);
				Logger.LogMessage(typeof(InputOutputViews),"PopulateLevels:"+ex.Message  ,Logger.Level.Debug);
				return false;
			}
		}

       /* private bool PopulateLevels(Syncfusion.Windows.Forms.Tools.TreeViewAdv treeView, LRRLevels levels, LRRLevelLinks levelLinks)
        {
            //treeView.Nodes.Clear();
            try
            {
                Hashtable _levelHash = new Hashtable();
                Hashtable _nodesHash = new Hashtable();
                Hashtable _childParent = new Hashtable();

                foreach (LRRLevel l in levels)
                {
                    _levelHash.Add(l.LevelID, l);
                }
                foreach (LRRLevelLink ll in levelLinks)
                {
                    _childParent.Add(ll.ChildID, ll.ParentID);

                    if (_nodesHash.ContainsKey(ll.ParentID))
                    {
                        TreeNodeAdv foundNode = _nodesHash[ll.ParentID] as TreeNodeAdv;
                        LRRLevel foundLevel = _levelHash[ll.ChildID] as LRRLevel;
                        TreeNodeAdv childNode = new TreeNodeAdv(foundLevel.Name);
                        childNode.Tag = foundLevel;
                        foundNode.Nodes.Add(childNode);
                        foundNode.Nodes.Sort(SortOrder.Ascending);
                    }
                    else
                    {
                        LRRLevel parentLevel = _levelHash[ll.ParentID] as LRRLevel;
                        LRRLevel childLevel = _levelHash[ll.ChildID] as LRRLevel;
                        TreeNodeAdv parentNode = new TreeNodeAdv(parentLevel.Name);
                        parentNode.Tag = parentLevel;
                        TreeNodeAdv childNode = new TreeNodeAdv(childLevel.Name);
                        childNode.Tag = childLevel;
                        parentNode.Nodes.Add(childNode);
                        parentNode.Nodes.Sort(SortOrder.Ascending);
                        _nodesHash.Add(ll.ParentID, parentNode);
                    }
                }

                foreach (object k in _childParent.Keys)
                {
                    string childID = (string)k;
                    string parentID = (string)_childParent[k];
                    TreeNodeAdv childNode = null;
                    TreeNodeAdv parentNode = null;
                    if (_nodesHash.ContainsKey(childID))
                    {
                        childNode = _nodesHash[childID] as TreeNodeAdv;
                    }
                    if (_nodesHash.ContainsKey(parentID))
                    {
                        parentNode = _nodesHash[parentID] as TreeNodeAdv;
                    }
                    if ((parentNode != null) && (childNode != null))
                    {
                        int index = -1;
                        foreach (TreeNodeAdv f in parentNode.Nodes)
                        {
                            if (f.Tag == childNode.Tag)
                            {
                                index = f.Index;
                                break;
                            }
                        }
                        if (index != -1)
                            parentNode.Nodes[index] = childNode;
                    }
                }

                TreeNodeAdv rootNode = _nodesHash["0"] as TreeNodeAdv;
                treeView.Nodes.Add(rootNode);
                return true;
            }
            catch (Exception ex)
            {
                string j = ex.Message.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                Logger.LogMessage(typeof(InputOutputViews), "PopulateLevels:" + ex.Message, Logger.Level.Debug);
                return false;
            }
        }*/
	
		#endregion

		#region BindGridModes
		#endregion

		#region BindGridPlantItems

		private void BindGridPlantItems()
		{
			
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay = new Hashtable();

			//Suspend the Layout of the Grid...
			gridPlantItems.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridPlantItems);
			
			columnForDisplay.Add("IsSelected",null);
			columnForDisplay.Add("Name",null);
			columnForDisplay.Add("MasterComponentType",null);
			
			int i = gridPlantItems.TableDescriptor.SortedColumns.Add("Name");
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridPlantItems,_lrrSiteComps.ItemType,null,true,columnForDisplay);
		
			RelativeWidths.Add("IsSelected",10);
			RelativeWidths.Add("Name",30);
			RelativeWidths.Add("MasterComponentType",30);
			
			SyncGridUtilities.InitializeGridColumnsWidth(gridPlantItems,RelativeWidths );
			
			gridPlantItems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_SITECOMPONENTS") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			gridPlantItems.TableDescriptor.AllowEdit = true;
			gridPlantItems.TableDescriptor.AllowNew = false;
			gridPlantItems.TableDescriptor.AllowRemove = false;

			gridPlantItems.SourceListSet.Add("ParentTable",_lrrSiteComps);
			//Set the data store 
			gridPlantItems.DataSource = _lrrSiteComps;

			gridPlantItems.TableDescriptor.Columns["Name"].ReadOnly=true;
			gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].ReadOnly=true;
			gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridPlantItems.TableDescriptor.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;

			//Resume the Layout of the Grid...
			gridPlantItems.ResumeLayout(false);
			
			//Events for check/uncheck all items
			gridPlantItems.TableControlQueryAllowSortColumn+=new GridQueryAllowSortColumnEventHandler(gridPlantItems_TableControlQueryAllowSortColumn);
			gridPlantItems.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);
			gridPlantItems.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridPlantItems_QueryCellStyleInfo);
			gridPlantItems.SaveCellText+=new GridCellTextEventHandler(gridPlantItems_SaveCellText);
		}
		#endregion

		#region BindGridMasterPlantItems

		private void BindGridMasterPlantItems()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay = new Hashtable();

			//Suspend the Layout of the Grid...
			gridMasterPlantItems.SuspendLayout();
			
			int i = gridMasterPlantItems.TableDescriptor.SortedColumns.Add("ComponentName");
			SyncGridUtilities.InitializeGridLookAndFeel(gridMasterPlantItems);
			
			columnForDisplay.Add("IsSelected",null);
			columnForDisplay.Add("ComponentName",null);
			
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridMasterPlantItems,_lrrMasterComponents.ItemType,null,true,columnForDisplay);
		
			RelativeWidths.Add("IsSelected",15);
			RelativeWidths.Add("ComponentName",67);
			
			SyncGridUtilities.InitializeGridColumnsWidth(gridMasterPlantItems,RelativeWidths );
			
			gridMasterPlantItems.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_MASTER_PLANT_ITEMS") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");   

			gridMasterPlantItems.TableDescriptor.AllowEdit = true;
			gridMasterPlantItems.TableDescriptor.AllowNew = false;
			gridMasterPlantItems.TableDescriptor.AllowRemove = false;
			gridMasterPlantItems.TableDescriptor.Columns["ComponentName"].ReadOnly=true;
			
			//Set the data store 
			gridMasterPlantItems.DataSource = _lrrMasterComponents;

			//Resume the Layout of the Grid...
			gridMasterPlantItems.ResumeLayout(false);
		}

		#endregion

		#region BindGridProperties

		private void BindGridProperties()
		{
			//Suspend the Layout of the Grid...
			gridProperties2.SuspendLayout();
			Hashtable columnForDisplay = new Hashtable();
			Hashtable RelativeWidths = new Hashtable();

			SyncGridUtilities.InitializeGridLookAndFeel(gridProperties2);
			
			columnForDisplay.Add("ComponentName",null);
			gridProperties2.TableDescriptor.Relations.Clear();
			//Initialize the columns for the grid...
			SyncGridUtilities.InitializeGridColumns(gridProperties2,_lrrMasterComponents2.ItemType,null,true,columnForDisplay);

			this.gridProperties2.TableDescriptor.RecordFilters.Clear();

			gridProperties2.TopLevelGroupOptions.ShowFilterBar = false;

			gridProperties2.TableDescriptor.AllowNew = false;
			gridProperties2.TableDescriptor.AllowRemove = true;
			gridProperties2.TableDescriptor.AllowEdit = true;
			gridProperties2.TableDescriptor.Relations.Clear();
			
			//gridProperties2.Width = pnlGridProperties.Width/2;
			//panel8.Width = pnlGridProperties.Width/2;

			//Add the parent table for the Relations...
			gridProperties2.Engine.SourceListSet.Add("ParentTable",_lrrMasterComponents2);
			
			//Set the data source for the grid
			gridProperties2.DataSource = _lrrMasterComponents2;

			gridProperties2.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_MASTER_PLANT_ITEMS") + " {RecordCount} " + LRRHeaderText.GetHeaderString("SID_ITEMS");   
			gridProperties2.TableDescriptor.AllowEdit = false;
			gridProperties2.TableDescriptor.AllowNew = false;
			gridProperties2.TableDescriptor.AllowRemove = false;

			//Properties
			GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
			grdCompProps.ChildTableName = "Properties";
			grdCompProps.RelationKeys.Add("ID","ComponentID");
			grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Blue;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			gridProperties2.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
			grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			gridProperties2.TableDescriptor.Relations.Add(grdCompProps);
			gridProperties2.NestedTableGroupOptions.ShowFilterBar = false;
			gridProperties2.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridProperties2.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
			gridProperties2.Engine.SourceListSet.Add("Properties",_lrrMasterProperties);


			//Key Press and Key Down events
			gridProperties2.TableControlCurrentCellKeyDown+=new GridTableControlKeyEventHandler(gridProperties2_TableControlCurrentCellKeyDown);
			gridProperties2.TableControlCurrentCellKeyPress+=new GridTableControlKeyPressEventHandler(gridProperties2_TableControlCurrentCellKeyPress);

			Hashtable columnForChildTable = new Hashtable();
			columnForChildTable.Add("Name",null);
			columnForChildTable.Add("IsSelected",null);

			RelativeWidths.Add("IsSelected",5);
			RelativeWidths.Add("Name",40);

			SyncGridUtilities.InitializeGridColumns(gridProperties2,grdCompProps.ChildTableDescriptor,_lrrMasterProperties.ItemType,RelativeWidths,false,null,columnForChildTable,true);
			gridProperties2.ResumeLayout(false);

			GridColumnDescriptor newColWidth=gridProperties2.TableDescriptor.Columns["ComponentName"];
			newColWidth.Width = 170;

			//Events for CheckBox in header Row
//			gridProperties2.GetTableControl("Properties").MouseUp+=new MouseEventHandler(TableControl_MouseUp);
			gridProperties2.TableControlQueryAllowSortColumn+=new GridQueryAllowSortColumnEventHandler(gridPlantItems_TableControlQueryAllowSortColumn);
			gridProperties2.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp1);
//			gridProperties2.GetTableControl("Properties").MouseUp+=new MouseEventHandler(TableControl_MouseUp1);
			gridProperties2.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridProperties2_QueryCellStyleInfo);
			gridProperties2.SaveCellText+=new GridCellTextEventHandler(gridProperties2_SaveCellText);
		}

		#endregion

		#region Bind Grid Plant Specific Properties
		private void BindGridPlantSpecficProperties()
		{
			//Suspend the Layout of the Grid...
			gridSiteSpecificProperties.SuspendLayout();
			Hashtable columnForDisplay = new Hashtable();
			Hashtable RelativeWidths = new Hashtable();

			SyncGridUtilities.InitializeGridLookAndFeel(gridSiteSpecificProperties);
			
			columnForDisplay.Add("Name",null);
			gridSiteSpecificProperties.TableDescriptor.Relations.Clear();
			//Initialize the columns for the grid...
			SyncGridUtilities.InitializeGridColumns(gridSiteSpecificProperties,siteComponentPlantSpecific.ItemType,null,true,columnForDisplay);

			this.gridSiteSpecificProperties.TableDescriptor.RecordFilters.Clear();
			gridSiteSpecificProperties.TableDescriptor.AllowNew = false;
			gridSiteSpecificProperties.TableDescriptor.AllowRemove = true;
			gridSiteSpecificProperties.TableDescriptor.AllowEdit = true;
			gridSiteSpecificProperties.TableDescriptor.Relations.Clear();

			//gridSiteSpecificProperties.Width = pnlGridProperties.Width/2;
			//panel9.Width = pnlGridProperties.Width/2;

			//Add the parent table for the Relations...
			gridSiteSpecificProperties.Engine.SourceListSet.Add("ParentTable",siteComponentPlantSpecific);
			
			//Set the data source for the grid
			gridSiteSpecificProperties.DataSource = siteComponentPlantSpecific;

			gridSiteSpecificProperties.TableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			gridSiteSpecificProperties.TableDescriptor.AllowEdit = false;
			gridSiteSpecificProperties.TableDescriptor.AllowNew = false;
			gridSiteSpecificProperties.TableDescriptor.AllowRemove = false;

			//Properties
			GridRelationDescriptor grdCompProps = new GridRelationDescriptor("Properties");
			grdCompProps.ChildTableName = "Properties";
			grdCompProps.RelationKeys.Add("SiteComponentID","ComponentID");
			grdCompProps.RelationKind = RelationKind.RelatedMasterDetails;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.BackColor = Color.Blue;
			grdCompProps.ChildTableDescriptor.Appearance.GroupCaptionCell.TextColor = Color.White;
			grdCompProps.ChildTableDescriptor.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_ATTRIBUTES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			gridSiteSpecificProperties.ShowRelationFields = ShowRelationFields.ShowDisplayFieldsOnly;
			grdCompProps.ChildTableDescriptor.Appearance.AlternateRecordFieldCell.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.InactiveCaptionText);
			gridSiteSpecificProperties.TableDescriptor.Relations.Add(grdCompProps);
			gridSiteSpecificProperties.NestedTableGroupOptions.ShowFilterBar = false;
			gridSiteSpecificProperties.NestedTableGroupOptions.ShowAddNewRecordBeforeDetails = false;
			gridSiteSpecificProperties.NestedTableGroupOptions.ShowAddNewRecordAfterDetails = false;
			gridSiteSpecificProperties.Engine.SourceListSet.Add("Properties",siteComponentPlantSpecificProps);

			Hashtable columnForChildTable = new Hashtable();
			columnForChildTable.Add("Name",null);
			columnForChildTable.Add("IsSelected",null);

			RelativeWidths.Add("IsSelected",10);
			RelativeWidths.Add("Name",95);

			SyncGridUtilities.InitializeGridColumns(gridSiteSpecificProperties,grdCompProps.ChildTableDescriptor,siteComponentPlantSpecificProps.ItemType,RelativeWidths,false,null,columnForChildTable,true);
			gridSiteSpecificProperties.ResumeLayout(false);


			GridColumnDescriptor newColWidth=gridSiteSpecificProperties.TableDescriptor.Columns["Name"];
			newColWidth.Width = 168;

			//Events for CheckBox in header Row
			gridSiteSpecificProperties.TableControlQueryAllowSortColumn+=new GridQueryAllowSortColumnEventHandler(gridPlantItems_TableControlQueryAllowSortColumn);
			gridSiteSpecificProperties.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp2);
			gridSiteSpecificProperties.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridSiteSpecificProperties_QueryCellStyleInfo);
			gridSiteSpecificProperties.SaveCellText+=new GridCellTextEventHandler(gridSiteSpecificProperties_SaveCellText);

		}
		#endregion

		#region Bind Aggregates
		public void BindAggregates()
		{
			Hashtable RelativeWidths = new Hashtable();
			Hashtable columnForDisplay = new Hashtable();

			//Suspend the Layout of the Grid...
			gridAggregates.SuspendLayout();

			SyncGridUtilities.InitializeGridLookAndFeel(gridAggregates);
			
			columnForDisplay.Add("IsSelected",null);
			columnForDisplay.Add("Name",null);
			columnForDisplay.Add("EquipmentTypeID",null);
			
			int i = gridAggregates.TableDescriptor.SortedColumns.Add("Name");
			//Populate the columns for the grid object
			SyncGridUtilities.InitializeGridColumns(gridAggregates,_lrrGridAggregates.ItemType,null,true,columnForDisplay);
		
			RelativeWidths.Add("IsSelected",10);
			RelativeWidths.Add("Name",30);
			RelativeWidths.Add("EquipmentTypeID",30);
			
			SyncGridUtilities.InitializeGridColumnsWidth(gridAggregates,RelativeWidths );
			
			gridAggregates.TopLevelGroupOptions.CaptionText = LRRHeaderText.GetHeaderString("SID_AGGREGATES") +" {RecordCount} "+ LRRHeaderText.GetHeaderString("SID_ITEMS");  
			gridAggregates.TableDescriptor.AllowEdit = true;
			gridAggregates.TableDescriptor.AllowNew = false;
			gridAggregates.TableDescriptor.AllowRemove = false;

			gridAggregates.SourceListSet.Add("ParentTable",_lrrGridAggregates);
			//Set the data store 
			gridAggregates.DataSource = _lrrGridAggregates;

			gridAggregates.TableDescriptor.Columns["Name"].ReadOnly=true;
			gridAggregates.TableDescriptor.Columns["EquipmentTypeID_ComponentName"].ReadOnly=true;
			gridAggregates.TableDescriptor.Columns["EquipmentTypeID_ComponentName"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridAggregates.TableDescriptor.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;

			//Resume the Layout of the Grid...
			gridAggregates.ResumeLayout(false);

			//Events for check/uncheck all items
			gridAggregates.TableControlQueryAllowSortColumn+=new GridQueryAllowSortColumnEventHandler(gridPlantItems_TableControlQueryAllowSortColumn);
			gridAggregates.TableControl.MouseUp+=new MouseEventHandler(TableControl_MouseUp);
			gridAggregates.QueryCellStyleInfo+=new GridTableCellStyleInfoEventHandler(gridAggregates_QueryCellStyleInfo);
			gridAggregates.SaveCellText+=new GridCellTextEventHandler(gridAggregates_SaveCellText);
		}
		#endregion

		#region checkPlantItems

		private void checkPlantItems()
		{
			int checkCount=0;
			LRRSiteComponents componentsToRemove = new LRRSiteComponents();
			LRRSiteComponents componentsToAdd = new LRRSiteComponents();
			if(_lrrSiteComps2 == null)
				return;
			this._lrrSiteComp = new LRRSiteComponent[_lrrSiteComps2.Count];
			_lrrSiteComps2.CopyTo(_lrrSiteComp,0);
			foreach(LRRSiteComponent lsc in _lrrSiteComp)
			{
				bool check = false;
				foreach(LRRSiteComponent lsc2 in componentsToAdd)
				{
					if(lsc.SiteComponentID != null)
					{
						if(lsc.SiteComponentID.Equals(lsc2.SiteComponentID))
						{
							check=true;
							break;
						}
					}
				}
				if(check == false)
					componentsToAdd.Add(lsc);
			}

			ArrayList arrListCompIDs = new ArrayList();
			foreach(LRRMasterComponent lrrmc in _lrrMasterComponents)
			{
				arrListCompIDs.Add(lrrmc.ID);
				if(lrrmc.IsSelected == false)
				{
					foreach(LRRSiteComponent lsc in componentsToAdd)
					{
						if(lsc.MasterComponentType != null)
						{
							if(lsc.MasterComponentType.Equals(lrrmc.ID))
							{
								componentsToRemove.Add(lsc);		
							}
						}
					}
				}
				else
					checkCount++;
			}

			foreach(LRRSiteComponent lsc in componentsToAdd)
			{
				if(lsc.MasterComponentType != null && !arrListCompIDs.Contains(lsc.MasterComponentType))
				{
					componentsToRemove.Add(lsc);
					checkCount++;
				}
			}
			
			if(checkCount!=0)
			{
				foreach(LRRSiteComponent lsc in componentsToRemove)
				{
					componentsToAdd.Remove(lsc);
				}
			}
			gridPlantItems.CurrencyManager.List.Clear();
			foreach(LRRSiteComponent lsc in componentsToAdd)
			{
				gridPlantItems.CurrencyManager.List.Add(lsc);
			}

			gridPlantItems.TableDescriptor.Columns["Name"].ReadOnly=true;
			gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].ReadOnly=true;
			gridPlantItems.TableDescriptor.Columns["MasterComponentType_ComponentName"].Appearance.AnyRecordFieldCell.ExclusiveChoiceList = false;
			gridPlantItems.TableDescriptor.Appearance.AnyRecordFieldCell.ShowButtons = GridShowButtons.Hide;

			createMasterAndSiteSpecificProperties();
			createAggregateProperties();
	
		}

		#endregion

        #region check/uncheck all items in the treeview

        private void CheckUncheckAllItemsForTreeView(TreeNode winTreeNode,bool boolStatus)
        {
            winTreeNode.Checked = boolStatus;
            foreach (TreeNode node in winTreeNode.Nodes)
            {  
                node.Checked = boolStatus;
                if (node.Nodes.Count > 0)
                {
                    // If the current node has child nodes, call the UncheckAllNodes method recursively.
                    CheckUncheckAllItemsForTreeView(node, boolStatus);
                }
            }
        }
        #endregion


        #endregion

        #region Aggregates
        private void checkAggregates()
		{
			//IsChanged = true;
			_lrrGridAggregates.Clear();
			foreach(LRRMasterComponent lrrMasterComp in _lrrMasterComponents)
			{
				if(lrrMasterComp.IsSelected)
				{
					foreach(LRRAggregate lrrAggregate in _lrrAggregates)
					{
						if(lrrAggregate.EquipmentTypeID == lrrMasterComp.ID)
						{
							_lrrGridAggregates.Add(lrrAggregate);	
						}
					}
				}
			}
		}

		private void createAggregateProperties()
		{
			//IsChanged = true;
			foreach(LRRAggregate lrrAggregate in _lrrGridAggregates)
			{
				if(lrrAggregate.IsSelected)
				{
					//Filter for Master Component
					LRRMasterComponent lrrMasterComp = _lrrMasterComponents.GetMasterComponentByID(lrrAggregate.EquipmentTypeID);
					if(!_lrrMasterComponents2.Contains(lrrMasterComp))
					{
						_lrrMasterComponents2.Add(lrrMasterComp);
					}
					
					//Add Aggregate Properties in master Properties grid
					LRRAggregateProperties lrrAggProps = _lrrAggregateProperties.FilterPropertiesByAggregate(lrrAggregate.AggregateID);
					foreach(LRRAggregateProperty lrrAggrProp in lrrAggProps)
					{
						LRRMasterProperty lrrMasterProperty = lrrMasterProperties.GetMasterPropertyByID(lrrAggrProp.MasterPropertyID);
						if(bImplementer)
						{
							if(!_lrrMasterProperties.Contains(lrrMasterProperty))
								_lrrMasterProperties.Add(lrrMasterProperty);
						}
						else
						{
							if(lrrMasterProperty.IsExposed == true)
							{
								if(!_lrrMasterProperties.Contains(lrrMasterProperty))
									_lrrMasterProperties.Add(lrrMasterProperty);
							}
						}
					}
				}
			}
		}

		#endregion

		#region Fields

		private	LRRApp					_lrrApp; //All object to access the DB Manager and DB Adapter
		private LRRLevels				_lrrLevels=null; //Levels Object
		private LRRLevelLinks			_lrrLevelLinks = null; //Level Links object
		private LRRModes				_lrrModes=null;//Modes Object
		private LRRSiteComponents		_lrrSiteComps=null;
		private LRRSiteComponents		_lrrSiteComps2=null;
		private LRRSiteComponents		_lrrSiteComps3=null;

		private LRRResultViewTemplates	_lrrResultViewTemplates=null;
		private LRRSearchTables			_lrrSearchTables    =null;
		private LRRSearchCriterias		_lrrSearchCriterias = null;
		//private LRRComplexEquipments    _lrrComplexEquipments = null;
		private LRRMasterComponents		_lrrMasterComponents = null;
		private LRRMasterComponents		_lrrMasterComponents2 = null;

		private LRRMasterProperties		_lrrMasterProperties = null;
		private LRRMasterProperties		 lrrMasterProperties = null;
		private LRRSiteComponent[]		_lrrSiteComp = null;

		private LRRSiteComponents siteComponents2 = null;

		private	LRRSiteComponents	siteComponentPlantSpecific = null;
		private	LRRSiteComponentProperties	siteComponentPlantSpecificProps = null;
		private LRRComponentTypes lrrComptypes	= null;

		//For Aggregates
		private LRRAggregates				_lrrAggregates = null;
		private LRRAggregateProperties		_lrrAggregateProperties = null;
		private LRRAggregatePropertyValues  _lrrAggregatePropertyValues = null;
		private LRRAggregates				_lrrGridAggregates = null;
		private LRRAggregates				_lrrResultAggregates = null;
		private bool                                bImplementer = false;
		private ArrayList				_arrProperties = new ArrayList();
		//private GridPersistanceUtil		_gutil = new GridPersistanceUtil();
		public bool					    IsChanged = false;
        public static bool              BPropertyValChanged = false;
		private int						_newSavedQueryCount=0;
		private bool					_isLastQuerySaved = false;

		#endregion

		private void gridPlantItems2_CurrentCellChanged(object sender,System.EventArgs e)
		{
			//IsChanged = true;
			checkPlantItems();
		}

		

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		    this.textBox1.Text = sRunStartTime;
			this.textBox2.Text = sRunEndTime;
		}

		private void InputOutputViews_Load(object sender, System.EventArgs e)
		{
			_rsProperties = new ResultPropertiesWindow();
			_rsComponents = new ResultPropertiesWindow();
		
			//Bind ActiveRunControl Set and result screens start and end time
			txtRunStartTime.DataBindings.Clear();
			txtRunEndTime.DataBindings.Clear();
			txtRunStartTime.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"StartTimeValue");
			txtRunEndTime.DataBindings.Add("Text",_lrrApp.ActiveRunControlSet.DataWindowObj,"EndTimeValue");

			pnlRun.Visible=false;

			
			if(_siteComponents == null)
			{
				_siteComponents = new LRRSiteComponents();
			}
			
			cmbMasterPlantItem.DataSource = _lrrSearchTables;
			cmbMasterPlantItem.DisplayMember = "TableName";
			cmbMasterPlantItem.ValueMember = "ID";
			
			cmbOpen.DataSource = _lrrSearchCriterias;
			cmbOpen.DisplayMember = "Name";
			cmbOpen.ValueMember = "ID";
			LRRSearchCriteria srchCriteria = _lrrSearchCriterias.GetSearchCriteriaByID("0");
			if(srchCriteria != null)
				cmbOpen.SelectedItem = srchCriteria;
			this.dockingManager1.LoadDockState();
            ApplicationPersistanceUtil.ApplyGridSettings(this.pnlFilterSection, this, 200);
			Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
			_lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter,false);
		}

		private void cmbOpen_SelectedIndexChanged(object sender, System.EventArgs e)
		{
            try
            {
                if (!bFlag)
                {
                    bFlag = true;
                    return;
                }
                LRRSearchCriteria searchCriteria = cmbOpen.SelectedItem as LRRSearchCriteria;
                if (searchCriteria == null)
                    return;
                //_gutil.SetBytesToSizeXml(searchCriteria.SizeXml);
                TreeNode rootNode = trvLevels.Nodes[0];
                trvLevels.SelectedNode = trvLevels.Nodes[0];
                CheckUncheckAllItemsForTreeView(trvLevels.SelectedNode, false);
                Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversion(trvLevels.SelectedNode);

                //for(int i = trvLevels.NodeToRowIndex(trvLevels.SelectedNode); i < trvLevels.GetNodeCount(true) + 1; i++)
                //{
                //    //trvLevels.RowIndexToNode(i).Checked = false;
                //    //trvLevels.SelectedNode = trvLevels.RowIndexToNode(i);
                //}


                //trvLevels.SelectedNode = trvLevels.Nodes[0];

                _lrrSiteComps.Clear();
                _lrrMasterComponents2.Clear();
                _lrrMasterProperties.Clear();
                siteComponentPlantSpecific.Clear();
                siteComponentPlantSpecificProps.Clear();
                _lrrGridAggregates.Clear();
                arLevels.Clear();

                foreach (LRRMasterComponent lrrMasterComp in _lrrMasterComponents)
                {
                    lrrMasterComp.IsSelected = false;
                }

                for (int i = 0; i < checkedListBox1.Items.Count; i++)
                {
                    checkedListBox1.SetItemCheckState(i, CheckState.Checked);
                }

                if (!searchCriteria.ID.Equals("0"))
                {
                    _SearchModes.ItemFilter = "SearchCriteriaID = '" + searchCriteria.ID + "'";
                    _SearchLevels.ItemFilter = "SearchCriteriaID = '" + searchCriteria.ID + "'";
                    _SearchCriteriaItems.ItemFilter = "SearchCriteriaID = '" + searchCriteria.ID + "'";

                    //
                    LRRSearchCriteriaItemProperties searchCriteriaItemProperties = _SearchCriteriaItemProperties.FilterItemsBySearchCriteriaID(searchCriteria.ID);

                    //Aggregates
                    LRRSearchCriteriaAggregateItems searchCriteriaAggrItems = _SearchCriteriaAggregateItems.FilterAggregateItemsBySearchCriteriaID(searchCriteria.ID);

                    //Filter Master Items and Comp Types
                    LRRSearchCriteriaComponentTypes searchCriteriaCompTypes = _SearchCriteriaComponentTypes.FilterCompTypesBySearchCriteriaID(searchCriteria.ID);
                    LRRSearchCriteriaMasterItems searchCriteriaMasterItems = _SearchCriteriaMasterItems.FilterMasterItemsBySearchCriteriaID(searchCriteria.ID);


                    //Modes
                    //				Hashtable htSearchModes = new Hashtable();
                    //				foreach(LRRSearchCriteriaMode searchMode in _SearchModes)
                    //				{
                    //					if(!htSearchModes.Contains(searchMode.ModeID))
                    //					{
                    //						htSearchModes.Add(searchMode.ModeID,searchMode);
                    //					}
                    //				}

                    //CompTypes
                    for (int i = 0; i < checkedListBox1.Items.Count; i++)
                    {
                        checkedListBox1.SetItemCheckState(i, CheckState.Unchecked);
                    }
                    foreach (LRRSearchCriteriaComponentType searchCriteriaCompType in searchCriteriaCompTypes)
                    {
                        for (int i = 0; i < checkedListBox1.Items.Count; i++)
                        {
                            if (checkedListBox1.Items[i].ToString() == lrrComptypes.GetComponentTypeByID(searchCriteriaCompType.ComponentType).Name)
                            {
                                checkedListBox1.SetItemCheckState(i, CheckState.Checked);
                                break;
                            }
                        }
                    }

                    //Master Items
                    foreach (LRRSearchCriteriaMasterItem searchCriteriaMasterItem in searchCriteriaMasterItems)
                    {
                        foreach (LRRMasterComponent lrrMasterComp in _lrrMasterComponents)
                        {
                            if (lrrMasterComp.ID == searchCriteriaMasterItem.ComponentID)
                            {
                                lrrMasterComp.IsSelected = true;
                            }
                        }
                    }


                    //Levels
                    Hashtable htSearchCriteriaLevel = new Hashtable();
                    foreach (LRRSearchCriteriaLevel searchLevel in _SearchLevels)
                    {
                        if (!htSearchCriteriaLevel.Contains(searchLevel.LevelID))
                        {
                            htSearchCriteriaLevel.Add(searchLevel.LevelID, searchLevel);
                        }
                    }

                    //				foreach(LRRMode _lrrMode in _lrrModes)
                    //				{
                    //					if(htSearchModes.Contains(_lrrMode.ModeId))
                    //					{
                    //						_lrrMode.IsSelected = true;
                    //					}
                    //				}

                    trvLevels.SelectedNode = trvLevels.Nodes[0];
                    List<TreeNode> parentNodeList = new List<TreeNode>();
                    parentNodeList.Add(trvLevels.SelectedNode);
                    GetAllTreeLevels(trvLevels.SelectedNode, ref parentNodeList);
                    //CheckUncheckAllItemsForTreeView(trvLevels.SelectedNode, true);
                    for (int i = trvLevels.SelectedNode.Index; i < trvLevels.GetNodeCount(true); i++)
                    {

                        TreeNode levelNode = parentNodeList[i] as TreeNode;
                        LRRLevel level = parentNodeList[i].Tag as LRRLevel;
                        //LRRLevel level = trvLevels.RowIndexToNode(i).Tag as LRRLevel;
                        if (htSearchCriteriaLevel.Contains(level.LevelID))
                        {
                            levelNode.Checked = true;
                            Symcon.LightRidge.PEAdvisor.Global.TreeViewUtility.TreeViewColorConversion(levelNode);
                        }
                        trvLevels.SelectedNode = levelNode;
                    }

                    /*for (int i = trvLevels.NodeToRowIndex(trvLevels.SelectedNode); i < trvLevels.GetNodeCount(true) + 1; i++)
                    {
                        LRRLevel level = trvLevels.RowIndexToNode(i).Tag as LRRLevel;
                        if (htSearchCriteriaLevel.Contains(level.LevelID))
                        {
                            trvLevels.RowIndexToNode(i).Checked = true;
                        }
                        trvLevels.SelectedNode = trvLevels.RowIndexToNode(i);
                    }*/
                    trvLevels.SelectedNode = trvLevels.Nodes[0];

                    foreach (LRRSearchCriteriaItem searchCriteriaItem in _SearchCriteriaItems)
                    {
                        foreach (LRRSiteComponent _lrrSiteComponent in _lrrSiteComps)
                        {
                            if (searchCriteriaItem.ItemID.Equals(_lrrSiteComponent.SiteComponentID))
                            {
                                _lrrSiteComponent.IsSelected = true;
                                //For Properties
                                foreach (LRRSiteComponentProperty lrrSiteCompProperty in _lrrSiteComponent.Properties)
                                {
                                    foreach (LRRSearchCriteriaItemProperty searchCriteriaItemProperty in searchCriteriaItemProperties)
                                    {
                                        if (searchCriteriaItemProperty.ItemPropertyID == lrrSiteCompProperty.ID)
                                        {
                                            lrrSiteCompProperty.IsSelected = true;

                                            //Handling of UIUOMs
                                            lrrSiteCompProperty.UIUomID = searchCriteriaItemProperty.UIUomID;
                                            /*if(lrrSiteCompProperty.UIUomID == null || lrrSiteCompProperty.UIUomID.Trim() == "")
                                            {
                                                lrrSiteCompProperty.UIUomID = lrrSiteCompProperty.UOM;
                                            }*/
                                            //Site Specific Property
                                            if (!siteComponentPlantSpecific.Contains(_lrrSiteComponent))
                                                siteComponentPlantSpecific.Add(_lrrSiteComponent);
                                            //siteComponentPlantSpecificProps.Add(lrrSiteCompProperty);
                                        }
                                    }
                                    siteComponentPlantSpecificProps.Add(lrrSiteCompProperty);
                                }
                            }
                        }
                    }

                    //Master Properties
                    createMasterAndSiteSpecificProperties();
                    //createAggregateProperties();
                    foreach (LRRMasterProperty lrrMasterProperty in _lrrMasterProperties)
                    {
                        lrrMasterProperty.IsSelected = false;
                    }

                    foreach (LRRSearchCriteriaItemProperty searchCriteriaItemProperty in searchCriteriaItemProperties)
                    {
                        foreach (LRRMasterProperty lrrMasterProperty in _lrrMasterProperties)
                        {
                            if (searchCriteriaItemProperty.ItemPropertyID == lrrMasterProperty.PropID)
                            {
                                lrrMasterProperty.IsSelected = true;

                                //Handling of UIUOMs
                                lrrMasterProperty.UIUomID = searchCriteriaItemProperty.UIUomID;
                            }
                        }

                    }

                    //Aggregate Items
                    foreach (LRRAggregate lrrAggr in _lrrAggregates)
                    {
                        foreach (LRRSearchCriteriaAggregateItem searchAggrItem in searchCriteriaAggrItems)
                        {
                            if (searchAggrItem.AggregateItemID == lrrAggr.AggregateID)
                            {
                                lrrAggr.IsSelected = true;
                                _lrrGridAggregates.Add(lrrAggr);
                                break;
                            }
                        }
                        //					_lrrGridAggregates.Add(lrrAggr);
                    }


                }
                gridPlantItems.Refresh();
                //arLevels.Clear();
                trvLevels.Refresh();
                IsChanged = false;
                _isLastQuerySaved = false;
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(InputOutputViews), " SearchResult Query: " + ex.Message, Logger.Level.Debug);
            }

		}

		private void cmbMasterPlantItem_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			//IsChanged = true;
			//tableName = "Master Plant Items";//cmbMasterPlantItem.SelectedValue.ToString();
		}

		private void btnExec_Click(object sender, System.EventArgs e)
		{
            try
            {
                transposeFlag = false;
                TimeSpan ts = endDateTime.Subtract(startDateTime);
                if (ts.Days < 0 || ts.Hours < 0 || ts.Minutes < 0 || ts.Seconds < 0)
                {
                    LRRMessagBox.ShowMessage("SID_DATE_ERROR", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                int nModesCol = 0;
                foreach (LRRMode lrrMode in LRRModel.ProjectModes)//_lrrModes)
                {
                    //				BaseObject bo = lrrMode as BaseObject;
                    //				if(bo.IsSelected)
                    //				{
                    if (lrrMode.ViewSelection)
                        nModesCol++;
                    //				}
                }

                if (nModesCol == 0)
                {
                    LRRMessagBox.ShowMessage("SID_SELECT_MODE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    _lrrApp.LRRUIManagerObj.ShowModesDialog();
                    return;
                }

                //Clear All Bindings
                if (iGridView != null)
                {
                    iGridView.ClearAllBindings();
                    iGridView.UnSubscribeReconnectCompleted();
                }
                if (chkGroupMode.Checked)
                {
                    iGridView = new Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleGroupedModeViewController();
                }
                else
                {
                    iGridView = new Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController();
                }

                int nCompCount = 0;
                int nCompPropertyCount = 0;
                LRRSiteComponents siteComponents = new LRRSiteComponents();
                LRRSiteComponentProperties siteComponentProperties2 = LRRModel.SiteComponentPropertiesObj;

                //			foreach(LRRSiteComponent siteComponent in _lrrSiteComps)
                _lrrSiteComps.SortColumn = "Name";
                _lrrSiteComps.Sort();
                for (int i = 0; i < _lrrSiteComps.Count; i++)
                {
                    LRRSiteComponent siteComponent = _lrrSiteComps[i];
                    BaseObject bo = siteComponent as BaseObject;
                    if (bo.IsSelected == true)
                    {
                        LRRSiteComponent siteComponent2 = siteComponent;//siteComponents2.GetSiteComponentByID(siteComponent.SiteComponentID);
                        LRRSiteComponentProperties siteComponentProperties = new LRRSiteComponentProperties();

                        foreach (LRRMasterProperty masterProperty in _lrrMasterProperties)
                        {
                            if (siteComponent2 == null)
                                continue;
                            if (masterProperty.IsSelected && masterProperty.ComponentID == siteComponent2.MasterComponentType)
                            {
                                LRRSiteComponentProperty siteComponentProperty2 = siteComponentProperties2.GetSiteCompPropFromMasterPropertyID(siteComponent2.SiteComponentID, masterProperty.PropID);
                                if (siteComponentProperty2 != null)
                                {
                                    //Handling of UIUOMs
                                    string uomID = siteComponentProperty2.UOM;
                                    siteComponentProperty2.UIUomID = masterProperty.UIUomID;
                                    /*if(siteComponentProperty2.UIUomID  == null || siteComponentProperty2.UIUomID.Trim() == "")
                                    {
                                        siteComponentProperty2.UIUomID = uomID;
                                    }*/
                                    siteComponentProperties.Add(siteComponentProperty2);
                                    nCompPropertyCount++;
                                }
                            }
                        }

                        foreach (LRRSiteComponentProperty lrrSiteCompProp in siteComponentPlantSpecificProps)
                        {
                            if (lrrSiteCompProp.IsSelected && lrrSiteCompProp.ComponentID == siteComponent.SiteComponentID)
                            {
                                LRRSiteComponentProperty siteComponentProperty3 = siteComponentProperties2.GetSiteCompPropFromID(lrrSiteCompProp.ID);

                                //Handling of UIUOMs
                                string uomID = siteComponentProperty3.UOM;
                                /*if(siteComponentProperty3.UIUomID  == null || siteComponentProperty3.UIUomID.Trim() == "")
                                {
                                    siteComponentProperty3.UIUomID = uomID;
                                }*/

                                siteComponentProperties.Add(siteComponentProperty3);
                                nCompPropertyCount++;
                            }
                        }

                        siteComponent2.Properties = siteComponentProperties;
                        siteComponents.Add(siteComponent2);
                        nCompCount++;
                    }
                }


                LRRSiteComponents siteCompCollection = siteComponents.Clone() as LRRSiteComponents;
                Hashtable MasterComponentTypeobj = new Hashtable();
                int nCtr = 0;
                foreach (LRRSiteComponent siteCompObj in siteCompCollection)
                {
                    string sMasterComponentType = siteCompObj.MasterComponentType == null ? "" : siteCompObj.MasterComponentType.ToString(Symcon.BusinessObjects.SymConverter.Culture);
                    if (!MasterComponentTypeobj.ContainsValue(sMasterComponentType))
                    {
                        MasterComponentTypeobj.Add(nCtr, sMasterComponentType);
                        nCtr++;
                        if (nCtr > 5)
                        {
                            LRRMessagBox.ShowMessage("SID_NERROW_DOWN_SEARCH", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            return;
                        }
                    }
                }

                _siteComponents.Clear();
                _siteComponents = siteComponents;

                //Create Aggregate Collection
                int nAggrPropCount = createAggregateCollection();

                nCompCount = _lrrResultAggregates.Count + nCompCount;

                if (nModesCol == 0 && nCompCount == 0)
                {
                    LRRMessagBox.ShowMessage("SIT_ATLEASTMODE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }


                if (nCompCount == 0)
                {
                    LRRMessagBox.ShowMessage("SID_ATLEASTSITE", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                nCompPropertyCount = nCompPropertyCount + nAggrPropCount;
                if (nCompPropertyCount == 0)
                {
                    LRRMessagBox.ShowMessage("SID_ATLEASTPROP", "SID_LABEL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
                LRRWaitWindowUtility.ShowPogressIndicator(LRRHeaderText.GetHeaderString(""));
                this.pnlGridContainer.Controls.Clear();

                ArrayList arrCollection = new ArrayList();
                arrCollection.Add(_siteComponents);
                arrCollection.Add(_lrrResultAggregates);

                LRRSearchCriteriaItemProperties srchCriteriaItemProps = null;
                LRRSearchCriteria searchCriteriaObj = this.cmbOpen.SelectedItem as LRRSearchCriteria;
                if (searchCriteriaObj != null && !searchCriteriaObj.ID.Equals("0"))
                {
                    srchCriteriaItemProps = new LRRSearchCriteriaItemProperties();
                    this._lrrApp.DBManagerObj.PopulateCollection(srchCriteriaItemProps, " where SearchCriteriaID = '" + searchCriteriaObj.ID + "'");
                }

                //PrepareQuery();
                iGridView.LoadPanel(arrCollection, srchCriteriaItemProps);

                //Set Recording/Trending Display Flags
                iGridView.ResetRecordingTrendingDisplayFlag(this.chkRecTrendingFlag.Checked);

                ArrayList pnlCollection = iGridView.GetPanelCollection();

                //Sets the panel and panelHeight
                SetPanel(pnlCollection);

                if (this.dockingManager1 != null)
                {
                    this.dockingManager1.HideAutoHiddenControl();
                    pnlFull.DockPadding.Left = this.dockingManager1.DockTabHeight;
                }

                //if (searchCriteriaObj != null)
                //{
                //    _gutil.GctlSetting = ApplicationPersistanceUtil.HtUserQueries[searchCriteriaObj.ID] as LRRGridControlSetting;
                //    _gutil._gridCollection = iGridView.GetPanelCollection();
                //    _gutil.LoadGridSettings(transposeFlag, chkGroupMode.Checked);
                //}

                pnlRun.Visible = true;

                //Show the Properties Form
                LRRResultProperties resultProperties = SearchRetrievalUtility.ShowPropertiesWindow(_siteComponents, _lrrResultAggregates);
                _rsProperties.PropertyCollection = resultProperties;
                _rsProperties.Text = "Result Properties Window";
                _rsProperties.BindGrid();
                _rsProperties.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(rsProperties_SelectedProperties);
                _rsProperties.Owner = this;


                //Show the Component List Form
                LRRResultProperties resultComponents = SearchRetrievalUtility.ShowComponents(_siteComponents, _lrrResultAggregates);
                _rsComponents.PropertyCollection = resultComponents;
                _rsComponents.Text = "Result Components Window";
                _rsComponents.BindGrid();
                _rsComponents.SelectedProperties += new ResultPropertiesWindow.SelectedPropertiesChanged(_rsComponents_SelectedProperties);
                _rsComponents.Owner = this;

                Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
                _lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter, true);

                iGridView.HideProperties(_rsProperties.UnSelectedRecords);
                iGridView.HideComponents(_rsComponents.UnSelectedRecords);
                IsChanged = true;
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(InputOutputViews), "ExecuteClick: " + ex, Logger.Level.Debug);
            }
            finally
            {
                LRRWaitWindowUtility.EndProgressIndicator();
            }

		}

		private int createAggregateCollection()
		{
			_lrrResultAggregates.Clear();
			int nAggrPropCount = 0;
			foreach(LRRAggregate lrrAggregate in _lrrGridAggregates)
			{
				if(lrrAggregate.IsSelected)
				{
					LRRAggregateProperties aggregateProperties = LRRModel.AggregatePropertiesObj.FilterPropertiesByAggregate(lrrAggregate.AggregateID);
					LRRAggregateProperties lrrAggrProps = new LRRAggregateProperties();
					foreach(LRRMasterProperty masterProperty in _lrrMasterProperties)
					{
						foreach(LRRAggregateProperty lrrAggrProperty in aggregateProperties)
						{
							if(masterProperty.IsSelected && masterProperty.PropID == lrrAggrProperty.MasterPropertyID)
							{
								//Handling of UIUOMs
								string uomID = lrrAggrProperty.UOM;
								/*if(lrrAggrProperty.UIUomID  == null || lrrAggrProperty.UIUomID.Trim() == "")
								{
									lrrAggrProperty.UIUomID = uomID;
								}*/

								lrrAggrProps.Add(lrrAggrProperty);
								nAggrPropCount ++;
								break;
							}
						}
					}
					lrrAggregate.AggregateProperties = lrrAggrProps;
					_lrrResultAggregates.Add(lrrAggregate);
				}
			}
			return nAggrPropCount;
		}

        /*private void trvLevels_AfterCheck(object sender, Syncfusion.Windows.Forms.Tools.TreeNodeAdvEventArgs e)
        {
            IsChanged = true;
            //Get the Current selected level
            try
            {
                ArrayList arChildLevels = new ArrayList();

                LRRLevel currLevel = e.Node.Tag as LRRLevel;
                if (e.Node.Checked)
                {
                    if (e.Node.HasChildren)
                    {
                        if (!isRootSelected)
                        {
                            if (chkAutomatic.Checked)
                            {
                                if (currLevel.LevelID == "0")
                                {
                                    isRootSelected = true;
                                    rootLevel = currLevel;
                                }
                                foreach (TreeNodeAdv tna in e.Node.Nodes)
                                {
                                    flag = false;
                                    if (tna.Checked && isRootSelected && tna.HasChildren)
                                    {
                                        foreach (TreeNodeAdv tna2 in tna.Nodes)
                                        {
                                            tna2.Checked = true;
                                        }
                                    }
                                    else
                                        tna.Checked = true;
                                }
                                flag = true;
                            }
                        }
                        else
                        {
                            foreach (TreeNodeAdv tna in e.Node.Nodes)
                            {
                                flag = false;
                                tna.Checked = true;
                            }
                            flag = true;
                        }
                    }
                    arLevels.Add(e.Node.Tag);
                    if (e.Node.Tag.Equals(rootLevel))
                        isRootSelected = false;
                }
                else
                {
                    arLevels.Remove(e.Node.Tag);
                }
                if (flag && !isRootSelected)
                {
                    ApplicationPersistanceUtil.SaveGridSettings(gridPlantItems, this, this.Tag);

                    Hashtable RelativeWidths = new Hashtable();
                    Hashtable columnForDisplay = new Hashtable();

                    columnForDisplay.Add("IsSelected", null);
                    columnForDisplay.Add("Name", null);
                    columnForDisplay.Add("MasterComponentType", null);

                    //Suspend the Layout of the Grid...
                    gridPlantItems.SuspendLayout();

                    SyncGridUtilities.InitializeGridLookAndFeel(gridPlantItems);

                    gridPlantItems.Engine.SourceListSet.Clear();
                    gridPlantItems.DataSource = null;
                    gridPlantItems.TableDescriptor.Relations.Clear();

                    _lrrSiteComps = new LRRSiteComponents();
                    _lrrSiteComps2 = new LRRSiteComponents();
                    SyncGridUtilities.InitializeGridColumns(gridPlantItems, _lrrSiteComps.ItemType, null, true, columnForDisplay);

                    for (int k = 0; k < arLevels.Count; k++)
                    {
                        LRRLevel currentLevel = arLevels[k] as LRRLevel;

                        LRRLevelLinks levelLinks = currentLevel.LevelLinks as LRRLevelLinks;
                        int l = levelLinks.Count;

                        if (currentLevel != null) //Check for null
                        {
                            LRRSiteComponents eachLevelSiteComponents = LRRModel.SiteComponentsObj.Clone() as LRRSiteComponents;
                            IEnumerator iEnum = eachLevelSiteComponents.GetEnumerator();
                            while (iEnum.MoveNext())
                            {
                                LRRSiteComponent siteComponent = iEnum.Current as LRRSiteComponent;
                                siteComponent.IsSelected = false;
                            }

                            LRRSiteComponents eachLvlSiteComps = eachLevelSiteComponents.FilterSiteComponentsByLevelID(currentLevel.LevelID);
                            //_lrrApp.DBManagerObj.PopulateCollection(eachLevelSiteComponents," WHERE PlantUnit = '" + currentLevel.LevelID + "'",false);
                            foreach (LRRSiteComponent lsc in eachLvlSiteComps)
                            {
                                if (!arChildLevels.Contains(lsc.Name))
                                {
                                    _lrrSiteComps.Add(lsc);
                                    _lrrSiteComps2.Add(lsc);
                                    arChildLevels.Add(lsc.Name);
                                }
                            }
                        }
                        else
                        {
                            return;
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Logger.LogMessage(typeof(InputOutputViews), "trvLevels_AfterCheck Event:" + ex.Message, Logger.Level.Debug);
            }

            if (flag && !isRootSelected)
            {
                gridPlantItems.DataSource = _lrrSiteComps;
                gridPlantItems.Engine.SourceListSet.Add(_lrrSiteComps);
                ApplicationPersistanceUtil.ApplyGridSettings(gridPlantItems, this, this.Tag);
                gridPlantItems.ResumeLayout(true);
                this.checkPlantItems();
            }
            FilterSiteComponents();
        }*/

        public void PrepareQuery(string searchQueryID)
		{
		
			Symcon.LightRidge.PEAdvisor.IOScreen.SearchCriteria query = new Symcon.LightRidge.PEAdvisor.IOScreen.SearchCriteria();

			LRRSearchCriteria searchCriteria = new LRRSearchCriteria();
			if(searchQueryID != null)
				searchCriteria.ID = searchQueryID;
			LRRSearchCriterias searchCriterias = new LRRSearchCriterias();
			searchCriteria.SearchTableID = "1";
			searchCriteria.Source="I/O";
			
			LRRSearchCriteriaModes modes = new LRRSearchCriteriaModes();
			foreach(LRRMode _lrrMode in LRRModel.ProjectModes)
			{
				LRRSearchCriteriaMode mode = new LRRSearchCriteriaMode();
				mode.SearchCriteriaID = searchCriteria.ID;
				mode.ModeID = _lrrMode.ModeId;
				mode.Source="I/O";
				modes.Add(mode);
			}

			LRRSearchCriteriaLevels levels = new LRRSearchCriteriaLevels();
			for(int i=0; i < arLevels.Count ; i++)
			{
				LRRSearchCriteriaLevel searchLevel = new LRRSearchCriteriaLevel();
				LRRLevel level = arLevels[i] as LRRLevel;
				searchLevel.LevelID = level.LevelID;
				searchLevel.SearchCriteriaID =  searchCriteria.ID;
				levels.Add(searchLevel);
			}
			
			LRRSearchCriteriaItems searchCriteriaItems = new LRRSearchCriteriaItems();
			foreach(LRRSiteComponent _lrrSiteComponent in _lrrSiteComps)
			{
				BaseObject bo = _lrrSiteComponent as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaItem searchCriteriaItem = new LRRSearchCriteriaItem();
					searchCriteriaItem.SearchCriteriaID	= searchCriteria.ID;
					searchCriteriaItem.ItemID = _lrrSiteComponent.SiteComponentID;
					searchCriteriaItem.Source="I/O";
					searchCriteriaItems.Add(searchCriteriaItem);
				}
			}

			//Aggregate Items
			LRRSearchCriteriaAggregateItems searchCriteriaAggrItems = new LRRSearchCriteriaAggregateItems();
			foreach(LRRAggregate lrrAggregate in _lrrGridAggregates)
			{
				BaseObject bo = lrrAggregate as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaAggregateItem searchCriteriaAggrItem = new LRRSearchCriteriaAggregateItem();
					searchCriteriaAggrItem.SearchCriteriaID	= searchCriteria.ID;
					searchCriteriaAggrItem.AggregateItemID = lrrAggregate.AggregateID;
					searchCriteriaAggrItem.Source="I/O";
					searchCriteriaAggrItems.Add(searchCriteriaAggrItem);
				}
			}

			LRRSearchCriteriaItemProperties searchCriteriaItemProperties = new LRRSearchCriteriaItemProperties();
			foreach(LRRMasterProperty lrrMasterProperty in _lrrMasterProperties)
			{
				BaseObject bo = lrrMasterProperty as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaItemProperty searchCriteriaItemProperty = new LRRSearchCriteriaItemProperty();
					searchCriteriaItemProperty.SearchCriteriaID	= searchCriteria.ID;
					searchCriteriaItemProperty.ItemPropertyID = lrrMasterProperty.PropID;

					//Handling of UI UOMs
//					searchCriteriaItemProperty.UIUomID = gridView.UIUOMHash[lrrMasterProperty.PropID].ToString();//LRRModel.MasterComponentPropertiesObj.GetMasterPropertyByID(lrrMasterProperty.PropID).UIUomID;
					searchCriteriaItemProperties.Add(searchCriteriaItemProperty);
				}
			}

			foreach(LRRSiteComponentProperty lrrSiteCompProp in siteComponentPlantSpecificProps)
			{
				BaseObject bo = lrrSiteCompProp as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaItemProperty searchCriteriaItemProperty = new LRRSearchCriteriaItemProperty();
					searchCriteriaItemProperty.SearchCriteriaID	= searchCriteria.ID;
					searchCriteriaItemProperty.ItemPropertyID = lrrSiteCompProp.ID;
					searchCriteriaItemProperty.ItemID = lrrSiteCompProp.ComponentID;

					//Handling of UI UOMs
//					searchCriteriaItemProperty.UIUomID = gridView.UIUOMHash[lrrSiteCompProp.ID].ToString();//LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lrrSiteCompProp.ID).UIUomID;
					searchCriteriaItemProperties.Add(searchCriteriaItemProperty);
				}
			}

			//Save Master Plant Items
			LRRSearchCriteriaMasterItems searchCriteriaMasterItems = new LRRSearchCriteriaMasterItems();
			foreach(LRRMasterComponent lrrMasterComp in _lrrMasterComponents)
			{
				BaseObject bo = lrrMasterComp as BaseObject;
				if(bo.IsSelected)
				{
					LRRSearchCriteriaMasterItem searchCriteriaMasterItem = new LRRSearchCriteriaMasterItem();
					searchCriteriaMasterItem.SearchCriteriaID	= searchCriteria.ID;
					searchCriteriaMasterItem.ComponentID = lrrMasterComp.ID;
					searchCriteriaMasterItems.Add(searchCriteriaMasterItem);
				}
			}

			//Save Component Types
			LRRSearchCriteriaComponentTypes searchCriteriaCompTypes = new LRRSearchCriteriaComponentTypes();
			for(int i=0;i < checkedListBox1.CheckedItems.Count;i++)
			{
				LRRSearchCriteriaComponentType searchCriteriaCompType = new LRRSearchCriteriaComponentType();
				searchCriteriaCompType.SearchCriteriaID = searchCriteria.ID;
				string compTypeName = checkedListBox1.CheckedItems[i].ToString();
				searchCriteriaCompType.ComponentType = lrrComptypes.GetComponentTypeByName(compTypeName).ID;
				searchCriteriaCompTypes.Add(searchCriteriaCompType);
			}
			
			//Assign to searchcriteria object
			query.SearchQuery = searchCriteria;
			query.SearchCriteriaItems = searchCriteriaItems;
			query.SearchCriteriaAggrItems = searchCriteriaAggrItems;
			query.SearchCriteriaMasterItems = searchCriteriaMasterItems;
			query.SearchCriteriaItemProps = searchCriteriaItemProperties;
			query.SearchCriteriaLevels = levels;
			query.SearchCriteriaModes = modes;
			query.SearchCriteriaCompTypes = searchCriteriaCompTypes;

			iGridView.SearchQuery = query;
		}

		public void SaveQuery(string name, string desc,LRRSearchGroupLevel groupLevel,bool isPublished)
		{
            //_gutil.GctlSetting = ApplicationPersistanceUtil.HtUserQueries[iGridView.SearchQuery.SearchQuery.ID] as LRRGridControlSetting;
            //_gutil._gridCollection = iGridView.GetPanelCollection();
            //_gutil.SaveGridSettings(transposeFlag, chkGroupMode.Checked);

			string searchID = iGridView.SearchQuery.SearchQuery.ID;

            string userSettingsID = null;
            //if(ApplicationPersistanceUtil.HtUserQueries.ContainsKey(searchID))
            //    ApplicationPersistanceUtil.HtUserQueries[searchID] = _gutil.GctlSetting;
            //else
            //    ApplicationPersistanceUtil.HtUserQueries.Add(searchID,_gutil.GctlSetting);

			string searchQueryID = null;
			string userID = this._lrrApp.DBManagerObj.AccessControlModel.UserID;

			IEnumerator iEnum = LRRModel.ChildModel.SearchCriterias.GetEnumerator();// _SearchCriterias.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRSearchCriteria srch = iEnum.Current as LRRSearchCriteria;
				if(srch.Name == name)
				{
					DialogResult dlgResult =  LRRMessagBox.ShowMessage("SID_QUERYNAME_DUPLICATE","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);  
					if(dlgResult == DialogResult.No)
					{
						return;
					}
					
					searchQueryID = srch.ID;
					
					srch.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
					_lrrApp.DBManagerObj.CommitObject(srch);
					//					_SearchCriterias.Remove(srch);
					//Remove from Model
					LRRSearchCriteria srchCriteria = LRRModel.ChildModel.SearchCriterias.GetSearchCriteriaByID(srch.ID);
					if(srchCriteria != null)
					{
						userID = srchCriteria.UserID;
                        userSettingsID = srchCriteria.UserSettingsID;
						srchCriteria.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
						LRRModel.ChildModel.SearchCriterias.Remove(srchCriteria);

						//Remove from Levels and Level Link tables
						LRRSearchGroupLevel lrrSrchGroupLevel = new LRRSearchGroupLevel();
						lrrSrchGroupLevel.LevelID = srchCriteria.ID;
						lrrSrchGroupLevel.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(lrrSrchGroupLevel);

						LRRSearchGroupLevelLink lrrSrchGroupLevelLink = new LRRSearchGroupLevelLink();
						_lrrApp.DBManagerObj.PopulateObject(lrrSrchGroupLevelLink,typeof(LRRSearchGroupLevelLink)," where ChildID = '" + srchCriteria.ID + "'");
					
						//Delete the Object
						lrrSrchGroupLevelLink.ObjectState = Symcon.Globals.Enums.DBOperation.DELETE;
						_lrrApp.DBManagerObj.CommitObject(lrrSrchGroupLevelLink);

					}
					_newSavedQueryCount--;
					break;
				}
			}
			
			if(iGridView != null)
			{
				PrepareQuery(searchQueryID);
				if(userID == null || userID.Trim() == "")
					userID = this._lrrApp.DBManagerObj.AccessControlModel.UserID;
				iGridView.SearchQuery.UserID = userID;
                iGridView.SearchQuery.SearchQuery.UserSettingsID = userSettingsID;
				iGridView.Save(name,desc,groupLevel,isPublished);
			}
			else
				return;

			LRRMessagBox.ShowMessage("SID_SAVEDINFO",true); 
			
			bFlag = false;
			
			if(_SearchModes != null)
				_SearchModes.Clear();
			if(_SearchLevels != null)
				_SearchLevels.Clear();
			if(_SearchCriteriaItems != null)
				_SearchCriteriaItems.Clear();
			if(_SearchCriterias != null)
				_SearchCriterias.Clear();
			if(_SearchCriteriaAggregateItems != null)
				_SearchCriteriaAggregateItems.Clear();
			if(_SearchCriteriaItemProperties != null)
				_SearchCriteriaItemProperties.Clear();
			if(_SearchCriteriaMasterItems != null)
				_SearchCriteriaMasterItems.Clear();
			if(_SearchCriteriaComponentTypes != null)
				_SearchCriteriaComponentTypes.Clear();

			_lrrApp.DBManagerObj.PopulateCollection(_SearchModes," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchLevels,"",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItems," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriterias," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_SearchCriterias = _SearchCriterias.FilterForUserByUserID();
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaAggregateItems," WHERE (Source = 'I/O' OR  Source is null) ",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaItemProperties,"",false,true);
			//Populate Master Items and Comp Types
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaMasterItems,"",false,true);
			_lrrApp.DBManagerObj.PopulateCollection(_SearchCriteriaComponentTypes,"",false,true);
//			_lrrSearchCriterias.Clear();
			_lrrSearchCriterias = _SearchCriterias;

			//Update in Model
//			LRRSearchCriterias srchCriterias = new LRRSearchCriterias();
//			_lrrApp.DBManagerObj.PopulateCollection(srchCriterias,false);
//			LRRModel.ChildModel.SearchCriterias = srchCriterias;
			LRRModel.ChildModel.SearchCriterias.Add(iGridView.SearchQuery.SearchQuery);

			cmbOpen.DataSource = _lrrSearchCriterias;
			cmbOpen.DisplayMember = "Name";
			cmbOpen.ValueMember = "ID";

			LRRSearchCriteria srchCriteria1 = _lrrSearchCriterias.GetSearchCriteriaByID(iGridView.SearchQuery.SearchQuery.ID);
			if(srchCriteria1 != null)
				cmbOpen.SelectedItem = srchCriteria1;

//			_lrrApp.DBManagerObj.PopulateCollection(_lrrSearchCriterias,false);
			IsChanged = false;
			LRRApplicationSettings.SSelectedQuery = cmbOpen.Items.Count + _newSavedQueryCount++;
			_isLastQuerySaved = true;
		}

		#region ILRRUIContainer Members
		public new void Refresh()
		{
			//Method to Refresh the User Interface form..
//			LRRUIManager lrrUI=new LRRUIManager();
//			
//			lrrUI.SaveGridSettings(gridPlantItems,this, this.Tag);
//			lrrUI.SaveGridSettings(gridPlantItems2,this, this.Tag);
//			lrrUI.SaveGridSettings(gridProperties2,this, this.Tag);
//
//			lrrUI.ApplyGridSettings(gridPlantItems,this, this.Tag);
//			lrrUI.ApplyGridSettings(gridPlantItems2,this, this.Tag);
//			lrrUI.ApplyGridSettings(gridProperties2,this, this.Tag);

		} 
		public void Save() //Method to save the contents of the form...
		{
            LRRSiteComponentPropertyValues toSaveSiteCompPropValues = LRRModel.PropertyValuesObj.GetChanges();
            LRRAggregatePropertyValues toSaveAggrPropValues = LRRModel.AggregatePropertyValuesObj.GetChanges();
            if (toSaveSiteCompPropValues.Count > 0)
            {
                    _lrrApp.DBManagerObj.CommitCollection(toSaveSiteCompPropValues);
                    if (toSaveAggrPropValues.Count > 0)
                        _lrrApp.DBManagerObj.CommitCollection(toSaveAggrPropValues);
                    LRRModel.PropertyValuesObj.RefreshCollection();
                    LRRMessagBox.ShowMessage("SID_SAVEDINFO", true); 
            }
            else
                LRRMessagBox.ShowMessage("SID_NODATASAVED", true);
            LRRModel.ProjectModes.ModesChanged -= new EventHandler(ProjectModes_ModesChanged);
            if (!_isLastQuerySaved)
                LRRApplicationSettings.SSelectedQuery = cmbOpen.SelectedIndex;

            dockingManager1.SetAutoHideMode(pnlFilterSection, true);
            this.dockingManager1.SaveDockState();

            ApplicationPersistanceUtil.SaveGridSettings(this.pnlFilterSection, this, 200);
            BPropertyValChanged = false;

			/*if(iGridView == null)
			{
				MessageBox.Show("Please execute the query before saving!");
				return;
			}

			string queryName = cmbOpen.Text;
			if(cmbOpen.SelectedValue != null && cmbOpen.SelectedValue.ToString() == "0")
				queryName = "";
			SaveQueryForm saveQueryForm = new SaveQueryForm(queryName,"Query");
			InternationalizationUtils.GetControlText(saveQueryForm,null); 
			DialogResult result = saveQueryForm.ShowDialog();
		
//			PrepareQuery();

			if(result == DialogResult.OK)
			{
				SaveQuery(saveQueryForm.queryName,saveQueryForm.queryDesc,saveQueryForm.SelectedLevel,saveQueryForm.IsPublished);
//				Refresh();
			}
//			pnlRun.Visible=false;*/
			
		}

        public void SaveQuery()
        {
            if (iGridView == null)
            {
                MessageBox.Show("Please execute the query before saving!");
                return;
            }

            string queryName = cmbOpen.Text;
            if (cmbOpen.SelectedValue != null && cmbOpen.SelectedValue.ToString() == "0")
                queryName = "";
            SaveQueryForm saveQueryForm = new SaveQueryForm(queryName, "Query");
            InternationalizationUtils.GetControlText(saveQueryForm, null);
            DialogResult result = saveQueryForm.ShowDialog();

            if (result == DialogResult.OK)
            {
                SaveQuery(saveQueryForm.queryName, saveQueryForm.queryDesc, saveQueryForm.SelectedLevel, saveQueryForm.IsPublished);
            }
            IsChanged = false;
        }

		public void CopyMasterProperties()
		{
		}
		public void Paste()
		{
		}
		public void Copy()
		{
		}
		public void Print()
		{
			if(iGridView != null)
				iGridView.Print();
		}
		public void Delete()
		{
		}
		public void ArrangeColumns()
		{
		}
		public void ClearFilter()
		{
		}
		public void InsertNewRows()//Inserts New rows 
		{
		}
		public void ImportToExcel()
		{
		}
		public void Export()
		{
            if (iGridView != null && iGridView.Export() != null)
            {
                ExportToExcel excelExpForm = new ExportToExcel(iGridView.Export());
                excelExpForm.ShowDialog(this);
            }
            else
            {
                MessageBox.Show(this,LRRHeaderText.GetHeaderString("SID_EXPORT_ERROR"));
            }
		}
		public void SelectionPaste()
		{
		}
		
		public  void RightLevel()
		{

		}
		public  void LeftLevel()
		{

		}
		public  void UpLevel()
		{

		}
		public  void DownLevel()
		{

		}


		//Methods Suported
		public bool SupportsMasterPropertiesCopy()
		{
			return false;
		}
		public bool SupportsCopy()
		{
			return false;
		}
		public bool SupportsPaste()
		{
			return false;
		}
		public bool SupportsExport()
		{
			return true;
		}
		public bool SupportsSave()
		{
			return true;
		}
		public bool SupportsRefresh()
		{
			return false;
		}
		public bool SupportsDelete()
		{
			return false;
		}
		public bool SupportsPrint()
		{
			return true;
		}
		public bool SupportsArrangeColumns()
		{
			return false;
		}
		public bool SupportsClearFilter()
		{
			return false;
		}
		public bool SupportsInsertNewRows()
		{
			return false;
		}
		public bool SupportsImportToExcel()
		{
			return false;
		}
		public bool SupportsSelectionPaste()
		{
			return false;
		}
		public bool SupportsLevel()
		{
			return false;
		}


		public TabControl ParentTabControl
		{
			set
			{
				_parentTabControl = value;
			}
			get{return _parentTabControl;}
		}
	
		public TabPage ParentTabPage
		{
			set
			{
				_parentTabPage = value;
			}
			get
			{
				return _parentTabPage;
			}
		}
		#endregion

		private void cmbOpen_DataSourceChanged(object sender, System.EventArgs e)
		{
			cmbOpen.Refresh();
		}

		private void dateTimePicker2_ValueChanged(object sender, System.EventArgs e)
		{	
			startDateTime = dateTimePicker2.Value;
		}

		private void dateTimePicker1_ValueChanged(object sender, System.EventArgs e)
		{
			endDateTime = dateTimePicker1.Value;
		}

		private void btnSelectAll_Click(object sender, System.EventArgs e)
		{
			//IsChanged = true;
			bool checkedFlag = false;
			if(btnSelectAll.Text == "Check All")
			{
				checkedFlag = true;
				btnSelectAll.Text = "Uncheck All";
			}
			else if(btnSelectAll.Text == "Uncheck All")
			{
				checkedFlag = false;
				btnSelectAll.Text = "Check All";
			}
			IEnumerator iEnum = _lrrSiteComps.GetEnumerator();
			while(iEnum.MoveNext())
			{
				LRRSiteComponent siteComponent = iEnum.Current as LRRSiteComponent;
				if(siteComponent != null)
					siteComponent.IsSelected = checkedFlag;
			}

			//UnCheck Master Properties
			if(!checkedFlag)
			{
//				CheckUncheckMasterProperties(checkedFlag);
			}

			gridPlantItems.Refresh();
			gridPlantItems_ValueChanged();

			//Check Master Properties
//			if(checkedFlag)
//				CheckUncheckMasterProperties(checkedFlag);

		}

		private void CheckUncheckMasterProperties(bool checkedFlag,string compID)
		{
			IEnumerator iMasterPropEnum = _lrrMasterProperties.GetEnumerator();
			while(iMasterPropEnum.MoveNext())
			{
				LRRMasterProperty masterProp = iMasterPropEnum.Current as LRRMasterProperty;
				if(masterProp != null && masterProp.ComponentID == compID)
					masterProp.IsSelected = checkedFlag;
			}
			gridProperties2.Refresh();
		}

		private void CheckUncheckSiteSpecificProperties(bool checkedFlag,string siteCompID)
		{
			IEnumerator iSiteCompPropEnum = siteComponentPlantSpecificProps.GetEnumerator();
			while(iSiteCompPropEnum.MoveNext())
			{
				LRRSiteComponentProperty siteCompProp = iSiteCompPropEnum.Current as LRRSiteComponentProperty;
				if(siteCompProp.ComponentID == siteCompID)
					siteCompProp.IsSelected = checkedFlag;
			}
			gridSiteSpecificProperties.Refresh();
		}

        public void CheckForIOViewsChanges(Form frm,bool fromRun)
        {
            GridCheckForViewChanges.CheckForViewChanges(IsChanged, null, null, frm, iGridView, _rsProperties, _isLastQuerySaved, cmbOpen, dockingManager1, pnlFilterSection, _lrrApp, fromRun);
        }


		private void gridPlantItems_ValueChanged()
		{
			createMasterAndSiteSpecificProperties();

			//Populate Aggregate Properties
			createAggregateProperties();

		}

		private void createMasterAndSiteSpecificProperties()
		{
			//IsChanged = true;
			_lrrMasterComponents2.Clear();
			_lrrMasterProperties.Clear();
			siteComponentPlantSpecificProps.Clear();
			siteComponentPlantSpecific.Clear();

			ArrayList arrMasterType = new ArrayList();
			ArrayList arrSiteCompProperties = new ArrayList();
			ArrayList arrSiteSpecificCompPropObjs = new ArrayList();

			foreach(LRRSiteComponent lrrSiteComponent in _lrrSiteComps)
			{
				if(lrrSiteComponent.IsSelected)
				{
					LRRSiteComponentProperties lrrSiteComponentProps = LRRModel.SiteComponentPropertiesObj.GetAllSiteComponentPropertiesByComponentID(lrrSiteComponent.SiteComponentID);//LRRModel.SiteComponentPropertiesObj.GetSiteComponentPropertiesByComponentID(lrrSiteComponent.SiteComponentID);//lrrSiteComponent.Properties;
					foreach(LRRSiteComponentProperty lrrSiteComponentProp in lrrSiteComponentProps)
					{
						if((lrrSiteComponentProp.PropertyID == null || lrrSiteComponentProp.PropertyID == "") && lrrSiteComponentProp.Type == "1")
						{
							siteComponentPlantSpecificProps.Add(lrrSiteComponentProp);
							LRRSiteComponent lrrSiteComp =  _lrrSiteComps.GetSiteComponentByID(lrrSiteComponentProp.ComponentID);
							if(!siteComponentPlantSpecific.Contains(lrrSiteComp))
								siteComponentPlantSpecific.Add(lrrSiteComp);
						}
						if(!arrSiteCompProperties.Contains(lrrSiteComponentProp.PropertyID))
						{
							arrSiteCompProperties.Add(lrrSiteComponentProp.PropertyID);
						}
					}

					if(!arrMasterType.Contains(lrrSiteComponent.MasterComponentType))
					{
						LRRMasterComponent lrrMasterComponent = _lrrMasterComponents.GetMasterComponentByID(lrrSiteComponent.MasterComponentType);
						_lrrMasterComponents2.Add(lrrMasterComponent);
						arrMasterType.Add(lrrSiteComponent.MasterComponentType);
					}
				}
			}

			for(int i=0; i < arrSiteCompProperties.Count;i++)
			{
				string prop = arrSiteCompProperties[i] == null ? "" : arrSiteCompProperties[i].ToString();
				foreach(LRRMasterProperty lrrMasterCompProp in lrrMasterProperties)
				{
					if(bImplementer == true)
					{
						if(lrrMasterCompProp.PropID == prop && lrrMasterCompProp.Type == "1")
						{
							_lrrMasterProperties.Add(lrrMasterCompProp);
						}
					}
					else
					{
						if(lrrMasterCompProp.PropID == prop && lrrMasterCompProp.Type == "1" && lrrMasterCompProp.IsExposed == true)
						{
							_lrrMasterProperties.Add(lrrMasterCompProp);
						}
					}

				}
			}
		}


		private void gridPlantItems_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			//IsChanged = true;
			gridPlantItems_ValueChanged();
		}

		private void gridMasterPlantItems_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			//IsChanged = true;
			checkPlantItems();

			//Populate Aggregates Grid
			checkAggregates();
		}

		private void InputOutputViews_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
            Form frm = sender as Form;
            CheckForIOViewsChanges(frm,false);
            BPropertyValChanged = false;
            IsChanged = false;
            LRRModel.ProjectModes.ModesChanged -= new EventHandler(ProjectModes_ModesChanged);
            //CommonViews.ChangedUIUOMDictionary.Clear(this.GetType());
			
            //Clear All Bindings
			/*if(iGridView != null)
			{
				iGridView.ClearAllBindings();
				iGridView.UnSubscribeReconnectCompleted();
			}
			_rsProperties.Dispose();
			_rsComponents.Dispose();

			if(_isChanged)
			{
				DialogResult k =   LRRMessagBox.ShowMessage("SID_SAVE_QUERY","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question); 
				if(k == DialogResult.Yes)  
				{
					Save();
				}
                
			}
			
			//Save the Property Values
			LRRSiteComponentPropertyValues toSaveSiteCompPropValues = LRRModel.PropertyValuesObj.GetChanges();
			LRRAggregatePropertyValues toSaveAggrPropValues = LRRModel.AggregatePropertyValuesObj.GetChanges();
			if(toSaveSiteCompPropValues.Count > 0)
			{
				DialogResult dlgResult = LRRMessagBox.ShowMessage(this,"SID_SAVE_PROPVALUE","SID_LABEL",MessageBoxButtons.YesNo,MessageBoxIcon.Question);      
				if(dlgResult == DialogResult.Yes)  
				{
					_lrrApp.DBManagerObj.CommitCollection(toSaveSiteCompPropValues);
					if(toSaveAggrPropValues.Count > 0)
						_lrrApp.DBManagerObj.CommitCollection(toSaveAggrPropValues);
				}
                else if (dlgResult == DialogResult.No)
                {
                    foreach(LRRSiteComponentPropertyValue lscpv in toSaveSiteCompPropValues)
                    {
                        LRRSiteComponentProperty lscp = LRRModel.SiteComponentPropertiesObj.GetSiteCompPropFromID(lscpv.SiteComponentPropertyID);
                        LRRSiteComponentPropertyValue lscpvObj = LRRModel.GetPropertyValueObject(typeof(LRRSiteComponent), lscpv.ModeID, lscpv.SiteComponentPropertyID, lscp.ComponentID) as LRRSiteComponentPropertyValue; 
                        lscpvObj.RollBackChanges(true);
                    }
                }
			}

			LRRModel.ProjectModes.ModesChanged-=new EventHandler(ProjectModes_ModesChanged);
			if(!_isLastQuerySaved)
				LRRApplicationSettings.SSelectedQuery = cmbOpen.SelectedIndex;

			//Commit the changes made to overrides
//			LRROverrides objOverridesInfoToSave = LRRModel.ChildModel.Overrides.GetChanges();
//			_lrrApp.DBManagerObj.CommitCollection(objOverridesInfoToSave);
            
            dockingManager1.SetAutoHideMode(pnlFilterSection, true);
            this.dockingManager1.SaveDockState();
            
            ApplicationPersistanceUtil.SaveGridSettings(this.pnlFilterSection, this, 200);*/
		}

		private void btnTranspose_Click(object sender, System.EventArgs e)
		{
			if(!transposeFlag)
				transposeFlag = true;
			else
				transposeFlag = false;

			//Clear All Bindings			
			if(iGridView != null)
			{
				iGridView.ClearAllBindings();
				iGridView.UnSubscribeReconnectCompleted();
			}
			if(transposeFlag && !chkGroupMode.Checked)
			{
				iGridView = new Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedViewController();
			}
			else if(!transposeFlag && !chkGroupMode.Checked)
			{
				iGridView = new Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleViewController();
			}

			if(transposeFlag && chkGroupMode.Checked)
			{
				iGridView = new Symcon.LightRidge.PEAdvisor.IOScreen.GridTransposedGroupedModeViewController();
			}
			else if(!transposeFlag && chkGroupMode.Checked)
			{
				iGridView = new Symcon.LightRidge.PEAdvisor.IOScreen.GridSimpleGroupedModeViewController();
			}
			
			this.SuspendLayout();
			
//			PrepareQuery();
			ArrayList arrCollection = new ArrayList();
			arrCollection.Add(_siteComponents);
			arrCollection.Add(_lrrResultAggregates);

			LRRSearchCriteriaItemProperties srchCriteriaItemProps = null;
			LRRSearchCriteria searchCriteriaObj = this.cmbOpen.SelectedItem as LRRSearchCriteria;
			if(searchCriteriaObj != null && !searchCriteriaObj.ID.Equals("0"))
			{
				srchCriteriaItemProps = new LRRSearchCriteriaItemProperties();
				this._lrrApp.DBManagerObj.PopulateCollection(srchCriteriaItemProps," where SearchCriteriaID = '" + searchCriteriaObj.ID + "'",false,true);
			}

			iGridView.LoadPanel(arrCollection,srchCriteriaItemProps);

            //Set Recording/Trending Display Flags
            iGridView.ResetRecordingTrendingDisplayFlag(this.chkRecTrendingFlag.Checked);

			ArrayList pnlCollection = iGridView.GetPanelCollection();

			//Sets the panel and panel Heights
			this.pnlGridContainer.Controls.Clear();
			SetPanel(pnlCollection);

			this.ResumeLayout(true);
			pnlRun.Visible=true;

            //_gutil.GctlSetting = ApplicationPersistanceUtil.HtUserQueries[iGridView.SearchQuery.SearchQuery.ID] as LRRGridControlSetting;

            //_gutil._gridCollection = iGridView.GetPanelCollection();
            //_gutil.LoadGridSettings(transposeFlag, chkGroupMode.Checked);
			
			iGridView.HideProperties(_rsProperties.UnSelectedRecords);
			iGridView.HideComponents(_rsComponents.UnSelectedRecords);
		}

		private void SetPanelHeight()
		{
			int iNumPanels = pnlGridContainer.Controls.Count/2;
			if(iNumPanels != 0)
			{
				int pnlHeight = this.pnlFull.Height - (pnlRun.Size.Height + SystemInformation.HorizontalScrollBarHeight);
				int gridPnlHeight = (pnlHeight)/iNumPanels;
				foreach(Control ctl in pnlGridContainer.Controls)
				{
					if(ctl.GetType() == typeof(Panel))
					{
						ctl.Height = gridPnlHeight;
					}
				}
			}
		}

		private void checkedListBox1_ItemCheck(object sender, ItemCheckEventArgs e)
		{
			//IsChanged = true;
			string compTypeName = checkedListBox1.Items[e.Index].ToString();
			LRRComponentType lrrCompType = lrrComptypes.GetComponentTypeByName(compTypeName);
			LRRMasterComponents lrrMasterComps = LRRModel.Model.FilterMasterComponentsByComponentTypeID(lrrCompType.ID);

			IEnumerator masterCompEnum = lrrMasterComps.GetEnumerator();

			while(masterCompEnum.MoveNext())
			{
				LRRMasterComponent masterComp = masterCompEnum.Current as LRRMasterComponent;
				LRRMasterComponent masterComponent = _lrrMasterComponents.GetMasterComponentByID(masterComp.ID);
				if(e.NewValue == CheckState.Checked)
				{
					masterComponent.IsSelected = false;
					_lrrMasterComponents.Add(masterComponent);
					if(_lrrSiteComps2 != null)
					{
						IEnumerator siteCompEnum = _lrrSiteComps2.GetEnumerator();
						while(siteCompEnum.MoveNext())
						{
							LRRSiteComponent lsc = siteCompEnum.Current as LRRSiteComponent;
							if(lsc.MasterComponentType == masterComponent.ID)
							{
								LRRSiteComponent lrrSiteComp = _lrrSiteComps.GetSiteComponentByID(lsc.SiteComponentID);
								if(!_lrrSiteComps.Contains(lrrSiteComp))
								{
									_lrrSiteComps.Add(lrrSiteComp);
								}
							}
						}
					}
				}
				else
				{
					masterComponent.IsSelected = false;
					_lrrMasterComponents.Remove(masterComponent);
					if(_lrrSiteComps2 != null)
					{
						IEnumerator siteCompEnum = _lrrSiteComps2.GetEnumerator();
						while(siteCompEnum.MoveNext())
						{
							LRRSiteComponent lsc = siteCompEnum.Current as LRRSiteComponent;
							if(lsc.MasterComponentType == masterComponent.ID)
							{
								LRRSiteComponent lrrSiteComp = _lrrSiteComps.GetSiteComponentByID(lsc.SiteComponentID);
								if(_lrrSiteComps.Contains(lrrSiteComp))
								{
									_lrrSiteComps.Remove(lrrSiteComp);
								}
							}
						}
					}
				}
			}

			createMasterAndSiteSpecificProperties();
			createAggregateProperties();
		}

		private void FilterSiteComponents()
		{
			IEnumerator siteCompEnum = _lrrSiteComps.GetEnumerator();
			ArrayList arrItemsToRemove = new ArrayList();

			while(siteCompEnum.MoveNext())
			{
				LRRSiteComponent lsc = siteCompEnum.Current as LRRSiteComponent;
				string masterCompID = LRRModel.Model.GetMasterComponentByID(lsc.MasterComponentType).ComponentID;
				LRRComponentType lrrCompType = lrrComptypes.GetComponentTypeByID(masterCompID);			
				
				if(!checkedListBox1.CheckedItems.Contains(lrrCompType.Name))
				{
					arrItemsToRemove.Add(lsc);
				}
			}

			for(int i=0; i < arrItemsToRemove.Count;i++)
			{
				LRRSiteComponent lsc = arrItemsToRemove[i] as LRRSiteComponent;
				_lrrSiteComps.Remove(lsc);
			}

//			createMasterAndSiteSpecificProperties();
		}
		
		private void btnPrint_Click(object sender, System.EventArgs e)
		{
//			try
//			{
//				ArrayList arrLines = new ArrayList();
//				GridControl gctl = null;
//				foreach(GridControl gctl2 in gridView.GetGridInstanceCollection())
//				{
//					if(chkGroupMode.Checked)
//					{
//						string gridName = null;
//						for(int i=1;i<=gctl2.ColCount;i++)
//						{
//							if(gctl2[0,i].Text.Trim() != "")
//							{
//								gridName = gctl2[0,i].Text;
//								break;
//							}
//						}
//						bool flag=false;
//						int n=GridPersistanceUtil._arrGridColMove[0].Count - 1;
//						while(n>=0)
//						{
//							if(GridPersistanceUtil._arrGridColMove[0][n].ToString() == gridName)
//							{
//								gctl = new GridControl();
//								gctl.Visible = false;
//								gctl.ColCount = gctl2.ColCount;
//								gctl.RowCount = gctl2.RowCount;
//								for(int i=0;i<=gctl.RowCount;i++)
//								{
//									for(int j=0;j<=gctl.ColCount;j++)
//									{
//										gctl[i,j].Text = gctl2[i,j].Text;
//									}
//								}
//
//						
//						
//								int m=GridPersistanceUtil._arrGridColMove[0].Count - 1;
//								while(m>=0)
//								{
//									if(GridPersistanceUtil._arrGridColMove[0][m].ToString() == gridName)
//									{
//										gctl.Cols.MoveRange(int.Parse(GridPersistanceUtil._arrGridColMove[3][m].ToString()),int.Parse(GridPersistanceUtil._arrGridColMove[2][m].ToString()),int.Parse(GridPersistanceUtil._arrGridColMove[1][m].ToString()));
//									}
//									m--;
//								}
//								flag = true;
//								break;
//							}
//							n--;
//						}
//						if(!flag)
//							gctl = gctl2;
//						
//						
//					}
//					else
//						gctl = gctl2;
//
//					arrLines.Add(gctl[0,1].Text);
//					int scCount = 0;
//					int nCount = 3;
//					ArrayList arrSCName = new ArrayList();
//					while(nCount<=gctl.ColCount)
//					{
//						if(gctl[1,nCount].HasCellValue)
//						{
//							if(!arrSCName.Contains(gctl[1,nCount].Text))
//							{
//								scCount++;
//								arrSCName.Add(gctl[1,nCount].Text);
//							}
//						}
//						nCount++;
//					}
//				
//					int modeCount = (gctl.ColCount - 2)/scCount;
//					int propCount;
//					if(transposeFlag)
//						propCount = gctl.RowCount - 2;
//					else
//						propCount = gctl.RowCount - 3;
//					for(int i=0;i<scCount;i++)
//					{
//						arrLines.Add("\t" + arrSCName[i]);
//						for(int j=0;j<modeCount; j++)
//						{
//							if(chkGroupMode.Checked)
//							{
//								if(transposeFlag)
//								{
//									arrLines.Add("\t\t" + gctl[2,i+3 + scCount*j].Text);
//									for(int k=0;k<propCount;k++)
//									{
//										if(gctl[k+3,2].Text != "")
//											arrLines.Add("\t\t\t" + gctl[k+3,1].Text + " (" + gctl[k+3,2].Text + ") = " + gctl[k+3,j*scCount + i + 3].Text);
//										else
//											arrLines.Add("\t\t\t" + gctl[k+3,1].Text + " = " + gctl[k+3,j*scCount + i + 3].Text);
//									}
//								}
//								else
//								{
//									arrLines.Add("\t\t" + gctl[2,i+3 + scCount*j].Text);
//									if(gctl[3,i+3+scCount*j].Text.Trim() != "")
//										arrLines.Add("\t\t\t UOM = " + gctl[3,i+3+scCount*j].Text);
//									for(int k=0;k<propCount;k++)
//									{
//										arrLines.Add("\t\t\t" + gctl[k+4,1].Text + " = " + gctl[k+4,j*scCount + i + 3].Text);
//									}
//								}
//							}
//							else
//							{
//								if(transposeFlag)
//								{
//									arrLines.Add("\t\t" + gctl[2,j+3].Text);
//									for(int k=0;k<propCount;k++)
//									{
//										if(gctl[k+3,2].Text.Trim() != "")
//											arrLines.Add("\t\t\t" + gctl[k+3,1].Text + " (" + gctl[k+3,2].Text + ") = " + gctl[k+3,i*modeCount + j + 3].Text);
//										else
//											arrLines.Add("\t\t\t" + gctl[k+3,1].Text + " = " + gctl[k+3,i*modeCount + j + 3].Text);
//									}
//								}
//								else
//								{
//									arrLines.Add("\t\t" + gctl[2,j+3].Text);
//									if(gctl[3,i+3+scCount*j].Text.Trim() != "")
//										arrLines.Add("\t\t\t UOM = " + gctl[3,i+3+scCount*j].Text);
//									for(int k=0;k<propCount;k++)
//									{
//										arrLines.Add("\t\t\t" + gctl[k+4,1].Text + " = " + gctl[k+4,i*modeCount + j + 3].Text);
//									}
//								}
//							}
//						}
//					}
//					arrLines.Add("");
//				}
//
//				PrintDataTable table1 = new PrintDataTable();
//				table1.Rows = new PrintRow[arrLines.Count - 1];
//				for(int i=0;i<(arrLines.Count-1);i++)
//				{
//					table1.Rows[i] = new PrintRow();
//					table1.Rows[i].ValueName = arrLines[i].ToString();
//				}
//				PrintData pd = new PrintData();
//				pd.HeaderName = "Search Results";
//				pd.PrintDataTableObj = table1;
//				PrintManager pm = new PrintManager(this,pd);
//				pm.Print();
//			}
//			catch(Exception ex)
//			{
//				Symcon.Utils.MessageLogger.Logger.LogMessage(typeof(InputOutputViews),ex.Message,Symcon.Utils.MessageLogger.Logger.Level.Debug);
//				Debug.Assert(false,ex.Message,ex.StackTrace);
//			}
		
		}
		private void dtPickerEnd_Validated(object sender, EventArgs e)
		{
			if(dtPickerEnd.Value < dtPickerStart.Value )
			{
				LRRMessagBox.ShowMessage("SID_DATE_ERROR","SID_LABEL",MessageBoxButtons.OK,MessageBoxIcon.Error);     
				return;
			}
		}

		private void comboBoxBase1_SelectionChangeCommitted(object sender, System.EventArgs e)
		{
			string s;
			string val = null;
			if(this.checkedListBox1.CheckedItems.Count > 0)
			{
				for(int i=0;i < this.checkedListBox1.CheckedItems.Count;i++)
				{
					s = this.checkedListBox1.CheckedItems[i].ToString();
					val = val == null ? s : val + "," + s; 
				}
				this.comboBoxBase1.TextBox.Text = val;
			}
			else
			{
				this.comboBoxBase1.TextBox.Text = "";
			}
		}

		private void ProjectModes_ModesChanged(object sender, EventArgs e)
		{
			if(iGridView == null)
				return;
			iGridView.HideModes();
		}
		#region ILRRUIContainer Members

		public void ClearSort()
		{
			// Add InputOutputViews.ClearSort implementation
			SyncGridUtilities.ClearSort(gridMasterPlantItems);
			SyncGridUtilities.ClearSort(gridPlantItems);
			SyncGridUtilities.ClearSort(gridProperties2);
			SyncGridUtilities.ClearSort(gridSiteSpecificProperties);
			SyncGridUtilities.ClearSort(gridAggregates);

			//Clear sorting for Result Screen
			if(iGridView != null)
				iGridView.ClearSort();
		}

		public bool SupportsClearSort()
		{
			// InputOutputViews.SupportsClearSort implementation
			return true;
		}

		#endregion

		private void gridProperties2_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
		{
			if(e.TableControl.TableDescriptor.Name == "Properties")
			{
				e.Inner.Handled = true;
			}
		}

		private void gridProperties2_TableControlCurrentCellKeyPress(object sender, GridTableControlKeyPressEventArgs e)
		{
			if(e.TableControl.TableDescriptor.Name == "Properties")
			{
				e.Inner.Handled = true;
			}
		}
	#region ILRRUIContainer Members

		public void CopyUOMTypes()
		{
		
		}

		public bool SupportsCopyUOMTypes()
		{
			return false;
		}

		#endregion

		private void gridAggregates_RecordValueChanged(object sender, Syncfusion.Grouping.RecordValueChangedEventArgs e)
		{
			createMasterAndSiteSpecificProperties();
			createAggregateProperties();
		}
		#region ILRRUIContainer Members

		public void PrintPreview()
		{
			if(iGridView != null)
				iGridView.PrintPreview();
		}

		#endregion

		private void rsProperties_SelectedProperties(ArrayList arrayUnSelectedRecords)
		{
			iGridView.HideProperties(arrayUnSelectedRecords);
		}

		private void InputOutputViews_Activated(object sender, EventArgs e)
		{
			if(_rsProperties != null && _rsProperties.IsWindowOpen)
				_rsProperties.Show();
			if(_rsComponents != null && _rsComponents.IsWindowOpen)
				_rsComponents.Show();
//			Syncfusion.Windows.Forms.Tools.XPMenus.Bar resultsFilter = _lrrApp.LRRUIManagerObj.MainFrameObj.BarResultsFilter;
//			_lrrApp.LRRUIManagerObj.MainFrameObj.MainFrameBarManager.GetCommandBarManager().SetBarVisibility(resultsFilter,true);
		}

		private void InputOutputViews_Deactivate(object sender, EventArgs e)
		{
			if(_rsProperties != null)
				_rsProperties.Hide();
			if(_rsComponents != null)
				_rsComponents.Hide();
		}
		#region ILRRUIContainer Members

		public void ShowPropertyList()
		{
			//InputOutputViews.ShowPropertyList implementation
			if(_rsProperties != null)
			{
				_rsProperties.IsWindowOpen = true;
				_rsProperties.Show();
			}
		}

		public void ShowComponentList()
		{
			//InputOutputViews.ShowComponentList implementation
			if(_rsComponents != null)
			{
				_rsComponents.IsWindowOpen = true;
				_rsComponents.Show();
			}
		}

		public bool SupportsResultsFilter()
		{
			// InputOutputViews.SupportsResultsFilter implementation
			return true;
		}

		#endregion

		private void _rsComponents_SelectedProperties(ArrayList arrayUnSelectedRecords)
		{
			iGridView.HideComponents(arrayUnSelectedRecords);
		}

		private void gridPlantItems_TableControlQueryAllowSortColumn(object sender, GridQueryAllowSortColumnEventArgs e)
		{
			if(e.Column.Name == "IsSelected")
			{
				e.AllowSort = false;
			}
		}

		private void TableControl_MouseUp(object sender, MouseEventArgs e)
		{
			int row, col;
			GridTableControl gridTableControl = sender as GridTableControl;
			gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
			GridTableCellStyleInfo style = gridTableControl.Model[row, col];

			IMouseController controller;
			gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

			if(controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
			{
				gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
			}
		}

		private void TableControl_MouseUp1(object sender, MouseEventArgs e)
		{
			int row, col;
//			GridTableControl gridTableControl = sender as GridTableControl;
			GridTableControl gridTableControl = gridProperties2.GetTableControl("Properties");
			gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
			GridTableCellStyleInfo style = gridTableControl.Model[row, col];
			
			IMouseController controller;
			gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

			if(controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
			{
				gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
			}
		}

		private void TableControl_MouseUp2(object sender, MouseEventArgs e)
		{
			int row, col;
			GridTableControl gridTableControl = gridSiteSpecificProperties.GetTableControl("Properties");
			gridTableControl.PointToRowCol(new Point(e.X, e.Y), out row, out col);
			GridTableCellStyleInfo style = gridTableControl.Model[row, col];
			
			IMouseController controller;
			gridTableControl.MouseControllerDispatcher.HitTest(new Point(e.X, e.Y), e.Button, e.Clicks, out controller);

			if(controller != null && controller.Name == "DragGroupHeader" && style.CellType == "CheckBox")
			{
				gridTableControl.GetCellRenderer(row, col).RaiseMouseUp(row, col, e);
			}
		}
		
		int row, col;
		bool CheckBoxValue = false;
		private void gridPlantItems_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row, out col);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = CheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

		private void gridPlantItems_SaveCellText(object sender, GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.CheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lrrSiteComps.GetEnumerator();
				while(iEnum.MoveNext())
				{
					LRRSiteComponent siteComponent = iEnum.Current as LRRSiteComponent;
					if(siteComponent != null)
						siteComponent.IsSelected = this.CheckBoxValue;
				}
				//UnCheck Master Properties
//				if(!this.CheckBoxValue)
//				{
//					CheckUncheckMasterProperties(this.CheckBoxValue);
//				}
				gridPlantItems.Refresh();
				gridPlantItems_ValueChanged();
				//Check Master Properties
//				if(this.CheckBoxValue)
//					CheckUncheckMasterProperties(this.CheckBoxValue);

				e.Handled = true;
			}
			else
			{
				if(!bool.Parse(e.Text))
				{
					this.CheckBoxValue = false;
					gridPlantItems.Refresh();  		
				}
			}
		}

		int row1, col1;
		Hashtable propertiesCheckBoxValue = new Hashtable();
		private void gridProperties2_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row1, out col1);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col1 +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				
				bool checkBox = false;
				//Get the cell value
				int iCount = e.TableCellIdentity.Table.Elements.Count - 1;
				LRRMasterProperty lrrMasterProp =e.TableCellIdentity.Table.Elements[iCount].GetData() as LRRMasterProperty;
				if(lrrMasterProp != null)
				{
					string compID = lrrMasterProp.ComponentID;
					if(propertiesCheckBoxValue.ContainsKey(compID))
					{
						checkBox = (bool)propertiesCheckBoxValue[compID];
					}
				}
				e.Style.CellValue = checkBox;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

		private void gridProperties2_SaveCellText(object sender, GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				int iCount = style.TableCellIdentity.Table.Elements.Count - 1;
				//Get the MasterPropID
				LRRMasterProperty lrrMasterProp = style.TableCellIdentity.Table.Elements[iCount].GetData() as LRRMasterProperty;
				bool checkBox = bool.Parse(e.Text);
				if(lrrMasterProp != null)
				{
					string compID = lrrMasterProp.ComponentID;
					if(!propertiesCheckBoxValue.ContainsKey(compID))
						propertiesCheckBoxValue.Add(compID,checkBox);
					else
					{
						propertiesCheckBoxValue[compID] = checkBox;
					}
					//Check/Uncheck Master Properties
					CheckUncheckMasterProperties(checkBox,compID);
				}
				e.Style.CellValue = checkBox;
				e.Handled = true;
			}
			
		}

		Hashtable siteSpecificPropsCheckBoxValue = new Hashtable();
		private void gridSiteSpecificProperties_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out row1, out col1);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == col1 +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				
				bool checkBox = false;
				//Get the cell value
				int iCount = e.TableCellIdentity.Table.Elements.Count - 1;
				LRRSiteComponentProperty lrrSiteCompProp =e.TableCellIdentity.Table.Elements[iCount].GetData() as LRRSiteComponentProperty;
				if(lrrSiteCompProp != null)
				{
					string siteCompID = lrrSiteCompProp.ComponentID;
					if(siteSpecificPropsCheckBoxValue.ContainsKey(siteCompID))
					{
						checkBox = (bool)siteSpecificPropsCheckBoxValue[siteCompID];
					}
				}
				e.Style.CellValue = checkBox;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;
		}

		private void gridSiteSpecificProperties_SaveCellText(object sender, GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				int iCount = style.TableCellIdentity.Table.Elements.Count - 1;
				//Get the SiteCompPropID
				LRRSiteComponentProperty lrrSiteCompProp = style.TableCellIdentity.Table.Elements[iCount].GetData() as LRRSiteComponentProperty;
				bool checkBox = bool.Parse(e.Text);
				if(lrrSiteCompProp != null)
				{
					string siteCompID = lrrSiteCompProp.ComponentID;
					if(!siteSpecificPropsCheckBoxValue.ContainsKey(siteCompID))
						siteSpecificPropsCheckBoxValue.Add(siteCompID,checkBox);
					else
					{
						siteSpecificPropsCheckBoxValue[siteCompID] = checkBox;
					}
					//Check/Uncheck SiteComponent Properties
					CheckUncheckSiteSpecificProperties(checkBox,siteCompID);
				}
				e.Style.CellValue = checkBox;
				e.Handled = true;
			}
			
		}
		
		int aggrRow, aggrCol;
		bool aggrCheckBoxValue = false;
		private void gridAggregates_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.TableCellIdentity.Table.TableDescriptor.ColumnToRowColIndex("IsSelected", out aggrRow, out aggrCol);
			if(e.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.TableCellIdentity.ColIndex == aggrCol +1)
			{
				e.Style.CellType = "CheckBox";
				e.Style.ReadOnly = false;
				e.Style.CellAppearance = GridCellAppearance.Raised;
				e.Style.CellValue = aggrCheckBoxValue;
				e.Style.CellValueType = typeof(bool);
				e.Style.Enabled = true;
			}
			e.Handled = true;

		}

		private void gridAggregates_SaveCellText(object sender, GridCellTextEventArgs e)
		{
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell && e.Style.CellType == "CheckBox")
			{
				this.aggrCheckBoxValue = bool.Parse(e.Text);
				IEnumerator iEnum = _lrrGridAggregates.GetEnumerator();
				while(iEnum.MoveNext())
				{
					LRRAggregate  aggregate = iEnum.Current as LRRAggregate;
					if(aggregate != null)
						aggregate.IsSelected = this.aggrCheckBoxValue;
				}
				gridAggregates.Refresh();
				gridPlantItems_ValueChanged();
				e.Handled = true;
			}
			else
			{
				if(!bool.Parse(e.Text))
				{
					this.aggrCheckBoxValue = false;
					gridAggregates.Refresh();  		
				}
			}
		}

		private void InputOutputViews_Closed(object sender, System.EventArgs e)
		{
			_lrrApp.LRRUIManagerObj.PerformDataDirtyCheck = true;

		}

		private void SetPanel(ArrayList pnlCollection)
		{
			int heightOfEach = pnlGridContainer.Height/pnlCollection.Count;
			int splitCnt = 0;
			for(int i=pnlCollection.Count-1;i>=0;i--)
			{
				Panel panel = pnlCollection[i] as Panel;
				panel.Height = heightOfEach;
				this.pnlGridContainer.Controls.Add(panel);
				if(splitCnt < pnlCollection.Count - 1)
				{
					Splitter splitGrid = new Splitter();
					splitGrid.Dock = DockStyle.Top;
					this.pnlGridContainer.Controls.Add(splitGrid);
					splitCnt++;
				}
			}
			if(this.pnlGridContainer.Controls.Count > 0)
				this.pnlGridContainer.Controls[0].Dock = DockStyle.Fill;
		}

		private void pnlGridContainer_Click(object sender, System.EventArgs e)
		{
			if(this.dockingManager1 != null)
			{
				this.dockingManager1.HideAutoHiddenControl();
			}
		}
		#region ILRRUIContainer Members

		public void LeftColMovement()
		{
			if(iGridView != null)
				iGridView.LeftColMovement();
		}

		public void RightColMovement()
		{
			if(iGridView != null)
				iGridView.RightColMovement();			
		}

		#endregion

		#region ILRRUIContainer Members

		public void PageSetup()
		{
			GridControlPrint gcPrint = new GridControlPrint();
			gcPrint.PageSetUp();
		}

		public void Undo()
		{
			// TODO:  Add InputOutputViews.Undo implementation
		}

		public bool SupportsPageSetup()
		{
			return true;
		}

		public bool SupportsUndo()
		{
			// TODO:  Add InputOutputViews.SupportsUndo implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public void OpenCompositeView()
		{
			// TODO:  Add InputOutputViews.OpenCompositeView implementation
		}

		public void TransposeView()
		{
			// TODO:  Add InputOutputViews.TransposeView implementation
		}

		public void OpenQuery()
		{
			// TODO:  Add InputOutputViews.OpenQuery implementation
		}

		public void OpenView()
		{
			// TODO:  Add InputOutputViews.OpenView implementation
		}

		public bool SupportsCompositeView()
		{
			// TODO:  Add InputOutputViews.SupportsCompositeView implementation
			return false;
		}

		#endregion

		#region ILRRUIContainer Members

		public bool PerformDirtyChk
		{
			get
			{
				// TODO:  Add InputOutputViews.PerformDirtyChk getter implementation
				return true;
			}
		}

		#endregion

		#region ILRRUISpecificContainer Members

		public void ChangeUOMSet()
		{
			if(iGridView != null)
			{
				ChangeUOMSetDefinitionForm chngUOMSetDefn = new ChangeUOMSetDefinitionForm();
				DialogResult dlgResult = chngUOMSetDefn.ShowDialog();
				if(dlgResult == DialogResult.OK && chngUOMSetDefn.MeasSysID != null)
				{
					iGridView.ChangeUOMSet(chngUOMSetDefn.MeasSysID);
				}
			}
		}

		public bool SupportsChangeUOMSet()
		{
			return true;
		}

		#endregion

		private void cmbOpen_DropDown(object sender, System.EventArgs e)
		{
			ComboBox senderComboBox = (ComboBox)sender;
			int width = senderComboBox.DropDownWidth;
			Graphics g = senderComboBox.CreateGraphics();
			Font font = senderComboBox.Font;
			int vertScrollBarWidth = 
				(senderComboBox.Items.Count>senderComboBox.MaxDropDownItems)
				?SystemInformation.VerticalScrollBarWidth:0;

			int newWidth;
			foreach (LRRSearchCriteria searchCriteria in ((ComboBox)sender).Items)
			{
				string s = searchCriteria.Name;
				newWidth = (int) g.MeasureString(s, font).Width 
					+ vertScrollBarWidth;
				if (width < newWidth )
				{
					width = newWidth;
				}
			}
			senderComboBox.DropDownWidth = width;
		}

        bool isOpen = false;
        private void dockingManager1_AutoHideAnimationStart(object sender, AutoHideAnimationEventArgs arg)
        {
            if (!isOpen)
            {
                InternationalizationUtils.GetControlText(this, this.components.Components);   
            }
        }

        private void chkRecTrendingFlag_CheckedChanged(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            if (iGridView != null)
                iGridView.ResetRecordingTrendingDisplayFlag(this.chkRecTrendingFlag.Checked);
            Cursor.Current = Cursors.Default;
        }
	}
}

